#include <gracelib.h>
#include <stdlib.h>
#include <math.h>
#include <float.h>
static char compilerRevision[] = "1560723984934899b9bf4496f3b68ced32fab99c";
static Object undefined;
extern Object done;
extern Object _prelude;
extern Object ObjectType;
extern Object String;
extern Object Number;
extern Object Boolean;
extern Object Dynamic;
extern Object Unknown;
extern Object Block;
extern Object Done;
extern Object Type;
extern Object GraceDefaultObject;
extern Object sourceObject;
static Object type_Object;
static Object type_String;
static Object type_Number;
static Object type_Boolean;
static Object type_Block;
static Object type_Done;
static Object type_Type;
static Object argv;
static Object emptyclosure;
static Object prelude;
static int isTailObject = 0;
static Object inheritingObject = NULL;
static const char modulename[] = "ast";
Object module_StandardPrelude_init();
static char *originalSourceLines[] = {
  "// #pragma noTypeChecks",
  "import \"util\" as util",
  "",
  "// This module contains classes and pseudo-classes for all the AST nodes used",
  "// in the parser. Because of the limitations of the class syntax, classes that",
  "// need more than one method are written as object literals containing methods.",
  "// Each node has a different signature according to its function, but the",
  "// common interface is given by type ASTNode ",
  "//",
  "// Most nodes also contain a \"value\" field, with varied type, holding the `main value`",
  "// in the node.  This field is confusing and should be appropriately re-named in",
  "// each case. Some nodes contain other fields for their specific use: while has",
  "// both a value (the condition) and a body, for example.",
  "",
  "def lineLength is public = 80",
  "",
  "method listMap(l, b) ancestors(as) is confidential {",
  "    def newList = list.empty",
  "    l.do { nd -> newList.addLast(nd.map(b) ancestors(as)) }",
  "    newList",
  "}",
  "method maybeMap(n, b) ancestors(as) is confidential {",
  "    if (n != false) then {",
  "        n.map(b) ancestors(as)",
  "    } else {",
  "        n",
  "    }",
  "}",
  "method maybeListMap(n, b) ancestors(as) is confidential {",
  "    if (n != false) then {",
  "        listMap(n, b) ancestors(as)",
  "    } else {",
  "        n",
  "    }",
  "}",
  "",
  "def ancestorChain = object {",
  "    factory method empty {",
  "        method isEmpty { true }",
  "        method asString { \"ancestorChain ▫\" }",
  "        method extend(n) { cons(n) onto(self) }",
  "    }",
  "    method with(n) { empty.extend(n) }",
  "    factory method cons(p) onto(as) is confidential {",
  "        method forebears { as }",
  "        method isEmpty { false }",
  "        method parent { p }",
  "        method grandparent { forebears.parent }",
  "        ",
  "        method asString {",
  "            var a := self",
  "            var s := \"ancestorChain \"",
  "            while { a.isEmpty.not } do {",
  "                s := s ++ a.parent ++ \"➤\"",
  "                a := a.forebears",
  "            }",
  "            s ++ \"▫\"",
  "        }",
  "        method extend(n) { cons(n) onto(self) }",
  "    }",
  "}",
  "",
  "def emptySeq = sequence.empty",
  "",
  "type AstNode = type {",
  "    kind -> String ",
  "        // Used for pseudo-instanceof tests.",
  "    register -> String",
  "        // Used in the code generator on to name the resulting object",
  "    line -> Number",
  "        // The source line the node came from",
  "    line:=(ln:Number)",
  "    linePos -> Number",
  "    linePos:=(lp:Number)",
  "    scope -> SymbolTable",
  "        // The symbolTable for names defined in this node and its sub-nodes",
  "    pretty(n:Number) -> String ",
  "        // Pretty-print-string of node at depth n",
  "    comments -> AstNode",
  "        // Comments associated with this node",
  "}",
  "",
  "type SymbolTable = Unknown",
  "",
  "class baseNode.new {",
  "    // the superclass of all AST nodes",
  "    var register is public := \"\"",
  "    var line is public := util.linenum",
  "    var linePos is public := util.linepos",
  "    var symbolTable := fakeSymbolTable",
  "    var comments is public := false",
  "",
  "    method kind { abstract }",
  "    method isAppliedOccurenceOfIdentifier { false }",
  "    method isMatchingBlock { false }",
  "    method isFieldDec { false }",
  "    method isInherits { false }",
  "    method isMember { false }",
  "    method isCall { false }",
  "    method isComment { false }",
  "    method isClass { false }",
  "    method isBind { false }",
  "    method isObject { false }",
  "    method isIdentifier { false }",
  "    method isDialect { false }",
  "    method isImport { false }",
  "    method canInherit {true }",
  "    method returnsObject { false }",
  "    method usesAsType(aNode) { false }",
  "    method hash { line.hash * linePos.hash }",
  "    method asString { \"{kind} {nameString}\" }",
  "    method nameString { \"?\" }",
  "    method isWritable { true }",
  "    method isReadable { true }",
  "    method isPublic { true }",
  "    method isConfidential { isPublic.not }",
  "    method decType {",
  "        if (self.dtype == false) then {",
  "            return unknownType",
  "        }",
  "        return self.dtype",
  "    }",
  "    method isSimple { true }  // needs no parens when used as reciever",
  "    method accept(visitor) {",
  "        self.accept(visitor) from (ancestorChain.empty)",
  "    }",
  "    method scope { symbolTable }",
  "",
  "    method scope:=(st) {",
  "        // override this method in subobjects that open a new scope. In such",
  "        // subobjects, and only in such subobjects, there should be a 2-way",
  "        // conection between the node and the symbol table that defines its scope.",
  "        symbolTable := st",
  "    }",
  "    method declarationKindWithAncestors(as) { self.kind }     ",
  "        // the kind of identifiers defined within me",
  "    method shallowCopyFieldsFrom(other) {",
  "        register := other.register",
  "        line := other.line",
  "        linePos := other.linePos",
  "        scope := other.scope",
  "        self",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        if ((scope.node == self).andAlso{util.target == \"symbols\"}) then {",
  "            \"{line}:{linePos} {self.kind}\\n{spc}Symbols({scope.variety}): {scope}{scope.elementScopesAsString}\"",
  "        } elseif {scope.variety == \"fake\"} then {",
  "            \"{line}:{linePos} {self.kind}\"",
  "        } else {",
  "            \"{line}:{linePos} {self.kind} {scope.asDebugString}\"",
  "        }",
  "    }",
  "    method deepCopy {",
  "        self.map { each -> each } ancestors(ancestorChain.empty)",
  "    }",
  "    method enclosingObject {",
  "        def obj = scope.enclosingObjectScope.node",
  "        util.log 20 verbose \"object enclosing {self} is {obj}\"",
  "        obj",
  "    }",
  "    method addComment(cmtNode) {",
  "        if (comments == false) then {",
  "            comments := cmtNode",
  "        } else {",
  "            comments.extendCommentUsing(cmtNode)",
  "        }",
  "    }",
  "    method addComments(cmtNodeList) {",
  "        cmtNodeList.do { each -> addComment(each) }",
  "    }",
  "}",
  "",
  "def nullNode is public = object {",
  "    inherits baseNode.new",
  "    def kind is public = \"null\"",
  "    method toGrace(depth) {",
  "        \"// null\"",
  "    }",
  "}",
  "",
  "def fakeSymbolTable = object {",
  "    var node is public := nullNode",
  "    method asString { \"fake Symbol Table\" }",
  "    method addNode (n) as (kind) {",
  "        ProgrammingError.raise \"fakeSymbolTable(on node {node}).addNode({n}) as \\\"{kind}\\\" requested\"",
  "    }",
  "    method thatDefines (name) ifNone (action) {",
  "        ProgrammingError.raise \"fakeSymbolTable.thatDefines({name}).\"",
  "    }",
  "    method enclosingObjectScope {",
  "        ProgrammingError.raise \"fakeSymbolTable.enclosingObjectScope on node {node}\"",
  "    }",
  "    method variety { \"fake\" }",
  "}",
  "",
  "class ifNode.new(cond, thenblock', elseblock') {",
  "    inherits baseNode.new",
  "    def kind is public = \"if\"",
  "    var value is public := cond",
  "    var thenblock is public := thenblock'",
  "    var elseblock is public := elseblock'",
  "    var handledIdentifiers is public := false",
  "    method isSimple { false }  // needs parens when used as reciever",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitIf(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            value.accept(visitor) from(newChain)",
  "            thenblock.accept(visitor) from(newChain)",
  "            elseblock.accept(visitor) from(newChain)",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.value := value.map(blk) ancestors(newChain)",
  "        n.thenblock := thenblock.map(blk) ancestors(newChain)",
  "        n.elseblock := elseblock.map(blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ self.value.pretty(depth+1)",
  "        s := s ++ \"\\n\"",
  "        if (util.target == \"symbols\") then {",
  "            s := s ++ spc ++ \"Then: {thenblock.pretty(depth+2)}\\n\"",
  "            s := s ++ spc ++ \"Else: {elseblock.pretty(depth+2)}\"",
  "        } else {",
  "            s := s ++ spc ++ \"Then:\"",
  "            for (self.thenblock.body) do { ix ->",
  "                s := s ++ \"\\n  \"++ spc ++ ix.pretty(depth+2)",
  "            }",
  "            s := s ++ \"\\n\"",
  "            s := s ++ spc ++ \"Else:\"",
  "            for (self.elseblock.body) do { ix ->",
  "                s := s ++ \"\\n  \"++ spc ++ ix.pretty(depth+2)",
  "            }",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        repeat (depth) times {",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"if ({self.value.toGrace(0)}) then \\{\"",
  "        for (self.thenblock.body) do { ix ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ ix.toGrace(depth + 1)",
  "        }",
  "        if (self.elseblock.isntEmpty) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"\\} else \\{\"",
  "            for (self.elseblock.body) do { ix ->",
  "                s := s ++ \"\\n\" ++ spc ++ \"    \" ++ ix.toGrace(depth + 1)",
  "            }",
  "        }",
  "        s := s ++ \"\\n\" ++ spc ++ \"\\}\"",
  "        s",
  "    }",
  "    method shallowCopy {",
  "        ifNode.new(nullNode, nullNode, nullNode).shallowCopyFieldsFrom(self)",
  "    }",
  "    method shallowCopyFieldsFrom(other) {",
  "        super.shallowCopyFieldsFrom(other)",
  "        handledIdentifiers := other.handledIdentifiers",
  "        self",
  "    }",
  "}",
  "class blockNode.new(params', body') {",
  "    inherits baseNode.new",
  "    def kind is public = \"block\"",
  "    def value is public = \"block\"",
  "    var params is public := params'",
  "    var body is public := body'",
  "    def selfclosure is public = true",
  "    var matchingPattern is public := false",
  "    var extraRuntimeData is public := false",
  "    for (params') do {p->",
  "        p.accept(patternMarkVisitor) from(ancestorChain.with(self))",
  "    }",
  "    method isEmpty { body.size == 0 }",
  "    method isntEmpty { body.size > 0 }",
  "    method scope:=(st) {",
  "        // sets up the 2-way conection between this node",
  "        // and the synmol table that defines the scope that I open.",
  "        symbolTable := st",
  "        st.node := self",
  "    }",
  "    method declarationKindWithAncestors(as) {",
  "        \"parameter\"",
  "    }",
  "    method isMatchingBlock { params.size == 1 }",
  "    method returnsObject {",
  "        (body.size > 0).andAlso { body.last.returnsObject }",
  "    }",
  "    method returnedObjectScope {",
  "        // precondition: returnsObject",
  "        body.last.returnedObjectScope",
  "    }",
  "    method parametersDo(b) {",
  "        params.do(b)",
  "    }",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitBlock(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            for (self.params) do { mx ->",
  "                mx.accept(visitor) from(newChain)",
  "            }",
  "            for (self.body) do { mx ->",
  "                mx.accept(visitor) from(newChain)",
  "            }",
  "            if (self.matchingPattern != false) then {",
  "                self.matchingPattern.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.params := listMap(params, blk) ancestors(newChain)",
  "        n.body := listMap(body, blk) ancestors(newChain)",
  "        n.matchingPattern := maybeMap(matchingPattern, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ \"Parameters:\"",
  "        for (self.params) do { mx ->",
  "            s := s ++ \"\\n  \"++ spc ++ mx.pretty(depth+2)",
  "        }",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ \"Body:\"",
  "        for (self.body) do { mx ->",
  "            s := s ++ \"\\n  \"++ spc ++ mx.pretty(depth+2)",
  "        }",
  "        if (self.matchingPattern != false) then {",
  "            s := s ++ \"\\n\"",
  "            s := s ++ spc ++ \"Pattern:\"",
  "            s := s ++ \"\\n  \"++ spc ++ self.matchingPattern.pretty(depth+2)",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"\\{\"",
  "        if (self.params.size > 0) then {",
  "            s := s ++ \" \"",
  "            for (self.params.indices) do { i ->",
  "                var p := self.params[i]",
  "                if (self.matchingPattern != false) then {",
  "                    s := s ++ \"(\" ++ p.toGrace(0) ++ \")\"",
  "                } else {",
  "                    s := s ++ p.toGrace(0)",
  "                }",
  "                if (i < self.params.size) then {",
  "                    s := s ++ \", \"",
  "                } else {",
  "                    s := s ++ \" ->\"",
  "                }",
  "            }",
  "        }",
  "        for (self.body) do { mx ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ mx.toGrace(depth + 1)",
  "        }",
  "        s := s ++ \"\\n\" ++ spc ++ \"\\}\"",
  "        s",
  "    }",
  "    method shallowCopy {",
  "        blockNode.new(params, body).shallowCopyFieldsFrom(self)",
  "    }",
  "    method shallowCopyFieldsFrom(other) {",
  "        super.shallowCopyFieldsFrom(other)",
  "        matchingPattern := other.matchingPattern",
  "        extraRuntimeData := other.extraRuntimeData",
  "        self",
  "    }",
  "}",
  "class catchCaseNode.new(block, cases', finally') {",
  "    inherits baseNode.new",
  "    def kind is public = \"catchcase\"",
  "    var value is public := block",
  "    var cases is public := cases'",
  "    var finally is public := finally'",
  "    method isSimple { false }  // needs parens when used as reciever",
  "",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitCatchCase(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            self.value.accept(visitor) from(newChain)",
  "            for (self.cases) do { mx ->",
  "                mx.accept(visitor) from(newChain)",
  "            }",
  "            if (self.finally != false) then {",
  "                self.finally.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.value := value.map(blk) ancestors(newChain)",
  "        n.cases := listMap(cases, blk) ancestors(newChain)",
  "        n.finally := maybeMap(finally, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"{super.pretty(depth)}\\n\"",
  "        s := s ++ spc ++ value.pretty(depth + 2)",
  "        for (self.cases) do { mx ->",
  "            s := s ++ \"\\n{spc}Case:\\n{spc}  {mx.pretty(depth+2)}\"",
  "        }",
  "        if (false != self.finally) then {",
  "            s := s ++ \"\\n{spc}Finally:\\n{spc}  {self.finally.pretty(depth+2)}\"",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"catch \" ++ self.value.toGrace(0) ++ \" \"",
  "        for (self.cases) do { case ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ \"case \" ++ case.toGrace(depth + 2)",
  "        }",
  "        if (self.finally != false) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ \"finally \" ++ self.finally.toGrace(depth + 2)",
  "        }",
  "        s",
  "    }",
  "    method shallowCopy {",
  "        catchCaseNode.new(nullNode, emptySeq, false).shallowCopyFieldsFrom(self)",
  "    }",
  "}",
  "class matchCaseNode.new(matchee', cases', elsecase') {",
  "    inherits baseNode.new",
  "    def kind is public = \"matchcase\"",
  "    var value is public := matchee'",
  "    var cases is public := cases'",
  "    var elsecase is public := elsecase'",
  "    method isSimple { false }  // needs parens when used as reciever",
  "    method matchee { value }",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitMatchCase(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            self.value.accept(visitor) from(newChain)",
  "            for (self.cases) do { mx ->",
  "                mx.accept(visitor) from(newChain)",
  "            }",
  "            if (self.elsecase != false) then {",
  "                self.elsecase.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.value := value.map(blk) ancestors(newChain)",
  "        n.cases := listMap(cases, blk) ancestors(newChain)",
  "        n.elsecase := maybeMap(elsecase, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ matchee.pretty(depth + 2)",
  "        for (self.cases) do { mx ->",
  "            s := s ++ \"\\n{spc}Case:\\n{spc}  {mx.pretty(depth+2)}\"",
  "        }",
  "        if (false != self.elsecase) then {",
  "            s := s ++ \"\\n{spc}Else:\\n{spc}  {self.elsecase.pretty(depth+2)}\"",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"match(\" ++ self.value.toGrace(0) ++ \")\"",
  "        for (self.cases) do { case ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ \"case \" ++ case.toGrace(depth + 2)",
  "        }",
  "        if (self.elsecase != false) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ \"else \" ++ self.elsecase.toGrace(depth + 2)",
  "        }",
  "        s",
  "    }",
  "    method shallowCopy {",
  "        matchCaseNode.new(nullNode, emptySeq, false).shallowCopyFieldsFrom(self)",
  "    }",
  "}",
  "class methodTypeNode.new(name', signature', rtype') {",
  "    // Represents the signature of a method in a type literal",
  "    // [signature]",
  "    //     object {",
  "    //         name := \"\"",
  "    //         params := sequence.empty",
  "    //         vararg := false/identifier",
  "    //     }",
  "    //     object {",
  "    //         name := \"\"",
  "    //         params := sequence.empty",
  "    //         vararg := false/identifier",
  "    //     }",
  "    //     ...",
  "    //     object {",
  "    //         ...",
  "    //     }",
  "    inherits baseNode.new",
  "    def kind is public = \"methodtype\"",
  "    var value is public := name'",
  "    var signature is public := signature'",
  "    var rtype is public := rtype'",
  "    var generics is public := false",
  "    def nameString:String is public = value",
  "",
  "    method parametersDo(b) {",
  "        signature.do { part -> ",
  "            part.params.do { each -> b.apply(each) }",
  "        }",
  "    }",
  "    method scope:=(st) {",
  "        // sets up the 2-way conection between this node",
  "        // and the symbol table that defines the scope that I open.",
  "        symbolTable := st",
  "        st.node := self",
  "    }",
  "    method declarationKindWithAncestors(as) { \"typedec\" }",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitMethodType(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            if (false != generics) then {",
  "                generics.accept(visitor) from(newChain)",
  "            }",
  "            if (rtype != false) then {",
  "                rtype.accept(visitor) from(newChain)",
  "            }",
  "            for (signature) do { part ->",
  "                part.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.rtype := maybeMap(rtype, blk) ancestors(newChain)",
  "        n.signature := listMap(signature, blk) ancestors(newChain)",
  "        n.generics := maybeMap(generics, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := \"{s}{spc}Name: {value}\\n\"",
  "        if (rtype != false) then {",
  "            s := \"{s}{spc}Returns:\\n  {spc}{rtype.pretty(depth + 2)}\"",
  "        }",
  "        if (false != generics) then {",
  "            s := \"{s}\\n{spc}TypeParams:\\n\" ",
  "            s := s ++ generics.pretty(depth + 2)",
  "        }",
  "        s := \"{s}\\n{spc}Signature:\"",
  "        for (signature) do { part ->",
  "            s := \"{s}\\n  {spc}{part.pretty(depth + 2)}\"",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var s := \"\"",
  "        for (self.signature) do { part ->",
  "            s := s ++ part.name",
  "            if ((part.params.size > 0) || (part.vararg != false)) then {",
  "                s := s ++ \"(\"",
  "                for (part.params.indices) do { pnr ->",
  "                    var p := part.params[pnr]",
  "                    s := s ++ p.toGrace(depth + 1)",
  "                    if ((pnr < part.params.size) || (part.vararg != false)) then {",
  "                        s := s ++ \", \"",
  "                    }",
  "                }",
  "                if (part.vararg != false) then {",
  "                    s := s ++ \"*\" ++ part.vararg.value",
  "                }",
  "                s := s ++ \")\"",
  "            }",
  "        }",
  "        if (self.rtype != false) then {",
  "            s := s ++ \" -> \" ++ self.rtype.toGrace(depth + 1)",
  "        }",
  "        s",
  "    }",
  "    method shallowCopy {",
  "        methodTypeNode.new(value, emptySeq, false).shallowCopyFieldsFrom(self)",
  "    }",
  "}",
  "class typeLiteralNode.new(methods', types') {",
  "    inherits baseNode.new",
  "    def kind is public = \"typeliteral\"",
  "    var methods is public := methods'",
  "    var types is public := types'",
  "    var nominal is public := false",
  "    var anonymous is public := true",
  "    var value is public := \"‹anon›\"",
  "    ",
  "    method name { value }",
  "    method name:=(n) {",
  "        value := n",
  "        anonymous := false",
  "    }",
  "    method asString {",
  "        \"typeliteral: methods = {methods}, types = {types}\"",
  "    }",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitTypeLiteral(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            for (self.methods) do { each ->",
  "                each.accept(visitor) from(newChain)",
  "            }",
  "            for (self.types) do { each ->",
  "                each.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.methods := listMap(methods, blk) ancestors (as)",
  "        n.types := listMap(types, blk) ancestors (as)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"{super.pretty(depth)}\\n\"",
  "        s := s ++ spc ++ \"Types:\"",
  "        for (types) do { each ->",
  "            s := s ++ \"\\n  \"++ spc ++ each.pretty(depth+2)",
  "        }",
  "        s := s ++ \"\\n\" ++ spc ++ \"Methods:\"",
  "        for (methods) do { each ->",
  "            s := s ++ \"\\n  \"++ spc ++ each.pretty(depth+2)",
  "        }",
  "        s := s ++ \"\\n\"",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"type\"",
  "        s := s ++ \" = \\{\"",
  "        for (self.methods) do { each ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ each.toGrace(depth + 1)",
  "        }",
  "        for (self.types) do { each ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ each.toGrace(depth + 1)",
  "        }",
  "        s ++ \"\\}\"",
  "    }",
  "    method shallowCopy {",
  "        typeLiteralNode.new(emptySeq, emptySeq).shallowCopyFieldsFrom(self)",
  "    }",
  "    method shallowCopyFieldsFrom(other) {",
  "        super.shallowCopyFieldsFrom(other)",
  "        nominal := other.nominal",
  "        anonymous := other.anonymous",
  "        value := other.value",
  "        self",
  "    }",
  "}",
  "",
  "class typeDecNode.new(name', typeValue) {",
  "    inherits baseNode.new",
  "    def kind is public = \"typedec\"",
  "    var name is public := name'",
  "    var value is public := typeValue",
  "    def nameString:String is public = name.value",
  "    var annotations is public := list.empty",
  "    var generics is public := false",
  "",
  "    method scope:=(st) {",
  "        // sets up the 2-way conection between this node",
  "        // and the synmol table that defines the scope that I open.",
  "        symbolTable := st",
  "        st.node := self",
  "    }",
  "    method declarationKindWithAncestors(as) {",
  "        \"parameter\"",
  "    }",
  "    method isConfidential {",
  "        if (annotations.size == 0) then { return false }",
  "        findAnnotation(self, \"confidential\")",
  "    }",
  "    method isPublic { isConfidential.not }",
  "    method isWritable { false }",
  "    method isReadable { isPublic }",
  "",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitTypeDec(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            name.accept(visitor) from(newChain)",
  "            if (generics != false) then {",
  "                generics.accept(visitor) from(newChain)",
  "            }",
  "            annotations.do { each -> each.accept(visitor) from(newChain) }",
  "            value.accept(visitor) from(newChain)",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.name := name.map(blk) ancestors(newChain)",
  "        n.generics := maybeMap(generics, blk) ancestors(newChain)",
  "        n.value := value.map(blk) ancestors(newChain)",
  "        n.annotations := listMap(annotations, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ self.name.pretty(depth + 1) ++ \"\\n\"",
  "        if (false != generics) then {",
  "            s := \"{s}{spc}Type parameters:\\n{generics.pretty(depth + 2)}\\n\"",
  "        }",
  "        s := s ++ spc ++ \"Value:\"",
  "        s := s ++ value.pretty(depth+2)",
  "        s := s ++ \"\\n\"",
  "        if (false != comments) then {",
  "            s := s ++ comments.pretty(depth+2)",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"\"",
  "        s := \"type {self.name}\"",
  "        if (false != generics) then {",
  "            generics.toGrace(0)",
  "        }",
  "        s ++ \" = \" ++ value(toGrace(depth + 2))",
  "    }",
  "    method shallowCopy {",
  "        typeDecNode.new(name, nullNode).shallowCopyFieldsFrom(self)",
  "    }",
  "}",
  "",
  "def methodNode = object {",
  "    method new(name, signature, body, dtype) scope(s) {",
  "        def result = new(name, signature, body, dtype)",
  "        result.scope := s",
  "        result",
  "    }",
  "    ",
  "    factory method new(name', signature', body', dtype') {",
  "        // Represents a method declaration",
  "        // name' is the name of the method (an identifierNode),",
  "        // signature is a sequence of signatureParts,",
  "        // body is a sequence of statements and declarations,",
  "        // dtype is the declared return type of the method, or false.",
  "",
  "        inherits baseNode.new",
  "        def kind is public = \"method\"",
  "        var value is public := name'",
  "        var signature is public := signature'",
  "        var body is public := body'",
  "        var dtype is public := dtype'",
  "        var varargs is public := false",
  "        var generics is public := false",
  "        var selfclosure is public := false",
  "        def nameString:String is public = value.value",
  "        var annotations is public := list.empty",
  "        var isFresh is public := false      // a method is 'fresh' if it answers a new object",
  "",
  "        method scope:=(st) {",
  "            // sets up the 2-way conection between this node",
  "            // and the synmol table that defines the scope that I open.",
  "            symbolTable := st",
  "            st.node := self",
  "        }",
  "        method declarationKindWithAncestors(as) {",
  "            \"parameter\"",
  "        }",
  "        method isConfidential {",
  "            if (annotations.size == 0) then { return false }",
  "            findAnnotation(self, \"confidential\")",
  "        }",
  "        method isPublic { isConfidential.not }",
  "        method isWritable { false }",
  "        method isReadable { isPublic }",
  "        method usesAsType(aNode) {",
  "            aNode == dtype",
  "        }",
  "        method returnsObject {",
  "            body.isEmpty.not.andAlso {body.last.returnsObject}",
  "        }",
  "        method returnedObjectScope {",
  "            // precondition: returnsObject",
  "            body.last.returnedObjectScope",
  "        }",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            if (visitor.visitMethod(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                self.value.accept(visitor) from(newChain)",
  "                if (false != generics) then {",
  "                    generics.accept(visitor) from(newChain)",
  "                }",
  "                for (self.signature) do { part ->",
  "                    for (part.params) do { p ->",
  "                        p.accept(visitor) from(newChain)",
  "                    }",
  "                    if (part.vararg != false) then {",
  "                        part.vararg.accept(visitor) from(newChain)",
  "                    }",
  "                }",
  "                if (dtype != false) then {",
  "                    dtype.accept(visitor) from(newChain)",
  "                }",
  "                for (self.annotations) do { ann ->",
  "                    ann.accept(visitor) from(newChain)",
  "                }",
  "                for (self.body) do { mx ->",
  "                    mx.accept(visitor) from(newChain)",
  "                }",
  "            }",
  "        }",
  "        method map(blk) ancestors(as){",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            n.body := listMap(body, blk) ancestors(newChain)",
  "            n.generics := maybeMap(generics, blk) ancestors(newChain)",
  "            n.signature := listMap(signature, blk) ancestors(newChain)",
  "            n.annotations := listMap(annotations, blk) ancestors(newChain)",
  "            n.dtype := maybeMap(dtype, blk) ancestors(newChain)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            var spc := \"\"",
  "            for (0..depth) do { i ->",
  "                spc := spc ++ \"  \"",
  "            }",
  "            var s := super.pretty(depth) ++ \"\\n\"",
  "            s := s ++ spc ++ \"Name: \" ++ self.value.pretty(depth+1)",
  "            s := s ++ \"\\n\"",
  "            if (false != self.dtype) then {",
  "                s := s ++ spc ++ \"Returns:\\n\" ++ spc ++ \"  \"",
  "                s := s ++ self.dtype.pretty(depth + 2) ++ \"\\n\"",
  "            }",
  "            if (isFresh) then { s := s ++ spc ++ \"Fresh\\n\" }",
  "            s := \"{s}{spc}Signature:\"",
  "            for (signature) do { part ->",
  "                s := \"{s}\\n  {spc}Part: {part.name}\"",
  "                s := \"{s}\\n    {spc}Parameters:\"",
  "                for (part.params) do { p ->",
  "                    s := \"{s}\\n      {spc}{p.pretty(depth + 4)}\"",
  "                }",
  "                if (part.vararg != false) then {",
  "                    s := \"{s}\\n    {spc}Vararg: {part.vararg.pretty(depth + 3)}\"",
  "                }",
  "            }",
  "            s := s ++ \"\\n\"",
  "            if (false != generics) then {",
  "                s := \"{s}{spc}Generics:\"",
  "                generics.do {g->",
  "                    s := \"{s}\\n{spc}  {g.pretty(0)}\"",
  "                }",
  "                s := s ++ \"\\n\"",
  "            }",
  "            if (annotations.size > 0) then {",
  "                s := \"{s}{spc}Annotations:\"",
  "                for (annotations) do {an->",
  "                    s := \"{s}\\n{spc}  {an.pretty(depth + 2)}\"",
  "                }",
  "                s := s ++ \"\\n\"",
  "            }",
  "            s := s ++ spc ++ \"Body:\"",
  "            for (self.body) do { mx ->",
  "                s := s ++ \"\\n  \"++ spc ++ mx.pretty(depth+2)",
  "            }",
  "            if (false != comments) then {",
  "                s := s ++ comments.pretty(depth+2)",
  "            }",
  "            s",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            var spc := \"\"",
  "            for (0..(depth - 1)) do { i ->",
  "                spc := spc ++ \"    \"",
  "            }",
  "            var s := \"method \"",
  "            var firstPart := true",
  "            for (self.signature) do { part ->",
  "                s := s ++ part.name",
  "                if (firstPart.andAlso{false != generics}) then {",
  "                    s := s ++ \"<\"",
  "                    for (1..(generics.size - 1)) do {ix ->",
  "                        s := s ++ generics.at(ix).toGrace(depth + 1)",
  "                    }",
  "                    s := s ++ generics.last.toGrace(depth + 1) ++ \">\"",
  "                }",
  "                firstPart := false",
  "                if ((part.params.size > 0) || (part.vararg != false)) then {",
  "                    s := s ++ \"(\"",
  "                    for (part.params.indices) do { pnr ->",
  "                        var p := part.params[pnr]",
  "                        s := s ++ p.toGrace(depth + 1)",
  "                        if ((pnr < part.params.size) || (part.vararg != false)) then {",
  "                            s := s ++ \", \"",
  "                        }",
  "                    }",
  "                    if (part.vararg != false) then {",
  "                        s := s ++ \"*\" ++ part.vararg.value",
  "                    }",
  "                    s := s ++ \")\"",
  "                }",
  "            }",
  "            if (self.dtype != false) then {",
  "                s := s ++ \" -> {self.dtype.toGrace(0)}\"",
  "            }",
  "            if (self.annotations.size > 0) then {",
  "                s := s ++ \" is \"",
  "                s := s ++ self.annotations.reduce(\"\", { a,b ->",
  "                    if (a != \"\") then { a ++ \", \" } else { \"\" } ++ b.toGrace(0) })",
  "            }",
  "            s := s ++ \" \\{\"",
  "            if (comments != false) then {",
  "                s := s ++ comments.toGrace(depth + 1)",
  "            }",
  "            for (self.body) do { mx ->",
  "                s := s ++ \"\\n\" ++ spc ++ \"    \" ++ mx.toGrace(depth + 1)",
  "            }",
  "            s := s ++ \"\\n\" ++ spc ++ \"\\}\"",
  "            s",
  "        }",
  "        method shallowCopy {",
  "            methodNode.new(value, signature, body, dtype).shallowCopyFieldsFrom(self)",
  "        }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            isFresh := other.isFresh",
  "            selfclosure := other.selfclosure",
  "            self",
  "        }",
  "    }",
  "}",
  "def callNode = object {",
  "    method new(what, with) scope(s) {",
  "        def result = new(what, with)",
  "        result.scope := s",
  "        result",
  "    }",
  "    factory method new(what, with') {",
  "        // requested as callNode.new(target:AstNode, parts:List)",
  "        // Represents a method request with arguments.",
  "        // The ‹target›.‹methodName› part is in `value`",
  "        // The argument list is in `with`, as a sequence of `callWithPart`s.",
  "        // [with]",
  "        //     object {",
  "        //         name := \"\"",
  "        //         args := sequence.empty",
  "        //     }",
  "        //     object {",
  "        //         name := \"\"",
  "        //         args := sequence.empty",
  "        //     }",
  "        //     ...",
  "        //     object {",
  "        //         ...",
  "        //     }",
  "        inherits baseNode.new",
  "        def kind is public = \"call\"",
  "        var value is public := what        // method being requested",
  "        var with is public := with'        // arguments",
  "        var generics is public := false",
  "        var isPattern is public := false",
  "        def nameString:String is public = value.nameString",
  "        ",
  "        method target { value }",
  "        method isCall { true }",
  "        method returnsObject {",
  "            if (value.isMember.not) then { return false }",
  "            if (value.nameString == \"clone\") then { return true }",
  "            if (value.nameString == \"copy\") then { return true }",
  "            return false",
  "        }",
  "        method returnedObjectScope {",
  "            // precondition: returnsObject",
  "            self.scope",
  "        }",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            if (visitor.visitCall(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                self.value.accept(visitor) from(newChain)",
  "                for (self.with) do { part ->",
  "                    for (part.args) do { arg ->",
  "                        arg.accept(visitor) from(newChain)",
  "                    }",
  "                }",
  "                if (false != generics) then {",
  "                    generics.do { each ->",
  "                        each.accept(visitor) from(newChain)",
  "                    }",
  "                }",
  "            }",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            n.value := value.map(blk) ancestors(newChain)",
  "            n.with := listMap(with, blk) ancestors(newChain)",
  "            n.generics := maybeListMap(generics, blk) ancestors(newChain)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            var spc := \"\"",
  "            for (0..depth) do { i ->",
  "                spc := spc ++ \"  \"",
  "            }",
  "            var s := super.pretty(depth) ++ \"\\n\"",
  "            s := s ++ spc ++ \"Method Name: {self.value.pretty(depth + 1)}\"",
  "            s := s ++ \"\\n\"",
  "            if (false != generics) then {",
  "                s := s ++ spc ++ \"  Generics:\\n\"",
  "                for (generics) do {g->",
  "                    s := s ++ spc ++ \"    \" ++ g.pretty(depth + 2) ++ \"\\n\"",
  "                }",
  "            }",
  "            s := s ++ spc ++ \"Arguments:\"",
  "            for (self.with) do { part ->",
  "                s := s ++ \"\\n  \" ++ spc ++ \"Part: \" ++ part.name",
  "                for (part.args) do { arg ->",
  "                    s := s ++ \"\\n      \" ++ spc ++ arg.pretty(depth + 2)",
  "                }",
  "            }",
  "            s",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            var spc := \"\"",
  "            repeat (depth) times {",
  "                spc := spc ++ \"    \"",
  "            }",
  "            var s := \"\"",
  "            // only the last member is the method call we need to handle",
  "            if (self.value.kind == \"member\") then {",
  "                var member := self.value",
  "                if (member.value.substringFrom(1)to(6) == \"prefix\") then {",
  "                    s := member.value.substringFrom(7)to(member.value.size)",
  "                    return s ++ member.in.toGrace(0)",
  "                }",
  "                if (member.in.isSimple) then {",
  "                    s := \"{member.in.toGrace 0}.\"",
  "                } else {",
  "                    s := \"({member.in.toGrace 0}).\"",
  "                }",
  "            }",
  "            var firstPart := true",
  "            for (self.with) do { part ->",
  "                s := s ++ part.name",
  "                if (firstPart.andAlso{generics != false}) then {",
  "                    s := s ++ \"<\"",
  "                    for (1..(generics.size - 1)) do {ix ->",
  "                        s := s ++ generics.at(ix).toGrace(depth + 1)",
  "                    }",
  "                    s := s ++ generics.last.toGrace(depth + 1) ++ \">\"",
  "                }",
  "                firstPart := false",
  "                if (part.args.size > 0) then {",
  "                    s := s ++ \"(\"",
  "                    for (part.args.indices) do { anr ->",
  "                        var arg := part.args[anr]",
  "                        s := s ++ arg.toGrace(depth + 1)",
  "                        if (anr < part.args.size) then {",
  "                            s := s ++ \", \"",
  "                        }",
  "                    }",
  "                    s := s ++ \")\"",
  "                }",
  "            }",
  "            s",
  "        }",
  "        method asString { \"call {what.pretty(0)}\" }",
  "        method shallowCopy {",
  "            callNode.new(value, with).shallowCopyFieldsFrom(self)",
  "        }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            isPattern := other.isPattern",
  "            self",
  "        }",
  "    }",
  "}",
  "class classNode.new(name', signature', body', superclass', constructor', dtype') {",
  "    // TODO  remove superclass as a parameter",
  "    // [signature]",
  "    //     object {",
  "    //         name := \"\"",
  "    //         params := sequence.empty",
  "    //         vararg := false/identifier",
  "    //     }",
  "    //     object {",
  "    //         name := \"\"",
  "    //         params := sequence.empty",
  "    //         vararg := false/identifier",
  "    //     }",
  "    //     ...",
  "    //     object {",
  "    //         ...",
  "    //     }",
  "    inherits baseNode.new",
  "    def kind is public = \"class\"",
  "    var value is public := body'",
  "    var name is public := name'",
  "    var constructor is public := constructor'",
  "    var signature is public := signature'",
  "    var dtype is public := dtype'",
  "    var generics is public := false",
  "    var superclass is public := superclass'",
  "    var annotations is public := list.empty",
  "    def nameString:String is public = name.value",
  "",
  "    var data is public := false",
  "",
  "    method declarationKindWithAncestors(as) {",
  "        \"method\"",
  "    }",
  "    method scope:=(st) {",
  "        // sets up the 2-way conection between this node and the",
  "        // symbol table that defines the scope that it opens.",
  "        symbolTable := st",
  "        st.node := self",
  "    }",
  "    method canInherit {true }",
  "    method returnsObject { true }",
  "    method returnedObjectScope { scope }",
  "",
  "    method isClass { true }",
  "    method isPublic {",
  "        // assume that classes are public by default",
  "        if (annotations.size == 0) then { return true }",
  "        findAnnotation(self, \"confidential\").not",
  "    }",
  "    method isWritable { false }",
  "    method isReadable { isPublic }",
  "    method usesAsType(aNode) {",
  "        aNode == dtype",
  "    }",
  "    method parametersDo(b) {",
  "        signature.do { part -> ",
  "            part.params.do { each -> b.apply(each) }",
  "        }",
  "    }",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitClass(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            self.name.accept(visitor) from(newChain)",
  "            self.constructor.accept(visitor) from(newChain)",
  "            if (false != generics) then {",
  "                generics.do { each ->",
  "                    each.accept(visitor) from(newChain)",
  "                }",
  "            }",
  "            if (superclass != false) then {",
  "                superclass.accept(visitor) from(newChain)",
  "            }",
  "            for (signature) do { partNode ->",
  "                partNode.accept(visitor) from(newChain)",
  "            }",
  "            if (dtype != false) then {",
  "                dtype.accept(visitor) from(newChain)",
  "            }",
  "            for (annotations) do { ann ->",
  "                ann.accept(visitor) from(newChain)",
  "            }",
  "            for (value) do { each ->",
  "                each.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.value := listMap(value, blk) ancestors(newChain)",
  "        n.name := name.map(blk) ancestors(newChain)",
  "        n.signature := listMap(signature, blk) ancestors(newChain)",
  "        n.generics := maybeMap(generics, blk) ancestors(newChain)",
  "        n.annotations := listMap(annotations, blk) ancestors(newChain)",
  "        n.superclass := maybeMap(superclass, blk) ancestors(newChain)",
  "        n.constructor := constructor.map(blk) ancestors(newChain)",
  "        n.dtype := maybeMap(dtype, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := \"{s}{spc}Name: {self.name.pretty(0)}\"",
  "        if (util.target == \"symbols\") then {",
  "            s := s ++ \"\\n{spc}Inner object symbols({scope.variety}): {scope.asString}\"",
  "            s := s ++ \"\\n{spc}Factory method symbols({scope.parent.variety}): {scope.parent.asString}\"",
  "            s := s ++ \"\\n{spc}Outer object symbols({scope.parent.parent.variety}): {scope.parent.parent.asString}\"",
  "            s := s ++ \"\\n{spc}enclosing symbols({scope.parent.parent.parent.variety}): {scope.parent.parent.parent.asDebugString}\"",
  "        }",
  "        if (self.superclass != false) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"Superclass:\"",
  "            s := s ++ \"\\n  \" ++ spc ++ self.superclass.pretty(depth + 2)",
  "        }",
  "        s := s ++ \"\\n\"",
  "        s := \"{s}{spc}Factory method: {constructor.pretty(0)}\\n\"",
  "        if(false != dtype) then {",
  "            s := \"{s}{spc}Returns:\\n  {spc}{dtype.pretty(depth + 2)}\\n\"",
  "        }",
  "        s := \"{s}{spc}Signature:\"",
  "        for (signature) do { part ->",
  "            s := \"{s}\\n  {spc}Part: {part.name}\"",
  "            s := \"{s}\\n    {spc}Parameters:\"",
  "            for (part.params) do { p ->",
  "                s := \"{s}\\n      {spc}{p.pretty(depth + 4)}\"",
  "            }",
  "            if (part.vararg != false) then {",
  "                s := \"{s}\\n    {spc}Vararg: {part.vararg.pretty(depth + 3)}\"",
  "            }",
  "        }",
  "        if (generics != false) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"Type Parameters:\\n\" ++",
  "                generics.pretty(depth + 2)",
  "        }",
  "        if (annotations.size > 0) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"Annotations:\"",
  "            for (annotations) do {a->",
  "                s := s ++ \" {a.pretty(depth + 2)}\"",
  "            }",
  "        }",
  "        s := s ++ \"\\n\" ++ spc ++ \"Body:\"",
  "        for (self.value) do { x ->",
  "            s := s ++ \"\\n  \"++ spc ++ x.pretty(depth+2)",
  "        }",
  "        if (false != comments) then {",
  "            s := s ++ comments.pretty(depth+2)",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"class {self.name.toGrace(0)}\"",
  "        if (self.name.kind != \"generic\") then {",
  "            // TODO generics + new-style constructors aren't possible at the moment",
  "            s := s ++ \".\"",
  "            for (self.signature) do { part ->",
  "                s := s ++ part.name",
  "                if ((part.params.size > 0) || (part.vararg != false)) then {",
  "                    s := s ++ \"(\"",
  "                    for (part.params.indices) do { pnr ->",
  "                        var p := part.params[pnr]",
  "                        s := s ++ p.toGrace(depth + 1)",
  "                        if ((pnr < part.params.size) || (part.vararg != false)) then {",
  "                            s := s ++ \", \"",
  "                        }",
  "                    }",
  "                    if (part.vararg != false) then {",
  "                        s := s ++ \"*\" ++ part.vararg.value",
  "                    }",
  "                    s := s ++ \")\"",
  "                }",
  "            }",
  "        }",
  "        if(false != dtype) then {",
  "            s := \"{s} -> {dtype.toGrace(depth + 1)}\"",
  "        }",
  "        s := s ++ \" \\{\"",
  "        for (self.value) do { mx ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ mx.toGrace(depth + 1)",
  "        }",
  "        s := s ++ \"\\n\" ++ spc ++ \"\\}\"",
  "        s",
  "    }",
  "    method shallowCopy {",
  "        classNode.new(name, emptySeq, emptySeq, false, nullNode, false)",
  "            .shallowCopyFieldsFrom(self)",
  "    }",
  "    method shallowCopyFieldsFrom(other) {",
  "        super.shallowCopyFieldsFrom(other)",
  "        data := other.data",
  "        self",
  "    }",
  "}",
  "def moduleNode = object {",
  "    method body(b) named(n) scope(s) {",
  "        def result = new(b)",
  "        result.classname := n",
  "        result.scope := s",
  "        result",
  "    }",
  "    factory method new(body) {",
  "        inherits objectNode.new(body, false)",
  "        def kind is public = \"module\"",
  "        method classname { \"module\" }",
  "        method isModule { true }",
  "        method returnsObject { false }",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            if (visitor.visitModule(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                if (self.superclass != false) then {",
  "                    self.superclass.accept(visitor) from(newChain)",
  "                }",
  "                for (self.value) do { x ->",
  "                    x.accept(visitor) from(newChain)",
  "                }",
  "            }",
  "        }",
  "        method shallowCopy {",
  "            moduleNode.new(emptySeq).shallowCopyFieldsFrom(self)",
  "        }",
  "    }",
  "}",
  "def objectNode = object {",
  "    method body(b) named(n) scope(s) {",
  "        def result = new(b, false)",
  "        result.classname := n",
  "        result.scope := s",
  "        result",
  "    }",
  "    method body(b) named(n) {",
  "        body(b) named(n) scope(fakeSymbolTable)",
  "    }",
  "    factory method new(body, superclass') {",
  "        // TODO  remove superclass as a parameter",
  "        inherits baseNode.new",
  "        def kind is public = \"object\"",
  "        var value is public := body",
  "        var superclass is public := superclass'",
  "        var classname is public := \"object\"",
  "        var data is public := false",
  "",
  "        method scope:=(st) {",
  "            // sets up the 2-way conection between this node",
  "            // and the symbol table that defines the scope that I open.",
  "            symbolTable := st",
  "            st.node := self",
  "        }",
  "        method returnsObject { true }",
  "        method returnedObjectScope { scope }",
  "        method canInherit {true }",
  "        method isObject { true }",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            if (visitor.visitObject(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                if (self.superclass != false) then {",
  "                    self.superclass.accept(visitor) from(newChain)",
  "                }",
  "                for (self.value) do { x ->",
  "                    x.accept(visitor) from(newChain)",
  "                }",
  "            }",
  "        }",
  "        method nameString { ",
  "            if (classname == \"object\") then {",
  "                \"object_on_line_{line}\"",
  "            } else {",
  "                classname",
  "            }",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            n.value := listMap(value, blk) ancestors(newChain)",
  "            n.superclass := maybeMap(superclass, blk) ancestors(newChain)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth') {",
  "            var depth := depth'",
  "            var spc := \"\"",
  "            for (0..depth) do { i ->",
  "                spc := spc ++ \"  \"",
  "            }",
  "            var s := super.pretty(depth)",
  "            if (self.superclass != false) then {",
  "                s := s ++ \"\\n\" ++ spc ++ \"Superclass:\"",
  "                s := s ++ \"\\n  \" ++ spc ++ self.superclass.pretty(depth + 1)",
  "                s := s ++ \"\\n\" ++ spc ++ \"Body:\"",
  "                depth := depth + 1",
  "            }",
  "            for (self.value) do { x ->",
  "                s := s ++ \"\\n\"++ spc ++ x.pretty(depth+1)",
  "            }",
  "            s",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            var spc := \"\"",
  "            for (0..(depth - 1)) do { i ->",
  "                spc := spc ++ \"    \"",
  "            }",
  "            var s := \"object \\{\"",
  "            for (self.value) do { x ->",
  "                s := s ++ \"\\n\" ++ spc ++ \"    \" ++ x.toGrace(depth + 1)",
  "            }",
  "            s := s ++ \"\\n\" ++ spc ++ \"\\}\"",
  "            s",
  "        }",
  "        method shallowCopy {",
  "            objectNode.new(emptySeq, false).shallowCopyFieldsFrom(self)",
  "        }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            data := other.data",
  "            classname := other.classname",
  "            self",
  "        }",
  "        method asString {",
  "            \"object {nameString}\"",
  "        }",
  "    }",
  "}",
  "class arrayNode.new(values) {",
  "    inherits baseNode.new",
  "    def kind is public = \"array\"",
  "    var value is public := values",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitArray(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            for (self.value) do { ax ->",
  "                ax.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.value := listMap(value, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { ai ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth)",
  "        for (self.value) do { ax ->",
  "            s := s ++ \"\\n\"++ spc ++ ax.pretty(depth+1)",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var s := \"[\"",
  "        for (self.value.indices) do { i ->",
  "            s := s ++ self.value[i].toGrace(0)",
  "            if (i < self.value.size) then {",
  "                s := s ++ \", \"",
  "            }",
  "        }",
  "        s := s ++ \"]\"",
  "        s",
  "    }",
  "    method shallowCopy {",
  "        arrayNode.new(emptySeq).shallowCopyFieldsFrom(self)",
  "    }",
  "}",
  "def memberNode = object {",
  "    method new(request, receiver) scope(s) {",
  "        def result = new(request, receiver)",
  "        result.scope := s",
  "        result",
  "    }",
  "    factory method new(request, receiver) {",
  "        // Represents a dotted request ‹receiver›.‹request›",
  "        inherits baseNode.new",
  "        def kind is public = \"member\"",
  "        var value is public := request  // NB: value is a String, not an Identifier",
  "        var in is public := receiver",
  "        var generics is public := false",
  "",
  "        method target { in }",
  "        method nameString { value }",
  "        method isMember { true }",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            if (visitor.visitMember(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                if (generics != false) then {",
  "                    generics.do { each -> each.accept(visitor) from(newChain) }",
  "                }",
  "                in.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            n.in := in.map(blk) ancestors(newChain)",
  "            n.generics := maybeListMap(generics, blk) ancestors(newChain)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            var spc := \"\"",
  "            for (0..depth) do { i ->",
  "                spc := spc ++ \"  \"",
  "            }",
  "            var s := \"{super.pretty(depth)}‹\" ++ self.value ++ \"›\\n\"",
  "            s := s ++ spc ++ in.pretty(depth)",
  "            if (generics != false) then {",
  "                s := s ++ \"\\n\" ++ spc ++ \"  Generics:\"",
  "                for (generics) do {g->",
  "                    s := s ++ \"\\n\" ++ spc ++ \"    \" ++ g.pretty(0)",
  "                }",
  "            }",
  "            s",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            var s := \"\"",
  "            if (self.value.substringFrom(1)to(6) == \"prefix\") then {",
  "                s := self.value.substringFrom(7)to(value.size)",
  "                s := s ++ \" \" ++ self.in.toGrace(0)",
  "            } else {",
  "                s := self.in.toGrace(depth) ++ \".\" ++ self.value",
  "            }",
  "            if (generics != false) then {",
  "                s := s ++ \"<\"",
  "                for (1..(generics.size - 1)) do {ix ->",
  "                    s := s ++ generics.at(ix).toGrace(depth + 1)",
  "                }",
  "                s := s ++ generics.last.toGrace(depth + 1) ++ \">\"",
  "            }",
  "            s",
  "        }",
  "        method asString { \"{in}.{value}\" }",
  "        method asIdentifier {",
  "            // make and return an identifiderNode for my request",
  "            def resultNode = identifierNode.new(value, false)",
  "            resultNode.inRequest := true",
  "            resultNode.line := line",
  "            resultNode.linePos := linePos",
  "            return resultNode",
  "        }",
  "        method shallowCopy {",
  "            memberNode.new(value, nullNode).shallowCopyFieldsFrom(self)",
  "        }",
  "    }",
  "}",
  "class genericNode.new(base, params') {",
  "    inherits baseNode.new",
  "    def kind is public = \"generic\"",
  "    var value is public := base        // APB: in a generic call, value is the called node",
  "                            // e.g. in List<Number>, value is Identifier‹List›",
  "    var params is public := params'",
  "    method nameString { value.nameString }",
  "    method asString { ",
  "        var s := \"generic {base}<\"",
  "        params.do { each -> s := \"{s}{each}\" } separatedBy { s := s ++ \", \" }",
  "        s ++ \">\"",
  "    }",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitGeneric(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            self.value.accept(visitor) from(newChain)",
  "            for (self.params) do { p ->",
  "                p.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.value := value.map(blk) ancestors(newChain)",
  "        n.params := listMap(params, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var s := \"{super.pretty(depth)}‹{self.value.value}›<\"",
  "        for (self.params.indices) do { i ->",
  "            s := s ++ self.params[i].pretty(depth+2)",
  "            if (i < self.params.size) then {",
  "                s := s ++ \", \"",
  "            }",
  "        }",
  "        s := s ++ \">\"",
  "        s",
  "",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var s := self.value.value ++ \"<\"",
  "        for (self.params.indices) do { i ->",
  "            s := s ++ self.params[i].toGrace(0)",
  "            if (i < self.params.size) then {",
  "                s := s ++ \", \"",
  "            }",
  "        }",
  "        s := s ++ \">\"",
  "        s",
  "    }",
  "    method shallowCopy {",
  "        genericNode.new(value, emptySeq).shallowCopyFieldsFrom(self)",
  "    }",
  "}",
  "",
  "class typeParametersNode.new(params') {",
  "    inherits baseNode.new",
  "    def kind is public = \"typeparams\"",
  "    var params is public := params'",
  "    method asString { ",
  "        var s := \"typeparams <\"",
  "        params.do { each -> s := \"{s}{each}\" } separatedBy { s := s ++ \", \" }",
  "        s ++ \">\"",
  "    }",
  "    method declarationKindWithAncestors(as) {",
  "        \"typeparam\"",
  "    }",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitTypeParameters(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            params.do { p ->",
  "                p.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method do(blk) {",
  "        params.do(blk)",
  "    }",
  "    method size { params.size }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.params := listMap(params, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        spc ++ super.pretty(depth) ++ self.asString",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        self.asString",
  "    }",
  "    method shallowCopy {",
  "        typeParametersNode.new(emptySeq).shallowCopyFieldsFrom(self)",
  "    }",
  "}",
  "def identifierNode = object {",
  "",
  "    method new(name, dtype) scope(s) {",
  "        def result = new(name, dtype)",
  "        result.scope := s",
  "        result",
  "    }",
  "",
  "    factory method new(name, dtype') {",
  "        inherits baseNode.new",
  "        def kind is public = \"identifier\"",
  "        var value is public := name",
  "        var wildcard is public := false",
  "        var dtype is public := dtype'",
  "        var isBindingOccurrence is public := false",
  "        var isAssigned is public := false",
  "        var inRequest is public := false",
  "        var generics is public := false",
  "        var isDeclaredByParent is public := false",
  "",
  "        method nameString { value }     //  value changes when parsing \"[]\"",
  "        ",
  "        method isIdentifier { true }",
  "",
  "        method isAppliedOccurenceOfIdentifier {",
  "            if (wildcard) then { ",
  "                false ",
  "            } else {",
  "                isBindingOccurrence.not",
  "            }",
  "        }",
  "        method declarationKindWithAncestors(as) {",
  "            as.parent.declarationKindWithAncestors(as)",
  "        }",
  "        method inTypePositionWithAncestors(as) {",
  "            // am I used by my parent node as a type?",
  "            // This is a hack, used as a subsitute for having information in the .gct",
  "            // telling us which identifiers represent types",
  "            if (as.isEmpty) then { return false }",
  "            as.parent.usesAsType(self)",
  "        }",
  "        method usesAsType(aNode) {",
  "            aNode == dtype",
  "        }",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            if (visitor.visitIdentifier(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                if (self.dtype != false) then {",
  "                    self.dtype.accept(visitor) from(newChain)",
  "                }",
  "            }",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            n.dtype := maybeMap(dtype, blk) ancestors(newChain)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            var spc := \"\"",
  "            for (0..depth) do { i ->",
  "                spc := spc ++ \"  \"",
  "            }",
  "            var s := super.pretty(depth)",
  "            if ( wildcard ) then {",
  "                s := s ++ \" Wildcard\"",
  "            } elseif { isBindingOccurrence } then {",
  "                s := s ++ \"Binding‹{value}›\"",
  "            } else {",
  "                s := s ++ \"‹{value}›\"",
  "            }",
  "            if (self.dtype != false) then {",
  "                s := s ++ \"\\n\" ++ spc ++ \"  Type: \"",
  "                s := s ++ self.dtype.pretty(depth + 2)",
  "            }",
  "            if (false != generics) then {",
  "                s := s ++ \"\\n\" ++ spc ++ \"Generics:\"",
  "                for (generics) do {g->",
  "                    s := s ++ spc ++ \"  \" ++ g.pretty(depth + 2)",
  "                }",
  "            }",
  "            s",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            var s",
  "            if(self.wildcard) then {",
  "                s := \"_\"",
  "            } else {",
  "                s := self.value",
  "            }",
  "            if (self.dtype != false) then {",
  "                s := s ++ \" : \" ++ self.dtype.toGrace(depth + 1)",
  "            }",
  "            if (false != generics) then {",
  "                s := s ++ \"<\"",
  "                for (1..(generics.size - 1)) do {ix ->",
  "                    s := s ++ generics.at(ix).toGrace(depth + 1)",
  "                }",
  "                s := s ++ generics.last.toGrace(depth + 1) ++ \">\"",
  "            }",
  "            s",
  "        }",
  "",
  "        method asString { ",
  "            if (isBindingOccurrence) then {",
  "                \"identifierBinding‹{value}›\"",
  "            } else { ",
  "                \"identifier‹{value}›\"",
  "            }",
  "        }",
  "        method shallowCopy {",
  "            identifierNode.new(value, false).shallowCopyFieldsFrom(self)",
  "        }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            wildcard := other.wildcard",
  "            isBindingOccurrence := other.isBindingOccurrence",
  "            isDeclaredByParent := other.isDeclaredByParent",
  "            isAssigned := other.isAssigned",
  "            inRequest := other.inRequest",
  "            self",
  "        }",
  "    }",
  "}",
  "",
  "def typeType is public = identifierNode.new(\"Type\", false)",
  "def unknownType is public = identifierNode.new(\"Unknown\", typeType)",
  "",
  "def stringNode = object {",
  "    method new(v) scope(s) {",
  "        def result = new(v)",
  "        result.scope := s",
  "        result",
  "    }",
  "",
  "    factory method new(v) {",
  "        inherits baseNode.new",
  "        def kind is public = \"string\"",
  "        var value is public := v",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            visitor.visitString(self) up(as)",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            \"{super.pretty(depth)}({self.value})\"",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            var s := \"\\\"\"",
  "            for (self.value) do { c ->",
  "                // TODO: what escapes are missing?",
  "                if (c == \"\\n\") then {",
  "                    s := s ++ \"\\\\n\"",
  "                } elseif (c == \"\\t\") then {",
  "                    s := s ++ \"\\\\t\"",
  "                } elseif (c == \"\\\"\") then {",
  "                    s := s ++ \"\\\\\\\"\"",
  "                } elseif (c == \"\\\\\") then {",
  "                    s := s ++ \"\\\\\\\\\"",
  "                } else {",
  "                    s := s ++ c",
  "                }",
  "            }",
  "            s := s ++ \"\\\"\"",
  "            s",
  "        }",
  "        method shallowCopy {",
  "            stringNode.new(value).shallowCopyFieldsFrom(self)",
  "        }",
  "    }",
  "}",
  "class numNode.new(val) {",
  "    inherits baseNode.new",
  "    def kind is public = \"num\"",
  "    var value is public := val",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        visitor.visitNum(self) up(as)",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        \"{super.pretty(depth)}({self.value})\"",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        self.value.asString",
  "    }",
  "    method asString { \"num {value}\" }",
  "    method shallowCopy {",
  "        numNode.new(value).shallowCopyFieldsFrom(self)",
  "    }",
  "}",
  "class opNode.new(op, l, r) {",
  "    inherits baseNode.new",
  "    def kind is public = \"op\"",
  "    def value is public = op     // a String",
  "    var left is public := l",
  "    var right is public := r",
  "    method isSimple { false }  // needs parens when used as reciever",
  "    method nameString { value }",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitOp(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            self.left.accept(visitor) from(newChain)",
  "            self.right.accept(visitor) from(newChain)",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.left := left.map(blk) ancestors(newChain)",
  "        n.right := right.map(blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"{super.pretty(depth)}‹\" ++ self.value ++ \"›\"",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ self.left.pretty(depth + 1)",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ self.right.pretty(depth + 1)",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var s := \"\"",
  "        if ((self.left.kind == \"op\") && (self.left.value != self.value)) then {",
  "            s := \"(\" ++ self.left.toGrace(0) ++ \")\"",
  "        } else {",
  "            s := self.left.toGrace(0)",
  "        }",
  "        if (self.value == \"..\") then {",
  "            s := s ++ self.value",
  "        } else {",
  "            s := s ++ \" \" ++ self.value ++ \" \"",
  "        }",
  "        if ((self.right.kind == \"op\") && (self.right.value != self.value)) then {",
  "            s := s ++ \"(\" ++ self.right.toGrace(0) ++ \")\"",
  "        } else {",
  "            s := s ++ self.right.toGrace(0)",
  "        }",
  "        s",
  "    }",
  "    method asIdentifier {",
  "        // make an identifiderNode with the same properties as me",
  "        def resultNode = identifierNode.new(value, false)",
  "        resultNode.inRequest := true",
  "        resultNode.line := line",
  "        resultNode.linePos := linePos",
  "        return resultNode",
  "    }",
  "    method shallowCopy {",
  "        opNode.new(value, nullNode, nullNode).shallowCopyFieldsFrom(self)",
  "    }",
  "}",
  "class indexNode.new(expr, index') {",
  "    // an expression in square brackets",
  "    inherits baseNode.new",
  "    def kind is public = \"index\"",
  "    var value is public := expr",
  "    var index is public := index'",
  "    ",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitIndex(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            self.value.accept(visitor) from(newChain)",
  "            self.index.accept(visitor) from(newChain)",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.value := value.map(blk) ancestors(newChain)",
  "        n.index := index.map(blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ self.value.pretty(depth + 1)",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ self.index.pretty(depth + 1)",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := self.value.toGrace(depth + 1)",
  "        s := s ++ \"[\" ++ self.index.toGrace(depth + 1) ++ \"]\"",
  "        s",
  "    }",
  "    method shallowCopy {",
  "        indexNode.new(nullNode, nullNode).shallowCopyFieldsFrom(self)",
  "    }",
  "}",
  "class bindNode.new(dest', val') {",
  "    // an assignment, or a request of a setter-method",
  "    inherits baseNode.new",
  "    def kind is public = \"bind\"",
  "    var dest is public := dest'",
  "    var value is public := val'",
  "    ",
  "    method isBind { true }",
  "    method asString { \"bind {value}\" }",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitBind(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            self.dest.accept(visitor) from(newChain)",
  "            self.value.accept(visitor) from(newChain)",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.dest := dest.map(blk) ancestors(newChain)",
  "        n.value := value.map(blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ self.dest.pretty(depth + 1)",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ self.value.pretty(depth + 1)",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := self.dest.toGrace(depth + 1)",
  "        s := s ++ \" := \" ++ self.value.toGrace(depth + 1)",
  "        s",
  "    }",
  "    method shallowCopy {",
  "        bindNode.new(dest, value).shallowCopyFieldsFrom(self)",
  "    }",
  "}",
  "def defDecNode = object {",
  "    method new(name', val, dtype') scope(s) {",
  "        def result = new(name', val, dtype')",
  "        result.scope := s",
  "        result",
  "    }",
  "",
  "    factory method new(name', val, dtype') {",
  "        inherits baseNode.new",
  "        def kind is public = \"defdec\"",
  "        var name is public := name'",
  "        var value is public := val",
  "        var dtype is public := dtype'",
  "        def nameString:String is public = name.value",
  "        var annotations is public := list.empty",
  "        var data is public := false",
  "        var startToken is public := false",
  "",
  "        method isPublic {",
  "            // defs are confidential by default",
  "            if (annotations.size == 0) then { return false }",
  "            if (findAnnotation(self, \"public\")) then { return true }",
  "            findAnnotation(self, \"readable\")",
  "        }",
  "        method isWritable { false }",
  "        method isReadable { isPublic }",
  "    //    method isFieldDec { ",
  "    //        if (parent.kind == \"object\") then { true }",
  "    //            elseif {parent.kind == \"class\"} then { true }",
  "    //            else { false }",
  "    //    }",
  "        method returnsObject {",
  "            value.returnsObject",
  "        }",
  "        method returnedObjectScope {",
  "            // precondition: returnsObject",
  "            value.returnedObjectScope",
  "        }",
  "        method usesAsType(aNode) {",
  "            aNode == dtype",
  "        }",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            if (visitor.visitDefDec(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                self.name.accept(visitor) from(newChain)",
  "                if (self.dtype != false) then {",
  "                    self.dtype.accept(visitor) from(newChain)",
  "                }",
  "                for (self.annotations) do { ann ->",
  "                    ann.accept(visitor) from(newChain)",
  "                }",
  "                if (self.value != false) then {",
  "                    self.value.accept(visitor) from(newChain)",
  "                }",
  "            }",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            n.name := name.map(blk) ancestors(newChain)",
  "            n.value := value.map(blk) ancestors(newChain)",
  "            n.dtype := maybeMap(dtype, blk) ancestors(newChain)",
  "            n.annotations := listMap(annotations, blk) ancestors(newChain)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            var spc := \"\"",
  "            for (0..depth) do { i ->",
  "                spc := spc ++ \"  \"",
  "            }",
  "            var s := super.pretty(depth) ++ \"\\n\"",
  "            s := s ++ spc ++ self.name.pretty(depth)",
  "            if (dtype != false) then {",
  "                s := s ++ \"\\n\" ++ spc ++ \"Type: \" ++ self.dtype.pretty(depth + 2)",
  "            }",
  "            if (false != value) then {",
  "                s := s ++ \"\\n\" ++ spc ++ \"Value: \" ++ value.pretty(depth + 2)",
  "            }",
  "            if (annotations.isEmpty.not) then {",
  "                s := s ++ \"\\n{spc}Annotations:\"",
  "                annotations.do { ann ->",
  "                    s := \"{s} {ann.pretty(depth + 2)}\"",
  "                }",
  "            }",
  "            if (false != comments) then {",
  "                s := s ++ comments.pretty(depth+2)",
  "            }",
  "            s",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            var spc := \"\"",
  "            for (0..(depth - 1)) do { i ->",
  "                spc := spc ++ \"    \"",
  "            }",
  "            var s := \"def {self.name.toGrace(0)}\"",
  "            if ( (self.dtype != false).andAlso{",
  "                    self.dtype.value != \"Unknown\" }) then {",
  "                s := s ++ \" : \" ++ self.dtype.toGrace(0)",
  "            }",
  "            if (self.annotations.size > 0) then {",
  "                s := s ++ \" is \"",
  "                s := s ++ self.annotations.reduce(\"\", { a,b ->",
  "                    if (a != \"\") then { a ++ \", \" } else { \"\" } ++ b.toGrace(0) })",
  "            }",
  "            if (self.value != false) then {",
  "                s := s ++ \" = \" ++ self.value.toGrace(depth)",
  "            }",
  "            s",
  "        }",
  "        method shallowCopy {",
  "            defDecNode.new(name, value, dtype).shallowCopyFieldsFrom(self)",
  "        }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            data := other.data",
  "            startToken := other.startToken",
  "            self",
  "        }",
  "    }",
  "}",
  "class varDecNode.new(name', val', dtype') {",
  "    inherits baseNode.new",
  "    def kind is public = \"vardec\"",
  "    var name is public := name'",
  "    var value is public := val'",
  "    var dtype is public := dtype'",
  "    def nameString:String is public = name.value",
  "    var annotations is public := list.empty",
  "",
  "    method isPublic {",
  "        // vars are confidential by default",
  "        if (annotations.size == 0) then { return false }",
  "        if (findAnnotation(self, \"public\")) then { return true }",
  "        findAnnotation(self, \"readable\")",
  "    }",
  "    method isWritable {",
  "        if (annotations.size == 0) then { return false }",
  "        if (findAnnotation(self, \"public\")) then { return true }",
  "        if (findAnnotation(self, \"writable\")) then { return true }",
  "        false",
  "    }",
  "    method isReadable {",
  "        if (annotations.size == 0) then { return false }",
  "        if (findAnnotation(self, \"public\")) then { return true }",
  "        if (findAnnotation(self, \"readable\")) then { return true }",
  "        false",
  "    }",
  "//    method isFieldDec { ",
  "//        if (parent.kind == \"object\") then { true }",
  "//            elseif {parent.kind == \"class\"} then { true }",
  "//            else { false }",
  "//    }",
  "    method usesAsType(aNode) {",
  "        aNode == dtype",
  "    }",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitVarDec(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            self.name.accept(visitor) from(newChain)",
  "            if (self.dtype != false) then {",
  "                self.dtype.accept(visitor) from(newChain)",
  "            }",
  "            for (self.annotations) do { ann ->",
  "                ann.accept(visitor) from(newChain)",
  "            }",
  "            if (self.value != false) then {",
  "                self.value.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.name := name.map(blk) ancestors(newChain)",
  "        n.value := maybeMap(value, blk) ancestors(newChain)",
  "        n.dtype := maybeMap(dtype, blk) ancestors(newChain)",
  "        n.annotations := listMap(annotations, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for ((0..depth)) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ self.name.pretty(depth + 1)",
  "        if (self.dtype != false) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"Type: \"",
  "            s := s ++ self.dtype.pretty(depth + 2)",
  "        }",
  "        if (false != self.value) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"Value: \"",
  "            s := s ++ self.value.pretty(depth + 2)",
  "        }",
  "        if (false != comments) then {",
  "            s := s ++ comments.pretty(depth+2)",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        repeat (depth) times {",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"var {self.name.toGrace(0)}\"",
  "        if ( (self.dtype != false).andAlso{",
  "                self.dtype.value != \"Unknown\" }) then {",
  "            s := s ++ \" : \" ++ self.dtype.toGrace(0)",
  "        }",
  "        if (self.annotations.size > 0) then {",
  "            s := s ++ \" is \"",
  "            s := s ++ self.annotations.reduce(\"\", { a,b ->",
  "                if (a != \"\") then { a ++ \", \" } else { \"\" } ++ b.toGrace(0) })",
  "        }",
  "        if (self.value != false) then {",
  "            s := s ++ \" := \" ++ self.value.toGrace(depth)",
  "        }",
  "        s",
  "    }",
  "    method shallowCopy {",
  "        varDecNode.new(name, value, dtype).shallowCopyFieldsFrom(self)",
  "    }",
  "}",
  "class importNode.new(path', name', dtype') {",
  "    inherits baseNode.new",
  "    def kind is public = \"import\"",
  "    var value is public := name'",
  "    var path is public := path'",
  "    var annotations is public := list.empty",
  "    var dtype is public := dtype'",
  "    method isImport { true }",
  "    method name { value }",
  "    method nameString { value.nameString }",
  "    method isPublic {",
  "        // imports, like defs, are confidential by default",
  "        if (annotations.size == 0) then { return false }",
  "        if (findAnnotation(self, \"public\")) then { return true }",
  "        findAnnotation(self, \"readable\")",
  "    }",
  "    method moduleName {",
  "        var bnm := \"\"",
  "        for (path) do {c->",
  "            if (c == \"/\") then {",
  "                bnm := \"\"",
  "            } else {",
  "                bnm := bnm ++ c",
  "            }",
  "        }",
  "        bnm",
  "    }",
  "    method isWritable { false }",
  "    method isReadable { isPublic }",
  "    method declarationKindWithAncestors(as) { \"defdec\" }",
  "    method usesAsType(aNode) {",
  "        aNode == dtype",
  "    }",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitImport(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            for (self.annotations) do { ann ->",
  "                ann.accept(visitor) from(newChain)",
  "            }",
  "            self.value.accept(visitor) from(newChain)",
  "            if (self.dtype != false) then {",
  "                self.dtype.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.value := value.map(blk) ancestors(newChain)",
  "        n.dtype := maybeMap(dtype, blk) ancestors(newChain)",
  "        n.annotations := listMap(annotations, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ \"{spc}Path: {path}\\n\"",
  "        s := s ++ \"{spc}Identifier: {value}\\n\"",
  "        if (annotations.size > 0) then {",
  "            s := s ++ \"{spc}Anotations: {annotations}\\n\"",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        \"import \\\"{self.path}\\\" as {nameString}\"",
  "    }",
  "    method shallowCopy {",
  "        importNode.new(path, nullNode, false).shallowCopyFieldsFrom(self)",
  "    }",
  "}",
  "class dialectNode.new(path') {",
  "    inherits baseNode.new",
  "    def kind is public = \"dialect\"",
  "    var value is public := path'",
  "    ",
  "    method isDialect { true }",
  "    method moduleName {",
  "        var bnm := \"\"",
  "        for (value) do {c->",
  "            if (c == \"/\") then {",
  "                bnm := \"\"",
  "            } else {",
  "                bnm := bnm ++ c",
  "            }",
  "        }",
  "        bnm",
  "    }",
  "    method path {",
  "        value",
  "    }",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        visitor.visitDialect(self) up(as)",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ \"{spc}Path: {self.value}\\n\"",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        \"dialect \\\"{self.value}\\\"\"",
  "    }",
  "    method shallowCopy {",
  "        dialectNode.new(value).shallowCopyFieldsFrom(self)",
  "    }",
  "}",
  "class returnNode.new(expr) {",
  "    inherits baseNode.new",
  "    def kind is public = \"return\"",
  "    var value is public := expr",
  "",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitReturn(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            self.value.accept(visitor) from(newChain)",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.value := value.map(blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ self.value.pretty(depth + 1)",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        \"return \" ++ self.value.toGrace(depth)",
  "    }",
  "    method shallowCopy {",
  "        returnNode.new(nullNode).shallowCopyFieldsFrom(self)",
  "    }",
  "}",
  "def inheritsNode = object {",
  "    method new(expr) scope(s) {",
  "        def result = new(expr)",
  "        result.scope := s",
  "        result",
  "    }",
  "    factory method new(expr) {",
  "        inherits baseNode.new",
  "        def kind is public = \"inherits\"",
  "        var value is public := expr",
  "        var providedNames is public := list.empty",
  "        ",
  "        method isInherits { true }",
  "        method inheritsFromMember { value.isMember }",
  "        method inheritsFromCall { value.isCall }",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            if (visitor.visitInherits(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                self.value.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            n.value := value.map(blk) ancestors(newChain)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            var spc := \"\"",
  "            for (0..depth) do { i ->",
  "                spc := spc ++ \"  \"",
  "            }",
  "            var s := super.pretty(depth) ++ \"\\n\"",
  "            s := s ++ spc ++ self.value.pretty(depth + 1)",
  "            if (providedNames.isEmpty.not) then {",
  "                s := s ++ \"\\n{spc}Provided names: {providedNames}\"",
  "            }",
  "            s",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            \"inherits {self.value.toGrace(0)}\"",
  "        }",
  "        method nameString { value.toGrace(0) }",
  "        method shallowCopy {",
  "            inheritsNode.new(nullNode).shallowCopyFieldsFrom(self)",
  "        }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            providedNames := other.providedNames",
  "            self",
  "        }",
  "    }",
  "}",
  "class blankNode.new {",
  "    inherits baseNode.new",
  "    def kind is public = \"blank\"",
  "    def value is public = \"blank\"",
  "    ",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        visitor.visitBlank(self) up(as)",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        blk.apply(n, as)",
  "    }",
  "    method nameString { \"\" }",
  "    method asString { \"blank\" }",
  "    method toGrace(depth : Number) -> String { \"\" }",
  "    method shallowCopy {",
  "        blankNode.new.shallowCopyFieldsFrom(self)",
  "    }",
  "}",
  "def signaturePart = object {",
  "    method new(*values) scope(s) {",
  "        var result",
  "        if (values.size == 1) then {",
  "            result := new(values[1])",
  "        } elseif { values.size == 2 } then {",
  "            result := new(values[1], values[2])",
  "        } else {",
  "            ProgrammingError.raise \"wrong number of arguments for signaturePart()scope()\"",
  "        }",
  "        result.scope := s",
  "        result",
  "    }",
  "    factory method new(*values) {",
  "        //  all parameters are optional",
  "        //     values[1]: this part of the method-name",
  "        //     values[2]: the sequence of paremeters",
  "        //     values[3]: false if there is no variable arity parameter,",
  "        //          otherwise the identifier representing it.",
  "",
  "        inherits baseNode.new",
  "        def kind is public = \"signaturepart\"",
  "        var name is public := \"\"",
  "        var params is public := list.empty",
  "        var vararg is public := false",
  "        var generics is public := false",
  "        var lineLength is public := 0",
  "        if (values.size > 0) then {",
  "            name := values[1]",
  "        }",
  "        if (values.size > 1) then {",
  "            params := values[2]",
  "        }",
  "        if (values.size > 2) then {",
  "            vararg := values[3]",
  "        }",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            if (visitor.visitSignaturePart(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                params.do { p -> p.accept(visitor) from(newChain) }",
  "                if (false != vararg) then { vararg.accept(visitor) from(newChain) }",
  "                if (false != generics) then {",
  "                    generics.do { g -> g.accept(visitor) from(newChain) }",
  "                }",
  "            }",
  "        }",
  "        method declarationKindWithAncestors(as) { \"parameter\" }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            n.params := listMap(params, blk) ancestors(newChain)",
  "            n.vararg := maybeMap(vararg, blk) ancestors(newChain)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            var spc := \"\"",
  "            for (0..depth) do { i ->",
  "                spc := spc ++ \"  \"",
  "            }",
  "            var s := \"{super.pretty(depth)}: {name}\"",
  "            if (params.isEmpty.not) then { s := \"{s}\\n{spc}Parameters:\" }",
  "            for (params) do { p ->",
  "                s := \"{s}\\n  {spc}{p.pretty(depth + 2)}\"",
  "            }",
  "            if (vararg != false) then {",
  "                s := \"{s}\\n  {spc}Vararg: {vararg.pretty(depth + 1)}\"",
  "            }",
  "            s",
  "        }",
  "        method shallowCopy {",
  "            signaturePart.new(name).shallowCopyFieldsFrom(self)",
  "        }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            lineLength := other.lineLength",
  "            self",
  "        }",
  "        method asString {",
  "            \"part: {name}\"",
  "        }",
  "    }",
  "}",
  "",
  "def callWithPart = object {",
  "    method new(name, argList) scope (s) {",
  "        def result = new(name, argList)",
  "        result.scope := s",
  "        result",
  "    }",
  "    factory method new(*values) {",
  "        // requested as",
  "        // - callWithPart.new(request:String), or",
  "        // - callWithPart.new(request:String, arguments:List)",
  "        // The first is equivalent to the second with an empty list of arguments",
  "        inherits baseNode.new",
  "        def kind is public = \"callwithpart\"",
  "        var name is public := \"\"",
  "        var args is public := list.empty",
  "        var lineLength is public := 0",
  "        if (values.size > 0) then {",
  "            name := values[1]",
  "        }",
  "        if (values.size > 1) then {",
  "            args := values[2]",
  "        }",
  "",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            n.args := listMap(args, blk) ancestors(newChain)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            var spc := \"\"",
  "            repeat (depth+1) times {",
  "                spc := spc ++ \"  \"",
  "            }",
  "            var s := \"{super.pretty(depth)}: {name}\"",
  "            s := \"{s}\\n    {spc}Args:\"",
  "            for (args) do { a ->",
  "                s := \"{s}\\n    {spc}{a.pretty(depth + 4)}\"",
  "            }",
  "            s",
  "        }",
  "        method shallowCopy {",
  "            callWithPart.new(name).shallowCopyFieldsFrom(self)",
  "        }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            lineLength := other.lineLength",
  "            self",
  "        }",
  "    }",
  "}",
  "",
  "def commentNode = object {",
  "    factory method new(val') {",
  "        inherits baseNode.new",
  "        def kind is public = \"comment\"",
  "        var value:String is public := val'",
  "        var isPartialLine:Boolean is public := false",
  "        var isPreceededByBlankLine is public := false",
  "        var endLine is public := util.linenum",
  "        method isComment { true }",
  "        method asString { \"comment ({line}–{endLine}): {value}\" }",
  "        method extendCommentUsing(cmtNode) {",
  "            value := value ++ \" \" ++ cmtNode.value",
  "            endLine := cmtNode.endLine",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            blk.apply(n, as)",
  "        }",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            visitor.visitComment(self) up(as)",
  "        }",
  "        method pretty(depth) {",
  "            var s := \"\\n\"",
  "            repeat (depth-1) times {",
  "                s := s ++ \"  \"",
  "            }",
  "            def pb = if (isPreceededByBlankLine) then { \" > blank\" } else { \"\" }",
  "            \"{s}Comment{pb}({line}–{endLine}): ‹{value}›\"",
  "        }",
  "        method toGrace(depth) {",
  "            // Partial line comments don't start with a newline, whereas",
  "            // full-line comments do.  No newline at end in either case.",
  "            if (isPartialLine) then {",
  "                \"// (partial) {value}\"",
  "            } else {",
  "                var spc := \"\"",
  "                repeat (depth) times { spc := spc ++ \"    \" }",
  "                wrap(value) to (lineLength) prefix (spc ++ \"// \")",
  "            }",
  "        }",
  "        method shallowCopy {",
  "            commentNode.new(nullNode).shallowCopyFieldsFrom(self)",
  "        }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            value := other.value",
  "            isPartialLine := other.isPartialLine",
  "            endLine := other.endLine",
  "            self",
  "        }",
  "    }",
  "}",
  "",
  "method wrap(str:String) to (l:Number) prefix (margin:String) {",
  "    def ind = margin.size",
  "    def len = max(ind + 4, l)",
  "    if ((ind + str.size) <= len) then {",
  "        return \"\\n\" ++ margin ++ str",
  "    }",
  "    var currBreak ",
  "    var trimmedLine",
  "",
  "    try {",
  "        currBreak := str.lastIndexOf \" \" startingAt (len - ind)",
  "            ifAbsent {len - ind}",
  "        trimmedLine := str.substringFrom (1) to (currBreak).trim",
  "    } catch { ex:NoSuchMethod ->  // C string libraries lack methods",
  "        currBreak := min(len - ind, str.size)",
  "        (1..currBreak).do { ix ->",
  "            if (str.at(ix) == \" \") then { currBreak := ix }",
  "        }",
  "        var end := currBreak",
  "        while {(end >= 1).andAlso{str.at(end) == \" \"}} do {",
  "            end := end - 1",
  "        }",
  "        var start := 1",
  "        while {(start <= str.size).andAlso{str.at(start) == \" \"}} do {",
  "            start := start + 1",
  "        }",
  "        trimmedLine := str.substringFrom (start) to (end)",
  "    }",
  "    \"\\n\" ++ margin ++ trimmedLine ++",
  "        wrap(str.substringFrom (currBreak+1) to (str.size))",
  "            to (l) prefix (margin)",
  "}",
  "",
  "",
  "type ASTVisitor = {",
  "     visitIf(o) up(as) -> Boolean",
  "     visitBlock(o) up(as) -> Boolean",
  "     visitMatchCase(o) up(as) -> Boolean",
  "     visitCatchCase(o) up(as) -> Boolean",
  "     visitMethodType(o) up(as) -> Boolean",
  "     visitSignaturePart(o) up(as) -> Boolean",
  "     visitTypeLiteral(o) up(as) -> Boolean",
  "     visitTypeParameters(o) up(as) -> Boolean",
  "     visitTypeDec(o) up(as) -> Boolean",
  "     visitMethod(o) up(as) -> Boolean",
  "     visitCall(o) up(as) -> Boolean",
  "     visitClass(o) up(as) -> Boolean",
  "     visitObject(o) up(as) -> Boolean",
  "     visitModule(o) up(as) -> Boolean",
  "     visitArray(o) up(as) -> Boolean",
  "     visitMember(o) up(as) -> Boolean",
  "     visitGeneric(o) up(as) -> Boolean",
  "     visitIdentifier(o) up(as) -> Boolean",
  "     visitString(o) up(as) -> Boolean",
  "     visitNum(o) up(as) -> Boolean",
  "     visitOp(o) up(as) -> Boolean",
  "     visitIndex(o) up(as) -> Boolean ",
  "     visitBind(o) up(as) -> Boolean",
  "     visitDefDec(o) up(as) -> Boolean",
  "     visitVarDec(o) up(as) -> Boolean",
  "     visitImport(o) up(as) -> Boolean",
  "     visitReturn(o) up(as) -> Boolean",
  "     visitInherits(o) up(as) -> Boolean",
  "     visitDialect(o) up(as) -> Boolean",
  "     visitBlank(o) up(as) -> Boolean",
  "     visitComment(o) up(as) -> Boolean",
  "}",
  "",
  "factory method baseVisitor -> ASTVisitor {",
  "    method visitIf(o) up(as) { visitIf(o) }",
  "    method visitBlock(o) up(as) { visitBlock(o) }",
  "    method visitMatchCase(o) up(as) { visitMatchCase(o) }",
  "    method visitCatchCase(o) up(as) { visitCatchCase(o) }",
  "    method visitMethodType(o) up(as) { visitMethodType(o) }",
  "    method visitSignaturePart(o) up(as) { visitSignaturePart(o) }",
  "    method visitTypeDec(o) up(as) { visitTypeDec(o) }",
  "    method visitTypeLiteral(o) up(as) { visitTypeLiteral(o) }",
  "    method visitTypeParameters(o) up(as) { visitTypeParameters(o) }",
  "    method visitMethod(o) up(as) { visitMethod(o) }",
  "    method visitCall(o) up(as) { visitCall(o) }",
  "    method visitClass(o) up(as) { visitClass(o) }",
  "    method visitObject(o) up(as) { visitObject(o) }",
  "    method visitModule(o) up(as) { visitObject(o) }",
  "    method visitArray(o) up(as) { visitArray(o) }",
  "    method visitMember(o) up(as) { visitMember(o) }",
  "    method visitGeneric(o) up(as) { visitGeneric(o) }",
  "    method visitIdentifier(o) up(as) { visitIdentifier(o) }",
  "    method visitString(o) up(as) { visitString(o) }",
  "    method visitNum(o) up(as) { visitNum(o) }",
  "    method visitOp(o) up(as) { visitOp(o) }",
  "    method visitIndex(o) up(as) { visitIndex(o) }",
  "    method visitBind(o) up(as) { visitBind(o) }",
  "    method visitDefDec(o) up(as) { visitDefDec(o) }",
  "    method visitVarDec(o) up(as) { visitVarDec(o) }",
  "    method visitImport(o) up(as) { visitImport(o) }",
  "    method visitReturn(o) up(as) { visitReturn(o) }",
  "    method visitInherits(o) up(as) { visitInherits(o) }",
  "    method visitDialect(o) up(as) { visitDialect(o) }",
  "    method visitBlank(o) up(as) { visitBlank(o) }",
  "    method visitComment(o) up(as) { visitComment(o) }",
  "",
  "    method visitIf(o) -> Boolean { true }",
  "    method visitBlock(o) -> Boolean { true }",
  "    method visitMatchCase(o) -> Boolean { true }",
  "    method visitCatchCase(o) -> Boolean { true }",
  "    method visitMethodType(o) -> Boolean { true }",
  "    method visitSignaturePart(o) -> Boolean { true }",
  "    method visitTypeDec(o) -> Boolean { true }",
  "    method visitTypeLiteral(o) -> Boolean { true }",
  "    method visitTypeParameters(o) -> Boolean { true }",
  "    method visitMethod(o) -> Boolean { true }",
  "    method visitCall(o) -> Boolean { true }",
  "    method visitClass(o) -> Boolean { true }",
  "    method visitObject(o) -> Boolean { true }",
  "    method visitModule(o) -> Boolean { true }",
  "    method visitArray(o) -> Boolean { true }",
  "    method visitMember(o) -> Boolean { true }",
  "    method visitGeneric(o) -> Boolean { true }",
  "    method visitIdentifier(o) -> Boolean { true }",
  "    method visitString(o) -> Boolean { true }",
  "    method visitNum(o) -> Boolean { true }",
  "    method visitOp(o) -> Boolean { true }",
  "    method visitIndex(o) -> Boolean { true }",
  "    method visitBind(o) -> Boolean { true }",
  "    method visitDefDec(o) -> Boolean { true }",
  "    method visitVarDec(o) -> Boolean { true }",
  "    method visitImport(o) -> Boolean { true }",
  "    method visitReturn(o) -> Boolean { true }",
  "    method visitInherits(o) -> Boolean { true }",
  "    method visitDialect(o) -> Boolean { true }",
  "    method visitBlank(o) -> Boolean { true }",
  "    method visitComment(o) -> Boolean { true }",
  "    ",
  "    method asString { \"an AST visitor\" }",
  "}",
  "",
  "factory method pluggableVisitor(visitation:Block2) -> ASTVisitor {",
  "    // Manufactures a default visitor, given a 2-parameter block.",
  "    // Typically, some of the methods will be overridden.",
  "    // The block will be applied with the AST node as the first argument",
  "    // and the ancestor chain as the second, and should answer true if",
  "    // the visitation is to continue and false if it is to go no deeper.",
  "",
  "    method visitIf(o) up(as) { visitation.apply (o, as) }",
  "    method visitBlock(o) up(as) { visitation.apply (o, as) }",
  "    method visitMatchCase(o) up(as) { visitation.apply (o, as) }",
  "    method visitCatchCase(o) up(as) { visitation.apply (o, as) }",
  "    method visitMethodType(o) up(as) { visitation.apply (o, as) }",
  "    method visitSignaturePart(o) up(as) { visitation.apply (o, as) }",
  "    method visitTypeDec(o) up(as) { visitation.apply (o, as) }",
  "    method visitTypeLiteral(o) up(as) { visitation.apply (o, as) }",
  "    method visitMethod(o) up(as) { visitation.apply (o, as) }",
  "    method visitCall(o) up(as) { visitation.apply (o, as) }",
  "    method visitClass(o) up(as) { visitation.apply (o, as) }",
  "    method visitObject(o) up(as) { visitation.apply (o, as) }",
  "    method visitModule(o) up(as) { visitation.apply (o, as) }",
  "    method visitArray(o) up(as) { visitation.apply (o, as) }",
  "    method visitMember(o) up(as) { visitation.apply (o, as) }",
  "    method visitGeneric(o) up(as) { visitation.apply (o, as) }",
  "    method visitIdentifier(o) up(as) { visitation.apply (o, as) }",
  "    method visitString(o) up(as) { visitation.apply (o, as) }",
  "    method visitNum(o) up(as) { visitation.apply (o, as) }",
  "    method visitOp(o) up(as) { visitation.apply (o, as) }",
  "    method visitIndex(o) up(as) { visitation.apply (o, as) }",
  "    method visitBind(o) up(as) { visitation.apply (o, as) }",
  "    method visitDefDec(o) up(as) { visitation.apply (o, as) }",
  "    method visitVarDec(o) up(as) { visitation.apply (o, as) }",
  "    method visitImport(o) up(as) { visitation.apply (o, as) }",
  "    method visitReturn(o) up(as) { visitation.apply (o, as) }",
  "    method visitInherits(o) up(as) { visitation.apply (o, as) }",
  "    method visitDialect(o) up(as) { visitation.apply (o, as) }",
  "    method visitBlank(o) up(as) { visitation.apply (o, as) }",
  "    method visitComment(o) up(as) { visitation.apply (o, as) }",
  "    ",
  "    method asString { \"a pluggable AST visitor\" }",
  "}",
  "",
  "",
  "def patternMarkVisitor = object {",
  "    inherits baseVisitor",
  "    method visitCall(c) up(as) {",
  "        c.isPattern := true",
  "        true",
  "    }",
  "}",
  "",
  "method findAnnotation(node, annName) {",
  "    for (node.annotations) do {ann->",
  "        if ((ann.kind == \"identifier\").andAlso {",
  "            ann.value == annName }) then {",
  "            return object {",
  "                inherits true",
  "                def value is public = ann",
  "            }",
  "        }",
  "    }",
  "    false",
  "}",
  NULL
};
Object reader_ast_outer_200(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_361(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_479(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_value_480(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_outer_488(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_491(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_509(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_569(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_572(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_register_573(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_ast_register_573(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_ast_line_574(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_line_574(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_linePos_575(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_linePos_575(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_symbolTable_576(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_symbolTable_576(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_comments_577(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_comments_577(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_outer_941(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_942(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_outer_950(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_node_951(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_ast_node_951(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_ast_outer_1016(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_1019(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_1020(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_1021(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_1021(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_thenblock_1022(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_thenblock_1022(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_elseblock_1023(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_elseblock_1023(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_handledIdentifiers_1024(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_handledIdentifiers_1024(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_outer_1371(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_1374(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_1375(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_1376(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_params_1377(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_params_1377(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_body_1378(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_body_1378(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_selfclosure_1379(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object reader_ast_matchingPattern_1380(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_matchingPattern_1380(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_extraRuntimeData_1381(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_ast_extraRuntimeData_1381(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_ast_outer_1823(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_1826(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_1827(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_1828(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_1828(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_cases_1829(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_cases_1829(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_finally_1830(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_finally_1830(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_outer_2128(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_2131(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_2132(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_2133(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_2133(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_cases_2134(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_cases_2134(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_elsecase_2135(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_elsecase_2135(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_outer_2432(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_2435(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_2436(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_2437(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_2437(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_signature_2438(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_signature_2438(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_rtype_2439(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_rtype_2439(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_generics_2440(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_generics_2440(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_nameString_2441(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object reader_ast_outer_2865(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_2868(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_2869(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_methods_2870(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_methods_2870(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_types_2871(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_types_2871(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_nominal_2872(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_nominal_2872(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_anonymous_2873(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_anonymous_2873(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_value_2874(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_value_2874(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_outer_3169(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_3172(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_3173(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_name_3174(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_name_3174(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_value_3175(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_value_3175(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_nameString_3176(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object reader_ast_annotations_3177(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_annotations_3177(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_generics_3178(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_generics_3178(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_outer_3490(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_3498(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_3499(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_3500(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_3500(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_signature_3501(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_signature_3501(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_body_3502(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_body_3502(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_dtype_3503(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_dtype_3503(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_varargs_3504(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_varargs_3504(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_generics_3505(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_ast_generics_3505(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_ast_selfclosure_3506(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[8];
}
Object writer_ast_selfclosure_3506(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[8] = args[0];
  return done;
}
Object reader_ast_nameString_3507(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[9];
}
Object reader_ast_annotations_3508(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[10];
}
Object writer_ast_annotations_3508(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[10] = args[0];
  return done;
}
Object reader_ast_isFresh_3509(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[11];
}
Object writer_ast_isFresh_3509(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[11] = args[0];
  return done;
}
Object reader_ast_outer_4492(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_4500(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_4501(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_4502(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_4502(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_with_4503(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_with_4503(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_generics_4504(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_generics_4504(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_isPattern_4505(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_isPattern_4505(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_nameString_4506(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object reader_ast_outer_5032(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_5035(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_5036(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_5037(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_5037(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_name_5038(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_name_5038(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_constructor_5039(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_constructor_5039(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_signature_5040(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_signature_5040(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_dtype_5041(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_dtype_5041(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_generics_5042(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_ast_generics_5042(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_ast_superclass_5043(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[8];
}
Object writer_ast_superclass_5043(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[8] = args[0];
  return done;
}
Object reader_ast_annotations_5044(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[9];
}
Object writer_ast_annotations_5044(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[9] = args[0];
  return done;
}
Object reader_ast_nameString_5045(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[10];
}
Object reader_ast_data_5046(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[11];
}
Object writer_ast_data_5046(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[11] = args[0];
  return done;
}
Object reader_ast_outer_6129(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_6139(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_6140(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_outer_6185(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_6199(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_6200(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_6201(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_6201(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_superclass_6202(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_superclass_6202(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_classname_6203(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_classname_6203(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_data_6204(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_data_6204(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_outer_6487(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_6490(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_6491(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_6492(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_6492(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_outer_6616(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_6624(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_6625(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_6626(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_6626(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_in_6627(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_in_6627(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_generics_6628(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_generics_6628(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_outer_6939(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_6942(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_6943(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_6944(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_6944(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_params_6945(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_params_6945(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_outer_7158(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_7161(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_7162(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_params_7163(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_params_7163(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_outer_7284(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_7292(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_7293(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_7294(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_7294(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_wildcard_7295(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_wildcard_7295(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_dtype_7296(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_dtype_7296(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_isBindingOccurrence_7297(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_isBindingOccurrence_7297(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_isAssigned_7298(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_isAssigned_7298(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_inRequest_7299(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_ast_inRequest_7299(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_ast_generics_7300(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[8];
}
Object writer_ast_generics_7300(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[8] = args[0];
  return done;
}
Object reader_ast_isDeclaredByParent_7301(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[9];
}
Object writer_ast_isDeclaredByParent_7301(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[9] = args[0];
  return done;
}
Object reader_ast_outer_7670(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_7678(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_7679(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_7680(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_7680(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_outer_7783(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_7786(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_7787(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_7788(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_7788(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_outer_7848(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_7851(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_7852(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_7853(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_left_7854(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_left_7854(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_right_7855(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_right_7855(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_outer_8116(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_8119(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_8120(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_8121(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_8121(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_index_8122(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_index_8122(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_outer_8272(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_8275(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_8276(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_dest_8277(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_dest_8277(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_value_8278(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_value_8278(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_outer_8440(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_8448(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_8449(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_name_8450(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_name_8450(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_value_8451(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_value_8451(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_dtype_8452(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_dtype_8452(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_nameString_8453(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object reader_ast_annotations_8454(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_annotations_8454(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_data_8455(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_ast_data_8455(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_ast_startToken_8456(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[8];
}
Object writer_ast_startToken_8456(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[8] = args[0];
  return done;
}
Object reader_ast_outer_8911(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_8914(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_8915(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_name_8916(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_name_8916(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_value_8917(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_value_8917(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_dtype_8918(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_dtype_8918(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_nameString_8919(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object reader_ast_annotations_8920(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_annotations_8920(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_outer_9360(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_9363(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_9364(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_9365(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_9365(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_path_9366(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_path_9366(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_annotations_9367(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_annotations_9367(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_dtype_9368(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_dtype_9368(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_outer_9634(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_9637(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_9638(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_9639(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_9639(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_outer_9742(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_9745(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_9746(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_9747(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_9747(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_outer_9827(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_9835(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_9836(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_9837(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_9837(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_providedNames_9838(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_providedNames_9838(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_outer_9982(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_9985(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_9986(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_9987(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_outer_10015(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_10052(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_10053(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_name_10054(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_name_10054(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_params_10055(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_params_10055(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_vararg_10056(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_vararg_10056(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_generics_10057(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_generics_10057(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_lineLength_10058(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_lineLength_10058(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_outer_10334(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_10342(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_10343(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_name_10344(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_name_10344(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_args_10345(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_args_10345(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_lineLength_10346(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_lineLength_10346(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_outer_10499(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_10502(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_10503(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_10504(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_10504(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_isPartialLine_10505(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_isPartialLine_10505(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_isPreceededByBlankLine_10506(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_isPreceededByBlankLine_10506(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_endLine_10507(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_endLine_10507(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_outer_10700(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
static Object strlit52;
static Object strlit59;
static Object strlit93;
static Object strlit112;
static Object strlit141;
static Object strlit169;
static Object strlit194;
static ClassData objclass199;
static Object strlit357;
static ClassData objclass360;
static Object strlit453;
static Object strlit472;
static ClassData objclass478;
Object module_util;
Object module_util_init();
static ClassData objclass487;
static ClassData objclass490;
static Object strlit495;
static ClassData objclass508;
static Object strlit520;
static Object strlit532;
static Object strlit547;
static ClassData objclass568;
static ClassData objclass571;
static Object strlit627;
static Object strlit634;
static Object strlit640;
static Object strlit646;
static Object strlit702;
static Object strlit711;
static Object strlit722;
static Object strlit737;
static Object strlit746;
static Object strlit753;
static Object strlit762;
static Object strlit767;
static Object strlit774;
static Object strlit781;
static Object strlit787;
static Object strlit804;
static Object strlit812;
static Object strlit819;
static Object strlit826;
static Object strlit832;
static Object strlit840;
static Object strlit849;
static Object strlit856;
static Object strlit863;
static Object strlit869;
static Object strlit896;
static Object strlit901;
static Object strlit905;
static Object strlit933;
static ClassData objclass940;
static Object strlit944;
static Object strlit947;
static ClassData objclass949;
static Object strlit953;
static Object strlit957;
static Object strlit962;
static Object strlit967;
static Object strlit973;
static Object strlit986;
static Object strlit990;
static Object strlit999;
static Object strlit1005;
static Object strlit1012;
static ClassData objclass1015;
static ClassData objclass1018;
static Object strlit1071;
static Object strlit1080;
static Object strlit1087;
static Object strlit1108;
static Object strlit1114;
static Object strlit1121;
static Object strlit1133;
static Object strlit1144;
static Object strlit1156;
static Object strlit1166;
static Object strlit1191;
static Object strlit1200;
static Object strlit1205;
static Object strlit1230;
static Object strlit1239;
static Object strlit1244;
static Object strlit1251;
static Object strlit1260;
static Object strlit1279;
static Object strlit1284;
static Object strlit1299;
static Object strlit1304;
static Object strlit1326;
static Object strlit1331;
static Object strlit1341;
static Object strlit1346;
static Object strlit1366;
static ClassData objclass1370;
static ClassData objclass1373;
static Object strlit1406;
static Object strlit1521;
static Object strlit1530;
static Object strlit1537;
static Object strlit1543;
static Object strlit1566;
static Object strlit1575;
static Object strlit1580;
static Object strlit1603;
static Object strlit1619;
static Object strlit1624;
static Object strlit1644;
static Object strlit1651;
static Object strlit1664;
static Object strlit1670;
static Object strlit1681;
static Object strlit1703;
static Object strlit1711;
static Object strlit1733;
static Object strlit1738;
static Object strlit1758;
static Object strlit1763;
static Object strlit1773;
static Object strlit1778;
static Object strlit1806;
static Object strlit1807;
static ClassData objclass1822;
static ClassData objclass1825;
static Object strlit1897;
static Object strlit1906;
static Object strlit1913;
static Object strlit1919;
static Object strlit1944;
static Object strlit1955;
static Object strlit1960;
static Object strlit1964;
static Object strlit1985;
static Object strlit1998;
static Object strlit2003;
static Object strlit2007;
static Object strlit2018;
static Object strlit2031;
static Object strlit2038;
static Object strlit2047;
static Object strlit2064;
static Object strlit2067;
static Object strlit2072;
static Object strlit2100;
static Object strlit2103;
static Object strlit2108;
static Object strlit2124;
static ClassData objclass2127;
static ClassData objclass2130;
static Object strlit2205;
static Object strlit2214;
static Object strlit2221;
static Object strlit2248;
static Object strlit2259;
static Object strlit2264;
static Object strlit2268;
static Object strlit2289;
static Object strlit2302;
static Object strlit2307;
static Object strlit2311;
static Object strlit2322;
static Object strlit2335;
static Object strlit2342;
static Object strlit2351;
static Object strlit2368;
static Object strlit2371;
static Object strlit2376;
static Object strlit2404;
static Object strlit2407;
static Object strlit2412;
static Object strlit2428;
static ClassData objclass2431;
static ClassData objclass2434;
static Object strlit2465;
static Object strlit2541;
static Object strlit2550;
static Object strlit2557;
static Object strlit2563;
static Object strlit2570;
static Object strlit2575;
static Object strlit2579;
static Object strlit2595;
static Object strlit2608;
static Object strlit2613;
static Object strlit2618;
static Object strlit2622;
static Object strlit2640;
static Object strlit2645;
static Object strlit2649;
static Object strlit2668;
static Object strlit2673;
static Object strlit2677;
static Object strlit2689;
static Object strlit2700;
static Object strlit2705;
static Object strlit2709;
static Object strlit2720;
static Object strlit2751;
static Object strlit2793;
static Object strlit2813;
static Object strlit2819;
static Object strlit2843;
static Object strlit2858;
static ClassData objclass2864;
static ClassData objclass2867;
static Object strlit2886;
static Object strlit2893;
static Object strlit2899;
static Object strlit2956;
static Object strlit2965;
static Object strlit2972;
static Object strlit2978;
static Object strlit2982;
static Object strlit3005;
static Object strlit3014;
static Object strlit3019;
static Object strlit3041;
static Object strlit3050;
static Object strlit3055;
static Object strlit3068;
static Object strlit3074;
static Object strlit3076;
static Object strlit3094;
static Object strlit3099;
static Object strlit3122;
static Object strlit3127;
static Object strlit3137;
static Object strlit3162;
static Object strlit3165;
static ClassData objclass3168;
static ClassData objclass3171;
static Object strlit3185;
static Object strlit3198;
static Object strlit3288;
static Object strlit3297;
static Object strlit3304;
static Object strlit3310;
static Object strlit3336;
static Object strlit3349;
static Object strlit3354;
static Object strlit3358;
static Object strlit3367;
static Object strlit3387;
static Object strlit3411;
static Object strlit3424;
static Object strlit3430;
static Object strlit3432;
static Object strlit3438;
static Object strlit3465;
static Object strlit3478;
static ClassData objclass3489;
static ClassData objclass3497;
static Object strlit3516;
static Object strlit3529;
static Object strlit3711;
static Object strlit3720;
static Object strlit3727;
static Object strlit3743;
static Object strlit3752;
static Object strlit3764;
static Object strlit3769;
static Object strlit3779;
static Object strlit3798;
static Object strlit3806;
static Object strlit3811;
static Object strlit3815;
static Object strlit3827;
static Object strlit3834;
static Object strlit3839;
static Object strlit3843;
static Object strlit3852;
static Object strlit3857;
static Object strlit3861;
static Object strlit3873;
static Object strlit3884;
static Object strlit3889;
static Object strlit3893;
static Object strlit3911;
static Object strlit3924;
static Object strlit3929;
static Object strlit3933;
static Object strlit3944;
static Object strlit3956;
static Object strlit3961;
static Object strlit3965;
static Object strlit3975;
static Object strlit3983;
static Object strlit3988;
static Object strlit3992;
static Object strlit4005;
static Object strlit4019;
static Object strlit4024;
static Object strlit4028;
static Object strlit4040;
static Object strlit4051;
static Object strlit4056;
static Object strlit4060;
static Object strlit4071;
static Object strlit4076;
static Object strlit4099;
static Object strlit4127;
static Object strlit4140;
static Object strlit4146;
static Object strlit4172;
static Object strlit4208;
static Object strlit4246;
static Object strlit4288;
static Object strlit4308;
static Object strlit4314;
static Object strlit4329;
static Object strlit4338;
static Object strlit4354;
static Object strlit4360;
static Object strlit4370;
static Object strlit4374;
static Object strlit4377;
static Object strlit4387;
static Object strlit4424;
static Object strlit4429;
static Object strlit4439;
static Object strlit4444;
static Object strlit4476;
static ClassData objclass4491;
static ClassData objclass4499;
static Object strlit4523;
static Object strlit4533;
static Object strlit4621;
static Object strlit4630;
static Object strlit4637;
static Object strlit4644;
static Object strlit4656;
static Object strlit4666;
static Object strlit4678;
static Object strlit4691;
static Object strlit4702;
static Object strlit4714;
static Object strlit4731;
static Object strlit4736;
static Object strlit4759;
static Object strlit4770;
static Object strlit4775;
static Object strlit4781;
static Object strlit4784;
static Object strlit4795;
static Object strlit4828;
static Object strlit4837;
static Object strlit4842;
static Object strlit4851;
static Object strlit4880;
static Object strlit4916;
static Object strlit4945;
static Object strlit4978;
static Object strlit4985;
static Object strlit4993;
static Object strlit5000;
static Object strlit5021;
static ClassData objclass5031;
static ClassData objclass5034;
static Object strlit5048;
static Object strlit5076;
static Object strlit5270;
static Object strlit5279;
static Object strlit5286;
static Object strlit5292;
static Object strlit5302;
static Object strlit5307;
static Object strlit5311;
static Object strlit5321;
static Object strlit5328;
static Object strlit5337;
static Object strlit5346;
static Object strlit5350;
static Object strlit5362;
static Object strlit5373;
static Object strlit5384;
static Object strlit5388;
static Object strlit5400;
static Object strlit5413;
static Object strlit5426;
static Object strlit5430;
static Object strlit5442;
static Object strlit5457;
static Object strlit5472;
static Object strlit5476;
static Object strlit5494;
static Object strlit5499;
static Object strlit5518;
static Object strlit5525;
static Object strlit5530;
static Object strlit5540;
static Object strlit5545;
static Object strlit5549;
static Object strlit5565;
static Object strlit5578;
static Object strlit5583;
static Object strlit5588;
static Object strlit5592;
static Object strlit5603;
static Object strlit5608;
static Object strlit5612;
static Object strlit5624;
static Object strlit5631;
static Object strlit5636;
static Object strlit5640;
static Object strlit5649;
static Object strlit5654;
static Object strlit5658;
static Object strlit5670;
static Object strlit5681;
static Object strlit5686;
static Object strlit5690;
static Object strlit5708;
static Object strlit5721;
static Object strlit5726;
static Object strlit5730;
static Object strlit5758;
static Object strlit5763;
static Object strlit5780;
static Object strlit5785;
static Object strlit5798;
static Object strlit5808;
static Object strlit5817;
static Object strlit5822;
static Object strlit5844;
static Object strlit5872;
static Object strlit5885;
static Object strlit5892;
static Object strlit5901;
static Object strlit5906;
static Object strlit5914;
static Object strlit5948;
static Object strlit5990;
static Object strlit6010;
static Object strlit6016;
static Object strlit6030;
static Object strlit6043;
static Object strlit6047;
static Object strlit6054;
static Object strlit6072;
static Object strlit6077;
static Object strlit6087;
static Object strlit6092;
static Object strlit6116;
static ClassData objclass6128;
static ClassData objclass6138;
static Object strlit6142;
static Object strlit6181;
static ClassData objclass6184;
static ClassData objclass6198;
static Object strlit6248;
static Object strlit6254;
static Object strlit6260;
static Object strlit6293;
static Object strlit6302;
static Object strlit6318;
static Object strlit6323;
static Object strlit6342;
static Object strlit6349;
static Object strlit6354;
static Object strlit6381;
static Object strlit6390;
static Object strlit6403;
static Object strlit6409;
static Object strlit6424;
static Object strlit6429;
static Object strlit6439;
static Object strlit6444;
static Object strlit6469;
static Object strlit6475;
static Object strlit6480;
static Object strlit6481;
static ClassData objclass6486;
static ClassData objclass6489;
static Object strlit6526;
static Object strlit6535;
static Object strlit6559;
static Object strlit6568;
static Object strlit6595;
static Object strlit6602;
static Object strlit6613;
static ClassData objclass6615;
static ClassData objclass6623;
static Object strlit6687;
static Object strlit6696;
static Object strlit6703;
static Object strlit6710;
static Object strlit6716;
static Object strlit6740;
static Object strlit6745;
static Object strlit6762;
static Object strlit6767;
static Object strlit6777;
static Object strlit6780;
static Object strlit6807;
static Object strlit6817;
static Object strlit6834;
static Object strlit6870;
static Object strlit6889;
static Object strlit6896;
static Object strlit6902;
static Object strlit6933;
static ClassData objclass6938;
static ClassData objclass6941;
static Object strlit6953;
static Object strlit6957;
static Object strlit6964;
static Object strlit6969;
static Object strlit6973;
static Object strlit6983;
static Object strlit6992;
static Object strlit7039;
static Object strlit7048;
static Object strlit7054;
static Object strlit7088;
static Object strlit7095;
static Object strlit7101;
static Object strlit7134;
static Object strlit7141;
static Object strlit7154;
static ClassData objclass7157;
static ClassData objclass7160;
static Object strlit7165;
static Object strlit7170;
static Object strlit7175;
static Object strlit7179;
static Object strlit7189;
static Object strlit7198;
static Object strlit7202;
static Object strlit7246;
static Object strlit7255;
static Object strlit7281;
static ClassData objclass7283;
static ClassData objclass7291;
static Object strlit7371;
static Object strlit7380;
static Object strlit7392;
static Object strlit7401;
static Object strlit7407;
static Object strlit7415;
static Object strlit7421;
static Object strlit7435;
static Object strlit7440;
static Object strlit7466;
static Object strlit7471;
static Object strlit7491;
static Object strlit7505;
static Object strlit7528;
static Object strlit7541;
static Object strlit7577;
static Object strlit7599;
static Object strlit7605;
static Object strlit7609;
static Object strlit7615;
static Object strlit7651;
static Object strlit7661;
static Object strlit7666;
static ClassData objclass7669;
static ClassData objclass7677;
static Object strlit7693;
static Object strlit7700;
static Object strlit7706;
static Object strlit7712;
static Object strlit7720;
static Object strlit7724;
static Object strlit7730;
static Object strlit7734;
static Object strlit7740;
static Object strlit7744;
static Object strlit7750;
static Object strlit7754;
static Object strlit7765;
static Object strlit7778;
static ClassData objclass7782;
static ClassData objclass7785;
static Object strlit7801;
static Object strlit7808;
static Object strlit7814;
static Object strlit7826;
static Object strlit7832;
static Object strlit7844;
static ClassData objclass7847;
static ClassData objclass7850;
static Object strlit7895;
static Object strlit7904;
static Object strlit7911;
static Object strlit7918;
static Object strlit7924;
static Object strlit7930;
static Object strlit7950;
static Object strlit7970;
static Object strlit7984;
static Object strlit7993;
static Object strlit8002;
static Object strlit8014;
static Object strlit8026;
static Object strlit8033;
static Object strlit8052;
static Object strlit8061;
static Object strlit8071;
static Object strlit8112;
static ClassData objclass8115;
static ClassData objclass8118;
static Object strlit8157;
static Object strlit8166;
static Object strlit8173;
static Object strlit8194;
static Object strlit8214;
static Object strlit8227;
static Object strlit8242;
static Object strlit8255;
static Object strlit8268;
static ClassData objclass8271;
static ClassData objclass8274;
static Object strlit8283;
static Object strlit8289;
static Object strlit8326;
static Object strlit8335;
static Object strlit8342;
static Object strlit8363;
static Object strlit8383;
static Object strlit8396;
static Object strlit8421;
static Object strlit8437;
static ClassData objclass8439;
static ClassData objclass8447;
static Object strlit8470;
static Object strlit8478;
static Object strlit8586;
static Object strlit8595;
static Object strlit8602;
static Object strlit8636;
static Object strlit8641;
static Object strlit8666;
static Object strlit8671;
static Object strlit8687;
static Object strlit8691;
static Object strlit8701;
static Object strlit8712;
static Object strlit8716;
static Object strlit8746;
static Object strlit8759;
static Object strlit8766;
static Object strlit8775;
static Object strlit8783;
static Object strlit8806;
static Object strlit8821;
static Object strlit8827;
static Object strlit8837;
static Object strlit8841;
static Object strlit8844;
static Object strlit8867;
static Object strlit8896;
static ClassData objclass8910;
static ClassData objclass8913;
static Object strlit8934;
static Object strlit8942;
static Object strlit8961;
static Object strlit8970;
static Object strlit8991;
static Object strlit9000;
static Object strlit9099;
static Object strlit9108;
static Object strlit9115;
static Object strlit9143;
static Object strlit9148;
static Object strlit9174;
static Object strlit9179;
static Object strlit9217;
static Object strlit9222;
static Object strlit9229;
static Object strlit9238;
static Object strlit9246;
static Object strlit9269;
static Object strlit9284;
static Object strlit9290;
static Object strlit9300;
static Object strlit9304;
static Object strlit9307;
static Object strlit9330;
static Object strlit9348;
static ClassData objclass9359;
static ClassData objclass9362;
static Object strlit9392;
static Object strlit9400;
static Object strlit9407;
static Object strlit9415;
static Object strlit9418;
static Object strlit9432;
static Object strlit9503;
static Object strlit9512;
static Object strlit9519;
static Object strlit9526;
static Object strlit9533;
static Object strlit9537;
static Object strlit9547;
static Object strlit9554;
static Object strlit9558;
static Object strlit9577;
static Object strlit9584;
static Object strlit9588;
static Object strlit9598;
static Object strlit9605;
static Object strlit9611;
static Object strlit9626;
static ClassData objclass9633;
static ClassData objclass9636;
static Object strlit9643;
static Object strlit9651;
static Object strlit9654;
static Object strlit9676;
static Object strlit9685;
static Object strlit9692;
static Object strlit9699;
static Object strlit9706;
static Object strlit9710;
static Object strlit9720;
static Object strlit9726;
static Object strlit9738;
static ClassData objclass9741;
static ClassData objclass9744;
static Object strlit9772;
static Object strlit9781;
static Object strlit9788;
static Object strlit9815;
static Object strlit9824;
static ClassData objclass9826;
static ClassData objclass9834;
static Object strlit9875;
static Object strlit9884;
static Object strlit9891;
static Object strlit9920;
static Object strlit9927;
static Object strlit9931;
static Object strlit9941;
static Object strlit9950;
static Object strlit9973;
static ClassData objclass9981;
static ClassData objclass9984;
static Object strlit9999;
static Object strlit10001;
static Object strlit10003;
static Object strlit10011;
static Object strlit10012;
static ClassData objclass10014;
static Object strlit10044;
static ClassData objclass10051;
static Object strlit10102;
static Object strlit10131;
static Object strlit10140;
static Object strlit10147;
static Object strlit10154;
static Object strlit10160;
static Object strlit10173;
static Object strlit10178;
static Object strlit10182;
static Object strlit10194;
static Object strlit10205;
static Object strlit10210;
static Object strlit10214;
static Object strlit10232;
static Object strlit10245;
static Object strlit10250;
static Object strlit10254;
static Object strlit10278;
static Object strlit10284;
static Object strlit10289;
static Object strlit10290;
static ClassData objclass10333;
static ClassData objclass10341;
static Object strlit10365;
static Object strlit10374;
static Object strlit10381;
static Object strlit10388;
static Object strlit10394;
static Object strlit10400;
static Object strlit10405;
static Object strlit10409;
static Object strlit10421;
static Object strlit10432;
static Object strlit10437;
static Object strlit10441;
static Object strlit10467;
static Object strlit10468;
static ClassData objclass10498;
static ClassData objclass10501;
static Object strlit10512;
static Object strlit10519;
static Object strlit10526;
static Object strlit10532;
static Object strlit10546;
static Object strlit10568;
static Object strlit10577;
static Object strlit10586;
static Object strlit10587;
static Object strlit10589;
static Object strlit10596;
static Object strlit10603;
static Object strlit10610;
static Object strlit10615;
static Object strlit10619;
static Object strlit10635;
static Object strlit10641;
static Object strlit10644;
static Object strlit10649;
static Object strlit10659;
static Object strlit10689;
static ClassData objclass10699;
Object meth_ast__apply7(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_b = getfromclosure(closure, 0);
  Object *var_as = getfromclosure(closure, 1);
  Object *var_newList = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_nd = &(stackframe->slots[0]);
  *var_nd = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe8 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe9 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_b (depth = 6)
  gc_frame_newslot(*var_b);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nd (depth = 6)
  params[0] = *var_b;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10 = callmethod(*var_nd, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe9);
// compiled call node returning call10 (depth = 5)
  gc_frame_newslot(call10);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newList (depth = 5)
  params[0] = call10;
  partcv[0] = 1;
  Object call11 = callmethod(*var_newList, "addLast",
    1, partcv, params);
  gc_frame_end(callframe8);
// compiled call node returning call11 (depth = 4)
  gc_frame_end(frame);
  return call11;
}
Object meth_ast_listMap_40__41_ancestors0(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "listMap()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method listMap()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method listMap()ancestors");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for listMap()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for listMap");
  Object *var_as = &(stackframe->slots[2]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newList = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newList");
// Begin line 18
  setline(18);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call3 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2);
// compiled call node returning call3 (depth = 6)
// compiled member node returning call3 (depth = 5)
  partcv[0] = 0;
  Object call4 = callmethod(call3, "empty",
    1, partcv, params);
  gc_frame_end(callframe1);
// compiled call node returning call4 (depth = 4)
// compiled member node returning call4 (depth = 3)
  *var_newList = call4;
  if (call4 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 19
  setline(19);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block6 = alloc_Block(NULL, NULL, "ast", 19);
  gc_frame_newslot(block6);
// method _apply
  block_savedest(block6);
  Object closure7 = createclosure(4, "_apply");
  setclosureframe(closure7, stackframe);
  addtoclosure(closure7, var_b);
  addtoclosure(closure7, var_as);
  addtoclosure(closure7, var_newList);
  addtoclosure(closure7, selfslot);
  struct UserObject *uo7 = (struct UserObject*)block6;
  uo7->data[0] = (Object)closure7;
  Method *meth_meth_ast__apply7 = addmethod2pos(block6, "_apply", &meth_ast__apply7, 0);
  int argcv_meth_ast__apply7[] = {1};
  meth_meth_ast__apply7->type = alloc_MethodType(1, argcv_meth_ast__apply7);
  meth_meth_ast__apply7->definitionModule = modulename;
  meth_meth_ast__apply7->definitionLine = 18;
// compiled block node returning block6 (depth = 3)
  gc_frame_newslot(block6);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_l (depth = 3)
  params[0] = block6;
  partcv[0] = 1;
  Object call13 = callmethod(*var_l, "do",
    1, partcv, params);
  gc_frame_end(callframe5);
// compiled call node returning call13 (depth = 2)
// Begin line 20
  setline(20);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_newList (depth = 2)
  gc_frame_end(frame);
  return *var_newList;
}
Object meth_ast_maybeMap_40__41_ancestors14(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "maybeMap()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method maybeMap()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method maybeMap()ancestors");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for maybeMap()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for maybeMap");
  Object *var_as = &(stackframe->slots[2]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 23
  setline(23);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool17 = alloc_Boolean(0);
// compiled identifier node returning bool17 (depth = 4)
  int op_slot_right_16 = gc_frame_newslot(bool17);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  int op_slot_left_16 = gc_frame_newslot(*var_n);
  params[0] = bool17;
  partcv[0] = 1;
  Object opresult19 = callmethod(*var_n, "!=", 1, partcv, params);
// compiled op node returning opresult19 (depth = 3)
  Object if15 = done;
  if (istrue(opresult19)) {
// Begin line 24
  setline(24);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe20 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_b (depth = 4)
  gc_frame_newslot(*var_b);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = *var_b;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call21 = callmethod(*var_n, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe20);
// compiled call node returning call21 (depth = 3)
    gc_frame_newslot(call21);
    if15 = call21;
  } else {
// Begin line 26
  setline(26);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_n (depth = 3)
    gc_frame_newslot(*var_n);
    if15 = *var_n;
  }
// compiled if node returning if15 (depth = 2)
  gc_frame_end(frame);
  return if15;
}
Object meth_ast_maybeListMap_40__41_ancestors22(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "maybeListMap()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method maybeListMap()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method maybeListMap()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for maybeListMap()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for maybeListMap");
  Object *var_as = &(stackframe->slots[2]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 30
  setline(30);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool25 = alloc_Boolean(0);
// compiled identifier node returning bool25 (depth = 4)
  int op_slot_right_24 = gc_frame_newslot(bool25);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  int op_slot_left_24 = gc_frame_newslot(*var_n);
  params[0] = bool25;
  partcv[0] = 1;
  Object opresult27 = callmethod(*var_n, "!=", 1, partcv, params);
// compiled op node returning opresult27 (depth = 3)
  Object if23 = done;
  if (istrue(opresult27)) {
// Begin line 31
  setline(31);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe28 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_b (depth = 4)
  gc_frame_newslot(*var_b);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 4: self request
  params[0] = *var_n;
  params[1] = *var_b;
  params[2] = *var_as;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call29 = callmethodflags(self, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe28);
// compiled call node returning call29 (depth = 3)
    gc_frame_newslot(call29);
    if23 = call29;
  } else {
// Begin line 33
  setline(33);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_n (depth = 3)
    gc_frame_newslot(*var_n);
    if23 = *var_n;
  }
// compiled if node returning if23 (depth = 2)
  gc_frame_end(frame);
  return if23;
}
Object meth_ast__apply64(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ind = getfromclosure(closure, 0);
  Object *var_len = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ind (depth = 8)
  int op_slot_right_65 = gc_frame_newslot(*var_ind);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_len (depth = 8)
  int op_slot_left_65 = gc_frame_newslot(*var_len);
  params[0] = *var_ind;
  partcv[0] = 1;
  Object diff67 = callmethod(*var_len, "-", 1, partcv, params);
// compiled op node returning diff67 (depth = 7)
  gc_frame_end(frame);
  return diff67;
}
Object meth_ast__apply57(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[3];
  Object *var_ind = getfromclosure(closure, 0);
  Object *var_len = getfromclosure(closure, 1);
  Object *var_str = getfromclosure(closure, 2);
  Object *var_currBreak = getfromclosure(closure, 3);
  Object *var_trimmedLine = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 4)
// Begin line 2672
  setline(2672);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe58 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit59 == NULL) {
    strlit59 = alloc_String(" ");
    gc_root(strlit59);
  }
// compiled string node returning strlit59 (depth = 6)
  gc_frame_newslot(strlit59);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ind (depth = 7)
  int op_slot_right_60 = gc_frame_newslot(*var_ind);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_len (depth = 7)
  int op_slot_left_60 = gc_frame_newslot(*var_len);
  params[0] = *var_ind;
  partcv[0] = 1;
  Object diff62 = callmethod(*var_len, "-", 1, partcv, params);
// compiled op node returning diff62 (depth = 6)
  gc_frame_newslot(diff62);
// Begin line 2673
  setline(2673);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 6)
  Object block63 = alloc_Block(NULL, NULL, "ast", 2673);
  gc_frame_newslot(block63);
// method _apply
  block_savedest(block63);
  Object closure64 = createclosure(3, "_apply");
  setclosureframe(closure64, stackframe);
  addtoclosure(closure64, var_ind);
  addtoclosure(closure64, var_len);
  addtoclosure(closure64, selfslot);
  struct UserObject *uo64 = (struct UserObject*)block63;
  uo64->data[0] = (Object)closure64;
  Method *meth_meth_ast__apply64 = addmethod2pos(block63, "_apply", &meth_ast__apply64, 0);
  int argcv_meth_ast__apply64[] = {0};
  meth_meth_ast__apply64->type = alloc_MethodType(1, argcv_meth_ast__apply64);
  meth_meth_ast__apply64->definitionModule = modulename;
  meth_meth_ast__apply64->definitionLine = 2665;
// compiled block node returning block63 (depth = 6)
  gc_frame_newslot(block63);
// call case 6: other member request
// Begin line 2672
  setline(2672);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_str (depth = 6)
  params[0] = strlit59;
  params[1] = diff62;
  params[2] = block63;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call69 = callmethod(*var_str, "lastIndexOf()startingAt()ifAbsent",
    3, partcv, params);
  gc_frame_end(callframe58);
// compiled call node returning call69 (depth = 5)
  *var_currBreak = call69;
  if (call69 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2674
  setline(2674);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe71 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe72 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num73 = alloc_Float64(1);
// compiled num node returning num73 (depth = 8)
  gc_frame_newslot(num73);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_currBreak (depth = 8)
  gc_frame_newslot(*var_currBreak);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_str (depth = 8)
  params[0] = num73;
  params[1] = *var_currBreak;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call74 = callmethod(*var_str, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe72);
// compiled call node returning call74 (depth = 7)
  partcv[0] = 0;
  Object call75 = callmethod(call74, "trim",
    1, partcv, params);
  gc_frame_end(callframe71);
// compiled call node returning call75 (depth = 6)
// compiled member node returning call75 (depth = 5)
  *var_trimmedLine = call75;
  if (call75 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply90(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_str = getfromclosure(closure, 0);
  Object *var_currBreak = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2678
  setline(2678);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit93 == NULL) {
    strlit93 = alloc_String(" ");
    gc_root(strlit93);
  }
// compiled string node returning strlit93 (depth = 8)
  int op_slot_right_92 = gc_frame_newslot(strlit93);
// starting to compile call node (depth = 8)
  int callframe95 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ix (depth = 9)
  gc_frame_newslot(*var_ix);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_str (depth = 9)
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call96 = callmethod(*var_str, "at",
    1, partcv, params);
  gc_frame_end(callframe95);
// compiled call node returning call96 (depth = 8)
  int op_slot_left_92 = gc_frame_newslot(call96);
  params[0] = strlit93;
  partcv[0] = 1;
  Object opresult97 = callmethod(call96, "==", 1, partcv, params);
// compiled op node returning opresult97 (depth = 7)
  Object if91 = done;
  if (istrue(opresult97)) {
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ix (depth = 8)
  *var_currBreak = *var_ix;
  if (*var_ix == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if91 = done;
  } else {
  }
// compiled if node returning if91 (depth = 6)
  gc_frame_end(frame);
  return if91;
}
Object meth_ast__apply110(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_end = getfromclosure(closure, 0);
  Object *var_str = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit112 == NULL) {
    strlit112 = alloc_String(" ");
    gc_root(strlit112);
  }
// compiled string node returning strlit112 (depth = 9)
  int op_slot_right_111 = gc_frame_newslot(strlit112);
// starting to compile call node (depth = 9)
  int callframe114 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_end (depth = 10)
  gc_frame_newslot(*var_end);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_str (depth = 10)
  params[0] = *var_end;
  partcv[0] = 1;
  Object call115 = callmethod(*var_str, "at",
    1, partcv, params);
  gc_frame_end(callframe114);
// compiled call node returning call115 (depth = 9)
  int op_slot_left_111 = gc_frame_newslot(call115);
  params[0] = strlit112;
  partcv[0] = 1;
  Object opresult116 = callmethod(call115, "==", 1, partcv, params);
// compiled op node returning opresult116 (depth = 8)
  gc_frame_end(frame);
  return opresult116;
}
Object meth_ast__apply107(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_end = getfromclosure(closure, 0);
  Object *var_str = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 6)
  int callframe108 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block109 = alloc_Block(NULL, NULL, "ast", 2681);
  gc_frame_newslot(block109);
// method _apply
  block_savedest(block109);
  Object closure110 = createclosure(3, "_apply");
  setclosureframe(closure110, stackframe);
  addtoclosure(closure110, var_end);
  addtoclosure(closure110, var_str);
  addtoclosure(closure110, selfslot);
  struct UserObject *uo110 = (struct UserObject*)block109;
  uo110->data[0] = (Object)closure110;
  Method *meth_meth_ast__apply110 = addmethod2pos(block109, "_apply", &meth_ast__apply110, 0);
  int argcv_meth_ast__apply110[] = {0};
  meth_meth_ast__apply110->type = alloc_MethodType(1, argcv_meth_ast__apply110);
  meth_meth_ast__apply110->definitionModule = modulename;
  meth_meth_ast__apply110->definitionLine = 2676;
// compiled block node returning block109 (depth = 7)
  gc_frame_newslot(block109);
// call case 6: other member request
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num119 = alloc_Float64(1);
// compiled num node returning num119 (depth = 8)
  int op_slot_right_118 = gc_frame_newslot(num119);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_end (depth = 8)
  int op_slot_left_118 = gc_frame_newslot(*var_end);
  params[0] = num119;
  partcv[0] = 1;
  Object opresult121 = callmethod(*var_end, ">=", 1, partcv, params);
// compiled op node returning opresult121 (depth = 7)
  params[0] = block109;
  partcv[0] = 1;
  Object call122 = callmethod(opresult121, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe108);
// compiled call node returning call122 (depth = 6)
  gc_frame_end(frame);
  return call122;
}
Object meth_ast__apply125(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_end = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 6)
// Begin line 2682
  setline(2682);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num127 = alloc_Float64(1);
// compiled num node returning num127 (depth = 8)
  int op_slot_right_126 = gc_frame_newslot(num127);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_end (depth = 8)
  int op_slot_left_126 = gc_frame_newslot(*var_end);
  params[0] = num127;
  partcv[0] = 1;
  Object diff129 = callmethod(*var_end, "-", 1, partcv, params);
// compiled op node returning diff129 (depth = 7)
  *var_end = diff129;
  if (diff129 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply139(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_start = getfromclosure(closure, 0);
  Object *var_str = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit141 == NULL) {
    strlit141 = alloc_String(" ");
    gc_root(strlit141);
  }
// compiled string node returning strlit141 (depth = 9)
  int op_slot_right_140 = gc_frame_newslot(strlit141);
// starting to compile call node (depth = 9)
  int callframe143 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_start (depth = 10)
  gc_frame_newslot(*var_start);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_str (depth = 10)
  params[0] = *var_start;
  partcv[0] = 1;
  Object call144 = callmethod(*var_str, "at",
    1, partcv, params);
  gc_frame_end(callframe143);
// compiled call node returning call144 (depth = 9)
  int op_slot_left_140 = gc_frame_newslot(call144);
  params[0] = strlit141;
  partcv[0] = 1;
  Object opresult145 = callmethod(call144, "==", 1, partcv, params);
// compiled op node returning opresult145 (depth = 8)
  gc_frame_end(frame);
  return opresult145;
}
Object meth_ast__apply136(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_start = getfromclosure(closure, 0);
  Object *var_str = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 6)
  int callframe137 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block138 = alloc_Block(NULL, NULL, "ast", 2685);
  gc_frame_newslot(block138);
// method _apply
  block_savedest(block138);
  Object closure139 = createclosure(3, "_apply");
  setclosureframe(closure139, stackframe);
  addtoclosure(closure139, var_start);
  addtoclosure(closure139, var_str);
  addtoclosure(closure139, selfslot);
  struct UserObject *uo139 = (struct UserObject*)block138;
  uo139->data[0] = (Object)closure139;
  Method *meth_meth_ast__apply139 = addmethod2pos(block138, "_apply", &meth_ast__apply139, 0);
  int argcv_meth_ast__apply139[] = {0};
  meth_meth_ast__apply139->type = alloc_MethodType(1, argcv_meth_ast__apply139);
  meth_meth_ast__apply139->definitionModule = modulename;
  meth_meth_ast__apply139->definitionLine = 2676;
// compiled block node returning block138 (depth = 7)
  gc_frame_newslot(block138);
// call case 6: other member request
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe148 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_str (depth = 10)
  partcv[0] = 0;
  Object call149 = callmethod(*var_str, "size",
    1, partcv, params);
  gc_frame_end(callframe148);
// compiled call node returning call149 (depth = 9)
// compiled member node returning call149 (depth = 8)
  int op_slot_right_147 = gc_frame_newslot(call149);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_start (depth = 8)
  int op_slot_left_147 = gc_frame_newslot(*var_start);
  params[0] = call149;
  partcv[0] = 1;
  Object opresult151 = callmethod(*var_start, "<=", 1, partcv, params);
// compiled op node returning opresult151 (depth = 7)
  params[0] = block138;
  partcv[0] = 1;
  Object call152 = callmethod(opresult151, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe137);
// compiled call node returning call152 (depth = 6)
  gc_frame_end(frame);
  return call152;
}
Object meth_ast__apply155(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_start = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 6)
// Begin line 2686
  setline(2686);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num157 = alloc_Float64(1);
// compiled num node returning num157 (depth = 8)
  int op_slot_right_156 = gc_frame_newslot(num157);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_start (depth = 8)
  int op_slot_left_156 = gc_frame_newslot(*var_start);
  params[0] = num157;
  partcv[0] = 1;
  Object sum159 = callmethod(*var_start, "+", 1, partcv, params);
// compiled op node returning sum159 (depth = 7)
  *var_start = sum159;
  if (sum159 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply79(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_ind = getfromclosure(closure, 0);
  Object *var_len = getfromclosure(closure, 1);
  Object *var_str = getfromclosure(closure, 2);
  Object *var_currBreak = getfromclosure(closure, 3);
  Object *var_trimmedLine = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ex = &(stackframe->slots[0]);
  *var_ex = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_end = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "end");
  Object *var_start = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "start");
// Begin line 2676
  setline(2676);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe80 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ind (depth = 7)
  int op_slot_right_81 = gc_frame_newslot(*var_ind);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_len (depth = 7)
  int op_slot_left_81 = gc_frame_newslot(*var_len);
  params[0] = *var_ind;
  partcv[0] = 1;
  Object diff83 = callmethod(*var_len, "-", 1, partcv, params);
// compiled op node returning diff83 (depth = 6)
  gc_frame_newslot(diff83);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe84 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_str (depth = 8)
  partcv[0] = 0;
  Object call85 = callmethod(*var_str, "size",
    1, partcv, params);
  gc_frame_end(callframe84);
// compiled call node returning call85 (depth = 7)
// compiled member node returning call85 (depth = 6)
  gc_frame_newslot(call85);
// call case 5: prelude request
  params[0] = diff83;
  params[1] = call85;
  partcv[0] = 2;
  Object call86 = callmethodflags(prelude, "min", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe80);
// compiled call node returning call86 (depth = 5)
  *var_currBreak = call86;
  if (call86 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2677
  setline(2677);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe88 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block89 = alloc_Block(NULL, NULL, "ast", 2677);
  gc_frame_newslot(block89);
// method _apply
  block_savedest(block89);
  Object closure90 = createclosure(3, "_apply");
  setclosureframe(closure90, stackframe);
  addtoclosure(closure90, var_str);
  addtoclosure(closure90, var_currBreak);
  addtoclosure(closure90, selfslot);
  struct UserObject *uo90 = (struct UserObject*)block89;
  uo90->data[0] = (Object)closure90;
  Method *meth_meth_ast__apply90 = addmethod2pos(block89, "_apply", &meth_ast__apply90, 0);
  int argcv_meth_ast__apply90[] = {1};
  meth_meth_ast__apply90->type = alloc_MethodType(1, argcv_meth_ast__apply90);
  meth_meth_ast__apply90->definitionModule = modulename;
  meth_meth_ast__apply90->definitionLine = 2676;
// compiled block node returning block89 (depth = 5)
  gc_frame_newslot(block89);
// call case 6: other member request
// Begin line 2677
  setline(2677);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_currBreak (depth = 6)
  int op_slot_right_100 = gc_frame_newslot(*var_currBreak);
// starting to compile num node (depth = 6)
  Object num102 = alloc_Float64(1);
// compiled num node returning num102 (depth = 6)
  int op_slot_left_100 = gc_frame_newslot(num102);
  params[0] = *var_currBreak;
  partcv[0] = 1;
  Object opresult103 = callmethod(num102, "..", 1, partcv, params);
// compiled op node returning opresult103 (depth = 5)
  params[0] = block89;
  partcv[0] = 1;
  Object call104 = callmethod(opresult103, "do",
    1, partcv, params);
  gc_frame_end(callframe88);
// compiled call node returning call104 (depth = 4)
// Begin line 2680
  setline(2680);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_currBreak (depth = 5)
  *var_end = *var_currBreak;
  if (*var_currBreak == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2681
  setline(2681);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe105 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block106 = alloc_Block(NULL, NULL, "ast", 2681);
  gc_frame_newslot(block106);
// method _apply
  block_savedest(block106);
  Object closure107 = createclosure(3, "_apply");
  setclosureframe(closure107, stackframe);
  addtoclosure(closure107, var_end);
  addtoclosure(closure107, var_str);
  addtoclosure(closure107, selfslot);
  struct UserObject *uo107 = (struct UserObject*)block106;
  uo107->data[0] = (Object)closure107;
  Method *meth_meth_ast__apply107 = addmethod2pos(block106, "_apply", &meth_ast__apply107, 0);
  int argcv_meth_ast__apply107[] = {0};
  meth_meth_ast__apply107->type = alloc_MethodType(1, argcv_meth_ast__apply107);
  meth_meth_ast__apply107->definitionModule = modulename;
  meth_meth_ast__apply107->definitionLine = 2676;
// compiled block node returning block106 (depth = 5)
  gc_frame_newslot(block106);
// starting to compile block node (depth = 5)
  Object block124 = alloc_Block(NULL, NULL, "ast", 2681);
  gc_frame_newslot(block124);
// method _apply
  block_savedest(block124);
  Object closure125 = createclosure(2, "_apply");
  setclosureframe(closure125, stackframe);
  addtoclosure(closure125, var_end);
  addtoclosure(closure125, selfslot);
  struct UserObject *uo125 = (struct UserObject*)block124;
  uo125->data[0] = (Object)closure125;
  Method *meth_meth_ast__apply125 = addmethod2pos(block124, "_apply", &meth_ast__apply125, 0);
  int argcv_meth_ast__apply125[] = {0};
  meth_meth_ast__apply125->type = alloc_MethodType(1, argcv_meth_ast__apply125);
  meth_meth_ast__apply125->definitionModule = modulename;
  meth_meth_ast__apply125->definitionLine = 2676;
// compiled block node returning block124 (depth = 5)
  gc_frame_newslot(block124);
// call case 5: prelude request
  params[0] = block106;
  params[1] = block124;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call132 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe105);
// compiled call node returning call132 (depth = 4)
// Begin line 2684
  setline(2684);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile num node (depth = 5)
  Object num133 = alloc_Float64(1);
// compiled num node returning num133 (depth = 5)
  *var_start = num133;
  if (num133 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2685
  setline(2685);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe134 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block135 = alloc_Block(NULL, NULL, "ast", 2685);
  gc_frame_newslot(block135);
// method _apply
  block_savedest(block135);
  Object closure136 = createclosure(3, "_apply");
  setclosureframe(closure136, stackframe);
  addtoclosure(closure136, var_start);
  addtoclosure(closure136, var_str);
  addtoclosure(closure136, selfslot);
  struct UserObject *uo136 = (struct UserObject*)block135;
  uo136->data[0] = (Object)closure136;
  Method *meth_meth_ast__apply136 = addmethod2pos(block135, "_apply", &meth_ast__apply136, 0);
  int argcv_meth_ast__apply136[] = {0};
  meth_meth_ast__apply136->type = alloc_MethodType(1, argcv_meth_ast__apply136);
  meth_meth_ast__apply136->definitionModule = modulename;
  meth_meth_ast__apply136->definitionLine = 2676;
// compiled block node returning block135 (depth = 5)
  gc_frame_newslot(block135);
// starting to compile block node (depth = 5)
  Object block154 = alloc_Block(NULL, NULL, "ast", 2685);
  gc_frame_newslot(block154);
// method _apply
  block_savedest(block154);
  Object closure155 = createclosure(2, "_apply");
  setclosureframe(closure155, stackframe);
  addtoclosure(closure155, var_start);
  addtoclosure(closure155, selfslot);
  struct UserObject *uo155 = (struct UserObject*)block154;
  uo155->data[0] = (Object)closure155;
  Method *meth_meth_ast__apply155 = addmethod2pos(block154, "_apply", &meth_ast__apply155, 0);
  int argcv_meth_ast__apply155[] = {0};
  meth_meth_ast__apply155->type = alloc_MethodType(1, argcv_meth_ast__apply155);
  meth_meth_ast__apply155->definitionModule = modulename;
  meth_meth_ast__apply155->definitionLine = 2685;
// compiled block node returning block154 (depth = 5)
  gc_frame_newslot(block154);
// call case 5: prelude request
  params[0] = block135;
  params[1] = block154;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call162 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe134);
// compiled call node returning call162 (depth = 4)
// Begin line 2688
  setline(2688);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe163 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_start (depth = 6)
  gc_frame_newslot(*var_start);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_end (depth = 6)
  gc_frame_newslot(*var_end);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_str (depth = 6)
  params[0] = *var_start;
  params[1] = *var_end;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call164 = callmethod(*var_str, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe163);
// compiled call node returning call164 (depth = 5)
  *var_trimmedLine = call164;
  if (call164 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_wrap_40__41_to_40__41_prefix30(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(8, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "wrap()to()prefix");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method wrap()to()prefix");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method wrap()to()prefix");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method wrap()to()prefix");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for wrap()to()prefix (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_str = &(stackframe->slots[0]);
  *var_str = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for wrap");
  Object *var_l = &(stackframe->slots[1]);
  *var_l = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for to");
  Object *var_margin = &(stackframe->slots[2]);
  *var_margin = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    gracedie("wrong number of arguments for prefix");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ind = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "ind");
  Object *var_len = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "len");
  Object *var_currBreak = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "currBreak");
  Object *var_trimmedLine = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "trimmedLine");
// Begin line 2663
  setline(2663);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe31 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_margin (depth = 5)
  partcv[0] = 0;
  Object call32 = callmethod(*var_margin, "size",
    1, partcv, params);
  gc_frame_end(callframe31);
// compiled call node returning call32 (depth = 4)
// compiled member node returning call32 (depth = 3)
  *var_ind = call32;
  if (call32 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2664
  setline(2664);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe33 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num35 = alloc_Float64(4);
// compiled num node returning num35 (depth = 5)
  int op_slot_right_34 = gc_frame_newslot(num35);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ind (depth = 5)
  int op_slot_left_34 = gc_frame_newslot(*var_ind);
  params[0] = num35;
  partcv[0] = 1;
  Object sum37 = callmethod(*var_ind, "+", 1, partcv, params);
// compiled op node returning sum37 (depth = 4)
  gc_frame_newslot(sum37);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_l (depth = 4)
  gc_frame_newslot(*var_l);
// call case 5: prelude request
  params[0] = sum37;
  params[1] = *var_l;
  partcv[0] = 2;
  Object call38 = callmethodflags(prelude, "max", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe33);
// compiled call node returning call38 (depth = 3)
  *var_len = call38;
  if (call38 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2665
  setline(2665);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_len (depth = 4)
  int op_slot_right_40 = gc_frame_newslot(*var_len);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe43 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_str (depth = 7)
  partcv[0] = 0;
  Object call44 = callmethod(*var_str, "size",
    1, partcv, params);
  gc_frame_end(callframe43);
// compiled call node returning call44 (depth = 6)
// compiled member node returning call44 (depth = 5)
  int op_slot_right_42 = gc_frame_newslot(call44);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ind (depth = 5)
  int op_slot_left_42 = gc_frame_newslot(*var_ind);
  params[0] = call44;
  partcv[0] = 1;
  Object sum46 = callmethod(*var_ind, "+", 1, partcv, params);
// compiled op node returning sum46 (depth = 4)
  int op_slot_left_40 = gc_frame_newslot(sum46);
  params[0] = *var_len;
  partcv[0] = 1;
  Object opresult47 = callmethod(sum46, "<=", 1, partcv, params);
// compiled op node returning opresult47 (depth = 3)
  Object if39 = done;
  if (istrue(opresult47)) {
// Begin line 2666
  setline(2666);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_str (depth = 5)
  int op_slot_right_48 = gc_frame_newslot(*var_str);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_margin (depth = 6)
  int op_slot_right_50 = gc_frame_newslot(*var_margin);
// starting to compile string node (depth = 6)
  if (strlit52 == NULL) {
    strlit52 = alloc_String("""\x0a""");
    gc_root(strlit52);
  }
// compiled string node returning strlit52 (depth = 6)
  int op_slot_left_50 = gc_frame_newslot(strlit52);
  params[0] = *var_margin;
  partcv[0] = 1;
  Object opresult53 = callmethod(strlit52, "++", 1, partcv, params);
// compiled op node returning opresult53 (depth = 5)
  int op_slot_left_48 = gc_frame_newslot(opresult53);
  params[0] = *var_str;
  partcv[0] = 1;
  Object opresult54 = callmethod(opresult53, "++", 1, partcv, params);
// compiled op node returning opresult54 (depth = 4)
  return opresult54;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if39 = undefined;
  } else {
  }
// compiled if node returning if39 (depth = 2)
// Begin line 2668
  setline(2668);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_currBreak = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 2669
  setline(2669);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_trimmedLine = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 2671
  setline(2671);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile catchcase node (depth = 2)
// starting to compile block node (depth = 3)
  Object block56 = alloc_Block(NULL, NULL, "ast", 2671);
  gc_frame_newslot(block56);
// method _apply
  block_savedest(block56);
  Object closure57 = createclosure(6, "_apply");
  setclosureframe(closure57, stackframe);
  addtoclosure(closure57, var_ind);
  addtoclosure(closure57, var_len);
  addtoclosure(closure57, var_str);
  addtoclosure(closure57, var_currBreak);
  addtoclosure(closure57, var_trimmedLine);
  addtoclosure(closure57, selfslot);
  struct UserObject *uo57 = (struct UserObject*)block56;
  uo57->data[0] = (Object)closure57;
  Method *meth_meth_ast__apply57 = addmethod2pos(block56, "_apply", &meth_ast__apply57, 0);
  int argcv_meth_ast__apply57[] = {0};
  meth_meth_ast__apply57->type = alloc_MethodType(1, argcv_meth_ast__apply57);
  meth_meth_ast__apply57->definitionModule = modulename;
  meth_meth_ast__apply57->definitionLine = 2665;
// compiled block node returning block56 (depth = 3)
  int frame55 = gc_frame_new();
  gc_frame_newslot(block56);
// Begin line 2675
  setline(2675);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block78 = alloc_Block(NULL, NULL, "ast", 2675);
  gc_frame_newslot(block78);
// method _apply
  block_savedest(block78);
  Object closure79 = createclosure(6, "_apply");
  setclosureframe(closure79, stackframe);
  addtoclosure(closure79, var_ind);
  addtoclosure(closure79, var_len);
  addtoclosure(closure79, var_str);
  addtoclosure(closure79, var_currBreak);
  addtoclosure(closure79, var_trimmedLine);
  addtoclosure(closure79, selfslot);
  struct UserObject *uo79 = (struct UserObject*)block78;
  uo79->data[0] = (Object)closure79;
  Method *meth_meth_ast__apply79 = addmethod2pos(block78, "_apply", &meth_ast__apply79, 0);
  int argcv_meth_ast__apply79[] = {1};
  meth_meth_ast__apply79->type = alloc_MethodType(1, argcv_meth_ast__apply79);
  meth_meth_ast__apply79->definitionModule = modulename;
  meth_meth_ast__apply79->definitionLine = 2674;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe167 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe168 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit169 == NULL) {
    strlit169 = alloc_String("ex");
    gc_root(strlit169);
  }
// compiled string node returning strlit169 (depth = 6)
  gc_frame_newslot(strlit169);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe170 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call171 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe170);
// compiled call node returning call171 (depth = 7)
// compiled member node returning call171 (depth = 6)
  params[0] = strlit169;
  partcv[0] = 1;
  Object call172 = callmethod(call171, "new",
    1, partcv, params);
  gc_frame_end(callframe168);
// compiled call node returning call172 (depth = 5)
  gc_frame_newslot(call172);
// Begin line 2675
  setline(2675);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe173 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call174 = callmethodflags(prelude, "NoSuchMethod", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe173);
// compiled call node returning call174 (depth = 6)
// compiled member node returning call174 (depth = 5)
  gc_frame_newslot(call174);
// call case 6: other member request
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe175 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call176 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe175);
// compiled call node returning call176 (depth = 6)
// compiled member node returning call176 (depth = 5)
  params[0] = call172;
  params[1] = call174;
  partcv[0] = 2;
  Object call177 = callmethod(call176, "new",
    1, partcv, params);
  gc_frame_end(callframe167);
// compiled call node returning call177 (depth = 4)
((struct UserObject *)block78)->data[1] = call177;
// compiled block node returning block78 (depth = 3)
  gc_frame_newslot(block78);
  params[0] = block78;
  setline(2671);
  Object catchres55 = catchCase(block56, params, 1,NULL);
  gc_frame_end(frame55);
// compiled catchcase node returning catchres55 (depth = 2)
// Begin line 2690
  setline(2690);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// Begin line 2691
  setline(2691);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe179 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe180 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num182 = alloc_Float64(1);
// compiled num node returning num182 (depth = 6)
  int op_slot_right_181 = gc_frame_newslot(num182);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_currBreak (depth = 6)
  int op_slot_left_181 = gc_frame_newslot(*var_currBreak);
  params[0] = num182;
  partcv[0] = 1;
  Object sum184 = callmethod(*var_currBreak, "+", 1, partcv, params);
// compiled op node returning sum184 (depth = 5)
  gc_frame_newslot(sum184);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe185 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_str (depth = 7)
  partcv[0] = 0;
  Object call186 = callmethod(*var_str, "size",
    1, partcv, params);
  gc_frame_end(callframe185);
// compiled call node returning call186 (depth = 6)
// compiled member node returning call186 (depth = 5)
  gc_frame_newslot(call186);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_str (depth = 5)
  params[0] = sum184;
  params[1] = call186;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call187 = callmethod(*var_str, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe180);
// compiled call node returning call187 (depth = 4)
  gc_frame_newslot(call187);
// Begin line 2692
  setline(2692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_l (depth = 4)
  gc_frame_newslot(*var_l);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_margin (depth = 4)
  gc_frame_newslot(*var_margin);
// call case 4: self request
  params[0] = call187;
  params[1] = *var_l;
  params[2] = *var_margin;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call188 = callmethodflags(self, "wrap()to()prefix", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe179);
// compiled call node returning call188 (depth = 3)
  int op_slot_right_178 = gc_frame_newslot(call188);
// Begin line 2690
  setline(2690);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_trimmedLine (depth = 4)
  int op_slot_right_190 = gc_frame_newslot(*var_trimmedLine);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_margin (depth = 5)
  int op_slot_right_192 = gc_frame_newslot(*var_margin);
// starting to compile string node (depth = 5)
  if (strlit194 == NULL) {
    strlit194 = alloc_String("""\x0a""");
    gc_root(strlit194);
  }
// compiled string node returning strlit194 (depth = 5)
  int op_slot_left_192 = gc_frame_newslot(strlit194);
  params[0] = *var_margin;
  partcv[0] = 1;
  Object opresult195 = callmethod(strlit194, "++", 1, partcv, params);
// compiled op node returning opresult195 (depth = 4)
  int op_slot_left_190 = gc_frame_newslot(opresult195);
  params[0] = *var_trimmedLine;
  partcv[0] = 1;
  Object opresult196 = callmethod(opresult195, "++", 1, partcv, params);
// compiled op node returning opresult196 (depth = 3)
  int op_slot_left_178 = gc_frame_newslot(opresult196);
  params[0] = call188;
  partcv[0] = 1;
  Object opresult197 = callmethod(opresult196, "++", 1, partcv, params);
// compiled op node returning opresult197 (depth = 2)
  gc_frame_end(frame);
  return opresult197;
}
Object meth_ast_visitIf_40__41_up201(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitIf()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitIf()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitIf()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitIf()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitIf");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2731
  setline(2731);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe202 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call203 = callmethodflags(self, "visitIf", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe202);
// compiled call node returning call203 (depth = 2)
  gc_frame_end(frame);
  return call203;
}
Object meth_ast_visitBlock_40__41_up204(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitBlock()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitBlock()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitBlock()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitBlock()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitBlock");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2732
  setline(2732);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe205 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call206 = callmethodflags(self, "visitBlock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe205);
// compiled call node returning call206 (depth = 2)
  gc_frame_end(frame);
  return call206;
}
Object meth_ast_visitMatchCase_40__41_up207(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMatchCase()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitMatchCase()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitMatchCase()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitMatchCase()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitMatchCase");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2733
  setline(2733);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe208 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call209 = callmethodflags(self, "visitMatchCase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe208);
// compiled call node returning call209 (depth = 2)
  gc_frame_end(frame);
  return call209;
}
Object meth_ast_visitCatchCase_40__41_up210(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitCatchCase()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitCatchCase()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitCatchCase()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitCatchCase()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitCatchCase");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2734
  setline(2734);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe211 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call212 = callmethodflags(self, "visitCatchCase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe211);
// compiled call node returning call212 (depth = 2)
  gc_frame_end(frame);
  return call212;
}
Object meth_ast_visitMethodType_40__41_up213(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMethodType()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitMethodType()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitMethodType()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitMethodType()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitMethodType");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2735
  setline(2735);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe214 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call215 = callmethodflags(self, "visitMethodType", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe214);
// compiled call node returning call215 (depth = 2)
  gc_frame_end(frame);
  return call215;
}
Object meth_ast_visitSignaturePart_40__41_up216(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitSignaturePart()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitSignaturePart()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitSignaturePart()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitSignaturePart()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitSignaturePart");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2736
  setline(2736);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe217 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call218 = callmethodflags(self, "visitSignaturePart", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe217);
// compiled call node returning call218 (depth = 2)
  gc_frame_end(frame);
  return call218;
}
Object meth_ast_visitTypeDec_40__41_up219(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTypeDec()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitTypeDec()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitTypeDec()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitTypeDec()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitTypeDec");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2737
  setline(2737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe220 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call221 = callmethodflags(self, "visitTypeDec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe220);
// compiled call node returning call221 (depth = 2)
  gc_frame_end(frame);
  return call221;
}
Object meth_ast_visitTypeLiteral_40__41_up222(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTypeLiteral()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitTypeLiteral()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitTypeLiteral()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitTypeLiteral()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitTypeLiteral");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2738
  setline(2738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe223 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call224 = callmethodflags(self, "visitTypeLiteral", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe223);
// compiled call node returning call224 (depth = 2)
  gc_frame_end(frame);
  return call224;
}
Object meth_ast_visitTypeParameters_40__41_up225(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTypeParameters()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitTypeParameters()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitTypeParameters()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitTypeParameters()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitTypeParameters");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2739
  setline(2739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe226 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call227 = callmethodflags(self, "visitTypeParameters", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe226);
// compiled call node returning call227 (depth = 2)
  gc_frame_end(frame);
  return call227;
}
Object meth_ast_visitMethod_40__41_up228(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMethod()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitMethod()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitMethod()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitMethod()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitMethod");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2740
  setline(2740);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe229 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call230 = callmethodflags(self, "visitMethod", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe229);
// compiled call node returning call230 (depth = 2)
  gc_frame_end(frame);
  return call230;
}
Object meth_ast_visitCall_40__41_up231(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitCall()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitCall()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitCall()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitCall()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitCall");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2741
  setline(2741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe232 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call233 = callmethodflags(self, "visitCall", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe232);
// compiled call node returning call233 (depth = 2)
  gc_frame_end(frame);
  return call233;
}
Object meth_ast_visitClass_40__41_up234(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitClass()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitClass()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitClass()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitClass()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitClass");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2742
  setline(2742);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe235 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call236 = callmethodflags(self, "visitClass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe235);
// compiled call node returning call236 (depth = 2)
  gc_frame_end(frame);
  return call236;
}
Object meth_ast_visitObject_40__41_up237(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitObject()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitObject()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitObject()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitObject()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitObject");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2743
  setline(2743);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe238 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call239 = callmethodflags(self, "visitObject", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe238);
// compiled call node returning call239 (depth = 2)
  gc_frame_end(frame);
  return call239;
}
Object meth_ast_visitModule_40__41_up240(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitModule()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitModule()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitModule()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitModule()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitModule");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2744
  setline(2744);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe241 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call242 = callmethodflags(self, "visitObject", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe241);
// compiled call node returning call242 (depth = 2)
  gc_frame_end(frame);
  return call242;
}
Object meth_ast_visitArray_40__41_up243(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitArray()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitArray()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitArray()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitArray()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitArray");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2745
  setline(2745);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe244 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call245 = callmethodflags(self, "visitArray", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe244);
// compiled call node returning call245 (depth = 2)
  gc_frame_end(frame);
  return call245;
}
Object meth_ast_visitMember_40__41_up246(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMember()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitMember()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitMember()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitMember()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitMember");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2746
  setline(2746);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe247 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call248 = callmethodflags(self, "visitMember", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe247);
// compiled call node returning call248 (depth = 2)
  gc_frame_end(frame);
  return call248;
}
Object meth_ast_visitGeneric_40__41_up249(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitGeneric()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitGeneric()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitGeneric()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitGeneric()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitGeneric");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2747
  setline(2747);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe250 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call251 = callmethodflags(self, "visitGeneric", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe250);
// compiled call node returning call251 (depth = 2)
  gc_frame_end(frame);
  return call251;
}
Object meth_ast_visitIdentifier_40__41_up252(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitIdentifier()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitIdentifier()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitIdentifier()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitIdentifier()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitIdentifier");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2748
  setline(2748);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe253 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call254 = callmethodflags(self, "visitIdentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe253);
// compiled call node returning call254 (depth = 2)
  gc_frame_end(frame);
  return call254;
}
Object meth_ast_visitString_40__41_up255(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitString()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitString()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitString()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitString()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitString");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2749
  setline(2749);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe256 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call257 = callmethodflags(self, "visitString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe256);
// compiled call node returning call257 (depth = 2)
  gc_frame_end(frame);
  return call257;
}
Object meth_ast_visitNum_40__41_up258(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitNum()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitNum()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitNum()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitNum()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitNum");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2750
  setline(2750);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe259 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call260 = callmethodflags(self, "visitNum", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe259);
// compiled call node returning call260 (depth = 2)
  gc_frame_end(frame);
  return call260;
}
Object meth_ast_visitOp_40__41_up261(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitOp()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitOp()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitOp()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitOp()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitOp");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2751
  setline(2751);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe262 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call263 = callmethodflags(self, "visitOp", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe262);
// compiled call node returning call263 (depth = 2)
  gc_frame_end(frame);
  return call263;
}
Object meth_ast_visitIndex_40__41_up264(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitIndex()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitIndex()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitIndex()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitIndex()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitIndex");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2752
  setline(2752);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe265 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call266 = callmethodflags(self, "visitIndex", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe265);
// compiled call node returning call266 (depth = 2)
  gc_frame_end(frame);
  return call266;
}
Object meth_ast_visitBind_40__41_up267(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitBind()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitBind()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitBind()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitBind()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitBind");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2753
  setline(2753);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe268 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call269 = callmethodflags(self, "visitBind", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe268);
// compiled call node returning call269 (depth = 2)
  gc_frame_end(frame);
  return call269;
}
Object meth_ast_visitDefDec_40__41_up270(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitDefDec()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitDefDec()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitDefDec()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitDefDec()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitDefDec");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2754
  setline(2754);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe271 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call272 = callmethodflags(self, "visitDefDec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe271);
// compiled call node returning call272 (depth = 2)
  gc_frame_end(frame);
  return call272;
}
Object meth_ast_visitVarDec_40__41_up273(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitVarDec()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitVarDec()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitVarDec()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitVarDec()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitVarDec");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2755
  setline(2755);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe274 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call275 = callmethodflags(self, "visitVarDec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe274);
// compiled call node returning call275 (depth = 2)
  gc_frame_end(frame);
  return call275;
}
Object meth_ast_visitImport_40__41_up276(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitImport()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitImport()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitImport()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitImport()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitImport");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2756
  setline(2756);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe277 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call278 = callmethodflags(self, "visitImport", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe277);
// compiled call node returning call278 (depth = 2)
  gc_frame_end(frame);
  return call278;
}
Object meth_ast_visitReturn_40__41_up279(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitReturn()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitReturn()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitReturn()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitReturn()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitReturn");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2757
  setline(2757);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe280 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call281 = callmethodflags(self, "visitReturn", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe280);
// compiled call node returning call281 (depth = 2)
  gc_frame_end(frame);
  return call281;
}
Object meth_ast_visitInherits_40__41_up282(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitInherits()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitInherits()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitInherits()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitInherits()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitInherits");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2758
  setline(2758);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe283 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call284 = callmethodflags(self, "visitInherits", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe283);
// compiled call node returning call284 (depth = 2)
  gc_frame_end(frame);
  return call284;
}
Object meth_ast_visitDialect_40__41_up285(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitDialect()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitDialect()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitDialect()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitDialect()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitDialect");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2759
  setline(2759);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe286 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call287 = callmethodflags(self, "visitDialect", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe286);
// compiled call node returning call287 (depth = 2)
  gc_frame_end(frame);
  return call287;
}
Object meth_ast_visitBlank_40__41_up288(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitBlank()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitBlank()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitBlank()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitBlank()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitBlank");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2760
  setline(2760);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe289 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call290 = callmethodflags(self, "visitBlank", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe289);
// compiled call node returning call290 (depth = 2)
  gc_frame_end(frame);
  return call290;
}
Object meth_ast_visitComment_40__41_up291(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitComment()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitComment()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitComment()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitComment()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitComment");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2761
  setline(2761);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe292 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call293 = callmethodflags(self, "visitComment", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe292);
// compiled call node returning call293 (depth = 2)
  gc_frame_end(frame);
  return call293;
}
Object meth_ast_visitIf294(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitIf");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitIf");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitIf (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitIf");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2763
  setline(2763);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool295 = alloc_Boolean(1);
// compiled identifier node returning bool295 (depth = 2)
  gc_frame_end(frame);
  return bool295;
}
Object meth_ast_visitBlock296(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitBlock");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitBlock");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitBlock (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitBlock");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2764
  setline(2764);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool297 = alloc_Boolean(1);
// compiled identifier node returning bool297 (depth = 2)
  gc_frame_end(frame);
  return bool297;
}
Object meth_ast_visitMatchCase298(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMatchCase");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitMatchCase");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitMatchCase (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitMatchCase");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2765
  setline(2765);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool299 = alloc_Boolean(1);
// compiled identifier node returning bool299 (depth = 2)
  gc_frame_end(frame);
  return bool299;
}
Object meth_ast_visitCatchCase300(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitCatchCase");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitCatchCase");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitCatchCase (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitCatchCase");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2766
  setline(2766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool301 = alloc_Boolean(1);
// compiled identifier node returning bool301 (depth = 2)
  gc_frame_end(frame);
  return bool301;
}
Object meth_ast_visitMethodType302(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMethodType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitMethodType");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitMethodType (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitMethodType");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2767
  setline(2767);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool303 = alloc_Boolean(1);
// compiled identifier node returning bool303 (depth = 2)
  gc_frame_end(frame);
  return bool303;
}
Object meth_ast_visitSignaturePart304(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitSignaturePart");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitSignaturePart");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitSignaturePart (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitSignaturePart");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2768
  setline(2768);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool305 = alloc_Boolean(1);
// compiled identifier node returning bool305 (depth = 2)
  gc_frame_end(frame);
  return bool305;
}
Object meth_ast_visitTypeDec306(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTypeDec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitTypeDec");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitTypeDec (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitTypeDec");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2769
  setline(2769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool307 = alloc_Boolean(1);
// compiled identifier node returning bool307 (depth = 2)
  gc_frame_end(frame);
  return bool307;
}
Object meth_ast_visitTypeLiteral308(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTypeLiteral");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitTypeLiteral");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitTypeLiteral (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitTypeLiteral");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2770
  setline(2770);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool309 = alloc_Boolean(1);
// compiled identifier node returning bool309 (depth = 2)
  gc_frame_end(frame);
  return bool309;
}
Object meth_ast_visitTypeParameters310(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTypeParameters");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitTypeParameters");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitTypeParameters (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitTypeParameters");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2771
  setline(2771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool311 = alloc_Boolean(1);
// compiled identifier node returning bool311 (depth = 2)
  gc_frame_end(frame);
  return bool311;
}
Object meth_ast_visitMethod312(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMethod");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitMethod");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitMethod (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitMethod");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2772
  setline(2772);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool313 = alloc_Boolean(1);
// compiled identifier node returning bool313 (depth = 2)
  gc_frame_end(frame);
  return bool313;
}
Object meth_ast_visitCall314(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitCall");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitCall");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitCall (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitCall");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2773
  setline(2773);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool315 = alloc_Boolean(1);
// compiled identifier node returning bool315 (depth = 2)
  gc_frame_end(frame);
  return bool315;
}
Object meth_ast_visitClass316(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitClass");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitClass");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitClass (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitClass");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2774
  setline(2774);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool317 = alloc_Boolean(1);
// compiled identifier node returning bool317 (depth = 2)
  gc_frame_end(frame);
  return bool317;
}
Object meth_ast_visitObject318(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitObject");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitObject (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitObject");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2775
  setline(2775);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool319 = alloc_Boolean(1);
// compiled identifier node returning bool319 (depth = 2)
  gc_frame_end(frame);
  return bool319;
}
Object meth_ast_visitModule320(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitModule");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitModule");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitModule (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitModule");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2776
  setline(2776);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool321 = alloc_Boolean(1);
// compiled identifier node returning bool321 (depth = 2)
  gc_frame_end(frame);
  return bool321;
}
Object meth_ast_visitArray322(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitArray");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitArray");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitArray (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitArray");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2777
  setline(2777);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool323 = alloc_Boolean(1);
// compiled identifier node returning bool323 (depth = 2)
  gc_frame_end(frame);
  return bool323;
}
Object meth_ast_visitMember324(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMember");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitMember");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitMember (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitMember");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2778
  setline(2778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool325 = alloc_Boolean(1);
// compiled identifier node returning bool325 (depth = 2)
  gc_frame_end(frame);
  return bool325;
}
Object meth_ast_visitGeneric326(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitGeneric");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitGeneric");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitGeneric (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitGeneric");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2779
  setline(2779);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool327 = alloc_Boolean(1);
// compiled identifier node returning bool327 (depth = 2)
  gc_frame_end(frame);
  return bool327;
}
Object meth_ast_visitIdentifier328(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitIdentifier");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitIdentifier (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitIdentifier");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2780
  setline(2780);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool329 = alloc_Boolean(1);
// compiled identifier node returning bool329 (depth = 2)
  gc_frame_end(frame);
  return bool329;
}
Object meth_ast_visitString330(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitString");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitString (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitString");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2781
  setline(2781);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool331 = alloc_Boolean(1);
// compiled identifier node returning bool331 (depth = 2)
  gc_frame_end(frame);
  return bool331;
}
Object meth_ast_visitNum332(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitNum");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitNum");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitNum (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitNum");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2782
  setline(2782);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool333 = alloc_Boolean(1);
// compiled identifier node returning bool333 (depth = 2)
  gc_frame_end(frame);
  return bool333;
}
Object meth_ast_visitOp334(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitOp");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitOp");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitOp (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitOp");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2783
  setline(2783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool335 = alloc_Boolean(1);
// compiled identifier node returning bool335 (depth = 2)
  gc_frame_end(frame);
  return bool335;
}
Object meth_ast_visitIndex336(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitIndex");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitIndex");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitIndex (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitIndex");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2784
  setline(2784);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool337 = alloc_Boolean(1);
// compiled identifier node returning bool337 (depth = 2)
  gc_frame_end(frame);
  return bool337;
}
Object meth_ast_visitBind338(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitBind");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitBind");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitBind (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitBind");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2785
  setline(2785);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool339 = alloc_Boolean(1);
// compiled identifier node returning bool339 (depth = 2)
  gc_frame_end(frame);
  return bool339;
}
Object meth_ast_visitDefDec340(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitDefDec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitDefDec");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitDefDec (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitDefDec");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2786
  setline(2786);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool341 = alloc_Boolean(1);
// compiled identifier node returning bool341 (depth = 2)
  gc_frame_end(frame);
  return bool341;
}
Object meth_ast_visitVarDec342(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitVarDec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitVarDec");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitVarDec (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitVarDec");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2787
  setline(2787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool343 = alloc_Boolean(1);
// compiled identifier node returning bool343 (depth = 2)
  gc_frame_end(frame);
  return bool343;
}
Object meth_ast_visitImport344(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitImport");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitImport");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitImport (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitImport");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2788
  setline(2788);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool345 = alloc_Boolean(1);
// compiled identifier node returning bool345 (depth = 2)
  gc_frame_end(frame);
  return bool345;
}
Object meth_ast_visitReturn346(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitReturn");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitReturn");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitReturn (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitReturn");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2789
  setline(2789);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool347 = alloc_Boolean(1);
// compiled identifier node returning bool347 (depth = 2)
  gc_frame_end(frame);
  return bool347;
}
Object meth_ast_visitInherits348(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitInherits");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitInherits");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitInherits (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitInherits");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2790
  setline(2790);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool349 = alloc_Boolean(1);
// compiled identifier node returning bool349 (depth = 2)
  gc_frame_end(frame);
  return bool349;
}
Object meth_ast_visitDialect350(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitDialect");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitDialect");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitDialect (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitDialect");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2791
  setline(2791);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool351 = alloc_Boolean(1);
// compiled identifier node returning bool351 (depth = 2)
  gc_frame_end(frame);
  return bool351;
}
Object meth_ast_visitBlank352(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitBlank");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitBlank");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitBlank (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitBlank");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2792
  setline(2792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool353 = alloc_Boolean(1);
// compiled identifier node returning bool353 (depth = 2)
  gc_frame_end(frame);
  return bool353;
}
Object meth_ast_visitComment354(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitComment");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitComment");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitComment (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitComment");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2793
  setline(2793);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool355 = alloc_Boolean(1);
// compiled identifier node returning bool355 (depth = 2)
  gc_frame_end(frame);
  return bool355;
}
Object meth_ast_asString356(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2795
  setline(2795);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit357 == NULL) {
    strlit357 = alloc_String("an AST visitor");
    gc_root(strlit357);
  }
// compiled string node returning strlit357 (depth = 2)
  gc_frame_end(frame);
  return strlit357;
}
Object meth_ast_baseVisitor198(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "baseVisitor");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for baseVisitor (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for baseVisitor");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject199 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj199 = alloc_userobj2(63,64, objclass199);
  gc_frame_newslot(obj199);
if (objclass199 == NULL) {
  glfree(obj199->class->name);
  obj199->class->name = "self.baseVisitor";
}
// OBJECT OUTER DEC outer
  adddatum2(obj199, self, 0);
  addmethodreal(obj199,"outer", &reader_ast_outer_200);
  Object oldself199 = self;
  struct StackFrameObject *oldstackframe199 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe199);
  gc_frame_newslot((Object)stackframe);
  self = obj199;
  Object *oldselfslot199 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter199 = (*(struct UserObject *)self).data[0], lowerouter199 = thisouter199;
  if (inheritingObject199) {
    struct UserObject *inho199 = (struct UserObject *)inheritingObject199;
    while (inho199->super != GraceDefaultObject) inho199 = (struct UserObject *)inho199->super;
    inho199->super = obj199;
    self = inheritingObject199;
    *selfslot = self;
    lowerouter199 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter199;
  }
// method visitIf()up
  struct UserObject *uo201 = (struct UserObject*)obj199;
  uo201->data[1] = emptyclosure;
  Method *meth_meth_ast_visitIf_40__41_up201 = addmethod2pos(obj199, "visitIf()up", &meth_ast_visitIf_40__41_up201, 1);
  int argcv_meth_ast_visitIf_40__41_up201[] = {1, 1};
  meth_meth_ast_visitIf_40__41_up201->type = alloc_MethodType(2, argcv_meth_ast_visitIf_40__41_up201);
  meth_meth_ast_visitIf_40__41_up201->definitionModule = modulename;
  meth_meth_ast_visitIf_40__41_up201->definitionLine = 2731;
// method visitBlock()up
  struct UserObject *uo204 = (struct UserObject*)obj199;
  uo204->data[2] = emptyclosure;
  Method *meth_meth_ast_visitBlock_40__41_up204 = addmethod2pos(obj199, "visitBlock()up", &meth_ast_visitBlock_40__41_up204, 2);
  int argcv_meth_ast_visitBlock_40__41_up204[] = {1, 1};
  meth_meth_ast_visitBlock_40__41_up204->type = alloc_MethodType(2, argcv_meth_ast_visitBlock_40__41_up204);
  meth_meth_ast_visitBlock_40__41_up204->definitionModule = modulename;
  meth_meth_ast_visitBlock_40__41_up204->definitionLine = 2732;
// method visitMatchCase()up
  struct UserObject *uo207 = (struct UserObject*)obj199;
  uo207->data[3] = emptyclosure;
  Method *meth_meth_ast_visitMatchCase_40__41_up207 = addmethod2pos(obj199, "visitMatchCase()up", &meth_ast_visitMatchCase_40__41_up207, 3);
  int argcv_meth_ast_visitMatchCase_40__41_up207[] = {1, 1};
  meth_meth_ast_visitMatchCase_40__41_up207->type = alloc_MethodType(2, argcv_meth_ast_visitMatchCase_40__41_up207);
  meth_meth_ast_visitMatchCase_40__41_up207->definitionModule = modulename;
  meth_meth_ast_visitMatchCase_40__41_up207->definitionLine = 2733;
// method visitCatchCase()up
  struct UserObject *uo210 = (struct UserObject*)obj199;
  uo210->data[4] = emptyclosure;
  Method *meth_meth_ast_visitCatchCase_40__41_up210 = addmethod2pos(obj199, "visitCatchCase()up", &meth_ast_visitCatchCase_40__41_up210, 4);
  int argcv_meth_ast_visitCatchCase_40__41_up210[] = {1, 1};
  meth_meth_ast_visitCatchCase_40__41_up210->type = alloc_MethodType(2, argcv_meth_ast_visitCatchCase_40__41_up210);
  meth_meth_ast_visitCatchCase_40__41_up210->definitionModule = modulename;
  meth_meth_ast_visitCatchCase_40__41_up210->definitionLine = 2734;
// method visitMethodType()up
  struct UserObject *uo213 = (struct UserObject*)obj199;
  uo213->data[5] = emptyclosure;
  Method *meth_meth_ast_visitMethodType_40__41_up213 = addmethod2pos(obj199, "visitMethodType()up", &meth_ast_visitMethodType_40__41_up213, 5);
  int argcv_meth_ast_visitMethodType_40__41_up213[] = {1, 1};
  meth_meth_ast_visitMethodType_40__41_up213->type = alloc_MethodType(2, argcv_meth_ast_visitMethodType_40__41_up213);
  meth_meth_ast_visitMethodType_40__41_up213->definitionModule = modulename;
  meth_meth_ast_visitMethodType_40__41_up213->definitionLine = 2735;
// method visitSignaturePart()up
  struct UserObject *uo216 = (struct UserObject*)obj199;
  uo216->data[6] = emptyclosure;
  Method *meth_meth_ast_visitSignaturePart_40__41_up216 = addmethod2pos(obj199, "visitSignaturePart()up", &meth_ast_visitSignaturePart_40__41_up216, 6);
  int argcv_meth_ast_visitSignaturePart_40__41_up216[] = {1, 1};
  meth_meth_ast_visitSignaturePart_40__41_up216->type = alloc_MethodType(2, argcv_meth_ast_visitSignaturePart_40__41_up216);
  meth_meth_ast_visitSignaturePart_40__41_up216->definitionModule = modulename;
  meth_meth_ast_visitSignaturePart_40__41_up216->definitionLine = 2736;
// method visitTypeDec()up
  struct UserObject *uo219 = (struct UserObject*)obj199;
  uo219->data[7] = emptyclosure;
  Method *meth_meth_ast_visitTypeDec_40__41_up219 = addmethod2pos(obj199, "visitTypeDec()up", &meth_ast_visitTypeDec_40__41_up219, 7);
  int argcv_meth_ast_visitTypeDec_40__41_up219[] = {1, 1};
  meth_meth_ast_visitTypeDec_40__41_up219->type = alloc_MethodType(2, argcv_meth_ast_visitTypeDec_40__41_up219);
  meth_meth_ast_visitTypeDec_40__41_up219->definitionModule = modulename;
  meth_meth_ast_visitTypeDec_40__41_up219->definitionLine = 2737;
// method visitTypeLiteral()up
  struct UserObject *uo222 = (struct UserObject*)obj199;
  uo222->data[8] = emptyclosure;
  Method *meth_meth_ast_visitTypeLiteral_40__41_up222 = addmethod2pos(obj199, "visitTypeLiteral()up", &meth_ast_visitTypeLiteral_40__41_up222, 8);
  int argcv_meth_ast_visitTypeLiteral_40__41_up222[] = {1, 1};
  meth_meth_ast_visitTypeLiteral_40__41_up222->type = alloc_MethodType(2, argcv_meth_ast_visitTypeLiteral_40__41_up222);
  meth_meth_ast_visitTypeLiteral_40__41_up222->definitionModule = modulename;
  meth_meth_ast_visitTypeLiteral_40__41_up222->definitionLine = 2738;
// method visitTypeParameters()up
  struct UserObject *uo225 = (struct UserObject*)obj199;
  uo225->data[9] = emptyclosure;
  Method *meth_meth_ast_visitTypeParameters_40__41_up225 = addmethod2pos(obj199, "visitTypeParameters()up", &meth_ast_visitTypeParameters_40__41_up225, 9);
  int argcv_meth_ast_visitTypeParameters_40__41_up225[] = {1, 1};
  meth_meth_ast_visitTypeParameters_40__41_up225->type = alloc_MethodType(2, argcv_meth_ast_visitTypeParameters_40__41_up225);
  meth_meth_ast_visitTypeParameters_40__41_up225->definitionModule = modulename;
  meth_meth_ast_visitTypeParameters_40__41_up225->definitionLine = 2739;
// method visitMethod()up
  struct UserObject *uo228 = (struct UserObject*)obj199;
  uo228->data[10] = emptyclosure;
  Method *meth_meth_ast_visitMethod_40__41_up228 = addmethod2pos(obj199, "visitMethod()up", &meth_ast_visitMethod_40__41_up228, 10);
  int argcv_meth_ast_visitMethod_40__41_up228[] = {1, 1};
  meth_meth_ast_visitMethod_40__41_up228->type = alloc_MethodType(2, argcv_meth_ast_visitMethod_40__41_up228);
  meth_meth_ast_visitMethod_40__41_up228->definitionModule = modulename;
  meth_meth_ast_visitMethod_40__41_up228->definitionLine = 2740;
// method visitCall()up
  struct UserObject *uo231 = (struct UserObject*)obj199;
  uo231->data[11] = emptyclosure;
  Method *meth_meth_ast_visitCall_40__41_up231 = addmethod2pos(obj199, "visitCall()up", &meth_ast_visitCall_40__41_up231, 11);
  int argcv_meth_ast_visitCall_40__41_up231[] = {1, 1};
  meth_meth_ast_visitCall_40__41_up231->type = alloc_MethodType(2, argcv_meth_ast_visitCall_40__41_up231);
  meth_meth_ast_visitCall_40__41_up231->definitionModule = modulename;
  meth_meth_ast_visitCall_40__41_up231->definitionLine = 2741;
// method visitClass()up
  struct UserObject *uo234 = (struct UserObject*)obj199;
  uo234->data[12] = emptyclosure;
  Method *meth_meth_ast_visitClass_40__41_up234 = addmethod2pos(obj199, "visitClass()up", &meth_ast_visitClass_40__41_up234, 12);
  int argcv_meth_ast_visitClass_40__41_up234[] = {1, 1};
  meth_meth_ast_visitClass_40__41_up234->type = alloc_MethodType(2, argcv_meth_ast_visitClass_40__41_up234);
  meth_meth_ast_visitClass_40__41_up234->definitionModule = modulename;
  meth_meth_ast_visitClass_40__41_up234->definitionLine = 2742;
// method visitObject()up
  struct UserObject *uo237 = (struct UserObject*)obj199;
  uo237->data[13] = emptyclosure;
  Method *meth_meth_ast_visitObject_40__41_up237 = addmethod2pos(obj199, "visitObject()up", &meth_ast_visitObject_40__41_up237, 13);
  int argcv_meth_ast_visitObject_40__41_up237[] = {1, 1};
  meth_meth_ast_visitObject_40__41_up237->type = alloc_MethodType(2, argcv_meth_ast_visitObject_40__41_up237);
  meth_meth_ast_visitObject_40__41_up237->definitionModule = modulename;
  meth_meth_ast_visitObject_40__41_up237->definitionLine = 2743;
// method visitModule()up
  struct UserObject *uo240 = (struct UserObject*)obj199;
  uo240->data[14] = emptyclosure;
  Method *meth_meth_ast_visitModule_40__41_up240 = addmethod2pos(obj199, "visitModule()up", &meth_ast_visitModule_40__41_up240, 14);
  int argcv_meth_ast_visitModule_40__41_up240[] = {1, 1};
  meth_meth_ast_visitModule_40__41_up240->type = alloc_MethodType(2, argcv_meth_ast_visitModule_40__41_up240);
  meth_meth_ast_visitModule_40__41_up240->definitionModule = modulename;
  meth_meth_ast_visitModule_40__41_up240->definitionLine = 2744;
// method visitArray()up
  struct UserObject *uo243 = (struct UserObject*)obj199;
  uo243->data[15] = emptyclosure;
  Method *meth_meth_ast_visitArray_40__41_up243 = addmethod2pos(obj199, "visitArray()up", &meth_ast_visitArray_40__41_up243, 15);
  int argcv_meth_ast_visitArray_40__41_up243[] = {1, 1};
  meth_meth_ast_visitArray_40__41_up243->type = alloc_MethodType(2, argcv_meth_ast_visitArray_40__41_up243);
  meth_meth_ast_visitArray_40__41_up243->definitionModule = modulename;
  meth_meth_ast_visitArray_40__41_up243->definitionLine = 2745;
// method visitMember()up
  struct UserObject *uo246 = (struct UserObject*)obj199;
  uo246->data[16] = emptyclosure;
  Method *meth_meth_ast_visitMember_40__41_up246 = addmethod2pos(obj199, "visitMember()up", &meth_ast_visitMember_40__41_up246, 16);
  int argcv_meth_ast_visitMember_40__41_up246[] = {1, 1};
  meth_meth_ast_visitMember_40__41_up246->type = alloc_MethodType(2, argcv_meth_ast_visitMember_40__41_up246);
  meth_meth_ast_visitMember_40__41_up246->definitionModule = modulename;
  meth_meth_ast_visitMember_40__41_up246->definitionLine = 2746;
// method visitGeneric()up
  struct UserObject *uo249 = (struct UserObject*)obj199;
  uo249->data[17] = emptyclosure;
  Method *meth_meth_ast_visitGeneric_40__41_up249 = addmethod2pos(obj199, "visitGeneric()up", &meth_ast_visitGeneric_40__41_up249, 17);
  int argcv_meth_ast_visitGeneric_40__41_up249[] = {1, 1};
  meth_meth_ast_visitGeneric_40__41_up249->type = alloc_MethodType(2, argcv_meth_ast_visitGeneric_40__41_up249);
  meth_meth_ast_visitGeneric_40__41_up249->definitionModule = modulename;
  meth_meth_ast_visitGeneric_40__41_up249->definitionLine = 2747;
// method visitIdentifier()up
  struct UserObject *uo252 = (struct UserObject*)obj199;
  uo252->data[18] = emptyclosure;
  Method *meth_meth_ast_visitIdentifier_40__41_up252 = addmethod2pos(obj199, "visitIdentifier()up", &meth_ast_visitIdentifier_40__41_up252, 18);
  int argcv_meth_ast_visitIdentifier_40__41_up252[] = {1, 1};
  meth_meth_ast_visitIdentifier_40__41_up252->type = alloc_MethodType(2, argcv_meth_ast_visitIdentifier_40__41_up252);
  meth_meth_ast_visitIdentifier_40__41_up252->definitionModule = modulename;
  meth_meth_ast_visitIdentifier_40__41_up252->definitionLine = 2748;
// method visitString()up
  struct UserObject *uo255 = (struct UserObject*)obj199;
  uo255->data[19] = emptyclosure;
  Method *meth_meth_ast_visitString_40__41_up255 = addmethod2pos(obj199, "visitString()up", &meth_ast_visitString_40__41_up255, 19);
  int argcv_meth_ast_visitString_40__41_up255[] = {1, 1};
  meth_meth_ast_visitString_40__41_up255->type = alloc_MethodType(2, argcv_meth_ast_visitString_40__41_up255);
  meth_meth_ast_visitString_40__41_up255->definitionModule = modulename;
  meth_meth_ast_visitString_40__41_up255->definitionLine = 2749;
// method visitNum()up
  struct UserObject *uo258 = (struct UserObject*)obj199;
  uo258->data[20] = emptyclosure;
  Method *meth_meth_ast_visitNum_40__41_up258 = addmethod2pos(obj199, "visitNum()up", &meth_ast_visitNum_40__41_up258, 20);
  int argcv_meth_ast_visitNum_40__41_up258[] = {1, 1};
  meth_meth_ast_visitNum_40__41_up258->type = alloc_MethodType(2, argcv_meth_ast_visitNum_40__41_up258);
  meth_meth_ast_visitNum_40__41_up258->definitionModule = modulename;
  meth_meth_ast_visitNum_40__41_up258->definitionLine = 2750;
// method visitOp()up
  struct UserObject *uo261 = (struct UserObject*)obj199;
  uo261->data[21] = emptyclosure;
  Method *meth_meth_ast_visitOp_40__41_up261 = addmethod2pos(obj199, "visitOp()up", &meth_ast_visitOp_40__41_up261, 21);
  int argcv_meth_ast_visitOp_40__41_up261[] = {1, 1};
  meth_meth_ast_visitOp_40__41_up261->type = alloc_MethodType(2, argcv_meth_ast_visitOp_40__41_up261);
  meth_meth_ast_visitOp_40__41_up261->definitionModule = modulename;
  meth_meth_ast_visitOp_40__41_up261->definitionLine = 2751;
// method visitIndex()up
  struct UserObject *uo264 = (struct UserObject*)obj199;
  uo264->data[22] = emptyclosure;
  Method *meth_meth_ast_visitIndex_40__41_up264 = addmethod2pos(obj199, "visitIndex()up", &meth_ast_visitIndex_40__41_up264, 22);
  int argcv_meth_ast_visitIndex_40__41_up264[] = {1, 1};
  meth_meth_ast_visitIndex_40__41_up264->type = alloc_MethodType(2, argcv_meth_ast_visitIndex_40__41_up264);
  meth_meth_ast_visitIndex_40__41_up264->definitionModule = modulename;
  meth_meth_ast_visitIndex_40__41_up264->definitionLine = 2752;
// method visitBind()up
  struct UserObject *uo267 = (struct UserObject*)obj199;
  uo267->data[23] = emptyclosure;
  Method *meth_meth_ast_visitBind_40__41_up267 = addmethod2pos(obj199, "visitBind()up", &meth_ast_visitBind_40__41_up267, 23);
  int argcv_meth_ast_visitBind_40__41_up267[] = {1, 1};
  meth_meth_ast_visitBind_40__41_up267->type = alloc_MethodType(2, argcv_meth_ast_visitBind_40__41_up267);
  meth_meth_ast_visitBind_40__41_up267->definitionModule = modulename;
  meth_meth_ast_visitBind_40__41_up267->definitionLine = 2753;
// method visitDefDec()up
  struct UserObject *uo270 = (struct UserObject*)obj199;
  uo270->data[24] = emptyclosure;
  Method *meth_meth_ast_visitDefDec_40__41_up270 = addmethod2pos(obj199, "visitDefDec()up", &meth_ast_visitDefDec_40__41_up270, 24);
  int argcv_meth_ast_visitDefDec_40__41_up270[] = {1, 1};
  meth_meth_ast_visitDefDec_40__41_up270->type = alloc_MethodType(2, argcv_meth_ast_visitDefDec_40__41_up270);
  meth_meth_ast_visitDefDec_40__41_up270->definitionModule = modulename;
  meth_meth_ast_visitDefDec_40__41_up270->definitionLine = 2754;
// method visitVarDec()up
  struct UserObject *uo273 = (struct UserObject*)obj199;
  uo273->data[25] = emptyclosure;
  Method *meth_meth_ast_visitVarDec_40__41_up273 = addmethod2pos(obj199, "visitVarDec()up", &meth_ast_visitVarDec_40__41_up273, 25);
  int argcv_meth_ast_visitVarDec_40__41_up273[] = {1, 1};
  meth_meth_ast_visitVarDec_40__41_up273->type = alloc_MethodType(2, argcv_meth_ast_visitVarDec_40__41_up273);
  meth_meth_ast_visitVarDec_40__41_up273->definitionModule = modulename;
  meth_meth_ast_visitVarDec_40__41_up273->definitionLine = 2755;
// method visitImport()up
  struct UserObject *uo276 = (struct UserObject*)obj199;
  uo276->data[26] = emptyclosure;
  Method *meth_meth_ast_visitImport_40__41_up276 = addmethod2pos(obj199, "visitImport()up", &meth_ast_visitImport_40__41_up276, 26);
  int argcv_meth_ast_visitImport_40__41_up276[] = {1, 1};
  meth_meth_ast_visitImport_40__41_up276->type = alloc_MethodType(2, argcv_meth_ast_visitImport_40__41_up276);
  meth_meth_ast_visitImport_40__41_up276->definitionModule = modulename;
  meth_meth_ast_visitImport_40__41_up276->definitionLine = 2756;
// method visitReturn()up
  struct UserObject *uo279 = (struct UserObject*)obj199;
  uo279->data[27] = emptyclosure;
  Method *meth_meth_ast_visitReturn_40__41_up279 = addmethod2pos(obj199, "visitReturn()up", &meth_ast_visitReturn_40__41_up279, 27);
  int argcv_meth_ast_visitReturn_40__41_up279[] = {1, 1};
  meth_meth_ast_visitReturn_40__41_up279->type = alloc_MethodType(2, argcv_meth_ast_visitReturn_40__41_up279);
  meth_meth_ast_visitReturn_40__41_up279->definitionModule = modulename;
  meth_meth_ast_visitReturn_40__41_up279->definitionLine = 2757;
// method visitInherits()up
  struct UserObject *uo282 = (struct UserObject*)obj199;
  uo282->data[28] = emptyclosure;
  Method *meth_meth_ast_visitInherits_40__41_up282 = addmethod2pos(obj199, "visitInherits()up", &meth_ast_visitInherits_40__41_up282, 28);
  int argcv_meth_ast_visitInherits_40__41_up282[] = {1, 1};
  meth_meth_ast_visitInherits_40__41_up282->type = alloc_MethodType(2, argcv_meth_ast_visitInherits_40__41_up282);
  meth_meth_ast_visitInherits_40__41_up282->definitionModule = modulename;
  meth_meth_ast_visitInherits_40__41_up282->definitionLine = 2758;
// method visitDialect()up
  struct UserObject *uo285 = (struct UserObject*)obj199;
  uo285->data[29] = emptyclosure;
  Method *meth_meth_ast_visitDialect_40__41_up285 = addmethod2pos(obj199, "visitDialect()up", &meth_ast_visitDialect_40__41_up285, 29);
  int argcv_meth_ast_visitDialect_40__41_up285[] = {1, 1};
  meth_meth_ast_visitDialect_40__41_up285->type = alloc_MethodType(2, argcv_meth_ast_visitDialect_40__41_up285);
  meth_meth_ast_visitDialect_40__41_up285->definitionModule = modulename;
  meth_meth_ast_visitDialect_40__41_up285->definitionLine = 2759;
// method visitBlank()up
  struct UserObject *uo288 = (struct UserObject*)obj199;
  uo288->data[30] = emptyclosure;
  Method *meth_meth_ast_visitBlank_40__41_up288 = addmethod2pos(obj199, "visitBlank()up", &meth_ast_visitBlank_40__41_up288, 30);
  int argcv_meth_ast_visitBlank_40__41_up288[] = {1, 1};
  meth_meth_ast_visitBlank_40__41_up288->type = alloc_MethodType(2, argcv_meth_ast_visitBlank_40__41_up288);
  meth_meth_ast_visitBlank_40__41_up288->definitionModule = modulename;
  meth_meth_ast_visitBlank_40__41_up288->definitionLine = 2760;
// method visitComment()up
  struct UserObject *uo291 = (struct UserObject*)obj199;
  uo291->data[31] = emptyclosure;
  Method *meth_meth_ast_visitComment_40__41_up291 = addmethod2pos(obj199, "visitComment()up", &meth_ast_visitComment_40__41_up291, 31);
  int argcv_meth_ast_visitComment_40__41_up291[] = {1, 1};
  meth_meth_ast_visitComment_40__41_up291->type = alloc_MethodType(2, argcv_meth_ast_visitComment_40__41_up291);
  meth_meth_ast_visitComment_40__41_up291->definitionModule = modulename;
  meth_meth_ast_visitComment_40__41_up291->definitionLine = 2761;
// method visitIf
  struct UserObject *uo294 = (struct UserObject*)obj199;
  uo294->data[32] = emptyclosure;
  Method *meth_meth_ast_visitIf294 = addmethod2pos(obj199, "visitIf", &meth_ast_visitIf294, 32);
  int argcv_meth_ast_visitIf294[] = {1};
  meth_meth_ast_visitIf294->type = alloc_MethodType(1, argcv_meth_ast_visitIf294);
  meth_meth_ast_visitIf294->definitionModule = modulename;
  meth_meth_ast_visitIf294->definitionLine = 2763;
// method visitBlock
  struct UserObject *uo296 = (struct UserObject*)obj199;
  uo296->data[33] = emptyclosure;
  Method *meth_meth_ast_visitBlock296 = addmethod2pos(obj199, "visitBlock", &meth_ast_visitBlock296, 33);
  int argcv_meth_ast_visitBlock296[] = {1};
  meth_meth_ast_visitBlock296->type = alloc_MethodType(1, argcv_meth_ast_visitBlock296);
  meth_meth_ast_visitBlock296->definitionModule = modulename;
  meth_meth_ast_visitBlock296->definitionLine = 2764;
// method visitMatchCase
  struct UserObject *uo298 = (struct UserObject*)obj199;
  uo298->data[34] = emptyclosure;
  Method *meth_meth_ast_visitMatchCase298 = addmethod2pos(obj199, "visitMatchCase", &meth_ast_visitMatchCase298, 34);
  int argcv_meth_ast_visitMatchCase298[] = {1};
  meth_meth_ast_visitMatchCase298->type = alloc_MethodType(1, argcv_meth_ast_visitMatchCase298);
  meth_meth_ast_visitMatchCase298->definitionModule = modulename;
  meth_meth_ast_visitMatchCase298->definitionLine = 2765;
// method visitCatchCase
  struct UserObject *uo300 = (struct UserObject*)obj199;
  uo300->data[35] = emptyclosure;
  Method *meth_meth_ast_visitCatchCase300 = addmethod2pos(obj199, "visitCatchCase", &meth_ast_visitCatchCase300, 35);
  int argcv_meth_ast_visitCatchCase300[] = {1};
  meth_meth_ast_visitCatchCase300->type = alloc_MethodType(1, argcv_meth_ast_visitCatchCase300);
  meth_meth_ast_visitCatchCase300->definitionModule = modulename;
  meth_meth_ast_visitCatchCase300->definitionLine = 2766;
// method visitMethodType
  struct UserObject *uo302 = (struct UserObject*)obj199;
  uo302->data[36] = emptyclosure;
  Method *meth_meth_ast_visitMethodType302 = addmethod2pos(obj199, "visitMethodType", &meth_ast_visitMethodType302, 36);
  int argcv_meth_ast_visitMethodType302[] = {1};
  meth_meth_ast_visitMethodType302->type = alloc_MethodType(1, argcv_meth_ast_visitMethodType302);
  meth_meth_ast_visitMethodType302->definitionModule = modulename;
  meth_meth_ast_visitMethodType302->definitionLine = 2767;
// method visitSignaturePart
  struct UserObject *uo304 = (struct UserObject*)obj199;
  uo304->data[37] = emptyclosure;
  Method *meth_meth_ast_visitSignaturePart304 = addmethod2pos(obj199, "visitSignaturePart", &meth_ast_visitSignaturePart304, 37);
  int argcv_meth_ast_visitSignaturePart304[] = {1};
  meth_meth_ast_visitSignaturePart304->type = alloc_MethodType(1, argcv_meth_ast_visitSignaturePart304);
  meth_meth_ast_visitSignaturePart304->definitionModule = modulename;
  meth_meth_ast_visitSignaturePart304->definitionLine = 2768;
// method visitTypeDec
  struct UserObject *uo306 = (struct UserObject*)obj199;
  uo306->data[38] = emptyclosure;
  Method *meth_meth_ast_visitTypeDec306 = addmethod2pos(obj199, "visitTypeDec", &meth_ast_visitTypeDec306, 38);
  int argcv_meth_ast_visitTypeDec306[] = {1};
  meth_meth_ast_visitTypeDec306->type = alloc_MethodType(1, argcv_meth_ast_visitTypeDec306);
  meth_meth_ast_visitTypeDec306->definitionModule = modulename;
  meth_meth_ast_visitTypeDec306->definitionLine = 2769;
// method visitTypeLiteral
  struct UserObject *uo308 = (struct UserObject*)obj199;
  uo308->data[39] = emptyclosure;
  Method *meth_meth_ast_visitTypeLiteral308 = addmethod2pos(obj199, "visitTypeLiteral", &meth_ast_visitTypeLiteral308, 39);
  int argcv_meth_ast_visitTypeLiteral308[] = {1};
  meth_meth_ast_visitTypeLiteral308->type = alloc_MethodType(1, argcv_meth_ast_visitTypeLiteral308);
  meth_meth_ast_visitTypeLiteral308->definitionModule = modulename;
  meth_meth_ast_visitTypeLiteral308->definitionLine = 2770;
// method visitTypeParameters
  struct UserObject *uo310 = (struct UserObject*)obj199;
  uo310->data[40] = emptyclosure;
  Method *meth_meth_ast_visitTypeParameters310 = addmethod2pos(obj199, "visitTypeParameters", &meth_ast_visitTypeParameters310, 40);
  int argcv_meth_ast_visitTypeParameters310[] = {1};
  meth_meth_ast_visitTypeParameters310->type = alloc_MethodType(1, argcv_meth_ast_visitTypeParameters310);
  meth_meth_ast_visitTypeParameters310->definitionModule = modulename;
  meth_meth_ast_visitTypeParameters310->definitionLine = 2771;
// method visitMethod
  struct UserObject *uo312 = (struct UserObject*)obj199;
  uo312->data[41] = emptyclosure;
  Method *meth_meth_ast_visitMethod312 = addmethod2pos(obj199, "visitMethod", &meth_ast_visitMethod312, 41);
  int argcv_meth_ast_visitMethod312[] = {1};
  meth_meth_ast_visitMethod312->type = alloc_MethodType(1, argcv_meth_ast_visitMethod312);
  meth_meth_ast_visitMethod312->definitionModule = modulename;
  meth_meth_ast_visitMethod312->definitionLine = 2772;
// method visitCall
  struct UserObject *uo314 = (struct UserObject*)obj199;
  uo314->data[42] = emptyclosure;
  Method *meth_meth_ast_visitCall314 = addmethod2pos(obj199, "visitCall", &meth_ast_visitCall314, 42);
  int argcv_meth_ast_visitCall314[] = {1};
  meth_meth_ast_visitCall314->type = alloc_MethodType(1, argcv_meth_ast_visitCall314);
  meth_meth_ast_visitCall314->definitionModule = modulename;
  meth_meth_ast_visitCall314->definitionLine = 2773;
// method visitClass
  struct UserObject *uo316 = (struct UserObject*)obj199;
  uo316->data[43] = emptyclosure;
  Method *meth_meth_ast_visitClass316 = addmethod2pos(obj199, "visitClass", &meth_ast_visitClass316, 43);
  int argcv_meth_ast_visitClass316[] = {1};
  meth_meth_ast_visitClass316->type = alloc_MethodType(1, argcv_meth_ast_visitClass316);
  meth_meth_ast_visitClass316->definitionModule = modulename;
  meth_meth_ast_visitClass316->definitionLine = 2774;
// method visitObject
  struct UserObject *uo318 = (struct UserObject*)obj199;
  uo318->data[44] = emptyclosure;
  Method *meth_meth_ast_visitObject318 = addmethod2pos(obj199, "visitObject", &meth_ast_visitObject318, 44);
  int argcv_meth_ast_visitObject318[] = {1};
  meth_meth_ast_visitObject318->type = alloc_MethodType(1, argcv_meth_ast_visitObject318);
  meth_meth_ast_visitObject318->definitionModule = modulename;
  meth_meth_ast_visitObject318->definitionLine = 2775;
// method visitModule
  struct UserObject *uo320 = (struct UserObject*)obj199;
  uo320->data[45] = emptyclosure;
  Method *meth_meth_ast_visitModule320 = addmethod2pos(obj199, "visitModule", &meth_ast_visitModule320, 45);
  int argcv_meth_ast_visitModule320[] = {1};
  meth_meth_ast_visitModule320->type = alloc_MethodType(1, argcv_meth_ast_visitModule320);
  meth_meth_ast_visitModule320->definitionModule = modulename;
  meth_meth_ast_visitModule320->definitionLine = 2776;
// method visitArray
  struct UserObject *uo322 = (struct UserObject*)obj199;
  uo322->data[46] = emptyclosure;
  Method *meth_meth_ast_visitArray322 = addmethod2pos(obj199, "visitArray", &meth_ast_visitArray322, 46);
  int argcv_meth_ast_visitArray322[] = {1};
  meth_meth_ast_visitArray322->type = alloc_MethodType(1, argcv_meth_ast_visitArray322);
  meth_meth_ast_visitArray322->definitionModule = modulename;
  meth_meth_ast_visitArray322->definitionLine = 2777;
// method visitMember
  struct UserObject *uo324 = (struct UserObject*)obj199;
  uo324->data[47] = emptyclosure;
  Method *meth_meth_ast_visitMember324 = addmethod2pos(obj199, "visitMember", &meth_ast_visitMember324, 47);
  int argcv_meth_ast_visitMember324[] = {1};
  meth_meth_ast_visitMember324->type = alloc_MethodType(1, argcv_meth_ast_visitMember324);
  meth_meth_ast_visitMember324->definitionModule = modulename;
  meth_meth_ast_visitMember324->definitionLine = 2778;
// method visitGeneric
  struct UserObject *uo326 = (struct UserObject*)obj199;
  uo326->data[48] = emptyclosure;
  Method *meth_meth_ast_visitGeneric326 = addmethod2pos(obj199, "visitGeneric", &meth_ast_visitGeneric326, 48);
  int argcv_meth_ast_visitGeneric326[] = {1};
  meth_meth_ast_visitGeneric326->type = alloc_MethodType(1, argcv_meth_ast_visitGeneric326);
  meth_meth_ast_visitGeneric326->definitionModule = modulename;
  meth_meth_ast_visitGeneric326->definitionLine = 2779;
// method visitIdentifier
  struct UserObject *uo328 = (struct UserObject*)obj199;
  uo328->data[49] = emptyclosure;
  Method *meth_meth_ast_visitIdentifier328 = addmethod2pos(obj199, "visitIdentifier", &meth_ast_visitIdentifier328, 49);
  int argcv_meth_ast_visitIdentifier328[] = {1};
  meth_meth_ast_visitIdentifier328->type = alloc_MethodType(1, argcv_meth_ast_visitIdentifier328);
  meth_meth_ast_visitIdentifier328->definitionModule = modulename;
  meth_meth_ast_visitIdentifier328->definitionLine = 2780;
// method visitString
  struct UserObject *uo330 = (struct UserObject*)obj199;
  uo330->data[50] = emptyclosure;
  Method *meth_meth_ast_visitString330 = addmethod2pos(obj199, "visitString", &meth_ast_visitString330, 50);
  int argcv_meth_ast_visitString330[] = {1};
  meth_meth_ast_visitString330->type = alloc_MethodType(1, argcv_meth_ast_visitString330);
  meth_meth_ast_visitString330->definitionModule = modulename;
  meth_meth_ast_visitString330->definitionLine = 2781;
// method visitNum
  struct UserObject *uo332 = (struct UserObject*)obj199;
  uo332->data[51] = emptyclosure;
  Method *meth_meth_ast_visitNum332 = addmethod2pos(obj199, "visitNum", &meth_ast_visitNum332, 51);
  int argcv_meth_ast_visitNum332[] = {1};
  meth_meth_ast_visitNum332->type = alloc_MethodType(1, argcv_meth_ast_visitNum332);
  meth_meth_ast_visitNum332->definitionModule = modulename;
  meth_meth_ast_visitNum332->definitionLine = 2782;
// method visitOp
  struct UserObject *uo334 = (struct UserObject*)obj199;
  uo334->data[52] = emptyclosure;
  Method *meth_meth_ast_visitOp334 = addmethod2pos(obj199, "visitOp", &meth_ast_visitOp334, 52);
  int argcv_meth_ast_visitOp334[] = {1};
  meth_meth_ast_visitOp334->type = alloc_MethodType(1, argcv_meth_ast_visitOp334);
  meth_meth_ast_visitOp334->definitionModule = modulename;
  meth_meth_ast_visitOp334->definitionLine = 2783;
// method visitIndex
  struct UserObject *uo336 = (struct UserObject*)obj199;
  uo336->data[53] = emptyclosure;
  Method *meth_meth_ast_visitIndex336 = addmethod2pos(obj199, "visitIndex", &meth_ast_visitIndex336, 53);
  int argcv_meth_ast_visitIndex336[] = {1};
  meth_meth_ast_visitIndex336->type = alloc_MethodType(1, argcv_meth_ast_visitIndex336);
  meth_meth_ast_visitIndex336->definitionModule = modulename;
  meth_meth_ast_visitIndex336->definitionLine = 2784;
// method visitBind
  struct UserObject *uo338 = (struct UserObject*)obj199;
  uo338->data[54] = emptyclosure;
  Method *meth_meth_ast_visitBind338 = addmethod2pos(obj199, "visitBind", &meth_ast_visitBind338, 54);
  int argcv_meth_ast_visitBind338[] = {1};
  meth_meth_ast_visitBind338->type = alloc_MethodType(1, argcv_meth_ast_visitBind338);
  meth_meth_ast_visitBind338->definitionModule = modulename;
  meth_meth_ast_visitBind338->definitionLine = 2785;
// method visitDefDec
  struct UserObject *uo340 = (struct UserObject*)obj199;
  uo340->data[55] = emptyclosure;
  Method *meth_meth_ast_visitDefDec340 = addmethod2pos(obj199, "visitDefDec", &meth_ast_visitDefDec340, 55);
  int argcv_meth_ast_visitDefDec340[] = {1};
  meth_meth_ast_visitDefDec340->type = alloc_MethodType(1, argcv_meth_ast_visitDefDec340);
  meth_meth_ast_visitDefDec340->definitionModule = modulename;
  meth_meth_ast_visitDefDec340->definitionLine = 2786;
// method visitVarDec
  struct UserObject *uo342 = (struct UserObject*)obj199;
  uo342->data[56] = emptyclosure;
  Method *meth_meth_ast_visitVarDec342 = addmethod2pos(obj199, "visitVarDec", &meth_ast_visitVarDec342, 56);
  int argcv_meth_ast_visitVarDec342[] = {1};
  meth_meth_ast_visitVarDec342->type = alloc_MethodType(1, argcv_meth_ast_visitVarDec342);
  meth_meth_ast_visitVarDec342->definitionModule = modulename;
  meth_meth_ast_visitVarDec342->definitionLine = 2787;
// method visitImport
  struct UserObject *uo344 = (struct UserObject*)obj199;
  uo344->data[57] = emptyclosure;
  Method *meth_meth_ast_visitImport344 = addmethod2pos(obj199, "visitImport", &meth_ast_visitImport344, 57);
  int argcv_meth_ast_visitImport344[] = {1};
  meth_meth_ast_visitImport344->type = alloc_MethodType(1, argcv_meth_ast_visitImport344);
  meth_meth_ast_visitImport344->definitionModule = modulename;
  meth_meth_ast_visitImport344->definitionLine = 2788;
// method visitReturn
  struct UserObject *uo346 = (struct UserObject*)obj199;
  uo346->data[58] = emptyclosure;
  Method *meth_meth_ast_visitReturn346 = addmethod2pos(obj199, "visitReturn", &meth_ast_visitReturn346, 58);
  int argcv_meth_ast_visitReturn346[] = {1};
  meth_meth_ast_visitReturn346->type = alloc_MethodType(1, argcv_meth_ast_visitReturn346);
  meth_meth_ast_visitReturn346->definitionModule = modulename;
  meth_meth_ast_visitReturn346->definitionLine = 2789;
// method visitInherits
  struct UserObject *uo348 = (struct UserObject*)obj199;
  uo348->data[59] = emptyclosure;
  Method *meth_meth_ast_visitInherits348 = addmethod2pos(obj199, "visitInherits", &meth_ast_visitInherits348, 59);
  int argcv_meth_ast_visitInherits348[] = {1};
  meth_meth_ast_visitInherits348->type = alloc_MethodType(1, argcv_meth_ast_visitInherits348);
  meth_meth_ast_visitInherits348->definitionModule = modulename;
  meth_meth_ast_visitInherits348->definitionLine = 2790;
// method visitDialect
  struct UserObject *uo350 = (struct UserObject*)obj199;
  uo350->data[60] = emptyclosure;
  Method *meth_meth_ast_visitDialect350 = addmethod2pos(obj199, "visitDialect", &meth_ast_visitDialect350, 60);
  int argcv_meth_ast_visitDialect350[] = {1};
  meth_meth_ast_visitDialect350->type = alloc_MethodType(1, argcv_meth_ast_visitDialect350);
  meth_meth_ast_visitDialect350->definitionModule = modulename;
  meth_meth_ast_visitDialect350->definitionLine = 2791;
// method visitBlank
  struct UserObject *uo352 = (struct UserObject*)obj199;
  uo352->data[61] = emptyclosure;
  Method *meth_meth_ast_visitBlank352 = addmethod2pos(obj199, "visitBlank", &meth_ast_visitBlank352, 61);
  int argcv_meth_ast_visitBlank352[] = {1};
  meth_meth_ast_visitBlank352->type = alloc_MethodType(1, argcv_meth_ast_visitBlank352);
  meth_meth_ast_visitBlank352->definitionModule = modulename;
  meth_meth_ast_visitBlank352->definitionLine = 2792;
// method visitComment
  struct UserObject *uo354 = (struct UserObject*)obj199;
  uo354->data[62] = emptyclosure;
  Method *meth_meth_ast_visitComment354 = addmethod2pos(obj199, "visitComment", &meth_ast_visitComment354, 62);
  int argcv_meth_ast_visitComment354[] = {1};
  meth_meth_ast_visitComment354->type = alloc_MethodType(1, argcv_meth_ast_visitComment354);
  meth_meth_ast_visitComment354->definitionModule = modulename;
  meth_meth_ast_visitComment354->definitionLine = 2793;
// method asString
  struct UserObject *uo356 = (struct UserObject*)obj199;
  uo356->data[63] = emptyclosure;
  Method *meth_meth_ast_asString356 = addmethod2pos(obj199, "asString", &meth_ast_asString356, 63);
  int argcv_meth_ast_asString356[] = {0};
  meth_meth_ast_asString356->type = alloc_MethodType(1, argcv_meth_ast_asString356);
  meth_meth_ast_asString356->definitionModule = modulename;
  meth_meth_ast_asString356->definitionLine = 2795;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  objclass199 = obj199->class;
  objclass199->definitionModule = modulename;
  objclass199->definitionLine = 2730;
  (*(struct UserObject *)self).data[0] = lowerouter199;
  self = oldself199;
  selfslot = oldselfslot199;
  stackframe = oldstackframe199;
  gc_frame_end(frame);
  return obj199;
}
Object meth_ast_baseVisitor198_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "baseVisitor()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for baseVisitor (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for baseVisitor");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject199 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj199 = alloc_userobj2(63,64, objclass199);
  gc_frame_newslot(obj199);
if (objclass199 == NULL) {
  glfree(obj199->class->name);
  obj199->class->name = "self.baseVisitor";
}
// OBJECT OUTER DEC outer
  adddatum2(obj199, self, 0);
  addmethodreal(obj199,"outer", &reader_ast_outer_200);
  Object oldself199 = self;
  struct StackFrameObject *oldstackframe199 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe199);
  gc_frame_newslot((Object)stackframe);
  self = obj199;
  Object *oldselfslot199 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter199 = (*(struct UserObject *)self).data[0], lowerouter199 = thisouter199;
  if (inheritingObject199) {
    struct UserObject *inho199 = (struct UserObject *)inheritingObject199;
    while (inho199->super != GraceDefaultObject) inho199 = (struct UserObject *)inho199->super;
    inho199->super = obj199;
    self = inheritingObject199;
    *selfslot = self;
    lowerouter199 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter199;
  }
// method visitIf()up
  struct UserObject *uo201 = (struct UserObject*)obj199;
  uo201->data[1] = emptyclosure;
  Method *meth_meth_ast_visitIf_40__41_up201 = addmethod2pos(obj199, "visitIf()up", &meth_ast_visitIf_40__41_up201, 1);
  int argcv_meth_ast_visitIf_40__41_up201[] = {1, 1};
  meth_meth_ast_visitIf_40__41_up201->type = alloc_MethodType(2, argcv_meth_ast_visitIf_40__41_up201);
  meth_meth_ast_visitIf_40__41_up201->definitionModule = modulename;
  meth_meth_ast_visitIf_40__41_up201->definitionLine = 2731;
// method visitBlock()up
  struct UserObject *uo204 = (struct UserObject*)obj199;
  uo204->data[2] = emptyclosure;
  Method *meth_meth_ast_visitBlock_40__41_up204 = addmethod2pos(obj199, "visitBlock()up", &meth_ast_visitBlock_40__41_up204, 2);
  int argcv_meth_ast_visitBlock_40__41_up204[] = {1, 1};
  meth_meth_ast_visitBlock_40__41_up204->type = alloc_MethodType(2, argcv_meth_ast_visitBlock_40__41_up204);
  meth_meth_ast_visitBlock_40__41_up204->definitionModule = modulename;
  meth_meth_ast_visitBlock_40__41_up204->definitionLine = 2732;
// method visitMatchCase()up
  struct UserObject *uo207 = (struct UserObject*)obj199;
  uo207->data[3] = emptyclosure;
  Method *meth_meth_ast_visitMatchCase_40__41_up207 = addmethod2pos(obj199, "visitMatchCase()up", &meth_ast_visitMatchCase_40__41_up207, 3);
  int argcv_meth_ast_visitMatchCase_40__41_up207[] = {1, 1};
  meth_meth_ast_visitMatchCase_40__41_up207->type = alloc_MethodType(2, argcv_meth_ast_visitMatchCase_40__41_up207);
  meth_meth_ast_visitMatchCase_40__41_up207->definitionModule = modulename;
  meth_meth_ast_visitMatchCase_40__41_up207->definitionLine = 2733;
// method visitCatchCase()up
  struct UserObject *uo210 = (struct UserObject*)obj199;
  uo210->data[4] = emptyclosure;
  Method *meth_meth_ast_visitCatchCase_40__41_up210 = addmethod2pos(obj199, "visitCatchCase()up", &meth_ast_visitCatchCase_40__41_up210, 4);
  int argcv_meth_ast_visitCatchCase_40__41_up210[] = {1, 1};
  meth_meth_ast_visitCatchCase_40__41_up210->type = alloc_MethodType(2, argcv_meth_ast_visitCatchCase_40__41_up210);
  meth_meth_ast_visitCatchCase_40__41_up210->definitionModule = modulename;
  meth_meth_ast_visitCatchCase_40__41_up210->definitionLine = 2734;
// method visitMethodType()up
  struct UserObject *uo213 = (struct UserObject*)obj199;
  uo213->data[5] = emptyclosure;
  Method *meth_meth_ast_visitMethodType_40__41_up213 = addmethod2pos(obj199, "visitMethodType()up", &meth_ast_visitMethodType_40__41_up213, 5);
  int argcv_meth_ast_visitMethodType_40__41_up213[] = {1, 1};
  meth_meth_ast_visitMethodType_40__41_up213->type = alloc_MethodType(2, argcv_meth_ast_visitMethodType_40__41_up213);
  meth_meth_ast_visitMethodType_40__41_up213->definitionModule = modulename;
  meth_meth_ast_visitMethodType_40__41_up213->definitionLine = 2735;
// method visitSignaturePart()up
  struct UserObject *uo216 = (struct UserObject*)obj199;
  uo216->data[6] = emptyclosure;
  Method *meth_meth_ast_visitSignaturePart_40__41_up216 = addmethod2pos(obj199, "visitSignaturePart()up", &meth_ast_visitSignaturePart_40__41_up216, 6);
  int argcv_meth_ast_visitSignaturePart_40__41_up216[] = {1, 1};
  meth_meth_ast_visitSignaturePart_40__41_up216->type = alloc_MethodType(2, argcv_meth_ast_visitSignaturePart_40__41_up216);
  meth_meth_ast_visitSignaturePart_40__41_up216->definitionModule = modulename;
  meth_meth_ast_visitSignaturePart_40__41_up216->definitionLine = 2736;
// method visitTypeDec()up
  struct UserObject *uo219 = (struct UserObject*)obj199;
  uo219->data[7] = emptyclosure;
  Method *meth_meth_ast_visitTypeDec_40__41_up219 = addmethod2pos(obj199, "visitTypeDec()up", &meth_ast_visitTypeDec_40__41_up219, 7);
  int argcv_meth_ast_visitTypeDec_40__41_up219[] = {1, 1};
  meth_meth_ast_visitTypeDec_40__41_up219->type = alloc_MethodType(2, argcv_meth_ast_visitTypeDec_40__41_up219);
  meth_meth_ast_visitTypeDec_40__41_up219->definitionModule = modulename;
  meth_meth_ast_visitTypeDec_40__41_up219->definitionLine = 2737;
// method visitTypeLiteral()up
  struct UserObject *uo222 = (struct UserObject*)obj199;
  uo222->data[8] = emptyclosure;
  Method *meth_meth_ast_visitTypeLiteral_40__41_up222 = addmethod2pos(obj199, "visitTypeLiteral()up", &meth_ast_visitTypeLiteral_40__41_up222, 8);
  int argcv_meth_ast_visitTypeLiteral_40__41_up222[] = {1, 1};
  meth_meth_ast_visitTypeLiteral_40__41_up222->type = alloc_MethodType(2, argcv_meth_ast_visitTypeLiteral_40__41_up222);
  meth_meth_ast_visitTypeLiteral_40__41_up222->definitionModule = modulename;
  meth_meth_ast_visitTypeLiteral_40__41_up222->definitionLine = 2738;
// method visitTypeParameters()up
  struct UserObject *uo225 = (struct UserObject*)obj199;
  uo225->data[9] = emptyclosure;
  Method *meth_meth_ast_visitTypeParameters_40__41_up225 = addmethod2pos(obj199, "visitTypeParameters()up", &meth_ast_visitTypeParameters_40__41_up225, 9);
  int argcv_meth_ast_visitTypeParameters_40__41_up225[] = {1, 1};
  meth_meth_ast_visitTypeParameters_40__41_up225->type = alloc_MethodType(2, argcv_meth_ast_visitTypeParameters_40__41_up225);
  meth_meth_ast_visitTypeParameters_40__41_up225->definitionModule = modulename;
  meth_meth_ast_visitTypeParameters_40__41_up225->definitionLine = 2739;
// method visitMethod()up
  struct UserObject *uo228 = (struct UserObject*)obj199;
  uo228->data[10] = emptyclosure;
  Method *meth_meth_ast_visitMethod_40__41_up228 = addmethod2pos(obj199, "visitMethod()up", &meth_ast_visitMethod_40__41_up228, 10);
  int argcv_meth_ast_visitMethod_40__41_up228[] = {1, 1};
  meth_meth_ast_visitMethod_40__41_up228->type = alloc_MethodType(2, argcv_meth_ast_visitMethod_40__41_up228);
  meth_meth_ast_visitMethod_40__41_up228->definitionModule = modulename;
  meth_meth_ast_visitMethod_40__41_up228->definitionLine = 2740;
// method visitCall()up
  struct UserObject *uo231 = (struct UserObject*)obj199;
  uo231->data[11] = emptyclosure;
  Method *meth_meth_ast_visitCall_40__41_up231 = addmethod2pos(obj199, "visitCall()up", &meth_ast_visitCall_40__41_up231, 11);
  int argcv_meth_ast_visitCall_40__41_up231[] = {1, 1};
  meth_meth_ast_visitCall_40__41_up231->type = alloc_MethodType(2, argcv_meth_ast_visitCall_40__41_up231);
  meth_meth_ast_visitCall_40__41_up231->definitionModule = modulename;
  meth_meth_ast_visitCall_40__41_up231->definitionLine = 2741;
// method visitClass()up
  struct UserObject *uo234 = (struct UserObject*)obj199;
  uo234->data[12] = emptyclosure;
  Method *meth_meth_ast_visitClass_40__41_up234 = addmethod2pos(obj199, "visitClass()up", &meth_ast_visitClass_40__41_up234, 12);
  int argcv_meth_ast_visitClass_40__41_up234[] = {1, 1};
  meth_meth_ast_visitClass_40__41_up234->type = alloc_MethodType(2, argcv_meth_ast_visitClass_40__41_up234);
  meth_meth_ast_visitClass_40__41_up234->definitionModule = modulename;
  meth_meth_ast_visitClass_40__41_up234->definitionLine = 2742;
// method visitObject()up
  struct UserObject *uo237 = (struct UserObject*)obj199;
  uo237->data[13] = emptyclosure;
  Method *meth_meth_ast_visitObject_40__41_up237 = addmethod2pos(obj199, "visitObject()up", &meth_ast_visitObject_40__41_up237, 13);
  int argcv_meth_ast_visitObject_40__41_up237[] = {1, 1};
  meth_meth_ast_visitObject_40__41_up237->type = alloc_MethodType(2, argcv_meth_ast_visitObject_40__41_up237);
  meth_meth_ast_visitObject_40__41_up237->definitionModule = modulename;
  meth_meth_ast_visitObject_40__41_up237->definitionLine = 2743;
// method visitModule()up
  struct UserObject *uo240 = (struct UserObject*)obj199;
  uo240->data[14] = emptyclosure;
  Method *meth_meth_ast_visitModule_40__41_up240 = addmethod2pos(obj199, "visitModule()up", &meth_ast_visitModule_40__41_up240, 14);
  int argcv_meth_ast_visitModule_40__41_up240[] = {1, 1};
  meth_meth_ast_visitModule_40__41_up240->type = alloc_MethodType(2, argcv_meth_ast_visitModule_40__41_up240);
  meth_meth_ast_visitModule_40__41_up240->definitionModule = modulename;
  meth_meth_ast_visitModule_40__41_up240->definitionLine = 2744;
// method visitArray()up
  struct UserObject *uo243 = (struct UserObject*)obj199;
  uo243->data[15] = emptyclosure;
  Method *meth_meth_ast_visitArray_40__41_up243 = addmethod2pos(obj199, "visitArray()up", &meth_ast_visitArray_40__41_up243, 15);
  int argcv_meth_ast_visitArray_40__41_up243[] = {1, 1};
  meth_meth_ast_visitArray_40__41_up243->type = alloc_MethodType(2, argcv_meth_ast_visitArray_40__41_up243);
  meth_meth_ast_visitArray_40__41_up243->definitionModule = modulename;
  meth_meth_ast_visitArray_40__41_up243->definitionLine = 2745;
// method visitMember()up
  struct UserObject *uo246 = (struct UserObject*)obj199;
  uo246->data[16] = emptyclosure;
  Method *meth_meth_ast_visitMember_40__41_up246 = addmethod2pos(obj199, "visitMember()up", &meth_ast_visitMember_40__41_up246, 16);
  int argcv_meth_ast_visitMember_40__41_up246[] = {1, 1};
  meth_meth_ast_visitMember_40__41_up246->type = alloc_MethodType(2, argcv_meth_ast_visitMember_40__41_up246);
  meth_meth_ast_visitMember_40__41_up246->definitionModule = modulename;
  meth_meth_ast_visitMember_40__41_up246->definitionLine = 2746;
// method visitGeneric()up
  struct UserObject *uo249 = (struct UserObject*)obj199;
  uo249->data[17] = emptyclosure;
  Method *meth_meth_ast_visitGeneric_40__41_up249 = addmethod2pos(obj199, "visitGeneric()up", &meth_ast_visitGeneric_40__41_up249, 17);
  int argcv_meth_ast_visitGeneric_40__41_up249[] = {1, 1};
  meth_meth_ast_visitGeneric_40__41_up249->type = alloc_MethodType(2, argcv_meth_ast_visitGeneric_40__41_up249);
  meth_meth_ast_visitGeneric_40__41_up249->definitionModule = modulename;
  meth_meth_ast_visitGeneric_40__41_up249->definitionLine = 2747;
// method visitIdentifier()up
  struct UserObject *uo252 = (struct UserObject*)obj199;
  uo252->data[18] = emptyclosure;
  Method *meth_meth_ast_visitIdentifier_40__41_up252 = addmethod2pos(obj199, "visitIdentifier()up", &meth_ast_visitIdentifier_40__41_up252, 18);
  int argcv_meth_ast_visitIdentifier_40__41_up252[] = {1, 1};
  meth_meth_ast_visitIdentifier_40__41_up252->type = alloc_MethodType(2, argcv_meth_ast_visitIdentifier_40__41_up252);
  meth_meth_ast_visitIdentifier_40__41_up252->definitionModule = modulename;
  meth_meth_ast_visitIdentifier_40__41_up252->definitionLine = 2748;
// method visitString()up
  struct UserObject *uo255 = (struct UserObject*)obj199;
  uo255->data[19] = emptyclosure;
  Method *meth_meth_ast_visitString_40__41_up255 = addmethod2pos(obj199, "visitString()up", &meth_ast_visitString_40__41_up255, 19);
  int argcv_meth_ast_visitString_40__41_up255[] = {1, 1};
  meth_meth_ast_visitString_40__41_up255->type = alloc_MethodType(2, argcv_meth_ast_visitString_40__41_up255);
  meth_meth_ast_visitString_40__41_up255->definitionModule = modulename;
  meth_meth_ast_visitString_40__41_up255->definitionLine = 2749;
// method visitNum()up
  struct UserObject *uo258 = (struct UserObject*)obj199;
  uo258->data[20] = emptyclosure;
  Method *meth_meth_ast_visitNum_40__41_up258 = addmethod2pos(obj199, "visitNum()up", &meth_ast_visitNum_40__41_up258, 20);
  int argcv_meth_ast_visitNum_40__41_up258[] = {1, 1};
  meth_meth_ast_visitNum_40__41_up258->type = alloc_MethodType(2, argcv_meth_ast_visitNum_40__41_up258);
  meth_meth_ast_visitNum_40__41_up258->definitionModule = modulename;
  meth_meth_ast_visitNum_40__41_up258->definitionLine = 2750;
// method visitOp()up
  struct UserObject *uo261 = (struct UserObject*)obj199;
  uo261->data[21] = emptyclosure;
  Method *meth_meth_ast_visitOp_40__41_up261 = addmethod2pos(obj199, "visitOp()up", &meth_ast_visitOp_40__41_up261, 21);
  int argcv_meth_ast_visitOp_40__41_up261[] = {1, 1};
  meth_meth_ast_visitOp_40__41_up261->type = alloc_MethodType(2, argcv_meth_ast_visitOp_40__41_up261);
  meth_meth_ast_visitOp_40__41_up261->definitionModule = modulename;
  meth_meth_ast_visitOp_40__41_up261->definitionLine = 2751;
// method visitIndex()up
  struct UserObject *uo264 = (struct UserObject*)obj199;
  uo264->data[22] = emptyclosure;
  Method *meth_meth_ast_visitIndex_40__41_up264 = addmethod2pos(obj199, "visitIndex()up", &meth_ast_visitIndex_40__41_up264, 22);
  int argcv_meth_ast_visitIndex_40__41_up264[] = {1, 1};
  meth_meth_ast_visitIndex_40__41_up264->type = alloc_MethodType(2, argcv_meth_ast_visitIndex_40__41_up264);
  meth_meth_ast_visitIndex_40__41_up264->definitionModule = modulename;
  meth_meth_ast_visitIndex_40__41_up264->definitionLine = 2752;
// method visitBind()up
  struct UserObject *uo267 = (struct UserObject*)obj199;
  uo267->data[23] = emptyclosure;
  Method *meth_meth_ast_visitBind_40__41_up267 = addmethod2pos(obj199, "visitBind()up", &meth_ast_visitBind_40__41_up267, 23);
  int argcv_meth_ast_visitBind_40__41_up267[] = {1, 1};
  meth_meth_ast_visitBind_40__41_up267->type = alloc_MethodType(2, argcv_meth_ast_visitBind_40__41_up267);
  meth_meth_ast_visitBind_40__41_up267->definitionModule = modulename;
  meth_meth_ast_visitBind_40__41_up267->definitionLine = 2753;
// method visitDefDec()up
  struct UserObject *uo270 = (struct UserObject*)obj199;
  uo270->data[24] = emptyclosure;
  Method *meth_meth_ast_visitDefDec_40__41_up270 = addmethod2pos(obj199, "visitDefDec()up", &meth_ast_visitDefDec_40__41_up270, 24);
  int argcv_meth_ast_visitDefDec_40__41_up270[] = {1, 1};
  meth_meth_ast_visitDefDec_40__41_up270->type = alloc_MethodType(2, argcv_meth_ast_visitDefDec_40__41_up270);
  meth_meth_ast_visitDefDec_40__41_up270->definitionModule = modulename;
  meth_meth_ast_visitDefDec_40__41_up270->definitionLine = 2754;
// method visitVarDec()up
  struct UserObject *uo273 = (struct UserObject*)obj199;
  uo273->data[25] = emptyclosure;
  Method *meth_meth_ast_visitVarDec_40__41_up273 = addmethod2pos(obj199, "visitVarDec()up", &meth_ast_visitVarDec_40__41_up273, 25);
  int argcv_meth_ast_visitVarDec_40__41_up273[] = {1, 1};
  meth_meth_ast_visitVarDec_40__41_up273->type = alloc_MethodType(2, argcv_meth_ast_visitVarDec_40__41_up273);
  meth_meth_ast_visitVarDec_40__41_up273->definitionModule = modulename;
  meth_meth_ast_visitVarDec_40__41_up273->definitionLine = 2755;
// method visitImport()up
  struct UserObject *uo276 = (struct UserObject*)obj199;
  uo276->data[26] = emptyclosure;
  Method *meth_meth_ast_visitImport_40__41_up276 = addmethod2pos(obj199, "visitImport()up", &meth_ast_visitImport_40__41_up276, 26);
  int argcv_meth_ast_visitImport_40__41_up276[] = {1, 1};
  meth_meth_ast_visitImport_40__41_up276->type = alloc_MethodType(2, argcv_meth_ast_visitImport_40__41_up276);
  meth_meth_ast_visitImport_40__41_up276->definitionModule = modulename;
  meth_meth_ast_visitImport_40__41_up276->definitionLine = 2756;
// method visitReturn()up
  struct UserObject *uo279 = (struct UserObject*)obj199;
  uo279->data[27] = emptyclosure;
  Method *meth_meth_ast_visitReturn_40__41_up279 = addmethod2pos(obj199, "visitReturn()up", &meth_ast_visitReturn_40__41_up279, 27);
  int argcv_meth_ast_visitReturn_40__41_up279[] = {1, 1};
  meth_meth_ast_visitReturn_40__41_up279->type = alloc_MethodType(2, argcv_meth_ast_visitReturn_40__41_up279);
  meth_meth_ast_visitReturn_40__41_up279->definitionModule = modulename;
  meth_meth_ast_visitReturn_40__41_up279->definitionLine = 2757;
// method visitInherits()up
  struct UserObject *uo282 = (struct UserObject*)obj199;
  uo282->data[28] = emptyclosure;
  Method *meth_meth_ast_visitInherits_40__41_up282 = addmethod2pos(obj199, "visitInherits()up", &meth_ast_visitInherits_40__41_up282, 28);
  int argcv_meth_ast_visitInherits_40__41_up282[] = {1, 1};
  meth_meth_ast_visitInherits_40__41_up282->type = alloc_MethodType(2, argcv_meth_ast_visitInherits_40__41_up282);
  meth_meth_ast_visitInherits_40__41_up282->definitionModule = modulename;
  meth_meth_ast_visitInherits_40__41_up282->definitionLine = 2758;
// method visitDialect()up
  struct UserObject *uo285 = (struct UserObject*)obj199;
  uo285->data[29] = emptyclosure;
  Method *meth_meth_ast_visitDialect_40__41_up285 = addmethod2pos(obj199, "visitDialect()up", &meth_ast_visitDialect_40__41_up285, 29);
  int argcv_meth_ast_visitDialect_40__41_up285[] = {1, 1};
  meth_meth_ast_visitDialect_40__41_up285->type = alloc_MethodType(2, argcv_meth_ast_visitDialect_40__41_up285);
  meth_meth_ast_visitDialect_40__41_up285->definitionModule = modulename;
  meth_meth_ast_visitDialect_40__41_up285->definitionLine = 2759;
// method visitBlank()up
  struct UserObject *uo288 = (struct UserObject*)obj199;
  uo288->data[30] = emptyclosure;
  Method *meth_meth_ast_visitBlank_40__41_up288 = addmethod2pos(obj199, "visitBlank()up", &meth_ast_visitBlank_40__41_up288, 30);
  int argcv_meth_ast_visitBlank_40__41_up288[] = {1, 1};
  meth_meth_ast_visitBlank_40__41_up288->type = alloc_MethodType(2, argcv_meth_ast_visitBlank_40__41_up288);
  meth_meth_ast_visitBlank_40__41_up288->definitionModule = modulename;
  meth_meth_ast_visitBlank_40__41_up288->definitionLine = 2760;
// method visitComment()up
  struct UserObject *uo291 = (struct UserObject*)obj199;
  uo291->data[31] = emptyclosure;
  Method *meth_meth_ast_visitComment_40__41_up291 = addmethod2pos(obj199, "visitComment()up", &meth_ast_visitComment_40__41_up291, 31);
  int argcv_meth_ast_visitComment_40__41_up291[] = {1, 1};
  meth_meth_ast_visitComment_40__41_up291->type = alloc_MethodType(2, argcv_meth_ast_visitComment_40__41_up291);
  meth_meth_ast_visitComment_40__41_up291->definitionModule = modulename;
  meth_meth_ast_visitComment_40__41_up291->definitionLine = 2761;
// method visitIf
  struct UserObject *uo294 = (struct UserObject*)obj199;
  uo294->data[32] = emptyclosure;
  Method *meth_meth_ast_visitIf294 = addmethod2pos(obj199, "visitIf", &meth_ast_visitIf294, 32);
  int argcv_meth_ast_visitIf294[] = {1};
  meth_meth_ast_visitIf294->type = alloc_MethodType(1, argcv_meth_ast_visitIf294);
  meth_meth_ast_visitIf294->definitionModule = modulename;
  meth_meth_ast_visitIf294->definitionLine = 2763;
// method visitBlock
  struct UserObject *uo296 = (struct UserObject*)obj199;
  uo296->data[33] = emptyclosure;
  Method *meth_meth_ast_visitBlock296 = addmethod2pos(obj199, "visitBlock", &meth_ast_visitBlock296, 33);
  int argcv_meth_ast_visitBlock296[] = {1};
  meth_meth_ast_visitBlock296->type = alloc_MethodType(1, argcv_meth_ast_visitBlock296);
  meth_meth_ast_visitBlock296->definitionModule = modulename;
  meth_meth_ast_visitBlock296->definitionLine = 2764;
// method visitMatchCase
  struct UserObject *uo298 = (struct UserObject*)obj199;
  uo298->data[34] = emptyclosure;
  Method *meth_meth_ast_visitMatchCase298 = addmethod2pos(obj199, "visitMatchCase", &meth_ast_visitMatchCase298, 34);
  int argcv_meth_ast_visitMatchCase298[] = {1};
  meth_meth_ast_visitMatchCase298->type = alloc_MethodType(1, argcv_meth_ast_visitMatchCase298);
  meth_meth_ast_visitMatchCase298->definitionModule = modulename;
  meth_meth_ast_visitMatchCase298->definitionLine = 2765;
// method visitCatchCase
  struct UserObject *uo300 = (struct UserObject*)obj199;
  uo300->data[35] = emptyclosure;
  Method *meth_meth_ast_visitCatchCase300 = addmethod2pos(obj199, "visitCatchCase", &meth_ast_visitCatchCase300, 35);
  int argcv_meth_ast_visitCatchCase300[] = {1};
  meth_meth_ast_visitCatchCase300->type = alloc_MethodType(1, argcv_meth_ast_visitCatchCase300);
  meth_meth_ast_visitCatchCase300->definitionModule = modulename;
  meth_meth_ast_visitCatchCase300->definitionLine = 2766;
// method visitMethodType
  struct UserObject *uo302 = (struct UserObject*)obj199;
  uo302->data[36] = emptyclosure;
  Method *meth_meth_ast_visitMethodType302 = addmethod2pos(obj199, "visitMethodType", &meth_ast_visitMethodType302, 36);
  int argcv_meth_ast_visitMethodType302[] = {1};
  meth_meth_ast_visitMethodType302->type = alloc_MethodType(1, argcv_meth_ast_visitMethodType302);
  meth_meth_ast_visitMethodType302->definitionModule = modulename;
  meth_meth_ast_visitMethodType302->definitionLine = 2767;
// method visitSignaturePart
  struct UserObject *uo304 = (struct UserObject*)obj199;
  uo304->data[37] = emptyclosure;
  Method *meth_meth_ast_visitSignaturePart304 = addmethod2pos(obj199, "visitSignaturePart", &meth_ast_visitSignaturePart304, 37);
  int argcv_meth_ast_visitSignaturePart304[] = {1};
  meth_meth_ast_visitSignaturePart304->type = alloc_MethodType(1, argcv_meth_ast_visitSignaturePart304);
  meth_meth_ast_visitSignaturePart304->definitionModule = modulename;
  meth_meth_ast_visitSignaturePart304->definitionLine = 2768;
// method visitTypeDec
  struct UserObject *uo306 = (struct UserObject*)obj199;
  uo306->data[38] = emptyclosure;
  Method *meth_meth_ast_visitTypeDec306 = addmethod2pos(obj199, "visitTypeDec", &meth_ast_visitTypeDec306, 38);
  int argcv_meth_ast_visitTypeDec306[] = {1};
  meth_meth_ast_visitTypeDec306->type = alloc_MethodType(1, argcv_meth_ast_visitTypeDec306);
  meth_meth_ast_visitTypeDec306->definitionModule = modulename;
  meth_meth_ast_visitTypeDec306->definitionLine = 2769;
// method visitTypeLiteral
  struct UserObject *uo308 = (struct UserObject*)obj199;
  uo308->data[39] = emptyclosure;
  Method *meth_meth_ast_visitTypeLiteral308 = addmethod2pos(obj199, "visitTypeLiteral", &meth_ast_visitTypeLiteral308, 39);
  int argcv_meth_ast_visitTypeLiteral308[] = {1};
  meth_meth_ast_visitTypeLiteral308->type = alloc_MethodType(1, argcv_meth_ast_visitTypeLiteral308);
  meth_meth_ast_visitTypeLiteral308->definitionModule = modulename;
  meth_meth_ast_visitTypeLiteral308->definitionLine = 2770;
// method visitTypeParameters
  struct UserObject *uo310 = (struct UserObject*)obj199;
  uo310->data[40] = emptyclosure;
  Method *meth_meth_ast_visitTypeParameters310 = addmethod2pos(obj199, "visitTypeParameters", &meth_ast_visitTypeParameters310, 40);
  int argcv_meth_ast_visitTypeParameters310[] = {1};
  meth_meth_ast_visitTypeParameters310->type = alloc_MethodType(1, argcv_meth_ast_visitTypeParameters310);
  meth_meth_ast_visitTypeParameters310->definitionModule = modulename;
  meth_meth_ast_visitTypeParameters310->definitionLine = 2771;
// method visitMethod
  struct UserObject *uo312 = (struct UserObject*)obj199;
  uo312->data[41] = emptyclosure;
  Method *meth_meth_ast_visitMethod312 = addmethod2pos(obj199, "visitMethod", &meth_ast_visitMethod312, 41);
  int argcv_meth_ast_visitMethod312[] = {1};
  meth_meth_ast_visitMethod312->type = alloc_MethodType(1, argcv_meth_ast_visitMethod312);
  meth_meth_ast_visitMethod312->definitionModule = modulename;
  meth_meth_ast_visitMethod312->definitionLine = 2772;
// method visitCall
  struct UserObject *uo314 = (struct UserObject*)obj199;
  uo314->data[42] = emptyclosure;
  Method *meth_meth_ast_visitCall314 = addmethod2pos(obj199, "visitCall", &meth_ast_visitCall314, 42);
  int argcv_meth_ast_visitCall314[] = {1};
  meth_meth_ast_visitCall314->type = alloc_MethodType(1, argcv_meth_ast_visitCall314);
  meth_meth_ast_visitCall314->definitionModule = modulename;
  meth_meth_ast_visitCall314->definitionLine = 2773;
// method visitClass
  struct UserObject *uo316 = (struct UserObject*)obj199;
  uo316->data[43] = emptyclosure;
  Method *meth_meth_ast_visitClass316 = addmethod2pos(obj199, "visitClass", &meth_ast_visitClass316, 43);
  int argcv_meth_ast_visitClass316[] = {1};
  meth_meth_ast_visitClass316->type = alloc_MethodType(1, argcv_meth_ast_visitClass316);
  meth_meth_ast_visitClass316->definitionModule = modulename;
  meth_meth_ast_visitClass316->definitionLine = 2774;
// method visitObject
  struct UserObject *uo318 = (struct UserObject*)obj199;
  uo318->data[44] = emptyclosure;
  Method *meth_meth_ast_visitObject318 = addmethod2pos(obj199, "visitObject", &meth_ast_visitObject318, 44);
  int argcv_meth_ast_visitObject318[] = {1};
  meth_meth_ast_visitObject318->type = alloc_MethodType(1, argcv_meth_ast_visitObject318);
  meth_meth_ast_visitObject318->definitionModule = modulename;
  meth_meth_ast_visitObject318->definitionLine = 2775;
// method visitModule
  struct UserObject *uo320 = (struct UserObject*)obj199;
  uo320->data[45] = emptyclosure;
  Method *meth_meth_ast_visitModule320 = addmethod2pos(obj199, "visitModule", &meth_ast_visitModule320, 45);
  int argcv_meth_ast_visitModule320[] = {1};
  meth_meth_ast_visitModule320->type = alloc_MethodType(1, argcv_meth_ast_visitModule320);
  meth_meth_ast_visitModule320->definitionModule = modulename;
  meth_meth_ast_visitModule320->definitionLine = 2776;
// method visitArray
  struct UserObject *uo322 = (struct UserObject*)obj199;
  uo322->data[46] = emptyclosure;
  Method *meth_meth_ast_visitArray322 = addmethod2pos(obj199, "visitArray", &meth_ast_visitArray322, 46);
  int argcv_meth_ast_visitArray322[] = {1};
  meth_meth_ast_visitArray322->type = alloc_MethodType(1, argcv_meth_ast_visitArray322);
  meth_meth_ast_visitArray322->definitionModule = modulename;
  meth_meth_ast_visitArray322->definitionLine = 2777;
// method visitMember
  struct UserObject *uo324 = (struct UserObject*)obj199;
  uo324->data[47] = emptyclosure;
  Method *meth_meth_ast_visitMember324 = addmethod2pos(obj199, "visitMember", &meth_ast_visitMember324, 47);
  int argcv_meth_ast_visitMember324[] = {1};
  meth_meth_ast_visitMember324->type = alloc_MethodType(1, argcv_meth_ast_visitMember324);
  meth_meth_ast_visitMember324->definitionModule = modulename;
  meth_meth_ast_visitMember324->definitionLine = 2778;
// method visitGeneric
  struct UserObject *uo326 = (struct UserObject*)obj199;
  uo326->data[48] = emptyclosure;
  Method *meth_meth_ast_visitGeneric326 = addmethod2pos(obj199, "visitGeneric", &meth_ast_visitGeneric326, 48);
  int argcv_meth_ast_visitGeneric326[] = {1};
  meth_meth_ast_visitGeneric326->type = alloc_MethodType(1, argcv_meth_ast_visitGeneric326);
  meth_meth_ast_visitGeneric326->definitionModule = modulename;
  meth_meth_ast_visitGeneric326->definitionLine = 2779;
// method visitIdentifier
  struct UserObject *uo328 = (struct UserObject*)obj199;
  uo328->data[49] = emptyclosure;
  Method *meth_meth_ast_visitIdentifier328 = addmethod2pos(obj199, "visitIdentifier", &meth_ast_visitIdentifier328, 49);
  int argcv_meth_ast_visitIdentifier328[] = {1};
  meth_meth_ast_visitIdentifier328->type = alloc_MethodType(1, argcv_meth_ast_visitIdentifier328);
  meth_meth_ast_visitIdentifier328->definitionModule = modulename;
  meth_meth_ast_visitIdentifier328->definitionLine = 2780;
// method visitString
  struct UserObject *uo330 = (struct UserObject*)obj199;
  uo330->data[50] = emptyclosure;
  Method *meth_meth_ast_visitString330 = addmethod2pos(obj199, "visitString", &meth_ast_visitString330, 50);
  int argcv_meth_ast_visitString330[] = {1};
  meth_meth_ast_visitString330->type = alloc_MethodType(1, argcv_meth_ast_visitString330);
  meth_meth_ast_visitString330->definitionModule = modulename;
  meth_meth_ast_visitString330->definitionLine = 2781;
// method visitNum
  struct UserObject *uo332 = (struct UserObject*)obj199;
  uo332->data[51] = emptyclosure;
  Method *meth_meth_ast_visitNum332 = addmethod2pos(obj199, "visitNum", &meth_ast_visitNum332, 51);
  int argcv_meth_ast_visitNum332[] = {1};
  meth_meth_ast_visitNum332->type = alloc_MethodType(1, argcv_meth_ast_visitNum332);
  meth_meth_ast_visitNum332->definitionModule = modulename;
  meth_meth_ast_visitNum332->definitionLine = 2782;
// method visitOp
  struct UserObject *uo334 = (struct UserObject*)obj199;
  uo334->data[52] = emptyclosure;
  Method *meth_meth_ast_visitOp334 = addmethod2pos(obj199, "visitOp", &meth_ast_visitOp334, 52);
  int argcv_meth_ast_visitOp334[] = {1};
  meth_meth_ast_visitOp334->type = alloc_MethodType(1, argcv_meth_ast_visitOp334);
  meth_meth_ast_visitOp334->definitionModule = modulename;
  meth_meth_ast_visitOp334->definitionLine = 2783;
// method visitIndex
  struct UserObject *uo336 = (struct UserObject*)obj199;
  uo336->data[53] = emptyclosure;
  Method *meth_meth_ast_visitIndex336 = addmethod2pos(obj199, "visitIndex", &meth_ast_visitIndex336, 53);
  int argcv_meth_ast_visitIndex336[] = {1};
  meth_meth_ast_visitIndex336->type = alloc_MethodType(1, argcv_meth_ast_visitIndex336);
  meth_meth_ast_visitIndex336->definitionModule = modulename;
  meth_meth_ast_visitIndex336->definitionLine = 2784;
// method visitBind
  struct UserObject *uo338 = (struct UserObject*)obj199;
  uo338->data[54] = emptyclosure;
  Method *meth_meth_ast_visitBind338 = addmethod2pos(obj199, "visitBind", &meth_ast_visitBind338, 54);
  int argcv_meth_ast_visitBind338[] = {1};
  meth_meth_ast_visitBind338->type = alloc_MethodType(1, argcv_meth_ast_visitBind338);
  meth_meth_ast_visitBind338->definitionModule = modulename;
  meth_meth_ast_visitBind338->definitionLine = 2785;
// method visitDefDec
  struct UserObject *uo340 = (struct UserObject*)obj199;
  uo340->data[55] = emptyclosure;
  Method *meth_meth_ast_visitDefDec340 = addmethod2pos(obj199, "visitDefDec", &meth_ast_visitDefDec340, 55);
  int argcv_meth_ast_visitDefDec340[] = {1};
  meth_meth_ast_visitDefDec340->type = alloc_MethodType(1, argcv_meth_ast_visitDefDec340);
  meth_meth_ast_visitDefDec340->definitionModule = modulename;
  meth_meth_ast_visitDefDec340->definitionLine = 2786;
// method visitVarDec
  struct UserObject *uo342 = (struct UserObject*)obj199;
  uo342->data[56] = emptyclosure;
  Method *meth_meth_ast_visitVarDec342 = addmethod2pos(obj199, "visitVarDec", &meth_ast_visitVarDec342, 56);
  int argcv_meth_ast_visitVarDec342[] = {1};
  meth_meth_ast_visitVarDec342->type = alloc_MethodType(1, argcv_meth_ast_visitVarDec342);
  meth_meth_ast_visitVarDec342->definitionModule = modulename;
  meth_meth_ast_visitVarDec342->definitionLine = 2787;
// method visitImport
  struct UserObject *uo344 = (struct UserObject*)obj199;
  uo344->data[57] = emptyclosure;
  Method *meth_meth_ast_visitImport344 = addmethod2pos(obj199, "visitImport", &meth_ast_visitImport344, 57);
  int argcv_meth_ast_visitImport344[] = {1};
  meth_meth_ast_visitImport344->type = alloc_MethodType(1, argcv_meth_ast_visitImport344);
  meth_meth_ast_visitImport344->definitionModule = modulename;
  meth_meth_ast_visitImport344->definitionLine = 2788;
// method visitReturn
  struct UserObject *uo346 = (struct UserObject*)obj199;
  uo346->data[58] = emptyclosure;
  Method *meth_meth_ast_visitReturn346 = addmethod2pos(obj199, "visitReturn", &meth_ast_visitReturn346, 58);
  int argcv_meth_ast_visitReturn346[] = {1};
  meth_meth_ast_visitReturn346->type = alloc_MethodType(1, argcv_meth_ast_visitReturn346);
  meth_meth_ast_visitReturn346->definitionModule = modulename;
  meth_meth_ast_visitReturn346->definitionLine = 2789;
// method visitInherits
  struct UserObject *uo348 = (struct UserObject*)obj199;
  uo348->data[59] = emptyclosure;
  Method *meth_meth_ast_visitInherits348 = addmethod2pos(obj199, "visitInherits", &meth_ast_visitInherits348, 59);
  int argcv_meth_ast_visitInherits348[] = {1};
  meth_meth_ast_visitInherits348->type = alloc_MethodType(1, argcv_meth_ast_visitInherits348);
  meth_meth_ast_visitInherits348->definitionModule = modulename;
  meth_meth_ast_visitInherits348->definitionLine = 2790;
// method visitDialect
  struct UserObject *uo350 = (struct UserObject*)obj199;
  uo350->data[60] = emptyclosure;
  Method *meth_meth_ast_visitDialect350 = addmethod2pos(obj199, "visitDialect", &meth_ast_visitDialect350, 60);
  int argcv_meth_ast_visitDialect350[] = {1};
  meth_meth_ast_visitDialect350->type = alloc_MethodType(1, argcv_meth_ast_visitDialect350);
  meth_meth_ast_visitDialect350->definitionModule = modulename;
  meth_meth_ast_visitDialect350->definitionLine = 2791;
// method visitBlank
  struct UserObject *uo352 = (struct UserObject*)obj199;
  uo352->data[61] = emptyclosure;
  Method *meth_meth_ast_visitBlank352 = addmethod2pos(obj199, "visitBlank", &meth_ast_visitBlank352, 61);
  int argcv_meth_ast_visitBlank352[] = {1};
  meth_meth_ast_visitBlank352->type = alloc_MethodType(1, argcv_meth_ast_visitBlank352);
  meth_meth_ast_visitBlank352->definitionModule = modulename;
  meth_meth_ast_visitBlank352->definitionLine = 2792;
// method visitComment
  struct UserObject *uo354 = (struct UserObject*)obj199;
  uo354->data[62] = emptyclosure;
  Method *meth_meth_ast_visitComment354 = addmethod2pos(obj199, "visitComment", &meth_ast_visitComment354, 62);
  int argcv_meth_ast_visitComment354[] = {1};
  meth_meth_ast_visitComment354->type = alloc_MethodType(1, argcv_meth_ast_visitComment354);
  meth_meth_ast_visitComment354->definitionModule = modulename;
  meth_meth_ast_visitComment354->definitionLine = 2793;
// method asString
  struct UserObject *uo356 = (struct UserObject*)obj199;
  uo356->data[63] = emptyclosure;
  Method *meth_meth_ast_asString356 = addmethod2pos(obj199, "asString", &meth_ast_asString356, 63);
  int argcv_meth_ast_asString356[] = {0};
  meth_meth_ast_asString356->type = alloc_MethodType(1, argcv_meth_ast_asString356);
  meth_meth_ast_asString356->definitionModule = modulename;
  meth_meth_ast_asString356->definitionLine = 2795;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  sourceObject = obj199;
  objclass199 = obj199->class;
  objclass199->definitionModule = modulename;
  objclass199->definitionLine = 2730;
  (*(struct UserObject *)self).data[0] = lowerouter199;
  self = oldself199;
  selfslot = oldselfslot199;
  stackframe = oldstackframe199;
  gc_frame_end(frame);
  return obj199;
}
Object meth_ast_visitIf_40__41_up362(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitIf()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitIf()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitIf()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitIf()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitIf");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2805
  setline(2805);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe363 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call364 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe363);
// compiled call node returning call364 (depth = 2)
  gc_frame_end(frame);
  return call364;
}
Object meth_ast_visitBlock_40__41_up365(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitBlock()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitBlock()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitBlock()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitBlock()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitBlock");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2806
  setline(2806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe366 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call367 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe366);
// compiled call node returning call367 (depth = 2)
  gc_frame_end(frame);
  return call367;
}
Object meth_ast_visitMatchCase_40__41_up368(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitMatchCase()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitMatchCase()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitMatchCase()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitMatchCase()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitMatchCase");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2807
  setline(2807);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe369 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call370 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe369);
// compiled call node returning call370 (depth = 2)
  gc_frame_end(frame);
  return call370;
}
Object meth_ast_visitCatchCase_40__41_up371(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitCatchCase()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitCatchCase()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitCatchCase()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitCatchCase()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitCatchCase");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2808
  setline(2808);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe372 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call373 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe372);
// compiled call node returning call373 (depth = 2)
  gc_frame_end(frame);
  return call373;
}
Object meth_ast_visitMethodType_40__41_up374(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitMethodType()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitMethodType()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitMethodType()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitMethodType()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitMethodType");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2809
  setline(2809);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe375 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call376 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe375);
// compiled call node returning call376 (depth = 2)
  gc_frame_end(frame);
  return call376;
}
Object meth_ast_visitSignaturePart_40__41_up377(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitSignaturePart()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitSignaturePart()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitSignaturePart()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitSignaturePart()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitSignaturePart");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2810
  setline(2810);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe378 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call379 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe378);
// compiled call node returning call379 (depth = 2)
  gc_frame_end(frame);
  return call379;
}
Object meth_ast_visitTypeDec_40__41_up380(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitTypeDec()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitTypeDec()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitTypeDec()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitTypeDec()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitTypeDec");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2811
  setline(2811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe381 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call382 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe381);
// compiled call node returning call382 (depth = 2)
  gc_frame_end(frame);
  return call382;
}
Object meth_ast_visitTypeLiteral_40__41_up383(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitTypeLiteral()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitTypeLiteral()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitTypeLiteral()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitTypeLiteral()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitTypeLiteral");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2812
  setline(2812);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe384 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call385 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe384);
// compiled call node returning call385 (depth = 2)
  gc_frame_end(frame);
  return call385;
}
Object meth_ast_visitMethod_40__41_up386(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitMethod()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitMethod()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitMethod()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitMethod()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitMethod");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2813
  setline(2813);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe387 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call388 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe387);
// compiled call node returning call388 (depth = 2)
  gc_frame_end(frame);
  return call388;
}
Object meth_ast_visitCall_40__41_up389(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitCall()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitCall()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitCall()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitCall()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitCall");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2814
  setline(2814);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe390 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call391 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe390);
// compiled call node returning call391 (depth = 2)
  gc_frame_end(frame);
  return call391;
}
Object meth_ast_visitClass_40__41_up392(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitClass()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitClass()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitClass()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitClass()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitClass");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2815
  setline(2815);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe393 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call394 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe393);
// compiled call node returning call394 (depth = 2)
  gc_frame_end(frame);
  return call394;
}
Object meth_ast_visitObject_40__41_up395(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitObject()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitObject()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitObject()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitObject()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitObject");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2816
  setline(2816);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe396 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call397 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe396);
// compiled call node returning call397 (depth = 2)
  gc_frame_end(frame);
  return call397;
}
Object meth_ast_visitModule_40__41_up398(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitModule()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitModule()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitModule()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitModule()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitModule");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2817
  setline(2817);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe399 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call400 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe399);
// compiled call node returning call400 (depth = 2)
  gc_frame_end(frame);
  return call400;
}
Object meth_ast_visitArray_40__41_up401(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitArray()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitArray()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitArray()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitArray()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitArray");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2818
  setline(2818);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe402 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call403 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe402);
// compiled call node returning call403 (depth = 2)
  gc_frame_end(frame);
  return call403;
}
Object meth_ast_visitMember_40__41_up404(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitMember()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitMember()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitMember()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitMember()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitMember");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2819
  setline(2819);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe405 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call406 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe405);
// compiled call node returning call406 (depth = 2)
  gc_frame_end(frame);
  return call406;
}
Object meth_ast_visitGeneric_40__41_up407(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitGeneric()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitGeneric()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitGeneric()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitGeneric()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitGeneric");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2820
  setline(2820);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe408 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call409 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe408);
// compiled call node returning call409 (depth = 2)
  gc_frame_end(frame);
  return call409;
}
Object meth_ast_visitIdentifier_40__41_up410(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 17, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitIdentifier()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitIdentifier()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitIdentifier()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitIdentifier()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitIdentifier");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2821
  setline(2821);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe411 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call412 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe411);
// compiled call node returning call412 (depth = 2)
  gc_frame_end(frame);
  return call412;
}
Object meth_ast_visitString_40__41_up413(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 18, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitString()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitString()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitString()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitString()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitString");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2822
  setline(2822);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe414 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call415 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe414);
// compiled call node returning call415 (depth = 2)
  gc_frame_end(frame);
  return call415;
}
Object meth_ast_visitNum_40__41_up416(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitNum()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitNum()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitNum()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitNum()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitNum");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2823
  setline(2823);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe417 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call418 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe417);
// compiled call node returning call418 (depth = 2)
  gc_frame_end(frame);
  return call418;
}
Object meth_ast_visitOp_40__41_up419(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitOp()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitOp()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitOp()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitOp()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitOp");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2824
  setline(2824);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe420 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call421 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe420);
// compiled call node returning call421 (depth = 2)
  gc_frame_end(frame);
  return call421;
}
Object meth_ast_visitIndex_40__41_up422(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitIndex()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitIndex()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitIndex()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitIndex()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitIndex");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2825
  setline(2825);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe423 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call424 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe423);
// compiled call node returning call424 (depth = 2)
  gc_frame_end(frame);
  return call424;
}
Object meth_ast_visitBind_40__41_up425(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 22, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitBind()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitBind()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitBind()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitBind()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitBind");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2826
  setline(2826);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe426 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call427 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe426);
// compiled call node returning call427 (depth = 2)
  gc_frame_end(frame);
  return call427;
}
Object meth_ast_visitDefDec_40__41_up428(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 23, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitDefDec()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitDefDec()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitDefDec()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitDefDec()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitDefDec");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2827
  setline(2827);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe429 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call430 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe429);
// compiled call node returning call430 (depth = 2)
  gc_frame_end(frame);
  return call430;
}
Object meth_ast_visitVarDec_40__41_up431(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 24, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitVarDec()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitVarDec()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitVarDec()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitVarDec()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitVarDec");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2828
  setline(2828);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe432 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call433 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe432);
// compiled call node returning call433 (depth = 2)
  gc_frame_end(frame);
  return call433;
}
Object meth_ast_visitImport_40__41_up434(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 25, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitImport()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitImport()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitImport()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitImport()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitImport");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2829
  setline(2829);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe435 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call436 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe435);
// compiled call node returning call436 (depth = 2)
  gc_frame_end(frame);
  return call436;
}
Object meth_ast_visitReturn_40__41_up437(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 26, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitReturn()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitReturn()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitReturn()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitReturn()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitReturn");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2830
  setline(2830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe438 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call439 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe438);
// compiled call node returning call439 (depth = 2)
  gc_frame_end(frame);
  return call439;
}
Object meth_ast_visitInherits_40__41_up440(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 27, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitInherits()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitInherits()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitInherits()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitInherits()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitInherits");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2831
  setline(2831);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe441 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call442 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe441);
// compiled call node returning call442 (depth = 2)
  gc_frame_end(frame);
  return call442;
}
Object meth_ast_visitDialect_40__41_up443(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 28, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitDialect()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitDialect()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitDialect()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitDialect()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitDialect");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2832
  setline(2832);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe444 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call445 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe444);
// compiled call node returning call445 (depth = 2)
  gc_frame_end(frame);
  return call445;
}
Object meth_ast_visitBlank_40__41_up446(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 29, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitBlank()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitBlank()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitBlank()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitBlank()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitBlank");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2833
  setline(2833);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe447 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call448 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe447);
// compiled call node returning call448 (depth = 2)
  gc_frame_end(frame);
  return call448;
}
Object meth_ast_visitComment_40__41_up449(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 30, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitComment()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitComment()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitComment()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitComment()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitComment");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2834
  setline(2834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe450 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call451 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe450);
// compiled call node returning call451 (depth = 2)
  gc_frame_end(frame);
  return call451;
}
Object meth_ast_asString452(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2836
  setline(2836);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit453 == NULL) {
    strlit453 = alloc_String("a pluggable AST visitor");
    gc_root(strlit453);
  }
// compiled string node returning strlit453 (depth = 2)
  gc_frame_end(frame);
  return strlit453;
}
Object meth_ast_pluggableVisitor359(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pluggableVisitor");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pluggableVisitor");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pluggableVisitor (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitation = &(stackframe->slots[0]);
  *var_visitation = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pluggableVisitor");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject360 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj360 = alloc_userobj2(31,32, objclass360);
  gc_frame_newslot(obj360);
if (objclass360 == NULL) {
  glfree(obj360->class->name);
  obj360->class->name = "self.pluggableVisitor";
}
// OBJECT OUTER DEC outer
  adddatum2(obj360, self, 0);
  addmethodreal(obj360,"outer", &reader_ast_outer_361);
  Object oldself360 = self;
  struct StackFrameObject *oldstackframe360 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe360);
  gc_frame_newslot((Object)stackframe);
  self = obj360;
  Object *oldselfslot360 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter360 = (*(struct UserObject *)self).data[0], lowerouter360 = thisouter360;
  if (inheritingObject360) {
    struct UserObject *inho360 = (struct UserObject *)inheritingObject360;
    while (inho360->super != GraceDefaultObject) inho360 = (struct UserObject *)inho360->super;
    inho360->super = obj360;
    self = inheritingObject360;
    *selfslot = self;
    lowerouter360 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter360;
  }
// method visitIf()up
  block_savedest(obj360);
  Object closure362 = createclosure(1, "visitIf()up");
  setclosureframe(closure362, stackframe);
  addtoclosure(closure362, var_visitation);
  struct UserObject *uo362 = (struct UserObject*)obj360;
  uo362->data[1] = (Object)closure362;
  Method *meth_meth_ast_visitIf_40__41_up362 = addmethod2pos(obj360, "visitIf()up", &meth_ast_visitIf_40__41_up362, 1);
  int argcv_meth_ast_visitIf_40__41_up362[] = {1, 1};
  meth_meth_ast_visitIf_40__41_up362->type = alloc_MethodType(2, argcv_meth_ast_visitIf_40__41_up362);
  meth_meth_ast_visitIf_40__41_up362->definitionModule = modulename;
  meth_meth_ast_visitIf_40__41_up362->definitionLine = 2805;
// method visitBlock()up
  block_savedest(obj360);
  Object closure365 = createclosure(1, "visitBlock()up");
  setclosureframe(closure365, stackframe);
  addtoclosure(closure365, var_visitation);
  struct UserObject *uo365 = (struct UserObject*)obj360;
  uo365->data[2] = (Object)closure365;
  Method *meth_meth_ast_visitBlock_40__41_up365 = addmethod2pos(obj360, "visitBlock()up", &meth_ast_visitBlock_40__41_up365, 2);
  int argcv_meth_ast_visitBlock_40__41_up365[] = {1, 1};
  meth_meth_ast_visitBlock_40__41_up365->type = alloc_MethodType(2, argcv_meth_ast_visitBlock_40__41_up365);
  meth_meth_ast_visitBlock_40__41_up365->definitionModule = modulename;
  meth_meth_ast_visitBlock_40__41_up365->definitionLine = 2806;
// method visitMatchCase()up
  block_savedest(obj360);
  Object closure368 = createclosure(1, "visitMatchCase()up");
  setclosureframe(closure368, stackframe);
  addtoclosure(closure368, var_visitation);
  struct UserObject *uo368 = (struct UserObject*)obj360;
  uo368->data[3] = (Object)closure368;
  Method *meth_meth_ast_visitMatchCase_40__41_up368 = addmethod2pos(obj360, "visitMatchCase()up", &meth_ast_visitMatchCase_40__41_up368, 3);
  int argcv_meth_ast_visitMatchCase_40__41_up368[] = {1, 1};
  meth_meth_ast_visitMatchCase_40__41_up368->type = alloc_MethodType(2, argcv_meth_ast_visitMatchCase_40__41_up368);
  meth_meth_ast_visitMatchCase_40__41_up368->definitionModule = modulename;
  meth_meth_ast_visitMatchCase_40__41_up368->definitionLine = 2807;
// method visitCatchCase()up
  block_savedest(obj360);
  Object closure371 = createclosure(1, "visitCatchCase()up");
  setclosureframe(closure371, stackframe);
  addtoclosure(closure371, var_visitation);
  struct UserObject *uo371 = (struct UserObject*)obj360;
  uo371->data[4] = (Object)closure371;
  Method *meth_meth_ast_visitCatchCase_40__41_up371 = addmethod2pos(obj360, "visitCatchCase()up", &meth_ast_visitCatchCase_40__41_up371, 4);
  int argcv_meth_ast_visitCatchCase_40__41_up371[] = {1, 1};
  meth_meth_ast_visitCatchCase_40__41_up371->type = alloc_MethodType(2, argcv_meth_ast_visitCatchCase_40__41_up371);
  meth_meth_ast_visitCatchCase_40__41_up371->definitionModule = modulename;
  meth_meth_ast_visitCatchCase_40__41_up371->definitionLine = 2808;
// method visitMethodType()up
  block_savedest(obj360);
  Object closure374 = createclosure(1, "visitMethodType()up");
  setclosureframe(closure374, stackframe);
  addtoclosure(closure374, var_visitation);
  struct UserObject *uo374 = (struct UserObject*)obj360;
  uo374->data[5] = (Object)closure374;
  Method *meth_meth_ast_visitMethodType_40__41_up374 = addmethod2pos(obj360, "visitMethodType()up", &meth_ast_visitMethodType_40__41_up374, 5);
  int argcv_meth_ast_visitMethodType_40__41_up374[] = {1, 1};
  meth_meth_ast_visitMethodType_40__41_up374->type = alloc_MethodType(2, argcv_meth_ast_visitMethodType_40__41_up374);
  meth_meth_ast_visitMethodType_40__41_up374->definitionModule = modulename;
  meth_meth_ast_visitMethodType_40__41_up374->definitionLine = 2809;
// method visitSignaturePart()up
  block_savedest(obj360);
  Object closure377 = createclosure(1, "visitSignaturePart()up");
  setclosureframe(closure377, stackframe);
  addtoclosure(closure377, var_visitation);
  struct UserObject *uo377 = (struct UserObject*)obj360;
  uo377->data[6] = (Object)closure377;
  Method *meth_meth_ast_visitSignaturePart_40__41_up377 = addmethod2pos(obj360, "visitSignaturePart()up", &meth_ast_visitSignaturePart_40__41_up377, 6);
  int argcv_meth_ast_visitSignaturePart_40__41_up377[] = {1, 1};
  meth_meth_ast_visitSignaturePart_40__41_up377->type = alloc_MethodType(2, argcv_meth_ast_visitSignaturePart_40__41_up377);
  meth_meth_ast_visitSignaturePart_40__41_up377->definitionModule = modulename;
  meth_meth_ast_visitSignaturePart_40__41_up377->definitionLine = 2810;
// method visitTypeDec()up
  block_savedest(obj360);
  Object closure380 = createclosure(1, "visitTypeDec()up");
  setclosureframe(closure380, stackframe);
  addtoclosure(closure380, var_visitation);
  struct UserObject *uo380 = (struct UserObject*)obj360;
  uo380->data[7] = (Object)closure380;
  Method *meth_meth_ast_visitTypeDec_40__41_up380 = addmethod2pos(obj360, "visitTypeDec()up", &meth_ast_visitTypeDec_40__41_up380, 7);
  int argcv_meth_ast_visitTypeDec_40__41_up380[] = {1, 1};
  meth_meth_ast_visitTypeDec_40__41_up380->type = alloc_MethodType(2, argcv_meth_ast_visitTypeDec_40__41_up380);
  meth_meth_ast_visitTypeDec_40__41_up380->definitionModule = modulename;
  meth_meth_ast_visitTypeDec_40__41_up380->definitionLine = 2811;
// method visitTypeLiteral()up
  block_savedest(obj360);
  Object closure383 = createclosure(1, "visitTypeLiteral()up");
  setclosureframe(closure383, stackframe);
  addtoclosure(closure383, var_visitation);
  struct UserObject *uo383 = (struct UserObject*)obj360;
  uo383->data[8] = (Object)closure383;
  Method *meth_meth_ast_visitTypeLiteral_40__41_up383 = addmethod2pos(obj360, "visitTypeLiteral()up", &meth_ast_visitTypeLiteral_40__41_up383, 8);
  int argcv_meth_ast_visitTypeLiteral_40__41_up383[] = {1, 1};
  meth_meth_ast_visitTypeLiteral_40__41_up383->type = alloc_MethodType(2, argcv_meth_ast_visitTypeLiteral_40__41_up383);
  meth_meth_ast_visitTypeLiteral_40__41_up383->definitionModule = modulename;
  meth_meth_ast_visitTypeLiteral_40__41_up383->definitionLine = 2812;
// method visitMethod()up
  block_savedest(obj360);
  Object closure386 = createclosure(1, "visitMethod()up");
  setclosureframe(closure386, stackframe);
  addtoclosure(closure386, var_visitation);
  struct UserObject *uo386 = (struct UserObject*)obj360;
  uo386->data[9] = (Object)closure386;
  Method *meth_meth_ast_visitMethod_40__41_up386 = addmethod2pos(obj360, "visitMethod()up", &meth_ast_visitMethod_40__41_up386, 9);
  int argcv_meth_ast_visitMethod_40__41_up386[] = {1, 1};
  meth_meth_ast_visitMethod_40__41_up386->type = alloc_MethodType(2, argcv_meth_ast_visitMethod_40__41_up386);
  meth_meth_ast_visitMethod_40__41_up386->definitionModule = modulename;
  meth_meth_ast_visitMethod_40__41_up386->definitionLine = 2813;
// method visitCall()up
  block_savedest(obj360);
  Object closure389 = createclosure(1, "visitCall()up");
  setclosureframe(closure389, stackframe);
  addtoclosure(closure389, var_visitation);
  struct UserObject *uo389 = (struct UserObject*)obj360;
  uo389->data[10] = (Object)closure389;
  Method *meth_meth_ast_visitCall_40__41_up389 = addmethod2pos(obj360, "visitCall()up", &meth_ast_visitCall_40__41_up389, 10);
  int argcv_meth_ast_visitCall_40__41_up389[] = {1, 1};
  meth_meth_ast_visitCall_40__41_up389->type = alloc_MethodType(2, argcv_meth_ast_visitCall_40__41_up389);
  meth_meth_ast_visitCall_40__41_up389->definitionModule = modulename;
  meth_meth_ast_visitCall_40__41_up389->definitionLine = 2814;
// method visitClass()up
  block_savedest(obj360);
  Object closure392 = createclosure(1, "visitClass()up");
  setclosureframe(closure392, stackframe);
  addtoclosure(closure392, var_visitation);
  struct UserObject *uo392 = (struct UserObject*)obj360;
  uo392->data[11] = (Object)closure392;
  Method *meth_meth_ast_visitClass_40__41_up392 = addmethod2pos(obj360, "visitClass()up", &meth_ast_visitClass_40__41_up392, 11);
  int argcv_meth_ast_visitClass_40__41_up392[] = {1, 1};
  meth_meth_ast_visitClass_40__41_up392->type = alloc_MethodType(2, argcv_meth_ast_visitClass_40__41_up392);
  meth_meth_ast_visitClass_40__41_up392->definitionModule = modulename;
  meth_meth_ast_visitClass_40__41_up392->definitionLine = 2815;
// method visitObject()up
  block_savedest(obj360);
  Object closure395 = createclosure(1, "visitObject()up");
  setclosureframe(closure395, stackframe);
  addtoclosure(closure395, var_visitation);
  struct UserObject *uo395 = (struct UserObject*)obj360;
  uo395->data[12] = (Object)closure395;
  Method *meth_meth_ast_visitObject_40__41_up395 = addmethod2pos(obj360, "visitObject()up", &meth_ast_visitObject_40__41_up395, 12);
  int argcv_meth_ast_visitObject_40__41_up395[] = {1, 1};
  meth_meth_ast_visitObject_40__41_up395->type = alloc_MethodType(2, argcv_meth_ast_visitObject_40__41_up395);
  meth_meth_ast_visitObject_40__41_up395->definitionModule = modulename;
  meth_meth_ast_visitObject_40__41_up395->definitionLine = 2816;
// method visitModule()up
  block_savedest(obj360);
  Object closure398 = createclosure(1, "visitModule()up");
  setclosureframe(closure398, stackframe);
  addtoclosure(closure398, var_visitation);
  struct UserObject *uo398 = (struct UserObject*)obj360;
  uo398->data[13] = (Object)closure398;
  Method *meth_meth_ast_visitModule_40__41_up398 = addmethod2pos(obj360, "visitModule()up", &meth_ast_visitModule_40__41_up398, 13);
  int argcv_meth_ast_visitModule_40__41_up398[] = {1, 1};
  meth_meth_ast_visitModule_40__41_up398->type = alloc_MethodType(2, argcv_meth_ast_visitModule_40__41_up398);
  meth_meth_ast_visitModule_40__41_up398->definitionModule = modulename;
  meth_meth_ast_visitModule_40__41_up398->definitionLine = 2817;
// method visitArray()up
  block_savedest(obj360);
  Object closure401 = createclosure(1, "visitArray()up");
  setclosureframe(closure401, stackframe);
  addtoclosure(closure401, var_visitation);
  struct UserObject *uo401 = (struct UserObject*)obj360;
  uo401->data[14] = (Object)closure401;
  Method *meth_meth_ast_visitArray_40__41_up401 = addmethod2pos(obj360, "visitArray()up", &meth_ast_visitArray_40__41_up401, 14);
  int argcv_meth_ast_visitArray_40__41_up401[] = {1, 1};
  meth_meth_ast_visitArray_40__41_up401->type = alloc_MethodType(2, argcv_meth_ast_visitArray_40__41_up401);
  meth_meth_ast_visitArray_40__41_up401->definitionModule = modulename;
  meth_meth_ast_visitArray_40__41_up401->definitionLine = 2818;
// method visitMember()up
  block_savedest(obj360);
  Object closure404 = createclosure(1, "visitMember()up");
  setclosureframe(closure404, stackframe);
  addtoclosure(closure404, var_visitation);
  struct UserObject *uo404 = (struct UserObject*)obj360;
  uo404->data[15] = (Object)closure404;
  Method *meth_meth_ast_visitMember_40__41_up404 = addmethod2pos(obj360, "visitMember()up", &meth_ast_visitMember_40__41_up404, 15);
  int argcv_meth_ast_visitMember_40__41_up404[] = {1, 1};
  meth_meth_ast_visitMember_40__41_up404->type = alloc_MethodType(2, argcv_meth_ast_visitMember_40__41_up404);
  meth_meth_ast_visitMember_40__41_up404->definitionModule = modulename;
  meth_meth_ast_visitMember_40__41_up404->definitionLine = 2819;
// method visitGeneric()up
  block_savedest(obj360);
  Object closure407 = createclosure(1, "visitGeneric()up");
  setclosureframe(closure407, stackframe);
  addtoclosure(closure407, var_visitation);
  struct UserObject *uo407 = (struct UserObject*)obj360;
  uo407->data[16] = (Object)closure407;
  Method *meth_meth_ast_visitGeneric_40__41_up407 = addmethod2pos(obj360, "visitGeneric()up", &meth_ast_visitGeneric_40__41_up407, 16);
  int argcv_meth_ast_visitGeneric_40__41_up407[] = {1, 1};
  meth_meth_ast_visitGeneric_40__41_up407->type = alloc_MethodType(2, argcv_meth_ast_visitGeneric_40__41_up407);
  meth_meth_ast_visitGeneric_40__41_up407->definitionModule = modulename;
  meth_meth_ast_visitGeneric_40__41_up407->definitionLine = 2820;
// method visitIdentifier()up
  block_savedest(obj360);
  Object closure410 = createclosure(1, "visitIdentifier()up");
  setclosureframe(closure410, stackframe);
  addtoclosure(closure410, var_visitation);
  struct UserObject *uo410 = (struct UserObject*)obj360;
  uo410->data[17] = (Object)closure410;
  Method *meth_meth_ast_visitIdentifier_40__41_up410 = addmethod2pos(obj360, "visitIdentifier()up", &meth_ast_visitIdentifier_40__41_up410, 17);
  int argcv_meth_ast_visitIdentifier_40__41_up410[] = {1, 1};
  meth_meth_ast_visitIdentifier_40__41_up410->type = alloc_MethodType(2, argcv_meth_ast_visitIdentifier_40__41_up410);
  meth_meth_ast_visitIdentifier_40__41_up410->definitionModule = modulename;
  meth_meth_ast_visitIdentifier_40__41_up410->definitionLine = 2821;
// method visitString()up
  block_savedest(obj360);
  Object closure413 = createclosure(1, "visitString()up");
  setclosureframe(closure413, stackframe);
  addtoclosure(closure413, var_visitation);
  struct UserObject *uo413 = (struct UserObject*)obj360;
  uo413->data[18] = (Object)closure413;
  Method *meth_meth_ast_visitString_40__41_up413 = addmethod2pos(obj360, "visitString()up", &meth_ast_visitString_40__41_up413, 18);
  int argcv_meth_ast_visitString_40__41_up413[] = {1, 1};
  meth_meth_ast_visitString_40__41_up413->type = alloc_MethodType(2, argcv_meth_ast_visitString_40__41_up413);
  meth_meth_ast_visitString_40__41_up413->definitionModule = modulename;
  meth_meth_ast_visitString_40__41_up413->definitionLine = 2822;
// method visitNum()up
  block_savedest(obj360);
  Object closure416 = createclosure(1, "visitNum()up");
  setclosureframe(closure416, stackframe);
  addtoclosure(closure416, var_visitation);
  struct UserObject *uo416 = (struct UserObject*)obj360;
  uo416->data[19] = (Object)closure416;
  Method *meth_meth_ast_visitNum_40__41_up416 = addmethod2pos(obj360, "visitNum()up", &meth_ast_visitNum_40__41_up416, 19);
  int argcv_meth_ast_visitNum_40__41_up416[] = {1, 1};
  meth_meth_ast_visitNum_40__41_up416->type = alloc_MethodType(2, argcv_meth_ast_visitNum_40__41_up416);
  meth_meth_ast_visitNum_40__41_up416->definitionModule = modulename;
  meth_meth_ast_visitNum_40__41_up416->definitionLine = 2823;
// method visitOp()up
  block_savedest(obj360);
  Object closure419 = createclosure(1, "visitOp()up");
  setclosureframe(closure419, stackframe);
  addtoclosure(closure419, var_visitation);
  struct UserObject *uo419 = (struct UserObject*)obj360;
  uo419->data[20] = (Object)closure419;
  Method *meth_meth_ast_visitOp_40__41_up419 = addmethod2pos(obj360, "visitOp()up", &meth_ast_visitOp_40__41_up419, 20);
  int argcv_meth_ast_visitOp_40__41_up419[] = {1, 1};
  meth_meth_ast_visitOp_40__41_up419->type = alloc_MethodType(2, argcv_meth_ast_visitOp_40__41_up419);
  meth_meth_ast_visitOp_40__41_up419->definitionModule = modulename;
  meth_meth_ast_visitOp_40__41_up419->definitionLine = 2824;
// method visitIndex()up
  block_savedest(obj360);
  Object closure422 = createclosure(1, "visitIndex()up");
  setclosureframe(closure422, stackframe);
  addtoclosure(closure422, var_visitation);
  struct UserObject *uo422 = (struct UserObject*)obj360;
  uo422->data[21] = (Object)closure422;
  Method *meth_meth_ast_visitIndex_40__41_up422 = addmethod2pos(obj360, "visitIndex()up", &meth_ast_visitIndex_40__41_up422, 21);
  int argcv_meth_ast_visitIndex_40__41_up422[] = {1, 1};
  meth_meth_ast_visitIndex_40__41_up422->type = alloc_MethodType(2, argcv_meth_ast_visitIndex_40__41_up422);
  meth_meth_ast_visitIndex_40__41_up422->definitionModule = modulename;
  meth_meth_ast_visitIndex_40__41_up422->definitionLine = 2825;
// method visitBind()up
  block_savedest(obj360);
  Object closure425 = createclosure(1, "visitBind()up");
  setclosureframe(closure425, stackframe);
  addtoclosure(closure425, var_visitation);
  struct UserObject *uo425 = (struct UserObject*)obj360;
  uo425->data[22] = (Object)closure425;
  Method *meth_meth_ast_visitBind_40__41_up425 = addmethod2pos(obj360, "visitBind()up", &meth_ast_visitBind_40__41_up425, 22);
  int argcv_meth_ast_visitBind_40__41_up425[] = {1, 1};
  meth_meth_ast_visitBind_40__41_up425->type = alloc_MethodType(2, argcv_meth_ast_visitBind_40__41_up425);
  meth_meth_ast_visitBind_40__41_up425->definitionModule = modulename;
  meth_meth_ast_visitBind_40__41_up425->definitionLine = 2826;
// method visitDefDec()up
  block_savedest(obj360);
  Object closure428 = createclosure(1, "visitDefDec()up");
  setclosureframe(closure428, stackframe);
  addtoclosure(closure428, var_visitation);
  struct UserObject *uo428 = (struct UserObject*)obj360;
  uo428->data[23] = (Object)closure428;
  Method *meth_meth_ast_visitDefDec_40__41_up428 = addmethod2pos(obj360, "visitDefDec()up", &meth_ast_visitDefDec_40__41_up428, 23);
  int argcv_meth_ast_visitDefDec_40__41_up428[] = {1, 1};
  meth_meth_ast_visitDefDec_40__41_up428->type = alloc_MethodType(2, argcv_meth_ast_visitDefDec_40__41_up428);
  meth_meth_ast_visitDefDec_40__41_up428->definitionModule = modulename;
  meth_meth_ast_visitDefDec_40__41_up428->definitionLine = 2827;
// method visitVarDec()up
  block_savedest(obj360);
  Object closure431 = createclosure(1, "visitVarDec()up");
  setclosureframe(closure431, stackframe);
  addtoclosure(closure431, var_visitation);
  struct UserObject *uo431 = (struct UserObject*)obj360;
  uo431->data[24] = (Object)closure431;
  Method *meth_meth_ast_visitVarDec_40__41_up431 = addmethod2pos(obj360, "visitVarDec()up", &meth_ast_visitVarDec_40__41_up431, 24);
  int argcv_meth_ast_visitVarDec_40__41_up431[] = {1, 1};
  meth_meth_ast_visitVarDec_40__41_up431->type = alloc_MethodType(2, argcv_meth_ast_visitVarDec_40__41_up431);
  meth_meth_ast_visitVarDec_40__41_up431->definitionModule = modulename;
  meth_meth_ast_visitVarDec_40__41_up431->definitionLine = 2828;
// method visitImport()up
  block_savedest(obj360);
  Object closure434 = createclosure(1, "visitImport()up");
  setclosureframe(closure434, stackframe);
  addtoclosure(closure434, var_visitation);
  struct UserObject *uo434 = (struct UserObject*)obj360;
  uo434->data[25] = (Object)closure434;
  Method *meth_meth_ast_visitImport_40__41_up434 = addmethod2pos(obj360, "visitImport()up", &meth_ast_visitImport_40__41_up434, 25);
  int argcv_meth_ast_visitImport_40__41_up434[] = {1, 1};
  meth_meth_ast_visitImport_40__41_up434->type = alloc_MethodType(2, argcv_meth_ast_visitImport_40__41_up434);
  meth_meth_ast_visitImport_40__41_up434->definitionModule = modulename;
  meth_meth_ast_visitImport_40__41_up434->definitionLine = 2829;
// method visitReturn()up
  block_savedest(obj360);
  Object closure437 = createclosure(1, "visitReturn()up");
  setclosureframe(closure437, stackframe);
  addtoclosure(closure437, var_visitation);
  struct UserObject *uo437 = (struct UserObject*)obj360;
  uo437->data[26] = (Object)closure437;
  Method *meth_meth_ast_visitReturn_40__41_up437 = addmethod2pos(obj360, "visitReturn()up", &meth_ast_visitReturn_40__41_up437, 26);
  int argcv_meth_ast_visitReturn_40__41_up437[] = {1, 1};
  meth_meth_ast_visitReturn_40__41_up437->type = alloc_MethodType(2, argcv_meth_ast_visitReturn_40__41_up437);
  meth_meth_ast_visitReturn_40__41_up437->definitionModule = modulename;
  meth_meth_ast_visitReturn_40__41_up437->definitionLine = 2830;
// method visitInherits()up
  block_savedest(obj360);
  Object closure440 = createclosure(1, "visitInherits()up");
  setclosureframe(closure440, stackframe);
  addtoclosure(closure440, var_visitation);
  struct UserObject *uo440 = (struct UserObject*)obj360;
  uo440->data[27] = (Object)closure440;
  Method *meth_meth_ast_visitInherits_40__41_up440 = addmethod2pos(obj360, "visitInherits()up", &meth_ast_visitInherits_40__41_up440, 27);
  int argcv_meth_ast_visitInherits_40__41_up440[] = {1, 1};
  meth_meth_ast_visitInherits_40__41_up440->type = alloc_MethodType(2, argcv_meth_ast_visitInherits_40__41_up440);
  meth_meth_ast_visitInherits_40__41_up440->definitionModule = modulename;
  meth_meth_ast_visitInherits_40__41_up440->definitionLine = 2831;
// method visitDialect()up
  block_savedest(obj360);
  Object closure443 = createclosure(1, "visitDialect()up");
  setclosureframe(closure443, stackframe);
  addtoclosure(closure443, var_visitation);
  struct UserObject *uo443 = (struct UserObject*)obj360;
  uo443->data[28] = (Object)closure443;
  Method *meth_meth_ast_visitDialect_40__41_up443 = addmethod2pos(obj360, "visitDialect()up", &meth_ast_visitDialect_40__41_up443, 28);
  int argcv_meth_ast_visitDialect_40__41_up443[] = {1, 1};
  meth_meth_ast_visitDialect_40__41_up443->type = alloc_MethodType(2, argcv_meth_ast_visitDialect_40__41_up443);
  meth_meth_ast_visitDialect_40__41_up443->definitionModule = modulename;
  meth_meth_ast_visitDialect_40__41_up443->definitionLine = 2832;
// method visitBlank()up
  block_savedest(obj360);
  Object closure446 = createclosure(1, "visitBlank()up");
  setclosureframe(closure446, stackframe);
  addtoclosure(closure446, var_visitation);
  struct UserObject *uo446 = (struct UserObject*)obj360;
  uo446->data[29] = (Object)closure446;
  Method *meth_meth_ast_visitBlank_40__41_up446 = addmethod2pos(obj360, "visitBlank()up", &meth_ast_visitBlank_40__41_up446, 29);
  int argcv_meth_ast_visitBlank_40__41_up446[] = {1, 1};
  meth_meth_ast_visitBlank_40__41_up446->type = alloc_MethodType(2, argcv_meth_ast_visitBlank_40__41_up446);
  meth_meth_ast_visitBlank_40__41_up446->definitionModule = modulename;
  meth_meth_ast_visitBlank_40__41_up446->definitionLine = 2833;
// method visitComment()up
  block_savedest(obj360);
  Object closure449 = createclosure(1, "visitComment()up");
  setclosureframe(closure449, stackframe);
  addtoclosure(closure449, var_visitation);
  struct UserObject *uo449 = (struct UserObject*)obj360;
  uo449->data[30] = (Object)closure449;
  Method *meth_meth_ast_visitComment_40__41_up449 = addmethod2pos(obj360, "visitComment()up", &meth_ast_visitComment_40__41_up449, 30);
  int argcv_meth_ast_visitComment_40__41_up449[] = {1, 1};
  meth_meth_ast_visitComment_40__41_up449->type = alloc_MethodType(2, argcv_meth_ast_visitComment_40__41_up449);
  meth_meth_ast_visitComment_40__41_up449->definitionModule = modulename;
  meth_meth_ast_visitComment_40__41_up449->definitionLine = 2834;
// method asString
  struct UserObject *uo452 = (struct UserObject*)obj360;
  uo452->data[31] = emptyclosure;
  Method *meth_meth_ast_asString452 = addmethod2pos(obj360, "asString", &meth_ast_asString452, 31);
  int argcv_meth_ast_asString452[] = {0};
  meth_meth_ast_asString452->type = alloc_MethodType(1, argcv_meth_ast_asString452);
  meth_meth_ast_asString452->definitionModule = modulename;
  meth_meth_ast_asString452->definitionLine = 2836;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  objclass360 = obj360->class;
  objclass360->definitionModule = modulename;
  objclass360->definitionLine = 2798;
  (*(struct UserObject *)self).data[0] = lowerouter360;
  self = oldself360;
  selfslot = oldselfslot360;
  stackframe = oldstackframe360;
  gc_frame_end(frame);
  return obj360;
}
Object meth_ast_pluggableVisitor359_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pluggableVisitor()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pluggableVisitor()object");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pluggableVisitor (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitation = &(stackframe->slots[0]);
  *var_visitation = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pluggableVisitor");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject360 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj360 = alloc_userobj2(31,32, objclass360);
  gc_frame_newslot(obj360);
if (objclass360 == NULL) {
  glfree(obj360->class->name);
  obj360->class->name = "self.pluggableVisitor";
}
// OBJECT OUTER DEC outer
  adddatum2(obj360, self, 0);
  addmethodreal(obj360,"outer", &reader_ast_outer_361);
  Object oldself360 = self;
  struct StackFrameObject *oldstackframe360 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe360);
  gc_frame_newslot((Object)stackframe);
  self = obj360;
  Object *oldselfslot360 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter360 = (*(struct UserObject *)self).data[0], lowerouter360 = thisouter360;
  if (inheritingObject360) {
    struct UserObject *inho360 = (struct UserObject *)inheritingObject360;
    while (inho360->super != GraceDefaultObject) inho360 = (struct UserObject *)inho360->super;
    inho360->super = obj360;
    self = inheritingObject360;
    *selfslot = self;
    lowerouter360 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter360;
  }
// method visitIf()up
  block_savedest(obj360);
  Object closure362 = createclosure(1, "visitIf()up");
  setclosureframe(closure362, stackframe);
  addtoclosure(closure362, var_visitation);
  struct UserObject *uo362 = (struct UserObject*)obj360;
  uo362->data[1] = (Object)closure362;
  Method *meth_meth_ast_visitIf_40__41_up362 = addmethod2pos(obj360, "visitIf()up", &meth_ast_visitIf_40__41_up362, 1);
  int argcv_meth_ast_visitIf_40__41_up362[] = {1, 1};
  meth_meth_ast_visitIf_40__41_up362->type = alloc_MethodType(2, argcv_meth_ast_visitIf_40__41_up362);
  meth_meth_ast_visitIf_40__41_up362->definitionModule = modulename;
  meth_meth_ast_visitIf_40__41_up362->definitionLine = 2805;
// method visitBlock()up
  block_savedest(obj360);
  Object closure365 = createclosure(1, "visitBlock()up");
  setclosureframe(closure365, stackframe);
  addtoclosure(closure365, var_visitation);
  struct UserObject *uo365 = (struct UserObject*)obj360;
  uo365->data[2] = (Object)closure365;
  Method *meth_meth_ast_visitBlock_40__41_up365 = addmethod2pos(obj360, "visitBlock()up", &meth_ast_visitBlock_40__41_up365, 2);
  int argcv_meth_ast_visitBlock_40__41_up365[] = {1, 1};
  meth_meth_ast_visitBlock_40__41_up365->type = alloc_MethodType(2, argcv_meth_ast_visitBlock_40__41_up365);
  meth_meth_ast_visitBlock_40__41_up365->definitionModule = modulename;
  meth_meth_ast_visitBlock_40__41_up365->definitionLine = 2806;
// method visitMatchCase()up
  block_savedest(obj360);
  Object closure368 = createclosure(1, "visitMatchCase()up");
  setclosureframe(closure368, stackframe);
  addtoclosure(closure368, var_visitation);
  struct UserObject *uo368 = (struct UserObject*)obj360;
  uo368->data[3] = (Object)closure368;
  Method *meth_meth_ast_visitMatchCase_40__41_up368 = addmethod2pos(obj360, "visitMatchCase()up", &meth_ast_visitMatchCase_40__41_up368, 3);
  int argcv_meth_ast_visitMatchCase_40__41_up368[] = {1, 1};
  meth_meth_ast_visitMatchCase_40__41_up368->type = alloc_MethodType(2, argcv_meth_ast_visitMatchCase_40__41_up368);
  meth_meth_ast_visitMatchCase_40__41_up368->definitionModule = modulename;
  meth_meth_ast_visitMatchCase_40__41_up368->definitionLine = 2807;
// method visitCatchCase()up
  block_savedest(obj360);
  Object closure371 = createclosure(1, "visitCatchCase()up");
  setclosureframe(closure371, stackframe);
  addtoclosure(closure371, var_visitation);
  struct UserObject *uo371 = (struct UserObject*)obj360;
  uo371->data[4] = (Object)closure371;
  Method *meth_meth_ast_visitCatchCase_40__41_up371 = addmethod2pos(obj360, "visitCatchCase()up", &meth_ast_visitCatchCase_40__41_up371, 4);
  int argcv_meth_ast_visitCatchCase_40__41_up371[] = {1, 1};
  meth_meth_ast_visitCatchCase_40__41_up371->type = alloc_MethodType(2, argcv_meth_ast_visitCatchCase_40__41_up371);
  meth_meth_ast_visitCatchCase_40__41_up371->definitionModule = modulename;
  meth_meth_ast_visitCatchCase_40__41_up371->definitionLine = 2808;
// method visitMethodType()up
  block_savedest(obj360);
  Object closure374 = createclosure(1, "visitMethodType()up");
  setclosureframe(closure374, stackframe);
  addtoclosure(closure374, var_visitation);
  struct UserObject *uo374 = (struct UserObject*)obj360;
  uo374->data[5] = (Object)closure374;
  Method *meth_meth_ast_visitMethodType_40__41_up374 = addmethod2pos(obj360, "visitMethodType()up", &meth_ast_visitMethodType_40__41_up374, 5);
  int argcv_meth_ast_visitMethodType_40__41_up374[] = {1, 1};
  meth_meth_ast_visitMethodType_40__41_up374->type = alloc_MethodType(2, argcv_meth_ast_visitMethodType_40__41_up374);
  meth_meth_ast_visitMethodType_40__41_up374->definitionModule = modulename;
  meth_meth_ast_visitMethodType_40__41_up374->definitionLine = 2809;
// method visitSignaturePart()up
  block_savedest(obj360);
  Object closure377 = createclosure(1, "visitSignaturePart()up");
  setclosureframe(closure377, stackframe);
  addtoclosure(closure377, var_visitation);
  struct UserObject *uo377 = (struct UserObject*)obj360;
  uo377->data[6] = (Object)closure377;
  Method *meth_meth_ast_visitSignaturePart_40__41_up377 = addmethod2pos(obj360, "visitSignaturePart()up", &meth_ast_visitSignaturePart_40__41_up377, 6);
  int argcv_meth_ast_visitSignaturePart_40__41_up377[] = {1, 1};
  meth_meth_ast_visitSignaturePart_40__41_up377->type = alloc_MethodType(2, argcv_meth_ast_visitSignaturePart_40__41_up377);
  meth_meth_ast_visitSignaturePart_40__41_up377->definitionModule = modulename;
  meth_meth_ast_visitSignaturePart_40__41_up377->definitionLine = 2810;
// method visitTypeDec()up
  block_savedest(obj360);
  Object closure380 = createclosure(1, "visitTypeDec()up");
  setclosureframe(closure380, stackframe);
  addtoclosure(closure380, var_visitation);
  struct UserObject *uo380 = (struct UserObject*)obj360;
  uo380->data[7] = (Object)closure380;
  Method *meth_meth_ast_visitTypeDec_40__41_up380 = addmethod2pos(obj360, "visitTypeDec()up", &meth_ast_visitTypeDec_40__41_up380, 7);
  int argcv_meth_ast_visitTypeDec_40__41_up380[] = {1, 1};
  meth_meth_ast_visitTypeDec_40__41_up380->type = alloc_MethodType(2, argcv_meth_ast_visitTypeDec_40__41_up380);
  meth_meth_ast_visitTypeDec_40__41_up380->definitionModule = modulename;
  meth_meth_ast_visitTypeDec_40__41_up380->definitionLine = 2811;
// method visitTypeLiteral()up
  block_savedest(obj360);
  Object closure383 = createclosure(1, "visitTypeLiteral()up");
  setclosureframe(closure383, stackframe);
  addtoclosure(closure383, var_visitation);
  struct UserObject *uo383 = (struct UserObject*)obj360;
  uo383->data[8] = (Object)closure383;
  Method *meth_meth_ast_visitTypeLiteral_40__41_up383 = addmethod2pos(obj360, "visitTypeLiteral()up", &meth_ast_visitTypeLiteral_40__41_up383, 8);
  int argcv_meth_ast_visitTypeLiteral_40__41_up383[] = {1, 1};
  meth_meth_ast_visitTypeLiteral_40__41_up383->type = alloc_MethodType(2, argcv_meth_ast_visitTypeLiteral_40__41_up383);
  meth_meth_ast_visitTypeLiteral_40__41_up383->definitionModule = modulename;
  meth_meth_ast_visitTypeLiteral_40__41_up383->definitionLine = 2812;
// method visitMethod()up
  block_savedest(obj360);
  Object closure386 = createclosure(1, "visitMethod()up");
  setclosureframe(closure386, stackframe);
  addtoclosure(closure386, var_visitation);
  struct UserObject *uo386 = (struct UserObject*)obj360;
  uo386->data[9] = (Object)closure386;
  Method *meth_meth_ast_visitMethod_40__41_up386 = addmethod2pos(obj360, "visitMethod()up", &meth_ast_visitMethod_40__41_up386, 9);
  int argcv_meth_ast_visitMethod_40__41_up386[] = {1, 1};
  meth_meth_ast_visitMethod_40__41_up386->type = alloc_MethodType(2, argcv_meth_ast_visitMethod_40__41_up386);
  meth_meth_ast_visitMethod_40__41_up386->definitionModule = modulename;
  meth_meth_ast_visitMethod_40__41_up386->definitionLine = 2813;
// method visitCall()up
  block_savedest(obj360);
  Object closure389 = createclosure(1, "visitCall()up");
  setclosureframe(closure389, stackframe);
  addtoclosure(closure389, var_visitation);
  struct UserObject *uo389 = (struct UserObject*)obj360;
  uo389->data[10] = (Object)closure389;
  Method *meth_meth_ast_visitCall_40__41_up389 = addmethod2pos(obj360, "visitCall()up", &meth_ast_visitCall_40__41_up389, 10);
  int argcv_meth_ast_visitCall_40__41_up389[] = {1, 1};
  meth_meth_ast_visitCall_40__41_up389->type = alloc_MethodType(2, argcv_meth_ast_visitCall_40__41_up389);
  meth_meth_ast_visitCall_40__41_up389->definitionModule = modulename;
  meth_meth_ast_visitCall_40__41_up389->definitionLine = 2814;
// method visitClass()up
  block_savedest(obj360);
  Object closure392 = createclosure(1, "visitClass()up");
  setclosureframe(closure392, stackframe);
  addtoclosure(closure392, var_visitation);
  struct UserObject *uo392 = (struct UserObject*)obj360;
  uo392->data[11] = (Object)closure392;
  Method *meth_meth_ast_visitClass_40__41_up392 = addmethod2pos(obj360, "visitClass()up", &meth_ast_visitClass_40__41_up392, 11);
  int argcv_meth_ast_visitClass_40__41_up392[] = {1, 1};
  meth_meth_ast_visitClass_40__41_up392->type = alloc_MethodType(2, argcv_meth_ast_visitClass_40__41_up392);
  meth_meth_ast_visitClass_40__41_up392->definitionModule = modulename;
  meth_meth_ast_visitClass_40__41_up392->definitionLine = 2815;
// method visitObject()up
  block_savedest(obj360);
  Object closure395 = createclosure(1, "visitObject()up");
  setclosureframe(closure395, stackframe);
  addtoclosure(closure395, var_visitation);
  struct UserObject *uo395 = (struct UserObject*)obj360;
  uo395->data[12] = (Object)closure395;
  Method *meth_meth_ast_visitObject_40__41_up395 = addmethod2pos(obj360, "visitObject()up", &meth_ast_visitObject_40__41_up395, 12);
  int argcv_meth_ast_visitObject_40__41_up395[] = {1, 1};
  meth_meth_ast_visitObject_40__41_up395->type = alloc_MethodType(2, argcv_meth_ast_visitObject_40__41_up395);
  meth_meth_ast_visitObject_40__41_up395->definitionModule = modulename;
  meth_meth_ast_visitObject_40__41_up395->definitionLine = 2816;
// method visitModule()up
  block_savedest(obj360);
  Object closure398 = createclosure(1, "visitModule()up");
  setclosureframe(closure398, stackframe);
  addtoclosure(closure398, var_visitation);
  struct UserObject *uo398 = (struct UserObject*)obj360;
  uo398->data[13] = (Object)closure398;
  Method *meth_meth_ast_visitModule_40__41_up398 = addmethod2pos(obj360, "visitModule()up", &meth_ast_visitModule_40__41_up398, 13);
  int argcv_meth_ast_visitModule_40__41_up398[] = {1, 1};
  meth_meth_ast_visitModule_40__41_up398->type = alloc_MethodType(2, argcv_meth_ast_visitModule_40__41_up398);
  meth_meth_ast_visitModule_40__41_up398->definitionModule = modulename;
  meth_meth_ast_visitModule_40__41_up398->definitionLine = 2817;
// method visitArray()up
  block_savedest(obj360);
  Object closure401 = createclosure(1, "visitArray()up");
  setclosureframe(closure401, stackframe);
  addtoclosure(closure401, var_visitation);
  struct UserObject *uo401 = (struct UserObject*)obj360;
  uo401->data[14] = (Object)closure401;
  Method *meth_meth_ast_visitArray_40__41_up401 = addmethod2pos(obj360, "visitArray()up", &meth_ast_visitArray_40__41_up401, 14);
  int argcv_meth_ast_visitArray_40__41_up401[] = {1, 1};
  meth_meth_ast_visitArray_40__41_up401->type = alloc_MethodType(2, argcv_meth_ast_visitArray_40__41_up401);
  meth_meth_ast_visitArray_40__41_up401->definitionModule = modulename;
  meth_meth_ast_visitArray_40__41_up401->definitionLine = 2818;
// method visitMember()up
  block_savedest(obj360);
  Object closure404 = createclosure(1, "visitMember()up");
  setclosureframe(closure404, stackframe);
  addtoclosure(closure404, var_visitation);
  struct UserObject *uo404 = (struct UserObject*)obj360;
  uo404->data[15] = (Object)closure404;
  Method *meth_meth_ast_visitMember_40__41_up404 = addmethod2pos(obj360, "visitMember()up", &meth_ast_visitMember_40__41_up404, 15);
  int argcv_meth_ast_visitMember_40__41_up404[] = {1, 1};
  meth_meth_ast_visitMember_40__41_up404->type = alloc_MethodType(2, argcv_meth_ast_visitMember_40__41_up404);
  meth_meth_ast_visitMember_40__41_up404->definitionModule = modulename;
  meth_meth_ast_visitMember_40__41_up404->definitionLine = 2819;
// method visitGeneric()up
  block_savedest(obj360);
  Object closure407 = createclosure(1, "visitGeneric()up");
  setclosureframe(closure407, stackframe);
  addtoclosure(closure407, var_visitation);
  struct UserObject *uo407 = (struct UserObject*)obj360;
  uo407->data[16] = (Object)closure407;
  Method *meth_meth_ast_visitGeneric_40__41_up407 = addmethod2pos(obj360, "visitGeneric()up", &meth_ast_visitGeneric_40__41_up407, 16);
  int argcv_meth_ast_visitGeneric_40__41_up407[] = {1, 1};
  meth_meth_ast_visitGeneric_40__41_up407->type = alloc_MethodType(2, argcv_meth_ast_visitGeneric_40__41_up407);
  meth_meth_ast_visitGeneric_40__41_up407->definitionModule = modulename;
  meth_meth_ast_visitGeneric_40__41_up407->definitionLine = 2820;
// method visitIdentifier()up
  block_savedest(obj360);
  Object closure410 = createclosure(1, "visitIdentifier()up");
  setclosureframe(closure410, stackframe);
  addtoclosure(closure410, var_visitation);
  struct UserObject *uo410 = (struct UserObject*)obj360;
  uo410->data[17] = (Object)closure410;
  Method *meth_meth_ast_visitIdentifier_40__41_up410 = addmethod2pos(obj360, "visitIdentifier()up", &meth_ast_visitIdentifier_40__41_up410, 17);
  int argcv_meth_ast_visitIdentifier_40__41_up410[] = {1, 1};
  meth_meth_ast_visitIdentifier_40__41_up410->type = alloc_MethodType(2, argcv_meth_ast_visitIdentifier_40__41_up410);
  meth_meth_ast_visitIdentifier_40__41_up410->definitionModule = modulename;
  meth_meth_ast_visitIdentifier_40__41_up410->definitionLine = 2821;
// method visitString()up
  block_savedest(obj360);
  Object closure413 = createclosure(1, "visitString()up");
  setclosureframe(closure413, stackframe);
  addtoclosure(closure413, var_visitation);
  struct UserObject *uo413 = (struct UserObject*)obj360;
  uo413->data[18] = (Object)closure413;
  Method *meth_meth_ast_visitString_40__41_up413 = addmethod2pos(obj360, "visitString()up", &meth_ast_visitString_40__41_up413, 18);
  int argcv_meth_ast_visitString_40__41_up413[] = {1, 1};
  meth_meth_ast_visitString_40__41_up413->type = alloc_MethodType(2, argcv_meth_ast_visitString_40__41_up413);
  meth_meth_ast_visitString_40__41_up413->definitionModule = modulename;
  meth_meth_ast_visitString_40__41_up413->definitionLine = 2822;
// method visitNum()up
  block_savedest(obj360);
  Object closure416 = createclosure(1, "visitNum()up");
  setclosureframe(closure416, stackframe);
  addtoclosure(closure416, var_visitation);
  struct UserObject *uo416 = (struct UserObject*)obj360;
  uo416->data[19] = (Object)closure416;
  Method *meth_meth_ast_visitNum_40__41_up416 = addmethod2pos(obj360, "visitNum()up", &meth_ast_visitNum_40__41_up416, 19);
  int argcv_meth_ast_visitNum_40__41_up416[] = {1, 1};
  meth_meth_ast_visitNum_40__41_up416->type = alloc_MethodType(2, argcv_meth_ast_visitNum_40__41_up416);
  meth_meth_ast_visitNum_40__41_up416->definitionModule = modulename;
  meth_meth_ast_visitNum_40__41_up416->definitionLine = 2823;
// method visitOp()up
  block_savedest(obj360);
  Object closure419 = createclosure(1, "visitOp()up");
  setclosureframe(closure419, stackframe);
  addtoclosure(closure419, var_visitation);
  struct UserObject *uo419 = (struct UserObject*)obj360;
  uo419->data[20] = (Object)closure419;
  Method *meth_meth_ast_visitOp_40__41_up419 = addmethod2pos(obj360, "visitOp()up", &meth_ast_visitOp_40__41_up419, 20);
  int argcv_meth_ast_visitOp_40__41_up419[] = {1, 1};
  meth_meth_ast_visitOp_40__41_up419->type = alloc_MethodType(2, argcv_meth_ast_visitOp_40__41_up419);
  meth_meth_ast_visitOp_40__41_up419->definitionModule = modulename;
  meth_meth_ast_visitOp_40__41_up419->definitionLine = 2824;
// method visitIndex()up
  block_savedest(obj360);
  Object closure422 = createclosure(1, "visitIndex()up");
  setclosureframe(closure422, stackframe);
  addtoclosure(closure422, var_visitation);
  struct UserObject *uo422 = (struct UserObject*)obj360;
  uo422->data[21] = (Object)closure422;
  Method *meth_meth_ast_visitIndex_40__41_up422 = addmethod2pos(obj360, "visitIndex()up", &meth_ast_visitIndex_40__41_up422, 21);
  int argcv_meth_ast_visitIndex_40__41_up422[] = {1, 1};
  meth_meth_ast_visitIndex_40__41_up422->type = alloc_MethodType(2, argcv_meth_ast_visitIndex_40__41_up422);
  meth_meth_ast_visitIndex_40__41_up422->definitionModule = modulename;
  meth_meth_ast_visitIndex_40__41_up422->definitionLine = 2825;
// method visitBind()up
  block_savedest(obj360);
  Object closure425 = createclosure(1, "visitBind()up");
  setclosureframe(closure425, stackframe);
  addtoclosure(closure425, var_visitation);
  struct UserObject *uo425 = (struct UserObject*)obj360;
  uo425->data[22] = (Object)closure425;
  Method *meth_meth_ast_visitBind_40__41_up425 = addmethod2pos(obj360, "visitBind()up", &meth_ast_visitBind_40__41_up425, 22);
  int argcv_meth_ast_visitBind_40__41_up425[] = {1, 1};
  meth_meth_ast_visitBind_40__41_up425->type = alloc_MethodType(2, argcv_meth_ast_visitBind_40__41_up425);
  meth_meth_ast_visitBind_40__41_up425->definitionModule = modulename;
  meth_meth_ast_visitBind_40__41_up425->definitionLine = 2826;
// method visitDefDec()up
  block_savedest(obj360);
  Object closure428 = createclosure(1, "visitDefDec()up");
  setclosureframe(closure428, stackframe);
  addtoclosure(closure428, var_visitation);
  struct UserObject *uo428 = (struct UserObject*)obj360;
  uo428->data[23] = (Object)closure428;
  Method *meth_meth_ast_visitDefDec_40__41_up428 = addmethod2pos(obj360, "visitDefDec()up", &meth_ast_visitDefDec_40__41_up428, 23);
  int argcv_meth_ast_visitDefDec_40__41_up428[] = {1, 1};
  meth_meth_ast_visitDefDec_40__41_up428->type = alloc_MethodType(2, argcv_meth_ast_visitDefDec_40__41_up428);
  meth_meth_ast_visitDefDec_40__41_up428->definitionModule = modulename;
  meth_meth_ast_visitDefDec_40__41_up428->definitionLine = 2827;
// method visitVarDec()up
  block_savedest(obj360);
  Object closure431 = createclosure(1, "visitVarDec()up");
  setclosureframe(closure431, stackframe);
  addtoclosure(closure431, var_visitation);
  struct UserObject *uo431 = (struct UserObject*)obj360;
  uo431->data[24] = (Object)closure431;
  Method *meth_meth_ast_visitVarDec_40__41_up431 = addmethod2pos(obj360, "visitVarDec()up", &meth_ast_visitVarDec_40__41_up431, 24);
  int argcv_meth_ast_visitVarDec_40__41_up431[] = {1, 1};
  meth_meth_ast_visitVarDec_40__41_up431->type = alloc_MethodType(2, argcv_meth_ast_visitVarDec_40__41_up431);
  meth_meth_ast_visitVarDec_40__41_up431->definitionModule = modulename;
  meth_meth_ast_visitVarDec_40__41_up431->definitionLine = 2828;
// method visitImport()up
  block_savedest(obj360);
  Object closure434 = createclosure(1, "visitImport()up");
  setclosureframe(closure434, stackframe);
  addtoclosure(closure434, var_visitation);
  struct UserObject *uo434 = (struct UserObject*)obj360;
  uo434->data[25] = (Object)closure434;
  Method *meth_meth_ast_visitImport_40__41_up434 = addmethod2pos(obj360, "visitImport()up", &meth_ast_visitImport_40__41_up434, 25);
  int argcv_meth_ast_visitImport_40__41_up434[] = {1, 1};
  meth_meth_ast_visitImport_40__41_up434->type = alloc_MethodType(2, argcv_meth_ast_visitImport_40__41_up434);
  meth_meth_ast_visitImport_40__41_up434->definitionModule = modulename;
  meth_meth_ast_visitImport_40__41_up434->definitionLine = 2829;
// method visitReturn()up
  block_savedest(obj360);
  Object closure437 = createclosure(1, "visitReturn()up");
  setclosureframe(closure437, stackframe);
  addtoclosure(closure437, var_visitation);
  struct UserObject *uo437 = (struct UserObject*)obj360;
  uo437->data[26] = (Object)closure437;
  Method *meth_meth_ast_visitReturn_40__41_up437 = addmethod2pos(obj360, "visitReturn()up", &meth_ast_visitReturn_40__41_up437, 26);
  int argcv_meth_ast_visitReturn_40__41_up437[] = {1, 1};
  meth_meth_ast_visitReturn_40__41_up437->type = alloc_MethodType(2, argcv_meth_ast_visitReturn_40__41_up437);
  meth_meth_ast_visitReturn_40__41_up437->definitionModule = modulename;
  meth_meth_ast_visitReturn_40__41_up437->definitionLine = 2830;
// method visitInherits()up
  block_savedest(obj360);
  Object closure440 = createclosure(1, "visitInherits()up");
  setclosureframe(closure440, stackframe);
  addtoclosure(closure440, var_visitation);
  struct UserObject *uo440 = (struct UserObject*)obj360;
  uo440->data[27] = (Object)closure440;
  Method *meth_meth_ast_visitInherits_40__41_up440 = addmethod2pos(obj360, "visitInherits()up", &meth_ast_visitInherits_40__41_up440, 27);
  int argcv_meth_ast_visitInherits_40__41_up440[] = {1, 1};
  meth_meth_ast_visitInherits_40__41_up440->type = alloc_MethodType(2, argcv_meth_ast_visitInherits_40__41_up440);
  meth_meth_ast_visitInherits_40__41_up440->definitionModule = modulename;
  meth_meth_ast_visitInherits_40__41_up440->definitionLine = 2831;
// method visitDialect()up
  block_savedest(obj360);
  Object closure443 = createclosure(1, "visitDialect()up");
  setclosureframe(closure443, stackframe);
  addtoclosure(closure443, var_visitation);
  struct UserObject *uo443 = (struct UserObject*)obj360;
  uo443->data[28] = (Object)closure443;
  Method *meth_meth_ast_visitDialect_40__41_up443 = addmethod2pos(obj360, "visitDialect()up", &meth_ast_visitDialect_40__41_up443, 28);
  int argcv_meth_ast_visitDialect_40__41_up443[] = {1, 1};
  meth_meth_ast_visitDialect_40__41_up443->type = alloc_MethodType(2, argcv_meth_ast_visitDialect_40__41_up443);
  meth_meth_ast_visitDialect_40__41_up443->definitionModule = modulename;
  meth_meth_ast_visitDialect_40__41_up443->definitionLine = 2832;
// method visitBlank()up
  block_savedest(obj360);
  Object closure446 = createclosure(1, "visitBlank()up");
  setclosureframe(closure446, stackframe);
  addtoclosure(closure446, var_visitation);
  struct UserObject *uo446 = (struct UserObject*)obj360;
  uo446->data[29] = (Object)closure446;
  Method *meth_meth_ast_visitBlank_40__41_up446 = addmethod2pos(obj360, "visitBlank()up", &meth_ast_visitBlank_40__41_up446, 29);
  int argcv_meth_ast_visitBlank_40__41_up446[] = {1, 1};
  meth_meth_ast_visitBlank_40__41_up446->type = alloc_MethodType(2, argcv_meth_ast_visitBlank_40__41_up446);
  meth_meth_ast_visitBlank_40__41_up446->definitionModule = modulename;
  meth_meth_ast_visitBlank_40__41_up446->definitionLine = 2833;
// method visitComment()up
  block_savedest(obj360);
  Object closure449 = createclosure(1, "visitComment()up");
  setclosureframe(closure449, stackframe);
  addtoclosure(closure449, var_visitation);
  struct UserObject *uo449 = (struct UserObject*)obj360;
  uo449->data[30] = (Object)closure449;
  Method *meth_meth_ast_visitComment_40__41_up449 = addmethod2pos(obj360, "visitComment()up", &meth_ast_visitComment_40__41_up449, 30);
  int argcv_meth_ast_visitComment_40__41_up449[] = {1, 1};
  meth_meth_ast_visitComment_40__41_up449->type = alloc_MethodType(2, argcv_meth_ast_visitComment_40__41_up449);
  meth_meth_ast_visitComment_40__41_up449->definitionModule = modulename;
  meth_meth_ast_visitComment_40__41_up449->definitionLine = 2834;
// method asString
  struct UserObject *uo452 = (struct UserObject*)obj360;
  uo452->data[31] = emptyclosure;
  Method *meth_meth_ast_asString452 = addmethod2pos(obj360, "asString", &meth_ast_asString452, 31);
  int argcv_meth_ast_asString452[] = {0};
  meth_meth_ast_asString452->type = alloc_MethodType(1, argcv_meth_ast_asString452);
  meth_meth_ast_asString452->definitionModule = modulename;
  meth_meth_ast_asString452->definitionLine = 2836;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  sourceObject = obj360;
  objclass360 = obj360->class;
  objclass360->definitionModule = modulename;
  objclass360->definitionLine = 2798;
  (*(struct UserObject *)self).data[0] = lowerouter360;
  self = oldself360;
  selfslot = oldselfslot360;
  stackframe = oldstackframe360;
  gc_frame_end(frame);
  return obj360;
}
Object meth_ast__apply464(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_annName = getfromclosure(closure, 0);
  Object *var_ann = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2851
  setline(2851);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_annName (depth = 8)
  int op_slot_right_465 = gc_frame_newslot(*var_annName);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe467 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ann (depth = 10)
  partcv[0] = 0;
  Object call468 = callmethod(*var_ann, "value",
    1, partcv, params);
  gc_frame_end(callframe467);
// compiled call node returning call468 (depth = 9)
// compiled member node returning call468 (depth = 8)
  int op_slot_left_465 = gc_frame_newslot(call468);
  params[0] = *var_annName;
  partcv[0] = 1;
  Object opresult469 = callmethod(call468, "==", 1, partcv, params);
// compiled op node returning opresult469 (depth = 7)
  gc_frame_end(frame);
  return opresult469;
}
Object meth_ast__apply460(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_annName = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ann = &(stackframe->slots[0]);
  *var_ann = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2850
  setline(2850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe462 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block463 = alloc_Block(NULL, NULL, "ast", 2850);
  gc_frame_newslot(block463);
// method _apply
  block_savedest(block463);
  Object closure464 = createclosure(3, "_apply");
  setclosureframe(closure464, stackframe);
  addtoclosure(closure464, var_annName);
  addtoclosure(closure464, var_ann);
  addtoclosure(closure464, selfslot);
  struct UserObject *uo464 = (struct UserObject*)block463;
  uo464->data[0] = (Object)closure464;
  Method *meth_meth_ast__apply464 = addmethod2pos(block463, "_apply", &meth_ast__apply464, 0);
  int argcv_meth_ast__apply464[] = {0};
  meth_meth_ast__apply464->type = alloc_MethodType(1, argcv_meth_ast__apply464);
  meth_meth_ast__apply464->definitionModule = modulename;
  meth_meth_ast__apply464->definitionLine = 2849;
// compiled block node returning block463 (depth = 6)
  gc_frame_newslot(block463);
// call case 6: other member request
// Begin line 2850
  setline(2850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit472 == NULL) {
    strlit472 = alloc_String("identifier");
    gc_root(strlit472);
  }
// compiled string node returning strlit472 (depth = 7)
  int op_slot_right_471 = gc_frame_newslot(strlit472);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe474 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ann (depth = 9)
  partcv[0] = 0;
  Object call475 = callmethod(*var_ann, "kind",
    1, partcv, params);
  gc_frame_end(callframe474);
// compiled call node returning call475 (depth = 8)
// compiled member node returning call475 (depth = 7)
  int op_slot_left_471 = gc_frame_newslot(call475);
  params[0] = strlit472;
  partcv[0] = 1;
  Object opresult476 = callmethod(call475, "==", 1, partcv, params);
// compiled op node returning opresult476 (depth = 6)
  params[0] = block463;
  partcv[0] = 1;
  Object call477 = callmethod(opresult476, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe462);
// compiled call node returning call477 (depth = 5)
  Object if461 = done;
  if (istrue(call477)) {
// Begin line 2852
  setline(2852);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile object node (depth = 6)
  Object inheritingObject478 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj478 = alloc_userobj2(2,4, objclass478);
  gc_frame_newslot(obj478);
// OBJECT OUTER DEC outer
  adddatum2(obj478, self, 0);
  addmethodreal(obj478,"outer", &reader_ast_outer_479);
  Object oldself478 = self;
  struct StackFrameObject *oldstackframe478 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe478);
  gc_frame_newslot((Object)stackframe);
  self = obj478;
  Object *oldselfslot478 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter478 = (*(struct UserObject *)self).data[0], lowerouter478 = thisouter478;
  if (inheritingObject478) {
    struct UserObject *inho478 = (struct UserObject *)inheritingObject478;
    while (inho478->super != GraceDefaultObject) inho478 = (struct UserObject *)inho478->super;
    inho478->super = obj478;
    self = inheritingObject478;
    *selfslot = self;
    lowerouter478 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter478;
  }
if (objclass478 == NULL) {
  Method *reader480 = addmethodrealflags(obj478, "value",&reader_ast_value_480, MFLAG_DEF);
  reader480->definitionModule = modulename;
  reader480->definitionLine = 2854;
}
adddatum2(obj478, alloc_Undefined(), 1);
  sourceObject = obj478;
// Begin line 2853
  setline(2853);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
  Object bool481 = alloc_Boolean(1);
// compiled identifier node returning bool481 (depth = 7)
  struct UserObject *obj478_uo = (struct UserObject *)obj478;
  obj478_uo->super = bool481;
  sourceObject = obj478;
// Begin line 2854
  setline(2854);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ann (depth = 7)
  adddatum2(obj478, *var_ann, 1);
  objclass478 = obj478->class;
  objclass478->definitionModule = modulename;
  objclass478->definitionLine = 2852;
  (*(struct UserObject *)self).data[0] = lowerouter478;
  self = oldself478;
  selfslot = oldselfslot478;
  stackframe = oldstackframe478;
// compiled object node returning obj478 (depth = 6)
  block_return(realself, obj478);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if461 = undefined;
  } else {
  }
// compiled if node returning if461 (depth = 4)
  gc_frame_end(frame);
  return if461;
}
Object meth_ast_findAnnotation455(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "findAnnotation");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method findAnnotation");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for findAnnotation (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_node = &(stackframe->slots[0]);
  *var_node = args[curarg];
  curarg++;
  Object *var_annName = &(stackframe->slots[1]);
  *var_annName = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for findAnnotation");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2849
  setline(2849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe456 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe457 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_node (depth = 5)
  partcv[0] = 0;
  Object call458 = callmethod(*var_node, "annotations",
    1, partcv, params);
  gc_frame_end(callframe457);
// compiled call node returning call458 (depth = 4)
// compiled member node returning call458 (depth = 3)
  gc_frame_newslot(call458);
// starting to compile block node (depth = 3)
  Object block459 = alloc_Block(NULL, NULL, "ast", 2849);
  gc_frame_newslot(block459);
// method _apply
  block_savedest(block459);
  Object closure460 = createclosure(2, "_apply");
  setclosureframe(closure460, stackframe);
  addtoclosure(closure460, var_annName);
  addtoclosure(closure460, selfslot);
  struct UserObject *uo460 = (struct UserObject*)block459;
  uo460->data[0] = (Object)closure460;
  Method *meth_meth_ast__apply460 = addmethod2pos(block459, "_apply", &meth_ast__apply460, 0);
  int argcv_meth_ast__apply460[] = {1};
  meth_meth_ast__apply460->type = alloc_MethodType(1, argcv_meth_ast__apply460);
  meth_meth_ast__apply460->definitionModule = modulename;
  meth_meth_ast__apply460->definitionLine = 2849;
// compiled block node returning block459 (depth = 3)
  gc_frame_newslot(block459);
// call case 5: prelude request
  params[0] = call458;
  params[1] = block459;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call483 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe456);
// compiled call node returning call483 (depth = 2)
// Begin line 2858
  setline(2858);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool484 = alloc_Boolean(0);
// compiled identifier node returning bool484 (depth = 2)
  gc_frame_end(frame);
  return bool484;
}
Object meth_ast_lineLength486(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lineLength");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lineLength = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for lineLength (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹lineLength›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 15
  setline(15);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lineLength (depth = 3)
  gc_frame_end(frame);
  return *var_lineLength;
}
Object meth_ast_isEmpty492(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isEmpty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isEmpty (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isEmpty");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 39
  setline(39);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool493 = alloc_Boolean(1);
// compiled identifier node returning bool493 (depth = 3)
  gc_frame_end(frame);
  return bool493;
}
Object meth_ast_asString494(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 40
  setline(40);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit495 == NULL) {
    strlit495 = alloc_String("ancestorChain ""\xe2""""\x96""""\xab""");
    gc_root(strlit495);
  }
// compiled string node returning strlit495 (depth = 3)
  gc_frame_end(frame);
  return strlit495;
}
Object meth_ast_extend496(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "extend");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method extend");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for extend (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for extend");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 41
  setline(41);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe497 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe498 = gc_frame_new();
// call case 3: self.outer request
  Object call499 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe498);
// compiled call node returning call499 (depth = 5)
// compiled member node returning call499 (depth = 4)
  params[0] = *var_n;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call500 = callmethodflags(call499, "cons()onto", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe497);
// compiled call node returning call500 (depth = 3)
  gc_frame_end(frame);
  return call500;
}
Object meth_ast_empty489(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "empty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for empty (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for empty");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject490 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj490 = alloc_userobj2(3,4, objclass490);
  gc_frame_newslot(obj490);
if (objclass490 == NULL) {
  glfree(obj490->class->name);
  obj490->class->name = "obj487.empty";
}
// OBJECT OUTER DEC outer
  adddatum2(obj490, self, 0);
  addmethodreal(obj490,"outer", &reader_ast_outer_491);
  Object oldself490 = self;
  struct StackFrameObject *oldstackframe490 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe490);
  gc_frame_newslot((Object)stackframe);
  self = obj490;
  Object *oldselfslot490 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter490 = (*(struct UserObject *)self).data[0], lowerouter490 = thisouter490;
  if (inheritingObject490) {
    struct UserObject *inho490 = (struct UserObject *)inheritingObject490;
    while (inho490->super != GraceDefaultObject) inho490 = (struct UserObject *)inho490->super;
    inho490->super = obj490;
    self = inheritingObject490;
    *selfslot = self;
    lowerouter490 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter490;
  }
// method isEmpty
  struct UserObject *uo492 = (struct UserObject*)obj490;
  uo492->data[1] = emptyclosure;
  Method *meth_meth_ast_isEmpty492 = addmethod2pos(obj490, "isEmpty", &meth_ast_isEmpty492, 1);
  int argcv_meth_ast_isEmpty492[] = {0};
  meth_meth_ast_isEmpty492->type = alloc_MethodType(1, argcv_meth_ast_isEmpty492);
  meth_meth_ast_isEmpty492->definitionModule = modulename;
  meth_meth_ast_isEmpty492->definitionLine = 39;
// method asString
  struct UserObject *uo494 = (struct UserObject*)obj490;
  uo494->data[2] = emptyclosure;
  Method *meth_meth_ast_asString494 = addmethod2pos(obj490, "asString", &meth_ast_asString494, 2);
  int argcv_meth_ast_asString494[] = {0};
  meth_meth_ast_asString494->type = alloc_MethodType(1, argcv_meth_ast_asString494);
  meth_meth_ast_asString494->definitionModule = modulename;
  meth_meth_ast_asString494->definitionLine = 40;
// method extend
  struct UserObject *uo496 = (struct UserObject*)obj490;
  uo496->data[3] = emptyclosure;
  Method *meth_meth_ast_extend496 = addmethod2pos(obj490, "extend", &meth_ast_extend496, 3);
  int argcv_meth_ast_extend496[] = {1};
  meth_meth_ast_extend496->type = alloc_MethodType(1, argcv_meth_ast_extend496);
  meth_meth_ast_extend496->definitionModule = modulename;
  meth_meth_ast_extend496->definitionLine = 41;
  sourceObject = obj490;
  sourceObject = obj490;
  sourceObject = obj490;
  objclass490 = obj490->class;
  objclass490->definitionModule = modulename;
  objclass490->definitionLine = 38;
  (*(struct UserObject *)self).data[0] = lowerouter490;
  self = oldself490;
  selfslot = oldselfslot490;
  stackframe = oldstackframe490;
  gc_frame_end(frame);
  return obj490;
}
Object meth_ast_empty489_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "empty()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for empty (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for empty");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject490 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj490 = alloc_userobj2(3,4, objclass490);
  gc_frame_newslot(obj490);
if (objclass490 == NULL) {
  glfree(obj490->class->name);
  obj490->class->name = "obj487.empty";
}
// OBJECT OUTER DEC outer
  adddatum2(obj490, self, 0);
  addmethodreal(obj490,"outer", &reader_ast_outer_491);
  Object oldself490 = self;
  struct StackFrameObject *oldstackframe490 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe490);
  gc_frame_newslot((Object)stackframe);
  self = obj490;
  Object *oldselfslot490 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter490 = (*(struct UserObject *)self).data[0], lowerouter490 = thisouter490;
  if (inheritingObject490) {
    struct UserObject *inho490 = (struct UserObject *)inheritingObject490;
    while (inho490->super != GraceDefaultObject) inho490 = (struct UserObject *)inho490->super;
    inho490->super = obj490;
    self = inheritingObject490;
    *selfslot = self;
    lowerouter490 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter490;
  }
// method isEmpty
  struct UserObject *uo492 = (struct UserObject*)obj490;
  uo492->data[1] = emptyclosure;
  Method *meth_meth_ast_isEmpty492 = addmethod2pos(obj490, "isEmpty", &meth_ast_isEmpty492, 1);
  int argcv_meth_ast_isEmpty492[] = {0};
  meth_meth_ast_isEmpty492->type = alloc_MethodType(1, argcv_meth_ast_isEmpty492);
  meth_meth_ast_isEmpty492->definitionModule = modulename;
  meth_meth_ast_isEmpty492->definitionLine = 39;
// method asString
  struct UserObject *uo494 = (struct UserObject*)obj490;
  uo494->data[2] = emptyclosure;
  Method *meth_meth_ast_asString494 = addmethod2pos(obj490, "asString", &meth_ast_asString494, 2);
  int argcv_meth_ast_asString494[] = {0};
  meth_meth_ast_asString494->type = alloc_MethodType(1, argcv_meth_ast_asString494);
  meth_meth_ast_asString494->definitionModule = modulename;
  meth_meth_ast_asString494->definitionLine = 40;
// method extend
  struct UserObject *uo496 = (struct UserObject*)obj490;
  uo496->data[3] = emptyclosure;
  Method *meth_meth_ast_extend496 = addmethod2pos(obj490, "extend", &meth_ast_extend496, 3);
  int argcv_meth_ast_extend496[] = {1};
  meth_meth_ast_extend496->type = alloc_MethodType(1, argcv_meth_ast_extend496);
  meth_meth_ast_extend496->definitionModule = modulename;
  meth_meth_ast_extend496->definitionLine = 41;
  sourceObject = obj490;
  sourceObject = obj490;
  sourceObject = obj490;
  objclass490 = obj490->class;
  objclass490->definitionModule = modulename;
  objclass490->definitionLine = 38;
  (*(struct UserObject *)self).data[0] = lowerouter490;
  self = oldself490;
  selfslot = oldselfslot490;
  stackframe = oldstackframe490;
  gc_frame_end(frame);
  return obj490;
}
Object meth_ast_with502(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "with");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method with");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for with (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for with");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 43
  setline(43);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe503 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe504 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call505 = callmethodflags(self, "empty", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe504);
// compiled call node returning call505 (depth = 5)
// compiled member node returning call505 (depth = 4)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call506 = callmethod(call505, "extend",
    1, partcv, params);
  gc_frame_end(callframe503);
// compiled call node returning call506 (depth = 3)
  gc_frame_end(frame);
  return call506;
}
Object meth_ast_forebears510(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "forebears");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_as = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for forebears (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for forebears");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 45
  setline(45);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_end(frame);
  return *var_as;
}
Object meth_ast_isEmpty511(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isEmpty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isEmpty (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isEmpty");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 46
  setline(46);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool512 = alloc_Boolean(0);
// compiled identifier node returning bool512 (depth = 3)
  gc_frame_end(frame);
  return bool512;
}
Object meth_ast_parent513(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_p = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for parent (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for parent");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 47
  setline(47);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_p (depth = 3)
  gc_frame_end(frame);
  return *var_p;
}
Object meth_ast_grandparent514(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "grandparent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for grandparent (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for grandparent");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 48
  setline(48);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe515 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe516 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call517 = callmethodflags(self, "forebears", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe516);
// compiled call node returning call517 (depth = 6)
// compiled member node returning call517 (depth = 5)
  partcv[0] = 0;
  Object call518 = callmethod(call517, "parent",
    1, partcv, params);
  gc_frame_end(callframe515);
// compiled call node returning call518 (depth = 4)
// compiled member node returning call518 (depth = 3)
  gc_frame_end(frame);
  return call518;
}
Object meth_ast__apply523(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_a = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe524 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe525 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_a (depth = 9)
  partcv[0] = 0;
  Object call526 = callmethod(*var_a, "isEmpty",
    1, partcv, params);
  gc_frame_end(callframe525);
// compiled call node returning call526 (depth = 8)
// compiled member node returning call526 (depth = 7)
  partcv[0] = 0;
  Object call527 = callmethod(call526, "not",
    1, partcv, params);
  gc_frame_end(callframe524);
// compiled call node returning call527 (depth = 6)
// compiled member node returning call527 (depth = 5)
  gc_frame_end(frame);
  return call527;
}
Object meth_ast__apply530(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_a = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// Begin line 54
  setline(54);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit532 == NULL) {
    strlit532 = alloc_String("""\xe2""""\x9e""""\xa4""");
    gc_root(strlit532);
  }
// compiled string node returning strlit532 (depth = 7)
  int op_slot_right_531 = gc_frame_newslot(strlit532);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe535 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_a (depth = 10)
  partcv[0] = 0;
  Object call536 = callmethod(*var_a, "parent",
    1, partcv, params);
  gc_frame_end(callframe535);
// compiled call node returning call536 (depth = 9)
// compiled member node returning call536 (depth = 8)
  int op_slot_right_534 = gc_frame_newslot(call536);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_534 = gc_frame_newslot(*var_s);
  params[0] = call536;
  partcv[0] = 1;
  Object opresult538 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult538 (depth = 7)
  int op_slot_left_531 = gc_frame_newslot(opresult538);
  params[0] = strlit532;
  partcv[0] = 1;
  Object opresult539 = callmethod(opresult538, "++", 1, partcv, params);
// compiled op node returning opresult539 (depth = 6)
  *var_s = opresult539;
  if (opresult539 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 55
  setline(55);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe541 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_a (depth = 8)
  partcv[0] = 0;
  Object call542 = callmethod(*var_a, "forebears",
    1, partcv, params);
  gc_frame_end(callframe541);
// compiled call node returning call542 (depth = 7)
// compiled member node returning call542 (depth = 6)
  *var_a = call542;
  if (call542 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_asString519(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_a = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "a");
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 51
  setline(51);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  *var_a = self;
  if (self == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 52
  setline(52);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit520 == NULL) {
    strlit520 = alloc_String("ancestorChain ");
    gc_root(strlit520);
  }
// compiled string node returning strlit520 (depth = 4)
  *var_s = strlit520;
  if (strlit520 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 53
  setline(53);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe521 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block522 = alloc_Block(NULL, NULL, "ast", 53);
  gc_frame_newslot(block522);
// method _apply
  block_savedest(block522);
  Object closure523 = createclosure(2, "_apply");
  setclosureframe(closure523, stackframe);
  addtoclosure(closure523, var_a);
  addtoclosure(closure523, selfslot);
  struct UserObject *uo523 = (struct UserObject*)block522;
  uo523->data[0] = (Object)closure523;
  Method *meth_meth_ast__apply523 = addmethod2pos(block522, "_apply", &meth_ast__apply523, 0);
  int argcv_meth_ast__apply523[] = {0};
  meth_meth_ast__apply523->type = alloc_MethodType(1, argcv_meth_ast__apply523);
  meth_meth_ast__apply523->definitionModule = modulename;
  meth_meth_ast__apply523->definitionLine = 48;
// compiled block node returning block522 (depth = 4)
  gc_frame_newslot(block522);
// starting to compile block node (depth = 4)
  Object block529 = alloc_Block(NULL, NULL, "ast", 53);
  gc_frame_newslot(block529);
// method _apply
  block_savedest(block529);
  Object closure530 = createclosure(3, "_apply");
  setclosureframe(closure530, stackframe);
  addtoclosure(closure530, var_a);
  addtoclosure(closure530, var_s);
  addtoclosure(closure530, selfslot);
  struct UserObject *uo530 = (struct UserObject*)block529;
  uo530->data[0] = (Object)closure530;
  Method *meth_meth_ast__apply530 = addmethod2pos(block529, "_apply", &meth_ast__apply530, 0);
  int argcv_meth_ast__apply530[] = {0};
  meth_meth_ast__apply530->type = alloc_MethodType(1, argcv_meth_ast__apply530);
  meth_meth_ast__apply530->definitionModule = modulename;
  meth_meth_ast__apply530->definitionLine = 53;
// compiled block node returning block529 (depth = 4)
  gc_frame_newslot(block529);
// call case 5: prelude request
  params[0] = block522;
  params[1] = block529;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call545 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe521);
// compiled call node returning call545 (depth = 3)
// Begin line 57
  setline(57);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit547 == NULL) {
    strlit547 = alloc_String("""\xe2""""\x96""""\xab""");
    gc_root(strlit547);
  }
// compiled string node returning strlit547 (depth = 4)
  int op_slot_right_546 = gc_frame_newslot(strlit547);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_left_546 = gc_frame_newslot(*var_s);
  params[0] = strlit547;
  partcv[0] = 1;
  Object opresult549 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult549 (depth = 3)
  gc_frame_end(frame);
  return opresult549;
}
Object meth_ast_extend550(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "extend");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method extend");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for extend (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for extend");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 59
  setline(59);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe551 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe552 = gc_frame_new();
// call case 3: self.outer request
  Object call553 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe552);
// compiled call node returning call553 (depth = 5)
// compiled member node returning call553 (depth = 4)
  params[0] = *var_n;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call554 = callmethodflags(call553, "cons()onto", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe551);
// compiled call node returning call554 (depth = 3)
  gc_frame_end(frame);
  return call554;
}
Object meth_ast_cons_40__41_onto507(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "cons()onto");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method cons()onto");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method cons()onto");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for cons()onto (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for cons");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for onto");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject508 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj508 = alloc_userobj2(6,7, objclass508);
  gc_frame_newslot(obj508);
if (objclass508 == NULL) {
  glfree(obj508->class->name);
  obj508->class->name = "obj487.cons()onto";
}
// OBJECT OUTER DEC outer
  adddatum2(obj508, self, 0);
  addmethodreal(obj508,"outer", &reader_ast_outer_509);
  Object oldself508 = self;
  struct StackFrameObject *oldstackframe508 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe508);
  gc_frame_newslot((Object)stackframe);
  self = obj508;
  Object *oldselfslot508 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter508 = (*(struct UserObject *)self).data[0], lowerouter508 = thisouter508;
  if (inheritingObject508) {
    struct UserObject *inho508 = (struct UserObject *)inheritingObject508;
    while (inho508->super != GraceDefaultObject) inho508 = (struct UserObject *)inho508->super;
    inho508->super = obj508;
    self = inheritingObject508;
    *selfslot = self;
    lowerouter508 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter508;
  }
// method forebears
  block_savedest(obj508);
  Object closure510 = createclosure(1, "forebears");
  setclosureframe(closure510, stackframe);
  addtoclosure(closure510, var_as);
  struct UserObject *uo510 = (struct UserObject*)obj508;
  uo510->data[1] = (Object)closure510;
  Method *meth_meth_ast_forebears510 = addmethod2pos(obj508, "forebears", &meth_ast_forebears510, 1);
  int argcv_meth_ast_forebears510[] = {0};
  meth_meth_ast_forebears510->type = alloc_MethodType(1, argcv_meth_ast_forebears510);
  meth_meth_ast_forebears510->definitionModule = modulename;
  meth_meth_ast_forebears510->definitionLine = 45;
// method isEmpty
  struct UserObject *uo511 = (struct UserObject*)obj508;
  uo511->data[2] = emptyclosure;
  Method *meth_meth_ast_isEmpty511 = addmethod2pos(obj508, "isEmpty", &meth_ast_isEmpty511, 2);
  int argcv_meth_ast_isEmpty511[] = {0};
  meth_meth_ast_isEmpty511->type = alloc_MethodType(1, argcv_meth_ast_isEmpty511);
  meth_meth_ast_isEmpty511->definitionModule = modulename;
  meth_meth_ast_isEmpty511->definitionLine = 46;
// method parent
  block_savedest(obj508);
  Object closure513 = createclosure(1, "parent");
  setclosureframe(closure513, stackframe);
  addtoclosure(closure513, var_p);
  struct UserObject *uo513 = (struct UserObject*)obj508;
  uo513->data[3] = (Object)closure513;
  Method *meth_meth_ast_parent513 = addmethod2pos(obj508, "parent", &meth_ast_parent513, 3);
  int argcv_meth_ast_parent513[] = {0};
  meth_meth_ast_parent513->type = alloc_MethodType(1, argcv_meth_ast_parent513);
  meth_meth_ast_parent513->definitionModule = modulename;
  meth_meth_ast_parent513->definitionLine = 47;
// method grandparent
  struct UserObject *uo514 = (struct UserObject*)obj508;
  uo514->data[4] = emptyclosure;
  Method *meth_meth_ast_grandparent514 = addmethod2pos(obj508, "grandparent", &meth_ast_grandparent514, 4);
  int argcv_meth_ast_grandparent514[] = {0};
  meth_meth_ast_grandparent514->type = alloc_MethodType(1, argcv_meth_ast_grandparent514);
  meth_meth_ast_grandparent514->definitionModule = modulename;
  meth_meth_ast_grandparent514->definitionLine = 48;
// method asString
  struct UserObject *uo519 = (struct UserObject*)obj508;
  uo519->data[5] = emptyclosure;
  Method *meth_meth_ast_asString519 = addmethod2pos(obj508, "asString", &meth_ast_asString519, 5);
  int argcv_meth_ast_asString519[] = {0};
  meth_meth_ast_asString519->type = alloc_MethodType(1, argcv_meth_ast_asString519);
  meth_meth_ast_asString519->definitionModule = modulename;
  meth_meth_ast_asString519->definitionLine = 50;
// method extend
  struct UserObject *uo550 = (struct UserObject*)obj508;
  uo550->data[6] = emptyclosure;
  Method *meth_meth_ast_extend550 = addmethod2pos(obj508, "extend", &meth_ast_extend550, 6);
  int argcv_meth_ast_extend550[] = {1};
  meth_meth_ast_extend550->type = alloc_MethodType(1, argcv_meth_ast_extend550);
  meth_meth_ast_extend550->definitionModule = modulename;
  meth_meth_ast_extend550->definitionLine = 59;
  sourceObject = obj508;
  sourceObject = obj508;
  sourceObject = obj508;
  sourceObject = obj508;
  sourceObject = obj508;
  sourceObject = obj508;
  objclass508 = obj508->class;
  objclass508->definitionModule = modulename;
  objclass508->definitionLine = 44;
  (*(struct UserObject *)self).data[0] = lowerouter508;
  self = oldself508;
  selfslot = oldselfslot508;
  stackframe = oldstackframe508;
  gc_frame_end(frame);
  return obj508;
}
Object meth_ast_cons_40__41_onto507_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "cons()onto()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0] + argcv[1]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method cons()onto()object");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method cons()onto()object");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for cons()onto (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for cons");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for onto");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject508 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj508 = alloc_userobj2(6,7, objclass508);
  gc_frame_newslot(obj508);
if (objclass508 == NULL) {
  glfree(obj508->class->name);
  obj508->class->name = "obj487.cons()onto";
}
// OBJECT OUTER DEC outer
  adddatum2(obj508, self, 0);
  addmethodreal(obj508,"outer", &reader_ast_outer_509);
  Object oldself508 = self;
  struct StackFrameObject *oldstackframe508 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe508);
  gc_frame_newslot((Object)stackframe);
  self = obj508;
  Object *oldselfslot508 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter508 = (*(struct UserObject *)self).data[0], lowerouter508 = thisouter508;
  if (inheritingObject508) {
    struct UserObject *inho508 = (struct UserObject *)inheritingObject508;
    while (inho508->super != GraceDefaultObject) inho508 = (struct UserObject *)inho508->super;
    inho508->super = obj508;
    self = inheritingObject508;
    *selfslot = self;
    lowerouter508 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter508;
  }
// method forebears
  block_savedest(obj508);
  Object closure510 = createclosure(1, "forebears");
  setclosureframe(closure510, stackframe);
  addtoclosure(closure510, var_as);
  struct UserObject *uo510 = (struct UserObject*)obj508;
  uo510->data[1] = (Object)closure510;
  Method *meth_meth_ast_forebears510 = addmethod2pos(obj508, "forebears", &meth_ast_forebears510, 1);
  int argcv_meth_ast_forebears510[] = {0};
  meth_meth_ast_forebears510->type = alloc_MethodType(1, argcv_meth_ast_forebears510);
  meth_meth_ast_forebears510->definitionModule = modulename;
  meth_meth_ast_forebears510->definitionLine = 45;
// method isEmpty
  struct UserObject *uo511 = (struct UserObject*)obj508;
  uo511->data[2] = emptyclosure;
  Method *meth_meth_ast_isEmpty511 = addmethod2pos(obj508, "isEmpty", &meth_ast_isEmpty511, 2);
  int argcv_meth_ast_isEmpty511[] = {0};
  meth_meth_ast_isEmpty511->type = alloc_MethodType(1, argcv_meth_ast_isEmpty511);
  meth_meth_ast_isEmpty511->definitionModule = modulename;
  meth_meth_ast_isEmpty511->definitionLine = 46;
// method parent
  block_savedest(obj508);
  Object closure513 = createclosure(1, "parent");
  setclosureframe(closure513, stackframe);
  addtoclosure(closure513, var_p);
  struct UserObject *uo513 = (struct UserObject*)obj508;
  uo513->data[3] = (Object)closure513;
  Method *meth_meth_ast_parent513 = addmethod2pos(obj508, "parent", &meth_ast_parent513, 3);
  int argcv_meth_ast_parent513[] = {0};
  meth_meth_ast_parent513->type = alloc_MethodType(1, argcv_meth_ast_parent513);
  meth_meth_ast_parent513->definitionModule = modulename;
  meth_meth_ast_parent513->definitionLine = 47;
// method grandparent
  struct UserObject *uo514 = (struct UserObject*)obj508;
  uo514->data[4] = emptyclosure;
  Method *meth_meth_ast_grandparent514 = addmethod2pos(obj508, "grandparent", &meth_ast_grandparent514, 4);
  int argcv_meth_ast_grandparent514[] = {0};
  meth_meth_ast_grandparent514->type = alloc_MethodType(1, argcv_meth_ast_grandparent514);
  meth_meth_ast_grandparent514->definitionModule = modulename;
  meth_meth_ast_grandparent514->definitionLine = 48;
// method asString
  struct UserObject *uo519 = (struct UserObject*)obj508;
  uo519->data[5] = emptyclosure;
  Method *meth_meth_ast_asString519 = addmethod2pos(obj508, "asString", &meth_ast_asString519, 5);
  int argcv_meth_ast_asString519[] = {0};
  meth_meth_ast_asString519->type = alloc_MethodType(1, argcv_meth_ast_asString519);
  meth_meth_ast_asString519->definitionModule = modulename;
  meth_meth_ast_asString519->definitionLine = 50;
// method extend
  struct UserObject *uo550 = (struct UserObject*)obj508;
  uo550->data[6] = emptyclosure;
  Method *meth_meth_ast_extend550 = addmethod2pos(obj508, "extend", &meth_ast_extend550, 6);
  int argcv_meth_ast_extend550[] = {1};
  meth_meth_ast_extend550->type = alloc_MethodType(1, argcv_meth_ast_extend550);
  meth_meth_ast_extend550->definitionModule = modulename;
  meth_meth_ast_extend550->definitionLine = 59;
  sourceObject = obj508;
  sourceObject = obj508;
  sourceObject = obj508;
  sourceObject = obj508;
  sourceObject = obj508;
  sourceObject = obj508;
  objclass508 = obj508->class;
  objclass508->definitionModule = modulename;
  objclass508->definitionLine = 44;
  (*(struct UserObject *)self).data[0] = lowerouter508;
  self = oldself508;
  selfslot = oldselfslot508;
  stackframe = oldstackframe508;
  gc_frame_end(frame);
  return obj508;
}
Object meth_ast_ancestorChain556(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "ancestorChain");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ancestorChain = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for ancestorChain (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹ancestorChain›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 37
  setline(37);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ancestorChain (depth = 3)
  gc_frame_end(frame);
  return *var_ancestorChain;
}
Object meth_ast_emptySeq561(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "emptySeq");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySeq = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for emptySeq (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹emptySeq›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_emptySeq (depth = 3)
  gc_frame_end(frame);
  return *var_emptySeq;
}
Object meth_ast_AstNode564(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "AstNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_AstNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for AstNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹AstNode›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 65
  setline(65);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_AstNode (depth = 3)
  gc_frame_end(frame);
  return *var_AstNode;
}
Object meth_ast_SymbolTable566(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "SymbolTable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_SymbolTable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for SymbolTable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹SymbolTable›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 83
  setline(83);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_SymbolTable (depth = 3)
  gc_frame_end(frame);
  return *var_SymbolTable;
}
Object meth_ast_baseNode567(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "baseNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_baseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for baseNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for baseNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_baseNode (depth = 3)
  gc_frame_end(frame);
  return *var_baseNode;
}
Object meth_ast_kind578(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "kind");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for kind (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for kind");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 93
  setline(93);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe579 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call580 = callmethodflags(prelude, "abstract", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe579);
// compiled call node returning call580 (depth = 5)
// compiled member node returning call580 (depth = 4)
  gc_frame_end(frame);
  return call580;
}
Object meth_ast_isAppliedOccurenceOfIdentifier581(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isAppliedOccurenceOfIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isAppliedOccurenceOfIdentifier (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isAppliedOccurenceOfIdentifier");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 94
  setline(94);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool582 = alloc_Boolean(0);
// compiled identifier node returning bool582 (depth = 4)
  gc_frame_end(frame);
  return bool582;
}
Object meth_ast_isMatchingBlock583(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isMatchingBlock");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isMatchingBlock (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isMatchingBlock");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 95
  setline(95);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool584 = alloc_Boolean(0);
// compiled identifier node returning bool584 (depth = 4)
  gc_frame_end(frame);
  return bool584;
}
Object meth_ast_isFieldDec585(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isFieldDec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isFieldDec (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isFieldDec");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 96
  setline(96);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool586 = alloc_Boolean(0);
// compiled identifier node returning bool586 (depth = 4)
  gc_frame_end(frame);
  return bool586;
}
Object meth_ast_isInherits587(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isInherits");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isInherits (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isInherits");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 97
  setline(97);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool588 = alloc_Boolean(0);
// compiled identifier node returning bool588 (depth = 4)
  gc_frame_end(frame);
  return bool588;
}
Object meth_ast_isMember589(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isMember");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isMember (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isMember");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 98
  setline(98);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool590 = alloc_Boolean(0);
// compiled identifier node returning bool590 (depth = 4)
  gc_frame_end(frame);
  return bool590;
}
Object meth_ast_isCall591(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isCall");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isCall (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isCall");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 99
  setline(99);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool592 = alloc_Boolean(0);
// compiled identifier node returning bool592 (depth = 4)
  gc_frame_end(frame);
  return bool592;
}
Object meth_ast_isComment593(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isComment");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isComment (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isComment");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 100
  setline(100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool594 = alloc_Boolean(0);
// compiled identifier node returning bool594 (depth = 4)
  gc_frame_end(frame);
  return bool594;
}
Object meth_ast_isClass595(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isClass");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isClass (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isClass");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 101
  setline(101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool596 = alloc_Boolean(0);
// compiled identifier node returning bool596 (depth = 4)
  gc_frame_end(frame);
  return bool596;
}
Object meth_ast_isBind597(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isBind");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isBind (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isBind");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 102
  setline(102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool598 = alloc_Boolean(0);
// compiled identifier node returning bool598 (depth = 4)
  gc_frame_end(frame);
  return bool598;
}
Object meth_ast_isObject599(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isObject (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isObject");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 103
  setline(103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool600 = alloc_Boolean(0);
// compiled identifier node returning bool600 (depth = 4)
  gc_frame_end(frame);
  return bool600;
}
Object meth_ast_isIdentifier601(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isIdentifier (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isIdentifier");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 104
  setline(104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool602 = alloc_Boolean(0);
// compiled identifier node returning bool602 (depth = 4)
  gc_frame_end(frame);
  return bool602;
}
Object meth_ast_isDialect603(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isDialect");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isDialect (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isDialect");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 105
  setline(105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool604 = alloc_Boolean(0);
// compiled identifier node returning bool604 (depth = 4)
  gc_frame_end(frame);
  return bool604;
}
Object meth_ast_isImport605(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isImport");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isImport (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isImport");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 106
  setline(106);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool606 = alloc_Boolean(0);
// compiled identifier node returning bool606 (depth = 4)
  gc_frame_end(frame);
  return bool606;
}
Object meth_ast_canInherit607(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "canInherit");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for canInherit (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for canInherit");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 107
  setline(107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool608 = alloc_Boolean(1);
// compiled identifier node returning bool608 (depth = 4)
  gc_frame_end(frame);
  return bool608;
}
Object meth_ast_returnsObject609(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnsObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for returnsObject (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for returnsObject");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 108
  setline(108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool610 = alloc_Boolean(0);
// compiled identifier node returning bool610 (depth = 4)
  gc_frame_end(frame);
  return bool610;
}
Object meth_ast_usesAsType611(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "usesAsType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method usesAsType");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for usesAsType (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aNode = &(stackframe->slots[0]);
  *var_aNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for usesAsType");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 109
  setline(109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool612 = alloc_Boolean(0);
// compiled identifier node returning bool612 (depth = 4)
  gc_frame_end(frame);
  return bool612;
}
Object meth_ast_hash613(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hash");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for hash (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for hash");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 110
  setline(110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe615 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe616 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call617 = callmethodflags(self, "linePos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe616);
// compiled call node returning call617 (depth = 8)
// compiled member node returning call617 (depth = 7)
  partcv[0] = 0;
  Object call618 = callmethod(call617, "hash",
    1, partcv, params);
  gc_frame_end(callframe615);
// compiled call node returning call618 (depth = 6)
// compiled member node returning call618 (depth = 5)
  int op_slot_right_614 = gc_frame_newslot(call618);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe620 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe621 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call622 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe621);
// compiled call node returning call622 (depth = 8)
// compiled member node returning call622 (depth = 7)
  partcv[0] = 0;
  Object call623 = callmethod(call622, "hash",
    1, partcv, params);
  gc_frame_end(callframe620);
// compiled call node returning call623 (depth = 6)
// compiled member node returning call623 (depth = 5)
  int op_slot_left_614 = gc_frame_newslot(call623);
  params[0] = call618;
  partcv[0] = 1;
  Object prod624 = callmethod(call623, "*", 1, partcv, params);
// compiled op node returning prod624 (depth = 4)
  gc_frame_end(frame);
  return prod624;
}
Object meth_ast_asString625(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 111
  setline(111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit627 == NULL) {
    strlit627 = alloc_String("");
    gc_root(strlit627);
  }
// compiled string node returning strlit627 (depth = 5)
  int op_slot_right_626 = gc_frame_newslot(strlit627);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe630 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call631 = callmethodflags(self, "nameString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe630);
// compiled call node returning call631 (depth = 7)
// compiled member node returning call631 (depth = 6)
  int op_slot_right_629 = gc_frame_newslot(call631);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit634 == NULL) {
    strlit634 = alloc_String(" ");
    gc_root(strlit634);
  }
// compiled string node returning strlit634 (depth = 7)
  int op_slot_right_633 = gc_frame_newslot(strlit634);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe637 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call638 = callmethodflags(self, "kind", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe637);
// compiled call node returning call638 (depth = 9)
// compiled member node returning call638 (depth = 8)
  int op_slot_right_636 = gc_frame_newslot(call638);
// starting to compile string node (depth = 8)
  if (strlit640 == NULL) {
    strlit640 = alloc_String("");
    gc_root(strlit640);
  }
// compiled string node returning strlit640 (depth = 8)
  int op_slot_left_636 = gc_frame_newslot(strlit640);
  params[0] = call638;
  partcv[0] = 1;
  Object opresult641 = callmethod(strlit640, "++", 1, partcv, params);
// compiled op node returning opresult641 (depth = 7)
  int op_slot_left_633 = gc_frame_newslot(opresult641);
  params[0] = strlit634;
  partcv[0] = 1;
  Object opresult642 = callmethod(opresult641, "++", 1, partcv, params);
// compiled op node returning opresult642 (depth = 6)
  int op_slot_left_629 = gc_frame_newslot(opresult642);
  params[0] = call631;
  partcv[0] = 1;
  Object opresult643 = callmethod(opresult642, "++", 1, partcv, params);
// compiled op node returning opresult643 (depth = 5)
  int op_slot_left_626 = gc_frame_newslot(opresult643);
  params[0] = strlit627;
  partcv[0] = 1;
  Object opresult644 = callmethod(opresult643, "++", 1, partcv, params);
// compiled op node returning opresult644 (depth = 4)
  gc_frame_end(frame);
  return opresult644;
}
Object meth_ast_nameString645(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for nameString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for nameString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 112
  setline(112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit646 == NULL) {
    strlit646 = alloc_String("?");
    gc_root(strlit646);
  }
// compiled string node returning strlit646 (depth = 4)
  gc_frame_end(frame);
  return strlit646;
}
Object meth_ast_isWritable647(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isWritable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isWritable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isWritable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 113
  setline(113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool648 = alloc_Boolean(1);
// compiled identifier node returning bool648 (depth = 4)
  gc_frame_end(frame);
  return bool648;
}
Object meth_ast_isReadable649(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isReadable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isReadable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isReadable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 114
  setline(114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool650 = alloc_Boolean(1);
// compiled identifier node returning bool650 (depth = 4)
  gc_frame_end(frame);
  return bool650;
}
Object meth_ast_isPublic651(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPublic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isPublic (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isPublic");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 115
  setline(115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool652 = alloc_Boolean(1);
// compiled identifier node returning bool652 (depth = 4)
  gc_frame_end(frame);
  return bool652;
}
Object meth_ast_isConfidential653(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isConfidential");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isConfidential (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isConfidential");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 116
  setline(116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe654 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe655 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call656 = callmethodflags(self, "isPublic", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe655);
// compiled call node returning call656 (depth = 7)
// compiled member node returning call656 (depth = 6)
  partcv[0] = 0;
  Object call657 = callmethod(call656, "not",
    1, partcv, params);
  gc_frame_end(callframe654);
// compiled call node returning call657 (depth = 5)
// compiled member node returning call657 (depth = 4)
  gc_frame_end(frame);
  return call657;
}
Object meth_ast_decType658(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 30, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "decType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_unknownType = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for decType (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for decType");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 118
  setline(118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool661 = alloc_Boolean(0);
// compiled identifier node returning bool661 (depth = 6)
  int op_slot_right_660 = gc_frame_newslot(bool661);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe663 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call664 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe663);
// compiled call node returning call664 (depth = 7)
// compiled member node returning call664 (depth = 6)
  int op_slot_left_660 = gc_frame_newslot(call664);
  params[0] = bool661;
  partcv[0] = 1;
  Object opresult665 = callmethod(call664, "==", 1, partcv, params);
// compiled op node returning opresult665 (depth = 5)
  Object if659 = done;
  if (istrue(opresult665)) {
// Begin line 119
  setline(119);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_unknownType (depth = 6)
  return *var_unknownType;
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if659 = undefined;
  } else {
  }
// compiled if node returning if659 (depth = 4)
// Begin line 121
  setline(121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe666 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call667 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe666);
// compiled call node returning call667 (depth = 6)
// compiled member node returning call667 (depth = 5)
  return call667;
// compiled return node returning undefined (depth = 4)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast_isSimple668(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSimple");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isSimple (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isSimple");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 123
  setline(123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool669 = alloc_Boolean(1);
// compiled identifier node returning bool669 (depth = 4)
  gc_frame_end(frame);
  return bool669;
}
Object meth_ast_accept670(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 32, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept");
  Object params[2];
  int partcv[2];
  Object *var_ancestorChain = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 125
  setline(125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe671 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe672 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ancestorChain (depth = 7)
  partcv[0] = 0;
  Object call673 = callmethod(*var_ancestorChain, "empty",
    1, partcv, params);
  gc_frame_end(callframe672);
// compiled call node returning call673 (depth = 6)
// compiled member node returning call673 (depth = 5)
  gc_frame_newslot(call673);
// call case 4: self request
  params[0] = *var_visitor;
  params[1] = call673;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call674 = callmethodflags(self, "accept()from", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe671);
// compiled call node returning call674 (depth = 4)
  gc_frame_end(frame);
  return call674;
}
Object meth_ast_scope675(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "scope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for scope (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for scope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 127
  setline(127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe676 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call677 = callmethodflags(self, "symbolTable", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe676);
// compiled call node returning call677 (depth = 5)
// compiled member node returning call677 (depth = 4)
  gc_frame_end(frame);
  return call677;
}
Object meth_ast_scope_58__61_678(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "scope:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method scope:=");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for scope:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_st = &(stackframe->slots[0]);
  *var_st = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for scope:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 133
  setline(133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 127
  setline(127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe679 = gc_frame_new();
// Begin line 133
  setline(133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_st (depth = 6)
  gc_frame_newslot(*var_st);
// call case 4: self request
  params[0] = *var_st;
  partcv[0] = 1;
  Object call680 = callmethodflags(self, "symbolTable:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe679);
// compiled call node returning call680 (depth = 5)
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_declarationKindWithAncestors681(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "declarationKindWithAncestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method declarationKindWithAncestors");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for declarationKindWithAncestors (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for declarationKindWithAncestors");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 135
  setline(135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe682 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call683 = callmethodflags(self, "kind", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe682);
// compiled call node returning call683 (depth = 5)
// compiled member node returning call683 (depth = 4)
  gc_frame_end(frame);
  return call683;
}
Object meth_ast_shallowCopyFieldsFrom684(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyFieldsFrom");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopyFieldsFrom (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyFieldsFrom");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 138
  setline(138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 135
  setline(135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe685 = gc_frame_new();
// Begin line 138
  setline(138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe686 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_other (depth = 8)
  partcv[0] = 0;
  Object call687 = callmethod(*var_other, "register",
    1, partcv, params);
  gc_frame_end(callframe686);
// compiled call node returning call687 (depth = 7)
// compiled member node returning call687 (depth = 6)
  gc_frame_newslot(call687);
// call case 4: self request
  params[0] = call687;
  partcv[0] = 1;
  Object call688 = callmethodflags(self, "register:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe685);
// compiled call node returning call688 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 139
  setline(139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 138
  setline(138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe689 = gc_frame_new();
// Begin line 139
  setline(139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe690 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_other (depth = 8)
  partcv[0] = 0;
  Object call691 = callmethod(*var_other, "line",
    1, partcv, params);
  gc_frame_end(callframe690);
// compiled call node returning call691 (depth = 7)
// compiled member node returning call691 (depth = 6)
  gc_frame_newslot(call691);
// call case 4: self request
  params[0] = call691;
  partcv[0] = 1;
  Object call692 = callmethodflags(self, "line:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe689);
// compiled call node returning call692 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 140
  setline(140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 139
  setline(139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe693 = gc_frame_new();
// Begin line 140
  setline(140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe694 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_other (depth = 8)
  partcv[0] = 0;
  Object call695 = callmethod(*var_other, "linePos",
    1, partcv, params);
  gc_frame_end(callframe694);
// compiled call node returning call695 (depth = 7)
// compiled member node returning call695 (depth = 6)
  gc_frame_newslot(call695);
// call case 4: self request
  params[0] = call695;
  partcv[0] = 1;
  Object call696 = callmethodflags(self, "linePos:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe693);
// compiled call node returning call696 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 141
  setline(141);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 140
  setline(140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe697 = gc_frame_new();
// Begin line 141
  setline(141);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe698 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_other (depth = 8)
  partcv[0] = 0;
  Object call699 = callmethod(*var_other, "scope",
    1, partcv, params);
  gc_frame_end(callframe698);
// compiled call node returning call699 (depth = 7)
// compiled member node returning call699 (depth = 6)
  gc_frame_newslot(call699);
// call case 4: self request
  params[0] = call699;
  partcv[0] = 1;
  Object call700 = callmethodflags(self, "scope:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe697);
// compiled call node returning call700 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 142
  setline(142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_end(frame);
  return self;
}
Object meth_ast__apply709(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 147
  setline(147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit711 == NULL) {
    strlit711 = alloc_String("  ");
    gc_root(strlit711);
  }
// compiled string node returning strlit711 (depth = 8)
  int op_slot_right_710 = gc_frame_newslot(strlit711);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_710 = gc_frame_newslot(*var_spc);
  params[0] = strlit711;
  partcv[0] = 1;
  Object opresult713 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult713 (depth = 7)
  *var_spc = opresult713;
  if (opresult713 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply720(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_util = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit722 == NULL) {
    strlit722 = alloc_String("symbols");
    gc_root(strlit722);
  }
// compiled string node returning strlit722 (depth = 8)
  int op_slot_right_721 = gc_frame_newslot(strlit722);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe724 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_util (depth = 10)
  partcv[0] = 0;
  Object call725 = callmethod(*var_util, "target",
    1, partcv, params);
  gc_frame_end(callframe724);
// compiled call node returning call725 (depth = 9)
// compiled member node returning call725 (depth = 8)
  int op_slot_left_721 = gc_frame_newslot(call725);
  params[0] = strlit722;
  partcv[0] = 1;
  Object opresult726 = callmethod(call725, "==", 1, partcv, params);
// compiled op node returning opresult726 (depth = 7)
  gc_frame_end(frame);
  return opresult726;
}
Object meth_ast_pretty701(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 37, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
// Begin line 145
  setline(145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit702 == NULL) {
    strlit702 = alloc_String("");
    gc_root(strlit702);
  }
// compiled string node returning strlit702 (depth = 5)
  *var_spc = strlit702;
  if (strlit702 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 146
  setline(146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe703 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_right_704 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 6)
  Object num706 = alloc_Float64(0);
// compiled num node returning num706 (depth = 6)
  int op_slot_left_704 = gc_frame_newslot(num706);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult707 = callmethod(num706, "..", 1, partcv, params);
// compiled op node returning opresult707 (depth = 5)
  gc_frame_newslot(opresult707);
// starting to compile block node (depth = 5)
  Object block708 = alloc_Block(NULL, NULL, "ast", 146);
  gc_frame_newslot(block708);
// method _apply
  block_savedest(block708);
  Object closure709 = createclosure(2, "_apply");
  setclosureframe(closure709, stackframe);
  addtoclosure(closure709, var_spc);
  addtoclosure(closure709, selfslot);
  struct UserObject *uo709 = (struct UserObject*)block708;
  uo709->data[0] = (Object)closure709;
  Method *meth_meth_ast__apply709 = addmethod2pos(block708, "_apply", &meth_ast__apply709, 0);
  int argcv_meth_ast__apply709[] = {1};
  meth_meth_ast__apply709->type = alloc_MethodType(1, argcv_meth_ast__apply709);
  meth_meth_ast__apply709->definitionModule = modulename;
  meth_meth_ast__apply709->definitionLine = 141;
// compiled block node returning block708 (depth = 5)
  gc_frame_newslot(block708);
// call case 5: prelude request
  params[0] = opresult707;
  params[1] = block708;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call716 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe703);
// compiled call node returning call716 (depth = 4)
// Begin line 149
  setline(149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe718 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block719 = alloc_Block(NULL, NULL, "ast", 149);
  gc_frame_newslot(block719);
// method _apply
  block_savedest(block719);
  Object closure720 = createclosure(2, "_apply");
  setclosureframe(closure720, stackframe);
  addtoclosure(closure720, var_util);
  addtoclosure(closure720, selfslot);
  struct UserObject *uo720 = (struct UserObject*)block719;
  uo720->data[0] = (Object)closure720;
  Method *meth_meth_ast__apply720 = addmethod2pos(block719, "_apply", &meth_ast__apply720, 0);
  int argcv_meth_ast__apply720[] = {0};
  meth_meth_ast__apply720->type = alloc_MethodType(1, argcv_meth_ast__apply720);
  meth_meth_ast__apply720->definitionModule = modulename;
  meth_meth_ast__apply720->definitionLine = 141;
// compiled block node returning block719 (depth = 6)
  gc_frame_newslot(block719);
// call case 6: other member request
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  int op_slot_right_728 = gc_frame_newslot(self);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe730 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe731 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call732 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe731);
// compiled call node returning call732 (depth = 10)
// compiled member node returning call732 (depth = 9)
  partcv[0] = 0;
  Object call733 = callmethod(call732, "node",
    1, partcv, params);
  gc_frame_end(callframe730);
// compiled call node returning call733 (depth = 8)
// compiled member node returning call733 (depth = 7)
  int op_slot_left_728 = gc_frame_newslot(call733);
  params[0] = self;
  partcv[0] = 1;
  Object opresult734 = callmethod(call733, "==", 1, partcv, params);
// compiled op node returning opresult734 (depth = 6)
  params[0] = block719;
  partcv[0] = 1;
  Object call735 = callmethod(opresult734, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe718);
// compiled call node returning call735 (depth = 5)
  Object if717 = done;
  if (istrue(call735)) {
// Begin line 150
  setline(150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit737 == NULL) {
    strlit737 = alloc_String("");
    gc_root(strlit737);
  }
// compiled string node returning strlit737 (depth = 6)
  int op_slot_right_736 = gc_frame_newslot(strlit737);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe740 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe741 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call742 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe741);
// compiled call node returning call742 (depth = 10)
// compiled member node returning call742 (depth = 9)
  partcv[0] = 0;
  Object call743 = callmethod(call742, "elementScopesAsString",
    1, partcv, params);
  gc_frame_end(callframe740);
// compiled call node returning call743 (depth = 8)
// compiled member node returning call743 (depth = 7)
  int op_slot_right_739 = gc_frame_newslot(call743);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit746 == NULL) {
    strlit746 = alloc_String("");
    gc_root(strlit746);
  }
// compiled string node returning strlit746 (depth = 8)
  int op_slot_right_745 = gc_frame_newslot(strlit746);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe749 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call750 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe749);
// compiled call node returning call750 (depth = 10)
// compiled member node returning call750 (depth = 9)
  int op_slot_right_748 = gc_frame_newslot(call750);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit753 == NULL) {
    strlit753 = alloc_String("): ");
    gc_root(strlit753);
  }
// compiled string node returning strlit753 (depth = 10)
  int op_slot_right_752 = gc_frame_newslot(strlit753);
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe756 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe757 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call758 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe757);
// compiled call node returning call758 (depth = 14)
// compiled member node returning call758 (depth = 13)
  partcv[0] = 0;
  Object call759 = callmethod(call758, "variety",
    1, partcv, params);
  gc_frame_end(callframe756);
// compiled call node returning call759 (depth = 12)
// compiled member node returning call759 (depth = 11)
  int op_slot_right_755 = gc_frame_newslot(call759);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit762 == NULL) {
    strlit762 = alloc_String("Symbols(");
    gc_root(strlit762);
  }
// compiled string node returning strlit762 (depth = 12)
  int op_slot_right_761 = gc_frame_newslot(strlit762);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_spc (depth = 13)
  int op_slot_right_764 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit767 == NULL) {
    strlit767 = alloc_String("""\x0a""");
    gc_root(strlit767);
  }
// compiled string node returning strlit767 (depth = 14)
  int op_slot_right_766 = gc_frame_newslot(strlit767);
// starting to compile op node (depth = 14)
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe770 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call771 = callmethodflags(self, "kind", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe770);
// compiled call node returning call771 (depth = 16)
// compiled member node returning call771 (depth = 15)
  int op_slot_right_769 = gc_frame_newslot(call771);
// starting to compile op node (depth = 15)
// starting to compile string node (depth = 16)
  if (strlit774 == NULL) {
    strlit774 = alloc_String(" ");
    gc_root(strlit774);
  }
// compiled string node returning strlit774 (depth = 16)
  int op_slot_right_773 = gc_frame_newslot(strlit774);
// starting to compile op node (depth = 16)
// starting to compile member node (depth = 17)
// starting to compile call node (depth = 18)
  int callframe777 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call778 = callmethodflags(self, "linePos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe777);
// compiled call node returning call778 (depth = 18)
// compiled member node returning call778 (depth = 17)
  int op_slot_right_776 = gc_frame_newslot(call778);
// starting to compile op node (depth = 17)
// starting to compile string node (depth = 18)
  if (strlit781 == NULL) {
    strlit781 = alloc_String(":");
    gc_root(strlit781);
  }
// compiled string node returning strlit781 (depth = 18)
  int op_slot_right_780 = gc_frame_newslot(strlit781);
// starting to compile op node (depth = 18)
// starting to compile member node (depth = 19)
// starting to compile call node (depth = 20)
  int callframe784 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call785 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe784);
// compiled call node returning call785 (depth = 20)
// compiled member node returning call785 (depth = 19)
  int op_slot_right_783 = gc_frame_newslot(call785);
// starting to compile string node (depth = 19)
  if (strlit787 == NULL) {
    strlit787 = alloc_String("");
    gc_root(strlit787);
  }
// compiled string node returning strlit787 (depth = 19)
  int op_slot_left_783 = gc_frame_newslot(strlit787);
  params[0] = call785;
  partcv[0] = 1;
  Object opresult788 = callmethod(strlit787, "++", 1, partcv, params);
// compiled op node returning opresult788 (depth = 18)
  int op_slot_left_780 = gc_frame_newslot(opresult788);
  params[0] = strlit781;
  partcv[0] = 1;
  Object opresult789 = callmethod(opresult788, "++", 1, partcv, params);
// compiled op node returning opresult789 (depth = 17)
  int op_slot_left_776 = gc_frame_newslot(opresult789);
  params[0] = call778;
  partcv[0] = 1;
  Object opresult790 = callmethod(opresult789, "++", 1, partcv, params);
// compiled op node returning opresult790 (depth = 16)
  int op_slot_left_773 = gc_frame_newslot(opresult790);
  params[0] = strlit774;
  partcv[0] = 1;
  Object opresult791 = callmethod(opresult790, "++", 1, partcv, params);
// compiled op node returning opresult791 (depth = 15)
  int op_slot_left_769 = gc_frame_newslot(opresult791);
  params[0] = call771;
  partcv[0] = 1;
  Object opresult792 = callmethod(opresult791, "++", 1, partcv, params);
// compiled op node returning opresult792 (depth = 14)
  int op_slot_left_766 = gc_frame_newslot(opresult792);
  params[0] = strlit767;
  partcv[0] = 1;
  Object opresult793 = callmethod(opresult792, "++", 1, partcv, params);
// compiled op node returning opresult793 (depth = 13)
  int op_slot_left_764 = gc_frame_newslot(opresult793);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult794 = callmethod(opresult793, "++", 1, partcv, params);
// compiled op node returning opresult794 (depth = 12)
  int op_slot_left_761 = gc_frame_newslot(opresult794);
  params[0] = strlit762;
  partcv[0] = 1;
  Object opresult795 = callmethod(opresult794, "++", 1, partcv, params);
// compiled op node returning opresult795 (depth = 11)
  int op_slot_left_755 = gc_frame_newslot(opresult795);
  params[0] = call759;
  partcv[0] = 1;
  Object opresult796 = callmethod(opresult795, "++", 1, partcv, params);
// compiled op node returning opresult796 (depth = 10)
  int op_slot_left_752 = gc_frame_newslot(opresult796);
  params[0] = strlit753;
  partcv[0] = 1;
  Object opresult797 = callmethod(opresult796, "++", 1, partcv, params);
// compiled op node returning opresult797 (depth = 9)
  int op_slot_left_748 = gc_frame_newslot(opresult797);
  params[0] = call750;
  partcv[0] = 1;
  Object opresult798 = callmethod(opresult797, "++", 1, partcv, params);
// compiled op node returning opresult798 (depth = 8)
  int op_slot_left_745 = gc_frame_newslot(opresult798);
  params[0] = strlit746;
  partcv[0] = 1;
  Object opresult799 = callmethod(opresult798, "++", 1, partcv, params);
// compiled op node returning opresult799 (depth = 7)
  int op_slot_left_739 = gc_frame_newslot(opresult799);
  params[0] = call743;
  partcv[0] = 1;
  Object opresult800 = callmethod(opresult799, "++", 1, partcv, params);
// compiled op node returning opresult800 (depth = 6)
  int op_slot_left_736 = gc_frame_newslot(opresult800);
  params[0] = strlit737;
  partcv[0] = 1;
  Object opresult801 = callmethod(opresult800, "++", 1, partcv, params);
// compiled op node returning opresult801 (depth = 5)
    gc_frame_newslot(opresult801);
    if717 = opresult801;
  } else {
// Begin line 153
  setline(153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 151
  setline(151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit804 == NULL) {
    strlit804 = alloc_String("fake");
    gc_root(strlit804);
  }
// compiled string node returning strlit804 (depth = 7)
  int op_slot_right_803 = gc_frame_newslot(strlit804);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe806 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe807 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call808 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe807);
// compiled call node returning call808 (depth = 10)
// compiled member node returning call808 (depth = 9)
  partcv[0] = 0;
  Object call809 = callmethod(call808, "variety",
    1, partcv, params);
  gc_frame_end(callframe806);
// compiled call node returning call809 (depth = 8)
// compiled member node returning call809 (depth = 7)
  int op_slot_left_803 = gc_frame_newslot(call809);
  params[0] = strlit804;
  partcv[0] = 1;
  Object opresult810 = callmethod(call809, "==", 1, partcv, params);
// compiled op node returning opresult810 (depth = 6)
  Object if802 = done;
  if (istrue(opresult810)) {
// Begin line 152
  setline(152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit812 == NULL) {
    strlit812 = alloc_String("");
    gc_root(strlit812);
  }
// compiled string node returning strlit812 (depth = 7)
  int op_slot_right_811 = gc_frame_newslot(strlit812);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe815 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call816 = callmethodflags(self, "kind", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe815);
// compiled call node returning call816 (depth = 9)
// compiled member node returning call816 (depth = 8)
  int op_slot_right_814 = gc_frame_newslot(call816);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit819 == NULL) {
    strlit819 = alloc_String(" ");
    gc_root(strlit819);
  }
// compiled string node returning strlit819 (depth = 9)
  int op_slot_right_818 = gc_frame_newslot(strlit819);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe822 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call823 = callmethodflags(self, "linePos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe822);
// compiled call node returning call823 (depth = 11)
// compiled member node returning call823 (depth = 10)
  int op_slot_right_821 = gc_frame_newslot(call823);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit826 == NULL) {
    strlit826 = alloc_String(":");
    gc_root(strlit826);
  }
// compiled string node returning strlit826 (depth = 11)
  int op_slot_right_825 = gc_frame_newslot(strlit826);
// starting to compile op node (depth = 11)
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe829 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call830 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe829);
// compiled call node returning call830 (depth = 13)
// compiled member node returning call830 (depth = 12)
  int op_slot_right_828 = gc_frame_newslot(call830);
// starting to compile string node (depth = 12)
  if (strlit832 == NULL) {
    strlit832 = alloc_String("");
    gc_root(strlit832);
  }
// compiled string node returning strlit832 (depth = 12)
  int op_slot_left_828 = gc_frame_newslot(strlit832);
  params[0] = call830;
  partcv[0] = 1;
  Object opresult833 = callmethod(strlit832, "++", 1, partcv, params);
// compiled op node returning opresult833 (depth = 11)
  int op_slot_left_825 = gc_frame_newslot(opresult833);
  params[0] = strlit826;
  partcv[0] = 1;
  Object opresult834 = callmethod(opresult833, "++", 1, partcv, params);
// compiled op node returning opresult834 (depth = 10)
  int op_slot_left_821 = gc_frame_newslot(opresult834);
  params[0] = call823;
  partcv[0] = 1;
  Object opresult835 = callmethod(opresult834, "++", 1, partcv, params);
// compiled op node returning opresult835 (depth = 9)
  int op_slot_left_818 = gc_frame_newslot(opresult835);
  params[0] = strlit819;
  partcv[0] = 1;
  Object opresult836 = callmethod(opresult835, "++", 1, partcv, params);
// compiled op node returning opresult836 (depth = 8)
  int op_slot_left_814 = gc_frame_newslot(opresult836);
  params[0] = call816;
  partcv[0] = 1;
  Object opresult837 = callmethod(opresult836, "++", 1, partcv, params);
// compiled op node returning opresult837 (depth = 7)
  int op_slot_left_811 = gc_frame_newslot(opresult837);
  params[0] = strlit812;
  partcv[0] = 1;
  Object opresult838 = callmethod(opresult837, "++", 1, partcv, params);
// compiled op node returning opresult838 (depth = 6)
    gc_frame_newslot(opresult838);
    if802 = opresult838;
  } else {
// Begin line 154
  setline(154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit840 == NULL) {
    strlit840 = alloc_String("");
    gc_root(strlit840);
  }
// compiled string node returning strlit840 (depth = 7)
  int op_slot_right_839 = gc_frame_newslot(strlit840);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe843 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe844 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call845 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe844);
// compiled call node returning call845 (depth = 11)
// compiled member node returning call845 (depth = 10)
  partcv[0] = 0;
  Object call846 = callmethod(call845, "asDebugString",
    1, partcv, params);
  gc_frame_end(callframe843);
// compiled call node returning call846 (depth = 9)
// compiled member node returning call846 (depth = 8)
  int op_slot_right_842 = gc_frame_newslot(call846);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit849 == NULL) {
    strlit849 = alloc_String(" ");
    gc_root(strlit849);
  }
// compiled string node returning strlit849 (depth = 9)
  int op_slot_right_848 = gc_frame_newslot(strlit849);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe852 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call853 = callmethodflags(self, "kind", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe852);
// compiled call node returning call853 (depth = 11)
// compiled member node returning call853 (depth = 10)
  int op_slot_right_851 = gc_frame_newslot(call853);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit856 == NULL) {
    strlit856 = alloc_String(" ");
    gc_root(strlit856);
  }
// compiled string node returning strlit856 (depth = 11)
  int op_slot_right_855 = gc_frame_newslot(strlit856);
// starting to compile op node (depth = 11)
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe859 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call860 = callmethodflags(self, "linePos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe859);
// compiled call node returning call860 (depth = 13)
// compiled member node returning call860 (depth = 12)
  int op_slot_right_858 = gc_frame_newslot(call860);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit863 == NULL) {
    strlit863 = alloc_String(":");
    gc_root(strlit863);
  }
// compiled string node returning strlit863 (depth = 13)
  int op_slot_right_862 = gc_frame_newslot(strlit863);
// starting to compile op node (depth = 13)
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe866 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call867 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe866);
// compiled call node returning call867 (depth = 15)
// compiled member node returning call867 (depth = 14)
  int op_slot_right_865 = gc_frame_newslot(call867);
// starting to compile string node (depth = 14)
  if (strlit869 == NULL) {
    strlit869 = alloc_String("");
    gc_root(strlit869);
  }
// compiled string node returning strlit869 (depth = 14)
  int op_slot_left_865 = gc_frame_newslot(strlit869);
  params[0] = call867;
  partcv[0] = 1;
  Object opresult870 = callmethod(strlit869, "++", 1, partcv, params);
// compiled op node returning opresult870 (depth = 13)
  int op_slot_left_862 = gc_frame_newslot(opresult870);
  params[0] = strlit863;
  partcv[0] = 1;
  Object opresult871 = callmethod(opresult870, "++", 1, partcv, params);
// compiled op node returning opresult871 (depth = 12)
  int op_slot_left_858 = gc_frame_newslot(opresult871);
  params[0] = call860;
  partcv[0] = 1;
  Object opresult872 = callmethod(opresult871, "++", 1, partcv, params);
// compiled op node returning opresult872 (depth = 11)
  int op_slot_left_855 = gc_frame_newslot(opresult872);
  params[0] = strlit856;
  partcv[0] = 1;
  Object opresult873 = callmethod(opresult872, "++", 1, partcv, params);
// compiled op node returning opresult873 (depth = 10)
  int op_slot_left_851 = gc_frame_newslot(opresult873);
  params[0] = call853;
  partcv[0] = 1;
  Object opresult874 = callmethod(opresult873, "++", 1, partcv, params);
// compiled op node returning opresult874 (depth = 9)
  int op_slot_left_848 = gc_frame_newslot(opresult874);
  params[0] = strlit849;
  partcv[0] = 1;
  Object opresult875 = callmethod(opresult874, "++", 1, partcv, params);
// compiled op node returning opresult875 (depth = 8)
  int op_slot_left_842 = gc_frame_newslot(opresult875);
  params[0] = call846;
  partcv[0] = 1;
  Object opresult876 = callmethod(opresult875, "++", 1, partcv, params);
// compiled op node returning opresult876 (depth = 7)
  int op_slot_left_839 = gc_frame_newslot(opresult876);
  params[0] = strlit840;
  partcv[0] = 1;
  Object opresult877 = callmethod(opresult876, "++", 1, partcv, params);
// compiled op node returning opresult877 (depth = 6)
    gc_frame_newslot(opresult877);
    if802 = opresult877;
  }
// compiled if node returning if802 (depth = 5)
    gc_frame_newslot(if802);
    if717 = if802;
  }
// compiled if node returning if717 (depth = 4)
  gc_frame_end(frame);
  return if717;
}
Object meth_ast__apply881(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_each (depth = 6)
  gc_frame_end(frame);
  return *var_each;
}
Object meth_ast_deepCopy878(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 38, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "deepCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_ancestorChain = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for deepCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for deepCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 158
  setline(158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe879 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block880 = alloc_Block(NULL, NULL, "ast", 158);
  gc_frame_newslot(block880);
// method _apply
  block_savedest(block880);
  Object closure881 = createclosure(1, "_apply");
  setclosureframe(closure881, stackframe);
  addtoclosure(closure881, selfslot);
  struct UserObject *uo881 = (struct UserObject*)block880;
  uo881->data[0] = (Object)closure881;
  Method *meth_meth_ast__apply881 = addmethod2pos(block880, "_apply", &meth_ast__apply881, 0);
  int argcv_meth_ast__apply881[] = {1};
  meth_meth_ast__apply881->type = alloc_MethodType(1, argcv_meth_ast__apply881);
  meth_meth_ast__apply881->definitionModule = modulename;
  meth_meth_ast__apply881->definitionLine = 154;
// compiled block node returning block880 (depth = 5)
  gc_frame_newslot(block880);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe883 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ancestorChain (depth = 7)
  partcv[0] = 0;
  Object call884 = callmethod(*var_ancestorChain, "empty",
    1, partcv, params);
  gc_frame_end(callframe883);
// compiled call node returning call884 (depth = 6)
// compiled member node returning call884 (depth = 5)
  gc_frame_newslot(call884);
// call case 4: self request
  params[0] = block880;
  params[1] = call884;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call885 = callmethodflags(self, "map()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe879);
// compiled call node returning call885 (depth = 4)
  gc_frame_end(frame);
  return call885;
}
Object meth_ast_enclosingObject886(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 39, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "enclosingObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for enclosingObject (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for enclosingObject");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_obj = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "obj");
// Begin line 161
  setline(161);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe887 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe888 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe889 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call890 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe889);
// compiled call node returning call890 (depth = 10)
// compiled member node returning call890 (depth = 9)
  partcv[0] = 0;
  Object call891 = callmethod(call890, "enclosingObjectScope",
    1, partcv, params);
  gc_frame_end(callframe888);
// compiled call node returning call891 (depth = 8)
// compiled member node returning call891 (depth = 7)
  partcv[0] = 0;
  Object call892 = callmethod(call891, "node",
    1, partcv, params);
  gc_frame_end(callframe887);
// compiled call node returning call892 (depth = 6)
// compiled member node returning call892 (depth = 5)
  *var_obj = call892;
  if (call892 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 162
  setline(162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe893 = gc_frame_new();
// starting to compile num node (depth = 5)
  Object num894 = alloc_Float64(20);
// compiled num node returning num894 (depth = 5)
  gc_frame_newslot(num894);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit896 == NULL) {
    strlit896 = alloc_String("");
    gc_root(strlit896);
  }
// compiled string node returning strlit896 (depth = 6)
  int op_slot_right_895 = gc_frame_newslot(strlit896);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_obj (depth = 7)
  int op_slot_right_898 = gc_frame_newslot(*var_obj);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit901 == NULL) {
    strlit901 = alloc_String(" is ");
    gc_root(strlit901);
  }
// compiled string node returning strlit901 (depth = 8)
  int op_slot_right_900 = gc_frame_newslot(strlit901);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning self (depth = 9)
  int op_slot_right_903 = gc_frame_newslot(self);
// starting to compile string node (depth = 9)
  if (strlit905 == NULL) {
    strlit905 = alloc_String("object enclosing ");
    gc_root(strlit905);
  }
// compiled string node returning strlit905 (depth = 9)
  int op_slot_left_903 = gc_frame_newslot(strlit905);
  params[0] = self;
  partcv[0] = 1;
  Object opresult906 = callmethod(strlit905, "++", 1, partcv, params);
// compiled op node returning opresult906 (depth = 8)
  int op_slot_left_900 = gc_frame_newslot(opresult906);
  params[0] = strlit901;
  partcv[0] = 1;
  Object opresult907 = callmethod(opresult906, "++", 1, partcv, params);
// compiled op node returning opresult907 (depth = 7)
  int op_slot_left_898 = gc_frame_newslot(opresult907);
  params[0] = *var_obj;
  partcv[0] = 1;
  Object opresult908 = callmethod(opresult907, "++", 1, partcv, params);
// compiled op node returning opresult908 (depth = 6)
  int op_slot_left_895 = gc_frame_newslot(opresult908);
  params[0] = strlit896;
  partcv[0] = 1;
  Object opresult909 = callmethod(opresult908, "++", 1, partcv, params);
// compiled op node returning opresult909 (depth = 5)
  gc_frame_newslot(opresult909);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  params[0] = num894;
  params[1] = opresult909;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call910 = callmethod(*var_util, "log()verbose",
    2, partcv, params);
  gc_frame_end(callframe893);
// compiled call node returning call910 (depth = 4)
// Begin line 163
  setline(163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_obj (depth = 4)
  gc_frame_end(frame);
  return *var_obj;
}
Object meth_ast_addComment911(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addComment");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method addComment");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for addComment (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cmtNode = &(stackframe->slots[0]);
  *var_cmtNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for addComment");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 166
  setline(166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool914 = alloc_Boolean(0);
// compiled identifier node returning bool914 (depth = 6)
  int op_slot_right_913 = gc_frame_newslot(bool914);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe916 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call917 = callmethodflags(self, "comments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe916);
// compiled call node returning call917 (depth = 7)
// compiled member node returning call917 (depth = 6)
  int op_slot_left_913 = gc_frame_newslot(call917);
  params[0] = bool914;
  partcv[0] = 1;
  Object opresult918 = callmethod(call917, "==", 1, partcv, params);
// compiled op node returning opresult918 (depth = 5)
  Object if912 = done;
  if (istrue(opresult918)) {
// Begin line 167
  setline(167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 166
  setline(166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe919 = gc_frame_new();
// Begin line 167
  setline(167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_cmtNode (depth = 7)
  gc_frame_newslot(*var_cmtNode);
// call case 4: self request
  params[0] = *var_cmtNode;
  partcv[0] = 1;
  Object call920 = callmethodflags(self, "comments:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe919);
// compiled call node returning call920 (depth = 6)
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if912 = done;
  } else {
// Begin line 169
  setline(169);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe921 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_cmtNode (depth = 6)
  gc_frame_newslot(*var_cmtNode);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe922 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call923 = callmethodflags(self, "comments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe922);
// compiled call node returning call923 (depth = 7)
// compiled member node returning call923 (depth = 6)
  params[0] = *var_cmtNode;
  partcv[0] = 1;
  Object call924 = callmethod(call923, "extendCommentUsing",
    1, partcv, params);
  gc_frame_end(callframe921);
// compiled call node returning call924 (depth = 5)
    gc_frame_newslot(call924);
    if912 = call924;
  }
// compiled if node returning if912 (depth = 4)
  gc_frame_end(frame);
  return if912;
}
Object meth_ast__apply928(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 6)
  int callframe929 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  gc_frame_newslot(*var_each);
// call case 4: self request
  params[0] = *var_each;
  partcv[0] = 1;
  Object call930 = callmethodflags(self, "addComment", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe929);
// compiled call node returning call930 (depth = 6)
  gc_frame_end(frame);
  return call930;
}
Object meth_ast_addComments925(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addComments");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method addComments");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for addComments (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cmtNodeList = &(stackframe->slots[0]);
  *var_cmtNodeList = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for addComments");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 173
  setline(173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe926 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block927 = alloc_Block(NULL, NULL, "ast", 173);
  gc_frame_newslot(block927);
// method _apply
  block_savedest(block927);
  Object closure928 = createclosure(1, "_apply");
  setclosureframe(closure928, stackframe);
  addtoclosure(closure928, selfslot);
  struct UserObject *uo928 = (struct UserObject*)block927;
  uo928->data[0] = (Object)closure928;
  Method *meth_meth_ast__apply928 = addmethod2pos(block927, "_apply", &meth_ast__apply928, 0);
  int argcv_meth_ast__apply928[] = {1};
  meth_meth_ast__apply928->type = alloc_MethodType(1, argcv_meth_ast__apply928);
  meth_meth_ast__apply928->definitionModule = modulename;
  meth_meth_ast__apply928->definitionLine = 169;
// compiled block node returning block927 (depth = 5)
  gc_frame_newslot(block927);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_cmtNodeList (depth = 5)
  params[0] = block927;
  partcv[0] = 1;
  Object call932 = callmethod(*var_cmtNodeList, "do",
    1, partcv, params);
  gc_frame_end(callframe926);
// compiled call node returning call932 (depth = 4)
  gc_frame_end(frame);
  return call932;
}
Object meth_ast_new570(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_unknownType = getfromclosure(closure, 0);
  Object *var_ancestorChain = getfromclosure(closure, 1);
  Object *var_util = getfromclosure(closure, 2);
  Object *var_fakeSymbolTable = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject571 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj571 = alloc_userobj2(46,42, objclass571);
  gc_frame_newslot(obj571);
if (objclass571 == NULL) {
  glfree(obj571->class->name);
  obj571->class->name = "baseNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj571, self, 0);
  addmethodreal(obj571,"outer", &reader_ast_outer_572);
  Object oldself571 = self;
  struct StackFrameObject *oldstackframe571 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe571);
  gc_frame_newslot((Object)stackframe);
  self = obj571;
  Object *oldselfslot571 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter571 = (*(struct UserObject *)self).data[0], lowerouter571 = thisouter571;
  if (inheritingObject571) {
    struct UserObject *inho571 = (struct UserObject *)inheritingObject571;
    while (inho571->super != GraceDefaultObject) inho571 = (struct UserObject *)inho571->super;
    inho571->super = obj571;
    self = inheritingObject571;
    *selfslot = self;
    lowerouter571 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter571;
  }
if (objclass571 == NULL) {
  Method *reader573 = addmethodrealflags(obj571, "register",&reader_ast_register_573, 0);
  Method *writer573 = addmethodrealflags(obj571, "register:=",&writer_ast_register_573, 0);
  reader573->definitionModule = modulename;
  writer573->definitionModule = modulename;
  reader573->definitionLine = 87;
  writer573->definitionLine = 87;
}
obj571->flags |= OFLAG_MUTABLE;
adddatum2(obj571, alloc_Undefined(), 1);
if (objclass571 == NULL) {
  Method *reader574 = addmethodrealflags(obj571, "line",&reader_ast_line_574, 0);
  Method *writer574 = addmethodrealflags(obj571, "line:=",&writer_ast_line_574, 0);
  reader574->definitionModule = modulename;
  writer574->definitionModule = modulename;
  reader574->definitionLine = 88;
  writer574->definitionLine = 88;
}
obj571->flags |= OFLAG_MUTABLE;
adddatum2(obj571, alloc_Undefined(), 2);
if (objclass571 == NULL) {
  Method *reader575 = addmethodrealflags(obj571, "linePos",&reader_ast_linePos_575, 0);
  Method *writer575 = addmethodrealflags(obj571, "linePos:=",&writer_ast_linePos_575, 0);
  reader575->definitionModule = modulename;
  writer575->definitionModule = modulename;
  reader575->definitionLine = 89;
  writer575->definitionLine = 89;
}
obj571->flags |= OFLAG_MUTABLE;
adddatum2(obj571, alloc_Undefined(), 3);
if (objclass571 == NULL) {
  Method *reader576 = addmethodrealflags(obj571, "symbolTable",&reader_ast_symbolTable_576, MFLAG_CONFIDENTIAL);
  Method *writer576 = addmethodrealflags(obj571, "symbolTable:=",&writer_ast_symbolTable_576, MFLAG_CONFIDENTIAL);
  reader576->definitionModule = modulename;
  writer576->definitionModule = modulename;
  reader576->definitionLine = 90;
  writer576->definitionLine = 90;
}
obj571->flags |= OFLAG_MUTABLE;
adddatum2(obj571, alloc_Undefined(), 4);
if (objclass571 == NULL) {
  Method *reader577 = addmethodrealflags(obj571, "comments",&reader_ast_comments_577, 0);
  Method *writer577 = addmethodrealflags(obj571, "comments:=",&writer_ast_comments_577, 0);
  reader577->definitionModule = modulename;
  writer577->definitionModule = modulename;
  reader577->definitionLine = 91;
  writer577->definitionLine = 91;
}
obj571->flags |= OFLAG_MUTABLE;
adddatum2(obj571, alloc_Undefined(), 5);
// method kind
  struct UserObject *uo578 = (struct UserObject*)obj571;
  uo578->data[6] = emptyclosure;
  Method *meth_meth_ast_kind578 = addmethod2pos(obj571, "kind", &meth_ast_kind578, 6);
  int argcv_meth_ast_kind578[] = {0};
  meth_meth_ast_kind578->type = alloc_MethodType(1, argcv_meth_ast_kind578);
  meth_meth_ast_kind578->definitionModule = modulename;
  meth_meth_ast_kind578->definitionLine = 93;
// method isAppliedOccurenceOfIdentifier
  struct UserObject *uo581 = (struct UserObject*)obj571;
  uo581->data[7] = emptyclosure;
  Method *meth_meth_ast_isAppliedOccurenceOfIdentifier581 = addmethod2pos(obj571, "isAppliedOccurenceOfIdentifier", &meth_ast_isAppliedOccurenceOfIdentifier581, 7);
  int argcv_meth_ast_isAppliedOccurenceOfIdentifier581[] = {0};
  meth_meth_ast_isAppliedOccurenceOfIdentifier581->type = alloc_MethodType(1, argcv_meth_ast_isAppliedOccurenceOfIdentifier581);
  meth_meth_ast_isAppliedOccurenceOfIdentifier581->definitionModule = modulename;
  meth_meth_ast_isAppliedOccurenceOfIdentifier581->definitionLine = 94;
// method isMatchingBlock
  struct UserObject *uo583 = (struct UserObject*)obj571;
  uo583->data[8] = emptyclosure;
  Method *meth_meth_ast_isMatchingBlock583 = addmethod2pos(obj571, "isMatchingBlock", &meth_ast_isMatchingBlock583, 8);
  int argcv_meth_ast_isMatchingBlock583[] = {0};
  meth_meth_ast_isMatchingBlock583->type = alloc_MethodType(1, argcv_meth_ast_isMatchingBlock583);
  meth_meth_ast_isMatchingBlock583->definitionModule = modulename;
  meth_meth_ast_isMatchingBlock583->definitionLine = 95;
// method isFieldDec
  struct UserObject *uo585 = (struct UserObject*)obj571;
  uo585->data[9] = emptyclosure;
  Method *meth_meth_ast_isFieldDec585 = addmethod2pos(obj571, "isFieldDec", &meth_ast_isFieldDec585, 9);
  int argcv_meth_ast_isFieldDec585[] = {0};
  meth_meth_ast_isFieldDec585->type = alloc_MethodType(1, argcv_meth_ast_isFieldDec585);
  meth_meth_ast_isFieldDec585->definitionModule = modulename;
  meth_meth_ast_isFieldDec585->definitionLine = 96;
// method isInherits
  struct UserObject *uo587 = (struct UserObject*)obj571;
  uo587->data[10] = emptyclosure;
  Method *meth_meth_ast_isInherits587 = addmethod2pos(obj571, "isInherits", &meth_ast_isInherits587, 10);
  int argcv_meth_ast_isInherits587[] = {0};
  meth_meth_ast_isInherits587->type = alloc_MethodType(1, argcv_meth_ast_isInherits587);
  meth_meth_ast_isInherits587->definitionModule = modulename;
  meth_meth_ast_isInherits587->definitionLine = 97;
// method isMember
  struct UserObject *uo589 = (struct UserObject*)obj571;
  uo589->data[11] = emptyclosure;
  Method *meth_meth_ast_isMember589 = addmethod2pos(obj571, "isMember", &meth_ast_isMember589, 11);
  int argcv_meth_ast_isMember589[] = {0};
  meth_meth_ast_isMember589->type = alloc_MethodType(1, argcv_meth_ast_isMember589);
  meth_meth_ast_isMember589->definitionModule = modulename;
  meth_meth_ast_isMember589->definitionLine = 98;
// method isCall
  struct UserObject *uo591 = (struct UserObject*)obj571;
  uo591->data[12] = emptyclosure;
  Method *meth_meth_ast_isCall591 = addmethod2pos(obj571, "isCall", &meth_ast_isCall591, 12);
  int argcv_meth_ast_isCall591[] = {0};
  meth_meth_ast_isCall591->type = alloc_MethodType(1, argcv_meth_ast_isCall591);
  meth_meth_ast_isCall591->definitionModule = modulename;
  meth_meth_ast_isCall591->definitionLine = 99;
// method isComment
  struct UserObject *uo593 = (struct UserObject*)obj571;
  uo593->data[13] = emptyclosure;
  Method *meth_meth_ast_isComment593 = addmethod2pos(obj571, "isComment", &meth_ast_isComment593, 13);
  int argcv_meth_ast_isComment593[] = {0};
  meth_meth_ast_isComment593->type = alloc_MethodType(1, argcv_meth_ast_isComment593);
  meth_meth_ast_isComment593->definitionModule = modulename;
  meth_meth_ast_isComment593->definitionLine = 100;
// method isClass
  struct UserObject *uo595 = (struct UserObject*)obj571;
  uo595->data[14] = emptyclosure;
  Method *meth_meth_ast_isClass595 = addmethod2pos(obj571, "isClass", &meth_ast_isClass595, 14);
  int argcv_meth_ast_isClass595[] = {0};
  meth_meth_ast_isClass595->type = alloc_MethodType(1, argcv_meth_ast_isClass595);
  meth_meth_ast_isClass595->definitionModule = modulename;
  meth_meth_ast_isClass595->definitionLine = 101;
// method isBind
  struct UserObject *uo597 = (struct UserObject*)obj571;
  uo597->data[15] = emptyclosure;
  Method *meth_meth_ast_isBind597 = addmethod2pos(obj571, "isBind", &meth_ast_isBind597, 15);
  int argcv_meth_ast_isBind597[] = {0};
  meth_meth_ast_isBind597->type = alloc_MethodType(1, argcv_meth_ast_isBind597);
  meth_meth_ast_isBind597->definitionModule = modulename;
  meth_meth_ast_isBind597->definitionLine = 102;
// method isObject
  struct UserObject *uo599 = (struct UserObject*)obj571;
  uo599->data[16] = emptyclosure;
  Method *meth_meth_ast_isObject599 = addmethod2pos(obj571, "isObject", &meth_ast_isObject599, 16);
  int argcv_meth_ast_isObject599[] = {0};
  meth_meth_ast_isObject599->type = alloc_MethodType(1, argcv_meth_ast_isObject599);
  meth_meth_ast_isObject599->definitionModule = modulename;
  meth_meth_ast_isObject599->definitionLine = 103;
// method isIdentifier
  struct UserObject *uo601 = (struct UserObject*)obj571;
  uo601->data[17] = emptyclosure;
  Method *meth_meth_ast_isIdentifier601 = addmethod2pos(obj571, "isIdentifier", &meth_ast_isIdentifier601, 17);
  int argcv_meth_ast_isIdentifier601[] = {0};
  meth_meth_ast_isIdentifier601->type = alloc_MethodType(1, argcv_meth_ast_isIdentifier601);
  meth_meth_ast_isIdentifier601->definitionModule = modulename;
  meth_meth_ast_isIdentifier601->definitionLine = 104;
// method isDialect
  struct UserObject *uo603 = (struct UserObject*)obj571;
  uo603->data[18] = emptyclosure;
  Method *meth_meth_ast_isDialect603 = addmethod2pos(obj571, "isDialect", &meth_ast_isDialect603, 18);
  int argcv_meth_ast_isDialect603[] = {0};
  meth_meth_ast_isDialect603->type = alloc_MethodType(1, argcv_meth_ast_isDialect603);
  meth_meth_ast_isDialect603->definitionModule = modulename;
  meth_meth_ast_isDialect603->definitionLine = 105;
// method isImport
  struct UserObject *uo605 = (struct UserObject*)obj571;
  uo605->data[19] = emptyclosure;
  Method *meth_meth_ast_isImport605 = addmethod2pos(obj571, "isImport", &meth_ast_isImport605, 19);
  int argcv_meth_ast_isImport605[] = {0};
  meth_meth_ast_isImport605->type = alloc_MethodType(1, argcv_meth_ast_isImport605);
  meth_meth_ast_isImport605->definitionModule = modulename;
  meth_meth_ast_isImport605->definitionLine = 106;
// method canInherit
  struct UserObject *uo607 = (struct UserObject*)obj571;
  uo607->data[20] = emptyclosure;
  Method *meth_meth_ast_canInherit607 = addmethod2pos(obj571, "canInherit", &meth_ast_canInherit607, 20);
  int argcv_meth_ast_canInherit607[] = {0};
  meth_meth_ast_canInherit607->type = alloc_MethodType(1, argcv_meth_ast_canInherit607);
  meth_meth_ast_canInherit607->definitionModule = modulename;
  meth_meth_ast_canInherit607->definitionLine = 107;
// method returnsObject
  struct UserObject *uo609 = (struct UserObject*)obj571;
  uo609->data[21] = emptyclosure;
  Method *meth_meth_ast_returnsObject609 = addmethod2pos(obj571, "returnsObject", &meth_ast_returnsObject609, 21);
  int argcv_meth_ast_returnsObject609[] = {0};
  meth_meth_ast_returnsObject609->type = alloc_MethodType(1, argcv_meth_ast_returnsObject609);
  meth_meth_ast_returnsObject609->definitionModule = modulename;
  meth_meth_ast_returnsObject609->definitionLine = 108;
// method usesAsType
  struct UserObject *uo611 = (struct UserObject*)obj571;
  uo611->data[22] = emptyclosure;
  Method *meth_meth_ast_usesAsType611 = addmethod2pos(obj571, "usesAsType", &meth_ast_usesAsType611, 22);
  int argcv_meth_ast_usesAsType611[] = {1};
  meth_meth_ast_usesAsType611->type = alloc_MethodType(1, argcv_meth_ast_usesAsType611);
  meth_meth_ast_usesAsType611->definitionModule = modulename;
  meth_meth_ast_usesAsType611->definitionLine = 109;
// method hash
  struct UserObject *uo613 = (struct UserObject*)obj571;
  uo613->data[23] = emptyclosure;
  Method *meth_meth_ast_hash613 = addmethod2pos(obj571, "hash", &meth_ast_hash613, 23);
  int argcv_meth_ast_hash613[] = {0};
  meth_meth_ast_hash613->type = alloc_MethodType(1, argcv_meth_ast_hash613);
  meth_meth_ast_hash613->definitionModule = modulename;
  meth_meth_ast_hash613->definitionLine = 110;
// method asString
  struct UserObject *uo625 = (struct UserObject*)obj571;
  uo625->data[24] = emptyclosure;
  Method *meth_meth_ast_asString625 = addmethod2pos(obj571, "asString", &meth_ast_asString625, 24);
  int argcv_meth_ast_asString625[] = {0};
  meth_meth_ast_asString625->type = alloc_MethodType(1, argcv_meth_ast_asString625);
  meth_meth_ast_asString625->definitionModule = modulename;
  meth_meth_ast_asString625->definitionLine = 111;
// method nameString
  struct UserObject *uo645 = (struct UserObject*)obj571;
  uo645->data[25] = emptyclosure;
  Method *meth_meth_ast_nameString645 = addmethod2pos(obj571, "nameString", &meth_ast_nameString645, 25);
  int argcv_meth_ast_nameString645[] = {0};
  meth_meth_ast_nameString645->type = alloc_MethodType(1, argcv_meth_ast_nameString645);
  meth_meth_ast_nameString645->definitionModule = modulename;
  meth_meth_ast_nameString645->definitionLine = 112;
// method isWritable
  struct UserObject *uo647 = (struct UserObject*)obj571;
  uo647->data[26] = emptyclosure;
  Method *meth_meth_ast_isWritable647 = addmethod2pos(obj571, "isWritable", &meth_ast_isWritable647, 26);
  int argcv_meth_ast_isWritable647[] = {0};
  meth_meth_ast_isWritable647->type = alloc_MethodType(1, argcv_meth_ast_isWritable647);
  meth_meth_ast_isWritable647->definitionModule = modulename;
  meth_meth_ast_isWritable647->definitionLine = 113;
// method isReadable
  struct UserObject *uo649 = (struct UserObject*)obj571;
  uo649->data[27] = emptyclosure;
  Method *meth_meth_ast_isReadable649 = addmethod2pos(obj571, "isReadable", &meth_ast_isReadable649, 27);
  int argcv_meth_ast_isReadable649[] = {0};
  meth_meth_ast_isReadable649->type = alloc_MethodType(1, argcv_meth_ast_isReadable649);
  meth_meth_ast_isReadable649->definitionModule = modulename;
  meth_meth_ast_isReadable649->definitionLine = 114;
// method isPublic
  struct UserObject *uo651 = (struct UserObject*)obj571;
  uo651->data[28] = emptyclosure;
  Method *meth_meth_ast_isPublic651 = addmethod2pos(obj571, "isPublic", &meth_ast_isPublic651, 28);
  int argcv_meth_ast_isPublic651[] = {0};
  meth_meth_ast_isPublic651->type = alloc_MethodType(1, argcv_meth_ast_isPublic651);
  meth_meth_ast_isPublic651->definitionModule = modulename;
  meth_meth_ast_isPublic651->definitionLine = 115;
// method isConfidential
  struct UserObject *uo653 = (struct UserObject*)obj571;
  uo653->data[29] = emptyclosure;
  Method *meth_meth_ast_isConfidential653 = addmethod2pos(obj571, "isConfidential", &meth_ast_isConfidential653, 29);
  int argcv_meth_ast_isConfidential653[] = {0};
  meth_meth_ast_isConfidential653->type = alloc_MethodType(1, argcv_meth_ast_isConfidential653);
  meth_meth_ast_isConfidential653->definitionModule = modulename;
  meth_meth_ast_isConfidential653->definitionLine = 116;
// method decType
  block_savedest(obj571);
  Object closure658 = createclosure(1, "decType");
  setclosureframe(closure658, stackframe);
  addtoclosure(closure658, var_unknownType);
  struct UserObject *uo658 = (struct UserObject*)obj571;
  uo658->data[30] = (Object)closure658;
  Method *meth_meth_ast_decType658 = addmethod2pos(obj571, "decType", &meth_ast_decType658, 30);
  int argcv_meth_ast_decType658[] = {0};
  meth_meth_ast_decType658->type = alloc_MethodType(1, argcv_meth_ast_decType658);
  meth_meth_ast_decType658->definitionModule = modulename;
  meth_meth_ast_decType658->definitionLine = 117;
// method isSimple
  struct UserObject *uo668 = (struct UserObject*)obj571;
  uo668->data[31] = emptyclosure;
  Method *meth_meth_ast_isSimple668 = addmethod2pos(obj571, "isSimple", &meth_ast_isSimple668, 31);
  int argcv_meth_ast_isSimple668[] = {0};
  meth_meth_ast_isSimple668->type = alloc_MethodType(1, argcv_meth_ast_isSimple668);
  meth_meth_ast_isSimple668->definitionModule = modulename;
  meth_meth_ast_isSimple668->definitionLine = 123;
// method accept
  block_savedest(obj571);
  Object closure670 = createclosure(1, "accept");
  setclosureframe(closure670, stackframe);
  addtoclosure(closure670, var_ancestorChain);
  struct UserObject *uo670 = (struct UserObject*)obj571;
  uo670->data[32] = (Object)closure670;
  Method *meth_meth_ast_accept670 = addmethod2pos(obj571, "accept", &meth_ast_accept670, 32);
  int argcv_meth_ast_accept670[] = {1};
  meth_meth_ast_accept670->type = alloc_MethodType(1, argcv_meth_ast_accept670);
  meth_meth_ast_accept670->definitionModule = modulename;
  meth_meth_ast_accept670->definitionLine = 124;
// method scope
  struct UserObject *uo675 = (struct UserObject*)obj571;
  uo675->data[33] = emptyclosure;
  Method *meth_meth_ast_scope675 = addmethod2pos(obj571, "scope", &meth_ast_scope675, 33);
  int argcv_meth_ast_scope675[] = {0};
  meth_meth_ast_scope675->type = alloc_MethodType(1, argcv_meth_ast_scope675);
  meth_meth_ast_scope675->definitionModule = modulename;
  meth_meth_ast_scope675->definitionLine = 127;
// method scope:=
  struct UserObject *uo678 = (struct UserObject*)obj571;
  uo678->data[34] = emptyclosure;
  Method *meth_meth_ast_scope_58__61_678 = addmethod2pos(obj571, "scope:=", &meth_ast_scope_58__61_678, 34);
  int argcv_meth_ast_scope_58__61_678[] = {1};
  meth_meth_ast_scope_58__61_678->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61_678);
  meth_meth_ast_scope_58__61_678->definitionModule = modulename;
  meth_meth_ast_scope_58__61_678->definitionLine = 129;
// method declarationKindWithAncestors
  struct UserObject *uo681 = (struct UserObject*)obj571;
  uo681->data[35] = emptyclosure;
  Method *meth_meth_ast_declarationKindWithAncestors681 = addmethod2pos(obj571, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors681, 35);
  int argcv_meth_ast_declarationKindWithAncestors681[] = {1};
  meth_meth_ast_declarationKindWithAncestors681->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors681);
  meth_meth_ast_declarationKindWithAncestors681->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors681->definitionLine = 135;
// method shallowCopyFieldsFrom
  struct UserObject *uo684 = (struct UserObject*)obj571;
  uo684->data[36] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom684 = addmethod2pos(obj571, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom684, 36);
  int argcv_meth_ast_shallowCopyFieldsFrom684[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom684->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom684);
  meth_meth_ast_shallowCopyFieldsFrom684->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom684->definitionLine = 137;
// method pretty
  block_savedest(obj571);
  Object closure701 = createclosure(1, "pretty");
  setclosureframe(closure701, stackframe);
  addtoclosure(closure701, var_util);
  struct UserObject *uo701 = (struct UserObject*)obj571;
  uo701->data[37] = (Object)closure701;
  Method *meth_meth_ast_pretty701 = addmethod2pos(obj571, "pretty", &meth_ast_pretty701, 37);
  int argcv_meth_ast_pretty701[] = {1};
  meth_meth_ast_pretty701->type = alloc_MethodType(1, argcv_meth_ast_pretty701);
  meth_meth_ast_pretty701->definitionModule = modulename;
  meth_meth_ast_pretty701->definitionLine = 144;
// method deepCopy
  block_savedest(obj571);
  Object closure878 = createclosure(1, "deepCopy");
  setclosureframe(closure878, stackframe);
  addtoclosure(closure878, var_ancestorChain);
  struct UserObject *uo878 = (struct UserObject*)obj571;
  uo878->data[38] = (Object)closure878;
  Method *meth_meth_ast_deepCopy878 = addmethod2pos(obj571, "deepCopy", &meth_ast_deepCopy878, 38);
  int argcv_meth_ast_deepCopy878[] = {0};
  meth_meth_ast_deepCopy878->type = alloc_MethodType(1, argcv_meth_ast_deepCopy878);
  meth_meth_ast_deepCopy878->definitionModule = modulename;
  meth_meth_ast_deepCopy878->definitionLine = 157;
// method enclosingObject
  block_savedest(obj571);
  Object closure886 = createclosure(1, "enclosingObject");
  setclosureframe(closure886, stackframe);
  addtoclosure(closure886, var_util);
  struct UserObject *uo886 = (struct UserObject*)obj571;
  uo886->data[39] = (Object)closure886;
  Method *meth_meth_ast_enclosingObject886 = addmethod2pos(obj571, "enclosingObject", &meth_ast_enclosingObject886, 39);
  int argcv_meth_ast_enclosingObject886[] = {0};
  meth_meth_ast_enclosingObject886->type = alloc_MethodType(1, argcv_meth_ast_enclosingObject886);
  meth_meth_ast_enclosingObject886->definitionModule = modulename;
  meth_meth_ast_enclosingObject886->definitionLine = 160;
// method addComment
  struct UserObject *uo911 = (struct UserObject*)obj571;
  uo911->data[40] = emptyclosure;
  Method *meth_meth_ast_addComment911 = addmethod2pos(obj571, "addComment", &meth_ast_addComment911, 40);
  int argcv_meth_ast_addComment911[] = {1};
  meth_meth_ast_addComment911->type = alloc_MethodType(1, argcv_meth_ast_addComment911);
  meth_meth_ast_addComment911->definitionModule = modulename;
  meth_meth_ast_addComment911->definitionLine = 165;
// method addComments
  struct UserObject *uo925 = (struct UserObject*)obj571;
  uo925->data[41] = emptyclosure;
  Method *meth_meth_ast_addComments925 = addmethod2pos(obj571, "addComments", &meth_ast_addComments925, 41);
  int argcv_meth_ast_addComments925[] = {1};
  meth_meth_ast_addComments925->type = alloc_MethodType(1, argcv_meth_ast_addComments925);
  meth_meth_ast_addComments925->definitionModule = modulename;
  meth_meth_ast_addComments925->definitionLine = 172;
  sourceObject = obj571;
// Begin line 87
  setline(87);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit933 == NULL) {
    strlit933 = alloc_String("");
    gc_root(strlit933);
  }
// compiled string node returning strlit933 (depth = 4)
  adddatum2(obj571, strlit933, 1);
  sourceObject = obj571;
// Begin line 88
  setline(88);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe934 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_util (depth = 6)
  partcv[0] = 0;
  Object call935 = callmethod(*var_util, "linenum",
    1, partcv, params);
  gc_frame_end(callframe934);
// compiled call node returning call935 (depth = 5)
// compiled member node returning call935 (depth = 4)
  adddatum2(obj571, call935, 2);
  sourceObject = obj571;
// Begin line 89
  setline(89);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe936 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_util (depth = 6)
  partcv[0] = 0;
  Object call937 = callmethod(*var_util, "linepos",
    1, partcv, params);
  gc_frame_end(callframe936);
// compiled call node returning call937 (depth = 5)
// compiled member node returning call937 (depth = 4)
  adddatum2(obj571, call937, 3);
  sourceObject = obj571;
// Begin line 90
  setline(90);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_fakeSymbolTable (depth = 4)
  adddatum2(obj571, *var_fakeSymbolTable, 4);
  sourceObject = obj571;
// Begin line 91
  setline(91);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool938 = alloc_Boolean(0);
// compiled identifier node returning bool938 (depth = 4)
  adddatum2(obj571, bool938, 5);
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  objclass571 = obj571->class;
  objclass571->definitionModule = modulename;
  objclass571->definitionLine = 85;
  (*(struct UserObject *)self).data[0] = lowerouter571;
  self = oldself571;
  selfslot = oldselfslot571;
  stackframe = oldstackframe571;
  gc_frame_end(frame);
  return obj571;
}
Object meth_ast_new570_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_unknownType = getfromclosure(closure, 0);
  Object *var_ancestorChain = getfromclosure(closure, 1);
  Object *var_util = getfromclosure(closure, 2);
  Object *var_fakeSymbolTable = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject571 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj571 = alloc_userobj2(46,42, objclass571);
  gc_frame_newslot(obj571);
if (objclass571 == NULL) {
  glfree(obj571->class->name);
  obj571->class->name = "baseNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj571, self, 0);
  addmethodreal(obj571,"outer", &reader_ast_outer_572);
  Object oldself571 = self;
  struct StackFrameObject *oldstackframe571 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe571);
  gc_frame_newslot((Object)stackframe);
  self = obj571;
  Object *oldselfslot571 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter571 = (*(struct UserObject *)self).data[0], lowerouter571 = thisouter571;
  if (inheritingObject571) {
    struct UserObject *inho571 = (struct UserObject *)inheritingObject571;
    while (inho571->super != GraceDefaultObject) inho571 = (struct UserObject *)inho571->super;
    inho571->super = obj571;
    self = inheritingObject571;
    *selfslot = self;
    lowerouter571 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter571;
  }
if (objclass571 == NULL) {
  Method *reader573 = addmethodrealflags(obj571, "register",&reader_ast_register_573, 0);
  Method *writer573 = addmethodrealflags(obj571, "register:=",&writer_ast_register_573, 0);
  reader573->definitionModule = modulename;
  writer573->definitionModule = modulename;
  reader573->definitionLine = 87;
  writer573->definitionLine = 87;
}
obj571->flags |= OFLAG_MUTABLE;
adddatum2(obj571, alloc_Undefined(), 1);
if (objclass571 == NULL) {
  Method *reader574 = addmethodrealflags(obj571, "line",&reader_ast_line_574, 0);
  Method *writer574 = addmethodrealflags(obj571, "line:=",&writer_ast_line_574, 0);
  reader574->definitionModule = modulename;
  writer574->definitionModule = modulename;
  reader574->definitionLine = 88;
  writer574->definitionLine = 88;
}
obj571->flags |= OFLAG_MUTABLE;
adddatum2(obj571, alloc_Undefined(), 2);
if (objclass571 == NULL) {
  Method *reader575 = addmethodrealflags(obj571, "linePos",&reader_ast_linePos_575, 0);
  Method *writer575 = addmethodrealflags(obj571, "linePos:=",&writer_ast_linePos_575, 0);
  reader575->definitionModule = modulename;
  writer575->definitionModule = modulename;
  reader575->definitionLine = 89;
  writer575->definitionLine = 89;
}
obj571->flags |= OFLAG_MUTABLE;
adddatum2(obj571, alloc_Undefined(), 3);
if (objclass571 == NULL) {
  Method *reader576 = addmethodrealflags(obj571, "symbolTable",&reader_ast_symbolTable_576, MFLAG_CONFIDENTIAL);
  Method *writer576 = addmethodrealflags(obj571, "symbolTable:=",&writer_ast_symbolTable_576, MFLAG_CONFIDENTIAL);
  reader576->definitionModule = modulename;
  writer576->definitionModule = modulename;
  reader576->definitionLine = 90;
  writer576->definitionLine = 90;
}
obj571->flags |= OFLAG_MUTABLE;
adddatum2(obj571, alloc_Undefined(), 4);
if (objclass571 == NULL) {
  Method *reader577 = addmethodrealflags(obj571, "comments",&reader_ast_comments_577, 0);
  Method *writer577 = addmethodrealflags(obj571, "comments:=",&writer_ast_comments_577, 0);
  reader577->definitionModule = modulename;
  writer577->definitionModule = modulename;
  reader577->definitionLine = 91;
  writer577->definitionLine = 91;
}
obj571->flags |= OFLAG_MUTABLE;
adddatum2(obj571, alloc_Undefined(), 5);
// method kind
  struct UserObject *uo578 = (struct UserObject*)obj571;
  uo578->data[6] = emptyclosure;
  Method *meth_meth_ast_kind578 = addmethod2pos(obj571, "kind", &meth_ast_kind578, 6);
  int argcv_meth_ast_kind578[] = {0};
  meth_meth_ast_kind578->type = alloc_MethodType(1, argcv_meth_ast_kind578);
  meth_meth_ast_kind578->definitionModule = modulename;
  meth_meth_ast_kind578->definitionLine = 93;
// method isAppliedOccurenceOfIdentifier
  struct UserObject *uo581 = (struct UserObject*)obj571;
  uo581->data[7] = emptyclosure;
  Method *meth_meth_ast_isAppliedOccurenceOfIdentifier581 = addmethod2pos(obj571, "isAppliedOccurenceOfIdentifier", &meth_ast_isAppliedOccurenceOfIdentifier581, 7);
  int argcv_meth_ast_isAppliedOccurenceOfIdentifier581[] = {0};
  meth_meth_ast_isAppliedOccurenceOfIdentifier581->type = alloc_MethodType(1, argcv_meth_ast_isAppliedOccurenceOfIdentifier581);
  meth_meth_ast_isAppliedOccurenceOfIdentifier581->definitionModule = modulename;
  meth_meth_ast_isAppliedOccurenceOfIdentifier581->definitionLine = 94;
// method isMatchingBlock
  struct UserObject *uo583 = (struct UserObject*)obj571;
  uo583->data[8] = emptyclosure;
  Method *meth_meth_ast_isMatchingBlock583 = addmethod2pos(obj571, "isMatchingBlock", &meth_ast_isMatchingBlock583, 8);
  int argcv_meth_ast_isMatchingBlock583[] = {0};
  meth_meth_ast_isMatchingBlock583->type = alloc_MethodType(1, argcv_meth_ast_isMatchingBlock583);
  meth_meth_ast_isMatchingBlock583->definitionModule = modulename;
  meth_meth_ast_isMatchingBlock583->definitionLine = 95;
// method isFieldDec
  struct UserObject *uo585 = (struct UserObject*)obj571;
  uo585->data[9] = emptyclosure;
  Method *meth_meth_ast_isFieldDec585 = addmethod2pos(obj571, "isFieldDec", &meth_ast_isFieldDec585, 9);
  int argcv_meth_ast_isFieldDec585[] = {0};
  meth_meth_ast_isFieldDec585->type = alloc_MethodType(1, argcv_meth_ast_isFieldDec585);
  meth_meth_ast_isFieldDec585->definitionModule = modulename;
  meth_meth_ast_isFieldDec585->definitionLine = 96;
// method isInherits
  struct UserObject *uo587 = (struct UserObject*)obj571;
  uo587->data[10] = emptyclosure;
  Method *meth_meth_ast_isInherits587 = addmethod2pos(obj571, "isInherits", &meth_ast_isInherits587, 10);
  int argcv_meth_ast_isInherits587[] = {0};
  meth_meth_ast_isInherits587->type = alloc_MethodType(1, argcv_meth_ast_isInherits587);
  meth_meth_ast_isInherits587->definitionModule = modulename;
  meth_meth_ast_isInherits587->definitionLine = 97;
// method isMember
  struct UserObject *uo589 = (struct UserObject*)obj571;
  uo589->data[11] = emptyclosure;
  Method *meth_meth_ast_isMember589 = addmethod2pos(obj571, "isMember", &meth_ast_isMember589, 11);
  int argcv_meth_ast_isMember589[] = {0};
  meth_meth_ast_isMember589->type = alloc_MethodType(1, argcv_meth_ast_isMember589);
  meth_meth_ast_isMember589->definitionModule = modulename;
  meth_meth_ast_isMember589->definitionLine = 98;
// method isCall
  struct UserObject *uo591 = (struct UserObject*)obj571;
  uo591->data[12] = emptyclosure;
  Method *meth_meth_ast_isCall591 = addmethod2pos(obj571, "isCall", &meth_ast_isCall591, 12);
  int argcv_meth_ast_isCall591[] = {0};
  meth_meth_ast_isCall591->type = alloc_MethodType(1, argcv_meth_ast_isCall591);
  meth_meth_ast_isCall591->definitionModule = modulename;
  meth_meth_ast_isCall591->definitionLine = 99;
// method isComment
  struct UserObject *uo593 = (struct UserObject*)obj571;
  uo593->data[13] = emptyclosure;
  Method *meth_meth_ast_isComment593 = addmethod2pos(obj571, "isComment", &meth_ast_isComment593, 13);
  int argcv_meth_ast_isComment593[] = {0};
  meth_meth_ast_isComment593->type = alloc_MethodType(1, argcv_meth_ast_isComment593);
  meth_meth_ast_isComment593->definitionModule = modulename;
  meth_meth_ast_isComment593->definitionLine = 100;
// method isClass
  struct UserObject *uo595 = (struct UserObject*)obj571;
  uo595->data[14] = emptyclosure;
  Method *meth_meth_ast_isClass595 = addmethod2pos(obj571, "isClass", &meth_ast_isClass595, 14);
  int argcv_meth_ast_isClass595[] = {0};
  meth_meth_ast_isClass595->type = alloc_MethodType(1, argcv_meth_ast_isClass595);
  meth_meth_ast_isClass595->definitionModule = modulename;
  meth_meth_ast_isClass595->definitionLine = 101;
// method isBind
  struct UserObject *uo597 = (struct UserObject*)obj571;
  uo597->data[15] = emptyclosure;
  Method *meth_meth_ast_isBind597 = addmethod2pos(obj571, "isBind", &meth_ast_isBind597, 15);
  int argcv_meth_ast_isBind597[] = {0};
  meth_meth_ast_isBind597->type = alloc_MethodType(1, argcv_meth_ast_isBind597);
  meth_meth_ast_isBind597->definitionModule = modulename;
  meth_meth_ast_isBind597->definitionLine = 102;
// method isObject
  struct UserObject *uo599 = (struct UserObject*)obj571;
  uo599->data[16] = emptyclosure;
  Method *meth_meth_ast_isObject599 = addmethod2pos(obj571, "isObject", &meth_ast_isObject599, 16);
  int argcv_meth_ast_isObject599[] = {0};
  meth_meth_ast_isObject599->type = alloc_MethodType(1, argcv_meth_ast_isObject599);
  meth_meth_ast_isObject599->definitionModule = modulename;
  meth_meth_ast_isObject599->definitionLine = 103;
// method isIdentifier
  struct UserObject *uo601 = (struct UserObject*)obj571;
  uo601->data[17] = emptyclosure;
  Method *meth_meth_ast_isIdentifier601 = addmethod2pos(obj571, "isIdentifier", &meth_ast_isIdentifier601, 17);
  int argcv_meth_ast_isIdentifier601[] = {0};
  meth_meth_ast_isIdentifier601->type = alloc_MethodType(1, argcv_meth_ast_isIdentifier601);
  meth_meth_ast_isIdentifier601->definitionModule = modulename;
  meth_meth_ast_isIdentifier601->definitionLine = 104;
// method isDialect
  struct UserObject *uo603 = (struct UserObject*)obj571;
  uo603->data[18] = emptyclosure;
  Method *meth_meth_ast_isDialect603 = addmethod2pos(obj571, "isDialect", &meth_ast_isDialect603, 18);
  int argcv_meth_ast_isDialect603[] = {0};
  meth_meth_ast_isDialect603->type = alloc_MethodType(1, argcv_meth_ast_isDialect603);
  meth_meth_ast_isDialect603->definitionModule = modulename;
  meth_meth_ast_isDialect603->definitionLine = 105;
// method isImport
  struct UserObject *uo605 = (struct UserObject*)obj571;
  uo605->data[19] = emptyclosure;
  Method *meth_meth_ast_isImport605 = addmethod2pos(obj571, "isImport", &meth_ast_isImport605, 19);
  int argcv_meth_ast_isImport605[] = {0};
  meth_meth_ast_isImport605->type = alloc_MethodType(1, argcv_meth_ast_isImport605);
  meth_meth_ast_isImport605->definitionModule = modulename;
  meth_meth_ast_isImport605->definitionLine = 106;
// method canInherit
  struct UserObject *uo607 = (struct UserObject*)obj571;
  uo607->data[20] = emptyclosure;
  Method *meth_meth_ast_canInherit607 = addmethod2pos(obj571, "canInherit", &meth_ast_canInherit607, 20);
  int argcv_meth_ast_canInherit607[] = {0};
  meth_meth_ast_canInherit607->type = alloc_MethodType(1, argcv_meth_ast_canInherit607);
  meth_meth_ast_canInherit607->definitionModule = modulename;
  meth_meth_ast_canInherit607->definitionLine = 107;
// method returnsObject
  struct UserObject *uo609 = (struct UserObject*)obj571;
  uo609->data[21] = emptyclosure;
  Method *meth_meth_ast_returnsObject609 = addmethod2pos(obj571, "returnsObject", &meth_ast_returnsObject609, 21);
  int argcv_meth_ast_returnsObject609[] = {0};
  meth_meth_ast_returnsObject609->type = alloc_MethodType(1, argcv_meth_ast_returnsObject609);
  meth_meth_ast_returnsObject609->definitionModule = modulename;
  meth_meth_ast_returnsObject609->definitionLine = 108;
// method usesAsType
  struct UserObject *uo611 = (struct UserObject*)obj571;
  uo611->data[22] = emptyclosure;
  Method *meth_meth_ast_usesAsType611 = addmethod2pos(obj571, "usesAsType", &meth_ast_usesAsType611, 22);
  int argcv_meth_ast_usesAsType611[] = {1};
  meth_meth_ast_usesAsType611->type = alloc_MethodType(1, argcv_meth_ast_usesAsType611);
  meth_meth_ast_usesAsType611->definitionModule = modulename;
  meth_meth_ast_usesAsType611->definitionLine = 109;
// method hash
  struct UserObject *uo613 = (struct UserObject*)obj571;
  uo613->data[23] = emptyclosure;
  Method *meth_meth_ast_hash613 = addmethod2pos(obj571, "hash", &meth_ast_hash613, 23);
  int argcv_meth_ast_hash613[] = {0};
  meth_meth_ast_hash613->type = alloc_MethodType(1, argcv_meth_ast_hash613);
  meth_meth_ast_hash613->definitionModule = modulename;
  meth_meth_ast_hash613->definitionLine = 110;
// method asString
  struct UserObject *uo625 = (struct UserObject*)obj571;
  uo625->data[24] = emptyclosure;
  Method *meth_meth_ast_asString625 = addmethod2pos(obj571, "asString", &meth_ast_asString625, 24);
  int argcv_meth_ast_asString625[] = {0};
  meth_meth_ast_asString625->type = alloc_MethodType(1, argcv_meth_ast_asString625);
  meth_meth_ast_asString625->definitionModule = modulename;
  meth_meth_ast_asString625->definitionLine = 111;
// method nameString
  struct UserObject *uo645 = (struct UserObject*)obj571;
  uo645->data[25] = emptyclosure;
  Method *meth_meth_ast_nameString645 = addmethod2pos(obj571, "nameString", &meth_ast_nameString645, 25);
  int argcv_meth_ast_nameString645[] = {0};
  meth_meth_ast_nameString645->type = alloc_MethodType(1, argcv_meth_ast_nameString645);
  meth_meth_ast_nameString645->definitionModule = modulename;
  meth_meth_ast_nameString645->definitionLine = 112;
// method isWritable
  struct UserObject *uo647 = (struct UserObject*)obj571;
  uo647->data[26] = emptyclosure;
  Method *meth_meth_ast_isWritable647 = addmethod2pos(obj571, "isWritable", &meth_ast_isWritable647, 26);
  int argcv_meth_ast_isWritable647[] = {0};
  meth_meth_ast_isWritable647->type = alloc_MethodType(1, argcv_meth_ast_isWritable647);
  meth_meth_ast_isWritable647->definitionModule = modulename;
  meth_meth_ast_isWritable647->definitionLine = 113;
// method isReadable
  struct UserObject *uo649 = (struct UserObject*)obj571;
  uo649->data[27] = emptyclosure;
  Method *meth_meth_ast_isReadable649 = addmethod2pos(obj571, "isReadable", &meth_ast_isReadable649, 27);
  int argcv_meth_ast_isReadable649[] = {0};
  meth_meth_ast_isReadable649->type = alloc_MethodType(1, argcv_meth_ast_isReadable649);
  meth_meth_ast_isReadable649->definitionModule = modulename;
  meth_meth_ast_isReadable649->definitionLine = 114;
// method isPublic
  struct UserObject *uo651 = (struct UserObject*)obj571;
  uo651->data[28] = emptyclosure;
  Method *meth_meth_ast_isPublic651 = addmethod2pos(obj571, "isPublic", &meth_ast_isPublic651, 28);
  int argcv_meth_ast_isPublic651[] = {0};
  meth_meth_ast_isPublic651->type = alloc_MethodType(1, argcv_meth_ast_isPublic651);
  meth_meth_ast_isPublic651->definitionModule = modulename;
  meth_meth_ast_isPublic651->definitionLine = 115;
// method isConfidential
  struct UserObject *uo653 = (struct UserObject*)obj571;
  uo653->data[29] = emptyclosure;
  Method *meth_meth_ast_isConfidential653 = addmethod2pos(obj571, "isConfidential", &meth_ast_isConfidential653, 29);
  int argcv_meth_ast_isConfidential653[] = {0};
  meth_meth_ast_isConfidential653->type = alloc_MethodType(1, argcv_meth_ast_isConfidential653);
  meth_meth_ast_isConfidential653->definitionModule = modulename;
  meth_meth_ast_isConfidential653->definitionLine = 116;
// method decType
  block_savedest(obj571);
  Object closure658 = createclosure(1, "decType");
  setclosureframe(closure658, stackframe);
  addtoclosure(closure658, var_unknownType);
  struct UserObject *uo658 = (struct UserObject*)obj571;
  uo658->data[30] = (Object)closure658;
  Method *meth_meth_ast_decType658 = addmethod2pos(obj571, "decType", &meth_ast_decType658, 30);
  int argcv_meth_ast_decType658[] = {0};
  meth_meth_ast_decType658->type = alloc_MethodType(1, argcv_meth_ast_decType658);
  meth_meth_ast_decType658->definitionModule = modulename;
  meth_meth_ast_decType658->definitionLine = 117;
// method isSimple
  struct UserObject *uo668 = (struct UserObject*)obj571;
  uo668->data[31] = emptyclosure;
  Method *meth_meth_ast_isSimple668 = addmethod2pos(obj571, "isSimple", &meth_ast_isSimple668, 31);
  int argcv_meth_ast_isSimple668[] = {0};
  meth_meth_ast_isSimple668->type = alloc_MethodType(1, argcv_meth_ast_isSimple668);
  meth_meth_ast_isSimple668->definitionModule = modulename;
  meth_meth_ast_isSimple668->definitionLine = 123;
// method accept
  block_savedest(obj571);
  Object closure670 = createclosure(1, "accept");
  setclosureframe(closure670, stackframe);
  addtoclosure(closure670, var_ancestorChain);
  struct UserObject *uo670 = (struct UserObject*)obj571;
  uo670->data[32] = (Object)closure670;
  Method *meth_meth_ast_accept670 = addmethod2pos(obj571, "accept", &meth_ast_accept670, 32);
  int argcv_meth_ast_accept670[] = {1};
  meth_meth_ast_accept670->type = alloc_MethodType(1, argcv_meth_ast_accept670);
  meth_meth_ast_accept670->definitionModule = modulename;
  meth_meth_ast_accept670->definitionLine = 124;
// method scope
  struct UserObject *uo675 = (struct UserObject*)obj571;
  uo675->data[33] = emptyclosure;
  Method *meth_meth_ast_scope675 = addmethod2pos(obj571, "scope", &meth_ast_scope675, 33);
  int argcv_meth_ast_scope675[] = {0};
  meth_meth_ast_scope675->type = alloc_MethodType(1, argcv_meth_ast_scope675);
  meth_meth_ast_scope675->definitionModule = modulename;
  meth_meth_ast_scope675->definitionLine = 127;
// method scope:=
  struct UserObject *uo678 = (struct UserObject*)obj571;
  uo678->data[34] = emptyclosure;
  Method *meth_meth_ast_scope_58__61_678 = addmethod2pos(obj571, "scope:=", &meth_ast_scope_58__61_678, 34);
  int argcv_meth_ast_scope_58__61_678[] = {1};
  meth_meth_ast_scope_58__61_678->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61_678);
  meth_meth_ast_scope_58__61_678->definitionModule = modulename;
  meth_meth_ast_scope_58__61_678->definitionLine = 129;
// method declarationKindWithAncestors
  struct UserObject *uo681 = (struct UserObject*)obj571;
  uo681->data[35] = emptyclosure;
  Method *meth_meth_ast_declarationKindWithAncestors681 = addmethod2pos(obj571, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors681, 35);
  int argcv_meth_ast_declarationKindWithAncestors681[] = {1};
  meth_meth_ast_declarationKindWithAncestors681->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors681);
  meth_meth_ast_declarationKindWithAncestors681->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors681->definitionLine = 135;
// method shallowCopyFieldsFrom
  struct UserObject *uo684 = (struct UserObject*)obj571;
  uo684->data[36] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom684 = addmethod2pos(obj571, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom684, 36);
  int argcv_meth_ast_shallowCopyFieldsFrom684[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom684->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom684);
  meth_meth_ast_shallowCopyFieldsFrom684->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom684->definitionLine = 137;
// method pretty
  block_savedest(obj571);
  Object closure701 = createclosure(1, "pretty");
  setclosureframe(closure701, stackframe);
  addtoclosure(closure701, var_util);
  struct UserObject *uo701 = (struct UserObject*)obj571;
  uo701->data[37] = (Object)closure701;
  Method *meth_meth_ast_pretty701 = addmethod2pos(obj571, "pretty", &meth_ast_pretty701, 37);
  int argcv_meth_ast_pretty701[] = {1};
  meth_meth_ast_pretty701->type = alloc_MethodType(1, argcv_meth_ast_pretty701);
  meth_meth_ast_pretty701->definitionModule = modulename;
  meth_meth_ast_pretty701->definitionLine = 144;
// method deepCopy
  block_savedest(obj571);
  Object closure878 = createclosure(1, "deepCopy");
  setclosureframe(closure878, stackframe);
  addtoclosure(closure878, var_ancestorChain);
  struct UserObject *uo878 = (struct UserObject*)obj571;
  uo878->data[38] = (Object)closure878;
  Method *meth_meth_ast_deepCopy878 = addmethod2pos(obj571, "deepCopy", &meth_ast_deepCopy878, 38);
  int argcv_meth_ast_deepCopy878[] = {0};
  meth_meth_ast_deepCopy878->type = alloc_MethodType(1, argcv_meth_ast_deepCopy878);
  meth_meth_ast_deepCopy878->definitionModule = modulename;
  meth_meth_ast_deepCopy878->definitionLine = 157;
// method enclosingObject
  block_savedest(obj571);
  Object closure886 = createclosure(1, "enclosingObject");
  setclosureframe(closure886, stackframe);
  addtoclosure(closure886, var_util);
  struct UserObject *uo886 = (struct UserObject*)obj571;
  uo886->data[39] = (Object)closure886;
  Method *meth_meth_ast_enclosingObject886 = addmethod2pos(obj571, "enclosingObject", &meth_ast_enclosingObject886, 39);
  int argcv_meth_ast_enclosingObject886[] = {0};
  meth_meth_ast_enclosingObject886->type = alloc_MethodType(1, argcv_meth_ast_enclosingObject886);
  meth_meth_ast_enclosingObject886->definitionModule = modulename;
  meth_meth_ast_enclosingObject886->definitionLine = 160;
// method addComment
  struct UserObject *uo911 = (struct UserObject*)obj571;
  uo911->data[40] = emptyclosure;
  Method *meth_meth_ast_addComment911 = addmethod2pos(obj571, "addComment", &meth_ast_addComment911, 40);
  int argcv_meth_ast_addComment911[] = {1};
  meth_meth_ast_addComment911->type = alloc_MethodType(1, argcv_meth_ast_addComment911);
  meth_meth_ast_addComment911->definitionModule = modulename;
  meth_meth_ast_addComment911->definitionLine = 165;
// method addComments
  struct UserObject *uo925 = (struct UserObject*)obj571;
  uo925->data[41] = emptyclosure;
  Method *meth_meth_ast_addComments925 = addmethod2pos(obj571, "addComments", &meth_ast_addComments925, 41);
  int argcv_meth_ast_addComments925[] = {1};
  meth_meth_ast_addComments925->type = alloc_MethodType(1, argcv_meth_ast_addComments925);
  meth_meth_ast_addComments925->definitionModule = modulename;
  meth_meth_ast_addComments925->definitionLine = 172;
  sourceObject = obj571;
// Begin line 87
  setline(87);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit933 == NULL) {
    strlit933 = alloc_String("");
    gc_root(strlit933);
  }
// compiled string node returning strlit933 (depth = 4)
  adddatum2(obj571, strlit933, 1);
  sourceObject = obj571;
// Begin line 88
  setline(88);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe934 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_util (depth = 6)
  partcv[0] = 0;
  Object call935 = callmethod(*var_util, "linenum",
    1, partcv, params);
  gc_frame_end(callframe934);
// compiled call node returning call935 (depth = 5)
// compiled member node returning call935 (depth = 4)
  adddatum2(obj571, call935, 2);
  sourceObject = obj571;
// Begin line 89
  setline(89);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe936 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_util (depth = 6)
  partcv[0] = 0;
  Object call937 = callmethod(*var_util, "linepos",
    1, partcv, params);
  gc_frame_end(callframe936);
// compiled call node returning call937 (depth = 5)
// compiled member node returning call937 (depth = 4)
  adddatum2(obj571, call937, 3);
  sourceObject = obj571;
// Begin line 90
  setline(90);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_fakeSymbolTable (depth = 4)
  adddatum2(obj571, *var_fakeSymbolTable, 4);
  sourceObject = obj571;
// Begin line 91
  setline(91);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool938 = alloc_Boolean(0);
// compiled identifier node returning bool938 (depth = 4)
  adddatum2(obj571, bool938, 5);
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  sourceObject = obj571;
  objclass571 = obj571->class;
  objclass571->definitionModule = modulename;
  objclass571->definitionLine = 85;
  (*(struct UserObject *)self).data[0] = lowerouter571;
  self = oldself571;
  selfslot = oldselfslot571;
  stackframe = oldstackframe571;
  gc_frame_end(frame);
  return obj571;
}
Object meth_ast_toGrace943(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 181
  setline(181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit944 == NULL) {
    strlit944 = alloc_String("// null");
    gc_root(strlit944);
  }
// compiled string node returning strlit944 (depth = 3)
  gc_frame_end(frame);
  return strlit944;
}
Object meth_ast_nullNode948(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "nullNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for nullNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹nullNode›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 177
  setline(177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_nullNode (depth = 3)
  gc_frame_end(frame);
  return *var_nullNode;
}
Object meth_ast_asString952(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 187
  setline(187);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit953 == NULL) {
    strlit953 = alloc_String("fake Symbol Table");
    gc_root(strlit953);
  }
// compiled string node returning strlit953 (depth = 3)
  gc_frame_end(frame);
  return strlit953;
}
Object meth_ast_addNode_40__41_as954(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addNode()as");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method addNode()as");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method addNode()as");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for addNode()as (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for addNode");
  Object *var_kind = &(stackframe->slots[1]);
  *var_kind = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for as");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 189
  setline(189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe955 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit957 == NULL) {
    strlit957 = alloc_String("""\x22"" requested");
    gc_root(strlit957);
  }
// compiled string node returning strlit957 (depth = 5)
  int op_slot_right_956 = gc_frame_newslot(strlit957);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_kind (depth = 6)
  int op_slot_right_959 = gc_frame_newslot(*var_kind);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit962 == NULL) {
    strlit962 = alloc_String(") as ""\x22""");
    gc_root(strlit962);
  }
// compiled string node returning strlit962 (depth = 7)
  int op_slot_right_961 = gc_frame_newslot(strlit962);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  int op_slot_right_964 = gc_frame_newslot(*var_n);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit967 == NULL) {
    strlit967 = alloc_String(").addNode(");
    gc_root(strlit967);
  }
// compiled string node returning strlit967 (depth = 9)
  int op_slot_right_966 = gc_frame_newslot(strlit967);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe970 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call971 = callmethodflags(self, "node", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe970);
// compiled call node returning call971 (depth = 11)
// compiled member node returning call971 (depth = 10)
  int op_slot_right_969 = gc_frame_newslot(call971);
// starting to compile string node (depth = 10)
  if (strlit973 == NULL) {
    strlit973 = alloc_String("fakeSymbolTable(on node ");
    gc_root(strlit973);
  }
// compiled string node returning strlit973 (depth = 10)
  int op_slot_left_969 = gc_frame_newslot(strlit973);
  params[0] = call971;
  partcv[0] = 1;
  Object opresult974 = callmethod(strlit973, "++", 1, partcv, params);
// compiled op node returning opresult974 (depth = 9)
  int op_slot_left_966 = gc_frame_newslot(opresult974);
  params[0] = strlit967;
  partcv[0] = 1;
  Object opresult975 = callmethod(opresult974, "++", 1, partcv, params);
// compiled op node returning opresult975 (depth = 8)
  int op_slot_left_964 = gc_frame_newslot(opresult975);
  params[0] = *var_n;
  partcv[0] = 1;
  Object opresult976 = callmethod(opresult975, "++", 1, partcv, params);
// compiled op node returning opresult976 (depth = 7)
  int op_slot_left_961 = gc_frame_newslot(opresult976);
  params[0] = strlit962;
  partcv[0] = 1;
  Object opresult977 = callmethod(opresult976, "++", 1, partcv, params);
// compiled op node returning opresult977 (depth = 6)
  int op_slot_left_959 = gc_frame_newslot(opresult977);
  params[0] = *var_kind;
  partcv[0] = 1;
  Object opresult978 = callmethod(opresult977, "++", 1, partcv, params);
// compiled op node returning opresult978 (depth = 5)
  int op_slot_left_956 = gc_frame_newslot(opresult978);
  params[0] = strlit957;
  partcv[0] = 1;
  Object opresult979 = callmethod(opresult978, "++", 1, partcv, params);
// compiled op node returning opresult979 (depth = 4)
  gc_frame_newslot(opresult979);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe980 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call981 = callmethodflags(prelude, "ProgrammingError", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe980);
// compiled call node returning call981 (depth = 5)
// compiled member node returning call981 (depth = 4)
  params[0] = opresult979;
  partcv[0] = 1;
  Object call982 = callmethod(call981, "raise",
    1, partcv, params);
  gc_frame_end(callframe955);
// compiled call node returning call982 (depth = 3)
  gc_frame_end(frame);
  return call982;
}
Object meth_ast_thatDefines_40__41_ifNone983(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "thatDefines()ifNone");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method thatDefines()ifNone");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method thatDefines()ifNone");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for thatDefines()ifNone (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_name = &(stackframe->slots[0]);
  *var_name = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for thatDefines");
  Object *var_action = &(stackframe->slots[1]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for ifNone");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 192
  setline(192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe984 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit986 == NULL) {
    strlit986 = alloc_String(").");
    gc_root(strlit986);
  }
// compiled string node returning strlit986 (depth = 5)
  int op_slot_right_985 = gc_frame_newslot(strlit986);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_name (depth = 6)
  int op_slot_right_988 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 6)
  if (strlit990 == NULL) {
    strlit990 = alloc_String("fakeSymbolTable.thatDefines(");
    gc_root(strlit990);
  }
// compiled string node returning strlit990 (depth = 6)
  int op_slot_left_988 = gc_frame_newslot(strlit990);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult991 = callmethod(strlit990, "++", 1, partcv, params);
// compiled op node returning opresult991 (depth = 5)
  int op_slot_left_985 = gc_frame_newslot(opresult991);
  params[0] = strlit986;
  partcv[0] = 1;
  Object opresult992 = callmethod(opresult991, "++", 1, partcv, params);
// compiled op node returning opresult992 (depth = 4)
  gc_frame_newslot(opresult992);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe993 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call994 = callmethodflags(prelude, "ProgrammingError", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe993);
// compiled call node returning call994 (depth = 5)
// compiled member node returning call994 (depth = 4)
  params[0] = opresult992;
  partcv[0] = 1;
  Object call995 = callmethod(call994, "raise",
    1, partcv, params);
  gc_frame_end(callframe984);
// compiled call node returning call995 (depth = 3)
  gc_frame_end(frame);
  return call995;
}
Object meth_ast_enclosingObjectScope996(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "enclosingObjectScope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for enclosingObjectScope (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for enclosingObjectScope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 195
  setline(195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe997 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit999 == NULL) {
    strlit999 = alloc_String("");
    gc_root(strlit999);
  }
// compiled string node returning strlit999 (depth = 5)
  int op_slot_right_998 = gc_frame_newslot(strlit999);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1002 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1003 = callmethodflags(self, "node", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1002);
// compiled call node returning call1003 (depth = 7)
// compiled member node returning call1003 (depth = 6)
  int op_slot_right_1001 = gc_frame_newslot(call1003);
// starting to compile string node (depth = 6)
  if (strlit1005 == NULL) {
    strlit1005 = alloc_String("fakeSymbolTable.enclosingObjectScope on node ");
    gc_root(strlit1005);
  }
// compiled string node returning strlit1005 (depth = 6)
  int op_slot_left_1001 = gc_frame_newslot(strlit1005);
  params[0] = call1003;
  partcv[0] = 1;
  Object opresult1006 = callmethod(strlit1005, "++", 1, partcv, params);
// compiled op node returning opresult1006 (depth = 5)
  int op_slot_left_998 = gc_frame_newslot(opresult1006);
  params[0] = strlit999;
  partcv[0] = 1;
  Object opresult1007 = callmethod(opresult1006, "++", 1, partcv, params);
// compiled op node returning opresult1007 (depth = 4)
  gc_frame_newslot(opresult1007);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1008 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call1009 = callmethodflags(prelude, "ProgrammingError", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1008);
// compiled call node returning call1009 (depth = 5)
// compiled member node returning call1009 (depth = 4)
  params[0] = opresult1007;
  partcv[0] = 1;
  Object call1010 = callmethod(call1009, "raise",
    1, partcv, params);
  gc_frame_end(callframe997);
// compiled call node returning call1010 (depth = 3)
  gc_frame_end(frame);
  return call1010;
}
Object meth_ast_variety1011(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "variety");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for variety (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for variety");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 197
  setline(197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1012 == NULL) {
    strlit1012 = alloc_String("fake");
    gc_root(strlit1012);
  }
// compiled string node returning strlit1012 (depth = 3)
  gc_frame_end(frame);
  return strlit1012;
}
Object meth_ast_fakeSymbolTable1013(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "fakeSymbolTable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_fakeSymbolTable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for fakeSymbolTable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹fakeSymbolTable›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 185
  setline(185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_fakeSymbolTable (depth = 3)
  gc_frame_end(frame);
  return *var_fakeSymbolTable;
}
Object meth_ast_ifNode1014(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "ifNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ifNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for ifNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for ifNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ifNode (depth = 3)
  gc_frame_end(frame);
  return *var_ifNode;
}
Object meth_ast_isSimple1025(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSimple");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isSimple (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isSimple");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 207
  setline(207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool1026 = alloc_Boolean(0);
// compiled identifier node returning bool1026 (depth = 4)
  gc_frame_end(frame);
  return bool1026;
}
Object meth_ast_accept_40__41_from1027(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 209
  setline(209);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1029 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1030 = callmethod(*var_visitor, "visitIf()up",
    2, partcv, params);
  gc_frame_end(callframe1029);
// compiled call node returning call1030 (depth = 5)
  Object if1028 = done;
  if (istrue(call1030)) {
// Begin line 210
  setline(210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1031 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_as (depth = 7)
  params[0] = self;
  partcv[0] = 1;
  Object call1032 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe1031);
// compiled call node returning call1032 (depth = 6)
  *var_newChain = call1032;
  if (call1032 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 211
  setline(211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1033 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1034 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1035 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1034);
// compiled call node returning call1035 (depth = 7)
// compiled member node returning call1035 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1036 = callmethod(call1035, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe1033);
// compiled call node returning call1036 (depth = 5)
// Begin line 212
  setline(212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1037 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1038 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1039 = callmethodflags(self, "thenblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1038);
// compiled call node returning call1039 (depth = 7)
// compiled member node returning call1039 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1040 = callmethod(call1039, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe1037);
// compiled call node returning call1040 (depth = 5)
// Begin line 213
  setline(213);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1041 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1042 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1043 = callmethodflags(self, "elseblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1042);
// compiled call node returning call1043 (depth = 7)
// compiled member node returning call1043 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1044 = callmethod(call1043, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe1041);
// compiled call node returning call1044 (depth = 5)
    gc_frame_newslot(call1044);
    if1028 = call1044;
  } else {
  }
// compiled if node returning if1028 (depth = 4)
  gc_frame_end(frame);
  return if1028;
}
Object meth_ast_map_40__41_ancestors1045(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 217
  setline(217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1046 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1047 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1046);
// compiled call node returning call1047 (depth = 6)
// compiled member node returning call1047 (depth = 5)
  *var_n = call1047;
  if (call1047 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 218
  setline(218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1048 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call1049 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe1048);
// compiled call node returning call1049 (depth = 5)
  *var_newChain = call1049;
  if (call1049 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 219
  setline(219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 217
  setline(217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1050 = gc_frame_new();
// Begin line 219
  setline(219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1051 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1052 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1053 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1052);
// compiled call node returning call1053 (depth = 8)
// compiled member node returning call1053 (depth = 7)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1054 = callmethod(call1053, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe1051);
// compiled call node returning call1054 (depth = 6)
  gc_frame_newslot(call1054);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call1054;
  partcv[0] = 1;
  Object call1055 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe1050);
// compiled call node returning call1055 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 220
  setline(220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 219
  setline(219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1056 = gc_frame_new();
// Begin line 220
  setline(220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1057 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1058 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1059 = callmethodflags(self, "thenblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1058);
// compiled call node returning call1059 (depth = 8)
// compiled member node returning call1059 (depth = 7)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1060 = callmethod(call1059, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe1057);
// compiled call node returning call1060 (depth = 6)
  gc_frame_newslot(call1060);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call1060;
  partcv[0] = 1;
  Object call1061 = callmethod(*var_n, "thenblock:=",
    1, partcv, params);
  gc_frame_end(callframe1056);
// compiled call node returning call1061 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 221
  setline(221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 220
  setline(220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1062 = gc_frame_new();
// Begin line 221
  setline(221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1063 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1064 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1065 = callmethodflags(self, "elseblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1064);
// compiled call node returning call1065 (depth = 8)
// compiled member node returning call1065 (depth = 7)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1066 = callmethod(call1065, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe1063);
// compiled call node returning call1066 (depth = 6)
  gc_frame_newslot(call1066);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call1066;
  partcv[0] = 1;
  Object call1067 = callmethod(*var_n, "elseblock:=",
    1, partcv, params);
  gc_frame_end(callframe1062);
// compiled call node returning call1067 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 222
  setline(222);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1068 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call1069 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe1068);
// compiled call node returning call1069 (depth = 4)
  gc_frame_end(frame);
  return call1069;
}
Object meth_ast__apply1078(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 227
  setline(227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1080 == NULL) {
    strlit1080 = alloc_String("  ");
    gc_root(strlit1080);
  }
// compiled string node returning strlit1080 (depth = 8)
  int op_slot_right_1079 = gc_frame_newslot(strlit1080);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_1079 = gc_frame_newslot(*var_spc);
  params[0] = strlit1080;
  partcv[0] = 1;
  Object opresult1082 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult1082 (depth = 7)
  *var_spc = opresult1082;
  if (opresult1082 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1179(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 238
  setline(238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1181 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num1183 = alloc_Float64(2);
// compiled num node returning num1183 (depth = 11)
  int op_slot_right_1182 = gc_frame_newslot(num1183);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_1182 = gc_frame_newslot(*var_depth);
  params[0] = num1183;
  partcv[0] = 1;
  Object sum1185 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum1185 (depth = 10)
  gc_frame_newslot(sum1185);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ix (depth = 10)
  params[0] = sum1185;
  partcv[0] = 1;
  Object call1186 = callmethod(*var_ix, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1181);
// compiled call node returning call1186 (depth = 9)
  int op_slot_right_1180 = gc_frame_newslot(call1186);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_1188 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1191 == NULL) {
    strlit1191 = alloc_String("""\x0a""  ");
    gc_root(strlit1191);
  }
// compiled string node returning strlit1191 (depth = 11)
  int op_slot_right_1190 = gc_frame_newslot(strlit1191);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_1190 = gc_frame_newslot(*var_s);
  params[0] = strlit1191;
  partcv[0] = 1;
  Object opresult1193 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1193 (depth = 10)
  int op_slot_left_1188 = gc_frame_newslot(opresult1193);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1194 = callmethod(opresult1193, "++", 1, partcv, params);
// compiled op node returning opresult1194 (depth = 9)
  int op_slot_left_1180 = gc_frame_newslot(opresult1194);
  params[0] = call1186;
  partcv[0] = 1;
  Object opresult1195 = callmethod(opresult1194, "++", 1, partcv, params);
// compiled op node returning opresult1195 (depth = 8)
  *var_s = opresult1195;
  if (opresult1195 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1218(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 243
  setline(243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1220 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num1222 = alloc_Float64(2);
// compiled num node returning num1222 (depth = 11)
  int op_slot_right_1221 = gc_frame_newslot(num1222);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_1221 = gc_frame_newslot(*var_depth);
  params[0] = num1222;
  partcv[0] = 1;
  Object sum1224 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum1224 (depth = 10)
  gc_frame_newslot(sum1224);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ix (depth = 10)
  params[0] = sum1224;
  partcv[0] = 1;
  Object call1225 = callmethod(*var_ix, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1220);
// compiled call node returning call1225 (depth = 9)
  int op_slot_right_1219 = gc_frame_newslot(call1225);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_1227 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1230 == NULL) {
    strlit1230 = alloc_String("""\x0a""  ");
    gc_root(strlit1230);
  }
// compiled string node returning strlit1230 (depth = 11)
  int op_slot_right_1229 = gc_frame_newslot(strlit1230);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_1229 = gc_frame_newslot(*var_s);
  params[0] = strlit1230;
  partcv[0] = 1;
  Object opresult1232 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1232 (depth = 10)
  int op_slot_left_1227 = gc_frame_newslot(opresult1232);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1233 = callmethod(opresult1232, "++", 1, partcv, params);
// compiled op node returning opresult1233 (depth = 9)
  int op_slot_left_1219 = gc_frame_newslot(opresult1233);
  params[0] = call1225;
  partcv[0] = 1;
  Object opresult1234 = callmethod(opresult1233, "++", 1, partcv, params);
// compiled op node returning opresult1234 (depth = 8)
  *var_s = opresult1234;
  if (opresult1234 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty1070(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 225
  setline(225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1071 == NULL) {
    strlit1071 = alloc_String("");
    gc_root(strlit1071);
  }
// compiled string node returning strlit1071 (depth = 5)
  *var_spc = strlit1071;
  if (strlit1071 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 226
  setline(226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1072 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_right_1073 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 6)
  Object num1075 = alloc_Float64(0);
// compiled num node returning num1075 (depth = 6)
  int op_slot_left_1073 = gc_frame_newslot(num1075);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult1076 = callmethod(num1075, "..", 1, partcv, params);
// compiled op node returning opresult1076 (depth = 5)
  gc_frame_newslot(opresult1076);
// starting to compile block node (depth = 5)
  Object block1077 = alloc_Block(NULL, NULL, "ast", 226);
  gc_frame_newslot(block1077);
// method _apply
  block_savedest(block1077);
  Object closure1078 = createclosure(2, "_apply");
  setclosureframe(closure1078, stackframe);
  addtoclosure(closure1078, var_spc);
  addtoclosure(closure1078, selfslot);
  struct UserObject *uo1078 = (struct UserObject*)block1077;
  uo1078->data[0] = (Object)closure1078;
  Method *meth_meth_ast__apply1078 = addmethod2pos(block1077, "_apply", &meth_ast__apply1078, 0);
  int argcv_meth_ast__apply1078[] = {1};
  meth_meth_ast__apply1078->type = alloc_MethodType(1, argcv_meth_ast__apply1078);
  meth_meth_ast__apply1078->definitionModule = modulename;
  meth_meth_ast__apply1078->definitionLine = 221;
// compiled block node returning block1077 (depth = 5)
  gc_frame_newslot(block1077);
// call case 5: prelude request
  params[0] = opresult1076;
  params[1] = block1077;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1085 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1072);
// compiled call node returning call1085 (depth = 4)
// Begin line 229
  setline(229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1087 == NULL) {
    strlit1087 = alloc_String("""\x0a""");
    gc_root(strlit1087);
  }
// compiled string node returning strlit1087 (depth = 6)
  int op_slot_right_1086 = gc_frame_newslot(strlit1087);
// starting to compile call node (depth = 6)
  int callframe1089 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call1090 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe1089);
// compiled call node returning call1090 (depth = 6)
  int op_slot_left_1086 = gc_frame_newslot(call1090);
  params[0] = strlit1087;
  partcv[0] = 1;
  Object opresult1091 = callmethod(call1090, "++", 1, partcv, params);
// compiled op node returning opresult1091 (depth = 5)
  *var_s = opresult1091;
  if (opresult1091 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 230
  setline(230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1093 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1095 = alloc_Float64(1);
// compiled num node returning num1095 (depth = 8)
  int op_slot_right_1094 = gc_frame_newslot(num1095);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_1094 = gc_frame_newslot(*var_depth);
  params[0] = num1095;
  partcv[0] = 1;
  Object sum1097 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum1097 (depth = 7)
  gc_frame_newslot(sum1097);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1098 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1099 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1098);
// compiled call node returning call1099 (depth = 8)
// compiled member node returning call1099 (depth = 7)
  params[0] = sum1097;
  partcv[0] = 1;
  Object call1100 = callmethod(call1099, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1093);
// compiled call node returning call1100 (depth = 6)
  int op_slot_right_1092 = gc_frame_newslot(call1100);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_1102 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1102 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1104 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1104 (depth = 6)
  int op_slot_left_1092 = gc_frame_newslot(opresult1104);
  params[0] = call1100;
  partcv[0] = 1;
  Object opresult1105 = callmethod(opresult1104, "++", 1, partcv, params);
// compiled op node returning opresult1105 (depth = 5)
  *var_s = opresult1105;
  if (opresult1105 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 231
  setline(231);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1108 == NULL) {
    strlit1108 = alloc_String("""\x0a""");
    gc_root(strlit1108);
  }
// compiled string node returning strlit1108 (depth = 6)
  int op_slot_right_1107 = gc_frame_newslot(strlit1108);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_1107 = gc_frame_newslot(*var_s);
  params[0] = strlit1108;
  partcv[0] = 1;
  Object opresult1110 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1110 (depth = 5)
  *var_s = opresult1110;
  if (opresult1110 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 232
  setline(232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1114 == NULL) {
    strlit1114 = alloc_String("symbols");
    gc_root(strlit1114);
  }
// compiled string node returning strlit1114 (depth = 6)
  int op_slot_right_1113 = gc_frame_newslot(strlit1114);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1116 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_util (depth = 8)
  partcv[0] = 0;
  Object call1117 = callmethod(*var_util, "target",
    1, partcv, params);
  gc_frame_end(callframe1116);
// compiled call node returning call1117 (depth = 7)
// compiled member node returning call1117 (depth = 6)
  int op_slot_left_1113 = gc_frame_newslot(call1117);
  params[0] = strlit1114;
  partcv[0] = 1;
  Object opresult1118 = callmethod(call1117, "==", 1, partcv, params);
// compiled op node returning opresult1118 (depth = 5)
  Object if1112 = done;
  if (istrue(opresult1118)) {
// Begin line 233
  setline(233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1121 == NULL) {
    strlit1121 = alloc_String("""\x0a""");
    gc_root(strlit1121);
  }
// compiled string node returning strlit1121 (depth = 8)
  int op_slot_right_1120 = gc_frame_newslot(strlit1121);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1124 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num1126 = alloc_Float64(2);
// compiled num node returning num1126 (depth = 11)
  int op_slot_right_1125 = gc_frame_newslot(num1126);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_1125 = gc_frame_newslot(*var_depth);
  params[0] = num1126;
  partcv[0] = 1;
  Object sum1128 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum1128 (depth = 10)
  gc_frame_newslot(sum1128);
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1129 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1130 = callmethodflags(self, "thenblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1129);
// compiled call node returning call1130 (depth = 11)
// compiled member node returning call1130 (depth = 10)
  params[0] = sum1128;
  partcv[0] = 1;
  Object call1131 = callmethod(call1130, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1124);
// compiled call node returning call1131 (depth = 9)
  int op_slot_right_1123 = gc_frame_newslot(call1131);
// starting to compile string node (depth = 9)
  if (strlit1133 == NULL) {
    strlit1133 = alloc_String("Then: ");
    gc_root(strlit1133);
  }
// compiled string node returning strlit1133 (depth = 9)
  int op_slot_left_1123 = gc_frame_newslot(strlit1133);
  params[0] = call1131;
  partcv[0] = 1;
  Object opresult1134 = callmethod(strlit1133, "++", 1, partcv, params);
// compiled op node returning opresult1134 (depth = 8)
  int op_slot_left_1120 = gc_frame_newslot(opresult1134);
  params[0] = strlit1121;
  partcv[0] = 1;
  Object opresult1135 = callmethod(opresult1134, "++", 1, partcv, params);
// compiled op node returning opresult1135 (depth = 7)
  int op_slot_right_1119 = gc_frame_newslot(opresult1135);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_1137 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_1137 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1139 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1139 (depth = 7)
  int op_slot_left_1119 = gc_frame_newslot(opresult1139);
  params[0] = opresult1135;
  partcv[0] = 1;
  Object opresult1140 = callmethod(opresult1139, "++", 1, partcv, params);
// compiled op node returning opresult1140 (depth = 6)
  *var_s = opresult1140;
  if (opresult1140 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 234
  setline(234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1144 == NULL) {
    strlit1144 = alloc_String("");
    gc_root(strlit1144);
  }
// compiled string node returning strlit1144 (depth = 8)
  int op_slot_right_1143 = gc_frame_newslot(strlit1144);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1147 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num1149 = alloc_Float64(2);
// compiled num node returning num1149 (depth = 11)
  int op_slot_right_1148 = gc_frame_newslot(num1149);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_1148 = gc_frame_newslot(*var_depth);
  params[0] = num1149;
  partcv[0] = 1;
  Object sum1151 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum1151 (depth = 10)
  gc_frame_newslot(sum1151);
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1152 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1153 = callmethodflags(self, "elseblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1152);
// compiled call node returning call1153 (depth = 11)
// compiled member node returning call1153 (depth = 10)
  params[0] = sum1151;
  partcv[0] = 1;
  Object call1154 = callmethod(call1153, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1147);
// compiled call node returning call1154 (depth = 9)
  int op_slot_right_1146 = gc_frame_newslot(call1154);
// starting to compile string node (depth = 9)
  if (strlit1156 == NULL) {
    strlit1156 = alloc_String("Else: ");
    gc_root(strlit1156);
  }
// compiled string node returning strlit1156 (depth = 9)
  int op_slot_left_1146 = gc_frame_newslot(strlit1156);
  params[0] = call1154;
  partcv[0] = 1;
  Object opresult1157 = callmethod(strlit1156, "++", 1, partcv, params);
// compiled op node returning opresult1157 (depth = 8)
  int op_slot_left_1143 = gc_frame_newslot(opresult1157);
  params[0] = strlit1144;
  partcv[0] = 1;
  Object opresult1158 = callmethod(opresult1157, "++", 1, partcv, params);
// compiled op node returning opresult1158 (depth = 7)
  int op_slot_right_1142 = gc_frame_newslot(opresult1158);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_1160 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_1160 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1162 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1162 (depth = 7)
  int op_slot_left_1142 = gc_frame_newslot(opresult1162);
  params[0] = opresult1158;
  partcv[0] = 1;
  Object opresult1163 = callmethod(opresult1162, "++", 1, partcv, params);
// compiled op node returning opresult1163 (depth = 6)
  *var_s = opresult1163;
  if (opresult1163 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if1112 = done;
  } else {
// Begin line 236
  setline(236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1166 == NULL) {
    strlit1166 = alloc_String("Then:");
    gc_root(strlit1166);
  }
// compiled string node returning strlit1166 (depth = 7)
  int op_slot_right_1165 = gc_frame_newslot(strlit1166);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_1168 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_1168 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1170 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1170 (depth = 7)
  int op_slot_left_1165 = gc_frame_newslot(opresult1170);
  params[0] = strlit1166;
  partcv[0] = 1;
  Object opresult1171 = callmethod(opresult1170, "++", 1, partcv, params);
// compiled op node returning opresult1171 (depth = 6)
  *var_s = opresult1171;
  if (opresult1171 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 237
  setline(237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1173 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1174 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1175 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1176 = callmethodflags(self, "thenblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1175);
// compiled call node returning call1176 (depth = 9)
// compiled member node returning call1176 (depth = 8)
  partcv[0] = 0;
  Object call1177 = callmethod(call1176, "body",
    1, partcv, params);
  gc_frame_end(callframe1174);
// compiled call node returning call1177 (depth = 7)
// compiled member node returning call1177 (depth = 6)
  gc_frame_newslot(call1177);
// starting to compile block node (depth = 6)
  Object block1178 = alloc_Block(NULL, NULL, "ast", 237);
  gc_frame_newslot(block1178);
// method _apply
  block_savedest(block1178);
  Object closure1179 = createclosure(4, "_apply");
  setclosureframe(closure1179, stackframe);
  addtoclosure(closure1179, var_depth);
  addtoclosure(closure1179, var_spc);
  addtoclosure(closure1179, var_s);
  addtoclosure(closure1179, selfslot);
  struct UserObject *uo1179 = (struct UserObject*)block1178;
  uo1179->data[0] = (Object)closure1179;
  Method *meth_meth_ast__apply1179 = addmethod2pos(block1178, "_apply", &meth_ast__apply1179, 0);
  int argcv_meth_ast__apply1179[] = {1};
  meth_meth_ast__apply1179->type = alloc_MethodType(1, argcv_meth_ast__apply1179);
  meth_meth_ast__apply1179->definitionModule = modulename;
  meth_meth_ast__apply1179->definitionLine = 237;
// compiled block node returning block1178 (depth = 6)
  gc_frame_newslot(block1178);
// call case 5: prelude request
  params[0] = call1177;
  params[1] = block1178;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1198 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1173);
// compiled call node returning call1198 (depth = 5)
// Begin line 240
  setline(240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1200 == NULL) {
    strlit1200 = alloc_String("""\x0a""");
    gc_root(strlit1200);
  }
// compiled string node returning strlit1200 (depth = 7)
  int op_slot_right_1199 = gc_frame_newslot(strlit1200);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1199 = gc_frame_newslot(*var_s);
  params[0] = strlit1200;
  partcv[0] = 1;
  Object opresult1202 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1202 (depth = 6)
  *var_s = opresult1202;
  if (opresult1202 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 241
  setline(241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1205 == NULL) {
    strlit1205 = alloc_String("Else:");
    gc_root(strlit1205);
  }
// compiled string node returning strlit1205 (depth = 7)
  int op_slot_right_1204 = gc_frame_newslot(strlit1205);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_1207 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_1207 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1209 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1209 (depth = 7)
  int op_slot_left_1204 = gc_frame_newslot(opresult1209);
  params[0] = strlit1205;
  partcv[0] = 1;
  Object opresult1210 = callmethod(opresult1209, "++", 1, partcv, params);
// compiled op node returning opresult1210 (depth = 6)
  *var_s = opresult1210;
  if (opresult1210 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 242
  setline(242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1212 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1213 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1214 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1215 = callmethodflags(self, "elseblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1214);
// compiled call node returning call1215 (depth = 9)
// compiled member node returning call1215 (depth = 8)
  partcv[0] = 0;
  Object call1216 = callmethod(call1215, "body",
    1, partcv, params);
  gc_frame_end(callframe1213);
// compiled call node returning call1216 (depth = 7)
// compiled member node returning call1216 (depth = 6)
  gc_frame_newslot(call1216);
// starting to compile block node (depth = 6)
  Object block1217 = alloc_Block(NULL, NULL, "ast", 242);
  gc_frame_newslot(block1217);
// method _apply
  block_savedest(block1217);
  Object closure1218 = createclosure(4, "_apply");
  setclosureframe(closure1218, stackframe);
  addtoclosure(closure1218, var_depth);
  addtoclosure(closure1218, var_spc);
  addtoclosure(closure1218, var_s);
  addtoclosure(closure1218, selfslot);
  struct UserObject *uo1218 = (struct UserObject*)block1217;
  uo1218->data[0] = (Object)closure1218;
  Method *meth_meth_ast__apply1218 = addmethod2pos(block1217, "_apply", &meth_ast__apply1218, 0);
  int argcv_meth_ast__apply1218[] = {1};
  meth_meth_ast__apply1218->type = alloc_MethodType(1, argcv_meth_ast__apply1218);
  meth_meth_ast__apply1218->definitionModule = modulename;
  meth_meth_ast__apply1218->definitionLine = 242;
// compiled block node returning block1217 (depth = 6)
  gc_frame_newslot(block1217);
// call case 5: prelude request
  params[0] = call1216;
  params[1] = block1217;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1237 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1212);
// compiled call node returning call1237 (depth = 5)
    gc_frame_newslot(call1237);
    if1112 = call1237;
  }
// compiled if node returning if1112 (depth = 4)
// Begin line 246
  setline(246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply1242(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 6)
// Begin line 251
  setline(251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1244 == NULL) {
    strlit1244 = alloc_String("    ");
    gc_root(strlit1244);
  }
// compiled string node returning strlit1244 (depth = 8)
  int op_slot_right_1243 = gc_frame_newslot(strlit1244);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_1243 = gc_frame_newslot(*var_spc);
  params[0] = strlit1244;
  partcv[0] = 1;
  Object opresult1246 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult1246 (depth = 7)
  *var_spc = opresult1246;
  if (opresult1246 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1269(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 255
  setline(255);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1271 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1273 = alloc_Float64(1);
// compiled num node returning num1273 (depth = 10)
  int op_slot_right_1272 = gc_frame_newslot(num1273);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_1272 = gc_frame_newslot(*var_depth);
  params[0] = num1273;
  partcv[0] = 1;
  Object sum1275 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum1275 (depth = 9)
  gc_frame_newslot(sum1275);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ix (depth = 9)
  params[0] = sum1275;
  partcv[0] = 1;
  Object call1276 = callmethod(*var_ix, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe1271);
// compiled call node returning call1276 (depth = 8)
  int op_slot_right_1270 = gc_frame_newslot(call1276);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1279 == NULL) {
    strlit1279 = alloc_String("    ");
    gc_root(strlit1279);
  }
// compiled string node returning strlit1279 (depth = 9)
  int op_slot_right_1278 = gc_frame_newslot(strlit1279);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_1281 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1284 == NULL) {
    strlit1284 = alloc_String("""\x0a""");
    gc_root(strlit1284);
  }
// compiled string node returning strlit1284 (depth = 11)
  int op_slot_right_1283 = gc_frame_newslot(strlit1284);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_1283 = gc_frame_newslot(*var_s);
  params[0] = strlit1284;
  partcv[0] = 1;
  Object opresult1286 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1286 (depth = 10)
  int op_slot_left_1281 = gc_frame_newslot(opresult1286);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1287 = callmethod(opresult1286, "++", 1, partcv, params);
// compiled op node returning opresult1287 (depth = 9)
  int op_slot_left_1278 = gc_frame_newslot(opresult1287);
  params[0] = strlit1279;
  partcv[0] = 1;
  Object opresult1288 = callmethod(opresult1287, "++", 1, partcv, params);
// compiled op node returning opresult1288 (depth = 8)
  int op_slot_left_1270 = gc_frame_newslot(opresult1288);
  params[0] = call1276;
  partcv[0] = 1;
  Object opresult1289 = callmethod(opresult1288, "++", 1, partcv, params);
// compiled op node returning opresult1289 (depth = 7)
  *var_s = opresult1289;
  if (opresult1289 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1316(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 260
  setline(260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1318 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num1320 = alloc_Float64(1);
// compiled num node returning num1320 (depth = 11)
  int op_slot_right_1319 = gc_frame_newslot(num1320);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_1319 = gc_frame_newslot(*var_depth);
  params[0] = num1320;
  partcv[0] = 1;
  Object sum1322 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum1322 (depth = 10)
  gc_frame_newslot(sum1322);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ix (depth = 10)
  params[0] = sum1322;
  partcv[0] = 1;
  Object call1323 = callmethod(*var_ix, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe1318);
// compiled call node returning call1323 (depth = 9)
  int op_slot_right_1317 = gc_frame_newslot(call1323);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1326 == NULL) {
    strlit1326 = alloc_String("    ");
    gc_root(strlit1326);
  }
// compiled string node returning strlit1326 (depth = 10)
  int op_slot_right_1325 = gc_frame_newslot(strlit1326);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_1328 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit1331 == NULL) {
    strlit1331 = alloc_String("""\x0a""");
    gc_root(strlit1331);
  }
// compiled string node returning strlit1331 (depth = 12)
  int op_slot_right_1330 = gc_frame_newslot(strlit1331);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_s (depth = 12)
  int op_slot_left_1330 = gc_frame_newslot(*var_s);
  params[0] = strlit1331;
  partcv[0] = 1;
  Object opresult1333 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1333 (depth = 11)
  int op_slot_left_1328 = gc_frame_newslot(opresult1333);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1334 = callmethod(opresult1333, "++", 1, partcv, params);
// compiled op node returning opresult1334 (depth = 10)
  int op_slot_left_1325 = gc_frame_newslot(opresult1334);
  params[0] = strlit1326;
  partcv[0] = 1;
  Object opresult1335 = callmethod(opresult1334, "++", 1, partcv, params);
// compiled op node returning opresult1335 (depth = 9)
  int op_slot_left_1317 = gc_frame_newslot(opresult1335);
  params[0] = call1323;
  partcv[0] = 1;
  Object opresult1336 = callmethod(opresult1335, "++", 1, partcv, params);
// compiled op node returning opresult1336 (depth = 8)
  *var_s = opresult1336;
  if (opresult1336 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace1238(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 249
  setline(249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1239 == NULL) {
    strlit1239 = alloc_String("");
    gc_root(strlit1239);
  }
// compiled string node returning strlit1239 (depth = 5)
  *var_spc = strlit1239;
  if (strlit1239 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 250
  setline(250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1240 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  gc_frame_newslot(*var_depth);
// starting to compile block node (depth = 5)
  Object block1241 = alloc_Block(NULL, NULL, "ast", 250);
  gc_frame_newslot(block1241);
// method _apply
  block_savedest(block1241);
  Object closure1242 = createclosure(2, "_apply");
  setclosureframe(closure1242, stackframe);
  addtoclosure(closure1242, var_spc);
  addtoclosure(closure1242, selfslot);
  struct UserObject *uo1242 = (struct UserObject*)block1241;
  uo1242->data[0] = (Object)closure1242;
  Method *meth_meth_ast__apply1242 = addmethod2pos(block1241, "_apply", &meth_ast__apply1242, 0);
  int argcv_meth_ast__apply1242[] = {0};
  meth_meth_ast__apply1242->type = alloc_MethodType(1, argcv_meth_ast__apply1242);
  meth_meth_ast__apply1242->definitionModule = modulename;
  meth_meth_ast__apply1242->definitionLine = 242;
// compiled block node returning block1241 (depth = 5)
  gc_frame_newslot(block1241);
// call case 5: prelude request
  params[0] = *var_depth;
  params[1] = block1241;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1249 = callmethodflags(prelude, "repeat()times", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1240);
// compiled call node returning call1249 (depth = 4)
// Begin line 253
  setline(253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1251 == NULL) {
    strlit1251 = alloc_String(") then {");
    gc_root(strlit1251);
  }
// compiled string node returning strlit1251 (depth = 6)
  int op_slot_right_1250 = gc_frame_newslot(strlit1251);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1254 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num1255 = alloc_Float64(0);
// compiled num node returning num1255 (depth = 8)
  gc_frame_newslot(num1255);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1256 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1257 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1256);
// compiled call node returning call1257 (depth = 9)
// compiled member node returning call1257 (depth = 8)
  params[0] = num1255;
  partcv[0] = 1;
  Object call1258 = callmethod(call1257, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe1254);
// compiled call node returning call1258 (depth = 7)
  int op_slot_right_1253 = gc_frame_newslot(call1258);
// starting to compile string node (depth = 7)
  if (strlit1260 == NULL) {
    strlit1260 = alloc_String("if (");
    gc_root(strlit1260);
  }
// compiled string node returning strlit1260 (depth = 7)
  int op_slot_left_1253 = gc_frame_newslot(strlit1260);
  params[0] = call1258;
  partcv[0] = 1;
  Object opresult1261 = callmethod(strlit1260, "++", 1, partcv, params);
// compiled op node returning opresult1261 (depth = 6)
  int op_slot_left_1250 = gc_frame_newslot(opresult1261);
  params[0] = strlit1251;
  partcv[0] = 1;
  Object opresult1262 = callmethod(opresult1261, "++", 1, partcv, params);
// compiled op node returning opresult1262 (depth = 5)
  *var_s = opresult1262;
  if (opresult1262 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 254
  setline(254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1263 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1264 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1265 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1266 = callmethodflags(self, "thenblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1265);
// compiled call node returning call1266 (depth = 8)
// compiled member node returning call1266 (depth = 7)
  partcv[0] = 0;
  Object call1267 = callmethod(call1266, "body",
    1, partcv, params);
  gc_frame_end(callframe1264);
// compiled call node returning call1267 (depth = 6)
// compiled member node returning call1267 (depth = 5)
  gc_frame_newslot(call1267);
// starting to compile block node (depth = 5)
  Object block1268 = alloc_Block(NULL, NULL, "ast", 254);
  gc_frame_newslot(block1268);
// method _apply
  block_savedest(block1268);
  Object closure1269 = createclosure(4, "_apply");
  setclosureframe(closure1269, stackframe);
  addtoclosure(closure1269, var_depth);
  addtoclosure(closure1269, var_spc);
  addtoclosure(closure1269, var_s);
  addtoclosure(closure1269, selfslot);
  struct UserObject *uo1269 = (struct UserObject*)block1268;
  uo1269->data[0] = (Object)closure1269;
  Method *meth_meth_ast__apply1269 = addmethod2pos(block1268, "_apply", &meth_ast__apply1269, 0);
  int argcv_meth_ast__apply1269[] = {1};
  meth_meth_ast__apply1269->type = alloc_MethodType(1, argcv_meth_ast__apply1269);
  meth_meth_ast__apply1269->definitionModule = modulename;
  meth_meth_ast__apply1269->definitionLine = 254;
// compiled block node returning block1268 (depth = 5)
  gc_frame_newslot(block1268);
// call case 5: prelude request
  params[0] = call1267;
  params[1] = block1268;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1292 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1263);
// compiled call node returning call1292 (depth = 4)
// Begin line 257
  setline(257);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1294 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1295 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1296 = callmethodflags(self, "elseblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1295);
// compiled call node returning call1296 (depth = 8)
// compiled member node returning call1296 (depth = 7)
  partcv[0] = 0;
  Object call1297 = callmethod(call1296, "isntEmpty",
    1, partcv, params);
  gc_frame_end(callframe1294);
// compiled call node returning call1297 (depth = 6)
// compiled member node returning call1297 (depth = 5)
  Object if1293 = done;
  if (istrue(call1297)) {
// Begin line 258
  setline(258);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1299 == NULL) {
    strlit1299 = alloc_String("} else {");
    gc_root(strlit1299);
  }
// compiled string node returning strlit1299 (depth = 7)
  int op_slot_right_1298 = gc_frame_newslot(strlit1299);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_1301 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1304 == NULL) {
    strlit1304 = alloc_String("""\x0a""");
    gc_root(strlit1304);
  }
// compiled string node returning strlit1304 (depth = 9)
  int op_slot_right_1303 = gc_frame_newslot(strlit1304);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_1303 = gc_frame_newslot(*var_s);
  params[0] = strlit1304;
  partcv[0] = 1;
  Object opresult1306 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1306 (depth = 8)
  int op_slot_left_1301 = gc_frame_newslot(opresult1306);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1307 = callmethod(opresult1306, "++", 1, partcv, params);
// compiled op node returning opresult1307 (depth = 7)
  int op_slot_left_1298 = gc_frame_newslot(opresult1307);
  params[0] = strlit1299;
  partcv[0] = 1;
  Object opresult1308 = callmethod(opresult1307, "++", 1, partcv, params);
// compiled op node returning opresult1308 (depth = 6)
  *var_s = opresult1308;
  if (opresult1308 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 259
  setline(259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1310 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1311 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1312 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1313 = callmethodflags(self, "elseblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1312);
// compiled call node returning call1313 (depth = 9)
// compiled member node returning call1313 (depth = 8)
  partcv[0] = 0;
  Object call1314 = callmethod(call1313, "body",
    1, partcv, params);
  gc_frame_end(callframe1311);
// compiled call node returning call1314 (depth = 7)
// compiled member node returning call1314 (depth = 6)
  gc_frame_newslot(call1314);
// starting to compile block node (depth = 6)
  Object block1315 = alloc_Block(NULL, NULL, "ast", 259);
  gc_frame_newslot(block1315);
// method _apply
  block_savedest(block1315);
  Object closure1316 = createclosure(4, "_apply");
  setclosureframe(closure1316, stackframe);
  addtoclosure(closure1316, var_depth);
  addtoclosure(closure1316, var_spc);
  addtoclosure(closure1316, var_s);
  addtoclosure(closure1316, selfslot);
  struct UserObject *uo1316 = (struct UserObject*)block1315;
  uo1316->data[0] = (Object)closure1316;
  Method *meth_meth_ast__apply1316 = addmethod2pos(block1315, "_apply", &meth_ast__apply1316, 0);
  int argcv_meth_ast__apply1316[] = {1};
  meth_meth_ast__apply1316->type = alloc_MethodType(1, argcv_meth_ast__apply1316);
  meth_meth_ast__apply1316->definitionModule = modulename;
  meth_meth_ast__apply1316->definitionLine = 259;
// compiled block node returning block1315 (depth = 6)
  gc_frame_newslot(block1315);
// call case 5: prelude request
  params[0] = call1314;
  params[1] = block1315;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1339 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1310);
// compiled call node returning call1339 (depth = 5)
    gc_frame_newslot(call1339);
    if1293 = call1339;
  } else {
  }
// compiled if node returning if1293 (depth = 4)
// Begin line 263
  setline(263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1341 == NULL) {
    strlit1341 = alloc_String("}");
    gc_root(strlit1341);
  }
// compiled string node returning strlit1341 (depth = 6)
  int op_slot_right_1340 = gc_frame_newslot(strlit1341);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_1343 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1346 == NULL) {
    strlit1346 = alloc_String("""\x0a""");
    gc_root(strlit1346);
  }
// compiled string node returning strlit1346 (depth = 8)
  int op_slot_right_1345 = gc_frame_newslot(strlit1346);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_1345 = gc_frame_newslot(*var_s);
  params[0] = strlit1346;
  partcv[0] = 1;
  Object opresult1348 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1348 (depth = 7)
  int op_slot_left_1343 = gc_frame_newslot(opresult1348);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1349 = callmethod(opresult1348, "++", 1, partcv, params);
// compiled op node returning opresult1349 (depth = 6)
  int op_slot_left_1340 = gc_frame_newslot(opresult1349);
  params[0] = strlit1341;
  partcv[0] = 1;
  Object opresult1350 = callmethod(opresult1349, "++", 1, partcv, params);
// compiled op node returning opresult1350 (depth = 5)
  *var_s = opresult1350;
  if (opresult1350 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 264
  setline(264);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy1352(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_ifNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 267
  setline(267);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1353 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe1354 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nullNode (depth = 6)
  gc_frame_newslot(*var_nullNode);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nullNode (depth = 6)
  gc_frame_newslot(*var_nullNode);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nullNode (depth = 6)
  gc_frame_newslot(*var_nullNode);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ifNode (depth = 6)
  params[0] = *var_nullNode;
  params[1] = *var_nullNode;
  params[2] = *var_nullNode;
  partcv[0] = 3;
  Object call1355 = callmethod(*var_ifNode, "new",
    1, partcv, params);
  gc_frame_end(callframe1354);
// compiled call node returning call1355 (depth = 5)
  params[0] = self;
  partcv[0] = 1;
  Object call1356 = callmethod(call1355, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe1353);
// compiled call node returning call1356 (depth = 4)
  gc_frame_end(frame);
  return call1356;
}
Object meth_ast_shallowCopyFieldsFrom1357(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyFieldsFrom");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopyFieldsFrom (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyFieldsFrom");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 270
  setline(270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1358 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call1359 = callmethod4(self, "shallowCopyFieldsFrom", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe1358);
// compiled call node returning call1359 (depth = 4)
// Begin line 271
  setline(271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 259
  setline(259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1360 = gc_frame_new();
// Begin line 271
  setline(271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1361 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_other (depth = 8)
  partcv[0] = 0;
  Object call1362 = callmethod(*var_other, "handledIdentifiers",
    1, partcv, params);
  gc_frame_end(callframe1361);
// compiled call node returning call1362 (depth = 7)
// compiled member node returning call1362 (depth = 6)
  gc_frame_newslot(call1362);
// call case 4: self request
  params[0] = call1362;
  partcv[0] = 1;
  Object call1363 = callmethodflags(self, "handledIdentifiers:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1360);
// compiled call node returning call1363 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 272
  setline(272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_new1017(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_ifNode = getfromclosure(closure, 2);
  Object *var_baseNode = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cond = &(stackframe->slots[0]);
  *var_cond = args[curarg];
  curarg++;
  Object *var_thenblock_39_ = &(stackframe->slots[1]);
  *var_thenblock_39_ = args[curarg];
  curarg++;
  Object *var_elseblock_39_ = &(stackframe->slots[2]);
  *var_elseblock_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1018 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1018 = alloc_userobj2(17,14, objclass1018);
  gc_frame_newslot(obj1018);
if (objclass1018 == NULL) {
  glfree(obj1018->class->name);
  obj1018->class->name = "ifNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1018, self, 0);
  addmethodreal(obj1018,"outer", &reader_ast_outer_1019);
  Object oldself1018 = self;
  struct StackFrameObject *oldstackframe1018 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1018);
  gc_frame_newslot((Object)stackframe);
  self = obj1018;
  Object *oldselfslot1018 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1018 = (*(struct UserObject *)self).data[0], lowerouter1018 = thisouter1018;
  if (inheritingObject1018) {
    struct UserObject *inho1018 = (struct UserObject *)inheritingObject1018;
    while (inho1018->super != GraceDefaultObject) inho1018 = (struct UserObject *)inho1018->super;
    inho1018->super = obj1018;
    self = inheritingObject1018;
    *selfslot = self;
    lowerouter1018 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1018;
  }
if (objclass1018 == NULL) {
  Method *reader1020 = addmethodrealflags(obj1018, "kind",&reader_ast_kind_1020, MFLAG_DEF);
  reader1020->definitionModule = modulename;
  reader1020->definitionLine = 202;
}
adddatum2(obj1018, alloc_Undefined(), 1);
if (objclass1018 == NULL) {
  Method *reader1021 = addmethodrealflags(obj1018, "value",&reader_ast_value_1021, 0);
  Method *writer1021 = addmethodrealflags(obj1018, "value:=",&writer_ast_value_1021, 0);
  reader1021->definitionModule = modulename;
  writer1021->definitionModule = modulename;
  reader1021->definitionLine = 203;
  writer1021->definitionLine = 203;
}
obj1018->flags |= OFLAG_MUTABLE;
adddatum2(obj1018, alloc_Undefined(), 2);
if (objclass1018 == NULL) {
  Method *reader1022 = addmethodrealflags(obj1018, "thenblock",&reader_ast_thenblock_1022, 0);
  Method *writer1022 = addmethodrealflags(obj1018, "thenblock:=",&writer_ast_thenblock_1022, 0);
  reader1022->definitionModule = modulename;
  writer1022->definitionModule = modulename;
  reader1022->definitionLine = 204;
  writer1022->definitionLine = 204;
}
obj1018->flags |= OFLAG_MUTABLE;
adddatum2(obj1018, alloc_Undefined(), 3);
if (objclass1018 == NULL) {
  Method *reader1023 = addmethodrealflags(obj1018, "elseblock",&reader_ast_elseblock_1023, 0);
  Method *writer1023 = addmethodrealflags(obj1018, "elseblock:=",&writer_ast_elseblock_1023, 0);
  reader1023->definitionModule = modulename;
  writer1023->definitionModule = modulename;
  reader1023->definitionLine = 205;
  writer1023->definitionLine = 205;
}
obj1018->flags |= OFLAG_MUTABLE;
adddatum2(obj1018, alloc_Undefined(), 4);
if (objclass1018 == NULL) {
  Method *reader1024 = addmethodrealflags(obj1018, "handledIdentifiers",&reader_ast_handledIdentifiers_1024, 0);
  Method *writer1024 = addmethodrealflags(obj1018, "handledIdentifiers:=",&writer_ast_handledIdentifiers_1024, 0);
  reader1024->definitionModule = modulename;
  writer1024->definitionModule = modulename;
  reader1024->definitionLine = 206;
  writer1024->definitionLine = 206;
}
obj1018->flags |= OFLAG_MUTABLE;
adddatum2(obj1018, alloc_Undefined(), 5);
// method isSimple
  struct UserObject *uo1025 = (struct UserObject*)obj1018;
  uo1025->data[6] = emptyclosure;
  Method *meth_meth_ast_isSimple1025 = addmethod2pos(obj1018, "isSimple", &meth_ast_isSimple1025, 6);
  int argcv_meth_ast_isSimple1025[] = {0};
  meth_meth_ast_isSimple1025->type = alloc_MethodType(1, argcv_meth_ast_isSimple1025);
  meth_meth_ast_isSimple1025->definitionModule = modulename;
  meth_meth_ast_isSimple1025->definitionLine = 207;
// method accept()from
  struct UserObject *uo1027 = (struct UserObject*)obj1018;
  uo1027->data[7] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from1027 = addmethod2pos(obj1018, "accept()from", &meth_ast_accept_40__41_from1027, 7);
  int argcv_meth_ast_accept_40__41_from1027[] = {1, 1};
  meth_meth_ast_accept_40__41_from1027->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from1027);
  meth_meth_ast_accept_40__41_from1027->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from1027->definitionLine = 208;
// method map()ancestors
  struct UserObject *uo1045 = (struct UserObject*)obj1018;
  uo1045->data[8] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors1045 = addmethod2pos(obj1018, "map()ancestors", &meth_ast_map_40__41_ancestors1045, 8);
  int argcv_meth_ast_map_40__41_ancestors1045[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors1045->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors1045);
  meth_meth_ast_map_40__41_ancestors1045->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors1045->definitionLine = 216;
// method pretty
  block_savedest(obj1018);
  Object closure1070 = createclosure(1, "pretty");
  setclosureframe(closure1070, stackframe);
  addtoclosure(closure1070, var_util);
  struct UserObject *uo1070 = (struct UserObject*)obj1018;
  uo1070->data[9] = (Object)closure1070;
  Method *meth_meth_ast_pretty1070 = addmethod2pos(obj1018, "pretty", &meth_ast_pretty1070, 9);
  int argcv_meth_ast_pretty1070[] = {1};
  meth_meth_ast_pretty1070->type = alloc_MethodType(1, argcv_meth_ast_pretty1070);
  meth_meth_ast_pretty1070->definitionModule = modulename;
  meth_meth_ast_pretty1070->definitionLine = 224;
// method toGrace
  struct UserObject *uo1238 = (struct UserObject*)obj1018;
  uo1238->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace1238 = addmethod2pos(obj1018, "toGrace", &meth_ast_toGrace1238, 10);
  int argcv_meth_ast_toGrace1238[] = {1};
  meth_meth_ast_toGrace1238->type = alloc_MethodType(1, argcv_meth_ast_toGrace1238);
meth_meth_ast_toGrace1238->type->types[0] = type_Number;
meth_meth_ast_toGrace1238->type->names[0] = "depth";
  meth_meth_ast_toGrace1238->definitionModule = modulename;
  meth_meth_ast_toGrace1238->definitionLine = 248;
// method shallowCopy
  block_savedest(obj1018);
  Object closure1352 = createclosure(2, "shallowCopy");
  setclosureframe(closure1352, stackframe);
  addtoclosure(closure1352, var_nullNode);
  addtoclosure(closure1352, var_ifNode);
  struct UserObject *uo1352 = (struct UserObject*)obj1018;
  uo1352->data[11] = (Object)closure1352;
  Method *meth_meth_ast_shallowCopy1352 = addmethod2pos(obj1018, "shallowCopy", &meth_ast_shallowCopy1352, 11);
  int argcv_meth_ast_shallowCopy1352[] = {0};
  meth_meth_ast_shallowCopy1352->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy1352);
  meth_meth_ast_shallowCopy1352->definitionModule = modulename;
  meth_meth_ast_shallowCopy1352->definitionLine = 266;
// method shallowCopyFieldsFrom
  struct UserObject *uo1357 = (struct UserObject*)obj1018;
  uo1357->data[12] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom1357 = addmethod2pos(obj1018, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom1357, 12);
  int argcv_meth_ast_shallowCopyFieldsFrom1357[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom1357->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom1357);
  meth_meth_ast_shallowCopyFieldsFrom1357->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom1357->definitionLine = 269;
  sourceObject = obj1018;
// Begin line 201
  setline(201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1364 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1365 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe1364);
// compiled call node returning call1365 (depth = 4)
  struct UserObject *obj1018_uo = (struct UserObject *)obj1018;
  obj1018_uo->super = call1365;
  sourceObject = obj1018;
// Begin line 202
  setline(202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit1366 == NULL) {
    strlit1366 = alloc_String("if");
    gc_root(strlit1366);
  }
// compiled string node returning strlit1366 (depth = 4)
  adddatum2(obj1018, strlit1366, 1);
  sourceObject = obj1018;
// Begin line 203
  setline(203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_cond (depth = 4)
  adddatum2(obj1018, *var_cond, 2);
  sourceObject = obj1018;
// Begin line 204
  setline(204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_thenblock_39_ (depth = 4)
  adddatum2(obj1018, *var_thenblock_39_, 3);
  sourceObject = obj1018;
// Begin line 205
  setline(205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_elseblock_39_ (depth = 4)
  adddatum2(obj1018, *var_elseblock_39_, 4);
  sourceObject = obj1018;
// Begin line 206
  setline(206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool1367 = alloc_Boolean(0);
// compiled identifier node returning bool1367 (depth = 4)
  adddatum2(obj1018, bool1367, 5);
  sourceObject = obj1018;
  sourceObject = obj1018;
  sourceObject = obj1018;
  sourceObject = obj1018;
  sourceObject = obj1018;
  sourceObject = obj1018;
  sourceObject = obj1018;
  objclass1018 = obj1018->class;
  objclass1018->definitionModule = modulename;
  objclass1018->definitionLine = 200;
  (*(struct UserObject *)self).data[0] = lowerouter1018;
  self = oldself1018;
  selfslot = oldselfslot1018;
  stackframe = oldstackframe1018;
  gc_frame_end(frame);
  return obj1018;
}
Object meth_ast_new1017_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_ifNode = getfromclosure(closure, 2);
  Object *var_baseNode = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cond = &(stackframe->slots[0]);
  *var_cond = args[curarg];
  curarg++;
  Object *var_thenblock_39_ = &(stackframe->slots[1]);
  *var_thenblock_39_ = args[curarg];
  curarg++;
  Object *var_elseblock_39_ = &(stackframe->slots[2]);
  *var_elseblock_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1018 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1018 = alloc_userobj2(17,14, objclass1018);
  gc_frame_newslot(obj1018);
if (objclass1018 == NULL) {
  glfree(obj1018->class->name);
  obj1018->class->name = "ifNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1018, self, 0);
  addmethodreal(obj1018,"outer", &reader_ast_outer_1019);
  Object oldself1018 = self;
  struct StackFrameObject *oldstackframe1018 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1018);
  gc_frame_newslot((Object)stackframe);
  self = obj1018;
  Object *oldselfslot1018 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1018 = (*(struct UserObject *)self).data[0], lowerouter1018 = thisouter1018;
  if (inheritingObject1018) {
    struct UserObject *inho1018 = (struct UserObject *)inheritingObject1018;
    while (inho1018->super != GraceDefaultObject) inho1018 = (struct UserObject *)inho1018->super;
    inho1018->super = obj1018;
    self = inheritingObject1018;
    *selfslot = self;
    lowerouter1018 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1018;
  }
if (objclass1018 == NULL) {
  Method *reader1020 = addmethodrealflags(obj1018, "kind",&reader_ast_kind_1020, MFLAG_DEF);
  reader1020->definitionModule = modulename;
  reader1020->definitionLine = 202;
}
adddatum2(obj1018, alloc_Undefined(), 1);
if (objclass1018 == NULL) {
  Method *reader1021 = addmethodrealflags(obj1018, "value",&reader_ast_value_1021, 0);
  Method *writer1021 = addmethodrealflags(obj1018, "value:=",&writer_ast_value_1021, 0);
  reader1021->definitionModule = modulename;
  writer1021->definitionModule = modulename;
  reader1021->definitionLine = 203;
  writer1021->definitionLine = 203;
}
obj1018->flags |= OFLAG_MUTABLE;
adddatum2(obj1018, alloc_Undefined(), 2);
if (objclass1018 == NULL) {
  Method *reader1022 = addmethodrealflags(obj1018, "thenblock",&reader_ast_thenblock_1022, 0);
  Method *writer1022 = addmethodrealflags(obj1018, "thenblock:=",&writer_ast_thenblock_1022, 0);
  reader1022->definitionModule = modulename;
  writer1022->definitionModule = modulename;
  reader1022->definitionLine = 204;
  writer1022->definitionLine = 204;
}
obj1018->flags |= OFLAG_MUTABLE;
adddatum2(obj1018, alloc_Undefined(), 3);
if (objclass1018 == NULL) {
  Method *reader1023 = addmethodrealflags(obj1018, "elseblock",&reader_ast_elseblock_1023, 0);
  Method *writer1023 = addmethodrealflags(obj1018, "elseblock:=",&writer_ast_elseblock_1023, 0);
  reader1023->definitionModule = modulename;
  writer1023->definitionModule = modulename;
  reader1023->definitionLine = 205;
  writer1023->definitionLine = 205;
}
obj1018->flags |= OFLAG_MUTABLE;
adddatum2(obj1018, alloc_Undefined(), 4);
if (objclass1018 == NULL) {
  Method *reader1024 = addmethodrealflags(obj1018, "handledIdentifiers",&reader_ast_handledIdentifiers_1024, 0);
  Method *writer1024 = addmethodrealflags(obj1018, "handledIdentifiers:=",&writer_ast_handledIdentifiers_1024, 0);
  reader1024->definitionModule = modulename;
  writer1024->definitionModule = modulename;
  reader1024->definitionLine = 206;
  writer1024->definitionLine = 206;
}
obj1018->flags |= OFLAG_MUTABLE;
adddatum2(obj1018, alloc_Undefined(), 5);
// method isSimple
  struct UserObject *uo1025 = (struct UserObject*)obj1018;
  uo1025->data[6] = emptyclosure;
  Method *meth_meth_ast_isSimple1025 = addmethod2pos(obj1018, "isSimple", &meth_ast_isSimple1025, 6);
  int argcv_meth_ast_isSimple1025[] = {0};
  meth_meth_ast_isSimple1025->type = alloc_MethodType(1, argcv_meth_ast_isSimple1025);
  meth_meth_ast_isSimple1025->definitionModule = modulename;
  meth_meth_ast_isSimple1025->definitionLine = 207;
// method accept()from
  struct UserObject *uo1027 = (struct UserObject*)obj1018;
  uo1027->data[7] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from1027 = addmethod2pos(obj1018, "accept()from", &meth_ast_accept_40__41_from1027, 7);
  int argcv_meth_ast_accept_40__41_from1027[] = {1, 1};
  meth_meth_ast_accept_40__41_from1027->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from1027);
  meth_meth_ast_accept_40__41_from1027->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from1027->definitionLine = 208;
// method map()ancestors
  struct UserObject *uo1045 = (struct UserObject*)obj1018;
  uo1045->data[8] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors1045 = addmethod2pos(obj1018, "map()ancestors", &meth_ast_map_40__41_ancestors1045, 8);
  int argcv_meth_ast_map_40__41_ancestors1045[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors1045->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors1045);
  meth_meth_ast_map_40__41_ancestors1045->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors1045->definitionLine = 216;
// method pretty
  block_savedest(obj1018);
  Object closure1070 = createclosure(1, "pretty");
  setclosureframe(closure1070, stackframe);
  addtoclosure(closure1070, var_util);
  struct UserObject *uo1070 = (struct UserObject*)obj1018;
  uo1070->data[9] = (Object)closure1070;
  Method *meth_meth_ast_pretty1070 = addmethod2pos(obj1018, "pretty", &meth_ast_pretty1070, 9);
  int argcv_meth_ast_pretty1070[] = {1};
  meth_meth_ast_pretty1070->type = alloc_MethodType(1, argcv_meth_ast_pretty1070);
  meth_meth_ast_pretty1070->definitionModule = modulename;
  meth_meth_ast_pretty1070->definitionLine = 224;
// method toGrace
  struct UserObject *uo1238 = (struct UserObject*)obj1018;
  uo1238->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace1238 = addmethod2pos(obj1018, "toGrace", &meth_ast_toGrace1238, 10);
  int argcv_meth_ast_toGrace1238[] = {1};
  meth_meth_ast_toGrace1238->type = alloc_MethodType(1, argcv_meth_ast_toGrace1238);
meth_meth_ast_toGrace1238->type->types[0] = type_Number;
meth_meth_ast_toGrace1238->type->names[0] = "depth";
  meth_meth_ast_toGrace1238->definitionModule = modulename;
  meth_meth_ast_toGrace1238->definitionLine = 248;
// method shallowCopy
  block_savedest(obj1018);
  Object closure1352 = createclosure(2, "shallowCopy");
  setclosureframe(closure1352, stackframe);
  addtoclosure(closure1352, var_nullNode);
  addtoclosure(closure1352, var_ifNode);
  struct UserObject *uo1352 = (struct UserObject*)obj1018;
  uo1352->data[11] = (Object)closure1352;
  Method *meth_meth_ast_shallowCopy1352 = addmethod2pos(obj1018, "shallowCopy", &meth_ast_shallowCopy1352, 11);
  int argcv_meth_ast_shallowCopy1352[] = {0};
  meth_meth_ast_shallowCopy1352->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy1352);
  meth_meth_ast_shallowCopy1352->definitionModule = modulename;
  meth_meth_ast_shallowCopy1352->definitionLine = 266;
// method shallowCopyFieldsFrom
  struct UserObject *uo1357 = (struct UserObject*)obj1018;
  uo1357->data[12] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom1357 = addmethod2pos(obj1018, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom1357, 12);
  int argcv_meth_ast_shallowCopyFieldsFrom1357[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom1357->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom1357);
  meth_meth_ast_shallowCopyFieldsFrom1357->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom1357->definitionLine = 269;
  sourceObject = obj1018;
// Begin line 201
  setline(201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1364 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1365 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe1364);
// compiled call node returning call1365 (depth = 4)
  struct UserObject *obj1018_uo = (struct UserObject *)obj1018;
  obj1018_uo->super = call1365;
  sourceObject = obj1018;
// Begin line 202
  setline(202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit1366 == NULL) {
    strlit1366 = alloc_String("if");
    gc_root(strlit1366);
  }
// compiled string node returning strlit1366 (depth = 4)
  adddatum2(obj1018, strlit1366, 1);
  sourceObject = obj1018;
// Begin line 203
  setline(203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_cond (depth = 4)
  adddatum2(obj1018, *var_cond, 2);
  sourceObject = obj1018;
// Begin line 204
  setline(204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_thenblock_39_ (depth = 4)
  adddatum2(obj1018, *var_thenblock_39_, 3);
  sourceObject = obj1018;
// Begin line 205
  setline(205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_elseblock_39_ (depth = 4)
  adddatum2(obj1018, *var_elseblock_39_, 4);
  sourceObject = obj1018;
// Begin line 206
  setline(206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool1367 = alloc_Boolean(0);
// compiled identifier node returning bool1367 (depth = 4)
  adddatum2(obj1018, bool1367, 5);
  sourceObject = obj1018;
  sourceObject = obj1018;
  sourceObject = obj1018;
  sourceObject = obj1018;
  sourceObject = obj1018;
  sourceObject = obj1018;
  sourceObject = obj1018;
  objclass1018 = obj1018->class;
  objclass1018->definitionModule = modulename;
  objclass1018->definitionLine = 200;
  (*(struct UserObject *)self).data[0] = lowerouter1018;
  self = oldself1018;
  selfslot = oldselfslot1018;
  stackframe = oldstackframe1018;
  gc_frame_end(frame);
  return obj1018;
}
Object meth_ast_blockNode1369(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 17, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "blockNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blockNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for blockNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for blockNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_blockNode (depth = 3)
  gc_frame_end(frame);
  return *var_blockNode;
}
Object meth_ast_isEmpty1382(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isEmpty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isEmpty (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isEmpty");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 287
  setline(287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1384 = alloc_Float64(0);
// compiled num node returning num1384 (depth = 5)
  int op_slot_right_1383 = gc_frame_newslot(num1384);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1386 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1387 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1388 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1387);
// compiled call node returning call1388 (depth = 8)
// compiled member node returning call1388 (depth = 7)
  partcv[0] = 0;
  Object call1389 = callmethod(call1388, "size",
    1, partcv, params);
  gc_frame_end(callframe1386);
// compiled call node returning call1389 (depth = 6)
// compiled member node returning call1389 (depth = 5)
  int op_slot_left_1383 = gc_frame_newslot(call1389);
  params[0] = num1384;
  partcv[0] = 1;
  Object opresult1390 = callmethod(call1389, "==", 1, partcv, params);
// compiled op node returning opresult1390 (depth = 4)
  gc_frame_end(frame);
  return opresult1390;
}
Object meth_ast_isntEmpty1391(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isntEmpty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isntEmpty (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isntEmpty");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 288
  setline(288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1393 = alloc_Float64(0);
// compiled num node returning num1393 (depth = 5)
  int op_slot_right_1392 = gc_frame_newslot(num1393);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1395 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1396 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1397 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1396);
// compiled call node returning call1397 (depth = 8)
// compiled member node returning call1397 (depth = 7)
  partcv[0] = 0;
  Object call1398 = callmethod(call1397, "size",
    1, partcv, params);
  gc_frame_end(callframe1395);
// compiled call node returning call1398 (depth = 6)
// compiled member node returning call1398 (depth = 5)
  int op_slot_left_1392 = gc_frame_newslot(call1398);
  params[0] = num1393;
  partcv[0] = 1;
  Object opresult1399 = callmethod(call1398, ">", 1, partcv, params);
// compiled op node returning opresult1399 (depth = 4)
  gc_frame_end(frame);
  return opresult1399;
}
Object meth_ast_scope_58__61_1400(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "scope:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method scope:=");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for scope:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_st = &(stackframe->slots[0]);
  *var_st = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for scope:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 292
  setline(292);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 288
  setline(288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1401 = gc_frame_new();
// Begin line 292
  setline(292);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_st (depth = 6)
  gc_frame_newslot(*var_st);
// call case 4: self request
  params[0] = *var_st;
  partcv[0] = 1;
  Object call1402 = callmethodflags(self, "symbolTable:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1401);
// compiled call node returning call1402 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 293
  setline(293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 288
  setline(288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1403 = gc_frame_new();
// Begin line 293
  setline(293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_st (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call1404 = callmethod(*var_st, "node:=",
    1, partcv, params);
  gc_frame_end(callframe1403);
// compiled call node returning call1404 (depth = 5)
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_declarationKindWithAncestors1405(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "declarationKindWithAncestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method declarationKindWithAncestors");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for declarationKindWithAncestors (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for declarationKindWithAncestors");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 296
  setline(296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit1406 == NULL) {
    strlit1406 = alloc_String("parameter");
    gc_root(strlit1406);
  }
// compiled string node returning strlit1406 (depth = 4)
  gc_frame_end(frame);
  return strlit1406;
}
Object meth_ast_isMatchingBlock1407(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isMatchingBlock");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isMatchingBlock (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isMatchingBlock");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 298
  setline(298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1409 = alloc_Float64(1);
// compiled num node returning num1409 (depth = 5)
  int op_slot_right_1408 = gc_frame_newslot(num1409);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1411 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1412 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1413 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1412);
// compiled call node returning call1413 (depth = 8)
// compiled member node returning call1413 (depth = 7)
  partcv[0] = 0;
  Object call1414 = callmethod(call1413, "size",
    1, partcv, params);
  gc_frame_end(callframe1411);
// compiled call node returning call1414 (depth = 6)
// compiled member node returning call1414 (depth = 5)
  int op_slot_left_1408 = gc_frame_newslot(call1414);
  params[0] = num1409;
  partcv[0] = 1;
  Object opresult1415 = callmethod(call1414, "==", 1, partcv, params);
// compiled op node returning opresult1415 (depth = 4)
  gc_frame_end(frame);
  return opresult1415;
}
Object meth_ast__apply1419(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1420 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1421 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1422 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1423 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1422);
// compiled call node returning call1423 (depth = 11)
// compiled member node returning call1423 (depth = 10)
  partcv[0] = 0;
  Object call1424 = callmethod(call1423, "last",
    1, partcv, params);
  gc_frame_end(callframe1421);
// compiled call node returning call1424 (depth = 9)
// compiled member node returning call1424 (depth = 8)
  partcv[0] = 0;
  Object call1425 = callmethod(call1424, "returnsObject",
    1, partcv, params);
  gc_frame_end(callframe1420);
// compiled call node returning call1425 (depth = 7)
// compiled member node returning call1425 (depth = 6)
  gc_frame_end(frame);
  return call1425;
}
Object meth_ast_returnsObject1416(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnsObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for returnsObject (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for returnsObject");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 300
  setline(300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1417 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block1418 = alloc_Block(NULL, NULL, "ast", 300);
  gc_frame_newslot(block1418);
// method _apply
  block_savedest(block1418);
  Object closure1419 = createclosure(1, "_apply");
  setclosureframe(closure1419, stackframe);
  addtoclosure(closure1419, selfslot);
  struct UserObject *uo1419 = (struct UserObject*)block1418;
  uo1419->data[0] = (Object)closure1419;
  Method *meth_meth_ast__apply1419 = addmethod2pos(block1418, "_apply", &meth_ast__apply1419, 0);
  int argcv_meth_ast__apply1419[] = {0};
  meth_meth_ast__apply1419->type = alloc_MethodType(1, argcv_meth_ast__apply1419);
  meth_meth_ast__apply1419->definitionModule = modulename;
  meth_meth_ast__apply1419->definitionLine = 298;
// compiled block node returning block1418 (depth = 5)
  gc_frame_newslot(block1418);
// call case 6: other member request
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1428 = alloc_Float64(0);
// compiled num node returning num1428 (depth = 6)
  int op_slot_right_1427 = gc_frame_newslot(num1428);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1430 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1431 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1432 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1431);
// compiled call node returning call1432 (depth = 9)
// compiled member node returning call1432 (depth = 8)
  partcv[0] = 0;
  Object call1433 = callmethod(call1432, "size",
    1, partcv, params);
  gc_frame_end(callframe1430);
// compiled call node returning call1433 (depth = 7)
// compiled member node returning call1433 (depth = 6)
  int op_slot_left_1427 = gc_frame_newslot(call1433);
  params[0] = num1428;
  partcv[0] = 1;
  Object opresult1434 = callmethod(call1433, ">", 1, partcv, params);
// compiled op node returning opresult1434 (depth = 5)
  params[0] = block1418;
  partcv[0] = 1;
  Object call1435 = callmethod(opresult1434, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe1417);
// compiled call node returning call1435 (depth = 4)
  gc_frame_end(frame);
  return call1435;
}
Object meth_ast_returnedObjectScope1436(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnedObjectScope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for returnedObjectScope (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for returnedObjectScope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 304
  setline(304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1437 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1438 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1439 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1440 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1439);
// compiled call node returning call1440 (depth = 9)
// compiled member node returning call1440 (depth = 8)
  partcv[0] = 0;
  Object call1441 = callmethod(call1440, "last",
    1, partcv, params);
  gc_frame_end(callframe1438);
// compiled call node returning call1441 (depth = 7)
// compiled member node returning call1441 (depth = 6)
  partcv[0] = 0;
  Object call1442 = callmethod(call1441, "returnedObjectScope",
    1, partcv, params);
  gc_frame_end(callframe1437);
// compiled call node returning call1442 (depth = 5)
// compiled member node returning call1442 (depth = 4)
  gc_frame_end(frame);
  return call1442;
}
Object meth_ast_parametersDo1443(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "parametersDo");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method parametersDo");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for parametersDo (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for parametersDo");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 307
  setline(307);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1444 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_b (depth = 5)
  gc_frame_newslot(*var_b);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1445 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1446 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1445);
// compiled call node returning call1446 (depth = 6)
// compiled member node returning call1446 (depth = 5)
  params[0] = *var_b;
  partcv[0] = 1;
  Object call1447 = callmethod(call1446, "do",
    1, partcv, params);
  gc_frame_end(callframe1444);
// compiled call node returning call1447 (depth = 4)
  gc_frame_end(frame);
  return call1447;
}
Object meth_ast__apply1458(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 313
  setline(313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1459 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_visitor (depth = 8)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_newChain (depth = 8)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mx (depth = 8)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1460 = callmethod(*var_mx, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe1459);
// compiled call node returning call1460 (depth = 7)
  gc_frame_end(frame);
  return call1460;
}
Object meth_ast__apply1467(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 316
  setline(316);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1468 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_visitor (depth = 8)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_newChain (depth = 8)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mx (depth = 8)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1469 = callmethod(*var_mx, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe1468);
// compiled call node returning call1469 (depth = 7)
  gc_frame_end(frame);
  return call1469;
}
Object meth_ast_accept_40__41_from1448(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 310
  setline(310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1450 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1451 = callmethod(*var_visitor, "visitBlock()up",
    2, partcv, params);
  gc_frame_end(callframe1450);
// compiled call node returning call1451 (depth = 5)
  Object if1449 = done;
  if (istrue(call1451)) {
// Begin line 311
  setline(311);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1452 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_as (depth = 7)
  params[0] = self;
  partcv[0] = 1;
  Object call1453 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe1452);
// compiled call node returning call1453 (depth = 6)
  *var_newChain = call1453;
  if (call1453 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 312
  setline(312);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1454 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1455 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1456 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1455);
// compiled call node returning call1456 (depth = 7)
// compiled member node returning call1456 (depth = 6)
  gc_frame_newslot(call1456);
// starting to compile block node (depth = 6)
  Object block1457 = alloc_Block(NULL, NULL, "ast", 312);
  gc_frame_newslot(block1457);
// method _apply
  block_savedest(block1457);
  Object closure1458 = createclosure(3, "_apply");
  setclosureframe(closure1458, stackframe);
  addtoclosure(closure1458, var_visitor);
  addtoclosure(closure1458, var_newChain);
  addtoclosure(closure1458, selfslot);
  struct UserObject *uo1458 = (struct UserObject*)block1457;
  uo1458->data[0] = (Object)closure1458;
  Method *meth_meth_ast__apply1458 = addmethod2pos(block1457, "_apply", &meth_ast__apply1458, 0);
  int argcv_meth_ast__apply1458[] = {1};
  meth_meth_ast__apply1458->type = alloc_MethodType(1, argcv_meth_ast__apply1458);
  meth_meth_ast__apply1458->definitionModule = modulename;
  meth_meth_ast__apply1458->definitionLine = 312;
// compiled block node returning block1457 (depth = 6)
  gc_frame_newslot(block1457);
// call case 5: prelude request
  params[0] = call1456;
  params[1] = block1457;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1462 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1454);
// compiled call node returning call1462 (depth = 5)
// Begin line 315
  setline(315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1463 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1464 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1465 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1464);
// compiled call node returning call1465 (depth = 7)
// compiled member node returning call1465 (depth = 6)
  gc_frame_newslot(call1465);
// starting to compile block node (depth = 6)
  Object block1466 = alloc_Block(NULL, NULL, "ast", 315);
  gc_frame_newslot(block1466);
// method _apply
  block_savedest(block1466);
  Object closure1467 = createclosure(3, "_apply");
  setclosureframe(closure1467, stackframe);
  addtoclosure(closure1467, var_visitor);
  addtoclosure(closure1467, var_newChain);
  addtoclosure(closure1467, selfslot);
  struct UserObject *uo1467 = (struct UserObject*)block1466;
  uo1467->data[0] = (Object)closure1467;
  Method *meth_meth_ast__apply1467 = addmethod2pos(block1466, "_apply", &meth_ast__apply1467, 0);
  int argcv_meth_ast__apply1467[] = {1};
  meth_meth_ast__apply1467->type = alloc_MethodType(1, argcv_meth_ast__apply1467);
  meth_meth_ast__apply1467->definitionModule = modulename;
  meth_meth_ast__apply1467->definitionLine = 315;
// compiled block node returning block1466 (depth = 6)
  gc_frame_newslot(block1466);
// call case 5: prelude request
  params[0] = call1465;
  params[1] = block1466;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1471 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1463);
// compiled call node returning call1471 (depth = 5)
// Begin line 318
  setline(318);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool1474 = alloc_Boolean(0);
// compiled identifier node returning bool1474 (depth = 7)
  int op_slot_right_1473 = gc_frame_newslot(bool1474);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1476 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1477 = callmethodflags(self, "matchingPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1476);
// compiled call node returning call1477 (depth = 8)
// compiled member node returning call1477 (depth = 7)
  int op_slot_left_1473 = gc_frame_newslot(call1477);
  params[0] = bool1474;
  partcv[0] = 1;
  Object opresult1478 = callmethod(call1477, "!=", 1, partcv, params);
// compiled op node returning opresult1478 (depth = 6)
  Object if1472 = done;
  if (istrue(opresult1478)) {
// Begin line 319
  setline(319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1479 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1480 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1481 = callmethodflags(self, "matchingPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1480);
// compiled call node returning call1481 (depth = 8)
// compiled member node returning call1481 (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1482 = callmethod(call1481, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe1479);
// compiled call node returning call1482 (depth = 6)
    gc_frame_newslot(call1482);
    if1472 = call1482;
  } else {
  }
// compiled if node returning if1472 (depth = 5)
    gc_frame_newslot(if1472);
    if1449 = if1472;
  } else {
  }
// compiled if node returning if1449 (depth = 4)
  gc_frame_end(frame);
  return if1449;
}
Object meth_ast_map_40__41_ancestors1483(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 324
  setline(324);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1484 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1485 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1484);
// compiled call node returning call1485 (depth = 6)
// compiled member node returning call1485 (depth = 5)
  *var_n = call1485;
  if (call1485 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 325
  setline(325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1486 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call1487 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe1486);
// compiled call node returning call1487 (depth = 5)
  *var_newChain = call1487;
  if (call1487 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 326
  setline(326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 324
  setline(324);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1488 = gc_frame_new();
// Begin line 326
  setline(326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1489 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1490 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1491 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1490);
// compiled call node returning call1491 (depth = 8)
// compiled member node returning call1491 (depth = 7)
  gc_frame_newslot(call1491);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1492 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1493 = gc_frame_new();
// call case 3: self.outer request
  Object call1494 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1493);
// compiled call node returning call1494 (depth = 10)
// compiled member node returning call1494 (depth = 9)
  partcv[0] = 0;
  Object call1495 = callmethodflags(call1494, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1492);
// compiled call node returning call1495 (depth = 8)
// compiled member node returning call1495 (depth = 7)
  params[0] = call1491;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call1496 = callmethodflags(call1495, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1489);
// compiled call node returning call1496 (depth = 6)
  gc_frame_newslot(call1496);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call1496;
  partcv[0] = 1;
  Object call1497 = callmethod(*var_n, "params:=",
    1, partcv, params);
  gc_frame_end(callframe1488);
// compiled call node returning call1497 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 327
  setline(327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 326
  setline(326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1498 = gc_frame_new();
// Begin line 327
  setline(327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1499 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1500 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1501 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1500);
// compiled call node returning call1501 (depth = 8)
// compiled member node returning call1501 (depth = 7)
  gc_frame_newslot(call1501);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1502 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1503 = gc_frame_new();
// call case 3: self.outer request
  Object call1504 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1503);
// compiled call node returning call1504 (depth = 10)
// compiled member node returning call1504 (depth = 9)
  partcv[0] = 0;
  Object call1505 = callmethodflags(call1504, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1502);
// compiled call node returning call1505 (depth = 8)
// compiled member node returning call1505 (depth = 7)
  params[0] = call1501;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call1506 = callmethodflags(call1505, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1499);
// compiled call node returning call1506 (depth = 6)
  gc_frame_newslot(call1506);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call1506;
  partcv[0] = 1;
  Object call1507 = callmethod(*var_n, "body:=",
    1, partcv, params);
  gc_frame_end(callframe1498);
// compiled call node returning call1507 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 328
  setline(328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 327
  setline(327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1508 = gc_frame_new();
// Begin line 328
  setline(328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1509 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1510 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1511 = callmethodflags(self, "matchingPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1510);
// compiled call node returning call1511 (depth = 8)
// compiled member node returning call1511 (depth = 7)
  gc_frame_newslot(call1511);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1512 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1513 = gc_frame_new();
// call case 3: self.outer request
  Object call1514 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1513);
// compiled call node returning call1514 (depth = 10)
// compiled member node returning call1514 (depth = 9)
  partcv[0] = 0;
  Object call1515 = callmethodflags(call1514, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1512);
// compiled call node returning call1515 (depth = 8)
// compiled member node returning call1515 (depth = 7)
  params[0] = call1511;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call1516 = callmethodflags(call1515, "maybeMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1509);
// compiled call node returning call1516 (depth = 6)
  gc_frame_newslot(call1516);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call1516;
  partcv[0] = 1;
  Object call1517 = callmethod(*var_n, "matchingPattern:=",
    1, partcv, params);
  gc_frame_end(callframe1508);
// compiled call node returning call1517 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 329
  setline(329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1518 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call1519 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe1518);
// compiled call node returning call1519 (depth = 4)
  gc_frame_end(frame);
  return call1519;
}
Object meth_ast__apply1528(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 334
  setline(334);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1530 == NULL) {
    strlit1530 = alloc_String("  ");
    gc_root(strlit1530);
  }
// compiled string node returning strlit1530 (depth = 8)
  int op_slot_right_1529 = gc_frame_newslot(strlit1530);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_1529 = gc_frame_newslot(*var_spc);
  params[0] = strlit1530;
  partcv[0] = 1;
  Object opresult1532 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult1532 (depth = 7)
  *var_spc = opresult1532;
  if (opresult1532 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1554(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 339
  setline(339);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1556 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1558 = alloc_Float64(2);
// compiled num node returning num1558 (depth = 10)
  int op_slot_right_1557 = gc_frame_newslot(num1558);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_1557 = gc_frame_newslot(*var_depth);
  params[0] = num1558;
  partcv[0] = 1;
  Object sum1560 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum1560 (depth = 9)
  gc_frame_newslot(sum1560);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_mx (depth = 9)
  params[0] = sum1560;
  partcv[0] = 1;
  Object call1561 = callmethod(*var_mx, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1556);
// compiled call node returning call1561 (depth = 8)
  int op_slot_right_1555 = gc_frame_newslot(call1561);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_1563 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1566 == NULL) {
    strlit1566 = alloc_String("""\x0a""  ");
    gc_root(strlit1566);
  }
// compiled string node returning strlit1566 (depth = 10)
  int op_slot_right_1565 = gc_frame_newslot(strlit1566);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_1565 = gc_frame_newslot(*var_s);
  params[0] = strlit1566;
  partcv[0] = 1;
  Object opresult1568 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1568 (depth = 9)
  int op_slot_left_1563 = gc_frame_newslot(opresult1568);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1569 = callmethod(opresult1568, "++", 1, partcv, params);
// compiled op node returning opresult1569 (depth = 8)
  int op_slot_left_1555 = gc_frame_newslot(opresult1569);
  params[0] = call1561;
  partcv[0] = 1;
  Object opresult1570 = callmethod(opresult1569, "++", 1, partcv, params);
// compiled op node returning opresult1570 (depth = 7)
  *var_s = opresult1570;
  if (opresult1570 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1591(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 344
  setline(344);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1593 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1595 = alloc_Float64(2);
// compiled num node returning num1595 (depth = 10)
  int op_slot_right_1594 = gc_frame_newslot(num1595);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_1594 = gc_frame_newslot(*var_depth);
  params[0] = num1595;
  partcv[0] = 1;
  Object sum1597 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum1597 (depth = 9)
  gc_frame_newslot(sum1597);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_mx (depth = 9)
  params[0] = sum1597;
  partcv[0] = 1;
  Object call1598 = callmethod(*var_mx, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1593);
// compiled call node returning call1598 (depth = 8)
  int op_slot_right_1592 = gc_frame_newslot(call1598);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_1600 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1603 == NULL) {
    strlit1603 = alloc_String("""\x0a""  ");
    gc_root(strlit1603);
  }
// compiled string node returning strlit1603 (depth = 10)
  int op_slot_right_1602 = gc_frame_newslot(strlit1603);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_1602 = gc_frame_newslot(*var_s);
  params[0] = strlit1603;
  partcv[0] = 1;
  Object opresult1605 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1605 (depth = 9)
  int op_slot_left_1600 = gc_frame_newslot(opresult1605);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1606 = callmethod(opresult1605, "++", 1, partcv, params);
// compiled op node returning opresult1606 (depth = 8)
  int op_slot_left_1592 = gc_frame_newslot(opresult1606);
  params[0] = call1598;
  partcv[0] = 1;
  Object opresult1607 = callmethod(opresult1606, "++", 1, partcv, params);
// compiled op node returning opresult1607 (depth = 7)
  *var_s = opresult1607;
  if (opresult1607 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty1520(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 332
  setline(332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1521 == NULL) {
    strlit1521 = alloc_String("");
    gc_root(strlit1521);
  }
// compiled string node returning strlit1521 (depth = 5)
  *var_spc = strlit1521;
  if (strlit1521 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 333
  setline(333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1522 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_right_1523 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 6)
  Object num1525 = alloc_Float64(0);
// compiled num node returning num1525 (depth = 6)
  int op_slot_left_1523 = gc_frame_newslot(num1525);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult1526 = callmethod(num1525, "..", 1, partcv, params);
// compiled op node returning opresult1526 (depth = 5)
  gc_frame_newslot(opresult1526);
// starting to compile block node (depth = 5)
  Object block1527 = alloc_Block(NULL, NULL, "ast", 333);
  gc_frame_newslot(block1527);
// method _apply
  block_savedest(block1527);
  Object closure1528 = createclosure(2, "_apply");
  setclosureframe(closure1528, stackframe);
  addtoclosure(closure1528, var_spc);
  addtoclosure(closure1528, selfslot);
  struct UserObject *uo1528 = (struct UserObject*)block1527;
  uo1528->data[0] = (Object)closure1528;
  Method *meth_meth_ast__apply1528 = addmethod2pos(block1527, "_apply", &meth_ast__apply1528, 0);
  int argcv_meth_ast__apply1528[] = {1};
  meth_meth_ast__apply1528->type = alloc_MethodType(1, argcv_meth_ast__apply1528);
  meth_meth_ast__apply1528->definitionModule = modulename;
  meth_meth_ast__apply1528->definitionLine = 328;
// compiled block node returning block1527 (depth = 5)
  gc_frame_newslot(block1527);
// call case 5: prelude request
  params[0] = opresult1526;
  params[1] = block1527;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1535 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1522);
// compiled call node returning call1535 (depth = 4)
// Begin line 336
  setline(336);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1537 == NULL) {
    strlit1537 = alloc_String("""\x0a""");
    gc_root(strlit1537);
  }
// compiled string node returning strlit1537 (depth = 6)
  int op_slot_right_1536 = gc_frame_newslot(strlit1537);
// starting to compile call node (depth = 6)
  int callframe1539 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call1540 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe1539);
// compiled call node returning call1540 (depth = 6)
  int op_slot_left_1536 = gc_frame_newslot(call1540);
  params[0] = strlit1537;
  partcv[0] = 1;
  Object opresult1541 = callmethod(call1540, "++", 1, partcv, params);
// compiled op node returning opresult1541 (depth = 5)
  *var_s = opresult1541;
  if (opresult1541 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 337
  setline(337);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1543 == NULL) {
    strlit1543 = alloc_String("Parameters:");
    gc_root(strlit1543);
  }
// compiled string node returning strlit1543 (depth = 6)
  int op_slot_right_1542 = gc_frame_newslot(strlit1543);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_1545 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1545 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1547 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1547 (depth = 6)
  int op_slot_left_1542 = gc_frame_newslot(opresult1547);
  params[0] = strlit1543;
  partcv[0] = 1;
  Object opresult1548 = callmethod(opresult1547, "++", 1, partcv, params);
// compiled op node returning opresult1548 (depth = 5)
  *var_s = opresult1548;
  if (opresult1548 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 338
  setline(338);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1550 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1551 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1552 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1551);
// compiled call node returning call1552 (depth = 6)
// compiled member node returning call1552 (depth = 5)
  gc_frame_newslot(call1552);
// starting to compile block node (depth = 5)
  Object block1553 = alloc_Block(NULL, NULL, "ast", 338);
  gc_frame_newslot(block1553);
// method _apply
  block_savedest(block1553);
  Object closure1554 = createclosure(4, "_apply");
  setclosureframe(closure1554, stackframe);
  addtoclosure(closure1554, var_depth);
  addtoclosure(closure1554, var_spc);
  addtoclosure(closure1554, var_s);
  addtoclosure(closure1554, selfslot);
  struct UserObject *uo1554 = (struct UserObject*)block1553;
  uo1554->data[0] = (Object)closure1554;
  Method *meth_meth_ast__apply1554 = addmethod2pos(block1553, "_apply", &meth_ast__apply1554, 0);
  int argcv_meth_ast__apply1554[] = {1};
  meth_meth_ast__apply1554->type = alloc_MethodType(1, argcv_meth_ast__apply1554);
  meth_meth_ast__apply1554->definitionModule = modulename;
  meth_meth_ast__apply1554->definitionLine = 338;
// compiled block node returning block1553 (depth = 5)
  gc_frame_newslot(block1553);
// call case 5: prelude request
  params[0] = call1552;
  params[1] = block1553;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1573 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1550);
// compiled call node returning call1573 (depth = 4)
// Begin line 341
  setline(341);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1575 == NULL) {
    strlit1575 = alloc_String("""\x0a""");
    gc_root(strlit1575);
  }
// compiled string node returning strlit1575 (depth = 6)
  int op_slot_right_1574 = gc_frame_newslot(strlit1575);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_1574 = gc_frame_newslot(*var_s);
  params[0] = strlit1575;
  partcv[0] = 1;
  Object opresult1577 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1577 (depth = 5)
  *var_s = opresult1577;
  if (opresult1577 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 342
  setline(342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1580 == NULL) {
    strlit1580 = alloc_String("Body:");
    gc_root(strlit1580);
  }
// compiled string node returning strlit1580 (depth = 6)
  int op_slot_right_1579 = gc_frame_newslot(strlit1580);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_1582 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1582 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1584 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1584 (depth = 6)
  int op_slot_left_1579 = gc_frame_newslot(opresult1584);
  params[0] = strlit1580;
  partcv[0] = 1;
  Object opresult1585 = callmethod(opresult1584, "++", 1, partcv, params);
// compiled op node returning opresult1585 (depth = 5)
  *var_s = opresult1585;
  if (opresult1585 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 343
  setline(343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1587 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1588 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1589 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1588);
// compiled call node returning call1589 (depth = 6)
// compiled member node returning call1589 (depth = 5)
  gc_frame_newslot(call1589);
// starting to compile block node (depth = 5)
  Object block1590 = alloc_Block(NULL, NULL, "ast", 343);
  gc_frame_newslot(block1590);
// method _apply
  block_savedest(block1590);
  Object closure1591 = createclosure(4, "_apply");
  setclosureframe(closure1591, stackframe);
  addtoclosure(closure1591, var_depth);
  addtoclosure(closure1591, var_spc);
  addtoclosure(closure1591, var_s);
  addtoclosure(closure1591, selfslot);
  struct UserObject *uo1591 = (struct UserObject*)block1590;
  uo1591->data[0] = (Object)closure1591;
  Method *meth_meth_ast__apply1591 = addmethod2pos(block1590, "_apply", &meth_ast__apply1591, 0);
  int argcv_meth_ast__apply1591[] = {1};
  meth_meth_ast__apply1591->type = alloc_MethodType(1, argcv_meth_ast__apply1591);
  meth_meth_ast__apply1591->definitionModule = modulename;
  meth_meth_ast__apply1591->definitionLine = 343;
// compiled block node returning block1590 (depth = 5)
  gc_frame_newslot(block1590);
// call case 5: prelude request
  params[0] = call1589;
  params[1] = block1590;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1610 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1587);
// compiled call node returning call1610 (depth = 4)
// Begin line 346
  setline(346);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool1613 = alloc_Boolean(0);
// compiled identifier node returning bool1613 (depth = 6)
  int op_slot_right_1612 = gc_frame_newslot(bool1613);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1615 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1616 = callmethodflags(self, "matchingPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1615);
// compiled call node returning call1616 (depth = 7)
// compiled member node returning call1616 (depth = 6)
  int op_slot_left_1612 = gc_frame_newslot(call1616);
  params[0] = bool1613;
  partcv[0] = 1;
  Object opresult1617 = callmethod(call1616, "!=", 1, partcv, params);
// compiled op node returning opresult1617 (depth = 5)
  Object if1611 = done;
  if (istrue(opresult1617)) {
// Begin line 347
  setline(347);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1619 == NULL) {
    strlit1619 = alloc_String("""\x0a""");
    gc_root(strlit1619);
  }
// compiled string node returning strlit1619 (depth = 7)
  int op_slot_right_1618 = gc_frame_newslot(strlit1619);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1618 = gc_frame_newslot(*var_s);
  params[0] = strlit1619;
  partcv[0] = 1;
  Object opresult1621 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1621 (depth = 6)
  *var_s = opresult1621;
  if (opresult1621 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 348
  setline(348);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1624 == NULL) {
    strlit1624 = alloc_String("Pattern:");
    gc_root(strlit1624);
  }
// compiled string node returning strlit1624 (depth = 7)
  int op_slot_right_1623 = gc_frame_newslot(strlit1624);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_1626 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_1626 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1628 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1628 (depth = 7)
  int op_slot_left_1623 = gc_frame_newslot(opresult1628);
  params[0] = strlit1624;
  partcv[0] = 1;
  Object opresult1629 = callmethod(opresult1628, "++", 1, partcv, params);
// compiled op node returning opresult1629 (depth = 6)
  *var_s = opresult1629;
  if (opresult1629 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 349
  setline(349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1632 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1634 = alloc_Float64(2);
// compiled num node returning num1634 (depth = 9)
  int op_slot_right_1633 = gc_frame_newslot(num1634);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_1633 = gc_frame_newslot(*var_depth);
  params[0] = num1634;
  partcv[0] = 1;
  Object sum1636 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum1636 (depth = 8)
  gc_frame_newslot(sum1636);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1637 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1638 = callmethodflags(self, "matchingPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1637);
// compiled call node returning call1638 (depth = 9)
// compiled member node returning call1638 (depth = 8)
  params[0] = sum1636;
  partcv[0] = 1;
  Object call1639 = callmethod(call1638, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1632);
// compiled call node returning call1639 (depth = 7)
  int op_slot_right_1631 = gc_frame_newslot(call1639);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_1641 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1644 == NULL) {
    strlit1644 = alloc_String("""\x0a""  ");
    gc_root(strlit1644);
  }
// compiled string node returning strlit1644 (depth = 9)
  int op_slot_right_1643 = gc_frame_newslot(strlit1644);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_1643 = gc_frame_newslot(*var_s);
  params[0] = strlit1644;
  partcv[0] = 1;
  Object opresult1646 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1646 (depth = 8)
  int op_slot_left_1641 = gc_frame_newslot(opresult1646);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1647 = callmethod(opresult1646, "++", 1, partcv, params);
// compiled op node returning opresult1647 (depth = 7)
  int op_slot_left_1631 = gc_frame_newslot(opresult1647);
  params[0] = call1639;
  partcv[0] = 1;
  Object opresult1648 = callmethod(opresult1647, "++", 1, partcv, params);
// compiled op node returning opresult1648 (depth = 6)
  *var_s = opresult1648;
  if (opresult1648 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if1611 = done;
  } else {
  }
// compiled if node returning if1611 (depth = 4)
// Begin line 351
  setline(351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply1662(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 356
  setline(356);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1664 == NULL) {
    strlit1664 = alloc_String("    ");
    gc_root(strlit1664);
  }
// compiled string node returning strlit1664 (depth = 8)
  int op_slot_right_1663 = gc_frame_newslot(strlit1664);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_1663 = gc_frame_newslot(*var_spc);
  params[0] = strlit1664;
  partcv[0] = 1;
  Object opresult1666 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult1666 (depth = 7)
  *var_spc = opresult1666;
  if (opresult1666 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1691(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_p = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "p");
// Begin line 362
  setline(362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 7)
// Begin line 363
  setline(363);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile index node (depth = 8)
// Begin line 362
  setline(362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1692 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1693 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1692);
// compiled call node returning call1693 (depth = 10)
// compiled member node returning call1693 (depth = 9)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  params[0] = *var_i;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres1694 = callmethod(call1693, "[]", 1, partcv, params);
// compiled index node returning idxres1694 (depth = 8)
  *var_p = idxres1694;
  if (idxres1694 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 7)
// Begin line 363
  setline(363);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
  Object bool1697 = alloc_Boolean(0);
// compiled identifier node returning bool1697 (depth = 9)
  int op_slot_right_1696 = gc_frame_newslot(bool1697);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1699 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1700 = callmethodflags(self, "matchingPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1699);
// compiled call node returning call1700 (depth = 10)
// compiled member node returning call1700 (depth = 9)
  int op_slot_left_1696 = gc_frame_newslot(call1700);
  params[0] = bool1697;
  partcv[0] = 1;
  Object opresult1701 = callmethod(call1700, "!=", 1, partcv, params);
// compiled op node returning opresult1701 (depth = 8)
  Object if1695 = done;
  if (istrue(opresult1701)) {
// Begin line 364
  setline(364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1703 == NULL) {
    strlit1703 = alloc_String(")");
    gc_root(strlit1703);
  }
// compiled string node returning strlit1703 (depth = 10)
  int op_slot_right_1702 = gc_frame_newslot(strlit1703);
// starting to compile op node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1706 = gc_frame_new();
// starting to compile num node (depth = 12)
  Object num1707 = alloc_Float64(0);
// compiled num node returning num1707 (depth = 12)
  gc_frame_newslot(num1707);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_p (depth = 12)
  params[0] = num1707;
  partcv[0] = 1;
  Object call1708 = callmethod(*var_p, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe1706);
// compiled call node returning call1708 (depth = 11)
  int op_slot_right_1705 = gc_frame_newslot(call1708);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit1711 == NULL) {
    strlit1711 = alloc_String("(");
    gc_root(strlit1711);
  }
// compiled string node returning strlit1711 (depth = 12)
  int op_slot_right_1710 = gc_frame_newslot(strlit1711);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_s (depth = 12)
  int op_slot_left_1710 = gc_frame_newslot(*var_s);
  params[0] = strlit1711;
  partcv[0] = 1;
  Object opresult1713 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1713 (depth = 11)
  int op_slot_left_1705 = gc_frame_newslot(opresult1713);
  params[0] = call1708;
  partcv[0] = 1;
  Object opresult1714 = callmethod(opresult1713, "++", 1, partcv, params);
// compiled op node returning opresult1714 (depth = 10)
  int op_slot_left_1702 = gc_frame_newslot(opresult1714);
  params[0] = strlit1703;
  partcv[0] = 1;
  Object opresult1715 = callmethod(opresult1714, "++", 1, partcv, params);
// compiled op node returning opresult1715 (depth = 9)
  *var_s = opresult1715;
  if (opresult1715 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if1695 = done;
  } else {
// Begin line 366
  setline(366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1718 = gc_frame_new();
// starting to compile num node (depth = 11)
  Object num1719 = alloc_Float64(0);
// compiled num node returning num1719 (depth = 11)
  gc_frame_newslot(num1719);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_p (depth = 11)
  params[0] = num1719;
  partcv[0] = 1;
  Object call1720 = callmethod(*var_p, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe1718);
// compiled call node returning call1720 (depth = 10)
  int op_slot_right_1717 = gc_frame_newslot(call1720);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_1717 = gc_frame_newslot(*var_s);
  params[0] = call1720;
  partcv[0] = 1;
  Object opresult1722 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1722 (depth = 9)
  *var_s = opresult1722;
  if (opresult1722 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if1695 = done;
  }
// compiled if node returning if1695 (depth = 7)
// Begin line 368
  setline(368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1726 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1727 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1728 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1727);
// compiled call node returning call1728 (depth = 12)
// compiled member node returning call1728 (depth = 11)
  partcv[0] = 0;
  Object call1729 = callmethod(call1728, "size",
    1, partcv, params);
  gc_frame_end(callframe1726);
// compiled call node returning call1729 (depth = 10)
// compiled member node returning call1729 (depth = 9)
  int op_slot_right_1725 = gc_frame_newslot(call1729);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  int op_slot_left_1725 = gc_frame_newslot(*var_i);
  params[0] = call1729;
  partcv[0] = 1;
  Object opresult1731 = callmethod(*var_i, "<", 1, partcv, params);
// compiled op node returning opresult1731 (depth = 8)
  Object if1724 = done;
  if (istrue(opresult1731)) {
// Begin line 369
  setline(369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1733 == NULL) {
    strlit1733 = alloc_String(", ");
    gc_root(strlit1733);
  }
// compiled string node returning strlit1733 (depth = 10)
  int op_slot_right_1732 = gc_frame_newslot(strlit1733);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_1732 = gc_frame_newslot(*var_s);
  params[0] = strlit1733;
  partcv[0] = 1;
  Object opresult1735 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1735 (depth = 9)
  *var_s = opresult1735;
  if (opresult1735 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if1724 = done;
  } else {
// Begin line 371
  setline(371);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1738 == NULL) {
    strlit1738 = alloc_String(" ->");
    gc_root(strlit1738);
  }
// compiled string node returning strlit1738 (depth = 10)
  int op_slot_right_1737 = gc_frame_newslot(strlit1738);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_1737 = gc_frame_newslot(*var_s);
  params[0] = strlit1738;
  partcv[0] = 1;
  Object opresult1740 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1740 (depth = 9)
  *var_s = opresult1740;
  if (opresult1740 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if1724 = done;
  }
// compiled if node returning if1724 (depth = 7)
  gc_frame_end(frame);
  return if1724;
}
Object meth_ast__apply1748(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 376
  setline(376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1750 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1752 = alloc_Float64(1);
// compiled num node returning num1752 (depth = 10)
  int op_slot_right_1751 = gc_frame_newslot(num1752);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_1751 = gc_frame_newslot(*var_depth);
  params[0] = num1752;
  partcv[0] = 1;
  Object sum1754 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum1754 (depth = 9)
  gc_frame_newslot(sum1754);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_mx (depth = 9)
  params[0] = sum1754;
  partcv[0] = 1;
  Object call1755 = callmethod(*var_mx, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe1750);
// compiled call node returning call1755 (depth = 8)
  int op_slot_right_1749 = gc_frame_newslot(call1755);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1758 == NULL) {
    strlit1758 = alloc_String("    ");
    gc_root(strlit1758);
  }
// compiled string node returning strlit1758 (depth = 9)
  int op_slot_right_1757 = gc_frame_newslot(strlit1758);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_1760 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1763 == NULL) {
    strlit1763 = alloc_String("""\x0a""");
    gc_root(strlit1763);
  }
// compiled string node returning strlit1763 (depth = 11)
  int op_slot_right_1762 = gc_frame_newslot(strlit1763);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_1762 = gc_frame_newslot(*var_s);
  params[0] = strlit1763;
  partcv[0] = 1;
  Object opresult1765 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1765 (depth = 10)
  int op_slot_left_1760 = gc_frame_newslot(opresult1765);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1766 = callmethod(opresult1765, "++", 1, partcv, params);
// compiled op node returning opresult1766 (depth = 9)
  int op_slot_left_1757 = gc_frame_newslot(opresult1766);
  params[0] = strlit1758;
  partcv[0] = 1;
  Object opresult1767 = callmethod(opresult1766, "++", 1, partcv, params);
// compiled op node returning opresult1767 (depth = 8)
  int op_slot_left_1749 = gc_frame_newslot(opresult1767);
  params[0] = call1755;
  partcv[0] = 1;
  Object opresult1768 = callmethod(opresult1767, "++", 1, partcv, params);
// compiled op node returning opresult1768 (depth = 7)
  *var_s = opresult1768;
  if (opresult1768 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace1650(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 354
  setline(354);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1651 == NULL) {
    strlit1651 = alloc_String("");
    gc_root(strlit1651);
  }
// compiled string node returning strlit1651 (depth = 5)
  *var_spc = strlit1651;
  if (strlit1651 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 355
  setline(355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1652 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num1655 = alloc_Float64(1);
// compiled num node returning num1655 (depth = 7)
  int op_slot_right_1654 = gc_frame_newslot(num1655);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_1654 = gc_frame_newslot(*var_depth);
  params[0] = num1655;
  partcv[0] = 1;
  Object diff1657 = callmethod(*var_depth, "-", 1, partcv, params);
// compiled op node returning diff1657 (depth = 6)
  int op_slot_right_1653 = gc_frame_newslot(diff1657);
// starting to compile num node (depth = 6)
  Object num1659 = alloc_Float64(0);
// compiled num node returning num1659 (depth = 6)
  int op_slot_left_1653 = gc_frame_newslot(num1659);
  params[0] = diff1657;
  partcv[0] = 1;
  Object opresult1660 = callmethod(num1659, "..", 1, partcv, params);
// compiled op node returning opresult1660 (depth = 5)
  gc_frame_newslot(opresult1660);
// starting to compile block node (depth = 5)
  Object block1661 = alloc_Block(NULL, NULL, "ast", 355);
  gc_frame_newslot(block1661);
// method _apply
  block_savedest(block1661);
  Object closure1662 = createclosure(2, "_apply");
  setclosureframe(closure1662, stackframe);
  addtoclosure(closure1662, var_spc);
  addtoclosure(closure1662, selfslot);
  struct UserObject *uo1662 = (struct UserObject*)block1661;
  uo1662->data[0] = (Object)closure1662;
  Method *meth_meth_ast__apply1662 = addmethod2pos(block1661, "_apply", &meth_ast__apply1662, 0);
  int argcv_meth_ast__apply1662[] = {1};
  meth_meth_ast__apply1662->type = alloc_MethodType(1, argcv_meth_ast__apply1662);
  meth_meth_ast__apply1662->definitionModule = modulename;
  meth_meth_ast__apply1662->definitionLine = 349;
// compiled block node returning block1661 (depth = 5)
  gc_frame_newslot(block1661);
// call case 5: prelude request
  params[0] = opresult1660;
  params[1] = block1661;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1669 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1652);
// compiled call node returning call1669 (depth = 4)
// Begin line 358
  setline(358);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1670 == NULL) {
    strlit1670 = alloc_String("{");
    gc_root(strlit1670);
  }
// compiled string node returning strlit1670 (depth = 5)
  *var_s = strlit1670;
  if (strlit1670 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 359
  setline(359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1673 = alloc_Float64(0);
// compiled num node returning num1673 (depth = 6)
  int op_slot_right_1672 = gc_frame_newslot(num1673);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1675 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1676 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1677 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1676);
// compiled call node returning call1677 (depth = 9)
// compiled member node returning call1677 (depth = 8)
  partcv[0] = 0;
  Object call1678 = callmethod(call1677, "size",
    1, partcv, params);
  gc_frame_end(callframe1675);
// compiled call node returning call1678 (depth = 7)
// compiled member node returning call1678 (depth = 6)
  int op_slot_left_1672 = gc_frame_newslot(call1678);
  params[0] = num1673;
  partcv[0] = 1;
  Object opresult1679 = callmethod(call1678, ">", 1, partcv, params);
// compiled op node returning opresult1679 (depth = 5)
  Object if1671 = done;
  if (istrue(opresult1679)) {
// Begin line 360
  setline(360);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1681 == NULL) {
    strlit1681 = alloc_String(" ");
    gc_root(strlit1681);
  }
// compiled string node returning strlit1681 (depth = 7)
  int op_slot_right_1680 = gc_frame_newslot(strlit1681);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1680 = gc_frame_newslot(*var_s);
  params[0] = strlit1681;
  partcv[0] = 1;
  Object opresult1683 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1683 (depth = 6)
  *var_s = opresult1683;
  if (opresult1683 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 361
  setline(361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1685 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1686 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1687 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1688 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1687);
// compiled call node returning call1688 (depth = 9)
// compiled member node returning call1688 (depth = 8)
  partcv[0] = 0;
  Object call1689 = callmethod(call1688, "indices",
    1, partcv, params);
  gc_frame_end(callframe1686);
// compiled call node returning call1689 (depth = 7)
// compiled member node returning call1689 (depth = 6)
  gc_frame_newslot(call1689);
// starting to compile block node (depth = 6)
  Object block1690 = alloc_Block(NULL, NULL, "ast", 361);
  gc_frame_newslot(block1690);
// method _apply
  block_savedest(block1690);
  Object closure1691 = createclosure(2, "_apply");
  setclosureframe(closure1691, stackframe);
  addtoclosure(closure1691, var_s);
  addtoclosure(closure1691, selfslot);
  struct UserObject *uo1691 = (struct UserObject*)block1690;
  uo1691->data[0] = (Object)closure1691;
  Method *meth_meth_ast__apply1691 = addmethod2pos(block1690, "_apply", &meth_ast__apply1691, 0);
  int argcv_meth_ast__apply1691[] = {1};
  meth_meth_ast__apply1691->type = alloc_MethodType(1, argcv_meth_ast__apply1691);
  meth_meth_ast__apply1691->definitionModule = modulename;
  meth_meth_ast__apply1691->definitionLine = 361;
// compiled block node returning block1690 (depth = 6)
  gc_frame_newslot(block1690);
// call case 5: prelude request
  params[0] = call1689;
  params[1] = block1690;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1743 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1685);
// compiled call node returning call1743 (depth = 5)
    gc_frame_newslot(call1743);
    if1671 = call1743;
  } else {
  }
// compiled if node returning if1671 (depth = 4)
// Begin line 375
  setline(375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1744 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1745 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1746 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1745);
// compiled call node returning call1746 (depth = 6)
// compiled member node returning call1746 (depth = 5)
  gc_frame_newslot(call1746);
// starting to compile block node (depth = 5)
  Object block1747 = alloc_Block(NULL, NULL, "ast", 375);
  gc_frame_newslot(block1747);
// method _apply
  block_savedest(block1747);
  Object closure1748 = createclosure(4, "_apply");
  setclosureframe(closure1748, stackframe);
  addtoclosure(closure1748, var_depth);
  addtoclosure(closure1748, var_spc);
  addtoclosure(closure1748, var_s);
  addtoclosure(closure1748, selfslot);
  struct UserObject *uo1748 = (struct UserObject*)block1747;
  uo1748->data[0] = (Object)closure1748;
  Method *meth_meth_ast__apply1748 = addmethod2pos(block1747, "_apply", &meth_ast__apply1748, 0);
  int argcv_meth_ast__apply1748[] = {1};
  meth_meth_ast__apply1748->type = alloc_MethodType(1, argcv_meth_ast__apply1748);
  meth_meth_ast__apply1748->definitionModule = modulename;
  meth_meth_ast__apply1748->definitionLine = 375;
// compiled block node returning block1747 (depth = 5)
  gc_frame_newslot(block1747);
// call case 5: prelude request
  params[0] = call1746;
  params[1] = block1747;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1771 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1744);
// compiled call node returning call1771 (depth = 4)
// Begin line 378
  setline(378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1773 == NULL) {
    strlit1773 = alloc_String("}");
    gc_root(strlit1773);
  }
// compiled string node returning strlit1773 (depth = 6)
  int op_slot_right_1772 = gc_frame_newslot(strlit1773);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_1775 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1778 == NULL) {
    strlit1778 = alloc_String("""\x0a""");
    gc_root(strlit1778);
  }
// compiled string node returning strlit1778 (depth = 8)
  int op_slot_right_1777 = gc_frame_newslot(strlit1778);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_1777 = gc_frame_newslot(*var_s);
  params[0] = strlit1778;
  partcv[0] = 1;
  Object opresult1780 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1780 (depth = 7)
  int op_slot_left_1775 = gc_frame_newslot(opresult1780);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1781 = callmethod(opresult1780, "++", 1, partcv, params);
// compiled op node returning opresult1781 (depth = 6)
  int op_slot_left_1772 = gc_frame_newslot(opresult1781);
  params[0] = strlit1773;
  partcv[0] = 1;
  Object opresult1782 = callmethod(opresult1781, "++", 1, partcv, params);
// compiled op node returning opresult1782 (depth = 5)
  *var_s = opresult1782;
  if (opresult1782 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 379
  setline(379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy1784(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_blockNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 382
  setline(382);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1785 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe1786 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1787 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1788 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1787);
// compiled call node returning call1788 (depth = 7)
// compiled member node returning call1788 (depth = 6)
  gc_frame_newslot(call1788);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1789 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1790 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1789);
// compiled call node returning call1790 (depth = 7)
// compiled member node returning call1790 (depth = 6)
  gc_frame_newslot(call1790);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blockNode (depth = 6)
  params[0] = call1788;
  params[1] = call1790;
  partcv[0] = 2;
  Object call1791 = callmethod(*var_blockNode, "new",
    1, partcv, params);
  gc_frame_end(callframe1786);
// compiled call node returning call1791 (depth = 5)
  params[0] = self;
  partcv[0] = 1;
  Object call1792 = callmethod(call1791, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe1785);
// compiled call node returning call1792 (depth = 4)
  gc_frame_end(frame);
  return call1792;
}
Object meth_ast_shallowCopyFieldsFrom1793(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyFieldsFrom");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopyFieldsFrom (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyFieldsFrom");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 385
  setline(385);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1794 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call1795 = callmethod4(self, "shallowCopyFieldsFrom", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe1794);
// compiled call node returning call1795 (depth = 4)
// Begin line 386
  setline(386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 382
  setline(382);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1796 = gc_frame_new();
// Begin line 386
  setline(386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1797 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_other (depth = 8)
  partcv[0] = 0;
  Object call1798 = callmethod(*var_other, "matchingPattern",
    1, partcv, params);
  gc_frame_end(callframe1797);
// compiled call node returning call1798 (depth = 7)
// compiled member node returning call1798 (depth = 6)
  gc_frame_newslot(call1798);
// call case 4: self request
  params[0] = call1798;
  partcv[0] = 1;
  Object call1799 = callmethodflags(self, "matchingPattern:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1796);
// compiled call node returning call1799 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 387
  setline(387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 386
  setline(386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1800 = gc_frame_new();
// Begin line 387
  setline(387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1801 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_other (depth = 8)
  partcv[0] = 0;
  Object call1802 = callmethod(*var_other, "extraRuntimeData",
    1, partcv, params);
  gc_frame_end(callframe1801);
// compiled call node returning call1802 (depth = 7)
// compiled member node returning call1802 (depth = 6)
  gc_frame_newslot(call1802);
// call case 4: self request
  params[0] = call1802;
  partcv[0] = 1;
  Object call1803 = callmethodflags(self, "extraRuntimeData:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1800);
// compiled call node returning call1803 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 388
  setline(388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_end(frame);
  return self;
}
Object meth_ast__apply1813(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_patternMarkVisitor = getfromclosure(closure, 0);
  Object *var_ancestorChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 285
  setline(285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1814 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_patternMarkVisitor (depth = 7)
  gc_frame_newslot(*var_patternMarkVisitor);
// starting to compile call node (depth = 7)
  int callframe1815 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning self (depth = 8)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ancestorChain (depth = 8)
  params[0] = self;
  partcv[0] = 1;
  Object call1816 = callmethod(*var_ancestorChain, "with",
    1, partcv, params);
  gc_frame_end(callframe1815);
// compiled call node returning call1816 (depth = 7)
  gc_frame_newslot(call1816);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_p (depth = 7)
  params[0] = *var_patternMarkVisitor;
  params[1] = call1816;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1817 = callmethod(*var_p, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe1814);
// compiled call node returning call1817 (depth = 6)
  gc_frame_end(frame);
  return call1817;
}
Object meth_ast_new1372(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method new");
  Object params[2];
  int partcv[2];
  Object *var_blockNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  Object *var_patternMarkVisitor = getfromclosure(closure, 2);
  Object *var_ancestorChain = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_params_39_ = &(stackframe->slots[0]);
  *var_params_39_ = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[1]);
  *var_body_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1373 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1373 = alloc_userobj2(27,24, objclass1373);
  gc_frame_newslot(obj1373);
if (objclass1373 == NULL) {
  glfree(obj1373->class->name);
  obj1373->class->name = "blockNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1373, self, 0);
  addmethodreal(obj1373,"outer", &reader_ast_outer_1374);
  Object oldself1373 = self;
  struct StackFrameObject *oldstackframe1373 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1373);
  gc_frame_newslot((Object)stackframe);
  self = obj1373;
  Object *oldselfslot1373 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1373 = (*(struct UserObject *)self).data[0], lowerouter1373 = thisouter1373;
  if (inheritingObject1373) {
    struct UserObject *inho1373 = (struct UserObject *)inheritingObject1373;
    while (inho1373->super != GraceDefaultObject) inho1373 = (struct UserObject *)inho1373->super;
    inho1373->super = obj1373;
    self = inheritingObject1373;
    *selfslot = self;
    lowerouter1373 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1373;
  }
if (objclass1373 == NULL) {
  Method *reader1375 = addmethodrealflags(obj1373, "kind",&reader_ast_kind_1375, MFLAG_DEF);
  reader1375->definitionModule = modulename;
  reader1375->definitionLine = 277;
}
adddatum2(obj1373, alloc_Undefined(), 1);
if (objclass1373 == NULL) {
  Method *reader1376 = addmethodrealflags(obj1373, "value",&reader_ast_value_1376, MFLAG_DEF);
  reader1376->definitionModule = modulename;
  reader1376->definitionLine = 278;
}
adddatum2(obj1373, alloc_Undefined(), 2);
if (objclass1373 == NULL) {
  Method *reader1377 = addmethodrealflags(obj1373, "params",&reader_ast_params_1377, 0);
  Method *writer1377 = addmethodrealflags(obj1373, "params:=",&writer_ast_params_1377, 0);
  reader1377->definitionModule = modulename;
  writer1377->definitionModule = modulename;
  reader1377->definitionLine = 279;
  writer1377->definitionLine = 279;
}
obj1373->flags |= OFLAG_MUTABLE;
adddatum2(obj1373, alloc_Undefined(), 3);
if (objclass1373 == NULL) {
  Method *reader1378 = addmethodrealflags(obj1373, "body",&reader_ast_body_1378, 0);
  Method *writer1378 = addmethodrealflags(obj1373, "body:=",&writer_ast_body_1378, 0);
  reader1378->definitionModule = modulename;
  writer1378->definitionModule = modulename;
  reader1378->definitionLine = 280;
  writer1378->definitionLine = 280;
}
obj1373->flags |= OFLAG_MUTABLE;
adddatum2(obj1373, alloc_Undefined(), 4);
if (objclass1373 == NULL) {
  Method *reader1379 = addmethodrealflags(obj1373, "selfclosure",&reader_ast_selfclosure_1379, MFLAG_DEF);
  reader1379->definitionModule = modulename;
  reader1379->definitionLine = 281;
}
adddatum2(obj1373, alloc_Undefined(), 5);
if (objclass1373 == NULL) {
  Method *reader1380 = addmethodrealflags(obj1373, "matchingPattern",&reader_ast_matchingPattern_1380, 0);
  Method *writer1380 = addmethodrealflags(obj1373, "matchingPattern:=",&writer_ast_matchingPattern_1380, 0);
  reader1380->definitionModule = modulename;
  writer1380->definitionModule = modulename;
  reader1380->definitionLine = 282;
  writer1380->definitionLine = 282;
}
obj1373->flags |= OFLAG_MUTABLE;
adddatum2(obj1373, alloc_Undefined(), 6);
if (objclass1373 == NULL) {
  Method *reader1381 = addmethodrealflags(obj1373, "extraRuntimeData",&reader_ast_extraRuntimeData_1381, 0);
  Method *writer1381 = addmethodrealflags(obj1373, "extraRuntimeData:=",&writer_ast_extraRuntimeData_1381, 0);
  reader1381->definitionModule = modulename;
  writer1381->definitionModule = modulename;
  reader1381->definitionLine = 283;
  writer1381->definitionLine = 283;
}
obj1373->flags |= OFLAG_MUTABLE;
adddatum2(obj1373, alloc_Undefined(), 7);
// method isEmpty
  struct UserObject *uo1382 = (struct UserObject*)obj1373;
  uo1382->data[8] = emptyclosure;
  Method *meth_meth_ast_isEmpty1382 = addmethod2pos(obj1373, "isEmpty", &meth_ast_isEmpty1382, 8);
  int argcv_meth_ast_isEmpty1382[] = {0};
  meth_meth_ast_isEmpty1382->type = alloc_MethodType(1, argcv_meth_ast_isEmpty1382);
  meth_meth_ast_isEmpty1382->definitionModule = modulename;
  meth_meth_ast_isEmpty1382->definitionLine = 287;
// method isntEmpty
  struct UserObject *uo1391 = (struct UserObject*)obj1373;
  uo1391->data[9] = emptyclosure;
  Method *meth_meth_ast_isntEmpty1391 = addmethod2pos(obj1373, "isntEmpty", &meth_ast_isntEmpty1391, 9);
  int argcv_meth_ast_isntEmpty1391[] = {0};
  meth_meth_ast_isntEmpty1391->type = alloc_MethodType(1, argcv_meth_ast_isntEmpty1391);
  meth_meth_ast_isntEmpty1391->definitionModule = modulename;
  meth_meth_ast_isntEmpty1391->definitionLine = 288;
// method scope:=
  struct UserObject *uo1400 = (struct UserObject*)obj1373;
  uo1400->data[10] = emptyclosure;
  Method *meth_meth_ast_scope_58__61_1400 = addmethod2pos(obj1373, "scope:=", &meth_ast_scope_58__61_1400, 10);
  int argcv_meth_ast_scope_58__61_1400[] = {1};
  meth_meth_ast_scope_58__61_1400->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61_1400);
  meth_meth_ast_scope_58__61_1400->definitionModule = modulename;
  meth_meth_ast_scope_58__61_1400->definitionLine = 289;
// method declarationKindWithAncestors
  struct UserObject *uo1405 = (struct UserObject*)obj1373;
  uo1405->data[11] = emptyclosure;
  Method *meth_meth_ast_declarationKindWithAncestors1405 = addmethod2pos(obj1373, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors1405, 11);
  int argcv_meth_ast_declarationKindWithAncestors1405[] = {1};
  meth_meth_ast_declarationKindWithAncestors1405->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors1405);
  meth_meth_ast_declarationKindWithAncestors1405->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors1405->definitionLine = 295;
// method isMatchingBlock
  struct UserObject *uo1407 = (struct UserObject*)obj1373;
  uo1407->data[12] = emptyclosure;
  Method *meth_meth_ast_isMatchingBlock1407 = addmethod2pos(obj1373, "isMatchingBlock", &meth_ast_isMatchingBlock1407, 12);
  int argcv_meth_ast_isMatchingBlock1407[] = {0};
  meth_meth_ast_isMatchingBlock1407->type = alloc_MethodType(1, argcv_meth_ast_isMatchingBlock1407);
  meth_meth_ast_isMatchingBlock1407->definitionModule = modulename;
  meth_meth_ast_isMatchingBlock1407->definitionLine = 298;
// method returnsObject
  struct UserObject *uo1416 = (struct UserObject*)obj1373;
  uo1416->data[13] = emptyclosure;
  Method *meth_meth_ast_returnsObject1416 = addmethod2pos(obj1373, "returnsObject", &meth_ast_returnsObject1416, 13);
  int argcv_meth_ast_returnsObject1416[] = {0};
  meth_meth_ast_returnsObject1416->type = alloc_MethodType(1, argcv_meth_ast_returnsObject1416);
  meth_meth_ast_returnsObject1416->definitionModule = modulename;
  meth_meth_ast_returnsObject1416->definitionLine = 299;
// method returnedObjectScope
  struct UserObject *uo1436 = (struct UserObject*)obj1373;
  uo1436->data[14] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope1436 = addmethod2pos(obj1373, "returnedObjectScope", &meth_ast_returnedObjectScope1436, 14);
  int argcv_meth_ast_returnedObjectScope1436[] = {0};
  meth_meth_ast_returnedObjectScope1436->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope1436);
  meth_meth_ast_returnedObjectScope1436->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope1436->definitionLine = 302;
// method parametersDo
  struct UserObject *uo1443 = (struct UserObject*)obj1373;
  uo1443->data[15] = emptyclosure;
  Method *meth_meth_ast_parametersDo1443 = addmethod2pos(obj1373, "parametersDo", &meth_ast_parametersDo1443, 15);
  int argcv_meth_ast_parametersDo1443[] = {1};
  meth_meth_ast_parametersDo1443->type = alloc_MethodType(1, argcv_meth_ast_parametersDo1443);
  meth_meth_ast_parametersDo1443->definitionModule = modulename;
  meth_meth_ast_parametersDo1443->definitionLine = 306;
// method accept()from
  struct UserObject *uo1448 = (struct UserObject*)obj1373;
  uo1448->data[16] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from1448 = addmethod2pos(obj1373, "accept()from", &meth_ast_accept_40__41_from1448, 16);
  int argcv_meth_ast_accept_40__41_from1448[] = {1, 1};
  meth_meth_ast_accept_40__41_from1448->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from1448);
  meth_meth_ast_accept_40__41_from1448->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from1448->definitionLine = 309;
// method map()ancestors
  struct UserObject *uo1483 = (struct UserObject*)obj1373;
  uo1483->data[17] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors1483 = addmethod2pos(obj1373, "map()ancestors", &meth_ast_map_40__41_ancestors1483, 17);
  int argcv_meth_ast_map_40__41_ancestors1483[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors1483->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors1483);
  meth_meth_ast_map_40__41_ancestors1483->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors1483->definitionLine = 323;
// method pretty
  struct UserObject *uo1520 = (struct UserObject*)obj1373;
  uo1520->data[18] = emptyclosure;
  Method *meth_meth_ast_pretty1520 = addmethod2pos(obj1373, "pretty", &meth_ast_pretty1520, 18);
  int argcv_meth_ast_pretty1520[] = {1};
  meth_meth_ast_pretty1520->type = alloc_MethodType(1, argcv_meth_ast_pretty1520);
  meth_meth_ast_pretty1520->definitionModule = modulename;
  meth_meth_ast_pretty1520->definitionLine = 331;
// method toGrace
  struct UserObject *uo1650 = (struct UserObject*)obj1373;
  uo1650->data[19] = emptyclosure;
  Method *meth_meth_ast_toGrace1650 = addmethod2pos(obj1373, "toGrace", &meth_ast_toGrace1650, 19);
  int argcv_meth_ast_toGrace1650[] = {1};
  meth_meth_ast_toGrace1650->type = alloc_MethodType(1, argcv_meth_ast_toGrace1650);
meth_meth_ast_toGrace1650->type->types[0] = type_Number;
meth_meth_ast_toGrace1650->type->names[0] = "depth";
  meth_meth_ast_toGrace1650->definitionModule = modulename;
  meth_meth_ast_toGrace1650->definitionLine = 353;
// method shallowCopy
  block_savedest(obj1373);
  Object closure1784 = createclosure(1, "shallowCopy");
  setclosureframe(closure1784, stackframe);
  addtoclosure(closure1784, var_blockNode);
  struct UserObject *uo1784 = (struct UserObject*)obj1373;
  uo1784->data[20] = (Object)closure1784;
  Method *meth_meth_ast_shallowCopy1784 = addmethod2pos(obj1373, "shallowCopy", &meth_ast_shallowCopy1784, 20);
  int argcv_meth_ast_shallowCopy1784[] = {0};
  meth_meth_ast_shallowCopy1784->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy1784);
  meth_meth_ast_shallowCopy1784->definitionModule = modulename;
  meth_meth_ast_shallowCopy1784->definitionLine = 381;
// method shallowCopyFieldsFrom
  struct UserObject *uo1793 = (struct UserObject*)obj1373;
  uo1793->data[21] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom1793 = addmethod2pos(obj1373, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom1793, 21);
  int argcv_meth_ast_shallowCopyFieldsFrom1793[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom1793->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom1793);
  meth_meth_ast_shallowCopyFieldsFrom1793->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom1793->definitionLine = 384;
  sourceObject = obj1373;
// Begin line 276
  setline(276);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1804 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1805 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe1804);
// compiled call node returning call1805 (depth = 4)
  struct UserObject *obj1373_uo = (struct UserObject *)obj1373;
  obj1373_uo->super = call1805;
  sourceObject = obj1373;
// Begin line 277
  setline(277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit1806 == NULL) {
    strlit1806 = alloc_String("block");
    gc_root(strlit1806);
  }
// compiled string node returning strlit1806 (depth = 4)
  adddatum2(obj1373, strlit1806, 1);
  sourceObject = obj1373;
// Begin line 278
  setline(278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit1807 == NULL) {
    strlit1807 = alloc_String("block");
    gc_root(strlit1807);
  }
// compiled string node returning strlit1807 (depth = 4)
  adddatum2(obj1373, strlit1807, 2);
  sourceObject = obj1373;
// Begin line 279
  setline(279);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_params_39_ (depth = 4)
  adddatum2(obj1373, *var_params_39_, 3);
  sourceObject = obj1373;
// Begin line 280
  setline(280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_body_39_ (depth = 4)
  adddatum2(obj1373, *var_body_39_, 4);
  sourceObject = obj1373;
// Begin line 281
  setline(281);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool1808 = alloc_Boolean(1);
// compiled identifier node returning bool1808 (depth = 4)
  adddatum2(obj1373, bool1808, 5);
  sourceObject = obj1373;
// Begin line 282
  setline(282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool1809 = alloc_Boolean(0);
// compiled identifier node returning bool1809 (depth = 4)
  adddatum2(obj1373, bool1809, 6);
  sourceObject = obj1373;
// Begin line 283
  setline(283);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool1810 = alloc_Boolean(0);
// compiled identifier node returning bool1810 (depth = 4)
  adddatum2(obj1373, bool1810, 7);
  sourceObject = obj1373;
// Begin line 284
  setline(284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1811 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_params_39_ (depth = 5)
  gc_frame_newslot(*var_params_39_);
// starting to compile block node (depth = 5)
  Object block1812 = alloc_Block(NULL, NULL, "ast", 284);
  gc_frame_newslot(block1812);
// method _apply
  block_savedest(block1812);
  Object closure1813 = createclosure(3, "_apply");
  setclosureframe(closure1813, stackframe);
  addtoclosure(closure1813, var_patternMarkVisitor);
  addtoclosure(closure1813, var_ancestorChain);
  addtoclosure(closure1813, selfslot);
  struct UserObject *uo1813 = (struct UserObject*)block1812;
  uo1813->data[0] = (Object)closure1813;
  Method *meth_meth_ast__apply1813 = addmethod2pos(block1812, "_apply", &meth_ast__apply1813, 0);
  int argcv_meth_ast__apply1813[] = {1};
  meth_meth_ast__apply1813->type = alloc_MethodType(1, argcv_meth_ast__apply1813);
  meth_meth_ast__apply1813->definitionModule = modulename;
  meth_meth_ast__apply1813->definitionLine = 387;
// compiled block node returning block1812 (depth = 5)
  gc_frame_newslot(block1812);
// call case 5: prelude request
  params[0] = *var_params_39_;
  params[1] = block1812;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1819 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1811);
// compiled call node returning call1819 (depth = 4)
  sourceObject = obj1373;
  sourceObject = obj1373;
  sourceObject = obj1373;
  sourceObject = obj1373;
  sourceObject = obj1373;
  sourceObject = obj1373;
  sourceObject = obj1373;
  sourceObject = obj1373;
  sourceObject = obj1373;
  sourceObject = obj1373;
  sourceObject = obj1373;
  sourceObject = obj1373;
  sourceObject = obj1373;
  sourceObject = obj1373;
  objclass1373 = obj1373->class;
  objclass1373->definitionModule = modulename;
  objclass1373->definitionLine = 275;
  (*(struct UserObject *)self).data[0] = lowerouter1373;
  self = oldself1373;
  selfslot = oldselfslot1373;
  stackframe = oldstackframe1373;
  gc_frame_end(frame);
  return obj1373;
}
Object meth_ast_new1372_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method new()object");
  Object params[2];
  int partcv[2];
  Object *var_blockNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  Object *var_patternMarkVisitor = getfromclosure(closure, 2);
  Object *var_ancestorChain = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_params_39_ = &(stackframe->slots[0]);
  *var_params_39_ = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[1]);
  *var_body_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1373 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1373 = alloc_userobj2(27,24, objclass1373);
  gc_frame_newslot(obj1373);
if (objclass1373 == NULL) {
  glfree(obj1373->class->name);
  obj1373->class->name = "blockNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1373, self, 0);
  addmethodreal(obj1373,"outer", &reader_ast_outer_1374);
  Object oldself1373 = self;
  struct StackFrameObject *oldstackframe1373 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1373);
  gc_frame_newslot((Object)stackframe);
  self = obj1373;
  Object *oldselfslot1373 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1373 = (*(struct UserObject *)self).data[0], lowerouter1373 = thisouter1373;
  if (inheritingObject1373) {
    struct UserObject *inho1373 = (struct UserObject *)inheritingObject1373;
    while (inho1373->super != GraceDefaultObject) inho1373 = (struct UserObject *)inho1373->super;
    inho1373->super = obj1373;
    self = inheritingObject1373;
    *selfslot = self;
    lowerouter1373 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1373;
  }
if (objclass1373 == NULL) {
  Method *reader1375 = addmethodrealflags(obj1373, "kind",&reader_ast_kind_1375, MFLAG_DEF);
  reader1375->definitionModule = modulename;
  reader1375->definitionLine = 277;
}
adddatum2(obj1373, alloc_Undefined(), 1);
if (objclass1373 == NULL) {
  Method *reader1376 = addmethodrealflags(obj1373, "value",&reader_ast_value_1376, MFLAG_DEF);
  reader1376->definitionModule = modulename;
  reader1376->definitionLine = 278;
}
adddatum2(obj1373, alloc_Undefined(), 2);
if (objclass1373 == NULL) {
  Method *reader1377 = addmethodrealflags(obj1373, "params",&reader_ast_params_1377, 0);
  Method *writer1377 = addmethodrealflags(obj1373, "params:=",&writer_ast_params_1377, 0);
  reader1377->definitionModule = modulename;
  writer1377->definitionModule = modulename;
  reader1377->definitionLine = 279;
  writer1377->definitionLine = 279;
}
obj1373->flags |= OFLAG_MUTABLE;
adddatum2(obj1373, alloc_Undefined(), 3);
if (objclass1373 == NULL) {
  Method *reader1378 = addmethodrealflags(obj1373, "body",&reader_ast_body_1378, 0);
  Method *writer1378 = addmethodrealflags(obj1373, "body:=",&writer_ast_body_1378, 0);
  reader1378->definitionModule = modulename;
  writer1378->definitionModule = modulename;
  reader1378->definitionLine = 280;
  writer1378->definitionLine = 280;
}
obj1373->flags |= OFLAG_MUTABLE;
adddatum2(obj1373, alloc_Undefined(), 4);
if (objclass1373 == NULL) {
  Method *reader1379 = addmethodrealflags(obj1373, "selfclosure",&reader_ast_selfclosure_1379, MFLAG_DEF);
  reader1379->definitionModule = modulename;
  reader1379->definitionLine = 281;
}
adddatum2(obj1373, alloc_Undefined(), 5);
if (objclass1373 == NULL) {
  Method *reader1380 = addmethodrealflags(obj1373, "matchingPattern",&reader_ast_matchingPattern_1380, 0);
  Method *writer1380 = addmethodrealflags(obj1373, "matchingPattern:=",&writer_ast_matchingPattern_1380, 0);
  reader1380->definitionModule = modulename;
  writer1380->definitionModule = modulename;
  reader1380->definitionLine = 282;
  writer1380->definitionLine = 282;
}
obj1373->flags |= OFLAG_MUTABLE;
adddatum2(obj1373, alloc_Undefined(), 6);
if (objclass1373 == NULL) {
  Method *reader1381 = addmethodrealflags(obj1373, "extraRuntimeData",&reader_ast_extraRuntimeData_1381, 0);
  Method *writer1381 = addmethodrealflags(obj1373, "extraRuntimeData:=",&writer_ast_extraRuntimeData_1381, 0);
  reader1381->definitionModule = modulename;
  writer1381->definitionModule = modulename;
  reader1381->definitionLine = 283;
  writer1381->definitionLine = 283;
}
obj1373->flags |= OFLAG_MUTABLE;
adddatum2(obj1373, alloc_Undefined(), 7);
// method isEmpty
  struct UserObject *uo1382 = (struct UserObject*)obj1373;
  uo1382->data[8] = emptyclosure;
  Method *meth_meth_ast_isEmpty1382 = addmethod2pos(obj1373, "isEmpty", &meth_ast_isEmpty1382, 8);
  int argcv_meth_ast_isEmpty1382[] = {0};
  meth_meth_ast_isEmpty1382->type = alloc_MethodType(1, argcv_meth_ast_isEmpty1382);
  meth_meth_ast_isEmpty1382->definitionModule = modulename;
  meth_meth_ast_isEmpty1382->definitionLine = 287;
// method isntEmpty
  struct UserObject *uo1391 = (struct UserObject*)obj1373;
  uo1391->data[9] = emptyclosure;
  Method *meth_meth_ast_isntEmpty1391 = addmethod2pos(obj1373, "isntEmpty", &meth_ast_isntEmpty1391, 9);
  int argcv_meth_ast_isntEmpty1391[] = {0};
  meth_meth_ast_isntEmpty1391->type = alloc_MethodType(1, argcv_meth_ast_isntEmpty1391);
  meth_meth_ast_isntEmpty1391->definitionModule = modulename;
  meth_meth_ast_isntEmpty1391->definitionLine = 288;
// method scope:=
  struct UserObject *uo1400 = (struct UserObject*)obj1373;
  uo1400->data[10] = emptyclosure;
  Method *meth_meth_ast_scope_58__61_1400 = addmethod2pos(obj1373, "scope:=", &meth_ast_scope_58__61_1400, 10);
  int argcv_meth_ast_scope_58__61_1400[] = {1};
  meth_meth_ast_scope_58__61_1400->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61_1400);
  meth_meth_ast_scope_58__61_1400->definitionModule = modulename;
  meth_meth_ast_scope_58__61_1400->definitionLine = 289;
// method declarationKindWithAncestors
  struct UserObject *uo1405 = (struct UserObject*)obj1373;
  uo1405->data[11] = emptyclosure;
  Method *meth_meth_ast_declarationKindWithAncestors1405 = addmethod2pos(obj1373, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors1405, 11);
  int argcv_meth_ast_declarationKindWithAncestors1405[] = {1};
  meth_meth_ast_declarationKindWithAncestors1405->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors1405);
  meth_meth_ast_declarationKindWithAncestors1405->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors1405->definitionLine = 295;
// method isMatchingBlock
  struct UserObject *uo1407 = (struct UserObject*)obj1373;
  uo1407->data[12] = emptyclosure;
  Method *meth_meth_ast_isMatchingBlock1407 = addmethod2pos(obj1373, "isMatchingBlock", &meth_ast_isMatchingBlock1407, 12);
  int argcv_meth_ast_isMatchingBlock1407[] = {0};
  meth_meth_ast_isMatchingBlock1407->type = alloc_MethodType(1, argcv_meth_ast_isMatchingBlock1407);
  meth_meth_ast_isMatchingBlock1407->definitionModule = modulename;
  meth_meth_ast_isMatchingBlock1407->definitionLine = 298;
// method returnsObject
  struct UserObject *uo1416 = (struct UserObject*)obj1373;
  uo1416->data[13] = emptyclosure;
  Method *meth_meth_ast_returnsObject1416 = addmethod2pos(obj1373, "returnsObject", &meth_ast_returnsObject1416, 13);
  int argcv_meth_ast_returnsObject1416[] = {0};
  meth_meth_ast_returnsObject1416->type = alloc_MethodType(1, argcv_meth_ast_returnsObject1416);
  meth_meth_ast_returnsObject1416->definitionModule = modulename;
  meth_meth_ast_returnsObject1416->definitionLine = 299;
// method returnedObjectScope
  struct UserObject *uo1436 = (struct UserObject*)obj1373;
  uo1436->data[14] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope1436 = addmethod2pos(obj1373, "returnedObjectScope", &meth_ast_returnedObjectScope1436, 14);
  int argcv_meth_ast_returnedObjectScope1436[] = {0};
  meth_meth_ast_returnedObjectScope1436->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope1436);
  meth_meth_ast_returnedObjectScope1436->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope1436->definitionLine = 302;
// method parametersDo
  struct UserObject *uo1443 = (struct UserObject*)obj1373;
  uo1443->data[15] = emptyclosure;
  Method *meth_meth_ast_parametersDo1443 = addmethod2pos(obj1373, "parametersDo", &meth_ast_parametersDo1443, 15);
  int argcv_meth_ast_parametersDo1443[] = {1};
  meth_meth_ast_parametersDo1443->type = alloc_MethodType(1, argcv_meth_ast_parametersDo1443);
  meth_meth_ast_parametersDo1443->definitionModule = modulename;
  meth_meth_ast_parametersDo1443->definitionLine = 306;
// method accept()from
  struct UserObject *uo1448 = (struct UserObject*)obj1373;
  uo1448->data[16] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from1448 = addmethod2pos(obj1373, "accept()from", &meth_ast_accept_40__41_from1448, 16);
  int argcv_meth_ast_accept_40__41_from1448[] = {1, 1};
  meth_meth_ast_accept_40__41_from1448->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from1448);
  meth_meth_ast_accept_40__41_from1448->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from1448->definitionLine = 309;
// method map()ancestors
  struct UserObject *uo1483 = (struct UserObject*)obj1373;
  uo1483->data[17] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors1483 = addmethod2pos(obj1373, "map()ancestors", &meth_ast_map_40__41_ancestors1483, 17);
  int argcv_meth_ast_map_40__41_ancestors1483[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors1483->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors1483);
  meth_meth_ast_map_40__41_ancestors1483->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors1483->definitionLine = 323;
// method pretty
  struct UserObject *uo1520 = (struct UserObject*)obj1373;
  uo1520->data[18] = emptyclosure;
  Method *meth_meth_ast_pretty1520 = addmethod2pos(obj1373, "pretty", &meth_ast_pretty1520, 18);
  int argcv_meth_ast_pretty1520[] = {1};
  meth_meth_ast_pretty1520->type = alloc_MethodType(1, argcv_meth_ast_pretty1520);
  meth_meth_ast_pretty1520->definitionModule = modulename;
  meth_meth_ast_pretty1520->definitionLine = 331;
// method toGrace
  struct UserObject *uo1650 = (struct UserObject*)obj1373;
  uo1650->data[19] = emptyclosure;
  Method *meth_meth_ast_toGrace1650 = addmethod2pos(obj1373, "toGrace", &meth_ast_toGrace1650, 19);
  int argcv_meth_ast_toGrace1650[] = {1};
  meth_meth_ast_toGrace1650->type = alloc_MethodType(1, argcv_meth_ast_toGrace1650);
meth_meth_ast_toGrace1650->type->types[0] = type_Number;
meth_meth_ast_toGrace1650->type->names[0] = "depth";
  meth_meth_ast_toGrace1650->definitionModule = modulename;
  meth_meth_ast_toGrace1650->definitionLine = 353;
// method shallowCopy
  block_savedest(obj1373);
  Object closure1784 = createclosure(1, "shallowCopy");
  setclosureframe(closure1784, stackframe);
  addtoclosure(closure1784, var_blockNode);
  struct UserObject *uo1784 = (struct UserObject*)obj1373;
  uo1784->data[20] = (Object)closure1784;
  Method *meth_meth_ast_shallowCopy1784 = addmethod2pos(obj1373, "shallowCopy", &meth_ast_shallowCopy1784, 20);
  int argcv_meth_ast_shallowCopy1784[] = {0};
  meth_meth_ast_shallowCopy1784->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy1784);
  meth_meth_ast_shallowCopy1784->definitionModule = modulename;
  meth_meth_ast_shallowCopy1784->definitionLine = 381;
// method shallowCopyFieldsFrom
  struct UserObject *uo1793 = (struct UserObject*)obj1373;
  uo1793->data[21] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom1793 = addmethod2pos(obj1373, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom1793, 21);
  int argcv_meth_ast_shallowCopyFieldsFrom1793[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom1793->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom1793);
  meth_meth_ast_shallowCopyFieldsFrom1793->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom1793->definitionLine = 384;
  sourceObject = obj1373;
// Begin line 276
  setline(276);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1804 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1805 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe1804);
// compiled call node returning call1805 (depth = 4)
  struct UserObject *obj1373_uo = (struct UserObject *)obj1373;
  obj1373_uo->super = call1805;
  sourceObject = obj1373;
// Begin line 277
  setline(277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit1806 == NULL) {
    strlit1806 = alloc_String("block");
    gc_root(strlit1806);
  }
// compiled string node returning strlit1806 (depth = 4)
  adddatum2(obj1373, strlit1806, 1);
  sourceObject = obj1373;
// Begin line 278
  setline(278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit1807 == NULL) {
    strlit1807 = alloc_String("block");
    gc_root(strlit1807);
  }
// compiled string node returning strlit1807 (depth = 4)
  adddatum2(obj1373, strlit1807, 2);
  sourceObject = obj1373;
// Begin line 279
  setline(279);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_params_39_ (depth = 4)
  adddatum2(obj1373, *var_params_39_, 3);
  sourceObject = obj1373;
// Begin line 280
  setline(280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_body_39_ (depth = 4)
  adddatum2(obj1373, *var_body_39_, 4);
  sourceObject = obj1373;
// Begin line 281
  setline(281);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool1808 = alloc_Boolean(1);
// compiled identifier node returning bool1808 (depth = 4)
  adddatum2(obj1373, bool1808, 5);
  sourceObject = obj1373;
// Begin line 282
  setline(282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool1809 = alloc_Boolean(0);
// compiled identifier node returning bool1809 (depth = 4)
  adddatum2(obj1373, bool1809, 6);
  sourceObject = obj1373;
// Begin line 283
  setline(283);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool1810 = alloc_Boolean(0);
// compiled identifier node returning bool1810 (depth = 4)
  adddatum2(obj1373, bool1810, 7);
  sourceObject = obj1373;
// Begin line 284
  setline(284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1811 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_params_39_ (depth = 5)
  gc_frame_newslot(*var_params_39_);
// starting to compile block node (depth = 5)
  Object block1812 = alloc_Block(NULL, NULL, "ast", 284);
  gc_frame_newslot(block1812);
// method _apply
  block_savedest(block1812);
  Object closure1813 = createclosure(3, "_apply");
  setclosureframe(closure1813, stackframe);
  addtoclosure(closure1813, var_patternMarkVisitor);
  addtoclosure(closure1813, var_ancestorChain);
  addtoclosure(closure1813, selfslot);
  struct UserObject *uo1813 = (struct UserObject*)block1812;
  uo1813->data[0] = (Object)closure1813;
  Method *meth_meth_ast__apply1813 = addmethod2pos(block1812, "_apply", &meth_ast__apply1813, 0);
  int argcv_meth_ast__apply1813[] = {1};
  meth_meth_ast__apply1813->type = alloc_MethodType(1, argcv_meth_ast__apply1813);
  meth_meth_ast__apply1813->definitionModule = modulename;
  meth_meth_ast__apply1813->definitionLine = 387;
// compiled block node returning block1812 (depth = 5)
  gc_frame_newslot(block1812);
// call case 5: prelude request
  params[0] = *var_params_39_;
  params[1] = block1812;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1819 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1811);
// compiled call node returning call1819 (depth = 4)
  sourceObject = obj1373;
  sourceObject = obj1373;
  sourceObject = obj1373;
  sourceObject = obj1373;
  sourceObject = obj1373;
  sourceObject = obj1373;
  sourceObject = obj1373;
  sourceObject = obj1373;
  sourceObject = obj1373;
  sourceObject = obj1373;
  sourceObject = obj1373;
  sourceObject = obj1373;
  sourceObject = obj1373;
  sourceObject = obj1373;
  objclass1373 = obj1373->class;
  objclass1373->definitionModule = modulename;
  objclass1373->definitionLine = 275;
  (*(struct UserObject *)self).data[0] = lowerouter1373;
  self = oldself1373;
  selfslot = oldselfslot1373;
  stackframe = oldstackframe1373;
  gc_frame_end(frame);
  return obj1373;
}
Object meth_ast_catchCaseNode1821(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 18, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "catchCaseNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_catchCaseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for catchCaseNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for catchCaseNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_catchCaseNode (depth = 3)
  gc_frame_end(frame);
  return *var_catchCaseNode;
}
Object meth_ast_isSimple1831(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSimple");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isSimple (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isSimple");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 397
  setline(397);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool1832 = alloc_Boolean(0);
// compiled identifier node returning bool1832 (depth = 4)
  gc_frame_end(frame);
  return bool1832;
}
Object meth_ast__apply1847(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 404
  setline(404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1848 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_visitor (depth = 8)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_newChain (depth = 8)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mx (depth = 8)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1849 = callmethod(*var_mx, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe1848);
// compiled call node returning call1849 (depth = 7)
  gc_frame_end(frame);
  return call1849;
}
Object meth_ast_accept_40__41_from1833(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 400
  setline(400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1835 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1836 = callmethod(*var_visitor, "visitCatchCase()up",
    2, partcv, params);
  gc_frame_end(callframe1835);
// compiled call node returning call1836 (depth = 5)
  Object if1834 = done;
  if (istrue(call1836)) {
// Begin line 401
  setline(401);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1837 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_as (depth = 7)
  params[0] = self;
  partcv[0] = 1;
  Object call1838 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe1837);
// compiled call node returning call1838 (depth = 6)
  *var_newChain = call1838;
  if (call1838 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 402
  setline(402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1839 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1840 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1841 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1840);
// compiled call node returning call1841 (depth = 7)
// compiled member node returning call1841 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1842 = callmethod(call1841, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe1839);
// compiled call node returning call1842 (depth = 5)
// Begin line 403
  setline(403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1843 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1844 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1845 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1844);
// compiled call node returning call1845 (depth = 7)
// compiled member node returning call1845 (depth = 6)
  gc_frame_newslot(call1845);
// starting to compile block node (depth = 6)
  Object block1846 = alloc_Block(NULL, NULL, "ast", 403);
  gc_frame_newslot(block1846);
// method _apply
  block_savedest(block1846);
  Object closure1847 = createclosure(3, "_apply");
  setclosureframe(closure1847, stackframe);
  addtoclosure(closure1847, var_visitor);
  addtoclosure(closure1847, var_newChain);
  addtoclosure(closure1847, selfslot);
  struct UserObject *uo1847 = (struct UserObject*)block1846;
  uo1847->data[0] = (Object)closure1847;
  Method *meth_meth_ast__apply1847 = addmethod2pos(block1846, "_apply", &meth_ast__apply1847, 0);
  int argcv_meth_ast__apply1847[] = {1};
  meth_meth_ast__apply1847->type = alloc_MethodType(1, argcv_meth_ast__apply1847);
  meth_meth_ast__apply1847->definitionModule = modulename;
  meth_meth_ast__apply1847->definitionLine = 403;
// compiled block node returning block1846 (depth = 6)
  gc_frame_newslot(block1846);
// call case 5: prelude request
  params[0] = call1845;
  params[1] = block1846;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1851 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1843);
// compiled call node returning call1851 (depth = 5)
// Begin line 406
  setline(406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool1854 = alloc_Boolean(0);
// compiled identifier node returning bool1854 (depth = 7)
  int op_slot_right_1853 = gc_frame_newslot(bool1854);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1856 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1857 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1856);
// compiled call node returning call1857 (depth = 8)
// compiled member node returning call1857 (depth = 7)
  int op_slot_left_1853 = gc_frame_newslot(call1857);
  params[0] = bool1854;
  partcv[0] = 1;
  Object opresult1858 = callmethod(call1857, "!=", 1, partcv, params);
// compiled op node returning opresult1858 (depth = 6)
  Object if1852 = done;
  if (istrue(opresult1858)) {
// Begin line 407
  setline(407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1859 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1860 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1861 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1860);
// compiled call node returning call1861 (depth = 8)
// compiled member node returning call1861 (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1862 = callmethod(call1861, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe1859);
// compiled call node returning call1862 (depth = 6)
    gc_frame_newslot(call1862);
    if1852 = call1862;
  } else {
  }
// compiled if node returning if1852 (depth = 5)
    gc_frame_newslot(if1852);
    if1834 = if1852;
  } else {
  }
// compiled if node returning if1834 (depth = 4)
  gc_frame_end(frame);
  return if1834;
}
Object meth_ast_map_40__41_ancestors1863(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 412
  setline(412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1864 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1865 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1864);
// compiled call node returning call1865 (depth = 6)
// compiled member node returning call1865 (depth = 5)
  *var_n = call1865;
  if (call1865 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 413
  setline(413);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1866 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call1867 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe1866);
// compiled call node returning call1867 (depth = 5)
  *var_newChain = call1867;
  if (call1867 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 414
  setline(414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 412
  setline(412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1868 = gc_frame_new();
// Begin line 414
  setline(414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1869 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1870 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1871 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1870);
// compiled call node returning call1871 (depth = 8)
// compiled member node returning call1871 (depth = 7)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1872 = callmethod(call1871, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe1869);
// compiled call node returning call1872 (depth = 6)
  gc_frame_newslot(call1872);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call1872;
  partcv[0] = 1;
  Object call1873 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe1868);
// compiled call node returning call1873 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 415
  setline(415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 414
  setline(414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1874 = gc_frame_new();
// Begin line 415
  setline(415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1875 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1876 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1877 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1876);
// compiled call node returning call1877 (depth = 8)
// compiled member node returning call1877 (depth = 7)
  gc_frame_newslot(call1877);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1878 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1879 = gc_frame_new();
// call case 3: self.outer request
  Object call1880 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1879);
// compiled call node returning call1880 (depth = 10)
// compiled member node returning call1880 (depth = 9)
  partcv[0] = 0;
  Object call1881 = callmethodflags(call1880, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1878);
// compiled call node returning call1881 (depth = 8)
// compiled member node returning call1881 (depth = 7)
  params[0] = call1877;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call1882 = callmethodflags(call1881, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1875);
// compiled call node returning call1882 (depth = 6)
  gc_frame_newslot(call1882);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call1882;
  partcv[0] = 1;
  Object call1883 = callmethod(*var_n, "cases:=",
    1, partcv, params);
  gc_frame_end(callframe1874);
// compiled call node returning call1883 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 416
  setline(416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 415
  setline(415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1884 = gc_frame_new();
// Begin line 416
  setline(416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1885 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1886 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1887 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1886);
// compiled call node returning call1887 (depth = 8)
// compiled member node returning call1887 (depth = 7)
  gc_frame_newslot(call1887);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1888 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1889 = gc_frame_new();
// call case 3: self.outer request
  Object call1890 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1889);
// compiled call node returning call1890 (depth = 10)
// compiled member node returning call1890 (depth = 9)
  partcv[0] = 0;
  Object call1891 = callmethodflags(call1890, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1888);
// compiled call node returning call1891 (depth = 8)
// compiled member node returning call1891 (depth = 7)
  params[0] = call1887;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call1892 = callmethodflags(call1891, "maybeMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1885);
// compiled call node returning call1892 (depth = 6)
  gc_frame_newslot(call1892);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call1892;
  partcv[0] = 1;
  Object call1893 = callmethod(*var_n, "finally:=",
    1, partcv, params);
  gc_frame_end(callframe1884);
// compiled call node returning call1893 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 417
  setline(417);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1894 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call1895 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe1894);
// compiled call node returning call1895 (depth = 4)
  gc_frame_end(frame);
  return call1895;
}
Object meth_ast__apply1904(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 422
  setline(422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1906 == NULL) {
    strlit1906 = alloc_String("  ");
    gc_root(strlit1906);
  }
// compiled string node returning strlit1906 (depth = 8)
  int op_slot_right_1905 = gc_frame_newslot(strlit1906);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_1905 = gc_frame_newslot(*var_spc);
  params[0] = strlit1906;
  partcv[0] = 1;
  Object opresult1908 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult1908 (depth = 7)
  *var_spc = opresult1908;
  if (opresult1908 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1941(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 427
  setline(427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1944 == NULL) {
    strlit1944 = alloc_String("");
    gc_root(strlit1944);
  }
// compiled string node returning strlit1944 (depth = 9)
  int op_slot_right_1943 = gc_frame_newslot(strlit1944);
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1947 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num1949 = alloc_Float64(2);
// compiled num node returning num1949 (depth = 12)
  int op_slot_right_1948 = gc_frame_newslot(num1949);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_depth (depth = 12)
  int op_slot_left_1948 = gc_frame_newslot(*var_depth);
  params[0] = num1949;
  partcv[0] = 1;
  Object sum1951 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum1951 (depth = 11)
  gc_frame_newslot(sum1951);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_mx (depth = 11)
  params[0] = sum1951;
  partcv[0] = 1;
  Object call1952 = callmethod(*var_mx, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1947);
// compiled call node returning call1952 (depth = 10)
  int op_slot_right_1946 = gc_frame_newslot(call1952);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1955 == NULL) {
    strlit1955 = alloc_String("  ");
    gc_root(strlit1955);
  }
// compiled string node returning strlit1955 (depth = 11)
  int op_slot_right_1954 = gc_frame_newslot(strlit1955);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_spc (depth = 12)
  int op_slot_right_1957 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit1960 == NULL) {
    strlit1960 = alloc_String("Case:""\x0a""");
    gc_root(strlit1960);
  }
// compiled string node returning strlit1960 (depth = 13)
  int op_slot_right_1959 = gc_frame_newslot(strlit1960);
// starting to compile op node (depth = 13)
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_spc (depth = 14)
  int op_slot_right_1962 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 14)
  if (strlit1964 == NULL) {
    strlit1964 = alloc_String("""\x0a""");
    gc_root(strlit1964);
  }
// compiled string node returning strlit1964 (depth = 14)
  int op_slot_left_1962 = gc_frame_newslot(strlit1964);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1965 = callmethod(strlit1964, "++", 1, partcv, params);
// compiled op node returning opresult1965 (depth = 13)
  int op_slot_left_1959 = gc_frame_newslot(opresult1965);
  params[0] = strlit1960;
  partcv[0] = 1;
  Object opresult1966 = callmethod(opresult1965, "++", 1, partcv, params);
// compiled op node returning opresult1966 (depth = 12)
  int op_slot_left_1957 = gc_frame_newslot(opresult1966);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1967 = callmethod(opresult1966, "++", 1, partcv, params);
// compiled op node returning opresult1967 (depth = 11)
  int op_slot_left_1954 = gc_frame_newslot(opresult1967);
  params[0] = strlit1955;
  partcv[0] = 1;
  Object opresult1968 = callmethod(opresult1967, "++", 1, partcv, params);
// compiled op node returning opresult1968 (depth = 10)
  int op_slot_left_1946 = gc_frame_newslot(opresult1968);
  params[0] = call1952;
  partcv[0] = 1;
  Object opresult1969 = callmethod(opresult1968, "++", 1, partcv, params);
// compiled op node returning opresult1969 (depth = 9)
  int op_slot_left_1943 = gc_frame_newslot(opresult1969);
  params[0] = strlit1944;
  partcv[0] = 1;
  Object opresult1970 = callmethod(opresult1969, "++", 1, partcv, params);
// compiled op node returning opresult1970 (depth = 8)
  int op_slot_right_1942 = gc_frame_newslot(opresult1970);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_1942 = gc_frame_newslot(*var_s);
  params[0] = opresult1970;
  partcv[0] = 1;
  Object opresult1972 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1972 (depth = 7)
  *var_s = opresult1972;
  if (opresult1972 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty1896(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 420
  setline(420);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1897 == NULL) {
    strlit1897 = alloc_String("");
    gc_root(strlit1897);
  }
// compiled string node returning strlit1897 (depth = 5)
  *var_spc = strlit1897;
  if (strlit1897 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 421
  setline(421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1898 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_right_1899 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 6)
  Object num1901 = alloc_Float64(0);
// compiled num node returning num1901 (depth = 6)
  int op_slot_left_1899 = gc_frame_newslot(num1901);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult1902 = callmethod(num1901, "..", 1, partcv, params);
// compiled op node returning opresult1902 (depth = 5)
  gc_frame_newslot(opresult1902);
// starting to compile block node (depth = 5)
  Object block1903 = alloc_Block(NULL, NULL, "ast", 421);
  gc_frame_newslot(block1903);
// method _apply
  block_savedest(block1903);
  Object closure1904 = createclosure(2, "_apply");
  setclosureframe(closure1904, stackframe);
  addtoclosure(closure1904, var_spc);
  addtoclosure(closure1904, selfslot);
  struct UserObject *uo1904 = (struct UserObject*)block1903;
  uo1904->data[0] = (Object)closure1904;
  Method *meth_meth_ast__apply1904 = addmethod2pos(block1903, "_apply", &meth_ast__apply1904, 0);
  int argcv_meth_ast__apply1904[] = {1};
  meth_meth_ast__apply1904->type = alloc_MethodType(1, argcv_meth_ast__apply1904);
  meth_meth_ast__apply1904->definitionModule = modulename;
  meth_meth_ast__apply1904->definitionLine = 416;
// compiled block node returning block1903 (depth = 5)
  gc_frame_newslot(block1903);
// call case 5: prelude request
  params[0] = opresult1902;
  params[1] = block1903;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1911 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1898);
// compiled call node returning call1911 (depth = 4)
// Begin line 424
  setline(424);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1913 == NULL) {
    strlit1913 = alloc_String("""\x0a""");
    gc_root(strlit1913);
  }
// compiled string node returning strlit1913 (depth = 6)
  int op_slot_right_1912 = gc_frame_newslot(strlit1913);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1916 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call1917 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe1916);
// compiled call node returning call1917 (depth = 7)
  int op_slot_right_1915 = gc_frame_newslot(call1917);
// starting to compile string node (depth = 7)
  if (strlit1919 == NULL) {
    strlit1919 = alloc_String("");
    gc_root(strlit1919);
  }
// compiled string node returning strlit1919 (depth = 7)
  int op_slot_left_1915 = gc_frame_newslot(strlit1919);
  params[0] = call1917;
  partcv[0] = 1;
  Object opresult1920 = callmethod(strlit1919, "++", 1, partcv, params);
// compiled op node returning opresult1920 (depth = 6)
  int op_slot_left_1912 = gc_frame_newslot(opresult1920);
  params[0] = strlit1913;
  partcv[0] = 1;
  Object opresult1921 = callmethod(opresult1920, "++", 1, partcv, params);
// compiled op node returning opresult1921 (depth = 5)
  *var_s = opresult1921;
  if (opresult1921 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 425
  setline(425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1923 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1925 = alloc_Float64(2);
// compiled num node returning num1925 (depth = 8)
  int op_slot_right_1924 = gc_frame_newslot(num1925);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_1924 = gc_frame_newslot(*var_depth);
  params[0] = num1925;
  partcv[0] = 1;
  Object sum1927 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum1927 (depth = 7)
  gc_frame_newslot(sum1927);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1928 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1929 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1928);
// compiled call node returning call1929 (depth = 8)
// compiled member node returning call1929 (depth = 7)
  params[0] = sum1927;
  partcv[0] = 1;
  Object call1930 = callmethod(call1929, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1923);
// compiled call node returning call1930 (depth = 6)
  int op_slot_right_1922 = gc_frame_newslot(call1930);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_1932 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1932 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1934 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1934 (depth = 6)
  int op_slot_left_1922 = gc_frame_newslot(opresult1934);
  params[0] = call1930;
  partcv[0] = 1;
  Object opresult1935 = callmethod(opresult1934, "++", 1, partcv, params);
// compiled op node returning opresult1935 (depth = 5)
  *var_s = opresult1935;
  if (opresult1935 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 426
  setline(426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1937 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1938 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1939 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1938);
// compiled call node returning call1939 (depth = 6)
// compiled member node returning call1939 (depth = 5)
  gc_frame_newslot(call1939);
// starting to compile block node (depth = 5)
  Object block1940 = alloc_Block(NULL, NULL, "ast", 426);
  gc_frame_newslot(block1940);
// method _apply
  block_savedest(block1940);
  Object closure1941 = createclosure(4, "_apply");
  setclosureframe(closure1941, stackframe);
  addtoclosure(closure1941, var_depth);
  addtoclosure(closure1941, var_spc);
  addtoclosure(closure1941, var_s);
  addtoclosure(closure1941, selfslot);
  struct UserObject *uo1941 = (struct UserObject*)block1940;
  uo1941->data[0] = (Object)closure1941;
  Method *meth_meth_ast__apply1941 = addmethod2pos(block1940, "_apply", &meth_ast__apply1941, 0);
  int argcv_meth_ast__apply1941[] = {1};
  meth_meth_ast__apply1941->type = alloc_MethodType(1, argcv_meth_ast__apply1941);
  meth_meth_ast__apply1941->definitionModule = modulename;
  meth_meth_ast__apply1941->definitionLine = 426;
// compiled block node returning block1940 (depth = 5)
  gc_frame_newslot(block1940);
// call case 5: prelude request
  params[0] = call1939;
  params[1] = block1940;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1975 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1937);
// compiled call node returning call1975 (depth = 4)
// Begin line 429
  setline(429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1978 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1979 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1978);
// compiled call node returning call1979 (depth = 7)
// compiled member node returning call1979 (depth = 6)
  int op_slot_right_1977 = gc_frame_newslot(call1979);
// starting to compile identifier node (depth = 6)
  Object bool1981 = alloc_Boolean(0);
// compiled identifier node returning bool1981 (depth = 6)
  int op_slot_left_1977 = gc_frame_newslot(bool1981);
  params[0] = call1979;
  partcv[0] = 1;
  Object opresult1982 = callmethod(bool1981, "!=", 1, partcv, params);
// compiled op node returning opresult1982 (depth = 5)
  Object if1976 = done;
  if (istrue(opresult1982)) {
// Begin line 430
  setline(430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1985 == NULL) {
    strlit1985 = alloc_String("");
    gc_root(strlit1985);
  }
// compiled string node returning strlit1985 (depth = 8)
  int op_slot_right_1984 = gc_frame_newslot(strlit1985);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1988 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num1990 = alloc_Float64(2);
// compiled num node returning num1990 (depth = 11)
  int op_slot_right_1989 = gc_frame_newslot(num1990);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_1989 = gc_frame_newslot(*var_depth);
  params[0] = num1990;
  partcv[0] = 1;
  Object sum1992 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum1992 (depth = 10)
  gc_frame_newslot(sum1992);
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1993 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1994 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1993);
// compiled call node returning call1994 (depth = 11)
// compiled member node returning call1994 (depth = 10)
  params[0] = sum1992;
  partcv[0] = 1;
  Object call1995 = callmethod(call1994, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1988);
// compiled call node returning call1995 (depth = 9)
  int op_slot_right_1987 = gc_frame_newslot(call1995);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1998 == NULL) {
    strlit1998 = alloc_String("  ");
    gc_root(strlit1998);
  }
// compiled string node returning strlit1998 (depth = 10)
  int op_slot_right_1997 = gc_frame_newslot(strlit1998);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_2000 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit2003 == NULL) {
    strlit2003 = alloc_String("Finally:""\x0a""");
    gc_root(strlit2003);
  }
// compiled string node returning strlit2003 (depth = 12)
  int op_slot_right_2002 = gc_frame_newslot(strlit2003);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_spc (depth = 13)
  int op_slot_right_2005 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 13)
  if (strlit2007 == NULL) {
    strlit2007 = alloc_String("""\x0a""");
    gc_root(strlit2007);
  }
// compiled string node returning strlit2007 (depth = 13)
  int op_slot_left_2005 = gc_frame_newslot(strlit2007);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2008 = callmethod(strlit2007, "++", 1, partcv, params);
// compiled op node returning opresult2008 (depth = 12)
  int op_slot_left_2002 = gc_frame_newslot(opresult2008);
  params[0] = strlit2003;
  partcv[0] = 1;
  Object opresult2009 = callmethod(opresult2008, "++", 1, partcv, params);
// compiled op node returning opresult2009 (depth = 11)
  int op_slot_left_2000 = gc_frame_newslot(opresult2009);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2010 = callmethod(opresult2009, "++", 1, partcv, params);
// compiled op node returning opresult2010 (depth = 10)
  int op_slot_left_1997 = gc_frame_newslot(opresult2010);
  params[0] = strlit1998;
  partcv[0] = 1;
  Object opresult2011 = callmethod(opresult2010, "++", 1, partcv, params);
// compiled op node returning opresult2011 (depth = 9)
  int op_slot_left_1987 = gc_frame_newslot(opresult2011);
  params[0] = call1995;
  partcv[0] = 1;
  Object opresult2012 = callmethod(opresult2011, "++", 1, partcv, params);
// compiled op node returning opresult2012 (depth = 8)
  int op_slot_left_1984 = gc_frame_newslot(opresult2012);
  params[0] = strlit1985;
  partcv[0] = 1;
  Object opresult2013 = callmethod(opresult2012, "++", 1, partcv, params);
// compiled op node returning opresult2013 (depth = 7)
  int op_slot_right_1983 = gc_frame_newslot(opresult2013);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1983 = gc_frame_newslot(*var_s);
  params[0] = opresult2013;
  partcv[0] = 1;
  Object opresult2015 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2015 (depth = 6)
  *var_s = opresult2015;
  if (opresult2015 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if1976 = done;
  } else {
  }
// compiled if node returning if1976 (depth = 4)
// Begin line 432
  setline(432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply2029(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 437
  setline(437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2031 == NULL) {
    strlit2031 = alloc_String("    ");
    gc_root(strlit2031);
  }
// compiled string node returning strlit2031 (depth = 8)
  int op_slot_right_2030 = gc_frame_newslot(strlit2031);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_2030 = gc_frame_newslot(*var_spc);
  params[0] = strlit2031;
  partcv[0] = 1;
  Object opresult2033 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult2033 (depth = 7)
  *var_spc = opresult2033;
  if (opresult2033 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply2054(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_case = &(stackframe->slots[0]);
  *var_case = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 441
  setline(441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2056 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num2058 = alloc_Float64(2);
// compiled num node returning num2058 (depth = 10)
  int op_slot_right_2057 = gc_frame_newslot(num2058);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_2057 = gc_frame_newslot(*var_depth);
  params[0] = num2058;
  partcv[0] = 1;
  Object sum2060 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2060 (depth = 9)
  gc_frame_newslot(sum2060);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_case (depth = 9)
  params[0] = sum2060;
  partcv[0] = 1;
  Object call2061 = callmethod(*var_case, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe2056);
// compiled call node returning call2061 (depth = 8)
  int op_slot_right_2055 = gc_frame_newslot(call2061);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2064 == NULL) {
    strlit2064 = alloc_String("case ");
    gc_root(strlit2064);
  }
// compiled string node returning strlit2064 (depth = 9)
  int op_slot_right_2063 = gc_frame_newslot(strlit2064);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2067 == NULL) {
    strlit2067 = alloc_String("    ");
    gc_root(strlit2067);
  }
// compiled string node returning strlit2067 (depth = 10)
  int op_slot_right_2066 = gc_frame_newslot(strlit2067);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_2069 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit2072 == NULL) {
    strlit2072 = alloc_String("""\x0a""");
    gc_root(strlit2072);
  }
// compiled string node returning strlit2072 (depth = 12)
  int op_slot_right_2071 = gc_frame_newslot(strlit2072);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_s (depth = 12)
  int op_slot_left_2071 = gc_frame_newslot(*var_s);
  params[0] = strlit2072;
  partcv[0] = 1;
  Object opresult2074 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2074 (depth = 11)
  int op_slot_left_2069 = gc_frame_newslot(opresult2074);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2075 = callmethod(opresult2074, "++", 1, partcv, params);
// compiled op node returning opresult2075 (depth = 10)
  int op_slot_left_2066 = gc_frame_newslot(opresult2075);
  params[0] = strlit2067;
  partcv[0] = 1;
  Object opresult2076 = callmethod(opresult2075, "++", 1, partcv, params);
// compiled op node returning opresult2076 (depth = 9)
  int op_slot_left_2063 = gc_frame_newslot(opresult2076);
  params[0] = strlit2064;
  partcv[0] = 1;
  Object opresult2077 = callmethod(opresult2076, "++", 1, partcv, params);
// compiled op node returning opresult2077 (depth = 8)
  int op_slot_left_2055 = gc_frame_newslot(opresult2077);
  params[0] = call2061;
  partcv[0] = 1;
  Object opresult2078 = callmethod(opresult2077, "++", 1, partcv, params);
// compiled op node returning opresult2078 (depth = 7)
  *var_s = opresult2078;
  if (opresult2078 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace2017(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 435
  setline(435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2018 == NULL) {
    strlit2018 = alloc_String("");
    gc_root(strlit2018);
  }
// compiled string node returning strlit2018 (depth = 5)
  *var_spc = strlit2018;
  if (strlit2018 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 436
  setline(436);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2019 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2022 = alloc_Float64(1);
// compiled num node returning num2022 (depth = 7)
  int op_slot_right_2021 = gc_frame_newslot(num2022);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_2021 = gc_frame_newslot(*var_depth);
  params[0] = num2022;
  partcv[0] = 1;
  Object diff2024 = callmethod(*var_depth, "-", 1, partcv, params);
// compiled op node returning diff2024 (depth = 6)
  int op_slot_right_2020 = gc_frame_newslot(diff2024);
// starting to compile num node (depth = 6)
  Object num2026 = alloc_Float64(0);
// compiled num node returning num2026 (depth = 6)
  int op_slot_left_2020 = gc_frame_newslot(num2026);
  params[0] = diff2024;
  partcv[0] = 1;
  Object opresult2027 = callmethod(num2026, "..", 1, partcv, params);
// compiled op node returning opresult2027 (depth = 5)
  gc_frame_newslot(opresult2027);
// starting to compile block node (depth = 5)
  Object block2028 = alloc_Block(NULL, NULL, "ast", 436);
  gc_frame_newslot(block2028);
// method _apply
  block_savedest(block2028);
  Object closure2029 = createclosure(2, "_apply");
  setclosureframe(closure2029, stackframe);
  addtoclosure(closure2029, var_spc);
  addtoclosure(closure2029, selfslot);
  struct UserObject *uo2029 = (struct UserObject*)block2028;
  uo2029->data[0] = (Object)closure2029;
  Method *meth_meth_ast__apply2029 = addmethod2pos(block2028, "_apply", &meth_ast__apply2029, 0);
  int argcv_meth_ast__apply2029[] = {1};
  meth_meth_ast__apply2029->type = alloc_MethodType(1, argcv_meth_ast__apply2029);
  meth_meth_ast__apply2029->definitionModule = modulename;
  meth_meth_ast__apply2029->definitionLine = 430;
// compiled block node returning block2028 (depth = 5)
  gc_frame_newslot(block2028);
// call case 5: prelude request
  params[0] = opresult2027;
  params[1] = block2028;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2036 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2019);
// compiled call node returning call2036 (depth = 4)
// Begin line 439
  setline(439);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2038 == NULL) {
    strlit2038 = alloc_String(" ");
    gc_root(strlit2038);
  }
// compiled string node returning strlit2038 (depth = 6)
  int op_slot_right_2037 = gc_frame_newslot(strlit2038);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2041 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num2042 = alloc_Float64(0);
// compiled num node returning num2042 (depth = 8)
  gc_frame_newslot(num2042);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2043 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2044 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2043);
// compiled call node returning call2044 (depth = 9)
// compiled member node returning call2044 (depth = 8)
  params[0] = num2042;
  partcv[0] = 1;
  Object call2045 = callmethod(call2044, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe2041);
// compiled call node returning call2045 (depth = 7)
  int op_slot_right_2040 = gc_frame_newslot(call2045);
// starting to compile string node (depth = 7)
  if (strlit2047 == NULL) {
    strlit2047 = alloc_String("catch ");
    gc_root(strlit2047);
  }
// compiled string node returning strlit2047 (depth = 7)
  int op_slot_left_2040 = gc_frame_newslot(strlit2047);
  params[0] = call2045;
  partcv[0] = 1;
  Object opresult2048 = callmethod(strlit2047, "++", 1, partcv, params);
// compiled op node returning opresult2048 (depth = 6)
  int op_slot_left_2037 = gc_frame_newslot(opresult2048);
  params[0] = strlit2038;
  partcv[0] = 1;
  Object opresult2049 = callmethod(opresult2048, "++", 1, partcv, params);
// compiled op node returning opresult2049 (depth = 5)
  *var_s = opresult2049;
  if (opresult2049 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 440
  setline(440);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2050 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2051 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2052 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2051);
// compiled call node returning call2052 (depth = 6)
// compiled member node returning call2052 (depth = 5)
  gc_frame_newslot(call2052);
// starting to compile block node (depth = 5)
  Object block2053 = alloc_Block(NULL, NULL, "ast", 440);
  gc_frame_newslot(block2053);
// method _apply
  block_savedest(block2053);
  Object closure2054 = createclosure(4, "_apply");
  setclosureframe(closure2054, stackframe);
  addtoclosure(closure2054, var_depth);
  addtoclosure(closure2054, var_spc);
  addtoclosure(closure2054, var_s);
  addtoclosure(closure2054, selfslot);
  struct UserObject *uo2054 = (struct UserObject*)block2053;
  uo2054->data[0] = (Object)closure2054;
  Method *meth_meth_ast__apply2054 = addmethod2pos(block2053, "_apply", &meth_ast__apply2054, 0);
  int argcv_meth_ast__apply2054[] = {1};
  meth_meth_ast__apply2054->type = alloc_MethodType(1, argcv_meth_ast__apply2054);
  meth_meth_ast__apply2054->definitionModule = modulename;
  meth_meth_ast__apply2054->definitionLine = 440;
// compiled block node returning block2053 (depth = 5)
  gc_frame_newslot(block2053);
// call case 5: prelude request
  params[0] = call2052;
  params[1] = block2053;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2081 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2050);
// compiled call node returning call2081 (depth = 4)
// Begin line 443
  setline(443);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool2084 = alloc_Boolean(0);
// compiled identifier node returning bool2084 (depth = 6)
  int op_slot_right_2083 = gc_frame_newslot(bool2084);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2086 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2087 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2086);
// compiled call node returning call2087 (depth = 7)
// compiled member node returning call2087 (depth = 6)
  int op_slot_left_2083 = gc_frame_newslot(call2087);
  params[0] = bool2084;
  partcv[0] = 1;
  Object opresult2088 = callmethod(call2087, "!=", 1, partcv, params);
// compiled op node returning opresult2088 (depth = 5)
  Object if2082 = done;
  if (istrue(opresult2088)) {
// Begin line 444
  setline(444);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2090 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2092 = alloc_Float64(2);
// compiled num node returning num2092 (depth = 9)
  int op_slot_right_2091 = gc_frame_newslot(num2092);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_2091 = gc_frame_newslot(*var_depth);
  params[0] = num2092;
  partcv[0] = 1;
  Object sum2094 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2094 (depth = 8)
  gc_frame_newslot(sum2094);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2095 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2096 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2095);
// compiled call node returning call2096 (depth = 9)
// compiled member node returning call2096 (depth = 8)
  params[0] = sum2094;
  partcv[0] = 1;
  Object call2097 = callmethod(call2096, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe2090);
// compiled call node returning call2097 (depth = 7)
  int op_slot_right_2089 = gc_frame_newslot(call2097);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2100 == NULL) {
    strlit2100 = alloc_String("finally ");
    gc_root(strlit2100);
  }
// compiled string node returning strlit2100 (depth = 8)
  int op_slot_right_2099 = gc_frame_newslot(strlit2100);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2103 == NULL) {
    strlit2103 = alloc_String("    ");
    gc_root(strlit2103);
  }
// compiled string node returning strlit2103 (depth = 9)
  int op_slot_right_2102 = gc_frame_newslot(strlit2103);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_2105 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2108 == NULL) {
    strlit2108 = alloc_String("""\x0a""");
    gc_root(strlit2108);
  }
// compiled string node returning strlit2108 (depth = 11)
  int op_slot_right_2107 = gc_frame_newslot(strlit2108);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_2107 = gc_frame_newslot(*var_s);
  params[0] = strlit2108;
  partcv[0] = 1;
  Object opresult2110 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2110 (depth = 10)
  int op_slot_left_2105 = gc_frame_newslot(opresult2110);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2111 = callmethod(opresult2110, "++", 1, partcv, params);
// compiled op node returning opresult2111 (depth = 9)
  int op_slot_left_2102 = gc_frame_newslot(opresult2111);
  params[0] = strlit2103;
  partcv[0] = 1;
  Object opresult2112 = callmethod(opresult2111, "++", 1, partcv, params);
// compiled op node returning opresult2112 (depth = 8)
  int op_slot_left_2099 = gc_frame_newslot(opresult2112);
  params[0] = strlit2100;
  partcv[0] = 1;
  Object opresult2113 = callmethod(opresult2112, "++", 1, partcv, params);
// compiled op node returning opresult2113 (depth = 7)
  int op_slot_left_2089 = gc_frame_newslot(opresult2113);
  params[0] = call2097;
  partcv[0] = 1;
  Object opresult2114 = callmethod(opresult2113, "++", 1, partcv, params);
// compiled op node returning opresult2114 (depth = 6)
  *var_s = opresult2114;
  if (opresult2114 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if2082 = done;
  } else {
  }
// compiled if node returning if2082 (depth = 4)
// Begin line 446
  setline(446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy2116(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_catchCaseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 449
  setline(449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2117 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe2118 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nullNode (depth = 6)
  gc_frame_newslot(*var_nullNode);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_emptySeq (depth = 6)
  gc_frame_newslot(*var_emptySeq);
// starting to compile identifier node (depth = 6)
  Object bool2119 = alloc_Boolean(0);
// compiled identifier node returning bool2119 (depth = 6)
  gc_frame_newslot(bool2119);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_catchCaseNode (depth = 6)
  params[0] = *var_nullNode;
  params[1] = *var_emptySeq;
  params[2] = bool2119;
  partcv[0] = 3;
  Object call2120 = callmethod(*var_catchCaseNode, "new",
    1, partcv, params);
  gc_frame_end(callframe2118);
// compiled call node returning call2120 (depth = 5)
  params[0] = self;
  partcv[0] = 1;
  Object call2121 = callmethod(call2120, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe2117);
// compiled call node returning call2121 (depth = 4)
  gc_frame_end(frame);
  return call2121;
}
Object meth_ast_new1824(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_catchCaseNode = getfromclosure(closure, 2);
  Object *var_baseNode = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block = &(stackframe->slots[0]);
  *var_block = args[curarg];
  curarg++;
  Object *var_cases_39_ = &(stackframe->slots[1]);
  *var_cases_39_ = args[curarg];
  curarg++;
  Object *var_finally_39_ = &(stackframe->slots[2]);
  *var_finally_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1825 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1825 = alloc_userobj2(14,12, objclass1825);
  gc_frame_newslot(obj1825);
if (objclass1825 == NULL) {
  glfree(obj1825->class->name);
  obj1825->class->name = "catchCaseNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1825, self, 0);
  addmethodreal(obj1825,"outer", &reader_ast_outer_1826);
  Object oldself1825 = self;
  struct StackFrameObject *oldstackframe1825 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1825);
  gc_frame_newslot((Object)stackframe);
  self = obj1825;
  Object *oldselfslot1825 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1825 = (*(struct UserObject *)self).data[0], lowerouter1825 = thisouter1825;
  if (inheritingObject1825) {
    struct UserObject *inho1825 = (struct UserObject *)inheritingObject1825;
    while (inho1825->super != GraceDefaultObject) inho1825 = (struct UserObject *)inho1825->super;
    inho1825->super = obj1825;
    self = inheritingObject1825;
    *selfslot = self;
    lowerouter1825 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1825;
  }
if (objclass1825 == NULL) {
  Method *reader1827 = addmethodrealflags(obj1825, "kind",&reader_ast_kind_1827, MFLAG_DEF);
  reader1827->definitionModule = modulename;
  reader1827->definitionLine = 393;
}
adddatum2(obj1825, alloc_Undefined(), 1);
if (objclass1825 == NULL) {
  Method *reader1828 = addmethodrealflags(obj1825, "value",&reader_ast_value_1828, 0);
  Method *writer1828 = addmethodrealflags(obj1825, "value:=",&writer_ast_value_1828, 0);
  reader1828->definitionModule = modulename;
  writer1828->definitionModule = modulename;
  reader1828->definitionLine = 394;
  writer1828->definitionLine = 394;
}
obj1825->flags |= OFLAG_MUTABLE;
adddatum2(obj1825, alloc_Undefined(), 2);
if (objclass1825 == NULL) {
  Method *reader1829 = addmethodrealflags(obj1825, "cases",&reader_ast_cases_1829, 0);
  Method *writer1829 = addmethodrealflags(obj1825, "cases:=",&writer_ast_cases_1829, 0);
  reader1829->definitionModule = modulename;
  writer1829->definitionModule = modulename;
  reader1829->definitionLine = 395;
  writer1829->definitionLine = 395;
}
obj1825->flags |= OFLAG_MUTABLE;
adddatum2(obj1825, alloc_Undefined(), 3);
if (objclass1825 == NULL) {
  Method *reader1830 = addmethodrealflags(obj1825, "finally",&reader_ast_finally_1830, 0);
  Method *writer1830 = addmethodrealflags(obj1825, "finally:=",&writer_ast_finally_1830, 0);
  reader1830->definitionModule = modulename;
  writer1830->definitionModule = modulename;
  reader1830->definitionLine = 396;
  writer1830->definitionLine = 396;
}
obj1825->flags |= OFLAG_MUTABLE;
adddatum2(obj1825, alloc_Undefined(), 4);
// method isSimple
  struct UserObject *uo1831 = (struct UserObject*)obj1825;
  uo1831->data[5] = emptyclosure;
  Method *meth_meth_ast_isSimple1831 = addmethod2pos(obj1825, "isSimple", &meth_ast_isSimple1831, 5);
  int argcv_meth_ast_isSimple1831[] = {0};
  meth_meth_ast_isSimple1831->type = alloc_MethodType(1, argcv_meth_ast_isSimple1831);
  meth_meth_ast_isSimple1831->definitionModule = modulename;
  meth_meth_ast_isSimple1831->definitionLine = 397;
// method accept()from
  struct UserObject *uo1833 = (struct UserObject*)obj1825;
  uo1833->data[6] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from1833 = addmethod2pos(obj1825, "accept()from", &meth_ast_accept_40__41_from1833, 6);
  int argcv_meth_ast_accept_40__41_from1833[] = {1, 1};
  meth_meth_ast_accept_40__41_from1833->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from1833);
  meth_meth_ast_accept_40__41_from1833->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from1833->definitionLine = 399;
// method map()ancestors
  struct UserObject *uo1863 = (struct UserObject*)obj1825;
  uo1863->data[7] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors1863 = addmethod2pos(obj1825, "map()ancestors", &meth_ast_map_40__41_ancestors1863, 7);
  int argcv_meth_ast_map_40__41_ancestors1863[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors1863->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors1863);
  meth_meth_ast_map_40__41_ancestors1863->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors1863->definitionLine = 411;
// method pretty
  struct UserObject *uo1896 = (struct UserObject*)obj1825;
  uo1896->data[8] = emptyclosure;
  Method *meth_meth_ast_pretty1896 = addmethod2pos(obj1825, "pretty", &meth_ast_pretty1896, 8);
  int argcv_meth_ast_pretty1896[] = {1};
  meth_meth_ast_pretty1896->type = alloc_MethodType(1, argcv_meth_ast_pretty1896);
  meth_meth_ast_pretty1896->definitionModule = modulename;
  meth_meth_ast_pretty1896->definitionLine = 419;
// method toGrace
  struct UserObject *uo2017 = (struct UserObject*)obj1825;
  uo2017->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace2017 = addmethod2pos(obj1825, "toGrace", &meth_ast_toGrace2017, 9);
  int argcv_meth_ast_toGrace2017[] = {1};
  meth_meth_ast_toGrace2017->type = alloc_MethodType(1, argcv_meth_ast_toGrace2017);
meth_meth_ast_toGrace2017->type->types[0] = type_Number;
meth_meth_ast_toGrace2017->type->names[0] = "depth";
  meth_meth_ast_toGrace2017->definitionModule = modulename;
  meth_meth_ast_toGrace2017->definitionLine = 434;
// method shallowCopy
  block_savedest(obj1825);
  Object closure2116 = createclosure(3, "shallowCopy");
  setclosureframe(closure2116, stackframe);
  addtoclosure(closure2116, var_nullNode);
  addtoclosure(closure2116, var_emptySeq);
  addtoclosure(closure2116, var_catchCaseNode);
  struct UserObject *uo2116 = (struct UserObject*)obj1825;
  uo2116->data[10] = (Object)closure2116;
  Method *meth_meth_ast_shallowCopy2116 = addmethod2pos(obj1825, "shallowCopy", &meth_ast_shallowCopy2116, 10);
  int argcv_meth_ast_shallowCopy2116[] = {0};
  meth_meth_ast_shallowCopy2116->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy2116);
  meth_meth_ast_shallowCopy2116->definitionModule = modulename;
  meth_meth_ast_shallowCopy2116->definitionLine = 448;
  sourceObject = obj1825;
// Begin line 392
  setline(392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2122 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2123 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe2122);
// compiled call node returning call2123 (depth = 4)
  struct UserObject *obj1825_uo = (struct UserObject *)obj1825;
  obj1825_uo->super = call2123;
  sourceObject = obj1825;
// Begin line 393
  setline(393);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit2124 == NULL) {
    strlit2124 = alloc_String("catchcase");
    gc_root(strlit2124);
  }
// compiled string node returning strlit2124 (depth = 4)
  adddatum2(obj1825, strlit2124, 1);
  sourceObject = obj1825;
// Begin line 394
  setline(394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_block (depth = 4)
  adddatum2(obj1825, *var_block, 2);
  sourceObject = obj1825;
// Begin line 395
  setline(395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_cases_39_ (depth = 4)
  adddatum2(obj1825, *var_cases_39_, 3);
  sourceObject = obj1825;
// Begin line 396
  setline(396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_finally_39_ (depth = 4)
  adddatum2(obj1825, *var_finally_39_, 4);
  sourceObject = obj1825;
  sourceObject = obj1825;
  sourceObject = obj1825;
  sourceObject = obj1825;
  sourceObject = obj1825;
  sourceObject = obj1825;
  objclass1825 = obj1825->class;
  objclass1825->definitionModule = modulename;
  objclass1825->definitionLine = 391;
  (*(struct UserObject *)self).data[0] = lowerouter1825;
  self = oldself1825;
  selfslot = oldselfslot1825;
  stackframe = oldstackframe1825;
  gc_frame_end(frame);
  return obj1825;
}
Object meth_ast_new1824_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_catchCaseNode = getfromclosure(closure, 2);
  Object *var_baseNode = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block = &(stackframe->slots[0]);
  *var_block = args[curarg];
  curarg++;
  Object *var_cases_39_ = &(stackframe->slots[1]);
  *var_cases_39_ = args[curarg];
  curarg++;
  Object *var_finally_39_ = &(stackframe->slots[2]);
  *var_finally_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1825 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1825 = alloc_userobj2(14,12, objclass1825);
  gc_frame_newslot(obj1825);
if (objclass1825 == NULL) {
  glfree(obj1825->class->name);
  obj1825->class->name = "catchCaseNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1825, self, 0);
  addmethodreal(obj1825,"outer", &reader_ast_outer_1826);
  Object oldself1825 = self;
  struct StackFrameObject *oldstackframe1825 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1825);
  gc_frame_newslot((Object)stackframe);
  self = obj1825;
  Object *oldselfslot1825 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1825 = (*(struct UserObject *)self).data[0], lowerouter1825 = thisouter1825;
  if (inheritingObject1825) {
    struct UserObject *inho1825 = (struct UserObject *)inheritingObject1825;
    while (inho1825->super != GraceDefaultObject) inho1825 = (struct UserObject *)inho1825->super;
    inho1825->super = obj1825;
    self = inheritingObject1825;
    *selfslot = self;
    lowerouter1825 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1825;
  }
if (objclass1825 == NULL) {
  Method *reader1827 = addmethodrealflags(obj1825, "kind",&reader_ast_kind_1827, MFLAG_DEF);
  reader1827->definitionModule = modulename;
  reader1827->definitionLine = 393;
}
adddatum2(obj1825, alloc_Undefined(), 1);
if (objclass1825 == NULL) {
  Method *reader1828 = addmethodrealflags(obj1825, "value",&reader_ast_value_1828, 0);
  Method *writer1828 = addmethodrealflags(obj1825, "value:=",&writer_ast_value_1828, 0);
  reader1828->definitionModule = modulename;
  writer1828->definitionModule = modulename;
  reader1828->definitionLine = 394;
  writer1828->definitionLine = 394;
}
obj1825->flags |= OFLAG_MUTABLE;
adddatum2(obj1825, alloc_Undefined(), 2);
if (objclass1825 == NULL) {
  Method *reader1829 = addmethodrealflags(obj1825, "cases",&reader_ast_cases_1829, 0);
  Method *writer1829 = addmethodrealflags(obj1825, "cases:=",&writer_ast_cases_1829, 0);
  reader1829->definitionModule = modulename;
  writer1829->definitionModule = modulename;
  reader1829->definitionLine = 395;
  writer1829->definitionLine = 395;
}
obj1825->flags |= OFLAG_MUTABLE;
adddatum2(obj1825, alloc_Undefined(), 3);
if (objclass1825 == NULL) {
  Method *reader1830 = addmethodrealflags(obj1825, "finally",&reader_ast_finally_1830, 0);
  Method *writer1830 = addmethodrealflags(obj1825, "finally:=",&writer_ast_finally_1830, 0);
  reader1830->definitionModule = modulename;
  writer1830->definitionModule = modulename;
  reader1830->definitionLine = 396;
  writer1830->definitionLine = 396;
}
obj1825->flags |= OFLAG_MUTABLE;
adddatum2(obj1825, alloc_Undefined(), 4);
// method isSimple
  struct UserObject *uo1831 = (struct UserObject*)obj1825;
  uo1831->data[5] = emptyclosure;
  Method *meth_meth_ast_isSimple1831 = addmethod2pos(obj1825, "isSimple", &meth_ast_isSimple1831, 5);
  int argcv_meth_ast_isSimple1831[] = {0};
  meth_meth_ast_isSimple1831->type = alloc_MethodType(1, argcv_meth_ast_isSimple1831);
  meth_meth_ast_isSimple1831->definitionModule = modulename;
  meth_meth_ast_isSimple1831->definitionLine = 397;
// method accept()from
  struct UserObject *uo1833 = (struct UserObject*)obj1825;
  uo1833->data[6] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from1833 = addmethod2pos(obj1825, "accept()from", &meth_ast_accept_40__41_from1833, 6);
  int argcv_meth_ast_accept_40__41_from1833[] = {1, 1};
  meth_meth_ast_accept_40__41_from1833->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from1833);
  meth_meth_ast_accept_40__41_from1833->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from1833->definitionLine = 399;
// method map()ancestors
  struct UserObject *uo1863 = (struct UserObject*)obj1825;
  uo1863->data[7] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors1863 = addmethod2pos(obj1825, "map()ancestors", &meth_ast_map_40__41_ancestors1863, 7);
  int argcv_meth_ast_map_40__41_ancestors1863[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors1863->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors1863);
  meth_meth_ast_map_40__41_ancestors1863->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors1863->definitionLine = 411;
// method pretty
  struct UserObject *uo1896 = (struct UserObject*)obj1825;
  uo1896->data[8] = emptyclosure;
  Method *meth_meth_ast_pretty1896 = addmethod2pos(obj1825, "pretty", &meth_ast_pretty1896, 8);
  int argcv_meth_ast_pretty1896[] = {1};
  meth_meth_ast_pretty1896->type = alloc_MethodType(1, argcv_meth_ast_pretty1896);
  meth_meth_ast_pretty1896->definitionModule = modulename;
  meth_meth_ast_pretty1896->definitionLine = 419;
// method toGrace
  struct UserObject *uo2017 = (struct UserObject*)obj1825;
  uo2017->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace2017 = addmethod2pos(obj1825, "toGrace", &meth_ast_toGrace2017, 9);
  int argcv_meth_ast_toGrace2017[] = {1};
  meth_meth_ast_toGrace2017->type = alloc_MethodType(1, argcv_meth_ast_toGrace2017);
meth_meth_ast_toGrace2017->type->types[0] = type_Number;
meth_meth_ast_toGrace2017->type->names[0] = "depth";
  meth_meth_ast_toGrace2017->definitionModule = modulename;
  meth_meth_ast_toGrace2017->definitionLine = 434;
// method shallowCopy
  block_savedest(obj1825);
  Object closure2116 = createclosure(3, "shallowCopy");
  setclosureframe(closure2116, stackframe);
  addtoclosure(closure2116, var_nullNode);
  addtoclosure(closure2116, var_emptySeq);
  addtoclosure(closure2116, var_catchCaseNode);
  struct UserObject *uo2116 = (struct UserObject*)obj1825;
  uo2116->data[10] = (Object)closure2116;
  Method *meth_meth_ast_shallowCopy2116 = addmethod2pos(obj1825, "shallowCopy", &meth_ast_shallowCopy2116, 10);
  int argcv_meth_ast_shallowCopy2116[] = {0};
  meth_meth_ast_shallowCopy2116->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy2116);
  meth_meth_ast_shallowCopy2116->definitionModule = modulename;
  meth_meth_ast_shallowCopy2116->definitionLine = 448;
  sourceObject = obj1825;
// Begin line 392
  setline(392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2122 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2123 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe2122);
// compiled call node returning call2123 (depth = 4)
  struct UserObject *obj1825_uo = (struct UserObject *)obj1825;
  obj1825_uo->super = call2123;
  sourceObject = obj1825;
// Begin line 393
  setline(393);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit2124 == NULL) {
    strlit2124 = alloc_String("catchcase");
    gc_root(strlit2124);
  }
// compiled string node returning strlit2124 (depth = 4)
  adddatum2(obj1825, strlit2124, 1);
  sourceObject = obj1825;
// Begin line 394
  setline(394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_block (depth = 4)
  adddatum2(obj1825, *var_block, 2);
  sourceObject = obj1825;
// Begin line 395
  setline(395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_cases_39_ (depth = 4)
  adddatum2(obj1825, *var_cases_39_, 3);
  sourceObject = obj1825;
// Begin line 396
  setline(396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_finally_39_ (depth = 4)
  adddatum2(obj1825, *var_finally_39_, 4);
  sourceObject = obj1825;
  sourceObject = obj1825;
  sourceObject = obj1825;
  sourceObject = obj1825;
  sourceObject = obj1825;
  sourceObject = obj1825;
  objclass1825 = obj1825->class;
  objclass1825->definitionModule = modulename;
  objclass1825->definitionLine = 391;
  (*(struct UserObject *)self).data[0] = lowerouter1825;
  self = oldself1825;
  selfslot = oldselfslot1825;
  stackframe = oldstackframe1825;
  gc_frame_end(frame);
  return obj1825;
}
Object meth_ast_matchCaseNode2126(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "matchCaseNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_matchCaseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for matchCaseNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for matchCaseNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_matchCaseNode (depth = 3)
  gc_frame_end(frame);
  return *var_matchCaseNode;
}
Object meth_ast_isSimple2136(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSimple");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isSimple (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isSimple");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 458
  setline(458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool2137 = alloc_Boolean(0);
// compiled identifier node returning bool2137 (depth = 4)
  gc_frame_end(frame);
  return bool2137;
}
Object meth_ast_matchee2138(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "matchee");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for matchee (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for matchee");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 459
  setline(459);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2139 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2140 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2139);
// compiled call node returning call2140 (depth = 5)
// compiled member node returning call2140 (depth = 4)
  gc_frame_end(frame);
  return call2140;
}
Object meth_ast__apply2155(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 465
  setline(465);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2156 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_visitor (depth = 8)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_newChain (depth = 8)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mx (depth = 8)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2157 = callmethod(*var_mx, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe2156);
// compiled call node returning call2157 (depth = 7)
  gc_frame_end(frame);
  return call2157;
}
Object meth_ast_accept_40__41_from2141(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 461
  setline(461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2143 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2144 = callmethod(*var_visitor, "visitMatchCase()up",
    2, partcv, params);
  gc_frame_end(callframe2143);
// compiled call node returning call2144 (depth = 5)
  Object if2142 = done;
  if (istrue(call2144)) {
// Begin line 462
  setline(462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2145 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_as (depth = 7)
  params[0] = self;
  partcv[0] = 1;
  Object call2146 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe2145);
// compiled call node returning call2146 (depth = 6)
  *var_newChain = call2146;
  if (call2146 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 463
  setline(463);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2147 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2148 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2149 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2148);
// compiled call node returning call2149 (depth = 7)
// compiled member node returning call2149 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2150 = callmethod(call2149, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe2147);
// compiled call node returning call2150 (depth = 5)
// Begin line 464
  setline(464);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2151 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2152 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2153 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2152);
// compiled call node returning call2153 (depth = 7)
// compiled member node returning call2153 (depth = 6)
  gc_frame_newslot(call2153);
// starting to compile block node (depth = 6)
  Object block2154 = alloc_Block(NULL, NULL, "ast", 464);
  gc_frame_newslot(block2154);
// method _apply
  block_savedest(block2154);
  Object closure2155 = createclosure(3, "_apply");
  setclosureframe(closure2155, stackframe);
  addtoclosure(closure2155, var_visitor);
  addtoclosure(closure2155, var_newChain);
  addtoclosure(closure2155, selfslot);
  struct UserObject *uo2155 = (struct UserObject*)block2154;
  uo2155->data[0] = (Object)closure2155;
  Method *meth_meth_ast__apply2155 = addmethod2pos(block2154, "_apply", &meth_ast__apply2155, 0);
  int argcv_meth_ast__apply2155[] = {1};
  meth_meth_ast__apply2155->type = alloc_MethodType(1, argcv_meth_ast__apply2155);
  meth_meth_ast__apply2155->definitionModule = modulename;
  meth_meth_ast__apply2155->definitionLine = 464;
// compiled block node returning block2154 (depth = 6)
  gc_frame_newslot(block2154);
// call case 5: prelude request
  params[0] = call2153;
  params[1] = block2154;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2159 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2151);
// compiled call node returning call2159 (depth = 5)
// Begin line 467
  setline(467);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool2162 = alloc_Boolean(0);
// compiled identifier node returning bool2162 (depth = 7)
  int op_slot_right_2161 = gc_frame_newslot(bool2162);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2164 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2165 = callmethodflags(self, "elsecase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2164);
// compiled call node returning call2165 (depth = 8)
// compiled member node returning call2165 (depth = 7)
  int op_slot_left_2161 = gc_frame_newslot(call2165);
  params[0] = bool2162;
  partcv[0] = 1;
  Object opresult2166 = callmethod(call2165, "!=", 1, partcv, params);
// compiled op node returning opresult2166 (depth = 6)
  Object if2160 = done;
  if (istrue(opresult2166)) {
// Begin line 468
  setline(468);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2167 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2168 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2169 = callmethodflags(self, "elsecase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2168);
// compiled call node returning call2169 (depth = 8)
// compiled member node returning call2169 (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2170 = callmethod(call2169, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe2167);
// compiled call node returning call2170 (depth = 6)
    gc_frame_newslot(call2170);
    if2160 = call2170;
  } else {
  }
// compiled if node returning if2160 (depth = 5)
    gc_frame_newslot(if2160);
    if2142 = if2160;
  } else {
  }
// compiled if node returning if2142 (depth = 4)
  gc_frame_end(frame);
  return if2142;
}
Object meth_ast_map_40__41_ancestors2171(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 473
  setline(473);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2172 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2173 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2172);
// compiled call node returning call2173 (depth = 6)
// compiled member node returning call2173 (depth = 5)
  *var_n = call2173;
  if (call2173 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 474
  setline(474);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2174 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call2175 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe2174);
// compiled call node returning call2175 (depth = 5)
  *var_newChain = call2175;
  if (call2175 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 475
  setline(475);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 473
  setline(473);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2176 = gc_frame_new();
// Begin line 475
  setline(475);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2177 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2178 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2179 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2178);
// compiled call node returning call2179 (depth = 8)
// compiled member node returning call2179 (depth = 7)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2180 = callmethod(call2179, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe2177);
// compiled call node returning call2180 (depth = 6)
  gc_frame_newslot(call2180);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call2180;
  partcv[0] = 1;
  Object call2181 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe2176);
// compiled call node returning call2181 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 476
  setline(476);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 475
  setline(475);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2182 = gc_frame_new();
// Begin line 476
  setline(476);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2183 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2184 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2185 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2184);
// compiled call node returning call2185 (depth = 8)
// compiled member node returning call2185 (depth = 7)
  gc_frame_newslot(call2185);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2186 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2187 = gc_frame_new();
// call case 3: self.outer request
  Object call2188 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2187);
// compiled call node returning call2188 (depth = 10)
// compiled member node returning call2188 (depth = 9)
  partcv[0] = 0;
  Object call2189 = callmethodflags(call2188, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2186);
// compiled call node returning call2189 (depth = 8)
// compiled member node returning call2189 (depth = 7)
  params[0] = call2185;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2190 = callmethodflags(call2189, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2183);
// compiled call node returning call2190 (depth = 6)
  gc_frame_newslot(call2190);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call2190;
  partcv[0] = 1;
  Object call2191 = callmethod(*var_n, "cases:=",
    1, partcv, params);
  gc_frame_end(callframe2182);
// compiled call node returning call2191 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 477
  setline(477);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 476
  setline(476);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2192 = gc_frame_new();
// Begin line 477
  setline(477);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2193 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2194 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2195 = callmethodflags(self, "elsecase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2194);
// compiled call node returning call2195 (depth = 8)
// compiled member node returning call2195 (depth = 7)
  gc_frame_newslot(call2195);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2196 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2197 = gc_frame_new();
// call case 3: self.outer request
  Object call2198 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2197);
// compiled call node returning call2198 (depth = 10)
// compiled member node returning call2198 (depth = 9)
  partcv[0] = 0;
  Object call2199 = callmethodflags(call2198, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2196);
// compiled call node returning call2199 (depth = 8)
// compiled member node returning call2199 (depth = 7)
  params[0] = call2195;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2200 = callmethodflags(call2199, "maybeMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2193);
// compiled call node returning call2200 (depth = 6)
  gc_frame_newslot(call2200);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call2200;
  partcv[0] = 1;
  Object call2201 = callmethod(*var_n, "elsecase:=",
    1, partcv, params);
  gc_frame_end(callframe2192);
// compiled call node returning call2201 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 478
  setline(478);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2202 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call2203 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe2202);
// compiled call node returning call2203 (depth = 4)
  gc_frame_end(frame);
  return call2203;
}
Object meth_ast__apply2212(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 483
  setline(483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2214 == NULL) {
    strlit2214 = alloc_String("  ");
    gc_root(strlit2214);
  }
// compiled string node returning strlit2214 (depth = 8)
  int op_slot_right_2213 = gc_frame_newslot(strlit2214);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_2213 = gc_frame_newslot(*var_spc);
  params[0] = strlit2214;
  partcv[0] = 1;
  Object opresult2216 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult2216 (depth = 7)
  *var_spc = opresult2216;
  if (opresult2216 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply2245(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 488
  setline(488);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2248 == NULL) {
    strlit2248 = alloc_String("");
    gc_root(strlit2248);
  }
// compiled string node returning strlit2248 (depth = 9)
  int op_slot_right_2247 = gc_frame_newslot(strlit2248);
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2251 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num2253 = alloc_Float64(2);
// compiled num node returning num2253 (depth = 12)
  int op_slot_right_2252 = gc_frame_newslot(num2253);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_depth (depth = 12)
  int op_slot_left_2252 = gc_frame_newslot(*var_depth);
  params[0] = num2253;
  partcv[0] = 1;
  Object sum2255 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2255 (depth = 11)
  gc_frame_newslot(sum2255);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_mx (depth = 11)
  params[0] = sum2255;
  partcv[0] = 1;
  Object call2256 = callmethod(*var_mx, "pretty",
    1, partcv, params);
  gc_frame_end(callframe2251);
// compiled call node returning call2256 (depth = 10)
  int op_slot_right_2250 = gc_frame_newslot(call2256);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2259 == NULL) {
    strlit2259 = alloc_String("  ");
    gc_root(strlit2259);
  }
// compiled string node returning strlit2259 (depth = 11)
  int op_slot_right_2258 = gc_frame_newslot(strlit2259);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_spc (depth = 12)
  int op_slot_right_2261 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit2264 == NULL) {
    strlit2264 = alloc_String("Case:""\x0a""");
    gc_root(strlit2264);
  }
// compiled string node returning strlit2264 (depth = 13)
  int op_slot_right_2263 = gc_frame_newslot(strlit2264);
// starting to compile op node (depth = 13)
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_spc (depth = 14)
  int op_slot_right_2266 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 14)
  if (strlit2268 == NULL) {
    strlit2268 = alloc_String("""\x0a""");
    gc_root(strlit2268);
  }
// compiled string node returning strlit2268 (depth = 14)
  int op_slot_left_2266 = gc_frame_newslot(strlit2268);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2269 = callmethod(strlit2268, "++", 1, partcv, params);
// compiled op node returning opresult2269 (depth = 13)
  int op_slot_left_2263 = gc_frame_newslot(opresult2269);
  params[0] = strlit2264;
  partcv[0] = 1;
  Object opresult2270 = callmethod(opresult2269, "++", 1, partcv, params);
// compiled op node returning opresult2270 (depth = 12)
  int op_slot_left_2261 = gc_frame_newslot(opresult2270);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2271 = callmethod(opresult2270, "++", 1, partcv, params);
// compiled op node returning opresult2271 (depth = 11)
  int op_slot_left_2258 = gc_frame_newslot(opresult2271);
  params[0] = strlit2259;
  partcv[0] = 1;
  Object opresult2272 = callmethod(opresult2271, "++", 1, partcv, params);
// compiled op node returning opresult2272 (depth = 10)
  int op_slot_left_2250 = gc_frame_newslot(opresult2272);
  params[0] = call2256;
  partcv[0] = 1;
  Object opresult2273 = callmethod(opresult2272, "++", 1, partcv, params);
// compiled op node returning opresult2273 (depth = 9)
  int op_slot_left_2247 = gc_frame_newslot(opresult2273);
  params[0] = strlit2248;
  partcv[0] = 1;
  Object opresult2274 = callmethod(opresult2273, "++", 1, partcv, params);
// compiled op node returning opresult2274 (depth = 8)
  int op_slot_right_2246 = gc_frame_newslot(opresult2274);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_2246 = gc_frame_newslot(*var_s);
  params[0] = opresult2274;
  partcv[0] = 1;
  Object opresult2276 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2276 (depth = 7)
  *var_s = opresult2276;
  if (opresult2276 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty2204(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 481
  setline(481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2205 == NULL) {
    strlit2205 = alloc_String("");
    gc_root(strlit2205);
  }
// compiled string node returning strlit2205 (depth = 5)
  *var_spc = strlit2205;
  if (strlit2205 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 482
  setline(482);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2206 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_right_2207 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 6)
  Object num2209 = alloc_Float64(0);
// compiled num node returning num2209 (depth = 6)
  int op_slot_left_2207 = gc_frame_newslot(num2209);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult2210 = callmethod(num2209, "..", 1, partcv, params);
// compiled op node returning opresult2210 (depth = 5)
  gc_frame_newslot(opresult2210);
// starting to compile block node (depth = 5)
  Object block2211 = alloc_Block(NULL, NULL, "ast", 482);
  gc_frame_newslot(block2211);
// method _apply
  block_savedest(block2211);
  Object closure2212 = createclosure(2, "_apply");
  setclosureframe(closure2212, stackframe);
  addtoclosure(closure2212, var_spc);
  addtoclosure(closure2212, selfslot);
  struct UserObject *uo2212 = (struct UserObject*)block2211;
  uo2212->data[0] = (Object)closure2212;
  Method *meth_meth_ast__apply2212 = addmethod2pos(block2211, "_apply", &meth_ast__apply2212, 0);
  int argcv_meth_ast__apply2212[] = {1};
  meth_meth_ast__apply2212->type = alloc_MethodType(1, argcv_meth_ast__apply2212);
  meth_meth_ast__apply2212->definitionModule = modulename;
  meth_meth_ast__apply2212->definitionLine = 477;
// compiled block node returning block2211 (depth = 5)
  gc_frame_newslot(block2211);
// call case 5: prelude request
  params[0] = opresult2210;
  params[1] = block2211;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2219 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2206);
// compiled call node returning call2219 (depth = 4)
// Begin line 485
  setline(485);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2221 == NULL) {
    strlit2221 = alloc_String("""\x0a""");
    gc_root(strlit2221);
  }
// compiled string node returning strlit2221 (depth = 6)
  int op_slot_right_2220 = gc_frame_newslot(strlit2221);
// starting to compile call node (depth = 6)
  int callframe2223 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call2224 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe2223);
// compiled call node returning call2224 (depth = 6)
  int op_slot_left_2220 = gc_frame_newslot(call2224);
  params[0] = strlit2221;
  partcv[0] = 1;
  Object opresult2225 = callmethod(call2224, "++", 1, partcv, params);
// compiled op node returning opresult2225 (depth = 5)
  *var_s = opresult2225;
  if (opresult2225 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 486
  setline(486);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2227 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2229 = alloc_Float64(2);
// compiled num node returning num2229 (depth = 8)
  int op_slot_right_2228 = gc_frame_newslot(num2229);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_2228 = gc_frame_newslot(*var_depth);
  params[0] = num2229;
  partcv[0] = 1;
  Object sum2231 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2231 (depth = 7)
  gc_frame_newslot(sum2231);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2232 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2233 = callmethodflags(self, "matchee", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2232);
// compiled call node returning call2233 (depth = 8)
// compiled member node returning call2233 (depth = 7)
  params[0] = sum2231;
  partcv[0] = 1;
  Object call2234 = callmethod(call2233, "pretty",
    1, partcv, params);
  gc_frame_end(callframe2227);
// compiled call node returning call2234 (depth = 6)
  int op_slot_right_2226 = gc_frame_newslot(call2234);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_2236 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_2236 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2238 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2238 (depth = 6)
  int op_slot_left_2226 = gc_frame_newslot(opresult2238);
  params[0] = call2234;
  partcv[0] = 1;
  Object opresult2239 = callmethod(opresult2238, "++", 1, partcv, params);
// compiled op node returning opresult2239 (depth = 5)
  *var_s = opresult2239;
  if (opresult2239 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 487
  setline(487);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2241 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2242 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2243 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2242);
// compiled call node returning call2243 (depth = 6)
// compiled member node returning call2243 (depth = 5)
  gc_frame_newslot(call2243);
// starting to compile block node (depth = 5)
  Object block2244 = alloc_Block(NULL, NULL, "ast", 487);
  gc_frame_newslot(block2244);
// method _apply
  block_savedest(block2244);
  Object closure2245 = createclosure(4, "_apply");
  setclosureframe(closure2245, stackframe);
  addtoclosure(closure2245, var_depth);
  addtoclosure(closure2245, var_spc);
  addtoclosure(closure2245, var_s);
  addtoclosure(closure2245, selfslot);
  struct UserObject *uo2245 = (struct UserObject*)block2244;
  uo2245->data[0] = (Object)closure2245;
  Method *meth_meth_ast__apply2245 = addmethod2pos(block2244, "_apply", &meth_ast__apply2245, 0);
  int argcv_meth_ast__apply2245[] = {1};
  meth_meth_ast__apply2245->type = alloc_MethodType(1, argcv_meth_ast__apply2245);
  meth_meth_ast__apply2245->definitionModule = modulename;
  meth_meth_ast__apply2245->definitionLine = 487;
// compiled block node returning block2244 (depth = 5)
  gc_frame_newslot(block2244);
// call case 5: prelude request
  params[0] = call2243;
  params[1] = block2244;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2279 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2241);
// compiled call node returning call2279 (depth = 4)
// Begin line 490
  setline(490);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2282 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2283 = callmethodflags(self, "elsecase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2282);
// compiled call node returning call2283 (depth = 7)
// compiled member node returning call2283 (depth = 6)
  int op_slot_right_2281 = gc_frame_newslot(call2283);
// starting to compile identifier node (depth = 6)
  Object bool2285 = alloc_Boolean(0);
// compiled identifier node returning bool2285 (depth = 6)
  int op_slot_left_2281 = gc_frame_newslot(bool2285);
  params[0] = call2283;
  partcv[0] = 1;
  Object opresult2286 = callmethod(bool2285, "!=", 1, partcv, params);
// compiled op node returning opresult2286 (depth = 5)
  Object if2280 = done;
  if (istrue(opresult2286)) {
// Begin line 491
  setline(491);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2289 == NULL) {
    strlit2289 = alloc_String("");
    gc_root(strlit2289);
  }
// compiled string node returning strlit2289 (depth = 8)
  int op_slot_right_2288 = gc_frame_newslot(strlit2289);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2292 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num2294 = alloc_Float64(2);
// compiled num node returning num2294 (depth = 11)
  int op_slot_right_2293 = gc_frame_newslot(num2294);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_2293 = gc_frame_newslot(*var_depth);
  params[0] = num2294;
  partcv[0] = 1;
  Object sum2296 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2296 (depth = 10)
  gc_frame_newslot(sum2296);
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2297 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2298 = callmethodflags(self, "elsecase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2297);
// compiled call node returning call2298 (depth = 11)
// compiled member node returning call2298 (depth = 10)
  params[0] = sum2296;
  partcv[0] = 1;
  Object call2299 = callmethod(call2298, "pretty",
    1, partcv, params);
  gc_frame_end(callframe2292);
// compiled call node returning call2299 (depth = 9)
  int op_slot_right_2291 = gc_frame_newslot(call2299);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2302 == NULL) {
    strlit2302 = alloc_String("  ");
    gc_root(strlit2302);
  }
// compiled string node returning strlit2302 (depth = 10)
  int op_slot_right_2301 = gc_frame_newslot(strlit2302);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_2304 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit2307 == NULL) {
    strlit2307 = alloc_String("Else:""\x0a""");
    gc_root(strlit2307);
  }
// compiled string node returning strlit2307 (depth = 12)
  int op_slot_right_2306 = gc_frame_newslot(strlit2307);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_spc (depth = 13)
  int op_slot_right_2309 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 13)
  if (strlit2311 == NULL) {
    strlit2311 = alloc_String("""\x0a""");
    gc_root(strlit2311);
  }
// compiled string node returning strlit2311 (depth = 13)
  int op_slot_left_2309 = gc_frame_newslot(strlit2311);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2312 = callmethod(strlit2311, "++", 1, partcv, params);
// compiled op node returning opresult2312 (depth = 12)
  int op_slot_left_2306 = gc_frame_newslot(opresult2312);
  params[0] = strlit2307;
  partcv[0] = 1;
  Object opresult2313 = callmethod(opresult2312, "++", 1, partcv, params);
// compiled op node returning opresult2313 (depth = 11)
  int op_slot_left_2304 = gc_frame_newslot(opresult2313);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2314 = callmethod(opresult2313, "++", 1, partcv, params);
// compiled op node returning opresult2314 (depth = 10)
  int op_slot_left_2301 = gc_frame_newslot(opresult2314);
  params[0] = strlit2302;
  partcv[0] = 1;
  Object opresult2315 = callmethod(opresult2314, "++", 1, partcv, params);
// compiled op node returning opresult2315 (depth = 9)
  int op_slot_left_2291 = gc_frame_newslot(opresult2315);
  params[0] = call2299;
  partcv[0] = 1;
  Object opresult2316 = callmethod(opresult2315, "++", 1, partcv, params);
// compiled op node returning opresult2316 (depth = 8)
  int op_slot_left_2288 = gc_frame_newslot(opresult2316);
  params[0] = strlit2289;
  partcv[0] = 1;
  Object opresult2317 = callmethod(opresult2316, "++", 1, partcv, params);
// compiled op node returning opresult2317 (depth = 7)
  int op_slot_right_2287 = gc_frame_newslot(opresult2317);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_2287 = gc_frame_newslot(*var_s);
  params[0] = opresult2317;
  partcv[0] = 1;
  Object opresult2319 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2319 (depth = 6)
  *var_s = opresult2319;
  if (opresult2319 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if2280 = done;
  } else {
  }
// compiled if node returning if2280 (depth = 4)
// Begin line 493
  setline(493);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply2333(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 498
  setline(498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2335 == NULL) {
    strlit2335 = alloc_String("    ");
    gc_root(strlit2335);
  }
// compiled string node returning strlit2335 (depth = 8)
  int op_slot_right_2334 = gc_frame_newslot(strlit2335);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_2334 = gc_frame_newslot(*var_spc);
  params[0] = strlit2335;
  partcv[0] = 1;
  Object opresult2337 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult2337 (depth = 7)
  *var_spc = opresult2337;
  if (opresult2337 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply2358(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_case = &(stackframe->slots[0]);
  *var_case = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 502
  setline(502);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2360 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num2362 = alloc_Float64(2);
// compiled num node returning num2362 (depth = 10)
  int op_slot_right_2361 = gc_frame_newslot(num2362);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_2361 = gc_frame_newslot(*var_depth);
  params[0] = num2362;
  partcv[0] = 1;
  Object sum2364 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2364 (depth = 9)
  gc_frame_newslot(sum2364);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_case (depth = 9)
  params[0] = sum2364;
  partcv[0] = 1;
  Object call2365 = callmethod(*var_case, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe2360);
// compiled call node returning call2365 (depth = 8)
  int op_slot_right_2359 = gc_frame_newslot(call2365);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2368 == NULL) {
    strlit2368 = alloc_String("case ");
    gc_root(strlit2368);
  }
// compiled string node returning strlit2368 (depth = 9)
  int op_slot_right_2367 = gc_frame_newslot(strlit2368);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2371 == NULL) {
    strlit2371 = alloc_String("    ");
    gc_root(strlit2371);
  }
// compiled string node returning strlit2371 (depth = 10)
  int op_slot_right_2370 = gc_frame_newslot(strlit2371);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_2373 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit2376 == NULL) {
    strlit2376 = alloc_String("""\x0a""");
    gc_root(strlit2376);
  }
// compiled string node returning strlit2376 (depth = 12)
  int op_slot_right_2375 = gc_frame_newslot(strlit2376);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_s (depth = 12)
  int op_slot_left_2375 = gc_frame_newslot(*var_s);
  params[0] = strlit2376;
  partcv[0] = 1;
  Object opresult2378 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2378 (depth = 11)
  int op_slot_left_2373 = gc_frame_newslot(opresult2378);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2379 = callmethod(opresult2378, "++", 1, partcv, params);
// compiled op node returning opresult2379 (depth = 10)
  int op_slot_left_2370 = gc_frame_newslot(opresult2379);
  params[0] = strlit2371;
  partcv[0] = 1;
  Object opresult2380 = callmethod(opresult2379, "++", 1, partcv, params);
// compiled op node returning opresult2380 (depth = 9)
  int op_slot_left_2367 = gc_frame_newslot(opresult2380);
  params[0] = strlit2368;
  partcv[0] = 1;
  Object opresult2381 = callmethod(opresult2380, "++", 1, partcv, params);
// compiled op node returning opresult2381 (depth = 8)
  int op_slot_left_2359 = gc_frame_newslot(opresult2381);
  params[0] = call2365;
  partcv[0] = 1;
  Object opresult2382 = callmethod(opresult2381, "++", 1, partcv, params);
// compiled op node returning opresult2382 (depth = 7)
  *var_s = opresult2382;
  if (opresult2382 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace2321(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 496
  setline(496);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2322 == NULL) {
    strlit2322 = alloc_String("");
    gc_root(strlit2322);
  }
// compiled string node returning strlit2322 (depth = 5)
  *var_spc = strlit2322;
  if (strlit2322 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 497
  setline(497);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2323 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2326 = alloc_Float64(1);
// compiled num node returning num2326 (depth = 7)
  int op_slot_right_2325 = gc_frame_newslot(num2326);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_2325 = gc_frame_newslot(*var_depth);
  params[0] = num2326;
  partcv[0] = 1;
  Object diff2328 = callmethod(*var_depth, "-", 1, partcv, params);
// compiled op node returning diff2328 (depth = 6)
  int op_slot_right_2324 = gc_frame_newslot(diff2328);
// starting to compile num node (depth = 6)
  Object num2330 = alloc_Float64(0);
// compiled num node returning num2330 (depth = 6)
  int op_slot_left_2324 = gc_frame_newslot(num2330);
  params[0] = diff2328;
  partcv[0] = 1;
  Object opresult2331 = callmethod(num2330, "..", 1, partcv, params);
// compiled op node returning opresult2331 (depth = 5)
  gc_frame_newslot(opresult2331);
// starting to compile block node (depth = 5)
  Object block2332 = alloc_Block(NULL, NULL, "ast", 497);
  gc_frame_newslot(block2332);
// method _apply
  block_savedest(block2332);
  Object closure2333 = createclosure(2, "_apply");
  setclosureframe(closure2333, stackframe);
  addtoclosure(closure2333, var_spc);
  addtoclosure(closure2333, selfslot);
  struct UserObject *uo2333 = (struct UserObject*)block2332;
  uo2333->data[0] = (Object)closure2333;
  Method *meth_meth_ast__apply2333 = addmethod2pos(block2332, "_apply", &meth_ast__apply2333, 0);
  int argcv_meth_ast__apply2333[] = {1};
  meth_meth_ast__apply2333->type = alloc_MethodType(1, argcv_meth_ast__apply2333);
  meth_meth_ast__apply2333->definitionModule = modulename;
  meth_meth_ast__apply2333->definitionLine = 491;
// compiled block node returning block2332 (depth = 5)
  gc_frame_newslot(block2332);
// call case 5: prelude request
  params[0] = opresult2331;
  params[1] = block2332;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2340 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2323);
// compiled call node returning call2340 (depth = 4)
// Begin line 500
  setline(500);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2342 == NULL) {
    strlit2342 = alloc_String(")");
    gc_root(strlit2342);
  }
// compiled string node returning strlit2342 (depth = 6)
  int op_slot_right_2341 = gc_frame_newslot(strlit2342);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2345 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num2346 = alloc_Float64(0);
// compiled num node returning num2346 (depth = 8)
  gc_frame_newslot(num2346);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2347 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2348 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2347);
// compiled call node returning call2348 (depth = 9)
// compiled member node returning call2348 (depth = 8)
  params[0] = num2346;
  partcv[0] = 1;
  Object call2349 = callmethod(call2348, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe2345);
// compiled call node returning call2349 (depth = 7)
  int op_slot_right_2344 = gc_frame_newslot(call2349);
// starting to compile string node (depth = 7)
  if (strlit2351 == NULL) {
    strlit2351 = alloc_String("match(");
    gc_root(strlit2351);
  }
// compiled string node returning strlit2351 (depth = 7)
  int op_slot_left_2344 = gc_frame_newslot(strlit2351);
  params[0] = call2349;
  partcv[0] = 1;
  Object opresult2352 = callmethod(strlit2351, "++", 1, partcv, params);
// compiled op node returning opresult2352 (depth = 6)
  int op_slot_left_2341 = gc_frame_newslot(opresult2352);
  params[0] = strlit2342;
  partcv[0] = 1;
  Object opresult2353 = callmethod(opresult2352, "++", 1, partcv, params);
// compiled op node returning opresult2353 (depth = 5)
  *var_s = opresult2353;
  if (opresult2353 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 501
  setline(501);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2354 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2355 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2356 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2355);
// compiled call node returning call2356 (depth = 6)
// compiled member node returning call2356 (depth = 5)
  gc_frame_newslot(call2356);
// starting to compile block node (depth = 5)
  Object block2357 = alloc_Block(NULL, NULL, "ast", 501);
  gc_frame_newslot(block2357);
// method _apply
  block_savedest(block2357);
  Object closure2358 = createclosure(4, "_apply");
  setclosureframe(closure2358, stackframe);
  addtoclosure(closure2358, var_depth);
  addtoclosure(closure2358, var_spc);
  addtoclosure(closure2358, var_s);
  addtoclosure(closure2358, selfslot);
  struct UserObject *uo2358 = (struct UserObject*)block2357;
  uo2358->data[0] = (Object)closure2358;
  Method *meth_meth_ast__apply2358 = addmethod2pos(block2357, "_apply", &meth_ast__apply2358, 0);
  int argcv_meth_ast__apply2358[] = {1};
  meth_meth_ast__apply2358->type = alloc_MethodType(1, argcv_meth_ast__apply2358);
  meth_meth_ast__apply2358->definitionModule = modulename;
  meth_meth_ast__apply2358->definitionLine = 501;
// compiled block node returning block2357 (depth = 5)
  gc_frame_newslot(block2357);
// call case 5: prelude request
  params[0] = call2356;
  params[1] = block2357;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2385 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2354);
// compiled call node returning call2385 (depth = 4)
// Begin line 504
  setline(504);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool2388 = alloc_Boolean(0);
// compiled identifier node returning bool2388 (depth = 6)
  int op_slot_right_2387 = gc_frame_newslot(bool2388);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2390 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2391 = callmethodflags(self, "elsecase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2390);
// compiled call node returning call2391 (depth = 7)
// compiled member node returning call2391 (depth = 6)
  int op_slot_left_2387 = gc_frame_newslot(call2391);
  params[0] = bool2388;
  partcv[0] = 1;
  Object opresult2392 = callmethod(call2391, "!=", 1, partcv, params);
// compiled op node returning opresult2392 (depth = 5)
  Object if2386 = done;
  if (istrue(opresult2392)) {
// Begin line 505
  setline(505);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2394 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2396 = alloc_Float64(2);
// compiled num node returning num2396 (depth = 9)
  int op_slot_right_2395 = gc_frame_newslot(num2396);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_2395 = gc_frame_newslot(*var_depth);
  params[0] = num2396;
  partcv[0] = 1;
  Object sum2398 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2398 (depth = 8)
  gc_frame_newslot(sum2398);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2399 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2400 = callmethodflags(self, "elsecase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2399);
// compiled call node returning call2400 (depth = 9)
// compiled member node returning call2400 (depth = 8)
  params[0] = sum2398;
  partcv[0] = 1;
  Object call2401 = callmethod(call2400, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe2394);
// compiled call node returning call2401 (depth = 7)
  int op_slot_right_2393 = gc_frame_newslot(call2401);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2404 == NULL) {
    strlit2404 = alloc_String("else ");
    gc_root(strlit2404);
  }
// compiled string node returning strlit2404 (depth = 8)
  int op_slot_right_2403 = gc_frame_newslot(strlit2404);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2407 == NULL) {
    strlit2407 = alloc_String("    ");
    gc_root(strlit2407);
  }
// compiled string node returning strlit2407 (depth = 9)
  int op_slot_right_2406 = gc_frame_newslot(strlit2407);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_2409 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2412 == NULL) {
    strlit2412 = alloc_String("""\x0a""");
    gc_root(strlit2412);
  }
// compiled string node returning strlit2412 (depth = 11)
  int op_slot_right_2411 = gc_frame_newslot(strlit2412);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_2411 = gc_frame_newslot(*var_s);
  params[0] = strlit2412;
  partcv[0] = 1;
  Object opresult2414 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2414 (depth = 10)
  int op_slot_left_2409 = gc_frame_newslot(opresult2414);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2415 = callmethod(opresult2414, "++", 1, partcv, params);
// compiled op node returning opresult2415 (depth = 9)
  int op_slot_left_2406 = gc_frame_newslot(opresult2415);
  params[0] = strlit2407;
  partcv[0] = 1;
  Object opresult2416 = callmethod(opresult2415, "++", 1, partcv, params);
// compiled op node returning opresult2416 (depth = 8)
  int op_slot_left_2403 = gc_frame_newslot(opresult2416);
  params[0] = strlit2404;
  partcv[0] = 1;
  Object opresult2417 = callmethod(opresult2416, "++", 1, partcv, params);
// compiled op node returning opresult2417 (depth = 7)
  int op_slot_left_2393 = gc_frame_newslot(opresult2417);
  params[0] = call2401;
  partcv[0] = 1;
  Object opresult2418 = callmethod(opresult2417, "++", 1, partcv, params);
// compiled op node returning opresult2418 (depth = 6)
  *var_s = opresult2418;
  if (opresult2418 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if2386 = done;
  } else {
  }
// compiled if node returning if2386 (depth = 4)
// Begin line 507
  setline(507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy2420(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_matchCaseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 510
  setline(510);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2421 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe2422 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nullNode (depth = 6)
  gc_frame_newslot(*var_nullNode);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_emptySeq (depth = 6)
  gc_frame_newslot(*var_emptySeq);
// starting to compile identifier node (depth = 6)
  Object bool2423 = alloc_Boolean(0);
// compiled identifier node returning bool2423 (depth = 6)
  gc_frame_newslot(bool2423);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_matchCaseNode (depth = 6)
  params[0] = *var_nullNode;
  params[1] = *var_emptySeq;
  params[2] = bool2423;
  partcv[0] = 3;
  Object call2424 = callmethod(*var_matchCaseNode, "new",
    1, partcv, params);
  gc_frame_end(callframe2422);
// compiled call node returning call2424 (depth = 5)
  params[0] = self;
  partcv[0] = 1;
  Object call2425 = callmethod(call2424, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe2421);
// compiled call node returning call2425 (depth = 4)
  gc_frame_end(frame);
  return call2425;
}
Object meth_ast_new2129(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_matchCaseNode = getfromclosure(closure, 2);
  Object *var_baseNode = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_matchee_39_ = &(stackframe->slots[0]);
  *var_matchee_39_ = args[curarg];
  curarg++;
  Object *var_cases_39_ = &(stackframe->slots[1]);
  *var_cases_39_ = args[curarg];
  curarg++;
  Object *var_elsecase_39_ = &(stackframe->slots[2]);
  *var_elsecase_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2130 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2130 = alloc_userobj2(15,13, objclass2130);
  gc_frame_newslot(obj2130);
if (objclass2130 == NULL) {
  glfree(obj2130->class->name);
  obj2130->class->name = "matchCaseNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2130, self, 0);
  addmethodreal(obj2130,"outer", &reader_ast_outer_2131);
  Object oldself2130 = self;
  struct StackFrameObject *oldstackframe2130 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2130);
  gc_frame_newslot((Object)stackframe);
  self = obj2130;
  Object *oldselfslot2130 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2130 = (*(struct UserObject *)self).data[0], lowerouter2130 = thisouter2130;
  if (inheritingObject2130) {
    struct UserObject *inho2130 = (struct UserObject *)inheritingObject2130;
    while (inho2130->super != GraceDefaultObject) inho2130 = (struct UserObject *)inho2130->super;
    inho2130->super = obj2130;
    self = inheritingObject2130;
    *selfslot = self;
    lowerouter2130 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2130;
  }
if (objclass2130 == NULL) {
  Method *reader2132 = addmethodrealflags(obj2130, "kind",&reader_ast_kind_2132, MFLAG_DEF);
  reader2132->definitionModule = modulename;
  reader2132->definitionLine = 454;
}
adddatum2(obj2130, alloc_Undefined(), 1);
if (objclass2130 == NULL) {
  Method *reader2133 = addmethodrealflags(obj2130, "value",&reader_ast_value_2133, 0);
  Method *writer2133 = addmethodrealflags(obj2130, "value:=",&writer_ast_value_2133, 0);
  reader2133->definitionModule = modulename;
  writer2133->definitionModule = modulename;
  reader2133->definitionLine = 455;
  writer2133->definitionLine = 455;
}
obj2130->flags |= OFLAG_MUTABLE;
adddatum2(obj2130, alloc_Undefined(), 2);
if (objclass2130 == NULL) {
  Method *reader2134 = addmethodrealflags(obj2130, "cases",&reader_ast_cases_2134, 0);
  Method *writer2134 = addmethodrealflags(obj2130, "cases:=",&writer_ast_cases_2134, 0);
  reader2134->definitionModule = modulename;
  writer2134->definitionModule = modulename;
  reader2134->definitionLine = 456;
  writer2134->definitionLine = 456;
}
obj2130->flags |= OFLAG_MUTABLE;
adddatum2(obj2130, alloc_Undefined(), 3);
if (objclass2130 == NULL) {
  Method *reader2135 = addmethodrealflags(obj2130, "elsecase",&reader_ast_elsecase_2135, 0);
  Method *writer2135 = addmethodrealflags(obj2130, "elsecase:=",&writer_ast_elsecase_2135, 0);
  reader2135->definitionModule = modulename;
  writer2135->definitionModule = modulename;
  reader2135->definitionLine = 457;
  writer2135->definitionLine = 457;
}
obj2130->flags |= OFLAG_MUTABLE;
adddatum2(obj2130, alloc_Undefined(), 4);
// method isSimple
  struct UserObject *uo2136 = (struct UserObject*)obj2130;
  uo2136->data[5] = emptyclosure;
  Method *meth_meth_ast_isSimple2136 = addmethod2pos(obj2130, "isSimple", &meth_ast_isSimple2136, 5);
  int argcv_meth_ast_isSimple2136[] = {0};
  meth_meth_ast_isSimple2136->type = alloc_MethodType(1, argcv_meth_ast_isSimple2136);
  meth_meth_ast_isSimple2136->definitionModule = modulename;
  meth_meth_ast_isSimple2136->definitionLine = 458;
// method matchee
  struct UserObject *uo2138 = (struct UserObject*)obj2130;
  uo2138->data[6] = emptyclosure;
  Method *meth_meth_ast_matchee2138 = addmethod2pos(obj2130, "matchee", &meth_ast_matchee2138, 6);
  int argcv_meth_ast_matchee2138[] = {0};
  meth_meth_ast_matchee2138->type = alloc_MethodType(1, argcv_meth_ast_matchee2138);
  meth_meth_ast_matchee2138->definitionModule = modulename;
  meth_meth_ast_matchee2138->definitionLine = 459;
// method accept()from
  struct UserObject *uo2141 = (struct UserObject*)obj2130;
  uo2141->data[7] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from2141 = addmethod2pos(obj2130, "accept()from", &meth_ast_accept_40__41_from2141, 7);
  int argcv_meth_ast_accept_40__41_from2141[] = {1, 1};
  meth_meth_ast_accept_40__41_from2141->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from2141);
  meth_meth_ast_accept_40__41_from2141->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from2141->definitionLine = 460;
// method map()ancestors
  struct UserObject *uo2171 = (struct UserObject*)obj2130;
  uo2171->data[8] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors2171 = addmethod2pos(obj2130, "map()ancestors", &meth_ast_map_40__41_ancestors2171, 8);
  int argcv_meth_ast_map_40__41_ancestors2171[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors2171->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors2171);
  meth_meth_ast_map_40__41_ancestors2171->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors2171->definitionLine = 472;
// method pretty
  struct UserObject *uo2204 = (struct UserObject*)obj2130;
  uo2204->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty2204 = addmethod2pos(obj2130, "pretty", &meth_ast_pretty2204, 9);
  int argcv_meth_ast_pretty2204[] = {1};
  meth_meth_ast_pretty2204->type = alloc_MethodType(1, argcv_meth_ast_pretty2204);
  meth_meth_ast_pretty2204->definitionModule = modulename;
  meth_meth_ast_pretty2204->definitionLine = 480;
// method toGrace
  struct UserObject *uo2321 = (struct UserObject*)obj2130;
  uo2321->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace2321 = addmethod2pos(obj2130, "toGrace", &meth_ast_toGrace2321, 10);
  int argcv_meth_ast_toGrace2321[] = {1};
  meth_meth_ast_toGrace2321->type = alloc_MethodType(1, argcv_meth_ast_toGrace2321);
meth_meth_ast_toGrace2321->type->types[0] = type_Number;
meth_meth_ast_toGrace2321->type->names[0] = "depth";
  meth_meth_ast_toGrace2321->definitionModule = modulename;
  meth_meth_ast_toGrace2321->definitionLine = 495;
// method shallowCopy
  block_savedest(obj2130);
  Object closure2420 = createclosure(3, "shallowCopy");
  setclosureframe(closure2420, stackframe);
  addtoclosure(closure2420, var_nullNode);
  addtoclosure(closure2420, var_emptySeq);
  addtoclosure(closure2420, var_matchCaseNode);
  struct UserObject *uo2420 = (struct UserObject*)obj2130;
  uo2420->data[11] = (Object)closure2420;
  Method *meth_meth_ast_shallowCopy2420 = addmethod2pos(obj2130, "shallowCopy", &meth_ast_shallowCopy2420, 11);
  int argcv_meth_ast_shallowCopy2420[] = {0};
  meth_meth_ast_shallowCopy2420->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy2420);
  meth_meth_ast_shallowCopy2420->definitionModule = modulename;
  meth_meth_ast_shallowCopy2420->definitionLine = 509;
  sourceObject = obj2130;
// Begin line 453
  setline(453);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2426 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2427 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe2426);
// compiled call node returning call2427 (depth = 4)
  struct UserObject *obj2130_uo = (struct UserObject *)obj2130;
  obj2130_uo->super = call2427;
  sourceObject = obj2130;
// Begin line 454
  setline(454);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit2428 == NULL) {
    strlit2428 = alloc_String("matchcase");
    gc_root(strlit2428);
  }
// compiled string node returning strlit2428 (depth = 4)
  adddatum2(obj2130, strlit2428, 1);
  sourceObject = obj2130;
// Begin line 455
  setline(455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_matchee_39_ (depth = 4)
  adddatum2(obj2130, *var_matchee_39_, 2);
  sourceObject = obj2130;
// Begin line 456
  setline(456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_cases_39_ (depth = 4)
  adddatum2(obj2130, *var_cases_39_, 3);
  sourceObject = obj2130;
// Begin line 457
  setline(457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_elsecase_39_ (depth = 4)
  adddatum2(obj2130, *var_elsecase_39_, 4);
  sourceObject = obj2130;
  sourceObject = obj2130;
  sourceObject = obj2130;
  sourceObject = obj2130;
  sourceObject = obj2130;
  sourceObject = obj2130;
  sourceObject = obj2130;
  objclass2130 = obj2130->class;
  objclass2130->definitionModule = modulename;
  objclass2130->definitionLine = 452;
  (*(struct UserObject *)self).data[0] = lowerouter2130;
  self = oldself2130;
  selfslot = oldselfslot2130;
  stackframe = oldstackframe2130;
  gc_frame_end(frame);
  return obj2130;
}
Object meth_ast_new2129_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_matchCaseNode = getfromclosure(closure, 2);
  Object *var_baseNode = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_matchee_39_ = &(stackframe->slots[0]);
  *var_matchee_39_ = args[curarg];
  curarg++;
  Object *var_cases_39_ = &(stackframe->slots[1]);
  *var_cases_39_ = args[curarg];
  curarg++;
  Object *var_elsecase_39_ = &(stackframe->slots[2]);
  *var_elsecase_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2130 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2130 = alloc_userobj2(15,13, objclass2130);
  gc_frame_newslot(obj2130);
if (objclass2130 == NULL) {
  glfree(obj2130->class->name);
  obj2130->class->name = "matchCaseNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2130, self, 0);
  addmethodreal(obj2130,"outer", &reader_ast_outer_2131);
  Object oldself2130 = self;
  struct StackFrameObject *oldstackframe2130 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2130);
  gc_frame_newslot((Object)stackframe);
  self = obj2130;
  Object *oldselfslot2130 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2130 = (*(struct UserObject *)self).data[0], lowerouter2130 = thisouter2130;
  if (inheritingObject2130) {
    struct UserObject *inho2130 = (struct UserObject *)inheritingObject2130;
    while (inho2130->super != GraceDefaultObject) inho2130 = (struct UserObject *)inho2130->super;
    inho2130->super = obj2130;
    self = inheritingObject2130;
    *selfslot = self;
    lowerouter2130 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2130;
  }
if (objclass2130 == NULL) {
  Method *reader2132 = addmethodrealflags(obj2130, "kind",&reader_ast_kind_2132, MFLAG_DEF);
  reader2132->definitionModule = modulename;
  reader2132->definitionLine = 454;
}
adddatum2(obj2130, alloc_Undefined(), 1);
if (objclass2130 == NULL) {
  Method *reader2133 = addmethodrealflags(obj2130, "value",&reader_ast_value_2133, 0);
  Method *writer2133 = addmethodrealflags(obj2130, "value:=",&writer_ast_value_2133, 0);
  reader2133->definitionModule = modulename;
  writer2133->definitionModule = modulename;
  reader2133->definitionLine = 455;
  writer2133->definitionLine = 455;
}
obj2130->flags |= OFLAG_MUTABLE;
adddatum2(obj2130, alloc_Undefined(), 2);
if (objclass2130 == NULL) {
  Method *reader2134 = addmethodrealflags(obj2130, "cases",&reader_ast_cases_2134, 0);
  Method *writer2134 = addmethodrealflags(obj2130, "cases:=",&writer_ast_cases_2134, 0);
  reader2134->definitionModule = modulename;
  writer2134->definitionModule = modulename;
  reader2134->definitionLine = 456;
  writer2134->definitionLine = 456;
}
obj2130->flags |= OFLAG_MUTABLE;
adddatum2(obj2130, alloc_Undefined(), 3);
if (objclass2130 == NULL) {
  Method *reader2135 = addmethodrealflags(obj2130, "elsecase",&reader_ast_elsecase_2135, 0);
  Method *writer2135 = addmethodrealflags(obj2130, "elsecase:=",&writer_ast_elsecase_2135, 0);
  reader2135->definitionModule = modulename;
  writer2135->definitionModule = modulename;
  reader2135->definitionLine = 457;
  writer2135->definitionLine = 457;
}
obj2130->flags |= OFLAG_MUTABLE;
adddatum2(obj2130, alloc_Undefined(), 4);
// method isSimple
  struct UserObject *uo2136 = (struct UserObject*)obj2130;
  uo2136->data[5] = emptyclosure;
  Method *meth_meth_ast_isSimple2136 = addmethod2pos(obj2130, "isSimple", &meth_ast_isSimple2136, 5);
  int argcv_meth_ast_isSimple2136[] = {0};
  meth_meth_ast_isSimple2136->type = alloc_MethodType(1, argcv_meth_ast_isSimple2136);
  meth_meth_ast_isSimple2136->definitionModule = modulename;
  meth_meth_ast_isSimple2136->definitionLine = 458;
// method matchee
  struct UserObject *uo2138 = (struct UserObject*)obj2130;
  uo2138->data[6] = emptyclosure;
  Method *meth_meth_ast_matchee2138 = addmethod2pos(obj2130, "matchee", &meth_ast_matchee2138, 6);
  int argcv_meth_ast_matchee2138[] = {0};
  meth_meth_ast_matchee2138->type = alloc_MethodType(1, argcv_meth_ast_matchee2138);
  meth_meth_ast_matchee2138->definitionModule = modulename;
  meth_meth_ast_matchee2138->definitionLine = 459;
// method accept()from
  struct UserObject *uo2141 = (struct UserObject*)obj2130;
  uo2141->data[7] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from2141 = addmethod2pos(obj2130, "accept()from", &meth_ast_accept_40__41_from2141, 7);
  int argcv_meth_ast_accept_40__41_from2141[] = {1, 1};
  meth_meth_ast_accept_40__41_from2141->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from2141);
  meth_meth_ast_accept_40__41_from2141->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from2141->definitionLine = 460;
// method map()ancestors
  struct UserObject *uo2171 = (struct UserObject*)obj2130;
  uo2171->data[8] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors2171 = addmethod2pos(obj2130, "map()ancestors", &meth_ast_map_40__41_ancestors2171, 8);
  int argcv_meth_ast_map_40__41_ancestors2171[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors2171->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors2171);
  meth_meth_ast_map_40__41_ancestors2171->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors2171->definitionLine = 472;
// method pretty
  struct UserObject *uo2204 = (struct UserObject*)obj2130;
  uo2204->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty2204 = addmethod2pos(obj2130, "pretty", &meth_ast_pretty2204, 9);
  int argcv_meth_ast_pretty2204[] = {1};
  meth_meth_ast_pretty2204->type = alloc_MethodType(1, argcv_meth_ast_pretty2204);
  meth_meth_ast_pretty2204->definitionModule = modulename;
  meth_meth_ast_pretty2204->definitionLine = 480;
// method toGrace
  struct UserObject *uo2321 = (struct UserObject*)obj2130;
  uo2321->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace2321 = addmethod2pos(obj2130, "toGrace", &meth_ast_toGrace2321, 10);
  int argcv_meth_ast_toGrace2321[] = {1};
  meth_meth_ast_toGrace2321->type = alloc_MethodType(1, argcv_meth_ast_toGrace2321);
meth_meth_ast_toGrace2321->type->types[0] = type_Number;
meth_meth_ast_toGrace2321->type->names[0] = "depth";
  meth_meth_ast_toGrace2321->definitionModule = modulename;
  meth_meth_ast_toGrace2321->definitionLine = 495;
// method shallowCopy
  block_savedest(obj2130);
  Object closure2420 = createclosure(3, "shallowCopy");
  setclosureframe(closure2420, stackframe);
  addtoclosure(closure2420, var_nullNode);
  addtoclosure(closure2420, var_emptySeq);
  addtoclosure(closure2420, var_matchCaseNode);
  struct UserObject *uo2420 = (struct UserObject*)obj2130;
  uo2420->data[11] = (Object)closure2420;
  Method *meth_meth_ast_shallowCopy2420 = addmethod2pos(obj2130, "shallowCopy", &meth_ast_shallowCopy2420, 11);
  int argcv_meth_ast_shallowCopy2420[] = {0};
  meth_meth_ast_shallowCopy2420->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy2420);
  meth_meth_ast_shallowCopy2420->definitionModule = modulename;
  meth_meth_ast_shallowCopy2420->definitionLine = 509;
  sourceObject = obj2130;
// Begin line 453
  setline(453);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2426 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2427 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe2426);
// compiled call node returning call2427 (depth = 4)
  struct UserObject *obj2130_uo = (struct UserObject *)obj2130;
  obj2130_uo->super = call2427;
  sourceObject = obj2130;
// Begin line 454
  setline(454);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit2428 == NULL) {
    strlit2428 = alloc_String("matchcase");
    gc_root(strlit2428);
  }
// compiled string node returning strlit2428 (depth = 4)
  adddatum2(obj2130, strlit2428, 1);
  sourceObject = obj2130;
// Begin line 455
  setline(455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_matchee_39_ (depth = 4)
  adddatum2(obj2130, *var_matchee_39_, 2);
  sourceObject = obj2130;
// Begin line 456
  setline(456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_cases_39_ (depth = 4)
  adddatum2(obj2130, *var_cases_39_, 3);
  sourceObject = obj2130;
// Begin line 457
  setline(457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_elsecase_39_ (depth = 4)
  adddatum2(obj2130, *var_elsecase_39_, 4);
  sourceObject = obj2130;
  sourceObject = obj2130;
  sourceObject = obj2130;
  sourceObject = obj2130;
  sourceObject = obj2130;
  sourceObject = obj2130;
  sourceObject = obj2130;
  objclass2130 = obj2130->class;
  objclass2130->definitionModule = modulename;
  objclass2130->definitionLine = 452;
  (*(struct UserObject *)self).data[0] = lowerouter2130;
  self = oldself2130;
  selfslot = oldselfslot2130;
  stackframe = oldstackframe2130;
  gc_frame_end(frame);
  return obj2130;
}
Object meth_ast_methodTypeNode2430(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "methodTypeNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_methodTypeNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for methodTypeNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for methodTypeNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_methodTypeNode (depth = 3)
  gc_frame_end(frame);
  return *var_methodTypeNode;
}
Object meth_ast__apply2448(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_b = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 8)
  int callframe2449 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_each (depth = 9)
  gc_frame_newslot(*var_each);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_b (depth = 9)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call2450 = callmethod(*var_b, "apply",
    1, partcv, params);
  gc_frame_end(callframe2449);
// compiled call node returning call2450 (depth = 8)
  gc_frame_end(frame);
  return call2450;
}
Object meth_ast__apply2445(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_b = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 540
  setline(540);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2446 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block2447 = alloc_Block(NULL, NULL, "ast", 540);
  gc_frame_newslot(block2447);
// method _apply
  block_savedest(block2447);
  Object closure2448 = createclosure(2, "_apply");
  setclosureframe(closure2448, stackframe);
  addtoclosure(closure2448, var_b);
  addtoclosure(closure2448, selfslot);
  struct UserObject *uo2448 = (struct UserObject*)block2447;
  uo2448->data[0] = (Object)closure2448;
  Method *meth_meth_ast__apply2448 = addmethod2pos(block2447, "_apply", &meth_ast__apply2448, 0);
  int argcv_meth_ast__apply2448[] = {1};
  meth_meth_ast__apply2448->type = alloc_MethodType(1, argcv_meth_ast__apply2448);
  meth_meth_ast__apply2448->definitionModule = modulename;
  meth_meth_ast__apply2448->definitionLine = 513;
// compiled block node returning block2447 (depth = 7)
  gc_frame_newslot(block2447);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2452 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  partcv[0] = 0;
  Object call2453 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe2452);
// compiled call node returning call2453 (depth = 8)
// compiled member node returning call2453 (depth = 7)
  params[0] = block2447;
  partcv[0] = 1;
  Object call2454 = callmethod(call2453, "do",
    1, partcv, params);
  gc_frame_end(callframe2446);
// compiled call node returning call2454 (depth = 6)
  gc_frame_end(frame);
  return call2454;
}
Object meth_ast_parametersDo2442(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "parametersDo");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method parametersDo");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for parametersDo (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for parametersDo");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 539
  setline(539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2443 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block2444 = alloc_Block(NULL, NULL, "ast", 539);
  gc_frame_newslot(block2444);
// method _apply
  block_savedest(block2444);
  Object closure2445 = createclosure(2, "_apply");
  setclosureframe(closure2445, stackframe);
  addtoclosure(closure2445, var_b);
  addtoclosure(closure2445, selfslot);
  struct UserObject *uo2445 = (struct UserObject*)block2444;
  uo2445->data[0] = (Object)closure2445;
  Method *meth_meth_ast__apply2445 = addmethod2pos(block2444, "_apply", &meth_ast__apply2445, 0);
  int argcv_meth_ast__apply2445[] = {1};
  meth_meth_ast__apply2445->type = alloc_MethodType(1, argcv_meth_ast__apply2445);
  meth_meth_ast__apply2445->definitionModule = modulename;
  meth_meth_ast__apply2445->definitionLine = 513;
// compiled block node returning block2444 (depth = 5)
  gc_frame_newslot(block2444);
// call case 6: other member request
// Begin line 539
  setline(539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2456 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2457 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2456);
// compiled call node returning call2457 (depth = 6)
// compiled member node returning call2457 (depth = 5)
  params[0] = block2444;
  partcv[0] = 1;
  Object call2458 = callmethod(call2457, "do",
    1, partcv, params);
  gc_frame_end(callframe2443);
// compiled call node returning call2458 (depth = 4)
  gc_frame_end(frame);
  return call2458;
}
Object meth_ast_scope_58__61_2459(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "scope:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method scope:=");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for scope:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_st = &(stackframe->slots[0]);
  *var_st = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for scope:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 546
  setline(546);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 539
  setline(539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2460 = gc_frame_new();
// Begin line 546
  setline(546);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_st (depth = 6)
  gc_frame_newslot(*var_st);
// call case 4: self request
  params[0] = *var_st;
  partcv[0] = 1;
  Object call2461 = callmethodflags(self, "symbolTable:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2460);
// compiled call node returning call2461 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 547
  setline(547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 539
  setline(539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2462 = gc_frame_new();
// Begin line 547
  setline(547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_st (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call2463 = callmethod(*var_st, "node:=",
    1, partcv, params);
  gc_frame_end(callframe2462);
// compiled call node returning call2463 (depth = 5)
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_declarationKindWithAncestors2464(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "declarationKindWithAncestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method declarationKindWithAncestors");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for declarationKindWithAncestors (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for declarationKindWithAncestors");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 549
  setline(549);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit2465 == NULL) {
    strlit2465 = alloc_String("typedec");
    gc_root(strlit2465);
  }
// compiled string node returning strlit2465 (depth = 4)
  gc_frame_end(frame);
  return strlit2465;
}
Object meth_ast__apply2498(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 560
  setline(560);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2499 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_visitor (depth = 8)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_newChain (depth = 8)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2500 = callmethod(*var_part, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe2499);
// compiled call node returning call2500 (depth = 7)
  gc_frame_end(frame);
  return call2500;
}
Object meth_ast_accept_40__41_from2466(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 551
  setline(551);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2468 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2469 = callmethod(*var_visitor, "visitMethodType()up",
    2, partcv, params);
  gc_frame_end(callframe2468);
// compiled call node returning call2469 (depth = 5)
  Object if2467 = done;
  if (istrue(call2469)) {
// Begin line 552
  setline(552);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2470 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_as (depth = 7)
  params[0] = self;
  partcv[0] = 1;
  Object call2471 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe2470);
// compiled call node returning call2471 (depth = 6)
  *var_newChain = call2471;
  if (call2471 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 553
  setline(553);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2474 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2475 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2474);
// compiled call node returning call2475 (depth = 8)
// compiled member node returning call2475 (depth = 7)
  int op_slot_right_2473 = gc_frame_newslot(call2475);
// starting to compile identifier node (depth = 7)
  Object bool2477 = alloc_Boolean(0);
// compiled identifier node returning bool2477 (depth = 7)
  int op_slot_left_2473 = gc_frame_newslot(bool2477);
  params[0] = call2475;
  partcv[0] = 1;
  Object opresult2478 = callmethod(bool2477, "!=", 1, partcv, params);
// compiled op node returning opresult2478 (depth = 6)
  Object if2472 = done;
  if (istrue(opresult2478)) {
// Begin line 554
  setline(554);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2479 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2480 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2481 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2480);
// compiled call node returning call2481 (depth = 8)
// compiled member node returning call2481 (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2482 = callmethod(call2481, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe2479);
// compiled call node returning call2482 (depth = 6)
    gc_frame_newslot(call2482);
    if2472 = call2482;
  } else {
  }
// compiled if node returning if2472 (depth = 5)
// Begin line 556
  setline(556);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool2485 = alloc_Boolean(0);
// compiled identifier node returning bool2485 (depth = 7)
  int op_slot_right_2484 = gc_frame_newslot(bool2485);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2487 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2488 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2487);
// compiled call node returning call2488 (depth = 8)
// compiled member node returning call2488 (depth = 7)
  int op_slot_left_2484 = gc_frame_newslot(call2488);
  params[0] = bool2485;
  partcv[0] = 1;
  Object opresult2489 = callmethod(call2488, "!=", 1, partcv, params);
// compiled op node returning opresult2489 (depth = 6)
  Object if2483 = done;
  if (istrue(opresult2489)) {
// Begin line 557
  setline(557);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2490 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2491 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2492 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2491);
// compiled call node returning call2492 (depth = 8)
// compiled member node returning call2492 (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2493 = callmethod(call2492, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe2490);
// compiled call node returning call2493 (depth = 6)
    gc_frame_newslot(call2493);
    if2483 = call2493;
  } else {
  }
// compiled if node returning if2483 (depth = 5)
// Begin line 559
  setline(559);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2494 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2495 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2496 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2495);
// compiled call node returning call2496 (depth = 7)
// compiled member node returning call2496 (depth = 6)
  gc_frame_newslot(call2496);
// starting to compile block node (depth = 6)
  Object block2497 = alloc_Block(NULL, NULL, "ast", 559);
  gc_frame_newslot(block2497);
// method _apply
  block_savedest(block2497);
  Object closure2498 = createclosure(3, "_apply");
  setclosureframe(closure2498, stackframe);
  addtoclosure(closure2498, var_visitor);
  addtoclosure(closure2498, var_newChain);
  addtoclosure(closure2498, selfslot);
  struct UserObject *uo2498 = (struct UserObject*)block2497;
  uo2498->data[0] = (Object)closure2498;
  Method *meth_meth_ast__apply2498 = addmethod2pos(block2497, "_apply", &meth_ast__apply2498, 0);
  int argcv_meth_ast__apply2498[] = {1};
  meth_meth_ast__apply2498->type = alloc_MethodType(1, argcv_meth_ast__apply2498);
  meth_meth_ast__apply2498->definitionModule = modulename;
  meth_meth_ast__apply2498->definitionLine = 559;
// compiled block node returning block2497 (depth = 6)
  gc_frame_newslot(block2497);
// call case 5: prelude request
  params[0] = call2496;
  params[1] = block2497;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2502 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2494);
// compiled call node returning call2502 (depth = 5)
    gc_frame_newslot(call2502);
    if2467 = call2502;
  } else {
  }
// compiled if node returning if2467 (depth = 4)
  gc_frame_end(frame);
  return if2467;
}
Object meth_ast_map_40__41_ancestors2503(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 565
  setline(565);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2504 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2505 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2504);
// compiled call node returning call2505 (depth = 6)
// compiled member node returning call2505 (depth = 5)
  *var_n = call2505;
  if (call2505 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 566
  setline(566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2506 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call2507 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe2506);
// compiled call node returning call2507 (depth = 5)
  *var_newChain = call2507;
  if (call2507 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 567
  setline(567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 565
  setline(565);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2508 = gc_frame_new();
// Begin line 567
  setline(567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2509 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2510 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2511 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2510);
// compiled call node returning call2511 (depth = 8)
// compiled member node returning call2511 (depth = 7)
  gc_frame_newslot(call2511);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2512 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2513 = gc_frame_new();
// call case 3: self.outer request
  Object call2514 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2513);
// compiled call node returning call2514 (depth = 10)
// compiled member node returning call2514 (depth = 9)
  partcv[0] = 0;
  Object call2515 = callmethodflags(call2514, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2512);
// compiled call node returning call2515 (depth = 8)
// compiled member node returning call2515 (depth = 7)
  params[0] = call2511;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2516 = callmethodflags(call2515, "maybeMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2509);
// compiled call node returning call2516 (depth = 6)
  gc_frame_newslot(call2516);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call2516;
  partcv[0] = 1;
  Object call2517 = callmethod(*var_n, "rtype:=",
    1, partcv, params);
  gc_frame_end(callframe2508);
// compiled call node returning call2517 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 568
  setline(568);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 567
  setline(567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2518 = gc_frame_new();
// Begin line 568
  setline(568);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2519 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2520 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2521 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2520);
// compiled call node returning call2521 (depth = 8)
// compiled member node returning call2521 (depth = 7)
  gc_frame_newslot(call2521);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2522 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2523 = gc_frame_new();
// call case 3: self.outer request
  Object call2524 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2523);
// compiled call node returning call2524 (depth = 10)
// compiled member node returning call2524 (depth = 9)
  partcv[0] = 0;
  Object call2525 = callmethodflags(call2524, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2522);
// compiled call node returning call2525 (depth = 8)
// compiled member node returning call2525 (depth = 7)
  params[0] = call2521;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2526 = callmethodflags(call2525, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2519);
// compiled call node returning call2526 (depth = 6)
  gc_frame_newslot(call2526);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call2526;
  partcv[0] = 1;
  Object call2527 = callmethod(*var_n, "signature:=",
    1, partcv, params);
  gc_frame_end(callframe2518);
// compiled call node returning call2527 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 569
  setline(569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 568
  setline(568);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2528 = gc_frame_new();
// Begin line 569
  setline(569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2529 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2530 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2531 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2530);
// compiled call node returning call2531 (depth = 8)
// compiled member node returning call2531 (depth = 7)
  gc_frame_newslot(call2531);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2532 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2533 = gc_frame_new();
// call case 3: self.outer request
  Object call2534 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2533);
// compiled call node returning call2534 (depth = 10)
// compiled member node returning call2534 (depth = 9)
  partcv[0] = 0;
  Object call2535 = callmethodflags(call2534, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2532);
// compiled call node returning call2535 (depth = 8)
// compiled member node returning call2535 (depth = 7)
  params[0] = call2531;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2536 = callmethodflags(call2535, "maybeMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2529);
// compiled call node returning call2536 (depth = 6)
  gc_frame_newslot(call2536);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call2536;
  partcv[0] = 1;
  Object call2537 = callmethod(*var_n, "generics:=",
    1, partcv, params);
  gc_frame_end(callframe2528);
// compiled call node returning call2537 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 570
  setline(570);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2538 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call2539 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe2538);
// compiled call node returning call2539 (depth = 4)
  gc_frame_end(frame);
  return call2539;
}
Object meth_ast__apply2548(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 575
  setline(575);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2550 == NULL) {
    strlit2550 = alloc_String("  ");
    gc_root(strlit2550);
  }
// compiled string node returning strlit2550 (depth = 8)
  int op_slot_right_2549 = gc_frame_newslot(strlit2550);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_2549 = gc_frame_newslot(*var_spc);
  params[0] = strlit2550;
  partcv[0] = 1;
  Object opresult2552 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult2552 (depth = 7)
  *var_spc = opresult2552;
  if (opresult2552 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply2687(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 588
  setline(588);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2689 == NULL) {
    strlit2689 = alloc_String("");
    gc_root(strlit2689);
  }
// compiled string node returning strlit2689 (depth = 8)
  int op_slot_right_2688 = gc_frame_newslot(strlit2689);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2692 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num2694 = alloc_Float64(2);
// compiled num node returning num2694 (depth = 11)
  int op_slot_right_2693 = gc_frame_newslot(num2694);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_2693 = gc_frame_newslot(*var_depth);
  params[0] = num2694;
  partcv[0] = 1;
  Object sum2696 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2696 (depth = 10)
  gc_frame_newslot(sum2696);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_part (depth = 10)
  params[0] = sum2696;
  partcv[0] = 1;
  Object call2697 = callmethod(*var_part, "pretty",
    1, partcv, params);
  gc_frame_end(callframe2692);
// compiled call node returning call2697 (depth = 9)
  int op_slot_right_2691 = gc_frame_newslot(call2697);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2700 == NULL) {
    strlit2700 = alloc_String("");
    gc_root(strlit2700);
  }
// compiled string node returning strlit2700 (depth = 10)
  int op_slot_right_2699 = gc_frame_newslot(strlit2700);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_2702 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit2705 == NULL) {
    strlit2705 = alloc_String("""\x0a""  ");
    gc_root(strlit2705);
  }
// compiled string node returning strlit2705 (depth = 12)
  int op_slot_right_2704 = gc_frame_newslot(strlit2705);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_s (depth = 13)
  int op_slot_right_2707 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 13)
  if (strlit2709 == NULL) {
    strlit2709 = alloc_String("");
    gc_root(strlit2709);
  }
// compiled string node returning strlit2709 (depth = 13)
  int op_slot_left_2707 = gc_frame_newslot(strlit2709);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2710 = callmethod(strlit2709, "++", 1, partcv, params);
// compiled op node returning opresult2710 (depth = 12)
  int op_slot_left_2704 = gc_frame_newslot(opresult2710);
  params[0] = strlit2705;
  partcv[0] = 1;
  Object opresult2711 = callmethod(opresult2710, "++", 1, partcv, params);
// compiled op node returning opresult2711 (depth = 11)
  int op_slot_left_2702 = gc_frame_newslot(opresult2711);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2712 = callmethod(opresult2711, "++", 1, partcv, params);
// compiled op node returning opresult2712 (depth = 10)
  int op_slot_left_2699 = gc_frame_newslot(opresult2712);
  params[0] = strlit2700;
  partcv[0] = 1;
  Object opresult2713 = callmethod(opresult2712, "++", 1, partcv, params);
// compiled op node returning opresult2713 (depth = 9)
  int op_slot_left_2691 = gc_frame_newslot(opresult2713);
  params[0] = call2697;
  partcv[0] = 1;
  Object opresult2714 = callmethod(opresult2713, "++", 1, partcv, params);
// compiled op node returning opresult2714 (depth = 8)
  int op_slot_left_2688 = gc_frame_newslot(opresult2714);
  params[0] = strlit2689;
  partcv[0] = 1;
  Object opresult2715 = callmethod(opresult2714, "++", 1, partcv, params);
// compiled op node returning opresult2715 (depth = 7)
  *var_s = opresult2715;
  if (opresult2715 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty2540(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 573
  setline(573);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2541 == NULL) {
    strlit2541 = alloc_String("");
    gc_root(strlit2541);
  }
// compiled string node returning strlit2541 (depth = 5)
  *var_spc = strlit2541;
  if (strlit2541 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 574
  setline(574);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2542 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_right_2543 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 6)
  Object num2545 = alloc_Float64(0);
// compiled num node returning num2545 (depth = 6)
  int op_slot_left_2543 = gc_frame_newslot(num2545);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult2546 = callmethod(num2545, "..", 1, partcv, params);
// compiled op node returning opresult2546 (depth = 5)
  gc_frame_newslot(opresult2546);
// starting to compile block node (depth = 5)
  Object block2547 = alloc_Block(NULL, NULL, "ast", 574);
  gc_frame_newslot(block2547);
// method _apply
  block_savedest(block2547);
  Object closure2548 = createclosure(2, "_apply");
  setclosureframe(closure2548, stackframe);
  addtoclosure(closure2548, var_spc);
  addtoclosure(closure2548, selfslot);
  struct UserObject *uo2548 = (struct UserObject*)block2547;
  uo2548->data[0] = (Object)closure2548;
  Method *meth_meth_ast__apply2548 = addmethod2pos(block2547, "_apply", &meth_ast__apply2548, 0);
  int argcv_meth_ast__apply2548[] = {1};
  meth_meth_ast__apply2548->type = alloc_MethodType(1, argcv_meth_ast__apply2548);
  meth_meth_ast__apply2548->definitionModule = modulename;
  meth_meth_ast__apply2548->definitionLine = 569;
// compiled block node returning block2547 (depth = 5)
  gc_frame_newslot(block2547);
// call case 5: prelude request
  params[0] = opresult2546;
  params[1] = block2547;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2555 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2542);
// compiled call node returning call2555 (depth = 4)
// Begin line 577
  setline(577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2557 == NULL) {
    strlit2557 = alloc_String("""\x0a""");
    gc_root(strlit2557);
  }
// compiled string node returning strlit2557 (depth = 6)
  int op_slot_right_2556 = gc_frame_newslot(strlit2557);
// starting to compile call node (depth = 6)
  int callframe2559 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call2560 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe2559);
// compiled call node returning call2560 (depth = 6)
  int op_slot_left_2556 = gc_frame_newslot(call2560);
  params[0] = strlit2557;
  partcv[0] = 1;
  Object opresult2561 = callmethod(call2560, "++", 1, partcv, params);
// compiled op node returning opresult2561 (depth = 5)
  *var_s = opresult2561;
  if (opresult2561 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 578
  setline(578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2563 == NULL) {
    strlit2563 = alloc_String("""\x0a""");
    gc_root(strlit2563);
  }
// compiled string node returning strlit2563 (depth = 6)
  int op_slot_right_2562 = gc_frame_newslot(strlit2563);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2566 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2567 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2566);
// compiled call node returning call2567 (depth = 8)
// compiled member node returning call2567 (depth = 7)
  int op_slot_right_2565 = gc_frame_newslot(call2567);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2570 == NULL) {
    strlit2570 = alloc_String("Name: ");
    gc_root(strlit2570);
  }
// compiled string node returning strlit2570 (depth = 8)
  int op_slot_right_2569 = gc_frame_newslot(strlit2570);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_2572 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2575 == NULL) {
    strlit2575 = alloc_String("");
    gc_root(strlit2575);
  }
// compiled string node returning strlit2575 (depth = 10)
  int op_slot_right_2574 = gc_frame_newslot(strlit2575);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_right_2577 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 11)
  if (strlit2579 == NULL) {
    strlit2579 = alloc_String("");
    gc_root(strlit2579);
  }
// compiled string node returning strlit2579 (depth = 11)
  int op_slot_left_2577 = gc_frame_newslot(strlit2579);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2580 = callmethod(strlit2579, "++", 1, partcv, params);
// compiled op node returning opresult2580 (depth = 10)
  int op_slot_left_2574 = gc_frame_newslot(opresult2580);
  params[0] = strlit2575;
  partcv[0] = 1;
  Object opresult2581 = callmethod(opresult2580, "++", 1, partcv, params);
// compiled op node returning opresult2581 (depth = 9)
  int op_slot_left_2572 = gc_frame_newslot(opresult2581);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2582 = callmethod(opresult2581, "++", 1, partcv, params);
// compiled op node returning opresult2582 (depth = 8)
  int op_slot_left_2569 = gc_frame_newslot(opresult2582);
  params[0] = strlit2570;
  partcv[0] = 1;
  Object opresult2583 = callmethod(opresult2582, "++", 1, partcv, params);
// compiled op node returning opresult2583 (depth = 7)
  int op_slot_left_2565 = gc_frame_newslot(opresult2583);
  params[0] = call2567;
  partcv[0] = 1;
  Object opresult2584 = callmethod(opresult2583, "++", 1, partcv, params);
// compiled op node returning opresult2584 (depth = 6)
  int op_slot_left_2562 = gc_frame_newslot(opresult2584);
  params[0] = strlit2563;
  partcv[0] = 1;
  Object opresult2585 = callmethod(opresult2584, "++", 1, partcv, params);
// compiled op node returning opresult2585 (depth = 5)
  *var_s = opresult2585;
  if (opresult2585 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 579
  setline(579);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool2589 = alloc_Boolean(0);
// compiled identifier node returning bool2589 (depth = 6)
  int op_slot_right_2588 = gc_frame_newslot(bool2589);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2591 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2592 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2591);
// compiled call node returning call2592 (depth = 7)
// compiled member node returning call2592 (depth = 6)
  int op_slot_left_2588 = gc_frame_newslot(call2592);
  params[0] = bool2589;
  partcv[0] = 1;
  Object opresult2593 = callmethod(call2592, "!=", 1, partcv, params);
// compiled op node returning opresult2593 (depth = 5)
  Object if2587 = done;
  if (istrue(opresult2593)) {
// Begin line 580
  setline(580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2595 == NULL) {
    strlit2595 = alloc_String("");
    gc_root(strlit2595);
  }
// compiled string node returning strlit2595 (depth = 7)
  int op_slot_right_2594 = gc_frame_newslot(strlit2595);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2598 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num2600 = alloc_Float64(2);
// compiled num node returning num2600 (depth = 10)
  int op_slot_right_2599 = gc_frame_newslot(num2600);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_2599 = gc_frame_newslot(*var_depth);
  params[0] = num2600;
  partcv[0] = 1;
  Object sum2602 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2602 (depth = 9)
  gc_frame_newslot(sum2602);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2603 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2604 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2603);
// compiled call node returning call2604 (depth = 10)
// compiled member node returning call2604 (depth = 9)
  params[0] = sum2602;
  partcv[0] = 1;
  Object call2605 = callmethod(call2604, "pretty",
    1, partcv, params);
  gc_frame_end(callframe2598);
// compiled call node returning call2605 (depth = 8)
  int op_slot_right_2597 = gc_frame_newslot(call2605);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2608 == NULL) {
    strlit2608 = alloc_String("");
    gc_root(strlit2608);
  }
// compiled string node returning strlit2608 (depth = 9)
  int op_slot_right_2607 = gc_frame_newslot(strlit2608);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_2610 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2613 == NULL) {
    strlit2613 = alloc_String("Returns:""\x0a""  ");
    gc_root(strlit2613);
  }
// compiled string node returning strlit2613 (depth = 11)
  int op_slot_right_2612 = gc_frame_newslot(strlit2613);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_spc (depth = 12)
  int op_slot_right_2615 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit2618 == NULL) {
    strlit2618 = alloc_String("");
    gc_root(strlit2618);
  }
// compiled string node returning strlit2618 (depth = 13)
  int op_slot_right_2617 = gc_frame_newslot(strlit2618);
// starting to compile op node (depth = 13)
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_s (depth = 14)
  int op_slot_right_2620 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 14)
  if (strlit2622 == NULL) {
    strlit2622 = alloc_String("");
    gc_root(strlit2622);
  }
// compiled string node returning strlit2622 (depth = 14)
  int op_slot_left_2620 = gc_frame_newslot(strlit2622);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2623 = callmethod(strlit2622, "++", 1, partcv, params);
// compiled op node returning opresult2623 (depth = 13)
  int op_slot_left_2617 = gc_frame_newslot(opresult2623);
  params[0] = strlit2618;
  partcv[0] = 1;
  Object opresult2624 = callmethod(opresult2623, "++", 1, partcv, params);
// compiled op node returning opresult2624 (depth = 12)
  int op_slot_left_2615 = gc_frame_newslot(opresult2624);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2625 = callmethod(opresult2624, "++", 1, partcv, params);
// compiled op node returning opresult2625 (depth = 11)
  int op_slot_left_2612 = gc_frame_newslot(opresult2625);
  params[0] = strlit2613;
  partcv[0] = 1;
  Object opresult2626 = callmethod(opresult2625, "++", 1, partcv, params);
// compiled op node returning opresult2626 (depth = 10)
  int op_slot_left_2610 = gc_frame_newslot(opresult2626);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2627 = callmethod(opresult2626, "++", 1, partcv, params);
// compiled op node returning opresult2627 (depth = 9)
  int op_slot_left_2607 = gc_frame_newslot(opresult2627);
  params[0] = strlit2608;
  partcv[0] = 1;
  Object opresult2628 = callmethod(opresult2627, "++", 1, partcv, params);
// compiled op node returning opresult2628 (depth = 8)
  int op_slot_left_2597 = gc_frame_newslot(opresult2628);
  params[0] = call2605;
  partcv[0] = 1;
  Object opresult2629 = callmethod(opresult2628, "++", 1, partcv, params);
// compiled op node returning opresult2629 (depth = 7)
  int op_slot_left_2594 = gc_frame_newslot(opresult2629);
  params[0] = strlit2595;
  partcv[0] = 1;
  Object opresult2630 = callmethod(opresult2629, "++", 1, partcv, params);
// compiled op node returning opresult2630 (depth = 6)
  *var_s = opresult2630;
  if (opresult2630 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if2587 = done;
  } else {
  }
// compiled if node returning if2587 (depth = 4)
// Begin line 582
  setline(582);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2634 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2635 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2634);
// compiled call node returning call2635 (depth = 7)
// compiled member node returning call2635 (depth = 6)
  int op_slot_right_2633 = gc_frame_newslot(call2635);
// starting to compile identifier node (depth = 6)
  Object bool2637 = alloc_Boolean(0);
// compiled identifier node returning bool2637 (depth = 6)
  int op_slot_left_2633 = gc_frame_newslot(bool2637);
  params[0] = call2635;
  partcv[0] = 1;
  Object opresult2638 = callmethod(bool2637, "!=", 1, partcv, params);
// compiled op node returning opresult2638 (depth = 5)
  Object if2632 = done;
  if (istrue(opresult2638)) {
// Begin line 583
  setline(583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2640 == NULL) {
    strlit2640 = alloc_String("TypeParams:""\x0a""");
    gc_root(strlit2640);
  }
// compiled string node returning strlit2640 (depth = 7)
  int op_slot_right_2639 = gc_frame_newslot(strlit2640);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_2642 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2645 == NULL) {
    strlit2645 = alloc_String("""\x0a""");
    gc_root(strlit2645);
  }
// compiled string node returning strlit2645 (depth = 9)
  int op_slot_right_2644 = gc_frame_newslot(strlit2645);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_right_2647 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 10)
  if (strlit2649 == NULL) {
    strlit2649 = alloc_String("");
    gc_root(strlit2649);
  }
// compiled string node returning strlit2649 (depth = 10)
  int op_slot_left_2647 = gc_frame_newslot(strlit2649);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2650 = callmethod(strlit2649, "++", 1, partcv, params);
// compiled op node returning opresult2650 (depth = 9)
  int op_slot_left_2644 = gc_frame_newslot(opresult2650);
  params[0] = strlit2645;
  partcv[0] = 1;
  Object opresult2651 = callmethod(opresult2650, "++", 1, partcv, params);
// compiled op node returning opresult2651 (depth = 8)
  int op_slot_left_2642 = gc_frame_newslot(opresult2651);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2652 = callmethod(opresult2651, "++", 1, partcv, params);
// compiled op node returning opresult2652 (depth = 7)
  int op_slot_left_2639 = gc_frame_newslot(opresult2652);
  params[0] = strlit2640;
  partcv[0] = 1;
  Object opresult2653 = callmethod(opresult2652, "++", 1, partcv, params);
// compiled op node returning opresult2653 (depth = 6)
  *var_s = opresult2653;
  if (opresult2653 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 584
  setline(584);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2656 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2658 = alloc_Float64(2);
// compiled num node returning num2658 (depth = 9)
  int op_slot_right_2657 = gc_frame_newslot(num2658);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_2657 = gc_frame_newslot(*var_depth);
  params[0] = num2658;
  partcv[0] = 1;
  Object sum2660 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2660 (depth = 8)
  gc_frame_newslot(sum2660);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2661 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2662 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2661);
// compiled call node returning call2662 (depth = 9)
// compiled member node returning call2662 (depth = 8)
  params[0] = sum2660;
  partcv[0] = 1;
  Object call2663 = callmethod(call2662, "pretty",
    1, partcv, params);
  gc_frame_end(callframe2656);
// compiled call node returning call2663 (depth = 7)
  int op_slot_right_2655 = gc_frame_newslot(call2663);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_2655 = gc_frame_newslot(*var_s);
  params[0] = call2663;
  partcv[0] = 1;
  Object opresult2665 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2665 (depth = 6)
  *var_s = opresult2665;
  if (opresult2665 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if2632 = done;
  } else {
  }
// compiled if node returning if2632 (depth = 4)
// Begin line 586
  setline(586);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2668 == NULL) {
    strlit2668 = alloc_String("Signature:");
    gc_root(strlit2668);
  }
// compiled string node returning strlit2668 (depth = 6)
  int op_slot_right_2667 = gc_frame_newslot(strlit2668);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_2670 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2673 == NULL) {
    strlit2673 = alloc_String("""\x0a""");
    gc_root(strlit2673);
  }
// compiled string node returning strlit2673 (depth = 8)
  int op_slot_right_2672 = gc_frame_newslot(strlit2673);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_right_2675 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 9)
  if (strlit2677 == NULL) {
    strlit2677 = alloc_String("");
    gc_root(strlit2677);
  }
// compiled string node returning strlit2677 (depth = 9)
  int op_slot_left_2675 = gc_frame_newslot(strlit2677);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2678 = callmethod(strlit2677, "++", 1, partcv, params);
// compiled op node returning opresult2678 (depth = 8)
  int op_slot_left_2672 = gc_frame_newslot(opresult2678);
  params[0] = strlit2673;
  partcv[0] = 1;
  Object opresult2679 = callmethod(opresult2678, "++", 1, partcv, params);
// compiled op node returning opresult2679 (depth = 7)
  int op_slot_left_2670 = gc_frame_newslot(opresult2679);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2680 = callmethod(opresult2679, "++", 1, partcv, params);
// compiled op node returning opresult2680 (depth = 6)
  int op_slot_left_2667 = gc_frame_newslot(opresult2680);
  params[0] = strlit2668;
  partcv[0] = 1;
  Object opresult2681 = callmethod(opresult2680, "++", 1, partcv, params);
// compiled op node returning opresult2681 (depth = 5)
  *var_s = opresult2681;
  if (opresult2681 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 587
  setline(587);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2683 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2684 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2685 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2684);
// compiled call node returning call2685 (depth = 6)
// compiled member node returning call2685 (depth = 5)
  gc_frame_newslot(call2685);
// starting to compile block node (depth = 5)
  Object block2686 = alloc_Block(NULL, NULL, "ast", 587);
  gc_frame_newslot(block2686);
// method _apply
  block_savedest(block2686);
  Object closure2687 = createclosure(4, "_apply");
  setclosureframe(closure2687, stackframe);
  addtoclosure(closure2687, var_depth);
  addtoclosure(closure2687, var_spc);
  addtoclosure(closure2687, var_s);
  addtoclosure(closure2687, selfslot);
  struct UserObject *uo2687 = (struct UserObject*)block2686;
  uo2687->data[0] = (Object)closure2687;
  Method *meth_meth_ast__apply2687 = addmethod2pos(block2686, "_apply", &meth_ast__apply2687, 0);
  int argcv_meth_ast__apply2687[] = {1};
  meth_meth_ast__apply2687->type = alloc_MethodType(1, argcv_meth_ast__apply2687);
  meth_meth_ast__apply2687->definitionModule = modulename;
  meth_meth_ast__apply2687->definitionLine = 587;
// compiled block node returning block2686 (depth = 5)
  gc_frame_newslot(block2686);
// call case 5: prelude request
  params[0] = call2685;
  params[1] = block2686;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2718 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2683);
// compiled call node returning call2718 (depth = 4)
// Begin line 590
  setline(590);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply2761(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_part = getfromclosure(closure, 0);
  Object *var_depth = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_pnr = &(stackframe->slots[0]);
  *var_pnr = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_p = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "p");
// Begin line 599
  setline(599);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 9)
// Begin line 600
  setline(600);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile index node (depth = 10)
// Begin line 599
  setline(599);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2762 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_part (depth = 13)
  partcv[0] = 0;
  Object call2763 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe2762);
// compiled call node returning call2763 (depth = 12)
// compiled member node returning call2763 (depth = 11)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_pnr (depth = 11)
  params[0] = *var_pnr;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres2764 = callmethod(call2763, "[]", 1, partcv, params);
// compiled index node returning idxres2764 (depth = 10)
  *var_p = idxres2764;
  if (idxres2764 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 9)
// Begin line 600
  setline(600);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2766 = gc_frame_new();
// starting to compile op node (depth = 12)
// starting to compile num node (depth = 13)
  Object num2768 = alloc_Float64(1);
// compiled num node returning num2768 (depth = 13)
  int op_slot_right_2767 = gc_frame_newslot(num2768);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_depth (depth = 13)
  int op_slot_left_2767 = gc_frame_newslot(*var_depth);
  params[0] = num2768;
  partcv[0] = 1;
  Object sum2770 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2770 (depth = 12)
  gc_frame_newslot(sum2770);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_p (depth = 12)
  params[0] = sum2770;
  partcv[0] = 1;
  Object call2771 = callmethod(*var_p, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe2766);
// compiled call node returning call2771 (depth = 11)
  int op_slot_right_2765 = gc_frame_newslot(call2771);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_2765 = gc_frame_newslot(*var_s);
  params[0] = call2771;
  partcv[0] = 1;
  Object opresult2773 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2773 (depth = 10)
  *var_s = opresult2773;
  if (opresult2773 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 601
  setline(601);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
  Object bool2778 = alloc_Boolean(0);
// compiled identifier node returning bool2778 (depth = 12)
  int op_slot_right_2777 = gc_frame_newslot(bool2778);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2780 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_part (depth = 14)
  partcv[0] = 0;
  Object call2781 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe2780);
// compiled call node returning call2781 (depth = 13)
// compiled member node returning call2781 (depth = 12)
  int op_slot_left_2777 = gc_frame_newslot(call2781);
  params[0] = bool2778;
  partcv[0] = 1;
  Object opresult2782 = callmethod(call2781, "!=", 1, partcv, params);
// compiled op node returning opresult2782 (depth = 11)
  int op_slot_right_2776 = gc_frame_newslot(opresult2782);
// starting to compile op node (depth = 11)
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2785 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe2786 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_part (depth = 16)
  partcv[0] = 0;
  Object call2787 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe2786);
// compiled call node returning call2787 (depth = 15)
// compiled member node returning call2787 (depth = 14)
  partcv[0] = 0;
  Object call2788 = callmethod(call2787, "size",
    1, partcv, params);
  gc_frame_end(callframe2785);
// compiled call node returning call2788 (depth = 13)
// compiled member node returning call2788 (depth = 12)
  int op_slot_right_2784 = gc_frame_newslot(call2788);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_pnr (depth = 12)
  int op_slot_left_2784 = gc_frame_newslot(*var_pnr);
  params[0] = call2788;
  partcv[0] = 1;
  Object opresult2790 = callmethod(*var_pnr, "<", 1, partcv, params);
// compiled op node returning opresult2790 (depth = 11)
  int op_slot_left_2776 = gc_frame_newslot(opresult2790);
  params[0] = opresult2782;
  partcv[0] = 1;
  Object opresult2791 = callmethod(opresult2790, "||", 1, partcv, params);
// compiled op node returning opresult2791 (depth = 10)
  Object if2775 = done;
  if (istrue(opresult2791)) {
// Begin line 602
  setline(602);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit2793 == NULL) {
    strlit2793 = alloc_String(", ");
    gc_root(strlit2793);
  }
// compiled string node returning strlit2793 (depth = 12)
  int op_slot_right_2792 = gc_frame_newslot(strlit2793);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_s (depth = 12)
  int op_slot_left_2792 = gc_frame_newslot(*var_s);
  params[0] = strlit2793;
  partcv[0] = 1;
  Object opresult2795 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2795 (depth = 11)
  *var_s = opresult2795;
  if (opresult2795 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
    gc_frame_newslot(done);
    if2775 = done;
  } else {
  }
// compiled if node returning if2775 (depth = 9)
  gc_frame_end(frame);
  return if2775;
}
Object meth_ast__apply2725(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_s = getfromclosure(closure, 0);
  Object *var_depth = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 595
  setline(595);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2727 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_part (depth = 10)
  partcv[0] = 0;
  Object call2728 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe2727);
// compiled call node returning call2728 (depth = 9)
// compiled member node returning call2728 (depth = 8)
  int op_slot_right_2726 = gc_frame_newslot(call2728);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_2726 = gc_frame_newslot(*var_s);
  params[0] = call2728;
  partcv[0] = 1;
  Object opresult2730 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2730 (depth = 7)
  *var_s = opresult2730;
  if (opresult2730 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 596
  setline(596);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
  Object bool2735 = alloc_Boolean(0);
// compiled identifier node returning bool2735 (depth = 9)
  int op_slot_right_2734 = gc_frame_newslot(bool2735);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2737 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_part (depth = 11)
  partcv[0] = 0;
  Object call2738 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe2737);
// compiled call node returning call2738 (depth = 10)
// compiled member node returning call2738 (depth = 9)
  int op_slot_left_2734 = gc_frame_newslot(call2738);
  params[0] = bool2735;
  partcv[0] = 1;
  Object opresult2739 = callmethod(call2738, "!=", 1, partcv, params);
// compiled op node returning opresult2739 (depth = 8)
  int op_slot_right_2733 = gc_frame_newslot(opresult2739);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2742 = alloc_Float64(0);
// compiled num node returning num2742 (depth = 9)
  int op_slot_right_2741 = gc_frame_newslot(num2742);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2744 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2745 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_part (depth = 13)
  partcv[0] = 0;
  Object call2746 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe2745);
// compiled call node returning call2746 (depth = 12)
// compiled member node returning call2746 (depth = 11)
  partcv[0] = 0;
  Object call2747 = callmethod(call2746, "size",
    1, partcv, params);
  gc_frame_end(callframe2744);
// compiled call node returning call2747 (depth = 10)
// compiled member node returning call2747 (depth = 9)
  int op_slot_left_2741 = gc_frame_newslot(call2747);
  params[0] = num2742;
  partcv[0] = 1;
  Object opresult2748 = callmethod(call2747, ">", 1, partcv, params);
// compiled op node returning opresult2748 (depth = 8)
  int op_slot_left_2733 = gc_frame_newslot(opresult2748);
  params[0] = opresult2739;
  partcv[0] = 1;
  Object opresult2749 = callmethod(opresult2748, "||", 1, partcv, params);
// compiled op node returning opresult2749 (depth = 7)
  Object if2732 = done;
  if (istrue(opresult2749)) {
// Begin line 597
  setline(597);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2751 == NULL) {
    strlit2751 = alloc_String("(");
    gc_root(strlit2751);
  }
// compiled string node returning strlit2751 (depth = 9)
  int op_slot_right_2750 = gc_frame_newslot(strlit2751);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_2750 = gc_frame_newslot(*var_s);
  params[0] = strlit2751;
  partcv[0] = 1;
  Object opresult2753 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2753 (depth = 8)
  *var_s = opresult2753;
  if (opresult2753 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 598
  setline(598);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2755 = gc_frame_new();
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2756 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2757 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_part (depth = 12)
  partcv[0] = 0;
  Object call2758 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe2757);
// compiled call node returning call2758 (depth = 11)
// compiled member node returning call2758 (depth = 10)
  partcv[0] = 0;
  Object call2759 = callmethod(call2758, "indices",
    1, partcv, params);
  gc_frame_end(callframe2756);
// compiled call node returning call2759 (depth = 9)
// compiled member node returning call2759 (depth = 8)
  gc_frame_newslot(call2759);
// starting to compile block node (depth = 8)
  Object block2760 = alloc_Block(NULL, NULL, "ast", 598);
  gc_frame_newslot(block2760);
// method _apply
  block_savedest(block2760);
  Object closure2761 = createclosure(4, "_apply");
  setclosureframe(closure2761, stackframe);
  addtoclosure(closure2761, var_part);
  addtoclosure(closure2761, var_depth);
  addtoclosure(closure2761, var_s);
  addtoclosure(closure2761, selfslot);
  struct UserObject *uo2761 = (struct UserObject*)block2760;
  uo2761->data[0] = (Object)closure2761;
  Method *meth_meth_ast__apply2761 = addmethod2pos(block2760, "_apply", &meth_ast__apply2761, 0);
  int argcv_meth_ast__apply2761[] = {1};
  meth_meth_ast__apply2761->type = alloc_MethodType(1, argcv_meth_ast__apply2761);
  meth_meth_ast__apply2761->definitionModule = modulename;
  meth_meth_ast__apply2761->definitionLine = 598;
// compiled block node returning block2760 (depth = 8)
  gc_frame_newslot(block2760);
// call case 5: prelude request
  params[0] = call2759;
  params[1] = block2760;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2798 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2755);
// compiled call node returning call2798 (depth = 7)
// Begin line 605
  setline(605);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
  Object bool2801 = alloc_Boolean(0);
// compiled identifier node returning bool2801 (depth = 9)
  int op_slot_right_2800 = gc_frame_newslot(bool2801);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2803 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_part (depth = 11)
  partcv[0] = 0;
  Object call2804 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe2803);
// compiled call node returning call2804 (depth = 10)
// compiled member node returning call2804 (depth = 9)
  int op_slot_left_2800 = gc_frame_newslot(call2804);
  params[0] = bool2801;
  partcv[0] = 1;
  Object opresult2805 = callmethod(call2804, "!=", 1, partcv, params);
// compiled op node returning opresult2805 (depth = 8)
  Object if2799 = done;
  if (istrue(opresult2805)) {
// Begin line 606
  setline(606);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2807 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2808 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_part (depth = 14)
  partcv[0] = 0;
  Object call2809 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe2808);
// compiled call node returning call2809 (depth = 13)
// compiled member node returning call2809 (depth = 12)
  partcv[0] = 0;
  Object call2810 = callmethod(call2809, "value",
    1, partcv, params);
  gc_frame_end(callframe2807);
// compiled call node returning call2810 (depth = 11)
// compiled member node returning call2810 (depth = 10)
  int op_slot_right_2806 = gc_frame_newslot(call2810);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2813 == NULL) {
    strlit2813 = alloc_String("*");
    gc_root(strlit2813);
  }
// compiled string node returning strlit2813 (depth = 11)
  int op_slot_right_2812 = gc_frame_newslot(strlit2813);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_2812 = gc_frame_newslot(*var_s);
  params[0] = strlit2813;
  partcv[0] = 1;
  Object opresult2815 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2815 (depth = 10)
  int op_slot_left_2806 = gc_frame_newslot(opresult2815);
  params[0] = call2810;
  partcv[0] = 1;
  Object opresult2816 = callmethod(opresult2815, "++", 1, partcv, params);
// compiled op node returning opresult2816 (depth = 9)
  *var_s = opresult2816;
  if (opresult2816 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if2799 = done;
  } else {
  }
// compiled if node returning if2799 (depth = 7)
// Begin line 608
  setline(608);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2819 == NULL) {
    strlit2819 = alloc_String(")");
    gc_root(strlit2819);
  }
// compiled string node returning strlit2819 (depth = 9)
  int op_slot_right_2818 = gc_frame_newslot(strlit2819);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_2818 = gc_frame_newslot(*var_s);
  params[0] = strlit2819;
  partcv[0] = 1;
  Object opresult2821 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2821 (depth = 8)
  *var_s = opresult2821;
  if (opresult2821 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if2732 = done;
  } else {
  }
// compiled if node returning if2732 (depth = 6)
  gc_frame_end(frame);
  return if2732;
}
Object meth_ast_toGrace2719(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 593
  setline(593);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2720 == NULL) {
    strlit2720 = alloc_String("");
    gc_root(strlit2720);
  }
// compiled string node returning strlit2720 (depth = 5)
  *var_s = strlit2720;
  if (strlit2720 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 594
  setline(594);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2721 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2722 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2723 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2722);
// compiled call node returning call2723 (depth = 6)
// compiled member node returning call2723 (depth = 5)
  gc_frame_newslot(call2723);
// starting to compile block node (depth = 5)
  Object block2724 = alloc_Block(NULL, NULL, "ast", 594);
  gc_frame_newslot(block2724);
// method _apply
  block_savedest(block2724);
  Object closure2725 = createclosure(3, "_apply");
  setclosureframe(closure2725, stackframe);
  addtoclosure(closure2725, var_s);
  addtoclosure(closure2725, var_depth);
  addtoclosure(closure2725, selfslot);
  struct UserObject *uo2725 = (struct UserObject*)block2724;
  uo2725->data[0] = (Object)closure2725;
  Method *meth_meth_ast__apply2725 = addmethod2pos(block2724, "_apply", &meth_ast__apply2725, 0);
  int argcv_meth_ast__apply2725[] = {1};
  meth_meth_ast__apply2725->type = alloc_MethodType(1, argcv_meth_ast__apply2725);
  meth_meth_ast__apply2725->definitionModule = modulename;
  meth_meth_ast__apply2725->definitionLine = 594;
// compiled block node returning block2724 (depth = 5)
  gc_frame_newslot(block2724);
// call case 5: prelude request
  params[0] = call2723;
  params[1] = block2724;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2824 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2721);
// compiled call node returning call2824 (depth = 4)
// Begin line 611
  setline(611);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool2827 = alloc_Boolean(0);
// compiled identifier node returning bool2827 (depth = 6)
  int op_slot_right_2826 = gc_frame_newslot(bool2827);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2829 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2830 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2829);
// compiled call node returning call2830 (depth = 7)
// compiled member node returning call2830 (depth = 6)
  int op_slot_left_2826 = gc_frame_newslot(call2830);
  params[0] = bool2827;
  partcv[0] = 1;
  Object opresult2831 = callmethod(call2830, "!=", 1, partcv, params);
// compiled op node returning opresult2831 (depth = 5)
  Object if2825 = done;
  if (istrue(opresult2831)) {
// Begin line 612
  setline(612);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2833 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2835 = alloc_Float64(1);
// compiled num node returning num2835 (depth = 9)
  int op_slot_right_2834 = gc_frame_newslot(num2835);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_2834 = gc_frame_newslot(*var_depth);
  params[0] = num2835;
  partcv[0] = 1;
  Object sum2837 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2837 (depth = 8)
  gc_frame_newslot(sum2837);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2838 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2839 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2838);
// compiled call node returning call2839 (depth = 9)
// compiled member node returning call2839 (depth = 8)
  params[0] = sum2837;
  partcv[0] = 1;
  Object call2840 = callmethod(call2839, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe2833);
// compiled call node returning call2840 (depth = 7)
  int op_slot_right_2832 = gc_frame_newslot(call2840);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2843 == NULL) {
    strlit2843 = alloc_String(" -> ");
    gc_root(strlit2843);
  }
// compiled string node returning strlit2843 (depth = 8)
  int op_slot_right_2842 = gc_frame_newslot(strlit2843);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_2842 = gc_frame_newslot(*var_s);
  params[0] = strlit2843;
  partcv[0] = 1;
  Object opresult2845 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2845 (depth = 7)
  int op_slot_left_2832 = gc_frame_newslot(opresult2845);
  params[0] = call2840;
  partcv[0] = 1;
  Object opresult2846 = callmethod(opresult2845, "++", 1, partcv, params);
// compiled op node returning opresult2846 (depth = 6)
  *var_s = opresult2846;
  if (opresult2846 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if2825 = done;
  } else {
  }
// compiled if node returning if2825 (depth = 4)
// Begin line 614
  setline(614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy2848(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_methodTypeNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 617
  setline(617);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2849 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe2850 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2851 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2852 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2851);
// compiled call node returning call2852 (depth = 7)
// compiled member node returning call2852 (depth = 6)
  gc_frame_newslot(call2852);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_emptySeq (depth = 6)
  gc_frame_newslot(*var_emptySeq);
// starting to compile identifier node (depth = 6)
  Object bool2853 = alloc_Boolean(0);
// compiled identifier node returning bool2853 (depth = 6)
  gc_frame_newslot(bool2853);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_methodTypeNode (depth = 6)
  params[0] = call2852;
  params[1] = *var_emptySeq;
  params[2] = bool2853;
  partcv[0] = 3;
  Object call2854 = callmethod(*var_methodTypeNode, "new",
    1, partcv, params);
  gc_frame_end(callframe2850);
// compiled call node returning call2854 (depth = 5)
  params[0] = self;
  partcv[0] = 1;
  Object call2855 = callmethod(call2854, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe2849);
// compiled call node returning call2855 (depth = 4)
  gc_frame_end(frame);
  return call2855;
}
Object meth_ast_new2433(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_methodTypeNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_signature_39_ = &(stackframe->slots[1]);
  *var_signature_39_ = args[curarg];
  curarg++;
  Object *var_rtype_39_ = &(stackframe->slots[2]);
  *var_rtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2434 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2434 = alloc_userobj2(19,16, objclass2434);
  gc_frame_newslot(obj2434);
if (objclass2434 == NULL) {
  glfree(obj2434->class->name);
  obj2434->class->name = "methodTypeNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2434, self, 0);
  addmethodreal(obj2434,"outer", &reader_ast_outer_2435);
  Object oldself2434 = self;
  struct StackFrameObject *oldstackframe2434 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2434);
  gc_frame_newslot((Object)stackframe);
  self = obj2434;
  Object *oldselfslot2434 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2434 = (*(struct UserObject *)self).data[0], lowerouter2434 = thisouter2434;
  if (inheritingObject2434) {
    struct UserObject *inho2434 = (struct UserObject *)inheritingObject2434;
    while (inho2434->super != GraceDefaultObject) inho2434 = (struct UserObject *)inho2434->super;
    inho2434->super = obj2434;
    self = inheritingObject2434;
    *selfslot = self;
    lowerouter2434 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2434;
  }
if (objclass2434 == NULL) {
  Method *reader2436 = addmethodrealflags(obj2434, "kind",&reader_ast_kind_2436, MFLAG_DEF);
  reader2436->definitionModule = modulename;
  reader2436->definitionLine = 531;
}
adddatum2(obj2434, alloc_Undefined(), 1);
if (objclass2434 == NULL) {
  Method *reader2437 = addmethodrealflags(obj2434, "value",&reader_ast_value_2437, 0);
  Method *writer2437 = addmethodrealflags(obj2434, "value:=",&writer_ast_value_2437, 0);
  reader2437->definitionModule = modulename;
  writer2437->definitionModule = modulename;
  reader2437->definitionLine = 532;
  writer2437->definitionLine = 532;
}
obj2434->flags |= OFLAG_MUTABLE;
adddatum2(obj2434, alloc_Undefined(), 2);
if (objclass2434 == NULL) {
  Method *reader2438 = addmethodrealflags(obj2434, "signature",&reader_ast_signature_2438, 0);
  Method *writer2438 = addmethodrealflags(obj2434, "signature:=",&writer_ast_signature_2438, 0);
  reader2438->definitionModule = modulename;
  writer2438->definitionModule = modulename;
  reader2438->definitionLine = 533;
  writer2438->definitionLine = 533;
}
obj2434->flags |= OFLAG_MUTABLE;
adddatum2(obj2434, alloc_Undefined(), 3);
if (objclass2434 == NULL) {
  Method *reader2439 = addmethodrealflags(obj2434, "rtype",&reader_ast_rtype_2439, 0);
  Method *writer2439 = addmethodrealflags(obj2434, "rtype:=",&writer_ast_rtype_2439, 0);
  reader2439->definitionModule = modulename;
  writer2439->definitionModule = modulename;
  reader2439->definitionLine = 534;
  writer2439->definitionLine = 534;
}
obj2434->flags |= OFLAG_MUTABLE;
adddatum2(obj2434, alloc_Undefined(), 4);
if (objclass2434 == NULL) {
  Method *reader2440 = addmethodrealflags(obj2434, "generics",&reader_ast_generics_2440, 0);
  Method *writer2440 = addmethodrealflags(obj2434, "generics:=",&writer_ast_generics_2440, 0);
  reader2440->definitionModule = modulename;
  writer2440->definitionModule = modulename;
  reader2440->definitionLine = 535;
  writer2440->definitionLine = 535;
}
obj2434->flags |= OFLAG_MUTABLE;
adddatum2(obj2434, alloc_Undefined(), 5);
if (objclass2434 == NULL) {
  Method *reader2441 = addmethodrealflags(obj2434, "nameString",&reader_ast_nameString_2441, MFLAG_DEF);
  reader2441->definitionModule = modulename;
  reader2441->definitionLine = 536;
}
adddatum2(obj2434, alloc_Undefined(), 6);
// method parametersDo
  struct UserObject *uo2442 = (struct UserObject*)obj2434;
  uo2442->data[7] = emptyclosure;
  Method *meth_meth_ast_parametersDo2442 = addmethod2pos(obj2434, "parametersDo", &meth_ast_parametersDo2442, 7);
  int argcv_meth_ast_parametersDo2442[] = {1};
  meth_meth_ast_parametersDo2442->type = alloc_MethodType(1, argcv_meth_ast_parametersDo2442);
  meth_meth_ast_parametersDo2442->definitionModule = modulename;
  meth_meth_ast_parametersDo2442->definitionLine = 538;
// method scope:=
  struct UserObject *uo2459 = (struct UserObject*)obj2434;
  uo2459->data[8] = emptyclosure;
  Method *meth_meth_ast_scope_58__61_2459 = addmethod2pos(obj2434, "scope:=", &meth_ast_scope_58__61_2459, 8);
  int argcv_meth_ast_scope_58__61_2459[] = {1};
  meth_meth_ast_scope_58__61_2459->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61_2459);
  meth_meth_ast_scope_58__61_2459->definitionModule = modulename;
  meth_meth_ast_scope_58__61_2459->definitionLine = 543;
// method declarationKindWithAncestors
  struct UserObject *uo2464 = (struct UserObject*)obj2434;
  uo2464->data[9] = emptyclosure;
  Method *meth_meth_ast_declarationKindWithAncestors2464 = addmethod2pos(obj2434, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors2464, 9);
  int argcv_meth_ast_declarationKindWithAncestors2464[] = {1};
  meth_meth_ast_declarationKindWithAncestors2464->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors2464);
  meth_meth_ast_declarationKindWithAncestors2464->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors2464->definitionLine = 549;
// method accept()from
  struct UserObject *uo2466 = (struct UserObject*)obj2434;
  uo2466->data[10] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from2466 = addmethod2pos(obj2434, "accept()from", &meth_ast_accept_40__41_from2466, 10);
  int argcv_meth_ast_accept_40__41_from2466[] = {1, 1};
  meth_meth_ast_accept_40__41_from2466->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from2466);
  meth_meth_ast_accept_40__41_from2466->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from2466->definitionLine = 550;
// method map()ancestors
  struct UserObject *uo2503 = (struct UserObject*)obj2434;
  uo2503->data[11] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors2503 = addmethod2pos(obj2434, "map()ancestors", &meth_ast_map_40__41_ancestors2503, 11);
  int argcv_meth_ast_map_40__41_ancestors2503[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors2503->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors2503);
  meth_meth_ast_map_40__41_ancestors2503->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors2503->definitionLine = 564;
// method pretty
  struct UserObject *uo2540 = (struct UserObject*)obj2434;
  uo2540->data[12] = emptyclosure;
  Method *meth_meth_ast_pretty2540 = addmethod2pos(obj2434, "pretty", &meth_ast_pretty2540, 12);
  int argcv_meth_ast_pretty2540[] = {1};
  meth_meth_ast_pretty2540->type = alloc_MethodType(1, argcv_meth_ast_pretty2540);
  meth_meth_ast_pretty2540->definitionModule = modulename;
  meth_meth_ast_pretty2540->definitionLine = 572;
// method toGrace
  struct UserObject *uo2719 = (struct UserObject*)obj2434;
  uo2719->data[13] = emptyclosure;
  Method *meth_meth_ast_toGrace2719 = addmethod2pos(obj2434, "toGrace", &meth_ast_toGrace2719, 13);
  int argcv_meth_ast_toGrace2719[] = {1};
  meth_meth_ast_toGrace2719->type = alloc_MethodType(1, argcv_meth_ast_toGrace2719);
meth_meth_ast_toGrace2719->type->types[0] = type_Number;
meth_meth_ast_toGrace2719->type->names[0] = "depth";
  meth_meth_ast_toGrace2719->definitionModule = modulename;
  meth_meth_ast_toGrace2719->definitionLine = 592;
// method shallowCopy
  block_savedest(obj2434);
  Object closure2848 = createclosure(2, "shallowCopy");
  setclosureframe(closure2848, stackframe);
  addtoclosure(closure2848, var_emptySeq);
  addtoclosure(closure2848, var_methodTypeNode);
  struct UserObject *uo2848 = (struct UserObject*)obj2434;
  uo2848->data[14] = (Object)closure2848;
  Method *meth_meth_ast_shallowCopy2848 = addmethod2pos(obj2434, "shallowCopy", &meth_ast_shallowCopy2848, 14);
  int argcv_meth_ast_shallowCopy2848[] = {0};
  meth_meth_ast_shallowCopy2848->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy2848);
  meth_meth_ast_shallowCopy2848->definitionModule = modulename;
  meth_meth_ast_shallowCopy2848->definitionLine = 616;
  sourceObject = obj2434;
// Begin line 530
  setline(530);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2856 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2857 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe2856);
// compiled call node returning call2857 (depth = 4)
  struct UserObject *obj2434_uo = (struct UserObject *)obj2434;
  obj2434_uo->super = call2857;
  sourceObject = obj2434;
// Begin line 531
  setline(531);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit2858 == NULL) {
    strlit2858 = alloc_String("methodtype");
    gc_root(strlit2858);
  }
// compiled string node returning strlit2858 (depth = 4)
  adddatum2(obj2434, strlit2858, 1);
  sourceObject = obj2434;
// Begin line 532
  setline(532);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_name_39_ (depth = 4)
  adddatum2(obj2434, *var_name_39_, 2);
  sourceObject = obj2434;
// Begin line 533
  setline(533);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_signature_39_ (depth = 4)
  adddatum2(obj2434, *var_signature_39_, 3);
  sourceObject = obj2434;
// Begin line 534
  setline(534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_rtype_39_ (depth = 4)
  adddatum2(obj2434, *var_rtype_39_, 4);
  sourceObject = obj2434;
// Begin line 535
  setline(535);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool2859 = alloc_Boolean(0);
// compiled identifier node returning bool2859 (depth = 4)
  adddatum2(obj2434, bool2859, 5);
  sourceObject = obj2434;
// Begin line 536
  setline(536);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2860 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2861 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2860);
// compiled call node returning call2861 (depth = 5)
// compiled member node returning call2861 (depth = 4)
  adddatum2(obj2434, call2861, 6);
  sourceObject = obj2434;
  sourceObject = obj2434;
  sourceObject = obj2434;
  sourceObject = obj2434;
  sourceObject = obj2434;
  sourceObject = obj2434;
  sourceObject = obj2434;
  sourceObject = obj2434;
  objclass2434 = obj2434->class;
  objclass2434->definitionModule = modulename;
  objclass2434->definitionLine = 513;
  (*(struct UserObject *)self).data[0] = lowerouter2434;
  self = oldself2434;
  selfslot = oldselfslot2434;
  stackframe = oldstackframe2434;
  gc_frame_end(frame);
  return obj2434;
}
Object meth_ast_new2433_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_methodTypeNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_signature_39_ = &(stackframe->slots[1]);
  *var_signature_39_ = args[curarg];
  curarg++;
  Object *var_rtype_39_ = &(stackframe->slots[2]);
  *var_rtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2434 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2434 = alloc_userobj2(19,16, objclass2434);
  gc_frame_newslot(obj2434);
if (objclass2434 == NULL) {
  glfree(obj2434->class->name);
  obj2434->class->name = "methodTypeNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2434, self, 0);
  addmethodreal(obj2434,"outer", &reader_ast_outer_2435);
  Object oldself2434 = self;
  struct StackFrameObject *oldstackframe2434 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2434);
  gc_frame_newslot((Object)stackframe);
  self = obj2434;
  Object *oldselfslot2434 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2434 = (*(struct UserObject *)self).data[0], lowerouter2434 = thisouter2434;
  if (inheritingObject2434) {
    struct UserObject *inho2434 = (struct UserObject *)inheritingObject2434;
    while (inho2434->super != GraceDefaultObject) inho2434 = (struct UserObject *)inho2434->super;
    inho2434->super = obj2434;
    self = inheritingObject2434;
    *selfslot = self;
    lowerouter2434 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2434;
  }
if (objclass2434 == NULL) {
  Method *reader2436 = addmethodrealflags(obj2434, "kind",&reader_ast_kind_2436, MFLAG_DEF);
  reader2436->definitionModule = modulename;
  reader2436->definitionLine = 531;
}
adddatum2(obj2434, alloc_Undefined(), 1);
if (objclass2434 == NULL) {
  Method *reader2437 = addmethodrealflags(obj2434, "value",&reader_ast_value_2437, 0);
  Method *writer2437 = addmethodrealflags(obj2434, "value:=",&writer_ast_value_2437, 0);
  reader2437->definitionModule = modulename;
  writer2437->definitionModule = modulename;
  reader2437->definitionLine = 532;
  writer2437->definitionLine = 532;
}
obj2434->flags |= OFLAG_MUTABLE;
adddatum2(obj2434, alloc_Undefined(), 2);
if (objclass2434 == NULL) {
  Method *reader2438 = addmethodrealflags(obj2434, "signature",&reader_ast_signature_2438, 0);
  Method *writer2438 = addmethodrealflags(obj2434, "signature:=",&writer_ast_signature_2438, 0);
  reader2438->definitionModule = modulename;
  writer2438->definitionModule = modulename;
  reader2438->definitionLine = 533;
  writer2438->definitionLine = 533;
}
obj2434->flags |= OFLAG_MUTABLE;
adddatum2(obj2434, alloc_Undefined(), 3);
if (objclass2434 == NULL) {
  Method *reader2439 = addmethodrealflags(obj2434, "rtype",&reader_ast_rtype_2439, 0);
  Method *writer2439 = addmethodrealflags(obj2434, "rtype:=",&writer_ast_rtype_2439, 0);
  reader2439->definitionModule = modulename;
  writer2439->definitionModule = modulename;
  reader2439->definitionLine = 534;
  writer2439->definitionLine = 534;
}
obj2434->flags |= OFLAG_MUTABLE;
adddatum2(obj2434, alloc_Undefined(), 4);
if (objclass2434 == NULL) {
  Method *reader2440 = addmethodrealflags(obj2434, "generics",&reader_ast_generics_2440, 0);
  Method *writer2440 = addmethodrealflags(obj2434, "generics:=",&writer_ast_generics_2440, 0);
  reader2440->definitionModule = modulename;
  writer2440->definitionModule = modulename;
  reader2440->definitionLine = 535;
  writer2440->definitionLine = 535;
}
obj2434->flags |= OFLAG_MUTABLE;
adddatum2(obj2434, alloc_Undefined(), 5);
if (objclass2434 == NULL) {
  Method *reader2441 = addmethodrealflags(obj2434, "nameString",&reader_ast_nameString_2441, MFLAG_DEF);
  reader2441->definitionModule = modulename;
  reader2441->definitionLine = 536;
}
adddatum2(obj2434, alloc_Undefined(), 6);
// method parametersDo
  struct UserObject *uo2442 = (struct UserObject*)obj2434;
  uo2442->data[7] = emptyclosure;
  Method *meth_meth_ast_parametersDo2442 = addmethod2pos(obj2434, "parametersDo", &meth_ast_parametersDo2442, 7);
  int argcv_meth_ast_parametersDo2442[] = {1};
  meth_meth_ast_parametersDo2442->type = alloc_MethodType(1, argcv_meth_ast_parametersDo2442);
  meth_meth_ast_parametersDo2442->definitionModule = modulename;
  meth_meth_ast_parametersDo2442->definitionLine = 538;
// method scope:=
  struct UserObject *uo2459 = (struct UserObject*)obj2434;
  uo2459->data[8] = emptyclosure;
  Method *meth_meth_ast_scope_58__61_2459 = addmethod2pos(obj2434, "scope:=", &meth_ast_scope_58__61_2459, 8);
  int argcv_meth_ast_scope_58__61_2459[] = {1};
  meth_meth_ast_scope_58__61_2459->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61_2459);
  meth_meth_ast_scope_58__61_2459->definitionModule = modulename;
  meth_meth_ast_scope_58__61_2459->definitionLine = 543;
// method declarationKindWithAncestors
  struct UserObject *uo2464 = (struct UserObject*)obj2434;
  uo2464->data[9] = emptyclosure;
  Method *meth_meth_ast_declarationKindWithAncestors2464 = addmethod2pos(obj2434, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors2464, 9);
  int argcv_meth_ast_declarationKindWithAncestors2464[] = {1};
  meth_meth_ast_declarationKindWithAncestors2464->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors2464);
  meth_meth_ast_declarationKindWithAncestors2464->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors2464->definitionLine = 549;
// method accept()from
  struct UserObject *uo2466 = (struct UserObject*)obj2434;
  uo2466->data[10] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from2466 = addmethod2pos(obj2434, "accept()from", &meth_ast_accept_40__41_from2466, 10);
  int argcv_meth_ast_accept_40__41_from2466[] = {1, 1};
  meth_meth_ast_accept_40__41_from2466->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from2466);
  meth_meth_ast_accept_40__41_from2466->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from2466->definitionLine = 550;
// method map()ancestors
  struct UserObject *uo2503 = (struct UserObject*)obj2434;
  uo2503->data[11] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors2503 = addmethod2pos(obj2434, "map()ancestors", &meth_ast_map_40__41_ancestors2503, 11);
  int argcv_meth_ast_map_40__41_ancestors2503[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors2503->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors2503);
  meth_meth_ast_map_40__41_ancestors2503->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors2503->definitionLine = 564;
// method pretty
  struct UserObject *uo2540 = (struct UserObject*)obj2434;
  uo2540->data[12] = emptyclosure;
  Method *meth_meth_ast_pretty2540 = addmethod2pos(obj2434, "pretty", &meth_ast_pretty2540, 12);
  int argcv_meth_ast_pretty2540[] = {1};
  meth_meth_ast_pretty2540->type = alloc_MethodType(1, argcv_meth_ast_pretty2540);
  meth_meth_ast_pretty2540->definitionModule = modulename;
  meth_meth_ast_pretty2540->definitionLine = 572;
// method toGrace
  struct UserObject *uo2719 = (struct UserObject*)obj2434;
  uo2719->data[13] = emptyclosure;
  Method *meth_meth_ast_toGrace2719 = addmethod2pos(obj2434, "toGrace", &meth_ast_toGrace2719, 13);
  int argcv_meth_ast_toGrace2719[] = {1};
  meth_meth_ast_toGrace2719->type = alloc_MethodType(1, argcv_meth_ast_toGrace2719);
meth_meth_ast_toGrace2719->type->types[0] = type_Number;
meth_meth_ast_toGrace2719->type->names[0] = "depth";
  meth_meth_ast_toGrace2719->definitionModule = modulename;
  meth_meth_ast_toGrace2719->definitionLine = 592;
// method shallowCopy
  block_savedest(obj2434);
  Object closure2848 = createclosure(2, "shallowCopy");
  setclosureframe(closure2848, stackframe);
  addtoclosure(closure2848, var_emptySeq);
  addtoclosure(closure2848, var_methodTypeNode);
  struct UserObject *uo2848 = (struct UserObject*)obj2434;
  uo2848->data[14] = (Object)closure2848;
  Method *meth_meth_ast_shallowCopy2848 = addmethod2pos(obj2434, "shallowCopy", &meth_ast_shallowCopy2848, 14);
  int argcv_meth_ast_shallowCopy2848[] = {0};
  meth_meth_ast_shallowCopy2848->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy2848);
  meth_meth_ast_shallowCopy2848->definitionModule = modulename;
  meth_meth_ast_shallowCopy2848->definitionLine = 616;
  sourceObject = obj2434;
// Begin line 530
  setline(530);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2856 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2857 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe2856);
// compiled call node returning call2857 (depth = 4)
  struct UserObject *obj2434_uo = (struct UserObject *)obj2434;
  obj2434_uo->super = call2857;
  sourceObject = obj2434;
// Begin line 531
  setline(531);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit2858 == NULL) {
    strlit2858 = alloc_String("methodtype");
    gc_root(strlit2858);
  }
// compiled string node returning strlit2858 (depth = 4)
  adddatum2(obj2434, strlit2858, 1);
  sourceObject = obj2434;
// Begin line 532
  setline(532);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_name_39_ (depth = 4)
  adddatum2(obj2434, *var_name_39_, 2);
  sourceObject = obj2434;
// Begin line 533
  setline(533);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_signature_39_ (depth = 4)
  adddatum2(obj2434, *var_signature_39_, 3);
  sourceObject = obj2434;
// Begin line 534
  setline(534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_rtype_39_ (depth = 4)
  adddatum2(obj2434, *var_rtype_39_, 4);
  sourceObject = obj2434;
// Begin line 535
  setline(535);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool2859 = alloc_Boolean(0);
// compiled identifier node returning bool2859 (depth = 4)
  adddatum2(obj2434, bool2859, 5);
  sourceObject = obj2434;
// Begin line 536
  setline(536);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2860 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2861 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2860);
// compiled call node returning call2861 (depth = 5)
// compiled member node returning call2861 (depth = 4)
  adddatum2(obj2434, call2861, 6);
  sourceObject = obj2434;
  sourceObject = obj2434;
  sourceObject = obj2434;
  sourceObject = obj2434;
  sourceObject = obj2434;
  sourceObject = obj2434;
  sourceObject = obj2434;
  sourceObject = obj2434;
  objclass2434 = obj2434->class;
  objclass2434->definitionModule = modulename;
  objclass2434->definitionLine = 513;
  (*(struct UserObject *)self).data[0] = lowerouter2434;
  self = oldself2434;
  selfslot = oldselfslot2434;
  stackframe = oldstackframe2434;
  gc_frame_end(frame);
  return obj2434;
}
Object meth_ast_typeLiteralNode2863(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeLiteralNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_typeLiteralNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for typeLiteralNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for typeLiteralNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_typeLiteralNode (depth = 3)
  gc_frame_end(frame);
  return *var_typeLiteralNode;
}
Object meth_ast_name2875(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "name");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for name (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for name");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 629
  setline(629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2876 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2877 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2876);
// compiled call node returning call2877 (depth = 5)
// compiled member node returning call2877 (depth = 4)
  gc_frame_end(frame);
  return call2877;
}
Object meth_ast_name_58__61_2878(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "name:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method name:=");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for name:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for name:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 631
  setline(631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 629
  setline(629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2879 = gc_frame_new();
// Begin line 631
  setline(631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 4: self request
  params[0] = *var_n;
  partcv[0] = 1;
  Object call2880 = callmethodflags(self, "value:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2879);
// compiled call node returning call2880 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 632
  setline(632);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 629
  setline(629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2881 = gc_frame_new();
// Begin line 632
  setline(632);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool2882 = alloc_Boolean(0);
// compiled identifier node returning bool2882 (depth = 6)
  gc_frame_newslot(bool2882);
// call case 4: self request
  params[0] = bool2882;
  partcv[0] = 1;
  Object call2883 = callmethodflags(self, "anonymous:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2881);
// compiled call node returning call2883 (depth = 5)
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_asString2884(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 635
  setline(635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2886 == NULL) {
    strlit2886 = alloc_String("");
    gc_root(strlit2886);
  }
// compiled string node returning strlit2886 (depth = 5)
  int op_slot_right_2885 = gc_frame_newslot(strlit2886);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2889 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2890 = callmethodflags(self, "types", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2889);
// compiled call node returning call2890 (depth = 7)
// compiled member node returning call2890 (depth = 6)
  int op_slot_right_2888 = gc_frame_newslot(call2890);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2893 == NULL) {
    strlit2893 = alloc_String(", types = ");
    gc_root(strlit2893);
  }
// compiled string node returning strlit2893 (depth = 7)
  int op_slot_right_2892 = gc_frame_newslot(strlit2893);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2896 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2897 = callmethodflags(self, "methods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2896);
// compiled call node returning call2897 (depth = 9)
// compiled member node returning call2897 (depth = 8)
  int op_slot_right_2895 = gc_frame_newslot(call2897);
// starting to compile string node (depth = 8)
  if (strlit2899 == NULL) {
    strlit2899 = alloc_String("typeliteral: methods = ");
    gc_root(strlit2899);
  }
// compiled string node returning strlit2899 (depth = 8)
  int op_slot_left_2895 = gc_frame_newslot(strlit2899);
  params[0] = call2897;
  partcv[0] = 1;
  Object opresult2900 = callmethod(strlit2899, "++", 1, partcv, params);
// compiled op node returning opresult2900 (depth = 7)
  int op_slot_left_2892 = gc_frame_newslot(opresult2900);
  params[0] = strlit2893;
  partcv[0] = 1;
  Object opresult2901 = callmethod(opresult2900, "++", 1, partcv, params);
// compiled op node returning opresult2901 (depth = 6)
  int op_slot_left_2888 = gc_frame_newslot(opresult2901);
  params[0] = call2890;
  partcv[0] = 1;
  Object opresult2902 = callmethod(opresult2901, "++", 1, partcv, params);
// compiled op node returning opresult2902 (depth = 5)
  int op_slot_left_2885 = gc_frame_newslot(opresult2902);
  params[0] = strlit2886;
  partcv[0] = 1;
  Object opresult2903 = callmethod(opresult2902, "++", 1, partcv, params);
// compiled op node returning opresult2903 (depth = 4)
  gc_frame_end(frame);
  return opresult2903;
}
Object meth_ast__apply2914(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 641
  setline(641);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2915 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_visitor (depth = 8)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_newChain (depth = 8)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2916 = callmethod(*var_each, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe2915);
// compiled call node returning call2916 (depth = 7)
  gc_frame_end(frame);
  return call2916;
}
Object meth_ast__apply2923(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 644
  setline(644);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2924 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_visitor (depth = 8)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_newChain (depth = 8)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2925 = callmethod(*var_each, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe2924);
// compiled call node returning call2925 (depth = 7)
  gc_frame_end(frame);
  return call2925;
}
Object meth_ast_accept_40__41_from2904(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 638
  setline(638);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2906 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2907 = callmethod(*var_visitor, "visitTypeLiteral()up",
    2, partcv, params);
  gc_frame_end(callframe2906);
// compiled call node returning call2907 (depth = 5)
  Object if2905 = done;
  if (istrue(call2907)) {
// Begin line 639
  setline(639);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2908 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_as (depth = 7)
  params[0] = self;
  partcv[0] = 1;
  Object call2909 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe2908);
// compiled call node returning call2909 (depth = 6)
  *var_newChain = call2909;
  if (call2909 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 640
  setline(640);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2910 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2911 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2912 = callmethodflags(self, "methods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2911);
// compiled call node returning call2912 (depth = 7)
// compiled member node returning call2912 (depth = 6)
  gc_frame_newslot(call2912);
// starting to compile block node (depth = 6)
  Object block2913 = alloc_Block(NULL, NULL, "ast", 640);
  gc_frame_newslot(block2913);
// method _apply
  block_savedest(block2913);
  Object closure2914 = createclosure(3, "_apply");
  setclosureframe(closure2914, stackframe);
  addtoclosure(closure2914, var_visitor);
  addtoclosure(closure2914, var_newChain);
  addtoclosure(closure2914, selfslot);
  struct UserObject *uo2914 = (struct UserObject*)block2913;
  uo2914->data[0] = (Object)closure2914;
  Method *meth_meth_ast__apply2914 = addmethod2pos(block2913, "_apply", &meth_ast__apply2914, 0);
  int argcv_meth_ast__apply2914[] = {1};
  meth_meth_ast__apply2914->type = alloc_MethodType(1, argcv_meth_ast__apply2914);
  meth_meth_ast__apply2914->definitionModule = modulename;
  meth_meth_ast__apply2914->definitionLine = 640;
// compiled block node returning block2913 (depth = 6)
  gc_frame_newslot(block2913);
// call case 5: prelude request
  params[0] = call2912;
  params[1] = block2913;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2918 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2910);
// compiled call node returning call2918 (depth = 5)
// Begin line 643
  setline(643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2919 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2920 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2921 = callmethodflags(self, "types", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2920);
// compiled call node returning call2921 (depth = 7)
// compiled member node returning call2921 (depth = 6)
  gc_frame_newslot(call2921);
// starting to compile block node (depth = 6)
  Object block2922 = alloc_Block(NULL, NULL, "ast", 643);
  gc_frame_newslot(block2922);
// method _apply
  block_savedest(block2922);
  Object closure2923 = createclosure(3, "_apply");
  setclosureframe(closure2923, stackframe);
  addtoclosure(closure2923, var_visitor);
  addtoclosure(closure2923, var_newChain);
  addtoclosure(closure2923, selfslot);
  struct UserObject *uo2923 = (struct UserObject*)block2922;
  uo2923->data[0] = (Object)closure2923;
  Method *meth_meth_ast__apply2923 = addmethod2pos(block2922, "_apply", &meth_ast__apply2923, 0);
  int argcv_meth_ast__apply2923[] = {1};
  meth_meth_ast__apply2923->type = alloc_MethodType(1, argcv_meth_ast__apply2923);
  meth_meth_ast__apply2923->definitionModule = modulename;
  meth_meth_ast__apply2923->definitionLine = 643;
// compiled block node returning block2922 (depth = 6)
  gc_frame_newslot(block2922);
// call case 5: prelude request
  params[0] = call2921;
  params[1] = block2922;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2927 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2919);
// compiled call node returning call2927 (depth = 5)
    gc_frame_newslot(call2927);
    if2905 = call2927;
  } else {
  }
// compiled if node returning if2905 (depth = 4)
  gc_frame_end(frame);
  return if2905;
}
Object meth_ast_map_40__41_ancestors2928(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 649
  setline(649);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2929 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2930 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2929);
// compiled call node returning call2930 (depth = 6)
// compiled member node returning call2930 (depth = 5)
  *var_n = call2930;
  if (call2930 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 650
  setline(650);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2931 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call2932 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe2931);
// compiled call node returning call2932 (depth = 5)
  *var_newChain = call2932;
  if (call2932 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 651
  setline(651);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 649
  setline(649);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2933 = gc_frame_new();
// Begin line 651
  setline(651);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2934 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2935 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2936 = callmethodflags(self, "methods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2935);
// compiled call node returning call2936 (depth = 8)
// compiled member node returning call2936 (depth = 7)
  gc_frame_newslot(call2936);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_as (depth = 7)
  gc_frame_newslot(*var_as);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2937 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2938 = gc_frame_new();
// call case 3: self.outer request
  Object call2939 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2938);
// compiled call node returning call2939 (depth = 10)
// compiled member node returning call2939 (depth = 9)
  partcv[0] = 0;
  Object call2940 = callmethodflags(call2939, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2937);
// compiled call node returning call2940 (depth = 8)
// compiled member node returning call2940 (depth = 7)
  params[0] = call2936;
  params[1] = *var_blk;
  params[2] = *var_as;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2941 = callmethodflags(call2940, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2934);
// compiled call node returning call2941 (depth = 6)
  gc_frame_newslot(call2941);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call2941;
  partcv[0] = 1;
  Object call2942 = callmethod(*var_n, "methods:=",
    1, partcv, params);
  gc_frame_end(callframe2933);
// compiled call node returning call2942 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 652
  setline(652);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 651
  setline(651);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2943 = gc_frame_new();
// Begin line 652
  setline(652);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2944 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2945 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2946 = callmethodflags(self, "types", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2945);
// compiled call node returning call2946 (depth = 8)
// compiled member node returning call2946 (depth = 7)
  gc_frame_newslot(call2946);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_as (depth = 7)
  gc_frame_newslot(*var_as);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2947 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2948 = gc_frame_new();
// call case 3: self.outer request
  Object call2949 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2948);
// compiled call node returning call2949 (depth = 10)
// compiled member node returning call2949 (depth = 9)
  partcv[0] = 0;
  Object call2950 = callmethodflags(call2949, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2947);
// compiled call node returning call2950 (depth = 8)
// compiled member node returning call2950 (depth = 7)
  params[0] = call2946;
  params[1] = *var_blk;
  params[2] = *var_as;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2951 = callmethodflags(call2950, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2944);
// compiled call node returning call2951 (depth = 6)
  gc_frame_newslot(call2951);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call2951;
  partcv[0] = 1;
  Object call2952 = callmethod(*var_n, "types:=",
    1, partcv, params);
  gc_frame_end(callframe2943);
// compiled call node returning call2952 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 653
  setline(653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2953 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call2954 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe2953);
// compiled call node returning call2954 (depth = 4)
  gc_frame_end(frame);
  return call2954;
}
Object meth_ast__apply2963(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 658
  setline(658);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2965 == NULL) {
    strlit2965 = alloc_String("  ");
    gc_root(strlit2965);
  }
// compiled string node returning strlit2965 (depth = 8)
  int op_slot_right_2964 = gc_frame_newslot(strlit2965);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_2964 = gc_frame_newslot(*var_spc);
  params[0] = strlit2965;
  partcv[0] = 1;
  Object opresult2967 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult2967 (depth = 7)
  *var_spc = opresult2967;
  if (opresult2967 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply2993(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 663
  setline(663);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2995 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num2997 = alloc_Float64(2);
// compiled num node returning num2997 (depth = 10)
  int op_slot_right_2996 = gc_frame_newslot(num2997);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_2996 = gc_frame_newslot(*var_depth);
  params[0] = num2997;
  partcv[0] = 1;
  Object sum2999 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2999 (depth = 9)
  gc_frame_newslot(sum2999);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_each (depth = 9)
  params[0] = sum2999;
  partcv[0] = 1;
  Object call3000 = callmethod(*var_each, "pretty",
    1, partcv, params);
  gc_frame_end(callframe2995);
// compiled call node returning call3000 (depth = 8)
  int op_slot_right_2994 = gc_frame_newslot(call3000);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_3002 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3005 == NULL) {
    strlit3005 = alloc_String("""\x0a""  ");
    gc_root(strlit3005);
  }
// compiled string node returning strlit3005 (depth = 10)
  int op_slot_right_3004 = gc_frame_newslot(strlit3005);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_3004 = gc_frame_newslot(*var_s);
  params[0] = strlit3005;
  partcv[0] = 1;
  Object opresult3007 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3007 (depth = 9)
  int op_slot_left_3002 = gc_frame_newslot(opresult3007);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3008 = callmethod(opresult3007, "++", 1, partcv, params);
// compiled op node returning opresult3008 (depth = 8)
  int op_slot_left_2994 = gc_frame_newslot(opresult3008);
  params[0] = call3000;
  partcv[0] = 1;
  Object opresult3009 = callmethod(opresult3008, "++", 1, partcv, params);
// compiled op node returning opresult3009 (depth = 7)
  *var_s = opresult3009;
  if (opresult3009 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply3029(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 667
  setline(667);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3031 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num3033 = alloc_Float64(2);
// compiled num node returning num3033 (depth = 10)
  int op_slot_right_3032 = gc_frame_newslot(num3033);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_3032 = gc_frame_newslot(*var_depth);
  params[0] = num3033;
  partcv[0] = 1;
  Object sum3035 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum3035 (depth = 9)
  gc_frame_newslot(sum3035);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_each (depth = 9)
  params[0] = sum3035;
  partcv[0] = 1;
  Object call3036 = callmethod(*var_each, "pretty",
    1, partcv, params);
  gc_frame_end(callframe3031);
// compiled call node returning call3036 (depth = 8)
  int op_slot_right_3030 = gc_frame_newslot(call3036);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_3038 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3041 == NULL) {
    strlit3041 = alloc_String("""\x0a""  ");
    gc_root(strlit3041);
  }
// compiled string node returning strlit3041 (depth = 10)
  int op_slot_right_3040 = gc_frame_newslot(strlit3041);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_3040 = gc_frame_newslot(*var_s);
  params[0] = strlit3041;
  partcv[0] = 1;
  Object opresult3043 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3043 (depth = 9)
  int op_slot_left_3038 = gc_frame_newslot(opresult3043);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3044 = callmethod(opresult3043, "++", 1, partcv, params);
// compiled op node returning opresult3044 (depth = 8)
  int op_slot_left_3030 = gc_frame_newslot(opresult3044);
  params[0] = call3036;
  partcv[0] = 1;
  Object opresult3045 = callmethod(opresult3044, "++", 1, partcv, params);
// compiled op node returning opresult3045 (depth = 7)
  *var_s = opresult3045;
  if (opresult3045 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty2955(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 656
  setline(656);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2956 == NULL) {
    strlit2956 = alloc_String("");
    gc_root(strlit2956);
  }
// compiled string node returning strlit2956 (depth = 5)
  *var_spc = strlit2956;
  if (strlit2956 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 657
  setline(657);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2957 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_right_2958 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 6)
  Object num2960 = alloc_Float64(0);
// compiled num node returning num2960 (depth = 6)
  int op_slot_left_2958 = gc_frame_newslot(num2960);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult2961 = callmethod(num2960, "..", 1, partcv, params);
// compiled op node returning opresult2961 (depth = 5)
  gc_frame_newslot(opresult2961);
// starting to compile block node (depth = 5)
  Object block2962 = alloc_Block(NULL, NULL, "ast", 657);
  gc_frame_newslot(block2962);
// method _apply
  block_savedest(block2962);
  Object closure2963 = createclosure(2, "_apply");
  setclosureframe(closure2963, stackframe);
  addtoclosure(closure2963, var_spc);
  addtoclosure(closure2963, selfslot);
  struct UserObject *uo2963 = (struct UserObject*)block2962;
  uo2963->data[0] = (Object)closure2963;
  Method *meth_meth_ast__apply2963 = addmethod2pos(block2962, "_apply", &meth_ast__apply2963, 0);
  int argcv_meth_ast__apply2963[] = {1};
  meth_meth_ast__apply2963->type = alloc_MethodType(1, argcv_meth_ast__apply2963);
  meth_meth_ast__apply2963->definitionModule = modulename;
  meth_meth_ast__apply2963->definitionLine = 652;
// compiled block node returning block2962 (depth = 5)
  gc_frame_newslot(block2962);
// call case 5: prelude request
  params[0] = opresult2961;
  params[1] = block2962;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2970 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2957);
// compiled call node returning call2970 (depth = 4)
// Begin line 660
  setline(660);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2972 == NULL) {
    strlit2972 = alloc_String("""\x0a""");
    gc_root(strlit2972);
  }
// compiled string node returning strlit2972 (depth = 6)
  int op_slot_right_2971 = gc_frame_newslot(strlit2972);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2975 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call2976 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe2975);
// compiled call node returning call2976 (depth = 7)
  int op_slot_right_2974 = gc_frame_newslot(call2976);
// starting to compile string node (depth = 7)
  if (strlit2978 == NULL) {
    strlit2978 = alloc_String("");
    gc_root(strlit2978);
  }
// compiled string node returning strlit2978 (depth = 7)
  int op_slot_left_2974 = gc_frame_newslot(strlit2978);
  params[0] = call2976;
  partcv[0] = 1;
  Object opresult2979 = callmethod(strlit2978, "++", 1, partcv, params);
// compiled op node returning opresult2979 (depth = 6)
  int op_slot_left_2971 = gc_frame_newslot(opresult2979);
  params[0] = strlit2972;
  partcv[0] = 1;
  Object opresult2980 = callmethod(opresult2979, "++", 1, partcv, params);
// compiled op node returning opresult2980 (depth = 5)
  *var_s = opresult2980;
  if (opresult2980 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 661
  setline(661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2982 == NULL) {
    strlit2982 = alloc_String("Types:");
    gc_root(strlit2982);
  }
// compiled string node returning strlit2982 (depth = 6)
  int op_slot_right_2981 = gc_frame_newslot(strlit2982);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_2984 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_2984 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2986 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2986 (depth = 6)
  int op_slot_left_2981 = gc_frame_newslot(opresult2986);
  params[0] = strlit2982;
  partcv[0] = 1;
  Object opresult2987 = callmethod(opresult2986, "++", 1, partcv, params);
// compiled op node returning opresult2987 (depth = 5)
  *var_s = opresult2987;
  if (opresult2987 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 662
  setline(662);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2989 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2990 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2991 = callmethodflags(self, "types", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2990);
// compiled call node returning call2991 (depth = 6)
// compiled member node returning call2991 (depth = 5)
  gc_frame_newslot(call2991);
// starting to compile block node (depth = 5)
  Object block2992 = alloc_Block(NULL, NULL, "ast", 662);
  gc_frame_newslot(block2992);
// method _apply
  block_savedest(block2992);
  Object closure2993 = createclosure(4, "_apply");
  setclosureframe(closure2993, stackframe);
  addtoclosure(closure2993, var_depth);
  addtoclosure(closure2993, var_spc);
  addtoclosure(closure2993, var_s);
  addtoclosure(closure2993, selfslot);
  struct UserObject *uo2993 = (struct UserObject*)block2992;
  uo2993->data[0] = (Object)closure2993;
  Method *meth_meth_ast__apply2993 = addmethod2pos(block2992, "_apply", &meth_ast__apply2993, 0);
  int argcv_meth_ast__apply2993[] = {1};
  meth_meth_ast__apply2993->type = alloc_MethodType(1, argcv_meth_ast__apply2993);
  meth_meth_ast__apply2993->definitionModule = modulename;
  meth_meth_ast__apply2993->definitionLine = 662;
// compiled block node returning block2992 (depth = 5)
  gc_frame_newslot(block2992);
// call case 5: prelude request
  params[0] = call2991;
  params[1] = block2992;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3012 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2989);
// compiled call node returning call3012 (depth = 4)
// Begin line 665
  setline(665);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3014 == NULL) {
    strlit3014 = alloc_String("Methods:");
    gc_root(strlit3014);
  }
// compiled string node returning strlit3014 (depth = 6)
  int op_slot_right_3013 = gc_frame_newslot(strlit3014);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_3016 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3019 == NULL) {
    strlit3019 = alloc_String("""\x0a""");
    gc_root(strlit3019);
  }
// compiled string node returning strlit3019 (depth = 8)
  int op_slot_right_3018 = gc_frame_newslot(strlit3019);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_3018 = gc_frame_newslot(*var_s);
  params[0] = strlit3019;
  partcv[0] = 1;
  Object opresult3021 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3021 (depth = 7)
  int op_slot_left_3016 = gc_frame_newslot(opresult3021);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3022 = callmethod(opresult3021, "++", 1, partcv, params);
// compiled op node returning opresult3022 (depth = 6)
  int op_slot_left_3013 = gc_frame_newslot(opresult3022);
  params[0] = strlit3014;
  partcv[0] = 1;
  Object opresult3023 = callmethod(opresult3022, "++", 1, partcv, params);
// compiled op node returning opresult3023 (depth = 5)
  *var_s = opresult3023;
  if (opresult3023 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 666
  setline(666);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3025 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3026 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3027 = callmethodflags(self, "methods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3026);
// compiled call node returning call3027 (depth = 6)
// compiled member node returning call3027 (depth = 5)
  gc_frame_newslot(call3027);
// starting to compile block node (depth = 5)
  Object block3028 = alloc_Block(NULL, NULL, "ast", 666);
  gc_frame_newslot(block3028);
// method _apply
  block_savedest(block3028);
  Object closure3029 = createclosure(4, "_apply");
  setclosureframe(closure3029, stackframe);
  addtoclosure(closure3029, var_depth);
  addtoclosure(closure3029, var_spc);
  addtoclosure(closure3029, var_s);
  addtoclosure(closure3029, selfslot);
  struct UserObject *uo3029 = (struct UserObject*)block3028;
  uo3029->data[0] = (Object)closure3029;
  Method *meth_meth_ast__apply3029 = addmethod2pos(block3028, "_apply", &meth_ast__apply3029, 0);
  int argcv_meth_ast__apply3029[] = {1};
  meth_meth_ast__apply3029->type = alloc_MethodType(1, argcv_meth_ast__apply3029);
  meth_meth_ast__apply3029->definitionModule = modulename;
  meth_meth_ast__apply3029->definitionLine = 666;
// compiled block node returning block3028 (depth = 5)
  gc_frame_newslot(block3028);
// call case 5: prelude request
  params[0] = call3027;
  params[1] = block3028;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3048 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3025);
// compiled call node returning call3048 (depth = 4)
// Begin line 669
  setline(669);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3050 == NULL) {
    strlit3050 = alloc_String("""\x0a""");
    gc_root(strlit3050);
  }
// compiled string node returning strlit3050 (depth = 6)
  int op_slot_right_3049 = gc_frame_newslot(strlit3050);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_3049 = gc_frame_newslot(*var_s);
  params[0] = strlit3050;
  partcv[0] = 1;
  Object opresult3052 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3052 (depth = 5)
  *var_s = opresult3052;
  if (opresult3052 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 670
  setline(670);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply3066(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 675
  setline(675);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3068 == NULL) {
    strlit3068 = alloc_String("    ");
    gc_root(strlit3068);
  }
// compiled string node returning strlit3068 (depth = 8)
  int op_slot_right_3067 = gc_frame_newslot(strlit3068);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_3067 = gc_frame_newslot(*var_spc);
  params[0] = strlit3068;
  partcv[0] = 1;
  Object opresult3070 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult3070 (depth = 7)
  *var_spc = opresult3070;
  if (opresult3070 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply3084(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 680
  setline(680);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3086 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num3088 = alloc_Float64(1);
// compiled num node returning num3088 (depth = 10)
  int op_slot_right_3087 = gc_frame_newslot(num3088);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_3087 = gc_frame_newslot(*var_depth);
  params[0] = num3088;
  partcv[0] = 1;
  Object sum3090 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum3090 (depth = 9)
  gc_frame_newslot(sum3090);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_each (depth = 9)
  params[0] = sum3090;
  partcv[0] = 1;
  Object call3091 = callmethod(*var_each, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe3086);
// compiled call node returning call3091 (depth = 8)
  int op_slot_right_3085 = gc_frame_newslot(call3091);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3094 == NULL) {
    strlit3094 = alloc_String("    ");
    gc_root(strlit3094);
  }
// compiled string node returning strlit3094 (depth = 9)
  int op_slot_right_3093 = gc_frame_newslot(strlit3094);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_3096 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit3099 == NULL) {
    strlit3099 = alloc_String("""\x0a""");
    gc_root(strlit3099);
  }
// compiled string node returning strlit3099 (depth = 11)
  int op_slot_right_3098 = gc_frame_newslot(strlit3099);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_3098 = gc_frame_newslot(*var_s);
  params[0] = strlit3099;
  partcv[0] = 1;
  Object opresult3101 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3101 (depth = 10)
  int op_slot_left_3096 = gc_frame_newslot(opresult3101);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3102 = callmethod(opresult3101, "++", 1, partcv, params);
// compiled op node returning opresult3102 (depth = 9)
  int op_slot_left_3093 = gc_frame_newslot(opresult3102);
  params[0] = strlit3094;
  partcv[0] = 1;
  Object opresult3103 = callmethod(opresult3102, "++", 1, partcv, params);
// compiled op node returning opresult3103 (depth = 8)
  int op_slot_left_3085 = gc_frame_newslot(opresult3103);
  params[0] = call3091;
  partcv[0] = 1;
  Object opresult3104 = callmethod(opresult3103, "++", 1, partcv, params);
// compiled op node returning opresult3104 (depth = 7)
  *var_s = opresult3104;
  if (opresult3104 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply3112(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 683
  setline(683);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3114 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num3116 = alloc_Float64(1);
// compiled num node returning num3116 (depth = 10)
  int op_slot_right_3115 = gc_frame_newslot(num3116);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_3115 = gc_frame_newslot(*var_depth);
  params[0] = num3116;
  partcv[0] = 1;
  Object sum3118 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum3118 (depth = 9)
  gc_frame_newslot(sum3118);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_each (depth = 9)
  params[0] = sum3118;
  partcv[0] = 1;
  Object call3119 = callmethod(*var_each, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe3114);
// compiled call node returning call3119 (depth = 8)
  int op_slot_right_3113 = gc_frame_newslot(call3119);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3122 == NULL) {
    strlit3122 = alloc_String("    ");
    gc_root(strlit3122);
  }
// compiled string node returning strlit3122 (depth = 9)
  int op_slot_right_3121 = gc_frame_newslot(strlit3122);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_3124 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit3127 == NULL) {
    strlit3127 = alloc_String("""\x0a""");
    gc_root(strlit3127);
  }
// compiled string node returning strlit3127 (depth = 11)
  int op_slot_right_3126 = gc_frame_newslot(strlit3127);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_3126 = gc_frame_newslot(*var_s);
  params[0] = strlit3127;
  partcv[0] = 1;
  Object opresult3129 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3129 (depth = 10)
  int op_slot_left_3124 = gc_frame_newslot(opresult3129);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3130 = callmethod(opresult3129, "++", 1, partcv, params);
// compiled op node returning opresult3130 (depth = 9)
  int op_slot_left_3121 = gc_frame_newslot(opresult3130);
  params[0] = strlit3122;
  partcv[0] = 1;
  Object opresult3131 = callmethod(opresult3130, "++", 1, partcv, params);
// compiled op node returning opresult3131 (depth = 8)
  int op_slot_left_3113 = gc_frame_newslot(opresult3131);
  params[0] = call3119;
  partcv[0] = 1;
  Object opresult3132 = callmethod(opresult3131, "++", 1, partcv, params);
// compiled op node returning opresult3132 (depth = 7)
  *var_s = opresult3132;
  if (opresult3132 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace3054(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 673
  setline(673);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3055 == NULL) {
    strlit3055 = alloc_String("");
    gc_root(strlit3055);
  }
// compiled string node returning strlit3055 (depth = 5)
  *var_spc = strlit3055;
  if (strlit3055 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 674
  setline(674);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3056 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num3059 = alloc_Float64(1);
// compiled num node returning num3059 (depth = 7)
  int op_slot_right_3058 = gc_frame_newslot(num3059);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_3058 = gc_frame_newslot(*var_depth);
  params[0] = num3059;
  partcv[0] = 1;
  Object diff3061 = callmethod(*var_depth, "-", 1, partcv, params);
// compiled op node returning diff3061 (depth = 6)
  int op_slot_right_3057 = gc_frame_newslot(diff3061);
// starting to compile num node (depth = 6)
  Object num3063 = alloc_Float64(0);
// compiled num node returning num3063 (depth = 6)
  int op_slot_left_3057 = gc_frame_newslot(num3063);
  params[0] = diff3061;
  partcv[0] = 1;
  Object opresult3064 = callmethod(num3063, "..", 1, partcv, params);
// compiled op node returning opresult3064 (depth = 5)
  gc_frame_newslot(opresult3064);
// starting to compile block node (depth = 5)
  Object block3065 = alloc_Block(NULL, NULL, "ast", 674);
  gc_frame_newslot(block3065);
// method _apply
  block_savedest(block3065);
  Object closure3066 = createclosure(2, "_apply");
  setclosureframe(closure3066, stackframe);
  addtoclosure(closure3066, var_spc);
  addtoclosure(closure3066, selfslot);
  struct UserObject *uo3066 = (struct UserObject*)block3065;
  uo3066->data[0] = (Object)closure3066;
  Method *meth_meth_ast__apply3066 = addmethod2pos(block3065, "_apply", &meth_ast__apply3066, 0);
  int argcv_meth_ast__apply3066[] = {1};
  meth_meth_ast__apply3066->type = alloc_MethodType(1, argcv_meth_ast__apply3066);
  meth_meth_ast__apply3066->definitionModule = modulename;
  meth_meth_ast__apply3066->definitionLine = 666;
// compiled block node returning block3065 (depth = 5)
  gc_frame_newslot(block3065);
// call case 5: prelude request
  params[0] = opresult3064;
  params[1] = block3065;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3073 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3056);
// compiled call node returning call3073 (depth = 4)
// Begin line 677
  setline(677);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3074 == NULL) {
    strlit3074 = alloc_String("type");
    gc_root(strlit3074);
  }
// compiled string node returning strlit3074 (depth = 5)
  *var_s = strlit3074;
  if (strlit3074 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 678
  setline(678);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3076 == NULL) {
    strlit3076 = alloc_String(" = {");
    gc_root(strlit3076);
  }
// compiled string node returning strlit3076 (depth = 6)
  int op_slot_right_3075 = gc_frame_newslot(strlit3076);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_3075 = gc_frame_newslot(*var_s);
  params[0] = strlit3076;
  partcv[0] = 1;
  Object opresult3078 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3078 (depth = 5)
  *var_s = opresult3078;
  if (opresult3078 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 679
  setline(679);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3080 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3081 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3082 = callmethodflags(self, "methods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3081);
// compiled call node returning call3082 (depth = 6)
// compiled member node returning call3082 (depth = 5)
  gc_frame_newslot(call3082);
// starting to compile block node (depth = 5)
  Object block3083 = alloc_Block(NULL, NULL, "ast", 679);
  gc_frame_newslot(block3083);
// method _apply
  block_savedest(block3083);
  Object closure3084 = createclosure(4, "_apply");
  setclosureframe(closure3084, stackframe);
  addtoclosure(closure3084, var_depth);
  addtoclosure(closure3084, var_spc);
  addtoclosure(closure3084, var_s);
  addtoclosure(closure3084, selfslot);
  struct UserObject *uo3084 = (struct UserObject*)block3083;
  uo3084->data[0] = (Object)closure3084;
  Method *meth_meth_ast__apply3084 = addmethod2pos(block3083, "_apply", &meth_ast__apply3084, 0);
  int argcv_meth_ast__apply3084[] = {1};
  meth_meth_ast__apply3084->type = alloc_MethodType(1, argcv_meth_ast__apply3084);
  meth_meth_ast__apply3084->definitionModule = modulename;
  meth_meth_ast__apply3084->definitionLine = 679;
// compiled block node returning block3083 (depth = 5)
  gc_frame_newslot(block3083);
// call case 5: prelude request
  params[0] = call3082;
  params[1] = block3083;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3107 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3080);
// compiled call node returning call3107 (depth = 4)
// Begin line 682
  setline(682);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3108 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3109 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3110 = callmethodflags(self, "types", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3109);
// compiled call node returning call3110 (depth = 6)
// compiled member node returning call3110 (depth = 5)
  gc_frame_newslot(call3110);
// starting to compile block node (depth = 5)
  Object block3111 = alloc_Block(NULL, NULL, "ast", 682);
  gc_frame_newslot(block3111);
// method _apply
  block_savedest(block3111);
  Object closure3112 = createclosure(4, "_apply");
  setclosureframe(closure3112, stackframe);
  addtoclosure(closure3112, var_depth);
  addtoclosure(closure3112, var_spc);
  addtoclosure(closure3112, var_s);
  addtoclosure(closure3112, selfslot);
  struct UserObject *uo3112 = (struct UserObject*)block3111;
  uo3112->data[0] = (Object)closure3112;
  Method *meth_meth_ast__apply3112 = addmethod2pos(block3111, "_apply", &meth_ast__apply3112, 0);
  int argcv_meth_ast__apply3112[] = {1};
  meth_meth_ast__apply3112->type = alloc_MethodType(1, argcv_meth_ast__apply3112);
  meth_meth_ast__apply3112->definitionModule = modulename;
  meth_meth_ast__apply3112->definitionLine = 682;
// compiled block node returning block3111 (depth = 5)
  gc_frame_newslot(block3111);
// call case 5: prelude request
  params[0] = call3110;
  params[1] = block3111;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3135 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3108);
// compiled call node returning call3135 (depth = 4)
// Begin line 685
  setline(685);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3137 == NULL) {
    strlit3137 = alloc_String("}");
    gc_root(strlit3137);
  }
// compiled string node returning strlit3137 (depth = 5)
  int op_slot_right_3136 = gc_frame_newslot(strlit3137);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_3136 = gc_frame_newslot(*var_s);
  params[0] = strlit3137;
  partcv[0] = 1;
  Object opresult3139 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3139 (depth = 4)
  gc_frame_end(frame);
  return opresult3139;
}
Object meth_ast_shallowCopy3140(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_typeLiteralNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 688
  setline(688);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3141 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe3142 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_emptySeq (depth = 6)
  gc_frame_newslot(*var_emptySeq);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_emptySeq (depth = 6)
  gc_frame_newslot(*var_emptySeq);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_typeLiteralNode (depth = 6)
  params[0] = *var_emptySeq;
  params[1] = *var_emptySeq;
  partcv[0] = 2;
  Object call3143 = callmethod(*var_typeLiteralNode, "new",
    1, partcv, params);
  gc_frame_end(callframe3142);
// compiled call node returning call3143 (depth = 5)
  params[0] = self;
  partcv[0] = 1;
  Object call3144 = callmethod(call3143, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe3141);
// compiled call node returning call3144 (depth = 4)
  gc_frame_end(frame);
  return call3144;
}
Object meth_ast_shallowCopyFieldsFrom3145(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyFieldsFrom");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopyFieldsFrom (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyFieldsFrom");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 691
  setline(691);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3146 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call3147 = callmethod4(self, "shallowCopyFieldsFrom", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe3146);
// compiled call node returning call3147 (depth = 4)
// Begin line 692
  setline(692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 682
  setline(682);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3148 = gc_frame_new();
// Begin line 692
  setline(692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3149 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_other (depth = 8)
  partcv[0] = 0;
  Object call3150 = callmethod(*var_other, "nominal",
    1, partcv, params);
  gc_frame_end(callframe3149);
// compiled call node returning call3150 (depth = 7)
// compiled member node returning call3150 (depth = 6)
  gc_frame_newslot(call3150);
// call case 4: self request
  params[0] = call3150;
  partcv[0] = 1;
  Object call3151 = callmethodflags(self, "nominal:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3148);
// compiled call node returning call3151 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 693
  setline(693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 692
  setline(692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3152 = gc_frame_new();
// Begin line 693
  setline(693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3153 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_other (depth = 8)
  partcv[0] = 0;
  Object call3154 = callmethod(*var_other, "anonymous",
    1, partcv, params);
  gc_frame_end(callframe3153);
// compiled call node returning call3154 (depth = 7)
// compiled member node returning call3154 (depth = 6)
  gc_frame_newslot(call3154);
// call case 4: self request
  params[0] = call3154;
  partcv[0] = 1;
  Object call3155 = callmethodflags(self, "anonymous:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3152);
// compiled call node returning call3155 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 694
  setline(694);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 693
  setline(693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3156 = gc_frame_new();
// Begin line 694
  setline(694);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3157 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_other (depth = 8)
  partcv[0] = 0;
  Object call3158 = callmethod(*var_other, "value",
    1, partcv, params);
  gc_frame_end(callframe3157);
// compiled call node returning call3158 (depth = 7)
// compiled member node returning call3158 (depth = 6)
  gc_frame_newslot(call3158);
// call case 4: self request
  params[0] = call3158;
  partcv[0] = 1;
  Object call3159 = callmethodflags(self, "value:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3156);
// compiled call node returning call3159 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 695
  setline(695);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_new2866(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_typeLiteralNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_methods_39_ = &(stackframe->slots[0]);
  *var_methods_39_ = args[curarg];
  curarg++;
  Object *var_types_39_ = &(stackframe->slots[1]);
  *var_types_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2867 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2867 = alloc_userobj2(21,17, objclass2867);
  gc_frame_newslot(obj2867);
if (objclass2867 == NULL) {
  glfree(obj2867->class->name);
  obj2867->class->name = "typeLiteralNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2867, self, 0);
  addmethodreal(obj2867,"outer", &reader_ast_outer_2868);
  Object oldself2867 = self;
  struct StackFrameObject *oldstackframe2867 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2867);
  gc_frame_newslot((Object)stackframe);
  self = obj2867;
  Object *oldselfslot2867 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2867 = (*(struct UserObject *)self).data[0], lowerouter2867 = thisouter2867;
  if (inheritingObject2867) {
    struct UserObject *inho2867 = (struct UserObject *)inheritingObject2867;
    while (inho2867->super != GraceDefaultObject) inho2867 = (struct UserObject *)inho2867->super;
    inho2867->super = obj2867;
    self = inheritingObject2867;
    *selfslot = self;
    lowerouter2867 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2867;
  }
if (objclass2867 == NULL) {
  Method *reader2869 = addmethodrealflags(obj2867, "kind",&reader_ast_kind_2869, MFLAG_DEF);
  reader2869->definitionModule = modulename;
  reader2869->definitionLine = 622;
}
adddatum2(obj2867, alloc_Undefined(), 1);
if (objclass2867 == NULL) {
  Method *reader2870 = addmethodrealflags(obj2867, "methods",&reader_ast_methods_2870, 0);
  Method *writer2870 = addmethodrealflags(obj2867, "methods:=",&writer_ast_methods_2870, 0);
  reader2870->definitionModule = modulename;
  writer2870->definitionModule = modulename;
  reader2870->definitionLine = 623;
  writer2870->definitionLine = 623;
}
obj2867->flags |= OFLAG_MUTABLE;
adddatum2(obj2867, alloc_Undefined(), 2);
if (objclass2867 == NULL) {
  Method *reader2871 = addmethodrealflags(obj2867, "types",&reader_ast_types_2871, 0);
  Method *writer2871 = addmethodrealflags(obj2867, "types:=",&writer_ast_types_2871, 0);
  reader2871->definitionModule = modulename;
  writer2871->definitionModule = modulename;
  reader2871->definitionLine = 624;
  writer2871->definitionLine = 624;
}
obj2867->flags |= OFLAG_MUTABLE;
adddatum2(obj2867, alloc_Undefined(), 3);
if (objclass2867 == NULL) {
  Method *reader2872 = addmethodrealflags(obj2867, "nominal",&reader_ast_nominal_2872, 0);
  Method *writer2872 = addmethodrealflags(obj2867, "nominal:=",&writer_ast_nominal_2872, 0);
  reader2872->definitionModule = modulename;
  writer2872->definitionModule = modulename;
  reader2872->definitionLine = 625;
  writer2872->definitionLine = 625;
}
obj2867->flags |= OFLAG_MUTABLE;
adddatum2(obj2867, alloc_Undefined(), 4);
if (objclass2867 == NULL) {
  Method *reader2873 = addmethodrealflags(obj2867, "anonymous",&reader_ast_anonymous_2873, 0);
  Method *writer2873 = addmethodrealflags(obj2867, "anonymous:=",&writer_ast_anonymous_2873, 0);
  reader2873->definitionModule = modulename;
  writer2873->definitionModule = modulename;
  reader2873->definitionLine = 626;
  writer2873->definitionLine = 626;
}
obj2867->flags |= OFLAG_MUTABLE;
adddatum2(obj2867, alloc_Undefined(), 5);
if (objclass2867 == NULL) {
  Method *reader2874 = addmethodrealflags(obj2867, "value",&reader_ast_value_2874, 0);
  Method *writer2874 = addmethodrealflags(obj2867, "value:=",&writer_ast_value_2874, 0);
  reader2874->definitionModule = modulename;
  writer2874->definitionModule = modulename;
  reader2874->definitionLine = 627;
  writer2874->definitionLine = 627;
}
obj2867->flags |= OFLAG_MUTABLE;
adddatum2(obj2867, alloc_Undefined(), 6);
// method name
  struct UserObject *uo2875 = (struct UserObject*)obj2867;
  uo2875->data[7] = emptyclosure;
  Method *meth_meth_ast_name2875 = addmethod2pos(obj2867, "name", &meth_ast_name2875, 7);
  int argcv_meth_ast_name2875[] = {0};
  meth_meth_ast_name2875->type = alloc_MethodType(1, argcv_meth_ast_name2875);
  meth_meth_ast_name2875->definitionModule = modulename;
  meth_meth_ast_name2875->definitionLine = 629;
// method name:=
  struct UserObject *uo2878 = (struct UserObject*)obj2867;
  uo2878->data[8] = emptyclosure;
  Method *meth_meth_ast_name_58__61_2878 = addmethod2pos(obj2867, "name:=", &meth_ast_name_58__61_2878, 8);
  int argcv_meth_ast_name_58__61_2878[] = {1};
  meth_meth_ast_name_58__61_2878->type = alloc_MethodType(1, argcv_meth_ast_name_58__61_2878);
  meth_meth_ast_name_58__61_2878->definitionModule = modulename;
  meth_meth_ast_name_58__61_2878->definitionLine = 630;
// method asString
  struct UserObject *uo2884 = (struct UserObject*)obj2867;
  uo2884->data[9] = emptyclosure;
  Method *meth_meth_ast_asString2884 = addmethod2pos(obj2867, "asString", &meth_ast_asString2884, 9);
  int argcv_meth_ast_asString2884[] = {0};
  meth_meth_ast_asString2884->type = alloc_MethodType(1, argcv_meth_ast_asString2884);
  meth_meth_ast_asString2884->definitionModule = modulename;
  meth_meth_ast_asString2884->definitionLine = 634;
// method accept()from
  struct UserObject *uo2904 = (struct UserObject*)obj2867;
  uo2904->data[10] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from2904 = addmethod2pos(obj2867, "accept()from", &meth_ast_accept_40__41_from2904, 10);
  int argcv_meth_ast_accept_40__41_from2904[] = {1, 1};
  meth_meth_ast_accept_40__41_from2904->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from2904);
  meth_meth_ast_accept_40__41_from2904->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from2904->definitionLine = 637;
// method map()ancestors
  struct UserObject *uo2928 = (struct UserObject*)obj2867;
  uo2928->data[11] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors2928 = addmethod2pos(obj2867, "map()ancestors", &meth_ast_map_40__41_ancestors2928, 11);
  int argcv_meth_ast_map_40__41_ancestors2928[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors2928->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors2928);
  meth_meth_ast_map_40__41_ancestors2928->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors2928->definitionLine = 648;
// method pretty
  struct UserObject *uo2955 = (struct UserObject*)obj2867;
  uo2955->data[12] = emptyclosure;
  Method *meth_meth_ast_pretty2955 = addmethod2pos(obj2867, "pretty", &meth_ast_pretty2955, 12);
  int argcv_meth_ast_pretty2955[] = {1};
  meth_meth_ast_pretty2955->type = alloc_MethodType(1, argcv_meth_ast_pretty2955);
  meth_meth_ast_pretty2955->definitionModule = modulename;
  meth_meth_ast_pretty2955->definitionLine = 655;
// method toGrace
  struct UserObject *uo3054 = (struct UserObject*)obj2867;
  uo3054->data[13] = emptyclosure;
  Method *meth_meth_ast_toGrace3054 = addmethod2pos(obj2867, "toGrace", &meth_ast_toGrace3054, 13);
  int argcv_meth_ast_toGrace3054[] = {1};
  meth_meth_ast_toGrace3054->type = alloc_MethodType(1, argcv_meth_ast_toGrace3054);
meth_meth_ast_toGrace3054->type->types[0] = type_Number;
meth_meth_ast_toGrace3054->type->names[0] = "depth";
  meth_meth_ast_toGrace3054->definitionModule = modulename;
  meth_meth_ast_toGrace3054->definitionLine = 672;
// method shallowCopy
  block_savedest(obj2867);
  Object closure3140 = createclosure(2, "shallowCopy");
  setclosureframe(closure3140, stackframe);
  addtoclosure(closure3140, var_emptySeq);
  addtoclosure(closure3140, var_typeLiteralNode);
  struct UserObject *uo3140 = (struct UserObject*)obj2867;
  uo3140->data[14] = (Object)closure3140;
  Method *meth_meth_ast_shallowCopy3140 = addmethod2pos(obj2867, "shallowCopy", &meth_ast_shallowCopy3140, 14);
  int argcv_meth_ast_shallowCopy3140[] = {0};
  meth_meth_ast_shallowCopy3140->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy3140);
  meth_meth_ast_shallowCopy3140->definitionModule = modulename;
  meth_meth_ast_shallowCopy3140->definitionLine = 687;
// method shallowCopyFieldsFrom
  struct UserObject *uo3145 = (struct UserObject*)obj2867;
  uo3145->data[15] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom3145 = addmethod2pos(obj2867, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom3145, 15);
  int argcv_meth_ast_shallowCopyFieldsFrom3145[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom3145->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom3145);
  meth_meth_ast_shallowCopyFieldsFrom3145->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom3145->definitionLine = 690;
  sourceObject = obj2867;
// Begin line 621
  setline(621);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3160 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3161 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe3160);
// compiled call node returning call3161 (depth = 4)
  struct UserObject *obj2867_uo = (struct UserObject *)obj2867;
  obj2867_uo->super = call3161;
  sourceObject = obj2867;
// Begin line 622
  setline(622);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit3162 == NULL) {
    strlit3162 = alloc_String("typeliteral");
    gc_root(strlit3162);
  }
// compiled string node returning strlit3162 (depth = 4)
  adddatum2(obj2867, strlit3162, 1);
  sourceObject = obj2867;
// Begin line 623
  setline(623);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_methods_39_ (depth = 4)
  adddatum2(obj2867, *var_methods_39_, 2);
  sourceObject = obj2867;
// Begin line 624
  setline(624);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_types_39_ (depth = 4)
  adddatum2(obj2867, *var_types_39_, 3);
  sourceObject = obj2867;
// Begin line 625
  setline(625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool3163 = alloc_Boolean(0);
// compiled identifier node returning bool3163 (depth = 4)
  adddatum2(obj2867, bool3163, 4);
  sourceObject = obj2867;
// Begin line 626
  setline(626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool3164 = alloc_Boolean(1);
// compiled identifier node returning bool3164 (depth = 4)
  adddatum2(obj2867, bool3164, 5);
  sourceObject = obj2867;
// Begin line 627
  setline(627);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit3165 == NULL) {
    strlit3165 = alloc_String("""\xe2""""\x80""""\xb9""anon""\xe2""""\x80""""\xba""");
    gc_root(strlit3165);
  }
// compiled string node returning strlit3165 (depth = 4)
  adddatum2(obj2867, strlit3165, 6);
  sourceObject = obj2867;
  sourceObject = obj2867;
  sourceObject = obj2867;
  sourceObject = obj2867;
  sourceObject = obj2867;
  sourceObject = obj2867;
  sourceObject = obj2867;
  sourceObject = obj2867;
  sourceObject = obj2867;
  objclass2867 = obj2867->class;
  objclass2867->definitionModule = modulename;
  objclass2867->definitionLine = 620;
  (*(struct UserObject *)self).data[0] = lowerouter2867;
  self = oldself2867;
  selfslot = oldselfslot2867;
  stackframe = oldstackframe2867;
  gc_frame_end(frame);
  return obj2867;
}
Object meth_ast_new2866_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_typeLiteralNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_methods_39_ = &(stackframe->slots[0]);
  *var_methods_39_ = args[curarg];
  curarg++;
  Object *var_types_39_ = &(stackframe->slots[1]);
  *var_types_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2867 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2867 = alloc_userobj2(21,17, objclass2867);
  gc_frame_newslot(obj2867);
if (objclass2867 == NULL) {
  glfree(obj2867->class->name);
  obj2867->class->name = "typeLiteralNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2867, self, 0);
  addmethodreal(obj2867,"outer", &reader_ast_outer_2868);
  Object oldself2867 = self;
  struct StackFrameObject *oldstackframe2867 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2867);
  gc_frame_newslot((Object)stackframe);
  self = obj2867;
  Object *oldselfslot2867 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2867 = (*(struct UserObject *)self).data[0], lowerouter2867 = thisouter2867;
  if (inheritingObject2867) {
    struct UserObject *inho2867 = (struct UserObject *)inheritingObject2867;
    while (inho2867->super != GraceDefaultObject) inho2867 = (struct UserObject *)inho2867->super;
    inho2867->super = obj2867;
    self = inheritingObject2867;
    *selfslot = self;
    lowerouter2867 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2867;
  }
if (objclass2867 == NULL) {
  Method *reader2869 = addmethodrealflags(obj2867, "kind",&reader_ast_kind_2869, MFLAG_DEF);
  reader2869->definitionModule = modulename;
  reader2869->definitionLine = 622;
}
adddatum2(obj2867, alloc_Undefined(), 1);
if (objclass2867 == NULL) {
  Method *reader2870 = addmethodrealflags(obj2867, "methods",&reader_ast_methods_2870, 0);
  Method *writer2870 = addmethodrealflags(obj2867, "methods:=",&writer_ast_methods_2870, 0);
  reader2870->definitionModule = modulename;
  writer2870->definitionModule = modulename;
  reader2870->definitionLine = 623;
  writer2870->definitionLine = 623;
}
obj2867->flags |= OFLAG_MUTABLE;
adddatum2(obj2867, alloc_Undefined(), 2);
if (objclass2867 == NULL) {
  Method *reader2871 = addmethodrealflags(obj2867, "types",&reader_ast_types_2871, 0);
  Method *writer2871 = addmethodrealflags(obj2867, "types:=",&writer_ast_types_2871, 0);
  reader2871->definitionModule = modulename;
  writer2871->definitionModule = modulename;
  reader2871->definitionLine = 624;
  writer2871->definitionLine = 624;
}
obj2867->flags |= OFLAG_MUTABLE;
adddatum2(obj2867, alloc_Undefined(), 3);
if (objclass2867 == NULL) {
  Method *reader2872 = addmethodrealflags(obj2867, "nominal",&reader_ast_nominal_2872, 0);
  Method *writer2872 = addmethodrealflags(obj2867, "nominal:=",&writer_ast_nominal_2872, 0);
  reader2872->definitionModule = modulename;
  writer2872->definitionModule = modulename;
  reader2872->definitionLine = 625;
  writer2872->definitionLine = 625;
}
obj2867->flags |= OFLAG_MUTABLE;
adddatum2(obj2867, alloc_Undefined(), 4);
if (objclass2867 == NULL) {
  Method *reader2873 = addmethodrealflags(obj2867, "anonymous",&reader_ast_anonymous_2873, 0);
  Method *writer2873 = addmethodrealflags(obj2867, "anonymous:=",&writer_ast_anonymous_2873, 0);
  reader2873->definitionModule = modulename;
  writer2873->definitionModule = modulename;
  reader2873->definitionLine = 626;
  writer2873->definitionLine = 626;
}
obj2867->flags |= OFLAG_MUTABLE;
adddatum2(obj2867, alloc_Undefined(), 5);
if (objclass2867 == NULL) {
  Method *reader2874 = addmethodrealflags(obj2867, "value",&reader_ast_value_2874, 0);
  Method *writer2874 = addmethodrealflags(obj2867, "value:=",&writer_ast_value_2874, 0);
  reader2874->definitionModule = modulename;
  writer2874->definitionModule = modulename;
  reader2874->definitionLine = 627;
  writer2874->definitionLine = 627;
}
obj2867->flags |= OFLAG_MUTABLE;
adddatum2(obj2867, alloc_Undefined(), 6);
// method name
  struct UserObject *uo2875 = (struct UserObject*)obj2867;
  uo2875->data[7] = emptyclosure;
  Method *meth_meth_ast_name2875 = addmethod2pos(obj2867, "name", &meth_ast_name2875, 7);
  int argcv_meth_ast_name2875[] = {0};
  meth_meth_ast_name2875->type = alloc_MethodType(1, argcv_meth_ast_name2875);
  meth_meth_ast_name2875->definitionModule = modulename;
  meth_meth_ast_name2875->definitionLine = 629;
// method name:=
  struct UserObject *uo2878 = (struct UserObject*)obj2867;
  uo2878->data[8] = emptyclosure;
  Method *meth_meth_ast_name_58__61_2878 = addmethod2pos(obj2867, "name:=", &meth_ast_name_58__61_2878, 8);
  int argcv_meth_ast_name_58__61_2878[] = {1};
  meth_meth_ast_name_58__61_2878->type = alloc_MethodType(1, argcv_meth_ast_name_58__61_2878);
  meth_meth_ast_name_58__61_2878->definitionModule = modulename;
  meth_meth_ast_name_58__61_2878->definitionLine = 630;
// method asString
  struct UserObject *uo2884 = (struct UserObject*)obj2867;
  uo2884->data[9] = emptyclosure;
  Method *meth_meth_ast_asString2884 = addmethod2pos(obj2867, "asString", &meth_ast_asString2884, 9);
  int argcv_meth_ast_asString2884[] = {0};
  meth_meth_ast_asString2884->type = alloc_MethodType(1, argcv_meth_ast_asString2884);
  meth_meth_ast_asString2884->definitionModule = modulename;
  meth_meth_ast_asString2884->definitionLine = 634;
// method accept()from
  struct UserObject *uo2904 = (struct UserObject*)obj2867;
  uo2904->data[10] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from2904 = addmethod2pos(obj2867, "accept()from", &meth_ast_accept_40__41_from2904, 10);
  int argcv_meth_ast_accept_40__41_from2904[] = {1, 1};
  meth_meth_ast_accept_40__41_from2904->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from2904);
  meth_meth_ast_accept_40__41_from2904->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from2904->definitionLine = 637;
// method map()ancestors
  struct UserObject *uo2928 = (struct UserObject*)obj2867;
  uo2928->data[11] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors2928 = addmethod2pos(obj2867, "map()ancestors", &meth_ast_map_40__41_ancestors2928, 11);
  int argcv_meth_ast_map_40__41_ancestors2928[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors2928->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors2928);
  meth_meth_ast_map_40__41_ancestors2928->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors2928->definitionLine = 648;
// method pretty
  struct UserObject *uo2955 = (struct UserObject*)obj2867;
  uo2955->data[12] = emptyclosure;
  Method *meth_meth_ast_pretty2955 = addmethod2pos(obj2867, "pretty", &meth_ast_pretty2955, 12);
  int argcv_meth_ast_pretty2955[] = {1};
  meth_meth_ast_pretty2955->type = alloc_MethodType(1, argcv_meth_ast_pretty2955);
  meth_meth_ast_pretty2955->definitionModule = modulename;
  meth_meth_ast_pretty2955->definitionLine = 655;
// method toGrace
  struct UserObject *uo3054 = (struct UserObject*)obj2867;
  uo3054->data[13] = emptyclosure;
  Method *meth_meth_ast_toGrace3054 = addmethod2pos(obj2867, "toGrace", &meth_ast_toGrace3054, 13);
  int argcv_meth_ast_toGrace3054[] = {1};
  meth_meth_ast_toGrace3054->type = alloc_MethodType(1, argcv_meth_ast_toGrace3054);
meth_meth_ast_toGrace3054->type->types[0] = type_Number;
meth_meth_ast_toGrace3054->type->names[0] = "depth";
  meth_meth_ast_toGrace3054->definitionModule = modulename;
  meth_meth_ast_toGrace3054->definitionLine = 672;
// method shallowCopy
  block_savedest(obj2867);
  Object closure3140 = createclosure(2, "shallowCopy");
  setclosureframe(closure3140, stackframe);
  addtoclosure(closure3140, var_emptySeq);
  addtoclosure(closure3140, var_typeLiteralNode);
  struct UserObject *uo3140 = (struct UserObject*)obj2867;
  uo3140->data[14] = (Object)closure3140;
  Method *meth_meth_ast_shallowCopy3140 = addmethod2pos(obj2867, "shallowCopy", &meth_ast_shallowCopy3140, 14);
  int argcv_meth_ast_shallowCopy3140[] = {0};
  meth_meth_ast_shallowCopy3140->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy3140);
  meth_meth_ast_shallowCopy3140->definitionModule = modulename;
  meth_meth_ast_shallowCopy3140->definitionLine = 687;
// method shallowCopyFieldsFrom
  struct UserObject *uo3145 = (struct UserObject*)obj2867;
  uo3145->data[15] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom3145 = addmethod2pos(obj2867, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom3145, 15);
  int argcv_meth_ast_shallowCopyFieldsFrom3145[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom3145->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom3145);
  meth_meth_ast_shallowCopyFieldsFrom3145->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom3145->definitionLine = 690;
  sourceObject = obj2867;
// Begin line 621
  setline(621);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3160 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3161 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe3160);
// compiled call node returning call3161 (depth = 4)
  struct UserObject *obj2867_uo = (struct UserObject *)obj2867;
  obj2867_uo->super = call3161;
  sourceObject = obj2867;
// Begin line 622
  setline(622);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit3162 == NULL) {
    strlit3162 = alloc_String("typeliteral");
    gc_root(strlit3162);
  }
// compiled string node returning strlit3162 (depth = 4)
  adddatum2(obj2867, strlit3162, 1);
  sourceObject = obj2867;
// Begin line 623
  setline(623);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_methods_39_ (depth = 4)
  adddatum2(obj2867, *var_methods_39_, 2);
  sourceObject = obj2867;
// Begin line 624
  setline(624);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_types_39_ (depth = 4)
  adddatum2(obj2867, *var_types_39_, 3);
  sourceObject = obj2867;
// Begin line 625
  setline(625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool3163 = alloc_Boolean(0);
// compiled identifier node returning bool3163 (depth = 4)
  adddatum2(obj2867, bool3163, 4);
  sourceObject = obj2867;
// Begin line 626
  setline(626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool3164 = alloc_Boolean(1);
// compiled identifier node returning bool3164 (depth = 4)
  adddatum2(obj2867, bool3164, 5);
  sourceObject = obj2867;
// Begin line 627
  setline(627);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit3165 == NULL) {
    strlit3165 = alloc_String("""\xe2""""\x80""""\xb9""anon""\xe2""""\x80""""\xba""");
    gc_root(strlit3165);
  }
// compiled string node returning strlit3165 (depth = 4)
  adddatum2(obj2867, strlit3165, 6);
  sourceObject = obj2867;
  sourceObject = obj2867;
  sourceObject = obj2867;
  sourceObject = obj2867;
  sourceObject = obj2867;
  sourceObject = obj2867;
  sourceObject = obj2867;
  sourceObject = obj2867;
  sourceObject = obj2867;
  objclass2867 = obj2867->class;
  objclass2867->definitionModule = modulename;
  objclass2867->definitionLine = 620;
  (*(struct UserObject *)self).data[0] = lowerouter2867;
  self = oldself2867;
  selfslot = oldselfslot2867;
  stackframe = oldstackframe2867;
  gc_frame_end(frame);
  return obj2867;
}
Object meth_ast_typeDecNode3167(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 22, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeDecNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_typeDecNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for typeDecNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for typeDecNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_typeDecNode (depth = 3)
  gc_frame_end(frame);
  return *var_typeDecNode;
}
Object meth_ast_scope_58__61_3179(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "scope:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method scope:=");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for scope:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_st = &(stackframe->slots[0]);
  *var_st = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for scope:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 711
  setline(711);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 699
  setline(699);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3180 = gc_frame_new();
// Begin line 711
  setline(711);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_st (depth = 6)
  gc_frame_newslot(*var_st);
// call case 4: self request
  params[0] = *var_st;
  partcv[0] = 1;
  Object call3181 = callmethodflags(self, "symbolTable:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3180);
// compiled call node returning call3181 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 712
  setline(712);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 699
  setline(699);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3182 = gc_frame_new();
// Begin line 712
  setline(712);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_st (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call3183 = callmethod(*var_st, "node:=",
    1, partcv, params);
  gc_frame_end(callframe3182);
// compiled call node returning call3183 (depth = 5)
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_declarationKindWithAncestors3184(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "declarationKindWithAncestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method declarationKindWithAncestors");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for declarationKindWithAncestors (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for declarationKindWithAncestors");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 715
  setline(715);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit3185 == NULL) {
    strlit3185 = alloc_String("parameter");
    gc_root(strlit3185);
  }
// compiled string node returning strlit3185 (depth = 4)
  gc_frame_end(frame);
  return strlit3185;
}
Object meth_ast_isConfidential3186(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isConfidential");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isConfidential (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isConfidential");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 718
  setline(718);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num3189 = alloc_Float64(0);
// compiled num node returning num3189 (depth = 6)
  int op_slot_right_3188 = gc_frame_newslot(num3189);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3191 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3192 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3193 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3192);
// compiled call node returning call3193 (depth = 9)
// compiled member node returning call3193 (depth = 8)
  partcv[0] = 0;
  Object call3194 = callmethod(call3193, "size",
    1, partcv, params);
  gc_frame_end(callframe3191);
// compiled call node returning call3194 (depth = 7)
// compiled member node returning call3194 (depth = 6)
  int op_slot_left_3188 = gc_frame_newslot(call3194);
  params[0] = num3189;
  partcv[0] = 1;
  Object opresult3195 = callmethod(call3194, "==", 1, partcv, params);
// compiled op node returning opresult3195 (depth = 5)
  Object if3187 = done;
  if (istrue(opresult3195)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool3196 = alloc_Boolean(0);
// compiled identifier node returning bool3196 (depth = 6)
  return bool3196;
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if3187 = undefined;
  } else {
  }
// compiled if node returning if3187 (depth = 4)
// Begin line 719
  setline(719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3197 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile string node (depth = 5)
  if (strlit3198 == NULL) {
    strlit3198 = alloc_String("confidential");
    gc_root(strlit3198);
  }
// compiled string node returning strlit3198 (depth = 5)
  gc_frame_newslot(strlit3198);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3199 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3200 = gc_frame_new();
// call case 3: self.outer request
  Object call3201 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3200);
// compiled call node returning call3201 (depth = 8)
// compiled member node returning call3201 (depth = 7)
  partcv[0] = 0;
  Object call3202 = callmethodflags(call3201, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3199);
// compiled call node returning call3202 (depth = 6)
// compiled member node returning call3202 (depth = 5)
  params[0] = self;
  params[1] = strlit3198;
  partcv[0] = 2;
  Object call3203 = callmethodflags(call3202, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3197);
// compiled call node returning call3203 (depth = 4)
  gc_frame_end(frame);
  return call3203;
}
Object meth_ast_isPublic3204(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPublic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isPublic (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isPublic");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 721
  setline(721);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3205 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3206 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3207 = callmethodflags(self, "isConfidential", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3206);
// compiled call node returning call3207 (depth = 7)
// compiled member node returning call3207 (depth = 6)
  partcv[0] = 0;
  Object call3208 = callmethod(call3207, "not",
    1, partcv, params);
  gc_frame_end(callframe3205);
// compiled call node returning call3208 (depth = 5)
// compiled member node returning call3208 (depth = 4)
  gc_frame_end(frame);
  return call3208;
}
Object meth_ast_isWritable3209(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isWritable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isWritable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isWritable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 722
  setline(722);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool3210 = alloc_Boolean(0);
// compiled identifier node returning bool3210 (depth = 4)
  gc_frame_end(frame);
  return bool3210;
}
Object meth_ast_isReadable3211(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isReadable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isReadable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isReadable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 723
  setline(723);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3212 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3213 = callmethodflags(self, "isPublic", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3212);
// compiled call node returning call3213 (depth = 5)
// compiled member node returning call3213 (depth = 4)
  gc_frame_end(frame);
  return call3213;
}
Object meth_ast__apply3237(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe3238 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_visitor (depth = 8)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_newChain (depth = 8)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3239 = callmethod(*var_each, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe3238);
// compiled call node returning call3239 (depth = 7)
  gc_frame_end(frame);
  return call3239;
}
Object meth_ast_accept_40__41_from3214(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 726
  setline(726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3216 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3217 = callmethod(*var_visitor, "visitTypeDec()up",
    2, partcv, params);
  gc_frame_end(callframe3216);
// compiled call node returning call3217 (depth = 5)
  Object if3215 = done;
  if (istrue(call3217)) {
// Begin line 727
  setline(727);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3218 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_as (depth = 7)
  params[0] = self;
  partcv[0] = 1;
  Object call3219 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe3218);
// compiled call node returning call3219 (depth = 6)
  *var_newChain = call3219;
  if (call3219 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 728
  setline(728);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3220 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3221 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3222 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3221);
// compiled call node returning call3222 (depth = 7)
// compiled member node returning call3222 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3223 = callmethod(call3222, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe3220);
// compiled call node returning call3223 (depth = 5)
// Begin line 729
  setline(729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool3226 = alloc_Boolean(0);
// compiled identifier node returning bool3226 (depth = 7)
  int op_slot_right_3225 = gc_frame_newslot(bool3226);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3228 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3229 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3228);
// compiled call node returning call3229 (depth = 8)
// compiled member node returning call3229 (depth = 7)
  int op_slot_left_3225 = gc_frame_newslot(call3229);
  params[0] = bool3226;
  partcv[0] = 1;
  Object opresult3230 = callmethod(call3229, "!=", 1, partcv, params);
// compiled op node returning opresult3230 (depth = 6)
  Object if3224 = done;
  if (istrue(opresult3230)) {
// Begin line 730
  setline(730);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3231 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3232 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3233 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3232);
// compiled call node returning call3233 (depth = 8)
// compiled member node returning call3233 (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3234 = callmethod(call3233, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe3231);
// compiled call node returning call3234 (depth = 6)
    gc_frame_newslot(call3234);
    if3224 = call3234;
  } else {
  }
// compiled if node returning if3224 (depth = 5)
// Begin line 732
  setline(732);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3235 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block3236 = alloc_Block(NULL, NULL, "ast", 732);
  gc_frame_newslot(block3236);
// method _apply
  block_savedest(block3236);
  Object closure3237 = createclosure(3, "_apply");
  setclosureframe(closure3237, stackframe);
  addtoclosure(closure3237, var_visitor);
  addtoclosure(closure3237, var_newChain);
  addtoclosure(closure3237, selfslot);
  struct UserObject *uo3237 = (struct UserObject*)block3236;
  uo3237->data[0] = (Object)closure3237;
  Method *meth_meth_ast__apply3237 = addmethod2pos(block3236, "_apply", &meth_ast__apply3237, 0);
  int argcv_meth_ast__apply3237[] = {1};
  meth_meth_ast__apply3237->type = alloc_MethodType(1, argcv_meth_ast__apply3237);
  meth_meth_ast__apply3237->definitionModule = modulename;
  meth_meth_ast__apply3237->definitionLine = 730;
// compiled block node returning block3236 (depth = 6)
  gc_frame_newslot(block3236);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3241 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3242 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3241);
// compiled call node returning call3242 (depth = 7)
// compiled member node returning call3242 (depth = 6)
  params[0] = block3236;
  partcv[0] = 1;
  Object call3243 = callmethod(call3242, "do",
    1, partcv, params);
  gc_frame_end(callframe3235);
// compiled call node returning call3243 (depth = 5)
// Begin line 733
  setline(733);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3244 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3245 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3246 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3245);
// compiled call node returning call3246 (depth = 7)
// compiled member node returning call3246 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3247 = callmethod(call3246, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe3244);
// compiled call node returning call3247 (depth = 5)
    gc_frame_newslot(call3247);
    if3215 = call3247;
  } else {
  }
// compiled if node returning if3215 (depth = 4)
  gc_frame_end(frame);
  return if3215;
}
Object meth_ast_map_40__41_ancestors3248(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 737
  setline(737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3249 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3250 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3249);
// compiled call node returning call3250 (depth = 6)
// compiled member node returning call3250 (depth = 5)
  *var_n = call3250;
  if (call3250 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 738
  setline(738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3251 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call3252 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe3251);
// compiled call node returning call3252 (depth = 5)
  *var_newChain = call3252;
  if (call3252 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 739
  setline(739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 737
  setline(737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3253 = gc_frame_new();
// Begin line 739
  setline(739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3254 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3255 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3256 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3255);
// compiled call node returning call3256 (depth = 8)
// compiled member node returning call3256 (depth = 7)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3257 = callmethod(call3256, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe3254);
// compiled call node returning call3257 (depth = 6)
  gc_frame_newslot(call3257);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call3257;
  partcv[0] = 1;
  Object call3258 = callmethod(*var_n, "name:=",
    1, partcv, params);
  gc_frame_end(callframe3253);
// compiled call node returning call3258 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 740
  setline(740);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 739
  setline(739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3259 = gc_frame_new();
// Begin line 740
  setline(740);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3260 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3261 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3262 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3261);
// compiled call node returning call3262 (depth = 8)
// compiled member node returning call3262 (depth = 7)
  gc_frame_newslot(call3262);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3263 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3264 = gc_frame_new();
// call case 3: self.outer request
  Object call3265 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3264);
// compiled call node returning call3265 (depth = 10)
// compiled member node returning call3265 (depth = 9)
  partcv[0] = 0;
  Object call3266 = callmethodflags(call3265, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3263);
// compiled call node returning call3266 (depth = 8)
// compiled member node returning call3266 (depth = 7)
  params[0] = call3262;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call3267 = callmethodflags(call3266, "maybeMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3260);
// compiled call node returning call3267 (depth = 6)
  gc_frame_newslot(call3267);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call3267;
  partcv[0] = 1;
  Object call3268 = callmethod(*var_n, "generics:=",
    1, partcv, params);
  gc_frame_end(callframe3259);
// compiled call node returning call3268 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 741
  setline(741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 740
  setline(740);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3269 = gc_frame_new();
// Begin line 741
  setline(741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3270 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3271 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3272 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3271);
// compiled call node returning call3272 (depth = 8)
// compiled member node returning call3272 (depth = 7)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3273 = callmethod(call3272, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe3270);
// compiled call node returning call3273 (depth = 6)
  gc_frame_newslot(call3273);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call3273;
  partcv[0] = 1;
  Object call3274 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe3269);
// compiled call node returning call3274 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 742
  setline(742);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 741
  setline(741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3275 = gc_frame_new();
// Begin line 742
  setline(742);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3276 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3277 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3278 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3277);
// compiled call node returning call3278 (depth = 8)
// compiled member node returning call3278 (depth = 7)
  gc_frame_newslot(call3278);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3279 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3280 = gc_frame_new();
// call case 3: self.outer request
  Object call3281 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3280);
// compiled call node returning call3281 (depth = 10)
// compiled member node returning call3281 (depth = 9)
  partcv[0] = 0;
  Object call3282 = callmethodflags(call3281, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3279);
// compiled call node returning call3282 (depth = 8)
// compiled member node returning call3282 (depth = 7)
  params[0] = call3278;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call3283 = callmethodflags(call3282, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3276);
// compiled call node returning call3283 (depth = 6)
  gc_frame_newslot(call3283);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call3283;
  partcv[0] = 1;
  Object call3284 = callmethod(*var_n, "annotations:=",
    1, partcv, params);
  gc_frame_end(callframe3275);
// compiled call node returning call3284 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 743
  setline(743);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3285 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call3286 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe3285);
// compiled call node returning call3286 (depth = 4)
  gc_frame_end(frame);
  return call3286;
}
Object meth_ast__apply3295(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 748
  setline(748);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3297 == NULL) {
    strlit3297 = alloc_String("  ");
    gc_root(strlit3297);
  }
// compiled string node returning strlit3297 (depth = 8)
  int op_slot_right_3296 = gc_frame_newslot(strlit3297);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_3296 = gc_frame_newslot(*var_spc);
  params[0] = strlit3297;
  partcv[0] = 1;
  Object opresult3299 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult3299 (depth = 7)
  *var_spc = opresult3299;
  if (opresult3299 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty3287(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 746
  setline(746);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3288 == NULL) {
    strlit3288 = alloc_String("");
    gc_root(strlit3288);
  }
// compiled string node returning strlit3288 (depth = 5)
  *var_spc = strlit3288;
  if (strlit3288 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 747
  setline(747);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3289 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_right_3290 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 6)
  Object num3292 = alloc_Float64(0);
// compiled num node returning num3292 (depth = 6)
  int op_slot_left_3290 = gc_frame_newslot(num3292);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult3293 = callmethod(num3292, "..", 1, partcv, params);
// compiled op node returning opresult3293 (depth = 5)
  gc_frame_newslot(opresult3293);
// starting to compile block node (depth = 5)
  Object block3294 = alloc_Block(NULL, NULL, "ast", 747);
  gc_frame_newslot(block3294);
// method _apply
  block_savedest(block3294);
  Object closure3295 = createclosure(2, "_apply");
  setclosureframe(closure3295, stackframe);
  addtoclosure(closure3295, var_spc);
  addtoclosure(closure3295, selfslot);
  struct UserObject *uo3295 = (struct UserObject*)block3294;
  uo3295->data[0] = (Object)closure3295;
  Method *meth_meth_ast__apply3295 = addmethod2pos(block3294, "_apply", &meth_ast__apply3295, 0);
  int argcv_meth_ast__apply3295[] = {1};
  meth_meth_ast__apply3295->type = alloc_MethodType(1, argcv_meth_ast__apply3295);
  meth_meth_ast__apply3295->definitionModule = modulename;
  meth_meth_ast__apply3295->definitionLine = 742;
// compiled block node returning block3294 (depth = 5)
  gc_frame_newslot(block3294);
// call case 5: prelude request
  params[0] = opresult3293;
  params[1] = block3294;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3302 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3289);
// compiled call node returning call3302 (depth = 4)
// Begin line 750
  setline(750);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3304 == NULL) {
    strlit3304 = alloc_String("""\x0a""");
    gc_root(strlit3304);
  }
// compiled string node returning strlit3304 (depth = 6)
  int op_slot_right_3303 = gc_frame_newslot(strlit3304);
// starting to compile call node (depth = 6)
  int callframe3306 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call3307 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe3306);
// compiled call node returning call3307 (depth = 6)
  int op_slot_left_3303 = gc_frame_newslot(call3307);
  params[0] = strlit3304;
  partcv[0] = 1;
  Object opresult3308 = callmethod(call3307, "++", 1, partcv, params);
// compiled op node returning opresult3308 (depth = 5)
  *var_s = opresult3308;
  if (opresult3308 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 751
  setline(751);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3310 == NULL) {
    strlit3310 = alloc_String("""\x0a""");
    gc_root(strlit3310);
  }
// compiled string node returning strlit3310 (depth = 6)
  int op_slot_right_3309 = gc_frame_newslot(strlit3310);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3313 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3315 = alloc_Float64(1);
// compiled num node returning num3315 (depth = 9)
  int op_slot_right_3314 = gc_frame_newslot(num3315);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_3314 = gc_frame_newslot(*var_depth);
  params[0] = num3315;
  partcv[0] = 1;
  Object sum3317 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum3317 (depth = 8)
  gc_frame_newslot(sum3317);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3318 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3319 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3318);
// compiled call node returning call3319 (depth = 9)
// compiled member node returning call3319 (depth = 8)
  params[0] = sum3317;
  partcv[0] = 1;
  Object call3320 = callmethod(call3319, "pretty",
    1, partcv, params);
  gc_frame_end(callframe3313);
// compiled call node returning call3320 (depth = 7)
  int op_slot_right_3312 = gc_frame_newslot(call3320);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_3322 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_3322 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3324 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3324 (depth = 7)
  int op_slot_left_3312 = gc_frame_newslot(opresult3324);
  params[0] = call3320;
  partcv[0] = 1;
  Object opresult3325 = callmethod(opresult3324, "++", 1, partcv, params);
// compiled op node returning opresult3325 (depth = 6)
  int op_slot_left_3309 = gc_frame_newslot(opresult3325);
  params[0] = strlit3310;
  partcv[0] = 1;
  Object opresult3326 = callmethod(opresult3325, "++", 1, partcv, params);
// compiled op node returning opresult3326 (depth = 5)
  *var_s = opresult3326;
  if (opresult3326 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 752
  setline(752);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3330 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3331 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3330);
// compiled call node returning call3331 (depth = 7)
// compiled member node returning call3331 (depth = 6)
  int op_slot_right_3329 = gc_frame_newslot(call3331);
// starting to compile identifier node (depth = 6)
  Object bool3333 = alloc_Boolean(0);
// compiled identifier node returning bool3333 (depth = 6)
  int op_slot_left_3329 = gc_frame_newslot(bool3333);
  params[0] = call3331;
  partcv[0] = 1;
  Object opresult3334 = callmethod(bool3333, "!=", 1, partcv, params);
// compiled op node returning opresult3334 (depth = 5)
  Object if3328 = done;
  if (istrue(opresult3334)) {
// Begin line 753
  setline(753);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3336 == NULL) {
    strlit3336 = alloc_String("""\x0a""");
    gc_root(strlit3336);
  }
// compiled string node returning strlit3336 (depth = 7)
  int op_slot_right_3335 = gc_frame_newslot(strlit3336);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3339 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num3341 = alloc_Float64(2);
// compiled num node returning num3341 (depth = 10)
  int op_slot_right_3340 = gc_frame_newslot(num3341);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_3340 = gc_frame_newslot(*var_depth);
  params[0] = num3341;
  partcv[0] = 1;
  Object sum3343 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum3343 (depth = 9)
  gc_frame_newslot(sum3343);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3344 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3345 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3344);
// compiled call node returning call3345 (depth = 10)
// compiled member node returning call3345 (depth = 9)
  params[0] = sum3343;
  partcv[0] = 1;
  Object call3346 = callmethod(call3345, "pretty",
    1, partcv, params);
  gc_frame_end(callframe3339);
// compiled call node returning call3346 (depth = 8)
  int op_slot_right_3338 = gc_frame_newslot(call3346);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3349 == NULL) {
    strlit3349 = alloc_String("Type parameters:""\x0a""");
    gc_root(strlit3349);
  }
// compiled string node returning strlit3349 (depth = 9)
  int op_slot_right_3348 = gc_frame_newslot(strlit3349);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_3351 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit3354 == NULL) {
    strlit3354 = alloc_String("");
    gc_root(strlit3354);
  }
// compiled string node returning strlit3354 (depth = 11)
  int op_slot_right_3353 = gc_frame_newslot(strlit3354);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_s (depth = 12)
  int op_slot_right_3356 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 12)
  if (strlit3358 == NULL) {
    strlit3358 = alloc_String("");
    gc_root(strlit3358);
  }
// compiled string node returning strlit3358 (depth = 12)
  int op_slot_left_3356 = gc_frame_newslot(strlit3358);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult3359 = callmethod(strlit3358, "++", 1, partcv, params);
// compiled op node returning opresult3359 (depth = 11)
  int op_slot_left_3353 = gc_frame_newslot(opresult3359);
  params[0] = strlit3354;
  partcv[0] = 1;
  Object opresult3360 = callmethod(opresult3359, "++", 1, partcv, params);
// compiled op node returning opresult3360 (depth = 10)
  int op_slot_left_3351 = gc_frame_newslot(opresult3360);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3361 = callmethod(opresult3360, "++", 1, partcv, params);
// compiled op node returning opresult3361 (depth = 9)
  int op_slot_left_3348 = gc_frame_newslot(opresult3361);
  params[0] = strlit3349;
  partcv[0] = 1;
  Object opresult3362 = callmethod(opresult3361, "++", 1, partcv, params);
// compiled op node returning opresult3362 (depth = 8)
  int op_slot_left_3338 = gc_frame_newslot(opresult3362);
  params[0] = call3346;
  partcv[0] = 1;
  Object opresult3363 = callmethod(opresult3362, "++", 1, partcv, params);
// compiled op node returning opresult3363 (depth = 7)
  int op_slot_left_3335 = gc_frame_newslot(opresult3363);
  params[0] = strlit3336;
  partcv[0] = 1;
  Object opresult3364 = callmethod(opresult3363, "++", 1, partcv, params);
// compiled op node returning opresult3364 (depth = 6)
  *var_s = opresult3364;
  if (opresult3364 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if3328 = done;
  } else {
  }
// compiled if node returning if3328 (depth = 4)
// Begin line 755
  setline(755);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3367 == NULL) {
    strlit3367 = alloc_String("Value:");
    gc_root(strlit3367);
  }
// compiled string node returning strlit3367 (depth = 6)
  int op_slot_right_3366 = gc_frame_newslot(strlit3367);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_3369 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_3369 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3371 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3371 (depth = 6)
  int op_slot_left_3366 = gc_frame_newslot(opresult3371);
  params[0] = strlit3367;
  partcv[0] = 1;
  Object opresult3372 = callmethod(opresult3371, "++", 1, partcv, params);
// compiled op node returning opresult3372 (depth = 5)
  *var_s = opresult3372;
  if (opresult3372 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 756
  setline(756);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3375 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num3377 = alloc_Float64(2);
// compiled num node returning num3377 (depth = 8)
  int op_slot_right_3376 = gc_frame_newslot(num3377);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_3376 = gc_frame_newslot(*var_depth);
  params[0] = num3377;
  partcv[0] = 1;
  Object sum3379 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum3379 (depth = 7)
  gc_frame_newslot(sum3379);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3380 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3381 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3380);
// compiled call node returning call3381 (depth = 8)
// compiled member node returning call3381 (depth = 7)
  params[0] = sum3379;
  partcv[0] = 1;
  Object call3382 = callmethod(call3381, "pretty",
    1, partcv, params);
  gc_frame_end(callframe3375);
// compiled call node returning call3382 (depth = 6)
  int op_slot_right_3374 = gc_frame_newslot(call3382);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_3374 = gc_frame_newslot(*var_s);
  params[0] = call3382;
  partcv[0] = 1;
  Object opresult3384 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3384 (depth = 5)
  *var_s = opresult3384;
  if (opresult3384 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 757
  setline(757);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3387 == NULL) {
    strlit3387 = alloc_String("""\x0a""");
    gc_root(strlit3387);
  }
// compiled string node returning strlit3387 (depth = 6)
  int op_slot_right_3386 = gc_frame_newslot(strlit3387);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_3386 = gc_frame_newslot(*var_s);
  params[0] = strlit3387;
  partcv[0] = 1;
  Object opresult3389 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3389 (depth = 5)
  *var_s = opresult3389;
  if (opresult3389 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 758
  setline(758);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3393 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3394 = callmethodflags(self, "comments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3393);
// compiled call node returning call3394 (depth = 7)
// compiled member node returning call3394 (depth = 6)
  int op_slot_right_3392 = gc_frame_newslot(call3394);
// starting to compile identifier node (depth = 6)
  Object bool3396 = alloc_Boolean(0);
// compiled identifier node returning bool3396 (depth = 6)
  int op_slot_left_3392 = gc_frame_newslot(bool3396);
  params[0] = call3394;
  partcv[0] = 1;
  Object opresult3397 = callmethod(bool3396, "!=", 1, partcv, params);
// compiled op node returning opresult3397 (depth = 5)
  Object if3391 = done;
  if (istrue(opresult3397)) {
// Begin line 759
  setline(759);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3399 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3401 = alloc_Float64(2);
// compiled num node returning num3401 (depth = 9)
  int op_slot_right_3400 = gc_frame_newslot(num3401);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_3400 = gc_frame_newslot(*var_depth);
  params[0] = num3401;
  partcv[0] = 1;
  Object sum3403 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum3403 (depth = 8)
  gc_frame_newslot(sum3403);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3404 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3405 = callmethodflags(self, "comments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3404);
// compiled call node returning call3405 (depth = 9)
// compiled member node returning call3405 (depth = 8)
  params[0] = sum3403;
  partcv[0] = 1;
  Object call3406 = callmethod(call3405, "pretty",
    1, partcv, params);
  gc_frame_end(callframe3399);
// compiled call node returning call3406 (depth = 7)
  int op_slot_right_3398 = gc_frame_newslot(call3406);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_3398 = gc_frame_newslot(*var_s);
  params[0] = call3406;
  partcv[0] = 1;
  Object opresult3408 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3408 (depth = 6)
  *var_s = opresult3408;
  if (opresult3408 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if3391 = done;
  } else {
  }
// compiled if node returning if3391 (depth = 4)
// Begin line 761
  setline(761);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply3422(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 766
  setline(766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3424 == NULL) {
    strlit3424 = alloc_String("    ");
    gc_root(strlit3424);
  }
// compiled string node returning strlit3424 (depth = 8)
  int op_slot_right_3423 = gc_frame_newslot(strlit3424);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_3423 = gc_frame_newslot(*var_spc);
  params[0] = strlit3424;
  partcv[0] = 1;
  Object opresult3426 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult3426 (depth = 7)
  *var_spc = opresult3426;
  if (opresult3426 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace3410(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 764
  setline(764);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3411 == NULL) {
    strlit3411 = alloc_String("");
    gc_root(strlit3411);
  }
// compiled string node returning strlit3411 (depth = 5)
  *var_spc = strlit3411;
  if (strlit3411 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 765
  setline(765);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3412 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num3415 = alloc_Float64(1);
// compiled num node returning num3415 (depth = 7)
  int op_slot_right_3414 = gc_frame_newslot(num3415);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_3414 = gc_frame_newslot(*var_depth);
  params[0] = num3415;
  partcv[0] = 1;
  Object diff3417 = callmethod(*var_depth, "-", 1, partcv, params);
// compiled op node returning diff3417 (depth = 6)
  int op_slot_right_3413 = gc_frame_newslot(diff3417);
// starting to compile num node (depth = 6)
  Object num3419 = alloc_Float64(0);
// compiled num node returning num3419 (depth = 6)
  int op_slot_left_3413 = gc_frame_newslot(num3419);
  params[0] = diff3417;
  partcv[0] = 1;
  Object opresult3420 = callmethod(num3419, "..", 1, partcv, params);
// compiled op node returning opresult3420 (depth = 5)
  gc_frame_newslot(opresult3420);
// starting to compile block node (depth = 5)
  Object block3421 = alloc_Block(NULL, NULL, "ast", 765);
  gc_frame_newslot(block3421);
// method _apply
  block_savedest(block3421);
  Object closure3422 = createclosure(2, "_apply");
  setclosureframe(closure3422, stackframe);
  addtoclosure(closure3422, var_spc);
  addtoclosure(closure3422, selfslot);
  struct UserObject *uo3422 = (struct UserObject*)block3421;
  uo3422->data[0] = (Object)closure3422;
  Method *meth_meth_ast__apply3422 = addmethod2pos(block3421, "_apply", &meth_ast__apply3422, 0);
  int argcv_meth_ast__apply3422[] = {1};
  meth_meth_ast__apply3422->type = alloc_MethodType(1, argcv_meth_ast__apply3422);
  meth_meth_ast__apply3422->definitionModule = modulename;
  meth_meth_ast__apply3422->definitionLine = 759;
// compiled block node returning block3421 (depth = 5)
  gc_frame_newslot(block3421);
// call case 5: prelude request
  params[0] = opresult3420;
  params[1] = block3421;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3429 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3412);
// compiled call node returning call3429 (depth = 4)
// Begin line 768
  setline(768);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3430 == NULL) {
    strlit3430 = alloc_String("");
    gc_root(strlit3430);
  }
// compiled string node returning strlit3430 (depth = 5)
  *var_s = strlit3430;
  if (strlit3430 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 769
  setline(769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3432 == NULL) {
    strlit3432 = alloc_String("");
    gc_root(strlit3432);
  }
// compiled string node returning strlit3432 (depth = 6)
  int op_slot_right_3431 = gc_frame_newslot(strlit3432);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3435 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3436 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3435);
// compiled call node returning call3436 (depth = 8)
// compiled member node returning call3436 (depth = 7)
  int op_slot_right_3434 = gc_frame_newslot(call3436);
// starting to compile string node (depth = 7)
  if (strlit3438 == NULL) {
    strlit3438 = alloc_String("type ");
    gc_root(strlit3438);
  }
// compiled string node returning strlit3438 (depth = 7)
  int op_slot_left_3434 = gc_frame_newslot(strlit3438);
  params[0] = call3436;
  partcv[0] = 1;
  Object opresult3439 = callmethod(strlit3438, "++", 1, partcv, params);
// compiled op node returning opresult3439 (depth = 6)
  int op_slot_left_3431 = gc_frame_newslot(opresult3439);
  params[0] = strlit3432;
  partcv[0] = 1;
  Object opresult3440 = callmethod(opresult3439, "++", 1, partcv, params);
// compiled op node returning opresult3440 (depth = 5)
  *var_s = opresult3440;
  if (opresult3440 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 770
  setline(770);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3444 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3445 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3444);
// compiled call node returning call3445 (depth = 7)
// compiled member node returning call3445 (depth = 6)
  int op_slot_right_3443 = gc_frame_newslot(call3445);
// starting to compile identifier node (depth = 6)
  Object bool3447 = alloc_Boolean(0);
// compiled identifier node returning bool3447 (depth = 6)
  int op_slot_left_3443 = gc_frame_newslot(bool3447);
  params[0] = call3445;
  partcv[0] = 1;
  Object opresult3448 = callmethod(bool3447, "!=", 1, partcv, params);
// compiled op node returning opresult3448 (depth = 5)
  Object if3442 = done;
  if (istrue(opresult3448)) {
// Begin line 771
  setline(771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3449 = gc_frame_new();
// starting to compile num node (depth = 6)
  Object num3450 = alloc_Float64(0);
// compiled num node returning num3450 (depth = 6)
  gc_frame_newslot(num3450);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3451 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3452 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3451);
// compiled call node returning call3452 (depth = 7)
// compiled member node returning call3452 (depth = 6)
  params[0] = num3450;
  partcv[0] = 1;
  Object call3453 = callmethod(call3452, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe3449);
// compiled call node returning call3453 (depth = 5)
    gc_frame_newslot(call3453);
    if3442 = call3453;
  } else {
  }
// compiled if node returning if3442 (depth = 4)
// Begin line 773
  setline(773);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3455 = gc_frame_new();
// starting to compile call node (depth = 6)
  int callframe3456 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num3458 = alloc_Float64(2);
// compiled num node returning num3458 (depth = 8)
  int op_slot_right_3457 = gc_frame_newslot(num3458);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_3457 = gc_frame_newslot(*var_depth);
  params[0] = num3458;
  partcv[0] = 1;
  Object sum3460 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum3460 (depth = 7)
  gc_frame_newslot(sum3460);
// call case 4: self request
  params[0] = sum3460;
  partcv[0] = 1;
  Object call3461 = callmethodflags(self, "toGrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3456);
// compiled call node returning call3461 (depth = 6)
  gc_frame_newslot(call3461);
// call case 4: self request
  params[0] = call3461;
  partcv[0] = 1;
  Object call3462 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3455);
// compiled call node returning call3462 (depth = 5)
  int op_slot_right_3454 = gc_frame_newslot(call3462);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3465 == NULL) {
    strlit3465 = alloc_String(" = ");
    gc_root(strlit3465);
  }
// compiled string node returning strlit3465 (depth = 6)
  int op_slot_right_3464 = gc_frame_newslot(strlit3465);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_3464 = gc_frame_newslot(*var_s);
  params[0] = strlit3465;
  partcv[0] = 1;
  Object opresult3467 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3467 (depth = 5)
  int op_slot_left_3454 = gc_frame_newslot(opresult3467);
  params[0] = call3462;
  partcv[0] = 1;
  Object opresult3468 = callmethod(opresult3467, "++", 1, partcv, params);
// compiled op node returning opresult3468 (depth = 4)
  gc_frame_end(frame);
  return opresult3468;
}
Object meth_ast_shallowCopy3469(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 17, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_typeDecNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 776
  setline(776);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3470 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe3471 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3472 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3473 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3472);
// compiled call node returning call3473 (depth = 7)
// compiled member node returning call3473 (depth = 6)
  gc_frame_newslot(call3473);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nullNode (depth = 6)
  gc_frame_newslot(*var_nullNode);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_typeDecNode (depth = 6)
  params[0] = call3473;
  params[1] = *var_nullNode;
  partcv[0] = 2;
  Object call3474 = callmethod(*var_typeDecNode, "new",
    1, partcv, params);
  gc_frame_end(callframe3471);
// compiled call node returning call3474 (depth = 5)
  params[0] = self;
  partcv[0] = 1;
  Object call3475 = callmethod(call3474, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe3470);
// compiled call node returning call3475 (depth = 4)
  gc_frame_end(frame);
  return call3475;
}
Object meth_ast_new3170(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_typeDecNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_typeValue = &(stackframe->slots[1]);
  *var_typeValue = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3171 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3171 = alloc_userobj2(22,19, objclass3171);
  gc_frame_newslot(obj3171);
if (objclass3171 == NULL) {
  glfree(obj3171->class->name);
  obj3171->class->name = "typeDecNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3171, self, 0);
  addmethodreal(obj3171,"outer", &reader_ast_outer_3172);
  Object oldself3171 = self;
  struct StackFrameObject *oldstackframe3171 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3171);
  gc_frame_newslot((Object)stackframe);
  self = obj3171;
  Object *oldselfslot3171 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3171 = (*(struct UserObject *)self).data[0], lowerouter3171 = thisouter3171;
  if (inheritingObject3171) {
    struct UserObject *inho3171 = (struct UserObject *)inheritingObject3171;
    while (inho3171->super != GraceDefaultObject) inho3171 = (struct UserObject *)inho3171->super;
    inho3171->super = obj3171;
    self = inheritingObject3171;
    *selfslot = self;
    lowerouter3171 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3171;
  }
if (objclass3171 == NULL) {
  Method *reader3173 = addmethodrealflags(obj3171, "kind",&reader_ast_kind_3173, MFLAG_DEF);
  reader3173->definitionModule = modulename;
  reader3173->definitionLine = 701;
}
adddatum2(obj3171, alloc_Undefined(), 1);
if (objclass3171 == NULL) {
  Method *reader3174 = addmethodrealflags(obj3171, "name",&reader_ast_name_3174, 0);
  Method *writer3174 = addmethodrealflags(obj3171, "name:=",&writer_ast_name_3174, 0);
  reader3174->definitionModule = modulename;
  writer3174->definitionModule = modulename;
  reader3174->definitionLine = 702;
  writer3174->definitionLine = 702;
}
obj3171->flags |= OFLAG_MUTABLE;
adddatum2(obj3171, alloc_Undefined(), 2);
if (objclass3171 == NULL) {
  Method *reader3175 = addmethodrealflags(obj3171, "value",&reader_ast_value_3175, 0);
  Method *writer3175 = addmethodrealflags(obj3171, "value:=",&writer_ast_value_3175, 0);
  reader3175->definitionModule = modulename;
  writer3175->definitionModule = modulename;
  reader3175->definitionLine = 703;
  writer3175->definitionLine = 703;
}
obj3171->flags |= OFLAG_MUTABLE;
adddatum2(obj3171, alloc_Undefined(), 3);
if (objclass3171 == NULL) {
  Method *reader3176 = addmethodrealflags(obj3171, "nameString",&reader_ast_nameString_3176, MFLAG_DEF);
  reader3176->definitionModule = modulename;
  reader3176->definitionLine = 704;
}
adddatum2(obj3171, alloc_Undefined(), 4);
if (objclass3171 == NULL) {
  Method *reader3177 = addmethodrealflags(obj3171, "annotations",&reader_ast_annotations_3177, 0);
  Method *writer3177 = addmethodrealflags(obj3171, "annotations:=",&writer_ast_annotations_3177, 0);
  reader3177->definitionModule = modulename;
  writer3177->definitionModule = modulename;
  reader3177->definitionLine = 705;
  writer3177->definitionLine = 705;
}
obj3171->flags |= OFLAG_MUTABLE;
adddatum2(obj3171, alloc_Undefined(), 5);
if (objclass3171 == NULL) {
  Method *reader3178 = addmethodrealflags(obj3171, "generics",&reader_ast_generics_3178, 0);
  Method *writer3178 = addmethodrealflags(obj3171, "generics:=",&writer_ast_generics_3178, 0);
  reader3178->definitionModule = modulename;
  writer3178->definitionModule = modulename;
  reader3178->definitionLine = 706;
  writer3178->definitionLine = 706;
}
obj3171->flags |= OFLAG_MUTABLE;
adddatum2(obj3171, alloc_Undefined(), 6);
// method scope:=
  struct UserObject *uo3179 = (struct UserObject*)obj3171;
  uo3179->data[7] = emptyclosure;
  Method *meth_meth_ast_scope_58__61_3179 = addmethod2pos(obj3171, "scope:=", &meth_ast_scope_58__61_3179, 7);
  int argcv_meth_ast_scope_58__61_3179[] = {1};
  meth_meth_ast_scope_58__61_3179->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61_3179);
  meth_meth_ast_scope_58__61_3179->definitionModule = modulename;
  meth_meth_ast_scope_58__61_3179->definitionLine = 708;
// method declarationKindWithAncestors
  struct UserObject *uo3184 = (struct UserObject*)obj3171;
  uo3184->data[8] = emptyclosure;
  Method *meth_meth_ast_declarationKindWithAncestors3184 = addmethod2pos(obj3171, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors3184, 8);
  int argcv_meth_ast_declarationKindWithAncestors3184[] = {1};
  meth_meth_ast_declarationKindWithAncestors3184->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors3184);
  meth_meth_ast_declarationKindWithAncestors3184->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors3184->definitionLine = 714;
// method isConfidential
  struct UserObject *uo3186 = (struct UserObject*)obj3171;
  uo3186->data[9] = emptyclosure;
  Method *meth_meth_ast_isConfidential3186 = addmethod2pos(obj3171, "isConfidential", &meth_ast_isConfidential3186, 9);
  int argcv_meth_ast_isConfidential3186[] = {0};
  meth_meth_ast_isConfidential3186->type = alloc_MethodType(1, argcv_meth_ast_isConfidential3186);
  meth_meth_ast_isConfidential3186->definitionModule = modulename;
  meth_meth_ast_isConfidential3186->definitionLine = 717;
// method isPublic
  struct UserObject *uo3204 = (struct UserObject*)obj3171;
  uo3204->data[10] = emptyclosure;
  Method *meth_meth_ast_isPublic3204 = addmethod2pos(obj3171, "isPublic", &meth_ast_isPublic3204, 10);
  int argcv_meth_ast_isPublic3204[] = {0};
  meth_meth_ast_isPublic3204->type = alloc_MethodType(1, argcv_meth_ast_isPublic3204);
  meth_meth_ast_isPublic3204->definitionModule = modulename;
  meth_meth_ast_isPublic3204->definitionLine = 721;
// method isWritable
  struct UserObject *uo3209 = (struct UserObject*)obj3171;
  uo3209->data[11] = emptyclosure;
  Method *meth_meth_ast_isWritable3209 = addmethod2pos(obj3171, "isWritable", &meth_ast_isWritable3209, 11);
  int argcv_meth_ast_isWritable3209[] = {0};
  meth_meth_ast_isWritable3209->type = alloc_MethodType(1, argcv_meth_ast_isWritable3209);
  meth_meth_ast_isWritable3209->definitionModule = modulename;
  meth_meth_ast_isWritable3209->definitionLine = 722;
// method isReadable
  struct UserObject *uo3211 = (struct UserObject*)obj3171;
  uo3211->data[12] = emptyclosure;
  Method *meth_meth_ast_isReadable3211 = addmethod2pos(obj3171, "isReadable", &meth_ast_isReadable3211, 12);
  int argcv_meth_ast_isReadable3211[] = {0};
  meth_meth_ast_isReadable3211->type = alloc_MethodType(1, argcv_meth_ast_isReadable3211);
  meth_meth_ast_isReadable3211->definitionModule = modulename;
  meth_meth_ast_isReadable3211->definitionLine = 723;
// method accept()from
  struct UserObject *uo3214 = (struct UserObject*)obj3171;
  uo3214->data[13] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from3214 = addmethod2pos(obj3171, "accept()from", &meth_ast_accept_40__41_from3214, 13);
  int argcv_meth_ast_accept_40__41_from3214[] = {1, 1};
  meth_meth_ast_accept_40__41_from3214->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from3214);
  meth_meth_ast_accept_40__41_from3214->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from3214->definitionLine = 725;
// method map()ancestors
  struct UserObject *uo3248 = (struct UserObject*)obj3171;
  uo3248->data[14] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors3248 = addmethod2pos(obj3171, "map()ancestors", &meth_ast_map_40__41_ancestors3248, 14);
  int argcv_meth_ast_map_40__41_ancestors3248[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors3248->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors3248);
  meth_meth_ast_map_40__41_ancestors3248->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors3248->definitionLine = 736;
// method pretty
  struct UserObject *uo3287 = (struct UserObject*)obj3171;
  uo3287->data[15] = emptyclosure;
  Method *meth_meth_ast_pretty3287 = addmethod2pos(obj3171, "pretty", &meth_ast_pretty3287, 15);
  int argcv_meth_ast_pretty3287[] = {1};
  meth_meth_ast_pretty3287->type = alloc_MethodType(1, argcv_meth_ast_pretty3287);
  meth_meth_ast_pretty3287->definitionModule = modulename;
  meth_meth_ast_pretty3287->definitionLine = 745;
// method toGrace
  struct UserObject *uo3410 = (struct UserObject*)obj3171;
  uo3410->data[16] = emptyclosure;
  Method *meth_meth_ast_toGrace3410 = addmethod2pos(obj3171, "toGrace", &meth_ast_toGrace3410, 16);
  int argcv_meth_ast_toGrace3410[] = {1};
  meth_meth_ast_toGrace3410->type = alloc_MethodType(1, argcv_meth_ast_toGrace3410);
meth_meth_ast_toGrace3410->type->types[0] = type_Number;
meth_meth_ast_toGrace3410->type->names[0] = "depth";
  meth_meth_ast_toGrace3410->definitionModule = modulename;
  meth_meth_ast_toGrace3410->definitionLine = 763;
// method shallowCopy
  block_savedest(obj3171);
  Object closure3469 = createclosure(2, "shallowCopy");
  setclosureframe(closure3469, stackframe);
  addtoclosure(closure3469, var_nullNode);
  addtoclosure(closure3469, var_typeDecNode);
  struct UserObject *uo3469 = (struct UserObject*)obj3171;
  uo3469->data[17] = (Object)closure3469;
  Method *meth_meth_ast_shallowCopy3469 = addmethod2pos(obj3171, "shallowCopy", &meth_ast_shallowCopy3469, 17);
  int argcv_meth_ast_shallowCopy3469[] = {0};
  meth_meth_ast_shallowCopy3469->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy3469);
  meth_meth_ast_shallowCopy3469->definitionModule = modulename;
  meth_meth_ast_shallowCopy3469->definitionLine = 775;
  sourceObject = obj3171;
// Begin line 700
  setline(700);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3476 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3477 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe3476);
// compiled call node returning call3477 (depth = 4)
  struct UserObject *obj3171_uo = (struct UserObject *)obj3171;
  obj3171_uo->super = call3477;
  sourceObject = obj3171;
// Begin line 701
  setline(701);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit3478 == NULL) {
    strlit3478 = alloc_String("typedec");
    gc_root(strlit3478);
  }
// compiled string node returning strlit3478 (depth = 4)
  adddatum2(obj3171, strlit3478, 1);
  sourceObject = obj3171;
// Begin line 702
  setline(702);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_name_39_ (depth = 4)
  adddatum2(obj3171, *var_name_39_, 2);
  sourceObject = obj3171;
// Begin line 703
  setline(703);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_typeValue (depth = 4)
  adddatum2(obj3171, *var_typeValue, 3);
  sourceObject = obj3171;
// Begin line 704
  setline(704);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3479 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3480 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3481 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3480);
// compiled call node returning call3481 (depth = 7)
// compiled member node returning call3481 (depth = 6)
  partcv[0] = 0;
  Object call3482 = callmethod(call3481, "value",
    1, partcv, params);
  gc_frame_end(callframe3479);
// compiled call node returning call3482 (depth = 5)
// compiled member node returning call3482 (depth = 4)
  adddatum2(obj3171, call3482, 4);
  sourceObject = obj3171;
// Begin line 705
  setline(705);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3483 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3484 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call3485 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3484);
// compiled call node returning call3485 (depth = 7)
// compiled member node returning call3485 (depth = 6)
  partcv[0] = 0;
  Object call3486 = callmethod(call3485, "empty",
    1, partcv, params);
  gc_frame_end(callframe3483);
// compiled call node returning call3486 (depth = 5)
// compiled member node returning call3486 (depth = 4)
  adddatum2(obj3171, call3486, 5);
  sourceObject = obj3171;
// Begin line 706
  setline(706);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool3487 = alloc_Boolean(0);
// compiled identifier node returning bool3487 (depth = 4)
  adddatum2(obj3171, bool3487, 6);
  sourceObject = obj3171;
  sourceObject = obj3171;
  sourceObject = obj3171;
  sourceObject = obj3171;
  sourceObject = obj3171;
  sourceObject = obj3171;
  sourceObject = obj3171;
  sourceObject = obj3171;
  sourceObject = obj3171;
  sourceObject = obj3171;
  sourceObject = obj3171;
  objclass3171 = obj3171->class;
  objclass3171->definitionModule = modulename;
  objclass3171->definitionLine = 699;
  (*(struct UserObject *)self).data[0] = lowerouter3171;
  self = oldself3171;
  selfslot = oldselfslot3171;
  stackframe = oldstackframe3171;
  gc_frame_end(frame);
  return obj3171;
}
Object meth_ast_new3170_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_typeDecNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_typeValue = &(stackframe->slots[1]);
  *var_typeValue = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3171 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3171 = alloc_userobj2(22,19, objclass3171);
  gc_frame_newslot(obj3171);
if (objclass3171 == NULL) {
  glfree(obj3171->class->name);
  obj3171->class->name = "typeDecNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3171, self, 0);
  addmethodreal(obj3171,"outer", &reader_ast_outer_3172);
  Object oldself3171 = self;
  struct StackFrameObject *oldstackframe3171 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3171);
  gc_frame_newslot((Object)stackframe);
  self = obj3171;
  Object *oldselfslot3171 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3171 = (*(struct UserObject *)self).data[0], lowerouter3171 = thisouter3171;
  if (inheritingObject3171) {
    struct UserObject *inho3171 = (struct UserObject *)inheritingObject3171;
    while (inho3171->super != GraceDefaultObject) inho3171 = (struct UserObject *)inho3171->super;
    inho3171->super = obj3171;
    self = inheritingObject3171;
    *selfslot = self;
    lowerouter3171 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3171;
  }
if (objclass3171 == NULL) {
  Method *reader3173 = addmethodrealflags(obj3171, "kind",&reader_ast_kind_3173, MFLAG_DEF);
  reader3173->definitionModule = modulename;
  reader3173->definitionLine = 701;
}
adddatum2(obj3171, alloc_Undefined(), 1);
if (objclass3171 == NULL) {
  Method *reader3174 = addmethodrealflags(obj3171, "name",&reader_ast_name_3174, 0);
  Method *writer3174 = addmethodrealflags(obj3171, "name:=",&writer_ast_name_3174, 0);
  reader3174->definitionModule = modulename;
  writer3174->definitionModule = modulename;
  reader3174->definitionLine = 702;
  writer3174->definitionLine = 702;
}
obj3171->flags |= OFLAG_MUTABLE;
adddatum2(obj3171, alloc_Undefined(), 2);
if (objclass3171 == NULL) {
  Method *reader3175 = addmethodrealflags(obj3171, "value",&reader_ast_value_3175, 0);
  Method *writer3175 = addmethodrealflags(obj3171, "value:=",&writer_ast_value_3175, 0);
  reader3175->definitionModule = modulename;
  writer3175->definitionModule = modulename;
  reader3175->definitionLine = 703;
  writer3175->definitionLine = 703;
}
obj3171->flags |= OFLAG_MUTABLE;
adddatum2(obj3171, alloc_Undefined(), 3);
if (objclass3171 == NULL) {
  Method *reader3176 = addmethodrealflags(obj3171, "nameString",&reader_ast_nameString_3176, MFLAG_DEF);
  reader3176->definitionModule = modulename;
  reader3176->definitionLine = 704;
}
adddatum2(obj3171, alloc_Undefined(), 4);
if (objclass3171 == NULL) {
  Method *reader3177 = addmethodrealflags(obj3171, "annotations",&reader_ast_annotations_3177, 0);
  Method *writer3177 = addmethodrealflags(obj3171, "annotations:=",&writer_ast_annotations_3177, 0);
  reader3177->definitionModule = modulename;
  writer3177->definitionModule = modulename;
  reader3177->definitionLine = 705;
  writer3177->definitionLine = 705;
}
obj3171->flags |= OFLAG_MUTABLE;
adddatum2(obj3171, alloc_Undefined(), 5);
if (objclass3171 == NULL) {
  Method *reader3178 = addmethodrealflags(obj3171, "generics",&reader_ast_generics_3178, 0);
  Method *writer3178 = addmethodrealflags(obj3171, "generics:=",&writer_ast_generics_3178, 0);
  reader3178->definitionModule = modulename;
  writer3178->definitionModule = modulename;
  reader3178->definitionLine = 706;
  writer3178->definitionLine = 706;
}
obj3171->flags |= OFLAG_MUTABLE;
adddatum2(obj3171, alloc_Undefined(), 6);
// method scope:=
  struct UserObject *uo3179 = (struct UserObject*)obj3171;
  uo3179->data[7] = emptyclosure;
  Method *meth_meth_ast_scope_58__61_3179 = addmethod2pos(obj3171, "scope:=", &meth_ast_scope_58__61_3179, 7);
  int argcv_meth_ast_scope_58__61_3179[] = {1};
  meth_meth_ast_scope_58__61_3179->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61_3179);
  meth_meth_ast_scope_58__61_3179->definitionModule = modulename;
  meth_meth_ast_scope_58__61_3179->definitionLine = 708;
// method declarationKindWithAncestors
  struct UserObject *uo3184 = (struct UserObject*)obj3171;
  uo3184->data[8] = emptyclosure;
  Method *meth_meth_ast_declarationKindWithAncestors3184 = addmethod2pos(obj3171, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors3184, 8);
  int argcv_meth_ast_declarationKindWithAncestors3184[] = {1};
  meth_meth_ast_declarationKindWithAncestors3184->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors3184);
  meth_meth_ast_declarationKindWithAncestors3184->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors3184->definitionLine = 714;
// method isConfidential
  struct UserObject *uo3186 = (struct UserObject*)obj3171;
  uo3186->data[9] = emptyclosure;
  Method *meth_meth_ast_isConfidential3186 = addmethod2pos(obj3171, "isConfidential", &meth_ast_isConfidential3186, 9);
  int argcv_meth_ast_isConfidential3186[] = {0};
  meth_meth_ast_isConfidential3186->type = alloc_MethodType(1, argcv_meth_ast_isConfidential3186);
  meth_meth_ast_isConfidential3186->definitionModule = modulename;
  meth_meth_ast_isConfidential3186->definitionLine = 717;
// method isPublic
  struct UserObject *uo3204 = (struct UserObject*)obj3171;
  uo3204->data[10] = emptyclosure;
  Method *meth_meth_ast_isPublic3204 = addmethod2pos(obj3171, "isPublic", &meth_ast_isPublic3204, 10);
  int argcv_meth_ast_isPublic3204[] = {0};
  meth_meth_ast_isPublic3204->type = alloc_MethodType(1, argcv_meth_ast_isPublic3204);
  meth_meth_ast_isPublic3204->definitionModule = modulename;
  meth_meth_ast_isPublic3204->definitionLine = 721;
// method isWritable
  struct UserObject *uo3209 = (struct UserObject*)obj3171;
  uo3209->data[11] = emptyclosure;
  Method *meth_meth_ast_isWritable3209 = addmethod2pos(obj3171, "isWritable", &meth_ast_isWritable3209, 11);
  int argcv_meth_ast_isWritable3209[] = {0};
  meth_meth_ast_isWritable3209->type = alloc_MethodType(1, argcv_meth_ast_isWritable3209);
  meth_meth_ast_isWritable3209->definitionModule = modulename;
  meth_meth_ast_isWritable3209->definitionLine = 722;
// method isReadable
  struct UserObject *uo3211 = (struct UserObject*)obj3171;
  uo3211->data[12] = emptyclosure;
  Method *meth_meth_ast_isReadable3211 = addmethod2pos(obj3171, "isReadable", &meth_ast_isReadable3211, 12);
  int argcv_meth_ast_isReadable3211[] = {0};
  meth_meth_ast_isReadable3211->type = alloc_MethodType(1, argcv_meth_ast_isReadable3211);
  meth_meth_ast_isReadable3211->definitionModule = modulename;
  meth_meth_ast_isReadable3211->definitionLine = 723;
// method accept()from
  struct UserObject *uo3214 = (struct UserObject*)obj3171;
  uo3214->data[13] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from3214 = addmethod2pos(obj3171, "accept()from", &meth_ast_accept_40__41_from3214, 13);
  int argcv_meth_ast_accept_40__41_from3214[] = {1, 1};
  meth_meth_ast_accept_40__41_from3214->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from3214);
  meth_meth_ast_accept_40__41_from3214->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from3214->definitionLine = 725;
// method map()ancestors
  struct UserObject *uo3248 = (struct UserObject*)obj3171;
  uo3248->data[14] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors3248 = addmethod2pos(obj3171, "map()ancestors", &meth_ast_map_40__41_ancestors3248, 14);
  int argcv_meth_ast_map_40__41_ancestors3248[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors3248->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors3248);
  meth_meth_ast_map_40__41_ancestors3248->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors3248->definitionLine = 736;
// method pretty
  struct UserObject *uo3287 = (struct UserObject*)obj3171;
  uo3287->data[15] = emptyclosure;
  Method *meth_meth_ast_pretty3287 = addmethod2pos(obj3171, "pretty", &meth_ast_pretty3287, 15);
  int argcv_meth_ast_pretty3287[] = {1};
  meth_meth_ast_pretty3287->type = alloc_MethodType(1, argcv_meth_ast_pretty3287);
  meth_meth_ast_pretty3287->definitionModule = modulename;
  meth_meth_ast_pretty3287->definitionLine = 745;
// method toGrace
  struct UserObject *uo3410 = (struct UserObject*)obj3171;
  uo3410->data[16] = emptyclosure;
  Method *meth_meth_ast_toGrace3410 = addmethod2pos(obj3171, "toGrace", &meth_ast_toGrace3410, 16);
  int argcv_meth_ast_toGrace3410[] = {1};
  meth_meth_ast_toGrace3410->type = alloc_MethodType(1, argcv_meth_ast_toGrace3410);
meth_meth_ast_toGrace3410->type->types[0] = type_Number;
meth_meth_ast_toGrace3410->type->names[0] = "depth";
  meth_meth_ast_toGrace3410->definitionModule = modulename;
  meth_meth_ast_toGrace3410->definitionLine = 763;
// method shallowCopy
  block_savedest(obj3171);
  Object closure3469 = createclosure(2, "shallowCopy");
  setclosureframe(closure3469, stackframe);
  addtoclosure(closure3469, var_nullNode);
  addtoclosure(closure3469, var_typeDecNode);
  struct UserObject *uo3469 = (struct UserObject*)obj3171;
  uo3469->data[17] = (Object)closure3469;
  Method *meth_meth_ast_shallowCopy3469 = addmethod2pos(obj3171, "shallowCopy", &meth_ast_shallowCopy3469, 17);
  int argcv_meth_ast_shallowCopy3469[] = {0};
  meth_meth_ast_shallowCopy3469->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy3469);
  meth_meth_ast_shallowCopy3469->definitionModule = modulename;
  meth_meth_ast_shallowCopy3469->definitionLine = 775;
  sourceObject = obj3171;
// Begin line 700
  setline(700);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3476 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3477 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe3476);
// compiled call node returning call3477 (depth = 4)
  struct UserObject *obj3171_uo = (struct UserObject *)obj3171;
  obj3171_uo->super = call3477;
  sourceObject = obj3171;
// Begin line 701
  setline(701);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit3478 == NULL) {
    strlit3478 = alloc_String("typedec");
    gc_root(strlit3478);
  }
// compiled string node returning strlit3478 (depth = 4)
  adddatum2(obj3171, strlit3478, 1);
  sourceObject = obj3171;
// Begin line 702
  setline(702);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_name_39_ (depth = 4)
  adddatum2(obj3171, *var_name_39_, 2);
  sourceObject = obj3171;
// Begin line 703
  setline(703);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_typeValue (depth = 4)
  adddatum2(obj3171, *var_typeValue, 3);
  sourceObject = obj3171;
// Begin line 704
  setline(704);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3479 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3480 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3481 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3480);
// compiled call node returning call3481 (depth = 7)
// compiled member node returning call3481 (depth = 6)
  partcv[0] = 0;
  Object call3482 = callmethod(call3481, "value",
    1, partcv, params);
  gc_frame_end(callframe3479);
// compiled call node returning call3482 (depth = 5)
// compiled member node returning call3482 (depth = 4)
  adddatum2(obj3171, call3482, 4);
  sourceObject = obj3171;
// Begin line 705
  setline(705);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3483 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3484 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call3485 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3484);
// compiled call node returning call3485 (depth = 7)
// compiled member node returning call3485 (depth = 6)
  partcv[0] = 0;
  Object call3486 = callmethod(call3485, "empty",
    1, partcv, params);
  gc_frame_end(callframe3483);
// compiled call node returning call3486 (depth = 5)
// compiled member node returning call3486 (depth = 4)
  adddatum2(obj3171, call3486, 5);
  sourceObject = obj3171;
// Begin line 706
  setline(706);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool3487 = alloc_Boolean(0);
// compiled identifier node returning bool3487 (depth = 4)
  adddatum2(obj3171, bool3487, 6);
  sourceObject = obj3171;
  sourceObject = obj3171;
  sourceObject = obj3171;
  sourceObject = obj3171;
  sourceObject = obj3171;
  sourceObject = obj3171;
  sourceObject = obj3171;
  sourceObject = obj3171;
  sourceObject = obj3171;
  sourceObject = obj3171;
  sourceObject = obj3171;
  objclass3171 = obj3171->class;
  objclass3171->definitionModule = modulename;
  objclass3171->definitionLine = 699;
  (*(struct UserObject *)self).data[0] = lowerouter3171;
  self = oldself3171;
  selfslot = oldselfslot3171;
  stackframe = oldstackframe3171;
  gc_frame_end(frame);
  return obj3171;
}
Object meth_ast_new_40__41_scope3491(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(7, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new()scope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 4)
    gracedie("insufficient arguments to method new()scope");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method new()scope");
  Object params[4];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for new()scope (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_name = &(stackframe->slots[0]);
  *var_name = args[curarg];
  curarg++;
  Object *var_signature = &(stackframe->slots[1]);
  *var_signature = args[curarg];
  curarg++;
  Object *var_body = &(stackframe->slots[2]);
  *var_body = args[curarg];
  curarg++;
  Object *var_dtype = &(stackframe->slots[3]);
  *var_dtype = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 4)
    gracedie("wrong number of arguments for new");
  Object *var_s = &(stackframe->slots[4]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for scope");
  Object *selfslot = &(stackframe->slots[5]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "result");
// Begin line 782
  setline(782);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3492 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_name (depth = 5)
  gc_frame_newslot(*var_name);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_signature (depth = 5)
  gc_frame_newslot(*var_signature);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_body (depth = 5)
  gc_frame_newslot(*var_body);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dtype (depth = 5)
  gc_frame_newslot(*var_dtype);
// call case 4: self request
  params[0] = *var_name;
  params[1] = *var_signature;
  params[2] = *var_body;
  params[3] = *var_dtype;
  partcv[0] = 4;
  Object call3493 = callmethodflags(self, "new", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3492);
// compiled call node returning call3493 (depth = 4)
  *var_result = call3493;
  if (call3493 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 783
  setline(783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 705
  setline(705);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3494 = gc_frame_new();
// Begin line 783
  setline(783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  gc_frame_newslot(*var_s);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call3495 = callmethod(*var_result, "scope:=",
    1, partcv, params);
  gc_frame_end(callframe3494);
// compiled call node returning call3495 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 784
  setline(784);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_scope_58__61_3510(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "scope:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method scope:=");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for scope:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_st = &(stackframe->slots[0]);
  *var_st = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for scope:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 810
  setline(810);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 705
  setline(705);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3511 = gc_frame_new();
// Begin line 810
  setline(810);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_st (depth = 5)
  gc_frame_newslot(*var_st);
// call case 4: self request
  params[0] = *var_st;
  partcv[0] = 1;
  Object call3512 = callmethodflags(self, "symbolTable:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3511);
// compiled call node returning call3512 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 811
  setline(811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 705
  setline(705);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3513 = gc_frame_new();
// Begin line 811
  setline(811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_st (depth = 5)
  params[0] = self;
  partcv[0] = 1;
  Object call3514 = callmethod(*var_st, "node:=",
    1, partcv, params);
  gc_frame_end(callframe3513);
// compiled call node returning call3514 (depth = 4)
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_declarationKindWithAncestors3515(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "declarationKindWithAncestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method declarationKindWithAncestors");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for declarationKindWithAncestors (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for declarationKindWithAncestors");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 814
  setline(814);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit3516 == NULL) {
    strlit3516 = alloc_String("parameter");
    gc_root(strlit3516);
  }
// compiled string node returning strlit3516 (depth = 3)
  gc_frame_end(frame);
  return strlit3516;
}
Object meth_ast_isConfidential3517(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isConfidential");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isConfidential (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isConfidential");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 817
  setline(817);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3520 = alloc_Float64(0);
// compiled num node returning num3520 (depth = 5)
  int op_slot_right_3519 = gc_frame_newslot(num3520);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3522 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3523 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3524 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3523);
// compiled call node returning call3524 (depth = 8)
// compiled member node returning call3524 (depth = 7)
  partcv[0] = 0;
  Object call3525 = callmethod(call3524, "size",
    1, partcv, params);
  gc_frame_end(callframe3522);
// compiled call node returning call3525 (depth = 6)
// compiled member node returning call3525 (depth = 5)
  int op_slot_left_3519 = gc_frame_newslot(call3525);
  params[0] = num3520;
  partcv[0] = 1;
  Object opresult3526 = callmethod(call3525, "==", 1, partcv, params);
// compiled op node returning opresult3526 (depth = 4)
  Object if3518 = done;
  if (istrue(opresult3526)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool3527 = alloc_Boolean(0);
// compiled identifier node returning bool3527 (depth = 5)
  return bool3527;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if3518 = undefined;
  } else {
  }
// compiled if node returning if3518 (depth = 3)
// Begin line 818
  setline(818);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3528 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile string node (depth = 4)
  if (strlit3529 == NULL) {
    strlit3529 = alloc_String("confidential");
    gc_root(strlit3529);
  }
// compiled string node returning strlit3529 (depth = 4)
  gc_frame_newslot(strlit3529);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3530 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3531 = gc_frame_new();
// call case 3: self.outer request
  Object call3532 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3531);
// compiled call node returning call3532 (depth = 7)
// compiled member node returning call3532 (depth = 6)
  partcv[0] = 0;
  Object call3533 = callmethodflags(call3532, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3530);
// compiled call node returning call3533 (depth = 5)
// compiled member node returning call3533 (depth = 4)
  params[0] = self;
  params[1] = strlit3529;
  partcv[0] = 2;
  Object call3534 = callmethodflags(call3533, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3528);
// compiled call node returning call3534 (depth = 3)
  gc_frame_end(frame);
  return call3534;
}
Object meth_ast_isPublic3535(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPublic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isPublic (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isPublic");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 820
  setline(820);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3536 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3537 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3538 = callmethodflags(self, "isConfidential", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3537);
// compiled call node returning call3538 (depth = 6)
// compiled member node returning call3538 (depth = 5)
  partcv[0] = 0;
  Object call3539 = callmethod(call3538, "not",
    1, partcv, params);
  gc_frame_end(callframe3536);
// compiled call node returning call3539 (depth = 4)
// compiled member node returning call3539 (depth = 3)
  gc_frame_end(frame);
  return call3539;
}
Object meth_ast_isWritable3540(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isWritable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isWritable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isWritable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 821
  setline(821);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3541 = alloc_Boolean(0);
// compiled identifier node returning bool3541 (depth = 3)
  gc_frame_end(frame);
  return bool3541;
}
Object meth_ast_isReadable3542(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isReadable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isReadable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isReadable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 822
  setline(822);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3543 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3544 = callmethodflags(self, "isPublic", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3543);
// compiled call node returning call3544 (depth = 4)
// compiled member node returning call3544 (depth = 3)
  gc_frame_end(frame);
  return call3544;
}
Object meth_ast_usesAsType3545(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "usesAsType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method usesAsType");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for usesAsType (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aNode = &(stackframe->slots[0]);
  *var_aNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for usesAsType");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 824
  setline(824);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3547 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3548 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3547);
// compiled call node returning call3548 (depth = 5)
// compiled member node returning call3548 (depth = 4)
  int op_slot_right_3546 = gc_frame_newslot(call3548);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_aNode (depth = 4)
  int op_slot_left_3546 = gc_frame_newslot(*var_aNode);
  params[0] = call3548;
  partcv[0] = 1;
  Object opresult3550 = callmethod(*var_aNode, "==", 1, partcv, params);
// compiled op node returning opresult3550 (depth = 3)
  gc_frame_end(frame);
  return opresult3550;
}
Object meth_ast__apply3554(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3555 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3556 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3557 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3558 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3557);
// compiled call node returning call3558 (depth = 10)
// compiled member node returning call3558 (depth = 9)
  partcv[0] = 0;
  Object call3559 = callmethod(call3558, "last",
    1, partcv, params);
  gc_frame_end(callframe3556);
// compiled call node returning call3559 (depth = 8)
// compiled member node returning call3559 (depth = 7)
  partcv[0] = 0;
  Object call3560 = callmethod(call3559, "returnsObject",
    1, partcv, params);
  gc_frame_end(callframe3555);
// compiled call node returning call3560 (depth = 6)
// compiled member node returning call3560 (depth = 5)
  gc_frame_end(frame);
  return call3560;
}
Object meth_ast_returnsObject3551(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnsObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for returnsObject (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for returnsObject");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 827
  setline(827);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3552 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block3553 = alloc_Block(NULL, NULL, "ast", 827);
  gc_frame_newslot(block3553);
// method _apply
  block_savedest(block3553);
  Object closure3554 = createclosure(1, "_apply");
  setclosureframe(closure3554, stackframe);
  addtoclosure(closure3554, selfslot);
  struct UserObject *uo3554 = (struct UserObject*)block3553;
  uo3554->data[0] = (Object)closure3554;
  Method *meth_meth_ast__apply3554 = addmethod2pos(block3553, "_apply", &meth_ast__apply3554, 0);
  int argcv_meth_ast__apply3554[] = {0};
  meth_meth_ast__apply3554->type = alloc_MethodType(1, argcv_meth_ast__apply3554);
  meth_meth_ast__apply3554->definitionModule = modulename;
  meth_meth_ast__apply3554->definitionLine = 824;
// compiled block node returning block3553 (depth = 4)
  gc_frame_newslot(block3553);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3562 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3563 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3564 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3565 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3564);
// compiled call node returning call3565 (depth = 9)
// compiled member node returning call3565 (depth = 8)
  partcv[0] = 0;
  Object call3566 = callmethod(call3565, "isEmpty",
    1, partcv, params);
  gc_frame_end(callframe3563);
// compiled call node returning call3566 (depth = 7)
// compiled member node returning call3566 (depth = 6)
  partcv[0] = 0;
  Object call3567 = callmethod(call3566, "not",
    1, partcv, params);
  gc_frame_end(callframe3562);
// compiled call node returning call3567 (depth = 5)
// compiled member node returning call3567 (depth = 4)
  params[0] = block3553;
  partcv[0] = 1;
  Object call3568 = callmethod(call3567, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe3552);
// compiled call node returning call3568 (depth = 3)
  gc_frame_end(frame);
  return call3568;
}
Object meth_ast_returnedObjectScope3569(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnedObjectScope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for returnedObjectScope (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for returnedObjectScope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 831
  setline(831);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3570 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3571 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3572 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3573 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3572);
// compiled call node returning call3573 (depth = 8)
// compiled member node returning call3573 (depth = 7)
  partcv[0] = 0;
  Object call3574 = callmethod(call3573, "last",
    1, partcv, params);
  gc_frame_end(callframe3571);
// compiled call node returning call3574 (depth = 6)
// compiled member node returning call3574 (depth = 5)
  partcv[0] = 0;
  Object call3575 = callmethod(call3574, "returnedObjectScope",
    1, partcv, params);
  gc_frame_end(callframe3570);
// compiled call node returning call3575 (depth = 4)
// compiled member node returning call3575 (depth = 3)
  gc_frame_end(frame);
  return call3575;
}
Object meth_ast__apply3606(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 842
  setline(842);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3607 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_visitor (depth = 9)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_newChain (depth = 9)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_p (depth = 9)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3608 = callmethod(*var_p, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe3607);
// compiled call node returning call3608 (depth = 8)
  gc_frame_end(frame);
  return call3608;
}
Object meth_ast__apply3601(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 841
  setline(841);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3602 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3603 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  partcv[0] = 0;
  Object call3604 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe3603);
// compiled call node returning call3604 (depth = 8)
// compiled member node returning call3604 (depth = 7)
  gc_frame_newslot(call3604);
// starting to compile block node (depth = 7)
  Object block3605 = alloc_Block(NULL, NULL, "ast", 841);
  gc_frame_newslot(block3605);
// method _apply
  block_savedest(block3605);
  Object closure3606 = createclosure(3, "_apply");
  setclosureframe(closure3606, stackframe);
  addtoclosure(closure3606, var_visitor);
  addtoclosure(closure3606, var_newChain);
  addtoclosure(closure3606, selfslot);
  struct UserObject *uo3606 = (struct UserObject*)block3605;
  uo3606->data[0] = (Object)closure3606;
  Method *meth_meth_ast__apply3606 = addmethod2pos(block3605, "_apply", &meth_ast__apply3606, 0);
  int argcv_meth_ast__apply3606[] = {1};
  meth_meth_ast__apply3606->type = alloc_MethodType(1, argcv_meth_ast__apply3606);
  meth_meth_ast__apply3606->definitionModule = modulename;
  meth_meth_ast__apply3606->definitionLine = 841;
// compiled block node returning block3605 (depth = 7)
  gc_frame_newslot(block3605);
// call case 5: prelude request
  params[0] = call3604;
  params[1] = block3605;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3610 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3602);
// compiled call node returning call3610 (depth = 6)
// Begin line 844
  setline(844);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool3613 = alloc_Boolean(0);
// compiled identifier node returning bool3613 (depth = 8)
  int op_slot_right_3612 = gc_frame_newslot(bool3613);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3615 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_part (depth = 10)
  partcv[0] = 0;
  Object call3616 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe3615);
// compiled call node returning call3616 (depth = 9)
// compiled member node returning call3616 (depth = 8)
  int op_slot_left_3612 = gc_frame_newslot(call3616);
  params[0] = bool3613;
  partcv[0] = 1;
  Object opresult3617 = callmethod(call3616, "!=", 1, partcv, params);
// compiled op node returning opresult3617 (depth = 7)
  Object if3611 = done;
  if (istrue(opresult3617)) {
// Begin line 845
  setline(845);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3618 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_visitor (depth = 8)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_newChain (depth = 8)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3619 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_part (depth = 10)
  partcv[0] = 0;
  Object call3620 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe3619);
// compiled call node returning call3620 (depth = 9)
// compiled member node returning call3620 (depth = 8)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3621 = callmethod(call3620, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe3618);
// compiled call node returning call3621 (depth = 7)
    gc_frame_newslot(call3621);
    if3611 = call3621;
  } else {
  }
// compiled if node returning if3611 (depth = 6)
  gc_frame_end(frame);
  return if3611;
}
Object meth_ast__apply3639(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ann = &(stackframe->slots[0]);
  *var_ann = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 852
  setline(852);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3640 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ann (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3641 = callmethod(*var_ann, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe3640);
// compiled call node returning call3641 (depth = 6)
  gc_frame_end(frame);
  return call3641;
}
Object meth_ast__apply3648(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 855
  setline(855);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3649 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_mx (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3650 = callmethod(*var_mx, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe3649);
// compiled call node returning call3650 (depth = 6)
  gc_frame_end(frame);
  return call3650;
}
Object meth_ast_accept_40__41_from3576(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 834
  setline(834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3578 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3579 = callmethod(*var_visitor, "visitMethod()up",
    2, partcv, params);
  gc_frame_end(callframe3578);
// compiled call node returning call3579 (depth = 4)
  Object if3577 = done;
  if (istrue(call3579)) {
// Begin line 835
  setline(835);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3580 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call3581 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe3580);
// compiled call node returning call3581 (depth = 5)
  *var_newChain = call3581;
  if (call3581 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 836
  setline(836);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3582 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3583 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3584 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3583);
// compiled call node returning call3584 (depth = 6)
// compiled member node returning call3584 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3585 = callmethod(call3584, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe3582);
// compiled call node returning call3585 (depth = 4)
// Begin line 837
  setline(837);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3588 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3589 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3588);
// compiled call node returning call3589 (depth = 7)
// compiled member node returning call3589 (depth = 6)
  int op_slot_right_3587 = gc_frame_newslot(call3589);
// starting to compile identifier node (depth = 6)
  Object bool3591 = alloc_Boolean(0);
// compiled identifier node returning bool3591 (depth = 6)
  int op_slot_left_3587 = gc_frame_newslot(bool3591);
  params[0] = call3589;
  partcv[0] = 1;
  Object opresult3592 = callmethod(bool3591, "!=", 1, partcv, params);
// compiled op node returning opresult3592 (depth = 5)
  Object if3586 = done;
  if (istrue(opresult3592)) {
// Begin line 838
  setline(838);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3593 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3594 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3595 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3594);
// compiled call node returning call3595 (depth = 7)
// compiled member node returning call3595 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3596 = callmethod(call3595, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe3593);
// compiled call node returning call3596 (depth = 5)
    gc_frame_newslot(call3596);
    if3586 = call3596;
  } else {
  }
// compiled if node returning if3586 (depth = 4)
// Begin line 840
  setline(840);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3597 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3598 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3599 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3598);
// compiled call node returning call3599 (depth = 6)
// compiled member node returning call3599 (depth = 5)
  gc_frame_newslot(call3599);
// starting to compile block node (depth = 5)
  Object block3600 = alloc_Block(NULL, NULL, "ast", 840);
  gc_frame_newslot(block3600);
// method _apply
  block_savedest(block3600);
  Object closure3601 = createclosure(3, "_apply");
  setclosureframe(closure3601, stackframe);
  addtoclosure(closure3601, var_visitor);
  addtoclosure(closure3601, var_newChain);
  addtoclosure(closure3601, selfslot);
  struct UserObject *uo3601 = (struct UserObject*)block3600;
  uo3601->data[0] = (Object)closure3601;
  Method *meth_meth_ast__apply3601 = addmethod2pos(block3600, "_apply", &meth_ast__apply3601, 0);
  int argcv_meth_ast__apply3601[] = {1};
  meth_meth_ast__apply3601->type = alloc_MethodType(1, argcv_meth_ast__apply3601);
  meth_meth_ast__apply3601->definitionModule = modulename;
  meth_meth_ast__apply3601->definitionLine = 840;
// compiled block node returning block3600 (depth = 5)
  gc_frame_newslot(block3600);
// call case 5: prelude request
  params[0] = call3599;
  params[1] = block3600;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3623 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3597);
// compiled call node returning call3623 (depth = 4)
// Begin line 848
  setline(848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool3626 = alloc_Boolean(0);
// compiled identifier node returning bool3626 (depth = 6)
  int op_slot_right_3625 = gc_frame_newslot(bool3626);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3628 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3629 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3628);
// compiled call node returning call3629 (depth = 7)
// compiled member node returning call3629 (depth = 6)
  int op_slot_left_3625 = gc_frame_newslot(call3629);
  params[0] = bool3626;
  partcv[0] = 1;
  Object opresult3630 = callmethod(call3629, "!=", 1, partcv, params);
// compiled op node returning opresult3630 (depth = 5)
  Object if3624 = done;
  if (istrue(opresult3630)) {
// Begin line 849
  setline(849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3631 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3632 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3633 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3632);
// compiled call node returning call3633 (depth = 7)
// compiled member node returning call3633 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3634 = callmethod(call3633, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe3631);
// compiled call node returning call3634 (depth = 5)
    gc_frame_newslot(call3634);
    if3624 = call3634;
  } else {
  }
// compiled if node returning if3624 (depth = 4)
// Begin line 851
  setline(851);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3635 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3636 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3637 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3636);
// compiled call node returning call3637 (depth = 6)
// compiled member node returning call3637 (depth = 5)
  gc_frame_newslot(call3637);
// starting to compile block node (depth = 5)
  Object block3638 = alloc_Block(NULL, NULL, "ast", 851);
  gc_frame_newslot(block3638);
// method _apply
  block_savedest(block3638);
  Object closure3639 = createclosure(3, "_apply");
  setclosureframe(closure3639, stackframe);
  addtoclosure(closure3639, var_visitor);
  addtoclosure(closure3639, var_newChain);
  addtoclosure(closure3639, selfslot);
  struct UserObject *uo3639 = (struct UserObject*)block3638;
  uo3639->data[0] = (Object)closure3639;
  Method *meth_meth_ast__apply3639 = addmethod2pos(block3638, "_apply", &meth_ast__apply3639, 0);
  int argcv_meth_ast__apply3639[] = {1};
  meth_meth_ast__apply3639->type = alloc_MethodType(1, argcv_meth_ast__apply3639);
  meth_meth_ast__apply3639->definitionModule = modulename;
  meth_meth_ast__apply3639->definitionLine = 851;
// compiled block node returning block3638 (depth = 5)
  gc_frame_newslot(block3638);
// call case 5: prelude request
  params[0] = call3637;
  params[1] = block3638;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3643 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3635);
// compiled call node returning call3643 (depth = 4)
// Begin line 854
  setline(854);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3644 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3645 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3646 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3645);
// compiled call node returning call3646 (depth = 6)
// compiled member node returning call3646 (depth = 5)
  gc_frame_newslot(call3646);
// starting to compile block node (depth = 5)
  Object block3647 = alloc_Block(NULL, NULL, "ast", 854);
  gc_frame_newslot(block3647);
// method _apply
  block_savedest(block3647);
  Object closure3648 = createclosure(3, "_apply");
  setclosureframe(closure3648, stackframe);
  addtoclosure(closure3648, var_visitor);
  addtoclosure(closure3648, var_newChain);
  addtoclosure(closure3648, selfslot);
  struct UserObject *uo3648 = (struct UserObject*)block3647;
  uo3648->data[0] = (Object)closure3648;
  Method *meth_meth_ast__apply3648 = addmethod2pos(block3647, "_apply", &meth_ast__apply3648, 0);
  int argcv_meth_ast__apply3648[] = {1};
  meth_meth_ast__apply3648->type = alloc_MethodType(1, argcv_meth_ast__apply3648);
  meth_meth_ast__apply3648->definitionModule = modulename;
  meth_meth_ast__apply3648->definitionLine = 854;
// compiled block node returning block3647 (depth = 5)
  gc_frame_newslot(block3647);
// call case 5: prelude request
  params[0] = call3646;
  params[1] = block3647;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3652 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3644);
// compiled call node returning call3652 (depth = 4)
    gc_frame_newslot(call3652);
    if3577 = call3652;
  } else {
  }
// compiled if node returning if3577 (depth = 3)
  gc_frame_end(frame);
  return if3577;
}
Object meth_ast_map_40__41_ancestors3653(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 860
  setline(860);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3654 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3655 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3654);
// compiled call node returning call3655 (depth = 5)
// compiled member node returning call3655 (depth = 4)
  *var_n = call3655;
  if (call3655 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 861
  setline(861);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3656 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call3657 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe3656);
// compiled call node returning call3657 (depth = 4)
  *var_newChain = call3657;
  if (call3657 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 862
  setline(862);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 860
  setline(860);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3658 = gc_frame_new();
// Begin line 862
  setline(862);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3659 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3660 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3661 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3660);
// compiled call node returning call3661 (depth = 7)
// compiled member node returning call3661 (depth = 6)
  gc_frame_newslot(call3661);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3662 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3663 = gc_frame_new();
// call case 3: self.outer request
  Object call3664 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3663);
// compiled call node returning call3664 (depth = 9)
// compiled member node returning call3664 (depth = 8)
  partcv[0] = 0;
  Object call3665 = callmethodflags(call3664, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3662);
// compiled call node returning call3665 (depth = 7)
// compiled member node returning call3665 (depth = 6)
  params[0] = call3661;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call3666 = callmethodflags(call3665, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3659);
// compiled call node returning call3666 (depth = 5)
  gc_frame_newslot(call3666);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  params[0] = call3666;
  partcv[0] = 1;
  Object call3667 = callmethod(*var_n, "body:=",
    1, partcv, params);
  gc_frame_end(callframe3658);
// compiled call node returning call3667 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 863
  setline(863);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 862
  setline(862);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3668 = gc_frame_new();
// Begin line 863
  setline(863);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3669 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3670 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3671 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3670);
// compiled call node returning call3671 (depth = 7)
// compiled member node returning call3671 (depth = 6)
  gc_frame_newslot(call3671);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3672 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3673 = gc_frame_new();
// call case 3: self.outer request
  Object call3674 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3673);
// compiled call node returning call3674 (depth = 9)
// compiled member node returning call3674 (depth = 8)
  partcv[0] = 0;
  Object call3675 = callmethodflags(call3674, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3672);
// compiled call node returning call3675 (depth = 7)
// compiled member node returning call3675 (depth = 6)
  params[0] = call3671;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call3676 = callmethodflags(call3675, "maybeMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3669);
// compiled call node returning call3676 (depth = 5)
  gc_frame_newslot(call3676);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  params[0] = call3676;
  partcv[0] = 1;
  Object call3677 = callmethod(*var_n, "generics:=",
    1, partcv, params);
  gc_frame_end(callframe3668);
// compiled call node returning call3677 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 864
  setline(864);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 863
  setline(863);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3678 = gc_frame_new();
// Begin line 864
  setline(864);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3679 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3680 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3681 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3680);
// compiled call node returning call3681 (depth = 7)
// compiled member node returning call3681 (depth = 6)
  gc_frame_newslot(call3681);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3682 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3683 = gc_frame_new();
// call case 3: self.outer request
  Object call3684 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3683);
// compiled call node returning call3684 (depth = 9)
// compiled member node returning call3684 (depth = 8)
  partcv[0] = 0;
  Object call3685 = callmethodflags(call3684, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3682);
// compiled call node returning call3685 (depth = 7)
// compiled member node returning call3685 (depth = 6)
  params[0] = call3681;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call3686 = callmethodflags(call3685, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3679);
// compiled call node returning call3686 (depth = 5)
  gc_frame_newslot(call3686);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  params[0] = call3686;
  partcv[0] = 1;
  Object call3687 = callmethod(*var_n, "signature:=",
    1, partcv, params);
  gc_frame_end(callframe3678);
// compiled call node returning call3687 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 865
  setline(865);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 864
  setline(864);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3688 = gc_frame_new();
// Begin line 865
  setline(865);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3689 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3690 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3691 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3690);
// compiled call node returning call3691 (depth = 7)
// compiled member node returning call3691 (depth = 6)
  gc_frame_newslot(call3691);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3692 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3693 = gc_frame_new();
// call case 3: self.outer request
  Object call3694 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3693);
// compiled call node returning call3694 (depth = 9)
// compiled member node returning call3694 (depth = 8)
  partcv[0] = 0;
  Object call3695 = callmethodflags(call3694, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3692);
// compiled call node returning call3695 (depth = 7)
// compiled member node returning call3695 (depth = 6)
  params[0] = call3691;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call3696 = callmethodflags(call3695, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3689);
// compiled call node returning call3696 (depth = 5)
  gc_frame_newslot(call3696);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  params[0] = call3696;
  partcv[0] = 1;
  Object call3697 = callmethod(*var_n, "annotations:=",
    1, partcv, params);
  gc_frame_end(callframe3688);
// compiled call node returning call3697 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 866
  setline(866);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 865
  setline(865);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3698 = gc_frame_new();
// Begin line 866
  setline(866);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3699 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3700 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3701 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3700);
// compiled call node returning call3701 (depth = 7)
// compiled member node returning call3701 (depth = 6)
  gc_frame_newslot(call3701);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3702 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3703 = gc_frame_new();
// call case 3: self.outer request
  Object call3704 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3703);
// compiled call node returning call3704 (depth = 9)
// compiled member node returning call3704 (depth = 8)
  partcv[0] = 0;
  Object call3705 = callmethodflags(call3704, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3702);
// compiled call node returning call3705 (depth = 7)
// compiled member node returning call3705 (depth = 6)
  params[0] = call3701;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call3706 = callmethodflags(call3705, "maybeMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3699);
// compiled call node returning call3706 (depth = 5)
  gc_frame_newslot(call3706);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  params[0] = call3706;
  partcv[0] = 1;
  Object call3707 = callmethod(*var_n, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe3698);
// compiled call node returning call3707 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 867
  setline(867);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3708 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call3709 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe3708);
// compiled call node returning call3709 (depth = 3)
  gc_frame_end(frame);
  return call3709;
}
Object meth_ast__apply3718(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 872
  setline(872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3720 == NULL) {
    strlit3720 = alloc_String("  ");
    gc_root(strlit3720);
  }
// compiled string node returning strlit3720 (depth = 7)
  int op_slot_right_3719 = gc_frame_newslot(strlit3720);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_3719 = gc_frame_newslot(*var_spc);
  params[0] = strlit3720;
  partcv[0] = 1;
  Object opresult3722 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult3722 (depth = 6)
  *var_spc = opresult3722;
  if (opresult3722 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply3871(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 887
  setline(887);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3873 == NULL) {
    strlit3873 = alloc_String("");
    gc_root(strlit3873);
  }
// compiled string node returning strlit3873 (depth = 9)
  int op_slot_right_3872 = gc_frame_newslot(strlit3873);
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3876 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num3878 = alloc_Float64(4);
// compiled num node returning num3878 (depth = 12)
  int op_slot_right_3877 = gc_frame_newslot(num3878);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_depth (depth = 12)
  int op_slot_left_3877 = gc_frame_newslot(*var_depth);
  params[0] = num3878;
  partcv[0] = 1;
  Object sum3880 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum3880 (depth = 11)
  gc_frame_newslot(sum3880);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_p (depth = 11)
  params[0] = sum3880;
  partcv[0] = 1;
  Object call3881 = callmethod(*var_p, "pretty",
    1, partcv, params);
  gc_frame_end(callframe3876);
// compiled call node returning call3881 (depth = 10)
  int op_slot_right_3875 = gc_frame_newslot(call3881);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit3884 == NULL) {
    strlit3884 = alloc_String("");
    gc_root(strlit3884);
  }
// compiled string node returning strlit3884 (depth = 11)
  int op_slot_right_3883 = gc_frame_newslot(strlit3884);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_spc (depth = 12)
  int op_slot_right_3886 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit3889 == NULL) {
    strlit3889 = alloc_String("""\x0a""      ");
    gc_root(strlit3889);
  }
// compiled string node returning strlit3889 (depth = 13)
  int op_slot_right_3888 = gc_frame_newslot(strlit3889);
// starting to compile op node (depth = 13)
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_s (depth = 14)
  int op_slot_right_3891 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 14)
  if (strlit3893 == NULL) {
    strlit3893 = alloc_String("");
    gc_root(strlit3893);
  }
// compiled string node returning strlit3893 (depth = 14)
  int op_slot_left_3891 = gc_frame_newslot(strlit3893);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult3894 = callmethod(strlit3893, "++", 1, partcv, params);
// compiled op node returning opresult3894 (depth = 13)
  int op_slot_left_3888 = gc_frame_newslot(opresult3894);
  params[0] = strlit3889;
  partcv[0] = 1;
  Object opresult3895 = callmethod(opresult3894, "++", 1, partcv, params);
// compiled op node returning opresult3895 (depth = 12)
  int op_slot_left_3886 = gc_frame_newslot(opresult3895);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3896 = callmethod(opresult3895, "++", 1, partcv, params);
// compiled op node returning opresult3896 (depth = 11)
  int op_slot_left_3883 = gc_frame_newslot(opresult3896);
  params[0] = strlit3884;
  partcv[0] = 1;
  Object opresult3897 = callmethod(opresult3896, "++", 1, partcv, params);
// compiled op node returning opresult3897 (depth = 10)
  int op_slot_left_3875 = gc_frame_newslot(opresult3897);
  params[0] = call3881;
  partcv[0] = 1;
  Object opresult3898 = callmethod(opresult3897, "++", 1, partcv, params);
// compiled op node returning opresult3898 (depth = 9)
  int op_slot_left_3872 = gc_frame_newslot(opresult3898);
  params[0] = strlit3873;
  partcv[0] = 1;
  Object opresult3899 = callmethod(opresult3898, "++", 1, partcv, params);
// compiled op node returning opresult3899 (depth = 8)
  *var_s = opresult3899;
  if (opresult3899 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply3825(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object *var_depth = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 884
  setline(884);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3827 == NULL) {
    strlit3827 = alloc_String("");
    gc_root(strlit3827);
  }
// compiled string node returning strlit3827 (depth = 7)
  int op_slot_right_3826 = gc_frame_newslot(strlit3827);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3830 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_part (depth = 10)
  partcv[0] = 0;
  Object call3831 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe3830);
// compiled call node returning call3831 (depth = 9)
// compiled member node returning call3831 (depth = 8)
  int op_slot_right_3829 = gc_frame_newslot(call3831);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3834 == NULL) {
    strlit3834 = alloc_String("Part: ");
    gc_root(strlit3834);
  }
// compiled string node returning strlit3834 (depth = 9)
  int op_slot_right_3833 = gc_frame_newslot(strlit3834);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_3836 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit3839 == NULL) {
    strlit3839 = alloc_String("""\x0a""  ");
    gc_root(strlit3839);
  }
// compiled string node returning strlit3839 (depth = 11)
  int op_slot_right_3838 = gc_frame_newslot(strlit3839);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_s (depth = 12)
  int op_slot_right_3841 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 12)
  if (strlit3843 == NULL) {
    strlit3843 = alloc_String("");
    gc_root(strlit3843);
  }
// compiled string node returning strlit3843 (depth = 12)
  int op_slot_left_3841 = gc_frame_newslot(strlit3843);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult3844 = callmethod(strlit3843, "++", 1, partcv, params);
// compiled op node returning opresult3844 (depth = 11)
  int op_slot_left_3838 = gc_frame_newslot(opresult3844);
  params[0] = strlit3839;
  partcv[0] = 1;
  Object opresult3845 = callmethod(opresult3844, "++", 1, partcv, params);
// compiled op node returning opresult3845 (depth = 10)
  int op_slot_left_3836 = gc_frame_newslot(opresult3845);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3846 = callmethod(opresult3845, "++", 1, partcv, params);
// compiled op node returning opresult3846 (depth = 9)
  int op_slot_left_3833 = gc_frame_newslot(opresult3846);
  params[0] = strlit3834;
  partcv[0] = 1;
  Object opresult3847 = callmethod(opresult3846, "++", 1, partcv, params);
// compiled op node returning opresult3847 (depth = 8)
  int op_slot_left_3829 = gc_frame_newslot(opresult3847);
  params[0] = call3831;
  partcv[0] = 1;
  Object opresult3848 = callmethod(opresult3847, "++", 1, partcv, params);
// compiled op node returning opresult3848 (depth = 7)
  int op_slot_left_3826 = gc_frame_newslot(opresult3848);
  params[0] = strlit3827;
  partcv[0] = 1;
  Object opresult3849 = callmethod(opresult3848, "++", 1, partcv, params);
// compiled op node returning opresult3849 (depth = 6)
  *var_s = opresult3849;
  if (opresult3849 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 885
  setline(885);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3852 == NULL) {
    strlit3852 = alloc_String("Parameters:");
    gc_root(strlit3852);
  }
// compiled string node returning strlit3852 (depth = 7)
  int op_slot_right_3851 = gc_frame_newslot(strlit3852);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_3854 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3857 == NULL) {
    strlit3857 = alloc_String("""\x0a""    ");
    gc_root(strlit3857);
  }
// compiled string node returning strlit3857 (depth = 9)
  int op_slot_right_3856 = gc_frame_newslot(strlit3857);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_right_3859 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 10)
  if (strlit3861 == NULL) {
    strlit3861 = alloc_String("");
    gc_root(strlit3861);
  }
// compiled string node returning strlit3861 (depth = 10)
  int op_slot_left_3859 = gc_frame_newslot(strlit3861);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult3862 = callmethod(strlit3861, "++", 1, partcv, params);
// compiled op node returning opresult3862 (depth = 9)
  int op_slot_left_3856 = gc_frame_newslot(opresult3862);
  params[0] = strlit3857;
  partcv[0] = 1;
  Object opresult3863 = callmethod(opresult3862, "++", 1, partcv, params);
// compiled op node returning opresult3863 (depth = 8)
  int op_slot_left_3854 = gc_frame_newslot(opresult3863);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3864 = callmethod(opresult3863, "++", 1, partcv, params);
// compiled op node returning opresult3864 (depth = 7)
  int op_slot_left_3851 = gc_frame_newslot(opresult3864);
  params[0] = strlit3852;
  partcv[0] = 1;
  Object opresult3865 = callmethod(opresult3864, "++", 1, partcv, params);
// compiled op node returning opresult3865 (depth = 6)
  *var_s = opresult3865;
  if (opresult3865 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 886
  setline(886);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3867 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3868 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  partcv[0] = 0;
  Object call3869 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe3868);
// compiled call node returning call3869 (depth = 7)
// compiled member node returning call3869 (depth = 6)
  gc_frame_newslot(call3869);
// starting to compile block node (depth = 6)
  Object block3870 = alloc_Block(NULL, NULL, "ast", 886);
  gc_frame_newslot(block3870);
// method _apply
  block_savedest(block3870);
  Object closure3871 = createclosure(4, "_apply");
  setclosureframe(closure3871, stackframe);
  addtoclosure(closure3871, var_depth);
  addtoclosure(closure3871, var_spc);
  addtoclosure(closure3871, var_s);
  addtoclosure(closure3871, selfslot);
  struct UserObject *uo3871 = (struct UserObject*)block3870;
  uo3871->data[0] = (Object)closure3871;
  Method *meth_meth_ast__apply3871 = addmethod2pos(block3870, "_apply", &meth_ast__apply3871, 0);
  int argcv_meth_ast__apply3871[] = {1};
  meth_meth_ast__apply3871->type = alloc_MethodType(1, argcv_meth_ast__apply3871);
  meth_meth_ast__apply3871->definitionModule = modulename;
  meth_meth_ast__apply3871->definitionLine = 886;
// compiled block node returning block3870 (depth = 6)
  gc_frame_newslot(block3870);
// call case 5: prelude request
  params[0] = call3869;
  params[1] = block3870;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3902 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3867);
// compiled call node returning call3902 (depth = 5)
// Begin line 889
  setline(889);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool3905 = alloc_Boolean(0);
// compiled identifier node returning bool3905 (depth = 7)
  int op_slot_right_3904 = gc_frame_newslot(bool3905);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3907 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  partcv[0] = 0;
  Object call3908 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe3907);
// compiled call node returning call3908 (depth = 8)
// compiled member node returning call3908 (depth = 7)
  int op_slot_left_3904 = gc_frame_newslot(call3908);
  params[0] = bool3905;
  partcv[0] = 1;
  Object opresult3909 = callmethod(call3908, "!=", 1, partcv, params);
// compiled op node returning opresult3909 (depth = 6)
  Object if3903 = done;
  if (istrue(opresult3909)) {
// Begin line 890
  setline(890);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3911 == NULL) {
    strlit3911 = alloc_String("");
    gc_root(strlit3911);
  }
// compiled string node returning strlit3911 (depth = 8)
  int op_slot_right_3910 = gc_frame_newslot(strlit3911);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3914 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num3916 = alloc_Float64(3);
// compiled num node returning num3916 (depth = 11)
  int op_slot_right_3915 = gc_frame_newslot(num3916);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_3915 = gc_frame_newslot(*var_depth);
  params[0] = num3916;
  partcv[0] = 1;
  Object sum3918 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum3918 (depth = 10)
  gc_frame_newslot(sum3918);
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3919 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_part (depth = 12)
  partcv[0] = 0;
  Object call3920 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe3919);
// compiled call node returning call3920 (depth = 11)
// compiled member node returning call3920 (depth = 10)
  params[0] = sum3918;
  partcv[0] = 1;
  Object call3921 = callmethod(call3920, "pretty",
    1, partcv, params);
  gc_frame_end(callframe3914);
// compiled call node returning call3921 (depth = 9)
  int op_slot_right_3913 = gc_frame_newslot(call3921);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3924 == NULL) {
    strlit3924 = alloc_String("Vararg: ");
    gc_root(strlit3924);
  }
// compiled string node returning strlit3924 (depth = 10)
  int op_slot_right_3923 = gc_frame_newslot(strlit3924);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_3926 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit3929 == NULL) {
    strlit3929 = alloc_String("""\x0a""    ");
    gc_root(strlit3929);
  }
// compiled string node returning strlit3929 (depth = 12)
  int op_slot_right_3928 = gc_frame_newslot(strlit3929);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_s (depth = 13)
  int op_slot_right_3931 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 13)
  if (strlit3933 == NULL) {
    strlit3933 = alloc_String("");
    gc_root(strlit3933);
  }
// compiled string node returning strlit3933 (depth = 13)
  int op_slot_left_3931 = gc_frame_newslot(strlit3933);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult3934 = callmethod(strlit3933, "++", 1, partcv, params);
// compiled op node returning opresult3934 (depth = 12)
  int op_slot_left_3928 = gc_frame_newslot(opresult3934);
  params[0] = strlit3929;
  partcv[0] = 1;
  Object opresult3935 = callmethod(opresult3934, "++", 1, partcv, params);
// compiled op node returning opresult3935 (depth = 11)
  int op_slot_left_3926 = gc_frame_newslot(opresult3935);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3936 = callmethod(opresult3935, "++", 1, partcv, params);
// compiled op node returning opresult3936 (depth = 10)
  int op_slot_left_3923 = gc_frame_newslot(opresult3936);
  params[0] = strlit3924;
  partcv[0] = 1;
  Object opresult3937 = callmethod(opresult3936, "++", 1, partcv, params);
// compiled op node returning opresult3937 (depth = 9)
  int op_slot_left_3913 = gc_frame_newslot(opresult3937);
  params[0] = call3921;
  partcv[0] = 1;
  Object opresult3938 = callmethod(opresult3937, "++", 1, partcv, params);
// compiled op node returning opresult3938 (depth = 8)
  int op_slot_left_3910 = gc_frame_newslot(opresult3938);
  params[0] = strlit3911;
  partcv[0] = 1;
  Object opresult3939 = callmethod(opresult3938, "++", 1, partcv, params);
// compiled op node returning opresult3939 (depth = 7)
  *var_s = opresult3939;
  if (opresult3939 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if3903 = done;
  } else {
  }
// compiled if node returning if3903 (depth = 5)
  gc_frame_end(frame);
  return if3903;
}
Object meth_ast__apply3973(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_g = &(stackframe->slots[0]);
  *var_g = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 897
  setline(897);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3975 == NULL) {
    strlit3975 = alloc_String("");
    gc_root(strlit3975);
  }
// compiled string node returning strlit3975 (depth = 8)
  int op_slot_right_3974 = gc_frame_newslot(strlit3975);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3978 = gc_frame_new();
// starting to compile num node (depth = 10)
  Object num3979 = alloc_Float64(0);
// compiled num node returning num3979 (depth = 10)
  gc_frame_newslot(num3979);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_g (depth = 10)
  params[0] = num3979;
  partcv[0] = 1;
  Object call3980 = callmethod(*var_g, "pretty",
    1, partcv, params);
  gc_frame_end(callframe3978);
// compiled call node returning call3980 (depth = 9)
  int op_slot_right_3977 = gc_frame_newslot(call3980);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3983 == NULL) {
    strlit3983 = alloc_String("  ");
    gc_root(strlit3983);
  }
// compiled string node returning strlit3983 (depth = 10)
  int op_slot_right_3982 = gc_frame_newslot(strlit3983);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_3985 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit3988 == NULL) {
    strlit3988 = alloc_String("""\x0a""");
    gc_root(strlit3988);
  }
// compiled string node returning strlit3988 (depth = 12)
  int op_slot_right_3987 = gc_frame_newslot(strlit3988);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_s (depth = 13)
  int op_slot_right_3990 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 13)
  if (strlit3992 == NULL) {
    strlit3992 = alloc_String("");
    gc_root(strlit3992);
  }
// compiled string node returning strlit3992 (depth = 13)
  int op_slot_left_3990 = gc_frame_newslot(strlit3992);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult3993 = callmethod(strlit3992, "++", 1, partcv, params);
// compiled op node returning opresult3993 (depth = 12)
  int op_slot_left_3987 = gc_frame_newslot(opresult3993);
  params[0] = strlit3988;
  partcv[0] = 1;
  Object opresult3994 = callmethod(opresult3993, "++", 1, partcv, params);
// compiled op node returning opresult3994 (depth = 11)
  int op_slot_left_3985 = gc_frame_newslot(opresult3994);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3995 = callmethod(opresult3994, "++", 1, partcv, params);
// compiled op node returning opresult3995 (depth = 10)
  int op_slot_left_3982 = gc_frame_newslot(opresult3995);
  params[0] = strlit3983;
  partcv[0] = 1;
  Object opresult3996 = callmethod(opresult3995, "++", 1, partcv, params);
// compiled op node returning opresult3996 (depth = 9)
  int op_slot_left_3977 = gc_frame_newslot(opresult3996);
  params[0] = call3980;
  partcv[0] = 1;
  Object opresult3997 = callmethod(opresult3996, "++", 1, partcv, params);
// compiled op node returning opresult3997 (depth = 8)
  int op_slot_left_3974 = gc_frame_newslot(opresult3997);
  params[0] = strlit3975;
  partcv[0] = 1;
  Object opresult3998 = callmethod(opresult3997, "++", 1, partcv, params);
// compiled op node returning opresult3998 (depth = 7)
  *var_s = opresult3998;
  if (opresult3998 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4038(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_an = &(stackframe->slots[0]);
  *var_an = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 904
  setline(904);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4040 == NULL) {
    strlit4040 = alloc_String("");
    gc_root(strlit4040);
  }
// compiled string node returning strlit4040 (depth = 8)
  int op_slot_right_4039 = gc_frame_newslot(strlit4040);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4043 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num4045 = alloc_Float64(2);
// compiled num node returning num4045 (depth = 11)
  int op_slot_right_4044 = gc_frame_newslot(num4045);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_4044 = gc_frame_newslot(*var_depth);
  params[0] = num4045;
  partcv[0] = 1;
  Object sum4047 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum4047 (depth = 10)
  gc_frame_newslot(sum4047);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_an (depth = 10)
  params[0] = sum4047;
  partcv[0] = 1;
  Object call4048 = callmethod(*var_an, "pretty",
    1, partcv, params);
  gc_frame_end(callframe4043);
// compiled call node returning call4048 (depth = 9)
  int op_slot_right_4042 = gc_frame_newslot(call4048);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit4051 == NULL) {
    strlit4051 = alloc_String("  ");
    gc_root(strlit4051);
  }
// compiled string node returning strlit4051 (depth = 10)
  int op_slot_right_4050 = gc_frame_newslot(strlit4051);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_4053 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit4056 == NULL) {
    strlit4056 = alloc_String("""\x0a""");
    gc_root(strlit4056);
  }
// compiled string node returning strlit4056 (depth = 12)
  int op_slot_right_4055 = gc_frame_newslot(strlit4056);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_s (depth = 13)
  int op_slot_right_4058 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 13)
  if (strlit4060 == NULL) {
    strlit4060 = alloc_String("");
    gc_root(strlit4060);
  }
// compiled string node returning strlit4060 (depth = 13)
  int op_slot_left_4058 = gc_frame_newslot(strlit4060);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4061 = callmethod(strlit4060, "++", 1, partcv, params);
// compiled op node returning opresult4061 (depth = 12)
  int op_slot_left_4055 = gc_frame_newslot(opresult4061);
  params[0] = strlit4056;
  partcv[0] = 1;
  Object opresult4062 = callmethod(opresult4061, "++", 1, partcv, params);
// compiled op node returning opresult4062 (depth = 11)
  int op_slot_left_4053 = gc_frame_newslot(opresult4062);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4063 = callmethod(opresult4062, "++", 1, partcv, params);
// compiled op node returning opresult4063 (depth = 10)
  int op_slot_left_4050 = gc_frame_newslot(opresult4063);
  params[0] = strlit4051;
  partcv[0] = 1;
  Object opresult4064 = callmethod(opresult4063, "++", 1, partcv, params);
// compiled op node returning opresult4064 (depth = 9)
  int op_slot_left_4042 = gc_frame_newslot(opresult4064);
  params[0] = call4048;
  partcv[0] = 1;
  Object opresult4065 = callmethod(opresult4064, "++", 1, partcv, params);
// compiled op node returning opresult4065 (depth = 8)
  int op_slot_left_4039 = gc_frame_newslot(opresult4065);
  params[0] = strlit4040;
  partcv[0] = 1;
  Object opresult4066 = callmethod(opresult4065, "++", 1, partcv, params);
// compiled op node returning opresult4066 (depth = 7)
  *var_s = opresult4066;
  if (opresult4066 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4087(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 910
  setline(910);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4089 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num4091 = alloc_Float64(2);
// compiled num node returning num4091 (depth = 9)
  int op_slot_right_4090 = gc_frame_newslot(num4091);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_4090 = gc_frame_newslot(*var_depth);
  params[0] = num4091;
  partcv[0] = 1;
  Object sum4093 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum4093 (depth = 8)
  gc_frame_newslot(sum4093);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mx (depth = 8)
  params[0] = sum4093;
  partcv[0] = 1;
  Object call4094 = callmethod(*var_mx, "pretty",
    1, partcv, params);
  gc_frame_end(callframe4089);
// compiled call node returning call4094 (depth = 7)
  int op_slot_right_4088 = gc_frame_newslot(call4094);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_4096 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4099 == NULL) {
    strlit4099 = alloc_String("""\x0a""  ");
    gc_root(strlit4099);
  }
// compiled string node returning strlit4099 (depth = 9)
  int op_slot_right_4098 = gc_frame_newslot(strlit4099);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_4098 = gc_frame_newslot(*var_s);
  params[0] = strlit4099;
  partcv[0] = 1;
  Object opresult4101 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4101 (depth = 8)
  int op_slot_left_4096 = gc_frame_newslot(opresult4101);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4102 = callmethod(opresult4101, "++", 1, partcv, params);
// compiled op node returning opresult4102 (depth = 7)
  int op_slot_left_4088 = gc_frame_newslot(opresult4102);
  params[0] = call4094;
  partcv[0] = 1;
  Object opresult4103 = callmethod(opresult4102, "++", 1, partcv, params);
// compiled op node returning opresult4103 (depth = 6)
  *var_s = opresult4103;
  if (opresult4103 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty3710(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 870
  setline(870);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3711 == NULL) {
    strlit3711 = alloc_String("");
    gc_root(strlit3711);
  }
// compiled string node returning strlit3711 (depth = 4)
  *var_spc = strlit3711;
  if (strlit3711 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 871
  setline(871);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3712 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_3713 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num3715 = alloc_Float64(0);
// compiled num node returning num3715 (depth = 5)
  int op_slot_left_3713 = gc_frame_newslot(num3715);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult3716 = callmethod(num3715, "..", 1, partcv, params);
// compiled op node returning opresult3716 (depth = 4)
  gc_frame_newslot(opresult3716);
// starting to compile block node (depth = 4)
  Object block3717 = alloc_Block(NULL, NULL, "ast", 871);
  gc_frame_newslot(block3717);
// method _apply
  block_savedest(block3717);
  Object closure3718 = createclosure(2, "_apply");
  setclosureframe(closure3718, stackframe);
  addtoclosure(closure3718, var_spc);
  addtoclosure(closure3718, selfslot);
  struct UserObject *uo3718 = (struct UserObject*)block3717;
  uo3718->data[0] = (Object)closure3718;
  Method *meth_meth_ast__apply3718 = addmethod2pos(block3717, "_apply", &meth_ast__apply3718, 0);
  int argcv_meth_ast__apply3718[] = {1};
  meth_meth_ast__apply3718->type = alloc_MethodType(1, argcv_meth_ast__apply3718);
  meth_meth_ast__apply3718->definitionModule = modulename;
  meth_meth_ast__apply3718->definitionLine = 866;
// compiled block node returning block3717 (depth = 4)
  gc_frame_newslot(block3717);
// call case 5: prelude request
  params[0] = opresult3716;
  params[1] = block3717;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3725 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3712);
// compiled call node returning call3725 (depth = 3)
// Begin line 874
  setline(874);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3727 == NULL) {
    strlit3727 = alloc_String("""\x0a""");
    gc_root(strlit3727);
  }
// compiled string node returning strlit3727 (depth = 5)
  int op_slot_right_3726 = gc_frame_newslot(strlit3727);
// starting to compile call node (depth = 5)
  int callframe3729 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call3730 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe3729);
// compiled call node returning call3730 (depth = 5)
  int op_slot_left_3726 = gc_frame_newslot(call3730);
  params[0] = strlit3727;
  partcv[0] = 1;
  Object opresult3731 = callmethod(call3730, "++", 1, partcv, params);
// compiled op node returning opresult3731 (depth = 4)
  *var_s = opresult3731;
  if (opresult3731 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 875
  setline(875);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3733 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num3735 = alloc_Float64(1);
// compiled num node returning num3735 (depth = 7)
  int op_slot_right_3734 = gc_frame_newslot(num3735);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_3734 = gc_frame_newslot(*var_depth);
  params[0] = num3735;
  partcv[0] = 1;
  Object sum3737 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum3737 (depth = 6)
  gc_frame_newslot(sum3737);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3738 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3739 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3738);
// compiled call node returning call3739 (depth = 7)
// compiled member node returning call3739 (depth = 6)
  params[0] = sum3737;
  partcv[0] = 1;
  Object call3740 = callmethod(call3739, "pretty",
    1, partcv, params);
  gc_frame_end(callframe3733);
// compiled call node returning call3740 (depth = 5)
  int op_slot_right_3732 = gc_frame_newslot(call3740);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3743 == NULL) {
    strlit3743 = alloc_String("Name: ");
    gc_root(strlit3743);
  }
// compiled string node returning strlit3743 (depth = 6)
  int op_slot_right_3742 = gc_frame_newslot(strlit3743);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_3745 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_3745 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3747 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3747 (depth = 6)
  int op_slot_left_3742 = gc_frame_newslot(opresult3747);
  params[0] = strlit3743;
  partcv[0] = 1;
  Object opresult3748 = callmethod(opresult3747, "++", 1, partcv, params);
// compiled op node returning opresult3748 (depth = 5)
  int op_slot_left_3732 = gc_frame_newslot(opresult3748);
  params[0] = call3740;
  partcv[0] = 1;
  Object opresult3749 = callmethod(opresult3748, "++", 1, partcv, params);
// compiled op node returning opresult3749 (depth = 4)
  *var_s = opresult3749;
  if (opresult3749 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 876
  setline(876);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3752 == NULL) {
    strlit3752 = alloc_String("""\x0a""");
    gc_root(strlit3752);
  }
// compiled string node returning strlit3752 (depth = 5)
  int op_slot_right_3751 = gc_frame_newslot(strlit3752);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_3751 = gc_frame_newslot(*var_s);
  params[0] = strlit3752;
  partcv[0] = 1;
  Object opresult3754 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3754 (depth = 4)
  *var_s = opresult3754;
  if (opresult3754 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 877
  setline(877);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3758 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3759 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3758);
// compiled call node returning call3759 (depth = 6)
// compiled member node returning call3759 (depth = 5)
  int op_slot_right_3757 = gc_frame_newslot(call3759);
// starting to compile identifier node (depth = 5)
  Object bool3761 = alloc_Boolean(0);
// compiled identifier node returning bool3761 (depth = 5)
  int op_slot_left_3757 = gc_frame_newslot(bool3761);
  params[0] = call3759;
  partcv[0] = 1;
  Object opresult3762 = callmethod(bool3761, "!=", 1, partcv, params);
// compiled op node returning opresult3762 (depth = 4)
  Object if3756 = done;
  if (istrue(opresult3762)) {
// Begin line 878
  setline(878);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3764 == NULL) {
    strlit3764 = alloc_String("  ");
    gc_root(strlit3764);
  }
// compiled string node returning strlit3764 (depth = 6)
  int op_slot_right_3763 = gc_frame_newslot(strlit3764);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_3766 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3769 == NULL) {
    strlit3769 = alloc_String("Returns:""\x0a""");
    gc_root(strlit3769);
  }
// compiled string node returning strlit3769 (depth = 8)
  int op_slot_right_3768 = gc_frame_newslot(strlit3769);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_3771 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_3771 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3773 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3773 (depth = 8)
  int op_slot_left_3768 = gc_frame_newslot(opresult3773);
  params[0] = strlit3769;
  partcv[0] = 1;
  Object opresult3774 = callmethod(opresult3773, "++", 1, partcv, params);
// compiled op node returning opresult3774 (depth = 7)
  int op_slot_left_3766 = gc_frame_newslot(opresult3774);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3775 = callmethod(opresult3774, "++", 1, partcv, params);
// compiled op node returning opresult3775 (depth = 6)
  int op_slot_left_3763 = gc_frame_newslot(opresult3775);
  params[0] = strlit3764;
  partcv[0] = 1;
  Object opresult3776 = callmethod(opresult3775, "++", 1, partcv, params);
// compiled op node returning opresult3776 (depth = 5)
  *var_s = opresult3776;
  if (opresult3776 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 879
  setline(879);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3779 == NULL) {
    strlit3779 = alloc_String("""\x0a""");
    gc_root(strlit3779);
  }
// compiled string node returning strlit3779 (depth = 6)
  int op_slot_right_3778 = gc_frame_newslot(strlit3779);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3782 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3784 = alloc_Float64(2);
// compiled num node returning num3784 (depth = 9)
  int op_slot_right_3783 = gc_frame_newslot(num3784);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_3783 = gc_frame_newslot(*var_depth);
  params[0] = num3784;
  partcv[0] = 1;
  Object sum3786 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum3786 (depth = 8)
  gc_frame_newslot(sum3786);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3787 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3788 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3787);
// compiled call node returning call3788 (depth = 9)
// compiled member node returning call3788 (depth = 8)
  params[0] = sum3786;
  partcv[0] = 1;
  Object call3789 = callmethod(call3788, "pretty",
    1, partcv, params);
  gc_frame_end(callframe3782);
// compiled call node returning call3789 (depth = 7)
  int op_slot_right_3781 = gc_frame_newslot(call3789);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_3781 = gc_frame_newslot(*var_s);
  params[0] = call3789;
  partcv[0] = 1;
  Object opresult3791 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3791 (depth = 6)
  int op_slot_left_3778 = gc_frame_newslot(opresult3791);
  params[0] = strlit3779;
  partcv[0] = 1;
  Object opresult3792 = callmethod(opresult3791, "++", 1, partcv, params);
// compiled op node returning opresult3792 (depth = 5)
  *var_s = opresult3792;
  if (opresult3792 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if3756 = done;
  } else {
  }
// compiled if node returning if3756 (depth = 3)
// Begin line 881
  setline(881);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3795 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3796 = callmethodflags(self, "isFresh", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3795);
// compiled call node returning call3796 (depth = 5)
// compiled member node returning call3796 (depth = 4)
  Object if3794 = done;
  if (istrue(call3796)) {
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3798 == NULL) {
    strlit3798 = alloc_String("Fresh""\x0a""");
    gc_root(strlit3798);
  }
// compiled string node returning strlit3798 (depth = 6)
  int op_slot_right_3797 = gc_frame_newslot(strlit3798);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_3800 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_3800 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3802 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3802 (depth = 6)
  int op_slot_left_3797 = gc_frame_newslot(opresult3802);
  params[0] = strlit3798;
  partcv[0] = 1;
  Object opresult3803 = callmethod(opresult3802, "++", 1, partcv, params);
// compiled op node returning opresult3803 (depth = 5)
  *var_s = opresult3803;
  if (opresult3803 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if3794 = done;
  } else {
  }
// compiled if node returning if3794 (depth = 3)
// Begin line 882
  setline(882);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3806 == NULL) {
    strlit3806 = alloc_String("Signature:");
    gc_root(strlit3806);
  }
// compiled string node returning strlit3806 (depth = 5)
  int op_slot_right_3805 = gc_frame_newslot(strlit3806);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_3808 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3811 == NULL) {
    strlit3811 = alloc_String("");
    gc_root(strlit3811);
  }
// compiled string node returning strlit3811 (depth = 7)
  int op_slot_right_3810 = gc_frame_newslot(strlit3811);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_right_3813 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 8)
  if (strlit3815 == NULL) {
    strlit3815 = alloc_String("");
    gc_root(strlit3815);
  }
// compiled string node returning strlit3815 (depth = 8)
  int op_slot_left_3813 = gc_frame_newslot(strlit3815);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult3816 = callmethod(strlit3815, "++", 1, partcv, params);
// compiled op node returning opresult3816 (depth = 7)
  int op_slot_left_3810 = gc_frame_newslot(opresult3816);
  params[0] = strlit3811;
  partcv[0] = 1;
  Object opresult3817 = callmethod(opresult3816, "++", 1, partcv, params);
// compiled op node returning opresult3817 (depth = 6)
  int op_slot_left_3808 = gc_frame_newslot(opresult3817);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3818 = callmethod(opresult3817, "++", 1, partcv, params);
// compiled op node returning opresult3818 (depth = 5)
  int op_slot_left_3805 = gc_frame_newslot(opresult3818);
  params[0] = strlit3806;
  partcv[0] = 1;
  Object opresult3819 = callmethod(opresult3818, "++", 1, partcv, params);
// compiled op node returning opresult3819 (depth = 4)
  *var_s = opresult3819;
  if (opresult3819 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 883
  setline(883);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3821 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3822 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3823 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3822);
// compiled call node returning call3823 (depth = 5)
// compiled member node returning call3823 (depth = 4)
  gc_frame_newslot(call3823);
// starting to compile block node (depth = 4)
  Object block3824 = alloc_Block(NULL, NULL, "ast", 883);
  gc_frame_newslot(block3824);
// method _apply
  block_savedest(block3824);
  Object closure3825 = createclosure(4, "_apply");
  setclosureframe(closure3825, stackframe);
  addtoclosure(closure3825, var_spc);
  addtoclosure(closure3825, var_s);
  addtoclosure(closure3825, var_depth);
  addtoclosure(closure3825, selfslot);
  struct UserObject *uo3825 = (struct UserObject*)block3824;
  uo3825->data[0] = (Object)closure3825;
  Method *meth_meth_ast__apply3825 = addmethod2pos(block3824, "_apply", &meth_ast__apply3825, 0);
  int argcv_meth_ast__apply3825[] = {1};
  meth_meth_ast__apply3825->type = alloc_MethodType(1, argcv_meth_ast__apply3825);
  meth_meth_ast__apply3825->definitionModule = modulename;
  meth_meth_ast__apply3825->definitionLine = 883;
// compiled block node returning block3824 (depth = 4)
  gc_frame_newslot(block3824);
// call case 5: prelude request
  params[0] = call3823;
  params[1] = block3824;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3942 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3821);
// compiled call node returning call3942 (depth = 3)
// Begin line 893
  setline(893);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3944 == NULL) {
    strlit3944 = alloc_String("""\x0a""");
    gc_root(strlit3944);
  }
// compiled string node returning strlit3944 (depth = 5)
  int op_slot_right_3943 = gc_frame_newslot(strlit3944);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_3943 = gc_frame_newslot(*var_s);
  params[0] = strlit3944;
  partcv[0] = 1;
  Object opresult3946 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3946 (depth = 4)
  *var_s = opresult3946;
  if (opresult3946 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 894
  setline(894);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3950 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3951 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3950);
// compiled call node returning call3951 (depth = 6)
// compiled member node returning call3951 (depth = 5)
  int op_slot_right_3949 = gc_frame_newslot(call3951);
// starting to compile identifier node (depth = 5)
  Object bool3953 = alloc_Boolean(0);
// compiled identifier node returning bool3953 (depth = 5)
  int op_slot_left_3949 = gc_frame_newslot(bool3953);
  params[0] = call3951;
  partcv[0] = 1;
  Object opresult3954 = callmethod(bool3953, "!=", 1, partcv, params);
// compiled op node returning opresult3954 (depth = 4)
  Object if3948 = done;
  if (istrue(opresult3954)) {
// Begin line 895
  setline(895);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3956 == NULL) {
    strlit3956 = alloc_String("Generics:");
    gc_root(strlit3956);
  }
// compiled string node returning strlit3956 (depth = 6)
  int op_slot_right_3955 = gc_frame_newslot(strlit3956);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_3958 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3961 == NULL) {
    strlit3961 = alloc_String("");
    gc_root(strlit3961);
  }
// compiled string node returning strlit3961 (depth = 8)
  int op_slot_right_3960 = gc_frame_newslot(strlit3961);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_right_3963 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 9)
  if (strlit3965 == NULL) {
    strlit3965 = alloc_String("");
    gc_root(strlit3965);
  }
// compiled string node returning strlit3965 (depth = 9)
  int op_slot_left_3963 = gc_frame_newslot(strlit3965);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult3966 = callmethod(strlit3965, "++", 1, partcv, params);
// compiled op node returning opresult3966 (depth = 8)
  int op_slot_left_3960 = gc_frame_newslot(opresult3966);
  params[0] = strlit3961;
  partcv[0] = 1;
  Object opresult3967 = callmethod(opresult3966, "++", 1, partcv, params);
// compiled op node returning opresult3967 (depth = 7)
  int op_slot_left_3958 = gc_frame_newslot(opresult3967);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3968 = callmethod(opresult3967, "++", 1, partcv, params);
// compiled op node returning opresult3968 (depth = 6)
  int op_slot_left_3955 = gc_frame_newslot(opresult3968);
  params[0] = strlit3956;
  partcv[0] = 1;
  Object opresult3969 = callmethod(opresult3968, "++", 1, partcv, params);
// compiled op node returning opresult3969 (depth = 5)
  *var_s = opresult3969;
  if (opresult3969 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 896
  setline(896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3971 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block3972 = alloc_Block(NULL, NULL, "ast", 896);
  gc_frame_newslot(block3972);
// method _apply
  block_savedest(block3972);
  Object closure3973 = createclosure(3, "_apply");
  setclosureframe(closure3973, stackframe);
  addtoclosure(closure3973, var_spc);
  addtoclosure(closure3973, var_s);
  addtoclosure(closure3973, selfslot);
  struct UserObject *uo3973 = (struct UserObject*)block3972;
  uo3973->data[0] = (Object)closure3973;
  Method *meth_meth_ast__apply3973 = addmethod2pos(block3972, "_apply", &meth_ast__apply3973, 0);
  int argcv_meth_ast__apply3973[] = {1};
  meth_meth_ast__apply3973->type = alloc_MethodType(1, argcv_meth_ast__apply3973);
  meth_meth_ast__apply3973->definitionModule = modulename;
  meth_meth_ast__apply3973->definitionLine = 894;
// compiled block node returning block3972 (depth = 5)
  gc_frame_newslot(block3972);
// call case 6: other member request
// Begin line 896
  setline(896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4001 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4002 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4001);
// compiled call node returning call4002 (depth = 6)
// compiled member node returning call4002 (depth = 5)
  params[0] = block3972;
  partcv[0] = 1;
  Object call4003 = callmethod(call4002, "do",
    1, partcv, params);
  gc_frame_end(callframe3971);
// compiled call node returning call4003 (depth = 4)
// Begin line 899
  setline(899);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4005 == NULL) {
    strlit4005 = alloc_String("""\x0a""");
    gc_root(strlit4005);
  }
// compiled string node returning strlit4005 (depth = 6)
  int op_slot_right_4004 = gc_frame_newslot(strlit4005);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4004 = gc_frame_newslot(*var_s);
  params[0] = strlit4005;
  partcv[0] = 1;
  Object opresult4007 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4007 (depth = 5)
  *var_s = opresult4007;
  if (opresult4007 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if3948 = done;
  } else {
  }
// compiled if node returning if3948 (depth = 3)
// Begin line 901
  setline(901);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4011 = alloc_Float64(0);
// compiled num node returning num4011 (depth = 5)
  int op_slot_right_4010 = gc_frame_newslot(num4011);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4013 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4014 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4015 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4014);
// compiled call node returning call4015 (depth = 8)
// compiled member node returning call4015 (depth = 7)
  partcv[0] = 0;
  Object call4016 = callmethod(call4015, "size",
    1, partcv, params);
  gc_frame_end(callframe4013);
// compiled call node returning call4016 (depth = 6)
// compiled member node returning call4016 (depth = 5)
  int op_slot_left_4010 = gc_frame_newslot(call4016);
  params[0] = num4011;
  partcv[0] = 1;
  Object opresult4017 = callmethod(call4016, ">", 1, partcv, params);
// compiled op node returning opresult4017 (depth = 4)
  Object if4009 = done;
  if (istrue(opresult4017)) {
// Begin line 902
  setline(902);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4019 == NULL) {
    strlit4019 = alloc_String("Annotations:");
    gc_root(strlit4019);
  }
// compiled string node returning strlit4019 (depth = 6)
  int op_slot_right_4018 = gc_frame_newslot(strlit4019);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_4021 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4024 == NULL) {
    strlit4024 = alloc_String("");
    gc_root(strlit4024);
  }
// compiled string node returning strlit4024 (depth = 8)
  int op_slot_right_4023 = gc_frame_newslot(strlit4024);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_right_4026 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 9)
  if (strlit4028 == NULL) {
    strlit4028 = alloc_String("");
    gc_root(strlit4028);
  }
// compiled string node returning strlit4028 (depth = 9)
  int op_slot_left_4026 = gc_frame_newslot(strlit4028);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4029 = callmethod(strlit4028, "++", 1, partcv, params);
// compiled op node returning opresult4029 (depth = 8)
  int op_slot_left_4023 = gc_frame_newslot(opresult4029);
  params[0] = strlit4024;
  partcv[0] = 1;
  Object opresult4030 = callmethod(opresult4029, "++", 1, partcv, params);
// compiled op node returning opresult4030 (depth = 7)
  int op_slot_left_4021 = gc_frame_newslot(opresult4030);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4031 = callmethod(opresult4030, "++", 1, partcv, params);
// compiled op node returning opresult4031 (depth = 6)
  int op_slot_left_4018 = gc_frame_newslot(opresult4031);
  params[0] = strlit4019;
  partcv[0] = 1;
  Object opresult4032 = callmethod(opresult4031, "++", 1, partcv, params);
// compiled op node returning opresult4032 (depth = 5)
  *var_s = opresult4032;
  if (opresult4032 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 903
  setline(903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4034 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4035 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4036 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4035);
// compiled call node returning call4036 (depth = 6)
// compiled member node returning call4036 (depth = 5)
  gc_frame_newslot(call4036);
// starting to compile block node (depth = 5)
  Object block4037 = alloc_Block(NULL, NULL, "ast", 903);
  gc_frame_newslot(block4037);
// method _apply
  block_savedest(block4037);
  Object closure4038 = createclosure(4, "_apply");
  setclosureframe(closure4038, stackframe);
  addtoclosure(closure4038, var_depth);
  addtoclosure(closure4038, var_spc);
  addtoclosure(closure4038, var_s);
  addtoclosure(closure4038, selfslot);
  struct UserObject *uo4038 = (struct UserObject*)block4037;
  uo4038->data[0] = (Object)closure4038;
  Method *meth_meth_ast__apply4038 = addmethod2pos(block4037, "_apply", &meth_ast__apply4038, 0);
  int argcv_meth_ast__apply4038[] = {1};
  meth_meth_ast__apply4038->type = alloc_MethodType(1, argcv_meth_ast__apply4038);
  meth_meth_ast__apply4038->definitionModule = modulename;
  meth_meth_ast__apply4038->definitionLine = 903;
// compiled block node returning block4037 (depth = 5)
  gc_frame_newslot(block4037);
// call case 5: prelude request
  params[0] = call4036;
  params[1] = block4037;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4069 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4034);
// compiled call node returning call4069 (depth = 4)
// Begin line 906
  setline(906);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4071 == NULL) {
    strlit4071 = alloc_String("""\x0a""");
    gc_root(strlit4071);
  }
// compiled string node returning strlit4071 (depth = 6)
  int op_slot_right_4070 = gc_frame_newslot(strlit4071);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4070 = gc_frame_newslot(*var_s);
  params[0] = strlit4071;
  partcv[0] = 1;
  Object opresult4073 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4073 (depth = 5)
  *var_s = opresult4073;
  if (opresult4073 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if4009 = done;
  } else {
  }
// compiled if node returning if4009 (depth = 3)
// Begin line 908
  setline(908);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4076 == NULL) {
    strlit4076 = alloc_String("Body:");
    gc_root(strlit4076);
  }
// compiled string node returning strlit4076 (depth = 5)
  int op_slot_right_4075 = gc_frame_newslot(strlit4076);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_4078 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4078 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4080 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4080 (depth = 5)
  int op_slot_left_4075 = gc_frame_newslot(opresult4080);
  params[0] = strlit4076;
  partcv[0] = 1;
  Object opresult4081 = callmethod(opresult4080, "++", 1, partcv, params);
// compiled op node returning opresult4081 (depth = 4)
  *var_s = opresult4081;
  if (opresult4081 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 909
  setline(909);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4083 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4084 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4085 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4084);
// compiled call node returning call4085 (depth = 5)
// compiled member node returning call4085 (depth = 4)
  gc_frame_newslot(call4085);
// starting to compile block node (depth = 4)
  Object block4086 = alloc_Block(NULL, NULL, "ast", 909);
  gc_frame_newslot(block4086);
// method _apply
  block_savedest(block4086);
  Object closure4087 = createclosure(4, "_apply");
  setclosureframe(closure4087, stackframe);
  addtoclosure(closure4087, var_depth);
  addtoclosure(closure4087, var_spc);
  addtoclosure(closure4087, var_s);
  addtoclosure(closure4087, selfslot);
  struct UserObject *uo4087 = (struct UserObject*)block4086;
  uo4087->data[0] = (Object)closure4087;
  Method *meth_meth_ast__apply4087 = addmethod2pos(block4086, "_apply", &meth_ast__apply4087, 0);
  int argcv_meth_ast__apply4087[] = {1};
  meth_meth_ast__apply4087->type = alloc_MethodType(1, argcv_meth_ast__apply4087);
  meth_meth_ast__apply4087->definitionModule = modulename;
  meth_meth_ast__apply4087->definitionLine = 909;
// compiled block node returning block4086 (depth = 4)
  gc_frame_newslot(block4086);
// call case 5: prelude request
  params[0] = call4085;
  params[1] = block4086;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4106 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4083);
// compiled call node returning call4106 (depth = 3)
// Begin line 912
  setline(912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4109 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4110 = callmethodflags(self, "comments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4109);
// compiled call node returning call4110 (depth = 6)
// compiled member node returning call4110 (depth = 5)
  int op_slot_right_4108 = gc_frame_newslot(call4110);
// starting to compile identifier node (depth = 5)
  Object bool4112 = alloc_Boolean(0);
// compiled identifier node returning bool4112 (depth = 5)
  int op_slot_left_4108 = gc_frame_newslot(bool4112);
  params[0] = call4110;
  partcv[0] = 1;
  Object opresult4113 = callmethod(bool4112, "!=", 1, partcv, params);
// compiled op node returning opresult4113 (depth = 4)
  Object if4107 = done;
  if (istrue(opresult4113)) {
// Begin line 913
  setline(913);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4115 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num4117 = alloc_Float64(2);
// compiled num node returning num4117 (depth = 8)
  int op_slot_right_4116 = gc_frame_newslot(num4117);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_4116 = gc_frame_newslot(*var_depth);
  params[0] = num4117;
  partcv[0] = 1;
  Object sum4119 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum4119 (depth = 7)
  gc_frame_newslot(sum4119);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4120 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4121 = callmethodflags(self, "comments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4120);
// compiled call node returning call4121 (depth = 8)
// compiled member node returning call4121 (depth = 7)
  params[0] = sum4119;
  partcv[0] = 1;
  Object call4122 = callmethod(call4121, "pretty",
    1, partcv, params);
  gc_frame_end(callframe4115);
// compiled call node returning call4122 (depth = 6)
  int op_slot_right_4114 = gc_frame_newslot(call4122);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4114 = gc_frame_newslot(*var_s);
  params[0] = call4122;
  partcv[0] = 1;
  Object opresult4124 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4124 (depth = 5)
  *var_s = opresult4124;
  if (opresult4124 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if4107 = done;
  } else {
  }
// compiled if node returning if4107 (depth = 3)
// Begin line 915
  setline(915);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply4138(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 920
  setline(920);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4140 == NULL) {
    strlit4140 = alloc_String("    ");
    gc_root(strlit4140);
  }
// compiled string node returning strlit4140 (depth = 7)
  int op_slot_right_4139 = gc_frame_newslot(strlit4140);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_4139 = gc_frame_newslot(*var_spc);
  params[0] = strlit4140;
  partcv[0] = 1;
  Object opresult4142 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult4142 (depth = 6)
  *var_spc = opresult4142;
  if (opresult4142 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4162(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4164 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4165 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4164);
// compiled call node returning call4165 (depth = 10)
// compiled member node returning call4165 (depth = 9)
  int op_slot_right_4163 = gc_frame_newslot(call4165);
// starting to compile identifier node (depth = 9)
  Object bool4167 = alloc_Boolean(0);
// compiled identifier node returning bool4167 (depth = 9)
  int op_slot_left_4163 = gc_frame_newslot(bool4167);
  params[0] = call4165;
  partcv[0] = 1;
  Object opresult4168 = callmethod(bool4167, "!=", 1, partcv, params);
// compiled op node returning opresult4168 (depth = 8)
  gc_frame_end(frame);
  return opresult4168;
}
Object meth_ast__apply4190(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 929
  setline(929);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4192 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num4194 = alloc_Float64(1);
// compiled num node returning num4194 (depth = 12)
  int op_slot_right_4193 = gc_frame_newslot(num4194);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_depth (depth = 12)
  int op_slot_left_4193 = gc_frame_newslot(*var_depth);
  params[0] = num4194;
  partcv[0] = 1;
  Object sum4196 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum4196 (depth = 11)
  gc_frame_newslot(sum4196);
// call case 6: other member request
// starting to compile call node (depth = 11)
  int callframe4197 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_ix (depth = 12)
  gc_frame_newslot(*var_ix);
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe4198 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4199 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4198);
// compiled call node returning call4199 (depth = 13)
// compiled member node returning call4199 (depth = 12)
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call4200 = callmethod(call4199, "at",
    1, partcv, params);
  gc_frame_end(callframe4197);
// compiled call node returning call4200 (depth = 11)
  params[0] = sum4196;
  partcv[0] = 1;
  Object call4201 = callmethod(call4200, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4192);
// compiled call node returning call4201 (depth = 10)
  int op_slot_right_4191 = gc_frame_newslot(call4201);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_4191 = gc_frame_newslot(*var_s);
  params[0] = call4201;
  partcv[0] = 1;
  Object opresult4203 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4203 (depth = 9)
  *var_s = opresult4203;
  if (opresult4203 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4256(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_part = getfromclosure(closure, 0);
  Object *var_depth = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_pnr = &(stackframe->slots[0]);
  *var_pnr = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_p = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "p");
// Begin line 937
  setline(937);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// Begin line 938
  setline(938);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile index node (depth = 9)
// Begin line 937
  setline(937);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe4257 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_part (depth = 12)
  partcv[0] = 0;
  Object call4258 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe4257);
// compiled call node returning call4258 (depth = 11)
// compiled member node returning call4258 (depth = 10)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_pnr (depth = 10)
  params[0] = *var_pnr;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres4259 = callmethod(call4258, "[]", 1, partcv, params);
// compiled index node returning idxres4259 (depth = 9)
  *var_p = idxres4259;
  if (idxres4259 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 938
  setline(938);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4261 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num4263 = alloc_Float64(1);
// compiled num node returning num4263 (depth = 12)
  int op_slot_right_4262 = gc_frame_newslot(num4263);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_depth (depth = 12)
  int op_slot_left_4262 = gc_frame_newslot(*var_depth);
  params[0] = num4263;
  partcv[0] = 1;
  Object sum4265 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum4265 (depth = 11)
  gc_frame_newslot(sum4265);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_p (depth = 11)
  params[0] = sum4265;
  partcv[0] = 1;
  Object call4266 = callmethod(*var_p, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4261);
// compiled call node returning call4266 (depth = 10)
  int op_slot_right_4260 = gc_frame_newslot(call4266);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_4260 = gc_frame_newslot(*var_s);
  params[0] = call4266;
  partcv[0] = 1;
  Object opresult4268 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4268 (depth = 9)
  *var_s = opresult4268;
  if (opresult4268 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 939
  setline(939);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
  Object bool4273 = alloc_Boolean(0);
// compiled identifier node returning bool4273 (depth = 11)
  int op_slot_right_4272 = gc_frame_newslot(bool4273);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe4275 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_part (depth = 13)
  partcv[0] = 0;
  Object call4276 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe4275);
// compiled call node returning call4276 (depth = 12)
// compiled member node returning call4276 (depth = 11)
  int op_slot_left_4272 = gc_frame_newslot(call4276);
  params[0] = bool4273;
  partcv[0] = 1;
  Object opresult4277 = callmethod(call4276, "!=", 1, partcv, params);
// compiled op node returning opresult4277 (depth = 10)
  int op_slot_right_4271 = gc_frame_newslot(opresult4277);
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe4280 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe4281 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_part (depth = 15)
  partcv[0] = 0;
  Object call4282 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe4281);
// compiled call node returning call4282 (depth = 14)
// compiled member node returning call4282 (depth = 13)
  partcv[0] = 0;
  Object call4283 = callmethod(call4282, "size",
    1, partcv, params);
  gc_frame_end(callframe4280);
// compiled call node returning call4283 (depth = 12)
// compiled member node returning call4283 (depth = 11)
  int op_slot_right_4279 = gc_frame_newslot(call4283);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_pnr (depth = 11)
  int op_slot_left_4279 = gc_frame_newslot(*var_pnr);
  params[0] = call4283;
  partcv[0] = 1;
  Object opresult4285 = callmethod(*var_pnr, "<", 1, partcv, params);
// compiled op node returning opresult4285 (depth = 10)
  int op_slot_left_4271 = gc_frame_newslot(opresult4285);
  params[0] = opresult4277;
  partcv[0] = 1;
  Object opresult4286 = callmethod(opresult4285, "||", 1, partcv, params);
// compiled op node returning opresult4286 (depth = 9)
  Object if4270 = done;
  if (istrue(opresult4286)) {
// Begin line 940
  setline(940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit4288 == NULL) {
    strlit4288 = alloc_String(", ");
    gc_root(strlit4288);
  }
// compiled string node returning strlit4288 (depth = 11)
  int op_slot_right_4287 = gc_frame_newslot(strlit4288);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_4287 = gc_frame_newslot(*var_s);
  params[0] = strlit4288;
  partcv[0] = 1;
  Object opresult4290 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4290 (depth = 10)
  *var_s = opresult4290;
  if (opresult4290 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if4270 = done;
  } else {
  }
// compiled if node returning if4270 (depth = 8)
  gc_frame_end(frame);
  return if4270;
}
Object meth_ast__apply4152(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_s = getfromclosure(closure, 0);
  Object *var_firstPart = getfromclosure(closure, 1);
  Object *var_depth = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 925
  setline(925);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4154 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  partcv[0] = 0;
  Object call4155 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe4154);
// compiled call node returning call4155 (depth = 8)
// compiled member node returning call4155 (depth = 7)
  int op_slot_right_4153 = gc_frame_newslot(call4155);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_4153 = gc_frame_newslot(*var_s);
  params[0] = call4155;
  partcv[0] = 1;
  Object opresult4157 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4157 (depth = 6)
  *var_s = opresult4157;
  if (opresult4157 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 926
  setline(926);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4160 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block4161 = alloc_Block(NULL, NULL, "ast", 926);
  gc_frame_newslot(block4161);
// method _apply
  block_savedest(block4161);
  Object closure4162 = createclosure(1, "_apply");
  setclosureframe(closure4162, stackframe);
  addtoclosure(closure4162, selfslot);
  struct UserObject *uo4162 = (struct UserObject*)block4161;
  uo4162->data[0] = (Object)closure4162;
  Method *meth_meth_ast__apply4162 = addmethod2pos(block4161, "_apply", &meth_ast__apply4162, 0);
  int argcv_meth_ast__apply4162[] = {0};
  meth_meth_ast__apply4162->type = alloc_MethodType(1, argcv_meth_ast__apply4162);
  meth_meth_ast__apply4162->definitionModule = modulename;
  meth_meth_ast__apply4162->definitionLine = 925;
// compiled block node returning block4161 (depth = 7)
  gc_frame_newslot(block4161);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_firstPart (depth = 7)
  params[0] = block4161;
  partcv[0] = 1;
  Object call4170 = callmethod(*var_firstPart, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe4160);
// compiled call node returning call4170 (depth = 6)
  Object if4159 = done;
  if (istrue(call4170)) {
// Begin line 927
  setline(927);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4172 == NULL) {
    strlit4172 = alloc_String("<");
    gc_root(strlit4172);
  }
// compiled string node returning strlit4172 (depth = 8)
  int op_slot_right_4171 = gc_frame_newslot(strlit4172);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_4171 = gc_frame_newslot(*var_s);
  params[0] = strlit4172;
  partcv[0] = 1;
  Object opresult4174 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4174 (depth = 7)
  *var_s = opresult4174;
  if (opresult4174 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 928
  setline(928);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4176 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num4179 = alloc_Float64(1);
// compiled num node returning num4179 (depth = 9)
  int op_slot_right_4178 = gc_frame_newslot(num4179);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4181 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe4182 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4183 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4182);
// compiled call node returning call4183 (depth = 12)
// compiled member node returning call4183 (depth = 11)
  partcv[0] = 0;
  Object call4184 = callmethod(call4183, "size",
    1, partcv, params);
  gc_frame_end(callframe4181);
// compiled call node returning call4184 (depth = 10)
// compiled member node returning call4184 (depth = 9)
  int op_slot_left_4178 = gc_frame_newslot(call4184);
  params[0] = num4179;
  partcv[0] = 1;
  Object diff4185 = callmethod(call4184, "-", 1, partcv, params);
// compiled op node returning diff4185 (depth = 8)
  int op_slot_right_4177 = gc_frame_newslot(diff4185);
// starting to compile num node (depth = 8)
  Object num4187 = alloc_Float64(1);
// compiled num node returning num4187 (depth = 8)
  int op_slot_left_4177 = gc_frame_newslot(num4187);
  params[0] = diff4185;
  partcv[0] = 1;
  Object opresult4188 = callmethod(num4187, "..", 1, partcv, params);
// compiled op node returning opresult4188 (depth = 7)
  gc_frame_newslot(opresult4188);
// starting to compile block node (depth = 7)
  Object block4189 = alloc_Block(NULL, NULL, "ast", 928);
  gc_frame_newslot(block4189);
// method _apply
  block_savedest(block4189);
  Object closure4190 = createclosure(3, "_apply");
  setclosureframe(closure4190, stackframe);
  addtoclosure(closure4190, var_depth);
  addtoclosure(closure4190, var_s);
  addtoclosure(closure4190, selfslot);
  struct UserObject *uo4190 = (struct UserObject*)block4189;
  uo4190->data[0] = (Object)closure4190;
  Method *meth_meth_ast__apply4190 = addmethod2pos(block4189, "_apply", &meth_ast__apply4190, 0);
  int argcv_meth_ast__apply4190[] = {1};
  meth_meth_ast__apply4190->type = alloc_MethodType(1, argcv_meth_ast__apply4190);
  meth_meth_ast__apply4190->definitionModule = modulename;
  meth_meth_ast__apply4190->definitionLine = 928;
// compiled block node returning block4189 (depth = 7)
  gc_frame_newslot(block4189);
// call case 5: prelude request
  params[0] = opresult4188;
  params[1] = block4189;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4206 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4176);
// compiled call node returning call4206 (depth = 6)
// Begin line 931
  setline(931);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4208 == NULL) {
    strlit4208 = alloc_String(">");
    gc_root(strlit4208);
  }
// compiled string node returning strlit4208 (depth = 8)
  int op_slot_right_4207 = gc_frame_newslot(strlit4208);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4211 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num4213 = alloc_Float64(1);
// compiled num node returning num4213 (depth = 11)
  int op_slot_right_4212 = gc_frame_newslot(num4213);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_4212 = gc_frame_newslot(*var_depth);
  params[0] = num4213;
  partcv[0] = 1;
  Object sum4215 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum4215 (depth = 10)
  gc_frame_newslot(sum4215);
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe4216 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe4217 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4218 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4217);
// compiled call node returning call4218 (depth = 13)
// compiled member node returning call4218 (depth = 12)
  partcv[0] = 0;
  Object call4219 = callmethod(call4218, "last",
    1, partcv, params);
  gc_frame_end(callframe4216);
// compiled call node returning call4219 (depth = 11)
// compiled member node returning call4219 (depth = 10)
  params[0] = sum4215;
  partcv[0] = 1;
  Object call4220 = callmethod(call4219, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4211);
// compiled call node returning call4220 (depth = 9)
  int op_slot_right_4210 = gc_frame_newslot(call4220);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_4210 = gc_frame_newslot(*var_s);
  params[0] = call4220;
  partcv[0] = 1;
  Object opresult4222 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4222 (depth = 8)
  int op_slot_left_4207 = gc_frame_newslot(opresult4222);
  params[0] = strlit4208;
  partcv[0] = 1;
  Object opresult4223 = callmethod(opresult4222, "++", 1, partcv, params);
// compiled op node returning opresult4223 (depth = 7)
  *var_s = opresult4223;
  if (opresult4223 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if4159 = done;
  } else {
  }
// compiled if node returning if4159 (depth = 5)
// Begin line 933
  setline(933);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool4225 = alloc_Boolean(0);
// compiled identifier node returning bool4225 (depth = 6)
  *var_firstPart = bool4225;
  if (bool4225 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 934
  setline(934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool4230 = alloc_Boolean(0);
// compiled identifier node returning bool4230 (depth = 8)
  int op_slot_right_4229 = gc_frame_newslot(bool4230);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4232 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_part (depth = 10)
  partcv[0] = 0;
  Object call4233 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe4232);
// compiled call node returning call4233 (depth = 9)
// compiled member node returning call4233 (depth = 8)
  int op_slot_left_4229 = gc_frame_newslot(call4233);
  params[0] = bool4230;
  partcv[0] = 1;
  Object opresult4234 = callmethod(call4233, "!=", 1, partcv, params);
// compiled op node returning opresult4234 (depth = 7)
  int op_slot_right_4228 = gc_frame_newslot(opresult4234);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num4237 = alloc_Float64(0);
// compiled num node returning num4237 (depth = 8)
  int op_slot_right_4236 = gc_frame_newslot(num4237);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4239 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe4240 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_part (depth = 12)
  partcv[0] = 0;
  Object call4241 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe4240);
// compiled call node returning call4241 (depth = 11)
// compiled member node returning call4241 (depth = 10)
  partcv[0] = 0;
  Object call4242 = callmethod(call4241, "size",
    1, partcv, params);
  gc_frame_end(callframe4239);
// compiled call node returning call4242 (depth = 9)
// compiled member node returning call4242 (depth = 8)
  int op_slot_left_4236 = gc_frame_newslot(call4242);
  params[0] = num4237;
  partcv[0] = 1;
  Object opresult4243 = callmethod(call4242, ">", 1, partcv, params);
// compiled op node returning opresult4243 (depth = 7)
  int op_slot_left_4228 = gc_frame_newslot(opresult4243);
  params[0] = opresult4234;
  partcv[0] = 1;
  Object opresult4244 = callmethod(opresult4243, "||", 1, partcv, params);
// compiled op node returning opresult4244 (depth = 6)
  Object if4227 = done;
  if (istrue(opresult4244)) {
// Begin line 935
  setline(935);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4246 == NULL) {
    strlit4246 = alloc_String("(");
    gc_root(strlit4246);
  }
// compiled string node returning strlit4246 (depth = 8)
  int op_slot_right_4245 = gc_frame_newslot(strlit4246);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_4245 = gc_frame_newslot(*var_s);
  params[0] = strlit4246;
  partcv[0] = 1;
  Object opresult4248 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4248 (depth = 7)
  *var_s = opresult4248;
  if (opresult4248 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 936
  setline(936);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4250 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4251 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4252 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_part (depth = 11)
  partcv[0] = 0;
  Object call4253 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe4252);
// compiled call node returning call4253 (depth = 10)
// compiled member node returning call4253 (depth = 9)
  partcv[0] = 0;
  Object call4254 = callmethod(call4253, "indices",
    1, partcv, params);
  gc_frame_end(callframe4251);
// compiled call node returning call4254 (depth = 8)
// compiled member node returning call4254 (depth = 7)
  gc_frame_newslot(call4254);
// starting to compile block node (depth = 7)
  Object block4255 = alloc_Block(NULL, NULL, "ast", 936);
  gc_frame_newslot(block4255);
// method _apply
  block_savedest(block4255);
  Object closure4256 = createclosure(4, "_apply");
  setclosureframe(closure4256, stackframe);
  addtoclosure(closure4256, var_part);
  addtoclosure(closure4256, var_depth);
  addtoclosure(closure4256, var_s);
  addtoclosure(closure4256, selfslot);
  struct UserObject *uo4256 = (struct UserObject*)block4255;
  uo4256->data[0] = (Object)closure4256;
  Method *meth_meth_ast__apply4256 = addmethod2pos(block4255, "_apply", &meth_ast__apply4256, 0);
  int argcv_meth_ast__apply4256[] = {1};
  meth_meth_ast__apply4256->type = alloc_MethodType(1, argcv_meth_ast__apply4256);
  meth_meth_ast__apply4256->definitionModule = modulename;
  meth_meth_ast__apply4256->definitionLine = 936;
// compiled block node returning block4255 (depth = 7)
  gc_frame_newslot(block4255);
// call case 5: prelude request
  params[0] = call4254;
  params[1] = block4255;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4293 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4250);
// compiled call node returning call4293 (depth = 6)
// Begin line 943
  setline(943);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool4296 = alloc_Boolean(0);
// compiled identifier node returning bool4296 (depth = 8)
  int op_slot_right_4295 = gc_frame_newslot(bool4296);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4298 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_part (depth = 10)
  partcv[0] = 0;
  Object call4299 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe4298);
// compiled call node returning call4299 (depth = 9)
// compiled member node returning call4299 (depth = 8)
  int op_slot_left_4295 = gc_frame_newslot(call4299);
  params[0] = bool4296;
  partcv[0] = 1;
  Object opresult4300 = callmethod(call4299, "!=", 1, partcv, params);
// compiled op node returning opresult4300 (depth = 7)
  Object if4294 = done;
  if (istrue(opresult4300)) {
// Begin line 944
  setline(944);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4302 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe4303 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_part (depth = 13)
  partcv[0] = 0;
  Object call4304 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe4303);
// compiled call node returning call4304 (depth = 12)
// compiled member node returning call4304 (depth = 11)
  partcv[0] = 0;
  Object call4305 = callmethod(call4304, "value",
    1, partcv, params);
  gc_frame_end(callframe4302);
// compiled call node returning call4305 (depth = 10)
// compiled member node returning call4305 (depth = 9)
  int op_slot_right_4301 = gc_frame_newslot(call4305);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit4308 == NULL) {
    strlit4308 = alloc_String("*");
    gc_root(strlit4308);
  }
// compiled string node returning strlit4308 (depth = 10)
  int op_slot_right_4307 = gc_frame_newslot(strlit4308);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_4307 = gc_frame_newslot(*var_s);
  params[0] = strlit4308;
  partcv[0] = 1;
  Object opresult4310 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4310 (depth = 9)
  int op_slot_left_4301 = gc_frame_newslot(opresult4310);
  params[0] = call4305;
  partcv[0] = 1;
  Object opresult4311 = callmethod(opresult4310, "++", 1, partcv, params);
// compiled op node returning opresult4311 (depth = 8)
  *var_s = opresult4311;
  if (opresult4311 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if4294 = done;
  } else {
  }
// compiled if node returning if4294 (depth = 6)
// Begin line 946
  setline(946);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4314 == NULL) {
    strlit4314 = alloc_String(")");
    gc_root(strlit4314);
  }
// compiled string node returning strlit4314 (depth = 8)
  int op_slot_right_4313 = gc_frame_newslot(strlit4314);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_4313 = gc_frame_newslot(*var_s);
  params[0] = strlit4314;
  partcv[0] = 1;
  Object opresult4316 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4316 (depth = 7)
  *var_s = opresult4316;
  if (opresult4316 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if4227 = done;
  } else {
  }
// compiled if node returning if4227 (depth = 5)
  gc_frame_end(frame);
  return if4227;
}
Object meth_ast__apply4362(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 955
  setline(955);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4364 = gc_frame_new();
// starting to compile num node (depth = 10)
  Object num4365 = alloc_Float64(0);
// compiled num node returning num4365 (depth = 10)
  gc_frame_newslot(num4365);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_b (depth = 10)
  params[0] = num4365;
  partcv[0] = 1;
  Object call4366 = callmethod(*var_b, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4364);
// compiled call node returning call4366 (depth = 9)
  int op_slot_right_4363 = gc_frame_newslot(call4366);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit4370 == NULL) {
    strlit4370 = alloc_String("");
    gc_root(strlit4370);
  }
// compiled string node returning strlit4370 (depth = 11)
  int op_slot_right_4369 = gc_frame_newslot(strlit4370);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_a (depth = 11)
  int op_slot_left_4369 = gc_frame_newslot(*var_a);
  params[0] = strlit4370;
  partcv[0] = 1;
  Object opresult4372 = callmethod(*var_a, "!=", 1, partcv, params);
// compiled op node returning opresult4372 (depth = 10)
  Object if4368 = done;
struct StackFrameObject *iftmpstackframe4368 = stackframe;
  if (istrue(opresult4372)) {
stackframe = alloc_StackFrame(0, iftmpstackframe4368);
gc_frame_newslot((Object)stackframe);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit4374 == NULL) {
    strlit4374 = alloc_String(", ");
    gc_root(strlit4374);
  }
// compiled string node returning strlit4374 (depth = 11)
  int op_slot_right_4373 = gc_frame_newslot(strlit4374);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_a (depth = 11)
  int op_slot_left_4373 = gc_frame_newslot(*var_a);
  params[0] = strlit4374;
  partcv[0] = 1;
  Object opresult4376 = callmethod(*var_a, "++", 1, partcv, params);
// compiled op node returning opresult4376 (depth = 10)
    gc_frame_newslot(opresult4376);
    if4368 = opresult4376;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe4368);
  gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 10)
  if (strlit4377 == NULL) {
    strlit4377 = alloc_String("");
    gc_root(strlit4377);
  }
// compiled string node returning strlit4377 (depth = 10)
    gc_frame_newslot(strlit4377);
    if4368 = strlit4377;
  }
stackframe = iftmpstackframe4368;
// compiled if node returning if4368 (depth = 9)
  int op_slot_left_4363 = gc_frame_newslot(if4368);
  params[0] = call4366;
  partcv[0] = 1;
  Object opresult4378 = callmethod(if4368, "++", 1, partcv, params);
// compiled op node returning opresult4378 (depth = 8)
  gc_frame_end(frame);
  return opresult4378;
}
Object meth_ast__apply4414(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 962
  setline(962);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4416 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num4418 = alloc_Float64(1);
// compiled num node returning num4418 (depth = 9)
  int op_slot_right_4417 = gc_frame_newslot(num4418);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_4417 = gc_frame_newslot(*var_depth);
  params[0] = num4418;
  partcv[0] = 1;
  Object sum4420 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum4420 (depth = 8)
  gc_frame_newslot(sum4420);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mx (depth = 8)
  params[0] = sum4420;
  partcv[0] = 1;
  Object call4421 = callmethod(*var_mx, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4416);
// compiled call node returning call4421 (depth = 7)
  int op_slot_right_4415 = gc_frame_newslot(call4421);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4424 == NULL) {
    strlit4424 = alloc_String("    ");
    gc_root(strlit4424);
  }
// compiled string node returning strlit4424 (depth = 8)
  int op_slot_right_4423 = gc_frame_newslot(strlit4424);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_4426 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit4429 == NULL) {
    strlit4429 = alloc_String("""\x0a""");
    gc_root(strlit4429);
  }
// compiled string node returning strlit4429 (depth = 10)
  int op_slot_right_4428 = gc_frame_newslot(strlit4429);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_4428 = gc_frame_newslot(*var_s);
  params[0] = strlit4429;
  partcv[0] = 1;
  Object opresult4431 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4431 (depth = 9)
  int op_slot_left_4426 = gc_frame_newslot(opresult4431);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4432 = callmethod(opresult4431, "++", 1, partcv, params);
// compiled op node returning opresult4432 (depth = 8)
  int op_slot_left_4423 = gc_frame_newslot(opresult4432);
  params[0] = strlit4424;
  partcv[0] = 1;
  Object opresult4433 = callmethod(opresult4432, "++", 1, partcv, params);
// compiled op node returning opresult4433 (depth = 7)
  int op_slot_left_4415 = gc_frame_newslot(opresult4433);
  params[0] = call4421;
  partcv[0] = 1;
  Object opresult4434 = callmethod(opresult4433, "++", 1, partcv, params);
// compiled op node returning opresult4434 (depth = 6)
  *var_s = opresult4434;
  if (opresult4434 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace4126(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
  Object *var_firstPart = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "firstPart");
// Begin line 918
  setline(918);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit4127 == NULL) {
    strlit4127 = alloc_String("");
    gc_root(strlit4127);
  }
// compiled string node returning strlit4127 (depth = 4)
  *var_spc = strlit4127;
  if (strlit4127 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 919
  setline(919);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4128 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num4131 = alloc_Float64(1);
// compiled num node returning num4131 (depth = 6)
  int op_slot_right_4130 = gc_frame_newslot(num4131);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_4130 = gc_frame_newslot(*var_depth);
  params[0] = num4131;
  partcv[0] = 1;
  Object diff4133 = callmethod(*var_depth, "-", 1, partcv, params);
// compiled op node returning diff4133 (depth = 5)
  int op_slot_right_4129 = gc_frame_newslot(diff4133);
// starting to compile num node (depth = 5)
  Object num4135 = alloc_Float64(0);
// compiled num node returning num4135 (depth = 5)
  int op_slot_left_4129 = gc_frame_newslot(num4135);
  params[0] = diff4133;
  partcv[0] = 1;
  Object opresult4136 = callmethod(num4135, "..", 1, partcv, params);
// compiled op node returning opresult4136 (depth = 4)
  gc_frame_newslot(opresult4136);
// starting to compile block node (depth = 4)
  Object block4137 = alloc_Block(NULL, NULL, "ast", 919);
  gc_frame_newslot(block4137);
// method _apply
  block_savedest(block4137);
  Object closure4138 = createclosure(2, "_apply");
  setclosureframe(closure4138, stackframe);
  addtoclosure(closure4138, var_spc);
  addtoclosure(closure4138, selfslot);
  struct UserObject *uo4138 = (struct UserObject*)block4137;
  uo4138->data[0] = (Object)closure4138;
  Method *meth_meth_ast__apply4138 = addmethod2pos(block4137, "_apply", &meth_ast__apply4138, 0);
  int argcv_meth_ast__apply4138[] = {1};
  meth_meth_ast__apply4138->type = alloc_MethodType(1, argcv_meth_ast__apply4138);
  meth_meth_ast__apply4138->definitionModule = modulename;
  meth_meth_ast__apply4138->definitionLine = 913;
// compiled block node returning block4137 (depth = 4)
  gc_frame_newslot(block4137);
// call case 5: prelude request
  params[0] = opresult4136;
  params[1] = block4137;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4145 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4128);
// compiled call node returning call4145 (depth = 3)
// Begin line 922
  setline(922);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit4146 == NULL) {
    strlit4146 = alloc_String("method ");
    gc_root(strlit4146);
  }
// compiled string node returning strlit4146 (depth = 4)
  *var_s = strlit4146;
  if (strlit4146 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 923
  setline(923);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool4147 = alloc_Boolean(1);
// compiled identifier node returning bool4147 (depth = 4)
  *var_firstPart = bool4147;
  if (bool4147 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 924
  setline(924);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4148 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4149 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4150 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4149);
// compiled call node returning call4150 (depth = 5)
// compiled member node returning call4150 (depth = 4)
  gc_frame_newslot(call4150);
// starting to compile block node (depth = 4)
  Object block4151 = alloc_Block(NULL, NULL, "ast", 924);
  gc_frame_newslot(block4151);
// method _apply
  block_savedest(block4151);
  Object closure4152 = createclosure(4, "_apply");
  setclosureframe(closure4152, stackframe);
  addtoclosure(closure4152, var_s);
  addtoclosure(closure4152, var_firstPart);
  addtoclosure(closure4152, var_depth);
  addtoclosure(closure4152, selfslot);
  struct UserObject *uo4152 = (struct UserObject*)block4151;
  uo4152->data[0] = (Object)closure4152;
  Method *meth_meth_ast__apply4152 = addmethod2pos(block4151, "_apply", &meth_ast__apply4152, 0);
  int argcv_meth_ast__apply4152[] = {1};
  meth_meth_ast__apply4152->type = alloc_MethodType(1, argcv_meth_ast__apply4152);
  meth_meth_ast__apply4152->definitionModule = modulename;
  meth_meth_ast__apply4152->definitionLine = 924;
// compiled block node returning block4151 (depth = 4)
  gc_frame_newslot(block4151);
// call case 5: prelude request
  params[0] = call4150;
  params[1] = block4151;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4319 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4148);
// compiled call node returning call4319 (depth = 3)
// Begin line 949
  setline(949);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool4322 = alloc_Boolean(0);
// compiled identifier node returning bool4322 (depth = 5)
  int op_slot_right_4321 = gc_frame_newslot(bool4322);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4324 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4325 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4324);
// compiled call node returning call4325 (depth = 6)
// compiled member node returning call4325 (depth = 5)
  int op_slot_left_4321 = gc_frame_newslot(call4325);
  params[0] = bool4322;
  partcv[0] = 1;
  Object opresult4326 = callmethod(call4325, "!=", 1, partcv, params);
// compiled op node returning opresult4326 (depth = 4)
  Object if4320 = done;
  if (istrue(opresult4326)) {
// Begin line 950
  setline(950);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4329 == NULL) {
    strlit4329 = alloc_String("");
    gc_root(strlit4329);
  }
// compiled string node returning strlit4329 (depth = 7)
  int op_slot_right_4328 = gc_frame_newslot(strlit4329);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4332 = gc_frame_new();
// starting to compile num node (depth = 9)
  Object num4333 = alloc_Float64(0);
// compiled num node returning num4333 (depth = 9)
  gc_frame_newslot(num4333);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4334 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4335 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4334);
// compiled call node returning call4335 (depth = 10)
// compiled member node returning call4335 (depth = 9)
  params[0] = num4333;
  partcv[0] = 1;
  Object call4336 = callmethod(call4335, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4332);
// compiled call node returning call4336 (depth = 8)
  int op_slot_right_4331 = gc_frame_newslot(call4336);
// starting to compile string node (depth = 8)
  if (strlit4338 == NULL) {
    strlit4338 = alloc_String(" -> ");
    gc_root(strlit4338);
  }
// compiled string node returning strlit4338 (depth = 8)
  int op_slot_left_4331 = gc_frame_newslot(strlit4338);
  params[0] = call4336;
  partcv[0] = 1;
  Object opresult4339 = callmethod(strlit4338, "++", 1, partcv, params);
// compiled op node returning opresult4339 (depth = 7)
  int op_slot_left_4328 = gc_frame_newslot(opresult4339);
  params[0] = strlit4329;
  partcv[0] = 1;
  Object opresult4340 = callmethod(opresult4339, "++", 1, partcv, params);
// compiled op node returning opresult4340 (depth = 6)
  int op_slot_right_4327 = gc_frame_newslot(opresult4340);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4327 = gc_frame_newslot(*var_s);
  params[0] = opresult4340;
  partcv[0] = 1;
  Object opresult4342 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4342 (depth = 5)
  *var_s = opresult4342;
  if (opresult4342 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if4320 = done;
  } else {
  }
// compiled if node returning if4320 (depth = 3)
// Begin line 952
  setline(952);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4346 = alloc_Float64(0);
// compiled num node returning num4346 (depth = 5)
  int op_slot_right_4345 = gc_frame_newslot(num4346);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4348 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4349 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4350 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4349);
// compiled call node returning call4350 (depth = 8)
// compiled member node returning call4350 (depth = 7)
  partcv[0] = 0;
  Object call4351 = callmethod(call4350, "size",
    1, partcv, params);
  gc_frame_end(callframe4348);
// compiled call node returning call4351 (depth = 6)
// compiled member node returning call4351 (depth = 5)
  int op_slot_left_4345 = gc_frame_newslot(call4351);
  params[0] = num4346;
  partcv[0] = 1;
  Object opresult4352 = callmethod(call4351, ">", 1, partcv, params);
// compiled op node returning opresult4352 (depth = 4)
  Object if4344 = done;
  if (istrue(opresult4352)) {
// Begin line 953
  setline(953);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4354 == NULL) {
    strlit4354 = alloc_String(" is ");
    gc_root(strlit4354);
  }
// compiled string node returning strlit4354 (depth = 6)
  int op_slot_right_4353 = gc_frame_newslot(strlit4354);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4353 = gc_frame_newslot(*var_s);
  params[0] = strlit4354;
  partcv[0] = 1;
  Object opresult4356 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4356 (depth = 5)
  *var_s = opresult4356;
  if (opresult4356 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 954
  setline(954);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4359 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4360 == NULL) {
    strlit4360 = alloc_String("");
    gc_root(strlit4360);
  }
// compiled string node returning strlit4360 (depth = 7)
  gc_frame_newslot(strlit4360);
// starting to compile block node (depth = 7)
  Object block4361 = alloc_Block(NULL, NULL, "ast", 954);
  gc_frame_newslot(block4361);
// method _apply
  block_savedest(block4361);
  Object closure4362 = createclosure(1, "_apply");
  setclosureframe(closure4362, stackframe);
  addtoclosure(closure4362, selfslot);
  struct UserObject *uo4362 = (struct UserObject*)block4361;
  uo4362->data[0] = (Object)closure4362;
  Method *meth_meth_ast__apply4362 = addmethod2pos(block4361, "_apply", &meth_ast__apply4362, 0);
  int argcv_meth_ast__apply4362[] = {2};
  meth_meth_ast__apply4362->type = alloc_MethodType(1, argcv_meth_ast__apply4362);
  meth_meth_ast__apply4362->definitionModule = modulename;
  meth_meth_ast__apply4362->definitionLine = 952;
// compiled block node returning block4361 (depth = 7)
  gc_frame_newslot(block4361);
// call case 6: other member request
// Begin line 954
  setline(954);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4380 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4381 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4380);
// compiled call node returning call4381 (depth = 8)
// compiled member node returning call4381 (depth = 7)
  params[0] = strlit4360;
  params[1] = block4361;
  partcv[0] = 2;
  Object call4382 = callmethod(call4381, "reduce",
    1, partcv, params);
  gc_frame_end(callframe4359);
// compiled call node returning call4382 (depth = 6)
  int op_slot_right_4358 = gc_frame_newslot(call4382);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4358 = gc_frame_newslot(*var_s);
  params[0] = call4382;
  partcv[0] = 1;
  Object opresult4384 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4384 (depth = 5)
  *var_s = opresult4384;
  if (opresult4384 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if4344 = done;
  } else {
  }
// compiled if node returning if4344 (depth = 3)
// Begin line 957
  setline(957);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4387 == NULL) {
    strlit4387 = alloc_String(" {");
    gc_root(strlit4387);
  }
// compiled string node returning strlit4387 (depth = 5)
  int op_slot_right_4386 = gc_frame_newslot(strlit4387);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_4386 = gc_frame_newslot(*var_s);
  params[0] = strlit4387;
  partcv[0] = 1;
  Object opresult4389 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4389 (depth = 4)
  *var_s = opresult4389;
  if (opresult4389 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 958
  setline(958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool4393 = alloc_Boolean(0);
// compiled identifier node returning bool4393 (depth = 5)
  int op_slot_right_4392 = gc_frame_newslot(bool4393);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4395 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4396 = callmethodflags(self, "comments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4395);
// compiled call node returning call4396 (depth = 6)
// compiled member node returning call4396 (depth = 5)
  int op_slot_left_4392 = gc_frame_newslot(call4396);
  params[0] = bool4393;
  partcv[0] = 1;
  Object opresult4397 = callmethod(call4396, "!=", 1, partcv, params);
// compiled op node returning opresult4397 (depth = 4)
  Object if4391 = done;
  if (istrue(opresult4397)) {
// Begin line 959
  setline(959);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4399 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num4401 = alloc_Float64(1);
// compiled num node returning num4401 (depth = 8)
  int op_slot_right_4400 = gc_frame_newslot(num4401);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_4400 = gc_frame_newslot(*var_depth);
  params[0] = num4401;
  partcv[0] = 1;
  Object sum4403 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum4403 (depth = 7)
  gc_frame_newslot(sum4403);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4404 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4405 = callmethodflags(self, "comments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4404);
// compiled call node returning call4405 (depth = 8)
// compiled member node returning call4405 (depth = 7)
  params[0] = sum4403;
  partcv[0] = 1;
  Object call4406 = callmethod(call4405, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4399);
// compiled call node returning call4406 (depth = 6)
  int op_slot_right_4398 = gc_frame_newslot(call4406);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4398 = gc_frame_newslot(*var_s);
  params[0] = call4406;
  partcv[0] = 1;
  Object opresult4408 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4408 (depth = 5)
  *var_s = opresult4408;
  if (opresult4408 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if4391 = done;
  } else {
  }
// compiled if node returning if4391 (depth = 3)
// Begin line 961
  setline(961);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4410 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4411 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4412 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4411);
// compiled call node returning call4412 (depth = 5)
// compiled member node returning call4412 (depth = 4)
  gc_frame_newslot(call4412);
// starting to compile block node (depth = 4)
  Object block4413 = alloc_Block(NULL, NULL, "ast", 961);
  gc_frame_newslot(block4413);
// method _apply
  block_savedest(block4413);
  Object closure4414 = createclosure(4, "_apply");
  setclosureframe(closure4414, stackframe);
  addtoclosure(closure4414, var_depth);
  addtoclosure(closure4414, var_spc);
  addtoclosure(closure4414, var_s);
  addtoclosure(closure4414, selfslot);
  struct UserObject *uo4414 = (struct UserObject*)block4413;
  uo4414->data[0] = (Object)closure4414;
  Method *meth_meth_ast__apply4414 = addmethod2pos(block4413, "_apply", &meth_ast__apply4414, 0);
  int argcv_meth_ast__apply4414[] = {1};
  meth_meth_ast__apply4414->type = alloc_MethodType(1, argcv_meth_ast__apply4414);
  meth_meth_ast__apply4414->definitionModule = modulename;
  meth_meth_ast__apply4414->definitionLine = 961;
// compiled block node returning block4413 (depth = 4)
  gc_frame_newslot(block4413);
// call case 5: prelude request
  params[0] = call4412;
  params[1] = block4413;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4437 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4410);
// compiled call node returning call4437 (depth = 3)
// Begin line 964
  setline(964);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4439 == NULL) {
    strlit4439 = alloc_String("}");
    gc_root(strlit4439);
  }
// compiled string node returning strlit4439 (depth = 5)
  int op_slot_right_4438 = gc_frame_newslot(strlit4439);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_4441 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4444 == NULL) {
    strlit4444 = alloc_String("""\x0a""");
    gc_root(strlit4444);
  }
// compiled string node returning strlit4444 (depth = 7)
  int op_slot_right_4443 = gc_frame_newslot(strlit4444);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_4443 = gc_frame_newslot(*var_s);
  params[0] = strlit4444;
  partcv[0] = 1;
  Object opresult4446 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4446 (depth = 6)
  int op_slot_left_4441 = gc_frame_newslot(opresult4446);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4447 = callmethod(opresult4446, "++", 1, partcv, params);
// compiled op node returning opresult4447 (depth = 5)
  int op_slot_left_4438 = gc_frame_newslot(opresult4447);
  params[0] = strlit4439;
  partcv[0] = 1;
  Object opresult4448 = callmethod(opresult4447, "++", 1, partcv, params);
// compiled op node returning opresult4448 (depth = 4)
  *var_s = opresult4448;
  if (opresult4448 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 965
  setline(965);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy4450(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 25, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[1];
  Object *var_methodNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 968
  setline(968);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4451 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe4452 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4453 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4454 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4453);
// compiled call node returning call4454 (depth = 6)
// compiled member node returning call4454 (depth = 5)
  gc_frame_newslot(call4454);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4455 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4456 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4455);
// compiled call node returning call4456 (depth = 6)
// compiled member node returning call4456 (depth = 5)
  gc_frame_newslot(call4456);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4457 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4458 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4457);
// compiled call node returning call4458 (depth = 6)
// compiled member node returning call4458 (depth = 5)
  gc_frame_newslot(call4458);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4459 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4460 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4459);
// compiled call node returning call4460 (depth = 6)
// compiled member node returning call4460 (depth = 5)
  gc_frame_newslot(call4460);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_methodNode (depth = 5)
  params[0] = call4454;
  params[1] = call4456;
  params[2] = call4458;
  params[3] = call4460;
  partcv[0] = 4;
  Object call4461 = callmethod(*var_methodNode, "new",
    1, partcv, params);
  gc_frame_end(callframe4452);
// compiled call node returning call4461 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call4462 = callmethod(call4461, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe4451);
// compiled call node returning call4462 (depth = 3)
  gc_frame_end(frame);
  return call4462;
}
Object meth_ast_shallowCopyFieldsFrom4463(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyFieldsFrom");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopyFieldsFrom (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyFieldsFrom");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 971
  setline(971);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4464 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call4465 = callmethod4(self, "shallowCopyFieldsFrom", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe4464);
// compiled call node returning call4465 (depth = 3)
// Begin line 972
  setline(972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 968
  setline(968);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4466 = gc_frame_new();
// Begin line 972
  setline(972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4467 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  partcv[0] = 0;
  Object call4468 = callmethod(*var_other, "isFresh",
    1, partcv, params);
  gc_frame_end(callframe4467);
// compiled call node returning call4468 (depth = 6)
// compiled member node returning call4468 (depth = 5)
  gc_frame_newslot(call4468);
// call case 4: self request
  params[0] = call4468;
  partcv[0] = 1;
  Object call4469 = callmethodflags(self, "isFresh:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4466);
// compiled call node returning call4469 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 973
  setline(973);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 972
  setline(972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4470 = gc_frame_new();
// Begin line 973
  setline(973);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4471 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  partcv[0] = 0;
  Object call4472 = callmethod(*var_other, "selfclosure",
    1, partcv, params);
  gc_frame_end(callframe4471);
// compiled call node returning call4472 (depth = 6)
// compiled member node returning call4472 (depth = 5)
  gc_frame_newslot(call4472);
// call case 4: self request
  params[0] = call4472;
  partcv[0] = 1;
  Object call4473 = callmethodflags(self, "selfclosure:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4470);
// compiled call node returning call4473 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 974
  setline(974);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_new3496(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 4)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_methodNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_signature_39_ = &(stackframe->slots[1]);
  *var_signature_39_ = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[2]);
  *var_body_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[3]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 4)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[4]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3497 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3497 = alloc_userobj2(36,28, objclass3497);
  gc_frame_newslot(obj3497);
if (objclass3497 == NULL) {
  glfree(obj3497->class->name);
  obj3497->class->name = "obj3489.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3497, self, 0);
  addmethodreal(obj3497,"outer", &reader_ast_outer_3498);
  Object oldself3497 = self;
  struct StackFrameObject *oldstackframe3497 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3497);
  gc_frame_newslot((Object)stackframe);
  self = obj3497;
  Object *oldselfslot3497 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3497 = (*(struct UserObject *)self).data[0], lowerouter3497 = thisouter3497;
  if (inheritingObject3497) {
    struct UserObject *inho3497 = (struct UserObject *)inheritingObject3497;
    while (inho3497->super != GraceDefaultObject) inho3497 = (struct UserObject *)inho3497->super;
    inho3497->super = obj3497;
    self = inheritingObject3497;
    *selfslot = self;
    lowerouter3497 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3497;
  }
if (objclass3497 == NULL) {
  Method *reader3499 = addmethodrealflags(obj3497, "kind",&reader_ast_kind_3499, MFLAG_DEF);
  reader3499->definitionModule = modulename;
  reader3499->definitionLine = 795;
}
adddatum2(obj3497, alloc_Undefined(), 1);
if (objclass3497 == NULL) {
  Method *reader3500 = addmethodrealflags(obj3497, "value",&reader_ast_value_3500, 0);
  Method *writer3500 = addmethodrealflags(obj3497, "value:=",&writer_ast_value_3500, 0);
  reader3500->definitionModule = modulename;
  writer3500->definitionModule = modulename;
  reader3500->definitionLine = 796;
  writer3500->definitionLine = 796;
}
obj3497->flags |= OFLAG_MUTABLE;
adddatum2(obj3497, alloc_Undefined(), 2);
if (objclass3497 == NULL) {
  Method *reader3501 = addmethodrealflags(obj3497, "signature",&reader_ast_signature_3501, 0);
  Method *writer3501 = addmethodrealflags(obj3497, "signature:=",&writer_ast_signature_3501, 0);
  reader3501->definitionModule = modulename;
  writer3501->definitionModule = modulename;
  reader3501->definitionLine = 797;
  writer3501->definitionLine = 797;
}
obj3497->flags |= OFLAG_MUTABLE;
adddatum2(obj3497, alloc_Undefined(), 3);
if (objclass3497 == NULL) {
  Method *reader3502 = addmethodrealflags(obj3497, "body",&reader_ast_body_3502, 0);
  Method *writer3502 = addmethodrealflags(obj3497, "body:=",&writer_ast_body_3502, 0);
  reader3502->definitionModule = modulename;
  writer3502->definitionModule = modulename;
  reader3502->definitionLine = 798;
  writer3502->definitionLine = 798;
}
obj3497->flags |= OFLAG_MUTABLE;
adddatum2(obj3497, alloc_Undefined(), 4);
if (objclass3497 == NULL) {
  Method *reader3503 = addmethodrealflags(obj3497, "dtype",&reader_ast_dtype_3503, 0);
  Method *writer3503 = addmethodrealflags(obj3497, "dtype:=",&writer_ast_dtype_3503, 0);
  reader3503->definitionModule = modulename;
  writer3503->definitionModule = modulename;
  reader3503->definitionLine = 799;
  writer3503->definitionLine = 799;
}
obj3497->flags |= OFLAG_MUTABLE;
adddatum2(obj3497, alloc_Undefined(), 5);
if (objclass3497 == NULL) {
  Method *reader3504 = addmethodrealflags(obj3497, "varargs",&reader_ast_varargs_3504, 0);
  Method *writer3504 = addmethodrealflags(obj3497, "varargs:=",&writer_ast_varargs_3504, 0);
  reader3504->definitionModule = modulename;
  writer3504->definitionModule = modulename;
  reader3504->definitionLine = 800;
  writer3504->definitionLine = 800;
}
obj3497->flags |= OFLAG_MUTABLE;
adddatum2(obj3497, alloc_Undefined(), 6);
if (objclass3497 == NULL) {
  Method *reader3505 = addmethodrealflags(obj3497, "generics",&reader_ast_generics_3505, 0);
  Method *writer3505 = addmethodrealflags(obj3497, "generics:=",&writer_ast_generics_3505, 0);
  reader3505->definitionModule = modulename;
  writer3505->definitionModule = modulename;
  reader3505->definitionLine = 801;
  writer3505->definitionLine = 801;
}
obj3497->flags |= OFLAG_MUTABLE;
adddatum2(obj3497, alloc_Undefined(), 7);
if (objclass3497 == NULL) {
  Method *reader3506 = addmethodrealflags(obj3497, "selfclosure",&reader_ast_selfclosure_3506, 0);
  Method *writer3506 = addmethodrealflags(obj3497, "selfclosure:=",&writer_ast_selfclosure_3506, 0);
  reader3506->definitionModule = modulename;
  writer3506->definitionModule = modulename;
  reader3506->definitionLine = 802;
  writer3506->definitionLine = 802;
}
obj3497->flags |= OFLAG_MUTABLE;
adddatum2(obj3497, alloc_Undefined(), 8);
if (objclass3497 == NULL) {
  Method *reader3507 = addmethodrealflags(obj3497, "nameString",&reader_ast_nameString_3507, MFLAG_DEF);
  reader3507->definitionModule = modulename;
  reader3507->definitionLine = 803;
}
adddatum2(obj3497, alloc_Undefined(), 9);
if (objclass3497 == NULL) {
  Method *reader3508 = addmethodrealflags(obj3497, "annotations",&reader_ast_annotations_3508, 0);
  Method *writer3508 = addmethodrealflags(obj3497, "annotations:=",&writer_ast_annotations_3508, 0);
  reader3508->definitionModule = modulename;
  writer3508->definitionModule = modulename;
  reader3508->definitionLine = 804;
  writer3508->definitionLine = 804;
}
obj3497->flags |= OFLAG_MUTABLE;
adddatum2(obj3497, alloc_Undefined(), 10);
if (objclass3497 == NULL) {
  Method *reader3509 = addmethodrealflags(obj3497, "isFresh",&reader_ast_isFresh_3509, 0);
  Method *writer3509 = addmethodrealflags(obj3497, "isFresh:=",&writer_ast_isFresh_3509, 0);
  reader3509->definitionModule = modulename;
  writer3509->definitionModule = modulename;
  reader3509->definitionLine = 805;
  writer3509->definitionLine = 805;
}
obj3497->flags |= OFLAG_MUTABLE;
adddatum2(obj3497, alloc_Undefined(), 11);
// method scope:=
  struct UserObject *uo3510 = (struct UserObject*)obj3497;
  uo3510->data[12] = emptyclosure;
  Method *meth_meth_ast_scope_58__61_3510 = addmethod2pos(obj3497, "scope:=", &meth_ast_scope_58__61_3510, 12);
  int argcv_meth_ast_scope_58__61_3510[] = {1};
  meth_meth_ast_scope_58__61_3510->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61_3510);
  meth_meth_ast_scope_58__61_3510->definitionModule = modulename;
  meth_meth_ast_scope_58__61_3510->definitionLine = 807;
// method declarationKindWithAncestors
  struct UserObject *uo3515 = (struct UserObject*)obj3497;
  uo3515->data[13] = emptyclosure;
  Method *meth_meth_ast_declarationKindWithAncestors3515 = addmethod2pos(obj3497, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors3515, 13);
  int argcv_meth_ast_declarationKindWithAncestors3515[] = {1};
  meth_meth_ast_declarationKindWithAncestors3515->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors3515);
  meth_meth_ast_declarationKindWithAncestors3515->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors3515->definitionLine = 813;
// method isConfidential
  struct UserObject *uo3517 = (struct UserObject*)obj3497;
  uo3517->data[14] = emptyclosure;
  Method *meth_meth_ast_isConfidential3517 = addmethod2pos(obj3497, "isConfidential", &meth_ast_isConfidential3517, 14);
  int argcv_meth_ast_isConfidential3517[] = {0};
  meth_meth_ast_isConfidential3517->type = alloc_MethodType(1, argcv_meth_ast_isConfidential3517);
  meth_meth_ast_isConfidential3517->definitionModule = modulename;
  meth_meth_ast_isConfidential3517->definitionLine = 816;
// method isPublic
  struct UserObject *uo3535 = (struct UserObject*)obj3497;
  uo3535->data[15] = emptyclosure;
  Method *meth_meth_ast_isPublic3535 = addmethod2pos(obj3497, "isPublic", &meth_ast_isPublic3535, 15);
  int argcv_meth_ast_isPublic3535[] = {0};
  meth_meth_ast_isPublic3535->type = alloc_MethodType(1, argcv_meth_ast_isPublic3535);
  meth_meth_ast_isPublic3535->definitionModule = modulename;
  meth_meth_ast_isPublic3535->definitionLine = 820;
// method isWritable
  struct UserObject *uo3540 = (struct UserObject*)obj3497;
  uo3540->data[16] = emptyclosure;
  Method *meth_meth_ast_isWritable3540 = addmethod2pos(obj3497, "isWritable", &meth_ast_isWritable3540, 16);
  int argcv_meth_ast_isWritable3540[] = {0};
  meth_meth_ast_isWritable3540->type = alloc_MethodType(1, argcv_meth_ast_isWritable3540);
  meth_meth_ast_isWritable3540->definitionModule = modulename;
  meth_meth_ast_isWritable3540->definitionLine = 821;
// method isReadable
  struct UserObject *uo3542 = (struct UserObject*)obj3497;
  uo3542->data[17] = emptyclosure;
  Method *meth_meth_ast_isReadable3542 = addmethod2pos(obj3497, "isReadable", &meth_ast_isReadable3542, 17);
  int argcv_meth_ast_isReadable3542[] = {0};
  meth_meth_ast_isReadable3542->type = alloc_MethodType(1, argcv_meth_ast_isReadable3542);
  meth_meth_ast_isReadable3542->definitionModule = modulename;
  meth_meth_ast_isReadable3542->definitionLine = 822;
// method usesAsType
  struct UserObject *uo3545 = (struct UserObject*)obj3497;
  uo3545->data[18] = emptyclosure;
  Method *meth_meth_ast_usesAsType3545 = addmethod2pos(obj3497, "usesAsType", &meth_ast_usesAsType3545, 18);
  int argcv_meth_ast_usesAsType3545[] = {1};
  meth_meth_ast_usesAsType3545->type = alloc_MethodType(1, argcv_meth_ast_usesAsType3545);
  meth_meth_ast_usesAsType3545->definitionModule = modulename;
  meth_meth_ast_usesAsType3545->definitionLine = 823;
// method returnsObject
  struct UserObject *uo3551 = (struct UserObject*)obj3497;
  uo3551->data[19] = emptyclosure;
  Method *meth_meth_ast_returnsObject3551 = addmethod2pos(obj3497, "returnsObject", &meth_ast_returnsObject3551, 19);
  int argcv_meth_ast_returnsObject3551[] = {0};
  meth_meth_ast_returnsObject3551->type = alloc_MethodType(1, argcv_meth_ast_returnsObject3551);
  meth_meth_ast_returnsObject3551->definitionModule = modulename;
  meth_meth_ast_returnsObject3551->definitionLine = 826;
// method returnedObjectScope
  struct UserObject *uo3569 = (struct UserObject*)obj3497;
  uo3569->data[20] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope3569 = addmethod2pos(obj3497, "returnedObjectScope", &meth_ast_returnedObjectScope3569, 20);
  int argcv_meth_ast_returnedObjectScope3569[] = {0};
  meth_meth_ast_returnedObjectScope3569->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope3569);
  meth_meth_ast_returnedObjectScope3569->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope3569->definitionLine = 829;
// method accept()from
  struct UserObject *uo3576 = (struct UserObject*)obj3497;
  uo3576->data[21] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from3576 = addmethod2pos(obj3497, "accept()from", &meth_ast_accept_40__41_from3576, 21);
  int argcv_meth_ast_accept_40__41_from3576[] = {1, 1};
  meth_meth_ast_accept_40__41_from3576->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from3576);
  meth_meth_ast_accept_40__41_from3576->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from3576->definitionLine = 833;
// method map()ancestors
  struct UserObject *uo3653 = (struct UserObject*)obj3497;
  uo3653->data[22] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors3653 = addmethod2pos(obj3497, "map()ancestors", &meth_ast_map_40__41_ancestors3653, 22);
  int argcv_meth_ast_map_40__41_ancestors3653[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors3653->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors3653);
  meth_meth_ast_map_40__41_ancestors3653->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors3653->definitionLine = 859;
// method pretty
  struct UserObject *uo3710 = (struct UserObject*)obj3497;
  uo3710->data[23] = emptyclosure;
  Method *meth_meth_ast_pretty3710 = addmethod2pos(obj3497, "pretty", &meth_ast_pretty3710, 23);
  int argcv_meth_ast_pretty3710[] = {1};
  meth_meth_ast_pretty3710->type = alloc_MethodType(1, argcv_meth_ast_pretty3710);
  meth_meth_ast_pretty3710->definitionModule = modulename;
  meth_meth_ast_pretty3710->definitionLine = 869;
// method toGrace
  struct UserObject *uo4126 = (struct UserObject*)obj3497;
  uo4126->data[24] = emptyclosure;
  Method *meth_meth_ast_toGrace4126 = addmethod2pos(obj3497, "toGrace", &meth_ast_toGrace4126, 24);
  int argcv_meth_ast_toGrace4126[] = {1};
  meth_meth_ast_toGrace4126->type = alloc_MethodType(1, argcv_meth_ast_toGrace4126);
meth_meth_ast_toGrace4126->type->types[0] = type_Number;
meth_meth_ast_toGrace4126->type->names[0] = "depth";
  meth_meth_ast_toGrace4126->definitionModule = modulename;
  meth_meth_ast_toGrace4126->definitionLine = 917;
// method shallowCopy
  block_savedest(obj3497);
  Object closure4450 = createclosure(1, "shallowCopy");
  setclosureframe(closure4450, stackframe);
  addtoclosure(closure4450, var_methodNode);
  struct UserObject *uo4450 = (struct UserObject*)obj3497;
  uo4450->data[25] = (Object)closure4450;
  Method *meth_meth_ast_shallowCopy4450 = addmethod2pos(obj3497, "shallowCopy", &meth_ast_shallowCopy4450, 25);
  int argcv_meth_ast_shallowCopy4450[] = {0};
  meth_meth_ast_shallowCopy4450->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy4450);
  meth_meth_ast_shallowCopy4450->definitionModule = modulename;
  meth_meth_ast_shallowCopy4450->definitionLine = 967;
// method shallowCopyFieldsFrom
  struct UserObject *uo4463 = (struct UserObject*)obj3497;
  uo4463->data[26] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom4463 = addmethod2pos(obj3497, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom4463, 26);
  int argcv_meth_ast_shallowCopyFieldsFrom4463[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom4463->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom4463);
  meth_meth_ast_shallowCopyFieldsFrom4463->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom4463->definitionLine = 970;
  sourceObject = obj3497;
// Begin line 794
  setline(794);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4474 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_baseNode (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call4475 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe4474);
// compiled call node returning call4475 (depth = 3)
  struct UserObject *obj3497_uo = (struct UserObject *)obj3497;
  obj3497_uo->super = call4475;
  sourceObject = obj3497;
// Begin line 795
  setline(795);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit4476 == NULL) {
    strlit4476 = alloc_String("method");
    gc_root(strlit4476);
  }
// compiled string node returning strlit4476 (depth = 3)
  adddatum2(obj3497, strlit4476, 1);
  sourceObject = obj3497;
// Begin line 796
  setline(796);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj3497, *var_name_39_, 2);
  sourceObject = obj3497;
// Begin line 797
  setline(797);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_signature_39_ (depth = 3)
  adddatum2(obj3497, *var_signature_39_, 3);
  sourceObject = obj3497;
// Begin line 798
  setline(798);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_body_39_ (depth = 3)
  adddatum2(obj3497, *var_body_39_, 4);
  sourceObject = obj3497;
// Begin line 799
  setline(799);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj3497, *var_dtype_39_, 5);
  sourceObject = obj3497;
// Begin line 800
  setline(800);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4477 = alloc_Boolean(0);
// compiled identifier node returning bool4477 (depth = 3)
  adddatum2(obj3497, bool4477, 6);
  sourceObject = obj3497;
// Begin line 801
  setline(801);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4478 = alloc_Boolean(0);
// compiled identifier node returning bool4478 (depth = 3)
  adddatum2(obj3497, bool4478, 7);
  sourceObject = obj3497;
// Begin line 802
  setline(802);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4479 = alloc_Boolean(0);
// compiled identifier node returning bool4479 (depth = 3)
  adddatum2(obj3497, bool4479, 8);
  sourceObject = obj3497;
// Begin line 803
  setline(803);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4480 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4481 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4482 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4481);
// compiled call node returning call4482 (depth = 6)
// compiled member node returning call4482 (depth = 5)
  partcv[0] = 0;
  Object call4483 = callmethod(call4482, "value",
    1, partcv, params);
  gc_frame_end(callframe4480);
// compiled call node returning call4483 (depth = 4)
// compiled member node returning call4483 (depth = 3)
  adddatum2(obj3497, call4483, 9);
  sourceObject = obj3497;
// Begin line 804
  setline(804);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4484 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4485 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4486 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4485);
// compiled call node returning call4486 (depth = 6)
// compiled member node returning call4486 (depth = 5)
  partcv[0] = 0;
  Object call4487 = callmethod(call4486, "empty",
    1, partcv, params);
  gc_frame_end(callframe4484);
// compiled call node returning call4487 (depth = 4)
// compiled member node returning call4487 (depth = 3)
  adddatum2(obj3497, call4487, 10);
  sourceObject = obj3497;
// Begin line 805
  setline(805);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4488 = alloc_Boolean(0);
// compiled identifier node returning bool4488 (depth = 3)
  adddatum2(obj3497, bool4488, 11);
  sourceObject = obj3497;
  sourceObject = obj3497;
  sourceObject = obj3497;
  sourceObject = obj3497;
  sourceObject = obj3497;
  sourceObject = obj3497;
  sourceObject = obj3497;
  sourceObject = obj3497;
  sourceObject = obj3497;
  sourceObject = obj3497;
  sourceObject = obj3497;
  sourceObject = obj3497;
  sourceObject = obj3497;
  sourceObject = obj3497;
  sourceObject = obj3497;
  objclass3497 = obj3497->class;
  objclass3497->definitionModule = modulename;
  objclass3497->definitionLine = 787;
  (*(struct UserObject *)self).data[0] = lowerouter3497;
  self = oldself3497;
  selfslot = oldselfslot3497;
  stackframe = oldstackframe3497;
  gc_frame_end(frame);
  return obj3497;
}
Object meth_ast_new3496_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 4)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_methodNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_signature_39_ = &(stackframe->slots[1]);
  *var_signature_39_ = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[2]);
  *var_body_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[3]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 4)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[4]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3497 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3497 = alloc_userobj2(36,28, objclass3497);
  gc_frame_newslot(obj3497);
if (objclass3497 == NULL) {
  glfree(obj3497->class->name);
  obj3497->class->name = "obj3489.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3497, self, 0);
  addmethodreal(obj3497,"outer", &reader_ast_outer_3498);
  Object oldself3497 = self;
  struct StackFrameObject *oldstackframe3497 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3497);
  gc_frame_newslot((Object)stackframe);
  self = obj3497;
  Object *oldselfslot3497 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3497 = (*(struct UserObject *)self).data[0], lowerouter3497 = thisouter3497;
  if (inheritingObject3497) {
    struct UserObject *inho3497 = (struct UserObject *)inheritingObject3497;
    while (inho3497->super != GraceDefaultObject) inho3497 = (struct UserObject *)inho3497->super;
    inho3497->super = obj3497;
    self = inheritingObject3497;
    *selfslot = self;
    lowerouter3497 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3497;
  }
if (objclass3497 == NULL) {
  Method *reader3499 = addmethodrealflags(obj3497, "kind",&reader_ast_kind_3499, MFLAG_DEF);
  reader3499->definitionModule = modulename;
  reader3499->definitionLine = 795;
}
adddatum2(obj3497, alloc_Undefined(), 1);
if (objclass3497 == NULL) {
  Method *reader3500 = addmethodrealflags(obj3497, "value",&reader_ast_value_3500, 0);
  Method *writer3500 = addmethodrealflags(obj3497, "value:=",&writer_ast_value_3500, 0);
  reader3500->definitionModule = modulename;
  writer3500->definitionModule = modulename;
  reader3500->definitionLine = 796;
  writer3500->definitionLine = 796;
}
obj3497->flags |= OFLAG_MUTABLE;
adddatum2(obj3497, alloc_Undefined(), 2);
if (objclass3497 == NULL) {
  Method *reader3501 = addmethodrealflags(obj3497, "signature",&reader_ast_signature_3501, 0);
  Method *writer3501 = addmethodrealflags(obj3497, "signature:=",&writer_ast_signature_3501, 0);
  reader3501->definitionModule = modulename;
  writer3501->definitionModule = modulename;
  reader3501->definitionLine = 797;
  writer3501->definitionLine = 797;
}
obj3497->flags |= OFLAG_MUTABLE;
adddatum2(obj3497, alloc_Undefined(), 3);
if (objclass3497 == NULL) {
  Method *reader3502 = addmethodrealflags(obj3497, "body",&reader_ast_body_3502, 0);
  Method *writer3502 = addmethodrealflags(obj3497, "body:=",&writer_ast_body_3502, 0);
  reader3502->definitionModule = modulename;
  writer3502->definitionModule = modulename;
  reader3502->definitionLine = 798;
  writer3502->definitionLine = 798;
}
obj3497->flags |= OFLAG_MUTABLE;
adddatum2(obj3497, alloc_Undefined(), 4);
if (objclass3497 == NULL) {
  Method *reader3503 = addmethodrealflags(obj3497, "dtype",&reader_ast_dtype_3503, 0);
  Method *writer3503 = addmethodrealflags(obj3497, "dtype:=",&writer_ast_dtype_3503, 0);
  reader3503->definitionModule = modulename;
  writer3503->definitionModule = modulename;
  reader3503->definitionLine = 799;
  writer3503->definitionLine = 799;
}
obj3497->flags |= OFLAG_MUTABLE;
adddatum2(obj3497, alloc_Undefined(), 5);
if (objclass3497 == NULL) {
  Method *reader3504 = addmethodrealflags(obj3497, "varargs",&reader_ast_varargs_3504, 0);
  Method *writer3504 = addmethodrealflags(obj3497, "varargs:=",&writer_ast_varargs_3504, 0);
  reader3504->definitionModule = modulename;
  writer3504->definitionModule = modulename;
  reader3504->definitionLine = 800;
  writer3504->definitionLine = 800;
}
obj3497->flags |= OFLAG_MUTABLE;
adddatum2(obj3497, alloc_Undefined(), 6);
if (objclass3497 == NULL) {
  Method *reader3505 = addmethodrealflags(obj3497, "generics",&reader_ast_generics_3505, 0);
  Method *writer3505 = addmethodrealflags(obj3497, "generics:=",&writer_ast_generics_3505, 0);
  reader3505->definitionModule = modulename;
  writer3505->definitionModule = modulename;
  reader3505->definitionLine = 801;
  writer3505->definitionLine = 801;
}
obj3497->flags |= OFLAG_MUTABLE;
adddatum2(obj3497, alloc_Undefined(), 7);
if (objclass3497 == NULL) {
  Method *reader3506 = addmethodrealflags(obj3497, "selfclosure",&reader_ast_selfclosure_3506, 0);
  Method *writer3506 = addmethodrealflags(obj3497, "selfclosure:=",&writer_ast_selfclosure_3506, 0);
  reader3506->definitionModule = modulename;
  writer3506->definitionModule = modulename;
  reader3506->definitionLine = 802;
  writer3506->definitionLine = 802;
}
obj3497->flags |= OFLAG_MUTABLE;
adddatum2(obj3497, alloc_Undefined(), 8);
if (objclass3497 == NULL) {
  Method *reader3507 = addmethodrealflags(obj3497, "nameString",&reader_ast_nameString_3507, MFLAG_DEF);
  reader3507->definitionModule = modulename;
  reader3507->definitionLine = 803;
}
adddatum2(obj3497, alloc_Undefined(), 9);
if (objclass3497 == NULL) {
  Method *reader3508 = addmethodrealflags(obj3497, "annotations",&reader_ast_annotations_3508, 0);
  Method *writer3508 = addmethodrealflags(obj3497, "annotations:=",&writer_ast_annotations_3508, 0);
  reader3508->definitionModule = modulename;
  writer3508->definitionModule = modulename;
  reader3508->definitionLine = 804;
  writer3508->definitionLine = 804;
}
obj3497->flags |= OFLAG_MUTABLE;
adddatum2(obj3497, alloc_Undefined(), 10);
if (objclass3497 == NULL) {
  Method *reader3509 = addmethodrealflags(obj3497, "isFresh",&reader_ast_isFresh_3509, 0);
  Method *writer3509 = addmethodrealflags(obj3497, "isFresh:=",&writer_ast_isFresh_3509, 0);
  reader3509->definitionModule = modulename;
  writer3509->definitionModule = modulename;
  reader3509->definitionLine = 805;
  writer3509->definitionLine = 805;
}
obj3497->flags |= OFLAG_MUTABLE;
adddatum2(obj3497, alloc_Undefined(), 11);
// method scope:=
  struct UserObject *uo3510 = (struct UserObject*)obj3497;
  uo3510->data[12] = emptyclosure;
  Method *meth_meth_ast_scope_58__61_3510 = addmethod2pos(obj3497, "scope:=", &meth_ast_scope_58__61_3510, 12);
  int argcv_meth_ast_scope_58__61_3510[] = {1};
  meth_meth_ast_scope_58__61_3510->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61_3510);
  meth_meth_ast_scope_58__61_3510->definitionModule = modulename;
  meth_meth_ast_scope_58__61_3510->definitionLine = 807;
// method declarationKindWithAncestors
  struct UserObject *uo3515 = (struct UserObject*)obj3497;
  uo3515->data[13] = emptyclosure;
  Method *meth_meth_ast_declarationKindWithAncestors3515 = addmethod2pos(obj3497, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors3515, 13);
  int argcv_meth_ast_declarationKindWithAncestors3515[] = {1};
  meth_meth_ast_declarationKindWithAncestors3515->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors3515);
  meth_meth_ast_declarationKindWithAncestors3515->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors3515->definitionLine = 813;
// method isConfidential
  struct UserObject *uo3517 = (struct UserObject*)obj3497;
  uo3517->data[14] = emptyclosure;
  Method *meth_meth_ast_isConfidential3517 = addmethod2pos(obj3497, "isConfidential", &meth_ast_isConfidential3517, 14);
  int argcv_meth_ast_isConfidential3517[] = {0};
  meth_meth_ast_isConfidential3517->type = alloc_MethodType(1, argcv_meth_ast_isConfidential3517);
  meth_meth_ast_isConfidential3517->definitionModule = modulename;
  meth_meth_ast_isConfidential3517->definitionLine = 816;
// method isPublic
  struct UserObject *uo3535 = (struct UserObject*)obj3497;
  uo3535->data[15] = emptyclosure;
  Method *meth_meth_ast_isPublic3535 = addmethod2pos(obj3497, "isPublic", &meth_ast_isPublic3535, 15);
  int argcv_meth_ast_isPublic3535[] = {0};
  meth_meth_ast_isPublic3535->type = alloc_MethodType(1, argcv_meth_ast_isPublic3535);
  meth_meth_ast_isPublic3535->definitionModule = modulename;
  meth_meth_ast_isPublic3535->definitionLine = 820;
// method isWritable
  struct UserObject *uo3540 = (struct UserObject*)obj3497;
  uo3540->data[16] = emptyclosure;
  Method *meth_meth_ast_isWritable3540 = addmethod2pos(obj3497, "isWritable", &meth_ast_isWritable3540, 16);
  int argcv_meth_ast_isWritable3540[] = {0};
  meth_meth_ast_isWritable3540->type = alloc_MethodType(1, argcv_meth_ast_isWritable3540);
  meth_meth_ast_isWritable3540->definitionModule = modulename;
  meth_meth_ast_isWritable3540->definitionLine = 821;
// method isReadable
  struct UserObject *uo3542 = (struct UserObject*)obj3497;
  uo3542->data[17] = emptyclosure;
  Method *meth_meth_ast_isReadable3542 = addmethod2pos(obj3497, "isReadable", &meth_ast_isReadable3542, 17);
  int argcv_meth_ast_isReadable3542[] = {0};
  meth_meth_ast_isReadable3542->type = alloc_MethodType(1, argcv_meth_ast_isReadable3542);
  meth_meth_ast_isReadable3542->definitionModule = modulename;
  meth_meth_ast_isReadable3542->definitionLine = 822;
// method usesAsType
  struct UserObject *uo3545 = (struct UserObject*)obj3497;
  uo3545->data[18] = emptyclosure;
  Method *meth_meth_ast_usesAsType3545 = addmethod2pos(obj3497, "usesAsType", &meth_ast_usesAsType3545, 18);
  int argcv_meth_ast_usesAsType3545[] = {1};
  meth_meth_ast_usesAsType3545->type = alloc_MethodType(1, argcv_meth_ast_usesAsType3545);
  meth_meth_ast_usesAsType3545->definitionModule = modulename;
  meth_meth_ast_usesAsType3545->definitionLine = 823;
// method returnsObject
  struct UserObject *uo3551 = (struct UserObject*)obj3497;
  uo3551->data[19] = emptyclosure;
  Method *meth_meth_ast_returnsObject3551 = addmethod2pos(obj3497, "returnsObject", &meth_ast_returnsObject3551, 19);
  int argcv_meth_ast_returnsObject3551[] = {0};
  meth_meth_ast_returnsObject3551->type = alloc_MethodType(1, argcv_meth_ast_returnsObject3551);
  meth_meth_ast_returnsObject3551->definitionModule = modulename;
  meth_meth_ast_returnsObject3551->definitionLine = 826;
// method returnedObjectScope
  struct UserObject *uo3569 = (struct UserObject*)obj3497;
  uo3569->data[20] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope3569 = addmethod2pos(obj3497, "returnedObjectScope", &meth_ast_returnedObjectScope3569, 20);
  int argcv_meth_ast_returnedObjectScope3569[] = {0};
  meth_meth_ast_returnedObjectScope3569->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope3569);
  meth_meth_ast_returnedObjectScope3569->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope3569->definitionLine = 829;
// method accept()from
  struct UserObject *uo3576 = (struct UserObject*)obj3497;
  uo3576->data[21] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from3576 = addmethod2pos(obj3497, "accept()from", &meth_ast_accept_40__41_from3576, 21);
  int argcv_meth_ast_accept_40__41_from3576[] = {1, 1};
  meth_meth_ast_accept_40__41_from3576->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from3576);
  meth_meth_ast_accept_40__41_from3576->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from3576->definitionLine = 833;
// method map()ancestors
  struct UserObject *uo3653 = (struct UserObject*)obj3497;
  uo3653->data[22] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors3653 = addmethod2pos(obj3497, "map()ancestors", &meth_ast_map_40__41_ancestors3653, 22);
  int argcv_meth_ast_map_40__41_ancestors3653[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors3653->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors3653);
  meth_meth_ast_map_40__41_ancestors3653->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors3653->definitionLine = 859;
// method pretty
  struct UserObject *uo3710 = (struct UserObject*)obj3497;
  uo3710->data[23] = emptyclosure;
  Method *meth_meth_ast_pretty3710 = addmethod2pos(obj3497, "pretty", &meth_ast_pretty3710, 23);
  int argcv_meth_ast_pretty3710[] = {1};
  meth_meth_ast_pretty3710->type = alloc_MethodType(1, argcv_meth_ast_pretty3710);
  meth_meth_ast_pretty3710->definitionModule = modulename;
  meth_meth_ast_pretty3710->definitionLine = 869;
// method toGrace
  struct UserObject *uo4126 = (struct UserObject*)obj3497;
  uo4126->data[24] = emptyclosure;
  Method *meth_meth_ast_toGrace4126 = addmethod2pos(obj3497, "toGrace", &meth_ast_toGrace4126, 24);
  int argcv_meth_ast_toGrace4126[] = {1};
  meth_meth_ast_toGrace4126->type = alloc_MethodType(1, argcv_meth_ast_toGrace4126);
meth_meth_ast_toGrace4126->type->types[0] = type_Number;
meth_meth_ast_toGrace4126->type->names[0] = "depth";
  meth_meth_ast_toGrace4126->definitionModule = modulename;
  meth_meth_ast_toGrace4126->definitionLine = 917;
// method shallowCopy
  block_savedest(obj3497);
  Object closure4450 = createclosure(1, "shallowCopy");
  setclosureframe(closure4450, stackframe);
  addtoclosure(closure4450, var_methodNode);
  struct UserObject *uo4450 = (struct UserObject*)obj3497;
  uo4450->data[25] = (Object)closure4450;
  Method *meth_meth_ast_shallowCopy4450 = addmethod2pos(obj3497, "shallowCopy", &meth_ast_shallowCopy4450, 25);
  int argcv_meth_ast_shallowCopy4450[] = {0};
  meth_meth_ast_shallowCopy4450->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy4450);
  meth_meth_ast_shallowCopy4450->definitionModule = modulename;
  meth_meth_ast_shallowCopy4450->definitionLine = 967;
// method shallowCopyFieldsFrom
  struct UserObject *uo4463 = (struct UserObject*)obj3497;
  uo4463->data[26] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom4463 = addmethod2pos(obj3497, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom4463, 26);
  int argcv_meth_ast_shallowCopyFieldsFrom4463[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom4463->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom4463);
  meth_meth_ast_shallowCopyFieldsFrom4463->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom4463->definitionLine = 970;
  sourceObject = obj3497;
// Begin line 794
  setline(794);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4474 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_baseNode (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call4475 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe4474);
// compiled call node returning call4475 (depth = 3)
  struct UserObject *obj3497_uo = (struct UserObject *)obj3497;
  obj3497_uo->super = call4475;
  sourceObject = obj3497;
// Begin line 795
  setline(795);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit4476 == NULL) {
    strlit4476 = alloc_String("method");
    gc_root(strlit4476);
  }
// compiled string node returning strlit4476 (depth = 3)
  adddatum2(obj3497, strlit4476, 1);
  sourceObject = obj3497;
// Begin line 796
  setline(796);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj3497, *var_name_39_, 2);
  sourceObject = obj3497;
// Begin line 797
  setline(797);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_signature_39_ (depth = 3)
  adddatum2(obj3497, *var_signature_39_, 3);
  sourceObject = obj3497;
// Begin line 798
  setline(798);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_body_39_ (depth = 3)
  adddatum2(obj3497, *var_body_39_, 4);
  sourceObject = obj3497;
// Begin line 799
  setline(799);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj3497, *var_dtype_39_, 5);
  sourceObject = obj3497;
// Begin line 800
  setline(800);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4477 = alloc_Boolean(0);
// compiled identifier node returning bool4477 (depth = 3)
  adddatum2(obj3497, bool4477, 6);
  sourceObject = obj3497;
// Begin line 801
  setline(801);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4478 = alloc_Boolean(0);
// compiled identifier node returning bool4478 (depth = 3)
  adddatum2(obj3497, bool4478, 7);
  sourceObject = obj3497;
// Begin line 802
  setline(802);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4479 = alloc_Boolean(0);
// compiled identifier node returning bool4479 (depth = 3)
  adddatum2(obj3497, bool4479, 8);
  sourceObject = obj3497;
// Begin line 803
  setline(803);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4480 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4481 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4482 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4481);
// compiled call node returning call4482 (depth = 6)
// compiled member node returning call4482 (depth = 5)
  partcv[0] = 0;
  Object call4483 = callmethod(call4482, "value",
    1, partcv, params);
  gc_frame_end(callframe4480);
// compiled call node returning call4483 (depth = 4)
// compiled member node returning call4483 (depth = 3)
  adddatum2(obj3497, call4483, 9);
  sourceObject = obj3497;
// Begin line 804
  setline(804);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4484 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4485 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4486 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4485);
// compiled call node returning call4486 (depth = 6)
// compiled member node returning call4486 (depth = 5)
  partcv[0] = 0;
  Object call4487 = callmethod(call4486, "empty",
    1, partcv, params);
  gc_frame_end(callframe4484);
// compiled call node returning call4487 (depth = 4)
// compiled member node returning call4487 (depth = 3)
  adddatum2(obj3497, call4487, 10);
  sourceObject = obj3497;
// Begin line 805
  setline(805);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4488 = alloc_Boolean(0);
// compiled identifier node returning bool4488 (depth = 3)
  adddatum2(obj3497, bool4488, 11);
  sourceObject = obj3497;
  sourceObject = obj3497;
  sourceObject = obj3497;
  sourceObject = obj3497;
  sourceObject = obj3497;
  sourceObject = obj3497;
  sourceObject = obj3497;
  sourceObject = obj3497;
  sourceObject = obj3497;
  sourceObject = obj3497;
  sourceObject = obj3497;
  sourceObject = obj3497;
  sourceObject = obj3497;
  sourceObject = obj3497;
  sourceObject = obj3497;
  objclass3497 = obj3497->class;
  objclass3497->definitionModule = modulename;
  objclass3497->definitionLine = 787;
  (*(struct UserObject *)self).data[0] = lowerouter3497;
  self = oldself3497;
  selfslot = oldselfslot3497;
  stackframe = oldstackframe3497;
  gc_frame_end(frame);
  return obj3497;
}
Object meth_ast_methodNode4490(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 23, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "methodNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_methodNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for methodNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹methodNode›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 780
  setline(780);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_methodNode (depth = 3)
  gc_frame_end(frame);
  return *var_methodNode;
}
Object meth_ast_new_40__41_scope4493(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new()scope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method new()scope");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method new()scope");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for new()scope (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_what = &(stackframe->slots[0]);
  *var_what = args[curarg];
  curarg++;
  Object *var_with = &(stackframe->slots[1]);
  *var_with = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for new");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for scope");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "result");
// Begin line 980
  setline(980);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4494 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_what (depth = 5)
  gc_frame_newslot(*var_what);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_with (depth = 5)
  gc_frame_newslot(*var_with);
// call case 4: self request
  params[0] = *var_what;
  params[1] = *var_with;
  partcv[0] = 2;
  Object call4495 = callmethodflags(self, "new", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4494);
// compiled call node returning call4495 (depth = 4)
  *var_result = call4495;
  if (call4495 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 981
  setline(981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 804
  setline(804);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4496 = gc_frame_new();
// Begin line 981
  setline(981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  gc_frame_newslot(*var_s);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call4497 = callmethod(*var_result, "scope:=",
    1, partcv, params);
  gc_frame_end(callframe4496);
// compiled call node returning call4497 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 982
  setline(982);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_target4507(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "target");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for target (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for target");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1010
  setline(1010);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4508 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4509 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4508);
// compiled call node returning call4509 (depth = 4)
// compiled member node returning call4509 (depth = 3)
  gc_frame_end(frame);
  return call4509;
}
Object meth_ast_isCall4510(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isCall");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isCall (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isCall");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1011
  setline(1011);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4511 = alloc_Boolean(1);
// compiled identifier node returning bool4511 (depth = 3)
  gc_frame_end(frame);
  return bool4511;
}
Object meth_ast_returnsObject4512(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnsObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for returnsObject (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for returnsObject");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1013
  setline(1013);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4514 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4515 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4516 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4517 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4516);
// compiled call node returning call4517 (depth = 9)
// compiled member node returning call4517 (depth = 8)
  partcv[0] = 0;
  Object call4518 = callmethod(call4517, "isMember",
    1, partcv, params);
  gc_frame_end(callframe4515);
// compiled call node returning call4518 (depth = 7)
// compiled member node returning call4518 (depth = 6)
  partcv[0] = 0;
  Object call4519 = callmethod(call4518, "not",
    1, partcv, params);
  gc_frame_end(callframe4514);
// compiled call node returning call4519 (depth = 5)
// compiled member node returning call4519 (depth = 4)
  Object if4513 = done;
  if (istrue(call4519)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool4520 = alloc_Boolean(0);
// compiled identifier node returning bool4520 (depth = 5)
  return bool4520;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if4513 = undefined;
  } else {
  }
// compiled if node returning if4513 (depth = 3)
// Begin line 1014
  setline(1014);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4523 == NULL) {
    strlit4523 = alloc_String("clone");
    gc_root(strlit4523);
  }
// compiled string node returning strlit4523 (depth = 5)
  int op_slot_right_4522 = gc_frame_newslot(strlit4523);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4525 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4526 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4527 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4526);
// compiled call node returning call4527 (depth = 8)
// compiled member node returning call4527 (depth = 7)
  partcv[0] = 0;
  Object call4528 = callmethod(call4527, "nameString",
    1, partcv, params);
  gc_frame_end(callframe4525);
// compiled call node returning call4528 (depth = 6)
// compiled member node returning call4528 (depth = 5)
  int op_slot_left_4522 = gc_frame_newslot(call4528);
  params[0] = strlit4523;
  partcv[0] = 1;
  Object opresult4529 = callmethod(call4528, "==", 1, partcv, params);
// compiled op node returning opresult4529 (depth = 4)
  Object if4521 = done;
  if (istrue(opresult4529)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool4530 = alloc_Boolean(1);
// compiled identifier node returning bool4530 (depth = 5)
  return bool4530;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if4521 = undefined;
  } else {
  }
// compiled if node returning if4521 (depth = 3)
// Begin line 1015
  setline(1015);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4533 == NULL) {
    strlit4533 = alloc_String("copy");
    gc_root(strlit4533);
  }
// compiled string node returning strlit4533 (depth = 5)
  int op_slot_right_4532 = gc_frame_newslot(strlit4533);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4535 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4536 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4537 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4536);
// compiled call node returning call4537 (depth = 8)
// compiled member node returning call4537 (depth = 7)
  partcv[0] = 0;
  Object call4538 = callmethod(call4537, "nameString",
    1, partcv, params);
  gc_frame_end(callframe4535);
// compiled call node returning call4538 (depth = 6)
// compiled member node returning call4538 (depth = 5)
  int op_slot_left_4532 = gc_frame_newslot(call4538);
  params[0] = strlit4533;
  partcv[0] = 1;
  Object opresult4539 = callmethod(call4538, "==", 1, partcv, params);
// compiled op node returning opresult4539 (depth = 4)
  Object if4531 = done;
  if (istrue(opresult4539)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool4540 = alloc_Boolean(1);
// compiled identifier node returning bool4540 (depth = 5)
  return bool4540;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if4531 = undefined;
  } else {
  }
// compiled if node returning if4531 (depth = 3)
// Begin line 1016
  setline(1016);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool4541 = alloc_Boolean(0);
// compiled identifier node returning bool4541 (depth = 4)
  return bool4541;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast_returnedObjectScope4542(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnedObjectScope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for returnedObjectScope (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for returnedObjectScope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1020
  setline(1020);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4543 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4544 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4543);
// compiled call node returning call4544 (depth = 4)
// compiled member node returning call4544 (depth = 3)
  gc_frame_end(frame);
  return call4544;
}
Object meth_ast__apply4564(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_arg = &(stackframe->slots[0]);
  *var_arg = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1028
  setline(1028);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4565 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_visitor (depth = 9)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_newChain (depth = 9)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_arg (depth = 9)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4566 = callmethod(*var_arg, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe4565);
// compiled call node returning call4566 (depth = 8)
  gc_frame_end(frame);
  return call4566;
}
Object meth_ast__apply4559(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1027
  setline(1027);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4560 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4561 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  partcv[0] = 0;
  Object call4562 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe4561);
// compiled call node returning call4562 (depth = 8)
// compiled member node returning call4562 (depth = 7)
  gc_frame_newslot(call4562);
// starting to compile block node (depth = 7)
  Object block4563 = alloc_Block(NULL, NULL, "ast", 1027);
  gc_frame_newslot(block4563);
// method _apply
  block_savedest(block4563);
  Object closure4564 = createclosure(3, "_apply");
  setclosureframe(closure4564, stackframe);
  addtoclosure(closure4564, var_visitor);
  addtoclosure(closure4564, var_newChain);
  addtoclosure(closure4564, selfslot);
  struct UserObject *uo4564 = (struct UserObject*)block4563;
  uo4564->data[0] = (Object)closure4564;
  Method *meth_meth_ast__apply4564 = addmethod2pos(block4563, "_apply", &meth_ast__apply4564, 0);
  int argcv_meth_ast__apply4564[] = {1};
  meth_meth_ast__apply4564->type = alloc_MethodType(1, argcv_meth_ast__apply4564);
  meth_meth_ast__apply4564->definitionModule = modulename;
  meth_meth_ast__apply4564->definitionLine = 1027;
// compiled block node returning block4563 (depth = 7)
  gc_frame_newslot(block4563);
// call case 5: prelude request
  params[0] = call4562;
  params[1] = block4563;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4568 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4560);
// compiled call node returning call4568 (depth = 6)
  gc_frame_end(frame);
  return call4568;
}
Object meth_ast__apply4580(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1033
  setline(1033);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4581 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_visitor (depth = 8)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_newChain (depth = 8)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4582 = callmethod(*var_each, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe4581);
// compiled call node returning call4582 (depth = 7)
  gc_frame_end(frame);
  return call4582;
}
Object meth_ast_accept_40__41_from4545(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1023
  setline(1023);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4547 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4548 = callmethod(*var_visitor, "visitCall()up",
    2, partcv, params);
  gc_frame_end(callframe4547);
// compiled call node returning call4548 (depth = 4)
  Object if4546 = done;
  if (istrue(call4548)) {
// Begin line 1024
  setline(1024);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4549 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call4550 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe4549);
// compiled call node returning call4550 (depth = 5)
  *var_newChain = call4550;
  if (call4550 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1025
  setline(1025);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4551 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4552 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4553 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4552);
// compiled call node returning call4553 (depth = 6)
// compiled member node returning call4553 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4554 = callmethod(call4553, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe4551);
// compiled call node returning call4554 (depth = 4)
// Begin line 1026
  setline(1026);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4555 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4556 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4557 = callmethodflags(self, "with", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4556);
// compiled call node returning call4557 (depth = 6)
// compiled member node returning call4557 (depth = 5)
  gc_frame_newslot(call4557);
// starting to compile block node (depth = 5)
  Object block4558 = alloc_Block(NULL, NULL, "ast", 1026);
  gc_frame_newslot(block4558);
// method _apply
  block_savedest(block4558);
  Object closure4559 = createclosure(3, "_apply");
  setclosureframe(closure4559, stackframe);
  addtoclosure(closure4559, var_visitor);
  addtoclosure(closure4559, var_newChain);
  addtoclosure(closure4559, selfslot);
  struct UserObject *uo4559 = (struct UserObject*)block4558;
  uo4559->data[0] = (Object)closure4559;
  Method *meth_meth_ast__apply4559 = addmethod2pos(block4558, "_apply", &meth_ast__apply4559, 0);
  int argcv_meth_ast__apply4559[] = {1};
  meth_meth_ast__apply4559->type = alloc_MethodType(1, argcv_meth_ast__apply4559);
  meth_meth_ast__apply4559->definitionModule = modulename;
  meth_meth_ast__apply4559->definitionLine = 1026;
// compiled block node returning block4558 (depth = 5)
  gc_frame_newslot(block4558);
// call case 5: prelude request
  params[0] = call4557;
  params[1] = block4558;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4570 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4555);
// compiled call node returning call4570 (depth = 4)
// Begin line 1031
  setline(1031);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4573 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4574 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4573);
// compiled call node returning call4574 (depth = 7)
// compiled member node returning call4574 (depth = 6)
  int op_slot_right_4572 = gc_frame_newslot(call4574);
// starting to compile identifier node (depth = 6)
  Object bool4576 = alloc_Boolean(0);
// compiled identifier node returning bool4576 (depth = 6)
  int op_slot_left_4572 = gc_frame_newslot(bool4576);
  params[0] = call4574;
  partcv[0] = 1;
  Object opresult4577 = callmethod(bool4576, "!=", 1, partcv, params);
// compiled op node returning opresult4577 (depth = 5)
  Object if4571 = done;
  if (istrue(opresult4577)) {
// Begin line 1032
  setline(1032);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4578 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block4579 = alloc_Block(NULL, NULL, "ast", 1032);
  gc_frame_newslot(block4579);
// method _apply
  block_savedest(block4579);
  Object closure4580 = createclosure(3, "_apply");
  setclosureframe(closure4580, stackframe);
  addtoclosure(closure4580, var_visitor);
  addtoclosure(closure4580, var_newChain);
  addtoclosure(closure4580, selfslot);
  struct UserObject *uo4580 = (struct UserObject*)block4579;
  uo4580->data[0] = (Object)closure4580;
  Method *meth_meth_ast__apply4580 = addmethod2pos(block4579, "_apply", &meth_ast__apply4580, 0);
  int argcv_meth_ast__apply4580[] = {1};
  meth_meth_ast__apply4580->type = alloc_MethodType(1, argcv_meth_ast__apply4580);
  meth_meth_ast__apply4580->definitionModule = modulename;
  meth_meth_ast__apply4580->definitionLine = 1031;
// compiled block node returning block4579 (depth = 6)
  gc_frame_newslot(block4579);
// call case 6: other member request
// Begin line 1032
  setline(1032);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4584 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4585 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4584);
// compiled call node returning call4585 (depth = 7)
// compiled member node returning call4585 (depth = 6)
  params[0] = block4579;
  partcv[0] = 1;
  Object call4586 = callmethod(call4585, "do",
    1, partcv, params);
  gc_frame_end(callframe4578);
// compiled call node returning call4586 (depth = 5)
    gc_frame_newslot(call4586);
    if4571 = call4586;
  } else {
  }
// compiled if node returning if4571 (depth = 4)
    gc_frame_newslot(if4571);
    if4546 = if4571;
  } else {
  }
// compiled if node returning if4546 (depth = 3)
  gc_frame_end(frame);
  return if4546;
}
Object meth_ast_map_40__41_ancestors4587(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1039
  setline(1039);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4588 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4589 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4588);
// compiled call node returning call4589 (depth = 5)
// compiled member node returning call4589 (depth = 4)
  *var_n = call4589;
  if (call4589 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1040
  setline(1040);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4590 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call4591 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe4590);
// compiled call node returning call4591 (depth = 4)
  *var_newChain = call4591;
  if (call4591 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1041
  setline(1041);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 1039
  setline(1039);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4592 = gc_frame_new();
// Begin line 1041
  setline(1041);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4593 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4594 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4595 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4594);
// compiled call node returning call4595 (depth = 7)
// compiled member node returning call4595 (depth = 6)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4596 = callmethod(call4595, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe4593);
// compiled call node returning call4596 (depth = 5)
  gc_frame_newslot(call4596);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  params[0] = call4596;
  partcv[0] = 1;
  Object call4597 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe4592);
// compiled call node returning call4597 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 1042
  setline(1042);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 1041
  setline(1041);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4598 = gc_frame_new();
// Begin line 1042
  setline(1042);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4599 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4600 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4601 = callmethodflags(self, "with", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4600);
// compiled call node returning call4601 (depth = 7)
// compiled member node returning call4601 (depth = 6)
  gc_frame_newslot(call4601);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4602 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4603 = gc_frame_new();
// call case 3: self.outer request
  Object call4604 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4603);
// compiled call node returning call4604 (depth = 9)
// compiled member node returning call4604 (depth = 8)
  partcv[0] = 0;
  Object call4605 = callmethodflags(call4604, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4602);
// compiled call node returning call4605 (depth = 7)
// compiled member node returning call4605 (depth = 6)
  params[0] = call4601;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call4606 = callmethodflags(call4605, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4599);
// compiled call node returning call4606 (depth = 5)
  gc_frame_newslot(call4606);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  params[0] = call4606;
  partcv[0] = 1;
  Object call4607 = callmethod(*var_n, "with:=",
    1, partcv, params);
  gc_frame_end(callframe4598);
// compiled call node returning call4607 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 1043
  setline(1043);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 1042
  setline(1042);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4608 = gc_frame_new();
// Begin line 1043
  setline(1043);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4609 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4610 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4611 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4610);
// compiled call node returning call4611 (depth = 7)
// compiled member node returning call4611 (depth = 6)
  gc_frame_newslot(call4611);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4612 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4613 = gc_frame_new();
// call case 3: self.outer request
  Object call4614 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4613);
// compiled call node returning call4614 (depth = 9)
// compiled member node returning call4614 (depth = 8)
  partcv[0] = 0;
  Object call4615 = callmethodflags(call4614, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4612);
// compiled call node returning call4615 (depth = 7)
// compiled member node returning call4615 (depth = 6)
  params[0] = call4611;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call4616 = callmethodflags(call4615, "maybeListMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4609);
// compiled call node returning call4616 (depth = 5)
  gc_frame_newslot(call4616);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  params[0] = call4616;
  partcv[0] = 1;
  Object call4617 = callmethod(*var_n, "generics:=",
    1, partcv, params);
  gc_frame_end(callframe4608);
// compiled call node returning call4617 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 1044
  setline(1044);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4618 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call4619 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe4618);
// compiled call node returning call4619 (depth = 3)
  gc_frame_end(frame);
  return call4619;
}
Object meth_ast__apply4628(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1049
  setline(1049);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4630 == NULL) {
    strlit4630 = alloc_String("  ");
    gc_root(strlit4630);
  }
// compiled string node returning strlit4630 (depth = 7)
  int op_slot_right_4629 = gc_frame_newslot(strlit4630);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_4629 = gc_frame_newslot(*var_spc);
  params[0] = strlit4630;
  partcv[0] = 1;
  Object opresult4632 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult4632 (depth = 6)
  *var_spc = opresult4632;
  if (opresult4632 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4689(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_g = &(stackframe->slots[0]);
  *var_g = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1057
  setline(1057);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4691 == NULL) {
    strlit4691 = alloc_String("""\x0a""");
    gc_root(strlit4691);
  }
// compiled string node returning strlit4691 (depth = 8)
  int op_slot_right_4690 = gc_frame_newslot(strlit4691);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4694 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num4696 = alloc_Float64(2);
// compiled num node returning num4696 (depth = 11)
  int op_slot_right_4695 = gc_frame_newslot(num4696);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_4695 = gc_frame_newslot(*var_depth);
  params[0] = num4696;
  partcv[0] = 1;
  Object sum4698 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum4698 (depth = 10)
  gc_frame_newslot(sum4698);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_g (depth = 10)
  params[0] = sum4698;
  partcv[0] = 1;
  Object call4699 = callmethod(*var_g, "pretty",
    1, partcv, params);
  gc_frame_end(callframe4694);
// compiled call node returning call4699 (depth = 9)
  int op_slot_right_4693 = gc_frame_newslot(call4699);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit4702 == NULL) {
    strlit4702 = alloc_String("    ");
    gc_root(strlit4702);
  }
// compiled string node returning strlit4702 (depth = 10)
  int op_slot_right_4701 = gc_frame_newslot(strlit4702);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_4704 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_4704 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4706 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4706 (depth = 10)
  int op_slot_left_4701 = gc_frame_newslot(opresult4706);
  params[0] = strlit4702;
  partcv[0] = 1;
  Object opresult4707 = callmethod(opresult4706, "++", 1, partcv, params);
// compiled op node returning opresult4707 (depth = 9)
  int op_slot_left_4693 = gc_frame_newslot(opresult4707);
  params[0] = call4699;
  partcv[0] = 1;
  Object opresult4708 = callmethod(opresult4707, "++", 1, partcv, params);
// compiled op node returning opresult4708 (depth = 8)
  int op_slot_left_4690 = gc_frame_newslot(opresult4708);
  params[0] = strlit4691;
  partcv[0] = 1;
  Object opresult4709 = callmethod(opresult4708, "++", 1, partcv, params);
// compiled op node returning opresult4709 (depth = 7)
  *var_s = opresult4709;
  if (opresult4709 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4747(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_arg = &(stackframe->slots[0]);
  *var_arg = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1064
  setline(1064);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4749 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num4751 = alloc_Float64(2);
// compiled num node returning num4751 (depth = 11)
  int op_slot_right_4750 = gc_frame_newslot(num4751);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_4750 = gc_frame_newslot(*var_depth);
  params[0] = num4751;
  partcv[0] = 1;
  Object sum4753 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum4753 (depth = 10)
  gc_frame_newslot(sum4753);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_arg (depth = 10)
  params[0] = sum4753;
  partcv[0] = 1;
  Object call4754 = callmethod(*var_arg, "pretty",
    1, partcv, params);
  gc_frame_end(callframe4749);
// compiled call node returning call4754 (depth = 9)
  int op_slot_right_4748 = gc_frame_newslot(call4754);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_4756 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit4759 == NULL) {
    strlit4759 = alloc_String("""\x0a""      ");
    gc_root(strlit4759);
  }
// compiled string node returning strlit4759 (depth = 11)
  int op_slot_right_4758 = gc_frame_newslot(strlit4759);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_4758 = gc_frame_newslot(*var_s);
  params[0] = strlit4759;
  partcv[0] = 1;
  Object opresult4761 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4761 (depth = 10)
  int op_slot_left_4756 = gc_frame_newslot(opresult4761);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4762 = callmethod(opresult4761, "++", 1, partcv, params);
// compiled op node returning opresult4762 (depth = 9)
  int op_slot_left_4748 = gc_frame_newslot(opresult4762);
  params[0] = call4754;
  partcv[0] = 1;
  Object opresult4763 = callmethod(opresult4762, "++", 1, partcv, params);
// compiled op node returning opresult4763 (depth = 8)
  *var_s = opresult4763;
  if (opresult4763 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4725(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object *var_depth = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1062
  setline(1062);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4727 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  partcv[0] = 0;
  Object call4728 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe4727);
// compiled call node returning call4728 (depth = 8)
// compiled member node returning call4728 (depth = 7)
  int op_slot_right_4726 = gc_frame_newslot(call4728);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4731 == NULL) {
    strlit4731 = alloc_String("Part: ");
    gc_root(strlit4731);
  }
// compiled string node returning strlit4731 (depth = 8)
  int op_slot_right_4730 = gc_frame_newslot(strlit4731);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_4733 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit4736 == NULL) {
    strlit4736 = alloc_String("""\x0a""  ");
    gc_root(strlit4736);
  }
// compiled string node returning strlit4736 (depth = 10)
  int op_slot_right_4735 = gc_frame_newslot(strlit4736);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_4735 = gc_frame_newslot(*var_s);
  params[0] = strlit4736;
  partcv[0] = 1;
  Object opresult4738 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4738 (depth = 9)
  int op_slot_left_4733 = gc_frame_newslot(opresult4738);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4739 = callmethod(opresult4738, "++", 1, partcv, params);
// compiled op node returning opresult4739 (depth = 8)
  int op_slot_left_4730 = gc_frame_newslot(opresult4739);
  params[0] = strlit4731;
  partcv[0] = 1;
  Object opresult4740 = callmethod(opresult4739, "++", 1, partcv, params);
// compiled op node returning opresult4740 (depth = 7)
  int op_slot_left_4726 = gc_frame_newslot(opresult4740);
  params[0] = call4728;
  partcv[0] = 1;
  Object opresult4741 = callmethod(opresult4740, "++", 1, partcv, params);
// compiled op node returning opresult4741 (depth = 6)
  *var_s = opresult4741;
  if (opresult4741 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1063
  setline(1063);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4743 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4744 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  partcv[0] = 0;
  Object call4745 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe4744);
// compiled call node returning call4745 (depth = 7)
// compiled member node returning call4745 (depth = 6)
  gc_frame_newslot(call4745);
// starting to compile block node (depth = 6)
  Object block4746 = alloc_Block(NULL, NULL, "ast", 1063);
  gc_frame_newslot(block4746);
// method _apply
  block_savedest(block4746);
  Object closure4747 = createclosure(4, "_apply");
  setclosureframe(closure4747, stackframe);
  addtoclosure(closure4747, var_depth);
  addtoclosure(closure4747, var_spc);
  addtoclosure(closure4747, var_s);
  addtoclosure(closure4747, selfslot);
  struct UserObject *uo4747 = (struct UserObject*)block4746;
  uo4747->data[0] = (Object)closure4747;
  Method *meth_meth_ast__apply4747 = addmethod2pos(block4746, "_apply", &meth_ast__apply4747, 0);
  int argcv_meth_ast__apply4747[] = {1};
  meth_meth_ast__apply4747->type = alloc_MethodType(1, argcv_meth_ast__apply4747);
  meth_meth_ast__apply4747->definitionModule = modulename;
  meth_meth_ast__apply4747->definitionLine = 1063;
// compiled block node returning block4746 (depth = 6)
  gc_frame_newslot(block4746);
// call case 5: prelude request
  params[0] = call4745;
  params[1] = block4746;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4766 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4743);
// compiled call node returning call4766 (depth = 5)
  gc_frame_end(frame);
  return call4766;
}
Object meth_ast_pretty4620(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1047
  setline(1047);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit4621 == NULL) {
    strlit4621 = alloc_String("");
    gc_root(strlit4621);
  }
// compiled string node returning strlit4621 (depth = 4)
  *var_spc = strlit4621;
  if (strlit4621 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1048
  setline(1048);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4622 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_4623 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num4625 = alloc_Float64(0);
// compiled num node returning num4625 (depth = 5)
  int op_slot_left_4623 = gc_frame_newslot(num4625);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult4626 = callmethod(num4625, "..", 1, partcv, params);
// compiled op node returning opresult4626 (depth = 4)
  gc_frame_newslot(opresult4626);
// starting to compile block node (depth = 4)
  Object block4627 = alloc_Block(NULL, NULL, "ast", 1048);
  gc_frame_newslot(block4627);
// method _apply
  block_savedest(block4627);
  Object closure4628 = createclosure(2, "_apply");
  setclosureframe(closure4628, stackframe);
  addtoclosure(closure4628, var_spc);
  addtoclosure(closure4628, selfslot);
  struct UserObject *uo4628 = (struct UserObject*)block4627;
  uo4628->data[0] = (Object)closure4628;
  Method *meth_meth_ast__apply4628 = addmethod2pos(block4627, "_apply", &meth_ast__apply4628, 0);
  int argcv_meth_ast__apply4628[] = {1};
  meth_meth_ast__apply4628->type = alloc_MethodType(1, argcv_meth_ast__apply4628);
  meth_meth_ast__apply4628->definitionModule = modulename;
  meth_meth_ast__apply4628->definitionLine = 1043;
// compiled block node returning block4627 (depth = 4)
  gc_frame_newslot(block4627);
// call case 5: prelude request
  params[0] = opresult4626;
  params[1] = block4627;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4635 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4622);
// compiled call node returning call4635 (depth = 3)
// Begin line 1051
  setline(1051);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4637 == NULL) {
    strlit4637 = alloc_String("""\x0a""");
    gc_root(strlit4637);
  }
// compiled string node returning strlit4637 (depth = 5)
  int op_slot_right_4636 = gc_frame_newslot(strlit4637);
// starting to compile call node (depth = 5)
  int callframe4639 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call4640 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe4639);
// compiled call node returning call4640 (depth = 5)
  int op_slot_left_4636 = gc_frame_newslot(call4640);
  params[0] = strlit4637;
  partcv[0] = 1;
  Object opresult4641 = callmethod(call4640, "++", 1, partcv, params);
// compiled op node returning opresult4641 (depth = 4)
  *var_s = opresult4641;
  if (opresult4641 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1052
  setline(1052);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4644 == NULL) {
    strlit4644 = alloc_String("");
    gc_root(strlit4644);
  }
// compiled string node returning strlit4644 (depth = 6)
  int op_slot_right_4643 = gc_frame_newslot(strlit4644);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4647 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num4649 = alloc_Float64(1);
// compiled num node returning num4649 (depth = 9)
  int op_slot_right_4648 = gc_frame_newslot(num4649);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_4648 = gc_frame_newslot(*var_depth);
  params[0] = num4649;
  partcv[0] = 1;
  Object sum4651 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum4651 (depth = 8)
  gc_frame_newslot(sum4651);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4652 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4653 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4652);
// compiled call node returning call4653 (depth = 9)
// compiled member node returning call4653 (depth = 8)
  params[0] = sum4651;
  partcv[0] = 1;
  Object call4654 = callmethod(call4653, "pretty",
    1, partcv, params);
  gc_frame_end(callframe4647);
// compiled call node returning call4654 (depth = 7)
  int op_slot_right_4646 = gc_frame_newslot(call4654);
// starting to compile string node (depth = 7)
  if (strlit4656 == NULL) {
    strlit4656 = alloc_String("Method Name: ");
    gc_root(strlit4656);
  }
// compiled string node returning strlit4656 (depth = 7)
  int op_slot_left_4646 = gc_frame_newslot(strlit4656);
  params[0] = call4654;
  partcv[0] = 1;
  Object opresult4657 = callmethod(strlit4656, "++", 1, partcv, params);
// compiled op node returning opresult4657 (depth = 6)
  int op_slot_left_4643 = gc_frame_newslot(opresult4657);
  params[0] = strlit4644;
  partcv[0] = 1;
  Object opresult4658 = callmethod(opresult4657, "++", 1, partcv, params);
// compiled op node returning opresult4658 (depth = 5)
  int op_slot_right_4642 = gc_frame_newslot(opresult4658);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_4660 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4660 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4662 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4662 (depth = 5)
  int op_slot_left_4642 = gc_frame_newslot(opresult4662);
  params[0] = opresult4658;
  partcv[0] = 1;
  Object opresult4663 = callmethod(opresult4662, "++", 1, partcv, params);
// compiled op node returning opresult4663 (depth = 4)
  *var_s = opresult4663;
  if (opresult4663 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1053
  setline(1053);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4666 == NULL) {
    strlit4666 = alloc_String("""\x0a""");
    gc_root(strlit4666);
  }
// compiled string node returning strlit4666 (depth = 5)
  int op_slot_right_4665 = gc_frame_newslot(strlit4666);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_4665 = gc_frame_newslot(*var_s);
  params[0] = strlit4666;
  partcv[0] = 1;
  Object opresult4668 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4668 (depth = 4)
  *var_s = opresult4668;
  if (opresult4668 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1054
  setline(1054);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4672 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4673 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4672);
// compiled call node returning call4673 (depth = 6)
// compiled member node returning call4673 (depth = 5)
  int op_slot_right_4671 = gc_frame_newslot(call4673);
// starting to compile identifier node (depth = 5)
  Object bool4675 = alloc_Boolean(0);
// compiled identifier node returning bool4675 (depth = 5)
  int op_slot_left_4671 = gc_frame_newslot(bool4675);
  params[0] = call4673;
  partcv[0] = 1;
  Object opresult4676 = callmethod(bool4675, "!=", 1, partcv, params);
// compiled op node returning opresult4676 (depth = 4)
  Object if4670 = done;
  if (istrue(opresult4676)) {
// Begin line 1055
  setline(1055);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4678 == NULL) {
    strlit4678 = alloc_String("  Generics:""\x0a""");
    gc_root(strlit4678);
  }
// compiled string node returning strlit4678 (depth = 6)
  int op_slot_right_4677 = gc_frame_newslot(strlit4678);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_4680 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_4680 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4682 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4682 (depth = 6)
  int op_slot_left_4677 = gc_frame_newslot(opresult4682);
  params[0] = strlit4678;
  partcv[0] = 1;
  Object opresult4683 = callmethod(opresult4682, "++", 1, partcv, params);
// compiled op node returning opresult4683 (depth = 5)
  *var_s = opresult4683;
  if (opresult4683 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1056
  setline(1056);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4685 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4686 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4687 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4686);
// compiled call node returning call4687 (depth = 6)
// compiled member node returning call4687 (depth = 5)
  gc_frame_newslot(call4687);
// starting to compile block node (depth = 5)
  Object block4688 = alloc_Block(NULL, NULL, "ast", 1056);
  gc_frame_newslot(block4688);
// method _apply
  block_savedest(block4688);
  Object closure4689 = createclosure(4, "_apply");
  setclosureframe(closure4689, stackframe);
  addtoclosure(closure4689, var_depth);
  addtoclosure(closure4689, var_spc);
  addtoclosure(closure4689, var_s);
  addtoclosure(closure4689, selfslot);
  struct UserObject *uo4689 = (struct UserObject*)block4688;
  uo4689->data[0] = (Object)closure4689;
  Method *meth_meth_ast__apply4689 = addmethod2pos(block4688, "_apply", &meth_ast__apply4689, 0);
  int argcv_meth_ast__apply4689[] = {1};
  meth_meth_ast__apply4689->type = alloc_MethodType(1, argcv_meth_ast__apply4689);
  meth_meth_ast__apply4689->definitionModule = modulename;
  meth_meth_ast__apply4689->definitionLine = 1056;
// compiled block node returning block4688 (depth = 5)
  gc_frame_newslot(block4688);
// call case 5: prelude request
  params[0] = call4687;
  params[1] = block4688;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4712 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4685);
// compiled call node returning call4712 (depth = 4)
    gc_frame_newslot(call4712);
    if4670 = call4712;
  } else {
  }
// compiled if node returning if4670 (depth = 3)
// Begin line 1060
  setline(1060);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4714 == NULL) {
    strlit4714 = alloc_String("Arguments:");
    gc_root(strlit4714);
  }
// compiled string node returning strlit4714 (depth = 5)
  int op_slot_right_4713 = gc_frame_newslot(strlit4714);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_4716 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4716 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4718 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4718 (depth = 5)
  int op_slot_left_4713 = gc_frame_newslot(opresult4718);
  params[0] = strlit4714;
  partcv[0] = 1;
  Object opresult4719 = callmethod(opresult4718, "++", 1, partcv, params);
// compiled op node returning opresult4719 (depth = 4)
  *var_s = opresult4719;
  if (opresult4719 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1061
  setline(1061);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4721 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4722 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4723 = callmethodflags(self, "with", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4722);
// compiled call node returning call4723 (depth = 5)
// compiled member node returning call4723 (depth = 4)
  gc_frame_newslot(call4723);
// starting to compile block node (depth = 4)
  Object block4724 = alloc_Block(NULL, NULL, "ast", 1061);
  gc_frame_newslot(block4724);
// method _apply
  block_savedest(block4724);
  Object closure4725 = createclosure(4, "_apply");
  setclosureframe(closure4725, stackframe);
  addtoclosure(closure4725, var_spc);
  addtoclosure(closure4725, var_s);
  addtoclosure(closure4725, var_depth);
  addtoclosure(closure4725, selfslot);
  struct UserObject *uo4725 = (struct UserObject*)block4724;
  uo4725->data[0] = (Object)closure4725;
  Method *meth_meth_ast__apply4725 = addmethod2pos(block4724, "_apply", &meth_ast__apply4725, 0);
  int argcv_meth_ast__apply4725[] = {1};
  meth_meth_ast__apply4725->type = alloc_MethodType(1, argcv_meth_ast__apply4725);
  meth_meth_ast__apply4725->definitionModule = modulename;
  meth_meth_ast__apply4725->definitionLine = 1061;
// compiled block node returning block4724 (depth = 4)
  gc_frame_newslot(block4724);
// call case 5: prelude request
  params[0] = call4723;
  params[1] = block4724;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4768 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4721);
// compiled call node returning call4768 (depth = 3)
// Begin line 1067
  setline(1067);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply4773(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// Begin line 1072
  setline(1072);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4775 == NULL) {
    strlit4775 = alloc_String("    ");
    gc_root(strlit4775);
  }
// compiled string node returning strlit4775 (depth = 7)
  int op_slot_right_4774 = gc_frame_newslot(strlit4775);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_4774 = gc_frame_newslot(*var_spc);
  params[0] = strlit4775;
  partcv[0] = 1;
  Object opresult4777 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult4777 (depth = 6)
  *var_spc = opresult4777;
  if (opresult4777 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4870(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
  Object bool4872 = alloc_Boolean(0);
// compiled identifier node returning bool4872 (depth = 9)
  int op_slot_right_4871 = gc_frame_newslot(bool4872);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4874 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4875 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4874);
// compiled call node returning call4875 (depth = 10)
// compiled member node returning call4875 (depth = 9)
  int op_slot_left_4871 = gc_frame_newslot(call4875);
  params[0] = bool4872;
  partcv[0] = 1;
  Object opresult4876 = callmethod(call4875, "!=", 1, partcv, params);
// compiled op node returning opresult4876 (depth = 8)
  gc_frame_end(frame);
  return opresult4876;
}
Object meth_ast__apply4898(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1094
  setline(1094);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4900 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num4902 = alloc_Float64(1);
// compiled num node returning num4902 (depth = 12)
  int op_slot_right_4901 = gc_frame_newslot(num4902);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_depth (depth = 12)
  int op_slot_left_4901 = gc_frame_newslot(*var_depth);
  params[0] = num4902;
  partcv[0] = 1;
  Object sum4904 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum4904 (depth = 11)
  gc_frame_newslot(sum4904);
// call case 6: other member request
// starting to compile call node (depth = 11)
  int callframe4905 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_ix (depth = 12)
  gc_frame_newslot(*var_ix);
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe4906 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4907 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4906);
// compiled call node returning call4907 (depth = 13)
// compiled member node returning call4907 (depth = 12)
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call4908 = callmethod(call4907, "at",
    1, partcv, params);
  gc_frame_end(callframe4905);
// compiled call node returning call4908 (depth = 11)
  params[0] = sum4904;
  partcv[0] = 1;
  Object call4909 = callmethod(call4908, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4900);
// compiled call node returning call4909 (depth = 10)
  int op_slot_right_4899 = gc_frame_newslot(call4909);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_4899 = gc_frame_newslot(*var_s);
  params[0] = call4909;
  partcv[0] = 1;
  Object opresult4911 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4911 (depth = 9)
  *var_s = opresult4911;
  if (opresult4911 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4955(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_part = getfromclosure(closure, 0);
  Object *var_depth = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_anr = &(stackframe->slots[0]);
  *var_anr = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_arg = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "arg");
// Begin line 1102
  setline(1102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// Begin line 1103
  setline(1103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile index node (depth = 9)
// Begin line 1102
  setline(1102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe4956 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_part (depth = 12)
  partcv[0] = 0;
  Object call4957 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe4956);
// compiled call node returning call4957 (depth = 11)
// compiled member node returning call4957 (depth = 10)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_anr (depth = 10)
  params[0] = *var_anr;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres4958 = callmethod(call4957, "[]", 1, partcv, params);
// compiled index node returning idxres4958 (depth = 9)
  *var_arg = idxres4958;
  if (idxres4958 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 1103
  setline(1103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4960 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num4962 = alloc_Float64(1);
// compiled num node returning num4962 (depth = 12)
  int op_slot_right_4961 = gc_frame_newslot(num4962);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_depth (depth = 12)
  int op_slot_left_4961 = gc_frame_newslot(*var_depth);
  params[0] = num4962;
  partcv[0] = 1;
  Object sum4964 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum4964 (depth = 11)
  gc_frame_newslot(sum4964);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_arg (depth = 11)
  params[0] = sum4964;
  partcv[0] = 1;
  Object call4965 = callmethod(*var_arg, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4960);
// compiled call node returning call4965 (depth = 10)
  int op_slot_right_4959 = gc_frame_newslot(call4965);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_4959 = gc_frame_newslot(*var_s);
  params[0] = call4965;
  partcv[0] = 1;
  Object opresult4967 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4967 (depth = 9)
  *var_s = opresult4967;
  if (opresult4967 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 1104
  setline(1104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe4971 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe4972 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_part (depth = 14)
  partcv[0] = 0;
  Object call4973 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe4972);
// compiled call node returning call4973 (depth = 13)
// compiled member node returning call4973 (depth = 12)
  partcv[0] = 0;
  Object call4974 = callmethod(call4973, "size",
    1, partcv, params);
  gc_frame_end(callframe4971);
// compiled call node returning call4974 (depth = 11)
// compiled member node returning call4974 (depth = 10)
  int op_slot_right_4970 = gc_frame_newslot(call4974);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_anr (depth = 10)
  int op_slot_left_4970 = gc_frame_newslot(*var_anr);
  params[0] = call4974;
  partcv[0] = 1;
  Object opresult4976 = callmethod(*var_anr, "<", 1, partcv, params);
// compiled op node returning opresult4976 (depth = 9)
  Object if4969 = done;
  if (istrue(opresult4976)) {
// Begin line 1105
  setline(1105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit4978 == NULL) {
    strlit4978 = alloc_String(", ");
    gc_root(strlit4978);
  }
// compiled string node returning strlit4978 (depth = 11)
  int op_slot_right_4977 = gc_frame_newslot(strlit4978);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_4977 = gc_frame_newslot(*var_s);
  params[0] = strlit4978;
  partcv[0] = 1;
  Object opresult4980 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4980 (depth = 10)
  *var_s = opresult4980;
  if (opresult4980 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if4969 = done;
  } else {
  }
// compiled if node returning if4969 (depth = 8)
  gc_frame_end(frame);
  return if4969;
}
Object meth_ast__apply4860(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_s = getfromclosure(closure, 0);
  Object *var_firstPart = getfromclosure(closure, 1);
  Object *var_depth = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1090
  setline(1090);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4862 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  partcv[0] = 0;
  Object call4863 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe4862);
// compiled call node returning call4863 (depth = 8)
// compiled member node returning call4863 (depth = 7)
  int op_slot_right_4861 = gc_frame_newslot(call4863);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_4861 = gc_frame_newslot(*var_s);
  params[0] = call4863;
  partcv[0] = 1;
  Object opresult4865 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4865 (depth = 6)
  *var_s = opresult4865;
  if (opresult4865 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1091
  setline(1091);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4868 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block4869 = alloc_Block(NULL, NULL, "ast", 1091);
  gc_frame_newslot(block4869);
// method _apply
  block_savedest(block4869);
  Object closure4870 = createclosure(1, "_apply");
  setclosureframe(closure4870, stackframe);
  addtoclosure(closure4870, selfslot);
  struct UserObject *uo4870 = (struct UserObject*)block4869;
  uo4870->data[0] = (Object)closure4870;
  Method *meth_meth_ast__apply4870 = addmethod2pos(block4869, "_apply", &meth_ast__apply4870, 0);
  int argcv_meth_ast__apply4870[] = {0};
  meth_meth_ast__apply4870->type = alloc_MethodType(1, argcv_meth_ast__apply4870);
  meth_meth_ast__apply4870->definitionModule = modulename;
  meth_meth_ast__apply4870->definitionLine = 1090;
// compiled block node returning block4869 (depth = 7)
  gc_frame_newslot(block4869);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_firstPart (depth = 7)
  params[0] = block4869;
  partcv[0] = 1;
  Object call4878 = callmethod(*var_firstPart, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe4868);
// compiled call node returning call4878 (depth = 6)
  Object if4867 = done;
  if (istrue(call4878)) {
// Begin line 1092
  setline(1092);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4880 == NULL) {
    strlit4880 = alloc_String("<");
    gc_root(strlit4880);
  }
// compiled string node returning strlit4880 (depth = 8)
  int op_slot_right_4879 = gc_frame_newslot(strlit4880);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_4879 = gc_frame_newslot(*var_s);
  params[0] = strlit4880;
  partcv[0] = 1;
  Object opresult4882 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4882 (depth = 7)
  *var_s = opresult4882;
  if (opresult4882 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1093
  setline(1093);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4884 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num4887 = alloc_Float64(1);
// compiled num node returning num4887 (depth = 9)
  int op_slot_right_4886 = gc_frame_newslot(num4887);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4889 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe4890 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4891 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4890);
// compiled call node returning call4891 (depth = 12)
// compiled member node returning call4891 (depth = 11)
  partcv[0] = 0;
  Object call4892 = callmethod(call4891, "size",
    1, partcv, params);
  gc_frame_end(callframe4889);
// compiled call node returning call4892 (depth = 10)
// compiled member node returning call4892 (depth = 9)
  int op_slot_left_4886 = gc_frame_newslot(call4892);
  params[0] = num4887;
  partcv[0] = 1;
  Object diff4893 = callmethod(call4892, "-", 1, partcv, params);
// compiled op node returning diff4893 (depth = 8)
  int op_slot_right_4885 = gc_frame_newslot(diff4893);
// starting to compile num node (depth = 8)
  Object num4895 = alloc_Float64(1);
// compiled num node returning num4895 (depth = 8)
  int op_slot_left_4885 = gc_frame_newslot(num4895);
  params[0] = diff4893;
  partcv[0] = 1;
  Object opresult4896 = callmethod(num4895, "..", 1, partcv, params);
// compiled op node returning opresult4896 (depth = 7)
  gc_frame_newslot(opresult4896);
// starting to compile block node (depth = 7)
  Object block4897 = alloc_Block(NULL, NULL, "ast", 1093);
  gc_frame_newslot(block4897);
// method _apply
  block_savedest(block4897);
  Object closure4898 = createclosure(3, "_apply");
  setclosureframe(closure4898, stackframe);
  addtoclosure(closure4898, var_depth);
  addtoclosure(closure4898, var_s);
  addtoclosure(closure4898, selfslot);
  struct UserObject *uo4898 = (struct UserObject*)block4897;
  uo4898->data[0] = (Object)closure4898;
  Method *meth_meth_ast__apply4898 = addmethod2pos(block4897, "_apply", &meth_ast__apply4898, 0);
  int argcv_meth_ast__apply4898[] = {1};
  meth_meth_ast__apply4898->type = alloc_MethodType(1, argcv_meth_ast__apply4898);
  meth_meth_ast__apply4898->definitionModule = modulename;
  meth_meth_ast__apply4898->definitionLine = 1093;
// compiled block node returning block4897 (depth = 7)
  gc_frame_newslot(block4897);
// call case 5: prelude request
  params[0] = opresult4896;
  params[1] = block4897;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4914 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4884);
// compiled call node returning call4914 (depth = 6)
// Begin line 1096
  setline(1096);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4916 == NULL) {
    strlit4916 = alloc_String(">");
    gc_root(strlit4916);
  }
// compiled string node returning strlit4916 (depth = 8)
  int op_slot_right_4915 = gc_frame_newslot(strlit4916);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4919 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num4921 = alloc_Float64(1);
// compiled num node returning num4921 (depth = 11)
  int op_slot_right_4920 = gc_frame_newslot(num4921);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_4920 = gc_frame_newslot(*var_depth);
  params[0] = num4921;
  partcv[0] = 1;
  Object sum4923 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum4923 (depth = 10)
  gc_frame_newslot(sum4923);
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe4924 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe4925 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4926 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4925);
// compiled call node returning call4926 (depth = 13)
// compiled member node returning call4926 (depth = 12)
  partcv[0] = 0;
  Object call4927 = callmethod(call4926, "last",
    1, partcv, params);
  gc_frame_end(callframe4924);
// compiled call node returning call4927 (depth = 11)
// compiled member node returning call4927 (depth = 10)
  params[0] = sum4923;
  partcv[0] = 1;
  Object call4928 = callmethod(call4927, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4919);
// compiled call node returning call4928 (depth = 9)
  int op_slot_right_4918 = gc_frame_newslot(call4928);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_4918 = gc_frame_newslot(*var_s);
  params[0] = call4928;
  partcv[0] = 1;
  Object opresult4930 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4930 (depth = 8)
  int op_slot_left_4915 = gc_frame_newslot(opresult4930);
  params[0] = strlit4916;
  partcv[0] = 1;
  Object opresult4931 = callmethod(opresult4930, "++", 1, partcv, params);
// compiled op node returning opresult4931 (depth = 7)
  *var_s = opresult4931;
  if (opresult4931 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if4867 = done;
  } else {
  }
// compiled if node returning if4867 (depth = 5)
// Begin line 1098
  setline(1098);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool4933 = alloc_Boolean(0);
// compiled identifier node returning bool4933 (depth = 6)
  *var_firstPart = bool4933;
  if (bool4933 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1099
  setline(1099);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num4937 = alloc_Float64(0);
// compiled num node returning num4937 (depth = 7)
  int op_slot_right_4936 = gc_frame_newslot(num4937);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4939 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4940 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_part (depth = 11)
  partcv[0] = 0;
  Object call4941 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe4940);
// compiled call node returning call4941 (depth = 10)
// compiled member node returning call4941 (depth = 9)
  partcv[0] = 0;
  Object call4942 = callmethod(call4941, "size",
    1, partcv, params);
  gc_frame_end(callframe4939);
// compiled call node returning call4942 (depth = 8)
// compiled member node returning call4942 (depth = 7)
  int op_slot_left_4936 = gc_frame_newslot(call4942);
  params[0] = num4937;
  partcv[0] = 1;
  Object opresult4943 = callmethod(call4942, ">", 1, partcv, params);
// compiled op node returning opresult4943 (depth = 6)
  Object if4935 = done;
  if (istrue(opresult4943)) {
// Begin line 1100
  setline(1100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4945 == NULL) {
    strlit4945 = alloc_String("(");
    gc_root(strlit4945);
  }
// compiled string node returning strlit4945 (depth = 8)
  int op_slot_right_4944 = gc_frame_newslot(strlit4945);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_4944 = gc_frame_newslot(*var_s);
  params[0] = strlit4945;
  partcv[0] = 1;
  Object opresult4947 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4947 (depth = 7)
  *var_s = opresult4947;
  if (opresult4947 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1101
  setline(1101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4949 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4950 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4951 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_part (depth = 11)
  partcv[0] = 0;
  Object call4952 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe4951);
// compiled call node returning call4952 (depth = 10)
// compiled member node returning call4952 (depth = 9)
  partcv[0] = 0;
  Object call4953 = callmethod(call4952, "indices",
    1, partcv, params);
  gc_frame_end(callframe4950);
// compiled call node returning call4953 (depth = 8)
// compiled member node returning call4953 (depth = 7)
  gc_frame_newslot(call4953);
// starting to compile block node (depth = 7)
  Object block4954 = alloc_Block(NULL, NULL, "ast", 1101);
  gc_frame_newslot(block4954);
// method _apply
  block_savedest(block4954);
  Object closure4955 = createclosure(4, "_apply");
  setclosureframe(closure4955, stackframe);
  addtoclosure(closure4955, var_part);
  addtoclosure(closure4955, var_depth);
  addtoclosure(closure4955, var_s);
  addtoclosure(closure4955, selfslot);
  struct UserObject *uo4955 = (struct UserObject*)block4954;
  uo4955->data[0] = (Object)closure4955;
  Method *meth_meth_ast__apply4955 = addmethod2pos(block4954, "_apply", &meth_ast__apply4955, 0);
  int argcv_meth_ast__apply4955[] = {1};
  meth_meth_ast__apply4955->type = alloc_MethodType(1, argcv_meth_ast__apply4955);
  meth_meth_ast__apply4955->definitionModule = modulename;
  meth_meth_ast__apply4955->definitionLine = 1101;
// compiled block node returning block4954 (depth = 7)
  gc_frame_newslot(block4954);
// call case 5: prelude request
  params[0] = call4953;
  params[1] = block4954;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4983 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4949);
// compiled call node returning call4983 (depth = 6)
// Begin line 1108
  setline(1108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4985 == NULL) {
    strlit4985 = alloc_String(")");
    gc_root(strlit4985);
  }
// compiled string node returning strlit4985 (depth = 8)
  int op_slot_right_4984 = gc_frame_newslot(strlit4985);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_4984 = gc_frame_newslot(*var_s);
  params[0] = strlit4985;
  partcv[0] = 1;
  Object opresult4987 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4987 (depth = 7)
  *var_s = opresult4987;
  if (opresult4987 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if4935 = done;
  } else {
  }
// compiled if node returning if4935 (depth = 5)
  gc_frame_end(frame);
  return if4935;
}
Object meth_ast_toGrace4769(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(6, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
  Object *var_member = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "member");
  Object *var_firstPart = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "firstPart");
// Begin line 1070
  setline(1070);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit4770 == NULL) {
    strlit4770 = alloc_String("");
    gc_root(strlit4770);
  }
// compiled string node returning strlit4770 (depth = 4)
  *var_spc = strlit4770;
  if (strlit4770 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1071
  setline(1071);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4771 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_depth (depth = 4)
  gc_frame_newslot(*var_depth);
// starting to compile block node (depth = 4)
  Object block4772 = alloc_Block(NULL, NULL, "ast", 1071);
  gc_frame_newslot(block4772);
// method _apply
  block_savedest(block4772);
  Object closure4773 = createclosure(2, "_apply");
  setclosureframe(closure4773, stackframe);
  addtoclosure(closure4773, var_spc);
  addtoclosure(closure4773, selfslot);
  struct UserObject *uo4773 = (struct UserObject*)block4772;
  uo4773->data[0] = (Object)closure4773;
  Method *meth_meth_ast__apply4773 = addmethod2pos(block4772, "_apply", &meth_ast__apply4773, 0);
  int argcv_meth_ast__apply4773[] = {0};
  meth_meth_ast__apply4773->type = alloc_MethodType(1, argcv_meth_ast__apply4773);
  meth_meth_ast__apply4773->definitionModule = modulename;
  meth_meth_ast__apply4773->definitionLine = 1063;
// compiled block node returning block4772 (depth = 4)
  gc_frame_newslot(block4772);
// call case 5: prelude request
  params[0] = *var_depth;
  params[1] = block4772;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4780 = callmethodflags(prelude, "repeat()times", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4771);
// compiled call node returning call4780 (depth = 3)
// Begin line 1074
  setline(1074);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit4781 == NULL) {
    strlit4781 = alloc_String("");
    gc_root(strlit4781);
  }
// compiled string node returning strlit4781 (depth = 4)
  *var_s = strlit4781;
  if (strlit4781 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1076
  setline(1076);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4784 == NULL) {
    strlit4784 = alloc_String("member");
    gc_root(strlit4784);
  }
// compiled string node returning strlit4784 (depth = 5)
  int op_slot_right_4783 = gc_frame_newslot(strlit4784);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4786 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4787 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4788 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4787);
// compiled call node returning call4788 (depth = 8)
// compiled member node returning call4788 (depth = 7)
  partcv[0] = 0;
  Object call4789 = callmethod(call4788, "kind",
    1, partcv, params);
  gc_frame_end(callframe4786);
// compiled call node returning call4789 (depth = 6)
// compiled member node returning call4789 (depth = 5)
  int op_slot_left_4783 = gc_frame_newslot(call4789);
  params[0] = strlit4784;
  partcv[0] = 1;
  Object opresult4790 = callmethod(call4789, "==", 1, partcv, params);
// compiled op node returning opresult4790 (depth = 4)
  Object if4782 = done;
  if (istrue(opresult4790)) {
// Begin line 1077
  setline(1077);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4791 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4792 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4791);
// compiled call node returning call4792 (depth = 6)
// compiled member node returning call4792 (depth = 5)
  *var_member = call4792;
  if (call4792 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1078
  setline(1078);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4795 == NULL) {
    strlit4795 = alloc_String("prefix");
    gc_root(strlit4795);
  }
// compiled string node returning strlit4795 (depth = 6)
  int op_slot_right_4794 = gc_frame_newslot(strlit4795);
// starting to compile call node (depth = 6)
  int callframe4797 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num4798 = alloc_Float64(1);
// compiled num node returning num4798 (depth = 7)
  gc_frame_newslot(num4798);
// starting to compile num node (depth = 7)
  Object num4799 = alloc_Float64(6);
// compiled num node returning num4799 (depth = 7)
  gc_frame_newslot(num4799);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4800 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_member (depth = 9)
  partcv[0] = 0;
  Object call4801 = callmethod(*var_member, "value",
    1, partcv, params);
  gc_frame_end(callframe4800);
// compiled call node returning call4801 (depth = 8)
// compiled member node returning call4801 (depth = 7)
  params[0] = num4798;
  params[1] = num4799;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4802 = callmethod(call4801, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe4797);
// compiled call node returning call4802 (depth = 6)
  int op_slot_left_4794 = gc_frame_newslot(call4802);
  params[0] = strlit4795;
  partcv[0] = 1;
  Object opresult4803 = callmethod(call4802, "==", 1, partcv, params);
// compiled op node returning opresult4803 (depth = 5)
  Object if4793 = done;
  if (istrue(opresult4803)) {
// Begin line 1079
  setline(1079);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4804 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num4805 = alloc_Float64(7);
// compiled num node returning num4805 (depth = 7)
  gc_frame_newslot(num4805);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4806 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4807 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_member (depth = 11)
  partcv[0] = 0;
  Object call4808 = callmethod(*var_member, "value",
    1, partcv, params);
  gc_frame_end(callframe4807);
// compiled call node returning call4808 (depth = 10)
// compiled member node returning call4808 (depth = 9)
  partcv[0] = 0;
  Object call4809 = callmethod(call4808, "size",
    1, partcv, params);
  gc_frame_end(callframe4806);
// compiled call node returning call4809 (depth = 8)
// compiled member node returning call4809 (depth = 7)
  gc_frame_newslot(call4809);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4810 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_member (depth = 9)
  partcv[0] = 0;
  Object call4811 = callmethod(*var_member, "value",
    1, partcv, params);
  gc_frame_end(callframe4810);
// compiled call node returning call4811 (depth = 8)
// compiled member node returning call4811 (depth = 7)
  params[0] = num4805;
  params[1] = call4809;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4812 = callmethod(call4811, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe4804);
// compiled call node returning call4812 (depth = 6)
  *var_s = call4812;
  if (call4812 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1080
  setline(1080);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4815 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num4816 = alloc_Float64(0);
// compiled num node returning num4816 (depth = 8)
  gc_frame_newslot(num4816);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4817 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_member (depth = 10)
  partcv[0] = 0;
  Object call4818 = callmethod(*var_member, "in",
    1, partcv, params);
  gc_frame_end(callframe4817);
// compiled call node returning call4818 (depth = 9)
// compiled member node returning call4818 (depth = 8)
  params[0] = num4816;
  partcv[0] = 1;
  Object call4819 = callmethod(call4818, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4815);
// compiled call node returning call4819 (depth = 7)
  int op_slot_right_4814 = gc_frame_newslot(call4819);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_4814 = gc_frame_newslot(*var_s);
  params[0] = call4819;
  partcv[0] = 1;
  Object opresult4821 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4821 (depth = 6)
  return opresult4821;
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if4793 = undefined;
  } else {
  }
// compiled if node returning if4793 (depth = 4)
// Begin line 1082
  setline(1082);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4823 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4824 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_member (depth = 9)
  partcv[0] = 0;
  Object call4825 = callmethod(*var_member, "in",
    1, partcv, params);
  gc_frame_end(callframe4824);
// compiled call node returning call4825 (depth = 8)
// compiled member node returning call4825 (depth = 7)
  partcv[0] = 0;
  Object call4826 = callmethod(call4825, "isSimple",
    1, partcv, params);
  gc_frame_end(callframe4823);
// compiled call node returning call4826 (depth = 6)
// compiled member node returning call4826 (depth = 5)
  Object if4822 = done;
  if (istrue(call4826)) {
// Begin line 1083
  setline(1083);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4828 == NULL) {
    strlit4828 = alloc_String(".");
    gc_root(strlit4828);
  }
// compiled string node returning strlit4828 (depth = 7)
  int op_slot_right_4827 = gc_frame_newslot(strlit4828);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4831 = gc_frame_new();
// starting to compile num node (depth = 9)
  Object num4832 = alloc_Float64(0);
// compiled num node returning num4832 (depth = 9)
  gc_frame_newslot(num4832);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4833 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_member (depth = 11)
  partcv[0] = 0;
  Object call4834 = callmethod(*var_member, "in",
    1, partcv, params);
  gc_frame_end(callframe4833);
// compiled call node returning call4834 (depth = 10)
// compiled member node returning call4834 (depth = 9)
  params[0] = num4832;
  partcv[0] = 1;
  Object call4835 = callmethod(call4834, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4831);
// compiled call node returning call4835 (depth = 8)
  int op_slot_right_4830 = gc_frame_newslot(call4835);
// starting to compile string node (depth = 8)
  if (strlit4837 == NULL) {
    strlit4837 = alloc_String("");
    gc_root(strlit4837);
  }
// compiled string node returning strlit4837 (depth = 8)
  int op_slot_left_4830 = gc_frame_newslot(strlit4837);
  params[0] = call4835;
  partcv[0] = 1;
  Object opresult4838 = callmethod(strlit4837, "++", 1, partcv, params);
// compiled op node returning opresult4838 (depth = 7)
  int op_slot_left_4827 = gc_frame_newslot(opresult4838);
  params[0] = strlit4828;
  partcv[0] = 1;
  Object opresult4839 = callmethod(opresult4838, "++", 1, partcv, params);
// compiled op node returning opresult4839 (depth = 6)
  *var_s = opresult4839;
  if (opresult4839 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if4822 = done;
  } else {
// Begin line 1085
  setline(1085);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4842 == NULL) {
    strlit4842 = alloc_String(").");
    gc_root(strlit4842);
  }
// compiled string node returning strlit4842 (depth = 7)
  int op_slot_right_4841 = gc_frame_newslot(strlit4842);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4845 = gc_frame_new();
// starting to compile num node (depth = 9)
  Object num4846 = alloc_Float64(0);
// compiled num node returning num4846 (depth = 9)
  gc_frame_newslot(num4846);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4847 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_member (depth = 11)
  partcv[0] = 0;
  Object call4848 = callmethod(*var_member, "in",
    1, partcv, params);
  gc_frame_end(callframe4847);
// compiled call node returning call4848 (depth = 10)
// compiled member node returning call4848 (depth = 9)
  params[0] = num4846;
  partcv[0] = 1;
  Object call4849 = callmethod(call4848, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4845);
// compiled call node returning call4849 (depth = 8)
  int op_slot_right_4844 = gc_frame_newslot(call4849);
// starting to compile string node (depth = 8)
  if (strlit4851 == NULL) {
    strlit4851 = alloc_String("(");
    gc_root(strlit4851);
  }
// compiled string node returning strlit4851 (depth = 8)
  int op_slot_left_4844 = gc_frame_newslot(strlit4851);
  params[0] = call4849;
  partcv[0] = 1;
  Object opresult4852 = callmethod(strlit4851, "++", 1, partcv, params);
// compiled op node returning opresult4852 (depth = 7)
  int op_slot_left_4841 = gc_frame_newslot(opresult4852);
  params[0] = strlit4842;
  partcv[0] = 1;
  Object opresult4853 = callmethod(opresult4852, "++", 1, partcv, params);
// compiled op node returning opresult4853 (depth = 6)
  *var_s = opresult4853;
  if (opresult4853 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if4822 = done;
  }
// compiled if node returning if4822 (depth = 4)
    gc_frame_newslot(if4822);
    if4782 = if4822;
  } else {
  }
// compiled if node returning if4782 (depth = 3)
// Begin line 1088
  setline(1088);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool4855 = alloc_Boolean(1);
// compiled identifier node returning bool4855 (depth = 4)
  *var_firstPart = bool4855;
  if (bool4855 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1089
  setline(1089);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4856 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4857 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4858 = callmethodflags(self, "with", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4857);
// compiled call node returning call4858 (depth = 5)
// compiled member node returning call4858 (depth = 4)
  gc_frame_newslot(call4858);
// starting to compile block node (depth = 4)
  Object block4859 = alloc_Block(NULL, NULL, "ast", 1089);
  gc_frame_newslot(block4859);
// method _apply
  block_savedest(block4859);
  Object closure4860 = createclosure(4, "_apply");
  setclosureframe(closure4860, stackframe);
  addtoclosure(closure4860, var_s);
  addtoclosure(closure4860, var_firstPart);
  addtoclosure(closure4860, var_depth);
  addtoclosure(closure4860, selfslot);
  struct UserObject *uo4860 = (struct UserObject*)block4859;
  uo4860->data[0] = (Object)closure4860;
  Method *meth_meth_ast__apply4860 = addmethod2pos(block4859, "_apply", &meth_ast__apply4860, 0);
  int argcv_meth_ast__apply4860[] = {1};
  meth_meth_ast__apply4860->type = alloc_MethodType(1, argcv_meth_ast__apply4860);
  meth_meth_ast__apply4860->definitionModule = modulename;
  meth_meth_ast__apply4860->definitionLine = 1089;
// compiled block node returning block4859 (depth = 4)
  gc_frame_newslot(block4859);
// call case 5: prelude request
  params[0] = call4858;
  params[1] = block4859;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4990 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4856);
// compiled call node returning call4990 (depth = 3)
// Begin line 1111
  setline(1111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_asString4991(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_what = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1113
  setline(1113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit4993 == NULL) {
    strlit4993 = alloc_String("");
    gc_root(strlit4993);
  }
// compiled string node returning strlit4993 (depth = 4)
  int op_slot_right_4992 = gc_frame_newslot(strlit4993);
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4996 = gc_frame_new();
// starting to compile num node (depth = 6)
  Object num4997 = alloc_Float64(0);
// compiled num node returning num4997 (depth = 6)
  gc_frame_newslot(num4997);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_what (depth = 6)
  params[0] = num4997;
  partcv[0] = 1;
  Object call4998 = callmethod(*var_what, "pretty",
    1, partcv, params);
  gc_frame_end(callframe4996);
// compiled call node returning call4998 (depth = 5)
  int op_slot_right_4995 = gc_frame_newslot(call4998);
// starting to compile string node (depth = 5)
  if (strlit5000 == NULL) {
    strlit5000 = alloc_String("call ");
    gc_root(strlit5000);
  }
// compiled string node returning strlit5000 (depth = 5)
  int op_slot_left_4995 = gc_frame_newslot(strlit5000);
  params[0] = call4998;
  partcv[0] = 1;
  Object opresult5001 = callmethod(strlit5000, "++", 1, partcv, params);
// compiled op node returning opresult5001 (depth = 4)
  int op_slot_left_4992 = gc_frame_newslot(opresult5001);
  params[0] = strlit4993;
  partcv[0] = 1;
  Object opresult5002 = callmethod(opresult5001, "++", 1, partcv, params);
// compiled op node returning opresult5002 (depth = 3)
  gc_frame_end(frame);
  return opresult5002;
}
Object meth_ast_shallowCopy5003(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_callNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1115
  setline(1115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5004 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe5005 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5006 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5007 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5006);
// compiled call node returning call5007 (depth = 6)
// compiled member node returning call5007 (depth = 5)
  gc_frame_newslot(call5007);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5008 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5009 = callmethodflags(self, "with", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5008);
// compiled call node returning call5009 (depth = 6)
// compiled member node returning call5009 (depth = 5)
  gc_frame_newslot(call5009);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_callNode (depth = 5)
  params[0] = call5007;
  params[1] = call5009;
  partcv[0] = 2;
  Object call5010 = callmethod(*var_callNode, "new",
    1, partcv, params);
  gc_frame_end(callframe5005);
// compiled call node returning call5010 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call5011 = callmethod(call5010, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe5004);
// compiled call node returning call5011 (depth = 3)
  gc_frame_end(frame);
  return call5011;
}
Object meth_ast_shallowCopyFieldsFrom5012(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyFieldsFrom");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopyFieldsFrom (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyFieldsFrom");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1118
  setline(1118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5013 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call5014 = callmethod4(self, "shallowCopyFieldsFrom", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe5013);
// compiled call node returning call5014 (depth = 3)
// Begin line 1119
  setline(1119);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 1115
  setline(1115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5015 = gc_frame_new();
// Begin line 1119
  setline(1119);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5016 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  partcv[0] = 0;
  Object call5017 = callmethod(*var_other, "isPattern",
    1, partcv, params);
  gc_frame_end(callframe5016);
// compiled call node returning call5017 (depth = 6)
// compiled member node returning call5017 (depth = 5)
  gc_frame_newslot(call5017);
// call case 4: self request
  params[0] = call5017;
  partcv[0] = 1;
  Object call5018 = callmethodflags(self, "isPattern:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5015);
// compiled call node returning call5018 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 1120
  setline(1120);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_new4498(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_callNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_what = &(stackframe->slots[0]);
  *var_what = args[curarg];
  curarg++;
  Object *var_with_39_ = &(stackframe->slots[1]);
  *var_with_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4499 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4499 = alloc_userobj2(22,19, objclass4499);
  gc_frame_newslot(obj4499);
if (objclass4499 == NULL) {
  glfree(obj4499->class->name);
  obj4499->class->name = "obj4491.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4499, self, 0);
  addmethodreal(obj4499,"outer", &reader_ast_outer_4500);
  Object oldself4499 = self;
  struct StackFrameObject *oldstackframe4499 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4499);
  gc_frame_newslot((Object)stackframe);
  self = obj4499;
  Object *oldselfslot4499 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4499 = (*(struct UserObject *)self).data[0], lowerouter4499 = thisouter4499;
  if (inheritingObject4499) {
    struct UserObject *inho4499 = (struct UserObject *)inheritingObject4499;
    while (inho4499->super != GraceDefaultObject) inho4499 = (struct UserObject *)inho4499->super;
    inho4499->super = obj4499;
    self = inheritingObject4499;
    *selfslot = self;
    lowerouter4499 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4499;
  }
if (objclass4499 == NULL) {
  Method *reader4501 = addmethodrealflags(obj4499, "kind",&reader_ast_kind_4501, MFLAG_DEF);
  reader4501->definitionModule = modulename;
  reader4501->definitionLine = 1003;
}
adddatum2(obj4499, alloc_Undefined(), 1);
if (objclass4499 == NULL) {
  Method *reader4502 = addmethodrealflags(obj4499, "value",&reader_ast_value_4502, 0);
  Method *writer4502 = addmethodrealflags(obj4499, "value:=",&writer_ast_value_4502, 0);
  reader4502->definitionModule = modulename;
  writer4502->definitionModule = modulename;
  reader4502->definitionLine = 1004;
  writer4502->definitionLine = 1004;
}
obj4499->flags |= OFLAG_MUTABLE;
adddatum2(obj4499, alloc_Undefined(), 2);
if (objclass4499 == NULL) {
  Method *reader4503 = addmethodrealflags(obj4499, "with",&reader_ast_with_4503, 0);
  Method *writer4503 = addmethodrealflags(obj4499, "with:=",&writer_ast_with_4503, 0);
  reader4503->definitionModule = modulename;
  writer4503->definitionModule = modulename;
  reader4503->definitionLine = 1005;
  writer4503->definitionLine = 1005;
}
obj4499->flags |= OFLAG_MUTABLE;
adddatum2(obj4499, alloc_Undefined(), 3);
if (objclass4499 == NULL) {
  Method *reader4504 = addmethodrealflags(obj4499, "generics",&reader_ast_generics_4504, 0);
  Method *writer4504 = addmethodrealflags(obj4499, "generics:=",&writer_ast_generics_4504, 0);
  reader4504->definitionModule = modulename;
  writer4504->definitionModule = modulename;
  reader4504->definitionLine = 1006;
  writer4504->definitionLine = 1006;
}
obj4499->flags |= OFLAG_MUTABLE;
adddatum2(obj4499, alloc_Undefined(), 4);
if (objclass4499 == NULL) {
  Method *reader4505 = addmethodrealflags(obj4499, "isPattern",&reader_ast_isPattern_4505, 0);
  Method *writer4505 = addmethodrealflags(obj4499, "isPattern:=",&writer_ast_isPattern_4505, 0);
  reader4505->definitionModule = modulename;
  writer4505->definitionModule = modulename;
  reader4505->definitionLine = 1007;
  writer4505->definitionLine = 1007;
}
obj4499->flags |= OFLAG_MUTABLE;
adddatum2(obj4499, alloc_Undefined(), 5);
if (objclass4499 == NULL) {
  Method *reader4506 = addmethodrealflags(obj4499, "nameString",&reader_ast_nameString_4506, MFLAG_DEF);
  reader4506->definitionModule = modulename;
  reader4506->definitionLine = 1008;
}
adddatum2(obj4499, alloc_Undefined(), 6);
// method target
  struct UserObject *uo4507 = (struct UserObject*)obj4499;
  uo4507->data[7] = emptyclosure;
  Method *meth_meth_ast_target4507 = addmethod2pos(obj4499, "target", &meth_ast_target4507, 7);
  int argcv_meth_ast_target4507[] = {0};
  meth_meth_ast_target4507->type = alloc_MethodType(1, argcv_meth_ast_target4507);
  meth_meth_ast_target4507->definitionModule = modulename;
  meth_meth_ast_target4507->definitionLine = 1010;
// method isCall
  struct UserObject *uo4510 = (struct UserObject*)obj4499;
  uo4510->data[8] = emptyclosure;
  Method *meth_meth_ast_isCall4510 = addmethod2pos(obj4499, "isCall", &meth_ast_isCall4510, 8);
  int argcv_meth_ast_isCall4510[] = {0};
  meth_meth_ast_isCall4510->type = alloc_MethodType(1, argcv_meth_ast_isCall4510);
  meth_meth_ast_isCall4510->definitionModule = modulename;
  meth_meth_ast_isCall4510->definitionLine = 1011;
// method returnsObject
  struct UserObject *uo4512 = (struct UserObject*)obj4499;
  uo4512->data[9] = emptyclosure;
  Method *meth_meth_ast_returnsObject4512 = addmethod2pos(obj4499, "returnsObject", &meth_ast_returnsObject4512, 9);
  int argcv_meth_ast_returnsObject4512[] = {0};
  meth_meth_ast_returnsObject4512->type = alloc_MethodType(1, argcv_meth_ast_returnsObject4512);
  meth_meth_ast_returnsObject4512->definitionModule = modulename;
  meth_meth_ast_returnsObject4512->definitionLine = 1012;
// method returnedObjectScope
  struct UserObject *uo4542 = (struct UserObject*)obj4499;
  uo4542->data[10] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope4542 = addmethod2pos(obj4499, "returnedObjectScope", &meth_ast_returnedObjectScope4542, 10);
  int argcv_meth_ast_returnedObjectScope4542[] = {0};
  meth_meth_ast_returnedObjectScope4542->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope4542);
  meth_meth_ast_returnedObjectScope4542->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope4542->definitionLine = 1018;
// method accept()from
  struct UserObject *uo4545 = (struct UserObject*)obj4499;
  uo4545->data[11] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from4545 = addmethod2pos(obj4499, "accept()from", &meth_ast_accept_40__41_from4545, 11);
  int argcv_meth_ast_accept_40__41_from4545[] = {1, 1};
  meth_meth_ast_accept_40__41_from4545->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from4545);
  meth_meth_ast_accept_40__41_from4545->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from4545->definitionLine = 1022;
// method map()ancestors
  struct UserObject *uo4587 = (struct UserObject*)obj4499;
  uo4587->data[12] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors4587 = addmethod2pos(obj4499, "map()ancestors", &meth_ast_map_40__41_ancestors4587, 12);
  int argcv_meth_ast_map_40__41_ancestors4587[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors4587->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors4587);
  meth_meth_ast_map_40__41_ancestors4587->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors4587->definitionLine = 1038;
// method pretty
  struct UserObject *uo4620 = (struct UserObject*)obj4499;
  uo4620->data[13] = emptyclosure;
  Method *meth_meth_ast_pretty4620 = addmethod2pos(obj4499, "pretty", &meth_ast_pretty4620, 13);
  int argcv_meth_ast_pretty4620[] = {1};
  meth_meth_ast_pretty4620->type = alloc_MethodType(1, argcv_meth_ast_pretty4620);
  meth_meth_ast_pretty4620->definitionModule = modulename;
  meth_meth_ast_pretty4620->definitionLine = 1046;
// method toGrace
  struct UserObject *uo4769 = (struct UserObject*)obj4499;
  uo4769->data[14] = emptyclosure;
  Method *meth_meth_ast_toGrace4769 = addmethod2pos(obj4499, "toGrace", &meth_ast_toGrace4769, 14);
  int argcv_meth_ast_toGrace4769[] = {1};
  meth_meth_ast_toGrace4769->type = alloc_MethodType(1, argcv_meth_ast_toGrace4769);
meth_meth_ast_toGrace4769->type->types[0] = type_Number;
meth_meth_ast_toGrace4769->type->names[0] = "depth";
  meth_meth_ast_toGrace4769->definitionModule = modulename;
  meth_meth_ast_toGrace4769->definitionLine = 1069;
// method asString
  block_savedest(obj4499);
  Object closure4991 = createclosure(1, "asString");
  setclosureframe(closure4991, stackframe);
  addtoclosure(closure4991, var_what);
  struct UserObject *uo4991 = (struct UserObject*)obj4499;
  uo4991->data[15] = (Object)closure4991;
  Method *meth_meth_ast_asString4991 = addmethod2pos(obj4499, "asString", &meth_ast_asString4991, 15);
  int argcv_meth_ast_asString4991[] = {0};
  meth_meth_ast_asString4991->type = alloc_MethodType(1, argcv_meth_ast_asString4991);
  meth_meth_ast_asString4991->definitionModule = modulename;
  meth_meth_ast_asString4991->definitionLine = 1113;
// method shallowCopy
  block_savedest(obj4499);
  Object closure5003 = createclosure(1, "shallowCopy");
  setclosureframe(closure5003, stackframe);
  addtoclosure(closure5003, var_callNode);
  struct UserObject *uo5003 = (struct UserObject*)obj4499;
  uo5003->data[16] = (Object)closure5003;
  Method *meth_meth_ast_shallowCopy5003 = addmethod2pos(obj4499, "shallowCopy", &meth_ast_shallowCopy5003, 16);
  int argcv_meth_ast_shallowCopy5003[] = {0};
  meth_meth_ast_shallowCopy5003->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy5003);
  meth_meth_ast_shallowCopy5003->definitionModule = modulename;
  meth_meth_ast_shallowCopy5003->definitionLine = 1114;
// method shallowCopyFieldsFrom
  struct UserObject *uo5012 = (struct UserObject*)obj4499;
  uo5012->data[17] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom5012 = addmethod2pos(obj4499, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom5012, 17);
  int argcv_meth_ast_shallowCopyFieldsFrom5012[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom5012->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom5012);
  meth_meth_ast_shallowCopyFieldsFrom5012->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom5012->definitionLine = 1117;
  sourceObject = obj4499;
// Begin line 1002
  setline(1002);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5019 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_baseNode (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5020 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe5019);
// compiled call node returning call5020 (depth = 3)
  struct UserObject *obj4499_uo = (struct UserObject *)obj4499;
  obj4499_uo->super = call5020;
  sourceObject = obj4499;
// Begin line 1003
  setline(1003);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5021 == NULL) {
    strlit5021 = alloc_String("call");
    gc_root(strlit5021);
  }
// compiled string node returning strlit5021 (depth = 3)
  adddatum2(obj4499, strlit5021, 1);
  sourceObject = obj4499;
// Begin line 1004
  setline(1004);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_what (depth = 3)
  adddatum2(obj4499, *var_what, 2);
  sourceObject = obj4499;
// Begin line 1005
  setline(1005);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_with_39_ (depth = 3)
  adddatum2(obj4499, *var_with_39_, 3);
  sourceObject = obj4499;
// Begin line 1006
  setline(1006);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5022 = alloc_Boolean(0);
// compiled identifier node returning bool5022 (depth = 3)
  adddatum2(obj4499, bool5022, 4);
  sourceObject = obj4499;
// Begin line 1007
  setline(1007);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5023 = alloc_Boolean(0);
// compiled identifier node returning bool5023 (depth = 3)
  adddatum2(obj4499, bool5023, 5);
  sourceObject = obj4499;
// Begin line 1008
  setline(1008);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5024 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5025 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5026 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5025);
// compiled call node returning call5026 (depth = 6)
// compiled member node returning call5026 (depth = 5)
  partcv[0] = 0;
  Object call5027 = callmethod(call5026, "nameString",
    1, partcv, params);
  gc_frame_end(callframe5024);
// compiled call node returning call5027 (depth = 4)
// compiled member node returning call5027 (depth = 3)
  adddatum2(obj4499, call5027, 6);
  sourceObject = obj4499;
  sourceObject = obj4499;
  sourceObject = obj4499;
  sourceObject = obj4499;
  sourceObject = obj4499;
  sourceObject = obj4499;
  sourceObject = obj4499;
  sourceObject = obj4499;
  sourceObject = obj4499;
  sourceObject = obj4499;
  sourceObject = obj4499;
  objclass4499 = obj4499->class;
  objclass4499->definitionModule = modulename;
  objclass4499->definitionLine = 984;
  (*(struct UserObject *)self).data[0] = lowerouter4499;
  self = oldself4499;
  selfslot = oldselfslot4499;
  stackframe = oldstackframe4499;
  gc_frame_end(frame);
  return obj4499;
}
Object meth_ast_new4498_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_callNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_what = &(stackframe->slots[0]);
  *var_what = args[curarg];
  curarg++;
  Object *var_with_39_ = &(stackframe->slots[1]);
  *var_with_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4499 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4499 = alloc_userobj2(22,19, objclass4499);
  gc_frame_newslot(obj4499);
if (objclass4499 == NULL) {
  glfree(obj4499->class->name);
  obj4499->class->name = "obj4491.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4499, self, 0);
  addmethodreal(obj4499,"outer", &reader_ast_outer_4500);
  Object oldself4499 = self;
  struct StackFrameObject *oldstackframe4499 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4499);
  gc_frame_newslot((Object)stackframe);
  self = obj4499;
  Object *oldselfslot4499 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4499 = (*(struct UserObject *)self).data[0], lowerouter4499 = thisouter4499;
  if (inheritingObject4499) {
    struct UserObject *inho4499 = (struct UserObject *)inheritingObject4499;
    while (inho4499->super != GraceDefaultObject) inho4499 = (struct UserObject *)inho4499->super;
    inho4499->super = obj4499;
    self = inheritingObject4499;
    *selfslot = self;
    lowerouter4499 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4499;
  }
if (objclass4499 == NULL) {
  Method *reader4501 = addmethodrealflags(obj4499, "kind",&reader_ast_kind_4501, MFLAG_DEF);
  reader4501->definitionModule = modulename;
  reader4501->definitionLine = 1003;
}
adddatum2(obj4499, alloc_Undefined(), 1);
if (objclass4499 == NULL) {
  Method *reader4502 = addmethodrealflags(obj4499, "value",&reader_ast_value_4502, 0);
  Method *writer4502 = addmethodrealflags(obj4499, "value:=",&writer_ast_value_4502, 0);
  reader4502->definitionModule = modulename;
  writer4502->definitionModule = modulename;
  reader4502->definitionLine = 1004;
  writer4502->definitionLine = 1004;
}
obj4499->flags |= OFLAG_MUTABLE;
adddatum2(obj4499, alloc_Undefined(), 2);
if (objclass4499 == NULL) {
  Method *reader4503 = addmethodrealflags(obj4499, "with",&reader_ast_with_4503, 0);
  Method *writer4503 = addmethodrealflags(obj4499, "with:=",&writer_ast_with_4503, 0);
  reader4503->definitionModule = modulename;
  writer4503->definitionModule = modulename;
  reader4503->definitionLine = 1005;
  writer4503->definitionLine = 1005;
}
obj4499->flags |= OFLAG_MUTABLE;
adddatum2(obj4499, alloc_Undefined(), 3);
if (objclass4499 == NULL) {
  Method *reader4504 = addmethodrealflags(obj4499, "generics",&reader_ast_generics_4504, 0);
  Method *writer4504 = addmethodrealflags(obj4499, "generics:=",&writer_ast_generics_4504, 0);
  reader4504->definitionModule = modulename;
  writer4504->definitionModule = modulename;
  reader4504->definitionLine = 1006;
  writer4504->definitionLine = 1006;
}
obj4499->flags |= OFLAG_MUTABLE;
adddatum2(obj4499, alloc_Undefined(), 4);
if (objclass4499 == NULL) {
  Method *reader4505 = addmethodrealflags(obj4499, "isPattern",&reader_ast_isPattern_4505, 0);
  Method *writer4505 = addmethodrealflags(obj4499, "isPattern:=",&writer_ast_isPattern_4505, 0);
  reader4505->definitionModule = modulename;
  writer4505->definitionModule = modulename;
  reader4505->definitionLine = 1007;
  writer4505->definitionLine = 1007;
}
obj4499->flags |= OFLAG_MUTABLE;
adddatum2(obj4499, alloc_Undefined(), 5);
if (objclass4499 == NULL) {
  Method *reader4506 = addmethodrealflags(obj4499, "nameString",&reader_ast_nameString_4506, MFLAG_DEF);
  reader4506->definitionModule = modulename;
  reader4506->definitionLine = 1008;
}
adddatum2(obj4499, alloc_Undefined(), 6);
// method target
  struct UserObject *uo4507 = (struct UserObject*)obj4499;
  uo4507->data[7] = emptyclosure;
  Method *meth_meth_ast_target4507 = addmethod2pos(obj4499, "target", &meth_ast_target4507, 7);
  int argcv_meth_ast_target4507[] = {0};
  meth_meth_ast_target4507->type = alloc_MethodType(1, argcv_meth_ast_target4507);
  meth_meth_ast_target4507->definitionModule = modulename;
  meth_meth_ast_target4507->definitionLine = 1010;
// method isCall
  struct UserObject *uo4510 = (struct UserObject*)obj4499;
  uo4510->data[8] = emptyclosure;
  Method *meth_meth_ast_isCall4510 = addmethod2pos(obj4499, "isCall", &meth_ast_isCall4510, 8);
  int argcv_meth_ast_isCall4510[] = {0};
  meth_meth_ast_isCall4510->type = alloc_MethodType(1, argcv_meth_ast_isCall4510);
  meth_meth_ast_isCall4510->definitionModule = modulename;
  meth_meth_ast_isCall4510->definitionLine = 1011;
// method returnsObject
  struct UserObject *uo4512 = (struct UserObject*)obj4499;
  uo4512->data[9] = emptyclosure;
  Method *meth_meth_ast_returnsObject4512 = addmethod2pos(obj4499, "returnsObject", &meth_ast_returnsObject4512, 9);
  int argcv_meth_ast_returnsObject4512[] = {0};
  meth_meth_ast_returnsObject4512->type = alloc_MethodType(1, argcv_meth_ast_returnsObject4512);
  meth_meth_ast_returnsObject4512->definitionModule = modulename;
  meth_meth_ast_returnsObject4512->definitionLine = 1012;
// method returnedObjectScope
  struct UserObject *uo4542 = (struct UserObject*)obj4499;
  uo4542->data[10] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope4542 = addmethod2pos(obj4499, "returnedObjectScope", &meth_ast_returnedObjectScope4542, 10);
  int argcv_meth_ast_returnedObjectScope4542[] = {0};
  meth_meth_ast_returnedObjectScope4542->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope4542);
  meth_meth_ast_returnedObjectScope4542->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope4542->definitionLine = 1018;
// method accept()from
  struct UserObject *uo4545 = (struct UserObject*)obj4499;
  uo4545->data[11] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from4545 = addmethod2pos(obj4499, "accept()from", &meth_ast_accept_40__41_from4545, 11);
  int argcv_meth_ast_accept_40__41_from4545[] = {1, 1};
  meth_meth_ast_accept_40__41_from4545->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from4545);
  meth_meth_ast_accept_40__41_from4545->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from4545->definitionLine = 1022;
// method map()ancestors
  struct UserObject *uo4587 = (struct UserObject*)obj4499;
  uo4587->data[12] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors4587 = addmethod2pos(obj4499, "map()ancestors", &meth_ast_map_40__41_ancestors4587, 12);
  int argcv_meth_ast_map_40__41_ancestors4587[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors4587->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors4587);
  meth_meth_ast_map_40__41_ancestors4587->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors4587->definitionLine = 1038;
// method pretty
  struct UserObject *uo4620 = (struct UserObject*)obj4499;
  uo4620->data[13] = emptyclosure;
  Method *meth_meth_ast_pretty4620 = addmethod2pos(obj4499, "pretty", &meth_ast_pretty4620, 13);
  int argcv_meth_ast_pretty4620[] = {1};
  meth_meth_ast_pretty4620->type = alloc_MethodType(1, argcv_meth_ast_pretty4620);
  meth_meth_ast_pretty4620->definitionModule = modulename;
  meth_meth_ast_pretty4620->definitionLine = 1046;
// method toGrace
  struct UserObject *uo4769 = (struct UserObject*)obj4499;
  uo4769->data[14] = emptyclosure;
  Method *meth_meth_ast_toGrace4769 = addmethod2pos(obj4499, "toGrace", &meth_ast_toGrace4769, 14);
  int argcv_meth_ast_toGrace4769[] = {1};
  meth_meth_ast_toGrace4769->type = alloc_MethodType(1, argcv_meth_ast_toGrace4769);
meth_meth_ast_toGrace4769->type->types[0] = type_Number;
meth_meth_ast_toGrace4769->type->names[0] = "depth";
  meth_meth_ast_toGrace4769->definitionModule = modulename;
  meth_meth_ast_toGrace4769->definitionLine = 1069;
// method asString
  block_savedest(obj4499);
  Object closure4991 = createclosure(1, "asString");
  setclosureframe(closure4991, stackframe);
  addtoclosure(closure4991, var_what);
  struct UserObject *uo4991 = (struct UserObject*)obj4499;
  uo4991->data[15] = (Object)closure4991;
  Method *meth_meth_ast_asString4991 = addmethod2pos(obj4499, "asString", &meth_ast_asString4991, 15);
  int argcv_meth_ast_asString4991[] = {0};
  meth_meth_ast_asString4991->type = alloc_MethodType(1, argcv_meth_ast_asString4991);
  meth_meth_ast_asString4991->definitionModule = modulename;
  meth_meth_ast_asString4991->definitionLine = 1113;
// method shallowCopy
  block_savedest(obj4499);
  Object closure5003 = createclosure(1, "shallowCopy");
  setclosureframe(closure5003, stackframe);
  addtoclosure(closure5003, var_callNode);
  struct UserObject *uo5003 = (struct UserObject*)obj4499;
  uo5003->data[16] = (Object)closure5003;
  Method *meth_meth_ast_shallowCopy5003 = addmethod2pos(obj4499, "shallowCopy", &meth_ast_shallowCopy5003, 16);
  int argcv_meth_ast_shallowCopy5003[] = {0};
  meth_meth_ast_shallowCopy5003->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy5003);
  meth_meth_ast_shallowCopy5003->definitionModule = modulename;
  meth_meth_ast_shallowCopy5003->definitionLine = 1114;
// method shallowCopyFieldsFrom
  struct UserObject *uo5012 = (struct UserObject*)obj4499;
  uo5012->data[17] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom5012 = addmethod2pos(obj4499, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom5012, 17);
  int argcv_meth_ast_shallowCopyFieldsFrom5012[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom5012->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom5012);
  meth_meth_ast_shallowCopyFieldsFrom5012->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom5012->definitionLine = 1117;
  sourceObject = obj4499;
// Begin line 1002
  setline(1002);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5019 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_baseNode (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5020 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe5019);
// compiled call node returning call5020 (depth = 3)
  struct UserObject *obj4499_uo = (struct UserObject *)obj4499;
  obj4499_uo->super = call5020;
  sourceObject = obj4499;
// Begin line 1003
  setline(1003);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5021 == NULL) {
    strlit5021 = alloc_String("call");
    gc_root(strlit5021);
  }
// compiled string node returning strlit5021 (depth = 3)
  adddatum2(obj4499, strlit5021, 1);
  sourceObject = obj4499;
// Begin line 1004
  setline(1004);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_what (depth = 3)
  adddatum2(obj4499, *var_what, 2);
  sourceObject = obj4499;
// Begin line 1005
  setline(1005);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_with_39_ (depth = 3)
  adddatum2(obj4499, *var_with_39_, 3);
  sourceObject = obj4499;
// Begin line 1006
  setline(1006);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5022 = alloc_Boolean(0);
// compiled identifier node returning bool5022 (depth = 3)
  adddatum2(obj4499, bool5022, 4);
  sourceObject = obj4499;
// Begin line 1007
  setline(1007);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5023 = alloc_Boolean(0);
// compiled identifier node returning bool5023 (depth = 3)
  adddatum2(obj4499, bool5023, 5);
  sourceObject = obj4499;
// Begin line 1008
  setline(1008);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5024 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5025 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5026 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5025);
// compiled call node returning call5026 (depth = 6)
// compiled member node returning call5026 (depth = 5)
  partcv[0] = 0;
  Object call5027 = callmethod(call5026, "nameString",
    1, partcv, params);
  gc_frame_end(callframe5024);
// compiled call node returning call5027 (depth = 4)
// compiled member node returning call5027 (depth = 3)
  adddatum2(obj4499, call5027, 6);
  sourceObject = obj4499;
  sourceObject = obj4499;
  sourceObject = obj4499;
  sourceObject = obj4499;
  sourceObject = obj4499;
  sourceObject = obj4499;
  sourceObject = obj4499;
  sourceObject = obj4499;
  sourceObject = obj4499;
  sourceObject = obj4499;
  sourceObject = obj4499;
  objclass4499 = obj4499->class;
  objclass4499->definitionModule = modulename;
  objclass4499->definitionLine = 984;
  (*(struct UserObject *)self).data[0] = lowerouter4499;
  self = oldself4499;
  selfslot = oldselfslot4499;
  stackframe = oldstackframe4499;
  gc_frame_end(frame);
  return obj4499;
}
Object meth_ast_callNode5029(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 24, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "callNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_callNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for callNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹callNode›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 978
  setline(978);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_callNode (depth = 3)
  gc_frame_end(frame);
  return *var_callNode;
}
Object meth_ast_classNode5030(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 25, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "classNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_classNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for classNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for classNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_classNode (depth = 3)
  gc_frame_end(frame);
  return *var_classNode;
}
Object meth_ast_declarationKindWithAncestors5047(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "declarationKindWithAncestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method declarationKindWithAncestors");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for declarationKindWithAncestors (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for declarationKindWithAncestors");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1156
  setline(1156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit5048 == NULL) {
    strlit5048 = alloc_String("method");
    gc_root(strlit5048);
  }
// compiled string node returning strlit5048 (depth = 4)
  gc_frame_end(frame);
  return strlit5048;
}
Object meth_ast_scope_58__61_5049(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "scope:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method scope:=");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for scope:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_st = &(stackframe->slots[0]);
  *var_st = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for scope:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1161
  setline(1161);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1124
  setline(1124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5050 = gc_frame_new();
// Begin line 1161
  setline(1161);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_st (depth = 6)
  gc_frame_newslot(*var_st);
// call case 4: self request
  params[0] = *var_st;
  partcv[0] = 1;
  Object call5051 = callmethodflags(self, "symbolTable:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5050);
// compiled call node returning call5051 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1162
  setline(1162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1124
  setline(1124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5052 = gc_frame_new();
// Begin line 1162
  setline(1162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_st (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call5053 = callmethod(*var_st, "node:=",
    1, partcv, params);
  gc_frame_end(callframe5052);
// compiled call node returning call5053 (depth = 5)
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_canInherit5054(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "canInherit");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for canInherit (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for canInherit");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1164
  setline(1164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool5055 = alloc_Boolean(1);
// compiled identifier node returning bool5055 (depth = 4)
  gc_frame_end(frame);
  return bool5055;
}
Object meth_ast_returnsObject5056(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnsObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for returnsObject (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for returnsObject");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1165
  setline(1165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool5057 = alloc_Boolean(1);
// compiled identifier node returning bool5057 (depth = 4)
  gc_frame_end(frame);
  return bool5057;
}
Object meth_ast_returnedObjectScope5058(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnedObjectScope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for returnedObjectScope (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for returnedObjectScope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1166
  setline(1166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5059 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5060 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5059);
// compiled call node returning call5060 (depth = 5)
// compiled member node returning call5060 (depth = 4)
  gc_frame_end(frame);
  return call5060;
}
Object meth_ast_isClass5061(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isClass");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isClass (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isClass");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1168
  setline(1168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool5062 = alloc_Boolean(1);
// compiled identifier node returning bool5062 (depth = 4)
  gc_frame_end(frame);
  return bool5062;
}
Object meth_ast_isPublic5063(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPublic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isPublic (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isPublic");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1171
  setline(1171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num5066 = alloc_Float64(0);
// compiled num node returning num5066 (depth = 6)
  int op_slot_right_5065 = gc_frame_newslot(num5066);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5068 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5069 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5070 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5069);
// compiled call node returning call5070 (depth = 9)
// compiled member node returning call5070 (depth = 8)
  partcv[0] = 0;
  Object call5071 = callmethod(call5070, "size",
    1, partcv, params);
  gc_frame_end(callframe5068);
// compiled call node returning call5071 (depth = 7)
// compiled member node returning call5071 (depth = 6)
  int op_slot_left_5065 = gc_frame_newslot(call5071);
  params[0] = num5066;
  partcv[0] = 1;
  Object opresult5072 = callmethod(call5071, "==", 1, partcv, params);
// compiled op node returning opresult5072 (depth = 5)
  Object if5064 = done;
  if (istrue(opresult5072)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool5073 = alloc_Boolean(1);
// compiled identifier node returning bool5073 (depth = 6)
  return bool5073;
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if5064 = undefined;
  } else {
  }
// compiled if node returning if5064 (depth = 4)
// Begin line 1172
  setline(1172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5074 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 6)
  int callframe5075 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// starting to compile string node (depth = 7)
  if (strlit5076 == NULL) {
    strlit5076 = alloc_String("confidential");
    gc_root(strlit5076);
  }
// compiled string node returning strlit5076 (depth = 7)
  gc_frame_newslot(strlit5076);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5077 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5078 = gc_frame_new();
// call case 3: self.outer request
  Object call5079 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5078);
// compiled call node returning call5079 (depth = 10)
// compiled member node returning call5079 (depth = 9)
  partcv[0] = 0;
  Object call5080 = callmethodflags(call5079, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5077);
// compiled call node returning call5080 (depth = 8)
// compiled member node returning call5080 (depth = 7)
  params[0] = self;
  params[1] = strlit5076;
  partcv[0] = 2;
  Object call5081 = callmethodflags(call5080, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5075);
// compiled call node returning call5081 (depth = 6)
  partcv[0] = 0;
  Object call5082 = callmethod(call5081, "not",
    1, partcv, params);
  gc_frame_end(callframe5074);
// compiled call node returning call5082 (depth = 5)
// compiled member node returning call5082 (depth = 4)
  gc_frame_end(frame);
  return call5082;
}
Object meth_ast_isWritable5083(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isWritable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isWritable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isWritable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1174
  setline(1174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool5084 = alloc_Boolean(0);
// compiled identifier node returning bool5084 (depth = 4)
  gc_frame_end(frame);
  return bool5084;
}
Object meth_ast_isReadable5085(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isReadable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isReadable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isReadable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1175
  setline(1175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5086 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5087 = callmethodflags(self, "isPublic", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5086);
// compiled call node returning call5087 (depth = 5)
// compiled member node returning call5087 (depth = 4)
  gc_frame_end(frame);
  return call5087;
}
Object meth_ast_usesAsType5088(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "usesAsType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method usesAsType");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for usesAsType (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aNode = &(stackframe->slots[0]);
  *var_aNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for usesAsType");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1177
  setline(1177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5090 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5091 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5090);
// compiled call node returning call5091 (depth = 6)
// compiled member node returning call5091 (depth = 5)
  int op_slot_right_5089 = gc_frame_newslot(call5091);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_aNode (depth = 5)
  int op_slot_left_5089 = gc_frame_newslot(*var_aNode);
  params[0] = call5091;
  partcv[0] = 1;
  Object opresult5093 = callmethod(*var_aNode, "==", 1, partcv, params);
// compiled op node returning opresult5093 (depth = 4)
  gc_frame_end(frame);
  return opresult5093;
}
Object meth_ast__apply5100(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_b = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 8)
  int callframe5101 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_each (depth = 9)
  gc_frame_newslot(*var_each);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_b (depth = 9)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call5102 = callmethod(*var_b, "apply",
    1, partcv, params);
  gc_frame_end(callframe5101);
// compiled call node returning call5102 (depth = 8)
  gc_frame_end(frame);
  return call5102;
}
Object meth_ast__apply5097(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_b = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1181
  setline(1181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5098 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block5099 = alloc_Block(NULL, NULL, "ast", 1181);
  gc_frame_newslot(block5099);
// method _apply
  block_savedest(block5099);
  Object closure5100 = createclosure(2, "_apply");
  setclosureframe(closure5100, stackframe);
  addtoclosure(closure5100, var_b);
  addtoclosure(closure5100, selfslot);
  struct UserObject *uo5100 = (struct UserObject*)block5099;
  uo5100->data[0] = (Object)closure5100;
  Method *meth_meth_ast__apply5100 = addmethod2pos(block5099, "_apply", &meth_ast__apply5100, 0);
  int argcv_meth_ast__apply5100[] = {1};
  meth_meth_ast__apply5100->type = alloc_MethodType(1, argcv_meth_ast__apply5100);
  meth_meth_ast__apply5100->definitionModule = modulename;
  meth_meth_ast__apply5100->definitionLine = 1177;
// compiled block node returning block5099 (depth = 7)
  gc_frame_newslot(block5099);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5104 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  partcv[0] = 0;
  Object call5105 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe5104);
// compiled call node returning call5105 (depth = 8)
// compiled member node returning call5105 (depth = 7)
  params[0] = block5099;
  partcv[0] = 1;
  Object call5106 = callmethod(call5105, "do",
    1, partcv, params);
  gc_frame_end(callframe5098);
// compiled call node returning call5106 (depth = 6)
  gc_frame_end(frame);
  return call5106;
}
Object meth_ast_parametersDo5094(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "parametersDo");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method parametersDo");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for parametersDo (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for parametersDo");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1180
  setline(1180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5095 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block5096 = alloc_Block(NULL, NULL, "ast", 1180);
  gc_frame_newslot(block5096);
// method _apply
  block_savedest(block5096);
  Object closure5097 = createclosure(2, "_apply");
  setclosureframe(closure5097, stackframe);
  addtoclosure(closure5097, var_b);
  addtoclosure(closure5097, selfslot);
  struct UserObject *uo5097 = (struct UserObject*)block5096;
  uo5097->data[0] = (Object)closure5097;
  Method *meth_meth_ast__apply5097 = addmethod2pos(block5096, "_apply", &meth_ast__apply5097, 0);
  int argcv_meth_ast__apply5097[] = {1};
  meth_meth_ast__apply5097->type = alloc_MethodType(1, argcv_meth_ast__apply5097);
  meth_meth_ast__apply5097->definitionModule = modulename;
  meth_meth_ast__apply5097->definitionLine = 1177;
// compiled block node returning block5096 (depth = 5)
  gc_frame_newslot(block5096);
// call case 6: other member request
// Begin line 1180
  setline(1180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5108 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5109 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5108);
// compiled call node returning call5109 (depth = 6)
// compiled member node returning call5109 (depth = 5)
  params[0] = block5096;
  partcv[0] = 1;
  Object call5110 = callmethod(call5109, "do",
    1, partcv, params);
  gc_frame_end(callframe5095);
// compiled call node returning call5110 (depth = 4)
  gc_frame_end(frame);
  return call5110;
}
Object meth_ast__apply5134(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1191
  setline(1191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe5135 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_visitor (depth = 9)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_newChain (depth = 9)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_each (depth = 9)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5136 = callmethod(*var_each, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe5135);
// compiled call node returning call5136 (depth = 8)
  gc_frame_end(frame);
  return call5136;
}
Object meth_ast__apply5156(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_partNode = &(stackframe->slots[0]);
  *var_partNode = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1198
  setline(1198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5157 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_visitor (depth = 8)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_newChain (depth = 8)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_partNode (depth = 8)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5158 = callmethod(*var_partNode, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe5157);
// compiled call node returning call5158 (depth = 7)
  gc_frame_end(frame);
  return call5158;
}
Object meth_ast__apply5176(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ann = &(stackframe->slots[0]);
  *var_ann = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1204
  setline(1204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5177 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_visitor (depth = 8)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_newChain (depth = 8)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ann (depth = 8)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5178 = callmethod(*var_ann, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe5177);
// compiled call node returning call5178 (depth = 7)
  gc_frame_end(frame);
  return call5178;
}
Object meth_ast__apply5185(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1207
  setline(1207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5186 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_visitor (depth = 8)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_newChain (depth = 8)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5187 = callmethod(*var_each, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe5186);
// compiled call node returning call5187 (depth = 7)
  gc_frame_end(frame);
  return call5187;
}
Object meth_ast_accept_40__41_from5111(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1185
  setline(1185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5113 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5114 = callmethod(*var_visitor, "visitClass()up",
    2, partcv, params);
  gc_frame_end(callframe5113);
// compiled call node returning call5114 (depth = 5)
  Object if5112 = done;
  if (istrue(call5114)) {
// Begin line 1186
  setline(1186);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5115 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_as (depth = 7)
  params[0] = self;
  partcv[0] = 1;
  Object call5116 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe5115);
// compiled call node returning call5116 (depth = 6)
  *var_newChain = call5116;
  if (call5116 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 1187
  setline(1187);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5117 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5118 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5119 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5118);
// compiled call node returning call5119 (depth = 7)
// compiled member node returning call5119 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5120 = callmethod(call5119, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe5117);
// compiled call node returning call5120 (depth = 5)
// Begin line 1188
  setline(1188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5121 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5122 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5123 = callmethodflags(self, "constructor", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5122);
// compiled call node returning call5123 (depth = 7)
// compiled member node returning call5123 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5124 = callmethod(call5123, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe5121);
// compiled call node returning call5124 (depth = 5)
// Begin line 1189
  setline(1189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5127 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5128 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5127);
// compiled call node returning call5128 (depth = 8)
// compiled member node returning call5128 (depth = 7)
  int op_slot_right_5126 = gc_frame_newslot(call5128);
// starting to compile identifier node (depth = 7)
  Object bool5130 = alloc_Boolean(0);
// compiled identifier node returning bool5130 (depth = 7)
  int op_slot_left_5126 = gc_frame_newslot(bool5130);
  params[0] = call5128;
  partcv[0] = 1;
  Object opresult5131 = callmethod(bool5130, "!=", 1, partcv, params);
// compiled op node returning opresult5131 (depth = 6)
  Object if5125 = done;
  if (istrue(opresult5131)) {
// Begin line 1190
  setline(1190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5132 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block5133 = alloc_Block(NULL, NULL, "ast", 1190);
  gc_frame_newslot(block5133);
// method _apply
  block_savedest(block5133);
  Object closure5134 = createclosure(3, "_apply");
  setclosureframe(closure5134, stackframe);
  addtoclosure(closure5134, var_visitor);
  addtoclosure(closure5134, var_newChain);
  addtoclosure(closure5134, selfslot);
  struct UserObject *uo5134 = (struct UserObject*)block5133;
  uo5134->data[0] = (Object)closure5134;
  Method *meth_meth_ast__apply5134 = addmethod2pos(block5133, "_apply", &meth_ast__apply5134, 0);
  int argcv_meth_ast__apply5134[] = {1};
  meth_meth_ast__apply5134->type = alloc_MethodType(1, argcv_meth_ast__apply5134);
  meth_meth_ast__apply5134->definitionModule = modulename;
  meth_meth_ast__apply5134->definitionLine = 1189;
// compiled block node returning block5133 (depth = 7)
  gc_frame_newslot(block5133);
// call case 6: other member request
// Begin line 1190
  setline(1190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5138 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5139 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5138);
// compiled call node returning call5139 (depth = 8)
// compiled member node returning call5139 (depth = 7)
  params[0] = block5133;
  partcv[0] = 1;
  Object call5140 = callmethod(call5139, "do",
    1, partcv, params);
  gc_frame_end(callframe5132);
// compiled call node returning call5140 (depth = 6)
    gc_frame_newslot(call5140);
    if5125 = call5140;
  } else {
  }
// compiled if node returning if5125 (depth = 5)
// Begin line 1194
  setline(1194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool5143 = alloc_Boolean(0);
// compiled identifier node returning bool5143 (depth = 7)
  int op_slot_right_5142 = gc_frame_newslot(bool5143);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5145 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5146 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5145);
// compiled call node returning call5146 (depth = 8)
// compiled member node returning call5146 (depth = 7)
  int op_slot_left_5142 = gc_frame_newslot(call5146);
  params[0] = bool5143;
  partcv[0] = 1;
  Object opresult5147 = callmethod(call5146, "!=", 1, partcv, params);
// compiled op node returning opresult5147 (depth = 6)
  Object if5141 = done;
  if (istrue(opresult5147)) {
// Begin line 1195
  setline(1195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5148 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5149 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5150 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5149);
// compiled call node returning call5150 (depth = 8)
// compiled member node returning call5150 (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5151 = callmethod(call5150, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe5148);
// compiled call node returning call5151 (depth = 6)
    gc_frame_newslot(call5151);
    if5141 = call5151;
  } else {
  }
// compiled if node returning if5141 (depth = 5)
// Begin line 1197
  setline(1197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5152 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5153 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5154 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5153);
// compiled call node returning call5154 (depth = 7)
// compiled member node returning call5154 (depth = 6)
  gc_frame_newslot(call5154);
// starting to compile block node (depth = 6)
  Object block5155 = alloc_Block(NULL, NULL, "ast", 1197);
  gc_frame_newslot(block5155);
// method _apply
  block_savedest(block5155);
  Object closure5156 = createclosure(3, "_apply");
  setclosureframe(closure5156, stackframe);
  addtoclosure(closure5156, var_visitor);
  addtoclosure(closure5156, var_newChain);
  addtoclosure(closure5156, selfslot);
  struct UserObject *uo5156 = (struct UserObject*)block5155;
  uo5156->data[0] = (Object)closure5156;
  Method *meth_meth_ast__apply5156 = addmethod2pos(block5155, "_apply", &meth_ast__apply5156, 0);
  int argcv_meth_ast__apply5156[] = {1};
  meth_meth_ast__apply5156->type = alloc_MethodType(1, argcv_meth_ast__apply5156);
  meth_meth_ast__apply5156->definitionModule = modulename;
  meth_meth_ast__apply5156->definitionLine = 1197;
// compiled block node returning block5155 (depth = 6)
  gc_frame_newslot(block5155);
// call case 5: prelude request
  params[0] = call5154;
  params[1] = block5155;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5160 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5152);
// compiled call node returning call5160 (depth = 5)
// Begin line 1200
  setline(1200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool5163 = alloc_Boolean(0);
// compiled identifier node returning bool5163 (depth = 7)
  int op_slot_right_5162 = gc_frame_newslot(bool5163);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5165 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5166 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5165);
// compiled call node returning call5166 (depth = 8)
// compiled member node returning call5166 (depth = 7)
  int op_slot_left_5162 = gc_frame_newslot(call5166);
  params[0] = bool5163;
  partcv[0] = 1;
  Object opresult5167 = callmethod(call5166, "!=", 1, partcv, params);
// compiled op node returning opresult5167 (depth = 6)
  Object if5161 = done;
  if (istrue(opresult5167)) {
// Begin line 1201
  setline(1201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5168 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5169 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5170 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5169);
// compiled call node returning call5170 (depth = 8)
// compiled member node returning call5170 (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5171 = callmethod(call5170, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe5168);
// compiled call node returning call5171 (depth = 6)
    gc_frame_newslot(call5171);
    if5161 = call5171;
  } else {
  }
// compiled if node returning if5161 (depth = 5)
// Begin line 1203
  setline(1203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5172 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5173 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5174 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5173);
// compiled call node returning call5174 (depth = 7)
// compiled member node returning call5174 (depth = 6)
  gc_frame_newslot(call5174);
// starting to compile block node (depth = 6)
  Object block5175 = alloc_Block(NULL, NULL, "ast", 1203);
  gc_frame_newslot(block5175);
// method _apply
  block_savedest(block5175);
  Object closure5176 = createclosure(3, "_apply");
  setclosureframe(closure5176, stackframe);
  addtoclosure(closure5176, var_visitor);
  addtoclosure(closure5176, var_newChain);
  addtoclosure(closure5176, selfslot);
  struct UserObject *uo5176 = (struct UserObject*)block5175;
  uo5176->data[0] = (Object)closure5176;
  Method *meth_meth_ast__apply5176 = addmethod2pos(block5175, "_apply", &meth_ast__apply5176, 0);
  int argcv_meth_ast__apply5176[] = {1};
  meth_meth_ast__apply5176->type = alloc_MethodType(1, argcv_meth_ast__apply5176);
  meth_meth_ast__apply5176->definitionModule = modulename;
  meth_meth_ast__apply5176->definitionLine = 1203;
// compiled block node returning block5175 (depth = 6)
  gc_frame_newslot(block5175);
// call case 5: prelude request
  params[0] = call5174;
  params[1] = block5175;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5180 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5172);
// compiled call node returning call5180 (depth = 5)
// Begin line 1206
  setline(1206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5181 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5182 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5183 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5182);
// compiled call node returning call5183 (depth = 7)
// compiled member node returning call5183 (depth = 6)
  gc_frame_newslot(call5183);
// starting to compile block node (depth = 6)
  Object block5184 = alloc_Block(NULL, NULL, "ast", 1206);
  gc_frame_newslot(block5184);
// method _apply
  block_savedest(block5184);
  Object closure5185 = createclosure(3, "_apply");
  setclosureframe(closure5185, stackframe);
  addtoclosure(closure5185, var_visitor);
  addtoclosure(closure5185, var_newChain);
  addtoclosure(closure5185, selfslot);
  struct UserObject *uo5185 = (struct UserObject*)block5184;
  uo5185->data[0] = (Object)closure5185;
  Method *meth_meth_ast__apply5185 = addmethod2pos(block5184, "_apply", &meth_ast__apply5185, 0);
  int argcv_meth_ast__apply5185[] = {1};
  meth_meth_ast__apply5185->type = alloc_MethodType(1, argcv_meth_ast__apply5185);
  meth_meth_ast__apply5185->definitionModule = modulename;
  meth_meth_ast__apply5185->definitionLine = 1206;
// compiled block node returning block5184 (depth = 6)
  gc_frame_newslot(block5184);
// call case 5: prelude request
  params[0] = call5183;
  params[1] = block5184;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5189 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5181);
// compiled call node returning call5189 (depth = 5)
    gc_frame_newslot(call5189);
    if5112 = call5189;
  } else {
  }
// compiled if node returning if5112 (depth = 4)
  gc_frame_end(frame);
  return if5112;
}
Object meth_ast_map_40__41_ancestors5190(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1212
  setline(1212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5191 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5192 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5191);
// compiled call node returning call5192 (depth = 6)
// compiled member node returning call5192 (depth = 5)
  *var_n = call5192;
  if (call5192 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1213
  setline(1213);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5193 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call5194 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe5193);
// compiled call node returning call5194 (depth = 5)
  *var_newChain = call5194;
  if (call5194 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1214
  setline(1214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1212
  setline(1212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5195 = gc_frame_new();
// Begin line 1214
  setline(1214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5196 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5197 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5198 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5197);
// compiled call node returning call5198 (depth = 8)
// compiled member node returning call5198 (depth = 7)
  gc_frame_newslot(call5198);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5199 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5200 = gc_frame_new();
// call case 3: self.outer request
  Object call5201 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5200);
// compiled call node returning call5201 (depth = 10)
// compiled member node returning call5201 (depth = 9)
  partcv[0] = 0;
  Object call5202 = callmethodflags(call5201, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5199);
// compiled call node returning call5202 (depth = 8)
// compiled member node returning call5202 (depth = 7)
  params[0] = call5198;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call5203 = callmethodflags(call5202, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5196);
// compiled call node returning call5203 (depth = 6)
  gc_frame_newslot(call5203);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call5203;
  partcv[0] = 1;
  Object call5204 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe5195);
// compiled call node returning call5204 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1215
  setline(1215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1214
  setline(1214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5205 = gc_frame_new();
// Begin line 1215
  setline(1215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5206 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5207 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5208 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5207);
// compiled call node returning call5208 (depth = 8)
// compiled member node returning call5208 (depth = 7)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5209 = callmethod(call5208, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe5206);
// compiled call node returning call5209 (depth = 6)
  gc_frame_newslot(call5209);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call5209;
  partcv[0] = 1;
  Object call5210 = callmethod(*var_n, "name:=",
    1, partcv, params);
  gc_frame_end(callframe5205);
// compiled call node returning call5210 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1216
  setline(1216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1215
  setline(1215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5211 = gc_frame_new();
// Begin line 1216
  setline(1216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5212 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5213 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5214 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5213);
// compiled call node returning call5214 (depth = 8)
// compiled member node returning call5214 (depth = 7)
  gc_frame_newslot(call5214);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5215 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5216 = gc_frame_new();
// call case 3: self.outer request
  Object call5217 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5216);
// compiled call node returning call5217 (depth = 10)
// compiled member node returning call5217 (depth = 9)
  partcv[0] = 0;
  Object call5218 = callmethodflags(call5217, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5215);
// compiled call node returning call5218 (depth = 8)
// compiled member node returning call5218 (depth = 7)
  params[0] = call5214;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call5219 = callmethodflags(call5218, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5212);
// compiled call node returning call5219 (depth = 6)
  gc_frame_newslot(call5219);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call5219;
  partcv[0] = 1;
  Object call5220 = callmethod(*var_n, "signature:=",
    1, partcv, params);
  gc_frame_end(callframe5211);
// compiled call node returning call5220 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1217
  setline(1217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1216
  setline(1216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5221 = gc_frame_new();
// Begin line 1217
  setline(1217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5222 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5223 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5224 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5223);
// compiled call node returning call5224 (depth = 8)
// compiled member node returning call5224 (depth = 7)
  gc_frame_newslot(call5224);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5225 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5226 = gc_frame_new();
// call case 3: self.outer request
  Object call5227 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5226);
// compiled call node returning call5227 (depth = 10)
// compiled member node returning call5227 (depth = 9)
  partcv[0] = 0;
  Object call5228 = callmethodflags(call5227, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5225);
// compiled call node returning call5228 (depth = 8)
// compiled member node returning call5228 (depth = 7)
  params[0] = call5224;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call5229 = callmethodflags(call5228, "maybeMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5222);
// compiled call node returning call5229 (depth = 6)
  gc_frame_newslot(call5229);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call5229;
  partcv[0] = 1;
  Object call5230 = callmethod(*var_n, "generics:=",
    1, partcv, params);
  gc_frame_end(callframe5221);
// compiled call node returning call5230 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1218
  setline(1218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1217
  setline(1217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5231 = gc_frame_new();
// Begin line 1218
  setline(1218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5232 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5233 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5234 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5233);
// compiled call node returning call5234 (depth = 8)
// compiled member node returning call5234 (depth = 7)
  gc_frame_newslot(call5234);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5235 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5236 = gc_frame_new();
// call case 3: self.outer request
  Object call5237 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5236);
// compiled call node returning call5237 (depth = 10)
// compiled member node returning call5237 (depth = 9)
  partcv[0] = 0;
  Object call5238 = callmethodflags(call5237, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5235);
// compiled call node returning call5238 (depth = 8)
// compiled member node returning call5238 (depth = 7)
  params[0] = call5234;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call5239 = callmethodflags(call5238, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5232);
// compiled call node returning call5239 (depth = 6)
  gc_frame_newslot(call5239);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call5239;
  partcv[0] = 1;
  Object call5240 = callmethod(*var_n, "annotations:=",
    1, partcv, params);
  gc_frame_end(callframe5231);
// compiled call node returning call5240 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1219
  setline(1219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1218
  setline(1218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5241 = gc_frame_new();
// Begin line 1219
  setline(1219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5242 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5243 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5244 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5243);
// compiled call node returning call5244 (depth = 8)
// compiled member node returning call5244 (depth = 7)
  gc_frame_newslot(call5244);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5245 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5246 = gc_frame_new();
// call case 3: self.outer request
  Object call5247 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5246);
// compiled call node returning call5247 (depth = 10)
// compiled member node returning call5247 (depth = 9)
  partcv[0] = 0;
  Object call5248 = callmethodflags(call5247, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5245);
// compiled call node returning call5248 (depth = 8)
// compiled member node returning call5248 (depth = 7)
  params[0] = call5244;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call5249 = callmethodflags(call5248, "maybeMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5242);
// compiled call node returning call5249 (depth = 6)
  gc_frame_newslot(call5249);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call5249;
  partcv[0] = 1;
  Object call5250 = callmethod(*var_n, "superclass:=",
    1, partcv, params);
  gc_frame_end(callframe5241);
// compiled call node returning call5250 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1220
  setline(1220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1219
  setline(1219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5251 = gc_frame_new();
// Begin line 1220
  setline(1220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5252 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5253 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5254 = callmethodflags(self, "constructor", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5253);
// compiled call node returning call5254 (depth = 8)
// compiled member node returning call5254 (depth = 7)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5255 = callmethod(call5254, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe5252);
// compiled call node returning call5255 (depth = 6)
  gc_frame_newslot(call5255);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call5255;
  partcv[0] = 1;
  Object call5256 = callmethod(*var_n, "constructor:=",
    1, partcv, params);
  gc_frame_end(callframe5251);
// compiled call node returning call5256 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1221
  setline(1221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1220
  setline(1220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5257 = gc_frame_new();
// Begin line 1221
  setline(1221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5258 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5259 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5260 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5259);
// compiled call node returning call5260 (depth = 8)
// compiled member node returning call5260 (depth = 7)
  gc_frame_newslot(call5260);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5261 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5262 = gc_frame_new();
// call case 3: self.outer request
  Object call5263 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5262);
// compiled call node returning call5263 (depth = 10)
// compiled member node returning call5263 (depth = 9)
  partcv[0] = 0;
  Object call5264 = callmethodflags(call5263, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5261);
// compiled call node returning call5264 (depth = 8)
// compiled member node returning call5264 (depth = 7)
  params[0] = call5260;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call5265 = callmethodflags(call5264, "maybeMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5258);
// compiled call node returning call5265 (depth = 6)
  gc_frame_newslot(call5265);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call5265;
  partcv[0] = 1;
  Object call5266 = callmethod(*var_n, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe5257);
// compiled call node returning call5266 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1222
  setline(1222);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5267 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call5268 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe5267);
// compiled call node returning call5268 (depth = 4)
  gc_frame_end(frame);
  return call5268;
}
Object meth_ast__apply5277(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1227
  setline(1227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5279 == NULL) {
    strlit5279 = alloc_String("  ");
    gc_root(strlit5279);
  }
// compiled string node returning strlit5279 (depth = 8)
  int op_slot_right_5278 = gc_frame_newslot(strlit5279);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_5278 = gc_frame_newslot(*var_spc);
  params[0] = strlit5279;
  partcv[0] = 1;
  Object opresult5281 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult5281 (depth = 7)
  *var_spc = opresult5281;
  if (opresult5281 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply5668(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1251
  setline(1251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit5670 == NULL) {
    strlit5670 = alloc_String("");
    gc_root(strlit5670);
  }
// compiled string node returning strlit5670 (depth = 10)
  int op_slot_right_5669 = gc_frame_newslot(strlit5670);
// starting to compile op node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe5673 = gc_frame_new();
// starting to compile op node (depth = 12)
// starting to compile num node (depth = 13)
  Object num5675 = alloc_Float64(4);
// compiled num node returning num5675 (depth = 13)
  int op_slot_right_5674 = gc_frame_newslot(num5675);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_depth (depth = 13)
  int op_slot_left_5674 = gc_frame_newslot(*var_depth);
  params[0] = num5675;
  partcv[0] = 1;
  Object sum5677 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum5677 (depth = 12)
  gc_frame_newslot(sum5677);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_p (depth = 12)
  params[0] = sum5677;
  partcv[0] = 1;
  Object call5678 = callmethod(*var_p, "pretty",
    1, partcv, params);
  gc_frame_end(callframe5673);
// compiled call node returning call5678 (depth = 11)
  int op_slot_right_5672 = gc_frame_newslot(call5678);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit5681 == NULL) {
    strlit5681 = alloc_String("");
    gc_root(strlit5681);
  }
// compiled string node returning strlit5681 (depth = 12)
  int op_slot_right_5680 = gc_frame_newslot(strlit5681);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_spc (depth = 13)
  int op_slot_right_5683 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit5686 == NULL) {
    strlit5686 = alloc_String("""\x0a""      ");
    gc_root(strlit5686);
  }
// compiled string node returning strlit5686 (depth = 14)
  int op_slot_right_5685 = gc_frame_newslot(strlit5686);
// starting to compile op node (depth = 14)
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_s (depth = 15)
  int op_slot_right_5688 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 15)
  if (strlit5690 == NULL) {
    strlit5690 = alloc_String("");
    gc_root(strlit5690);
  }
// compiled string node returning strlit5690 (depth = 15)
  int op_slot_left_5688 = gc_frame_newslot(strlit5690);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult5691 = callmethod(strlit5690, "++", 1, partcv, params);
// compiled op node returning opresult5691 (depth = 14)
  int op_slot_left_5685 = gc_frame_newslot(opresult5691);
  params[0] = strlit5686;
  partcv[0] = 1;
  Object opresult5692 = callmethod(opresult5691, "++", 1, partcv, params);
// compiled op node returning opresult5692 (depth = 13)
  int op_slot_left_5683 = gc_frame_newslot(opresult5692);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5693 = callmethod(opresult5692, "++", 1, partcv, params);
// compiled op node returning opresult5693 (depth = 12)
  int op_slot_left_5680 = gc_frame_newslot(opresult5693);
  params[0] = strlit5681;
  partcv[0] = 1;
  Object opresult5694 = callmethod(opresult5693, "++", 1, partcv, params);
// compiled op node returning opresult5694 (depth = 11)
  int op_slot_left_5672 = gc_frame_newslot(opresult5694);
  params[0] = call5678;
  partcv[0] = 1;
  Object opresult5695 = callmethod(opresult5694, "++", 1, partcv, params);
// compiled op node returning opresult5695 (depth = 10)
  int op_slot_left_5669 = gc_frame_newslot(opresult5695);
  params[0] = strlit5670;
  partcv[0] = 1;
  Object opresult5696 = callmethod(opresult5695, "++", 1, partcv, params);
// compiled op node returning opresult5696 (depth = 9)
  *var_s = opresult5696;
  if (opresult5696 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply5622(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object *var_depth = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1248
  setline(1248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5624 == NULL) {
    strlit5624 = alloc_String("");
    gc_root(strlit5624);
  }
// compiled string node returning strlit5624 (depth = 8)
  int op_slot_right_5623 = gc_frame_newslot(strlit5624);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5627 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_part (depth = 11)
  partcv[0] = 0;
  Object call5628 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe5627);
// compiled call node returning call5628 (depth = 10)
// compiled member node returning call5628 (depth = 9)
  int op_slot_right_5626 = gc_frame_newslot(call5628);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit5631 == NULL) {
    strlit5631 = alloc_String("Part: ");
    gc_root(strlit5631);
  }
// compiled string node returning strlit5631 (depth = 10)
  int op_slot_right_5630 = gc_frame_newslot(strlit5631);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_5633 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit5636 == NULL) {
    strlit5636 = alloc_String("""\x0a""  ");
    gc_root(strlit5636);
  }
// compiled string node returning strlit5636 (depth = 12)
  int op_slot_right_5635 = gc_frame_newslot(strlit5636);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_s (depth = 13)
  int op_slot_right_5638 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 13)
  if (strlit5640 == NULL) {
    strlit5640 = alloc_String("");
    gc_root(strlit5640);
  }
// compiled string node returning strlit5640 (depth = 13)
  int op_slot_left_5638 = gc_frame_newslot(strlit5640);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult5641 = callmethod(strlit5640, "++", 1, partcv, params);
// compiled op node returning opresult5641 (depth = 12)
  int op_slot_left_5635 = gc_frame_newslot(opresult5641);
  params[0] = strlit5636;
  partcv[0] = 1;
  Object opresult5642 = callmethod(opresult5641, "++", 1, partcv, params);
// compiled op node returning opresult5642 (depth = 11)
  int op_slot_left_5633 = gc_frame_newslot(opresult5642);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5643 = callmethod(opresult5642, "++", 1, partcv, params);
// compiled op node returning opresult5643 (depth = 10)
  int op_slot_left_5630 = gc_frame_newslot(opresult5643);
  params[0] = strlit5631;
  partcv[0] = 1;
  Object opresult5644 = callmethod(opresult5643, "++", 1, partcv, params);
// compiled op node returning opresult5644 (depth = 9)
  int op_slot_left_5626 = gc_frame_newslot(opresult5644);
  params[0] = call5628;
  partcv[0] = 1;
  Object opresult5645 = callmethod(opresult5644, "++", 1, partcv, params);
// compiled op node returning opresult5645 (depth = 8)
  int op_slot_left_5623 = gc_frame_newslot(opresult5645);
  params[0] = strlit5624;
  partcv[0] = 1;
  Object opresult5646 = callmethod(opresult5645, "++", 1, partcv, params);
// compiled op node returning opresult5646 (depth = 7)
  *var_s = opresult5646;
  if (opresult5646 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1249
  setline(1249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5649 == NULL) {
    strlit5649 = alloc_String("Parameters:");
    gc_root(strlit5649);
  }
// compiled string node returning strlit5649 (depth = 8)
  int op_slot_right_5648 = gc_frame_newslot(strlit5649);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_5651 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit5654 == NULL) {
    strlit5654 = alloc_String("""\x0a""    ");
    gc_root(strlit5654);
  }
// compiled string node returning strlit5654 (depth = 10)
  int op_slot_right_5653 = gc_frame_newslot(strlit5654);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_right_5656 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 11)
  if (strlit5658 == NULL) {
    strlit5658 = alloc_String("");
    gc_root(strlit5658);
  }
// compiled string node returning strlit5658 (depth = 11)
  int op_slot_left_5656 = gc_frame_newslot(strlit5658);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult5659 = callmethod(strlit5658, "++", 1, partcv, params);
// compiled op node returning opresult5659 (depth = 10)
  int op_slot_left_5653 = gc_frame_newslot(opresult5659);
  params[0] = strlit5654;
  partcv[0] = 1;
  Object opresult5660 = callmethod(opresult5659, "++", 1, partcv, params);
// compiled op node returning opresult5660 (depth = 9)
  int op_slot_left_5651 = gc_frame_newslot(opresult5660);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5661 = callmethod(opresult5660, "++", 1, partcv, params);
// compiled op node returning opresult5661 (depth = 8)
  int op_slot_left_5648 = gc_frame_newslot(opresult5661);
  params[0] = strlit5649;
  partcv[0] = 1;
  Object opresult5662 = callmethod(opresult5661, "++", 1, partcv, params);
// compiled op node returning opresult5662 (depth = 7)
  *var_s = opresult5662;
  if (opresult5662 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1250
  setline(1250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5664 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5665 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  partcv[0] = 0;
  Object call5666 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe5665);
// compiled call node returning call5666 (depth = 8)
// compiled member node returning call5666 (depth = 7)
  gc_frame_newslot(call5666);
// starting to compile block node (depth = 7)
  Object block5667 = alloc_Block(NULL, NULL, "ast", 1250);
  gc_frame_newslot(block5667);
// method _apply
  block_savedest(block5667);
  Object closure5668 = createclosure(4, "_apply");
  setclosureframe(closure5668, stackframe);
  addtoclosure(closure5668, var_depth);
  addtoclosure(closure5668, var_spc);
  addtoclosure(closure5668, var_s);
  addtoclosure(closure5668, selfslot);
  struct UserObject *uo5668 = (struct UserObject*)block5667;
  uo5668->data[0] = (Object)closure5668;
  Method *meth_meth_ast__apply5668 = addmethod2pos(block5667, "_apply", &meth_ast__apply5668, 0);
  int argcv_meth_ast__apply5668[] = {1};
  meth_meth_ast__apply5668->type = alloc_MethodType(1, argcv_meth_ast__apply5668);
  meth_meth_ast__apply5668->definitionModule = modulename;
  meth_meth_ast__apply5668->definitionLine = 1250;
// compiled block node returning block5667 (depth = 7)
  gc_frame_newslot(block5667);
// call case 5: prelude request
  params[0] = call5666;
  params[1] = block5667;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5699 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5664);
// compiled call node returning call5699 (depth = 6)
// Begin line 1253
  setline(1253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool5702 = alloc_Boolean(0);
// compiled identifier node returning bool5702 (depth = 8)
  int op_slot_right_5701 = gc_frame_newslot(bool5702);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5704 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_part (depth = 10)
  partcv[0] = 0;
  Object call5705 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe5704);
// compiled call node returning call5705 (depth = 9)
// compiled member node returning call5705 (depth = 8)
  int op_slot_left_5701 = gc_frame_newslot(call5705);
  params[0] = bool5702;
  partcv[0] = 1;
  Object opresult5706 = callmethod(call5705, "!=", 1, partcv, params);
// compiled op node returning opresult5706 (depth = 7)
  Object if5700 = done;
  if (istrue(opresult5706)) {
// Begin line 1254
  setline(1254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5708 == NULL) {
    strlit5708 = alloc_String("");
    gc_root(strlit5708);
  }
// compiled string node returning strlit5708 (depth = 9)
  int op_slot_right_5707 = gc_frame_newslot(strlit5708);
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5711 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num5713 = alloc_Float64(3);
// compiled num node returning num5713 (depth = 12)
  int op_slot_right_5712 = gc_frame_newslot(num5713);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_depth (depth = 12)
  int op_slot_left_5712 = gc_frame_newslot(*var_depth);
  params[0] = num5713;
  partcv[0] = 1;
  Object sum5715 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum5715 (depth = 11)
  gc_frame_newslot(sum5715);
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe5716 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_part (depth = 13)
  partcv[0] = 0;
  Object call5717 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe5716);
// compiled call node returning call5717 (depth = 12)
// compiled member node returning call5717 (depth = 11)
  params[0] = sum5715;
  partcv[0] = 1;
  Object call5718 = callmethod(call5717, "pretty",
    1, partcv, params);
  gc_frame_end(callframe5711);
// compiled call node returning call5718 (depth = 10)
  int op_slot_right_5710 = gc_frame_newslot(call5718);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit5721 == NULL) {
    strlit5721 = alloc_String("Vararg: ");
    gc_root(strlit5721);
  }
// compiled string node returning strlit5721 (depth = 11)
  int op_slot_right_5720 = gc_frame_newslot(strlit5721);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_spc (depth = 12)
  int op_slot_right_5723 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit5726 == NULL) {
    strlit5726 = alloc_String("""\x0a""    ");
    gc_root(strlit5726);
  }
// compiled string node returning strlit5726 (depth = 13)
  int op_slot_right_5725 = gc_frame_newslot(strlit5726);
// starting to compile op node (depth = 13)
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_s (depth = 14)
  int op_slot_right_5728 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 14)
  if (strlit5730 == NULL) {
    strlit5730 = alloc_String("");
    gc_root(strlit5730);
  }
// compiled string node returning strlit5730 (depth = 14)
  int op_slot_left_5728 = gc_frame_newslot(strlit5730);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult5731 = callmethod(strlit5730, "++", 1, partcv, params);
// compiled op node returning opresult5731 (depth = 13)
  int op_slot_left_5725 = gc_frame_newslot(opresult5731);
  params[0] = strlit5726;
  partcv[0] = 1;
  Object opresult5732 = callmethod(opresult5731, "++", 1, partcv, params);
// compiled op node returning opresult5732 (depth = 12)
  int op_slot_left_5723 = gc_frame_newslot(opresult5732);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5733 = callmethod(opresult5732, "++", 1, partcv, params);
// compiled op node returning opresult5733 (depth = 11)
  int op_slot_left_5720 = gc_frame_newslot(opresult5733);
  params[0] = strlit5721;
  partcv[0] = 1;
  Object opresult5734 = callmethod(opresult5733, "++", 1, partcv, params);
// compiled op node returning opresult5734 (depth = 10)
  int op_slot_left_5710 = gc_frame_newslot(opresult5734);
  params[0] = call5718;
  partcv[0] = 1;
  Object opresult5735 = callmethod(opresult5734, "++", 1, partcv, params);
// compiled op node returning opresult5735 (depth = 9)
  int op_slot_left_5707 = gc_frame_newslot(opresult5735);
  params[0] = strlit5708;
  partcv[0] = 1;
  Object opresult5736 = callmethod(opresult5735, "++", 1, partcv, params);
// compiled op node returning opresult5736 (depth = 8)
  *var_s = opresult5736;
  if (opresult5736 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if5700 = done;
  } else {
  }
// compiled if node returning if5700 (depth = 6)
  gc_frame_end(frame);
  return if5700;
}
Object meth_ast__apply5795(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1264
  setline(1264);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit5798 == NULL) {
    strlit5798 = alloc_String("");
    gc_root(strlit5798);
  }
// compiled string node returning strlit5798 (depth = 10)
  int op_slot_right_5797 = gc_frame_newslot(strlit5798);
// starting to compile op node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe5801 = gc_frame_new();
// starting to compile op node (depth = 12)
// starting to compile num node (depth = 13)
  Object num5803 = alloc_Float64(2);
// compiled num node returning num5803 (depth = 13)
  int op_slot_right_5802 = gc_frame_newslot(num5803);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_depth (depth = 13)
  int op_slot_left_5802 = gc_frame_newslot(*var_depth);
  params[0] = num5803;
  partcv[0] = 1;
  Object sum5805 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum5805 (depth = 12)
  gc_frame_newslot(sum5805);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_a (depth = 12)
  params[0] = sum5805;
  partcv[0] = 1;
  Object call5806 = callmethod(*var_a, "pretty",
    1, partcv, params);
  gc_frame_end(callframe5801);
// compiled call node returning call5806 (depth = 11)
  int op_slot_right_5800 = gc_frame_newslot(call5806);
// starting to compile string node (depth = 11)
  if (strlit5808 == NULL) {
    strlit5808 = alloc_String(" ");
    gc_root(strlit5808);
  }
// compiled string node returning strlit5808 (depth = 11)
  int op_slot_left_5800 = gc_frame_newslot(strlit5808);
  params[0] = call5806;
  partcv[0] = 1;
  Object opresult5809 = callmethod(strlit5808, "++", 1, partcv, params);
// compiled op node returning opresult5809 (depth = 10)
  int op_slot_left_5797 = gc_frame_newslot(opresult5809);
  params[0] = strlit5798;
  partcv[0] = 1;
  Object opresult5810 = callmethod(opresult5809, "++", 1, partcv, params);
// compiled op node returning opresult5810 (depth = 9)
  int op_slot_right_5796 = gc_frame_newslot(opresult5810);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_5796 = gc_frame_newslot(*var_s);
  params[0] = opresult5810;
  partcv[0] = 1;
  Object opresult5812 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5812 (depth = 8)
  *var_s = opresult5812;
  if (opresult5812 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply5832(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1269
  setline(1269);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5834 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num5836 = alloc_Float64(2);
// compiled num node returning num5836 (depth = 10)
  int op_slot_right_5835 = gc_frame_newslot(num5836);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_5835 = gc_frame_newslot(*var_depth);
  params[0] = num5836;
  partcv[0] = 1;
  Object sum5838 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum5838 (depth = 9)
  gc_frame_newslot(sum5838);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_x (depth = 9)
  params[0] = sum5838;
  partcv[0] = 1;
  Object call5839 = callmethod(*var_x, "pretty",
    1, partcv, params);
  gc_frame_end(callframe5834);
// compiled call node returning call5839 (depth = 8)
  int op_slot_right_5833 = gc_frame_newslot(call5839);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_5841 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit5844 == NULL) {
    strlit5844 = alloc_String("""\x0a""  ");
    gc_root(strlit5844);
  }
// compiled string node returning strlit5844 (depth = 10)
  int op_slot_right_5843 = gc_frame_newslot(strlit5844);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_5843 = gc_frame_newslot(*var_s);
  params[0] = strlit5844;
  partcv[0] = 1;
  Object opresult5846 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5846 (depth = 9)
  int op_slot_left_5841 = gc_frame_newslot(opresult5846);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5847 = callmethod(opresult5846, "++", 1, partcv, params);
// compiled op node returning opresult5847 (depth = 8)
  int op_slot_left_5833 = gc_frame_newslot(opresult5847);
  params[0] = call5839;
  partcv[0] = 1;
  Object opresult5848 = callmethod(opresult5847, "++", 1, partcv, params);
// compiled op node returning opresult5848 (depth = 7)
  *var_s = opresult5848;
  if (opresult5848 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty5269(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 25, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1225
  setline(1225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5270 == NULL) {
    strlit5270 = alloc_String("");
    gc_root(strlit5270);
  }
// compiled string node returning strlit5270 (depth = 5)
  *var_spc = strlit5270;
  if (strlit5270 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1226
  setline(1226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5271 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_right_5272 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 6)
  Object num5274 = alloc_Float64(0);
// compiled num node returning num5274 (depth = 6)
  int op_slot_left_5272 = gc_frame_newslot(num5274);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult5275 = callmethod(num5274, "..", 1, partcv, params);
// compiled op node returning opresult5275 (depth = 5)
  gc_frame_newslot(opresult5275);
// starting to compile block node (depth = 5)
  Object block5276 = alloc_Block(NULL, NULL, "ast", 1226);
  gc_frame_newslot(block5276);
// method _apply
  block_savedest(block5276);
  Object closure5277 = createclosure(2, "_apply");
  setclosureframe(closure5277, stackframe);
  addtoclosure(closure5277, var_spc);
  addtoclosure(closure5277, selfslot);
  struct UserObject *uo5277 = (struct UserObject*)block5276;
  uo5277->data[0] = (Object)closure5277;
  Method *meth_meth_ast__apply5277 = addmethod2pos(block5276, "_apply", &meth_ast__apply5277, 0);
  int argcv_meth_ast__apply5277[] = {1};
  meth_meth_ast__apply5277->type = alloc_MethodType(1, argcv_meth_ast__apply5277);
  meth_meth_ast__apply5277->definitionModule = modulename;
  meth_meth_ast__apply5277->definitionLine = 1221;
// compiled block node returning block5276 (depth = 5)
  gc_frame_newslot(block5276);
// call case 5: prelude request
  params[0] = opresult5275;
  params[1] = block5276;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5284 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5271);
// compiled call node returning call5284 (depth = 4)
// Begin line 1229
  setline(1229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5286 == NULL) {
    strlit5286 = alloc_String("""\x0a""");
    gc_root(strlit5286);
  }
// compiled string node returning strlit5286 (depth = 6)
  int op_slot_right_5285 = gc_frame_newslot(strlit5286);
// starting to compile call node (depth = 6)
  int callframe5288 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call5289 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe5288);
// compiled call node returning call5289 (depth = 6)
  int op_slot_left_5285 = gc_frame_newslot(call5289);
  params[0] = strlit5286;
  partcv[0] = 1;
  Object opresult5290 = callmethod(call5289, "++", 1, partcv, params);
// compiled op node returning opresult5290 (depth = 5)
  *var_s = opresult5290;
  if (opresult5290 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1230
  setline(1230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5292 == NULL) {
    strlit5292 = alloc_String("");
    gc_root(strlit5292);
  }
// compiled string node returning strlit5292 (depth = 6)
  int op_slot_right_5291 = gc_frame_newslot(strlit5292);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5295 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num5296 = alloc_Float64(0);
// compiled num node returning num5296 (depth = 8)
  gc_frame_newslot(num5296);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5297 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5298 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5297);
// compiled call node returning call5298 (depth = 9)
// compiled member node returning call5298 (depth = 8)
  params[0] = num5296;
  partcv[0] = 1;
  Object call5299 = callmethod(call5298, "pretty",
    1, partcv, params);
  gc_frame_end(callframe5295);
// compiled call node returning call5299 (depth = 7)
  int op_slot_right_5294 = gc_frame_newslot(call5299);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5302 == NULL) {
    strlit5302 = alloc_String("Name: ");
    gc_root(strlit5302);
  }
// compiled string node returning strlit5302 (depth = 8)
  int op_slot_right_5301 = gc_frame_newslot(strlit5302);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_5304 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit5307 == NULL) {
    strlit5307 = alloc_String("");
    gc_root(strlit5307);
  }
// compiled string node returning strlit5307 (depth = 10)
  int op_slot_right_5306 = gc_frame_newslot(strlit5307);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_right_5309 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 11)
  if (strlit5311 == NULL) {
    strlit5311 = alloc_String("");
    gc_root(strlit5311);
  }
// compiled string node returning strlit5311 (depth = 11)
  int op_slot_left_5309 = gc_frame_newslot(strlit5311);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult5312 = callmethod(strlit5311, "++", 1, partcv, params);
// compiled op node returning opresult5312 (depth = 10)
  int op_slot_left_5306 = gc_frame_newslot(opresult5312);
  params[0] = strlit5307;
  partcv[0] = 1;
  Object opresult5313 = callmethod(opresult5312, "++", 1, partcv, params);
// compiled op node returning opresult5313 (depth = 9)
  int op_slot_left_5304 = gc_frame_newslot(opresult5313);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5314 = callmethod(opresult5313, "++", 1, partcv, params);
// compiled op node returning opresult5314 (depth = 8)
  int op_slot_left_5301 = gc_frame_newslot(opresult5314);
  params[0] = strlit5302;
  partcv[0] = 1;
  Object opresult5315 = callmethod(opresult5314, "++", 1, partcv, params);
// compiled op node returning opresult5315 (depth = 7)
  int op_slot_left_5294 = gc_frame_newslot(opresult5315);
  params[0] = call5299;
  partcv[0] = 1;
  Object opresult5316 = callmethod(opresult5315, "++", 1, partcv, params);
// compiled op node returning opresult5316 (depth = 6)
  int op_slot_left_5291 = gc_frame_newslot(opresult5316);
  params[0] = strlit5292;
  partcv[0] = 1;
  Object opresult5317 = callmethod(opresult5316, "++", 1, partcv, params);
// compiled op node returning opresult5317 (depth = 5)
  *var_s = opresult5317;
  if (opresult5317 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1231
  setline(1231);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5321 == NULL) {
    strlit5321 = alloc_String("symbols");
    gc_root(strlit5321);
  }
// compiled string node returning strlit5321 (depth = 6)
  int op_slot_right_5320 = gc_frame_newslot(strlit5321);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5323 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_util (depth = 8)
  partcv[0] = 0;
  Object call5324 = callmethod(*var_util, "target",
    1, partcv, params);
  gc_frame_end(callframe5323);
// compiled call node returning call5324 (depth = 7)
// compiled member node returning call5324 (depth = 6)
  int op_slot_left_5320 = gc_frame_newslot(call5324);
  params[0] = strlit5321;
  partcv[0] = 1;
  Object opresult5325 = callmethod(call5324, "==", 1, partcv, params);
// compiled op node returning opresult5325 (depth = 5)
  Object if5319 = done;
  if (istrue(opresult5325)) {
// Begin line 1232
  setline(1232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5328 == NULL) {
    strlit5328 = alloc_String("");
    gc_root(strlit5328);
  }
// compiled string node returning strlit5328 (depth = 8)
  int op_slot_right_5327 = gc_frame_newslot(strlit5328);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5331 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe5332 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5333 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5332);
// compiled call node returning call5333 (depth = 12)
// compiled member node returning call5333 (depth = 11)
  partcv[0] = 0;
  Object call5334 = callmethod(call5333, "asString",
    1, partcv, params);
  gc_frame_end(callframe5331);
// compiled call node returning call5334 (depth = 10)
// compiled member node returning call5334 (depth = 9)
  int op_slot_right_5330 = gc_frame_newslot(call5334);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit5337 == NULL) {
    strlit5337 = alloc_String("): ");
    gc_root(strlit5337);
  }
// compiled string node returning strlit5337 (depth = 10)
  int op_slot_right_5336 = gc_frame_newslot(strlit5337);
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe5340 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe5341 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5342 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5341);
// compiled call node returning call5342 (depth = 14)
// compiled member node returning call5342 (depth = 13)
  partcv[0] = 0;
  Object call5343 = callmethod(call5342, "variety",
    1, partcv, params);
  gc_frame_end(callframe5340);
// compiled call node returning call5343 (depth = 12)
// compiled member node returning call5343 (depth = 11)
  int op_slot_right_5339 = gc_frame_newslot(call5343);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit5346 == NULL) {
    strlit5346 = alloc_String("Inner object symbols(");
    gc_root(strlit5346);
  }
// compiled string node returning strlit5346 (depth = 12)
  int op_slot_right_5345 = gc_frame_newslot(strlit5346);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_spc (depth = 13)
  int op_slot_right_5348 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 13)
  if (strlit5350 == NULL) {
    strlit5350 = alloc_String("""\x0a""");
    gc_root(strlit5350);
  }
// compiled string node returning strlit5350 (depth = 13)
  int op_slot_left_5348 = gc_frame_newslot(strlit5350);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5351 = callmethod(strlit5350, "++", 1, partcv, params);
// compiled op node returning opresult5351 (depth = 12)
  int op_slot_left_5345 = gc_frame_newslot(opresult5351);
  params[0] = strlit5346;
  partcv[0] = 1;
  Object opresult5352 = callmethod(opresult5351, "++", 1, partcv, params);
// compiled op node returning opresult5352 (depth = 11)
  int op_slot_left_5339 = gc_frame_newslot(opresult5352);
  params[0] = call5343;
  partcv[0] = 1;
  Object opresult5353 = callmethod(opresult5352, "++", 1, partcv, params);
// compiled op node returning opresult5353 (depth = 10)
  int op_slot_left_5336 = gc_frame_newslot(opresult5353);
  params[0] = strlit5337;
  partcv[0] = 1;
  Object opresult5354 = callmethod(opresult5353, "++", 1, partcv, params);
// compiled op node returning opresult5354 (depth = 9)
  int op_slot_left_5330 = gc_frame_newslot(opresult5354);
  params[0] = call5334;
  partcv[0] = 1;
  Object opresult5355 = callmethod(opresult5354, "++", 1, partcv, params);
// compiled op node returning opresult5355 (depth = 8)
  int op_slot_left_5327 = gc_frame_newslot(opresult5355);
  params[0] = strlit5328;
  partcv[0] = 1;
  Object opresult5356 = callmethod(opresult5355, "++", 1, partcv, params);
// compiled op node returning opresult5356 (depth = 7)
  int op_slot_right_5326 = gc_frame_newslot(opresult5356);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_5326 = gc_frame_newslot(*var_s);
  params[0] = opresult5356;
  partcv[0] = 1;
  Object opresult5358 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5358 (depth = 6)
  *var_s = opresult5358;
  if (opresult5358 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1233
  setline(1233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5362 == NULL) {
    strlit5362 = alloc_String("");
    gc_root(strlit5362);
  }
// compiled string node returning strlit5362 (depth = 8)
  int op_slot_right_5361 = gc_frame_newslot(strlit5362);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5365 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe5366 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe5367 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5368 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5367);
// compiled call node returning call5368 (depth = 14)
// compiled member node returning call5368 (depth = 13)
  partcv[0] = 0;
  Object call5369 = callmethod(call5368, "parent",
    1, partcv, params);
  gc_frame_end(callframe5366);
// compiled call node returning call5369 (depth = 12)
// compiled member node returning call5369 (depth = 11)
  partcv[0] = 0;
  Object call5370 = callmethod(call5369, "asString",
    1, partcv, params);
  gc_frame_end(callframe5365);
// compiled call node returning call5370 (depth = 10)
// compiled member node returning call5370 (depth = 9)
  int op_slot_right_5364 = gc_frame_newslot(call5370);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit5373 == NULL) {
    strlit5373 = alloc_String("): ");
    gc_root(strlit5373);
  }
// compiled string node returning strlit5373 (depth = 10)
  int op_slot_right_5372 = gc_frame_newslot(strlit5373);
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe5376 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe5377 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe5378 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5379 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5378);
// compiled call node returning call5379 (depth = 16)
// compiled member node returning call5379 (depth = 15)
  partcv[0] = 0;
  Object call5380 = callmethod(call5379, "parent",
    1, partcv, params);
  gc_frame_end(callframe5377);
// compiled call node returning call5380 (depth = 14)
// compiled member node returning call5380 (depth = 13)
  partcv[0] = 0;
  Object call5381 = callmethod(call5380, "variety",
    1, partcv, params);
  gc_frame_end(callframe5376);
// compiled call node returning call5381 (depth = 12)
// compiled member node returning call5381 (depth = 11)
  int op_slot_right_5375 = gc_frame_newslot(call5381);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit5384 == NULL) {
    strlit5384 = alloc_String("Factory method symbols(");
    gc_root(strlit5384);
  }
// compiled string node returning strlit5384 (depth = 12)
  int op_slot_right_5383 = gc_frame_newslot(strlit5384);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_spc (depth = 13)
  int op_slot_right_5386 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 13)
  if (strlit5388 == NULL) {
    strlit5388 = alloc_String("""\x0a""");
    gc_root(strlit5388);
  }
// compiled string node returning strlit5388 (depth = 13)
  int op_slot_left_5386 = gc_frame_newslot(strlit5388);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5389 = callmethod(strlit5388, "++", 1, partcv, params);
// compiled op node returning opresult5389 (depth = 12)
  int op_slot_left_5383 = gc_frame_newslot(opresult5389);
  params[0] = strlit5384;
  partcv[0] = 1;
  Object opresult5390 = callmethod(opresult5389, "++", 1, partcv, params);
// compiled op node returning opresult5390 (depth = 11)
  int op_slot_left_5375 = gc_frame_newslot(opresult5390);
  params[0] = call5381;
  partcv[0] = 1;
  Object opresult5391 = callmethod(opresult5390, "++", 1, partcv, params);
// compiled op node returning opresult5391 (depth = 10)
  int op_slot_left_5372 = gc_frame_newslot(opresult5391);
  params[0] = strlit5373;
  partcv[0] = 1;
  Object opresult5392 = callmethod(opresult5391, "++", 1, partcv, params);
// compiled op node returning opresult5392 (depth = 9)
  int op_slot_left_5364 = gc_frame_newslot(opresult5392);
  params[0] = call5370;
  partcv[0] = 1;
  Object opresult5393 = callmethod(opresult5392, "++", 1, partcv, params);
// compiled op node returning opresult5393 (depth = 8)
  int op_slot_left_5361 = gc_frame_newslot(opresult5393);
  params[0] = strlit5362;
  partcv[0] = 1;
  Object opresult5394 = callmethod(opresult5393, "++", 1, partcv, params);
// compiled op node returning opresult5394 (depth = 7)
  int op_slot_right_5360 = gc_frame_newslot(opresult5394);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_5360 = gc_frame_newslot(*var_s);
  params[0] = opresult5394;
  partcv[0] = 1;
  Object opresult5396 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5396 (depth = 6)
  *var_s = opresult5396;
  if (opresult5396 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1234
  setline(1234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5400 == NULL) {
    strlit5400 = alloc_String("");
    gc_root(strlit5400);
  }
// compiled string node returning strlit5400 (depth = 8)
  int op_slot_right_5399 = gc_frame_newslot(strlit5400);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5403 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe5404 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe5405 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe5406 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5407 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5406);
// compiled call node returning call5407 (depth = 16)
// compiled member node returning call5407 (depth = 15)
  partcv[0] = 0;
  Object call5408 = callmethod(call5407, "parent",
    1, partcv, params);
  gc_frame_end(callframe5405);
// compiled call node returning call5408 (depth = 14)
// compiled member node returning call5408 (depth = 13)
  partcv[0] = 0;
  Object call5409 = callmethod(call5408, "parent",
    1, partcv, params);
  gc_frame_end(callframe5404);
// compiled call node returning call5409 (depth = 12)
// compiled member node returning call5409 (depth = 11)
  partcv[0] = 0;
  Object call5410 = callmethod(call5409, "asString",
    1, partcv, params);
  gc_frame_end(callframe5403);
// compiled call node returning call5410 (depth = 10)
// compiled member node returning call5410 (depth = 9)
  int op_slot_right_5402 = gc_frame_newslot(call5410);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit5413 == NULL) {
    strlit5413 = alloc_String("): ");
    gc_root(strlit5413);
  }
// compiled string node returning strlit5413 (depth = 10)
  int op_slot_right_5412 = gc_frame_newslot(strlit5413);
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe5416 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe5417 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe5418 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 17)
// starting to compile call node (depth = 18)
  int callframe5419 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5420 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5419);
// compiled call node returning call5420 (depth = 18)
// compiled member node returning call5420 (depth = 17)
  partcv[0] = 0;
  Object call5421 = callmethod(call5420, "parent",
    1, partcv, params);
  gc_frame_end(callframe5418);
// compiled call node returning call5421 (depth = 16)
// compiled member node returning call5421 (depth = 15)
  partcv[0] = 0;
  Object call5422 = callmethod(call5421, "parent",
    1, partcv, params);
  gc_frame_end(callframe5417);
// compiled call node returning call5422 (depth = 14)
// compiled member node returning call5422 (depth = 13)
  partcv[0] = 0;
  Object call5423 = callmethod(call5422, "variety",
    1, partcv, params);
  gc_frame_end(callframe5416);
// compiled call node returning call5423 (depth = 12)
// compiled member node returning call5423 (depth = 11)
  int op_slot_right_5415 = gc_frame_newslot(call5423);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit5426 == NULL) {
    strlit5426 = alloc_String("Outer object symbols(");
    gc_root(strlit5426);
  }
// compiled string node returning strlit5426 (depth = 12)
  int op_slot_right_5425 = gc_frame_newslot(strlit5426);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_spc (depth = 13)
  int op_slot_right_5428 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 13)
  if (strlit5430 == NULL) {
    strlit5430 = alloc_String("""\x0a""");
    gc_root(strlit5430);
  }
// compiled string node returning strlit5430 (depth = 13)
  int op_slot_left_5428 = gc_frame_newslot(strlit5430);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5431 = callmethod(strlit5430, "++", 1, partcv, params);
// compiled op node returning opresult5431 (depth = 12)
  int op_slot_left_5425 = gc_frame_newslot(opresult5431);
  params[0] = strlit5426;
  partcv[0] = 1;
  Object opresult5432 = callmethod(opresult5431, "++", 1, partcv, params);
// compiled op node returning opresult5432 (depth = 11)
  int op_slot_left_5415 = gc_frame_newslot(opresult5432);
  params[0] = call5423;
  partcv[0] = 1;
  Object opresult5433 = callmethod(opresult5432, "++", 1, partcv, params);
// compiled op node returning opresult5433 (depth = 10)
  int op_slot_left_5412 = gc_frame_newslot(opresult5433);
  params[0] = strlit5413;
  partcv[0] = 1;
  Object opresult5434 = callmethod(opresult5433, "++", 1, partcv, params);
// compiled op node returning opresult5434 (depth = 9)
  int op_slot_left_5402 = gc_frame_newslot(opresult5434);
  params[0] = call5410;
  partcv[0] = 1;
  Object opresult5435 = callmethod(opresult5434, "++", 1, partcv, params);
// compiled op node returning opresult5435 (depth = 8)
  int op_slot_left_5399 = gc_frame_newslot(opresult5435);
  params[0] = strlit5400;
  partcv[0] = 1;
  Object opresult5436 = callmethod(opresult5435, "++", 1, partcv, params);
// compiled op node returning opresult5436 (depth = 7)
  int op_slot_right_5398 = gc_frame_newslot(opresult5436);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_5398 = gc_frame_newslot(*var_s);
  params[0] = opresult5436;
  partcv[0] = 1;
  Object opresult5438 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5438 (depth = 6)
  *var_s = opresult5438;
  if (opresult5438 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1235
  setline(1235);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5442 == NULL) {
    strlit5442 = alloc_String("");
    gc_root(strlit5442);
  }
// compiled string node returning strlit5442 (depth = 8)
  int op_slot_right_5441 = gc_frame_newslot(strlit5442);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5445 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe5446 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe5447 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe5448 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 17)
// starting to compile call node (depth = 18)
  int callframe5449 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5450 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5449);
// compiled call node returning call5450 (depth = 18)
// compiled member node returning call5450 (depth = 17)
  partcv[0] = 0;
  Object call5451 = callmethod(call5450, "parent",
    1, partcv, params);
  gc_frame_end(callframe5448);
// compiled call node returning call5451 (depth = 16)
// compiled member node returning call5451 (depth = 15)
  partcv[0] = 0;
  Object call5452 = callmethod(call5451, "parent",
    1, partcv, params);
  gc_frame_end(callframe5447);
// compiled call node returning call5452 (depth = 14)
// compiled member node returning call5452 (depth = 13)
  partcv[0] = 0;
  Object call5453 = callmethod(call5452, "parent",
    1, partcv, params);
  gc_frame_end(callframe5446);
// compiled call node returning call5453 (depth = 12)
// compiled member node returning call5453 (depth = 11)
  partcv[0] = 0;
  Object call5454 = callmethod(call5453, "asDebugString",
    1, partcv, params);
  gc_frame_end(callframe5445);
// compiled call node returning call5454 (depth = 10)
// compiled member node returning call5454 (depth = 9)
  int op_slot_right_5444 = gc_frame_newslot(call5454);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit5457 == NULL) {
    strlit5457 = alloc_String("): ");
    gc_root(strlit5457);
  }
// compiled string node returning strlit5457 (depth = 10)
  int op_slot_right_5456 = gc_frame_newslot(strlit5457);
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe5460 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe5461 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe5462 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 17)
// starting to compile call node (depth = 18)
  int callframe5463 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 19)
// starting to compile call node (depth = 20)
  int callframe5464 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5465 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5464);
// compiled call node returning call5465 (depth = 20)
// compiled member node returning call5465 (depth = 19)
  partcv[0] = 0;
  Object call5466 = callmethod(call5465, "parent",
    1, partcv, params);
  gc_frame_end(callframe5463);
// compiled call node returning call5466 (depth = 18)
// compiled member node returning call5466 (depth = 17)
  partcv[0] = 0;
  Object call5467 = callmethod(call5466, "parent",
    1, partcv, params);
  gc_frame_end(callframe5462);
// compiled call node returning call5467 (depth = 16)
// compiled member node returning call5467 (depth = 15)
  partcv[0] = 0;
  Object call5468 = callmethod(call5467, "parent",
    1, partcv, params);
  gc_frame_end(callframe5461);
// compiled call node returning call5468 (depth = 14)
// compiled member node returning call5468 (depth = 13)
  partcv[0] = 0;
  Object call5469 = callmethod(call5468, "variety",
    1, partcv, params);
  gc_frame_end(callframe5460);
// compiled call node returning call5469 (depth = 12)
// compiled member node returning call5469 (depth = 11)
  int op_slot_right_5459 = gc_frame_newslot(call5469);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit5472 == NULL) {
    strlit5472 = alloc_String("enclosing symbols(");
    gc_root(strlit5472);
  }
// compiled string node returning strlit5472 (depth = 12)
  int op_slot_right_5471 = gc_frame_newslot(strlit5472);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_spc (depth = 13)
  int op_slot_right_5474 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 13)
  if (strlit5476 == NULL) {
    strlit5476 = alloc_String("""\x0a""");
    gc_root(strlit5476);
  }
// compiled string node returning strlit5476 (depth = 13)
  int op_slot_left_5474 = gc_frame_newslot(strlit5476);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5477 = callmethod(strlit5476, "++", 1, partcv, params);
// compiled op node returning opresult5477 (depth = 12)
  int op_slot_left_5471 = gc_frame_newslot(opresult5477);
  params[0] = strlit5472;
  partcv[0] = 1;
  Object opresult5478 = callmethod(opresult5477, "++", 1, partcv, params);
// compiled op node returning opresult5478 (depth = 11)
  int op_slot_left_5459 = gc_frame_newslot(opresult5478);
  params[0] = call5469;
  partcv[0] = 1;
  Object opresult5479 = callmethod(opresult5478, "++", 1, partcv, params);
// compiled op node returning opresult5479 (depth = 10)
  int op_slot_left_5456 = gc_frame_newslot(opresult5479);
  params[0] = strlit5457;
  partcv[0] = 1;
  Object opresult5480 = callmethod(opresult5479, "++", 1, partcv, params);
// compiled op node returning opresult5480 (depth = 9)
  int op_slot_left_5444 = gc_frame_newslot(opresult5480);
  params[0] = call5454;
  partcv[0] = 1;
  Object opresult5481 = callmethod(opresult5480, "++", 1, partcv, params);
// compiled op node returning opresult5481 (depth = 8)
  int op_slot_left_5441 = gc_frame_newslot(opresult5481);
  params[0] = strlit5442;
  partcv[0] = 1;
  Object opresult5482 = callmethod(opresult5481, "++", 1, partcv, params);
// compiled op node returning opresult5482 (depth = 7)
  int op_slot_right_5440 = gc_frame_newslot(opresult5482);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_5440 = gc_frame_newslot(*var_s);
  params[0] = opresult5482;
  partcv[0] = 1;
  Object opresult5484 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5484 (depth = 6)
  *var_s = opresult5484;
  if (opresult5484 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if5319 = done;
  } else {
  }
// compiled if node returning if5319 (depth = 4)
// Begin line 1237
  setline(1237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool5488 = alloc_Boolean(0);
// compiled identifier node returning bool5488 (depth = 6)
  int op_slot_right_5487 = gc_frame_newslot(bool5488);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5490 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5491 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5490);
// compiled call node returning call5491 (depth = 7)
// compiled member node returning call5491 (depth = 6)
  int op_slot_left_5487 = gc_frame_newslot(call5491);
  params[0] = bool5488;
  partcv[0] = 1;
  Object opresult5492 = callmethod(call5491, "!=", 1, partcv, params);
// compiled op node returning opresult5492 (depth = 5)
  Object if5486 = done;
  if (istrue(opresult5492)) {
// Begin line 1238
  setline(1238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5494 == NULL) {
    strlit5494 = alloc_String("Superclass:");
    gc_root(strlit5494);
  }
// compiled string node returning strlit5494 (depth = 7)
  int op_slot_right_5493 = gc_frame_newslot(strlit5494);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_5496 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5499 == NULL) {
    strlit5499 = alloc_String("""\x0a""");
    gc_root(strlit5499);
  }
// compiled string node returning strlit5499 (depth = 9)
  int op_slot_right_5498 = gc_frame_newslot(strlit5499);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_5498 = gc_frame_newslot(*var_s);
  params[0] = strlit5499;
  partcv[0] = 1;
  Object opresult5501 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5501 (depth = 8)
  int op_slot_left_5496 = gc_frame_newslot(opresult5501);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5502 = callmethod(opresult5501, "++", 1, partcv, params);
// compiled op node returning opresult5502 (depth = 7)
  int op_slot_left_5493 = gc_frame_newslot(opresult5502);
  params[0] = strlit5494;
  partcv[0] = 1;
  Object opresult5503 = callmethod(opresult5502, "++", 1, partcv, params);
// compiled op node returning opresult5503 (depth = 6)
  *var_s = opresult5503;
  if (opresult5503 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1239
  setline(1239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5506 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num5508 = alloc_Float64(2);
// compiled num node returning num5508 (depth = 9)
  int op_slot_right_5507 = gc_frame_newslot(num5508);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_5507 = gc_frame_newslot(*var_depth);
  params[0] = num5508;
  partcv[0] = 1;
  Object sum5510 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum5510 (depth = 8)
  gc_frame_newslot(sum5510);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5511 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5512 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5511);
// compiled call node returning call5512 (depth = 9)
// compiled member node returning call5512 (depth = 8)
  params[0] = sum5510;
  partcv[0] = 1;
  Object call5513 = callmethod(call5512, "pretty",
    1, partcv, params);
  gc_frame_end(callframe5506);
// compiled call node returning call5513 (depth = 7)
  int op_slot_right_5505 = gc_frame_newslot(call5513);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_5515 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5518 == NULL) {
    strlit5518 = alloc_String("""\x0a""  ");
    gc_root(strlit5518);
  }
// compiled string node returning strlit5518 (depth = 9)
  int op_slot_right_5517 = gc_frame_newslot(strlit5518);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_5517 = gc_frame_newslot(*var_s);
  params[0] = strlit5518;
  partcv[0] = 1;
  Object opresult5520 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5520 (depth = 8)
  int op_slot_left_5515 = gc_frame_newslot(opresult5520);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5521 = callmethod(opresult5520, "++", 1, partcv, params);
// compiled op node returning opresult5521 (depth = 7)
  int op_slot_left_5505 = gc_frame_newslot(opresult5521);
  params[0] = call5513;
  partcv[0] = 1;
  Object opresult5522 = callmethod(opresult5521, "++", 1, partcv, params);
// compiled op node returning opresult5522 (depth = 6)
  *var_s = opresult5522;
  if (opresult5522 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if5486 = done;
  } else {
  }
// compiled if node returning if5486 (depth = 4)
// Begin line 1241
  setline(1241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5525 == NULL) {
    strlit5525 = alloc_String("""\x0a""");
    gc_root(strlit5525);
  }
// compiled string node returning strlit5525 (depth = 6)
  int op_slot_right_5524 = gc_frame_newslot(strlit5525);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_5524 = gc_frame_newslot(*var_s);
  params[0] = strlit5525;
  partcv[0] = 1;
  Object opresult5527 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5527 (depth = 5)
  *var_s = opresult5527;
  if (opresult5527 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1242
  setline(1242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5530 == NULL) {
    strlit5530 = alloc_String("""\x0a""");
    gc_root(strlit5530);
  }
// compiled string node returning strlit5530 (depth = 6)
  int op_slot_right_5529 = gc_frame_newslot(strlit5530);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5533 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num5534 = alloc_Float64(0);
// compiled num node returning num5534 (depth = 8)
  gc_frame_newslot(num5534);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5535 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5536 = callmethodflags(self, "constructor", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5535);
// compiled call node returning call5536 (depth = 9)
// compiled member node returning call5536 (depth = 8)
  params[0] = num5534;
  partcv[0] = 1;
  Object call5537 = callmethod(call5536, "pretty",
    1, partcv, params);
  gc_frame_end(callframe5533);
// compiled call node returning call5537 (depth = 7)
  int op_slot_right_5532 = gc_frame_newslot(call5537);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5540 == NULL) {
    strlit5540 = alloc_String("Factory method: ");
    gc_root(strlit5540);
  }
// compiled string node returning strlit5540 (depth = 8)
  int op_slot_right_5539 = gc_frame_newslot(strlit5540);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_5542 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit5545 == NULL) {
    strlit5545 = alloc_String("");
    gc_root(strlit5545);
  }
// compiled string node returning strlit5545 (depth = 10)
  int op_slot_right_5544 = gc_frame_newslot(strlit5545);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_right_5547 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 11)
  if (strlit5549 == NULL) {
    strlit5549 = alloc_String("");
    gc_root(strlit5549);
  }
// compiled string node returning strlit5549 (depth = 11)
  int op_slot_left_5547 = gc_frame_newslot(strlit5549);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult5550 = callmethod(strlit5549, "++", 1, partcv, params);
// compiled op node returning opresult5550 (depth = 10)
  int op_slot_left_5544 = gc_frame_newslot(opresult5550);
  params[0] = strlit5545;
  partcv[0] = 1;
  Object opresult5551 = callmethod(opresult5550, "++", 1, partcv, params);
// compiled op node returning opresult5551 (depth = 9)
  int op_slot_left_5542 = gc_frame_newslot(opresult5551);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5552 = callmethod(opresult5551, "++", 1, partcv, params);
// compiled op node returning opresult5552 (depth = 8)
  int op_slot_left_5539 = gc_frame_newslot(opresult5552);
  params[0] = strlit5540;
  partcv[0] = 1;
  Object opresult5553 = callmethod(opresult5552, "++", 1, partcv, params);
// compiled op node returning opresult5553 (depth = 7)
  int op_slot_left_5532 = gc_frame_newslot(opresult5553);
  params[0] = call5537;
  partcv[0] = 1;
  Object opresult5554 = callmethod(opresult5553, "++", 1, partcv, params);
// compiled op node returning opresult5554 (depth = 6)
  int op_slot_left_5529 = gc_frame_newslot(opresult5554);
  params[0] = strlit5530;
  partcv[0] = 1;
  Object opresult5555 = callmethod(opresult5554, "++", 1, partcv, params);
// compiled op node returning opresult5555 (depth = 5)
  *var_s = opresult5555;
  if (opresult5555 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1243
  setline(1243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5559 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5560 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5559);
// compiled call node returning call5560 (depth = 7)
// compiled member node returning call5560 (depth = 6)
  int op_slot_right_5558 = gc_frame_newslot(call5560);
// starting to compile identifier node (depth = 6)
  Object bool5562 = alloc_Boolean(0);
// compiled identifier node returning bool5562 (depth = 6)
  int op_slot_left_5558 = gc_frame_newslot(bool5562);
  params[0] = call5560;
  partcv[0] = 1;
  Object opresult5563 = callmethod(bool5562, "!=", 1, partcv, params);
// compiled op node returning opresult5563 (depth = 5)
  Object if5557 = done;
  if (istrue(opresult5563)) {
// Begin line 1244
  setline(1244);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5565 == NULL) {
    strlit5565 = alloc_String("""\x0a""");
    gc_root(strlit5565);
  }
// compiled string node returning strlit5565 (depth = 7)
  int op_slot_right_5564 = gc_frame_newslot(strlit5565);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5568 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num5570 = alloc_Float64(2);
// compiled num node returning num5570 (depth = 10)
  int op_slot_right_5569 = gc_frame_newslot(num5570);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_5569 = gc_frame_newslot(*var_depth);
  params[0] = num5570;
  partcv[0] = 1;
  Object sum5572 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum5572 (depth = 9)
  gc_frame_newslot(sum5572);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5573 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5574 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5573);
// compiled call node returning call5574 (depth = 10)
// compiled member node returning call5574 (depth = 9)
  params[0] = sum5572;
  partcv[0] = 1;
  Object call5575 = callmethod(call5574, "pretty",
    1, partcv, params);
  gc_frame_end(callframe5568);
// compiled call node returning call5575 (depth = 8)
  int op_slot_right_5567 = gc_frame_newslot(call5575);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5578 == NULL) {
    strlit5578 = alloc_String("");
    gc_root(strlit5578);
  }
// compiled string node returning strlit5578 (depth = 9)
  int op_slot_right_5577 = gc_frame_newslot(strlit5578);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_5580 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit5583 == NULL) {
    strlit5583 = alloc_String("Returns:""\x0a""  ");
    gc_root(strlit5583);
  }
// compiled string node returning strlit5583 (depth = 11)
  int op_slot_right_5582 = gc_frame_newslot(strlit5583);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_spc (depth = 12)
  int op_slot_right_5585 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit5588 == NULL) {
    strlit5588 = alloc_String("");
    gc_root(strlit5588);
  }
// compiled string node returning strlit5588 (depth = 13)
  int op_slot_right_5587 = gc_frame_newslot(strlit5588);
// starting to compile op node (depth = 13)
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_s (depth = 14)
  int op_slot_right_5590 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 14)
  if (strlit5592 == NULL) {
    strlit5592 = alloc_String("");
    gc_root(strlit5592);
  }
// compiled string node returning strlit5592 (depth = 14)
  int op_slot_left_5590 = gc_frame_newslot(strlit5592);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult5593 = callmethod(strlit5592, "++", 1, partcv, params);
// compiled op node returning opresult5593 (depth = 13)
  int op_slot_left_5587 = gc_frame_newslot(opresult5593);
  params[0] = strlit5588;
  partcv[0] = 1;
  Object opresult5594 = callmethod(opresult5593, "++", 1, partcv, params);
// compiled op node returning opresult5594 (depth = 12)
  int op_slot_left_5585 = gc_frame_newslot(opresult5594);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5595 = callmethod(opresult5594, "++", 1, partcv, params);
// compiled op node returning opresult5595 (depth = 11)
  int op_slot_left_5582 = gc_frame_newslot(opresult5595);
  params[0] = strlit5583;
  partcv[0] = 1;
  Object opresult5596 = callmethod(opresult5595, "++", 1, partcv, params);
// compiled op node returning opresult5596 (depth = 10)
  int op_slot_left_5580 = gc_frame_newslot(opresult5596);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5597 = callmethod(opresult5596, "++", 1, partcv, params);
// compiled op node returning opresult5597 (depth = 9)
  int op_slot_left_5577 = gc_frame_newslot(opresult5597);
  params[0] = strlit5578;
  partcv[0] = 1;
  Object opresult5598 = callmethod(opresult5597, "++", 1, partcv, params);
// compiled op node returning opresult5598 (depth = 8)
  int op_slot_left_5567 = gc_frame_newslot(opresult5598);
  params[0] = call5575;
  partcv[0] = 1;
  Object opresult5599 = callmethod(opresult5598, "++", 1, partcv, params);
// compiled op node returning opresult5599 (depth = 7)
  int op_slot_left_5564 = gc_frame_newslot(opresult5599);
  params[0] = strlit5565;
  partcv[0] = 1;
  Object opresult5600 = callmethod(opresult5599, "++", 1, partcv, params);
// compiled op node returning opresult5600 (depth = 6)
  *var_s = opresult5600;
  if (opresult5600 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if5557 = done;
  } else {
  }
// compiled if node returning if5557 (depth = 4)
// Begin line 1246
  setline(1246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5603 == NULL) {
    strlit5603 = alloc_String("Signature:");
    gc_root(strlit5603);
  }
// compiled string node returning strlit5603 (depth = 6)
  int op_slot_right_5602 = gc_frame_newslot(strlit5603);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_5605 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5608 == NULL) {
    strlit5608 = alloc_String("");
    gc_root(strlit5608);
  }
// compiled string node returning strlit5608 (depth = 8)
  int op_slot_right_5607 = gc_frame_newslot(strlit5608);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_right_5610 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 9)
  if (strlit5612 == NULL) {
    strlit5612 = alloc_String("");
    gc_root(strlit5612);
  }
// compiled string node returning strlit5612 (depth = 9)
  int op_slot_left_5610 = gc_frame_newslot(strlit5612);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult5613 = callmethod(strlit5612, "++", 1, partcv, params);
// compiled op node returning opresult5613 (depth = 8)
  int op_slot_left_5607 = gc_frame_newslot(opresult5613);
  params[0] = strlit5608;
  partcv[0] = 1;
  Object opresult5614 = callmethod(opresult5613, "++", 1, partcv, params);
// compiled op node returning opresult5614 (depth = 7)
  int op_slot_left_5605 = gc_frame_newslot(opresult5614);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5615 = callmethod(opresult5614, "++", 1, partcv, params);
// compiled op node returning opresult5615 (depth = 6)
  int op_slot_left_5602 = gc_frame_newslot(opresult5615);
  params[0] = strlit5603;
  partcv[0] = 1;
  Object opresult5616 = callmethod(opresult5615, "++", 1, partcv, params);
// compiled op node returning opresult5616 (depth = 5)
  *var_s = opresult5616;
  if (opresult5616 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1247
  setline(1247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5618 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5619 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5620 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5619);
// compiled call node returning call5620 (depth = 6)
// compiled member node returning call5620 (depth = 5)
  gc_frame_newslot(call5620);
// starting to compile block node (depth = 5)
  Object block5621 = alloc_Block(NULL, NULL, "ast", 1247);
  gc_frame_newslot(block5621);
// method _apply
  block_savedest(block5621);
  Object closure5622 = createclosure(4, "_apply");
  setclosureframe(closure5622, stackframe);
  addtoclosure(closure5622, var_spc);
  addtoclosure(closure5622, var_s);
  addtoclosure(closure5622, var_depth);
  addtoclosure(closure5622, selfslot);
  struct UserObject *uo5622 = (struct UserObject*)block5621;
  uo5622->data[0] = (Object)closure5622;
  Method *meth_meth_ast__apply5622 = addmethod2pos(block5621, "_apply", &meth_ast__apply5622, 0);
  int argcv_meth_ast__apply5622[] = {1};
  meth_meth_ast__apply5622->type = alloc_MethodType(1, argcv_meth_ast__apply5622);
  meth_meth_ast__apply5622->definitionModule = modulename;
  meth_meth_ast__apply5622->definitionLine = 1247;
// compiled block node returning block5621 (depth = 5)
  gc_frame_newslot(block5621);
// call case 5: prelude request
  params[0] = call5620;
  params[1] = block5621;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5739 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5618);
// compiled call node returning call5739 (depth = 4)
// Begin line 1257
  setline(1257);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool5742 = alloc_Boolean(0);
// compiled identifier node returning bool5742 (depth = 6)
  int op_slot_right_5741 = gc_frame_newslot(bool5742);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5744 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5745 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5744);
// compiled call node returning call5745 (depth = 7)
// compiled member node returning call5745 (depth = 6)
  int op_slot_left_5741 = gc_frame_newslot(call5745);
  params[0] = bool5742;
  partcv[0] = 1;
  Object opresult5746 = callmethod(call5745, "!=", 1, partcv, params);
// compiled op node returning opresult5746 (depth = 5)
  Object if5740 = done;
  if (istrue(opresult5746)) {
// Begin line 1258
  setline(1258);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 1259
  setline(1259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5748 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num5750 = alloc_Float64(2);
// compiled num node returning num5750 (depth = 9)
  int op_slot_right_5749 = gc_frame_newslot(num5750);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_5749 = gc_frame_newslot(*var_depth);
  params[0] = num5750;
  partcv[0] = 1;
  Object sum5752 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum5752 (depth = 8)
  gc_frame_newslot(sum5752);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5753 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5754 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5753);
// compiled call node returning call5754 (depth = 9)
// compiled member node returning call5754 (depth = 8)
  params[0] = sum5752;
  partcv[0] = 1;
  Object call5755 = callmethod(call5754, "pretty",
    1, partcv, params);
  gc_frame_end(callframe5748);
// compiled call node returning call5755 (depth = 7)
  int op_slot_right_5747 = gc_frame_newslot(call5755);
// Begin line 1258
  setline(1258);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5758 == NULL) {
    strlit5758 = alloc_String("Type Parameters:""\x0a""");
    gc_root(strlit5758);
  }
// compiled string node returning strlit5758 (depth = 8)
  int op_slot_right_5757 = gc_frame_newslot(strlit5758);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_5760 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit5763 == NULL) {
    strlit5763 = alloc_String("""\x0a""");
    gc_root(strlit5763);
  }
// compiled string node returning strlit5763 (depth = 10)
  int op_slot_right_5762 = gc_frame_newslot(strlit5763);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_5762 = gc_frame_newslot(*var_s);
  params[0] = strlit5763;
  partcv[0] = 1;
  Object opresult5765 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5765 (depth = 9)
  int op_slot_left_5760 = gc_frame_newslot(opresult5765);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5766 = callmethod(opresult5765, "++", 1, partcv, params);
// compiled op node returning opresult5766 (depth = 8)
  int op_slot_left_5757 = gc_frame_newslot(opresult5766);
  params[0] = strlit5758;
  partcv[0] = 1;
  Object opresult5767 = callmethod(opresult5766, "++", 1, partcv, params);
// compiled op node returning opresult5767 (depth = 7)
  int op_slot_left_5747 = gc_frame_newslot(opresult5767);
  params[0] = call5755;
  partcv[0] = 1;
  Object opresult5768 = callmethod(opresult5767, "++", 1, partcv, params);
// compiled op node returning opresult5768 (depth = 6)
  *var_s = opresult5768;
  if (opresult5768 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if5740 = done;
  } else {
  }
// compiled if node returning if5740 (depth = 4)
// Begin line 1261
  setline(1261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num5772 = alloc_Float64(0);
// compiled num node returning num5772 (depth = 6)
  int op_slot_right_5771 = gc_frame_newslot(num5772);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5774 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5775 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5776 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5775);
// compiled call node returning call5776 (depth = 9)
// compiled member node returning call5776 (depth = 8)
  partcv[0] = 0;
  Object call5777 = callmethod(call5776, "size",
    1, partcv, params);
  gc_frame_end(callframe5774);
// compiled call node returning call5777 (depth = 7)
// compiled member node returning call5777 (depth = 6)
  int op_slot_left_5771 = gc_frame_newslot(call5777);
  params[0] = num5772;
  partcv[0] = 1;
  Object opresult5778 = callmethod(call5777, ">", 1, partcv, params);
// compiled op node returning opresult5778 (depth = 5)
  Object if5770 = done;
  if (istrue(opresult5778)) {
// Begin line 1262
  setline(1262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5780 == NULL) {
    strlit5780 = alloc_String("Annotations:");
    gc_root(strlit5780);
  }
// compiled string node returning strlit5780 (depth = 7)
  int op_slot_right_5779 = gc_frame_newslot(strlit5780);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_5782 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5785 == NULL) {
    strlit5785 = alloc_String("""\x0a""");
    gc_root(strlit5785);
  }
// compiled string node returning strlit5785 (depth = 9)
  int op_slot_right_5784 = gc_frame_newslot(strlit5785);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_5784 = gc_frame_newslot(*var_s);
  params[0] = strlit5785;
  partcv[0] = 1;
  Object opresult5787 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5787 (depth = 8)
  int op_slot_left_5782 = gc_frame_newslot(opresult5787);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5788 = callmethod(opresult5787, "++", 1, partcv, params);
// compiled op node returning opresult5788 (depth = 7)
  int op_slot_left_5779 = gc_frame_newslot(opresult5788);
  params[0] = strlit5780;
  partcv[0] = 1;
  Object opresult5789 = callmethod(opresult5788, "++", 1, partcv, params);
// compiled op node returning opresult5789 (depth = 6)
  *var_s = opresult5789;
  if (opresult5789 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1263
  setline(1263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5791 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5792 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5793 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5792);
// compiled call node returning call5793 (depth = 7)
// compiled member node returning call5793 (depth = 6)
  gc_frame_newslot(call5793);
// starting to compile block node (depth = 6)
  Object block5794 = alloc_Block(NULL, NULL, "ast", 1263);
  gc_frame_newslot(block5794);
// method _apply
  block_savedest(block5794);
  Object closure5795 = createclosure(3, "_apply");
  setclosureframe(closure5795, stackframe);
  addtoclosure(closure5795, var_depth);
  addtoclosure(closure5795, var_s);
  addtoclosure(closure5795, selfslot);
  struct UserObject *uo5795 = (struct UserObject*)block5794;
  uo5795->data[0] = (Object)closure5795;
  Method *meth_meth_ast__apply5795 = addmethod2pos(block5794, "_apply", &meth_ast__apply5795, 0);
  int argcv_meth_ast__apply5795[] = {1};
  meth_meth_ast__apply5795->type = alloc_MethodType(1, argcv_meth_ast__apply5795);
  meth_meth_ast__apply5795->definitionModule = modulename;
  meth_meth_ast__apply5795->definitionLine = 1263;
// compiled block node returning block5794 (depth = 6)
  gc_frame_newslot(block5794);
// call case 5: prelude request
  params[0] = call5793;
  params[1] = block5794;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5815 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5791);
// compiled call node returning call5815 (depth = 5)
    gc_frame_newslot(call5815);
    if5770 = call5815;
  } else {
  }
// compiled if node returning if5770 (depth = 4)
// Begin line 1267
  setline(1267);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5817 == NULL) {
    strlit5817 = alloc_String("Body:");
    gc_root(strlit5817);
  }
// compiled string node returning strlit5817 (depth = 6)
  int op_slot_right_5816 = gc_frame_newslot(strlit5817);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_5819 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5822 == NULL) {
    strlit5822 = alloc_String("""\x0a""");
    gc_root(strlit5822);
  }
// compiled string node returning strlit5822 (depth = 8)
  int op_slot_right_5821 = gc_frame_newslot(strlit5822);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_5821 = gc_frame_newslot(*var_s);
  params[0] = strlit5822;
  partcv[0] = 1;
  Object opresult5824 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5824 (depth = 7)
  int op_slot_left_5819 = gc_frame_newslot(opresult5824);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5825 = callmethod(opresult5824, "++", 1, partcv, params);
// compiled op node returning opresult5825 (depth = 6)
  int op_slot_left_5816 = gc_frame_newslot(opresult5825);
  params[0] = strlit5817;
  partcv[0] = 1;
  Object opresult5826 = callmethod(opresult5825, "++", 1, partcv, params);
// compiled op node returning opresult5826 (depth = 5)
  *var_s = opresult5826;
  if (opresult5826 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1268
  setline(1268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5828 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5829 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5830 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5829);
// compiled call node returning call5830 (depth = 6)
// compiled member node returning call5830 (depth = 5)
  gc_frame_newslot(call5830);
// starting to compile block node (depth = 5)
  Object block5831 = alloc_Block(NULL, NULL, "ast", 1268);
  gc_frame_newslot(block5831);
// method _apply
  block_savedest(block5831);
  Object closure5832 = createclosure(4, "_apply");
  setclosureframe(closure5832, stackframe);
  addtoclosure(closure5832, var_depth);
  addtoclosure(closure5832, var_spc);
  addtoclosure(closure5832, var_s);
  addtoclosure(closure5832, selfslot);
  struct UserObject *uo5832 = (struct UserObject*)block5831;
  uo5832->data[0] = (Object)closure5832;
  Method *meth_meth_ast__apply5832 = addmethod2pos(block5831, "_apply", &meth_ast__apply5832, 0);
  int argcv_meth_ast__apply5832[] = {1};
  meth_meth_ast__apply5832->type = alloc_MethodType(1, argcv_meth_ast__apply5832);
  meth_meth_ast__apply5832->definitionModule = modulename;
  meth_meth_ast__apply5832->definitionLine = 1268;
// compiled block node returning block5831 (depth = 5)
  gc_frame_newslot(block5831);
// call case 5: prelude request
  params[0] = call5830;
  params[1] = block5831;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5851 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5828);
// compiled call node returning call5851 (depth = 4)
// Begin line 1271
  setline(1271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5854 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5855 = callmethodflags(self, "comments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5854);
// compiled call node returning call5855 (depth = 7)
// compiled member node returning call5855 (depth = 6)
  int op_slot_right_5853 = gc_frame_newslot(call5855);
// starting to compile identifier node (depth = 6)
  Object bool5857 = alloc_Boolean(0);
// compiled identifier node returning bool5857 (depth = 6)
  int op_slot_left_5853 = gc_frame_newslot(bool5857);
  params[0] = call5855;
  partcv[0] = 1;
  Object opresult5858 = callmethod(bool5857, "!=", 1, partcv, params);
// compiled op node returning opresult5858 (depth = 5)
  Object if5852 = done;
  if (istrue(opresult5858)) {
// Begin line 1272
  setline(1272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5860 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num5862 = alloc_Float64(2);
// compiled num node returning num5862 (depth = 9)
  int op_slot_right_5861 = gc_frame_newslot(num5862);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_5861 = gc_frame_newslot(*var_depth);
  params[0] = num5862;
  partcv[0] = 1;
  Object sum5864 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum5864 (depth = 8)
  gc_frame_newslot(sum5864);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5865 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5866 = callmethodflags(self, "comments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5865);
// compiled call node returning call5866 (depth = 9)
// compiled member node returning call5866 (depth = 8)
  params[0] = sum5864;
  partcv[0] = 1;
  Object call5867 = callmethod(call5866, "pretty",
    1, partcv, params);
  gc_frame_end(callframe5860);
// compiled call node returning call5867 (depth = 7)
  int op_slot_right_5859 = gc_frame_newslot(call5867);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_5859 = gc_frame_newslot(*var_s);
  params[0] = call5867;
  partcv[0] = 1;
  Object opresult5869 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5869 (depth = 6)
  *var_s = opresult5869;
  if (opresult5869 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if5852 = done;
  } else {
  }
// compiled if node returning if5852 (depth = 4)
// Begin line 1274
  setline(1274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply5883(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1279
  setline(1279);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5885 == NULL) {
    strlit5885 = alloc_String("    ");
    gc_root(strlit5885);
  }
// compiled string node returning strlit5885 (depth = 8)
  int op_slot_right_5884 = gc_frame_newslot(strlit5885);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_5884 = gc_frame_newslot(*var_spc);
  params[0] = strlit5885;
  partcv[0] = 1;
  Object opresult5887 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult5887 (depth = 7)
  *var_spc = opresult5887;
  if (opresult5887 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply5958(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_part = getfromclosure(closure, 0);
  Object *var_depth = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_pnr = &(stackframe->slots[0]);
  *var_pnr = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_p = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "p");
// Begin line 1290
  setline(1290);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 10)
// Begin line 1291
  setline(1291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile index node (depth = 11)
// Begin line 1290
  setline(1290);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe5959 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_part (depth = 14)
  partcv[0] = 0;
  Object call5960 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe5959);
// compiled call node returning call5960 (depth = 13)
// compiled member node returning call5960 (depth = 12)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_pnr (depth = 12)
  params[0] = *var_pnr;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres5961 = callmethod(call5960, "[]", 1, partcv, params);
// compiled index node returning idxres5961 (depth = 11)
  *var_p = idxres5961;
  if (idxres5961 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 10)
// Begin line 1291
  setline(1291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe5963 = gc_frame_new();
// starting to compile op node (depth = 13)
// starting to compile num node (depth = 14)
  Object num5965 = alloc_Float64(1);
// compiled num node returning num5965 (depth = 14)
  int op_slot_right_5964 = gc_frame_newslot(num5965);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_depth (depth = 14)
  int op_slot_left_5964 = gc_frame_newslot(*var_depth);
  params[0] = num5965;
  partcv[0] = 1;
  Object sum5967 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum5967 (depth = 13)
  gc_frame_newslot(sum5967);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_p (depth = 13)
  params[0] = sum5967;
  partcv[0] = 1;
  Object call5968 = callmethod(*var_p, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe5963);
// compiled call node returning call5968 (depth = 12)
  int op_slot_right_5962 = gc_frame_newslot(call5968);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_s (depth = 12)
  int op_slot_left_5962 = gc_frame_newslot(*var_s);
  params[0] = call5968;
  partcv[0] = 1;
  Object opresult5970 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5970 (depth = 11)
  *var_s = opresult5970;
  if (opresult5970 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
// Begin line 1292
  setline(1292);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
  Object bool5975 = alloc_Boolean(0);
// compiled identifier node returning bool5975 (depth = 13)
  int op_slot_right_5974 = gc_frame_newslot(bool5975);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe5977 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_part (depth = 15)
  partcv[0] = 0;
  Object call5978 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe5977);
// compiled call node returning call5978 (depth = 14)
// compiled member node returning call5978 (depth = 13)
  int op_slot_left_5974 = gc_frame_newslot(call5978);
  params[0] = bool5975;
  partcv[0] = 1;
  Object opresult5979 = callmethod(call5978, "!=", 1, partcv, params);
// compiled op node returning opresult5979 (depth = 12)
  int op_slot_right_5973 = gc_frame_newslot(opresult5979);
// starting to compile op node (depth = 12)
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe5982 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe5983 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_part (depth = 17)
  partcv[0] = 0;
  Object call5984 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe5983);
// compiled call node returning call5984 (depth = 16)
// compiled member node returning call5984 (depth = 15)
  partcv[0] = 0;
  Object call5985 = callmethod(call5984, "size",
    1, partcv, params);
  gc_frame_end(callframe5982);
// compiled call node returning call5985 (depth = 14)
// compiled member node returning call5985 (depth = 13)
  int op_slot_right_5981 = gc_frame_newslot(call5985);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_pnr (depth = 13)
  int op_slot_left_5981 = gc_frame_newslot(*var_pnr);
  params[0] = call5985;
  partcv[0] = 1;
  Object opresult5987 = callmethod(*var_pnr, "<", 1, partcv, params);
// compiled op node returning opresult5987 (depth = 12)
  int op_slot_left_5973 = gc_frame_newslot(opresult5987);
  params[0] = opresult5979;
  partcv[0] = 1;
  Object opresult5988 = callmethod(opresult5987, "||", 1, partcv, params);
// compiled op node returning opresult5988 (depth = 11)
  Object if5972 = done;
  if (istrue(opresult5988)) {
// Begin line 1293
  setline(1293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 11)
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit5990 == NULL) {
    strlit5990 = alloc_String(", ");
    gc_root(strlit5990);
  }
// compiled string node returning strlit5990 (depth = 13)
  int op_slot_right_5989 = gc_frame_newslot(strlit5990);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_s (depth = 13)
  int op_slot_left_5989 = gc_frame_newslot(*var_s);
  params[0] = strlit5990;
  partcv[0] = 1;
  Object opresult5992 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5992 (depth = 12)
  *var_s = opresult5992;
  if (opresult5992 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 11)
    gc_frame_newslot(done);
    if5972 = done;
  } else {
  }
// compiled if node returning if5972 (depth = 10)
  gc_frame_end(frame);
  return if5972;
}
Object meth_ast__apply5922(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_s = getfromclosure(closure, 0);
  Object *var_depth = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1286
  setline(1286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5924 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_part (depth = 11)
  partcv[0] = 0;
  Object call5925 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe5924);
// compiled call node returning call5925 (depth = 10)
// compiled member node returning call5925 (depth = 9)
  int op_slot_right_5923 = gc_frame_newslot(call5925);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_5923 = gc_frame_newslot(*var_s);
  params[0] = call5925;
  partcv[0] = 1;
  Object opresult5927 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5927 (depth = 8)
  *var_s = opresult5927;
  if (opresult5927 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 1287
  setline(1287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
  Object bool5932 = alloc_Boolean(0);
// compiled identifier node returning bool5932 (depth = 10)
  int op_slot_right_5931 = gc_frame_newslot(bool5932);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe5934 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_part (depth = 12)
  partcv[0] = 0;
  Object call5935 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe5934);
// compiled call node returning call5935 (depth = 11)
// compiled member node returning call5935 (depth = 10)
  int op_slot_left_5931 = gc_frame_newslot(call5935);
  params[0] = bool5932;
  partcv[0] = 1;
  Object opresult5936 = callmethod(call5935, "!=", 1, partcv, params);
// compiled op node returning opresult5936 (depth = 9)
  int op_slot_right_5930 = gc_frame_newslot(opresult5936);
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num5939 = alloc_Float64(0);
// compiled num node returning num5939 (depth = 10)
  int op_slot_right_5938 = gc_frame_newslot(num5939);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe5941 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe5942 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_part (depth = 14)
  partcv[0] = 0;
  Object call5943 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe5942);
// compiled call node returning call5943 (depth = 13)
// compiled member node returning call5943 (depth = 12)
  partcv[0] = 0;
  Object call5944 = callmethod(call5943, "size",
    1, partcv, params);
  gc_frame_end(callframe5941);
// compiled call node returning call5944 (depth = 11)
// compiled member node returning call5944 (depth = 10)
  int op_slot_left_5938 = gc_frame_newslot(call5944);
  params[0] = num5939;
  partcv[0] = 1;
  Object opresult5945 = callmethod(call5944, ">", 1, partcv, params);
// compiled op node returning opresult5945 (depth = 9)
  int op_slot_left_5930 = gc_frame_newslot(opresult5945);
  params[0] = opresult5936;
  partcv[0] = 1;
  Object opresult5946 = callmethod(opresult5945, "||", 1, partcv, params);
// compiled op node returning opresult5946 (depth = 8)
  Object if5929 = done;
  if (istrue(opresult5946)) {
// Begin line 1288
  setline(1288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit5948 == NULL) {
    strlit5948 = alloc_String("(");
    gc_root(strlit5948);
  }
// compiled string node returning strlit5948 (depth = 10)
  int op_slot_right_5947 = gc_frame_newslot(strlit5948);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_5947 = gc_frame_newslot(*var_s);
  params[0] = strlit5948;
  partcv[0] = 1;
  Object opresult5950 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5950 (depth = 9)
  *var_s = opresult5950;
  if (opresult5950 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 1289
  setline(1289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe5952 = gc_frame_new();
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5953 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe5954 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_part (depth = 13)
  partcv[0] = 0;
  Object call5955 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe5954);
// compiled call node returning call5955 (depth = 12)
// compiled member node returning call5955 (depth = 11)
  partcv[0] = 0;
  Object call5956 = callmethod(call5955, "indices",
    1, partcv, params);
  gc_frame_end(callframe5953);
// compiled call node returning call5956 (depth = 10)
// compiled member node returning call5956 (depth = 9)
  gc_frame_newslot(call5956);
// starting to compile block node (depth = 9)
  Object block5957 = alloc_Block(NULL, NULL, "ast", 1289);
  gc_frame_newslot(block5957);
// method _apply
  block_savedest(block5957);
  Object closure5958 = createclosure(4, "_apply");
  setclosureframe(closure5958, stackframe);
  addtoclosure(closure5958, var_part);
  addtoclosure(closure5958, var_depth);
  addtoclosure(closure5958, var_s);
  addtoclosure(closure5958, selfslot);
  struct UserObject *uo5958 = (struct UserObject*)block5957;
  uo5958->data[0] = (Object)closure5958;
  Method *meth_meth_ast__apply5958 = addmethod2pos(block5957, "_apply", &meth_ast__apply5958, 0);
  int argcv_meth_ast__apply5958[] = {1};
  meth_meth_ast__apply5958->type = alloc_MethodType(1, argcv_meth_ast__apply5958);
  meth_meth_ast__apply5958->definitionModule = modulename;
  meth_meth_ast__apply5958->definitionLine = 1289;
// compiled block node returning block5957 (depth = 9)
  gc_frame_newslot(block5957);
// call case 5: prelude request
  params[0] = call5956;
  params[1] = block5957;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5995 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5952);
// compiled call node returning call5995 (depth = 8)
// Begin line 1296
  setline(1296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
  Object bool5998 = alloc_Boolean(0);
// compiled identifier node returning bool5998 (depth = 10)
  int op_slot_right_5997 = gc_frame_newslot(bool5998);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6000 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_part (depth = 12)
  partcv[0] = 0;
  Object call6001 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe6000);
// compiled call node returning call6001 (depth = 11)
// compiled member node returning call6001 (depth = 10)
  int op_slot_left_5997 = gc_frame_newslot(call6001);
  params[0] = bool5998;
  partcv[0] = 1;
  Object opresult6002 = callmethod(call6001, "!=", 1, partcv, params);
// compiled op node returning opresult6002 (depth = 9)
  Object if5996 = done;
  if (istrue(opresult6002)) {
// Begin line 1297
  setline(1297);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe6004 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe6005 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_part (depth = 15)
  partcv[0] = 0;
  Object call6006 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe6005);
// compiled call node returning call6006 (depth = 14)
// compiled member node returning call6006 (depth = 13)
  partcv[0] = 0;
  Object call6007 = callmethod(call6006, "value",
    1, partcv, params);
  gc_frame_end(callframe6004);
// compiled call node returning call6007 (depth = 12)
// compiled member node returning call6007 (depth = 11)
  int op_slot_right_6003 = gc_frame_newslot(call6007);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit6010 == NULL) {
    strlit6010 = alloc_String("*");
    gc_root(strlit6010);
  }
// compiled string node returning strlit6010 (depth = 12)
  int op_slot_right_6009 = gc_frame_newslot(strlit6010);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_s (depth = 12)
  int op_slot_left_6009 = gc_frame_newslot(*var_s);
  params[0] = strlit6010;
  partcv[0] = 1;
  Object opresult6012 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6012 (depth = 11)
  int op_slot_left_6003 = gc_frame_newslot(opresult6012);
  params[0] = call6007;
  partcv[0] = 1;
  Object opresult6013 = callmethod(opresult6012, "++", 1, partcv, params);
// compiled op node returning opresult6013 (depth = 10)
  *var_s = opresult6013;
  if (opresult6013 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if5996 = done;
  } else {
  }
// compiled if node returning if5996 (depth = 8)
// Begin line 1299
  setline(1299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit6016 == NULL) {
    strlit6016 = alloc_String(")");
    gc_root(strlit6016);
  }
// compiled string node returning strlit6016 (depth = 10)
  int op_slot_right_6015 = gc_frame_newslot(strlit6016);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_6015 = gc_frame_newslot(*var_s);
  params[0] = strlit6016;
  partcv[0] = 1;
  Object opresult6018 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6018 (depth = 9)
  *var_s = opresult6018;
  if (opresult6018 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if5929 = done;
  } else {
  }
// compiled if node returning if5929 (depth = 7)
  gc_frame_end(frame);
  return if5929;
}
Object meth_ast__apply6062(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1308
  setline(1308);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6064 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num6066 = alloc_Float64(1);
// compiled num node returning num6066 (depth = 10)
  int op_slot_right_6065 = gc_frame_newslot(num6066);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_6065 = gc_frame_newslot(*var_depth);
  params[0] = num6066;
  partcv[0] = 1;
  Object sum6068 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum6068 (depth = 9)
  gc_frame_newslot(sum6068);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_mx (depth = 9)
  params[0] = sum6068;
  partcv[0] = 1;
  Object call6069 = callmethod(*var_mx, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6064);
// compiled call node returning call6069 (depth = 8)
  int op_slot_right_6063 = gc_frame_newslot(call6069);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6072 == NULL) {
    strlit6072 = alloc_String("    ");
    gc_root(strlit6072);
  }
// compiled string node returning strlit6072 (depth = 9)
  int op_slot_right_6071 = gc_frame_newslot(strlit6072);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_6074 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit6077 == NULL) {
    strlit6077 = alloc_String("""\x0a""");
    gc_root(strlit6077);
  }
// compiled string node returning strlit6077 (depth = 11)
  int op_slot_right_6076 = gc_frame_newslot(strlit6077);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_6076 = gc_frame_newslot(*var_s);
  params[0] = strlit6077;
  partcv[0] = 1;
  Object opresult6079 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6079 (depth = 10)
  int op_slot_left_6074 = gc_frame_newslot(opresult6079);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6080 = callmethod(opresult6079, "++", 1, partcv, params);
// compiled op node returning opresult6080 (depth = 9)
  int op_slot_left_6071 = gc_frame_newslot(opresult6080);
  params[0] = strlit6072;
  partcv[0] = 1;
  Object opresult6081 = callmethod(opresult6080, "++", 1, partcv, params);
// compiled op node returning opresult6081 (depth = 8)
  int op_slot_left_6063 = gc_frame_newslot(opresult6081);
  params[0] = call6069;
  partcv[0] = 1;
  Object opresult6082 = callmethod(opresult6081, "++", 1, partcv, params);
// compiled op node returning opresult6082 (depth = 7)
  *var_s = opresult6082;
  if (opresult6082 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace5871(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1277
  setline(1277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5872 == NULL) {
    strlit5872 = alloc_String("");
    gc_root(strlit5872);
  }
// compiled string node returning strlit5872 (depth = 5)
  *var_spc = strlit5872;
  if (strlit5872 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1278
  setline(1278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5873 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num5876 = alloc_Float64(1);
// compiled num node returning num5876 (depth = 7)
  int op_slot_right_5875 = gc_frame_newslot(num5876);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_5875 = gc_frame_newslot(*var_depth);
  params[0] = num5876;
  partcv[0] = 1;
  Object diff5878 = callmethod(*var_depth, "-", 1, partcv, params);
// compiled op node returning diff5878 (depth = 6)
  int op_slot_right_5874 = gc_frame_newslot(diff5878);
// starting to compile num node (depth = 6)
  Object num5880 = alloc_Float64(0);
// compiled num node returning num5880 (depth = 6)
  int op_slot_left_5874 = gc_frame_newslot(num5880);
  params[0] = diff5878;
  partcv[0] = 1;
  Object opresult5881 = callmethod(num5880, "..", 1, partcv, params);
// compiled op node returning opresult5881 (depth = 5)
  gc_frame_newslot(opresult5881);
// starting to compile block node (depth = 5)
  Object block5882 = alloc_Block(NULL, NULL, "ast", 1278);
  gc_frame_newslot(block5882);
// method _apply
  block_savedest(block5882);
  Object closure5883 = createclosure(2, "_apply");
  setclosureframe(closure5883, stackframe);
  addtoclosure(closure5883, var_spc);
  addtoclosure(closure5883, selfslot);
  struct UserObject *uo5883 = (struct UserObject*)block5882;
  uo5883->data[0] = (Object)closure5883;
  Method *meth_meth_ast__apply5883 = addmethod2pos(block5882, "_apply", &meth_ast__apply5883, 0);
  int argcv_meth_ast__apply5883[] = {1};
  meth_meth_ast__apply5883->type = alloc_MethodType(1, argcv_meth_ast__apply5883);
  meth_meth_ast__apply5883->definitionModule = modulename;
  meth_meth_ast__apply5883->definitionLine = 1272;
// compiled block node returning block5882 (depth = 5)
  gc_frame_newslot(block5882);
// call case 5: prelude request
  params[0] = opresult5881;
  params[1] = block5882;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5890 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5873);
// compiled call node returning call5890 (depth = 4)
// Begin line 1281
  setline(1281);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5892 == NULL) {
    strlit5892 = alloc_String("");
    gc_root(strlit5892);
  }
// compiled string node returning strlit5892 (depth = 6)
  int op_slot_right_5891 = gc_frame_newslot(strlit5892);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5895 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num5896 = alloc_Float64(0);
// compiled num node returning num5896 (depth = 8)
  gc_frame_newslot(num5896);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5897 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5898 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5897);
// compiled call node returning call5898 (depth = 9)
// compiled member node returning call5898 (depth = 8)
  params[0] = num5896;
  partcv[0] = 1;
  Object call5899 = callmethod(call5898, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe5895);
// compiled call node returning call5899 (depth = 7)
  int op_slot_right_5894 = gc_frame_newslot(call5899);
// starting to compile string node (depth = 7)
  if (strlit5901 == NULL) {
    strlit5901 = alloc_String("class ");
    gc_root(strlit5901);
  }
// compiled string node returning strlit5901 (depth = 7)
  int op_slot_left_5894 = gc_frame_newslot(strlit5901);
  params[0] = call5899;
  partcv[0] = 1;
  Object opresult5902 = callmethod(strlit5901, "++", 1, partcv, params);
// compiled op node returning opresult5902 (depth = 6)
  int op_slot_left_5891 = gc_frame_newslot(opresult5902);
  params[0] = strlit5892;
  partcv[0] = 1;
  Object opresult5903 = callmethod(opresult5902, "++", 1, partcv, params);
// compiled op node returning opresult5903 (depth = 5)
  *var_s = opresult5903;
  if (opresult5903 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1282
  setline(1282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5906 == NULL) {
    strlit5906 = alloc_String("generic");
    gc_root(strlit5906);
  }
// compiled string node returning strlit5906 (depth = 6)
  int op_slot_right_5905 = gc_frame_newslot(strlit5906);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5908 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5909 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5910 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5909);
// compiled call node returning call5910 (depth = 9)
// compiled member node returning call5910 (depth = 8)
  partcv[0] = 0;
  Object call5911 = callmethod(call5910, "kind",
    1, partcv, params);
  gc_frame_end(callframe5908);
// compiled call node returning call5911 (depth = 7)
// compiled member node returning call5911 (depth = 6)
  int op_slot_left_5905 = gc_frame_newslot(call5911);
  params[0] = strlit5906;
  partcv[0] = 1;
  Object opresult5912 = callmethod(call5911, "!=", 1, partcv, params);
// compiled op node returning opresult5912 (depth = 5)
  Object if5904 = done;
  if (istrue(opresult5912)) {
// Begin line 1284
  setline(1284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5914 == NULL) {
    strlit5914 = alloc_String(".");
    gc_root(strlit5914);
  }
// compiled string node returning strlit5914 (depth = 7)
  int op_slot_right_5913 = gc_frame_newslot(strlit5914);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_5913 = gc_frame_newslot(*var_s);
  params[0] = strlit5914;
  partcv[0] = 1;
  Object opresult5916 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5916 (depth = 6)
  *var_s = opresult5916;
  if (opresult5916 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1285
  setline(1285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5918 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5919 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5920 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5919);
// compiled call node returning call5920 (depth = 7)
// compiled member node returning call5920 (depth = 6)
  gc_frame_newslot(call5920);
// starting to compile block node (depth = 6)
  Object block5921 = alloc_Block(NULL, NULL, "ast", 1285);
  gc_frame_newslot(block5921);
// method _apply
  block_savedest(block5921);
  Object closure5922 = createclosure(3, "_apply");
  setclosureframe(closure5922, stackframe);
  addtoclosure(closure5922, var_s);
  addtoclosure(closure5922, var_depth);
  addtoclosure(closure5922, selfslot);
  struct UserObject *uo5922 = (struct UserObject*)block5921;
  uo5922->data[0] = (Object)closure5922;
  Method *meth_meth_ast__apply5922 = addmethod2pos(block5921, "_apply", &meth_ast__apply5922, 0);
  int argcv_meth_ast__apply5922[] = {1};
  meth_meth_ast__apply5922->type = alloc_MethodType(1, argcv_meth_ast__apply5922);
  meth_meth_ast__apply5922->definitionModule = modulename;
  meth_meth_ast__apply5922->definitionLine = 1285;
// compiled block node returning block5921 (depth = 6)
  gc_frame_newslot(block5921);
// call case 5: prelude request
  params[0] = call5920;
  params[1] = block5921;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6021 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5918);
// compiled call node returning call6021 (depth = 5)
    gc_frame_newslot(call6021);
    if5904 = call6021;
  } else {
  }
// compiled if node returning if5904 (depth = 4)
// Begin line 1303
  setline(1303);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6024 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6025 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6024);
// compiled call node returning call6025 (depth = 7)
// compiled member node returning call6025 (depth = 6)
  int op_slot_right_6023 = gc_frame_newslot(call6025);
// starting to compile identifier node (depth = 6)
  Object bool6027 = alloc_Boolean(0);
// compiled identifier node returning bool6027 (depth = 6)
  int op_slot_left_6023 = gc_frame_newslot(bool6027);
  params[0] = call6025;
  partcv[0] = 1;
  Object opresult6028 = callmethod(bool6027, "!=", 1, partcv, params);
// compiled op node returning opresult6028 (depth = 5)
  Object if6022 = done;
  if (istrue(opresult6028)) {
// Begin line 1304
  setline(1304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6030 == NULL) {
    strlit6030 = alloc_String("");
    gc_root(strlit6030);
  }
// compiled string node returning strlit6030 (depth = 7)
  int op_slot_right_6029 = gc_frame_newslot(strlit6030);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6033 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num6035 = alloc_Float64(1);
// compiled num node returning num6035 (depth = 10)
  int op_slot_right_6034 = gc_frame_newslot(num6035);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_6034 = gc_frame_newslot(*var_depth);
  params[0] = num6035;
  partcv[0] = 1;
  Object sum6037 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum6037 (depth = 9)
  gc_frame_newslot(sum6037);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6038 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6039 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6038);
// compiled call node returning call6039 (depth = 10)
// compiled member node returning call6039 (depth = 9)
  params[0] = sum6037;
  partcv[0] = 1;
  Object call6040 = callmethod(call6039, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6033);
// compiled call node returning call6040 (depth = 8)
  int op_slot_right_6032 = gc_frame_newslot(call6040);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6043 == NULL) {
    strlit6043 = alloc_String(" -> ");
    gc_root(strlit6043);
  }
// compiled string node returning strlit6043 (depth = 9)
  int op_slot_right_6042 = gc_frame_newslot(strlit6043);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_right_6045 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 10)
  if (strlit6047 == NULL) {
    strlit6047 = alloc_String("");
    gc_root(strlit6047);
  }
// compiled string node returning strlit6047 (depth = 10)
  int op_slot_left_6045 = gc_frame_newslot(strlit6047);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult6048 = callmethod(strlit6047, "++", 1, partcv, params);
// compiled op node returning opresult6048 (depth = 9)
  int op_slot_left_6042 = gc_frame_newslot(opresult6048);
  params[0] = strlit6043;
  partcv[0] = 1;
  Object opresult6049 = callmethod(opresult6048, "++", 1, partcv, params);
// compiled op node returning opresult6049 (depth = 8)
  int op_slot_left_6032 = gc_frame_newslot(opresult6049);
  params[0] = call6040;
  partcv[0] = 1;
  Object opresult6050 = callmethod(opresult6049, "++", 1, partcv, params);
// compiled op node returning opresult6050 (depth = 7)
  int op_slot_left_6029 = gc_frame_newslot(opresult6050);
  params[0] = strlit6030;
  partcv[0] = 1;
  Object opresult6051 = callmethod(opresult6050, "++", 1, partcv, params);
// compiled op node returning opresult6051 (depth = 6)
  *var_s = opresult6051;
  if (opresult6051 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if6022 = done;
  } else {
  }
// compiled if node returning if6022 (depth = 4)
// Begin line 1306
  setline(1306);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6054 == NULL) {
    strlit6054 = alloc_String(" {");
    gc_root(strlit6054);
  }
// compiled string node returning strlit6054 (depth = 6)
  int op_slot_right_6053 = gc_frame_newslot(strlit6054);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_6053 = gc_frame_newslot(*var_s);
  params[0] = strlit6054;
  partcv[0] = 1;
  Object opresult6056 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6056 (depth = 5)
  *var_s = opresult6056;
  if (opresult6056 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1307
  setline(1307);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6058 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6059 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6060 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6059);
// compiled call node returning call6060 (depth = 6)
// compiled member node returning call6060 (depth = 5)
  gc_frame_newslot(call6060);
// starting to compile block node (depth = 5)
  Object block6061 = alloc_Block(NULL, NULL, "ast", 1307);
  gc_frame_newslot(block6061);
// method _apply
  block_savedest(block6061);
  Object closure6062 = createclosure(4, "_apply");
  setclosureframe(closure6062, stackframe);
  addtoclosure(closure6062, var_depth);
  addtoclosure(closure6062, var_spc);
  addtoclosure(closure6062, var_s);
  addtoclosure(closure6062, selfslot);
  struct UserObject *uo6062 = (struct UserObject*)block6061;
  uo6062->data[0] = (Object)closure6062;
  Method *meth_meth_ast__apply6062 = addmethod2pos(block6061, "_apply", &meth_ast__apply6062, 0);
  int argcv_meth_ast__apply6062[] = {1};
  meth_meth_ast__apply6062->type = alloc_MethodType(1, argcv_meth_ast__apply6062);
  meth_meth_ast__apply6062->definitionModule = modulename;
  meth_meth_ast__apply6062->definitionLine = 1307;
// compiled block node returning block6061 (depth = 5)
  gc_frame_newslot(block6061);
// call case 5: prelude request
  params[0] = call6060;
  params[1] = block6061;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6085 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6058);
// compiled call node returning call6085 (depth = 4)
// Begin line 1310
  setline(1310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6087 == NULL) {
    strlit6087 = alloc_String("}");
    gc_root(strlit6087);
  }
// compiled string node returning strlit6087 (depth = 6)
  int op_slot_right_6086 = gc_frame_newslot(strlit6087);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_6089 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit6092 == NULL) {
    strlit6092 = alloc_String("""\x0a""");
    gc_root(strlit6092);
  }
// compiled string node returning strlit6092 (depth = 8)
  int op_slot_right_6091 = gc_frame_newslot(strlit6092);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_6091 = gc_frame_newslot(*var_s);
  params[0] = strlit6092;
  partcv[0] = 1;
  Object opresult6094 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6094 (depth = 7)
  int op_slot_left_6089 = gc_frame_newslot(opresult6094);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6095 = callmethod(opresult6094, "++", 1, partcv, params);
// compiled op node returning opresult6095 (depth = 6)
  int op_slot_left_6086 = gc_frame_newslot(opresult6095);
  params[0] = strlit6087;
  partcv[0] = 1;
  Object opresult6096 = callmethod(opresult6095, "++", 1, partcv, params);
// compiled op node returning opresult6096 (depth = 5)
  *var_s = opresult6096;
  if (opresult6096 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1311
  setline(1311);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy6098(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 27, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[6];
  int partcv[1];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_classNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1315
  setline(1315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6099 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// Begin line 1314
  setline(1314);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6100 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6101 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6102 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6101);
// compiled call node returning call6102 (depth = 7)
// compiled member node returning call6102 (depth = 6)
  gc_frame_newslot(call6102);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_emptySeq (depth = 6)
  gc_frame_newslot(*var_emptySeq);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_emptySeq (depth = 6)
  gc_frame_newslot(*var_emptySeq);
// starting to compile identifier node (depth = 6)
  Object bool6103 = alloc_Boolean(0);
// compiled identifier node returning bool6103 (depth = 6)
  gc_frame_newslot(bool6103);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nullNode (depth = 6)
  gc_frame_newslot(*var_nullNode);
// starting to compile identifier node (depth = 6)
  Object bool6104 = alloc_Boolean(0);
// compiled identifier node returning bool6104 (depth = 6)
  gc_frame_newslot(bool6104);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_classNode (depth = 6)
  params[0] = call6102;
  params[1] = *var_emptySeq;
  params[2] = *var_emptySeq;
  params[3] = bool6103;
  params[4] = *var_nullNode;
  params[5] = bool6104;
  partcv[0] = 6;
  Object call6105 = callmethod(*var_classNode, "new",
    1, partcv, params);
  gc_frame_end(callframe6100);
// compiled call node returning call6105 (depth = 5)
  params[0] = self;
  partcv[0] = 1;
  Object call6106 = callmethod(call6105, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe6099);
// compiled call node returning call6106 (depth = 4)
  gc_frame_end(frame);
  return call6106;
}
Object meth_ast_shallowCopyFieldsFrom6107(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyFieldsFrom");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopyFieldsFrom (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyFieldsFrom");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1318
  setline(1318);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6108 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call6109 = callmethod4(self, "shallowCopyFieldsFrom", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe6108);
// compiled call node returning call6109 (depth = 4)
// Begin line 1319
  setline(1319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1314
  setline(1314);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6110 = gc_frame_new();
// Begin line 1319
  setline(1319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6111 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_other (depth = 8)
  partcv[0] = 0;
  Object call6112 = callmethod(*var_other, "data",
    1, partcv, params);
  gc_frame_end(callframe6111);
// compiled call node returning call6112 (depth = 7)
// compiled member node returning call6112 (depth = 6)
  gc_frame_newslot(call6112);
// call case 4: self request
  params[0] = call6112;
  partcv[0] = 1;
  Object call6113 = callmethodflags(self, "data:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6110);
// compiled call node returning call6113 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1320
  setline(1320);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_new5033(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 6)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_nullNode = getfromclosure(closure, 2);
  Object *var_classNode = getfromclosure(closure, 3);
  Object *var_baseNode = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_signature_39_ = &(stackframe->slots[1]);
  *var_signature_39_ = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[2]);
  *var_body_39_ = args[curarg];
  curarg++;
  Object *var_superclass_39_ = &(stackframe->slots[3]);
  *var_superclass_39_ = args[curarg];
  curarg++;
  Object *var_constructor_39_ = &(stackframe->slots[4]);
  *var_constructor_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[5]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 6)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[6]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5034 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5034 = alloc_userobj2(38,30, objclass5034);
  gc_frame_newslot(obj5034);
if (objclass5034 == NULL) {
  glfree(obj5034->class->name);
  obj5034->class->name = "classNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5034, self, 0);
  addmethodreal(obj5034,"outer", &reader_ast_outer_5035);
  Object oldself5034 = self;
  struct StackFrameObject *oldstackframe5034 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5034);
  gc_frame_newslot((Object)stackframe);
  self = obj5034;
  Object *oldselfslot5034 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5034 = (*(struct UserObject *)self).data[0], lowerouter5034 = thisouter5034;
  if (inheritingObject5034) {
    struct UserObject *inho5034 = (struct UserObject *)inheritingObject5034;
    while (inho5034->super != GraceDefaultObject) inho5034 = (struct UserObject *)inho5034->super;
    inho5034->super = obj5034;
    self = inheritingObject5034;
    *selfslot = self;
    lowerouter5034 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5034;
  }
if (objclass5034 == NULL) {
  Method *reader5036 = addmethodrealflags(obj5034, "kind",&reader_ast_kind_5036, MFLAG_DEF);
  reader5036->definitionModule = modulename;
  reader5036->definitionLine = 1142;
}
adddatum2(obj5034, alloc_Undefined(), 1);
if (objclass5034 == NULL) {
  Method *reader5037 = addmethodrealflags(obj5034, "value",&reader_ast_value_5037, 0);
  Method *writer5037 = addmethodrealflags(obj5034, "value:=",&writer_ast_value_5037, 0);
  reader5037->definitionModule = modulename;
  writer5037->definitionModule = modulename;
  reader5037->definitionLine = 1143;
  writer5037->definitionLine = 1143;
}
obj5034->flags |= OFLAG_MUTABLE;
adddatum2(obj5034, alloc_Undefined(), 2);
if (objclass5034 == NULL) {
  Method *reader5038 = addmethodrealflags(obj5034, "name",&reader_ast_name_5038, 0);
  Method *writer5038 = addmethodrealflags(obj5034, "name:=",&writer_ast_name_5038, 0);
  reader5038->definitionModule = modulename;
  writer5038->definitionModule = modulename;
  reader5038->definitionLine = 1144;
  writer5038->definitionLine = 1144;
}
obj5034->flags |= OFLAG_MUTABLE;
adddatum2(obj5034, alloc_Undefined(), 3);
if (objclass5034 == NULL) {
  Method *reader5039 = addmethodrealflags(obj5034, "constructor",&reader_ast_constructor_5039, 0);
  Method *writer5039 = addmethodrealflags(obj5034, "constructor:=",&writer_ast_constructor_5039, 0);
  reader5039->definitionModule = modulename;
  writer5039->definitionModule = modulename;
  reader5039->definitionLine = 1145;
  writer5039->definitionLine = 1145;
}
obj5034->flags |= OFLAG_MUTABLE;
adddatum2(obj5034, alloc_Undefined(), 4);
if (objclass5034 == NULL) {
  Method *reader5040 = addmethodrealflags(obj5034, "signature",&reader_ast_signature_5040, 0);
  Method *writer5040 = addmethodrealflags(obj5034, "signature:=",&writer_ast_signature_5040, 0);
  reader5040->definitionModule = modulename;
  writer5040->definitionModule = modulename;
  reader5040->definitionLine = 1146;
  writer5040->definitionLine = 1146;
}
obj5034->flags |= OFLAG_MUTABLE;
adddatum2(obj5034, alloc_Undefined(), 5);
if (objclass5034 == NULL) {
  Method *reader5041 = addmethodrealflags(obj5034, "dtype",&reader_ast_dtype_5041, 0);
  Method *writer5041 = addmethodrealflags(obj5034, "dtype:=",&writer_ast_dtype_5041, 0);
  reader5041->definitionModule = modulename;
  writer5041->definitionModule = modulename;
  reader5041->definitionLine = 1147;
  writer5041->definitionLine = 1147;
}
obj5034->flags |= OFLAG_MUTABLE;
adddatum2(obj5034, alloc_Undefined(), 6);
if (objclass5034 == NULL) {
  Method *reader5042 = addmethodrealflags(obj5034, "generics",&reader_ast_generics_5042, 0);
  Method *writer5042 = addmethodrealflags(obj5034, "generics:=",&writer_ast_generics_5042, 0);
  reader5042->definitionModule = modulename;
  writer5042->definitionModule = modulename;
  reader5042->definitionLine = 1148;
  writer5042->definitionLine = 1148;
}
obj5034->flags |= OFLAG_MUTABLE;
adddatum2(obj5034, alloc_Undefined(), 7);
if (objclass5034 == NULL) {
  Method *reader5043 = addmethodrealflags(obj5034, "superclass",&reader_ast_superclass_5043, 0);
  Method *writer5043 = addmethodrealflags(obj5034, "superclass:=",&writer_ast_superclass_5043, 0);
  reader5043->definitionModule = modulename;
  writer5043->definitionModule = modulename;
  reader5043->definitionLine = 1149;
  writer5043->definitionLine = 1149;
}
obj5034->flags |= OFLAG_MUTABLE;
adddatum2(obj5034, alloc_Undefined(), 8);
if (objclass5034 == NULL) {
  Method *reader5044 = addmethodrealflags(obj5034, "annotations",&reader_ast_annotations_5044, 0);
  Method *writer5044 = addmethodrealflags(obj5034, "annotations:=",&writer_ast_annotations_5044, 0);
  reader5044->definitionModule = modulename;
  writer5044->definitionModule = modulename;
  reader5044->definitionLine = 1150;
  writer5044->definitionLine = 1150;
}
obj5034->flags |= OFLAG_MUTABLE;
adddatum2(obj5034, alloc_Undefined(), 9);
if (objclass5034 == NULL) {
  Method *reader5045 = addmethodrealflags(obj5034, "nameString",&reader_ast_nameString_5045, MFLAG_DEF);
  reader5045->definitionModule = modulename;
  reader5045->definitionLine = 1151;
}
adddatum2(obj5034, alloc_Undefined(), 10);
if (objclass5034 == NULL) {
  Method *reader5046 = addmethodrealflags(obj5034, "data",&reader_ast_data_5046, 0);
  Method *writer5046 = addmethodrealflags(obj5034, "data:=",&writer_ast_data_5046, 0);
  reader5046->definitionModule = modulename;
  writer5046->definitionModule = modulename;
  reader5046->definitionLine = 1153;
  writer5046->definitionLine = 1153;
}
obj5034->flags |= OFLAG_MUTABLE;
adddatum2(obj5034, alloc_Undefined(), 11);
// method declarationKindWithAncestors
  struct UserObject *uo5047 = (struct UserObject*)obj5034;
  uo5047->data[12] = emptyclosure;
  Method *meth_meth_ast_declarationKindWithAncestors5047 = addmethod2pos(obj5034, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors5047, 12);
  int argcv_meth_ast_declarationKindWithAncestors5047[] = {1};
  meth_meth_ast_declarationKindWithAncestors5047->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors5047);
  meth_meth_ast_declarationKindWithAncestors5047->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors5047->definitionLine = 1155;
// method scope:=
  struct UserObject *uo5049 = (struct UserObject*)obj5034;
  uo5049->data[13] = emptyclosure;
  Method *meth_meth_ast_scope_58__61_5049 = addmethod2pos(obj5034, "scope:=", &meth_ast_scope_58__61_5049, 13);
  int argcv_meth_ast_scope_58__61_5049[] = {1};
  meth_meth_ast_scope_58__61_5049->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61_5049);
  meth_meth_ast_scope_58__61_5049->definitionModule = modulename;
  meth_meth_ast_scope_58__61_5049->definitionLine = 1158;
// method canInherit
  struct UserObject *uo5054 = (struct UserObject*)obj5034;
  uo5054->data[14] = emptyclosure;
  Method *meth_meth_ast_canInherit5054 = addmethod2pos(obj5034, "canInherit", &meth_ast_canInherit5054, 14);
  int argcv_meth_ast_canInherit5054[] = {0};
  meth_meth_ast_canInherit5054->type = alloc_MethodType(1, argcv_meth_ast_canInherit5054);
  meth_meth_ast_canInherit5054->definitionModule = modulename;
  meth_meth_ast_canInherit5054->definitionLine = 1164;
// method returnsObject
  struct UserObject *uo5056 = (struct UserObject*)obj5034;
  uo5056->data[15] = emptyclosure;
  Method *meth_meth_ast_returnsObject5056 = addmethod2pos(obj5034, "returnsObject", &meth_ast_returnsObject5056, 15);
  int argcv_meth_ast_returnsObject5056[] = {0};
  meth_meth_ast_returnsObject5056->type = alloc_MethodType(1, argcv_meth_ast_returnsObject5056);
  meth_meth_ast_returnsObject5056->definitionModule = modulename;
  meth_meth_ast_returnsObject5056->definitionLine = 1165;
// method returnedObjectScope
  struct UserObject *uo5058 = (struct UserObject*)obj5034;
  uo5058->data[16] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope5058 = addmethod2pos(obj5034, "returnedObjectScope", &meth_ast_returnedObjectScope5058, 16);
  int argcv_meth_ast_returnedObjectScope5058[] = {0};
  meth_meth_ast_returnedObjectScope5058->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope5058);
  meth_meth_ast_returnedObjectScope5058->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope5058->definitionLine = 1166;
// method isClass
  struct UserObject *uo5061 = (struct UserObject*)obj5034;
  uo5061->data[17] = emptyclosure;
  Method *meth_meth_ast_isClass5061 = addmethod2pos(obj5034, "isClass", &meth_ast_isClass5061, 17);
  int argcv_meth_ast_isClass5061[] = {0};
  meth_meth_ast_isClass5061->type = alloc_MethodType(1, argcv_meth_ast_isClass5061);
  meth_meth_ast_isClass5061->definitionModule = modulename;
  meth_meth_ast_isClass5061->definitionLine = 1168;
// method isPublic
  struct UserObject *uo5063 = (struct UserObject*)obj5034;
  uo5063->data[18] = emptyclosure;
  Method *meth_meth_ast_isPublic5063 = addmethod2pos(obj5034, "isPublic", &meth_ast_isPublic5063, 18);
  int argcv_meth_ast_isPublic5063[] = {0};
  meth_meth_ast_isPublic5063->type = alloc_MethodType(1, argcv_meth_ast_isPublic5063);
  meth_meth_ast_isPublic5063->definitionModule = modulename;
  meth_meth_ast_isPublic5063->definitionLine = 1169;
// method isWritable
  struct UserObject *uo5083 = (struct UserObject*)obj5034;
  uo5083->data[19] = emptyclosure;
  Method *meth_meth_ast_isWritable5083 = addmethod2pos(obj5034, "isWritable", &meth_ast_isWritable5083, 19);
  int argcv_meth_ast_isWritable5083[] = {0};
  meth_meth_ast_isWritable5083->type = alloc_MethodType(1, argcv_meth_ast_isWritable5083);
  meth_meth_ast_isWritable5083->definitionModule = modulename;
  meth_meth_ast_isWritable5083->definitionLine = 1174;
// method isReadable
  struct UserObject *uo5085 = (struct UserObject*)obj5034;
  uo5085->data[20] = emptyclosure;
  Method *meth_meth_ast_isReadable5085 = addmethod2pos(obj5034, "isReadable", &meth_ast_isReadable5085, 20);
  int argcv_meth_ast_isReadable5085[] = {0};
  meth_meth_ast_isReadable5085->type = alloc_MethodType(1, argcv_meth_ast_isReadable5085);
  meth_meth_ast_isReadable5085->definitionModule = modulename;
  meth_meth_ast_isReadable5085->definitionLine = 1175;
// method usesAsType
  struct UserObject *uo5088 = (struct UserObject*)obj5034;
  uo5088->data[21] = emptyclosure;
  Method *meth_meth_ast_usesAsType5088 = addmethod2pos(obj5034, "usesAsType", &meth_ast_usesAsType5088, 21);
  int argcv_meth_ast_usesAsType5088[] = {1};
  meth_meth_ast_usesAsType5088->type = alloc_MethodType(1, argcv_meth_ast_usesAsType5088);
  meth_meth_ast_usesAsType5088->definitionModule = modulename;
  meth_meth_ast_usesAsType5088->definitionLine = 1176;
// method parametersDo
  struct UserObject *uo5094 = (struct UserObject*)obj5034;
  uo5094->data[22] = emptyclosure;
  Method *meth_meth_ast_parametersDo5094 = addmethod2pos(obj5034, "parametersDo", &meth_ast_parametersDo5094, 22);
  int argcv_meth_ast_parametersDo5094[] = {1};
  meth_meth_ast_parametersDo5094->type = alloc_MethodType(1, argcv_meth_ast_parametersDo5094);
  meth_meth_ast_parametersDo5094->definitionModule = modulename;
  meth_meth_ast_parametersDo5094->definitionLine = 1179;
// method accept()from
  struct UserObject *uo5111 = (struct UserObject*)obj5034;
  uo5111->data[23] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from5111 = addmethod2pos(obj5034, "accept()from", &meth_ast_accept_40__41_from5111, 23);
  int argcv_meth_ast_accept_40__41_from5111[] = {1, 1};
  meth_meth_ast_accept_40__41_from5111->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from5111);
  meth_meth_ast_accept_40__41_from5111->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from5111->definitionLine = 1184;
// method map()ancestors
  struct UserObject *uo5190 = (struct UserObject*)obj5034;
  uo5190->data[24] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors5190 = addmethod2pos(obj5034, "map()ancestors", &meth_ast_map_40__41_ancestors5190, 24);
  int argcv_meth_ast_map_40__41_ancestors5190[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors5190->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors5190);
  meth_meth_ast_map_40__41_ancestors5190->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors5190->definitionLine = 1211;
// method pretty
  block_savedest(obj5034);
  Object closure5269 = createclosure(1, "pretty");
  setclosureframe(closure5269, stackframe);
  addtoclosure(closure5269, var_util);
  struct UserObject *uo5269 = (struct UserObject*)obj5034;
  uo5269->data[25] = (Object)closure5269;
  Method *meth_meth_ast_pretty5269 = addmethod2pos(obj5034, "pretty", &meth_ast_pretty5269, 25);
  int argcv_meth_ast_pretty5269[] = {1};
  meth_meth_ast_pretty5269->type = alloc_MethodType(1, argcv_meth_ast_pretty5269);
  meth_meth_ast_pretty5269->definitionModule = modulename;
  meth_meth_ast_pretty5269->definitionLine = 1224;
// method toGrace
  struct UserObject *uo5871 = (struct UserObject*)obj5034;
  uo5871->data[26] = emptyclosure;
  Method *meth_meth_ast_toGrace5871 = addmethod2pos(obj5034, "toGrace", &meth_ast_toGrace5871, 26);
  int argcv_meth_ast_toGrace5871[] = {1};
  meth_meth_ast_toGrace5871->type = alloc_MethodType(1, argcv_meth_ast_toGrace5871);
meth_meth_ast_toGrace5871->type->types[0] = type_Number;
meth_meth_ast_toGrace5871->type->names[0] = "depth";
  meth_meth_ast_toGrace5871->definitionModule = modulename;
  meth_meth_ast_toGrace5871->definitionLine = 1276;
// method shallowCopy
  block_savedest(obj5034);
  Object closure6098 = createclosure(3, "shallowCopy");
  setclosureframe(closure6098, stackframe);
  addtoclosure(closure6098, var_emptySeq);
  addtoclosure(closure6098, var_nullNode);
  addtoclosure(closure6098, var_classNode);
  struct UserObject *uo6098 = (struct UserObject*)obj5034;
  uo6098->data[27] = (Object)closure6098;
  Method *meth_meth_ast_shallowCopy6098 = addmethod2pos(obj5034, "shallowCopy", &meth_ast_shallowCopy6098, 27);
  int argcv_meth_ast_shallowCopy6098[] = {0};
  meth_meth_ast_shallowCopy6098->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy6098);
  meth_meth_ast_shallowCopy6098->definitionModule = modulename;
  meth_meth_ast_shallowCopy6098->definitionLine = 1313;
// method shallowCopyFieldsFrom
  struct UserObject *uo6107 = (struct UserObject*)obj5034;
  uo6107->data[28] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom6107 = addmethod2pos(obj5034, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom6107, 28);
  int argcv_meth_ast_shallowCopyFieldsFrom6107[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom6107->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom6107);
  meth_meth_ast_shallowCopyFieldsFrom6107->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom6107->definitionLine = 1317;
  sourceObject = obj5034;
// Begin line 1141
  setline(1141);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6114 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6115 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe6114);
// compiled call node returning call6115 (depth = 4)
  struct UserObject *obj5034_uo = (struct UserObject *)obj5034;
  obj5034_uo->super = call6115;
  sourceObject = obj5034;
// Begin line 1142
  setline(1142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit6116 == NULL) {
    strlit6116 = alloc_String("class");
    gc_root(strlit6116);
  }
// compiled string node returning strlit6116 (depth = 4)
  adddatum2(obj5034, strlit6116, 1);
  sourceObject = obj5034;
// Begin line 1143
  setline(1143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_body_39_ (depth = 4)
  adddatum2(obj5034, *var_body_39_, 2);
  sourceObject = obj5034;
// Begin line 1144
  setline(1144);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_name_39_ (depth = 4)
  adddatum2(obj5034, *var_name_39_, 3);
  sourceObject = obj5034;
// Begin line 1145
  setline(1145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_constructor_39_ (depth = 4)
  adddatum2(obj5034, *var_constructor_39_, 4);
  sourceObject = obj5034;
// Begin line 1146
  setline(1146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_signature_39_ (depth = 4)
  adddatum2(obj5034, *var_signature_39_, 5);
  sourceObject = obj5034;
// Begin line 1147
  setline(1147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_dtype_39_ (depth = 4)
  adddatum2(obj5034, *var_dtype_39_, 6);
  sourceObject = obj5034;
// Begin line 1148
  setline(1148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool6117 = alloc_Boolean(0);
// compiled identifier node returning bool6117 (depth = 4)
  adddatum2(obj5034, bool6117, 7);
  sourceObject = obj5034;
// Begin line 1149
  setline(1149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_superclass_39_ (depth = 4)
  adddatum2(obj5034, *var_superclass_39_, 8);
  sourceObject = obj5034;
// Begin line 1150
  setline(1150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6118 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6119 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call6120 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6119);
// compiled call node returning call6120 (depth = 7)
// compiled member node returning call6120 (depth = 6)
  partcv[0] = 0;
  Object call6121 = callmethod(call6120, "empty",
    1, partcv, params);
  gc_frame_end(callframe6118);
// compiled call node returning call6121 (depth = 5)
// compiled member node returning call6121 (depth = 4)
  adddatum2(obj5034, call6121, 9);
  sourceObject = obj5034;
// Begin line 1151
  setline(1151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6122 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6123 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6124 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6123);
// compiled call node returning call6124 (depth = 7)
// compiled member node returning call6124 (depth = 6)
  partcv[0] = 0;
  Object call6125 = callmethod(call6124, "value",
    1, partcv, params);
  gc_frame_end(callframe6122);
// compiled call node returning call6125 (depth = 5)
// compiled member node returning call6125 (depth = 4)
  adddatum2(obj5034, call6125, 10);
  sourceObject = obj5034;
// Begin line 1153
  setline(1153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool6126 = alloc_Boolean(0);
// compiled identifier node returning bool6126 (depth = 4)
  adddatum2(obj5034, bool6126, 11);
  sourceObject = obj5034;
  sourceObject = obj5034;
  sourceObject = obj5034;
  sourceObject = obj5034;
  sourceObject = obj5034;
  sourceObject = obj5034;
  sourceObject = obj5034;
  sourceObject = obj5034;
  sourceObject = obj5034;
  sourceObject = obj5034;
  sourceObject = obj5034;
  sourceObject = obj5034;
  sourceObject = obj5034;
  sourceObject = obj5034;
  sourceObject = obj5034;
  sourceObject = obj5034;
  sourceObject = obj5034;
  objclass5034 = obj5034->class;
  objclass5034->definitionModule = modulename;
  objclass5034->definitionLine = 1124;
  (*(struct UserObject *)self).data[0] = lowerouter5034;
  self = oldself5034;
  selfslot = oldselfslot5034;
  stackframe = oldstackframe5034;
  gc_frame_end(frame);
  return obj5034;
}
Object meth_ast_new5033_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 6)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_nullNode = getfromclosure(closure, 2);
  Object *var_classNode = getfromclosure(closure, 3);
  Object *var_baseNode = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_signature_39_ = &(stackframe->slots[1]);
  *var_signature_39_ = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[2]);
  *var_body_39_ = args[curarg];
  curarg++;
  Object *var_superclass_39_ = &(stackframe->slots[3]);
  *var_superclass_39_ = args[curarg];
  curarg++;
  Object *var_constructor_39_ = &(stackframe->slots[4]);
  *var_constructor_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[5]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 6)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[6]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5034 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5034 = alloc_userobj2(38,30, objclass5034);
  gc_frame_newslot(obj5034);
if (objclass5034 == NULL) {
  glfree(obj5034->class->name);
  obj5034->class->name = "classNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5034, self, 0);
  addmethodreal(obj5034,"outer", &reader_ast_outer_5035);
  Object oldself5034 = self;
  struct StackFrameObject *oldstackframe5034 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5034);
  gc_frame_newslot((Object)stackframe);
  self = obj5034;
  Object *oldselfslot5034 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5034 = (*(struct UserObject *)self).data[0], lowerouter5034 = thisouter5034;
  if (inheritingObject5034) {
    struct UserObject *inho5034 = (struct UserObject *)inheritingObject5034;
    while (inho5034->super != GraceDefaultObject) inho5034 = (struct UserObject *)inho5034->super;
    inho5034->super = obj5034;
    self = inheritingObject5034;
    *selfslot = self;
    lowerouter5034 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5034;
  }
if (objclass5034 == NULL) {
  Method *reader5036 = addmethodrealflags(obj5034, "kind",&reader_ast_kind_5036, MFLAG_DEF);
  reader5036->definitionModule = modulename;
  reader5036->definitionLine = 1142;
}
adddatum2(obj5034, alloc_Undefined(), 1);
if (objclass5034 == NULL) {
  Method *reader5037 = addmethodrealflags(obj5034, "value",&reader_ast_value_5037, 0);
  Method *writer5037 = addmethodrealflags(obj5034, "value:=",&writer_ast_value_5037, 0);
  reader5037->definitionModule = modulename;
  writer5037->definitionModule = modulename;
  reader5037->definitionLine = 1143;
  writer5037->definitionLine = 1143;
}
obj5034->flags |= OFLAG_MUTABLE;
adddatum2(obj5034, alloc_Undefined(), 2);
if (objclass5034 == NULL) {
  Method *reader5038 = addmethodrealflags(obj5034, "name",&reader_ast_name_5038, 0);
  Method *writer5038 = addmethodrealflags(obj5034, "name:=",&writer_ast_name_5038, 0);
  reader5038->definitionModule = modulename;
  writer5038->definitionModule = modulename;
  reader5038->definitionLine = 1144;
  writer5038->definitionLine = 1144;
}
obj5034->flags |= OFLAG_MUTABLE;
adddatum2(obj5034, alloc_Undefined(), 3);
if (objclass5034 == NULL) {
  Method *reader5039 = addmethodrealflags(obj5034, "constructor",&reader_ast_constructor_5039, 0);
  Method *writer5039 = addmethodrealflags(obj5034, "constructor:=",&writer_ast_constructor_5039, 0);
  reader5039->definitionModule = modulename;
  writer5039->definitionModule = modulename;
  reader5039->definitionLine = 1145;
  writer5039->definitionLine = 1145;
}
obj5034->flags |= OFLAG_MUTABLE;
adddatum2(obj5034, alloc_Undefined(), 4);
if (objclass5034 == NULL) {
  Method *reader5040 = addmethodrealflags(obj5034, "signature",&reader_ast_signature_5040, 0);
  Method *writer5040 = addmethodrealflags(obj5034, "signature:=",&writer_ast_signature_5040, 0);
  reader5040->definitionModule = modulename;
  writer5040->definitionModule = modulename;
  reader5040->definitionLine = 1146;
  writer5040->definitionLine = 1146;
}
obj5034->flags |= OFLAG_MUTABLE;
adddatum2(obj5034, alloc_Undefined(), 5);
if (objclass5034 == NULL) {
  Method *reader5041 = addmethodrealflags(obj5034, "dtype",&reader_ast_dtype_5041, 0);
  Method *writer5041 = addmethodrealflags(obj5034, "dtype:=",&writer_ast_dtype_5041, 0);
  reader5041->definitionModule = modulename;
  writer5041->definitionModule = modulename;
  reader5041->definitionLine = 1147;
  writer5041->definitionLine = 1147;
}
obj5034->flags |= OFLAG_MUTABLE;
adddatum2(obj5034, alloc_Undefined(), 6);
if (objclass5034 == NULL) {
  Method *reader5042 = addmethodrealflags(obj5034, "generics",&reader_ast_generics_5042, 0);
  Method *writer5042 = addmethodrealflags(obj5034, "generics:=",&writer_ast_generics_5042, 0);
  reader5042->definitionModule = modulename;
  writer5042->definitionModule = modulename;
  reader5042->definitionLine = 1148;
  writer5042->definitionLine = 1148;
}
obj5034->flags |= OFLAG_MUTABLE;
adddatum2(obj5034, alloc_Undefined(), 7);
if (objclass5034 == NULL) {
  Method *reader5043 = addmethodrealflags(obj5034, "superclass",&reader_ast_superclass_5043, 0);
  Method *writer5043 = addmethodrealflags(obj5034, "superclass:=",&writer_ast_superclass_5043, 0);
  reader5043->definitionModule = modulename;
  writer5043->definitionModule = modulename;
  reader5043->definitionLine = 1149;
  writer5043->definitionLine = 1149;
}
obj5034->flags |= OFLAG_MUTABLE;
adddatum2(obj5034, alloc_Undefined(), 8);
if (objclass5034 == NULL) {
  Method *reader5044 = addmethodrealflags(obj5034, "annotations",&reader_ast_annotations_5044, 0);
  Method *writer5044 = addmethodrealflags(obj5034, "annotations:=",&writer_ast_annotations_5044, 0);
  reader5044->definitionModule = modulename;
  writer5044->definitionModule = modulename;
  reader5044->definitionLine = 1150;
  writer5044->definitionLine = 1150;
}
obj5034->flags |= OFLAG_MUTABLE;
adddatum2(obj5034, alloc_Undefined(), 9);
if (objclass5034 == NULL) {
  Method *reader5045 = addmethodrealflags(obj5034, "nameString",&reader_ast_nameString_5045, MFLAG_DEF);
  reader5045->definitionModule = modulename;
  reader5045->definitionLine = 1151;
}
adddatum2(obj5034, alloc_Undefined(), 10);
if (objclass5034 == NULL) {
  Method *reader5046 = addmethodrealflags(obj5034, "data",&reader_ast_data_5046, 0);
  Method *writer5046 = addmethodrealflags(obj5034, "data:=",&writer_ast_data_5046, 0);
  reader5046->definitionModule = modulename;
  writer5046->definitionModule = modulename;
  reader5046->definitionLine = 1153;
  writer5046->definitionLine = 1153;
}
obj5034->flags |= OFLAG_MUTABLE;
adddatum2(obj5034, alloc_Undefined(), 11);
// method declarationKindWithAncestors
  struct UserObject *uo5047 = (struct UserObject*)obj5034;
  uo5047->data[12] = emptyclosure;
  Method *meth_meth_ast_declarationKindWithAncestors5047 = addmethod2pos(obj5034, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors5047, 12);
  int argcv_meth_ast_declarationKindWithAncestors5047[] = {1};
  meth_meth_ast_declarationKindWithAncestors5047->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors5047);
  meth_meth_ast_declarationKindWithAncestors5047->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors5047->definitionLine = 1155;
// method scope:=
  struct UserObject *uo5049 = (struct UserObject*)obj5034;
  uo5049->data[13] = emptyclosure;
  Method *meth_meth_ast_scope_58__61_5049 = addmethod2pos(obj5034, "scope:=", &meth_ast_scope_58__61_5049, 13);
  int argcv_meth_ast_scope_58__61_5049[] = {1};
  meth_meth_ast_scope_58__61_5049->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61_5049);
  meth_meth_ast_scope_58__61_5049->definitionModule = modulename;
  meth_meth_ast_scope_58__61_5049->definitionLine = 1158;
// method canInherit
  struct UserObject *uo5054 = (struct UserObject*)obj5034;
  uo5054->data[14] = emptyclosure;
  Method *meth_meth_ast_canInherit5054 = addmethod2pos(obj5034, "canInherit", &meth_ast_canInherit5054, 14);
  int argcv_meth_ast_canInherit5054[] = {0};
  meth_meth_ast_canInherit5054->type = alloc_MethodType(1, argcv_meth_ast_canInherit5054);
  meth_meth_ast_canInherit5054->definitionModule = modulename;
  meth_meth_ast_canInherit5054->definitionLine = 1164;
// method returnsObject
  struct UserObject *uo5056 = (struct UserObject*)obj5034;
  uo5056->data[15] = emptyclosure;
  Method *meth_meth_ast_returnsObject5056 = addmethod2pos(obj5034, "returnsObject", &meth_ast_returnsObject5056, 15);
  int argcv_meth_ast_returnsObject5056[] = {0};
  meth_meth_ast_returnsObject5056->type = alloc_MethodType(1, argcv_meth_ast_returnsObject5056);
  meth_meth_ast_returnsObject5056->definitionModule = modulename;
  meth_meth_ast_returnsObject5056->definitionLine = 1165;
// method returnedObjectScope
  struct UserObject *uo5058 = (struct UserObject*)obj5034;
  uo5058->data[16] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope5058 = addmethod2pos(obj5034, "returnedObjectScope", &meth_ast_returnedObjectScope5058, 16);
  int argcv_meth_ast_returnedObjectScope5058[] = {0};
  meth_meth_ast_returnedObjectScope5058->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope5058);
  meth_meth_ast_returnedObjectScope5058->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope5058->definitionLine = 1166;
// method isClass
  struct UserObject *uo5061 = (struct UserObject*)obj5034;
  uo5061->data[17] = emptyclosure;
  Method *meth_meth_ast_isClass5061 = addmethod2pos(obj5034, "isClass", &meth_ast_isClass5061, 17);
  int argcv_meth_ast_isClass5061[] = {0};
  meth_meth_ast_isClass5061->type = alloc_MethodType(1, argcv_meth_ast_isClass5061);
  meth_meth_ast_isClass5061->definitionModule = modulename;
  meth_meth_ast_isClass5061->definitionLine = 1168;
// method isPublic
  struct UserObject *uo5063 = (struct UserObject*)obj5034;
  uo5063->data[18] = emptyclosure;
  Method *meth_meth_ast_isPublic5063 = addmethod2pos(obj5034, "isPublic", &meth_ast_isPublic5063, 18);
  int argcv_meth_ast_isPublic5063[] = {0};
  meth_meth_ast_isPublic5063->type = alloc_MethodType(1, argcv_meth_ast_isPublic5063);
  meth_meth_ast_isPublic5063->definitionModule = modulename;
  meth_meth_ast_isPublic5063->definitionLine = 1169;
// method isWritable
  struct UserObject *uo5083 = (struct UserObject*)obj5034;
  uo5083->data[19] = emptyclosure;
  Method *meth_meth_ast_isWritable5083 = addmethod2pos(obj5034, "isWritable", &meth_ast_isWritable5083, 19);
  int argcv_meth_ast_isWritable5083[] = {0};
  meth_meth_ast_isWritable5083->type = alloc_MethodType(1, argcv_meth_ast_isWritable5083);
  meth_meth_ast_isWritable5083->definitionModule = modulename;
  meth_meth_ast_isWritable5083->definitionLine = 1174;
// method isReadable
  struct UserObject *uo5085 = (struct UserObject*)obj5034;
  uo5085->data[20] = emptyclosure;
  Method *meth_meth_ast_isReadable5085 = addmethod2pos(obj5034, "isReadable", &meth_ast_isReadable5085, 20);
  int argcv_meth_ast_isReadable5085[] = {0};
  meth_meth_ast_isReadable5085->type = alloc_MethodType(1, argcv_meth_ast_isReadable5085);
  meth_meth_ast_isReadable5085->definitionModule = modulename;
  meth_meth_ast_isReadable5085->definitionLine = 1175;
// method usesAsType
  struct UserObject *uo5088 = (struct UserObject*)obj5034;
  uo5088->data[21] = emptyclosure;
  Method *meth_meth_ast_usesAsType5088 = addmethod2pos(obj5034, "usesAsType", &meth_ast_usesAsType5088, 21);
  int argcv_meth_ast_usesAsType5088[] = {1};
  meth_meth_ast_usesAsType5088->type = alloc_MethodType(1, argcv_meth_ast_usesAsType5088);
  meth_meth_ast_usesAsType5088->definitionModule = modulename;
  meth_meth_ast_usesAsType5088->definitionLine = 1176;
// method parametersDo
  struct UserObject *uo5094 = (struct UserObject*)obj5034;
  uo5094->data[22] = emptyclosure;
  Method *meth_meth_ast_parametersDo5094 = addmethod2pos(obj5034, "parametersDo", &meth_ast_parametersDo5094, 22);
  int argcv_meth_ast_parametersDo5094[] = {1};
  meth_meth_ast_parametersDo5094->type = alloc_MethodType(1, argcv_meth_ast_parametersDo5094);
  meth_meth_ast_parametersDo5094->definitionModule = modulename;
  meth_meth_ast_parametersDo5094->definitionLine = 1179;
// method accept()from
  struct UserObject *uo5111 = (struct UserObject*)obj5034;
  uo5111->data[23] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from5111 = addmethod2pos(obj5034, "accept()from", &meth_ast_accept_40__41_from5111, 23);
  int argcv_meth_ast_accept_40__41_from5111[] = {1, 1};
  meth_meth_ast_accept_40__41_from5111->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from5111);
  meth_meth_ast_accept_40__41_from5111->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from5111->definitionLine = 1184;
// method map()ancestors
  struct UserObject *uo5190 = (struct UserObject*)obj5034;
  uo5190->data[24] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors5190 = addmethod2pos(obj5034, "map()ancestors", &meth_ast_map_40__41_ancestors5190, 24);
  int argcv_meth_ast_map_40__41_ancestors5190[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors5190->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors5190);
  meth_meth_ast_map_40__41_ancestors5190->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors5190->definitionLine = 1211;
// method pretty
  block_savedest(obj5034);
  Object closure5269 = createclosure(1, "pretty");
  setclosureframe(closure5269, stackframe);
  addtoclosure(closure5269, var_util);
  struct UserObject *uo5269 = (struct UserObject*)obj5034;
  uo5269->data[25] = (Object)closure5269;
  Method *meth_meth_ast_pretty5269 = addmethod2pos(obj5034, "pretty", &meth_ast_pretty5269, 25);
  int argcv_meth_ast_pretty5269[] = {1};
  meth_meth_ast_pretty5269->type = alloc_MethodType(1, argcv_meth_ast_pretty5269);
  meth_meth_ast_pretty5269->definitionModule = modulename;
  meth_meth_ast_pretty5269->definitionLine = 1224;
// method toGrace
  struct UserObject *uo5871 = (struct UserObject*)obj5034;
  uo5871->data[26] = emptyclosure;
  Method *meth_meth_ast_toGrace5871 = addmethod2pos(obj5034, "toGrace", &meth_ast_toGrace5871, 26);
  int argcv_meth_ast_toGrace5871[] = {1};
  meth_meth_ast_toGrace5871->type = alloc_MethodType(1, argcv_meth_ast_toGrace5871);
meth_meth_ast_toGrace5871->type->types[0] = type_Number;
meth_meth_ast_toGrace5871->type->names[0] = "depth";
  meth_meth_ast_toGrace5871->definitionModule = modulename;
  meth_meth_ast_toGrace5871->definitionLine = 1276;
// method shallowCopy
  block_savedest(obj5034);
  Object closure6098 = createclosure(3, "shallowCopy");
  setclosureframe(closure6098, stackframe);
  addtoclosure(closure6098, var_emptySeq);
  addtoclosure(closure6098, var_nullNode);
  addtoclosure(closure6098, var_classNode);
  struct UserObject *uo6098 = (struct UserObject*)obj5034;
  uo6098->data[27] = (Object)closure6098;
  Method *meth_meth_ast_shallowCopy6098 = addmethod2pos(obj5034, "shallowCopy", &meth_ast_shallowCopy6098, 27);
  int argcv_meth_ast_shallowCopy6098[] = {0};
  meth_meth_ast_shallowCopy6098->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy6098);
  meth_meth_ast_shallowCopy6098->definitionModule = modulename;
  meth_meth_ast_shallowCopy6098->definitionLine = 1313;
// method shallowCopyFieldsFrom
  struct UserObject *uo6107 = (struct UserObject*)obj5034;
  uo6107->data[28] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom6107 = addmethod2pos(obj5034, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom6107, 28);
  int argcv_meth_ast_shallowCopyFieldsFrom6107[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom6107->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom6107);
  meth_meth_ast_shallowCopyFieldsFrom6107->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom6107->definitionLine = 1317;
  sourceObject = obj5034;
// Begin line 1141
  setline(1141);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6114 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6115 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe6114);
// compiled call node returning call6115 (depth = 4)
  struct UserObject *obj5034_uo = (struct UserObject *)obj5034;
  obj5034_uo->super = call6115;
  sourceObject = obj5034;
// Begin line 1142
  setline(1142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit6116 == NULL) {
    strlit6116 = alloc_String("class");
    gc_root(strlit6116);
  }
// compiled string node returning strlit6116 (depth = 4)
  adddatum2(obj5034, strlit6116, 1);
  sourceObject = obj5034;
// Begin line 1143
  setline(1143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_body_39_ (depth = 4)
  adddatum2(obj5034, *var_body_39_, 2);
  sourceObject = obj5034;
// Begin line 1144
  setline(1144);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_name_39_ (depth = 4)
  adddatum2(obj5034, *var_name_39_, 3);
  sourceObject = obj5034;
// Begin line 1145
  setline(1145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_constructor_39_ (depth = 4)
  adddatum2(obj5034, *var_constructor_39_, 4);
  sourceObject = obj5034;
// Begin line 1146
  setline(1146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_signature_39_ (depth = 4)
  adddatum2(obj5034, *var_signature_39_, 5);
  sourceObject = obj5034;
// Begin line 1147
  setline(1147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_dtype_39_ (depth = 4)
  adddatum2(obj5034, *var_dtype_39_, 6);
  sourceObject = obj5034;
// Begin line 1148
  setline(1148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool6117 = alloc_Boolean(0);
// compiled identifier node returning bool6117 (depth = 4)
  adddatum2(obj5034, bool6117, 7);
  sourceObject = obj5034;
// Begin line 1149
  setline(1149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_superclass_39_ (depth = 4)
  adddatum2(obj5034, *var_superclass_39_, 8);
  sourceObject = obj5034;
// Begin line 1150
  setline(1150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6118 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6119 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call6120 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6119);
// compiled call node returning call6120 (depth = 7)
// compiled member node returning call6120 (depth = 6)
  partcv[0] = 0;
  Object call6121 = callmethod(call6120, "empty",
    1, partcv, params);
  gc_frame_end(callframe6118);
// compiled call node returning call6121 (depth = 5)
// compiled member node returning call6121 (depth = 4)
  adddatum2(obj5034, call6121, 9);
  sourceObject = obj5034;
// Begin line 1151
  setline(1151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6122 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6123 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6124 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6123);
// compiled call node returning call6124 (depth = 7)
// compiled member node returning call6124 (depth = 6)
  partcv[0] = 0;
  Object call6125 = callmethod(call6124, "value",
    1, partcv, params);
  gc_frame_end(callframe6122);
// compiled call node returning call6125 (depth = 5)
// compiled member node returning call6125 (depth = 4)
  adddatum2(obj5034, call6125, 10);
  sourceObject = obj5034;
// Begin line 1153
  setline(1153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool6126 = alloc_Boolean(0);
// compiled identifier node returning bool6126 (depth = 4)
  adddatum2(obj5034, bool6126, 11);
  sourceObject = obj5034;
  sourceObject = obj5034;
  sourceObject = obj5034;
  sourceObject = obj5034;
  sourceObject = obj5034;
  sourceObject = obj5034;
  sourceObject = obj5034;
  sourceObject = obj5034;
  sourceObject = obj5034;
  sourceObject = obj5034;
  sourceObject = obj5034;
  sourceObject = obj5034;
  sourceObject = obj5034;
  sourceObject = obj5034;
  sourceObject = obj5034;
  sourceObject = obj5034;
  sourceObject = obj5034;
  objclass5034 = obj5034->class;
  objclass5034->definitionModule = modulename;
  objclass5034->definitionLine = 1124;
  (*(struct UserObject *)self).data[0] = lowerouter5034;
  self = oldself5034;
  selfslot = oldselfslot5034;
  stackframe = oldstackframe5034;
  gc_frame_end(frame);
  return obj5034;
}
Object meth_ast_body_40__41_named_40__41_scope6130(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "body()named()scope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method body()named()scope");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method body()named()scope");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method body()named()scope");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for body()named()scope (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for body");
  Object *var_n = &(stackframe->slots[1]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for named");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    gracedie("wrong number of arguments for scope");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "result");
// Begin line 1325
  setline(1325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6131 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_b (depth = 5)
  gc_frame_newslot(*var_b);
// call case 4: self request
  params[0] = *var_b;
  partcv[0] = 1;
  Object call6132 = callmethodflags(self, "new", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6131);
// compiled call node returning call6132 (depth = 4)
  *var_result = call6132;
  if (call6132 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1326
  setline(1326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 1151
  setline(1151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6133 = gc_frame_new();
// Begin line 1326
  setline(1326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call6134 = callmethod(*var_result, "classname:=",
    1, partcv, params);
  gc_frame_end(callframe6133);
// compiled call node returning call6134 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 1327
  setline(1327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 1151
  setline(1151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6135 = gc_frame_new();
// Begin line 1327
  setline(1327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  gc_frame_newslot(*var_s);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call6136 = callmethod(*var_result, "scope:=",
    1, partcv, params);
  gc_frame_end(callframe6135);
// compiled call node returning call6136 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 1328
  setline(1328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_classname6141(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "classname");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for classname (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for classname");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1333
  setline(1333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6142 == NULL) {
    strlit6142 = alloc_String("module");
    gc_root(strlit6142);
  }
// compiled string node returning strlit6142 (depth = 3)
  gc_frame_end(frame);
  return strlit6142;
}
Object meth_ast_isModule6143(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isModule");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isModule (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isModule");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1334
  setline(1334);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6144 = alloc_Boolean(1);
// compiled identifier node returning bool6144 (depth = 3)
  gc_frame_end(frame);
  return bool6144;
}
Object meth_ast_returnsObject6145(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnsObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for returnsObject (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for returnsObject");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1335
  setline(1335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6146 = alloc_Boolean(0);
// compiled identifier node returning bool6146 (depth = 3)
  gc_frame_end(frame);
  return bool6146;
}
Object meth_ast__apply6168(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1343
  setline(1343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6169 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_x (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6170 = callmethod(*var_x, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe6169);
// compiled call node returning call6170 (depth = 6)
  gc_frame_end(frame);
  return call6170;
}
Object meth_ast_accept_40__41_from6147(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1337
  setline(1337);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6149 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6150 = callmethod(*var_visitor, "visitModule()up",
    2, partcv, params);
  gc_frame_end(callframe6149);
// compiled call node returning call6150 (depth = 4)
  Object if6148 = done;
  if (istrue(call6150)) {
// Begin line 1338
  setline(1338);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6151 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call6152 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe6151);
// compiled call node returning call6152 (depth = 5)
  *var_newChain = call6152;
  if (call6152 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1339
  setline(1339);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool6155 = alloc_Boolean(0);
// compiled identifier node returning bool6155 (depth = 6)
  int op_slot_right_6154 = gc_frame_newslot(bool6155);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6157 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6158 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6157);
// compiled call node returning call6158 (depth = 7)
// compiled member node returning call6158 (depth = 6)
  int op_slot_left_6154 = gc_frame_newslot(call6158);
  params[0] = bool6155;
  partcv[0] = 1;
  Object opresult6159 = callmethod(call6158, "!=", 1, partcv, params);
// compiled op node returning opresult6159 (depth = 5)
  Object if6153 = done;
  if (istrue(opresult6159)) {
// Begin line 1340
  setline(1340);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6160 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6161 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6162 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6161);
// compiled call node returning call6162 (depth = 7)
// compiled member node returning call6162 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6163 = callmethod(call6162, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe6160);
// compiled call node returning call6163 (depth = 5)
    gc_frame_newslot(call6163);
    if6153 = call6163;
  } else {
  }
// compiled if node returning if6153 (depth = 4)
// Begin line 1342
  setline(1342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6164 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6165 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6166 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6165);
// compiled call node returning call6166 (depth = 6)
// compiled member node returning call6166 (depth = 5)
  gc_frame_newslot(call6166);
// starting to compile block node (depth = 5)
  Object block6167 = alloc_Block(NULL, NULL, "ast", 1342);
  gc_frame_newslot(block6167);
// method _apply
  block_savedest(block6167);
  Object closure6168 = createclosure(3, "_apply");
  setclosureframe(closure6168, stackframe);
  addtoclosure(closure6168, var_visitor);
  addtoclosure(closure6168, var_newChain);
  addtoclosure(closure6168, selfslot);
  struct UserObject *uo6168 = (struct UserObject*)block6167;
  uo6168->data[0] = (Object)closure6168;
  Method *meth_meth_ast__apply6168 = addmethod2pos(block6167, "_apply", &meth_ast__apply6168, 0);
  int argcv_meth_ast__apply6168[] = {1};
  meth_meth_ast__apply6168->type = alloc_MethodType(1, argcv_meth_ast__apply6168);
  meth_meth_ast__apply6168->definitionModule = modulename;
  meth_meth_ast__apply6168->definitionLine = 1342;
// compiled block node returning block6167 (depth = 5)
  gc_frame_newslot(block6167);
// call case 5: prelude request
  params[0] = call6166;
  params[1] = block6167;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6172 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6164);
// compiled call node returning call6172 (depth = 4)
    gc_frame_newslot(call6172);
    if6148 = call6172;
  } else {
  }
// compiled if node returning if6148 (depth = 3)
  gc_frame_end(frame);
  return if6148;
}
Object meth_ast_shallowCopy6173(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_moduleNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1348
  setline(1348);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6174 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe6175 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_emptySeq (depth = 5)
  gc_frame_newslot(*var_emptySeq);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_moduleNode (depth = 5)
  params[0] = *var_emptySeq;
  partcv[0] = 1;
  Object call6176 = callmethod(*var_moduleNode, "new",
    1, partcv, params);
  gc_frame_end(callframe6175);
// compiled call node returning call6176 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call6177 = callmethod(call6176, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe6174);
// compiled call node returning call6177 (depth = 3)
  gc_frame_end(frame);
  return call6177;
}
Object meth_ast_new6137(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new");
  Object params[3];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_moduleNode = getfromclosure(closure, 1);
  Object *var_objectNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_body = &(stackframe->slots[0]);
  *var_body = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6138 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6138 = alloc_userobj2(7,8, objclass6138);
  gc_frame_newslot(obj6138);
if (objclass6138 == NULL) {
  glfree(obj6138->class->name);
  obj6138->class->name = "obj6128.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6138, self, 0);
  addmethodreal(obj6138,"outer", &reader_ast_outer_6139);
  Object oldself6138 = self;
  struct StackFrameObject *oldstackframe6138 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6138);
  gc_frame_newslot((Object)stackframe);
  self = obj6138;
  Object *oldselfslot6138 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6138 = (*(struct UserObject *)self).data[0], lowerouter6138 = thisouter6138;
  if (inheritingObject6138) {
    struct UserObject *inho6138 = (struct UserObject *)inheritingObject6138;
    while (inho6138->super != GraceDefaultObject) inho6138 = (struct UserObject *)inho6138->super;
    inho6138->super = obj6138;
    self = inheritingObject6138;
    *selfslot = self;
    lowerouter6138 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6138;
  }
if (objclass6138 == NULL) {
  Method *reader6140 = addmethodrealflags(obj6138, "kind",&reader_ast_kind_6140, MFLAG_DEF);
  reader6140->definitionModule = modulename;
  reader6140->definitionLine = 1332;
}
adddatum2(obj6138, alloc_Undefined(), 1);
// method classname
  struct UserObject *uo6141 = (struct UserObject*)obj6138;
  uo6141->data[2] = emptyclosure;
  Method *meth_meth_ast_classname6141 = addmethod2pos(obj6138, "classname", &meth_ast_classname6141, 2);
  int argcv_meth_ast_classname6141[] = {0};
  meth_meth_ast_classname6141->type = alloc_MethodType(1, argcv_meth_ast_classname6141);
  meth_meth_ast_classname6141->definitionModule = modulename;
  meth_meth_ast_classname6141->definitionLine = 1333;
// method isModule
  struct UserObject *uo6143 = (struct UserObject*)obj6138;
  uo6143->data[3] = emptyclosure;
  Method *meth_meth_ast_isModule6143 = addmethod2pos(obj6138, "isModule", &meth_ast_isModule6143, 3);
  int argcv_meth_ast_isModule6143[] = {0};
  meth_meth_ast_isModule6143->type = alloc_MethodType(1, argcv_meth_ast_isModule6143);
  meth_meth_ast_isModule6143->definitionModule = modulename;
  meth_meth_ast_isModule6143->definitionLine = 1334;
// method returnsObject
  struct UserObject *uo6145 = (struct UserObject*)obj6138;
  uo6145->data[4] = emptyclosure;
  Method *meth_meth_ast_returnsObject6145 = addmethod2pos(obj6138, "returnsObject", &meth_ast_returnsObject6145, 4);
  int argcv_meth_ast_returnsObject6145[] = {0};
  meth_meth_ast_returnsObject6145->type = alloc_MethodType(1, argcv_meth_ast_returnsObject6145);
  meth_meth_ast_returnsObject6145->definitionModule = modulename;
  meth_meth_ast_returnsObject6145->definitionLine = 1335;
// method accept()from
  struct UserObject *uo6147 = (struct UserObject*)obj6138;
  uo6147->data[5] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from6147 = addmethod2pos(obj6138, "accept()from", &meth_ast_accept_40__41_from6147, 5);
  int argcv_meth_ast_accept_40__41_from6147[] = {1, 1};
  meth_meth_ast_accept_40__41_from6147->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from6147);
  meth_meth_ast_accept_40__41_from6147->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from6147->definitionLine = 1336;
// method shallowCopy
  block_savedest(obj6138);
  Object closure6173 = createclosure(2, "shallowCopy");
  setclosureframe(closure6173, stackframe);
  addtoclosure(closure6173, var_emptySeq);
  addtoclosure(closure6173, var_moduleNode);
  struct UserObject *uo6173 = (struct UserObject*)obj6138;
  uo6173->data[6] = (Object)closure6173;
  Method *meth_meth_ast_shallowCopy6173 = addmethod2pos(obj6138, "shallowCopy", &meth_ast_shallowCopy6173, 6);
  int argcv_meth_ast_shallowCopy6173[] = {0};
  meth_meth_ast_shallowCopy6173->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy6173);
  meth_meth_ast_shallowCopy6173->definitionModule = modulename;
  meth_meth_ast_shallowCopy6173->definitionLine = 1347;
  sourceObject = obj6138;
// Begin line 1331
  setline(1331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6178 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_body (depth = 4)
  gc_frame_newslot(*var_body);
// starting to compile identifier node (depth = 4)
  Object bool6179 = alloc_Boolean(0);
// compiled identifier node returning bool6179 (depth = 4)
  gc_frame_newslot(bool6179);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_objectNode (depth = 4)
  params[0] = *var_body;
  params[1] = bool6179;
  params[2] = self;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call6180 = callmethod(*var_objectNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe6178);
// compiled call node returning call6180 (depth = 3)
  struct UserObject *obj6138_uo = (struct UserObject *)obj6138;
  obj6138_uo->super = call6180;
  sourceObject = obj6138;
// Begin line 1332
  setline(1332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6181 == NULL) {
    strlit6181 = alloc_String("module");
    gc_root(strlit6181);
  }
// compiled string node returning strlit6181 (depth = 3)
  adddatum2(obj6138, strlit6181, 1);
  sourceObject = obj6138;
  sourceObject = obj6138;
  sourceObject = obj6138;
  sourceObject = obj6138;
  sourceObject = obj6138;
  objclass6138 = obj6138->class;
  objclass6138->definitionModule = modulename;
  objclass6138->definitionLine = 1330;
  (*(struct UserObject *)self).data[0] = lowerouter6138;
  self = oldself6138;
  selfslot = oldselfslot6138;
  stackframe = oldstackframe6138;
  gc_frame_end(frame);
  return obj6138;
}
Object meth_ast_new6137_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new()object");
  Object params[3];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_moduleNode = getfromclosure(closure, 1);
  Object *var_objectNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_body = &(stackframe->slots[0]);
  *var_body = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6138 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6138 = alloc_userobj2(7,8, objclass6138);
  gc_frame_newslot(obj6138);
if (objclass6138 == NULL) {
  glfree(obj6138->class->name);
  obj6138->class->name = "obj6128.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6138, self, 0);
  addmethodreal(obj6138,"outer", &reader_ast_outer_6139);
  Object oldself6138 = self;
  struct StackFrameObject *oldstackframe6138 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6138);
  gc_frame_newslot((Object)stackframe);
  self = obj6138;
  Object *oldselfslot6138 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6138 = (*(struct UserObject *)self).data[0], lowerouter6138 = thisouter6138;
  if (inheritingObject6138) {
    struct UserObject *inho6138 = (struct UserObject *)inheritingObject6138;
    while (inho6138->super != GraceDefaultObject) inho6138 = (struct UserObject *)inho6138->super;
    inho6138->super = obj6138;
    self = inheritingObject6138;
    *selfslot = self;
    lowerouter6138 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6138;
  }
if (objclass6138 == NULL) {
  Method *reader6140 = addmethodrealflags(obj6138, "kind",&reader_ast_kind_6140, MFLAG_DEF);
  reader6140->definitionModule = modulename;
  reader6140->definitionLine = 1332;
}
adddatum2(obj6138, alloc_Undefined(), 1);
// method classname
  struct UserObject *uo6141 = (struct UserObject*)obj6138;
  uo6141->data[2] = emptyclosure;
  Method *meth_meth_ast_classname6141 = addmethod2pos(obj6138, "classname", &meth_ast_classname6141, 2);
  int argcv_meth_ast_classname6141[] = {0};
  meth_meth_ast_classname6141->type = alloc_MethodType(1, argcv_meth_ast_classname6141);
  meth_meth_ast_classname6141->definitionModule = modulename;
  meth_meth_ast_classname6141->definitionLine = 1333;
// method isModule
  struct UserObject *uo6143 = (struct UserObject*)obj6138;
  uo6143->data[3] = emptyclosure;
  Method *meth_meth_ast_isModule6143 = addmethod2pos(obj6138, "isModule", &meth_ast_isModule6143, 3);
  int argcv_meth_ast_isModule6143[] = {0};
  meth_meth_ast_isModule6143->type = alloc_MethodType(1, argcv_meth_ast_isModule6143);
  meth_meth_ast_isModule6143->definitionModule = modulename;
  meth_meth_ast_isModule6143->definitionLine = 1334;
// method returnsObject
  struct UserObject *uo6145 = (struct UserObject*)obj6138;
  uo6145->data[4] = emptyclosure;
  Method *meth_meth_ast_returnsObject6145 = addmethod2pos(obj6138, "returnsObject", &meth_ast_returnsObject6145, 4);
  int argcv_meth_ast_returnsObject6145[] = {0};
  meth_meth_ast_returnsObject6145->type = alloc_MethodType(1, argcv_meth_ast_returnsObject6145);
  meth_meth_ast_returnsObject6145->definitionModule = modulename;
  meth_meth_ast_returnsObject6145->definitionLine = 1335;
// method accept()from
  struct UserObject *uo6147 = (struct UserObject*)obj6138;
  uo6147->data[5] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from6147 = addmethod2pos(obj6138, "accept()from", &meth_ast_accept_40__41_from6147, 5);
  int argcv_meth_ast_accept_40__41_from6147[] = {1, 1};
  meth_meth_ast_accept_40__41_from6147->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from6147);
  meth_meth_ast_accept_40__41_from6147->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from6147->definitionLine = 1336;
// method shallowCopy
  block_savedest(obj6138);
  Object closure6173 = createclosure(2, "shallowCopy");
  setclosureframe(closure6173, stackframe);
  addtoclosure(closure6173, var_emptySeq);
  addtoclosure(closure6173, var_moduleNode);
  struct UserObject *uo6173 = (struct UserObject*)obj6138;
  uo6173->data[6] = (Object)closure6173;
  Method *meth_meth_ast_shallowCopy6173 = addmethod2pos(obj6138, "shallowCopy", &meth_ast_shallowCopy6173, 6);
  int argcv_meth_ast_shallowCopy6173[] = {0};
  meth_meth_ast_shallowCopy6173->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy6173);
  meth_meth_ast_shallowCopy6173->definitionModule = modulename;
  meth_meth_ast_shallowCopy6173->definitionLine = 1347;
  sourceObject = obj6138;
// Begin line 1331
  setline(1331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6178 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_body (depth = 4)
  gc_frame_newslot(*var_body);
// starting to compile identifier node (depth = 4)
  Object bool6179 = alloc_Boolean(0);
// compiled identifier node returning bool6179 (depth = 4)
  gc_frame_newslot(bool6179);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_objectNode (depth = 4)
  params[0] = *var_body;
  params[1] = bool6179;
  params[2] = self;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call6180 = callmethod(*var_objectNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe6178);
// compiled call node returning call6180 (depth = 3)
  struct UserObject *obj6138_uo = (struct UserObject *)obj6138;
  obj6138_uo->super = call6180;
  sourceObject = obj6138;
// Begin line 1332
  setline(1332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6181 == NULL) {
    strlit6181 = alloc_String("module");
    gc_root(strlit6181);
  }
// compiled string node returning strlit6181 (depth = 3)
  adddatum2(obj6138, strlit6181, 1);
  sourceObject = obj6138;
  sourceObject = obj6138;
  sourceObject = obj6138;
  sourceObject = obj6138;
  sourceObject = obj6138;
  objclass6138 = obj6138->class;
  objclass6138->definitionModule = modulename;
  objclass6138->definitionLine = 1330;
  (*(struct UserObject *)self).data[0] = lowerouter6138;
  self = oldself6138;
  selfslot = oldselfslot6138;
  stackframe = oldstackframe6138;
  gc_frame_end(frame);
  return obj6138;
}
Object meth_ast_moduleNode6183(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 26, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "moduleNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_moduleNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for moduleNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹moduleNode›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1323
  setline(1323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_moduleNode (depth = 3)
  gc_frame_end(frame);
  return *var_moduleNode;
}
Object meth_ast_body_40__41_named_40__41_scope6186(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "body()named()scope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method body()named()scope");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method body()named()scope");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method body()named()scope");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for body()named()scope (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for body");
  Object *var_n = &(stackframe->slots[1]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for named");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    gracedie("wrong number of arguments for scope");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "result");
// Begin line 1354
  setline(1354);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6187 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_b (depth = 5)
  gc_frame_newslot(*var_b);
// starting to compile identifier node (depth = 5)
  Object bool6188 = alloc_Boolean(0);
// compiled identifier node returning bool6188 (depth = 5)
  gc_frame_newslot(bool6188);
// call case 4: self request
  params[0] = *var_b;
  params[1] = bool6188;
  partcv[0] = 2;
  Object call6189 = callmethodflags(self, "new", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6187);
// compiled call node returning call6189 (depth = 4)
  *var_result = call6189;
  if (call6189 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1355
  setline(1355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 1342
  setline(1342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6190 = gc_frame_new();
// Begin line 1355
  setline(1355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call6191 = callmethod(*var_result, "classname:=",
    1, partcv, params);
  gc_frame_end(callframe6190);
// compiled call node returning call6191 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 1356
  setline(1356);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 1342
  setline(1342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6192 = gc_frame_new();
// Begin line 1356
  setline(1356);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  gc_frame_newslot(*var_s);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call6193 = callmethod(*var_result, "scope:=",
    1, partcv, params);
  gc_frame_end(callframe6192);
// compiled call node returning call6193 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 1357
  setline(1357);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_body_40__41_named6194(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "body()named");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method body()named");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method body()named");
  Object params[3];
  int partcv[3];
  Object *var_fakeSymbolTable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for body()named (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for body");
  Object *var_n = &(stackframe->slots[1]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for named");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1360
  setline(1360);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6195 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_b (depth = 4)
  gc_frame_newslot(*var_b);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_fakeSymbolTable (depth = 4)
  gc_frame_newslot(*var_fakeSymbolTable);
// call case 4: self request
  params[0] = *var_b;
  params[1] = *var_n;
  params[2] = *var_fakeSymbolTable;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6196 = callmethodflags(self, "body()named()scope", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6195);
// compiled call node returning call6196 (depth = 3)
  gc_frame_end(frame);
  return call6196;
}
Object meth_ast_scope_58__61_6205(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "scope:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method scope:=");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for scope:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_st = &(stackframe->slots[0]);
  *var_st = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for scope:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1374
  setline(1374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 1342
  setline(1342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6206 = gc_frame_new();
// Begin line 1374
  setline(1374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_st (depth = 5)
  gc_frame_newslot(*var_st);
// call case 4: self request
  params[0] = *var_st;
  partcv[0] = 1;
  Object call6207 = callmethodflags(self, "symbolTable:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6206);
// compiled call node returning call6207 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 1375
  setline(1375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 1342
  setline(1342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6208 = gc_frame_new();
// Begin line 1375
  setline(1375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_st (depth = 5)
  params[0] = self;
  partcv[0] = 1;
  Object call6209 = callmethod(*var_st, "node:=",
    1, partcv, params);
  gc_frame_end(callframe6208);
// compiled call node returning call6209 (depth = 4)
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_returnsObject6210(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnsObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for returnsObject (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for returnsObject");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1377
  setline(1377);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6211 = alloc_Boolean(1);
// compiled identifier node returning bool6211 (depth = 3)
  gc_frame_end(frame);
  return bool6211;
}
Object meth_ast_returnedObjectScope6212(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnedObjectScope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for returnedObjectScope (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for returnedObjectScope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1378
  setline(1378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6213 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6214 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6213);
// compiled call node returning call6214 (depth = 4)
// compiled member node returning call6214 (depth = 3)
  gc_frame_end(frame);
  return call6214;
}
Object meth_ast_canInherit6215(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "canInherit");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for canInherit (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for canInherit");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1379
  setline(1379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6216 = alloc_Boolean(1);
// compiled identifier node returning bool6216 (depth = 3)
  gc_frame_end(frame);
  return bool6216;
}
Object meth_ast_isObject6217(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isObject (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isObject");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1380
  setline(1380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6218 = alloc_Boolean(1);
// compiled identifier node returning bool6218 (depth = 3)
  gc_frame_end(frame);
  return bool6218;
}
Object meth_ast__apply6240(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1388
  setline(1388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6241 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_x (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6242 = callmethod(*var_x, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe6241);
// compiled call node returning call6242 (depth = 6)
  gc_frame_end(frame);
  return call6242;
}
Object meth_ast_accept_40__41_from6219(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1382
  setline(1382);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6221 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6222 = callmethod(*var_visitor, "visitObject()up",
    2, partcv, params);
  gc_frame_end(callframe6221);
// compiled call node returning call6222 (depth = 4)
  Object if6220 = done;
  if (istrue(call6222)) {
// Begin line 1383
  setline(1383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6223 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call6224 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe6223);
// compiled call node returning call6224 (depth = 5)
  *var_newChain = call6224;
  if (call6224 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1384
  setline(1384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool6227 = alloc_Boolean(0);
// compiled identifier node returning bool6227 (depth = 6)
  int op_slot_right_6226 = gc_frame_newslot(bool6227);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6229 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6230 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6229);
// compiled call node returning call6230 (depth = 7)
// compiled member node returning call6230 (depth = 6)
  int op_slot_left_6226 = gc_frame_newslot(call6230);
  params[0] = bool6227;
  partcv[0] = 1;
  Object opresult6231 = callmethod(call6230, "!=", 1, partcv, params);
// compiled op node returning opresult6231 (depth = 5)
  Object if6225 = done;
  if (istrue(opresult6231)) {
// Begin line 1385
  setline(1385);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6232 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6233 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6234 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6233);
// compiled call node returning call6234 (depth = 7)
// compiled member node returning call6234 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6235 = callmethod(call6234, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe6232);
// compiled call node returning call6235 (depth = 5)
    gc_frame_newslot(call6235);
    if6225 = call6235;
  } else {
  }
// compiled if node returning if6225 (depth = 4)
// Begin line 1387
  setline(1387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6236 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6237 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6238 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6237);
// compiled call node returning call6238 (depth = 6)
// compiled member node returning call6238 (depth = 5)
  gc_frame_newslot(call6238);
// starting to compile block node (depth = 5)
  Object block6239 = alloc_Block(NULL, NULL, "ast", 1387);
  gc_frame_newslot(block6239);
// method _apply
  block_savedest(block6239);
  Object closure6240 = createclosure(3, "_apply");
  setclosureframe(closure6240, stackframe);
  addtoclosure(closure6240, var_visitor);
  addtoclosure(closure6240, var_newChain);
  addtoclosure(closure6240, selfslot);
  struct UserObject *uo6240 = (struct UserObject*)block6239;
  uo6240->data[0] = (Object)closure6240;
  Method *meth_meth_ast__apply6240 = addmethod2pos(block6239, "_apply", &meth_ast__apply6240, 0);
  int argcv_meth_ast__apply6240[] = {1};
  meth_meth_ast__apply6240->type = alloc_MethodType(1, argcv_meth_ast__apply6240);
  meth_meth_ast__apply6240->definitionModule = modulename;
  meth_meth_ast__apply6240->definitionLine = 1387;
// compiled block node returning block6239 (depth = 5)
  gc_frame_newslot(block6239);
// call case 5: prelude request
  params[0] = call6238;
  params[1] = block6239;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6244 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6236);
// compiled call node returning call6244 (depth = 4)
    gc_frame_newslot(call6244);
    if6220 = call6244;
  } else {
  }
// compiled if node returning if6220 (depth = 3)
  gc_frame_end(frame);
  return if6220;
}
Object meth_ast_nameString6245(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for nameString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for nameString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1393
  setline(1393);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6248 == NULL) {
    strlit6248 = alloc_String("object");
    gc_root(strlit6248);
  }
// compiled string node returning strlit6248 (depth = 5)
  int op_slot_right_6247 = gc_frame_newslot(strlit6248);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6250 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6251 = callmethodflags(self, "classname", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6250);
// compiled call node returning call6251 (depth = 6)
// compiled member node returning call6251 (depth = 5)
  int op_slot_left_6247 = gc_frame_newslot(call6251);
  params[0] = strlit6248;
  partcv[0] = 1;
  Object opresult6252 = callmethod(call6251, "==", 1, partcv, params);
// compiled op node returning opresult6252 (depth = 4)
  Object if6246 = done;
  if (istrue(opresult6252)) {
// Begin line 1394
  setline(1394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6254 == NULL) {
    strlit6254 = alloc_String("");
    gc_root(strlit6254);
  }
// compiled string node returning strlit6254 (depth = 5)
  int op_slot_right_6253 = gc_frame_newslot(strlit6254);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6257 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6258 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6257);
// compiled call node returning call6258 (depth = 7)
// compiled member node returning call6258 (depth = 6)
  int op_slot_right_6256 = gc_frame_newslot(call6258);
// starting to compile string node (depth = 6)
  if (strlit6260 == NULL) {
    strlit6260 = alloc_String("object_on_line_");
    gc_root(strlit6260);
  }
// compiled string node returning strlit6260 (depth = 6)
  int op_slot_left_6256 = gc_frame_newslot(strlit6260);
  params[0] = call6258;
  partcv[0] = 1;
  Object opresult6261 = callmethod(strlit6260, "++", 1, partcv, params);
// compiled op node returning opresult6261 (depth = 5)
  int op_slot_left_6253 = gc_frame_newslot(opresult6261);
  params[0] = strlit6254;
  partcv[0] = 1;
  Object opresult6262 = callmethod(opresult6261, "++", 1, partcv, params);
// compiled op node returning opresult6262 (depth = 4)
    gc_frame_newslot(opresult6262);
    if6246 = opresult6262;
  } else {
// Begin line 1396
  setline(1396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6263 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6264 = callmethodflags(self, "classname", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6263);
// compiled call node returning call6264 (depth = 5)
// compiled member node returning call6264 (depth = 4)
    gc_frame_newslot(call6264);
    if6246 = call6264;
  }
// compiled if node returning if6246 (depth = 3)
  gc_frame_end(frame);
  return if6246;
}
Object meth_ast_map_40__41_ancestors6265(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1400
  setline(1400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6266 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6267 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6266);
// compiled call node returning call6267 (depth = 5)
// compiled member node returning call6267 (depth = 4)
  *var_n = call6267;
  if (call6267 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1401
  setline(1401);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6268 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call6269 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe6268);
// compiled call node returning call6269 (depth = 4)
  *var_newChain = call6269;
  if (call6269 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1402
  setline(1402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 1400
  setline(1400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6270 = gc_frame_new();
// Begin line 1402
  setline(1402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6271 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6272 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6273 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6272);
// compiled call node returning call6273 (depth = 7)
// compiled member node returning call6273 (depth = 6)
  gc_frame_newslot(call6273);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6274 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6275 = gc_frame_new();
// call case 3: self.outer request
  Object call6276 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6275);
// compiled call node returning call6276 (depth = 9)
// compiled member node returning call6276 (depth = 8)
  partcv[0] = 0;
  Object call6277 = callmethodflags(call6276, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6274);
// compiled call node returning call6277 (depth = 7)
// compiled member node returning call6277 (depth = 6)
  params[0] = call6273;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call6278 = callmethodflags(call6277, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6271);
// compiled call node returning call6278 (depth = 5)
  gc_frame_newslot(call6278);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  params[0] = call6278;
  partcv[0] = 1;
  Object call6279 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe6270);
// compiled call node returning call6279 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 1403
  setline(1403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 1402
  setline(1402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6280 = gc_frame_new();
// Begin line 1403
  setline(1403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6281 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6282 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6283 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6282);
// compiled call node returning call6283 (depth = 7)
// compiled member node returning call6283 (depth = 6)
  gc_frame_newslot(call6283);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6284 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6285 = gc_frame_new();
// call case 3: self.outer request
  Object call6286 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6285);
// compiled call node returning call6286 (depth = 9)
// compiled member node returning call6286 (depth = 8)
  partcv[0] = 0;
  Object call6287 = callmethodflags(call6286, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6284);
// compiled call node returning call6287 (depth = 7)
// compiled member node returning call6287 (depth = 6)
  params[0] = call6283;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call6288 = callmethodflags(call6287, "maybeMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6281);
// compiled call node returning call6288 (depth = 5)
  gc_frame_newslot(call6288);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  params[0] = call6288;
  partcv[0] = 1;
  Object call6289 = callmethod(*var_n, "superclass:=",
    1, partcv, params);
  gc_frame_end(callframe6280);
// compiled call node returning call6289 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 1404
  setline(1404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6290 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call6291 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe6290);
// compiled call node returning call6291 (depth = 3)
  gc_frame_end(frame);
  return call6291;
}
Object meth_ast__apply6300(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1410
  setline(1410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6302 == NULL) {
    strlit6302 = alloc_String("  ");
    gc_root(strlit6302);
  }
// compiled string node returning strlit6302 (depth = 7)
  int op_slot_right_6301 = gc_frame_newslot(strlit6302);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_6301 = gc_frame_newslot(*var_spc);
  params[0] = strlit6302;
  partcv[0] = 1;
  Object opresult6304 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult6304 (depth = 6)
  *var_spc = opresult6304;
  if (opresult6304 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply6369(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1420
  setline(1420);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6371 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num6373 = alloc_Float64(1);
// compiled num node returning num6373 (depth = 9)
  int op_slot_right_6372 = gc_frame_newslot(num6373);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_6372 = gc_frame_newslot(*var_depth);
  params[0] = num6373;
  partcv[0] = 1;
  Object sum6375 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum6375 (depth = 8)
  gc_frame_newslot(sum6375);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_x (depth = 8)
  params[0] = sum6375;
  partcv[0] = 1;
  Object call6376 = callmethod(*var_x, "pretty",
    1, partcv, params);
  gc_frame_end(callframe6371);
// compiled call node returning call6376 (depth = 7)
  int op_slot_right_6370 = gc_frame_newslot(call6376);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_6378 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6381 == NULL) {
    strlit6381 = alloc_String("""\x0a""");
    gc_root(strlit6381);
  }
// compiled string node returning strlit6381 (depth = 9)
  int op_slot_right_6380 = gc_frame_newslot(strlit6381);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_6380 = gc_frame_newslot(*var_s);
  params[0] = strlit6381;
  partcv[0] = 1;
  Object opresult6383 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6383 (depth = 8)
  int op_slot_left_6378 = gc_frame_newslot(opresult6383);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6384 = callmethod(opresult6383, "++", 1, partcv, params);
// compiled op node returning opresult6384 (depth = 7)
  int op_slot_left_6370 = gc_frame_newslot(opresult6384);
  params[0] = call6376;
  partcv[0] = 1;
  Object opresult6385 = callmethod(opresult6384, "++", 1, partcv, params);
// compiled op node returning opresult6385 (depth = 6)
  *var_s = opresult6385;
  if (opresult6385 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty6292(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth_39_ = &(stackframe->slots[0]);
  *var_depth_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_depth = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "depth");
  Object *var_spc = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "spc");
  Object *var_s = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "s");
// Begin line 1407
  setline(1407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_depth_39_ (depth = 4)
  *var_depth = *var_depth_39_;
  if (*var_depth_39_ == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1408
  setline(1408);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6293 == NULL) {
    strlit6293 = alloc_String("");
    gc_root(strlit6293);
  }
// compiled string node returning strlit6293 (depth = 4)
  *var_spc = strlit6293;
  if (strlit6293 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1409
  setline(1409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6294 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_6295 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num6297 = alloc_Float64(0);
// compiled num node returning num6297 (depth = 5)
  int op_slot_left_6295 = gc_frame_newslot(num6297);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult6298 = callmethod(num6297, "..", 1, partcv, params);
// compiled op node returning opresult6298 (depth = 4)
  gc_frame_newslot(opresult6298);
// starting to compile block node (depth = 4)
  Object block6299 = alloc_Block(NULL, NULL, "ast", 1409);
  gc_frame_newslot(block6299);
// method _apply
  block_savedest(block6299);
  Object closure6300 = createclosure(2, "_apply");
  setclosureframe(closure6300, stackframe);
  addtoclosure(closure6300, var_spc);
  addtoclosure(closure6300, selfslot);
  struct UserObject *uo6300 = (struct UserObject*)block6299;
  uo6300->data[0] = (Object)closure6300;
  Method *meth_meth_ast__apply6300 = addmethod2pos(block6299, "_apply", &meth_ast__apply6300, 0);
  int argcv_meth_ast__apply6300[] = {1};
  meth_meth_ast__apply6300->type = alloc_MethodType(1, argcv_meth_ast__apply6300);
  meth_meth_ast__apply6300->definitionModule = modulename;
  meth_meth_ast__apply6300->definitionLine = 1403;
// compiled block node returning block6299 (depth = 4)
  gc_frame_newslot(block6299);
// call case 5: prelude request
  params[0] = opresult6298;
  params[1] = block6299;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6307 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6294);
// compiled call node returning call6307 (depth = 3)
// Begin line 1412
  setline(1412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6308 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call6309 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe6308);
// compiled call node returning call6309 (depth = 4)
  *var_s = call6309;
  if (call6309 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1413
  setline(1413);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool6312 = alloc_Boolean(0);
// compiled identifier node returning bool6312 (depth = 5)
  int op_slot_right_6311 = gc_frame_newslot(bool6312);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6314 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6315 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6314);
// compiled call node returning call6315 (depth = 6)
// compiled member node returning call6315 (depth = 5)
  int op_slot_left_6311 = gc_frame_newslot(call6315);
  params[0] = bool6312;
  partcv[0] = 1;
  Object opresult6316 = callmethod(call6315, "!=", 1, partcv, params);
// compiled op node returning opresult6316 (depth = 4)
  Object if6310 = done;
  if (istrue(opresult6316)) {
// Begin line 1414
  setline(1414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6318 == NULL) {
    strlit6318 = alloc_String("Superclass:");
    gc_root(strlit6318);
  }
// compiled string node returning strlit6318 (depth = 6)
  int op_slot_right_6317 = gc_frame_newslot(strlit6318);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_6320 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit6323 == NULL) {
    strlit6323 = alloc_String("""\x0a""");
    gc_root(strlit6323);
  }
// compiled string node returning strlit6323 (depth = 8)
  int op_slot_right_6322 = gc_frame_newslot(strlit6323);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_6322 = gc_frame_newslot(*var_s);
  params[0] = strlit6323;
  partcv[0] = 1;
  Object opresult6325 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6325 (depth = 7)
  int op_slot_left_6320 = gc_frame_newslot(opresult6325);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6326 = callmethod(opresult6325, "++", 1, partcv, params);
// compiled op node returning opresult6326 (depth = 6)
  int op_slot_left_6317 = gc_frame_newslot(opresult6326);
  params[0] = strlit6318;
  partcv[0] = 1;
  Object opresult6327 = callmethod(opresult6326, "++", 1, partcv, params);
// compiled op node returning opresult6327 (depth = 5)
  *var_s = opresult6327;
  if (opresult6327 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1415
  setline(1415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6330 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num6332 = alloc_Float64(1);
// compiled num node returning num6332 (depth = 8)
  int op_slot_right_6331 = gc_frame_newslot(num6332);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_6331 = gc_frame_newslot(*var_depth);
  params[0] = num6332;
  partcv[0] = 1;
  Object sum6334 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum6334 (depth = 7)
  gc_frame_newslot(sum6334);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6335 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6336 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6335);
// compiled call node returning call6336 (depth = 8)
// compiled member node returning call6336 (depth = 7)
  params[0] = sum6334;
  partcv[0] = 1;
  Object call6337 = callmethod(call6336, "pretty",
    1, partcv, params);
  gc_frame_end(callframe6330);
// compiled call node returning call6337 (depth = 6)
  int op_slot_right_6329 = gc_frame_newslot(call6337);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_6339 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit6342 == NULL) {
    strlit6342 = alloc_String("""\x0a""  ");
    gc_root(strlit6342);
  }
// compiled string node returning strlit6342 (depth = 8)
  int op_slot_right_6341 = gc_frame_newslot(strlit6342);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_6341 = gc_frame_newslot(*var_s);
  params[0] = strlit6342;
  partcv[0] = 1;
  Object opresult6344 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6344 (depth = 7)
  int op_slot_left_6339 = gc_frame_newslot(opresult6344);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6345 = callmethod(opresult6344, "++", 1, partcv, params);
// compiled op node returning opresult6345 (depth = 6)
  int op_slot_left_6329 = gc_frame_newslot(opresult6345);
  params[0] = call6337;
  partcv[0] = 1;
  Object opresult6346 = callmethod(opresult6345, "++", 1, partcv, params);
// compiled op node returning opresult6346 (depth = 5)
  *var_s = opresult6346;
  if (opresult6346 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1416
  setline(1416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6349 == NULL) {
    strlit6349 = alloc_String("Body:");
    gc_root(strlit6349);
  }
// compiled string node returning strlit6349 (depth = 6)
  int op_slot_right_6348 = gc_frame_newslot(strlit6349);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_6351 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit6354 == NULL) {
    strlit6354 = alloc_String("""\x0a""");
    gc_root(strlit6354);
  }
// compiled string node returning strlit6354 (depth = 8)
  int op_slot_right_6353 = gc_frame_newslot(strlit6354);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_6353 = gc_frame_newslot(*var_s);
  params[0] = strlit6354;
  partcv[0] = 1;
  Object opresult6356 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6356 (depth = 7)
  int op_slot_left_6351 = gc_frame_newslot(opresult6356);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6357 = callmethod(opresult6356, "++", 1, partcv, params);
// compiled op node returning opresult6357 (depth = 6)
  int op_slot_left_6348 = gc_frame_newslot(opresult6357);
  params[0] = strlit6349;
  partcv[0] = 1;
  Object opresult6358 = callmethod(opresult6357, "++", 1, partcv, params);
// compiled op node returning opresult6358 (depth = 5)
  *var_s = opresult6358;
  if (opresult6358 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1417
  setline(1417);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num6361 = alloc_Float64(1);
// compiled num node returning num6361 (depth = 6)
  int op_slot_right_6360 = gc_frame_newslot(num6361);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_6360 = gc_frame_newslot(*var_depth);
  params[0] = num6361;
  partcv[0] = 1;
  Object sum6363 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum6363 (depth = 5)
  *var_depth = sum6363;
  if (sum6363 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if6310 = done;
  } else {
  }
// compiled if node returning if6310 (depth = 3)
// Begin line 1419
  setline(1419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6365 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6366 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6367 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6366);
// compiled call node returning call6367 (depth = 5)
// compiled member node returning call6367 (depth = 4)
  gc_frame_newslot(call6367);
// starting to compile block node (depth = 4)
  Object block6368 = alloc_Block(NULL, NULL, "ast", 1419);
  gc_frame_newslot(block6368);
// method _apply
  block_savedest(block6368);
  Object closure6369 = createclosure(4, "_apply");
  setclosureframe(closure6369, stackframe);
  addtoclosure(closure6369, var_depth);
  addtoclosure(closure6369, var_spc);
  addtoclosure(closure6369, var_s);
  addtoclosure(closure6369, selfslot);
  struct UserObject *uo6369 = (struct UserObject*)block6368;
  uo6369->data[0] = (Object)closure6369;
  Method *meth_meth_ast__apply6369 = addmethod2pos(block6368, "_apply", &meth_ast__apply6369, 0);
  int argcv_meth_ast__apply6369[] = {1};
  meth_meth_ast__apply6369->type = alloc_MethodType(1, argcv_meth_ast__apply6369);
  meth_meth_ast__apply6369->definitionModule = modulename;
  meth_meth_ast__apply6369->definitionLine = 1419;
// compiled block node returning block6368 (depth = 4)
  gc_frame_newslot(block6368);
// call case 5: prelude request
  params[0] = call6367;
  params[1] = block6368;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6388 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6365);
// compiled call node returning call6388 (depth = 3)
// Begin line 1422
  setline(1422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply6401(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1427
  setline(1427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6403 == NULL) {
    strlit6403 = alloc_String("    ");
    gc_root(strlit6403);
  }
// compiled string node returning strlit6403 (depth = 7)
  int op_slot_right_6402 = gc_frame_newslot(strlit6403);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_6402 = gc_frame_newslot(*var_spc);
  params[0] = strlit6403;
  partcv[0] = 1;
  Object opresult6405 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult6405 (depth = 6)
  *var_spc = opresult6405;
  if (opresult6405 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply6414(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1431
  setline(1431);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6416 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num6418 = alloc_Float64(1);
// compiled num node returning num6418 (depth = 9)
  int op_slot_right_6417 = gc_frame_newslot(num6418);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_6417 = gc_frame_newslot(*var_depth);
  params[0] = num6418;
  partcv[0] = 1;
  Object sum6420 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum6420 (depth = 8)
  gc_frame_newslot(sum6420);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_x (depth = 8)
  params[0] = sum6420;
  partcv[0] = 1;
  Object call6421 = callmethod(*var_x, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6416);
// compiled call node returning call6421 (depth = 7)
  int op_slot_right_6415 = gc_frame_newslot(call6421);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit6424 == NULL) {
    strlit6424 = alloc_String("    ");
    gc_root(strlit6424);
  }
// compiled string node returning strlit6424 (depth = 8)
  int op_slot_right_6423 = gc_frame_newslot(strlit6424);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_6426 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit6429 == NULL) {
    strlit6429 = alloc_String("""\x0a""");
    gc_root(strlit6429);
  }
// compiled string node returning strlit6429 (depth = 10)
  int op_slot_right_6428 = gc_frame_newslot(strlit6429);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_6428 = gc_frame_newslot(*var_s);
  params[0] = strlit6429;
  partcv[0] = 1;
  Object opresult6431 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6431 (depth = 9)
  int op_slot_left_6426 = gc_frame_newslot(opresult6431);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6432 = callmethod(opresult6431, "++", 1, partcv, params);
// compiled op node returning opresult6432 (depth = 8)
  int op_slot_left_6423 = gc_frame_newslot(opresult6432);
  params[0] = strlit6424;
  partcv[0] = 1;
  Object opresult6433 = callmethod(opresult6432, "++", 1, partcv, params);
// compiled op node returning opresult6433 (depth = 7)
  int op_slot_left_6415 = gc_frame_newslot(opresult6433);
  params[0] = call6421;
  partcv[0] = 1;
  Object opresult6434 = callmethod(opresult6433, "++", 1, partcv, params);
// compiled op node returning opresult6434 (depth = 6)
  *var_s = opresult6434;
  if (opresult6434 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace6389(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1425
  setline(1425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6390 == NULL) {
    strlit6390 = alloc_String("");
    gc_root(strlit6390);
  }
// compiled string node returning strlit6390 (depth = 4)
  *var_spc = strlit6390;
  if (strlit6390 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1426
  setline(1426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6391 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num6394 = alloc_Float64(1);
// compiled num node returning num6394 (depth = 6)
  int op_slot_right_6393 = gc_frame_newslot(num6394);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_6393 = gc_frame_newslot(*var_depth);
  params[0] = num6394;
  partcv[0] = 1;
  Object diff6396 = callmethod(*var_depth, "-", 1, partcv, params);
// compiled op node returning diff6396 (depth = 5)
  int op_slot_right_6392 = gc_frame_newslot(diff6396);
// starting to compile num node (depth = 5)
  Object num6398 = alloc_Float64(0);
// compiled num node returning num6398 (depth = 5)
  int op_slot_left_6392 = gc_frame_newslot(num6398);
  params[0] = diff6396;
  partcv[0] = 1;
  Object opresult6399 = callmethod(num6398, "..", 1, partcv, params);
// compiled op node returning opresult6399 (depth = 4)
  gc_frame_newslot(opresult6399);
// starting to compile block node (depth = 4)
  Object block6400 = alloc_Block(NULL, NULL, "ast", 1426);
  gc_frame_newslot(block6400);
// method _apply
  block_savedest(block6400);
  Object closure6401 = createclosure(2, "_apply");
  setclosureframe(closure6401, stackframe);
  addtoclosure(closure6401, var_spc);
  addtoclosure(closure6401, selfslot);
  struct UserObject *uo6401 = (struct UserObject*)block6400;
  uo6401->data[0] = (Object)closure6401;
  Method *meth_meth_ast__apply6401 = addmethod2pos(block6400, "_apply", &meth_ast__apply6401, 0);
  int argcv_meth_ast__apply6401[] = {1};
  meth_meth_ast__apply6401->type = alloc_MethodType(1, argcv_meth_ast__apply6401);
  meth_meth_ast__apply6401->definitionModule = modulename;
  meth_meth_ast__apply6401->definitionLine = 1419;
// compiled block node returning block6400 (depth = 4)
  gc_frame_newslot(block6400);
// call case 5: prelude request
  params[0] = opresult6399;
  params[1] = block6400;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6408 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6391);
// compiled call node returning call6408 (depth = 3)
// Begin line 1429
  setline(1429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6409 == NULL) {
    strlit6409 = alloc_String("object {");
    gc_root(strlit6409);
  }
// compiled string node returning strlit6409 (depth = 4)
  *var_s = strlit6409;
  if (strlit6409 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1430
  setline(1430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6410 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6411 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6412 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6411);
// compiled call node returning call6412 (depth = 5)
// compiled member node returning call6412 (depth = 4)
  gc_frame_newslot(call6412);
// starting to compile block node (depth = 4)
  Object block6413 = alloc_Block(NULL, NULL, "ast", 1430);
  gc_frame_newslot(block6413);
// method _apply
  block_savedest(block6413);
  Object closure6414 = createclosure(4, "_apply");
  setclosureframe(closure6414, stackframe);
  addtoclosure(closure6414, var_depth);
  addtoclosure(closure6414, var_spc);
  addtoclosure(closure6414, var_s);
  addtoclosure(closure6414, selfslot);
  struct UserObject *uo6414 = (struct UserObject*)block6413;
  uo6414->data[0] = (Object)closure6414;
  Method *meth_meth_ast__apply6414 = addmethod2pos(block6413, "_apply", &meth_ast__apply6414, 0);
  int argcv_meth_ast__apply6414[] = {1};
  meth_meth_ast__apply6414->type = alloc_MethodType(1, argcv_meth_ast__apply6414);
  meth_meth_ast__apply6414->definitionModule = modulename;
  meth_meth_ast__apply6414->definitionLine = 1430;
// compiled block node returning block6413 (depth = 4)
  gc_frame_newslot(block6413);
// call case 5: prelude request
  params[0] = call6412;
  params[1] = block6413;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6437 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6410);
// compiled call node returning call6437 (depth = 3)
// Begin line 1433
  setline(1433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6439 == NULL) {
    strlit6439 = alloc_String("}");
    gc_root(strlit6439);
  }
// compiled string node returning strlit6439 (depth = 5)
  int op_slot_right_6438 = gc_frame_newslot(strlit6439);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_6441 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6444 == NULL) {
    strlit6444 = alloc_String("""\x0a""");
    gc_root(strlit6444);
  }
// compiled string node returning strlit6444 (depth = 7)
  int op_slot_right_6443 = gc_frame_newslot(strlit6444);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6443 = gc_frame_newslot(*var_s);
  params[0] = strlit6444;
  partcv[0] = 1;
  Object opresult6446 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6446 (depth = 6)
  int op_slot_left_6441 = gc_frame_newslot(opresult6446);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6447 = callmethod(opresult6446, "++", 1, partcv, params);
// compiled op node returning opresult6447 (depth = 5)
  int op_slot_left_6438 = gc_frame_newslot(opresult6447);
  params[0] = strlit6439;
  partcv[0] = 1;
  Object opresult6448 = callmethod(opresult6447, "++", 1, partcv, params);
// compiled op node returning opresult6448 (depth = 4)
  *var_s = opresult6448;
  if (opresult6448 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1434
  setline(1434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy6450(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_objectNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1437
  setline(1437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6451 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe6452 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_emptySeq (depth = 5)
  gc_frame_newslot(*var_emptySeq);
// starting to compile identifier node (depth = 5)
  Object bool6453 = alloc_Boolean(0);
// compiled identifier node returning bool6453 (depth = 5)
  gc_frame_newslot(bool6453);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_objectNode (depth = 5)
  params[0] = *var_emptySeq;
  params[1] = bool6453;
  partcv[0] = 2;
  Object call6454 = callmethod(*var_objectNode, "new",
    1, partcv, params);
  gc_frame_end(callframe6452);
// compiled call node returning call6454 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call6455 = callmethod(call6454, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe6451);
// compiled call node returning call6455 (depth = 3)
  gc_frame_end(frame);
  return call6455;
}
Object meth_ast_shallowCopyFieldsFrom6456(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyFieldsFrom");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopyFieldsFrom (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyFieldsFrom");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1440
  setline(1440);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6457 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call6458 = callmethod4(self, "shallowCopyFieldsFrom", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe6457);
// compiled call node returning call6458 (depth = 3)
// Begin line 1441
  setline(1441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 1430
  setline(1430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6459 = gc_frame_new();
// Begin line 1441
  setline(1441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6460 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  partcv[0] = 0;
  Object call6461 = callmethod(*var_other, "data",
    1, partcv, params);
  gc_frame_end(callframe6460);
// compiled call node returning call6461 (depth = 6)
// compiled member node returning call6461 (depth = 5)
  gc_frame_newslot(call6461);
// call case 4: self request
  params[0] = call6461;
  partcv[0] = 1;
  Object call6462 = callmethodflags(self, "data:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6459);
// compiled call node returning call6462 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 1442
  setline(1442);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 1441
  setline(1441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6463 = gc_frame_new();
// Begin line 1442
  setline(1442);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6464 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  partcv[0] = 0;
  Object call6465 = callmethod(*var_other, "classname",
    1, partcv, params);
  gc_frame_end(callframe6464);
// compiled call node returning call6465 (depth = 6)
// compiled member node returning call6465 (depth = 5)
  gc_frame_newslot(call6465);
// call case 4: self request
  params[0] = call6465;
  partcv[0] = 1;
  Object call6466 = callmethodflags(self, "classname:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6463);
// compiled call node returning call6466 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 1443
  setline(1443);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_asString6467(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1446
  setline(1446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6469 == NULL) {
    strlit6469 = alloc_String("");
    gc_root(strlit6469);
  }
// compiled string node returning strlit6469 (depth = 4)
  int op_slot_right_6468 = gc_frame_newslot(strlit6469);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6472 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6473 = callmethodflags(self, "nameString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6472);
// compiled call node returning call6473 (depth = 6)
// compiled member node returning call6473 (depth = 5)
  int op_slot_right_6471 = gc_frame_newslot(call6473);
// starting to compile string node (depth = 5)
  if (strlit6475 == NULL) {
    strlit6475 = alloc_String("object ");
    gc_root(strlit6475);
  }
// compiled string node returning strlit6475 (depth = 5)
  int op_slot_left_6471 = gc_frame_newslot(strlit6475);
  params[0] = call6473;
  partcv[0] = 1;
  Object opresult6476 = callmethod(strlit6475, "++", 1, partcv, params);
// compiled op node returning opresult6476 (depth = 4)
  int op_slot_left_6468 = gc_frame_newslot(opresult6476);
  params[0] = strlit6469;
  partcv[0] = 1;
  Object opresult6477 = callmethod(opresult6476, "++", 1, partcv, params);
// compiled op node returning opresult6477 (depth = 3)
  gc_frame_end(frame);
  return opresult6477;
}
Object meth_ast_new6197(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_objectNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_body = &(stackframe->slots[0]);
  *var_body = args[curarg];
  curarg++;
  Object *var_superclass_39_ = &(stackframe->slots[1]);
  *var_superclass_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6198 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6198 = alloc_userobj2(23,20, objclass6198);
  gc_frame_newslot(obj6198);
if (objclass6198 == NULL) {
  glfree(obj6198->class->name);
  obj6198->class->name = "obj6184.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6198, self, 0);
  addmethodreal(obj6198,"outer", &reader_ast_outer_6199);
  Object oldself6198 = self;
  struct StackFrameObject *oldstackframe6198 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6198);
  gc_frame_newslot((Object)stackframe);
  self = obj6198;
  Object *oldselfslot6198 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6198 = (*(struct UserObject *)self).data[0], lowerouter6198 = thisouter6198;
  if (inheritingObject6198) {
    struct UserObject *inho6198 = (struct UserObject *)inheritingObject6198;
    while (inho6198->super != GraceDefaultObject) inho6198 = (struct UserObject *)inho6198->super;
    inho6198->super = obj6198;
    self = inheritingObject6198;
    *selfslot = self;
    lowerouter6198 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6198;
  }
if (objclass6198 == NULL) {
  Method *reader6200 = addmethodrealflags(obj6198, "kind",&reader_ast_kind_6200, MFLAG_DEF);
  reader6200->definitionModule = modulename;
  reader6200->definitionLine = 1365;
}
adddatum2(obj6198, alloc_Undefined(), 1);
if (objclass6198 == NULL) {
  Method *reader6201 = addmethodrealflags(obj6198, "value",&reader_ast_value_6201, 0);
  Method *writer6201 = addmethodrealflags(obj6198, "value:=",&writer_ast_value_6201, 0);
  reader6201->definitionModule = modulename;
  writer6201->definitionModule = modulename;
  reader6201->definitionLine = 1366;
  writer6201->definitionLine = 1366;
}
obj6198->flags |= OFLAG_MUTABLE;
adddatum2(obj6198, alloc_Undefined(), 2);
if (objclass6198 == NULL) {
  Method *reader6202 = addmethodrealflags(obj6198, "superclass",&reader_ast_superclass_6202, 0);
  Method *writer6202 = addmethodrealflags(obj6198, "superclass:=",&writer_ast_superclass_6202, 0);
  reader6202->definitionModule = modulename;
  writer6202->definitionModule = modulename;
  reader6202->definitionLine = 1367;
  writer6202->definitionLine = 1367;
}
obj6198->flags |= OFLAG_MUTABLE;
adddatum2(obj6198, alloc_Undefined(), 3);
if (objclass6198 == NULL) {
  Method *reader6203 = addmethodrealflags(obj6198, "classname",&reader_ast_classname_6203, 0);
  Method *writer6203 = addmethodrealflags(obj6198, "classname:=",&writer_ast_classname_6203, 0);
  reader6203->definitionModule = modulename;
  writer6203->definitionModule = modulename;
  reader6203->definitionLine = 1368;
  writer6203->definitionLine = 1368;
}
obj6198->flags |= OFLAG_MUTABLE;
adddatum2(obj6198, alloc_Undefined(), 4);
if (objclass6198 == NULL) {
  Method *reader6204 = addmethodrealflags(obj6198, "data",&reader_ast_data_6204, 0);
  Method *writer6204 = addmethodrealflags(obj6198, "data:=",&writer_ast_data_6204, 0);
  reader6204->definitionModule = modulename;
  writer6204->definitionModule = modulename;
  reader6204->definitionLine = 1369;
  writer6204->definitionLine = 1369;
}
obj6198->flags |= OFLAG_MUTABLE;
adddatum2(obj6198, alloc_Undefined(), 5);
// method scope:=
  struct UserObject *uo6205 = (struct UserObject*)obj6198;
  uo6205->data[6] = emptyclosure;
  Method *meth_meth_ast_scope_58__61_6205 = addmethod2pos(obj6198, "scope:=", &meth_ast_scope_58__61_6205, 6);
  int argcv_meth_ast_scope_58__61_6205[] = {1};
  meth_meth_ast_scope_58__61_6205->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61_6205);
  meth_meth_ast_scope_58__61_6205->definitionModule = modulename;
  meth_meth_ast_scope_58__61_6205->definitionLine = 1371;
// method returnsObject
  struct UserObject *uo6210 = (struct UserObject*)obj6198;
  uo6210->data[7] = emptyclosure;
  Method *meth_meth_ast_returnsObject6210 = addmethod2pos(obj6198, "returnsObject", &meth_ast_returnsObject6210, 7);
  int argcv_meth_ast_returnsObject6210[] = {0};
  meth_meth_ast_returnsObject6210->type = alloc_MethodType(1, argcv_meth_ast_returnsObject6210);
  meth_meth_ast_returnsObject6210->definitionModule = modulename;
  meth_meth_ast_returnsObject6210->definitionLine = 1377;
// method returnedObjectScope
  struct UserObject *uo6212 = (struct UserObject*)obj6198;
  uo6212->data[8] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope6212 = addmethod2pos(obj6198, "returnedObjectScope", &meth_ast_returnedObjectScope6212, 8);
  int argcv_meth_ast_returnedObjectScope6212[] = {0};
  meth_meth_ast_returnedObjectScope6212->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope6212);
  meth_meth_ast_returnedObjectScope6212->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope6212->definitionLine = 1378;
// method canInherit
  struct UserObject *uo6215 = (struct UserObject*)obj6198;
  uo6215->data[9] = emptyclosure;
  Method *meth_meth_ast_canInherit6215 = addmethod2pos(obj6198, "canInherit", &meth_ast_canInherit6215, 9);
  int argcv_meth_ast_canInherit6215[] = {0};
  meth_meth_ast_canInherit6215->type = alloc_MethodType(1, argcv_meth_ast_canInherit6215);
  meth_meth_ast_canInherit6215->definitionModule = modulename;
  meth_meth_ast_canInherit6215->definitionLine = 1379;
// method isObject
  struct UserObject *uo6217 = (struct UserObject*)obj6198;
  uo6217->data[10] = emptyclosure;
  Method *meth_meth_ast_isObject6217 = addmethod2pos(obj6198, "isObject", &meth_ast_isObject6217, 10);
  int argcv_meth_ast_isObject6217[] = {0};
  meth_meth_ast_isObject6217->type = alloc_MethodType(1, argcv_meth_ast_isObject6217);
  meth_meth_ast_isObject6217->definitionModule = modulename;
  meth_meth_ast_isObject6217->definitionLine = 1380;
// method accept()from
  struct UserObject *uo6219 = (struct UserObject*)obj6198;
  uo6219->data[11] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from6219 = addmethod2pos(obj6198, "accept()from", &meth_ast_accept_40__41_from6219, 11);
  int argcv_meth_ast_accept_40__41_from6219[] = {1, 1};
  meth_meth_ast_accept_40__41_from6219->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from6219);
  meth_meth_ast_accept_40__41_from6219->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from6219->definitionLine = 1381;
// method nameString
  struct UserObject *uo6245 = (struct UserObject*)obj6198;
  uo6245->data[12] = emptyclosure;
  Method *meth_meth_ast_nameString6245 = addmethod2pos(obj6198, "nameString", &meth_ast_nameString6245, 12);
  int argcv_meth_ast_nameString6245[] = {0};
  meth_meth_ast_nameString6245->type = alloc_MethodType(1, argcv_meth_ast_nameString6245);
  meth_meth_ast_nameString6245->definitionModule = modulename;
  meth_meth_ast_nameString6245->definitionLine = 1392;
// method map()ancestors
  struct UserObject *uo6265 = (struct UserObject*)obj6198;
  uo6265->data[13] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors6265 = addmethod2pos(obj6198, "map()ancestors", &meth_ast_map_40__41_ancestors6265, 13);
  int argcv_meth_ast_map_40__41_ancestors6265[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors6265->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors6265);
  meth_meth_ast_map_40__41_ancestors6265->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors6265->definitionLine = 1399;
// method pretty
  struct UserObject *uo6292 = (struct UserObject*)obj6198;
  uo6292->data[14] = emptyclosure;
  Method *meth_meth_ast_pretty6292 = addmethod2pos(obj6198, "pretty", &meth_ast_pretty6292, 14);
  int argcv_meth_ast_pretty6292[] = {1};
  meth_meth_ast_pretty6292->type = alloc_MethodType(1, argcv_meth_ast_pretty6292);
  meth_meth_ast_pretty6292->definitionModule = modulename;
  meth_meth_ast_pretty6292->definitionLine = 1406;
// method toGrace
  struct UserObject *uo6389 = (struct UserObject*)obj6198;
  uo6389->data[15] = emptyclosure;
  Method *meth_meth_ast_toGrace6389 = addmethod2pos(obj6198, "toGrace", &meth_ast_toGrace6389, 15);
  int argcv_meth_ast_toGrace6389[] = {1};
  meth_meth_ast_toGrace6389->type = alloc_MethodType(1, argcv_meth_ast_toGrace6389);
meth_meth_ast_toGrace6389->type->types[0] = type_Number;
meth_meth_ast_toGrace6389->type->names[0] = "depth";
  meth_meth_ast_toGrace6389->definitionModule = modulename;
  meth_meth_ast_toGrace6389->definitionLine = 1424;
// method shallowCopy
  block_savedest(obj6198);
  Object closure6450 = createclosure(2, "shallowCopy");
  setclosureframe(closure6450, stackframe);
  addtoclosure(closure6450, var_emptySeq);
  addtoclosure(closure6450, var_objectNode);
  struct UserObject *uo6450 = (struct UserObject*)obj6198;
  uo6450->data[16] = (Object)closure6450;
  Method *meth_meth_ast_shallowCopy6450 = addmethod2pos(obj6198, "shallowCopy", &meth_ast_shallowCopy6450, 16);
  int argcv_meth_ast_shallowCopy6450[] = {0};
  meth_meth_ast_shallowCopy6450->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy6450);
  meth_meth_ast_shallowCopy6450->definitionModule = modulename;
  meth_meth_ast_shallowCopy6450->definitionLine = 1436;
// method shallowCopyFieldsFrom
  struct UserObject *uo6456 = (struct UserObject*)obj6198;
  uo6456->data[17] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom6456 = addmethod2pos(obj6198, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom6456, 17);
  int argcv_meth_ast_shallowCopyFieldsFrom6456[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom6456->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom6456);
  meth_meth_ast_shallowCopyFieldsFrom6456->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom6456->definitionLine = 1439;
// method asString
  struct UserObject *uo6467 = (struct UserObject*)obj6198;
  uo6467->data[18] = emptyclosure;
  Method *meth_meth_ast_asString6467 = addmethod2pos(obj6198, "asString", &meth_ast_asString6467, 18);
  int argcv_meth_ast_asString6467[] = {0};
  meth_meth_ast_asString6467->type = alloc_MethodType(1, argcv_meth_ast_asString6467);
  meth_meth_ast_asString6467->definitionModule = modulename;
  meth_meth_ast_asString6467->definitionLine = 1445;
  sourceObject = obj6198;
// Begin line 1364
  setline(1364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6478 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_baseNode (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6479 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe6478);
// compiled call node returning call6479 (depth = 3)
  struct UserObject *obj6198_uo = (struct UserObject *)obj6198;
  obj6198_uo->super = call6479;
  sourceObject = obj6198;
// Begin line 1365
  setline(1365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6480 == NULL) {
    strlit6480 = alloc_String("object");
    gc_root(strlit6480);
  }
// compiled string node returning strlit6480 (depth = 3)
  adddatum2(obj6198, strlit6480, 1);
  sourceObject = obj6198;
// Begin line 1366
  setline(1366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_body (depth = 3)
  adddatum2(obj6198, *var_body, 2);
  sourceObject = obj6198;
// Begin line 1367
  setline(1367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_superclass_39_ (depth = 3)
  adddatum2(obj6198, *var_superclass_39_, 3);
  sourceObject = obj6198;
// Begin line 1368
  setline(1368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6481 == NULL) {
    strlit6481 = alloc_String("object");
    gc_root(strlit6481);
  }
// compiled string node returning strlit6481 (depth = 3)
  adddatum2(obj6198, strlit6481, 4);
  sourceObject = obj6198;
// Begin line 1369
  setline(1369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6482 = alloc_Boolean(0);
// compiled identifier node returning bool6482 (depth = 3)
  adddatum2(obj6198, bool6482, 5);
  sourceObject = obj6198;
  sourceObject = obj6198;
  sourceObject = obj6198;
  sourceObject = obj6198;
  sourceObject = obj6198;
  sourceObject = obj6198;
  sourceObject = obj6198;
  sourceObject = obj6198;
  sourceObject = obj6198;
  sourceObject = obj6198;
  sourceObject = obj6198;
  sourceObject = obj6198;
  sourceObject = obj6198;
  objclass6198 = obj6198->class;
  objclass6198->definitionModule = modulename;
  objclass6198->definitionLine = 1362;
  (*(struct UserObject *)self).data[0] = lowerouter6198;
  self = oldself6198;
  selfslot = oldselfslot6198;
  stackframe = oldstackframe6198;
  gc_frame_end(frame);
  return obj6198;
}
Object meth_ast_new6197_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_objectNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_body = &(stackframe->slots[0]);
  *var_body = args[curarg];
  curarg++;
  Object *var_superclass_39_ = &(stackframe->slots[1]);
  *var_superclass_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6198 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6198 = alloc_userobj2(23,20, objclass6198);
  gc_frame_newslot(obj6198);
if (objclass6198 == NULL) {
  glfree(obj6198->class->name);
  obj6198->class->name = "obj6184.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6198, self, 0);
  addmethodreal(obj6198,"outer", &reader_ast_outer_6199);
  Object oldself6198 = self;
  struct StackFrameObject *oldstackframe6198 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6198);
  gc_frame_newslot((Object)stackframe);
  self = obj6198;
  Object *oldselfslot6198 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6198 = (*(struct UserObject *)self).data[0], lowerouter6198 = thisouter6198;
  if (inheritingObject6198) {
    struct UserObject *inho6198 = (struct UserObject *)inheritingObject6198;
    while (inho6198->super != GraceDefaultObject) inho6198 = (struct UserObject *)inho6198->super;
    inho6198->super = obj6198;
    self = inheritingObject6198;
    *selfslot = self;
    lowerouter6198 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6198;
  }
if (objclass6198 == NULL) {
  Method *reader6200 = addmethodrealflags(obj6198, "kind",&reader_ast_kind_6200, MFLAG_DEF);
  reader6200->definitionModule = modulename;
  reader6200->definitionLine = 1365;
}
adddatum2(obj6198, alloc_Undefined(), 1);
if (objclass6198 == NULL) {
  Method *reader6201 = addmethodrealflags(obj6198, "value",&reader_ast_value_6201, 0);
  Method *writer6201 = addmethodrealflags(obj6198, "value:=",&writer_ast_value_6201, 0);
  reader6201->definitionModule = modulename;
  writer6201->definitionModule = modulename;
  reader6201->definitionLine = 1366;
  writer6201->definitionLine = 1366;
}
obj6198->flags |= OFLAG_MUTABLE;
adddatum2(obj6198, alloc_Undefined(), 2);
if (objclass6198 == NULL) {
  Method *reader6202 = addmethodrealflags(obj6198, "superclass",&reader_ast_superclass_6202, 0);
  Method *writer6202 = addmethodrealflags(obj6198, "superclass:=",&writer_ast_superclass_6202, 0);
  reader6202->definitionModule = modulename;
  writer6202->definitionModule = modulename;
  reader6202->definitionLine = 1367;
  writer6202->definitionLine = 1367;
}
obj6198->flags |= OFLAG_MUTABLE;
adddatum2(obj6198, alloc_Undefined(), 3);
if (objclass6198 == NULL) {
  Method *reader6203 = addmethodrealflags(obj6198, "classname",&reader_ast_classname_6203, 0);
  Method *writer6203 = addmethodrealflags(obj6198, "classname:=",&writer_ast_classname_6203, 0);
  reader6203->definitionModule = modulename;
  writer6203->definitionModule = modulename;
  reader6203->definitionLine = 1368;
  writer6203->definitionLine = 1368;
}
obj6198->flags |= OFLAG_MUTABLE;
adddatum2(obj6198, alloc_Undefined(), 4);
if (objclass6198 == NULL) {
  Method *reader6204 = addmethodrealflags(obj6198, "data",&reader_ast_data_6204, 0);
  Method *writer6204 = addmethodrealflags(obj6198, "data:=",&writer_ast_data_6204, 0);
  reader6204->definitionModule = modulename;
  writer6204->definitionModule = modulename;
  reader6204->definitionLine = 1369;
  writer6204->definitionLine = 1369;
}
obj6198->flags |= OFLAG_MUTABLE;
adddatum2(obj6198, alloc_Undefined(), 5);
// method scope:=
  struct UserObject *uo6205 = (struct UserObject*)obj6198;
  uo6205->data[6] = emptyclosure;
  Method *meth_meth_ast_scope_58__61_6205 = addmethod2pos(obj6198, "scope:=", &meth_ast_scope_58__61_6205, 6);
  int argcv_meth_ast_scope_58__61_6205[] = {1};
  meth_meth_ast_scope_58__61_6205->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61_6205);
  meth_meth_ast_scope_58__61_6205->definitionModule = modulename;
  meth_meth_ast_scope_58__61_6205->definitionLine = 1371;
// method returnsObject
  struct UserObject *uo6210 = (struct UserObject*)obj6198;
  uo6210->data[7] = emptyclosure;
  Method *meth_meth_ast_returnsObject6210 = addmethod2pos(obj6198, "returnsObject", &meth_ast_returnsObject6210, 7);
  int argcv_meth_ast_returnsObject6210[] = {0};
  meth_meth_ast_returnsObject6210->type = alloc_MethodType(1, argcv_meth_ast_returnsObject6210);
  meth_meth_ast_returnsObject6210->definitionModule = modulename;
  meth_meth_ast_returnsObject6210->definitionLine = 1377;
// method returnedObjectScope
  struct UserObject *uo6212 = (struct UserObject*)obj6198;
  uo6212->data[8] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope6212 = addmethod2pos(obj6198, "returnedObjectScope", &meth_ast_returnedObjectScope6212, 8);
  int argcv_meth_ast_returnedObjectScope6212[] = {0};
  meth_meth_ast_returnedObjectScope6212->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope6212);
  meth_meth_ast_returnedObjectScope6212->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope6212->definitionLine = 1378;
// method canInherit
  struct UserObject *uo6215 = (struct UserObject*)obj6198;
  uo6215->data[9] = emptyclosure;
  Method *meth_meth_ast_canInherit6215 = addmethod2pos(obj6198, "canInherit", &meth_ast_canInherit6215, 9);
  int argcv_meth_ast_canInherit6215[] = {0};
  meth_meth_ast_canInherit6215->type = alloc_MethodType(1, argcv_meth_ast_canInherit6215);
  meth_meth_ast_canInherit6215->definitionModule = modulename;
  meth_meth_ast_canInherit6215->definitionLine = 1379;
// method isObject
  struct UserObject *uo6217 = (struct UserObject*)obj6198;
  uo6217->data[10] = emptyclosure;
  Method *meth_meth_ast_isObject6217 = addmethod2pos(obj6198, "isObject", &meth_ast_isObject6217, 10);
  int argcv_meth_ast_isObject6217[] = {0};
  meth_meth_ast_isObject6217->type = alloc_MethodType(1, argcv_meth_ast_isObject6217);
  meth_meth_ast_isObject6217->definitionModule = modulename;
  meth_meth_ast_isObject6217->definitionLine = 1380;
// method accept()from
  struct UserObject *uo6219 = (struct UserObject*)obj6198;
  uo6219->data[11] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from6219 = addmethod2pos(obj6198, "accept()from", &meth_ast_accept_40__41_from6219, 11);
  int argcv_meth_ast_accept_40__41_from6219[] = {1, 1};
  meth_meth_ast_accept_40__41_from6219->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from6219);
  meth_meth_ast_accept_40__41_from6219->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from6219->definitionLine = 1381;
// method nameString
  struct UserObject *uo6245 = (struct UserObject*)obj6198;
  uo6245->data[12] = emptyclosure;
  Method *meth_meth_ast_nameString6245 = addmethod2pos(obj6198, "nameString", &meth_ast_nameString6245, 12);
  int argcv_meth_ast_nameString6245[] = {0};
  meth_meth_ast_nameString6245->type = alloc_MethodType(1, argcv_meth_ast_nameString6245);
  meth_meth_ast_nameString6245->definitionModule = modulename;
  meth_meth_ast_nameString6245->definitionLine = 1392;
// method map()ancestors
  struct UserObject *uo6265 = (struct UserObject*)obj6198;
  uo6265->data[13] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors6265 = addmethod2pos(obj6198, "map()ancestors", &meth_ast_map_40__41_ancestors6265, 13);
  int argcv_meth_ast_map_40__41_ancestors6265[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors6265->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors6265);
  meth_meth_ast_map_40__41_ancestors6265->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors6265->definitionLine = 1399;
// method pretty
  struct UserObject *uo6292 = (struct UserObject*)obj6198;
  uo6292->data[14] = emptyclosure;
  Method *meth_meth_ast_pretty6292 = addmethod2pos(obj6198, "pretty", &meth_ast_pretty6292, 14);
  int argcv_meth_ast_pretty6292[] = {1};
  meth_meth_ast_pretty6292->type = alloc_MethodType(1, argcv_meth_ast_pretty6292);
  meth_meth_ast_pretty6292->definitionModule = modulename;
  meth_meth_ast_pretty6292->definitionLine = 1406;
// method toGrace
  struct UserObject *uo6389 = (struct UserObject*)obj6198;
  uo6389->data[15] = emptyclosure;
  Method *meth_meth_ast_toGrace6389 = addmethod2pos(obj6198, "toGrace", &meth_ast_toGrace6389, 15);
  int argcv_meth_ast_toGrace6389[] = {1};
  meth_meth_ast_toGrace6389->type = alloc_MethodType(1, argcv_meth_ast_toGrace6389);
meth_meth_ast_toGrace6389->type->types[0] = type_Number;
meth_meth_ast_toGrace6389->type->names[0] = "depth";
  meth_meth_ast_toGrace6389->definitionModule = modulename;
  meth_meth_ast_toGrace6389->definitionLine = 1424;
// method shallowCopy
  block_savedest(obj6198);
  Object closure6450 = createclosure(2, "shallowCopy");
  setclosureframe(closure6450, stackframe);
  addtoclosure(closure6450, var_emptySeq);
  addtoclosure(closure6450, var_objectNode);
  struct UserObject *uo6450 = (struct UserObject*)obj6198;
  uo6450->data[16] = (Object)closure6450;
  Method *meth_meth_ast_shallowCopy6450 = addmethod2pos(obj6198, "shallowCopy", &meth_ast_shallowCopy6450, 16);
  int argcv_meth_ast_shallowCopy6450[] = {0};
  meth_meth_ast_shallowCopy6450->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy6450);
  meth_meth_ast_shallowCopy6450->definitionModule = modulename;
  meth_meth_ast_shallowCopy6450->definitionLine = 1436;
// method shallowCopyFieldsFrom
  struct UserObject *uo6456 = (struct UserObject*)obj6198;
  uo6456->data[17] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom6456 = addmethod2pos(obj6198, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom6456, 17);
  int argcv_meth_ast_shallowCopyFieldsFrom6456[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom6456->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom6456);
  meth_meth_ast_shallowCopyFieldsFrom6456->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom6456->definitionLine = 1439;
// method asString
  struct UserObject *uo6467 = (struct UserObject*)obj6198;
  uo6467->data[18] = emptyclosure;
  Method *meth_meth_ast_asString6467 = addmethod2pos(obj6198, "asString", &meth_ast_asString6467, 18);
  int argcv_meth_ast_asString6467[] = {0};
  meth_meth_ast_asString6467->type = alloc_MethodType(1, argcv_meth_ast_asString6467);
  meth_meth_ast_asString6467->definitionModule = modulename;
  meth_meth_ast_asString6467->definitionLine = 1445;
  sourceObject = obj6198;
// Begin line 1364
  setline(1364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6478 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_baseNode (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6479 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe6478);
// compiled call node returning call6479 (depth = 3)
  struct UserObject *obj6198_uo = (struct UserObject *)obj6198;
  obj6198_uo->super = call6479;
  sourceObject = obj6198;
// Begin line 1365
  setline(1365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6480 == NULL) {
    strlit6480 = alloc_String("object");
    gc_root(strlit6480);
  }
// compiled string node returning strlit6480 (depth = 3)
  adddatum2(obj6198, strlit6480, 1);
  sourceObject = obj6198;
// Begin line 1366
  setline(1366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_body (depth = 3)
  adddatum2(obj6198, *var_body, 2);
  sourceObject = obj6198;
// Begin line 1367
  setline(1367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_superclass_39_ (depth = 3)
  adddatum2(obj6198, *var_superclass_39_, 3);
  sourceObject = obj6198;
// Begin line 1368
  setline(1368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6481 == NULL) {
    strlit6481 = alloc_String("object");
    gc_root(strlit6481);
  }
// compiled string node returning strlit6481 (depth = 3)
  adddatum2(obj6198, strlit6481, 4);
  sourceObject = obj6198;
// Begin line 1369
  setline(1369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6482 = alloc_Boolean(0);
// compiled identifier node returning bool6482 (depth = 3)
  adddatum2(obj6198, bool6482, 5);
  sourceObject = obj6198;
  sourceObject = obj6198;
  sourceObject = obj6198;
  sourceObject = obj6198;
  sourceObject = obj6198;
  sourceObject = obj6198;
  sourceObject = obj6198;
  sourceObject = obj6198;
  sourceObject = obj6198;
  sourceObject = obj6198;
  sourceObject = obj6198;
  sourceObject = obj6198;
  sourceObject = obj6198;
  objclass6198 = obj6198->class;
  objclass6198->definitionModule = modulename;
  objclass6198->definitionLine = 1362;
  (*(struct UserObject *)self).data[0] = lowerouter6198;
  self = oldself6198;
  selfslot = oldselfslot6198;
  stackframe = oldstackframe6198;
  gc_frame_end(frame);
  return obj6198;
}
Object meth_ast_objectNode6484(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 27, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "objectNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_objectNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for objectNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹objectNode›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1352
  setline(1352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_objectNode (depth = 3)
  gc_frame_end(frame);
  return *var_objectNode;
}
Object meth_ast_arrayNode6485(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 28, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "arrayNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_arrayNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for arrayNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for arrayNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_arrayNode (depth = 3)
  gc_frame_end(frame);
  return *var_arrayNode;
}
Object meth_ast__apply6503(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ax = &(stackframe->slots[0]);
  *var_ax = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1458
  setline(1458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6504 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_visitor (depth = 8)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_newChain (depth = 8)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ax (depth = 8)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6505 = callmethod(*var_ax, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe6504);
// compiled call node returning call6505 (depth = 7)
  gc_frame_end(frame);
  return call6505;
}
Object meth_ast_accept_40__41_from6493(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1455
  setline(1455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6495 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6496 = callmethod(*var_visitor, "visitArray()up",
    2, partcv, params);
  gc_frame_end(callframe6495);
// compiled call node returning call6496 (depth = 5)
  Object if6494 = done;
  if (istrue(call6496)) {
// Begin line 1456
  setline(1456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6497 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_as (depth = 7)
  params[0] = self;
  partcv[0] = 1;
  Object call6498 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe6497);
// compiled call node returning call6498 (depth = 6)
  *var_newChain = call6498;
  if (call6498 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 1457
  setline(1457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6499 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6500 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6501 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6500);
// compiled call node returning call6501 (depth = 7)
// compiled member node returning call6501 (depth = 6)
  gc_frame_newslot(call6501);
// starting to compile block node (depth = 6)
  Object block6502 = alloc_Block(NULL, NULL, "ast", 1457);
  gc_frame_newslot(block6502);
// method _apply
  block_savedest(block6502);
  Object closure6503 = createclosure(3, "_apply");
  setclosureframe(closure6503, stackframe);
  addtoclosure(closure6503, var_visitor);
  addtoclosure(closure6503, var_newChain);
  addtoclosure(closure6503, selfslot);
  struct UserObject *uo6503 = (struct UserObject*)block6502;
  uo6503->data[0] = (Object)closure6503;
  Method *meth_meth_ast__apply6503 = addmethod2pos(block6502, "_apply", &meth_ast__apply6503, 0);
  int argcv_meth_ast__apply6503[] = {1};
  meth_meth_ast__apply6503->type = alloc_MethodType(1, argcv_meth_ast__apply6503);
  meth_meth_ast__apply6503->definitionModule = modulename;
  meth_meth_ast__apply6503->definitionLine = 1457;
// compiled block node returning block6502 (depth = 6)
  gc_frame_newslot(block6502);
// call case 5: prelude request
  params[0] = call6501;
  params[1] = block6502;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6507 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6499);
// compiled call node returning call6507 (depth = 5)
    gc_frame_newslot(call6507);
    if6494 = call6507;
  } else {
  }
// compiled if node returning if6494 (depth = 4)
  gc_frame_end(frame);
  return if6494;
}
Object meth_ast_map_40__41_ancestors6508(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1463
  setline(1463);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6509 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6510 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6509);
// compiled call node returning call6510 (depth = 6)
// compiled member node returning call6510 (depth = 5)
  *var_n = call6510;
  if (call6510 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1464
  setline(1464);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6511 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call6512 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe6511);
// compiled call node returning call6512 (depth = 5)
  *var_newChain = call6512;
  if (call6512 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1465
  setline(1465);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1463
  setline(1463);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6513 = gc_frame_new();
// Begin line 1465
  setline(1465);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6514 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6515 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6516 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6515);
// compiled call node returning call6516 (depth = 8)
// compiled member node returning call6516 (depth = 7)
  gc_frame_newslot(call6516);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6517 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6518 = gc_frame_new();
// call case 3: self.outer request
  Object call6519 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6518);
// compiled call node returning call6519 (depth = 10)
// compiled member node returning call6519 (depth = 9)
  partcv[0] = 0;
  Object call6520 = callmethodflags(call6519, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6517);
// compiled call node returning call6520 (depth = 8)
// compiled member node returning call6520 (depth = 7)
  params[0] = call6516;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call6521 = callmethodflags(call6520, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6514);
// compiled call node returning call6521 (depth = 6)
  gc_frame_newslot(call6521);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call6521;
  partcv[0] = 1;
  Object call6522 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe6513);
// compiled call node returning call6522 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1466
  setline(1466);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6523 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call6524 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe6523);
// compiled call node returning call6524 (depth = 4)
  gc_frame_end(frame);
  return call6524;
}
Object meth_ast__apply6533(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ai = &(stackframe->slots[0]);
  *var_ai = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1471
  setline(1471);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit6535 == NULL) {
    strlit6535 = alloc_String("  ");
    gc_root(strlit6535);
  }
// compiled string node returning strlit6535 (depth = 8)
  int op_slot_right_6534 = gc_frame_newslot(strlit6535);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_6534 = gc_frame_newslot(*var_spc);
  params[0] = strlit6535;
  partcv[0] = 1;
  Object opresult6537 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult6537 (depth = 7)
  *var_spc = opresult6537;
  if (opresult6537 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply6547(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ax = &(stackframe->slots[0]);
  *var_ax = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1475
  setline(1475);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6549 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num6551 = alloc_Float64(1);
// compiled num node returning num6551 (depth = 10)
  int op_slot_right_6550 = gc_frame_newslot(num6551);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_6550 = gc_frame_newslot(*var_depth);
  params[0] = num6551;
  partcv[0] = 1;
  Object sum6553 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum6553 (depth = 9)
  gc_frame_newslot(sum6553);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ax (depth = 9)
  params[0] = sum6553;
  partcv[0] = 1;
  Object call6554 = callmethod(*var_ax, "pretty",
    1, partcv, params);
  gc_frame_end(callframe6549);
// compiled call node returning call6554 (depth = 8)
  int op_slot_right_6548 = gc_frame_newslot(call6554);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_6556 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit6559 == NULL) {
    strlit6559 = alloc_String("""\x0a""");
    gc_root(strlit6559);
  }
// compiled string node returning strlit6559 (depth = 10)
  int op_slot_right_6558 = gc_frame_newslot(strlit6559);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_6558 = gc_frame_newslot(*var_s);
  params[0] = strlit6559;
  partcv[0] = 1;
  Object opresult6561 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6561 (depth = 9)
  int op_slot_left_6556 = gc_frame_newslot(opresult6561);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6562 = callmethod(opresult6561, "++", 1, partcv, params);
// compiled op node returning opresult6562 (depth = 8)
  int op_slot_left_6548 = gc_frame_newslot(opresult6562);
  params[0] = call6554;
  partcv[0] = 1;
  Object opresult6563 = callmethod(opresult6562, "++", 1, partcv, params);
// compiled op node returning opresult6563 (depth = 7)
  *var_s = opresult6563;
  if (opresult6563 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty6525(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1469
  setline(1469);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6526 == NULL) {
    strlit6526 = alloc_String("");
    gc_root(strlit6526);
  }
// compiled string node returning strlit6526 (depth = 5)
  *var_spc = strlit6526;
  if (strlit6526 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1470
  setline(1470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6527 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_right_6528 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 6)
  Object num6530 = alloc_Float64(0);
// compiled num node returning num6530 (depth = 6)
  int op_slot_left_6528 = gc_frame_newslot(num6530);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult6531 = callmethod(num6530, "..", 1, partcv, params);
// compiled op node returning opresult6531 (depth = 5)
  gc_frame_newslot(opresult6531);
// starting to compile block node (depth = 5)
  Object block6532 = alloc_Block(NULL, NULL, "ast", 1470);
  gc_frame_newslot(block6532);
// method _apply
  block_savedest(block6532);
  Object closure6533 = createclosure(2, "_apply");
  setclosureframe(closure6533, stackframe);
  addtoclosure(closure6533, var_spc);
  addtoclosure(closure6533, selfslot);
  struct UserObject *uo6533 = (struct UserObject*)block6532;
  uo6533->data[0] = (Object)closure6533;
  Method *meth_meth_ast__apply6533 = addmethod2pos(block6532, "_apply", &meth_ast__apply6533, 0);
  int argcv_meth_ast__apply6533[] = {1};
  meth_meth_ast__apply6533->type = alloc_MethodType(1, argcv_meth_ast__apply6533);
  meth_meth_ast__apply6533->definitionModule = modulename;
  meth_meth_ast__apply6533->definitionLine = 1465;
// compiled block node returning block6532 (depth = 5)
  gc_frame_newslot(block6532);
// call case 5: prelude request
  params[0] = opresult6531;
  params[1] = block6532;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6540 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6527);
// compiled call node returning call6540 (depth = 4)
// Begin line 1473
  setline(1473);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6541 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call6542 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe6541);
// compiled call node returning call6542 (depth = 5)
  *var_s = call6542;
  if (call6542 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1474
  setline(1474);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6543 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6544 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6545 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6544);
// compiled call node returning call6545 (depth = 6)
// compiled member node returning call6545 (depth = 5)
  gc_frame_newslot(call6545);
// starting to compile block node (depth = 5)
  Object block6546 = alloc_Block(NULL, NULL, "ast", 1474);
  gc_frame_newslot(block6546);
// method _apply
  block_savedest(block6546);
  Object closure6547 = createclosure(4, "_apply");
  setclosureframe(closure6547, stackframe);
  addtoclosure(closure6547, var_depth);
  addtoclosure(closure6547, var_spc);
  addtoclosure(closure6547, var_s);
  addtoclosure(closure6547, selfslot);
  struct UserObject *uo6547 = (struct UserObject*)block6546;
  uo6547->data[0] = (Object)closure6547;
  Method *meth_meth_ast__apply6547 = addmethod2pos(block6546, "_apply", &meth_ast__apply6547, 0);
  int argcv_meth_ast__apply6547[] = {1};
  meth_meth_ast__apply6547->type = alloc_MethodType(1, argcv_meth_ast__apply6547);
  meth_meth_ast__apply6547->definitionModule = modulename;
  meth_meth_ast__apply6547->definitionLine = 1474;
// compiled block node returning block6546 (depth = 5)
  gc_frame_newslot(block6546);
// call case 5: prelude request
  params[0] = call6545;
  params[1] = block6546;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6566 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6543);
// compiled call node returning call6566 (depth = 4)
// Begin line 1477
  setline(1477);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply6575(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1482
  setline(1482);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6577 = gc_frame_new();
// starting to compile num node (depth = 9)
  Object num6578 = alloc_Float64(0);
// compiled num node returning num6578 (depth = 9)
  gc_frame_newslot(num6578);
// call case 6: other member request
// starting to compile index node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6579 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6580 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6579);
// compiled call node returning call6580 (depth = 11)
// compiled member node returning call6580 (depth = 10)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  params[0] = *var_i;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres6581 = callmethod(call6580, "[]", 1, partcv, params);
// compiled index node returning idxres6581 (depth = 9)
  params[0] = num6578;
  partcv[0] = 1;
  Object call6582 = callmethod(idxres6581, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6577);
// compiled call node returning call6582 (depth = 8)
  int op_slot_right_6576 = gc_frame_newslot(call6582);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_6576 = gc_frame_newslot(*var_s);
  params[0] = call6582;
  partcv[0] = 1;
  Object opresult6584 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6584 (depth = 7)
  *var_s = opresult6584;
  if (opresult6584 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1483
  setline(1483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6588 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6589 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6590 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6589);
// compiled call node returning call6590 (depth = 11)
// compiled member node returning call6590 (depth = 10)
  partcv[0] = 0;
  Object call6591 = callmethod(call6590, "size",
    1, partcv, params);
  gc_frame_end(callframe6588);
// compiled call node returning call6591 (depth = 9)
// compiled member node returning call6591 (depth = 8)
  int op_slot_right_6587 = gc_frame_newslot(call6591);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  int op_slot_left_6587 = gc_frame_newslot(*var_i);
  params[0] = call6591;
  partcv[0] = 1;
  Object opresult6593 = callmethod(*var_i, "<", 1, partcv, params);
// compiled op node returning opresult6593 (depth = 7)
  Object if6586 = done;
  if (istrue(opresult6593)) {
// Begin line 1484
  setline(1484);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6595 == NULL) {
    strlit6595 = alloc_String(", ");
    gc_root(strlit6595);
  }
// compiled string node returning strlit6595 (depth = 9)
  int op_slot_right_6594 = gc_frame_newslot(strlit6595);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_6594 = gc_frame_newslot(*var_s);
  params[0] = strlit6595;
  partcv[0] = 1;
  Object opresult6597 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6597 (depth = 8)
  *var_s = opresult6597;
  if (opresult6597 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if6586 = done;
  } else {
  }
// compiled if node returning if6586 (depth = 6)
  gc_frame_end(frame);
  return if6586;
}
Object meth_ast_toGrace6567(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1480
  setline(1480);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6568 == NULL) {
    strlit6568 = alloc_String("[");
    gc_root(strlit6568);
  }
// compiled string node returning strlit6568 (depth = 5)
  *var_s = strlit6568;
  if (strlit6568 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1481
  setline(1481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6569 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6570 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6571 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6572 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6571);
// compiled call node returning call6572 (depth = 8)
// compiled member node returning call6572 (depth = 7)
  partcv[0] = 0;
  Object call6573 = callmethod(call6572, "indices",
    1, partcv, params);
  gc_frame_end(callframe6570);
// compiled call node returning call6573 (depth = 6)
// compiled member node returning call6573 (depth = 5)
  gc_frame_newslot(call6573);
// starting to compile block node (depth = 5)
  Object block6574 = alloc_Block(NULL, NULL, "ast", 1481);
  gc_frame_newslot(block6574);
// method _apply
  block_savedest(block6574);
  Object closure6575 = createclosure(2, "_apply");
  setclosureframe(closure6575, stackframe);
  addtoclosure(closure6575, var_s);
  addtoclosure(closure6575, selfslot);
  struct UserObject *uo6575 = (struct UserObject*)block6574;
  uo6575->data[0] = (Object)closure6575;
  Method *meth_meth_ast__apply6575 = addmethod2pos(block6574, "_apply", &meth_ast__apply6575, 0);
  int argcv_meth_ast__apply6575[] = {1};
  meth_meth_ast__apply6575->type = alloc_MethodType(1, argcv_meth_ast__apply6575);
  meth_meth_ast__apply6575->definitionModule = modulename;
  meth_meth_ast__apply6575->definitionLine = 1481;
// compiled block node returning block6574 (depth = 5)
  gc_frame_newslot(block6574);
// call case 5: prelude request
  params[0] = call6573;
  params[1] = block6574;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6600 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6569);
// compiled call node returning call6600 (depth = 4)
// Begin line 1487
  setline(1487);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6602 == NULL) {
    strlit6602 = alloc_String("]");
    gc_root(strlit6602);
  }
// compiled string node returning strlit6602 (depth = 6)
  int op_slot_right_6601 = gc_frame_newslot(strlit6602);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_6601 = gc_frame_newslot(*var_s);
  params[0] = strlit6602;
  partcv[0] = 1;
  Object opresult6604 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6604 (depth = 5)
  *var_s = opresult6604;
  if (opresult6604 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1488
  setline(1488);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy6606(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_arrayNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1491
  setline(1491);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6607 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe6608 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_emptySeq (depth = 6)
  gc_frame_newslot(*var_emptySeq);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_arrayNode (depth = 6)
  params[0] = *var_emptySeq;
  partcv[0] = 1;
  Object call6609 = callmethod(*var_arrayNode, "new",
    1, partcv, params);
  gc_frame_end(callframe6608);
// compiled call node returning call6609 (depth = 5)
  params[0] = self;
  partcv[0] = 1;
  Object call6610 = callmethod(call6609, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe6607);
// compiled call node returning call6610 (depth = 4)
  gc_frame_end(frame);
  return call6610;
}
Object meth_ast_new6488(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_arrayNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_values = &(stackframe->slots[0]);
  *var_values = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6489 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6489 = alloc_userobj2(9,9, objclass6489);
  gc_frame_newslot(obj6489);
if (objclass6489 == NULL) {
  glfree(obj6489->class->name);
  obj6489->class->name = "arrayNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6489, self, 0);
  addmethodreal(obj6489,"outer", &reader_ast_outer_6490);
  Object oldself6489 = self;
  struct StackFrameObject *oldstackframe6489 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6489);
  gc_frame_newslot((Object)stackframe);
  self = obj6489;
  Object *oldselfslot6489 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6489 = (*(struct UserObject *)self).data[0], lowerouter6489 = thisouter6489;
  if (inheritingObject6489) {
    struct UserObject *inho6489 = (struct UserObject *)inheritingObject6489;
    while (inho6489->super != GraceDefaultObject) inho6489 = (struct UserObject *)inho6489->super;
    inho6489->super = obj6489;
    self = inheritingObject6489;
    *selfslot = self;
    lowerouter6489 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6489;
  }
if (objclass6489 == NULL) {
  Method *reader6491 = addmethodrealflags(obj6489, "kind",&reader_ast_kind_6491, MFLAG_DEF);
  reader6491->definitionModule = modulename;
  reader6491->definitionLine = 1452;
}
adddatum2(obj6489, alloc_Undefined(), 1);
if (objclass6489 == NULL) {
  Method *reader6492 = addmethodrealflags(obj6489, "value",&reader_ast_value_6492, 0);
  Method *writer6492 = addmethodrealflags(obj6489, "value:=",&writer_ast_value_6492, 0);
  reader6492->definitionModule = modulename;
  writer6492->definitionModule = modulename;
  reader6492->definitionLine = 1453;
  writer6492->definitionLine = 1453;
}
obj6489->flags |= OFLAG_MUTABLE;
adddatum2(obj6489, alloc_Undefined(), 2);
// method accept()from
  struct UserObject *uo6493 = (struct UserObject*)obj6489;
  uo6493->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from6493 = addmethod2pos(obj6489, "accept()from", &meth_ast_accept_40__41_from6493, 3);
  int argcv_meth_ast_accept_40__41_from6493[] = {1, 1};
  meth_meth_ast_accept_40__41_from6493->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from6493);
  meth_meth_ast_accept_40__41_from6493->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from6493->definitionLine = 1454;
// method map()ancestors
  struct UserObject *uo6508 = (struct UserObject*)obj6489;
  uo6508->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors6508 = addmethod2pos(obj6489, "map()ancestors", &meth_ast_map_40__41_ancestors6508, 4);
  int argcv_meth_ast_map_40__41_ancestors6508[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors6508->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors6508);
  meth_meth_ast_map_40__41_ancestors6508->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors6508->definitionLine = 1462;
// method pretty
  struct UserObject *uo6525 = (struct UserObject*)obj6489;
  uo6525->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty6525 = addmethod2pos(obj6489, "pretty", &meth_ast_pretty6525, 5);
  int argcv_meth_ast_pretty6525[] = {1};
  meth_meth_ast_pretty6525->type = alloc_MethodType(1, argcv_meth_ast_pretty6525);
  meth_meth_ast_pretty6525->definitionModule = modulename;
  meth_meth_ast_pretty6525->definitionLine = 1468;
// method toGrace
  struct UserObject *uo6567 = (struct UserObject*)obj6489;
  uo6567->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace6567 = addmethod2pos(obj6489, "toGrace", &meth_ast_toGrace6567, 6);
  int argcv_meth_ast_toGrace6567[] = {1};
  meth_meth_ast_toGrace6567->type = alloc_MethodType(1, argcv_meth_ast_toGrace6567);
meth_meth_ast_toGrace6567->type->types[0] = type_Number;
meth_meth_ast_toGrace6567->type->names[0] = "depth";
  meth_meth_ast_toGrace6567->definitionModule = modulename;
  meth_meth_ast_toGrace6567->definitionLine = 1479;
// method shallowCopy
  block_savedest(obj6489);
  Object closure6606 = createclosure(2, "shallowCopy");
  setclosureframe(closure6606, stackframe);
  addtoclosure(closure6606, var_emptySeq);
  addtoclosure(closure6606, var_arrayNode);
  struct UserObject *uo6606 = (struct UserObject*)obj6489;
  uo6606->data[7] = (Object)closure6606;
  Method *meth_meth_ast_shallowCopy6606 = addmethod2pos(obj6489, "shallowCopy", &meth_ast_shallowCopy6606, 7);
  int argcv_meth_ast_shallowCopy6606[] = {0};
  meth_meth_ast_shallowCopy6606->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy6606);
  meth_meth_ast_shallowCopy6606->definitionModule = modulename;
  meth_meth_ast_shallowCopy6606->definitionLine = 1490;
  sourceObject = obj6489;
// Begin line 1451
  setline(1451);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6611 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6612 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe6611);
// compiled call node returning call6612 (depth = 4)
  struct UserObject *obj6489_uo = (struct UserObject *)obj6489;
  obj6489_uo->super = call6612;
  sourceObject = obj6489;
// Begin line 1452
  setline(1452);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit6613 == NULL) {
    strlit6613 = alloc_String("array");
    gc_root(strlit6613);
  }
// compiled string node returning strlit6613 (depth = 4)
  adddatum2(obj6489, strlit6613, 1);
  sourceObject = obj6489;
// Begin line 1453
  setline(1453);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  adddatum2(obj6489, *var_values, 2);
  sourceObject = obj6489;
  sourceObject = obj6489;
  sourceObject = obj6489;
  sourceObject = obj6489;
  sourceObject = obj6489;
  objclass6489 = obj6489->class;
  objclass6489->definitionModule = modulename;
  objclass6489->definitionLine = 1450;
  (*(struct UserObject *)self).data[0] = lowerouter6489;
  self = oldself6489;
  selfslot = oldselfslot6489;
  stackframe = oldstackframe6489;
  gc_frame_end(frame);
  return obj6489;
}
Object meth_ast_new6488_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_arrayNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_values = &(stackframe->slots[0]);
  *var_values = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6489 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6489 = alloc_userobj2(9,9, objclass6489);
  gc_frame_newslot(obj6489);
if (objclass6489 == NULL) {
  glfree(obj6489->class->name);
  obj6489->class->name = "arrayNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6489, self, 0);
  addmethodreal(obj6489,"outer", &reader_ast_outer_6490);
  Object oldself6489 = self;
  struct StackFrameObject *oldstackframe6489 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6489);
  gc_frame_newslot((Object)stackframe);
  self = obj6489;
  Object *oldselfslot6489 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6489 = (*(struct UserObject *)self).data[0], lowerouter6489 = thisouter6489;
  if (inheritingObject6489) {
    struct UserObject *inho6489 = (struct UserObject *)inheritingObject6489;
    while (inho6489->super != GraceDefaultObject) inho6489 = (struct UserObject *)inho6489->super;
    inho6489->super = obj6489;
    self = inheritingObject6489;
    *selfslot = self;
    lowerouter6489 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6489;
  }
if (objclass6489 == NULL) {
  Method *reader6491 = addmethodrealflags(obj6489, "kind",&reader_ast_kind_6491, MFLAG_DEF);
  reader6491->definitionModule = modulename;
  reader6491->definitionLine = 1452;
}
adddatum2(obj6489, alloc_Undefined(), 1);
if (objclass6489 == NULL) {
  Method *reader6492 = addmethodrealflags(obj6489, "value",&reader_ast_value_6492, 0);
  Method *writer6492 = addmethodrealflags(obj6489, "value:=",&writer_ast_value_6492, 0);
  reader6492->definitionModule = modulename;
  writer6492->definitionModule = modulename;
  reader6492->definitionLine = 1453;
  writer6492->definitionLine = 1453;
}
obj6489->flags |= OFLAG_MUTABLE;
adddatum2(obj6489, alloc_Undefined(), 2);
// method accept()from
  struct UserObject *uo6493 = (struct UserObject*)obj6489;
  uo6493->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from6493 = addmethod2pos(obj6489, "accept()from", &meth_ast_accept_40__41_from6493, 3);
  int argcv_meth_ast_accept_40__41_from6493[] = {1, 1};
  meth_meth_ast_accept_40__41_from6493->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from6493);
  meth_meth_ast_accept_40__41_from6493->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from6493->definitionLine = 1454;
// method map()ancestors
  struct UserObject *uo6508 = (struct UserObject*)obj6489;
  uo6508->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors6508 = addmethod2pos(obj6489, "map()ancestors", &meth_ast_map_40__41_ancestors6508, 4);
  int argcv_meth_ast_map_40__41_ancestors6508[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors6508->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors6508);
  meth_meth_ast_map_40__41_ancestors6508->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors6508->definitionLine = 1462;
// method pretty
  struct UserObject *uo6525 = (struct UserObject*)obj6489;
  uo6525->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty6525 = addmethod2pos(obj6489, "pretty", &meth_ast_pretty6525, 5);
  int argcv_meth_ast_pretty6525[] = {1};
  meth_meth_ast_pretty6525->type = alloc_MethodType(1, argcv_meth_ast_pretty6525);
  meth_meth_ast_pretty6525->definitionModule = modulename;
  meth_meth_ast_pretty6525->definitionLine = 1468;
// method toGrace
  struct UserObject *uo6567 = (struct UserObject*)obj6489;
  uo6567->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace6567 = addmethod2pos(obj6489, "toGrace", &meth_ast_toGrace6567, 6);
  int argcv_meth_ast_toGrace6567[] = {1};
  meth_meth_ast_toGrace6567->type = alloc_MethodType(1, argcv_meth_ast_toGrace6567);
meth_meth_ast_toGrace6567->type->types[0] = type_Number;
meth_meth_ast_toGrace6567->type->names[0] = "depth";
  meth_meth_ast_toGrace6567->definitionModule = modulename;
  meth_meth_ast_toGrace6567->definitionLine = 1479;
// method shallowCopy
  block_savedest(obj6489);
  Object closure6606 = createclosure(2, "shallowCopy");
  setclosureframe(closure6606, stackframe);
  addtoclosure(closure6606, var_emptySeq);
  addtoclosure(closure6606, var_arrayNode);
  struct UserObject *uo6606 = (struct UserObject*)obj6489;
  uo6606->data[7] = (Object)closure6606;
  Method *meth_meth_ast_shallowCopy6606 = addmethod2pos(obj6489, "shallowCopy", &meth_ast_shallowCopy6606, 7);
  int argcv_meth_ast_shallowCopy6606[] = {0};
  meth_meth_ast_shallowCopy6606->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy6606);
  meth_meth_ast_shallowCopy6606->definitionModule = modulename;
  meth_meth_ast_shallowCopy6606->definitionLine = 1490;
  sourceObject = obj6489;
// Begin line 1451
  setline(1451);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6611 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6612 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe6611);
// compiled call node returning call6612 (depth = 4)
  struct UserObject *obj6489_uo = (struct UserObject *)obj6489;
  obj6489_uo->super = call6612;
  sourceObject = obj6489;
// Begin line 1452
  setline(1452);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit6613 == NULL) {
    strlit6613 = alloc_String("array");
    gc_root(strlit6613);
  }
// compiled string node returning strlit6613 (depth = 4)
  adddatum2(obj6489, strlit6613, 1);
  sourceObject = obj6489;
// Begin line 1453
  setline(1453);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  adddatum2(obj6489, *var_values, 2);
  sourceObject = obj6489;
  sourceObject = obj6489;
  sourceObject = obj6489;
  sourceObject = obj6489;
  sourceObject = obj6489;
  objclass6489 = obj6489->class;
  objclass6489->definitionModule = modulename;
  objclass6489->definitionLine = 1450;
  (*(struct UserObject *)self).data[0] = lowerouter6489;
  self = oldself6489;
  selfslot = oldselfslot6489;
  stackframe = oldstackframe6489;
  gc_frame_end(frame);
  return obj6489;
}
Object meth_ast_new_40__41_scope6617(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new()scope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method new()scope");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method new()scope");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for new()scope (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_request = &(stackframe->slots[0]);
  *var_request = args[curarg];
  curarg++;
  Object *var_receiver = &(stackframe->slots[1]);
  *var_receiver = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for new");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for scope");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "result");
// Begin line 1496
  setline(1496);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6618 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_request (depth = 5)
  gc_frame_newslot(*var_request);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_receiver (depth = 5)
  gc_frame_newslot(*var_receiver);
// call case 4: self request
  params[0] = *var_request;
  params[1] = *var_receiver;
  partcv[0] = 2;
  Object call6619 = callmethodflags(self, "new", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6618);
// compiled call node returning call6619 (depth = 4)
  *var_result = call6619;
  if (call6619 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1497
  setline(1497);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 1483
  setline(1483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6620 = gc_frame_new();
// Begin line 1497
  setline(1497);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  gc_frame_newslot(*var_s);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call6621 = callmethod(*var_result, "scope:=",
    1, partcv, params);
  gc_frame_end(callframe6620);
// compiled call node returning call6621 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 1498
  setline(1498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_target6629(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "target");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for target (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for target");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1508
  setline(1508);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6630 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6631 = callmethodflags(self, "in", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6630);
// compiled call node returning call6631 (depth = 4)
// compiled member node returning call6631 (depth = 3)
  gc_frame_end(frame);
  return call6631;
}
Object meth_ast_nameString6632(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for nameString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for nameString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1509
  setline(1509);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6633 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6634 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6633);
// compiled call node returning call6634 (depth = 4)
// compiled member node returning call6634 (depth = 3)
  gc_frame_end(frame);
  return call6634;
}
Object meth_ast_isMember6635(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isMember");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isMember (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isMember");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1510
  setline(1510);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6636 = alloc_Boolean(1);
// compiled identifier node returning bool6636 (depth = 3)
  gc_frame_end(frame);
  return bool6636;
}
Object meth_ast__apply6652(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe6653 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_visitor (depth = 8)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_newChain (depth = 8)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6654 = callmethod(*var_each, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe6653);
// compiled call node returning call6654 (depth = 7)
  gc_frame_end(frame);
  return call6654;
}
Object meth_ast_accept_40__41_from6637(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1512
  setline(1512);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6639 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6640 = callmethod(*var_visitor, "visitMember()up",
    2, partcv, params);
  gc_frame_end(callframe6639);
// compiled call node returning call6640 (depth = 4)
  Object if6638 = done;
  if (istrue(call6640)) {
// Begin line 1513
  setline(1513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6641 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call6642 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe6641);
// compiled call node returning call6642 (depth = 5)
  *var_newChain = call6642;
  if (call6642 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1514
  setline(1514);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool6645 = alloc_Boolean(0);
// compiled identifier node returning bool6645 (depth = 6)
  int op_slot_right_6644 = gc_frame_newslot(bool6645);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6647 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6648 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6647);
// compiled call node returning call6648 (depth = 7)
// compiled member node returning call6648 (depth = 6)
  int op_slot_left_6644 = gc_frame_newslot(call6648);
  params[0] = bool6645;
  partcv[0] = 1;
  Object opresult6649 = callmethod(call6648, "!=", 1, partcv, params);
// compiled op node returning opresult6649 (depth = 5)
  Object if6643 = done;
  if (istrue(opresult6649)) {
// Begin line 1515
  setline(1515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6650 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block6651 = alloc_Block(NULL, NULL, "ast", 1515);
  gc_frame_newslot(block6651);
// method _apply
  block_savedest(block6651);
  Object closure6652 = createclosure(3, "_apply");
  setclosureframe(closure6652, stackframe);
  addtoclosure(closure6652, var_visitor);
  addtoclosure(closure6652, var_newChain);
  addtoclosure(closure6652, selfslot);
  struct UserObject *uo6652 = (struct UserObject*)block6651;
  uo6652->data[0] = (Object)closure6652;
  Method *meth_meth_ast__apply6652 = addmethod2pos(block6651, "_apply", &meth_ast__apply6652, 0);
  int argcv_meth_ast__apply6652[] = {1};
  meth_meth_ast__apply6652->type = alloc_MethodType(1, argcv_meth_ast__apply6652);
  meth_meth_ast__apply6652->definitionModule = modulename;
  meth_meth_ast__apply6652->definitionLine = 1514;
// compiled block node returning block6651 (depth = 6)
  gc_frame_newslot(block6651);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6656 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6657 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6656);
// compiled call node returning call6657 (depth = 7)
// compiled member node returning call6657 (depth = 6)
  params[0] = block6651;
  partcv[0] = 1;
  Object call6658 = callmethod(call6657, "do",
    1, partcv, params);
  gc_frame_end(callframe6650);
// compiled call node returning call6658 (depth = 5)
    gc_frame_newslot(call6658);
    if6643 = call6658;
  } else {
  }
// compiled if node returning if6643 (depth = 4)
// Begin line 1517
  setline(1517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6659 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6660 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6661 = callmethodflags(self, "in", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6660);
// compiled call node returning call6661 (depth = 6)
// compiled member node returning call6661 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6662 = callmethod(call6661, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe6659);
// compiled call node returning call6662 (depth = 4)
    gc_frame_newslot(call6662);
    if6638 = call6662;
  } else {
  }
// compiled if node returning if6638 (depth = 3)
  gc_frame_end(frame);
  return if6638;
}
Object meth_ast_map_40__41_ancestors6663(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1521
  setline(1521);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6664 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6665 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6664);
// compiled call node returning call6665 (depth = 5)
// compiled member node returning call6665 (depth = 4)
  *var_n = call6665;
  if (call6665 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1522
  setline(1522);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6666 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call6667 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe6666);
// compiled call node returning call6667 (depth = 4)
  *var_newChain = call6667;
  if (call6667 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1523
  setline(1523);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 1521
  setline(1521);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6668 = gc_frame_new();
// Begin line 1523
  setline(1523);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6669 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6670 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6671 = callmethodflags(self, "in", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6670);
// compiled call node returning call6671 (depth = 7)
// compiled member node returning call6671 (depth = 6)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6672 = callmethod(call6671, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe6669);
// compiled call node returning call6672 (depth = 5)
  gc_frame_newslot(call6672);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  params[0] = call6672;
  partcv[0] = 1;
  Object call6673 = callmethod(*var_n, "in:=",
    1, partcv, params);
  gc_frame_end(callframe6668);
// compiled call node returning call6673 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 1524
  setline(1524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 1523
  setline(1523);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6674 = gc_frame_new();
// Begin line 1524
  setline(1524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6675 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6676 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6677 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6676);
// compiled call node returning call6677 (depth = 7)
// compiled member node returning call6677 (depth = 6)
  gc_frame_newslot(call6677);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6678 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6679 = gc_frame_new();
// call case 3: self.outer request
  Object call6680 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6679);
// compiled call node returning call6680 (depth = 9)
// compiled member node returning call6680 (depth = 8)
  partcv[0] = 0;
  Object call6681 = callmethodflags(call6680, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6678);
// compiled call node returning call6681 (depth = 7)
// compiled member node returning call6681 (depth = 6)
  params[0] = call6677;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call6682 = callmethodflags(call6681, "maybeListMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6675);
// compiled call node returning call6682 (depth = 5)
  gc_frame_newslot(call6682);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  params[0] = call6682;
  partcv[0] = 1;
  Object call6683 = callmethod(*var_n, "generics:=",
    1, partcv, params);
  gc_frame_end(callframe6674);
// compiled call node returning call6683 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 1525
  setline(1525);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6684 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call6685 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe6684);
// compiled call node returning call6685 (depth = 3)
  gc_frame_end(frame);
  return call6685;
}
Object meth_ast__apply6694(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1530
  setline(1530);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6696 == NULL) {
    strlit6696 = alloc_String("  ");
    gc_root(strlit6696);
  }
// compiled string node returning strlit6696 (depth = 7)
  int op_slot_right_6695 = gc_frame_newslot(strlit6696);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_6695 = gc_frame_newslot(*var_spc);
  params[0] = strlit6696;
  partcv[0] = 1;
  Object opresult6698 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult6698 (depth = 6)
  *var_spc = opresult6698;
  if (opresult6698 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply6755(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_g = &(stackframe->slots[0]);
  *var_g = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1537
  setline(1537);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6757 = gc_frame_new();
// starting to compile num node (depth = 9)
  Object num6758 = alloc_Float64(0);
// compiled num node returning num6758 (depth = 9)
  gc_frame_newslot(num6758);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_g (depth = 9)
  params[0] = num6758;
  partcv[0] = 1;
  Object call6759 = callmethod(*var_g, "pretty",
    1, partcv, params);
  gc_frame_end(callframe6757);
// compiled call node returning call6759 (depth = 8)
  int op_slot_right_6756 = gc_frame_newslot(call6759);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6762 == NULL) {
    strlit6762 = alloc_String("    ");
    gc_root(strlit6762);
  }
// compiled string node returning strlit6762 (depth = 9)
  int op_slot_right_6761 = gc_frame_newslot(strlit6762);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_6764 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit6767 == NULL) {
    strlit6767 = alloc_String("""\x0a""");
    gc_root(strlit6767);
  }
// compiled string node returning strlit6767 (depth = 11)
  int op_slot_right_6766 = gc_frame_newslot(strlit6767);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_6766 = gc_frame_newslot(*var_s);
  params[0] = strlit6767;
  partcv[0] = 1;
  Object opresult6769 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6769 (depth = 10)
  int op_slot_left_6764 = gc_frame_newslot(opresult6769);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6770 = callmethod(opresult6769, "++", 1, partcv, params);
// compiled op node returning opresult6770 (depth = 9)
  int op_slot_left_6761 = gc_frame_newslot(opresult6770);
  params[0] = strlit6762;
  partcv[0] = 1;
  Object opresult6771 = callmethod(opresult6770, "++", 1, partcv, params);
// compiled op node returning opresult6771 (depth = 8)
  int op_slot_left_6756 = gc_frame_newslot(opresult6771);
  params[0] = call6759;
  partcv[0] = 1;
  Object opresult6772 = callmethod(opresult6771, "++", 1, partcv, params);
// compiled op node returning opresult6772 (depth = 7)
  *var_s = opresult6772;
  if (opresult6772 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty6686(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1528
  setline(1528);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6687 == NULL) {
    strlit6687 = alloc_String("");
    gc_root(strlit6687);
  }
// compiled string node returning strlit6687 (depth = 4)
  *var_spc = strlit6687;
  if (strlit6687 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1529
  setline(1529);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6688 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_6689 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num6691 = alloc_Float64(0);
// compiled num node returning num6691 (depth = 5)
  int op_slot_left_6689 = gc_frame_newslot(num6691);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult6692 = callmethod(num6691, "..", 1, partcv, params);
// compiled op node returning opresult6692 (depth = 4)
  gc_frame_newslot(opresult6692);
// starting to compile block node (depth = 4)
  Object block6693 = alloc_Block(NULL, NULL, "ast", 1529);
  gc_frame_newslot(block6693);
// method _apply
  block_savedest(block6693);
  Object closure6694 = createclosure(2, "_apply");
  setclosureframe(closure6694, stackframe);
  addtoclosure(closure6694, var_spc);
  addtoclosure(closure6694, selfslot);
  struct UserObject *uo6694 = (struct UserObject*)block6693;
  uo6694->data[0] = (Object)closure6694;
  Method *meth_meth_ast__apply6694 = addmethod2pos(block6693, "_apply", &meth_ast__apply6694, 0);
  int argcv_meth_ast__apply6694[] = {1};
  meth_meth_ast__apply6694->type = alloc_MethodType(1, argcv_meth_ast__apply6694);
  meth_meth_ast__apply6694->definitionModule = modulename;
  meth_meth_ast__apply6694->definitionLine = 1524;
// compiled block node returning block6693 (depth = 4)
  gc_frame_newslot(block6693);
// call case 5: prelude request
  params[0] = opresult6692;
  params[1] = block6693;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6701 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6688);
// compiled call node returning call6701 (depth = 3)
// Begin line 1532
  setline(1532);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6703 == NULL) {
    strlit6703 = alloc_String("""\xe2""""\x80""""\xba""""\x0a""");
    gc_root(strlit6703);
  }
// compiled string node returning strlit6703 (depth = 5)
  int op_slot_right_6702 = gc_frame_newslot(strlit6703);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6706 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6707 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6706);
// compiled call node returning call6707 (depth = 7)
// compiled member node returning call6707 (depth = 6)
  int op_slot_right_6705 = gc_frame_newslot(call6707);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6710 == NULL) {
    strlit6710 = alloc_String("""\xe2""""\x80""""\xb9""");
    gc_root(strlit6710);
  }
// compiled string node returning strlit6710 (depth = 7)
  int op_slot_right_6709 = gc_frame_newslot(strlit6710);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6713 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call6714 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe6713);
// compiled call node returning call6714 (depth = 8)
  int op_slot_right_6712 = gc_frame_newslot(call6714);
// starting to compile string node (depth = 8)
  if (strlit6716 == NULL) {
    strlit6716 = alloc_String("");
    gc_root(strlit6716);
  }
// compiled string node returning strlit6716 (depth = 8)
  int op_slot_left_6712 = gc_frame_newslot(strlit6716);
  params[0] = call6714;
  partcv[0] = 1;
  Object opresult6717 = callmethod(strlit6716, "++", 1, partcv, params);
// compiled op node returning opresult6717 (depth = 7)
  int op_slot_left_6709 = gc_frame_newslot(opresult6717);
  params[0] = strlit6710;
  partcv[0] = 1;
  Object opresult6718 = callmethod(opresult6717, "++", 1, partcv, params);
// compiled op node returning opresult6718 (depth = 6)
  int op_slot_left_6705 = gc_frame_newslot(opresult6718);
  params[0] = call6707;
  partcv[0] = 1;
  Object opresult6719 = callmethod(opresult6718, "++", 1, partcv, params);
// compiled op node returning opresult6719 (depth = 5)
  int op_slot_left_6702 = gc_frame_newslot(opresult6719);
  params[0] = strlit6703;
  partcv[0] = 1;
  Object opresult6720 = callmethod(opresult6719, "++", 1, partcv, params);
// compiled op node returning opresult6720 (depth = 4)
  *var_s = opresult6720;
  if (opresult6720 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1533
  setline(1533);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6722 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6723 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6724 = callmethodflags(self, "in", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6723);
// compiled call node returning call6724 (depth = 7)
// compiled member node returning call6724 (depth = 6)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call6725 = callmethod(call6724, "pretty",
    1, partcv, params);
  gc_frame_end(callframe6722);
// compiled call node returning call6725 (depth = 5)
  int op_slot_right_6721 = gc_frame_newslot(call6725);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_6727 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_6727 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6729 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6729 (depth = 5)
  int op_slot_left_6721 = gc_frame_newslot(opresult6729);
  params[0] = call6725;
  partcv[0] = 1;
  Object opresult6730 = callmethod(opresult6729, "++", 1, partcv, params);
// compiled op node returning opresult6730 (depth = 4)
  *var_s = opresult6730;
  if (opresult6730 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1534
  setline(1534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool6734 = alloc_Boolean(0);
// compiled identifier node returning bool6734 (depth = 5)
  int op_slot_right_6733 = gc_frame_newslot(bool6734);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6736 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6737 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6736);
// compiled call node returning call6737 (depth = 6)
// compiled member node returning call6737 (depth = 5)
  int op_slot_left_6733 = gc_frame_newslot(call6737);
  params[0] = bool6734;
  partcv[0] = 1;
  Object opresult6738 = callmethod(call6737, "!=", 1, partcv, params);
// compiled op node returning opresult6738 (depth = 4)
  Object if6732 = done;
  if (istrue(opresult6738)) {
// Begin line 1535
  setline(1535);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6740 == NULL) {
    strlit6740 = alloc_String("  Generics:");
    gc_root(strlit6740);
  }
// compiled string node returning strlit6740 (depth = 6)
  int op_slot_right_6739 = gc_frame_newslot(strlit6740);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_6742 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit6745 == NULL) {
    strlit6745 = alloc_String("""\x0a""");
    gc_root(strlit6745);
  }
// compiled string node returning strlit6745 (depth = 8)
  int op_slot_right_6744 = gc_frame_newslot(strlit6745);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_6744 = gc_frame_newslot(*var_s);
  params[0] = strlit6745;
  partcv[0] = 1;
  Object opresult6747 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6747 (depth = 7)
  int op_slot_left_6742 = gc_frame_newslot(opresult6747);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6748 = callmethod(opresult6747, "++", 1, partcv, params);
// compiled op node returning opresult6748 (depth = 6)
  int op_slot_left_6739 = gc_frame_newslot(opresult6748);
  params[0] = strlit6740;
  partcv[0] = 1;
  Object opresult6749 = callmethod(opresult6748, "++", 1, partcv, params);
// compiled op node returning opresult6749 (depth = 5)
  *var_s = opresult6749;
  if (opresult6749 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1536
  setline(1536);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6751 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6752 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6753 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6752);
// compiled call node returning call6753 (depth = 6)
// compiled member node returning call6753 (depth = 5)
  gc_frame_newslot(call6753);
// starting to compile block node (depth = 5)
  Object block6754 = alloc_Block(NULL, NULL, "ast", 1536);
  gc_frame_newslot(block6754);
// method _apply
  block_savedest(block6754);
  Object closure6755 = createclosure(3, "_apply");
  setclosureframe(closure6755, stackframe);
  addtoclosure(closure6755, var_spc);
  addtoclosure(closure6755, var_s);
  addtoclosure(closure6755, selfslot);
  struct UserObject *uo6755 = (struct UserObject*)block6754;
  uo6755->data[0] = (Object)closure6755;
  Method *meth_meth_ast__apply6755 = addmethod2pos(block6754, "_apply", &meth_ast__apply6755, 0);
  int argcv_meth_ast__apply6755[] = {1};
  meth_meth_ast__apply6755->type = alloc_MethodType(1, argcv_meth_ast__apply6755);
  meth_meth_ast__apply6755->definitionModule = modulename;
  meth_meth_ast__apply6755->definitionLine = 1536;
// compiled block node returning block6754 (depth = 5)
  gc_frame_newslot(block6754);
// call case 5: prelude request
  params[0] = call6753;
  params[1] = block6754;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6775 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6751);
// compiled call node returning call6775 (depth = 4)
    gc_frame_newslot(call6775);
    if6732 = call6775;
  } else {
  }
// compiled if node returning if6732 (depth = 3)
// Begin line 1540
  setline(1540);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply6852(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1553
  setline(1553);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6854 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num6856 = alloc_Float64(1);
// compiled num node returning num6856 (depth = 10)
  int op_slot_right_6855 = gc_frame_newslot(num6856);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_6855 = gc_frame_newslot(*var_depth);
  params[0] = num6856;
  partcv[0] = 1;
  Object sum6858 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum6858 (depth = 9)
  gc_frame_newslot(sum6858);
// call case 6: other member request
// starting to compile call node (depth = 9)
  int callframe6859 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ix (depth = 10)
  gc_frame_newslot(*var_ix);
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6860 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6861 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6860);
// compiled call node returning call6861 (depth = 11)
// compiled member node returning call6861 (depth = 10)
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call6862 = callmethod(call6861, "at",
    1, partcv, params);
  gc_frame_end(callframe6859);
// compiled call node returning call6862 (depth = 9)
  params[0] = sum6858;
  partcv[0] = 1;
  Object call6863 = callmethod(call6862, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6854);
// compiled call node returning call6863 (depth = 8)
  int op_slot_right_6853 = gc_frame_newslot(call6863);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_6853 = gc_frame_newslot(*var_s);
  params[0] = call6863;
  partcv[0] = 1;
  Object opresult6865 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6865 (depth = 7)
  *var_s = opresult6865;
  if (opresult6865 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace6776(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1543
  setline(1543);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6777 == NULL) {
    strlit6777 = alloc_String("");
    gc_root(strlit6777);
  }
// compiled string node returning strlit6777 (depth = 4)
  *var_s = strlit6777;
  if (strlit6777 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1544
  setline(1544);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6780 == NULL) {
    strlit6780 = alloc_String("prefix");
    gc_root(strlit6780);
  }
// compiled string node returning strlit6780 (depth = 5)
  int op_slot_right_6779 = gc_frame_newslot(strlit6780);
// starting to compile call node (depth = 5)
  int callframe6782 = gc_frame_new();
// starting to compile num node (depth = 6)
  Object num6783 = alloc_Float64(1);
// compiled num node returning num6783 (depth = 6)
  gc_frame_newslot(num6783);
// starting to compile num node (depth = 6)
  Object num6784 = alloc_Float64(6);
// compiled num node returning num6784 (depth = 6)
  gc_frame_newslot(num6784);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6785 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6786 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6785);
// compiled call node returning call6786 (depth = 7)
// compiled member node returning call6786 (depth = 6)
  params[0] = num6783;
  params[1] = num6784;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6787 = callmethod(call6786, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe6782);
// compiled call node returning call6787 (depth = 5)
  int op_slot_left_6779 = gc_frame_newslot(call6787);
  params[0] = strlit6780;
  partcv[0] = 1;
  Object opresult6788 = callmethod(call6787, "==", 1, partcv, params);
// compiled op node returning opresult6788 (depth = 4)
  Object if6778 = done;
  if (istrue(opresult6788)) {
// Begin line 1545
  setline(1545);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6789 = gc_frame_new();
// starting to compile num node (depth = 6)
  Object num6790 = alloc_Float64(7);
// compiled num node returning num6790 (depth = 6)
  gc_frame_newslot(num6790);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6791 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6792 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6793 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6792);
// compiled call node returning call6793 (depth = 9)
// compiled member node returning call6793 (depth = 8)
  partcv[0] = 0;
  Object call6794 = callmethod(call6793, "size",
    1, partcv, params);
  gc_frame_end(callframe6791);
// compiled call node returning call6794 (depth = 7)
// compiled member node returning call6794 (depth = 6)
  gc_frame_newslot(call6794);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6795 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6796 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6795);
// compiled call node returning call6796 (depth = 7)
// compiled member node returning call6796 (depth = 6)
  params[0] = num6790;
  params[1] = call6794;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6797 = callmethod(call6796, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe6789);
// compiled call node returning call6797 (depth = 5)
  *var_s = call6797;
  if (call6797 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1546
  setline(1546);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6800 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num6801 = alloc_Float64(0);
// compiled num node returning num6801 (depth = 7)
  gc_frame_newslot(num6801);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6802 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6803 = callmethodflags(self, "in", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6802);
// compiled call node returning call6803 (depth = 8)
// compiled member node returning call6803 (depth = 7)
  params[0] = num6801;
  partcv[0] = 1;
  Object call6804 = callmethod(call6803, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6800);
// compiled call node returning call6804 (depth = 6)
  int op_slot_right_6799 = gc_frame_newslot(call6804);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6807 == NULL) {
    strlit6807 = alloc_String(" ");
    gc_root(strlit6807);
  }
// compiled string node returning strlit6807 (depth = 7)
  int op_slot_right_6806 = gc_frame_newslot(strlit6807);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6806 = gc_frame_newslot(*var_s);
  params[0] = strlit6807;
  partcv[0] = 1;
  Object opresult6809 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6809 (depth = 6)
  int op_slot_left_6799 = gc_frame_newslot(opresult6809);
  params[0] = call6804;
  partcv[0] = 1;
  Object opresult6810 = callmethod(opresult6809, "++", 1, partcv, params);
// compiled op node returning opresult6810 (depth = 5)
  *var_s = opresult6810;
  if (opresult6810 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if6778 = done;
  } else {
// Begin line 1548
  setline(1548);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6813 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6814 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6813);
// compiled call node returning call6814 (depth = 7)
// compiled member node returning call6814 (depth = 6)
  int op_slot_right_6812 = gc_frame_newslot(call6814);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6817 == NULL) {
    strlit6817 = alloc_String(".");
    gc_root(strlit6817);
  }
// compiled string node returning strlit6817 (depth = 7)
  int op_slot_right_6816 = gc_frame_newslot(strlit6817);
// starting to compile call node (depth = 7)
  int callframe6819 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  gc_frame_newslot(*var_depth);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6820 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6821 = callmethodflags(self, "in", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6820);
// compiled call node returning call6821 (depth = 9)
// compiled member node returning call6821 (depth = 8)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call6822 = callmethod(call6821, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6819);
// compiled call node returning call6822 (depth = 7)
  int op_slot_left_6816 = gc_frame_newslot(call6822);
  params[0] = strlit6817;
  partcv[0] = 1;
  Object opresult6823 = callmethod(call6822, "++", 1, partcv, params);
// compiled op node returning opresult6823 (depth = 6)
  int op_slot_left_6812 = gc_frame_newslot(opresult6823);
  params[0] = call6814;
  partcv[0] = 1;
  Object opresult6824 = callmethod(opresult6823, "++", 1, partcv, params);
// compiled op node returning opresult6824 (depth = 5)
  *var_s = opresult6824;
  if (opresult6824 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if6778 = done;
  }
// compiled if node returning if6778 (depth = 3)
// Begin line 1550
  setline(1550);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool6828 = alloc_Boolean(0);
// compiled identifier node returning bool6828 (depth = 5)
  int op_slot_right_6827 = gc_frame_newslot(bool6828);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6830 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6831 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6830);
// compiled call node returning call6831 (depth = 6)
// compiled member node returning call6831 (depth = 5)
  int op_slot_left_6827 = gc_frame_newslot(call6831);
  params[0] = bool6828;
  partcv[0] = 1;
  Object opresult6832 = callmethod(call6831, "!=", 1, partcv, params);
// compiled op node returning opresult6832 (depth = 4)
  Object if6826 = done;
  if (istrue(opresult6832)) {
// Begin line 1551
  setline(1551);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6834 == NULL) {
    strlit6834 = alloc_String("<");
    gc_root(strlit6834);
  }
// compiled string node returning strlit6834 (depth = 6)
  int op_slot_right_6833 = gc_frame_newslot(strlit6834);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_6833 = gc_frame_newslot(*var_s);
  params[0] = strlit6834;
  partcv[0] = 1;
  Object opresult6836 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6836 (depth = 5)
  *var_s = opresult6836;
  if (opresult6836 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1552
  setline(1552);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6838 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num6841 = alloc_Float64(1);
// compiled num node returning num6841 (depth = 7)
  int op_slot_right_6840 = gc_frame_newslot(num6841);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6843 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6844 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6845 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6844);
// compiled call node returning call6845 (depth = 10)
// compiled member node returning call6845 (depth = 9)
  partcv[0] = 0;
  Object call6846 = callmethod(call6845, "size",
    1, partcv, params);
  gc_frame_end(callframe6843);
// compiled call node returning call6846 (depth = 8)
// compiled member node returning call6846 (depth = 7)
  int op_slot_left_6840 = gc_frame_newslot(call6846);
  params[0] = num6841;
  partcv[0] = 1;
  Object diff6847 = callmethod(call6846, "-", 1, partcv, params);
// compiled op node returning diff6847 (depth = 6)
  int op_slot_right_6839 = gc_frame_newslot(diff6847);
// starting to compile num node (depth = 6)
  Object num6849 = alloc_Float64(1);
// compiled num node returning num6849 (depth = 6)
  int op_slot_left_6839 = gc_frame_newslot(num6849);
  params[0] = diff6847;
  partcv[0] = 1;
  Object opresult6850 = callmethod(num6849, "..", 1, partcv, params);
// compiled op node returning opresult6850 (depth = 5)
  gc_frame_newslot(opresult6850);
// starting to compile block node (depth = 5)
  Object block6851 = alloc_Block(NULL, NULL, "ast", 1552);
  gc_frame_newslot(block6851);
// method _apply
  block_savedest(block6851);
  Object closure6852 = createclosure(3, "_apply");
  setclosureframe(closure6852, stackframe);
  addtoclosure(closure6852, var_depth);
  addtoclosure(closure6852, var_s);
  addtoclosure(closure6852, selfslot);
  struct UserObject *uo6852 = (struct UserObject*)block6851;
  uo6852->data[0] = (Object)closure6852;
  Method *meth_meth_ast__apply6852 = addmethod2pos(block6851, "_apply", &meth_ast__apply6852, 0);
  int argcv_meth_ast__apply6852[] = {1};
  meth_meth_ast__apply6852->type = alloc_MethodType(1, argcv_meth_ast__apply6852);
  meth_meth_ast__apply6852->definitionModule = modulename;
  meth_meth_ast__apply6852->definitionLine = 1552;
// compiled block node returning block6851 (depth = 5)
  gc_frame_newslot(block6851);
// call case 5: prelude request
  params[0] = opresult6850;
  params[1] = block6851;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6868 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6838);
// compiled call node returning call6868 (depth = 4)
// Begin line 1555
  setline(1555);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6870 == NULL) {
    strlit6870 = alloc_String(">");
    gc_root(strlit6870);
  }
// compiled string node returning strlit6870 (depth = 6)
  int op_slot_right_6869 = gc_frame_newslot(strlit6870);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6873 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num6875 = alloc_Float64(1);
// compiled num node returning num6875 (depth = 9)
  int op_slot_right_6874 = gc_frame_newslot(num6875);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_6874 = gc_frame_newslot(*var_depth);
  params[0] = num6875;
  partcv[0] = 1;
  Object sum6877 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum6877 (depth = 8)
  gc_frame_newslot(sum6877);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6878 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6879 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6880 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6879);
// compiled call node returning call6880 (depth = 11)
// compiled member node returning call6880 (depth = 10)
  partcv[0] = 0;
  Object call6881 = callmethod(call6880, "last",
    1, partcv, params);
  gc_frame_end(callframe6878);
// compiled call node returning call6881 (depth = 9)
// compiled member node returning call6881 (depth = 8)
  params[0] = sum6877;
  partcv[0] = 1;
  Object call6882 = callmethod(call6881, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6873);
// compiled call node returning call6882 (depth = 7)
  int op_slot_right_6872 = gc_frame_newslot(call6882);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6872 = gc_frame_newslot(*var_s);
  params[0] = call6882;
  partcv[0] = 1;
  Object opresult6884 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6884 (depth = 6)
  int op_slot_left_6869 = gc_frame_newslot(opresult6884);
  params[0] = strlit6870;
  partcv[0] = 1;
  Object opresult6885 = callmethod(opresult6884, "++", 1, partcv, params);
// compiled op node returning opresult6885 (depth = 5)
  *var_s = opresult6885;
  if (opresult6885 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if6826 = done;
  } else {
  }
// compiled if node returning if6826 (depth = 3)
// Begin line 1557
  setline(1557);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_asString6887(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1559
  setline(1559);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6889 == NULL) {
    strlit6889 = alloc_String("");
    gc_root(strlit6889);
  }
// compiled string node returning strlit6889 (depth = 4)
  int op_slot_right_6888 = gc_frame_newslot(strlit6889);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6892 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6893 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6892);
// compiled call node returning call6893 (depth = 6)
// compiled member node returning call6893 (depth = 5)
  int op_slot_right_6891 = gc_frame_newslot(call6893);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6896 == NULL) {
    strlit6896 = alloc_String(".");
    gc_root(strlit6896);
  }
// compiled string node returning strlit6896 (depth = 6)
  int op_slot_right_6895 = gc_frame_newslot(strlit6896);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6899 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6900 = callmethodflags(self, "in", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6899);
// compiled call node returning call6900 (depth = 8)
// compiled member node returning call6900 (depth = 7)
  int op_slot_right_6898 = gc_frame_newslot(call6900);
// starting to compile string node (depth = 7)
  if (strlit6902 == NULL) {
    strlit6902 = alloc_String("");
    gc_root(strlit6902);
  }
// compiled string node returning strlit6902 (depth = 7)
  int op_slot_left_6898 = gc_frame_newslot(strlit6902);
  params[0] = call6900;
  partcv[0] = 1;
  Object opresult6903 = callmethod(strlit6902, "++", 1, partcv, params);
// compiled op node returning opresult6903 (depth = 6)
  int op_slot_left_6895 = gc_frame_newslot(opresult6903);
  params[0] = strlit6896;
  partcv[0] = 1;
  Object opresult6904 = callmethod(opresult6903, "++", 1, partcv, params);
// compiled op node returning opresult6904 (depth = 5)
  int op_slot_left_6891 = gc_frame_newslot(opresult6904);
  params[0] = call6893;
  partcv[0] = 1;
  Object opresult6905 = callmethod(opresult6904, "++", 1, partcv, params);
// compiled op node returning opresult6905 (depth = 4)
  int op_slot_left_6888 = gc_frame_newslot(opresult6905);
  params[0] = strlit6889;
  partcv[0] = 1;
  Object opresult6906 = callmethod(opresult6905, "++", 1, partcv, params);
// compiled op node returning opresult6906 (depth = 3)
  gc_frame_end(frame);
  return opresult6906;
}
Object meth_ast_asIdentifier6907(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_identifierNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asIdentifier (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asIdentifier");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_resultNode = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "resultNode");
// Begin line 1562
  setline(1562);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6908 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6909 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6910 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6909);
// compiled call node returning call6910 (depth = 6)
// compiled member node returning call6910 (depth = 5)
  gc_frame_newslot(call6910);
// starting to compile identifier node (depth = 5)
  Object bool6911 = alloc_Boolean(0);
// compiled identifier node returning bool6911 (depth = 5)
  gc_frame_newslot(bool6911);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_identifierNode (depth = 5)
  params[0] = call6910;
  params[1] = bool6911;
  partcv[0] = 2;
  Object call6912 = callmethod(*var_identifierNode, "new",
    1, partcv, params);
  gc_frame_end(callframe6908);
// compiled call node returning call6912 (depth = 4)
  *var_resultNode = call6912;
  if (call6912 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1563
  setline(1563);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 1562
  setline(1562);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6913 = gc_frame_new();
// Begin line 1563
  setline(1563);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool6914 = alloc_Boolean(1);
// compiled identifier node returning bool6914 (depth = 5)
  gc_frame_newslot(bool6914);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_resultNode (depth = 5)
  params[0] = bool6914;
  partcv[0] = 1;
  Object call6915 = callmethod(*var_resultNode, "inRequest:=",
    1, partcv, params);
  gc_frame_end(callframe6913);
// compiled call node returning call6915 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 1564
  setline(1564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 1562
  setline(1562);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6916 = gc_frame_new();
// Begin line 1564
  setline(1564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6917 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6918 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6917);
// compiled call node returning call6918 (depth = 6)
// compiled member node returning call6918 (depth = 5)
  gc_frame_newslot(call6918);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_resultNode (depth = 5)
  params[0] = call6918;
  partcv[0] = 1;
  Object call6919 = callmethod(*var_resultNode, "line:=",
    1, partcv, params);
  gc_frame_end(callframe6916);
// compiled call node returning call6919 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 1565
  setline(1565);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 1564
  setline(1564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6920 = gc_frame_new();
// Begin line 1565
  setline(1565);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6921 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6922 = callmethodflags(self, "linePos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6921);
// compiled call node returning call6922 (depth = 6)
// compiled member node returning call6922 (depth = 5)
  gc_frame_newslot(call6922);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_resultNode (depth = 5)
  params[0] = call6922;
  partcv[0] = 1;
  Object call6923 = callmethod(*var_resultNode, "linePos:=",
    1, partcv, params);
  gc_frame_end(callframe6920);
// compiled call node returning call6923 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 1566
  setline(1566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_resultNode (depth = 4)
  return *var_resultNode;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast_shallowCopy6924(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_memberNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1569
  setline(1569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6925 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe6926 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6927 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6928 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6927);
// compiled call node returning call6928 (depth = 6)
// compiled member node returning call6928 (depth = 5)
  gc_frame_newslot(call6928);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_memberNode (depth = 5)
  params[0] = call6928;
  params[1] = *var_nullNode;
  partcv[0] = 2;
  Object call6929 = callmethod(*var_memberNode, "new",
    1, partcv, params);
  gc_frame_end(callframe6926);
// compiled call node returning call6929 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call6930 = callmethod(call6929, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe6925);
// compiled call node returning call6930 (depth = 3)
  gc_frame_end(frame);
  return call6930;
}
Object meth_ast_new6622(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_identifierNode = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_memberNode = getfromclosure(closure, 2);
  Object *var_baseNode = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_request = &(stackframe->slots[0]);
  *var_request = args[curarg];
  curarg++;
  Object *var_receiver = &(stackframe->slots[1]);
  *var_receiver = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6623 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6623 = alloc_userobj2(18,16, objclass6623);
  gc_frame_newslot(obj6623);
if (objclass6623 == NULL) {
  glfree(obj6623->class->name);
  obj6623->class->name = "obj6615.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6623, self, 0);
  addmethodreal(obj6623,"outer", &reader_ast_outer_6624);
  Object oldself6623 = self;
  struct StackFrameObject *oldstackframe6623 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6623);
  gc_frame_newslot((Object)stackframe);
  self = obj6623;
  Object *oldselfslot6623 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6623 = (*(struct UserObject *)self).data[0], lowerouter6623 = thisouter6623;
  if (inheritingObject6623) {
    struct UserObject *inho6623 = (struct UserObject *)inheritingObject6623;
    while (inho6623->super != GraceDefaultObject) inho6623 = (struct UserObject *)inho6623->super;
    inho6623->super = obj6623;
    self = inheritingObject6623;
    *selfslot = self;
    lowerouter6623 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6623;
  }
if (objclass6623 == NULL) {
  Method *reader6625 = addmethodrealflags(obj6623, "kind",&reader_ast_kind_6625, MFLAG_DEF);
  reader6625->definitionModule = modulename;
  reader6625->definitionLine = 1503;
}
adddatum2(obj6623, alloc_Undefined(), 1);
if (objclass6623 == NULL) {
  Method *reader6626 = addmethodrealflags(obj6623, "value",&reader_ast_value_6626, 0);
  Method *writer6626 = addmethodrealflags(obj6623, "value:=",&writer_ast_value_6626, 0);
  reader6626->definitionModule = modulename;
  writer6626->definitionModule = modulename;
  reader6626->definitionLine = 1504;
  writer6626->definitionLine = 1504;
}
obj6623->flags |= OFLAG_MUTABLE;
adddatum2(obj6623, alloc_Undefined(), 2);
if (objclass6623 == NULL) {
  Method *reader6627 = addmethodrealflags(obj6623, "in",&reader_ast_in_6627, 0);
  Method *writer6627 = addmethodrealflags(obj6623, "in:=",&writer_ast_in_6627, 0);
  reader6627->definitionModule = modulename;
  writer6627->definitionModule = modulename;
  reader6627->definitionLine = 1505;
  writer6627->definitionLine = 1505;
}
obj6623->flags |= OFLAG_MUTABLE;
adddatum2(obj6623, alloc_Undefined(), 3);
if (objclass6623 == NULL) {
  Method *reader6628 = addmethodrealflags(obj6623, "generics",&reader_ast_generics_6628, 0);
  Method *writer6628 = addmethodrealflags(obj6623, "generics:=",&writer_ast_generics_6628, 0);
  reader6628->definitionModule = modulename;
  writer6628->definitionModule = modulename;
  reader6628->definitionLine = 1506;
  writer6628->definitionLine = 1506;
}
obj6623->flags |= OFLAG_MUTABLE;
adddatum2(obj6623, alloc_Undefined(), 4);
// method target
  struct UserObject *uo6629 = (struct UserObject*)obj6623;
  uo6629->data[5] = emptyclosure;
  Method *meth_meth_ast_target6629 = addmethod2pos(obj6623, "target", &meth_ast_target6629, 5);
  int argcv_meth_ast_target6629[] = {0};
  meth_meth_ast_target6629->type = alloc_MethodType(1, argcv_meth_ast_target6629);
  meth_meth_ast_target6629->definitionModule = modulename;
  meth_meth_ast_target6629->definitionLine = 1508;
// method nameString
  struct UserObject *uo6632 = (struct UserObject*)obj6623;
  uo6632->data[6] = emptyclosure;
  Method *meth_meth_ast_nameString6632 = addmethod2pos(obj6623, "nameString", &meth_ast_nameString6632, 6);
  int argcv_meth_ast_nameString6632[] = {0};
  meth_meth_ast_nameString6632->type = alloc_MethodType(1, argcv_meth_ast_nameString6632);
  meth_meth_ast_nameString6632->definitionModule = modulename;
  meth_meth_ast_nameString6632->definitionLine = 1509;
// method isMember
  struct UserObject *uo6635 = (struct UserObject*)obj6623;
  uo6635->data[7] = emptyclosure;
  Method *meth_meth_ast_isMember6635 = addmethod2pos(obj6623, "isMember", &meth_ast_isMember6635, 7);
  int argcv_meth_ast_isMember6635[] = {0};
  meth_meth_ast_isMember6635->type = alloc_MethodType(1, argcv_meth_ast_isMember6635);
  meth_meth_ast_isMember6635->definitionModule = modulename;
  meth_meth_ast_isMember6635->definitionLine = 1510;
// method accept()from
  struct UserObject *uo6637 = (struct UserObject*)obj6623;
  uo6637->data[8] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from6637 = addmethod2pos(obj6623, "accept()from", &meth_ast_accept_40__41_from6637, 8);
  int argcv_meth_ast_accept_40__41_from6637[] = {1, 1};
  meth_meth_ast_accept_40__41_from6637->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from6637);
  meth_meth_ast_accept_40__41_from6637->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from6637->definitionLine = 1511;
// method map()ancestors
  struct UserObject *uo6663 = (struct UserObject*)obj6623;
  uo6663->data[9] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors6663 = addmethod2pos(obj6623, "map()ancestors", &meth_ast_map_40__41_ancestors6663, 9);
  int argcv_meth_ast_map_40__41_ancestors6663[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors6663->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors6663);
  meth_meth_ast_map_40__41_ancestors6663->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors6663->definitionLine = 1520;
// method pretty
  struct UserObject *uo6686 = (struct UserObject*)obj6623;
  uo6686->data[10] = emptyclosure;
  Method *meth_meth_ast_pretty6686 = addmethod2pos(obj6623, "pretty", &meth_ast_pretty6686, 10);
  int argcv_meth_ast_pretty6686[] = {1};
  meth_meth_ast_pretty6686->type = alloc_MethodType(1, argcv_meth_ast_pretty6686);
  meth_meth_ast_pretty6686->definitionModule = modulename;
  meth_meth_ast_pretty6686->definitionLine = 1527;
// method toGrace
  struct UserObject *uo6776 = (struct UserObject*)obj6623;
  uo6776->data[11] = emptyclosure;
  Method *meth_meth_ast_toGrace6776 = addmethod2pos(obj6623, "toGrace", &meth_ast_toGrace6776, 11);
  int argcv_meth_ast_toGrace6776[] = {1};
  meth_meth_ast_toGrace6776->type = alloc_MethodType(1, argcv_meth_ast_toGrace6776);
meth_meth_ast_toGrace6776->type->types[0] = type_Number;
meth_meth_ast_toGrace6776->type->names[0] = "depth";
  meth_meth_ast_toGrace6776->definitionModule = modulename;
  meth_meth_ast_toGrace6776->definitionLine = 1542;
// method asString
  struct UserObject *uo6887 = (struct UserObject*)obj6623;
  uo6887->data[12] = emptyclosure;
  Method *meth_meth_ast_asString6887 = addmethod2pos(obj6623, "asString", &meth_ast_asString6887, 12);
  int argcv_meth_ast_asString6887[] = {0};
  meth_meth_ast_asString6887->type = alloc_MethodType(1, argcv_meth_ast_asString6887);
  meth_meth_ast_asString6887->definitionModule = modulename;
  meth_meth_ast_asString6887->definitionLine = 1559;
// method asIdentifier
  block_savedest(obj6623);
  Object closure6907 = createclosure(1, "asIdentifier");
  setclosureframe(closure6907, stackframe);
  addtoclosure(closure6907, var_identifierNode);
  struct UserObject *uo6907 = (struct UserObject*)obj6623;
  uo6907->data[13] = (Object)closure6907;
  Method *meth_meth_ast_asIdentifier6907 = addmethod2pos(obj6623, "asIdentifier", &meth_ast_asIdentifier6907, 13);
  int argcv_meth_ast_asIdentifier6907[] = {0};
  meth_meth_ast_asIdentifier6907->type = alloc_MethodType(1, argcv_meth_ast_asIdentifier6907);
  meth_meth_ast_asIdentifier6907->definitionModule = modulename;
  meth_meth_ast_asIdentifier6907->definitionLine = 1560;
// method shallowCopy
  block_savedest(obj6623);
  Object closure6924 = createclosure(2, "shallowCopy");
  setclosureframe(closure6924, stackframe);
  addtoclosure(closure6924, var_nullNode);
  addtoclosure(closure6924, var_memberNode);
  struct UserObject *uo6924 = (struct UserObject*)obj6623;
  uo6924->data[14] = (Object)closure6924;
  Method *meth_meth_ast_shallowCopy6924 = addmethod2pos(obj6623, "shallowCopy", &meth_ast_shallowCopy6924, 14);
  int argcv_meth_ast_shallowCopy6924[] = {0};
  meth_meth_ast_shallowCopy6924->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy6924);
  meth_meth_ast_shallowCopy6924->definitionModule = modulename;
  meth_meth_ast_shallowCopy6924->definitionLine = 1568;
  sourceObject = obj6623;
// Begin line 1502
  setline(1502);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6931 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_baseNode (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6932 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe6931);
// compiled call node returning call6932 (depth = 3)
  struct UserObject *obj6623_uo = (struct UserObject *)obj6623;
  obj6623_uo->super = call6932;
  sourceObject = obj6623;
// Begin line 1503
  setline(1503);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6933 == NULL) {
    strlit6933 = alloc_String("member");
    gc_root(strlit6933);
  }
// compiled string node returning strlit6933 (depth = 3)
  adddatum2(obj6623, strlit6933, 1);
  sourceObject = obj6623;
// Begin line 1504
  setline(1504);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_request (depth = 3)
  adddatum2(obj6623, *var_request, 2);
  sourceObject = obj6623;
// Begin line 1505
  setline(1505);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_receiver (depth = 3)
  adddatum2(obj6623, *var_receiver, 3);
  sourceObject = obj6623;
// Begin line 1506
  setline(1506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6934 = alloc_Boolean(0);
// compiled identifier node returning bool6934 (depth = 3)
  adddatum2(obj6623, bool6934, 4);
  sourceObject = obj6623;
  sourceObject = obj6623;
  sourceObject = obj6623;
  sourceObject = obj6623;
  sourceObject = obj6623;
  sourceObject = obj6623;
  sourceObject = obj6623;
  sourceObject = obj6623;
  sourceObject = obj6623;
  sourceObject = obj6623;
  objclass6623 = obj6623->class;
  objclass6623->definitionModule = modulename;
  objclass6623->definitionLine = 1500;
  (*(struct UserObject *)self).data[0] = lowerouter6623;
  self = oldself6623;
  selfslot = oldselfslot6623;
  stackframe = oldstackframe6623;
  gc_frame_end(frame);
  return obj6623;
}
Object meth_ast_new6622_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_identifierNode = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_memberNode = getfromclosure(closure, 2);
  Object *var_baseNode = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_request = &(stackframe->slots[0]);
  *var_request = args[curarg];
  curarg++;
  Object *var_receiver = &(stackframe->slots[1]);
  *var_receiver = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6623 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6623 = alloc_userobj2(18,16, objclass6623);
  gc_frame_newslot(obj6623);
if (objclass6623 == NULL) {
  glfree(obj6623->class->name);
  obj6623->class->name = "obj6615.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6623, self, 0);
  addmethodreal(obj6623,"outer", &reader_ast_outer_6624);
  Object oldself6623 = self;
  struct StackFrameObject *oldstackframe6623 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6623);
  gc_frame_newslot((Object)stackframe);
  self = obj6623;
  Object *oldselfslot6623 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6623 = (*(struct UserObject *)self).data[0], lowerouter6623 = thisouter6623;
  if (inheritingObject6623) {
    struct UserObject *inho6623 = (struct UserObject *)inheritingObject6623;
    while (inho6623->super != GraceDefaultObject) inho6623 = (struct UserObject *)inho6623->super;
    inho6623->super = obj6623;
    self = inheritingObject6623;
    *selfslot = self;
    lowerouter6623 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6623;
  }
if (objclass6623 == NULL) {
  Method *reader6625 = addmethodrealflags(obj6623, "kind",&reader_ast_kind_6625, MFLAG_DEF);
  reader6625->definitionModule = modulename;
  reader6625->definitionLine = 1503;
}
adddatum2(obj6623, alloc_Undefined(), 1);
if (objclass6623 == NULL) {
  Method *reader6626 = addmethodrealflags(obj6623, "value",&reader_ast_value_6626, 0);
  Method *writer6626 = addmethodrealflags(obj6623, "value:=",&writer_ast_value_6626, 0);
  reader6626->definitionModule = modulename;
  writer6626->definitionModule = modulename;
  reader6626->definitionLine = 1504;
  writer6626->definitionLine = 1504;
}
obj6623->flags |= OFLAG_MUTABLE;
adddatum2(obj6623, alloc_Undefined(), 2);
if (objclass6623 == NULL) {
  Method *reader6627 = addmethodrealflags(obj6623, "in",&reader_ast_in_6627, 0);
  Method *writer6627 = addmethodrealflags(obj6623, "in:=",&writer_ast_in_6627, 0);
  reader6627->definitionModule = modulename;
  writer6627->definitionModule = modulename;
  reader6627->definitionLine = 1505;
  writer6627->definitionLine = 1505;
}
obj6623->flags |= OFLAG_MUTABLE;
adddatum2(obj6623, alloc_Undefined(), 3);
if (objclass6623 == NULL) {
  Method *reader6628 = addmethodrealflags(obj6623, "generics",&reader_ast_generics_6628, 0);
  Method *writer6628 = addmethodrealflags(obj6623, "generics:=",&writer_ast_generics_6628, 0);
  reader6628->definitionModule = modulename;
  writer6628->definitionModule = modulename;
  reader6628->definitionLine = 1506;
  writer6628->definitionLine = 1506;
}
obj6623->flags |= OFLAG_MUTABLE;
adddatum2(obj6623, alloc_Undefined(), 4);
// method target
  struct UserObject *uo6629 = (struct UserObject*)obj6623;
  uo6629->data[5] = emptyclosure;
  Method *meth_meth_ast_target6629 = addmethod2pos(obj6623, "target", &meth_ast_target6629, 5);
  int argcv_meth_ast_target6629[] = {0};
  meth_meth_ast_target6629->type = alloc_MethodType(1, argcv_meth_ast_target6629);
  meth_meth_ast_target6629->definitionModule = modulename;
  meth_meth_ast_target6629->definitionLine = 1508;
// method nameString
  struct UserObject *uo6632 = (struct UserObject*)obj6623;
  uo6632->data[6] = emptyclosure;
  Method *meth_meth_ast_nameString6632 = addmethod2pos(obj6623, "nameString", &meth_ast_nameString6632, 6);
  int argcv_meth_ast_nameString6632[] = {0};
  meth_meth_ast_nameString6632->type = alloc_MethodType(1, argcv_meth_ast_nameString6632);
  meth_meth_ast_nameString6632->definitionModule = modulename;
  meth_meth_ast_nameString6632->definitionLine = 1509;
// method isMember
  struct UserObject *uo6635 = (struct UserObject*)obj6623;
  uo6635->data[7] = emptyclosure;
  Method *meth_meth_ast_isMember6635 = addmethod2pos(obj6623, "isMember", &meth_ast_isMember6635, 7);
  int argcv_meth_ast_isMember6635[] = {0};
  meth_meth_ast_isMember6635->type = alloc_MethodType(1, argcv_meth_ast_isMember6635);
  meth_meth_ast_isMember6635->definitionModule = modulename;
  meth_meth_ast_isMember6635->definitionLine = 1510;
// method accept()from
  struct UserObject *uo6637 = (struct UserObject*)obj6623;
  uo6637->data[8] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from6637 = addmethod2pos(obj6623, "accept()from", &meth_ast_accept_40__41_from6637, 8);
  int argcv_meth_ast_accept_40__41_from6637[] = {1, 1};
  meth_meth_ast_accept_40__41_from6637->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from6637);
  meth_meth_ast_accept_40__41_from6637->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from6637->definitionLine = 1511;
// method map()ancestors
  struct UserObject *uo6663 = (struct UserObject*)obj6623;
  uo6663->data[9] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors6663 = addmethod2pos(obj6623, "map()ancestors", &meth_ast_map_40__41_ancestors6663, 9);
  int argcv_meth_ast_map_40__41_ancestors6663[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors6663->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors6663);
  meth_meth_ast_map_40__41_ancestors6663->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors6663->definitionLine = 1520;
// method pretty
  struct UserObject *uo6686 = (struct UserObject*)obj6623;
  uo6686->data[10] = emptyclosure;
  Method *meth_meth_ast_pretty6686 = addmethod2pos(obj6623, "pretty", &meth_ast_pretty6686, 10);
  int argcv_meth_ast_pretty6686[] = {1};
  meth_meth_ast_pretty6686->type = alloc_MethodType(1, argcv_meth_ast_pretty6686);
  meth_meth_ast_pretty6686->definitionModule = modulename;
  meth_meth_ast_pretty6686->definitionLine = 1527;
// method toGrace
  struct UserObject *uo6776 = (struct UserObject*)obj6623;
  uo6776->data[11] = emptyclosure;
  Method *meth_meth_ast_toGrace6776 = addmethod2pos(obj6623, "toGrace", &meth_ast_toGrace6776, 11);
  int argcv_meth_ast_toGrace6776[] = {1};
  meth_meth_ast_toGrace6776->type = alloc_MethodType(1, argcv_meth_ast_toGrace6776);
meth_meth_ast_toGrace6776->type->types[0] = type_Number;
meth_meth_ast_toGrace6776->type->names[0] = "depth";
  meth_meth_ast_toGrace6776->definitionModule = modulename;
  meth_meth_ast_toGrace6776->definitionLine = 1542;
// method asString
  struct UserObject *uo6887 = (struct UserObject*)obj6623;
  uo6887->data[12] = emptyclosure;
  Method *meth_meth_ast_asString6887 = addmethod2pos(obj6623, "asString", &meth_ast_asString6887, 12);
  int argcv_meth_ast_asString6887[] = {0};
  meth_meth_ast_asString6887->type = alloc_MethodType(1, argcv_meth_ast_asString6887);
  meth_meth_ast_asString6887->definitionModule = modulename;
  meth_meth_ast_asString6887->definitionLine = 1559;
// method asIdentifier
  block_savedest(obj6623);
  Object closure6907 = createclosure(1, "asIdentifier");
  setclosureframe(closure6907, stackframe);
  addtoclosure(closure6907, var_identifierNode);
  struct UserObject *uo6907 = (struct UserObject*)obj6623;
  uo6907->data[13] = (Object)closure6907;
  Method *meth_meth_ast_asIdentifier6907 = addmethod2pos(obj6623, "asIdentifier", &meth_ast_asIdentifier6907, 13);
  int argcv_meth_ast_asIdentifier6907[] = {0};
  meth_meth_ast_asIdentifier6907->type = alloc_MethodType(1, argcv_meth_ast_asIdentifier6907);
  meth_meth_ast_asIdentifier6907->definitionModule = modulename;
  meth_meth_ast_asIdentifier6907->definitionLine = 1560;
// method shallowCopy
  block_savedest(obj6623);
  Object closure6924 = createclosure(2, "shallowCopy");
  setclosureframe(closure6924, stackframe);
  addtoclosure(closure6924, var_nullNode);
  addtoclosure(closure6924, var_memberNode);
  struct UserObject *uo6924 = (struct UserObject*)obj6623;
  uo6924->data[14] = (Object)closure6924;
  Method *meth_meth_ast_shallowCopy6924 = addmethod2pos(obj6623, "shallowCopy", &meth_ast_shallowCopy6924, 14);
  int argcv_meth_ast_shallowCopy6924[] = {0};
  meth_meth_ast_shallowCopy6924->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy6924);
  meth_meth_ast_shallowCopy6924->definitionModule = modulename;
  meth_meth_ast_shallowCopy6924->definitionLine = 1568;
  sourceObject = obj6623;
// Begin line 1502
  setline(1502);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6931 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_baseNode (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6932 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe6931);
// compiled call node returning call6932 (depth = 3)
  struct UserObject *obj6623_uo = (struct UserObject *)obj6623;
  obj6623_uo->super = call6932;
  sourceObject = obj6623;
// Begin line 1503
  setline(1503);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6933 == NULL) {
    strlit6933 = alloc_String("member");
    gc_root(strlit6933);
  }
// compiled string node returning strlit6933 (depth = 3)
  adddatum2(obj6623, strlit6933, 1);
  sourceObject = obj6623;
// Begin line 1504
  setline(1504);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_request (depth = 3)
  adddatum2(obj6623, *var_request, 2);
  sourceObject = obj6623;
// Begin line 1505
  setline(1505);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_receiver (depth = 3)
  adddatum2(obj6623, *var_receiver, 3);
  sourceObject = obj6623;
// Begin line 1506
  setline(1506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6934 = alloc_Boolean(0);
// compiled identifier node returning bool6934 (depth = 3)
  adddatum2(obj6623, bool6934, 4);
  sourceObject = obj6623;
  sourceObject = obj6623;
  sourceObject = obj6623;
  sourceObject = obj6623;
  sourceObject = obj6623;
  sourceObject = obj6623;
  sourceObject = obj6623;
  sourceObject = obj6623;
  sourceObject = obj6623;
  sourceObject = obj6623;
  objclass6623 = obj6623->class;
  objclass6623->definitionModule = modulename;
  objclass6623->definitionLine = 1500;
  (*(struct UserObject *)self).data[0] = lowerouter6623;
  self = oldself6623;
  selfslot = oldselfslot6623;
  stackframe = oldstackframe6623;
  gc_frame_end(frame);
  return obj6623;
}
Object meth_ast_memberNode6936(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 29, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "memberNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_memberNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for memberNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹memberNode›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1494
  setline(1494);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_memberNode (depth = 3)
  gc_frame_end(frame);
  return *var_memberNode;
}
Object meth_ast_genericNode6937(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 30, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "genericNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_genericNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for genericNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for genericNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_genericNode (depth = 3)
  gc_frame_end(frame);
  return *var_genericNode;
}
Object meth_ast_nameString6946(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for nameString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for nameString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1579
  setline(1579);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6947 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6948 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6949 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6948);
// compiled call node returning call6949 (depth = 7)
// compiled member node returning call6949 (depth = 6)
  partcv[0] = 0;
  Object call6950 = callmethod(call6949, "nameString",
    1, partcv, params);
  gc_frame_end(callframe6947);
// compiled call node returning call6950 (depth = 5)
// compiled member node returning call6950 (depth = 4)
  gc_frame_end(frame);
  return call6950;
}
Object meth_ast__apply6962(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit6964 == NULL) {
    strlit6964 = alloc_String("");
    gc_root(strlit6964);
  }
// compiled string node returning strlit6964 (depth = 8)
  int op_slot_right_6963 = gc_frame_newslot(strlit6964);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_each (depth = 9)
  int op_slot_right_6966 = gc_frame_newslot(*var_each);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit6969 == NULL) {
    strlit6969 = alloc_String("");
    gc_root(strlit6969);
  }
// compiled string node returning strlit6969 (depth = 10)
  int op_slot_right_6968 = gc_frame_newslot(strlit6969);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_right_6971 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 11)
  if (strlit6973 == NULL) {
    strlit6973 = alloc_String("");
    gc_root(strlit6973);
  }
// compiled string node returning strlit6973 (depth = 11)
  int op_slot_left_6971 = gc_frame_newslot(strlit6973);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult6974 = callmethod(strlit6973, "++", 1, partcv, params);
// compiled op node returning opresult6974 (depth = 10)
  int op_slot_left_6968 = gc_frame_newslot(opresult6974);
  params[0] = strlit6969;
  partcv[0] = 1;
  Object opresult6975 = callmethod(opresult6974, "++", 1, partcv, params);
// compiled op node returning opresult6975 (depth = 9)
  int op_slot_left_6966 = gc_frame_newslot(opresult6975);
  params[0] = *var_each;
  partcv[0] = 1;
  Object opresult6976 = callmethod(opresult6975, "++", 1, partcv, params);
// compiled op node returning opresult6976 (depth = 8)
  int op_slot_left_6963 = gc_frame_newslot(opresult6976);
  params[0] = strlit6964;
  partcv[0] = 1;
  Object opresult6977 = callmethod(opresult6976, "++", 1, partcv, params);
// compiled op node returning opresult6977 (depth = 7)
  *var_s = opresult6977;
  if (opresult6977 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply6981(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit6983 == NULL) {
    strlit6983 = alloc_String(", ");
    gc_root(strlit6983);
  }
// compiled string node returning strlit6983 (depth = 8)
  int op_slot_right_6982 = gc_frame_newslot(strlit6983);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_6982 = gc_frame_newslot(*var_s);
  params[0] = strlit6983;
  partcv[0] = 1;
  Object opresult6985 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6985 (depth = 7)
  *var_s = opresult6985;
  if (opresult6985 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_asString6951(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_base = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
// Begin line 1581
  setline(1581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6953 == NULL) {
    strlit6953 = alloc_String("<");
    gc_root(strlit6953);
  }
// compiled string node returning strlit6953 (depth = 6)
  int op_slot_right_6952 = gc_frame_newslot(strlit6953);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_base (depth = 7)
  int op_slot_right_6955 = gc_frame_newslot(*var_base);
// starting to compile string node (depth = 7)
  if (strlit6957 == NULL) {
    strlit6957 = alloc_String("generic ");
    gc_root(strlit6957);
  }
// compiled string node returning strlit6957 (depth = 7)
  int op_slot_left_6955 = gc_frame_newslot(strlit6957);
  params[0] = *var_base;
  partcv[0] = 1;
  Object opresult6958 = callmethod(strlit6957, "++", 1, partcv, params);
// compiled op node returning opresult6958 (depth = 6)
  int op_slot_left_6952 = gc_frame_newslot(opresult6958);
  params[0] = strlit6953;
  partcv[0] = 1;
  Object opresult6959 = callmethod(opresult6958, "++", 1, partcv, params);
// compiled op node returning opresult6959 (depth = 5)
  *var_s = opresult6959;
  if (opresult6959 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1582
  setline(1582);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6960 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block6961 = alloc_Block(NULL, NULL, "ast", 1582);
  gc_frame_newslot(block6961);
// method _apply
  block_savedest(block6961);
  Object closure6962 = createclosure(2, "_apply");
  setclosureframe(closure6962, stackframe);
  addtoclosure(closure6962, var_s);
  addtoclosure(closure6962, selfslot);
  struct UserObject *uo6962 = (struct UserObject*)block6961;
  uo6962->data[0] = (Object)closure6962;
  Method *meth_meth_ast__apply6962 = addmethod2pos(block6961, "_apply", &meth_ast__apply6962, 0);
  int argcv_meth_ast__apply6962[] = {1};
  meth_meth_ast__apply6962->type = alloc_MethodType(1, argcv_meth_ast__apply6962);
  meth_meth_ast__apply6962->definitionModule = modulename;
  meth_meth_ast__apply6962->definitionLine = 1579;
// compiled block node returning block6961 (depth = 5)
  gc_frame_newslot(block6961);
// starting to compile block node (depth = 5)
  Object block6980 = alloc_Block(NULL, NULL, "ast", 1582);
  gc_frame_newslot(block6980);
// method _apply
  block_savedest(block6980);
  Object closure6981 = createclosure(2, "_apply");
  setclosureframe(closure6981, stackframe);
  addtoclosure(closure6981, var_s);
  addtoclosure(closure6981, selfslot);
  struct UserObject *uo6981 = (struct UserObject*)block6980;
  uo6981->data[0] = (Object)closure6981;
  Method *meth_meth_ast__apply6981 = addmethod2pos(block6980, "_apply", &meth_ast__apply6981, 0);
  int argcv_meth_ast__apply6981[] = {0};
  meth_meth_ast__apply6981->type = alloc_MethodType(1, argcv_meth_ast__apply6981);
  meth_meth_ast__apply6981->definitionModule = modulename;
  meth_meth_ast__apply6981->definitionLine = 1579;
// compiled block node returning block6980 (depth = 5)
  gc_frame_newslot(block6980);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6988 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6989 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6988);
// compiled call node returning call6989 (depth = 6)
// compiled member node returning call6989 (depth = 5)
  params[0] = block6961;
  params[1] = block6980;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6990 = callmethod(call6989, "do()separatedBy",
    2, partcv, params);
  gc_frame_end(callframe6960);
// compiled call node returning call6990 (depth = 4)
// Begin line 1583
  setline(1583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6992 == NULL) {
    strlit6992 = alloc_String(">");
    gc_root(strlit6992);
  }
// compiled string node returning strlit6992 (depth = 5)
  int op_slot_right_6991 = gc_frame_newslot(strlit6992);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_6991 = gc_frame_newslot(*var_s);
  params[0] = strlit6992;
  partcv[0] = 1;
  Object opresult6994 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6994 (depth = 4)
  gc_frame_end(frame);
  return opresult6994;
}
Object meth_ast__apply7009(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1590
  setline(1590);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe7010 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_visitor (depth = 8)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_newChain (depth = 8)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_p (depth = 8)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7011 = callmethod(*var_p, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe7010);
// compiled call node returning call7011 (depth = 7)
  gc_frame_end(frame);
  return call7011;
}
Object meth_ast_accept_40__41_from6995(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1586
  setline(1586);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6997 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6998 = callmethod(*var_visitor, "visitGeneric()up",
    2, partcv, params);
  gc_frame_end(callframe6997);
// compiled call node returning call6998 (depth = 5)
  Object if6996 = done;
  if (istrue(call6998)) {
// Begin line 1587
  setline(1587);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6999 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_as (depth = 7)
  params[0] = self;
  partcv[0] = 1;
  Object call7000 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe6999);
// compiled call node returning call7000 (depth = 6)
  *var_newChain = call7000;
  if (call7000 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 1588
  setline(1588);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7001 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7002 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7003 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7002);
// compiled call node returning call7003 (depth = 7)
// compiled member node returning call7003 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7004 = callmethod(call7003, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe7001);
// compiled call node returning call7004 (depth = 5)
// Begin line 1589
  setline(1589);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7005 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7006 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7007 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7006);
// compiled call node returning call7007 (depth = 7)
// compiled member node returning call7007 (depth = 6)
  gc_frame_newslot(call7007);
// starting to compile block node (depth = 6)
  Object block7008 = alloc_Block(NULL, NULL, "ast", 1589);
  gc_frame_newslot(block7008);
// method _apply
  block_savedest(block7008);
  Object closure7009 = createclosure(3, "_apply");
  setclosureframe(closure7009, stackframe);
  addtoclosure(closure7009, var_visitor);
  addtoclosure(closure7009, var_newChain);
  addtoclosure(closure7009, selfslot);
  struct UserObject *uo7009 = (struct UserObject*)block7008;
  uo7009->data[0] = (Object)closure7009;
  Method *meth_meth_ast__apply7009 = addmethod2pos(block7008, "_apply", &meth_ast__apply7009, 0);
  int argcv_meth_ast__apply7009[] = {1};
  meth_meth_ast__apply7009->type = alloc_MethodType(1, argcv_meth_ast__apply7009);
  meth_meth_ast__apply7009->definitionModule = modulename;
  meth_meth_ast__apply7009->definitionLine = 1589;
// compiled block node returning block7008 (depth = 6)
  gc_frame_newslot(block7008);
// call case 5: prelude request
  params[0] = call7007;
  params[1] = block7008;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7013 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7005);
// compiled call node returning call7013 (depth = 5)
    gc_frame_newslot(call7013);
    if6996 = call7013;
  } else {
  }
// compiled if node returning if6996 (depth = 4)
  gc_frame_end(frame);
  return if6996;
}
Object meth_ast_map_40__41_ancestors7014(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1595
  setline(1595);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7015 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7016 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7015);
// compiled call node returning call7016 (depth = 6)
// compiled member node returning call7016 (depth = 5)
  *var_n = call7016;
  if (call7016 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1596
  setline(1596);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7017 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7018 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe7017);
// compiled call node returning call7018 (depth = 5)
  *var_newChain = call7018;
  if (call7018 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1597
  setline(1597);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1595
  setline(1595);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7019 = gc_frame_new();
// Begin line 1597
  setline(1597);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7020 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7021 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7022 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7021);
// compiled call node returning call7022 (depth = 8)
// compiled member node returning call7022 (depth = 7)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7023 = callmethod(call7022, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe7020);
// compiled call node returning call7023 (depth = 6)
  gc_frame_newslot(call7023);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call7023;
  partcv[0] = 1;
  Object call7024 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe7019);
// compiled call node returning call7024 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1598
  setline(1598);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1597
  setline(1597);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7025 = gc_frame_new();
// Begin line 1598
  setline(1598);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7026 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7027 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7028 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7027);
// compiled call node returning call7028 (depth = 8)
// compiled member node returning call7028 (depth = 7)
  gc_frame_newslot(call7028);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7029 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7030 = gc_frame_new();
// call case 3: self.outer request
  Object call7031 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7030);
// compiled call node returning call7031 (depth = 10)
// compiled member node returning call7031 (depth = 9)
  partcv[0] = 0;
  Object call7032 = callmethodflags(call7031, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7029);
// compiled call node returning call7032 (depth = 8)
// compiled member node returning call7032 (depth = 7)
  params[0] = call7028;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call7033 = callmethodflags(call7032, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7026);
// compiled call node returning call7033 (depth = 6)
  gc_frame_newslot(call7033);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call7033;
  partcv[0] = 1;
  Object call7034 = callmethod(*var_n, "params:=",
    1, partcv, params);
  gc_frame_end(callframe7025);
// compiled call node returning call7034 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1599
  setline(1599);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7035 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call7036 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe7035);
// compiled call node returning call7036 (depth = 4)
  gc_frame_end(frame);
  return call7036;
}
Object meth_ast__apply7065(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1604
  setline(1604);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7067 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num7069 = alloc_Float64(2);
// compiled num node returning num7069 (depth = 10)
  int op_slot_right_7068 = gc_frame_newslot(num7069);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_7068 = gc_frame_newslot(*var_depth);
  params[0] = num7069;
  partcv[0] = 1;
  Object sum7071 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum7071 (depth = 9)
  gc_frame_newslot(sum7071);
// call case 6: other member request
// starting to compile index node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe7072 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7073 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7072);
// compiled call node returning call7073 (depth = 11)
// compiled member node returning call7073 (depth = 10)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  params[0] = *var_i;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres7074 = callmethod(call7073, "[]", 1, partcv, params);
// compiled index node returning idxres7074 (depth = 9)
  params[0] = sum7071;
  partcv[0] = 1;
  Object call7075 = callmethod(idxres7074, "pretty",
    1, partcv, params);
  gc_frame_end(callframe7067);
// compiled call node returning call7075 (depth = 8)
  int op_slot_right_7066 = gc_frame_newslot(call7075);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_7066 = gc_frame_newslot(*var_s);
  params[0] = call7075;
  partcv[0] = 1;
  Object opresult7077 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7077 (depth = 7)
  *var_s = opresult7077;
  if (opresult7077 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1605
  setline(1605);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7081 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe7082 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7083 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7082);
// compiled call node returning call7083 (depth = 11)
// compiled member node returning call7083 (depth = 10)
  partcv[0] = 0;
  Object call7084 = callmethod(call7083, "size",
    1, partcv, params);
  gc_frame_end(callframe7081);
// compiled call node returning call7084 (depth = 9)
// compiled member node returning call7084 (depth = 8)
  int op_slot_right_7080 = gc_frame_newslot(call7084);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  int op_slot_left_7080 = gc_frame_newslot(*var_i);
  params[0] = call7084;
  partcv[0] = 1;
  Object opresult7086 = callmethod(*var_i, "<", 1, partcv, params);
// compiled op node returning opresult7086 (depth = 7)
  Object if7079 = done;
  if (istrue(opresult7086)) {
// Begin line 1606
  setline(1606);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit7088 == NULL) {
    strlit7088 = alloc_String(", ");
    gc_root(strlit7088);
  }
// compiled string node returning strlit7088 (depth = 9)
  int op_slot_right_7087 = gc_frame_newslot(strlit7088);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_7087 = gc_frame_newslot(*var_s);
  params[0] = strlit7088;
  partcv[0] = 1;
  Object opresult7090 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7090 (depth = 8)
  *var_s = opresult7090;
  if (opresult7090 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if7079 = done;
  } else {
  }
// compiled if node returning if7079 (depth = 6)
  gc_frame_end(frame);
  return if7079;
}
Object meth_ast_pretty7037(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1602
  setline(1602);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7039 == NULL) {
    strlit7039 = alloc_String("""\xe2""""\x80""""\xba""<");
    gc_root(strlit7039);
  }
// compiled string node returning strlit7039 (depth = 6)
  int op_slot_right_7038 = gc_frame_newslot(strlit7039);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7042 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7043 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7044 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7043);
// compiled call node returning call7044 (depth = 10)
// compiled member node returning call7044 (depth = 9)
  partcv[0] = 0;
  Object call7045 = callmethod(call7044, "value",
    1, partcv, params);
  gc_frame_end(callframe7042);
// compiled call node returning call7045 (depth = 8)
// compiled member node returning call7045 (depth = 7)
  int op_slot_right_7041 = gc_frame_newslot(call7045);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit7048 == NULL) {
    strlit7048 = alloc_String("""\xe2""""\x80""""\xb9""");
    gc_root(strlit7048);
  }
// compiled string node returning strlit7048 (depth = 8)
  int op_slot_right_7047 = gc_frame_newslot(strlit7048);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7051 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call7052 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe7051);
// compiled call node returning call7052 (depth = 9)
  int op_slot_right_7050 = gc_frame_newslot(call7052);
// starting to compile string node (depth = 9)
  if (strlit7054 == NULL) {
    strlit7054 = alloc_String("");
    gc_root(strlit7054);
  }
// compiled string node returning strlit7054 (depth = 9)
  int op_slot_left_7050 = gc_frame_newslot(strlit7054);
  params[0] = call7052;
  partcv[0] = 1;
  Object opresult7055 = callmethod(strlit7054, "++", 1, partcv, params);
// compiled op node returning opresult7055 (depth = 8)
  int op_slot_left_7047 = gc_frame_newslot(opresult7055);
  params[0] = strlit7048;
  partcv[0] = 1;
  Object opresult7056 = callmethod(opresult7055, "++", 1, partcv, params);
// compiled op node returning opresult7056 (depth = 7)
  int op_slot_left_7041 = gc_frame_newslot(opresult7056);
  params[0] = call7045;
  partcv[0] = 1;
  Object opresult7057 = callmethod(opresult7056, "++", 1, partcv, params);
// compiled op node returning opresult7057 (depth = 6)
  int op_slot_left_7038 = gc_frame_newslot(opresult7057);
  params[0] = strlit7039;
  partcv[0] = 1;
  Object opresult7058 = callmethod(opresult7057, "++", 1, partcv, params);
// compiled op node returning opresult7058 (depth = 5)
  *var_s = opresult7058;
  if (opresult7058 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1603
  setline(1603);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7059 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7060 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7061 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7062 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7061);
// compiled call node returning call7062 (depth = 8)
// compiled member node returning call7062 (depth = 7)
  partcv[0] = 0;
  Object call7063 = callmethod(call7062, "indices",
    1, partcv, params);
  gc_frame_end(callframe7060);
// compiled call node returning call7063 (depth = 6)
// compiled member node returning call7063 (depth = 5)
  gc_frame_newslot(call7063);
// starting to compile block node (depth = 5)
  Object block7064 = alloc_Block(NULL, NULL, "ast", 1603);
  gc_frame_newslot(block7064);
// method _apply
  block_savedest(block7064);
  Object closure7065 = createclosure(3, "_apply");
  setclosureframe(closure7065, stackframe);
  addtoclosure(closure7065, var_depth);
  addtoclosure(closure7065, var_s);
  addtoclosure(closure7065, selfslot);
  struct UserObject *uo7065 = (struct UserObject*)block7064;
  uo7065->data[0] = (Object)closure7065;
  Method *meth_meth_ast__apply7065 = addmethod2pos(block7064, "_apply", &meth_ast__apply7065, 0);
  int argcv_meth_ast__apply7065[] = {1};
  meth_meth_ast__apply7065->type = alloc_MethodType(1, argcv_meth_ast__apply7065);
  meth_meth_ast__apply7065->definitionModule = modulename;
  meth_meth_ast__apply7065->definitionLine = 1603;
// compiled block node returning block7064 (depth = 5)
  gc_frame_newslot(block7064);
// call case 5: prelude request
  params[0] = call7063;
  params[1] = block7064;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7093 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7059);
// compiled call node returning call7093 (depth = 4)
// Begin line 1609
  setline(1609);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7095 == NULL) {
    strlit7095 = alloc_String(">");
    gc_root(strlit7095);
  }
// compiled string node returning strlit7095 (depth = 6)
  int op_slot_right_7094 = gc_frame_newslot(strlit7095);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7094 = gc_frame_newslot(*var_s);
  params[0] = strlit7095;
  partcv[0] = 1;
  Object opresult7097 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7097 (depth = 5)
  *var_s = opresult7097;
  if (opresult7097 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1610
  setline(1610);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply7114(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1616
  setline(1616);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7116 = gc_frame_new();
// starting to compile num node (depth = 9)
  Object num7117 = alloc_Float64(0);
// compiled num node returning num7117 (depth = 9)
  gc_frame_newslot(num7117);
// call case 6: other member request
// starting to compile index node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe7118 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7119 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7118);
// compiled call node returning call7119 (depth = 11)
// compiled member node returning call7119 (depth = 10)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  params[0] = *var_i;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres7120 = callmethod(call7119, "[]", 1, partcv, params);
// compiled index node returning idxres7120 (depth = 9)
  params[0] = num7117;
  partcv[0] = 1;
  Object call7121 = callmethod(idxres7120, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe7116);
// compiled call node returning call7121 (depth = 8)
  int op_slot_right_7115 = gc_frame_newslot(call7121);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_7115 = gc_frame_newslot(*var_s);
  params[0] = call7121;
  partcv[0] = 1;
  Object opresult7123 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7123 (depth = 7)
  *var_s = opresult7123;
  if (opresult7123 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1617
  setline(1617);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7127 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe7128 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7129 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7128);
// compiled call node returning call7129 (depth = 11)
// compiled member node returning call7129 (depth = 10)
  partcv[0] = 0;
  Object call7130 = callmethod(call7129, "size",
    1, partcv, params);
  gc_frame_end(callframe7127);
// compiled call node returning call7130 (depth = 9)
// compiled member node returning call7130 (depth = 8)
  int op_slot_right_7126 = gc_frame_newslot(call7130);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  int op_slot_left_7126 = gc_frame_newslot(*var_i);
  params[0] = call7130;
  partcv[0] = 1;
  Object opresult7132 = callmethod(*var_i, "<", 1, partcv, params);
// compiled op node returning opresult7132 (depth = 7)
  Object if7125 = done;
  if (istrue(opresult7132)) {
// Begin line 1618
  setline(1618);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit7134 == NULL) {
    strlit7134 = alloc_String(", ");
    gc_root(strlit7134);
  }
// compiled string node returning strlit7134 (depth = 9)
  int op_slot_right_7133 = gc_frame_newslot(strlit7134);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_7133 = gc_frame_newslot(*var_s);
  params[0] = strlit7134;
  partcv[0] = 1;
  Object opresult7136 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7136 (depth = 8)
  *var_s = opresult7136;
  if (opresult7136 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if7125 = done;
  } else {
  }
// compiled if node returning if7125 (depth = 6)
  gc_frame_end(frame);
  return if7125;
}
Object meth_ast_toGrace7099(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1614
  setline(1614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7101 == NULL) {
    strlit7101 = alloc_String("<");
    gc_root(strlit7101);
  }
// compiled string node returning strlit7101 (depth = 6)
  int op_slot_right_7100 = gc_frame_newslot(strlit7101);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7103 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7104 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7105 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7104);
// compiled call node returning call7105 (depth = 9)
// compiled member node returning call7105 (depth = 8)
  partcv[0] = 0;
  Object call7106 = callmethod(call7105, "value",
    1, partcv, params);
  gc_frame_end(callframe7103);
// compiled call node returning call7106 (depth = 7)
// compiled member node returning call7106 (depth = 6)
  int op_slot_left_7100 = gc_frame_newslot(call7106);
  params[0] = strlit7101;
  partcv[0] = 1;
  Object opresult7107 = callmethod(call7106, "++", 1, partcv, params);
// compiled op node returning opresult7107 (depth = 5)
  *var_s = opresult7107;
  if (opresult7107 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1615
  setline(1615);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7108 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7109 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7110 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7111 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7110);
// compiled call node returning call7111 (depth = 8)
// compiled member node returning call7111 (depth = 7)
  partcv[0] = 0;
  Object call7112 = callmethod(call7111, "indices",
    1, partcv, params);
  gc_frame_end(callframe7109);
// compiled call node returning call7112 (depth = 6)
// compiled member node returning call7112 (depth = 5)
  gc_frame_newslot(call7112);
// starting to compile block node (depth = 5)
  Object block7113 = alloc_Block(NULL, NULL, "ast", 1615);
  gc_frame_newslot(block7113);
// method _apply
  block_savedest(block7113);
  Object closure7114 = createclosure(2, "_apply");
  setclosureframe(closure7114, stackframe);
  addtoclosure(closure7114, var_s);
  addtoclosure(closure7114, selfslot);
  struct UserObject *uo7114 = (struct UserObject*)block7113;
  uo7114->data[0] = (Object)closure7114;
  Method *meth_meth_ast__apply7114 = addmethod2pos(block7113, "_apply", &meth_ast__apply7114, 0);
  int argcv_meth_ast__apply7114[] = {1};
  meth_meth_ast__apply7114->type = alloc_MethodType(1, argcv_meth_ast__apply7114);
  meth_meth_ast__apply7114->definitionModule = modulename;
  meth_meth_ast__apply7114->definitionLine = 1615;
// compiled block node returning block7113 (depth = 5)
  gc_frame_newslot(block7113);
// call case 5: prelude request
  params[0] = call7112;
  params[1] = block7113;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7139 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7108);
// compiled call node returning call7139 (depth = 4)
// Begin line 1621
  setline(1621);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7141 == NULL) {
    strlit7141 = alloc_String(">");
    gc_root(strlit7141);
  }
// compiled string node returning strlit7141 (depth = 6)
  int op_slot_right_7140 = gc_frame_newslot(strlit7141);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7140 = gc_frame_newslot(*var_s);
  params[0] = strlit7141;
  partcv[0] = 1;
  Object opresult7143 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7143 (depth = 5)
  *var_s = opresult7143;
  if (opresult7143 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1622
  setline(1622);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy7145(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_genericNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1625
  setline(1625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7146 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe7147 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7148 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7149 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7148);
// compiled call node returning call7149 (depth = 7)
// compiled member node returning call7149 (depth = 6)
  gc_frame_newslot(call7149);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_emptySeq (depth = 6)
  gc_frame_newslot(*var_emptySeq);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_genericNode (depth = 6)
  params[0] = call7149;
  params[1] = *var_emptySeq;
  partcv[0] = 2;
  Object call7150 = callmethod(*var_genericNode, "new",
    1, partcv, params);
  gc_frame_end(callframe7147);
// compiled call node returning call7150 (depth = 5)
  params[0] = self;
  partcv[0] = 1;
  Object call7151 = callmethod(call7150, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe7146);
// compiled call node returning call7151 (depth = 4)
  gc_frame_end(frame);
  return call7151;
}
Object meth_ast_new6940(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_genericNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_base = &(stackframe->slots[0]);
  *var_base = args[curarg];
  curarg++;
  Object *var_params_39_ = &(stackframe->slots[1]);
  *var_params_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6941 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6941 = alloc_userobj2(13,12, objclass6941);
  gc_frame_newslot(obj6941);
if (objclass6941 == NULL) {
  glfree(obj6941->class->name);
  obj6941->class->name = "genericNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6941, self, 0);
  addmethodreal(obj6941,"outer", &reader_ast_outer_6942);
  Object oldself6941 = self;
  struct StackFrameObject *oldstackframe6941 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6941);
  gc_frame_newslot((Object)stackframe);
  self = obj6941;
  Object *oldselfslot6941 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6941 = (*(struct UserObject *)self).data[0], lowerouter6941 = thisouter6941;
  if (inheritingObject6941) {
    struct UserObject *inho6941 = (struct UserObject *)inheritingObject6941;
    while (inho6941->super != GraceDefaultObject) inho6941 = (struct UserObject *)inho6941->super;
    inho6941->super = obj6941;
    self = inheritingObject6941;
    *selfslot = self;
    lowerouter6941 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6941;
  }
if (objclass6941 == NULL) {
  Method *reader6943 = addmethodrealflags(obj6941, "kind",&reader_ast_kind_6943, MFLAG_DEF);
  reader6943->definitionModule = modulename;
  reader6943->definitionLine = 1575;
}
adddatum2(obj6941, alloc_Undefined(), 1);
if (objclass6941 == NULL) {
  Method *reader6944 = addmethodrealflags(obj6941, "value",&reader_ast_value_6944, 0);
  Method *writer6944 = addmethodrealflags(obj6941, "value:=",&writer_ast_value_6944, 0);
  reader6944->definitionModule = modulename;
  writer6944->definitionModule = modulename;
  reader6944->definitionLine = 1576;
  writer6944->definitionLine = 1576;
}
obj6941->flags |= OFLAG_MUTABLE;
adddatum2(obj6941, alloc_Undefined(), 2);
if (objclass6941 == NULL) {
  Method *reader6945 = addmethodrealflags(obj6941, "params",&reader_ast_params_6945, 0);
  Method *writer6945 = addmethodrealflags(obj6941, "params:=",&writer_ast_params_6945, 0);
  reader6945->definitionModule = modulename;
  writer6945->definitionModule = modulename;
  reader6945->definitionLine = 1578;
  writer6945->definitionLine = 1578;
}
obj6941->flags |= OFLAG_MUTABLE;
adddatum2(obj6941, alloc_Undefined(), 3);
// method nameString
  struct UserObject *uo6946 = (struct UserObject*)obj6941;
  uo6946->data[4] = emptyclosure;
  Method *meth_meth_ast_nameString6946 = addmethod2pos(obj6941, "nameString", &meth_ast_nameString6946, 4);
  int argcv_meth_ast_nameString6946[] = {0};
  meth_meth_ast_nameString6946->type = alloc_MethodType(1, argcv_meth_ast_nameString6946);
  meth_meth_ast_nameString6946->definitionModule = modulename;
  meth_meth_ast_nameString6946->definitionLine = 1579;
// method asString
  block_savedest(obj6941);
  Object closure6951 = createclosure(1, "asString");
  setclosureframe(closure6951, stackframe);
  addtoclosure(closure6951, var_base);
  struct UserObject *uo6951 = (struct UserObject*)obj6941;
  uo6951->data[5] = (Object)closure6951;
  Method *meth_meth_ast_asString6951 = addmethod2pos(obj6941, "asString", &meth_ast_asString6951, 5);
  int argcv_meth_ast_asString6951[] = {0};
  meth_meth_ast_asString6951->type = alloc_MethodType(1, argcv_meth_ast_asString6951);
  meth_meth_ast_asString6951->definitionModule = modulename;
  meth_meth_ast_asString6951->definitionLine = 1580;
// method accept()from
  struct UserObject *uo6995 = (struct UserObject*)obj6941;
  uo6995->data[6] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from6995 = addmethod2pos(obj6941, "accept()from", &meth_ast_accept_40__41_from6995, 6);
  int argcv_meth_ast_accept_40__41_from6995[] = {1, 1};
  meth_meth_ast_accept_40__41_from6995->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from6995);
  meth_meth_ast_accept_40__41_from6995->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from6995->definitionLine = 1585;
// method map()ancestors
  struct UserObject *uo7014 = (struct UserObject*)obj6941;
  uo7014->data[7] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors7014 = addmethod2pos(obj6941, "map()ancestors", &meth_ast_map_40__41_ancestors7014, 7);
  int argcv_meth_ast_map_40__41_ancestors7014[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors7014->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors7014);
  meth_meth_ast_map_40__41_ancestors7014->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors7014->definitionLine = 1594;
// method pretty
  struct UserObject *uo7037 = (struct UserObject*)obj6941;
  uo7037->data[8] = emptyclosure;
  Method *meth_meth_ast_pretty7037 = addmethod2pos(obj6941, "pretty", &meth_ast_pretty7037, 8);
  int argcv_meth_ast_pretty7037[] = {1};
  meth_meth_ast_pretty7037->type = alloc_MethodType(1, argcv_meth_ast_pretty7037);
  meth_meth_ast_pretty7037->definitionModule = modulename;
  meth_meth_ast_pretty7037->definitionLine = 1601;
// method toGrace
  struct UserObject *uo7099 = (struct UserObject*)obj6941;
  uo7099->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace7099 = addmethod2pos(obj6941, "toGrace", &meth_ast_toGrace7099, 9);
  int argcv_meth_ast_toGrace7099[] = {1};
  meth_meth_ast_toGrace7099->type = alloc_MethodType(1, argcv_meth_ast_toGrace7099);
meth_meth_ast_toGrace7099->type->types[0] = type_Number;
meth_meth_ast_toGrace7099->type->names[0] = "depth";
  meth_meth_ast_toGrace7099->definitionModule = modulename;
  meth_meth_ast_toGrace7099->definitionLine = 1613;
// method shallowCopy
  block_savedest(obj6941);
  Object closure7145 = createclosure(2, "shallowCopy");
  setclosureframe(closure7145, stackframe);
  addtoclosure(closure7145, var_emptySeq);
  addtoclosure(closure7145, var_genericNode);
  struct UserObject *uo7145 = (struct UserObject*)obj6941;
  uo7145->data[10] = (Object)closure7145;
  Method *meth_meth_ast_shallowCopy7145 = addmethod2pos(obj6941, "shallowCopy", &meth_ast_shallowCopy7145, 10);
  int argcv_meth_ast_shallowCopy7145[] = {0};
  meth_meth_ast_shallowCopy7145->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy7145);
  meth_meth_ast_shallowCopy7145->definitionModule = modulename;
  meth_meth_ast_shallowCopy7145->definitionLine = 1624;
  sourceObject = obj6941;
// Begin line 1574
  setline(1574);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7152 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7153 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7152);
// compiled call node returning call7153 (depth = 4)
  struct UserObject *obj6941_uo = (struct UserObject *)obj6941;
  obj6941_uo->super = call7153;
  sourceObject = obj6941;
// Begin line 1575
  setline(1575);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit7154 == NULL) {
    strlit7154 = alloc_String("generic");
    gc_root(strlit7154);
  }
// compiled string node returning strlit7154 (depth = 4)
  adddatum2(obj6941, strlit7154, 1);
  sourceObject = obj6941;
// Begin line 1576
  setline(1576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_base (depth = 4)
  adddatum2(obj6941, *var_base, 2);
  sourceObject = obj6941;
// Begin line 1578
  setline(1578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_params_39_ (depth = 4)
  adddatum2(obj6941, *var_params_39_, 3);
  sourceObject = obj6941;
  sourceObject = obj6941;
  sourceObject = obj6941;
  sourceObject = obj6941;
  sourceObject = obj6941;
  sourceObject = obj6941;
  sourceObject = obj6941;
  objclass6941 = obj6941->class;
  objclass6941->definitionModule = modulename;
  objclass6941->definitionLine = 1573;
  (*(struct UserObject *)self).data[0] = lowerouter6941;
  self = oldself6941;
  selfslot = oldselfslot6941;
  stackframe = oldstackframe6941;
  gc_frame_end(frame);
  return obj6941;
}
Object meth_ast_new6940_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_genericNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_base = &(stackframe->slots[0]);
  *var_base = args[curarg];
  curarg++;
  Object *var_params_39_ = &(stackframe->slots[1]);
  *var_params_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6941 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6941 = alloc_userobj2(13,12, objclass6941);
  gc_frame_newslot(obj6941);
if (objclass6941 == NULL) {
  glfree(obj6941->class->name);
  obj6941->class->name = "genericNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6941, self, 0);
  addmethodreal(obj6941,"outer", &reader_ast_outer_6942);
  Object oldself6941 = self;
  struct StackFrameObject *oldstackframe6941 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6941);
  gc_frame_newslot((Object)stackframe);
  self = obj6941;
  Object *oldselfslot6941 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6941 = (*(struct UserObject *)self).data[0], lowerouter6941 = thisouter6941;
  if (inheritingObject6941) {
    struct UserObject *inho6941 = (struct UserObject *)inheritingObject6941;
    while (inho6941->super != GraceDefaultObject) inho6941 = (struct UserObject *)inho6941->super;
    inho6941->super = obj6941;
    self = inheritingObject6941;
    *selfslot = self;
    lowerouter6941 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6941;
  }
if (objclass6941 == NULL) {
  Method *reader6943 = addmethodrealflags(obj6941, "kind",&reader_ast_kind_6943, MFLAG_DEF);
  reader6943->definitionModule = modulename;
  reader6943->definitionLine = 1575;
}
adddatum2(obj6941, alloc_Undefined(), 1);
if (objclass6941 == NULL) {
  Method *reader6944 = addmethodrealflags(obj6941, "value",&reader_ast_value_6944, 0);
  Method *writer6944 = addmethodrealflags(obj6941, "value:=",&writer_ast_value_6944, 0);
  reader6944->definitionModule = modulename;
  writer6944->definitionModule = modulename;
  reader6944->definitionLine = 1576;
  writer6944->definitionLine = 1576;
}
obj6941->flags |= OFLAG_MUTABLE;
adddatum2(obj6941, alloc_Undefined(), 2);
if (objclass6941 == NULL) {
  Method *reader6945 = addmethodrealflags(obj6941, "params",&reader_ast_params_6945, 0);
  Method *writer6945 = addmethodrealflags(obj6941, "params:=",&writer_ast_params_6945, 0);
  reader6945->definitionModule = modulename;
  writer6945->definitionModule = modulename;
  reader6945->definitionLine = 1578;
  writer6945->definitionLine = 1578;
}
obj6941->flags |= OFLAG_MUTABLE;
adddatum2(obj6941, alloc_Undefined(), 3);
// method nameString
  struct UserObject *uo6946 = (struct UserObject*)obj6941;
  uo6946->data[4] = emptyclosure;
  Method *meth_meth_ast_nameString6946 = addmethod2pos(obj6941, "nameString", &meth_ast_nameString6946, 4);
  int argcv_meth_ast_nameString6946[] = {0};
  meth_meth_ast_nameString6946->type = alloc_MethodType(1, argcv_meth_ast_nameString6946);
  meth_meth_ast_nameString6946->definitionModule = modulename;
  meth_meth_ast_nameString6946->definitionLine = 1579;
// method asString
  block_savedest(obj6941);
  Object closure6951 = createclosure(1, "asString");
  setclosureframe(closure6951, stackframe);
  addtoclosure(closure6951, var_base);
  struct UserObject *uo6951 = (struct UserObject*)obj6941;
  uo6951->data[5] = (Object)closure6951;
  Method *meth_meth_ast_asString6951 = addmethod2pos(obj6941, "asString", &meth_ast_asString6951, 5);
  int argcv_meth_ast_asString6951[] = {0};
  meth_meth_ast_asString6951->type = alloc_MethodType(1, argcv_meth_ast_asString6951);
  meth_meth_ast_asString6951->definitionModule = modulename;
  meth_meth_ast_asString6951->definitionLine = 1580;
// method accept()from
  struct UserObject *uo6995 = (struct UserObject*)obj6941;
  uo6995->data[6] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from6995 = addmethod2pos(obj6941, "accept()from", &meth_ast_accept_40__41_from6995, 6);
  int argcv_meth_ast_accept_40__41_from6995[] = {1, 1};
  meth_meth_ast_accept_40__41_from6995->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from6995);
  meth_meth_ast_accept_40__41_from6995->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from6995->definitionLine = 1585;
// method map()ancestors
  struct UserObject *uo7014 = (struct UserObject*)obj6941;
  uo7014->data[7] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors7014 = addmethod2pos(obj6941, "map()ancestors", &meth_ast_map_40__41_ancestors7014, 7);
  int argcv_meth_ast_map_40__41_ancestors7014[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors7014->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors7014);
  meth_meth_ast_map_40__41_ancestors7014->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors7014->definitionLine = 1594;
// method pretty
  struct UserObject *uo7037 = (struct UserObject*)obj6941;
  uo7037->data[8] = emptyclosure;
  Method *meth_meth_ast_pretty7037 = addmethod2pos(obj6941, "pretty", &meth_ast_pretty7037, 8);
  int argcv_meth_ast_pretty7037[] = {1};
  meth_meth_ast_pretty7037->type = alloc_MethodType(1, argcv_meth_ast_pretty7037);
  meth_meth_ast_pretty7037->definitionModule = modulename;
  meth_meth_ast_pretty7037->definitionLine = 1601;
// method toGrace
  struct UserObject *uo7099 = (struct UserObject*)obj6941;
  uo7099->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace7099 = addmethod2pos(obj6941, "toGrace", &meth_ast_toGrace7099, 9);
  int argcv_meth_ast_toGrace7099[] = {1};
  meth_meth_ast_toGrace7099->type = alloc_MethodType(1, argcv_meth_ast_toGrace7099);
meth_meth_ast_toGrace7099->type->types[0] = type_Number;
meth_meth_ast_toGrace7099->type->names[0] = "depth";
  meth_meth_ast_toGrace7099->definitionModule = modulename;
  meth_meth_ast_toGrace7099->definitionLine = 1613;
// method shallowCopy
  block_savedest(obj6941);
  Object closure7145 = createclosure(2, "shallowCopy");
  setclosureframe(closure7145, stackframe);
  addtoclosure(closure7145, var_emptySeq);
  addtoclosure(closure7145, var_genericNode);
  struct UserObject *uo7145 = (struct UserObject*)obj6941;
  uo7145->data[10] = (Object)closure7145;
  Method *meth_meth_ast_shallowCopy7145 = addmethod2pos(obj6941, "shallowCopy", &meth_ast_shallowCopy7145, 10);
  int argcv_meth_ast_shallowCopy7145[] = {0};
  meth_meth_ast_shallowCopy7145->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy7145);
  meth_meth_ast_shallowCopy7145->definitionModule = modulename;
  meth_meth_ast_shallowCopy7145->definitionLine = 1624;
  sourceObject = obj6941;
// Begin line 1574
  setline(1574);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7152 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7153 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7152);
// compiled call node returning call7153 (depth = 4)
  struct UserObject *obj6941_uo = (struct UserObject *)obj6941;
  obj6941_uo->super = call7153;
  sourceObject = obj6941;
// Begin line 1575
  setline(1575);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit7154 == NULL) {
    strlit7154 = alloc_String("generic");
    gc_root(strlit7154);
  }
// compiled string node returning strlit7154 (depth = 4)
  adddatum2(obj6941, strlit7154, 1);
  sourceObject = obj6941;
// Begin line 1576
  setline(1576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_base (depth = 4)
  adddatum2(obj6941, *var_base, 2);
  sourceObject = obj6941;
// Begin line 1578
  setline(1578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_params_39_ (depth = 4)
  adddatum2(obj6941, *var_params_39_, 3);
  sourceObject = obj6941;
  sourceObject = obj6941;
  sourceObject = obj6941;
  sourceObject = obj6941;
  sourceObject = obj6941;
  sourceObject = obj6941;
  sourceObject = obj6941;
  objclass6941 = obj6941->class;
  objclass6941->definitionModule = modulename;
  objclass6941->definitionLine = 1573;
  (*(struct UserObject *)self).data[0] = lowerouter6941;
  self = oldself6941;
  selfslot = oldselfslot6941;
  stackframe = oldstackframe6941;
  gc_frame_end(frame);
  return obj6941;
}
Object meth_ast_typeParametersNode7156(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 31, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeParametersNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_typeParametersNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for typeParametersNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for typeParametersNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_typeParametersNode (depth = 3)
  gc_frame_end(frame);
  return *var_typeParametersNode;
}
Object meth_ast__apply7168(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit7170 == NULL) {
    strlit7170 = alloc_String("");
    gc_root(strlit7170);
  }
// compiled string node returning strlit7170 (depth = 8)
  int op_slot_right_7169 = gc_frame_newslot(strlit7170);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_each (depth = 9)
  int op_slot_right_7172 = gc_frame_newslot(*var_each);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit7175 == NULL) {
    strlit7175 = alloc_String("");
    gc_root(strlit7175);
  }
// compiled string node returning strlit7175 (depth = 10)
  int op_slot_right_7174 = gc_frame_newslot(strlit7175);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_right_7177 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 11)
  if (strlit7179 == NULL) {
    strlit7179 = alloc_String("");
    gc_root(strlit7179);
  }
// compiled string node returning strlit7179 (depth = 11)
  int op_slot_left_7177 = gc_frame_newslot(strlit7179);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult7180 = callmethod(strlit7179, "++", 1, partcv, params);
// compiled op node returning opresult7180 (depth = 10)
  int op_slot_left_7174 = gc_frame_newslot(opresult7180);
  params[0] = strlit7175;
  partcv[0] = 1;
  Object opresult7181 = callmethod(opresult7180, "++", 1, partcv, params);
// compiled op node returning opresult7181 (depth = 9)
  int op_slot_left_7172 = gc_frame_newslot(opresult7181);
  params[0] = *var_each;
  partcv[0] = 1;
  Object opresult7182 = callmethod(opresult7181, "++", 1, partcv, params);
// compiled op node returning opresult7182 (depth = 8)
  int op_slot_left_7169 = gc_frame_newslot(opresult7182);
  params[0] = strlit7170;
  partcv[0] = 1;
  Object opresult7183 = callmethod(opresult7182, "++", 1, partcv, params);
// compiled op node returning opresult7183 (depth = 7)
  *var_s = opresult7183;
  if (opresult7183 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply7187(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit7189 == NULL) {
    strlit7189 = alloc_String(", ");
    gc_root(strlit7189);
  }
// compiled string node returning strlit7189 (depth = 8)
  int op_slot_right_7188 = gc_frame_newslot(strlit7189);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_7188 = gc_frame_newslot(*var_s);
  params[0] = strlit7189;
  partcv[0] = 1;
  Object opresult7191 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7191 (depth = 7)
  *var_s = opresult7191;
  if (opresult7191 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_asString7164(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
// Begin line 1634
  setline(1634);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7165 == NULL) {
    strlit7165 = alloc_String("typeparams <");
    gc_root(strlit7165);
  }
// compiled string node returning strlit7165 (depth = 5)
  *var_s = strlit7165;
  if (strlit7165 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1635
  setline(1635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7166 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block7167 = alloc_Block(NULL, NULL, "ast", 1635);
  gc_frame_newslot(block7167);
// method _apply
  block_savedest(block7167);
  Object closure7168 = createclosure(2, "_apply");
  setclosureframe(closure7168, stackframe);
  addtoclosure(closure7168, var_s);
  addtoclosure(closure7168, selfslot);
  struct UserObject *uo7168 = (struct UserObject*)block7167;
  uo7168->data[0] = (Object)closure7168;
  Method *meth_meth_ast__apply7168 = addmethod2pos(block7167, "_apply", &meth_ast__apply7168, 0);
  int argcv_meth_ast__apply7168[] = {1};
  meth_meth_ast__apply7168->type = alloc_MethodType(1, argcv_meth_ast__apply7168);
  meth_meth_ast__apply7168->definitionModule = modulename;
  meth_meth_ast__apply7168->definitionLine = 1629;
// compiled block node returning block7167 (depth = 5)
  gc_frame_newslot(block7167);
// starting to compile block node (depth = 5)
  Object block7186 = alloc_Block(NULL, NULL, "ast", 1635);
  gc_frame_newslot(block7186);
// method _apply
  block_savedest(block7186);
  Object closure7187 = createclosure(2, "_apply");
  setclosureframe(closure7187, stackframe);
  addtoclosure(closure7187, var_s);
  addtoclosure(closure7187, selfslot);
  struct UserObject *uo7187 = (struct UserObject*)block7186;
  uo7187->data[0] = (Object)closure7187;
  Method *meth_meth_ast__apply7187 = addmethod2pos(block7186, "_apply", &meth_ast__apply7187, 0);
  int argcv_meth_ast__apply7187[] = {0};
  meth_meth_ast__apply7187->type = alloc_MethodType(1, argcv_meth_ast__apply7187);
  meth_meth_ast__apply7187->definitionModule = modulename;
  meth_meth_ast__apply7187->definitionLine = 1629;
// compiled block node returning block7186 (depth = 5)
  gc_frame_newslot(block7186);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7194 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7195 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7194);
// compiled call node returning call7195 (depth = 6)
// compiled member node returning call7195 (depth = 5)
  params[0] = block7167;
  params[1] = block7186;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7196 = callmethod(call7195, "do()separatedBy",
    2, partcv, params);
  gc_frame_end(callframe7166);
// compiled call node returning call7196 (depth = 4)
// Begin line 1636
  setline(1636);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7198 == NULL) {
    strlit7198 = alloc_String(">");
    gc_root(strlit7198);
  }
// compiled string node returning strlit7198 (depth = 5)
  int op_slot_right_7197 = gc_frame_newslot(strlit7198);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_7197 = gc_frame_newslot(*var_s);
  params[0] = strlit7198;
  partcv[0] = 1;
  Object opresult7200 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7200 (depth = 4)
  gc_frame_end(frame);
  return opresult7200;
}
Object meth_ast_declarationKindWithAncestors7201(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "declarationKindWithAncestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method declarationKindWithAncestors");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for declarationKindWithAncestors (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for declarationKindWithAncestors");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1639
  setline(1639);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit7202 == NULL) {
    strlit7202 = alloc_String("typeparam");
    gc_root(strlit7202);
  }
// compiled string node returning strlit7202 (depth = 4)
  gc_frame_end(frame);
  return strlit7202;
}
Object meth_ast__apply7211(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1645
  setline(1645);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe7212 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_visitor (depth = 8)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_newChain (depth = 8)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_p (depth = 8)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7213 = callmethod(*var_p, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe7212);
// compiled call node returning call7213 (depth = 7)
  gc_frame_end(frame);
  return call7213;
}
Object meth_ast_accept_40__41_from7203(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1642
  setline(1642);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7205 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7206 = callmethod(*var_visitor, "visitTypeParameters()up",
    2, partcv, params);
  gc_frame_end(callframe7205);
// compiled call node returning call7206 (depth = 5)
  Object if7204 = done;
  if (istrue(call7206)) {
// Begin line 1643
  setline(1643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7207 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_as (depth = 7)
  params[0] = self;
  partcv[0] = 1;
  Object call7208 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe7207);
// compiled call node returning call7208 (depth = 6)
  *var_newChain = call7208;
  if (call7208 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 1644
  setline(1644);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7209 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block7210 = alloc_Block(NULL, NULL, "ast", 1644);
  gc_frame_newslot(block7210);
// method _apply
  block_savedest(block7210);
  Object closure7211 = createclosure(3, "_apply");
  setclosureframe(closure7211, stackframe);
  addtoclosure(closure7211, var_visitor);
  addtoclosure(closure7211, var_newChain);
  addtoclosure(closure7211, selfslot);
  struct UserObject *uo7211 = (struct UserObject*)block7210;
  uo7211->data[0] = (Object)closure7211;
  Method *meth_meth_ast__apply7211 = addmethod2pos(block7210, "_apply", &meth_ast__apply7211, 0);
  int argcv_meth_ast__apply7211[] = {1};
  meth_meth_ast__apply7211->type = alloc_MethodType(1, argcv_meth_ast__apply7211);
  meth_meth_ast__apply7211->definitionModule = modulename;
  meth_meth_ast__apply7211->definitionLine = 1635;
// compiled block node returning block7210 (depth = 6)
  gc_frame_newslot(block7210);
// call case 6: other member request
// Begin line 1644
  setline(1644);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7215 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7216 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7215);
// compiled call node returning call7216 (depth = 7)
// compiled member node returning call7216 (depth = 6)
  params[0] = block7210;
  partcv[0] = 1;
  Object call7217 = callmethod(call7216, "do",
    1, partcv, params);
  gc_frame_end(callframe7209);
// compiled call node returning call7217 (depth = 5)
    gc_frame_newslot(call7217);
    if7204 = call7217;
  } else {
  }
// compiled if node returning if7204 (depth = 4)
  gc_frame_end(frame);
  return if7204;
}
Object meth_ast_do7218(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method do");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for do (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for do");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1650
  setline(1650);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7219 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7220 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7221 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7220);
// compiled call node returning call7221 (depth = 6)
// compiled member node returning call7221 (depth = 5)
  params[0] = *var_blk;
  partcv[0] = 1;
  Object call7222 = callmethod(call7221, "do",
    1, partcv, params);
  gc_frame_end(callframe7219);
// compiled call node returning call7222 (depth = 4)
  gc_frame_end(frame);
  return call7222;
}
Object meth_ast_size7223(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "size");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for size (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for size");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1652
  setline(1652);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7224 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7225 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7226 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7225);
// compiled call node returning call7226 (depth = 7)
// compiled member node returning call7226 (depth = 6)
  partcv[0] = 0;
  Object call7227 = callmethod(call7226, "size",
    1, partcv, params);
  gc_frame_end(callframe7224);
// compiled call node returning call7227 (depth = 5)
// compiled member node returning call7227 (depth = 4)
  gc_frame_end(frame);
  return call7227;
}
Object meth_ast_map_40__41_ancestors7228(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1654
  setline(1654);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7229 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7230 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7229);
// compiled call node returning call7230 (depth = 6)
// compiled member node returning call7230 (depth = 5)
  *var_n = call7230;
  if (call7230 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1655
  setline(1655);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7231 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7232 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe7231);
// compiled call node returning call7232 (depth = 5)
  *var_newChain = call7232;
  if (call7232 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1656
  setline(1656);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1654
  setline(1654);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7233 = gc_frame_new();
// Begin line 1656
  setline(1656);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7234 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7235 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7236 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7235);
// compiled call node returning call7236 (depth = 8)
// compiled member node returning call7236 (depth = 7)
  gc_frame_newslot(call7236);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7237 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7238 = gc_frame_new();
// call case 3: self.outer request
  Object call7239 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7238);
// compiled call node returning call7239 (depth = 10)
// compiled member node returning call7239 (depth = 9)
  partcv[0] = 0;
  Object call7240 = callmethodflags(call7239, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7237);
// compiled call node returning call7240 (depth = 8)
// compiled member node returning call7240 (depth = 7)
  params[0] = call7236;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call7241 = callmethodflags(call7240, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7234);
// compiled call node returning call7241 (depth = 6)
  gc_frame_newslot(call7241);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call7241;
  partcv[0] = 1;
  Object call7242 = callmethod(*var_n, "params:=",
    1, partcv, params);
  gc_frame_end(callframe7233);
// compiled call node returning call7242 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1657
  setline(1657);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7243 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call7244 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe7243);
// compiled call node returning call7244 (depth = 4)
  gc_frame_end(frame);
  return call7244;
}
Object meth_ast__apply7253(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1662
  setline(1662);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit7255 == NULL) {
    strlit7255 = alloc_String("  ");
    gc_root(strlit7255);
  }
// compiled string node returning strlit7255 (depth = 8)
  int op_slot_right_7254 = gc_frame_newslot(strlit7255);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_7254 = gc_frame_newslot(*var_spc);
  params[0] = strlit7255;
  partcv[0] = 1;
  Object opresult7257 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult7257 (depth = 7)
  *var_spc = opresult7257;
  if (opresult7257 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty7245(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
// Begin line 1660
  setline(1660);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7246 == NULL) {
    strlit7246 = alloc_String("");
    gc_root(strlit7246);
  }
// compiled string node returning strlit7246 (depth = 5)
  *var_spc = strlit7246;
  if (strlit7246 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1661
  setline(1661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7247 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_right_7248 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 6)
  Object num7250 = alloc_Float64(0);
// compiled num node returning num7250 (depth = 6)
  int op_slot_left_7248 = gc_frame_newslot(num7250);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult7251 = callmethod(num7250, "..", 1, partcv, params);
// compiled op node returning opresult7251 (depth = 5)
  gc_frame_newslot(opresult7251);
// starting to compile block node (depth = 5)
  Object block7252 = alloc_Block(NULL, NULL, "ast", 1661);
  gc_frame_newslot(block7252);
// method _apply
  block_savedest(block7252);
  Object closure7253 = createclosure(2, "_apply");
  setclosureframe(closure7253, stackframe);
  addtoclosure(closure7253, var_spc);
  addtoclosure(closure7253, selfslot);
  struct UserObject *uo7253 = (struct UserObject*)block7252;
  uo7253->data[0] = (Object)closure7253;
  Method *meth_meth_ast__apply7253 = addmethod2pos(block7252, "_apply", &meth_ast__apply7253, 0);
  int argcv_meth_ast__apply7253[] = {1};
  meth_meth_ast__apply7253->type = alloc_MethodType(1, argcv_meth_ast__apply7253);
  meth_meth_ast__apply7253->definitionModule = modulename;
  meth_meth_ast__apply7253->definitionLine = 1656;
// compiled block node returning block7252 (depth = 5)
  gc_frame_newslot(block7252);
// call case 5: prelude request
  params[0] = opresult7251;
  params[1] = block7252;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7260 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7247);
// compiled call node returning call7260 (depth = 4)
// Begin line 1664
  setline(1664);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7262 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7263 = callmethodflags(self, "asString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7262);
// compiled call node returning call7263 (depth = 6)
// compiled member node returning call7263 (depth = 5)
  int op_slot_right_7261 = gc_frame_newslot(call7263);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7266 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call7267 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe7266);
// compiled call node returning call7267 (depth = 6)
  int op_slot_right_7265 = gc_frame_newslot(call7267);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_left_7265 = gc_frame_newslot(*var_spc);
  params[0] = call7267;
  partcv[0] = 1;
  Object opresult7269 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult7269 (depth = 5)
  int op_slot_left_7261 = gc_frame_newslot(opresult7269);
  params[0] = call7263;
  partcv[0] = 1;
  Object opresult7270 = callmethod(opresult7269, "++", 1, partcv, params);
// compiled op node returning opresult7270 (depth = 4)
  gc_frame_end(frame);
  return opresult7270;
}
Object meth_ast_toGrace7271(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1667
  setline(1667);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7272 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7273 = callmethodflags(self, "asString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7272);
// compiled call node returning call7273 (depth = 5)
// compiled member node returning call7273 (depth = 4)
  gc_frame_end(frame);
  return call7273;
}
Object meth_ast_shallowCopy7274(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_typeParametersNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1670
  setline(1670);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7275 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe7276 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_emptySeq (depth = 6)
  gc_frame_newslot(*var_emptySeq);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_typeParametersNode (depth = 6)
  params[0] = *var_emptySeq;
  partcv[0] = 1;
  Object call7277 = callmethod(*var_typeParametersNode, "new",
    1, partcv, params);
  gc_frame_end(callframe7276);
// compiled call node returning call7277 (depth = 5)
  params[0] = self;
  partcv[0] = 1;
  Object call7278 = callmethod(call7277, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe7275);
// compiled call node returning call7278 (depth = 4)
  gc_frame_end(frame);
  return call7278;
}
Object meth_ast_new7159(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_typeParametersNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_params_39_ = &(stackframe->slots[0]);
  *var_params_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7160 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7160 = alloc_userobj2(13,13, objclass7160);
  gc_frame_newslot(obj7160);
if (objclass7160 == NULL) {
  glfree(obj7160->class->name);
  obj7160->class->name = "typeParametersNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7160, self, 0);
  addmethodreal(obj7160,"outer", &reader_ast_outer_7161);
  Object oldself7160 = self;
  struct StackFrameObject *oldstackframe7160 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7160);
  gc_frame_newslot((Object)stackframe);
  self = obj7160;
  Object *oldselfslot7160 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7160 = (*(struct UserObject *)self).data[0], lowerouter7160 = thisouter7160;
  if (inheritingObject7160) {
    struct UserObject *inho7160 = (struct UserObject *)inheritingObject7160;
    while (inho7160->super != GraceDefaultObject) inho7160 = (struct UserObject *)inho7160->super;
    inho7160->super = obj7160;
    self = inheritingObject7160;
    *selfslot = self;
    lowerouter7160 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7160;
  }
if (objclass7160 == NULL) {
  Method *reader7162 = addmethodrealflags(obj7160, "kind",&reader_ast_kind_7162, MFLAG_DEF);
  reader7162->definitionModule = modulename;
  reader7162->definitionLine = 1631;
}
adddatum2(obj7160, alloc_Undefined(), 1);
if (objclass7160 == NULL) {
  Method *reader7163 = addmethodrealflags(obj7160, "params",&reader_ast_params_7163, 0);
  Method *writer7163 = addmethodrealflags(obj7160, "params:=",&writer_ast_params_7163, 0);
  reader7163->definitionModule = modulename;
  writer7163->definitionModule = modulename;
  reader7163->definitionLine = 1632;
  writer7163->definitionLine = 1632;
}
obj7160->flags |= OFLAG_MUTABLE;
adddatum2(obj7160, alloc_Undefined(), 2);
// method asString
  struct UserObject *uo7164 = (struct UserObject*)obj7160;
  uo7164->data[3] = emptyclosure;
  Method *meth_meth_ast_asString7164 = addmethod2pos(obj7160, "asString", &meth_ast_asString7164, 3);
  int argcv_meth_ast_asString7164[] = {0};
  meth_meth_ast_asString7164->type = alloc_MethodType(1, argcv_meth_ast_asString7164);
  meth_meth_ast_asString7164->definitionModule = modulename;
  meth_meth_ast_asString7164->definitionLine = 1633;
// method declarationKindWithAncestors
  struct UserObject *uo7201 = (struct UserObject*)obj7160;
  uo7201->data[4] = emptyclosure;
  Method *meth_meth_ast_declarationKindWithAncestors7201 = addmethod2pos(obj7160, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors7201, 4);
  int argcv_meth_ast_declarationKindWithAncestors7201[] = {1};
  meth_meth_ast_declarationKindWithAncestors7201->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors7201);
  meth_meth_ast_declarationKindWithAncestors7201->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors7201->definitionLine = 1638;
// method accept()from
  struct UserObject *uo7203 = (struct UserObject*)obj7160;
  uo7203->data[5] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from7203 = addmethod2pos(obj7160, "accept()from", &meth_ast_accept_40__41_from7203, 5);
  int argcv_meth_ast_accept_40__41_from7203[] = {1, 1};
  meth_meth_ast_accept_40__41_from7203->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from7203);
  meth_meth_ast_accept_40__41_from7203->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from7203->definitionLine = 1641;
// method do
  struct UserObject *uo7218 = (struct UserObject*)obj7160;
  uo7218->data[6] = emptyclosure;
  Method *meth_meth_ast_do7218 = addmethod2pos(obj7160, "do", &meth_ast_do7218, 6);
  int argcv_meth_ast_do7218[] = {1};
  meth_meth_ast_do7218->type = alloc_MethodType(1, argcv_meth_ast_do7218);
  meth_meth_ast_do7218->definitionModule = modulename;
  meth_meth_ast_do7218->definitionLine = 1649;
// method size
  struct UserObject *uo7223 = (struct UserObject*)obj7160;
  uo7223->data[7] = emptyclosure;
  Method *meth_meth_ast_size7223 = addmethod2pos(obj7160, "size", &meth_ast_size7223, 7);
  int argcv_meth_ast_size7223[] = {0};
  meth_meth_ast_size7223->type = alloc_MethodType(1, argcv_meth_ast_size7223);
  meth_meth_ast_size7223->definitionModule = modulename;
  meth_meth_ast_size7223->definitionLine = 1652;
// method map()ancestors
  struct UserObject *uo7228 = (struct UserObject*)obj7160;
  uo7228->data[8] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors7228 = addmethod2pos(obj7160, "map()ancestors", &meth_ast_map_40__41_ancestors7228, 8);
  int argcv_meth_ast_map_40__41_ancestors7228[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors7228->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors7228);
  meth_meth_ast_map_40__41_ancestors7228->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors7228->definitionLine = 1653;
// method pretty
  struct UserObject *uo7245 = (struct UserObject*)obj7160;
  uo7245->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty7245 = addmethod2pos(obj7160, "pretty", &meth_ast_pretty7245, 9);
  int argcv_meth_ast_pretty7245[] = {1};
  meth_meth_ast_pretty7245->type = alloc_MethodType(1, argcv_meth_ast_pretty7245);
  meth_meth_ast_pretty7245->definitionModule = modulename;
  meth_meth_ast_pretty7245->definitionLine = 1659;
// method toGrace
  struct UserObject *uo7271 = (struct UserObject*)obj7160;
  uo7271->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace7271 = addmethod2pos(obj7160, "toGrace", &meth_ast_toGrace7271, 10);
  int argcv_meth_ast_toGrace7271[] = {1};
  meth_meth_ast_toGrace7271->type = alloc_MethodType(1, argcv_meth_ast_toGrace7271);
meth_meth_ast_toGrace7271->type->types[0] = type_Number;
meth_meth_ast_toGrace7271->type->names[0] = "depth";
  meth_meth_ast_toGrace7271->definitionModule = modulename;
  meth_meth_ast_toGrace7271->definitionLine = 1666;
// method shallowCopy
  block_savedest(obj7160);
  Object closure7274 = createclosure(2, "shallowCopy");
  setclosureframe(closure7274, stackframe);
  addtoclosure(closure7274, var_emptySeq);
  addtoclosure(closure7274, var_typeParametersNode);
  struct UserObject *uo7274 = (struct UserObject*)obj7160;
  uo7274->data[11] = (Object)closure7274;
  Method *meth_meth_ast_shallowCopy7274 = addmethod2pos(obj7160, "shallowCopy", &meth_ast_shallowCopy7274, 11);
  int argcv_meth_ast_shallowCopy7274[] = {0};
  meth_meth_ast_shallowCopy7274->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy7274);
  meth_meth_ast_shallowCopy7274->definitionModule = modulename;
  meth_meth_ast_shallowCopy7274->definitionLine = 1669;
  sourceObject = obj7160;
// Begin line 1630
  setline(1630);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7279 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7280 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7279);
// compiled call node returning call7280 (depth = 4)
  struct UserObject *obj7160_uo = (struct UserObject *)obj7160;
  obj7160_uo->super = call7280;
  sourceObject = obj7160;
// Begin line 1631
  setline(1631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit7281 == NULL) {
    strlit7281 = alloc_String("typeparams");
    gc_root(strlit7281);
  }
// compiled string node returning strlit7281 (depth = 4)
  adddatum2(obj7160, strlit7281, 1);
  sourceObject = obj7160;
// Begin line 1632
  setline(1632);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_params_39_ (depth = 4)
  adddatum2(obj7160, *var_params_39_, 2);
  sourceObject = obj7160;
  sourceObject = obj7160;
  sourceObject = obj7160;
  sourceObject = obj7160;
  sourceObject = obj7160;
  sourceObject = obj7160;
  sourceObject = obj7160;
  sourceObject = obj7160;
  sourceObject = obj7160;
  objclass7160 = obj7160->class;
  objclass7160->definitionModule = modulename;
  objclass7160->definitionLine = 1629;
  (*(struct UserObject *)self).data[0] = lowerouter7160;
  self = oldself7160;
  selfslot = oldselfslot7160;
  stackframe = oldstackframe7160;
  gc_frame_end(frame);
  return obj7160;
}
Object meth_ast_new7159_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_typeParametersNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_params_39_ = &(stackframe->slots[0]);
  *var_params_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7160 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7160 = alloc_userobj2(13,13, objclass7160);
  gc_frame_newslot(obj7160);
if (objclass7160 == NULL) {
  glfree(obj7160->class->name);
  obj7160->class->name = "typeParametersNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7160, self, 0);
  addmethodreal(obj7160,"outer", &reader_ast_outer_7161);
  Object oldself7160 = self;
  struct StackFrameObject *oldstackframe7160 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7160);
  gc_frame_newslot((Object)stackframe);
  self = obj7160;
  Object *oldselfslot7160 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7160 = (*(struct UserObject *)self).data[0], lowerouter7160 = thisouter7160;
  if (inheritingObject7160) {
    struct UserObject *inho7160 = (struct UserObject *)inheritingObject7160;
    while (inho7160->super != GraceDefaultObject) inho7160 = (struct UserObject *)inho7160->super;
    inho7160->super = obj7160;
    self = inheritingObject7160;
    *selfslot = self;
    lowerouter7160 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7160;
  }
if (objclass7160 == NULL) {
  Method *reader7162 = addmethodrealflags(obj7160, "kind",&reader_ast_kind_7162, MFLAG_DEF);
  reader7162->definitionModule = modulename;
  reader7162->definitionLine = 1631;
}
adddatum2(obj7160, alloc_Undefined(), 1);
if (objclass7160 == NULL) {
  Method *reader7163 = addmethodrealflags(obj7160, "params",&reader_ast_params_7163, 0);
  Method *writer7163 = addmethodrealflags(obj7160, "params:=",&writer_ast_params_7163, 0);
  reader7163->definitionModule = modulename;
  writer7163->definitionModule = modulename;
  reader7163->definitionLine = 1632;
  writer7163->definitionLine = 1632;
}
obj7160->flags |= OFLAG_MUTABLE;
adddatum2(obj7160, alloc_Undefined(), 2);
// method asString
  struct UserObject *uo7164 = (struct UserObject*)obj7160;
  uo7164->data[3] = emptyclosure;
  Method *meth_meth_ast_asString7164 = addmethod2pos(obj7160, "asString", &meth_ast_asString7164, 3);
  int argcv_meth_ast_asString7164[] = {0};
  meth_meth_ast_asString7164->type = alloc_MethodType(1, argcv_meth_ast_asString7164);
  meth_meth_ast_asString7164->definitionModule = modulename;
  meth_meth_ast_asString7164->definitionLine = 1633;
// method declarationKindWithAncestors
  struct UserObject *uo7201 = (struct UserObject*)obj7160;
  uo7201->data[4] = emptyclosure;
  Method *meth_meth_ast_declarationKindWithAncestors7201 = addmethod2pos(obj7160, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors7201, 4);
  int argcv_meth_ast_declarationKindWithAncestors7201[] = {1};
  meth_meth_ast_declarationKindWithAncestors7201->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors7201);
  meth_meth_ast_declarationKindWithAncestors7201->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors7201->definitionLine = 1638;
// method accept()from
  struct UserObject *uo7203 = (struct UserObject*)obj7160;
  uo7203->data[5] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from7203 = addmethod2pos(obj7160, "accept()from", &meth_ast_accept_40__41_from7203, 5);
  int argcv_meth_ast_accept_40__41_from7203[] = {1, 1};
  meth_meth_ast_accept_40__41_from7203->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from7203);
  meth_meth_ast_accept_40__41_from7203->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from7203->definitionLine = 1641;
// method do
  struct UserObject *uo7218 = (struct UserObject*)obj7160;
  uo7218->data[6] = emptyclosure;
  Method *meth_meth_ast_do7218 = addmethod2pos(obj7160, "do", &meth_ast_do7218, 6);
  int argcv_meth_ast_do7218[] = {1};
  meth_meth_ast_do7218->type = alloc_MethodType(1, argcv_meth_ast_do7218);
  meth_meth_ast_do7218->definitionModule = modulename;
  meth_meth_ast_do7218->definitionLine = 1649;
// method size
  struct UserObject *uo7223 = (struct UserObject*)obj7160;
  uo7223->data[7] = emptyclosure;
  Method *meth_meth_ast_size7223 = addmethod2pos(obj7160, "size", &meth_ast_size7223, 7);
  int argcv_meth_ast_size7223[] = {0};
  meth_meth_ast_size7223->type = alloc_MethodType(1, argcv_meth_ast_size7223);
  meth_meth_ast_size7223->definitionModule = modulename;
  meth_meth_ast_size7223->definitionLine = 1652;
// method map()ancestors
  struct UserObject *uo7228 = (struct UserObject*)obj7160;
  uo7228->data[8] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors7228 = addmethod2pos(obj7160, "map()ancestors", &meth_ast_map_40__41_ancestors7228, 8);
  int argcv_meth_ast_map_40__41_ancestors7228[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors7228->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors7228);
  meth_meth_ast_map_40__41_ancestors7228->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors7228->definitionLine = 1653;
// method pretty
  struct UserObject *uo7245 = (struct UserObject*)obj7160;
  uo7245->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty7245 = addmethod2pos(obj7160, "pretty", &meth_ast_pretty7245, 9);
  int argcv_meth_ast_pretty7245[] = {1};
  meth_meth_ast_pretty7245->type = alloc_MethodType(1, argcv_meth_ast_pretty7245);
  meth_meth_ast_pretty7245->definitionModule = modulename;
  meth_meth_ast_pretty7245->definitionLine = 1659;
// method toGrace
  struct UserObject *uo7271 = (struct UserObject*)obj7160;
  uo7271->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace7271 = addmethod2pos(obj7160, "toGrace", &meth_ast_toGrace7271, 10);
  int argcv_meth_ast_toGrace7271[] = {1};
  meth_meth_ast_toGrace7271->type = alloc_MethodType(1, argcv_meth_ast_toGrace7271);
meth_meth_ast_toGrace7271->type->types[0] = type_Number;
meth_meth_ast_toGrace7271->type->names[0] = "depth";
  meth_meth_ast_toGrace7271->definitionModule = modulename;
  meth_meth_ast_toGrace7271->definitionLine = 1666;
// method shallowCopy
  block_savedest(obj7160);
  Object closure7274 = createclosure(2, "shallowCopy");
  setclosureframe(closure7274, stackframe);
  addtoclosure(closure7274, var_emptySeq);
  addtoclosure(closure7274, var_typeParametersNode);
  struct UserObject *uo7274 = (struct UserObject*)obj7160;
  uo7274->data[11] = (Object)closure7274;
  Method *meth_meth_ast_shallowCopy7274 = addmethod2pos(obj7160, "shallowCopy", &meth_ast_shallowCopy7274, 11);
  int argcv_meth_ast_shallowCopy7274[] = {0};
  meth_meth_ast_shallowCopy7274->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy7274);
  meth_meth_ast_shallowCopy7274->definitionModule = modulename;
  meth_meth_ast_shallowCopy7274->definitionLine = 1669;
  sourceObject = obj7160;
// Begin line 1630
  setline(1630);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7279 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7280 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7279);
// compiled call node returning call7280 (depth = 4)
  struct UserObject *obj7160_uo = (struct UserObject *)obj7160;
  obj7160_uo->super = call7280;
  sourceObject = obj7160;
// Begin line 1631
  setline(1631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit7281 == NULL) {
    strlit7281 = alloc_String("typeparams");
    gc_root(strlit7281);
  }
// compiled string node returning strlit7281 (depth = 4)
  adddatum2(obj7160, strlit7281, 1);
  sourceObject = obj7160;
// Begin line 1632
  setline(1632);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_params_39_ (depth = 4)
  adddatum2(obj7160, *var_params_39_, 2);
  sourceObject = obj7160;
  sourceObject = obj7160;
  sourceObject = obj7160;
  sourceObject = obj7160;
  sourceObject = obj7160;
  sourceObject = obj7160;
  sourceObject = obj7160;
  sourceObject = obj7160;
  sourceObject = obj7160;
  objclass7160 = obj7160->class;
  objclass7160->definitionModule = modulename;
  objclass7160->definitionLine = 1629;
  (*(struct UserObject *)self).data[0] = lowerouter7160;
  self = oldself7160;
  selfslot = oldselfslot7160;
  stackframe = oldstackframe7160;
  gc_frame_end(frame);
  return obj7160;
}
Object meth_ast_new_40__41_scope7285(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new()scope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method new()scope");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method new()scope");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for new()scope (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_name = &(stackframe->slots[0]);
  *var_name = args[curarg];
  curarg++;
  Object *var_dtype = &(stackframe->slots[1]);
  *var_dtype = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for new");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for scope");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "result");
// Begin line 1676
  setline(1676);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7286 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_name (depth = 5)
  gc_frame_newslot(*var_name);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dtype (depth = 5)
  gc_frame_newslot(*var_dtype);
// call case 4: self request
  params[0] = *var_name;
  params[1] = *var_dtype;
  partcv[0] = 2;
  Object call7287 = callmethodflags(self, "new", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7286);
// compiled call node returning call7287 (depth = 4)
  *var_result = call7287;
  if (call7287 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1677
  setline(1677);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 1667
  setline(1667);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7288 = gc_frame_new();
// Begin line 1677
  setline(1677);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  gc_frame_newslot(*var_s);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call7289 = callmethod(*var_result, "scope:=",
    1, partcv, params);
  gc_frame_end(callframe7288);
// compiled call node returning call7289 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 1678
  setline(1678);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_nameString7302(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for nameString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for nameString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1693
  setline(1693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7303 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7304 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7303);
// compiled call node returning call7304 (depth = 4)
// compiled member node returning call7304 (depth = 3)
  gc_frame_end(frame);
  return call7304;
}
Object meth_ast_isIdentifier7305(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isIdentifier (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isIdentifier");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1695
  setline(1695);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7306 = alloc_Boolean(1);
// compiled identifier node returning bool7306 (depth = 3)
  gc_frame_end(frame);
  return bool7306;
}
Object meth_ast_isAppliedOccurenceOfIdentifier7307(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isAppliedOccurenceOfIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isAppliedOccurenceOfIdentifier (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isAppliedOccurenceOfIdentifier");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1698
  setline(1698);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7309 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7310 = callmethodflags(self, "wildcard", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7309);
// compiled call node returning call7310 (depth = 5)
// compiled member node returning call7310 (depth = 4)
  Object if7308 = done;
  if (istrue(call7310)) {
// Begin line 1699
  setline(1699);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool7311 = alloc_Boolean(0);
// compiled identifier node returning bool7311 (depth = 4)
    gc_frame_newslot(bool7311);
    if7308 = bool7311;
  } else {
// Begin line 1701
  setline(1701);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7312 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7313 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7314 = callmethodflags(self, "isBindingOccurrence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7313);
// compiled call node returning call7314 (depth = 7)
// compiled member node returning call7314 (depth = 6)
  partcv[0] = 0;
  Object call7315 = callmethod(call7314, "not",
    1, partcv, params);
  gc_frame_end(callframe7312);
// compiled call node returning call7315 (depth = 5)
// compiled member node returning call7315 (depth = 4)
    gc_frame_newslot(call7315);
    if7308 = call7315;
  }
// compiled if node returning if7308 (depth = 3)
  gc_frame_end(frame);
  return if7308;
}
Object meth_ast_declarationKindWithAncestors7316(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "declarationKindWithAncestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method declarationKindWithAncestors");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for declarationKindWithAncestors (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for declarationKindWithAncestors");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1705
  setline(1705);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7317 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7318 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  partcv[0] = 0;
  Object call7319 = callmethod(*var_as, "parent",
    1, partcv, params);
  gc_frame_end(callframe7318);
// compiled call node returning call7319 (depth = 5)
// compiled member node returning call7319 (depth = 4)
  params[0] = *var_as;
  partcv[0] = 1;
  Object call7320 = callmethod(call7319, "declarationKindWithAncestors",
    1, partcv, params);
  gc_frame_end(callframe7317);
// compiled call node returning call7320 (depth = 3)
  gc_frame_end(frame);
  return call7320;
}
Object meth_ast_inTypePositionWithAncestors7321(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "inTypePositionWithAncestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method inTypePositionWithAncestors");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for inTypePositionWithAncestors (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for inTypePositionWithAncestors");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1711
  setline(1711);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7323 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  partcv[0] = 0;
  Object call7324 = callmethod(*var_as, "isEmpty",
    1, partcv, params);
  gc_frame_end(callframe7323);
// compiled call node returning call7324 (depth = 5)
// compiled member node returning call7324 (depth = 4)
  Object if7322 = done;
  if (istrue(call7324)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool7325 = alloc_Boolean(0);
// compiled identifier node returning bool7325 (depth = 5)
  return bool7325;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if7322 = undefined;
  } else {
  }
// compiled if node returning if7322 (depth = 3)
// Begin line 1712
  setline(1712);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7326 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7327 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  partcv[0] = 0;
  Object call7328 = callmethod(*var_as, "parent",
    1, partcv, params);
  gc_frame_end(callframe7327);
// compiled call node returning call7328 (depth = 5)
// compiled member node returning call7328 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call7329 = callmethod(call7328, "usesAsType",
    1, partcv, params);
  gc_frame_end(callframe7326);
// compiled call node returning call7329 (depth = 3)
  gc_frame_end(frame);
  return call7329;
}
Object meth_ast_usesAsType7330(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "usesAsType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method usesAsType");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for usesAsType (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aNode = &(stackframe->slots[0]);
  *var_aNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for usesAsType");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1715
  setline(1715);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7332 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7333 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7332);
// compiled call node returning call7333 (depth = 5)
// compiled member node returning call7333 (depth = 4)
  int op_slot_right_7331 = gc_frame_newslot(call7333);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_aNode (depth = 4)
  int op_slot_left_7331 = gc_frame_newslot(*var_aNode);
  params[0] = call7333;
  partcv[0] = 1;
  Object opresult7335 = callmethod(*var_aNode, "==", 1, partcv, params);
// compiled op node returning opresult7335 (depth = 3)
  gc_frame_end(frame);
  return opresult7335;
}
Object meth_ast_accept_40__41_from7336(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1718
  setline(1718);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7338 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7339 = callmethod(*var_visitor, "visitIdentifier()up",
    2, partcv, params);
  gc_frame_end(callframe7338);
// compiled call node returning call7339 (depth = 4)
  Object if7337 = done;
  if (istrue(call7339)) {
// Begin line 1719
  setline(1719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7340 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call7341 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe7340);
// compiled call node returning call7341 (depth = 5)
  *var_newChain = call7341;
  if (call7341 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1720
  setline(1720);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool7344 = alloc_Boolean(0);
// compiled identifier node returning bool7344 (depth = 6)
  int op_slot_right_7343 = gc_frame_newslot(bool7344);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7346 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7347 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7346);
// compiled call node returning call7347 (depth = 7)
// compiled member node returning call7347 (depth = 6)
  int op_slot_left_7343 = gc_frame_newslot(call7347);
  params[0] = bool7344;
  partcv[0] = 1;
  Object opresult7348 = callmethod(call7347, "!=", 1, partcv, params);
// compiled op node returning opresult7348 (depth = 5)
  Object if7342 = done;
  if (istrue(opresult7348)) {
// Begin line 1721
  setline(1721);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7349 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7350 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7351 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7350);
// compiled call node returning call7351 (depth = 7)
// compiled member node returning call7351 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7352 = callmethod(call7351, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe7349);
// compiled call node returning call7352 (depth = 5)
    gc_frame_newslot(call7352);
    if7342 = call7352;
  } else {
  }
// compiled if node returning if7342 (depth = 4)
    gc_frame_newslot(if7342);
    if7337 = if7342;
  } else {
  }
// compiled if node returning if7337 (depth = 3)
  gc_frame_end(frame);
  return if7337;
}
Object meth_ast_map_40__41_ancestors7353(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1726
  setline(1726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7354 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7355 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7354);
// compiled call node returning call7355 (depth = 5)
// compiled member node returning call7355 (depth = 4)
  *var_n = call7355;
  if (call7355 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1727
  setline(1727);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7356 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7357 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe7356);
// compiled call node returning call7357 (depth = 4)
  *var_newChain = call7357;
  if (call7357 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1728
  setline(1728);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 1726
  setline(1726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7358 = gc_frame_new();
// Begin line 1728
  setline(1728);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7359 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7360 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7361 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7360);
// compiled call node returning call7361 (depth = 7)
// compiled member node returning call7361 (depth = 6)
  gc_frame_newslot(call7361);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7362 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7363 = gc_frame_new();
// call case 3: self.outer request
  Object call7364 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7363);
// compiled call node returning call7364 (depth = 9)
// compiled member node returning call7364 (depth = 8)
  partcv[0] = 0;
  Object call7365 = callmethodflags(call7364, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7362);
// compiled call node returning call7365 (depth = 7)
// compiled member node returning call7365 (depth = 6)
  params[0] = call7361;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call7366 = callmethodflags(call7365, "maybeMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7359);
// compiled call node returning call7366 (depth = 5)
  gc_frame_newslot(call7366);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  params[0] = call7366;
  partcv[0] = 1;
  Object call7367 = callmethod(*var_n, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe7358);
// compiled call node returning call7367 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 1729
  setline(1729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7368 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call7369 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe7368);
// compiled call node returning call7369 (depth = 3)
  gc_frame_end(frame);
  return call7369;
}
Object meth_ast__apply7378(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1734
  setline(1734);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7380 == NULL) {
    strlit7380 = alloc_String("  ");
    gc_root(strlit7380);
  }
// compiled string node returning strlit7380 (depth = 7)
  int op_slot_right_7379 = gc_frame_newslot(strlit7380);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_7379 = gc_frame_newslot(*var_spc);
  params[0] = strlit7380;
  partcv[0] = 1;
  Object opresult7382 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult7382 (depth = 6)
  *var_spc = opresult7382;
  if (opresult7382 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply7481(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_g = &(stackframe->slots[0]);
  *var_g = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1751
  setline(1751);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7483 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num7485 = alloc_Float64(2);
// compiled num node returning num7485 (depth = 10)
  int op_slot_right_7484 = gc_frame_newslot(num7485);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_7484 = gc_frame_newslot(*var_depth);
  params[0] = num7485;
  partcv[0] = 1;
  Object sum7487 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum7487 (depth = 9)
  gc_frame_newslot(sum7487);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_g (depth = 9)
  params[0] = sum7487;
  partcv[0] = 1;
  Object call7488 = callmethod(*var_g, "pretty",
    1, partcv, params);
  gc_frame_end(callframe7483);
// compiled call node returning call7488 (depth = 8)
  int op_slot_right_7482 = gc_frame_newslot(call7488);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit7491 == NULL) {
    strlit7491 = alloc_String("  ");
    gc_root(strlit7491);
  }
// compiled string node returning strlit7491 (depth = 9)
  int op_slot_right_7490 = gc_frame_newslot(strlit7491);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_7493 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_7493 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7495 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7495 (depth = 9)
  int op_slot_left_7490 = gc_frame_newslot(opresult7495);
  params[0] = strlit7491;
  partcv[0] = 1;
  Object opresult7496 = callmethod(opresult7495, "++", 1, partcv, params);
// compiled op node returning opresult7496 (depth = 8)
  int op_slot_left_7482 = gc_frame_newslot(opresult7496);
  params[0] = call7488;
  partcv[0] = 1;
  Object opresult7497 = callmethod(opresult7496, "++", 1, partcv, params);
// compiled op node returning opresult7497 (depth = 7)
  *var_s = opresult7497;
  if (opresult7497 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty7370(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1732
  setline(1732);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7371 == NULL) {
    strlit7371 = alloc_String("");
    gc_root(strlit7371);
  }
// compiled string node returning strlit7371 (depth = 4)
  *var_spc = strlit7371;
  if (strlit7371 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1733
  setline(1733);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7372 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_7373 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num7375 = alloc_Float64(0);
// compiled num node returning num7375 (depth = 5)
  int op_slot_left_7373 = gc_frame_newslot(num7375);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult7376 = callmethod(num7375, "..", 1, partcv, params);
// compiled op node returning opresult7376 (depth = 4)
  gc_frame_newslot(opresult7376);
// starting to compile block node (depth = 4)
  Object block7377 = alloc_Block(NULL, NULL, "ast", 1733);
  gc_frame_newslot(block7377);
// method _apply
  block_savedest(block7377);
  Object closure7378 = createclosure(2, "_apply");
  setclosureframe(closure7378, stackframe);
  addtoclosure(closure7378, var_spc);
  addtoclosure(closure7378, selfslot);
  struct UserObject *uo7378 = (struct UserObject*)block7377;
  uo7378->data[0] = (Object)closure7378;
  Method *meth_meth_ast__apply7378 = addmethod2pos(block7377, "_apply", &meth_ast__apply7378, 0);
  int argcv_meth_ast__apply7378[] = {1};
  meth_meth_ast__apply7378->type = alloc_MethodType(1, argcv_meth_ast__apply7378);
  meth_meth_ast__apply7378->definitionModule = modulename;
  meth_meth_ast__apply7378->definitionLine = 1728;
// compiled block node returning block7377 (depth = 4)
  gc_frame_newslot(block7377);
// call case 5: prelude request
  params[0] = opresult7376;
  params[1] = block7377;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7385 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7372);
// compiled call node returning call7385 (depth = 3)
// Begin line 1736
  setline(1736);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7386 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call7387 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe7386);
// compiled call node returning call7387 (depth = 4)
  *var_s = call7387;
  if (call7387 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1737
  setline(1737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7389 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7390 = callmethodflags(self, "wildcard", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7389);
// compiled call node returning call7390 (depth = 5)
// compiled member node returning call7390 (depth = 4)
  Object if7388 = done;
  if (istrue(call7390)) {
// Begin line 1738
  setline(1738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7392 == NULL) {
    strlit7392 = alloc_String(" Wildcard");
    gc_root(strlit7392);
  }
// compiled string node returning strlit7392 (depth = 6)
  int op_slot_right_7391 = gc_frame_newslot(strlit7392);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7391 = gc_frame_newslot(*var_s);
  params[0] = strlit7392;
  partcv[0] = 1;
  Object opresult7394 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7394 (depth = 5)
  *var_s = opresult7394;
  if (opresult7394 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7388 = done;
  } else {
// Begin line 1741
  setline(1741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1739
  setline(1739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7397 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7398 = callmethodflags(self, "isBindingOccurrence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7397);
// compiled call node returning call7398 (depth = 6)
// compiled member node returning call7398 (depth = 5)
  Object if7396 = done;
  if (istrue(call7398)) {
// Begin line 1740
  setline(1740);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit7401 == NULL) {
    strlit7401 = alloc_String("""\xe2""""\x80""""\xba""");
    gc_root(strlit7401);
  }
// compiled string node returning strlit7401 (depth = 8)
  int op_slot_right_7400 = gc_frame_newslot(strlit7401);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7404 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7405 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7404);
// compiled call node returning call7405 (depth = 10)
// compiled member node returning call7405 (depth = 9)
  int op_slot_right_7403 = gc_frame_newslot(call7405);
// starting to compile string node (depth = 9)
  if (strlit7407 == NULL) {
    strlit7407 = alloc_String("Binding""\xe2""""\x80""""\xb9""");
    gc_root(strlit7407);
  }
// compiled string node returning strlit7407 (depth = 9)
  int op_slot_left_7403 = gc_frame_newslot(strlit7407);
  params[0] = call7405;
  partcv[0] = 1;
  Object opresult7408 = callmethod(strlit7407, "++", 1, partcv, params);
// compiled op node returning opresult7408 (depth = 8)
  int op_slot_left_7400 = gc_frame_newslot(opresult7408);
  params[0] = strlit7401;
  partcv[0] = 1;
  Object opresult7409 = callmethod(opresult7408, "++", 1, partcv, params);
// compiled op node returning opresult7409 (depth = 7)
  int op_slot_right_7399 = gc_frame_newslot(opresult7409);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_7399 = gc_frame_newslot(*var_s);
  params[0] = opresult7409;
  partcv[0] = 1;
  Object opresult7411 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7411 (depth = 6)
  *var_s = opresult7411;
  if (opresult7411 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if7396 = done;
  } else {
// Begin line 1742
  setline(1742);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit7415 == NULL) {
    strlit7415 = alloc_String("""\xe2""""\x80""""\xba""");
    gc_root(strlit7415);
  }
// compiled string node returning strlit7415 (depth = 8)
  int op_slot_right_7414 = gc_frame_newslot(strlit7415);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7418 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7419 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7418);
// compiled call node returning call7419 (depth = 10)
// compiled member node returning call7419 (depth = 9)
  int op_slot_right_7417 = gc_frame_newslot(call7419);
// starting to compile string node (depth = 9)
  if (strlit7421 == NULL) {
    strlit7421 = alloc_String("""\xe2""""\x80""""\xb9""");
    gc_root(strlit7421);
  }
// compiled string node returning strlit7421 (depth = 9)
  int op_slot_left_7417 = gc_frame_newslot(strlit7421);
  params[0] = call7419;
  partcv[0] = 1;
  Object opresult7422 = callmethod(strlit7421, "++", 1, partcv, params);
// compiled op node returning opresult7422 (depth = 8)
  int op_slot_left_7414 = gc_frame_newslot(opresult7422);
  params[0] = strlit7415;
  partcv[0] = 1;
  Object opresult7423 = callmethod(opresult7422, "++", 1, partcv, params);
// compiled op node returning opresult7423 (depth = 7)
  int op_slot_right_7413 = gc_frame_newslot(opresult7423);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_7413 = gc_frame_newslot(*var_s);
  params[0] = opresult7423;
  partcv[0] = 1;
  Object opresult7425 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7425 (depth = 6)
  *var_s = opresult7425;
  if (opresult7425 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if7396 = done;
  }
// compiled if node returning if7396 (depth = 4)
    gc_frame_newslot(if7396);
    if7388 = if7396;
  }
// compiled if node returning if7388 (depth = 3)
// Begin line 1744
  setline(1744);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool7429 = alloc_Boolean(0);
// compiled identifier node returning bool7429 (depth = 5)
  int op_slot_right_7428 = gc_frame_newslot(bool7429);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7431 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7432 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7431);
// compiled call node returning call7432 (depth = 6)
// compiled member node returning call7432 (depth = 5)
  int op_slot_left_7428 = gc_frame_newslot(call7432);
  params[0] = bool7429;
  partcv[0] = 1;
  Object opresult7433 = callmethod(call7432, "!=", 1, partcv, params);
// compiled op node returning opresult7433 (depth = 4)
  Object if7427 = done;
  if (istrue(opresult7433)) {
// Begin line 1745
  setline(1745);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7435 == NULL) {
    strlit7435 = alloc_String("  Type: ");
    gc_root(strlit7435);
  }
// compiled string node returning strlit7435 (depth = 6)
  int op_slot_right_7434 = gc_frame_newslot(strlit7435);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_7437 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit7440 == NULL) {
    strlit7440 = alloc_String("""\x0a""");
    gc_root(strlit7440);
  }
// compiled string node returning strlit7440 (depth = 8)
  int op_slot_right_7439 = gc_frame_newslot(strlit7440);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_7439 = gc_frame_newslot(*var_s);
  params[0] = strlit7440;
  partcv[0] = 1;
  Object opresult7442 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7442 (depth = 7)
  int op_slot_left_7437 = gc_frame_newslot(opresult7442);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7443 = callmethod(opresult7442, "++", 1, partcv, params);
// compiled op node returning opresult7443 (depth = 6)
  int op_slot_left_7434 = gc_frame_newslot(opresult7443);
  params[0] = strlit7435;
  partcv[0] = 1;
  Object opresult7444 = callmethod(opresult7443, "++", 1, partcv, params);
// compiled op node returning opresult7444 (depth = 5)
  *var_s = opresult7444;
  if (opresult7444 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1746
  setline(1746);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7447 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num7449 = alloc_Float64(2);
// compiled num node returning num7449 (depth = 8)
  int op_slot_right_7448 = gc_frame_newslot(num7449);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_7448 = gc_frame_newslot(*var_depth);
  params[0] = num7449;
  partcv[0] = 1;
  Object sum7451 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum7451 (depth = 7)
  gc_frame_newslot(sum7451);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7452 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7453 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7452);
// compiled call node returning call7453 (depth = 8)
// compiled member node returning call7453 (depth = 7)
  params[0] = sum7451;
  partcv[0] = 1;
  Object call7454 = callmethod(call7453, "pretty",
    1, partcv, params);
  gc_frame_end(callframe7447);
// compiled call node returning call7454 (depth = 6)
  int op_slot_right_7446 = gc_frame_newslot(call7454);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7446 = gc_frame_newslot(*var_s);
  params[0] = call7454;
  partcv[0] = 1;
  Object opresult7456 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7456 (depth = 5)
  *var_s = opresult7456;
  if (opresult7456 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7427 = done;
  } else {
  }
// compiled if node returning if7427 (depth = 3)
// Begin line 1748
  setline(1748);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7460 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7461 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7460);
// compiled call node returning call7461 (depth = 6)
// compiled member node returning call7461 (depth = 5)
  int op_slot_right_7459 = gc_frame_newslot(call7461);
// starting to compile identifier node (depth = 5)
  Object bool7463 = alloc_Boolean(0);
// compiled identifier node returning bool7463 (depth = 5)
  int op_slot_left_7459 = gc_frame_newslot(bool7463);
  params[0] = call7461;
  partcv[0] = 1;
  Object opresult7464 = callmethod(bool7463, "!=", 1, partcv, params);
// compiled op node returning opresult7464 (depth = 4)
  Object if7458 = done;
  if (istrue(opresult7464)) {
// Begin line 1749
  setline(1749);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7466 == NULL) {
    strlit7466 = alloc_String("Generics:");
    gc_root(strlit7466);
  }
// compiled string node returning strlit7466 (depth = 6)
  int op_slot_right_7465 = gc_frame_newslot(strlit7466);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_7468 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit7471 == NULL) {
    strlit7471 = alloc_String("""\x0a""");
    gc_root(strlit7471);
  }
// compiled string node returning strlit7471 (depth = 8)
  int op_slot_right_7470 = gc_frame_newslot(strlit7471);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_7470 = gc_frame_newslot(*var_s);
  params[0] = strlit7471;
  partcv[0] = 1;
  Object opresult7473 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7473 (depth = 7)
  int op_slot_left_7468 = gc_frame_newslot(opresult7473);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7474 = callmethod(opresult7473, "++", 1, partcv, params);
// compiled op node returning opresult7474 (depth = 6)
  int op_slot_left_7465 = gc_frame_newslot(opresult7474);
  params[0] = strlit7466;
  partcv[0] = 1;
  Object opresult7475 = callmethod(opresult7474, "++", 1, partcv, params);
// compiled op node returning opresult7475 (depth = 5)
  *var_s = opresult7475;
  if (opresult7475 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1750
  setline(1750);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7477 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7478 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7479 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7478);
// compiled call node returning call7479 (depth = 6)
// compiled member node returning call7479 (depth = 5)
  gc_frame_newslot(call7479);
// starting to compile block node (depth = 5)
  Object block7480 = alloc_Block(NULL, NULL, "ast", 1750);
  gc_frame_newslot(block7480);
// method _apply
  block_savedest(block7480);
  Object closure7481 = createclosure(4, "_apply");
  setclosureframe(closure7481, stackframe);
  addtoclosure(closure7481, var_depth);
  addtoclosure(closure7481, var_spc);
  addtoclosure(closure7481, var_s);
  addtoclosure(closure7481, selfslot);
  struct UserObject *uo7481 = (struct UserObject*)block7480;
  uo7481->data[0] = (Object)closure7481;
  Method *meth_meth_ast__apply7481 = addmethod2pos(block7480, "_apply", &meth_ast__apply7481, 0);
  int argcv_meth_ast__apply7481[] = {1};
  meth_meth_ast__apply7481->type = alloc_MethodType(1, argcv_meth_ast__apply7481);
  meth_meth_ast__apply7481->definitionModule = modulename;
  meth_meth_ast__apply7481->definitionLine = 1750;
// compiled block node returning block7480 (depth = 5)
  gc_frame_newslot(block7480);
// call case 5: prelude request
  params[0] = call7479;
  params[1] = block7480;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7500 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7477);
// compiled call node returning call7500 (depth = 4)
    gc_frame_newslot(call7500);
    if7458 = call7500;
  } else {
  }
// compiled if node returning if7458 (depth = 3)
// Begin line 1754
  setline(1754);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply7559(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1769
  setline(1769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7561 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num7563 = alloc_Float64(1);
// compiled num node returning num7563 (depth = 10)
  int op_slot_right_7562 = gc_frame_newslot(num7563);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_7562 = gc_frame_newslot(*var_depth);
  params[0] = num7563;
  partcv[0] = 1;
  Object sum7565 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum7565 (depth = 9)
  gc_frame_newslot(sum7565);
// call case 6: other member request
// starting to compile call node (depth = 9)
  int callframe7566 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ix (depth = 10)
  gc_frame_newslot(*var_ix);
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe7567 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7568 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7567);
// compiled call node returning call7568 (depth = 11)
// compiled member node returning call7568 (depth = 10)
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call7569 = callmethod(call7568, "at",
    1, partcv, params);
  gc_frame_end(callframe7566);
// compiled call node returning call7569 (depth = 9)
  params[0] = sum7565;
  partcv[0] = 1;
  Object call7570 = callmethod(call7569, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe7561);
// compiled call node returning call7570 (depth = 8)
  int op_slot_right_7560 = gc_frame_newslot(call7570);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_7560 = gc_frame_newslot(*var_s);
  params[0] = call7570;
  partcv[0] = 1;
  Object opresult7572 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7572 (depth = 7)
  *var_s = opresult7572;
  if (opresult7572 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace7501(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1757
  setline(1757);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_s = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 1758
  setline(1758);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7503 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7504 = callmethodflags(self, "wildcard", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7503);
// compiled call node returning call7504 (depth = 5)
// compiled member node returning call7504 (depth = 4)
  Object if7502 = done;
  if (istrue(call7504)) {
// Begin line 1759
  setline(1759);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7505 == NULL) {
    strlit7505 = alloc_String("_");
    gc_root(strlit7505);
  }
// compiled string node returning strlit7505 (depth = 5)
  *var_s = strlit7505;
  if (strlit7505 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7502 = done;
  } else {
// Begin line 1761
  setline(1761);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7507 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7508 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7507);
// compiled call node returning call7508 (depth = 6)
// compiled member node returning call7508 (depth = 5)
  *var_s = call7508;
  if (call7508 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7502 = done;
  }
// compiled if node returning if7502 (depth = 3)
// Begin line 1763
  setline(1763);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool7512 = alloc_Boolean(0);
// compiled identifier node returning bool7512 (depth = 5)
  int op_slot_right_7511 = gc_frame_newslot(bool7512);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7514 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7515 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7514);
// compiled call node returning call7515 (depth = 6)
// compiled member node returning call7515 (depth = 5)
  int op_slot_left_7511 = gc_frame_newslot(call7515);
  params[0] = bool7512;
  partcv[0] = 1;
  Object opresult7516 = callmethod(call7515, "!=", 1, partcv, params);
// compiled op node returning opresult7516 (depth = 4)
  Object if7510 = done;
  if (istrue(opresult7516)) {
// Begin line 1764
  setline(1764);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7518 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num7520 = alloc_Float64(1);
// compiled num node returning num7520 (depth = 8)
  int op_slot_right_7519 = gc_frame_newslot(num7520);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_7519 = gc_frame_newslot(*var_depth);
  params[0] = num7520;
  partcv[0] = 1;
  Object sum7522 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum7522 (depth = 7)
  gc_frame_newslot(sum7522);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7523 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7524 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7523);
// compiled call node returning call7524 (depth = 8)
// compiled member node returning call7524 (depth = 7)
  params[0] = sum7522;
  partcv[0] = 1;
  Object call7525 = callmethod(call7524, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe7518);
// compiled call node returning call7525 (depth = 6)
  int op_slot_right_7517 = gc_frame_newslot(call7525);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7528 == NULL) {
    strlit7528 = alloc_String(" : ");
    gc_root(strlit7528);
  }
// compiled string node returning strlit7528 (depth = 7)
  int op_slot_right_7527 = gc_frame_newslot(strlit7528);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_7527 = gc_frame_newslot(*var_s);
  params[0] = strlit7528;
  partcv[0] = 1;
  Object opresult7530 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7530 (depth = 6)
  int op_slot_left_7517 = gc_frame_newslot(opresult7530);
  params[0] = call7525;
  partcv[0] = 1;
  Object opresult7531 = callmethod(opresult7530, "++", 1, partcv, params);
// compiled op node returning opresult7531 (depth = 5)
  *var_s = opresult7531;
  if (opresult7531 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7510 = done;
  } else {
  }
// compiled if node returning if7510 (depth = 3)
// Begin line 1766
  setline(1766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7535 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7536 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7535);
// compiled call node returning call7536 (depth = 6)
// compiled member node returning call7536 (depth = 5)
  int op_slot_right_7534 = gc_frame_newslot(call7536);
// starting to compile identifier node (depth = 5)
  Object bool7538 = alloc_Boolean(0);
// compiled identifier node returning bool7538 (depth = 5)
  int op_slot_left_7534 = gc_frame_newslot(bool7538);
  params[0] = call7536;
  partcv[0] = 1;
  Object opresult7539 = callmethod(bool7538, "!=", 1, partcv, params);
// compiled op node returning opresult7539 (depth = 4)
  Object if7533 = done;
  if (istrue(opresult7539)) {
// Begin line 1767
  setline(1767);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7541 == NULL) {
    strlit7541 = alloc_String("<");
    gc_root(strlit7541);
  }
// compiled string node returning strlit7541 (depth = 6)
  int op_slot_right_7540 = gc_frame_newslot(strlit7541);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7540 = gc_frame_newslot(*var_s);
  params[0] = strlit7541;
  partcv[0] = 1;
  Object opresult7543 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7543 (depth = 5)
  *var_s = opresult7543;
  if (opresult7543 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1768
  setline(1768);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7545 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num7548 = alloc_Float64(1);
// compiled num node returning num7548 (depth = 7)
  int op_slot_right_7547 = gc_frame_newslot(num7548);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7550 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7551 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7552 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7551);
// compiled call node returning call7552 (depth = 10)
// compiled member node returning call7552 (depth = 9)
  partcv[0] = 0;
  Object call7553 = callmethod(call7552, "size",
    1, partcv, params);
  gc_frame_end(callframe7550);
// compiled call node returning call7553 (depth = 8)
// compiled member node returning call7553 (depth = 7)
  int op_slot_left_7547 = gc_frame_newslot(call7553);
  params[0] = num7548;
  partcv[0] = 1;
  Object diff7554 = callmethod(call7553, "-", 1, partcv, params);
// compiled op node returning diff7554 (depth = 6)
  int op_slot_right_7546 = gc_frame_newslot(diff7554);
// starting to compile num node (depth = 6)
  Object num7556 = alloc_Float64(1);
// compiled num node returning num7556 (depth = 6)
  int op_slot_left_7546 = gc_frame_newslot(num7556);
  params[0] = diff7554;
  partcv[0] = 1;
  Object opresult7557 = callmethod(num7556, "..", 1, partcv, params);
// compiled op node returning opresult7557 (depth = 5)
  gc_frame_newslot(opresult7557);
// starting to compile block node (depth = 5)
  Object block7558 = alloc_Block(NULL, NULL, "ast", 1768);
  gc_frame_newslot(block7558);
// method _apply
  block_savedest(block7558);
  Object closure7559 = createclosure(3, "_apply");
  setclosureframe(closure7559, stackframe);
  addtoclosure(closure7559, var_depth);
  addtoclosure(closure7559, var_s);
  addtoclosure(closure7559, selfslot);
  struct UserObject *uo7559 = (struct UserObject*)block7558;
  uo7559->data[0] = (Object)closure7559;
  Method *meth_meth_ast__apply7559 = addmethod2pos(block7558, "_apply", &meth_ast__apply7559, 0);
  int argcv_meth_ast__apply7559[] = {1};
  meth_meth_ast__apply7559->type = alloc_MethodType(1, argcv_meth_ast__apply7559);
  meth_meth_ast__apply7559->definitionModule = modulename;
  meth_meth_ast__apply7559->definitionLine = 1768;
// compiled block node returning block7558 (depth = 5)
  gc_frame_newslot(block7558);
// call case 5: prelude request
  params[0] = opresult7557;
  params[1] = block7558;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7575 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7545);
// compiled call node returning call7575 (depth = 4)
// Begin line 1771
  setline(1771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7577 == NULL) {
    strlit7577 = alloc_String(">");
    gc_root(strlit7577);
  }
// compiled string node returning strlit7577 (depth = 6)
  int op_slot_right_7576 = gc_frame_newslot(strlit7577);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7580 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num7582 = alloc_Float64(1);
// compiled num node returning num7582 (depth = 9)
  int op_slot_right_7581 = gc_frame_newslot(num7582);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_7581 = gc_frame_newslot(*var_depth);
  params[0] = num7582;
  partcv[0] = 1;
  Object sum7584 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum7584 (depth = 8)
  gc_frame_newslot(sum7584);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7585 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe7586 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7587 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7586);
// compiled call node returning call7587 (depth = 11)
// compiled member node returning call7587 (depth = 10)
  partcv[0] = 0;
  Object call7588 = callmethod(call7587, "last",
    1, partcv, params);
  gc_frame_end(callframe7585);
// compiled call node returning call7588 (depth = 9)
// compiled member node returning call7588 (depth = 8)
  params[0] = sum7584;
  partcv[0] = 1;
  Object call7589 = callmethod(call7588, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe7580);
// compiled call node returning call7589 (depth = 7)
  int op_slot_right_7579 = gc_frame_newslot(call7589);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_7579 = gc_frame_newslot(*var_s);
  params[0] = call7589;
  partcv[0] = 1;
  Object opresult7591 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7591 (depth = 6)
  int op_slot_left_7576 = gc_frame_newslot(opresult7591);
  params[0] = strlit7577;
  partcv[0] = 1;
  Object opresult7592 = callmethod(opresult7591, "++", 1, partcv, params);
// compiled op node returning opresult7592 (depth = 5)
  *var_s = opresult7592;
  if (opresult7592 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7533 = done;
  } else {
  }
// compiled if node returning if7533 (depth = 3)
// Begin line 1773
  setline(1773);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_asString7594(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1777
  setline(1777);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7596 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7597 = callmethodflags(self, "isBindingOccurrence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7596);
// compiled call node returning call7597 (depth = 5)
// compiled member node returning call7597 (depth = 4)
  Object if7595 = done;
  if (istrue(call7597)) {
// Begin line 1778
  setline(1778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7599 == NULL) {
    strlit7599 = alloc_String("""\xe2""""\x80""""\xba""");
    gc_root(strlit7599);
  }
// compiled string node returning strlit7599 (depth = 5)
  int op_slot_right_7598 = gc_frame_newslot(strlit7599);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7602 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7603 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7602);
// compiled call node returning call7603 (depth = 7)
// compiled member node returning call7603 (depth = 6)
  int op_slot_right_7601 = gc_frame_newslot(call7603);
// starting to compile string node (depth = 6)
  if (strlit7605 == NULL) {
    strlit7605 = alloc_String("identifierBinding""\xe2""""\x80""""\xb9""");
    gc_root(strlit7605);
  }
// compiled string node returning strlit7605 (depth = 6)
  int op_slot_left_7601 = gc_frame_newslot(strlit7605);
  params[0] = call7603;
  partcv[0] = 1;
  Object opresult7606 = callmethod(strlit7605, "++", 1, partcv, params);
// compiled op node returning opresult7606 (depth = 5)
  int op_slot_left_7598 = gc_frame_newslot(opresult7606);
  params[0] = strlit7599;
  partcv[0] = 1;
  Object opresult7607 = callmethod(opresult7606, "++", 1, partcv, params);
// compiled op node returning opresult7607 (depth = 4)
    gc_frame_newslot(opresult7607);
    if7595 = opresult7607;
  } else {
// Begin line 1780
  setline(1780);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7609 == NULL) {
    strlit7609 = alloc_String("""\xe2""""\x80""""\xba""");
    gc_root(strlit7609);
  }
// compiled string node returning strlit7609 (depth = 5)
  int op_slot_right_7608 = gc_frame_newslot(strlit7609);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7612 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7613 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7612);
// compiled call node returning call7613 (depth = 7)
// compiled member node returning call7613 (depth = 6)
  int op_slot_right_7611 = gc_frame_newslot(call7613);
// starting to compile string node (depth = 6)
  if (strlit7615 == NULL) {
    strlit7615 = alloc_String("identifier""\xe2""""\x80""""\xb9""");
    gc_root(strlit7615);
  }
// compiled string node returning strlit7615 (depth = 6)
  int op_slot_left_7611 = gc_frame_newslot(strlit7615);
  params[0] = call7613;
  partcv[0] = 1;
  Object opresult7616 = callmethod(strlit7615, "++", 1, partcv, params);
// compiled op node returning opresult7616 (depth = 5)
  int op_slot_left_7608 = gc_frame_newslot(opresult7616);
  params[0] = strlit7609;
  partcv[0] = 1;
  Object opresult7617 = callmethod(opresult7616, "++", 1, partcv, params);
// compiled op node returning opresult7617 (depth = 4)
    gc_frame_newslot(opresult7617);
    if7595 = opresult7617;
  }
// compiled if node returning if7595 (depth = 3)
  gc_frame_end(frame);
  return if7595;
}
Object meth_ast_shallowCopy7618(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_identifierNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1784
  setline(1784);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7619 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe7620 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7621 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7622 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7621);
// compiled call node returning call7622 (depth = 6)
// compiled member node returning call7622 (depth = 5)
  gc_frame_newslot(call7622);
// starting to compile identifier node (depth = 5)
  Object bool7623 = alloc_Boolean(0);
// compiled identifier node returning bool7623 (depth = 5)
  gc_frame_newslot(bool7623);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_identifierNode (depth = 5)
  params[0] = call7622;
  params[1] = bool7623;
  partcv[0] = 2;
  Object call7624 = callmethod(*var_identifierNode, "new",
    1, partcv, params);
  gc_frame_end(callframe7620);
// compiled call node returning call7624 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call7625 = callmethod(call7624, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe7619);
// compiled call node returning call7625 (depth = 3)
  gc_frame_end(frame);
  return call7625;
}
Object meth_ast_shallowCopyFieldsFrom7626(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyFieldsFrom");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopyFieldsFrom (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyFieldsFrom");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1787
  setline(1787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7627 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call7628 = callmethod4(self, "shallowCopyFieldsFrom", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe7627);
// compiled call node returning call7628 (depth = 3)
// Begin line 1788
  setline(1788);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 1784
  setline(1784);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7629 = gc_frame_new();
// Begin line 1788
  setline(1788);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7630 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  partcv[0] = 0;
  Object call7631 = callmethod(*var_other, "wildcard",
    1, partcv, params);
  gc_frame_end(callframe7630);
// compiled call node returning call7631 (depth = 6)
// compiled member node returning call7631 (depth = 5)
  gc_frame_newslot(call7631);
// call case 4: self request
  params[0] = call7631;
  partcv[0] = 1;
  Object call7632 = callmethodflags(self, "wildcard:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7629);
// compiled call node returning call7632 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 1789
  setline(1789);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 1788
  setline(1788);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7633 = gc_frame_new();
// Begin line 1789
  setline(1789);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7634 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  partcv[0] = 0;
  Object call7635 = callmethod(*var_other, "isBindingOccurrence",
    1, partcv, params);
  gc_frame_end(callframe7634);
// compiled call node returning call7635 (depth = 6)
// compiled member node returning call7635 (depth = 5)
  gc_frame_newslot(call7635);
// call case 4: self request
  params[0] = call7635;
  partcv[0] = 1;
  Object call7636 = callmethodflags(self, "isBindingOccurrence:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7633);
// compiled call node returning call7636 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 1790
  setline(1790);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 1789
  setline(1789);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7637 = gc_frame_new();
// Begin line 1790
  setline(1790);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7638 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  partcv[0] = 0;
  Object call7639 = callmethod(*var_other, "isDeclaredByParent",
    1, partcv, params);
  gc_frame_end(callframe7638);
// compiled call node returning call7639 (depth = 6)
// compiled member node returning call7639 (depth = 5)
  gc_frame_newslot(call7639);
// call case 4: self request
  params[0] = call7639;
  partcv[0] = 1;
  Object call7640 = callmethodflags(self, "isDeclaredByParent:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7637);
// compiled call node returning call7640 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 1791
  setline(1791);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 1790
  setline(1790);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7641 = gc_frame_new();
// Begin line 1791
  setline(1791);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7642 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  partcv[0] = 0;
  Object call7643 = callmethod(*var_other, "isAssigned",
    1, partcv, params);
  gc_frame_end(callframe7642);
// compiled call node returning call7643 (depth = 6)
// compiled member node returning call7643 (depth = 5)
  gc_frame_newslot(call7643);
// call case 4: self request
  params[0] = call7643;
  partcv[0] = 1;
  Object call7644 = callmethodflags(self, "isAssigned:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7641);
// compiled call node returning call7644 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 1792
  setline(1792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 1791
  setline(1791);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7645 = gc_frame_new();
// Begin line 1792
  setline(1792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7646 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  partcv[0] = 0;
  Object call7647 = callmethod(*var_other, "inRequest",
    1, partcv, params);
  gc_frame_end(callframe7646);
// compiled call node returning call7647 (depth = 6)
// compiled member node returning call7647 (depth = 5)
  gc_frame_newslot(call7647);
// call case 4: self request
  params[0] = call7647;
  partcv[0] = 1;
  Object call7648 = callmethodflags(self, "inRequest:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7645);
// compiled call node returning call7648 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 1793
  setline(1793);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_new7290(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_identifierNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name = &(stackframe->slots[0]);
  *var_name = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[1]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7291 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7291 = alloc_userobj2(31,24, objclass7291);
  gc_frame_newslot(obj7291);
if (objclass7291 == NULL) {
  glfree(obj7291->class->name);
  obj7291->class->name = "obj7283.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7291, self, 0);
  addmethodreal(obj7291,"outer", &reader_ast_outer_7292);
  Object oldself7291 = self;
  struct StackFrameObject *oldstackframe7291 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7291);
  gc_frame_newslot((Object)stackframe);
  self = obj7291;
  Object *oldselfslot7291 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7291 = (*(struct UserObject *)self).data[0], lowerouter7291 = thisouter7291;
  if (inheritingObject7291) {
    struct UserObject *inho7291 = (struct UserObject *)inheritingObject7291;
    while (inho7291->super != GraceDefaultObject) inho7291 = (struct UserObject *)inho7291->super;
    inho7291->super = obj7291;
    self = inheritingObject7291;
    *selfslot = self;
    lowerouter7291 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7291;
  }
if (objclass7291 == NULL) {
  Method *reader7293 = addmethodrealflags(obj7291, "kind",&reader_ast_kind_7293, MFLAG_DEF);
  reader7293->definitionModule = modulename;
  reader7293->definitionLine = 1683;
}
adddatum2(obj7291, alloc_Undefined(), 1);
if (objclass7291 == NULL) {
  Method *reader7294 = addmethodrealflags(obj7291, "value",&reader_ast_value_7294, 0);
  Method *writer7294 = addmethodrealflags(obj7291, "value:=",&writer_ast_value_7294, 0);
  reader7294->definitionModule = modulename;
  writer7294->definitionModule = modulename;
  reader7294->definitionLine = 1684;
  writer7294->definitionLine = 1684;
}
obj7291->flags |= OFLAG_MUTABLE;
adddatum2(obj7291, alloc_Undefined(), 2);
if (objclass7291 == NULL) {
  Method *reader7295 = addmethodrealflags(obj7291, "wildcard",&reader_ast_wildcard_7295, 0);
  Method *writer7295 = addmethodrealflags(obj7291, "wildcard:=",&writer_ast_wildcard_7295, 0);
  reader7295->definitionModule = modulename;
  writer7295->definitionModule = modulename;
  reader7295->definitionLine = 1685;
  writer7295->definitionLine = 1685;
}
obj7291->flags |= OFLAG_MUTABLE;
adddatum2(obj7291, alloc_Undefined(), 3);
if (objclass7291 == NULL) {
  Method *reader7296 = addmethodrealflags(obj7291, "dtype",&reader_ast_dtype_7296, 0);
  Method *writer7296 = addmethodrealflags(obj7291, "dtype:=",&writer_ast_dtype_7296, 0);
  reader7296->definitionModule = modulename;
  writer7296->definitionModule = modulename;
  reader7296->definitionLine = 1686;
  writer7296->definitionLine = 1686;
}
obj7291->flags |= OFLAG_MUTABLE;
adddatum2(obj7291, alloc_Undefined(), 4);
if (objclass7291 == NULL) {
  Method *reader7297 = addmethodrealflags(obj7291, "isBindingOccurrence",&reader_ast_isBindingOccurrence_7297, 0);
  Method *writer7297 = addmethodrealflags(obj7291, "isBindingOccurrence:=",&writer_ast_isBindingOccurrence_7297, 0);
  reader7297->definitionModule = modulename;
  writer7297->definitionModule = modulename;
  reader7297->definitionLine = 1687;
  writer7297->definitionLine = 1687;
}
obj7291->flags |= OFLAG_MUTABLE;
adddatum2(obj7291, alloc_Undefined(), 5);
if (objclass7291 == NULL) {
  Method *reader7298 = addmethodrealflags(obj7291, "isAssigned",&reader_ast_isAssigned_7298, 0);
  Method *writer7298 = addmethodrealflags(obj7291, "isAssigned:=",&writer_ast_isAssigned_7298, 0);
  reader7298->definitionModule = modulename;
  writer7298->definitionModule = modulename;
  reader7298->definitionLine = 1688;
  writer7298->definitionLine = 1688;
}
obj7291->flags |= OFLAG_MUTABLE;
adddatum2(obj7291, alloc_Undefined(), 6);
if (objclass7291 == NULL) {
  Method *reader7299 = addmethodrealflags(obj7291, "inRequest",&reader_ast_inRequest_7299, 0);
  Method *writer7299 = addmethodrealflags(obj7291, "inRequest:=",&writer_ast_inRequest_7299, 0);
  reader7299->definitionModule = modulename;
  writer7299->definitionModule = modulename;
  reader7299->definitionLine = 1689;
  writer7299->definitionLine = 1689;
}
obj7291->flags |= OFLAG_MUTABLE;
adddatum2(obj7291, alloc_Undefined(), 7);
if (objclass7291 == NULL) {
  Method *reader7300 = addmethodrealflags(obj7291, "generics",&reader_ast_generics_7300, 0);
  Method *writer7300 = addmethodrealflags(obj7291, "generics:=",&writer_ast_generics_7300, 0);
  reader7300->definitionModule = modulename;
  writer7300->definitionModule = modulename;
  reader7300->definitionLine = 1690;
  writer7300->definitionLine = 1690;
}
obj7291->flags |= OFLAG_MUTABLE;
adddatum2(obj7291, alloc_Undefined(), 8);
if (objclass7291 == NULL) {
  Method *reader7301 = addmethodrealflags(obj7291, "isDeclaredByParent",&reader_ast_isDeclaredByParent_7301, 0);
  Method *writer7301 = addmethodrealflags(obj7291, "isDeclaredByParent:=",&writer_ast_isDeclaredByParent_7301, 0);
  reader7301->definitionModule = modulename;
  writer7301->definitionModule = modulename;
  reader7301->definitionLine = 1691;
  writer7301->definitionLine = 1691;
}
obj7291->flags |= OFLAG_MUTABLE;
adddatum2(obj7291, alloc_Undefined(), 9);
// method nameString
  struct UserObject *uo7302 = (struct UserObject*)obj7291;
  uo7302->data[10] = emptyclosure;
  Method *meth_meth_ast_nameString7302 = addmethod2pos(obj7291, "nameString", &meth_ast_nameString7302, 10);
  int argcv_meth_ast_nameString7302[] = {0};
  meth_meth_ast_nameString7302->type = alloc_MethodType(1, argcv_meth_ast_nameString7302);
  meth_meth_ast_nameString7302->definitionModule = modulename;
  meth_meth_ast_nameString7302->definitionLine = 1693;
// method isIdentifier
  struct UserObject *uo7305 = (struct UserObject*)obj7291;
  uo7305->data[11] = emptyclosure;
  Method *meth_meth_ast_isIdentifier7305 = addmethod2pos(obj7291, "isIdentifier", &meth_ast_isIdentifier7305, 11);
  int argcv_meth_ast_isIdentifier7305[] = {0};
  meth_meth_ast_isIdentifier7305->type = alloc_MethodType(1, argcv_meth_ast_isIdentifier7305);
  meth_meth_ast_isIdentifier7305->definitionModule = modulename;
  meth_meth_ast_isIdentifier7305->definitionLine = 1695;
// method isAppliedOccurenceOfIdentifier
  struct UserObject *uo7307 = (struct UserObject*)obj7291;
  uo7307->data[12] = emptyclosure;
  Method *meth_meth_ast_isAppliedOccurenceOfIdentifier7307 = addmethod2pos(obj7291, "isAppliedOccurenceOfIdentifier", &meth_ast_isAppliedOccurenceOfIdentifier7307, 12);
  int argcv_meth_ast_isAppliedOccurenceOfIdentifier7307[] = {0};
  meth_meth_ast_isAppliedOccurenceOfIdentifier7307->type = alloc_MethodType(1, argcv_meth_ast_isAppliedOccurenceOfIdentifier7307);
  meth_meth_ast_isAppliedOccurenceOfIdentifier7307->definitionModule = modulename;
  meth_meth_ast_isAppliedOccurenceOfIdentifier7307->definitionLine = 1697;
// method declarationKindWithAncestors
  struct UserObject *uo7316 = (struct UserObject*)obj7291;
  uo7316->data[13] = emptyclosure;
  Method *meth_meth_ast_declarationKindWithAncestors7316 = addmethod2pos(obj7291, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors7316, 13);
  int argcv_meth_ast_declarationKindWithAncestors7316[] = {1};
  meth_meth_ast_declarationKindWithAncestors7316->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors7316);
  meth_meth_ast_declarationKindWithAncestors7316->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors7316->definitionLine = 1704;
// method inTypePositionWithAncestors
  struct UserObject *uo7321 = (struct UserObject*)obj7291;
  uo7321->data[14] = emptyclosure;
  Method *meth_meth_ast_inTypePositionWithAncestors7321 = addmethod2pos(obj7291, "inTypePositionWithAncestors", &meth_ast_inTypePositionWithAncestors7321, 14);
  int argcv_meth_ast_inTypePositionWithAncestors7321[] = {1};
  meth_meth_ast_inTypePositionWithAncestors7321->type = alloc_MethodType(1, argcv_meth_ast_inTypePositionWithAncestors7321);
  meth_meth_ast_inTypePositionWithAncestors7321->definitionModule = modulename;
  meth_meth_ast_inTypePositionWithAncestors7321->definitionLine = 1707;
// method usesAsType
  struct UserObject *uo7330 = (struct UserObject*)obj7291;
  uo7330->data[15] = emptyclosure;
  Method *meth_meth_ast_usesAsType7330 = addmethod2pos(obj7291, "usesAsType", &meth_ast_usesAsType7330, 15);
  int argcv_meth_ast_usesAsType7330[] = {1};
  meth_meth_ast_usesAsType7330->type = alloc_MethodType(1, argcv_meth_ast_usesAsType7330);
  meth_meth_ast_usesAsType7330->definitionModule = modulename;
  meth_meth_ast_usesAsType7330->definitionLine = 1714;
// method accept()from
  struct UserObject *uo7336 = (struct UserObject*)obj7291;
  uo7336->data[16] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from7336 = addmethod2pos(obj7291, "accept()from", &meth_ast_accept_40__41_from7336, 16);
  int argcv_meth_ast_accept_40__41_from7336[] = {1, 1};
  meth_meth_ast_accept_40__41_from7336->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from7336);
  meth_meth_ast_accept_40__41_from7336->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from7336->definitionLine = 1717;
// method map()ancestors
  struct UserObject *uo7353 = (struct UserObject*)obj7291;
  uo7353->data[17] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors7353 = addmethod2pos(obj7291, "map()ancestors", &meth_ast_map_40__41_ancestors7353, 17);
  int argcv_meth_ast_map_40__41_ancestors7353[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors7353->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors7353);
  meth_meth_ast_map_40__41_ancestors7353->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors7353->definitionLine = 1725;
// method pretty
  struct UserObject *uo7370 = (struct UserObject*)obj7291;
  uo7370->data[18] = emptyclosure;
  Method *meth_meth_ast_pretty7370 = addmethod2pos(obj7291, "pretty", &meth_ast_pretty7370, 18);
  int argcv_meth_ast_pretty7370[] = {1};
  meth_meth_ast_pretty7370->type = alloc_MethodType(1, argcv_meth_ast_pretty7370);
  meth_meth_ast_pretty7370->definitionModule = modulename;
  meth_meth_ast_pretty7370->definitionLine = 1731;
// method toGrace
  struct UserObject *uo7501 = (struct UserObject*)obj7291;
  uo7501->data[19] = emptyclosure;
  Method *meth_meth_ast_toGrace7501 = addmethod2pos(obj7291, "toGrace", &meth_ast_toGrace7501, 19);
  int argcv_meth_ast_toGrace7501[] = {1};
  meth_meth_ast_toGrace7501->type = alloc_MethodType(1, argcv_meth_ast_toGrace7501);
meth_meth_ast_toGrace7501->type->types[0] = type_Number;
meth_meth_ast_toGrace7501->type->names[0] = "depth";
  meth_meth_ast_toGrace7501->definitionModule = modulename;
  meth_meth_ast_toGrace7501->definitionLine = 1756;
// method asString
  struct UserObject *uo7594 = (struct UserObject*)obj7291;
  uo7594->data[20] = emptyclosure;
  Method *meth_meth_ast_asString7594 = addmethod2pos(obj7291, "asString", &meth_ast_asString7594, 20);
  int argcv_meth_ast_asString7594[] = {0};
  meth_meth_ast_asString7594->type = alloc_MethodType(1, argcv_meth_ast_asString7594);
  meth_meth_ast_asString7594->definitionModule = modulename;
  meth_meth_ast_asString7594->definitionLine = 1776;
// method shallowCopy
  block_savedest(obj7291);
  Object closure7618 = createclosure(1, "shallowCopy");
  setclosureframe(closure7618, stackframe);
  addtoclosure(closure7618, var_identifierNode);
  struct UserObject *uo7618 = (struct UserObject*)obj7291;
  uo7618->data[21] = (Object)closure7618;
  Method *meth_meth_ast_shallowCopy7618 = addmethod2pos(obj7291, "shallowCopy", &meth_ast_shallowCopy7618, 21);
  int argcv_meth_ast_shallowCopy7618[] = {0};
  meth_meth_ast_shallowCopy7618->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy7618);
  meth_meth_ast_shallowCopy7618->definitionModule = modulename;
  meth_meth_ast_shallowCopy7618->definitionLine = 1783;
// method shallowCopyFieldsFrom
  struct UserObject *uo7626 = (struct UserObject*)obj7291;
  uo7626->data[22] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom7626 = addmethod2pos(obj7291, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom7626, 22);
  int argcv_meth_ast_shallowCopyFieldsFrom7626[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom7626->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom7626);
  meth_meth_ast_shallowCopyFieldsFrom7626->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom7626->definitionLine = 1786;
  sourceObject = obj7291;
// Begin line 1682
  setline(1682);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7649 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_baseNode (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7650 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7649);
// compiled call node returning call7650 (depth = 3)
  struct UserObject *obj7291_uo = (struct UserObject *)obj7291;
  obj7291_uo->super = call7650;
  sourceObject = obj7291;
// Begin line 1683
  setline(1683);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7651 == NULL) {
    strlit7651 = alloc_String("identifier");
    gc_root(strlit7651);
  }
// compiled string node returning strlit7651 (depth = 3)
  adddatum2(obj7291, strlit7651, 1);
  sourceObject = obj7291;
// Begin line 1684
  setline(1684);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name (depth = 3)
  adddatum2(obj7291, *var_name, 2);
  sourceObject = obj7291;
// Begin line 1685
  setline(1685);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7652 = alloc_Boolean(0);
// compiled identifier node returning bool7652 (depth = 3)
  adddatum2(obj7291, bool7652, 3);
  sourceObject = obj7291;
// Begin line 1686
  setline(1686);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj7291, *var_dtype_39_, 4);
  sourceObject = obj7291;
// Begin line 1687
  setline(1687);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7653 = alloc_Boolean(0);
// compiled identifier node returning bool7653 (depth = 3)
  adddatum2(obj7291, bool7653, 5);
  sourceObject = obj7291;
// Begin line 1688
  setline(1688);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7654 = alloc_Boolean(0);
// compiled identifier node returning bool7654 (depth = 3)
  adddatum2(obj7291, bool7654, 6);
  sourceObject = obj7291;
// Begin line 1689
  setline(1689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7655 = alloc_Boolean(0);
// compiled identifier node returning bool7655 (depth = 3)
  adddatum2(obj7291, bool7655, 7);
  sourceObject = obj7291;
// Begin line 1690
  setline(1690);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7656 = alloc_Boolean(0);
// compiled identifier node returning bool7656 (depth = 3)
  adddatum2(obj7291, bool7656, 8);
  sourceObject = obj7291;
// Begin line 1691
  setline(1691);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7657 = alloc_Boolean(0);
// compiled identifier node returning bool7657 (depth = 3)
  adddatum2(obj7291, bool7657, 9);
  sourceObject = obj7291;
  sourceObject = obj7291;
  sourceObject = obj7291;
  sourceObject = obj7291;
  sourceObject = obj7291;
  sourceObject = obj7291;
  sourceObject = obj7291;
  sourceObject = obj7291;
  sourceObject = obj7291;
  sourceObject = obj7291;
  sourceObject = obj7291;
  sourceObject = obj7291;
  sourceObject = obj7291;
  objclass7291 = obj7291->class;
  objclass7291->definitionModule = modulename;
  objclass7291->definitionLine = 1681;
  (*(struct UserObject *)self).data[0] = lowerouter7291;
  self = oldself7291;
  selfslot = oldselfslot7291;
  stackframe = oldstackframe7291;
  gc_frame_end(frame);
  return obj7291;
}
Object meth_ast_new7290_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_identifierNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name = &(stackframe->slots[0]);
  *var_name = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[1]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7291 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7291 = alloc_userobj2(31,24, objclass7291);
  gc_frame_newslot(obj7291);
if (objclass7291 == NULL) {
  glfree(obj7291->class->name);
  obj7291->class->name = "obj7283.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7291, self, 0);
  addmethodreal(obj7291,"outer", &reader_ast_outer_7292);
  Object oldself7291 = self;
  struct StackFrameObject *oldstackframe7291 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7291);
  gc_frame_newslot((Object)stackframe);
  self = obj7291;
  Object *oldselfslot7291 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7291 = (*(struct UserObject *)self).data[0], lowerouter7291 = thisouter7291;
  if (inheritingObject7291) {
    struct UserObject *inho7291 = (struct UserObject *)inheritingObject7291;
    while (inho7291->super != GraceDefaultObject) inho7291 = (struct UserObject *)inho7291->super;
    inho7291->super = obj7291;
    self = inheritingObject7291;
    *selfslot = self;
    lowerouter7291 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7291;
  }
if (objclass7291 == NULL) {
  Method *reader7293 = addmethodrealflags(obj7291, "kind",&reader_ast_kind_7293, MFLAG_DEF);
  reader7293->definitionModule = modulename;
  reader7293->definitionLine = 1683;
}
adddatum2(obj7291, alloc_Undefined(), 1);
if (objclass7291 == NULL) {
  Method *reader7294 = addmethodrealflags(obj7291, "value",&reader_ast_value_7294, 0);
  Method *writer7294 = addmethodrealflags(obj7291, "value:=",&writer_ast_value_7294, 0);
  reader7294->definitionModule = modulename;
  writer7294->definitionModule = modulename;
  reader7294->definitionLine = 1684;
  writer7294->definitionLine = 1684;
}
obj7291->flags |= OFLAG_MUTABLE;
adddatum2(obj7291, alloc_Undefined(), 2);
if (objclass7291 == NULL) {
  Method *reader7295 = addmethodrealflags(obj7291, "wildcard",&reader_ast_wildcard_7295, 0);
  Method *writer7295 = addmethodrealflags(obj7291, "wildcard:=",&writer_ast_wildcard_7295, 0);
  reader7295->definitionModule = modulename;
  writer7295->definitionModule = modulename;
  reader7295->definitionLine = 1685;
  writer7295->definitionLine = 1685;
}
obj7291->flags |= OFLAG_MUTABLE;
adddatum2(obj7291, alloc_Undefined(), 3);
if (objclass7291 == NULL) {
  Method *reader7296 = addmethodrealflags(obj7291, "dtype",&reader_ast_dtype_7296, 0);
  Method *writer7296 = addmethodrealflags(obj7291, "dtype:=",&writer_ast_dtype_7296, 0);
  reader7296->definitionModule = modulename;
  writer7296->definitionModule = modulename;
  reader7296->definitionLine = 1686;
  writer7296->definitionLine = 1686;
}
obj7291->flags |= OFLAG_MUTABLE;
adddatum2(obj7291, alloc_Undefined(), 4);
if (objclass7291 == NULL) {
  Method *reader7297 = addmethodrealflags(obj7291, "isBindingOccurrence",&reader_ast_isBindingOccurrence_7297, 0);
  Method *writer7297 = addmethodrealflags(obj7291, "isBindingOccurrence:=",&writer_ast_isBindingOccurrence_7297, 0);
  reader7297->definitionModule = modulename;
  writer7297->definitionModule = modulename;
  reader7297->definitionLine = 1687;
  writer7297->definitionLine = 1687;
}
obj7291->flags |= OFLAG_MUTABLE;
adddatum2(obj7291, alloc_Undefined(), 5);
if (objclass7291 == NULL) {
  Method *reader7298 = addmethodrealflags(obj7291, "isAssigned",&reader_ast_isAssigned_7298, 0);
  Method *writer7298 = addmethodrealflags(obj7291, "isAssigned:=",&writer_ast_isAssigned_7298, 0);
  reader7298->definitionModule = modulename;
  writer7298->definitionModule = modulename;
  reader7298->definitionLine = 1688;
  writer7298->definitionLine = 1688;
}
obj7291->flags |= OFLAG_MUTABLE;
adddatum2(obj7291, alloc_Undefined(), 6);
if (objclass7291 == NULL) {
  Method *reader7299 = addmethodrealflags(obj7291, "inRequest",&reader_ast_inRequest_7299, 0);
  Method *writer7299 = addmethodrealflags(obj7291, "inRequest:=",&writer_ast_inRequest_7299, 0);
  reader7299->definitionModule = modulename;
  writer7299->definitionModule = modulename;
  reader7299->definitionLine = 1689;
  writer7299->definitionLine = 1689;
}
obj7291->flags |= OFLAG_MUTABLE;
adddatum2(obj7291, alloc_Undefined(), 7);
if (objclass7291 == NULL) {
  Method *reader7300 = addmethodrealflags(obj7291, "generics",&reader_ast_generics_7300, 0);
  Method *writer7300 = addmethodrealflags(obj7291, "generics:=",&writer_ast_generics_7300, 0);
  reader7300->definitionModule = modulename;
  writer7300->definitionModule = modulename;
  reader7300->definitionLine = 1690;
  writer7300->definitionLine = 1690;
}
obj7291->flags |= OFLAG_MUTABLE;
adddatum2(obj7291, alloc_Undefined(), 8);
if (objclass7291 == NULL) {
  Method *reader7301 = addmethodrealflags(obj7291, "isDeclaredByParent",&reader_ast_isDeclaredByParent_7301, 0);
  Method *writer7301 = addmethodrealflags(obj7291, "isDeclaredByParent:=",&writer_ast_isDeclaredByParent_7301, 0);
  reader7301->definitionModule = modulename;
  writer7301->definitionModule = modulename;
  reader7301->definitionLine = 1691;
  writer7301->definitionLine = 1691;
}
obj7291->flags |= OFLAG_MUTABLE;
adddatum2(obj7291, alloc_Undefined(), 9);
// method nameString
  struct UserObject *uo7302 = (struct UserObject*)obj7291;
  uo7302->data[10] = emptyclosure;
  Method *meth_meth_ast_nameString7302 = addmethod2pos(obj7291, "nameString", &meth_ast_nameString7302, 10);
  int argcv_meth_ast_nameString7302[] = {0};
  meth_meth_ast_nameString7302->type = alloc_MethodType(1, argcv_meth_ast_nameString7302);
  meth_meth_ast_nameString7302->definitionModule = modulename;
  meth_meth_ast_nameString7302->definitionLine = 1693;
// method isIdentifier
  struct UserObject *uo7305 = (struct UserObject*)obj7291;
  uo7305->data[11] = emptyclosure;
  Method *meth_meth_ast_isIdentifier7305 = addmethod2pos(obj7291, "isIdentifier", &meth_ast_isIdentifier7305, 11);
  int argcv_meth_ast_isIdentifier7305[] = {0};
  meth_meth_ast_isIdentifier7305->type = alloc_MethodType(1, argcv_meth_ast_isIdentifier7305);
  meth_meth_ast_isIdentifier7305->definitionModule = modulename;
  meth_meth_ast_isIdentifier7305->definitionLine = 1695;
// method isAppliedOccurenceOfIdentifier
  struct UserObject *uo7307 = (struct UserObject*)obj7291;
  uo7307->data[12] = emptyclosure;
  Method *meth_meth_ast_isAppliedOccurenceOfIdentifier7307 = addmethod2pos(obj7291, "isAppliedOccurenceOfIdentifier", &meth_ast_isAppliedOccurenceOfIdentifier7307, 12);
  int argcv_meth_ast_isAppliedOccurenceOfIdentifier7307[] = {0};
  meth_meth_ast_isAppliedOccurenceOfIdentifier7307->type = alloc_MethodType(1, argcv_meth_ast_isAppliedOccurenceOfIdentifier7307);
  meth_meth_ast_isAppliedOccurenceOfIdentifier7307->definitionModule = modulename;
  meth_meth_ast_isAppliedOccurenceOfIdentifier7307->definitionLine = 1697;
// method declarationKindWithAncestors
  struct UserObject *uo7316 = (struct UserObject*)obj7291;
  uo7316->data[13] = emptyclosure;
  Method *meth_meth_ast_declarationKindWithAncestors7316 = addmethod2pos(obj7291, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors7316, 13);
  int argcv_meth_ast_declarationKindWithAncestors7316[] = {1};
  meth_meth_ast_declarationKindWithAncestors7316->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors7316);
  meth_meth_ast_declarationKindWithAncestors7316->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors7316->definitionLine = 1704;
// method inTypePositionWithAncestors
  struct UserObject *uo7321 = (struct UserObject*)obj7291;
  uo7321->data[14] = emptyclosure;
  Method *meth_meth_ast_inTypePositionWithAncestors7321 = addmethod2pos(obj7291, "inTypePositionWithAncestors", &meth_ast_inTypePositionWithAncestors7321, 14);
  int argcv_meth_ast_inTypePositionWithAncestors7321[] = {1};
  meth_meth_ast_inTypePositionWithAncestors7321->type = alloc_MethodType(1, argcv_meth_ast_inTypePositionWithAncestors7321);
  meth_meth_ast_inTypePositionWithAncestors7321->definitionModule = modulename;
  meth_meth_ast_inTypePositionWithAncestors7321->definitionLine = 1707;
// method usesAsType
  struct UserObject *uo7330 = (struct UserObject*)obj7291;
  uo7330->data[15] = emptyclosure;
  Method *meth_meth_ast_usesAsType7330 = addmethod2pos(obj7291, "usesAsType", &meth_ast_usesAsType7330, 15);
  int argcv_meth_ast_usesAsType7330[] = {1};
  meth_meth_ast_usesAsType7330->type = alloc_MethodType(1, argcv_meth_ast_usesAsType7330);
  meth_meth_ast_usesAsType7330->definitionModule = modulename;
  meth_meth_ast_usesAsType7330->definitionLine = 1714;
// method accept()from
  struct UserObject *uo7336 = (struct UserObject*)obj7291;
  uo7336->data[16] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from7336 = addmethod2pos(obj7291, "accept()from", &meth_ast_accept_40__41_from7336, 16);
  int argcv_meth_ast_accept_40__41_from7336[] = {1, 1};
  meth_meth_ast_accept_40__41_from7336->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from7336);
  meth_meth_ast_accept_40__41_from7336->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from7336->definitionLine = 1717;
// method map()ancestors
  struct UserObject *uo7353 = (struct UserObject*)obj7291;
  uo7353->data[17] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors7353 = addmethod2pos(obj7291, "map()ancestors", &meth_ast_map_40__41_ancestors7353, 17);
  int argcv_meth_ast_map_40__41_ancestors7353[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors7353->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors7353);
  meth_meth_ast_map_40__41_ancestors7353->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors7353->definitionLine = 1725;
// method pretty
  struct UserObject *uo7370 = (struct UserObject*)obj7291;
  uo7370->data[18] = emptyclosure;
  Method *meth_meth_ast_pretty7370 = addmethod2pos(obj7291, "pretty", &meth_ast_pretty7370, 18);
  int argcv_meth_ast_pretty7370[] = {1};
  meth_meth_ast_pretty7370->type = alloc_MethodType(1, argcv_meth_ast_pretty7370);
  meth_meth_ast_pretty7370->definitionModule = modulename;
  meth_meth_ast_pretty7370->definitionLine = 1731;
// method toGrace
  struct UserObject *uo7501 = (struct UserObject*)obj7291;
  uo7501->data[19] = emptyclosure;
  Method *meth_meth_ast_toGrace7501 = addmethod2pos(obj7291, "toGrace", &meth_ast_toGrace7501, 19);
  int argcv_meth_ast_toGrace7501[] = {1};
  meth_meth_ast_toGrace7501->type = alloc_MethodType(1, argcv_meth_ast_toGrace7501);
meth_meth_ast_toGrace7501->type->types[0] = type_Number;
meth_meth_ast_toGrace7501->type->names[0] = "depth";
  meth_meth_ast_toGrace7501->definitionModule = modulename;
  meth_meth_ast_toGrace7501->definitionLine = 1756;
// method asString
  struct UserObject *uo7594 = (struct UserObject*)obj7291;
  uo7594->data[20] = emptyclosure;
  Method *meth_meth_ast_asString7594 = addmethod2pos(obj7291, "asString", &meth_ast_asString7594, 20);
  int argcv_meth_ast_asString7594[] = {0};
  meth_meth_ast_asString7594->type = alloc_MethodType(1, argcv_meth_ast_asString7594);
  meth_meth_ast_asString7594->definitionModule = modulename;
  meth_meth_ast_asString7594->definitionLine = 1776;
// method shallowCopy
  block_savedest(obj7291);
  Object closure7618 = createclosure(1, "shallowCopy");
  setclosureframe(closure7618, stackframe);
  addtoclosure(closure7618, var_identifierNode);
  struct UserObject *uo7618 = (struct UserObject*)obj7291;
  uo7618->data[21] = (Object)closure7618;
  Method *meth_meth_ast_shallowCopy7618 = addmethod2pos(obj7291, "shallowCopy", &meth_ast_shallowCopy7618, 21);
  int argcv_meth_ast_shallowCopy7618[] = {0};
  meth_meth_ast_shallowCopy7618->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy7618);
  meth_meth_ast_shallowCopy7618->definitionModule = modulename;
  meth_meth_ast_shallowCopy7618->definitionLine = 1783;
// method shallowCopyFieldsFrom
  struct UserObject *uo7626 = (struct UserObject*)obj7291;
  uo7626->data[22] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom7626 = addmethod2pos(obj7291, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom7626, 22);
  int argcv_meth_ast_shallowCopyFieldsFrom7626[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom7626->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom7626);
  meth_meth_ast_shallowCopyFieldsFrom7626->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom7626->definitionLine = 1786;
  sourceObject = obj7291;
// Begin line 1682
  setline(1682);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7649 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_baseNode (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7650 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7649);
// compiled call node returning call7650 (depth = 3)
  struct UserObject *obj7291_uo = (struct UserObject *)obj7291;
  obj7291_uo->super = call7650;
  sourceObject = obj7291;
// Begin line 1683
  setline(1683);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7651 == NULL) {
    strlit7651 = alloc_String("identifier");
    gc_root(strlit7651);
  }
// compiled string node returning strlit7651 (depth = 3)
  adddatum2(obj7291, strlit7651, 1);
  sourceObject = obj7291;
// Begin line 1684
  setline(1684);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name (depth = 3)
  adddatum2(obj7291, *var_name, 2);
  sourceObject = obj7291;
// Begin line 1685
  setline(1685);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7652 = alloc_Boolean(0);
// compiled identifier node returning bool7652 (depth = 3)
  adddatum2(obj7291, bool7652, 3);
  sourceObject = obj7291;
// Begin line 1686
  setline(1686);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj7291, *var_dtype_39_, 4);
  sourceObject = obj7291;
// Begin line 1687
  setline(1687);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7653 = alloc_Boolean(0);
// compiled identifier node returning bool7653 (depth = 3)
  adddatum2(obj7291, bool7653, 5);
  sourceObject = obj7291;
// Begin line 1688
  setline(1688);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7654 = alloc_Boolean(0);
// compiled identifier node returning bool7654 (depth = 3)
  adddatum2(obj7291, bool7654, 6);
  sourceObject = obj7291;
// Begin line 1689
  setline(1689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7655 = alloc_Boolean(0);
// compiled identifier node returning bool7655 (depth = 3)
  adddatum2(obj7291, bool7655, 7);
  sourceObject = obj7291;
// Begin line 1690
  setline(1690);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7656 = alloc_Boolean(0);
// compiled identifier node returning bool7656 (depth = 3)
  adddatum2(obj7291, bool7656, 8);
  sourceObject = obj7291;
// Begin line 1691
  setline(1691);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7657 = alloc_Boolean(0);
// compiled identifier node returning bool7657 (depth = 3)
  adddatum2(obj7291, bool7657, 9);
  sourceObject = obj7291;
  sourceObject = obj7291;
  sourceObject = obj7291;
  sourceObject = obj7291;
  sourceObject = obj7291;
  sourceObject = obj7291;
  sourceObject = obj7291;
  sourceObject = obj7291;
  sourceObject = obj7291;
  sourceObject = obj7291;
  sourceObject = obj7291;
  sourceObject = obj7291;
  sourceObject = obj7291;
  objclass7291 = obj7291->class;
  objclass7291->definitionModule = modulename;
  objclass7291->definitionLine = 1681;
  (*(struct UserObject *)self).data[0] = lowerouter7291;
  self = oldself7291;
  selfslot = oldselfslot7291;
  stackframe = oldstackframe7291;
  gc_frame_end(frame);
  return obj7291;
}
Object meth_ast_identifierNode7659(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 32, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "identifierNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_identifierNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for identifierNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹identifierNode›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1673
  setline(1673);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_identifierNode (depth = 3)
  gc_frame_end(frame);
  return *var_identifierNode;
}
Object meth_ast_typeType7664(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 33, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_typeType = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for typeType (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹typeType›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1798
  setline(1798);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_typeType (depth = 3)
  gc_frame_end(frame);
  return *var_typeType;
}
Object meth_ast_unknownType7668(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 34, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "unknownType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_unknownType = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for unknownType (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹unknownType›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1799
  setline(1799);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_unknownType (depth = 3)
  gc_frame_end(frame);
  return *var_unknownType;
}
Object meth_ast_new_40__41_scope7671(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new()scope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new()scope");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method new()scope");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for new()scope (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *var_s = &(stackframe->slots[1]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for scope");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "result");
// Begin line 1803
  setline(1803);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7672 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_v (depth = 5)
  gc_frame_newslot(*var_v);
// call case 4: self request
  params[0] = *var_v;
  partcv[0] = 1;
  Object call7673 = callmethodflags(self, "new", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7672);
// compiled call node returning call7673 (depth = 4)
  *var_result = call7673;
  if (call7673 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1804
  setline(1804);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 1792
  setline(1792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7674 = gc_frame_new();
// Begin line 1804
  setline(1804);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  gc_frame_newslot(*var_s);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call7675 = callmethod(*var_result, "scope:=",
    1, partcv, params);
  gc_frame_end(callframe7674);
// compiled call node returning call7675 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 1805
  setline(1805);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_accept_40__41_from7681(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1813
  setline(1813);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7682 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_visitor (depth = 4)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7683 = callmethod(*var_visitor, "visitString()up",
    2, partcv, params);
  gc_frame_end(callframe7682);
// compiled call node returning call7683 (depth = 3)
  gc_frame_end(frame);
  return call7683;
}
Object meth_ast_map_40__41_ancestors7684(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1816
  setline(1816);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7685 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7686 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7685);
// compiled call node returning call7686 (depth = 5)
// compiled member node returning call7686 (depth = 4)
  *var_n = call7686;
  if (call7686 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1817
  setline(1817);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7687 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7688 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe7687);
// compiled call node returning call7688 (depth = 4)
  *var_newChain = call7688;
  if (call7688 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1818
  setline(1818);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7689 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call7690 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe7689);
// compiled call node returning call7690 (depth = 3)
  gc_frame_end(frame);
  return call7690;
}
Object meth_ast_pretty7691(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1821
  setline(1821);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7693 == NULL) {
    strlit7693 = alloc_String(")");
    gc_root(strlit7693);
  }
// compiled string node returning strlit7693 (depth = 4)
  int op_slot_right_7692 = gc_frame_newslot(strlit7693);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7696 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7697 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7696);
// compiled call node returning call7697 (depth = 6)
// compiled member node returning call7697 (depth = 5)
  int op_slot_right_7695 = gc_frame_newslot(call7697);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7700 == NULL) {
    strlit7700 = alloc_String("(");
    gc_root(strlit7700);
  }
// compiled string node returning strlit7700 (depth = 6)
  int op_slot_right_7699 = gc_frame_newslot(strlit7700);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7703 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call7704 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe7703);
// compiled call node returning call7704 (depth = 7)
  int op_slot_right_7702 = gc_frame_newslot(call7704);
// starting to compile string node (depth = 7)
  if (strlit7706 == NULL) {
    strlit7706 = alloc_String("");
    gc_root(strlit7706);
  }
// compiled string node returning strlit7706 (depth = 7)
  int op_slot_left_7702 = gc_frame_newslot(strlit7706);
  params[0] = call7704;
  partcv[0] = 1;
  Object opresult7707 = callmethod(strlit7706, "++", 1, partcv, params);
// compiled op node returning opresult7707 (depth = 6)
  int op_slot_left_7699 = gc_frame_newslot(opresult7707);
  params[0] = strlit7700;
  partcv[0] = 1;
  Object opresult7708 = callmethod(opresult7707, "++", 1, partcv, params);
// compiled op node returning opresult7708 (depth = 5)
  int op_slot_left_7695 = gc_frame_newslot(opresult7708);
  params[0] = call7697;
  partcv[0] = 1;
  Object opresult7709 = callmethod(opresult7708, "++", 1, partcv, params);
// compiled op node returning opresult7709 (depth = 4)
  int op_slot_left_7692 = gc_frame_newslot(opresult7709);
  params[0] = strlit7693;
  partcv[0] = 1;
  Object opresult7710 = callmethod(opresult7709, "++", 1, partcv, params);
// compiled op node returning opresult7710 (depth = 3)
  gc_frame_end(frame);
  return opresult7710;
}
Object meth_ast__apply7717(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1827
  setline(1827);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7720 == NULL) {
    strlit7720 = alloc_String("""\x0a""");
    gc_root(strlit7720);
  }
// compiled string node returning strlit7720 (depth = 7)
  int op_slot_right_7719 = gc_frame_newslot(strlit7720);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_c (depth = 7)
  int op_slot_left_7719 = gc_frame_newslot(*var_c);
  params[0] = strlit7720;
  partcv[0] = 1;
  Object opresult7722 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult7722 (depth = 6)
  Object if7718 = done;
  if (istrue(opresult7722)) {
// Begin line 1828
  setline(1828);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit7724 == NULL) {
    strlit7724 = alloc_String("\\n");
    gc_root(strlit7724);
  }
// compiled string node returning strlit7724 (depth = 8)
  int op_slot_right_7723 = gc_frame_newslot(strlit7724);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_7723 = gc_frame_newslot(*var_s);
  params[0] = strlit7724;
  partcv[0] = 1;
  Object opresult7726 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7726 (depth = 7)
  *var_s = opresult7726;
  if (opresult7726 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if7718 = done;
  } else {
// Begin line 1831
  setline(1831);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1829
  setline(1829);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit7730 == NULL) {
    strlit7730 = alloc_String("""\x09""");
    gc_root(strlit7730);
  }
// compiled string node returning strlit7730 (depth = 8)
  int op_slot_right_7729 = gc_frame_newslot(strlit7730);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  int op_slot_left_7729 = gc_frame_newslot(*var_c);
  params[0] = strlit7730;
  partcv[0] = 1;
  Object opresult7732 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult7732 (depth = 7)
  Object if7728 = done;
  if (istrue(opresult7732)) {
// Begin line 1830
  setline(1830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit7734 == NULL) {
    strlit7734 = alloc_String("\\t");
    gc_root(strlit7734);
  }
// compiled string node returning strlit7734 (depth = 9)
  int op_slot_right_7733 = gc_frame_newslot(strlit7734);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_7733 = gc_frame_newslot(*var_s);
  params[0] = strlit7734;
  partcv[0] = 1;
  Object opresult7736 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7736 (depth = 8)
  *var_s = opresult7736;
  if (opresult7736 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if7728 = done;
  } else {
// Begin line 1833
  setline(1833);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 1831
  setline(1831);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit7740 == NULL) {
    strlit7740 = alloc_String("""\x22""");
    gc_root(strlit7740);
  }
// compiled string node returning strlit7740 (depth = 9)
  int op_slot_right_7739 = gc_frame_newslot(strlit7740);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_c (depth = 9)
  int op_slot_left_7739 = gc_frame_newslot(*var_c);
  params[0] = strlit7740;
  partcv[0] = 1;
  Object opresult7742 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult7742 (depth = 8)
  Object if7738 = done;
  if (istrue(opresult7742)) {
// Begin line 1832
  setline(1832);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit7744 == NULL) {
    strlit7744 = alloc_String("\\""\x22""");
    gc_root(strlit7744);
  }
// compiled string node returning strlit7744 (depth = 10)
  int op_slot_right_7743 = gc_frame_newslot(strlit7744);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_7743 = gc_frame_newslot(*var_s);
  params[0] = strlit7744;
  partcv[0] = 1;
  Object opresult7746 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7746 (depth = 9)
  *var_s = opresult7746;
  if (opresult7746 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if7738 = done;
  } else {
// Begin line 1835
  setline(1835);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 1833
  setline(1833);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit7750 == NULL) {
    strlit7750 = alloc_String("\\");
    gc_root(strlit7750);
  }
// compiled string node returning strlit7750 (depth = 10)
  int op_slot_right_7749 = gc_frame_newslot(strlit7750);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_c (depth = 10)
  int op_slot_left_7749 = gc_frame_newslot(*var_c);
  params[0] = strlit7750;
  partcv[0] = 1;
  Object opresult7752 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult7752 (depth = 9)
  Object if7748 = done;
  if (istrue(opresult7752)) {
// Begin line 1834
  setline(1834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit7754 == NULL) {
    strlit7754 = alloc_String("\\\\");
    gc_root(strlit7754);
  }
// compiled string node returning strlit7754 (depth = 11)
  int op_slot_right_7753 = gc_frame_newslot(strlit7754);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_7753 = gc_frame_newslot(*var_s);
  params[0] = strlit7754;
  partcv[0] = 1;
  Object opresult7756 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7756 (depth = 10)
  *var_s = opresult7756;
  if (opresult7756 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if7748 = done;
  } else {
// Begin line 1836
  setline(1836);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_c (depth = 11)
  int op_slot_right_7758 = gc_frame_newslot(*var_c);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_7758 = gc_frame_newslot(*var_s);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult7760 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7760 (depth = 10)
  *var_s = opresult7760;
  if (opresult7760 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if7748 = done;
  }
// compiled if node returning if7748 (depth = 8)
    gc_frame_newslot(if7748);
    if7738 = if7748;
  }
// compiled if node returning if7738 (depth = 7)
    gc_frame_newslot(if7738);
    if7728 = if7738;
  }
// compiled if node returning if7728 (depth = 6)
    gc_frame_newslot(if7728);
    if7718 = if7728;
  }
// compiled if node returning if7718 (depth = 5)
  gc_frame_end(frame);
  return if7718;
}
Object meth_ast_toGrace7711(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1824
  setline(1824);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7712 == NULL) {
    strlit7712 = alloc_String("""\x22""");
    gc_root(strlit7712);
  }
// compiled string node returning strlit7712 (depth = 4)
  *var_s = strlit7712;
  if (strlit7712 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1825
  setline(1825);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7713 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7714 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7715 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7714);
// compiled call node returning call7715 (depth = 5)
// compiled member node returning call7715 (depth = 4)
  gc_frame_newslot(call7715);
// starting to compile block node (depth = 4)
  Object block7716 = alloc_Block(NULL, NULL, "ast", 1825);
  gc_frame_newslot(block7716);
// method _apply
  block_savedest(block7716);
  Object closure7717 = createclosure(2, "_apply");
  setclosureframe(closure7717, stackframe);
  addtoclosure(closure7717, var_s);
  addtoclosure(closure7717, selfslot);
  struct UserObject *uo7717 = (struct UserObject*)block7716;
  uo7717->data[0] = (Object)closure7717;
  Method *meth_meth_ast__apply7717 = addmethod2pos(block7716, "_apply", &meth_ast__apply7717, 0);
  int argcv_meth_ast__apply7717[] = {1};
  meth_meth_ast__apply7717->type = alloc_MethodType(1, argcv_meth_ast__apply7717);
  meth_meth_ast__apply7717->definitionModule = modulename;
  meth_meth_ast__apply7717->definitionLine = 1825;
// compiled block node returning block7716 (depth = 4)
  gc_frame_newslot(block7716);
// call case 5: prelude request
  params[0] = call7715;
  params[1] = block7716;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7763 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7713);
// compiled call node returning call7763 (depth = 3)
// Begin line 1839
  setline(1839);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7765 == NULL) {
    strlit7765 = alloc_String("""\x22""");
    gc_root(strlit7765);
  }
// compiled string node returning strlit7765 (depth = 5)
  int op_slot_right_7764 = gc_frame_newslot(strlit7765);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_7764 = gc_frame_newslot(*var_s);
  params[0] = strlit7765;
  partcv[0] = 1;
  Object opresult7767 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7767 (depth = 4)
  *var_s = opresult7767;
  if (opresult7767 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1840
  setline(1840);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy7769(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_stringNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1843
  setline(1843);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7770 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe7771 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7772 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7773 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7772);
// compiled call node returning call7773 (depth = 6)
// compiled member node returning call7773 (depth = 5)
  gc_frame_newslot(call7773);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_stringNode (depth = 5)
  params[0] = call7773;
  partcv[0] = 1;
  Object call7774 = callmethod(*var_stringNode, "new",
    1, partcv, params);
  gc_frame_end(callframe7771);
// compiled call node returning call7774 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call7775 = callmethod(call7774, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe7770);
// compiled call node returning call7775 (depth = 3)
  gc_frame_end(frame);
  return call7775;
}
Object meth_ast_new7676(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_stringNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7677 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7677 = alloc_userobj2(9,9, objclass7677);
  gc_frame_newslot(obj7677);
if (objclass7677 == NULL) {
  glfree(obj7677->class->name);
  obj7677->class->name = "obj7669.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7677, self, 0);
  addmethodreal(obj7677,"outer", &reader_ast_outer_7678);
  Object oldself7677 = self;
  struct StackFrameObject *oldstackframe7677 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7677);
  gc_frame_newslot((Object)stackframe);
  self = obj7677;
  Object *oldselfslot7677 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7677 = (*(struct UserObject *)self).data[0], lowerouter7677 = thisouter7677;
  if (inheritingObject7677) {
    struct UserObject *inho7677 = (struct UserObject *)inheritingObject7677;
    while (inho7677->super != GraceDefaultObject) inho7677 = (struct UserObject *)inho7677->super;
    inho7677->super = obj7677;
    self = inheritingObject7677;
    *selfslot = self;
    lowerouter7677 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7677;
  }
if (objclass7677 == NULL) {
  Method *reader7679 = addmethodrealflags(obj7677, "kind",&reader_ast_kind_7679, MFLAG_DEF);
  reader7679->definitionModule = modulename;
  reader7679->definitionLine = 1810;
}
adddatum2(obj7677, alloc_Undefined(), 1);
if (objclass7677 == NULL) {
  Method *reader7680 = addmethodrealflags(obj7677, "value",&reader_ast_value_7680, 0);
  Method *writer7680 = addmethodrealflags(obj7677, "value:=",&writer_ast_value_7680, 0);
  reader7680->definitionModule = modulename;
  writer7680->definitionModule = modulename;
  reader7680->definitionLine = 1811;
  writer7680->definitionLine = 1811;
}
obj7677->flags |= OFLAG_MUTABLE;
adddatum2(obj7677, alloc_Undefined(), 2);
// method accept()from
  struct UserObject *uo7681 = (struct UserObject*)obj7677;
  uo7681->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from7681 = addmethod2pos(obj7677, "accept()from", &meth_ast_accept_40__41_from7681, 3);
  int argcv_meth_ast_accept_40__41_from7681[] = {1, 1};
  meth_meth_ast_accept_40__41_from7681->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from7681);
  meth_meth_ast_accept_40__41_from7681->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from7681->definitionLine = 1812;
// method map()ancestors
  struct UserObject *uo7684 = (struct UserObject*)obj7677;
  uo7684->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors7684 = addmethod2pos(obj7677, "map()ancestors", &meth_ast_map_40__41_ancestors7684, 4);
  int argcv_meth_ast_map_40__41_ancestors7684[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors7684->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors7684);
  meth_meth_ast_map_40__41_ancestors7684->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors7684->definitionLine = 1815;
// method pretty
  struct UserObject *uo7691 = (struct UserObject*)obj7677;
  uo7691->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty7691 = addmethod2pos(obj7677, "pretty", &meth_ast_pretty7691, 5);
  int argcv_meth_ast_pretty7691[] = {1};
  meth_meth_ast_pretty7691->type = alloc_MethodType(1, argcv_meth_ast_pretty7691);
  meth_meth_ast_pretty7691->definitionModule = modulename;
  meth_meth_ast_pretty7691->definitionLine = 1820;
// method toGrace
  struct UserObject *uo7711 = (struct UserObject*)obj7677;
  uo7711->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace7711 = addmethod2pos(obj7677, "toGrace", &meth_ast_toGrace7711, 6);
  int argcv_meth_ast_toGrace7711[] = {1};
  meth_meth_ast_toGrace7711->type = alloc_MethodType(1, argcv_meth_ast_toGrace7711);
meth_meth_ast_toGrace7711->type->types[0] = type_Number;
meth_meth_ast_toGrace7711->type->names[0] = "depth";
  meth_meth_ast_toGrace7711->definitionModule = modulename;
  meth_meth_ast_toGrace7711->definitionLine = 1823;
// method shallowCopy
  block_savedest(obj7677);
  Object closure7769 = createclosure(1, "shallowCopy");
  setclosureframe(closure7769, stackframe);
  addtoclosure(closure7769, var_stringNode);
  struct UserObject *uo7769 = (struct UserObject*)obj7677;
  uo7769->data[7] = (Object)closure7769;
  Method *meth_meth_ast_shallowCopy7769 = addmethod2pos(obj7677, "shallowCopy", &meth_ast_shallowCopy7769, 7);
  int argcv_meth_ast_shallowCopy7769[] = {0};
  meth_meth_ast_shallowCopy7769->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy7769);
  meth_meth_ast_shallowCopy7769->definitionModule = modulename;
  meth_meth_ast_shallowCopy7769->definitionLine = 1842;
  sourceObject = obj7677;
// Begin line 1809
  setline(1809);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7776 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_baseNode (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7777 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7776);
// compiled call node returning call7777 (depth = 3)
  struct UserObject *obj7677_uo = (struct UserObject *)obj7677;
  obj7677_uo->super = call7777;
  sourceObject = obj7677;
// Begin line 1810
  setline(1810);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7778 == NULL) {
    strlit7778 = alloc_String("string");
    gc_root(strlit7778);
  }
// compiled string node returning strlit7778 (depth = 3)
  adddatum2(obj7677, strlit7778, 1);
  sourceObject = obj7677;
// Begin line 1811
  setline(1811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_v (depth = 3)
  adddatum2(obj7677, *var_v, 2);
  sourceObject = obj7677;
  sourceObject = obj7677;
  sourceObject = obj7677;
  sourceObject = obj7677;
  sourceObject = obj7677;
  objclass7677 = obj7677->class;
  objclass7677->definitionModule = modulename;
  objclass7677->definitionLine = 1808;
  (*(struct UserObject *)self).data[0] = lowerouter7677;
  self = oldself7677;
  selfslot = oldselfslot7677;
  stackframe = oldstackframe7677;
  gc_frame_end(frame);
  return obj7677;
}
Object meth_ast_new7676_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_stringNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7677 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7677 = alloc_userobj2(9,9, objclass7677);
  gc_frame_newslot(obj7677);
if (objclass7677 == NULL) {
  glfree(obj7677->class->name);
  obj7677->class->name = "obj7669.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7677, self, 0);
  addmethodreal(obj7677,"outer", &reader_ast_outer_7678);
  Object oldself7677 = self;
  struct StackFrameObject *oldstackframe7677 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7677);
  gc_frame_newslot((Object)stackframe);
  self = obj7677;
  Object *oldselfslot7677 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7677 = (*(struct UserObject *)self).data[0], lowerouter7677 = thisouter7677;
  if (inheritingObject7677) {
    struct UserObject *inho7677 = (struct UserObject *)inheritingObject7677;
    while (inho7677->super != GraceDefaultObject) inho7677 = (struct UserObject *)inho7677->super;
    inho7677->super = obj7677;
    self = inheritingObject7677;
    *selfslot = self;
    lowerouter7677 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7677;
  }
if (objclass7677 == NULL) {
  Method *reader7679 = addmethodrealflags(obj7677, "kind",&reader_ast_kind_7679, MFLAG_DEF);
  reader7679->definitionModule = modulename;
  reader7679->definitionLine = 1810;
}
adddatum2(obj7677, alloc_Undefined(), 1);
if (objclass7677 == NULL) {
  Method *reader7680 = addmethodrealflags(obj7677, "value",&reader_ast_value_7680, 0);
  Method *writer7680 = addmethodrealflags(obj7677, "value:=",&writer_ast_value_7680, 0);
  reader7680->definitionModule = modulename;
  writer7680->definitionModule = modulename;
  reader7680->definitionLine = 1811;
  writer7680->definitionLine = 1811;
}
obj7677->flags |= OFLAG_MUTABLE;
adddatum2(obj7677, alloc_Undefined(), 2);
// method accept()from
  struct UserObject *uo7681 = (struct UserObject*)obj7677;
  uo7681->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from7681 = addmethod2pos(obj7677, "accept()from", &meth_ast_accept_40__41_from7681, 3);
  int argcv_meth_ast_accept_40__41_from7681[] = {1, 1};
  meth_meth_ast_accept_40__41_from7681->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from7681);
  meth_meth_ast_accept_40__41_from7681->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from7681->definitionLine = 1812;
// method map()ancestors
  struct UserObject *uo7684 = (struct UserObject*)obj7677;
  uo7684->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors7684 = addmethod2pos(obj7677, "map()ancestors", &meth_ast_map_40__41_ancestors7684, 4);
  int argcv_meth_ast_map_40__41_ancestors7684[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors7684->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors7684);
  meth_meth_ast_map_40__41_ancestors7684->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors7684->definitionLine = 1815;
// method pretty
  struct UserObject *uo7691 = (struct UserObject*)obj7677;
  uo7691->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty7691 = addmethod2pos(obj7677, "pretty", &meth_ast_pretty7691, 5);
  int argcv_meth_ast_pretty7691[] = {1};
  meth_meth_ast_pretty7691->type = alloc_MethodType(1, argcv_meth_ast_pretty7691);
  meth_meth_ast_pretty7691->definitionModule = modulename;
  meth_meth_ast_pretty7691->definitionLine = 1820;
// method toGrace
  struct UserObject *uo7711 = (struct UserObject*)obj7677;
  uo7711->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace7711 = addmethod2pos(obj7677, "toGrace", &meth_ast_toGrace7711, 6);
  int argcv_meth_ast_toGrace7711[] = {1};
  meth_meth_ast_toGrace7711->type = alloc_MethodType(1, argcv_meth_ast_toGrace7711);
meth_meth_ast_toGrace7711->type->types[0] = type_Number;
meth_meth_ast_toGrace7711->type->names[0] = "depth";
  meth_meth_ast_toGrace7711->definitionModule = modulename;
  meth_meth_ast_toGrace7711->definitionLine = 1823;
// method shallowCopy
  block_savedest(obj7677);
  Object closure7769 = createclosure(1, "shallowCopy");
  setclosureframe(closure7769, stackframe);
  addtoclosure(closure7769, var_stringNode);
  struct UserObject *uo7769 = (struct UserObject*)obj7677;
  uo7769->data[7] = (Object)closure7769;
  Method *meth_meth_ast_shallowCopy7769 = addmethod2pos(obj7677, "shallowCopy", &meth_ast_shallowCopy7769, 7);
  int argcv_meth_ast_shallowCopy7769[] = {0};
  meth_meth_ast_shallowCopy7769->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy7769);
  meth_meth_ast_shallowCopy7769->definitionModule = modulename;
  meth_meth_ast_shallowCopy7769->definitionLine = 1842;
  sourceObject = obj7677;
// Begin line 1809
  setline(1809);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7776 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_baseNode (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7777 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7776);
// compiled call node returning call7777 (depth = 3)
  struct UserObject *obj7677_uo = (struct UserObject *)obj7677;
  obj7677_uo->super = call7777;
  sourceObject = obj7677;
// Begin line 1810
  setline(1810);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7778 == NULL) {
    strlit7778 = alloc_String("string");
    gc_root(strlit7778);
  }
// compiled string node returning strlit7778 (depth = 3)
  adddatum2(obj7677, strlit7778, 1);
  sourceObject = obj7677;
// Begin line 1811
  setline(1811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_v (depth = 3)
  adddatum2(obj7677, *var_v, 2);
  sourceObject = obj7677;
  sourceObject = obj7677;
  sourceObject = obj7677;
  sourceObject = obj7677;
  sourceObject = obj7677;
  objclass7677 = obj7677->class;
  objclass7677->definitionModule = modulename;
  objclass7677->definitionLine = 1808;
  (*(struct UserObject *)self).data[0] = lowerouter7677;
  self = oldself7677;
  selfslot = oldselfslot7677;
  stackframe = oldstackframe7677;
  gc_frame_end(frame);
  return obj7677;
}
Object meth_ast_stringNode7780(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 35, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "stringNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_stringNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for stringNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹stringNode›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1801
  setline(1801);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_stringNode (depth = 3)
  gc_frame_end(frame);
  return *var_stringNode;
}
Object meth_ast_numNode7781(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 36, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "numNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_numNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for numNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for numNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_numNode (depth = 3)
  gc_frame_end(frame);
  return *var_numNode;
}
Object meth_ast_accept_40__41_from7789(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1852
  setline(1852);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7790 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7791 = callmethod(*var_visitor, "visitNum()up",
    2, partcv, params);
  gc_frame_end(callframe7790);
// compiled call node returning call7791 (depth = 4)
  gc_frame_end(frame);
  return call7791;
}
Object meth_ast_map_40__41_ancestors7792(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1855
  setline(1855);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7793 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7794 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7793);
// compiled call node returning call7794 (depth = 6)
// compiled member node returning call7794 (depth = 5)
  *var_n = call7794;
  if (call7794 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1856
  setline(1856);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7795 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7796 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe7795);
// compiled call node returning call7796 (depth = 5)
  *var_newChain = call7796;
  if (call7796 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1857
  setline(1857);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7797 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call7798 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe7797);
// compiled call node returning call7798 (depth = 4)
  gc_frame_end(frame);
  return call7798;
}
Object meth_ast_pretty7799(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1860
  setline(1860);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7801 == NULL) {
    strlit7801 = alloc_String(")");
    gc_root(strlit7801);
  }
// compiled string node returning strlit7801 (depth = 5)
  int op_slot_right_7800 = gc_frame_newslot(strlit7801);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7804 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7805 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7804);
// compiled call node returning call7805 (depth = 7)
// compiled member node returning call7805 (depth = 6)
  int op_slot_right_7803 = gc_frame_newslot(call7805);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7808 == NULL) {
    strlit7808 = alloc_String("(");
    gc_root(strlit7808);
  }
// compiled string node returning strlit7808 (depth = 7)
  int op_slot_right_7807 = gc_frame_newslot(strlit7808);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7811 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call7812 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe7811);
// compiled call node returning call7812 (depth = 8)
  int op_slot_right_7810 = gc_frame_newslot(call7812);
// starting to compile string node (depth = 8)
  if (strlit7814 == NULL) {
    strlit7814 = alloc_String("");
    gc_root(strlit7814);
  }
// compiled string node returning strlit7814 (depth = 8)
  int op_slot_left_7810 = gc_frame_newslot(strlit7814);
  params[0] = call7812;
  partcv[0] = 1;
  Object opresult7815 = callmethod(strlit7814, "++", 1, partcv, params);
// compiled op node returning opresult7815 (depth = 7)
  int op_slot_left_7807 = gc_frame_newslot(opresult7815);
  params[0] = strlit7808;
  partcv[0] = 1;
  Object opresult7816 = callmethod(opresult7815, "++", 1, partcv, params);
// compiled op node returning opresult7816 (depth = 6)
  int op_slot_left_7803 = gc_frame_newslot(opresult7816);
  params[0] = call7805;
  partcv[0] = 1;
  Object opresult7817 = callmethod(opresult7816, "++", 1, partcv, params);
// compiled op node returning opresult7817 (depth = 5)
  int op_slot_left_7800 = gc_frame_newslot(opresult7817);
  params[0] = strlit7801;
  partcv[0] = 1;
  Object opresult7818 = callmethod(opresult7817, "++", 1, partcv, params);
// compiled op node returning opresult7818 (depth = 4)
  gc_frame_end(frame);
  return opresult7818;
}
Object meth_ast_toGrace7819(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1863
  setline(1863);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7820 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7821 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7822 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7821);
// compiled call node returning call7822 (depth = 7)
// compiled member node returning call7822 (depth = 6)
  partcv[0] = 0;
  Object call7823 = callmethod(call7822, "asString",
    1, partcv, params);
  gc_frame_end(callframe7820);
// compiled call node returning call7823 (depth = 5)
// compiled member node returning call7823 (depth = 4)
  gc_frame_end(frame);
  return call7823;
}
Object meth_ast_asString7824(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1865
  setline(1865);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7826 == NULL) {
    strlit7826 = alloc_String("");
    gc_root(strlit7826);
  }
// compiled string node returning strlit7826 (depth = 5)
  int op_slot_right_7825 = gc_frame_newslot(strlit7826);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7829 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7830 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7829);
// compiled call node returning call7830 (depth = 7)
// compiled member node returning call7830 (depth = 6)
  int op_slot_right_7828 = gc_frame_newslot(call7830);
// starting to compile string node (depth = 6)
  if (strlit7832 == NULL) {
    strlit7832 = alloc_String("num ");
    gc_root(strlit7832);
  }
// compiled string node returning strlit7832 (depth = 6)
  int op_slot_left_7828 = gc_frame_newslot(strlit7832);
  params[0] = call7830;
  partcv[0] = 1;
  Object opresult7833 = callmethod(strlit7832, "++", 1, partcv, params);
// compiled op node returning opresult7833 (depth = 5)
  int op_slot_left_7825 = gc_frame_newslot(opresult7833);
  params[0] = strlit7826;
  partcv[0] = 1;
  Object opresult7834 = callmethod(opresult7833, "++", 1, partcv, params);
// compiled op node returning opresult7834 (depth = 4)
  gc_frame_end(frame);
  return opresult7834;
}
Object meth_ast_shallowCopy7835(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_numNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1867
  setline(1867);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7836 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe7837 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7838 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7839 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7838);
// compiled call node returning call7839 (depth = 7)
// compiled member node returning call7839 (depth = 6)
  gc_frame_newslot(call7839);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_numNode (depth = 6)
  params[0] = call7839;
  partcv[0] = 1;
  Object call7840 = callmethod(*var_numNode, "new",
    1, partcv, params);
  gc_frame_end(callframe7837);
// compiled call node returning call7840 (depth = 5)
  params[0] = self;
  partcv[0] = 1;
  Object call7841 = callmethod(call7840, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe7836);
// compiled call node returning call7841 (depth = 4)
  gc_frame_end(frame);
  return call7841;
}
Object meth_ast_new7784(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_numNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_val = &(stackframe->slots[0]);
  *var_val = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7785 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7785 = alloc_userobj2(10,10, objclass7785);
  gc_frame_newslot(obj7785);
if (objclass7785 == NULL) {
  glfree(obj7785->class->name);
  obj7785->class->name = "numNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7785, self, 0);
  addmethodreal(obj7785,"outer", &reader_ast_outer_7786);
  Object oldself7785 = self;
  struct StackFrameObject *oldstackframe7785 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7785);
  gc_frame_newslot((Object)stackframe);
  self = obj7785;
  Object *oldselfslot7785 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7785 = (*(struct UserObject *)self).data[0], lowerouter7785 = thisouter7785;
  if (inheritingObject7785) {
    struct UserObject *inho7785 = (struct UserObject *)inheritingObject7785;
    while (inho7785->super != GraceDefaultObject) inho7785 = (struct UserObject *)inho7785->super;
    inho7785->super = obj7785;
    self = inheritingObject7785;
    *selfslot = self;
    lowerouter7785 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7785;
  }
if (objclass7785 == NULL) {
  Method *reader7787 = addmethodrealflags(obj7785, "kind",&reader_ast_kind_7787, MFLAG_DEF);
  reader7787->definitionModule = modulename;
  reader7787->definitionLine = 1849;
}
adddatum2(obj7785, alloc_Undefined(), 1);
if (objclass7785 == NULL) {
  Method *reader7788 = addmethodrealflags(obj7785, "value",&reader_ast_value_7788, 0);
  Method *writer7788 = addmethodrealflags(obj7785, "value:=",&writer_ast_value_7788, 0);
  reader7788->definitionModule = modulename;
  writer7788->definitionModule = modulename;
  reader7788->definitionLine = 1850;
  writer7788->definitionLine = 1850;
}
obj7785->flags |= OFLAG_MUTABLE;
adddatum2(obj7785, alloc_Undefined(), 2);
// method accept()from
  struct UserObject *uo7789 = (struct UserObject*)obj7785;
  uo7789->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from7789 = addmethod2pos(obj7785, "accept()from", &meth_ast_accept_40__41_from7789, 3);
  int argcv_meth_ast_accept_40__41_from7789[] = {1, 1};
  meth_meth_ast_accept_40__41_from7789->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from7789);
  meth_meth_ast_accept_40__41_from7789->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from7789->definitionLine = 1851;
// method map()ancestors
  struct UserObject *uo7792 = (struct UserObject*)obj7785;
  uo7792->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors7792 = addmethod2pos(obj7785, "map()ancestors", &meth_ast_map_40__41_ancestors7792, 4);
  int argcv_meth_ast_map_40__41_ancestors7792[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors7792->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors7792);
  meth_meth_ast_map_40__41_ancestors7792->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors7792->definitionLine = 1854;
// method pretty
  struct UserObject *uo7799 = (struct UserObject*)obj7785;
  uo7799->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty7799 = addmethod2pos(obj7785, "pretty", &meth_ast_pretty7799, 5);
  int argcv_meth_ast_pretty7799[] = {1};
  meth_meth_ast_pretty7799->type = alloc_MethodType(1, argcv_meth_ast_pretty7799);
  meth_meth_ast_pretty7799->definitionModule = modulename;
  meth_meth_ast_pretty7799->definitionLine = 1859;
// method toGrace
  struct UserObject *uo7819 = (struct UserObject*)obj7785;
  uo7819->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace7819 = addmethod2pos(obj7785, "toGrace", &meth_ast_toGrace7819, 6);
  int argcv_meth_ast_toGrace7819[] = {1};
  meth_meth_ast_toGrace7819->type = alloc_MethodType(1, argcv_meth_ast_toGrace7819);
meth_meth_ast_toGrace7819->type->types[0] = type_Number;
meth_meth_ast_toGrace7819->type->names[0] = "depth";
  meth_meth_ast_toGrace7819->definitionModule = modulename;
  meth_meth_ast_toGrace7819->definitionLine = 1862;
// method asString
  struct UserObject *uo7824 = (struct UserObject*)obj7785;
  uo7824->data[7] = emptyclosure;
  Method *meth_meth_ast_asString7824 = addmethod2pos(obj7785, "asString", &meth_ast_asString7824, 7);
  int argcv_meth_ast_asString7824[] = {0};
  meth_meth_ast_asString7824->type = alloc_MethodType(1, argcv_meth_ast_asString7824);
  meth_meth_ast_asString7824->definitionModule = modulename;
  meth_meth_ast_asString7824->definitionLine = 1865;
// method shallowCopy
  block_savedest(obj7785);
  Object closure7835 = createclosure(1, "shallowCopy");
  setclosureframe(closure7835, stackframe);
  addtoclosure(closure7835, var_numNode);
  struct UserObject *uo7835 = (struct UserObject*)obj7785;
  uo7835->data[8] = (Object)closure7835;
  Method *meth_meth_ast_shallowCopy7835 = addmethod2pos(obj7785, "shallowCopy", &meth_ast_shallowCopy7835, 8);
  int argcv_meth_ast_shallowCopy7835[] = {0};
  meth_meth_ast_shallowCopy7835->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy7835);
  meth_meth_ast_shallowCopy7835->definitionModule = modulename;
  meth_meth_ast_shallowCopy7835->definitionLine = 1866;
  sourceObject = obj7785;
// Begin line 1848
  setline(1848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7842 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7843 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7842);
// compiled call node returning call7843 (depth = 4)
  struct UserObject *obj7785_uo = (struct UserObject *)obj7785;
  obj7785_uo->super = call7843;
  sourceObject = obj7785;
// Begin line 1849
  setline(1849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit7844 == NULL) {
    strlit7844 = alloc_String("num");
    gc_root(strlit7844);
  }
// compiled string node returning strlit7844 (depth = 4)
  adddatum2(obj7785, strlit7844, 1);
  sourceObject = obj7785;
// Begin line 1850
  setline(1850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_val (depth = 4)
  adddatum2(obj7785, *var_val, 2);
  sourceObject = obj7785;
  sourceObject = obj7785;
  sourceObject = obj7785;
  sourceObject = obj7785;
  sourceObject = obj7785;
  sourceObject = obj7785;
  objclass7785 = obj7785->class;
  objclass7785->definitionModule = modulename;
  objclass7785->definitionLine = 1847;
  (*(struct UserObject *)self).data[0] = lowerouter7785;
  self = oldself7785;
  selfslot = oldselfslot7785;
  stackframe = oldstackframe7785;
  gc_frame_end(frame);
  return obj7785;
}
Object meth_ast_new7784_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_numNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_val = &(stackframe->slots[0]);
  *var_val = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7785 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7785 = alloc_userobj2(10,10, objclass7785);
  gc_frame_newslot(obj7785);
if (objclass7785 == NULL) {
  glfree(obj7785->class->name);
  obj7785->class->name = "numNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7785, self, 0);
  addmethodreal(obj7785,"outer", &reader_ast_outer_7786);
  Object oldself7785 = self;
  struct StackFrameObject *oldstackframe7785 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7785);
  gc_frame_newslot((Object)stackframe);
  self = obj7785;
  Object *oldselfslot7785 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7785 = (*(struct UserObject *)self).data[0], lowerouter7785 = thisouter7785;
  if (inheritingObject7785) {
    struct UserObject *inho7785 = (struct UserObject *)inheritingObject7785;
    while (inho7785->super != GraceDefaultObject) inho7785 = (struct UserObject *)inho7785->super;
    inho7785->super = obj7785;
    self = inheritingObject7785;
    *selfslot = self;
    lowerouter7785 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7785;
  }
if (objclass7785 == NULL) {
  Method *reader7787 = addmethodrealflags(obj7785, "kind",&reader_ast_kind_7787, MFLAG_DEF);
  reader7787->definitionModule = modulename;
  reader7787->definitionLine = 1849;
}
adddatum2(obj7785, alloc_Undefined(), 1);
if (objclass7785 == NULL) {
  Method *reader7788 = addmethodrealflags(obj7785, "value",&reader_ast_value_7788, 0);
  Method *writer7788 = addmethodrealflags(obj7785, "value:=",&writer_ast_value_7788, 0);
  reader7788->definitionModule = modulename;
  writer7788->definitionModule = modulename;
  reader7788->definitionLine = 1850;
  writer7788->definitionLine = 1850;
}
obj7785->flags |= OFLAG_MUTABLE;
adddatum2(obj7785, alloc_Undefined(), 2);
// method accept()from
  struct UserObject *uo7789 = (struct UserObject*)obj7785;
  uo7789->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from7789 = addmethod2pos(obj7785, "accept()from", &meth_ast_accept_40__41_from7789, 3);
  int argcv_meth_ast_accept_40__41_from7789[] = {1, 1};
  meth_meth_ast_accept_40__41_from7789->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from7789);
  meth_meth_ast_accept_40__41_from7789->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from7789->definitionLine = 1851;
// method map()ancestors
  struct UserObject *uo7792 = (struct UserObject*)obj7785;
  uo7792->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors7792 = addmethod2pos(obj7785, "map()ancestors", &meth_ast_map_40__41_ancestors7792, 4);
  int argcv_meth_ast_map_40__41_ancestors7792[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors7792->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors7792);
  meth_meth_ast_map_40__41_ancestors7792->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors7792->definitionLine = 1854;
// method pretty
  struct UserObject *uo7799 = (struct UserObject*)obj7785;
  uo7799->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty7799 = addmethod2pos(obj7785, "pretty", &meth_ast_pretty7799, 5);
  int argcv_meth_ast_pretty7799[] = {1};
  meth_meth_ast_pretty7799->type = alloc_MethodType(1, argcv_meth_ast_pretty7799);
  meth_meth_ast_pretty7799->definitionModule = modulename;
  meth_meth_ast_pretty7799->definitionLine = 1859;
// method toGrace
  struct UserObject *uo7819 = (struct UserObject*)obj7785;
  uo7819->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace7819 = addmethod2pos(obj7785, "toGrace", &meth_ast_toGrace7819, 6);
  int argcv_meth_ast_toGrace7819[] = {1};
  meth_meth_ast_toGrace7819->type = alloc_MethodType(1, argcv_meth_ast_toGrace7819);
meth_meth_ast_toGrace7819->type->types[0] = type_Number;
meth_meth_ast_toGrace7819->type->names[0] = "depth";
  meth_meth_ast_toGrace7819->definitionModule = modulename;
  meth_meth_ast_toGrace7819->definitionLine = 1862;
// method asString
  struct UserObject *uo7824 = (struct UserObject*)obj7785;
  uo7824->data[7] = emptyclosure;
  Method *meth_meth_ast_asString7824 = addmethod2pos(obj7785, "asString", &meth_ast_asString7824, 7);
  int argcv_meth_ast_asString7824[] = {0};
  meth_meth_ast_asString7824->type = alloc_MethodType(1, argcv_meth_ast_asString7824);
  meth_meth_ast_asString7824->definitionModule = modulename;
  meth_meth_ast_asString7824->definitionLine = 1865;
// method shallowCopy
  block_savedest(obj7785);
  Object closure7835 = createclosure(1, "shallowCopy");
  setclosureframe(closure7835, stackframe);
  addtoclosure(closure7835, var_numNode);
  struct UserObject *uo7835 = (struct UserObject*)obj7785;
  uo7835->data[8] = (Object)closure7835;
  Method *meth_meth_ast_shallowCopy7835 = addmethod2pos(obj7785, "shallowCopy", &meth_ast_shallowCopy7835, 8);
  int argcv_meth_ast_shallowCopy7835[] = {0};
  meth_meth_ast_shallowCopy7835->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy7835);
  meth_meth_ast_shallowCopy7835->definitionModule = modulename;
  meth_meth_ast_shallowCopy7835->definitionLine = 1866;
  sourceObject = obj7785;
// Begin line 1848
  setline(1848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7842 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7843 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7842);
// compiled call node returning call7843 (depth = 4)
  struct UserObject *obj7785_uo = (struct UserObject *)obj7785;
  obj7785_uo->super = call7843;
  sourceObject = obj7785;
// Begin line 1849
  setline(1849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit7844 == NULL) {
    strlit7844 = alloc_String("num");
    gc_root(strlit7844);
  }
// compiled string node returning strlit7844 (depth = 4)
  adddatum2(obj7785, strlit7844, 1);
  sourceObject = obj7785;
// Begin line 1850
  setline(1850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_val (depth = 4)
  adddatum2(obj7785, *var_val, 2);
  sourceObject = obj7785;
  sourceObject = obj7785;
  sourceObject = obj7785;
  sourceObject = obj7785;
  sourceObject = obj7785;
  sourceObject = obj7785;
  objclass7785 = obj7785->class;
  objclass7785->definitionModule = modulename;
  objclass7785->definitionLine = 1847;
  (*(struct UserObject *)self).data[0] = lowerouter7785;
  self = oldself7785;
  selfslot = oldselfslot7785;
  stackframe = oldstackframe7785;
  gc_frame_end(frame);
  return obj7785;
}
Object meth_ast_opNode7846(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 37, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "opNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_opNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for opNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for opNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_opNode (depth = 3)
  gc_frame_end(frame);
  return *var_opNode;
}
Object meth_ast_isSimple7856(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSimple");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isSimple (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isSimple");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1876
  setline(1876);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool7857 = alloc_Boolean(0);
// compiled identifier node returning bool7857 (depth = 4)
  gc_frame_end(frame);
  return bool7857;
}
Object meth_ast_nameString7858(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for nameString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for nameString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1877
  setline(1877);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7859 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7860 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7859);
// compiled call node returning call7860 (depth = 5)
// compiled member node returning call7860 (depth = 4)
  gc_frame_end(frame);
  return call7860;
}
Object meth_ast_accept_40__41_from7861(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1879
  setline(1879);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7863 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7864 = callmethod(*var_visitor, "visitOp()up",
    2, partcv, params);
  gc_frame_end(callframe7863);
// compiled call node returning call7864 (depth = 5)
  Object if7862 = done;
  if (istrue(call7864)) {
// Begin line 1880
  setline(1880);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7865 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_as (depth = 7)
  params[0] = self;
  partcv[0] = 1;
  Object call7866 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe7865);
// compiled call node returning call7866 (depth = 6)
  *var_newChain = call7866;
  if (call7866 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 1881
  setline(1881);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7867 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7868 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7869 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7868);
// compiled call node returning call7869 (depth = 7)
// compiled member node returning call7869 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7870 = callmethod(call7869, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe7867);
// compiled call node returning call7870 (depth = 5)
// Begin line 1882
  setline(1882);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7871 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7872 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7873 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7872);
// compiled call node returning call7873 (depth = 7)
// compiled member node returning call7873 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7874 = callmethod(call7873, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe7871);
// compiled call node returning call7874 (depth = 5)
    gc_frame_newslot(call7874);
    if7862 = call7874;
  } else {
  }
// compiled if node returning if7862 (depth = 4)
  gc_frame_end(frame);
  return if7862;
}
Object meth_ast_map_40__41_ancestors7875(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1886
  setline(1886);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7876 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7877 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7876);
// compiled call node returning call7877 (depth = 6)
// compiled member node returning call7877 (depth = 5)
  *var_n = call7877;
  if (call7877 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1887
  setline(1887);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7878 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7879 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe7878);
// compiled call node returning call7879 (depth = 5)
  *var_newChain = call7879;
  if (call7879 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1888
  setline(1888);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1886
  setline(1886);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7880 = gc_frame_new();
// Begin line 1888
  setline(1888);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7881 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7882 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7883 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7882);
// compiled call node returning call7883 (depth = 8)
// compiled member node returning call7883 (depth = 7)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7884 = callmethod(call7883, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe7881);
// compiled call node returning call7884 (depth = 6)
  gc_frame_newslot(call7884);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call7884;
  partcv[0] = 1;
  Object call7885 = callmethod(*var_n, "left:=",
    1, partcv, params);
  gc_frame_end(callframe7880);
// compiled call node returning call7885 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1889
  setline(1889);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1888
  setline(1888);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7886 = gc_frame_new();
// Begin line 1889
  setline(1889);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7887 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7888 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7889 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7888);
// compiled call node returning call7889 (depth = 8)
// compiled member node returning call7889 (depth = 7)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7890 = callmethod(call7889, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe7887);
// compiled call node returning call7890 (depth = 6)
  gc_frame_newslot(call7890);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call7890;
  partcv[0] = 1;
  Object call7891 = callmethod(*var_n, "right:=",
    1, partcv, params);
  gc_frame_end(callframe7886);
// compiled call node returning call7891 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1890
  setline(1890);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7892 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call7893 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe7892);
// compiled call node returning call7893 (depth = 4)
  gc_frame_end(frame);
  return call7893;
}
Object meth_ast__apply7902(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1895
  setline(1895);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit7904 == NULL) {
    strlit7904 = alloc_String("  ");
    gc_root(strlit7904);
  }
// compiled string node returning strlit7904 (depth = 8)
  int op_slot_right_7903 = gc_frame_newslot(strlit7904);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_7903 = gc_frame_newslot(*var_spc);
  params[0] = strlit7904;
  partcv[0] = 1;
  Object opresult7906 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult7906 (depth = 7)
  *var_spc = opresult7906;
  if (opresult7906 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty7894(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1893
  setline(1893);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7895 == NULL) {
    strlit7895 = alloc_String("");
    gc_root(strlit7895);
  }
// compiled string node returning strlit7895 (depth = 5)
  *var_spc = strlit7895;
  if (strlit7895 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1894
  setline(1894);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7896 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_right_7897 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 6)
  Object num7899 = alloc_Float64(0);
// compiled num node returning num7899 (depth = 6)
  int op_slot_left_7897 = gc_frame_newslot(num7899);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult7900 = callmethod(num7899, "..", 1, partcv, params);
// compiled op node returning opresult7900 (depth = 5)
  gc_frame_newslot(opresult7900);
// starting to compile block node (depth = 5)
  Object block7901 = alloc_Block(NULL, NULL, "ast", 1894);
  gc_frame_newslot(block7901);
// method _apply
  block_savedest(block7901);
  Object closure7902 = createclosure(2, "_apply");
  setclosureframe(closure7902, stackframe);
  addtoclosure(closure7902, var_spc);
  addtoclosure(closure7902, selfslot);
  struct UserObject *uo7902 = (struct UserObject*)block7901;
  uo7902->data[0] = (Object)closure7902;
  Method *meth_meth_ast__apply7902 = addmethod2pos(block7901, "_apply", &meth_ast__apply7902, 0);
  int argcv_meth_ast__apply7902[] = {1};
  meth_meth_ast__apply7902->type = alloc_MethodType(1, argcv_meth_ast__apply7902);
  meth_meth_ast__apply7902->definitionModule = modulename;
  meth_meth_ast__apply7902->definitionLine = 1889;
// compiled block node returning block7901 (depth = 5)
  gc_frame_newslot(block7901);
// call case 5: prelude request
  params[0] = opresult7900;
  params[1] = block7901;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7909 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7896);
// compiled call node returning call7909 (depth = 4)
// Begin line 1897
  setline(1897);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7911 == NULL) {
    strlit7911 = alloc_String("""\xe2""""\x80""""\xba""");
    gc_root(strlit7911);
  }
// compiled string node returning strlit7911 (depth = 6)
  int op_slot_right_7910 = gc_frame_newslot(strlit7911);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7914 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7915 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7914);
// compiled call node returning call7915 (depth = 8)
// compiled member node returning call7915 (depth = 7)
  int op_slot_right_7913 = gc_frame_newslot(call7915);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit7918 == NULL) {
    strlit7918 = alloc_String("""\xe2""""\x80""""\xb9""");
    gc_root(strlit7918);
  }
// compiled string node returning strlit7918 (depth = 8)
  int op_slot_right_7917 = gc_frame_newslot(strlit7918);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7921 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call7922 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe7921);
// compiled call node returning call7922 (depth = 9)
  int op_slot_right_7920 = gc_frame_newslot(call7922);
// starting to compile string node (depth = 9)
  if (strlit7924 == NULL) {
    strlit7924 = alloc_String("");
    gc_root(strlit7924);
  }
// compiled string node returning strlit7924 (depth = 9)
  int op_slot_left_7920 = gc_frame_newslot(strlit7924);
  params[0] = call7922;
  partcv[0] = 1;
  Object opresult7925 = callmethod(strlit7924, "++", 1, partcv, params);
// compiled op node returning opresult7925 (depth = 8)
  int op_slot_left_7917 = gc_frame_newslot(opresult7925);
  params[0] = strlit7918;
  partcv[0] = 1;
  Object opresult7926 = callmethod(opresult7925, "++", 1, partcv, params);
// compiled op node returning opresult7926 (depth = 7)
  int op_slot_left_7913 = gc_frame_newslot(opresult7926);
  params[0] = call7915;
  partcv[0] = 1;
  Object opresult7927 = callmethod(opresult7926, "++", 1, partcv, params);
// compiled op node returning opresult7927 (depth = 6)
  int op_slot_left_7910 = gc_frame_newslot(opresult7927);
  params[0] = strlit7911;
  partcv[0] = 1;
  Object opresult7928 = callmethod(opresult7927, "++", 1, partcv, params);
// compiled op node returning opresult7928 (depth = 5)
  *var_s = opresult7928;
  if (opresult7928 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1898
  setline(1898);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7930 == NULL) {
    strlit7930 = alloc_String("""\x0a""");
    gc_root(strlit7930);
  }
// compiled string node returning strlit7930 (depth = 6)
  int op_slot_right_7929 = gc_frame_newslot(strlit7930);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7929 = gc_frame_newslot(*var_s);
  params[0] = strlit7930;
  partcv[0] = 1;
  Object opresult7932 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7932 (depth = 5)
  *var_s = opresult7932;
  if (opresult7932 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1899
  setline(1899);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7935 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num7937 = alloc_Float64(1);
// compiled num node returning num7937 (depth = 8)
  int op_slot_right_7936 = gc_frame_newslot(num7937);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_7936 = gc_frame_newslot(*var_depth);
  params[0] = num7937;
  partcv[0] = 1;
  Object sum7939 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum7939 (depth = 7)
  gc_frame_newslot(sum7939);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7940 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7941 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7940);
// compiled call node returning call7941 (depth = 8)
// compiled member node returning call7941 (depth = 7)
  params[0] = sum7939;
  partcv[0] = 1;
  Object call7942 = callmethod(call7941, "pretty",
    1, partcv, params);
  gc_frame_end(callframe7935);
// compiled call node returning call7942 (depth = 6)
  int op_slot_right_7934 = gc_frame_newslot(call7942);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_7944 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_7944 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7946 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7946 (depth = 6)
  int op_slot_left_7934 = gc_frame_newslot(opresult7946);
  params[0] = call7942;
  partcv[0] = 1;
  Object opresult7947 = callmethod(opresult7946, "++", 1, partcv, params);
// compiled op node returning opresult7947 (depth = 5)
  *var_s = opresult7947;
  if (opresult7947 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1900
  setline(1900);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7950 == NULL) {
    strlit7950 = alloc_String("""\x0a""");
    gc_root(strlit7950);
  }
// compiled string node returning strlit7950 (depth = 6)
  int op_slot_right_7949 = gc_frame_newslot(strlit7950);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7949 = gc_frame_newslot(*var_s);
  params[0] = strlit7950;
  partcv[0] = 1;
  Object opresult7952 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7952 (depth = 5)
  *var_s = opresult7952;
  if (opresult7952 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1901
  setline(1901);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7955 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num7957 = alloc_Float64(1);
// compiled num node returning num7957 (depth = 8)
  int op_slot_right_7956 = gc_frame_newslot(num7957);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_7956 = gc_frame_newslot(*var_depth);
  params[0] = num7957;
  partcv[0] = 1;
  Object sum7959 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum7959 (depth = 7)
  gc_frame_newslot(sum7959);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7960 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7961 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7960);
// compiled call node returning call7961 (depth = 8)
// compiled member node returning call7961 (depth = 7)
  params[0] = sum7959;
  partcv[0] = 1;
  Object call7962 = callmethod(call7961, "pretty",
    1, partcv, params);
  gc_frame_end(callframe7955);
// compiled call node returning call7962 (depth = 6)
  int op_slot_right_7954 = gc_frame_newslot(call7962);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_7964 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_7964 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7966 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7966 (depth = 6)
  int op_slot_left_7954 = gc_frame_newslot(opresult7966);
  params[0] = call7962;
  partcv[0] = 1;
  Object opresult7967 = callmethod(opresult7966, "++", 1, partcv, params);
// compiled op node returning opresult7967 (depth = 5)
  *var_s = opresult7967;
  if (opresult7967 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1902
  setline(1902);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_toGrace7969(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1905
  setline(1905);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7970 == NULL) {
    strlit7970 = alloc_String("");
    gc_root(strlit7970);
  }
// compiled string node returning strlit7970 (depth = 5)
  *var_s = strlit7970;
  if (strlit7970 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1906
  setline(1906);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7974 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7975 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7974);
// compiled call node returning call7975 (depth = 8)
// compiled member node returning call7975 (depth = 7)
  int op_slot_right_7973 = gc_frame_newslot(call7975);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7977 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7978 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7979 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7978);
// compiled call node returning call7979 (depth = 10)
// compiled member node returning call7979 (depth = 9)
  partcv[0] = 0;
  Object call7980 = callmethod(call7979, "value",
    1, partcv, params);
  gc_frame_end(callframe7977);
// compiled call node returning call7980 (depth = 8)
// compiled member node returning call7980 (depth = 7)
  int op_slot_left_7973 = gc_frame_newslot(call7980);
  params[0] = call7975;
  partcv[0] = 1;
  Object opresult7981 = callmethod(call7980, "!=", 1, partcv, params);
// compiled op node returning opresult7981 (depth = 6)
  int op_slot_right_7972 = gc_frame_newslot(opresult7981);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7984 == NULL) {
    strlit7984 = alloc_String("op");
    gc_root(strlit7984);
  }
// compiled string node returning strlit7984 (depth = 7)
  int op_slot_right_7983 = gc_frame_newslot(strlit7984);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7986 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7987 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7988 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7987);
// compiled call node returning call7988 (depth = 10)
// compiled member node returning call7988 (depth = 9)
  partcv[0] = 0;
  Object call7989 = callmethod(call7988, "kind",
    1, partcv, params);
  gc_frame_end(callframe7986);
// compiled call node returning call7989 (depth = 8)
// compiled member node returning call7989 (depth = 7)
  int op_slot_left_7983 = gc_frame_newslot(call7989);
  params[0] = strlit7984;
  partcv[0] = 1;
  Object opresult7990 = callmethod(call7989, "==", 1, partcv, params);
// compiled op node returning opresult7990 (depth = 6)
  int op_slot_left_7972 = gc_frame_newslot(opresult7990);
  params[0] = opresult7981;
  partcv[0] = 1;
  Object opresult7991 = callmethod(opresult7990, "&&", 1, partcv, params);
// compiled op node returning opresult7991 (depth = 5)
  Object if7971 = done;
  if (istrue(opresult7991)) {
// Begin line 1907
  setline(1907);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7993 == NULL) {
    strlit7993 = alloc_String(")");
    gc_root(strlit7993);
  }
// compiled string node returning strlit7993 (depth = 7)
  int op_slot_right_7992 = gc_frame_newslot(strlit7993);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7996 = gc_frame_new();
// starting to compile num node (depth = 9)
  Object num7997 = alloc_Float64(0);
// compiled num node returning num7997 (depth = 9)
  gc_frame_newslot(num7997);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7998 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7999 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7998);
// compiled call node returning call7999 (depth = 10)
// compiled member node returning call7999 (depth = 9)
  params[0] = num7997;
  partcv[0] = 1;
  Object call8000 = callmethod(call7999, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe7996);
// compiled call node returning call8000 (depth = 8)
  int op_slot_right_7995 = gc_frame_newslot(call8000);
// starting to compile string node (depth = 8)
  if (strlit8002 == NULL) {
    strlit8002 = alloc_String("(");
    gc_root(strlit8002);
  }
// compiled string node returning strlit8002 (depth = 8)
  int op_slot_left_7995 = gc_frame_newslot(strlit8002);
  params[0] = call8000;
  partcv[0] = 1;
  Object opresult8003 = callmethod(strlit8002, "++", 1, partcv, params);
// compiled op node returning opresult8003 (depth = 7)
  int op_slot_left_7992 = gc_frame_newslot(opresult8003);
  params[0] = strlit7993;
  partcv[0] = 1;
  Object opresult8004 = callmethod(opresult8003, "++", 1, partcv, params);
// compiled op node returning opresult8004 (depth = 6)
  *var_s = opresult8004;
  if (opresult8004 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if7971 = done;
  } else {
// Begin line 1909
  setline(1909);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8006 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num8007 = alloc_Float64(0);
// compiled num node returning num8007 (depth = 7)
  gc_frame_newslot(num8007);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8008 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8009 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8008);
// compiled call node returning call8009 (depth = 8)
// compiled member node returning call8009 (depth = 7)
  params[0] = num8007;
  partcv[0] = 1;
  Object call8010 = callmethod(call8009, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe8006);
// compiled call node returning call8010 (depth = 6)
  *var_s = call8010;
  if (call8010 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if7971 = done;
  }
// compiled if node returning if7971 (depth = 4)
// Begin line 1911
  setline(1911);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8014 == NULL) {
    strlit8014 = alloc_String("..");
    gc_root(strlit8014);
  }
// compiled string node returning strlit8014 (depth = 6)
  int op_slot_right_8013 = gc_frame_newslot(strlit8014);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8016 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8017 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8016);
// compiled call node returning call8017 (depth = 7)
// compiled member node returning call8017 (depth = 6)
  int op_slot_left_8013 = gc_frame_newslot(call8017);
  params[0] = strlit8014;
  partcv[0] = 1;
  Object opresult8018 = callmethod(call8017, "==", 1, partcv, params);
// compiled op node returning opresult8018 (depth = 5)
  Object if8012 = done;
  if (istrue(opresult8018)) {
// Begin line 1912
  setline(1912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8020 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8021 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8020);
// compiled call node returning call8021 (depth = 8)
// compiled member node returning call8021 (depth = 7)
  int op_slot_right_8019 = gc_frame_newslot(call8021);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_8019 = gc_frame_newslot(*var_s);
  params[0] = call8021;
  partcv[0] = 1;
  Object opresult8023 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8023 (depth = 6)
  *var_s = opresult8023;
  if (opresult8023 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if8012 = done;
  } else {
// Begin line 1914
  setline(1914);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8026 == NULL) {
    strlit8026 = alloc_String(" ");
    gc_root(strlit8026);
  }
// compiled string node returning strlit8026 (depth = 7)
  int op_slot_right_8025 = gc_frame_newslot(strlit8026);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8029 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8030 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8029);
// compiled call node returning call8030 (depth = 9)
// compiled member node returning call8030 (depth = 8)
  int op_slot_right_8028 = gc_frame_newslot(call8030);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit8033 == NULL) {
    strlit8033 = alloc_String(" ");
    gc_root(strlit8033);
  }
// compiled string node returning strlit8033 (depth = 9)
  int op_slot_right_8032 = gc_frame_newslot(strlit8033);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_8032 = gc_frame_newslot(*var_s);
  params[0] = strlit8033;
  partcv[0] = 1;
  Object opresult8035 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8035 (depth = 8)
  int op_slot_left_8028 = gc_frame_newslot(opresult8035);
  params[0] = call8030;
  partcv[0] = 1;
  Object opresult8036 = callmethod(opresult8035, "++", 1, partcv, params);
// compiled op node returning opresult8036 (depth = 7)
  int op_slot_left_8025 = gc_frame_newslot(opresult8036);
  params[0] = strlit8026;
  partcv[0] = 1;
  Object opresult8037 = callmethod(opresult8036, "++", 1, partcv, params);
// compiled op node returning opresult8037 (depth = 6)
  *var_s = opresult8037;
  if (opresult8037 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if8012 = done;
  }
// compiled if node returning if8012 (depth = 4)
// Begin line 1916
  setline(1916);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8042 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8043 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8042);
// compiled call node returning call8043 (depth = 8)
// compiled member node returning call8043 (depth = 7)
  int op_slot_right_8041 = gc_frame_newslot(call8043);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8045 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8046 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8047 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8046);
// compiled call node returning call8047 (depth = 10)
// compiled member node returning call8047 (depth = 9)
  partcv[0] = 0;
  Object call8048 = callmethod(call8047, "value",
    1, partcv, params);
  gc_frame_end(callframe8045);
// compiled call node returning call8048 (depth = 8)
// compiled member node returning call8048 (depth = 7)
  int op_slot_left_8041 = gc_frame_newslot(call8048);
  params[0] = call8043;
  partcv[0] = 1;
  Object opresult8049 = callmethod(call8048, "!=", 1, partcv, params);
// compiled op node returning opresult8049 (depth = 6)
  int op_slot_right_8040 = gc_frame_newslot(opresult8049);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8052 == NULL) {
    strlit8052 = alloc_String("op");
    gc_root(strlit8052);
  }
// compiled string node returning strlit8052 (depth = 7)
  int op_slot_right_8051 = gc_frame_newslot(strlit8052);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8054 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8055 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8056 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8055);
// compiled call node returning call8056 (depth = 10)
// compiled member node returning call8056 (depth = 9)
  partcv[0] = 0;
  Object call8057 = callmethod(call8056, "kind",
    1, partcv, params);
  gc_frame_end(callframe8054);
// compiled call node returning call8057 (depth = 8)
// compiled member node returning call8057 (depth = 7)
  int op_slot_left_8051 = gc_frame_newslot(call8057);
  params[0] = strlit8052;
  partcv[0] = 1;
  Object opresult8058 = callmethod(call8057, "==", 1, partcv, params);
// compiled op node returning opresult8058 (depth = 6)
  int op_slot_left_8040 = gc_frame_newslot(opresult8058);
  params[0] = opresult8049;
  partcv[0] = 1;
  Object opresult8059 = callmethod(opresult8058, "&&", 1, partcv, params);
// compiled op node returning opresult8059 (depth = 5)
  Object if8039 = done;
  if (istrue(opresult8059)) {
// Begin line 1917
  setline(1917);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8061 == NULL) {
    strlit8061 = alloc_String(")");
    gc_root(strlit8061);
  }
// compiled string node returning strlit8061 (depth = 7)
  int op_slot_right_8060 = gc_frame_newslot(strlit8061);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8064 = gc_frame_new();
// starting to compile num node (depth = 9)
  Object num8065 = alloc_Float64(0);
// compiled num node returning num8065 (depth = 9)
  gc_frame_newslot(num8065);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8066 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8067 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8066);
// compiled call node returning call8067 (depth = 10)
// compiled member node returning call8067 (depth = 9)
  params[0] = num8065;
  partcv[0] = 1;
  Object call8068 = callmethod(call8067, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe8064);
// compiled call node returning call8068 (depth = 8)
  int op_slot_right_8063 = gc_frame_newslot(call8068);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit8071 == NULL) {
    strlit8071 = alloc_String("(");
    gc_root(strlit8071);
  }
// compiled string node returning strlit8071 (depth = 9)
  int op_slot_right_8070 = gc_frame_newslot(strlit8071);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_8070 = gc_frame_newslot(*var_s);
  params[0] = strlit8071;
  partcv[0] = 1;
  Object opresult8073 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8073 (depth = 8)
  int op_slot_left_8063 = gc_frame_newslot(opresult8073);
  params[0] = call8068;
  partcv[0] = 1;
  Object opresult8074 = callmethod(opresult8073, "++", 1, partcv, params);
// compiled op node returning opresult8074 (depth = 7)
  int op_slot_left_8060 = gc_frame_newslot(opresult8074);
  params[0] = strlit8061;
  partcv[0] = 1;
  Object opresult8075 = callmethod(opresult8074, "++", 1, partcv, params);
// compiled op node returning opresult8075 (depth = 6)
  *var_s = opresult8075;
  if (opresult8075 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if8039 = done;
  } else {
// Begin line 1919
  setline(1919);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8078 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num8079 = alloc_Float64(0);
// compiled num node returning num8079 (depth = 8)
  gc_frame_newslot(num8079);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8080 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8081 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8080);
// compiled call node returning call8081 (depth = 9)
// compiled member node returning call8081 (depth = 8)
  params[0] = num8079;
  partcv[0] = 1;
  Object call8082 = callmethod(call8081, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe8078);
// compiled call node returning call8082 (depth = 7)
  int op_slot_right_8077 = gc_frame_newslot(call8082);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_8077 = gc_frame_newslot(*var_s);
  params[0] = call8082;
  partcv[0] = 1;
  Object opresult8084 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8084 (depth = 6)
  *var_s = opresult8084;
  if (opresult8084 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if8039 = done;
  }
// compiled if node returning if8039 (depth = 4)
// Begin line 1921
  setline(1921);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_asIdentifier8086(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_identifierNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asIdentifier (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asIdentifier");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_resultNode = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "resultNode");
// Begin line 1925
  setline(1925);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8087 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8088 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8089 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8088);
// compiled call node returning call8089 (depth = 7)
// compiled member node returning call8089 (depth = 6)
  gc_frame_newslot(call8089);
// starting to compile identifier node (depth = 6)
  Object bool8090 = alloc_Boolean(0);
// compiled identifier node returning bool8090 (depth = 6)
  gc_frame_newslot(bool8090);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_identifierNode (depth = 6)
  params[0] = call8089;
  params[1] = bool8090;
  partcv[0] = 2;
  Object call8091 = callmethod(*var_identifierNode, "new",
    1, partcv, params);
  gc_frame_end(callframe8087);
// compiled call node returning call8091 (depth = 5)
  *var_resultNode = call8091;
  if (call8091 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1926
  setline(1926);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1925
  setline(1925);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8092 = gc_frame_new();
// Begin line 1926
  setline(1926);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool8093 = alloc_Boolean(1);
// compiled identifier node returning bool8093 (depth = 6)
  gc_frame_newslot(bool8093);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_resultNode (depth = 6)
  params[0] = bool8093;
  partcv[0] = 1;
  Object call8094 = callmethod(*var_resultNode, "inRequest:=",
    1, partcv, params);
  gc_frame_end(callframe8092);
// compiled call node returning call8094 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1927
  setline(1927);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1925
  setline(1925);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8095 = gc_frame_new();
// Begin line 1927
  setline(1927);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8096 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8097 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8096);
// compiled call node returning call8097 (depth = 7)
// compiled member node returning call8097 (depth = 6)
  gc_frame_newslot(call8097);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_resultNode (depth = 6)
  params[0] = call8097;
  partcv[0] = 1;
  Object call8098 = callmethod(*var_resultNode, "line:=",
    1, partcv, params);
  gc_frame_end(callframe8095);
// compiled call node returning call8098 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1928
  setline(1928);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1927
  setline(1927);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8099 = gc_frame_new();
// Begin line 1928
  setline(1928);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8100 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8101 = callmethodflags(self, "linePos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8100);
// compiled call node returning call8101 (depth = 7)
// compiled member node returning call8101 (depth = 6)
  gc_frame_newslot(call8101);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_resultNode (depth = 6)
  params[0] = call8101;
  partcv[0] = 1;
  Object call8102 = callmethod(*var_resultNode, "linePos:=",
    1, partcv, params);
  gc_frame_end(callframe8099);
// compiled call node returning call8102 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1929
  setline(1929);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_resultNode (depth = 5)
  return *var_resultNode;
// compiled return node returning undefined (depth = 4)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast_shallowCopy8103(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_opNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1932
  setline(1932);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8104 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe8105 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8106 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8107 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8106);
// compiled call node returning call8107 (depth = 7)
// compiled member node returning call8107 (depth = 6)
  gc_frame_newslot(call8107);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nullNode (depth = 6)
  gc_frame_newslot(*var_nullNode);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nullNode (depth = 6)
  gc_frame_newslot(*var_nullNode);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_opNode (depth = 6)
  params[0] = call8107;
  params[1] = *var_nullNode;
  params[2] = *var_nullNode;
  partcv[0] = 3;
  Object call8108 = callmethod(*var_opNode, "new",
    1, partcv, params);
  gc_frame_end(callframe8105);
// compiled call node returning call8108 (depth = 5)
  params[0] = self;
  partcv[0] = 1;
  Object call8109 = callmethod(call8108, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe8104);
// compiled call node returning call8109 (depth = 4)
  gc_frame_end(frame);
  return call8109;
}
Object meth_ast_new7849(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_identifierNode = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_opNode = getfromclosure(closure, 2);
  Object *var_baseNode = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_op = &(stackframe->slots[0]);
  *var_op = args[curarg];
  curarg++;
  Object *var_l = &(stackframe->slots[1]);
  *var_l = args[curarg];
  curarg++;
  Object *var_r = &(stackframe->slots[2]);
  *var_r = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7850 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7850 = alloc_userobj2(15,14, objclass7850);
  gc_frame_newslot(obj7850);
if (objclass7850 == NULL) {
  glfree(obj7850->class->name);
  obj7850->class->name = "opNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7850, self, 0);
  addmethodreal(obj7850,"outer", &reader_ast_outer_7851);
  Object oldself7850 = self;
  struct StackFrameObject *oldstackframe7850 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7850);
  gc_frame_newslot((Object)stackframe);
  self = obj7850;
  Object *oldselfslot7850 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7850 = (*(struct UserObject *)self).data[0], lowerouter7850 = thisouter7850;
  if (inheritingObject7850) {
    struct UserObject *inho7850 = (struct UserObject *)inheritingObject7850;
    while (inho7850->super != GraceDefaultObject) inho7850 = (struct UserObject *)inho7850->super;
    inho7850->super = obj7850;
    self = inheritingObject7850;
    *selfslot = self;
    lowerouter7850 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7850;
  }
if (objclass7850 == NULL) {
  Method *reader7852 = addmethodrealflags(obj7850, "kind",&reader_ast_kind_7852, MFLAG_DEF);
  reader7852->definitionModule = modulename;
  reader7852->definitionLine = 1872;
}
adddatum2(obj7850, alloc_Undefined(), 1);
if (objclass7850 == NULL) {
  Method *reader7853 = addmethodrealflags(obj7850, "value",&reader_ast_value_7853, MFLAG_DEF);
  reader7853->definitionModule = modulename;
  reader7853->definitionLine = 1873;
}
adddatum2(obj7850, alloc_Undefined(), 2);
if (objclass7850 == NULL) {
  Method *reader7854 = addmethodrealflags(obj7850, "left",&reader_ast_left_7854, 0);
  Method *writer7854 = addmethodrealflags(obj7850, "left:=",&writer_ast_left_7854, 0);
  reader7854->definitionModule = modulename;
  writer7854->definitionModule = modulename;
  reader7854->definitionLine = 1874;
  writer7854->definitionLine = 1874;
}
obj7850->flags |= OFLAG_MUTABLE;
adddatum2(obj7850, alloc_Undefined(), 3);
if (objclass7850 == NULL) {
  Method *reader7855 = addmethodrealflags(obj7850, "right",&reader_ast_right_7855, 0);
  Method *writer7855 = addmethodrealflags(obj7850, "right:=",&writer_ast_right_7855, 0);
  reader7855->definitionModule = modulename;
  writer7855->definitionModule = modulename;
  reader7855->definitionLine = 1875;
  writer7855->definitionLine = 1875;
}
obj7850->flags |= OFLAG_MUTABLE;
adddatum2(obj7850, alloc_Undefined(), 4);
// method isSimple
  struct UserObject *uo7856 = (struct UserObject*)obj7850;
  uo7856->data[5] = emptyclosure;
  Method *meth_meth_ast_isSimple7856 = addmethod2pos(obj7850, "isSimple", &meth_ast_isSimple7856, 5);
  int argcv_meth_ast_isSimple7856[] = {0};
  meth_meth_ast_isSimple7856->type = alloc_MethodType(1, argcv_meth_ast_isSimple7856);
  meth_meth_ast_isSimple7856->definitionModule = modulename;
  meth_meth_ast_isSimple7856->definitionLine = 1876;
// method nameString
  struct UserObject *uo7858 = (struct UserObject*)obj7850;
  uo7858->data[6] = emptyclosure;
  Method *meth_meth_ast_nameString7858 = addmethod2pos(obj7850, "nameString", &meth_ast_nameString7858, 6);
  int argcv_meth_ast_nameString7858[] = {0};
  meth_meth_ast_nameString7858->type = alloc_MethodType(1, argcv_meth_ast_nameString7858);
  meth_meth_ast_nameString7858->definitionModule = modulename;
  meth_meth_ast_nameString7858->definitionLine = 1877;
// method accept()from
  struct UserObject *uo7861 = (struct UserObject*)obj7850;
  uo7861->data[7] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from7861 = addmethod2pos(obj7850, "accept()from", &meth_ast_accept_40__41_from7861, 7);
  int argcv_meth_ast_accept_40__41_from7861[] = {1, 1};
  meth_meth_ast_accept_40__41_from7861->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from7861);
  meth_meth_ast_accept_40__41_from7861->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from7861->definitionLine = 1878;
// method map()ancestors
  struct UserObject *uo7875 = (struct UserObject*)obj7850;
  uo7875->data[8] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors7875 = addmethod2pos(obj7850, "map()ancestors", &meth_ast_map_40__41_ancestors7875, 8);
  int argcv_meth_ast_map_40__41_ancestors7875[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors7875->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors7875);
  meth_meth_ast_map_40__41_ancestors7875->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors7875->definitionLine = 1885;
// method pretty
  struct UserObject *uo7894 = (struct UserObject*)obj7850;
  uo7894->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty7894 = addmethod2pos(obj7850, "pretty", &meth_ast_pretty7894, 9);
  int argcv_meth_ast_pretty7894[] = {1};
  meth_meth_ast_pretty7894->type = alloc_MethodType(1, argcv_meth_ast_pretty7894);
  meth_meth_ast_pretty7894->definitionModule = modulename;
  meth_meth_ast_pretty7894->definitionLine = 1892;
// method toGrace
  struct UserObject *uo7969 = (struct UserObject*)obj7850;
  uo7969->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace7969 = addmethod2pos(obj7850, "toGrace", &meth_ast_toGrace7969, 10);
  int argcv_meth_ast_toGrace7969[] = {1};
  meth_meth_ast_toGrace7969->type = alloc_MethodType(1, argcv_meth_ast_toGrace7969);
meth_meth_ast_toGrace7969->type->types[0] = type_Number;
meth_meth_ast_toGrace7969->type->names[0] = "depth";
  meth_meth_ast_toGrace7969->definitionModule = modulename;
  meth_meth_ast_toGrace7969->definitionLine = 1904;
// method asIdentifier
  block_savedest(obj7850);
  Object closure8086 = createclosure(1, "asIdentifier");
  setclosureframe(closure8086, stackframe);
  addtoclosure(closure8086, var_identifierNode);
  struct UserObject *uo8086 = (struct UserObject*)obj7850;
  uo8086->data[11] = (Object)closure8086;
  Method *meth_meth_ast_asIdentifier8086 = addmethod2pos(obj7850, "asIdentifier", &meth_ast_asIdentifier8086, 11);
  int argcv_meth_ast_asIdentifier8086[] = {0};
  meth_meth_ast_asIdentifier8086->type = alloc_MethodType(1, argcv_meth_ast_asIdentifier8086);
  meth_meth_ast_asIdentifier8086->definitionModule = modulename;
  meth_meth_ast_asIdentifier8086->definitionLine = 1923;
// method shallowCopy
  block_savedest(obj7850);
  Object closure8103 = createclosure(2, "shallowCopy");
  setclosureframe(closure8103, stackframe);
  addtoclosure(closure8103, var_nullNode);
  addtoclosure(closure8103, var_opNode);
  struct UserObject *uo8103 = (struct UserObject*)obj7850;
  uo8103->data[12] = (Object)closure8103;
  Method *meth_meth_ast_shallowCopy8103 = addmethod2pos(obj7850, "shallowCopy", &meth_ast_shallowCopy8103, 12);
  int argcv_meth_ast_shallowCopy8103[] = {0};
  meth_meth_ast_shallowCopy8103->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy8103);
  meth_meth_ast_shallowCopy8103->definitionModule = modulename;
  meth_meth_ast_shallowCopy8103->definitionLine = 1931;
  sourceObject = obj7850;
// Begin line 1871
  setline(1871);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8110 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call8111 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe8110);
// compiled call node returning call8111 (depth = 4)
  struct UserObject *obj7850_uo = (struct UserObject *)obj7850;
  obj7850_uo->super = call8111;
  sourceObject = obj7850;
// Begin line 1872
  setline(1872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit8112 == NULL) {
    strlit8112 = alloc_String("op");
    gc_root(strlit8112);
  }
// compiled string node returning strlit8112 (depth = 4)
  adddatum2(obj7850, strlit8112, 1);
  sourceObject = obj7850;
// Begin line 1873
  setline(1873);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_op (depth = 4)
  adddatum2(obj7850, *var_op, 2);
  sourceObject = obj7850;
// Begin line 1874
  setline(1874);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_l (depth = 4)
  adddatum2(obj7850, *var_l, 3);
  sourceObject = obj7850;
// Begin line 1875
  setline(1875);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_r (depth = 4)
  adddatum2(obj7850, *var_r, 4);
  sourceObject = obj7850;
  sourceObject = obj7850;
  sourceObject = obj7850;
  sourceObject = obj7850;
  sourceObject = obj7850;
  sourceObject = obj7850;
  sourceObject = obj7850;
  sourceObject = obj7850;
  objclass7850 = obj7850->class;
  objclass7850->definitionModule = modulename;
  objclass7850->definitionLine = 1870;
  (*(struct UserObject *)self).data[0] = lowerouter7850;
  self = oldself7850;
  selfslot = oldselfslot7850;
  stackframe = oldstackframe7850;
  gc_frame_end(frame);
  return obj7850;
}
Object meth_ast_new7849_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_identifierNode = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_opNode = getfromclosure(closure, 2);
  Object *var_baseNode = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_op = &(stackframe->slots[0]);
  *var_op = args[curarg];
  curarg++;
  Object *var_l = &(stackframe->slots[1]);
  *var_l = args[curarg];
  curarg++;
  Object *var_r = &(stackframe->slots[2]);
  *var_r = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7850 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7850 = alloc_userobj2(15,14, objclass7850);
  gc_frame_newslot(obj7850);
if (objclass7850 == NULL) {
  glfree(obj7850->class->name);
  obj7850->class->name = "opNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7850, self, 0);
  addmethodreal(obj7850,"outer", &reader_ast_outer_7851);
  Object oldself7850 = self;
  struct StackFrameObject *oldstackframe7850 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7850);
  gc_frame_newslot((Object)stackframe);
  self = obj7850;
  Object *oldselfslot7850 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7850 = (*(struct UserObject *)self).data[0], lowerouter7850 = thisouter7850;
  if (inheritingObject7850) {
    struct UserObject *inho7850 = (struct UserObject *)inheritingObject7850;
    while (inho7850->super != GraceDefaultObject) inho7850 = (struct UserObject *)inho7850->super;
    inho7850->super = obj7850;
    self = inheritingObject7850;
    *selfslot = self;
    lowerouter7850 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7850;
  }
if (objclass7850 == NULL) {
  Method *reader7852 = addmethodrealflags(obj7850, "kind",&reader_ast_kind_7852, MFLAG_DEF);
  reader7852->definitionModule = modulename;
  reader7852->definitionLine = 1872;
}
adddatum2(obj7850, alloc_Undefined(), 1);
if (objclass7850 == NULL) {
  Method *reader7853 = addmethodrealflags(obj7850, "value",&reader_ast_value_7853, MFLAG_DEF);
  reader7853->definitionModule = modulename;
  reader7853->definitionLine = 1873;
}
adddatum2(obj7850, alloc_Undefined(), 2);
if (objclass7850 == NULL) {
  Method *reader7854 = addmethodrealflags(obj7850, "left",&reader_ast_left_7854, 0);
  Method *writer7854 = addmethodrealflags(obj7850, "left:=",&writer_ast_left_7854, 0);
  reader7854->definitionModule = modulename;
  writer7854->definitionModule = modulename;
  reader7854->definitionLine = 1874;
  writer7854->definitionLine = 1874;
}
obj7850->flags |= OFLAG_MUTABLE;
adddatum2(obj7850, alloc_Undefined(), 3);
if (objclass7850 == NULL) {
  Method *reader7855 = addmethodrealflags(obj7850, "right",&reader_ast_right_7855, 0);
  Method *writer7855 = addmethodrealflags(obj7850, "right:=",&writer_ast_right_7855, 0);
  reader7855->definitionModule = modulename;
  writer7855->definitionModule = modulename;
  reader7855->definitionLine = 1875;
  writer7855->definitionLine = 1875;
}
obj7850->flags |= OFLAG_MUTABLE;
adddatum2(obj7850, alloc_Undefined(), 4);
// method isSimple
  struct UserObject *uo7856 = (struct UserObject*)obj7850;
  uo7856->data[5] = emptyclosure;
  Method *meth_meth_ast_isSimple7856 = addmethod2pos(obj7850, "isSimple", &meth_ast_isSimple7856, 5);
  int argcv_meth_ast_isSimple7856[] = {0};
  meth_meth_ast_isSimple7856->type = alloc_MethodType(1, argcv_meth_ast_isSimple7856);
  meth_meth_ast_isSimple7856->definitionModule = modulename;
  meth_meth_ast_isSimple7856->definitionLine = 1876;
// method nameString
  struct UserObject *uo7858 = (struct UserObject*)obj7850;
  uo7858->data[6] = emptyclosure;
  Method *meth_meth_ast_nameString7858 = addmethod2pos(obj7850, "nameString", &meth_ast_nameString7858, 6);
  int argcv_meth_ast_nameString7858[] = {0};
  meth_meth_ast_nameString7858->type = alloc_MethodType(1, argcv_meth_ast_nameString7858);
  meth_meth_ast_nameString7858->definitionModule = modulename;
  meth_meth_ast_nameString7858->definitionLine = 1877;
// method accept()from
  struct UserObject *uo7861 = (struct UserObject*)obj7850;
  uo7861->data[7] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from7861 = addmethod2pos(obj7850, "accept()from", &meth_ast_accept_40__41_from7861, 7);
  int argcv_meth_ast_accept_40__41_from7861[] = {1, 1};
  meth_meth_ast_accept_40__41_from7861->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from7861);
  meth_meth_ast_accept_40__41_from7861->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from7861->definitionLine = 1878;
// method map()ancestors
  struct UserObject *uo7875 = (struct UserObject*)obj7850;
  uo7875->data[8] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors7875 = addmethod2pos(obj7850, "map()ancestors", &meth_ast_map_40__41_ancestors7875, 8);
  int argcv_meth_ast_map_40__41_ancestors7875[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors7875->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors7875);
  meth_meth_ast_map_40__41_ancestors7875->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors7875->definitionLine = 1885;
// method pretty
  struct UserObject *uo7894 = (struct UserObject*)obj7850;
  uo7894->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty7894 = addmethod2pos(obj7850, "pretty", &meth_ast_pretty7894, 9);
  int argcv_meth_ast_pretty7894[] = {1};
  meth_meth_ast_pretty7894->type = alloc_MethodType(1, argcv_meth_ast_pretty7894);
  meth_meth_ast_pretty7894->definitionModule = modulename;
  meth_meth_ast_pretty7894->definitionLine = 1892;
// method toGrace
  struct UserObject *uo7969 = (struct UserObject*)obj7850;
  uo7969->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace7969 = addmethod2pos(obj7850, "toGrace", &meth_ast_toGrace7969, 10);
  int argcv_meth_ast_toGrace7969[] = {1};
  meth_meth_ast_toGrace7969->type = alloc_MethodType(1, argcv_meth_ast_toGrace7969);
meth_meth_ast_toGrace7969->type->types[0] = type_Number;
meth_meth_ast_toGrace7969->type->names[0] = "depth";
  meth_meth_ast_toGrace7969->definitionModule = modulename;
  meth_meth_ast_toGrace7969->definitionLine = 1904;
// method asIdentifier
  block_savedest(obj7850);
  Object closure8086 = createclosure(1, "asIdentifier");
  setclosureframe(closure8086, stackframe);
  addtoclosure(closure8086, var_identifierNode);
  struct UserObject *uo8086 = (struct UserObject*)obj7850;
  uo8086->data[11] = (Object)closure8086;
  Method *meth_meth_ast_asIdentifier8086 = addmethod2pos(obj7850, "asIdentifier", &meth_ast_asIdentifier8086, 11);
  int argcv_meth_ast_asIdentifier8086[] = {0};
  meth_meth_ast_asIdentifier8086->type = alloc_MethodType(1, argcv_meth_ast_asIdentifier8086);
  meth_meth_ast_asIdentifier8086->definitionModule = modulename;
  meth_meth_ast_asIdentifier8086->definitionLine = 1923;
// method shallowCopy
  block_savedest(obj7850);
  Object closure8103 = createclosure(2, "shallowCopy");
  setclosureframe(closure8103, stackframe);
  addtoclosure(closure8103, var_nullNode);
  addtoclosure(closure8103, var_opNode);
  struct UserObject *uo8103 = (struct UserObject*)obj7850;
  uo8103->data[12] = (Object)closure8103;
  Method *meth_meth_ast_shallowCopy8103 = addmethod2pos(obj7850, "shallowCopy", &meth_ast_shallowCopy8103, 12);
  int argcv_meth_ast_shallowCopy8103[] = {0};
  meth_meth_ast_shallowCopy8103->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy8103);
  meth_meth_ast_shallowCopy8103->definitionModule = modulename;
  meth_meth_ast_shallowCopy8103->definitionLine = 1931;
  sourceObject = obj7850;
// Begin line 1871
  setline(1871);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8110 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call8111 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe8110);
// compiled call node returning call8111 (depth = 4)
  struct UserObject *obj7850_uo = (struct UserObject *)obj7850;
  obj7850_uo->super = call8111;
  sourceObject = obj7850;
// Begin line 1872
  setline(1872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit8112 == NULL) {
    strlit8112 = alloc_String("op");
    gc_root(strlit8112);
  }
// compiled string node returning strlit8112 (depth = 4)
  adddatum2(obj7850, strlit8112, 1);
  sourceObject = obj7850;
// Begin line 1873
  setline(1873);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_op (depth = 4)
  adddatum2(obj7850, *var_op, 2);
  sourceObject = obj7850;
// Begin line 1874
  setline(1874);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_l (depth = 4)
  adddatum2(obj7850, *var_l, 3);
  sourceObject = obj7850;
// Begin line 1875
  setline(1875);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_r (depth = 4)
  adddatum2(obj7850, *var_r, 4);
  sourceObject = obj7850;
  sourceObject = obj7850;
  sourceObject = obj7850;
  sourceObject = obj7850;
  sourceObject = obj7850;
  sourceObject = obj7850;
  sourceObject = obj7850;
  sourceObject = obj7850;
  objclass7850 = obj7850->class;
  objclass7850->definitionModule = modulename;
  objclass7850->definitionLine = 1870;
  (*(struct UserObject *)self).data[0] = lowerouter7850;
  self = oldself7850;
  selfslot = oldselfslot7850;
  stackframe = oldstackframe7850;
  gc_frame_end(frame);
  return obj7850;
}
Object meth_ast_indexNode8114(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 38, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "indexNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_indexNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for indexNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for indexNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indexNode (depth = 3)
  gc_frame_end(frame);
  return *var_indexNode;
}
Object meth_ast_accept_40__41_from8123(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1943
  setline(1943);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8125 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8126 = callmethod(*var_visitor, "visitIndex()up",
    2, partcv, params);
  gc_frame_end(callframe8125);
// compiled call node returning call8126 (depth = 5)
  Object if8124 = done;
  if (istrue(call8126)) {
// Begin line 1944
  setline(1944);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8127 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_as (depth = 7)
  params[0] = self;
  partcv[0] = 1;
  Object call8128 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe8127);
// compiled call node returning call8128 (depth = 6)
  *var_newChain = call8128;
  if (call8128 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 1945
  setline(1945);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8129 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8130 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8131 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8130);
// compiled call node returning call8131 (depth = 7)
// compiled member node returning call8131 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8132 = callmethod(call8131, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe8129);
// compiled call node returning call8132 (depth = 5)
// Begin line 1946
  setline(1946);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8133 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8134 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8135 = callmethodflags(self, "index", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8134);
// compiled call node returning call8135 (depth = 7)
// compiled member node returning call8135 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8136 = callmethod(call8135, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe8133);
// compiled call node returning call8136 (depth = 5)
    gc_frame_newslot(call8136);
    if8124 = call8136;
  } else {
  }
// compiled if node returning if8124 (depth = 4)
  gc_frame_end(frame);
  return if8124;
}
Object meth_ast_map_40__41_ancestors8137(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1950
  setline(1950);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8138 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8139 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8138);
// compiled call node returning call8139 (depth = 6)
// compiled member node returning call8139 (depth = 5)
  *var_n = call8139;
  if (call8139 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1951
  setline(1951);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8140 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call8141 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe8140);
// compiled call node returning call8141 (depth = 5)
  *var_newChain = call8141;
  if (call8141 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1952
  setline(1952);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1950
  setline(1950);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8142 = gc_frame_new();
// Begin line 1952
  setline(1952);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8143 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8144 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8145 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8144);
// compiled call node returning call8145 (depth = 8)
// compiled member node returning call8145 (depth = 7)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8146 = callmethod(call8145, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe8143);
// compiled call node returning call8146 (depth = 6)
  gc_frame_newslot(call8146);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call8146;
  partcv[0] = 1;
  Object call8147 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe8142);
// compiled call node returning call8147 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1953
  setline(1953);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1952
  setline(1952);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8148 = gc_frame_new();
// Begin line 1953
  setline(1953);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8149 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8150 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8151 = callmethodflags(self, "index", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8150);
// compiled call node returning call8151 (depth = 8)
// compiled member node returning call8151 (depth = 7)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8152 = callmethod(call8151, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe8149);
// compiled call node returning call8152 (depth = 6)
  gc_frame_newslot(call8152);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call8152;
  partcv[0] = 1;
  Object call8153 = callmethod(*var_n, "index:=",
    1, partcv, params);
  gc_frame_end(callframe8148);
// compiled call node returning call8153 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1954
  setline(1954);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8154 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call8155 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe8154);
// compiled call node returning call8155 (depth = 4)
  gc_frame_end(frame);
  return call8155;
}
Object meth_ast__apply8164(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1959
  setline(1959);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8166 == NULL) {
    strlit8166 = alloc_String("  ");
    gc_root(strlit8166);
  }
// compiled string node returning strlit8166 (depth = 8)
  int op_slot_right_8165 = gc_frame_newslot(strlit8166);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_8165 = gc_frame_newslot(*var_spc);
  params[0] = strlit8166;
  partcv[0] = 1;
  Object opresult8168 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult8168 (depth = 7)
  *var_spc = opresult8168;
  if (opresult8168 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty8156(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1957
  setline(1957);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8157 == NULL) {
    strlit8157 = alloc_String("");
    gc_root(strlit8157);
  }
// compiled string node returning strlit8157 (depth = 5)
  *var_spc = strlit8157;
  if (strlit8157 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1958
  setline(1958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8158 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_right_8159 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 6)
  Object num8161 = alloc_Float64(0);
// compiled num node returning num8161 (depth = 6)
  int op_slot_left_8159 = gc_frame_newslot(num8161);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult8162 = callmethod(num8161, "..", 1, partcv, params);
// compiled op node returning opresult8162 (depth = 5)
  gc_frame_newslot(opresult8162);
// starting to compile block node (depth = 5)
  Object block8163 = alloc_Block(NULL, NULL, "ast", 1958);
  gc_frame_newslot(block8163);
// method _apply
  block_savedest(block8163);
  Object closure8164 = createclosure(2, "_apply");
  setclosureframe(closure8164, stackframe);
  addtoclosure(closure8164, var_spc);
  addtoclosure(closure8164, selfslot);
  struct UserObject *uo8164 = (struct UserObject*)block8163;
  uo8164->data[0] = (Object)closure8164;
  Method *meth_meth_ast__apply8164 = addmethod2pos(block8163, "_apply", &meth_ast__apply8164, 0);
  int argcv_meth_ast__apply8164[] = {1};
  meth_meth_ast__apply8164->type = alloc_MethodType(1, argcv_meth_ast__apply8164);
  meth_meth_ast__apply8164->definitionModule = modulename;
  meth_meth_ast__apply8164->definitionLine = 1953;
// compiled block node returning block8163 (depth = 5)
  gc_frame_newslot(block8163);
// call case 5: prelude request
  params[0] = opresult8162;
  params[1] = block8163;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8171 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8158);
// compiled call node returning call8171 (depth = 4)
// Begin line 1961
  setline(1961);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8173 == NULL) {
    strlit8173 = alloc_String("""\x0a""");
    gc_root(strlit8173);
  }
// compiled string node returning strlit8173 (depth = 6)
  int op_slot_right_8172 = gc_frame_newslot(strlit8173);
// starting to compile call node (depth = 6)
  int callframe8175 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call8176 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe8175);
// compiled call node returning call8176 (depth = 6)
  int op_slot_left_8172 = gc_frame_newslot(call8176);
  params[0] = strlit8173;
  partcv[0] = 1;
  Object opresult8177 = callmethod(call8176, "++", 1, partcv, params);
// compiled op node returning opresult8177 (depth = 5)
  *var_s = opresult8177;
  if (opresult8177 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1962
  setline(1962);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8179 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num8181 = alloc_Float64(1);
// compiled num node returning num8181 (depth = 8)
  int op_slot_right_8180 = gc_frame_newslot(num8181);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_8180 = gc_frame_newslot(*var_depth);
  params[0] = num8181;
  partcv[0] = 1;
  Object sum8183 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum8183 (depth = 7)
  gc_frame_newslot(sum8183);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8184 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8185 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8184);
// compiled call node returning call8185 (depth = 8)
// compiled member node returning call8185 (depth = 7)
  params[0] = sum8183;
  partcv[0] = 1;
  Object call8186 = callmethod(call8185, "pretty",
    1, partcv, params);
  gc_frame_end(callframe8179);
// compiled call node returning call8186 (depth = 6)
  int op_slot_right_8178 = gc_frame_newslot(call8186);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_8188 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_8188 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8190 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8190 (depth = 6)
  int op_slot_left_8178 = gc_frame_newslot(opresult8190);
  params[0] = call8186;
  partcv[0] = 1;
  Object opresult8191 = callmethod(opresult8190, "++", 1, partcv, params);
// compiled op node returning opresult8191 (depth = 5)
  *var_s = opresult8191;
  if (opresult8191 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1963
  setline(1963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8194 == NULL) {
    strlit8194 = alloc_String("""\x0a""");
    gc_root(strlit8194);
  }
// compiled string node returning strlit8194 (depth = 6)
  int op_slot_right_8193 = gc_frame_newslot(strlit8194);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8193 = gc_frame_newslot(*var_s);
  params[0] = strlit8194;
  partcv[0] = 1;
  Object opresult8196 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8196 (depth = 5)
  *var_s = opresult8196;
  if (opresult8196 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1964
  setline(1964);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8199 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num8201 = alloc_Float64(1);
// compiled num node returning num8201 (depth = 8)
  int op_slot_right_8200 = gc_frame_newslot(num8201);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_8200 = gc_frame_newslot(*var_depth);
  params[0] = num8201;
  partcv[0] = 1;
  Object sum8203 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum8203 (depth = 7)
  gc_frame_newslot(sum8203);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8204 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8205 = callmethodflags(self, "index", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8204);
// compiled call node returning call8205 (depth = 8)
// compiled member node returning call8205 (depth = 7)
  params[0] = sum8203;
  partcv[0] = 1;
  Object call8206 = callmethod(call8205, "pretty",
    1, partcv, params);
  gc_frame_end(callframe8199);
// compiled call node returning call8206 (depth = 6)
  int op_slot_right_8198 = gc_frame_newslot(call8206);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_8208 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_8208 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8210 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8210 (depth = 6)
  int op_slot_left_8198 = gc_frame_newslot(opresult8210);
  params[0] = call8206;
  partcv[0] = 1;
  Object opresult8211 = callmethod(opresult8210, "++", 1, partcv, params);
// compiled op node returning opresult8211 (depth = 5)
  *var_s = opresult8211;
  if (opresult8211 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1965
  setline(1965);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply8225(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1970
  setline(1970);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8227 == NULL) {
    strlit8227 = alloc_String("    ");
    gc_root(strlit8227);
  }
// compiled string node returning strlit8227 (depth = 8)
  int op_slot_right_8226 = gc_frame_newslot(strlit8227);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_8226 = gc_frame_newslot(*var_spc);
  params[0] = strlit8227;
  partcv[0] = 1;
  Object opresult8229 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult8229 (depth = 7)
  *var_spc = opresult8229;
  if (opresult8229 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace8213(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1968
  setline(1968);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8214 == NULL) {
    strlit8214 = alloc_String("");
    gc_root(strlit8214);
  }
// compiled string node returning strlit8214 (depth = 5)
  *var_spc = strlit8214;
  if (strlit8214 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1969
  setline(1969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8215 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num8218 = alloc_Float64(1);
// compiled num node returning num8218 (depth = 7)
  int op_slot_right_8217 = gc_frame_newslot(num8218);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_8217 = gc_frame_newslot(*var_depth);
  params[0] = num8218;
  partcv[0] = 1;
  Object diff8220 = callmethod(*var_depth, "-", 1, partcv, params);
// compiled op node returning diff8220 (depth = 6)
  int op_slot_right_8216 = gc_frame_newslot(diff8220);
// starting to compile num node (depth = 6)
  Object num8222 = alloc_Float64(0);
// compiled num node returning num8222 (depth = 6)
  int op_slot_left_8216 = gc_frame_newslot(num8222);
  params[0] = diff8220;
  partcv[0] = 1;
  Object opresult8223 = callmethod(num8222, "..", 1, partcv, params);
// compiled op node returning opresult8223 (depth = 5)
  gc_frame_newslot(opresult8223);
// starting to compile block node (depth = 5)
  Object block8224 = alloc_Block(NULL, NULL, "ast", 1969);
  gc_frame_newslot(block8224);
// method _apply
  block_savedest(block8224);
  Object closure8225 = createclosure(2, "_apply");
  setclosureframe(closure8225, stackframe);
  addtoclosure(closure8225, var_spc);
  addtoclosure(closure8225, selfslot);
  struct UserObject *uo8225 = (struct UserObject*)block8224;
  uo8225->data[0] = (Object)closure8225;
  Method *meth_meth_ast__apply8225 = addmethod2pos(block8224, "_apply", &meth_ast__apply8225, 0);
  int argcv_meth_ast__apply8225[] = {1};
  meth_meth_ast__apply8225->type = alloc_MethodType(1, argcv_meth_ast__apply8225);
  meth_meth_ast__apply8225->definitionModule = modulename;
  meth_meth_ast__apply8225->definitionLine = 1964;
// compiled block node returning block8224 (depth = 5)
  gc_frame_newslot(block8224);
// call case 5: prelude request
  params[0] = opresult8223;
  params[1] = block8224;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8232 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8215);
// compiled call node returning call8232 (depth = 4)
// Begin line 1972
  setline(1972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8233 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num8235 = alloc_Float64(1);
// compiled num node returning num8235 (depth = 7)
  int op_slot_right_8234 = gc_frame_newslot(num8235);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_8234 = gc_frame_newslot(*var_depth);
  params[0] = num8235;
  partcv[0] = 1;
  Object sum8237 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum8237 (depth = 6)
  gc_frame_newslot(sum8237);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8238 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8239 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8238);
// compiled call node returning call8239 (depth = 7)
// compiled member node returning call8239 (depth = 6)
  params[0] = sum8237;
  partcv[0] = 1;
  Object call8240 = callmethod(call8239, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe8233);
// compiled call node returning call8240 (depth = 5)
  *var_s = call8240;
  if (call8240 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1973
  setline(1973);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8242 == NULL) {
    strlit8242 = alloc_String("]");
    gc_root(strlit8242);
  }
// compiled string node returning strlit8242 (depth = 6)
  int op_slot_right_8241 = gc_frame_newslot(strlit8242);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8245 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num8247 = alloc_Float64(1);
// compiled num node returning num8247 (depth = 9)
  int op_slot_right_8246 = gc_frame_newslot(num8247);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_8246 = gc_frame_newslot(*var_depth);
  params[0] = num8247;
  partcv[0] = 1;
  Object sum8249 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum8249 (depth = 8)
  gc_frame_newslot(sum8249);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8250 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8251 = callmethodflags(self, "index", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8250);
// compiled call node returning call8251 (depth = 9)
// compiled member node returning call8251 (depth = 8)
  params[0] = sum8249;
  partcv[0] = 1;
  Object call8252 = callmethod(call8251, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe8245);
// compiled call node returning call8252 (depth = 7)
  int op_slot_right_8244 = gc_frame_newslot(call8252);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8255 == NULL) {
    strlit8255 = alloc_String("[");
    gc_root(strlit8255);
  }
// compiled string node returning strlit8255 (depth = 8)
  int op_slot_right_8254 = gc_frame_newslot(strlit8255);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_8254 = gc_frame_newslot(*var_s);
  params[0] = strlit8255;
  partcv[0] = 1;
  Object opresult8257 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8257 (depth = 7)
  int op_slot_left_8244 = gc_frame_newslot(opresult8257);
  params[0] = call8252;
  partcv[0] = 1;
  Object opresult8258 = callmethod(opresult8257, "++", 1, partcv, params);
// compiled op node returning opresult8258 (depth = 6)
  int op_slot_left_8241 = gc_frame_newslot(opresult8258);
  params[0] = strlit8242;
  partcv[0] = 1;
  Object opresult8259 = callmethod(opresult8258, "++", 1, partcv, params);
// compiled op node returning opresult8259 (depth = 5)
  *var_s = opresult8259;
  if (opresult8259 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1974
  setline(1974);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy8261(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_indexNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1977
  setline(1977);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8262 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe8263 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nullNode (depth = 6)
  gc_frame_newslot(*var_nullNode);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nullNode (depth = 6)
  gc_frame_newslot(*var_nullNode);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_indexNode (depth = 6)
  params[0] = *var_nullNode;
  params[1] = *var_nullNode;
  partcv[0] = 2;
  Object call8264 = callmethod(*var_indexNode, "new",
    1, partcv, params);
  gc_frame_end(callframe8263);
// compiled call node returning call8264 (depth = 5)
  params[0] = self;
  partcv[0] = 1;
  Object call8265 = callmethod(call8264, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe8262);
// compiled call node returning call8265 (depth = 4)
  gc_frame_end(frame);
  return call8265;
}
Object meth_ast_new8117(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_indexNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
  Object *var_index_39_ = &(stackframe->slots[1]);
  *var_index_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject8118 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8118 = alloc_userobj2(11,10, objclass8118);
  gc_frame_newslot(obj8118);
if (objclass8118 == NULL) {
  glfree(obj8118->class->name);
  obj8118->class->name = "indexNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj8118, self, 0);
  addmethodreal(obj8118,"outer", &reader_ast_outer_8119);
  Object oldself8118 = self;
  struct StackFrameObject *oldstackframe8118 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8118);
  gc_frame_newslot((Object)stackframe);
  self = obj8118;
  Object *oldselfslot8118 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8118 = (*(struct UserObject *)self).data[0], lowerouter8118 = thisouter8118;
  if (inheritingObject8118) {
    struct UserObject *inho8118 = (struct UserObject *)inheritingObject8118;
    while (inho8118->super != GraceDefaultObject) inho8118 = (struct UserObject *)inho8118->super;
    inho8118->super = obj8118;
    self = inheritingObject8118;
    *selfslot = self;
    lowerouter8118 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8118;
  }
if (objclass8118 == NULL) {
  Method *reader8120 = addmethodrealflags(obj8118, "kind",&reader_ast_kind_8120, MFLAG_DEF);
  reader8120->definitionModule = modulename;
  reader8120->definitionLine = 1938;
}
adddatum2(obj8118, alloc_Undefined(), 1);
if (objclass8118 == NULL) {
  Method *reader8121 = addmethodrealflags(obj8118, "value",&reader_ast_value_8121, 0);
  Method *writer8121 = addmethodrealflags(obj8118, "value:=",&writer_ast_value_8121, 0);
  reader8121->definitionModule = modulename;
  writer8121->definitionModule = modulename;
  reader8121->definitionLine = 1939;
  writer8121->definitionLine = 1939;
}
obj8118->flags |= OFLAG_MUTABLE;
adddatum2(obj8118, alloc_Undefined(), 2);
if (objclass8118 == NULL) {
  Method *reader8122 = addmethodrealflags(obj8118, "index",&reader_ast_index_8122, 0);
  Method *writer8122 = addmethodrealflags(obj8118, "index:=",&writer_ast_index_8122, 0);
  reader8122->definitionModule = modulename;
  writer8122->definitionModule = modulename;
  reader8122->definitionLine = 1940;
  writer8122->definitionLine = 1940;
}
obj8118->flags |= OFLAG_MUTABLE;
adddatum2(obj8118, alloc_Undefined(), 3);
// method accept()from
  struct UserObject *uo8123 = (struct UserObject*)obj8118;
  uo8123->data[4] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from8123 = addmethod2pos(obj8118, "accept()from", &meth_ast_accept_40__41_from8123, 4);
  int argcv_meth_ast_accept_40__41_from8123[] = {1, 1};
  meth_meth_ast_accept_40__41_from8123->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from8123);
  meth_meth_ast_accept_40__41_from8123->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from8123->definitionLine = 1942;
// method map()ancestors
  struct UserObject *uo8137 = (struct UserObject*)obj8118;
  uo8137->data[5] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors8137 = addmethod2pos(obj8118, "map()ancestors", &meth_ast_map_40__41_ancestors8137, 5);
  int argcv_meth_ast_map_40__41_ancestors8137[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors8137->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors8137);
  meth_meth_ast_map_40__41_ancestors8137->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors8137->definitionLine = 1949;
// method pretty
  struct UserObject *uo8156 = (struct UserObject*)obj8118;
  uo8156->data[6] = emptyclosure;
  Method *meth_meth_ast_pretty8156 = addmethod2pos(obj8118, "pretty", &meth_ast_pretty8156, 6);
  int argcv_meth_ast_pretty8156[] = {1};
  meth_meth_ast_pretty8156->type = alloc_MethodType(1, argcv_meth_ast_pretty8156);
  meth_meth_ast_pretty8156->definitionModule = modulename;
  meth_meth_ast_pretty8156->definitionLine = 1956;
// method toGrace
  struct UserObject *uo8213 = (struct UserObject*)obj8118;
  uo8213->data[7] = emptyclosure;
  Method *meth_meth_ast_toGrace8213 = addmethod2pos(obj8118, "toGrace", &meth_ast_toGrace8213, 7);
  int argcv_meth_ast_toGrace8213[] = {1};
  meth_meth_ast_toGrace8213->type = alloc_MethodType(1, argcv_meth_ast_toGrace8213);
meth_meth_ast_toGrace8213->type->types[0] = type_Number;
meth_meth_ast_toGrace8213->type->names[0] = "depth";
  meth_meth_ast_toGrace8213->definitionModule = modulename;
  meth_meth_ast_toGrace8213->definitionLine = 1967;
// method shallowCopy
  block_savedest(obj8118);
  Object closure8261 = createclosure(2, "shallowCopy");
  setclosureframe(closure8261, stackframe);
  addtoclosure(closure8261, var_nullNode);
  addtoclosure(closure8261, var_indexNode);
  struct UserObject *uo8261 = (struct UserObject*)obj8118;
  uo8261->data[8] = (Object)closure8261;
  Method *meth_meth_ast_shallowCopy8261 = addmethod2pos(obj8118, "shallowCopy", &meth_ast_shallowCopy8261, 8);
  int argcv_meth_ast_shallowCopy8261[] = {0};
  meth_meth_ast_shallowCopy8261->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy8261);
  meth_meth_ast_shallowCopy8261->definitionModule = modulename;
  meth_meth_ast_shallowCopy8261->definitionLine = 1976;
  sourceObject = obj8118;
// Begin line 1937
  setline(1937);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8266 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call8267 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe8266);
// compiled call node returning call8267 (depth = 4)
  struct UserObject *obj8118_uo = (struct UserObject *)obj8118;
  obj8118_uo->super = call8267;
  sourceObject = obj8118;
// Begin line 1938
  setline(1938);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit8268 == NULL) {
    strlit8268 = alloc_String("index");
    gc_root(strlit8268);
  }
// compiled string node returning strlit8268 (depth = 4)
  adddatum2(obj8118, strlit8268, 1);
  sourceObject = obj8118;
// Begin line 1939
  setline(1939);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_expr (depth = 4)
  adddatum2(obj8118, *var_expr, 2);
  sourceObject = obj8118;
// Begin line 1940
  setline(1940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_index_39_ (depth = 4)
  adddatum2(obj8118, *var_index_39_, 3);
  sourceObject = obj8118;
  sourceObject = obj8118;
  sourceObject = obj8118;
  sourceObject = obj8118;
  sourceObject = obj8118;
  objclass8118 = obj8118->class;
  objclass8118->definitionModule = modulename;
  objclass8118->definitionLine = 1935;
  (*(struct UserObject *)self).data[0] = lowerouter8118;
  self = oldself8118;
  selfslot = oldselfslot8118;
  stackframe = oldstackframe8118;
  gc_frame_end(frame);
  return obj8118;
}
Object meth_ast_new8117_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_indexNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
  Object *var_index_39_ = &(stackframe->slots[1]);
  *var_index_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject8118 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8118 = alloc_userobj2(11,10, objclass8118);
  gc_frame_newslot(obj8118);
if (objclass8118 == NULL) {
  glfree(obj8118->class->name);
  obj8118->class->name = "indexNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj8118, self, 0);
  addmethodreal(obj8118,"outer", &reader_ast_outer_8119);
  Object oldself8118 = self;
  struct StackFrameObject *oldstackframe8118 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8118);
  gc_frame_newslot((Object)stackframe);
  self = obj8118;
  Object *oldselfslot8118 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8118 = (*(struct UserObject *)self).data[0], lowerouter8118 = thisouter8118;
  if (inheritingObject8118) {
    struct UserObject *inho8118 = (struct UserObject *)inheritingObject8118;
    while (inho8118->super != GraceDefaultObject) inho8118 = (struct UserObject *)inho8118->super;
    inho8118->super = obj8118;
    self = inheritingObject8118;
    *selfslot = self;
    lowerouter8118 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8118;
  }
if (objclass8118 == NULL) {
  Method *reader8120 = addmethodrealflags(obj8118, "kind",&reader_ast_kind_8120, MFLAG_DEF);
  reader8120->definitionModule = modulename;
  reader8120->definitionLine = 1938;
}
adddatum2(obj8118, alloc_Undefined(), 1);
if (objclass8118 == NULL) {
  Method *reader8121 = addmethodrealflags(obj8118, "value",&reader_ast_value_8121, 0);
  Method *writer8121 = addmethodrealflags(obj8118, "value:=",&writer_ast_value_8121, 0);
  reader8121->definitionModule = modulename;
  writer8121->definitionModule = modulename;
  reader8121->definitionLine = 1939;
  writer8121->definitionLine = 1939;
}
obj8118->flags |= OFLAG_MUTABLE;
adddatum2(obj8118, alloc_Undefined(), 2);
if (objclass8118 == NULL) {
  Method *reader8122 = addmethodrealflags(obj8118, "index",&reader_ast_index_8122, 0);
  Method *writer8122 = addmethodrealflags(obj8118, "index:=",&writer_ast_index_8122, 0);
  reader8122->definitionModule = modulename;
  writer8122->definitionModule = modulename;
  reader8122->definitionLine = 1940;
  writer8122->definitionLine = 1940;
}
obj8118->flags |= OFLAG_MUTABLE;
adddatum2(obj8118, alloc_Undefined(), 3);
// method accept()from
  struct UserObject *uo8123 = (struct UserObject*)obj8118;
  uo8123->data[4] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from8123 = addmethod2pos(obj8118, "accept()from", &meth_ast_accept_40__41_from8123, 4);
  int argcv_meth_ast_accept_40__41_from8123[] = {1, 1};
  meth_meth_ast_accept_40__41_from8123->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from8123);
  meth_meth_ast_accept_40__41_from8123->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from8123->definitionLine = 1942;
// method map()ancestors
  struct UserObject *uo8137 = (struct UserObject*)obj8118;
  uo8137->data[5] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors8137 = addmethod2pos(obj8118, "map()ancestors", &meth_ast_map_40__41_ancestors8137, 5);
  int argcv_meth_ast_map_40__41_ancestors8137[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors8137->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors8137);
  meth_meth_ast_map_40__41_ancestors8137->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors8137->definitionLine = 1949;
// method pretty
  struct UserObject *uo8156 = (struct UserObject*)obj8118;
  uo8156->data[6] = emptyclosure;
  Method *meth_meth_ast_pretty8156 = addmethod2pos(obj8118, "pretty", &meth_ast_pretty8156, 6);
  int argcv_meth_ast_pretty8156[] = {1};
  meth_meth_ast_pretty8156->type = alloc_MethodType(1, argcv_meth_ast_pretty8156);
  meth_meth_ast_pretty8156->definitionModule = modulename;
  meth_meth_ast_pretty8156->definitionLine = 1956;
// method toGrace
  struct UserObject *uo8213 = (struct UserObject*)obj8118;
  uo8213->data[7] = emptyclosure;
  Method *meth_meth_ast_toGrace8213 = addmethod2pos(obj8118, "toGrace", &meth_ast_toGrace8213, 7);
  int argcv_meth_ast_toGrace8213[] = {1};
  meth_meth_ast_toGrace8213->type = alloc_MethodType(1, argcv_meth_ast_toGrace8213);
meth_meth_ast_toGrace8213->type->types[0] = type_Number;
meth_meth_ast_toGrace8213->type->names[0] = "depth";
  meth_meth_ast_toGrace8213->definitionModule = modulename;
  meth_meth_ast_toGrace8213->definitionLine = 1967;
// method shallowCopy
  block_savedest(obj8118);
  Object closure8261 = createclosure(2, "shallowCopy");
  setclosureframe(closure8261, stackframe);
  addtoclosure(closure8261, var_nullNode);
  addtoclosure(closure8261, var_indexNode);
  struct UserObject *uo8261 = (struct UserObject*)obj8118;
  uo8261->data[8] = (Object)closure8261;
  Method *meth_meth_ast_shallowCopy8261 = addmethod2pos(obj8118, "shallowCopy", &meth_ast_shallowCopy8261, 8);
  int argcv_meth_ast_shallowCopy8261[] = {0};
  meth_meth_ast_shallowCopy8261->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy8261);
  meth_meth_ast_shallowCopy8261->definitionModule = modulename;
  meth_meth_ast_shallowCopy8261->definitionLine = 1976;
  sourceObject = obj8118;
// Begin line 1937
  setline(1937);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8266 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call8267 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe8266);
// compiled call node returning call8267 (depth = 4)
  struct UserObject *obj8118_uo = (struct UserObject *)obj8118;
  obj8118_uo->super = call8267;
  sourceObject = obj8118;
// Begin line 1938
  setline(1938);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit8268 == NULL) {
    strlit8268 = alloc_String("index");
    gc_root(strlit8268);
  }
// compiled string node returning strlit8268 (depth = 4)
  adddatum2(obj8118, strlit8268, 1);
  sourceObject = obj8118;
// Begin line 1939
  setline(1939);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_expr (depth = 4)
  adddatum2(obj8118, *var_expr, 2);
  sourceObject = obj8118;
// Begin line 1940
  setline(1940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_index_39_ (depth = 4)
  adddatum2(obj8118, *var_index_39_, 3);
  sourceObject = obj8118;
  sourceObject = obj8118;
  sourceObject = obj8118;
  sourceObject = obj8118;
  sourceObject = obj8118;
  objclass8118 = obj8118->class;
  objclass8118->definitionModule = modulename;
  objclass8118->definitionLine = 1935;
  (*(struct UserObject *)self).data[0] = lowerouter8118;
  self = oldself8118;
  selfslot = oldselfslot8118;
  stackframe = oldstackframe8118;
  gc_frame_end(frame);
  return obj8118;
}
Object meth_ast_bindNode8270(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 39, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "bindNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_bindNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for bindNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for bindNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_bindNode (depth = 3)
  gc_frame_end(frame);
  return *var_bindNode;
}
Object meth_ast_isBind8279(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isBind");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isBind (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isBind");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1987
  setline(1987);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool8280 = alloc_Boolean(1);
// compiled identifier node returning bool8280 (depth = 4)
  gc_frame_end(frame);
  return bool8280;
}
Object meth_ast_asString8281(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1988
  setline(1988);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8283 == NULL) {
    strlit8283 = alloc_String("");
    gc_root(strlit8283);
  }
// compiled string node returning strlit8283 (depth = 5)
  int op_slot_right_8282 = gc_frame_newslot(strlit8283);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8286 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8287 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8286);
// compiled call node returning call8287 (depth = 7)
// compiled member node returning call8287 (depth = 6)
  int op_slot_right_8285 = gc_frame_newslot(call8287);
// starting to compile string node (depth = 6)
  if (strlit8289 == NULL) {
    strlit8289 = alloc_String("bind ");
    gc_root(strlit8289);
  }
// compiled string node returning strlit8289 (depth = 6)
  int op_slot_left_8285 = gc_frame_newslot(strlit8289);
  params[0] = call8287;
  partcv[0] = 1;
  Object opresult8290 = callmethod(strlit8289, "++", 1, partcv, params);
// compiled op node returning opresult8290 (depth = 5)
  int op_slot_left_8282 = gc_frame_newslot(opresult8290);
  params[0] = strlit8283;
  partcv[0] = 1;
  Object opresult8291 = callmethod(opresult8290, "++", 1, partcv, params);
// compiled op node returning opresult8291 (depth = 4)
  gc_frame_end(frame);
  return opresult8291;
}
Object meth_ast_accept_40__41_from8292(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1990
  setline(1990);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8294 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8295 = callmethod(*var_visitor, "visitBind()up",
    2, partcv, params);
  gc_frame_end(callframe8294);
// compiled call node returning call8295 (depth = 5)
  Object if8293 = done;
  if (istrue(call8295)) {
// Begin line 1991
  setline(1991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8296 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_as (depth = 7)
  params[0] = self;
  partcv[0] = 1;
  Object call8297 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe8296);
// compiled call node returning call8297 (depth = 6)
  *var_newChain = call8297;
  if (call8297 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 1992
  setline(1992);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8298 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8299 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8300 = callmethodflags(self, "dest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8299);
// compiled call node returning call8300 (depth = 7)
// compiled member node returning call8300 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8301 = callmethod(call8300, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe8298);
// compiled call node returning call8301 (depth = 5)
// Begin line 1993
  setline(1993);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8302 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8303 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8304 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8303);
// compiled call node returning call8304 (depth = 7)
// compiled member node returning call8304 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8305 = callmethod(call8304, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe8302);
// compiled call node returning call8305 (depth = 5)
    gc_frame_newslot(call8305);
    if8293 = call8305;
  } else {
  }
// compiled if node returning if8293 (depth = 4)
  gc_frame_end(frame);
  return if8293;
}
Object meth_ast_map_40__41_ancestors8306(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1997
  setline(1997);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8307 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8308 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8307);
// compiled call node returning call8308 (depth = 6)
// compiled member node returning call8308 (depth = 5)
  *var_n = call8308;
  if (call8308 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1998
  setline(1998);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8309 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call8310 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe8309);
// compiled call node returning call8310 (depth = 5)
  *var_newChain = call8310;
  if (call8310 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1999
  setline(1999);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1997
  setline(1997);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8311 = gc_frame_new();
// Begin line 1999
  setline(1999);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8312 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8313 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8314 = callmethodflags(self, "dest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8313);
// compiled call node returning call8314 (depth = 8)
// compiled member node returning call8314 (depth = 7)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8315 = callmethod(call8314, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe8312);
// compiled call node returning call8315 (depth = 6)
  gc_frame_newslot(call8315);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call8315;
  partcv[0] = 1;
  Object call8316 = callmethod(*var_n, "dest:=",
    1, partcv, params);
  gc_frame_end(callframe8311);
// compiled call node returning call8316 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 2000
  setline(2000);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1999
  setline(1999);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8317 = gc_frame_new();
// Begin line 2000
  setline(2000);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8318 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8319 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8320 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8319);
// compiled call node returning call8320 (depth = 8)
// compiled member node returning call8320 (depth = 7)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8321 = callmethod(call8320, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe8318);
// compiled call node returning call8321 (depth = 6)
  gc_frame_newslot(call8321);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call8321;
  partcv[0] = 1;
  Object call8322 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe8317);
// compiled call node returning call8322 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 2001
  setline(2001);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8323 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call8324 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe8323);
// compiled call node returning call8324 (depth = 4)
  gc_frame_end(frame);
  return call8324;
}
Object meth_ast__apply8333(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2006
  setline(2006);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8335 == NULL) {
    strlit8335 = alloc_String("  ");
    gc_root(strlit8335);
  }
// compiled string node returning strlit8335 (depth = 8)
  int op_slot_right_8334 = gc_frame_newslot(strlit8335);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_8334 = gc_frame_newslot(*var_spc);
  params[0] = strlit8335;
  partcv[0] = 1;
  Object opresult8337 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult8337 (depth = 7)
  *var_spc = opresult8337;
  if (opresult8337 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty8325(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2004
  setline(2004);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8326 == NULL) {
    strlit8326 = alloc_String("");
    gc_root(strlit8326);
  }
// compiled string node returning strlit8326 (depth = 5)
  *var_spc = strlit8326;
  if (strlit8326 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2005
  setline(2005);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8327 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_right_8328 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 6)
  Object num8330 = alloc_Float64(0);
// compiled num node returning num8330 (depth = 6)
  int op_slot_left_8328 = gc_frame_newslot(num8330);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult8331 = callmethod(num8330, "..", 1, partcv, params);
// compiled op node returning opresult8331 (depth = 5)
  gc_frame_newslot(opresult8331);
// starting to compile block node (depth = 5)
  Object block8332 = alloc_Block(NULL, NULL, "ast", 2005);
  gc_frame_newslot(block8332);
// method _apply
  block_savedest(block8332);
  Object closure8333 = createclosure(2, "_apply");
  setclosureframe(closure8333, stackframe);
  addtoclosure(closure8333, var_spc);
  addtoclosure(closure8333, selfslot);
  struct UserObject *uo8333 = (struct UserObject*)block8332;
  uo8333->data[0] = (Object)closure8333;
  Method *meth_meth_ast__apply8333 = addmethod2pos(block8332, "_apply", &meth_ast__apply8333, 0);
  int argcv_meth_ast__apply8333[] = {1};
  meth_meth_ast__apply8333->type = alloc_MethodType(1, argcv_meth_ast__apply8333);
  meth_meth_ast__apply8333->definitionModule = modulename;
  meth_meth_ast__apply8333->definitionLine = 2000;
// compiled block node returning block8332 (depth = 5)
  gc_frame_newslot(block8332);
// call case 5: prelude request
  params[0] = opresult8331;
  params[1] = block8332;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8340 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8327);
// compiled call node returning call8340 (depth = 4)
// Begin line 2008
  setline(2008);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8342 == NULL) {
    strlit8342 = alloc_String("""\x0a""");
    gc_root(strlit8342);
  }
// compiled string node returning strlit8342 (depth = 6)
  int op_slot_right_8341 = gc_frame_newslot(strlit8342);
// starting to compile call node (depth = 6)
  int callframe8344 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call8345 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe8344);
// compiled call node returning call8345 (depth = 6)
  int op_slot_left_8341 = gc_frame_newslot(call8345);
  params[0] = strlit8342;
  partcv[0] = 1;
  Object opresult8346 = callmethod(call8345, "++", 1, partcv, params);
// compiled op node returning opresult8346 (depth = 5)
  *var_s = opresult8346;
  if (opresult8346 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2009
  setline(2009);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8348 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num8350 = alloc_Float64(1);
// compiled num node returning num8350 (depth = 8)
  int op_slot_right_8349 = gc_frame_newslot(num8350);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_8349 = gc_frame_newslot(*var_depth);
  params[0] = num8350;
  partcv[0] = 1;
  Object sum8352 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum8352 (depth = 7)
  gc_frame_newslot(sum8352);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8353 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8354 = callmethodflags(self, "dest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8353);
// compiled call node returning call8354 (depth = 8)
// compiled member node returning call8354 (depth = 7)
  params[0] = sum8352;
  partcv[0] = 1;
  Object call8355 = callmethod(call8354, "pretty",
    1, partcv, params);
  gc_frame_end(callframe8348);
// compiled call node returning call8355 (depth = 6)
  int op_slot_right_8347 = gc_frame_newslot(call8355);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_8357 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_8357 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8359 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8359 (depth = 6)
  int op_slot_left_8347 = gc_frame_newslot(opresult8359);
  params[0] = call8355;
  partcv[0] = 1;
  Object opresult8360 = callmethod(opresult8359, "++", 1, partcv, params);
// compiled op node returning opresult8360 (depth = 5)
  *var_s = opresult8360;
  if (opresult8360 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2010
  setline(2010);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8363 == NULL) {
    strlit8363 = alloc_String("""\x0a""");
    gc_root(strlit8363);
  }
// compiled string node returning strlit8363 (depth = 6)
  int op_slot_right_8362 = gc_frame_newslot(strlit8363);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8362 = gc_frame_newslot(*var_s);
  params[0] = strlit8363;
  partcv[0] = 1;
  Object opresult8365 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8365 (depth = 5)
  *var_s = opresult8365;
  if (opresult8365 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2011
  setline(2011);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8368 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num8370 = alloc_Float64(1);
// compiled num node returning num8370 (depth = 8)
  int op_slot_right_8369 = gc_frame_newslot(num8370);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_8369 = gc_frame_newslot(*var_depth);
  params[0] = num8370;
  partcv[0] = 1;
  Object sum8372 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum8372 (depth = 7)
  gc_frame_newslot(sum8372);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8373 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8374 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8373);
// compiled call node returning call8374 (depth = 8)
// compiled member node returning call8374 (depth = 7)
  params[0] = sum8372;
  partcv[0] = 1;
  Object call8375 = callmethod(call8374, "pretty",
    1, partcv, params);
  gc_frame_end(callframe8368);
// compiled call node returning call8375 (depth = 6)
  int op_slot_right_8367 = gc_frame_newslot(call8375);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_8377 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_8377 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8379 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8379 (depth = 6)
  int op_slot_left_8367 = gc_frame_newslot(opresult8379);
  params[0] = call8375;
  partcv[0] = 1;
  Object opresult8380 = callmethod(opresult8379, "++", 1, partcv, params);
// compiled op node returning opresult8380 (depth = 5)
  *var_s = opresult8380;
  if (opresult8380 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2012
  setline(2012);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply8394(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2017
  setline(2017);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8396 == NULL) {
    strlit8396 = alloc_String("    ");
    gc_root(strlit8396);
  }
// compiled string node returning strlit8396 (depth = 8)
  int op_slot_right_8395 = gc_frame_newslot(strlit8396);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_8395 = gc_frame_newslot(*var_spc);
  params[0] = strlit8396;
  partcv[0] = 1;
  Object opresult8398 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult8398 (depth = 7)
  *var_spc = opresult8398;
  if (opresult8398 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace8382(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2015
  setline(2015);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8383 == NULL) {
    strlit8383 = alloc_String("");
    gc_root(strlit8383);
  }
// compiled string node returning strlit8383 (depth = 5)
  *var_spc = strlit8383;
  if (strlit8383 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2016
  setline(2016);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8384 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num8387 = alloc_Float64(1);
// compiled num node returning num8387 (depth = 7)
  int op_slot_right_8386 = gc_frame_newslot(num8387);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_8386 = gc_frame_newslot(*var_depth);
  params[0] = num8387;
  partcv[0] = 1;
  Object diff8389 = callmethod(*var_depth, "-", 1, partcv, params);
// compiled op node returning diff8389 (depth = 6)
  int op_slot_right_8385 = gc_frame_newslot(diff8389);
// starting to compile num node (depth = 6)
  Object num8391 = alloc_Float64(0);
// compiled num node returning num8391 (depth = 6)
  int op_slot_left_8385 = gc_frame_newslot(num8391);
  params[0] = diff8389;
  partcv[0] = 1;
  Object opresult8392 = callmethod(num8391, "..", 1, partcv, params);
// compiled op node returning opresult8392 (depth = 5)
  gc_frame_newslot(opresult8392);
// starting to compile block node (depth = 5)
  Object block8393 = alloc_Block(NULL, NULL, "ast", 2016);
  gc_frame_newslot(block8393);
// method _apply
  block_savedest(block8393);
  Object closure8394 = createclosure(2, "_apply");
  setclosureframe(closure8394, stackframe);
  addtoclosure(closure8394, var_spc);
  addtoclosure(closure8394, selfslot);
  struct UserObject *uo8394 = (struct UserObject*)block8393;
  uo8394->data[0] = (Object)closure8394;
  Method *meth_meth_ast__apply8394 = addmethod2pos(block8393, "_apply", &meth_ast__apply8394, 0);
  int argcv_meth_ast__apply8394[] = {1};
  meth_meth_ast__apply8394->type = alloc_MethodType(1, argcv_meth_ast__apply8394);
  meth_meth_ast__apply8394->definitionModule = modulename;
  meth_meth_ast__apply8394->definitionLine = 2011;
// compiled block node returning block8393 (depth = 5)
  gc_frame_newslot(block8393);
// call case 5: prelude request
  params[0] = opresult8392;
  params[1] = block8393;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8401 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8384);
// compiled call node returning call8401 (depth = 4)
// Begin line 2019
  setline(2019);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8402 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num8404 = alloc_Float64(1);
// compiled num node returning num8404 (depth = 7)
  int op_slot_right_8403 = gc_frame_newslot(num8404);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_8403 = gc_frame_newslot(*var_depth);
  params[0] = num8404;
  partcv[0] = 1;
  Object sum8406 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum8406 (depth = 6)
  gc_frame_newslot(sum8406);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8407 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8408 = callmethodflags(self, "dest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8407);
// compiled call node returning call8408 (depth = 7)
// compiled member node returning call8408 (depth = 6)
  params[0] = sum8406;
  partcv[0] = 1;
  Object call8409 = callmethod(call8408, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe8402);
// compiled call node returning call8409 (depth = 5)
  *var_s = call8409;
  if (call8409 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2020
  setline(2020);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8411 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num8413 = alloc_Float64(1);
// compiled num node returning num8413 (depth = 8)
  int op_slot_right_8412 = gc_frame_newslot(num8413);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_8412 = gc_frame_newslot(*var_depth);
  params[0] = num8413;
  partcv[0] = 1;
  Object sum8415 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum8415 (depth = 7)
  gc_frame_newslot(sum8415);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8416 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8417 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8416);
// compiled call node returning call8417 (depth = 8)
// compiled member node returning call8417 (depth = 7)
  params[0] = sum8415;
  partcv[0] = 1;
  Object call8418 = callmethod(call8417, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe8411);
// compiled call node returning call8418 (depth = 6)
  int op_slot_right_8410 = gc_frame_newslot(call8418);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8421 == NULL) {
    strlit8421 = alloc_String(" := ");
    gc_root(strlit8421);
  }
// compiled string node returning strlit8421 (depth = 7)
  int op_slot_right_8420 = gc_frame_newslot(strlit8421);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_8420 = gc_frame_newslot(*var_s);
  params[0] = strlit8421;
  partcv[0] = 1;
  Object opresult8423 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8423 (depth = 6)
  int op_slot_left_8410 = gc_frame_newslot(opresult8423);
  params[0] = call8418;
  partcv[0] = 1;
  Object opresult8424 = callmethod(opresult8423, "++", 1, partcv, params);
// compiled op node returning opresult8424 (depth = 5)
  *var_s = opresult8424;
  if (opresult8424 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2021
  setline(2021);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy8426(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_bindNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2024
  setline(2024);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8427 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe8428 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8429 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8430 = callmethodflags(self, "dest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8429);
// compiled call node returning call8430 (depth = 7)
// compiled member node returning call8430 (depth = 6)
  gc_frame_newslot(call8430);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8431 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8432 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8431);
// compiled call node returning call8432 (depth = 7)
// compiled member node returning call8432 (depth = 6)
  gc_frame_newslot(call8432);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_bindNode (depth = 6)
  params[0] = call8430;
  params[1] = call8432;
  partcv[0] = 2;
  Object call8433 = callmethod(*var_bindNode, "new",
    1, partcv, params);
  gc_frame_end(callframe8428);
// compiled call node returning call8433 (depth = 5)
  params[0] = self;
  partcv[0] = 1;
  Object call8434 = callmethod(call8433, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe8427);
// compiled call node returning call8434 (depth = 4)
  gc_frame_end(frame);
  return call8434;
}
Object meth_ast_new8273(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_bindNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_dest_39_ = &(stackframe->slots[0]);
  *var_dest_39_ = args[curarg];
  curarg++;
  Object *var_val_39_ = &(stackframe->slots[1]);
  *var_val_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject8274 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8274 = alloc_userobj2(13,12, objclass8274);
  gc_frame_newslot(obj8274);
if (objclass8274 == NULL) {
  glfree(obj8274->class->name);
  obj8274->class->name = "bindNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj8274, self, 0);
  addmethodreal(obj8274,"outer", &reader_ast_outer_8275);
  Object oldself8274 = self;
  struct StackFrameObject *oldstackframe8274 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8274);
  gc_frame_newslot((Object)stackframe);
  self = obj8274;
  Object *oldselfslot8274 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8274 = (*(struct UserObject *)self).data[0], lowerouter8274 = thisouter8274;
  if (inheritingObject8274) {
    struct UserObject *inho8274 = (struct UserObject *)inheritingObject8274;
    while (inho8274->super != GraceDefaultObject) inho8274 = (struct UserObject *)inho8274->super;
    inho8274->super = obj8274;
    self = inheritingObject8274;
    *selfslot = self;
    lowerouter8274 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8274;
  }
if (objclass8274 == NULL) {
  Method *reader8276 = addmethodrealflags(obj8274, "kind",&reader_ast_kind_8276, MFLAG_DEF);
  reader8276->definitionModule = modulename;
  reader8276->definitionLine = 1983;
}
adddatum2(obj8274, alloc_Undefined(), 1);
if (objclass8274 == NULL) {
  Method *reader8277 = addmethodrealflags(obj8274, "dest",&reader_ast_dest_8277, 0);
  Method *writer8277 = addmethodrealflags(obj8274, "dest:=",&writer_ast_dest_8277, 0);
  reader8277->definitionModule = modulename;
  writer8277->definitionModule = modulename;
  reader8277->definitionLine = 1984;
  writer8277->definitionLine = 1984;
}
obj8274->flags |= OFLAG_MUTABLE;
adddatum2(obj8274, alloc_Undefined(), 2);
if (objclass8274 == NULL) {
  Method *reader8278 = addmethodrealflags(obj8274, "value",&reader_ast_value_8278, 0);
  Method *writer8278 = addmethodrealflags(obj8274, "value:=",&writer_ast_value_8278, 0);
  reader8278->definitionModule = modulename;
  writer8278->definitionModule = modulename;
  reader8278->definitionLine = 1985;
  writer8278->definitionLine = 1985;
}
obj8274->flags |= OFLAG_MUTABLE;
adddatum2(obj8274, alloc_Undefined(), 3);
// method isBind
  struct UserObject *uo8279 = (struct UserObject*)obj8274;
  uo8279->data[4] = emptyclosure;
  Method *meth_meth_ast_isBind8279 = addmethod2pos(obj8274, "isBind", &meth_ast_isBind8279, 4);
  int argcv_meth_ast_isBind8279[] = {0};
  meth_meth_ast_isBind8279->type = alloc_MethodType(1, argcv_meth_ast_isBind8279);
  meth_meth_ast_isBind8279->definitionModule = modulename;
  meth_meth_ast_isBind8279->definitionLine = 1987;
// method asString
  struct UserObject *uo8281 = (struct UserObject*)obj8274;
  uo8281->data[5] = emptyclosure;
  Method *meth_meth_ast_asString8281 = addmethod2pos(obj8274, "asString", &meth_ast_asString8281, 5);
  int argcv_meth_ast_asString8281[] = {0};
  meth_meth_ast_asString8281->type = alloc_MethodType(1, argcv_meth_ast_asString8281);
  meth_meth_ast_asString8281->definitionModule = modulename;
  meth_meth_ast_asString8281->definitionLine = 1988;
// method accept()from
  struct UserObject *uo8292 = (struct UserObject*)obj8274;
  uo8292->data[6] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from8292 = addmethod2pos(obj8274, "accept()from", &meth_ast_accept_40__41_from8292, 6);
  int argcv_meth_ast_accept_40__41_from8292[] = {1, 1};
  meth_meth_ast_accept_40__41_from8292->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from8292);
  meth_meth_ast_accept_40__41_from8292->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from8292->definitionLine = 1989;
// method map()ancestors
  struct UserObject *uo8306 = (struct UserObject*)obj8274;
  uo8306->data[7] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors8306 = addmethod2pos(obj8274, "map()ancestors", &meth_ast_map_40__41_ancestors8306, 7);
  int argcv_meth_ast_map_40__41_ancestors8306[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors8306->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors8306);
  meth_meth_ast_map_40__41_ancestors8306->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors8306->definitionLine = 1996;
// method pretty
  struct UserObject *uo8325 = (struct UserObject*)obj8274;
  uo8325->data[8] = emptyclosure;
  Method *meth_meth_ast_pretty8325 = addmethod2pos(obj8274, "pretty", &meth_ast_pretty8325, 8);
  int argcv_meth_ast_pretty8325[] = {1};
  meth_meth_ast_pretty8325->type = alloc_MethodType(1, argcv_meth_ast_pretty8325);
  meth_meth_ast_pretty8325->definitionModule = modulename;
  meth_meth_ast_pretty8325->definitionLine = 2003;
// method toGrace
  struct UserObject *uo8382 = (struct UserObject*)obj8274;
  uo8382->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace8382 = addmethod2pos(obj8274, "toGrace", &meth_ast_toGrace8382, 9);
  int argcv_meth_ast_toGrace8382[] = {1};
  meth_meth_ast_toGrace8382->type = alloc_MethodType(1, argcv_meth_ast_toGrace8382);
meth_meth_ast_toGrace8382->type->types[0] = type_Number;
meth_meth_ast_toGrace8382->type->names[0] = "depth";
  meth_meth_ast_toGrace8382->definitionModule = modulename;
  meth_meth_ast_toGrace8382->definitionLine = 2014;
// method shallowCopy
  block_savedest(obj8274);
  Object closure8426 = createclosure(1, "shallowCopy");
  setclosureframe(closure8426, stackframe);
  addtoclosure(closure8426, var_bindNode);
  struct UserObject *uo8426 = (struct UserObject*)obj8274;
  uo8426->data[10] = (Object)closure8426;
  Method *meth_meth_ast_shallowCopy8426 = addmethod2pos(obj8274, "shallowCopy", &meth_ast_shallowCopy8426, 10);
  int argcv_meth_ast_shallowCopy8426[] = {0};
  meth_meth_ast_shallowCopy8426->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy8426);
  meth_meth_ast_shallowCopy8426->definitionModule = modulename;
  meth_meth_ast_shallowCopy8426->definitionLine = 2023;
  sourceObject = obj8274;
// Begin line 1982
  setline(1982);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8435 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call8436 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe8435);
// compiled call node returning call8436 (depth = 4)
  struct UserObject *obj8274_uo = (struct UserObject *)obj8274;
  obj8274_uo->super = call8436;
  sourceObject = obj8274;
// Begin line 1983
  setline(1983);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit8437 == NULL) {
    strlit8437 = alloc_String("bind");
    gc_root(strlit8437);
  }
// compiled string node returning strlit8437 (depth = 4)
  adddatum2(obj8274, strlit8437, 1);
  sourceObject = obj8274;
// Begin line 1984
  setline(1984);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_dest_39_ (depth = 4)
  adddatum2(obj8274, *var_dest_39_, 2);
  sourceObject = obj8274;
// Begin line 1985
  setline(1985);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_val_39_ (depth = 4)
  adddatum2(obj8274, *var_val_39_, 3);
  sourceObject = obj8274;
  sourceObject = obj8274;
  sourceObject = obj8274;
  sourceObject = obj8274;
  sourceObject = obj8274;
  sourceObject = obj8274;
  sourceObject = obj8274;
  objclass8274 = obj8274->class;
  objclass8274->definitionModule = modulename;
  objclass8274->definitionLine = 1980;
  (*(struct UserObject *)self).data[0] = lowerouter8274;
  self = oldself8274;
  selfslot = oldselfslot8274;
  stackframe = oldstackframe8274;
  gc_frame_end(frame);
  return obj8274;
}
Object meth_ast_new8273_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_bindNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_dest_39_ = &(stackframe->slots[0]);
  *var_dest_39_ = args[curarg];
  curarg++;
  Object *var_val_39_ = &(stackframe->slots[1]);
  *var_val_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject8274 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8274 = alloc_userobj2(13,12, objclass8274);
  gc_frame_newslot(obj8274);
if (objclass8274 == NULL) {
  glfree(obj8274->class->name);
  obj8274->class->name = "bindNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj8274, self, 0);
  addmethodreal(obj8274,"outer", &reader_ast_outer_8275);
  Object oldself8274 = self;
  struct StackFrameObject *oldstackframe8274 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8274);
  gc_frame_newslot((Object)stackframe);
  self = obj8274;
  Object *oldselfslot8274 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8274 = (*(struct UserObject *)self).data[0], lowerouter8274 = thisouter8274;
  if (inheritingObject8274) {
    struct UserObject *inho8274 = (struct UserObject *)inheritingObject8274;
    while (inho8274->super != GraceDefaultObject) inho8274 = (struct UserObject *)inho8274->super;
    inho8274->super = obj8274;
    self = inheritingObject8274;
    *selfslot = self;
    lowerouter8274 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8274;
  }
if (objclass8274 == NULL) {
  Method *reader8276 = addmethodrealflags(obj8274, "kind",&reader_ast_kind_8276, MFLAG_DEF);
  reader8276->definitionModule = modulename;
  reader8276->definitionLine = 1983;
}
adddatum2(obj8274, alloc_Undefined(), 1);
if (objclass8274 == NULL) {
  Method *reader8277 = addmethodrealflags(obj8274, "dest",&reader_ast_dest_8277, 0);
  Method *writer8277 = addmethodrealflags(obj8274, "dest:=",&writer_ast_dest_8277, 0);
  reader8277->definitionModule = modulename;
  writer8277->definitionModule = modulename;
  reader8277->definitionLine = 1984;
  writer8277->definitionLine = 1984;
}
obj8274->flags |= OFLAG_MUTABLE;
adddatum2(obj8274, alloc_Undefined(), 2);
if (objclass8274 == NULL) {
  Method *reader8278 = addmethodrealflags(obj8274, "value",&reader_ast_value_8278, 0);
  Method *writer8278 = addmethodrealflags(obj8274, "value:=",&writer_ast_value_8278, 0);
  reader8278->definitionModule = modulename;
  writer8278->definitionModule = modulename;
  reader8278->definitionLine = 1985;
  writer8278->definitionLine = 1985;
}
obj8274->flags |= OFLAG_MUTABLE;
adddatum2(obj8274, alloc_Undefined(), 3);
// method isBind
  struct UserObject *uo8279 = (struct UserObject*)obj8274;
  uo8279->data[4] = emptyclosure;
  Method *meth_meth_ast_isBind8279 = addmethod2pos(obj8274, "isBind", &meth_ast_isBind8279, 4);
  int argcv_meth_ast_isBind8279[] = {0};
  meth_meth_ast_isBind8279->type = alloc_MethodType(1, argcv_meth_ast_isBind8279);
  meth_meth_ast_isBind8279->definitionModule = modulename;
  meth_meth_ast_isBind8279->definitionLine = 1987;
// method asString
  struct UserObject *uo8281 = (struct UserObject*)obj8274;
  uo8281->data[5] = emptyclosure;
  Method *meth_meth_ast_asString8281 = addmethod2pos(obj8274, "asString", &meth_ast_asString8281, 5);
  int argcv_meth_ast_asString8281[] = {0};
  meth_meth_ast_asString8281->type = alloc_MethodType(1, argcv_meth_ast_asString8281);
  meth_meth_ast_asString8281->definitionModule = modulename;
  meth_meth_ast_asString8281->definitionLine = 1988;
// method accept()from
  struct UserObject *uo8292 = (struct UserObject*)obj8274;
  uo8292->data[6] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from8292 = addmethod2pos(obj8274, "accept()from", &meth_ast_accept_40__41_from8292, 6);
  int argcv_meth_ast_accept_40__41_from8292[] = {1, 1};
  meth_meth_ast_accept_40__41_from8292->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from8292);
  meth_meth_ast_accept_40__41_from8292->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from8292->definitionLine = 1989;
// method map()ancestors
  struct UserObject *uo8306 = (struct UserObject*)obj8274;
  uo8306->data[7] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors8306 = addmethod2pos(obj8274, "map()ancestors", &meth_ast_map_40__41_ancestors8306, 7);
  int argcv_meth_ast_map_40__41_ancestors8306[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors8306->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors8306);
  meth_meth_ast_map_40__41_ancestors8306->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors8306->definitionLine = 1996;
// method pretty
  struct UserObject *uo8325 = (struct UserObject*)obj8274;
  uo8325->data[8] = emptyclosure;
  Method *meth_meth_ast_pretty8325 = addmethod2pos(obj8274, "pretty", &meth_ast_pretty8325, 8);
  int argcv_meth_ast_pretty8325[] = {1};
  meth_meth_ast_pretty8325->type = alloc_MethodType(1, argcv_meth_ast_pretty8325);
  meth_meth_ast_pretty8325->definitionModule = modulename;
  meth_meth_ast_pretty8325->definitionLine = 2003;
// method toGrace
  struct UserObject *uo8382 = (struct UserObject*)obj8274;
  uo8382->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace8382 = addmethod2pos(obj8274, "toGrace", &meth_ast_toGrace8382, 9);
  int argcv_meth_ast_toGrace8382[] = {1};
  meth_meth_ast_toGrace8382->type = alloc_MethodType(1, argcv_meth_ast_toGrace8382);
meth_meth_ast_toGrace8382->type->types[0] = type_Number;
meth_meth_ast_toGrace8382->type->names[0] = "depth";
  meth_meth_ast_toGrace8382->definitionModule = modulename;
  meth_meth_ast_toGrace8382->definitionLine = 2014;
// method shallowCopy
  block_savedest(obj8274);
  Object closure8426 = createclosure(1, "shallowCopy");
  setclosureframe(closure8426, stackframe);
  addtoclosure(closure8426, var_bindNode);
  struct UserObject *uo8426 = (struct UserObject*)obj8274;
  uo8426->data[10] = (Object)closure8426;
  Method *meth_meth_ast_shallowCopy8426 = addmethod2pos(obj8274, "shallowCopy", &meth_ast_shallowCopy8426, 10);
  int argcv_meth_ast_shallowCopy8426[] = {0};
  meth_meth_ast_shallowCopy8426->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy8426);
  meth_meth_ast_shallowCopy8426->definitionModule = modulename;
  meth_meth_ast_shallowCopy8426->definitionLine = 2023;
  sourceObject = obj8274;
// Begin line 1982
  setline(1982);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8435 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call8436 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe8435);
// compiled call node returning call8436 (depth = 4)
  struct UserObject *obj8274_uo = (struct UserObject *)obj8274;
  obj8274_uo->super = call8436;
  sourceObject = obj8274;
// Begin line 1983
  setline(1983);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit8437 == NULL) {
    strlit8437 = alloc_String("bind");
    gc_root(strlit8437);
  }
// compiled string node returning strlit8437 (depth = 4)
  adddatum2(obj8274, strlit8437, 1);
  sourceObject = obj8274;
// Begin line 1984
  setline(1984);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_dest_39_ (depth = 4)
  adddatum2(obj8274, *var_dest_39_, 2);
  sourceObject = obj8274;
// Begin line 1985
  setline(1985);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_val_39_ (depth = 4)
  adddatum2(obj8274, *var_val_39_, 3);
  sourceObject = obj8274;
  sourceObject = obj8274;
  sourceObject = obj8274;
  sourceObject = obj8274;
  sourceObject = obj8274;
  sourceObject = obj8274;
  sourceObject = obj8274;
  objclass8274 = obj8274->class;
  objclass8274->definitionModule = modulename;
  objclass8274->definitionLine = 1980;
  (*(struct UserObject *)self).data[0] = lowerouter8274;
  self = oldself8274;
  selfslot = oldselfslot8274;
  stackframe = oldstackframe8274;
  gc_frame_end(frame);
  return obj8274;
}
Object meth_ast_new_40__41_scope8441(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(6, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new()scope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method new()scope");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method new()scope");
  Object params[3];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for new()scope (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_val = &(stackframe->slots[1]);
  *var_val = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    gracedie("wrong number of arguments for new");
  Object *var_s = &(stackframe->slots[3]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for scope");
  Object *selfslot = &(stackframe->slots[4]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "result");
// Begin line 2029
  setline(2029);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8442 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_name_39_ (depth = 5)
  gc_frame_newslot(*var_name_39_);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  gc_frame_newslot(*var_val);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dtype_39_ (depth = 5)
  gc_frame_newslot(*var_dtype_39_);
// call case 4: self request
  params[0] = *var_name_39_;
  params[1] = *var_val;
  params[2] = *var_dtype_39_;
  partcv[0] = 3;
  Object call8443 = callmethodflags(self, "new", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8442);
// compiled call node returning call8443 (depth = 4)
  *var_result = call8443;
  if (call8443 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2030
  setline(2030);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2024
  setline(2024);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8444 = gc_frame_new();
// Begin line 2030
  setline(2030);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  gc_frame_newslot(*var_s);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call8445 = callmethod(*var_result, "scope:=",
    1, partcv, params);
  gc_frame_end(callframe8444);
// compiled call node returning call8445 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 2031
  setline(2031);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_isPublic8457(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPublic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isPublic (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isPublic");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2047
  setline(2047);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num8460 = alloc_Float64(0);
// compiled num node returning num8460 (depth = 5)
  int op_slot_right_8459 = gc_frame_newslot(num8460);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8462 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8463 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8464 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8463);
// compiled call node returning call8464 (depth = 8)
// compiled member node returning call8464 (depth = 7)
  partcv[0] = 0;
  Object call8465 = callmethod(call8464, "size",
    1, partcv, params);
  gc_frame_end(callframe8462);
// compiled call node returning call8465 (depth = 6)
// compiled member node returning call8465 (depth = 5)
  int op_slot_left_8459 = gc_frame_newslot(call8465);
  params[0] = num8460;
  partcv[0] = 1;
  Object opresult8466 = callmethod(call8465, "==", 1, partcv, params);
// compiled op node returning opresult8466 (depth = 4)
  Object if8458 = done;
  if (istrue(opresult8466)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8467 = alloc_Boolean(0);
// compiled identifier node returning bool8467 (depth = 5)
  return bool8467;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if8458 = undefined;
  } else {
  }
// compiled if node returning if8458 (depth = 3)
// Begin line 2048
  setline(2048);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8469 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile string node (depth = 5)
  if (strlit8470 == NULL) {
    strlit8470 = alloc_String("public");
    gc_root(strlit8470);
  }
// compiled string node returning strlit8470 (depth = 5)
  gc_frame_newslot(strlit8470);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8471 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8472 = gc_frame_new();
// call case 3: self.outer request
  Object call8473 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8472);
// compiled call node returning call8473 (depth = 8)
// compiled member node returning call8473 (depth = 7)
  partcv[0] = 0;
  Object call8474 = callmethodflags(call8473, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8471);
// compiled call node returning call8474 (depth = 6)
// compiled member node returning call8474 (depth = 5)
  params[0] = self;
  params[1] = strlit8470;
  partcv[0] = 2;
  Object call8475 = callmethodflags(call8474, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8469);
// compiled call node returning call8475 (depth = 4)
  Object if8468 = done;
  if (istrue(call8475)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8476 = alloc_Boolean(1);
// compiled identifier node returning bool8476 (depth = 5)
  return bool8476;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if8468 = undefined;
  } else {
  }
// compiled if node returning if8468 (depth = 3)
// Begin line 2049
  setline(2049);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8477 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile string node (depth = 4)
  if (strlit8478 == NULL) {
    strlit8478 = alloc_String("readable");
    gc_root(strlit8478);
  }
// compiled string node returning strlit8478 (depth = 4)
  gc_frame_newslot(strlit8478);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8479 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8480 = gc_frame_new();
// call case 3: self.outer request
  Object call8481 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8480);
// compiled call node returning call8481 (depth = 7)
// compiled member node returning call8481 (depth = 6)
  partcv[0] = 0;
  Object call8482 = callmethodflags(call8481, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8479);
// compiled call node returning call8482 (depth = 5)
// compiled member node returning call8482 (depth = 4)
  params[0] = self;
  params[1] = strlit8478;
  partcv[0] = 2;
  Object call8483 = callmethodflags(call8482, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8477);
// compiled call node returning call8483 (depth = 3)
  gc_frame_end(frame);
  return call8483;
}
Object meth_ast_isWritable8484(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isWritable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isWritable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isWritable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2051
  setline(2051);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8485 = alloc_Boolean(0);
// compiled identifier node returning bool8485 (depth = 3)
  gc_frame_end(frame);
  return bool8485;
}
Object meth_ast_isReadable8486(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isReadable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isReadable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isReadable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2052
  setline(2052);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8487 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8488 = callmethodflags(self, "isPublic", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8487);
// compiled call node returning call8488 (depth = 4)
// compiled member node returning call8488 (depth = 3)
  gc_frame_end(frame);
  return call8488;
}
Object meth_ast_returnsObject8489(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnsObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for returnsObject (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for returnsObject");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2059
  setline(2059);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8490 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8491 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8492 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8491);
// compiled call node returning call8492 (depth = 6)
// compiled member node returning call8492 (depth = 5)
  partcv[0] = 0;
  Object call8493 = callmethod(call8492, "returnsObject",
    1, partcv, params);
  gc_frame_end(callframe8490);
// compiled call node returning call8493 (depth = 4)
// compiled member node returning call8493 (depth = 3)
  gc_frame_end(frame);
  return call8493;
}
Object meth_ast_returnedObjectScope8494(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnedObjectScope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for returnedObjectScope (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for returnedObjectScope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2063
  setline(2063);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8495 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8496 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8497 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8496);
// compiled call node returning call8497 (depth = 6)
// compiled member node returning call8497 (depth = 5)
  partcv[0] = 0;
  Object call8498 = callmethod(call8497, "returnedObjectScope",
    1, partcv, params);
  gc_frame_end(callframe8495);
// compiled call node returning call8498 (depth = 4)
// compiled member node returning call8498 (depth = 3)
  gc_frame_end(frame);
  return call8498;
}
Object meth_ast_usesAsType8499(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "usesAsType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method usesAsType");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for usesAsType (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aNode = &(stackframe->slots[0]);
  *var_aNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for usesAsType");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2066
  setline(2066);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8501 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8502 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8501);
// compiled call node returning call8502 (depth = 5)
// compiled member node returning call8502 (depth = 4)
  int op_slot_right_8500 = gc_frame_newslot(call8502);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_aNode (depth = 4)
  int op_slot_left_8500 = gc_frame_newslot(*var_aNode);
  params[0] = call8502;
  partcv[0] = 1;
  Object opresult8504 = callmethod(*var_aNode, "==", 1, partcv, params);
// compiled op node returning opresult8504 (depth = 3)
  gc_frame_end(frame);
  return opresult8504;
}
Object meth_ast__apply8530(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ann = &(stackframe->slots[0]);
  *var_ann = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2076
  setline(2076);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8531 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ann (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8532 = callmethod(*var_ann, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe8531);
// compiled call node returning call8532 (depth = 6)
  gc_frame_end(frame);
  return call8532;
}
Object meth_ast_accept_40__41_from8505(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 2069
  setline(2069);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8507 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8508 = callmethod(*var_visitor, "visitDefDec()up",
    2, partcv, params);
  gc_frame_end(callframe8507);
// compiled call node returning call8508 (depth = 4)
  Object if8506 = done;
  if (istrue(call8508)) {
// Begin line 2070
  setline(2070);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8509 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call8510 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe8509);
// compiled call node returning call8510 (depth = 5)
  *var_newChain = call8510;
  if (call8510 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2071
  setline(2071);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8511 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8512 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8513 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8512);
// compiled call node returning call8513 (depth = 6)
// compiled member node returning call8513 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8514 = callmethod(call8513, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe8511);
// compiled call node returning call8514 (depth = 4)
// Begin line 2072
  setline(2072);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool8517 = alloc_Boolean(0);
// compiled identifier node returning bool8517 (depth = 6)
  int op_slot_right_8516 = gc_frame_newslot(bool8517);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8519 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8520 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8519);
// compiled call node returning call8520 (depth = 7)
// compiled member node returning call8520 (depth = 6)
  int op_slot_left_8516 = gc_frame_newslot(call8520);
  params[0] = bool8517;
  partcv[0] = 1;
  Object opresult8521 = callmethod(call8520, "!=", 1, partcv, params);
// compiled op node returning opresult8521 (depth = 5)
  Object if8515 = done;
  if (istrue(opresult8521)) {
// Begin line 2073
  setline(2073);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8522 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8523 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8524 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8523);
// compiled call node returning call8524 (depth = 7)
// compiled member node returning call8524 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8525 = callmethod(call8524, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe8522);
// compiled call node returning call8525 (depth = 5)
    gc_frame_newslot(call8525);
    if8515 = call8525;
  } else {
  }
// compiled if node returning if8515 (depth = 4)
// Begin line 2075
  setline(2075);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8526 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8527 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8528 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8527);
// compiled call node returning call8528 (depth = 6)
// compiled member node returning call8528 (depth = 5)
  gc_frame_newslot(call8528);
// starting to compile block node (depth = 5)
  Object block8529 = alloc_Block(NULL, NULL, "ast", 2075);
  gc_frame_newslot(block8529);
// method _apply
  block_savedest(block8529);
  Object closure8530 = createclosure(3, "_apply");
  setclosureframe(closure8530, stackframe);
  addtoclosure(closure8530, var_visitor);
  addtoclosure(closure8530, var_newChain);
  addtoclosure(closure8530, selfslot);
  struct UserObject *uo8530 = (struct UserObject*)block8529;
  uo8530->data[0] = (Object)closure8530;
  Method *meth_meth_ast__apply8530 = addmethod2pos(block8529, "_apply", &meth_ast__apply8530, 0);
  int argcv_meth_ast__apply8530[] = {1};
  meth_meth_ast__apply8530->type = alloc_MethodType(1, argcv_meth_ast__apply8530);
  meth_meth_ast__apply8530->definitionModule = modulename;
  meth_meth_ast__apply8530->definitionLine = 2075;
// compiled block node returning block8529 (depth = 5)
  gc_frame_newslot(block8529);
// call case 5: prelude request
  params[0] = call8528;
  params[1] = block8529;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8534 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8526);
// compiled call node returning call8534 (depth = 4)
// Begin line 2078
  setline(2078);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool8537 = alloc_Boolean(0);
// compiled identifier node returning bool8537 (depth = 6)
  int op_slot_right_8536 = gc_frame_newslot(bool8537);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8539 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8540 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8539);
// compiled call node returning call8540 (depth = 7)
// compiled member node returning call8540 (depth = 6)
  int op_slot_left_8536 = gc_frame_newslot(call8540);
  params[0] = bool8537;
  partcv[0] = 1;
  Object opresult8541 = callmethod(call8540, "!=", 1, partcv, params);
// compiled op node returning opresult8541 (depth = 5)
  Object if8535 = done;
  if (istrue(opresult8541)) {
// Begin line 2079
  setline(2079);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8542 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8543 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8544 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8543);
// compiled call node returning call8544 (depth = 7)
// compiled member node returning call8544 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8545 = callmethod(call8544, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe8542);
// compiled call node returning call8545 (depth = 5)
    gc_frame_newslot(call8545);
    if8535 = call8545;
  } else {
  }
// compiled if node returning if8535 (depth = 4)
    gc_frame_newslot(if8535);
    if8506 = if8535;
  } else {
  }
// compiled if node returning if8506 (depth = 3)
  gc_frame_end(frame);
  return if8506;
}
Object meth_ast_map_40__41_ancestors8546(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2084
  setline(2084);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8547 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8548 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8547);
// compiled call node returning call8548 (depth = 5)
// compiled member node returning call8548 (depth = 4)
  *var_n = call8548;
  if (call8548 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2085
  setline(2085);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8549 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call8550 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe8549);
// compiled call node returning call8550 (depth = 4)
  *var_newChain = call8550;
  if (call8550 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2086
  setline(2086);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2084
  setline(2084);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8551 = gc_frame_new();
// Begin line 2086
  setline(2086);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8552 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8553 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8554 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8553);
// compiled call node returning call8554 (depth = 7)
// compiled member node returning call8554 (depth = 6)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8555 = callmethod(call8554, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe8552);
// compiled call node returning call8555 (depth = 5)
  gc_frame_newslot(call8555);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  params[0] = call8555;
  partcv[0] = 1;
  Object call8556 = callmethod(*var_n, "name:=",
    1, partcv, params);
  gc_frame_end(callframe8551);
// compiled call node returning call8556 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 2087
  setline(2087);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2086
  setline(2086);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8557 = gc_frame_new();
// Begin line 2087
  setline(2087);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8558 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8559 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8560 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8559);
// compiled call node returning call8560 (depth = 7)
// compiled member node returning call8560 (depth = 6)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8561 = callmethod(call8560, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe8558);
// compiled call node returning call8561 (depth = 5)
  gc_frame_newslot(call8561);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  params[0] = call8561;
  partcv[0] = 1;
  Object call8562 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe8557);
// compiled call node returning call8562 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 2088
  setline(2088);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2087
  setline(2087);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8563 = gc_frame_new();
// Begin line 2088
  setline(2088);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8564 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8565 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8566 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8565);
// compiled call node returning call8566 (depth = 7)
// compiled member node returning call8566 (depth = 6)
  gc_frame_newslot(call8566);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8567 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8568 = gc_frame_new();
// call case 3: self.outer request
  Object call8569 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8568);
// compiled call node returning call8569 (depth = 9)
// compiled member node returning call8569 (depth = 8)
  partcv[0] = 0;
  Object call8570 = callmethodflags(call8569, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8567);
// compiled call node returning call8570 (depth = 7)
// compiled member node returning call8570 (depth = 6)
  params[0] = call8566;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call8571 = callmethodflags(call8570, "maybeMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8564);
// compiled call node returning call8571 (depth = 5)
  gc_frame_newslot(call8571);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  params[0] = call8571;
  partcv[0] = 1;
  Object call8572 = callmethod(*var_n, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe8563);
// compiled call node returning call8572 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 2089
  setline(2089);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2088
  setline(2088);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8573 = gc_frame_new();
// Begin line 2089
  setline(2089);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8574 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8575 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8576 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8575);
// compiled call node returning call8576 (depth = 7)
// compiled member node returning call8576 (depth = 6)
  gc_frame_newslot(call8576);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8577 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8578 = gc_frame_new();
// call case 3: self.outer request
  Object call8579 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8578);
// compiled call node returning call8579 (depth = 9)
// compiled member node returning call8579 (depth = 8)
  partcv[0] = 0;
  Object call8580 = callmethodflags(call8579, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8577);
// compiled call node returning call8580 (depth = 7)
// compiled member node returning call8580 (depth = 6)
  params[0] = call8576;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call8581 = callmethodflags(call8580, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8574);
// compiled call node returning call8581 (depth = 5)
  gc_frame_newslot(call8581);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  params[0] = call8581;
  partcv[0] = 1;
  Object call8582 = callmethod(*var_n, "annotations:=",
    1, partcv, params);
  gc_frame_end(callframe8573);
// compiled call node returning call8582 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 2090
  setline(2090);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8583 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call8584 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe8583);
// compiled call node returning call8584 (depth = 3)
  gc_frame_end(frame);
  return call8584;
}
Object meth_ast__apply8593(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2095
  setline(2095);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8595 == NULL) {
    strlit8595 = alloc_String("  ");
    gc_root(strlit8595);
  }
// compiled string node returning strlit8595 (depth = 7)
  int op_slot_right_8594 = gc_frame_newslot(strlit8595);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_8594 = gc_frame_newslot(*var_spc);
  params[0] = strlit8595;
  partcv[0] = 1;
  Object opresult8597 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult8597 (depth = 6)
  *var_spc = opresult8597;
  if (opresult8597 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply8699(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ann = &(stackframe->slots[0]);
  *var_ann = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2108
  setline(2108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8701 == NULL) {
    strlit8701 = alloc_String("");
    gc_root(strlit8701);
  }
// compiled string node returning strlit8701 (depth = 8)
  int op_slot_right_8700 = gc_frame_newslot(strlit8701);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8704 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num8706 = alloc_Float64(2);
// compiled num node returning num8706 (depth = 11)
  int op_slot_right_8705 = gc_frame_newslot(num8706);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_8705 = gc_frame_newslot(*var_depth);
  params[0] = num8706;
  partcv[0] = 1;
  Object sum8708 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum8708 (depth = 10)
  gc_frame_newslot(sum8708);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ann (depth = 10)
  params[0] = sum8708;
  partcv[0] = 1;
  Object call8709 = callmethod(*var_ann, "pretty",
    1, partcv, params);
  gc_frame_end(callframe8704);
// compiled call node returning call8709 (depth = 9)
  int op_slot_right_8703 = gc_frame_newslot(call8709);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit8712 == NULL) {
    strlit8712 = alloc_String(" ");
    gc_root(strlit8712);
  }
// compiled string node returning strlit8712 (depth = 10)
  int op_slot_right_8711 = gc_frame_newslot(strlit8712);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_right_8714 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 11)
  if (strlit8716 == NULL) {
    strlit8716 = alloc_String("");
    gc_root(strlit8716);
  }
// compiled string node returning strlit8716 (depth = 11)
  int op_slot_left_8714 = gc_frame_newslot(strlit8716);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult8717 = callmethod(strlit8716, "++", 1, partcv, params);
// compiled op node returning opresult8717 (depth = 10)
  int op_slot_left_8711 = gc_frame_newslot(opresult8717);
  params[0] = strlit8712;
  partcv[0] = 1;
  Object opresult8718 = callmethod(opresult8717, "++", 1, partcv, params);
// compiled op node returning opresult8718 (depth = 9)
  int op_slot_left_8703 = gc_frame_newslot(opresult8718);
  params[0] = call8709;
  partcv[0] = 1;
  Object opresult8719 = callmethod(opresult8718, "++", 1, partcv, params);
// compiled op node returning opresult8719 (depth = 8)
  int op_slot_left_8700 = gc_frame_newslot(opresult8719);
  params[0] = strlit8701;
  partcv[0] = 1;
  Object opresult8720 = callmethod(opresult8719, "++", 1, partcv, params);
// compiled op node returning opresult8720 (depth = 7)
  *var_s = opresult8720;
  if (opresult8720 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty8585(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2093
  setline(2093);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit8586 == NULL) {
    strlit8586 = alloc_String("");
    gc_root(strlit8586);
  }
// compiled string node returning strlit8586 (depth = 4)
  *var_spc = strlit8586;
  if (strlit8586 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2094
  setline(2094);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8587 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_8588 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num8590 = alloc_Float64(0);
// compiled num node returning num8590 (depth = 5)
  int op_slot_left_8588 = gc_frame_newslot(num8590);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult8591 = callmethod(num8590, "..", 1, partcv, params);
// compiled op node returning opresult8591 (depth = 4)
  gc_frame_newslot(opresult8591);
// starting to compile block node (depth = 4)
  Object block8592 = alloc_Block(NULL, NULL, "ast", 2094);
  gc_frame_newslot(block8592);
// method _apply
  block_savedest(block8592);
  Object closure8593 = createclosure(2, "_apply");
  setclosureframe(closure8593, stackframe);
  addtoclosure(closure8593, var_spc);
  addtoclosure(closure8593, selfslot);
  struct UserObject *uo8593 = (struct UserObject*)block8592;
  uo8593->data[0] = (Object)closure8593;
  Method *meth_meth_ast__apply8593 = addmethod2pos(block8592, "_apply", &meth_ast__apply8593, 0);
  int argcv_meth_ast__apply8593[] = {1};
  meth_meth_ast__apply8593->type = alloc_MethodType(1, argcv_meth_ast__apply8593);
  meth_meth_ast__apply8593->definitionModule = modulename;
  meth_meth_ast__apply8593->definitionLine = 2089;
// compiled block node returning block8592 (depth = 4)
  gc_frame_newslot(block8592);
// call case 5: prelude request
  params[0] = opresult8591;
  params[1] = block8592;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8600 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8587);
// compiled call node returning call8600 (depth = 3)
// Begin line 2097
  setline(2097);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8602 == NULL) {
    strlit8602 = alloc_String("""\x0a""");
    gc_root(strlit8602);
  }
// compiled string node returning strlit8602 (depth = 5)
  int op_slot_right_8601 = gc_frame_newslot(strlit8602);
// starting to compile call node (depth = 5)
  int callframe8604 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call8605 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe8604);
// compiled call node returning call8605 (depth = 5)
  int op_slot_left_8601 = gc_frame_newslot(call8605);
  params[0] = strlit8602;
  partcv[0] = 1;
  Object opresult8606 = callmethod(call8605, "++", 1, partcv, params);
// compiled op node returning opresult8606 (depth = 4)
  *var_s = opresult8606;
  if (opresult8606 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2098
  setline(2098);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8608 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8609 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8610 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8609);
// compiled call node returning call8610 (depth = 7)
// compiled member node returning call8610 (depth = 6)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call8611 = callmethod(call8610, "pretty",
    1, partcv, params);
  gc_frame_end(callframe8608);
// compiled call node returning call8611 (depth = 5)
  int op_slot_right_8607 = gc_frame_newslot(call8611);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_8613 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8613 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8615 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8615 (depth = 5)
  int op_slot_left_8607 = gc_frame_newslot(opresult8615);
  params[0] = call8611;
  partcv[0] = 1;
  Object opresult8616 = callmethod(opresult8615, "++", 1, partcv, params);
// compiled op node returning opresult8616 (depth = 4)
  *var_s = opresult8616;
  if (opresult8616 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 2099
  setline(2099);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8620 = alloc_Boolean(0);
// compiled identifier node returning bool8620 (depth = 5)
  int op_slot_right_8619 = gc_frame_newslot(bool8620);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8622 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8623 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8622);
// compiled call node returning call8623 (depth = 6)
// compiled member node returning call8623 (depth = 5)
  int op_slot_left_8619 = gc_frame_newslot(call8623);
  params[0] = bool8620;
  partcv[0] = 1;
  Object opresult8624 = callmethod(call8623, "!=", 1, partcv, params);
// compiled op node returning opresult8624 (depth = 4)
  Object if8618 = done;
  if (istrue(opresult8624)) {
// Begin line 2100
  setline(2100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8626 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num8628 = alloc_Float64(2);
// compiled num node returning num8628 (depth = 8)
  int op_slot_right_8627 = gc_frame_newslot(num8628);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_8627 = gc_frame_newslot(*var_depth);
  params[0] = num8628;
  partcv[0] = 1;
  Object sum8630 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum8630 (depth = 7)
  gc_frame_newslot(sum8630);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8631 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8632 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8631);
// compiled call node returning call8632 (depth = 8)
// compiled member node returning call8632 (depth = 7)
  params[0] = sum8630;
  partcv[0] = 1;
  Object call8633 = callmethod(call8632, "pretty",
    1, partcv, params);
  gc_frame_end(callframe8626);
// compiled call node returning call8633 (depth = 6)
  int op_slot_right_8625 = gc_frame_newslot(call8633);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8636 == NULL) {
    strlit8636 = alloc_String("Type: ");
    gc_root(strlit8636);
  }
// compiled string node returning strlit8636 (depth = 7)
  int op_slot_right_8635 = gc_frame_newslot(strlit8636);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_8638 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit8641 == NULL) {
    strlit8641 = alloc_String("""\x0a""");
    gc_root(strlit8641);
  }
// compiled string node returning strlit8641 (depth = 9)
  int op_slot_right_8640 = gc_frame_newslot(strlit8641);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_8640 = gc_frame_newslot(*var_s);
  params[0] = strlit8641;
  partcv[0] = 1;
  Object opresult8643 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8643 (depth = 8)
  int op_slot_left_8638 = gc_frame_newslot(opresult8643);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8644 = callmethod(opresult8643, "++", 1, partcv, params);
// compiled op node returning opresult8644 (depth = 7)
  int op_slot_left_8635 = gc_frame_newslot(opresult8644);
  params[0] = strlit8636;
  partcv[0] = 1;
  Object opresult8645 = callmethod(opresult8644, "++", 1, partcv, params);
// compiled op node returning opresult8645 (depth = 6)
  int op_slot_left_8625 = gc_frame_newslot(opresult8645);
  params[0] = call8633;
  partcv[0] = 1;
  Object opresult8646 = callmethod(opresult8645, "++", 1, partcv, params);
// compiled op node returning opresult8646 (depth = 5)
  *var_s = opresult8646;
  if (opresult8646 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8618 = done;
  } else {
  }
// compiled if node returning if8618 (depth = 3)
// Begin line 2102
  setline(2102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8650 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8651 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8650);
// compiled call node returning call8651 (depth = 6)
// compiled member node returning call8651 (depth = 5)
  int op_slot_right_8649 = gc_frame_newslot(call8651);
// starting to compile identifier node (depth = 5)
  Object bool8653 = alloc_Boolean(0);
// compiled identifier node returning bool8653 (depth = 5)
  int op_slot_left_8649 = gc_frame_newslot(bool8653);
  params[0] = call8651;
  partcv[0] = 1;
  Object opresult8654 = callmethod(bool8653, "!=", 1, partcv, params);
// compiled op node returning opresult8654 (depth = 4)
  Object if8648 = done;
  if (istrue(opresult8654)) {
// Begin line 2103
  setline(2103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8656 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num8658 = alloc_Float64(2);
// compiled num node returning num8658 (depth = 8)
  int op_slot_right_8657 = gc_frame_newslot(num8658);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_8657 = gc_frame_newslot(*var_depth);
  params[0] = num8658;
  partcv[0] = 1;
  Object sum8660 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum8660 (depth = 7)
  gc_frame_newslot(sum8660);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8661 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8662 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8661);
// compiled call node returning call8662 (depth = 8)
// compiled member node returning call8662 (depth = 7)
  params[0] = sum8660;
  partcv[0] = 1;
  Object call8663 = callmethod(call8662, "pretty",
    1, partcv, params);
  gc_frame_end(callframe8656);
// compiled call node returning call8663 (depth = 6)
  int op_slot_right_8655 = gc_frame_newslot(call8663);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8666 == NULL) {
    strlit8666 = alloc_String("Value: ");
    gc_root(strlit8666);
  }
// compiled string node returning strlit8666 (depth = 7)
  int op_slot_right_8665 = gc_frame_newslot(strlit8666);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_8668 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit8671 == NULL) {
    strlit8671 = alloc_String("""\x0a""");
    gc_root(strlit8671);
  }
// compiled string node returning strlit8671 (depth = 9)
  int op_slot_right_8670 = gc_frame_newslot(strlit8671);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_8670 = gc_frame_newslot(*var_s);
  params[0] = strlit8671;
  partcv[0] = 1;
  Object opresult8673 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8673 (depth = 8)
  int op_slot_left_8668 = gc_frame_newslot(opresult8673);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8674 = callmethod(opresult8673, "++", 1, partcv, params);
// compiled op node returning opresult8674 (depth = 7)
  int op_slot_left_8665 = gc_frame_newslot(opresult8674);
  params[0] = strlit8666;
  partcv[0] = 1;
  Object opresult8675 = callmethod(opresult8674, "++", 1, partcv, params);
// compiled op node returning opresult8675 (depth = 6)
  int op_slot_left_8655 = gc_frame_newslot(opresult8675);
  params[0] = call8663;
  partcv[0] = 1;
  Object opresult8676 = callmethod(opresult8675, "++", 1, partcv, params);
// compiled op node returning opresult8676 (depth = 5)
  *var_s = opresult8676;
  if (opresult8676 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8648 = done;
  } else {
  }
// compiled if node returning if8648 (depth = 3)
// Begin line 2105
  setline(2105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8679 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8680 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8681 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8682 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8681);
// compiled call node returning call8682 (depth = 9)
// compiled member node returning call8682 (depth = 8)
  partcv[0] = 0;
  Object call8683 = callmethod(call8682, "isEmpty",
    1, partcv, params);
  gc_frame_end(callframe8680);
// compiled call node returning call8683 (depth = 7)
// compiled member node returning call8683 (depth = 6)
  partcv[0] = 0;
  Object call8684 = callmethod(call8683, "not",
    1, partcv, params);
  gc_frame_end(callframe8679);
// compiled call node returning call8684 (depth = 5)
// compiled member node returning call8684 (depth = 4)
  Object if8678 = done;
  if (istrue(call8684)) {
// Begin line 2106
  setline(2106);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8687 == NULL) {
    strlit8687 = alloc_String("Annotations:");
    gc_root(strlit8687);
  }
// compiled string node returning strlit8687 (depth = 7)
  int op_slot_right_8686 = gc_frame_newslot(strlit8687);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_8689 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 8)
  if (strlit8691 == NULL) {
    strlit8691 = alloc_String("""\x0a""");
    gc_root(strlit8691);
  }
// compiled string node returning strlit8691 (depth = 8)
  int op_slot_left_8689 = gc_frame_newslot(strlit8691);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8692 = callmethod(strlit8691, "++", 1, partcv, params);
// compiled op node returning opresult8692 (depth = 7)
  int op_slot_left_8686 = gc_frame_newslot(opresult8692);
  params[0] = strlit8687;
  partcv[0] = 1;
  Object opresult8693 = callmethod(opresult8692, "++", 1, partcv, params);
// compiled op node returning opresult8693 (depth = 6)
  int op_slot_right_8685 = gc_frame_newslot(opresult8693);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8685 = gc_frame_newslot(*var_s);
  params[0] = opresult8693;
  partcv[0] = 1;
  Object opresult8695 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8695 (depth = 5)
  *var_s = opresult8695;
  if (opresult8695 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2107
  setline(2107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8697 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block8698 = alloc_Block(NULL, NULL, "ast", 2107);
  gc_frame_newslot(block8698);
// method _apply
  block_savedest(block8698);
  Object closure8699 = createclosure(3, "_apply");
  setclosureframe(closure8699, stackframe);
  addtoclosure(closure8699, var_depth);
  addtoclosure(closure8699, var_s);
  addtoclosure(closure8699, selfslot);
  struct UserObject *uo8699 = (struct UserObject*)block8698;
  uo8699->data[0] = (Object)closure8699;
  Method *meth_meth_ast__apply8699 = addmethod2pos(block8698, "_apply", &meth_ast__apply8699, 0);
  int argcv_meth_ast__apply8699[] = {1};
  meth_meth_ast__apply8699->type = alloc_MethodType(1, argcv_meth_ast__apply8699);
  meth_meth_ast__apply8699->definitionModule = modulename;
  meth_meth_ast__apply8699->definitionLine = 2105;
// compiled block node returning block8698 (depth = 5)
  gc_frame_newslot(block8698);
// call case 6: other member request
// Begin line 2107
  setline(2107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8723 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8724 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8723);
// compiled call node returning call8724 (depth = 6)
// compiled member node returning call8724 (depth = 5)
  params[0] = block8698;
  partcv[0] = 1;
  Object call8725 = callmethod(call8724, "do",
    1, partcv, params);
  gc_frame_end(callframe8697);
// compiled call node returning call8725 (depth = 4)
    gc_frame_newslot(call8725);
    if8678 = call8725;
  } else {
  }
// compiled if node returning if8678 (depth = 3)
// Begin line 2111
  setline(2111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8728 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8729 = callmethodflags(self, "comments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8728);
// compiled call node returning call8729 (depth = 6)
// compiled member node returning call8729 (depth = 5)
  int op_slot_right_8727 = gc_frame_newslot(call8729);
// starting to compile identifier node (depth = 5)
  Object bool8731 = alloc_Boolean(0);
// compiled identifier node returning bool8731 (depth = 5)
  int op_slot_left_8727 = gc_frame_newslot(bool8731);
  params[0] = call8729;
  partcv[0] = 1;
  Object opresult8732 = callmethod(bool8731, "!=", 1, partcv, params);
// compiled op node returning opresult8732 (depth = 4)
  Object if8726 = done;
  if (istrue(opresult8732)) {
// Begin line 2112
  setline(2112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8734 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num8736 = alloc_Float64(2);
// compiled num node returning num8736 (depth = 8)
  int op_slot_right_8735 = gc_frame_newslot(num8736);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_8735 = gc_frame_newslot(*var_depth);
  params[0] = num8736;
  partcv[0] = 1;
  Object sum8738 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum8738 (depth = 7)
  gc_frame_newslot(sum8738);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8739 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8740 = callmethodflags(self, "comments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8739);
// compiled call node returning call8740 (depth = 8)
// compiled member node returning call8740 (depth = 7)
  params[0] = sum8738;
  partcv[0] = 1;
  Object call8741 = callmethod(call8740, "pretty",
    1, partcv, params);
  gc_frame_end(callframe8734);
// compiled call node returning call8741 (depth = 6)
  int op_slot_right_8733 = gc_frame_newslot(call8741);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8733 = gc_frame_newslot(*var_s);
  params[0] = call8741;
  partcv[0] = 1;
  Object opresult8743 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8743 (depth = 5)
  *var_s = opresult8743;
  if (opresult8743 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8726 = done;
  } else {
  }
// compiled if node returning if8726 (depth = 3)
// Begin line 2114
  setline(2114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply8757(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2119
  setline(2119);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8759 == NULL) {
    strlit8759 = alloc_String("    ");
    gc_root(strlit8759);
  }
// compiled string node returning strlit8759 (depth = 7)
  int op_slot_right_8758 = gc_frame_newslot(strlit8759);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_8758 = gc_frame_newslot(*var_spc);
  params[0] = strlit8759;
  partcv[0] = 1;
  Object opresult8761 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult8761 (depth = 6)
  *var_spc = opresult8761;
  if (opresult8761 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply8781(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2123
  setline(2123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8783 == NULL) {
    strlit8783 = alloc_String("Unknown");
    gc_root(strlit8783);
  }
// compiled string node returning strlit8783 (depth = 7)
  int op_slot_right_8782 = gc_frame_newslot(strlit8783);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8785 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8786 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8787 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8786);
// compiled call node returning call8787 (depth = 10)
// compiled member node returning call8787 (depth = 9)
  partcv[0] = 0;
  Object call8788 = callmethod(call8787, "value",
    1, partcv, params);
  gc_frame_end(callframe8785);
// compiled call node returning call8788 (depth = 8)
// compiled member node returning call8788 (depth = 7)
  int op_slot_left_8782 = gc_frame_newslot(call8788);
  params[0] = strlit8783;
  partcv[0] = 1;
  Object opresult8789 = callmethod(call8788, "!=", 1, partcv, params);
// compiled op node returning opresult8789 (depth = 6)
  gc_frame_end(frame);
  return opresult8789;
}
Object meth_ast__apply8829(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2129
  setline(2129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8831 = gc_frame_new();
// starting to compile num node (depth = 10)
  Object num8832 = alloc_Float64(0);
// compiled num node returning num8832 (depth = 10)
  gc_frame_newslot(num8832);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_b (depth = 10)
  params[0] = num8832;
  partcv[0] = 1;
  Object call8833 = callmethod(*var_b, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe8831);
// compiled call node returning call8833 (depth = 9)
  int op_slot_right_8830 = gc_frame_newslot(call8833);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit8837 == NULL) {
    strlit8837 = alloc_String("");
    gc_root(strlit8837);
  }
// compiled string node returning strlit8837 (depth = 11)
  int op_slot_right_8836 = gc_frame_newslot(strlit8837);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_a (depth = 11)
  int op_slot_left_8836 = gc_frame_newslot(*var_a);
  params[0] = strlit8837;
  partcv[0] = 1;
  Object opresult8839 = callmethod(*var_a, "!=", 1, partcv, params);
// compiled op node returning opresult8839 (depth = 10)
  Object if8835 = done;
struct StackFrameObject *iftmpstackframe8835 = stackframe;
  if (istrue(opresult8839)) {
stackframe = alloc_StackFrame(0, iftmpstackframe8835);
gc_frame_newslot((Object)stackframe);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit8841 == NULL) {
    strlit8841 = alloc_String(", ");
    gc_root(strlit8841);
  }
// compiled string node returning strlit8841 (depth = 11)
  int op_slot_right_8840 = gc_frame_newslot(strlit8841);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_a (depth = 11)
  int op_slot_left_8840 = gc_frame_newslot(*var_a);
  params[0] = strlit8841;
  partcv[0] = 1;
  Object opresult8843 = callmethod(*var_a, "++", 1, partcv, params);
// compiled op node returning opresult8843 (depth = 10)
    gc_frame_newslot(opresult8843);
    if8835 = opresult8843;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe8835);
  gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 10)
  if (strlit8844 == NULL) {
    strlit8844 = alloc_String("");
    gc_root(strlit8844);
  }
// compiled string node returning strlit8844 (depth = 10)
    gc_frame_newslot(strlit8844);
    if8835 = strlit8844;
  }
stackframe = iftmpstackframe8835;
// compiled if node returning if8835 (depth = 9)
  int op_slot_left_8830 = gc_frame_newslot(if8835);
  params[0] = call8833;
  partcv[0] = 1;
  Object opresult8845 = callmethod(if8835, "++", 1, partcv, params);
// compiled op node returning opresult8845 (depth = 8)
  gc_frame_end(frame);
  return opresult8845;
}
Object meth_ast_toGrace8745(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2117
  setline(2117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit8746 == NULL) {
    strlit8746 = alloc_String("");
    gc_root(strlit8746);
  }
// compiled string node returning strlit8746 (depth = 4)
  *var_spc = strlit8746;
  if (strlit8746 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2118
  setline(2118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8747 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num8750 = alloc_Float64(1);
// compiled num node returning num8750 (depth = 6)
  int op_slot_right_8749 = gc_frame_newslot(num8750);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_8749 = gc_frame_newslot(*var_depth);
  params[0] = num8750;
  partcv[0] = 1;
  Object diff8752 = callmethod(*var_depth, "-", 1, partcv, params);
// compiled op node returning diff8752 (depth = 5)
  int op_slot_right_8748 = gc_frame_newslot(diff8752);
// starting to compile num node (depth = 5)
  Object num8754 = alloc_Float64(0);
// compiled num node returning num8754 (depth = 5)
  int op_slot_left_8748 = gc_frame_newslot(num8754);
  params[0] = diff8752;
  partcv[0] = 1;
  Object opresult8755 = callmethod(num8754, "..", 1, partcv, params);
// compiled op node returning opresult8755 (depth = 4)
  gc_frame_newslot(opresult8755);
// starting to compile block node (depth = 4)
  Object block8756 = alloc_Block(NULL, NULL, "ast", 2118);
  gc_frame_newslot(block8756);
// method _apply
  block_savedest(block8756);
  Object closure8757 = createclosure(2, "_apply");
  setclosureframe(closure8757, stackframe);
  addtoclosure(closure8757, var_spc);
  addtoclosure(closure8757, selfslot);
  struct UserObject *uo8757 = (struct UserObject*)block8756;
  uo8757->data[0] = (Object)closure8757;
  Method *meth_meth_ast__apply8757 = addmethod2pos(block8756, "_apply", &meth_ast__apply8757, 0);
  int argcv_meth_ast__apply8757[] = {1};
  meth_meth_ast__apply8757->type = alloc_MethodType(1, argcv_meth_ast__apply8757);
  meth_meth_ast__apply8757->definitionModule = modulename;
  meth_meth_ast__apply8757->definitionLine = 2112;
// compiled block node returning block8756 (depth = 4)
  gc_frame_newslot(block8756);
// call case 5: prelude request
  params[0] = opresult8755;
  params[1] = block8756;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8764 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8747);
// compiled call node returning call8764 (depth = 3)
// Begin line 2121
  setline(2121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8766 == NULL) {
    strlit8766 = alloc_String("");
    gc_root(strlit8766);
  }
// compiled string node returning strlit8766 (depth = 5)
  int op_slot_right_8765 = gc_frame_newslot(strlit8766);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8769 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num8770 = alloc_Float64(0);
// compiled num node returning num8770 (depth = 7)
  gc_frame_newslot(num8770);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8771 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8772 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8771);
// compiled call node returning call8772 (depth = 8)
// compiled member node returning call8772 (depth = 7)
  params[0] = num8770;
  partcv[0] = 1;
  Object call8773 = callmethod(call8772, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe8769);
// compiled call node returning call8773 (depth = 6)
  int op_slot_right_8768 = gc_frame_newslot(call8773);
// starting to compile string node (depth = 6)
  if (strlit8775 == NULL) {
    strlit8775 = alloc_String("def ");
    gc_root(strlit8775);
  }
// compiled string node returning strlit8775 (depth = 6)
  int op_slot_left_8768 = gc_frame_newslot(strlit8775);
  params[0] = call8773;
  partcv[0] = 1;
  Object opresult8776 = callmethod(strlit8775, "++", 1, partcv, params);
// compiled op node returning opresult8776 (depth = 5)
  int op_slot_left_8765 = gc_frame_newslot(opresult8776);
  params[0] = strlit8766;
  partcv[0] = 1;
  Object opresult8777 = callmethod(opresult8776, "++", 1, partcv, params);
// compiled op node returning opresult8777 (depth = 4)
  *var_s = opresult8777;
  if (opresult8777 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2122
  setline(2122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8779 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block8780 = alloc_Block(NULL, NULL, "ast", 2122);
  gc_frame_newslot(block8780);
// method _apply
  block_savedest(block8780);
  Object closure8781 = createclosure(1, "_apply");
  setclosureframe(closure8781, stackframe);
  addtoclosure(closure8781, selfslot);
  struct UserObject *uo8781 = (struct UserObject*)block8780;
  uo8781->data[0] = (Object)closure8781;
  Method *meth_meth_ast__apply8781 = addmethod2pos(block8780, "_apply", &meth_ast__apply8781, 0);
  int argcv_meth_ast__apply8781[] = {0};
  meth_meth_ast__apply8781->type = alloc_MethodType(1, argcv_meth_ast__apply8781);
  meth_meth_ast__apply8781->definitionModule = modulename;
  meth_meth_ast__apply8781->definitionLine = 2121;
// compiled block node returning block8780 (depth = 5)
  gc_frame_newslot(block8780);
// call case 6: other member request
// Begin line 2122
  setline(2122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool8792 = alloc_Boolean(0);
// compiled identifier node returning bool8792 (depth = 6)
  int op_slot_right_8791 = gc_frame_newslot(bool8792);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8794 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8795 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8794);
// compiled call node returning call8795 (depth = 7)
// compiled member node returning call8795 (depth = 6)
  int op_slot_left_8791 = gc_frame_newslot(call8795);
  params[0] = bool8792;
  partcv[0] = 1;
  Object opresult8796 = callmethod(call8795, "!=", 1, partcv, params);
// compiled op node returning opresult8796 (depth = 5)
  params[0] = block8780;
  partcv[0] = 1;
  Object call8797 = callmethod(opresult8796, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe8779);
// compiled call node returning call8797 (depth = 4)
  Object if8778 = done;
  if (istrue(call8797)) {
// Begin line 2124
  setline(2124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8799 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num8800 = alloc_Float64(0);
// compiled num node returning num8800 (depth = 7)
  gc_frame_newslot(num8800);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8801 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8802 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8801);
// compiled call node returning call8802 (depth = 8)
// compiled member node returning call8802 (depth = 7)
  params[0] = num8800;
  partcv[0] = 1;
  Object call8803 = callmethod(call8802, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe8799);
// compiled call node returning call8803 (depth = 6)
  int op_slot_right_8798 = gc_frame_newslot(call8803);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8806 == NULL) {
    strlit8806 = alloc_String(" : ");
    gc_root(strlit8806);
  }
// compiled string node returning strlit8806 (depth = 7)
  int op_slot_right_8805 = gc_frame_newslot(strlit8806);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_8805 = gc_frame_newslot(*var_s);
  params[0] = strlit8806;
  partcv[0] = 1;
  Object opresult8808 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8808 (depth = 6)
  int op_slot_left_8798 = gc_frame_newslot(opresult8808);
  params[0] = call8803;
  partcv[0] = 1;
  Object opresult8809 = callmethod(opresult8808, "++", 1, partcv, params);
// compiled op node returning opresult8809 (depth = 5)
  *var_s = opresult8809;
  if (opresult8809 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8778 = done;
  } else {
  }
// compiled if node returning if8778 (depth = 3)
// Begin line 2126
  setline(2126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num8813 = alloc_Float64(0);
// compiled num node returning num8813 (depth = 5)
  int op_slot_right_8812 = gc_frame_newslot(num8813);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8815 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8816 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8817 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8816);
// compiled call node returning call8817 (depth = 8)
// compiled member node returning call8817 (depth = 7)
  partcv[0] = 0;
  Object call8818 = callmethod(call8817, "size",
    1, partcv, params);
  gc_frame_end(callframe8815);
// compiled call node returning call8818 (depth = 6)
// compiled member node returning call8818 (depth = 5)
  int op_slot_left_8812 = gc_frame_newslot(call8818);
  params[0] = num8813;
  partcv[0] = 1;
  Object opresult8819 = callmethod(call8818, ">", 1, partcv, params);
// compiled op node returning opresult8819 (depth = 4)
  Object if8811 = done;
  if (istrue(opresult8819)) {
// Begin line 2127
  setline(2127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8821 == NULL) {
    strlit8821 = alloc_String(" is ");
    gc_root(strlit8821);
  }
// compiled string node returning strlit8821 (depth = 6)
  int op_slot_right_8820 = gc_frame_newslot(strlit8821);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8820 = gc_frame_newslot(*var_s);
  params[0] = strlit8821;
  partcv[0] = 1;
  Object opresult8823 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8823 (depth = 5)
  *var_s = opresult8823;
  if (opresult8823 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2128
  setline(2128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8826 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit8827 == NULL) {
    strlit8827 = alloc_String("");
    gc_root(strlit8827);
  }
// compiled string node returning strlit8827 (depth = 7)
  gc_frame_newslot(strlit8827);
// starting to compile block node (depth = 7)
  Object block8828 = alloc_Block(NULL, NULL, "ast", 2128);
  gc_frame_newslot(block8828);
// method _apply
  block_savedest(block8828);
  Object closure8829 = createclosure(1, "_apply");
  setclosureframe(closure8829, stackframe);
  addtoclosure(closure8829, selfslot);
  struct UserObject *uo8829 = (struct UserObject*)block8828;
  uo8829->data[0] = (Object)closure8829;
  Method *meth_meth_ast__apply8829 = addmethod2pos(block8828, "_apply", &meth_ast__apply8829, 0);
  int argcv_meth_ast__apply8829[] = {2};
  meth_meth_ast__apply8829->type = alloc_MethodType(1, argcv_meth_ast__apply8829);
  meth_meth_ast__apply8829->definitionModule = modulename;
  meth_meth_ast__apply8829->definitionLine = 2126;
// compiled block node returning block8828 (depth = 7)
  gc_frame_newslot(block8828);
// call case 6: other member request
// Begin line 2128
  setline(2128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8847 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8848 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8847);
// compiled call node returning call8848 (depth = 8)
// compiled member node returning call8848 (depth = 7)
  params[0] = strlit8827;
  params[1] = block8828;
  partcv[0] = 2;
  Object call8849 = callmethod(call8848, "reduce",
    1, partcv, params);
  gc_frame_end(callframe8826);
// compiled call node returning call8849 (depth = 6)
  int op_slot_right_8825 = gc_frame_newslot(call8849);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8825 = gc_frame_newslot(*var_s);
  params[0] = call8849;
  partcv[0] = 1;
  Object opresult8851 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8851 (depth = 5)
  *var_s = opresult8851;
  if (opresult8851 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8811 = done;
  } else {
  }
// compiled if node returning if8811 (depth = 3)
// Begin line 2131
  setline(2131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8855 = alloc_Boolean(0);
// compiled identifier node returning bool8855 (depth = 5)
  int op_slot_right_8854 = gc_frame_newslot(bool8855);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8857 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8858 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8857);
// compiled call node returning call8858 (depth = 6)
// compiled member node returning call8858 (depth = 5)
  int op_slot_left_8854 = gc_frame_newslot(call8858);
  params[0] = bool8855;
  partcv[0] = 1;
  Object opresult8859 = callmethod(call8858, "!=", 1, partcv, params);
// compiled op node returning opresult8859 (depth = 4)
  Object if8853 = done;
  if (istrue(opresult8859)) {
// Begin line 2132
  setline(2132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8861 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8862 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8863 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8862);
// compiled call node returning call8863 (depth = 8)
// compiled member node returning call8863 (depth = 7)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call8864 = callmethod(call8863, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe8861);
// compiled call node returning call8864 (depth = 6)
  int op_slot_right_8860 = gc_frame_newslot(call8864);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8867 == NULL) {
    strlit8867 = alloc_String(" = ");
    gc_root(strlit8867);
  }
// compiled string node returning strlit8867 (depth = 7)
  int op_slot_right_8866 = gc_frame_newslot(strlit8867);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_8866 = gc_frame_newslot(*var_s);
  params[0] = strlit8867;
  partcv[0] = 1;
  Object opresult8869 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8869 (depth = 6)
  int op_slot_left_8860 = gc_frame_newslot(opresult8869);
  params[0] = call8864;
  partcv[0] = 1;
  Object opresult8870 = callmethod(opresult8869, "++", 1, partcv, params);
// compiled op node returning opresult8870 (depth = 5)
  *var_s = opresult8870;
  if (opresult8870 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8853 = done;
  } else {
  }
// compiled if node returning if8853 (depth = 3)
// Begin line 2134
  setline(2134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy8872(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_defDecNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2137
  setline(2137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8873 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe8874 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8875 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8876 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8875);
// compiled call node returning call8876 (depth = 6)
// compiled member node returning call8876 (depth = 5)
  gc_frame_newslot(call8876);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8877 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8878 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8877);
// compiled call node returning call8878 (depth = 6)
// compiled member node returning call8878 (depth = 5)
  gc_frame_newslot(call8878);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8879 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8880 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8879);
// compiled call node returning call8880 (depth = 6)
// compiled member node returning call8880 (depth = 5)
  gc_frame_newslot(call8880);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_defDecNode (depth = 5)
  params[0] = call8876;
  params[1] = call8878;
  params[2] = call8880;
  partcv[0] = 3;
  Object call8881 = callmethod(*var_defDecNode, "new",
    1, partcv, params);
  gc_frame_end(callframe8874);
// compiled call node returning call8881 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call8882 = callmethod(call8881, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe8873);
// compiled call node returning call8882 (depth = 3)
  gc_frame_end(frame);
  return call8882;
}
Object meth_ast_shallowCopyFieldsFrom8883(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyFieldsFrom");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopyFieldsFrom (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyFieldsFrom");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2140
  setline(2140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8884 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call8885 = callmethod4(self, "shallowCopyFieldsFrom", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe8884);
// compiled call node returning call8885 (depth = 3)
// Begin line 2141
  setline(2141);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2137
  setline(2137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8886 = gc_frame_new();
// Begin line 2141
  setline(2141);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8887 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  partcv[0] = 0;
  Object call8888 = callmethod(*var_other, "data",
    1, partcv, params);
  gc_frame_end(callframe8887);
// compiled call node returning call8888 (depth = 6)
// compiled member node returning call8888 (depth = 5)
  gc_frame_newslot(call8888);
// call case 4: self request
  params[0] = call8888;
  partcv[0] = 1;
  Object call8889 = callmethodflags(self, "data:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8886);
// compiled call node returning call8889 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 2142
  setline(2142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2141
  setline(2141);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8890 = gc_frame_new();
// Begin line 2142
  setline(2142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8891 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  partcv[0] = 0;
  Object call8892 = callmethod(*var_other, "startToken",
    1, partcv, params);
  gc_frame_end(callframe8891);
// compiled call node returning call8892 (depth = 6)
// compiled member node returning call8892 (depth = 5)
  gc_frame_newslot(call8892);
// call case 4: self request
  params[0] = call8892;
  partcv[0] = 1;
  Object call8893 = callmethodflags(self, "startToken:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8890);
// compiled call node returning call8893 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 2143
  setline(2143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_new8446(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_defDecNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_val = &(stackframe->slots[1]);
  *var_val = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject8447 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8447 = alloc_userobj2(27,22, objclass8447);
  gc_frame_newslot(obj8447);
if (objclass8447 == NULL) {
  glfree(obj8447->class->name);
  obj8447->class->name = "obj8439.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj8447, self, 0);
  addmethodreal(obj8447,"outer", &reader_ast_outer_8448);
  Object oldself8447 = self;
  struct StackFrameObject *oldstackframe8447 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8447);
  gc_frame_newslot((Object)stackframe);
  self = obj8447;
  Object *oldselfslot8447 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8447 = (*(struct UserObject *)self).data[0], lowerouter8447 = thisouter8447;
  if (inheritingObject8447) {
    struct UserObject *inho8447 = (struct UserObject *)inheritingObject8447;
    while (inho8447->super != GraceDefaultObject) inho8447 = (struct UserObject *)inho8447->super;
    inho8447->super = obj8447;
    self = inheritingObject8447;
    *selfslot = self;
    lowerouter8447 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8447;
  }
if (objclass8447 == NULL) {
  Method *reader8449 = addmethodrealflags(obj8447, "kind",&reader_ast_kind_8449, MFLAG_DEF);
  reader8449->definitionModule = modulename;
  reader8449->definitionLine = 2036;
}
adddatum2(obj8447, alloc_Undefined(), 1);
if (objclass8447 == NULL) {
  Method *reader8450 = addmethodrealflags(obj8447, "name",&reader_ast_name_8450, 0);
  Method *writer8450 = addmethodrealflags(obj8447, "name:=",&writer_ast_name_8450, 0);
  reader8450->definitionModule = modulename;
  writer8450->definitionModule = modulename;
  reader8450->definitionLine = 2037;
  writer8450->definitionLine = 2037;
}
obj8447->flags |= OFLAG_MUTABLE;
adddatum2(obj8447, alloc_Undefined(), 2);
if (objclass8447 == NULL) {
  Method *reader8451 = addmethodrealflags(obj8447, "value",&reader_ast_value_8451, 0);
  Method *writer8451 = addmethodrealflags(obj8447, "value:=",&writer_ast_value_8451, 0);
  reader8451->definitionModule = modulename;
  writer8451->definitionModule = modulename;
  reader8451->definitionLine = 2038;
  writer8451->definitionLine = 2038;
}
obj8447->flags |= OFLAG_MUTABLE;
adddatum2(obj8447, alloc_Undefined(), 3);
if (objclass8447 == NULL) {
  Method *reader8452 = addmethodrealflags(obj8447, "dtype",&reader_ast_dtype_8452, 0);
  Method *writer8452 = addmethodrealflags(obj8447, "dtype:=",&writer_ast_dtype_8452, 0);
  reader8452->definitionModule = modulename;
  writer8452->definitionModule = modulename;
  reader8452->definitionLine = 2039;
  writer8452->definitionLine = 2039;
}
obj8447->flags |= OFLAG_MUTABLE;
adddatum2(obj8447, alloc_Undefined(), 4);
if (objclass8447 == NULL) {
  Method *reader8453 = addmethodrealflags(obj8447, "nameString",&reader_ast_nameString_8453, MFLAG_DEF);
  reader8453->definitionModule = modulename;
  reader8453->definitionLine = 2040;
}
adddatum2(obj8447, alloc_Undefined(), 5);
if (objclass8447 == NULL) {
  Method *reader8454 = addmethodrealflags(obj8447, "annotations",&reader_ast_annotations_8454, 0);
  Method *writer8454 = addmethodrealflags(obj8447, "annotations:=",&writer_ast_annotations_8454, 0);
  reader8454->definitionModule = modulename;
  writer8454->definitionModule = modulename;
  reader8454->definitionLine = 2041;
  writer8454->definitionLine = 2041;
}
obj8447->flags |= OFLAG_MUTABLE;
adddatum2(obj8447, alloc_Undefined(), 6);
if (objclass8447 == NULL) {
  Method *reader8455 = addmethodrealflags(obj8447, "data",&reader_ast_data_8455, 0);
  Method *writer8455 = addmethodrealflags(obj8447, "data:=",&writer_ast_data_8455, 0);
  reader8455->definitionModule = modulename;
  writer8455->definitionModule = modulename;
  reader8455->definitionLine = 2042;
  writer8455->definitionLine = 2042;
}
obj8447->flags |= OFLAG_MUTABLE;
adddatum2(obj8447, alloc_Undefined(), 7);
if (objclass8447 == NULL) {
  Method *reader8456 = addmethodrealflags(obj8447, "startToken",&reader_ast_startToken_8456, 0);
  Method *writer8456 = addmethodrealflags(obj8447, "startToken:=",&writer_ast_startToken_8456, 0);
  reader8456->definitionModule = modulename;
  writer8456->definitionModule = modulename;
  reader8456->definitionLine = 2043;
  writer8456->definitionLine = 2043;
}
obj8447->flags |= OFLAG_MUTABLE;
adddatum2(obj8447, alloc_Undefined(), 8);
// method isPublic
  struct UserObject *uo8457 = (struct UserObject*)obj8447;
  uo8457->data[9] = emptyclosure;
  Method *meth_meth_ast_isPublic8457 = addmethod2pos(obj8447, "isPublic", &meth_ast_isPublic8457, 9);
  int argcv_meth_ast_isPublic8457[] = {0};
  meth_meth_ast_isPublic8457->type = alloc_MethodType(1, argcv_meth_ast_isPublic8457);
  meth_meth_ast_isPublic8457->definitionModule = modulename;
  meth_meth_ast_isPublic8457->definitionLine = 2045;
// method isWritable
  struct UserObject *uo8484 = (struct UserObject*)obj8447;
  uo8484->data[10] = emptyclosure;
  Method *meth_meth_ast_isWritable8484 = addmethod2pos(obj8447, "isWritable", &meth_ast_isWritable8484, 10);
  int argcv_meth_ast_isWritable8484[] = {0};
  meth_meth_ast_isWritable8484->type = alloc_MethodType(1, argcv_meth_ast_isWritable8484);
  meth_meth_ast_isWritable8484->definitionModule = modulename;
  meth_meth_ast_isWritable8484->definitionLine = 2051;
// method isReadable
  struct UserObject *uo8486 = (struct UserObject*)obj8447;
  uo8486->data[11] = emptyclosure;
  Method *meth_meth_ast_isReadable8486 = addmethod2pos(obj8447, "isReadable", &meth_ast_isReadable8486, 11);
  int argcv_meth_ast_isReadable8486[] = {0};
  meth_meth_ast_isReadable8486->type = alloc_MethodType(1, argcv_meth_ast_isReadable8486);
  meth_meth_ast_isReadable8486->definitionModule = modulename;
  meth_meth_ast_isReadable8486->definitionLine = 2052;
// method returnsObject
  struct UserObject *uo8489 = (struct UserObject*)obj8447;
  uo8489->data[12] = emptyclosure;
  Method *meth_meth_ast_returnsObject8489 = addmethod2pos(obj8447, "returnsObject", &meth_ast_returnsObject8489, 12);
  int argcv_meth_ast_returnsObject8489[] = {0};
  meth_meth_ast_returnsObject8489->type = alloc_MethodType(1, argcv_meth_ast_returnsObject8489);
  meth_meth_ast_returnsObject8489->definitionModule = modulename;
  meth_meth_ast_returnsObject8489->definitionLine = 2058;
// method returnedObjectScope
  struct UserObject *uo8494 = (struct UserObject*)obj8447;
  uo8494->data[13] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope8494 = addmethod2pos(obj8447, "returnedObjectScope", &meth_ast_returnedObjectScope8494, 13);
  int argcv_meth_ast_returnedObjectScope8494[] = {0};
  meth_meth_ast_returnedObjectScope8494->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope8494);
  meth_meth_ast_returnedObjectScope8494->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope8494->definitionLine = 2061;
// method usesAsType
  struct UserObject *uo8499 = (struct UserObject*)obj8447;
  uo8499->data[14] = emptyclosure;
  Method *meth_meth_ast_usesAsType8499 = addmethod2pos(obj8447, "usesAsType", &meth_ast_usesAsType8499, 14);
  int argcv_meth_ast_usesAsType8499[] = {1};
  meth_meth_ast_usesAsType8499->type = alloc_MethodType(1, argcv_meth_ast_usesAsType8499);
  meth_meth_ast_usesAsType8499->definitionModule = modulename;
  meth_meth_ast_usesAsType8499->definitionLine = 2065;
// method accept()from
  struct UserObject *uo8505 = (struct UserObject*)obj8447;
  uo8505->data[15] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from8505 = addmethod2pos(obj8447, "accept()from", &meth_ast_accept_40__41_from8505, 15);
  int argcv_meth_ast_accept_40__41_from8505[] = {1, 1};
  meth_meth_ast_accept_40__41_from8505->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from8505);
  meth_meth_ast_accept_40__41_from8505->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from8505->definitionLine = 2068;
// method map()ancestors
  struct UserObject *uo8546 = (struct UserObject*)obj8447;
  uo8546->data[16] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors8546 = addmethod2pos(obj8447, "map()ancestors", &meth_ast_map_40__41_ancestors8546, 16);
  int argcv_meth_ast_map_40__41_ancestors8546[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors8546->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors8546);
  meth_meth_ast_map_40__41_ancestors8546->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors8546->definitionLine = 2083;
// method pretty
  struct UserObject *uo8585 = (struct UserObject*)obj8447;
  uo8585->data[17] = emptyclosure;
  Method *meth_meth_ast_pretty8585 = addmethod2pos(obj8447, "pretty", &meth_ast_pretty8585, 17);
  int argcv_meth_ast_pretty8585[] = {1};
  meth_meth_ast_pretty8585->type = alloc_MethodType(1, argcv_meth_ast_pretty8585);
  meth_meth_ast_pretty8585->definitionModule = modulename;
  meth_meth_ast_pretty8585->definitionLine = 2092;
// method toGrace
  struct UserObject *uo8745 = (struct UserObject*)obj8447;
  uo8745->data[18] = emptyclosure;
  Method *meth_meth_ast_toGrace8745 = addmethod2pos(obj8447, "toGrace", &meth_ast_toGrace8745, 18);
  int argcv_meth_ast_toGrace8745[] = {1};
  meth_meth_ast_toGrace8745->type = alloc_MethodType(1, argcv_meth_ast_toGrace8745);
meth_meth_ast_toGrace8745->type->types[0] = type_Number;
meth_meth_ast_toGrace8745->type->names[0] = "depth";
  meth_meth_ast_toGrace8745->definitionModule = modulename;
  meth_meth_ast_toGrace8745->definitionLine = 2116;
// method shallowCopy
  block_savedest(obj8447);
  Object closure8872 = createclosure(1, "shallowCopy");
  setclosureframe(closure8872, stackframe);
  addtoclosure(closure8872, var_defDecNode);
  struct UserObject *uo8872 = (struct UserObject*)obj8447;
  uo8872->data[19] = (Object)closure8872;
  Method *meth_meth_ast_shallowCopy8872 = addmethod2pos(obj8447, "shallowCopy", &meth_ast_shallowCopy8872, 19);
  int argcv_meth_ast_shallowCopy8872[] = {0};
  meth_meth_ast_shallowCopy8872->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy8872);
  meth_meth_ast_shallowCopy8872->definitionModule = modulename;
  meth_meth_ast_shallowCopy8872->definitionLine = 2136;
// method shallowCopyFieldsFrom
  struct UserObject *uo8883 = (struct UserObject*)obj8447;
  uo8883->data[20] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom8883 = addmethod2pos(obj8447, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom8883, 20);
  int argcv_meth_ast_shallowCopyFieldsFrom8883[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom8883->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom8883);
  meth_meth_ast_shallowCopyFieldsFrom8883->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom8883->definitionLine = 2139;
  sourceObject = obj8447;
// Begin line 2035
  setline(2035);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8894 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_baseNode (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call8895 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe8894);
// compiled call node returning call8895 (depth = 3)
  struct UserObject *obj8447_uo = (struct UserObject *)obj8447;
  obj8447_uo->super = call8895;
  sourceObject = obj8447;
// Begin line 2036
  setline(2036);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit8896 == NULL) {
    strlit8896 = alloc_String("defdec");
    gc_root(strlit8896);
  }
// compiled string node returning strlit8896 (depth = 3)
  adddatum2(obj8447, strlit8896, 1);
  sourceObject = obj8447;
// Begin line 2037
  setline(2037);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj8447, *var_name_39_, 2);
  sourceObject = obj8447;
// Begin line 2038
  setline(2038);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val (depth = 3)
  adddatum2(obj8447, *var_val, 3);
  sourceObject = obj8447;
// Begin line 2039
  setline(2039);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj8447, *var_dtype_39_, 4);
  sourceObject = obj8447;
// Begin line 2040
  setline(2040);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8897 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8898 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8899 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8898);
// compiled call node returning call8899 (depth = 6)
// compiled member node returning call8899 (depth = 5)
  partcv[0] = 0;
  Object call8900 = callmethod(call8899, "value",
    1, partcv, params);
  gc_frame_end(callframe8897);
// compiled call node returning call8900 (depth = 4)
// compiled member node returning call8900 (depth = 3)
  adddatum2(obj8447, call8900, 5);
  sourceObject = obj8447;
// Begin line 2041
  setline(2041);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8901 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8902 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call8903 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8902);
// compiled call node returning call8903 (depth = 6)
// compiled member node returning call8903 (depth = 5)
  partcv[0] = 0;
  Object call8904 = callmethod(call8903, "empty",
    1, partcv, params);
  gc_frame_end(callframe8901);
// compiled call node returning call8904 (depth = 4)
// compiled member node returning call8904 (depth = 3)
  adddatum2(obj8447, call8904, 6);
  sourceObject = obj8447;
// Begin line 2042
  setline(2042);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8905 = alloc_Boolean(0);
// compiled identifier node returning bool8905 (depth = 3)
  adddatum2(obj8447, bool8905, 7);
  sourceObject = obj8447;
// Begin line 2043
  setline(2043);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8906 = alloc_Boolean(0);
// compiled identifier node returning bool8906 (depth = 3)
  adddatum2(obj8447, bool8906, 8);
  sourceObject = obj8447;
  sourceObject = obj8447;
  sourceObject = obj8447;
  sourceObject = obj8447;
  sourceObject = obj8447;
  sourceObject = obj8447;
  sourceObject = obj8447;
  sourceObject = obj8447;
  sourceObject = obj8447;
  sourceObject = obj8447;
  sourceObject = obj8447;
  sourceObject = obj8447;
  objclass8447 = obj8447->class;
  objclass8447->definitionModule = modulename;
  objclass8447->definitionLine = 2034;
  (*(struct UserObject *)self).data[0] = lowerouter8447;
  self = oldself8447;
  selfslot = oldselfslot8447;
  stackframe = oldstackframe8447;
  gc_frame_end(frame);
  return obj8447;
}
Object meth_ast_new8446_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_defDecNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_val = &(stackframe->slots[1]);
  *var_val = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject8447 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8447 = alloc_userobj2(27,22, objclass8447);
  gc_frame_newslot(obj8447);
if (objclass8447 == NULL) {
  glfree(obj8447->class->name);
  obj8447->class->name = "obj8439.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj8447, self, 0);
  addmethodreal(obj8447,"outer", &reader_ast_outer_8448);
  Object oldself8447 = self;
  struct StackFrameObject *oldstackframe8447 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8447);
  gc_frame_newslot((Object)stackframe);
  self = obj8447;
  Object *oldselfslot8447 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8447 = (*(struct UserObject *)self).data[0], lowerouter8447 = thisouter8447;
  if (inheritingObject8447) {
    struct UserObject *inho8447 = (struct UserObject *)inheritingObject8447;
    while (inho8447->super != GraceDefaultObject) inho8447 = (struct UserObject *)inho8447->super;
    inho8447->super = obj8447;
    self = inheritingObject8447;
    *selfslot = self;
    lowerouter8447 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8447;
  }
if (objclass8447 == NULL) {
  Method *reader8449 = addmethodrealflags(obj8447, "kind",&reader_ast_kind_8449, MFLAG_DEF);
  reader8449->definitionModule = modulename;
  reader8449->definitionLine = 2036;
}
adddatum2(obj8447, alloc_Undefined(), 1);
if (objclass8447 == NULL) {
  Method *reader8450 = addmethodrealflags(obj8447, "name",&reader_ast_name_8450, 0);
  Method *writer8450 = addmethodrealflags(obj8447, "name:=",&writer_ast_name_8450, 0);
  reader8450->definitionModule = modulename;
  writer8450->definitionModule = modulename;
  reader8450->definitionLine = 2037;
  writer8450->definitionLine = 2037;
}
obj8447->flags |= OFLAG_MUTABLE;
adddatum2(obj8447, alloc_Undefined(), 2);
if (objclass8447 == NULL) {
  Method *reader8451 = addmethodrealflags(obj8447, "value",&reader_ast_value_8451, 0);
  Method *writer8451 = addmethodrealflags(obj8447, "value:=",&writer_ast_value_8451, 0);
  reader8451->definitionModule = modulename;
  writer8451->definitionModule = modulename;
  reader8451->definitionLine = 2038;
  writer8451->definitionLine = 2038;
}
obj8447->flags |= OFLAG_MUTABLE;
adddatum2(obj8447, alloc_Undefined(), 3);
if (objclass8447 == NULL) {
  Method *reader8452 = addmethodrealflags(obj8447, "dtype",&reader_ast_dtype_8452, 0);
  Method *writer8452 = addmethodrealflags(obj8447, "dtype:=",&writer_ast_dtype_8452, 0);
  reader8452->definitionModule = modulename;
  writer8452->definitionModule = modulename;
  reader8452->definitionLine = 2039;
  writer8452->definitionLine = 2039;
}
obj8447->flags |= OFLAG_MUTABLE;
adddatum2(obj8447, alloc_Undefined(), 4);
if (objclass8447 == NULL) {
  Method *reader8453 = addmethodrealflags(obj8447, "nameString",&reader_ast_nameString_8453, MFLAG_DEF);
  reader8453->definitionModule = modulename;
  reader8453->definitionLine = 2040;
}
adddatum2(obj8447, alloc_Undefined(), 5);
if (objclass8447 == NULL) {
  Method *reader8454 = addmethodrealflags(obj8447, "annotations",&reader_ast_annotations_8454, 0);
  Method *writer8454 = addmethodrealflags(obj8447, "annotations:=",&writer_ast_annotations_8454, 0);
  reader8454->definitionModule = modulename;
  writer8454->definitionModule = modulename;
  reader8454->definitionLine = 2041;
  writer8454->definitionLine = 2041;
}
obj8447->flags |= OFLAG_MUTABLE;
adddatum2(obj8447, alloc_Undefined(), 6);
if (objclass8447 == NULL) {
  Method *reader8455 = addmethodrealflags(obj8447, "data",&reader_ast_data_8455, 0);
  Method *writer8455 = addmethodrealflags(obj8447, "data:=",&writer_ast_data_8455, 0);
  reader8455->definitionModule = modulename;
  writer8455->definitionModule = modulename;
  reader8455->definitionLine = 2042;
  writer8455->definitionLine = 2042;
}
obj8447->flags |= OFLAG_MUTABLE;
adddatum2(obj8447, alloc_Undefined(), 7);
if (objclass8447 == NULL) {
  Method *reader8456 = addmethodrealflags(obj8447, "startToken",&reader_ast_startToken_8456, 0);
  Method *writer8456 = addmethodrealflags(obj8447, "startToken:=",&writer_ast_startToken_8456, 0);
  reader8456->definitionModule = modulename;
  writer8456->definitionModule = modulename;
  reader8456->definitionLine = 2043;
  writer8456->definitionLine = 2043;
}
obj8447->flags |= OFLAG_MUTABLE;
adddatum2(obj8447, alloc_Undefined(), 8);
// method isPublic
  struct UserObject *uo8457 = (struct UserObject*)obj8447;
  uo8457->data[9] = emptyclosure;
  Method *meth_meth_ast_isPublic8457 = addmethod2pos(obj8447, "isPublic", &meth_ast_isPublic8457, 9);
  int argcv_meth_ast_isPublic8457[] = {0};
  meth_meth_ast_isPublic8457->type = alloc_MethodType(1, argcv_meth_ast_isPublic8457);
  meth_meth_ast_isPublic8457->definitionModule = modulename;
  meth_meth_ast_isPublic8457->definitionLine = 2045;
// method isWritable
  struct UserObject *uo8484 = (struct UserObject*)obj8447;
  uo8484->data[10] = emptyclosure;
  Method *meth_meth_ast_isWritable8484 = addmethod2pos(obj8447, "isWritable", &meth_ast_isWritable8484, 10);
  int argcv_meth_ast_isWritable8484[] = {0};
  meth_meth_ast_isWritable8484->type = alloc_MethodType(1, argcv_meth_ast_isWritable8484);
  meth_meth_ast_isWritable8484->definitionModule = modulename;
  meth_meth_ast_isWritable8484->definitionLine = 2051;
// method isReadable
  struct UserObject *uo8486 = (struct UserObject*)obj8447;
  uo8486->data[11] = emptyclosure;
  Method *meth_meth_ast_isReadable8486 = addmethod2pos(obj8447, "isReadable", &meth_ast_isReadable8486, 11);
  int argcv_meth_ast_isReadable8486[] = {0};
  meth_meth_ast_isReadable8486->type = alloc_MethodType(1, argcv_meth_ast_isReadable8486);
  meth_meth_ast_isReadable8486->definitionModule = modulename;
  meth_meth_ast_isReadable8486->definitionLine = 2052;
// method returnsObject
  struct UserObject *uo8489 = (struct UserObject*)obj8447;
  uo8489->data[12] = emptyclosure;
  Method *meth_meth_ast_returnsObject8489 = addmethod2pos(obj8447, "returnsObject", &meth_ast_returnsObject8489, 12);
  int argcv_meth_ast_returnsObject8489[] = {0};
  meth_meth_ast_returnsObject8489->type = alloc_MethodType(1, argcv_meth_ast_returnsObject8489);
  meth_meth_ast_returnsObject8489->definitionModule = modulename;
  meth_meth_ast_returnsObject8489->definitionLine = 2058;
// method returnedObjectScope
  struct UserObject *uo8494 = (struct UserObject*)obj8447;
  uo8494->data[13] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope8494 = addmethod2pos(obj8447, "returnedObjectScope", &meth_ast_returnedObjectScope8494, 13);
  int argcv_meth_ast_returnedObjectScope8494[] = {0};
  meth_meth_ast_returnedObjectScope8494->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope8494);
  meth_meth_ast_returnedObjectScope8494->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope8494->definitionLine = 2061;
// method usesAsType
  struct UserObject *uo8499 = (struct UserObject*)obj8447;
  uo8499->data[14] = emptyclosure;
  Method *meth_meth_ast_usesAsType8499 = addmethod2pos(obj8447, "usesAsType", &meth_ast_usesAsType8499, 14);
  int argcv_meth_ast_usesAsType8499[] = {1};
  meth_meth_ast_usesAsType8499->type = alloc_MethodType(1, argcv_meth_ast_usesAsType8499);
  meth_meth_ast_usesAsType8499->definitionModule = modulename;
  meth_meth_ast_usesAsType8499->definitionLine = 2065;
// method accept()from
  struct UserObject *uo8505 = (struct UserObject*)obj8447;
  uo8505->data[15] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from8505 = addmethod2pos(obj8447, "accept()from", &meth_ast_accept_40__41_from8505, 15);
  int argcv_meth_ast_accept_40__41_from8505[] = {1, 1};
  meth_meth_ast_accept_40__41_from8505->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from8505);
  meth_meth_ast_accept_40__41_from8505->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from8505->definitionLine = 2068;
// method map()ancestors
  struct UserObject *uo8546 = (struct UserObject*)obj8447;
  uo8546->data[16] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors8546 = addmethod2pos(obj8447, "map()ancestors", &meth_ast_map_40__41_ancestors8546, 16);
  int argcv_meth_ast_map_40__41_ancestors8546[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors8546->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors8546);
  meth_meth_ast_map_40__41_ancestors8546->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors8546->definitionLine = 2083;
// method pretty
  struct UserObject *uo8585 = (struct UserObject*)obj8447;
  uo8585->data[17] = emptyclosure;
  Method *meth_meth_ast_pretty8585 = addmethod2pos(obj8447, "pretty", &meth_ast_pretty8585, 17);
  int argcv_meth_ast_pretty8585[] = {1};
  meth_meth_ast_pretty8585->type = alloc_MethodType(1, argcv_meth_ast_pretty8585);
  meth_meth_ast_pretty8585->definitionModule = modulename;
  meth_meth_ast_pretty8585->definitionLine = 2092;
// method toGrace
  struct UserObject *uo8745 = (struct UserObject*)obj8447;
  uo8745->data[18] = emptyclosure;
  Method *meth_meth_ast_toGrace8745 = addmethod2pos(obj8447, "toGrace", &meth_ast_toGrace8745, 18);
  int argcv_meth_ast_toGrace8745[] = {1};
  meth_meth_ast_toGrace8745->type = alloc_MethodType(1, argcv_meth_ast_toGrace8745);
meth_meth_ast_toGrace8745->type->types[0] = type_Number;
meth_meth_ast_toGrace8745->type->names[0] = "depth";
  meth_meth_ast_toGrace8745->definitionModule = modulename;
  meth_meth_ast_toGrace8745->definitionLine = 2116;
// method shallowCopy
  block_savedest(obj8447);
  Object closure8872 = createclosure(1, "shallowCopy");
  setclosureframe(closure8872, stackframe);
  addtoclosure(closure8872, var_defDecNode);
  struct UserObject *uo8872 = (struct UserObject*)obj8447;
  uo8872->data[19] = (Object)closure8872;
  Method *meth_meth_ast_shallowCopy8872 = addmethod2pos(obj8447, "shallowCopy", &meth_ast_shallowCopy8872, 19);
  int argcv_meth_ast_shallowCopy8872[] = {0};
  meth_meth_ast_shallowCopy8872->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy8872);
  meth_meth_ast_shallowCopy8872->definitionModule = modulename;
  meth_meth_ast_shallowCopy8872->definitionLine = 2136;
// method shallowCopyFieldsFrom
  struct UserObject *uo8883 = (struct UserObject*)obj8447;
  uo8883->data[20] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom8883 = addmethod2pos(obj8447, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom8883, 20);
  int argcv_meth_ast_shallowCopyFieldsFrom8883[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom8883->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom8883);
  meth_meth_ast_shallowCopyFieldsFrom8883->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom8883->definitionLine = 2139;
  sourceObject = obj8447;
// Begin line 2035
  setline(2035);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8894 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_baseNode (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call8895 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe8894);
// compiled call node returning call8895 (depth = 3)
  struct UserObject *obj8447_uo = (struct UserObject *)obj8447;
  obj8447_uo->super = call8895;
  sourceObject = obj8447;
// Begin line 2036
  setline(2036);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit8896 == NULL) {
    strlit8896 = alloc_String("defdec");
    gc_root(strlit8896);
  }
// compiled string node returning strlit8896 (depth = 3)
  adddatum2(obj8447, strlit8896, 1);
  sourceObject = obj8447;
// Begin line 2037
  setline(2037);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj8447, *var_name_39_, 2);
  sourceObject = obj8447;
// Begin line 2038
  setline(2038);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val (depth = 3)
  adddatum2(obj8447, *var_val, 3);
  sourceObject = obj8447;
// Begin line 2039
  setline(2039);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj8447, *var_dtype_39_, 4);
  sourceObject = obj8447;
// Begin line 2040
  setline(2040);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8897 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8898 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8899 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8898);
// compiled call node returning call8899 (depth = 6)
// compiled member node returning call8899 (depth = 5)
  partcv[0] = 0;
  Object call8900 = callmethod(call8899, "value",
    1, partcv, params);
  gc_frame_end(callframe8897);
// compiled call node returning call8900 (depth = 4)
// compiled member node returning call8900 (depth = 3)
  adddatum2(obj8447, call8900, 5);
  sourceObject = obj8447;
// Begin line 2041
  setline(2041);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8901 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8902 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call8903 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8902);
// compiled call node returning call8903 (depth = 6)
// compiled member node returning call8903 (depth = 5)
  partcv[0] = 0;
  Object call8904 = callmethod(call8903, "empty",
    1, partcv, params);
  gc_frame_end(callframe8901);
// compiled call node returning call8904 (depth = 4)
// compiled member node returning call8904 (depth = 3)
  adddatum2(obj8447, call8904, 6);
  sourceObject = obj8447;
// Begin line 2042
  setline(2042);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8905 = alloc_Boolean(0);
// compiled identifier node returning bool8905 (depth = 3)
  adddatum2(obj8447, bool8905, 7);
  sourceObject = obj8447;
// Begin line 2043
  setline(2043);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8906 = alloc_Boolean(0);
// compiled identifier node returning bool8906 (depth = 3)
  adddatum2(obj8447, bool8906, 8);
  sourceObject = obj8447;
  sourceObject = obj8447;
  sourceObject = obj8447;
  sourceObject = obj8447;
  sourceObject = obj8447;
  sourceObject = obj8447;
  sourceObject = obj8447;
  sourceObject = obj8447;
  sourceObject = obj8447;
  sourceObject = obj8447;
  sourceObject = obj8447;
  sourceObject = obj8447;
  objclass8447 = obj8447->class;
  objclass8447->definitionModule = modulename;
  objclass8447->definitionLine = 2034;
  (*(struct UserObject *)self).data[0] = lowerouter8447;
  self = oldself8447;
  selfslot = oldselfslot8447;
  stackframe = oldstackframe8447;
  gc_frame_end(frame);
  return obj8447;
}
Object meth_ast_defDecNode8908(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 40, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "defDecNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_defDecNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for defDecNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹defDecNode›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2027
  setline(2027);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_defDecNode (depth = 3)
  gc_frame_end(frame);
  return *var_defDecNode;
}
Object meth_ast_varDecNode8909(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 41, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "varDecNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_varDecNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for varDecNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for varDecNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_varDecNode (depth = 3)
  gc_frame_end(frame);
  return *var_varDecNode;
}
Object meth_ast_isPublic8921(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPublic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isPublic (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isPublic");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2158
  setline(2158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num8924 = alloc_Float64(0);
// compiled num node returning num8924 (depth = 6)
  int op_slot_right_8923 = gc_frame_newslot(num8924);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8926 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8927 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8928 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8927);
// compiled call node returning call8928 (depth = 9)
// compiled member node returning call8928 (depth = 8)
  partcv[0] = 0;
  Object call8929 = callmethod(call8928, "size",
    1, partcv, params);
  gc_frame_end(callframe8926);
// compiled call node returning call8929 (depth = 7)
// compiled member node returning call8929 (depth = 6)
  int op_slot_left_8923 = gc_frame_newslot(call8929);
  params[0] = num8924;
  partcv[0] = 1;
  Object opresult8930 = callmethod(call8929, "==", 1, partcv, params);
// compiled op node returning opresult8930 (depth = 5)
  Object if8922 = done;
  if (istrue(opresult8930)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool8931 = alloc_Boolean(0);
// compiled identifier node returning bool8931 (depth = 6)
  return bool8931;
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if8922 = undefined;
  } else {
  }
// compiled if node returning if8922 (depth = 4)
// Begin line 2159
  setline(2159);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8933 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile string node (depth = 6)
  if (strlit8934 == NULL) {
    strlit8934 = alloc_String("public");
    gc_root(strlit8934);
  }
// compiled string node returning strlit8934 (depth = 6)
  gc_frame_newslot(strlit8934);
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8935 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8936 = gc_frame_new();
// call case 3: self.outer request
  Object call8937 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8936);
// compiled call node returning call8937 (depth = 9)
// compiled member node returning call8937 (depth = 8)
  partcv[0] = 0;
  Object call8938 = callmethodflags(call8937, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8935);
// compiled call node returning call8938 (depth = 7)
// compiled member node returning call8938 (depth = 6)
  params[0] = self;
  params[1] = strlit8934;
  partcv[0] = 2;
  Object call8939 = callmethodflags(call8938, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8933);
// compiled call node returning call8939 (depth = 5)
  Object if8932 = done;
  if (istrue(call8939)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool8940 = alloc_Boolean(1);
// compiled identifier node returning bool8940 (depth = 6)
  return bool8940;
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if8932 = undefined;
  } else {
  }
// compiled if node returning if8932 (depth = 4)
// Begin line 2160
  setline(2160);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8941 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile string node (depth = 5)
  if (strlit8942 == NULL) {
    strlit8942 = alloc_String("readable");
    gc_root(strlit8942);
  }
// compiled string node returning strlit8942 (depth = 5)
  gc_frame_newslot(strlit8942);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8943 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8944 = gc_frame_new();
// call case 3: self.outer request
  Object call8945 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8944);
// compiled call node returning call8945 (depth = 8)
// compiled member node returning call8945 (depth = 7)
  partcv[0] = 0;
  Object call8946 = callmethodflags(call8945, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8943);
// compiled call node returning call8946 (depth = 6)
// compiled member node returning call8946 (depth = 5)
  params[0] = self;
  params[1] = strlit8942;
  partcv[0] = 2;
  Object call8947 = callmethodflags(call8946, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8941);
// compiled call node returning call8947 (depth = 4)
  gc_frame_end(frame);
  return call8947;
}
Object meth_ast_isWritable8948(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isWritable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isWritable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isWritable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2163
  setline(2163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num8951 = alloc_Float64(0);
// compiled num node returning num8951 (depth = 6)
  int op_slot_right_8950 = gc_frame_newslot(num8951);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8953 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8954 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8955 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8954);
// compiled call node returning call8955 (depth = 9)
// compiled member node returning call8955 (depth = 8)
  partcv[0] = 0;
  Object call8956 = callmethod(call8955, "size",
    1, partcv, params);
  gc_frame_end(callframe8953);
// compiled call node returning call8956 (depth = 7)
// compiled member node returning call8956 (depth = 6)
  int op_slot_left_8950 = gc_frame_newslot(call8956);
  params[0] = num8951;
  partcv[0] = 1;
  Object opresult8957 = callmethod(call8956, "==", 1, partcv, params);
// compiled op node returning opresult8957 (depth = 5)
  Object if8949 = done;
  if (istrue(opresult8957)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool8958 = alloc_Boolean(0);
// compiled identifier node returning bool8958 (depth = 6)
  return bool8958;
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if8949 = undefined;
  } else {
  }
// compiled if node returning if8949 (depth = 4)
// Begin line 2164
  setline(2164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8960 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile string node (depth = 6)
  if (strlit8961 == NULL) {
    strlit8961 = alloc_String("public");
    gc_root(strlit8961);
  }
// compiled string node returning strlit8961 (depth = 6)
  gc_frame_newslot(strlit8961);
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8962 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8963 = gc_frame_new();
// call case 3: self.outer request
  Object call8964 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8963);
// compiled call node returning call8964 (depth = 9)
// compiled member node returning call8964 (depth = 8)
  partcv[0] = 0;
  Object call8965 = callmethodflags(call8964, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8962);
// compiled call node returning call8965 (depth = 7)
// compiled member node returning call8965 (depth = 6)
  params[0] = self;
  params[1] = strlit8961;
  partcv[0] = 2;
  Object call8966 = callmethodflags(call8965, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8960);
// compiled call node returning call8966 (depth = 5)
  Object if8959 = done;
  if (istrue(call8966)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool8967 = alloc_Boolean(1);
// compiled identifier node returning bool8967 (depth = 6)
  return bool8967;
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if8959 = undefined;
  } else {
  }
// compiled if node returning if8959 (depth = 4)
// Begin line 2165
  setline(2165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8969 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile string node (depth = 6)
  if (strlit8970 == NULL) {
    strlit8970 = alloc_String("writable");
    gc_root(strlit8970);
  }
// compiled string node returning strlit8970 (depth = 6)
  gc_frame_newslot(strlit8970);
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8971 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8972 = gc_frame_new();
// call case 3: self.outer request
  Object call8973 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8972);
// compiled call node returning call8973 (depth = 9)
// compiled member node returning call8973 (depth = 8)
  partcv[0] = 0;
  Object call8974 = callmethodflags(call8973, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8971);
// compiled call node returning call8974 (depth = 7)
// compiled member node returning call8974 (depth = 6)
  params[0] = self;
  params[1] = strlit8970;
  partcv[0] = 2;
  Object call8975 = callmethodflags(call8974, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8969);
// compiled call node returning call8975 (depth = 5)
  Object if8968 = done;
  if (istrue(call8975)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool8976 = alloc_Boolean(1);
// compiled identifier node returning bool8976 (depth = 6)
  return bool8976;
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if8968 = undefined;
  } else {
  }
// compiled if node returning if8968 (depth = 4)
// Begin line 2166
  setline(2166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool8977 = alloc_Boolean(0);
// compiled identifier node returning bool8977 (depth = 4)
  gc_frame_end(frame);
  return bool8977;
}
Object meth_ast_isReadable8978(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isReadable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isReadable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isReadable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2169
  setline(2169);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num8981 = alloc_Float64(0);
// compiled num node returning num8981 (depth = 6)
  int op_slot_right_8980 = gc_frame_newslot(num8981);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8983 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8984 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8985 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8984);
// compiled call node returning call8985 (depth = 9)
// compiled member node returning call8985 (depth = 8)
  partcv[0] = 0;
  Object call8986 = callmethod(call8985, "size",
    1, partcv, params);
  gc_frame_end(callframe8983);
// compiled call node returning call8986 (depth = 7)
// compiled member node returning call8986 (depth = 6)
  int op_slot_left_8980 = gc_frame_newslot(call8986);
  params[0] = num8981;
  partcv[0] = 1;
  Object opresult8987 = callmethod(call8986, "==", 1, partcv, params);
// compiled op node returning opresult8987 (depth = 5)
  Object if8979 = done;
  if (istrue(opresult8987)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool8988 = alloc_Boolean(0);
// compiled identifier node returning bool8988 (depth = 6)
  return bool8988;
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if8979 = undefined;
  } else {
  }
// compiled if node returning if8979 (depth = 4)
// Begin line 2170
  setline(2170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8990 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile string node (depth = 6)
  if (strlit8991 == NULL) {
    strlit8991 = alloc_String("public");
    gc_root(strlit8991);
  }
// compiled string node returning strlit8991 (depth = 6)
  gc_frame_newslot(strlit8991);
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8992 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8993 = gc_frame_new();
// call case 3: self.outer request
  Object call8994 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8993);
// compiled call node returning call8994 (depth = 9)
// compiled member node returning call8994 (depth = 8)
  partcv[0] = 0;
  Object call8995 = callmethodflags(call8994, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8992);
// compiled call node returning call8995 (depth = 7)
// compiled member node returning call8995 (depth = 6)
  params[0] = self;
  params[1] = strlit8991;
  partcv[0] = 2;
  Object call8996 = callmethodflags(call8995, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8990);
// compiled call node returning call8996 (depth = 5)
  Object if8989 = done;
  if (istrue(call8996)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool8997 = alloc_Boolean(1);
// compiled identifier node returning bool8997 (depth = 6)
  return bool8997;
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if8989 = undefined;
  } else {
  }
// compiled if node returning if8989 (depth = 4)
// Begin line 2171
  setline(2171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8999 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile string node (depth = 6)
  if (strlit9000 == NULL) {
    strlit9000 = alloc_String("readable");
    gc_root(strlit9000);
  }
// compiled string node returning strlit9000 (depth = 6)
  gc_frame_newslot(strlit9000);
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9001 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9002 = gc_frame_new();
// call case 3: self.outer request
  Object call9003 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9002);
// compiled call node returning call9003 (depth = 9)
// compiled member node returning call9003 (depth = 8)
  partcv[0] = 0;
  Object call9004 = callmethodflags(call9003, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9001);
// compiled call node returning call9004 (depth = 7)
// compiled member node returning call9004 (depth = 6)
  params[0] = self;
  params[1] = strlit9000;
  partcv[0] = 2;
  Object call9005 = callmethodflags(call9004, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8999);
// compiled call node returning call9005 (depth = 5)
  Object if8998 = done;
  if (istrue(call9005)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool9006 = alloc_Boolean(1);
// compiled identifier node returning bool9006 (depth = 6)
  return bool9006;
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if8998 = undefined;
  } else {
  }
// compiled if node returning if8998 (depth = 4)
// Begin line 2172
  setline(2172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool9007 = alloc_Boolean(0);
// compiled identifier node returning bool9007 (depth = 4)
  gc_frame_end(frame);
  return bool9007;
}
Object meth_ast_usesAsType9008(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "usesAsType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method usesAsType");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for usesAsType (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aNode = &(stackframe->slots[0]);
  *var_aNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for usesAsType");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2180
  setline(2180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9010 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9011 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9010);
// compiled call node returning call9011 (depth = 6)
// compiled member node returning call9011 (depth = 5)
  int op_slot_right_9009 = gc_frame_newslot(call9011);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_aNode (depth = 5)
  int op_slot_left_9009 = gc_frame_newslot(*var_aNode);
  params[0] = call9011;
  partcv[0] = 1;
  Object opresult9013 = callmethod(*var_aNode, "==", 1, partcv, params);
// compiled op node returning opresult9013 (depth = 4)
  gc_frame_end(frame);
  return opresult9013;
}
Object meth_ast__apply9039(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ann = &(stackframe->slots[0]);
  *var_ann = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2190
  setline(2190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe9040 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_visitor (depth = 8)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_newChain (depth = 8)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ann (depth = 8)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9041 = callmethod(*var_ann, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe9040);
// compiled call node returning call9041 (depth = 7)
  gc_frame_end(frame);
  return call9041;
}
Object meth_ast_accept_40__41_from9014(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 2183
  setline(2183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9016 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9017 = callmethod(*var_visitor, "visitVarDec()up",
    2, partcv, params);
  gc_frame_end(callframe9016);
// compiled call node returning call9017 (depth = 5)
  Object if9015 = done;
  if (istrue(call9017)) {
// Begin line 2184
  setline(2184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9018 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_as (depth = 7)
  params[0] = self;
  partcv[0] = 1;
  Object call9019 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe9018);
// compiled call node returning call9019 (depth = 6)
  *var_newChain = call9019;
  if (call9019 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2185
  setline(2185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9020 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9021 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9022 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9021);
// compiled call node returning call9022 (depth = 7)
// compiled member node returning call9022 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9023 = callmethod(call9022, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe9020);
// compiled call node returning call9023 (depth = 5)
// Begin line 2186
  setline(2186);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool9026 = alloc_Boolean(0);
// compiled identifier node returning bool9026 (depth = 7)
  int op_slot_right_9025 = gc_frame_newslot(bool9026);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9028 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9029 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9028);
// compiled call node returning call9029 (depth = 8)
// compiled member node returning call9029 (depth = 7)
  int op_slot_left_9025 = gc_frame_newslot(call9029);
  params[0] = bool9026;
  partcv[0] = 1;
  Object opresult9030 = callmethod(call9029, "!=", 1, partcv, params);
// compiled op node returning opresult9030 (depth = 6)
  Object if9024 = done;
  if (istrue(opresult9030)) {
// Begin line 2187
  setline(2187);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9031 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9032 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9033 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9032);
// compiled call node returning call9033 (depth = 8)
// compiled member node returning call9033 (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9034 = callmethod(call9033, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe9031);
// compiled call node returning call9034 (depth = 6)
    gc_frame_newslot(call9034);
    if9024 = call9034;
  } else {
  }
// compiled if node returning if9024 (depth = 5)
// Begin line 2189
  setline(2189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9035 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9036 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9037 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9036);
// compiled call node returning call9037 (depth = 7)
// compiled member node returning call9037 (depth = 6)
  gc_frame_newslot(call9037);
// starting to compile block node (depth = 6)
  Object block9038 = alloc_Block(NULL, NULL, "ast", 2189);
  gc_frame_newslot(block9038);
// method _apply
  block_savedest(block9038);
  Object closure9039 = createclosure(3, "_apply");
  setclosureframe(closure9039, stackframe);
  addtoclosure(closure9039, var_visitor);
  addtoclosure(closure9039, var_newChain);
  addtoclosure(closure9039, selfslot);
  struct UserObject *uo9039 = (struct UserObject*)block9038;
  uo9039->data[0] = (Object)closure9039;
  Method *meth_meth_ast__apply9039 = addmethod2pos(block9038, "_apply", &meth_ast__apply9039, 0);
  int argcv_meth_ast__apply9039[] = {1};
  meth_meth_ast__apply9039->type = alloc_MethodType(1, argcv_meth_ast__apply9039);
  meth_meth_ast__apply9039->definitionModule = modulename;
  meth_meth_ast__apply9039->definitionLine = 2189;
// compiled block node returning block9038 (depth = 6)
  gc_frame_newslot(block9038);
// call case 5: prelude request
  params[0] = call9037;
  params[1] = block9038;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9043 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9035);
// compiled call node returning call9043 (depth = 5)
// Begin line 2192
  setline(2192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool9046 = alloc_Boolean(0);
// compiled identifier node returning bool9046 (depth = 7)
  int op_slot_right_9045 = gc_frame_newslot(bool9046);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9048 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9049 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9048);
// compiled call node returning call9049 (depth = 8)
// compiled member node returning call9049 (depth = 7)
  int op_slot_left_9045 = gc_frame_newslot(call9049);
  params[0] = bool9046;
  partcv[0] = 1;
  Object opresult9050 = callmethod(call9049, "!=", 1, partcv, params);
// compiled op node returning opresult9050 (depth = 6)
  Object if9044 = done;
  if (istrue(opresult9050)) {
// Begin line 2193
  setline(2193);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9051 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9052 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9053 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9052);
// compiled call node returning call9053 (depth = 8)
// compiled member node returning call9053 (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9054 = callmethod(call9053, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe9051);
// compiled call node returning call9054 (depth = 6)
    gc_frame_newslot(call9054);
    if9044 = call9054;
  } else {
  }
// compiled if node returning if9044 (depth = 5)
    gc_frame_newslot(if9044);
    if9015 = if9044;
  } else {
  }
// compiled if node returning if9015 (depth = 4)
  gc_frame_end(frame);
  return if9015;
}
Object meth_ast_map_40__41_ancestors9055(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2198
  setline(2198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9056 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9057 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9056);
// compiled call node returning call9057 (depth = 6)
// compiled member node returning call9057 (depth = 5)
  *var_n = call9057;
  if (call9057 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2199
  setline(2199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9058 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call9059 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe9058);
// compiled call node returning call9059 (depth = 5)
  *var_newChain = call9059;
  if (call9059 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2200
  setline(2200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2198
  setline(2198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9060 = gc_frame_new();
// Begin line 2200
  setline(2200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9061 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9062 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9063 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9062);
// compiled call node returning call9063 (depth = 8)
// compiled member node returning call9063 (depth = 7)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9064 = callmethod(call9063, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe9061);
// compiled call node returning call9064 (depth = 6)
  gc_frame_newslot(call9064);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call9064;
  partcv[0] = 1;
  Object call9065 = callmethod(*var_n, "name:=",
    1, partcv, params);
  gc_frame_end(callframe9060);
// compiled call node returning call9065 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 2201
  setline(2201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2200
  setline(2200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9066 = gc_frame_new();
// Begin line 2201
  setline(2201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9067 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9068 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9069 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9068);
// compiled call node returning call9069 (depth = 8)
// compiled member node returning call9069 (depth = 7)
  gc_frame_newslot(call9069);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9070 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9071 = gc_frame_new();
// call case 3: self.outer request
  Object call9072 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9071);
// compiled call node returning call9072 (depth = 10)
// compiled member node returning call9072 (depth = 9)
  partcv[0] = 0;
  Object call9073 = callmethodflags(call9072, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9070);
// compiled call node returning call9073 (depth = 8)
// compiled member node returning call9073 (depth = 7)
  params[0] = call9069;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call9074 = callmethodflags(call9073, "maybeMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9067);
// compiled call node returning call9074 (depth = 6)
  gc_frame_newslot(call9074);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call9074;
  partcv[0] = 1;
  Object call9075 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe9066);
// compiled call node returning call9075 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 2202
  setline(2202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2201
  setline(2201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9076 = gc_frame_new();
// Begin line 2202
  setline(2202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9077 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9078 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9079 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9078);
// compiled call node returning call9079 (depth = 8)
// compiled member node returning call9079 (depth = 7)
  gc_frame_newslot(call9079);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9080 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9081 = gc_frame_new();
// call case 3: self.outer request
  Object call9082 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9081);
// compiled call node returning call9082 (depth = 10)
// compiled member node returning call9082 (depth = 9)
  partcv[0] = 0;
  Object call9083 = callmethodflags(call9082, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9080);
// compiled call node returning call9083 (depth = 8)
// compiled member node returning call9083 (depth = 7)
  params[0] = call9079;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call9084 = callmethodflags(call9083, "maybeMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9077);
// compiled call node returning call9084 (depth = 6)
  gc_frame_newslot(call9084);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call9084;
  partcv[0] = 1;
  Object call9085 = callmethod(*var_n, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe9076);
// compiled call node returning call9085 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 2203
  setline(2203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2202
  setline(2202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9086 = gc_frame_new();
// Begin line 2203
  setline(2203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9087 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9088 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9089 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9088);
// compiled call node returning call9089 (depth = 8)
// compiled member node returning call9089 (depth = 7)
  gc_frame_newslot(call9089);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9090 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9091 = gc_frame_new();
// call case 3: self.outer request
  Object call9092 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9091);
// compiled call node returning call9092 (depth = 10)
// compiled member node returning call9092 (depth = 9)
  partcv[0] = 0;
  Object call9093 = callmethodflags(call9092, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9090);
// compiled call node returning call9093 (depth = 8)
// compiled member node returning call9093 (depth = 7)
  params[0] = call9089;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call9094 = callmethodflags(call9093, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9087);
// compiled call node returning call9094 (depth = 6)
  gc_frame_newslot(call9094);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call9094;
  partcv[0] = 1;
  Object call9095 = callmethod(*var_n, "annotations:=",
    1, partcv, params);
  gc_frame_end(callframe9086);
// compiled call node returning call9095 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 2204
  setline(2204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9096 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call9097 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe9096);
// compiled call node returning call9097 (depth = 4)
  gc_frame_end(frame);
  return call9097;
}
Object meth_ast__apply9106(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2209
  setline(2209);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9108 == NULL) {
    strlit9108 = alloc_String("  ");
    gc_root(strlit9108);
  }
// compiled string node returning strlit9108 (depth = 8)
  int op_slot_right_9107 = gc_frame_newslot(strlit9108);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_9107 = gc_frame_newslot(*var_spc);
  params[0] = strlit9108;
  partcv[0] = 1;
  Object opresult9110 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult9110 (depth = 7)
  *var_spc = opresult9110;
  if (opresult9110 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty9098(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2207
  setline(2207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9099 == NULL) {
    strlit9099 = alloc_String("");
    gc_root(strlit9099);
  }
// compiled string node returning strlit9099 (depth = 5)
  *var_spc = strlit9099;
  if (strlit9099 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2208
  setline(2208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9100 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_right_9101 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 6)
  Object num9103 = alloc_Float64(0);
// compiled num node returning num9103 (depth = 6)
  int op_slot_left_9101 = gc_frame_newslot(num9103);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult9104 = callmethod(num9103, "..", 1, partcv, params);
// compiled op node returning opresult9104 (depth = 5)
  gc_frame_newslot(opresult9104);
// starting to compile block node (depth = 5)
  Object block9105 = alloc_Block(NULL, NULL, "ast", 2208);
  gc_frame_newslot(block9105);
// method _apply
  block_savedest(block9105);
  Object closure9106 = createclosure(2, "_apply");
  setclosureframe(closure9106, stackframe);
  addtoclosure(closure9106, var_spc);
  addtoclosure(closure9106, selfslot);
  struct UserObject *uo9106 = (struct UserObject*)block9105;
  uo9106->data[0] = (Object)closure9106;
  Method *meth_meth_ast__apply9106 = addmethod2pos(block9105, "_apply", &meth_ast__apply9106, 0);
  int argcv_meth_ast__apply9106[] = {1};
  meth_meth_ast__apply9106->type = alloc_MethodType(1, argcv_meth_ast__apply9106);
  meth_meth_ast__apply9106->definitionModule = modulename;
  meth_meth_ast__apply9106->definitionLine = 2203;
// compiled block node returning block9105 (depth = 5)
  gc_frame_newslot(block9105);
// call case 5: prelude request
  params[0] = opresult9104;
  params[1] = block9105;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9113 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9100);
// compiled call node returning call9113 (depth = 4)
// Begin line 2211
  setline(2211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9115 == NULL) {
    strlit9115 = alloc_String("""\x0a""");
    gc_root(strlit9115);
  }
// compiled string node returning strlit9115 (depth = 6)
  int op_slot_right_9114 = gc_frame_newslot(strlit9115);
// starting to compile call node (depth = 6)
  int callframe9117 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call9118 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe9117);
// compiled call node returning call9118 (depth = 6)
  int op_slot_left_9114 = gc_frame_newslot(call9118);
  params[0] = strlit9115;
  partcv[0] = 1;
  Object opresult9119 = callmethod(call9118, "++", 1, partcv, params);
// compiled op node returning opresult9119 (depth = 5)
  *var_s = opresult9119;
  if (opresult9119 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2212
  setline(2212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9121 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num9123 = alloc_Float64(1);
// compiled num node returning num9123 (depth = 8)
  int op_slot_right_9122 = gc_frame_newslot(num9123);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_9122 = gc_frame_newslot(*var_depth);
  params[0] = num9123;
  partcv[0] = 1;
  Object sum9125 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum9125 (depth = 7)
  gc_frame_newslot(sum9125);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9126 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9127 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9126);
// compiled call node returning call9127 (depth = 8)
// compiled member node returning call9127 (depth = 7)
  params[0] = sum9125;
  partcv[0] = 1;
  Object call9128 = callmethod(call9127, "pretty",
    1, partcv, params);
  gc_frame_end(callframe9121);
// compiled call node returning call9128 (depth = 6)
  int op_slot_right_9120 = gc_frame_newslot(call9128);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_9130 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_9130 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9132 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult9132 (depth = 6)
  int op_slot_left_9120 = gc_frame_newslot(opresult9132);
  params[0] = call9128;
  partcv[0] = 1;
  Object opresult9133 = callmethod(opresult9132, "++", 1, partcv, params);
// compiled op node returning opresult9133 (depth = 5)
  *var_s = opresult9133;
  if (opresult9133 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2213
  setline(2213);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool9137 = alloc_Boolean(0);
// compiled identifier node returning bool9137 (depth = 6)
  int op_slot_right_9136 = gc_frame_newslot(bool9137);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9139 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9140 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9139);
// compiled call node returning call9140 (depth = 7)
// compiled member node returning call9140 (depth = 6)
  int op_slot_left_9136 = gc_frame_newslot(call9140);
  params[0] = bool9137;
  partcv[0] = 1;
  Object opresult9141 = callmethod(call9140, "!=", 1, partcv, params);
// compiled op node returning opresult9141 (depth = 5)
  Object if9135 = done;
  if (istrue(opresult9141)) {
// Begin line 2214
  setline(2214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9143 == NULL) {
    strlit9143 = alloc_String("Type: ");
    gc_root(strlit9143);
  }
// compiled string node returning strlit9143 (depth = 7)
  int op_slot_right_9142 = gc_frame_newslot(strlit9143);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_9145 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9148 == NULL) {
    strlit9148 = alloc_String("""\x0a""");
    gc_root(strlit9148);
  }
// compiled string node returning strlit9148 (depth = 9)
  int op_slot_right_9147 = gc_frame_newslot(strlit9148);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_9147 = gc_frame_newslot(*var_s);
  params[0] = strlit9148;
  partcv[0] = 1;
  Object opresult9150 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult9150 (depth = 8)
  int op_slot_left_9145 = gc_frame_newslot(opresult9150);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9151 = callmethod(opresult9150, "++", 1, partcv, params);
// compiled op node returning opresult9151 (depth = 7)
  int op_slot_left_9142 = gc_frame_newslot(opresult9151);
  params[0] = strlit9143;
  partcv[0] = 1;
  Object opresult9152 = callmethod(opresult9151, "++", 1, partcv, params);
// compiled op node returning opresult9152 (depth = 6)
  *var_s = opresult9152;
  if (opresult9152 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 2215
  setline(2215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9155 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num9157 = alloc_Float64(2);
// compiled num node returning num9157 (depth = 9)
  int op_slot_right_9156 = gc_frame_newslot(num9157);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_9156 = gc_frame_newslot(*var_depth);
  params[0] = num9157;
  partcv[0] = 1;
  Object sum9159 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum9159 (depth = 8)
  gc_frame_newslot(sum9159);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9160 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9161 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9160);
// compiled call node returning call9161 (depth = 9)
// compiled member node returning call9161 (depth = 8)
  params[0] = sum9159;
  partcv[0] = 1;
  Object call9162 = callmethod(call9161, "pretty",
    1, partcv, params);
  gc_frame_end(callframe9155);
// compiled call node returning call9162 (depth = 7)
  int op_slot_right_9154 = gc_frame_newslot(call9162);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_9154 = gc_frame_newslot(*var_s);
  params[0] = call9162;
  partcv[0] = 1;
  Object opresult9164 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult9164 (depth = 6)
  *var_s = opresult9164;
  if (opresult9164 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if9135 = done;
  } else {
  }
// compiled if node returning if9135 (depth = 4)
// Begin line 2217
  setline(2217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9168 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9169 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9168);
// compiled call node returning call9169 (depth = 7)
// compiled member node returning call9169 (depth = 6)
  int op_slot_right_9167 = gc_frame_newslot(call9169);
// starting to compile identifier node (depth = 6)
  Object bool9171 = alloc_Boolean(0);
// compiled identifier node returning bool9171 (depth = 6)
  int op_slot_left_9167 = gc_frame_newslot(bool9171);
  params[0] = call9169;
  partcv[0] = 1;
  Object opresult9172 = callmethod(bool9171, "!=", 1, partcv, params);
// compiled op node returning opresult9172 (depth = 5)
  Object if9166 = done;
  if (istrue(opresult9172)) {
// Begin line 2218
  setline(2218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9174 == NULL) {
    strlit9174 = alloc_String("Value: ");
    gc_root(strlit9174);
  }
// compiled string node returning strlit9174 (depth = 7)
  int op_slot_right_9173 = gc_frame_newslot(strlit9174);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_9176 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9179 == NULL) {
    strlit9179 = alloc_String("""\x0a""");
    gc_root(strlit9179);
  }
// compiled string node returning strlit9179 (depth = 9)
  int op_slot_right_9178 = gc_frame_newslot(strlit9179);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_9178 = gc_frame_newslot(*var_s);
  params[0] = strlit9179;
  partcv[0] = 1;
  Object opresult9181 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult9181 (depth = 8)
  int op_slot_left_9176 = gc_frame_newslot(opresult9181);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9182 = callmethod(opresult9181, "++", 1, partcv, params);
// compiled op node returning opresult9182 (depth = 7)
  int op_slot_left_9173 = gc_frame_newslot(opresult9182);
  params[0] = strlit9174;
  partcv[0] = 1;
  Object opresult9183 = callmethod(opresult9182, "++", 1, partcv, params);
// compiled op node returning opresult9183 (depth = 6)
  *var_s = opresult9183;
  if (opresult9183 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 2219
  setline(2219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9186 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num9188 = alloc_Float64(2);
// compiled num node returning num9188 (depth = 9)
  int op_slot_right_9187 = gc_frame_newslot(num9188);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_9187 = gc_frame_newslot(*var_depth);
  params[0] = num9188;
  partcv[0] = 1;
  Object sum9190 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum9190 (depth = 8)
  gc_frame_newslot(sum9190);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9191 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9192 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9191);
// compiled call node returning call9192 (depth = 9)
// compiled member node returning call9192 (depth = 8)
  params[0] = sum9190;
  partcv[0] = 1;
  Object call9193 = callmethod(call9192, "pretty",
    1, partcv, params);
  gc_frame_end(callframe9186);
// compiled call node returning call9193 (depth = 7)
  int op_slot_right_9185 = gc_frame_newslot(call9193);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_9185 = gc_frame_newslot(*var_s);
  params[0] = call9193;
  partcv[0] = 1;
  Object opresult9195 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult9195 (depth = 6)
  *var_s = opresult9195;
  if (opresult9195 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if9166 = done;
  } else {
  }
// compiled if node returning if9166 (depth = 4)
// Begin line 2221
  setline(2221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9199 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9200 = callmethodflags(self, "comments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9199);
// compiled call node returning call9200 (depth = 7)
// compiled member node returning call9200 (depth = 6)
  int op_slot_right_9198 = gc_frame_newslot(call9200);
// starting to compile identifier node (depth = 6)
  Object bool9202 = alloc_Boolean(0);
// compiled identifier node returning bool9202 (depth = 6)
  int op_slot_left_9198 = gc_frame_newslot(bool9202);
  params[0] = call9200;
  partcv[0] = 1;
  Object opresult9203 = callmethod(bool9202, "!=", 1, partcv, params);
// compiled op node returning opresult9203 (depth = 5)
  Object if9197 = done;
  if (istrue(opresult9203)) {
// Begin line 2222
  setline(2222);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9205 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num9207 = alloc_Float64(2);
// compiled num node returning num9207 (depth = 9)
  int op_slot_right_9206 = gc_frame_newslot(num9207);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_9206 = gc_frame_newslot(*var_depth);
  params[0] = num9207;
  partcv[0] = 1;
  Object sum9209 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum9209 (depth = 8)
  gc_frame_newslot(sum9209);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9210 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9211 = callmethodflags(self, "comments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9210);
// compiled call node returning call9211 (depth = 9)
// compiled member node returning call9211 (depth = 8)
  params[0] = sum9209;
  partcv[0] = 1;
  Object call9212 = callmethod(call9211, "pretty",
    1, partcv, params);
  gc_frame_end(callframe9205);
// compiled call node returning call9212 (depth = 7)
  int op_slot_right_9204 = gc_frame_newslot(call9212);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_9204 = gc_frame_newslot(*var_s);
  params[0] = call9212;
  partcv[0] = 1;
  Object opresult9214 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult9214 (depth = 6)
  *var_s = opresult9214;
  if (opresult9214 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if9197 = done;
  } else {
  }
// compiled if node returning if9197 (depth = 4)
// Begin line 2224
  setline(2224);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply9220(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 6)
// Begin line 2229
  setline(2229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9222 == NULL) {
    strlit9222 = alloc_String("    ");
    gc_root(strlit9222);
  }
// compiled string node returning strlit9222 (depth = 8)
  int op_slot_right_9221 = gc_frame_newslot(strlit9222);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_9221 = gc_frame_newslot(*var_spc);
  params[0] = strlit9222;
  partcv[0] = 1;
  Object opresult9224 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult9224 (depth = 7)
  *var_spc = opresult9224;
  if (opresult9224 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply9244(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2233
  setline(2233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9246 == NULL) {
    strlit9246 = alloc_String("Unknown");
    gc_root(strlit9246);
  }
// compiled string node returning strlit9246 (depth = 8)
  int op_slot_right_9245 = gc_frame_newslot(strlit9246);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9248 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9249 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9250 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9249);
// compiled call node returning call9250 (depth = 11)
// compiled member node returning call9250 (depth = 10)
  partcv[0] = 0;
  Object call9251 = callmethod(call9250, "value",
    1, partcv, params);
  gc_frame_end(callframe9248);
// compiled call node returning call9251 (depth = 9)
// compiled member node returning call9251 (depth = 8)
  int op_slot_left_9245 = gc_frame_newslot(call9251);
  params[0] = strlit9246;
  partcv[0] = 1;
  Object opresult9252 = callmethod(call9251, "!=", 1, partcv, params);
// compiled op node returning opresult9252 (depth = 7)
  gc_frame_end(frame);
  return opresult9252;
}
Object meth_ast__apply9292(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2239
  setline(2239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9294 = gc_frame_new();
// starting to compile num node (depth = 11)
  Object num9295 = alloc_Float64(0);
// compiled num node returning num9295 (depth = 11)
  gc_frame_newslot(num9295);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_b (depth = 11)
  params[0] = num9295;
  partcv[0] = 1;
  Object call9296 = callmethod(*var_b, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe9294);
// compiled call node returning call9296 (depth = 10)
  int op_slot_right_9293 = gc_frame_newslot(call9296);
// starting to compile if node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit9300 == NULL) {
    strlit9300 = alloc_String("");
    gc_root(strlit9300);
  }
// compiled string node returning strlit9300 (depth = 12)
  int op_slot_right_9299 = gc_frame_newslot(strlit9300);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_a (depth = 12)
  int op_slot_left_9299 = gc_frame_newslot(*var_a);
  params[0] = strlit9300;
  partcv[0] = 1;
  Object opresult9302 = callmethod(*var_a, "!=", 1, partcv, params);
// compiled op node returning opresult9302 (depth = 11)
  Object if9298 = done;
struct StackFrameObject *iftmpstackframe9298 = stackframe;
  if (istrue(opresult9302)) {
stackframe = alloc_StackFrame(0, iftmpstackframe9298);
gc_frame_newslot((Object)stackframe);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit9304 == NULL) {
    strlit9304 = alloc_String(", ");
    gc_root(strlit9304);
  }
// compiled string node returning strlit9304 (depth = 12)
  int op_slot_right_9303 = gc_frame_newslot(strlit9304);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_a (depth = 12)
  int op_slot_left_9303 = gc_frame_newslot(*var_a);
  params[0] = strlit9304;
  partcv[0] = 1;
  Object opresult9306 = callmethod(*var_a, "++", 1, partcv, params);
// compiled op node returning opresult9306 (depth = 11)
    gc_frame_newslot(opresult9306);
    if9298 = opresult9306;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe9298);
  gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 11)
  if (strlit9307 == NULL) {
    strlit9307 = alloc_String("");
    gc_root(strlit9307);
  }
// compiled string node returning strlit9307 (depth = 11)
    gc_frame_newslot(strlit9307);
    if9298 = strlit9307;
  }
stackframe = iftmpstackframe9298;
// compiled if node returning if9298 (depth = 10)
  int op_slot_left_9293 = gc_frame_newslot(if9298);
  params[0] = call9296;
  partcv[0] = 1;
  Object opresult9308 = callmethod(if9298, "++", 1, partcv, params);
// compiled op node returning opresult9308 (depth = 9)
  gc_frame_end(frame);
  return opresult9308;
}
Object meth_ast_toGrace9216(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2227
  setline(2227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9217 == NULL) {
    strlit9217 = alloc_String("");
    gc_root(strlit9217);
  }
// compiled string node returning strlit9217 (depth = 5)
  *var_spc = strlit9217;
  if (strlit9217 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2228
  setline(2228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9218 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  gc_frame_newslot(*var_depth);
// starting to compile block node (depth = 5)
  Object block9219 = alloc_Block(NULL, NULL, "ast", 2228);
  gc_frame_newslot(block9219);
// method _apply
  block_savedest(block9219);
  Object closure9220 = createclosure(2, "_apply");
  setclosureframe(closure9220, stackframe);
  addtoclosure(closure9220, var_spc);
  addtoclosure(closure9220, selfslot);
  struct UserObject *uo9220 = (struct UserObject*)block9219;
  uo9220->data[0] = (Object)closure9220;
  Method *meth_meth_ast__apply9220 = addmethod2pos(block9219, "_apply", &meth_ast__apply9220, 0);
  int argcv_meth_ast__apply9220[] = {0};
  meth_meth_ast__apply9220->type = alloc_MethodType(1, argcv_meth_ast__apply9220);
  meth_meth_ast__apply9220->definitionModule = modulename;
  meth_meth_ast__apply9220->definitionLine = 2222;
// compiled block node returning block9219 (depth = 5)
  gc_frame_newslot(block9219);
// call case 5: prelude request
  params[0] = *var_depth;
  params[1] = block9219;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9227 = callmethodflags(prelude, "repeat()times", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9218);
// compiled call node returning call9227 (depth = 4)
// Begin line 2231
  setline(2231);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9229 == NULL) {
    strlit9229 = alloc_String("");
    gc_root(strlit9229);
  }
// compiled string node returning strlit9229 (depth = 6)
  int op_slot_right_9228 = gc_frame_newslot(strlit9229);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9232 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num9233 = alloc_Float64(0);
// compiled num node returning num9233 (depth = 8)
  gc_frame_newslot(num9233);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9234 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9235 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9234);
// compiled call node returning call9235 (depth = 9)
// compiled member node returning call9235 (depth = 8)
  params[0] = num9233;
  partcv[0] = 1;
  Object call9236 = callmethod(call9235, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe9232);
// compiled call node returning call9236 (depth = 7)
  int op_slot_right_9231 = gc_frame_newslot(call9236);
// starting to compile string node (depth = 7)
  if (strlit9238 == NULL) {
    strlit9238 = alloc_String("var ");
    gc_root(strlit9238);
  }
// compiled string node returning strlit9238 (depth = 7)
  int op_slot_left_9231 = gc_frame_newslot(strlit9238);
  params[0] = call9236;
  partcv[0] = 1;
  Object opresult9239 = callmethod(strlit9238, "++", 1, partcv, params);
// compiled op node returning opresult9239 (depth = 6)
  int op_slot_left_9228 = gc_frame_newslot(opresult9239);
  params[0] = strlit9229;
  partcv[0] = 1;
  Object opresult9240 = callmethod(opresult9239, "++", 1, partcv, params);
// compiled op node returning opresult9240 (depth = 5)
  *var_s = opresult9240;
  if (opresult9240 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2232
  setline(2232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9242 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block9243 = alloc_Block(NULL, NULL, "ast", 2232);
  gc_frame_newslot(block9243);
// method _apply
  block_savedest(block9243);
  Object closure9244 = createclosure(1, "_apply");
  setclosureframe(closure9244, stackframe);
  addtoclosure(closure9244, selfslot);
  struct UserObject *uo9244 = (struct UserObject*)block9243;
  uo9244->data[0] = (Object)closure9244;
  Method *meth_meth_ast__apply9244 = addmethod2pos(block9243, "_apply", &meth_ast__apply9244, 0);
  int argcv_meth_ast__apply9244[] = {0};
  meth_meth_ast__apply9244->type = alloc_MethodType(1, argcv_meth_ast__apply9244);
  meth_meth_ast__apply9244->definitionModule = modulename;
  meth_meth_ast__apply9244->definitionLine = 2231;
// compiled block node returning block9243 (depth = 6)
  gc_frame_newslot(block9243);
// call case 6: other member request
// Begin line 2232
  setline(2232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool9255 = alloc_Boolean(0);
// compiled identifier node returning bool9255 (depth = 7)
  int op_slot_right_9254 = gc_frame_newslot(bool9255);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9257 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9258 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9257);
// compiled call node returning call9258 (depth = 8)
// compiled member node returning call9258 (depth = 7)
  int op_slot_left_9254 = gc_frame_newslot(call9258);
  params[0] = bool9255;
  partcv[0] = 1;
  Object opresult9259 = callmethod(call9258, "!=", 1, partcv, params);
// compiled op node returning opresult9259 (depth = 6)
  params[0] = block9243;
  partcv[0] = 1;
  Object call9260 = callmethod(opresult9259, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe9242);
// compiled call node returning call9260 (depth = 5)
  Object if9241 = done;
  if (istrue(call9260)) {
// Begin line 2234
  setline(2234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9262 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num9263 = alloc_Float64(0);
// compiled num node returning num9263 (depth = 8)
  gc_frame_newslot(num9263);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9264 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9265 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9264);
// compiled call node returning call9265 (depth = 9)
// compiled member node returning call9265 (depth = 8)
  params[0] = num9263;
  partcv[0] = 1;
  Object call9266 = callmethod(call9265, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe9262);
// compiled call node returning call9266 (depth = 7)
  int op_slot_right_9261 = gc_frame_newslot(call9266);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9269 == NULL) {
    strlit9269 = alloc_String(" : ");
    gc_root(strlit9269);
  }
// compiled string node returning strlit9269 (depth = 8)
  int op_slot_right_9268 = gc_frame_newslot(strlit9269);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_9268 = gc_frame_newslot(*var_s);
  params[0] = strlit9269;
  partcv[0] = 1;
  Object opresult9271 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult9271 (depth = 7)
  int op_slot_left_9261 = gc_frame_newslot(opresult9271);
  params[0] = call9266;
  partcv[0] = 1;
  Object opresult9272 = callmethod(opresult9271, "++", 1, partcv, params);
// compiled op node returning opresult9272 (depth = 6)
  *var_s = opresult9272;
  if (opresult9272 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if9241 = done;
  } else {
  }
// compiled if node returning if9241 (depth = 4)
// Begin line 2236
  setline(2236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num9276 = alloc_Float64(0);
// compiled num node returning num9276 (depth = 6)
  int op_slot_right_9275 = gc_frame_newslot(num9276);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9278 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9279 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9280 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9279);
// compiled call node returning call9280 (depth = 9)
// compiled member node returning call9280 (depth = 8)
  partcv[0] = 0;
  Object call9281 = callmethod(call9280, "size",
    1, partcv, params);
  gc_frame_end(callframe9278);
// compiled call node returning call9281 (depth = 7)
// compiled member node returning call9281 (depth = 6)
  int op_slot_left_9275 = gc_frame_newslot(call9281);
  params[0] = num9276;
  partcv[0] = 1;
  Object opresult9282 = callmethod(call9281, ">", 1, partcv, params);
// compiled op node returning opresult9282 (depth = 5)
  Object if9274 = done;
  if (istrue(opresult9282)) {
// Begin line 2237
  setline(2237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9284 == NULL) {
    strlit9284 = alloc_String(" is ");
    gc_root(strlit9284);
  }
// compiled string node returning strlit9284 (depth = 7)
  int op_slot_right_9283 = gc_frame_newslot(strlit9284);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_9283 = gc_frame_newslot(*var_s);
  params[0] = strlit9284;
  partcv[0] = 1;
  Object opresult9286 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult9286 (depth = 6)
  *var_s = opresult9286;
  if (opresult9286 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 2238
  setline(2238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9289 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit9290 == NULL) {
    strlit9290 = alloc_String("");
    gc_root(strlit9290);
  }
// compiled string node returning strlit9290 (depth = 8)
  gc_frame_newslot(strlit9290);
// starting to compile block node (depth = 8)
  Object block9291 = alloc_Block(NULL, NULL, "ast", 2238);
  gc_frame_newslot(block9291);
// method _apply
  block_savedest(block9291);
  Object closure9292 = createclosure(1, "_apply");
  setclosureframe(closure9292, stackframe);
  addtoclosure(closure9292, selfslot);
  struct UserObject *uo9292 = (struct UserObject*)block9291;
  uo9292->data[0] = (Object)closure9292;
  Method *meth_meth_ast__apply9292 = addmethod2pos(block9291, "_apply", &meth_ast__apply9292, 0);
  int argcv_meth_ast__apply9292[] = {2};
  meth_meth_ast__apply9292->type = alloc_MethodType(1, argcv_meth_ast__apply9292);
  meth_meth_ast__apply9292->definitionModule = modulename;
  meth_meth_ast__apply9292->definitionLine = 2236;
// compiled block node returning block9291 (depth = 8)
  gc_frame_newslot(block9291);
// call case 6: other member request
// Begin line 2238
  setline(2238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9310 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9311 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9310);
// compiled call node returning call9311 (depth = 9)
// compiled member node returning call9311 (depth = 8)
  params[0] = strlit9290;
  params[1] = block9291;
  partcv[0] = 2;
  Object call9312 = callmethod(call9311, "reduce",
    1, partcv, params);
  gc_frame_end(callframe9289);
// compiled call node returning call9312 (depth = 7)
  int op_slot_right_9288 = gc_frame_newslot(call9312);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_9288 = gc_frame_newslot(*var_s);
  params[0] = call9312;
  partcv[0] = 1;
  Object opresult9314 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult9314 (depth = 6)
  *var_s = opresult9314;
  if (opresult9314 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if9274 = done;
  } else {
  }
// compiled if node returning if9274 (depth = 4)
// Begin line 2241
  setline(2241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool9318 = alloc_Boolean(0);
// compiled identifier node returning bool9318 (depth = 6)
  int op_slot_right_9317 = gc_frame_newslot(bool9318);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9320 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9321 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9320);
// compiled call node returning call9321 (depth = 7)
// compiled member node returning call9321 (depth = 6)
  int op_slot_left_9317 = gc_frame_newslot(call9321);
  params[0] = bool9318;
  partcv[0] = 1;
  Object opresult9322 = callmethod(call9321, "!=", 1, partcv, params);
// compiled op node returning opresult9322 (depth = 5)
  Object if9316 = done;
  if (istrue(opresult9322)) {
// Begin line 2242
  setline(2242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9324 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  gc_frame_newslot(*var_depth);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9325 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9326 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9325);
// compiled call node returning call9326 (depth = 9)
// compiled member node returning call9326 (depth = 8)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call9327 = callmethod(call9326, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe9324);
// compiled call node returning call9327 (depth = 7)
  int op_slot_right_9323 = gc_frame_newslot(call9327);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9330 == NULL) {
    strlit9330 = alloc_String(" := ");
    gc_root(strlit9330);
  }
// compiled string node returning strlit9330 (depth = 8)
  int op_slot_right_9329 = gc_frame_newslot(strlit9330);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_9329 = gc_frame_newslot(*var_s);
  params[0] = strlit9330;
  partcv[0] = 1;
  Object opresult9332 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult9332 (depth = 7)
  int op_slot_left_9323 = gc_frame_newslot(opresult9332);
  params[0] = call9327;
  partcv[0] = 1;
  Object opresult9333 = callmethod(opresult9332, "++", 1, partcv, params);
// compiled op node returning opresult9333 (depth = 6)
  *var_s = opresult9333;
  if (opresult9333 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if9316 = done;
  } else {
  }
// compiled if node returning if9316 (depth = 4)
// Begin line 2244
  setline(2244);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy9335(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_varDecNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2247
  setline(2247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9336 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe9337 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9338 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9339 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9338);
// compiled call node returning call9339 (depth = 7)
// compiled member node returning call9339 (depth = 6)
  gc_frame_newslot(call9339);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9340 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9341 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9340);
// compiled call node returning call9341 (depth = 7)
// compiled member node returning call9341 (depth = 6)
  gc_frame_newslot(call9341);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9342 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9343 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9342);
// compiled call node returning call9343 (depth = 7)
// compiled member node returning call9343 (depth = 6)
  gc_frame_newslot(call9343);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_varDecNode (depth = 6)
  params[0] = call9339;
  params[1] = call9341;
  params[2] = call9343;
  partcv[0] = 3;
  Object call9344 = callmethod(*var_varDecNode, "new",
    1, partcv, params);
  gc_frame_end(callframe9337);
// compiled call node returning call9344 (depth = 5)
  params[0] = self;
  partcv[0] = 1;
  Object call9345 = callmethod(call9344, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe9336);
// compiled call node returning call9345 (depth = 4)
  gc_frame_end(frame);
  return call9345;
}
Object meth_ast_new8912(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_varDecNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_val_39_ = &(stackframe->slots[1]);
  *var_val_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject8913 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8913 = alloc_userobj2(20,17, objclass8913);
  gc_frame_newslot(obj8913);
if (objclass8913 == NULL) {
  glfree(obj8913->class->name);
  obj8913->class->name = "varDecNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj8913, self, 0);
  addmethodreal(obj8913,"outer", &reader_ast_outer_8914);
  Object oldself8913 = self;
  struct StackFrameObject *oldstackframe8913 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8913);
  gc_frame_newslot((Object)stackframe);
  self = obj8913;
  Object *oldselfslot8913 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8913 = (*(struct UserObject *)self).data[0], lowerouter8913 = thisouter8913;
  if (inheritingObject8913) {
    struct UserObject *inho8913 = (struct UserObject *)inheritingObject8913;
    while (inho8913->super != GraceDefaultObject) inho8913 = (struct UserObject *)inho8913->super;
    inho8913->super = obj8913;
    self = inheritingObject8913;
    *selfslot = self;
    lowerouter8913 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8913;
  }
if (objclass8913 == NULL) {
  Method *reader8915 = addmethodrealflags(obj8913, "kind",&reader_ast_kind_8915, MFLAG_DEF);
  reader8915->definitionModule = modulename;
  reader8915->definitionLine = 2149;
}
adddatum2(obj8913, alloc_Undefined(), 1);
if (objclass8913 == NULL) {
  Method *reader8916 = addmethodrealflags(obj8913, "name",&reader_ast_name_8916, 0);
  Method *writer8916 = addmethodrealflags(obj8913, "name:=",&writer_ast_name_8916, 0);
  reader8916->definitionModule = modulename;
  writer8916->definitionModule = modulename;
  reader8916->definitionLine = 2150;
  writer8916->definitionLine = 2150;
}
obj8913->flags |= OFLAG_MUTABLE;
adddatum2(obj8913, alloc_Undefined(), 2);
if (objclass8913 == NULL) {
  Method *reader8917 = addmethodrealflags(obj8913, "value",&reader_ast_value_8917, 0);
  Method *writer8917 = addmethodrealflags(obj8913, "value:=",&writer_ast_value_8917, 0);
  reader8917->definitionModule = modulename;
  writer8917->definitionModule = modulename;
  reader8917->definitionLine = 2151;
  writer8917->definitionLine = 2151;
}
obj8913->flags |= OFLAG_MUTABLE;
adddatum2(obj8913, alloc_Undefined(), 3);
if (objclass8913 == NULL) {
  Method *reader8918 = addmethodrealflags(obj8913, "dtype",&reader_ast_dtype_8918, 0);
  Method *writer8918 = addmethodrealflags(obj8913, "dtype:=",&writer_ast_dtype_8918, 0);
  reader8918->definitionModule = modulename;
  writer8918->definitionModule = modulename;
  reader8918->definitionLine = 2152;
  writer8918->definitionLine = 2152;
}
obj8913->flags |= OFLAG_MUTABLE;
adddatum2(obj8913, alloc_Undefined(), 4);
if (objclass8913 == NULL) {
  Method *reader8919 = addmethodrealflags(obj8913, "nameString",&reader_ast_nameString_8919, MFLAG_DEF);
  reader8919->definitionModule = modulename;
  reader8919->definitionLine = 2153;
}
adddatum2(obj8913, alloc_Undefined(), 5);
if (objclass8913 == NULL) {
  Method *reader8920 = addmethodrealflags(obj8913, "annotations",&reader_ast_annotations_8920, 0);
  Method *writer8920 = addmethodrealflags(obj8913, "annotations:=",&writer_ast_annotations_8920, 0);
  reader8920->definitionModule = modulename;
  writer8920->definitionModule = modulename;
  reader8920->definitionLine = 2154;
  writer8920->definitionLine = 2154;
}
obj8913->flags |= OFLAG_MUTABLE;
adddatum2(obj8913, alloc_Undefined(), 6);
// method isPublic
  struct UserObject *uo8921 = (struct UserObject*)obj8913;
  uo8921->data[7] = emptyclosure;
  Method *meth_meth_ast_isPublic8921 = addmethod2pos(obj8913, "isPublic", &meth_ast_isPublic8921, 7);
  int argcv_meth_ast_isPublic8921[] = {0};
  meth_meth_ast_isPublic8921->type = alloc_MethodType(1, argcv_meth_ast_isPublic8921);
  meth_meth_ast_isPublic8921->definitionModule = modulename;
  meth_meth_ast_isPublic8921->definitionLine = 2156;
// method isWritable
  struct UserObject *uo8948 = (struct UserObject*)obj8913;
  uo8948->data[8] = emptyclosure;
  Method *meth_meth_ast_isWritable8948 = addmethod2pos(obj8913, "isWritable", &meth_ast_isWritable8948, 8);
  int argcv_meth_ast_isWritable8948[] = {0};
  meth_meth_ast_isWritable8948->type = alloc_MethodType(1, argcv_meth_ast_isWritable8948);
  meth_meth_ast_isWritable8948->definitionModule = modulename;
  meth_meth_ast_isWritable8948->definitionLine = 2162;
// method isReadable
  struct UserObject *uo8978 = (struct UserObject*)obj8913;
  uo8978->data[9] = emptyclosure;
  Method *meth_meth_ast_isReadable8978 = addmethod2pos(obj8913, "isReadable", &meth_ast_isReadable8978, 9);
  int argcv_meth_ast_isReadable8978[] = {0};
  meth_meth_ast_isReadable8978->type = alloc_MethodType(1, argcv_meth_ast_isReadable8978);
  meth_meth_ast_isReadable8978->definitionModule = modulename;
  meth_meth_ast_isReadable8978->definitionLine = 2168;
// method usesAsType
  struct UserObject *uo9008 = (struct UserObject*)obj8913;
  uo9008->data[10] = emptyclosure;
  Method *meth_meth_ast_usesAsType9008 = addmethod2pos(obj8913, "usesAsType", &meth_ast_usesAsType9008, 10);
  int argcv_meth_ast_usesAsType9008[] = {1};
  meth_meth_ast_usesAsType9008->type = alloc_MethodType(1, argcv_meth_ast_usesAsType9008);
  meth_meth_ast_usesAsType9008->definitionModule = modulename;
  meth_meth_ast_usesAsType9008->definitionLine = 2179;
// method accept()from
  struct UserObject *uo9014 = (struct UserObject*)obj8913;
  uo9014->data[11] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from9014 = addmethod2pos(obj8913, "accept()from", &meth_ast_accept_40__41_from9014, 11);
  int argcv_meth_ast_accept_40__41_from9014[] = {1, 1};
  meth_meth_ast_accept_40__41_from9014->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from9014);
  meth_meth_ast_accept_40__41_from9014->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from9014->definitionLine = 2182;
// method map()ancestors
  struct UserObject *uo9055 = (struct UserObject*)obj8913;
  uo9055->data[12] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors9055 = addmethod2pos(obj8913, "map()ancestors", &meth_ast_map_40__41_ancestors9055, 12);
  int argcv_meth_ast_map_40__41_ancestors9055[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors9055->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors9055);
  meth_meth_ast_map_40__41_ancestors9055->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors9055->definitionLine = 2197;
// method pretty
  struct UserObject *uo9098 = (struct UserObject*)obj8913;
  uo9098->data[13] = emptyclosure;
  Method *meth_meth_ast_pretty9098 = addmethod2pos(obj8913, "pretty", &meth_ast_pretty9098, 13);
  int argcv_meth_ast_pretty9098[] = {1};
  meth_meth_ast_pretty9098->type = alloc_MethodType(1, argcv_meth_ast_pretty9098);
  meth_meth_ast_pretty9098->definitionModule = modulename;
  meth_meth_ast_pretty9098->definitionLine = 2206;
// method toGrace
  struct UserObject *uo9216 = (struct UserObject*)obj8913;
  uo9216->data[14] = emptyclosure;
  Method *meth_meth_ast_toGrace9216 = addmethod2pos(obj8913, "toGrace", &meth_ast_toGrace9216, 14);
  int argcv_meth_ast_toGrace9216[] = {1};
  meth_meth_ast_toGrace9216->type = alloc_MethodType(1, argcv_meth_ast_toGrace9216);
meth_meth_ast_toGrace9216->type->types[0] = type_Number;
meth_meth_ast_toGrace9216->type->names[0] = "depth";
  meth_meth_ast_toGrace9216->definitionModule = modulename;
  meth_meth_ast_toGrace9216->definitionLine = 2226;
// method shallowCopy
  block_savedest(obj8913);
  Object closure9335 = createclosure(1, "shallowCopy");
  setclosureframe(closure9335, stackframe);
  addtoclosure(closure9335, var_varDecNode);
  struct UserObject *uo9335 = (struct UserObject*)obj8913;
  uo9335->data[15] = (Object)closure9335;
  Method *meth_meth_ast_shallowCopy9335 = addmethod2pos(obj8913, "shallowCopy", &meth_ast_shallowCopy9335, 15);
  int argcv_meth_ast_shallowCopy9335[] = {0};
  meth_meth_ast_shallowCopy9335->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy9335);
  meth_meth_ast_shallowCopy9335->definitionModule = modulename;
  meth_meth_ast_shallowCopy9335->definitionLine = 2246;
  sourceObject = obj8913;
// Begin line 2148
  setline(2148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9346 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9347 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe9346);
// compiled call node returning call9347 (depth = 4)
  struct UserObject *obj8913_uo = (struct UserObject *)obj8913;
  obj8913_uo->super = call9347;
  sourceObject = obj8913;
// Begin line 2149
  setline(2149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit9348 == NULL) {
    strlit9348 = alloc_String("vardec");
    gc_root(strlit9348);
  }
// compiled string node returning strlit9348 (depth = 4)
  adddatum2(obj8913, strlit9348, 1);
  sourceObject = obj8913;
// Begin line 2150
  setline(2150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_name_39_ (depth = 4)
  adddatum2(obj8913, *var_name_39_, 2);
  sourceObject = obj8913;
// Begin line 2151
  setline(2151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_val_39_ (depth = 4)
  adddatum2(obj8913, *var_val_39_, 3);
  sourceObject = obj8913;
// Begin line 2152
  setline(2152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_dtype_39_ (depth = 4)
  adddatum2(obj8913, *var_dtype_39_, 4);
  sourceObject = obj8913;
// Begin line 2153
  setline(2153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9349 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9350 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9351 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9350);
// compiled call node returning call9351 (depth = 7)
// compiled member node returning call9351 (depth = 6)
  partcv[0] = 0;
  Object call9352 = callmethod(call9351, "value",
    1, partcv, params);
  gc_frame_end(callframe9349);
// compiled call node returning call9352 (depth = 5)
// compiled member node returning call9352 (depth = 4)
  adddatum2(obj8913, call9352, 5);
  sourceObject = obj8913;
// Begin line 2154
  setline(2154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9353 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9354 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call9355 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9354);
// compiled call node returning call9355 (depth = 7)
// compiled member node returning call9355 (depth = 6)
  partcv[0] = 0;
  Object call9356 = callmethod(call9355, "empty",
    1, partcv, params);
  gc_frame_end(callframe9353);
// compiled call node returning call9356 (depth = 5)
// compiled member node returning call9356 (depth = 4)
  adddatum2(obj8913, call9356, 6);
  sourceObject = obj8913;
  sourceObject = obj8913;
  sourceObject = obj8913;
  sourceObject = obj8913;
  sourceObject = obj8913;
  sourceObject = obj8913;
  sourceObject = obj8913;
  sourceObject = obj8913;
  sourceObject = obj8913;
  objclass8913 = obj8913->class;
  objclass8913->definitionModule = modulename;
  objclass8913->definitionLine = 2147;
  (*(struct UserObject *)self).data[0] = lowerouter8913;
  self = oldself8913;
  selfslot = oldselfslot8913;
  stackframe = oldstackframe8913;
  gc_frame_end(frame);
  return obj8913;
}
Object meth_ast_new8912_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_varDecNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_val_39_ = &(stackframe->slots[1]);
  *var_val_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject8913 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8913 = alloc_userobj2(20,17, objclass8913);
  gc_frame_newslot(obj8913);
if (objclass8913 == NULL) {
  glfree(obj8913->class->name);
  obj8913->class->name = "varDecNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj8913, self, 0);
  addmethodreal(obj8913,"outer", &reader_ast_outer_8914);
  Object oldself8913 = self;
  struct StackFrameObject *oldstackframe8913 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8913);
  gc_frame_newslot((Object)stackframe);
  self = obj8913;
  Object *oldselfslot8913 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8913 = (*(struct UserObject *)self).data[0], lowerouter8913 = thisouter8913;
  if (inheritingObject8913) {
    struct UserObject *inho8913 = (struct UserObject *)inheritingObject8913;
    while (inho8913->super != GraceDefaultObject) inho8913 = (struct UserObject *)inho8913->super;
    inho8913->super = obj8913;
    self = inheritingObject8913;
    *selfslot = self;
    lowerouter8913 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8913;
  }
if (objclass8913 == NULL) {
  Method *reader8915 = addmethodrealflags(obj8913, "kind",&reader_ast_kind_8915, MFLAG_DEF);
  reader8915->definitionModule = modulename;
  reader8915->definitionLine = 2149;
}
adddatum2(obj8913, alloc_Undefined(), 1);
if (objclass8913 == NULL) {
  Method *reader8916 = addmethodrealflags(obj8913, "name",&reader_ast_name_8916, 0);
  Method *writer8916 = addmethodrealflags(obj8913, "name:=",&writer_ast_name_8916, 0);
  reader8916->definitionModule = modulename;
  writer8916->definitionModule = modulename;
  reader8916->definitionLine = 2150;
  writer8916->definitionLine = 2150;
}
obj8913->flags |= OFLAG_MUTABLE;
adddatum2(obj8913, alloc_Undefined(), 2);
if (objclass8913 == NULL) {
  Method *reader8917 = addmethodrealflags(obj8913, "value",&reader_ast_value_8917, 0);
  Method *writer8917 = addmethodrealflags(obj8913, "value:=",&writer_ast_value_8917, 0);
  reader8917->definitionModule = modulename;
  writer8917->definitionModule = modulename;
  reader8917->definitionLine = 2151;
  writer8917->definitionLine = 2151;
}
obj8913->flags |= OFLAG_MUTABLE;
adddatum2(obj8913, alloc_Undefined(), 3);
if (objclass8913 == NULL) {
  Method *reader8918 = addmethodrealflags(obj8913, "dtype",&reader_ast_dtype_8918, 0);
  Method *writer8918 = addmethodrealflags(obj8913, "dtype:=",&writer_ast_dtype_8918, 0);
  reader8918->definitionModule = modulename;
  writer8918->definitionModule = modulename;
  reader8918->definitionLine = 2152;
  writer8918->definitionLine = 2152;
}
obj8913->flags |= OFLAG_MUTABLE;
adddatum2(obj8913, alloc_Undefined(), 4);
if (objclass8913 == NULL) {
  Method *reader8919 = addmethodrealflags(obj8913, "nameString",&reader_ast_nameString_8919, MFLAG_DEF);
  reader8919->definitionModule = modulename;
  reader8919->definitionLine = 2153;
}
adddatum2(obj8913, alloc_Undefined(), 5);
if (objclass8913 == NULL) {
  Method *reader8920 = addmethodrealflags(obj8913, "annotations",&reader_ast_annotations_8920, 0);
  Method *writer8920 = addmethodrealflags(obj8913, "annotations:=",&writer_ast_annotations_8920, 0);
  reader8920->definitionModule = modulename;
  writer8920->definitionModule = modulename;
  reader8920->definitionLine = 2154;
  writer8920->definitionLine = 2154;
}
obj8913->flags |= OFLAG_MUTABLE;
adddatum2(obj8913, alloc_Undefined(), 6);
// method isPublic
  struct UserObject *uo8921 = (struct UserObject*)obj8913;
  uo8921->data[7] = emptyclosure;
  Method *meth_meth_ast_isPublic8921 = addmethod2pos(obj8913, "isPublic", &meth_ast_isPublic8921, 7);
  int argcv_meth_ast_isPublic8921[] = {0};
  meth_meth_ast_isPublic8921->type = alloc_MethodType(1, argcv_meth_ast_isPublic8921);
  meth_meth_ast_isPublic8921->definitionModule = modulename;
  meth_meth_ast_isPublic8921->definitionLine = 2156;
// method isWritable
  struct UserObject *uo8948 = (struct UserObject*)obj8913;
  uo8948->data[8] = emptyclosure;
  Method *meth_meth_ast_isWritable8948 = addmethod2pos(obj8913, "isWritable", &meth_ast_isWritable8948, 8);
  int argcv_meth_ast_isWritable8948[] = {0};
  meth_meth_ast_isWritable8948->type = alloc_MethodType(1, argcv_meth_ast_isWritable8948);
  meth_meth_ast_isWritable8948->definitionModule = modulename;
  meth_meth_ast_isWritable8948->definitionLine = 2162;
// method isReadable
  struct UserObject *uo8978 = (struct UserObject*)obj8913;
  uo8978->data[9] = emptyclosure;
  Method *meth_meth_ast_isReadable8978 = addmethod2pos(obj8913, "isReadable", &meth_ast_isReadable8978, 9);
  int argcv_meth_ast_isReadable8978[] = {0};
  meth_meth_ast_isReadable8978->type = alloc_MethodType(1, argcv_meth_ast_isReadable8978);
  meth_meth_ast_isReadable8978->definitionModule = modulename;
  meth_meth_ast_isReadable8978->definitionLine = 2168;
// method usesAsType
  struct UserObject *uo9008 = (struct UserObject*)obj8913;
  uo9008->data[10] = emptyclosure;
  Method *meth_meth_ast_usesAsType9008 = addmethod2pos(obj8913, "usesAsType", &meth_ast_usesAsType9008, 10);
  int argcv_meth_ast_usesAsType9008[] = {1};
  meth_meth_ast_usesAsType9008->type = alloc_MethodType(1, argcv_meth_ast_usesAsType9008);
  meth_meth_ast_usesAsType9008->definitionModule = modulename;
  meth_meth_ast_usesAsType9008->definitionLine = 2179;
// method accept()from
  struct UserObject *uo9014 = (struct UserObject*)obj8913;
  uo9014->data[11] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from9014 = addmethod2pos(obj8913, "accept()from", &meth_ast_accept_40__41_from9014, 11);
  int argcv_meth_ast_accept_40__41_from9014[] = {1, 1};
  meth_meth_ast_accept_40__41_from9014->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from9014);
  meth_meth_ast_accept_40__41_from9014->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from9014->definitionLine = 2182;
// method map()ancestors
  struct UserObject *uo9055 = (struct UserObject*)obj8913;
  uo9055->data[12] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors9055 = addmethod2pos(obj8913, "map()ancestors", &meth_ast_map_40__41_ancestors9055, 12);
  int argcv_meth_ast_map_40__41_ancestors9055[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors9055->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors9055);
  meth_meth_ast_map_40__41_ancestors9055->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors9055->definitionLine = 2197;
// method pretty
  struct UserObject *uo9098 = (struct UserObject*)obj8913;
  uo9098->data[13] = emptyclosure;
  Method *meth_meth_ast_pretty9098 = addmethod2pos(obj8913, "pretty", &meth_ast_pretty9098, 13);
  int argcv_meth_ast_pretty9098[] = {1};
  meth_meth_ast_pretty9098->type = alloc_MethodType(1, argcv_meth_ast_pretty9098);
  meth_meth_ast_pretty9098->definitionModule = modulename;
  meth_meth_ast_pretty9098->definitionLine = 2206;
// method toGrace
  struct UserObject *uo9216 = (struct UserObject*)obj8913;
  uo9216->data[14] = emptyclosure;
  Method *meth_meth_ast_toGrace9216 = addmethod2pos(obj8913, "toGrace", &meth_ast_toGrace9216, 14);
  int argcv_meth_ast_toGrace9216[] = {1};
  meth_meth_ast_toGrace9216->type = alloc_MethodType(1, argcv_meth_ast_toGrace9216);
meth_meth_ast_toGrace9216->type->types[0] = type_Number;
meth_meth_ast_toGrace9216->type->names[0] = "depth";
  meth_meth_ast_toGrace9216->definitionModule = modulename;
  meth_meth_ast_toGrace9216->definitionLine = 2226;
// method shallowCopy
  block_savedest(obj8913);
  Object closure9335 = createclosure(1, "shallowCopy");
  setclosureframe(closure9335, stackframe);
  addtoclosure(closure9335, var_varDecNode);
  struct UserObject *uo9335 = (struct UserObject*)obj8913;
  uo9335->data[15] = (Object)closure9335;
  Method *meth_meth_ast_shallowCopy9335 = addmethod2pos(obj8913, "shallowCopy", &meth_ast_shallowCopy9335, 15);
  int argcv_meth_ast_shallowCopy9335[] = {0};
  meth_meth_ast_shallowCopy9335->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy9335);
  meth_meth_ast_shallowCopy9335->definitionModule = modulename;
  meth_meth_ast_shallowCopy9335->definitionLine = 2246;
  sourceObject = obj8913;
// Begin line 2148
  setline(2148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9346 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9347 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe9346);
// compiled call node returning call9347 (depth = 4)
  struct UserObject *obj8913_uo = (struct UserObject *)obj8913;
  obj8913_uo->super = call9347;
  sourceObject = obj8913;
// Begin line 2149
  setline(2149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit9348 == NULL) {
    strlit9348 = alloc_String("vardec");
    gc_root(strlit9348);
  }
// compiled string node returning strlit9348 (depth = 4)
  adddatum2(obj8913, strlit9348, 1);
  sourceObject = obj8913;
// Begin line 2150
  setline(2150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_name_39_ (depth = 4)
  adddatum2(obj8913, *var_name_39_, 2);
  sourceObject = obj8913;
// Begin line 2151
  setline(2151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_val_39_ (depth = 4)
  adddatum2(obj8913, *var_val_39_, 3);
  sourceObject = obj8913;
// Begin line 2152
  setline(2152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_dtype_39_ (depth = 4)
  adddatum2(obj8913, *var_dtype_39_, 4);
  sourceObject = obj8913;
// Begin line 2153
  setline(2153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9349 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9350 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9351 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9350);
// compiled call node returning call9351 (depth = 7)
// compiled member node returning call9351 (depth = 6)
  partcv[0] = 0;
  Object call9352 = callmethod(call9351, "value",
    1, partcv, params);
  gc_frame_end(callframe9349);
// compiled call node returning call9352 (depth = 5)
// compiled member node returning call9352 (depth = 4)
  adddatum2(obj8913, call9352, 5);
  sourceObject = obj8913;
// Begin line 2154
  setline(2154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9353 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9354 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call9355 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9354);
// compiled call node returning call9355 (depth = 7)
// compiled member node returning call9355 (depth = 6)
  partcv[0] = 0;
  Object call9356 = callmethod(call9355, "empty",
    1, partcv, params);
  gc_frame_end(callframe9353);
// compiled call node returning call9356 (depth = 5)
// compiled member node returning call9356 (depth = 4)
  adddatum2(obj8913, call9356, 6);
  sourceObject = obj8913;
  sourceObject = obj8913;
  sourceObject = obj8913;
  sourceObject = obj8913;
  sourceObject = obj8913;
  sourceObject = obj8913;
  sourceObject = obj8913;
  sourceObject = obj8913;
  sourceObject = obj8913;
  objclass8913 = obj8913->class;
  objclass8913->definitionModule = modulename;
  objclass8913->definitionLine = 2147;
  (*(struct UserObject *)self).data[0] = lowerouter8913;
  self = oldself8913;
  selfslot = oldselfslot8913;
  stackframe = oldstackframe8913;
  gc_frame_end(frame);
  return obj8913;
}
Object meth_ast_importNode9358(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 42, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "importNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_importNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for importNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for importNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_importNode (depth = 3)
  gc_frame_end(frame);
  return *var_importNode;
}
Object meth_ast_isImport9369(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isImport");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isImport (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isImport");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2257
  setline(2257);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool9370 = alloc_Boolean(1);
// compiled identifier node returning bool9370 (depth = 4)
  gc_frame_end(frame);
  return bool9370;
}
Object meth_ast_name9371(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "name");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for name (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for name");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2258
  setline(2258);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9372 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9373 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9372);
// compiled call node returning call9373 (depth = 5)
// compiled member node returning call9373 (depth = 4)
  gc_frame_end(frame);
  return call9373;
}
Object meth_ast_nameString9374(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for nameString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for nameString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2259
  setline(2259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9375 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9376 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9377 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9376);
// compiled call node returning call9377 (depth = 7)
// compiled member node returning call9377 (depth = 6)
  partcv[0] = 0;
  Object call9378 = callmethod(call9377, "nameString",
    1, partcv, params);
  gc_frame_end(callframe9375);
// compiled call node returning call9378 (depth = 5)
// compiled member node returning call9378 (depth = 4)
  gc_frame_end(frame);
  return call9378;
}
Object meth_ast_isPublic9379(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPublic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isPublic (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isPublic");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2262
  setline(2262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num9382 = alloc_Float64(0);
// compiled num node returning num9382 (depth = 6)
  int op_slot_right_9381 = gc_frame_newslot(num9382);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9384 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9385 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9386 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9385);
// compiled call node returning call9386 (depth = 9)
// compiled member node returning call9386 (depth = 8)
  partcv[0] = 0;
  Object call9387 = callmethod(call9386, "size",
    1, partcv, params);
  gc_frame_end(callframe9384);
// compiled call node returning call9387 (depth = 7)
// compiled member node returning call9387 (depth = 6)
  int op_slot_left_9381 = gc_frame_newslot(call9387);
  params[0] = num9382;
  partcv[0] = 1;
  Object opresult9388 = callmethod(call9387, "==", 1, partcv, params);
// compiled op node returning opresult9388 (depth = 5)
  Object if9380 = done;
  if (istrue(opresult9388)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool9389 = alloc_Boolean(0);
// compiled identifier node returning bool9389 (depth = 6)
  return bool9389;
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if9380 = undefined;
  } else {
  }
// compiled if node returning if9380 (depth = 4)
// Begin line 2263
  setline(2263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9391 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile string node (depth = 6)
  if (strlit9392 == NULL) {
    strlit9392 = alloc_String("public");
    gc_root(strlit9392);
  }
// compiled string node returning strlit9392 (depth = 6)
  gc_frame_newslot(strlit9392);
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9393 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9394 = gc_frame_new();
// call case 3: self.outer request
  Object call9395 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9394);
// compiled call node returning call9395 (depth = 9)
// compiled member node returning call9395 (depth = 8)
  partcv[0] = 0;
  Object call9396 = callmethodflags(call9395, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9393);
// compiled call node returning call9396 (depth = 7)
// compiled member node returning call9396 (depth = 6)
  params[0] = self;
  params[1] = strlit9392;
  partcv[0] = 2;
  Object call9397 = callmethodflags(call9396, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9391);
// compiled call node returning call9397 (depth = 5)
  Object if9390 = done;
  if (istrue(call9397)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool9398 = alloc_Boolean(1);
// compiled identifier node returning bool9398 (depth = 6)
  return bool9398;
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if9390 = undefined;
  } else {
  }
// compiled if node returning if9390 (depth = 4)
// Begin line 2264
  setline(2264);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9399 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile string node (depth = 5)
  if (strlit9400 == NULL) {
    strlit9400 = alloc_String("readable");
    gc_root(strlit9400);
  }
// compiled string node returning strlit9400 (depth = 5)
  gc_frame_newslot(strlit9400);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9401 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9402 = gc_frame_new();
// call case 3: self.outer request
  Object call9403 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9402);
// compiled call node returning call9403 (depth = 8)
// compiled member node returning call9403 (depth = 7)
  partcv[0] = 0;
  Object call9404 = callmethodflags(call9403, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9401);
// compiled call node returning call9404 (depth = 6)
// compiled member node returning call9404 (depth = 5)
  params[0] = self;
  params[1] = strlit9400;
  partcv[0] = 2;
  Object call9405 = callmethodflags(call9404, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9399);
// compiled call node returning call9405 (depth = 4)
  gc_frame_end(frame);
  return call9405;
}
Object meth_ast__apply9412(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_bnm = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2269
  setline(2269);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9415 == NULL) {
    strlit9415 = alloc_String("/");
    gc_root(strlit9415);
  }
// compiled string node returning strlit9415 (depth = 8)
  int op_slot_right_9414 = gc_frame_newslot(strlit9415);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  int op_slot_left_9414 = gc_frame_newslot(*var_c);
  params[0] = strlit9415;
  partcv[0] = 1;
  Object opresult9417 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult9417 (depth = 7)
  Object if9413 = done;
  if (istrue(opresult9417)) {
// Begin line 2270
  setline(2270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9418 == NULL) {
    strlit9418 = alloc_String("");
    gc_root(strlit9418);
  }
// compiled string node returning strlit9418 (depth = 8)
  *var_bnm = strlit9418;
  if (strlit9418 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if9413 = done;
  } else {
// Begin line 2272
  setline(2272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_c (depth = 9)
  int op_slot_right_9420 = gc_frame_newslot(*var_c);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_bnm (depth = 9)
  int op_slot_left_9420 = gc_frame_newslot(*var_bnm);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult9422 = callmethod(*var_bnm, "++", 1, partcv, params);
// compiled op node returning opresult9422 (depth = 8)
  *var_bnm = opresult9422;
  if (opresult9422 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if9413 = done;
  }
// compiled if node returning if9413 (depth = 6)
  gc_frame_end(frame);
  return if9413;
}
Object meth_ast_moduleName9406(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "moduleName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for moduleName (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for moduleName");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_bnm = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "bnm");
// Begin line 2267
  setline(2267);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9407 == NULL) {
    strlit9407 = alloc_String("");
    gc_root(strlit9407);
  }
// compiled string node returning strlit9407 (depth = 5)
  *var_bnm = strlit9407;
  if (strlit9407 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2268
  setline(2268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9408 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9409 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9410 = callmethodflags(self, "path", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9409);
// compiled call node returning call9410 (depth = 6)
// compiled member node returning call9410 (depth = 5)
  gc_frame_newslot(call9410);
// starting to compile block node (depth = 5)
  Object block9411 = alloc_Block(NULL, NULL, "ast", 2268);
  gc_frame_newslot(block9411);
// method _apply
  block_savedest(block9411);
  Object closure9412 = createclosure(2, "_apply");
  setclosureframe(closure9412, stackframe);
  addtoclosure(closure9412, var_bnm);
  addtoclosure(closure9412, selfslot);
  struct UserObject *uo9412 = (struct UserObject*)block9411;
  uo9412->data[0] = (Object)closure9412;
  Method *meth_meth_ast__apply9412 = addmethod2pos(block9411, "_apply", &meth_ast__apply9412, 0);
  int argcv_meth_ast__apply9412[] = {1};
  meth_meth_ast__apply9412->type = alloc_MethodType(1, argcv_meth_ast__apply9412);
  meth_meth_ast__apply9412->definitionModule = modulename;
  meth_meth_ast__apply9412->definitionLine = 2268;
// compiled block node returning block9411 (depth = 5)
  gc_frame_newslot(block9411);
// call case 5: prelude request
  params[0] = call9410;
  params[1] = block9411;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9425 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9408);
// compiled call node returning call9425 (depth = 4)
// Begin line 2275
  setline(2275);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_bnm (depth = 4)
  gc_frame_end(frame);
  return *var_bnm;
}
Object meth_ast_isWritable9426(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isWritable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isWritable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isWritable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2277
  setline(2277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool9427 = alloc_Boolean(0);
// compiled identifier node returning bool9427 (depth = 4)
  gc_frame_end(frame);
  return bool9427;
}
Object meth_ast_isReadable9428(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isReadable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isReadable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isReadable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2278
  setline(2278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9429 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9430 = callmethodflags(self, "isPublic", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9429);
// compiled call node returning call9430 (depth = 5)
// compiled member node returning call9430 (depth = 4)
  gc_frame_end(frame);
  return call9430;
}
Object meth_ast_declarationKindWithAncestors9431(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "declarationKindWithAncestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method declarationKindWithAncestors");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for declarationKindWithAncestors (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for declarationKindWithAncestors");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2279
  setline(2279);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit9432 == NULL) {
    strlit9432 = alloc_String("defdec");
    gc_root(strlit9432);
  }
// compiled string node returning strlit9432 (depth = 4)
  gc_frame_end(frame);
  return strlit9432;
}
Object meth_ast_usesAsType9433(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "usesAsType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method usesAsType");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for usesAsType (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aNode = &(stackframe->slots[0]);
  *var_aNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for usesAsType");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2281
  setline(2281);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9435 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9436 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9435);
// compiled call node returning call9436 (depth = 6)
// compiled member node returning call9436 (depth = 5)
  int op_slot_right_9434 = gc_frame_newslot(call9436);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_aNode (depth = 5)
  int op_slot_left_9434 = gc_frame_newslot(*var_aNode);
  params[0] = call9436;
  partcv[0] = 1;
  Object opresult9438 = callmethod(*var_aNode, "==", 1, partcv, params);
// compiled op node returning opresult9438 (depth = 4)
  gc_frame_end(frame);
  return opresult9438;
}
Object meth_ast__apply9449(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ann = &(stackframe->slots[0]);
  *var_ann = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2287
  setline(2287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe9450 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_visitor (depth = 8)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_newChain (depth = 8)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ann (depth = 8)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9451 = callmethod(*var_ann, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe9450);
// compiled call node returning call9451 (depth = 7)
  gc_frame_end(frame);
  return call9451;
}
Object meth_ast_accept_40__41_from9439(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 2284
  setline(2284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9441 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9442 = callmethod(*var_visitor, "visitImport()up",
    2, partcv, params);
  gc_frame_end(callframe9441);
// compiled call node returning call9442 (depth = 5)
  Object if9440 = done;
  if (istrue(call9442)) {
// Begin line 2285
  setline(2285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9443 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_as (depth = 7)
  params[0] = self;
  partcv[0] = 1;
  Object call9444 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe9443);
// compiled call node returning call9444 (depth = 6)
  *var_newChain = call9444;
  if (call9444 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2286
  setline(2286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9445 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9446 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9447 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9446);
// compiled call node returning call9447 (depth = 7)
// compiled member node returning call9447 (depth = 6)
  gc_frame_newslot(call9447);
// starting to compile block node (depth = 6)
  Object block9448 = alloc_Block(NULL, NULL, "ast", 2286);
  gc_frame_newslot(block9448);
// method _apply
  block_savedest(block9448);
  Object closure9449 = createclosure(3, "_apply");
  setclosureframe(closure9449, stackframe);
  addtoclosure(closure9449, var_visitor);
  addtoclosure(closure9449, var_newChain);
  addtoclosure(closure9449, selfslot);
  struct UserObject *uo9449 = (struct UserObject*)block9448;
  uo9449->data[0] = (Object)closure9449;
  Method *meth_meth_ast__apply9449 = addmethod2pos(block9448, "_apply", &meth_ast__apply9449, 0);
  int argcv_meth_ast__apply9449[] = {1};
  meth_meth_ast__apply9449->type = alloc_MethodType(1, argcv_meth_ast__apply9449);
  meth_meth_ast__apply9449->definitionModule = modulename;
  meth_meth_ast__apply9449->definitionLine = 2286;
// compiled block node returning block9448 (depth = 6)
  gc_frame_newslot(block9448);
// call case 5: prelude request
  params[0] = call9447;
  params[1] = block9448;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9453 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9445);
// compiled call node returning call9453 (depth = 5)
// Begin line 2289
  setline(2289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9454 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9455 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9456 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9455);
// compiled call node returning call9456 (depth = 7)
// compiled member node returning call9456 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9457 = callmethod(call9456, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe9454);
// compiled call node returning call9457 (depth = 5)
// Begin line 2290
  setline(2290);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool9460 = alloc_Boolean(0);
// compiled identifier node returning bool9460 (depth = 7)
  int op_slot_right_9459 = gc_frame_newslot(bool9460);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9462 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9463 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9462);
// compiled call node returning call9463 (depth = 8)
// compiled member node returning call9463 (depth = 7)
  int op_slot_left_9459 = gc_frame_newslot(call9463);
  params[0] = bool9460;
  partcv[0] = 1;
  Object opresult9464 = callmethod(call9463, "!=", 1, partcv, params);
// compiled op node returning opresult9464 (depth = 6)
  Object if9458 = done;
  if (istrue(opresult9464)) {
// Begin line 2291
  setline(2291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9465 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9466 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9467 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9466);
// compiled call node returning call9467 (depth = 8)
// compiled member node returning call9467 (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9468 = callmethod(call9467, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe9465);
// compiled call node returning call9468 (depth = 6)
    gc_frame_newslot(call9468);
    if9458 = call9468;
  } else {
  }
// compiled if node returning if9458 (depth = 5)
    gc_frame_newslot(if9458);
    if9440 = if9458;
  } else {
  }
// compiled if node returning if9440 (depth = 4)
  gc_frame_end(frame);
  return if9440;
}
Object meth_ast_map_40__41_ancestors9469(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2296
  setline(2296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9470 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9471 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9470);
// compiled call node returning call9471 (depth = 6)
// compiled member node returning call9471 (depth = 5)
  *var_n = call9471;
  if (call9471 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2297
  setline(2297);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9472 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call9473 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe9472);
// compiled call node returning call9473 (depth = 5)
  *var_newChain = call9473;
  if (call9473 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2298
  setline(2298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2296
  setline(2296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9474 = gc_frame_new();
// Begin line 2298
  setline(2298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9475 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9476 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9477 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9476);
// compiled call node returning call9477 (depth = 8)
// compiled member node returning call9477 (depth = 7)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9478 = callmethod(call9477, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe9475);
// compiled call node returning call9478 (depth = 6)
  gc_frame_newslot(call9478);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call9478;
  partcv[0] = 1;
  Object call9479 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe9474);
// compiled call node returning call9479 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 2299
  setline(2299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2298
  setline(2298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9480 = gc_frame_new();
// Begin line 2299
  setline(2299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9481 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9482 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9483 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9482);
// compiled call node returning call9483 (depth = 8)
// compiled member node returning call9483 (depth = 7)
  gc_frame_newslot(call9483);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9484 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9485 = gc_frame_new();
// call case 3: self.outer request
  Object call9486 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9485);
// compiled call node returning call9486 (depth = 10)
// compiled member node returning call9486 (depth = 9)
  partcv[0] = 0;
  Object call9487 = callmethodflags(call9486, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9484);
// compiled call node returning call9487 (depth = 8)
// compiled member node returning call9487 (depth = 7)
  params[0] = call9483;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call9488 = callmethodflags(call9487, "maybeMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9481);
// compiled call node returning call9488 (depth = 6)
  gc_frame_newslot(call9488);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call9488;
  partcv[0] = 1;
  Object call9489 = callmethod(*var_n, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe9480);
// compiled call node returning call9489 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 2300
  setline(2300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2299
  setline(2299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9490 = gc_frame_new();
// Begin line 2300
  setline(2300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9491 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9492 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9493 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9492);
// compiled call node returning call9493 (depth = 8)
// compiled member node returning call9493 (depth = 7)
  gc_frame_newslot(call9493);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9494 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9495 = gc_frame_new();
// call case 3: self.outer request
  Object call9496 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9495);
// compiled call node returning call9496 (depth = 10)
// compiled member node returning call9496 (depth = 9)
  partcv[0] = 0;
  Object call9497 = callmethodflags(call9496, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9494);
// compiled call node returning call9497 (depth = 8)
// compiled member node returning call9497 (depth = 7)
  params[0] = call9493;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call9498 = callmethodflags(call9497, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9491);
// compiled call node returning call9498 (depth = 6)
  gc_frame_newslot(call9498);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call9498;
  partcv[0] = 1;
  Object call9499 = callmethod(*var_n, "annotations:=",
    1, partcv, params);
  gc_frame_end(callframe9490);
// compiled call node returning call9499 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 2301
  setline(2301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9500 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call9501 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe9500);
// compiled call node returning call9501 (depth = 4)
  gc_frame_end(frame);
  return call9501;
}
Object meth_ast__apply9510(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2306
  setline(2306);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9512 == NULL) {
    strlit9512 = alloc_String("  ");
    gc_root(strlit9512);
  }
// compiled string node returning strlit9512 (depth = 8)
  int op_slot_right_9511 = gc_frame_newslot(strlit9512);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_9511 = gc_frame_newslot(*var_spc);
  params[0] = strlit9512;
  partcv[0] = 1;
  Object opresult9514 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult9514 (depth = 7)
  *var_spc = opresult9514;
  if (opresult9514 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty9502(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2304
  setline(2304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9503 == NULL) {
    strlit9503 = alloc_String("");
    gc_root(strlit9503);
  }
// compiled string node returning strlit9503 (depth = 5)
  *var_spc = strlit9503;
  if (strlit9503 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2305
  setline(2305);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9504 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_right_9505 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 6)
  Object num9507 = alloc_Float64(0);
// compiled num node returning num9507 (depth = 6)
  int op_slot_left_9505 = gc_frame_newslot(num9507);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult9508 = callmethod(num9507, "..", 1, partcv, params);
// compiled op node returning opresult9508 (depth = 5)
  gc_frame_newslot(opresult9508);
// starting to compile block node (depth = 5)
  Object block9509 = alloc_Block(NULL, NULL, "ast", 2305);
  gc_frame_newslot(block9509);
// method _apply
  block_savedest(block9509);
  Object closure9510 = createclosure(2, "_apply");
  setclosureframe(closure9510, stackframe);
  addtoclosure(closure9510, var_spc);
  addtoclosure(closure9510, selfslot);
  struct UserObject *uo9510 = (struct UserObject*)block9509;
  uo9510->data[0] = (Object)closure9510;
  Method *meth_meth_ast__apply9510 = addmethod2pos(block9509, "_apply", &meth_ast__apply9510, 0);
  int argcv_meth_ast__apply9510[] = {1};
  meth_meth_ast__apply9510->type = alloc_MethodType(1, argcv_meth_ast__apply9510);
  meth_meth_ast__apply9510->definitionModule = modulename;
  meth_meth_ast__apply9510->definitionLine = 2300;
// compiled block node returning block9509 (depth = 5)
  gc_frame_newslot(block9509);
// call case 5: prelude request
  params[0] = opresult9508;
  params[1] = block9509;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9517 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9504);
// compiled call node returning call9517 (depth = 4)
// Begin line 2308
  setline(2308);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9519 == NULL) {
    strlit9519 = alloc_String("""\x0a""");
    gc_root(strlit9519);
  }
// compiled string node returning strlit9519 (depth = 6)
  int op_slot_right_9518 = gc_frame_newslot(strlit9519);
// starting to compile call node (depth = 6)
  int callframe9521 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call9522 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe9521);
// compiled call node returning call9522 (depth = 6)
  int op_slot_left_9518 = gc_frame_newslot(call9522);
  params[0] = strlit9519;
  partcv[0] = 1;
  Object opresult9523 = callmethod(call9522, "++", 1, partcv, params);
// compiled op node returning opresult9523 (depth = 5)
  *var_s = opresult9523;
  if (opresult9523 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2309
  setline(2309);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9526 == NULL) {
    strlit9526 = alloc_String("""\x0a""");
    gc_root(strlit9526);
  }
// compiled string node returning strlit9526 (depth = 7)
  int op_slot_right_9525 = gc_frame_newslot(strlit9526);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9529 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9530 = callmethodflags(self, "path", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9529);
// compiled call node returning call9530 (depth = 9)
// compiled member node returning call9530 (depth = 8)
  int op_slot_right_9528 = gc_frame_newslot(call9530);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9533 == NULL) {
    strlit9533 = alloc_String("Path: ");
    gc_root(strlit9533);
  }
// compiled string node returning strlit9533 (depth = 9)
  int op_slot_right_9532 = gc_frame_newslot(strlit9533);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_9535 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 10)
  if (strlit9537 == NULL) {
    strlit9537 = alloc_String("");
    gc_root(strlit9537);
  }
// compiled string node returning strlit9537 (depth = 10)
  int op_slot_left_9535 = gc_frame_newslot(strlit9537);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9538 = callmethod(strlit9537, "++", 1, partcv, params);
// compiled op node returning opresult9538 (depth = 9)
  int op_slot_left_9532 = gc_frame_newslot(opresult9538);
  params[0] = strlit9533;
  partcv[0] = 1;
  Object opresult9539 = callmethod(opresult9538, "++", 1, partcv, params);
// compiled op node returning opresult9539 (depth = 8)
  int op_slot_left_9528 = gc_frame_newslot(opresult9539);
  params[0] = call9530;
  partcv[0] = 1;
  Object opresult9540 = callmethod(opresult9539, "++", 1, partcv, params);
// compiled op node returning opresult9540 (depth = 7)
  int op_slot_left_9525 = gc_frame_newslot(opresult9540);
  params[0] = strlit9526;
  partcv[0] = 1;
  Object opresult9541 = callmethod(opresult9540, "++", 1, partcv, params);
// compiled op node returning opresult9541 (depth = 6)
  int op_slot_right_9524 = gc_frame_newslot(opresult9541);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_9524 = gc_frame_newslot(*var_s);
  params[0] = opresult9541;
  partcv[0] = 1;
  Object opresult9543 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult9543 (depth = 5)
  *var_s = opresult9543;
  if (opresult9543 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2310
  setline(2310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9547 == NULL) {
    strlit9547 = alloc_String("""\x0a""");
    gc_root(strlit9547);
  }
// compiled string node returning strlit9547 (depth = 7)
  int op_slot_right_9546 = gc_frame_newslot(strlit9547);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9550 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9551 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9550);
// compiled call node returning call9551 (depth = 9)
// compiled member node returning call9551 (depth = 8)
  int op_slot_right_9549 = gc_frame_newslot(call9551);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9554 == NULL) {
    strlit9554 = alloc_String("Identifier: ");
    gc_root(strlit9554);
  }
// compiled string node returning strlit9554 (depth = 9)
  int op_slot_right_9553 = gc_frame_newslot(strlit9554);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_9556 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 10)
  if (strlit9558 == NULL) {
    strlit9558 = alloc_String("");
    gc_root(strlit9558);
  }
// compiled string node returning strlit9558 (depth = 10)
  int op_slot_left_9556 = gc_frame_newslot(strlit9558);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9559 = callmethod(strlit9558, "++", 1, partcv, params);
// compiled op node returning opresult9559 (depth = 9)
  int op_slot_left_9553 = gc_frame_newslot(opresult9559);
  params[0] = strlit9554;
  partcv[0] = 1;
  Object opresult9560 = callmethod(opresult9559, "++", 1, partcv, params);
// compiled op node returning opresult9560 (depth = 8)
  int op_slot_left_9549 = gc_frame_newslot(opresult9560);
  params[0] = call9551;
  partcv[0] = 1;
  Object opresult9561 = callmethod(opresult9560, "++", 1, partcv, params);
// compiled op node returning opresult9561 (depth = 7)
  int op_slot_left_9546 = gc_frame_newslot(opresult9561);
  params[0] = strlit9547;
  partcv[0] = 1;
  Object opresult9562 = callmethod(opresult9561, "++", 1, partcv, params);
// compiled op node returning opresult9562 (depth = 6)
  int op_slot_right_9545 = gc_frame_newslot(opresult9562);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_9545 = gc_frame_newslot(*var_s);
  params[0] = opresult9562;
  partcv[0] = 1;
  Object opresult9564 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult9564 (depth = 5)
  *var_s = opresult9564;
  if (opresult9564 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2311
  setline(2311);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num9568 = alloc_Float64(0);
// compiled num node returning num9568 (depth = 6)
  int op_slot_right_9567 = gc_frame_newslot(num9568);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9570 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9571 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9572 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9571);
// compiled call node returning call9572 (depth = 9)
// compiled member node returning call9572 (depth = 8)
  partcv[0] = 0;
  Object call9573 = callmethod(call9572, "size",
    1, partcv, params);
  gc_frame_end(callframe9570);
// compiled call node returning call9573 (depth = 7)
// compiled member node returning call9573 (depth = 6)
  int op_slot_left_9567 = gc_frame_newslot(call9573);
  params[0] = num9568;
  partcv[0] = 1;
  Object opresult9574 = callmethod(call9573, ">", 1, partcv, params);
// compiled op node returning opresult9574 (depth = 5)
  Object if9566 = done;
  if (istrue(opresult9574)) {
// Begin line 2312
  setline(2312);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9577 == NULL) {
    strlit9577 = alloc_String("""\x0a""");
    gc_root(strlit9577);
  }
// compiled string node returning strlit9577 (depth = 8)
  int op_slot_right_9576 = gc_frame_newslot(strlit9577);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9580 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9581 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9580);
// compiled call node returning call9581 (depth = 10)
// compiled member node returning call9581 (depth = 9)
  int op_slot_right_9579 = gc_frame_newslot(call9581);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit9584 == NULL) {
    strlit9584 = alloc_String("Anotations: ");
    gc_root(strlit9584);
  }
// compiled string node returning strlit9584 (depth = 10)
  int op_slot_right_9583 = gc_frame_newslot(strlit9584);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_9586 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 11)
  if (strlit9588 == NULL) {
    strlit9588 = alloc_String("");
    gc_root(strlit9588);
  }
// compiled string node returning strlit9588 (depth = 11)
  int op_slot_left_9586 = gc_frame_newslot(strlit9588);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9589 = callmethod(strlit9588, "++", 1, partcv, params);
// compiled op node returning opresult9589 (depth = 10)
  int op_slot_left_9583 = gc_frame_newslot(opresult9589);
  params[0] = strlit9584;
  partcv[0] = 1;
  Object opresult9590 = callmethod(opresult9589, "++", 1, partcv, params);
// compiled op node returning opresult9590 (depth = 9)
  int op_slot_left_9579 = gc_frame_newslot(opresult9590);
  params[0] = call9581;
  partcv[0] = 1;
  Object opresult9591 = callmethod(opresult9590, "++", 1, partcv, params);
// compiled op node returning opresult9591 (depth = 8)
  int op_slot_left_9576 = gc_frame_newslot(opresult9591);
  params[0] = strlit9577;
  partcv[0] = 1;
  Object opresult9592 = callmethod(opresult9591, "++", 1, partcv, params);
// compiled op node returning opresult9592 (depth = 7)
  int op_slot_right_9575 = gc_frame_newslot(opresult9592);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_9575 = gc_frame_newslot(*var_s);
  params[0] = opresult9592;
  partcv[0] = 1;
  Object opresult9594 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult9594 (depth = 6)
  *var_s = opresult9594;
  if (opresult9594 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if9566 = done;
  } else {
  }
// compiled if node returning if9566 (depth = 4)
// Begin line 2314
  setline(2314);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_toGrace9596(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2317
  setline(2317);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9598 == NULL) {
    strlit9598 = alloc_String("");
    gc_root(strlit9598);
  }
// compiled string node returning strlit9598 (depth = 5)
  int op_slot_right_9597 = gc_frame_newslot(strlit9598);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9601 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9602 = callmethodflags(self, "nameString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9601);
// compiled call node returning call9602 (depth = 7)
// compiled member node returning call9602 (depth = 6)
  int op_slot_right_9600 = gc_frame_newslot(call9602);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9605 == NULL) {
    strlit9605 = alloc_String("""\x22"" as ");
    gc_root(strlit9605);
  }
// compiled string node returning strlit9605 (depth = 7)
  int op_slot_right_9604 = gc_frame_newslot(strlit9605);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9608 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9609 = callmethodflags(self, "path", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9608);
// compiled call node returning call9609 (depth = 9)
// compiled member node returning call9609 (depth = 8)
  int op_slot_right_9607 = gc_frame_newslot(call9609);
// starting to compile string node (depth = 8)
  if (strlit9611 == NULL) {
    strlit9611 = alloc_String("import ""\x22""");
    gc_root(strlit9611);
  }
// compiled string node returning strlit9611 (depth = 8)
  int op_slot_left_9607 = gc_frame_newslot(strlit9611);
  params[0] = call9609;
  partcv[0] = 1;
  Object opresult9612 = callmethod(strlit9611, "++", 1, partcv, params);
// compiled op node returning opresult9612 (depth = 7)
  int op_slot_left_9604 = gc_frame_newslot(opresult9612);
  params[0] = strlit9605;
  partcv[0] = 1;
  Object opresult9613 = callmethod(opresult9612, "++", 1, partcv, params);
// compiled op node returning opresult9613 (depth = 6)
  int op_slot_left_9600 = gc_frame_newslot(opresult9613);
  params[0] = call9602;
  partcv[0] = 1;
  Object opresult9614 = callmethod(opresult9613, "++", 1, partcv, params);
// compiled op node returning opresult9614 (depth = 5)
  int op_slot_left_9597 = gc_frame_newslot(opresult9614);
  params[0] = strlit9598;
  partcv[0] = 1;
  Object opresult9615 = callmethod(opresult9614, "++", 1, partcv, params);
// compiled op node returning opresult9615 (depth = 4)
  gc_frame_end(frame);
  return opresult9615;
}
Object meth_ast_shallowCopy9616(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_importNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2320
  setline(2320);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9617 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe9618 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9619 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9620 = callmethodflags(self, "path", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9619);
// compiled call node returning call9620 (depth = 7)
// compiled member node returning call9620 (depth = 6)
  gc_frame_newslot(call9620);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nullNode (depth = 6)
  gc_frame_newslot(*var_nullNode);
// starting to compile identifier node (depth = 6)
  Object bool9621 = alloc_Boolean(0);
// compiled identifier node returning bool9621 (depth = 6)
  gc_frame_newslot(bool9621);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_importNode (depth = 6)
  params[0] = call9620;
  params[1] = *var_nullNode;
  params[2] = bool9621;
  partcv[0] = 3;
  Object call9622 = callmethod(*var_importNode, "new",
    1, partcv, params);
  gc_frame_end(callframe9618);
// compiled call node returning call9622 (depth = 5)
  params[0] = self;
  partcv[0] = 1;
  Object call9623 = callmethod(call9622, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe9617);
// compiled call node returning call9623 (depth = 4)
  gc_frame_end(frame);
  return call9623;
}
Object meth_ast_new9361(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_importNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_path_39_ = &(stackframe->slots[0]);
  *var_path_39_ = args[curarg];
  curarg++;
  Object *var_name_39_ = &(stackframe->slots[1]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9362 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9362 = alloc_userobj2(24,21, objclass9362);
  gc_frame_newslot(obj9362);
if (objclass9362 == NULL) {
  glfree(obj9362->class->name);
  obj9362->class->name = "importNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9362, self, 0);
  addmethodreal(obj9362,"outer", &reader_ast_outer_9363);
  Object oldself9362 = self;
  struct StackFrameObject *oldstackframe9362 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9362);
  gc_frame_newslot((Object)stackframe);
  self = obj9362;
  Object *oldselfslot9362 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9362 = (*(struct UserObject *)self).data[0], lowerouter9362 = thisouter9362;
  if (inheritingObject9362) {
    struct UserObject *inho9362 = (struct UserObject *)inheritingObject9362;
    while (inho9362->super != GraceDefaultObject) inho9362 = (struct UserObject *)inho9362->super;
    inho9362->super = obj9362;
    self = inheritingObject9362;
    *selfslot = self;
    lowerouter9362 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9362;
  }
if (objclass9362 == NULL) {
  Method *reader9364 = addmethodrealflags(obj9362, "kind",&reader_ast_kind_9364, MFLAG_DEF);
  reader9364->definitionModule = modulename;
  reader9364->definitionLine = 2252;
}
adddatum2(obj9362, alloc_Undefined(), 1);
if (objclass9362 == NULL) {
  Method *reader9365 = addmethodrealflags(obj9362, "value",&reader_ast_value_9365, 0);
  Method *writer9365 = addmethodrealflags(obj9362, "value:=",&writer_ast_value_9365, 0);
  reader9365->definitionModule = modulename;
  writer9365->definitionModule = modulename;
  reader9365->definitionLine = 2253;
  writer9365->definitionLine = 2253;
}
obj9362->flags |= OFLAG_MUTABLE;
adddatum2(obj9362, alloc_Undefined(), 2);
if (objclass9362 == NULL) {
  Method *reader9366 = addmethodrealflags(obj9362, "path",&reader_ast_path_9366, 0);
  Method *writer9366 = addmethodrealflags(obj9362, "path:=",&writer_ast_path_9366, 0);
  reader9366->definitionModule = modulename;
  writer9366->definitionModule = modulename;
  reader9366->definitionLine = 2254;
  writer9366->definitionLine = 2254;
}
obj9362->flags |= OFLAG_MUTABLE;
adddatum2(obj9362, alloc_Undefined(), 3);
if (objclass9362 == NULL) {
  Method *reader9367 = addmethodrealflags(obj9362, "annotations",&reader_ast_annotations_9367, 0);
  Method *writer9367 = addmethodrealflags(obj9362, "annotations:=",&writer_ast_annotations_9367, 0);
  reader9367->definitionModule = modulename;
  writer9367->definitionModule = modulename;
  reader9367->definitionLine = 2255;
  writer9367->definitionLine = 2255;
}
obj9362->flags |= OFLAG_MUTABLE;
adddatum2(obj9362, alloc_Undefined(), 4);
if (objclass9362 == NULL) {
  Method *reader9368 = addmethodrealflags(obj9362, "dtype",&reader_ast_dtype_9368, 0);
  Method *writer9368 = addmethodrealflags(obj9362, "dtype:=",&writer_ast_dtype_9368, 0);
  reader9368->definitionModule = modulename;
  writer9368->definitionModule = modulename;
  reader9368->definitionLine = 2256;
  writer9368->definitionLine = 2256;
}
obj9362->flags |= OFLAG_MUTABLE;
adddatum2(obj9362, alloc_Undefined(), 5);
// method isImport
  struct UserObject *uo9369 = (struct UserObject*)obj9362;
  uo9369->data[6] = emptyclosure;
  Method *meth_meth_ast_isImport9369 = addmethod2pos(obj9362, "isImport", &meth_ast_isImport9369, 6);
  int argcv_meth_ast_isImport9369[] = {0};
  meth_meth_ast_isImport9369->type = alloc_MethodType(1, argcv_meth_ast_isImport9369);
  meth_meth_ast_isImport9369->definitionModule = modulename;
  meth_meth_ast_isImport9369->definitionLine = 2257;
// method name
  struct UserObject *uo9371 = (struct UserObject*)obj9362;
  uo9371->data[7] = emptyclosure;
  Method *meth_meth_ast_name9371 = addmethod2pos(obj9362, "name", &meth_ast_name9371, 7);
  int argcv_meth_ast_name9371[] = {0};
  meth_meth_ast_name9371->type = alloc_MethodType(1, argcv_meth_ast_name9371);
  meth_meth_ast_name9371->definitionModule = modulename;
  meth_meth_ast_name9371->definitionLine = 2258;
// method nameString
  struct UserObject *uo9374 = (struct UserObject*)obj9362;
  uo9374->data[8] = emptyclosure;
  Method *meth_meth_ast_nameString9374 = addmethod2pos(obj9362, "nameString", &meth_ast_nameString9374, 8);
  int argcv_meth_ast_nameString9374[] = {0};
  meth_meth_ast_nameString9374->type = alloc_MethodType(1, argcv_meth_ast_nameString9374);
  meth_meth_ast_nameString9374->definitionModule = modulename;
  meth_meth_ast_nameString9374->definitionLine = 2259;
// method isPublic
  struct UserObject *uo9379 = (struct UserObject*)obj9362;
  uo9379->data[9] = emptyclosure;
  Method *meth_meth_ast_isPublic9379 = addmethod2pos(obj9362, "isPublic", &meth_ast_isPublic9379, 9);
  int argcv_meth_ast_isPublic9379[] = {0};
  meth_meth_ast_isPublic9379->type = alloc_MethodType(1, argcv_meth_ast_isPublic9379);
  meth_meth_ast_isPublic9379->definitionModule = modulename;
  meth_meth_ast_isPublic9379->definitionLine = 2260;
// method moduleName
  struct UserObject *uo9406 = (struct UserObject*)obj9362;
  uo9406->data[10] = emptyclosure;
  Method *meth_meth_ast_moduleName9406 = addmethod2pos(obj9362, "moduleName", &meth_ast_moduleName9406, 10);
  int argcv_meth_ast_moduleName9406[] = {0};
  meth_meth_ast_moduleName9406->type = alloc_MethodType(1, argcv_meth_ast_moduleName9406);
  meth_meth_ast_moduleName9406->definitionModule = modulename;
  meth_meth_ast_moduleName9406->definitionLine = 2266;
// method isWritable
  struct UserObject *uo9426 = (struct UserObject*)obj9362;
  uo9426->data[11] = emptyclosure;
  Method *meth_meth_ast_isWritable9426 = addmethod2pos(obj9362, "isWritable", &meth_ast_isWritable9426, 11);
  int argcv_meth_ast_isWritable9426[] = {0};
  meth_meth_ast_isWritable9426->type = alloc_MethodType(1, argcv_meth_ast_isWritable9426);
  meth_meth_ast_isWritable9426->definitionModule = modulename;
  meth_meth_ast_isWritable9426->definitionLine = 2277;
// method isReadable
  struct UserObject *uo9428 = (struct UserObject*)obj9362;
  uo9428->data[12] = emptyclosure;
  Method *meth_meth_ast_isReadable9428 = addmethod2pos(obj9362, "isReadable", &meth_ast_isReadable9428, 12);
  int argcv_meth_ast_isReadable9428[] = {0};
  meth_meth_ast_isReadable9428->type = alloc_MethodType(1, argcv_meth_ast_isReadable9428);
  meth_meth_ast_isReadable9428->definitionModule = modulename;
  meth_meth_ast_isReadable9428->definitionLine = 2278;
// method declarationKindWithAncestors
  struct UserObject *uo9431 = (struct UserObject*)obj9362;
  uo9431->data[13] = emptyclosure;
  Method *meth_meth_ast_declarationKindWithAncestors9431 = addmethod2pos(obj9362, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors9431, 13);
  int argcv_meth_ast_declarationKindWithAncestors9431[] = {1};
  meth_meth_ast_declarationKindWithAncestors9431->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors9431);
  meth_meth_ast_declarationKindWithAncestors9431->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors9431->definitionLine = 2279;
// method usesAsType
  struct UserObject *uo9433 = (struct UserObject*)obj9362;
  uo9433->data[14] = emptyclosure;
  Method *meth_meth_ast_usesAsType9433 = addmethod2pos(obj9362, "usesAsType", &meth_ast_usesAsType9433, 14);
  int argcv_meth_ast_usesAsType9433[] = {1};
  meth_meth_ast_usesAsType9433->type = alloc_MethodType(1, argcv_meth_ast_usesAsType9433);
  meth_meth_ast_usesAsType9433->definitionModule = modulename;
  meth_meth_ast_usesAsType9433->definitionLine = 2280;
// method accept()from
  struct UserObject *uo9439 = (struct UserObject*)obj9362;
  uo9439->data[15] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from9439 = addmethod2pos(obj9362, "accept()from", &meth_ast_accept_40__41_from9439, 15);
  int argcv_meth_ast_accept_40__41_from9439[] = {1, 1};
  meth_meth_ast_accept_40__41_from9439->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from9439);
  meth_meth_ast_accept_40__41_from9439->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from9439->definitionLine = 2283;
// method map()ancestors
  struct UserObject *uo9469 = (struct UserObject*)obj9362;
  uo9469->data[16] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors9469 = addmethod2pos(obj9362, "map()ancestors", &meth_ast_map_40__41_ancestors9469, 16);
  int argcv_meth_ast_map_40__41_ancestors9469[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors9469->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors9469);
  meth_meth_ast_map_40__41_ancestors9469->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors9469->definitionLine = 2295;
// method pretty
  struct UserObject *uo9502 = (struct UserObject*)obj9362;
  uo9502->data[17] = emptyclosure;
  Method *meth_meth_ast_pretty9502 = addmethod2pos(obj9362, "pretty", &meth_ast_pretty9502, 17);
  int argcv_meth_ast_pretty9502[] = {1};
  meth_meth_ast_pretty9502->type = alloc_MethodType(1, argcv_meth_ast_pretty9502);
  meth_meth_ast_pretty9502->definitionModule = modulename;
  meth_meth_ast_pretty9502->definitionLine = 2303;
// method toGrace
  struct UserObject *uo9596 = (struct UserObject*)obj9362;
  uo9596->data[18] = emptyclosure;
  Method *meth_meth_ast_toGrace9596 = addmethod2pos(obj9362, "toGrace", &meth_ast_toGrace9596, 18);
  int argcv_meth_ast_toGrace9596[] = {1};
  meth_meth_ast_toGrace9596->type = alloc_MethodType(1, argcv_meth_ast_toGrace9596);
meth_meth_ast_toGrace9596->type->types[0] = type_Number;
meth_meth_ast_toGrace9596->type->names[0] = "depth";
  meth_meth_ast_toGrace9596->definitionModule = modulename;
  meth_meth_ast_toGrace9596->definitionLine = 2316;
// method shallowCopy
  block_savedest(obj9362);
  Object closure9616 = createclosure(2, "shallowCopy");
  setclosureframe(closure9616, stackframe);
  addtoclosure(closure9616, var_nullNode);
  addtoclosure(closure9616, var_importNode);
  struct UserObject *uo9616 = (struct UserObject*)obj9362;
  uo9616->data[19] = (Object)closure9616;
  Method *meth_meth_ast_shallowCopy9616 = addmethod2pos(obj9362, "shallowCopy", &meth_ast_shallowCopy9616, 19);
  int argcv_meth_ast_shallowCopy9616[] = {0};
  meth_meth_ast_shallowCopy9616->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy9616);
  meth_meth_ast_shallowCopy9616->definitionModule = modulename;
  meth_meth_ast_shallowCopy9616->definitionLine = 2319;
  sourceObject = obj9362;
// Begin line 2251
  setline(2251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9624 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9625 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe9624);
// compiled call node returning call9625 (depth = 4)
  struct UserObject *obj9362_uo = (struct UserObject *)obj9362;
  obj9362_uo->super = call9625;
  sourceObject = obj9362;
// Begin line 2252
  setline(2252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit9626 == NULL) {
    strlit9626 = alloc_String("import");
    gc_root(strlit9626);
  }
// compiled string node returning strlit9626 (depth = 4)
  adddatum2(obj9362, strlit9626, 1);
  sourceObject = obj9362;
// Begin line 2253
  setline(2253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_name_39_ (depth = 4)
  adddatum2(obj9362, *var_name_39_, 2);
  sourceObject = obj9362;
// Begin line 2254
  setline(2254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_path_39_ (depth = 4)
  adddatum2(obj9362, *var_path_39_, 3);
  sourceObject = obj9362;
// Begin line 2255
  setline(2255);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9627 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9628 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call9629 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9628);
// compiled call node returning call9629 (depth = 7)
// compiled member node returning call9629 (depth = 6)
  partcv[0] = 0;
  Object call9630 = callmethod(call9629, "empty",
    1, partcv, params);
  gc_frame_end(callframe9627);
// compiled call node returning call9630 (depth = 5)
// compiled member node returning call9630 (depth = 4)
  adddatum2(obj9362, call9630, 4);
  sourceObject = obj9362;
// Begin line 2256
  setline(2256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_dtype_39_ (depth = 4)
  adddatum2(obj9362, *var_dtype_39_, 5);
  sourceObject = obj9362;
  sourceObject = obj9362;
  sourceObject = obj9362;
  sourceObject = obj9362;
  sourceObject = obj9362;
  sourceObject = obj9362;
  sourceObject = obj9362;
  sourceObject = obj9362;
  sourceObject = obj9362;
  sourceObject = obj9362;
  sourceObject = obj9362;
  sourceObject = obj9362;
  sourceObject = obj9362;
  sourceObject = obj9362;
  objclass9362 = obj9362->class;
  objclass9362->definitionModule = modulename;
  objclass9362->definitionLine = 2250;
  (*(struct UserObject *)self).data[0] = lowerouter9362;
  self = oldself9362;
  selfslot = oldselfslot9362;
  stackframe = oldstackframe9362;
  gc_frame_end(frame);
  return obj9362;
}
Object meth_ast_new9361_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_importNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_path_39_ = &(stackframe->slots[0]);
  *var_path_39_ = args[curarg];
  curarg++;
  Object *var_name_39_ = &(stackframe->slots[1]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9362 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9362 = alloc_userobj2(24,21, objclass9362);
  gc_frame_newslot(obj9362);
if (objclass9362 == NULL) {
  glfree(obj9362->class->name);
  obj9362->class->name = "importNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9362, self, 0);
  addmethodreal(obj9362,"outer", &reader_ast_outer_9363);
  Object oldself9362 = self;
  struct StackFrameObject *oldstackframe9362 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9362);
  gc_frame_newslot((Object)stackframe);
  self = obj9362;
  Object *oldselfslot9362 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9362 = (*(struct UserObject *)self).data[0], lowerouter9362 = thisouter9362;
  if (inheritingObject9362) {
    struct UserObject *inho9362 = (struct UserObject *)inheritingObject9362;
    while (inho9362->super != GraceDefaultObject) inho9362 = (struct UserObject *)inho9362->super;
    inho9362->super = obj9362;
    self = inheritingObject9362;
    *selfslot = self;
    lowerouter9362 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9362;
  }
if (objclass9362 == NULL) {
  Method *reader9364 = addmethodrealflags(obj9362, "kind",&reader_ast_kind_9364, MFLAG_DEF);
  reader9364->definitionModule = modulename;
  reader9364->definitionLine = 2252;
}
adddatum2(obj9362, alloc_Undefined(), 1);
if (objclass9362 == NULL) {
  Method *reader9365 = addmethodrealflags(obj9362, "value",&reader_ast_value_9365, 0);
  Method *writer9365 = addmethodrealflags(obj9362, "value:=",&writer_ast_value_9365, 0);
  reader9365->definitionModule = modulename;
  writer9365->definitionModule = modulename;
  reader9365->definitionLine = 2253;
  writer9365->definitionLine = 2253;
}
obj9362->flags |= OFLAG_MUTABLE;
adddatum2(obj9362, alloc_Undefined(), 2);
if (objclass9362 == NULL) {
  Method *reader9366 = addmethodrealflags(obj9362, "path",&reader_ast_path_9366, 0);
  Method *writer9366 = addmethodrealflags(obj9362, "path:=",&writer_ast_path_9366, 0);
  reader9366->definitionModule = modulename;
  writer9366->definitionModule = modulename;
  reader9366->definitionLine = 2254;
  writer9366->definitionLine = 2254;
}
obj9362->flags |= OFLAG_MUTABLE;
adddatum2(obj9362, alloc_Undefined(), 3);
if (objclass9362 == NULL) {
  Method *reader9367 = addmethodrealflags(obj9362, "annotations",&reader_ast_annotations_9367, 0);
  Method *writer9367 = addmethodrealflags(obj9362, "annotations:=",&writer_ast_annotations_9367, 0);
  reader9367->definitionModule = modulename;
  writer9367->definitionModule = modulename;
  reader9367->definitionLine = 2255;
  writer9367->definitionLine = 2255;
}
obj9362->flags |= OFLAG_MUTABLE;
adddatum2(obj9362, alloc_Undefined(), 4);
if (objclass9362 == NULL) {
  Method *reader9368 = addmethodrealflags(obj9362, "dtype",&reader_ast_dtype_9368, 0);
  Method *writer9368 = addmethodrealflags(obj9362, "dtype:=",&writer_ast_dtype_9368, 0);
  reader9368->definitionModule = modulename;
  writer9368->definitionModule = modulename;
  reader9368->definitionLine = 2256;
  writer9368->definitionLine = 2256;
}
obj9362->flags |= OFLAG_MUTABLE;
adddatum2(obj9362, alloc_Undefined(), 5);
// method isImport
  struct UserObject *uo9369 = (struct UserObject*)obj9362;
  uo9369->data[6] = emptyclosure;
  Method *meth_meth_ast_isImport9369 = addmethod2pos(obj9362, "isImport", &meth_ast_isImport9369, 6);
  int argcv_meth_ast_isImport9369[] = {0};
  meth_meth_ast_isImport9369->type = alloc_MethodType(1, argcv_meth_ast_isImport9369);
  meth_meth_ast_isImport9369->definitionModule = modulename;
  meth_meth_ast_isImport9369->definitionLine = 2257;
// method name
  struct UserObject *uo9371 = (struct UserObject*)obj9362;
  uo9371->data[7] = emptyclosure;
  Method *meth_meth_ast_name9371 = addmethod2pos(obj9362, "name", &meth_ast_name9371, 7);
  int argcv_meth_ast_name9371[] = {0};
  meth_meth_ast_name9371->type = alloc_MethodType(1, argcv_meth_ast_name9371);
  meth_meth_ast_name9371->definitionModule = modulename;
  meth_meth_ast_name9371->definitionLine = 2258;
// method nameString
  struct UserObject *uo9374 = (struct UserObject*)obj9362;
  uo9374->data[8] = emptyclosure;
  Method *meth_meth_ast_nameString9374 = addmethod2pos(obj9362, "nameString", &meth_ast_nameString9374, 8);
  int argcv_meth_ast_nameString9374[] = {0};
  meth_meth_ast_nameString9374->type = alloc_MethodType(1, argcv_meth_ast_nameString9374);
  meth_meth_ast_nameString9374->definitionModule = modulename;
  meth_meth_ast_nameString9374->definitionLine = 2259;
// method isPublic
  struct UserObject *uo9379 = (struct UserObject*)obj9362;
  uo9379->data[9] = emptyclosure;
  Method *meth_meth_ast_isPublic9379 = addmethod2pos(obj9362, "isPublic", &meth_ast_isPublic9379, 9);
  int argcv_meth_ast_isPublic9379[] = {0};
  meth_meth_ast_isPublic9379->type = alloc_MethodType(1, argcv_meth_ast_isPublic9379);
  meth_meth_ast_isPublic9379->definitionModule = modulename;
  meth_meth_ast_isPublic9379->definitionLine = 2260;
// method moduleName
  struct UserObject *uo9406 = (struct UserObject*)obj9362;
  uo9406->data[10] = emptyclosure;
  Method *meth_meth_ast_moduleName9406 = addmethod2pos(obj9362, "moduleName", &meth_ast_moduleName9406, 10);
  int argcv_meth_ast_moduleName9406[] = {0};
  meth_meth_ast_moduleName9406->type = alloc_MethodType(1, argcv_meth_ast_moduleName9406);
  meth_meth_ast_moduleName9406->definitionModule = modulename;
  meth_meth_ast_moduleName9406->definitionLine = 2266;
// method isWritable
  struct UserObject *uo9426 = (struct UserObject*)obj9362;
  uo9426->data[11] = emptyclosure;
  Method *meth_meth_ast_isWritable9426 = addmethod2pos(obj9362, "isWritable", &meth_ast_isWritable9426, 11);
  int argcv_meth_ast_isWritable9426[] = {0};
  meth_meth_ast_isWritable9426->type = alloc_MethodType(1, argcv_meth_ast_isWritable9426);
  meth_meth_ast_isWritable9426->definitionModule = modulename;
  meth_meth_ast_isWritable9426->definitionLine = 2277;
// method isReadable
  struct UserObject *uo9428 = (struct UserObject*)obj9362;
  uo9428->data[12] = emptyclosure;
  Method *meth_meth_ast_isReadable9428 = addmethod2pos(obj9362, "isReadable", &meth_ast_isReadable9428, 12);
  int argcv_meth_ast_isReadable9428[] = {0};
  meth_meth_ast_isReadable9428->type = alloc_MethodType(1, argcv_meth_ast_isReadable9428);
  meth_meth_ast_isReadable9428->definitionModule = modulename;
  meth_meth_ast_isReadable9428->definitionLine = 2278;
// method declarationKindWithAncestors
  struct UserObject *uo9431 = (struct UserObject*)obj9362;
  uo9431->data[13] = emptyclosure;
  Method *meth_meth_ast_declarationKindWithAncestors9431 = addmethod2pos(obj9362, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors9431, 13);
  int argcv_meth_ast_declarationKindWithAncestors9431[] = {1};
  meth_meth_ast_declarationKindWithAncestors9431->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors9431);
  meth_meth_ast_declarationKindWithAncestors9431->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors9431->definitionLine = 2279;
// method usesAsType
  struct UserObject *uo9433 = (struct UserObject*)obj9362;
  uo9433->data[14] = emptyclosure;
  Method *meth_meth_ast_usesAsType9433 = addmethod2pos(obj9362, "usesAsType", &meth_ast_usesAsType9433, 14);
  int argcv_meth_ast_usesAsType9433[] = {1};
  meth_meth_ast_usesAsType9433->type = alloc_MethodType(1, argcv_meth_ast_usesAsType9433);
  meth_meth_ast_usesAsType9433->definitionModule = modulename;
  meth_meth_ast_usesAsType9433->definitionLine = 2280;
// method accept()from
  struct UserObject *uo9439 = (struct UserObject*)obj9362;
  uo9439->data[15] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from9439 = addmethod2pos(obj9362, "accept()from", &meth_ast_accept_40__41_from9439, 15);
  int argcv_meth_ast_accept_40__41_from9439[] = {1, 1};
  meth_meth_ast_accept_40__41_from9439->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from9439);
  meth_meth_ast_accept_40__41_from9439->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from9439->definitionLine = 2283;
// method map()ancestors
  struct UserObject *uo9469 = (struct UserObject*)obj9362;
  uo9469->data[16] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors9469 = addmethod2pos(obj9362, "map()ancestors", &meth_ast_map_40__41_ancestors9469, 16);
  int argcv_meth_ast_map_40__41_ancestors9469[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors9469->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors9469);
  meth_meth_ast_map_40__41_ancestors9469->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors9469->definitionLine = 2295;
// method pretty
  struct UserObject *uo9502 = (struct UserObject*)obj9362;
  uo9502->data[17] = emptyclosure;
  Method *meth_meth_ast_pretty9502 = addmethod2pos(obj9362, "pretty", &meth_ast_pretty9502, 17);
  int argcv_meth_ast_pretty9502[] = {1};
  meth_meth_ast_pretty9502->type = alloc_MethodType(1, argcv_meth_ast_pretty9502);
  meth_meth_ast_pretty9502->definitionModule = modulename;
  meth_meth_ast_pretty9502->definitionLine = 2303;
// method toGrace
  struct UserObject *uo9596 = (struct UserObject*)obj9362;
  uo9596->data[18] = emptyclosure;
  Method *meth_meth_ast_toGrace9596 = addmethod2pos(obj9362, "toGrace", &meth_ast_toGrace9596, 18);
  int argcv_meth_ast_toGrace9596[] = {1};
  meth_meth_ast_toGrace9596->type = alloc_MethodType(1, argcv_meth_ast_toGrace9596);
meth_meth_ast_toGrace9596->type->types[0] = type_Number;
meth_meth_ast_toGrace9596->type->names[0] = "depth";
  meth_meth_ast_toGrace9596->definitionModule = modulename;
  meth_meth_ast_toGrace9596->definitionLine = 2316;
// method shallowCopy
  block_savedest(obj9362);
  Object closure9616 = createclosure(2, "shallowCopy");
  setclosureframe(closure9616, stackframe);
  addtoclosure(closure9616, var_nullNode);
  addtoclosure(closure9616, var_importNode);
  struct UserObject *uo9616 = (struct UserObject*)obj9362;
  uo9616->data[19] = (Object)closure9616;
  Method *meth_meth_ast_shallowCopy9616 = addmethod2pos(obj9362, "shallowCopy", &meth_ast_shallowCopy9616, 19);
  int argcv_meth_ast_shallowCopy9616[] = {0};
  meth_meth_ast_shallowCopy9616->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy9616);
  meth_meth_ast_shallowCopy9616->definitionModule = modulename;
  meth_meth_ast_shallowCopy9616->definitionLine = 2319;
  sourceObject = obj9362;
// Begin line 2251
  setline(2251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9624 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9625 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe9624);
// compiled call node returning call9625 (depth = 4)
  struct UserObject *obj9362_uo = (struct UserObject *)obj9362;
  obj9362_uo->super = call9625;
  sourceObject = obj9362;
// Begin line 2252
  setline(2252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit9626 == NULL) {
    strlit9626 = alloc_String("import");
    gc_root(strlit9626);
  }
// compiled string node returning strlit9626 (depth = 4)
  adddatum2(obj9362, strlit9626, 1);
  sourceObject = obj9362;
// Begin line 2253
  setline(2253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_name_39_ (depth = 4)
  adddatum2(obj9362, *var_name_39_, 2);
  sourceObject = obj9362;
// Begin line 2254
  setline(2254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_path_39_ (depth = 4)
  adddatum2(obj9362, *var_path_39_, 3);
  sourceObject = obj9362;
// Begin line 2255
  setline(2255);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9627 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9628 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call9629 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9628);
// compiled call node returning call9629 (depth = 7)
// compiled member node returning call9629 (depth = 6)
  partcv[0] = 0;
  Object call9630 = callmethod(call9629, "empty",
    1, partcv, params);
  gc_frame_end(callframe9627);
// compiled call node returning call9630 (depth = 5)
// compiled member node returning call9630 (depth = 4)
  adddatum2(obj9362, call9630, 4);
  sourceObject = obj9362;
// Begin line 2256
  setline(2256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_dtype_39_ (depth = 4)
  adddatum2(obj9362, *var_dtype_39_, 5);
  sourceObject = obj9362;
  sourceObject = obj9362;
  sourceObject = obj9362;
  sourceObject = obj9362;
  sourceObject = obj9362;
  sourceObject = obj9362;
  sourceObject = obj9362;
  sourceObject = obj9362;
  sourceObject = obj9362;
  sourceObject = obj9362;
  sourceObject = obj9362;
  sourceObject = obj9362;
  sourceObject = obj9362;
  sourceObject = obj9362;
  objclass9362 = obj9362->class;
  objclass9362->definitionModule = modulename;
  objclass9362->definitionLine = 2250;
  (*(struct UserObject *)self).data[0] = lowerouter9362;
  self = oldself9362;
  selfslot = oldselfslot9362;
  stackframe = oldstackframe9362;
  gc_frame_end(frame);
  return obj9362;
}
Object meth_ast_dialectNode9632(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 43, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dialectNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_dialectNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for dialectNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for dialectNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dialectNode (depth = 3)
  gc_frame_end(frame);
  return *var_dialectNode;
}
Object meth_ast_isDialect9640(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isDialect");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isDialect (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isDialect");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2328
  setline(2328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool9641 = alloc_Boolean(1);
// compiled identifier node returning bool9641 (depth = 4)
  gc_frame_end(frame);
  return bool9641;
}
Object meth_ast__apply9648(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_bnm = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2332
  setline(2332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9651 == NULL) {
    strlit9651 = alloc_String("/");
    gc_root(strlit9651);
  }
// compiled string node returning strlit9651 (depth = 8)
  int op_slot_right_9650 = gc_frame_newslot(strlit9651);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  int op_slot_left_9650 = gc_frame_newslot(*var_c);
  params[0] = strlit9651;
  partcv[0] = 1;
  Object opresult9653 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult9653 (depth = 7)
  Object if9649 = done;
  if (istrue(opresult9653)) {
// Begin line 2333
  setline(2333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9654 == NULL) {
    strlit9654 = alloc_String("");
    gc_root(strlit9654);
  }
// compiled string node returning strlit9654 (depth = 8)
  *var_bnm = strlit9654;
  if (strlit9654 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if9649 = done;
  } else {
// Begin line 2335
  setline(2335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_c (depth = 9)
  int op_slot_right_9656 = gc_frame_newslot(*var_c);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_bnm (depth = 9)
  int op_slot_left_9656 = gc_frame_newslot(*var_bnm);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult9658 = callmethod(*var_bnm, "++", 1, partcv, params);
// compiled op node returning opresult9658 (depth = 8)
  *var_bnm = opresult9658;
  if (opresult9658 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if9649 = done;
  }
// compiled if node returning if9649 (depth = 6)
  gc_frame_end(frame);
  return if9649;
}
Object meth_ast_moduleName9642(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "moduleName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for moduleName (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for moduleName");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_bnm = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "bnm");
// Begin line 2330
  setline(2330);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9643 == NULL) {
    strlit9643 = alloc_String("");
    gc_root(strlit9643);
  }
// compiled string node returning strlit9643 (depth = 5)
  *var_bnm = strlit9643;
  if (strlit9643 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2331
  setline(2331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9644 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9645 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9646 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9645);
// compiled call node returning call9646 (depth = 6)
// compiled member node returning call9646 (depth = 5)
  gc_frame_newslot(call9646);
// starting to compile block node (depth = 5)
  Object block9647 = alloc_Block(NULL, NULL, "ast", 2331);
  gc_frame_newslot(block9647);
// method _apply
  block_savedest(block9647);
  Object closure9648 = createclosure(2, "_apply");
  setclosureframe(closure9648, stackframe);
  addtoclosure(closure9648, var_bnm);
  addtoclosure(closure9648, selfslot);
  struct UserObject *uo9648 = (struct UserObject*)block9647;
  uo9648->data[0] = (Object)closure9648;
  Method *meth_meth_ast__apply9648 = addmethod2pos(block9647, "_apply", &meth_ast__apply9648, 0);
  int argcv_meth_ast__apply9648[] = {1};
  meth_meth_ast__apply9648->type = alloc_MethodType(1, argcv_meth_ast__apply9648);
  meth_meth_ast__apply9648->definitionModule = modulename;
  meth_meth_ast__apply9648->definitionLine = 2331;
// compiled block node returning block9647 (depth = 5)
  gc_frame_newslot(block9647);
// call case 5: prelude request
  params[0] = call9646;
  params[1] = block9647;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9661 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9644);
// compiled call node returning call9661 (depth = 4)
// Begin line 2338
  setline(2338);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_bnm (depth = 4)
  gc_frame_end(frame);
  return *var_bnm;
}
Object meth_ast_path9662(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "path");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for path (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for path");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2341
  setline(2341);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9663 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9664 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9663);
// compiled call node returning call9664 (depth = 5)
// compiled member node returning call9664 (depth = 4)
  gc_frame_end(frame);
  return call9664;
}
Object meth_ast_accept_40__41_from9665(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2344
  setline(2344);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9666 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9667 = callmethod(*var_visitor, "visitDialect()up",
    2, partcv, params);
  gc_frame_end(callframe9666);
// compiled call node returning call9667 (depth = 4)
  gc_frame_end(frame);
  return call9667;
}
Object meth_ast_map_40__41_ancestors9668(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2347
  setline(2347);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9669 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9670 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9669);
// compiled call node returning call9670 (depth = 6)
// compiled member node returning call9670 (depth = 5)
  *var_n = call9670;
  if (call9670 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2348
  setline(2348);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9671 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call9672 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe9671);
// compiled call node returning call9672 (depth = 5)
  *var_newChain = call9672;
  if (call9672 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2349
  setline(2349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9673 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call9674 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe9673);
// compiled call node returning call9674 (depth = 4)
  gc_frame_end(frame);
  return call9674;
}
Object meth_ast__apply9683(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2354
  setline(2354);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9685 == NULL) {
    strlit9685 = alloc_String("  ");
    gc_root(strlit9685);
  }
// compiled string node returning strlit9685 (depth = 8)
  int op_slot_right_9684 = gc_frame_newslot(strlit9685);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_9684 = gc_frame_newslot(*var_spc);
  params[0] = strlit9685;
  partcv[0] = 1;
  Object opresult9687 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult9687 (depth = 7)
  *var_spc = opresult9687;
  if (opresult9687 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty9675(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2352
  setline(2352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9676 == NULL) {
    strlit9676 = alloc_String("");
    gc_root(strlit9676);
  }
// compiled string node returning strlit9676 (depth = 5)
  *var_spc = strlit9676;
  if (strlit9676 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2353
  setline(2353);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9677 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_right_9678 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 6)
  Object num9680 = alloc_Float64(0);
// compiled num node returning num9680 (depth = 6)
  int op_slot_left_9678 = gc_frame_newslot(num9680);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult9681 = callmethod(num9680, "..", 1, partcv, params);
// compiled op node returning opresult9681 (depth = 5)
  gc_frame_newslot(opresult9681);
// starting to compile block node (depth = 5)
  Object block9682 = alloc_Block(NULL, NULL, "ast", 2353);
  gc_frame_newslot(block9682);
// method _apply
  block_savedest(block9682);
  Object closure9683 = createclosure(2, "_apply");
  setclosureframe(closure9683, stackframe);
  addtoclosure(closure9683, var_spc);
  addtoclosure(closure9683, selfslot);
  struct UserObject *uo9683 = (struct UserObject*)block9682;
  uo9683->data[0] = (Object)closure9683;
  Method *meth_meth_ast__apply9683 = addmethod2pos(block9682, "_apply", &meth_ast__apply9683, 0);
  int argcv_meth_ast__apply9683[] = {1};
  meth_meth_ast__apply9683->type = alloc_MethodType(1, argcv_meth_ast__apply9683);
  meth_meth_ast__apply9683->definitionModule = modulename;
  meth_meth_ast__apply9683->definitionLine = 2347;
// compiled block node returning block9682 (depth = 5)
  gc_frame_newslot(block9682);
// call case 5: prelude request
  params[0] = opresult9681;
  params[1] = block9682;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9690 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9677);
// compiled call node returning call9690 (depth = 4)
// Begin line 2356
  setline(2356);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9692 == NULL) {
    strlit9692 = alloc_String("""\x0a""");
    gc_root(strlit9692);
  }
// compiled string node returning strlit9692 (depth = 6)
  int op_slot_right_9691 = gc_frame_newslot(strlit9692);
// starting to compile call node (depth = 6)
  int callframe9694 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call9695 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe9694);
// compiled call node returning call9695 (depth = 6)
  int op_slot_left_9691 = gc_frame_newslot(call9695);
  params[0] = strlit9692;
  partcv[0] = 1;
  Object opresult9696 = callmethod(call9695, "++", 1, partcv, params);
// compiled op node returning opresult9696 (depth = 5)
  *var_s = opresult9696;
  if (opresult9696 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2357
  setline(2357);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9699 == NULL) {
    strlit9699 = alloc_String("""\x0a""");
    gc_root(strlit9699);
  }
// compiled string node returning strlit9699 (depth = 7)
  int op_slot_right_9698 = gc_frame_newslot(strlit9699);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9702 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9703 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9702);
// compiled call node returning call9703 (depth = 9)
// compiled member node returning call9703 (depth = 8)
  int op_slot_right_9701 = gc_frame_newslot(call9703);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9706 == NULL) {
    strlit9706 = alloc_String("Path: ");
    gc_root(strlit9706);
  }
// compiled string node returning strlit9706 (depth = 9)
  int op_slot_right_9705 = gc_frame_newslot(strlit9706);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_9708 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 10)
  if (strlit9710 == NULL) {
    strlit9710 = alloc_String("");
    gc_root(strlit9710);
  }
// compiled string node returning strlit9710 (depth = 10)
  int op_slot_left_9708 = gc_frame_newslot(strlit9710);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9711 = callmethod(strlit9710, "++", 1, partcv, params);
// compiled op node returning opresult9711 (depth = 9)
  int op_slot_left_9705 = gc_frame_newslot(opresult9711);
  params[0] = strlit9706;
  partcv[0] = 1;
  Object opresult9712 = callmethod(opresult9711, "++", 1, partcv, params);
// compiled op node returning opresult9712 (depth = 8)
  int op_slot_left_9701 = gc_frame_newslot(opresult9712);
  params[0] = call9703;
  partcv[0] = 1;
  Object opresult9713 = callmethod(opresult9712, "++", 1, partcv, params);
// compiled op node returning opresult9713 (depth = 7)
  int op_slot_left_9698 = gc_frame_newslot(opresult9713);
  params[0] = strlit9699;
  partcv[0] = 1;
  Object opresult9714 = callmethod(opresult9713, "++", 1, partcv, params);
// compiled op node returning opresult9714 (depth = 6)
  int op_slot_right_9697 = gc_frame_newslot(opresult9714);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_9697 = gc_frame_newslot(*var_s);
  params[0] = opresult9714;
  partcv[0] = 1;
  Object opresult9716 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult9716 (depth = 5)
  *var_s = opresult9716;
  if (opresult9716 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2358
  setline(2358);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_toGrace9718(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2361
  setline(2361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9720 == NULL) {
    strlit9720 = alloc_String("""\x22""");
    gc_root(strlit9720);
  }
// compiled string node returning strlit9720 (depth = 5)
  int op_slot_right_9719 = gc_frame_newslot(strlit9720);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9723 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9724 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9723);
// compiled call node returning call9724 (depth = 7)
// compiled member node returning call9724 (depth = 6)
  int op_slot_right_9722 = gc_frame_newslot(call9724);
// starting to compile string node (depth = 6)
  if (strlit9726 == NULL) {
    strlit9726 = alloc_String("dialect ""\x22""");
    gc_root(strlit9726);
  }
// compiled string node returning strlit9726 (depth = 6)
  int op_slot_left_9722 = gc_frame_newslot(strlit9726);
  params[0] = call9724;
  partcv[0] = 1;
  Object opresult9727 = callmethod(strlit9726, "++", 1, partcv, params);
// compiled op node returning opresult9727 (depth = 5)
  int op_slot_left_9719 = gc_frame_newslot(opresult9727);
  params[0] = strlit9720;
  partcv[0] = 1;
  Object opresult9728 = callmethod(opresult9727, "++", 1, partcv, params);
// compiled op node returning opresult9728 (depth = 4)
  gc_frame_end(frame);
  return opresult9728;
}
Object meth_ast_shallowCopy9729(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_dialectNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2364
  setline(2364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9730 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe9731 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9732 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9733 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9732);
// compiled call node returning call9733 (depth = 7)
// compiled member node returning call9733 (depth = 6)
  gc_frame_newslot(call9733);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_dialectNode (depth = 6)
  params[0] = call9733;
  partcv[0] = 1;
  Object call9734 = callmethod(*var_dialectNode, "new",
    1, partcv, params);
  gc_frame_end(callframe9731);
// compiled call node returning call9734 (depth = 5)
  params[0] = self;
  partcv[0] = 1;
  Object call9735 = callmethod(call9734, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe9730);
// compiled call node returning call9735 (depth = 4)
  gc_frame_end(frame);
  return call9735;
}
Object meth_ast_new9635(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_dialectNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_path_39_ = &(stackframe->slots[0]);
  *var_path_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9636 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9636 = alloc_userobj2(12,12, objclass9636);
  gc_frame_newslot(obj9636);
if (objclass9636 == NULL) {
  glfree(obj9636->class->name);
  obj9636->class->name = "dialectNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9636, self, 0);
  addmethodreal(obj9636,"outer", &reader_ast_outer_9637);
  Object oldself9636 = self;
  struct StackFrameObject *oldstackframe9636 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9636);
  gc_frame_newslot((Object)stackframe);
  self = obj9636;
  Object *oldselfslot9636 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9636 = (*(struct UserObject *)self).data[0], lowerouter9636 = thisouter9636;
  if (inheritingObject9636) {
    struct UserObject *inho9636 = (struct UserObject *)inheritingObject9636;
    while (inho9636->super != GraceDefaultObject) inho9636 = (struct UserObject *)inho9636->super;
    inho9636->super = obj9636;
    self = inheritingObject9636;
    *selfslot = self;
    lowerouter9636 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9636;
  }
if (objclass9636 == NULL) {
  Method *reader9638 = addmethodrealflags(obj9636, "kind",&reader_ast_kind_9638, MFLAG_DEF);
  reader9638->definitionModule = modulename;
  reader9638->definitionLine = 2325;
}
adddatum2(obj9636, alloc_Undefined(), 1);
if (objclass9636 == NULL) {
  Method *reader9639 = addmethodrealflags(obj9636, "value",&reader_ast_value_9639, 0);
  Method *writer9639 = addmethodrealflags(obj9636, "value:=",&writer_ast_value_9639, 0);
  reader9639->definitionModule = modulename;
  writer9639->definitionModule = modulename;
  reader9639->definitionLine = 2326;
  writer9639->definitionLine = 2326;
}
obj9636->flags |= OFLAG_MUTABLE;
adddatum2(obj9636, alloc_Undefined(), 2);
// method isDialect
  struct UserObject *uo9640 = (struct UserObject*)obj9636;
  uo9640->data[3] = emptyclosure;
  Method *meth_meth_ast_isDialect9640 = addmethod2pos(obj9636, "isDialect", &meth_ast_isDialect9640, 3);
  int argcv_meth_ast_isDialect9640[] = {0};
  meth_meth_ast_isDialect9640->type = alloc_MethodType(1, argcv_meth_ast_isDialect9640);
  meth_meth_ast_isDialect9640->definitionModule = modulename;
  meth_meth_ast_isDialect9640->definitionLine = 2328;
// method moduleName
  struct UserObject *uo9642 = (struct UserObject*)obj9636;
  uo9642->data[4] = emptyclosure;
  Method *meth_meth_ast_moduleName9642 = addmethod2pos(obj9636, "moduleName", &meth_ast_moduleName9642, 4);
  int argcv_meth_ast_moduleName9642[] = {0};
  meth_meth_ast_moduleName9642->type = alloc_MethodType(1, argcv_meth_ast_moduleName9642);
  meth_meth_ast_moduleName9642->definitionModule = modulename;
  meth_meth_ast_moduleName9642->definitionLine = 2329;
// method path
  struct UserObject *uo9662 = (struct UserObject*)obj9636;
  uo9662->data[5] = emptyclosure;
  Method *meth_meth_ast_path9662 = addmethod2pos(obj9636, "path", &meth_ast_path9662, 5);
  int argcv_meth_ast_path9662[] = {0};
  meth_meth_ast_path9662->type = alloc_MethodType(1, argcv_meth_ast_path9662);
  meth_meth_ast_path9662->definitionModule = modulename;
  meth_meth_ast_path9662->definitionLine = 2340;
// method accept()from
  struct UserObject *uo9665 = (struct UserObject*)obj9636;
  uo9665->data[6] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from9665 = addmethod2pos(obj9636, "accept()from", &meth_ast_accept_40__41_from9665, 6);
  int argcv_meth_ast_accept_40__41_from9665[] = {1, 1};
  meth_meth_ast_accept_40__41_from9665->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from9665);
  meth_meth_ast_accept_40__41_from9665->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from9665->definitionLine = 2343;
// method map()ancestors
  struct UserObject *uo9668 = (struct UserObject*)obj9636;
  uo9668->data[7] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors9668 = addmethod2pos(obj9636, "map()ancestors", &meth_ast_map_40__41_ancestors9668, 7);
  int argcv_meth_ast_map_40__41_ancestors9668[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors9668->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors9668);
  meth_meth_ast_map_40__41_ancestors9668->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors9668->definitionLine = 2346;
// method pretty
  struct UserObject *uo9675 = (struct UserObject*)obj9636;
  uo9675->data[8] = emptyclosure;
  Method *meth_meth_ast_pretty9675 = addmethod2pos(obj9636, "pretty", &meth_ast_pretty9675, 8);
  int argcv_meth_ast_pretty9675[] = {1};
  meth_meth_ast_pretty9675->type = alloc_MethodType(1, argcv_meth_ast_pretty9675);
  meth_meth_ast_pretty9675->definitionModule = modulename;
  meth_meth_ast_pretty9675->definitionLine = 2351;
// method toGrace
  struct UserObject *uo9718 = (struct UserObject*)obj9636;
  uo9718->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace9718 = addmethod2pos(obj9636, "toGrace", &meth_ast_toGrace9718, 9);
  int argcv_meth_ast_toGrace9718[] = {1};
  meth_meth_ast_toGrace9718->type = alloc_MethodType(1, argcv_meth_ast_toGrace9718);
meth_meth_ast_toGrace9718->type->types[0] = type_Number;
meth_meth_ast_toGrace9718->type->names[0] = "depth";
  meth_meth_ast_toGrace9718->definitionModule = modulename;
  meth_meth_ast_toGrace9718->definitionLine = 2360;
// method shallowCopy
  block_savedest(obj9636);
  Object closure9729 = createclosure(1, "shallowCopy");
  setclosureframe(closure9729, stackframe);
  addtoclosure(closure9729, var_dialectNode);
  struct UserObject *uo9729 = (struct UserObject*)obj9636;
  uo9729->data[10] = (Object)closure9729;
  Method *meth_meth_ast_shallowCopy9729 = addmethod2pos(obj9636, "shallowCopy", &meth_ast_shallowCopy9729, 10);
  int argcv_meth_ast_shallowCopy9729[] = {0};
  meth_meth_ast_shallowCopy9729->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy9729);
  meth_meth_ast_shallowCopy9729->definitionModule = modulename;
  meth_meth_ast_shallowCopy9729->definitionLine = 2363;
  sourceObject = obj9636;
// Begin line 2324
  setline(2324);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9736 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9737 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe9736);
// compiled call node returning call9737 (depth = 4)
  struct UserObject *obj9636_uo = (struct UserObject *)obj9636;
  obj9636_uo->super = call9737;
  sourceObject = obj9636;
// Begin line 2325
  setline(2325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit9738 == NULL) {
    strlit9738 = alloc_String("dialect");
    gc_root(strlit9738);
  }
// compiled string node returning strlit9738 (depth = 4)
  adddatum2(obj9636, strlit9738, 1);
  sourceObject = obj9636;
// Begin line 2326
  setline(2326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_path_39_ (depth = 4)
  adddatum2(obj9636, *var_path_39_, 2);
  sourceObject = obj9636;
  sourceObject = obj9636;
  sourceObject = obj9636;
  sourceObject = obj9636;
  sourceObject = obj9636;
  sourceObject = obj9636;
  sourceObject = obj9636;
  sourceObject = obj9636;
  objclass9636 = obj9636->class;
  objclass9636->definitionModule = modulename;
  objclass9636->definitionLine = 2323;
  (*(struct UserObject *)self).data[0] = lowerouter9636;
  self = oldself9636;
  selfslot = oldselfslot9636;
  stackframe = oldstackframe9636;
  gc_frame_end(frame);
  return obj9636;
}
Object meth_ast_new9635_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_dialectNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_path_39_ = &(stackframe->slots[0]);
  *var_path_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9636 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9636 = alloc_userobj2(12,12, objclass9636);
  gc_frame_newslot(obj9636);
if (objclass9636 == NULL) {
  glfree(obj9636->class->name);
  obj9636->class->name = "dialectNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9636, self, 0);
  addmethodreal(obj9636,"outer", &reader_ast_outer_9637);
  Object oldself9636 = self;
  struct StackFrameObject *oldstackframe9636 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9636);
  gc_frame_newslot((Object)stackframe);
  self = obj9636;
  Object *oldselfslot9636 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9636 = (*(struct UserObject *)self).data[0], lowerouter9636 = thisouter9636;
  if (inheritingObject9636) {
    struct UserObject *inho9636 = (struct UserObject *)inheritingObject9636;
    while (inho9636->super != GraceDefaultObject) inho9636 = (struct UserObject *)inho9636->super;
    inho9636->super = obj9636;
    self = inheritingObject9636;
    *selfslot = self;
    lowerouter9636 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9636;
  }
if (objclass9636 == NULL) {
  Method *reader9638 = addmethodrealflags(obj9636, "kind",&reader_ast_kind_9638, MFLAG_DEF);
  reader9638->definitionModule = modulename;
  reader9638->definitionLine = 2325;
}
adddatum2(obj9636, alloc_Undefined(), 1);
if (objclass9636 == NULL) {
  Method *reader9639 = addmethodrealflags(obj9636, "value",&reader_ast_value_9639, 0);
  Method *writer9639 = addmethodrealflags(obj9636, "value:=",&writer_ast_value_9639, 0);
  reader9639->definitionModule = modulename;
  writer9639->definitionModule = modulename;
  reader9639->definitionLine = 2326;
  writer9639->definitionLine = 2326;
}
obj9636->flags |= OFLAG_MUTABLE;
adddatum2(obj9636, alloc_Undefined(), 2);
// method isDialect
  struct UserObject *uo9640 = (struct UserObject*)obj9636;
  uo9640->data[3] = emptyclosure;
  Method *meth_meth_ast_isDialect9640 = addmethod2pos(obj9636, "isDialect", &meth_ast_isDialect9640, 3);
  int argcv_meth_ast_isDialect9640[] = {0};
  meth_meth_ast_isDialect9640->type = alloc_MethodType(1, argcv_meth_ast_isDialect9640);
  meth_meth_ast_isDialect9640->definitionModule = modulename;
  meth_meth_ast_isDialect9640->definitionLine = 2328;
// method moduleName
  struct UserObject *uo9642 = (struct UserObject*)obj9636;
  uo9642->data[4] = emptyclosure;
  Method *meth_meth_ast_moduleName9642 = addmethod2pos(obj9636, "moduleName", &meth_ast_moduleName9642, 4);
  int argcv_meth_ast_moduleName9642[] = {0};
  meth_meth_ast_moduleName9642->type = alloc_MethodType(1, argcv_meth_ast_moduleName9642);
  meth_meth_ast_moduleName9642->definitionModule = modulename;
  meth_meth_ast_moduleName9642->definitionLine = 2329;
// method path
  struct UserObject *uo9662 = (struct UserObject*)obj9636;
  uo9662->data[5] = emptyclosure;
  Method *meth_meth_ast_path9662 = addmethod2pos(obj9636, "path", &meth_ast_path9662, 5);
  int argcv_meth_ast_path9662[] = {0};
  meth_meth_ast_path9662->type = alloc_MethodType(1, argcv_meth_ast_path9662);
  meth_meth_ast_path9662->definitionModule = modulename;
  meth_meth_ast_path9662->definitionLine = 2340;
// method accept()from
  struct UserObject *uo9665 = (struct UserObject*)obj9636;
  uo9665->data[6] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from9665 = addmethod2pos(obj9636, "accept()from", &meth_ast_accept_40__41_from9665, 6);
  int argcv_meth_ast_accept_40__41_from9665[] = {1, 1};
  meth_meth_ast_accept_40__41_from9665->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from9665);
  meth_meth_ast_accept_40__41_from9665->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from9665->definitionLine = 2343;
// method map()ancestors
  struct UserObject *uo9668 = (struct UserObject*)obj9636;
  uo9668->data[7] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors9668 = addmethod2pos(obj9636, "map()ancestors", &meth_ast_map_40__41_ancestors9668, 7);
  int argcv_meth_ast_map_40__41_ancestors9668[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors9668->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors9668);
  meth_meth_ast_map_40__41_ancestors9668->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors9668->definitionLine = 2346;
// method pretty
  struct UserObject *uo9675 = (struct UserObject*)obj9636;
  uo9675->data[8] = emptyclosure;
  Method *meth_meth_ast_pretty9675 = addmethod2pos(obj9636, "pretty", &meth_ast_pretty9675, 8);
  int argcv_meth_ast_pretty9675[] = {1};
  meth_meth_ast_pretty9675->type = alloc_MethodType(1, argcv_meth_ast_pretty9675);
  meth_meth_ast_pretty9675->definitionModule = modulename;
  meth_meth_ast_pretty9675->definitionLine = 2351;
// method toGrace
  struct UserObject *uo9718 = (struct UserObject*)obj9636;
  uo9718->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace9718 = addmethod2pos(obj9636, "toGrace", &meth_ast_toGrace9718, 9);
  int argcv_meth_ast_toGrace9718[] = {1};
  meth_meth_ast_toGrace9718->type = alloc_MethodType(1, argcv_meth_ast_toGrace9718);
meth_meth_ast_toGrace9718->type->types[0] = type_Number;
meth_meth_ast_toGrace9718->type->names[0] = "depth";
  meth_meth_ast_toGrace9718->definitionModule = modulename;
  meth_meth_ast_toGrace9718->definitionLine = 2360;
// method shallowCopy
  block_savedest(obj9636);
  Object closure9729 = createclosure(1, "shallowCopy");
  setclosureframe(closure9729, stackframe);
  addtoclosure(closure9729, var_dialectNode);
  struct UserObject *uo9729 = (struct UserObject*)obj9636;
  uo9729->data[10] = (Object)closure9729;
  Method *meth_meth_ast_shallowCopy9729 = addmethod2pos(obj9636, "shallowCopy", &meth_ast_shallowCopy9729, 10);
  int argcv_meth_ast_shallowCopy9729[] = {0};
  meth_meth_ast_shallowCopy9729->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy9729);
  meth_meth_ast_shallowCopy9729->definitionModule = modulename;
  meth_meth_ast_shallowCopy9729->definitionLine = 2363;
  sourceObject = obj9636;
// Begin line 2324
  setline(2324);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9736 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9737 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe9736);
// compiled call node returning call9737 (depth = 4)
  struct UserObject *obj9636_uo = (struct UserObject *)obj9636;
  obj9636_uo->super = call9737;
  sourceObject = obj9636;
// Begin line 2325
  setline(2325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit9738 == NULL) {
    strlit9738 = alloc_String("dialect");
    gc_root(strlit9738);
  }
// compiled string node returning strlit9738 (depth = 4)
  adddatum2(obj9636, strlit9738, 1);
  sourceObject = obj9636;
// Begin line 2326
  setline(2326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_path_39_ (depth = 4)
  adddatum2(obj9636, *var_path_39_, 2);
  sourceObject = obj9636;
  sourceObject = obj9636;
  sourceObject = obj9636;
  sourceObject = obj9636;
  sourceObject = obj9636;
  sourceObject = obj9636;
  sourceObject = obj9636;
  sourceObject = obj9636;
  objclass9636 = obj9636->class;
  objclass9636->definitionModule = modulename;
  objclass9636->definitionLine = 2323;
  (*(struct UserObject *)self).data[0] = lowerouter9636;
  self = oldself9636;
  selfslot = oldselfslot9636;
  stackframe = oldstackframe9636;
  gc_frame_end(frame);
  return obj9636;
}
Object meth_ast_returnNode9740(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 44, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "returnNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_returnNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for returnNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for returnNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_returnNode (depth = 3)
  gc_frame_end(frame);
  return *var_returnNode;
}
Object meth_ast_accept_40__41_from9748(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 2373
  setline(2373);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9750 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9751 = callmethod(*var_visitor, "visitReturn()up",
    2, partcv, params);
  gc_frame_end(callframe9750);
// compiled call node returning call9751 (depth = 5)
  Object if9749 = done;
  if (istrue(call9751)) {
// Begin line 2374
  setline(2374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9752 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_as (depth = 7)
  params[0] = self;
  partcv[0] = 1;
  Object call9753 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe9752);
// compiled call node returning call9753 (depth = 6)
  *var_newChain = call9753;
  if (call9753 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2375
  setline(2375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9754 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9755 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9756 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9755);
// compiled call node returning call9756 (depth = 7)
// compiled member node returning call9756 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9757 = callmethod(call9756, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe9754);
// compiled call node returning call9757 (depth = 5)
    gc_frame_newslot(call9757);
    if9749 = call9757;
  } else {
  }
// compiled if node returning if9749 (depth = 4)
  gc_frame_end(frame);
  return if9749;
}
Object meth_ast_map_40__41_ancestors9758(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2379
  setline(2379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9759 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9760 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9759);
// compiled call node returning call9760 (depth = 6)
// compiled member node returning call9760 (depth = 5)
  *var_n = call9760;
  if (call9760 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2380
  setline(2380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9761 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call9762 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe9761);
// compiled call node returning call9762 (depth = 5)
  *var_newChain = call9762;
  if (call9762 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2381
  setline(2381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2379
  setline(2379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9763 = gc_frame_new();
// Begin line 2381
  setline(2381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9764 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9765 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9766 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9765);
// compiled call node returning call9766 (depth = 8)
// compiled member node returning call9766 (depth = 7)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9767 = callmethod(call9766, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe9764);
// compiled call node returning call9767 (depth = 6)
  gc_frame_newslot(call9767);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call9767;
  partcv[0] = 1;
  Object call9768 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe9763);
// compiled call node returning call9768 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 2382
  setline(2382);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9769 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call9770 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe9769);
// compiled call node returning call9770 (depth = 4)
  gc_frame_end(frame);
  return call9770;
}
Object meth_ast__apply9779(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2387
  setline(2387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9781 == NULL) {
    strlit9781 = alloc_String("  ");
    gc_root(strlit9781);
  }
// compiled string node returning strlit9781 (depth = 8)
  int op_slot_right_9780 = gc_frame_newslot(strlit9781);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_9780 = gc_frame_newslot(*var_spc);
  params[0] = strlit9781;
  partcv[0] = 1;
  Object opresult9783 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult9783 (depth = 7)
  *var_spc = opresult9783;
  if (opresult9783 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty9771(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2385
  setline(2385);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9772 == NULL) {
    strlit9772 = alloc_String("");
    gc_root(strlit9772);
  }
// compiled string node returning strlit9772 (depth = 5)
  *var_spc = strlit9772;
  if (strlit9772 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2386
  setline(2386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9773 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_right_9774 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 6)
  Object num9776 = alloc_Float64(0);
// compiled num node returning num9776 (depth = 6)
  int op_slot_left_9774 = gc_frame_newslot(num9776);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult9777 = callmethod(num9776, "..", 1, partcv, params);
// compiled op node returning opresult9777 (depth = 5)
  gc_frame_newslot(opresult9777);
// starting to compile block node (depth = 5)
  Object block9778 = alloc_Block(NULL, NULL, "ast", 2386);
  gc_frame_newslot(block9778);
// method _apply
  block_savedest(block9778);
  Object closure9779 = createclosure(2, "_apply");
  setclosureframe(closure9779, stackframe);
  addtoclosure(closure9779, var_spc);
  addtoclosure(closure9779, selfslot);
  struct UserObject *uo9779 = (struct UserObject*)block9778;
  uo9779->data[0] = (Object)closure9779;
  Method *meth_meth_ast__apply9779 = addmethod2pos(block9778, "_apply", &meth_ast__apply9779, 0);
  int argcv_meth_ast__apply9779[] = {1};
  meth_meth_ast__apply9779->type = alloc_MethodType(1, argcv_meth_ast__apply9779);
  meth_meth_ast__apply9779->definitionModule = modulename;
  meth_meth_ast__apply9779->definitionLine = 2381;
// compiled block node returning block9778 (depth = 5)
  gc_frame_newslot(block9778);
// call case 5: prelude request
  params[0] = opresult9777;
  params[1] = block9778;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9786 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9773);
// compiled call node returning call9786 (depth = 4)
// Begin line 2389
  setline(2389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9788 == NULL) {
    strlit9788 = alloc_String("""\x0a""");
    gc_root(strlit9788);
  }
// compiled string node returning strlit9788 (depth = 6)
  int op_slot_right_9787 = gc_frame_newslot(strlit9788);
// starting to compile call node (depth = 6)
  int callframe9790 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call9791 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe9790);
// compiled call node returning call9791 (depth = 6)
  int op_slot_left_9787 = gc_frame_newslot(call9791);
  params[0] = strlit9788;
  partcv[0] = 1;
  Object opresult9792 = callmethod(call9791, "++", 1, partcv, params);
// compiled op node returning opresult9792 (depth = 5)
  *var_s = opresult9792;
  if (opresult9792 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2390
  setline(2390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9794 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num9796 = alloc_Float64(1);
// compiled num node returning num9796 (depth = 8)
  int op_slot_right_9795 = gc_frame_newslot(num9796);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_9795 = gc_frame_newslot(*var_depth);
  params[0] = num9796;
  partcv[0] = 1;
  Object sum9798 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum9798 (depth = 7)
  gc_frame_newslot(sum9798);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9799 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9800 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9799);
// compiled call node returning call9800 (depth = 8)
// compiled member node returning call9800 (depth = 7)
  params[0] = sum9798;
  partcv[0] = 1;
  Object call9801 = callmethod(call9800, "pretty",
    1, partcv, params);
  gc_frame_end(callframe9794);
// compiled call node returning call9801 (depth = 6)
  int op_slot_right_9793 = gc_frame_newslot(call9801);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_9803 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_9803 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9805 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult9805 (depth = 6)
  int op_slot_left_9793 = gc_frame_newslot(opresult9805);
  params[0] = call9801;
  partcv[0] = 1;
  Object opresult9806 = callmethod(opresult9805, "++", 1, partcv, params);
// compiled op node returning opresult9806 (depth = 5)
  *var_s = opresult9806;
  if (opresult9806 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2391
  setline(2391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_toGrace9808(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2394
  setline(2394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9810 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9811 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9812 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9811);
// compiled call node returning call9812 (depth = 7)
// compiled member node returning call9812 (depth = 6)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call9813 = callmethod(call9812, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe9810);
// compiled call node returning call9813 (depth = 5)
  int op_slot_right_9809 = gc_frame_newslot(call9813);
// starting to compile string node (depth = 5)
  if (strlit9815 == NULL) {
    strlit9815 = alloc_String("return ");
    gc_root(strlit9815);
  }
// compiled string node returning strlit9815 (depth = 5)
  int op_slot_left_9809 = gc_frame_newslot(strlit9815);
  params[0] = call9813;
  partcv[0] = 1;
  Object opresult9816 = callmethod(strlit9815, "++", 1, partcv, params);
// compiled op node returning opresult9816 (depth = 4)
  gc_frame_end(frame);
  return opresult9816;
}
Object meth_ast_shallowCopy9817(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_returnNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2397
  setline(2397);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9818 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe9819 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nullNode (depth = 6)
  gc_frame_newslot(*var_nullNode);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_returnNode (depth = 6)
  params[0] = *var_nullNode;
  partcv[0] = 1;
  Object call9820 = callmethod(*var_returnNode, "new",
    1, partcv, params);
  gc_frame_end(callframe9819);
// compiled call node returning call9820 (depth = 5)
  params[0] = self;
  partcv[0] = 1;
  Object call9821 = callmethod(call9820, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe9818);
// compiled call node returning call9821 (depth = 4)
  gc_frame_end(frame);
  return call9821;
}
Object meth_ast_new9743(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_returnNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9744 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9744 = alloc_userobj2(9,9, objclass9744);
  gc_frame_newslot(obj9744);
if (objclass9744 == NULL) {
  glfree(obj9744->class->name);
  obj9744->class->name = "returnNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9744, self, 0);
  addmethodreal(obj9744,"outer", &reader_ast_outer_9745);
  Object oldself9744 = self;
  struct StackFrameObject *oldstackframe9744 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9744);
  gc_frame_newslot((Object)stackframe);
  self = obj9744;
  Object *oldselfslot9744 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9744 = (*(struct UserObject *)self).data[0], lowerouter9744 = thisouter9744;
  if (inheritingObject9744) {
    struct UserObject *inho9744 = (struct UserObject *)inheritingObject9744;
    while (inho9744->super != GraceDefaultObject) inho9744 = (struct UserObject *)inho9744->super;
    inho9744->super = obj9744;
    self = inheritingObject9744;
    *selfslot = self;
    lowerouter9744 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9744;
  }
if (objclass9744 == NULL) {
  Method *reader9746 = addmethodrealflags(obj9744, "kind",&reader_ast_kind_9746, MFLAG_DEF);
  reader9746->definitionModule = modulename;
  reader9746->definitionLine = 2369;
}
adddatum2(obj9744, alloc_Undefined(), 1);
if (objclass9744 == NULL) {
  Method *reader9747 = addmethodrealflags(obj9744, "value",&reader_ast_value_9747, 0);
  Method *writer9747 = addmethodrealflags(obj9744, "value:=",&writer_ast_value_9747, 0);
  reader9747->definitionModule = modulename;
  writer9747->definitionModule = modulename;
  reader9747->definitionLine = 2370;
  writer9747->definitionLine = 2370;
}
obj9744->flags |= OFLAG_MUTABLE;
adddatum2(obj9744, alloc_Undefined(), 2);
// method accept()from
  struct UserObject *uo9748 = (struct UserObject*)obj9744;
  uo9748->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from9748 = addmethod2pos(obj9744, "accept()from", &meth_ast_accept_40__41_from9748, 3);
  int argcv_meth_ast_accept_40__41_from9748[] = {1, 1};
  meth_meth_ast_accept_40__41_from9748->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from9748);
  meth_meth_ast_accept_40__41_from9748->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from9748->definitionLine = 2372;
// method map()ancestors
  struct UserObject *uo9758 = (struct UserObject*)obj9744;
  uo9758->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors9758 = addmethod2pos(obj9744, "map()ancestors", &meth_ast_map_40__41_ancestors9758, 4);
  int argcv_meth_ast_map_40__41_ancestors9758[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors9758->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors9758);
  meth_meth_ast_map_40__41_ancestors9758->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors9758->definitionLine = 2378;
// method pretty
  struct UserObject *uo9771 = (struct UserObject*)obj9744;
  uo9771->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty9771 = addmethod2pos(obj9744, "pretty", &meth_ast_pretty9771, 5);
  int argcv_meth_ast_pretty9771[] = {1};
  meth_meth_ast_pretty9771->type = alloc_MethodType(1, argcv_meth_ast_pretty9771);
  meth_meth_ast_pretty9771->definitionModule = modulename;
  meth_meth_ast_pretty9771->definitionLine = 2384;
// method toGrace
  struct UserObject *uo9808 = (struct UserObject*)obj9744;
  uo9808->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace9808 = addmethod2pos(obj9744, "toGrace", &meth_ast_toGrace9808, 6);
  int argcv_meth_ast_toGrace9808[] = {1};
  meth_meth_ast_toGrace9808->type = alloc_MethodType(1, argcv_meth_ast_toGrace9808);
meth_meth_ast_toGrace9808->type->types[0] = type_Number;
meth_meth_ast_toGrace9808->type->names[0] = "depth";
  meth_meth_ast_toGrace9808->definitionModule = modulename;
  meth_meth_ast_toGrace9808->definitionLine = 2393;
// method shallowCopy
  block_savedest(obj9744);
  Object closure9817 = createclosure(2, "shallowCopy");
  setclosureframe(closure9817, stackframe);
  addtoclosure(closure9817, var_nullNode);
  addtoclosure(closure9817, var_returnNode);
  struct UserObject *uo9817 = (struct UserObject*)obj9744;
  uo9817->data[7] = (Object)closure9817;
  Method *meth_meth_ast_shallowCopy9817 = addmethod2pos(obj9744, "shallowCopy", &meth_ast_shallowCopy9817, 7);
  int argcv_meth_ast_shallowCopy9817[] = {0};
  meth_meth_ast_shallowCopy9817->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy9817);
  meth_meth_ast_shallowCopy9817->definitionModule = modulename;
  meth_meth_ast_shallowCopy9817->definitionLine = 2396;
  sourceObject = obj9744;
// Begin line 2368
  setline(2368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9822 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9823 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe9822);
// compiled call node returning call9823 (depth = 4)
  struct UserObject *obj9744_uo = (struct UserObject *)obj9744;
  obj9744_uo->super = call9823;
  sourceObject = obj9744;
// Begin line 2369
  setline(2369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit9824 == NULL) {
    strlit9824 = alloc_String("return");
    gc_root(strlit9824);
  }
// compiled string node returning strlit9824 (depth = 4)
  adddatum2(obj9744, strlit9824, 1);
  sourceObject = obj9744;
// Begin line 2370
  setline(2370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_expr (depth = 4)
  adddatum2(obj9744, *var_expr, 2);
  sourceObject = obj9744;
  sourceObject = obj9744;
  sourceObject = obj9744;
  sourceObject = obj9744;
  sourceObject = obj9744;
  objclass9744 = obj9744->class;
  objclass9744->definitionModule = modulename;
  objclass9744->definitionLine = 2367;
  (*(struct UserObject *)self).data[0] = lowerouter9744;
  self = oldself9744;
  selfslot = oldselfslot9744;
  stackframe = oldstackframe9744;
  gc_frame_end(frame);
  return obj9744;
}
Object meth_ast_new9743_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_returnNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9744 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9744 = alloc_userobj2(9,9, objclass9744);
  gc_frame_newslot(obj9744);
if (objclass9744 == NULL) {
  glfree(obj9744->class->name);
  obj9744->class->name = "returnNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9744, self, 0);
  addmethodreal(obj9744,"outer", &reader_ast_outer_9745);
  Object oldself9744 = self;
  struct StackFrameObject *oldstackframe9744 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9744);
  gc_frame_newslot((Object)stackframe);
  self = obj9744;
  Object *oldselfslot9744 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9744 = (*(struct UserObject *)self).data[0], lowerouter9744 = thisouter9744;
  if (inheritingObject9744) {
    struct UserObject *inho9744 = (struct UserObject *)inheritingObject9744;
    while (inho9744->super != GraceDefaultObject) inho9744 = (struct UserObject *)inho9744->super;
    inho9744->super = obj9744;
    self = inheritingObject9744;
    *selfslot = self;
    lowerouter9744 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9744;
  }
if (objclass9744 == NULL) {
  Method *reader9746 = addmethodrealflags(obj9744, "kind",&reader_ast_kind_9746, MFLAG_DEF);
  reader9746->definitionModule = modulename;
  reader9746->definitionLine = 2369;
}
adddatum2(obj9744, alloc_Undefined(), 1);
if (objclass9744 == NULL) {
  Method *reader9747 = addmethodrealflags(obj9744, "value",&reader_ast_value_9747, 0);
  Method *writer9747 = addmethodrealflags(obj9744, "value:=",&writer_ast_value_9747, 0);
  reader9747->definitionModule = modulename;
  writer9747->definitionModule = modulename;
  reader9747->definitionLine = 2370;
  writer9747->definitionLine = 2370;
}
obj9744->flags |= OFLAG_MUTABLE;
adddatum2(obj9744, alloc_Undefined(), 2);
// method accept()from
  struct UserObject *uo9748 = (struct UserObject*)obj9744;
  uo9748->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from9748 = addmethod2pos(obj9744, "accept()from", &meth_ast_accept_40__41_from9748, 3);
  int argcv_meth_ast_accept_40__41_from9748[] = {1, 1};
  meth_meth_ast_accept_40__41_from9748->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from9748);
  meth_meth_ast_accept_40__41_from9748->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from9748->definitionLine = 2372;
// method map()ancestors
  struct UserObject *uo9758 = (struct UserObject*)obj9744;
  uo9758->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors9758 = addmethod2pos(obj9744, "map()ancestors", &meth_ast_map_40__41_ancestors9758, 4);
  int argcv_meth_ast_map_40__41_ancestors9758[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors9758->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors9758);
  meth_meth_ast_map_40__41_ancestors9758->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors9758->definitionLine = 2378;
// method pretty
  struct UserObject *uo9771 = (struct UserObject*)obj9744;
  uo9771->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty9771 = addmethod2pos(obj9744, "pretty", &meth_ast_pretty9771, 5);
  int argcv_meth_ast_pretty9771[] = {1};
  meth_meth_ast_pretty9771->type = alloc_MethodType(1, argcv_meth_ast_pretty9771);
  meth_meth_ast_pretty9771->definitionModule = modulename;
  meth_meth_ast_pretty9771->definitionLine = 2384;
// method toGrace
  struct UserObject *uo9808 = (struct UserObject*)obj9744;
  uo9808->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace9808 = addmethod2pos(obj9744, "toGrace", &meth_ast_toGrace9808, 6);
  int argcv_meth_ast_toGrace9808[] = {1};
  meth_meth_ast_toGrace9808->type = alloc_MethodType(1, argcv_meth_ast_toGrace9808);
meth_meth_ast_toGrace9808->type->types[0] = type_Number;
meth_meth_ast_toGrace9808->type->names[0] = "depth";
  meth_meth_ast_toGrace9808->definitionModule = modulename;
  meth_meth_ast_toGrace9808->definitionLine = 2393;
// method shallowCopy
  block_savedest(obj9744);
  Object closure9817 = createclosure(2, "shallowCopy");
  setclosureframe(closure9817, stackframe);
  addtoclosure(closure9817, var_nullNode);
  addtoclosure(closure9817, var_returnNode);
  struct UserObject *uo9817 = (struct UserObject*)obj9744;
  uo9817->data[7] = (Object)closure9817;
  Method *meth_meth_ast_shallowCopy9817 = addmethod2pos(obj9744, "shallowCopy", &meth_ast_shallowCopy9817, 7);
  int argcv_meth_ast_shallowCopy9817[] = {0};
  meth_meth_ast_shallowCopy9817->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy9817);
  meth_meth_ast_shallowCopy9817->definitionModule = modulename;
  meth_meth_ast_shallowCopy9817->definitionLine = 2396;
  sourceObject = obj9744;
// Begin line 2368
  setline(2368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9822 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9823 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe9822);
// compiled call node returning call9823 (depth = 4)
  struct UserObject *obj9744_uo = (struct UserObject *)obj9744;
  obj9744_uo->super = call9823;
  sourceObject = obj9744;
// Begin line 2369
  setline(2369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit9824 == NULL) {
    strlit9824 = alloc_String("return");
    gc_root(strlit9824);
  }
// compiled string node returning strlit9824 (depth = 4)
  adddatum2(obj9744, strlit9824, 1);
  sourceObject = obj9744;
// Begin line 2370
  setline(2370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_expr (depth = 4)
  adddatum2(obj9744, *var_expr, 2);
  sourceObject = obj9744;
  sourceObject = obj9744;
  sourceObject = obj9744;
  sourceObject = obj9744;
  sourceObject = obj9744;
  objclass9744 = obj9744->class;
  objclass9744->definitionModule = modulename;
  objclass9744->definitionLine = 2367;
  (*(struct UserObject *)self).data[0] = lowerouter9744;
  self = oldself9744;
  selfslot = oldselfslot9744;
  stackframe = oldstackframe9744;
  gc_frame_end(frame);
  return obj9744;
}
Object meth_ast_new_40__41_scope9828(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new()scope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new()scope");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method new()scope");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for new()scope (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *var_s = &(stackframe->slots[1]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for scope");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "result");
// Begin line 2402
  setline(2402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9829 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_expr (depth = 5)
  gc_frame_newslot(*var_expr);
// call case 4: self request
  params[0] = *var_expr;
  partcv[0] = 1;
  Object call9830 = callmethodflags(self, "new", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9829);
// compiled call node returning call9830 (depth = 4)
  *var_result = call9830;
  if (call9830 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2403
  setline(2403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2394
  setline(2394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9831 = gc_frame_new();
// Begin line 2403
  setline(2403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  gc_frame_newslot(*var_s);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call9832 = callmethod(*var_result, "scope:=",
    1, partcv, params);
  gc_frame_end(callframe9831);
// compiled call node returning call9832 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 2404
  setline(2404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_isInherits9839(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isInherits");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isInherits (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isInherits");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2412
  setline(2412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9840 = alloc_Boolean(1);
// compiled identifier node returning bool9840 (depth = 3)
  gc_frame_end(frame);
  return bool9840;
}
Object meth_ast_inheritsFromMember9841(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "inheritsFromMember");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for inheritsFromMember (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for inheritsFromMember");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2413
  setline(2413);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9842 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9843 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9844 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9843);
// compiled call node returning call9844 (depth = 6)
// compiled member node returning call9844 (depth = 5)
  partcv[0] = 0;
  Object call9845 = callmethod(call9844, "isMember",
    1, partcv, params);
  gc_frame_end(callframe9842);
// compiled call node returning call9845 (depth = 4)
// compiled member node returning call9845 (depth = 3)
  gc_frame_end(frame);
  return call9845;
}
Object meth_ast_inheritsFromCall9846(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "inheritsFromCall");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for inheritsFromCall (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for inheritsFromCall");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2414
  setline(2414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9847 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9848 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9849 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9848);
// compiled call node returning call9849 (depth = 6)
// compiled member node returning call9849 (depth = 5)
  partcv[0] = 0;
  Object call9850 = callmethod(call9849, "isCall",
    1, partcv, params);
  gc_frame_end(callframe9847);
// compiled call node returning call9850 (depth = 4)
// compiled member node returning call9850 (depth = 3)
  gc_frame_end(frame);
  return call9850;
}
Object meth_ast_accept_40__41_from9851(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 2416
  setline(2416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9853 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9854 = callmethod(*var_visitor, "visitInherits()up",
    2, partcv, params);
  gc_frame_end(callframe9853);
// compiled call node returning call9854 (depth = 4)
  Object if9852 = done;
  if (istrue(call9854)) {
// Begin line 2417
  setline(2417);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9855 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call9856 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe9855);
// compiled call node returning call9856 (depth = 5)
  *var_newChain = call9856;
  if (call9856 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2418
  setline(2418);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9857 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9858 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9859 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9858);
// compiled call node returning call9859 (depth = 6)
// compiled member node returning call9859 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9860 = callmethod(call9859, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe9857);
// compiled call node returning call9860 (depth = 4)
    gc_frame_newslot(call9860);
    if9852 = call9860;
  } else {
  }
// compiled if node returning if9852 (depth = 3)
  gc_frame_end(frame);
  return if9852;
}
Object meth_ast_map_40__41_ancestors9861(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2422
  setline(2422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9862 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9863 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9862);
// compiled call node returning call9863 (depth = 5)
// compiled member node returning call9863 (depth = 4)
  *var_n = call9863;
  if (call9863 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2423
  setline(2423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9864 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call9865 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe9864);
// compiled call node returning call9865 (depth = 4)
  *var_newChain = call9865;
  if (call9865 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2424
  setline(2424);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2422
  setline(2422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9866 = gc_frame_new();
// Begin line 2424
  setline(2424);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9867 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9868 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9869 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9868);
// compiled call node returning call9869 (depth = 7)
// compiled member node returning call9869 (depth = 6)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9870 = callmethod(call9869, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe9867);
// compiled call node returning call9870 (depth = 5)
  gc_frame_newslot(call9870);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  params[0] = call9870;
  partcv[0] = 1;
  Object call9871 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe9866);
// compiled call node returning call9871 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 2425
  setline(2425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9872 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call9873 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe9872);
// compiled call node returning call9873 (depth = 3)
  gc_frame_end(frame);
  return call9873;
}
Object meth_ast__apply9882(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2430
  setline(2430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9884 == NULL) {
    strlit9884 = alloc_String("  ");
    gc_root(strlit9884);
  }
// compiled string node returning strlit9884 (depth = 7)
  int op_slot_right_9883 = gc_frame_newslot(strlit9884);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_9883 = gc_frame_newslot(*var_spc);
  params[0] = strlit9884;
  partcv[0] = 1;
  Object opresult9886 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult9886 (depth = 6)
  *var_spc = opresult9886;
  if (opresult9886 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty9874(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2428
  setline(2428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9875 == NULL) {
    strlit9875 = alloc_String("");
    gc_root(strlit9875);
  }
// compiled string node returning strlit9875 (depth = 4)
  *var_spc = strlit9875;
  if (strlit9875 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2429
  setline(2429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9876 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_9877 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num9879 = alloc_Float64(0);
// compiled num node returning num9879 (depth = 5)
  int op_slot_left_9877 = gc_frame_newslot(num9879);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult9880 = callmethod(num9879, "..", 1, partcv, params);
// compiled op node returning opresult9880 (depth = 4)
  gc_frame_newslot(opresult9880);
// starting to compile block node (depth = 4)
  Object block9881 = alloc_Block(NULL, NULL, "ast", 2429);
  gc_frame_newslot(block9881);
// method _apply
  block_savedest(block9881);
  Object closure9882 = createclosure(2, "_apply");
  setclosureframe(closure9882, stackframe);
  addtoclosure(closure9882, var_spc);
  addtoclosure(closure9882, selfslot);
  struct UserObject *uo9882 = (struct UserObject*)block9881;
  uo9882->data[0] = (Object)closure9882;
  Method *meth_meth_ast__apply9882 = addmethod2pos(block9881, "_apply", &meth_ast__apply9882, 0);
  int argcv_meth_ast__apply9882[] = {1};
  meth_meth_ast__apply9882->type = alloc_MethodType(1, argcv_meth_ast__apply9882);
  meth_meth_ast__apply9882->definitionModule = modulename;
  meth_meth_ast__apply9882->definitionLine = 2424;
// compiled block node returning block9881 (depth = 4)
  gc_frame_newslot(block9881);
// call case 5: prelude request
  params[0] = opresult9880;
  params[1] = block9881;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9889 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9876);
// compiled call node returning call9889 (depth = 3)
// Begin line 2432
  setline(2432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9891 == NULL) {
    strlit9891 = alloc_String("""\x0a""");
    gc_root(strlit9891);
  }
// compiled string node returning strlit9891 (depth = 5)
  int op_slot_right_9890 = gc_frame_newslot(strlit9891);
// starting to compile call node (depth = 5)
  int callframe9893 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call9894 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe9893);
// compiled call node returning call9894 (depth = 5)
  int op_slot_left_9890 = gc_frame_newslot(call9894);
  params[0] = strlit9891;
  partcv[0] = 1;
  Object opresult9895 = callmethod(call9894, "++", 1, partcv, params);
// compiled op node returning opresult9895 (depth = 4)
  *var_s = opresult9895;
  if (opresult9895 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2433
  setline(2433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9897 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num9899 = alloc_Float64(1);
// compiled num node returning num9899 (depth = 7)
  int op_slot_right_9898 = gc_frame_newslot(num9899);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_9898 = gc_frame_newslot(*var_depth);
  params[0] = num9899;
  partcv[0] = 1;
  Object sum9901 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum9901 (depth = 6)
  gc_frame_newslot(sum9901);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9902 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9903 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9902);
// compiled call node returning call9903 (depth = 7)
// compiled member node returning call9903 (depth = 6)
  params[0] = sum9901;
  partcv[0] = 1;
  Object call9904 = callmethod(call9903, "pretty",
    1, partcv, params);
  gc_frame_end(callframe9897);
// compiled call node returning call9904 (depth = 5)
  int op_slot_right_9896 = gc_frame_newslot(call9904);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_9906 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_9906 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9908 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult9908 (depth = 5)
  int op_slot_left_9896 = gc_frame_newslot(opresult9908);
  params[0] = call9904;
  partcv[0] = 1;
  Object opresult9909 = callmethod(opresult9908, "++", 1, partcv, params);
// compiled op node returning opresult9909 (depth = 4)
  *var_s = opresult9909;
  if (opresult9909 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 2434
  setline(2434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9912 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9913 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9914 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9915 = callmethodflags(self, "providedNames", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9914);
// compiled call node returning call9915 (depth = 9)
// compiled member node returning call9915 (depth = 8)
  partcv[0] = 0;
  Object call9916 = callmethod(call9915, "isEmpty",
    1, partcv, params);
  gc_frame_end(callframe9913);
// compiled call node returning call9916 (depth = 7)
// compiled member node returning call9916 (depth = 6)
  partcv[0] = 0;
  Object call9917 = callmethod(call9916, "not",
    1, partcv, params);
  gc_frame_end(callframe9912);
// compiled call node returning call9917 (depth = 5)
// compiled member node returning call9917 (depth = 4)
  Object if9911 = done;
  if (istrue(call9917)) {
// Begin line 2435
  setline(2435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9920 == NULL) {
    strlit9920 = alloc_String("");
    gc_root(strlit9920);
  }
// compiled string node returning strlit9920 (depth = 7)
  int op_slot_right_9919 = gc_frame_newslot(strlit9920);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9923 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9924 = callmethodflags(self, "providedNames", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9923);
// compiled call node returning call9924 (depth = 9)
// compiled member node returning call9924 (depth = 8)
  int op_slot_right_9922 = gc_frame_newslot(call9924);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9927 == NULL) {
    strlit9927 = alloc_String("Provided names: ");
    gc_root(strlit9927);
  }
// compiled string node returning strlit9927 (depth = 9)
  int op_slot_right_9926 = gc_frame_newslot(strlit9927);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_9929 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 10)
  if (strlit9931 == NULL) {
    strlit9931 = alloc_String("""\x0a""");
    gc_root(strlit9931);
  }
// compiled string node returning strlit9931 (depth = 10)
  int op_slot_left_9929 = gc_frame_newslot(strlit9931);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9932 = callmethod(strlit9931, "++", 1, partcv, params);
// compiled op node returning opresult9932 (depth = 9)
  int op_slot_left_9926 = gc_frame_newslot(opresult9932);
  params[0] = strlit9927;
  partcv[0] = 1;
  Object opresult9933 = callmethod(opresult9932, "++", 1, partcv, params);
// compiled op node returning opresult9933 (depth = 8)
  int op_slot_left_9922 = gc_frame_newslot(opresult9933);
  params[0] = call9924;
  partcv[0] = 1;
  Object opresult9934 = callmethod(opresult9933, "++", 1, partcv, params);
// compiled op node returning opresult9934 (depth = 7)
  int op_slot_left_9919 = gc_frame_newslot(opresult9934);
  params[0] = strlit9920;
  partcv[0] = 1;
  Object opresult9935 = callmethod(opresult9934, "++", 1, partcv, params);
// compiled op node returning opresult9935 (depth = 6)
  int op_slot_right_9918 = gc_frame_newslot(opresult9935);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_9918 = gc_frame_newslot(*var_s);
  params[0] = opresult9935;
  partcv[0] = 1;
  Object opresult9937 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult9937 (depth = 5)
  *var_s = opresult9937;
  if (opresult9937 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if9911 = done;
  } else {
  }
// compiled if node returning if9911 (depth = 3)
// Begin line 2437
  setline(2437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_toGrace9939(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2440
  setline(2440);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9941 == NULL) {
    strlit9941 = alloc_String("");
    gc_root(strlit9941);
  }
// compiled string node returning strlit9941 (depth = 4)
  int op_slot_right_9940 = gc_frame_newslot(strlit9941);
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9944 = gc_frame_new();
// starting to compile num node (depth = 6)
  Object num9945 = alloc_Float64(0);
// compiled num node returning num9945 (depth = 6)
  gc_frame_newslot(num9945);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9946 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9947 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9946);
// compiled call node returning call9947 (depth = 7)
// compiled member node returning call9947 (depth = 6)
  params[0] = num9945;
  partcv[0] = 1;
  Object call9948 = callmethod(call9947, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe9944);
// compiled call node returning call9948 (depth = 5)
  int op_slot_right_9943 = gc_frame_newslot(call9948);
// starting to compile string node (depth = 5)
  if (strlit9950 == NULL) {
    strlit9950 = alloc_String("inherits ");
    gc_root(strlit9950);
  }
// compiled string node returning strlit9950 (depth = 5)
  int op_slot_left_9943 = gc_frame_newslot(strlit9950);
  params[0] = call9948;
  partcv[0] = 1;
  Object opresult9951 = callmethod(strlit9950, "++", 1, partcv, params);
// compiled op node returning opresult9951 (depth = 4)
  int op_slot_left_9940 = gc_frame_newslot(opresult9951);
  params[0] = strlit9941;
  partcv[0] = 1;
  Object opresult9952 = callmethod(opresult9951, "++", 1, partcv, params);
// compiled op node returning opresult9952 (depth = 3)
  gc_frame_end(frame);
  return opresult9952;
}
Object meth_ast_nameString9953(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for nameString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for nameString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2442
  setline(2442);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9954 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num9955 = alloc_Float64(0);
// compiled num node returning num9955 (depth = 4)
  gc_frame_newslot(num9955);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9956 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9957 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9956);
// compiled call node returning call9957 (depth = 5)
// compiled member node returning call9957 (depth = 4)
  params[0] = num9955;
  partcv[0] = 1;
  Object call9958 = callmethod(call9957, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe9954);
// compiled call node returning call9958 (depth = 3)
  gc_frame_end(frame);
  return call9958;
}
Object meth_ast_shallowCopy9959(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_inheritsNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2444
  setline(2444);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9960 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe9961 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_inheritsNode (depth = 5)
  params[0] = *var_nullNode;
  partcv[0] = 1;
  Object call9962 = callmethod(*var_inheritsNode, "new",
    1, partcv, params);
  gc_frame_end(callframe9961);
// compiled call node returning call9962 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call9963 = callmethod(call9962, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe9960);
// compiled call node returning call9963 (depth = 3)
  gc_frame_end(frame);
  return call9963;
}
Object meth_ast_shallowCopyFieldsFrom9964(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyFieldsFrom");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopyFieldsFrom (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyFieldsFrom");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2447
  setline(2447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9965 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call9966 = callmethod4(self, "shallowCopyFieldsFrom", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe9965);
// compiled call node returning call9966 (depth = 3)
// Begin line 2448
  setline(2448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2442
  setline(2442);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9967 = gc_frame_new();
// Begin line 2448
  setline(2448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9968 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  partcv[0] = 0;
  Object call9969 = callmethod(*var_other, "providedNames",
    1, partcv, params);
  gc_frame_end(callframe9968);
// compiled call node returning call9969 (depth = 6)
// compiled member node returning call9969 (depth = 5)
  gc_frame_newslot(call9969);
// call case 4: self request
  params[0] = call9969;
  partcv[0] = 1;
  Object call9970 = callmethodflags(self, "providedNames:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9967);
// compiled call node returning call9970 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 2449
  setline(2449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_new9833(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_inheritsNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9834 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9834 = alloc_userobj2(16,15, objclass9834);
  gc_frame_newslot(obj9834);
if (objclass9834 == NULL) {
  glfree(obj9834->class->name);
  obj9834->class->name = "obj9826.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9834, self, 0);
  addmethodreal(obj9834,"outer", &reader_ast_outer_9835);
  Object oldself9834 = self;
  struct StackFrameObject *oldstackframe9834 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9834);
  gc_frame_newslot((Object)stackframe);
  self = obj9834;
  Object *oldselfslot9834 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9834 = (*(struct UserObject *)self).data[0], lowerouter9834 = thisouter9834;
  if (inheritingObject9834) {
    struct UserObject *inho9834 = (struct UserObject *)inheritingObject9834;
    while (inho9834->super != GraceDefaultObject) inho9834 = (struct UserObject *)inho9834->super;
    inho9834->super = obj9834;
    self = inheritingObject9834;
    *selfslot = self;
    lowerouter9834 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9834;
  }
if (objclass9834 == NULL) {
  Method *reader9836 = addmethodrealflags(obj9834, "kind",&reader_ast_kind_9836, MFLAG_DEF);
  reader9836->definitionModule = modulename;
  reader9836->definitionLine = 2408;
}
adddatum2(obj9834, alloc_Undefined(), 1);
if (objclass9834 == NULL) {
  Method *reader9837 = addmethodrealflags(obj9834, "value",&reader_ast_value_9837, 0);
  Method *writer9837 = addmethodrealflags(obj9834, "value:=",&writer_ast_value_9837, 0);
  reader9837->definitionModule = modulename;
  writer9837->definitionModule = modulename;
  reader9837->definitionLine = 2409;
  writer9837->definitionLine = 2409;
}
obj9834->flags |= OFLAG_MUTABLE;
adddatum2(obj9834, alloc_Undefined(), 2);
if (objclass9834 == NULL) {
  Method *reader9838 = addmethodrealflags(obj9834, "providedNames",&reader_ast_providedNames_9838, 0);
  Method *writer9838 = addmethodrealflags(obj9834, "providedNames:=",&writer_ast_providedNames_9838, 0);
  reader9838->definitionModule = modulename;
  writer9838->definitionModule = modulename;
  reader9838->definitionLine = 2410;
  writer9838->definitionLine = 2410;
}
obj9834->flags |= OFLAG_MUTABLE;
adddatum2(obj9834, alloc_Undefined(), 3);
// method isInherits
  struct UserObject *uo9839 = (struct UserObject*)obj9834;
  uo9839->data[4] = emptyclosure;
  Method *meth_meth_ast_isInherits9839 = addmethod2pos(obj9834, "isInherits", &meth_ast_isInherits9839, 4);
  int argcv_meth_ast_isInherits9839[] = {0};
  meth_meth_ast_isInherits9839->type = alloc_MethodType(1, argcv_meth_ast_isInherits9839);
  meth_meth_ast_isInherits9839->definitionModule = modulename;
  meth_meth_ast_isInherits9839->definitionLine = 2412;
// method inheritsFromMember
  struct UserObject *uo9841 = (struct UserObject*)obj9834;
  uo9841->data[5] = emptyclosure;
  Method *meth_meth_ast_inheritsFromMember9841 = addmethod2pos(obj9834, "inheritsFromMember", &meth_ast_inheritsFromMember9841, 5);
  int argcv_meth_ast_inheritsFromMember9841[] = {0};
  meth_meth_ast_inheritsFromMember9841->type = alloc_MethodType(1, argcv_meth_ast_inheritsFromMember9841);
  meth_meth_ast_inheritsFromMember9841->definitionModule = modulename;
  meth_meth_ast_inheritsFromMember9841->definitionLine = 2413;
// method inheritsFromCall
  struct UserObject *uo9846 = (struct UserObject*)obj9834;
  uo9846->data[6] = emptyclosure;
  Method *meth_meth_ast_inheritsFromCall9846 = addmethod2pos(obj9834, "inheritsFromCall", &meth_ast_inheritsFromCall9846, 6);
  int argcv_meth_ast_inheritsFromCall9846[] = {0};
  meth_meth_ast_inheritsFromCall9846->type = alloc_MethodType(1, argcv_meth_ast_inheritsFromCall9846);
  meth_meth_ast_inheritsFromCall9846->definitionModule = modulename;
  meth_meth_ast_inheritsFromCall9846->definitionLine = 2414;
// method accept()from
  struct UserObject *uo9851 = (struct UserObject*)obj9834;
  uo9851->data[7] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from9851 = addmethod2pos(obj9834, "accept()from", &meth_ast_accept_40__41_from9851, 7);
  int argcv_meth_ast_accept_40__41_from9851[] = {1, 1};
  meth_meth_ast_accept_40__41_from9851->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from9851);
  meth_meth_ast_accept_40__41_from9851->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from9851->definitionLine = 2415;
// method map()ancestors
  struct UserObject *uo9861 = (struct UserObject*)obj9834;
  uo9861->data[8] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors9861 = addmethod2pos(obj9834, "map()ancestors", &meth_ast_map_40__41_ancestors9861, 8);
  int argcv_meth_ast_map_40__41_ancestors9861[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors9861->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors9861);
  meth_meth_ast_map_40__41_ancestors9861->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors9861->definitionLine = 2421;
// method pretty
  struct UserObject *uo9874 = (struct UserObject*)obj9834;
  uo9874->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty9874 = addmethod2pos(obj9834, "pretty", &meth_ast_pretty9874, 9);
  int argcv_meth_ast_pretty9874[] = {1};
  meth_meth_ast_pretty9874->type = alloc_MethodType(1, argcv_meth_ast_pretty9874);
  meth_meth_ast_pretty9874->definitionModule = modulename;
  meth_meth_ast_pretty9874->definitionLine = 2427;
// method toGrace
  struct UserObject *uo9939 = (struct UserObject*)obj9834;
  uo9939->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace9939 = addmethod2pos(obj9834, "toGrace", &meth_ast_toGrace9939, 10);
  int argcv_meth_ast_toGrace9939[] = {1};
  meth_meth_ast_toGrace9939->type = alloc_MethodType(1, argcv_meth_ast_toGrace9939);
meth_meth_ast_toGrace9939->type->types[0] = type_Number;
meth_meth_ast_toGrace9939->type->names[0] = "depth";
  meth_meth_ast_toGrace9939->definitionModule = modulename;
  meth_meth_ast_toGrace9939->definitionLine = 2439;
// method nameString
  struct UserObject *uo9953 = (struct UserObject*)obj9834;
  uo9953->data[11] = emptyclosure;
  Method *meth_meth_ast_nameString9953 = addmethod2pos(obj9834, "nameString", &meth_ast_nameString9953, 11);
  int argcv_meth_ast_nameString9953[] = {0};
  meth_meth_ast_nameString9953->type = alloc_MethodType(1, argcv_meth_ast_nameString9953);
  meth_meth_ast_nameString9953->definitionModule = modulename;
  meth_meth_ast_nameString9953->definitionLine = 2442;
// method shallowCopy
  block_savedest(obj9834);
  Object closure9959 = createclosure(2, "shallowCopy");
  setclosureframe(closure9959, stackframe);
  addtoclosure(closure9959, var_nullNode);
  addtoclosure(closure9959, var_inheritsNode);
  struct UserObject *uo9959 = (struct UserObject*)obj9834;
  uo9959->data[12] = (Object)closure9959;
  Method *meth_meth_ast_shallowCopy9959 = addmethod2pos(obj9834, "shallowCopy", &meth_ast_shallowCopy9959, 12);
  int argcv_meth_ast_shallowCopy9959[] = {0};
  meth_meth_ast_shallowCopy9959->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy9959);
  meth_meth_ast_shallowCopy9959->definitionModule = modulename;
  meth_meth_ast_shallowCopy9959->definitionLine = 2443;
// method shallowCopyFieldsFrom
  struct UserObject *uo9964 = (struct UserObject*)obj9834;
  uo9964->data[13] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom9964 = addmethod2pos(obj9834, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom9964, 13);
  int argcv_meth_ast_shallowCopyFieldsFrom9964[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom9964->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom9964);
  meth_meth_ast_shallowCopyFieldsFrom9964->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom9964->definitionLine = 2446;
  sourceObject = obj9834;
// Begin line 2407
  setline(2407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9971 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_baseNode (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9972 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe9971);
// compiled call node returning call9972 (depth = 3)
  struct UserObject *obj9834_uo = (struct UserObject *)obj9834;
  obj9834_uo->super = call9972;
  sourceObject = obj9834;
// Begin line 2408
  setline(2408);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9973 == NULL) {
    strlit9973 = alloc_String("inherits");
    gc_root(strlit9973);
  }
// compiled string node returning strlit9973 (depth = 3)
  adddatum2(obj9834, strlit9973, 1);
  sourceObject = obj9834;
// Begin line 2409
  setline(2409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_expr (depth = 3)
  adddatum2(obj9834, *var_expr, 2);
  sourceObject = obj9834;
// Begin line 2410
  setline(2410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9974 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9975 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call9976 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9975);
// compiled call node returning call9976 (depth = 6)
// compiled member node returning call9976 (depth = 5)
  partcv[0] = 0;
  Object call9977 = callmethod(call9976, "empty",
    1, partcv, params);
  gc_frame_end(callframe9974);
// compiled call node returning call9977 (depth = 4)
// compiled member node returning call9977 (depth = 3)
  adddatum2(obj9834, call9977, 3);
  sourceObject = obj9834;
  sourceObject = obj9834;
  sourceObject = obj9834;
  sourceObject = obj9834;
  sourceObject = obj9834;
  sourceObject = obj9834;
  sourceObject = obj9834;
  sourceObject = obj9834;
  sourceObject = obj9834;
  sourceObject = obj9834;
  objclass9834 = obj9834->class;
  objclass9834->definitionModule = modulename;
  objclass9834->definitionLine = 2406;
  (*(struct UserObject *)self).data[0] = lowerouter9834;
  self = oldself9834;
  selfslot = oldselfslot9834;
  stackframe = oldstackframe9834;
  gc_frame_end(frame);
  return obj9834;
}
Object meth_ast_new9833_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_inheritsNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9834 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9834 = alloc_userobj2(16,15, objclass9834);
  gc_frame_newslot(obj9834);
if (objclass9834 == NULL) {
  glfree(obj9834->class->name);
  obj9834->class->name = "obj9826.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9834, self, 0);
  addmethodreal(obj9834,"outer", &reader_ast_outer_9835);
  Object oldself9834 = self;
  struct StackFrameObject *oldstackframe9834 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9834);
  gc_frame_newslot((Object)stackframe);
  self = obj9834;
  Object *oldselfslot9834 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9834 = (*(struct UserObject *)self).data[0], lowerouter9834 = thisouter9834;
  if (inheritingObject9834) {
    struct UserObject *inho9834 = (struct UserObject *)inheritingObject9834;
    while (inho9834->super != GraceDefaultObject) inho9834 = (struct UserObject *)inho9834->super;
    inho9834->super = obj9834;
    self = inheritingObject9834;
    *selfslot = self;
    lowerouter9834 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9834;
  }
if (objclass9834 == NULL) {
  Method *reader9836 = addmethodrealflags(obj9834, "kind",&reader_ast_kind_9836, MFLAG_DEF);
  reader9836->definitionModule = modulename;
  reader9836->definitionLine = 2408;
}
adddatum2(obj9834, alloc_Undefined(), 1);
if (objclass9834 == NULL) {
  Method *reader9837 = addmethodrealflags(obj9834, "value",&reader_ast_value_9837, 0);
  Method *writer9837 = addmethodrealflags(obj9834, "value:=",&writer_ast_value_9837, 0);
  reader9837->definitionModule = modulename;
  writer9837->definitionModule = modulename;
  reader9837->definitionLine = 2409;
  writer9837->definitionLine = 2409;
}
obj9834->flags |= OFLAG_MUTABLE;
adddatum2(obj9834, alloc_Undefined(), 2);
if (objclass9834 == NULL) {
  Method *reader9838 = addmethodrealflags(obj9834, "providedNames",&reader_ast_providedNames_9838, 0);
  Method *writer9838 = addmethodrealflags(obj9834, "providedNames:=",&writer_ast_providedNames_9838, 0);
  reader9838->definitionModule = modulename;
  writer9838->definitionModule = modulename;
  reader9838->definitionLine = 2410;
  writer9838->definitionLine = 2410;
}
obj9834->flags |= OFLAG_MUTABLE;
adddatum2(obj9834, alloc_Undefined(), 3);
// method isInherits
  struct UserObject *uo9839 = (struct UserObject*)obj9834;
  uo9839->data[4] = emptyclosure;
  Method *meth_meth_ast_isInherits9839 = addmethod2pos(obj9834, "isInherits", &meth_ast_isInherits9839, 4);
  int argcv_meth_ast_isInherits9839[] = {0};
  meth_meth_ast_isInherits9839->type = alloc_MethodType(1, argcv_meth_ast_isInherits9839);
  meth_meth_ast_isInherits9839->definitionModule = modulename;
  meth_meth_ast_isInherits9839->definitionLine = 2412;
// method inheritsFromMember
  struct UserObject *uo9841 = (struct UserObject*)obj9834;
  uo9841->data[5] = emptyclosure;
  Method *meth_meth_ast_inheritsFromMember9841 = addmethod2pos(obj9834, "inheritsFromMember", &meth_ast_inheritsFromMember9841, 5);
  int argcv_meth_ast_inheritsFromMember9841[] = {0};
  meth_meth_ast_inheritsFromMember9841->type = alloc_MethodType(1, argcv_meth_ast_inheritsFromMember9841);
  meth_meth_ast_inheritsFromMember9841->definitionModule = modulename;
  meth_meth_ast_inheritsFromMember9841->definitionLine = 2413;
// method inheritsFromCall
  struct UserObject *uo9846 = (struct UserObject*)obj9834;
  uo9846->data[6] = emptyclosure;
  Method *meth_meth_ast_inheritsFromCall9846 = addmethod2pos(obj9834, "inheritsFromCall", &meth_ast_inheritsFromCall9846, 6);
  int argcv_meth_ast_inheritsFromCall9846[] = {0};
  meth_meth_ast_inheritsFromCall9846->type = alloc_MethodType(1, argcv_meth_ast_inheritsFromCall9846);
  meth_meth_ast_inheritsFromCall9846->definitionModule = modulename;
  meth_meth_ast_inheritsFromCall9846->definitionLine = 2414;
// method accept()from
  struct UserObject *uo9851 = (struct UserObject*)obj9834;
  uo9851->data[7] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from9851 = addmethod2pos(obj9834, "accept()from", &meth_ast_accept_40__41_from9851, 7);
  int argcv_meth_ast_accept_40__41_from9851[] = {1, 1};
  meth_meth_ast_accept_40__41_from9851->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from9851);
  meth_meth_ast_accept_40__41_from9851->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from9851->definitionLine = 2415;
// method map()ancestors
  struct UserObject *uo9861 = (struct UserObject*)obj9834;
  uo9861->data[8] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors9861 = addmethod2pos(obj9834, "map()ancestors", &meth_ast_map_40__41_ancestors9861, 8);
  int argcv_meth_ast_map_40__41_ancestors9861[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors9861->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors9861);
  meth_meth_ast_map_40__41_ancestors9861->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors9861->definitionLine = 2421;
// method pretty
  struct UserObject *uo9874 = (struct UserObject*)obj9834;
  uo9874->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty9874 = addmethod2pos(obj9834, "pretty", &meth_ast_pretty9874, 9);
  int argcv_meth_ast_pretty9874[] = {1};
  meth_meth_ast_pretty9874->type = alloc_MethodType(1, argcv_meth_ast_pretty9874);
  meth_meth_ast_pretty9874->definitionModule = modulename;
  meth_meth_ast_pretty9874->definitionLine = 2427;
// method toGrace
  struct UserObject *uo9939 = (struct UserObject*)obj9834;
  uo9939->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace9939 = addmethod2pos(obj9834, "toGrace", &meth_ast_toGrace9939, 10);
  int argcv_meth_ast_toGrace9939[] = {1};
  meth_meth_ast_toGrace9939->type = alloc_MethodType(1, argcv_meth_ast_toGrace9939);
meth_meth_ast_toGrace9939->type->types[0] = type_Number;
meth_meth_ast_toGrace9939->type->names[0] = "depth";
  meth_meth_ast_toGrace9939->definitionModule = modulename;
  meth_meth_ast_toGrace9939->definitionLine = 2439;
// method nameString
  struct UserObject *uo9953 = (struct UserObject*)obj9834;
  uo9953->data[11] = emptyclosure;
  Method *meth_meth_ast_nameString9953 = addmethod2pos(obj9834, "nameString", &meth_ast_nameString9953, 11);
  int argcv_meth_ast_nameString9953[] = {0};
  meth_meth_ast_nameString9953->type = alloc_MethodType(1, argcv_meth_ast_nameString9953);
  meth_meth_ast_nameString9953->definitionModule = modulename;
  meth_meth_ast_nameString9953->definitionLine = 2442;
// method shallowCopy
  block_savedest(obj9834);
  Object closure9959 = createclosure(2, "shallowCopy");
  setclosureframe(closure9959, stackframe);
  addtoclosure(closure9959, var_nullNode);
  addtoclosure(closure9959, var_inheritsNode);
  struct UserObject *uo9959 = (struct UserObject*)obj9834;
  uo9959->data[12] = (Object)closure9959;
  Method *meth_meth_ast_shallowCopy9959 = addmethod2pos(obj9834, "shallowCopy", &meth_ast_shallowCopy9959, 12);
  int argcv_meth_ast_shallowCopy9959[] = {0};
  meth_meth_ast_shallowCopy9959->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy9959);
  meth_meth_ast_shallowCopy9959->definitionModule = modulename;
  meth_meth_ast_shallowCopy9959->definitionLine = 2443;
// method shallowCopyFieldsFrom
  struct UserObject *uo9964 = (struct UserObject*)obj9834;
  uo9964->data[13] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom9964 = addmethod2pos(obj9834, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom9964, 13);
  int argcv_meth_ast_shallowCopyFieldsFrom9964[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom9964->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom9964);
  meth_meth_ast_shallowCopyFieldsFrom9964->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom9964->definitionLine = 2446;
  sourceObject = obj9834;
// Begin line 2407
  setline(2407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9971 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_baseNode (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9972 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe9971);
// compiled call node returning call9972 (depth = 3)
  struct UserObject *obj9834_uo = (struct UserObject *)obj9834;
  obj9834_uo->super = call9972;
  sourceObject = obj9834;
// Begin line 2408
  setline(2408);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9973 == NULL) {
    strlit9973 = alloc_String("inherits");
    gc_root(strlit9973);
  }
// compiled string node returning strlit9973 (depth = 3)
  adddatum2(obj9834, strlit9973, 1);
  sourceObject = obj9834;
// Begin line 2409
  setline(2409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_expr (depth = 3)
  adddatum2(obj9834, *var_expr, 2);
  sourceObject = obj9834;
// Begin line 2410
  setline(2410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9974 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9975 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call9976 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9975);
// compiled call node returning call9976 (depth = 6)
// compiled member node returning call9976 (depth = 5)
  partcv[0] = 0;
  Object call9977 = callmethod(call9976, "empty",
    1, partcv, params);
  gc_frame_end(callframe9974);
// compiled call node returning call9977 (depth = 4)
// compiled member node returning call9977 (depth = 3)
  adddatum2(obj9834, call9977, 3);
  sourceObject = obj9834;
  sourceObject = obj9834;
  sourceObject = obj9834;
  sourceObject = obj9834;
  sourceObject = obj9834;
  sourceObject = obj9834;
  sourceObject = obj9834;
  sourceObject = obj9834;
  sourceObject = obj9834;
  sourceObject = obj9834;
  objclass9834 = obj9834->class;
  objclass9834->definitionModule = modulename;
  objclass9834->definitionLine = 2406;
  (*(struct UserObject *)self).data[0] = lowerouter9834;
  self = oldself9834;
  selfslot = oldselfslot9834;
  stackframe = oldstackframe9834;
  gc_frame_end(frame);
  return obj9834;
}
Object meth_ast_inheritsNode9979(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 45, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "inheritsNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_inheritsNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for inheritsNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹inheritsNode›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2400
  setline(2400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_inheritsNode (depth = 3)
  gc_frame_end(frame);
  return *var_inheritsNode;
}
Object meth_ast_blankNode9980(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 46, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "blankNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blankNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for blankNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for blankNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_blankNode (depth = 3)
  gc_frame_end(frame);
  return *var_blankNode;
}
Object meth_ast_accept_40__41_from9988(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2459
  setline(2459);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9989 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9990 = callmethod(*var_visitor, "visitBlank()up",
    2, partcv, params);
  gc_frame_end(callframe9989);
// compiled call node returning call9990 (depth = 4)
  gc_frame_end(frame);
  return call9990;
}
Object meth_ast_map_40__41_ancestors9991(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2462
  setline(2462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9992 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9993 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9992);
// compiled call node returning call9993 (depth = 6)
// compiled member node returning call9993 (depth = 5)
  *var_n = call9993;
  if (call9993 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2463
  setline(2463);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9994 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call9995 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe9994);
// compiled call node returning call9995 (depth = 5)
  *var_newChain = call9995;
  if (call9995 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2464
  setline(2464);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9996 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call9997 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe9996);
// compiled call node returning call9997 (depth = 4)
  gc_frame_end(frame);
  return call9997;
}
Object meth_ast_nameString9998(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for nameString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for nameString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2466
  setline(2466);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit9999 == NULL) {
    strlit9999 = alloc_String("");
    gc_root(strlit9999);
  }
// compiled string node returning strlit9999 (depth = 4)
  gc_frame_end(frame);
  return strlit9999;
}
Object meth_ast_asString10000(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2467
  setline(2467);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit10001 == NULL) {
    strlit10001 = alloc_String("blank");
    gc_root(strlit10001);
  }
// compiled string node returning strlit10001 (depth = 4)
  gc_frame_end(frame);
  return strlit10001;
}
Object meth_ast_toGrace10002(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2468
  setline(2468);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit10003 == NULL) {
    strlit10003 = alloc_String("");
    gc_root(strlit10003);
  }
// compiled string node returning strlit10003 (depth = 4)
  gc_frame_end(frame);
  return strlit10003;
}
Object meth_ast_shallowCopy10004(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blankNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2470
  setline(2470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10005 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10006 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blankNode (depth = 7)
  partcv[0] = 0;
  Object call10007 = callmethod(*var_blankNode, "new",
    1, partcv, params);
  gc_frame_end(callframe10006);
// compiled call node returning call10007 (depth = 6)
// compiled member node returning call10007 (depth = 5)
  params[0] = self;
  partcv[0] = 1;
  Object call10008 = callmethod(call10007, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe10005);
// compiled call node returning call10008 (depth = 4)
  gc_frame_end(frame);
  return call10008;
}
Object meth_ast_new9983(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_blankNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9984 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9984 = alloc_userobj2(9,10, objclass9984);
  gc_frame_newslot(obj9984);
if (objclass9984 == NULL) {
  glfree(obj9984->class->name);
  obj9984->class->name = "blankNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9984, self, 0);
  addmethodreal(obj9984,"outer", &reader_ast_outer_9985);
  Object oldself9984 = self;
  struct StackFrameObject *oldstackframe9984 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9984);
  gc_frame_newslot((Object)stackframe);
  self = obj9984;
  Object *oldselfslot9984 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9984 = (*(struct UserObject *)self).data[0], lowerouter9984 = thisouter9984;
  if (inheritingObject9984) {
    struct UserObject *inho9984 = (struct UserObject *)inheritingObject9984;
    while (inho9984->super != GraceDefaultObject) inho9984 = (struct UserObject *)inho9984->super;
    inho9984->super = obj9984;
    self = inheritingObject9984;
    *selfslot = self;
    lowerouter9984 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9984;
  }
if (objclass9984 == NULL) {
  Method *reader9986 = addmethodrealflags(obj9984, "kind",&reader_ast_kind_9986, MFLAG_DEF);
  reader9986->definitionModule = modulename;
  reader9986->definitionLine = 2455;
}
adddatum2(obj9984, alloc_Undefined(), 1);
if (objclass9984 == NULL) {
  Method *reader9987 = addmethodrealflags(obj9984, "value",&reader_ast_value_9987, MFLAG_DEF);
  reader9987->definitionModule = modulename;
  reader9987->definitionLine = 2456;
}
adddatum2(obj9984, alloc_Undefined(), 2);
// method accept()from
  struct UserObject *uo9988 = (struct UserObject*)obj9984;
  uo9988->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from9988 = addmethod2pos(obj9984, "accept()from", &meth_ast_accept_40__41_from9988, 3);
  int argcv_meth_ast_accept_40__41_from9988[] = {1, 1};
  meth_meth_ast_accept_40__41_from9988->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from9988);
  meth_meth_ast_accept_40__41_from9988->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from9988->definitionLine = 2458;
// method map()ancestors
  struct UserObject *uo9991 = (struct UserObject*)obj9984;
  uo9991->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors9991 = addmethod2pos(obj9984, "map()ancestors", &meth_ast_map_40__41_ancestors9991, 4);
  int argcv_meth_ast_map_40__41_ancestors9991[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors9991->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors9991);
  meth_meth_ast_map_40__41_ancestors9991->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors9991->definitionLine = 2461;
// method nameString
  struct UserObject *uo9998 = (struct UserObject*)obj9984;
  uo9998->data[5] = emptyclosure;
  Method *meth_meth_ast_nameString9998 = addmethod2pos(obj9984, "nameString", &meth_ast_nameString9998, 5);
  int argcv_meth_ast_nameString9998[] = {0};
  meth_meth_ast_nameString9998->type = alloc_MethodType(1, argcv_meth_ast_nameString9998);
  meth_meth_ast_nameString9998->definitionModule = modulename;
  meth_meth_ast_nameString9998->definitionLine = 2466;
// method asString
  struct UserObject *uo10000 = (struct UserObject*)obj9984;
  uo10000->data[6] = emptyclosure;
  Method *meth_meth_ast_asString10000 = addmethod2pos(obj9984, "asString", &meth_ast_asString10000, 6);
  int argcv_meth_ast_asString10000[] = {0};
  meth_meth_ast_asString10000->type = alloc_MethodType(1, argcv_meth_ast_asString10000);
  meth_meth_ast_asString10000->definitionModule = modulename;
  meth_meth_ast_asString10000->definitionLine = 2467;
// method toGrace
  struct UserObject *uo10002 = (struct UserObject*)obj9984;
  uo10002->data[7] = emptyclosure;
  Method *meth_meth_ast_toGrace10002 = addmethod2pos(obj9984, "toGrace", &meth_ast_toGrace10002, 7);
  int argcv_meth_ast_toGrace10002[] = {1};
  meth_meth_ast_toGrace10002->type = alloc_MethodType(1, argcv_meth_ast_toGrace10002);
meth_meth_ast_toGrace10002->type->types[0] = type_Number;
meth_meth_ast_toGrace10002->type->names[0] = "depth";
  meth_meth_ast_toGrace10002->definitionModule = modulename;
  meth_meth_ast_toGrace10002->definitionLine = 2468;
// method shallowCopy
  block_savedest(obj9984);
  Object closure10004 = createclosure(1, "shallowCopy");
  setclosureframe(closure10004, stackframe);
  addtoclosure(closure10004, var_blankNode);
  struct UserObject *uo10004 = (struct UserObject*)obj9984;
  uo10004->data[8] = (Object)closure10004;
  Method *meth_meth_ast_shallowCopy10004 = addmethod2pos(obj9984, "shallowCopy", &meth_ast_shallowCopy10004, 8);
  int argcv_meth_ast_shallowCopy10004[] = {0};
  meth_meth_ast_shallowCopy10004->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy10004);
  meth_meth_ast_shallowCopy10004->definitionModule = modulename;
  meth_meth_ast_shallowCopy10004->definitionLine = 2469;
  sourceObject = obj9984;
// Begin line 2454
  setline(2454);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10009 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call10010 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe10009);
// compiled call node returning call10010 (depth = 4)
  struct UserObject *obj9984_uo = (struct UserObject *)obj9984;
  obj9984_uo->super = call10010;
  sourceObject = obj9984;
// Begin line 2455
  setline(2455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit10011 == NULL) {
    strlit10011 = alloc_String("blank");
    gc_root(strlit10011);
  }
// compiled string node returning strlit10011 (depth = 4)
  adddatum2(obj9984, strlit10011, 1);
  sourceObject = obj9984;
// Begin line 2456
  setline(2456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit10012 == NULL) {
    strlit10012 = alloc_String("blank");
    gc_root(strlit10012);
  }
// compiled string node returning strlit10012 (depth = 4)
  adddatum2(obj9984, strlit10012, 2);
  sourceObject = obj9984;
  sourceObject = obj9984;
  sourceObject = obj9984;
  sourceObject = obj9984;
  sourceObject = obj9984;
  sourceObject = obj9984;
  objclass9984 = obj9984->class;
  objclass9984->definitionModule = modulename;
  objclass9984->definitionLine = 2453;
  (*(struct UserObject *)self).data[0] = lowerouter9984;
  self = oldself9984;
  selfslot = oldselfslot9984;
  stackframe = oldstackframe9984;
  gc_frame_end(frame);
  return obj9984;
}
Object meth_ast_new9983_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_blankNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9984 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9984 = alloc_userobj2(9,10, objclass9984);
  gc_frame_newslot(obj9984);
if (objclass9984 == NULL) {
  glfree(obj9984->class->name);
  obj9984->class->name = "blankNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9984, self, 0);
  addmethodreal(obj9984,"outer", &reader_ast_outer_9985);
  Object oldself9984 = self;
  struct StackFrameObject *oldstackframe9984 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9984);
  gc_frame_newslot((Object)stackframe);
  self = obj9984;
  Object *oldselfslot9984 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9984 = (*(struct UserObject *)self).data[0], lowerouter9984 = thisouter9984;
  if (inheritingObject9984) {
    struct UserObject *inho9984 = (struct UserObject *)inheritingObject9984;
    while (inho9984->super != GraceDefaultObject) inho9984 = (struct UserObject *)inho9984->super;
    inho9984->super = obj9984;
    self = inheritingObject9984;
    *selfslot = self;
    lowerouter9984 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9984;
  }
if (objclass9984 == NULL) {
  Method *reader9986 = addmethodrealflags(obj9984, "kind",&reader_ast_kind_9986, MFLAG_DEF);
  reader9986->definitionModule = modulename;
  reader9986->definitionLine = 2455;
}
adddatum2(obj9984, alloc_Undefined(), 1);
if (objclass9984 == NULL) {
  Method *reader9987 = addmethodrealflags(obj9984, "value",&reader_ast_value_9987, MFLAG_DEF);
  reader9987->definitionModule = modulename;
  reader9987->definitionLine = 2456;
}
adddatum2(obj9984, alloc_Undefined(), 2);
// method accept()from
  struct UserObject *uo9988 = (struct UserObject*)obj9984;
  uo9988->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from9988 = addmethod2pos(obj9984, "accept()from", &meth_ast_accept_40__41_from9988, 3);
  int argcv_meth_ast_accept_40__41_from9988[] = {1, 1};
  meth_meth_ast_accept_40__41_from9988->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from9988);
  meth_meth_ast_accept_40__41_from9988->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from9988->definitionLine = 2458;
// method map()ancestors
  struct UserObject *uo9991 = (struct UserObject*)obj9984;
  uo9991->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors9991 = addmethod2pos(obj9984, "map()ancestors", &meth_ast_map_40__41_ancestors9991, 4);
  int argcv_meth_ast_map_40__41_ancestors9991[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors9991->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors9991);
  meth_meth_ast_map_40__41_ancestors9991->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors9991->definitionLine = 2461;
// method nameString
  struct UserObject *uo9998 = (struct UserObject*)obj9984;
  uo9998->data[5] = emptyclosure;
  Method *meth_meth_ast_nameString9998 = addmethod2pos(obj9984, "nameString", &meth_ast_nameString9998, 5);
  int argcv_meth_ast_nameString9998[] = {0};
  meth_meth_ast_nameString9998->type = alloc_MethodType(1, argcv_meth_ast_nameString9998);
  meth_meth_ast_nameString9998->definitionModule = modulename;
  meth_meth_ast_nameString9998->definitionLine = 2466;
// method asString
  struct UserObject *uo10000 = (struct UserObject*)obj9984;
  uo10000->data[6] = emptyclosure;
  Method *meth_meth_ast_asString10000 = addmethod2pos(obj9984, "asString", &meth_ast_asString10000, 6);
  int argcv_meth_ast_asString10000[] = {0};
  meth_meth_ast_asString10000->type = alloc_MethodType(1, argcv_meth_ast_asString10000);
  meth_meth_ast_asString10000->definitionModule = modulename;
  meth_meth_ast_asString10000->definitionLine = 2467;
// method toGrace
  struct UserObject *uo10002 = (struct UserObject*)obj9984;
  uo10002->data[7] = emptyclosure;
  Method *meth_meth_ast_toGrace10002 = addmethod2pos(obj9984, "toGrace", &meth_ast_toGrace10002, 7);
  int argcv_meth_ast_toGrace10002[] = {1};
  meth_meth_ast_toGrace10002->type = alloc_MethodType(1, argcv_meth_ast_toGrace10002);
meth_meth_ast_toGrace10002->type->types[0] = type_Number;
meth_meth_ast_toGrace10002->type->names[0] = "depth";
  meth_meth_ast_toGrace10002->definitionModule = modulename;
  meth_meth_ast_toGrace10002->definitionLine = 2468;
// method shallowCopy
  block_savedest(obj9984);
  Object closure10004 = createclosure(1, "shallowCopy");
  setclosureframe(closure10004, stackframe);
  addtoclosure(closure10004, var_blankNode);
  struct UserObject *uo10004 = (struct UserObject*)obj9984;
  uo10004->data[8] = (Object)closure10004;
  Method *meth_meth_ast_shallowCopy10004 = addmethod2pos(obj9984, "shallowCopy", &meth_ast_shallowCopy10004, 8);
  int argcv_meth_ast_shallowCopy10004[] = {0};
  meth_meth_ast_shallowCopy10004->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy10004);
  meth_meth_ast_shallowCopy10004->definitionModule = modulename;
  meth_meth_ast_shallowCopy10004->definitionLine = 2469;
  sourceObject = obj9984;
// Begin line 2454
  setline(2454);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10009 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call10010 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe10009);
// compiled call node returning call10010 (depth = 4)
  struct UserObject *obj9984_uo = (struct UserObject *)obj9984;
  obj9984_uo->super = call10010;
  sourceObject = obj9984;
// Begin line 2455
  setline(2455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit10011 == NULL) {
    strlit10011 = alloc_String("blank");
    gc_root(strlit10011);
  }
// compiled string node returning strlit10011 (depth = 4)
  adddatum2(obj9984, strlit10011, 1);
  sourceObject = obj9984;
// Begin line 2456
  setline(2456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit10012 == NULL) {
    strlit10012 = alloc_String("blank");
    gc_root(strlit10012);
  }
// compiled string node returning strlit10012 (depth = 4)
  adddatum2(obj9984, strlit10012, 2);
  sourceObject = obj9984;
  sourceObject = obj9984;
  sourceObject = obj9984;
  sourceObject = obj9984;
  sourceObject = obj9984;
  sourceObject = obj9984;
  objclass9984 = obj9984->class;
  objclass9984->definitionModule = modulename;
  objclass9984->definitionLine = 2453;
  (*(struct UserObject *)self).data[0] = lowerouter9984;
  self = oldself9984;
  selfslot = oldselfslot9984;
  stackframe = oldstackframe9984;
  gc_frame_end(frame);
  return obj9984;
}
Object meth_ast_new_40__41_scope10016(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new()scope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method new()scope");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for new()scope (probably reflection error): got %i lists, expected 2.", nparts);
  Object var_init_values = alloc_BuiltinList();
  for (i = 0; i < argcv[0]; i++) {
    callmethod(var_init_values, "push", 1, pushcv, &args[curarg]);
    curarg++;
  }
  Object *var_values = &(stackframe->slots[0]);
  *var_values = var_init_values;
  Object *var_s = &(stackframe->slots[1]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for scope");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "result");
// Begin line 2475
  setline(2475);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_result = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 2476
  setline(2476);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num10019 = alloc_Float64(1);
// compiled num node returning num10019 (depth = 5)
  int op_slot_right_10018 = gc_frame_newslot(num10019);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10021 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call10022 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe10021);
// compiled call node returning call10022 (depth = 6)
// compiled member node returning call10022 (depth = 5)
  int op_slot_left_10018 = gc_frame_newslot(call10022);
  params[0] = num10019;
  partcv[0] = 1;
  Object opresult10023 = callmethod(call10022, "==", 1, partcv, params);
// compiled op node returning opresult10023 (depth = 4)
  Object if10017 = done;
  if (istrue(opresult10023)) {
// Begin line 2477
  setline(2477);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10024 = gc_frame_new();
// starting to compile index node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
// starting to compile num node (depth = 7)
  Object num10025 = alloc_Float64(1);
// compiled num node returning num10025 (depth = 7)
  params[0] = num10025;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres10026 = callmethod(*var_values, "[]", 1, partcv, params);
// compiled index node returning idxres10026 (depth = 6)
  gc_frame_newslot(idxres10026);
// call case 4: self request
  params[0] = idxres10026;
  partcv[0] = 1;
  Object call10027 = callmethodflags(self, "new", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10024);
// compiled call node returning call10027 (depth = 5)
  *var_result = call10027;
  if (call10027 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if10017 = done;
  } else {
// Begin line 2480
  setline(2480);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2478
  setline(2478);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num10031 = alloc_Float64(2);
// compiled num node returning num10031 (depth = 6)
  int op_slot_right_10030 = gc_frame_newslot(num10031);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10033 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call10034 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe10033);
// compiled call node returning call10034 (depth = 7)
// compiled member node returning call10034 (depth = 6)
  int op_slot_left_10030 = gc_frame_newslot(call10034);
  params[0] = num10031;
  partcv[0] = 1;
  Object opresult10035 = callmethod(call10034, "==", 1, partcv, params);
// compiled op node returning opresult10035 (depth = 5)
  Object if10029 = done;
  if (istrue(opresult10035)) {
// Begin line 2479
  setline(2479);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10036 = gc_frame_new();
// starting to compile index node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
// starting to compile num node (depth = 8)
  Object num10037 = alloc_Float64(1);
// compiled num node returning num10037 (depth = 8)
  params[0] = num10037;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres10038 = callmethod(*var_values, "[]", 1, partcv, params);
// compiled index node returning idxres10038 (depth = 7)
  gc_frame_newslot(idxres10038);
// starting to compile index node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
// starting to compile num node (depth = 8)
  Object num10039 = alloc_Float64(2);
// compiled num node returning num10039 (depth = 8)
  params[0] = num10039;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres10040 = callmethod(*var_values, "[]", 1, partcv, params);
// compiled index node returning idxres10040 (depth = 7)
  gc_frame_newslot(idxres10040);
// call case 4: self request
  params[0] = idxres10038;
  params[1] = idxres10040;
  partcv[0] = 2;
  Object call10041 = callmethodflags(self, "new", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10036);
// compiled call node returning call10041 (depth = 6)
  *var_result = call10041;
  if (call10041 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if10029 = done;
  } else {
// Begin line 2481
  setline(2481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10043 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit10044 == NULL) {
    strlit10044 = alloc_String("wrong number of arguments for signaturePart()scope()");
    gc_root(strlit10044);
  }
// compiled string node returning strlit10044 (depth = 6)
  gc_frame_newslot(strlit10044);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10045 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call10046 = callmethodflags(prelude, "ProgrammingError", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10045);
// compiled call node returning call10046 (depth = 7)
// compiled member node returning call10046 (depth = 6)
  params[0] = strlit10044;
  partcv[0] = 1;
  Object call10047 = callmethod(call10046, "raise",
    1, partcv, params);
  gc_frame_end(callframe10043);
// compiled call node returning call10047 (depth = 5)
    gc_frame_newslot(call10047);
    if10029 = call10047;
  }
// compiled if node returning if10029 (depth = 4)
    gc_frame_newslot(if10029);
    if10017 = if10029;
  }
// compiled if node returning if10017 (depth = 3)
// Begin line 2483
  setline(2483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2481
  setline(2481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10048 = gc_frame_new();
// Begin line 2483
  setline(2483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  gc_frame_newslot(*var_s);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call10049 = callmethod(*var_result, "scope:=",
    1, partcv, params);
  gc_frame_end(callframe10048);
// compiled call node returning call10049 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 2484
  setline(2484);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast__apply10067(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 6)
  int callframe10068 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_p (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10069 = callmethod(*var_p, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe10068);
// compiled call node returning call10069 (depth = 6)
  gc_frame_end(frame);
  return call10069;
}
Object meth_ast__apply10094(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_g = &(stackframe->slots[0]);
  *var_g = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe10095 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_visitor (depth = 8)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_newChain (depth = 8)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_g (depth = 8)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10096 = callmethod(*var_g, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe10095);
// compiled call node returning call10096 (depth = 7)
  gc_frame_end(frame);
  return call10096;
}
Object meth_ast_accept_40__41_from10059(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 2510
  setline(2510);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10061 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10062 = callmethod(*var_visitor, "visitSignaturePart()up",
    2, partcv, params);
  gc_frame_end(callframe10061);
// compiled call node returning call10062 (depth = 4)
  Object if10060 = done;
  if (istrue(call10062)) {
// Begin line 2511
  setline(2511);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10063 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call10064 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe10063);
// compiled call node returning call10064 (depth = 5)
  *var_newChain = call10064;
  if (call10064 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2512
  setline(2512);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10065 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block10066 = alloc_Block(NULL, NULL, "ast", 2512);
  gc_frame_newslot(block10066);
// method _apply
  block_savedest(block10066);
  Object closure10067 = createclosure(3, "_apply");
  setclosureframe(closure10067, stackframe);
  addtoclosure(closure10067, var_visitor);
  addtoclosure(closure10067, var_newChain);
  addtoclosure(closure10067, selfslot);
  struct UserObject *uo10067 = (struct UserObject*)block10066;
  uo10067->data[0] = (Object)closure10067;
  Method *meth_meth_ast__apply10067 = addmethod2pos(block10066, "_apply", &meth_ast__apply10067, 0);
  int argcv_meth_ast__apply10067[] = {1};
  meth_meth_ast__apply10067->type = alloc_MethodType(1, argcv_meth_ast__apply10067);
  meth_meth_ast__apply10067->definitionModule = modulename;
  meth_meth_ast__apply10067->definitionLine = 2481;
// compiled block node returning block10066 (depth = 5)
  gc_frame_newslot(block10066);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10071 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10072 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10071);
// compiled call node returning call10072 (depth = 6)
// compiled member node returning call10072 (depth = 5)
  params[0] = block10066;
  partcv[0] = 1;
  Object call10073 = callmethod(call10072, "do",
    1, partcv, params);
  gc_frame_end(callframe10065);
// compiled call node returning call10073 (depth = 4)
// Begin line 2513
  setline(2513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10076 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10077 = callmethodflags(self, "vararg", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10076);
// compiled call node returning call10077 (depth = 7)
// compiled member node returning call10077 (depth = 6)
  int op_slot_right_10075 = gc_frame_newslot(call10077);
// starting to compile identifier node (depth = 6)
  Object bool10079 = alloc_Boolean(0);
// compiled identifier node returning bool10079 (depth = 6)
  int op_slot_left_10075 = gc_frame_newslot(bool10079);
  params[0] = call10077;
  partcv[0] = 1;
  Object opresult10080 = callmethod(bool10079, "!=", 1, partcv, params);
// compiled op node returning opresult10080 (depth = 5)
  Object if10074 = done;
  if (istrue(opresult10080)) {
// starting to compile call node (depth = 5)
  int callframe10081 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10082 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10083 = callmethodflags(self, "vararg", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10082);
// compiled call node returning call10083 (depth = 7)
// compiled member node returning call10083 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10084 = callmethod(call10083, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe10081);
// compiled call node returning call10084 (depth = 5)
    gc_frame_newslot(call10084);
    if10074 = call10084;
  } else {
  }
// compiled if node returning if10074 (depth = 4)
// Begin line 2514
  setline(2514);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10087 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10088 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10087);
// compiled call node returning call10088 (depth = 7)
// compiled member node returning call10088 (depth = 6)
  int op_slot_right_10086 = gc_frame_newslot(call10088);
// starting to compile identifier node (depth = 6)
  Object bool10090 = alloc_Boolean(0);
// compiled identifier node returning bool10090 (depth = 6)
  int op_slot_left_10086 = gc_frame_newslot(bool10090);
  params[0] = call10088;
  partcv[0] = 1;
  Object opresult10091 = callmethod(bool10090, "!=", 1, partcv, params);
// compiled op node returning opresult10091 (depth = 5)
  Object if10085 = done;
  if (istrue(opresult10091)) {
// Begin line 2515
  setline(2515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10092 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block10093 = alloc_Block(NULL, NULL, "ast", 2515);
  gc_frame_newslot(block10093);
// method _apply
  block_savedest(block10093);
  Object closure10094 = createclosure(3, "_apply");
  setclosureframe(closure10094, stackframe);
  addtoclosure(closure10094, var_visitor);
  addtoclosure(closure10094, var_newChain);
  addtoclosure(closure10094, selfslot);
  struct UserObject *uo10094 = (struct UserObject*)block10093;
  uo10094->data[0] = (Object)closure10094;
  Method *meth_meth_ast__apply10094 = addmethod2pos(block10093, "_apply", &meth_ast__apply10094, 0);
  int argcv_meth_ast__apply10094[] = {1};
  meth_meth_ast__apply10094->type = alloc_MethodType(1, argcv_meth_ast__apply10094);
  meth_meth_ast__apply10094->definitionModule = modulename;
  meth_meth_ast__apply10094->definitionLine = 2514;
// compiled block node returning block10093 (depth = 6)
  gc_frame_newslot(block10093);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10098 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10099 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10098);
// compiled call node returning call10099 (depth = 7)
// compiled member node returning call10099 (depth = 6)
  params[0] = block10093;
  partcv[0] = 1;
  Object call10100 = callmethod(call10099, "do",
    1, partcv, params);
  gc_frame_end(callframe10092);
// compiled call node returning call10100 (depth = 5)
    gc_frame_newslot(call10100);
    if10085 = call10100;
  } else {
  }
// compiled if node returning if10085 (depth = 4)
    gc_frame_newslot(if10085);
    if10060 = if10085;
  } else {
  }
// compiled if node returning if10060 (depth = 3)
  gc_frame_end(frame);
  return if10060;
}
Object meth_ast_declarationKindWithAncestors10101(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "declarationKindWithAncestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method declarationKindWithAncestors");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for declarationKindWithAncestors (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for declarationKindWithAncestors");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2519
  setline(2519);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit10102 == NULL) {
    strlit10102 = alloc_String("parameter");
    gc_root(strlit10102);
  }
// compiled string node returning strlit10102 (depth = 3)
  gc_frame_end(frame);
  return strlit10102;
}
Object meth_ast_map_40__41_ancestors10103(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2521
  setline(2521);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10104 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10105 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10104);
// compiled call node returning call10105 (depth = 5)
// compiled member node returning call10105 (depth = 4)
  *var_n = call10105;
  if (call10105 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2522
  setline(2522);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10106 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call10107 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe10106);
// compiled call node returning call10107 (depth = 4)
  *var_newChain = call10107;
  if (call10107 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2523
  setline(2523);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2521
  setline(2521);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10108 = gc_frame_new();
// Begin line 2523
  setline(2523);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10109 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10110 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10111 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10110);
// compiled call node returning call10111 (depth = 7)
// compiled member node returning call10111 (depth = 6)
  gc_frame_newslot(call10111);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10112 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10113 = gc_frame_new();
// call case 3: self.outer request
  Object call10114 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe10113);
// compiled call node returning call10114 (depth = 9)
// compiled member node returning call10114 (depth = 8)
  partcv[0] = 0;
  Object call10115 = callmethodflags(call10114, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10112);
// compiled call node returning call10115 (depth = 7)
// compiled member node returning call10115 (depth = 6)
  params[0] = call10111;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call10116 = callmethodflags(call10115, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10109);
// compiled call node returning call10116 (depth = 5)
  gc_frame_newslot(call10116);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  params[0] = call10116;
  partcv[0] = 1;
  Object call10117 = callmethod(*var_n, "params:=",
    1, partcv, params);
  gc_frame_end(callframe10108);
// compiled call node returning call10117 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 2524
  setline(2524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2523
  setline(2523);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10118 = gc_frame_new();
// Begin line 2524
  setline(2524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10119 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10120 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10121 = callmethodflags(self, "vararg", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10120);
// compiled call node returning call10121 (depth = 7)
// compiled member node returning call10121 (depth = 6)
  gc_frame_newslot(call10121);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10122 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10123 = gc_frame_new();
// call case 3: self.outer request
  Object call10124 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe10123);
// compiled call node returning call10124 (depth = 9)
// compiled member node returning call10124 (depth = 8)
  partcv[0] = 0;
  Object call10125 = callmethodflags(call10124, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10122);
// compiled call node returning call10125 (depth = 7)
// compiled member node returning call10125 (depth = 6)
  params[0] = call10121;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call10126 = callmethodflags(call10125, "maybeMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10119);
// compiled call node returning call10126 (depth = 5)
  gc_frame_newslot(call10126);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  params[0] = call10126;
  partcv[0] = 1;
  Object call10127 = callmethod(*var_n, "vararg:=",
    1, partcv, params);
  gc_frame_end(callframe10118);
// compiled call node returning call10127 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 2525
  setline(2525);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10128 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call10129 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe10128);
// compiled call node returning call10129 (depth = 3)
  gc_frame_end(frame);
  return call10129;
}
Object meth_ast__apply10138(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2530
  setline(2530);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10140 == NULL) {
    strlit10140 = alloc_String("  ");
    gc_root(strlit10140);
  }
// compiled string node returning strlit10140 (depth = 7)
  int op_slot_right_10139 = gc_frame_newslot(strlit10140);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_10139 = gc_frame_newslot(*var_spc);
  params[0] = strlit10140;
  partcv[0] = 1;
  Object opresult10142 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult10142 (depth = 6)
  *var_spc = opresult10142;
  if (opresult10142 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply10192(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2535
  setline(2535);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10194 == NULL) {
    strlit10194 = alloc_String("");
    gc_root(strlit10194);
  }
// compiled string node returning strlit10194 (depth = 7)
  int op_slot_right_10193 = gc_frame_newslot(strlit10194);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10197 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num10199 = alloc_Float64(2);
// compiled num node returning num10199 (depth = 10)
  int op_slot_right_10198 = gc_frame_newslot(num10199);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_10198 = gc_frame_newslot(*var_depth);
  params[0] = num10199;
  partcv[0] = 1;
  Object sum10201 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum10201 (depth = 9)
  gc_frame_newslot(sum10201);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_p (depth = 9)
  params[0] = sum10201;
  partcv[0] = 1;
  Object call10202 = callmethod(*var_p, "pretty",
    1, partcv, params);
  gc_frame_end(callframe10197);
// compiled call node returning call10202 (depth = 8)
  int op_slot_right_10196 = gc_frame_newslot(call10202);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit10205 == NULL) {
    strlit10205 = alloc_String("");
    gc_root(strlit10205);
  }
// compiled string node returning strlit10205 (depth = 9)
  int op_slot_right_10204 = gc_frame_newslot(strlit10205);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_10207 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit10210 == NULL) {
    strlit10210 = alloc_String("""\x0a""  ");
    gc_root(strlit10210);
  }
// compiled string node returning strlit10210 (depth = 11)
  int op_slot_right_10209 = gc_frame_newslot(strlit10210);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_s (depth = 12)
  int op_slot_right_10212 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 12)
  if (strlit10214 == NULL) {
    strlit10214 = alloc_String("");
    gc_root(strlit10214);
  }
// compiled string node returning strlit10214 (depth = 12)
  int op_slot_left_10212 = gc_frame_newslot(strlit10214);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult10215 = callmethod(strlit10214, "++", 1, partcv, params);
// compiled op node returning opresult10215 (depth = 11)
  int op_slot_left_10209 = gc_frame_newslot(opresult10215);
  params[0] = strlit10210;
  partcv[0] = 1;
  Object opresult10216 = callmethod(opresult10215, "++", 1, partcv, params);
// compiled op node returning opresult10216 (depth = 10)
  int op_slot_left_10207 = gc_frame_newslot(opresult10216);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult10217 = callmethod(opresult10216, "++", 1, partcv, params);
// compiled op node returning opresult10217 (depth = 9)
  int op_slot_left_10204 = gc_frame_newslot(opresult10217);
  params[0] = strlit10205;
  partcv[0] = 1;
  Object opresult10218 = callmethod(opresult10217, "++", 1, partcv, params);
// compiled op node returning opresult10218 (depth = 8)
  int op_slot_left_10196 = gc_frame_newslot(opresult10218);
  params[0] = call10202;
  partcv[0] = 1;
  Object opresult10219 = callmethod(opresult10218, "++", 1, partcv, params);
// compiled op node returning opresult10219 (depth = 7)
  int op_slot_left_10193 = gc_frame_newslot(opresult10219);
  params[0] = strlit10194;
  partcv[0] = 1;
  Object opresult10220 = callmethod(opresult10219, "++", 1, partcv, params);
// compiled op node returning opresult10220 (depth = 6)
  *var_s = opresult10220;
  if (opresult10220 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty10130(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2528
  setline(2528);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit10131 == NULL) {
    strlit10131 = alloc_String("");
    gc_root(strlit10131);
  }
// compiled string node returning strlit10131 (depth = 4)
  *var_spc = strlit10131;
  if (strlit10131 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2529
  setline(2529);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10132 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_10133 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num10135 = alloc_Float64(0);
// compiled num node returning num10135 (depth = 5)
  int op_slot_left_10133 = gc_frame_newslot(num10135);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult10136 = callmethod(num10135, "..", 1, partcv, params);
// compiled op node returning opresult10136 (depth = 4)
  gc_frame_newslot(opresult10136);
// starting to compile block node (depth = 4)
  Object block10137 = alloc_Block(NULL, NULL, "ast", 2529);
  gc_frame_newslot(block10137);
// method _apply
  block_savedest(block10137);
  Object closure10138 = createclosure(2, "_apply");
  setclosureframe(closure10138, stackframe);
  addtoclosure(closure10138, var_spc);
  addtoclosure(closure10138, selfslot);
  struct UserObject *uo10138 = (struct UserObject*)block10137;
  uo10138->data[0] = (Object)closure10138;
  Method *meth_meth_ast__apply10138 = addmethod2pos(block10137, "_apply", &meth_ast__apply10138, 0);
  int argcv_meth_ast__apply10138[] = {1};
  meth_meth_ast__apply10138->type = alloc_MethodType(1, argcv_meth_ast__apply10138);
  meth_meth_ast__apply10138->definitionModule = modulename;
  meth_meth_ast__apply10138->definitionLine = 2524;
// compiled block node returning block10137 (depth = 4)
  gc_frame_newslot(block10137);
// call case 5: prelude request
  params[0] = opresult10136;
  params[1] = block10137;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10145 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10132);
// compiled call node returning call10145 (depth = 3)
// Begin line 2532
  setline(2532);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit10147 == NULL) {
    strlit10147 = alloc_String("");
    gc_root(strlit10147);
  }
// compiled string node returning strlit10147 (depth = 5)
  int op_slot_right_10146 = gc_frame_newslot(strlit10147);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10150 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10151 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10150);
// compiled call node returning call10151 (depth = 7)
// compiled member node returning call10151 (depth = 6)
  int op_slot_right_10149 = gc_frame_newslot(call10151);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10154 == NULL) {
    strlit10154 = alloc_String(": ");
    gc_root(strlit10154);
  }
// compiled string node returning strlit10154 (depth = 7)
  int op_slot_right_10153 = gc_frame_newslot(strlit10154);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10157 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call10158 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe10157);
// compiled call node returning call10158 (depth = 8)
  int op_slot_right_10156 = gc_frame_newslot(call10158);
// starting to compile string node (depth = 8)
  if (strlit10160 == NULL) {
    strlit10160 = alloc_String("");
    gc_root(strlit10160);
  }
// compiled string node returning strlit10160 (depth = 8)
  int op_slot_left_10156 = gc_frame_newslot(strlit10160);
  params[0] = call10158;
  partcv[0] = 1;
  Object opresult10161 = callmethod(strlit10160, "++", 1, partcv, params);
// compiled op node returning opresult10161 (depth = 7)
  int op_slot_left_10153 = gc_frame_newslot(opresult10161);
  params[0] = strlit10154;
  partcv[0] = 1;
  Object opresult10162 = callmethod(opresult10161, "++", 1, partcv, params);
// compiled op node returning opresult10162 (depth = 6)
  int op_slot_left_10149 = gc_frame_newslot(opresult10162);
  params[0] = call10151;
  partcv[0] = 1;
  Object opresult10163 = callmethod(opresult10162, "++", 1, partcv, params);
// compiled op node returning opresult10163 (depth = 5)
  int op_slot_left_10146 = gc_frame_newslot(opresult10163);
  params[0] = strlit10147;
  partcv[0] = 1;
  Object opresult10164 = callmethod(opresult10163, "++", 1, partcv, params);
// compiled op node returning opresult10164 (depth = 4)
  *var_s = opresult10164;
  if (opresult10164 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2533
  setline(2533);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10166 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10167 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10168 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10169 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10168);
// compiled call node returning call10169 (depth = 9)
// compiled member node returning call10169 (depth = 8)
  partcv[0] = 0;
  Object call10170 = callmethod(call10169, "isEmpty",
    1, partcv, params);
  gc_frame_end(callframe10167);
// compiled call node returning call10170 (depth = 7)
// compiled member node returning call10170 (depth = 6)
  partcv[0] = 0;
  Object call10171 = callmethod(call10170, "not",
    1, partcv, params);
  gc_frame_end(callframe10166);
// compiled call node returning call10171 (depth = 5)
// compiled member node returning call10171 (depth = 4)
  Object if10165 = done;
  if (istrue(call10171)) {
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10173 == NULL) {
    strlit10173 = alloc_String("Parameters:");
    gc_root(strlit10173);
  }
// compiled string node returning strlit10173 (depth = 6)
  int op_slot_right_10172 = gc_frame_newslot(strlit10173);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_10175 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit10178 == NULL) {
    strlit10178 = alloc_String("""\x0a""");
    gc_root(strlit10178);
  }
// compiled string node returning strlit10178 (depth = 8)
  int op_slot_right_10177 = gc_frame_newslot(strlit10178);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_right_10180 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 9)
  if (strlit10182 == NULL) {
    strlit10182 = alloc_String("");
    gc_root(strlit10182);
  }
// compiled string node returning strlit10182 (depth = 9)
  int op_slot_left_10180 = gc_frame_newslot(strlit10182);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult10183 = callmethod(strlit10182, "++", 1, partcv, params);
// compiled op node returning opresult10183 (depth = 8)
  int op_slot_left_10177 = gc_frame_newslot(opresult10183);
  params[0] = strlit10178;
  partcv[0] = 1;
  Object opresult10184 = callmethod(opresult10183, "++", 1, partcv, params);
// compiled op node returning opresult10184 (depth = 7)
  int op_slot_left_10175 = gc_frame_newslot(opresult10184);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult10185 = callmethod(opresult10184, "++", 1, partcv, params);
// compiled op node returning opresult10185 (depth = 6)
  int op_slot_left_10172 = gc_frame_newslot(opresult10185);
  params[0] = strlit10173;
  partcv[0] = 1;
  Object opresult10186 = callmethod(opresult10185, "++", 1, partcv, params);
// compiled op node returning opresult10186 (depth = 5)
  *var_s = opresult10186;
  if (opresult10186 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if10165 = done;
  } else {
  }
// compiled if node returning if10165 (depth = 3)
// Begin line 2534
  setline(2534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10188 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10189 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10190 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10189);
// compiled call node returning call10190 (depth = 5)
// compiled member node returning call10190 (depth = 4)
  gc_frame_newslot(call10190);
// starting to compile block node (depth = 4)
  Object block10191 = alloc_Block(NULL, NULL, "ast", 2534);
  gc_frame_newslot(block10191);
// method _apply
  block_savedest(block10191);
  Object closure10192 = createclosure(4, "_apply");
  setclosureframe(closure10192, stackframe);
  addtoclosure(closure10192, var_depth);
  addtoclosure(closure10192, var_spc);
  addtoclosure(closure10192, var_s);
  addtoclosure(closure10192, selfslot);
  struct UserObject *uo10192 = (struct UserObject*)block10191;
  uo10192->data[0] = (Object)closure10192;
  Method *meth_meth_ast__apply10192 = addmethod2pos(block10191, "_apply", &meth_ast__apply10192, 0);
  int argcv_meth_ast__apply10192[] = {1};
  meth_meth_ast__apply10192->type = alloc_MethodType(1, argcv_meth_ast__apply10192);
  meth_meth_ast__apply10192->definitionModule = modulename;
  meth_meth_ast__apply10192->definitionLine = 2534;
// compiled block node returning block10191 (depth = 4)
  gc_frame_newslot(block10191);
// call case 5: prelude request
  params[0] = call10190;
  params[1] = block10191;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10223 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10188);
// compiled call node returning call10223 (depth = 3)
// Begin line 2537
  setline(2537);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool10226 = alloc_Boolean(0);
// compiled identifier node returning bool10226 (depth = 5)
  int op_slot_right_10225 = gc_frame_newslot(bool10226);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10228 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10229 = callmethodflags(self, "vararg", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10228);
// compiled call node returning call10229 (depth = 6)
// compiled member node returning call10229 (depth = 5)
  int op_slot_left_10225 = gc_frame_newslot(call10229);
  params[0] = bool10226;
  partcv[0] = 1;
  Object opresult10230 = callmethod(call10229, "!=", 1, partcv, params);
// compiled op node returning opresult10230 (depth = 4)
  Object if10224 = done;
  if (istrue(opresult10230)) {
// Begin line 2538
  setline(2538);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10232 == NULL) {
    strlit10232 = alloc_String("");
    gc_root(strlit10232);
  }
// compiled string node returning strlit10232 (depth = 6)
  int op_slot_right_10231 = gc_frame_newslot(strlit10232);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10235 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num10237 = alloc_Float64(1);
// compiled num node returning num10237 (depth = 9)
  int op_slot_right_10236 = gc_frame_newslot(num10237);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_10236 = gc_frame_newslot(*var_depth);
  params[0] = num10237;
  partcv[0] = 1;
  Object sum10239 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum10239 (depth = 8)
  gc_frame_newslot(sum10239);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10240 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10241 = callmethodflags(self, "vararg", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10240);
// compiled call node returning call10241 (depth = 9)
// compiled member node returning call10241 (depth = 8)
  params[0] = sum10239;
  partcv[0] = 1;
  Object call10242 = callmethod(call10241, "pretty",
    1, partcv, params);
  gc_frame_end(callframe10235);
// compiled call node returning call10242 (depth = 7)
  int op_slot_right_10234 = gc_frame_newslot(call10242);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit10245 == NULL) {
    strlit10245 = alloc_String("Vararg: ");
    gc_root(strlit10245);
  }
// compiled string node returning strlit10245 (depth = 8)
  int op_slot_right_10244 = gc_frame_newslot(strlit10245);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_10247 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit10250 == NULL) {
    strlit10250 = alloc_String("""\x0a""  ");
    gc_root(strlit10250);
  }
// compiled string node returning strlit10250 (depth = 10)
  int op_slot_right_10249 = gc_frame_newslot(strlit10250);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_right_10252 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 11)
  if (strlit10254 == NULL) {
    strlit10254 = alloc_String("");
    gc_root(strlit10254);
  }
// compiled string node returning strlit10254 (depth = 11)
  int op_slot_left_10252 = gc_frame_newslot(strlit10254);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult10255 = callmethod(strlit10254, "++", 1, partcv, params);
// compiled op node returning opresult10255 (depth = 10)
  int op_slot_left_10249 = gc_frame_newslot(opresult10255);
  params[0] = strlit10250;
  partcv[0] = 1;
  Object opresult10256 = callmethod(opresult10255, "++", 1, partcv, params);
// compiled op node returning opresult10256 (depth = 9)
  int op_slot_left_10247 = gc_frame_newslot(opresult10256);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult10257 = callmethod(opresult10256, "++", 1, partcv, params);
// compiled op node returning opresult10257 (depth = 8)
  int op_slot_left_10244 = gc_frame_newslot(opresult10257);
  params[0] = strlit10245;
  partcv[0] = 1;
  Object opresult10258 = callmethod(opresult10257, "++", 1, partcv, params);
// compiled op node returning opresult10258 (depth = 7)
  int op_slot_left_10234 = gc_frame_newslot(opresult10258);
  params[0] = call10242;
  partcv[0] = 1;
  Object opresult10259 = callmethod(opresult10258, "++", 1, partcv, params);
// compiled op node returning opresult10259 (depth = 6)
  int op_slot_left_10231 = gc_frame_newslot(opresult10259);
  params[0] = strlit10232;
  partcv[0] = 1;
  Object opresult10260 = callmethod(opresult10259, "++", 1, partcv, params);
// compiled op node returning opresult10260 (depth = 5)
  *var_s = opresult10260;
  if (opresult10260 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if10224 = done;
  } else {
  }
// compiled if node returning if10224 (depth = 3)
// Begin line 2540
  setline(2540);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy10262(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_signaturePart = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2543
  setline(2543);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10263 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe10264 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10265 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10266 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10265);
// compiled call node returning call10266 (depth = 6)
// compiled member node returning call10266 (depth = 5)
  gc_frame_newslot(call10266);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_signaturePart (depth = 5)
  params[0] = call10266;
  partcv[0] = 1;
  Object call10267 = callmethod(*var_signaturePart, "new",
    1, partcv, params);
  gc_frame_end(callframe10264);
// compiled call node returning call10267 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call10268 = callmethod(call10267, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe10263);
// compiled call node returning call10268 (depth = 3)
  gc_frame_end(frame);
  return call10268;
}
Object meth_ast_shallowCopyFieldsFrom10269(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyFieldsFrom");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopyFieldsFrom (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyFieldsFrom");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2546
  setline(2546);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10270 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call10271 = callmethod4(self, "shallowCopyFieldsFrom", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe10270);
// compiled call node returning call10271 (depth = 3)
// Begin line 2547
  setline(2547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2543
  setline(2543);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10272 = gc_frame_new();
// Begin line 2547
  setline(2547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10273 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  partcv[0] = 0;
  Object call10274 = callmethod(*var_other, "lineLength",
    1, partcv, params);
  gc_frame_end(callframe10273);
// compiled call node returning call10274 (depth = 6)
// compiled member node returning call10274 (depth = 5)
  gc_frame_newslot(call10274);
// call case 4: self request
  params[0] = call10274;
  partcv[0] = 1;
  Object call10275 = callmethodflags(self, "lineLength:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10272);
// compiled call node returning call10275 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 2548
  setline(2548);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_asString10276(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2551
  setline(2551);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit10278 == NULL) {
    strlit10278 = alloc_String("");
    gc_root(strlit10278);
  }
// compiled string node returning strlit10278 (depth = 4)
  int op_slot_right_10277 = gc_frame_newslot(strlit10278);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10281 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10282 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10281);
// compiled call node returning call10282 (depth = 6)
// compiled member node returning call10282 (depth = 5)
  int op_slot_right_10280 = gc_frame_newslot(call10282);
// starting to compile string node (depth = 5)
  if (strlit10284 == NULL) {
    strlit10284 = alloc_String("part: ");
    gc_root(strlit10284);
  }
// compiled string node returning strlit10284 (depth = 5)
  int op_slot_left_10280 = gc_frame_newslot(strlit10284);
  params[0] = call10282;
  partcv[0] = 1;
  Object opresult10285 = callmethod(strlit10284, "++", 1, partcv, params);
// compiled op node returning opresult10285 (depth = 4)
  int op_slot_left_10277 = gc_frame_newslot(opresult10285);
  params[0] = strlit10278;
  partcv[0] = 1;
  Object opresult10286 = callmethod(opresult10285, "++", 1, partcv, params);
// compiled op node returning opresult10286 (depth = 3)
  gc_frame_end(frame);
  return opresult10286;
}
Object meth_ast_new10050(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_signaturePart = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object var_init_values = alloc_BuiltinList();
  for (i = 0; i < argcv[0]; i++) {
    callmethod(var_init_values, "push", 1, pushcv, &args[curarg]);
    curarg++;
  }
  Object *var_values = &(stackframe->slots[0]);
  *var_values = var_init_values;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject10051 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj10051 = alloc_userobj2(22,18, objclass10051);
  gc_frame_newslot(obj10051);
if (objclass10051 == NULL) {
  glfree(obj10051->class->name);
  obj10051->class->name = "obj10014.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj10051, self, 0);
  addmethodreal(obj10051,"outer", &reader_ast_outer_10052);
  Object oldself10051 = self;
  struct StackFrameObject *oldstackframe10051 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe10051);
  gc_frame_newslot((Object)stackframe);
  self = obj10051;
  Object *oldselfslot10051 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter10051 = (*(struct UserObject *)self).data[0], lowerouter10051 = thisouter10051;
  if (inheritingObject10051) {
    struct UserObject *inho10051 = (struct UserObject *)inheritingObject10051;
    while (inho10051->super != GraceDefaultObject) inho10051 = (struct UserObject *)inho10051->super;
    inho10051->super = obj10051;
    self = inheritingObject10051;
    *selfslot = self;
    lowerouter10051 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter10051;
  }
if (objclass10051 == NULL) {
  Method *reader10053 = addmethodrealflags(obj10051, "kind",&reader_ast_kind_10053, MFLAG_DEF);
  reader10053->definitionModule = modulename;
  reader10053->definitionLine = 2494;
}
adddatum2(obj10051, alloc_Undefined(), 1);
if (objclass10051 == NULL) {
  Method *reader10054 = addmethodrealflags(obj10051, "name",&reader_ast_name_10054, 0);
  Method *writer10054 = addmethodrealflags(obj10051, "name:=",&writer_ast_name_10054, 0);
  reader10054->definitionModule = modulename;
  writer10054->definitionModule = modulename;
  reader10054->definitionLine = 2495;
  writer10054->definitionLine = 2495;
}
obj10051->flags |= OFLAG_MUTABLE;
adddatum2(obj10051, alloc_Undefined(), 2);
if (objclass10051 == NULL) {
  Method *reader10055 = addmethodrealflags(obj10051, "params",&reader_ast_params_10055, 0);
  Method *writer10055 = addmethodrealflags(obj10051, "params:=",&writer_ast_params_10055, 0);
  reader10055->definitionModule = modulename;
  writer10055->definitionModule = modulename;
  reader10055->definitionLine = 2496;
  writer10055->definitionLine = 2496;
}
obj10051->flags |= OFLAG_MUTABLE;
adddatum2(obj10051, alloc_Undefined(), 3);
if (objclass10051 == NULL) {
  Method *reader10056 = addmethodrealflags(obj10051, "vararg",&reader_ast_vararg_10056, 0);
  Method *writer10056 = addmethodrealflags(obj10051, "vararg:=",&writer_ast_vararg_10056, 0);
  reader10056->definitionModule = modulename;
  writer10056->definitionModule = modulename;
  reader10056->definitionLine = 2497;
  writer10056->definitionLine = 2497;
}
obj10051->flags |= OFLAG_MUTABLE;
adddatum2(obj10051, alloc_Undefined(), 4);
if (objclass10051 == NULL) {
  Method *reader10057 = addmethodrealflags(obj10051, "generics",&reader_ast_generics_10057, 0);
  Method *writer10057 = addmethodrealflags(obj10051, "generics:=",&writer_ast_generics_10057, 0);
  reader10057->definitionModule = modulename;
  writer10057->definitionModule = modulename;
  reader10057->definitionLine = 2498;
  writer10057->definitionLine = 2498;
}
obj10051->flags |= OFLAG_MUTABLE;
adddatum2(obj10051, alloc_Undefined(), 5);
if (objclass10051 == NULL) {
  Method *reader10058 = addmethodrealflags(obj10051, "lineLength",&reader_ast_lineLength_10058, 0);
  Method *writer10058 = addmethodrealflags(obj10051, "lineLength:=",&writer_ast_lineLength_10058, 0);
  reader10058->definitionModule = modulename;
  writer10058->definitionModule = modulename;
  reader10058->definitionLine = 2499;
  writer10058->definitionLine = 2499;
}
obj10051->flags |= OFLAG_MUTABLE;
adddatum2(obj10051, alloc_Undefined(), 6);
// method accept()from
  struct UserObject *uo10059 = (struct UserObject*)obj10051;
  uo10059->data[7] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from10059 = addmethod2pos(obj10051, "accept()from", &meth_ast_accept_40__41_from10059, 7);
  int argcv_meth_ast_accept_40__41_from10059[] = {1, 1};
  meth_meth_ast_accept_40__41_from10059->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from10059);
  meth_meth_ast_accept_40__41_from10059->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from10059->definitionLine = 2509;
// method declarationKindWithAncestors
  struct UserObject *uo10101 = (struct UserObject*)obj10051;
  uo10101->data[8] = emptyclosure;
  Method *meth_meth_ast_declarationKindWithAncestors10101 = addmethod2pos(obj10051, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors10101, 8);
  int argcv_meth_ast_declarationKindWithAncestors10101[] = {1};
  meth_meth_ast_declarationKindWithAncestors10101->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors10101);
  meth_meth_ast_declarationKindWithAncestors10101->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors10101->definitionLine = 2519;
// method map()ancestors
  struct UserObject *uo10103 = (struct UserObject*)obj10051;
  uo10103->data[9] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors10103 = addmethod2pos(obj10051, "map()ancestors", &meth_ast_map_40__41_ancestors10103, 9);
  int argcv_meth_ast_map_40__41_ancestors10103[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors10103->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors10103);
  meth_meth_ast_map_40__41_ancestors10103->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors10103->definitionLine = 2520;
// method pretty
  struct UserObject *uo10130 = (struct UserObject*)obj10051;
  uo10130->data[10] = emptyclosure;
  Method *meth_meth_ast_pretty10130 = addmethod2pos(obj10051, "pretty", &meth_ast_pretty10130, 10);
  int argcv_meth_ast_pretty10130[] = {1};
  meth_meth_ast_pretty10130->type = alloc_MethodType(1, argcv_meth_ast_pretty10130);
  meth_meth_ast_pretty10130->definitionModule = modulename;
  meth_meth_ast_pretty10130->definitionLine = 2527;
// method shallowCopy
  block_savedest(obj10051);
  Object closure10262 = createclosure(1, "shallowCopy");
  setclosureframe(closure10262, stackframe);
  addtoclosure(closure10262, var_signaturePart);
  struct UserObject *uo10262 = (struct UserObject*)obj10051;
  uo10262->data[11] = (Object)closure10262;
  Method *meth_meth_ast_shallowCopy10262 = addmethod2pos(obj10051, "shallowCopy", &meth_ast_shallowCopy10262, 11);
  int argcv_meth_ast_shallowCopy10262[] = {0};
  meth_meth_ast_shallowCopy10262->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy10262);
  meth_meth_ast_shallowCopy10262->definitionModule = modulename;
  meth_meth_ast_shallowCopy10262->definitionLine = 2542;
// method shallowCopyFieldsFrom
  struct UserObject *uo10269 = (struct UserObject*)obj10051;
  uo10269->data[12] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom10269 = addmethod2pos(obj10051, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom10269, 12);
  int argcv_meth_ast_shallowCopyFieldsFrom10269[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom10269->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom10269);
  meth_meth_ast_shallowCopyFieldsFrom10269->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom10269->definitionLine = 2545;
// method asString
  struct UserObject *uo10276 = (struct UserObject*)obj10051;
  uo10276->data[13] = emptyclosure;
  Method *meth_meth_ast_asString10276 = addmethod2pos(obj10051, "asString", &meth_ast_asString10276, 13);
  int argcv_meth_ast_asString10276[] = {0};
  meth_meth_ast_asString10276->type = alloc_MethodType(1, argcv_meth_ast_asString10276);
  meth_meth_ast_asString10276->definitionModule = modulename;
  meth_meth_ast_asString10276->definitionLine = 2550;
  sourceObject = obj10051;
// Begin line 2493
  setline(2493);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10287 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_baseNode (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call10288 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe10287);
// compiled call node returning call10288 (depth = 3)
  struct UserObject *obj10051_uo = (struct UserObject *)obj10051;
  obj10051_uo->super = call10288;
  sourceObject = obj10051;
// Begin line 2494
  setline(2494);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit10289 == NULL) {
    strlit10289 = alloc_String("signaturepart");
    gc_root(strlit10289);
  }
// compiled string node returning strlit10289 (depth = 3)
  adddatum2(obj10051, strlit10289, 1);
  sourceObject = obj10051;
// Begin line 2495
  setline(2495);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit10290 == NULL) {
    strlit10290 = alloc_String("");
    gc_root(strlit10290);
  }
// compiled string node returning strlit10290 (depth = 3)
  adddatum2(obj10051, strlit10290, 2);
  sourceObject = obj10051;
// Begin line 2496
  setline(2496);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10291 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10292 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call10293 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10292);
// compiled call node returning call10293 (depth = 6)
// compiled member node returning call10293 (depth = 5)
  partcv[0] = 0;
  Object call10294 = callmethod(call10293, "empty",
    1, partcv, params);
  gc_frame_end(callframe10291);
// compiled call node returning call10294 (depth = 4)
// compiled member node returning call10294 (depth = 3)
  adddatum2(obj10051, call10294, 3);
  sourceObject = obj10051;
// Begin line 2497
  setline(2497);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10295 = alloc_Boolean(0);
// compiled identifier node returning bool10295 (depth = 3)
  adddatum2(obj10051, bool10295, 4);
  sourceObject = obj10051;
// Begin line 2498
  setline(2498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10296 = alloc_Boolean(0);
// compiled identifier node returning bool10296 (depth = 3)
  adddatum2(obj10051, bool10296, 5);
  sourceObject = obj10051;
// Begin line 2499
  setline(2499);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num10297 = alloc_Float64(0);
// compiled num node returning num10297 (depth = 3)
  adddatum2(obj10051, num10297, 6);
  sourceObject = obj10051;
// Begin line 2500
  setline(2500);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num10300 = alloc_Float64(0);
// compiled num node returning num10300 (depth = 5)
  int op_slot_right_10299 = gc_frame_newslot(num10300);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10302 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call10303 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe10302);
// compiled call node returning call10303 (depth = 6)
// compiled member node returning call10303 (depth = 5)
  int op_slot_left_10299 = gc_frame_newslot(call10303);
  params[0] = num10300;
  partcv[0] = 1;
  Object opresult10304 = callmethod(call10303, ">", 1, partcv, params);
// compiled op node returning opresult10304 (depth = 4)
  Object if10298 = done;
struct StackFrameObject *iftmpstackframe10298 = stackframe;
  if (istrue(opresult10304)) {
stackframe = alloc_StackFrame(0, iftmpstackframe10298);
gc_frame_newslot((Object)stackframe);
// Begin line 2501
  setline(2501);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2500
  setline(2500);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10305 = gc_frame_new();
// Begin line 2502
  setline(2502);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile index node (depth = 6)
// Begin line 2501
  setline(2501);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
// starting to compile num node (depth = 7)
  Object num10306 = alloc_Float64(1);
// compiled num node returning num10306 (depth = 7)
  params[0] = num10306;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres10307 = callmethod(*var_values, "[]", 1, partcv, params);
// compiled index node returning idxres10307 (depth = 6)
  gc_frame_newslot(idxres10307);
// call case 4: self request
  params[0] = idxres10307;
  partcv[0] = 1;
  Object call10308 = callmethodflags(self, "name:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10305);
// compiled call node returning call10308 (depth = 5)
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if10298 = done;
  } else {
  }
stackframe = iftmpstackframe10298;
// compiled if node returning if10298 (depth = 3)
  sourceObject = obj10051;
// Begin line 2503
  setline(2503);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num10311 = alloc_Float64(1);
// compiled num node returning num10311 (depth = 5)
  int op_slot_right_10310 = gc_frame_newslot(num10311);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10313 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call10314 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe10313);
// compiled call node returning call10314 (depth = 6)
// compiled member node returning call10314 (depth = 5)
  int op_slot_left_10310 = gc_frame_newslot(call10314);
  params[0] = num10311;
  partcv[0] = 1;
  Object opresult10315 = callmethod(call10314, ">", 1, partcv, params);
// compiled op node returning opresult10315 (depth = 4)
  Object if10309 = done;
struct StackFrameObject *iftmpstackframe10309 = stackframe;
  if (istrue(opresult10315)) {
stackframe = alloc_StackFrame(0, iftmpstackframe10309);
gc_frame_newslot((Object)stackframe);
// Begin line 2504
  setline(2504);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2503
  setline(2503);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10316 = gc_frame_new();
// Begin line 2505
  setline(2505);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile index node (depth = 6)
// Begin line 2504
  setline(2504);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
// starting to compile num node (depth = 7)
  Object num10317 = alloc_Float64(2);
// compiled num node returning num10317 (depth = 7)
  params[0] = num10317;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres10318 = callmethod(*var_values, "[]", 1, partcv, params);
// compiled index node returning idxres10318 (depth = 6)
  gc_frame_newslot(idxres10318);
// call case 4: self request
  params[0] = idxres10318;
  partcv[0] = 1;
  Object call10319 = callmethodflags(self, "params:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10316);
// compiled call node returning call10319 (depth = 5)
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if10309 = done;
  } else {
  }
stackframe = iftmpstackframe10309;
// compiled if node returning if10309 (depth = 3)
  sourceObject = obj10051;
// Begin line 2506
  setline(2506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num10322 = alloc_Float64(2);
// compiled num node returning num10322 (depth = 5)
  int op_slot_right_10321 = gc_frame_newslot(num10322);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10324 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call10325 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe10324);
// compiled call node returning call10325 (depth = 6)
// compiled member node returning call10325 (depth = 5)
  int op_slot_left_10321 = gc_frame_newslot(call10325);
  params[0] = num10322;
  partcv[0] = 1;
  Object opresult10326 = callmethod(call10325, ">", 1, partcv, params);
// compiled op node returning opresult10326 (depth = 4)
  Object if10320 = done;
struct StackFrameObject *iftmpstackframe10320 = stackframe;
  if (istrue(opresult10326)) {
stackframe = alloc_StackFrame(0, iftmpstackframe10320);
gc_frame_newslot((Object)stackframe);
// Begin line 2507
  setline(2507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2506
  setline(2506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10327 = gc_frame_new();
// Begin line 2508
  setline(2508);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile index node (depth = 6)
// Begin line 2507
  setline(2507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
// starting to compile num node (depth = 7)
  Object num10328 = alloc_Float64(3);
// compiled num node returning num10328 (depth = 7)
  params[0] = num10328;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres10329 = callmethod(*var_values, "[]", 1, partcv, params);
// compiled index node returning idxres10329 (depth = 6)
  gc_frame_newslot(idxres10329);
// call case 4: self request
  params[0] = idxres10329;
  partcv[0] = 1;
  Object call10330 = callmethodflags(self, "vararg:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10327);
// compiled call node returning call10330 (depth = 5)
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if10320 = done;
  } else {
  }
stackframe = iftmpstackframe10320;
// compiled if node returning if10320 (depth = 3)
  sourceObject = obj10051;
  sourceObject = obj10051;
  sourceObject = obj10051;
  sourceObject = obj10051;
  sourceObject = obj10051;
  sourceObject = obj10051;
  sourceObject = obj10051;
  objclass10051 = obj10051->class;
  objclass10051->definitionModule = modulename;
  objclass10051->definitionLine = 2486;
  (*(struct UserObject *)self).data[0] = lowerouter10051;
  self = oldself10051;
  selfslot = oldselfslot10051;
  stackframe = oldstackframe10051;
  gc_frame_end(frame);
  return obj10051;
}
Object meth_ast_new10050_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_signaturePart = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object var_init_values = alloc_BuiltinList();
  for (i = 0; i < argcv[0]; i++) {
    callmethod(var_init_values, "push", 1, pushcv, &args[curarg]);
    curarg++;
  }
  Object *var_values = &(stackframe->slots[0]);
  *var_values = var_init_values;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject10051 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj10051 = alloc_userobj2(22,18, objclass10051);
  gc_frame_newslot(obj10051);
if (objclass10051 == NULL) {
  glfree(obj10051->class->name);
  obj10051->class->name = "obj10014.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj10051, self, 0);
  addmethodreal(obj10051,"outer", &reader_ast_outer_10052);
  Object oldself10051 = self;
  struct StackFrameObject *oldstackframe10051 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe10051);
  gc_frame_newslot((Object)stackframe);
  self = obj10051;
  Object *oldselfslot10051 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter10051 = (*(struct UserObject *)self).data[0], lowerouter10051 = thisouter10051;
  if (inheritingObject10051) {
    struct UserObject *inho10051 = (struct UserObject *)inheritingObject10051;
    while (inho10051->super != GraceDefaultObject) inho10051 = (struct UserObject *)inho10051->super;
    inho10051->super = obj10051;
    self = inheritingObject10051;
    *selfslot = self;
    lowerouter10051 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter10051;
  }
if (objclass10051 == NULL) {
  Method *reader10053 = addmethodrealflags(obj10051, "kind",&reader_ast_kind_10053, MFLAG_DEF);
  reader10053->definitionModule = modulename;
  reader10053->definitionLine = 2494;
}
adddatum2(obj10051, alloc_Undefined(), 1);
if (objclass10051 == NULL) {
  Method *reader10054 = addmethodrealflags(obj10051, "name",&reader_ast_name_10054, 0);
  Method *writer10054 = addmethodrealflags(obj10051, "name:=",&writer_ast_name_10054, 0);
  reader10054->definitionModule = modulename;
  writer10054->definitionModule = modulename;
  reader10054->definitionLine = 2495;
  writer10054->definitionLine = 2495;
}
obj10051->flags |= OFLAG_MUTABLE;
adddatum2(obj10051, alloc_Undefined(), 2);
if (objclass10051 == NULL) {
  Method *reader10055 = addmethodrealflags(obj10051, "params",&reader_ast_params_10055, 0);
  Method *writer10055 = addmethodrealflags(obj10051, "params:=",&writer_ast_params_10055, 0);
  reader10055->definitionModule = modulename;
  writer10055->definitionModule = modulename;
  reader10055->definitionLine = 2496;
  writer10055->definitionLine = 2496;
}
obj10051->flags |= OFLAG_MUTABLE;
adddatum2(obj10051, alloc_Undefined(), 3);
if (objclass10051 == NULL) {
  Method *reader10056 = addmethodrealflags(obj10051, "vararg",&reader_ast_vararg_10056, 0);
  Method *writer10056 = addmethodrealflags(obj10051, "vararg:=",&writer_ast_vararg_10056, 0);
  reader10056->definitionModule = modulename;
  writer10056->definitionModule = modulename;
  reader10056->definitionLine = 2497;
  writer10056->definitionLine = 2497;
}
obj10051->flags |= OFLAG_MUTABLE;
adddatum2(obj10051, alloc_Undefined(), 4);
if (objclass10051 == NULL) {
  Method *reader10057 = addmethodrealflags(obj10051, "generics",&reader_ast_generics_10057, 0);
  Method *writer10057 = addmethodrealflags(obj10051, "generics:=",&writer_ast_generics_10057, 0);
  reader10057->definitionModule = modulename;
  writer10057->definitionModule = modulename;
  reader10057->definitionLine = 2498;
  writer10057->definitionLine = 2498;
}
obj10051->flags |= OFLAG_MUTABLE;
adddatum2(obj10051, alloc_Undefined(), 5);
if (objclass10051 == NULL) {
  Method *reader10058 = addmethodrealflags(obj10051, "lineLength",&reader_ast_lineLength_10058, 0);
  Method *writer10058 = addmethodrealflags(obj10051, "lineLength:=",&writer_ast_lineLength_10058, 0);
  reader10058->definitionModule = modulename;
  writer10058->definitionModule = modulename;
  reader10058->definitionLine = 2499;
  writer10058->definitionLine = 2499;
}
obj10051->flags |= OFLAG_MUTABLE;
adddatum2(obj10051, alloc_Undefined(), 6);
// method accept()from
  struct UserObject *uo10059 = (struct UserObject*)obj10051;
  uo10059->data[7] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from10059 = addmethod2pos(obj10051, "accept()from", &meth_ast_accept_40__41_from10059, 7);
  int argcv_meth_ast_accept_40__41_from10059[] = {1, 1};
  meth_meth_ast_accept_40__41_from10059->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from10059);
  meth_meth_ast_accept_40__41_from10059->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from10059->definitionLine = 2509;
// method declarationKindWithAncestors
  struct UserObject *uo10101 = (struct UserObject*)obj10051;
  uo10101->data[8] = emptyclosure;
  Method *meth_meth_ast_declarationKindWithAncestors10101 = addmethod2pos(obj10051, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors10101, 8);
  int argcv_meth_ast_declarationKindWithAncestors10101[] = {1};
  meth_meth_ast_declarationKindWithAncestors10101->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors10101);
  meth_meth_ast_declarationKindWithAncestors10101->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors10101->definitionLine = 2519;
// method map()ancestors
  struct UserObject *uo10103 = (struct UserObject*)obj10051;
  uo10103->data[9] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors10103 = addmethod2pos(obj10051, "map()ancestors", &meth_ast_map_40__41_ancestors10103, 9);
  int argcv_meth_ast_map_40__41_ancestors10103[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors10103->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors10103);
  meth_meth_ast_map_40__41_ancestors10103->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors10103->definitionLine = 2520;
// method pretty
  struct UserObject *uo10130 = (struct UserObject*)obj10051;
  uo10130->data[10] = emptyclosure;
  Method *meth_meth_ast_pretty10130 = addmethod2pos(obj10051, "pretty", &meth_ast_pretty10130, 10);
  int argcv_meth_ast_pretty10130[] = {1};
  meth_meth_ast_pretty10130->type = alloc_MethodType(1, argcv_meth_ast_pretty10130);
  meth_meth_ast_pretty10130->definitionModule = modulename;
  meth_meth_ast_pretty10130->definitionLine = 2527;
// method shallowCopy
  block_savedest(obj10051);
  Object closure10262 = createclosure(1, "shallowCopy");
  setclosureframe(closure10262, stackframe);
  addtoclosure(closure10262, var_signaturePart);
  struct UserObject *uo10262 = (struct UserObject*)obj10051;
  uo10262->data[11] = (Object)closure10262;
  Method *meth_meth_ast_shallowCopy10262 = addmethod2pos(obj10051, "shallowCopy", &meth_ast_shallowCopy10262, 11);
  int argcv_meth_ast_shallowCopy10262[] = {0};
  meth_meth_ast_shallowCopy10262->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy10262);
  meth_meth_ast_shallowCopy10262->definitionModule = modulename;
  meth_meth_ast_shallowCopy10262->definitionLine = 2542;
// method shallowCopyFieldsFrom
  struct UserObject *uo10269 = (struct UserObject*)obj10051;
  uo10269->data[12] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom10269 = addmethod2pos(obj10051, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom10269, 12);
  int argcv_meth_ast_shallowCopyFieldsFrom10269[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom10269->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom10269);
  meth_meth_ast_shallowCopyFieldsFrom10269->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom10269->definitionLine = 2545;
// method asString
  struct UserObject *uo10276 = (struct UserObject*)obj10051;
  uo10276->data[13] = emptyclosure;
  Method *meth_meth_ast_asString10276 = addmethod2pos(obj10051, "asString", &meth_ast_asString10276, 13);
  int argcv_meth_ast_asString10276[] = {0};
  meth_meth_ast_asString10276->type = alloc_MethodType(1, argcv_meth_ast_asString10276);
  meth_meth_ast_asString10276->definitionModule = modulename;
  meth_meth_ast_asString10276->definitionLine = 2550;
  sourceObject = obj10051;
// Begin line 2493
  setline(2493);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10287 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_baseNode (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call10288 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe10287);
// compiled call node returning call10288 (depth = 3)
  struct UserObject *obj10051_uo = (struct UserObject *)obj10051;
  obj10051_uo->super = call10288;
  sourceObject = obj10051;
// Begin line 2494
  setline(2494);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit10289 == NULL) {
    strlit10289 = alloc_String("signaturepart");
    gc_root(strlit10289);
  }
// compiled string node returning strlit10289 (depth = 3)
  adddatum2(obj10051, strlit10289, 1);
  sourceObject = obj10051;
// Begin line 2495
  setline(2495);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit10290 == NULL) {
    strlit10290 = alloc_String("");
    gc_root(strlit10290);
  }
// compiled string node returning strlit10290 (depth = 3)
  adddatum2(obj10051, strlit10290, 2);
  sourceObject = obj10051;
// Begin line 2496
  setline(2496);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10291 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10292 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call10293 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10292);
// compiled call node returning call10293 (depth = 6)
// compiled member node returning call10293 (depth = 5)
  partcv[0] = 0;
  Object call10294 = callmethod(call10293, "empty",
    1, partcv, params);
  gc_frame_end(callframe10291);
// compiled call node returning call10294 (depth = 4)
// compiled member node returning call10294 (depth = 3)
  adddatum2(obj10051, call10294, 3);
  sourceObject = obj10051;
// Begin line 2497
  setline(2497);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10295 = alloc_Boolean(0);
// compiled identifier node returning bool10295 (depth = 3)
  adddatum2(obj10051, bool10295, 4);
  sourceObject = obj10051;
// Begin line 2498
  setline(2498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10296 = alloc_Boolean(0);
// compiled identifier node returning bool10296 (depth = 3)
  adddatum2(obj10051, bool10296, 5);
  sourceObject = obj10051;
// Begin line 2499
  setline(2499);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num10297 = alloc_Float64(0);
// compiled num node returning num10297 (depth = 3)
  adddatum2(obj10051, num10297, 6);
  sourceObject = obj10051;
// Begin line 2500
  setline(2500);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num10300 = alloc_Float64(0);
// compiled num node returning num10300 (depth = 5)
  int op_slot_right_10299 = gc_frame_newslot(num10300);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10302 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call10303 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe10302);
// compiled call node returning call10303 (depth = 6)
// compiled member node returning call10303 (depth = 5)
  int op_slot_left_10299 = gc_frame_newslot(call10303);
  params[0] = num10300;
  partcv[0] = 1;
  Object opresult10304 = callmethod(call10303, ">", 1, partcv, params);
// compiled op node returning opresult10304 (depth = 4)
  Object if10298 = done;
struct StackFrameObject *iftmpstackframe10298 = stackframe;
  if (istrue(opresult10304)) {
stackframe = alloc_StackFrame(0, iftmpstackframe10298);
gc_frame_newslot((Object)stackframe);
// Begin line 2501
  setline(2501);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2500
  setline(2500);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10305 = gc_frame_new();
// Begin line 2502
  setline(2502);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile index node (depth = 6)
// Begin line 2501
  setline(2501);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
// starting to compile num node (depth = 7)
  Object num10306 = alloc_Float64(1);
// compiled num node returning num10306 (depth = 7)
  params[0] = num10306;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres10307 = callmethod(*var_values, "[]", 1, partcv, params);
// compiled index node returning idxres10307 (depth = 6)
  gc_frame_newslot(idxres10307);
// call case 4: self request
  params[0] = idxres10307;
  partcv[0] = 1;
  Object call10308 = callmethodflags(self, "name:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10305);
// compiled call node returning call10308 (depth = 5)
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if10298 = done;
  } else {
  }
stackframe = iftmpstackframe10298;
// compiled if node returning if10298 (depth = 3)
  sourceObject = obj10051;
// Begin line 2503
  setline(2503);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num10311 = alloc_Float64(1);
// compiled num node returning num10311 (depth = 5)
  int op_slot_right_10310 = gc_frame_newslot(num10311);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10313 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call10314 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe10313);
// compiled call node returning call10314 (depth = 6)
// compiled member node returning call10314 (depth = 5)
  int op_slot_left_10310 = gc_frame_newslot(call10314);
  params[0] = num10311;
  partcv[0] = 1;
  Object opresult10315 = callmethod(call10314, ">", 1, partcv, params);
// compiled op node returning opresult10315 (depth = 4)
  Object if10309 = done;
struct StackFrameObject *iftmpstackframe10309 = stackframe;
  if (istrue(opresult10315)) {
stackframe = alloc_StackFrame(0, iftmpstackframe10309);
gc_frame_newslot((Object)stackframe);
// Begin line 2504
  setline(2504);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2503
  setline(2503);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10316 = gc_frame_new();
// Begin line 2505
  setline(2505);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile index node (depth = 6)
// Begin line 2504
  setline(2504);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
// starting to compile num node (depth = 7)
  Object num10317 = alloc_Float64(2);
// compiled num node returning num10317 (depth = 7)
  params[0] = num10317;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres10318 = callmethod(*var_values, "[]", 1, partcv, params);
// compiled index node returning idxres10318 (depth = 6)
  gc_frame_newslot(idxres10318);
// call case 4: self request
  params[0] = idxres10318;
  partcv[0] = 1;
  Object call10319 = callmethodflags(self, "params:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10316);
// compiled call node returning call10319 (depth = 5)
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if10309 = done;
  } else {
  }
stackframe = iftmpstackframe10309;
// compiled if node returning if10309 (depth = 3)
  sourceObject = obj10051;
// Begin line 2506
  setline(2506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num10322 = alloc_Float64(2);
// compiled num node returning num10322 (depth = 5)
  int op_slot_right_10321 = gc_frame_newslot(num10322);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10324 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call10325 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe10324);
// compiled call node returning call10325 (depth = 6)
// compiled member node returning call10325 (depth = 5)
  int op_slot_left_10321 = gc_frame_newslot(call10325);
  params[0] = num10322;
  partcv[0] = 1;
  Object opresult10326 = callmethod(call10325, ">", 1, partcv, params);
// compiled op node returning opresult10326 (depth = 4)
  Object if10320 = done;
struct StackFrameObject *iftmpstackframe10320 = stackframe;
  if (istrue(opresult10326)) {
stackframe = alloc_StackFrame(0, iftmpstackframe10320);
gc_frame_newslot((Object)stackframe);
// Begin line 2507
  setline(2507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2506
  setline(2506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10327 = gc_frame_new();
// Begin line 2508
  setline(2508);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile index node (depth = 6)
// Begin line 2507
  setline(2507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
// starting to compile num node (depth = 7)
  Object num10328 = alloc_Float64(3);
// compiled num node returning num10328 (depth = 7)
  params[0] = num10328;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres10329 = callmethod(*var_values, "[]", 1, partcv, params);
// compiled index node returning idxres10329 (depth = 6)
  gc_frame_newslot(idxres10329);
// call case 4: self request
  params[0] = idxres10329;
  partcv[0] = 1;
  Object call10330 = callmethodflags(self, "vararg:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10327);
// compiled call node returning call10330 (depth = 5)
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if10320 = done;
  } else {
  }
stackframe = iftmpstackframe10320;
// compiled if node returning if10320 (depth = 3)
  sourceObject = obj10051;
  sourceObject = obj10051;
  sourceObject = obj10051;
  sourceObject = obj10051;
  sourceObject = obj10051;
  sourceObject = obj10051;
  sourceObject = obj10051;
  objclass10051 = obj10051->class;
  objclass10051->definitionModule = modulename;
  objclass10051->definitionLine = 2486;
  (*(struct UserObject *)self).data[0] = lowerouter10051;
  self = oldself10051;
  selfslot = oldselfslot10051;
  stackframe = oldstackframe10051;
  gc_frame_end(frame);
  return obj10051;
}
Object meth_ast_signaturePart10332(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 47, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "signaturePart");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_signaturePart = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for signaturePart (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹signaturePart›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2473
  setline(2473);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_signaturePart (depth = 3)
  gc_frame_end(frame);
  return *var_signaturePart;
}
Object meth_ast_new_40__41_scope10335(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new()scope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method new()scope");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method new()scope");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for new()scope (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_name = &(stackframe->slots[0]);
  *var_name = args[curarg];
  curarg++;
  Object *var_argList = &(stackframe->slots[1]);
  *var_argList = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for new");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for scope");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "result");
// Begin line 2558
  setline(2558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10336 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_name (depth = 5)
  gc_frame_newslot(*var_name);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_argList (depth = 5)
  gc_frame_newslot(*var_argList);
// call case 4: self request
  params[0] = *var_name;
  params[1] = *var_argList;
  partcv[0] = 2;
  Object call10337 = callmethodflags(self, "new", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10336);
// compiled call node returning call10337 (depth = 4)
  *var_result = call10337;
  if (call10337 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2559
  setline(2559);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2506
  setline(2506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10338 = gc_frame_new();
// Begin line 2559
  setline(2559);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  gc_frame_newslot(*var_s);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call10339 = callmethod(*var_result, "scope:=",
    1, partcv, params);
  gc_frame_end(callframe10338);
// compiled call node returning call10339 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 2560
  setline(2560);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_map_40__41_ancestors10347(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2580
  setline(2580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10348 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10349 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10348);
// compiled call node returning call10349 (depth = 5)
// compiled member node returning call10349 (depth = 4)
  *var_n = call10349;
  if (call10349 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2581
  setline(2581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10350 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call10351 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe10350);
// compiled call node returning call10351 (depth = 4)
  *var_newChain = call10351;
  if (call10351 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2582
  setline(2582);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2580
  setline(2580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10352 = gc_frame_new();
// Begin line 2582
  setline(2582);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10353 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10354 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10355 = callmethodflags(self, "args", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10354);
// compiled call node returning call10355 (depth = 7)
// compiled member node returning call10355 (depth = 6)
  gc_frame_newslot(call10355);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10356 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10357 = gc_frame_new();
// call case 3: self.outer request
  Object call10358 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe10357);
// compiled call node returning call10358 (depth = 9)
// compiled member node returning call10358 (depth = 8)
  partcv[0] = 0;
  Object call10359 = callmethodflags(call10358, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10356);
// compiled call node returning call10359 (depth = 7)
// compiled member node returning call10359 (depth = 6)
  params[0] = call10355;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call10360 = callmethodflags(call10359, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10353);
// compiled call node returning call10360 (depth = 5)
  gc_frame_newslot(call10360);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  params[0] = call10360;
  partcv[0] = 1;
  Object call10361 = callmethod(*var_n, "args:=",
    1, partcv, params);
  gc_frame_end(callframe10352);
// compiled call node returning call10361 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 2583
  setline(2583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10362 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call10363 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe10362);
// compiled call node returning call10363 (depth = 3)
  gc_frame_end(frame);
  return call10363;
}
Object meth_ast__apply10372(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// Begin line 2588
  setline(2588);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10374 == NULL) {
    strlit10374 = alloc_String("  ");
    gc_root(strlit10374);
  }
// compiled string node returning strlit10374 (depth = 7)
  int op_slot_right_10373 = gc_frame_newslot(strlit10374);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_10373 = gc_frame_newslot(*var_spc);
  params[0] = strlit10374;
  partcv[0] = 1;
  Object opresult10376 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult10376 (depth = 6)
  *var_spc = opresult10376;
  if (opresult10376 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply10419(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2593
  setline(2593);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10421 == NULL) {
    strlit10421 = alloc_String("");
    gc_root(strlit10421);
  }
// compiled string node returning strlit10421 (depth = 7)
  int op_slot_right_10420 = gc_frame_newslot(strlit10421);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10424 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num10426 = alloc_Float64(4);
// compiled num node returning num10426 (depth = 10)
  int op_slot_right_10425 = gc_frame_newslot(num10426);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_10425 = gc_frame_newslot(*var_depth);
  params[0] = num10426;
  partcv[0] = 1;
  Object sum10428 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum10428 (depth = 9)
  gc_frame_newslot(sum10428);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_a (depth = 9)
  params[0] = sum10428;
  partcv[0] = 1;
  Object call10429 = callmethod(*var_a, "pretty",
    1, partcv, params);
  gc_frame_end(callframe10424);
// compiled call node returning call10429 (depth = 8)
  int op_slot_right_10423 = gc_frame_newslot(call10429);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit10432 == NULL) {
    strlit10432 = alloc_String("");
    gc_root(strlit10432);
  }
// compiled string node returning strlit10432 (depth = 9)
  int op_slot_right_10431 = gc_frame_newslot(strlit10432);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_10434 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit10437 == NULL) {
    strlit10437 = alloc_String("""\x0a""    ");
    gc_root(strlit10437);
  }
// compiled string node returning strlit10437 (depth = 11)
  int op_slot_right_10436 = gc_frame_newslot(strlit10437);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_s (depth = 12)
  int op_slot_right_10439 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 12)
  if (strlit10441 == NULL) {
    strlit10441 = alloc_String("");
    gc_root(strlit10441);
  }
// compiled string node returning strlit10441 (depth = 12)
  int op_slot_left_10439 = gc_frame_newslot(strlit10441);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult10442 = callmethod(strlit10441, "++", 1, partcv, params);
// compiled op node returning opresult10442 (depth = 11)
  int op_slot_left_10436 = gc_frame_newslot(opresult10442);
  params[0] = strlit10437;
  partcv[0] = 1;
  Object opresult10443 = callmethod(opresult10442, "++", 1, partcv, params);
// compiled op node returning opresult10443 (depth = 10)
  int op_slot_left_10434 = gc_frame_newslot(opresult10443);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult10444 = callmethod(opresult10443, "++", 1, partcv, params);
// compiled op node returning opresult10444 (depth = 9)
  int op_slot_left_10431 = gc_frame_newslot(opresult10444);
  params[0] = strlit10432;
  partcv[0] = 1;
  Object opresult10445 = callmethod(opresult10444, "++", 1, partcv, params);
// compiled op node returning opresult10445 (depth = 8)
  int op_slot_left_10423 = gc_frame_newslot(opresult10445);
  params[0] = call10429;
  partcv[0] = 1;
  Object opresult10446 = callmethod(opresult10445, "++", 1, partcv, params);
// compiled op node returning opresult10446 (depth = 7)
  int op_slot_left_10420 = gc_frame_newslot(opresult10446);
  params[0] = strlit10421;
  partcv[0] = 1;
  Object opresult10447 = callmethod(opresult10446, "++", 1, partcv, params);
// compiled op node returning opresult10447 (depth = 6)
  *var_s = opresult10447;
  if (opresult10447 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty10364(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2586
  setline(2586);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit10365 == NULL) {
    strlit10365 = alloc_String("");
    gc_root(strlit10365);
  }
// compiled string node returning strlit10365 (depth = 4)
  *var_spc = strlit10365;
  if (strlit10365 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2587
  setline(2587);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10366 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num10368 = alloc_Float64(1);
// compiled num node returning num10368 (depth = 5)
  int op_slot_right_10367 = gc_frame_newslot(num10368);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_left_10367 = gc_frame_newslot(*var_depth);
  params[0] = num10368;
  partcv[0] = 1;
  Object sum10370 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum10370 (depth = 4)
  gc_frame_newslot(sum10370);
// starting to compile block node (depth = 4)
  Object block10371 = alloc_Block(NULL, NULL, "ast", 2587);
  gc_frame_newslot(block10371);
// method _apply
  block_savedest(block10371);
  Object closure10372 = createclosure(2, "_apply");
  setclosureframe(closure10372, stackframe);
  addtoclosure(closure10372, var_spc);
  addtoclosure(closure10372, selfslot);
  struct UserObject *uo10372 = (struct UserObject*)block10371;
  uo10372->data[0] = (Object)closure10372;
  Method *meth_meth_ast__apply10372 = addmethod2pos(block10371, "_apply", &meth_ast__apply10372, 0);
  int argcv_meth_ast__apply10372[] = {0};
  meth_meth_ast__apply10372->type = alloc_MethodType(1, argcv_meth_ast__apply10372);
  meth_meth_ast__apply10372->definitionModule = modulename;
  meth_meth_ast__apply10372->definitionLine = 2582;
// compiled block node returning block10371 (depth = 4)
  gc_frame_newslot(block10371);
// call case 5: prelude request
  params[0] = sum10370;
  params[1] = block10371;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10379 = callmethodflags(prelude, "repeat()times", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10366);
// compiled call node returning call10379 (depth = 3)
// Begin line 2590
  setline(2590);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit10381 == NULL) {
    strlit10381 = alloc_String("");
    gc_root(strlit10381);
  }
// compiled string node returning strlit10381 (depth = 5)
  int op_slot_right_10380 = gc_frame_newslot(strlit10381);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10384 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10385 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10384);
// compiled call node returning call10385 (depth = 7)
// compiled member node returning call10385 (depth = 6)
  int op_slot_right_10383 = gc_frame_newslot(call10385);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10388 == NULL) {
    strlit10388 = alloc_String(": ");
    gc_root(strlit10388);
  }
// compiled string node returning strlit10388 (depth = 7)
  int op_slot_right_10387 = gc_frame_newslot(strlit10388);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10391 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call10392 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe10391);
// compiled call node returning call10392 (depth = 8)
  int op_slot_right_10390 = gc_frame_newslot(call10392);
// starting to compile string node (depth = 8)
  if (strlit10394 == NULL) {
    strlit10394 = alloc_String("");
    gc_root(strlit10394);
  }
// compiled string node returning strlit10394 (depth = 8)
  int op_slot_left_10390 = gc_frame_newslot(strlit10394);
  params[0] = call10392;
  partcv[0] = 1;
  Object opresult10395 = callmethod(strlit10394, "++", 1, partcv, params);
// compiled op node returning opresult10395 (depth = 7)
  int op_slot_left_10387 = gc_frame_newslot(opresult10395);
  params[0] = strlit10388;
  partcv[0] = 1;
  Object opresult10396 = callmethod(opresult10395, "++", 1, partcv, params);
// compiled op node returning opresult10396 (depth = 6)
  int op_slot_left_10383 = gc_frame_newslot(opresult10396);
  params[0] = call10385;
  partcv[0] = 1;
  Object opresult10397 = callmethod(opresult10396, "++", 1, partcv, params);
// compiled op node returning opresult10397 (depth = 5)
  int op_slot_left_10380 = gc_frame_newslot(opresult10397);
  params[0] = strlit10381;
  partcv[0] = 1;
  Object opresult10398 = callmethod(opresult10397, "++", 1, partcv, params);
// compiled op node returning opresult10398 (depth = 4)
  *var_s = opresult10398;
  if (opresult10398 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2591
  setline(2591);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit10400 == NULL) {
    strlit10400 = alloc_String("Args:");
    gc_root(strlit10400);
  }
// compiled string node returning strlit10400 (depth = 5)
  int op_slot_right_10399 = gc_frame_newslot(strlit10400);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_10402 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10405 == NULL) {
    strlit10405 = alloc_String("""\x0a""    ");
    gc_root(strlit10405);
  }
// compiled string node returning strlit10405 (depth = 7)
  int op_slot_right_10404 = gc_frame_newslot(strlit10405);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_right_10407 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 8)
  if (strlit10409 == NULL) {
    strlit10409 = alloc_String("");
    gc_root(strlit10409);
  }
// compiled string node returning strlit10409 (depth = 8)
  int op_slot_left_10407 = gc_frame_newslot(strlit10409);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult10410 = callmethod(strlit10409, "++", 1, partcv, params);
// compiled op node returning opresult10410 (depth = 7)
  int op_slot_left_10404 = gc_frame_newslot(opresult10410);
  params[0] = strlit10405;
  partcv[0] = 1;
  Object opresult10411 = callmethod(opresult10410, "++", 1, partcv, params);
// compiled op node returning opresult10411 (depth = 6)
  int op_slot_left_10402 = gc_frame_newslot(opresult10411);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult10412 = callmethod(opresult10411, "++", 1, partcv, params);
// compiled op node returning opresult10412 (depth = 5)
  int op_slot_left_10399 = gc_frame_newslot(opresult10412);
  params[0] = strlit10400;
  partcv[0] = 1;
  Object opresult10413 = callmethod(opresult10412, "++", 1, partcv, params);
// compiled op node returning opresult10413 (depth = 4)
  *var_s = opresult10413;
  if (opresult10413 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 2592
  setline(2592);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10415 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10416 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10417 = callmethodflags(self, "args", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10416);
// compiled call node returning call10417 (depth = 5)
// compiled member node returning call10417 (depth = 4)
  gc_frame_newslot(call10417);
// starting to compile block node (depth = 4)
  Object block10418 = alloc_Block(NULL, NULL, "ast", 2592);
  gc_frame_newslot(block10418);
// method _apply
  block_savedest(block10418);
  Object closure10419 = createclosure(4, "_apply");
  setclosureframe(closure10419, stackframe);
  addtoclosure(closure10419, var_depth);
  addtoclosure(closure10419, var_spc);
  addtoclosure(closure10419, var_s);
  addtoclosure(closure10419, selfslot);
  struct UserObject *uo10419 = (struct UserObject*)block10418;
  uo10419->data[0] = (Object)closure10419;
  Method *meth_meth_ast__apply10419 = addmethod2pos(block10418, "_apply", &meth_ast__apply10419, 0);
  int argcv_meth_ast__apply10419[] = {1};
  meth_meth_ast__apply10419->type = alloc_MethodType(1, argcv_meth_ast__apply10419);
  meth_meth_ast__apply10419->definitionModule = modulename;
  meth_meth_ast__apply10419->definitionLine = 2592;
// compiled block node returning block10418 (depth = 4)
  gc_frame_newslot(block10418);
// call case 5: prelude request
  params[0] = call10417;
  params[1] = block10418;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10450 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10415);
// compiled call node returning call10450 (depth = 3)
// Begin line 2595
  setline(2595);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy10451(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_callWithPart = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2598
  setline(2598);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10452 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe10453 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10454 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10455 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10454);
// compiled call node returning call10455 (depth = 6)
// compiled member node returning call10455 (depth = 5)
  gc_frame_newslot(call10455);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_callWithPart (depth = 5)
  params[0] = call10455;
  partcv[0] = 1;
  Object call10456 = callmethod(*var_callWithPart, "new",
    1, partcv, params);
  gc_frame_end(callframe10453);
// compiled call node returning call10456 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call10457 = callmethod(call10456, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe10452);
// compiled call node returning call10457 (depth = 3)
  gc_frame_end(frame);
  return call10457;
}
Object meth_ast_shallowCopyFieldsFrom10458(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyFieldsFrom");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopyFieldsFrom (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyFieldsFrom");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2601
  setline(2601);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10459 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call10460 = callmethod4(self, "shallowCopyFieldsFrom", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe10459);
// compiled call node returning call10460 (depth = 3)
// Begin line 2602
  setline(2602);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2598
  setline(2598);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10461 = gc_frame_new();
// Begin line 2602
  setline(2602);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10462 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  partcv[0] = 0;
  Object call10463 = callmethod(*var_other, "lineLength",
    1, partcv, params);
  gc_frame_end(callframe10462);
// compiled call node returning call10463 (depth = 6)
// compiled member node returning call10463 (depth = 5)
  gc_frame_newslot(call10463);
// call case 4: self request
  params[0] = call10463;
  partcv[0] = 1;
  Object call10464 = callmethodflags(self, "lineLength:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10461);
// compiled call node returning call10464 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 2603
  setline(2603);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_new10340(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_callWithPart = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object var_init_values = alloc_BuiltinList();
  for (i = 0; i < argcv[0]; i++) {
    callmethod(var_init_values, "push", 1, pushcv, &args[curarg]);
    curarg++;
  }
  Object *var_values = &(stackframe->slots[0]);
  *var_values = var_init_values;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject10341 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj10341 = alloc_userobj2(14,12, objclass10341);
  gc_frame_newslot(obj10341);
if (objclass10341 == NULL) {
  glfree(obj10341->class->name);
  obj10341->class->name = "obj10333.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj10341, self, 0);
  addmethodreal(obj10341,"outer", &reader_ast_outer_10342);
  Object oldself10341 = self;
  struct StackFrameObject *oldstackframe10341 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe10341);
  gc_frame_newslot((Object)stackframe);
  self = obj10341;
  Object *oldselfslot10341 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter10341 = (*(struct UserObject *)self).data[0], lowerouter10341 = thisouter10341;
  if (inheritingObject10341) {
    struct UserObject *inho10341 = (struct UserObject *)inheritingObject10341;
    while (inho10341->super != GraceDefaultObject) inho10341 = (struct UserObject *)inho10341->super;
    inho10341->super = obj10341;
    self = inheritingObject10341;
    *selfslot = self;
    lowerouter10341 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter10341;
  }
if (objclass10341 == NULL) {
  Method *reader10343 = addmethodrealflags(obj10341, "kind",&reader_ast_kind_10343, MFLAG_DEF);
  reader10343->definitionModule = modulename;
  reader10343->definitionLine = 2568;
}
adddatum2(obj10341, alloc_Undefined(), 1);
if (objclass10341 == NULL) {
  Method *reader10344 = addmethodrealflags(obj10341, "name",&reader_ast_name_10344, 0);
  Method *writer10344 = addmethodrealflags(obj10341, "name:=",&writer_ast_name_10344, 0);
  reader10344->definitionModule = modulename;
  writer10344->definitionModule = modulename;
  reader10344->definitionLine = 2569;
  writer10344->definitionLine = 2569;
}
obj10341->flags |= OFLAG_MUTABLE;
adddatum2(obj10341, alloc_Undefined(), 2);
if (objclass10341 == NULL) {
  Method *reader10345 = addmethodrealflags(obj10341, "args",&reader_ast_args_10345, 0);
  Method *writer10345 = addmethodrealflags(obj10341, "args:=",&writer_ast_args_10345, 0);
  reader10345->definitionModule = modulename;
  writer10345->definitionModule = modulename;
  reader10345->definitionLine = 2570;
  writer10345->definitionLine = 2570;
}
obj10341->flags |= OFLAG_MUTABLE;
adddatum2(obj10341, alloc_Undefined(), 3);
if (objclass10341 == NULL) {
  Method *reader10346 = addmethodrealflags(obj10341, "lineLength",&reader_ast_lineLength_10346, 0);
  Method *writer10346 = addmethodrealflags(obj10341, "lineLength:=",&writer_ast_lineLength_10346, 0);
  reader10346->definitionModule = modulename;
  writer10346->definitionModule = modulename;
  reader10346->definitionLine = 2571;
  writer10346->definitionLine = 2571;
}
obj10341->flags |= OFLAG_MUTABLE;
adddatum2(obj10341, alloc_Undefined(), 4);
// method map()ancestors
  struct UserObject *uo10347 = (struct UserObject*)obj10341;
  uo10347->data[5] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors10347 = addmethod2pos(obj10341, "map()ancestors", &meth_ast_map_40__41_ancestors10347, 5);
  int argcv_meth_ast_map_40__41_ancestors10347[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors10347->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors10347);
  meth_meth_ast_map_40__41_ancestors10347->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors10347->definitionLine = 2579;
// method pretty
  struct UserObject *uo10364 = (struct UserObject*)obj10341;
  uo10364->data[6] = emptyclosure;
  Method *meth_meth_ast_pretty10364 = addmethod2pos(obj10341, "pretty", &meth_ast_pretty10364, 6);
  int argcv_meth_ast_pretty10364[] = {1};
  meth_meth_ast_pretty10364->type = alloc_MethodType(1, argcv_meth_ast_pretty10364);
  meth_meth_ast_pretty10364->definitionModule = modulename;
  meth_meth_ast_pretty10364->definitionLine = 2585;
// method shallowCopy
  block_savedest(obj10341);
  Object closure10451 = createclosure(1, "shallowCopy");
  setclosureframe(closure10451, stackframe);
  addtoclosure(closure10451, var_callWithPart);
  struct UserObject *uo10451 = (struct UserObject*)obj10341;
  uo10451->data[7] = (Object)closure10451;
  Method *meth_meth_ast_shallowCopy10451 = addmethod2pos(obj10341, "shallowCopy", &meth_ast_shallowCopy10451, 7);
  int argcv_meth_ast_shallowCopy10451[] = {0};
  meth_meth_ast_shallowCopy10451->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy10451);
  meth_meth_ast_shallowCopy10451->definitionModule = modulename;
  meth_meth_ast_shallowCopy10451->definitionLine = 2597;
// method shallowCopyFieldsFrom
  struct UserObject *uo10458 = (struct UserObject*)obj10341;
  uo10458->data[8] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom10458 = addmethod2pos(obj10341, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom10458, 8);
  int argcv_meth_ast_shallowCopyFieldsFrom10458[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom10458->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom10458);
  meth_meth_ast_shallowCopyFieldsFrom10458->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom10458->definitionLine = 2600;
  sourceObject = obj10341;
// Begin line 2567
  setline(2567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10465 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_baseNode (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call10466 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe10465);
// compiled call node returning call10466 (depth = 3)
  struct UserObject *obj10341_uo = (struct UserObject *)obj10341;
  obj10341_uo->super = call10466;
  sourceObject = obj10341;
// Begin line 2568
  setline(2568);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit10467 == NULL) {
    strlit10467 = alloc_String("callwithpart");
    gc_root(strlit10467);
  }
// compiled string node returning strlit10467 (depth = 3)
  adddatum2(obj10341, strlit10467, 1);
  sourceObject = obj10341;
// Begin line 2569
  setline(2569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit10468 == NULL) {
    strlit10468 = alloc_String("");
    gc_root(strlit10468);
  }
// compiled string node returning strlit10468 (depth = 3)
  adddatum2(obj10341, strlit10468, 2);
  sourceObject = obj10341;
// Begin line 2570
  setline(2570);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10469 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10470 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call10471 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10470);
// compiled call node returning call10471 (depth = 6)
// compiled member node returning call10471 (depth = 5)
  partcv[0] = 0;
  Object call10472 = callmethod(call10471, "empty",
    1, partcv, params);
  gc_frame_end(callframe10469);
// compiled call node returning call10472 (depth = 4)
// compiled member node returning call10472 (depth = 3)
  adddatum2(obj10341, call10472, 3);
  sourceObject = obj10341;
// Begin line 2571
  setline(2571);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num10473 = alloc_Float64(0);
// compiled num node returning num10473 (depth = 3)
  adddatum2(obj10341, num10473, 4);
  sourceObject = obj10341;
// Begin line 2572
  setline(2572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num10476 = alloc_Float64(0);
// compiled num node returning num10476 (depth = 5)
  int op_slot_right_10475 = gc_frame_newslot(num10476);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10478 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call10479 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe10478);
// compiled call node returning call10479 (depth = 6)
// compiled member node returning call10479 (depth = 5)
  int op_slot_left_10475 = gc_frame_newslot(call10479);
  params[0] = num10476;
  partcv[0] = 1;
  Object opresult10480 = callmethod(call10479, ">", 1, partcv, params);
// compiled op node returning opresult10480 (depth = 4)
  Object if10474 = done;
struct StackFrameObject *iftmpstackframe10474 = stackframe;
  if (istrue(opresult10480)) {
stackframe = alloc_StackFrame(0, iftmpstackframe10474);
gc_frame_newslot((Object)stackframe);
// Begin line 2573
  setline(2573);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2572
  setline(2572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10481 = gc_frame_new();
// Begin line 2574
  setline(2574);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile index node (depth = 6)
// Begin line 2573
  setline(2573);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
// starting to compile num node (depth = 7)
  Object num10482 = alloc_Float64(1);
// compiled num node returning num10482 (depth = 7)
  params[0] = num10482;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres10483 = callmethod(*var_values, "[]", 1, partcv, params);
// compiled index node returning idxres10483 (depth = 6)
  gc_frame_newslot(idxres10483);
// call case 4: self request
  params[0] = idxres10483;
  partcv[0] = 1;
  Object call10484 = callmethodflags(self, "name:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10481);
// compiled call node returning call10484 (depth = 5)
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if10474 = done;
  } else {
  }
stackframe = iftmpstackframe10474;
// compiled if node returning if10474 (depth = 3)
  sourceObject = obj10341;
// Begin line 2575
  setline(2575);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num10487 = alloc_Float64(1);
// compiled num node returning num10487 (depth = 5)
  int op_slot_right_10486 = gc_frame_newslot(num10487);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10489 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call10490 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe10489);
// compiled call node returning call10490 (depth = 6)
// compiled member node returning call10490 (depth = 5)
  int op_slot_left_10486 = gc_frame_newslot(call10490);
  params[0] = num10487;
  partcv[0] = 1;
  Object opresult10491 = callmethod(call10490, ">", 1, partcv, params);
// compiled op node returning opresult10491 (depth = 4)
  Object if10485 = done;
struct StackFrameObject *iftmpstackframe10485 = stackframe;
  if (istrue(opresult10491)) {
stackframe = alloc_StackFrame(0, iftmpstackframe10485);
gc_frame_newslot((Object)stackframe);
// Begin line 2576
  setline(2576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2575
  setline(2575);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10492 = gc_frame_new();
// Begin line 2577
  setline(2577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile index node (depth = 6)
// Begin line 2576
  setline(2576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
// starting to compile num node (depth = 7)
  Object num10493 = alloc_Float64(2);
// compiled num node returning num10493 (depth = 7)
  params[0] = num10493;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres10494 = callmethod(*var_values, "[]", 1, partcv, params);
// compiled index node returning idxres10494 (depth = 6)
  gc_frame_newslot(idxres10494);
// call case 4: self request
  params[0] = idxres10494;
  partcv[0] = 1;
  Object call10495 = callmethodflags(self, "args:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10492);
// compiled call node returning call10495 (depth = 5)
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if10485 = done;
  } else {
  }
stackframe = iftmpstackframe10485;
// compiled if node returning if10485 (depth = 3)
  sourceObject = obj10341;
  sourceObject = obj10341;
  sourceObject = obj10341;
  sourceObject = obj10341;
  objclass10341 = obj10341->class;
  objclass10341->definitionModule = modulename;
  objclass10341->definitionLine = 2562;
  (*(struct UserObject *)self).data[0] = lowerouter10341;
  self = oldself10341;
  selfslot = oldselfslot10341;
  stackframe = oldstackframe10341;
  gc_frame_end(frame);
  return obj10341;
}
Object meth_ast_new10340_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_callWithPart = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object var_init_values = alloc_BuiltinList();
  for (i = 0; i < argcv[0]; i++) {
    callmethod(var_init_values, "push", 1, pushcv, &args[curarg]);
    curarg++;
  }
  Object *var_values = &(stackframe->slots[0]);
  *var_values = var_init_values;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject10341 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj10341 = alloc_userobj2(14,12, objclass10341);
  gc_frame_newslot(obj10341);
if (objclass10341 == NULL) {
  glfree(obj10341->class->name);
  obj10341->class->name = "obj10333.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj10341, self, 0);
  addmethodreal(obj10341,"outer", &reader_ast_outer_10342);
  Object oldself10341 = self;
  struct StackFrameObject *oldstackframe10341 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe10341);
  gc_frame_newslot((Object)stackframe);
  self = obj10341;
  Object *oldselfslot10341 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter10341 = (*(struct UserObject *)self).data[0], lowerouter10341 = thisouter10341;
  if (inheritingObject10341) {
    struct UserObject *inho10341 = (struct UserObject *)inheritingObject10341;
    while (inho10341->super != GraceDefaultObject) inho10341 = (struct UserObject *)inho10341->super;
    inho10341->super = obj10341;
    self = inheritingObject10341;
    *selfslot = self;
    lowerouter10341 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter10341;
  }
if (objclass10341 == NULL) {
  Method *reader10343 = addmethodrealflags(obj10341, "kind",&reader_ast_kind_10343, MFLAG_DEF);
  reader10343->definitionModule = modulename;
  reader10343->definitionLine = 2568;
}
adddatum2(obj10341, alloc_Undefined(), 1);
if (objclass10341 == NULL) {
  Method *reader10344 = addmethodrealflags(obj10341, "name",&reader_ast_name_10344, 0);
  Method *writer10344 = addmethodrealflags(obj10341, "name:=",&writer_ast_name_10344, 0);
  reader10344->definitionModule = modulename;
  writer10344->definitionModule = modulename;
  reader10344->definitionLine = 2569;
  writer10344->definitionLine = 2569;
}
obj10341->flags |= OFLAG_MUTABLE;
adddatum2(obj10341, alloc_Undefined(), 2);
if (objclass10341 == NULL) {
  Method *reader10345 = addmethodrealflags(obj10341, "args",&reader_ast_args_10345, 0);
  Method *writer10345 = addmethodrealflags(obj10341, "args:=",&writer_ast_args_10345, 0);
  reader10345->definitionModule = modulename;
  writer10345->definitionModule = modulename;
  reader10345->definitionLine = 2570;
  writer10345->definitionLine = 2570;
}
obj10341->flags |= OFLAG_MUTABLE;
adddatum2(obj10341, alloc_Undefined(), 3);
if (objclass10341 == NULL) {
  Method *reader10346 = addmethodrealflags(obj10341, "lineLength",&reader_ast_lineLength_10346, 0);
  Method *writer10346 = addmethodrealflags(obj10341, "lineLength:=",&writer_ast_lineLength_10346, 0);
  reader10346->definitionModule = modulename;
  writer10346->definitionModule = modulename;
  reader10346->definitionLine = 2571;
  writer10346->definitionLine = 2571;
}
obj10341->flags |= OFLAG_MUTABLE;
adddatum2(obj10341, alloc_Undefined(), 4);
// method map()ancestors
  struct UserObject *uo10347 = (struct UserObject*)obj10341;
  uo10347->data[5] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors10347 = addmethod2pos(obj10341, "map()ancestors", &meth_ast_map_40__41_ancestors10347, 5);
  int argcv_meth_ast_map_40__41_ancestors10347[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors10347->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors10347);
  meth_meth_ast_map_40__41_ancestors10347->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors10347->definitionLine = 2579;
// method pretty
  struct UserObject *uo10364 = (struct UserObject*)obj10341;
  uo10364->data[6] = emptyclosure;
  Method *meth_meth_ast_pretty10364 = addmethod2pos(obj10341, "pretty", &meth_ast_pretty10364, 6);
  int argcv_meth_ast_pretty10364[] = {1};
  meth_meth_ast_pretty10364->type = alloc_MethodType(1, argcv_meth_ast_pretty10364);
  meth_meth_ast_pretty10364->definitionModule = modulename;
  meth_meth_ast_pretty10364->definitionLine = 2585;
// method shallowCopy
  block_savedest(obj10341);
  Object closure10451 = createclosure(1, "shallowCopy");
  setclosureframe(closure10451, stackframe);
  addtoclosure(closure10451, var_callWithPart);
  struct UserObject *uo10451 = (struct UserObject*)obj10341;
  uo10451->data[7] = (Object)closure10451;
  Method *meth_meth_ast_shallowCopy10451 = addmethod2pos(obj10341, "shallowCopy", &meth_ast_shallowCopy10451, 7);
  int argcv_meth_ast_shallowCopy10451[] = {0};
  meth_meth_ast_shallowCopy10451->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy10451);
  meth_meth_ast_shallowCopy10451->definitionModule = modulename;
  meth_meth_ast_shallowCopy10451->definitionLine = 2597;
// method shallowCopyFieldsFrom
  struct UserObject *uo10458 = (struct UserObject*)obj10341;
  uo10458->data[8] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom10458 = addmethod2pos(obj10341, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom10458, 8);
  int argcv_meth_ast_shallowCopyFieldsFrom10458[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom10458->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom10458);
  meth_meth_ast_shallowCopyFieldsFrom10458->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom10458->definitionLine = 2600;
  sourceObject = obj10341;
// Begin line 2567
  setline(2567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10465 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_baseNode (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call10466 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe10465);
// compiled call node returning call10466 (depth = 3)
  struct UserObject *obj10341_uo = (struct UserObject *)obj10341;
  obj10341_uo->super = call10466;
  sourceObject = obj10341;
// Begin line 2568
  setline(2568);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit10467 == NULL) {
    strlit10467 = alloc_String("callwithpart");
    gc_root(strlit10467);
  }
// compiled string node returning strlit10467 (depth = 3)
  adddatum2(obj10341, strlit10467, 1);
  sourceObject = obj10341;
// Begin line 2569
  setline(2569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit10468 == NULL) {
    strlit10468 = alloc_String("");
    gc_root(strlit10468);
  }
// compiled string node returning strlit10468 (depth = 3)
  adddatum2(obj10341, strlit10468, 2);
  sourceObject = obj10341;
// Begin line 2570
  setline(2570);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10469 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10470 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call10471 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10470);
// compiled call node returning call10471 (depth = 6)
// compiled member node returning call10471 (depth = 5)
  partcv[0] = 0;
  Object call10472 = callmethod(call10471, "empty",
    1, partcv, params);
  gc_frame_end(callframe10469);
// compiled call node returning call10472 (depth = 4)
// compiled member node returning call10472 (depth = 3)
  adddatum2(obj10341, call10472, 3);
  sourceObject = obj10341;
// Begin line 2571
  setline(2571);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num10473 = alloc_Float64(0);
// compiled num node returning num10473 (depth = 3)
  adddatum2(obj10341, num10473, 4);
  sourceObject = obj10341;
// Begin line 2572
  setline(2572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num10476 = alloc_Float64(0);
// compiled num node returning num10476 (depth = 5)
  int op_slot_right_10475 = gc_frame_newslot(num10476);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10478 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call10479 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe10478);
// compiled call node returning call10479 (depth = 6)
// compiled member node returning call10479 (depth = 5)
  int op_slot_left_10475 = gc_frame_newslot(call10479);
  params[0] = num10476;
  partcv[0] = 1;
  Object opresult10480 = callmethod(call10479, ">", 1, partcv, params);
// compiled op node returning opresult10480 (depth = 4)
  Object if10474 = done;
struct StackFrameObject *iftmpstackframe10474 = stackframe;
  if (istrue(opresult10480)) {
stackframe = alloc_StackFrame(0, iftmpstackframe10474);
gc_frame_newslot((Object)stackframe);
// Begin line 2573
  setline(2573);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2572
  setline(2572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10481 = gc_frame_new();
// Begin line 2574
  setline(2574);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile index node (depth = 6)
// Begin line 2573
  setline(2573);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
// starting to compile num node (depth = 7)
  Object num10482 = alloc_Float64(1);
// compiled num node returning num10482 (depth = 7)
  params[0] = num10482;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres10483 = callmethod(*var_values, "[]", 1, partcv, params);
// compiled index node returning idxres10483 (depth = 6)
  gc_frame_newslot(idxres10483);
// call case 4: self request
  params[0] = idxres10483;
  partcv[0] = 1;
  Object call10484 = callmethodflags(self, "name:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10481);
// compiled call node returning call10484 (depth = 5)
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if10474 = done;
  } else {
  }
stackframe = iftmpstackframe10474;
// compiled if node returning if10474 (depth = 3)
  sourceObject = obj10341;
// Begin line 2575
  setline(2575);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num10487 = alloc_Float64(1);
// compiled num node returning num10487 (depth = 5)
  int op_slot_right_10486 = gc_frame_newslot(num10487);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10489 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call10490 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe10489);
// compiled call node returning call10490 (depth = 6)
// compiled member node returning call10490 (depth = 5)
  int op_slot_left_10486 = gc_frame_newslot(call10490);
  params[0] = num10487;
  partcv[0] = 1;
  Object opresult10491 = callmethod(call10490, ">", 1, partcv, params);
// compiled op node returning opresult10491 (depth = 4)
  Object if10485 = done;
struct StackFrameObject *iftmpstackframe10485 = stackframe;
  if (istrue(opresult10491)) {
stackframe = alloc_StackFrame(0, iftmpstackframe10485);
gc_frame_newslot((Object)stackframe);
// Begin line 2576
  setline(2576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2575
  setline(2575);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10492 = gc_frame_new();
// Begin line 2577
  setline(2577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile index node (depth = 6)
// Begin line 2576
  setline(2576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
// starting to compile num node (depth = 7)
  Object num10493 = alloc_Float64(2);
// compiled num node returning num10493 (depth = 7)
  params[0] = num10493;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres10494 = callmethod(*var_values, "[]", 1, partcv, params);
// compiled index node returning idxres10494 (depth = 6)
  gc_frame_newslot(idxres10494);
// call case 4: self request
  params[0] = idxres10494;
  partcv[0] = 1;
  Object call10495 = callmethodflags(self, "args:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10492);
// compiled call node returning call10495 (depth = 5)
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if10485 = done;
  } else {
  }
stackframe = iftmpstackframe10485;
// compiled if node returning if10485 (depth = 3)
  sourceObject = obj10341;
  sourceObject = obj10341;
  sourceObject = obj10341;
  sourceObject = obj10341;
  objclass10341 = obj10341->class;
  objclass10341->definitionModule = modulename;
  objclass10341->definitionLine = 2562;
  (*(struct UserObject *)self).data[0] = lowerouter10341;
  self = oldself10341;
  selfslot = oldselfslot10341;
  stackframe = oldstackframe10341;
  gc_frame_end(frame);
  return obj10341;
}
Object meth_ast_callWithPart10497(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 48, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "callWithPart");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_callWithPart = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for callWithPart (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹callWithPart›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2556
  setline(2556);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_callWithPart (depth = 3)
  gc_frame_end(frame);
  return *var_callWithPart;
}
Object meth_ast_isComment10508(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isComment");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isComment (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isComment");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2616
  setline(2616);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10509 = alloc_Boolean(1);
// compiled identifier node returning bool10509 (depth = 3)
  gc_frame_end(frame);
  return bool10509;
}
Object meth_ast_asString10510(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2617
  setline(2617);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit10512 == NULL) {
    strlit10512 = alloc_String("");
    gc_root(strlit10512);
  }
// compiled string node returning strlit10512 (depth = 4)
  int op_slot_right_10511 = gc_frame_newslot(strlit10512);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10515 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10516 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10515);
// compiled call node returning call10516 (depth = 6)
// compiled member node returning call10516 (depth = 5)
  int op_slot_right_10514 = gc_frame_newslot(call10516);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10519 == NULL) {
    strlit10519 = alloc_String("): ");
    gc_root(strlit10519);
  }
// compiled string node returning strlit10519 (depth = 6)
  int op_slot_right_10518 = gc_frame_newslot(strlit10519);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10522 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10523 = callmethodflags(self, "endLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10522);
// compiled call node returning call10523 (depth = 8)
// compiled member node returning call10523 (depth = 7)
  int op_slot_right_10521 = gc_frame_newslot(call10523);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit10526 == NULL) {
    strlit10526 = alloc_String("""\xe2""""\x80""""\x93""");
    gc_root(strlit10526);
  }
// compiled string node returning strlit10526 (depth = 8)
  int op_slot_right_10525 = gc_frame_newslot(strlit10526);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10529 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10530 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10529);
// compiled call node returning call10530 (depth = 10)
// compiled member node returning call10530 (depth = 9)
  int op_slot_right_10528 = gc_frame_newslot(call10530);
// starting to compile string node (depth = 9)
  if (strlit10532 == NULL) {
    strlit10532 = alloc_String("comment (");
    gc_root(strlit10532);
  }
// compiled string node returning strlit10532 (depth = 9)
  int op_slot_left_10528 = gc_frame_newslot(strlit10532);
  params[0] = call10530;
  partcv[0] = 1;
  Object opresult10533 = callmethod(strlit10532, "++", 1, partcv, params);
// compiled op node returning opresult10533 (depth = 8)
  int op_slot_left_10525 = gc_frame_newslot(opresult10533);
  params[0] = strlit10526;
  partcv[0] = 1;
  Object opresult10534 = callmethod(opresult10533, "++", 1, partcv, params);
// compiled op node returning opresult10534 (depth = 7)
  int op_slot_left_10521 = gc_frame_newslot(opresult10534);
  params[0] = call10523;
  partcv[0] = 1;
  Object opresult10535 = callmethod(opresult10534, "++", 1, partcv, params);
// compiled op node returning opresult10535 (depth = 6)
  int op_slot_left_10518 = gc_frame_newslot(opresult10535);
  params[0] = strlit10519;
  partcv[0] = 1;
  Object opresult10536 = callmethod(opresult10535, "++", 1, partcv, params);
// compiled op node returning opresult10536 (depth = 5)
  int op_slot_left_10514 = gc_frame_newslot(opresult10536);
  params[0] = call10516;
  partcv[0] = 1;
  Object opresult10537 = callmethod(opresult10536, "++", 1, partcv, params);
// compiled op node returning opresult10537 (depth = 4)
  int op_slot_left_10511 = gc_frame_newslot(opresult10537);
  params[0] = strlit10512;
  partcv[0] = 1;
  Object opresult10538 = callmethod(opresult10537, "++", 1, partcv, params);
// compiled op node returning opresult10538 (depth = 3)
  gc_frame_end(frame);
  return opresult10538;
}
Object meth_ast_extendCommentUsing10539(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "extendCommentUsing");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method extendCommentUsing");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for extendCommentUsing (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cmtNode = &(stackframe->slots[0]);
  *var_cmtNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for extendCommentUsing");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2619
  setline(2619);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2617
  setline(2617);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10540 = gc_frame_new();
// Begin line 2619
  setline(2619);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10542 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_cmtNode (depth = 8)
  partcv[0] = 0;
  Object call10543 = callmethod(*var_cmtNode, "value",
    1, partcv, params);
  gc_frame_end(callframe10542);
// compiled call node returning call10543 (depth = 7)
// compiled member node returning call10543 (depth = 6)
  int op_slot_right_10541 = gc_frame_newslot(call10543);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10546 == NULL) {
    strlit10546 = alloc_String(" ");
    gc_root(strlit10546);
  }
// compiled string node returning strlit10546 (depth = 7)
  int op_slot_right_10545 = gc_frame_newslot(strlit10546);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10548 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10549 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10548);
// compiled call node returning call10549 (depth = 8)
// compiled member node returning call10549 (depth = 7)
  int op_slot_left_10545 = gc_frame_newslot(call10549);
  params[0] = strlit10546;
  partcv[0] = 1;
  Object opresult10550 = callmethod(call10549, "++", 1, partcv, params);
// compiled op node returning opresult10550 (depth = 6)
  int op_slot_left_10541 = gc_frame_newslot(opresult10550);
  params[0] = call10543;
  partcv[0] = 1;
  Object opresult10551 = callmethod(opresult10550, "++", 1, partcv, params);
// compiled op node returning opresult10551 (depth = 5)
  gc_frame_newslot(opresult10551);
// call case 4: self request
  params[0] = opresult10551;
  partcv[0] = 1;
  Object call10552 = callmethodflags(self, "value:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10540);
// compiled call node returning call10552 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 2620
  setline(2620);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2619
  setline(2619);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10553 = gc_frame_new();
// Begin line 2620
  setline(2620);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10554 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_cmtNode (depth = 7)
  partcv[0] = 0;
  Object call10555 = callmethod(*var_cmtNode, "endLine",
    1, partcv, params);
  gc_frame_end(callframe10554);
// compiled call node returning call10555 (depth = 6)
// compiled member node returning call10555 (depth = 5)
  gc_frame_newslot(call10555);
// call case 4: self request
  params[0] = call10555;
  partcv[0] = 1;
  Object call10556 = callmethodflags(self, "endLine:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10553);
// compiled call node returning call10556 (depth = 4)
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map_40__41_ancestors10557(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()ancestors");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2623
  setline(2623);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10558 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10559 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10558);
// compiled call node returning call10559 (depth = 5)
// compiled member node returning call10559 (depth = 4)
  *var_n = call10559;
  if (call10559 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2624
  setline(2624);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10560 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call10561 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe10560);
// compiled call node returning call10561 (depth = 4)
  *var_newChain = call10561;
  if (call10561 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2625
  setline(2625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10562 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call10563 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe10562);
// compiled call node returning call10563 (depth = 3)
  gc_frame_end(frame);
  return call10563;
}
Object meth_ast_accept_40__41_from10564(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2628
  setline(2628);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10565 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_visitor (depth = 4)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10566 = callmethod(*var_visitor, "visitComment()up",
    2, partcv, params);
  gc_frame_end(callframe10565);
// compiled call node returning call10566 (depth = 3)
  gc_frame_end(frame);
  return call10566;
}
Object meth_ast__apply10575(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// Begin line 2633
  setline(2633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10577 == NULL) {
    strlit10577 = alloc_String("  ");
    gc_root(strlit10577);
  }
// compiled string node returning strlit10577 (depth = 7)
  int op_slot_right_10576 = gc_frame_newslot(strlit10577);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_10576 = gc_frame_newslot(*var_s);
  params[0] = strlit10577;
  partcv[0] = 1;
  Object opresult10579 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult10579 (depth = 6)
  *var_s = opresult10579;
  if (opresult10579 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty10567(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
  Object *var_pb = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "pb");
// Begin line 2631
  setline(2631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit10568 == NULL) {
    strlit10568 = alloc_String("""\x0a""");
    gc_root(strlit10568);
  }
// compiled string node returning strlit10568 (depth = 4)
  *var_s = strlit10568;
  if (strlit10568 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2632
  setline(2632);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10569 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num10571 = alloc_Float64(1);
// compiled num node returning num10571 (depth = 5)
  int op_slot_right_10570 = gc_frame_newslot(num10571);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_left_10570 = gc_frame_newslot(*var_depth);
  params[0] = num10571;
  partcv[0] = 1;
  Object diff10573 = callmethod(*var_depth, "-", 1, partcv, params);
// compiled op node returning diff10573 (depth = 4)
  gc_frame_newslot(diff10573);
// starting to compile block node (depth = 4)
  Object block10574 = alloc_Block(NULL, NULL, "ast", 2632);
  gc_frame_newslot(block10574);
// method _apply
  block_savedest(block10574);
  Object closure10575 = createclosure(2, "_apply");
  setclosureframe(closure10575, stackframe);
  addtoclosure(closure10575, var_s);
  addtoclosure(closure10575, selfslot);
  struct UserObject *uo10575 = (struct UserObject*)block10574;
  uo10575->data[0] = (Object)closure10575;
  Method *meth_meth_ast__apply10575 = addmethod2pos(block10574, "_apply", &meth_ast__apply10575, 0);
  int argcv_meth_ast__apply10575[] = {0};
  meth_meth_ast__apply10575->type = alloc_MethodType(1, argcv_meth_ast__apply10575);
  meth_meth_ast__apply10575->definitionModule = modulename;
  meth_meth_ast__apply10575->definitionLine = 2623;
// compiled block node returning block10574 (depth = 4)
  gc_frame_newslot(block10574);
// call case 5: prelude request
  params[0] = diff10573;
  params[1] = block10574;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10582 = callmethodflags(prelude, "repeat()times", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10569);
// compiled call node returning call10582 (depth = 3)
// Begin line 2635
  setline(2635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10584 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10585 = callmethodflags(self, "isPreceededByBlankLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10584);
// compiled call node returning call10585 (depth = 6)
// compiled member node returning call10585 (depth = 5)
  Object if10583 = done;
struct StackFrameObject *iftmpstackframe10583 = stackframe;
  if (istrue(call10585)) {
stackframe = alloc_StackFrame(0, iftmpstackframe10583);
gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 5)
  if (strlit10586 == NULL) {
    strlit10586 = alloc_String(" > blank");
    gc_root(strlit10586);
  }
// compiled string node returning strlit10586 (depth = 5)
    gc_frame_newslot(strlit10586);
    if10583 = strlit10586;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe10583);
  gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 5)
  if (strlit10587 == NULL) {
    strlit10587 = alloc_String("");
    gc_root(strlit10587);
  }
// compiled string node returning strlit10587 (depth = 5)
    gc_frame_newslot(strlit10587);
    if10583 = strlit10587;
  }
stackframe = iftmpstackframe10583;
// compiled if node returning if10583 (depth = 4)
  *var_pb = if10583;
  if (if10583 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2636
  setline(2636);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit10589 == NULL) {
    strlit10589 = alloc_String("""\xe2""""\x80""""\xba""");
    gc_root(strlit10589);
  }
// compiled string node returning strlit10589 (depth = 4)
  int op_slot_right_10588 = gc_frame_newslot(strlit10589);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10592 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10593 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10592);
// compiled call node returning call10593 (depth = 6)
// compiled member node returning call10593 (depth = 5)
  int op_slot_right_10591 = gc_frame_newslot(call10593);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10596 == NULL) {
    strlit10596 = alloc_String("): ""\xe2""""\x80""""\xb9""");
    gc_root(strlit10596);
  }
// compiled string node returning strlit10596 (depth = 6)
  int op_slot_right_10595 = gc_frame_newslot(strlit10596);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10599 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10600 = callmethodflags(self, "endLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10599);
// compiled call node returning call10600 (depth = 8)
// compiled member node returning call10600 (depth = 7)
  int op_slot_right_10598 = gc_frame_newslot(call10600);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit10603 == NULL) {
    strlit10603 = alloc_String("""\xe2""""\x80""""\x93""");
    gc_root(strlit10603);
  }
// compiled string node returning strlit10603 (depth = 8)
  int op_slot_right_10602 = gc_frame_newslot(strlit10603);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10606 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10607 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10606);
// compiled call node returning call10607 (depth = 10)
// compiled member node returning call10607 (depth = 9)
  int op_slot_right_10605 = gc_frame_newslot(call10607);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit10610 == NULL) {
    strlit10610 = alloc_String("(");
    gc_root(strlit10610);
  }
// compiled string node returning strlit10610 (depth = 10)
  int op_slot_right_10609 = gc_frame_newslot(strlit10610);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_pb (depth = 11)
  int op_slot_right_10612 = gc_frame_newslot(*var_pb);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit10615 == NULL) {
    strlit10615 = alloc_String("Comment");
    gc_root(strlit10615);
  }
// compiled string node returning strlit10615 (depth = 12)
  int op_slot_right_10614 = gc_frame_newslot(strlit10615);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_s (depth = 13)
  int op_slot_right_10617 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 13)
  if (strlit10619 == NULL) {
    strlit10619 = alloc_String("");
    gc_root(strlit10619);
  }
// compiled string node returning strlit10619 (depth = 13)
  int op_slot_left_10617 = gc_frame_newslot(strlit10619);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult10620 = callmethod(strlit10619, "++", 1, partcv, params);
// compiled op node returning opresult10620 (depth = 12)
  int op_slot_left_10614 = gc_frame_newslot(opresult10620);
  params[0] = strlit10615;
  partcv[0] = 1;
  Object opresult10621 = callmethod(opresult10620, "++", 1, partcv, params);
// compiled op node returning opresult10621 (depth = 11)
  int op_slot_left_10612 = gc_frame_newslot(opresult10621);
  params[0] = *var_pb;
  partcv[0] = 1;
  Object opresult10622 = callmethod(opresult10621, "++", 1, partcv, params);
// compiled op node returning opresult10622 (depth = 10)
  int op_slot_left_10609 = gc_frame_newslot(opresult10622);
  params[0] = strlit10610;
  partcv[0] = 1;
  Object opresult10623 = callmethod(opresult10622, "++", 1, partcv, params);
// compiled op node returning opresult10623 (depth = 9)
  int op_slot_left_10605 = gc_frame_newslot(opresult10623);
  params[0] = call10607;
  partcv[0] = 1;
  Object opresult10624 = callmethod(opresult10623, "++", 1, partcv, params);
// compiled op node returning opresult10624 (depth = 8)
  int op_slot_left_10602 = gc_frame_newslot(opresult10624);
  params[0] = strlit10603;
  partcv[0] = 1;
  Object opresult10625 = callmethod(opresult10624, "++", 1, partcv, params);
// compiled op node returning opresult10625 (depth = 7)
  int op_slot_left_10598 = gc_frame_newslot(opresult10625);
  params[0] = call10600;
  partcv[0] = 1;
  Object opresult10626 = callmethod(opresult10625, "++", 1, partcv, params);
// compiled op node returning opresult10626 (depth = 6)
  int op_slot_left_10595 = gc_frame_newslot(opresult10626);
  params[0] = strlit10596;
  partcv[0] = 1;
  Object opresult10627 = callmethod(opresult10626, "++", 1, partcv, params);
// compiled op node returning opresult10627 (depth = 5)
  int op_slot_left_10591 = gc_frame_newslot(opresult10627);
  params[0] = call10593;
  partcv[0] = 1;
  Object opresult10628 = callmethod(opresult10627, "++", 1, partcv, params);
// compiled op node returning opresult10628 (depth = 4)
  int op_slot_left_10588 = gc_frame_newslot(opresult10628);
  params[0] = strlit10589;
  partcv[0] = 1;
  Object opresult10629 = callmethod(opresult10628, "++", 1, partcv, params);
// compiled op node returning opresult10629 (depth = 3)
  gc_frame_end(frame);
  return opresult10629;
}
Object meth_ast__apply10647(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit10649 == NULL) {
    strlit10649 = alloc_String("    ");
    gc_root(strlit10649);
  }
// compiled string node returning strlit10649 (depth = 8)
  int op_slot_right_10648 = gc_frame_newslot(strlit10649);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_10648 = gc_frame_newslot(*var_spc);
  params[0] = strlit10649;
  partcv[0] = 1;
  Object opresult10651 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult10651 (depth = 7)
  *var_spc = opresult10651;
  if (opresult10651 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace10630(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[3];
  int partcv[3];
  Object *var_lineLength = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
// Begin line 2641
  setline(2641);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10632 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10633 = callmethodflags(self, "isPartialLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10632);
// compiled call node returning call10633 (depth = 5)
// compiled member node returning call10633 (depth = 4)
  Object if10631 = done;
  if (istrue(call10633)) {
// Begin line 2642
  setline(2642);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit10635 == NULL) {
    strlit10635 = alloc_String("");
    gc_root(strlit10635);
  }
// compiled string node returning strlit10635 (depth = 5)
  int op_slot_right_10634 = gc_frame_newslot(strlit10635);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10638 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10639 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10638);
// compiled call node returning call10639 (depth = 7)
// compiled member node returning call10639 (depth = 6)
  int op_slot_right_10637 = gc_frame_newslot(call10639);
// starting to compile string node (depth = 6)
  if (strlit10641 == NULL) {
    strlit10641 = alloc_String("// (partial) ");
    gc_root(strlit10641);
  }
// compiled string node returning strlit10641 (depth = 6)
  int op_slot_left_10637 = gc_frame_newslot(strlit10641);
  params[0] = call10639;
  partcv[0] = 1;
  Object opresult10642 = callmethod(strlit10641, "++", 1, partcv, params);
// compiled op node returning opresult10642 (depth = 5)
  int op_slot_left_10634 = gc_frame_newslot(opresult10642);
  params[0] = strlit10635;
  partcv[0] = 1;
  Object opresult10643 = callmethod(opresult10642, "++", 1, partcv, params);
// compiled op node returning opresult10643 (depth = 4)
    gc_frame_newslot(opresult10643);
    if10631 = opresult10643;
  } else {
// Begin line 2644
  setline(2644);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit10644 == NULL) {
    strlit10644 = alloc_String("");
    gc_root(strlit10644);
  }
// compiled string node returning strlit10644 (depth = 5)
  *var_spc = strlit10644;
  if (strlit10644 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2645
  setline(2645);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10645 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  gc_frame_newslot(*var_depth);
// starting to compile block node (depth = 5)
  Object block10646 = alloc_Block(NULL, NULL, "ast", 2645);
  gc_frame_newslot(block10646);
// method _apply
  block_savedest(block10646);
  Object closure10647 = createclosure(2, "_apply");
  setclosureframe(closure10647, stackframe);
  addtoclosure(closure10647, var_spc);
  addtoclosure(closure10647, selfslot);
  struct UserObject *uo10647 = (struct UserObject*)block10646;
  uo10647->data[0] = (Object)closure10647;
  Method *meth_meth_ast__apply10647 = addmethod2pos(block10646, "_apply", &meth_ast__apply10647, 0);
  int argcv_meth_ast__apply10647[] = {0};
  meth_meth_ast__apply10647->type = alloc_MethodType(1, argcv_meth_ast__apply10647);
  meth_meth_ast__apply10647->definitionModule = modulename;
  meth_meth_ast__apply10647->definitionLine = 2642;
// compiled block node returning block10646 (depth = 5)
  gc_frame_newslot(block10646);
// call case 5: prelude request
  params[0] = *var_depth;
  params[1] = block10646;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10654 = callmethodflags(prelude, "repeat()times", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10645);
// compiled call node returning call10654 (depth = 4)
// Begin line 2646
  setline(2646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10655 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10656 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10657 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10656);
// compiled call node returning call10657 (depth = 6)
// compiled member node returning call10657 (depth = 5)
  gc_frame_newslot(call10657);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineLength (depth = 5)
  gc_frame_newslot(*var_lineLength);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10659 == NULL) {
    strlit10659 = alloc_String("// ");
    gc_root(strlit10659);
  }
// compiled string node returning strlit10659 (depth = 6)
  int op_slot_right_10658 = gc_frame_newslot(strlit10659);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_left_10658 = gc_frame_newslot(*var_spc);
  params[0] = strlit10659;
  partcv[0] = 1;
  Object opresult10661 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult10661 (depth = 5)
  gc_frame_newslot(opresult10661);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10662 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10663 = gc_frame_new();
// call case 3: self.outer request
  Object call10664 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe10663);
// compiled call node returning call10664 (depth = 8)
// compiled member node returning call10664 (depth = 7)
  partcv[0] = 0;
  Object call10665 = callmethodflags(call10664, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10662);
// compiled call node returning call10665 (depth = 6)
// compiled member node returning call10665 (depth = 5)
  params[0] = call10657;
  params[1] = *var_lineLength;
  params[2] = opresult10661;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call10666 = callmethodflags(call10665, "wrap()to()prefix", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10655);
// compiled call node returning call10666 (depth = 4)
    gc_frame_newslot(call10666);
    if10631 = call10666;
  }
// compiled if node returning if10631 (depth = 3)
  gc_frame_end(frame);
  return if10631;
}
Object meth_ast_shallowCopy10667(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_commentNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2650
  setline(2650);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10668 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe10669 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_commentNode (depth = 5)
  params[0] = *var_nullNode;
  partcv[0] = 1;
  Object call10670 = callmethod(*var_commentNode, "new",
    1, partcv, params);
  gc_frame_end(callframe10669);
// compiled call node returning call10670 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call10671 = callmethod(call10670, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe10668);
// compiled call node returning call10671 (depth = 3)
  gc_frame_end(frame);
  return call10671;
}
Object meth_ast_shallowCopyFieldsFrom10672(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyFieldsFrom");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopyFieldsFrom (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyFieldsFrom");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2653
  setline(2653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10673 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call10674 = callmethod4(self, "shallowCopyFieldsFrom", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe10673);
// compiled call node returning call10674 (depth = 3)
// Begin line 2654
  setline(2654);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2646
  setline(2646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10675 = gc_frame_new();
// Begin line 2654
  setline(2654);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10676 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  partcv[0] = 0;
  Object call10677 = callmethod(*var_other, "value",
    1, partcv, params);
  gc_frame_end(callframe10676);
// compiled call node returning call10677 (depth = 6)
// compiled member node returning call10677 (depth = 5)
  gc_frame_newslot(call10677);
// call case 4: self request
  params[0] = call10677;
  partcv[0] = 1;
  Object call10678 = callmethodflags(self, "value:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10675);
// compiled call node returning call10678 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 2655
  setline(2655);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2654
  setline(2654);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10679 = gc_frame_new();
// Begin line 2655
  setline(2655);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10680 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  partcv[0] = 0;
  Object call10681 = callmethod(*var_other, "isPartialLine",
    1, partcv, params);
  gc_frame_end(callframe10680);
// compiled call node returning call10681 (depth = 6)
// compiled member node returning call10681 (depth = 5)
  gc_frame_newslot(call10681);
// call case 4: self request
  params[0] = call10681;
  partcv[0] = 1;
  Object call10682 = callmethodflags(self, "isPartialLine:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10679);
// compiled call node returning call10682 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 2656
  setline(2656);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2655
  setline(2655);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10683 = gc_frame_new();
// Begin line 2656
  setline(2656);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10684 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  partcv[0] = 0;
  Object call10685 = callmethod(*var_other, "endLine",
    1, partcv, params);
  gc_frame_end(callframe10684);
// compiled call node returning call10685 (depth = 6)
// compiled member node returning call10685 (depth = 5)
  gc_frame_newslot(call10685);
// call case 4: self request
  params[0] = call10685;
  partcv[0] = 1;
  Object call10686 = callmethodflags(self, "endLine:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10683);
// compiled call node returning call10686 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 2657
  setline(2657);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_new10500(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_lineLength = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_commentNode = getfromclosure(closure, 2);
  Object *var_baseNode = getfromclosure(closure, 3);
  Object *var_util = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_val_39_ = &(stackframe->slots[0]);
  *var_val_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject10501 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj10501 = alloc_userobj2(19,16, objclass10501);
  gc_frame_newslot(obj10501);
if (objclass10501 == NULL) {
  glfree(obj10501->class->name);
  obj10501->class->name = "obj10498.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj10501, self, 0);
  addmethodreal(obj10501,"outer", &reader_ast_outer_10502);
  Object oldself10501 = self;
  struct StackFrameObject *oldstackframe10501 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe10501);
  gc_frame_newslot((Object)stackframe);
  self = obj10501;
  Object *oldselfslot10501 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter10501 = (*(struct UserObject *)self).data[0], lowerouter10501 = thisouter10501;
  if (inheritingObject10501) {
    struct UserObject *inho10501 = (struct UserObject *)inheritingObject10501;
    while (inho10501->super != GraceDefaultObject) inho10501 = (struct UserObject *)inho10501->super;
    inho10501->super = obj10501;
    self = inheritingObject10501;
    *selfslot = self;
    lowerouter10501 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter10501;
  }
if (objclass10501 == NULL) {
  Method *reader10503 = addmethodrealflags(obj10501, "kind",&reader_ast_kind_10503, MFLAG_DEF);
  reader10503->definitionModule = modulename;
  reader10503->definitionLine = 2611;
}
adddatum2(obj10501, alloc_Undefined(), 1);
if (objclass10501 == NULL) {
  Method *reader10504 = addmethodrealflags(obj10501, "value",&reader_ast_value_10504, 0);
  Method *writer10504 = addmethodrealflags(obj10501, "value:=",&writer_ast_value_10504, 0);
  reader10504->definitionModule = modulename;
  writer10504->definitionModule = modulename;
  reader10504->definitionLine = 2612;
  writer10504->definitionLine = 2612;
}
obj10501->flags |= OFLAG_MUTABLE;
adddatum2(obj10501, alloc_Undefined(), 2);
if (objclass10501 == NULL) {
  Method *reader10505 = addmethodrealflags(obj10501, "isPartialLine",&reader_ast_isPartialLine_10505, 0);
  Method *writer10505 = addmethodrealflags(obj10501, "isPartialLine:=",&writer_ast_isPartialLine_10505, 0);
  reader10505->definitionModule = modulename;
  writer10505->definitionModule = modulename;
  reader10505->definitionLine = 2613;
  writer10505->definitionLine = 2613;
}
obj10501->flags |= OFLAG_MUTABLE;
adddatum2(obj10501, alloc_Undefined(), 3);
if (objclass10501 == NULL) {
  Method *reader10506 = addmethodrealflags(obj10501, "isPreceededByBlankLine",&reader_ast_isPreceededByBlankLine_10506, 0);
  Method *writer10506 = addmethodrealflags(obj10501, "isPreceededByBlankLine:=",&writer_ast_isPreceededByBlankLine_10506, 0);
  reader10506->definitionModule = modulename;
  writer10506->definitionModule = modulename;
  reader10506->definitionLine = 2614;
  writer10506->definitionLine = 2614;
}
obj10501->flags |= OFLAG_MUTABLE;
adddatum2(obj10501, alloc_Undefined(), 4);
if (objclass10501 == NULL) {
  Method *reader10507 = addmethodrealflags(obj10501, "endLine",&reader_ast_endLine_10507, 0);
  Method *writer10507 = addmethodrealflags(obj10501, "endLine:=",&writer_ast_endLine_10507, 0);
  reader10507->definitionModule = modulename;
  writer10507->definitionModule = modulename;
  reader10507->definitionLine = 2615;
  writer10507->definitionLine = 2615;
}
obj10501->flags |= OFLAG_MUTABLE;
adddatum2(obj10501, alloc_Undefined(), 5);
// method isComment
  struct UserObject *uo10508 = (struct UserObject*)obj10501;
  uo10508->data[6] = emptyclosure;
  Method *meth_meth_ast_isComment10508 = addmethod2pos(obj10501, "isComment", &meth_ast_isComment10508, 6);
  int argcv_meth_ast_isComment10508[] = {0};
  meth_meth_ast_isComment10508->type = alloc_MethodType(1, argcv_meth_ast_isComment10508);
  meth_meth_ast_isComment10508->definitionModule = modulename;
  meth_meth_ast_isComment10508->definitionLine = 2616;
// method asString
  struct UserObject *uo10510 = (struct UserObject*)obj10501;
  uo10510->data[7] = emptyclosure;
  Method *meth_meth_ast_asString10510 = addmethod2pos(obj10501, "asString", &meth_ast_asString10510, 7);
  int argcv_meth_ast_asString10510[] = {0};
  meth_meth_ast_asString10510->type = alloc_MethodType(1, argcv_meth_ast_asString10510);
  meth_meth_ast_asString10510->definitionModule = modulename;
  meth_meth_ast_asString10510->definitionLine = 2617;
// method extendCommentUsing
  struct UserObject *uo10539 = (struct UserObject*)obj10501;
  uo10539->data[8] = emptyclosure;
  Method *meth_meth_ast_extendCommentUsing10539 = addmethod2pos(obj10501, "extendCommentUsing", &meth_ast_extendCommentUsing10539, 8);
  int argcv_meth_ast_extendCommentUsing10539[] = {1};
  meth_meth_ast_extendCommentUsing10539->type = alloc_MethodType(1, argcv_meth_ast_extendCommentUsing10539);
  meth_meth_ast_extendCommentUsing10539->definitionModule = modulename;
  meth_meth_ast_extendCommentUsing10539->definitionLine = 2618;
// method map()ancestors
  struct UserObject *uo10557 = (struct UserObject*)obj10501;
  uo10557->data[9] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors10557 = addmethod2pos(obj10501, "map()ancestors", &meth_ast_map_40__41_ancestors10557, 9);
  int argcv_meth_ast_map_40__41_ancestors10557[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors10557->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors10557);
  meth_meth_ast_map_40__41_ancestors10557->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors10557->definitionLine = 2622;
// method accept()from
  struct UserObject *uo10564 = (struct UserObject*)obj10501;
  uo10564->data[10] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from10564 = addmethod2pos(obj10501, "accept()from", &meth_ast_accept_40__41_from10564, 10);
  int argcv_meth_ast_accept_40__41_from10564[] = {1, 1};
  meth_meth_ast_accept_40__41_from10564->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from10564);
  meth_meth_ast_accept_40__41_from10564->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from10564->definitionLine = 2627;
// method pretty
  struct UserObject *uo10567 = (struct UserObject*)obj10501;
  uo10567->data[11] = emptyclosure;
  Method *meth_meth_ast_pretty10567 = addmethod2pos(obj10501, "pretty", &meth_ast_pretty10567, 11);
  int argcv_meth_ast_pretty10567[] = {1};
  meth_meth_ast_pretty10567->type = alloc_MethodType(1, argcv_meth_ast_pretty10567);
  meth_meth_ast_pretty10567->definitionModule = modulename;
  meth_meth_ast_pretty10567->definitionLine = 2630;
// method toGrace
  block_savedest(obj10501);
  Object closure10630 = createclosure(1, "toGrace");
  setclosureframe(closure10630, stackframe);
  addtoclosure(closure10630, var_lineLength);
  struct UserObject *uo10630 = (struct UserObject*)obj10501;
  uo10630->data[12] = (Object)closure10630;
  Method *meth_meth_ast_toGrace10630 = addmethod2pos(obj10501, "toGrace", &meth_ast_toGrace10630, 12);
  int argcv_meth_ast_toGrace10630[] = {1};
  meth_meth_ast_toGrace10630->type = alloc_MethodType(1, argcv_meth_ast_toGrace10630);
  meth_meth_ast_toGrace10630->definitionModule = modulename;
  meth_meth_ast_toGrace10630->definitionLine = 2638;
// method shallowCopy
  block_savedest(obj10501);
  Object closure10667 = createclosure(2, "shallowCopy");
  setclosureframe(closure10667, stackframe);
  addtoclosure(closure10667, var_nullNode);
  addtoclosure(closure10667, var_commentNode);
  struct UserObject *uo10667 = (struct UserObject*)obj10501;
  uo10667->data[13] = (Object)closure10667;
  Method *meth_meth_ast_shallowCopy10667 = addmethod2pos(obj10501, "shallowCopy", &meth_ast_shallowCopy10667, 13);
  int argcv_meth_ast_shallowCopy10667[] = {0};
  meth_meth_ast_shallowCopy10667->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy10667);
  meth_meth_ast_shallowCopy10667->definitionModule = modulename;
  meth_meth_ast_shallowCopy10667->definitionLine = 2649;
// method shallowCopyFieldsFrom
  struct UserObject *uo10672 = (struct UserObject*)obj10501;
  uo10672->data[14] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom10672 = addmethod2pos(obj10501, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom10672, 14);
  int argcv_meth_ast_shallowCopyFieldsFrom10672[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom10672->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom10672);
  meth_meth_ast_shallowCopyFieldsFrom10672->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom10672->definitionLine = 2652;
  sourceObject = obj10501;
// Begin line 2610
  setline(2610);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10687 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_baseNode (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call10688 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe10687);
// compiled call node returning call10688 (depth = 3)
  struct UserObject *obj10501_uo = (struct UserObject *)obj10501;
  obj10501_uo->super = call10688;
  sourceObject = obj10501;
// Begin line 2611
  setline(2611);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit10689 == NULL) {
    strlit10689 = alloc_String("comment");
    gc_root(strlit10689);
  }
// compiled string node returning strlit10689 (depth = 3)
  adddatum2(obj10501, strlit10689, 1);
  sourceObject = obj10501;
// Begin line 2612
  setline(2612);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val_39_ (depth = 3)
  adddatum2(obj10501, *var_val_39_, 2);
  sourceObject = obj10501;
// Begin line 2613
  setline(2613);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10690 = alloc_Boolean(0);
// compiled identifier node returning bool10690 (depth = 3)
  adddatum2(obj10501, bool10690, 3);
  sourceObject = obj10501;
// Begin line 2614
  setline(2614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10691 = alloc_Boolean(0);
// compiled identifier node returning bool10691 (depth = 3)
  adddatum2(obj10501, bool10691, 4);
  sourceObject = obj10501;
// Begin line 2615
  setline(2615);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10692 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  partcv[0] = 0;
  Object call10693 = callmethod(*var_util, "linenum",
    1, partcv, params);
  gc_frame_end(callframe10692);
// compiled call node returning call10693 (depth = 4)
// compiled member node returning call10693 (depth = 3)
  adddatum2(obj10501, call10693, 5);
  sourceObject = obj10501;
  sourceObject = obj10501;
  sourceObject = obj10501;
  sourceObject = obj10501;
  sourceObject = obj10501;
  sourceObject = obj10501;
  sourceObject = obj10501;
  sourceObject = obj10501;
  sourceObject = obj10501;
  objclass10501 = obj10501->class;
  objclass10501->definitionModule = modulename;
  objclass10501->definitionLine = 2609;
  (*(struct UserObject *)self).data[0] = lowerouter10501;
  self = oldself10501;
  selfslot = oldselfslot10501;
  stackframe = oldstackframe10501;
  gc_frame_end(frame);
  return obj10501;
}
Object meth_ast_new10500_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_lineLength = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_commentNode = getfromclosure(closure, 2);
  Object *var_baseNode = getfromclosure(closure, 3);
  Object *var_util = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_val_39_ = &(stackframe->slots[0]);
  *var_val_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject10501 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj10501 = alloc_userobj2(19,16, objclass10501);
  gc_frame_newslot(obj10501);
if (objclass10501 == NULL) {
  glfree(obj10501->class->name);
  obj10501->class->name = "obj10498.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj10501, self, 0);
  addmethodreal(obj10501,"outer", &reader_ast_outer_10502);
  Object oldself10501 = self;
  struct StackFrameObject *oldstackframe10501 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe10501);
  gc_frame_newslot((Object)stackframe);
  self = obj10501;
  Object *oldselfslot10501 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter10501 = (*(struct UserObject *)self).data[0], lowerouter10501 = thisouter10501;
  if (inheritingObject10501) {
    struct UserObject *inho10501 = (struct UserObject *)inheritingObject10501;
    while (inho10501->super != GraceDefaultObject) inho10501 = (struct UserObject *)inho10501->super;
    inho10501->super = obj10501;
    self = inheritingObject10501;
    *selfslot = self;
    lowerouter10501 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter10501;
  }
if (objclass10501 == NULL) {
  Method *reader10503 = addmethodrealflags(obj10501, "kind",&reader_ast_kind_10503, MFLAG_DEF);
  reader10503->definitionModule = modulename;
  reader10503->definitionLine = 2611;
}
adddatum2(obj10501, alloc_Undefined(), 1);
if (objclass10501 == NULL) {
  Method *reader10504 = addmethodrealflags(obj10501, "value",&reader_ast_value_10504, 0);
  Method *writer10504 = addmethodrealflags(obj10501, "value:=",&writer_ast_value_10504, 0);
  reader10504->definitionModule = modulename;
  writer10504->definitionModule = modulename;
  reader10504->definitionLine = 2612;
  writer10504->definitionLine = 2612;
}
obj10501->flags |= OFLAG_MUTABLE;
adddatum2(obj10501, alloc_Undefined(), 2);
if (objclass10501 == NULL) {
  Method *reader10505 = addmethodrealflags(obj10501, "isPartialLine",&reader_ast_isPartialLine_10505, 0);
  Method *writer10505 = addmethodrealflags(obj10501, "isPartialLine:=",&writer_ast_isPartialLine_10505, 0);
  reader10505->definitionModule = modulename;
  writer10505->definitionModule = modulename;
  reader10505->definitionLine = 2613;
  writer10505->definitionLine = 2613;
}
obj10501->flags |= OFLAG_MUTABLE;
adddatum2(obj10501, alloc_Undefined(), 3);
if (objclass10501 == NULL) {
  Method *reader10506 = addmethodrealflags(obj10501, "isPreceededByBlankLine",&reader_ast_isPreceededByBlankLine_10506, 0);
  Method *writer10506 = addmethodrealflags(obj10501, "isPreceededByBlankLine:=",&writer_ast_isPreceededByBlankLine_10506, 0);
  reader10506->definitionModule = modulename;
  writer10506->definitionModule = modulename;
  reader10506->definitionLine = 2614;
  writer10506->definitionLine = 2614;
}
obj10501->flags |= OFLAG_MUTABLE;
adddatum2(obj10501, alloc_Undefined(), 4);
if (objclass10501 == NULL) {
  Method *reader10507 = addmethodrealflags(obj10501, "endLine",&reader_ast_endLine_10507, 0);
  Method *writer10507 = addmethodrealflags(obj10501, "endLine:=",&writer_ast_endLine_10507, 0);
  reader10507->definitionModule = modulename;
  writer10507->definitionModule = modulename;
  reader10507->definitionLine = 2615;
  writer10507->definitionLine = 2615;
}
obj10501->flags |= OFLAG_MUTABLE;
adddatum2(obj10501, alloc_Undefined(), 5);
// method isComment
  struct UserObject *uo10508 = (struct UserObject*)obj10501;
  uo10508->data[6] = emptyclosure;
  Method *meth_meth_ast_isComment10508 = addmethod2pos(obj10501, "isComment", &meth_ast_isComment10508, 6);
  int argcv_meth_ast_isComment10508[] = {0};
  meth_meth_ast_isComment10508->type = alloc_MethodType(1, argcv_meth_ast_isComment10508);
  meth_meth_ast_isComment10508->definitionModule = modulename;
  meth_meth_ast_isComment10508->definitionLine = 2616;
// method asString
  struct UserObject *uo10510 = (struct UserObject*)obj10501;
  uo10510->data[7] = emptyclosure;
  Method *meth_meth_ast_asString10510 = addmethod2pos(obj10501, "asString", &meth_ast_asString10510, 7);
  int argcv_meth_ast_asString10510[] = {0};
  meth_meth_ast_asString10510->type = alloc_MethodType(1, argcv_meth_ast_asString10510);
  meth_meth_ast_asString10510->definitionModule = modulename;
  meth_meth_ast_asString10510->definitionLine = 2617;
// method extendCommentUsing
  struct UserObject *uo10539 = (struct UserObject*)obj10501;
  uo10539->data[8] = emptyclosure;
  Method *meth_meth_ast_extendCommentUsing10539 = addmethod2pos(obj10501, "extendCommentUsing", &meth_ast_extendCommentUsing10539, 8);
  int argcv_meth_ast_extendCommentUsing10539[] = {1};
  meth_meth_ast_extendCommentUsing10539->type = alloc_MethodType(1, argcv_meth_ast_extendCommentUsing10539);
  meth_meth_ast_extendCommentUsing10539->definitionModule = modulename;
  meth_meth_ast_extendCommentUsing10539->definitionLine = 2618;
// method map()ancestors
  struct UserObject *uo10557 = (struct UserObject*)obj10501;
  uo10557->data[9] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors10557 = addmethod2pos(obj10501, "map()ancestors", &meth_ast_map_40__41_ancestors10557, 9);
  int argcv_meth_ast_map_40__41_ancestors10557[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors10557->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors10557);
  meth_meth_ast_map_40__41_ancestors10557->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors10557->definitionLine = 2622;
// method accept()from
  struct UserObject *uo10564 = (struct UserObject*)obj10501;
  uo10564->data[10] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from10564 = addmethod2pos(obj10501, "accept()from", &meth_ast_accept_40__41_from10564, 10);
  int argcv_meth_ast_accept_40__41_from10564[] = {1, 1};
  meth_meth_ast_accept_40__41_from10564->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from10564);
  meth_meth_ast_accept_40__41_from10564->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from10564->definitionLine = 2627;
// method pretty
  struct UserObject *uo10567 = (struct UserObject*)obj10501;
  uo10567->data[11] = emptyclosure;
  Method *meth_meth_ast_pretty10567 = addmethod2pos(obj10501, "pretty", &meth_ast_pretty10567, 11);
  int argcv_meth_ast_pretty10567[] = {1};
  meth_meth_ast_pretty10567->type = alloc_MethodType(1, argcv_meth_ast_pretty10567);
  meth_meth_ast_pretty10567->definitionModule = modulename;
  meth_meth_ast_pretty10567->definitionLine = 2630;
// method toGrace
  block_savedest(obj10501);
  Object closure10630 = createclosure(1, "toGrace");
  setclosureframe(closure10630, stackframe);
  addtoclosure(closure10630, var_lineLength);
  struct UserObject *uo10630 = (struct UserObject*)obj10501;
  uo10630->data[12] = (Object)closure10630;
  Method *meth_meth_ast_toGrace10630 = addmethod2pos(obj10501, "toGrace", &meth_ast_toGrace10630, 12);
  int argcv_meth_ast_toGrace10630[] = {1};
  meth_meth_ast_toGrace10630->type = alloc_MethodType(1, argcv_meth_ast_toGrace10630);
  meth_meth_ast_toGrace10630->definitionModule = modulename;
  meth_meth_ast_toGrace10630->definitionLine = 2638;
// method shallowCopy
  block_savedest(obj10501);
  Object closure10667 = createclosure(2, "shallowCopy");
  setclosureframe(closure10667, stackframe);
  addtoclosure(closure10667, var_nullNode);
  addtoclosure(closure10667, var_commentNode);
  struct UserObject *uo10667 = (struct UserObject*)obj10501;
  uo10667->data[13] = (Object)closure10667;
  Method *meth_meth_ast_shallowCopy10667 = addmethod2pos(obj10501, "shallowCopy", &meth_ast_shallowCopy10667, 13);
  int argcv_meth_ast_shallowCopy10667[] = {0};
  meth_meth_ast_shallowCopy10667->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy10667);
  meth_meth_ast_shallowCopy10667->definitionModule = modulename;
  meth_meth_ast_shallowCopy10667->definitionLine = 2649;
// method shallowCopyFieldsFrom
  struct UserObject *uo10672 = (struct UserObject*)obj10501;
  uo10672->data[14] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom10672 = addmethod2pos(obj10501, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom10672, 14);
  int argcv_meth_ast_shallowCopyFieldsFrom10672[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom10672->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom10672);
  meth_meth_ast_shallowCopyFieldsFrom10672->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom10672->definitionLine = 2652;
  sourceObject = obj10501;
// Begin line 2610
  setline(2610);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10687 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_baseNode (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call10688 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe10687);
// compiled call node returning call10688 (depth = 3)
  struct UserObject *obj10501_uo = (struct UserObject *)obj10501;
  obj10501_uo->super = call10688;
  sourceObject = obj10501;
// Begin line 2611
  setline(2611);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit10689 == NULL) {
    strlit10689 = alloc_String("comment");
    gc_root(strlit10689);
  }
// compiled string node returning strlit10689 (depth = 3)
  adddatum2(obj10501, strlit10689, 1);
  sourceObject = obj10501;
// Begin line 2612
  setline(2612);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val_39_ (depth = 3)
  adddatum2(obj10501, *var_val_39_, 2);
  sourceObject = obj10501;
// Begin line 2613
  setline(2613);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10690 = alloc_Boolean(0);
// compiled identifier node returning bool10690 (depth = 3)
  adddatum2(obj10501, bool10690, 3);
  sourceObject = obj10501;
// Begin line 2614
  setline(2614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10691 = alloc_Boolean(0);
// compiled identifier node returning bool10691 (depth = 3)
  adddatum2(obj10501, bool10691, 4);
  sourceObject = obj10501;
// Begin line 2615
  setline(2615);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10692 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  partcv[0] = 0;
  Object call10693 = callmethod(*var_util, "linenum",
    1, partcv, params);
  gc_frame_end(callframe10692);
// compiled call node returning call10693 (depth = 4)
// compiled member node returning call10693 (depth = 3)
  adddatum2(obj10501, call10693, 5);
  sourceObject = obj10501;
  sourceObject = obj10501;
  sourceObject = obj10501;
  sourceObject = obj10501;
  sourceObject = obj10501;
  sourceObject = obj10501;
  sourceObject = obj10501;
  sourceObject = obj10501;
  sourceObject = obj10501;
  objclass10501 = obj10501->class;
  objclass10501->definitionModule = modulename;
  objclass10501->definitionLine = 2609;
  (*(struct UserObject *)self).data[0] = lowerouter10501;
  self = oldself10501;
  selfslot = oldselfslot10501;
  stackframe = oldstackframe10501;
  gc_frame_end(frame);
  return obj10501;
}
Object meth_ast_commentNode10695(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 49, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "commentNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_commentNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for commentNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹commentNode›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2608
  setline(2608);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_commentNode (depth = 3)
  gc_frame_end(frame);
  return *var_commentNode;
}
Object meth_ast_ASTVisitor10698(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 50, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "ASTVisitor");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ASTVisitor = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for ASTVisitor (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹ASTVisitor›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2696
  setline(2696);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ASTVisitor (depth = 3)
  gc_frame_end(frame);
  return *var_ASTVisitor;
}
Object meth_ast_visitCall_40__41_up10701(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitCall()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitCall()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitCall()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitCall()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitCall");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2843
  setline(2843);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2615
  setline(2615);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10702 = gc_frame_new();
// Begin line 2843
  setline(2843);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool10703 = alloc_Boolean(1);
// compiled identifier node returning bool10703 (depth = 5)
  gc_frame_newslot(bool10703);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_c (depth = 5)
  params[0] = bool10703;
  partcv[0] = 1;
  Object call10704 = callmethod(*var_c, "isPattern:=",
    1, partcv, params);
  gc_frame_end(callframe10702);
// compiled call node returning call10704 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 2844
  setline(2844);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10705 = alloc_Boolean(1);
// compiled identifier node returning bool10705 (depth = 3)
  gc_frame_end(frame);
  return bool10705;
}
Object meth_ast_patternMarkVisitor10710(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 51, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "patternMarkVisitor");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_patternMarkVisitor = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for patternMarkVisitor (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹patternMarkVisitor›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2840
  setline(2840);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_patternMarkVisitor (depth = 3)
  gc_frame_end(frame);
  return *var_patternMarkVisitor;
}
Object module_ast_init() {
  int flags = 0;
  int frame = gc_frame_new();
  Object self = alloc_obj2(55, 55);
  self->class->definitionModule = modulename;
  gc_root(self);
  prelude = module_StandardPrelude_init();
  adddatum2(self, prelude, 0);
  addmethod2(self, "outer", &grace_userobj_outer);
  setline(1);
  setmodule(modulename);
  setsource(originalSourceLines);
  setclassname(self, "Module<ast>");
  Object *var_MatchFailed = alloc_var();
  *var_MatchFailed = alloc_MatchFailed();
  Object *var_noSuchValue = alloc_var();
  *var_noSuchValue = done;
  Object *var_done = alloc_var();
  *var_done = done;
  Object *var_Object = alloc_var();
  *var_Object = ObjectType;
  type_Object = ObjectType;
  Object *var_String = alloc_var();
  *var_String = String;
  type_String = String;
  Object *var_Block = alloc_var();
  *var_Block = Block;
  type_Block = Block;
  Object *var_Done = alloc_var();
  *var_Done = Done;
  type_Done = Done;
  Object *var_Number = alloc_var();
  *var_Number = Number;
  type_Number = Number;
  Object *var_Boolean = alloc_var();
  *var_Boolean = Boolean;
  type_Boolean = Boolean;
  Object *var_Dynamic = alloc_var();
  *var_Dynamic = Dynamic;
  Object *var_Unknown = alloc_var();
  *var_Unknown= Unknown;
  Object *var_Type = alloc_var();
  *var_Type = Type;
  type_Done = Type;
  Object *var__prelude = alloc_var();
  *var__prelude = grace_prelude();
  Object *var_prelude = alloc_var();
  *var_prelude = prelude;
  gc_root(*var_MatchFailed);
  emptyclosure = createclosure(0, "empty");
  gc_root(emptyclosure);
  struct StackFrameObject *stackframe = alloc_StackFrame(55, NULL);
  gc_root((Object)stackframe);
  pushstackframe(stackframe, "module scope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object params[2];
  int partcv[2];
  Object *var_util = alloc_var();
  Object *var_lineLength = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "lineLength");
  Object *var_ancestorChain = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "ancestorChain");
  Object *var_emptySeq = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "emptySeq");
  Object *var_AstNode = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "AstNode");
  Object *var_SymbolTable = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "SymbolTable");
  Object *var_baseNode = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "baseNode");
  Object *var_nullNode = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "nullNode");
  Object *var_fakeSymbolTable = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "fakeSymbolTable");
  Object *var_ifNode = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "ifNode");
  Object *var_blockNode = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "blockNode");
  Object *var_catchCaseNode = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "catchCaseNode");
  Object *var_matchCaseNode = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "matchCaseNode");
  Object *var_methodTypeNode = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "methodTypeNode");
  Object *var_typeLiteralNode = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "typeLiteralNode");
  Object *var_typeDecNode = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "typeDecNode");
  Object *var_methodNode = &(stackframe->slots[16]);
  setframeelementname(stackframe, 16, "methodNode");
  Object *var_callNode = &(stackframe->slots[17]);
  setframeelementname(stackframe, 17, "callNode");
  Object *var_classNode = &(stackframe->slots[18]);
  setframeelementname(stackframe, 18, "classNode");
  Object *var_moduleNode = &(stackframe->slots[19]);
  setframeelementname(stackframe, 19, "moduleNode");
  Object *var_objectNode = &(stackframe->slots[20]);
  setframeelementname(stackframe, 20, "objectNode");
  Object *var_arrayNode = &(stackframe->slots[21]);
  setframeelementname(stackframe, 21, "arrayNode");
  Object *var_memberNode = &(stackframe->slots[22]);
  setframeelementname(stackframe, 22, "memberNode");
  Object *var_genericNode = &(stackframe->slots[23]);
  setframeelementname(stackframe, 23, "genericNode");
  Object *var_typeParametersNode = &(stackframe->slots[24]);
  setframeelementname(stackframe, 24, "typeParametersNode");
  Object *var_identifierNode = &(stackframe->slots[25]);
  setframeelementname(stackframe, 25, "identifierNode");
  Object *var_typeType = &(stackframe->slots[26]);
  setframeelementname(stackframe, 26, "typeType");
  Object *var_unknownType = &(stackframe->slots[27]);
  setframeelementname(stackframe, 27, "unknownType");
  Object *var_stringNode = &(stackframe->slots[28]);
  setframeelementname(stackframe, 28, "stringNode");
  Object *var_numNode = &(stackframe->slots[29]);
  setframeelementname(stackframe, 29, "numNode");
  Object *var_opNode = &(stackframe->slots[30]);
  setframeelementname(stackframe, 30, "opNode");
  Object *var_indexNode = &(stackframe->slots[31]);
  setframeelementname(stackframe, 31, "indexNode");
  Object *var_bindNode = &(stackframe->slots[32]);
  setframeelementname(stackframe, 32, "bindNode");
  Object *var_defDecNode = &(stackframe->slots[33]);
  setframeelementname(stackframe, 33, "defDecNode");
  Object *var_varDecNode = &(stackframe->slots[34]);
  setframeelementname(stackframe, 34, "varDecNode");
  Object *var_importNode = &(stackframe->slots[35]);
  setframeelementname(stackframe, 35, "importNode");
  Object *var_dialectNode = &(stackframe->slots[36]);
  setframeelementname(stackframe, 36, "dialectNode");
  Object *var_returnNode = &(stackframe->slots[37]);
  setframeelementname(stackframe, 37, "returnNode");
  Object *var_inheritsNode = &(stackframe->slots[38]);
  setframeelementname(stackframe, 38, "inheritsNode");
  Object *var_blankNode = &(stackframe->slots[39]);
  setframeelementname(stackframe, 39, "blankNode");
  Object *var_signaturePart = &(stackframe->slots[40]);
  setframeelementname(stackframe, 40, "signaturePart");
  Object *var_callWithPart = &(stackframe->slots[41]);
  setframeelementname(stackframe, 41, "callWithPart");
  Object *var_commentNode = &(stackframe->slots[42]);
  setframeelementname(stackframe, 42, "commentNode");
  Object *var_ASTVisitor = &(stackframe->slots[43]);
  setframeelementname(stackframe, 43, "ASTVisitor");
  Object *var_patternMarkVisitor = &(stackframe->slots[44]);
  setframeelementname(stackframe, 44, "patternMarkVisitor");
// Begin line 17
  setline(17);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method listMap()ancestors
  struct UserObject *uo0 = (struct UserObject*)self;
  uo0->data[1] = emptyclosure;
  Method *meth_meth_ast_listMap_40__41_ancestors0 = addmethod2pos(self, "listMap()ancestors", &meth_ast_listMap_40__41_ancestors0, 1);
  int argcv_meth_ast_listMap_40__41_ancestors0[] = {2, 1};
  meth_meth_ast_listMap_40__41_ancestors0->type = alloc_MethodType(2, argcv_meth_ast_listMap_40__41_ancestors0);
  meth_meth_ast_listMap_40__41_ancestors0->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_ast_listMap_40__41_ancestors0->definitionModule = modulename;
  meth_meth_ast_listMap_40__41_ancestors0->definitionLine = 17;
// compiled method node returning  (depth = 1)
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method maybeMap()ancestors
  struct UserObject *uo14 = (struct UserObject*)self;
  uo14->data[2] = emptyclosure;
  Method *meth_meth_ast_maybeMap_40__41_ancestors14 = addmethod2pos(self, "maybeMap()ancestors", &meth_ast_maybeMap_40__41_ancestors14, 2);
  int argcv_meth_ast_maybeMap_40__41_ancestors14[] = {2, 1};
  meth_meth_ast_maybeMap_40__41_ancestors14->type = alloc_MethodType(2, argcv_meth_ast_maybeMap_40__41_ancestors14);
  meth_meth_ast_maybeMap_40__41_ancestors14->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_ast_maybeMap_40__41_ancestors14->definitionModule = modulename;
  meth_meth_ast_maybeMap_40__41_ancestors14->definitionLine = 22;
// compiled method node returning  (depth = 1)
// Begin line 29
  setline(29);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method maybeListMap()ancestors
  struct UserObject *uo22 = (struct UserObject*)self;
  uo22->data[3] = emptyclosure;
  Method *meth_meth_ast_maybeListMap_40__41_ancestors22 = addmethod2pos(self, "maybeListMap()ancestors", &meth_ast_maybeListMap_40__41_ancestors22, 3);
  int argcv_meth_ast_maybeListMap_40__41_ancestors22[] = {2, 1};
  meth_meth_ast_maybeListMap_40__41_ancestors22->type = alloc_MethodType(2, argcv_meth_ast_maybeListMap_40__41_ancestors22);
  meth_meth_ast_maybeListMap_40__41_ancestors22->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_ast_maybeListMap_40__41_ancestors22->definitionModule = modulename;
  meth_meth_ast_maybeListMap_40__41_ancestors22->definitionLine = 29;
// compiled method node returning  (depth = 1)
// Begin line 2662
  setline(2662);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method wrap()to()prefix
  struct UserObject *uo30 = (struct UserObject*)self;
  uo30->data[4] = emptyclosure;
  Method *meth_meth_ast_wrap_40__41_to_40__41_prefix30 = addmethod2pos(self, "wrap()to()prefix", &meth_ast_wrap_40__41_to_40__41_prefix30, 4);
  int argcv_meth_ast_wrap_40__41_to_40__41_prefix30[] = {1, 1, 1};
  meth_meth_ast_wrap_40__41_to_40__41_prefix30->type = alloc_MethodType(3, argcv_meth_ast_wrap_40__41_to_40__41_prefix30);
meth_meth_ast_wrap_40__41_to_40__41_prefix30->type->types[0] = type_String;
meth_meth_ast_wrap_40__41_to_40__41_prefix30->type->names[0] = "str";
meth_meth_ast_wrap_40__41_to_40__41_prefix30->type->types[1] = type_Number;
meth_meth_ast_wrap_40__41_to_40__41_prefix30->type->names[1] = "l";
meth_meth_ast_wrap_40__41_to_40__41_prefix30->type->types[2] = type_String;
meth_meth_ast_wrap_40__41_to_40__41_prefix30->type->names[2] = "margin";
  meth_meth_ast_wrap_40__41_to_40__41_prefix30->definitionModule = modulename;
  meth_meth_ast_wrap_40__41_to_40__41_prefix30->definitionLine = 2662;
// compiled method node returning  (depth = 1)
// Begin line 2730
  setline(2730);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method baseVisitor
  struct UserObject *uo198 = (struct UserObject*)self;
  uo198->data[5] = emptyclosure;
  Method *meth_meth_ast_baseVisitor198 = addmethod2pos(self, "baseVisitor", &meth_ast_baseVisitor198, 5);
  int argcv_meth_ast_baseVisitor198[] = {0};
  meth_meth_ast_baseVisitor198->type = alloc_MethodType(1, argcv_meth_ast_baseVisitor198);
  meth_meth_ast_baseVisitor198->definitionModule = modulename;
  meth_meth_ast_baseVisitor198->definitionLine = 2730;
  Method *meth_meth_ast_baseVisitor198_object = addmethod2pos(self, "baseVisitor()object", &meth_ast_baseVisitor198_object, 5);
  int argcv_meth_ast_baseVisitor198_object[] = {0};
  meth_meth_ast_baseVisitor198_object->type = alloc_MethodType(1, argcv_meth_ast_baseVisitor198_object);
  meth_meth_ast_baseVisitor198_object->definitionModule = modulename;
  meth_meth_ast_baseVisitor198_object->definitionLine = 2730;
// compiled method node returning  (depth = 1)
// Begin line 2798
  setline(2798);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method pluggableVisitor
  struct UserObject *uo359 = (struct UserObject*)self;
  uo359->data[6] = emptyclosure;
  Method *meth_meth_ast_pluggableVisitor359 = addmethod2pos(self, "pluggableVisitor", &meth_ast_pluggableVisitor359, 6);
  int argcv_meth_ast_pluggableVisitor359[] = {1};
  meth_meth_ast_pluggableVisitor359->type = alloc_MethodType(1, argcv_meth_ast_pluggableVisitor359);
  meth_meth_ast_pluggableVisitor359->definitionModule = modulename;
  meth_meth_ast_pluggableVisitor359->definitionLine = 2798;
  Method *meth_meth_ast_pluggableVisitor359_object = addmethod2pos(self, "pluggableVisitor()object", &meth_ast_pluggableVisitor359_object, 6);
  int argcv_meth_ast_pluggableVisitor359_object[] = {1};
  meth_meth_ast_pluggableVisitor359_object->type = alloc_MethodType(1, argcv_meth_ast_pluggableVisitor359_object);
  meth_meth_ast_pluggableVisitor359_object->definitionModule = modulename;
  meth_meth_ast_pluggableVisitor359_object->definitionLine = 2798;
// compiled method node returning  (depth = 1)
// Begin line 2848
  setline(2848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method findAnnotation
  struct UserObject *uo455 = (struct UserObject*)self;
  uo455->data[7] = emptyclosure;
  Method *meth_meth_ast_findAnnotation455 = addmethod2pos(self, "findAnnotation", &meth_ast_findAnnotation455, 7);
  int argcv_meth_ast_findAnnotation455[] = {2};
  meth_meth_ast_findAnnotation455->type = alloc_MethodType(1, argcv_meth_ast_findAnnotation455);
  meth_meth_ast_findAnnotation455->definitionModule = modulename;
  meth_meth_ast_findAnnotation455->definitionLine = 2848;
// compiled method node returning  (depth = 1)
// Begin line 2
  setline(2);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of util as util
  if (module_util == NULL)
    module_util = LOAD_MODULE(util);
  *var_util = module_util;
// compiled import node returning done (depth = 1)
// Begin line 14
  setline(14);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 15
  setline(15);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile num node (depth = 2)
  Object num485 = alloc_Float64(80);
// compiled num node returning num485 (depth = 2)
  *var_lineLength = num485;
  if (num485 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 2850
  setline(2850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method lineLength
  block_savedest(self);
  Object closure486 = createclosure(1, "lineLength");
  setclosureframe(closure486, stackframe);
  addtoclosure(closure486, var_lineLength);
  struct UserObject *uo486 = (struct UserObject*)self;
  uo486->data[8] = (Object)closure486;
  Method *meth_meth_ast_lineLength486 = addmethod2pos(self, "lineLength", &meth_ast_lineLength486, 8);
  int argcv_meth_ast_lineLength486[] = {0};
  meth_meth_ast_lineLength486->type = alloc_MethodType(1, argcv_meth_ast_lineLength486);
  meth_meth_ast_lineLength486->definitionModule = modulename;
  meth_meth_ast_lineLength486->definitionLine = 2850;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 36
  setline(36);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 37
  setline(37);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject487 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj487 = alloc_userobj2(5,6, objclass487);
  gc_frame_newslot(obj487);
// OBJECT OUTER DEC outer
  adddatum2(obj487, self, 0);
  addmethodreal(obj487,"outer", &reader_ast_outer_488);
  Object oldself487 = self;
  struct StackFrameObject *oldstackframe487 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe487);
  gc_frame_newslot((Object)stackframe);
  self = obj487;
  Object *oldselfslot487 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter487 = (*(struct UserObject *)self).data[0], lowerouter487 = thisouter487;
  if (inheritingObject487) {
    struct UserObject *inho487 = (struct UserObject *)inheritingObject487;
    while (inho487->super != GraceDefaultObject) inho487 = (struct UserObject *)inho487->super;
    inho487->super = obj487;
    self = inheritingObject487;
    *selfslot = self;
    lowerouter487 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter487;
  }
// method empty
  struct UserObject *uo489 = (struct UserObject*)obj487;
  uo489->data[1] = emptyclosure;
  Method *meth_meth_ast_empty489 = addmethod2pos(obj487, "empty", &meth_ast_empty489, 1);
  int argcv_meth_ast_empty489[] = {0};
  meth_meth_ast_empty489->type = alloc_MethodType(1, argcv_meth_ast_empty489);
  meth_meth_ast_empty489->definitionModule = modulename;
  meth_meth_ast_empty489->definitionLine = 38;
  Method *meth_meth_ast_empty489_object = addmethod2pos(obj487, "empty()object", &meth_ast_empty489_object, 1);
  int argcv_meth_ast_empty489_object[] = {0};
  meth_meth_ast_empty489_object->type = alloc_MethodType(1, argcv_meth_ast_empty489_object);
  meth_meth_ast_empty489_object->definitionModule = modulename;
  meth_meth_ast_empty489_object->definitionLine = 38;
// method with
  struct UserObject *uo502 = (struct UserObject*)obj487;
  uo502->data[2] = emptyclosure;
  Method *meth_meth_ast_with502 = addmethod2pos(obj487, "with", &meth_ast_with502, 2);
  int argcv_meth_ast_with502[] = {1};
  meth_meth_ast_with502->type = alloc_MethodType(1, argcv_meth_ast_with502);
  meth_meth_ast_with502->definitionModule = modulename;
  meth_meth_ast_with502->definitionLine = 43;
// method cons()onto
  struct UserObject *uo507 = (struct UserObject*)obj487;
  uo507->data[3] = emptyclosure;
  Method *meth_meth_ast_cons_40__41_onto507 = addmethod2pos(obj487, "cons()onto", &meth_ast_cons_40__41_onto507, 3);
  int argcv_meth_ast_cons_40__41_onto507[] = {1, 1};
  meth_meth_ast_cons_40__41_onto507->type = alloc_MethodType(2, argcv_meth_ast_cons_40__41_onto507);
  meth_meth_ast_cons_40__41_onto507->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_ast_cons_40__41_onto507->definitionModule = modulename;
  meth_meth_ast_cons_40__41_onto507->definitionLine = 44;
  Method *meth_meth_ast_cons_40__41_onto507_object = addmethod2pos(obj487, "cons()onto()object", &meth_ast_cons_40__41_onto507_object, 3);
  int argcv_meth_ast_cons_40__41_onto507_object[] = {1, 1};
  meth_meth_ast_cons_40__41_onto507_object->type = alloc_MethodType(2, argcv_meth_ast_cons_40__41_onto507_object);
  meth_meth_ast_cons_40__41_onto507_object->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_ast_cons_40__41_onto507_object->definitionModule = modulename;
  meth_meth_ast_cons_40__41_onto507_object->definitionLine = 44;
  sourceObject = obj487;
  sourceObject = obj487;
  sourceObject = obj487;
  objclass487 = obj487->class;
  objclass487->definitionModule = modulename;
  objclass487->definitionLine = 37;
  (*(struct UserObject *)self).data[0] = lowerouter487;
  self = oldself487;
  selfslot = oldselfslot487;
  stackframe = oldstackframe487;
// compiled object node returning obj487 (depth = 2)
  *var_ancestorChain = obj487;
  if (obj487 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// starting to compile method node (depth = 2)
// method ancestorChain
  block_savedest(self);
  Object closure556 = createclosure(1, "ancestorChain");
  setclosureframe(closure556, stackframe);
  addtoclosure(closure556, var_ancestorChain);
  struct UserObject *uo556 = (struct UserObject*)self;
  uo556->data[9] = (Object)closure556;
  Method *meth_meth_ast_ancestorChain556 = addmethod2pos(self, "ancestorChain", &meth_ast_ancestorChain556, 9);
  int argcv_meth_ast_ancestorChain556[] = {0};
  meth_meth_ast_ancestorChain556->type = alloc_MethodType(1, argcv_meth_ast_ancestorChain556);
  meth_meth_ast_ancestorChain556->definitionModule = modulename;
  meth_meth_ast_ancestorChain556->definitionLine = 59;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 62
  setline(62);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 63
  setline(63);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe557 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe558 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call559 = callmethodflags(prelude, "sequence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe558);
// compiled call node returning call559 (depth = 5)
// compiled member node returning call559 (depth = 4)
  partcv[0] = 0;
  Object call560 = callmethod(call559, "empty",
    1, partcv, params);
  gc_frame_end(callframe557);
// compiled call node returning call560 (depth = 3)
// compiled member node returning call560 (depth = 2)
  *var_emptySeq = call560;
  if (call560 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// starting to compile method node (depth = 2)
// method emptySeq
  block_savedest(self);
  Object closure561 = createclosure(1, "emptySeq");
  setclosureframe(closure561, stackframe);
  addtoclosure(closure561, var_emptySeq);
  struct UserObject *uo561 = (struct UserObject*)self;
  uo561->data[10] = (Object)closure561;
  Method *meth_meth_ast_emptySeq561 = addmethod2pos(self, "emptySeq", &meth_ast_emptySeq561, 10);
  int argcv_meth_ast_emptySeq561[] = {0};
  meth_meth_ast_emptySeq561->type = alloc_MethodType(1, argcv_meth_ast_emptySeq561);
  meth_meth_ast_emptySeq561->definitionModule = modulename;
  meth_meth_ast_emptySeq561->definitionLine = 63;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 64
  setline(64);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 65
  setline(65);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl AstNode
// starting to compile typeliteral node (depth = 2)
//   Type literal 
    Object type563 = alloc_Type("AstNode", 9);
    add_Method((ClassData)type563, "kind", NULL);
    add_Method((ClassData)type563, "register", NULL);
    add_Method((ClassData)type563, "line", NULL);
    add_Method((ClassData)type563, "line:=", NULL);
    add_Method((ClassData)type563, "linePos", NULL);
    add_Method((ClassData)type563, "linePos:=", NULL);
    add_Method((ClassData)type563, "scope", NULL);
    add_Method((ClassData)type563, "pretty", NULL);
    add_Method((ClassData)type563, "comments", NULL);
// compiled typeliteral node returning type563 (depth = 2)
  *var_AstNode = type563;
// Begin line 63
  setline(63);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method AstNode
  block_savedest(self);
  Object closure564 = createclosure(1, "AstNode");
  setclosureframe(closure564, stackframe);
  addtoclosure(closure564, var_AstNode);
  struct UserObject *uo564 = (struct UserObject*)self;
  uo564->data[11] = (Object)closure564;
  Method *meth_meth_ast_AstNode564 = addmethod2pos(self, "AstNode", &meth_ast_AstNode564, 11);
  int argcv_meth_ast_AstNode564[] = {0};
  meth_meth_ast_AstNode564->type = alloc_MethodType(1, argcv_meth_ast_AstNode564);
  meth_meth_ast_AstNode564->definitionModule = modulename;
  meth_meth_ast_AstNode564->definitionLine = 63;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 82
  setline(82);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 83
  setline(83);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl SymbolTable
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_Unknown (depth = 2)
  *var_SymbolTable = *var_Unknown;
// Begin line 63
  setline(63);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method SymbolTable
  block_savedest(self);
  Object closure566 = createclosure(1, "SymbolTable");
  setclosureframe(closure566, stackframe);
  addtoclosure(closure566, var_SymbolTable);
  struct UserObject *uo566 = (struct UserObject*)self;
  uo566->data[12] = (Object)closure566;
  Method *meth_meth_ast_SymbolTable566 = addmethod2pos(self, "SymbolTable", &meth_ast_SymbolTable566, 12);
  int argcv_meth_ast_SymbolTable566[] = {0};
  meth_meth_ast_SymbolTable566->type = alloc_MethodType(1, argcv_meth_ast_SymbolTable566);
  meth_meth_ast_SymbolTable566->definitionModule = modulename;
  meth_meth_ast_SymbolTable566->definitionLine = 63;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 84
  setline(84);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 85
  setline(85);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method baseNode
  block_savedest(self);
  Object closure567 = createclosure(1, "baseNode");
  setclosureframe(closure567, stackframe);
  addtoclosure(closure567, var_baseNode);
  struct UserObject *uo567 = (struct UserObject*)self;
  uo567->data[13] = (Object)closure567;
  Method *meth_meth_ast_baseNode567 = addmethod2pos(self, "baseNode", &meth_ast_baseNode567, 13);
  int argcv_meth_ast_baseNode567[] = {0};
  meth_meth_ast_baseNode567->type = alloc_MethodType(1, argcv_meth_ast_baseNode567);
  meth_meth_ast_baseNode567->definitionModule = modulename;
  meth_meth_ast_baseNode567->definitionLine = 85;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject568 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj568 = alloc_userobj2(2,4, objclass568);
  gc_frame_newslot(obj568);
// OBJECT OUTER DEC outer
  adddatum2(obj568, self, 0);
  addmethodreal(obj568,"outer", &reader_ast_outer_569);
  Object oldself568 = self;
  struct StackFrameObject *oldstackframe568 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe568);
  gc_frame_newslot((Object)stackframe);
  self = obj568;
  Object *oldselfslot568 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter568 = (*(struct UserObject *)self).data[0], lowerouter568 = thisouter568;
  if (inheritingObject568) {
    struct UserObject *inho568 = (struct UserObject *)inheritingObject568;
    while (inho568->super != GraceDefaultObject) inho568 = (struct UserObject *)inho568->super;
    inho568->super = obj568;
    self = inheritingObject568;
    *selfslot = self;
    lowerouter568 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter568;
  }
// method new
  block_savedest(obj568);
  Object closure570 = createclosure(4, "new");
  setclosureframe(closure570, stackframe);
  addtoclosure(closure570, var_unknownType);
  addtoclosure(closure570, var_ancestorChain);
  addtoclosure(closure570, var_util);
  addtoclosure(closure570, var_fakeSymbolTable);
  struct UserObject *uo570 = (struct UserObject*)obj568;
  uo570->data[1] = (Object)closure570;
  Method *meth_meth_ast_new570 = addmethod2pos(obj568, "new", &meth_ast_new570, 1);
  int argcv_meth_ast_new570[] = {0};
  meth_meth_ast_new570->type = alloc_MethodType(1, argcv_meth_ast_new570);
  meth_meth_ast_new570->definitionModule = modulename;
  meth_meth_ast_new570->definitionLine = 85;
  block_savedest(obj568);
  Object closure939 = createclosure(4, "new()object");
  setclosureframe(closure939, stackframe);
  addtoclosure(closure939, var_unknownType);
  addtoclosure(closure939, var_ancestorChain);
  addtoclosure(closure939, var_util);
  addtoclosure(closure939, var_fakeSymbolTable);
  Method *meth_meth_ast_new570_object = addmethod2pos(obj568, "new()object", &meth_ast_new570_object, 1);
  meth_meth_ast_new570_object->definitionModule = modulename;
  meth_meth_ast_new570_object->definitionLine = 85;
  sourceObject = obj568;
  objclass568 = obj568->class;
  objclass568->definitionModule = modulename;
  objclass568->definitionLine = 85;
  (*(struct UserObject *)self).data[0] = lowerouter568;
  self = oldself568;
  selfslot = oldselfslot568;
  stackframe = oldstackframe568;
// compiled object node returning obj568 (depth = 3)
  *var_baseNode = obj568;
  if (obj568 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 176
  setline(176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 177
  setline(177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject940 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj940 = alloc_userobj2(3,4, objclass940);
  gc_frame_newslot(obj940);
// OBJECT OUTER DEC outer
  adddatum2(obj940, self, 0);
  addmethodreal(obj940,"outer", &reader_ast_outer_941);
  Object oldself940 = self;
  struct StackFrameObject *oldstackframe940 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe940);
  gc_frame_newslot((Object)stackframe);
  self = obj940;
  Object *oldselfslot940 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter940 = (*(struct UserObject *)self).data[0], lowerouter940 = thisouter940;
  if (inheritingObject940) {
    struct UserObject *inho940 = (struct UserObject *)inheritingObject940;
    while (inho940->super != GraceDefaultObject) inho940 = (struct UserObject *)inho940->super;
    inho940->super = obj940;
    self = inheritingObject940;
    *selfslot = self;
    lowerouter940 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter940;
  }
if (objclass940 == NULL) {
  Method *reader942 = addmethodrealflags(obj940, "kind",&reader_ast_kind_942, MFLAG_DEF);
  reader942->definitionModule = modulename;
  reader942->definitionLine = 179;
}
adddatum2(obj940, alloc_Undefined(), 1);
// method toGrace
  struct UserObject *uo943 = (struct UserObject*)obj940;
  uo943->data[2] = emptyclosure;
  Method *meth_meth_ast_toGrace943 = addmethod2pos(obj940, "toGrace", &meth_ast_toGrace943, 2);
  int argcv_meth_ast_toGrace943[] = {1};
  meth_meth_ast_toGrace943->type = alloc_MethodType(1, argcv_meth_ast_toGrace943);
  meth_meth_ast_toGrace943->definitionModule = modulename;
  meth_meth_ast_toGrace943->definitionLine = 180;
  sourceObject = obj940;
// Begin line 178
  setline(178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe945 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_baseNode (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call946 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe945);
// compiled call node returning call946 (depth = 3)
  struct UserObject *obj940_uo = (struct UserObject *)obj940;
  obj940_uo->super = call946;
  sourceObject = obj940;
// Begin line 179
  setline(179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit947 == NULL) {
    strlit947 = alloc_String("null");
    gc_root(strlit947);
  }
// compiled string node returning strlit947 (depth = 3)
  adddatum2(obj940, strlit947, 1);
  sourceObject = obj940;
  objclass940 = obj940->class;
  objclass940->definitionModule = modulename;
  objclass940->definitionLine = 177;
  (*(struct UserObject *)self).data[0] = lowerouter940;
  self = oldself940;
  selfslot = oldselfslot940;
  stackframe = oldstackframe940;
// compiled object node returning obj940 (depth = 2)
  *var_nullNode = obj940;
  if (obj940 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 89
  setline(89);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method nullNode
  block_savedest(self);
  Object closure948 = createclosure(1, "nullNode");
  setclosureframe(closure948, stackframe);
  addtoclosure(closure948, var_nullNode);
  struct UserObject *uo948 = (struct UserObject*)self;
  uo948->data[14] = (Object)closure948;
  Method *meth_meth_ast_nullNode948 = addmethod2pos(self, "nullNode", &meth_ast_nullNode948, 14);
  int argcv_meth_ast_nullNode948[] = {0};
  meth_meth_ast_nullNode948->type = alloc_MethodType(1, argcv_meth_ast_nullNode948);
  meth_meth_ast_nullNode948->definitionModule = modulename;
  meth_meth_ast_nullNode948->definitionLine = 89;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 184
  setline(184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 185
  setline(185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject949 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj949 = alloc_userobj2(7,7, objclass949);
  gc_frame_newslot(obj949);
// OBJECT OUTER DEC outer
  adddatum2(obj949, self, 0);
  addmethodreal(obj949,"outer", &reader_ast_outer_950);
  Object oldself949 = self;
  struct StackFrameObject *oldstackframe949 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe949);
  gc_frame_newslot((Object)stackframe);
  self = obj949;
  Object *oldselfslot949 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter949 = (*(struct UserObject *)self).data[0], lowerouter949 = thisouter949;
  if (inheritingObject949) {
    struct UserObject *inho949 = (struct UserObject *)inheritingObject949;
    while (inho949->super != GraceDefaultObject) inho949 = (struct UserObject *)inho949->super;
    inho949->super = obj949;
    self = inheritingObject949;
    *selfslot = self;
    lowerouter949 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter949;
  }
if (objclass949 == NULL) {
  Method *reader951 = addmethodrealflags(obj949, "node",&reader_ast_node_951, 0);
  Method *writer951 = addmethodrealflags(obj949, "node:=",&writer_ast_node_951, 0);
  reader951->definitionModule = modulename;
  writer951->definitionModule = modulename;
  reader951->definitionLine = 186;
  writer951->definitionLine = 186;
}
obj949->flags |= OFLAG_MUTABLE;
adddatum2(obj949, alloc_Undefined(), 1);
// method asString
  struct UserObject *uo952 = (struct UserObject*)obj949;
  uo952->data[2] = emptyclosure;
  Method *meth_meth_ast_asString952 = addmethod2pos(obj949, "asString", &meth_ast_asString952, 2);
  int argcv_meth_ast_asString952[] = {0};
  meth_meth_ast_asString952->type = alloc_MethodType(1, argcv_meth_ast_asString952);
  meth_meth_ast_asString952->definitionModule = modulename;
  meth_meth_ast_asString952->definitionLine = 187;
// method addNode()as
  struct UserObject *uo954 = (struct UserObject*)obj949;
  uo954->data[3] = emptyclosure;
  Method *meth_meth_ast_addNode_40__41_as954 = addmethod2pos(obj949, "addNode()as", &meth_ast_addNode_40__41_as954, 3);
  int argcv_meth_ast_addNode_40__41_as954[] = {1, 1};
  meth_meth_ast_addNode_40__41_as954->type = alloc_MethodType(2, argcv_meth_ast_addNode_40__41_as954);
  meth_meth_ast_addNode_40__41_as954->definitionModule = modulename;
  meth_meth_ast_addNode_40__41_as954->definitionLine = 188;
// method thatDefines()ifNone
  struct UserObject *uo983 = (struct UserObject*)obj949;
  uo983->data[4] = emptyclosure;
  Method *meth_meth_ast_thatDefines_40__41_ifNone983 = addmethod2pos(obj949, "thatDefines()ifNone", &meth_ast_thatDefines_40__41_ifNone983, 4);
  int argcv_meth_ast_thatDefines_40__41_ifNone983[] = {1, 1};
  meth_meth_ast_thatDefines_40__41_ifNone983->type = alloc_MethodType(2, argcv_meth_ast_thatDefines_40__41_ifNone983);
  meth_meth_ast_thatDefines_40__41_ifNone983->definitionModule = modulename;
  meth_meth_ast_thatDefines_40__41_ifNone983->definitionLine = 191;
// method enclosingObjectScope
  struct UserObject *uo996 = (struct UserObject*)obj949;
  uo996->data[5] = emptyclosure;
  Method *meth_meth_ast_enclosingObjectScope996 = addmethod2pos(obj949, "enclosingObjectScope", &meth_ast_enclosingObjectScope996, 5);
  int argcv_meth_ast_enclosingObjectScope996[] = {0};
  meth_meth_ast_enclosingObjectScope996->type = alloc_MethodType(1, argcv_meth_ast_enclosingObjectScope996);
  meth_meth_ast_enclosingObjectScope996->definitionModule = modulename;
  meth_meth_ast_enclosingObjectScope996->definitionLine = 194;
// method variety
  struct UserObject *uo1011 = (struct UserObject*)obj949;
  uo1011->data[6] = emptyclosure;
  Method *meth_meth_ast_variety1011 = addmethod2pos(obj949, "variety", &meth_ast_variety1011, 6);
  int argcv_meth_ast_variety1011[] = {0};
  meth_meth_ast_variety1011->type = alloc_MethodType(1, argcv_meth_ast_variety1011);
  meth_meth_ast_variety1011->definitionModule = modulename;
  meth_meth_ast_variety1011->definitionLine = 197;
  sourceObject = obj949;
// Begin line 186
  setline(186);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_nullNode (depth = 3)
  adddatum2(obj949, *var_nullNode, 1);
  sourceObject = obj949;
  sourceObject = obj949;
  sourceObject = obj949;
  sourceObject = obj949;
  sourceObject = obj949;
  objclass949 = obj949->class;
  objclass949->definitionModule = modulename;
  objclass949->definitionLine = 185;
  (*(struct UserObject *)self).data[0] = lowerouter949;
  self = oldself949;
  selfslot = oldselfslot949;
  stackframe = oldstackframe949;
// compiled object node returning obj949 (depth = 2)
  *var_fakeSymbolTable = obj949;
  if (obj949 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 195
  setline(195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method fakeSymbolTable
  block_savedest(self);
  Object closure1013 = createclosure(1, "fakeSymbolTable");
  setclosureframe(closure1013, stackframe);
  addtoclosure(closure1013, var_fakeSymbolTable);
  struct UserObject *uo1013 = (struct UserObject*)self;
  uo1013->data[15] = (Object)closure1013;
  Method *meth_meth_ast_fakeSymbolTable1013 = addmethod2pos(self, "fakeSymbolTable", &meth_ast_fakeSymbolTable1013, 15);
  int argcv_meth_ast_fakeSymbolTable1013[] = {0};
  meth_meth_ast_fakeSymbolTable1013->type = alloc_MethodType(1, argcv_meth_ast_fakeSymbolTable1013);
  meth_meth_ast_fakeSymbolTable1013->definitionModule = modulename;
  meth_meth_ast_fakeSymbolTable1013->definitionLine = 195;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 199
  setline(199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 200
  setline(200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method ifNode
  block_savedest(self);
  Object closure1014 = createclosure(1, "ifNode");
  setclosureframe(closure1014, stackframe);
  addtoclosure(closure1014, var_ifNode);
  struct UserObject *uo1014 = (struct UserObject*)self;
  uo1014->data[16] = (Object)closure1014;
  Method *meth_meth_ast_ifNode1014 = addmethod2pos(self, "ifNode", &meth_ast_ifNode1014, 16);
  int argcv_meth_ast_ifNode1014[] = {0};
  meth_meth_ast_ifNode1014->type = alloc_MethodType(1, argcv_meth_ast_ifNode1014);
  meth_meth_ast_ifNode1014->definitionModule = modulename;
  meth_meth_ast_ifNode1014->definitionLine = 200;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject1015 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1015 = alloc_userobj2(2,4, objclass1015);
  gc_frame_newslot(obj1015);
// OBJECT OUTER DEC outer
  adddatum2(obj1015, self, 0);
  addmethodreal(obj1015,"outer", &reader_ast_outer_1016);
  Object oldself1015 = self;
  struct StackFrameObject *oldstackframe1015 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1015);
  gc_frame_newslot((Object)stackframe);
  self = obj1015;
  Object *oldselfslot1015 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1015 = (*(struct UserObject *)self).data[0], lowerouter1015 = thisouter1015;
  if (inheritingObject1015) {
    struct UserObject *inho1015 = (struct UserObject *)inheritingObject1015;
    while (inho1015->super != GraceDefaultObject) inho1015 = (struct UserObject *)inho1015->super;
    inho1015->super = obj1015;
    self = inheritingObject1015;
    *selfslot = self;
    lowerouter1015 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1015;
  }
// method new
  block_savedest(obj1015);
  Object closure1017 = createclosure(4, "new");
  setclosureframe(closure1017, stackframe);
  addtoclosure(closure1017, var_util);
  addtoclosure(closure1017, var_nullNode);
  addtoclosure(closure1017, var_ifNode);
  addtoclosure(closure1017, var_baseNode);
  struct UserObject *uo1017 = (struct UserObject*)obj1015;
  uo1017->data[1] = (Object)closure1017;
  Method *meth_meth_ast_new1017 = addmethod2pos(obj1015, "new", &meth_ast_new1017, 1);
  int argcv_meth_ast_new1017[] = {3};
  meth_meth_ast_new1017->type = alloc_MethodType(1, argcv_meth_ast_new1017);
  meth_meth_ast_new1017->definitionModule = modulename;
  meth_meth_ast_new1017->definitionLine = 200;
  block_savedest(obj1015);
  Object closure1368 = createclosure(4, "new()object");
  setclosureframe(closure1368, stackframe);
  addtoclosure(closure1368, var_util);
  addtoclosure(closure1368, var_nullNode);
  addtoclosure(closure1368, var_ifNode);
  addtoclosure(closure1368, var_baseNode);
  Method *meth_meth_ast_new1017_object = addmethod2pos(obj1015, "new()object", &meth_ast_new1017_object, 1);
  meth_meth_ast_new1017_object->definitionModule = modulename;
  meth_meth_ast_new1017_object->definitionLine = 200;
  sourceObject = obj1015;
  objclass1015 = obj1015->class;
  objclass1015->definitionModule = modulename;
  objclass1015->definitionLine = 200;
  (*(struct UserObject *)self).data[0] = lowerouter1015;
  self = oldself1015;
  selfslot = oldselfslot1015;
  stackframe = oldstackframe1015;
// compiled object node returning obj1015 (depth = 3)
  *var_ifNode = obj1015;
  if (obj1015 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 275
  setline(275);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method blockNode
  block_savedest(self);
  Object closure1369 = createclosure(1, "blockNode");
  setclosureframe(closure1369, stackframe);
  addtoclosure(closure1369, var_blockNode);
  struct UserObject *uo1369 = (struct UserObject*)self;
  uo1369->data[17] = (Object)closure1369;
  Method *meth_meth_ast_blockNode1369 = addmethod2pos(self, "blockNode", &meth_ast_blockNode1369, 17);
  int argcv_meth_ast_blockNode1369[] = {0};
  meth_meth_ast_blockNode1369->type = alloc_MethodType(1, argcv_meth_ast_blockNode1369);
  meth_meth_ast_blockNode1369->definitionModule = modulename;
  meth_meth_ast_blockNode1369->definitionLine = 275;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject1370 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1370 = alloc_userobj2(2,4, objclass1370);
  gc_frame_newslot(obj1370);
// OBJECT OUTER DEC outer
  adddatum2(obj1370, self, 0);
  addmethodreal(obj1370,"outer", &reader_ast_outer_1371);
  Object oldself1370 = self;
  struct StackFrameObject *oldstackframe1370 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1370);
  gc_frame_newslot((Object)stackframe);
  self = obj1370;
  Object *oldselfslot1370 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1370 = (*(struct UserObject *)self).data[0], lowerouter1370 = thisouter1370;
  if (inheritingObject1370) {
    struct UserObject *inho1370 = (struct UserObject *)inheritingObject1370;
    while (inho1370->super != GraceDefaultObject) inho1370 = (struct UserObject *)inho1370->super;
    inho1370->super = obj1370;
    self = inheritingObject1370;
    *selfslot = self;
    lowerouter1370 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1370;
  }
// method new
  block_savedest(obj1370);
  Object closure1372 = createclosure(4, "new");
  setclosureframe(closure1372, stackframe);
  addtoclosure(closure1372, var_blockNode);
  addtoclosure(closure1372, var_baseNode);
  addtoclosure(closure1372, var_patternMarkVisitor);
  addtoclosure(closure1372, var_ancestorChain);
  struct UserObject *uo1372 = (struct UserObject*)obj1370;
  uo1372->data[1] = (Object)closure1372;
  Method *meth_meth_ast_new1372 = addmethod2pos(obj1370, "new", &meth_ast_new1372, 1);
  int argcv_meth_ast_new1372[] = {2};
  meth_meth_ast_new1372->type = alloc_MethodType(1, argcv_meth_ast_new1372);
  meth_meth_ast_new1372->definitionModule = modulename;
  meth_meth_ast_new1372->definitionLine = 275;
  block_savedest(obj1370);
  Object closure1820 = createclosure(4, "new()object");
  setclosureframe(closure1820, stackframe);
  addtoclosure(closure1820, var_blockNode);
  addtoclosure(closure1820, var_baseNode);
  addtoclosure(closure1820, var_patternMarkVisitor);
  addtoclosure(closure1820, var_ancestorChain);
  Method *meth_meth_ast_new1372_object = addmethod2pos(obj1370, "new()object", &meth_ast_new1372_object, 1);
  meth_meth_ast_new1372_object->definitionModule = modulename;
  meth_meth_ast_new1372_object->definitionLine = 275;
  sourceObject = obj1370;
  objclass1370 = obj1370->class;
  objclass1370->definitionModule = modulename;
  objclass1370->definitionLine = 275;
  (*(struct UserObject *)self).data[0] = lowerouter1370;
  self = oldself1370;
  selfslot = oldselfslot1370;
  stackframe = oldstackframe1370;
// compiled object node returning obj1370 (depth = 3)
  *var_blockNode = obj1370;
  if (obj1370 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 391
  setline(391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method catchCaseNode
  block_savedest(self);
  Object closure1821 = createclosure(1, "catchCaseNode");
  setclosureframe(closure1821, stackframe);
  addtoclosure(closure1821, var_catchCaseNode);
  struct UserObject *uo1821 = (struct UserObject*)self;
  uo1821->data[18] = (Object)closure1821;
  Method *meth_meth_ast_catchCaseNode1821 = addmethod2pos(self, "catchCaseNode", &meth_ast_catchCaseNode1821, 18);
  int argcv_meth_ast_catchCaseNode1821[] = {0};
  meth_meth_ast_catchCaseNode1821->type = alloc_MethodType(1, argcv_meth_ast_catchCaseNode1821);
  meth_meth_ast_catchCaseNode1821->definitionModule = modulename;
  meth_meth_ast_catchCaseNode1821->definitionLine = 391;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject1822 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1822 = alloc_userobj2(2,4, objclass1822);
  gc_frame_newslot(obj1822);
// OBJECT OUTER DEC outer
  adddatum2(obj1822, self, 0);
  addmethodreal(obj1822,"outer", &reader_ast_outer_1823);
  Object oldself1822 = self;
  struct StackFrameObject *oldstackframe1822 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1822);
  gc_frame_newslot((Object)stackframe);
  self = obj1822;
  Object *oldselfslot1822 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1822 = (*(struct UserObject *)self).data[0], lowerouter1822 = thisouter1822;
  if (inheritingObject1822) {
    struct UserObject *inho1822 = (struct UserObject *)inheritingObject1822;
    while (inho1822->super != GraceDefaultObject) inho1822 = (struct UserObject *)inho1822->super;
    inho1822->super = obj1822;
    self = inheritingObject1822;
    *selfslot = self;
    lowerouter1822 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1822;
  }
// method new
  block_savedest(obj1822);
  Object closure1824 = createclosure(4, "new");
  setclosureframe(closure1824, stackframe);
  addtoclosure(closure1824, var_nullNode);
  addtoclosure(closure1824, var_emptySeq);
  addtoclosure(closure1824, var_catchCaseNode);
  addtoclosure(closure1824, var_baseNode);
  struct UserObject *uo1824 = (struct UserObject*)obj1822;
  uo1824->data[1] = (Object)closure1824;
  Method *meth_meth_ast_new1824 = addmethod2pos(obj1822, "new", &meth_ast_new1824, 1);
  int argcv_meth_ast_new1824[] = {3};
  meth_meth_ast_new1824->type = alloc_MethodType(1, argcv_meth_ast_new1824);
  meth_meth_ast_new1824->definitionModule = modulename;
  meth_meth_ast_new1824->definitionLine = 391;
  block_savedest(obj1822);
  Object closure2125 = createclosure(4, "new()object");
  setclosureframe(closure2125, stackframe);
  addtoclosure(closure2125, var_nullNode);
  addtoclosure(closure2125, var_emptySeq);
  addtoclosure(closure2125, var_catchCaseNode);
  addtoclosure(closure2125, var_baseNode);
  Method *meth_meth_ast_new1824_object = addmethod2pos(obj1822, "new()object", &meth_ast_new1824_object, 1);
  meth_meth_ast_new1824_object->definitionModule = modulename;
  meth_meth_ast_new1824_object->definitionLine = 391;
  sourceObject = obj1822;
  objclass1822 = obj1822->class;
  objclass1822->definitionModule = modulename;
  objclass1822->definitionLine = 391;
  (*(struct UserObject *)self).data[0] = lowerouter1822;
  self = oldself1822;
  selfslot = oldselfslot1822;
  stackframe = oldstackframe1822;
// compiled object node returning obj1822 (depth = 3)
  *var_catchCaseNode = obj1822;
  if (obj1822 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 398
  setline(398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 452
  setline(452);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method matchCaseNode
  block_savedest(self);
  Object closure2126 = createclosure(1, "matchCaseNode");
  setclosureframe(closure2126, stackframe);
  addtoclosure(closure2126, var_matchCaseNode);
  struct UserObject *uo2126 = (struct UserObject*)self;
  uo2126->data[19] = (Object)closure2126;
  Method *meth_meth_ast_matchCaseNode2126 = addmethod2pos(self, "matchCaseNode", &meth_ast_matchCaseNode2126, 19);
  int argcv_meth_ast_matchCaseNode2126[] = {0};
  meth_meth_ast_matchCaseNode2126->type = alloc_MethodType(1, argcv_meth_ast_matchCaseNode2126);
  meth_meth_ast_matchCaseNode2126->definitionModule = modulename;
  meth_meth_ast_matchCaseNode2126->definitionLine = 452;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject2127 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2127 = alloc_userobj2(2,4, objclass2127);
  gc_frame_newslot(obj2127);
// OBJECT OUTER DEC outer
  adddatum2(obj2127, self, 0);
  addmethodreal(obj2127,"outer", &reader_ast_outer_2128);
  Object oldself2127 = self;
  struct StackFrameObject *oldstackframe2127 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2127);
  gc_frame_newslot((Object)stackframe);
  self = obj2127;
  Object *oldselfslot2127 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2127 = (*(struct UserObject *)self).data[0], lowerouter2127 = thisouter2127;
  if (inheritingObject2127) {
    struct UserObject *inho2127 = (struct UserObject *)inheritingObject2127;
    while (inho2127->super != GraceDefaultObject) inho2127 = (struct UserObject *)inho2127->super;
    inho2127->super = obj2127;
    self = inheritingObject2127;
    *selfslot = self;
    lowerouter2127 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2127;
  }
// method new
  block_savedest(obj2127);
  Object closure2129 = createclosure(4, "new");
  setclosureframe(closure2129, stackframe);
  addtoclosure(closure2129, var_nullNode);
  addtoclosure(closure2129, var_emptySeq);
  addtoclosure(closure2129, var_matchCaseNode);
  addtoclosure(closure2129, var_baseNode);
  struct UserObject *uo2129 = (struct UserObject*)obj2127;
  uo2129->data[1] = (Object)closure2129;
  Method *meth_meth_ast_new2129 = addmethod2pos(obj2127, "new", &meth_ast_new2129, 1);
  int argcv_meth_ast_new2129[] = {3};
  meth_meth_ast_new2129->type = alloc_MethodType(1, argcv_meth_ast_new2129);
  meth_meth_ast_new2129->definitionModule = modulename;
  meth_meth_ast_new2129->definitionLine = 452;
  block_savedest(obj2127);
  Object closure2429 = createclosure(4, "new()object");
  setclosureframe(closure2429, stackframe);
  addtoclosure(closure2429, var_nullNode);
  addtoclosure(closure2429, var_emptySeq);
  addtoclosure(closure2429, var_matchCaseNode);
  addtoclosure(closure2429, var_baseNode);
  Method *meth_meth_ast_new2129_object = addmethod2pos(obj2127, "new()object", &meth_ast_new2129_object, 1);
  meth_meth_ast_new2129_object->definitionModule = modulename;
  meth_meth_ast_new2129_object->definitionLine = 452;
  sourceObject = obj2127;
  objclass2127 = obj2127->class;
  objclass2127->definitionModule = modulename;
  objclass2127->definitionLine = 452;
  (*(struct UserObject *)self).data[0] = lowerouter2127;
  self = oldself2127;
  selfslot = oldselfslot2127;
  stackframe = oldstackframe2127;
// compiled object node returning obj2127 (depth = 3)
  *var_matchCaseNode = obj2127;
  if (obj2127 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 513
  setline(513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method methodTypeNode
  block_savedest(self);
  Object closure2430 = createclosure(1, "methodTypeNode");
  setclosureframe(closure2430, stackframe);
  addtoclosure(closure2430, var_methodTypeNode);
  struct UserObject *uo2430 = (struct UserObject*)self;
  uo2430->data[20] = (Object)closure2430;
  Method *meth_meth_ast_methodTypeNode2430 = addmethod2pos(self, "methodTypeNode", &meth_ast_methodTypeNode2430, 20);
  int argcv_meth_ast_methodTypeNode2430[] = {0};
  meth_meth_ast_methodTypeNode2430->type = alloc_MethodType(1, argcv_meth_ast_methodTypeNode2430);
  meth_meth_ast_methodTypeNode2430->definitionModule = modulename;
  meth_meth_ast_methodTypeNode2430->definitionLine = 513;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject2431 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2431 = alloc_userobj2(2,4, objclass2431);
  gc_frame_newslot(obj2431);
// OBJECT OUTER DEC outer
  adddatum2(obj2431, self, 0);
  addmethodreal(obj2431,"outer", &reader_ast_outer_2432);
  Object oldself2431 = self;
  struct StackFrameObject *oldstackframe2431 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2431);
  gc_frame_newslot((Object)stackframe);
  self = obj2431;
  Object *oldselfslot2431 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2431 = (*(struct UserObject *)self).data[0], lowerouter2431 = thisouter2431;
  if (inheritingObject2431) {
    struct UserObject *inho2431 = (struct UserObject *)inheritingObject2431;
    while (inho2431->super != GraceDefaultObject) inho2431 = (struct UserObject *)inho2431->super;
    inho2431->super = obj2431;
    self = inheritingObject2431;
    *selfslot = self;
    lowerouter2431 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2431;
  }
// method new
  block_savedest(obj2431);
  Object closure2433 = createclosure(3, "new");
  setclosureframe(closure2433, stackframe);
  addtoclosure(closure2433, var_emptySeq);
  addtoclosure(closure2433, var_methodTypeNode);
  addtoclosure(closure2433, var_baseNode);
  struct UserObject *uo2433 = (struct UserObject*)obj2431;
  uo2433->data[1] = (Object)closure2433;
  Method *meth_meth_ast_new2433 = addmethod2pos(obj2431, "new", &meth_ast_new2433, 1);
  int argcv_meth_ast_new2433[] = {3};
  meth_meth_ast_new2433->type = alloc_MethodType(1, argcv_meth_ast_new2433);
  meth_meth_ast_new2433->definitionModule = modulename;
  meth_meth_ast_new2433->definitionLine = 513;
  block_savedest(obj2431);
  Object closure2862 = createclosure(3, "new()object");
  setclosureframe(closure2862, stackframe);
  addtoclosure(closure2862, var_emptySeq);
  addtoclosure(closure2862, var_methodTypeNode);
  addtoclosure(closure2862, var_baseNode);
  Method *meth_meth_ast_new2433_object = addmethod2pos(obj2431, "new()object", &meth_ast_new2433_object, 1);
  meth_meth_ast_new2433_object->definitionModule = modulename;
  meth_meth_ast_new2433_object->definitionLine = 513;
  sourceObject = obj2431;
  objclass2431 = obj2431->class;
  objclass2431->definitionModule = modulename;
  objclass2431->definitionLine = 513;
  (*(struct UserObject *)self).data[0] = lowerouter2431;
  self = oldself2431;
  selfslot = oldselfslot2431;
  stackframe = oldstackframe2431;
// compiled object node returning obj2431 (depth = 3)
  *var_methodTypeNode = obj2431;
  if (obj2431 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 537
  setline(537);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 620
  setline(620);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method typeLiteralNode
  block_savedest(self);
  Object closure2863 = createclosure(1, "typeLiteralNode");
  setclosureframe(closure2863, stackframe);
  addtoclosure(closure2863, var_typeLiteralNode);
  struct UserObject *uo2863 = (struct UserObject*)self;
  uo2863->data[21] = (Object)closure2863;
  Method *meth_meth_ast_typeLiteralNode2863 = addmethod2pos(self, "typeLiteralNode", &meth_ast_typeLiteralNode2863, 21);
  int argcv_meth_ast_typeLiteralNode2863[] = {0};
  meth_meth_ast_typeLiteralNode2863->type = alloc_MethodType(1, argcv_meth_ast_typeLiteralNode2863);
  meth_meth_ast_typeLiteralNode2863->definitionModule = modulename;
  meth_meth_ast_typeLiteralNode2863->definitionLine = 620;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject2864 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2864 = alloc_userobj2(2,4, objclass2864);
  gc_frame_newslot(obj2864);
// OBJECT OUTER DEC outer
  adddatum2(obj2864, self, 0);
  addmethodreal(obj2864,"outer", &reader_ast_outer_2865);
  Object oldself2864 = self;
  struct StackFrameObject *oldstackframe2864 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2864);
  gc_frame_newslot((Object)stackframe);
  self = obj2864;
  Object *oldselfslot2864 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2864 = (*(struct UserObject *)self).data[0], lowerouter2864 = thisouter2864;
  if (inheritingObject2864) {
    struct UserObject *inho2864 = (struct UserObject *)inheritingObject2864;
    while (inho2864->super != GraceDefaultObject) inho2864 = (struct UserObject *)inho2864->super;
    inho2864->super = obj2864;
    self = inheritingObject2864;
    *selfslot = self;
    lowerouter2864 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2864;
  }
// method new
  block_savedest(obj2864);
  Object closure2866 = createclosure(3, "new");
  setclosureframe(closure2866, stackframe);
  addtoclosure(closure2866, var_emptySeq);
  addtoclosure(closure2866, var_typeLiteralNode);
  addtoclosure(closure2866, var_baseNode);
  struct UserObject *uo2866 = (struct UserObject*)obj2864;
  uo2866->data[1] = (Object)closure2866;
  Method *meth_meth_ast_new2866 = addmethod2pos(obj2864, "new", &meth_ast_new2866, 1);
  int argcv_meth_ast_new2866[] = {2};
  meth_meth_ast_new2866->type = alloc_MethodType(1, argcv_meth_ast_new2866);
  meth_meth_ast_new2866->definitionModule = modulename;
  meth_meth_ast_new2866->definitionLine = 620;
  block_savedest(obj2864);
  Object closure3166 = createclosure(3, "new()object");
  setclosureframe(closure3166, stackframe);
  addtoclosure(closure3166, var_emptySeq);
  addtoclosure(closure3166, var_typeLiteralNode);
  addtoclosure(closure3166, var_baseNode);
  Method *meth_meth_ast_new2866_object = addmethod2pos(obj2864, "new()object", &meth_ast_new2866_object, 1);
  meth_meth_ast_new2866_object->definitionModule = modulename;
  meth_meth_ast_new2866_object->definitionLine = 620;
  sourceObject = obj2864;
  objclass2864 = obj2864->class;
  objclass2864->definitionModule = modulename;
  objclass2864->definitionLine = 620;
  (*(struct UserObject *)self).data[0] = lowerouter2864;
  self = oldself2864;
  selfslot = oldselfslot2864;
  stackframe = oldstackframe2864;
// compiled object node returning obj2864 (depth = 3)
  *var_typeLiteralNode = obj2864;
  if (obj2864 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 698
  setline(698);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 699
  setline(699);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method typeDecNode
  block_savedest(self);
  Object closure3167 = createclosure(1, "typeDecNode");
  setclosureframe(closure3167, stackframe);
  addtoclosure(closure3167, var_typeDecNode);
  struct UserObject *uo3167 = (struct UserObject*)self;
  uo3167->data[22] = (Object)closure3167;
  Method *meth_meth_ast_typeDecNode3167 = addmethod2pos(self, "typeDecNode", &meth_ast_typeDecNode3167, 22);
  int argcv_meth_ast_typeDecNode3167[] = {0};
  meth_meth_ast_typeDecNode3167->type = alloc_MethodType(1, argcv_meth_ast_typeDecNode3167);
  meth_meth_ast_typeDecNode3167->definitionModule = modulename;
  meth_meth_ast_typeDecNode3167->definitionLine = 699;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject3168 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3168 = alloc_userobj2(2,4, objclass3168);
  gc_frame_newslot(obj3168);
// OBJECT OUTER DEC outer
  adddatum2(obj3168, self, 0);
  addmethodreal(obj3168,"outer", &reader_ast_outer_3169);
  Object oldself3168 = self;
  struct StackFrameObject *oldstackframe3168 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3168);
  gc_frame_newslot((Object)stackframe);
  self = obj3168;
  Object *oldselfslot3168 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3168 = (*(struct UserObject *)self).data[0], lowerouter3168 = thisouter3168;
  if (inheritingObject3168) {
    struct UserObject *inho3168 = (struct UserObject *)inheritingObject3168;
    while (inho3168->super != GraceDefaultObject) inho3168 = (struct UserObject *)inho3168->super;
    inho3168->super = obj3168;
    self = inheritingObject3168;
    *selfslot = self;
    lowerouter3168 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3168;
  }
// method new
  block_savedest(obj3168);
  Object closure3170 = createclosure(3, "new");
  setclosureframe(closure3170, stackframe);
  addtoclosure(closure3170, var_nullNode);
  addtoclosure(closure3170, var_typeDecNode);
  addtoclosure(closure3170, var_baseNode);
  struct UserObject *uo3170 = (struct UserObject*)obj3168;
  uo3170->data[1] = (Object)closure3170;
  Method *meth_meth_ast_new3170 = addmethod2pos(obj3168, "new", &meth_ast_new3170, 1);
  int argcv_meth_ast_new3170[] = {2};
  meth_meth_ast_new3170->type = alloc_MethodType(1, argcv_meth_ast_new3170);
  meth_meth_ast_new3170->definitionModule = modulename;
  meth_meth_ast_new3170->definitionLine = 699;
  block_savedest(obj3168);
  Object closure3488 = createclosure(3, "new()object");
  setclosureframe(closure3488, stackframe);
  addtoclosure(closure3488, var_nullNode);
  addtoclosure(closure3488, var_typeDecNode);
  addtoclosure(closure3488, var_baseNode);
  Method *meth_meth_ast_new3170_object = addmethod2pos(obj3168, "new()object", &meth_ast_new3170_object, 1);
  meth_meth_ast_new3170_object->definitionModule = modulename;
  meth_meth_ast_new3170_object->definitionLine = 699;
  sourceObject = obj3168;
  objclass3168 = obj3168->class;
  objclass3168->definitionModule = modulename;
  objclass3168->definitionLine = 699;
  (*(struct UserObject *)self).data[0] = lowerouter3168;
  self = oldself3168;
  selfslot = oldselfslot3168;
  stackframe = oldstackframe3168;
// compiled object node returning obj3168 (depth = 3)
  *var_typeDecNode = obj3168;
  if (obj3168 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 779
  setline(779);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 780
  setline(780);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject3489 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3489 = alloc_userobj2(3,4, objclass3489);
  gc_frame_newslot(obj3489);
// OBJECT OUTER DEC outer
  adddatum2(obj3489, self, 0);
  addmethodreal(obj3489,"outer", &reader_ast_outer_3490);
  Object oldself3489 = self;
  struct StackFrameObject *oldstackframe3489 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3489);
  gc_frame_newslot((Object)stackframe);
  self = obj3489;
  Object *oldselfslot3489 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3489 = (*(struct UserObject *)self).data[0], lowerouter3489 = thisouter3489;
  if (inheritingObject3489) {
    struct UserObject *inho3489 = (struct UserObject *)inheritingObject3489;
    while (inho3489->super != GraceDefaultObject) inho3489 = (struct UserObject *)inho3489->super;
    inho3489->super = obj3489;
    self = inheritingObject3489;
    *selfslot = self;
    lowerouter3489 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3489;
  }
// method new()scope
  struct UserObject *uo3491 = (struct UserObject*)obj3489;
  uo3491->data[1] = emptyclosure;
  Method *meth_meth_ast_new_40__41_scope3491 = addmethod2pos(obj3489, "new()scope", &meth_ast_new_40__41_scope3491, 1);
  int argcv_meth_ast_new_40__41_scope3491[] = {4, 1};
  meth_meth_ast_new_40__41_scope3491->type = alloc_MethodType(2, argcv_meth_ast_new_40__41_scope3491);
  meth_meth_ast_new_40__41_scope3491->definitionModule = modulename;
  meth_meth_ast_new_40__41_scope3491->definitionLine = 781;
// method new
  block_savedest(obj3489);
  Object closure3496 = createclosure(2, "new");
  setclosureframe(closure3496, stackframe);
  addtoclosure(closure3496, var_methodNode);
  addtoclosure(closure3496, var_baseNode);
  struct UserObject *uo3496 = (struct UserObject*)obj3489;
  uo3496->data[2] = (Object)closure3496;
  Method *meth_meth_ast_new3496 = addmethod2pos(obj3489, "new", &meth_ast_new3496, 2);
  int argcv_meth_ast_new3496[] = {4};
  meth_meth_ast_new3496->type = alloc_MethodType(1, argcv_meth_ast_new3496);
  meth_meth_ast_new3496->definitionModule = modulename;
  meth_meth_ast_new3496->definitionLine = 787;
  block_savedest(obj3489);
  Object closure4489 = createclosure(2, "new()object");
  setclosureframe(closure4489, stackframe);
  addtoclosure(closure4489, var_methodNode);
  addtoclosure(closure4489, var_baseNode);
  Method *meth_meth_ast_new3496_object = addmethod2pos(obj3489, "new()object", &meth_ast_new3496_object, 2);
  meth_meth_ast_new3496_object->definitionModule = modulename;
  meth_meth_ast_new3496_object->definitionLine = 787;
  sourceObject = obj3489;
  sourceObject = obj3489;
  objclass3489 = obj3489->class;
  objclass3489->definitionModule = modulename;
  objclass3489->definitionLine = 780;
  (*(struct UserObject *)self).data[0] = lowerouter3489;
  self = oldself3489;
  selfslot = oldselfslot3489;
  stackframe = oldstackframe3489;
// compiled object node returning obj3489 (depth = 2)
  *var_methodNode = obj3489;
  if (obj3489 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 804
  setline(804);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method methodNode
  block_savedest(self);
  Object closure4490 = createclosure(1, "methodNode");
  setclosureframe(closure4490, stackframe);
  addtoclosure(closure4490, var_methodNode);
  struct UserObject *uo4490 = (struct UserObject*)self;
  uo4490->data[23] = (Object)closure4490;
  Method *meth_meth_ast_methodNode4490 = addmethod2pos(self, "methodNode", &meth_ast_methodNode4490, 23);
  int argcv_meth_ast_methodNode4490[] = {0};
  meth_meth_ast_methodNode4490->type = alloc_MethodType(1, argcv_meth_ast_methodNode4490);
  meth_meth_ast_methodNode4490->definitionModule = modulename;
  meth_meth_ast_methodNode4490->definitionLine = 804;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 806
  setline(806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 978
  setline(978);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject4491 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4491 = alloc_userobj2(3,4, objclass4491);
  gc_frame_newslot(obj4491);
// OBJECT OUTER DEC outer
  adddatum2(obj4491, self, 0);
  addmethodreal(obj4491,"outer", &reader_ast_outer_4492);
  Object oldself4491 = self;
  struct StackFrameObject *oldstackframe4491 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4491);
  gc_frame_newslot((Object)stackframe);
  self = obj4491;
  Object *oldselfslot4491 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4491 = (*(struct UserObject *)self).data[0], lowerouter4491 = thisouter4491;
  if (inheritingObject4491) {
    struct UserObject *inho4491 = (struct UserObject *)inheritingObject4491;
    while (inho4491->super != GraceDefaultObject) inho4491 = (struct UserObject *)inho4491->super;
    inho4491->super = obj4491;
    self = inheritingObject4491;
    *selfslot = self;
    lowerouter4491 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4491;
  }
// method new()scope
  struct UserObject *uo4493 = (struct UserObject*)obj4491;
  uo4493->data[1] = emptyclosure;
  Method *meth_meth_ast_new_40__41_scope4493 = addmethod2pos(obj4491, "new()scope", &meth_ast_new_40__41_scope4493, 1);
  int argcv_meth_ast_new_40__41_scope4493[] = {2, 1};
  meth_meth_ast_new_40__41_scope4493->type = alloc_MethodType(2, argcv_meth_ast_new_40__41_scope4493);
  meth_meth_ast_new_40__41_scope4493->definitionModule = modulename;
  meth_meth_ast_new_40__41_scope4493->definitionLine = 979;
// method new
  block_savedest(obj4491);
  Object closure4498 = createclosure(2, "new");
  setclosureframe(closure4498, stackframe);
  addtoclosure(closure4498, var_callNode);
  addtoclosure(closure4498, var_baseNode);
  struct UserObject *uo4498 = (struct UserObject*)obj4491;
  uo4498->data[2] = (Object)closure4498;
  Method *meth_meth_ast_new4498 = addmethod2pos(obj4491, "new", &meth_ast_new4498, 2);
  int argcv_meth_ast_new4498[] = {2};
  meth_meth_ast_new4498->type = alloc_MethodType(1, argcv_meth_ast_new4498);
  meth_meth_ast_new4498->definitionModule = modulename;
  meth_meth_ast_new4498->definitionLine = 984;
  block_savedest(obj4491);
  Object closure5028 = createclosure(2, "new()object");
  setclosureframe(closure5028, stackframe);
  addtoclosure(closure5028, var_callNode);
  addtoclosure(closure5028, var_baseNode);
  Method *meth_meth_ast_new4498_object = addmethod2pos(obj4491, "new()object", &meth_ast_new4498_object, 2);
  meth_meth_ast_new4498_object->definitionModule = modulename;
  meth_meth_ast_new4498_object->definitionLine = 984;
  sourceObject = obj4491;
  sourceObject = obj4491;
  objclass4491 = obj4491->class;
  objclass4491->definitionModule = modulename;
  objclass4491->definitionLine = 978;
  (*(struct UserObject *)self).data[0] = lowerouter4491;
  self = oldself4491;
  selfslot = oldselfslot4491;
  stackframe = oldstackframe4491;
// compiled object node returning obj4491 (depth = 2)
  *var_callNode = obj4491;
  if (obj4491 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// starting to compile method node (depth = 2)
// method callNode
  block_savedest(self);
  Object closure5029 = createclosure(1, "callNode");
  setclosureframe(closure5029, stackframe);
  addtoclosure(closure5029, var_callNode);
  struct UserObject *uo5029 = (struct UserObject*)self;
  uo5029->data[24] = (Object)closure5029;
  Method *meth_meth_ast_callNode5029 = addmethod2pos(self, "callNode", &meth_ast_callNode5029, 24);
  int argcv_meth_ast_callNode5029[] = {0};
  meth_meth_ast_callNode5029->type = alloc_MethodType(1, argcv_meth_ast_callNode5029);
  meth_meth_ast_callNode5029->definitionModule = modulename;
  meth_meth_ast_callNode5029->definitionLine = 1008;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1009
  setline(1009);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1124
  setline(1124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method classNode
  block_savedest(self);
  Object closure5030 = createclosure(1, "classNode");
  setclosureframe(closure5030, stackframe);
  addtoclosure(closure5030, var_classNode);
  struct UserObject *uo5030 = (struct UserObject*)self;
  uo5030->data[25] = (Object)closure5030;
  Method *meth_meth_ast_classNode5030 = addmethod2pos(self, "classNode", &meth_ast_classNode5030, 25);
  int argcv_meth_ast_classNode5030[] = {0};
  meth_meth_ast_classNode5030->type = alloc_MethodType(1, argcv_meth_ast_classNode5030);
  meth_meth_ast_classNode5030->definitionModule = modulename;
  meth_meth_ast_classNode5030->definitionLine = 1124;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject5031 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5031 = alloc_userobj2(2,4, objclass5031);
  gc_frame_newslot(obj5031);
// OBJECT OUTER DEC outer
  adddatum2(obj5031, self, 0);
  addmethodreal(obj5031,"outer", &reader_ast_outer_5032);
  Object oldself5031 = self;
  struct StackFrameObject *oldstackframe5031 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5031);
  gc_frame_newslot((Object)stackframe);
  self = obj5031;
  Object *oldselfslot5031 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5031 = (*(struct UserObject *)self).data[0], lowerouter5031 = thisouter5031;
  if (inheritingObject5031) {
    struct UserObject *inho5031 = (struct UserObject *)inheritingObject5031;
    while (inho5031->super != GraceDefaultObject) inho5031 = (struct UserObject *)inho5031->super;
    inho5031->super = obj5031;
    self = inheritingObject5031;
    *selfslot = self;
    lowerouter5031 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5031;
  }
// method new
  block_savedest(obj5031);
  Object closure5033 = createclosure(5, "new");
  setclosureframe(closure5033, stackframe);
  addtoclosure(closure5033, var_util);
  addtoclosure(closure5033, var_emptySeq);
  addtoclosure(closure5033, var_nullNode);
  addtoclosure(closure5033, var_classNode);
  addtoclosure(closure5033, var_baseNode);
  struct UserObject *uo5033 = (struct UserObject*)obj5031;
  uo5033->data[1] = (Object)closure5033;
  Method *meth_meth_ast_new5033 = addmethod2pos(obj5031, "new", &meth_ast_new5033, 1);
  int argcv_meth_ast_new5033[] = {6};
  meth_meth_ast_new5033->type = alloc_MethodType(1, argcv_meth_ast_new5033);
  meth_meth_ast_new5033->definitionModule = modulename;
  meth_meth_ast_new5033->definitionLine = 1124;
  block_savedest(obj5031);
  Object closure6127 = createclosure(5, "new()object");
  setclosureframe(closure6127, stackframe);
  addtoclosure(closure6127, var_util);
  addtoclosure(closure6127, var_emptySeq);
  addtoclosure(closure6127, var_nullNode);
  addtoclosure(closure6127, var_classNode);
  addtoclosure(closure6127, var_baseNode);
  Method *meth_meth_ast_new5033_object = addmethod2pos(obj5031, "new()object", &meth_ast_new5033_object, 1);
  meth_meth_ast_new5033_object->definitionModule = modulename;
  meth_meth_ast_new5033_object->definitionLine = 1124;
  sourceObject = obj5031;
  objclass5031 = obj5031->class;
  objclass5031->definitionModule = modulename;
  objclass5031->definitionLine = 1124;
  (*(struct UserObject *)self).data[0] = lowerouter5031;
  self = oldself5031;
  selfslot = oldselfslot5031;
  stackframe = oldstackframe5031;
// compiled object node returning obj5031 (depth = 3)
  *var_classNode = obj5031;
  if (obj5031 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 1167
  setline(1167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1323
  setline(1323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject6128 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6128 = alloc_userobj2(3,4, objclass6128);
  gc_frame_newslot(obj6128);
// OBJECT OUTER DEC outer
  adddatum2(obj6128, self, 0);
  addmethodreal(obj6128,"outer", &reader_ast_outer_6129);
  Object oldself6128 = self;
  struct StackFrameObject *oldstackframe6128 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6128);
  gc_frame_newslot((Object)stackframe);
  self = obj6128;
  Object *oldselfslot6128 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6128 = (*(struct UserObject *)self).data[0], lowerouter6128 = thisouter6128;
  if (inheritingObject6128) {
    struct UserObject *inho6128 = (struct UserObject *)inheritingObject6128;
    while (inho6128->super != GraceDefaultObject) inho6128 = (struct UserObject *)inho6128->super;
    inho6128->super = obj6128;
    self = inheritingObject6128;
    *selfslot = self;
    lowerouter6128 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6128;
  }
// method body()named()scope
  struct UserObject *uo6130 = (struct UserObject*)obj6128;
  uo6130->data[1] = emptyclosure;
  Method *meth_meth_ast_body_40__41_named_40__41_scope6130 = addmethod2pos(obj6128, "body()named()scope", &meth_ast_body_40__41_named_40__41_scope6130, 1);
  int argcv_meth_ast_body_40__41_named_40__41_scope6130[] = {1, 1, 1};
  meth_meth_ast_body_40__41_named_40__41_scope6130->type = alloc_MethodType(3, argcv_meth_ast_body_40__41_named_40__41_scope6130);
  meth_meth_ast_body_40__41_named_40__41_scope6130->definitionModule = modulename;
  meth_meth_ast_body_40__41_named_40__41_scope6130->definitionLine = 1324;
// method new
  block_savedest(obj6128);
  Object closure6137 = createclosure(3, "new");
  setclosureframe(closure6137, stackframe);
  addtoclosure(closure6137, var_emptySeq);
  addtoclosure(closure6137, var_moduleNode);
  addtoclosure(closure6137, var_objectNode);
  struct UserObject *uo6137 = (struct UserObject*)obj6128;
  uo6137->data[2] = (Object)closure6137;
  Method *meth_meth_ast_new6137 = addmethod2pos(obj6128, "new", &meth_ast_new6137, 2);
  int argcv_meth_ast_new6137[] = {1};
  meth_meth_ast_new6137->type = alloc_MethodType(1, argcv_meth_ast_new6137);
  meth_meth_ast_new6137->definitionModule = modulename;
  meth_meth_ast_new6137->definitionLine = 1330;
  block_savedest(obj6128);
  Object closure6182 = createclosure(3, "new()object");
  setclosureframe(closure6182, stackframe);
  addtoclosure(closure6182, var_emptySeq);
  addtoclosure(closure6182, var_moduleNode);
  addtoclosure(closure6182, var_objectNode);
  Method *meth_meth_ast_new6137_object = addmethod2pos(obj6128, "new()object", &meth_ast_new6137_object, 2);
  meth_meth_ast_new6137_object->definitionModule = modulename;
  meth_meth_ast_new6137_object->definitionLine = 1330;
  sourceObject = obj6128;
  sourceObject = obj6128;
  objclass6128 = obj6128->class;
  objclass6128->definitionModule = modulename;
  objclass6128->definitionLine = 1323;
  (*(struct UserObject *)self).data[0] = lowerouter6128;
  self = oldself6128;
  selfslot = oldselfslot6128;
  stackframe = oldstackframe6128;
// compiled object node returning obj6128 (depth = 2)
  *var_moduleNode = obj6128;
  if (obj6128 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 1342
  setline(1342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method moduleNode
  block_savedest(self);
  Object closure6183 = createclosure(1, "moduleNode");
  setclosureframe(closure6183, stackframe);
  addtoclosure(closure6183, var_moduleNode);
  struct UserObject *uo6183 = (struct UserObject*)self;
  uo6183->data[26] = (Object)closure6183;
  Method *meth_meth_ast_moduleNode6183 = addmethod2pos(self, "moduleNode", &meth_ast_moduleNode6183, 26);
  int argcv_meth_ast_moduleNode6183[] = {0};
  meth_meth_ast_moduleNode6183->type = alloc_MethodType(1, argcv_meth_ast_moduleNode6183);
  meth_meth_ast_moduleNode6183->definitionModule = modulename;
  meth_meth_ast_moduleNode6183->definitionLine = 1342;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1352
  setline(1352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject6184 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6184 = alloc_userobj2(4,5, objclass6184);
  gc_frame_newslot(obj6184);
// OBJECT OUTER DEC outer
  adddatum2(obj6184, self, 0);
  addmethodreal(obj6184,"outer", &reader_ast_outer_6185);
  Object oldself6184 = self;
  struct StackFrameObject *oldstackframe6184 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6184);
  gc_frame_newslot((Object)stackframe);
  self = obj6184;
  Object *oldselfslot6184 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6184 = (*(struct UserObject *)self).data[0], lowerouter6184 = thisouter6184;
  if (inheritingObject6184) {
    struct UserObject *inho6184 = (struct UserObject *)inheritingObject6184;
    while (inho6184->super != GraceDefaultObject) inho6184 = (struct UserObject *)inho6184->super;
    inho6184->super = obj6184;
    self = inheritingObject6184;
    *selfslot = self;
    lowerouter6184 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6184;
  }
// method body()named()scope
  struct UserObject *uo6186 = (struct UserObject*)obj6184;
  uo6186->data[1] = emptyclosure;
  Method *meth_meth_ast_body_40__41_named_40__41_scope6186 = addmethod2pos(obj6184, "body()named()scope", &meth_ast_body_40__41_named_40__41_scope6186, 1);
  int argcv_meth_ast_body_40__41_named_40__41_scope6186[] = {1, 1, 1};
  meth_meth_ast_body_40__41_named_40__41_scope6186->type = alloc_MethodType(3, argcv_meth_ast_body_40__41_named_40__41_scope6186);
  meth_meth_ast_body_40__41_named_40__41_scope6186->definitionModule = modulename;
  meth_meth_ast_body_40__41_named_40__41_scope6186->definitionLine = 1353;
// method body()named
  block_savedest(obj6184);
  Object closure6194 = createclosure(1, "body()named");
  setclosureframe(closure6194, stackframe);
  addtoclosure(closure6194, var_fakeSymbolTable);
  struct UserObject *uo6194 = (struct UserObject*)obj6184;
  uo6194->data[2] = (Object)closure6194;
  Method *meth_meth_ast_body_40__41_named6194 = addmethod2pos(obj6184, "body()named", &meth_ast_body_40__41_named6194, 2);
  int argcv_meth_ast_body_40__41_named6194[] = {1, 1};
  meth_meth_ast_body_40__41_named6194->type = alloc_MethodType(2, argcv_meth_ast_body_40__41_named6194);
  meth_meth_ast_body_40__41_named6194->definitionModule = modulename;
  meth_meth_ast_body_40__41_named6194->definitionLine = 1359;
// method new
  block_savedest(obj6184);
  Object closure6197 = createclosure(3, "new");
  setclosureframe(closure6197, stackframe);
  addtoclosure(closure6197, var_emptySeq);
  addtoclosure(closure6197, var_objectNode);
  addtoclosure(closure6197, var_baseNode);
  struct UserObject *uo6197 = (struct UserObject*)obj6184;
  uo6197->data[3] = (Object)closure6197;
  Method *meth_meth_ast_new6197 = addmethod2pos(obj6184, "new", &meth_ast_new6197, 3);
  int argcv_meth_ast_new6197[] = {2};
  meth_meth_ast_new6197->type = alloc_MethodType(1, argcv_meth_ast_new6197);
  meth_meth_ast_new6197->definitionModule = modulename;
  meth_meth_ast_new6197->definitionLine = 1362;
  block_savedest(obj6184);
  Object closure6483 = createclosure(3, "new()object");
  setclosureframe(closure6483, stackframe);
  addtoclosure(closure6483, var_emptySeq);
  addtoclosure(closure6483, var_objectNode);
  addtoclosure(closure6483, var_baseNode);
  Method *meth_meth_ast_new6197_object = addmethod2pos(obj6184, "new()object", &meth_ast_new6197_object, 3);
  meth_meth_ast_new6197_object->definitionModule = modulename;
  meth_meth_ast_new6197_object->definitionLine = 1362;
  sourceObject = obj6184;
  sourceObject = obj6184;
  sourceObject = obj6184;
  objclass6184 = obj6184->class;
  objclass6184->definitionModule = modulename;
  objclass6184->definitionLine = 1352;
  (*(struct UserObject *)self).data[0] = lowerouter6184;
  self = oldself6184;
  selfslot = oldselfslot6184;
  stackframe = oldstackframe6184;
// compiled object node returning obj6184 (depth = 2)
  *var_objectNode = obj6184;
  if (obj6184 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 1446
  setline(1446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method objectNode
  block_savedest(self);
  Object closure6484 = createclosure(1, "objectNode");
  setclosureframe(closure6484, stackframe);
  addtoclosure(closure6484, var_objectNode);
  struct UserObject *uo6484 = (struct UserObject*)self;
  uo6484->data[27] = (Object)closure6484;
  Method *meth_meth_ast_objectNode6484 = addmethod2pos(self, "objectNode", &meth_ast_objectNode6484, 27);
  int argcv_meth_ast_objectNode6484[] = {0};
  meth_meth_ast_objectNode6484->type = alloc_MethodType(1, argcv_meth_ast_objectNode6484);
  meth_meth_ast_objectNode6484->definitionModule = modulename;
  meth_meth_ast_objectNode6484->definitionLine = 1446;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1370
  setline(1370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1450
  setline(1450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method arrayNode
  block_savedest(self);
  Object closure6485 = createclosure(1, "arrayNode");
  setclosureframe(closure6485, stackframe);
  addtoclosure(closure6485, var_arrayNode);
  struct UserObject *uo6485 = (struct UserObject*)self;
  uo6485->data[28] = (Object)closure6485;
  Method *meth_meth_ast_arrayNode6485 = addmethod2pos(self, "arrayNode", &meth_ast_arrayNode6485, 28);
  int argcv_meth_ast_arrayNode6485[] = {0};
  meth_meth_ast_arrayNode6485->type = alloc_MethodType(1, argcv_meth_ast_arrayNode6485);
  meth_meth_ast_arrayNode6485->definitionModule = modulename;
  meth_meth_ast_arrayNode6485->definitionLine = 1450;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject6486 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6486 = alloc_userobj2(2,4, objclass6486);
  gc_frame_newslot(obj6486);
// OBJECT OUTER DEC outer
  adddatum2(obj6486, self, 0);
  addmethodreal(obj6486,"outer", &reader_ast_outer_6487);
  Object oldself6486 = self;
  struct StackFrameObject *oldstackframe6486 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6486);
  gc_frame_newslot((Object)stackframe);
  self = obj6486;
  Object *oldselfslot6486 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6486 = (*(struct UserObject *)self).data[0], lowerouter6486 = thisouter6486;
  if (inheritingObject6486) {
    struct UserObject *inho6486 = (struct UserObject *)inheritingObject6486;
    while (inho6486->super != GraceDefaultObject) inho6486 = (struct UserObject *)inho6486->super;
    inho6486->super = obj6486;
    self = inheritingObject6486;
    *selfslot = self;
    lowerouter6486 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6486;
  }
// method new
  block_savedest(obj6486);
  Object closure6488 = createclosure(3, "new");
  setclosureframe(closure6488, stackframe);
  addtoclosure(closure6488, var_emptySeq);
  addtoclosure(closure6488, var_arrayNode);
  addtoclosure(closure6488, var_baseNode);
  struct UserObject *uo6488 = (struct UserObject*)obj6486;
  uo6488->data[1] = (Object)closure6488;
  Method *meth_meth_ast_new6488 = addmethod2pos(obj6486, "new", &meth_ast_new6488, 1);
  int argcv_meth_ast_new6488[] = {1};
  meth_meth_ast_new6488->type = alloc_MethodType(1, argcv_meth_ast_new6488);
  meth_meth_ast_new6488->definitionModule = modulename;
  meth_meth_ast_new6488->definitionLine = 1450;
  block_savedest(obj6486);
  Object closure6614 = createclosure(3, "new()object");
  setclosureframe(closure6614, stackframe);
  addtoclosure(closure6614, var_emptySeq);
  addtoclosure(closure6614, var_arrayNode);
  addtoclosure(closure6614, var_baseNode);
  Method *meth_meth_ast_new6488_object = addmethod2pos(obj6486, "new()object", &meth_ast_new6488_object, 1);
  meth_meth_ast_new6488_object->definitionModule = modulename;
  meth_meth_ast_new6488_object->definitionLine = 1450;
  sourceObject = obj6486;
  objclass6486 = obj6486->class;
  objclass6486->definitionModule = modulename;
  objclass6486->definitionLine = 1450;
  (*(struct UserObject *)self).data[0] = lowerouter6486;
  self = oldself6486;
  selfslot = oldselfslot6486;
  stackframe = oldstackframe6486;
// compiled object node returning obj6486 (depth = 3)
  *var_arrayNode = obj6486;
  if (obj6486 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 1494
  setline(1494);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject6615 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6615 = alloc_userobj2(3,4, objclass6615);
  gc_frame_newslot(obj6615);
// OBJECT OUTER DEC outer
  adddatum2(obj6615, self, 0);
  addmethodreal(obj6615,"outer", &reader_ast_outer_6616);
  Object oldself6615 = self;
  struct StackFrameObject *oldstackframe6615 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6615);
  gc_frame_newslot((Object)stackframe);
  self = obj6615;
  Object *oldselfslot6615 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6615 = (*(struct UserObject *)self).data[0], lowerouter6615 = thisouter6615;
  if (inheritingObject6615) {
    struct UserObject *inho6615 = (struct UserObject *)inheritingObject6615;
    while (inho6615->super != GraceDefaultObject) inho6615 = (struct UserObject *)inho6615->super;
    inho6615->super = obj6615;
    self = inheritingObject6615;
    *selfslot = self;
    lowerouter6615 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6615;
  }
// method new()scope
  struct UserObject *uo6617 = (struct UserObject*)obj6615;
  uo6617->data[1] = emptyclosure;
  Method *meth_meth_ast_new_40__41_scope6617 = addmethod2pos(obj6615, "new()scope", &meth_ast_new_40__41_scope6617, 1);
  int argcv_meth_ast_new_40__41_scope6617[] = {2, 1};
  meth_meth_ast_new_40__41_scope6617->type = alloc_MethodType(2, argcv_meth_ast_new_40__41_scope6617);
  meth_meth_ast_new_40__41_scope6617->definitionModule = modulename;
  meth_meth_ast_new_40__41_scope6617->definitionLine = 1495;
// method new
  block_savedest(obj6615);
  Object closure6622 = createclosure(4, "new");
  setclosureframe(closure6622, stackframe);
  addtoclosure(closure6622, var_identifierNode);
  addtoclosure(closure6622, var_nullNode);
  addtoclosure(closure6622, var_memberNode);
  addtoclosure(closure6622, var_baseNode);
  struct UserObject *uo6622 = (struct UserObject*)obj6615;
  uo6622->data[2] = (Object)closure6622;
  Method *meth_meth_ast_new6622 = addmethod2pos(obj6615, "new", &meth_ast_new6622, 2);
  int argcv_meth_ast_new6622[] = {2};
  meth_meth_ast_new6622->type = alloc_MethodType(1, argcv_meth_ast_new6622);
  meth_meth_ast_new6622->definitionModule = modulename;
  meth_meth_ast_new6622->definitionLine = 1500;
  block_savedest(obj6615);
  Object closure6935 = createclosure(4, "new()object");
  setclosureframe(closure6935, stackframe);
  addtoclosure(closure6935, var_identifierNode);
  addtoclosure(closure6935, var_nullNode);
  addtoclosure(closure6935, var_memberNode);
  addtoclosure(closure6935, var_baseNode);
  Method *meth_meth_ast_new6622_object = addmethod2pos(obj6615, "new()object", &meth_ast_new6622_object, 2);
  meth_meth_ast_new6622_object->definitionModule = modulename;
  meth_meth_ast_new6622_object->definitionLine = 1500;
  sourceObject = obj6615;
  sourceObject = obj6615;
  objclass6615 = obj6615->class;
  objclass6615->definitionModule = modulename;
  objclass6615->definitionLine = 1494;
  (*(struct UserObject *)self).data[0] = lowerouter6615;
  self = oldself6615;
  selfslot = oldselfslot6615;
  stackframe = oldstackframe6615;
// compiled object node returning obj6615 (depth = 2)
  *var_memberNode = obj6615;
  if (obj6615 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 1569
  setline(1569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method memberNode
  block_savedest(self);
  Object closure6936 = createclosure(1, "memberNode");
  setclosureframe(closure6936, stackframe);
  addtoclosure(closure6936, var_memberNode);
  struct UserObject *uo6936 = (struct UserObject*)self;
  uo6936->data[29] = (Object)closure6936;
  Method *meth_meth_ast_memberNode6936 = addmethod2pos(self, "memberNode", &meth_ast_memberNode6936, 29);
  int argcv_meth_ast_memberNode6936[] = {0};
  meth_meth_ast_memberNode6936->type = alloc_MethodType(1, argcv_meth_ast_memberNode6936);
  meth_meth_ast_memberNode6936->definitionModule = modulename;
  meth_meth_ast_memberNode6936->definitionLine = 1569;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1507
  setline(1507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1573
  setline(1573);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method genericNode
  block_savedest(self);
  Object closure6937 = createclosure(1, "genericNode");
  setclosureframe(closure6937, stackframe);
  addtoclosure(closure6937, var_genericNode);
  struct UserObject *uo6937 = (struct UserObject*)self;
  uo6937->data[30] = (Object)closure6937;
  Method *meth_meth_ast_genericNode6937 = addmethod2pos(self, "genericNode", &meth_ast_genericNode6937, 30);
  int argcv_meth_ast_genericNode6937[] = {0};
  meth_meth_ast_genericNode6937->type = alloc_MethodType(1, argcv_meth_ast_genericNode6937);
  meth_meth_ast_genericNode6937->definitionModule = modulename;
  meth_meth_ast_genericNode6937->definitionLine = 1573;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject6938 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6938 = alloc_userobj2(2,4, objclass6938);
  gc_frame_newslot(obj6938);
// OBJECT OUTER DEC outer
  adddatum2(obj6938, self, 0);
  addmethodreal(obj6938,"outer", &reader_ast_outer_6939);
  Object oldself6938 = self;
  struct StackFrameObject *oldstackframe6938 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6938);
  gc_frame_newslot((Object)stackframe);
  self = obj6938;
  Object *oldselfslot6938 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6938 = (*(struct UserObject *)self).data[0], lowerouter6938 = thisouter6938;
  if (inheritingObject6938) {
    struct UserObject *inho6938 = (struct UserObject *)inheritingObject6938;
    while (inho6938->super != GraceDefaultObject) inho6938 = (struct UserObject *)inho6938->super;
    inho6938->super = obj6938;
    self = inheritingObject6938;
    *selfslot = self;
    lowerouter6938 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6938;
  }
// method new
  block_savedest(obj6938);
  Object closure6940 = createclosure(3, "new");
  setclosureframe(closure6940, stackframe);
  addtoclosure(closure6940, var_emptySeq);
  addtoclosure(closure6940, var_genericNode);
  addtoclosure(closure6940, var_baseNode);
  struct UserObject *uo6940 = (struct UserObject*)obj6938;
  uo6940->data[1] = (Object)closure6940;
  Method *meth_meth_ast_new6940 = addmethod2pos(obj6938, "new", &meth_ast_new6940, 1);
  int argcv_meth_ast_new6940[] = {2};
  meth_meth_ast_new6940->type = alloc_MethodType(1, argcv_meth_ast_new6940);
  meth_meth_ast_new6940->definitionModule = modulename;
  meth_meth_ast_new6940->definitionLine = 1573;
  block_savedest(obj6938);
  Object closure7155 = createclosure(3, "new()object");
  setclosureframe(closure7155, stackframe);
  addtoclosure(closure7155, var_emptySeq);
  addtoclosure(closure7155, var_genericNode);
  addtoclosure(closure7155, var_baseNode);
  Method *meth_meth_ast_new6940_object = addmethod2pos(obj6938, "new()object", &meth_ast_new6940_object, 1);
  meth_meth_ast_new6940_object->definitionModule = modulename;
  meth_meth_ast_new6940_object->definitionLine = 1573;
  sourceObject = obj6938;
  objclass6938 = obj6938->class;
  objclass6938->definitionModule = modulename;
  objclass6938->definitionLine = 1573;
  (*(struct UserObject *)self).data[0] = lowerouter6938;
  self = oldself6938;
  selfslot = oldselfslot6938;
  stackframe = oldstackframe6938;
// compiled object node returning obj6938 (depth = 3)
  *var_genericNode = obj6938;
  if (obj6938 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 1628
  setline(1628);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1629
  setline(1629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method typeParametersNode
  block_savedest(self);
  Object closure7156 = createclosure(1, "typeParametersNode");
  setclosureframe(closure7156, stackframe);
  addtoclosure(closure7156, var_typeParametersNode);
  struct UserObject *uo7156 = (struct UserObject*)self;
  uo7156->data[31] = (Object)closure7156;
  Method *meth_meth_ast_typeParametersNode7156 = addmethod2pos(self, "typeParametersNode", &meth_ast_typeParametersNode7156, 31);
  int argcv_meth_ast_typeParametersNode7156[] = {0};
  meth_meth_ast_typeParametersNode7156->type = alloc_MethodType(1, argcv_meth_ast_typeParametersNode7156);
  meth_meth_ast_typeParametersNode7156->definitionModule = modulename;
  meth_meth_ast_typeParametersNode7156->definitionLine = 1629;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject7157 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7157 = alloc_userobj2(2,4, objclass7157);
  gc_frame_newslot(obj7157);
// OBJECT OUTER DEC outer
  adddatum2(obj7157, self, 0);
  addmethodreal(obj7157,"outer", &reader_ast_outer_7158);
  Object oldself7157 = self;
  struct StackFrameObject *oldstackframe7157 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7157);
  gc_frame_newslot((Object)stackframe);
  self = obj7157;
  Object *oldselfslot7157 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7157 = (*(struct UserObject *)self).data[0], lowerouter7157 = thisouter7157;
  if (inheritingObject7157) {
    struct UserObject *inho7157 = (struct UserObject *)inheritingObject7157;
    while (inho7157->super != GraceDefaultObject) inho7157 = (struct UserObject *)inho7157->super;
    inho7157->super = obj7157;
    self = inheritingObject7157;
    *selfslot = self;
    lowerouter7157 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7157;
  }
// method new
  block_savedest(obj7157);
  Object closure7159 = createclosure(3, "new");
  setclosureframe(closure7159, stackframe);
  addtoclosure(closure7159, var_emptySeq);
  addtoclosure(closure7159, var_typeParametersNode);
  addtoclosure(closure7159, var_baseNode);
  struct UserObject *uo7159 = (struct UserObject*)obj7157;
  uo7159->data[1] = (Object)closure7159;
  Method *meth_meth_ast_new7159 = addmethod2pos(obj7157, "new", &meth_ast_new7159, 1);
  int argcv_meth_ast_new7159[] = {1};
  meth_meth_ast_new7159->type = alloc_MethodType(1, argcv_meth_ast_new7159);
  meth_meth_ast_new7159->definitionModule = modulename;
  meth_meth_ast_new7159->definitionLine = 1629;
  block_savedest(obj7157);
  Object closure7282 = createclosure(3, "new()object");
  setclosureframe(closure7282, stackframe);
  addtoclosure(closure7282, var_emptySeq);
  addtoclosure(closure7282, var_typeParametersNode);
  addtoclosure(closure7282, var_baseNode);
  Method *meth_meth_ast_new7159_object = addmethod2pos(obj7157, "new()object", &meth_ast_new7159_object, 1);
  meth_meth_ast_new7159_object->definitionModule = modulename;
  meth_meth_ast_new7159_object->definitionLine = 1629;
  sourceObject = obj7157;
  objclass7157 = obj7157->class;
  objclass7157->definitionModule = modulename;
  objclass7157->definitionLine = 1629;
  (*(struct UserObject *)self).data[0] = lowerouter7157;
  self = oldself7157;
  selfslot = oldselfslot7157;
  stackframe = oldstackframe7157;
// compiled object node returning obj7157 (depth = 3)
  *var_typeParametersNode = obj7157;
  if (obj7157 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 1673
  setline(1673);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject7283 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7283 = alloc_userobj2(3,4, objclass7283);
  gc_frame_newslot(obj7283);
// OBJECT OUTER DEC outer
  adddatum2(obj7283, self, 0);
  addmethodreal(obj7283,"outer", &reader_ast_outer_7284);
  Object oldself7283 = self;
  struct StackFrameObject *oldstackframe7283 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7283);
  gc_frame_newslot((Object)stackframe);
  self = obj7283;
  Object *oldselfslot7283 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7283 = (*(struct UserObject *)self).data[0], lowerouter7283 = thisouter7283;
  if (inheritingObject7283) {
    struct UserObject *inho7283 = (struct UserObject *)inheritingObject7283;
    while (inho7283->super != GraceDefaultObject) inho7283 = (struct UserObject *)inho7283->super;
    inho7283->super = obj7283;
    self = inheritingObject7283;
    *selfslot = self;
    lowerouter7283 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7283;
  }
// method new()scope
  struct UserObject *uo7285 = (struct UserObject*)obj7283;
  uo7285->data[1] = emptyclosure;
  Method *meth_meth_ast_new_40__41_scope7285 = addmethod2pos(obj7283, "new()scope", &meth_ast_new_40__41_scope7285, 1);
  int argcv_meth_ast_new_40__41_scope7285[] = {2, 1};
  meth_meth_ast_new_40__41_scope7285->type = alloc_MethodType(2, argcv_meth_ast_new_40__41_scope7285);
  meth_meth_ast_new_40__41_scope7285->definitionModule = modulename;
  meth_meth_ast_new_40__41_scope7285->definitionLine = 1675;
// method new
  block_savedest(obj7283);
  Object closure7290 = createclosure(2, "new");
  setclosureframe(closure7290, stackframe);
  addtoclosure(closure7290, var_identifierNode);
  addtoclosure(closure7290, var_baseNode);
  struct UserObject *uo7290 = (struct UserObject*)obj7283;
  uo7290->data[2] = (Object)closure7290;
  Method *meth_meth_ast_new7290 = addmethod2pos(obj7283, "new", &meth_ast_new7290, 2);
  int argcv_meth_ast_new7290[] = {2};
  meth_meth_ast_new7290->type = alloc_MethodType(1, argcv_meth_ast_new7290);
  meth_meth_ast_new7290->definitionModule = modulename;
  meth_meth_ast_new7290->definitionLine = 1681;
  block_savedest(obj7283);
  Object closure7658 = createclosure(2, "new()object");
  setclosureframe(closure7658, stackframe);
  addtoclosure(closure7658, var_identifierNode);
  addtoclosure(closure7658, var_baseNode);
  Method *meth_meth_ast_new7290_object = addmethod2pos(obj7283, "new()object", &meth_ast_new7290_object, 2);
  meth_meth_ast_new7290_object->definitionModule = modulename;
  meth_meth_ast_new7290_object->definitionLine = 1681;
  sourceObject = obj7283;
  sourceObject = obj7283;
  objclass7283 = obj7283->class;
  objclass7283->definitionModule = modulename;
  objclass7283->definitionLine = 1673;
  (*(struct UserObject *)self).data[0] = lowerouter7283;
  self = oldself7283;
  selfslot = oldselfslot7283;
  stackframe = oldstackframe7283;
// compiled object node returning obj7283 (depth = 2)
  *var_identifierNode = obj7283;
  if (obj7283 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 1792
  setline(1792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method identifierNode
  block_savedest(self);
  Object closure7659 = createclosure(1, "identifierNode");
  setclosureframe(closure7659, stackframe);
  addtoclosure(closure7659, var_identifierNode);
  struct UserObject *uo7659 = (struct UserObject*)self;
  uo7659->data[32] = (Object)closure7659;
  Method *meth_meth_ast_identifierNode7659 = addmethod2pos(self, "identifierNode", &meth_ast_identifierNode7659, 32);
  int argcv_meth_ast_identifierNode7659[] = {0};
  meth_meth_ast_identifierNode7659->type = alloc_MethodType(1, argcv_meth_ast_identifierNode7659);
  meth_meth_ast_identifierNode7659->definitionModule = modulename;
  meth_meth_ast_identifierNode7659->definitionLine = 1792;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1797
  setline(1797);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1798
  setline(1798);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe7660 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit7661 == NULL) {
    strlit7661 = alloc_String("Type");
    gc_root(strlit7661);
  }
// compiled string node returning strlit7661 (depth = 3)
  gc_frame_newslot(strlit7661);
// starting to compile identifier node (depth = 3)
  Object bool7662 = alloc_Boolean(0);
// compiled identifier node returning bool7662 (depth = 3)
  gc_frame_newslot(bool7662);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_identifierNode (depth = 3)
  params[0] = strlit7661;
  params[1] = bool7662;
  partcv[0] = 2;
  Object call7663 = callmethod(*var_identifierNode, "new",
    1, partcv, params);
  gc_frame_end(callframe7660);
// compiled call node returning call7663 (depth = 2)
  *var_typeType = call7663;
  if (call7663 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 1792
  setline(1792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method typeType
  block_savedest(self);
  Object closure7664 = createclosure(1, "typeType");
  setclosureframe(closure7664, stackframe);
  addtoclosure(closure7664, var_typeType);
  struct UserObject *uo7664 = (struct UserObject*)self;
  uo7664->data[33] = (Object)closure7664;
  Method *meth_meth_ast_typeType7664 = addmethod2pos(self, "typeType", &meth_ast_typeType7664, 33);
  int argcv_meth_ast_typeType7664[] = {0};
  meth_meth_ast_typeType7664->type = alloc_MethodType(1, argcv_meth_ast_typeType7664);
  meth_meth_ast_typeType7664->definitionModule = modulename;
  meth_meth_ast_typeType7664->definitionLine = 1792;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1799
  setline(1799);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe7665 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit7666 == NULL) {
    strlit7666 = alloc_String("Unknown");
    gc_root(strlit7666);
  }
// compiled string node returning strlit7666 (depth = 3)
  gc_frame_newslot(strlit7666);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_typeType (depth = 3)
  gc_frame_newslot(*var_typeType);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_identifierNode (depth = 3)
  params[0] = strlit7666;
  params[1] = *var_typeType;
  partcv[0] = 2;
  Object call7667 = callmethod(*var_identifierNode, "new",
    1, partcv, params);
  gc_frame_end(callframe7665);
// compiled call node returning call7667 (depth = 2)
  *var_unknownType = call7667;
  if (call7667 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 1792
  setline(1792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method unknownType
  block_savedest(self);
  Object closure7668 = createclosure(1, "unknownType");
  setclosureframe(closure7668, stackframe);
  addtoclosure(closure7668, var_unknownType);
  struct UserObject *uo7668 = (struct UserObject*)self;
  uo7668->data[34] = (Object)closure7668;
  Method *meth_meth_ast_unknownType7668 = addmethod2pos(self, "unknownType", &meth_ast_unknownType7668, 34);
  int argcv_meth_ast_unknownType7668[] = {0};
  meth_meth_ast_unknownType7668->type = alloc_MethodType(1, argcv_meth_ast_unknownType7668);
  meth_meth_ast_unknownType7668->definitionModule = modulename;
  meth_meth_ast_unknownType7668->definitionLine = 1792;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1800
  setline(1800);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1801
  setline(1801);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject7669 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7669 = alloc_userobj2(3,4, objclass7669);
  gc_frame_newslot(obj7669);
// OBJECT OUTER DEC outer
  adddatum2(obj7669, self, 0);
  addmethodreal(obj7669,"outer", &reader_ast_outer_7670);
  Object oldself7669 = self;
  struct StackFrameObject *oldstackframe7669 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7669);
  gc_frame_newslot((Object)stackframe);
  self = obj7669;
  Object *oldselfslot7669 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7669 = (*(struct UserObject *)self).data[0], lowerouter7669 = thisouter7669;
  if (inheritingObject7669) {
    struct UserObject *inho7669 = (struct UserObject *)inheritingObject7669;
    while (inho7669->super != GraceDefaultObject) inho7669 = (struct UserObject *)inho7669->super;
    inho7669->super = obj7669;
    self = inheritingObject7669;
    *selfslot = self;
    lowerouter7669 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7669;
  }
// method new()scope
  struct UserObject *uo7671 = (struct UserObject*)obj7669;
  uo7671->data[1] = emptyclosure;
  Method *meth_meth_ast_new_40__41_scope7671 = addmethod2pos(obj7669, "new()scope", &meth_ast_new_40__41_scope7671, 1);
  int argcv_meth_ast_new_40__41_scope7671[] = {1, 1};
  meth_meth_ast_new_40__41_scope7671->type = alloc_MethodType(2, argcv_meth_ast_new_40__41_scope7671);
  meth_meth_ast_new_40__41_scope7671->definitionModule = modulename;
  meth_meth_ast_new_40__41_scope7671->definitionLine = 1802;
// method new
  block_savedest(obj7669);
  Object closure7676 = createclosure(2, "new");
  setclosureframe(closure7676, stackframe);
  addtoclosure(closure7676, var_stringNode);
  addtoclosure(closure7676, var_baseNode);
  struct UserObject *uo7676 = (struct UserObject*)obj7669;
  uo7676->data[2] = (Object)closure7676;
  Method *meth_meth_ast_new7676 = addmethod2pos(obj7669, "new", &meth_ast_new7676, 2);
  int argcv_meth_ast_new7676[] = {1};
  meth_meth_ast_new7676->type = alloc_MethodType(1, argcv_meth_ast_new7676);
  meth_meth_ast_new7676->definitionModule = modulename;
  meth_meth_ast_new7676->definitionLine = 1808;
  block_savedest(obj7669);
  Object closure7779 = createclosure(2, "new()object");
  setclosureframe(closure7779, stackframe);
  addtoclosure(closure7779, var_stringNode);
  addtoclosure(closure7779, var_baseNode);
  Method *meth_meth_ast_new7676_object = addmethod2pos(obj7669, "new()object", &meth_ast_new7676_object, 2);
  meth_meth_ast_new7676_object->definitionModule = modulename;
  meth_meth_ast_new7676_object->definitionLine = 1808;
  sourceObject = obj7669;
  sourceObject = obj7669;
  objclass7669 = obj7669->class;
  objclass7669->definitionModule = modulename;
  objclass7669->definitionLine = 1801;
  (*(struct UserObject *)self).data[0] = lowerouter7669;
  self = oldself7669;
  selfslot = oldselfslot7669;
  stackframe = oldstackframe7669;
// compiled object node returning obj7669 (depth = 2)
  *var_stringNode = obj7669;
  if (obj7669 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 1843
  setline(1843);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method stringNode
  block_savedest(self);
  Object closure7780 = createclosure(1, "stringNode");
  setclosureframe(closure7780, stackframe);
  addtoclosure(closure7780, var_stringNode);
  struct UserObject *uo7780 = (struct UserObject*)self;
  uo7780->data[35] = (Object)closure7780;
  Method *meth_meth_ast_stringNode7780 = addmethod2pos(self, "stringNode", &meth_ast_stringNode7780, 35);
  int argcv_meth_ast_stringNode7780[] = {0};
  meth_meth_ast_stringNode7780->type = alloc_MethodType(1, argcv_meth_ast_stringNode7780);
  meth_meth_ast_stringNode7780->definitionModule = modulename;
  meth_meth_ast_stringNode7780->definitionLine = 1843;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1807
  setline(1807);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1847
  setline(1847);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method numNode
  block_savedest(self);
  Object closure7781 = createclosure(1, "numNode");
  setclosureframe(closure7781, stackframe);
  addtoclosure(closure7781, var_numNode);
  struct UserObject *uo7781 = (struct UserObject*)self;
  uo7781->data[36] = (Object)closure7781;
  Method *meth_meth_ast_numNode7781 = addmethod2pos(self, "numNode", &meth_ast_numNode7781, 36);
  int argcv_meth_ast_numNode7781[] = {0};
  meth_meth_ast_numNode7781->type = alloc_MethodType(1, argcv_meth_ast_numNode7781);
  meth_meth_ast_numNode7781->definitionModule = modulename;
  meth_meth_ast_numNode7781->definitionLine = 1847;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject7782 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7782 = alloc_userobj2(2,4, objclass7782);
  gc_frame_newslot(obj7782);
// OBJECT OUTER DEC outer
  adddatum2(obj7782, self, 0);
  addmethodreal(obj7782,"outer", &reader_ast_outer_7783);
  Object oldself7782 = self;
  struct StackFrameObject *oldstackframe7782 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7782);
  gc_frame_newslot((Object)stackframe);
  self = obj7782;
  Object *oldselfslot7782 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7782 = (*(struct UserObject *)self).data[0], lowerouter7782 = thisouter7782;
  if (inheritingObject7782) {
    struct UserObject *inho7782 = (struct UserObject *)inheritingObject7782;
    while (inho7782->super != GraceDefaultObject) inho7782 = (struct UserObject *)inho7782->super;
    inho7782->super = obj7782;
    self = inheritingObject7782;
    *selfslot = self;
    lowerouter7782 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7782;
  }
// method new
  block_savedest(obj7782);
  Object closure7784 = createclosure(2, "new");
  setclosureframe(closure7784, stackframe);
  addtoclosure(closure7784, var_numNode);
  addtoclosure(closure7784, var_baseNode);
  struct UserObject *uo7784 = (struct UserObject*)obj7782;
  uo7784->data[1] = (Object)closure7784;
  Method *meth_meth_ast_new7784 = addmethod2pos(obj7782, "new", &meth_ast_new7784, 1);
  int argcv_meth_ast_new7784[] = {1};
  meth_meth_ast_new7784->type = alloc_MethodType(1, argcv_meth_ast_new7784);
  meth_meth_ast_new7784->definitionModule = modulename;
  meth_meth_ast_new7784->definitionLine = 1847;
  block_savedest(obj7782);
  Object closure7845 = createclosure(2, "new()object");
  setclosureframe(closure7845, stackframe);
  addtoclosure(closure7845, var_numNode);
  addtoclosure(closure7845, var_baseNode);
  Method *meth_meth_ast_new7784_object = addmethod2pos(obj7782, "new()object", &meth_ast_new7784_object, 1);
  meth_meth_ast_new7784_object->definitionModule = modulename;
  meth_meth_ast_new7784_object->definitionLine = 1847;
  sourceObject = obj7782;
  objclass7782 = obj7782->class;
  objclass7782->definitionModule = modulename;
  objclass7782->definitionLine = 1847;
  (*(struct UserObject *)self).data[0] = lowerouter7782;
  self = oldself7782;
  selfslot = oldselfslot7782;
  stackframe = oldstackframe7782;
// compiled object node returning obj7782 (depth = 3)
  *var_numNode = obj7782;
  if (obj7782 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 1870
  setline(1870);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method opNode
  block_savedest(self);
  Object closure7846 = createclosure(1, "opNode");
  setclosureframe(closure7846, stackframe);
  addtoclosure(closure7846, var_opNode);
  struct UserObject *uo7846 = (struct UserObject*)self;
  uo7846->data[37] = (Object)closure7846;
  Method *meth_meth_ast_opNode7846 = addmethod2pos(self, "opNode", &meth_ast_opNode7846, 37);
  int argcv_meth_ast_opNode7846[] = {0};
  meth_meth_ast_opNode7846->type = alloc_MethodType(1, argcv_meth_ast_opNode7846);
  meth_meth_ast_opNode7846->definitionModule = modulename;
  meth_meth_ast_opNode7846->definitionLine = 1870;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject7847 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7847 = alloc_userobj2(2,4, objclass7847);
  gc_frame_newslot(obj7847);
// OBJECT OUTER DEC outer
  adddatum2(obj7847, self, 0);
  addmethodreal(obj7847,"outer", &reader_ast_outer_7848);
  Object oldself7847 = self;
  struct StackFrameObject *oldstackframe7847 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7847);
  gc_frame_newslot((Object)stackframe);
  self = obj7847;
  Object *oldselfslot7847 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7847 = (*(struct UserObject *)self).data[0], lowerouter7847 = thisouter7847;
  if (inheritingObject7847) {
    struct UserObject *inho7847 = (struct UserObject *)inheritingObject7847;
    while (inho7847->super != GraceDefaultObject) inho7847 = (struct UserObject *)inho7847->super;
    inho7847->super = obj7847;
    self = inheritingObject7847;
    *selfslot = self;
    lowerouter7847 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7847;
  }
// method new
  block_savedest(obj7847);
  Object closure7849 = createclosure(4, "new");
  setclosureframe(closure7849, stackframe);
  addtoclosure(closure7849, var_identifierNode);
  addtoclosure(closure7849, var_nullNode);
  addtoclosure(closure7849, var_opNode);
  addtoclosure(closure7849, var_baseNode);
  struct UserObject *uo7849 = (struct UserObject*)obj7847;
  uo7849->data[1] = (Object)closure7849;
  Method *meth_meth_ast_new7849 = addmethod2pos(obj7847, "new", &meth_ast_new7849, 1);
  int argcv_meth_ast_new7849[] = {3};
  meth_meth_ast_new7849->type = alloc_MethodType(1, argcv_meth_ast_new7849);
  meth_meth_ast_new7849->definitionModule = modulename;
  meth_meth_ast_new7849->definitionLine = 1870;
  block_savedest(obj7847);
  Object closure8113 = createclosure(4, "new()object");
  setclosureframe(closure8113, stackframe);
  addtoclosure(closure8113, var_identifierNode);
  addtoclosure(closure8113, var_nullNode);
  addtoclosure(closure8113, var_opNode);
  addtoclosure(closure8113, var_baseNode);
  Method *meth_meth_ast_new7849_object = addmethod2pos(obj7847, "new()object", &meth_ast_new7849_object, 1);
  meth_meth_ast_new7849_object->definitionModule = modulename;
  meth_meth_ast_new7849_object->definitionLine = 1870;
  sourceObject = obj7847;
  objclass7847 = obj7847->class;
  objclass7847->definitionModule = modulename;
  objclass7847->definitionLine = 1870;
  (*(struct UserObject *)self).data[0] = lowerouter7847;
  self = oldself7847;
  selfslot = oldselfslot7847;
  stackframe = oldstackframe7847;
// compiled object node returning obj7847 (depth = 3)
  *var_opNode = obj7847;
  if (obj7847 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 1935
  setline(1935);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method indexNode
  block_savedest(self);
  Object closure8114 = createclosure(1, "indexNode");
  setclosureframe(closure8114, stackframe);
  addtoclosure(closure8114, var_indexNode);
  struct UserObject *uo8114 = (struct UserObject*)self;
  uo8114->data[38] = (Object)closure8114;
  Method *meth_meth_ast_indexNode8114 = addmethod2pos(self, "indexNode", &meth_ast_indexNode8114, 38);
  int argcv_meth_ast_indexNode8114[] = {0};
  meth_meth_ast_indexNode8114->type = alloc_MethodType(1, argcv_meth_ast_indexNode8114);
  meth_meth_ast_indexNode8114->definitionModule = modulename;
  meth_meth_ast_indexNode8114->definitionLine = 1935;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject8115 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8115 = alloc_userobj2(2,4, objclass8115);
  gc_frame_newslot(obj8115);
// OBJECT OUTER DEC outer
  adddatum2(obj8115, self, 0);
  addmethodreal(obj8115,"outer", &reader_ast_outer_8116);
  Object oldself8115 = self;
  struct StackFrameObject *oldstackframe8115 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8115);
  gc_frame_newslot((Object)stackframe);
  self = obj8115;
  Object *oldselfslot8115 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8115 = (*(struct UserObject *)self).data[0], lowerouter8115 = thisouter8115;
  if (inheritingObject8115) {
    struct UserObject *inho8115 = (struct UserObject *)inheritingObject8115;
    while (inho8115->super != GraceDefaultObject) inho8115 = (struct UserObject *)inho8115->super;
    inho8115->super = obj8115;
    self = inheritingObject8115;
    *selfslot = self;
    lowerouter8115 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8115;
  }
// method new
  block_savedest(obj8115);
  Object closure8117 = createclosure(3, "new");
  setclosureframe(closure8117, stackframe);
  addtoclosure(closure8117, var_nullNode);
  addtoclosure(closure8117, var_indexNode);
  addtoclosure(closure8117, var_baseNode);
  struct UserObject *uo8117 = (struct UserObject*)obj8115;
  uo8117->data[1] = (Object)closure8117;
  Method *meth_meth_ast_new8117 = addmethod2pos(obj8115, "new", &meth_ast_new8117, 1);
  int argcv_meth_ast_new8117[] = {2};
  meth_meth_ast_new8117->type = alloc_MethodType(1, argcv_meth_ast_new8117);
  meth_meth_ast_new8117->definitionModule = modulename;
  meth_meth_ast_new8117->definitionLine = 1935;
  block_savedest(obj8115);
  Object closure8269 = createclosure(3, "new()object");
  setclosureframe(closure8269, stackframe);
  addtoclosure(closure8269, var_nullNode);
  addtoclosure(closure8269, var_indexNode);
  addtoclosure(closure8269, var_baseNode);
  Method *meth_meth_ast_new8117_object = addmethod2pos(obj8115, "new()object", &meth_ast_new8117_object, 1);
  meth_meth_ast_new8117_object->definitionModule = modulename;
  meth_meth_ast_new8117_object->definitionLine = 1935;
  sourceObject = obj8115;
  objclass8115 = obj8115->class;
  objclass8115->definitionModule = modulename;
  objclass8115->definitionLine = 1935;
  (*(struct UserObject *)self).data[0] = lowerouter8115;
  self = oldself8115;
  selfslot = oldselfslot8115;
  stackframe = oldstackframe8115;
// compiled object node returning obj8115 (depth = 3)
  *var_indexNode = obj8115;
  if (obj8115 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 1941
  setline(1941);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1980
  setline(1980);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method bindNode
  block_savedest(self);
  Object closure8270 = createclosure(1, "bindNode");
  setclosureframe(closure8270, stackframe);
  addtoclosure(closure8270, var_bindNode);
  struct UserObject *uo8270 = (struct UserObject*)self;
  uo8270->data[39] = (Object)closure8270;
  Method *meth_meth_ast_bindNode8270 = addmethod2pos(self, "bindNode", &meth_ast_bindNode8270, 39);
  int argcv_meth_ast_bindNode8270[] = {0};
  meth_meth_ast_bindNode8270->type = alloc_MethodType(1, argcv_meth_ast_bindNode8270);
  meth_meth_ast_bindNode8270->definitionModule = modulename;
  meth_meth_ast_bindNode8270->definitionLine = 1980;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject8271 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8271 = alloc_userobj2(2,4, objclass8271);
  gc_frame_newslot(obj8271);
// OBJECT OUTER DEC outer
  adddatum2(obj8271, self, 0);
  addmethodreal(obj8271,"outer", &reader_ast_outer_8272);
  Object oldself8271 = self;
  struct StackFrameObject *oldstackframe8271 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8271);
  gc_frame_newslot((Object)stackframe);
  self = obj8271;
  Object *oldselfslot8271 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8271 = (*(struct UserObject *)self).data[0], lowerouter8271 = thisouter8271;
  if (inheritingObject8271) {
    struct UserObject *inho8271 = (struct UserObject *)inheritingObject8271;
    while (inho8271->super != GraceDefaultObject) inho8271 = (struct UserObject *)inho8271->super;
    inho8271->super = obj8271;
    self = inheritingObject8271;
    *selfslot = self;
    lowerouter8271 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8271;
  }
// method new
  block_savedest(obj8271);
  Object closure8273 = createclosure(2, "new");
  setclosureframe(closure8273, stackframe);
  addtoclosure(closure8273, var_bindNode);
  addtoclosure(closure8273, var_baseNode);
  struct UserObject *uo8273 = (struct UserObject*)obj8271;
  uo8273->data[1] = (Object)closure8273;
  Method *meth_meth_ast_new8273 = addmethod2pos(obj8271, "new", &meth_ast_new8273, 1);
  int argcv_meth_ast_new8273[] = {2};
  meth_meth_ast_new8273->type = alloc_MethodType(1, argcv_meth_ast_new8273);
  meth_meth_ast_new8273->definitionModule = modulename;
  meth_meth_ast_new8273->definitionLine = 1980;
  block_savedest(obj8271);
  Object closure8438 = createclosure(2, "new()object");
  setclosureframe(closure8438, stackframe);
  addtoclosure(closure8438, var_bindNode);
  addtoclosure(closure8438, var_baseNode);
  Method *meth_meth_ast_new8273_object = addmethod2pos(obj8271, "new()object", &meth_ast_new8273_object, 1);
  meth_meth_ast_new8273_object->definitionModule = modulename;
  meth_meth_ast_new8273_object->definitionLine = 1980;
  sourceObject = obj8271;
  objclass8271 = obj8271->class;
  objclass8271->definitionModule = modulename;
  objclass8271->definitionLine = 1980;
  (*(struct UserObject *)self).data[0] = lowerouter8271;
  self = oldself8271;
  selfslot = oldselfslot8271;
  stackframe = oldstackframe8271;
// compiled object node returning obj8271 (depth = 3)
  *var_bindNode = obj8271;
  if (obj8271 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 1986
  setline(1986);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2027
  setline(2027);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject8439 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8439 = alloc_userobj2(3,4, objclass8439);
  gc_frame_newslot(obj8439);
// OBJECT OUTER DEC outer
  adddatum2(obj8439, self, 0);
  addmethodreal(obj8439,"outer", &reader_ast_outer_8440);
  Object oldself8439 = self;
  struct StackFrameObject *oldstackframe8439 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8439);
  gc_frame_newslot((Object)stackframe);
  self = obj8439;
  Object *oldselfslot8439 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8439 = (*(struct UserObject *)self).data[0], lowerouter8439 = thisouter8439;
  if (inheritingObject8439) {
    struct UserObject *inho8439 = (struct UserObject *)inheritingObject8439;
    while (inho8439->super != GraceDefaultObject) inho8439 = (struct UserObject *)inho8439->super;
    inho8439->super = obj8439;
    self = inheritingObject8439;
    *selfslot = self;
    lowerouter8439 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8439;
  }
// method new()scope
  struct UserObject *uo8441 = (struct UserObject*)obj8439;
  uo8441->data[1] = emptyclosure;
  Method *meth_meth_ast_new_40__41_scope8441 = addmethod2pos(obj8439, "new()scope", &meth_ast_new_40__41_scope8441, 1);
  int argcv_meth_ast_new_40__41_scope8441[] = {3, 1};
  meth_meth_ast_new_40__41_scope8441->type = alloc_MethodType(2, argcv_meth_ast_new_40__41_scope8441);
  meth_meth_ast_new_40__41_scope8441->definitionModule = modulename;
  meth_meth_ast_new_40__41_scope8441->definitionLine = 2028;
// method new
  block_savedest(obj8439);
  Object closure8446 = createclosure(2, "new");
  setclosureframe(closure8446, stackframe);
  addtoclosure(closure8446, var_defDecNode);
  addtoclosure(closure8446, var_baseNode);
  struct UserObject *uo8446 = (struct UserObject*)obj8439;
  uo8446->data[2] = (Object)closure8446;
  Method *meth_meth_ast_new8446 = addmethod2pos(obj8439, "new", &meth_ast_new8446, 2);
  int argcv_meth_ast_new8446[] = {3};
  meth_meth_ast_new8446->type = alloc_MethodType(1, argcv_meth_ast_new8446);
  meth_meth_ast_new8446->definitionModule = modulename;
  meth_meth_ast_new8446->definitionLine = 2034;
  block_savedest(obj8439);
  Object closure8907 = createclosure(2, "new()object");
  setclosureframe(closure8907, stackframe);
  addtoclosure(closure8907, var_defDecNode);
  addtoclosure(closure8907, var_baseNode);
  Method *meth_meth_ast_new8446_object = addmethod2pos(obj8439, "new()object", &meth_ast_new8446_object, 2);
  meth_meth_ast_new8446_object->definitionModule = modulename;
  meth_meth_ast_new8446_object->definitionLine = 2034;
  sourceObject = obj8439;
  sourceObject = obj8439;
  objclass8439 = obj8439->class;
  objclass8439->definitionModule = modulename;
  objclass8439->definitionLine = 2027;
  (*(struct UserObject *)self).data[0] = lowerouter8439;
  self = oldself8439;
  selfslot = oldselfslot8439;
  stackframe = oldstackframe8439;
// compiled object node returning obj8439 (depth = 2)
  *var_defDecNode = obj8439;
  if (obj8439 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 2041
  setline(2041);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method defDecNode
  block_savedest(self);
  Object closure8908 = createclosure(1, "defDecNode");
  setclosureframe(closure8908, stackframe);
  addtoclosure(closure8908, var_defDecNode);
  struct UserObject *uo8908 = (struct UserObject*)self;
  uo8908->data[40] = (Object)closure8908;
  Method *meth_meth_ast_defDecNode8908 = addmethod2pos(self, "defDecNode", &meth_ast_defDecNode8908, 40);
  int argcv_meth_ast_defDecNode8908[] = {0};
  meth_meth_ast_defDecNode8908->type = alloc_MethodType(1, argcv_meth_ast_defDecNode8908);
  meth_meth_ast_defDecNode8908->definitionModule = modulename;
  meth_meth_ast_defDecNode8908->definitionLine = 2041;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2044
  setline(2044);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2147
  setline(2147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method varDecNode
  block_savedest(self);
  Object closure8909 = createclosure(1, "varDecNode");
  setclosureframe(closure8909, stackframe);
  addtoclosure(closure8909, var_varDecNode);
  struct UserObject *uo8909 = (struct UserObject*)self;
  uo8909->data[41] = (Object)closure8909;
  Method *meth_meth_ast_varDecNode8909 = addmethod2pos(self, "varDecNode", &meth_ast_varDecNode8909, 41);
  int argcv_meth_ast_varDecNode8909[] = {0};
  meth_meth_ast_varDecNode8909->type = alloc_MethodType(1, argcv_meth_ast_varDecNode8909);
  meth_meth_ast_varDecNode8909->definitionModule = modulename;
  meth_meth_ast_varDecNode8909->definitionLine = 2147;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject8910 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8910 = alloc_userobj2(2,4, objclass8910);
  gc_frame_newslot(obj8910);
// OBJECT OUTER DEC outer
  adddatum2(obj8910, self, 0);
  addmethodreal(obj8910,"outer", &reader_ast_outer_8911);
  Object oldself8910 = self;
  struct StackFrameObject *oldstackframe8910 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8910);
  gc_frame_newslot((Object)stackframe);
  self = obj8910;
  Object *oldselfslot8910 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8910 = (*(struct UserObject *)self).data[0], lowerouter8910 = thisouter8910;
  if (inheritingObject8910) {
    struct UserObject *inho8910 = (struct UserObject *)inheritingObject8910;
    while (inho8910->super != GraceDefaultObject) inho8910 = (struct UserObject *)inho8910->super;
    inho8910->super = obj8910;
    self = inheritingObject8910;
    *selfslot = self;
    lowerouter8910 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8910;
  }
// method new
  block_savedest(obj8910);
  Object closure8912 = createclosure(2, "new");
  setclosureframe(closure8912, stackframe);
  addtoclosure(closure8912, var_varDecNode);
  addtoclosure(closure8912, var_baseNode);
  struct UserObject *uo8912 = (struct UserObject*)obj8910;
  uo8912->data[1] = (Object)closure8912;
  Method *meth_meth_ast_new8912 = addmethod2pos(obj8910, "new", &meth_ast_new8912, 1);
  int argcv_meth_ast_new8912[] = {3};
  meth_meth_ast_new8912->type = alloc_MethodType(1, argcv_meth_ast_new8912);
  meth_meth_ast_new8912->definitionModule = modulename;
  meth_meth_ast_new8912->definitionLine = 2147;
  block_savedest(obj8910);
  Object closure9357 = createclosure(2, "new()object");
  setclosureframe(closure9357, stackframe);
  addtoclosure(closure9357, var_varDecNode);
  addtoclosure(closure9357, var_baseNode);
  Method *meth_meth_ast_new8912_object = addmethod2pos(obj8910, "new()object", &meth_ast_new8912_object, 1);
  meth_meth_ast_new8912_object->definitionModule = modulename;
  meth_meth_ast_new8912_object->definitionLine = 2147;
  sourceObject = obj8910;
  objclass8910 = obj8910->class;
  objclass8910->definitionModule = modulename;
  objclass8910->definitionLine = 2147;
  (*(struct UserObject *)self).data[0] = lowerouter8910;
  self = oldself8910;
  selfslot = oldselfslot8910;
  stackframe = oldstackframe8910;
// compiled object node returning obj8910 (depth = 3)
  *var_varDecNode = obj8910;
  if (obj8910 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 2155
  setline(2155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2250
  setline(2250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method importNode
  block_savedest(self);
  Object closure9358 = createclosure(1, "importNode");
  setclosureframe(closure9358, stackframe);
  addtoclosure(closure9358, var_importNode);
  struct UserObject *uo9358 = (struct UserObject*)self;
  uo9358->data[42] = (Object)closure9358;
  Method *meth_meth_ast_importNode9358 = addmethod2pos(self, "importNode", &meth_ast_importNode9358, 42);
  int argcv_meth_ast_importNode9358[] = {0};
  meth_meth_ast_importNode9358->type = alloc_MethodType(1, argcv_meth_ast_importNode9358);
  meth_meth_ast_importNode9358->definitionModule = modulename;
  meth_meth_ast_importNode9358->definitionLine = 2250;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject9359 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9359 = alloc_userobj2(2,4, objclass9359);
  gc_frame_newslot(obj9359);
// OBJECT OUTER DEC outer
  adddatum2(obj9359, self, 0);
  addmethodreal(obj9359,"outer", &reader_ast_outer_9360);
  Object oldself9359 = self;
  struct StackFrameObject *oldstackframe9359 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9359);
  gc_frame_newslot((Object)stackframe);
  self = obj9359;
  Object *oldselfslot9359 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9359 = (*(struct UserObject *)self).data[0], lowerouter9359 = thisouter9359;
  if (inheritingObject9359) {
    struct UserObject *inho9359 = (struct UserObject *)inheritingObject9359;
    while (inho9359->super != GraceDefaultObject) inho9359 = (struct UserObject *)inho9359->super;
    inho9359->super = obj9359;
    self = inheritingObject9359;
    *selfslot = self;
    lowerouter9359 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9359;
  }
// method new
  block_savedest(obj9359);
  Object closure9361 = createclosure(3, "new");
  setclosureframe(closure9361, stackframe);
  addtoclosure(closure9361, var_nullNode);
  addtoclosure(closure9361, var_importNode);
  addtoclosure(closure9361, var_baseNode);
  struct UserObject *uo9361 = (struct UserObject*)obj9359;
  uo9361->data[1] = (Object)closure9361;
  Method *meth_meth_ast_new9361 = addmethod2pos(obj9359, "new", &meth_ast_new9361, 1);
  int argcv_meth_ast_new9361[] = {3};
  meth_meth_ast_new9361->type = alloc_MethodType(1, argcv_meth_ast_new9361);
  meth_meth_ast_new9361->definitionModule = modulename;
  meth_meth_ast_new9361->definitionLine = 2250;
  block_savedest(obj9359);
  Object closure9631 = createclosure(3, "new()object");
  setclosureframe(closure9631, stackframe);
  addtoclosure(closure9631, var_nullNode);
  addtoclosure(closure9631, var_importNode);
  addtoclosure(closure9631, var_baseNode);
  Method *meth_meth_ast_new9361_object = addmethod2pos(obj9359, "new()object", &meth_ast_new9361_object, 1);
  meth_meth_ast_new9361_object->definitionModule = modulename;
  meth_meth_ast_new9361_object->definitionLine = 2250;
  sourceObject = obj9359;
  objclass9359 = obj9359->class;
  objclass9359->definitionModule = modulename;
  objclass9359->definitionLine = 2250;
  (*(struct UserObject *)self).data[0] = lowerouter9359;
  self = oldself9359;
  selfslot = oldselfslot9359;
  stackframe = oldstackframe9359;
// compiled object node returning obj9359 (depth = 3)
  *var_importNode = obj9359;
  if (obj9359 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 2323
  setline(2323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method dialectNode
  block_savedest(self);
  Object closure9632 = createclosure(1, "dialectNode");
  setclosureframe(closure9632, stackframe);
  addtoclosure(closure9632, var_dialectNode);
  struct UserObject *uo9632 = (struct UserObject*)self;
  uo9632->data[43] = (Object)closure9632;
  Method *meth_meth_ast_dialectNode9632 = addmethod2pos(self, "dialectNode", &meth_ast_dialectNode9632, 43);
  int argcv_meth_ast_dialectNode9632[] = {0};
  meth_meth_ast_dialectNode9632->type = alloc_MethodType(1, argcv_meth_ast_dialectNode9632);
  meth_meth_ast_dialectNode9632->definitionModule = modulename;
  meth_meth_ast_dialectNode9632->definitionLine = 2323;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject9633 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9633 = alloc_userobj2(2,4, objclass9633);
  gc_frame_newslot(obj9633);
// OBJECT OUTER DEC outer
  adddatum2(obj9633, self, 0);
  addmethodreal(obj9633,"outer", &reader_ast_outer_9634);
  Object oldself9633 = self;
  struct StackFrameObject *oldstackframe9633 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9633);
  gc_frame_newslot((Object)stackframe);
  self = obj9633;
  Object *oldselfslot9633 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9633 = (*(struct UserObject *)self).data[0], lowerouter9633 = thisouter9633;
  if (inheritingObject9633) {
    struct UserObject *inho9633 = (struct UserObject *)inheritingObject9633;
    while (inho9633->super != GraceDefaultObject) inho9633 = (struct UserObject *)inho9633->super;
    inho9633->super = obj9633;
    self = inheritingObject9633;
    *selfslot = self;
    lowerouter9633 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9633;
  }
// method new
  block_savedest(obj9633);
  Object closure9635 = createclosure(2, "new");
  setclosureframe(closure9635, stackframe);
  addtoclosure(closure9635, var_dialectNode);
  addtoclosure(closure9635, var_baseNode);
  struct UserObject *uo9635 = (struct UserObject*)obj9633;
  uo9635->data[1] = (Object)closure9635;
  Method *meth_meth_ast_new9635 = addmethod2pos(obj9633, "new", &meth_ast_new9635, 1);
  int argcv_meth_ast_new9635[] = {1};
  meth_meth_ast_new9635->type = alloc_MethodType(1, argcv_meth_ast_new9635);
  meth_meth_ast_new9635->definitionModule = modulename;
  meth_meth_ast_new9635->definitionLine = 2323;
  block_savedest(obj9633);
  Object closure9739 = createclosure(2, "new()object");
  setclosureframe(closure9739, stackframe);
  addtoclosure(closure9739, var_dialectNode);
  addtoclosure(closure9739, var_baseNode);
  Method *meth_meth_ast_new9635_object = addmethod2pos(obj9633, "new()object", &meth_ast_new9635_object, 1);
  meth_meth_ast_new9635_object->definitionModule = modulename;
  meth_meth_ast_new9635_object->definitionLine = 2323;
  sourceObject = obj9633;
  objclass9633 = obj9633->class;
  objclass9633->definitionModule = modulename;
  objclass9633->definitionLine = 2323;
  (*(struct UserObject *)self).data[0] = lowerouter9633;
  self = oldself9633;
  selfslot = oldselfslot9633;
  stackframe = oldstackframe9633;
// compiled object node returning obj9633 (depth = 3)
  *var_dialectNode = obj9633;
  if (obj9633 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 2327
  setline(2327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2367
  setline(2367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method returnNode
  block_savedest(self);
  Object closure9740 = createclosure(1, "returnNode");
  setclosureframe(closure9740, stackframe);
  addtoclosure(closure9740, var_returnNode);
  struct UserObject *uo9740 = (struct UserObject*)self;
  uo9740->data[44] = (Object)closure9740;
  Method *meth_meth_ast_returnNode9740 = addmethod2pos(self, "returnNode", &meth_ast_returnNode9740, 44);
  int argcv_meth_ast_returnNode9740[] = {0};
  meth_meth_ast_returnNode9740->type = alloc_MethodType(1, argcv_meth_ast_returnNode9740);
  meth_meth_ast_returnNode9740->definitionModule = modulename;
  meth_meth_ast_returnNode9740->definitionLine = 2367;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject9741 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9741 = alloc_userobj2(2,4, objclass9741);
  gc_frame_newslot(obj9741);
// OBJECT OUTER DEC outer
  adddatum2(obj9741, self, 0);
  addmethodreal(obj9741,"outer", &reader_ast_outer_9742);
  Object oldself9741 = self;
  struct StackFrameObject *oldstackframe9741 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9741);
  gc_frame_newslot((Object)stackframe);
  self = obj9741;
  Object *oldselfslot9741 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9741 = (*(struct UserObject *)self).data[0], lowerouter9741 = thisouter9741;
  if (inheritingObject9741) {
    struct UserObject *inho9741 = (struct UserObject *)inheritingObject9741;
    while (inho9741->super != GraceDefaultObject) inho9741 = (struct UserObject *)inho9741->super;
    inho9741->super = obj9741;
    self = inheritingObject9741;
    *selfslot = self;
    lowerouter9741 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9741;
  }
// method new
  block_savedest(obj9741);
  Object closure9743 = createclosure(3, "new");
  setclosureframe(closure9743, stackframe);
  addtoclosure(closure9743, var_nullNode);
  addtoclosure(closure9743, var_returnNode);
  addtoclosure(closure9743, var_baseNode);
  struct UserObject *uo9743 = (struct UserObject*)obj9741;
  uo9743->data[1] = (Object)closure9743;
  Method *meth_meth_ast_new9743 = addmethod2pos(obj9741, "new", &meth_ast_new9743, 1);
  int argcv_meth_ast_new9743[] = {1};
  meth_meth_ast_new9743->type = alloc_MethodType(1, argcv_meth_ast_new9743);
  meth_meth_ast_new9743->definitionModule = modulename;
  meth_meth_ast_new9743->definitionLine = 2367;
  block_savedest(obj9741);
  Object closure9825 = createclosure(3, "new()object");
  setclosureframe(closure9825, stackframe);
  addtoclosure(closure9825, var_nullNode);
  addtoclosure(closure9825, var_returnNode);
  addtoclosure(closure9825, var_baseNode);
  Method *meth_meth_ast_new9743_object = addmethod2pos(obj9741, "new()object", &meth_ast_new9743_object, 1);
  meth_meth_ast_new9743_object->definitionModule = modulename;
  meth_meth_ast_new9743_object->definitionLine = 2367;
  sourceObject = obj9741;
  objclass9741 = obj9741->class;
  objclass9741->definitionModule = modulename;
  objclass9741->definitionLine = 2367;
  (*(struct UserObject *)self).data[0] = lowerouter9741;
  self = oldself9741;
  selfslot = oldselfslot9741;
  stackframe = oldstackframe9741;
// compiled object node returning obj9741 (depth = 3)
  *var_returnNode = obj9741;
  if (obj9741 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 2371
  setline(2371);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2400
  setline(2400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject9826 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9826 = alloc_userobj2(3,4, objclass9826);
  gc_frame_newslot(obj9826);
// OBJECT OUTER DEC outer
  adddatum2(obj9826, self, 0);
  addmethodreal(obj9826,"outer", &reader_ast_outer_9827);
  Object oldself9826 = self;
  struct StackFrameObject *oldstackframe9826 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9826);
  gc_frame_newslot((Object)stackframe);
  self = obj9826;
  Object *oldselfslot9826 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9826 = (*(struct UserObject *)self).data[0], lowerouter9826 = thisouter9826;
  if (inheritingObject9826) {
    struct UserObject *inho9826 = (struct UserObject *)inheritingObject9826;
    while (inho9826->super != GraceDefaultObject) inho9826 = (struct UserObject *)inho9826->super;
    inho9826->super = obj9826;
    self = inheritingObject9826;
    *selfslot = self;
    lowerouter9826 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9826;
  }
// method new()scope
  struct UserObject *uo9828 = (struct UserObject*)obj9826;
  uo9828->data[1] = emptyclosure;
  Method *meth_meth_ast_new_40__41_scope9828 = addmethod2pos(obj9826, "new()scope", &meth_ast_new_40__41_scope9828, 1);
  int argcv_meth_ast_new_40__41_scope9828[] = {1, 1};
  meth_meth_ast_new_40__41_scope9828->type = alloc_MethodType(2, argcv_meth_ast_new_40__41_scope9828);
  meth_meth_ast_new_40__41_scope9828->definitionModule = modulename;
  meth_meth_ast_new_40__41_scope9828->definitionLine = 2401;
// method new
  block_savedest(obj9826);
  Object closure9833 = createclosure(3, "new");
  setclosureframe(closure9833, stackframe);
  addtoclosure(closure9833, var_nullNode);
  addtoclosure(closure9833, var_inheritsNode);
  addtoclosure(closure9833, var_baseNode);
  struct UserObject *uo9833 = (struct UserObject*)obj9826;
  uo9833->data[2] = (Object)closure9833;
  Method *meth_meth_ast_new9833 = addmethod2pos(obj9826, "new", &meth_ast_new9833, 2);
  int argcv_meth_ast_new9833[] = {1};
  meth_meth_ast_new9833->type = alloc_MethodType(1, argcv_meth_ast_new9833);
  meth_meth_ast_new9833->definitionModule = modulename;
  meth_meth_ast_new9833->definitionLine = 2406;
  block_savedest(obj9826);
  Object closure9978 = createclosure(3, "new()object");
  setclosureframe(closure9978, stackframe);
  addtoclosure(closure9978, var_nullNode);
  addtoclosure(closure9978, var_inheritsNode);
  addtoclosure(closure9978, var_baseNode);
  Method *meth_meth_ast_new9833_object = addmethod2pos(obj9826, "new()object", &meth_ast_new9833_object, 2);
  meth_meth_ast_new9833_object->definitionModule = modulename;
  meth_meth_ast_new9833_object->definitionLine = 2406;
  sourceObject = obj9826;
  sourceObject = obj9826;
  objclass9826 = obj9826->class;
  objclass9826->definitionModule = modulename;
  objclass9826->definitionLine = 2400;
  (*(struct UserObject *)self).data[0] = lowerouter9826;
  self = oldself9826;
  selfslot = oldselfslot9826;
  stackframe = oldstackframe9826;
// compiled object node returning obj9826 (depth = 2)
  *var_inheritsNode = obj9826;
  if (obj9826 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// starting to compile method node (depth = 2)
// method inheritsNode
  block_savedest(self);
  Object closure9979 = createclosure(1, "inheritsNode");
  setclosureframe(closure9979, stackframe);
  addtoclosure(closure9979, var_inheritsNode);
  struct UserObject *uo9979 = (struct UserObject*)self;
  uo9979->data[45] = (Object)closure9979;
  Method *meth_meth_ast_inheritsNode9979 = addmethod2pos(self, "inheritsNode", &meth_ast_inheritsNode9979, 45);
  int argcv_meth_ast_inheritsNode9979[] = {0};
  meth_meth_ast_inheritsNode9979->type = alloc_MethodType(1, argcv_meth_ast_inheritsNode9979);
  meth_meth_ast_inheritsNode9979->definitionModule = modulename;
  meth_meth_ast_inheritsNode9979->definitionLine = 2410;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2411
  setline(2411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2453
  setline(2453);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method blankNode
  block_savedest(self);
  Object closure9980 = createclosure(1, "blankNode");
  setclosureframe(closure9980, stackframe);
  addtoclosure(closure9980, var_blankNode);
  struct UserObject *uo9980 = (struct UserObject*)self;
  uo9980->data[46] = (Object)closure9980;
  Method *meth_meth_ast_blankNode9980 = addmethod2pos(self, "blankNode", &meth_ast_blankNode9980, 46);
  int argcv_meth_ast_blankNode9980[] = {0};
  meth_meth_ast_blankNode9980->type = alloc_MethodType(1, argcv_meth_ast_blankNode9980);
  meth_meth_ast_blankNode9980->definitionModule = modulename;
  meth_meth_ast_blankNode9980->definitionLine = 2453;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject9981 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9981 = alloc_userobj2(2,4, objclass9981);
  gc_frame_newslot(obj9981);
// OBJECT OUTER DEC outer
  adddatum2(obj9981, self, 0);
  addmethodreal(obj9981,"outer", &reader_ast_outer_9982);
  Object oldself9981 = self;
  struct StackFrameObject *oldstackframe9981 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9981);
  gc_frame_newslot((Object)stackframe);
  self = obj9981;
  Object *oldselfslot9981 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9981 = (*(struct UserObject *)self).data[0], lowerouter9981 = thisouter9981;
  if (inheritingObject9981) {
    struct UserObject *inho9981 = (struct UserObject *)inheritingObject9981;
    while (inho9981->super != GraceDefaultObject) inho9981 = (struct UserObject *)inho9981->super;
    inho9981->super = obj9981;
    self = inheritingObject9981;
    *selfslot = self;
    lowerouter9981 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9981;
  }
// method new
  block_savedest(obj9981);
  Object closure9983 = createclosure(2, "new");
  setclosureframe(closure9983, stackframe);
  addtoclosure(closure9983, var_blankNode);
  addtoclosure(closure9983, var_baseNode);
  struct UserObject *uo9983 = (struct UserObject*)obj9981;
  uo9983->data[1] = (Object)closure9983;
  Method *meth_meth_ast_new9983 = addmethod2pos(obj9981, "new", &meth_ast_new9983, 1);
  int argcv_meth_ast_new9983[] = {0};
  meth_meth_ast_new9983->type = alloc_MethodType(1, argcv_meth_ast_new9983);
  meth_meth_ast_new9983->definitionModule = modulename;
  meth_meth_ast_new9983->definitionLine = 2453;
  block_savedest(obj9981);
  Object closure10013 = createclosure(2, "new()object");
  setclosureframe(closure10013, stackframe);
  addtoclosure(closure10013, var_blankNode);
  addtoclosure(closure10013, var_baseNode);
  Method *meth_meth_ast_new9983_object = addmethod2pos(obj9981, "new()object", &meth_ast_new9983_object, 1);
  meth_meth_ast_new9983_object->definitionModule = modulename;
  meth_meth_ast_new9983_object->definitionLine = 2453;
  sourceObject = obj9981;
  objclass9981 = obj9981->class;
  objclass9981->definitionModule = modulename;
  objclass9981->definitionLine = 2453;
  (*(struct UserObject *)self).data[0] = lowerouter9981;
  self = oldself9981;
  selfslot = oldselfslot9981;
  stackframe = oldstackframe9981;
// compiled object node returning obj9981 (depth = 3)
  *var_blankNode = obj9981;
  if (obj9981 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 2457
  setline(2457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2473
  setline(2473);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject10014 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj10014 = alloc_userobj2(3,4, objclass10014);
  gc_frame_newslot(obj10014);
// OBJECT OUTER DEC outer
  adddatum2(obj10014, self, 0);
  addmethodreal(obj10014,"outer", &reader_ast_outer_10015);
  Object oldself10014 = self;
  struct StackFrameObject *oldstackframe10014 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe10014);
  gc_frame_newslot((Object)stackframe);
  self = obj10014;
  Object *oldselfslot10014 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter10014 = (*(struct UserObject *)self).data[0], lowerouter10014 = thisouter10014;
  if (inheritingObject10014) {
    struct UserObject *inho10014 = (struct UserObject *)inheritingObject10014;
    while (inho10014->super != GraceDefaultObject) inho10014 = (struct UserObject *)inho10014->super;
    inho10014->super = obj10014;
    self = inheritingObject10014;
    *selfslot = self;
    lowerouter10014 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter10014;
  }
// method new()scope
  struct UserObject *uo10016 = (struct UserObject*)obj10014;
  uo10016->data[1] = emptyclosure;
  Method *meth_meth_ast_new_40__41_scope10016 = addmethod2pos(obj10014, "new()scope", &meth_ast_new_40__41_scope10016, 1);
  int argcv_meth_ast_new_40__41_scope10016[] = {0, 1};
  meth_meth_ast_new_40__41_scope10016->type = alloc_MethodType(2, argcv_meth_ast_new_40__41_scope10016);
  meth_meth_ast_new_40__41_scope10016->definitionModule = modulename;
  meth_meth_ast_new_40__41_scope10016->definitionLine = 2474;
// method new
  block_savedest(obj10014);
  Object closure10050 = createclosure(2, "new");
  setclosureframe(closure10050, stackframe);
  addtoclosure(closure10050, var_signaturePart);
  addtoclosure(closure10050, var_baseNode);
  struct UserObject *uo10050 = (struct UserObject*)obj10014;
  uo10050->data[2] = (Object)closure10050;
  Method *meth_meth_ast_new10050 = addmethod2pos(obj10014, "new", &meth_ast_new10050, 2);
  int argcv_meth_ast_new10050[] = {0};
  meth_meth_ast_new10050->type = alloc_MethodType(1, argcv_meth_ast_new10050);
  meth_meth_ast_new10050->definitionModule = modulename;
  meth_meth_ast_new10050->definitionLine = 2486;
  block_savedest(obj10014);
  Object closure10331 = createclosure(2, "new()object");
  setclosureframe(closure10331, stackframe);
  addtoclosure(closure10331, var_signaturePart);
  addtoclosure(closure10331, var_baseNode);
  Method *meth_meth_ast_new10050_object = addmethod2pos(obj10014, "new()object", &meth_ast_new10050_object, 2);
  meth_meth_ast_new10050_object->definitionModule = modulename;
  meth_meth_ast_new10050_object->definitionLine = 2486;
  sourceObject = obj10014;
  sourceObject = obj10014;
  objclass10014 = obj10014->class;
  objclass10014->definitionModule = modulename;
  objclass10014->definitionLine = 2473;
  (*(struct UserObject *)self).data[0] = lowerouter10014;
  self = oldself10014;
  selfslot = oldselfslot10014;
  stackframe = oldstackframe10014;
// compiled object node returning obj10014 (depth = 2)
  *var_signaturePart = obj10014;
  if (obj10014 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 2506
  setline(2506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method signaturePart
  block_savedest(self);
  Object closure10332 = createclosure(1, "signaturePart");
  setclosureframe(closure10332, stackframe);
  addtoclosure(closure10332, var_signaturePart);
  struct UserObject *uo10332 = (struct UserObject*)self;
  uo10332->data[47] = (Object)closure10332;
  Method *meth_meth_ast_signaturePart10332 = addmethod2pos(self, "signaturePart", &meth_ast_signaturePart10332, 47);
  int argcv_meth_ast_signaturePart10332[] = {0};
  meth_meth_ast_signaturePart10332->type = alloc_MethodType(1, argcv_meth_ast_signaturePart10332);
  meth_meth_ast_signaturePart10332->definitionModule = modulename;
  meth_meth_ast_signaturePart10332->definitionLine = 2506;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2555
  setline(2555);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2556
  setline(2556);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject10333 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj10333 = alloc_userobj2(3,4, objclass10333);
  gc_frame_newslot(obj10333);
// OBJECT OUTER DEC outer
  adddatum2(obj10333, self, 0);
  addmethodreal(obj10333,"outer", &reader_ast_outer_10334);
  Object oldself10333 = self;
  struct StackFrameObject *oldstackframe10333 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe10333);
  gc_frame_newslot((Object)stackframe);
  self = obj10333;
  Object *oldselfslot10333 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter10333 = (*(struct UserObject *)self).data[0], lowerouter10333 = thisouter10333;
  if (inheritingObject10333) {
    struct UserObject *inho10333 = (struct UserObject *)inheritingObject10333;
    while (inho10333->super != GraceDefaultObject) inho10333 = (struct UserObject *)inho10333->super;
    inho10333->super = obj10333;
    self = inheritingObject10333;
    *selfslot = self;
    lowerouter10333 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter10333;
  }
// method new()scope
  struct UserObject *uo10335 = (struct UserObject*)obj10333;
  uo10335->data[1] = emptyclosure;
  Method *meth_meth_ast_new_40__41_scope10335 = addmethod2pos(obj10333, "new()scope", &meth_ast_new_40__41_scope10335, 1);
  int argcv_meth_ast_new_40__41_scope10335[] = {2, 1};
  meth_meth_ast_new_40__41_scope10335->type = alloc_MethodType(2, argcv_meth_ast_new_40__41_scope10335);
  meth_meth_ast_new_40__41_scope10335->definitionModule = modulename;
  meth_meth_ast_new_40__41_scope10335->definitionLine = 2557;
// method new
  block_savedest(obj10333);
  Object closure10340 = createclosure(2, "new");
  setclosureframe(closure10340, stackframe);
  addtoclosure(closure10340, var_callWithPart);
  addtoclosure(closure10340, var_baseNode);
  struct UserObject *uo10340 = (struct UserObject*)obj10333;
  uo10340->data[2] = (Object)closure10340;
  Method *meth_meth_ast_new10340 = addmethod2pos(obj10333, "new", &meth_ast_new10340, 2);
  int argcv_meth_ast_new10340[] = {0};
  meth_meth_ast_new10340->type = alloc_MethodType(1, argcv_meth_ast_new10340);
  meth_meth_ast_new10340->definitionModule = modulename;
  meth_meth_ast_new10340->definitionLine = 2562;
  block_savedest(obj10333);
  Object closure10496 = createclosure(2, "new()object");
  setclosureframe(closure10496, stackframe);
  addtoclosure(closure10496, var_callWithPart);
  addtoclosure(closure10496, var_baseNode);
  Method *meth_meth_ast_new10340_object = addmethod2pos(obj10333, "new()object", &meth_ast_new10340_object, 2);
  meth_meth_ast_new10340_object->definitionModule = modulename;
  meth_meth_ast_new10340_object->definitionLine = 2562;
  sourceObject = obj10333;
  sourceObject = obj10333;
  objclass10333 = obj10333->class;
  objclass10333->definitionModule = modulename;
  objclass10333->definitionLine = 2556;
  (*(struct UserObject *)self).data[0] = lowerouter10333;
  self = oldself10333;
  selfslot = oldselfslot10333;
  stackframe = oldstackframe10333;
// compiled object node returning obj10333 (depth = 2)
  *var_callWithPart = obj10333;
  if (obj10333 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 2575
  setline(2575);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method callWithPart
  block_savedest(self);
  Object closure10497 = createclosure(1, "callWithPart");
  setclosureframe(closure10497, stackframe);
  addtoclosure(closure10497, var_callWithPart);
  struct UserObject *uo10497 = (struct UserObject*)self;
  uo10497->data[48] = (Object)closure10497;
  Method *meth_meth_ast_callWithPart10497 = addmethod2pos(self, "callWithPart", &meth_ast_callWithPart10497, 48);
  int argcv_meth_ast_callWithPart10497[] = {0};
  meth_meth_ast_callWithPart10497->type = alloc_MethodType(1, argcv_meth_ast_callWithPart10497);
  meth_meth_ast_callWithPart10497->definitionModule = modulename;
  meth_meth_ast_callWithPart10497->definitionLine = 2575;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2607
  setline(2607);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2608
  setline(2608);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject10498 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj10498 = alloc_userobj2(2,4, objclass10498);
  gc_frame_newslot(obj10498);
// OBJECT OUTER DEC outer
  adddatum2(obj10498, self, 0);
  addmethodreal(obj10498,"outer", &reader_ast_outer_10499);
  Object oldself10498 = self;
  struct StackFrameObject *oldstackframe10498 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe10498);
  gc_frame_newslot((Object)stackframe);
  self = obj10498;
  Object *oldselfslot10498 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter10498 = (*(struct UserObject *)self).data[0], lowerouter10498 = thisouter10498;
  if (inheritingObject10498) {
    struct UserObject *inho10498 = (struct UserObject *)inheritingObject10498;
    while (inho10498->super != GraceDefaultObject) inho10498 = (struct UserObject *)inho10498->super;
    inho10498->super = obj10498;
    self = inheritingObject10498;
    *selfslot = self;
    lowerouter10498 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter10498;
  }
// method new
  block_savedest(obj10498);
  Object closure10500 = createclosure(5, "new");
  setclosureframe(closure10500, stackframe);
  addtoclosure(closure10500, var_lineLength);
  addtoclosure(closure10500, var_nullNode);
  addtoclosure(closure10500, var_commentNode);
  addtoclosure(closure10500, var_baseNode);
  addtoclosure(closure10500, var_util);
  struct UserObject *uo10500 = (struct UserObject*)obj10498;
  uo10500->data[1] = (Object)closure10500;
  Method *meth_meth_ast_new10500 = addmethod2pos(obj10498, "new", &meth_ast_new10500, 1);
  int argcv_meth_ast_new10500[] = {1};
  meth_meth_ast_new10500->type = alloc_MethodType(1, argcv_meth_ast_new10500);
  meth_meth_ast_new10500->definitionModule = modulename;
  meth_meth_ast_new10500->definitionLine = 2609;
  block_savedest(obj10498);
  Object closure10694 = createclosure(5, "new()object");
  setclosureframe(closure10694, stackframe);
  addtoclosure(closure10694, var_lineLength);
  addtoclosure(closure10694, var_nullNode);
  addtoclosure(closure10694, var_commentNode);
  addtoclosure(closure10694, var_baseNode);
  addtoclosure(closure10694, var_util);
  Method *meth_meth_ast_new10500_object = addmethod2pos(obj10498, "new()object", &meth_ast_new10500_object, 1);
  meth_meth_ast_new10500_object->definitionModule = modulename;
  meth_meth_ast_new10500_object->definitionLine = 2609;
  sourceObject = obj10498;
  objclass10498 = obj10498->class;
  objclass10498->definitionModule = modulename;
  objclass10498->definitionLine = 2608;
  (*(struct UserObject *)self).data[0] = lowerouter10498;
  self = oldself10498;
  selfslot = oldselfslot10498;
  stackframe = oldstackframe10498;
// compiled object node returning obj10498 (depth = 2)
  *var_commentNode = obj10498;
  if (obj10498 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// starting to compile method node (depth = 2)
// method commentNode
  block_savedest(self);
  Object closure10695 = createclosure(1, "commentNode");
  setclosureframe(closure10695, stackframe);
  addtoclosure(closure10695, var_commentNode);
  struct UserObject *uo10695 = (struct UserObject*)self;
  uo10695->data[49] = (Object)closure10695;
  Method *meth_meth_ast_commentNode10695 = addmethod2pos(self, "commentNode", &meth_ast_commentNode10695, 49);
  int argcv_meth_ast_commentNode10695[] = {0};
  meth_meth_ast_commentNode10695->type = alloc_MethodType(1, argcv_meth_ast_commentNode10695);
  meth_meth_ast_commentNode10695->definitionModule = modulename;
  meth_meth_ast_commentNode10695->definitionLine = 2615;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2661
  setline(2661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2695
  setline(2695);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2696
  setline(2696);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl ASTVisitor
// starting to compile typeliteral node (depth = 2)
//   Type literal 
    Object type10697 = alloc_Type("ASTVisitor", 31);
    add_Method((ClassData)type10697, "visitIf()up", NULL);
    add_Method((ClassData)type10697, "visitBlock()up", NULL);
    add_Method((ClassData)type10697, "visitMatchCase()up", NULL);
    add_Method((ClassData)type10697, "visitCatchCase()up", NULL);
    add_Method((ClassData)type10697, "visitMethodType()up", NULL);
    add_Method((ClassData)type10697, "visitSignaturePart()up", NULL);
    add_Method((ClassData)type10697, "visitTypeLiteral()up", NULL);
    add_Method((ClassData)type10697, "visitTypeParameters()up", NULL);
    add_Method((ClassData)type10697, "visitTypeDec()up", NULL);
    add_Method((ClassData)type10697, "visitMethod()up", NULL);
    add_Method((ClassData)type10697, "visitCall()up", NULL);
    add_Method((ClassData)type10697, "visitClass()up", NULL);
    add_Method((ClassData)type10697, "visitObject()up", NULL);
    add_Method((ClassData)type10697, "visitModule()up", NULL);
    add_Method((ClassData)type10697, "visitArray()up", NULL);
    add_Method((ClassData)type10697, "visitMember()up", NULL);
    add_Method((ClassData)type10697, "visitGeneric()up", NULL);
    add_Method((ClassData)type10697, "visitIdentifier()up", NULL);
    add_Method((ClassData)type10697, "visitString()up", NULL);
    add_Method((ClassData)type10697, "visitNum()up", NULL);
    add_Method((ClassData)type10697, "visitOp()up", NULL);
    add_Method((ClassData)type10697, "visitIndex()up", NULL);
    add_Method((ClassData)type10697, "visitBind()up", NULL);
    add_Method((ClassData)type10697, "visitDefDec()up", NULL);
    add_Method((ClassData)type10697, "visitVarDec()up", NULL);
    add_Method((ClassData)type10697, "visitImport()up", NULL);
    add_Method((ClassData)type10697, "visitReturn()up", NULL);
    add_Method((ClassData)type10697, "visitInherits()up", NULL);
    add_Method((ClassData)type10697, "visitDialect()up", NULL);
    add_Method((ClassData)type10697, "visitBlank()up", NULL);
    add_Method((ClassData)type10697, "visitComment()up", NULL);
// compiled typeliteral node returning type10697 (depth = 2)
  *var_ASTVisitor = type10697;
// Begin line 2615
  setline(2615);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method ASTVisitor
  block_savedest(self);
  Object closure10698 = createclosure(1, "ASTVisitor");
  setclosureframe(closure10698, stackframe);
  addtoclosure(closure10698, var_ASTVisitor);
  struct UserObject *uo10698 = (struct UserObject*)self;
  uo10698->data[50] = (Object)closure10698;
  Method *meth_meth_ast_ASTVisitor10698 = addmethod2pos(self, "ASTVisitor", &meth_ast_ASTVisitor10698, 50);
  int argcv_meth_ast_ASTVisitor10698[] = {0};
  meth_meth_ast_ASTVisitor10698->type = alloc_MethodType(1, argcv_meth_ast_ASTVisitor10698);
  meth_meth_ast_ASTVisitor10698->definitionModule = modulename;
  meth_meth_ast_ASTVisitor10698->definitionLine = 2615;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 2729
  setline(2729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2797
  setline(2797);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2839
  setline(2839);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2840
  setline(2840);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject10699 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj10699 = alloc_userobj2(2,4, objclass10699);
  gc_frame_newslot(obj10699);
// OBJECT OUTER DEC outer
  adddatum2(obj10699, self, 0);
  addmethodreal(obj10699,"outer", &reader_ast_outer_10700);
  Object oldself10699 = self;
  struct StackFrameObject *oldstackframe10699 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe10699);
  gc_frame_newslot((Object)stackframe);
  self = obj10699;
  Object *oldselfslot10699 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter10699 = (*(struct UserObject *)self).data[0], lowerouter10699 = thisouter10699;
  if (inheritingObject10699) {
    struct UserObject *inho10699 = (struct UserObject *)inheritingObject10699;
    while (inho10699->super != GraceDefaultObject) inho10699 = (struct UserObject *)inho10699->super;
    inho10699->super = obj10699;
    self = inheritingObject10699;
    *selfslot = self;
    lowerouter10699 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter10699;
  }
// method visitCall()up
  struct UserObject *uo10701 = (struct UserObject*)obj10699;
  uo10701->data[1] = emptyclosure;
  Method *meth_meth_ast_visitCall_40__41_up10701 = addmethod2pos(obj10699, "visitCall()up", &meth_ast_visitCall_40__41_up10701, 1);
  int argcv_meth_ast_visitCall_40__41_up10701[] = {1, 1};
  meth_meth_ast_visitCall_40__41_up10701->type = alloc_MethodType(2, argcv_meth_ast_visitCall_40__41_up10701);
  meth_meth_ast_visitCall_40__41_up10701->definitionModule = modulename;
  meth_meth_ast_visitCall_40__41_up10701->definitionLine = 2842;
  sourceObject = obj10699;
// Begin line 2841
  setline(2841);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10706 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10707 = gc_frame_new();
// call case 3: self.outer request
  Object call10708 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe10707);
// compiled call node returning call10708 (depth = 5)
// compiled member node returning call10708 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call10709 = callmethodflags(call10708, "baseVisitor()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10706);
// compiled call node returning call10709 (depth = 3)
  struct UserObject *obj10699_uo = (struct UserObject *)obj10699;
  obj10699_uo->super = call10709;
  sourceObject = obj10699;
  objclass10699 = obj10699->class;
  objclass10699->definitionModule = modulename;
  objclass10699->definitionLine = 2840;
  (*(struct UserObject *)self).data[0] = lowerouter10699;
  self = oldself10699;
  selfslot = oldselfslot10699;
  stackframe = oldstackframe10699;
// compiled object node returning obj10699 (depth = 2)
  *var_patternMarkVisitor = obj10699;
  if (obj10699 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// starting to compile method node (depth = 2)
// method patternMarkVisitor
  block_savedest(self);
  Object closure10710 = createclosure(1, "patternMarkVisitor");
  setclosureframe(closure10710, stackframe);
  addtoclosure(closure10710, var_patternMarkVisitor);
  struct UserObject *uo10710 = (struct UserObject*)self;
  uo10710->data[51] = (Object)closure10710;
  Method *meth_meth_ast_patternMarkVisitor10710 = addmethod2pos(self, "patternMarkVisitor", &meth_ast_patternMarkVisitor10710, 51);
  int argcv_meth_ast_patternMarkVisitor10710[] = {0};
  meth_meth_ast_patternMarkVisitor10710->type = alloc_MethodType(1, argcv_meth_ast_patternMarkVisitor10710);
  meth_meth_ast_patternMarkVisitor10710->definitionModule = modulename;
  meth_meth_ast_patternMarkVisitor10710->definitionLine = 2841;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2847
  setline(2847);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
  gc_frame_end(frame);
  return self;
}
