#include <gracelib.h>
#include <stdlib.h>
#include <math.h>
#include <float.h>
static char compilerRevision[] = "1560723984934899b9bf4496f3b68ced32fab99c";
static Object undefined;
extern Object done;
extern Object _prelude;
extern Object ObjectType;
extern Object String;
extern Object Number;
extern Object Boolean;
extern Object Dynamic;
extern Object Unknown;
extern Object Block;
extern Object Done;
extern Object Type;
extern Object GraceDefaultObject;
extern Object sourceObject;
static Object type_Object;
static Object type_String;
static Object type_Number;
static Object type_Boolean;
static Object type_Block;
static Object type_Done;
static Object type_Type;
static Object argv;
static Object emptyclosure;
static Object prelude;
static int isTailObject = 0;
static Object inheritingObject = NULL;
static const char modulename[] = "collectionsPrelude";
Object module_StandardPrelude_init();
static char *originalSourceLines[] = {
  "#pragma NativePrelude",
  "",
  "def BoundsError = ProgrammingError.refine \"BoundsError\"",
  "def Exhausted = ProgrammingError.refine \"iterator Exhausted\"",
  "def SubobjectResponsibility = ProgrammingError.refine \"SubobjectResponsibility\"",
  "def NoSuchObject = ProgrammingError.refine \"no such object\"",
  "def RequestError = ProgrammingError.refine \"inapproriate argument in method request\"",
  "def ConcurrentModification = ProgrammingError.refine \"object modified while iterating\"",
  "def SizeUnknown = Exception.refine \"the size is unknown\"",
  "",
  "method abstract {",
  "    // repeated in StandardPrelude",
  "    SubobjectResponsibility.raise \"abstract method not overriden by subobject\"",
  "}",
  "",
  "type Block0<R> = type {",
  "    apply -> R",
  "}",
  "",
  "type Block1<T,R> = type {",
  "    apply(a:T) -> R",
  "}",
  "",
  "type Block2<S,T,R> = type {",
  "    apply(a:S, b:T) -> R",
  "}",
  "",
  "type SelfType = Unknown     // becuase it's not yet in the language",
  "",
  "type Collection<T> = Object & type {",
  "    isEmpty -> Boolean",
  "    do(block1: Block1<T,Done>) -> Done",
  "    do(body:Block1<T,Done>) separatedBy(separator:Block0<Done>) -> Done",
  "    fold(blk:Block1<Object, T>) startingWith(initial:Object) -> Object",
  "    map(blk:Block1<T,Object>) -> Iterator<Object>",
  "    filter(condition:Block1<T,Boolean>) -> Iterator<T>",
  "    iterator -> Iterator<T>",
  "    ++(o: Collection<T>) -> Collection<T>",
  "    asList -> List<T>",
  "    asSequence -> Sequence<T>",
  "    asSet -> Set<T>",
  "}",
  "",
  "type Enumerable<T> = Collection<T> & type {",
  "    values -> Collection<T>",
  "    asDictionary -> Dictionary<Number,T>",
  "    keysAndValuesDo(action:Block2<Number,T,Object>) -> Done",
  "    onto(resultFactory:EmptyCollectionFactory<T>) -> Collection<T>",
  "    into(existing:Collection<Unknown>) -> Collection<Unknown>",
  "    sortedBy(comparison:Block2<T,T,Number>) -> SelfType",
  "    sorted -> SelfType",
  "}",
  "",
  "type Sequence<T> = Enumerable<T> & type {",
  "    size -> Number",
  "    at(n:Number) -> T",
  "    [](n:Number) -> T",
  "    indices -> Sequence<Number>",
  "    keys -> Sequence<Number>",
  "    first -> T",
  "    second -> T",
  "    third -> T",
  "    fourth -> T",
  "    fifth -> T",
  "    last -> T",
  "    indexOf<W>(elem:T)ifAbsent(action:Block0<W>) -> Number | W",
  "    indexOf(elem:T) -> Number",
  "    contains(elem:T) -> Boolean",
  "    reversed -> Sequence<T>",
  "}",
  "",
  "type List<T> = Sequence<T> & type {",
  "    add(*x: T) -> List<T>",
  "    addAll(xs:Collection<T>) -> List<T>",
  "    addFirst(*x: T) -> List<T>",
  "    addAllFirst(xs:Collection<T>) -> List<T>",
  "    addLast(*x: T) -> List<T>    // same as add",
  "    at(ix:Number) put(v:T) -> List<T>",
  "    []:= (ix:Number, v:T) -> Done",
  "    removeFirst -> T",
  "    removeAt(n: Number) -> T",
  "    removeLast -> T",
  "    remove(*v:T)",
  "    remove(*v:T) ifAbsent(action:Block0<Done>)",
  "    removeAll(vs: Collection<T>)",
  "    removeAll(vs: Collection<T>) ifAbsent(action:Block0<Done>)",
  "    indexOf(v:T)",
  "    indexOf<U>(v:T) ifAbsent(action:Block0<U>)",
  "    pop -> T",
  "    first -> T",
  "    second -> T",
  "    third -> T",
  "    fourth -> T",
  "    fifth -> T",
  "    last -> T",
  "    ++(o: List<T>) -> List<T>",
  "    addAll(l: Collection<T>) -> List<T>",
  "    copy -> List<T>",
  "    sort -> List<T>",
  "    sortBy(sortBlock:Block2<T,T,Number>) -> List<T>",
  "    reverse -> List<T>",
  "    reversed -> List<T>",
  "}",
  "",
  "type Set<T> = Collection<T> & type {",
  "    size -> Number",
  "    add(*elements:T) -> SelfType",
  "    addAll(elements:Collection<T>) -> SelfType",
  "    remove(*elements: T) -> Set<T>",
  "    remove(*elements: T) ifAbsent(block: Block0<Done>) -> Set<T>",
  "    includes(booleanBlock: Block1<T,Boolean>) -> Boolean",
  "    find(booleanBlock: Block1<T,Boolean>) ifNone(notFoundBlock: Block0<T>) -> T",
  "    copy -> Set<T>",
  "    contains(elem:T) -> Boolean",
  "    ** (other:Set<T>) -> Set<T>",
  "    -- (other:Set<T>) -> Set<T>",
  "    ++ (other:Set<T>) -> Set<T>",
  "    removeAll(elems:Collection<T>)",
  "    removeAll(elems:Collection<T>)ifAbsent(action:Block0<Done>) -> Set<T>",
  "    onto(resultFactory:EmptyCollectionFactory<T>) -> Collection<T>",
  "    into(existing:Collection<Unknown>) -> Collection<Unknown>",
  "}",
  "",
  "type Dictionary<K,T> = Collection<T> & type {",
  "    size -> Number",
  "    containsKey(k:K) -> Boolean",
  "    containsValue(v:T) -> Boolean",
  "    contains(elem:T) -> Boolean",
  "    at(key:K)ifAbsent(action:Block0<Unknown>) -> Unknown",
  "    at(key:K)put(value:T) -> Dictionary<K,T>",
  "    []:= (k:K, v:T) -> Done",
  "    at(k:K) -> T",
  "    [] (k:K) -> T",
  "    removeAllKeys(keys:Collection<K>) -> Dictionary<K,T>",
  "    removeKey(*keys:K) -> Dictionary<K,T>",
  "    removeAllValues(removals:Collection<T>) -> Dictionary<K,T>",
  "    removeValue(*removals:T) -> Dictionary<K,T>",
  "    keys -> Enumerable<K>",
  "    values -> Enumerable<T>",
  "    bindings -> Enumerable<Binding<K,T>>",
  "    keysAndValuesDo(action:Block2<K,T,Done>) -> Done",
  "    keysDo(action:Block1<K,Done>) -> Done",
  "    valuesDo(action:Block1<T,Done>) -> Done",
  "    == (other:Object) -> Boolean",
  "    copy -> Dictionary<K,T>",
  "    ++ (other:Dictionary<K, T>) -> Dictionary<K, T>",
  "    -- (other:Dictionary<K, T>) -> Dictionary<K, T>",
  "    asDictionary -> Dictionary<K, T>",
  "}",
  "",
  "type Iterator<T> = type {",
  "    hasNext -> Boolean",
  "    next -> T",
  "}",
  "",
  "type CollectionFactory<T> = type {",
  "    withAll (elts:Collection<T>) -> Collection<T>",
  "    with (*elts:Object) -> Collection<T>",
  "    empty -> Collection<T>",
  "}",
  "",
  "type EmptyCollectionFactory<T> = type {",
  "    empty -> Collection<T>",
  "}",
  "",
  "class collectionFactory.trait<T> {",
  "    method withAll(elts:Collection<T>) -> Collection<T> { abstract }",
  "    method with(*a:T) -> Unknown { self.withAll(a) }",
  "    method empty -> Unknown { self.with() }",
  "}",
  "",
  "factory method lazySequenceOver<T,R>(source:Collection<T>)",
  "        mappedBy(function:Block1<T,R>) -> Enumerable<R> is confidential {",
  "    inherits enumerable.trait<T>",
  "    factory method iterator {",
  "        def sourceIterator = source.iterator",
  "        method asString { \"an iterator over a lazy map sequence\" }",
  "        method hasNext { sourceIterator.hasNext }",
  "        method next { function.apply(sourceIterator.next) }",
  "    }",
  "    method size { source.size }",
  "    method isEmpty { source.isEmpty }",
  "    method asDebugString { \"a lazy sequence mapping over {source}\" }",
  "}",
  "",
  "factory method lazySequenceOver<T>(source:Collection<T>)",
  "        filteredBy(predicate:Block1<T,Boolean>) -> Enumerable<T> is confidential {",
  "    inherits enumerable.trait<T>",
  "    factory method iterator {",
  "        var cache",
  "        var cacheLoaded := false",
  "        def sourceIterator = source.iterator",
  "        method asString { \"an iterator over filtered {source}\" }",
  "        method hasNext {",
  "        // To determine if this iterator has a next element, we have to find",
  "        // an acceptable element; this is then cached, for the use of next",
  "            if (cacheLoaded) then { return true }",
  "            try {",
  "                cache := nextAcceptableElement",
  "                cacheLoaded := true",
  "            } catch { ex:Exhausted -> return false }",
  "            return true",
  "        }",
  "        method next {",
  "            if (cacheLoaded.not) then { cache := nextAcceptableElement }",
  "            cacheLoaded := false",
  "            return cache",
  "        }",
  "        method nextAcceptableElement is confidential {",
  "        // return the next element of the underlying iterator satisfying",
  "        // predicate; if there is none, raises Exhausted.",
  "            while { true } do {",
  "                def outerNext = sourceIterator.next",
  "                def acceptable = predicate.apply(outerNext)",
  "                if (acceptable) then { return outerNext }",
  "            }",
  "        }",
  "    }",
  "    method asDebugString { \"a lazy sequence filtering {source}\" }",
  "}",
  "factory method iteratorConcat<T>(left:Iterator<T>, right:Iterator<T>) {",
  "    method next {",
  "        if (left.hasNext) then {",
  "            left.next",
  "        } else {",
  "            right.next",
  "        }",
  "    }",
  "    method hasNext {",
  "        if (left.hasNext) then { return true }",
  "        return right.hasNext",
  "    }",
  "    method asDebugString { \"iteratorConcat of {left} and {right}\" }",
  "    method asString { \"an iterator over a concatenation\" }",
  "}",
  "factory method lazyConcatenation<T>(left, right) -> Enumerable<T>{",
  "    inherits enumerable.trait<T>",
  "    method iterator {",
  "        iteratorConcat(left.iterator, right.iterator)",
  "    }",
  "    method asDebugString { \"lazy concatenation of {left} and {right}\" }",
  "    method asString { super.asString }",
  "    method size { left.size + right.size }  // may raise SizeUnknown",
  "}",
  "",
  "class collection.trait<T> {",
  "    method do { abstract }",
  "    method iterator { abstract }",
  "    method isEmpty {",
  "        // override if size is known",
  "        iterator.hasNext.not",
  "    }",
  "    method do(block1) separatedBy(block0) {",
  "        var firstTime := true",
  "        var i := 0",
  "        self.do { each ->",
  "            if (firstTime) then {",
  "                firstTime := false",
  "            } else {",
  "                block0.apply",
  "            }",
  "            block1.apply(each)",
  "        }",
  "        return self",
  "    }",
  "    method reduce(initial, blk) {",
  "    // deprecated; for compatibility with builtInList",
  "        fold(blk)startingWith(initial)",
  "    }",
  "    method fold(blk)startingWith(initial) {",
  "        var result := initial",
  "        self.do {it ->",
  "            result := blk.apply(result, it)",
  "        }",
  "        return result",
  "    }",
  "    method map<R>(block1:Block1<T,R>) -> Enumerable<R> {",
  "        lazySequenceOver(self) mappedBy(block1)",
  "    }",
  "    method filter(selectionCondition:Block1<T,Boolean>) -> Enumerable<T> {",
  "        lazySequenceOver(self) filteredBy(selectionCondition)",
  "    }",
  "",
  "    method iter { self.iterator }",
  "",
  "    method asSequence {",
  "        sequence.withAll(self)",
  "    }",
  "    method asList {",
  "        list.withAll(self)",
  "    }",
  "    method asSet {",
  "        set.withAll(self)",
  "    }",
  "}",
  "",
  "class enumerable.trait<T> {",
  "    inherits collection.trait<T>",
  "    method iterator { abstract }",
  "    method size {",
  "        // override if size is known",
  "        SizeUnknown.raise \"size requested on {asDebugString}\"",
  "    }",
  "    method asDictionary {",
  "        def result = dictionary.empty",
  "        keysAndValuesDo { k, v ->",
  "            result.at(k) put(v)",
  "        }",
  "        return result",
  "    }",
  "    method onto(f: CollectionFactory<T>) -> Collection<T> {",
  "        f.withAll(self)",
  "    }",
  "    method into(existing: Collection<T>) -> Collection<T> {",
  "        def selfIterator = self.iterator",
  "        while {selfIterator.hasNext} do {",
  "            existing.add(selfIterator.next)",
  "        }",
  "        existing",
  "    }",
  "    method ==(other) {",
  "        // there are 6 copies of this method!  Do we need traits!",
  "        match (other)",
  "            case {o:Collection ->",
  "                def selfIter = self.iterator",
  "                def otherIter = other.iterator",
  "                while {selfIter.hasNext && otherIter.hasNext} do {",
  "                    if (selfIter.next != otherIter.next) then {",
  "                        return false",
  "                    }",
  "                }",
  "                def result = selfIter.hasNext == otherIter.hasNext",
  "                return result",
  "            }",
  "            case {_ ->",
  "                return false",
  "            }",
  "    }",
  "    method do(block1:Block1<T,Done>) -> Done {",
  "        def selfIterator = self.iterator",
  "        while {selfIterator.hasNext} do {",
  "            block1.apply(selfIterator.next)",
  "        }",
  "    }",
  "    method keysAndValuesDo(block2:Block2<Number,T,Done>) -> Done {",
  "        var ix := 0",
  "        def selfIterator = self.iterator",
  "        while {selfIterator.hasNext} do {",
  "            ix := ix + 1",
  "            block2.apply(ix, selfIterator.next)",
  "        }",
  "    }",
  "    method values -> Collection<T> {",
  "        self",
  "    }",
  "    method fold<R>(block2)startingWith(initial) -> R {",
  "        var res := initial",
  "        def selfIterator = self.iterator",
  "        while { selfIterator.hasNext } do {",
  "            res := block2.apply(res, selfIterator.next)",
  "        }",
  "        return res",
  "    }",
  "    method ++ (other) -> Enumerable<T> {",
  "        lazyConcatenation(self, other)",
  "    }",
  "    method sortedBy(sortBlock:Block2) -> List<T> {",
  "        self.asList.sortBy(sortBlock:Block2)",
  "    }",
  "    method sorted -> List<T> {",
  "        self.asList.sort",
  "    }",
  "    method asString {",
  "        var s := \"⟨\"",
  "        do { each -> s := s ++ each.asString } separatedBy { s := s ++ \", \" }",
  "        s ++ \"⟩\"",
  "    }",
  "}",
  "",
  "class indexable.trait<T> {",
  "    inherits collection.trait<T>",
  "    method at { abstract }",
  "    method size { abstract }",
  "    method isEmpty { size == 0 }",
  "    method keysAndValuesDo(action:Block2<Number,T,Done>) -> Done {",
  "        def curSize = size",
  "        var i := 1",
  "        while {i <= curSize} do {",
  "            action.apply(i, self.at(i))",
  "            i := i + 1",
  "        }",
  "    }",
  "    method first { at(1) }",
  "    method second { at(2) }",
  "    method third { at(3) }",
  "    method fourth { at(4) }",
  "    method fifth { at(5) }",
  "    method last { at(size) }",
  "    method [](ix) { at(ix) }",
  "    method indices { range.from 1 to(size) }",
  "    method indexOf(sought:T)  {",
  "        indexOf(sought) ifAbsent { NoSuchObject.raise \"{sought} not in collection\" }",
  "    }",
  "    method indexOf(sought:T) ifAbsent(action:Block0)  {",
  "        keysAndValuesDo { ix, v ->",
  "            if (v == sought) then { return ix }",
  "        }",
  "        action.apply",
  "    }",
  "    method asDictionary {",
  "        def result = dictionary.empty",
  "        keysAndValuesDo { k, v ->",
  "            result.at(k) put(v)",
  "        }",
  "        return result",
  "    }",
  "    method onto(f: CollectionFactory<T>) -> Collection<T> {",
  "        f.withAll(self)",
  "    }",
  "    method into(existing: Collection<T>) -> Collection<T> {",
  "        def selfIterator = self.iterator",
  "        while {selfIterator.hasNext} do {",
  "            existing.add(selfIterator.next)",
  "        }",
  "        existing",
  "    }",
  "}",
  "",
  "method max(a,b) is confidential {",
  "    if (a > b) then { a } else { b }",
  "}",
  "",
  "factory method sequence<T> {",
  "    inherits collectionFactory.trait<T>",
  "",
  "    method withAll(*a:Collection) {",
  "        var forecastSize := 0",
  "        var sizeUncertain := false",
  "        // size might be uncertain if one of the arguments is a lazy collection.",
  "        for (a) do { arg ->",
  "            try {",
  "                forecastSize := forecastSize + arg.size",
  "            } catch { _:SizeUnknown ->",
  "                forecastSize := forecastSize + 8",
  "                sizeUncertain := true",
  "            }",
  "        }",
  "        var inner := _prelude.PrimitiveArray.new(forecastSize)",
  "        var innerSize := inner.size",
  "        var ix := 0",
  "        if (sizeUncertain) then {",
  "            // less-than-optimal path",
  "            for (a) do { arg ->",
  "                for (arg) do { elt ->",
  "                    if (innerSize <= ix) then {",
  "                        def newInner = _prelude.PrimitiveArray.new(innerSize*2)",
  "                        for (0..(innerSize-1)) do { i ->",
  "                            newInner.at(i)put(inner.at(i))",
  "                        }",
  "                        inner := newInner",
  "                        innerSize := inner.size",
  "                    }",
  "                    inner.at(ix)put(elt)",
  "                    ix := ix + 1",
  "                }",
  "            }",
  "        } else {",
  "            // common, fast path",
  "            for (a) do { arg ->",
  "                for (arg) do { elt ->",
  "                    inner.at(ix)put(elt)",
  "                    ix := ix + 1",
  "                }",
  "            }",
  "        }",
  "        self.fromPrimitiveArray(inner, ix)",
  "    }",
  "    method fromPrimitiveArray(pArray, sz) is confidential {",
  "        object {",
  "            inherits indexable.trait",
  "            var mods:Number is readable := 0",
  "            def size is public = sz",
  "            def inner = pArray",
  "",
  "            method boundsCheck(n) is confidential {",
  "                if (!(n >= 1) || !(n <= size)) then {",
  "                    // the condition is written this way because NaN always",
  "                    // compares false",
  "                    BoundsError.raise \"index {n} out of bounds 1..{size}\"",
  "                }",
  "            }",
  "            method at(n) {",
  "                boundsCheck(n)",
  "                inner.at(n-1)",
  "            }",
  "            method [](n) {",
  "                boundsCheck(n)",
  "                inner.at(n-1)",
  "            }",
  "            method keys {",
  "                range.from(1)to(size)",
  "            }",
  "            method values {",
  "                self",
  "            }",
  "            method keysAndValuesDo(block2) {",
  "                var i := 0",
  "                while {i < size} do {",
  "                    block2.apply(i+1, inner.at(i))",
  "                    i := i + 1",
  "                }",
  "            }",
  "            method reversed {",
  "                def freshArray = _prelude.PrimitiveArray.new(size)",
  "                var ix := size - 1",
  "                do { each ->",
  "                    freshArray.at (ix) put(each)",
  "                    ix := ix - 1",
  "                }",
  "                outer.fromPrimitiveArray(freshArray, size)",
  "            }",
  "            method ++(other:Collection) {",
  "                sequence.withAll(self, other)",
  "            }",
  "            method asString {",
  "                var s := \"⟨\"",
  "                for (0..(size-1)) do {i->",
  "                    s := s ++ inner.at(i).asString",
  "                    if (i < (size-1)) then { s := s ++ \", \" }",
  "                }",
  "                s ++ \"⟩\"",
  "            }",
  "            method contains(element) {",
  "                do { each -> if (each == element) then { return true } }",
  "                return false",
  "            }",
  "            method do(block1) {",
  "                var i := 0",
  "                while {i < size} do {",
  "                    block1.apply(inner.at(i))",
  "                    i := i + 1",
  "                }",
  "            }",
  "            method ==(other) {",
  "                // there are 6 copies of this method!  Do we need traits!",
  "                match (other)",
  "                    case {o:Collection ->",
  "                        def selfIter = self.iterator",
  "                        def otherIter = other.iterator",
  "                        while {selfIter.hasNext && otherIter.hasNext} do {",
  "                            if (selfIter.next != otherIter.next) then {",
  "                                return false",
  "                            }",
  "                        }",
  "                        return selfIter.hasNext == otherIter.hasNext",
  "                    }",
  "                    case {_ ->",
  "                        return false",
  "                    }",
  "            }",
  "            method iterator {",
  "                object {",
  "                    var imods:Number := mods",
  "                    var idx := 1",
  "                    method asDebugString { \"{asString}⟪{idx}⟫\" }",
  "                    method asString { \"aSequenceIterator\" }",
  "                    method hasNext { idx <= sz }",
  "                    method next {",
  "                        if (imods != mods) then { ConcurrentModification.raise (asDebugString) }",
  "                        if (idx > sz) then { Exhausted.raise \"on sequence {outer}⟪{idx}⟫\" }",
  "                        def ret = at(idx)",
  "                        idx := idx + 1",
  "                        ret",
  "                    }",
  "                }",
  "            }",
  "            method sorted {",
  "                asList.sortBy { l, r ->",
  "                    if (l == r) then {0}",
  "                        elseif (l < r) then {-1}",
  "                        else {1}",
  "                }.asSequence",
  "            }",
  "            method sortedBy(sortBlock:Block2){",
  "                asList.sortBy(sortBlock:Block2).asSequence",
  "            }",
  "        }",
  "    }",
  "}",
  "",
  "factory method list<T> {",
  "    inherits collectionFactory.trait<T>",
  "",
  "    method withAll(a:Collection<T>) -> List<T> {",
  "        if (engine == \"js\") then {",
  "            return object {",
  "                inherits indexable.trait<T>",
  "",
  "                var mods:Number is readable := 0",
  "                var sz := 0",
  "                var jsArray := native \"js\" code ‹var result = [];›",
  "                a.do { each ->",
  "                    native \"js\" code ‹superDepth.data.jsArray.push(var_each);›",
  "                }",
  "",
  "",
  "                method boundsCheck(n) is confidential {",
  "                    native \"js\" code ‹var ix = var_n._value;",
  "                      if ( !(ix >= 1) || !(ix <= superDepth.data.jsArray.length)) {",
  "                          var msg = \"index \" + ix + \" out of bounds 1..\" + superDepth.data.jsArray.length;",
  "                          var BoundsError = callmethod(Grace_prelude, \"BoundsError\", [0]);",
  "                          callmethod(BoundsError,\"raise\", [1], new GraceString(msg));",
  "                      }›",
  "                    if (!(n >= 1) || ! (n <= size)) then {",
  "                        BoundsError.raise \"index {n} out of bounds 1..{size}\"",
  "                    }",
  "                }",
  "",
  "",
  "                method size {",
  "                    native \"js\" code ‹return new GraceNum(superDepth.data.jsArray.length)›",
  "                    sz",
  "                }",
  "",
  "                method at(n) {",
  "                    native \"js\" code ‹var ix = var_n._value;",
  "                        if ( !(ix >= 1) || !(ix <= superDepth.data.jsArray.length)) {",
  "                            var msg = \"index \" + ix + \" out of bounds 1..\" + superDepth.data.jsArray.length;",
  "                            var BoundsError = callmethod(Grace_prelude, \"BoundsError\", [0]);",
  "                            callmethod(BoundsError, \"raise\", [1], new GraceString(msg));",
  "                        }",
  "                        return superDepth.data.jsArray[ix - 1];›",
  "                }",
  "",
  "                method [](n) {",
  "                    native \"js\" code ‹var ix = var_n._value;",
  "                        if ( !(ix >= 1) || !(ix <= superDepth.data.jsArray.length)) {",
  "                            var msg = \"index \" + ix + \" out of bounds 1..\" + superDepth.data.jsArray.length;",
  "                            var BoundsError = callmethod(Grace_prelude, \"BoundsError\", [0]);",
  "                            callmethod(BoundsError, \"raise\", [1], new GraceString(msg));",
  "                        }",
  "                        return superDepth.data.jsArray[ix - 1];›",
  "                }",
  "",
  "                method at(n)put(x) {",
  "                    mods := mods + 1",
  "                    native \"js\" code ‹var  ix = var_n._value;",
  "                        if (!(ix >= 1) || !(ix <= superDepth.data.jsArray.length + 1)) {",
  "                            var msg = \"index \" + ix + \" out of bounds 1..\" + superDepth.data.jsArray.length;",
  "                            var BoundsError = callmethod(Grace_prelude, \"BoundsError\", [0]);",
  "                            callmethod(BoundsError, \"raise\", [1], new GraceString(msg));",
  "                        }",
  "                        superDepth.data.jsArray[ix-1] = var_x;",
  "                        return this;›",
  "                }",
  "",
  "                method []:=(n, x) {",
  "                    mods := mods + 1",
  "                    native \"js\" code ‹var ix = var_n._value;",
  "                        if (!(ix >= 1) || !(ix <= superDepth.data.jsArray.length + 1)) {",
  "                            var msg = \"index \" + ix + \" out of bounds 1..\" + superDepth.data.jsArray.length;",
  "                            var BoundsError = callmethod(Grace_prelude, \"BoundsError\", [0]);",
  "                            callmethod(BoundsError, \"raise\", [1], new GraceString(msg));",
  "                        }",
  "                        superDepth.data.jsArray[ix-1] = var_x;",
  "                        return GraceDone;›",
  "                }",
  "",
  "                method add(*x) {",
  "                    mods := mods + 1",
  "                    if (x.size == 1) then {",
  "                        native \"js\" code ‹var v = callmethod(var_x, \"first\", [0]);",
  "                        superDepth.data.jsArray.push(v);",
  "                        return this;›",
  "                    }",
  "                    addAll(x)",
  "                }",
  "",
  "                method push(x) {",
  "                    mods := mods + 1",
  "                    native \"js\" code ‹superDepth.data.jsArray.push(var_x);",
  "                        return this;›",
  "                }",
  "",
  "                method removeLast {",
  "                    mods := mods + 1",
  "                    native \"js\" code ‹if (superDepth.data.jsArray.length === 0) {",
  "                        var msg = \"you can't remove an element from an empty list\";",
  "                        var BoundsError = callmethod(Grace_prelude, \"BoundsError\", [0]);",
  "                        callmethod(BoundsError, \"raise\", [1], new GraceString(msg));",
  "                    } else",
  "                        return superDepth.data.jsArray.pop();›",
  "                }",
  "",
  "                method addAllFirst(l) {",
  "                    mods := mods + 1",
  "                    var ix := l.size;",
  "                    while {ix > 0} do {",
  "                        def each = l.at(ix)",
  "                        ix := ix - 1",
  "                        native \"js\" code ‹superDepth.data.jsArray.unshift(var_each);›",
  "                    }",
  "                    self",
  "                }",
  "",
  "                method removeAt(n) {",
  "                    mods := mods + 1",
  "                    def removed = self.at(n)    // does the bounds check",
  "                    native \"js\" code ‹superDepth.data.jsArray.splice(var_n._value - 1, 1);›",
  "                    return removed",
  "                }",
  "",
  "                method sortBy(sortBlock:Block2) {",
  "                    mods := mods + 1",
  "                    native \"js\" code ‹var compareFun = function compareFun(a, b) {",
  "                              var res = callmethod(var_sortBlock, \"apply\", [2], a, b);",
  "                              if (res.className == \"number\") return res._value;",
  "                              throw new GraceExceptionPacket(TypeErrorObject,",
  "                                     new GraceString(\"sort block in list.sortBy method did not return a number\"));",
  "                          }",
  "                          superDepth.data.jsArray.sort(compareFun);›",
  "                    self",
  "                }",
  "                // end of native methods",
  "",
  "",
  "                method addLast(*x) { addAll(x) }    // compatibility",
  "                method addAll(l) {",
  "                    for (l) do { each -> push(each) }",
  "                    self",
  "                }",
  "",
  "                method addFirst(*l) { addAllFirst(l) }",
  "",
  "",
  "                method removeFirst {",
  "                    removeAt(1)",
  "                }",
  "",
  "",
  "                method remove(*v:T) {",
  "                    removeAll(v)",
  "                }",
  "",
  "",
  "                method remove(*v:T) ifAbsent(action:Block0<Done>) {",
  "                    removeAll(v) ifAbsent (action)",
  "                }",
  "",
  "",
  "                method removeAll(vs: Collection<T>) {",
  "                    removeAll(vs) ifAbsent { NoSuchObject.raise \"object not in list\" }",
  "                }",
  "",
  "",
  "                method removeAll(vs: Collection<T>) ifAbsent(action:Block0<Done>)  {",
  "                    for (vs) do { each ->",
  "                        def ix = self.indexOf(each) ifAbsent {return action.apply}",
  "                        removeAt(ix)",
  "                    }",
  "                    self",
  "                }",
  "",
  "",
  "                method pop { removeLast }",
  "",
  "                method reversed {",
  "                    def result = list.empty",
  "                    do { each -> result.addFirst(each) }",
  "                    result",
  "                }",
  "                method reverse {",
  "                    mods := mods + 1",
  "                    var hiIx := size",
  "                    var loIx := 1",
  "                    while {loIx < hiIx} do {",
  "                        def hiVal = self.at(hiIx)",
  "                        self.at(hiIx) put (self.at(loIx))",
  "                        self.at(loIx) put (hiVal)",
  "                        hiIx := hiIx - 1",
  "                        loIx := loIx + 1",
  "                    }",
  "                    self",
  "                }",
  "",
  "                method ++(o) {",
  "                    def l = list.withAll(self)",
  "                    l.addAll(o)",
  "                }",
  "",
  "",
  "                method asString {",
  "                    var s := \"[\"",
  "                    def curSize = self.size",
  "                    for (1..curSize) do { i ->",
  "                        s := s ++ at(i).asString",
  "                        if (i < curSize) then { s := s ++ \", \" }",
  "                    }",
  "                    s ++ \"]\"",
  "                }",
  "",
  "",
  "                method extend(l) { addAll(l); done }    // compatibility",
  "",
  "",
  "                method contains(element) {",
  "                    do { each -> if (each == element) then { return true } }",
  "                    return false",
  "                }",
  "",
  "                method do(block1) {",
  "                    var i := 1",
  "                    def curSize = self.size",
  "                    while {i <= curSize} do {",
  "                        block1.apply(self.at(i))",
  "                        i := i + 1",
  "                    }",
  "                }",
  "",
  "                method ==(other) {",
  "                // there are 6 copies of this method!  Do we need traits!",
  "                    match (other)",
  "                        case {o:Collection ->",
  "                            def selfIter = self.iterator",
  "                            def otherIter = other.iterator",
  "                            while {selfIter.hasNext && otherIter.hasNext} do {",
  "                                if (selfIter.next != otherIter.next) then {",
  "                                    return false",
  "                                }",
  "                            }",
  "                            return selfIter.hasNext == otherIter.hasNext",
  "                        }",
  "                        case {_ ->",
  "                            return false",
  "                        }",
  "                }",
  "",
  "                method iterator {",
  "                    object {",
  "                        var imods := mods",
  "                        var idx := 1",
  "                        method asDebugString { \"{asString}⟪{idx}⟫\" }",
  "                        method asString { \"aListIterator\" }",
  "                        method hasNext { idx <= size }",
  "                        method next {",
  "                            if (imods != mods) then {",
  "                                ConcurrentModification.raise (asDebugString)",
  "                            }",
  "                            if (idx > size) then { Exhausted.raise \"on list\" }",
  "                            def ret = at(idx)",
  "                            idx := idx + 1",
  "                            ret",
  "                        }",
  "                    }",
  "                }",
  "",
  "                method values {",
  "                    self",
  "                }",
  "",
  "                method keys {",
  "                    self.indices",
  "                }",
  "",
  "                method sort {",
  "                    mods := mods + 1",
  "                    sortBy { l, r ->",
  "                        if (l == r) then {0}",
  "                            elseif (l < r) then {-1}",
  "                            else {1}",
  "                    }",
  "                }",
  "                method sortedBy(sortBlock:Block2) {",
  "                    copy.sortBy(sortBlock:Block2)",
  "                }",
  "                method sorted {",
  "                    copy.sort",
  "                }",
  "                method copy {",
  "                    outer.withAll(self)",
  "                }",
  "            }",
  "        }   // end of if (engine == \"js\") then ...",
  "",
  "        object {",
  "            // the new list object without native code",
  "            inherits indexable.trait<T>",
  "",
  "            var mods:Number is readable := 0",
  "            var initialSize",
  "            try { initialSize := a.size * 2 + 1 }",
  "                catch { _ex:SizeUnknown -> initialSize := 9 }",
  "            var inner := _prelude.PrimitiveArray.new(initialSize)",
  "            var size is readable := 0",
  "            for (a) do {x->",
  "                inner.at(size)put(x)",
  "                size := size + 1",
  "            }",
  "            method boundsCheck(n) is confidential {",
  "                if ( !(n >= 1) || !(n <= size)) then {",
  "                    BoundsError.raise \"index {n} out of bounds 1..{size}\"",
  "                }",
  "            }",
  "            method at(n) {",
  "                boundsCheck(n)",
  "                inner.at(n-1)",
  "            }",
  "            method [](n) {",
  "                boundsCheck(n)",
  "                inner.at(n-1)",
  "            }",
  "            method at(n)put(x) {",
  "                mods := mods + 1",
  "                if (n == (size+1)) then {",
  "                    addLast(x)",
  "                } else {",
  "                    boundsCheck(n)",
  "                    inner.at(n-1)put(x)",
  "                }",
  "                self",
  "            }",
  "            method []:=(n,x) {",
  "                mods := mods + 1",
  "                if (n == (size+1)) then {",
  "                    addLast(x)",
  "                } else {",
  "                    boundsCheck(n)",
  "                    inner.at(n-1)put(x)",
  "                }",
  "                done",
  "            }",
  "            method add(*x) {",
  "                addAll(x)",
  "            }",
  "            method addAll(l) {",
  "                mods := mods + 1",
  "                if ((size + l.size) > inner.size) then {",
  "                    expandTo(max(size + l.size, size * 2))",
  "                }",
  "                for (l) do {each ->",
  "                    inner.at(size)put(each)",
  "                    size := size + 1",
  "                }",
  "                self",
  "            }",
  "            method push(x) {",
  "                mods := mods + 1",
  "                if (size == inner.size) then { expandTo(inner.size * 2) }",
  "                inner.at(size)put(x)",
  "                size := size + 1",
  "                self",
  "            }",
  "            method addLast(*x) { addAll(x) }    // compatibility",
  "            method removeLast {",
  "                mods := mods + 1",
  "                def result = inner.at(size - 1)",
  "                size := size - 1",
  "                result",
  "            }",
  "            method addAllFirst(l) {",
  "                mods := mods + 1",
  "                def increase = l.size",
  "                if ((size + increase) > inner.size) then {",
  "                    expandTo(max(size + increase, size * 2))",
  "                }",
  "                for (range.from(size-1)downTo(0)) do {i->",
  "                    inner.at(i+increase)put(inner.at(i))",
  "                }",
  "                var insertionIndex := 0",
  "                for (l) do {each ->",
  "                    inner.at(insertionIndex)put(each)",
  "                    insertionIndex := insertionIndex + 1",
  "                }",
  "                size := size + increase",
  "                self",
  "            }",
  "            method addFirst(*l) { addAllFirst(l) }",
  "            method removeFirst {",
  "                removeAt(1)",
  "            }",
  "            method removeAt(n) {",
  "                mods := mods + 1",
  "                boundsCheck(n)",
  "                def removed = inner.at(n-1)",
  "                for (n..(size-1)) do {i->",
  "                    inner.at(i-1)put(inner.at(i))",
  "                }",
  "                size := size - 1",
  "                return removed",
  "            }",
  "            method remove(*v:T) {",
  "                removeAll(v)",
  "            }",
  "            method remove(*v:T) ifAbsent(action:Block0<Done>) {",
  "                removeAll(v) ifAbsent (action)",
  "            }",
  "            method removeAll(vs: Collection<T>) {",
  "                removeAll(vs) ifAbsent { NoSuchObject.raise \"object not in list\" }",
  "            }",
  "            method removeAll(vs: Collection<T>) ifAbsent(action:Block0<Done>)  {",
  "                mods := mods + 1",
  "                for (vs) do { each ->",
  "                    def ix = indexOf(each) ifAbsent {return action.apply}",
  "                    removeAt(ix)",
  "                }",
  "                self",
  "            }",
  "            method pop { removeLast }",
  "            method reversed {",
  "                def result = list.empty",
  "                do { each -> result.addFirst(each) }",
  "                result",
  "            }",
  "            method reverse {",
  "                mods := mods + 1",
  "                var hiIx := size",
  "                var loIx := 1",
  "                while {loIx < hiIx} do {",
  "                    def hiVal = self.at(hiIx)",
  "                    self.at(hiIx) put (self.at(loIx))",
  "                    self.at(loIx) put (hiVal)",
  "                    hiIx := hiIx - 1",
  "                    loIx := loIx + 1",
  "                }",
  "                self",
  "            }",
  "            method ++(o) {",
  "                def l = list.withAll(self)",
  "                l.addAll(o)",
  "            }",
  "            method asString {",
  "                var s := \"[\"",
  "                for (0..(size-1)) do {i->",
  "                    s := s ++ inner.at(i).asString",
  "                    if (i < (size-1)) then { s := s ++ \", \" }",
  "                }",
  "                s ++ \"]\"",
  "            }",
  "            method contains(element) {",
  "                do { each -> if (each == element) then { return true } }",
  "                return false",
  "            }",
  "            method do(block1) {",
  "                var i := 0",
  "                while {i < size} do {",
  "                    block1.apply(inner.at(i))",
  "                    i := i + 1",
  "                }",
  "            }",
  "",
  "            method ==(other) {",
  "                // there are 6 copies of this method!  Do we need traits!",
  "                match (other)",
  "                    case {o:Collection ->",
  "                        def selfIter = self.iterator",
  "                        def otherIter = other.iterator",
  "                        while {selfIter.hasNext && otherIter.hasNext} do {",
  "                            if (selfIter.next != otherIter.next) then {",
  "                                return false",
  "                            }",
  "                        }",
  "                        return selfIter.hasNext == otherIter.hasNext",
  "                    }",
  "                    case {_ ->",
  "                        return false",
  "                    }",
  "            }",
  "            method iterator {",
  "                object {",
  "                    var imods := mods",
  "                    var idx := 1",
  "                    method asDebugString { \"{asString}⟪{idx}⟫\" }",
  "                    method asString { \"aListIterator\" }",
  "                    method hasNext { idx <= size }",
  "                    method next {",
  "                        if (imods != mods) then {",
  "                            ConcurrentModification.raise (asDebugString)",
  "                        }",
  "                        if (idx > size) then { Exhausted.raise \"on list\" }",
  "                        def ret = at(idx)",
  "                        idx := idx + 1",
  "                        ret",
  "                    }",
  "                }",
  "            }",
  "            method values {",
  "                self",
  "            }",
  "            method keys {",
  "                self.indices",
  "            }",
  "            method expandTo(newSize) is confidential {",
  "                def newInner = _prelude.PrimitiveArray.new(newSize)",
  "                for (0..(size-1)) do {i->",
  "                    newInner.at(i)put(inner.at(i))",
  "                }",
  "                inner := newInner",
  "            }",
  "            method sortBy(sortBlock:Block2) {",
  "                mods := mods + 1",
  "                inner.sortInitial(size) by(sortBlock)",
  "                self",
  "            }",
  "            method sort {",
  "                sortBy { l, r ->",
  "                    if (l == r) then {0}",
  "                        elseif (l < r) then {-1}",
  "                        else {1}",
  "                }",
  "            }",
  "            method sortedBy(sortBlock:Block2) {",
  "                copy.sortBy(sortBlock:Block2)",
  "            }",
  "            method sorted {",
  "                copy.sort",
  "            }",
  "            method copy {",
  "                outer.withAll(self)",
  "            }",
  "        }",
  "    }",
  "}",
  "factory method set<T> {",
  "    inherits collectionFactory.trait<T>",
  "",
  "    method withAll(a:Collection<T>) -> Set<T> {",
  "        object {",
  "            inherits collection.trait",
  "            var mods:Number is readable := 0",
  "            var initialSize",
  "            try { initialSize := max(a.size * 3 + 1, 8) }",
  "                catch { _:SizeUnknown -> initialSize := 8 }",
  "            var inner := _prelude.PrimitiveArray.new(initialSize)",
  "            def unused = object {",
  "                var unused := true",
  "                method asString { \"unused\" }",
  "            }",
  "            def removed = object {",
  "                var removed := true",
  "                method asString { \"removed\" }",
  "            }",
  "            var size is readable := 0",
  "            for (0..(initialSize - 1)) do {i->",
  "                inner.at(i)put(unused)",
  "            }",
  "            for (a) do { x-> add(x) }",
  "",
  "            method addAll(elements) {",
  "                mods := mods + 1",
  "                for (elements) do { x ->",
  "                    if (! contains(x)) then {",
  "                        def t = findPositionForAdd(x)",
  "                        inner.at(t)put(x)",
  "                        size := size + 1",
  "                        if (size > (inner.size / 2)) then {",
  "                            expand",
  "                        }",
  "                    }",
  "                }",
  "                self    // for chaining",
  "            }",
  "",
  "            method add(*elements) { addAll(elements) }",
  "",
  "            method removeAll(elements) {",
  "                for (elements) do { x ->",
  "                    remove (x) ifAbsent {",
  "                        NoSuchObject.raise \"set does not contain {x}\"",
  "                    }",
  "                }",
  "                self    // for chaining",
  "            }",
  "            method removeAll(elements)ifAbsent(block) {",
  "                mods := mods + 1",
  "                for (elements) do { x ->",
  "                    var t := findPosition(x)",
  "                    if (inner.at(t) == x) then {",
  "                        inner.at(t) put (removed)",
  "                        size := size - 1",
  "                    } else {",
  "                        block.apply",
  "                    }",
  "                }",
  "                self    // for chaining",
  "            }",
  "",
  "            method remove(*elements)ifAbsent(block) {",
  "                removeAll(elements) ifAbsent(block)",
  "            }",
  "",
  "            method remove(*elements) {",
  "                removeAll(elements)",
  "            }",
  "",
  "            method contains(x) {",
  "                var t := findPosition(x)",
  "                if (inner.at(t) == x) then {",
  "                    return true",
  "                }",
  "                return false",
  "            }",
  "            method includes(booleanBlock) {",
  "                self.do { each ->",
  "                    if (booleanBlock.apply(each)) then { return true }",
  "                }",
  "                return false",
  "            }",
  "            method find(booleanBlock)ifNone(notFoundBlock) {",
  "                self.do { each ->",
  "                    if (booleanBlock.apply(each)) then { return each }",
  "                }",
  "                return notFoundBlock.apply",
  "            }",
  "            method findPosition(x) is confidential {",
  "                def h = x.hash",
  "                def s = inner.size",
  "                var t := h % s",
  "                var jump := 5",
  "                var candidate",
  "                while {",
  "                    candidate := inner.at(t)",
  "                    candidate != unused",
  "                } do {",
  "                    if (candidate == x) then {",
  "                        return t",
  "                    }",
  "                    if (jump != 0) then {",
  "                        t := (t * 3 + 1) % s",
  "                        jump := jump - 1",
  "                    } else {",
  "                        t := (t + 1) % s",
  "                    }",
  "                }",
  "                return t",
  "            }",
  "            method findPositionForAdd(x) is confidential {",
  "                def h = x.hash",
  "                def s = inner.size",
  "                var t := h % s",
  "                var jump := 5",
  "                var candidate",
  "                while {",
  "                    candidate := inner.at(t)",
  "                    (candidate != unused).andAlso{candidate != removed}",
  "                } do {",
  "                    if (candidate == x) then {",
  "                        return t",
  "                    }",
  "                    if (jump != 0) then {",
  "                        t := (t * 3 + 1) % s",
  "                        jump := jump - 1",
  "                    } else {",
  "                        t := (t + 1) % s",
  "                    }",
  "                }",
  "                return t",
  "            }",
  "",
  "            method asString {",
  "                var s := \"set\\{\"",
  "                do {each -> s := s ++ each.asString }",
  "                    separatedBy { s := s ++ \", \" }",
  "                s ++ \"\\}\"",
  "            }",
  "            method extend(l) {",
  "                for (l) do {i->",
  "                    add(i)",
  "                }",
  "            }",
  "            method do(block1) {",
  "                var i := 0",
  "                var found := 0",
  "                var candidate",
  "                while {found < size} do {",
  "                    candidate := inner.at(i)",
  "                    if ((candidate != unused).andAlso{candidate != removed}) then {",
  "                        found := found + 1",
  "                        block1.apply(candidate)",
  "                    }",
  "                    i := i + 1",
  "                }",
  "            }",
  "            method iterator {",
  "                object {",
  "                    var imods:Number := mods",
  "                    var count := 1",
  "                    var idx := -1",
  "                    method hasNext { size >= count }",
  "                    method next {",
  "                        var candidate",
  "                        def innerSize = inner.size",
  "                        while {",
  "                            idx := idx + 1",
  "                            if (imods != mods) then {",
  "                                ConcurrentModification.raise (outer.asString)",
  "                            }",
  "                            if (idx >= innerSize) then {",
  "                                Exhausted.raise \"iterator over {outer.asString}\"",
  "                            }",
  "                            candidate := inner.at(idx)",
  "                            (candidate == unused).orElse{candidate == removed}",
  "                        } do { }",
  "                        count := count + 1",
  "                        candidate",
  "                    }",
  "                }",
  "            }",
  "",
  "            method expand is confidential {",
  "                def c = inner.size",
  "                def n = c * 2",
  "                def oldInner = inner",
  "                size := 0",
  "                inner := _prelude.PrimitiveArray.new(n)",
  "                for (0..(inner.size-1)) do {i->",
  "                    inner.at(i)put(unused)",
  "                }",
  "                for (0..(oldInner.size-1)) do {i->",
  "                    if ((oldInner.at(i) != unused).andAlso{oldInner.at(i) != removed}) then {",
  "                        add(oldInner.at(i))",
  "                    }",
  "                }",
  "            }",
  "            method ==(other) {",
  "                match (other)",
  "                    case {o:Collection ->",
  "                        var oSize := 0",
  "                        o.do { each ->",
  "                            oSize := oSize + 1",
  "                            if (! self.contains(each)) then {",
  "                                return false",
  "                            }",
  "                        }",
  "                        return oSize == self.size",
  "                    }",
  "                    case {_ ->",
  "                        return false",
  "                    }",
  "            }",
  "            method copy {",
  "                outer.withAll(self)",
  "            }",
  "            method ++ (other) {",
  "            // set union",
  "                copy.addAll(other)",
  "            }",
  "            method -- (other) {",
  "            // set difference",
  "                def result = set.empty",
  "                for (self) do {v->",
  "                    if (!other.contains(v)) then {",
  "                        result.add(v)",
  "                    }",
  "                }",
  "                result",
  "            }",
  "            method ** (other) {",
  "            // set intersection",
  "                (filter {each -> other.contains(each)}).asSet",
  "            }",
  "            method onto(f: CollectionFactory<T>) -> Collection<T> {",
  "                f.withAll(self)",
  "            }",
  "            method into(existing: Collection<T>) -> Collection<T> {",
  "                do { each -> existing.add(each) }",
  "                existing",
  "            }",
  "        }",
  "    }",
  "}",
  "",
  "type Binding<K,T> = {",
  "    key -> K",
  "    value -> T",
  "    hash -> Number",
  "    == -> Boolean",
  "}",
  "",
  "class binding.key(k)value(v) {",
  "    method key {k}",
  "    method value {v}",
  "    method asString { \"{k}::{v}\" }",
  "    method hashcode { (k.hashcode * 1021) + v.hashcode }",
  "    method hash { (k.hash * 1021) + v.hash }",
  "    method == (other) {",
  "        match (other)",
  "            case {o:Binding -> (k == o.key) && (v == o.value) }",
  "            case {_ -> return false }",
  "    }",
  "}",
  "",
  "factory method dictionary<K,T> {",
  "    inherits collectionFactory.trait<T>",
  "    method at(k:K)put(v:T) {",
  "            self.empty.at(k)put(v)",
  "    }",
  "    method withAll(initialBindings:Collection<Binding<K,T>>) -> Dictionary<K,T> {",
  "        object {",
  "            inherits collection.trait<T>",
  "            var mods:Number is readable := 0",
  "            var numBindings := 0",
  "            var inner := _prelude.PrimitiveArray.new(8)",
  "            def unused = object {",
  "                var unused := true",
  "                def key is public = self",
  "                def value is public = self",
  "                method asString { \"unused\" }",
  "            }",
  "            def removed = object {",
  "                var removed := true",
  "                def key is public = self",
  "                def value is public = self",
  "                method asString { \"removed\" }",
  "            }",
  "            for (0..(inner.size-1)) do {i->",
  "                inner.at(i)put(unused)",
  "            }",
  "            for (initialBindings) do { b -> at(b.key)put(b.value) }",
  "            method size { numBindings }",
  "            method at(key')put(value') {",
  "                mods := mods + 1",
  "                var t := findPositionForAdd(key')",
  "                if ((inner.at(t) == unused).orElse{inner.at(t) == removed}) then {",
  "                    numBindings := numBindings + 1",
  "                }",
  "                inner.at(t)put(binding.key(key')value(value'))",
  "                if ((size * 2) > inner.size) then { expand }",
  "                self    // for chaining",
  "            }",
  "            method []:=(k, v) {",
  "                at(k)put(v)",
  "                done",
  "            }",
  "            method at(k) {",
  "                var b := inner.at(findPosition(k))",
  "                if (b.key == k) then {",
  "                    return b.value",
  "                }",
  "                NoSuchObject.raise \"dictionary does not contain entry with key {k}\"",
  "            }",
  "            method at(k) ifAbsent(action) {",
  "                var b := inner.at(findPosition(k))",
  "                if (b.key == k) then {",
  "                    return b.value",
  "                }",
  "                return action.apply",
  "            }",
  "            method [](k) { at(k) }",
  "            method containsKey(k) {",
  "                var t := findPosition(k)",
  "                if (inner.at(t).key == k) then {",
  "                    return true",
  "                }",
  "                return false",
  "            }",
  "            method removeAllKeys(keys) {",
  "                mods := mods + 1",
  "                for (keys) do { k ->",
  "                    var t := findPosition(k)",
  "                    if (inner.at(t).key == k) then {",
  "                        inner.at(t)put(removed)",
  "                        numBindings := numBindings - 1",
  "                    } else {",
  "                        NoSuchObject.raise \"dictionary does not contain entry with key {k}\"",
  "                    }",
  "                }",
  "                return self",
  "            }",
  "            method removeKey(*keys) {",
  "                removeAllKeys(keys)",
  "            }",
  "            method removeAllValues(removals) {",
  "                mods := mods + 1",
  "                for (0..(inner.size-1)) do {i->",
  "                    def a = inner.at(i)",
  "                    if (removals.contains(a.value)) then {",
  "                        inner.at(i)put(removed)",
  "                        numBindings := numBindings - 1",
  "                    }",
  "                }",
  "                return self",
  "            }",
  "            method removeValue(*removals) {",
  "                removeAllValues(removals)",
  "            }",
  "            method containsValue(v) {",
  "                self.valuesDo{ each ->",
  "                    if (v == each) then { return true }",
  "                }",
  "                return false",
  "            }",
  "            method contains(v) { containsValue(v) }",
  "            method findPosition(x) is confidential {",
  "                def h = x.hash",
  "                def s = inner.size",
  "                var t := h % s",
  "                var jump := 5",
  "                while {inner.at(t) != unused} do {",
  "                    if (inner.at(t).key == x) then {",
  "                        return t",
  "                    }",
  "                    if (jump != 0) then {",
  "                        t := (t * 3 + 1) % s",
  "                        jump := jump - 1",
  "                    } else {",
  "                        t := (t + 1) % s",
  "                    }",
  "                }",
  "                return t",
  "            }",
  "            method findPositionForAdd(x) is confidential {",
  "                def h = x.hash",
  "                def s = inner.size",
  "                var t := h % s",
  "                var jump := 5",
  "                while {(inner.at(t) != unused).andAlso{inner.at(t) != removed}} do {",
  "                    if (inner.at(t).key == x) then {",
  "                        return t",
  "                    }",
  "                    if (jump != 0) then {",
  "                        t := (t * 3 + 1) % s",
  "                        jump := jump - 1",
  "                    } else {",
  "                        t := (t + 1) % s",
  "                    }",
  "                }",
  "                return t",
  "            }",
  "            method asString {",
  "                // do()separatedBy won't work, because it iterates over values,",
  "                // and we need an iterator over bindings.",
  "                var s := \"dict⟬\"",
  "                var firstElement := true",
  "                for (0..(inner.size-1)) do {i->",
  "                    def a = inner.at(i)",
  "                    if ((a != unused) && (a != removed)) then {",
  "                        if (! firstElement) then {",
  "                            s := s ++ \", \"",
  "                        } else {",
  "                            firstElement := false",
  "                        }",
  "                        s := s ++ \"{a.key}::{a.value}\"",
  "                    }",
  "                }",
  "                s ++ \"⟭\"",
  "            }",
  "            method asDebugString {",
  "                var s := \"dict⟬\"",
  "                for (0..(inner.size-1)) do {i->",
  "                    if (i > 0) then { s := s ++ \", \" }",
  "                    def a = inner.at(i)",
  "                    if ((a != unused) && (a != removed)) then {",
  "                        s := s ++ \"{i}→{a.key}::{a.value}\"",
  "                    } else {",
  "                        s := s ++ \"{i}→{a.asDebugString}\"",
  "                    }",
  "                }",
  "                s ++ \"⟭\"",
  "            }",
  "            method keys -> Enumerable<K> {",
  "                def sourceDictionary = self",
  "                object {",
  "                    inherits enumerable.trait<K>",
  "                    factory method iterator {",
  "                        def sourceIterator = sourceDictionary.bindingsIterator",
  "                        method hasNext { sourceIterator.hasNext }",
  "                        method next { sourceIterator.next.key }",
  "                        method asString {",
  "                            \"an iterator over keys of {sourceDictionary}\"",
  "                        }",
  "                    }",
  "                    def size is public = sourceDictionary.size",
  "                    method asDebugString {",
  "                        \"a lazy sequence over keys of {sourceDictionary}\"",
  "                    }",
  "                }",
  "            }",
  "            method values -> Enumerable<T> {",
  "                def sourceDictionary = self",
  "                object {",
  "                    inherits enumerable.trait<T>",
  "                    factory method iterator {",
  "                        def sourceIterator = sourceDictionary.bindingsIterator",
  "                        // should be request on outer",
  "                        method hasNext { sourceIterator.hasNext }",
  "                        method next { sourceIterator.next.value }",
  "                        method asString {",
  "                            \"an iterator over values of {sourceDictionary}\"",
  "                        }",
  "                    }",
  "                    def size is public = sourceDictionary.size",
  "                    method asDebugString {",
  "                        \"a lazy sequence over values of {sourceDictionary}\"",
  "                    }",
  "                }",
  "            }",
  "            method bindings -> Enumerable<T> {",
  "                def sourceDictionary = self",
  "                object {",
  "                    inherits enumerable.trait<T>",
  "                    method iterator { sourceDictionary.bindingsIterator }",
  "                    // should be request on outer",
  "                    def size is public = sourceDictionary.size",
  "                    method asDebugString {",
  "                        \"a lazy sequence over bindings of {sourceDictionary}\"",
  "                    }",
  "                }",
  "            }",
  "            method iterator -> Iterator<T> { values.iterator }",
  "            factory method bindingsIterator -> Iterator<Binding<K, T>> {",
  "                // this should be confidential, but can't be until `outer` is fixed.",
  "                def imods:Number = mods",
  "                var count := 1",
  "                var idx := 0",
  "                var elt",
  "                method hasNext { size >= count }",
  "                method next {",
  "                    if (imods != mods) then {",
  "                        ConcurrentModification.raise (outer.asString)",
  "                    }",
  "                    if (size < count) then { Exhausted.raise \"over {outer.asString}\" }",
  "                    while {",
  "                        elt := inner.at(idx)",
  "                        (elt == unused) || (elt == removed)",
  "                    } do {",
  "                        idx := idx + 1",
  "                    }",
  "                    count := count + 1",
  "                    idx := idx + 1",
  "                    elt",
  "                }",
  "            }",
  "            method expand is confidential {",
  "                def c = inner.size",
  "                def n = c * 2",
  "                def oldInner = inner",
  "                inner := _prelude.PrimitiveArray.new(n)",
  "                for (0..(n - 1)) do {i->",
  "                    inner.at(i)put(unused)",
  "                }",
  "                numBindings := 0",
  "                for (0..(c - 1)) do {i->",
  "                    def a = oldInner.at(i)",
  "                    if ((a != unused).andAlso{a != removed}) then {",
  "                        self.at(a.key)put(a.value)",
  "                    }",
  "                }",
  "            }",
  "            method keysAndValuesDo(block2) {",
  "                 for (0..(inner.size-1)) do {i->",
  "                    def a = inner.at(i)",
  "                    if ((a != unused).andAlso{a != removed}) then {",
  "                        block2.apply(a.key, a.value)",
  "                    }",
  "                }",
  "            }",
  "            method keysDo(block1) {",
  "                 for (0..(inner.size-1)) do {i->",
  "                    def a = inner.at(i)",
  "                    if ((a != unused).andAlso{a != removed}) then {",
  "                        block1.apply(a.key)",
  "                    }",
  "                }",
  "            }",
  "            method valuesDo(block1) {",
  "                 for (0..(inner.size-1)) do {i->",
  "                    def a = inner.at(i)",
  "                    if ((a != unused).andAlso{a != removed}) then {",
  "                        block1.apply(a.value)",
  "                    }",
  "                }",
  "            }",
  "            method do(block1) { valuesDo(block1) }",
  "",
  "            method ==(other) {",
  "                match (other)",
  "                    case {o:Dictionary ->",
  "                        if (self.size != o.size) then {return false}",
  "                        self.keysAndValuesDo { k, v ->",
  "                            if (o.at(k)ifAbsent{return false} != v) then {",
  "                                return false",
  "                            }",
  "                        }",
  "                        return true",
  "                    }",
  "                    case {_ ->",
  "                        return false",
  "                    }",
  "            }",
  "",
  "            method copy {",
  "                def newCopy = dictionary.empty",
  "                self.keysAndValuesDo{ k, v ->",
  "                    newCopy.at(k)put(v)",
  "                }",
  "                newCopy",
  "            }",
  "",
  "            method asDictionary {",
  "                self",
  "            }",
  "",
  "            method ++(other) {",
  "                def newDict = self.copy",
  "                other.keysAndValuesDo {k, v ->",
  "                    newDict.at(k) put(v)",
  "                }",
  "                return newDict",
  "            }",
  "",
  "            method --(other) {",
  "                def newDict = dictionary.empty",
  "                keysAndValuesDo { k, v ->",
  "                    if (! other.containsKey(k)) then {",
  "                        newDict.at(k) put(v)",
  "                    }",
  "                }",
  "                return newDict",
  "            }",
  "        }",
  "    }",
  "}",
  "",
  "factory method range {",
  "    method from(lower)to(upper) -> Sequence<Number> {",
  "        object {",
  "            inherits indexable.trait<Number>",
  "            match (lower)",
  "                case {_:Number -> }",
  "                case {_ -> RequestError.raise \"lower bound {lower}\" ++",
  "                    \" in range.from({lower})to({upper}) is not an integer\" }",
  "            def start = lower.truncated",
  "            if (start != lower) then {",
  "                RequestError.raise \"lower bound {lower}\" ++",
  "                    \" in range.from({lower})to({upper}) is not an integer\" }",
  "",
  "            match (upper)",
  "                case {_:Number -> }",
  "                case {_ -> RequestError.raise \"upper bound {upper}\" ++",
  "                    \" in range.from({lower})to({upper}) is not an integer\" }",
  "            def stop = upper.truncated",
  "            if (stop != upper) then {",
  "                RequestError.raise \"upper bound {upper}\" ++",
  "                    \" in range.from()to() is not an integer\"",
  "            }",
  "",
  "            def size is public =",
  "                if ((upper-lower+1) < 0) then { 0 } else {upper-lower+1}",
  "",
  "            def hash is public = { ((start.hash * 1021) + stop.hash) * 3 }",
  "",
  "            method iterator -> Iterator {",
  "                object {",
  "                    var val := start",
  "                    method hasNext { val <= stop }",
  "                    method next {",
  "                        if (val > stop) then {",
  "                            Exhausted.raise \"over {outer.asString}\"",
  "                        }",
  "                        val := val + 1",
  "                        return (val - 1)",
  "                    }",
  "                    method asString { \"{super.asString} from {upper} to {lower}\" }",
  "                }",
  "            }",
  "            method at(ix:Number) {",
  "                if (!(ix <= self.size)) then {",
  "                    BoundsError.raise \"requested range.at({ix}), but upper bound is {size}\"",
  "                }",
  "                if (!(ix >= 1)) then {",
  "                    BoundsError.raise \"requested range.at({ix}), but lower bound is 1\"",
  "                }",
  "                return start + (ix - 1)",
  "            }",
  "            method contains(elem) -> Boolean {",
  "                try {",
  "                    def intElem = elem.truncated",
  "                    if (intElem != elem) then {return false}",
  "                    if (intElem < start) then {return false}",
  "                    if (intElem > stop) then {return false}",
  "                } catch { ex:_prelude.Exception -> return false }",
  "                return true",
  "            }",
  "            method do(block1) {",
  "                var val := start",
  "                while {val <= stop} do {",
  "                    block1.apply(val)",
  "                    val := val + 1",
  "                }",
  "            }",
  "            method keysAndValuesDo(block2) {",
  "                var key := 1",
  "                var val := start",
  "                while {val <= stop} do {",
  "                    block2.apply(key, val)",
  "                    key := key + 1",
  "                    val := val + 1",
  "                }",
  "            }",
  "            method reversed {",
  "                from(upper)downTo(lower)",
  "            }",
  "            method ++(other) {",
  "                sequence.withAll(self, other)",
  "            }",
  "            method ==(other) {",
  "                // there are 6 copies of this method!  Do we need traits!",
  "                match (other)",
  "                    case {o:Collection ->",
  "                        def selfIter = self.iterator",
  "                        def otherIter = other.iterator",
  "                        while {selfIter.hasNext && otherIter.hasNext} do {",
  "                            if (selfIter.next != otherIter.next) then {",
  "                                return false",
  "                            }",
  "                        }",
  "                        return selfIter.hasNext == otherIter.hasNext",
  "                    }",
  "                    case {_ ->",
  "                        return false",
  "                    }",
  "            }",
  "            method sorted { self }",
  "",
  "            method sortedBy(c) { self.asList.sortBy(c) }",
  "",
  "            method keys { 1..self.size }",
  "",
  "            method values { self }",
  "",
  "            method asString -> String{",
  "                \"range.from({lower})to({upper})\"",
  "            }",
  "",
  "            method asList{",
  "                var result := list.empty",
  "                for (self) do { each -> result.add(each) }",
  "                result",
  "            }",
  "",
  "            method asSequence {",
  "                self",
  "            }",
  "        }",
  "    }",
  "    method from(upper)downTo(lower) -> Sequence<Number> {",
  "        object {",
  "            inherits indexable.trait",
  "            match (upper)",
  "                case {_:Number -> }",
  "                case {_ -> RequestError.raise \"upper bound {upper}\" ++",
  "                    \" in range.from({upper})downTo({lower}) is not an integer\" }",
  "            def start = upper.truncated",
  "            if (start != upper) then {",
  "                RequestError.raise \"upper bound {upper}\" ++",
  "                    \" in range.from({upper})downTo({lower}) is not an integer\"",
  "            }",
  "            match (lower)",
  "                case {_:Number -> }",
  "                case {_ -> RequestError.raise \"lower bound {lower}\" ++",
  "                    \" in range.from({upper})downTo({lower}) is not an integer\" }",
  "            def stop = lower.truncated",
  "            if (stop != lower) then {",
  "                RequestError.raise \"lower bound {lower}\" ++",
  "                    \" in range.from({upper})downTo({lower}) is not an integer\"",
  "            }",
  "            def size is public =",
  "                if ((upper-lower+1) < 0) then { 0 } else {upper-lower+1}",
  "            method iterator {",
  "                object {",
  "                    var val := start",
  "                    method hasNext { val >= stop }",
  "                    method next {",
  "                        if (val < stop) then { Exhausted.raise \"over {outer.asString}\" }",
  "                        val := val - 1",
  "                        return (val + 1)",
  "                    }",
  "                    method asString { \"anIterator over {super.asString}\" }",
  "                }",
  "            }",
  "            method at(ix:Number) {",
  "                if (!(ix <= self.size)) then {",
  "                    BoundsError.raise \"requested range.at({ix}) but upper bound is {size}\"",
  "                }",
  "                if (!(ix >= 1)) then {",
  "                    BoundsError.raise \"requested range.at({ix}) but lower bound is 1\"",
  "                }",
  "                return start - (ix - 1)",
  "            }",
  "            method contains(elem) -> Boolean {",
  "                try {",
  "                    def intElem = elem.truncated",
  "                    if (intElem != elem) then {return false}",
  "                    if (intElem > start) then {return false}",
  "                    if (intElem < stop) then {return false}",
  "                } catch { ex:_prelude.Exception -> return false }",
  "                return true",
  "            }",
  "            method do(block1) {",
  "                var val := start",
  "                while {val >= stop} do {",
  "                    block1.apply(val)",
  "                    val := val - 1",
  "                }",
  "            }",
  "            method keysAndValuesDo(block2) {",
  "                var key := 1",
  "                var val := start",
  "                while {val >= stop} do {",
  "                    block2.apply(key, val)",
  "                    key := key + 1",
  "                    val := val - 1",
  "                }",
  "            }",
  "            method reversed {",
  "                from(lower)to(upper)",
  "            }",
  "            method ++(other) {",
  "                sequence.withAll(self, other)",
  "            }",
  "            method ==(other) {",
  "                // there are 6 copies of this method!  Do we need traits!",
  "                match (other)",
  "                    case {o:Collection ->",
  "                        def selfIter = self.iterator",
  "                        def otherIter = other.iterator",
  "                        while {selfIter.hasNext && otherIter.hasNext} do {",
  "                            if (selfIter.next != otherIter.next) then {",
  "                                return false",
  "                            }",
  "                        }",
  "                        return selfIter.hasNext == otherIter.hasNext",
  "                    }",
  "                    case {_ ->",
  "                        return false",
  "                    }",
  "            }",
  "            method sorted { self.reversed }",
  "",
  "            method sortedBy(c) { self.asList.sortBy(c) }",
  "",
  "            method keys { 1..self.size }",
  "",
  "            method values { self }",
  "",
  "            method asString -> String {",
  "                \"range.from {upper} downTo {lower}\"",
  "            }",
  "            method asSequence {",
  "                self",
  "            }",
  "        }",
  "    }",
  "}",
  NULL
};
Object reader_collectionsPrelude_outer_6(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_9(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_sourceIterator_10(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_collectionsPrelude_outer_48(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_51(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_cache_52(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_cache_52(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_cacheLoaded_53(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_collectionsPrelude_cacheLoaded_53(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_collectionsPrelude_sourceIterator_54(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_collectionsPrelude_outer_144(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_181(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_228(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_345(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_mods_346(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_mods_346(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_size_347(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_collectionsPrelude_inner_348(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_collectionsPrelude_outer_630(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_imods_631(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_imods_631(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_idx_632(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_collectionsPrelude_idx_632(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_762(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_772(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_mods_773(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_mods_773(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_sz_774(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_collectionsPrelude_sz_774(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_collectionsPrelude_jsArray_775(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_collectionsPrelude_jsArray_775(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_1169(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_imods_1170(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_imods_1170(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_idx_1171(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_collectionsPrelude_idx_1171(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_1308(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_mods_1309(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_mods_1309(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_initialSize_1310(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_collectionsPrelude_initialSize_1310(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_collectionsPrelude_inner_1311(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_collectionsPrelude_inner_1311(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_collectionsPrelude_size_1312(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_collectionsPrelude_size_1312(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_1978(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_imods_1979(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_imods_1979(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_idx_1980(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_collectionsPrelude_idx_1980(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_2208(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_2211(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_mods_2212(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_mods_2212(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_initialSize_2213(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_collectionsPrelude_initialSize_2213(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_collectionsPrelude_inner_2214(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_collectionsPrelude_inner_2214(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_collectionsPrelude_unused_2215(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object reader_collectionsPrelude_removed_2216(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object reader_collectionsPrelude_size_2217(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_collectionsPrelude_size_2217(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_2592(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_imods_2593(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_imods_2593(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_count_2594(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_collectionsPrelude_count_2594(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_collectionsPrelude_idx_2595(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_collectionsPrelude_idx_2595(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_2932(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_unused_2933(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_unused_2933(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_2938(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_removed_2939(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_removed_2939(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_2978(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_2986(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_mods_2987(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_mods_2987(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_numBindings_2988(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_collectionsPrelude_numBindings_2988(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_collectionsPrelude_inner_2989(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_collectionsPrelude_inner_2989(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_collectionsPrelude_unused_2990(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object reader_collectionsPrelude_removed_2991(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object reader_collectionsPrelude_outer_3572(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_3575(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_sourceIterator_3576(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_collectionsPrelude_size_3601(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_collectionsPrelude_outer_3618(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_3621(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_sourceIterator_3622(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_collectionsPrelude_size_3647(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_collectionsPrelude_outer_3664(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_size_3668(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_collectionsPrelude_outer_3690(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_imods_3691(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_collectionsPrelude_count_3692(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_collectionsPrelude_count_3692(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_collectionsPrelude_idx_3693(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_collectionsPrelude_idx_3693(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_collectionsPrelude_elt_3694(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_collectionsPrelude_elt_3694(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_4127(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_unused_4128(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_unused_4128(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_key_4129(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_collectionsPrelude_value_4130(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_collectionsPrelude_outer_4135(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_removed_4136(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_removed_4136(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_key_4137(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_collectionsPrelude_value_4138(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_collectionsPrelude_outer_4182(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_4185(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_start_4186(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_collectionsPrelude_stop_4187(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_collectionsPrelude_size_4188(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_collectionsPrelude_hash_4189(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object reader_collectionsPrelude_outer_4192(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_val_4193(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_val_4193(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_4728(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_start_4729(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_collectionsPrelude_stop_4730(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_collectionsPrelude_size_4731(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_collectionsPrelude_outer_4734(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_val_4735(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_val_4735(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_5333(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_5336(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_5353(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_5356(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_5452(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_5455(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_5671(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_5674(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_5832(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_5835(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
static Object strlit2;
static ClassData objclass5;
static ClassData objclass8;
static Object strlit12;
static Object strlit36;
static Object strlit40;
static ClassData objclass47;
static ClassData objclass50;
static Object strlit57;
static Object strlit61;
static Object strlit86;
static Object strlit132;
static Object strlit136;
static ClassData objclass143;
static Object strlit162;
static Object strlit167;
static Object strlit171;
static Object strlit177;
static ClassData objclass180;
static Object strlit193;
static Object strlit198;
static Object strlit202;
static ClassData objclass227;
static Object strlit257;
static ClassData objclass344;
static Object strlit369;
static Object strlit376;
static Object strlit380;
static Object strlit492;
static Object strlit527;
static Object strlit534;
static Object strlit617;
static ClassData objclass629;
static Object strlit635;
static Object strlit642;
static Object strlit648;
static Object strlit654;
static Object strlit684;
static Object strlit691;
static Object strlit697;
static ClassData objclass761;
static Object strlit766;
static ClassData objclass771;
static Object strlit796;
static Object strlit803;
static Object strlit807;
static Object strlit951;
static Object strlit1042;
static Object strlit1065;
static Object strlit1072;
static Object strlit1156;
static ClassData objclass1168;
static Object strlit1174;
static Object strlit1181;
static Object strlit1187;
static Object strlit1193;
static Object strlit1230;
static ClassData objclass1307;
static Object strlit1333;
static Object strlit1340;
static Object strlit1344;
static Object strlit1741;
static Object strlit1840;
static Object strlit1875;
static Object strlit1882;
static Object strlit1965;
static ClassData objclass1977;
static Object strlit1983;
static Object strlit1990;
static Object strlit1996;
static Object strlit2002;
static Object strlit2039;
static Object strlit2169;
static ClassData objclass2207;
static ClassData objclass2210;
static Object strlit2279;
static Object strlit2283;
static Object strlit2509;
static Object strlit2523;
static Object strlit2530;
static ClassData objclass2591;
static Object strlit2648;
static Object strlit2656;
static Object strlit2821;
static Object strlit2918;
static ClassData objclass2931;
static Object strlit2935;
static ClassData objclass2937;
static Object strlit2941;
static ClassData objclass2977;
static ClassData objclass2985;
static Object strlit3080;
static Object strlit3084;
static Object strlit3163;
static Object strlit3167;
static Object strlit3394;
static Object strlit3433;
static Object strlit3441;
static Object strlit3448;
static Object strlit3454;
static Object strlit3465;
static Object strlit3469;
static Object strlit3491;
static Object strlit3515;
static Object strlit3522;
static Object strlit3529;
static Object strlit3533;
static Object strlit3545;
static Object strlit3552;
static Object strlit3556;
static Object strlit3567;
static ClassData objclass3571;
static ClassData objclass3574;
static Object strlit3591;
static Object strlit3595;
static Object strlit3604;
static Object strlit3608;
static ClassData objclass3617;
static ClassData objclass3620;
static Object strlit3637;
static Object strlit3641;
static Object strlit3650;
static Object strlit3654;
static ClassData objclass3663;
static Object strlit3671;
static Object strlit3675;
static ClassData objclass3689;
static Object strlit3734;
static Object strlit3742;
static Object strlit4058;
static ClassData objclass4126;
static Object strlit4132;
static ClassData objclass4134;
static Object strlit4140;
static ClassData objclass4181;
static ClassData objclass4184;
static ClassData objclass4191;
static Object strlit4217;
static Object strlit4225;
static Object strlit4245;
static Object strlit4250;
static Object strlit4255;
static Object strlit4261;
static Object strlit4284;
static Object strlit4291;
static Object strlit4295;
static Object strlit4310;
static Object strlit4314;
static Object strlit4359;
static Object strlit4477;
static Object strlit4504;
static Object strlit4509;
static Object strlit4513;
static Object strlit4543;
static Object strlit4554;
static Object strlit4559;
static Object strlit4563;
static Object strlit4571;
static Object strlit4575;
static Object strlit4591;
static Object strlit4596;
static Object strlit4600;
static Object strlit4608;
static Object strlit4612;
static Object strlit4623;
static Object strlit4634;
static Object strlit4639;
static Object strlit4643;
static Object strlit4651;
static Object strlit4655;
static Object strlit4670;
static Object strlit4674;
static Object strlit4678;
static ClassData objclass4727;
static ClassData objclass4733;
static Object strlit4759;
static Object strlit4767;
static Object strlit4787;
static Object strlit4793;
static Object strlit4812;
static Object strlit4819;
static Object strlit4823;
static Object strlit4838;
static Object strlit4842;
static Object strlit4887;
static Object strlit5005;
static Object strlit5034;
static Object strlit5039;
static Object strlit5043;
static Object strlit5057;
static Object strlit5068;
static Object strlit5073;
static Object strlit5077;
static Object strlit5085;
static Object strlit5089;
static Object strlit5105;
static Object strlit5110;
static Object strlit5114;
static Object strlit5122;
static Object strlit5126;
static Object strlit5137;
static Object strlit5148;
static Object strlit5153;
static Object strlit5157;
static Object strlit5165;
static Object strlit5169;
static Object strlit5185;
static Object strlit5190;
static Object strlit5194;
static Object strlit5202;
static Object strlit5206;
static Object strlit5234;
static Object strlit5240;
static Object strlit5246;
static Object strlit5252;
static Object strlit5258;
static Object strlit5264;
static Object strlit5270;
static ClassData objclass5332;
static ClassData objclass5335;
static ClassData objclass5352;
static ClassData objclass5355;
static ClassData objclass5451;
static ClassData objclass5454;
static Object strlit5466;
static Object strlit5472;
static Object strlit5554;
static Object strlit5642;
static Object strlit5656;
static Object strlit5663;
static ClassData objclass5670;
static ClassData objclass5673;
static Object strlit5766;
static Object strlit5770;
static ClassData objclass5831;
static ClassData objclass5834;
static Object strlit5840;
static Object strlit5845;
static Object strlit5849;
static Object strlit5898;
Object meth_collectionsPrelude_abstract0(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "abstract");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_SubobjectResponsibility = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for abstract (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for abstract");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 13
  setline(13);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit2 == NULL) {
    strlit2 = alloc_String("abstract method not overriden by subobject");
    gc_root(strlit2);
  }
// compiled string node returning strlit2 (depth = 3)
  gc_frame_newslot(strlit2);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_SubobjectResponsibility (depth = 3)
  params[0] = strlit2;
  partcv[0] = 1;
  Object call3 = callmethod(*var_SubobjectResponsibility, "raise",
    1, partcv, params);
  gc_frame_end(callframe1);
// compiled call node returning call3 (depth = 2)
  gc_frame_end(frame);
  return call3;
}
Object meth_collectionsPrelude_asString11(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 177
  setline(177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit12 == NULL) {
    strlit12 = alloc_String("an iterator over a lazy map sequence");
    gc_root(strlit12);
  }
// compiled string node returning strlit12 (depth = 2)
  gc_frame_end(frame);
  return strlit12;
}
Object meth_collectionsPrelude_hasNext13(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for hasNext (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for hasNext");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 178
  setline(178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe14 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe15 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call16 = callmethodflags(self, "sourceIterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe15);
// compiled call node returning call16 (depth = 5)
// compiled member node returning call16 (depth = 4)
  partcv[0] = 0;
  Object call17 = callmethod(call16, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe14);
// compiled call node returning call17 (depth = 3)
// compiled member node returning call17 (depth = 2)
  gc_frame_end(frame);
  return call17;
}
Object meth_collectionsPrelude_next18(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_function = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for next (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for next");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 179
  setline(179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe19 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe20 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe21 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call22 = callmethodflags(self, "sourceIterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe21);
// compiled call node returning call22 (depth = 6)
// compiled member node returning call22 (depth = 5)
  partcv[0] = 0;
  Object call23 = callmethod(call22, "next",
    1, partcv, params);
  gc_frame_end(callframe20);
// compiled call node returning call23 (depth = 4)
// compiled member node returning call23 (depth = 3)
  gc_frame_newslot(call23);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_function (depth = 3)
  params[0] = call23;
  partcv[0] = 1;
  Object call24 = callmethod(*var_function, "apply",
    1, partcv, params);
  gc_frame_end(callframe19);
// compiled call node returning call24 (depth = 2)
  gc_frame_end(frame);
  return call24;
}
Object meth_collectionsPrelude_iterator7(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_function = getfromclosure(closure, 0);
  Object *var_source = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject8 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8 = alloc_userobj2(4,5, objclass8);
  gc_frame_newslot(obj8);
if (objclass8 == NULL) {
  glfree(obj8->class->name);
  obj8->class->name = "obj5.iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj8, self, 0);
  addmethodreal(obj8,"outer", &reader_collectionsPrelude_outer_9);
  Object oldself8 = self;
  struct StackFrameObject *oldstackframe8 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8);
  gc_frame_newslot((Object)stackframe);
  self = obj8;
  Object *oldselfslot8 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8 = (*(struct UserObject *)self).data[0], lowerouter8 = thisouter8;
  if (inheritingObject8) {
    struct UserObject *inho8 = (struct UserObject *)inheritingObject8;
    while (inho8->super != GraceDefaultObject) inho8 = (struct UserObject *)inho8->super;
    inho8->super = obj8;
    self = inheritingObject8;
    *selfslot = self;
    lowerouter8 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8;
  }
if (objclass8 == NULL) {
  Method *reader10 = addmethodrealflags(obj8, "sourceIterator",&reader_collectionsPrelude_sourceIterator_10, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader10->definitionModule = modulename;
  reader10->definitionLine = 176;
}
adddatum2(obj8, alloc_Undefined(), 1);
// method asString
  struct UserObject *uo11 = (struct UserObject*)obj8;
  uo11->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString11 = addmethod2pos(obj8, "asString", &meth_collectionsPrelude_asString11, 2);
  int argcv_meth_collectionsPrelude_asString11[] = {0};
  meth_meth_collectionsPrelude_asString11->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString11);
  meth_meth_collectionsPrelude_asString11->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString11->definitionLine = 177;
// method hasNext
  struct UserObject *uo13 = (struct UserObject*)obj8;
  uo13->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext13 = addmethod2pos(obj8, "hasNext", &meth_collectionsPrelude_hasNext13, 3);
  int argcv_meth_collectionsPrelude_hasNext13[] = {0};
  meth_meth_collectionsPrelude_hasNext13->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext13);
  meth_meth_collectionsPrelude_hasNext13->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext13->definitionLine = 178;
// method next
  block_savedest(obj8);
  Object closure18 = createclosure(1, "next");
  setclosureframe(closure18, stackframe);
  addtoclosure(closure18, var_function);
  struct UserObject *uo18 = (struct UserObject*)obj8;
  uo18->data[4] = (Object)closure18;
  Method *meth_meth_collectionsPrelude_next18 = addmethod2pos(obj8, "next", &meth_collectionsPrelude_next18, 4);
  int argcv_meth_collectionsPrelude_next18[] = {0};
  meth_meth_collectionsPrelude_next18->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next18);
  meth_meth_collectionsPrelude_next18->definitionModule = modulename;
  meth_meth_collectionsPrelude_next18->definitionLine = 179;
  sourceObject = obj8;
// Begin line 176
  setline(176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe25 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_source (depth = 4)
  partcv[0] = 0;
  Object call26 = callmethod(*var_source, "iterator",
    1, partcv, params);
  gc_frame_end(callframe25);
// compiled call node returning call26 (depth = 3)
// compiled member node returning call26 (depth = 2)
  adddatum2(obj8, call26, 1);
  sourceObject = obj8;
  sourceObject = obj8;
  sourceObject = obj8;
  objclass8 = obj8->class;
  objclass8->definitionModule = modulename;
  objclass8->definitionLine = 175;
  (*(struct UserObject *)self).data[0] = lowerouter8;
  self = oldself8;
  selfslot = oldselfslot8;
  stackframe = oldstackframe8;
  gc_frame_end(frame);
  return obj8;
}
Object meth_collectionsPrelude_iterator7_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_function = getfromclosure(closure, 0);
  Object *var_source = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject8 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8 = alloc_userobj2(4,5, objclass8);
  gc_frame_newslot(obj8);
if (objclass8 == NULL) {
  glfree(obj8->class->name);
  obj8->class->name = "obj5.iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj8, self, 0);
  addmethodreal(obj8,"outer", &reader_collectionsPrelude_outer_9);
  Object oldself8 = self;
  struct StackFrameObject *oldstackframe8 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8);
  gc_frame_newslot((Object)stackframe);
  self = obj8;
  Object *oldselfslot8 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8 = (*(struct UserObject *)self).data[0], lowerouter8 = thisouter8;
  if (inheritingObject8) {
    struct UserObject *inho8 = (struct UserObject *)inheritingObject8;
    while (inho8->super != GraceDefaultObject) inho8 = (struct UserObject *)inho8->super;
    inho8->super = obj8;
    self = inheritingObject8;
    *selfslot = self;
    lowerouter8 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8;
  }
if (objclass8 == NULL) {
  Method *reader10 = addmethodrealflags(obj8, "sourceIterator",&reader_collectionsPrelude_sourceIterator_10, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader10->definitionModule = modulename;
  reader10->definitionLine = 176;
}
adddatum2(obj8, alloc_Undefined(), 1);
// method asString
  struct UserObject *uo11 = (struct UserObject*)obj8;
  uo11->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString11 = addmethod2pos(obj8, "asString", &meth_collectionsPrelude_asString11, 2);
  int argcv_meth_collectionsPrelude_asString11[] = {0};
  meth_meth_collectionsPrelude_asString11->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString11);
  meth_meth_collectionsPrelude_asString11->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString11->definitionLine = 177;
// method hasNext
  struct UserObject *uo13 = (struct UserObject*)obj8;
  uo13->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext13 = addmethod2pos(obj8, "hasNext", &meth_collectionsPrelude_hasNext13, 3);
  int argcv_meth_collectionsPrelude_hasNext13[] = {0};
  meth_meth_collectionsPrelude_hasNext13->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext13);
  meth_meth_collectionsPrelude_hasNext13->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext13->definitionLine = 178;
// method next
  block_savedest(obj8);
  Object closure18 = createclosure(1, "next");
  setclosureframe(closure18, stackframe);
  addtoclosure(closure18, var_function);
  struct UserObject *uo18 = (struct UserObject*)obj8;
  uo18->data[4] = (Object)closure18;
  Method *meth_meth_collectionsPrelude_next18 = addmethod2pos(obj8, "next", &meth_collectionsPrelude_next18, 4);
  int argcv_meth_collectionsPrelude_next18[] = {0};
  meth_meth_collectionsPrelude_next18->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next18);
  meth_meth_collectionsPrelude_next18->definitionModule = modulename;
  meth_meth_collectionsPrelude_next18->definitionLine = 179;
  sourceObject = obj8;
// Begin line 176
  setline(176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe25 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_source (depth = 4)
  partcv[0] = 0;
  Object call26 = callmethod(*var_source, "iterator",
    1, partcv, params);
  gc_frame_end(callframe25);
// compiled call node returning call26 (depth = 3)
// compiled member node returning call26 (depth = 2)
  adddatum2(obj8, call26, 1);
  sourceObject = obj8;
  sourceObject = obj8;
  sourceObject = obj8;
  objclass8 = obj8->class;
  objclass8->definitionModule = modulename;
  objclass8->definitionLine = 175;
  (*(struct UserObject *)self).data[0] = lowerouter8;
  self = oldself8;
  selfslot = oldselfslot8;
  stackframe = oldstackframe8;
  gc_frame_end(frame);
  return obj8;
}
Object meth_collectionsPrelude_size28(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "size");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_source = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for size (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for size");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 181
  setline(181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe29 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_source (depth = 4)
  partcv[0] = 0;
  Object call30 = callmethod(*var_source, "size",
    1, partcv, params);
  gc_frame_end(callframe29);
// compiled call node returning call30 (depth = 3)
// compiled member node returning call30 (depth = 2)
  gc_frame_end(frame);
  return call30;
}
Object meth_collectionsPrelude_isEmpty31(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "isEmpty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_source = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isEmpty (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isEmpty");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 182
  setline(182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe32 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_source (depth = 4)
  partcv[0] = 0;
  Object call33 = callmethod(*var_source, "isEmpty",
    1, partcv, params);
  gc_frame_end(callframe32);
// compiled call node returning call33 (depth = 3)
// compiled member node returning call33 (depth = 2)
  gc_frame_end(frame);
  return call33;
}
Object meth_collectionsPrelude_asDebugString34(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_source = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asDebugString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asDebugString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit36 == NULL) {
    strlit36 = alloc_String("");
    gc_root(strlit36);
  }
// compiled string node returning strlit36 (depth = 3)
  int op_slot_right_35 = gc_frame_newslot(strlit36);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_source (depth = 4)
  int op_slot_right_38 = gc_frame_newslot(*var_source);
// starting to compile string node (depth = 4)
  if (strlit40 == NULL) {
    strlit40 = alloc_String("a lazy sequence mapping over ");
    gc_root(strlit40);
  }
// compiled string node returning strlit40 (depth = 4)
  int op_slot_left_38 = gc_frame_newslot(strlit40);
  params[0] = *var_source;
  partcv[0] = 1;
  Object opresult41 = callmethod(strlit40, "++", 1, partcv, params);
// compiled op node returning opresult41 (depth = 3)
  int op_slot_left_35 = gc_frame_newslot(opresult41);
  params[0] = strlit36;
  partcv[0] = 1;
  Object opresult42 = callmethod(opresult41, "++", 1, partcv, params);
// compiled op node returning opresult42 (depth = 2)
  gc_frame_end(frame);
  return opresult42;
}
Object meth_collectionsPrelude_lazySequenceOver_40__41_mappedBy4(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lazySequenceOver()mappedBy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method lazySequenceOver()mappedBy");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method lazySequenceOver()mappedBy");
  Object params[1];
  int partcv[2];
  Object *var_enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for lazySequenceOver()mappedBy (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_source = &(stackframe->slots[0]);
  *var_source = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for lazySequenceOver");
  Object *var_function = &(stackframe->slots[1]);
  *var_function = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for mappedBy");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start generics
  Object *var_T = &(stackframe->slots[3]);
  Object *var_R = &(stackframe->slots[4]);
  if (nparts == 1 + 2 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 2) {
      gracedie("insufficient generic parameters");
    }
    *var_T = args[curarg++];
    *var_R = args[curarg++];
  } else {
    *var_T = Unknown;
    *var_R = Unknown;
  }
// End generics
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5 = alloc_userobj2(6,7, objclass5);
  gc_frame_newslot(obj5);
if (objclass5 == NULL) {
  glfree(obj5->class->name);
  obj5->class->name = "self.lazySequenceOver()mappedBy";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5, self, 0);
  addmethodreal(obj5,"outer", &reader_collectionsPrelude_outer_6);
  Object oldself5 = self;
  struct StackFrameObject *oldstackframe5 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5);
  gc_frame_newslot((Object)stackframe);
  self = obj5;
  Object *oldselfslot5 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5 = (*(struct UserObject *)self).data[0], lowerouter5 = thisouter5;
  if (inheritingObject5) {
    struct UserObject *inho5 = (struct UserObject *)inheritingObject5;
    while (inho5->super != GraceDefaultObject) inho5 = (struct UserObject *)inho5->super;
    inho5->super = obj5;
    self = inheritingObject5;
    *selfslot = self;
    lowerouter5 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5;
  }
// method iterator
  block_savedest(obj5);
  Object closure7 = createclosure(2, "iterator");
  setclosureframe(closure7, stackframe);
  addtoclosure(closure7, var_function);
  addtoclosure(closure7, var_source);
  struct UserObject *uo7 = (struct UserObject*)obj5;
  uo7->data[1] = (Object)closure7;
  Method *meth_meth_collectionsPrelude_iterator7 = addmethod2pos(obj5, "iterator", &meth_collectionsPrelude_iterator7, 1);
  int argcv_meth_collectionsPrelude_iterator7[] = {0};
  meth_meth_collectionsPrelude_iterator7->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator7);
  meth_meth_collectionsPrelude_iterator7->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator7->definitionLine = 175;
  block_savedest(obj5);
  Object closure27 = createclosure(2, "iterator()object");
  setclosureframe(closure27, stackframe);
  addtoclosure(closure27, var_function);
  addtoclosure(closure27, var_source);
  Method *meth_meth_collectionsPrelude_iterator7_object = addmethod2pos(obj5, "iterator()object", &meth_collectionsPrelude_iterator7_object, 1);
  meth_meth_collectionsPrelude_iterator7_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator7_object->definitionLine = 175;
// method size
  block_savedest(obj5);
  Object closure28 = createclosure(1, "size");
  setclosureframe(closure28, stackframe);
  addtoclosure(closure28, var_source);
  struct UserObject *uo28 = (struct UserObject*)obj5;
  uo28->data[2] = (Object)closure28;
  Method *meth_meth_collectionsPrelude_size28 = addmethod2pos(obj5, "size", &meth_collectionsPrelude_size28, 2);
  int argcv_meth_collectionsPrelude_size28[] = {0};
  meth_meth_collectionsPrelude_size28->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size28);
  meth_meth_collectionsPrelude_size28->definitionModule = modulename;
  meth_meth_collectionsPrelude_size28->definitionLine = 181;
// method isEmpty
  block_savedest(obj5);
  Object closure31 = createclosure(1, "isEmpty");
  setclosureframe(closure31, stackframe);
  addtoclosure(closure31, var_source);
  struct UserObject *uo31 = (struct UserObject*)obj5;
  uo31->data[3] = (Object)closure31;
  Method *meth_meth_collectionsPrelude_isEmpty31 = addmethod2pos(obj5, "isEmpty", &meth_collectionsPrelude_isEmpty31, 3);
  int argcv_meth_collectionsPrelude_isEmpty31[] = {0};
  meth_meth_collectionsPrelude_isEmpty31->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_isEmpty31);
  meth_meth_collectionsPrelude_isEmpty31->definitionModule = modulename;
  meth_meth_collectionsPrelude_isEmpty31->definitionLine = 182;
// method asDebugString
  block_savedest(obj5);
  Object closure34 = createclosure(1, "asDebugString");
  setclosureframe(closure34, stackframe);
  addtoclosure(closure34, var_source);
  struct UserObject *uo34 = (struct UserObject*)obj5;
  uo34->data[4] = (Object)closure34;
  Method *meth_meth_collectionsPrelude_asDebugString34 = addmethod2pos(obj5, "asDebugString", &meth_collectionsPrelude_asDebugString34, 4);
  int argcv_meth_collectionsPrelude_asDebugString34[] = {0};
  meth_meth_collectionsPrelude_asDebugString34->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString34);
  meth_meth_collectionsPrelude_asDebugString34->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString34->definitionLine = 183;
  sourceObject = obj5;
// Begin line 174
  setline(174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe43 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call44 = callmethod(*var_enumerable, "trait()object",
    2, partcv, params);
  gc_frame_end(callframe43);
// compiled call node returning call44 (depth = 2)
  struct UserObject *obj5_uo = (struct UserObject *)obj5;
  obj5_uo->super = call44;
  sourceObject = obj5;
  sourceObject = obj5;
  sourceObject = obj5;
  sourceObject = obj5;
  objclass5 = obj5->class;
  objclass5->definitionModule = modulename;
  objclass5->definitionLine = 172;
  (*(struct UserObject *)self).data[0] = lowerouter5;
  self = oldself5;
  selfslot = oldselfslot5;
  stackframe = oldstackframe5;
  gc_frame_end(frame);
  return obj5;
}
Object meth_collectionsPrelude_lazySequenceOver_40__41_mappedBy4_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lazySequenceOver()mappedBy()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0] + argcv[1]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method lazySequenceOver()mappedBy()object");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method lazySequenceOver()mappedBy()object");
  Object params[1];
  int partcv[2];
  Object *var_enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for lazySequenceOver()mappedBy (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_source = &(stackframe->slots[0]);
  *var_source = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for lazySequenceOver");
  Object *var_function = &(stackframe->slots[1]);
  *var_function = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for mappedBy");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start generics
  Object *var_T = &(stackframe->slots[3]);
  Object *var_R = &(stackframe->slots[4]);
  if (nparts == 1 + 2 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 2) {
      gracedie("insufficient generic parameters");
    }
    *var_T = args[curarg++];
    *var_R = args[curarg++];
  } else {
    *var_T = Unknown;
    *var_R = Unknown;
  }
// End generics
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5 = alloc_userobj2(6,7, objclass5);
  gc_frame_newslot(obj5);
if (objclass5 == NULL) {
  glfree(obj5->class->name);
  obj5->class->name = "self.lazySequenceOver()mappedBy";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5, self, 0);
  addmethodreal(obj5,"outer", &reader_collectionsPrelude_outer_6);
  Object oldself5 = self;
  struct StackFrameObject *oldstackframe5 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5);
  gc_frame_newslot((Object)stackframe);
  self = obj5;
  Object *oldselfslot5 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5 = (*(struct UserObject *)self).data[0], lowerouter5 = thisouter5;
  if (inheritingObject5) {
    struct UserObject *inho5 = (struct UserObject *)inheritingObject5;
    while (inho5->super != GraceDefaultObject) inho5 = (struct UserObject *)inho5->super;
    inho5->super = obj5;
    self = inheritingObject5;
    *selfslot = self;
    lowerouter5 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5;
  }
// method iterator
  block_savedest(obj5);
  Object closure7 = createclosure(2, "iterator");
  setclosureframe(closure7, stackframe);
  addtoclosure(closure7, var_function);
  addtoclosure(closure7, var_source);
  struct UserObject *uo7 = (struct UserObject*)obj5;
  uo7->data[1] = (Object)closure7;
  Method *meth_meth_collectionsPrelude_iterator7 = addmethod2pos(obj5, "iterator", &meth_collectionsPrelude_iterator7, 1);
  int argcv_meth_collectionsPrelude_iterator7[] = {0};
  meth_meth_collectionsPrelude_iterator7->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator7);
  meth_meth_collectionsPrelude_iterator7->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator7->definitionLine = 175;
  block_savedest(obj5);
  Object closure27 = createclosure(2, "iterator()object");
  setclosureframe(closure27, stackframe);
  addtoclosure(closure27, var_function);
  addtoclosure(closure27, var_source);
  Method *meth_meth_collectionsPrelude_iterator7_object = addmethod2pos(obj5, "iterator()object", &meth_collectionsPrelude_iterator7_object, 1);
  meth_meth_collectionsPrelude_iterator7_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator7_object->definitionLine = 175;
// method size
  block_savedest(obj5);
  Object closure28 = createclosure(1, "size");
  setclosureframe(closure28, stackframe);
  addtoclosure(closure28, var_source);
  struct UserObject *uo28 = (struct UserObject*)obj5;
  uo28->data[2] = (Object)closure28;
  Method *meth_meth_collectionsPrelude_size28 = addmethod2pos(obj5, "size", &meth_collectionsPrelude_size28, 2);
  int argcv_meth_collectionsPrelude_size28[] = {0};
  meth_meth_collectionsPrelude_size28->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size28);
  meth_meth_collectionsPrelude_size28->definitionModule = modulename;
  meth_meth_collectionsPrelude_size28->definitionLine = 181;
// method isEmpty
  block_savedest(obj5);
  Object closure31 = createclosure(1, "isEmpty");
  setclosureframe(closure31, stackframe);
  addtoclosure(closure31, var_source);
  struct UserObject *uo31 = (struct UserObject*)obj5;
  uo31->data[3] = (Object)closure31;
  Method *meth_meth_collectionsPrelude_isEmpty31 = addmethod2pos(obj5, "isEmpty", &meth_collectionsPrelude_isEmpty31, 3);
  int argcv_meth_collectionsPrelude_isEmpty31[] = {0};
  meth_meth_collectionsPrelude_isEmpty31->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_isEmpty31);
  meth_meth_collectionsPrelude_isEmpty31->definitionModule = modulename;
  meth_meth_collectionsPrelude_isEmpty31->definitionLine = 182;
// method asDebugString
  block_savedest(obj5);
  Object closure34 = createclosure(1, "asDebugString");
  setclosureframe(closure34, stackframe);
  addtoclosure(closure34, var_source);
  struct UserObject *uo34 = (struct UserObject*)obj5;
  uo34->data[4] = (Object)closure34;
  Method *meth_meth_collectionsPrelude_asDebugString34 = addmethod2pos(obj5, "asDebugString", &meth_collectionsPrelude_asDebugString34, 4);
  int argcv_meth_collectionsPrelude_asDebugString34[] = {0};
  meth_meth_collectionsPrelude_asDebugString34->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString34);
  meth_meth_collectionsPrelude_asDebugString34->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString34->definitionLine = 183;
  sourceObject = obj5;
// Begin line 174
  setline(174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe43 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call44 = callmethod(*var_enumerable, "trait()object",
    2, partcv, params);
  gc_frame_end(callframe43);
// compiled call node returning call44 (depth = 2)
  struct UserObject *obj5_uo = (struct UserObject *)obj5;
  obj5_uo->super = call44;
  sourceObject = obj5;
  sourceObject = obj5;
  sourceObject = obj5;
  sourceObject = obj5;
  objclass5 = obj5->class;
  objclass5->definitionModule = modulename;
  objclass5->definitionLine = 172;
  (*(struct UserObject *)self).data[0] = lowerouter5;
  self = oldself5;
  selfslot = oldselfslot5;
  stackframe = oldstackframe5;
  gc_frame_end(frame);
  return obj5;
}
Object meth_collectionsPrelude_asString55(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_source = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 193
  setline(193);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit57 == NULL) {
    strlit57 = alloc_String("");
    gc_root(strlit57);
  }
// compiled string node returning strlit57 (depth = 3)
  int op_slot_right_56 = gc_frame_newslot(strlit57);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_source (depth = 4)
  int op_slot_right_59 = gc_frame_newslot(*var_source);
// starting to compile string node (depth = 4)
  if (strlit61 == NULL) {
    strlit61 = alloc_String("an iterator over filtered ");
    gc_root(strlit61);
  }
// compiled string node returning strlit61 (depth = 4)
  int op_slot_left_59 = gc_frame_newslot(strlit61);
  params[0] = *var_source;
  partcv[0] = 1;
  Object opresult62 = callmethod(strlit61, "++", 1, partcv, params);
// compiled op node returning opresult62 (depth = 3)
  int op_slot_left_56 = gc_frame_newslot(opresult62);
  params[0] = strlit57;
  partcv[0] = 1;
  Object opresult63 = callmethod(opresult62, "++", 1, partcv, params);
// compiled op node returning opresult63 (depth = 2)
  gc_frame_end(frame);
  return opresult63;
}
Object meth_collectionsPrelude__apply71(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 4)
// Begin line 197
  setline(197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe72 = gc_frame_new();
// Begin line 199
  setline(199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe73 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call74 = callmethodflags(self, "nextAcceptableElement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe73);
// compiled call node returning call74 (depth = 7)
// compiled member node returning call74 (depth = 6)
  gc_frame_newslot(call74);
// call case 4: self request
  params[0] = call74;
  partcv[0] = 1;
  Object call75 = callmethodflags(self, "cache:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe72);
// compiled call node returning call75 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 200
  setline(200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 199
  setline(199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe76 = gc_frame_new();
// Begin line 200
  setline(200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool77 = alloc_Boolean(1);
// compiled identifier node returning bool77 (depth = 6)
  gc_frame_newslot(bool77);
// call case 4: self request
  params[0] = bool77;
  partcv[0] = 1;
  Object call78 = callmethodflags(self, "cacheLoaded:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe76);
// compiled call node returning call78 (depth = 5)
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude__apply81(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ex = &(stackframe->slots[0]);
  *var_ex = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool82 = alloc_Boolean(0);
// compiled identifier node returning bool82 (depth = 5)
  block_return(realself, bool82);
// compiled return node returning undefined (depth = 4)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_hasNext64(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_Exhausted = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for hasNext (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for hasNext");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 197
  setline(197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe66 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call67 = callmethodflags(self, "cacheLoaded", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe66);
// compiled call node returning call67 (depth = 4)
// compiled member node returning call67 (depth = 3)
  Object if65 = done;
  if (istrue(call67)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool68 = alloc_Boolean(1);
// compiled identifier node returning bool68 (depth = 4)
  return bool68;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if65 = undefined;
  } else {
  }
// compiled if node returning if65 (depth = 2)
// Begin line 198
  setline(198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile catchcase node (depth = 2)
// starting to compile block node (depth = 3)
  Object block70 = alloc_Block(NULL, NULL, "collectionsPrelude", 198);
  gc_frame_newslot(block70);
// method _apply
  block_savedest(block70);
  Object closure71 = createclosure(1, "_apply");
  setclosureframe(closure71, stackframe);
  addtoclosure(closure71, selfslot);
  struct UserObject *uo71 = (struct UserObject*)block70;
  uo71->data[0] = (Object)closure71;
  Method *meth_meth_collectionsPrelude__apply71 = addmethod2pos(block70, "_apply", &meth_collectionsPrelude__apply71, 0);
  int argcv_meth_collectionsPrelude__apply71[] = {0};
  meth_meth_collectionsPrelude__apply71->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply71);
  meth_meth_collectionsPrelude__apply71->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply71->definitionLine = 197;
// compiled block node returning block70 (depth = 3)
  int frame69 = gc_frame_new();
  gc_frame_newslot(block70);
// Begin line 201
  setline(201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block80 = alloc_Block(NULL, NULL, "collectionsPrelude", 201);
  gc_frame_newslot(block80);
// method _apply
  block_savedest(block80);
  Object closure81 = createclosure(1, "_apply");
  setclosureframe(closure81, stackframe);
  addtoclosure(closure81, selfslot);
  struct UserObject *uo81 = (struct UserObject*)block80;
  uo81->data[0] = (Object)closure81;
  Method *meth_meth_collectionsPrelude__apply81 = addmethod2pos(block80, "_apply", &meth_collectionsPrelude__apply81, 0);
  int argcv_meth_collectionsPrelude__apply81[] = {1};
  meth_meth_collectionsPrelude__apply81->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply81);
  meth_meth_collectionsPrelude__apply81->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply81->definitionLine = 199;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe84 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe85 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit86 == NULL) {
    strlit86 = alloc_String("ex");
    gc_root(strlit86);
  }
// compiled string node returning strlit86 (depth = 6)
  gc_frame_newslot(strlit86);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe87 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call88 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe87);
// compiled call node returning call88 (depth = 7)
// compiled member node returning call88 (depth = 6)
  params[0] = strlit86;
  partcv[0] = 1;
  Object call89 = callmethod(call88, "new",
    1, partcv, params);
  gc_frame_end(callframe85);
// compiled call node returning call89 (depth = 5)
  gc_frame_newslot(call89);
// Begin line 201
  setline(201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_Exhausted (depth = 5)
  gc_frame_newslot(*var_Exhausted);
// call case 6: other member request
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe90 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call91 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe90);
// compiled call node returning call91 (depth = 6)
// compiled member node returning call91 (depth = 5)
  params[0] = call89;
  params[1] = *var_Exhausted;
  partcv[0] = 2;
  Object call92 = callmethod(call91, "new",
    1, partcv, params);
  gc_frame_end(callframe84);
// compiled call node returning call92 (depth = 4)
((struct UserObject *)block80)->data[1] = call92;
// compiled block node returning block80 (depth = 3)
  gc_frame_newslot(block80);
  params[0] = block80;
  setline(198);
  Object catchres69 = catchCase(block70, params, 1,NULL);
  gc_frame_end(frame69);
// compiled catchcase node returning catchres69 (depth = 2)
// Begin line 202
  setline(202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool93 = alloc_Boolean(1);
// compiled identifier node returning bool93 (depth = 3)
  return bool93;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_next94(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for next (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for next");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 205
  setline(205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe96 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe97 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call98 = callmethodflags(self, "cacheLoaded", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe97);
// compiled call node returning call98 (depth = 6)
// compiled member node returning call98 (depth = 5)
  partcv[0] = 0;
  Object call99 = callmethod(call98, "not",
    1, partcv, params);
  gc_frame_end(callframe96);
// compiled call node returning call99 (depth = 4)
// compiled member node returning call99 (depth = 3)
  Object if95 = done;
  if (istrue(call99)) {
// starting to compile bind node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe100 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe101 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call102 = callmethodflags(self, "nextAcceptableElement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe101);
// compiled call node returning call102 (depth = 6)
// compiled member node returning call102 (depth = 5)
  gc_frame_newslot(call102);
// call case 4: self request
  params[0] = call102;
  partcv[0] = 1;
  Object call103 = callmethodflags(self, "cache:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe100);
// compiled call node returning call103 (depth = 4)
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if95 = done;
  } else {
  }
// compiled if node returning if95 (depth = 2)
// Begin line 206
  setline(206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 205
  setline(205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe104 = gc_frame_new();
// Begin line 206
  setline(206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool105 = alloc_Boolean(0);
// compiled identifier node returning bool105 (depth = 4)
  gc_frame_newslot(bool105);
// call case 4: self request
  params[0] = bool105;
  partcv[0] = 1;
  Object call106 = callmethodflags(self, "cacheLoaded:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe104);
// compiled call node returning call106 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 207
  setline(207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe107 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call108 = callmethodflags(self, "cache", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe107);
// compiled call node returning call108 (depth = 4)
// compiled member node returning call108 (depth = 3)
  return call108;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply112(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 4)
  Object bool113 = alloc_Boolean(1);
// compiled identifier node returning bool113 (depth = 4)
  gc_frame_end(frame);
  return bool113;
}
Object meth_collectionsPrelude__apply116(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_predicate = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_outerNext = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "outerNext");
  Object *var_acceptable = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "acceptable");
// Begin line 213
  setline(213);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe117 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe118 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call119 = callmethodflags(self, "sourceIterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe118);
// compiled call node returning call119 (depth = 8)
// compiled member node returning call119 (depth = 7)
  partcv[0] = 0;
  Object call120 = callmethod(call119, "next",
    1, partcv, params);
  gc_frame_end(callframe117);
// compiled call node returning call120 (depth = 6)
// compiled member node returning call120 (depth = 5)
  *var_outerNext = call120;
  if (call120 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 214
  setline(214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe121 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_outerNext (depth = 6)
  gc_frame_newslot(*var_outerNext);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_predicate (depth = 6)
  params[0] = *var_outerNext;
  partcv[0] = 1;
  Object call122 = callmethod(*var_predicate, "apply",
    1, partcv, params);
  gc_frame_end(callframe121);
// compiled call node returning call122 (depth = 5)
  *var_acceptable = call122;
  if (call122 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 215
  setline(215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_acceptable (depth = 5)
  Object if123 = done;
  if (istrue(*var_acceptable)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_outerNext (depth = 6)
  block_return(realself, *var_outerNext);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if123 = undefined;
  } else {
  }
// compiled if node returning if123 (depth = 4)
  gc_frame_end(frame);
  return if123;
}
Object meth_collectionsPrelude_nextAcceptableElement109(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "nextAcceptableElement");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_predicate = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for nextAcceptableElement (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for nextAcceptableElement");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 212
  setline(212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe110 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block111 = alloc_Block(NULL, NULL, "collectionsPrelude", 212);
  gc_frame_newslot(block111);
// method _apply
  block_savedest(block111);
  Object closure112 = createclosure(1, "_apply");
  setclosureframe(closure112, stackframe);
  addtoclosure(closure112, selfslot);
  struct UserObject *uo112 = (struct UserObject*)block111;
  uo112->data[0] = (Object)closure112;
  Method *meth_meth_collectionsPrelude__apply112 = addmethod2pos(block111, "_apply", &meth_collectionsPrelude__apply112, 0);
  int argcv_meth_collectionsPrelude__apply112[] = {0};
  meth_meth_collectionsPrelude__apply112->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply112);
  meth_meth_collectionsPrelude__apply112->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply112->definitionLine = 207;
// compiled block node returning block111 (depth = 3)
  gc_frame_newslot(block111);
// starting to compile block node (depth = 3)
  Object block115 = alloc_Block(NULL, NULL, "collectionsPrelude", 212);
  gc_frame_newslot(block115);
// method _apply
  block_savedest(block115);
  Object closure116 = createclosure(2, "_apply");
  setclosureframe(closure116, stackframe);
  addtoclosure(closure116, var_predicate);
  addtoclosure(closure116, selfslot);
  struct UserObject *uo116 = (struct UserObject*)block115;
  uo116->data[0] = (Object)closure116;
  Method *meth_meth_collectionsPrelude__apply116 = addmethod2pos(block115, "_apply", &meth_collectionsPrelude__apply116, 0);
  int argcv_meth_collectionsPrelude__apply116[] = {0};
  meth_meth_collectionsPrelude__apply116->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply116);
  meth_meth_collectionsPrelude__apply116->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply116->definitionLine = 207;
// compiled block node returning block115 (depth = 3)
  gc_frame_newslot(block115);
// call case 5: prelude request
  params[0] = block111;
  params[1] = block115;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call125 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe110);
// compiled call node returning call125 (depth = 2)
  gc_frame_end(frame);
  return call125;
}
Object meth_collectionsPrelude_iterator49(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_source = getfromclosure(closure, 0);
  Object *var_Exhausted = getfromclosure(closure, 1);
  Object *var_predicate = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject50 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj50 = alloc_userobj2(9,8, objclass50);
  gc_frame_newslot(obj50);
if (objclass50 == NULL) {
  glfree(obj50->class->name);
  obj50->class->name = "obj47.iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj50, self, 0);
  addmethodreal(obj50,"outer", &reader_collectionsPrelude_outer_51);
  Object oldself50 = self;
  struct StackFrameObject *oldstackframe50 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe50);
  gc_frame_newslot((Object)stackframe);
  self = obj50;
  Object *oldselfslot50 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter50 = (*(struct UserObject *)self).data[0], lowerouter50 = thisouter50;
  if (inheritingObject50) {
    struct UserObject *inho50 = (struct UserObject *)inheritingObject50;
    while (inho50->super != GraceDefaultObject) inho50 = (struct UserObject *)inho50->super;
    inho50->super = obj50;
    self = inheritingObject50;
    *selfslot = self;
    lowerouter50 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter50;
  }
if (objclass50 == NULL) {
  Method *reader52 = addmethodrealflags(obj50, "cache",&reader_collectionsPrelude_cache_52, MFLAG_CONFIDENTIAL);
  Method *writer52 = addmethodrealflags(obj50, "cache:=",&writer_collectionsPrelude_cache_52, MFLAG_CONFIDENTIAL);
  reader52->definitionModule = modulename;
  writer52->definitionModule = modulename;
  reader52->definitionLine = 190;
  writer52->definitionLine = 190;
}
obj50->flags |= OFLAG_MUTABLE;
adddatum2(obj50, alloc_Undefined(), 1);
if (objclass50 == NULL) {
  Method *reader53 = addmethodrealflags(obj50, "cacheLoaded",&reader_collectionsPrelude_cacheLoaded_53, MFLAG_CONFIDENTIAL);
  Method *writer53 = addmethodrealflags(obj50, "cacheLoaded:=",&writer_collectionsPrelude_cacheLoaded_53, MFLAG_CONFIDENTIAL);
  reader53->definitionModule = modulename;
  writer53->definitionModule = modulename;
  reader53->definitionLine = 191;
  writer53->definitionLine = 191;
}
obj50->flags |= OFLAG_MUTABLE;
adddatum2(obj50, alloc_Undefined(), 2);
if (objclass50 == NULL) {
  Method *reader54 = addmethodrealflags(obj50, "sourceIterator",&reader_collectionsPrelude_sourceIterator_54, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader54->definitionModule = modulename;
  reader54->definitionLine = 192;
}
adddatum2(obj50, alloc_Undefined(), 3);
// method asString
  block_savedest(obj50);
  Object closure55 = createclosure(1, "asString");
  setclosureframe(closure55, stackframe);
  addtoclosure(closure55, var_source);
  struct UserObject *uo55 = (struct UserObject*)obj50;
  uo55->data[4] = (Object)closure55;
  Method *meth_meth_collectionsPrelude_asString55 = addmethod2pos(obj50, "asString", &meth_collectionsPrelude_asString55, 4);
  int argcv_meth_collectionsPrelude_asString55[] = {0};
  meth_meth_collectionsPrelude_asString55->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString55);
  meth_meth_collectionsPrelude_asString55->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString55->definitionLine = 193;
// method hasNext
  block_savedest(obj50);
  Object closure64 = createclosure(1, "hasNext");
  setclosureframe(closure64, stackframe);
  addtoclosure(closure64, var_Exhausted);
  struct UserObject *uo64 = (struct UserObject*)obj50;
  uo64->data[5] = (Object)closure64;
  Method *meth_meth_collectionsPrelude_hasNext64 = addmethod2pos(obj50, "hasNext", &meth_collectionsPrelude_hasNext64, 5);
  int argcv_meth_collectionsPrelude_hasNext64[] = {0};
  meth_meth_collectionsPrelude_hasNext64->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext64);
  meth_meth_collectionsPrelude_hasNext64->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext64->definitionLine = 194;
// method next
  struct UserObject *uo94 = (struct UserObject*)obj50;
  uo94->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_next94 = addmethod2pos(obj50, "next", &meth_collectionsPrelude_next94, 6);
  int argcv_meth_collectionsPrelude_next94[] = {0};
  meth_meth_collectionsPrelude_next94->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next94);
  meth_meth_collectionsPrelude_next94->definitionModule = modulename;
  meth_meth_collectionsPrelude_next94->definitionLine = 204;
// method nextAcceptableElement
  block_savedest(obj50);
  Object closure109 = createclosure(1, "nextAcceptableElement");
  setclosureframe(closure109, stackframe);
  addtoclosure(closure109, var_predicate);
  struct UserObject *uo109 = (struct UserObject*)obj50;
  uo109->data[7] = (Object)closure109;
  Method *meth_meth_collectionsPrelude_nextAcceptableElement109 = addmethod2pos(obj50, "nextAcceptableElement", &meth_collectionsPrelude_nextAcceptableElement109, 7);
  int argcv_meth_collectionsPrelude_nextAcceptableElement109[] = {0};
  meth_meth_collectionsPrelude_nextAcceptableElement109->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_nextAcceptableElement109);
  meth_meth_collectionsPrelude_nextAcceptableElement109->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_nextAcceptableElement109->definitionModule = modulename;
  meth_meth_collectionsPrelude_nextAcceptableElement109->definitionLine = 209;
  sourceObject = obj50;
  adddatum2(obj50, undefined, 1);
  sourceObject = obj50;
// Begin line 191
  setline(191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool126 = alloc_Boolean(0);
// compiled identifier node returning bool126 (depth = 2)
  adddatum2(obj50, bool126, 2);
  sourceObject = obj50;
// Begin line 192
  setline(192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe127 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_source (depth = 4)
  partcv[0] = 0;
  Object call128 = callmethod(*var_source, "iterator",
    1, partcv, params);
  gc_frame_end(callframe127);
// compiled call node returning call128 (depth = 3)
// compiled member node returning call128 (depth = 2)
  adddatum2(obj50, call128, 3);
  sourceObject = obj50;
  sourceObject = obj50;
  sourceObject = obj50;
  sourceObject = obj50;
  objclass50 = obj50->class;
  objclass50->definitionModule = modulename;
  objclass50->definitionLine = 189;
  (*(struct UserObject *)self).data[0] = lowerouter50;
  self = oldself50;
  selfslot = oldselfslot50;
  stackframe = oldstackframe50;
  gc_frame_end(frame);
  return obj50;
}
Object meth_collectionsPrelude_iterator49_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_source = getfromclosure(closure, 0);
  Object *var_Exhausted = getfromclosure(closure, 1);
  Object *var_predicate = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject50 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj50 = alloc_userobj2(9,8, objclass50);
  gc_frame_newslot(obj50);
if (objclass50 == NULL) {
  glfree(obj50->class->name);
  obj50->class->name = "obj47.iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj50, self, 0);
  addmethodreal(obj50,"outer", &reader_collectionsPrelude_outer_51);
  Object oldself50 = self;
  struct StackFrameObject *oldstackframe50 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe50);
  gc_frame_newslot((Object)stackframe);
  self = obj50;
  Object *oldselfslot50 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter50 = (*(struct UserObject *)self).data[0], lowerouter50 = thisouter50;
  if (inheritingObject50) {
    struct UserObject *inho50 = (struct UserObject *)inheritingObject50;
    while (inho50->super != GraceDefaultObject) inho50 = (struct UserObject *)inho50->super;
    inho50->super = obj50;
    self = inheritingObject50;
    *selfslot = self;
    lowerouter50 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter50;
  }
if (objclass50 == NULL) {
  Method *reader52 = addmethodrealflags(obj50, "cache",&reader_collectionsPrelude_cache_52, MFLAG_CONFIDENTIAL);
  Method *writer52 = addmethodrealflags(obj50, "cache:=",&writer_collectionsPrelude_cache_52, MFLAG_CONFIDENTIAL);
  reader52->definitionModule = modulename;
  writer52->definitionModule = modulename;
  reader52->definitionLine = 190;
  writer52->definitionLine = 190;
}
obj50->flags |= OFLAG_MUTABLE;
adddatum2(obj50, alloc_Undefined(), 1);
if (objclass50 == NULL) {
  Method *reader53 = addmethodrealflags(obj50, "cacheLoaded",&reader_collectionsPrelude_cacheLoaded_53, MFLAG_CONFIDENTIAL);
  Method *writer53 = addmethodrealflags(obj50, "cacheLoaded:=",&writer_collectionsPrelude_cacheLoaded_53, MFLAG_CONFIDENTIAL);
  reader53->definitionModule = modulename;
  writer53->definitionModule = modulename;
  reader53->definitionLine = 191;
  writer53->definitionLine = 191;
}
obj50->flags |= OFLAG_MUTABLE;
adddatum2(obj50, alloc_Undefined(), 2);
if (objclass50 == NULL) {
  Method *reader54 = addmethodrealflags(obj50, "sourceIterator",&reader_collectionsPrelude_sourceIterator_54, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader54->definitionModule = modulename;
  reader54->definitionLine = 192;
}
adddatum2(obj50, alloc_Undefined(), 3);
// method asString
  block_savedest(obj50);
  Object closure55 = createclosure(1, "asString");
  setclosureframe(closure55, stackframe);
  addtoclosure(closure55, var_source);
  struct UserObject *uo55 = (struct UserObject*)obj50;
  uo55->data[4] = (Object)closure55;
  Method *meth_meth_collectionsPrelude_asString55 = addmethod2pos(obj50, "asString", &meth_collectionsPrelude_asString55, 4);
  int argcv_meth_collectionsPrelude_asString55[] = {0};
  meth_meth_collectionsPrelude_asString55->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString55);
  meth_meth_collectionsPrelude_asString55->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString55->definitionLine = 193;
// method hasNext
  block_savedest(obj50);
  Object closure64 = createclosure(1, "hasNext");
  setclosureframe(closure64, stackframe);
  addtoclosure(closure64, var_Exhausted);
  struct UserObject *uo64 = (struct UserObject*)obj50;
  uo64->data[5] = (Object)closure64;
  Method *meth_meth_collectionsPrelude_hasNext64 = addmethod2pos(obj50, "hasNext", &meth_collectionsPrelude_hasNext64, 5);
  int argcv_meth_collectionsPrelude_hasNext64[] = {0};
  meth_meth_collectionsPrelude_hasNext64->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext64);
  meth_meth_collectionsPrelude_hasNext64->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext64->definitionLine = 194;
// method next
  struct UserObject *uo94 = (struct UserObject*)obj50;
  uo94->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_next94 = addmethod2pos(obj50, "next", &meth_collectionsPrelude_next94, 6);
  int argcv_meth_collectionsPrelude_next94[] = {0};
  meth_meth_collectionsPrelude_next94->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next94);
  meth_meth_collectionsPrelude_next94->definitionModule = modulename;
  meth_meth_collectionsPrelude_next94->definitionLine = 204;
// method nextAcceptableElement
  block_savedest(obj50);
  Object closure109 = createclosure(1, "nextAcceptableElement");
  setclosureframe(closure109, stackframe);
  addtoclosure(closure109, var_predicate);
  struct UserObject *uo109 = (struct UserObject*)obj50;
  uo109->data[7] = (Object)closure109;
  Method *meth_meth_collectionsPrelude_nextAcceptableElement109 = addmethod2pos(obj50, "nextAcceptableElement", &meth_collectionsPrelude_nextAcceptableElement109, 7);
  int argcv_meth_collectionsPrelude_nextAcceptableElement109[] = {0};
  meth_meth_collectionsPrelude_nextAcceptableElement109->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_nextAcceptableElement109);
  meth_meth_collectionsPrelude_nextAcceptableElement109->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_nextAcceptableElement109->definitionModule = modulename;
  meth_meth_collectionsPrelude_nextAcceptableElement109->definitionLine = 209;
  sourceObject = obj50;
  adddatum2(obj50, undefined, 1);
  sourceObject = obj50;
// Begin line 191
  setline(191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool126 = alloc_Boolean(0);
// compiled identifier node returning bool126 (depth = 2)
  adddatum2(obj50, bool126, 2);
  sourceObject = obj50;
// Begin line 192
  setline(192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe127 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_source (depth = 4)
  partcv[0] = 0;
  Object call128 = callmethod(*var_source, "iterator",
    1, partcv, params);
  gc_frame_end(callframe127);
// compiled call node returning call128 (depth = 3)
// compiled member node returning call128 (depth = 2)
  adddatum2(obj50, call128, 3);
  sourceObject = obj50;
  sourceObject = obj50;
  sourceObject = obj50;
  sourceObject = obj50;
  objclass50 = obj50->class;
  objclass50->definitionModule = modulename;
  objclass50->definitionLine = 189;
  (*(struct UserObject *)self).data[0] = lowerouter50;
  self = oldself50;
  selfslot = oldselfslot50;
  stackframe = oldstackframe50;
  gc_frame_end(frame);
  return obj50;
}
Object meth_collectionsPrelude_asDebugString130(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_source = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asDebugString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asDebugString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 219
  setline(219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit132 == NULL) {
    strlit132 = alloc_String("");
    gc_root(strlit132);
  }
// compiled string node returning strlit132 (depth = 3)
  int op_slot_right_131 = gc_frame_newslot(strlit132);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_source (depth = 4)
  int op_slot_right_134 = gc_frame_newslot(*var_source);
// starting to compile string node (depth = 4)
  if (strlit136 == NULL) {
    strlit136 = alloc_String("a lazy sequence filtering ");
    gc_root(strlit136);
  }
// compiled string node returning strlit136 (depth = 4)
  int op_slot_left_134 = gc_frame_newslot(strlit136);
  params[0] = *var_source;
  partcv[0] = 1;
  Object opresult137 = callmethod(strlit136, "++", 1, partcv, params);
// compiled op node returning opresult137 (depth = 3)
  int op_slot_left_131 = gc_frame_newslot(opresult137);
  params[0] = strlit132;
  partcv[0] = 1;
  Object opresult138 = callmethod(opresult137, "++", 1, partcv, params);
// compiled op node returning opresult138 (depth = 2)
  gc_frame_end(frame);
  return opresult138;
}
Object meth_collectionsPrelude_lazySequenceOver_40__41_filteredBy46(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lazySequenceOver()filteredBy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method lazySequenceOver()filteredBy");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method lazySequenceOver()filteredBy");
  Object params[1];
  int partcv[2];
  Object *var_Exhausted = getfromclosure(closure, 0);
  Object *var_enumerable = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for lazySequenceOver()filteredBy (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_source = &(stackframe->slots[0]);
  *var_source = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for lazySequenceOver");
  Object *var_predicate = &(stackframe->slots[1]);
  *var_predicate = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for filteredBy");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start generics
  Object *var_T = &(stackframe->slots[3]);
  if (nparts == 1 + 2 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      gracedie("insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End generics
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject47 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj47 = alloc_userobj2(4,5, objclass47);
  gc_frame_newslot(obj47);
if (objclass47 == NULL) {
  glfree(obj47->class->name);
  obj47->class->name = "self.lazySequenceOver()filteredBy";
}
// OBJECT OUTER DEC outer
  adddatum2(obj47, self, 0);
  addmethodreal(obj47,"outer", &reader_collectionsPrelude_outer_48);
  Object oldself47 = self;
  struct StackFrameObject *oldstackframe47 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe47);
  gc_frame_newslot((Object)stackframe);
  self = obj47;
  Object *oldselfslot47 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter47 = (*(struct UserObject *)self).data[0], lowerouter47 = thisouter47;
  if (inheritingObject47) {
    struct UserObject *inho47 = (struct UserObject *)inheritingObject47;
    while (inho47->super != GraceDefaultObject) inho47 = (struct UserObject *)inho47->super;
    inho47->super = obj47;
    self = inheritingObject47;
    *selfslot = self;
    lowerouter47 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter47;
  }
// method iterator
  block_savedest(obj47);
  Object closure49 = createclosure(3, "iterator");
  setclosureframe(closure49, stackframe);
  addtoclosure(closure49, var_source);
  addtoclosure(closure49, var_Exhausted);
  addtoclosure(closure49, var_predicate);
  struct UserObject *uo49 = (struct UserObject*)obj47;
  uo49->data[1] = (Object)closure49;
  Method *meth_meth_collectionsPrelude_iterator49 = addmethod2pos(obj47, "iterator", &meth_collectionsPrelude_iterator49, 1);
  int argcv_meth_collectionsPrelude_iterator49[] = {0};
  meth_meth_collectionsPrelude_iterator49->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator49);
  meth_meth_collectionsPrelude_iterator49->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator49->definitionLine = 189;
  block_savedest(obj47);
  Object closure129 = createclosure(3, "iterator()object");
  setclosureframe(closure129, stackframe);
  addtoclosure(closure129, var_source);
  addtoclosure(closure129, var_Exhausted);
  addtoclosure(closure129, var_predicate);
  Method *meth_meth_collectionsPrelude_iterator49_object = addmethod2pos(obj47, "iterator()object", &meth_collectionsPrelude_iterator49_object, 1);
  meth_meth_collectionsPrelude_iterator49_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator49_object->definitionLine = 189;
// method asDebugString
  block_savedest(obj47);
  Object closure130 = createclosure(1, "asDebugString");
  setclosureframe(closure130, stackframe);
  addtoclosure(closure130, var_source);
  struct UserObject *uo130 = (struct UserObject*)obj47;
  uo130->data[2] = (Object)closure130;
  Method *meth_meth_collectionsPrelude_asDebugString130 = addmethod2pos(obj47, "asDebugString", &meth_collectionsPrelude_asDebugString130, 2);
  int argcv_meth_collectionsPrelude_asDebugString130[] = {0};
  meth_meth_collectionsPrelude_asDebugString130->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString130);
  meth_meth_collectionsPrelude_asDebugString130->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString130->definitionLine = 219;
  sourceObject = obj47;
// Begin line 188
  setline(188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe139 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call140 = callmethod(*var_enumerable, "trait()object",
    2, partcv, params);
  gc_frame_end(callframe139);
// compiled call node returning call140 (depth = 2)
  struct UserObject *obj47_uo = (struct UserObject *)obj47;
  obj47_uo->super = call140;
  sourceObject = obj47;
  sourceObject = obj47;
  objclass47 = obj47->class;
  objclass47->definitionModule = modulename;
  objclass47->definitionLine = 186;
  (*(struct UserObject *)self).data[0] = lowerouter47;
  self = oldself47;
  selfslot = oldselfslot47;
  stackframe = oldstackframe47;
  gc_frame_end(frame);
  return obj47;
}
Object meth_collectionsPrelude_lazySequenceOver_40__41_filteredBy46_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lazySequenceOver()filteredBy()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0] + argcv[1]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method lazySequenceOver()filteredBy()object");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method lazySequenceOver()filteredBy()object");
  Object params[1];
  int partcv[2];
  Object *var_Exhausted = getfromclosure(closure, 0);
  Object *var_enumerable = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for lazySequenceOver()filteredBy (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_source = &(stackframe->slots[0]);
  *var_source = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for lazySequenceOver");
  Object *var_predicate = &(stackframe->slots[1]);
  *var_predicate = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for filteredBy");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start generics
  Object *var_T = &(stackframe->slots[3]);
  if (nparts == 1 + 2 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      gracedie("insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End generics
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject47 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj47 = alloc_userobj2(4,5, objclass47);
  gc_frame_newslot(obj47);
if (objclass47 == NULL) {
  glfree(obj47->class->name);
  obj47->class->name = "self.lazySequenceOver()filteredBy";
}
// OBJECT OUTER DEC outer
  adddatum2(obj47, self, 0);
  addmethodreal(obj47,"outer", &reader_collectionsPrelude_outer_48);
  Object oldself47 = self;
  struct StackFrameObject *oldstackframe47 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe47);
  gc_frame_newslot((Object)stackframe);
  self = obj47;
  Object *oldselfslot47 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter47 = (*(struct UserObject *)self).data[0], lowerouter47 = thisouter47;
  if (inheritingObject47) {
    struct UserObject *inho47 = (struct UserObject *)inheritingObject47;
    while (inho47->super != GraceDefaultObject) inho47 = (struct UserObject *)inho47->super;
    inho47->super = obj47;
    self = inheritingObject47;
    *selfslot = self;
    lowerouter47 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter47;
  }
// method iterator
  block_savedest(obj47);
  Object closure49 = createclosure(3, "iterator");
  setclosureframe(closure49, stackframe);
  addtoclosure(closure49, var_source);
  addtoclosure(closure49, var_Exhausted);
  addtoclosure(closure49, var_predicate);
  struct UserObject *uo49 = (struct UserObject*)obj47;
  uo49->data[1] = (Object)closure49;
  Method *meth_meth_collectionsPrelude_iterator49 = addmethod2pos(obj47, "iterator", &meth_collectionsPrelude_iterator49, 1);
  int argcv_meth_collectionsPrelude_iterator49[] = {0};
  meth_meth_collectionsPrelude_iterator49->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator49);
  meth_meth_collectionsPrelude_iterator49->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator49->definitionLine = 189;
  block_savedest(obj47);
  Object closure129 = createclosure(3, "iterator()object");
  setclosureframe(closure129, stackframe);
  addtoclosure(closure129, var_source);
  addtoclosure(closure129, var_Exhausted);
  addtoclosure(closure129, var_predicate);
  Method *meth_meth_collectionsPrelude_iterator49_object = addmethod2pos(obj47, "iterator()object", &meth_collectionsPrelude_iterator49_object, 1);
  meth_meth_collectionsPrelude_iterator49_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator49_object->definitionLine = 189;
// method asDebugString
  block_savedest(obj47);
  Object closure130 = createclosure(1, "asDebugString");
  setclosureframe(closure130, stackframe);
  addtoclosure(closure130, var_source);
  struct UserObject *uo130 = (struct UserObject*)obj47;
  uo130->data[2] = (Object)closure130;
  Method *meth_meth_collectionsPrelude_asDebugString130 = addmethod2pos(obj47, "asDebugString", &meth_collectionsPrelude_asDebugString130, 2);
  int argcv_meth_collectionsPrelude_asDebugString130[] = {0};
  meth_meth_collectionsPrelude_asDebugString130->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString130);
  meth_meth_collectionsPrelude_asDebugString130->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString130->definitionLine = 219;
  sourceObject = obj47;
// Begin line 188
  setline(188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe139 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call140 = callmethod(*var_enumerable, "trait()object",
    2, partcv, params);
  gc_frame_end(callframe139);
// compiled call node returning call140 (depth = 2)
  struct UserObject *obj47_uo = (struct UserObject *)obj47;
  obj47_uo->super = call140;
  sourceObject = obj47;
  sourceObject = obj47;
  objclass47 = obj47->class;
  objclass47->definitionModule = modulename;
  objclass47->definitionLine = 186;
  (*(struct UserObject *)self).data[0] = lowerouter47;
  self = oldself47;
  selfslot = oldselfslot47;
  stackframe = oldstackframe47;
  gc_frame_end(frame);
  return obj47;
}
Object meth_collectionsPrelude_next145(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_left = getfromclosure(closure, 0);
  Object *var_right = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for next (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for next");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 223
  setline(223);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe147 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_left (depth = 5)
  partcv[0] = 0;
  Object call148 = callmethod(*var_left, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe147);
// compiled call node returning call148 (depth = 4)
// compiled member node returning call148 (depth = 3)
  Object if146 = done;
  if (istrue(call148)) {
// Begin line 224
  setline(224);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe149 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_left (depth = 5)
  partcv[0] = 0;
  Object call150 = callmethod(*var_left, "next",
    1, partcv, params);
  gc_frame_end(callframe149);
// compiled call node returning call150 (depth = 4)
// compiled member node returning call150 (depth = 3)
    gc_frame_newslot(call150);
    if146 = call150;
  } else {
// Begin line 226
  setline(226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe151 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_right (depth = 5)
  partcv[0] = 0;
  Object call152 = callmethod(*var_right, "next",
    1, partcv, params);
  gc_frame_end(callframe151);
// compiled call node returning call152 (depth = 4)
// compiled member node returning call152 (depth = 3)
    gc_frame_newslot(call152);
    if146 = call152;
  }
// compiled if node returning if146 (depth = 2)
  gc_frame_end(frame);
  return if146;
}
Object meth_collectionsPrelude_hasNext153(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_left = getfromclosure(closure, 0);
  Object *var_right = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for hasNext (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for hasNext");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 230
  setline(230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe155 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_left (depth = 5)
  partcv[0] = 0;
  Object call156 = callmethod(*var_left, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe155);
// compiled call node returning call156 (depth = 4)
// compiled member node returning call156 (depth = 3)
  Object if154 = done;
  if (istrue(call156)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool157 = alloc_Boolean(1);
// compiled identifier node returning bool157 (depth = 4)
  return bool157;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if154 = undefined;
  } else {
  }
// compiled if node returning if154 (depth = 2)
// Begin line 231
  setline(231);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe158 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_right (depth = 5)
  partcv[0] = 0;
  Object call159 = callmethod(*var_right, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe158);
// compiled call node returning call159 (depth = 4)
// compiled member node returning call159 (depth = 3)
  return call159;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_asDebugString160(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_right = getfromclosure(closure, 0);
  Object *var_left = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asDebugString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asDebugString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 233
  setline(233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit162 == NULL) {
    strlit162 = alloc_String("");
    gc_root(strlit162);
  }
// compiled string node returning strlit162 (depth = 3)
  int op_slot_right_161 = gc_frame_newslot(strlit162);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_right (depth = 4)
  int op_slot_right_164 = gc_frame_newslot(*var_right);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit167 == NULL) {
    strlit167 = alloc_String(" and ");
    gc_root(strlit167);
  }
// compiled string node returning strlit167 (depth = 5)
  int op_slot_right_166 = gc_frame_newslot(strlit167);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_left (depth = 6)
  int op_slot_right_169 = gc_frame_newslot(*var_left);
// starting to compile string node (depth = 6)
  if (strlit171 == NULL) {
    strlit171 = alloc_String("iteratorConcat of ");
    gc_root(strlit171);
  }
// compiled string node returning strlit171 (depth = 6)
  int op_slot_left_169 = gc_frame_newslot(strlit171);
  params[0] = *var_left;
  partcv[0] = 1;
  Object opresult172 = callmethod(strlit171, "++", 1, partcv, params);
// compiled op node returning opresult172 (depth = 5)
  int op_slot_left_166 = gc_frame_newslot(opresult172);
  params[0] = strlit167;
  partcv[0] = 1;
  Object opresult173 = callmethod(opresult172, "++", 1, partcv, params);
// compiled op node returning opresult173 (depth = 4)
  int op_slot_left_164 = gc_frame_newslot(opresult173);
  params[0] = *var_right;
  partcv[0] = 1;
  Object opresult174 = callmethod(opresult173, "++", 1, partcv, params);
// compiled op node returning opresult174 (depth = 3)
  int op_slot_left_161 = gc_frame_newslot(opresult174);
  params[0] = strlit162;
  partcv[0] = 1;
  Object opresult175 = callmethod(opresult174, "++", 1, partcv, params);
// compiled op node returning opresult175 (depth = 2)
  gc_frame_end(frame);
  return opresult175;
}
Object meth_collectionsPrelude_asString176(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 234
  setline(234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit177 == NULL) {
    strlit177 = alloc_String("an iterator over a concatenation");
    gc_root(strlit177);
  }
// compiled string node returning strlit177 (depth = 2)
  gc_frame_end(frame);
  return strlit177;
}
Object meth_collectionsPrelude_iteratorConcat142(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "iteratorConcat");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method iteratorConcat");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for iteratorConcat (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_left = &(stackframe->slots[0]);
  *var_left = args[curarg];
  curarg++;
  Object *var_right = &(stackframe->slots[1]);
  *var_right = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for iteratorConcat");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start generics
  Object *var_T = &(stackframe->slots[3]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      gracedie("insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End generics
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject143 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj143 = alloc_userobj2(4,5, objclass143);
  gc_frame_newslot(obj143);
if (objclass143 == NULL) {
  glfree(obj143->class->name);
  obj143->class->name = "self.iteratorConcat";
}
// OBJECT OUTER DEC outer
  adddatum2(obj143, self, 0);
  addmethodreal(obj143,"outer", &reader_collectionsPrelude_outer_144);
  Object oldself143 = self;
  struct StackFrameObject *oldstackframe143 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe143);
  gc_frame_newslot((Object)stackframe);
  self = obj143;
  Object *oldselfslot143 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter143 = (*(struct UserObject *)self).data[0], lowerouter143 = thisouter143;
  if (inheritingObject143) {
    struct UserObject *inho143 = (struct UserObject *)inheritingObject143;
    while (inho143->super != GraceDefaultObject) inho143 = (struct UserObject *)inho143->super;
    inho143->super = obj143;
    self = inheritingObject143;
    *selfslot = self;
    lowerouter143 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter143;
  }
// method next
  block_savedest(obj143);
  Object closure145 = createclosure(2, "next");
  setclosureframe(closure145, stackframe);
  addtoclosure(closure145, var_left);
  addtoclosure(closure145, var_right);
  struct UserObject *uo145 = (struct UserObject*)obj143;
  uo145->data[1] = (Object)closure145;
  Method *meth_meth_collectionsPrelude_next145 = addmethod2pos(obj143, "next", &meth_collectionsPrelude_next145, 1);
  int argcv_meth_collectionsPrelude_next145[] = {0};
  meth_meth_collectionsPrelude_next145->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next145);
  meth_meth_collectionsPrelude_next145->definitionModule = modulename;
  meth_meth_collectionsPrelude_next145->definitionLine = 222;
// method hasNext
  block_savedest(obj143);
  Object closure153 = createclosure(2, "hasNext");
  setclosureframe(closure153, stackframe);
  addtoclosure(closure153, var_left);
  addtoclosure(closure153, var_right);
  struct UserObject *uo153 = (struct UserObject*)obj143;
  uo153->data[2] = (Object)closure153;
  Method *meth_meth_collectionsPrelude_hasNext153 = addmethod2pos(obj143, "hasNext", &meth_collectionsPrelude_hasNext153, 2);
  int argcv_meth_collectionsPrelude_hasNext153[] = {0};
  meth_meth_collectionsPrelude_hasNext153->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext153);
  meth_meth_collectionsPrelude_hasNext153->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext153->definitionLine = 229;
// method asDebugString
  block_savedest(obj143);
  Object closure160 = createclosure(2, "asDebugString");
  setclosureframe(closure160, stackframe);
  addtoclosure(closure160, var_right);
  addtoclosure(closure160, var_left);
  struct UserObject *uo160 = (struct UserObject*)obj143;
  uo160->data[3] = (Object)closure160;
  Method *meth_meth_collectionsPrelude_asDebugString160 = addmethod2pos(obj143, "asDebugString", &meth_collectionsPrelude_asDebugString160, 3);
  int argcv_meth_collectionsPrelude_asDebugString160[] = {0};
  meth_meth_collectionsPrelude_asDebugString160->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString160);
  meth_meth_collectionsPrelude_asDebugString160->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString160->definitionLine = 233;
// method asString
  struct UserObject *uo176 = (struct UserObject*)obj143;
  uo176->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString176 = addmethod2pos(obj143, "asString", &meth_collectionsPrelude_asString176, 4);
  int argcv_meth_collectionsPrelude_asString176[] = {0};
  meth_meth_collectionsPrelude_asString176->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString176);
  meth_meth_collectionsPrelude_asString176->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString176->definitionLine = 234;
  sourceObject = obj143;
  sourceObject = obj143;
  sourceObject = obj143;
  sourceObject = obj143;
  objclass143 = obj143->class;
  objclass143->definitionModule = modulename;
  objclass143->definitionLine = 221;
  (*(struct UserObject *)self).data[0] = lowerouter143;
  self = oldself143;
  selfslot = oldselfslot143;
  stackframe = oldstackframe143;
  gc_frame_end(frame);
  return obj143;
}
Object meth_collectionsPrelude_iteratorConcat142_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "iteratorConcat()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method iteratorConcat()object");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for iteratorConcat (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_left = &(stackframe->slots[0]);
  *var_left = args[curarg];
  curarg++;
  Object *var_right = &(stackframe->slots[1]);
  *var_right = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for iteratorConcat");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start generics
  Object *var_T = &(stackframe->slots[3]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      gracedie("insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End generics
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject143 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj143 = alloc_userobj2(4,5, objclass143);
  gc_frame_newslot(obj143);
if (objclass143 == NULL) {
  glfree(obj143->class->name);
  obj143->class->name = "self.iteratorConcat";
}
// OBJECT OUTER DEC outer
  adddatum2(obj143, self, 0);
  addmethodreal(obj143,"outer", &reader_collectionsPrelude_outer_144);
  Object oldself143 = self;
  struct StackFrameObject *oldstackframe143 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe143);
  gc_frame_newslot((Object)stackframe);
  self = obj143;
  Object *oldselfslot143 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter143 = (*(struct UserObject *)self).data[0], lowerouter143 = thisouter143;
  if (inheritingObject143) {
    struct UserObject *inho143 = (struct UserObject *)inheritingObject143;
    while (inho143->super != GraceDefaultObject) inho143 = (struct UserObject *)inho143->super;
    inho143->super = obj143;
    self = inheritingObject143;
    *selfslot = self;
    lowerouter143 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter143;
  }
// method next
  block_savedest(obj143);
  Object closure145 = createclosure(2, "next");
  setclosureframe(closure145, stackframe);
  addtoclosure(closure145, var_left);
  addtoclosure(closure145, var_right);
  struct UserObject *uo145 = (struct UserObject*)obj143;
  uo145->data[1] = (Object)closure145;
  Method *meth_meth_collectionsPrelude_next145 = addmethod2pos(obj143, "next", &meth_collectionsPrelude_next145, 1);
  int argcv_meth_collectionsPrelude_next145[] = {0};
  meth_meth_collectionsPrelude_next145->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next145);
  meth_meth_collectionsPrelude_next145->definitionModule = modulename;
  meth_meth_collectionsPrelude_next145->definitionLine = 222;
// method hasNext
  block_savedest(obj143);
  Object closure153 = createclosure(2, "hasNext");
  setclosureframe(closure153, stackframe);
  addtoclosure(closure153, var_left);
  addtoclosure(closure153, var_right);
  struct UserObject *uo153 = (struct UserObject*)obj143;
  uo153->data[2] = (Object)closure153;
  Method *meth_meth_collectionsPrelude_hasNext153 = addmethod2pos(obj143, "hasNext", &meth_collectionsPrelude_hasNext153, 2);
  int argcv_meth_collectionsPrelude_hasNext153[] = {0};
  meth_meth_collectionsPrelude_hasNext153->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext153);
  meth_meth_collectionsPrelude_hasNext153->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext153->definitionLine = 229;
// method asDebugString
  block_savedest(obj143);
  Object closure160 = createclosure(2, "asDebugString");
  setclosureframe(closure160, stackframe);
  addtoclosure(closure160, var_right);
  addtoclosure(closure160, var_left);
  struct UserObject *uo160 = (struct UserObject*)obj143;
  uo160->data[3] = (Object)closure160;
  Method *meth_meth_collectionsPrelude_asDebugString160 = addmethod2pos(obj143, "asDebugString", &meth_collectionsPrelude_asDebugString160, 3);
  int argcv_meth_collectionsPrelude_asDebugString160[] = {0};
  meth_meth_collectionsPrelude_asDebugString160->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString160);
  meth_meth_collectionsPrelude_asDebugString160->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString160->definitionLine = 233;
// method asString
  struct UserObject *uo176 = (struct UserObject*)obj143;
  uo176->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString176 = addmethod2pos(obj143, "asString", &meth_collectionsPrelude_asString176, 4);
  int argcv_meth_collectionsPrelude_asString176[] = {0};
  meth_meth_collectionsPrelude_asString176->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString176);
  meth_meth_collectionsPrelude_asString176->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString176->definitionLine = 234;
  sourceObject = obj143;
  sourceObject = obj143;
  sourceObject = obj143;
  sourceObject = obj143;
  objclass143 = obj143->class;
  objclass143->definitionModule = modulename;
  objclass143->definitionLine = 221;
  (*(struct UserObject *)self).data[0] = lowerouter143;
  self = oldself143;
  selfslot = oldselfslot143;
  stackframe = oldstackframe143;
  gc_frame_end(frame);
  return obj143;
}
Object meth_collectionsPrelude_iterator182(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_left = getfromclosure(closure, 0);
  Object *var_right = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 239
  setline(239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe183 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe184 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_left (depth = 5)
  partcv[0] = 0;
  Object call185 = callmethod(*var_left, "iterator",
    1, partcv, params);
  gc_frame_end(callframe184);
// compiled call node returning call185 (depth = 4)
// compiled member node returning call185 (depth = 3)
  gc_frame_newslot(call185);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe186 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_right (depth = 5)
  partcv[0] = 0;
  Object call187 = callmethod(*var_right, "iterator",
    1, partcv, params);
  gc_frame_end(callframe186);
// compiled call node returning call187 (depth = 4)
// compiled member node returning call187 (depth = 3)
  gc_frame_newslot(call187);
// call case 2: outer request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe188 = gc_frame_new();
// call case 3: self.outer request
  Object call189 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe188);
// compiled call node returning call189 (depth = 4)
// compiled member node returning call189 (depth = 3)
  params[0] = call185;
  params[1] = call187;
  partcv[0] = 2;
  Object call190 = callmethodflags(call189, "iteratorConcat", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe183);
// compiled call node returning call190 (depth = 2)
  gc_frame_end(frame);
  return call190;
}
Object meth_collectionsPrelude_asDebugString191(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_right = getfromclosure(closure, 0);
  Object *var_left = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asDebugString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asDebugString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 241
  setline(241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit193 == NULL) {
    strlit193 = alloc_String("");
    gc_root(strlit193);
  }
// compiled string node returning strlit193 (depth = 3)
  int op_slot_right_192 = gc_frame_newslot(strlit193);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_right (depth = 4)
  int op_slot_right_195 = gc_frame_newslot(*var_right);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit198 == NULL) {
    strlit198 = alloc_String(" and ");
    gc_root(strlit198);
  }
// compiled string node returning strlit198 (depth = 5)
  int op_slot_right_197 = gc_frame_newslot(strlit198);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_left (depth = 6)
  int op_slot_right_200 = gc_frame_newslot(*var_left);
// starting to compile string node (depth = 6)
  if (strlit202 == NULL) {
    strlit202 = alloc_String("lazy concatenation of ");
    gc_root(strlit202);
  }
// compiled string node returning strlit202 (depth = 6)
  int op_slot_left_200 = gc_frame_newslot(strlit202);
  params[0] = *var_left;
  partcv[0] = 1;
  Object opresult203 = callmethod(strlit202, "++", 1, partcv, params);
// compiled op node returning opresult203 (depth = 5)
  int op_slot_left_197 = gc_frame_newslot(opresult203);
  params[0] = strlit198;
  partcv[0] = 1;
  Object opresult204 = callmethod(opresult203, "++", 1, partcv, params);
// compiled op node returning opresult204 (depth = 4)
  int op_slot_left_195 = gc_frame_newslot(opresult204);
  params[0] = *var_right;
  partcv[0] = 1;
  Object opresult205 = callmethod(opresult204, "++", 1, partcv, params);
// compiled op node returning opresult205 (depth = 3)
  int op_slot_left_192 = gc_frame_newslot(opresult205);
  params[0] = strlit193;
  partcv[0] = 1;
  Object opresult206 = callmethod(opresult205, "++", 1, partcv, params);
// compiled op node returning opresult206 (depth = 2)
  gc_frame_end(frame);
  return opresult206;
}
Object meth_collectionsPrelude_asString207(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 242
  setline(242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe208 = gc_frame_new();
// call case 1: super request
  partcv[0] = 0;
  Object call209 = callmethod4(self, "asString", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe208);
// compiled call node returning call209 (depth = 3)
// compiled member node returning call209 (depth = 2)
  gc_frame_end(frame);
  return call209;
}
Object meth_collectionsPrelude_size210(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "size");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_right = getfromclosure(closure, 0);
  Object *var_left = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for size (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for size");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 243
  setline(243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe212 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_right (depth = 5)
  partcv[0] = 0;
  Object call213 = callmethod(*var_right, "size",
    1, partcv, params);
  gc_frame_end(callframe212);
// compiled call node returning call213 (depth = 4)
// compiled member node returning call213 (depth = 3)
  int op_slot_right_211 = gc_frame_newslot(call213);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe215 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_left (depth = 5)
  partcv[0] = 0;
  Object call216 = callmethod(*var_left, "size",
    1, partcv, params);
  gc_frame_end(callframe215);
// compiled call node returning call216 (depth = 4)
// compiled member node returning call216 (depth = 3)
  int op_slot_left_211 = gc_frame_newslot(call216);
  params[0] = call213;
  partcv[0] = 1;
  Object sum217 = callmethod(call216, "+", 1, partcv, params);
// compiled op node returning sum217 (depth = 2)
  gc_frame_end(frame);
  return sum217;
}
Object meth_collectionsPrelude_lazyConcatenation179(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lazyConcatenation");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method lazyConcatenation");
  Object params[1];
  int partcv[2];
  Object *var_enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for lazyConcatenation (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_left = &(stackframe->slots[0]);
  *var_left = args[curarg];
  curarg++;
  Object *var_right = &(stackframe->slots[1]);
  *var_right = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for lazyConcatenation");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start generics
  Object *var_T = &(stackframe->slots[3]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      gracedie("insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End generics
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject180 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj180 = alloc_userobj2(5,6, objclass180);
  gc_frame_newslot(obj180);
if (objclass180 == NULL) {
  glfree(obj180->class->name);
  obj180->class->name = "self.lazyConcatenation";
}
// OBJECT OUTER DEC outer
  adddatum2(obj180, self, 0);
  addmethodreal(obj180,"outer", &reader_collectionsPrelude_outer_181);
  Object oldself180 = self;
  struct StackFrameObject *oldstackframe180 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe180);
  gc_frame_newslot((Object)stackframe);
  self = obj180;
  Object *oldselfslot180 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter180 = (*(struct UserObject *)self).data[0], lowerouter180 = thisouter180;
  if (inheritingObject180) {
    struct UserObject *inho180 = (struct UserObject *)inheritingObject180;
    while (inho180->super != GraceDefaultObject) inho180 = (struct UserObject *)inho180->super;
    inho180->super = obj180;
    self = inheritingObject180;
    *selfslot = self;
    lowerouter180 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter180;
  }
// method iterator
  block_savedest(obj180);
  Object closure182 = createclosure(2, "iterator");
  setclosureframe(closure182, stackframe);
  addtoclosure(closure182, var_left);
  addtoclosure(closure182, var_right);
  struct UserObject *uo182 = (struct UserObject*)obj180;
  uo182->data[1] = (Object)closure182;
  Method *meth_meth_collectionsPrelude_iterator182 = addmethod2pos(obj180, "iterator", &meth_collectionsPrelude_iterator182, 1);
  int argcv_meth_collectionsPrelude_iterator182[] = {0};
  meth_meth_collectionsPrelude_iterator182->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator182);
  meth_meth_collectionsPrelude_iterator182->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator182->definitionLine = 238;
// method asDebugString
  block_savedest(obj180);
  Object closure191 = createclosure(2, "asDebugString");
  setclosureframe(closure191, stackframe);
  addtoclosure(closure191, var_right);
  addtoclosure(closure191, var_left);
  struct UserObject *uo191 = (struct UserObject*)obj180;
  uo191->data[2] = (Object)closure191;
  Method *meth_meth_collectionsPrelude_asDebugString191 = addmethod2pos(obj180, "asDebugString", &meth_collectionsPrelude_asDebugString191, 2);
  int argcv_meth_collectionsPrelude_asDebugString191[] = {0};
  meth_meth_collectionsPrelude_asDebugString191->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString191);
  meth_meth_collectionsPrelude_asDebugString191->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString191->definitionLine = 241;
// method asString
  struct UserObject *uo207 = (struct UserObject*)obj180;
  uo207->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString207 = addmethod2pos(obj180, "asString", &meth_collectionsPrelude_asString207, 3);
  int argcv_meth_collectionsPrelude_asString207[] = {0};
  meth_meth_collectionsPrelude_asString207->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString207);
  meth_meth_collectionsPrelude_asString207->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString207->definitionLine = 242;
// method size
  block_savedest(obj180);
  Object closure210 = createclosure(2, "size");
  setclosureframe(closure210, stackframe);
  addtoclosure(closure210, var_right);
  addtoclosure(closure210, var_left);
  struct UserObject *uo210 = (struct UserObject*)obj180;
  uo210->data[4] = (Object)closure210;
  Method *meth_meth_collectionsPrelude_size210 = addmethod2pos(obj180, "size", &meth_collectionsPrelude_size210, 4);
  int argcv_meth_collectionsPrelude_size210[] = {0};
  meth_meth_collectionsPrelude_size210->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size210);
  meth_meth_collectionsPrelude_size210->definitionModule = modulename;
  meth_meth_collectionsPrelude_size210->definitionLine = 243;
  sourceObject = obj180;
// Begin line 237
  setline(237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe218 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call219 = callmethod(*var_enumerable, "trait()object",
    2, partcv, params);
  gc_frame_end(callframe218);
// compiled call node returning call219 (depth = 2)
  struct UserObject *obj180_uo = (struct UserObject *)obj180;
  obj180_uo->super = call219;
  sourceObject = obj180;
  sourceObject = obj180;
  sourceObject = obj180;
  sourceObject = obj180;
  objclass180 = obj180->class;
  objclass180->definitionModule = modulename;
  objclass180->definitionLine = 236;
  (*(struct UserObject *)self).data[0] = lowerouter180;
  self = oldself180;
  selfslot = oldselfslot180;
  stackframe = oldstackframe180;
  gc_frame_end(frame);
  return obj180;
}
Object meth_collectionsPrelude_lazyConcatenation179_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lazyConcatenation()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method lazyConcatenation()object");
  Object params[1];
  int partcv[2];
  Object *var_enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for lazyConcatenation (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_left = &(stackframe->slots[0]);
  *var_left = args[curarg];
  curarg++;
  Object *var_right = &(stackframe->slots[1]);
  *var_right = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for lazyConcatenation");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start generics
  Object *var_T = &(stackframe->slots[3]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      gracedie("insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End generics
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject180 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj180 = alloc_userobj2(5,6, objclass180);
  gc_frame_newslot(obj180);
if (objclass180 == NULL) {
  glfree(obj180->class->name);
  obj180->class->name = "self.lazyConcatenation";
}
// OBJECT OUTER DEC outer
  adddatum2(obj180, self, 0);
  addmethodreal(obj180,"outer", &reader_collectionsPrelude_outer_181);
  Object oldself180 = self;
  struct StackFrameObject *oldstackframe180 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe180);
  gc_frame_newslot((Object)stackframe);
  self = obj180;
  Object *oldselfslot180 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter180 = (*(struct UserObject *)self).data[0], lowerouter180 = thisouter180;
  if (inheritingObject180) {
    struct UserObject *inho180 = (struct UserObject *)inheritingObject180;
    while (inho180->super != GraceDefaultObject) inho180 = (struct UserObject *)inho180->super;
    inho180->super = obj180;
    self = inheritingObject180;
    *selfslot = self;
    lowerouter180 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter180;
  }
// method iterator
  block_savedest(obj180);
  Object closure182 = createclosure(2, "iterator");
  setclosureframe(closure182, stackframe);
  addtoclosure(closure182, var_left);
  addtoclosure(closure182, var_right);
  struct UserObject *uo182 = (struct UserObject*)obj180;
  uo182->data[1] = (Object)closure182;
  Method *meth_meth_collectionsPrelude_iterator182 = addmethod2pos(obj180, "iterator", &meth_collectionsPrelude_iterator182, 1);
  int argcv_meth_collectionsPrelude_iterator182[] = {0};
  meth_meth_collectionsPrelude_iterator182->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator182);
  meth_meth_collectionsPrelude_iterator182->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator182->definitionLine = 238;
// method asDebugString
  block_savedest(obj180);
  Object closure191 = createclosure(2, "asDebugString");
  setclosureframe(closure191, stackframe);
  addtoclosure(closure191, var_right);
  addtoclosure(closure191, var_left);
  struct UserObject *uo191 = (struct UserObject*)obj180;
  uo191->data[2] = (Object)closure191;
  Method *meth_meth_collectionsPrelude_asDebugString191 = addmethod2pos(obj180, "asDebugString", &meth_collectionsPrelude_asDebugString191, 2);
  int argcv_meth_collectionsPrelude_asDebugString191[] = {0};
  meth_meth_collectionsPrelude_asDebugString191->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString191);
  meth_meth_collectionsPrelude_asDebugString191->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString191->definitionLine = 241;
// method asString
  struct UserObject *uo207 = (struct UserObject*)obj180;
  uo207->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString207 = addmethod2pos(obj180, "asString", &meth_collectionsPrelude_asString207, 3);
  int argcv_meth_collectionsPrelude_asString207[] = {0};
  meth_meth_collectionsPrelude_asString207->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString207);
  meth_meth_collectionsPrelude_asString207->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString207->definitionLine = 242;
// method size
  block_savedest(obj180);
  Object closure210 = createclosure(2, "size");
  setclosureframe(closure210, stackframe);
  addtoclosure(closure210, var_right);
  addtoclosure(closure210, var_left);
  struct UserObject *uo210 = (struct UserObject*)obj180;
  uo210->data[4] = (Object)closure210;
  Method *meth_meth_collectionsPrelude_size210 = addmethod2pos(obj180, "size", &meth_collectionsPrelude_size210, 4);
  int argcv_meth_collectionsPrelude_size210[] = {0};
  meth_meth_collectionsPrelude_size210->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size210);
  meth_meth_collectionsPrelude_size210->definitionModule = modulename;
  meth_meth_collectionsPrelude_size210->definitionLine = 243;
  sourceObject = obj180;
// Begin line 237
  setline(237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe218 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call219 = callmethod(*var_enumerable, "trait()object",
    2, partcv, params);
  gc_frame_end(callframe218);
// compiled call node returning call219 (depth = 2)
  struct UserObject *obj180_uo = (struct UserObject *)obj180;
  obj180_uo->super = call219;
  sourceObject = obj180;
  sourceObject = obj180;
  sourceObject = obj180;
  sourceObject = obj180;
  objclass180 = obj180->class;
  objclass180->definitionModule = modulename;
  objclass180->definitionLine = 236;
  (*(struct UserObject *)self).data[0] = lowerouter180;
  self = oldself180;
  selfslot = oldselfslot180;
  stackframe = oldstackframe180;
  gc_frame_end(frame);
  return obj180;
}
Object meth_collectionsPrelude_max221(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "max");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method max");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for max (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for max");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 430
  setline(430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_b (depth = 4)
  int op_slot_right_223 = gc_frame_newslot(*var_b);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_a (depth = 4)
  int op_slot_left_223 = gc_frame_newslot(*var_a);
  params[0] = *var_b;
  partcv[0] = 1;
  Object opresult225 = callmethod(*var_a, ">", 1, partcv, params);
// compiled op node returning opresult225 (depth = 3)
  Object if222 = done;
  if (istrue(opresult225)) {
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_a (depth = 3)
    gc_frame_newslot(*var_a);
    if222 = *var_a;
  } else {
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_b (depth = 3)
    gc_frame_newslot(*var_b);
    if222 = *var_b;
  }
// compiled if node returning if222 (depth = 2)
  gc_frame_end(frame);
  return if222;
}
Object meth_collectionsPrelude__apply237(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_arg = getfromclosure(closure, 0);
  Object *var_forecastSize = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 6)
// Begin line 442
  setline(442);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe239 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_arg (depth = 10)
  partcv[0] = 0;
  Object call240 = callmethod(*var_arg, "size",
    1, partcv, params);
  gc_frame_end(callframe239);
// compiled call node returning call240 (depth = 9)
// compiled member node returning call240 (depth = 8)
  int op_slot_right_238 = gc_frame_newslot(call240);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_forecastSize (depth = 8)
  int op_slot_left_238 = gc_frame_newslot(*var_forecastSize);
  params[0] = call240;
  partcv[0] = 1;
  Object sum242 = callmethod(*var_forecastSize, "+", 1, partcv, params);
// compiled op node returning sum242 (depth = 7)
  *var_forecastSize = sum242;
  if (sum242 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude__apply246(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_forecastSize = getfromclosure(closure, 0);
  Object *var_sizeUncertain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___13 = &(stackframe->slots[0]);
  *var___13 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 444
  setline(444);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num248 = alloc_Float64(8);
// compiled num node returning num248 (depth = 8)
  int op_slot_right_247 = gc_frame_newslot(num248);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_forecastSize (depth = 8)
  int op_slot_left_247 = gc_frame_newslot(*var_forecastSize);
  params[0] = num248;
  partcv[0] = 1;
  Object sum250 = callmethod(*var_forecastSize, "+", 1, partcv, params);
// compiled op node returning sum250 (depth = 7)
  *var_forecastSize = sum250;
  if (sum250 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 445
  setline(445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool252 = alloc_Boolean(1);
// compiled identifier node returning bool252 (depth = 7)
  *var_sizeUncertain = bool252;
  if (bool252 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude__apply234(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[1];
  Object *var_forecastSize = getfromclosure(closure, 0);
  Object *var_sizeUncertain = getfromclosure(closure, 1);
  Object *var_SizeUnknown = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_arg = &(stackframe->slots[0]);
  *var_arg = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 441
  setline(441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile catchcase node (depth = 4)
// starting to compile block node (depth = 5)
  Object block236 = alloc_Block(NULL, NULL, "collectionsPrelude", 441);
  gc_frame_newslot(block236);
// method _apply
  block_savedest(block236);
  Object closure237 = createclosure(3, "_apply");
  setclosureframe(closure237, stackframe);
  addtoclosure(closure237, var_arg);
  addtoclosure(closure237, var_forecastSize);
  addtoclosure(closure237, selfslot);
  struct UserObject *uo237 = (struct UserObject*)block236;
  uo237->data[0] = (Object)closure237;
  Method *meth_meth_collectionsPrelude__apply237 = addmethod2pos(block236, "_apply", &meth_collectionsPrelude__apply237, 0);
  int argcv_meth_collectionsPrelude__apply237[] = {0};
  meth_meth_collectionsPrelude__apply237->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply237);
  meth_meth_collectionsPrelude__apply237->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply237->definitionLine = 243;
// compiled block node returning block236 (depth = 5)
  int frame235 = gc_frame_new();
  gc_frame_newslot(block236);
// Begin line 443
  setline(443);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 5)
  Object block245 = alloc_Block(NULL, NULL, "collectionsPrelude", 443);
  gc_frame_newslot(block245);
// method _apply
  block_savedest(block245);
  Object closure246 = createclosure(3, "_apply");
  setclosureframe(closure246, stackframe);
  addtoclosure(closure246, var_forecastSize);
  addtoclosure(closure246, var_sizeUncertain);
  addtoclosure(closure246, selfslot);
  struct UserObject *uo246 = (struct UserObject*)block245;
  uo246->data[0] = (Object)closure246;
  Method *meth_meth_collectionsPrelude__apply246 = addmethod2pos(block245, "_apply", &meth_collectionsPrelude__apply246, 0);
  int argcv_meth_collectionsPrelude__apply246[] = {1};
  meth_meth_collectionsPrelude__apply246->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply246);
  meth_meth_collectionsPrelude__apply246->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply246->definitionLine = 442;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe255 = gc_frame_new();
// starting to compile call node (depth = 7)
  int callframe256 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit257 == NULL) {
    strlit257 = alloc_String("__13");
    gc_root(strlit257);
  }
// compiled string node returning strlit257 (depth = 8)
  gc_frame_newslot(strlit257);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe258 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call259 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe258);
// compiled call node returning call259 (depth = 9)
// compiled member node returning call259 (depth = 8)
  params[0] = strlit257;
  partcv[0] = 1;
  Object call260 = callmethod(call259, "new",
    1, partcv, params);
  gc_frame_end(callframe256);
// compiled call node returning call260 (depth = 7)
  gc_frame_newslot(call260);
// Begin line 443
  setline(443);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_SizeUnknown (depth = 7)
  gc_frame_newslot(*var_SizeUnknown);
// call case 6: other member request
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe261 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call262 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe261);
// compiled call node returning call262 (depth = 8)
// compiled member node returning call262 (depth = 7)
  params[0] = call260;
  params[1] = *var_SizeUnknown;
  partcv[0] = 2;
  Object call263 = callmethod(call262, "new",
    1, partcv, params);
  gc_frame_end(callframe255);
// compiled call node returning call263 (depth = 6)
((struct UserObject *)block245)->data[1] = call263;
// compiled block node returning block245 (depth = 5)
  gc_frame_newslot(block245);
  params[0] = block245;
  setline(441);
  Object catchres235 = catchCase(block236, params, 1,NULL);
  gc_frame_end(frame235);
// compiled catchcase node returning catchres235 (depth = 4)
  gc_frame_end(frame);
  return catchres235;
}
Object meth_collectionsPrelude__apply302(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_inner = getfromclosure(closure, 0);
  Object *var_newInner = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 458
  setline(458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe303 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_i (depth = 11)
  gc_frame_newslot(*var_i);
// starting to compile call node (depth = 11)
  int callframe304 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_i (depth = 12)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_inner (depth = 12)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call305 = callmethod(*var_inner, "at",
    1, partcv, params);
  gc_frame_end(callframe304);
// compiled call node returning call305 (depth = 11)
  gc_frame_newslot(call305);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_newInner (depth = 11)
  params[0] = *var_i;
  params[1] = call305;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call306 = callmethod(*var_newInner, "at()put",
    2, partcv, params);
  gc_frame_end(callframe303);
// compiled call node returning call306 (depth = 10)
  gc_frame_end(frame);
  return call306;
}
Object meth_collectionsPrelude__apply279(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_ix = getfromclosure(closure, 0);
  Object *var_innerSize = getfromclosure(closure, 1);
  Object *var__prelude = getfromclosure(closure, 2);
  Object *var_inner = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_elt = &(stackframe->slots[0]);
  *var_elt = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newInner = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "newInner");
// Begin line 455
  setline(455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ix (depth = 9)
  int op_slot_right_281 = gc_frame_newslot(*var_ix);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_innerSize (depth = 9)
  int op_slot_left_281 = gc_frame_newslot(*var_innerSize);
  params[0] = *var_ix;
  partcv[0] = 1;
  Object opresult283 = callmethod(*var_innerSize, "<=", 1, partcv, params);
// compiled op node returning opresult283 (depth = 8)
  Object if280 = done;
  if (istrue(opresult283)) {
// Begin line 456
  setline(456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe284 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num286 = alloc_Float64(2);
// compiled num node returning num286 (depth = 11)
  int op_slot_right_285 = gc_frame_newslot(num286);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_innerSize (depth = 11)
  int op_slot_left_285 = gc_frame_newslot(*var_innerSize);
  params[0] = num286;
  partcv[0] = 1;
  Object prod288 = callmethod(*var_innerSize, "*", 1, partcv, params);
// compiled op node returning prod288 (depth = 10)
  gc_frame_newslot(prod288);
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe289 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var__prelude (depth = 12)
  partcv[0] = 0;
  Object call290 = callmethod(*var__prelude, "PrimitiveArray",
    1, partcv, params);
  gc_frame_end(callframe289);
// compiled call node returning call290 (depth = 11)
// compiled member node returning call290 (depth = 10)
  params[0] = prod288;
  partcv[0] = 1;
  Object call291 = callmethod(call290, "new",
    1, partcv, params);
  gc_frame_end(callframe284);
// compiled call node returning call291 (depth = 9)
  *var_newInner = call291;
  if (call291 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 457
  setline(457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe292 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num295 = alloc_Float64(1);
// compiled num node returning num295 (depth = 11)
  int op_slot_right_294 = gc_frame_newslot(num295);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_innerSize (depth = 11)
  int op_slot_left_294 = gc_frame_newslot(*var_innerSize);
  params[0] = num295;
  partcv[0] = 1;
  Object diff297 = callmethod(*var_innerSize, "-", 1, partcv, params);
// compiled op node returning diff297 (depth = 10)
  int op_slot_right_293 = gc_frame_newslot(diff297);
// starting to compile num node (depth = 10)
  Object num299 = alloc_Float64(0);
// compiled num node returning num299 (depth = 10)
  int op_slot_left_293 = gc_frame_newslot(num299);
  params[0] = diff297;
  partcv[0] = 1;
  Object opresult300 = callmethod(num299, "..", 1, partcv, params);
// compiled op node returning opresult300 (depth = 9)
  gc_frame_newslot(opresult300);
// starting to compile block node (depth = 9)
  Object block301 = alloc_Block(NULL, NULL, "collectionsPrelude", 457);
  gc_frame_newslot(block301);
// method _apply
  block_savedest(block301);
  Object closure302 = createclosure(3, "_apply");
  setclosureframe(closure302, stackframe);
  addtoclosure(closure302, var_inner);
  addtoclosure(closure302, var_newInner);
  addtoclosure(closure302, selfslot);
  struct UserObject *uo302 = (struct UserObject*)block301;
  uo302->data[0] = (Object)closure302;
  Method *meth_meth_collectionsPrelude__apply302 = addmethod2pos(block301, "_apply", &meth_collectionsPrelude__apply302, 0);
  int argcv_meth_collectionsPrelude__apply302[] = {1};
  meth_meth_collectionsPrelude__apply302->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply302);
  meth_meth_collectionsPrelude__apply302->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply302->definitionLine = 456;
// compiled block node returning block301 (depth = 9)
  gc_frame_newslot(block301);
// call case 5: prelude request
  params[0] = opresult300;
  params[1] = block301;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call308 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe292);
// compiled call node returning call308 (depth = 8)
// Begin line 460
  setline(460);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_newInner (depth = 9)
  *var_inner = *var_newInner;
  if (*var_newInner == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 461
  setline(461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe310 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_inner (depth = 11)
  partcv[0] = 0;
  Object call311 = callmethod(*var_inner, "size",
    1, partcv, params);
  gc_frame_end(callframe310);
// compiled call node returning call311 (depth = 10)
// compiled member node returning call311 (depth = 9)
  *var_innerSize = call311;
  if (call311 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if280 = done;
  } else {
  }
// compiled if node returning if280 (depth = 7)
// Begin line 463
  setline(463);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe313 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ix (depth = 8)
  gc_frame_newslot(*var_ix);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_elt (depth = 8)
  gc_frame_newslot(*var_elt);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_inner (depth = 8)
  params[0] = *var_ix;
  params[1] = *var_elt;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call314 = callmethod(*var_inner, "at()put",
    2, partcv, params);
  gc_frame_end(callframe313);
// compiled call node returning call314 (depth = 7)
// Begin line 464
  setline(464);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num316 = alloc_Float64(1);
// compiled num node returning num316 (depth = 9)
  int op_slot_right_315 = gc_frame_newslot(num316);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ix (depth = 9)
  int op_slot_left_315 = gc_frame_newslot(*var_ix);
  params[0] = num316;
  partcv[0] = 1;
  Object sum318 = callmethod(*var_ix, "+", 1, partcv, params);
// compiled op node returning sum318 (depth = 8)
  *var_ix = sum318;
  if (sum318 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude__apply276(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_ix = getfromclosure(closure, 0);
  Object *var_innerSize = getfromclosure(closure, 1);
  Object *var__prelude = getfromclosure(closure, 2);
  Object *var_inner = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_arg = &(stackframe->slots[0]);
  *var_arg = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 454
  setline(454);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe277 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_arg (depth = 6)
  gc_frame_newslot(*var_arg);
// starting to compile block node (depth = 6)
  Object block278 = alloc_Block(NULL, NULL, "collectionsPrelude", 454);
  gc_frame_newslot(block278);
// method _apply
  block_savedest(block278);
  Object closure279 = createclosure(5, "_apply");
  setclosureframe(closure279, stackframe);
  addtoclosure(closure279, var_ix);
  addtoclosure(closure279, var_innerSize);
  addtoclosure(closure279, var__prelude);
  addtoclosure(closure279, var_inner);
  addtoclosure(closure279, selfslot);
  struct UserObject *uo279 = (struct UserObject*)block278;
  uo279->data[0] = (Object)closure279;
  Method *meth_meth_collectionsPrelude__apply279 = addmethod2pos(block278, "_apply", &meth_collectionsPrelude__apply279, 0);
  int argcv_meth_collectionsPrelude__apply279[] = {1};
  meth_meth_collectionsPrelude__apply279->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply279);
  meth_meth_collectionsPrelude__apply279->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply279->definitionLine = 449;
// compiled block node returning block278 (depth = 6)
  gc_frame_newslot(block278);
// call case 5: prelude request
  params[0] = *var_arg;
  params[1] = block278;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call321 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe277);
// compiled call node returning call321 (depth = 5)
  gc_frame_end(frame);
  return call321;
}
Object meth_collectionsPrelude__apply329(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_ix = getfromclosure(closure, 0);
  Object *var_inner = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_elt = &(stackframe->slots[0]);
  *var_elt = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 471
  setline(471);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe330 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ix (depth = 8)
  gc_frame_newslot(*var_ix);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_elt (depth = 8)
  gc_frame_newslot(*var_elt);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_inner (depth = 8)
  params[0] = *var_ix;
  params[1] = *var_elt;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call331 = callmethod(*var_inner, "at()put",
    2, partcv, params);
  gc_frame_end(callframe330);
// compiled call node returning call331 (depth = 7)
// Begin line 472
  setline(472);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num333 = alloc_Float64(1);
// compiled num node returning num333 (depth = 9)
  int op_slot_right_332 = gc_frame_newslot(num333);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ix (depth = 9)
  int op_slot_left_332 = gc_frame_newslot(*var_ix);
  params[0] = num333;
  partcv[0] = 1;
  Object sum335 = callmethod(*var_ix, "+", 1, partcv, params);
// compiled op node returning sum335 (depth = 8)
  *var_ix = sum335;
  if (sum335 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude__apply326(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_ix = getfromclosure(closure, 0);
  Object *var_inner = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_arg = &(stackframe->slots[0]);
  *var_arg = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 470
  setline(470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe327 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_arg (depth = 6)
  gc_frame_newslot(*var_arg);
// starting to compile block node (depth = 6)
  Object block328 = alloc_Block(NULL, NULL, "collectionsPrelude", 470);
  gc_frame_newslot(block328);
// method _apply
  block_savedest(block328);
  Object closure329 = createclosure(3, "_apply");
  setclosureframe(closure329, stackframe);
  addtoclosure(closure329, var_ix);
  addtoclosure(closure329, var_inner);
  addtoclosure(closure329, selfslot);
  struct UserObject *uo329 = (struct UserObject*)block328;
  uo329->data[0] = (Object)closure329;
  Method *meth_meth_collectionsPrelude__apply329 = addmethod2pos(block328, "_apply", &meth_collectionsPrelude__apply329, 0);
  int argcv_meth_collectionsPrelude__apply329[] = {1};
  meth_meth_collectionsPrelude__apply329->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply329);
  meth_meth_collectionsPrelude__apply329->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply329->definitionLine = 461;
// compiled block node returning block328 (depth = 6)
  gc_frame_newslot(block328);
// call case 5: prelude request
  params[0] = *var_arg;
  params[1] = block328;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call338 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe327);
// compiled call node returning call338 (depth = 5)
  gc_frame_end(frame);
  return call338;
}
Object meth_collectionsPrelude_withAll229(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "withAll");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_SizeUnknown = getfromclosure(closure, 0);
  Object *var__prelude = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for withAll (probably reflection error): got %i lists, expected 1.", nparts);
  Object var_init_a = alloc_BuiltinList();
  for (i = 0; i < argcv[0]; i++) {
    callmethod(var_init_a, "push", 1, pushcv, &args[curarg]);
    curarg++;
  }
  Object *var_a = &(stackframe->slots[0]);
  *var_a = var_init_a;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_forecastSize = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "forecastSize");
  Object *var_sizeUncertain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "sizeUncertain");
  Object *var_inner = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "inner");
  Object *var_innerSize = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "innerSize");
  Object *var_ix = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "ix");
// Begin line 437
  setline(437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num230 = alloc_Float64(0);
// compiled num node returning num230 (depth = 3)
  *var_forecastSize = num230;
  if (num230 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 438
  setline(438);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool231 = alloc_Boolean(0);
// compiled identifier node returning bool231 (depth = 3)
  *var_sizeUncertain = bool231;
  if (bool231 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 440
  setline(440);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe232 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_a (depth = 3)
  gc_frame_newslot(*var_a);
// starting to compile block node (depth = 3)
  Object block233 = alloc_Block(NULL, NULL, "collectionsPrelude", 440);
  gc_frame_newslot(block233);
// method _apply
  block_savedest(block233);
  Object closure234 = createclosure(4, "_apply");
  setclosureframe(closure234, stackframe);
  addtoclosure(closure234, var_forecastSize);
  addtoclosure(closure234, var_sizeUncertain);
  addtoclosure(closure234, var_SizeUnknown);
  addtoclosure(closure234, selfslot);
  struct UserObject *uo234 = (struct UserObject*)block233;
  uo234->data[0] = (Object)closure234;
  Method *meth_meth_collectionsPrelude__apply234 = addmethod2pos(block233, "_apply", &meth_collectionsPrelude__apply234, 0);
  int argcv_meth_collectionsPrelude__apply234[] = {1};
  meth_meth_collectionsPrelude__apply234->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply234);
  meth_meth_collectionsPrelude__apply234->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply234->definitionLine = 243;
// compiled block node returning block233 (depth = 3)
  gc_frame_newslot(block233);
// call case 5: prelude request
  params[0] = *var_a;
  params[1] = block233;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call265 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe232);
// compiled call node returning call265 (depth = 2)
// Begin line 448
  setline(448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe266 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_forecastSize (depth = 4)
  gc_frame_newslot(*var_forecastSize);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe267 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var__prelude (depth = 6)
  partcv[0] = 0;
  Object call268 = callmethod(*var__prelude, "PrimitiveArray",
    1, partcv, params);
  gc_frame_end(callframe267);
// compiled call node returning call268 (depth = 5)
// compiled member node returning call268 (depth = 4)
  params[0] = *var_forecastSize;
  partcv[0] = 1;
  Object call269 = callmethod(call268, "new",
    1, partcv, params);
  gc_frame_end(callframe266);
// compiled call node returning call269 (depth = 3)
  *var_inner = call269;
  if (call269 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 449
  setline(449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe270 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_inner (depth = 5)
  partcv[0] = 0;
  Object call271 = callmethod(*var_inner, "size",
    1, partcv, params);
  gc_frame_end(callframe270);
// compiled call node returning call271 (depth = 4)
// compiled member node returning call271 (depth = 3)
  *var_innerSize = call271;
  if (call271 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 450
  setline(450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num272 = alloc_Float64(0);
// compiled num node returning num272 (depth = 3)
  *var_ix = num272;
  if (num272 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 451
  setline(451);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sizeUncertain (depth = 3)
  Object if273 = done;
  if (istrue(*var_sizeUncertain)) {
// Begin line 453
  setline(453);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe274 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_a (depth = 4)
  gc_frame_newslot(*var_a);
// starting to compile block node (depth = 4)
  Object block275 = alloc_Block(NULL, NULL, "collectionsPrelude", 453);
  gc_frame_newslot(block275);
// method _apply
  block_savedest(block275);
  Object closure276 = createclosure(5, "_apply");
  setclosureframe(closure276, stackframe);
  addtoclosure(closure276, var_ix);
  addtoclosure(closure276, var_innerSize);
  addtoclosure(closure276, var__prelude);
  addtoclosure(closure276, var_inner);
  addtoclosure(closure276, selfslot);
  struct UserObject *uo276 = (struct UserObject*)block275;
  uo276->data[0] = (Object)closure276;
  Method *meth_meth_collectionsPrelude__apply276 = addmethod2pos(block275, "_apply", &meth_collectionsPrelude__apply276, 0);
  int argcv_meth_collectionsPrelude__apply276[] = {1};
  meth_meth_collectionsPrelude__apply276->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply276);
  meth_meth_collectionsPrelude__apply276->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply276->definitionLine = 449;
// compiled block node returning block275 (depth = 4)
  gc_frame_newslot(block275);
// call case 5: prelude request
  params[0] = *var_a;
  params[1] = block275;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call323 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe274);
// compiled call node returning call323 (depth = 3)
    gc_frame_newslot(call323);
    if273 = call323;
  } else {
// Begin line 469
  setline(469);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe324 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_a (depth = 4)
  gc_frame_newslot(*var_a);
// starting to compile block node (depth = 4)
  Object block325 = alloc_Block(NULL, NULL, "collectionsPrelude", 469);
  gc_frame_newslot(block325);
// method _apply
  block_savedest(block325);
  Object closure326 = createclosure(3, "_apply");
  setclosureframe(closure326, stackframe);
  addtoclosure(closure326, var_ix);
  addtoclosure(closure326, var_inner);
  addtoclosure(closure326, selfslot);
  struct UserObject *uo326 = (struct UserObject*)block325;
  uo326->data[0] = (Object)closure326;
  Method *meth_meth_collectionsPrelude__apply326 = addmethod2pos(block325, "_apply", &meth_collectionsPrelude__apply326, 0);
  int argcv_meth_collectionsPrelude__apply326[] = {1};
  meth_meth_collectionsPrelude__apply326->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply326);
  meth_meth_collectionsPrelude__apply326->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply326->definitionLine = 461;
// compiled block node returning block325 (depth = 4)
  gc_frame_newslot(block325);
// call case 5: prelude request
  params[0] = *var_a;
  params[1] = block325;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call340 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe324);
// compiled call node returning call340 (depth = 3)
    gc_frame_newslot(call340);
    if273 = call340;
  }
// compiled if node returning if273 (depth = 2)
// Begin line 476
  setline(476);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe341 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_inner (depth = 3)
  gc_frame_newslot(*var_inner);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ix (depth = 3)
  gc_frame_newslot(*var_ix);
// call case 4: self request
  params[0] = *var_inner;
  params[1] = *var_ix;
  partcv[0] = 2;
  Object call342 = callmethodflags(self, "fromPrimitiveArray", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe341);
// compiled call node returning call342 (depth = 2)
  gc_frame_end(frame);
  return call342;
}
Object meth_collectionsPrelude_boundsCheck349(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "boundsCheck");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method boundsCheck");
  Object params[1];
  int partcv[1];
  Object *var_BoundsError = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for boundsCheck (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for boundsCheck");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 486
  setline(486);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe352 = gc_frame_new();
// call case 6: other member request
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe354 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call355 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe354);
// compiled call node returning call355 (depth = 7)
// compiled member node returning call355 (depth = 6)
  int op_slot_right_353 = gc_frame_newslot(call355);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  int op_slot_left_353 = gc_frame_newslot(*var_n);
  params[0] = call355;
  partcv[0] = 1;
  Object opresult357 = callmethod(*var_n, "<=", 1, partcv, params);
// compiled op node returning opresult357 (depth = 5)
  partcv[0] = 0;
  Object call358 = callmethod(opresult357, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe352);
// compiled call node returning call358 (depth = 4)
  int op_slot_right_351 = gc_frame_newslot(call358);
// starting to compile call node (depth = 4)
  int callframe360 = gc_frame_new();
// call case 6: other member request
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num362 = alloc_Float64(1);
// compiled num node returning num362 (depth = 6)
  int op_slot_right_361 = gc_frame_newslot(num362);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  int op_slot_left_361 = gc_frame_newslot(*var_n);
  params[0] = num362;
  partcv[0] = 1;
  Object opresult364 = callmethod(*var_n, ">=", 1, partcv, params);
// compiled op node returning opresult364 (depth = 5)
  partcv[0] = 0;
  Object call365 = callmethod(opresult364, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe360);
// compiled call node returning call365 (depth = 4)
  int op_slot_left_351 = gc_frame_newslot(call365);
  params[0] = call358;
  partcv[0] = 1;
  Object opresult366 = callmethod(call365, "||", 1, partcv, params);
// compiled op node returning opresult366 (depth = 3)
  Object if350 = done;
  if (istrue(opresult366)) {
// Begin line 489
  setline(489);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe367 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit369 == NULL) {
    strlit369 = alloc_String("");
    gc_root(strlit369);
  }
// compiled string node returning strlit369 (depth = 5)
  int op_slot_right_368 = gc_frame_newslot(strlit369);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe372 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call373 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe372);
// compiled call node returning call373 (depth = 7)
// compiled member node returning call373 (depth = 6)
  int op_slot_right_371 = gc_frame_newslot(call373);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit376 == NULL) {
    strlit376 = alloc_String(" out of bounds 1..");
    gc_root(strlit376);
  }
// compiled string node returning strlit376 (depth = 7)
  int op_slot_right_375 = gc_frame_newslot(strlit376);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  int op_slot_right_378 = gc_frame_newslot(*var_n);
// starting to compile string node (depth = 8)
  if (strlit380 == NULL) {
    strlit380 = alloc_String("index ");
    gc_root(strlit380);
  }
// compiled string node returning strlit380 (depth = 8)
  int op_slot_left_378 = gc_frame_newslot(strlit380);
  params[0] = *var_n;
  partcv[0] = 1;
  Object opresult381 = callmethod(strlit380, "++", 1, partcv, params);
// compiled op node returning opresult381 (depth = 7)
  int op_slot_left_375 = gc_frame_newslot(opresult381);
  params[0] = strlit376;
  partcv[0] = 1;
  Object opresult382 = callmethod(opresult381, "++", 1, partcv, params);
// compiled op node returning opresult382 (depth = 6)
  int op_slot_left_371 = gc_frame_newslot(opresult382);
  params[0] = call373;
  partcv[0] = 1;
  Object opresult383 = callmethod(opresult382, "++", 1, partcv, params);
// compiled op node returning opresult383 (depth = 5)
  int op_slot_left_368 = gc_frame_newslot(opresult383);
  params[0] = strlit369;
  partcv[0] = 1;
  Object opresult384 = callmethod(opresult383, "++", 1, partcv, params);
// compiled op node returning opresult384 (depth = 4)
  gc_frame_newslot(opresult384);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_BoundsError (depth = 4)
  params[0] = opresult384;
  partcv[0] = 1;
  Object call385 = callmethod(*var_BoundsError, "raise",
    1, partcv, params);
  gc_frame_end(callframe367);
// compiled call node returning call385 (depth = 3)
    gc_frame_newslot(call385);
    if350 = call385;
  } else {
  }
// compiled if node returning if350 (depth = 2)
  gc_frame_end(frame);
  return if350;
}
Object meth_collectionsPrelude_at386(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "at");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method at");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for at (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for at");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 493
  setline(493);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe387 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_n (depth = 3)
  gc_frame_newslot(*var_n);
// call case 4: self request
  params[0] = *var_n;
  partcv[0] = 1;
  Object call388 = callmethodflags(self, "boundsCheck", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe387);
// compiled call node returning call388 (depth = 2)
// Begin line 494
  setline(494);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe389 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num391 = alloc_Float64(1);
// compiled num node returning num391 (depth = 4)
  int op_slot_right_390 = gc_frame_newslot(num391);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  int op_slot_left_390 = gc_frame_newslot(*var_n);
  params[0] = num391;
  partcv[0] = 1;
  Object diff393 = callmethod(*var_n, "-", 1, partcv, params);
// compiled op node returning diff393 (depth = 3)
  gc_frame_newslot(diff393);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe394 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call395 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe394);
// compiled call node returning call395 (depth = 4)
// compiled member node returning call395 (depth = 3)
  params[0] = diff393;
  partcv[0] = 1;
  Object call396 = callmethod(call395, "at",
    1, partcv, params);
  gc_frame_end(callframe389);
// compiled call node returning call396 (depth = 2)
  gc_frame_end(frame);
  return call396;
}
Object meth_collectionsPrelude__91__93_397(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "[]");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method []");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for [] (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for [");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 497
  setline(497);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe398 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_n (depth = 3)
  gc_frame_newslot(*var_n);
// call case 4: self request
  params[0] = *var_n;
  partcv[0] = 1;
  Object call399 = callmethodflags(self, "boundsCheck", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe398);
// compiled call node returning call399 (depth = 2)
// Begin line 498
  setline(498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe400 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num402 = alloc_Float64(1);
// compiled num node returning num402 (depth = 4)
  int op_slot_right_401 = gc_frame_newslot(num402);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  int op_slot_left_401 = gc_frame_newslot(*var_n);
  params[0] = num402;
  partcv[0] = 1;
  Object diff404 = callmethod(*var_n, "-", 1, partcv, params);
// compiled op node returning diff404 (depth = 3)
  gc_frame_newslot(diff404);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe405 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call406 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe405);
// compiled call node returning call406 (depth = 4)
// compiled member node returning call406 (depth = 3)
  params[0] = diff404;
  partcv[0] = 1;
  Object call407 = callmethod(call406, "at",
    1, partcv, params);
  gc_frame_end(callframe400);
// compiled call node returning call407 (depth = 2)
  gc_frame_end(frame);
  return call407;
}
Object meth_collectionsPrelude_keys408(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keys");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for keys (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for keys");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 501
  setline(501);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe409 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num410 = alloc_Float64(1);
// compiled num node returning num410 (depth = 3)
  gc_frame_newslot(num410);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe411 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call412 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe411);
// compiled call node returning call412 (depth = 4)
// compiled member node returning call412 (depth = 3)
  gc_frame_newslot(call412);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe413 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe414 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe415 = gc_frame_new();
// call case 3: self.outer request
  Object call416 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe415);
// compiled call node returning call416 (depth = 8)
// compiled member node returning call416 (depth = 7)
  partcv[0] = 0;
  Object call417 = callmethodflags(call416, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe414);
// compiled call node returning call417 (depth = 6)
// compiled member node returning call417 (depth = 5)
  partcv[0] = 0;
  Object call418 = callmethodflags(call417, "range", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe413);
// compiled call node returning call418 (depth = 4)
// compiled member node returning call418 (depth = 3)
  params[0] = num410;
  params[1] = call412;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call419 = callmethod(call418, "from()to",
    2, partcv, params);
  gc_frame_end(callframe409);
// compiled call node returning call419 (depth = 2)
  gc_frame_end(frame);
  return call419;
}
Object meth_collectionsPrelude_values420(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "values");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for values (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for values");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 504
  setline(504);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply425(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe427 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call428 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe427);
// compiled call node returning call428 (depth = 6)
// compiled member node returning call428 (depth = 5)
  int op_slot_right_426 = gc_frame_newslot(call428);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  int op_slot_left_426 = gc_frame_newslot(*var_i);
  params[0] = call428;
  partcv[0] = 1;
  Object opresult430 = callmethod(*var_i, "<", 1, partcv, params);
// compiled op node returning opresult430 (depth = 4)
  gc_frame_end(frame);
  return opresult430;
}
Object meth_collectionsPrelude__apply433(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object *var_block2 = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 509
  setline(509);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe434 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num436 = alloc_Float64(1);
// compiled num node returning num436 (depth = 6)
  int op_slot_right_435 = gc_frame_newslot(num436);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_435 = gc_frame_newslot(*var_i);
  params[0] = num436;
  partcv[0] = 1;
  Object sum438 = callmethod(*var_i, "+", 1, partcv, params);
// compiled op node returning sum438 (depth = 5)
  gc_frame_newslot(sum438);
// starting to compile call node (depth = 5)
  int callframe439 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe440 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call441 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe440);
// compiled call node returning call441 (depth = 7)
// compiled member node returning call441 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call442 = callmethod(call441, "at",
    1, partcv, params);
  gc_frame_end(callframe439);
// compiled call node returning call442 (depth = 5)
  gc_frame_newslot(call442);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_block2 (depth = 5)
  params[0] = sum438;
  params[1] = call442;
  partcv[0] = 2;
  Object call443 = callmethod(*var_block2, "apply",
    1, partcv, params);
  gc_frame_end(callframe434);
// compiled call node returning call443 (depth = 4)
// Begin line 510
  setline(510);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num445 = alloc_Float64(1);
// compiled num node returning num445 (depth = 6)
  int op_slot_right_444 = gc_frame_newslot(num445);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_444 = gc_frame_newslot(*var_i);
  params[0] = num445;
  partcv[0] = 1;
  Object sum447 = callmethod(*var_i, "+", 1, partcv, params);
// compiled op node returning sum447 (depth = 5)
  *var_i = sum447;
  if (sum447 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_keysAndValuesDo421(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keysAndValuesDo");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method keysAndValuesDo");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for keysAndValuesDo (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block2 = &(stackframe->slots[0]);
  *var_block2 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for keysAndValuesDo");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_i = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "i");
// Begin line 507
  setline(507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num422 = alloc_Float64(0);
// compiled num node returning num422 (depth = 3)
  *var_i = num422;
  if (num422 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 508
  setline(508);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe423 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block424 = alloc_Block(NULL, NULL, "collectionsPrelude", 508);
  gc_frame_newslot(block424);
// method _apply
  block_savedest(block424);
  Object closure425 = createclosure(2, "_apply");
  setclosureframe(closure425, stackframe);
  addtoclosure(closure425, var_i);
  addtoclosure(closure425, selfslot);
  struct UserObject *uo425 = (struct UserObject*)block424;
  uo425->data[0] = (Object)closure425;
  Method *meth_meth_collectionsPrelude__apply425 = addmethod2pos(block424, "_apply", &meth_collectionsPrelude__apply425, 0);
  int argcv_meth_collectionsPrelude__apply425[] = {0};
  meth_meth_collectionsPrelude__apply425->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply425);
  meth_meth_collectionsPrelude__apply425->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply425->definitionLine = 501;
// compiled block node returning block424 (depth = 3)
  gc_frame_newslot(block424);
// starting to compile block node (depth = 3)
  Object block432 = alloc_Block(NULL, NULL, "collectionsPrelude", 508);
  gc_frame_newslot(block432);
// method _apply
  block_savedest(block432);
  Object closure433 = createclosure(3, "_apply");
  setclosureframe(closure433, stackframe);
  addtoclosure(closure433, var_i);
  addtoclosure(closure433, var_block2);
  addtoclosure(closure433, selfslot);
  struct UserObject *uo433 = (struct UserObject*)block432;
  uo433->data[0] = (Object)closure433;
  Method *meth_meth_collectionsPrelude__apply433 = addmethod2pos(block432, "_apply", &meth_collectionsPrelude__apply433, 0);
  int argcv_meth_collectionsPrelude__apply433[] = {0};
  meth_meth_collectionsPrelude__apply433->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply433);
  meth_meth_collectionsPrelude__apply433->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply433->definitionLine = 508;
// compiled block node returning block432 (depth = 3)
  gc_frame_newslot(block432);
// call case 5: prelude request
  params[0] = block424;
  params[1] = block432;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call450 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe423);
// compiled call node returning call450 (depth = 2)
  gc_frame_end(frame);
  return call450;
}
Object meth_collectionsPrelude__apply466(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_ix = getfromclosure(closure, 0);
  Object *var_freshArray = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 517
  setline(517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe467 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ix (depth = 5)
  gc_frame_newslot(*var_ix);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_each (depth = 5)
  gc_frame_newslot(*var_each);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_freshArray (depth = 5)
  params[0] = *var_ix;
  params[1] = *var_each;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call468 = callmethod(*var_freshArray, "at()put",
    2, partcv, params);
  gc_frame_end(callframe467);
// compiled call node returning call468 (depth = 4)
// Begin line 518
  setline(518);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num470 = alloc_Float64(1);
// compiled num node returning num470 (depth = 6)
  int op_slot_right_469 = gc_frame_newslot(num470);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  int op_slot_left_469 = gc_frame_newslot(*var_ix);
  params[0] = num470;
  partcv[0] = 1;
  Object diff472 = callmethod(*var_ix, "-", 1, partcv, params);
// compiled op node returning diff472 (depth = 5)
  *var_ix = diff472;
  if (diff472 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_reversed451(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "reversed");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var__prelude = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for reversed (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for reversed");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_freshArray = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "freshArray");
  Object *var_ix = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "ix");
// Begin line 514
  setline(514);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe452 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe453 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call454 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe453);
// compiled call node returning call454 (depth = 5)
// compiled member node returning call454 (depth = 4)
  gc_frame_newslot(call454);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe455 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var__prelude (depth = 6)
  partcv[0] = 0;
  Object call456 = callmethod(*var__prelude, "PrimitiveArray",
    1, partcv, params);
  gc_frame_end(callframe455);
// compiled call node returning call456 (depth = 5)
// compiled member node returning call456 (depth = 4)
  params[0] = call454;
  partcv[0] = 1;
  Object call457 = callmethod(call456, "new",
    1, partcv, params);
  gc_frame_end(callframe452);
// compiled call node returning call457 (depth = 3)
  *var_freshArray = call457;
  if (call457 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 515
  setline(515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num459 = alloc_Float64(1);
// compiled num node returning num459 (depth = 4)
  int op_slot_right_458 = gc_frame_newslot(num459);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe461 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call462 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe461);
// compiled call node returning call462 (depth = 5)
// compiled member node returning call462 (depth = 4)
  int op_slot_left_458 = gc_frame_newslot(call462);
  params[0] = num459;
  partcv[0] = 1;
  Object diff463 = callmethod(call462, "-", 1, partcv, params);
// compiled op node returning diff463 (depth = 3)
  *var_ix = diff463;
  if (diff463 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 516
  setline(516);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe464 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block465 = alloc_Block(NULL, NULL, "collectionsPrelude", 516);
  gc_frame_newslot(block465);
// method _apply
  block_savedest(block465);
  Object closure466 = createclosure(3, "_apply");
  setclosureframe(closure466, stackframe);
  addtoclosure(closure466, var_ix);
  addtoclosure(closure466, var_freshArray);
  addtoclosure(closure466, selfslot);
  struct UserObject *uo466 = (struct UserObject*)block465;
  uo466->data[0] = (Object)closure466;
  Method *meth_meth_collectionsPrelude__apply466 = addmethod2pos(block465, "_apply", &meth_collectionsPrelude__apply466, 0);
  int argcv_meth_collectionsPrelude__apply466[] = {1};
  meth_meth_collectionsPrelude__apply466->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply466);
  meth_meth_collectionsPrelude__apply466->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply466->definitionLine = 515;
// compiled block node returning block465 (depth = 3)
  gc_frame_newslot(block465);
// call case 4: self request
  params[0] = block465;
  partcv[0] = 1;
  Object call475 = callmethodflags(self, "do", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe464);
// compiled call node returning call475 (depth = 2)
// Begin line 520
  setline(520);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe476 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_freshArray (depth = 3)
  gc_frame_newslot(*var_freshArray);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe477 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call478 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe477);
// compiled call node returning call478 (depth = 4)
// compiled member node returning call478 (depth = 3)
  gc_frame_newslot(call478);
// call case 2: outer request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe479 = gc_frame_new();
// call case 3: self.outer request
  Object call480 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe479);
// compiled call node returning call480 (depth = 4)
// compiled member node returning call480 (depth = 3)
  params[0] = *var_freshArray;
  params[1] = call478;
  partcv[0] = 2;
  Object call481 = callmethodflags(call480, "fromPrimitiveArray", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe476);
// compiled call node returning call481 (depth = 2)
  gc_frame_end(frame);
  return call481;
}
Object meth_collectionsPrelude__43__43_482(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "++");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method ++");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for ++ (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for ++");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 523
  setline(523);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe483 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  gc_frame_newslot(*var_other);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe484 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe485 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe486 = gc_frame_new();
// call case 3: self.outer request
  Object call487 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe486);
// compiled call node returning call487 (depth = 8)
// compiled member node returning call487 (depth = 7)
  partcv[0] = 0;
  Object call488 = callmethodflags(call487, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe485);
// compiled call node returning call488 (depth = 6)
// compiled member node returning call488 (depth = 5)
  partcv[0] = 0;
  Object call489 = callmethodflags(call488, "sequence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe484);
// compiled call node returning call489 (depth = 4)
// compiled member node returning call489 (depth = 3)
  params[0] = self;
  params[1] = *var_other;
  partcv[0] = 2;
  Object call490 = callmethod(call489, "withAll",
    1, partcv, params);
  gc_frame_end(callframe483);
// compiled call node returning call490 (depth = 2)
  gc_frame_end(frame);
  return call490;
}
Object meth_collectionsPrelude__apply505(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 528
  setline(528);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe507 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe508 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe509 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call510 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe509);
// compiled call node returning call510 (depth = 10)
// compiled member node returning call510 (depth = 9)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call511 = callmethod(call510, "at",
    1, partcv, params);
  gc_frame_end(callframe508);
// compiled call node returning call511 (depth = 8)
  partcv[0] = 0;
  Object call512 = callmethod(call511, "asString",
    1, partcv, params);
  gc_frame_end(callframe507);
// compiled call node returning call512 (depth = 7)
// compiled member node returning call512 (depth = 6)
  int op_slot_right_506 = gc_frame_newslot(call512);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_506 = gc_frame_newslot(*var_s);
  params[0] = call512;
  partcv[0] = 1;
  Object opresult514 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult514 (depth = 5)
  *var_s = opresult514;
  if (opresult514 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 529
  setline(529);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num519 = alloc_Float64(1);
// compiled num node returning num519 (depth = 7)
  int op_slot_right_518 = gc_frame_newslot(num519);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe521 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call522 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe521);
// compiled call node returning call522 (depth = 8)
// compiled member node returning call522 (depth = 7)
  int op_slot_left_518 = gc_frame_newslot(call522);
  params[0] = num519;
  partcv[0] = 1;
  Object diff523 = callmethod(call522, "-", 1, partcv, params);
// compiled op node returning diff523 (depth = 6)
  int op_slot_right_517 = gc_frame_newslot(diff523);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_517 = gc_frame_newslot(*var_i);
  params[0] = diff523;
  partcv[0] = 1;
  Object opresult525 = callmethod(*var_i, "<", 1, partcv, params);
// compiled op node returning opresult525 (depth = 5)
  Object if516 = done;
  if (istrue(opresult525)) {
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit527 == NULL) {
    strlit527 = alloc_String(", ");
    gc_root(strlit527);
  }
// compiled string node returning strlit527 (depth = 7)
  int op_slot_right_526 = gc_frame_newslot(strlit527);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_526 = gc_frame_newslot(*var_s);
  params[0] = strlit527;
  partcv[0] = 1;
  Object opresult529 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult529 (depth = 6)
  *var_s = opresult529;
  if (opresult529 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if516 = done;
  } else {
  }
// compiled if node returning if516 (depth = 4)
  gc_frame_end(frame);
  return if516;
}
Object meth_collectionsPrelude_asString491(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
// Begin line 526
  setline(526);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit492 == NULL) {
    strlit492 = alloc_String("""\xe2""""\x9f""""\xa8""");
    gc_root(strlit492);
  }
// compiled string node returning strlit492 (depth = 3)
  *var_s = strlit492;
  if (strlit492 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 527
  setline(527);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe493 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num496 = alloc_Float64(1);
// compiled num node returning num496 (depth = 5)
  int op_slot_right_495 = gc_frame_newslot(num496);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe498 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call499 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe498);
// compiled call node returning call499 (depth = 6)
// compiled member node returning call499 (depth = 5)
  int op_slot_left_495 = gc_frame_newslot(call499);
  params[0] = num496;
  partcv[0] = 1;
  Object diff500 = callmethod(call499, "-", 1, partcv, params);
// compiled op node returning diff500 (depth = 4)
  int op_slot_right_494 = gc_frame_newslot(diff500);
// starting to compile num node (depth = 4)
  Object num502 = alloc_Float64(0);
// compiled num node returning num502 (depth = 4)
  int op_slot_left_494 = gc_frame_newslot(num502);
  params[0] = diff500;
  partcv[0] = 1;
  Object opresult503 = callmethod(num502, "..", 1, partcv, params);
// compiled op node returning opresult503 (depth = 3)
  gc_frame_newslot(opresult503);
// starting to compile block node (depth = 3)
  Object block504 = alloc_Block(NULL, NULL, "collectionsPrelude", 527);
  gc_frame_newslot(block504);
// method _apply
  block_savedest(block504);
  Object closure505 = createclosure(2, "_apply");
  setclosureframe(closure505, stackframe);
  addtoclosure(closure505, var_s);
  addtoclosure(closure505, selfslot);
  struct UserObject *uo505 = (struct UserObject*)block504;
  uo505->data[0] = (Object)closure505;
  Method *meth_meth_collectionsPrelude__apply505 = addmethod2pos(block504, "_apply", &meth_collectionsPrelude__apply505, 0);
  int argcv_meth_collectionsPrelude__apply505[] = {1};
  meth_meth_collectionsPrelude__apply505->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply505);
  meth_meth_collectionsPrelude__apply505->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply505->definitionLine = 527;
// compiled block node returning block504 (depth = 3)
  gc_frame_newslot(block504);
// call case 5: prelude request
  params[0] = opresult503;
  params[1] = block504;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call532 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe493);
// compiled call node returning call532 (depth = 2)
// Begin line 531
  setline(531);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit534 == NULL) {
    strlit534 = alloc_String("""\xe2""""\x9f""""\xa9""");
    gc_root(strlit534);
  }
// compiled string node returning strlit534 (depth = 3)
  int op_slot_right_533 = gc_frame_newslot(strlit534);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  int op_slot_left_533 = gc_frame_newslot(*var_s);
  params[0] = strlit534;
  partcv[0] = 1;
  Object opresult536 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult536 (depth = 2)
  gc_frame_end(frame);
  return opresult536;
}
Object meth_collectionsPrelude__apply540(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_element = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_element (depth = 6)
  int op_slot_right_542 = gc_frame_newslot(*var_element);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_each (depth = 6)
  int op_slot_left_542 = gc_frame_newslot(*var_each);
  params[0] = *var_element;
  partcv[0] = 1;
  Object opresult544 = callmethod(*var_each, "==", 1, partcv, params);
// compiled op node returning opresult544 (depth = 5)
  Object if541 = done;
  if (istrue(opresult544)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool545 = alloc_Boolean(1);
// compiled identifier node returning bool545 (depth = 6)
  block_return(realself, bool545);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if541 = undefined;
  } else {
  }
// compiled if node returning if541 (depth = 4)
  gc_frame_end(frame);
  return if541;
}
Object meth_collectionsPrelude_contains537(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "contains");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method contains");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for contains (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_element = &(stackframe->slots[0]);
  *var_element = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for contains");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 534
  setline(534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe538 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block539 = alloc_Block(NULL, NULL, "collectionsPrelude", 534);
  gc_frame_newslot(block539);
// method _apply
  block_savedest(block539);
  Object closure540 = createclosure(2, "_apply");
  setclosureframe(closure540, stackframe);
  addtoclosure(closure540, var_element);
  addtoclosure(closure540, selfslot);
  struct UserObject *uo540 = (struct UserObject*)block539;
  uo540->data[0] = (Object)closure540;
  Method *meth_meth_collectionsPrelude__apply540 = addmethod2pos(block539, "_apply", &meth_collectionsPrelude__apply540, 0);
  int argcv_meth_collectionsPrelude__apply540[] = {1};
  meth_meth_collectionsPrelude__apply540->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply540);
  meth_meth_collectionsPrelude__apply540->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply540->definitionLine = 529;
// compiled block node returning block539 (depth = 3)
  gc_frame_newslot(block539);
// call case 4: self request
  params[0] = block539;
  partcv[0] = 1;
  Object call547 = callmethodflags(self, "do", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe538);
// compiled call node returning call547 (depth = 2)
// Begin line 535
  setline(535);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool548 = alloc_Boolean(0);
// compiled identifier node returning bool548 (depth = 3)
  return bool548;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply553(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe555 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call556 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe555);
// compiled call node returning call556 (depth = 6)
// compiled member node returning call556 (depth = 5)
  int op_slot_right_554 = gc_frame_newslot(call556);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  int op_slot_left_554 = gc_frame_newslot(*var_i);
  params[0] = call556;
  partcv[0] = 1;
  Object opresult558 = callmethod(*var_i, "<", 1, partcv, params);
// compiled op node returning opresult558 (depth = 4)
  gc_frame_end(frame);
  return opresult558;
}
Object meth_collectionsPrelude__apply561(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object *var_block1 = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 540
  setline(540);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe562 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe563 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe564 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call565 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe564);
// compiled call node returning call565 (depth = 7)
// compiled member node returning call565 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call566 = callmethod(call565, "at",
    1, partcv, params);
  gc_frame_end(callframe563);
// compiled call node returning call566 (depth = 5)
  gc_frame_newslot(call566);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_block1 (depth = 5)
  params[0] = call566;
  partcv[0] = 1;
  Object call567 = callmethod(*var_block1, "apply",
    1, partcv, params);
  gc_frame_end(callframe562);
// compiled call node returning call567 (depth = 4)
// Begin line 541
  setline(541);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num569 = alloc_Float64(1);
// compiled num node returning num569 (depth = 6)
  int op_slot_right_568 = gc_frame_newslot(num569);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_568 = gc_frame_newslot(*var_i);
  params[0] = num569;
  partcv[0] = 1;
  Object sum571 = callmethod(*var_i, "+", 1, partcv, params);
// compiled op node returning sum571 (depth = 5)
  *var_i = sum571;
  if (sum571 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_do549(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method do");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for do (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for do");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_i = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "i");
// Begin line 538
  setline(538);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num550 = alloc_Float64(0);
// compiled num node returning num550 (depth = 3)
  *var_i = num550;
  if (num550 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 539
  setline(539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe551 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block552 = alloc_Block(NULL, NULL, "collectionsPrelude", 539);
  gc_frame_newslot(block552);
// method _apply
  block_savedest(block552);
  Object closure553 = createclosure(2, "_apply");
  setclosureframe(closure553, stackframe);
  addtoclosure(closure553, var_i);
  addtoclosure(closure553, selfslot);
  struct UserObject *uo553 = (struct UserObject*)block552;
  uo553->data[0] = (Object)closure553;
  Method *meth_meth_collectionsPrelude__apply553 = addmethod2pos(block552, "_apply", &meth_collectionsPrelude__apply553, 0);
  int argcv_meth_collectionsPrelude__apply553[] = {0};
  meth_meth_collectionsPrelude__apply553->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply553);
  meth_meth_collectionsPrelude__apply553->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply553->definitionLine = 529;
// compiled block node returning block552 (depth = 3)
  gc_frame_newslot(block552);
// starting to compile block node (depth = 3)
  Object block560 = alloc_Block(NULL, NULL, "collectionsPrelude", 539);
  gc_frame_newslot(block560);
// method _apply
  block_savedest(block560);
  Object closure561 = createclosure(3, "_apply");
  setclosureframe(closure561, stackframe);
  addtoclosure(closure561, var_i);
  addtoclosure(closure561, var_block1);
  addtoclosure(closure561, selfslot);
  struct UserObject *uo561 = (struct UserObject*)block560;
  uo561->data[0] = (Object)closure561;
  Method *meth_meth_collectionsPrelude__apply561 = addmethod2pos(block560, "_apply", &meth_collectionsPrelude__apply561, 0);
  int argcv_meth_collectionsPrelude__apply561[] = {0};
  meth_meth_collectionsPrelude__apply561->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply561);
  meth_meth_collectionsPrelude__apply561->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply561->definitionLine = 539;
// compiled block node returning block560 (depth = 3)
  gc_frame_newslot(block560);
// call case 5: prelude request
  params[0] = block552;
  params[1] = block560;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call574 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe551);
// compiled call node returning call574 (depth = 2)
  gc_frame_end(frame);
  return call574;
}
Object meth_collectionsPrelude__apply585(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_otherIter = getfromclosure(closure, 0);
  Object *var_selfIter = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe587 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_otherIter (depth = 9)
  partcv[0] = 0;
  Object call588 = callmethod(*var_otherIter, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe587);
// compiled call node returning call588 (depth = 8)
// compiled member node returning call588 (depth = 7)
  int op_slot_right_586 = gc_frame_newslot(call588);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe590 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_selfIter (depth = 9)
  partcv[0] = 0;
  Object call591 = callmethod(*var_selfIter, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe590);
// compiled call node returning call591 (depth = 8)
// compiled member node returning call591 (depth = 7)
  int op_slot_left_586 = gc_frame_newslot(call591);
  params[0] = call588;
  partcv[0] = 1;
  Object opresult592 = callmethod(call591, "&&", 1, partcv, params);
// compiled op node returning opresult592 (depth = 6)
  gc_frame_end(frame);
  return opresult592;
}
Object meth_collectionsPrelude__apply595(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_otherIter = getfromclosure(closure, 0);
  Object *var_selfIter = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 551
  setline(551);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe598 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_otherIter (depth = 10)
  partcv[0] = 0;
  Object call599 = callmethod(*var_otherIter, "next",
    1, partcv, params);
  gc_frame_end(callframe598);
// compiled call node returning call599 (depth = 9)
// compiled member node returning call599 (depth = 8)
  int op_slot_right_597 = gc_frame_newslot(call599);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe601 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_selfIter (depth = 10)
  partcv[0] = 0;
  Object call602 = callmethod(*var_selfIter, "next",
    1, partcv, params);
  gc_frame_end(callframe601);
// compiled call node returning call602 (depth = 9)
// compiled member node returning call602 (depth = 8)
  int op_slot_left_597 = gc_frame_newslot(call602);
  params[0] = call599;
  partcv[0] = 1;
  Object opresult603 = callmethod(call602, "!=", 1, partcv, params);
// compiled op node returning opresult603 (depth = 7)
  Object if596 = done;
  if (istrue(opresult603)) {
// Begin line 552
  setline(552);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool604 = alloc_Boolean(0);
// compiled identifier node returning bool604 (depth = 8)
  block_return(realself, bool604);
// compiled return node returning undefined (depth = 7)
    gc_frame_newslot(undefined);
    if596 = undefined;
  } else {
  }
// compiled if node returning if596 (depth = 6)
  gc_frame_end(frame);
  return if596;
}
Object meth_collectionsPrelude__apply578(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_other = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_selfIter = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "selfIter");
  Object *var_otherIter = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "otherIter");
// Begin line 548
  setline(548);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe579 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call580 = callmethodflags(self, "iterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe579);
// compiled call node returning call580 (depth = 6)
// compiled member node returning call580 (depth = 5)
  *var_selfIter = call580;
  if (call580 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 549
  setline(549);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe581 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  partcv[0] = 0;
  Object call582 = callmethod(*var_other, "iterator",
    1, partcv, params);
  gc_frame_end(callframe581);
// compiled call node returning call582 (depth = 6)
// compiled member node returning call582 (depth = 5)
  *var_otherIter = call582;
  if (call582 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 550
  setline(550);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe583 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block584 = alloc_Block(NULL, NULL, "collectionsPrelude", 550);
  gc_frame_newslot(block584);
// method _apply
  block_savedest(block584);
  Object closure585 = createclosure(3, "_apply");
  setclosureframe(closure585, stackframe);
  addtoclosure(closure585, var_otherIter);
  addtoclosure(closure585, var_selfIter);
  addtoclosure(closure585, selfslot);
  struct UserObject *uo585 = (struct UserObject*)block584;
  uo585->data[0] = (Object)closure585;
  Method *meth_meth_collectionsPrelude__apply585 = addmethod2pos(block584, "_apply", &meth_collectionsPrelude__apply585, 0);
  int argcv_meth_collectionsPrelude__apply585[] = {0};
  meth_meth_collectionsPrelude__apply585->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply585);
  meth_meth_collectionsPrelude__apply585->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply585->definitionLine = 549;
// compiled block node returning block584 (depth = 5)
  gc_frame_newslot(block584);
// starting to compile block node (depth = 5)
  Object block594 = alloc_Block(NULL, NULL, "collectionsPrelude", 550);
  gc_frame_newslot(block594);
// method _apply
  block_savedest(block594);
  Object closure595 = createclosure(3, "_apply");
  setclosureframe(closure595, stackframe);
  addtoclosure(closure595, var_otherIter);
  addtoclosure(closure595, var_selfIter);
  addtoclosure(closure595, selfslot);
  struct UserObject *uo595 = (struct UserObject*)block594;
  uo595->data[0] = (Object)closure595;
  Method *meth_meth_collectionsPrelude__apply595 = addmethod2pos(block594, "_apply", &meth_collectionsPrelude__apply595, 0);
  int argcv_meth_collectionsPrelude__apply595[] = {0};
  meth_meth_collectionsPrelude__apply595->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply595);
  meth_meth_collectionsPrelude__apply595->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply595->definitionLine = 550;
// compiled block node returning block594 (depth = 5)
  gc_frame_newslot(block594);
// call case 5: prelude request
  params[0] = block584;
  params[1] = block594;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call606 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe583);
// compiled call node returning call606 (depth = 4)
// Begin line 555
  setline(555);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe608 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_otherIter (depth = 8)
  partcv[0] = 0;
  Object call609 = callmethod(*var_otherIter, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe608);
// compiled call node returning call609 (depth = 7)
// compiled member node returning call609 (depth = 6)
  int op_slot_right_607 = gc_frame_newslot(call609);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe611 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_selfIter (depth = 8)
  partcv[0] = 0;
  Object call612 = callmethod(*var_selfIter, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe611);
// compiled call node returning call612 (depth = 7)
// compiled member node returning call612 (depth = 6)
  int op_slot_left_607 = gc_frame_newslot(call612);
  params[0] = call609;
  partcv[0] = 1;
  Object opresult613 = callmethod(call612, "==", 1, partcv, params);
// compiled op node returning opresult613 (depth = 5)
  block_return(realself, opresult613);
// compiled return node returning undefined (depth = 4)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply625(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___14 = &(stackframe->slots[0]);
  *var___14 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 558
  setline(558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool626 = alloc_Boolean(0);
// compiled identifier node returning bool626 (depth = 5)
  block_return(realself, bool626);
// compiled return node returning undefined (depth = 4)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__61__61_575(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "==");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method ==");
  Object params[2];
  int partcv[1];
  Object *var_Collection = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for == (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for ==");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 546
  setline(546);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  int frame576 = gc_frame_new();
  gc_frame_newslot(*var_other);
// Begin line 547
  setline(547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block577 = alloc_Block(NULL, NULL, "collectionsPrelude", 547);
  gc_frame_newslot(block577);
// method _apply
  block_savedest(block577);
  Object closure578 = createclosure(2, "_apply");
  setclosureframe(closure578, stackframe);
  addtoclosure(closure578, var_other);
  addtoclosure(closure578, selfslot);
  struct UserObject *uo578 = (struct UserObject*)block577;
  uo578->data[0] = (Object)closure578;
  Method *meth_meth_collectionsPrelude__apply578 = addmethod2pos(block577, "_apply", &meth_collectionsPrelude__apply578, 0);
  int argcv_meth_collectionsPrelude__apply578[] = {1};
  meth_meth_collectionsPrelude__apply578->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply578);
  meth_meth_collectionsPrelude__apply578->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply578->definitionLine = 540;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe615 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe616 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit617 == NULL) {
    strlit617 = alloc_String("o");
    gc_root(strlit617);
  }
// compiled string node returning strlit617 (depth = 6)
  gc_frame_newslot(strlit617);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe618 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call619 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe618);
// compiled call node returning call619 (depth = 7)
// compiled member node returning call619 (depth = 6)
  params[0] = strlit617;
  partcv[0] = 1;
  Object call620 = callmethod(call619, "new",
    1, partcv, params);
  gc_frame_end(callframe616);
// compiled call node returning call620 (depth = 5)
  gc_frame_newslot(call620);
// Begin line 547
  setline(547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_Collection (depth = 5)
  gc_frame_newslot(*var_Collection);
// call case 6: other member request
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe621 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call622 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe621);
// compiled call node returning call622 (depth = 6)
// compiled member node returning call622 (depth = 5)
  params[0] = call620;
  params[1] = *var_Collection;
  partcv[0] = 2;
  Object call623 = callmethod(call622, "new",
    1, partcv, params);
  gc_frame_end(callframe615);
// compiled call node returning call623 (depth = 4)
((struct UserObject *)block577)->data[1] = call623;
// compiled block node returning block577 (depth = 3)
  gc_frame_newslot(block577);
// Begin line 557
  setline(557);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block624 = alloc_Block(NULL, NULL, "collectionsPrelude", 557);
  gc_frame_newslot(block624);
// method _apply
  block_savedest(block624);
  Object closure625 = createclosure(1, "_apply");
  setclosureframe(closure625, stackframe);
  addtoclosure(closure625, selfslot);
  struct UserObject *uo625 = (struct UserObject*)block624;
  uo625->data[0] = (Object)closure625;
  Method *meth_meth_collectionsPrelude__apply625 = addmethod2pos(block624, "_apply", &meth_collectionsPrelude__apply625, 0);
  int argcv_meth_collectionsPrelude__apply625[] = {1};
  meth_meth_collectionsPrelude__apply625->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply625);
  meth_meth_collectionsPrelude__apply625->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply625->definitionLine = 0;
// compiled block node returning block624 (depth = 3)
  gc_frame_newslot(block624);
  params[0] = block577;
  params[1] = block624;
  Object matchres576 = matchCase(*var_other, params, 2,NULL);
  gc_frame_end(frame576);
// compiled matchcase node returning matchres576 (depth = 2)
  gc_frame_end(frame);
  return matchres576;
}
Object meth_collectionsPrelude_asDebugString633(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asDebugString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asDebugString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 565
  setline(565);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit635 == NULL) {
    strlit635 = alloc_String("""\xe2""""\x9f""""\xab""");
    gc_root(strlit635);
  }
// compiled string node returning strlit635 (depth = 3)
  int op_slot_right_634 = gc_frame_newslot(strlit635);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe638 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call639 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe638);
// compiled call node returning call639 (depth = 5)
// compiled member node returning call639 (depth = 4)
  int op_slot_right_637 = gc_frame_newslot(call639);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit642 == NULL) {
    strlit642 = alloc_String("""\xe2""""\x9f""""\xaa""");
    gc_root(strlit642);
  }
// compiled string node returning strlit642 (depth = 5)
  int op_slot_right_641 = gc_frame_newslot(strlit642);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe645 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call646 = callmethodflags(self, "asString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe645);
// compiled call node returning call646 (depth = 7)
// compiled member node returning call646 (depth = 6)
  int op_slot_right_644 = gc_frame_newslot(call646);
// starting to compile string node (depth = 6)
  if (strlit648 == NULL) {
    strlit648 = alloc_String("");
    gc_root(strlit648);
  }
// compiled string node returning strlit648 (depth = 6)
  int op_slot_left_644 = gc_frame_newslot(strlit648);
  params[0] = call646;
  partcv[0] = 1;
  Object opresult649 = callmethod(strlit648, "++", 1, partcv, params);
// compiled op node returning opresult649 (depth = 5)
  int op_slot_left_641 = gc_frame_newslot(opresult649);
  params[0] = strlit642;
  partcv[0] = 1;
  Object opresult650 = callmethod(opresult649, "++", 1, partcv, params);
// compiled op node returning opresult650 (depth = 4)
  int op_slot_left_637 = gc_frame_newslot(opresult650);
  params[0] = call639;
  partcv[0] = 1;
  Object opresult651 = callmethod(opresult650, "++", 1, partcv, params);
// compiled op node returning opresult651 (depth = 3)
  int op_slot_left_634 = gc_frame_newslot(opresult651);
  params[0] = strlit635;
  partcv[0] = 1;
  Object opresult652 = callmethod(opresult651, "++", 1, partcv, params);
// compiled op node returning opresult652 (depth = 2)
  gc_frame_end(frame);
  return opresult652;
}
Object meth_collectionsPrelude_asString653(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 566
  setline(566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit654 == NULL) {
    strlit654 = alloc_String("aSequenceIterator");
    gc_root(strlit654);
  }
// compiled string node returning strlit654 (depth = 2)
  gc_frame_end(frame);
  return strlit654;
}
Object meth_collectionsPrelude_hasNext655(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sz = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for hasNext (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for hasNext");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 567
  setline(567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sz (depth = 3)
  int op_slot_right_656 = gc_frame_newslot(*var_sz);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe658 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call659 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe658);
// compiled call node returning call659 (depth = 4)
// compiled member node returning call659 (depth = 3)
  int op_slot_left_656 = gc_frame_newslot(call659);
  params[0] = *var_sz;
  partcv[0] = 1;
  Object opresult660 = callmethod(call659, "<=", 1, partcv, params);
// compiled op node returning opresult660 (depth = 2)
  gc_frame_end(frame);
  return opresult660;
}
Object meth_collectionsPrelude_next661(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_sz = getfromclosure(closure, 1);
  Object *var_Exhausted = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for next (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for next");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ret = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "ret");
// Begin line 569
  setline(569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe664 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe665 = gc_frame_new();
// call case 3: self.outer request
  Object call666 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe665);
// compiled call node returning call666 (depth = 7)
// compiled member node returning call666 (depth = 6)
  partcv[0] = 0;
  Object call667 = callmethodflags(call666, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe664);
// compiled call node returning call667 (depth = 5)
// compiled member node returning call667 (depth = 4)
  int op_slot_right_663 = gc_frame_newslot(call667);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe669 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call670 = callmethodflags(self, "imods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe669);
// compiled call node returning call670 (depth = 5)
// compiled member node returning call670 (depth = 4)
  int op_slot_left_663 = gc_frame_newslot(call670);
  params[0] = call667;
  partcv[0] = 1;
  Object opresult671 = callmethod(call670, "!=", 1, partcv, params);
// compiled op node returning opresult671 (depth = 3)
  Object if662 = done;
  if (istrue(opresult671)) {
// starting to compile call node (depth = 3)
  int callframe672 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe673 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call674 = callmethodflags(self, "asDebugString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe673);
// compiled call node returning call674 (depth = 5)
// compiled member node returning call674 (depth = 4)
  gc_frame_newslot(call674);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ConcurrentModification (depth = 4)
  params[0] = call674;
  partcv[0] = 1;
  Object call675 = callmethod(*var_ConcurrentModification, "raise",
    1, partcv, params);
  gc_frame_end(callframe672);
// compiled call node returning call675 (depth = 3)
    gc_frame_newslot(call675);
    if662 = call675;
  } else {
  }
// compiled if node returning if662 (depth = 2)
// Begin line 570
  setline(570);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sz (depth = 4)
  int op_slot_right_677 = gc_frame_newslot(*var_sz);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe679 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call680 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe679);
// compiled call node returning call680 (depth = 5)
// compiled member node returning call680 (depth = 4)
  int op_slot_left_677 = gc_frame_newslot(call680);
  params[0] = *var_sz;
  partcv[0] = 1;
  Object opresult681 = callmethod(call680, ">", 1, partcv, params);
// compiled op node returning opresult681 (depth = 3)
  Object if676 = done;
  if (istrue(opresult681)) {
// starting to compile call node (depth = 3)
  int callframe682 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit684 == NULL) {
    strlit684 = alloc_String("""\xe2""""\x9f""""\xab""");
    gc_root(strlit684);
  }
// compiled string node returning strlit684 (depth = 5)
  int op_slot_right_683 = gc_frame_newslot(strlit684);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe687 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call688 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe687);
// compiled call node returning call688 (depth = 7)
// compiled member node returning call688 (depth = 6)
  int op_slot_right_686 = gc_frame_newslot(call688);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit691 == NULL) {
    strlit691 = alloc_String("""\xe2""""\x9f""""\xaa""");
    gc_root(strlit691);
  }
// compiled string node returning strlit691 (depth = 7)
  int op_slot_right_690 = gc_frame_newslot(strlit691);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe694 = gc_frame_new();
// call case 3: self.outer request
  Object call695 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe694);
// compiled call node returning call695 (depth = 9)
// compiled member node returning call695 (depth = 8)
  int op_slot_right_693 = gc_frame_newslot(call695);
// starting to compile string node (depth = 8)
  if (strlit697 == NULL) {
    strlit697 = alloc_String("on sequence ");
    gc_root(strlit697);
  }
// compiled string node returning strlit697 (depth = 8)
  int op_slot_left_693 = gc_frame_newslot(strlit697);
  params[0] = call695;
  partcv[0] = 1;
  Object opresult698 = callmethod(strlit697, "++", 1, partcv, params);
// compiled op node returning opresult698 (depth = 7)
  int op_slot_left_690 = gc_frame_newslot(opresult698);
  params[0] = strlit691;
  partcv[0] = 1;
  Object opresult699 = callmethod(opresult698, "++", 1, partcv, params);
// compiled op node returning opresult699 (depth = 6)
  int op_slot_left_686 = gc_frame_newslot(opresult699);
  params[0] = call688;
  partcv[0] = 1;
  Object opresult700 = callmethod(opresult699, "++", 1, partcv, params);
// compiled op node returning opresult700 (depth = 5)
  int op_slot_left_683 = gc_frame_newslot(opresult700);
  params[0] = strlit684;
  partcv[0] = 1;
  Object opresult701 = callmethod(opresult700, "++", 1, partcv, params);
// compiled op node returning opresult701 (depth = 4)
  gc_frame_newslot(opresult701);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_Exhausted (depth = 4)
  params[0] = opresult701;
  partcv[0] = 1;
  Object call702 = callmethod(*var_Exhausted, "raise",
    1, partcv, params);
  gc_frame_end(callframe682);
// compiled call node returning call702 (depth = 3)
    gc_frame_newslot(call702);
    if676 = call702;
  } else {
  }
// compiled if node returning if676 (depth = 2)
// Begin line 571
  setline(571);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe703 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe704 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call705 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe704);
// compiled call node returning call705 (depth = 5)
// compiled member node returning call705 (depth = 4)
  gc_frame_newslot(call705);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe706 = gc_frame_new();
// call case 3: self.outer request
  Object call707 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe706);
// compiled call node returning call707 (depth = 5)
// compiled member node returning call707 (depth = 4)
  params[0] = call705;
  partcv[0] = 1;
  Object call708 = callmethodflags(call707, "at", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe703);
// compiled call node returning call708 (depth = 3)
  *var_ret = call708;
  if (call708 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 572
  setline(572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 571
  setline(571);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe709 = gc_frame_new();
// Begin line 572
  setline(572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num711 = alloc_Float64(1);
// compiled num node returning num711 (depth = 5)
  int op_slot_right_710 = gc_frame_newslot(num711);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe713 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call714 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe713);
// compiled call node returning call714 (depth = 6)
// compiled member node returning call714 (depth = 5)
  int op_slot_left_710 = gc_frame_newslot(call714);
  params[0] = num711;
  partcv[0] = 1;
  Object sum715 = callmethod(call714, "+", 1, partcv, params);
// compiled op node returning sum715 (depth = 4)
  gc_frame_newslot(sum715);
// call case 4: self request
  params[0] = sum715;
  partcv[0] = 1;
  Object call716 = callmethodflags(self, "idx:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe709);
// compiled call node returning call716 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 573
  setline(573);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_ret (depth = 2)
  gc_frame_end(frame);
  return *var_ret;
}
Object meth_collectionsPrelude_iterator628(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sz = getfromclosure(closure, 0);
  Object *var_ConcurrentModification = getfromclosure(closure, 1);
  Object *var_Exhausted = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject629 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj629 = alloc_userobj2(8,7, objclass629);
  gc_frame_newslot(obj629);
if (objclass629 == NULL) {
  glfree(obj629->class->name);
  obj629->class->name = "obj344.iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj629, self, 0);
  addmethodreal(obj629,"outer", &reader_collectionsPrelude_outer_630);
  Object oldself629 = self;
  struct StackFrameObject *oldstackframe629 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe629);
  gc_frame_newslot((Object)stackframe);
  self = obj629;
  Object *oldselfslot629 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter629 = (*(struct UserObject *)self).data[0], lowerouter629 = thisouter629;
  if (inheritingObject629) {
    struct UserObject *inho629 = (struct UserObject *)inheritingObject629;
    while (inho629->super != GraceDefaultObject) inho629 = (struct UserObject *)inho629->super;
    inho629->super = obj629;
    self = inheritingObject629;
    *selfslot = self;
    lowerouter629 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter629;
  }
if (objclass629 == NULL) {
  Method *reader631 = addmethodrealflags(obj629, "imods",&reader_collectionsPrelude_imods_631, MFLAG_CONFIDENTIAL);
  Method *writer631 = addmethodrealflags(obj629, "imods:=",&writer_collectionsPrelude_imods_631, MFLAG_CONFIDENTIAL);
  reader631->definitionModule = modulename;
  writer631->definitionModule = modulename;
  reader631->definitionLine = 563;
  writer631->definitionLine = 563;
}
obj629->flags |= OFLAG_MUTABLE;
adddatum2(obj629, alloc_Undefined(), 1);
if (objclass629 == NULL) {
  Method *reader632 = addmethodrealflags(obj629, "idx",&reader_collectionsPrelude_idx_632, MFLAG_CONFIDENTIAL);
  Method *writer632 = addmethodrealflags(obj629, "idx:=",&writer_collectionsPrelude_idx_632, MFLAG_CONFIDENTIAL);
  reader632->definitionModule = modulename;
  writer632->definitionModule = modulename;
  reader632->definitionLine = 564;
  writer632->definitionLine = 564;
}
obj629->flags |= OFLAG_MUTABLE;
adddatum2(obj629, alloc_Undefined(), 2);
// method asDebugString
  struct UserObject *uo633 = (struct UserObject*)obj629;
  uo633->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDebugString633 = addmethod2pos(obj629, "asDebugString", &meth_collectionsPrelude_asDebugString633, 3);
  int argcv_meth_collectionsPrelude_asDebugString633[] = {0};
  meth_meth_collectionsPrelude_asDebugString633->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString633);
  meth_meth_collectionsPrelude_asDebugString633->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString633->definitionLine = 565;
// method asString
  struct UserObject *uo653 = (struct UserObject*)obj629;
  uo653->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString653 = addmethod2pos(obj629, "asString", &meth_collectionsPrelude_asString653, 4);
  int argcv_meth_collectionsPrelude_asString653[] = {0};
  meth_meth_collectionsPrelude_asString653->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString653);
  meth_meth_collectionsPrelude_asString653->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString653->definitionLine = 566;
// method hasNext
  block_savedest(obj629);
  Object closure655 = createclosure(1, "hasNext");
  setclosureframe(closure655, stackframe);
  addtoclosure(closure655, var_sz);
  struct UserObject *uo655 = (struct UserObject*)obj629;
  uo655->data[5] = (Object)closure655;
  Method *meth_meth_collectionsPrelude_hasNext655 = addmethod2pos(obj629, "hasNext", &meth_collectionsPrelude_hasNext655, 5);
  int argcv_meth_collectionsPrelude_hasNext655[] = {0};
  meth_meth_collectionsPrelude_hasNext655->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext655);
  meth_meth_collectionsPrelude_hasNext655->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext655->definitionLine = 567;
// method next
  block_savedest(obj629);
  Object closure661 = createclosure(3, "next");
  setclosureframe(closure661, stackframe);
  addtoclosure(closure661, var_ConcurrentModification);
  addtoclosure(closure661, var_sz);
  addtoclosure(closure661, var_Exhausted);
  struct UserObject *uo661 = (struct UserObject*)obj629;
  uo661->data[6] = (Object)closure661;
  Method *meth_meth_collectionsPrelude_next661 = addmethod2pos(obj629, "next", &meth_collectionsPrelude_next661, 6);
  int argcv_meth_collectionsPrelude_next661[] = {0};
  meth_meth_collectionsPrelude_next661->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next661);
  meth_meth_collectionsPrelude_next661->definitionModule = modulename;
  meth_meth_collectionsPrelude_next661->definitionLine = 568;
  sourceObject = obj629;
// Begin line 563
  setline(563);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe717 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe718 = gc_frame_new();
// call case 3: self.outer request
  Object call719 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe718);
// compiled call node returning call719 (depth = 5)
// compiled member node returning call719 (depth = 4)
  partcv[0] = 0;
  Object call720 = callmethodflags(call719, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe717);
// compiled call node returning call720 (depth = 3)
// compiled member node returning call720 (depth = 2)
  adddatum2(obj629, call720, 1);
  sourceObject = obj629;
// Begin line 564
  setline(564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num721 = alloc_Float64(1);
// compiled num node returning num721 (depth = 2)
  adddatum2(obj629, num721, 2);
  sourceObject = obj629;
  sourceObject = obj629;
  sourceObject = obj629;
  sourceObject = obj629;
  objclass629 = obj629->class;
  objclass629->definitionModule = modulename;
  objclass629->definitionLine = 562;
  (*(struct UserObject *)self).data[0] = lowerouter629;
  self = oldself629;
  selfslot = oldselfslot629;
  stackframe = oldstackframe629;
  gc_frame_end(frame);
  return obj629;
}
Object meth_collectionsPrelude_iterator628_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_sz = getfromclosure(closure, 0);
  Object *var_ConcurrentModification = getfromclosure(closure, 1);
  Object *var_Exhausted = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject629 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj629 = alloc_userobj2(8,7, objclass629);
  gc_frame_newslot(obj629);
if (objclass629 == NULL) {
  glfree(obj629->class->name);
  obj629->class->name = "obj344.iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj629, self, 0);
  addmethodreal(obj629,"outer", &reader_collectionsPrelude_outer_630);
  Object oldself629 = self;
  struct StackFrameObject *oldstackframe629 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe629);
  gc_frame_newslot((Object)stackframe);
  self = obj629;
  Object *oldselfslot629 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter629 = (*(struct UserObject *)self).data[0], lowerouter629 = thisouter629;
  if (inheritingObject629) {
    struct UserObject *inho629 = (struct UserObject *)inheritingObject629;
    while (inho629->super != GraceDefaultObject) inho629 = (struct UserObject *)inho629->super;
    inho629->super = obj629;
    self = inheritingObject629;
    *selfslot = self;
    lowerouter629 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter629;
  }
if (objclass629 == NULL) {
  Method *reader631 = addmethodrealflags(obj629, "imods",&reader_collectionsPrelude_imods_631, MFLAG_CONFIDENTIAL);
  Method *writer631 = addmethodrealflags(obj629, "imods:=",&writer_collectionsPrelude_imods_631, MFLAG_CONFIDENTIAL);
  reader631->definitionModule = modulename;
  writer631->definitionModule = modulename;
  reader631->definitionLine = 563;
  writer631->definitionLine = 563;
}
obj629->flags |= OFLAG_MUTABLE;
adddatum2(obj629, alloc_Undefined(), 1);
if (objclass629 == NULL) {
  Method *reader632 = addmethodrealflags(obj629, "idx",&reader_collectionsPrelude_idx_632, MFLAG_CONFIDENTIAL);
  Method *writer632 = addmethodrealflags(obj629, "idx:=",&writer_collectionsPrelude_idx_632, MFLAG_CONFIDENTIAL);
  reader632->definitionModule = modulename;
  writer632->definitionModule = modulename;
  reader632->definitionLine = 564;
  writer632->definitionLine = 564;
}
obj629->flags |= OFLAG_MUTABLE;
adddatum2(obj629, alloc_Undefined(), 2);
// method asDebugString
  struct UserObject *uo633 = (struct UserObject*)obj629;
  uo633->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDebugString633 = addmethod2pos(obj629, "asDebugString", &meth_collectionsPrelude_asDebugString633, 3);
  int argcv_meth_collectionsPrelude_asDebugString633[] = {0};
  meth_meth_collectionsPrelude_asDebugString633->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString633);
  meth_meth_collectionsPrelude_asDebugString633->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString633->definitionLine = 565;
// method asString
  struct UserObject *uo653 = (struct UserObject*)obj629;
  uo653->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString653 = addmethod2pos(obj629, "asString", &meth_collectionsPrelude_asString653, 4);
  int argcv_meth_collectionsPrelude_asString653[] = {0};
  meth_meth_collectionsPrelude_asString653->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString653);
  meth_meth_collectionsPrelude_asString653->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString653->definitionLine = 566;
// method hasNext
  block_savedest(obj629);
  Object closure655 = createclosure(1, "hasNext");
  setclosureframe(closure655, stackframe);
  addtoclosure(closure655, var_sz);
  struct UserObject *uo655 = (struct UserObject*)obj629;
  uo655->data[5] = (Object)closure655;
  Method *meth_meth_collectionsPrelude_hasNext655 = addmethod2pos(obj629, "hasNext", &meth_collectionsPrelude_hasNext655, 5);
  int argcv_meth_collectionsPrelude_hasNext655[] = {0};
  meth_meth_collectionsPrelude_hasNext655->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext655);
  meth_meth_collectionsPrelude_hasNext655->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext655->definitionLine = 567;
// method next
  block_savedest(obj629);
  Object closure661 = createclosure(3, "next");
  setclosureframe(closure661, stackframe);
  addtoclosure(closure661, var_ConcurrentModification);
  addtoclosure(closure661, var_sz);
  addtoclosure(closure661, var_Exhausted);
  struct UserObject *uo661 = (struct UserObject*)obj629;
  uo661->data[6] = (Object)closure661;
  Method *meth_meth_collectionsPrelude_next661 = addmethod2pos(obj629, "next", &meth_collectionsPrelude_next661, 6);
  int argcv_meth_collectionsPrelude_next661[] = {0};
  meth_meth_collectionsPrelude_next661->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next661);
  meth_meth_collectionsPrelude_next661->definitionModule = modulename;
  meth_meth_collectionsPrelude_next661->definitionLine = 568;
  sourceObject = obj629;
// Begin line 563
  setline(563);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe717 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe718 = gc_frame_new();
// call case 3: self.outer request
  Object call719 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe718);
// compiled call node returning call719 (depth = 5)
// compiled member node returning call719 (depth = 4)
  partcv[0] = 0;
  Object call720 = callmethodflags(call719, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe717);
// compiled call node returning call720 (depth = 3)
// compiled member node returning call720 (depth = 2)
  adddatum2(obj629, call720, 1);
  sourceObject = obj629;
// Begin line 564
  setline(564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num721 = alloc_Float64(1);
// compiled num node returning num721 (depth = 2)
  adddatum2(obj629, num721, 2);
  sourceObject = obj629;
  sourceObject = obj629;
  sourceObject = obj629;
  sourceObject = obj629;
  objclass629 = obj629->class;
  objclass629->definitionModule = modulename;
  objclass629->definitionLine = 562;
  (*(struct UserObject *)self).data[0] = lowerouter629;
  self = oldself629;
  selfslot = oldselfslot629;
  stackframe = oldstackframe629;
  gc_frame_end(frame);
  return obj629;
}
Object meth_collectionsPrelude__apply727(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  Object *var_r = &(stackframe->slots[1]);
  *var_r = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 579
  setline(579);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_r (depth = 8)
  int op_slot_right_729 = gc_frame_newslot(*var_r);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_l (depth = 8)
  int op_slot_left_729 = gc_frame_newslot(*var_l);
  params[0] = *var_r;
  partcv[0] = 1;
  Object opresult731 = callmethod(*var_l, "==", 1, partcv, params);
// compiled op node returning opresult731 (depth = 7)
  Object if728 = done;
  if (istrue(opresult731)) {
// starting to compile num node (depth = 7)
  Object num732 = alloc_Float64(0);
// compiled num node returning num732 (depth = 7)
    gc_frame_newslot(num732);
    if728 = num732;
  } else {
// Begin line 581
  setline(581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 580
  setline(580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_r (depth = 9)
  int op_slot_right_734 = gc_frame_newslot(*var_r);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_l (depth = 9)
  int op_slot_left_734 = gc_frame_newslot(*var_l);
  params[0] = *var_r;
  partcv[0] = 1;
  Object opresult736 = callmethod(*var_l, "<", 1, partcv, params);
// compiled op node returning opresult736 (depth = 8)
  Object if733 = done;
  if (istrue(opresult736)) {
// starting to compile call node (depth = 8)
  int callframe737 = gc_frame_new();
// call case 6: other member request
// starting to compile num node (depth = 9)
  Object num738 = alloc_Float64(1);
// compiled num node returning num738 (depth = 9)
  partcv[0] = 0;
  Object call739 = callmethod(num738, "prefix-",
    1, partcv, params);
  gc_frame_end(callframe737);
// compiled call node returning call739 (depth = 8)
    gc_frame_newslot(call739);
    if733 = call739;
  } else {
// Begin line 581
  setline(581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 8)
  Object num740 = alloc_Float64(1);
// compiled num node returning num740 (depth = 8)
    gc_frame_newslot(num740);
    if733 = num740;
  }
// compiled if node returning if733 (depth = 7)
    gc_frame_newslot(if733);
    if728 = if733;
  }
// compiled if node returning if728 (depth = 6)
  gc_frame_end(frame);
  return if728;
}
Object meth_collectionsPrelude_sorted723(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sorted");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for sorted (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for sorted");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 582
  setline(582);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe724 = gc_frame_new();
// call case 6: other member request
// Begin line 578
  setline(578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe725 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block726 = alloc_Block(NULL, NULL, "collectionsPrelude", 578);
  gc_frame_newslot(block726);
// method _apply
  block_savedest(block726);
  Object closure727 = createclosure(1, "_apply");
  setclosureframe(closure727, stackframe);
  addtoclosure(closure727, selfslot);
  struct UserObject *uo727 = (struct UserObject*)block726;
  uo727->data[0] = (Object)closure727;
  Method *meth_meth_collectionsPrelude__apply727 = addmethod2pos(block726, "_apply", &meth_collectionsPrelude__apply727, 0);
  int argcv_meth_collectionsPrelude__apply727[] = {2};
  meth_meth_collectionsPrelude__apply727->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply727);
  meth_meth_collectionsPrelude__apply727->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply727->definitionLine = 582;
// compiled block node returning block726 (depth = 5)
  gc_frame_newslot(block726);
// call case 6: other member request
// Begin line 578
  setline(578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe742 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call743 = callmethodflags(self, "asList", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe742);
// compiled call node returning call743 (depth = 6)
// compiled member node returning call743 (depth = 5)
  params[0] = block726;
  partcv[0] = 1;
  Object call744 = callmethod(call743, "sortBy",
    1, partcv, params);
  gc_frame_end(callframe725);
// compiled call node returning call744 (depth = 4)
  partcv[0] = 0;
  Object call745 = callmethod(call744, "asSequence",
    1, partcv, params);
  gc_frame_end(callframe724);
// compiled call node returning call745 (depth = 3)
// compiled member node returning call745 (depth = 2)
  gc_frame_end(frame);
  return call745;
}
Object meth_collectionsPrelude_sortedBy746(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sortedBy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method sortedBy");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for sortedBy (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_sortBlock = &(stackframe->slots[0]);
  *var_sortBlock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for sortedBy");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 585
  setline(585);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe747 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe748 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sortBlock (depth = 5)
  gc_frame_newslot(*var_sortBlock);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe749 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call750 = callmethodflags(self, "asList", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe749);
// compiled call node returning call750 (depth = 6)
// compiled member node returning call750 (depth = 5)
  params[0] = *var_sortBlock;
  partcv[0] = 1;
  Object call751 = callmethod(call750, "sortBy",
    1, partcv, params);
  gc_frame_end(callframe748);
// compiled call node returning call751 (depth = 4)
  partcv[0] = 0;
  Object call752 = callmethod(call751, "asSequence",
    1, partcv, params);
  gc_frame_end(callframe747);
// compiled call node returning call752 (depth = 3)
// compiled member node returning call752 (depth = 2)
  gc_frame_end(frame);
  return call752;
}
Object meth_collectionsPrelude_fromPrimitiveArray343(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "fromPrimitiveArray");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method fromPrimitiveArray");
  Object params[1];
  int partcv[2];
  Object *var_BoundsError = getfromclosure(closure, 0);
  Object *var__prelude = getfromclosure(closure, 1);
  Object *var_Collection = getfromclosure(closure, 2);
  Object *var_ConcurrentModification = getfromclosure(closure, 3);
  Object *var_Exhausted = getfromclosure(closure, 4);
  Object *var_indexable = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for fromPrimitiveArray (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_pArray = &(stackframe->slots[0]);
  *var_pArray = args[curarg];
  curarg++;
  Object *var_sz = &(stackframe->slots[1]);
  *var_sz = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for fromPrimitiveArray");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject344 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj344 = alloc_userobj2(21,21, objclass344);
  gc_frame_newslot(obj344);
if (objclass344 == NULL) {
  glfree(obj344->class->name);
  obj344->class->name = "obj227.fromPrimitiveArray";
}
// OBJECT OUTER DEC outer
  adddatum2(obj344, self, 0);
  addmethodreal(obj344,"outer", &reader_collectionsPrelude_outer_345);
  Object oldself344 = self;
  struct StackFrameObject *oldstackframe344 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe344);
  gc_frame_newslot((Object)stackframe);
  self = obj344;
  Object *oldselfslot344 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter344 = (*(struct UserObject *)self).data[0], lowerouter344 = thisouter344;
  if (inheritingObject344) {
    struct UserObject *inho344 = (struct UserObject *)inheritingObject344;
    while (inho344->super != GraceDefaultObject) inho344 = (struct UserObject *)inho344->super;
    inho344->super = obj344;
    self = inheritingObject344;
    *selfslot = self;
    lowerouter344 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter344;
  }
if (objclass344 == NULL) {
  Method *reader346 = addmethodrealflags(obj344, "mods",&reader_collectionsPrelude_mods_346, 0);
  Method *writer346 = addmethodrealflags(obj344, "mods:=",&writer_collectionsPrelude_mods_346, MFLAG_CONFIDENTIAL);
  reader346->definitionModule = modulename;
  writer346->definitionModule = modulename;
  reader346->definitionLine = 481;
  writer346->definitionLine = 481;
}
obj344->flags |= OFLAG_MUTABLE;
adddatum2(obj344, alloc_Undefined(), 1);
if (objclass344 == NULL) {
  Method *reader347 = addmethodrealflags(obj344, "size",&reader_collectionsPrelude_size_347, MFLAG_DEF);
  reader347->definitionModule = modulename;
  reader347->definitionLine = 482;
}
adddatum2(obj344, alloc_Undefined(), 2);
if (objclass344 == NULL) {
  Method *reader348 = addmethodrealflags(obj344, "inner",&reader_collectionsPrelude_inner_348, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader348->definitionModule = modulename;
  reader348->definitionLine = 483;
}
adddatum2(obj344, alloc_Undefined(), 3);
// method boundsCheck
  block_savedest(obj344);
  Object closure349 = createclosure(1, "boundsCheck");
  setclosureframe(closure349, stackframe);
  addtoclosure(closure349, var_BoundsError);
  struct UserObject *uo349 = (struct UserObject*)obj344;
  uo349->data[4] = (Object)closure349;
  Method *meth_meth_collectionsPrelude_boundsCheck349 = addmethod2pos(obj344, "boundsCheck", &meth_collectionsPrelude_boundsCheck349, 4);
  int argcv_meth_collectionsPrelude_boundsCheck349[] = {1};
  meth_meth_collectionsPrelude_boundsCheck349->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_boundsCheck349);
  meth_meth_collectionsPrelude_boundsCheck349->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_boundsCheck349->definitionModule = modulename;
  meth_meth_collectionsPrelude_boundsCheck349->definitionLine = 485;
// method at
  struct UserObject *uo386 = (struct UserObject*)obj344;
  uo386->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at386 = addmethod2pos(obj344, "at", &meth_collectionsPrelude_at386, 5);
  int argcv_meth_collectionsPrelude_at386[] = {1};
  meth_meth_collectionsPrelude_at386->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at386);
  meth_meth_collectionsPrelude_at386->definitionModule = modulename;
  meth_meth_collectionsPrelude_at386->definitionLine = 492;
// method []
  struct UserObject *uo397 = (struct UserObject*)obj344;
  uo397->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude__91__93_397 = addmethod2pos(obj344, "[]", &meth_collectionsPrelude__91__93_397, 6);
  int argcv_meth_collectionsPrelude__91__93_397[] = {1};
  meth_meth_collectionsPrelude__91__93_397->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__91__93_397);
  meth_meth_collectionsPrelude__91__93_397->definitionModule = modulename;
  meth_meth_collectionsPrelude__91__93_397->definitionLine = 496;
// method keys
  struct UserObject *uo408 = (struct UserObject*)obj344;
  uo408->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keys408 = addmethod2pos(obj344, "keys", &meth_collectionsPrelude_keys408, 7);
  int argcv_meth_collectionsPrelude_keys408[] = {0};
  meth_meth_collectionsPrelude_keys408->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys408);
  meth_meth_collectionsPrelude_keys408->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys408->definitionLine = 500;
// method values
  struct UserObject *uo420 = (struct UserObject*)obj344;
  uo420->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values420 = addmethod2pos(obj344, "values", &meth_collectionsPrelude_values420, 8);
  int argcv_meth_collectionsPrelude_values420[] = {0};
  meth_meth_collectionsPrelude_values420->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values420);
  meth_meth_collectionsPrelude_values420->definitionModule = modulename;
  meth_meth_collectionsPrelude_values420->definitionLine = 503;
// method keysAndValuesDo
  struct UserObject *uo421 = (struct UserObject*)obj344;
  uo421->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo421 = addmethod2pos(obj344, "keysAndValuesDo", &meth_collectionsPrelude_keysAndValuesDo421, 9);
  int argcv_meth_collectionsPrelude_keysAndValuesDo421[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo421->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo421);
  meth_meth_collectionsPrelude_keysAndValuesDo421->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo421->definitionLine = 506;
// method reversed
  block_savedest(obj344);
  Object closure451 = createclosure(1, "reversed");
  setclosureframe(closure451, stackframe);
  addtoclosure(closure451, var__prelude);
  struct UserObject *uo451 = (struct UserObject*)obj344;
  uo451->data[10] = (Object)closure451;
  Method *meth_meth_collectionsPrelude_reversed451 = addmethod2pos(obj344, "reversed", &meth_collectionsPrelude_reversed451, 10);
  int argcv_meth_collectionsPrelude_reversed451[] = {0};
  meth_meth_collectionsPrelude_reversed451->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reversed451);
  meth_meth_collectionsPrelude_reversed451->definitionModule = modulename;
  meth_meth_collectionsPrelude_reversed451->definitionLine = 513;
// method ++
  struct UserObject *uo482 = (struct UserObject*)obj344;
  uo482->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43_482 = addmethod2pos(obj344, "++", &meth_collectionsPrelude__43__43_482, 11);
  int argcv_meth_collectionsPrelude__43__43_482[] = {1};
  meth_meth_collectionsPrelude__43__43_482->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43_482);
  meth_meth_collectionsPrelude__43__43_482->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43_482->definitionLine = 522;
// method asString
  struct UserObject *uo491 = (struct UserObject*)obj344;
  uo491->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString491 = addmethod2pos(obj344, "asString", &meth_collectionsPrelude_asString491, 12);
  int argcv_meth_collectionsPrelude_asString491[] = {0};
  meth_meth_collectionsPrelude_asString491->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString491);
  meth_meth_collectionsPrelude_asString491->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString491->definitionLine = 525;
// method contains
  struct UserObject *uo537 = (struct UserObject*)obj344;
  uo537->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_contains537 = addmethod2pos(obj344, "contains", &meth_collectionsPrelude_contains537, 13);
  int argcv_meth_collectionsPrelude_contains537[] = {1};
  meth_meth_collectionsPrelude_contains537->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains537);
  meth_meth_collectionsPrelude_contains537->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains537->definitionLine = 533;
// method do
  struct UserObject *uo549 = (struct UserObject*)obj344;
  uo549->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do549 = addmethod2pos(obj344, "do", &meth_collectionsPrelude_do549, 14);
  int argcv_meth_collectionsPrelude_do549[] = {1};
  meth_meth_collectionsPrelude_do549->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do549);
  meth_meth_collectionsPrelude_do549->definitionModule = modulename;
  meth_meth_collectionsPrelude_do549->definitionLine = 537;
// method ==
  block_savedest(obj344);
  Object closure575 = createclosure(1, "==");
  setclosureframe(closure575, stackframe);
  addtoclosure(closure575, var_Collection);
  struct UserObject *uo575 = (struct UserObject*)obj344;
  uo575->data[15] = (Object)closure575;
  Method *meth_meth_collectionsPrelude__61__61_575 = addmethod2pos(obj344, "==", &meth_collectionsPrelude__61__61_575, 15);
  int argcv_meth_collectionsPrelude__61__61_575[] = {1};
  meth_meth_collectionsPrelude__61__61_575->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61_575);
  meth_meth_collectionsPrelude__61__61_575->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61_575->definitionLine = 544;
// method iterator
  block_savedest(obj344);
  Object closure628 = createclosure(3, "iterator");
  setclosureframe(closure628, stackframe);
  addtoclosure(closure628, var_sz);
  addtoclosure(closure628, var_ConcurrentModification);
  addtoclosure(closure628, var_Exhausted);
  struct UserObject *uo628 = (struct UserObject*)obj344;
  uo628->data[16] = (Object)closure628;
  Method *meth_meth_collectionsPrelude_iterator628 = addmethod2pos(obj344, "iterator", &meth_collectionsPrelude_iterator628, 16);
  int argcv_meth_collectionsPrelude_iterator628[] = {0};
  meth_meth_collectionsPrelude_iterator628->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator628);
  meth_meth_collectionsPrelude_iterator628->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator628->definitionLine = 561;
  block_savedest(obj344);
  Object closure722 = createclosure(3, "iterator()object");
  setclosureframe(closure722, stackframe);
  addtoclosure(closure722, var_sz);
  addtoclosure(closure722, var_ConcurrentModification);
  addtoclosure(closure722, var_Exhausted);
  Method *meth_meth_collectionsPrelude_iterator628_object = addmethod2pos(obj344, "iterator()object", &meth_collectionsPrelude_iterator628_object, 16);
  meth_meth_collectionsPrelude_iterator628_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator628_object->definitionLine = 561;
// method sorted
  struct UserObject *uo723 = (struct UserObject*)obj344;
  uo723->data[17] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted723 = addmethod2pos(obj344, "sorted", &meth_collectionsPrelude_sorted723, 17);
  int argcv_meth_collectionsPrelude_sorted723[] = {0};
  meth_meth_collectionsPrelude_sorted723->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted723);
  meth_meth_collectionsPrelude_sorted723->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted723->definitionLine = 577;
// method sortedBy
  struct UserObject *uo746 = (struct UserObject*)obj344;
  uo746->data[18] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy746 = addmethod2pos(obj344, "sortedBy", &meth_collectionsPrelude_sortedBy746, 18);
  int argcv_meth_collectionsPrelude_sortedBy746[] = {1};
  meth_meth_collectionsPrelude_sortedBy746->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy746);
  meth_meth_collectionsPrelude_sortedBy746->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy746->definitionLine = 584;
  sourceObject = obj344;
// Begin line 480
  setline(480);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe753 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indexable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call754 = callmethod(*var_indexable, "trait()object",
    2, partcv, params);
  gc_frame_end(callframe753);
// compiled call node returning call754 (depth = 2)
  struct UserObject *obj344_uo = (struct UserObject *)obj344;
  obj344_uo->super = call754;
  sourceObject = obj344;
// Begin line 481
  setline(481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num755 = alloc_Float64(0);
// compiled num node returning num755 (depth = 2)
  adddatum2(obj344, num755, 1);
  sourceObject = obj344;
// Begin line 482
  setline(482);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_sz (depth = 2)
  adddatum2(obj344, *var_sz, 2);
  sourceObject = obj344;
// Begin line 483
  setline(483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_pArray (depth = 2)
  adddatum2(obj344, *var_pArray, 3);
  sourceObject = obj344;
  sourceObject = obj344;
  sourceObject = obj344;
  sourceObject = obj344;
  sourceObject = obj344;
  sourceObject = obj344;
  sourceObject = obj344;
  sourceObject = obj344;
  sourceObject = obj344;
  sourceObject = obj344;
  sourceObject = obj344;
  sourceObject = obj344;
  sourceObject = obj344;
  sourceObject = obj344;
  sourceObject = obj344;
  objclass344 = obj344->class;
  objclass344->definitionModule = modulename;
  objclass344->definitionLine = 479;
  (*(struct UserObject *)self).data[0] = lowerouter344;
  self = oldself344;
  selfslot = oldselfslot344;
  stackframe = oldstackframe344;
  gc_frame_end(frame);
  return obj344;
}
Object meth_collectionsPrelude_fromPrimitiveArray343_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "fromPrimitiveArray()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method fromPrimitiveArray()object");
  Object params[1];
  int partcv[2];
  Object *var_BoundsError = getfromclosure(closure, 0);
  Object *var__prelude = getfromclosure(closure, 1);
  Object *var_Collection = getfromclosure(closure, 2);
  Object *var_ConcurrentModification = getfromclosure(closure, 3);
  Object *var_Exhausted = getfromclosure(closure, 4);
  Object *var_indexable = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for fromPrimitiveArray (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_pArray = &(stackframe->slots[0]);
  *var_pArray = args[curarg];
  curarg++;
  Object *var_sz = &(stackframe->slots[1]);
  *var_sz = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for fromPrimitiveArray");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject344 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj344 = alloc_userobj2(21,21, objclass344);
  gc_frame_newslot(obj344);
if (objclass344 == NULL) {
  glfree(obj344->class->name);
  obj344->class->name = "obj227.fromPrimitiveArray";
}
// OBJECT OUTER DEC outer
  adddatum2(obj344, self, 0);
  addmethodreal(obj344,"outer", &reader_collectionsPrelude_outer_345);
  Object oldself344 = self;
  struct StackFrameObject *oldstackframe344 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe344);
  gc_frame_newslot((Object)stackframe);
  self = obj344;
  Object *oldselfslot344 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter344 = (*(struct UserObject *)self).data[0], lowerouter344 = thisouter344;
  if (inheritingObject344) {
    struct UserObject *inho344 = (struct UserObject *)inheritingObject344;
    while (inho344->super != GraceDefaultObject) inho344 = (struct UserObject *)inho344->super;
    inho344->super = obj344;
    self = inheritingObject344;
    *selfslot = self;
    lowerouter344 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter344;
  }
if (objclass344 == NULL) {
  Method *reader346 = addmethodrealflags(obj344, "mods",&reader_collectionsPrelude_mods_346, 0);
  Method *writer346 = addmethodrealflags(obj344, "mods:=",&writer_collectionsPrelude_mods_346, MFLAG_CONFIDENTIAL);
  reader346->definitionModule = modulename;
  writer346->definitionModule = modulename;
  reader346->definitionLine = 481;
  writer346->definitionLine = 481;
}
obj344->flags |= OFLAG_MUTABLE;
adddatum2(obj344, alloc_Undefined(), 1);
if (objclass344 == NULL) {
  Method *reader347 = addmethodrealflags(obj344, "size",&reader_collectionsPrelude_size_347, MFLAG_DEF);
  reader347->definitionModule = modulename;
  reader347->definitionLine = 482;
}
adddatum2(obj344, alloc_Undefined(), 2);
if (objclass344 == NULL) {
  Method *reader348 = addmethodrealflags(obj344, "inner",&reader_collectionsPrelude_inner_348, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader348->definitionModule = modulename;
  reader348->definitionLine = 483;
}
adddatum2(obj344, alloc_Undefined(), 3);
// method boundsCheck
  block_savedest(obj344);
  Object closure349 = createclosure(1, "boundsCheck");
  setclosureframe(closure349, stackframe);
  addtoclosure(closure349, var_BoundsError);
  struct UserObject *uo349 = (struct UserObject*)obj344;
  uo349->data[4] = (Object)closure349;
  Method *meth_meth_collectionsPrelude_boundsCheck349 = addmethod2pos(obj344, "boundsCheck", &meth_collectionsPrelude_boundsCheck349, 4);
  int argcv_meth_collectionsPrelude_boundsCheck349[] = {1};
  meth_meth_collectionsPrelude_boundsCheck349->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_boundsCheck349);
  meth_meth_collectionsPrelude_boundsCheck349->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_boundsCheck349->definitionModule = modulename;
  meth_meth_collectionsPrelude_boundsCheck349->definitionLine = 485;
// method at
  struct UserObject *uo386 = (struct UserObject*)obj344;
  uo386->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at386 = addmethod2pos(obj344, "at", &meth_collectionsPrelude_at386, 5);
  int argcv_meth_collectionsPrelude_at386[] = {1};
  meth_meth_collectionsPrelude_at386->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at386);
  meth_meth_collectionsPrelude_at386->definitionModule = modulename;
  meth_meth_collectionsPrelude_at386->definitionLine = 492;
// method []
  struct UserObject *uo397 = (struct UserObject*)obj344;
  uo397->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude__91__93_397 = addmethod2pos(obj344, "[]", &meth_collectionsPrelude__91__93_397, 6);
  int argcv_meth_collectionsPrelude__91__93_397[] = {1};
  meth_meth_collectionsPrelude__91__93_397->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__91__93_397);
  meth_meth_collectionsPrelude__91__93_397->definitionModule = modulename;
  meth_meth_collectionsPrelude__91__93_397->definitionLine = 496;
// method keys
  struct UserObject *uo408 = (struct UserObject*)obj344;
  uo408->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keys408 = addmethod2pos(obj344, "keys", &meth_collectionsPrelude_keys408, 7);
  int argcv_meth_collectionsPrelude_keys408[] = {0};
  meth_meth_collectionsPrelude_keys408->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys408);
  meth_meth_collectionsPrelude_keys408->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys408->definitionLine = 500;
// method values
  struct UserObject *uo420 = (struct UserObject*)obj344;
  uo420->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values420 = addmethod2pos(obj344, "values", &meth_collectionsPrelude_values420, 8);
  int argcv_meth_collectionsPrelude_values420[] = {0};
  meth_meth_collectionsPrelude_values420->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values420);
  meth_meth_collectionsPrelude_values420->definitionModule = modulename;
  meth_meth_collectionsPrelude_values420->definitionLine = 503;
// method keysAndValuesDo
  struct UserObject *uo421 = (struct UserObject*)obj344;
  uo421->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo421 = addmethod2pos(obj344, "keysAndValuesDo", &meth_collectionsPrelude_keysAndValuesDo421, 9);
  int argcv_meth_collectionsPrelude_keysAndValuesDo421[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo421->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo421);
  meth_meth_collectionsPrelude_keysAndValuesDo421->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo421->definitionLine = 506;
// method reversed
  block_savedest(obj344);
  Object closure451 = createclosure(1, "reversed");
  setclosureframe(closure451, stackframe);
  addtoclosure(closure451, var__prelude);
  struct UserObject *uo451 = (struct UserObject*)obj344;
  uo451->data[10] = (Object)closure451;
  Method *meth_meth_collectionsPrelude_reversed451 = addmethod2pos(obj344, "reversed", &meth_collectionsPrelude_reversed451, 10);
  int argcv_meth_collectionsPrelude_reversed451[] = {0};
  meth_meth_collectionsPrelude_reversed451->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reversed451);
  meth_meth_collectionsPrelude_reversed451->definitionModule = modulename;
  meth_meth_collectionsPrelude_reversed451->definitionLine = 513;
// method ++
  struct UserObject *uo482 = (struct UserObject*)obj344;
  uo482->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43_482 = addmethod2pos(obj344, "++", &meth_collectionsPrelude__43__43_482, 11);
  int argcv_meth_collectionsPrelude__43__43_482[] = {1};
  meth_meth_collectionsPrelude__43__43_482->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43_482);
  meth_meth_collectionsPrelude__43__43_482->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43_482->definitionLine = 522;
// method asString
  struct UserObject *uo491 = (struct UserObject*)obj344;
  uo491->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString491 = addmethod2pos(obj344, "asString", &meth_collectionsPrelude_asString491, 12);
  int argcv_meth_collectionsPrelude_asString491[] = {0};
  meth_meth_collectionsPrelude_asString491->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString491);
  meth_meth_collectionsPrelude_asString491->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString491->definitionLine = 525;
// method contains
  struct UserObject *uo537 = (struct UserObject*)obj344;
  uo537->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_contains537 = addmethod2pos(obj344, "contains", &meth_collectionsPrelude_contains537, 13);
  int argcv_meth_collectionsPrelude_contains537[] = {1};
  meth_meth_collectionsPrelude_contains537->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains537);
  meth_meth_collectionsPrelude_contains537->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains537->definitionLine = 533;
// method do
  struct UserObject *uo549 = (struct UserObject*)obj344;
  uo549->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do549 = addmethod2pos(obj344, "do", &meth_collectionsPrelude_do549, 14);
  int argcv_meth_collectionsPrelude_do549[] = {1};
  meth_meth_collectionsPrelude_do549->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do549);
  meth_meth_collectionsPrelude_do549->definitionModule = modulename;
  meth_meth_collectionsPrelude_do549->definitionLine = 537;
// method ==
  block_savedest(obj344);
  Object closure575 = createclosure(1, "==");
  setclosureframe(closure575, stackframe);
  addtoclosure(closure575, var_Collection);
  struct UserObject *uo575 = (struct UserObject*)obj344;
  uo575->data[15] = (Object)closure575;
  Method *meth_meth_collectionsPrelude__61__61_575 = addmethod2pos(obj344, "==", &meth_collectionsPrelude__61__61_575, 15);
  int argcv_meth_collectionsPrelude__61__61_575[] = {1};
  meth_meth_collectionsPrelude__61__61_575->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61_575);
  meth_meth_collectionsPrelude__61__61_575->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61_575->definitionLine = 544;
// method iterator
  block_savedest(obj344);
  Object closure628 = createclosure(3, "iterator");
  setclosureframe(closure628, stackframe);
  addtoclosure(closure628, var_sz);
  addtoclosure(closure628, var_ConcurrentModification);
  addtoclosure(closure628, var_Exhausted);
  struct UserObject *uo628 = (struct UserObject*)obj344;
  uo628->data[16] = (Object)closure628;
  Method *meth_meth_collectionsPrelude_iterator628 = addmethod2pos(obj344, "iterator", &meth_collectionsPrelude_iterator628, 16);
  int argcv_meth_collectionsPrelude_iterator628[] = {0};
  meth_meth_collectionsPrelude_iterator628->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator628);
  meth_meth_collectionsPrelude_iterator628->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator628->definitionLine = 561;
  block_savedest(obj344);
  Object closure722 = createclosure(3, "iterator()object");
  setclosureframe(closure722, stackframe);
  addtoclosure(closure722, var_sz);
  addtoclosure(closure722, var_ConcurrentModification);
  addtoclosure(closure722, var_Exhausted);
  Method *meth_meth_collectionsPrelude_iterator628_object = addmethod2pos(obj344, "iterator()object", &meth_collectionsPrelude_iterator628_object, 16);
  meth_meth_collectionsPrelude_iterator628_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator628_object->definitionLine = 561;
// method sorted
  struct UserObject *uo723 = (struct UserObject*)obj344;
  uo723->data[17] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted723 = addmethod2pos(obj344, "sorted", &meth_collectionsPrelude_sorted723, 17);
  int argcv_meth_collectionsPrelude_sorted723[] = {0};
  meth_meth_collectionsPrelude_sorted723->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted723);
  meth_meth_collectionsPrelude_sorted723->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted723->definitionLine = 577;
// method sortedBy
  struct UserObject *uo746 = (struct UserObject*)obj344;
  uo746->data[18] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy746 = addmethod2pos(obj344, "sortedBy", &meth_collectionsPrelude_sortedBy746, 18);
  int argcv_meth_collectionsPrelude_sortedBy746[] = {1};
  meth_meth_collectionsPrelude_sortedBy746->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy746);
  meth_meth_collectionsPrelude_sortedBy746->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy746->definitionLine = 584;
  sourceObject = obj344;
// Begin line 480
  setline(480);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe753 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indexable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call754 = callmethod(*var_indexable, "trait()object",
    2, partcv, params);
  gc_frame_end(callframe753);
// compiled call node returning call754 (depth = 2)
  struct UserObject *obj344_uo = (struct UserObject *)obj344;
  obj344_uo->super = call754;
  sourceObject = obj344;
// Begin line 481
  setline(481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num755 = alloc_Float64(0);
// compiled num node returning num755 (depth = 2)
  adddatum2(obj344, num755, 1);
  sourceObject = obj344;
// Begin line 482
  setline(482);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_sz (depth = 2)
  adddatum2(obj344, *var_sz, 2);
  sourceObject = obj344;
// Begin line 483
  setline(483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_pArray (depth = 2)
  adddatum2(obj344, *var_pArray, 3);
  sourceObject = obj344;
  sourceObject = obj344;
  sourceObject = obj344;
  sourceObject = obj344;
  sourceObject = obj344;
  sourceObject = obj344;
  sourceObject = obj344;
  sourceObject = obj344;
  sourceObject = obj344;
  sourceObject = obj344;
  sourceObject = obj344;
  sourceObject = obj344;
  sourceObject = obj344;
  sourceObject = obj344;
  sourceObject = obj344;
  objclass344 = obj344->class;
  objclass344->definitionModule = modulename;
  objclass344->definitionLine = 479;
  (*(struct UserObject *)self).data[0] = lowerouter344;
  self = oldself344;
  selfslot = oldselfslot344;
  stackframe = oldstackframe344;
  gc_frame_end(frame);
  return obj344;
}
Object meth_collectionsPrelude_sequence226(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "sequence");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_SizeUnknown = getfromclosure(closure, 0);
  Object *var__prelude = getfromclosure(closure, 1);
  Object *var_BoundsError = getfromclosure(closure, 2);
  Object *var_Collection = getfromclosure(closure, 3);
  Object *var_ConcurrentModification = getfromclosure(closure, 4);
  Object *var_Exhausted = getfromclosure(closure, 5);
  Object *var_indexable = getfromclosure(closure, 6);
  Object *var_collectionFactory = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for sequence (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for sequence");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start generics
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      gracedie("insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End generics
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject227 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj227 = alloc_userobj2(4,5, objclass227);
  gc_frame_newslot(obj227);
if (objclass227 == NULL) {
  glfree(obj227->class->name);
  obj227->class->name = "self.sequence";
}
// OBJECT OUTER DEC outer
  adddatum2(obj227, self, 0);
  addmethodreal(obj227,"outer", &reader_collectionsPrelude_outer_228);
  Object oldself227 = self;
  struct StackFrameObject *oldstackframe227 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe227);
  gc_frame_newslot((Object)stackframe);
  self = obj227;
  Object *oldselfslot227 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter227 = (*(struct UserObject *)self).data[0], lowerouter227 = thisouter227;
  if (inheritingObject227) {
    struct UserObject *inho227 = (struct UserObject *)inheritingObject227;
    while (inho227->super != GraceDefaultObject) inho227 = (struct UserObject *)inho227->super;
    inho227->super = obj227;
    self = inheritingObject227;
    *selfslot = self;
    lowerouter227 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter227;
  }
// method withAll
  block_savedest(obj227);
  Object closure229 = createclosure(2, "withAll");
  setclosureframe(closure229, stackframe);
  addtoclosure(closure229, var_SizeUnknown);
  addtoclosure(closure229, var__prelude);
  struct UserObject *uo229 = (struct UserObject*)obj227;
  uo229->data[1] = (Object)closure229;
  Method *meth_meth_collectionsPrelude_withAll229 = addmethod2pos(obj227, "withAll", &meth_collectionsPrelude_withAll229, 1);
  int argcv_meth_collectionsPrelude_withAll229[] = {0};
  meth_meth_collectionsPrelude_withAll229->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_withAll229);
  meth_meth_collectionsPrelude_withAll229->definitionModule = modulename;
  meth_meth_collectionsPrelude_withAll229->definitionLine = 436;
// method fromPrimitiveArray
  block_savedest(obj227);
  Object closure343 = createclosure(6, "fromPrimitiveArray");
  setclosureframe(closure343, stackframe);
  addtoclosure(closure343, var_BoundsError);
  addtoclosure(closure343, var__prelude);
  addtoclosure(closure343, var_Collection);
  addtoclosure(closure343, var_ConcurrentModification);
  addtoclosure(closure343, var_Exhausted);
  addtoclosure(closure343, var_indexable);
  struct UserObject *uo343 = (struct UserObject*)obj227;
  uo343->data[2] = (Object)closure343;
  Method *meth_meth_collectionsPrelude_fromPrimitiveArray343 = addmethod2pos(obj227, "fromPrimitiveArray", &meth_collectionsPrelude_fromPrimitiveArray343, 2);
  int argcv_meth_collectionsPrelude_fromPrimitiveArray343[] = {2};
  meth_meth_collectionsPrelude_fromPrimitiveArray343->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_fromPrimitiveArray343);
  meth_meth_collectionsPrelude_fromPrimitiveArray343->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_fromPrimitiveArray343->definitionModule = modulename;
  meth_meth_collectionsPrelude_fromPrimitiveArray343->definitionLine = 478;
  block_savedest(obj227);
  Object closure756 = createclosure(6, "fromPrimitiveArray()object");
  setclosureframe(closure756, stackframe);
  addtoclosure(closure756, var_BoundsError);
  addtoclosure(closure756, var__prelude);
  addtoclosure(closure756, var_Collection);
  addtoclosure(closure756, var_ConcurrentModification);
  addtoclosure(closure756, var_Exhausted);
  addtoclosure(closure756, var_indexable);
  Method *meth_meth_collectionsPrelude_fromPrimitiveArray343_object = addmethod2pos(obj227, "fromPrimitiveArray()object", &meth_collectionsPrelude_fromPrimitiveArray343_object, 2);
  meth_meth_collectionsPrelude_fromPrimitiveArray343_object->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_fromPrimitiveArray343_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_fromPrimitiveArray343_object->definitionLine = 478;
  sourceObject = obj227;
// Begin line 434
  setline(434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe757 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_collectionFactory (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call758 = callmethod(*var_collectionFactory, "trait()object",
    2, partcv, params);
  gc_frame_end(callframe757);
// compiled call node returning call758 (depth = 2)
  struct UserObject *obj227_uo = (struct UserObject *)obj227;
  obj227_uo->super = call758;
  sourceObject = obj227;
  sourceObject = obj227;
  objclass227 = obj227->class;
  objclass227->definitionModule = modulename;
  objclass227->definitionLine = 433;
  (*(struct UserObject *)self).data[0] = lowerouter227;
  self = oldself227;
  selfslot = oldselfslot227;
  stackframe = oldstackframe227;
  gc_frame_end(frame);
  return obj227;
}
Object meth_collectionsPrelude_sequence226_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "sequence()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_SizeUnknown = getfromclosure(closure, 0);
  Object *var__prelude = getfromclosure(closure, 1);
  Object *var_BoundsError = getfromclosure(closure, 2);
  Object *var_Collection = getfromclosure(closure, 3);
  Object *var_ConcurrentModification = getfromclosure(closure, 4);
  Object *var_Exhausted = getfromclosure(closure, 5);
  Object *var_indexable = getfromclosure(closure, 6);
  Object *var_collectionFactory = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for sequence (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for sequence");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start generics
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      gracedie("insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End generics
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject227 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj227 = alloc_userobj2(4,5, objclass227);
  gc_frame_newslot(obj227);
if (objclass227 == NULL) {
  glfree(obj227->class->name);
  obj227->class->name = "self.sequence";
}
// OBJECT OUTER DEC outer
  adddatum2(obj227, self, 0);
  addmethodreal(obj227,"outer", &reader_collectionsPrelude_outer_228);
  Object oldself227 = self;
  struct StackFrameObject *oldstackframe227 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe227);
  gc_frame_newslot((Object)stackframe);
  self = obj227;
  Object *oldselfslot227 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter227 = (*(struct UserObject *)self).data[0], lowerouter227 = thisouter227;
  if (inheritingObject227) {
    struct UserObject *inho227 = (struct UserObject *)inheritingObject227;
    while (inho227->super != GraceDefaultObject) inho227 = (struct UserObject *)inho227->super;
    inho227->super = obj227;
    self = inheritingObject227;
    *selfslot = self;
    lowerouter227 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter227;
  }
// method withAll
  block_savedest(obj227);
  Object closure229 = createclosure(2, "withAll");
  setclosureframe(closure229, stackframe);
  addtoclosure(closure229, var_SizeUnknown);
  addtoclosure(closure229, var__prelude);
  struct UserObject *uo229 = (struct UserObject*)obj227;
  uo229->data[1] = (Object)closure229;
  Method *meth_meth_collectionsPrelude_withAll229 = addmethod2pos(obj227, "withAll", &meth_collectionsPrelude_withAll229, 1);
  int argcv_meth_collectionsPrelude_withAll229[] = {0};
  meth_meth_collectionsPrelude_withAll229->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_withAll229);
  meth_meth_collectionsPrelude_withAll229->definitionModule = modulename;
  meth_meth_collectionsPrelude_withAll229->definitionLine = 436;
// method fromPrimitiveArray
  block_savedest(obj227);
  Object closure343 = createclosure(6, "fromPrimitiveArray");
  setclosureframe(closure343, stackframe);
  addtoclosure(closure343, var_BoundsError);
  addtoclosure(closure343, var__prelude);
  addtoclosure(closure343, var_Collection);
  addtoclosure(closure343, var_ConcurrentModification);
  addtoclosure(closure343, var_Exhausted);
  addtoclosure(closure343, var_indexable);
  struct UserObject *uo343 = (struct UserObject*)obj227;
  uo343->data[2] = (Object)closure343;
  Method *meth_meth_collectionsPrelude_fromPrimitiveArray343 = addmethod2pos(obj227, "fromPrimitiveArray", &meth_collectionsPrelude_fromPrimitiveArray343, 2);
  int argcv_meth_collectionsPrelude_fromPrimitiveArray343[] = {2};
  meth_meth_collectionsPrelude_fromPrimitiveArray343->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_fromPrimitiveArray343);
  meth_meth_collectionsPrelude_fromPrimitiveArray343->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_fromPrimitiveArray343->definitionModule = modulename;
  meth_meth_collectionsPrelude_fromPrimitiveArray343->definitionLine = 478;
  block_savedest(obj227);
  Object closure756 = createclosure(6, "fromPrimitiveArray()object");
  setclosureframe(closure756, stackframe);
  addtoclosure(closure756, var_BoundsError);
  addtoclosure(closure756, var__prelude);
  addtoclosure(closure756, var_Collection);
  addtoclosure(closure756, var_ConcurrentModification);
  addtoclosure(closure756, var_Exhausted);
  addtoclosure(closure756, var_indexable);
  Method *meth_meth_collectionsPrelude_fromPrimitiveArray343_object = addmethod2pos(obj227, "fromPrimitiveArray()object", &meth_collectionsPrelude_fromPrimitiveArray343_object, 2);
  meth_meth_collectionsPrelude_fromPrimitiveArray343_object->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_fromPrimitiveArray343_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_fromPrimitiveArray343_object->definitionLine = 478;
  sourceObject = obj227;
// Begin line 434
  setline(434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe757 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_collectionFactory (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call758 = callmethod(*var_collectionFactory, "trait()object",
    2, partcv, params);
  gc_frame_end(callframe757);
// compiled call node returning call758 (depth = 2)
  struct UserObject *obj227_uo = (struct UserObject *)obj227;
  obj227_uo->super = call758;
  sourceObject = obj227;
  sourceObject = obj227;
  objclass227 = obj227->class;
  objclass227->definitionModule = modulename;
  objclass227->definitionLine = 433;
  (*(struct UserObject *)self).data[0] = lowerouter227;
  self = oldself227;
  selfslot = oldselfslot227;
  stackframe = oldstackframe227;
  gc_frame_end(frame);
  return obj227;
}
Object meth_collectionsPrelude_boundsCheck776(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "boundsCheck");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method boundsCheck");
  Object params[1];
  int partcv[1];
  Object *var_BoundsError = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for boundsCheck (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for boundsCheck");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 608
  setline(608);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
// compiled call node returning done (depth = 5)
// Begin line 614
  setline(614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe779 = gc_frame_new();
// call case 6: other member request
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe781 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call782 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe781);
// compiled call node returning call782 (depth = 10)
// compiled member node returning call782 (depth = 9)
  int op_slot_right_780 = gc_frame_newslot(call782);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_n (depth = 9)
  int op_slot_left_780 = gc_frame_newslot(*var_n);
  params[0] = call782;
  partcv[0] = 1;
  Object opresult784 = callmethod(*var_n, "<=", 1, partcv, params);
// compiled op node returning opresult784 (depth = 8)
  partcv[0] = 0;
  Object call785 = callmethod(opresult784, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe779);
// compiled call node returning call785 (depth = 7)
  int op_slot_right_778 = gc_frame_newslot(call785);
// starting to compile call node (depth = 7)
  int callframe787 = gc_frame_new();
// call case 6: other member request
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num789 = alloc_Float64(1);
// compiled num node returning num789 (depth = 9)
  int op_slot_right_788 = gc_frame_newslot(num789);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_n (depth = 9)
  int op_slot_left_788 = gc_frame_newslot(*var_n);
  params[0] = num789;
  partcv[0] = 1;
  Object opresult791 = callmethod(*var_n, ">=", 1, partcv, params);
// compiled op node returning opresult791 (depth = 8)
  partcv[0] = 0;
  Object call792 = callmethod(opresult791, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe787);
// compiled call node returning call792 (depth = 7)
  int op_slot_left_778 = gc_frame_newslot(call792);
  params[0] = call785;
  partcv[0] = 1;
  Object opresult793 = callmethod(call792, "||", 1, partcv, params);
// compiled op node returning opresult793 (depth = 6)
  Object if777 = done;
  if (istrue(opresult793)) {
// Begin line 615
  setline(615);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe794 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit796 == NULL) {
    strlit796 = alloc_String("");
    gc_root(strlit796);
  }
// compiled string node returning strlit796 (depth = 8)
  int op_slot_right_795 = gc_frame_newslot(strlit796);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe799 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call800 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe799);
// compiled call node returning call800 (depth = 10)
// compiled member node returning call800 (depth = 9)
  int op_slot_right_798 = gc_frame_newslot(call800);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit803 == NULL) {
    strlit803 = alloc_String(" out of bounds 1..");
    gc_root(strlit803);
  }
// compiled string node returning strlit803 (depth = 10)
  int op_slot_right_802 = gc_frame_newslot(strlit803);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_n (depth = 11)
  int op_slot_right_805 = gc_frame_newslot(*var_n);
// starting to compile string node (depth = 11)
  if (strlit807 == NULL) {
    strlit807 = alloc_String("index ");
    gc_root(strlit807);
  }
// compiled string node returning strlit807 (depth = 11)
  int op_slot_left_805 = gc_frame_newslot(strlit807);
  params[0] = *var_n;
  partcv[0] = 1;
  Object opresult808 = callmethod(strlit807, "++", 1, partcv, params);
// compiled op node returning opresult808 (depth = 10)
  int op_slot_left_802 = gc_frame_newslot(opresult808);
  params[0] = strlit803;
  partcv[0] = 1;
  Object opresult809 = callmethod(opresult808, "++", 1, partcv, params);
// compiled op node returning opresult809 (depth = 9)
  int op_slot_left_798 = gc_frame_newslot(opresult809);
  params[0] = call800;
  partcv[0] = 1;
  Object opresult810 = callmethod(opresult809, "++", 1, partcv, params);
// compiled op node returning opresult810 (depth = 8)
  int op_slot_left_795 = gc_frame_newslot(opresult810);
  params[0] = strlit796;
  partcv[0] = 1;
  Object opresult811 = callmethod(opresult810, "++", 1, partcv, params);
// compiled op node returning opresult811 (depth = 7)
  gc_frame_newslot(opresult811);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_BoundsError (depth = 7)
  params[0] = opresult811;
  partcv[0] = 1;
  Object call812 = callmethod(*var_BoundsError, "raise",
    1, partcv, params);
  gc_frame_end(callframe794);
// compiled call node returning call812 (depth = 6)
    gc_frame_newslot(call812);
    if777 = call812;
  } else {
  }
// compiled if node returning if777 (depth = 5)
  gc_frame_end(frame);
  return if777;
}
Object meth_collectionsPrelude_size813(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "size");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for size (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for size");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 621
  setline(621);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
// compiled call node returning done (depth = 5)
// Begin line 622
  setline(622);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe814 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call815 = callmethodflags(self, "sz", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe814);
// compiled call node returning call815 (depth = 6)
// compiled member node returning call815 (depth = 5)
  gc_frame_end(frame);
  return call815;
}
Object meth_collectionsPrelude_at816(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "at");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method at");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for at (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for at");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 626
  setline(626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
// compiled call node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude__91__93_817(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "[]");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method []");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for [] (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for [");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 636
  setline(636);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
// compiled call node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_at_40__41_put818(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "at()put");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method at()put");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method at()put");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for at()put (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for at");
  Object *var_x = &(stackframe->slots[1]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for put");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 646
  setline(646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 622
  setline(622);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe819 = gc_frame_new();
// Begin line 646
  setline(646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num821 = alloc_Float64(1);
// compiled num node returning num821 (depth = 8)
  int op_slot_right_820 = gc_frame_newslot(num821);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe823 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call824 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe823);
// compiled call node returning call824 (depth = 9)
// compiled member node returning call824 (depth = 8)
  int op_slot_left_820 = gc_frame_newslot(call824);
  params[0] = num821;
  partcv[0] = 1;
  Object sum825 = callmethod(call824, "+", 1, partcv, params);
// compiled op node returning sum825 (depth = 7)
  gc_frame_newslot(sum825);
// call case 4: self request
  params[0] = sum825;
  partcv[0] = 1;
  Object call826 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe819);
// compiled call node returning call826 (depth = 6)
// compiled bind node returning done (depth = 5)
// Begin line 647
  setline(647);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
// compiled call node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude__91__93__58__61_827(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "[]:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method []:=");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for []:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  Object *var_x = &(stackframe->slots[1]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for [:=");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 658
  setline(658);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 646
  setline(646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe828 = gc_frame_new();
// Begin line 658
  setline(658);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num830 = alloc_Float64(1);
// compiled num node returning num830 (depth = 8)
  int op_slot_right_829 = gc_frame_newslot(num830);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe832 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call833 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe832);
// compiled call node returning call833 (depth = 9)
// compiled member node returning call833 (depth = 8)
  int op_slot_left_829 = gc_frame_newslot(call833);
  params[0] = num830;
  partcv[0] = 1;
  Object sum834 = callmethod(call833, "+", 1, partcv, params);
// compiled op node returning sum834 (depth = 7)
  gc_frame_newslot(sum834);
// call case 4: self request
  params[0] = sum834;
  partcv[0] = 1;
  Object call835 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe828);
// compiled call node returning call835 (depth = 6)
// compiled bind node returning done (depth = 5)
// Begin line 659
  setline(659);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
// compiled call node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_add836(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "add");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for add (probably reflection error): got %i lists, expected 1.", nparts);
  Object var_init_x = alloc_BuiltinList();
  for (i = 0; i < argcv[0]; i++) {
    callmethod(var_init_x, "push", 1, pushcv, &args[curarg]);
    curarg++;
  }
  Object *var_x = &(stackframe->slots[0]);
  *var_x = var_init_x;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 670
  setline(670);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 658
  setline(658);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe837 = gc_frame_new();
// Begin line 670
  setline(670);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num839 = alloc_Float64(1);
// compiled num node returning num839 (depth = 8)
  int op_slot_right_838 = gc_frame_newslot(num839);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe841 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call842 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe841);
// compiled call node returning call842 (depth = 9)
// compiled member node returning call842 (depth = 8)
  int op_slot_left_838 = gc_frame_newslot(call842);
  params[0] = num839;
  partcv[0] = 1;
  Object sum843 = callmethod(call842, "+", 1, partcv, params);
// compiled op node returning sum843 (depth = 7)
  gc_frame_newslot(sum843);
// call case 4: self request
  params[0] = sum843;
  partcv[0] = 1;
  Object call844 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe837);
// compiled call node returning call844 (depth = 6)
// compiled bind node returning done (depth = 5)
// Begin line 671
  setline(671);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num847 = alloc_Float64(1);
// compiled num node returning num847 (depth = 7)
  int op_slot_right_846 = gc_frame_newslot(num847);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe849 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_x (depth = 9)
  partcv[0] = 0;
  Object call850 = callmethod(*var_x, "size",
    1, partcv, params);
  gc_frame_end(callframe849);
// compiled call node returning call850 (depth = 8)
// compiled member node returning call850 (depth = 7)
  int op_slot_left_846 = gc_frame_newslot(call850);
  params[0] = num847;
  partcv[0] = 1;
  Object opresult851 = callmethod(call850, "==", 1, partcv, params);
// compiled op node returning opresult851 (depth = 6)
  Object if845 = done;
  if (istrue(opresult851)) {
// Begin line 672
  setline(672);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
// compiled call node returning done (depth = 6)
    gc_frame_newslot(done);
    if845 = done;
  } else {
  }
// compiled if node returning if845 (depth = 5)
// Begin line 676
  setline(676);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe852 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_x (depth = 6)
  gc_frame_newslot(*var_x);
// call case 4: self request
  params[0] = *var_x;
  partcv[0] = 1;
  Object call853 = callmethodflags(self, "addAll", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe852);
// compiled call node returning call853 (depth = 5)
  gc_frame_end(frame);
  return call853;
}
Object meth_collectionsPrelude_push854(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "push");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method push");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for push (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for push");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 680
  setline(680);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 671
  setline(671);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe855 = gc_frame_new();
// Begin line 680
  setline(680);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num857 = alloc_Float64(1);
// compiled num node returning num857 (depth = 8)
  int op_slot_right_856 = gc_frame_newslot(num857);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe859 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call860 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe859);
// compiled call node returning call860 (depth = 9)
// compiled member node returning call860 (depth = 8)
  int op_slot_left_856 = gc_frame_newslot(call860);
  params[0] = num857;
  partcv[0] = 1;
  Object sum861 = callmethod(call860, "+", 1, partcv, params);
// compiled op node returning sum861 (depth = 7)
  gc_frame_newslot(sum861);
// call case 4: self request
  params[0] = sum861;
  partcv[0] = 1;
  Object call862 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe855);
// compiled call node returning call862 (depth = 6)
// compiled bind node returning done (depth = 5)
// Begin line 681
  setline(681);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
// compiled call node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_removeLast863(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "removeLast");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for removeLast (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for removeLast");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 686
  setline(686);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 680
  setline(680);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe864 = gc_frame_new();
// Begin line 686
  setline(686);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num866 = alloc_Float64(1);
// compiled num node returning num866 (depth = 8)
  int op_slot_right_865 = gc_frame_newslot(num866);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe868 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call869 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe868);
// compiled call node returning call869 (depth = 9)
// compiled member node returning call869 (depth = 8)
  int op_slot_left_865 = gc_frame_newslot(call869);
  params[0] = num866;
  partcv[0] = 1;
  Object sum870 = callmethod(call869, "+", 1, partcv, params);
// compiled op node returning sum870 (depth = 7)
  gc_frame_newslot(sum870);
// call case 4: self request
  params[0] = sum870;
  partcv[0] = 1;
  Object call871 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe864);
// compiled call node returning call871 (depth = 6)
// compiled bind node returning done (depth = 5)
// Begin line 687
  setline(687);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
// compiled call node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude__apply885(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ix = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num887 = alloc_Float64(0);
// compiled num node returning num887 (depth = 8)
  int op_slot_right_886 = gc_frame_newslot(num887);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ix (depth = 8)
  int op_slot_left_886 = gc_frame_newslot(*var_ix);
  params[0] = num887;
  partcv[0] = 1;
  Object opresult889 = callmethod(*var_ix, ">", 1, partcv, params);
// compiled op node returning opresult889 (depth = 7)
  gc_frame_end(frame);
  return opresult889;
}
Object meth_collectionsPrelude__apply892(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ix = getfromclosure(closure, 0);
  Object *var_l = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_each = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "each");
// Begin line 699
  setline(699);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe893 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ix (depth = 9)
  gc_frame_newslot(*var_ix);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_l (depth = 9)
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call894 = callmethod(*var_l, "at",
    1, partcv, params);
  gc_frame_end(callframe893);
// compiled call node returning call894 (depth = 8)
  *var_each = call894;
  if (call894 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 700
  setline(700);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num896 = alloc_Float64(1);
// compiled num node returning num896 (depth = 9)
  int op_slot_right_895 = gc_frame_newslot(num896);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ix (depth = 9)
  int op_slot_left_895 = gc_frame_newslot(*var_ix);
  params[0] = num896;
  partcv[0] = 1;
  Object diff898 = callmethod(*var_ix, "-", 1, partcv, params);
// compiled op node returning diff898 (depth = 8)
  *var_ix = diff898;
  if (diff898 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 701
  setline(701);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
// compiled call node returning done (depth = 7)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_addAllFirst872(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addAllFirst");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method addAllFirst");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for addAllFirst (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for addAllFirst");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ix = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "ix");
// Begin line 696
  setline(696);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 686
  setline(686);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe873 = gc_frame_new();
// Begin line 696
  setline(696);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num875 = alloc_Float64(1);
// compiled num node returning num875 (depth = 8)
  int op_slot_right_874 = gc_frame_newslot(num875);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe877 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call878 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe877);
// compiled call node returning call878 (depth = 9)
// compiled member node returning call878 (depth = 8)
  int op_slot_left_874 = gc_frame_newslot(call878);
  params[0] = num875;
  partcv[0] = 1;
  Object sum879 = callmethod(call878, "+", 1, partcv, params);
// compiled op node returning sum879 (depth = 7)
  gc_frame_newslot(sum879);
// call case 4: self request
  params[0] = sum879;
  partcv[0] = 1;
  Object call880 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe873);
// compiled call node returning call880 (depth = 6)
// compiled bind node returning done (depth = 5)
// Begin line 697
  setline(697);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe881 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_l (depth = 8)
  partcv[0] = 0;
  Object call882 = callmethod(*var_l, "size",
    1, partcv, params);
  gc_frame_end(callframe881);
// compiled call node returning call882 (depth = 7)
// compiled member node returning call882 (depth = 6)
  *var_ix = call882;
  if (call882 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 698
  setline(698);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe883 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block884 = alloc_Block(NULL, NULL, "collectionsPrelude", 698);
  gc_frame_newslot(block884);
// method _apply
  block_savedest(block884);
  Object closure885 = createclosure(2, "_apply");
  setclosureframe(closure885, stackframe);
  addtoclosure(closure885, var_ix);
  addtoclosure(closure885, selfslot);
  struct UserObject *uo885 = (struct UserObject*)block884;
  uo885->data[0] = (Object)closure885;
  Method *meth_meth_collectionsPrelude__apply885 = addmethod2pos(block884, "_apply", &meth_collectionsPrelude__apply885, 0);
  int argcv_meth_collectionsPrelude__apply885[] = {0};
  meth_meth_collectionsPrelude__apply885->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply885);
  meth_meth_collectionsPrelude__apply885->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply885->definitionLine = 697;
// compiled block node returning block884 (depth = 6)
  gc_frame_newslot(block884);
// starting to compile block node (depth = 6)
  Object block891 = alloc_Block(NULL, NULL, "collectionsPrelude", 698);
  gc_frame_newslot(block891);
// method _apply
  block_savedest(block891);
  Object closure892 = createclosure(3, "_apply");
  setclosureframe(closure892, stackframe);
  addtoclosure(closure892, var_ix);
  addtoclosure(closure892, var_l);
  addtoclosure(closure892, selfslot);
  struct UserObject *uo892 = (struct UserObject*)block891;
  uo892->data[0] = (Object)closure892;
  Method *meth_meth_collectionsPrelude__apply892 = addmethod2pos(block891, "_apply", &meth_collectionsPrelude__apply892, 0);
  int argcv_meth_collectionsPrelude__apply892[] = {0};
  meth_meth_collectionsPrelude__apply892->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply892);
  meth_meth_collectionsPrelude__apply892->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply892->definitionLine = 697;
// compiled block node returning block891 (depth = 6)
  gc_frame_newslot(block891);
// call case 5: prelude request
  params[0] = block884;
  params[1] = block891;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call901 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe883);
// compiled call node returning call901 (depth = 5)
// Begin line 703
  setline(703);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_removeAt902(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "removeAt");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method removeAt");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for removeAt (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for removeAt");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_removed = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "removed");
// Begin line 707
  setline(707);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 697
  setline(697);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe903 = gc_frame_new();
// Begin line 707
  setline(707);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num905 = alloc_Float64(1);
// compiled num node returning num905 (depth = 8)
  int op_slot_right_904 = gc_frame_newslot(num905);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe907 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call908 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe907);
// compiled call node returning call908 (depth = 9)
// compiled member node returning call908 (depth = 8)
  int op_slot_left_904 = gc_frame_newslot(call908);
  params[0] = num905;
  partcv[0] = 1;
  Object sum909 = callmethod(call908, "+", 1, partcv, params);
// compiled op node returning sum909 (depth = 7)
  gc_frame_newslot(sum909);
// call case 4: self request
  params[0] = sum909;
  partcv[0] = 1;
  Object call910 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe903);
// compiled call node returning call910 (depth = 6)
// compiled bind node returning done (depth = 5)
// Begin line 708
  setline(708);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe911 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 4: self request
  params[0] = *var_n;
  partcv[0] = 1;
  Object call912 = callmethodflags(self, "at", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe911);
// compiled call node returning call912 (depth = 6)
  *var_removed = call912;
  if (call912 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 709
  setline(709);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
// compiled call node returning done (depth = 5)
// Begin line 710
  setline(710);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_removed (depth = 6)
  return *var_removed;
// compiled return node returning undefined (depth = 5)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_sortBy913(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sortBy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method sortBy");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for sortBy (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_sortBlock = &(stackframe->slots[0]);
  *var_sortBlock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for sortBy");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 714
  setline(714);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 707
  setline(707);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe914 = gc_frame_new();
// Begin line 714
  setline(714);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num916 = alloc_Float64(1);
// compiled num node returning num916 (depth = 8)
  int op_slot_right_915 = gc_frame_newslot(num916);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe918 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call919 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe918);
// compiled call node returning call919 (depth = 9)
// compiled member node returning call919 (depth = 8)
  int op_slot_left_915 = gc_frame_newslot(call919);
  params[0] = num916;
  partcv[0] = 1;
  Object sum920 = callmethod(call919, "+", 1, partcv, params);
// compiled op node returning sum920 (depth = 7)
  gc_frame_newslot(sum920);
// call case 4: self request
  params[0] = sum920;
  partcv[0] = 1;
  Object call921 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe914);
// compiled call node returning call921 (depth = 6)
// compiled bind node returning done (depth = 5)
// Begin line 715
  setline(715);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
// compiled call node returning done (depth = 5)
// Begin line 722
  setline(722);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_addLast922(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addLast");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for addLast (probably reflection error): got %i lists, expected 1.", nparts);
  Object var_init_x = alloc_BuiltinList();
  for (i = 0; i < argcv[0]; i++) {
    callmethod(var_init_x, "push", 1, pushcv, &args[curarg]);
    curarg++;
  }
  Object *var_x = &(stackframe->slots[0]);
  *var_x = var_init_x;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 727
  setline(727);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe923 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_x (depth = 6)
  gc_frame_newslot(*var_x);
// call case 4: self request
  params[0] = *var_x;
  partcv[0] = 1;
  Object call924 = callmethodflags(self, "addAll", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe923);
// compiled call node returning call924 (depth = 5)
  gc_frame_end(frame);
  return call924;
}
Object meth_collectionsPrelude__apply928(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe929 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  gc_frame_newslot(*var_each);
// call case 4: self request
  params[0] = *var_each;
  partcv[0] = 1;
  Object call930 = callmethodflags(self, "push", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe929);
// compiled call node returning call930 (depth = 7)
  gc_frame_end(frame);
  return call930;
}
Object meth_collectionsPrelude_addAll925(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addAll");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method addAll");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for addAll (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for addAll");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 729
  setline(729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe926 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_l (depth = 6)
  gc_frame_newslot(*var_l);
// starting to compile block node (depth = 6)
  Object block927 = alloc_Block(NULL, NULL, "collectionsPrelude", 729);
  gc_frame_newslot(block927);
// method _apply
  block_savedest(block927);
  Object closure928 = createclosure(1, "_apply");
  setclosureframe(closure928, stackframe);
  addtoclosure(closure928, selfslot);
  struct UserObject *uo928 = (struct UserObject*)block927;
  uo928->data[0] = (Object)closure928;
  Method *meth_meth_collectionsPrelude__apply928 = addmethod2pos(block927, "_apply", &meth_collectionsPrelude__apply928, 0);
  int argcv_meth_collectionsPrelude__apply928[] = {1};
  meth_meth_collectionsPrelude__apply928->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply928);
  meth_meth_collectionsPrelude__apply928->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply928->definitionLine = 714;
// compiled block node returning block927 (depth = 6)
  gc_frame_newslot(block927);
// call case 5: prelude request
  params[0] = *var_l;
  params[1] = block927;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call932 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe926);
// compiled call node returning call932 (depth = 5)
// Begin line 730
  setline(730);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_addFirst933(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addFirst");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for addFirst (probably reflection error): got %i lists, expected 1.", nparts);
  Object var_init_l = alloc_BuiltinList();
  for (i = 0; i < argcv[0]; i++) {
    callmethod(var_init_l, "push", 1, pushcv, &args[curarg]);
    curarg++;
  }
  Object *var_l = &(stackframe->slots[0]);
  *var_l = var_init_l;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 733
  setline(733);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe934 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_l (depth = 6)
  gc_frame_newslot(*var_l);
// call case 4: self request
  params[0] = *var_l;
  partcv[0] = 1;
  Object call935 = callmethodflags(self, "addAllFirst", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe934);
// compiled call node returning call935 (depth = 5)
  gc_frame_end(frame);
  return call935;
}
Object meth_collectionsPrelude_removeFirst936(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "removeFirst");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for removeFirst (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for removeFirst");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 737
  setline(737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe937 = gc_frame_new();
// starting to compile num node (depth = 6)
  Object num938 = alloc_Float64(1);
// compiled num node returning num938 (depth = 6)
  gc_frame_newslot(num938);
// call case 4: self request
  params[0] = num938;
  partcv[0] = 1;
  Object call939 = callmethodflags(self, "removeAt", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe937);
// compiled call node returning call939 (depth = 5)
  gc_frame_end(frame);
  return call939;
}
Object meth_collectionsPrelude_remove940(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "remove");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for remove (probably reflection error): got %i lists, expected 1.", nparts);
  Object var_init_v = alloc_BuiltinList();
  for (i = 0; i < argcv[0]; i++) {
    callmethod(var_init_v, "push", 1, pushcv, &args[curarg]);
    curarg++;
  }
  Object *var_v = &(stackframe->slots[0]);
  *var_v = var_init_v;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 742
  setline(742);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe941 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  gc_frame_newslot(*var_v);
// call case 4: self request
  params[0] = *var_v;
  partcv[0] = 1;
  Object call942 = callmethodflags(self, "removeAll", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe941);
// compiled call node returning call942 (depth = 5)
  gc_frame_end(frame);
  return call942;
}
Object meth_collectionsPrelude_remove_40__41_ifAbsent943(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "remove()ifAbsent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method remove()ifAbsent");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for remove()ifAbsent (probably reflection error): got %i lists, expected 2.", nparts);
  Object var_init_v = alloc_BuiltinList();
  for (i = 0; i < argcv[0]; i++) {
    callmethod(var_init_v, "push", 1, pushcv, &args[curarg]);
    curarg++;
  }
  Object *var_v = &(stackframe->slots[0]);
  *var_v = var_init_v;
  Object *var_action = &(stackframe->slots[1]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for ifAbsent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 747
  setline(747);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe944 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  gc_frame_newslot(*var_v);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_action (depth = 6)
  gc_frame_newslot(*var_action);
// call case 4: self request
  params[0] = *var_v;
  params[1] = *var_action;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call945 = callmethodflags(self, "removeAll()ifAbsent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe944);
// compiled call node returning call945 (depth = 5)
  gc_frame_end(frame);
  return call945;
}
Object meth_collectionsPrelude__apply949(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe950 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit951 == NULL) {
    strlit951 = alloc_String("object not in list");
    gc_root(strlit951);
  }
// compiled string node returning strlit951 (depth = 8)
  gc_frame_newslot(strlit951);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_NoSuchObject (depth = 8)
  params[0] = strlit951;
  partcv[0] = 1;
  Object call952 = callmethod(*var_NoSuchObject, "raise",
    1, partcv, params);
  gc_frame_end(callframe950);
// compiled call node returning call952 (depth = 7)
  gc_frame_end(frame);
  return call952;
}
Object meth_collectionsPrelude_removeAll946(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 22, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "removeAll");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method removeAll");
  Object params[2];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for removeAll (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_vs = &(stackframe->slots[0]);
  *var_vs = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for removeAll");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 752
  setline(752);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe947 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_vs (depth = 6)
  gc_frame_newslot(*var_vs);
// starting to compile block node (depth = 6)
  Object block948 = alloc_Block(NULL, NULL, "collectionsPrelude", 752);
  gc_frame_newslot(block948);
// method _apply
  block_savedest(block948);
  Object closure949 = createclosure(2, "_apply");
  setclosureframe(closure949, stackframe);
  addtoclosure(closure949, var_NoSuchObject);
  addtoclosure(closure949, selfslot);
  struct UserObject *uo949 = (struct UserObject*)block948;
  uo949->data[0] = (Object)closure949;
  Method *meth_meth_collectionsPrelude__apply949 = addmethod2pos(block948, "_apply", &meth_collectionsPrelude__apply949, 0);
  int argcv_meth_collectionsPrelude__apply949[] = {0};
  meth_meth_collectionsPrelude__apply949->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply949);
  meth_meth_collectionsPrelude__apply949->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply949->definitionLine = 714;
// compiled block node returning block948 (depth = 6)
  gc_frame_newslot(block948);
// call case 4: self request
  params[0] = *var_vs;
  params[1] = block948;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call954 = callmethodflags(self, "removeAll()ifAbsent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe947);
// compiled call node returning call954 (depth = 5)
  gc_frame_end(frame);
  return call954;
}
Object meth_collectionsPrelude__apply961(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_action = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile return node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe962 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_action (depth = 13)
  partcv[0] = 0;
  Object call963 = callmethod(*var_action, "apply",
    1, partcv, params);
  gc_frame_end(callframe962);
// compiled call node returning call963 (depth = 12)
// compiled member node returning call963 (depth = 11)
  block_return(realself, call963);
// compiled return node returning undefined (depth = 10)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply958(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_action = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ix = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "ix");
// Begin line 758
  setline(758);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe959 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_each (depth = 9)
  gc_frame_newslot(*var_each);
// starting to compile block node (depth = 9)
  Object block960 = alloc_Block(NULL, NULL, "collectionsPrelude", 758);
  gc_frame_newslot(block960);
// method _apply
  block_savedest(block960);
  Object closure961 = createclosure(2, "_apply");
  setclosureframe(closure961, stackframe);
  addtoclosure(closure961, var_action);
  addtoclosure(closure961, selfslot);
  struct UserObject *uo961 = (struct UserObject*)block960;
  uo961->data[0] = (Object)closure961;
  Method *meth_meth_collectionsPrelude__apply961 = addmethod2pos(block960, "_apply", &meth_collectionsPrelude__apply961, 0);
  int argcv_meth_collectionsPrelude__apply961[] = {0};
  meth_meth_collectionsPrelude__apply961->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply961);
  meth_meth_collectionsPrelude__apply961->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply961->definitionLine = 714;
// compiled block node returning block960 (depth = 9)
  gc_frame_newslot(block960);
// call case 4: self request
  params[0] = *var_each;
  params[1] = block960;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call965 = callmethodflags(self, "indexOf()ifAbsent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe959);
// compiled call node returning call965 (depth = 8)
  *var_ix = call965;
  if (call965 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 759
  setline(759);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe966 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ix (depth = 8)
  gc_frame_newslot(*var_ix);
// call case 4: self request
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call967 = callmethodflags(self, "removeAt", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe966);
// compiled call node returning call967 (depth = 7)
  gc_frame_end(frame);
  return call967;
}
Object meth_collectionsPrelude_removeAll_40__41_ifAbsent955(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "removeAll()ifAbsent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method removeAll()ifAbsent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method removeAll()ifAbsent");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for removeAll()ifAbsent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_vs = &(stackframe->slots[0]);
  *var_vs = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for removeAll");
  Object *var_action = &(stackframe->slots[1]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for ifAbsent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 757
  setline(757);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe956 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_vs (depth = 6)
  gc_frame_newslot(*var_vs);
// starting to compile block node (depth = 6)
  Object block957 = alloc_Block(NULL, NULL, "collectionsPrelude", 757);
  gc_frame_newslot(block957);
// method _apply
  block_savedest(block957);
  Object closure958 = createclosure(2, "_apply");
  setclosureframe(closure958, stackframe);
  addtoclosure(closure958, var_action);
  addtoclosure(closure958, selfslot);
  struct UserObject *uo958 = (struct UserObject*)block957;
  uo958->data[0] = (Object)closure958;
  Method *meth_meth_collectionsPrelude__apply958 = addmethod2pos(block957, "_apply", &meth_collectionsPrelude__apply958, 0);
  int argcv_meth_collectionsPrelude__apply958[] = {1};
  meth_meth_collectionsPrelude__apply958->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply958);
  meth_meth_collectionsPrelude__apply958->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply958->definitionLine = 714;
// compiled block node returning block957 (depth = 6)
  gc_frame_newslot(block957);
// call case 5: prelude request
  params[0] = *var_vs;
  params[1] = block957;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call969 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe956);
// compiled call node returning call969 (depth = 5)
// Begin line 761
  setline(761);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_pop970(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pop");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pop (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for pop");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 765
  setline(765);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe971 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call972 = callmethodflags(self, "removeLast", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe971);
// compiled call node returning call972 (depth = 6)
// compiled member node returning call972 (depth = 5)
  gc_frame_end(frame);
  return call972;
}
Object meth_collectionsPrelude__apply984(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_result = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe985 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  gc_frame_newslot(*var_each);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_result (depth = 8)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call986 = callmethod(*var_result, "addFirst",
    1, partcv, params);
  gc_frame_end(callframe985);
// compiled call node returning call986 (depth = 7)
  gc_frame_end(frame);
  return call986;
}
Object meth_collectionsPrelude_reversed973(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "reversed");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for reversed (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for reversed");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "result");
// Begin line 768
  setline(768);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe974 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe975 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe976 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe977 = gc_frame_new();
// call case 3: self.outer request
  Object call978 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe977);
// compiled call node returning call978 (depth = 13)
// compiled member node returning call978 (depth = 12)
  partcv[0] = 0;
  Object call979 = callmethodflags(call978, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe976);
// compiled call node returning call979 (depth = 11)
// compiled member node returning call979 (depth = 10)
  partcv[0] = 0;
  Object call980 = callmethodflags(call979, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe975);
// compiled call node returning call980 (depth = 9)
// compiled member node returning call980 (depth = 8)
  partcv[0] = 0;
  Object call981 = callmethod(call980, "empty",
    1, partcv, params);
  gc_frame_end(callframe974);
// compiled call node returning call981 (depth = 7)
// compiled member node returning call981 (depth = 6)
  *var_result = call981;
  if (call981 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 769
  setline(769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe982 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block983 = alloc_Block(NULL, NULL, "collectionsPrelude", 769);
  gc_frame_newslot(block983);
// method _apply
  block_savedest(block983);
  Object closure984 = createclosure(2, "_apply");
  setclosureframe(closure984, stackframe);
  addtoclosure(closure984, var_result);
  addtoclosure(closure984, selfslot);
  struct UserObject *uo984 = (struct UserObject*)block983;
  uo984->data[0] = (Object)closure984;
  Method *meth_meth_collectionsPrelude__apply984 = addmethod2pos(block983, "_apply", &meth_collectionsPrelude__apply984, 0);
  int argcv_meth_collectionsPrelude__apply984[] = {1};
  meth_meth_collectionsPrelude__apply984->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply984);
  meth_meth_collectionsPrelude__apply984->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply984->definitionLine = 768;
// compiled block node returning block983 (depth = 6)
  gc_frame_newslot(block983);
// call case 4: self request
  params[0] = block983;
  partcv[0] = 1;
  Object call988 = callmethodflags(self, "do", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe982);
// compiled call node returning call988 (depth = 5)
// Begin line 770
  setline(770);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_collectionsPrelude__apply1003(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_hiIx = getfromclosure(closure, 0);
  Object *var_loIx = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_hiIx (depth = 8)
  int op_slot_right_1004 = gc_frame_newslot(*var_hiIx);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_loIx (depth = 8)
  int op_slot_left_1004 = gc_frame_newslot(*var_loIx);
  params[0] = *var_hiIx;
  partcv[0] = 1;
  Object opresult1006 = callmethod(*var_loIx, "<", 1, partcv, params);
// compiled op node returning opresult1006 (depth = 7)
  gc_frame_end(frame);
  return opresult1006;
}
Object meth_collectionsPrelude__apply1009(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_hiIx = getfromclosure(closure, 0);
  Object *var_loIx = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_hiVal = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "hiVal");
// Begin line 777
  setline(777);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1010 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_hiIx (depth = 9)
  gc_frame_newslot(*var_hiIx);
// call case 4: self request
  params[0] = *var_hiIx;
  partcv[0] = 1;
  Object call1011 = callmethodflags(self, "at", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1010);
// compiled call node returning call1011 (depth = 8)
  *var_hiVal = call1011;
  if (call1011 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 778
  setline(778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1012 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_hiIx (depth = 8)
  gc_frame_newslot(*var_hiIx);
// starting to compile call node (depth = 8)
  int callframe1013 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_loIx (depth = 9)
  gc_frame_newslot(*var_loIx);
// call case 4: self request
  params[0] = *var_loIx;
  partcv[0] = 1;
  Object call1014 = callmethodflags(self, "at", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1013);
// compiled call node returning call1014 (depth = 8)
  gc_frame_newslot(call1014);
// call case 4: self request
  params[0] = *var_hiIx;
  params[1] = call1014;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1015 = callmethodflags(self, "at()put", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1012);
// compiled call node returning call1015 (depth = 7)
// Begin line 779
  setline(779);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1016 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_loIx (depth = 8)
  gc_frame_newslot(*var_loIx);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_hiVal (depth = 8)
  gc_frame_newslot(*var_hiVal);
// call case 4: self request
  params[0] = *var_loIx;
  params[1] = *var_hiVal;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1017 = callmethodflags(self, "at()put", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1016);
// compiled call node returning call1017 (depth = 7)
// Begin line 780
  setline(780);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1019 = alloc_Float64(1);
// compiled num node returning num1019 (depth = 9)
  int op_slot_right_1018 = gc_frame_newslot(num1019);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_hiIx (depth = 9)
  int op_slot_left_1018 = gc_frame_newslot(*var_hiIx);
  params[0] = num1019;
  partcv[0] = 1;
  Object diff1021 = callmethod(*var_hiIx, "-", 1, partcv, params);
// compiled op node returning diff1021 (depth = 8)
  *var_hiIx = diff1021;
  if (diff1021 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 781
  setline(781);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1024 = alloc_Float64(1);
// compiled num node returning num1024 (depth = 9)
  int op_slot_right_1023 = gc_frame_newslot(num1024);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_loIx (depth = 9)
  int op_slot_left_1023 = gc_frame_newslot(*var_loIx);
  params[0] = num1024;
  partcv[0] = 1;
  Object sum1026 = callmethod(*var_loIx, "+", 1, partcv, params);
// compiled op node returning sum1026 (depth = 8)
  *var_loIx = sum1026;
  if (sum1026 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_reverse989(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "reverse");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for reverse (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for reverse");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_hiIx = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "hiIx");
  Object *var_loIx = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "loIx");
// Begin line 773
  setline(773);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 768
  setline(768);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe990 = gc_frame_new();
// Begin line 773
  setline(773);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num992 = alloc_Float64(1);
// compiled num node returning num992 (depth = 8)
  int op_slot_right_991 = gc_frame_newslot(num992);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe994 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call995 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe994);
// compiled call node returning call995 (depth = 9)
// compiled member node returning call995 (depth = 8)
  int op_slot_left_991 = gc_frame_newslot(call995);
  params[0] = num992;
  partcv[0] = 1;
  Object sum996 = callmethod(call995, "+", 1, partcv, params);
// compiled op node returning sum996 (depth = 7)
  gc_frame_newslot(sum996);
// call case 4: self request
  params[0] = sum996;
  partcv[0] = 1;
  Object call997 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe990);
// compiled call node returning call997 (depth = 6)
// compiled bind node returning done (depth = 5)
// Begin line 774
  setline(774);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe998 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call999 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe998);
// compiled call node returning call999 (depth = 7)
// compiled member node returning call999 (depth = 6)
  *var_hiIx = call999;
  if (call999 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 775
  setline(775);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1000 = alloc_Float64(1);
// compiled num node returning num1000 (depth = 6)
  *var_loIx = num1000;
  if (num1000 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 776
  setline(776);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1001 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block1002 = alloc_Block(NULL, NULL, "collectionsPrelude", 776);
  gc_frame_newslot(block1002);
// method _apply
  block_savedest(block1002);
  Object closure1003 = createclosure(3, "_apply");
  setclosureframe(closure1003, stackframe);
  addtoclosure(closure1003, var_hiIx);
  addtoclosure(closure1003, var_loIx);
  addtoclosure(closure1003, selfslot);
  struct UserObject *uo1003 = (struct UserObject*)block1002;
  uo1003->data[0] = (Object)closure1003;
  Method *meth_meth_collectionsPrelude__apply1003 = addmethod2pos(block1002, "_apply", &meth_collectionsPrelude__apply1003, 0);
  int argcv_meth_collectionsPrelude__apply1003[] = {0};
  meth_meth_collectionsPrelude__apply1003->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1003);
  meth_meth_collectionsPrelude__apply1003->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1003->definitionLine = 774;
// compiled block node returning block1002 (depth = 6)
  gc_frame_newslot(block1002);
// starting to compile block node (depth = 6)
  Object block1008 = alloc_Block(NULL, NULL, "collectionsPrelude", 776);
  gc_frame_newslot(block1008);
// method _apply
  block_savedest(block1008);
  Object closure1009 = createclosure(3, "_apply");
  setclosureframe(closure1009, stackframe);
  addtoclosure(closure1009, var_hiIx);
  addtoclosure(closure1009, var_loIx);
  addtoclosure(closure1009, selfslot);
  struct UserObject *uo1009 = (struct UserObject*)block1008;
  uo1009->data[0] = (Object)closure1009;
  Method *meth_meth_collectionsPrelude__apply1009 = addmethod2pos(block1008, "_apply", &meth_collectionsPrelude__apply1009, 0);
  int argcv_meth_collectionsPrelude__apply1009[] = {0};
  meth_meth_collectionsPrelude__apply1009->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1009);
  meth_meth_collectionsPrelude__apply1009->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1009->definitionLine = 774;
// compiled block node returning block1008 (depth = 6)
  gc_frame_newslot(block1008);
// call case 5: prelude request
  params[0] = block1002;
  params[1] = block1008;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1029 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1001);
// compiled call node returning call1029 (depth = 5)
// Begin line 783
  setline(783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__43__43_1030(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "++");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method ++");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for ++ (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for ++");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_l = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "l");
// Begin line 787
  setline(787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1031 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1032 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1033 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1034 = gc_frame_new();
// call case 3: self.outer request
  Object call1035 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1034);
// compiled call node returning call1035 (depth = 12)
// compiled member node returning call1035 (depth = 11)
  partcv[0] = 0;
  Object call1036 = callmethodflags(call1035, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1033);
// compiled call node returning call1036 (depth = 10)
// compiled member node returning call1036 (depth = 9)
  partcv[0] = 0;
  Object call1037 = callmethodflags(call1036, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1032);
// compiled call node returning call1037 (depth = 8)
// compiled member node returning call1037 (depth = 7)
  params[0] = self;
  partcv[0] = 1;
  Object call1038 = callmethod(call1037, "withAll",
    1, partcv, params);
  gc_frame_end(callframe1031);
// compiled call node returning call1038 (depth = 6)
  *var_l = call1038;
  if (call1038 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 788
  setline(788);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1039 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_l (depth = 6)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call1040 = callmethod(*var_l, "addAll",
    1, partcv, params);
  gc_frame_end(callframe1039);
// compiled call node returning call1040 (depth = 5)
  gc_frame_end(frame);
  return call1040;
}
Object meth_collectionsPrelude__apply1051(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object *var_curSize = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 796
  setline(796);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1053 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 11)
  int callframe1054 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_i (depth = 12)
  gc_frame_newslot(*var_i);
// call case 4: self request
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1055 = callmethodflags(self, "at", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1054);
// compiled call node returning call1055 (depth = 11)
  partcv[0] = 0;
  Object call1056 = callmethod(call1055, "asString",
    1, partcv, params);
  gc_frame_end(callframe1053);
// compiled call node returning call1056 (depth = 10)
// compiled member node returning call1056 (depth = 9)
  int op_slot_right_1052 = gc_frame_newslot(call1056);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_1052 = gc_frame_newslot(*var_s);
  params[0] = call1056;
  partcv[0] = 1;
  Object opresult1058 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1058 (depth = 8)
  *var_s = opresult1058;
  if (opresult1058 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 797
  setline(797);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_curSize (depth = 9)
  int op_slot_right_1061 = gc_frame_newslot(*var_curSize);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  int op_slot_left_1061 = gc_frame_newslot(*var_i);
  params[0] = *var_curSize;
  partcv[0] = 1;
  Object opresult1063 = callmethod(*var_i, "<", 1, partcv, params);
// compiled op node returning opresult1063 (depth = 8)
  Object if1060 = done;
  if (istrue(opresult1063)) {
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1065 == NULL) {
    strlit1065 = alloc_String(", ");
    gc_root(strlit1065);
  }
// compiled string node returning strlit1065 (depth = 10)
  int op_slot_right_1064 = gc_frame_newslot(strlit1065);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_1064 = gc_frame_newslot(*var_s);
  params[0] = strlit1065;
  partcv[0] = 1;
  Object opresult1067 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1067 (depth = 9)
  *var_s = opresult1067;
  if (opresult1067 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if1060 = done;
  } else {
  }
// compiled if node returning if1060 (depth = 7)
  gc_frame_end(frame);
  return if1060;
}
Object meth_collectionsPrelude_asString1041(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
  Object *var_curSize = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "curSize");
// Begin line 793
  setline(793);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1042 == NULL) {
    strlit1042 = alloc_String("[");
    gc_root(strlit1042);
  }
// compiled string node returning strlit1042 (depth = 6)
  *var_s = strlit1042;
  if (strlit1042 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 794
  setline(794);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1043 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1044 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1043);
// compiled call node returning call1044 (depth = 7)
// compiled member node returning call1044 (depth = 6)
  *var_curSize = call1044;
  if (call1044 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 795
  setline(795);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1045 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_curSize (depth = 7)
  int op_slot_right_1046 = gc_frame_newslot(*var_curSize);
// starting to compile num node (depth = 7)
  Object num1048 = alloc_Float64(1);
// compiled num node returning num1048 (depth = 7)
  int op_slot_left_1046 = gc_frame_newslot(num1048);
  params[0] = *var_curSize;
  partcv[0] = 1;
  Object opresult1049 = callmethod(num1048, "..", 1, partcv, params);
// compiled op node returning opresult1049 (depth = 6)
  gc_frame_newslot(opresult1049);
// starting to compile block node (depth = 6)
  Object block1050 = alloc_Block(NULL, NULL, "collectionsPrelude", 795);
  gc_frame_newslot(block1050);
// method _apply
  block_savedest(block1050);
  Object closure1051 = createclosure(3, "_apply");
  setclosureframe(closure1051, stackframe);
  addtoclosure(closure1051, var_s);
  addtoclosure(closure1051, var_curSize);
  addtoclosure(closure1051, selfslot);
  struct UserObject *uo1051 = (struct UserObject*)block1050;
  uo1051->data[0] = (Object)closure1051;
  Method *meth_meth_collectionsPrelude__apply1051 = addmethod2pos(block1050, "_apply", &meth_collectionsPrelude__apply1051, 0);
  int argcv_meth_collectionsPrelude__apply1051[] = {1};
  meth_meth_collectionsPrelude__apply1051->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1051);
  meth_meth_collectionsPrelude__apply1051->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1051->definitionLine = 794;
// compiled block node returning block1050 (depth = 6)
  gc_frame_newslot(block1050);
// call case 5: prelude request
  params[0] = opresult1049;
  params[1] = block1050;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1070 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1045);
// compiled call node returning call1070 (depth = 5)
// Begin line 799
  setline(799);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1072 == NULL) {
    strlit1072 = alloc_String("]");
    gc_root(strlit1072);
  }
// compiled string node returning strlit1072 (depth = 6)
  int op_slot_right_1071 = gc_frame_newslot(strlit1072);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_1071 = gc_frame_newslot(*var_s);
  params[0] = strlit1072;
  partcv[0] = 1;
  Object opresult1074 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1074 (depth = 5)
  gc_frame_end(frame);
  return opresult1074;
}
Object meth_collectionsPrelude_extend1075(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 29, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "extend");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method extend");
  Object params[1];
  int partcv[1];
  Object *var_done = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for extend (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for extend");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 803
  setline(803);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1076 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_l (depth = 6)
  gc_frame_newslot(*var_l);
// call case 4: self request
  params[0] = *var_l;
  partcv[0] = 1;
  Object call1077 = callmethodflags(self, "addAll", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1076);
// compiled call node returning call1077 (depth = 5)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_done (depth = 5)
  gc_frame_end(frame);
  return *var_done;
}
Object meth_collectionsPrelude__apply1081(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_element = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_element (depth = 9)
  int op_slot_right_1083 = gc_frame_newslot(*var_element);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_each (depth = 9)
  int op_slot_left_1083 = gc_frame_newslot(*var_each);
  params[0] = *var_element;
  partcv[0] = 1;
  Object opresult1085 = callmethod(*var_each, "==", 1, partcv, params);
// compiled op node returning opresult1085 (depth = 8)
  Object if1082 = done;
  if (istrue(opresult1085)) {
// starting to compile return node (depth = 8)
// starting to compile identifier node (depth = 9)
  Object bool1086 = alloc_Boolean(1);
// compiled identifier node returning bool1086 (depth = 9)
  block_return(realself, bool1086);
// compiled return node returning undefined (depth = 8)
    gc_frame_newslot(undefined);
    if1082 = undefined;
  } else {
  }
// compiled if node returning if1082 (depth = 7)
  gc_frame_end(frame);
  return if1082;
}
Object meth_collectionsPrelude_contains1078(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "contains");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method contains");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for contains (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_element = &(stackframe->slots[0]);
  *var_element = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for contains");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 807
  setline(807);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1079 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block1080 = alloc_Block(NULL, NULL, "collectionsPrelude", 807);
  gc_frame_newslot(block1080);
// method _apply
  block_savedest(block1080);
  Object closure1081 = createclosure(2, "_apply");
  setclosureframe(closure1081, stackframe);
  addtoclosure(closure1081, var_element);
  addtoclosure(closure1081, selfslot);
  struct UserObject *uo1081 = (struct UserObject*)block1080;
  uo1081->data[0] = (Object)closure1081;
  Method *meth_meth_collectionsPrelude__apply1081 = addmethod2pos(block1080, "_apply", &meth_collectionsPrelude__apply1081, 0);
  int argcv_meth_collectionsPrelude__apply1081[] = {1};
  meth_meth_collectionsPrelude__apply1081->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1081);
  meth_meth_collectionsPrelude__apply1081->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1081->definitionLine = 796;
// compiled block node returning block1080 (depth = 6)
  gc_frame_newslot(block1080);
// call case 4: self request
  params[0] = block1080;
  partcv[0] = 1;
  Object call1088 = callmethodflags(self, "do", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1079);
// compiled call node returning call1088 (depth = 5)
// Begin line 808
  setline(808);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool1089 = alloc_Boolean(0);
// compiled identifier node returning bool1089 (depth = 6)
  return bool1089;
// compiled return node returning undefined (depth = 5)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply1096(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_curSize = getfromclosure(closure, 0);
  Object *var_i = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_curSize (depth = 8)
  int op_slot_right_1097 = gc_frame_newslot(*var_curSize);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  int op_slot_left_1097 = gc_frame_newslot(*var_i);
  params[0] = *var_curSize;
  partcv[0] = 1;
  Object opresult1099 = callmethod(*var_i, "<=", 1, partcv, params);
// compiled op node returning opresult1099 (depth = 7)
  gc_frame_end(frame);
  return opresult1099;
}
Object meth_collectionsPrelude__apply1102(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object *var_block1 = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 815
  setline(815);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1103 = gc_frame_new();
// starting to compile call node (depth = 8)
  int callframe1104 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  gc_frame_newslot(*var_i);
// call case 4: self request
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1105 = callmethodflags(self, "at", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1104);
// compiled call node returning call1105 (depth = 8)
  gc_frame_newslot(call1105);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_block1 (depth = 8)
  params[0] = call1105;
  partcv[0] = 1;
  Object call1106 = callmethod(*var_block1, "apply",
    1, partcv, params);
  gc_frame_end(callframe1103);
// compiled call node returning call1106 (depth = 7)
// Begin line 816
  setline(816);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1108 = alloc_Float64(1);
// compiled num node returning num1108 (depth = 9)
  int op_slot_right_1107 = gc_frame_newslot(num1108);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  int op_slot_left_1107 = gc_frame_newslot(*var_i);
  params[0] = num1108;
  partcv[0] = 1;
  Object sum1110 = callmethod(*var_i, "+", 1, partcv, params);
// compiled op node returning sum1110 (depth = 8)
  *var_i = sum1110;
  if (sum1110 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_do1090(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method do");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for do (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for do");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_i = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "i");
  Object *var_curSize = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "curSize");
// Begin line 812
  setline(812);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1091 = alloc_Float64(1);
// compiled num node returning num1091 (depth = 6)
  *var_i = num1091;
  if (num1091 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 813
  setline(813);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1092 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1093 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1092);
// compiled call node returning call1093 (depth = 7)
// compiled member node returning call1093 (depth = 6)
  *var_curSize = call1093;
  if (call1093 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 814
  setline(814);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1094 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block1095 = alloc_Block(NULL, NULL, "collectionsPrelude", 814);
  gc_frame_newslot(block1095);
// method _apply
  block_savedest(block1095);
  Object closure1096 = createclosure(3, "_apply");
  setclosureframe(closure1096, stackframe);
  addtoclosure(closure1096, var_curSize);
  addtoclosure(closure1096, var_i);
  addtoclosure(closure1096, selfslot);
  struct UserObject *uo1096 = (struct UserObject*)block1095;
  uo1096->data[0] = (Object)closure1096;
  Method *meth_meth_collectionsPrelude__apply1096 = addmethod2pos(block1095, "_apply", &meth_collectionsPrelude__apply1096, 0);
  int argcv_meth_collectionsPrelude__apply1096[] = {0};
  meth_meth_collectionsPrelude__apply1096->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1096);
  meth_meth_collectionsPrelude__apply1096->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1096->definitionLine = 813;
// compiled block node returning block1095 (depth = 6)
  gc_frame_newslot(block1095);
// starting to compile block node (depth = 6)
  Object block1101 = alloc_Block(NULL, NULL, "collectionsPrelude", 814);
  gc_frame_newslot(block1101);
// method _apply
  block_savedest(block1101);
  Object closure1102 = createclosure(3, "_apply");
  setclosureframe(closure1102, stackframe);
  addtoclosure(closure1102, var_i);
  addtoclosure(closure1102, var_block1);
  addtoclosure(closure1102, selfslot);
  struct UserObject *uo1102 = (struct UserObject*)block1101;
  uo1102->data[0] = (Object)closure1102;
  Method *meth_meth_collectionsPrelude__apply1102 = addmethod2pos(block1101, "_apply", &meth_collectionsPrelude__apply1102, 0);
  int argcv_meth_collectionsPrelude__apply1102[] = {0};
  meth_meth_collectionsPrelude__apply1102->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1102);
  meth_meth_collectionsPrelude__apply1102->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1102->definitionLine = 813;
// compiled block node returning block1101 (depth = 6)
  gc_frame_newslot(block1101);
// call case 5: prelude request
  params[0] = block1095;
  params[1] = block1101;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1113 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1094);
// compiled call node returning call1113 (depth = 5)
  gc_frame_end(frame);
  return call1113;
}
Object meth_collectionsPrelude__apply1124(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_otherIter = getfromclosure(closure, 0);
  Object *var_selfIter = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1126 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_otherIter (depth = 12)
  partcv[0] = 0;
  Object call1127 = callmethod(*var_otherIter, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe1126);
// compiled call node returning call1127 (depth = 11)
// compiled member node returning call1127 (depth = 10)
  int op_slot_right_1125 = gc_frame_newslot(call1127);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1129 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_selfIter (depth = 12)
  partcv[0] = 0;
  Object call1130 = callmethod(*var_selfIter, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe1129);
// compiled call node returning call1130 (depth = 11)
// compiled member node returning call1130 (depth = 10)
  int op_slot_left_1125 = gc_frame_newslot(call1130);
  params[0] = call1127;
  partcv[0] = 1;
  Object opresult1131 = callmethod(call1130, "&&", 1, partcv, params);
// compiled op node returning opresult1131 (depth = 9)
  gc_frame_end(frame);
  return opresult1131;
}
Object meth_collectionsPrelude__apply1134(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_otherIter = getfromclosure(closure, 0);
  Object *var_selfIter = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 827
  setline(827);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1137 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_otherIter (depth = 13)
  partcv[0] = 0;
  Object call1138 = callmethod(*var_otherIter, "next",
    1, partcv, params);
  gc_frame_end(callframe1137);
// compiled call node returning call1138 (depth = 12)
// compiled member node returning call1138 (depth = 11)
  int op_slot_right_1136 = gc_frame_newslot(call1138);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1140 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_selfIter (depth = 13)
  partcv[0] = 0;
  Object call1141 = callmethod(*var_selfIter, "next",
    1, partcv, params);
  gc_frame_end(callframe1140);
// compiled call node returning call1141 (depth = 12)
// compiled member node returning call1141 (depth = 11)
  int op_slot_left_1136 = gc_frame_newslot(call1141);
  params[0] = call1138;
  partcv[0] = 1;
  Object opresult1142 = callmethod(call1141, "!=", 1, partcv, params);
// compiled op node returning opresult1142 (depth = 10)
  Object if1135 = done;
  if (istrue(opresult1142)) {
// Begin line 828
  setline(828);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 10)
// starting to compile identifier node (depth = 11)
  Object bool1143 = alloc_Boolean(0);
// compiled identifier node returning bool1143 (depth = 11)
  block_return(realself, bool1143);
// compiled return node returning undefined (depth = 10)
    gc_frame_newslot(undefined);
    if1135 = undefined;
  } else {
  }
// compiled if node returning if1135 (depth = 9)
  gc_frame_end(frame);
  return if1135;
}
Object meth_collectionsPrelude__apply1117(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_other = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_selfIter = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "selfIter");
  Object *var_otherIter = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "otherIter");
// Begin line 824
  setline(824);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1118 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1119 = callmethodflags(self, "iterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1118);
// compiled call node returning call1119 (depth = 9)
// compiled member node returning call1119 (depth = 8)
  *var_selfIter = call1119;
  if (call1119 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 825
  setline(825);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1120 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_other (depth = 10)
  partcv[0] = 0;
  Object call1121 = callmethod(*var_other, "iterator",
    1, partcv, params);
  gc_frame_end(callframe1120);
// compiled call node returning call1121 (depth = 9)
// compiled member node returning call1121 (depth = 8)
  *var_otherIter = call1121;
  if (call1121 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 826
  setline(826);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1122 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block1123 = alloc_Block(NULL, NULL, "collectionsPrelude", 826);
  gc_frame_newslot(block1123);
// method _apply
  block_savedest(block1123);
  Object closure1124 = createclosure(3, "_apply");
  setclosureframe(closure1124, stackframe);
  addtoclosure(closure1124, var_otherIter);
  addtoclosure(closure1124, var_selfIter);
  addtoclosure(closure1124, selfslot);
  struct UserObject *uo1124 = (struct UserObject*)block1123;
  uo1124->data[0] = (Object)closure1124;
  Method *meth_meth_collectionsPrelude__apply1124 = addmethod2pos(block1123, "_apply", &meth_collectionsPrelude__apply1124, 0);
  int argcv_meth_collectionsPrelude__apply1124[] = {0};
  meth_meth_collectionsPrelude__apply1124->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1124);
  meth_meth_collectionsPrelude__apply1124->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1124->definitionLine = 825;
// compiled block node returning block1123 (depth = 8)
  gc_frame_newslot(block1123);
// starting to compile block node (depth = 8)
  Object block1133 = alloc_Block(NULL, NULL, "collectionsPrelude", 826);
  gc_frame_newslot(block1133);
// method _apply
  block_savedest(block1133);
  Object closure1134 = createclosure(3, "_apply");
  setclosureframe(closure1134, stackframe);
  addtoclosure(closure1134, var_otherIter);
  addtoclosure(closure1134, var_selfIter);
  addtoclosure(closure1134, selfslot);
  struct UserObject *uo1134 = (struct UserObject*)block1133;
  uo1134->data[0] = (Object)closure1134;
  Method *meth_meth_collectionsPrelude__apply1134 = addmethod2pos(block1133, "_apply", &meth_collectionsPrelude__apply1134, 0);
  int argcv_meth_collectionsPrelude__apply1134[] = {0};
  meth_meth_collectionsPrelude__apply1134->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1134);
  meth_meth_collectionsPrelude__apply1134->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1134->definitionLine = 826;
// compiled block node returning block1133 (depth = 8)
  gc_frame_newslot(block1133);
// call case 5: prelude request
  params[0] = block1123;
  params[1] = block1133;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1145 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1122);
// compiled call node returning call1145 (depth = 7)
// Begin line 831
  setline(831);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1147 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_otherIter (depth = 11)
  partcv[0] = 0;
  Object call1148 = callmethod(*var_otherIter, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe1147);
// compiled call node returning call1148 (depth = 10)
// compiled member node returning call1148 (depth = 9)
  int op_slot_right_1146 = gc_frame_newslot(call1148);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1150 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_selfIter (depth = 11)
  partcv[0] = 0;
  Object call1151 = callmethod(*var_selfIter, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe1150);
// compiled call node returning call1151 (depth = 10)
// compiled member node returning call1151 (depth = 9)
  int op_slot_left_1146 = gc_frame_newslot(call1151);
  params[0] = call1148;
  partcv[0] = 1;
  Object opresult1152 = callmethod(call1151, "==", 1, partcv, params);
// compiled op node returning opresult1152 (depth = 8)
  block_return(realself, opresult1152);
// compiled return node returning undefined (depth = 7)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply1164(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___15 = &(stackframe->slots[0]);
  *var___15 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 834
  setline(834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool1165 = alloc_Boolean(0);
// compiled identifier node returning bool1165 (depth = 8)
  block_return(realself, bool1165);
// compiled return node returning undefined (depth = 7)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__61__61_1114(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 32, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "==");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method ==");
  Object params[2];
  int partcv[1];
  Object *var_Collection = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for == (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for ==");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 822
  setline(822);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  int frame1115 = gc_frame_new();
  gc_frame_newslot(*var_other);
// Begin line 823
  setline(823);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 6)
  Object block1116 = alloc_Block(NULL, NULL, "collectionsPrelude", 823);
  gc_frame_newslot(block1116);
// method _apply
  block_savedest(block1116);
  Object closure1117 = createclosure(2, "_apply");
  setclosureframe(closure1117, stackframe);
  addtoclosure(closure1117, var_other);
  addtoclosure(closure1117, selfslot);
  struct UserObject *uo1117 = (struct UserObject*)block1116;
  uo1117->data[0] = (Object)closure1117;
  Method *meth_meth_collectionsPrelude__apply1117 = addmethod2pos(block1116, "_apply", &meth_collectionsPrelude__apply1117, 0);
  int argcv_meth_collectionsPrelude__apply1117[] = {1};
  meth_meth_collectionsPrelude__apply1117->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1117);
  meth_meth_collectionsPrelude__apply1117->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1117->definitionLine = 813;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1154 = gc_frame_new();
// starting to compile call node (depth = 8)
  int callframe1155 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1156 == NULL) {
    strlit1156 = alloc_String("o");
    gc_root(strlit1156);
  }
// compiled string node returning strlit1156 (depth = 9)
  gc_frame_newslot(strlit1156);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1157 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call1158 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1157);
// compiled call node returning call1158 (depth = 10)
// compiled member node returning call1158 (depth = 9)
  params[0] = strlit1156;
  partcv[0] = 1;
  Object call1159 = callmethod(call1158, "new",
    1, partcv, params);
  gc_frame_end(callframe1155);
// compiled call node returning call1159 (depth = 8)
  gc_frame_newslot(call1159);
// Begin line 823
  setline(823);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_Collection (depth = 8)
  gc_frame_newslot(*var_Collection);
// call case 6: other member request
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1160 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call1161 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1160);
// compiled call node returning call1161 (depth = 9)
// compiled member node returning call1161 (depth = 8)
  params[0] = call1159;
  params[1] = *var_Collection;
  partcv[0] = 2;
  Object call1162 = callmethod(call1161, "new",
    1, partcv, params);
  gc_frame_end(callframe1154);
// compiled call node returning call1162 (depth = 7)
((struct UserObject *)block1116)->data[1] = call1162;
// compiled block node returning block1116 (depth = 6)
  gc_frame_newslot(block1116);
// Begin line 833
  setline(833);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 6)
  Object block1163 = alloc_Block(NULL, NULL, "collectionsPrelude", 833);
  gc_frame_newslot(block1163);
// method _apply
  block_savedest(block1163);
  Object closure1164 = createclosure(1, "_apply");
  setclosureframe(closure1164, stackframe);
  addtoclosure(closure1164, selfslot);
  struct UserObject *uo1164 = (struct UserObject*)block1163;
  uo1164->data[0] = (Object)closure1164;
  Method *meth_meth_collectionsPrelude__apply1164 = addmethod2pos(block1163, "_apply", &meth_collectionsPrelude__apply1164, 0);
  int argcv_meth_collectionsPrelude__apply1164[] = {1};
  meth_meth_collectionsPrelude__apply1164->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1164);
  meth_meth_collectionsPrelude__apply1164->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1164->definitionLine = 0;
// compiled block node returning block1163 (depth = 6)
  gc_frame_newslot(block1163);
  params[0] = block1116;
  params[1] = block1163;
  Object matchres1115 = matchCase(*var_other, params, 2,NULL);
  gc_frame_end(frame1115);
// compiled matchcase node returning matchres1115 (depth = 5)
  gc_frame_end(frame);
  return matchres1115;
}
Object meth_collectionsPrelude_asDebugString1172(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asDebugString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asDebugString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 842
  setline(842);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1174 == NULL) {
    strlit1174 = alloc_String("""\xe2""""\x9f""""\xab""");
    gc_root(strlit1174);
  }
// compiled string node returning strlit1174 (depth = 6)
  int op_slot_right_1173 = gc_frame_newslot(strlit1174);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1177 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1178 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1177);
// compiled call node returning call1178 (depth = 8)
// compiled member node returning call1178 (depth = 7)
  int op_slot_right_1176 = gc_frame_newslot(call1178);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1181 == NULL) {
    strlit1181 = alloc_String("""\xe2""""\x9f""""\xaa""");
    gc_root(strlit1181);
  }
// compiled string node returning strlit1181 (depth = 8)
  int op_slot_right_1180 = gc_frame_newslot(strlit1181);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1184 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1185 = callmethodflags(self, "asString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1184);
// compiled call node returning call1185 (depth = 10)
// compiled member node returning call1185 (depth = 9)
  int op_slot_right_1183 = gc_frame_newslot(call1185);
// starting to compile string node (depth = 9)
  if (strlit1187 == NULL) {
    strlit1187 = alloc_String("");
    gc_root(strlit1187);
  }
// compiled string node returning strlit1187 (depth = 9)
  int op_slot_left_1183 = gc_frame_newslot(strlit1187);
  params[0] = call1185;
  partcv[0] = 1;
  Object opresult1188 = callmethod(strlit1187, "++", 1, partcv, params);
// compiled op node returning opresult1188 (depth = 8)
  int op_slot_left_1180 = gc_frame_newslot(opresult1188);
  params[0] = strlit1181;
  partcv[0] = 1;
  Object opresult1189 = callmethod(opresult1188, "++", 1, partcv, params);
// compiled op node returning opresult1189 (depth = 7)
  int op_slot_left_1176 = gc_frame_newslot(opresult1189);
  params[0] = call1178;
  partcv[0] = 1;
  Object opresult1190 = callmethod(opresult1189, "++", 1, partcv, params);
// compiled op node returning opresult1190 (depth = 6)
  int op_slot_left_1173 = gc_frame_newslot(opresult1190);
  params[0] = strlit1174;
  partcv[0] = 1;
  Object opresult1191 = callmethod(opresult1190, "++", 1, partcv, params);
// compiled op node returning opresult1191 (depth = 5)
  gc_frame_end(frame);
  return opresult1191;
}
Object meth_collectionsPrelude_asString1192(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 843
  setline(843);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit1193 == NULL) {
    strlit1193 = alloc_String("aListIterator");
    gc_root(strlit1193);
  }
// compiled string node returning strlit1193 (depth = 5)
  gc_frame_end(frame);
  return strlit1193;
}
Object meth_collectionsPrelude_hasNext1194(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for hasNext (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for hasNext");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 844
  setline(844);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1196 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1197 = gc_frame_new();
// call case 3: self.outer request
  Object call1198 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1197);
// compiled call node returning call1198 (depth = 9)
// compiled member node returning call1198 (depth = 8)
  partcv[0] = 0;
  Object call1199 = callmethodflags(call1198, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1196);
// compiled call node returning call1199 (depth = 7)
// compiled member node returning call1199 (depth = 6)
  int op_slot_right_1195 = gc_frame_newslot(call1199);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1201 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1202 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1201);
// compiled call node returning call1202 (depth = 7)
// compiled member node returning call1202 (depth = 6)
  int op_slot_left_1195 = gc_frame_newslot(call1202);
  params[0] = call1199;
  partcv[0] = 1;
  Object opresult1203 = callmethod(call1202, "<=", 1, partcv, params);
// compiled op node returning opresult1203 (depth = 5)
  gc_frame_end(frame);
  return opresult1203;
}
Object meth_collectionsPrelude_next1204(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_Exhausted = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for next (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for next");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ret = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "ret");
// Begin line 846
  setline(846);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1207 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1208 = gc_frame_new();
// call case 3: self.outer request
  Object call1209 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1208);
// compiled call node returning call1209 (depth = 10)
// compiled member node returning call1209 (depth = 9)
  partcv[0] = 0;
  Object call1210 = callmethodflags(call1209, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1207);
// compiled call node returning call1210 (depth = 8)
// compiled member node returning call1210 (depth = 7)
  int op_slot_right_1206 = gc_frame_newslot(call1210);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1212 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1213 = callmethodflags(self, "imods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1212);
// compiled call node returning call1213 (depth = 8)
// compiled member node returning call1213 (depth = 7)
  int op_slot_left_1206 = gc_frame_newslot(call1213);
  params[0] = call1210;
  partcv[0] = 1;
  Object opresult1214 = callmethod(call1213, "!=", 1, partcv, params);
// compiled op node returning opresult1214 (depth = 6)
  Object if1205 = done;
  if (istrue(opresult1214)) {
// Begin line 847
  setline(847);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1215 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1216 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1217 = callmethodflags(self, "asDebugString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1216);
// compiled call node returning call1217 (depth = 8)
// compiled member node returning call1217 (depth = 7)
  gc_frame_newslot(call1217);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ConcurrentModification (depth = 7)
  params[0] = call1217;
  partcv[0] = 1;
  Object call1218 = callmethod(*var_ConcurrentModification, "raise",
    1, partcv, params);
  gc_frame_end(callframe1215);
// compiled call node returning call1218 (depth = 6)
    gc_frame_newslot(call1218);
    if1205 = call1218;
  } else {
  }
// compiled if node returning if1205 (depth = 5)
// Begin line 849
  setline(849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1221 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1222 = gc_frame_new();
// call case 3: self.outer request
  Object call1223 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1222);
// compiled call node returning call1223 (depth = 10)
// compiled member node returning call1223 (depth = 9)
  partcv[0] = 0;
  Object call1224 = callmethodflags(call1223, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1221);
// compiled call node returning call1224 (depth = 8)
// compiled member node returning call1224 (depth = 7)
  int op_slot_right_1220 = gc_frame_newslot(call1224);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1226 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1227 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1226);
// compiled call node returning call1227 (depth = 8)
// compiled member node returning call1227 (depth = 7)
  int op_slot_left_1220 = gc_frame_newslot(call1227);
  params[0] = call1224;
  partcv[0] = 1;
  Object opresult1228 = callmethod(call1227, ">", 1, partcv, params);
// compiled op node returning opresult1228 (depth = 6)
  Object if1219 = done;
  if (istrue(opresult1228)) {
// starting to compile call node (depth = 6)
  int callframe1229 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit1230 == NULL) {
    strlit1230 = alloc_String("on list");
    gc_root(strlit1230);
  }
// compiled string node returning strlit1230 (depth = 7)
  gc_frame_newslot(strlit1230);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Exhausted (depth = 7)
  params[0] = strlit1230;
  partcv[0] = 1;
  Object call1231 = callmethod(*var_Exhausted, "raise",
    1, partcv, params);
  gc_frame_end(callframe1229);
// compiled call node returning call1231 (depth = 6)
    gc_frame_newslot(call1231);
    if1219 = call1231;
  } else {
  }
// compiled if node returning if1219 (depth = 5)
// Begin line 850
  setline(850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1232 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1233 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1234 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1233);
// compiled call node returning call1234 (depth = 8)
// compiled member node returning call1234 (depth = 7)
  gc_frame_newslot(call1234);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1235 = gc_frame_new();
// call case 3: self.outer request
  Object call1236 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1235);
// compiled call node returning call1236 (depth = 8)
// compiled member node returning call1236 (depth = 7)
  params[0] = call1234;
  partcv[0] = 1;
  Object call1237 = callmethodflags(call1236, "at", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1232);
// compiled call node returning call1237 (depth = 6)
  *var_ret = call1237;
  if (call1237 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 851
  setline(851);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 850
  setline(850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1238 = gc_frame_new();
// Begin line 851
  setline(851);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1240 = alloc_Float64(1);
// compiled num node returning num1240 (depth = 8)
  int op_slot_right_1239 = gc_frame_newslot(num1240);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1242 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1243 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1242);
// compiled call node returning call1243 (depth = 9)
// compiled member node returning call1243 (depth = 8)
  int op_slot_left_1239 = gc_frame_newslot(call1243);
  params[0] = num1240;
  partcv[0] = 1;
  Object sum1244 = callmethod(call1243, "+", 1, partcv, params);
// compiled op node returning sum1244 (depth = 7)
  gc_frame_newslot(sum1244);
// call case 4: self request
  params[0] = sum1244;
  partcv[0] = 1;
  Object call1245 = callmethodflags(self, "idx:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1238);
// compiled call node returning call1245 (depth = 6)
// compiled bind node returning done (depth = 5)
// Begin line 852
  setline(852);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ret (depth = 5)
  gc_frame_end(frame);
  return *var_ret;
}
Object meth_collectionsPrelude_iterator1167(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 33, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_Exhausted = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1168 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1168 = alloc_userobj2(8,7, objclass1168);
  gc_frame_newslot(obj1168);
if (objclass1168 == NULL) {
  glfree(obj1168->class->name);
  obj1168->class->name = "obj771.iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1168, self, 0);
  addmethodreal(obj1168,"outer", &reader_collectionsPrelude_outer_1169);
  Object oldself1168 = self;
  struct StackFrameObject *oldstackframe1168 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1168);
  gc_frame_newslot((Object)stackframe);
  self = obj1168;
  Object *oldselfslot1168 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1168 = (*(struct UserObject *)self).data[0], lowerouter1168 = thisouter1168;
  if (inheritingObject1168) {
    struct UserObject *inho1168 = (struct UserObject *)inheritingObject1168;
    while (inho1168->super != GraceDefaultObject) inho1168 = (struct UserObject *)inho1168->super;
    inho1168->super = obj1168;
    self = inheritingObject1168;
    *selfslot = self;
    lowerouter1168 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1168;
  }
if (objclass1168 == NULL) {
  Method *reader1170 = addmethodrealflags(obj1168, "imods",&reader_collectionsPrelude_imods_1170, MFLAG_CONFIDENTIAL);
  Method *writer1170 = addmethodrealflags(obj1168, "imods:=",&writer_collectionsPrelude_imods_1170, MFLAG_CONFIDENTIAL);
  reader1170->definitionModule = modulename;
  writer1170->definitionModule = modulename;
  reader1170->definitionLine = 840;
  writer1170->definitionLine = 840;
}
obj1168->flags |= OFLAG_MUTABLE;
adddatum2(obj1168, alloc_Undefined(), 1);
if (objclass1168 == NULL) {
  Method *reader1171 = addmethodrealflags(obj1168, "idx",&reader_collectionsPrelude_idx_1171, MFLAG_CONFIDENTIAL);
  Method *writer1171 = addmethodrealflags(obj1168, "idx:=",&writer_collectionsPrelude_idx_1171, MFLAG_CONFIDENTIAL);
  reader1171->definitionModule = modulename;
  writer1171->definitionModule = modulename;
  reader1171->definitionLine = 841;
  writer1171->definitionLine = 841;
}
obj1168->flags |= OFLAG_MUTABLE;
adddatum2(obj1168, alloc_Undefined(), 2);
// method asDebugString
  struct UserObject *uo1172 = (struct UserObject*)obj1168;
  uo1172->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDebugString1172 = addmethod2pos(obj1168, "asDebugString", &meth_collectionsPrelude_asDebugString1172, 3);
  int argcv_meth_collectionsPrelude_asDebugString1172[] = {0};
  meth_meth_collectionsPrelude_asDebugString1172->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString1172);
  meth_meth_collectionsPrelude_asDebugString1172->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString1172->definitionLine = 842;
// method asString
  struct UserObject *uo1192 = (struct UserObject*)obj1168;
  uo1192->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString1192 = addmethod2pos(obj1168, "asString", &meth_collectionsPrelude_asString1192, 4);
  int argcv_meth_collectionsPrelude_asString1192[] = {0};
  meth_meth_collectionsPrelude_asString1192->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString1192);
  meth_meth_collectionsPrelude_asString1192->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString1192->definitionLine = 843;
// method hasNext
  struct UserObject *uo1194 = (struct UserObject*)obj1168;
  uo1194->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext1194 = addmethod2pos(obj1168, "hasNext", &meth_collectionsPrelude_hasNext1194, 5);
  int argcv_meth_collectionsPrelude_hasNext1194[] = {0};
  meth_meth_collectionsPrelude_hasNext1194->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext1194);
  meth_meth_collectionsPrelude_hasNext1194->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext1194->definitionLine = 844;
// method next
  block_savedest(obj1168);
  Object closure1204 = createclosure(2, "next");
  setclosureframe(closure1204, stackframe);
  addtoclosure(closure1204, var_ConcurrentModification);
  addtoclosure(closure1204, var_Exhausted);
  struct UserObject *uo1204 = (struct UserObject*)obj1168;
  uo1204->data[6] = (Object)closure1204;
  Method *meth_meth_collectionsPrelude_next1204 = addmethod2pos(obj1168, "next", &meth_collectionsPrelude_next1204, 6);
  int argcv_meth_collectionsPrelude_next1204[] = {0};
  meth_meth_collectionsPrelude_next1204->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next1204);
  meth_meth_collectionsPrelude_next1204->definitionModule = modulename;
  meth_meth_collectionsPrelude_next1204->definitionLine = 845;
  sourceObject = obj1168;
// Begin line 840
  setline(840);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1246 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1247 = gc_frame_new();
// call case 3: self.outer request
  Object call1248 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1247);
// compiled call node returning call1248 (depth = 8)
// compiled member node returning call1248 (depth = 7)
  partcv[0] = 0;
  Object call1249 = callmethodflags(call1248, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1246);
// compiled call node returning call1249 (depth = 6)
// compiled member node returning call1249 (depth = 5)
  adddatum2(obj1168, call1249, 1);
  sourceObject = obj1168;
// Begin line 841
  setline(841);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num1250 = alloc_Float64(1);
// compiled num node returning num1250 (depth = 5)
  adddatum2(obj1168, num1250, 2);
  sourceObject = obj1168;
  sourceObject = obj1168;
  sourceObject = obj1168;
  sourceObject = obj1168;
  objclass1168 = obj1168->class;
  objclass1168->definitionModule = modulename;
  objclass1168->definitionLine = 839;
  (*(struct UserObject *)self).data[0] = lowerouter1168;
  self = oldself1168;
  selfslot = oldselfslot1168;
  stackframe = oldstackframe1168;
  gc_frame_end(frame);
  return obj1168;
}
Object meth_collectionsPrelude_iterator1167_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 33, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_Exhausted = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1168 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1168 = alloc_userobj2(8,7, objclass1168);
  gc_frame_newslot(obj1168);
if (objclass1168 == NULL) {
  glfree(obj1168->class->name);
  obj1168->class->name = "obj771.iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1168, self, 0);
  addmethodreal(obj1168,"outer", &reader_collectionsPrelude_outer_1169);
  Object oldself1168 = self;
  struct StackFrameObject *oldstackframe1168 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1168);
  gc_frame_newslot((Object)stackframe);
  self = obj1168;
  Object *oldselfslot1168 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1168 = (*(struct UserObject *)self).data[0], lowerouter1168 = thisouter1168;
  if (inheritingObject1168) {
    struct UserObject *inho1168 = (struct UserObject *)inheritingObject1168;
    while (inho1168->super != GraceDefaultObject) inho1168 = (struct UserObject *)inho1168->super;
    inho1168->super = obj1168;
    self = inheritingObject1168;
    *selfslot = self;
    lowerouter1168 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1168;
  }
if (objclass1168 == NULL) {
  Method *reader1170 = addmethodrealflags(obj1168, "imods",&reader_collectionsPrelude_imods_1170, MFLAG_CONFIDENTIAL);
  Method *writer1170 = addmethodrealflags(obj1168, "imods:=",&writer_collectionsPrelude_imods_1170, MFLAG_CONFIDENTIAL);
  reader1170->definitionModule = modulename;
  writer1170->definitionModule = modulename;
  reader1170->definitionLine = 840;
  writer1170->definitionLine = 840;
}
obj1168->flags |= OFLAG_MUTABLE;
adddatum2(obj1168, alloc_Undefined(), 1);
if (objclass1168 == NULL) {
  Method *reader1171 = addmethodrealflags(obj1168, "idx",&reader_collectionsPrelude_idx_1171, MFLAG_CONFIDENTIAL);
  Method *writer1171 = addmethodrealflags(obj1168, "idx:=",&writer_collectionsPrelude_idx_1171, MFLAG_CONFIDENTIAL);
  reader1171->definitionModule = modulename;
  writer1171->definitionModule = modulename;
  reader1171->definitionLine = 841;
  writer1171->definitionLine = 841;
}
obj1168->flags |= OFLAG_MUTABLE;
adddatum2(obj1168, alloc_Undefined(), 2);
// method asDebugString
  struct UserObject *uo1172 = (struct UserObject*)obj1168;
  uo1172->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDebugString1172 = addmethod2pos(obj1168, "asDebugString", &meth_collectionsPrelude_asDebugString1172, 3);
  int argcv_meth_collectionsPrelude_asDebugString1172[] = {0};
  meth_meth_collectionsPrelude_asDebugString1172->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString1172);
  meth_meth_collectionsPrelude_asDebugString1172->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString1172->definitionLine = 842;
// method asString
  struct UserObject *uo1192 = (struct UserObject*)obj1168;
  uo1192->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString1192 = addmethod2pos(obj1168, "asString", &meth_collectionsPrelude_asString1192, 4);
  int argcv_meth_collectionsPrelude_asString1192[] = {0};
  meth_meth_collectionsPrelude_asString1192->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString1192);
  meth_meth_collectionsPrelude_asString1192->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString1192->definitionLine = 843;
// method hasNext
  struct UserObject *uo1194 = (struct UserObject*)obj1168;
  uo1194->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext1194 = addmethod2pos(obj1168, "hasNext", &meth_collectionsPrelude_hasNext1194, 5);
  int argcv_meth_collectionsPrelude_hasNext1194[] = {0};
  meth_meth_collectionsPrelude_hasNext1194->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext1194);
  meth_meth_collectionsPrelude_hasNext1194->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext1194->definitionLine = 844;
// method next
  block_savedest(obj1168);
  Object closure1204 = createclosure(2, "next");
  setclosureframe(closure1204, stackframe);
  addtoclosure(closure1204, var_ConcurrentModification);
  addtoclosure(closure1204, var_Exhausted);
  struct UserObject *uo1204 = (struct UserObject*)obj1168;
  uo1204->data[6] = (Object)closure1204;
  Method *meth_meth_collectionsPrelude_next1204 = addmethod2pos(obj1168, "next", &meth_collectionsPrelude_next1204, 6);
  int argcv_meth_collectionsPrelude_next1204[] = {0};
  meth_meth_collectionsPrelude_next1204->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next1204);
  meth_meth_collectionsPrelude_next1204->definitionModule = modulename;
  meth_meth_collectionsPrelude_next1204->definitionLine = 845;
  sourceObject = obj1168;
// Begin line 840
  setline(840);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1246 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1247 = gc_frame_new();
// call case 3: self.outer request
  Object call1248 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1247);
// compiled call node returning call1248 (depth = 8)
// compiled member node returning call1248 (depth = 7)
  partcv[0] = 0;
  Object call1249 = callmethodflags(call1248, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1246);
// compiled call node returning call1249 (depth = 6)
// compiled member node returning call1249 (depth = 5)
  adddatum2(obj1168, call1249, 1);
  sourceObject = obj1168;
// Begin line 841
  setline(841);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num1250 = alloc_Float64(1);
// compiled num node returning num1250 (depth = 5)
  adddatum2(obj1168, num1250, 2);
  sourceObject = obj1168;
  sourceObject = obj1168;
  sourceObject = obj1168;
  sourceObject = obj1168;
  objclass1168 = obj1168->class;
  objclass1168->definitionModule = modulename;
  objclass1168->definitionLine = 839;
  (*(struct UserObject *)self).data[0] = lowerouter1168;
  self = oldself1168;
  selfslot = oldselfslot1168;
  stackframe = oldstackframe1168;
  gc_frame_end(frame);
  return obj1168;
}
Object meth_collectionsPrelude_values1252(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "values");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for values (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for values");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 858
  setline(858);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_keys1253(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keys");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for keys (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for keys");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 862
  setline(862);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1254 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1255 = callmethodflags(self, "indices", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1254);
// compiled call node returning call1255 (depth = 6)
// compiled member node returning call1255 (depth = 5)
  gc_frame_end(frame);
  return call1255;
}
Object meth_collectionsPrelude__apply1267(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  Object *var_r = &(stackframe->slots[1]);
  *var_r = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 868
  setline(868);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_r (depth = 9)
  int op_slot_right_1269 = gc_frame_newslot(*var_r);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_l (depth = 9)
  int op_slot_left_1269 = gc_frame_newslot(*var_l);
  params[0] = *var_r;
  partcv[0] = 1;
  Object opresult1271 = callmethod(*var_l, "==", 1, partcv, params);
// compiled op node returning opresult1271 (depth = 8)
  Object if1268 = done;
  if (istrue(opresult1271)) {
// starting to compile num node (depth = 8)
  Object num1272 = alloc_Float64(0);
// compiled num node returning num1272 (depth = 8)
    gc_frame_newslot(num1272);
    if1268 = num1272;
  } else {
// Begin line 870
  setline(870);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 869
  setline(869);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_r (depth = 10)
  int op_slot_right_1274 = gc_frame_newslot(*var_r);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_l (depth = 10)
  int op_slot_left_1274 = gc_frame_newslot(*var_l);
  params[0] = *var_r;
  partcv[0] = 1;
  Object opresult1276 = callmethod(*var_l, "<", 1, partcv, params);
// compiled op node returning opresult1276 (depth = 9)
  Object if1273 = done;
  if (istrue(opresult1276)) {
// starting to compile call node (depth = 9)
  int callframe1277 = gc_frame_new();
// call case 6: other member request
// starting to compile num node (depth = 10)
  Object num1278 = alloc_Float64(1);
// compiled num node returning num1278 (depth = 10)
  partcv[0] = 0;
  Object call1279 = callmethod(num1278, "prefix-",
    1, partcv, params);
  gc_frame_end(callframe1277);
// compiled call node returning call1279 (depth = 9)
    gc_frame_newslot(call1279);
    if1273 = call1279;
  } else {
// Begin line 870
  setline(870);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 9)
  Object num1280 = alloc_Float64(1);
// compiled num node returning num1280 (depth = 9)
    gc_frame_newslot(num1280);
    if1273 = num1280;
  }
// compiled if node returning if1273 (depth = 8)
    gc_frame_newslot(if1273);
    if1268 = if1273;
  }
// compiled if node returning if1268 (depth = 7)
  gc_frame_end(frame);
  return if1268;
}
Object meth_collectionsPrelude_sort1256(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sort");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for sort (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for sort");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 866
  setline(866);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 862
  setline(862);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1257 = gc_frame_new();
// Begin line 866
  setline(866);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1259 = alloc_Float64(1);
// compiled num node returning num1259 (depth = 8)
  int op_slot_right_1258 = gc_frame_newslot(num1259);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1261 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1262 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1261);
// compiled call node returning call1262 (depth = 9)
// compiled member node returning call1262 (depth = 8)
  int op_slot_left_1258 = gc_frame_newslot(call1262);
  params[0] = num1259;
  partcv[0] = 1;
  Object sum1263 = callmethod(call1262, "+", 1, partcv, params);
// compiled op node returning sum1263 (depth = 7)
  gc_frame_newslot(sum1263);
// call case 4: self request
  params[0] = sum1263;
  partcv[0] = 1;
  Object call1264 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1257);
// compiled call node returning call1264 (depth = 6)
// compiled bind node returning done (depth = 5)
// Begin line 867
  setline(867);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1265 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block1266 = alloc_Block(NULL, NULL, "collectionsPrelude", 867);
  gc_frame_newslot(block1266);
// method _apply
  block_savedest(block1266);
  Object closure1267 = createclosure(1, "_apply");
  setclosureframe(closure1267, stackframe);
  addtoclosure(closure1267, selfslot);
  struct UserObject *uo1267 = (struct UserObject*)block1266;
  uo1267->data[0] = (Object)closure1267;
  Method *meth_meth_collectionsPrelude__apply1267 = addmethod2pos(block1266, "_apply", &meth_collectionsPrelude__apply1267, 0);
  int argcv_meth_collectionsPrelude__apply1267[] = {2};
  meth_meth_collectionsPrelude__apply1267->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1267);
  meth_meth_collectionsPrelude__apply1267->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1267->definitionLine = 866;
// compiled block node returning block1266 (depth = 6)
  gc_frame_newslot(block1266);
// call case 4: self request
  params[0] = block1266;
  partcv[0] = 1;
  Object call1282 = callmethodflags(self, "sortBy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1265);
// compiled call node returning call1282 (depth = 5)
  gc_frame_end(frame);
  return call1282;
}
Object meth_collectionsPrelude_sortedBy1283(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sortedBy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method sortedBy");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for sortedBy (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_sortBlock = &(stackframe->slots[0]);
  *var_sortBlock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for sortedBy");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 874
  setline(874);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1284 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sortBlock (depth = 6)
  gc_frame_newslot(*var_sortBlock);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1285 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1286 = callmethodflags(self, "copy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1285);
// compiled call node returning call1286 (depth = 7)
// compiled member node returning call1286 (depth = 6)
  params[0] = *var_sortBlock;
  partcv[0] = 1;
  Object call1287 = callmethod(call1286, "sortBy",
    1, partcv, params);
  gc_frame_end(callframe1284);
// compiled call node returning call1287 (depth = 5)
  gc_frame_end(frame);
  return call1287;
}
Object meth_collectionsPrelude_sorted1288(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sorted");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for sorted (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for sorted");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 877
  setline(877);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1289 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1290 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1291 = callmethodflags(self, "copy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1290);
// compiled call node returning call1291 (depth = 8)
// compiled member node returning call1291 (depth = 7)
  partcv[0] = 0;
  Object call1292 = callmethod(call1291, "sort",
    1, partcv, params);
  gc_frame_end(callframe1289);
// compiled call node returning call1292 (depth = 6)
// compiled member node returning call1292 (depth = 5)
  gc_frame_end(frame);
  return call1292;
}
Object meth_collectionsPrelude_copy1293(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "copy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for copy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for copy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 880
  setline(880);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1294 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1295 = gc_frame_new();
// call case 3: self.outer request
  Object call1296 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1295);
// compiled call node returning call1296 (depth = 7)
// compiled member node returning call1296 (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call1297 = callmethodflags(call1296, "withAll", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1294);
// compiled call node returning call1297 (depth = 5)
  gc_frame_end(frame);
  return call1297;
}
Object meth_collectionsPrelude__apply1304(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 603
  setline(603);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
// compiled call node returning done (depth = 7)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_boundsCheck1313(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "boundsCheck");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method boundsCheck");
  Object params[1];
  int partcv[1];
  Object *var_BoundsError = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for boundsCheck (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for boundsCheck");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 900
  setline(900);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1316 = gc_frame_new();
// call case 6: other member request
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1318 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1319 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1318);
// compiled call node returning call1319 (depth = 7)
// compiled member node returning call1319 (depth = 6)
  int op_slot_right_1317 = gc_frame_newslot(call1319);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  int op_slot_left_1317 = gc_frame_newslot(*var_n);
  params[0] = call1319;
  partcv[0] = 1;
  Object opresult1321 = callmethod(*var_n, "<=", 1, partcv, params);
// compiled op node returning opresult1321 (depth = 5)
  partcv[0] = 0;
  Object call1322 = callmethod(opresult1321, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe1316);
// compiled call node returning call1322 (depth = 4)
  int op_slot_right_1315 = gc_frame_newslot(call1322);
// starting to compile call node (depth = 4)
  int callframe1324 = gc_frame_new();
// call case 6: other member request
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1326 = alloc_Float64(1);
// compiled num node returning num1326 (depth = 6)
  int op_slot_right_1325 = gc_frame_newslot(num1326);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  int op_slot_left_1325 = gc_frame_newslot(*var_n);
  params[0] = num1326;
  partcv[0] = 1;
  Object opresult1328 = callmethod(*var_n, ">=", 1, partcv, params);
// compiled op node returning opresult1328 (depth = 5)
  partcv[0] = 0;
  Object call1329 = callmethod(opresult1328, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe1324);
// compiled call node returning call1329 (depth = 4)
  int op_slot_left_1315 = gc_frame_newslot(call1329);
  params[0] = call1322;
  partcv[0] = 1;
  Object opresult1330 = callmethod(call1329, "||", 1, partcv, params);
// compiled op node returning opresult1330 (depth = 3)
  Object if1314 = done;
  if (istrue(opresult1330)) {
// Begin line 901
  setline(901);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1331 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1333 == NULL) {
    strlit1333 = alloc_String("");
    gc_root(strlit1333);
  }
// compiled string node returning strlit1333 (depth = 5)
  int op_slot_right_1332 = gc_frame_newslot(strlit1333);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1336 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1337 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1336);
// compiled call node returning call1337 (depth = 7)
// compiled member node returning call1337 (depth = 6)
  int op_slot_right_1335 = gc_frame_newslot(call1337);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1340 == NULL) {
    strlit1340 = alloc_String(" out of bounds 1..");
    gc_root(strlit1340);
  }
// compiled string node returning strlit1340 (depth = 7)
  int op_slot_right_1339 = gc_frame_newslot(strlit1340);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  int op_slot_right_1342 = gc_frame_newslot(*var_n);
// starting to compile string node (depth = 8)
  if (strlit1344 == NULL) {
    strlit1344 = alloc_String("index ");
    gc_root(strlit1344);
  }
// compiled string node returning strlit1344 (depth = 8)
  int op_slot_left_1342 = gc_frame_newslot(strlit1344);
  params[0] = *var_n;
  partcv[0] = 1;
  Object opresult1345 = callmethod(strlit1344, "++", 1, partcv, params);
// compiled op node returning opresult1345 (depth = 7)
  int op_slot_left_1339 = gc_frame_newslot(opresult1345);
  params[0] = strlit1340;
  partcv[0] = 1;
  Object opresult1346 = callmethod(opresult1345, "++", 1, partcv, params);
// compiled op node returning opresult1346 (depth = 6)
  int op_slot_left_1335 = gc_frame_newslot(opresult1346);
  params[0] = call1337;
  partcv[0] = 1;
  Object opresult1347 = callmethod(opresult1346, "++", 1, partcv, params);
// compiled op node returning opresult1347 (depth = 5)
  int op_slot_left_1332 = gc_frame_newslot(opresult1347);
  params[0] = strlit1333;
  partcv[0] = 1;
  Object opresult1348 = callmethod(opresult1347, "++", 1, partcv, params);
// compiled op node returning opresult1348 (depth = 4)
  gc_frame_newslot(opresult1348);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_BoundsError (depth = 4)
  params[0] = opresult1348;
  partcv[0] = 1;
  Object call1349 = callmethod(*var_BoundsError, "raise",
    1, partcv, params);
  gc_frame_end(callframe1331);
// compiled call node returning call1349 (depth = 3)
    gc_frame_newslot(call1349);
    if1314 = call1349;
  } else {
  }
// compiled if node returning if1314 (depth = 2)
  gc_frame_end(frame);
  return if1314;
}
Object meth_collectionsPrelude_at1350(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "at");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method at");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for at (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for at");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 905
  setline(905);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1351 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_n (depth = 3)
  gc_frame_newslot(*var_n);
// call case 4: self request
  params[0] = *var_n;
  partcv[0] = 1;
  Object call1352 = callmethodflags(self, "boundsCheck", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1351);
// compiled call node returning call1352 (depth = 2)
// Begin line 906
  setline(906);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1353 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1355 = alloc_Float64(1);
// compiled num node returning num1355 (depth = 4)
  int op_slot_right_1354 = gc_frame_newslot(num1355);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  int op_slot_left_1354 = gc_frame_newslot(*var_n);
  params[0] = num1355;
  partcv[0] = 1;
  Object diff1357 = callmethod(*var_n, "-", 1, partcv, params);
// compiled op node returning diff1357 (depth = 3)
  gc_frame_newslot(diff1357);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1358 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1359 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1358);
// compiled call node returning call1359 (depth = 4)
// compiled member node returning call1359 (depth = 3)
  params[0] = diff1357;
  partcv[0] = 1;
  Object call1360 = callmethod(call1359, "at",
    1, partcv, params);
  gc_frame_end(callframe1353);
// compiled call node returning call1360 (depth = 2)
  gc_frame_end(frame);
  return call1360;
}
Object meth_collectionsPrelude__91__93_1361(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "[]");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method []");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for [] (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for [");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 909
  setline(909);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1362 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_n (depth = 3)
  gc_frame_newslot(*var_n);
// call case 4: self request
  params[0] = *var_n;
  partcv[0] = 1;
  Object call1363 = callmethodflags(self, "boundsCheck", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1362);
// compiled call node returning call1363 (depth = 2)
// Begin line 910
  setline(910);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1364 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1366 = alloc_Float64(1);
// compiled num node returning num1366 (depth = 4)
  int op_slot_right_1365 = gc_frame_newslot(num1366);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  int op_slot_left_1365 = gc_frame_newslot(*var_n);
  params[0] = num1366;
  partcv[0] = 1;
  Object diff1368 = callmethod(*var_n, "-", 1, partcv, params);
// compiled op node returning diff1368 (depth = 3)
  gc_frame_newslot(diff1368);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1369 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1370 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1369);
// compiled call node returning call1370 (depth = 4)
// compiled member node returning call1370 (depth = 3)
  params[0] = diff1368;
  partcv[0] = 1;
  Object call1371 = callmethod(call1370, "at",
    1, partcv, params);
  gc_frame_end(callframe1364);
// compiled call node returning call1371 (depth = 2)
  gc_frame_end(frame);
  return call1371;
}
Object meth_collectionsPrelude_at_40__41_put1372(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "at()put");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method at()put");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method at()put");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for at()put (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for at");
  Object *var_x = &(stackframe->slots[1]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for put");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 913
  setline(913);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 910
  setline(910);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1373 = gc_frame_new();
// Begin line 913
  setline(913);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1375 = alloc_Float64(1);
// compiled num node returning num1375 (depth = 5)
  int op_slot_right_1374 = gc_frame_newslot(num1375);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1377 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1378 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1377);
// compiled call node returning call1378 (depth = 6)
// compiled member node returning call1378 (depth = 5)
  int op_slot_left_1374 = gc_frame_newslot(call1378);
  params[0] = num1375;
  partcv[0] = 1;
  Object sum1379 = callmethod(call1378, "+", 1, partcv, params);
// compiled op node returning sum1379 (depth = 4)
  gc_frame_newslot(sum1379);
// call case 4: self request
  params[0] = sum1379;
  partcv[0] = 1;
  Object call1380 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1373);
// compiled call node returning call1380 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 914
  setline(914);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1384 = alloc_Float64(1);
// compiled num node returning num1384 (depth = 5)
  int op_slot_right_1383 = gc_frame_newslot(num1384);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1386 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1387 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1386);
// compiled call node returning call1387 (depth = 6)
// compiled member node returning call1387 (depth = 5)
  int op_slot_left_1383 = gc_frame_newslot(call1387);
  params[0] = num1384;
  partcv[0] = 1;
  Object sum1388 = callmethod(call1387, "+", 1, partcv, params);
// compiled op node returning sum1388 (depth = 4)
  int op_slot_right_1382 = gc_frame_newslot(sum1388);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  int op_slot_left_1382 = gc_frame_newslot(*var_n);
  params[0] = sum1388;
  partcv[0] = 1;
  Object opresult1390 = callmethod(*var_n, "==", 1, partcv, params);
// compiled op node returning opresult1390 (depth = 3)
  Object if1381 = done;
  if (istrue(opresult1390)) {
// Begin line 915
  setline(915);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1391 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_x (depth = 4)
  gc_frame_newslot(*var_x);
// call case 4: self request
  params[0] = *var_x;
  partcv[0] = 1;
  Object call1392 = callmethodflags(self, "addLast", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1391);
// compiled call node returning call1392 (depth = 3)
    gc_frame_newslot(call1392);
    if1381 = call1392;
  } else {
// Begin line 917
  setline(917);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1393 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// call case 4: self request
  params[0] = *var_n;
  partcv[0] = 1;
  Object call1394 = callmethodflags(self, "boundsCheck", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1393);
// compiled call node returning call1394 (depth = 3)
// Begin line 918
  setline(918);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1395 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1397 = alloc_Float64(1);
// compiled num node returning num1397 (depth = 5)
  int op_slot_right_1396 = gc_frame_newslot(num1397);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  int op_slot_left_1396 = gc_frame_newslot(*var_n);
  params[0] = num1397;
  partcv[0] = 1;
  Object diff1399 = callmethod(*var_n, "-", 1, partcv, params);
// compiled op node returning diff1399 (depth = 4)
  gc_frame_newslot(diff1399);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_x (depth = 4)
  gc_frame_newslot(*var_x);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1400 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1401 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1400);
// compiled call node returning call1401 (depth = 5)
// compiled member node returning call1401 (depth = 4)
  params[0] = diff1399;
  params[1] = *var_x;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1402 = callmethod(call1401, "at()put",
    2, partcv, params);
  gc_frame_end(callframe1395);
// compiled call node returning call1402 (depth = 3)
    gc_frame_newslot(call1402);
    if1381 = call1402;
  }
// compiled if node returning if1381 (depth = 2)
// Begin line 920
  setline(920);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__91__93__58__61_1403(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "[]:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method []:=");
  Object params[2];
  int partcv[2];
  Object *var_done = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for []:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  Object *var_x = &(stackframe->slots[1]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for [:=");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 923
  setline(923);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 918
  setline(918);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1404 = gc_frame_new();
// Begin line 923
  setline(923);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1406 = alloc_Float64(1);
// compiled num node returning num1406 (depth = 5)
  int op_slot_right_1405 = gc_frame_newslot(num1406);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1408 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1409 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1408);
// compiled call node returning call1409 (depth = 6)
// compiled member node returning call1409 (depth = 5)
  int op_slot_left_1405 = gc_frame_newslot(call1409);
  params[0] = num1406;
  partcv[0] = 1;
  Object sum1410 = callmethod(call1409, "+", 1, partcv, params);
// compiled op node returning sum1410 (depth = 4)
  gc_frame_newslot(sum1410);
// call case 4: self request
  params[0] = sum1410;
  partcv[0] = 1;
  Object call1411 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1404);
// compiled call node returning call1411 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 924
  setline(924);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1415 = alloc_Float64(1);
// compiled num node returning num1415 (depth = 5)
  int op_slot_right_1414 = gc_frame_newslot(num1415);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1417 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1418 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1417);
// compiled call node returning call1418 (depth = 6)
// compiled member node returning call1418 (depth = 5)
  int op_slot_left_1414 = gc_frame_newslot(call1418);
  params[0] = num1415;
  partcv[0] = 1;
  Object sum1419 = callmethod(call1418, "+", 1, partcv, params);
// compiled op node returning sum1419 (depth = 4)
  int op_slot_right_1413 = gc_frame_newslot(sum1419);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  int op_slot_left_1413 = gc_frame_newslot(*var_n);
  params[0] = sum1419;
  partcv[0] = 1;
  Object opresult1421 = callmethod(*var_n, "==", 1, partcv, params);
// compiled op node returning opresult1421 (depth = 3)
  Object if1412 = done;
  if (istrue(opresult1421)) {
// Begin line 925
  setline(925);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1422 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_x (depth = 4)
  gc_frame_newslot(*var_x);
// call case 4: self request
  params[0] = *var_x;
  partcv[0] = 1;
  Object call1423 = callmethodflags(self, "addLast", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1422);
// compiled call node returning call1423 (depth = 3)
    gc_frame_newslot(call1423);
    if1412 = call1423;
  } else {
// Begin line 927
  setline(927);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1424 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// call case 4: self request
  params[0] = *var_n;
  partcv[0] = 1;
  Object call1425 = callmethodflags(self, "boundsCheck", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1424);
// compiled call node returning call1425 (depth = 3)
// Begin line 928
  setline(928);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1426 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1428 = alloc_Float64(1);
// compiled num node returning num1428 (depth = 5)
  int op_slot_right_1427 = gc_frame_newslot(num1428);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  int op_slot_left_1427 = gc_frame_newslot(*var_n);
  params[0] = num1428;
  partcv[0] = 1;
  Object diff1430 = callmethod(*var_n, "-", 1, partcv, params);
// compiled op node returning diff1430 (depth = 4)
  gc_frame_newslot(diff1430);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_x (depth = 4)
  gc_frame_newslot(*var_x);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1431 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1432 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1431);
// compiled call node returning call1432 (depth = 5)
// compiled member node returning call1432 (depth = 4)
  params[0] = diff1430;
  params[1] = *var_x;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1433 = callmethod(call1432, "at()put",
    2, partcv, params);
  gc_frame_end(callframe1426);
// compiled call node returning call1433 (depth = 3)
    gc_frame_newslot(call1433);
    if1412 = call1433;
  }
// compiled if node returning if1412 (depth = 2)
// Begin line 930
  setline(930);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_done (depth = 2)
  gc_frame_end(frame);
  return *var_done;
}
Object meth_collectionsPrelude_add1434(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "add");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for add (probably reflection error): got %i lists, expected 1.", nparts);
  Object var_init_x = alloc_BuiltinList();
  for (i = 0; i < argcv[0]; i++) {
    callmethod(var_init_x, "push", 1, pushcv, &args[curarg]);
    curarg++;
  }
  Object *var_x = &(stackframe->slots[0]);
  *var_x = var_init_x;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 933
  setline(933);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1435 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_x (depth = 3)
  gc_frame_newslot(*var_x);
// call case 4: self request
  params[0] = *var_x;
  partcv[0] = 1;
  Object call1436 = callmethodflags(self, "addAll", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1435);
// compiled call node returning call1436 (depth = 2)
  gc_frame_end(frame);
  return call1436;
}
Object meth_collectionsPrelude__apply1484(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 941
  setline(941);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1485 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1486 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1487 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1486);
// compiled call node returning call1487 (depth = 6)
// compiled member node returning call1487 (depth = 5)
  gc_frame_newslot(call1487);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_each (depth = 5)
  gc_frame_newslot(*var_each);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1488 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1489 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1488);
// compiled call node returning call1489 (depth = 6)
// compiled member node returning call1489 (depth = 5)
  params[0] = call1487;
  params[1] = *var_each;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1490 = callmethod(call1489, "at()put",
    2, partcv, params);
  gc_frame_end(callframe1485);
// compiled call node returning call1490 (depth = 4)
// Begin line 942
  setline(942);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 941
  setline(941);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1491 = gc_frame_new();
// Begin line 942
  setline(942);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num1493 = alloc_Float64(1);
// compiled num node returning num1493 (depth = 7)
  int op_slot_right_1492 = gc_frame_newslot(num1493);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1495 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1496 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1495);
// compiled call node returning call1496 (depth = 8)
// compiled member node returning call1496 (depth = 7)
  int op_slot_left_1492 = gc_frame_newslot(call1496);
  params[0] = num1493;
  partcv[0] = 1;
  Object sum1497 = callmethod(call1496, "+", 1, partcv, params);
// compiled op node returning sum1497 (depth = 6)
  gc_frame_newslot(sum1497);
// call case 4: self request
  params[0] = sum1497;
  partcv[0] = 1;
  Object call1498 = callmethodflags(self, "size:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1491);
// compiled call node returning call1498 (depth = 5)
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_addAll1437(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addAll");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method addAll");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for addAll (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for addAll");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 936
  setline(936);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 928
  setline(928);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1438 = gc_frame_new();
// Begin line 936
  setline(936);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1440 = alloc_Float64(1);
// compiled num node returning num1440 (depth = 5)
  int op_slot_right_1439 = gc_frame_newslot(num1440);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1442 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1443 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1442);
// compiled call node returning call1443 (depth = 6)
// compiled member node returning call1443 (depth = 5)
  int op_slot_left_1439 = gc_frame_newslot(call1443);
  params[0] = num1440;
  partcv[0] = 1;
  Object sum1444 = callmethod(call1443, "+", 1, partcv, params);
// compiled op node returning sum1444 (depth = 4)
  gc_frame_newslot(sum1444);
// call case 4: self request
  params[0] = sum1444;
  partcv[0] = 1;
  Object call1445 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1438);
// compiled call node returning call1445 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 937
  setline(937);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1448 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1449 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1450 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1449);
// compiled call node returning call1450 (depth = 7)
// compiled member node returning call1450 (depth = 6)
  partcv[0] = 0;
  Object call1451 = callmethod(call1450, "size",
    1, partcv, params);
  gc_frame_end(callframe1448);
// compiled call node returning call1451 (depth = 5)
// compiled member node returning call1451 (depth = 4)
  int op_slot_right_1447 = gc_frame_newslot(call1451);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1454 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_l (depth = 7)
  partcv[0] = 0;
  Object call1455 = callmethod(*var_l, "size",
    1, partcv, params);
  gc_frame_end(callframe1454);
// compiled call node returning call1455 (depth = 6)
// compiled member node returning call1455 (depth = 5)
  int op_slot_right_1453 = gc_frame_newslot(call1455);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1457 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1458 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1457);
// compiled call node returning call1458 (depth = 6)
// compiled member node returning call1458 (depth = 5)
  int op_slot_left_1453 = gc_frame_newslot(call1458);
  params[0] = call1455;
  partcv[0] = 1;
  Object sum1459 = callmethod(call1458, "+", 1, partcv, params);
// compiled op node returning sum1459 (depth = 4)
  int op_slot_left_1447 = gc_frame_newslot(sum1459);
  params[0] = call1451;
  partcv[0] = 1;
  Object opresult1460 = callmethod(sum1459, ">", 1, partcv, params);
// compiled op node returning opresult1460 (depth = 3)
  Object if1446 = done;
  if (istrue(opresult1460)) {
// Begin line 938
  setline(938);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1461 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe1462 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1464 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_l (depth = 8)
  partcv[0] = 0;
  Object call1465 = callmethod(*var_l, "size",
    1, partcv, params);
  gc_frame_end(callframe1464);
// compiled call node returning call1465 (depth = 7)
// compiled member node returning call1465 (depth = 6)
  int op_slot_right_1463 = gc_frame_newslot(call1465);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1467 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1468 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1467);
// compiled call node returning call1468 (depth = 7)
// compiled member node returning call1468 (depth = 6)
  int op_slot_left_1463 = gc_frame_newslot(call1468);
  params[0] = call1465;
  partcv[0] = 1;
  Object sum1469 = callmethod(call1468, "+", 1, partcv, params);
// compiled op node returning sum1469 (depth = 5)
  gc_frame_newslot(sum1469);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1471 = alloc_Float64(2);
// compiled num node returning num1471 (depth = 6)
  int op_slot_right_1470 = gc_frame_newslot(num1471);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1473 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1474 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1473);
// compiled call node returning call1474 (depth = 7)
// compiled member node returning call1474 (depth = 6)
  int op_slot_left_1470 = gc_frame_newslot(call1474);
  params[0] = num1471;
  partcv[0] = 1;
  Object prod1475 = callmethod(call1474, "*", 1, partcv, params);
// compiled op node returning prod1475 (depth = 5)
  gc_frame_newslot(prod1475);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1476 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1477 = gc_frame_new();
// call case 3: self.outer request
  Object call1478 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1477);
// compiled call node returning call1478 (depth = 8)
// compiled member node returning call1478 (depth = 7)
  partcv[0] = 0;
  Object call1479 = callmethodflags(call1478, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1476);
// compiled call node returning call1479 (depth = 6)
// compiled member node returning call1479 (depth = 5)
  params[0] = sum1469;
  params[1] = prod1475;
  partcv[0] = 2;
  Object call1480 = callmethodflags(call1479, "max", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1462);
// compiled call node returning call1480 (depth = 4)
  gc_frame_newslot(call1480);
// call case 4: self request
  params[0] = call1480;
  partcv[0] = 1;
  Object call1481 = callmethodflags(self, "expandTo", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1461);
// compiled call node returning call1481 (depth = 3)
    gc_frame_newslot(call1481);
    if1446 = call1481;
  } else {
  }
// compiled if node returning if1446 (depth = 2)
// Begin line 940
  setline(940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1482 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_l (depth = 3)
  gc_frame_newslot(*var_l);
// starting to compile block node (depth = 3)
  Object block1483 = alloc_Block(NULL, NULL, "collectionsPrelude", 940);
  gc_frame_newslot(block1483);
// method _apply
  block_savedest(block1483);
  Object closure1484 = createclosure(1, "_apply");
  setclosureframe(closure1484, stackframe);
  addtoclosure(closure1484, selfslot);
  struct UserObject *uo1484 = (struct UserObject*)block1483;
  uo1484->data[0] = (Object)closure1484;
  Method *meth_meth_collectionsPrelude__apply1484 = addmethod2pos(block1483, "_apply", &meth_collectionsPrelude__apply1484, 0);
  int argcv_meth_collectionsPrelude__apply1484[] = {1};
  meth_meth_collectionsPrelude__apply1484->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1484);
  meth_meth_collectionsPrelude__apply1484->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1484->definitionLine = 938;
// compiled block node returning block1483 (depth = 3)
  gc_frame_newslot(block1483);
// call case 5: prelude request
  params[0] = *var_l;
  params[1] = block1483;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1500 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1482);
// compiled call node returning call1500 (depth = 2)
// Begin line 944
  setline(944);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_push1501(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "push");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method push");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for push (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for push");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 947
  setline(947);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 942
  setline(942);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1502 = gc_frame_new();
// Begin line 947
  setline(947);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1504 = alloc_Float64(1);
// compiled num node returning num1504 (depth = 5)
  int op_slot_right_1503 = gc_frame_newslot(num1504);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1506 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1507 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1506);
// compiled call node returning call1507 (depth = 6)
// compiled member node returning call1507 (depth = 5)
  int op_slot_left_1503 = gc_frame_newslot(call1507);
  params[0] = num1504;
  partcv[0] = 1;
  Object sum1508 = callmethod(call1507, "+", 1, partcv, params);
// compiled op node returning sum1508 (depth = 4)
  gc_frame_newslot(sum1508);
// call case 4: self request
  params[0] = sum1508;
  partcv[0] = 1;
  Object call1509 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1502);
// compiled call node returning call1509 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 948
  setline(948);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1512 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1513 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1514 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1513);
// compiled call node returning call1514 (depth = 7)
// compiled member node returning call1514 (depth = 6)
  partcv[0] = 0;
  Object call1515 = callmethod(call1514, "size",
    1, partcv, params);
  gc_frame_end(callframe1512);
// compiled call node returning call1515 (depth = 5)
// compiled member node returning call1515 (depth = 4)
  int op_slot_right_1511 = gc_frame_newslot(call1515);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1517 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1518 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1517);
// compiled call node returning call1518 (depth = 5)
// compiled member node returning call1518 (depth = 4)
  int op_slot_left_1511 = gc_frame_newslot(call1518);
  params[0] = call1515;
  partcv[0] = 1;
  Object opresult1519 = callmethod(call1518, "==", 1, partcv, params);
// compiled op node returning opresult1519 (depth = 3)
  Object if1510 = done;
  if (istrue(opresult1519)) {
// starting to compile call node (depth = 3)
  int callframe1520 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1522 = alloc_Float64(2);
// compiled num node returning num1522 (depth = 5)
  int op_slot_right_1521 = gc_frame_newslot(num1522);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1524 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1525 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1526 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1525);
// compiled call node returning call1526 (depth = 8)
// compiled member node returning call1526 (depth = 7)
  partcv[0] = 0;
  Object call1527 = callmethod(call1526, "size",
    1, partcv, params);
  gc_frame_end(callframe1524);
// compiled call node returning call1527 (depth = 6)
// compiled member node returning call1527 (depth = 5)
  int op_slot_left_1521 = gc_frame_newslot(call1527);
  params[0] = num1522;
  partcv[0] = 1;
  Object prod1528 = callmethod(call1527, "*", 1, partcv, params);
// compiled op node returning prod1528 (depth = 4)
  gc_frame_newslot(prod1528);
// call case 4: self request
  params[0] = prod1528;
  partcv[0] = 1;
  Object call1529 = callmethodflags(self, "expandTo", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1520);
// compiled call node returning call1529 (depth = 3)
    gc_frame_newslot(call1529);
    if1510 = call1529;
  } else {
  }
// compiled if node returning if1510 (depth = 2)
// Begin line 949
  setline(949);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1530 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1531 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1532 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1531);
// compiled call node returning call1532 (depth = 4)
// compiled member node returning call1532 (depth = 3)
  gc_frame_newslot(call1532);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_x (depth = 3)
  gc_frame_newslot(*var_x);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1533 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1534 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1533);
// compiled call node returning call1534 (depth = 4)
// compiled member node returning call1534 (depth = 3)
  params[0] = call1532;
  params[1] = *var_x;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1535 = callmethod(call1534, "at()put",
    2, partcv, params);
  gc_frame_end(callframe1530);
// compiled call node returning call1535 (depth = 2)
// Begin line 950
  setline(950);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 949
  setline(949);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1536 = gc_frame_new();
// Begin line 950
  setline(950);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1538 = alloc_Float64(1);
// compiled num node returning num1538 (depth = 5)
  int op_slot_right_1537 = gc_frame_newslot(num1538);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1540 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1541 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1540);
// compiled call node returning call1541 (depth = 6)
// compiled member node returning call1541 (depth = 5)
  int op_slot_left_1537 = gc_frame_newslot(call1541);
  params[0] = num1538;
  partcv[0] = 1;
  Object sum1542 = callmethod(call1541, "+", 1, partcv, params);
// compiled op node returning sum1542 (depth = 4)
  gc_frame_newslot(sum1542);
// call case 4: self request
  params[0] = sum1542;
  partcv[0] = 1;
  Object call1543 = callmethodflags(self, "size:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1536);
// compiled call node returning call1543 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 951
  setline(951);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_addLast1544(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addLast");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for addLast (probably reflection error): got %i lists, expected 1.", nparts);
  Object var_init_x = alloc_BuiltinList();
  for (i = 0; i < argcv[0]; i++) {
    callmethod(var_init_x, "push", 1, pushcv, &args[curarg]);
    curarg++;
  }
  Object *var_x = &(stackframe->slots[0]);
  *var_x = var_init_x;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 953
  setline(953);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1545 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_x (depth = 3)
  gc_frame_newslot(*var_x);
// call case 4: self request
  params[0] = *var_x;
  partcv[0] = 1;
  Object call1546 = callmethodflags(self, "addAll", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1545);
// compiled call node returning call1546 (depth = 2)
  gc_frame_end(frame);
  return call1546;
}
Object meth_collectionsPrelude_removeLast1547(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "removeLast");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for removeLast (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for removeLast");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "result");
// Begin line 955
  setline(955);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 950
  setline(950);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1548 = gc_frame_new();
// Begin line 955
  setline(955);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1550 = alloc_Float64(1);
// compiled num node returning num1550 (depth = 5)
  int op_slot_right_1549 = gc_frame_newslot(num1550);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1552 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1553 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1552);
// compiled call node returning call1553 (depth = 6)
// compiled member node returning call1553 (depth = 5)
  int op_slot_left_1549 = gc_frame_newslot(call1553);
  params[0] = num1550;
  partcv[0] = 1;
  Object sum1554 = callmethod(call1553, "+", 1, partcv, params);
// compiled op node returning sum1554 (depth = 4)
  gc_frame_newslot(sum1554);
// call case 4: self request
  params[0] = sum1554;
  partcv[0] = 1;
  Object call1555 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1548);
// compiled call node returning call1555 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 956
  setline(956);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1556 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1558 = alloc_Float64(1);
// compiled num node returning num1558 (depth = 5)
  int op_slot_right_1557 = gc_frame_newslot(num1558);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1560 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1561 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1560);
// compiled call node returning call1561 (depth = 6)
// compiled member node returning call1561 (depth = 5)
  int op_slot_left_1557 = gc_frame_newslot(call1561);
  params[0] = num1558;
  partcv[0] = 1;
  Object diff1562 = callmethod(call1561, "-", 1, partcv, params);
// compiled op node returning diff1562 (depth = 4)
  gc_frame_newslot(diff1562);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1563 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1564 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1563);
// compiled call node returning call1564 (depth = 5)
// compiled member node returning call1564 (depth = 4)
  params[0] = diff1562;
  partcv[0] = 1;
  Object call1565 = callmethod(call1564, "at",
    1, partcv, params);
  gc_frame_end(callframe1556);
// compiled call node returning call1565 (depth = 3)
  *var_result = call1565;
  if (call1565 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 957
  setline(957);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 956
  setline(956);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1566 = gc_frame_new();
// Begin line 957
  setline(957);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1568 = alloc_Float64(1);
// compiled num node returning num1568 (depth = 5)
  int op_slot_right_1567 = gc_frame_newslot(num1568);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1570 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1571 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1570);
// compiled call node returning call1571 (depth = 6)
// compiled member node returning call1571 (depth = 5)
  int op_slot_left_1567 = gc_frame_newslot(call1571);
  params[0] = num1568;
  partcv[0] = 1;
  Object diff1572 = callmethod(call1571, "-", 1, partcv, params);
// compiled op node returning diff1572 (depth = 4)
  gc_frame_newslot(diff1572);
// call case 4: self request
  params[0] = diff1572;
  partcv[0] = 1;
  Object call1573 = callmethodflags(self, "size:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1566);
// compiled call node returning call1573 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 958
  setline(958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_result (depth = 2)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_collectionsPrelude__apply1634(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_increase = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 967
  setline(967);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1635 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_increase (depth = 6)
  int op_slot_right_1636 = gc_frame_newslot(*var_increase);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_1636 = gc_frame_newslot(*var_i);
  params[0] = *var_increase;
  partcv[0] = 1;
  Object sum1638 = callmethod(*var_i, "+", 1, partcv, params);
// compiled op node returning sum1638 (depth = 5)
  gc_frame_newslot(sum1638);
// starting to compile call node (depth = 5)
  int callframe1639 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1640 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1641 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1640);
// compiled call node returning call1641 (depth = 7)
// compiled member node returning call1641 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1642 = callmethod(call1641, "at",
    1, partcv, params);
  gc_frame_end(callframe1639);
// compiled call node returning call1642 (depth = 5)
  gc_frame_newslot(call1642);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1643 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1644 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1643);
// compiled call node returning call1644 (depth = 6)
// compiled member node returning call1644 (depth = 5)
  params[0] = sum1638;
  params[1] = call1642;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1645 = callmethod(call1644, "at()put",
    2, partcv, params);
  gc_frame_end(callframe1635);
// compiled call node returning call1645 (depth = 4)
  gc_frame_end(frame);
  return call1645;
}
Object meth_collectionsPrelude__apply1651(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_insertionIndex = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 971
  setline(971);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1652 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_insertionIndex (depth = 5)
  gc_frame_newslot(*var_insertionIndex);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_each (depth = 5)
  gc_frame_newslot(*var_each);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1653 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1654 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1653);
// compiled call node returning call1654 (depth = 6)
// compiled member node returning call1654 (depth = 5)
  params[0] = *var_insertionIndex;
  params[1] = *var_each;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1655 = callmethod(call1654, "at()put",
    2, partcv, params);
  gc_frame_end(callframe1652);
// compiled call node returning call1655 (depth = 4)
// Begin line 972
  setline(972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1657 = alloc_Float64(1);
// compiled num node returning num1657 (depth = 6)
  int op_slot_right_1656 = gc_frame_newslot(num1657);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_insertionIndex (depth = 6)
  int op_slot_left_1656 = gc_frame_newslot(*var_insertionIndex);
  params[0] = num1657;
  partcv[0] = 1;
  Object sum1659 = callmethod(*var_insertionIndex, "+", 1, partcv, params);
// compiled op node returning sum1659 (depth = 5)
  *var_insertionIndex = sum1659;
  if (sum1659 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_addAllFirst1574(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addAllFirst");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method addAllFirst");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for addAllFirst (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for addAllFirst");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_increase = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "increase");
  Object *var_insertionIndex = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "insertionIndex");
// Begin line 961
  setline(961);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 957
  setline(957);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1575 = gc_frame_new();
// Begin line 961
  setline(961);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1577 = alloc_Float64(1);
// compiled num node returning num1577 (depth = 5)
  int op_slot_right_1576 = gc_frame_newslot(num1577);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1579 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1580 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1579);
// compiled call node returning call1580 (depth = 6)
// compiled member node returning call1580 (depth = 5)
  int op_slot_left_1576 = gc_frame_newslot(call1580);
  params[0] = num1577;
  partcv[0] = 1;
  Object sum1581 = callmethod(call1580, "+", 1, partcv, params);
// compiled op node returning sum1581 (depth = 4)
  gc_frame_newslot(sum1581);
// call case 4: self request
  params[0] = sum1581;
  partcv[0] = 1;
  Object call1582 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1575);
// compiled call node returning call1582 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 962
  setline(962);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1583 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_l (depth = 5)
  partcv[0] = 0;
  Object call1584 = callmethod(*var_l, "size",
    1, partcv, params);
  gc_frame_end(callframe1583);
// compiled call node returning call1584 (depth = 4)
// compiled member node returning call1584 (depth = 3)
  *var_increase = call1584;
  if (call1584 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 963
  setline(963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1587 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1588 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1589 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1588);
// compiled call node returning call1589 (depth = 7)
// compiled member node returning call1589 (depth = 6)
  partcv[0] = 0;
  Object call1590 = callmethod(call1589, "size",
    1, partcv, params);
  gc_frame_end(callframe1587);
// compiled call node returning call1590 (depth = 5)
// compiled member node returning call1590 (depth = 4)
  int op_slot_right_1586 = gc_frame_newslot(call1590);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_increase (depth = 5)
  int op_slot_right_1592 = gc_frame_newslot(*var_increase);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1594 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1595 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1594);
// compiled call node returning call1595 (depth = 6)
// compiled member node returning call1595 (depth = 5)
  int op_slot_left_1592 = gc_frame_newslot(call1595);
  params[0] = *var_increase;
  partcv[0] = 1;
  Object sum1596 = callmethod(call1595, "+", 1, partcv, params);
// compiled op node returning sum1596 (depth = 4)
  int op_slot_left_1586 = gc_frame_newslot(sum1596);
  params[0] = call1590;
  partcv[0] = 1;
  Object opresult1597 = callmethod(sum1596, ">", 1, partcv, params);
// compiled op node returning opresult1597 (depth = 3)
  Object if1585 = done;
  if (istrue(opresult1597)) {
// Begin line 964
  setline(964);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1598 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe1599 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_increase (depth = 6)
  int op_slot_right_1600 = gc_frame_newslot(*var_increase);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1602 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1603 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1602);
// compiled call node returning call1603 (depth = 7)
// compiled member node returning call1603 (depth = 6)
  int op_slot_left_1600 = gc_frame_newslot(call1603);
  params[0] = *var_increase;
  partcv[0] = 1;
  Object sum1604 = callmethod(call1603, "+", 1, partcv, params);
// compiled op node returning sum1604 (depth = 5)
  gc_frame_newslot(sum1604);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1606 = alloc_Float64(2);
// compiled num node returning num1606 (depth = 6)
  int op_slot_right_1605 = gc_frame_newslot(num1606);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1608 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1609 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1608);
// compiled call node returning call1609 (depth = 7)
// compiled member node returning call1609 (depth = 6)
  int op_slot_left_1605 = gc_frame_newslot(call1609);
  params[0] = num1606;
  partcv[0] = 1;
  Object prod1610 = callmethod(call1609, "*", 1, partcv, params);
// compiled op node returning prod1610 (depth = 5)
  gc_frame_newslot(prod1610);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1611 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1612 = gc_frame_new();
// call case 3: self.outer request
  Object call1613 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1612);
// compiled call node returning call1613 (depth = 8)
// compiled member node returning call1613 (depth = 7)
  partcv[0] = 0;
  Object call1614 = callmethodflags(call1613, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1611);
// compiled call node returning call1614 (depth = 6)
// compiled member node returning call1614 (depth = 5)
  params[0] = sum1604;
  params[1] = prod1610;
  partcv[0] = 2;
  Object call1615 = callmethodflags(call1614, "max", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1599);
// compiled call node returning call1615 (depth = 4)
  gc_frame_newslot(call1615);
// call case 4: self request
  params[0] = call1615;
  partcv[0] = 1;
  Object call1616 = callmethodflags(self, "expandTo", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1598);
// compiled call node returning call1616 (depth = 3)
    gc_frame_newslot(call1616);
    if1585 = call1616;
  } else {
  }
// compiled if node returning if1585 (depth = 2)
// Begin line 966
  setline(966);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1617 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe1618 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1620 = alloc_Float64(1);
// compiled num node returning num1620 (depth = 5)
  int op_slot_right_1619 = gc_frame_newslot(num1620);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1622 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1623 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1622);
// compiled call node returning call1623 (depth = 6)
// compiled member node returning call1623 (depth = 5)
  int op_slot_left_1619 = gc_frame_newslot(call1623);
  params[0] = num1620;
  partcv[0] = 1;
  Object diff1624 = callmethod(call1623, "-", 1, partcv, params);
// compiled op node returning diff1624 (depth = 4)
  gc_frame_newslot(diff1624);
// starting to compile num node (depth = 4)
  Object num1625 = alloc_Float64(0);
// compiled num node returning num1625 (depth = 4)
  gc_frame_newslot(num1625);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1626 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1627 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1628 = gc_frame_new();
// call case 3: self.outer request
  Object call1629 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1628);
// compiled call node returning call1629 (depth = 9)
// compiled member node returning call1629 (depth = 8)
  partcv[0] = 0;
  Object call1630 = callmethodflags(call1629, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1627);
// compiled call node returning call1630 (depth = 7)
// compiled member node returning call1630 (depth = 6)
  partcv[0] = 0;
  Object call1631 = callmethodflags(call1630, "range", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1626);
// compiled call node returning call1631 (depth = 5)
// compiled member node returning call1631 (depth = 4)
  params[0] = diff1624;
  params[1] = num1625;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1632 = callmethod(call1631, "from()downTo",
    2, partcv, params);
  gc_frame_end(callframe1618);
// compiled call node returning call1632 (depth = 3)
  gc_frame_newslot(call1632);
// starting to compile block node (depth = 3)
  Object block1633 = alloc_Block(NULL, NULL, "collectionsPrelude", 966);
  gc_frame_newslot(block1633);
// method _apply
  block_savedest(block1633);
  Object closure1634 = createclosure(2, "_apply");
  setclosureframe(closure1634, stackframe);
  addtoclosure(closure1634, var_increase);
  addtoclosure(closure1634, selfslot);
  struct UserObject *uo1634 = (struct UserObject*)block1633;
  uo1634->data[0] = (Object)closure1634;
  Method *meth_meth_collectionsPrelude__apply1634 = addmethod2pos(block1633, "_apply", &meth_collectionsPrelude__apply1634, 0);
  int argcv_meth_collectionsPrelude__apply1634[] = {1};
  meth_meth_collectionsPrelude__apply1634->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1634);
  meth_meth_collectionsPrelude__apply1634->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1634->definitionLine = 966;
// compiled block node returning block1633 (depth = 3)
  gc_frame_newslot(block1633);
// call case 5: prelude request
  params[0] = call1632;
  params[1] = block1633;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1647 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1617);
// compiled call node returning call1647 (depth = 2)
// Begin line 969
  setline(969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num1648 = alloc_Float64(0);
// compiled num node returning num1648 (depth = 3)
  *var_insertionIndex = num1648;
  if (num1648 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 970
  setline(970);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1649 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_l (depth = 3)
  gc_frame_newslot(*var_l);
// starting to compile block node (depth = 3)
  Object block1650 = alloc_Block(NULL, NULL, "collectionsPrelude", 970);
  gc_frame_newslot(block1650);
// method _apply
  block_savedest(block1650);
  Object closure1651 = createclosure(2, "_apply");
  setclosureframe(closure1651, stackframe);
  addtoclosure(closure1651, var_insertionIndex);
  addtoclosure(closure1651, selfslot);
  struct UserObject *uo1651 = (struct UserObject*)block1650;
  uo1651->data[0] = (Object)closure1651;
  Method *meth_meth_collectionsPrelude__apply1651 = addmethod2pos(block1650, "_apply", &meth_collectionsPrelude__apply1651, 0);
  int argcv_meth_collectionsPrelude__apply1651[] = {1};
  meth_meth_collectionsPrelude__apply1651->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1651);
  meth_meth_collectionsPrelude__apply1651->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1651->definitionLine = 967;
// compiled block node returning block1650 (depth = 3)
  gc_frame_newslot(block1650);
// call case 5: prelude request
  params[0] = *var_l;
  params[1] = block1650;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1662 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1649);
// compiled call node returning call1662 (depth = 2)
// Begin line 974
  setline(974);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 971
  setline(971);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1663 = gc_frame_new();
// Begin line 974
  setline(974);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_increase (depth = 5)
  int op_slot_right_1664 = gc_frame_newslot(*var_increase);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1666 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1667 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1666);
// compiled call node returning call1667 (depth = 6)
// compiled member node returning call1667 (depth = 5)
  int op_slot_left_1664 = gc_frame_newslot(call1667);
  params[0] = *var_increase;
  partcv[0] = 1;
  Object sum1668 = callmethod(call1667, "+", 1, partcv, params);
// compiled op node returning sum1668 (depth = 4)
  gc_frame_newslot(sum1668);
// call case 4: self request
  params[0] = sum1668;
  partcv[0] = 1;
  Object call1669 = callmethodflags(self, "size:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1663);
// compiled call node returning call1669 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 975
  setline(975);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_addFirst1670(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addFirst");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for addFirst (probably reflection error): got %i lists, expected 1.", nparts);
  Object var_init_l = alloc_BuiltinList();
  for (i = 0; i < argcv[0]; i++) {
    callmethod(var_init_l, "push", 1, pushcv, &args[curarg]);
    curarg++;
  }
  Object *var_l = &(stackframe->slots[0]);
  *var_l = var_init_l;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 977
  setline(977);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1671 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_l (depth = 3)
  gc_frame_newslot(*var_l);
// call case 4: self request
  params[0] = *var_l;
  partcv[0] = 1;
  Object call1672 = callmethodflags(self, "addAllFirst", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1671);
// compiled call node returning call1672 (depth = 2)
  gc_frame_end(frame);
  return call1672;
}
Object meth_collectionsPrelude_removeFirst1673(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "removeFirst");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for removeFirst (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for removeFirst");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 979
  setline(979);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1674 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num1675 = alloc_Float64(1);
// compiled num node returning num1675 (depth = 3)
  gc_frame_newslot(num1675);
// call case 4: self request
  params[0] = num1675;
  partcv[0] = 1;
  Object call1676 = callmethodflags(self, "removeAt", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1674);
// compiled call node returning call1676 (depth = 2)
  gc_frame_end(frame);
  return call1676;
}
Object meth_collectionsPrelude__apply1707(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 986
  setline(986);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1708 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1710 = alloc_Float64(1);
// compiled num node returning num1710 (depth = 6)
  int op_slot_right_1709 = gc_frame_newslot(num1710);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_1709 = gc_frame_newslot(*var_i);
  params[0] = num1710;
  partcv[0] = 1;
  Object diff1712 = callmethod(*var_i, "-", 1, partcv, params);
// compiled op node returning diff1712 (depth = 5)
  gc_frame_newslot(diff1712);
// starting to compile call node (depth = 5)
  int callframe1713 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1714 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1715 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1714);
// compiled call node returning call1715 (depth = 7)
// compiled member node returning call1715 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1716 = callmethod(call1715, "at",
    1, partcv, params);
  gc_frame_end(callframe1713);
// compiled call node returning call1716 (depth = 5)
  gc_frame_newslot(call1716);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1717 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1718 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1717);
// compiled call node returning call1718 (depth = 6)
// compiled member node returning call1718 (depth = 5)
  params[0] = diff1712;
  params[1] = call1716;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1719 = callmethod(call1718, "at()put",
    2, partcv, params);
  gc_frame_end(callframe1708);
// compiled call node returning call1719 (depth = 4)
  gc_frame_end(frame);
  return call1719;
}
Object meth_collectionsPrelude_removeAt1677(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "removeAt");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method removeAt");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for removeAt (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for removeAt");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_removed = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "removed");
// Begin line 982
  setline(982);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 974
  setline(974);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1678 = gc_frame_new();
// Begin line 982
  setline(982);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1680 = alloc_Float64(1);
// compiled num node returning num1680 (depth = 5)
  int op_slot_right_1679 = gc_frame_newslot(num1680);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1682 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1683 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1682);
// compiled call node returning call1683 (depth = 6)
// compiled member node returning call1683 (depth = 5)
  int op_slot_left_1679 = gc_frame_newslot(call1683);
  params[0] = num1680;
  partcv[0] = 1;
  Object sum1684 = callmethod(call1683, "+", 1, partcv, params);
// compiled op node returning sum1684 (depth = 4)
  gc_frame_newslot(sum1684);
// call case 4: self request
  params[0] = sum1684;
  partcv[0] = 1;
  Object call1685 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1678);
// compiled call node returning call1685 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 983
  setline(983);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1686 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_n (depth = 3)
  gc_frame_newslot(*var_n);
// call case 4: self request
  params[0] = *var_n;
  partcv[0] = 1;
  Object call1687 = callmethodflags(self, "boundsCheck", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1686);
// compiled call node returning call1687 (depth = 2)
// Begin line 984
  setline(984);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1688 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1690 = alloc_Float64(1);
// compiled num node returning num1690 (depth = 5)
  int op_slot_right_1689 = gc_frame_newslot(num1690);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  int op_slot_left_1689 = gc_frame_newslot(*var_n);
  params[0] = num1690;
  partcv[0] = 1;
  Object diff1692 = callmethod(*var_n, "-", 1, partcv, params);
// compiled op node returning diff1692 (depth = 4)
  gc_frame_newslot(diff1692);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1693 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1694 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1693);
// compiled call node returning call1694 (depth = 5)
// compiled member node returning call1694 (depth = 4)
  params[0] = diff1692;
  partcv[0] = 1;
  Object call1695 = callmethod(call1694, "at",
    1, partcv, params);
  gc_frame_end(callframe1688);
// compiled call node returning call1695 (depth = 3)
  *var_removed = call1695;
  if (call1695 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 985
  setline(985);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1696 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1699 = alloc_Float64(1);
// compiled num node returning num1699 (depth = 5)
  int op_slot_right_1698 = gc_frame_newslot(num1699);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1701 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1702 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1701);
// compiled call node returning call1702 (depth = 6)
// compiled member node returning call1702 (depth = 5)
  int op_slot_left_1698 = gc_frame_newslot(call1702);
  params[0] = num1699;
  partcv[0] = 1;
  Object diff1703 = callmethod(call1702, "-", 1, partcv, params);
// compiled op node returning diff1703 (depth = 4)
  int op_slot_right_1697 = gc_frame_newslot(diff1703);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  int op_slot_left_1697 = gc_frame_newslot(*var_n);
  params[0] = diff1703;
  partcv[0] = 1;
  Object opresult1705 = callmethod(*var_n, "..", 1, partcv, params);
// compiled op node returning opresult1705 (depth = 3)
  gc_frame_newslot(opresult1705);
// starting to compile block node (depth = 3)
  Object block1706 = alloc_Block(NULL, NULL, "collectionsPrelude", 985);
  gc_frame_newslot(block1706);
// method _apply
  block_savedest(block1706);
  Object closure1707 = createclosure(1, "_apply");
  setclosureframe(closure1707, stackframe);
  addtoclosure(closure1707, selfslot);
  struct UserObject *uo1707 = (struct UserObject*)block1706;
  uo1707->data[0] = (Object)closure1707;
  Method *meth_meth_collectionsPrelude__apply1707 = addmethod2pos(block1706, "_apply", &meth_collectionsPrelude__apply1707, 0);
  int argcv_meth_collectionsPrelude__apply1707[] = {1};
  meth_meth_collectionsPrelude__apply1707->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1707);
  meth_meth_collectionsPrelude__apply1707->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1707->definitionLine = 985;
// compiled block node returning block1706 (depth = 3)
  gc_frame_newslot(block1706);
// call case 5: prelude request
  params[0] = opresult1705;
  params[1] = block1706;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1721 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1696);
// compiled call node returning call1721 (depth = 2)
// Begin line 988
  setline(988);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 986
  setline(986);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1722 = gc_frame_new();
// Begin line 988
  setline(988);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1724 = alloc_Float64(1);
// compiled num node returning num1724 (depth = 5)
  int op_slot_right_1723 = gc_frame_newslot(num1724);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1726 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1727 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1726);
// compiled call node returning call1727 (depth = 6)
// compiled member node returning call1727 (depth = 5)
  int op_slot_left_1723 = gc_frame_newslot(call1727);
  params[0] = num1724;
  partcv[0] = 1;
  Object diff1728 = callmethod(call1727, "-", 1, partcv, params);
// compiled op node returning diff1728 (depth = 4)
  gc_frame_newslot(diff1728);
// call case 4: self request
  params[0] = diff1728;
  partcv[0] = 1;
  Object call1729 = callmethodflags(self, "size:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1722);
// compiled call node returning call1729 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 989
  setline(989);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_removed (depth = 3)
  return *var_removed;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_remove1730(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "remove");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for remove (probably reflection error): got %i lists, expected 1.", nparts);
  Object var_init_v = alloc_BuiltinList();
  for (i = 0; i < argcv[0]; i++) {
    callmethod(var_init_v, "push", 1, pushcv, &args[curarg]);
    curarg++;
  }
  Object *var_v = &(stackframe->slots[0]);
  *var_v = var_init_v;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 992
  setline(992);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1731 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_v (depth = 3)
  gc_frame_newslot(*var_v);
// call case 4: self request
  params[0] = *var_v;
  partcv[0] = 1;
  Object call1732 = callmethodflags(self, "removeAll", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1731);
// compiled call node returning call1732 (depth = 2)
  gc_frame_end(frame);
  return call1732;
}
Object meth_collectionsPrelude_remove_40__41_ifAbsent1733(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "remove()ifAbsent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method remove()ifAbsent");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for remove()ifAbsent (probably reflection error): got %i lists, expected 2.", nparts);
  Object var_init_v = alloc_BuiltinList();
  for (i = 0; i < argcv[0]; i++) {
    callmethod(var_init_v, "push", 1, pushcv, &args[curarg]);
    curarg++;
  }
  Object *var_v = &(stackframe->slots[0]);
  *var_v = var_init_v;
  Object *var_action = &(stackframe->slots[1]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for ifAbsent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 995
  setline(995);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1734 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_v (depth = 3)
  gc_frame_newslot(*var_v);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_action (depth = 3)
  gc_frame_newslot(*var_action);
// call case 4: self request
  params[0] = *var_v;
  params[1] = *var_action;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1735 = callmethodflags(self, "removeAll()ifAbsent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1734);
// compiled call node returning call1735 (depth = 2)
  gc_frame_end(frame);
  return call1735;
}
Object meth_collectionsPrelude__apply1739(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe1740 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1741 == NULL) {
    strlit1741 = alloc_String("object not in list");
    gc_root(strlit1741);
  }
// compiled string node returning strlit1741 (depth = 5)
  gc_frame_newslot(strlit1741);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_NoSuchObject (depth = 5)
  params[0] = strlit1741;
  partcv[0] = 1;
  Object call1742 = callmethod(*var_NoSuchObject, "raise",
    1, partcv, params);
  gc_frame_end(callframe1740);
// compiled call node returning call1742 (depth = 4)
  gc_frame_end(frame);
  return call1742;
}
Object meth_collectionsPrelude_removeAll1736(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "removeAll");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method removeAll");
  Object params[2];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for removeAll (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_vs = &(stackframe->slots[0]);
  *var_vs = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for removeAll");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 998
  setline(998);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1737 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_vs (depth = 3)
  gc_frame_newslot(*var_vs);
// starting to compile block node (depth = 3)
  Object block1738 = alloc_Block(NULL, NULL, "collectionsPrelude", 998);
  gc_frame_newslot(block1738);
// method _apply
  block_savedest(block1738);
  Object closure1739 = createclosure(2, "_apply");
  setclosureframe(closure1739, stackframe);
  addtoclosure(closure1739, var_NoSuchObject);
  addtoclosure(closure1739, selfslot);
  struct UserObject *uo1739 = (struct UserObject*)block1738;
  uo1739->data[0] = (Object)closure1739;
  Method *meth_meth_collectionsPrelude__apply1739 = addmethod2pos(block1738, "_apply", &meth_collectionsPrelude__apply1739, 0);
  int argcv_meth_collectionsPrelude__apply1739[] = {0};
  meth_meth_collectionsPrelude__apply1739->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1739);
  meth_meth_collectionsPrelude__apply1739->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1739->definitionLine = 988;
// compiled block node returning block1738 (depth = 3)
  gc_frame_newslot(block1738);
// call case 4: self request
  params[0] = *var_vs;
  params[1] = block1738;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1744 = callmethodflags(self, "removeAll()ifAbsent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1737);
// compiled call node returning call1744 (depth = 2)
  gc_frame_end(frame);
  return call1744;
}
Object meth_collectionsPrelude__apply1759(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_action = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile return node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1760 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_action (depth = 10)
  partcv[0] = 0;
  Object call1761 = callmethod(*var_action, "apply",
    1, partcv, params);
  gc_frame_end(callframe1760);
// compiled call node returning call1761 (depth = 9)
// compiled member node returning call1761 (depth = 8)
  block_return(realself, call1761);
// compiled return node returning undefined (depth = 7)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply1756(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_action = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ix = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "ix");
// Begin line 1003
  setline(1003);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1757 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_each (depth = 6)
  gc_frame_newslot(*var_each);
// starting to compile block node (depth = 6)
  Object block1758 = alloc_Block(NULL, NULL, "collectionsPrelude", 1003);
  gc_frame_newslot(block1758);
// method _apply
  block_savedest(block1758);
  Object closure1759 = createclosure(2, "_apply");
  setclosureframe(closure1759, stackframe);
  addtoclosure(closure1759, var_action);
  addtoclosure(closure1759, selfslot);
  struct UserObject *uo1759 = (struct UserObject*)block1758;
  uo1759->data[0] = (Object)closure1759;
  Method *meth_meth_collectionsPrelude__apply1759 = addmethod2pos(block1758, "_apply", &meth_collectionsPrelude__apply1759, 0);
  int argcv_meth_collectionsPrelude__apply1759[] = {0};
  meth_meth_collectionsPrelude__apply1759->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1759);
  meth_meth_collectionsPrelude__apply1759->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1759->definitionLine = 1001;
// compiled block node returning block1758 (depth = 6)
  gc_frame_newslot(block1758);
// call case 4: self request
  params[0] = *var_each;
  params[1] = block1758;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1763 = callmethodflags(self, "indexOf()ifAbsent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1757);
// compiled call node returning call1763 (depth = 5)
  *var_ix = call1763;
  if (call1763 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1004
  setline(1004);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1764 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ix (depth = 5)
  gc_frame_newslot(*var_ix);
// call case 4: self request
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call1765 = callmethodflags(self, "removeAt", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1764);
// compiled call node returning call1765 (depth = 4)
  gc_frame_end(frame);
  return call1765;
}
Object meth_collectionsPrelude_removeAll_40__41_ifAbsent1745(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "removeAll()ifAbsent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method removeAll()ifAbsent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method removeAll()ifAbsent");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for removeAll()ifAbsent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_vs = &(stackframe->slots[0]);
  *var_vs = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for removeAll");
  Object *var_action = &(stackframe->slots[1]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for ifAbsent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1001
  setline(1001);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 988
  setline(988);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1746 = gc_frame_new();
// Begin line 1001
  setline(1001);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1748 = alloc_Float64(1);
// compiled num node returning num1748 (depth = 5)
  int op_slot_right_1747 = gc_frame_newslot(num1748);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1750 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1751 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1750);
// compiled call node returning call1751 (depth = 6)
// compiled member node returning call1751 (depth = 5)
  int op_slot_left_1747 = gc_frame_newslot(call1751);
  params[0] = num1748;
  partcv[0] = 1;
  Object sum1752 = callmethod(call1751, "+", 1, partcv, params);
// compiled op node returning sum1752 (depth = 4)
  gc_frame_newslot(sum1752);
// call case 4: self request
  params[0] = sum1752;
  partcv[0] = 1;
  Object call1753 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1746);
// compiled call node returning call1753 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 1002
  setline(1002);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1754 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_vs (depth = 3)
  gc_frame_newslot(*var_vs);
// starting to compile block node (depth = 3)
  Object block1755 = alloc_Block(NULL, NULL, "collectionsPrelude", 1002);
  gc_frame_newslot(block1755);
// method _apply
  block_savedest(block1755);
  Object closure1756 = createclosure(2, "_apply");
  setclosureframe(closure1756, stackframe);
  addtoclosure(closure1756, var_action);
  addtoclosure(closure1756, selfslot);
  struct UserObject *uo1756 = (struct UserObject*)block1755;
  uo1756->data[0] = (Object)closure1756;
  Method *meth_meth_collectionsPrelude__apply1756 = addmethod2pos(block1755, "_apply", &meth_collectionsPrelude__apply1756, 0);
  int argcv_meth_collectionsPrelude__apply1756[] = {1};
  meth_meth_collectionsPrelude__apply1756->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1756);
  meth_meth_collectionsPrelude__apply1756->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1756->definitionLine = 1001;
// compiled block node returning block1755 (depth = 3)
  gc_frame_newslot(block1755);
// call case 5: prelude request
  params[0] = *var_vs;
  params[1] = block1755;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1767 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1754);
// compiled call node returning call1767 (depth = 2)
// Begin line 1006
  setline(1006);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_pop1768(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pop");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pop (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for pop");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1008
  setline(1008);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1769 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1770 = callmethodflags(self, "removeLast", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1769);
// compiled call node returning call1770 (depth = 3)
// compiled member node returning call1770 (depth = 2)
  gc_frame_end(frame);
  return call1770;
}
Object meth_collectionsPrelude__apply1782(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_result = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe1783 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_each (depth = 5)
  gc_frame_newslot(*var_each);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call1784 = callmethod(*var_result, "addFirst",
    1, partcv, params);
  gc_frame_end(callframe1783);
// compiled call node returning call1784 (depth = 4)
  gc_frame_end(frame);
  return call1784;
}
Object meth_collectionsPrelude_reversed1771(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "reversed");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for reversed (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for reversed");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "result");
// Begin line 1010
  setline(1010);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1772 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1773 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1774 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1775 = gc_frame_new();
// call case 3: self.outer request
  Object call1776 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1775);
// compiled call node returning call1776 (depth = 10)
// compiled member node returning call1776 (depth = 9)
  partcv[0] = 0;
  Object call1777 = callmethodflags(call1776, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1774);
// compiled call node returning call1777 (depth = 8)
// compiled member node returning call1777 (depth = 7)
  partcv[0] = 0;
  Object call1778 = callmethodflags(call1777, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1773);
// compiled call node returning call1778 (depth = 6)
// compiled member node returning call1778 (depth = 5)
  partcv[0] = 0;
  Object call1779 = callmethod(call1778, "empty",
    1, partcv, params);
  gc_frame_end(callframe1772);
// compiled call node returning call1779 (depth = 4)
// compiled member node returning call1779 (depth = 3)
  *var_result = call1779;
  if (call1779 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1011
  setline(1011);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1780 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block1781 = alloc_Block(NULL, NULL, "collectionsPrelude", 1011);
  gc_frame_newslot(block1781);
// method _apply
  block_savedest(block1781);
  Object closure1782 = createclosure(2, "_apply");
  setclosureframe(closure1782, stackframe);
  addtoclosure(closure1782, var_result);
  addtoclosure(closure1782, selfslot);
  struct UserObject *uo1782 = (struct UserObject*)block1781;
  uo1782->data[0] = (Object)closure1782;
  Method *meth_meth_collectionsPrelude__apply1782 = addmethod2pos(block1781, "_apply", &meth_collectionsPrelude__apply1782, 0);
  int argcv_meth_collectionsPrelude__apply1782[] = {1};
  meth_meth_collectionsPrelude__apply1782->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1782);
  meth_meth_collectionsPrelude__apply1782->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1782->definitionLine = 1010;
// compiled block node returning block1781 (depth = 3)
  gc_frame_newslot(block1781);
// call case 4: self request
  params[0] = block1781;
  partcv[0] = 1;
  Object call1786 = callmethodflags(self, "do", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1780);
// compiled call node returning call1786 (depth = 2)
// Begin line 1012
  setline(1012);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_result (depth = 2)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_collectionsPrelude__apply1801(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_hiIx = getfromclosure(closure, 0);
  Object *var_loIx = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_hiIx (depth = 5)
  int op_slot_right_1802 = gc_frame_newslot(*var_hiIx);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_loIx (depth = 5)
  int op_slot_left_1802 = gc_frame_newslot(*var_loIx);
  params[0] = *var_hiIx;
  partcv[0] = 1;
  Object opresult1804 = callmethod(*var_loIx, "<", 1, partcv, params);
// compiled op node returning opresult1804 (depth = 4)
  gc_frame_end(frame);
  return opresult1804;
}
Object meth_collectionsPrelude__apply1807(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_hiIx = getfromclosure(closure, 0);
  Object *var_loIx = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_hiVal = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "hiVal");
// Begin line 1019
  setline(1019);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1808 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_hiIx (depth = 6)
  gc_frame_newslot(*var_hiIx);
// call case 4: self request
  params[0] = *var_hiIx;
  partcv[0] = 1;
  Object call1809 = callmethodflags(self, "at", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1808);
// compiled call node returning call1809 (depth = 5)
  *var_hiVal = call1809;
  if (call1809 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1020
  setline(1020);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1810 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_hiIx (depth = 5)
  gc_frame_newslot(*var_hiIx);
// starting to compile call node (depth = 5)
  int callframe1811 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_loIx (depth = 6)
  gc_frame_newslot(*var_loIx);
// call case 4: self request
  params[0] = *var_loIx;
  partcv[0] = 1;
  Object call1812 = callmethodflags(self, "at", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1811);
// compiled call node returning call1812 (depth = 5)
  gc_frame_newslot(call1812);
// call case 4: self request
  params[0] = *var_hiIx;
  params[1] = call1812;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1813 = callmethodflags(self, "at()put", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1810);
// compiled call node returning call1813 (depth = 4)
// Begin line 1021
  setline(1021);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1814 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_loIx (depth = 5)
  gc_frame_newslot(*var_loIx);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_hiVal (depth = 5)
  gc_frame_newslot(*var_hiVal);
// call case 4: self request
  params[0] = *var_loIx;
  params[1] = *var_hiVal;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1815 = callmethodflags(self, "at()put", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1814);
// compiled call node returning call1815 (depth = 4)
// Begin line 1022
  setline(1022);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1817 = alloc_Float64(1);
// compiled num node returning num1817 (depth = 6)
  int op_slot_right_1816 = gc_frame_newslot(num1817);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_hiIx (depth = 6)
  int op_slot_left_1816 = gc_frame_newslot(*var_hiIx);
  params[0] = num1817;
  partcv[0] = 1;
  Object diff1819 = callmethod(*var_hiIx, "-", 1, partcv, params);
// compiled op node returning diff1819 (depth = 5)
  *var_hiIx = diff1819;
  if (diff1819 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1023
  setline(1023);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1822 = alloc_Float64(1);
// compiled num node returning num1822 (depth = 6)
  int op_slot_right_1821 = gc_frame_newslot(num1822);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_loIx (depth = 6)
  int op_slot_left_1821 = gc_frame_newslot(*var_loIx);
  params[0] = num1822;
  partcv[0] = 1;
  Object sum1824 = callmethod(*var_loIx, "+", 1, partcv, params);
// compiled op node returning sum1824 (depth = 5)
  *var_loIx = sum1824;
  if (sum1824 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_reverse1787(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "reverse");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for reverse (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for reverse");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_hiIx = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "hiIx");
  Object *var_loIx = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "loIx");
// Begin line 1015
  setline(1015);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 1010
  setline(1010);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1788 = gc_frame_new();
// Begin line 1015
  setline(1015);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1790 = alloc_Float64(1);
// compiled num node returning num1790 (depth = 5)
  int op_slot_right_1789 = gc_frame_newslot(num1790);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1792 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1793 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1792);
// compiled call node returning call1793 (depth = 6)
// compiled member node returning call1793 (depth = 5)
  int op_slot_left_1789 = gc_frame_newslot(call1793);
  params[0] = num1790;
  partcv[0] = 1;
  Object sum1794 = callmethod(call1793, "+", 1, partcv, params);
// compiled op node returning sum1794 (depth = 4)
  gc_frame_newslot(sum1794);
// call case 4: self request
  params[0] = sum1794;
  partcv[0] = 1;
  Object call1795 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1788);
// compiled call node returning call1795 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 1016
  setline(1016);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1796 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1797 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1796);
// compiled call node returning call1797 (depth = 4)
// compiled member node returning call1797 (depth = 3)
  *var_hiIx = call1797;
  if (call1797 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1017
  setline(1017);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num1798 = alloc_Float64(1);
// compiled num node returning num1798 (depth = 3)
  *var_loIx = num1798;
  if (num1798 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1018
  setline(1018);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1799 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block1800 = alloc_Block(NULL, NULL, "collectionsPrelude", 1018);
  gc_frame_newslot(block1800);
// method _apply
  block_savedest(block1800);
  Object closure1801 = createclosure(3, "_apply");
  setclosureframe(closure1801, stackframe);
  addtoclosure(closure1801, var_hiIx);
  addtoclosure(closure1801, var_loIx);
  addtoclosure(closure1801, selfslot);
  struct UserObject *uo1801 = (struct UserObject*)block1800;
  uo1801->data[0] = (Object)closure1801;
  Method *meth_meth_collectionsPrelude__apply1801 = addmethod2pos(block1800, "_apply", &meth_collectionsPrelude__apply1801, 0);
  int argcv_meth_collectionsPrelude__apply1801[] = {0};
  meth_meth_collectionsPrelude__apply1801->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1801);
  meth_meth_collectionsPrelude__apply1801->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1801->definitionLine = 1016;
// compiled block node returning block1800 (depth = 3)
  gc_frame_newslot(block1800);
// starting to compile block node (depth = 3)
  Object block1806 = alloc_Block(NULL, NULL, "collectionsPrelude", 1018);
  gc_frame_newslot(block1806);
// method _apply
  block_savedest(block1806);
  Object closure1807 = createclosure(3, "_apply");
  setclosureframe(closure1807, stackframe);
  addtoclosure(closure1807, var_hiIx);
  addtoclosure(closure1807, var_loIx);
  addtoclosure(closure1807, selfslot);
  struct UserObject *uo1807 = (struct UserObject*)block1806;
  uo1807->data[0] = (Object)closure1807;
  Method *meth_meth_collectionsPrelude__apply1807 = addmethod2pos(block1806, "_apply", &meth_collectionsPrelude__apply1807, 0);
  int argcv_meth_collectionsPrelude__apply1807[] = {0};
  meth_meth_collectionsPrelude__apply1807->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1807);
  meth_meth_collectionsPrelude__apply1807->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1807->definitionLine = 1016;
// compiled block node returning block1806 (depth = 3)
  gc_frame_newslot(block1806);
// call case 5: prelude request
  params[0] = block1800;
  params[1] = block1806;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1827 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1799);
// compiled call node returning call1827 (depth = 2)
// Begin line 1025
  setline(1025);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__43__43_1828(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "++");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method ++");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for ++ (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for ++");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_l = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "l");
// Begin line 1028
  setline(1028);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1829 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1830 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1831 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1832 = gc_frame_new();
// call case 3: self.outer request
  Object call1833 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1832);
// compiled call node returning call1833 (depth = 9)
// compiled member node returning call1833 (depth = 8)
  partcv[0] = 0;
  Object call1834 = callmethodflags(call1833, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1831);
// compiled call node returning call1834 (depth = 7)
// compiled member node returning call1834 (depth = 6)
  partcv[0] = 0;
  Object call1835 = callmethodflags(call1834, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1830);
// compiled call node returning call1835 (depth = 5)
// compiled member node returning call1835 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call1836 = callmethod(call1835, "withAll",
    1, partcv, params);
  gc_frame_end(callframe1829);
// compiled call node returning call1836 (depth = 3)
  *var_l = call1836;
  if (call1836 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1029
  setline(1029);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1837 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_l (depth = 3)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call1838 = callmethod(*var_l, "addAll",
    1, partcv, params);
  gc_frame_end(callframe1837);
// compiled call node returning call1838 (depth = 2)
  gc_frame_end(frame);
  return call1838;
}
Object meth_collectionsPrelude__apply1853(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1034
  setline(1034);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1855 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe1856 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1857 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1858 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1857);
// compiled call node returning call1858 (depth = 10)
// compiled member node returning call1858 (depth = 9)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1859 = callmethod(call1858, "at",
    1, partcv, params);
  gc_frame_end(callframe1856);
// compiled call node returning call1859 (depth = 8)
  partcv[0] = 0;
  Object call1860 = callmethod(call1859, "asString",
    1, partcv, params);
  gc_frame_end(callframe1855);
// compiled call node returning call1860 (depth = 7)
// compiled member node returning call1860 (depth = 6)
  int op_slot_right_1854 = gc_frame_newslot(call1860);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_1854 = gc_frame_newslot(*var_s);
  params[0] = call1860;
  partcv[0] = 1;
  Object opresult1862 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1862 (depth = 5)
  *var_s = opresult1862;
  if (opresult1862 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1035
  setline(1035);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num1867 = alloc_Float64(1);
// compiled num node returning num1867 (depth = 7)
  int op_slot_right_1866 = gc_frame_newslot(num1867);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1869 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1870 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1869);
// compiled call node returning call1870 (depth = 8)
// compiled member node returning call1870 (depth = 7)
  int op_slot_left_1866 = gc_frame_newslot(call1870);
  params[0] = num1867;
  partcv[0] = 1;
  Object diff1871 = callmethod(call1870, "-", 1, partcv, params);
// compiled op node returning diff1871 (depth = 6)
  int op_slot_right_1865 = gc_frame_newslot(diff1871);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_1865 = gc_frame_newslot(*var_i);
  params[0] = diff1871;
  partcv[0] = 1;
  Object opresult1873 = callmethod(*var_i, "<", 1, partcv, params);
// compiled op node returning opresult1873 (depth = 5)
  Object if1864 = done;
  if (istrue(opresult1873)) {
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1875 == NULL) {
    strlit1875 = alloc_String(", ");
    gc_root(strlit1875);
  }
// compiled string node returning strlit1875 (depth = 7)
  int op_slot_right_1874 = gc_frame_newslot(strlit1875);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1874 = gc_frame_newslot(*var_s);
  params[0] = strlit1875;
  partcv[0] = 1;
  Object opresult1877 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1877 (depth = 6)
  *var_s = opresult1877;
  if (opresult1877 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if1864 = done;
  } else {
  }
// compiled if node returning if1864 (depth = 4)
  gc_frame_end(frame);
  return if1864;
}
Object meth_collectionsPrelude_asString1839(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
// Begin line 1032
  setline(1032);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit1840 == NULL) {
    strlit1840 = alloc_String("[");
    gc_root(strlit1840);
  }
// compiled string node returning strlit1840 (depth = 3)
  *var_s = strlit1840;
  if (strlit1840 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1033
  setline(1033);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1841 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1844 = alloc_Float64(1);
// compiled num node returning num1844 (depth = 5)
  int op_slot_right_1843 = gc_frame_newslot(num1844);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1846 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1847 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1846);
// compiled call node returning call1847 (depth = 6)
// compiled member node returning call1847 (depth = 5)
  int op_slot_left_1843 = gc_frame_newslot(call1847);
  params[0] = num1844;
  partcv[0] = 1;
  Object diff1848 = callmethod(call1847, "-", 1, partcv, params);
// compiled op node returning diff1848 (depth = 4)
  int op_slot_right_1842 = gc_frame_newslot(diff1848);
// starting to compile num node (depth = 4)
  Object num1850 = alloc_Float64(0);
// compiled num node returning num1850 (depth = 4)
  int op_slot_left_1842 = gc_frame_newslot(num1850);
  params[0] = diff1848;
  partcv[0] = 1;
  Object opresult1851 = callmethod(num1850, "..", 1, partcv, params);
// compiled op node returning opresult1851 (depth = 3)
  gc_frame_newslot(opresult1851);
// starting to compile block node (depth = 3)
  Object block1852 = alloc_Block(NULL, NULL, "collectionsPrelude", 1033);
  gc_frame_newslot(block1852);
// method _apply
  block_savedest(block1852);
  Object closure1853 = createclosure(2, "_apply");
  setclosureframe(closure1853, stackframe);
  addtoclosure(closure1853, var_s);
  addtoclosure(closure1853, selfslot);
  struct UserObject *uo1853 = (struct UserObject*)block1852;
  uo1853->data[0] = (Object)closure1853;
  Method *meth_meth_collectionsPrelude__apply1853 = addmethod2pos(block1852, "_apply", &meth_collectionsPrelude__apply1853, 0);
  int argcv_meth_collectionsPrelude__apply1853[] = {1};
  meth_meth_collectionsPrelude__apply1853->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1853);
  meth_meth_collectionsPrelude__apply1853->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1853->definitionLine = 1033;
// compiled block node returning block1852 (depth = 3)
  gc_frame_newslot(block1852);
// call case 5: prelude request
  params[0] = opresult1851;
  params[1] = block1852;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1880 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1841);
// compiled call node returning call1880 (depth = 2)
// Begin line 1037
  setline(1037);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit1882 == NULL) {
    strlit1882 = alloc_String("]");
    gc_root(strlit1882);
  }
// compiled string node returning strlit1882 (depth = 3)
  int op_slot_right_1881 = gc_frame_newslot(strlit1882);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  int op_slot_left_1881 = gc_frame_newslot(*var_s);
  params[0] = strlit1882;
  partcv[0] = 1;
  Object opresult1884 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1884 (depth = 2)
  gc_frame_end(frame);
  return opresult1884;
}
Object meth_collectionsPrelude__apply1888(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_element = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_element (depth = 6)
  int op_slot_right_1890 = gc_frame_newslot(*var_element);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_each (depth = 6)
  int op_slot_left_1890 = gc_frame_newslot(*var_each);
  params[0] = *var_element;
  partcv[0] = 1;
  Object opresult1892 = callmethod(*var_each, "==", 1, partcv, params);
// compiled op node returning opresult1892 (depth = 5)
  Object if1889 = done;
  if (istrue(opresult1892)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool1893 = alloc_Boolean(1);
// compiled identifier node returning bool1893 (depth = 6)
  block_return(realself, bool1893);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if1889 = undefined;
  } else {
  }
// compiled if node returning if1889 (depth = 4)
  gc_frame_end(frame);
  return if1889;
}
Object meth_collectionsPrelude_contains1885(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "contains");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method contains");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for contains (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_element = &(stackframe->slots[0]);
  *var_element = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for contains");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1040
  setline(1040);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1886 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block1887 = alloc_Block(NULL, NULL, "collectionsPrelude", 1040);
  gc_frame_newslot(block1887);
// method _apply
  block_savedest(block1887);
  Object closure1888 = createclosure(2, "_apply");
  setclosureframe(closure1888, stackframe);
  addtoclosure(closure1888, var_element);
  addtoclosure(closure1888, selfslot);
  struct UserObject *uo1888 = (struct UserObject*)block1887;
  uo1888->data[0] = (Object)closure1888;
  Method *meth_meth_collectionsPrelude__apply1888 = addmethod2pos(block1887, "_apply", &meth_collectionsPrelude__apply1888, 0);
  int argcv_meth_collectionsPrelude__apply1888[] = {1};
  meth_meth_collectionsPrelude__apply1888->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1888);
  meth_meth_collectionsPrelude__apply1888->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1888->definitionLine = 1035;
// compiled block node returning block1887 (depth = 3)
  gc_frame_newslot(block1887);
// call case 4: self request
  params[0] = block1887;
  partcv[0] = 1;
  Object call1895 = callmethodflags(self, "do", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1886);
// compiled call node returning call1895 (depth = 2)
// Begin line 1041
  setline(1041);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool1896 = alloc_Boolean(0);
// compiled identifier node returning bool1896 (depth = 3)
  return bool1896;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply1901(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1903 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1904 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1903);
// compiled call node returning call1904 (depth = 6)
// compiled member node returning call1904 (depth = 5)
  int op_slot_right_1902 = gc_frame_newslot(call1904);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  int op_slot_left_1902 = gc_frame_newslot(*var_i);
  params[0] = call1904;
  partcv[0] = 1;
  Object opresult1906 = callmethod(*var_i, "<", 1, partcv, params);
// compiled op node returning opresult1906 (depth = 4)
  gc_frame_end(frame);
  return opresult1906;
}
Object meth_collectionsPrelude__apply1909(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object *var_block1 = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1046
  setline(1046);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1910 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe1911 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1912 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1913 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1912);
// compiled call node returning call1913 (depth = 7)
// compiled member node returning call1913 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1914 = callmethod(call1913, "at",
    1, partcv, params);
  gc_frame_end(callframe1911);
// compiled call node returning call1914 (depth = 5)
  gc_frame_newslot(call1914);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_block1 (depth = 5)
  params[0] = call1914;
  partcv[0] = 1;
  Object call1915 = callmethod(*var_block1, "apply",
    1, partcv, params);
  gc_frame_end(callframe1910);
// compiled call node returning call1915 (depth = 4)
// Begin line 1047
  setline(1047);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1917 = alloc_Float64(1);
// compiled num node returning num1917 (depth = 6)
  int op_slot_right_1916 = gc_frame_newslot(num1917);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_1916 = gc_frame_newslot(*var_i);
  params[0] = num1917;
  partcv[0] = 1;
  Object sum1919 = callmethod(*var_i, "+", 1, partcv, params);
// compiled op node returning sum1919 (depth = 5)
  *var_i = sum1919;
  if (sum1919 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_do1897(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method do");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for do (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for do");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_i = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "i");
// Begin line 1044
  setline(1044);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num1898 = alloc_Float64(0);
// compiled num node returning num1898 (depth = 3)
  *var_i = num1898;
  if (num1898 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1045
  setline(1045);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1899 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block1900 = alloc_Block(NULL, NULL, "collectionsPrelude", 1045);
  gc_frame_newslot(block1900);
// method _apply
  block_savedest(block1900);
  Object closure1901 = createclosure(2, "_apply");
  setclosureframe(closure1901, stackframe);
  addtoclosure(closure1901, var_i);
  addtoclosure(closure1901, selfslot);
  struct UserObject *uo1901 = (struct UserObject*)block1900;
  uo1901->data[0] = (Object)closure1901;
  Method *meth_meth_collectionsPrelude__apply1901 = addmethod2pos(block1900, "_apply", &meth_collectionsPrelude__apply1901, 0);
  int argcv_meth_collectionsPrelude__apply1901[] = {0};
  meth_meth_collectionsPrelude__apply1901->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1901);
  meth_meth_collectionsPrelude__apply1901->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1901->definitionLine = 1035;
// compiled block node returning block1900 (depth = 3)
  gc_frame_newslot(block1900);
// starting to compile block node (depth = 3)
  Object block1908 = alloc_Block(NULL, NULL, "collectionsPrelude", 1045);
  gc_frame_newslot(block1908);
// method _apply
  block_savedest(block1908);
  Object closure1909 = createclosure(3, "_apply");
  setclosureframe(closure1909, stackframe);
  addtoclosure(closure1909, var_i);
  addtoclosure(closure1909, var_block1);
  addtoclosure(closure1909, selfslot);
  struct UserObject *uo1909 = (struct UserObject*)block1908;
  uo1909->data[0] = (Object)closure1909;
  Method *meth_meth_collectionsPrelude__apply1909 = addmethod2pos(block1908, "_apply", &meth_collectionsPrelude__apply1909, 0);
  int argcv_meth_collectionsPrelude__apply1909[] = {0};
  meth_meth_collectionsPrelude__apply1909->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1909);
  meth_meth_collectionsPrelude__apply1909->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1909->definitionLine = 1045;
// compiled block node returning block1908 (depth = 3)
  gc_frame_newslot(block1908);
// call case 5: prelude request
  params[0] = block1900;
  params[1] = block1908;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1922 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1899);
// compiled call node returning call1922 (depth = 2)
  gc_frame_end(frame);
  return call1922;
}
Object meth_collectionsPrelude__apply1933(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_otherIter = getfromclosure(closure, 0);
  Object *var_selfIter = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1935 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_otherIter (depth = 9)
  partcv[0] = 0;
  Object call1936 = callmethod(*var_otherIter, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe1935);
// compiled call node returning call1936 (depth = 8)
// compiled member node returning call1936 (depth = 7)
  int op_slot_right_1934 = gc_frame_newslot(call1936);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1938 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_selfIter (depth = 9)
  partcv[0] = 0;
  Object call1939 = callmethod(*var_selfIter, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe1938);
// compiled call node returning call1939 (depth = 8)
// compiled member node returning call1939 (depth = 7)
  int op_slot_left_1934 = gc_frame_newslot(call1939);
  params[0] = call1936;
  partcv[0] = 1;
  Object opresult1940 = callmethod(call1939, "&&", 1, partcv, params);
// compiled op node returning opresult1940 (depth = 6)
  gc_frame_end(frame);
  return opresult1940;
}
Object meth_collectionsPrelude__apply1943(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_otherIter = getfromclosure(closure, 0);
  Object *var_selfIter = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1058
  setline(1058);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1946 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_otherIter (depth = 10)
  partcv[0] = 0;
  Object call1947 = callmethod(*var_otherIter, "next",
    1, partcv, params);
  gc_frame_end(callframe1946);
// compiled call node returning call1947 (depth = 9)
// compiled member node returning call1947 (depth = 8)
  int op_slot_right_1945 = gc_frame_newslot(call1947);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1949 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_selfIter (depth = 10)
  partcv[0] = 0;
  Object call1950 = callmethod(*var_selfIter, "next",
    1, partcv, params);
  gc_frame_end(callframe1949);
// compiled call node returning call1950 (depth = 9)
// compiled member node returning call1950 (depth = 8)
  int op_slot_left_1945 = gc_frame_newslot(call1950);
  params[0] = call1947;
  partcv[0] = 1;
  Object opresult1951 = callmethod(call1950, "!=", 1, partcv, params);
// compiled op node returning opresult1951 (depth = 7)
  Object if1944 = done;
  if (istrue(opresult1951)) {
// Begin line 1059
  setline(1059);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool1952 = alloc_Boolean(0);
// compiled identifier node returning bool1952 (depth = 8)
  block_return(realself, bool1952);
// compiled return node returning undefined (depth = 7)
    gc_frame_newslot(undefined);
    if1944 = undefined;
  } else {
  }
// compiled if node returning if1944 (depth = 6)
  gc_frame_end(frame);
  return if1944;
}
Object meth_collectionsPrelude__apply1926(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_other = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_selfIter = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "selfIter");
  Object *var_otherIter = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "otherIter");
// Begin line 1055
  setline(1055);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1927 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1928 = callmethodflags(self, "iterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1927);
// compiled call node returning call1928 (depth = 6)
// compiled member node returning call1928 (depth = 5)
  *var_selfIter = call1928;
  if (call1928 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1056
  setline(1056);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1929 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  partcv[0] = 0;
  Object call1930 = callmethod(*var_other, "iterator",
    1, partcv, params);
  gc_frame_end(callframe1929);
// compiled call node returning call1930 (depth = 6)
// compiled member node returning call1930 (depth = 5)
  *var_otherIter = call1930;
  if (call1930 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1057
  setline(1057);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1931 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block1932 = alloc_Block(NULL, NULL, "collectionsPrelude", 1057);
  gc_frame_newslot(block1932);
// method _apply
  block_savedest(block1932);
  Object closure1933 = createclosure(3, "_apply");
  setclosureframe(closure1933, stackframe);
  addtoclosure(closure1933, var_otherIter);
  addtoclosure(closure1933, var_selfIter);
  addtoclosure(closure1933, selfslot);
  struct UserObject *uo1933 = (struct UserObject*)block1932;
  uo1933->data[0] = (Object)closure1933;
  Method *meth_meth_collectionsPrelude__apply1933 = addmethod2pos(block1932, "_apply", &meth_collectionsPrelude__apply1933, 0);
  int argcv_meth_collectionsPrelude__apply1933[] = {0};
  meth_meth_collectionsPrelude__apply1933->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1933);
  meth_meth_collectionsPrelude__apply1933->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1933->definitionLine = 1056;
// compiled block node returning block1932 (depth = 5)
  gc_frame_newslot(block1932);
// starting to compile block node (depth = 5)
  Object block1942 = alloc_Block(NULL, NULL, "collectionsPrelude", 1057);
  gc_frame_newslot(block1942);
// method _apply
  block_savedest(block1942);
  Object closure1943 = createclosure(3, "_apply");
  setclosureframe(closure1943, stackframe);
  addtoclosure(closure1943, var_otherIter);
  addtoclosure(closure1943, var_selfIter);
  addtoclosure(closure1943, selfslot);
  struct UserObject *uo1943 = (struct UserObject*)block1942;
  uo1943->data[0] = (Object)closure1943;
  Method *meth_meth_collectionsPrelude__apply1943 = addmethod2pos(block1942, "_apply", &meth_collectionsPrelude__apply1943, 0);
  int argcv_meth_collectionsPrelude__apply1943[] = {0};
  meth_meth_collectionsPrelude__apply1943->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1943);
  meth_meth_collectionsPrelude__apply1943->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1943->definitionLine = 1057;
// compiled block node returning block1942 (depth = 5)
  gc_frame_newslot(block1942);
// call case 5: prelude request
  params[0] = block1932;
  params[1] = block1942;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1954 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1931);
// compiled call node returning call1954 (depth = 4)
// Begin line 1062
  setline(1062);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1956 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_otherIter (depth = 8)
  partcv[0] = 0;
  Object call1957 = callmethod(*var_otherIter, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe1956);
// compiled call node returning call1957 (depth = 7)
// compiled member node returning call1957 (depth = 6)
  int op_slot_right_1955 = gc_frame_newslot(call1957);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1959 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_selfIter (depth = 8)
  partcv[0] = 0;
  Object call1960 = callmethod(*var_selfIter, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe1959);
// compiled call node returning call1960 (depth = 7)
// compiled member node returning call1960 (depth = 6)
  int op_slot_left_1955 = gc_frame_newslot(call1960);
  params[0] = call1957;
  partcv[0] = 1;
  Object opresult1961 = callmethod(call1960, "==", 1, partcv, params);
// compiled op node returning opresult1961 (depth = 5)
  block_return(realself, opresult1961);
// compiled return node returning undefined (depth = 4)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply1973(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___16 = &(stackframe->slots[0]);
  *var___16 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1065
  setline(1065);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool1974 = alloc_Boolean(0);
// compiled identifier node returning bool1974 (depth = 5)
  block_return(realself, bool1974);
// compiled return node returning undefined (depth = 4)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__61__61_1923(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 30, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "==");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method ==");
  Object params[2];
  int partcv[1];
  Object *var_Collection = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for == (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for ==");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1053
  setline(1053);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  int frame1924 = gc_frame_new();
  gc_frame_newslot(*var_other);
// Begin line 1054
  setline(1054);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block1925 = alloc_Block(NULL, NULL, "collectionsPrelude", 1054);
  gc_frame_newslot(block1925);
// method _apply
  block_savedest(block1925);
  Object closure1926 = createclosure(2, "_apply");
  setclosureframe(closure1926, stackframe);
  addtoclosure(closure1926, var_other);
  addtoclosure(closure1926, selfslot);
  struct UserObject *uo1926 = (struct UserObject*)block1925;
  uo1926->data[0] = (Object)closure1926;
  Method *meth_meth_collectionsPrelude__apply1926 = addmethod2pos(block1925, "_apply", &meth_collectionsPrelude__apply1926, 0);
  int argcv_meth_collectionsPrelude__apply1926[] = {1};
  meth_meth_collectionsPrelude__apply1926->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1926);
  meth_meth_collectionsPrelude__apply1926->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1926->definitionLine = 1046;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1963 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe1964 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit1965 == NULL) {
    strlit1965 = alloc_String("o");
    gc_root(strlit1965);
  }
// compiled string node returning strlit1965 (depth = 6)
  gc_frame_newslot(strlit1965);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1966 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call1967 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1966);
// compiled call node returning call1967 (depth = 7)
// compiled member node returning call1967 (depth = 6)
  params[0] = strlit1965;
  partcv[0] = 1;
  Object call1968 = callmethod(call1967, "new",
    1, partcv, params);
  gc_frame_end(callframe1964);
// compiled call node returning call1968 (depth = 5)
  gc_frame_newslot(call1968);
// Begin line 1054
  setline(1054);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_Collection (depth = 5)
  gc_frame_newslot(*var_Collection);
// call case 6: other member request
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1969 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call1970 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1969);
// compiled call node returning call1970 (depth = 6)
// compiled member node returning call1970 (depth = 5)
  params[0] = call1968;
  params[1] = *var_Collection;
  partcv[0] = 2;
  Object call1971 = callmethod(call1970, "new",
    1, partcv, params);
  gc_frame_end(callframe1963);
// compiled call node returning call1971 (depth = 4)
((struct UserObject *)block1925)->data[1] = call1971;
// compiled block node returning block1925 (depth = 3)
  gc_frame_newslot(block1925);
// Begin line 1064
  setline(1064);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block1972 = alloc_Block(NULL, NULL, "collectionsPrelude", 1064);
  gc_frame_newslot(block1972);
// method _apply
  block_savedest(block1972);
  Object closure1973 = createclosure(1, "_apply");
  setclosureframe(closure1973, stackframe);
  addtoclosure(closure1973, selfslot);
  struct UserObject *uo1973 = (struct UserObject*)block1972;
  uo1973->data[0] = (Object)closure1973;
  Method *meth_meth_collectionsPrelude__apply1973 = addmethod2pos(block1972, "_apply", &meth_collectionsPrelude__apply1973, 0);
  int argcv_meth_collectionsPrelude__apply1973[] = {1};
  meth_meth_collectionsPrelude__apply1973->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1973);
  meth_meth_collectionsPrelude__apply1973->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1973->definitionLine = 0;
// compiled block node returning block1972 (depth = 3)
  gc_frame_newslot(block1972);
  params[0] = block1925;
  params[1] = block1972;
  Object matchres1924 = matchCase(*var_other, params, 2,NULL);
  gc_frame_end(frame1924);
// compiled matchcase node returning matchres1924 (depth = 2)
  gc_frame_end(frame);
  return matchres1924;
}
Object meth_collectionsPrelude_asDebugString1981(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asDebugString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asDebugString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1072
  setline(1072);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit1983 == NULL) {
    strlit1983 = alloc_String("""\xe2""""\x9f""""\xab""");
    gc_root(strlit1983);
  }
// compiled string node returning strlit1983 (depth = 3)
  int op_slot_right_1982 = gc_frame_newslot(strlit1983);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1986 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1987 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1986);
// compiled call node returning call1987 (depth = 5)
// compiled member node returning call1987 (depth = 4)
  int op_slot_right_1985 = gc_frame_newslot(call1987);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1990 == NULL) {
    strlit1990 = alloc_String("""\xe2""""\x9f""""\xaa""");
    gc_root(strlit1990);
  }
// compiled string node returning strlit1990 (depth = 5)
  int op_slot_right_1989 = gc_frame_newslot(strlit1990);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1993 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1994 = callmethodflags(self, "asString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1993);
// compiled call node returning call1994 (depth = 7)
// compiled member node returning call1994 (depth = 6)
  int op_slot_right_1992 = gc_frame_newslot(call1994);
// starting to compile string node (depth = 6)
  if (strlit1996 == NULL) {
    strlit1996 = alloc_String("");
    gc_root(strlit1996);
  }
// compiled string node returning strlit1996 (depth = 6)
  int op_slot_left_1992 = gc_frame_newslot(strlit1996);
  params[0] = call1994;
  partcv[0] = 1;
  Object opresult1997 = callmethod(strlit1996, "++", 1, partcv, params);
// compiled op node returning opresult1997 (depth = 5)
  int op_slot_left_1989 = gc_frame_newslot(opresult1997);
  params[0] = strlit1990;
  partcv[0] = 1;
  Object opresult1998 = callmethod(opresult1997, "++", 1, partcv, params);
// compiled op node returning opresult1998 (depth = 4)
  int op_slot_left_1985 = gc_frame_newslot(opresult1998);
  params[0] = call1987;
  partcv[0] = 1;
  Object opresult1999 = callmethod(opresult1998, "++", 1, partcv, params);
// compiled op node returning opresult1999 (depth = 3)
  int op_slot_left_1982 = gc_frame_newslot(opresult1999);
  params[0] = strlit1983;
  partcv[0] = 1;
  Object opresult2000 = callmethod(opresult1999, "++", 1, partcv, params);
// compiled op node returning opresult2000 (depth = 2)
  gc_frame_end(frame);
  return opresult2000;
}
Object meth_collectionsPrelude_asString2001(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1073
  setline(1073);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit2002 == NULL) {
    strlit2002 = alloc_String("aListIterator");
    gc_root(strlit2002);
  }
// compiled string node returning strlit2002 (depth = 2)
  gc_frame_end(frame);
  return strlit2002;
}
Object meth_collectionsPrelude_hasNext2003(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for hasNext (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for hasNext");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1074
  setline(1074);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2005 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2006 = gc_frame_new();
// call case 3: self.outer request
  Object call2007 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2006);
// compiled call node returning call2007 (depth = 6)
// compiled member node returning call2007 (depth = 5)
  partcv[0] = 0;
  Object call2008 = callmethodflags(call2007, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2005);
// compiled call node returning call2008 (depth = 4)
// compiled member node returning call2008 (depth = 3)
  int op_slot_right_2004 = gc_frame_newslot(call2008);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2010 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2011 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2010);
// compiled call node returning call2011 (depth = 4)
// compiled member node returning call2011 (depth = 3)
  int op_slot_left_2004 = gc_frame_newslot(call2011);
  params[0] = call2008;
  partcv[0] = 1;
  Object opresult2012 = callmethod(call2011, "<=", 1, partcv, params);
// compiled op node returning opresult2012 (depth = 2)
  gc_frame_end(frame);
  return opresult2012;
}
Object meth_collectionsPrelude_next2013(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_Exhausted = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for next (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for next");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ret = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "ret");
// Begin line 1076
  setline(1076);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2016 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2017 = gc_frame_new();
// call case 3: self.outer request
  Object call2018 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2017);
// compiled call node returning call2018 (depth = 7)
// compiled member node returning call2018 (depth = 6)
  partcv[0] = 0;
  Object call2019 = callmethodflags(call2018, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2016);
// compiled call node returning call2019 (depth = 5)
// compiled member node returning call2019 (depth = 4)
  int op_slot_right_2015 = gc_frame_newslot(call2019);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2021 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2022 = callmethodflags(self, "imods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2021);
// compiled call node returning call2022 (depth = 5)
// compiled member node returning call2022 (depth = 4)
  int op_slot_left_2015 = gc_frame_newslot(call2022);
  params[0] = call2019;
  partcv[0] = 1;
  Object opresult2023 = callmethod(call2022, "!=", 1, partcv, params);
// compiled op node returning opresult2023 (depth = 3)
  Object if2014 = done;
  if (istrue(opresult2023)) {
// Begin line 1077
  setline(1077);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2024 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2025 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2026 = callmethodflags(self, "asDebugString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2025);
// compiled call node returning call2026 (depth = 5)
// compiled member node returning call2026 (depth = 4)
  gc_frame_newslot(call2026);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ConcurrentModification (depth = 4)
  params[0] = call2026;
  partcv[0] = 1;
  Object call2027 = callmethod(*var_ConcurrentModification, "raise",
    1, partcv, params);
  gc_frame_end(callframe2024);
// compiled call node returning call2027 (depth = 3)
    gc_frame_newslot(call2027);
    if2014 = call2027;
  } else {
  }
// compiled if node returning if2014 (depth = 2)
// Begin line 1079
  setline(1079);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2030 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2031 = gc_frame_new();
// call case 3: self.outer request
  Object call2032 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2031);
// compiled call node returning call2032 (depth = 7)
// compiled member node returning call2032 (depth = 6)
  partcv[0] = 0;
  Object call2033 = callmethodflags(call2032, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2030);
// compiled call node returning call2033 (depth = 5)
// compiled member node returning call2033 (depth = 4)
  int op_slot_right_2029 = gc_frame_newslot(call2033);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2035 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2036 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2035);
// compiled call node returning call2036 (depth = 5)
// compiled member node returning call2036 (depth = 4)
  int op_slot_left_2029 = gc_frame_newslot(call2036);
  params[0] = call2033;
  partcv[0] = 1;
  Object opresult2037 = callmethod(call2036, ">", 1, partcv, params);
// compiled op node returning opresult2037 (depth = 3)
  Object if2028 = done;
  if (istrue(opresult2037)) {
// starting to compile call node (depth = 3)
  int callframe2038 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit2039 == NULL) {
    strlit2039 = alloc_String("on list");
    gc_root(strlit2039);
  }
// compiled string node returning strlit2039 (depth = 4)
  gc_frame_newslot(strlit2039);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_Exhausted (depth = 4)
  params[0] = strlit2039;
  partcv[0] = 1;
  Object call2040 = callmethod(*var_Exhausted, "raise",
    1, partcv, params);
  gc_frame_end(callframe2038);
// compiled call node returning call2040 (depth = 3)
    gc_frame_newslot(call2040);
    if2028 = call2040;
  } else {
  }
// compiled if node returning if2028 (depth = 2)
// Begin line 1080
  setline(1080);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2041 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2042 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2043 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2042);
// compiled call node returning call2043 (depth = 5)
// compiled member node returning call2043 (depth = 4)
  gc_frame_newslot(call2043);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2044 = gc_frame_new();
// call case 3: self.outer request
  Object call2045 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2044);
// compiled call node returning call2045 (depth = 5)
// compiled member node returning call2045 (depth = 4)
  params[0] = call2043;
  partcv[0] = 1;
  Object call2046 = callmethodflags(call2045, "at", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2041);
// compiled call node returning call2046 (depth = 3)
  *var_ret = call2046;
  if (call2046 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1081
  setline(1081);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 1080
  setline(1080);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2047 = gc_frame_new();
// Begin line 1081
  setline(1081);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2049 = alloc_Float64(1);
// compiled num node returning num2049 (depth = 5)
  int op_slot_right_2048 = gc_frame_newslot(num2049);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2051 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2052 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2051);
// compiled call node returning call2052 (depth = 6)
// compiled member node returning call2052 (depth = 5)
  int op_slot_left_2048 = gc_frame_newslot(call2052);
  params[0] = num2049;
  partcv[0] = 1;
  Object sum2053 = callmethod(call2052, "+", 1, partcv, params);
// compiled op node returning sum2053 (depth = 4)
  gc_frame_newslot(sum2053);
// call case 4: self request
  params[0] = sum2053;
  partcv[0] = 1;
  Object call2054 = callmethodflags(self, "idx:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2047);
// compiled call node returning call2054 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 1082
  setline(1082);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_ret (depth = 2)
  gc_frame_end(frame);
  return *var_ret;
}
Object meth_collectionsPrelude_iterator1976(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 31, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_Exhausted = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1977 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1977 = alloc_userobj2(8,7, objclass1977);
  gc_frame_newslot(obj1977);
if (objclass1977 == NULL) {
  glfree(obj1977->class->name);
  obj1977->class->name = "obj1307.iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1977, self, 0);
  addmethodreal(obj1977,"outer", &reader_collectionsPrelude_outer_1978);
  Object oldself1977 = self;
  struct StackFrameObject *oldstackframe1977 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1977);
  gc_frame_newslot((Object)stackframe);
  self = obj1977;
  Object *oldselfslot1977 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1977 = (*(struct UserObject *)self).data[0], lowerouter1977 = thisouter1977;
  if (inheritingObject1977) {
    struct UserObject *inho1977 = (struct UserObject *)inheritingObject1977;
    while (inho1977->super != GraceDefaultObject) inho1977 = (struct UserObject *)inho1977->super;
    inho1977->super = obj1977;
    self = inheritingObject1977;
    *selfslot = self;
    lowerouter1977 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1977;
  }
if (objclass1977 == NULL) {
  Method *reader1979 = addmethodrealflags(obj1977, "imods",&reader_collectionsPrelude_imods_1979, MFLAG_CONFIDENTIAL);
  Method *writer1979 = addmethodrealflags(obj1977, "imods:=",&writer_collectionsPrelude_imods_1979, MFLAG_CONFIDENTIAL);
  reader1979->definitionModule = modulename;
  writer1979->definitionModule = modulename;
  reader1979->definitionLine = 1070;
  writer1979->definitionLine = 1070;
}
obj1977->flags |= OFLAG_MUTABLE;
adddatum2(obj1977, alloc_Undefined(), 1);
if (objclass1977 == NULL) {
  Method *reader1980 = addmethodrealflags(obj1977, "idx",&reader_collectionsPrelude_idx_1980, MFLAG_CONFIDENTIAL);
  Method *writer1980 = addmethodrealflags(obj1977, "idx:=",&writer_collectionsPrelude_idx_1980, MFLAG_CONFIDENTIAL);
  reader1980->definitionModule = modulename;
  writer1980->definitionModule = modulename;
  reader1980->definitionLine = 1071;
  writer1980->definitionLine = 1071;
}
obj1977->flags |= OFLAG_MUTABLE;
adddatum2(obj1977, alloc_Undefined(), 2);
// method asDebugString
  struct UserObject *uo1981 = (struct UserObject*)obj1977;
  uo1981->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDebugString1981 = addmethod2pos(obj1977, "asDebugString", &meth_collectionsPrelude_asDebugString1981, 3);
  int argcv_meth_collectionsPrelude_asDebugString1981[] = {0};
  meth_meth_collectionsPrelude_asDebugString1981->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString1981);
  meth_meth_collectionsPrelude_asDebugString1981->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString1981->definitionLine = 1072;
// method asString
  struct UserObject *uo2001 = (struct UserObject*)obj1977;
  uo2001->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString2001 = addmethod2pos(obj1977, "asString", &meth_collectionsPrelude_asString2001, 4);
  int argcv_meth_collectionsPrelude_asString2001[] = {0};
  meth_meth_collectionsPrelude_asString2001->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString2001);
  meth_meth_collectionsPrelude_asString2001->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString2001->definitionLine = 1073;
// method hasNext
  struct UserObject *uo2003 = (struct UserObject*)obj1977;
  uo2003->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext2003 = addmethod2pos(obj1977, "hasNext", &meth_collectionsPrelude_hasNext2003, 5);
  int argcv_meth_collectionsPrelude_hasNext2003[] = {0};
  meth_meth_collectionsPrelude_hasNext2003->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext2003);
  meth_meth_collectionsPrelude_hasNext2003->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext2003->definitionLine = 1074;
// method next
  block_savedest(obj1977);
  Object closure2013 = createclosure(2, "next");
  setclosureframe(closure2013, stackframe);
  addtoclosure(closure2013, var_ConcurrentModification);
  addtoclosure(closure2013, var_Exhausted);
  struct UserObject *uo2013 = (struct UserObject*)obj1977;
  uo2013->data[6] = (Object)closure2013;
  Method *meth_meth_collectionsPrelude_next2013 = addmethod2pos(obj1977, "next", &meth_collectionsPrelude_next2013, 6);
  int argcv_meth_collectionsPrelude_next2013[] = {0};
  meth_meth_collectionsPrelude_next2013->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next2013);
  meth_meth_collectionsPrelude_next2013->definitionModule = modulename;
  meth_meth_collectionsPrelude_next2013->definitionLine = 1075;
  sourceObject = obj1977;
// Begin line 1070
  setline(1070);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2055 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2056 = gc_frame_new();
// call case 3: self.outer request
  Object call2057 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2056);
// compiled call node returning call2057 (depth = 5)
// compiled member node returning call2057 (depth = 4)
  partcv[0] = 0;
  Object call2058 = callmethodflags(call2057, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2055);
// compiled call node returning call2058 (depth = 3)
// compiled member node returning call2058 (depth = 2)
  adddatum2(obj1977, call2058, 1);
  sourceObject = obj1977;
// Begin line 1071
  setline(1071);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2059 = alloc_Float64(1);
// compiled num node returning num2059 (depth = 2)
  adddatum2(obj1977, num2059, 2);
  sourceObject = obj1977;
  sourceObject = obj1977;
  sourceObject = obj1977;
  sourceObject = obj1977;
  objclass1977 = obj1977->class;
  objclass1977->definitionModule = modulename;
  objclass1977->definitionLine = 1069;
  (*(struct UserObject *)self).data[0] = lowerouter1977;
  self = oldself1977;
  selfslot = oldselfslot1977;
  stackframe = oldstackframe1977;
  gc_frame_end(frame);
  return obj1977;
}
Object meth_collectionsPrelude_iterator1976_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 31, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_Exhausted = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1977 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1977 = alloc_userobj2(8,7, objclass1977);
  gc_frame_newslot(obj1977);
if (objclass1977 == NULL) {
  glfree(obj1977->class->name);
  obj1977->class->name = "obj1307.iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1977, self, 0);
  addmethodreal(obj1977,"outer", &reader_collectionsPrelude_outer_1978);
  Object oldself1977 = self;
  struct StackFrameObject *oldstackframe1977 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1977);
  gc_frame_newslot((Object)stackframe);
  self = obj1977;
  Object *oldselfslot1977 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1977 = (*(struct UserObject *)self).data[0], lowerouter1977 = thisouter1977;
  if (inheritingObject1977) {
    struct UserObject *inho1977 = (struct UserObject *)inheritingObject1977;
    while (inho1977->super != GraceDefaultObject) inho1977 = (struct UserObject *)inho1977->super;
    inho1977->super = obj1977;
    self = inheritingObject1977;
    *selfslot = self;
    lowerouter1977 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1977;
  }
if (objclass1977 == NULL) {
  Method *reader1979 = addmethodrealflags(obj1977, "imods",&reader_collectionsPrelude_imods_1979, MFLAG_CONFIDENTIAL);
  Method *writer1979 = addmethodrealflags(obj1977, "imods:=",&writer_collectionsPrelude_imods_1979, MFLAG_CONFIDENTIAL);
  reader1979->definitionModule = modulename;
  writer1979->definitionModule = modulename;
  reader1979->definitionLine = 1070;
  writer1979->definitionLine = 1070;
}
obj1977->flags |= OFLAG_MUTABLE;
adddatum2(obj1977, alloc_Undefined(), 1);
if (objclass1977 == NULL) {
  Method *reader1980 = addmethodrealflags(obj1977, "idx",&reader_collectionsPrelude_idx_1980, MFLAG_CONFIDENTIAL);
  Method *writer1980 = addmethodrealflags(obj1977, "idx:=",&writer_collectionsPrelude_idx_1980, MFLAG_CONFIDENTIAL);
  reader1980->definitionModule = modulename;
  writer1980->definitionModule = modulename;
  reader1980->definitionLine = 1071;
  writer1980->definitionLine = 1071;
}
obj1977->flags |= OFLAG_MUTABLE;
adddatum2(obj1977, alloc_Undefined(), 2);
// method asDebugString
  struct UserObject *uo1981 = (struct UserObject*)obj1977;
  uo1981->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDebugString1981 = addmethod2pos(obj1977, "asDebugString", &meth_collectionsPrelude_asDebugString1981, 3);
  int argcv_meth_collectionsPrelude_asDebugString1981[] = {0};
  meth_meth_collectionsPrelude_asDebugString1981->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString1981);
  meth_meth_collectionsPrelude_asDebugString1981->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString1981->definitionLine = 1072;
// method asString
  struct UserObject *uo2001 = (struct UserObject*)obj1977;
  uo2001->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString2001 = addmethod2pos(obj1977, "asString", &meth_collectionsPrelude_asString2001, 4);
  int argcv_meth_collectionsPrelude_asString2001[] = {0};
  meth_meth_collectionsPrelude_asString2001->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString2001);
  meth_meth_collectionsPrelude_asString2001->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString2001->definitionLine = 1073;
// method hasNext
  struct UserObject *uo2003 = (struct UserObject*)obj1977;
  uo2003->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext2003 = addmethod2pos(obj1977, "hasNext", &meth_collectionsPrelude_hasNext2003, 5);
  int argcv_meth_collectionsPrelude_hasNext2003[] = {0};
  meth_meth_collectionsPrelude_hasNext2003->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext2003);
  meth_meth_collectionsPrelude_hasNext2003->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext2003->definitionLine = 1074;
// method next
  block_savedest(obj1977);
  Object closure2013 = createclosure(2, "next");
  setclosureframe(closure2013, stackframe);
  addtoclosure(closure2013, var_ConcurrentModification);
  addtoclosure(closure2013, var_Exhausted);
  struct UserObject *uo2013 = (struct UserObject*)obj1977;
  uo2013->data[6] = (Object)closure2013;
  Method *meth_meth_collectionsPrelude_next2013 = addmethod2pos(obj1977, "next", &meth_collectionsPrelude_next2013, 6);
  int argcv_meth_collectionsPrelude_next2013[] = {0};
  meth_meth_collectionsPrelude_next2013->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next2013);
  meth_meth_collectionsPrelude_next2013->definitionModule = modulename;
  meth_meth_collectionsPrelude_next2013->definitionLine = 1075;
  sourceObject = obj1977;
// Begin line 1070
  setline(1070);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2055 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2056 = gc_frame_new();
// call case 3: self.outer request
  Object call2057 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2056);
// compiled call node returning call2057 (depth = 5)
// compiled member node returning call2057 (depth = 4)
  partcv[0] = 0;
  Object call2058 = callmethodflags(call2057, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2055);
// compiled call node returning call2058 (depth = 3)
// compiled member node returning call2058 (depth = 2)
  adddatum2(obj1977, call2058, 1);
  sourceObject = obj1977;
// Begin line 1071
  setline(1071);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2059 = alloc_Float64(1);
// compiled num node returning num2059 (depth = 2)
  adddatum2(obj1977, num2059, 2);
  sourceObject = obj1977;
  sourceObject = obj1977;
  sourceObject = obj1977;
  sourceObject = obj1977;
  objclass1977 = obj1977->class;
  objclass1977->definitionModule = modulename;
  objclass1977->definitionLine = 1069;
  (*(struct UserObject *)self).data[0] = lowerouter1977;
  self = oldself1977;
  selfslot = oldselfslot1977;
  stackframe = oldstackframe1977;
  gc_frame_end(frame);
  return obj1977;
}
Object meth_collectionsPrelude_values2061(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "values");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for values (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for values");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1087
  setline(1087);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_keys2062(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keys");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for keys (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for keys");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1090
  setline(1090);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2063 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2064 = callmethodflags(self, "indices", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2063);
// compiled call node returning call2064 (depth = 3)
// compiled member node returning call2064 (depth = 2)
  gc_frame_end(frame);
  return call2064;
}
Object meth_collectionsPrelude__apply2082(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_newInner = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1095
  setline(1095);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2083 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  gc_frame_newslot(*var_i);
// starting to compile call node (depth = 5)
  int callframe2084 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2085 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2086 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2085);
// compiled call node returning call2086 (depth = 7)
// compiled member node returning call2086 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call2087 = callmethod(call2086, "at",
    1, partcv, params);
  gc_frame_end(callframe2084);
// compiled call node returning call2087 (depth = 5)
  gc_frame_newslot(call2087);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newInner (depth = 5)
  params[0] = *var_i;
  params[1] = call2087;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2088 = callmethod(*var_newInner, "at()put",
    2, partcv, params);
  gc_frame_end(callframe2083);
// compiled call node returning call2088 (depth = 4)
  gc_frame_end(frame);
  return call2088;
}
Object meth_collectionsPrelude_expandTo2065(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 34, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "expandTo");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method expandTo");
  Object params[2];
  int partcv[2];
  Object *var__prelude = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for expandTo (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_newSize = &(stackframe->slots[0]);
  *var_newSize = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for expandTo");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newInner = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "newInner");
// Begin line 1093
  setline(1093);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2066 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_newSize (depth = 4)
  gc_frame_newslot(*var_newSize);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2067 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var__prelude (depth = 6)
  partcv[0] = 0;
  Object call2068 = callmethod(*var__prelude, "PrimitiveArray",
    1, partcv, params);
  gc_frame_end(callframe2067);
// compiled call node returning call2068 (depth = 5)
// compiled member node returning call2068 (depth = 4)
  params[0] = *var_newSize;
  partcv[0] = 1;
  Object call2069 = callmethod(call2068, "new",
    1, partcv, params);
  gc_frame_end(callframe2066);
// compiled call node returning call2069 (depth = 3)
  *var_newInner = call2069;
  if (call2069 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1094
  setline(1094);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2070 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2073 = alloc_Float64(1);
// compiled num node returning num2073 (depth = 5)
  int op_slot_right_2072 = gc_frame_newslot(num2073);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2075 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2076 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2075);
// compiled call node returning call2076 (depth = 6)
// compiled member node returning call2076 (depth = 5)
  int op_slot_left_2072 = gc_frame_newslot(call2076);
  params[0] = num2073;
  partcv[0] = 1;
  Object diff2077 = callmethod(call2076, "-", 1, partcv, params);
// compiled op node returning diff2077 (depth = 4)
  int op_slot_right_2071 = gc_frame_newslot(diff2077);
// starting to compile num node (depth = 4)
  Object num2079 = alloc_Float64(0);
// compiled num node returning num2079 (depth = 4)
  int op_slot_left_2071 = gc_frame_newslot(num2079);
  params[0] = diff2077;
  partcv[0] = 1;
  Object opresult2080 = callmethod(num2079, "..", 1, partcv, params);
// compiled op node returning opresult2080 (depth = 3)
  gc_frame_newslot(opresult2080);
// starting to compile block node (depth = 3)
  Object block2081 = alloc_Block(NULL, NULL, "collectionsPrelude", 1094);
  gc_frame_newslot(block2081);
// method _apply
  block_savedest(block2081);
  Object closure2082 = createclosure(2, "_apply");
  setclosureframe(closure2082, stackframe);
  addtoclosure(closure2082, var_newInner);
  addtoclosure(closure2082, selfslot);
  struct UserObject *uo2082 = (struct UserObject*)block2081;
  uo2082->data[0] = (Object)closure2082;
  Method *meth_meth_collectionsPrelude__apply2082 = addmethod2pos(block2081, "_apply", &meth_collectionsPrelude__apply2082, 0);
  int argcv_meth_collectionsPrelude__apply2082[] = {1};
  meth_meth_collectionsPrelude__apply2082->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2082);
  meth_meth_collectionsPrelude__apply2082->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2082->definitionLine = 1094;
// compiled block node returning block2081 (depth = 3)
  gc_frame_newslot(block2081);
// call case 5: prelude request
  params[0] = opresult2080;
  params[1] = block2081;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2090 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2070);
// compiled call node returning call2090 (depth = 2)
// Begin line 1097
  setline(1097);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 1095
  setline(1095);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2091 = gc_frame_new();
// Begin line 1097
  setline(1097);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_newInner (depth = 4)
  gc_frame_newslot(*var_newInner);
// call case 4: self request
  params[0] = *var_newInner;
  partcv[0] = 1;
  Object call2092 = callmethodflags(self, "inner:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2091);
// compiled call node returning call2092 (depth = 3)
// compiled bind node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_sortBy2093(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sortBy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method sortBy");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for sortBy (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_sortBlock = &(stackframe->slots[0]);
  *var_sortBlock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for sortBy");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1100
  setline(1100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 1095
  setline(1095);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2094 = gc_frame_new();
// Begin line 1100
  setline(1100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2096 = alloc_Float64(1);
// compiled num node returning num2096 (depth = 5)
  int op_slot_right_2095 = gc_frame_newslot(num2096);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2098 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2099 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2098);
// compiled call node returning call2099 (depth = 6)
// compiled member node returning call2099 (depth = 5)
  int op_slot_left_2095 = gc_frame_newslot(call2099);
  params[0] = num2096;
  partcv[0] = 1;
  Object sum2100 = callmethod(call2099, "+", 1, partcv, params);
// compiled op node returning sum2100 (depth = 4)
  gc_frame_newslot(sum2100);
// call case 4: self request
  params[0] = sum2100;
  partcv[0] = 1;
  Object call2101 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2094);
// compiled call node returning call2101 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 1101
  setline(1101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2102 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2103 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2104 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2103);
// compiled call node returning call2104 (depth = 4)
// compiled member node returning call2104 (depth = 3)
  gc_frame_newslot(call2104);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sortBlock (depth = 3)
  gc_frame_newslot(*var_sortBlock);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2105 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2106 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2105);
// compiled call node returning call2106 (depth = 4)
// compiled member node returning call2106 (depth = 3)
  params[0] = call2104;
  params[1] = *var_sortBlock;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2107 = callmethod(call2106, "sortInitial()by",
    2, partcv, params);
  gc_frame_end(callframe2102);
// compiled call node returning call2107 (depth = 2)
// Begin line 1102
  setline(1102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply2111(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  Object *var_r = &(stackframe->slots[1]);
  *var_r = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1106
  setline(1106);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_r (depth = 6)
  int op_slot_right_2113 = gc_frame_newslot(*var_r);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_l (depth = 6)
  int op_slot_left_2113 = gc_frame_newslot(*var_l);
  params[0] = *var_r;
  partcv[0] = 1;
  Object opresult2115 = callmethod(*var_l, "==", 1, partcv, params);
// compiled op node returning opresult2115 (depth = 5)
  Object if2112 = done;
  if (istrue(opresult2115)) {
// starting to compile num node (depth = 5)
  Object num2116 = alloc_Float64(0);
// compiled num node returning num2116 (depth = 5)
    gc_frame_newslot(num2116);
    if2112 = num2116;
  } else {
// Begin line 1108
  setline(1108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1107
  setline(1107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_r (depth = 7)
  int op_slot_right_2118 = gc_frame_newslot(*var_r);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_l (depth = 7)
  int op_slot_left_2118 = gc_frame_newslot(*var_l);
  params[0] = *var_r;
  partcv[0] = 1;
  Object opresult2120 = callmethod(*var_l, "<", 1, partcv, params);
// compiled op node returning opresult2120 (depth = 6)
  Object if2117 = done;
  if (istrue(opresult2120)) {
// starting to compile call node (depth = 6)
  int callframe2121 = gc_frame_new();
// call case 6: other member request
// starting to compile num node (depth = 7)
  Object num2122 = alloc_Float64(1);
// compiled num node returning num2122 (depth = 7)
  partcv[0] = 0;
  Object call2123 = callmethod(num2122, "prefix-",
    1, partcv, params);
  gc_frame_end(callframe2121);
// compiled call node returning call2123 (depth = 6)
    gc_frame_newslot(call2123);
    if2117 = call2123;
  } else {
// Begin line 1108
  setline(1108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num2124 = alloc_Float64(1);
// compiled num node returning num2124 (depth = 6)
    gc_frame_newslot(num2124);
    if2117 = num2124;
  }
// compiled if node returning if2117 (depth = 5)
    gc_frame_newslot(if2117);
    if2112 = if2117;
  }
// compiled if node returning if2112 (depth = 4)
  gc_frame_end(frame);
  return if2112;
}
Object meth_collectionsPrelude_sort2108(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sort");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for sort (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for sort");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1105
  setline(1105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2109 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2110 = alloc_Block(NULL, NULL, "collectionsPrelude", 1105);
  gc_frame_newslot(block2110);
// method _apply
  block_savedest(block2110);
  Object closure2111 = createclosure(1, "_apply");
  setclosureframe(closure2111, stackframe);
  addtoclosure(closure2111, selfslot);
  struct UserObject *uo2111 = (struct UserObject*)block2110;
  uo2111->data[0] = (Object)closure2111;
  Method *meth_meth_collectionsPrelude__apply2111 = addmethod2pos(block2110, "_apply", &meth_collectionsPrelude__apply2111, 0);
  int argcv_meth_collectionsPrelude__apply2111[] = {2};
  meth_meth_collectionsPrelude__apply2111->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2111);
  meth_meth_collectionsPrelude__apply2111->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2111->definitionLine = 1101;
// compiled block node returning block2110 (depth = 3)
  gc_frame_newslot(block2110);
// call case 4: self request
  params[0] = block2110;
  partcv[0] = 1;
  Object call2126 = callmethodflags(self, "sortBy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2109);
// compiled call node returning call2126 (depth = 2)
  gc_frame_end(frame);
  return call2126;
}
Object meth_collectionsPrelude_sortedBy2127(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sortedBy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method sortedBy");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for sortedBy (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_sortBlock = &(stackframe->slots[0]);
  *var_sortBlock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for sortedBy");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1112
  setline(1112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2128 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sortBlock (depth = 3)
  gc_frame_newslot(*var_sortBlock);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2129 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2130 = callmethodflags(self, "copy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2129);
// compiled call node returning call2130 (depth = 4)
// compiled member node returning call2130 (depth = 3)
  params[0] = *var_sortBlock;
  partcv[0] = 1;
  Object call2131 = callmethod(call2130, "sortBy",
    1, partcv, params);
  gc_frame_end(callframe2128);
// compiled call node returning call2131 (depth = 2)
  gc_frame_end(frame);
  return call2131;
}
Object meth_collectionsPrelude_sorted2132(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sorted");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for sorted (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for sorted");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1115
  setline(1115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2133 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2134 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2135 = callmethodflags(self, "copy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2134);
// compiled call node returning call2135 (depth = 5)
// compiled member node returning call2135 (depth = 4)
  partcv[0] = 0;
  Object call2136 = callmethod(call2135, "sort",
    1, partcv, params);
  gc_frame_end(callframe2133);
// compiled call node returning call2136 (depth = 3)
// compiled member node returning call2136 (depth = 2)
  gc_frame_end(frame);
  return call2136;
}
Object meth_collectionsPrelude_copy2137(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "copy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for copy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for copy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1118
  setline(1118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2138 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2139 = gc_frame_new();
// call case 3: self.outer request
  Object call2140 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2139);
// compiled call node returning call2140 (depth = 4)
// compiled member node returning call2140 (depth = 3)
  params[0] = self;
  partcv[0] = 1;
  Object call2141 = callmethodflags(call2140, "withAll", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2138);
// compiled call node returning call2141 (depth = 2)
  gc_frame_end(frame);
  return call2141;
}
Object meth_collectionsPrelude__apply2147(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_a = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 4)
// Begin line 1118
  setline(1118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2148 = gc_frame_new();
// Begin line 891
  setline(891);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2150 = alloc_Float64(1);
// compiled num node returning num2150 (depth = 7)
  int op_slot_right_2149 = gc_frame_newslot(num2150);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2153 = alloc_Float64(2);
// compiled num node returning num2153 (depth = 8)
  int op_slot_right_2152 = gc_frame_newslot(num2153);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2155 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_a (depth = 10)
  partcv[0] = 0;
  Object call2156 = callmethod(*var_a, "size",
    1, partcv, params);
  gc_frame_end(callframe2155);
// compiled call node returning call2156 (depth = 9)
// compiled member node returning call2156 (depth = 8)
  int op_slot_left_2152 = gc_frame_newslot(call2156);
  params[0] = num2153;
  partcv[0] = 1;
  Object prod2157 = callmethod(call2156, "*", 1, partcv, params);
// compiled op node returning prod2157 (depth = 7)
  int op_slot_left_2149 = gc_frame_newslot(prod2157);
  params[0] = num2150;
  partcv[0] = 1;
  Object sum2158 = callmethod(prod2157, "+", 1, partcv, params);
// compiled op node returning sum2158 (depth = 6)
  gc_frame_newslot(sum2158);
// call case 4: self request
  params[0] = sum2158;
  partcv[0] = 1;
  Object call2159 = callmethodflags(self, "initialSize:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2148);
// compiled call node returning call2159 (depth = 5)
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude__apply2162(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var__ex = &(stackframe->slots[0]);
  *var__ex = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 4)
// Begin line 891
  setline(891);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2163 = gc_frame_new();
// Begin line 892
  setline(892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num2164 = alloc_Float64(9);
// compiled num node returning num2164 (depth = 6)
  gc_frame_newslot(num2164);
// call case 4: self request
  params[0] = num2164;
  partcv[0] = 1;
  Object call2165 = callmethodflags(self, "initialSize:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2163);
// compiled call node returning call2165 (depth = 5)
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude__apply2185(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 896
  setline(896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2186 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2187 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2188 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2187);
// compiled call node returning call2188 (depth = 6)
// compiled member node returning call2188 (depth = 5)
  gc_frame_newslot(call2188);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_x (depth = 5)
  gc_frame_newslot(*var_x);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2189 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2190 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2189);
// compiled call node returning call2190 (depth = 6)
// compiled member node returning call2190 (depth = 5)
  params[0] = call2188;
  params[1] = *var_x;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2191 = callmethod(call2190, "at()put",
    2, partcv, params);
  gc_frame_end(callframe2186);
// compiled call node returning call2191 (depth = 4)
// Begin line 897
  setline(897);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 896
  setline(896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2192 = gc_frame_new();
// Begin line 897
  setline(897);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2194 = alloc_Float64(1);
// compiled num node returning num2194 (depth = 7)
  int op_slot_right_2193 = gc_frame_newslot(num2194);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2196 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2197 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2196);
// compiled call node returning call2197 (depth = 8)
// compiled member node returning call2197 (depth = 7)
  int op_slot_left_2193 = gc_frame_newslot(call2197);
  params[0] = num2194;
  partcv[0] = 1;
  Object sum2198 = callmethod(call2197, "+", 1, partcv, params);
// compiled op node returning sum2198 (depth = 6)
  gc_frame_newslot(sum2198);
// call case 4: self request
  params[0] = sum2198;
  partcv[0] = 1;
  Object call2199 = callmethodflags(self, "size:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2192);
// compiled call node returning call2199 (depth = 5)
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_withAll763(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "withAll");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method withAll");
  Object params[2];
  int partcv[2];
  Object *var_BoundsError = getfromclosure(closure, 0);
  Object *var_NoSuchObject = getfromclosure(closure, 1);
  Object *var_done = getfromclosure(closure, 2);
  Object *var_Collection = getfromclosure(closure, 3);
  Object *var_ConcurrentModification = getfromclosure(closure, 4);
  Object *var_Exhausted = getfromclosure(closure, 5);
  Object *var_indexable = getfromclosure(closure, 6);
  Object *var__prelude = getfromclosure(closure, 7);
  Object *var_SizeUnknown = getfromclosure(closure, 8);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for withAll (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for withAll");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 595
  setline(595);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit766 == NULL) {
    strlit766 = alloc_String("js");
    gc_root(strlit766);
  }
// compiled string node returning strlit766 (depth = 4)
  int op_slot_right_765 = gc_frame_newslot(strlit766);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe768 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call769 = callmethodflags(prelude, "engine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe768);
// compiled call node returning call769 (depth = 5)
// compiled member node returning call769 (depth = 4)
  int op_slot_left_765 = gc_frame_newslot(call769);
  params[0] = strlit766;
  partcv[0] = 1;
  Object opresult770 = callmethod(call769, "==", 1, partcv, params);
// compiled op node returning opresult770 (depth = 3)
  Object if764 = done;
  if (istrue(opresult770)) {
// Begin line 596
  setline(596);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile object node (depth = 4)
  Object inheritingObject771 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj771 = alloc_userobj2(45,43, objclass771);
  gc_frame_newslot(obj771);
// OBJECT OUTER DEC outer
  adddatum2(obj771, self, 0);
  addmethodreal(obj771,"outer", &reader_collectionsPrelude_outer_772);
  Object oldself771 = self;
  struct StackFrameObject *oldstackframe771 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe771);
  gc_frame_newslot((Object)stackframe);
  self = obj771;
  Object *oldselfslot771 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter771 = (*(struct UserObject *)self).data[0], lowerouter771 = thisouter771;
  if (inheritingObject771) {
    struct UserObject *inho771 = (struct UserObject *)inheritingObject771;
    while (inho771->super != GraceDefaultObject) inho771 = (struct UserObject *)inho771->super;
    inho771->super = obj771;
    self = inheritingObject771;
    *selfslot = self;
    lowerouter771 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter771;
  }
if (objclass771 == NULL) {
  Method *reader773 = addmethodrealflags(obj771, "mods",&reader_collectionsPrelude_mods_773, 0);
  Method *writer773 = addmethodrealflags(obj771, "mods:=",&writer_collectionsPrelude_mods_773, MFLAG_CONFIDENTIAL);
  reader773->definitionModule = modulename;
  writer773->definitionModule = modulename;
  reader773->definitionLine = 599;
  writer773->definitionLine = 599;
}
obj771->flags |= OFLAG_MUTABLE;
adddatum2(obj771, alloc_Undefined(), 1);
if (objclass771 == NULL) {
  Method *reader774 = addmethodrealflags(obj771, "sz",&reader_collectionsPrelude_sz_774, MFLAG_CONFIDENTIAL);
  Method *writer774 = addmethodrealflags(obj771, "sz:=",&writer_collectionsPrelude_sz_774, MFLAG_CONFIDENTIAL);
  reader774->definitionModule = modulename;
  writer774->definitionModule = modulename;
  reader774->definitionLine = 600;
  writer774->definitionLine = 600;
}
obj771->flags |= OFLAG_MUTABLE;
adddatum2(obj771, alloc_Undefined(), 2);
if (objclass771 == NULL) {
  Method *reader775 = addmethodrealflags(obj771, "jsArray",&reader_collectionsPrelude_jsArray_775, MFLAG_CONFIDENTIAL);
  Method *writer775 = addmethodrealflags(obj771, "jsArray:=",&writer_collectionsPrelude_jsArray_775, MFLAG_CONFIDENTIAL);
  reader775->definitionModule = modulename;
  writer775->definitionModule = modulename;
  reader775->definitionLine = 601;
  writer775->definitionLine = 601;
}
obj771->flags |= OFLAG_MUTABLE;
adddatum2(obj771, alloc_Undefined(), 3);
// method boundsCheck
  block_savedest(obj771);
  Object closure776 = createclosure(1, "boundsCheck");
  setclosureframe(closure776, stackframe);
  addtoclosure(closure776, var_BoundsError);
  struct UserObject *uo776 = (struct UserObject*)obj771;
  uo776->data[4] = (Object)closure776;
  Method *meth_meth_collectionsPrelude_boundsCheck776 = addmethod2pos(obj771, "boundsCheck", &meth_collectionsPrelude_boundsCheck776, 4);
  int argcv_meth_collectionsPrelude_boundsCheck776[] = {1};
  meth_meth_collectionsPrelude_boundsCheck776->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_boundsCheck776);
  meth_meth_collectionsPrelude_boundsCheck776->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_boundsCheck776->definitionModule = modulename;
  meth_meth_collectionsPrelude_boundsCheck776->definitionLine = 607;
// method size
  struct UserObject *uo813 = (struct UserObject*)obj771;
  uo813->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_size813 = addmethod2pos(obj771, "size", &meth_collectionsPrelude_size813, 5);
  int argcv_meth_collectionsPrelude_size813[] = {0};
  meth_meth_collectionsPrelude_size813->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size813);
  meth_meth_collectionsPrelude_size813->definitionModule = modulename;
  meth_meth_collectionsPrelude_size813->definitionLine = 620;
// method at
  struct UserObject *uo816 = (struct UserObject*)obj771;
  uo816->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at816 = addmethod2pos(obj771, "at", &meth_collectionsPrelude_at816, 6);
  int argcv_meth_collectionsPrelude_at816[] = {1};
  meth_meth_collectionsPrelude_at816->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at816);
  meth_meth_collectionsPrelude_at816->definitionModule = modulename;
  meth_meth_collectionsPrelude_at816->definitionLine = 625;
// method []
  struct UserObject *uo817 = (struct UserObject*)obj771;
  uo817->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude__91__93_817 = addmethod2pos(obj771, "[]", &meth_collectionsPrelude__91__93_817, 7);
  int argcv_meth_collectionsPrelude__91__93_817[] = {1};
  meth_meth_collectionsPrelude__91__93_817->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__91__93_817);
  meth_meth_collectionsPrelude__91__93_817->definitionModule = modulename;
  meth_meth_collectionsPrelude__91__93_817->definitionLine = 635;
// method at()put
  struct UserObject *uo818 = (struct UserObject*)obj771;
  uo818->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at_40__41_put818 = addmethod2pos(obj771, "at()put", &meth_collectionsPrelude_at_40__41_put818, 8);
  int argcv_meth_collectionsPrelude_at_40__41_put818[] = {1, 1};
  meth_meth_collectionsPrelude_at_40__41_put818->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_at_40__41_put818);
  meth_meth_collectionsPrelude_at_40__41_put818->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40__41_put818->definitionLine = 645;
// method []:=
  struct UserObject *uo827 = (struct UserObject*)obj771;
  uo827->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude__91__93__58__61_827 = addmethod2pos(obj771, "[]:=", &meth_collectionsPrelude__91__93__58__61_827, 9);
  int argcv_meth_collectionsPrelude__91__93__58__61_827[] = {2};
  meth_meth_collectionsPrelude__91__93__58__61_827->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__91__93__58__61_827);
  meth_meth_collectionsPrelude__91__93__58__61_827->definitionModule = modulename;
  meth_meth_collectionsPrelude__91__93__58__61_827->definitionLine = 657;
// method add
  struct UserObject *uo836 = (struct UserObject*)obj771;
  uo836->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_add836 = addmethod2pos(obj771, "add", &meth_collectionsPrelude_add836, 10);
  int argcv_meth_collectionsPrelude_add836[] = {0};
  meth_meth_collectionsPrelude_add836->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_add836);
  meth_meth_collectionsPrelude_add836->definitionModule = modulename;
  meth_meth_collectionsPrelude_add836->definitionLine = 669;
// method push
  struct UserObject *uo854 = (struct UserObject*)obj771;
  uo854->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_push854 = addmethod2pos(obj771, "push", &meth_collectionsPrelude_push854, 11);
  int argcv_meth_collectionsPrelude_push854[] = {1};
  meth_meth_collectionsPrelude_push854->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_push854);
  meth_meth_collectionsPrelude_push854->definitionModule = modulename;
  meth_meth_collectionsPrelude_push854->definitionLine = 679;
// method removeLast
  struct UserObject *uo863 = (struct UserObject*)obj771;
  uo863->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeLast863 = addmethod2pos(obj771, "removeLast", &meth_collectionsPrelude_removeLast863, 12);
  int argcv_meth_collectionsPrelude_removeLast863[] = {0};
  meth_meth_collectionsPrelude_removeLast863->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeLast863);
  meth_meth_collectionsPrelude_removeLast863->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeLast863->definitionLine = 685;
// method addAllFirst
  struct UserObject *uo872 = (struct UserObject*)obj771;
  uo872->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addAllFirst872 = addmethod2pos(obj771, "addAllFirst", &meth_collectionsPrelude_addAllFirst872, 13);
  int argcv_meth_collectionsPrelude_addAllFirst872[] = {1};
  meth_meth_collectionsPrelude_addAllFirst872->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addAllFirst872);
  meth_meth_collectionsPrelude_addAllFirst872->definitionModule = modulename;
  meth_meth_collectionsPrelude_addAllFirst872->definitionLine = 695;
// method removeAt
  struct UserObject *uo902 = (struct UserObject*)obj771;
  uo902->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeAt902 = addmethod2pos(obj771, "removeAt", &meth_collectionsPrelude_removeAt902, 14);
  int argcv_meth_collectionsPrelude_removeAt902[] = {1};
  meth_meth_collectionsPrelude_removeAt902->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAt902);
  meth_meth_collectionsPrelude_removeAt902->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAt902->definitionLine = 706;
// method sortBy
  struct UserObject *uo913 = (struct UserObject*)obj771;
  uo913->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortBy913 = addmethod2pos(obj771, "sortBy", &meth_collectionsPrelude_sortBy913, 15);
  int argcv_meth_collectionsPrelude_sortBy913[] = {1};
  meth_meth_collectionsPrelude_sortBy913->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortBy913);
  meth_meth_collectionsPrelude_sortBy913->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortBy913->definitionLine = 713;
// method addLast
  struct UserObject *uo922 = (struct UserObject*)obj771;
  uo922->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addLast922 = addmethod2pos(obj771, "addLast", &meth_collectionsPrelude_addLast922, 16);
  int argcv_meth_collectionsPrelude_addLast922[] = {0};
  meth_meth_collectionsPrelude_addLast922->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addLast922);
  meth_meth_collectionsPrelude_addLast922->definitionModule = modulename;
  meth_meth_collectionsPrelude_addLast922->definitionLine = 727;
// method addAll
  struct UserObject *uo925 = (struct UserObject*)obj771;
  uo925->data[17] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addAll925 = addmethod2pos(obj771, "addAll", &meth_collectionsPrelude_addAll925, 17);
  int argcv_meth_collectionsPrelude_addAll925[] = {1};
  meth_meth_collectionsPrelude_addAll925->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addAll925);
  meth_meth_collectionsPrelude_addAll925->definitionModule = modulename;
  meth_meth_collectionsPrelude_addAll925->definitionLine = 728;
// method addFirst
  struct UserObject *uo933 = (struct UserObject*)obj771;
  uo933->data[18] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addFirst933 = addmethod2pos(obj771, "addFirst", &meth_collectionsPrelude_addFirst933, 18);
  int argcv_meth_collectionsPrelude_addFirst933[] = {0};
  meth_meth_collectionsPrelude_addFirst933->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addFirst933);
  meth_meth_collectionsPrelude_addFirst933->definitionModule = modulename;
  meth_meth_collectionsPrelude_addFirst933->definitionLine = 733;
// method removeFirst
  struct UserObject *uo936 = (struct UserObject*)obj771;
  uo936->data[19] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeFirst936 = addmethod2pos(obj771, "removeFirst", &meth_collectionsPrelude_removeFirst936, 19);
  int argcv_meth_collectionsPrelude_removeFirst936[] = {0};
  meth_meth_collectionsPrelude_removeFirst936->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeFirst936);
  meth_meth_collectionsPrelude_removeFirst936->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeFirst936->definitionLine = 736;
// method remove
  struct UserObject *uo940 = (struct UserObject*)obj771;
  uo940->data[20] = emptyclosure;
  Method *meth_meth_collectionsPrelude_remove940 = addmethod2pos(obj771, "remove", &meth_collectionsPrelude_remove940, 20);
  int argcv_meth_collectionsPrelude_remove940[] = {0};
  meth_meth_collectionsPrelude_remove940->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_remove940);
  meth_meth_collectionsPrelude_remove940->definitionModule = modulename;
  meth_meth_collectionsPrelude_remove940->definitionLine = 741;
// method remove()ifAbsent
  struct UserObject *uo943 = (struct UserObject*)obj771;
  uo943->data[21] = emptyclosure;
  Method *meth_meth_collectionsPrelude_remove_40__41_ifAbsent943 = addmethod2pos(obj771, "remove()ifAbsent", &meth_collectionsPrelude_remove_40__41_ifAbsent943, 21);
  int argcv_meth_collectionsPrelude_remove_40__41_ifAbsent943[] = {0, 1};
  meth_meth_collectionsPrelude_remove_40__41_ifAbsent943->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_remove_40__41_ifAbsent943);
  meth_meth_collectionsPrelude_remove_40__41_ifAbsent943->definitionModule = modulename;
  meth_meth_collectionsPrelude_remove_40__41_ifAbsent943->definitionLine = 746;
// method removeAll
  block_savedest(obj771);
  Object closure946 = createclosure(1, "removeAll");
  setclosureframe(closure946, stackframe);
  addtoclosure(closure946, var_NoSuchObject);
  struct UserObject *uo946 = (struct UserObject*)obj771;
  uo946->data[22] = (Object)closure946;
  Method *meth_meth_collectionsPrelude_removeAll946 = addmethod2pos(obj771, "removeAll", &meth_collectionsPrelude_removeAll946, 22);
  int argcv_meth_collectionsPrelude_removeAll946[] = {1};
  meth_meth_collectionsPrelude_removeAll946->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAll946);
  meth_meth_collectionsPrelude_removeAll946->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAll946->definitionLine = 751;
// method removeAll()ifAbsent
  struct UserObject *uo955 = (struct UserObject*)obj771;
  uo955->data[23] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeAll_40__41_ifAbsent955 = addmethod2pos(obj771, "removeAll()ifAbsent", &meth_collectionsPrelude_removeAll_40__41_ifAbsent955, 23);
  int argcv_meth_collectionsPrelude_removeAll_40__41_ifAbsent955[] = {1, 1};
  meth_meth_collectionsPrelude_removeAll_40__41_ifAbsent955->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_removeAll_40__41_ifAbsent955);
  meth_meth_collectionsPrelude_removeAll_40__41_ifAbsent955->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAll_40__41_ifAbsent955->definitionLine = 756;
// method pop
  struct UserObject *uo970 = (struct UserObject*)obj771;
  uo970->data[24] = emptyclosure;
  Method *meth_meth_collectionsPrelude_pop970 = addmethod2pos(obj771, "pop", &meth_collectionsPrelude_pop970, 24);
  int argcv_meth_collectionsPrelude_pop970[] = {0};
  meth_meth_collectionsPrelude_pop970->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_pop970);
  meth_meth_collectionsPrelude_pop970->definitionModule = modulename;
  meth_meth_collectionsPrelude_pop970->definitionLine = 765;
// method reversed
  struct UserObject *uo973 = (struct UserObject*)obj771;
  uo973->data[25] = emptyclosure;
  Method *meth_meth_collectionsPrelude_reversed973 = addmethod2pos(obj771, "reversed", &meth_collectionsPrelude_reversed973, 25);
  int argcv_meth_collectionsPrelude_reversed973[] = {0};
  meth_meth_collectionsPrelude_reversed973->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reversed973);
  meth_meth_collectionsPrelude_reversed973->definitionModule = modulename;
  meth_meth_collectionsPrelude_reversed973->definitionLine = 767;
// method reverse
  struct UserObject *uo989 = (struct UserObject*)obj771;
  uo989->data[26] = emptyclosure;
  Method *meth_meth_collectionsPrelude_reverse989 = addmethod2pos(obj771, "reverse", &meth_collectionsPrelude_reverse989, 26);
  int argcv_meth_collectionsPrelude_reverse989[] = {0};
  meth_meth_collectionsPrelude_reverse989->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reverse989);
  meth_meth_collectionsPrelude_reverse989->definitionModule = modulename;
  meth_meth_collectionsPrelude_reverse989->definitionLine = 772;
// method ++
  struct UserObject *uo1030 = (struct UserObject*)obj771;
  uo1030->data[27] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43_1030 = addmethod2pos(obj771, "++", &meth_collectionsPrelude__43__43_1030, 27);
  int argcv_meth_collectionsPrelude__43__43_1030[] = {1};
  meth_meth_collectionsPrelude__43__43_1030->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43_1030);
  meth_meth_collectionsPrelude__43__43_1030->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43_1030->definitionLine = 786;
// method asString
  struct UserObject *uo1041 = (struct UserObject*)obj771;
  uo1041->data[28] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString1041 = addmethod2pos(obj771, "asString", &meth_collectionsPrelude_asString1041, 28);
  int argcv_meth_collectionsPrelude_asString1041[] = {0};
  meth_meth_collectionsPrelude_asString1041->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString1041);
  meth_meth_collectionsPrelude_asString1041->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString1041->definitionLine = 792;
// method extend
  block_savedest(obj771);
  Object closure1075 = createclosure(1, "extend");
  setclosureframe(closure1075, stackframe);
  addtoclosure(closure1075, var_done);
  struct UserObject *uo1075 = (struct UserObject*)obj771;
  uo1075->data[29] = (Object)closure1075;
  Method *meth_meth_collectionsPrelude_extend1075 = addmethod2pos(obj771, "extend", &meth_collectionsPrelude_extend1075, 29);
  int argcv_meth_collectionsPrelude_extend1075[] = {1};
  meth_meth_collectionsPrelude_extend1075->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_extend1075);
  meth_meth_collectionsPrelude_extend1075->definitionModule = modulename;
  meth_meth_collectionsPrelude_extend1075->definitionLine = 803;
// method contains
  struct UserObject *uo1078 = (struct UserObject*)obj771;
  uo1078->data[30] = emptyclosure;
  Method *meth_meth_collectionsPrelude_contains1078 = addmethod2pos(obj771, "contains", &meth_collectionsPrelude_contains1078, 30);
  int argcv_meth_collectionsPrelude_contains1078[] = {1};
  meth_meth_collectionsPrelude_contains1078->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains1078);
  meth_meth_collectionsPrelude_contains1078->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains1078->definitionLine = 806;
// method do
  struct UserObject *uo1090 = (struct UserObject*)obj771;
  uo1090->data[31] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do1090 = addmethod2pos(obj771, "do", &meth_collectionsPrelude_do1090, 31);
  int argcv_meth_collectionsPrelude_do1090[] = {1};
  meth_meth_collectionsPrelude_do1090->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do1090);
  meth_meth_collectionsPrelude_do1090->definitionModule = modulename;
  meth_meth_collectionsPrelude_do1090->definitionLine = 811;
// method ==
  block_savedest(obj771);
  Object closure1114 = createclosure(1, "==");
  setclosureframe(closure1114, stackframe);
  addtoclosure(closure1114, var_Collection);
  struct UserObject *uo1114 = (struct UserObject*)obj771;
  uo1114->data[32] = (Object)closure1114;
  Method *meth_meth_collectionsPrelude__61__61_1114 = addmethod2pos(obj771, "==", &meth_collectionsPrelude__61__61_1114, 32);
  int argcv_meth_collectionsPrelude__61__61_1114[] = {1};
  meth_meth_collectionsPrelude__61__61_1114->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61_1114);
  meth_meth_collectionsPrelude__61__61_1114->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61_1114->definitionLine = 820;
// method iterator
  block_savedest(obj771);
  Object closure1167 = createclosure(2, "iterator");
  setclosureframe(closure1167, stackframe);
  addtoclosure(closure1167, var_ConcurrentModification);
  addtoclosure(closure1167, var_Exhausted);
  struct UserObject *uo1167 = (struct UserObject*)obj771;
  uo1167->data[33] = (Object)closure1167;
  Method *meth_meth_collectionsPrelude_iterator1167 = addmethod2pos(obj771, "iterator", &meth_collectionsPrelude_iterator1167, 33);
  int argcv_meth_collectionsPrelude_iterator1167[] = {0};
  meth_meth_collectionsPrelude_iterator1167->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator1167);
  meth_meth_collectionsPrelude_iterator1167->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator1167->definitionLine = 838;
  block_savedest(obj771);
  Object closure1251 = createclosure(2, "iterator()object");
  setclosureframe(closure1251, stackframe);
  addtoclosure(closure1251, var_ConcurrentModification);
  addtoclosure(closure1251, var_Exhausted);
  Method *meth_meth_collectionsPrelude_iterator1167_object = addmethod2pos(obj771, "iterator()object", &meth_collectionsPrelude_iterator1167_object, 33);
  meth_meth_collectionsPrelude_iterator1167_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator1167_object->definitionLine = 838;
// method values
  struct UserObject *uo1252 = (struct UserObject*)obj771;
  uo1252->data[34] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values1252 = addmethod2pos(obj771, "values", &meth_collectionsPrelude_values1252, 34);
  int argcv_meth_collectionsPrelude_values1252[] = {0};
  meth_meth_collectionsPrelude_values1252->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values1252);
  meth_meth_collectionsPrelude_values1252->definitionModule = modulename;
  meth_meth_collectionsPrelude_values1252->definitionLine = 857;
// method keys
  struct UserObject *uo1253 = (struct UserObject*)obj771;
  uo1253->data[35] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keys1253 = addmethod2pos(obj771, "keys", &meth_collectionsPrelude_keys1253, 35);
  int argcv_meth_collectionsPrelude_keys1253[] = {0};
  meth_meth_collectionsPrelude_keys1253->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys1253);
  meth_meth_collectionsPrelude_keys1253->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys1253->definitionLine = 861;
// method sort
  struct UserObject *uo1256 = (struct UserObject*)obj771;
  uo1256->data[36] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sort1256 = addmethod2pos(obj771, "sort", &meth_collectionsPrelude_sort1256, 36);
  int argcv_meth_collectionsPrelude_sort1256[] = {0};
  meth_meth_collectionsPrelude_sort1256->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sort1256);
  meth_meth_collectionsPrelude_sort1256->definitionModule = modulename;
  meth_meth_collectionsPrelude_sort1256->definitionLine = 865;
// method sortedBy
  struct UserObject *uo1283 = (struct UserObject*)obj771;
  uo1283->data[37] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy1283 = addmethod2pos(obj771, "sortedBy", &meth_collectionsPrelude_sortedBy1283, 37);
  int argcv_meth_collectionsPrelude_sortedBy1283[] = {1};
  meth_meth_collectionsPrelude_sortedBy1283->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy1283);
  meth_meth_collectionsPrelude_sortedBy1283->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy1283->definitionLine = 873;
// method sorted
  struct UserObject *uo1288 = (struct UserObject*)obj771;
  uo1288->data[38] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted1288 = addmethod2pos(obj771, "sorted", &meth_collectionsPrelude_sorted1288, 38);
  int argcv_meth_collectionsPrelude_sorted1288[] = {0};
  meth_meth_collectionsPrelude_sorted1288->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted1288);
  meth_meth_collectionsPrelude_sorted1288->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted1288->definitionLine = 876;
// method copy
  struct UserObject *uo1293 = (struct UserObject*)obj771;
  uo1293->data[39] = emptyclosure;
  Method *meth_meth_collectionsPrelude_copy1293 = addmethod2pos(obj771, "copy", &meth_collectionsPrelude_copy1293, 39);
  int argcv_meth_collectionsPrelude_copy1293[] = {0};
  meth_meth_collectionsPrelude_copy1293->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_copy1293);
  meth_meth_collectionsPrelude_copy1293->definitionModule = modulename;
  meth_meth_collectionsPrelude_copy1293->definitionLine = 879;
  sourceObject = obj771;
// Begin line 597
  setline(597);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1298 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_indexable (depth = 6)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1299 = callmethod(*var_indexable, "trait()object",
    2, partcv, params);
  gc_frame_end(callframe1298);
// compiled call node returning call1299 (depth = 5)
  struct UserObject *obj771_uo = (struct UserObject *)obj771;
  obj771_uo->super = call1299;
  sourceObject = obj771;
// Begin line 599
  setline(599);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num1300 = alloc_Float64(0);
// compiled num node returning num1300 (depth = 5)
  adddatum2(obj771, num1300, 1);
  sourceObject = obj771;
// Begin line 600
  setline(600);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num1301 = alloc_Float64(0);
// compiled num node returning num1301 (depth = 5)
  adddatum2(obj771, num1301, 2);
  sourceObject = obj771;
// Begin line 601
  setline(601);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
// compiled call node returning done (depth = 5)
  adddatum2(obj771, done, 3);
  sourceObject = obj771;
// Begin line 602
  setline(602);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1302 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block1303 = alloc_Block(NULL, NULL, "collectionsPrelude", 602);
  gc_frame_newslot(block1303);
// method _apply
  block_savedest(block1303);
  Object closure1304 = createclosure(1, "_apply");
  setclosureframe(closure1304, stackframe);
  addtoclosure(closure1304, selfslot);
  struct UserObject *uo1304 = (struct UserObject*)block1303;
  uo1304->data[0] = (Object)closure1304;
  Method *meth_meth_collectionsPrelude__apply1304 = addmethod2pos(block1303, "_apply", &meth_collectionsPrelude__apply1304, 0);
  int argcv_meth_collectionsPrelude__apply1304[] = {1};
  meth_meth_collectionsPrelude__apply1304->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1304);
  meth_meth_collectionsPrelude__apply1304->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1304->definitionLine = 880;
// compiled block node returning block1303 (depth = 6)
  gc_frame_newslot(block1303);
// call case 6: other member request
// Begin line 602
  setline(602);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_a (depth = 6)
  params[0] = block1303;
  partcv[0] = 1;
  Object call1306 = callmethod(*var_a, "do",
    1, partcv, params);
  gc_frame_end(callframe1302);
// compiled call node returning call1306 (depth = 5)
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  objclass771 = obj771->class;
  objclass771->definitionModule = modulename;
  objclass771->definitionLine = 596;
  (*(struct UserObject *)self).data[0] = lowerouter771;
  self = oldself771;
  selfslot = oldselfslot771;
  stackframe = oldstackframe771;
// compiled object node returning obj771 (depth = 4)
  return obj771;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if764 = undefined;
  } else {
  }
// compiled if node returning if764 (depth = 2)
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1307 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1307 = alloc_userobj2(47,44, objclass1307);
  gc_frame_newslot(obj1307);
if (objclass1307 == NULL) {
  glfree(obj1307->class->name);
  obj1307->class->name = "obj761.withAll";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1307, self, 0);
  addmethodreal(obj1307,"outer", &reader_collectionsPrelude_outer_1308);
  Object oldself1307 = self;
  struct StackFrameObject *oldstackframe1307 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1307);
  gc_frame_newslot((Object)stackframe);
  self = obj1307;
  Object *oldselfslot1307 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1307 = (*(struct UserObject *)self).data[0], lowerouter1307 = thisouter1307;
  if (inheritingObject1307) {
    struct UserObject *inho1307 = (struct UserObject *)inheritingObject1307;
    while (inho1307->super != GraceDefaultObject) inho1307 = (struct UserObject *)inho1307->super;
    inho1307->super = obj1307;
    self = inheritingObject1307;
    *selfslot = self;
    lowerouter1307 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1307;
  }
if (objclass1307 == NULL) {
  Method *reader1309 = addmethodrealflags(obj1307, "mods",&reader_collectionsPrelude_mods_1309, 0);
  Method *writer1309 = addmethodrealflags(obj1307, "mods:=",&writer_collectionsPrelude_mods_1309, MFLAG_CONFIDENTIAL);
  reader1309->definitionModule = modulename;
  writer1309->definitionModule = modulename;
  reader1309->definitionLine = 889;
  writer1309->definitionLine = 889;
}
obj1307->flags |= OFLAG_MUTABLE;
adddatum2(obj1307, alloc_Undefined(), 1);
if (objclass1307 == NULL) {
  Method *reader1310 = addmethodrealflags(obj1307, "initialSize",&reader_collectionsPrelude_initialSize_1310, MFLAG_CONFIDENTIAL);
  Method *writer1310 = addmethodrealflags(obj1307, "initialSize:=",&writer_collectionsPrelude_initialSize_1310, MFLAG_CONFIDENTIAL);
  reader1310->definitionModule = modulename;
  writer1310->definitionModule = modulename;
  reader1310->definitionLine = 890;
  writer1310->definitionLine = 890;
}
obj1307->flags |= OFLAG_MUTABLE;
adddatum2(obj1307, alloc_Undefined(), 2);
if (objclass1307 == NULL) {
  Method *reader1311 = addmethodrealflags(obj1307, "inner",&reader_collectionsPrelude_inner_1311, MFLAG_CONFIDENTIAL);
  Method *writer1311 = addmethodrealflags(obj1307, "inner:=",&writer_collectionsPrelude_inner_1311, MFLAG_CONFIDENTIAL);
  reader1311->definitionModule = modulename;
  writer1311->definitionModule = modulename;
  reader1311->definitionLine = 893;
  writer1311->definitionLine = 893;
}
obj1307->flags |= OFLAG_MUTABLE;
adddatum2(obj1307, alloc_Undefined(), 3);
if (objclass1307 == NULL) {
  Method *reader1312 = addmethodrealflags(obj1307, "size",&reader_collectionsPrelude_size_1312, 0);
  Method *writer1312 = addmethodrealflags(obj1307, "size:=",&writer_collectionsPrelude_size_1312, MFLAG_CONFIDENTIAL);
  reader1312->definitionModule = modulename;
  writer1312->definitionModule = modulename;
  reader1312->definitionLine = 894;
  writer1312->definitionLine = 894;
}
obj1307->flags |= OFLAG_MUTABLE;
adddatum2(obj1307, alloc_Undefined(), 4);
// method boundsCheck
  block_savedest(obj1307);
  Object closure1313 = createclosure(1, "boundsCheck");
  setclosureframe(closure1313, stackframe);
  addtoclosure(closure1313, var_BoundsError);
  struct UserObject *uo1313 = (struct UserObject*)obj1307;
  uo1313->data[5] = (Object)closure1313;
  Method *meth_meth_collectionsPrelude_boundsCheck1313 = addmethod2pos(obj1307, "boundsCheck", &meth_collectionsPrelude_boundsCheck1313, 5);
  int argcv_meth_collectionsPrelude_boundsCheck1313[] = {1};
  meth_meth_collectionsPrelude_boundsCheck1313->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_boundsCheck1313);
  meth_meth_collectionsPrelude_boundsCheck1313->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_boundsCheck1313->definitionModule = modulename;
  meth_meth_collectionsPrelude_boundsCheck1313->definitionLine = 899;
// method at
  struct UserObject *uo1350 = (struct UserObject*)obj1307;
  uo1350->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at1350 = addmethod2pos(obj1307, "at", &meth_collectionsPrelude_at1350, 6);
  int argcv_meth_collectionsPrelude_at1350[] = {1};
  meth_meth_collectionsPrelude_at1350->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at1350);
  meth_meth_collectionsPrelude_at1350->definitionModule = modulename;
  meth_meth_collectionsPrelude_at1350->definitionLine = 904;
// method []
  struct UserObject *uo1361 = (struct UserObject*)obj1307;
  uo1361->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude__91__93_1361 = addmethod2pos(obj1307, "[]", &meth_collectionsPrelude__91__93_1361, 7);
  int argcv_meth_collectionsPrelude__91__93_1361[] = {1};
  meth_meth_collectionsPrelude__91__93_1361->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__91__93_1361);
  meth_meth_collectionsPrelude__91__93_1361->definitionModule = modulename;
  meth_meth_collectionsPrelude__91__93_1361->definitionLine = 908;
// method at()put
  struct UserObject *uo1372 = (struct UserObject*)obj1307;
  uo1372->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at_40__41_put1372 = addmethod2pos(obj1307, "at()put", &meth_collectionsPrelude_at_40__41_put1372, 8);
  int argcv_meth_collectionsPrelude_at_40__41_put1372[] = {1, 1};
  meth_meth_collectionsPrelude_at_40__41_put1372->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_at_40__41_put1372);
  meth_meth_collectionsPrelude_at_40__41_put1372->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40__41_put1372->definitionLine = 912;
// method []:=
  block_savedest(obj1307);
  Object closure1403 = createclosure(1, "[]:=");
  setclosureframe(closure1403, stackframe);
  addtoclosure(closure1403, var_done);
  struct UserObject *uo1403 = (struct UserObject*)obj1307;
  uo1403->data[9] = (Object)closure1403;
  Method *meth_meth_collectionsPrelude__91__93__58__61_1403 = addmethod2pos(obj1307, "[]:=", &meth_collectionsPrelude__91__93__58__61_1403, 9);
  int argcv_meth_collectionsPrelude__91__93__58__61_1403[] = {2};
  meth_meth_collectionsPrelude__91__93__58__61_1403->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__91__93__58__61_1403);
  meth_meth_collectionsPrelude__91__93__58__61_1403->definitionModule = modulename;
  meth_meth_collectionsPrelude__91__93__58__61_1403->definitionLine = 922;
// method add
  struct UserObject *uo1434 = (struct UserObject*)obj1307;
  uo1434->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_add1434 = addmethod2pos(obj1307, "add", &meth_collectionsPrelude_add1434, 10);
  int argcv_meth_collectionsPrelude_add1434[] = {0};
  meth_meth_collectionsPrelude_add1434->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_add1434);
  meth_meth_collectionsPrelude_add1434->definitionModule = modulename;
  meth_meth_collectionsPrelude_add1434->definitionLine = 932;
// method addAll
  struct UserObject *uo1437 = (struct UserObject*)obj1307;
  uo1437->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addAll1437 = addmethod2pos(obj1307, "addAll", &meth_collectionsPrelude_addAll1437, 11);
  int argcv_meth_collectionsPrelude_addAll1437[] = {1};
  meth_meth_collectionsPrelude_addAll1437->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addAll1437);
  meth_meth_collectionsPrelude_addAll1437->definitionModule = modulename;
  meth_meth_collectionsPrelude_addAll1437->definitionLine = 935;
// method push
  struct UserObject *uo1501 = (struct UserObject*)obj1307;
  uo1501->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_push1501 = addmethod2pos(obj1307, "push", &meth_collectionsPrelude_push1501, 12);
  int argcv_meth_collectionsPrelude_push1501[] = {1};
  meth_meth_collectionsPrelude_push1501->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_push1501);
  meth_meth_collectionsPrelude_push1501->definitionModule = modulename;
  meth_meth_collectionsPrelude_push1501->definitionLine = 946;
// method addLast
  struct UserObject *uo1544 = (struct UserObject*)obj1307;
  uo1544->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addLast1544 = addmethod2pos(obj1307, "addLast", &meth_collectionsPrelude_addLast1544, 13);
  int argcv_meth_collectionsPrelude_addLast1544[] = {0};
  meth_meth_collectionsPrelude_addLast1544->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addLast1544);
  meth_meth_collectionsPrelude_addLast1544->definitionModule = modulename;
  meth_meth_collectionsPrelude_addLast1544->definitionLine = 953;
// method removeLast
  struct UserObject *uo1547 = (struct UserObject*)obj1307;
  uo1547->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeLast1547 = addmethod2pos(obj1307, "removeLast", &meth_collectionsPrelude_removeLast1547, 14);
  int argcv_meth_collectionsPrelude_removeLast1547[] = {0};
  meth_meth_collectionsPrelude_removeLast1547->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeLast1547);
  meth_meth_collectionsPrelude_removeLast1547->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeLast1547->definitionLine = 954;
// method addAllFirst
  struct UserObject *uo1574 = (struct UserObject*)obj1307;
  uo1574->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addAllFirst1574 = addmethod2pos(obj1307, "addAllFirst", &meth_collectionsPrelude_addAllFirst1574, 15);
  int argcv_meth_collectionsPrelude_addAllFirst1574[] = {1};
  meth_meth_collectionsPrelude_addAllFirst1574->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addAllFirst1574);
  meth_meth_collectionsPrelude_addAllFirst1574->definitionModule = modulename;
  meth_meth_collectionsPrelude_addAllFirst1574->definitionLine = 960;
// method addFirst
  struct UserObject *uo1670 = (struct UserObject*)obj1307;
  uo1670->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addFirst1670 = addmethod2pos(obj1307, "addFirst", &meth_collectionsPrelude_addFirst1670, 16);
  int argcv_meth_collectionsPrelude_addFirst1670[] = {0};
  meth_meth_collectionsPrelude_addFirst1670->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addFirst1670);
  meth_meth_collectionsPrelude_addFirst1670->definitionModule = modulename;
  meth_meth_collectionsPrelude_addFirst1670->definitionLine = 977;
// method removeFirst
  struct UserObject *uo1673 = (struct UserObject*)obj1307;
  uo1673->data[17] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeFirst1673 = addmethod2pos(obj1307, "removeFirst", &meth_collectionsPrelude_removeFirst1673, 17);
  int argcv_meth_collectionsPrelude_removeFirst1673[] = {0};
  meth_meth_collectionsPrelude_removeFirst1673->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeFirst1673);
  meth_meth_collectionsPrelude_removeFirst1673->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeFirst1673->definitionLine = 978;
// method removeAt
  struct UserObject *uo1677 = (struct UserObject*)obj1307;
  uo1677->data[18] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeAt1677 = addmethod2pos(obj1307, "removeAt", &meth_collectionsPrelude_removeAt1677, 18);
  int argcv_meth_collectionsPrelude_removeAt1677[] = {1};
  meth_meth_collectionsPrelude_removeAt1677->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAt1677);
  meth_meth_collectionsPrelude_removeAt1677->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAt1677->definitionLine = 981;
// method remove
  struct UserObject *uo1730 = (struct UserObject*)obj1307;
  uo1730->data[19] = emptyclosure;
  Method *meth_meth_collectionsPrelude_remove1730 = addmethod2pos(obj1307, "remove", &meth_collectionsPrelude_remove1730, 19);
  int argcv_meth_collectionsPrelude_remove1730[] = {0};
  meth_meth_collectionsPrelude_remove1730->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_remove1730);
  meth_meth_collectionsPrelude_remove1730->definitionModule = modulename;
  meth_meth_collectionsPrelude_remove1730->definitionLine = 991;
// method remove()ifAbsent
  struct UserObject *uo1733 = (struct UserObject*)obj1307;
  uo1733->data[20] = emptyclosure;
  Method *meth_meth_collectionsPrelude_remove_40__41_ifAbsent1733 = addmethod2pos(obj1307, "remove()ifAbsent", &meth_collectionsPrelude_remove_40__41_ifAbsent1733, 20);
  int argcv_meth_collectionsPrelude_remove_40__41_ifAbsent1733[] = {0, 1};
  meth_meth_collectionsPrelude_remove_40__41_ifAbsent1733->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_remove_40__41_ifAbsent1733);
  meth_meth_collectionsPrelude_remove_40__41_ifAbsent1733->definitionModule = modulename;
  meth_meth_collectionsPrelude_remove_40__41_ifAbsent1733->definitionLine = 994;
// method removeAll
  block_savedest(obj1307);
  Object closure1736 = createclosure(1, "removeAll");
  setclosureframe(closure1736, stackframe);
  addtoclosure(closure1736, var_NoSuchObject);
  struct UserObject *uo1736 = (struct UserObject*)obj1307;
  uo1736->data[21] = (Object)closure1736;
  Method *meth_meth_collectionsPrelude_removeAll1736 = addmethod2pos(obj1307, "removeAll", &meth_collectionsPrelude_removeAll1736, 21);
  int argcv_meth_collectionsPrelude_removeAll1736[] = {1};
  meth_meth_collectionsPrelude_removeAll1736->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAll1736);
  meth_meth_collectionsPrelude_removeAll1736->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAll1736->definitionLine = 997;
// method removeAll()ifAbsent
  struct UserObject *uo1745 = (struct UserObject*)obj1307;
  uo1745->data[22] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeAll_40__41_ifAbsent1745 = addmethod2pos(obj1307, "removeAll()ifAbsent", &meth_collectionsPrelude_removeAll_40__41_ifAbsent1745, 22);
  int argcv_meth_collectionsPrelude_removeAll_40__41_ifAbsent1745[] = {1, 1};
  meth_meth_collectionsPrelude_removeAll_40__41_ifAbsent1745->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_removeAll_40__41_ifAbsent1745);
  meth_meth_collectionsPrelude_removeAll_40__41_ifAbsent1745->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAll_40__41_ifAbsent1745->definitionLine = 1000;
// method pop
  struct UserObject *uo1768 = (struct UserObject*)obj1307;
  uo1768->data[23] = emptyclosure;
  Method *meth_meth_collectionsPrelude_pop1768 = addmethod2pos(obj1307, "pop", &meth_collectionsPrelude_pop1768, 23);
  int argcv_meth_collectionsPrelude_pop1768[] = {0};
  meth_meth_collectionsPrelude_pop1768->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_pop1768);
  meth_meth_collectionsPrelude_pop1768->definitionModule = modulename;
  meth_meth_collectionsPrelude_pop1768->definitionLine = 1008;
// method reversed
  struct UserObject *uo1771 = (struct UserObject*)obj1307;
  uo1771->data[24] = emptyclosure;
  Method *meth_meth_collectionsPrelude_reversed1771 = addmethod2pos(obj1307, "reversed", &meth_collectionsPrelude_reversed1771, 24);
  int argcv_meth_collectionsPrelude_reversed1771[] = {0};
  meth_meth_collectionsPrelude_reversed1771->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reversed1771);
  meth_meth_collectionsPrelude_reversed1771->definitionModule = modulename;
  meth_meth_collectionsPrelude_reversed1771->definitionLine = 1009;
// method reverse
  struct UserObject *uo1787 = (struct UserObject*)obj1307;
  uo1787->data[25] = emptyclosure;
  Method *meth_meth_collectionsPrelude_reverse1787 = addmethod2pos(obj1307, "reverse", &meth_collectionsPrelude_reverse1787, 25);
  int argcv_meth_collectionsPrelude_reverse1787[] = {0};
  meth_meth_collectionsPrelude_reverse1787->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reverse1787);
  meth_meth_collectionsPrelude_reverse1787->definitionModule = modulename;
  meth_meth_collectionsPrelude_reverse1787->definitionLine = 1014;
// method ++
  struct UserObject *uo1828 = (struct UserObject*)obj1307;
  uo1828->data[26] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43_1828 = addmethod2pos(obj1307, "++", &meth_collectionsPrelude__43__43_1828, 26);
  int argcv_meth_collectionsPrelude__43__43_1828[] = {1};
  meth_meth_collectionsPrelude__43__43_1828->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43_1828);
  meth_meth_collectionsPrelude__43__43_1828->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43_1828->definitionLine = 1027;
// method asString
  struct UserObject *uo1839 = (struct UserObject*)obj1307;
  uo1839->data[27] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString1839 = addmethod2pos(obj1307, "asString", &meth_collectionsPrelude_asString1839, 27);
  int argcv_meth_collectionsPrelude_asString1839[] = {0};
  meth_meth_collectionsPrelude_asString1839->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString1839);
  meth_meth_collectionsPrelude_asString1839->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString1839->definitionLine = 1031;
// method contains
  struct UserObject *uo1885 = (struct UserObject*)obj1307;
  uo1885->data[28] = emptyclosure;
  Method *meth_meth_collectionsPrelude_contains1885 = addmethod2pos(obj1307, "contains", &meth_collectionsPrelude_contains1885, 28);
  int argcv_meth_collectionsPrelude_contains1885[] = {1};
  meth_meth_collectionsPrelude_contains1885->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains1885);
  meth_meth_collectionsPrelude_contains1885->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains1885->definitionLine = 1039;
// method do
  struct UserObject *uo1897 = (struct UserObject*)obj1307;
  uo1897->data[29] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do1897 = addmethod2pos(obj1307, "do", &meth_collectionsPrelude_do1897, 29);
  int argcv_meth_collectionsPrelude_do1897[] = {1};
  meth_meth_collectionsPrelude_do1897->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do1897);
  meth_meth_collectionsPrelude_do1897->definitionModule = modulename;
  meth_meth_collectionsPrelude_do1897->definitionLine = 1043;
// method ==
  block_savedest(obj1307);
  Object closure1923 = createclosure(1, "==");
  setclosureframe(closure1923, stackframe);
  addtoclosure(closure1923, var_Collection);
  struct UserObject *uo1923 = (struct UserObject*)obj1307;
  uo1923->data[30] = (Object)closure1923;
  Method *meth_meth_collectionsPrelude__61__61_1923 = addmethod2pos(obj1307, "==", &meth_collectionsPrelude__61__61_1923, 30);
  int argcv_meth_collectionsPrelude__61__61_1923[] = {1};
  meth_meth_collectionsPrelude__61__61_1923->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61_1923);
  meth_meth_collectionsPrelude__61__61_1923->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61_1923->definitionLine = 1051;
// method iterator
  block_savedest(obj1307);
  Object closure1976 = createclosure(2, "iterator");
  setclosureframe(closure1976, stackframe);
  addtoclosure(closure1976, var_ConcurrentModification);
  addtoclosure(closure1976, var_Exhausted);
  struct UserObject *uo1976 = (struct UserObject*)obj1307;
  uo1976->data[31] = (Object)closure1976;
  Method *meth_meth_collectionsPrelude_iterator1976 = addmethod2pos(obj1307, "iterator", &meth_collectionsPrelude_iterator1976, 31);
  int argcv_meth_collectionsPrelude_iterator1976[] = {0};
  meth_meth_collectionsPrelude_iterator1976->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator1976);
  meth_meth_collectionsPrelude_iterator1976->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator1976->definitionLine = 1068;
  block_savedest(obj1307);
  Object closure2060 = createclosure(2, "iterator()object");
  setclosureframe(closure2060, stackframe);
  addtoclosure(closure2060, var_ConcurrentModification);
  addtoclosure(closure2060, var_Exhausted);
  Method *meth_meth_collectionsPrelude_iterator1976_object = addmethod2pos(obj1307, "iterator()object", &meth_collectionsPrelude_iterator1976_object, 31);
  meth_meth_collectionsPrelude_iterator1976_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator1976_object->definitionLine = 1068;
// method values
  struct UserObject *uo2061 = (struct UserObject*)obj1307;
  uo2061->data[32] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values2061 = addmethod2pos(obj1307, "values", &meth_collectionsPrelude_values2061, 32);
  int argcv_meth_collectionsPrelude_values2061[] = {0};
  meth_meth_collectionsPrelude_values2061->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values2061);
  meth_meth_collectionsPrelude_values2061->definitionModule = modulename;
  meth_meth_collectionsPrelude_values2061->definitionLine = 1086;
// method keys
  struct UserObject *uo2062 = (struct UserObject*)obj1307;
  uo2062->data[33] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keys2062 = addmethod2pos(obj1307, "keys", &meth_collectionsPrelude_keys2062, 33);
  int argcv_meth_collectionsPrelude_keys2062[] = {0};
  meth_meth_collectionsPrelude_keys2062->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys2062);
  meth_meth_collectionsPrelude_keys2062->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys2062->definitionLine = 1089;
// method expandTo
  block_savedest(obj1307);
  Object closure2065 = createclosure(1, "expandTo");
  setclosureframe(closure2065, stackframe);
  addtoclosure(closure2065, var__prelude);
  struct UserObject *uo2065 = (struct UserObject*)obj1307;
  uo2065->data[34] = (Object)closure2065;
  Method *meth_meth_collectionsPrelude_expandTo2065 = addmethod2pos(obj1307, "expandTo", &meth_collectionsPrelude_expandTo2065, 34);
  int argcv_meth_collectionsPrelude_expandTo2065[] = {1};
  meth_meth_collectionsPrelude_expandTo2065->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_expandTo2065);
  meth_meth_collectionsPrelude_expandTo2065->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_expandTo2065->definitionModule = modulename;
  meth_meth_collectionsPrelude_expandTo2065->definitionLine = 1092;
// method sortBy
  struct UserObject *uo2093 = (struct UserObject*)obj1307;
  uo2093->data[35] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortBy2093 = addmethod2pos(obj1307, "sortBy", &meth_collectionsPrelude_sortBy2093, 35);
  int argcv_meth_collectionsPrelude_sortBy2093[] = {1};
  meth_meth_collectionsPrelude_sortBy2093->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortBy2093);
  meth_meth_collectionsPrelude_sortBy2093->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortBy2093->definitionLine = 1099;
// method sort
  struct UserObject *uo2108 = (struct UserObject*)obj1307;
  uo2108->data[36] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sort2108 = addmethod2pos(obj1307, "sort", &meth_collectionsPrelude_sort2108, 36);
  int argcv_meth_collectionsPrelude_sort2108[] = {0};
  meth_meth_collectionsPrelude_sort2108->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sort2108);
  meth_meth_collectionsPrelude_sort2108->definitionModule = modulename;
  meth_meth_collectionsPrelude_sort2108->definitionLine = 1104;
// method sortedBy
  struct UserObject *uo2127 = (struct UserObject*)obj1307;
  uo2127->data[37] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy2127 = addmethod2pos(obj1307, "sortedBy", &meth_collectionsPrelude_sortedBy2127, 37);
  int argcv_meth_collectionsPrelude_sortedBy2127[] = {1};
  meth_meth_collectionsPrelude_sortedBy2127->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy2127);
  meth_meth_collectionsPrelude_sortedBy2127->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy2127->definitionLine = 1111;
// method sorted
  struct UserObject *uo2132 = (struct UserObject*)obj1307;
  uo2132->data[38] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted2132 = addmethod2pos(obj1307, "sorted", &meth_collectionsPrelude_sorted2132, 38);
  int argcv_meth_collectionsPrelude_sorted2132[] = {0};
  meth_meth_collectionsPrelude_sorted2132->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted2132);
  meth_meth_collectionsPrelude_sorted2132->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted2132->definitionLine = 1114;
// method copy
  struct UserObject *uo2137 = (struct UserObject*)obj1307;
  uo2137->data[39] = emptyclosure;
  Method *meth_meth_collectionsPrelude_copy2137 = addmethod2pos(obj1307, "copy", &meth_collectionsPrelude_copy2137, 39);
  int argcv_meth_collectionsPrelude_copy2137[] = {0};
  meth_meth_collectionsPrelude_copy2137->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_copy2137);
  meth_meth_collectionsPrelude_copy2137->definitionModule = modulename;
  meth_meth_collectionsPrelude_copy2137->definitionLine = 1117;
  sourceObject = obj1307;
// Begin line 887
  setline(887);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2142 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indexable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2143 = callmethod(*var_indexable, "trait()object",
    2, partcv, params);
  gc_frame_end(callframe2142);
// compiled call node returning call2143 (depth = 2)
  struct UserObject *obj1307_uo = (struct UserObject *)obj1307;
  obj1307_uo->super = call2143;
  sourceObject = obj1307;
// Begin line 889
  setline(889);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2144 = alloc_Float64(0);
// compiled num node returning num2144 (depth = 2)
  adddatum2(obj1307, num2144, 1);
  sourceObject = obj1307;
  adddatum2(obj1307, undefined, 2);
  sourceObject = obj1307;
// Begin line 891
  setline(891);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile catchcase node (depth = 2)
// starting to compile block node (depth = 3)
  Object block2146 = alloc_Block(NULL, NULL, "collectionsPrelude", 891);
  gc_frame_newslot(block2146);
// method _apply
  block_savedest(block2146);
  Object closure2147 = createclosure(2, "_apply");
  setclosureframe(closure2147, stackframe);
  addtoclosure(closure2147, var_a);
  addtoclosure(closure2147, selfslot);
  struct UserObject *uo2147 = (struct UserObject*)block2146;
  uo2147->data[0] = (Object)closure2147;
  Method *meth_meth_collectionsPrelude__apply2147 = addmethod2pos(block2146, "_apply", &meth_collectionsPrelude__apply2147, 0);
  int argcv_meth_collectionsPrelude__apply2147[] = {0};
  meth_meth_collectionsPrelude__apply2147->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2147);
  meth_meth_collectionsPrelude__apply2147->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2147->definitionLine = 1118;
// compiled block node returning block2146 (depth = 3)
  int frame2145 = gc_frame_new();
  gc_frame_newslot(block2146);
// Begin line 892
  setline(892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block2161 = alloc_Block(NULL, NULL, "collectionsPrelude", 892);
  gc_frame_newslot(block2161);
// method _apply
  block_savedest(block2161);
  Object closure2162 = createclosure(1, "_apply");
  setclosureframe(closure2162, stackframe);
  addtoclosure(closure2162, selfslot);
  struct UserObject *uo2162 = (struct UserObject*)block2161;
  uo2162->data[0] = (Object)closure2162;
  Method *meth_meth_collectionsPrelude__apply2162 = addmethod2pos(block2161, "_apply", &meth_collectionsPrelude__apply2162, 0);
  int argcv_meth_collectionsPrelude__apply2162[] = {1};
  meth_meth_collectionsPrelude__apply2162->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2162);
  meth_meth_collectionsPrelude__apply2162->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2162->definitionLine = 891;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2167 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe2168 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit2169 == NULL) {
    strlit2169 = alloc_String("_ex");
    gc_root(strlit2169);
  }
// compiled string node returning strlit2169 (depth = 6)
  gc_frame_newslot(strlit2169);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2170 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call2171 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2170);
// compiled call node returning call2171 (depth = 7)
// compiled member node returning call2171 (depth = 6)
  params[0] = strlit2169;
  partcv[0] = 1;
  Object call2172 = callmethod(call2171, "new",
    1, partcv, params);
  gc_frame_end(callframe2168);
// compiled call node returning call2172 (depth = 5)
  gc_frame_newslot(call2172);
// Begin line 892
  setline(892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_SizeUnknown (depth = 5)
  gc_frame_newslot(*var_SizeUnknown);
// call case 6: other member request
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2173 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call2174 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2173);
// compiled call node returning call2174 (depth = 6)
// compiled member node returning call2174 (depth = 5)
  params[0] = call2172;
  params[1] = *var_SizeUnknown;
  partcv[0] = 2;
  Object call2175 = callmethod(call2174, "new",
    1, partcv, params);
  gc_frame_end(callframe2167);
// compiled call node returning call2175 (depth = 4)
((struct UserObject *)block2161)->data[1] = call2175;
// compiled block node returning block2161 (depth = 3)
  gc_frame_newslot(block2161);
  params[0] = block2161;
  setline(891);
  Object catchres2145 = catchCase(block2146, params, 1,NULL);
  gc_frame_end(frame2145);
// compiled catchcase node returning catchres2145 (depth = 2)
  sourceObject = obj1307;
// Begin line 893
  setline(893);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2176 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2177 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2178 = callmethodflags(self, "initialSize", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2177);
// compiled call node returning call2178 (depth = 4)
// compiled member node returning call2178 (depth = 3)
  gc_frame_newslot(call2178);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2179 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var__prelude (depth = 5)
  partcv[0] = 0;
  Object call2180 = callmethod(*var__prelude, "PrimitiveArray",
    1, partcv, params);
  gc_frame_end(callframe2179);
// compiled call node returning call2180 (depth = 4)
// compiled member node returning call2180 (depth = 3)
  params[0] = call2178;
  partcv[0] = 1;
  Object call2181 = callmethod(call2180, "new",
    1, partcv, params);
  gc_frame_end(callframe2176);
// compiled call node returning call2181 (depth = 2)
  adddatum2(obj1307, call2181, 3);
  sourceObject = obj1307;
// Begin line 894
  setline(894);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2182 = alloc_Float64(0);
// compiled num node returning num2182 (depth = 2)
  adddatum2(obj1307, num2182, 4);
  sourceObject = obj1307;
// Begin line 895
  setline(895);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2183 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_a (depth = 3)
  gc_frame_newslot(*var_a);
// starting to compile block node (depth = 3)
  Object block2184 = alloc_Block(NULL, NULL, "collectionsPrelude", 895);
  gc_frame_newslot(block2184);
// method _apply
  block_savedest(block2184);
  Object closure2185 = createclosure(1, "_apply");
  setclosureframe(closure2185, stackframe);
  addtoclosure(closure2185, selfslot);
  struct UserObject *uo2185 = (struct UserObject*)block2184;
  uo2185->data[0] = (Object)closure2185;
  Method *meth_meth_collectionsPrelude__apply2185 = addmethod2pos(block2184, "_apply", &meth_collectionsPrelude__apply2185, 0);
  int argcv_meth_collectionsPrelude__apply2185[] = {1};
  meth_meth_collectionsPrelude__apply2185->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2185);
  meth_meth_collectionsPrelude__apply2185->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2185->definitionLine = 893;
// compiled block node returning block2184 (depth = 3)
  gc_frame_newslot(block2184);
// call case 5: prelude request
  params[0] = *var_a;
  params[1] = block2184;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2201 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2183);
// compiled call node returning call2201 (depth = 2)
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  objclass1307 = obj1307->class;
  objclass1307->definitionModule = modulename;
  objclass1307->definitionLine = 885;
  (*(struct UserObject *)self).data[0] = lowerouter1307;
  self = oldself1307;
  selfslot = oldselfslot1307;
  stackframe = oldstackframe1307;
  gc_frame_end(frame);
  return obj1307;
}
Object meth_collectionsPrelude_withAll763_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "withAll()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method withAll()object");
  Object params[2];
  int partcv[2];
  Object *var_BoundsError = getfromclosure(closure, 0);
  Object *var_NoSuchObject = getfromclosure(closure, 1);
  Object *var_done = getfromclosure(closure, 2);
  Object *var_Collection = getfromclosure(closure, 3);
  Object *var_ConcurrentModification = getfromclosure(closure, 4);
  Object *var_Exhausted = getfromclosure(closure, 5);
  Object *var_indexable = getfromclosure(closure, 6);
  Object *var__prelude = getfromclosure(closure, 7);
  Object *var_SizeUnknown = getfromclosure(closure, 8);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for withAll (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for withAll");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 595
  setline(595);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit766 == NULL) {
    strlit766 = alloc_String("js");
    gc_root(strlit766);
  }
// compiled string node returning strlit766 (depth = 4)
  int op_slot_right_765 = gc_frame_newslot(strlit766);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe768 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call769 = callmethodflags(prelude, "engine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe768);
// compiled call node returning call769 (depth = 5)
// compiled member node returning call769 (depth = 4)
  int op_slot_left_765 = gc_frame_newslot(call769);
  params[0] = strlit766;
  partcv[0] = 1;
  Object opresult770 = callmethod(call769, "==", 1, partcv, params);
// compiled op node returning opresult770 (depth = 3)
  Object if764 = done;
  if (istrue(opresult770)) {
// Begin line 596
  setline(596);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile object node (depth = 4)
  Object inheritingObject771 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj771 = alloc_userobj2(45,43, objclass771);
  gc_frame_newslot(obj771);
// OBJECT OUTER DEC outer
  adddatum2(obj771, self, 0);
  addmethodreal(obj771,"outer", &reader_collectionsPrelude_outer_772);
  Object oldself771 = self;
  struct StackFrameObject *oldstackframe771 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe771);
  gc_frame_newslot((Object)stackframe);
  self = obj771;
  Object *oldselfslot771 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter771 = (*(struct UserObject *)self).data[0], lowerouter771 = thisouter771;
  if (inheritingObject771) {
    struct UserObject *inho771 = (struct UserObject *)inheritingObject771;
    while (inho771->super != GraceDefaultObject) inho771 = (struct UserObject *)inho771->super;
    inho771->super = obj771;
    self = inheritingObject771;
    *selfslot = self;
    lowerouter771 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter771;
  }
if (objclass771 == NULL) {
  Method *reader773 = addmethodrealflags(obj771, "mods",&reader_collectionsPrelude_mods_773, 0);
  Method *writer773 = addmethodrealflags(obj771, "mods:=",&writer_collectionsPrelude_mods_773, MFLAG_CONFIDENTIAL);
  reader773->definitionModule = modulename;
  writer773->definitionModule = modulename;
  reader773->definitionLine = 599;
  writer773->definitionLine = 599;
}
obj771->flags |= OFLAG_MUTABLE;
adddatum2(obj771, alloc_Undefined(), 1);
if (objclass771 == NULL) {
  Method *reader774 = addmethodrealflags(obj771, "sz",&reader_collectionsPrelude_sz_774, MFLAG_CONFIDENTIAL);
  Method *writer774 = addmethodrealflags(obj771, "sz:=",&writer_collectionsPrelude_sz_774, MFLAG_CONFIDENTIAL);
  reader774->definitionModule = modulename;
  writer774->definitionModule = modulename;
  reader774->definitionLine = 600;
  writer774->definitionLine = 600;
}
obj771->flags |= OFLAG_MUTABLE;
adddatum2(obj771, alloc_Undefined(), 2);
if (objclass771 == NULL) {
  Method *reader775 = addmethodrealflags(obj771, "jsArray",&reader_collectionsPrelude_jsArray_775, MFLAG_CONFIDENTIAL);
  Method *writer775 = addmethodrealflags(obj771, "jsArray:=",&writer_collectionsPrelude_jsArray_775, MFLAG_CONFIDENTIAL);
  reader775->definitionModule = modulename;
  writer775->definitionModule = modulename;
  reader775->definitionLine = 601;
  writer775->definitionLine = 601;
}
obj771->flags |= OFLAG_MUTABLE;
adddatum2(obj771, alloc_Undefined(), 3);
// method boundsCheck
  block_savedest(obj771);
  Object closure776 = createclosure(1, "boundsCheck");
  setclosureframe(closure776, stackframe);
  addtoclosure(closure776, var_BoundsError);
  struct UserObject *uo776 = (struct UserObject*)obj771;
  uo776->data[4] = (Object)closure776;
  Method *meth_meth_collectionsPrelude_boundsCheck776 = addmethod2pos(obj771, "boundsCheck", &meth_collectionsPrelude_boundsCheck776, 4);
  int argcv_meth_collectionsPrelude_boundsCheck776[] = {1};
  meth_meth_collectionsPrelude_boundsCheck776->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_boundsCheck776);
  meth_meth_collectionsPrelude_boundsCheck776->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_boundsCheck776->definitionModule = modulename;
  meth_meth_collectionsPrelude_boundsCheck776->definitionLine = 607;
// method size
  struct UserObject *uo813 = (struct UserObject*)obj771;
  uo813->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_size813 = addmethod2pos(obj771, "size", &meth_collectionsPrelude_size813, 5);
  int argcv_meth_collectionsPrelude_size813[] = {0};
  meth_meth_collectionsPrelude_size813->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size813);
  meth_meth_collectionsPrelude_size813->definitionModule = modulename;
  meth_meth_collectionsPrelude_size813->definitionLine = 620;
// method at
  struct UserObject *uo816 = (struct UserObject*)obj771;
  uo816->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at816 = addmethod2pos(obj771, "at", &meth_collectionsPrelude_at816, 6);
  int argcv_meth_collectionsPrelude_at816[] = {1};
  meth_meth_collectionsPrelude_at816->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at816);
  meth_meth_collectionsPrelude_at816->definitionModule = modulename;
  meth_meth_collectionsPrelude_at816->definitionLine = 625;
// method []
  struct UserObject *uo817 = (struct UserObject*)obj771;
  uo817->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude__91__93_817 = addmethod2pos(obj771, "[]", &meth_collectionsPrelude__91__93_817, 7);
  int argcv_meth_collectionsPrelude__91__93_817[] = {1};
  meth_meth_collectionsPrelude__91__93_817->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__91__93_817);
  meth_meth_collectionsPrelude__91__93_817->definitionModule = modulename;
  meth_meth_collectionsPrelude__91__93_817->definitionLine = 635;
// method at()put
  struct UserObject *uo818 = (struct UserObject*)obj771;
  uo818->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at_40__41_put818 = addmethod2pos(obj771, "at()put", &meth_collectionsPrelude_at_40__41_put818, 8);
  int argcv_meth_collectionsPrelude_at_40__41_put818[] = {1, 1};
  meth_meth_collectionsPrelude_at_40__41_put818->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_at_40__41_put818);
  meth_meth_collectionsPrelude_at_40__41_put818->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40__41_put818->definitionLine = 645;
// method []:=
  struct UserObject *uo827 = (struct UserObject*)obj771;
  uo827->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude__91__93__58__61_827 = addmethod2pos(obj771, "[]:=", &meth_collectionsPrelude__91__93__58__61_827, 9);
  int argcv_meth_collectionsPrelude__91__93__58__61_827[] = {2};
  meth_meth_collectionsPrelude__91__93__58__61_827->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__91__93__58__61_827);
  meth_meth_collectionsPrelude__91__93__58__61_827->definitionModule = modulename;
  meth_meth_collectionsPrelude__91__93__58__61_827->definitionLine = 657;
// method add
  struct UserObject *uo836 = (struct UserObject*)obj771;
  uo836->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_add836 = addmethod2pos(obj771, "add", &meth_collectionsPrelude_add836, 10);
  int argcv_meth_collectionsPrelude_add836[] = {0};
  meth_meth_collectionsPrelude_add836->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_add836);
  meth_meth_collectionsPrelude_add836->definitionModule = modulename;
  meth_meth_collectionsPrelude_add836->definitionLine = 669;
// method push
  struct UserObject *uo854 = (struct UserObject*)obj771;
  uo854->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_push854 = addmethod2pos(obj771, "push", &meth_collectionsPrelude_push854, 11);
  int argcv_meth_collectionsPrelude_push854[] = {1};
  meth_meth_collectionsPrelude_push854->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_push854);
  meth_meth_collectionsPrelude_push854->definitionModule = modulename;
  meth_meth_collectionsPrelude_push854->definitionLine = 679;
// method removeLast
  struct UserObject *uo863 = (struct UserObject*)obj771;
  uo863->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeLast863 = addmethod2pos(obj771, "removeLast", &meth_collectionsPrelude_removeLast863, 12);
  int argcv_meth_collectionsPrelude_removeLast863[] = {0};
  meth_meth_collectionsPrelude_removeLast863->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeLast863);
  meth_meth_collectionsPrelude_removeLast863->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeLast863->definitionLine = 685;
// method addAllFirst
  struct UserObject *uo872 = (struct UserObject*)obj771;
  uo872->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addAllFirst872 = addmethod2pos(obj771, "addAllFirst", &meth_collectionsPrelude_addAllFirst872, 13);
  int argcv_meth_collectionsPrelude_addAllFirst872[] = {1};
  meth_meth_collectionsPrelude_addAllFirst872->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addAllFirst872);
  meth_meth_collectionsPrelude_addAllFirst872->definitionModule = modulename;
  meth_meth_collectionsPrelude_addAllFirst872->definitionLine = 695;
// method removeAt
  struct UserObject *uo902 = (struct UserObject*)obj771;
  uo902->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeAt902 = addmethod2pos(obj771, "removeAt", &meth_collectionsPrelude_removeAt902, 14);
  int argcv_meth_collectionsPrelude_removeAt902[] = {1};
  meth_meth_collectionsPrelude_removeAt902->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAt902);
  meth_meth_collectionsPrelude_removeAt902->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAt902->definitionLine = 706;
// method sortBy
  struct UserObject *uo913 = (struct UserObject*)obj771;
  uo913->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortBy913 = addmethod2pos(obj771, "sortBy", &meth_collectionsPrelude_sortBy913, 15);
  int argcv_meth_collectionsPrelude_sortBy913[] = {1};
  meth_meth_collectionsPrelude_sortBy913->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortBy913);
  meth_meth_collectionsPrelude_sortBy913->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortBy913->definitionLine = 713;
// method addLast
  struct UserObject *uo922 = (struct UserObject*)obj771;
  uo922->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addLast922 = addmethod2pos(obj771, "addLast", &meth_collectionsPrelude_addLast922, 16);
  int argcv_meth_collectionsPrelude_addLast922[] = {0};
  meth_meth_collectionsPrelude_addLast922->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addLast922);
  meth_meth_collectionsPrelude_addLast922->definitionModule = modulename;
  meth_meth_collectionsPrelude_addLast922->definitionLine = 727;
// method addAll
  struct UserObject *uo925 = (struct UserObject*)obj771;
  uo925->data[17] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addAll925 = addmethod2pos(obj771, "addAll", &meth_collectionsPrelude_addAll925, 17);
  int argcv_meth_collectionsPrelude_addAll925[] = {1};
  meth_meth_collectionsPrelude_addAll925->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addAll925);
  meth_meth_collectionsPrelude_addAll925->definitionModule = modulename;
  meth_meth_collectionsPrelude_addAll925->definitionLine = 728;
// method addFirst
  struct UserObject *uo933 = (struct UserObject*)obj771;
  uo933->data[18] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addFirst933 = addmethod2pos(obj771, "addFirst", &meth_collectionsPrelude_addFirst933, 18);
  int argcv_meth_collectionsPrelude_addFirst933[] = {0};
  meth_meth_collectionsPrelude_addFirst933->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addFirst933);
  meth_meth_collectionsPrelude_addFirst933->definitionModule = modulename;
  meth_meth_collectionsPrelude_addFirst933->definitionLine = 733;
// method removeFirst
  struct UserObject *uo936 = (struct UserObject*)obj771;
  uo936->data[19] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeFirst936 = addmethod2pos(obj771, "removeFirst", &meth_collectionsPrelude_removeFirst936, 19);
  int argcv_meth_collectionsPrelude_removeFirst936[] = {0};
  meth_meth_collectionsPrelude_removeFirst936->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeFirst936);
  meth_meth_collectionsPrelude_removeFirst936->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeFirst936->definitionLine = 736;
// method remove
  struct UserObject *uo940 = (struct UserObject*)obj771;
  uo940->data[20] = emptyclosure;
  Method *meth_meth_collectionsPrelude_remove940 = addmethod2pos(obj771, "remove", &meth_collectionsPrelude_remove940, 20);
  int argcv_meth_collectionsPrelude_remove940[] = {0};
  meth_meth_collectionsPrelude_remove940->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_remove940);
  meth_meth_collectionsPrelude_remove940->definitionModule = modulename;
  meth_meth_collectionsPrelude_remove940->definitionLine = 741;
// method remove()ifAbsent
  struct UserObject *uo943 = (struct UserObject*)obj771;
  uo943->data[21] = emptyclosure;
  Method *meth_meth_collectionsPrelude_remove_40__41_ifAbsent943 = addmethod2pos(obj771, "remove()ifAbsent", &meth_collectionsPrelude_remove_40__41_ifAbsent943, 21);
  int argcv_meth_collectionsPrelude_remove_40__41_ifAbsent943[] = {0, 1};
  meth_meth_collectionsPrelude_remove_40__41_ifAbsent943->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_remove_40__41_ifAbsent943);
  meth_meth_collectionsPrelude_remove_40__41_ifAbsent943->definitionModule = modulename;
  meth_meth_collectionsPrelude_remove_40__41_ifAbsent943->definitionLine = 746;
// method removeAll
  block_savedest(obj771);
  Object closure946 = createclosure(1, "removeAll");
  setclosureframe(closure946, stackframe);
  addtoclosure(closure946, var_NoSuchObject);
  struct UserObject *uo946 = (struct UserObject*)obj771;
  uo946->data[22] = (Object)closure946;
  Method *meth_meth_collectionsPrelude_removeAll946 = addmethod2pos(obj771, "removeAll", &meth_collectionsPrelude_removeAll946, 22);
  int argcv_meth_collectionsPrelude_removeAll946[] = {1};
  meth_meth_collectionsPrelude_removeAll946->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAll946);
  meth_meth_collectionsPrelude_removeAll946->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAll946->definitionLine = 751;
// method removeAll()ifAbsent
  struct UserObject *uo955 = (struct UserObject*)obj771;
  uo955->data[23] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeAll_40__41_ifAbsent955 = addmethod2pos(obj771, "removeAll()ifAbsent", &meth_collectionsPrelude_removeAll_40__41_ifAbsent955, 23);
  int argcv_meth_collectionsPrelude_removeAll_40__41_ifAbsent955[] = {1, 1};
  meth_meth_collectionsPrelude_removeAll_40__41_ifAbsent955->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_removeAll_40__41_ifAbsent955);
  meth_meth_collectionsPrelude_removeAll_40__41_ifAbsent955->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAll_40__41_ifAbsent955->definitionLine = 756;
// method pop
  struct UserObject *uo970 = (struct UserObject*)obj771;
  uo970->data[24] = emptyclosure;
  Method *meth_meth_collectionsPrelude_pop970 = addmethod2pos(obj771, "pop", &meth_collectionsPrelude_pop970, 24);
  int argcv_meth_collectionsPrelude_pop970[] = {0};
  meth_meth_collectionsPrelude_pop970->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_pop970);
  meth_meth_collectionsPrelude_pop970->definitionModule = modulename;
  meth_meth_collectionsPrelude_pop970->definitionLine = 765;
// method reversed
  struct UserObject *uo973 = (struct UserObject*)obj771;
  uo973->data[25] = emptyclosure;
  Method *meth_meth_collectionsPrelude_reversed973 = addmethod2pos(obj771, "reversed", &meth_collectionsPrelude_reversed973, 25);
  int argcv_meth_collectionsPrelude_reversed973[] = {0};
  meth_meth_collectionsPrelude_reversed973->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reversed973);
  meth_meth_collectionsPrelude_reversed973->definitionModule = modulename;
  meth_meth_collectionsPrelude_reversed973->definitionLine = 767;
// method reverse
  struct UserObject *uo989 = (struct UserObject*)obj771;
  uo989->data[26] = emptyclosure;
  Method *meth_meth_collectionsPrelude_reverse989 = addmethod2pos(obj771, "reverse", &meth_collectionsPrelude_reverse989, 26);
  int argcv_meth_collectionsPrelude_reverse989[] = {0};
  meth_meth_collectionsPrelude_reverse989->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reverse989);
  meth_meth_collectionsPrelude_reverse989->definitionModule = modulename;
  meth_meth_collectionsPrelude_reverse989->definitionLine = 772;
// method ++
  struct UserObject *uo1030 = (struct UserObject*)obj771;
  uo1030->data[27] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43_1030 = addmethod2pos(obj771, "++", &meth_collectionsPrelude__43__43_1030, 27);
  int argcv_meth_collectionsPrelude__43__43_1030[] = {1};
  meth_meth_collectionsPrelude__43__43_1030->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43_1030);
  meth_meth_collectionsPrelude__43__43_1030->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43_1030->definitionLine = 786;
// method asString
  struct UserObject *uo1041 = (struct UserObject*)obj771;
  uo1041->data[28] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString1041 = addmethod2pos(obj771, "asString", &meth_collectionsPrelude_asString1041, 28);
  int argcv_meth_collectionsPrelude_asString1041[] = {0};
  meth_meth_collectionsPrelude_asString1041->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString1041);
  meth_meth_collectionsPrelude_asString1041->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString1041->definitionLine = 792;
// method extend
  block_savedest(obj771);
  Object closure1075 = createclosure(1, "extend");
  setclosureframe(closure1075, stackframe);
  addtoclosure(closure1075, var_done);
  struct UserObject *uo1075 = (struct UserObject*)obj771;
  uo1075->data[29] = (Object)closure1075;
  Method *meth_meth_collectionsPrelude_extend1075 = addmethod2pos(obj771, "extend", &meth_collectionsPrelude_extend1075, 29);
  int argcv_meth_collectionsPrelude_extend1075[] = {1};
  meth_meth_collectionsPrelude_extend1075->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_extend1075);
  meth_meth_collectionsPrelude_extend1075->definitionModule = modulename;
  meth_meth_collectionsPrelude_extend1075->definitionLine = 803;
// method contains
  struct UserObject *uo1078 = (struct UserObject*)obj771;
  uo1078->data[30] = emptyclosure;
  Method *meth_meth_collectionsPrelude_contains1078 = addmethod2pos(obj771, "contains", &meth_collectionsPrelude_contains1078, 30);
  int argcv_meth_collectionsPrelude_contains1078[] = {1};
  meth_meth_collectionsPrelude_contains1078->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains1078);
  meth_meth_collectionsPrelude_contains1078->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains1078->definitionLine = 806;
// method do
  struct UserObject *uo1090 = (struct UserObject*)obj771;
  uo1090->data[31] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do1090 = addmethod2pos(obj771, "do", &meth_collectionsPrelude_do1090, 31);
  int argcv_meth_collectionsPrelude_do1090[] = {1};
  meth_meth_collectionsPrelude_do1090->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do1090);
  meth_meth_collectionsPrelude_do1090->definitionModule = modulename;
  meth_meth_collectionsPrelude_do1090->definitionLine = 811;
// method ==
  block_savedest(obj771);
  Object closure1114 = createclosure(1, "==");
  setclosureframe(closure1114, stackframe);
  addtoclosure(closure1114, var_Collection);
  struct UserObject *uo1114 = (struct UserObject*)obj771;
  uo1114->data[32] = (Object)closure1114;
  Method *meth_meth_collectionsPrelude__61__61_1114 = addmethod2pos(obj771, "==", &meth_collectionsPrelude__61__61_1114, 32);
  int argcv_meth_collectionsPrelude__61__61_1114[] = {1};
  meth_meth_collectionsPrelude__61__61_1114->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61_1114);
  meth_meth_collectionsPrelude__61__61_1114->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61_1114->definitionLine = 820;
// method iterator
  block_savedest(obj771);
  Object closure1167 = createclosure(2, "iterator");
  setclosureframe(closure1167, stackframe);
  addtoclosure(closure1167, var_ConcurrentModification);
  addtoclosure(closure1167, var_Exhausted);
  struct UserObject *uo1167 = (struct UserObject*)obj771;
  uo1167->data[33] = (Object)closure1167;
  Method *meth_meth_collectionsPrelude_iterator1167 = addmethod2pos(obj771, "iterator", &meth_collectionsPrelude_iterator1167, 33);
  int argcv_meth_collectionsPrelude_iterator1167[] = {0};
  meth_meth_collectionsPrelude_iterator1167->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator1167);
  meth_meth_collectionsPrelude_iterator1167->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator1167->definitionLine = 838;
  block_savedest(obj771);
  Object closure1251 = createclosure(2, "iterator()object");
  setclosureframe(closure1251, stackframe);
  addtoclosure(closure1251, var_ConcurrentModification);
  addtoclosure(closure1251, var_Exhausted);
  Method *meth_meth_collectionsPrelude_iterator1167_object = addmethod2pos(obj771, "iterator()object", &meth_collectionsPrelude_iterator1167_object, 33);
  meth_meth_collectionsPrelude_iterator1167_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator1167_object->definitionLine = 838;
// method values
  struct UserObject *uo1252 = (struct UserObject*)obj771;
  uo1252->data[34] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values1252 = addmethod2pos(obj771, "values", &meth_collectionsPrelude_values1252, 34);
  int argcv_meth_collectionsPrelude_values1252[] = {0};
  meth_meth_collectionsPrelude_values1252->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values1252);
  meth_meth_collectionsPrelude_values1252->definitionModule = modulename;
  meth_meth_collectionsPrelude_values1252->definitionLine = 857;
// method keys
  struct UserObject *uo1253 = (struct UserObject*)obj771;
  uo1253->data[35] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keys1253 = addmethod2pos(obj771, "keys", &meth_collectionsPrelude_keys1253, 35);
  int argcv_meth_collectionsPrelude_keys1253[] = {0};
  meth_meth_collectionsPrelude_keys1253->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys1253);
  meth_meth_collectionsPrelude_keys1253->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys1253->definitionLine = 861;
// method sort
  struct UserObject *uo1256 = (struct UserObject*)obj771;
  uo1256->data[36] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sort1256 = addmethod2pos(obj771, "sort", &meth_collectionsPrelude_sort1256, 36);
  int argcv_meth_collectionsPrelude_sort1256[] = {0};
  meth_meth_collectionsPrelude_sort1256->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sort1256);
  meth_meth_collectionsPrelude_sort1256->definitionModule = modulename;
  meth_meth_collectionsPrelude_sort1256->definitionLine = 865;
// method sortedBy
  struct UserObject *uo1283 = (struct UserObject*)obj771;
  uo1283->data[37] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy1283 = addmethod2pos(obj771, "sortedBy", &meth_collectionsPrelude_sortedBy1283, 37);
  int argcv_meth_collectionsPrelude_sortedBy1283[] = {1};
  meth_meth_collectionsPrelude_sortedBy1283->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy1283);
  meth_meth_collectionsPrelude_sortedBy1283->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy1283->definitionLine = 873;
// method sorted
  struct UserObject *uo1288 = (struct UserObject*)obj771;
  uo1288->data[38] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted1288 = addmethod2pos(obj771, "sorted", &meth_collectionsPrelude_sorted1288, 38);
  int argcv_meth_collectionsPrelude_sorted1288[] = {0};
  meth_meth_collectionsPrelude_sorted1288->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted1288);
  meth_meth_collectionsPrelude_sorted1288->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted1288->definitionLine = 876;
// method copy
  struct UserObject *uo1293 = (struct UserObject*)obj771;
  uo1293->data[39] = emptyclosure;
  Method *meth_meth_collectionsPrelude_copy1293 = addmethod2pos(obj771, "copy", &meth_collectionsPrelude_copy1293, 39);
  int argcv_meth_collectionsPrelude_copy1293[] = {0};
  meth_meth_collectionsPrelude_copy1293->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_copy1293);
  meth_meth_collectionsPrelude_copy1293->definitionModule = modulename;
  meth_meth_collectionsPrelude_copy1293->definitionLine = 879;
  sourceObject = obj771;
// Begin line 597
  setline(597);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1298 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_indexable (depth = 6)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1299 = callmethod(*var_indexable, "trait()object",
    2, partcv, params);
  gc_frame_end(callframe1298);
// compiled call node returning call1299 (depth = 5)
  struct UserObject *obj771_uo = (struct UserObject *)obj771;
  obj771_uo->super = call1299;
  sourceObject = obj771;
// Begin line 599
  setline(599);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num1300 = alloc_Float64(0);
// compiled num node returning num1300 (depth = 5)
  adddatum2(obj771, num1300, 1);
  sourceObject = obj771;
// Begin line 600
  setline(600);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num1301 = alloc_Float64(0);
// compiled num node returning num1301 (depth = 5)
  adddatum2(obj771, num1301, 2);
  sourceObject = obj771;
// Begin line 601
  setline(601);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
// compiled call node returning done (depth = 5)
  adddatum2(obj771, done, 3);
  sourceObject = obj771;
// Begin line 602
  setline(602);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1302 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block1303 = alloc_Block(NULL, NULL, "collectionsPrelude", 602);
  gc_frame_newslot(block1303);
// method _apply
  block_savedest(block1303);
  Object closure1304 = createclosure(1, "_apply");
  setclosureframe(closure1304, stackframe);
  addtoclosure(closure1304, selfslot);
  struct UserObject *uo1304 = (struct UserObject*)block1303;
  uo1304->data[0] = (Object)closure1304;
  Method *meth_meth_collectionsPrelude__apply1304 = addmethod2pos(block1303, "_apply", &meth_collectionsPrelude__apply1304, 0);
  int argcv_meth_collectionsPrelude__apply1304[] = {1};
  meth_meth_collectionsPrelude__apply1304->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1304);
  meth_meth_collectionsPrelude__apply1304->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1304->definitionLine = 880;
// compiled block node returning block1303 (depth = 6)
  gc_frame_newslot(block1303);
// call case 6: other member request
// Begin line 602
  setline(602);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_a (depth = 6)
  params[0] = block1303;
  partcv[0] = 1;
  Object call1306 = callmethod(*var_a, "do",
    1, partcv, params);
  gc_frame_end(callframe1302);
// compiled call node returning call1306 (depth = 5)
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  sourceObject = obj771;
  objclass771 = obj771->class;
  objclass771->definitionModule = modulename;
  objclass771->definitionLine = 596;
  (*(struct UserObject *)self).data[0] = lowerouter771;
  self = oldself771;
  selfslot = oldselfslot771;
  stackframe = oldstackframe771;
// compiled object node returning obj771 (depth = 4)
  return obj771;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if764 = undefined;
  } else {
  }
// compiled if node returning if764 (depth = 2)
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1307 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1307 = alloc_userobj2(47,44, objclass1307);
  gc_frame_newslot(obj1307);
if (objclass1307 == NULL) {
  glfree(obj1307->class->name);
  obj1307->class->name = "obj761.withAll";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1307, self, 0);
  addmethodreal(obj1307,"outer", &reader_collectionsPrelude_outer_1308);
  Object oldself1307 = self;
  struct StackFrameObject *oldstackframe1307 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1307);
  gc_frame_newslot((Object)stackframe);
  self = obj1307;
  Object *oldselfslot1307 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1307 = (*(struct UserObject *)self).data[0], lowerouter1307 = thisouter1307;
  if (inheritingObject1307) {
    struct UserObject *inho1307 = (struct UserObject *)inheritingObject1307;
    while (inho1307->super != GraceDefaultObject) inho1307 = (struct UserObject *)inho1307->super;
    inho1307->super = obj1307;
    self = inheritingObject1307;
    *selfslot = self;
    lowerouter1307 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1307;
  }
if (objclass1307 == NULL) {
  Method *reader1309 = addmethodrealflags(obj1307, "mods",&reader_collectionsPrelude_mods_1309, 0);
  Method *writer1309 = addmethodrealflags(obj1307, "mods:=",&writer_collectionsPrelude_mods_1309, MFLAG_CONFIDENTIAL);
  reader1309->definitionModule = modulename;
  writer1309->definitionModule = modulename;
  reader1309->definitionLine = 889;
  writer1309->definitionLine = 889;
}
obj1307->flags |= OFLAG_MUTABLE;
adddatum2(obj1307, alloc_Undefined(), 1);
if (objclass1307 == NULL) {
  Method *reader1310 = addmethodrealflags(obj1307, "initialSize",&reader_collectionsPrelude_initialSize_1310, MFLAG_CONFIDENTIAL);
  Method *writer1310 = addmethodrealflags(obj1307, "initialSize:=",&writer_collectionsPrelude_initialSize_1310, MFLAG_CONFIDENTIAL);
  reader1310->definitionModule = modulename;
  writer1310->definitionModule = modulename;
  reader1310->definitionLine = 890;
  writer1310->definitionLine = 890;
}
obj1307->flags |= OFLAG_MUTABLE;
adddatum2(obj1307, alloc_Undefined(), 2);
if (objclass1307 == NULL) {
  Method *reader1311 = addmethodrealflags(obj1307, "inner",&reader_collectionsPrelude_inner_1311, MFLAG_CONFIDENTIAL);
  Method *writer1311 = addmethodrealflags(obj1307, "inner:=",&writer_collectionsPrelude_inner_1311, MFLAG_CONFIDENTIAL);
  reader1311->definitionModule = modulename;
  writer1311->definitionModule = modulename;
  reader1311->definitionLine = 893;
  writer1311->definitionLine = 893;
}
obj1307->flags |= OFLAG_MUTABLE;
adddatum2(obj1307, alloc_Undefined(), 3);
if (objclass1307 == NULL) {
  Method *reader1312 = addmethodrealflags(obj1307, "size",&reader_collectionsPrelude_size_1312, 0);
  Method *writer1312 = addmethodrealflags(obj1307, "size:=",&writer_collectionsPrelude_size_1312, MFLAG_CONFIDENTIAL);
  reader1312->definitionModule = modulename;
  writer1312->definitionModule = modulename;
  reader1312->definitionLine = 894;
  writer1312->definitionLine = 894;
}
obj1307->flags |= OFLAG_MUTABLE;
adddatum2(obj1307, alloc_Undefined(), 4);
// method boundsCheck
  block_savedest(obj1307);
  Object closure1313 = createclosure(1, "boundsCheck");
  setclosureframe(closure1313, stackframe);
  addtoclosure(closure1313, var_BoundsError);
  struct UserObject *uo1313 = (struct UserObject*)obj1307;
  uo1313->data[5] = (Object)closure1313;
  Method *meth_meth_collectionsPrelude_boundsCheck1313 = addmethod2pos(obj1307, "boundsCheck", &meth_collectionsPrelude_boundsCheck1313, 5);
  int argcv_meth_collectionsPrelude_boundsCheck1313[] = {1};
  meth_meth_collectionsPrelude_boundsCheck1313->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_boundsCheck1313);
  meth_meth_collectionsPrelude_boundsCheck1313->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_boundsCheck1313->definitionModule = modulename;
  meth_meth_collectionsPrelude_boundsCheck1313->definitionLine = 899;
// method at
  struct UserObject *uo1350 = (struct UserObject*)obj1307;
  uo1350->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at1350 = addmethod2pos(obj1307, "at", &meth_collectionsPrelude_at1350, 6);
  int argcv_meth_collectionsPrelude_at1350[] = {1};
  meth_meth_collectionsPrelude_at1350->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at1350);
  meth_meth_collectionsPrelude_at1350->definitionModule = modulename;
  meth_meth_collectionsPrelude_at1350->definitionLine = 904;
// method []
  struct UserObject *uo1361 = (struct UserObject*)obj1307;
  uo1361->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude__91__93_1361 = addmethod2pos(obj1307, "[]", &meth_collectionsPrelude__91__93_1361, 7);
  int argcv_meth_collectionsPrelude__91__93_1361[] = {1};
  meth_meth_collectionsPrelude__91__93_1361->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__91__93_1361);
  meth_meth_collectionsPrelude__91__93_1361->definitionModule = modulename;
  meth_meth_collectionsPrelude__91__93_1361->definitionLine = 908;
// method at()put
  struct UserObject *uo1372 = (struct UserObject*)obj1307;
  uo1372->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at_40__41_put1372 = addmethod2pos(obj1307, "at()put", &meth_collectionsPrelude_at_40__41_put1372, 8);
  int argcv_meth_collectionsPrelude_at_40__41_put1372[] = {1, 1};
  meth_meth_collectionsPrelude_at_40__41_put1372->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_at_40__41_put1372);
  meth_meth_collectionsPrelude_at_40__41_put1372->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40__41_put1372->definitionLine = 912;
// method []:=
  block_savedest(obj1307);
  Object closure1403 = createclosure(1, "[]:=");
  setclosureframe(closure1403, stackframe);
  addtoclosure(closure1403, var_done);
  struct UserObject *uo1403 = (struct UserObject*)obj1307;
  uo1403->data[9] = (Object)closure1403;
  Method *meth_meth_collectionsPrelude__91__93__58__61_1403 = addmethod2pos(obj1307, "[]:=", &meth_collectionsPrelude__91__93__58__61_1403, 9);
  int argcv_meth_collectionsPrelude__91__93__58__61_1403[] = {2};
  meth_meth_collectionsPrelude__91__93__58__61_1403->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__91__93__58__61_1403);
  meth_meth_collectionsPrelude__91__93__58__61_1403->definitionModule = modulename;
  meth_meth_collectionsPrelude__91__93__58__61_1403->definitionLine = 922;
// method add
  struct UserObject *uo1434 = (struct UserObject*)obj1307;
  uo1434->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_add1434 = addmethod2pos(obj1307, "add", &meth_collectionsPrelude_add1434, 10);
  int argcv_meth_collectionsPrelude_add1434[] = {0};
  meth_meth_collectionsPrelude_add1434->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_add1434);
  meth_meth_collectionsPrelude_add1434->definitionModule = modulename;
  meth_meth_collectionsPrelude_add1434->definitionLine = 932;
// method addAll
  struct UserObject *uo1437 = (struct UserObject*)obj1307;
  uo1437->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addAll1437 = addmethod2pos(obj1307, "addAll", &meth_collectionsPrelude_addAll1437, 11);
  int argcv_meth_collectionsPrelude_addAll1437[] = {1};
  meth_meth_collectionsPrelude_addAll1437->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addAll1437);
  meth_meth_collectionsPrelude_addAll1437->definitionModule = modulename;
  meth_meth_collectionsPrelude_addAll1437->definitionLine = 935;
// method push
  struct UserObject *uo1501 = (struct UserObject*)obj1307;
  uo1501->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_push1501 = addmethod2pos(obj1307, "push", &meth_collectionsPrelude_push1501, 12);
  int argcv_meth_collectionsPrelude_push1501[] = {1};
  meth_meth_collectionsPrelude_push1501->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_push1501);
  meth_meth_collectionsPrelude_push1501->definitionModule = modulename;
  meth_meth_collectionsPrelude_push1501->definitionLine = 946;
// method addLast
  struct UserObject *uo1544 = (struct UserObject*)obj1307;
  uo1544->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addLast1544 = addmethod2pos(obj1307, "addLast", &meth_collectionsPrelude_addLast1544, 13);
  int argcv_meth_collectionsPrelude_addLast1544[] = {0};
  meth_meth_collectionsPrelude_addLast1544->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addLast1544);
  meth_meth_collectionsPrelude_addLast1544->definitionModule = modulename;
  meth_meth_collectionsPrelude_addLast1544->definitionLine = 953;
// method removeLast
  struct UserObject *uo1547 = (struct UserObject*)obj1307;
  uo1547->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeLast1547 = addmethod2pos(obj1307, "removeLast", &meth_collectionsPrelude_removeLast1547, 14);
  int argcv_meth_collectionsPrelude_removeLast1547[] = {0};
  meth_meth_collectionsPrelude_removeLast1547->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeLast1547);
  meth_meth_collectionsPrelude_removeLast1547->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeLast1547->definitionLine = 954;
// method addAllFirst
  struct UserObject *uo1574 = (struct UserObject*)obj1307;
  uo1574->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addAllFirst1574 = addmethod2pos(obj1307, "addAllFirst", &meth_collectionsPrelude_addAllFirst1574, 15);
  int argcv_meth_collectionsPrelude_addAllFirst1574[] = {1};
  meth_meth_collectionsPrelude_addAllFirst1574->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addAllFirst1574);
  meth_meth_collectionsPrelude_addAllFirst1574->definitionModule = modulename;
  meth_meth_collectionsPrelude_addAllFirst1574->definitionLine = 960;
// method addFirst
  struct UserObject *uo1670 = (struct UserObject*)obj1307;
  uo1670->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addFirst1670 = addmethod2pos(obj1307, "addFirst", &meth_collectionsPrelude_addFirst1670, 16);
  int argcv_meth_collectionsPrelude_addFirst1670[] = {0};
  meth_meth_collectionsPrelude_addFirst1670->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addFirst1670);
  meth_meth_collectionsPrelude_addFirst1670->definitionModule = modulename;
  meth_meth_collectionsPrelude_addFirst1670->definitionLine = 977;
// method removeFirst
  struct UserObject *uo1673 = (struct UserObject*)obj1307;
  uo1673->data[17] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeFirst1673 = addmethod2pos(obj1307, "removeFirst", &meth_collectionsPrelude_removeFirst1673, 17);
  int argcv_meth_collectionsPrelude_removeFirst1673[] = {0};
  meth_meth_collectionsPrelude_removeFirst1673->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeFirst1673);
  meth_meth_collectionsPrelude_removeFirst1673->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeFirst1673->definitionLine = 978;
// method removeAt
  struct UserObject *uo1677 = (struct UserObject*)obj1307;
  uo1677->data[18] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeAt1677 = addmethod2pos(obj1307, "removeAt", &meth_collectionsPrelude_removeAt1677, 18);
  int argcv_meth_collectionsPrelude_removeAt1677[] = {1};
  meth_meth_collectionsPrelude_removeAt1677->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAt1677);
  meth_meth_collectionsPrelude_removeAt1677->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAt1677->definitionLine = 981;
// method remove
  struct UserObject *uo1730 = (struct UserObject*)obj1307;
  uo1730->data[19] = emptyclosure;
  Method *meth_meth_collectionsPrelude_remove1730 = addmethod2pos(obj1307, "remove", &meth_collectionsPrelude_remove1730, 19);
  int argcv_meth_collectionsPrelude_remove1730[] = {0};
  meth_meth_collectionsPrelude_remove1730->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_remove1730);
  meth_meth_collectionsPrelude_remove1730->definitionModule = modulename;
  meth_meth_collectionsPrelude_remove1730->definitionLine = 991;
// method remove()ifAbsent
  struct UserObject *uo1733 = (struct UserObject*)obj1307;
  uo1733->data[20] = emptyclosure;
  Method *meth_meth_collectionsPrelude_remove_40__41_ifAbsent1733 = addmethod2pos(obj1307, "remove()ifAbsent", &meth_collectionsPrelude_remove_40__41_ifAbsent1733, 20);
  int argcv_meth_collectionsPrelude_remove_40__41_ifAbsent1733[] = {0, 1};
  meth_meth_collectionsPrelude_remove_40__41_ifAbsent1733->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_remove_40__41_ifAbsent1733);
  meth_meth_collectionsPrelude_remove_40__41_ifAbsent1733->definitionModule = modulename;
  meth_meth_collectionsPrelude_remove_40__41_ifAbsent1733->definitionLine = 994;
// method removeAll
  block_savedest(obj1307);
  Object closure1736 = createclosure(1, "removeAll");
  setclosureframe(closure1736, stackframe);
  addtoclosure(closure1736, var_NoSuchObject);
  struct UserObject *uo1736 = (struct UserObject*)obj1307;
  uo1736->data[21] = (Object)closure1736;
  Method *meth_meth_collectionsPrelude_removeAll1736 = addmethod2pos(obj1307, "removeAll", &meth_collectionsPrelude_removeAll1736, 21);
  int argcv_meth_collectionsPrelude_removeAll1736[] = {1};
  meth_meth_collectionsPrelude_removeAll1736->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAll1736);
  meth_meth_collectionsPrelude_removeAll1736->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAll1736->definitionLine = 997;
// method removeAll()ifAbsent
  struct UserObject *uo1745 = (struct UserObject*)obj1307;
  uo1745->data[22] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeAll_40__41_ifAbsent1745 = addmethod2pos(obj1307, "removeAll()ifAbsent", &meth_collectionsPrelude_removeAll_40__41_ifAbsent1745, 22);
  int argcv_meth_collectionsPrelude_removeAll_40__41_ifAbsent1745[] = {1, 1};
  meth_meth_collectionsPrelude_removeAll_40__41_ifAbsent1745->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_removeAll_40__41_ifAbsent1745);
  meth_meth_collectionsPrelude_removeAll_40__41_ifAbsent1745->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAll_40__41_ifAbsent1745->definitionLine = 1000;
// method pop
  struct UserObject *uo1768 = (struct UserObject*)obj1307;
  uo1768->data[23] = emptyclosure;
  Method *meth_meth_collectionsPrelude_pop1768 = addmethod2pos(obj1307, "pop", &meth_collectionsPrelude_pop1768, 23);
  int argcv_meth_collectionsPrelude_pop1768[] = {0};
  meth_meth_collectionsPrelude_pop1768->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_pop1768);
  meth_meth_collectionsPrelude_pop1768->definitionModule = modulename;
  meth_meth_collectionsPrelude_pop1768->definitionLine = 1008;
// method reversed
  struct UserObject *uo1771 = (struct UserObject*)obj1307;
  uo1771->data[24] = emptyclosure;
  Method *meth_meth_collectionsPrelude_reversed1771 = addmethod2pos(obj1307, "reversed", &meth_collectionsPrelude_reversed1771, 24);
  int argcv_meth_collectionsPrelude_reversed1771[] = {0};
  meth_meth_collectionsPrelude_reversed1771->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reversed1771);
  meth_meth_collectionsPrelude_reversed1771->definitionModule = modulename;
  meth_meth_collectionsPrelude_reversed1771->definitionLine = 1009;
// method reverse
  struct UserObject *uo1787 = (struct UserObject*)obj1307;
  uo1787->data[25] = emptyclosure;
  Method *meth_meth_collectionsPrelude_reverse1787 = addmethod2pos(obj1307, "reverse", &meth_collectionsPrelude_reverse1787, 25);
  int argcv_meth_collectionsPrelude_reverse1787[] = {0};
  meth_meth_collectionsPrelude_reverse1787->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reverse1787);
  meth_meth_collectionsPrelude_reverse1787->definitionModule = modulename;
  meth_meth_collectionsPrelude_reverse1787->definitionLine = 1014;
// method ++
  struct UserObject *uo1828 = (struct UserObject*)obj1307;
  uo1828->data[26] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43_1828 = addmethod2pos(obj1307, "++", &meth_collectionsPrelude__43__43_1828, 26);
  int argcv_meth_collectionsPrelude__43__43_1828[] = {1};
  meth_meth_collectionsPrelude__43__43_1828->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43_1828);
  meth_meth_collectionsPrelude__43__43_1828->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43_1828->definitionLine = 1027;
// method asString
  struct UserObject *uo1839 = (struct UserObject*)obj1307;
  uo1839->data[27] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString1839 = addmethod2pos(obj1307, "asString", &meth_collectionsPrelude_asString1839, 27);
  int argcv_meth_collectionsPrelude_asString1839[] = {0};
  meth_meth_collectionsPrelude_asString1839->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString1839);
  meth_meth_collectionsPrelude_asString1839->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString1839->definitionLine = 1031;
// method contains
  struct UserObject *uo1885 = (struct UserObject*)obj1307;
  uo1885->data[28] = emptyclosure;
  Method *meth_meth_collectionsPrelude_contains1885 = addmethod2pos(obj1307, "contains", &meth_collectionsPrelude_contains1885, 28);
  int argcv_meth_collectionsPrelude_contains1885[] = {1};
  meth_meth_collectionsPrelude_contains1885->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains1885);
  meth_meth_collectionsPrelude_contains1885->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains1885->definitionLine = 1039;
// method do
  struct UserObject *uo1897 = (struct UserObject*)obj1307;
  uo1897->data[29] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do1897 = addmethod2pos(obj1307, "do", &meth_collectionsPrelude_do1897, 29);
  int argcv_meth_collectionsPrelude_do1897[] = {1};
  meth_meth_collectionsPrelude_do1897->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do1897);
  meth_meth_collectionsPrelude_do1897->definitionModule = modulename;
  meth_meth_collectionsPrelude_do1897->definitionLine = 1043;
// method ==
  block_savedest(obj1307);
  Object closure1923 = createclosure(1, "==");
  setclosureframe(closure1923, stackframe);
  addtoclosure(closure1923, var_Collection);
  struct UserObject *uo1923 = (struct UserObject*)obj1307;
  uo1923->data[30] = (Object)closure1923;
  Method *meth_meth_collectionsPrelude__61__61_1923 = addmethod2pos(obj1307, "==", &meth_collectionsPrelude__61__61_1923, 30);
  int argcv_meth_collectionsPrelude__61__61_1923[] = {1};
  meth_meth_collectionsPrelude__61__61_1923->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61_1923);
  meth_meth_collectionsPrelude__61__61_1923->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61_1923->definitionLine = 1051;
// method iterator
  block_savedest(obj1307);
  Object closure1976 = createclosure(2, "iterator");
  setclosureframe(closure1976, stackframe);
  addtoclosure(closure1976, var_ConcurrentModification);
  addtoclosure(closure1976, var_Exhausted);
  struct UserObject *uo1976 = (struct UserObject*)obj1307;
  uo1976->data[31] = (Object)closure1976;
  Method *meth_meth_collectionsPrelude_iterator1976 = addmethod2pos(obj1307, "iterator", &meth_collectionsPrelude_iterator1976, 31);
  int argcv_meth_collectionsPrelude_iterator1976[] = {0};
  meth_meth_collectionsPrelude_iterator1976->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator1976);
  meth_meth_collectionsPrelude_iterator1976->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator1976->definitionLine = 1068;
  block_savedest(obj1307);
  Object closure2060 = createclosure(2, "iterator()object");
  setclosureframe(closure2060, stackframe);
  addtoclosure(closure2060, var_ConcurrentModification);
  addtoclosure(closure2060, var_Exhausted);
  Method *meth_meth_collectionsPrelude_iterator1976_object = addmethod2pos(obj1307, "iterator()object", &meth_collectionsPrelude_iterator1976_object, 31);
  meth_meth_collectionsPrelude_iterator1976_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator1976_object->definitionLine = 1068;
// method values
  struct UserObject *uo2061 = (struct UserObject*)obj1307;
  uo2061->data[32] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values2061 = addmethod2pos(obj1307, "values", &meth_collectionsPrelude_values2061, 32);
  int argcv_meth_collectionsPrelude_values2061[] = {0};
  meth_meth_collectionsPrelude_values2061->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values2061);
  meth_meth_collectionsPrelude_values2061->definitionModule = modulename;
  meth_meth_collectionsPrelude_values2061->definitionLine = 1086;
// method keys
  struct UserObject *uo2062 = (struct UserObject*)obj1307;
  uo2062->data[33] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keys2062 = addmethod2pos(obj1307, "keys", &meth_collectionsPrelude_keys2062, 33);
  int argcv_meth_collectionsPrelude_keys2062[] = {0};
  meth_meth_collectionsPrelude_keys2062->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys2062);
  meth_meth_collectionsPrelude_keys2062->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys2062->definitionLine = 1089;
// method expandTo
  block_savedest(obj1307);
  Object closure2065 = createclosure(1, "expandTo");
  setclosureframe(closure2065, stackframe);
  addtoclosure(closure2065, var__prelude);
  struct UserObject *uo2065 = (struct UserObject*)obj1307;
  uo2065->data[34] = (Object)closure2065;
  Method *meth_meth_collectionsPrelude_expandTo2065 = addmethod2pos(obj1307, "expandTo", &meth_collectionsPrelude_expandTo2065, 34);
  int argcv_meth_collectionsPrelude_expandTo2065[] = {1};
  meth_meth_collectionsPrelude_expandTo2065->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_expandTo2065);
  meth_meth_collectionsPrelude_expandTo2065->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_expandTo2065->definitionModule = modulename;
  meth_meth_collectionsPrelude_expandTo2065->definitionLine = 1092;
// method sortBy
  struct UserObject *uo2093 = (struct UserObject*)obj1307;
  uo2093->data[35] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortBy2093 = addmethod2pos(obj1307, "sortBy", &meth_collectionsPrelude_sortBy2093, 35);
  int argcv_meth_collectionsPrelude_sortBy2093[] = {1};
  meth_meth_collectionsPrelude_sortBy2093->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortBy2093);
  meth_meth_collectionsPrelude_sortBy2093->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortBy2093->definitionLine = 1099;
// method sort
  struct UserObject *uo2108 = (struct UserObject*)obj1307;
  uo2108->data[36] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sort2108 = addmethod2pos(obj1307, "sort", &meth_collectionsPrelude_sort2108, 36);
  int argcv_meth_collectionsPrelude_sort2108[] = {0};
  meth_meth_collectionsPrelude_sort2108->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sort2108);
  meth_meth_collectionsPrelude_sort2108->definitionModule = modulename;
  meth_meth_collectionsPrelude_sort2108->definitionLine = 1104;
// method sortedBy
  struct UserObject *uo2127 = (struct UserObject*)obj1307;
  uo2127->data[37] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy2127 = addmethod2pos(obj1307, "sortedBy", &meth_collectionsPrelude_sortedBy2127, 37);
  int argcv_meth_collectionsPrelude_sortedBy2127[] = {1};
  meth_meth_collectionsPrelude_sortedBy2127->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy2127);
  meth_meth_collectionsPrelude_sortedBy2127->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy2127->definitionLine = 1111;
// method sorted
  struct UserObject *uo2132 = (struct UserObject*)obj1307;
  uo2132->data[38] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted2132 = addmethod2pos(obj1307, "sorted", &meth_collectionsPrelude_sorted2132, 38);
  int argcv_meth_collectionsPrelude_sorted2132[] = {0};
  meth_meth_collectionsPrelude_sorted2132->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted2132);
  meth_meth_collectionsPrelude_sorted2132->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted2132->definitionLine = 1114;
// method copy
  struct UserObject *uo2137 = (struct UserObject*)obj1307;
  uo2137->data[39] = emptyclosure;
  Method *meth_meth_collectionsPrelude_copy2137 = addmethod2pos(obj1307, "copy", &meth_collectionsPrelude_copy2137, 39);
  int argcv_meth_collectionsPrelude_copy2137[] = {0};
  meth_meth_collectionsPrelude_copy2137->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_copy2137);
  meth_meth_collectionsPrelude_copy2137->definitionModule = modulename;
  meth_meth_collectionsPrelude_copy2137->definitionLine = 1117;
  sourceObject = obj1307;
// Begin line 887
  setline(887);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2142 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indexable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2143 = callmethod(*var_indexable, "trait()object",
    2, partcv, params);
  gc_frame_end(callframe2142);
// compiled call node returning call2143 (depth = 2)
  struct UserObject *obj1307_uo = (struct UserObject *)obj1307;
  obj1307_uo->super = call2143;
  sourceObject = obj1307;
// Begin line 889
  setline(889);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2144 = alloc_Float64(0);
// compiled num node returning num2144 (depth = 2)
  adddatum2(obj1307, num2144, 1);
  sourceObject = obj1307;
  adddatum2(obj1307, undefined, 2);
  sourceObject = obj1307;
// Begin line 891
  setline(891);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile catchcase node (depth = 2)
// starting to compile block node (depth = 3)
  Object block2146 = alloc_Block(NULL, NULL, "collectionsPrelude", 891);
  gc_frame_newslot(block2146);
// method _apply
  block_savedest(block2146);
  Object closure2147 = createclosure(2, "_apply");
  setclosureframe(closure2147, stackframe);
  addtoclosure(closure2147, var_a);
  addtoclosure(closure2147, selfslot);
  struct UserObject *uo2147 = (struct UserObject*)block2146;
  uo2147->data[0] = (Object)closure2147;
  Method *meth_meth_collectionsPrelude__apply2147 = addmethod2pos(block2146, "_apply", &meth_collectionsPrelude__apply2147, 0);
  int argcv_meth_collectionsPrelude__apply2147[] = {0};
  meth_meth_collectionsPrelude__apply2147->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2147);
  meth_meth_collectionsPrelude__apply2147->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2147->definitionLine = 1118;
// compiled block node returning block2146 (depth = 3)
  int frame2145 = gc_frame_new();
  gc_frame_newslot(block2146);
// Begin line 892
  setline(892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block2161 = alloc_Block(NULL, NULL, "collectionsPrelude", 892);
  gc_frame_newslot(block2161);
// method _apply
  block_savedest(block2161);
  Object closure2162 = createclosure(1, "_apply");
  setclosureframe(closure2162, stackframe);
  addtoclosure(closure2162, selfslot);
  struct UserObject *uo2162 = (struct UserObject*)block2161;
  uo2162->data[0] = (Object)closure2162;
  Method *meth_meth_collectionsPrelude__apply2162 = addmethod2pos(block2161, "_apply", &meth_collectionsPrelude__apply2162, 0);
  int argcv_meth_collectionsPrelude__apply2162[] = {1};
  meth_meth_collectionsPrelude__apply2162->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2162);
  meth_meth_collectionsPrelude__apply2162->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2162->definitionLine = 891;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2167 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe2168 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit2169 == NULL) {
    strlit2169 = alloc_String("_ex");
    gc_root(strlit2169);
  }
// compiled string node returning strlit2169 (depth = 6)
  gc_frame_newslot(strlit2169);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2170 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call2171 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2170);
// compiled call node returning call2171 (depth = 7)
// compiled member node returning call2171 (depth = 6)
  params[0] = strlit2169;
  partcv[0] = 1;
  Object call2172 = callmethod(call2171, "new",
    1, partcv, params);
  gc_frame_end(callframe2168);
// compiled call node returning call2172 (depth = 5)
  gc_frame_newslot(call2172);
// Begin line 892
  setline(892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_SizeUnknown (depth = 5)
  gc_frame_newslot(*var_SizeUnknown);
// call case 6: other member request
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2173 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call2174 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2173);
// compiled call node returning call2174 (depth = 6)
// compiled member node returning call2174 (depth = 5)
  params[0] = call2172;
  params[1] = *var_SizeUnknown;
  partcv[0] = 2;
  Object call2175 = callmethod(call2174, "new",
    1, partcv, params);
  gc_frame_end(callframe2167);
// compiled call node returning call2175 (depth = 4)
((struct UserObject *)block2161)->data[1] = call2175;
// compiled block node returning block2161 (depth = 3)
  gc_frame_newslot(block2161);
  params[0] = block2161;
  setline(891);
  Object catchres2145 = catchCase(block2146, params, 1,NULL);
  gc_frame_end(frame2145);
// compiled catchcase node returning catchres2145 (depth = 2)
  sourceObject = obj1307;
// Begin line 893
  setline(893);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2176 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2177 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2178 = callmethodflags(self, "initialSize", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2177);
// compiled call node returning call2178 (depth = 4)
// compiled member node returning call2178 (depth = 3)
  gc_frame_newslot(call2178);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2179 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var__prelude (depth = 5)
  partcv[0] = 0;
  Object call2180 = callmethod(*var__prelude, "PrimitiveArray",
    1, partcv, params);
  gc_frame_end(callframe2179);
// compiled call node returning call2180 (depth = 4)
// compiled member node returning call2180 (depth = 3)
  params[0] = call2178;
  partcv[0] = 1;
  Object call2181 = callmethod(call2180, "new",
    1, partcv, params);
  gc_frame_end(callframe2176);
// compiled call node returning call2181 (depth = 2)
  adddatum2(obj1307, call2181, 3);
  sourceObject = obj1307;
// Begin line 894
  setline(894);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2182 = alloc_Float64(0);
// compiled num node returning num2182 (depth = 2)
  adddatum2(obj1307, num2182, 4);
  sourceObject = obj1307;
// Begin line 895
  setline(895);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2183 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_a (depth = 3)
  gc_frame_newslot(*var_a);
// starting to compile block node (depth = 3)
  Object block2184 = alloc_Block(NULL, NULL, "collectionsPrelude", 895);
  gc_frame_newslot(block2184);
// method _apply
  block_savedest(block2184);
  Object closure2185 = createclosure(1, "_apply");
  setclosureframe(closure2185, stackframe);
  addtoclosure(closure2185, selfslot);
  struct UserObject *uo2185 = (struct UserObject*)block2184;
  uo2185->data[0] = (Object)closure2185;
  Method *meth_meth_collectionsPrelude__apply2185 = addmethod2pos(block2184, "_apply", &meth_collectionsPrelude__apply2185, 0);
  int argcv_meth_collectionsPrelude__apply2185[] = {1};
  meth_meth_collectionsPrelude__apply2185->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2185);
  meth_meth_collectionsPrelude__apply2185->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2185->definitionLine = 893;
// compiled block node returning block2184 (depth = 3)
  gc_frame_newslot(block2184);
// call case 5: prelude request
  params[0] = *var_a;
  params[1] = block2184;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2201 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2183);
// compiled call node returning call2201 (depth = 2)
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  sourceObject = obj1307;
  objclass1307 = obj1307->class;
  objclass1307->definitionModule = modulename;
  objclass1307->definitionLine = 885;
  (*(struct UserObject *)self).data[0] = lowerouter1307;
  self = oldself1307;
  selfslot = oldselfslot1307;
  stackframe = oldstackframe1307;
  gc_frame_end(frame);
  return obj1307;
}
Object meth_collectionsPrelude_list760(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "list");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_BoundsError = getfromclosure(closure, 0);
  Object *var_NoSuchObject = getfromclosure(closure, 1);
  Object *var_done = getfromclosure(closure, 2);
  Object *var_Collection = getfromclosure(closure, 3);
  Object *var_ConcurrentModification = getfromclosure(closure, 4);
  Object *var_Exhausted = getfromclosure(closure, 5);
  Object *var_indexable = getfromclosure(closure, 6);
  Object *var__prelude = getfromclosure(closure, 7);
  Object *var_SizeUnknown = getfromclosure(closure, 8);
  Object *var_collectionFactory = getfromclosure(closure, 9);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for list (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for list");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start generics
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      gracedie("insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End generics
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject761 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj761 = alloc_userobj2(3,4, objclass761);
  gc_frame_newslot(obj761);
if (objclass761 == NULL) {
  glfree(obj761->class->name);
  obj761->class->name = "self.list";
}
// OBJECT OUTER DEC outer
  adddatum2(obj761, self, 0);
  addmethodreal(obj761,"outer", &reader_collectionsPrelude_outer_762);
  Object oldself761 = self;
  struct StackFrameObject *oldstackframe761 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe761);
  gc_frame_newslot((Object)stackframe);
  self = obj761;
  Object *oldselfslot761 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter761 = (*(struct UserObject *)self).data[0], lowerouter761 = thisouter761;
  if (inheritingObject761) {
    struct UserObject *inho761 = (struct UserObject *)inheritingObject761;
    while (inho761->super != GraceDefaultObject) inho761 = (struct UserObject *)inho761->super;
    inho761->super = obj761;
    self = inheritingObject761;
    *selfslot = self;
    lowerouter761 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter761;
  }
// method withAll
  block_savedest(obj761);
  Object closure763 = createclosure(9, "withAll");
  setclosureframe(closure763, stackframe);
  addtoclosure(closure763, var_BoundsError);
  addtoclosure(closure763, var_NoSuchObject);
  addtoclosure(closure763, var_done);
  addtoclosure(closure763, var_Collection);
  addtoclosure(closure763, var_ConcurrentModification);
  addtoclosure(closure763, var_Exhausted);
  addtoclosure(closure763, var_indexable);
  addtoclosure(closure763, var__prelude);
  addtoclosure(closure763, var_SizeUnknown);
  struct UserObject *uo763 = (struct UserObject*)obj761;
  uo763->data[1] = (Object)closure763;
  Method *meth_meth_collectionsPrelude_withAll763 = addmethod2pos(obj761, "withAll", &meth_collectionsPrelude_withAll763, 1);
  int argcv_meth_collectionsPrelude_withAll763[] = {1};
  meth_meth_collectionsPrelude_withAll763->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_withAll763);
  meth_meth_collectionsPrelude_withAll763->definitionModule = modulename;
  meth_meth_collectionsPrelude_withAll763->definitionLine = 594;
  block_savedest(obj761);
  Object closure2202 = createclosure(9, "withAll()object");
  setclosureframe(closure2202, stackframe);
  addtoclosure(closure2202, var_BoundsError);
  addtoclosure(closure2202, var_NoSuchObject);
  addtoclosure(closure2202, var_done);
  addtoclosure(closure2202, var_Collection);
  addtoclosure(closure2202, var_ConcurrentModification);
  addtoclosure(closure2202, var_Exhausted);
  addtoclosure(closure2202, var_indexable);
  addtoclosure(closure2202, var__prelude);
  addtoclosure(closure2202, var_SizeUnknown);
  Method *meth_meth_collectionsPrelude_withAll763_object = addmethod2pos(obj761, "withAll()object", &meth_collectionsPrelude_withAll763_object, 1);
  meth_meth_collectionsPrelude_withAll763_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_withAll763_object->definitionLine = 594;
  sourceObject = obj761;
// Begin line 592
  setline(592);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2203 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_collectionFactory (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2204 = callmethod(*var_collectionFactory, "trait()object",
    2, partcv, params);
  gc_frame_end(callframe2203);
// compiled call node returning call2204 (depth = 2)
  struct UserObject *obj761_uo = (struct UserObject *)obj761;
  obj761_uo->super = call2204;
  sourceObject = obj761;
  objclass761 = obj761->class;
  objclass761->definitionModule = modulename;
  objclass761->definitionLine = 591;
  (*(struct UserObject *)self).data[0] = lowerouter761;
  self = oldself761;
  selfslot = oldselfslot761;
  stackframe = oldstackframe761;
  gc_frame_end(frame);
  return obj761;
}
Object meth_collectionsPrelude_list760_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "list()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_BoundsError = getfromclosure(closure, 0);
  Object *var_NoSuchObject = getfromclosure(closure, 1);
  Object *var_done = getfromclosure(closure, 2);
  Object *var_Collection = getfromclosure(closure, 3);
  Object *var_ConcurrentModification = getfromclosure(closure, 4);
  Object *var_Exhausted = getfromclosure(closure, 5);
  Object *var_indexable = getfromclosure(closure, 6);
  Object *var__prelude = getfromclosure(closure, 7);
  Object *var_SizeUnknown = getfromclosure(closure, 8);
  Object *var_collectionFactory = getfromclosure(closure, 9);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for list (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for list");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start generics
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      gracedie("insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End generics
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject761 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj761 = alloc_userobj2(3,4, objclass761);
  gc_frame_newslot(obj761);
if (objclass761 == NULL) {
  glfree(obj761->class->name);
  obj761->class->name = "self.list";
}
// OBJECT OUTER DEC outer
  adddatum2(obj761, self, 0);
  addmethodreal(obj761,"outer", &reader_collectionsPrelude_outer_762);
  Object oldself761 = self;
  struct StackFrameObject *oldstackframe761 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe761);
  gc_frame_newslot((Object)stackframe);
  self = obj761;
  Object *oldselfslot761 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter761 = (*(struct UserObject *)self).data[0], lowerouter761 = thisouter761;
  if (inheritingObject761) {
    struct UserObject *inho761 = (struct UserObject *)inheritingObject761;
    while (inho761->super != GraceDefaultObject) inho761 = (struct UserObject *)inho761->super;
    inho761->super = obj761;
    self = inheritingObject761;
    *selfslot = self;
    lowerouter761 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter761;
  }
// method withAll
  block_savedest(obj761);
  Object closure763 = createclosure(9, "withAll");
  setclosureframe(closure763, stackframe);
  addtoclosure(closure763, var_BoundsError);
  addtoclosure(closure763, var_NoSuchObject);
  addtoclosure(closure763, var_done);
  addtoclosure(closure763, var_Collection);
  addtoclosure(closure763, var_ConcurrentModification);
  addtoclosure(closure763, var_Exhausted);
  addtoclosure(closure763, var_indexable);
  addtoclosure(closure763, var__prelude);
  addtoclosure(closure763, var_SizeUnknown);
  struct UserObject *uo763 = (struct UserObject*)obj761;
  uo763->data[1] = (Object)closure763;
  Method *meth_meth_collectionsPrelude_withAll763 = addmethod2pos(obj761, "withAll", &meth_collectionsPrelude_withAll763, 1);
  int argcv_meth_collectionsPrelude_withAll763[] = {1};
  meth_meth_collectionsPrelude_withAll763->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_withAll763);
  meth_meth_collectionsPrelude_withAll763->definitionModule = modulename;
  meth_meth_collectionsPrelude_withAll763->definitionLine = 594;
  block_savedest(obj761);
  Object closure2202 = createclosure(9, "withAll()object");
  setclosureframe(closure2202, stackframe);
  addtoclosure(closure2202, var_BoundsError);
  addtoclosure(closure2202, var_NoSuchObject);
  addtoclosure(closure2202, var_done);
  addtoclosure(closure2202, var_Collection);
  addtoclosure(closure2202, var_ConcurrentModification);
  addtoclosure(closure2202, var_Exhausted);
  addtoclosure(closure2202, var_indexable);
  addtoclosure(closure2202, var__prelude);
  addtoclosure(closure2202, var_SizeUnknown);
  Method *meth_meth_collectionsPrelude_withAll763_object = addmethod2pos(obj761, "withAll()object", &meth_collectionsPrelude_withAll763_object, 1);
  meth_meth_collectionsPrelude_withAll763_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_withAll763_object->definitionLine = 594;
  sourceObject = obj761;
// Begin line 592
  setline(592);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2203 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_collectionFactory (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2204 = callmethod(*var_collectionFactory, "trait()object",
    2, partcv, params);
  gc_frame_end(callframe2203);
// compiled call node returning call2204 (depth = 2)
  struct UserObject *obj761_uo = (struct UserObject *)obj761;
  obj761_uo->super = call2204;
  sourceObject = obj761;
  objclass761 = obj761->class;
  objclass761->definitionModule = modulename;
  objclass761->definitionLine = 591;
  (*(struct UserObject *)self).data[0] = lowerouter761;
  self = oldself761;
  selfslot = oldselfslot761;
  stackframe = oldstackframe761;
  gc_frame_end(frame);
  return obj761;
}
Object meth_collectionsPrelude__apply2229(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_t = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "t");
// Begin line 1151
  setline(1151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2231 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 6)
  int callframe2232 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_x (depth = 7)
  gc_frame_newslot(*var_x);
// call case 4: self request
  params[0] = *var_x;
  partcv[0] = 1;
  Object call2233 = callmethodflags(self, "contains", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2232);
// compiled call node returning call2233 (depth = 6)
  partcv[0] = 0;
  Object call2234 = callmethod(call2233, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe2231);
// compiled call node returning call2234 (depth = 5)
  Object if2230 = done;
  if (istrue(call2234)) {
// Begin line 1152
  setline(1152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2235 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_x (depth = 7)
  gc_frame_newslot(*var_x);
// call case 4: self request
  params[0] = *var_x;
  partcv[0] = 1;
  Object call2236 = callmethodflags(self, "findPositionForAdd", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2235);
// compiled call node returning call2236 (depth = 6)
  *var_t = call2236;
  if (call2236 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 1153
  setline(1153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2237 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_x (depth = 6)
  gc_frame_newslot(*var_x);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2238 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2239 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2238);
// compiled call node returning call2239 (depth = 7)
// compiled member node returning call2239 (depth = 6)
  params[0] = *var_t;
  params[1] = *var_x;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2240 = callmethod(call2239, "at()put",
    2, partcv, params);
  gc_frame_end(callframe2237);
// compiled call node returning call2240 (depth = 5)
// Begin line 1154
  setline(1154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 1153
  setline(1153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2241 = gc_frame_new();
// Begin line 1154
  setline(1154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2243 = alloc_Float64(1);
// compiled num node returning num2243 (depth = 8)
  int op_slot_right_2242 = gc_frame_newslot(num2243);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2245 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2246 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2245);
// compiled call node returning call2246 (depth = 9)
// compiled member node returning call2246 (depth = 8)
  int op_slot_left_2242 = gc_frame_newslot(call2246);
  params[0] = num2243;
  partcv[0] = 1;
  Object sum2247 = callmethod(call2246, "+", 1, partcv, params);
// compiled op node returning sum2247 (depth = 7)
  gc_frame_newslot(sum2247);
// call case 4: self request
  params[0] = sum2247;
  partcv[0] = 1;
  Object call2248 = callmethodflags(self, "size:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2241);
// compiled call node returning call2248 (depth = 6)
// compiled bind node returning done (depth = 5)
// Begin line 1155
  setline(1155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2252 = alloc_Float64(2);
// compiled num node returning num2252 (depth = 8)
  int op_slot_right_2251 = gc_frame_newslot(num2252);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2254 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2255 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2256 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2255);
// compiled call node returning call2256 (depth = 11)
// compiled member node returning call2256 (depth = 10)
  partcv[0] = 0;
  Object call2257 = callmethod(call2256, "size",
    1, partcv, params);
  gc_frame_end(callframe2254);
// compiled call node returning call2257 (depth = 9)
// compiled member node returning call2257 (depth = 8)
  int op_slot_left_2251 = gc_frame_newslot(call2257);
  params[0] = num2252;
  partcv[0] = 1;
  Object quotient2258 = callmethod(call2257, "/", 1, partcv, params);
// compiled op node returning quotient2258 (depth = 7)
  int op_slot_right_2250 = gc_frame_newslot(quotient2258);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2260 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2261 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2260);
// compiled call node returning call2261 (depth = 8)
// compiled member node returning call2261 (depth = 7)
  int op_slot_left_2250 = gc_frame_newslot(call2261);
  params[0] = quotient2258;
  partcv[0] = 1;
  Object opresult2262 = callmethod(call2261, ">", 1, partcv, params);
// compiled op node returning opresult2262 (depth = 6)
  Object if2249 = done;
  if (istrue(opresult2262)) {
// Begin line 1156
  setline(1156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2263 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2264 = callmethodflags(self, "expand", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2263);
// compiled call node returning call2264 (depth = 7)
// compiled member node returning call2264 (depth = 6)
    gc_frame_newslot(call2264);
    if2249 = call2264;
  } else {
  }
// compiled if node returning if2249 (depth = 5)
    gc_frame_newslot(if2249);
    if2230 = if2249;
  } else {
  }
// compiled if node returning if2230 (depth = 4)
  gc_frame_end(frame);
  return if2230;
}
Object meth_collectionsPrelude_addAll2218(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addAll");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method addAll");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for addAll (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_elements = &(stackframe->slots[0]);
  *var_elements = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for addAll");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1149
  setline(1149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 897
  setline(897);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2219 = gc_frame_new();
// Begin line 1149
  setline(1149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2221 = alloc_Float64(1);
// compiled num node returning num2221 (depth = 5)
  int op_slot_right_2220 = gc_frame_newslot(num2221);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2223 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2224 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2223);
// compiled call node returning call2224 (depth = 6)
// compiled member node returning call2224 (depth = 5)
  int op_slot_left_2220 = gc_frame_newslot(call2224);
  params[0] = num2221;
  partcv[0] = 1;
  Object sum2225 = callmethod(call2224, "+", 1, partcv, params);
// compiled op node returning sum2225 (depth = 4)
  gc_frame_newslot(sum2225);
// call case 4: self request
  params[0] = sum2225;
  partcv[0] = 1;
  Object call2226 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2219);
// compiled call node returning call2226 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 1150
  setline(1150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2227 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elements (depth = 3)
  gc_frame_newslot(*var_elements);
// starting to compile block node (depth = 3)
  Object block2228 = alloc_Block(NULL, NULL, "collectionsPrelude", 1150);
  gc_frame_newslot(block2228);
// method _apply
  block_savedest(block2228);
  Object closure2229 = createclosure(1, "_apply");
  setclosureframe(closure2229, stackframe);
  addtoclosure(closure2229, selfslot);
  struct UserObject *uo2229 = (struct UserObject*)block2228;
  uo2229->data[0] = (Object)closure2229;
  Method *meth_meth_collectionsPrelude__apply2229 = addmethod2pos(block2228, "_apply", &meth_collectionsPrelude__apply2229, 0);
  int argcv_meth_collectionsPrelude__apply2229[] = {1};
  meth_meth_collectionsPrelude__apply2229->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2229);
  meth_meth_collectionsPrelude__apply2229->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2229->definitionLine = 1149;
// compiled block node returning block2228 (depth = 3)
  gc_frame_newslot(block2228);
// call case 5: prelude request
  params[0] = *var_elements;
  params[1] = block2228;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2266 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2227);
// compiled call node returning call2266 (depth = 2)
// Begin line 1160
  setline(1160);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_add2267(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "add");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for add (probably reflection error): got %i lists, expected 1.", nparts);
  Object var_init_elements = alloc_BuiltinList();
  for (i = 0; i < argcv[0]; i++) {
    callmethod(var_init_elements, "push", 1, pushcv, &args[curarg]);
    curarg++;
  }
  Object *var_elements = &(stackframe->slots[0]);
  *var_elements = var_init_elements;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1163
  setline(1163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2268 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elements (depth = 3)
  gc_frame_newslot(*var_elements);
// call case 4: self request
  params[0] = *var_elements;
  partcv[0] = 1;
  Object call2269 = callmethodflags(self, "addAll", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2268);
// compiled call node returning call2269 (depth = 2)
  gc_frame_end(frame);
  return call2269;
}
Object meth_collectionsPrelude__apply2276(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_x = getfromclosure(closure, 0);
  Object *var_NoSuchObject = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1168
  setline(1168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2277 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2279 == NULL) {
    strlit2279 = alloc_String("");
    gc_root(strlit2279);
  }
// compiled string node returning strlit2279 (depth = 8)
  int op_slot_right_2278 = gc_frame_newslot(strlit2279);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_x (depth = 9)
  int op_slot_right_2281 = gc_frame_newslot(*var_x);
// starting to compile string node (depth = 9)
  if (strlit2283 == NULL) {
    strlit2283 = alloc_String("set does not contain ");
    gc_root(strlit2283);
  }
// compiled string node returning strlit2283 (depth = 9)
  int op_slot_left_2281 = gc_frame_newslot(strlit2283);
  params[0] = *var_x;
  partcv[0] = 1;
  Object opresult2284 = callmethod(strlit2283, "++", 1, partcv, params);
// compiled op node returning opresult2284 (depth = 8)
  int op_slot_left_2278 = gc_frame_newslot(opresult2284);
  params[0] = strlit2279;
  partcv[0] = 1;
  Object opresult2285 = callmethod(opresult2284, "++", 1, partcv, params);
// compiled op node returning opresult2285 (depth = 7)
  gc_frame_newslot(opresult2285);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_NoSuchObject (depth = 7)
  params[0] = opresult2285;
  partcv[0] = 1;
  Object call2286 = callmethod(*var_NoSuchObject, "raise",
    1, partcv, params);
  gc_frame_end(callframe2277);
// compiled call node returning call2286 (depth = 6)
  gc_frame_end(frame);
  return call2286;
}
Object meth_collectionsPrelude__apply2273(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1167
  setline(1167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2274 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_x (depth = 5)
  gc_frame_newslot(*var_x);
// starting to compile block node (depth = 5)
  Object block2275 = alloc_Block(NULL, NULL, "collectionsPrelude", 1167);
  gc_frame_newslot(block2275);
// method _apply
  block_savedest(block2275);
  Object closure2276 = createclosure(3, "_apply");
  setclosureframe(closure2276, stackframe);
  addtoclosure(closure2276, var_x);
  addtoclosure(closure2276, var_NoSuchObject);
  addtoclosure(closure2276, selfslot);
  struct UserObject *uo2276 = (struct UserObject*)block2275;
  uo2276->data[0] = (Object)closure2276;
  Method *meth_meth_collectionsPrelude__apply2276 = addmethod2pos(block2275, "_apply", &meth_collectionsPrelude__apply2276, 0);
  int argcv_meth_collectionsPrelude__apply2276[] = {0};
  meth_meth_collectionsPrelude__apply2276->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2276);
  meth_meth_collectionsPrelude__apply2276->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2276->definitionLine = 1156;
// compiled block node returning block2275 (depth = 5)
  gc_frame_newslot(block2275);
// call case 4: self request
  params[0] = *var_x;
  params[1] = block2275;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2288 = callmethodflags(self, "remove()ifAbsent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2274);
// compiled call node returning call2288 (depth = 4)
  gc_frame_end(frame);
  return call2288;
}
Object meth_collectionsPrelude_removeAll2270(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "removeAll");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method removeAll");
  Object params[2];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for removeAll (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_elements = &(stackframe->slots[0]);
  *var_elements = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for removeAll");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1166
  setline(1166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2271 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elements (depth = 3)
  gc_frame_newslot(*var_elements);
// starting to compile block node (depth = 3)
  Object block2272 = alloc_Block(NULL, NULL, "collectionsPrelude", 1166);
  gc_frame_newslot(block2272);
// method _apply
  block_savedest(block2272);
  Object closure2273 = createclosure(2, "_apply");
  setclosureframe(closure2273, stackframe);
  addtoclosure(closure2273, var_NoSuchObject);
  addtoclosure(closure2273, selfslot);
  struct UserObject *uo2273 = (struct UserObject*)block2272;
  uo2273->data[0] = (Object)closure2273;
  Method *meth_meth_collectionsPrelude__apply2273 = addmethod2pos(block2272, "_apply", &meth_collectionsPrelude__apply2273, 0);
  int argcv_meth_collectionsPrelude__apply2273[] = {1};
  meth_meth_collectionsPrelude__apply2273->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2273);
  meth_meth_collectionsPrelude__apply2273->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2273->definitionLine = 1156;
// compiled block node returning block2272 (depth = 3)
  gc_frame_newslot(block2272);
// call case 5: prelude request
  params[0] = *var_elements;
  params[1] = block2272;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2290 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2271);
// compiled call node returning call2290 (depth = 2)
// Begin line 1171
  setline(1171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply2302(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_block = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_t = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "t");
// Begin line 1176
  setline(1176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2303 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_x (depth = 6)
  gc_frame_newslot(*var_x);
// call case 4: self request
  params[0] = *var_x;
  partcv[0] = 1;
  Object call2304 = callmethodflags(self, "findPosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2303);
// compiled call node returning call2304 (depth = 5)
  *var_t = call2304;
  if (call2304 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1177
  setline(1177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_x (depth = 6)
  int op_slot_right_2306 = gc_frame_newslot(*var_x);
// starting to compile call node (depth = 6)
  int callframe2308 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_t (depth = 7)
  gc_frame_newslot(*var_t);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2309 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2310 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2309);
// compiled call node returning call2310 (depth = 8)
// compiled member node returning call2310 (depth = 7)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call2311 = callmethod(call2310, "at",
    1, partcv, params);
  gc_frame_end(callframe2308);
// compiled call node returning call2311 (depth = 6)
  int op_slot_left_2306 = gc_frame_newslot(call2311);
  params[0] = *var_x;
  partcv[0] = 1;
  Object opresult2312 = callmethod(call2311, "==", 1, partcv, params);
// compiled op node returning opresult2312 (depth = 5)
  Object if2305 = done;
  if (istrue(opresult2312)) {
// Begin line 1178
  setline(1178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2313 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2314 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2315 = callmethodflags(self, "removed", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2314);
// compiled call node returning call2315 (depth = 7)
// compiled member node returning call2315 (depth = 6)
  gc_frame_newslot(call2315);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2316 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2317 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2316);
// compiled call node returning call2317 (depth = 7)
// compiled member node returning call2317 (depth = 6)
  params[0] = *var_t;
  params[1] = call2315;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2318 = callmethod(call2317, "at()put",
    2, partcv, params);
  gc_frame_end(callframe2313);
// compiled call node returning call2318 (depth = 5)
// Begin line 1179
  setline(1179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 1178
  setline(1178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2319 = gc_frame_new();
// Begin line 1179
  setline(1179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2321 = alloc_Float64(1);
// compiled num node returning num2321 (depth = 8)
  int op_slot_right_2320 = gc_frame_newslot(num2321);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2323 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2324 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2323);
// compiled call node returning call2324 (depth = 9)
// compiled member node returning call2324 (depth = 8)
  int op_slot_left_2320 = gc_frame_newslot(call2324);
  params[0] = num2321;
  partcv[0] = 1;
  Object diff2325 = callmethod(call2324, "-", 1, partcv, params);
// compiled op node returning diff2325 (depth = 7)
  gc_frame_newslot(diff2325);
// call case 4: self request
  params[0] = diff2325;
  partcv[0] = 1;
  Object call2326 = callmethodflags(self, "size:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2319);
// compiled call node returning call2326 (depth = 6)
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if2305 = done;
  } else {
// Begin line 1181
  setline(1181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2327 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_block (depth = 7)
  partcv[0] = 0;
  Object call2328 = callmethod(*var_block, "apply",
    1, partcv, params);
  gc_frame_end(callframe2327);
// compiled call node returning call2328 (depth = 6)
// compiled member node returning call2328 (depth = 5)
    gc_frame_newslot(call2328);
    if2305 = call2328;
  }
// compiled if node returning if2305 (depth = 4)
  gc_frame_end(frame);
  return if2305;
}
Object meth_collectionsPrelude_removeAll_40__41_ifAbsent2291(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "removeAll()ifAbsent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method removeAll()ifAbsent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method removeAll()ifAbsent");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for removeAll()ifAbsent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_elements = &(stackframe->slots[0]);
  *var_elements = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for removeAll");
  Object *var_block = &(stackframe->slots[1]);
  *var_block = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for ifAbsent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1174
  setline(1174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 1156
  setline(1156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2292 = gc_frame_new();
// Begin line 1174
  setline(1174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2294 = alloc_Float64(1);
// compiled num node returning num2294 (depth = 5)
  int op_slot_right_2293 = gc_frame_newslot(num2294);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2296 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2297 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2296);
// compiled call node returning call2297 (depth = 6)
// compiled member node returning call2297 (depth = 5)
  int op_slot_left_2293 = gc_frame_newslot(call2297);
  params[0] = num2294;
  partcv[0] = 1;
  Object sum2298 = callmethod(call2297, "+", 1, partcv, params);
// compiled op node returning sum2298 (depth = 4)
  gc_frame_newslot(sum2298);
// call case 4: self request
  params[0] = sum2298;
  partcv[0] = 1;
  Object call2299 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2292);
// compiled call node returning call2299 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 1175
  setline(1175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2300 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elements (depth = 3)
  gc_frame_newslot(*var_elements);
// starting to compile block node (depth = 3)
  Object block2301 = alloc_Block(NULL, NULL, "collectionsPrelude", 1175);
  gc_frame_newslot(block2301);
// method _apply
  block_savedest(block2301);
  Object closure2302 = createclosure(2, "_apply");
  setclosureframe(closure2302, stackframe);
  addtoclosure(closure2302, var_block);
  addtoclosure(closure2302, selfslot);
  struct UserObject *uo2302 = (struct UserObject*)block2301;
  uo2302->data[0] = (Object)closure2302;
  Method *meth_meth_collectionsPrelude__apply2302 = addmethod2pos(block2301, "_apply", &meth_collectionsPrelude__apply2302, 0);
  int argcv_meth_collectionsPrelude__apply2302[] = {1};
  meth_meth_collectionsPrelude__apply2302->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2302);
  meth_meth_collectionsPrelude__apply2302->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2302->definitionLine = 1174;
// compiled block node returning block2301 (depth = 3)
  gc_frame_newslot(block2301);
// call case 5: prelude request
  params[0] = *var_elements;
  params[1] = block2301;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2330 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2300);
// compiled call node returning call2330 (depth = 2)
// Begin line 1184
  setline(1184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_remove_40__41_ifAbsent2331(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "remove()ifAbsent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method remove()ifAbsent");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for remove()ifAbsent (probably reflection error): got %i lists, expected 2.", nparts);
  Object var_init_elements = alloc_BuiltinList();
  for (i = 0; i < argcv[0]; i++) {
    callmethod(var_init_elements, "push", 1, pushcv, &args[curarg]);
    curarg++;
  }
  Object *var_elements = &(stackframe->slots[0]);
  *var_elements = var_init_elements;
  Object *var_block = &(stackframe->slots[1]);
  *var_block = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for ifAbsent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1188
  setline(1188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2332 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elements (depth = 3)
  gc_frame_newslot(*var_elements);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_block (depth = 3)
  gc_frame_newslot(*var_block);
// call case 4: self request
  params[0] = *var_elements;
  params[1] = *var_block;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2333 = callmethodflags(self, "removeAll()ifAbsent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2332);
// compiled call node returning call2333 (depth = 2)
  gc_frame_end(frame);
  return call2333;
}
Object meth_collectionsPrelude_remove2334(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "remove");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for remove (probably reflection error): got %i lists, expected 1.", nparts);
  Object var_init_elements = alloc_BuiltinList();
  for (i = 0; i < argcv[0]; i++) {
    callmethod(var_init_elements, "push", 1, pushcv, &args[curarg]);
    curarg++;
  }
  Object *var_elements = &(stackframe->slots[0]);
  *var_elements = var_init_elements;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1192
  setline(1192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2335 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elements (depth = 3)
  gc_frame_newslot(*var_elements);
// call case 4: self request
  params[0] = *var_elements;
  partcv[0] = 1;
  Object call2336 = callmethodflags(self, "removeAll", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2335);
// compiled call node returning call2336 (depth = 2)
  gc_frame_end(frame);
  return call2336;
}
Object meth_collectionsPrelude_contains2337(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "contains");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method contains");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for contains (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for contains");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_t = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "t");
// Begin line 1196
  setline(1196);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2338 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_x (depth = 4)
  gc_frame_newslot(*var_x);
// call case 4: self request
  params[0] = *var_x;
  partcv[0] = 1;
  Object call2339 = callmethodflags(self, "findPosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2338);
// compiled call node returning call2339 (depth = 3)
  *var_t = call2339;
  if (call2339 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1197
  setline(1197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_x (depth = 4)
  int op_slot_right_2341 = gc_frame_newslot(*var_x);
// starting to compile call node (depth = 4)
  int callframe2343 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_t (depth = 5)
  gc_frame_newslot(*var_t);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2344 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2345 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2344);
// compiled call node returning call2345 (depth = 6)
// compiled member node returning call2345 (depth = 5)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call2346 = callmethod(call2345, "at",
    1, partcv, params);
  gc_frame_end(callframe2343);
// compiled call node returning call2346 (depth = 4)
  int op_slot_left_2341 = gc_frame_newslot(call2346);
  params[0] = *var_x;
  partcv[0] = 1;
  Object opresult2347 = callmethod(call2346, "==", 1, partcv, params);
// compiled op node returning opresult2347 (depth = 3)
  Object if2340 = done;
  if (istrue(opresult2347)) {
// Begin line 1198
  setline(1198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool2348 = alloc_Boolean(1);
// compiled identifier node returning bool2348 (depth = 4)
  return bool2348;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if2340 = undefined;
  } else {
  }
// compiled if node returning if2340 (depth = 2)
// Begin line 1200
  setline(1200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool2349 = alloc_Boolean(0);
// compiled identifier node returning bool2349 (depth = 3)
  return bool2349;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply2353(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_booleanBlock = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1204
  setline(1204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2355 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_each (depth = 6)
  gc_frame_newslot(*var_each);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_booleanBlock (depth = 6)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call2356 = callmethod(*var_booleanBlock, "apply",
    1, partcv, params);
  gc_frame_end(callframe2355);
// compiled call node returning call2356 (depth = 5)
  Object if2354 = done;
  if (istrue(call2356)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool2357 = alloc_Boolean(1);
// compiled identifier node returning bool2357 (depth = 6)
  block_return(realself, bool2357);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if2354 = undefined;
  } else {
  }
// compiled if node returning if2354 (depth = 4)
  gc_frame_end(frame);
  return if2354;
}
Object meth_collectionsPrelude_includes2350(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "includes");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method includes");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for includes (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_booleanBlock = &(stackframe->slots[0]);
  *var_booleanBlock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for includes");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1203
  setline(1203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2351 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2352 = alloc_Block(NULL, NULL, "collectionsPrelude", 1203);
  gc_frame_newslot(block2352);
// method _apply
  block_savedest(block2352);
  Object closure2353 = createclosure(2, "_apply");
  setclosureframe(closure2353, stackframe);
  addtoclosure(closure2353, var_booleanBlock);
  addtoclosure(closure2353, selfslot);
  struct UserObject *uo2353 = (struct UserObject*)block2352;
  uo2353->data[0] = (Object)closure2353;
  Method *meth_meth_collectionsPrelude__apply2353 = addmethod2pos(block2352, "_apply", &meth_collectionsPrelude__apply2353, 0);
  int argcv_meth_collectionsPrelude__apply2353[] = {1};
  meth_meth_collectionsPrelude__apply2353->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2353);
  meth_meth_collectionsPrelude__apply2353->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2353->definitionLine = 1197;
// compiled block node returning block2352 (depth = 3)
  gc_frame_newslot(block2352);
// call case 4: self request
  params[0] = block2352;
  partcv[0] = 1;
  Object call2359 = callmethodflags(self, "do", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2351);
// compiled call node returning call2359 (depth = 2)
// Begin line 1206
  setline(1206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool2360 = alloc_Boolean(0);
// compiled identifier node returning bool2360 (depth = 3)
  return bool2360;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply2364(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_booleanBlock = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1210
  setline(1210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2366 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_each (depth = 6)
  gc_frame_newslot(*var_each);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_booleanBlock (depth = 6)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call2367 = callmethod(*var_booleanBlock, "apply",
    1, partcv, params);
  gc_frame_end(callframe2366);
// compiled call node returning call2367 (depth = 5)
  Object if2365 = done;
  if (istrue(call2367)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_each (depth = 6)
  block_return(realself, *var_each);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if2365 = undefined;
  } else {
  }
// compiled if node returning if2365 (depth = 4)
  gc_frame_end(frame);
  return if2365;
}
Object meth_collectionsPrelude_find_40__41_ifNone2361(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "find()ifNone");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method find()ifNone");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method find()ifNone");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for find()ifNone (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_booleanBlock = &(stackframe->slots[0]);
  *var_booleanBlock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for find");
  Object *var_notFoundBlock = &(stackframe->slots[1]);
  *var_notFoundBlock = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for ifNone");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1209
  setline(1209);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2362 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2363 = alloc_Block(NULL, NULL, "collectionsPrelude", 1209);
  gc_frame_newslot(block2363);
// method _apply
  block_savedest(block2363);
  Object closure2364 = createclosure(2, "_apply");
  setclosureframe(closure2364, stackframe);
  addtoclosure(closure2364, var_booleanBlock);
  addtoclosure(closure2364, selfslot);
  struct UserObject *uo2364 = (struct UserObject*)block2363;
  uo2364->data[0] = (Object)closure2364;
  Method *meth_meth_collectionsPrelude__apply2364 = addmethod2pos(block2363, "_apply", &meth_collectionsPrelude__apply2364, 0);
  int argcv_meth_collectionsPrelude__apply2364[] = {1};
  meth_meth_collectionsPrelude__apply2364->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2364);
  meth_meth_collectionsPrelude__apply2364->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2364->definitionLine = 1197;
// compiled block node returning block2363 (depth = 3)
  gc_frame_newslot(block2363);
// call case 4: self request
  params[0] = block2363;
  partcv[0] = 1;
  Object call2369 = callmethodflags(self, "do", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2362);
// compiled call node returning call2369 (depth = 2)
// Begin line 1212
  setline(1212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2370 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_notFoundBlock (depth = 5)
  partcv[0] = 0;
  Object call2371 = callmethod(*var_notFoundBlock, "apply",
    1, partcv, params);
  gc_frame_end(callframe2370);
// compiled call node returning call2371 (depth = 4)
// compiled member node returning call2371 (depth = 3)
  return call2371;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply2385(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_t = getfromclosure(closure, 0);
  Object *var_candidate = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 4)
// Begin line 1221
  setline(1221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2386 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2387 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2388 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2387);
// compiled call node returning call2388 (depth = 7)
// compiled member node returning call2388 (depth = 6)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call2389 = callmethod(call2388, "at",
    1, partcv, params);
  gc_frame_end(callframe2386);
// compiled call node returning call2389 (depth = 5)
  *var_candidate = call2389;
  if (call2389 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1222
  setline(1222);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2392 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2393 = callmethodflags(self, "unused", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2392);
// compiled call node returning call2393 (depth = 6)
// compiled member node returning call2393 (depth = 5)
  int op_slot_right_2391 = gc_frame_newslot(call2393);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_candidate (depth = 5)
  int op_slot_left_2391 = gc_frame_newslot(*var_candidate);
  params[0] = call2393;
  partcv[0] = 1;
  Object opresult2395 = callmethod(*var_candidate, "!=", 1, partcv, params);
// compiled op node returning opresult2395 (depth = 4)
  gc_frame_end(frame);
  return opresult2395;
}
Object meth_collectionsPrelude__apply2398(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_x = getfromclosure(closure, 0);
  Object *var_candidate = getfromclosure(closure, 1);
  Object *var_t = getfromclosure(closure, 2);
  Object *var_jump = getfromclosure(closure, 3);
  Object *var_s = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1224
  setline(1224);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_x (depth = 6)
  int op_slot_right_2400 = gc_frame_newslot(*var_x);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_candidate (depth = 6)
  int op_slot_left_2400 = gc_frame_newslot(*var_candidate);
  params[0] = *var_x;
  partcv[0] = 1;
  Object opresult2402 = callmethod(*var_candidate, "==", 1, partcv, params);
// compiled op node returning opresult2402 (depth = 5)
  Object if2399 = done;
  if (istrue(opresult2402)) {
// Begin line 1225
  setline(1225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  block_return(realself, *var_t);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if2399 = undefined;
  } else {
  }
// compiled if node returning if2399 (depth = 4)
// Begin line 1227
  setline(1227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num2405 = alloc_Float64(0);
// compiled num node returning num2405 (depth = 6)
  int op_slot_right_2404 = gc_frame_newslot(num2405);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_jump (depth = 6)
  int op_slot_left_2404 = gc_frame_newslot(*var_jump);
  params[0] = num2405;
  partcv[0] = 1;
  Object opresult2407 = callmethod(*var_jump, "!=", 1, partcv, params);
// compiled op node returning opresult2407 (depth = 5)
  Object if2403 = done;
  if (istrue(opresult2407)) {
// Begin line 1228
  setline(1228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_2408 = gc_frame_newslot(*var_s);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2411 = alloc_Float64(1);
// compiled num node returning num2411 (depth = 8)
  int op_slot_right_2410 = gc_frame_newslot(num2411);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2414 = alloc_Float64(3);
// compiled num node returning num2414 (depth = 9)
  int op_slot_right_2413 = gc_frame_newslot(num2414);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_t (depth = 9)
  int op_slot_left_2413 = gc_frame_newslot(*var_t);
  params[0] = num2414;
  partcv[0] = 1;
  Object prod2416 = callmethod(*var_t, "*", 1, partcv, params);
// compiled op node returning prod2416 (depth = 8)
  int op_slot_left_2410 = gc_frame_newslot(prod2416);
  params[0] = num2411;
  partcv[0] = 1;
  Object sum2417 = callmethod(prod2416, "+", 1, partcv, params);
// compiled op node returning sum2417 (depth = 7)
  int op_slot_left_2408 = gc_frame_newslot(sum2417);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus2418 = callmethod(sum2417, "%", 1, partcv, params);
// compiled op node returning modulus2418 (depth = 6)
  *var_t = modulus2418;
  if (modulus2418 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1229
  setline(1229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2421 = alloc_Float64(1);
// compiled num node returning num2421 (depth = 7)
  int op_slot_right_2420 = gc_frame_newslot(num2421);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_jump (depth = 7)
  int op_slot_left_2420 = gc_frame_newslot(*var_jump);
  params[0] = num2421;
  partcv[0] = 1;
  Object diff2423 = callmethod(*var_jump, "-", 1, partcv, params);
// compiled op node returning diff2423 (depth = 6)
  *var_jump = diff2423;
  if (diff2423 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if2403 = done;
  } else {
// Begin line 1231
  setline(1231);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_2425 = gc_frame_newslot(*var_s);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2428 = alloc_Float64(1);
// compiled num node returning num2428 (depth = 8)
  int op_slot_right_2427 = gc_frame_newslot(num2428);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  int op_slot_left_2427 = gc_frame_newslot(*var_t);
  params[0] = num2428;
  partcv[0] = 1;
  Object sum2430 = callmethod(*var_t, "+", 1, partcv, params);
// compiled op node returning sum2430 (depth = 7)
  int op_slot_left_2425 = gc_frame_newslot(sum2430);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus2431 = callmethod(sum2430, "%", 1, partcv, params);
// compiled op node returning modulus2431 (depth = 6)
  *var_t = modulus2431;
  if (modulus2431 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if2403 = done;
  }
// compiled if node returning if2403 (depth = 4)
  gc_frame_end(frame);
  return if2403;
}
Object meth_collectionsPrelude_findPosition2372(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(7, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "findPosition");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method findPosition");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for findPosition (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for findPosition");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_h = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "h");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
  Object *var_t = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "t");
  Object *var_jump = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "jump");
  Object *var_candidate = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "candidate");
// Begin line 1215
  setline(1215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2373 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_x (depth = 5)
  partcv[0] = 0;
  Object call2374 = callmethod(*var_x, "hash",
    1, partcv, params);
  gc_frame_end(callframe2373);
// compiled call node returning call2374 (depth = 4)
// compiled member node returning call2374 (depth = 3)
  *var_h = call2374;
  if (call2374 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1216
  setline(1216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2375 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2376 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2377 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2376);
// compiled call node returning call2377 (depth = 6)
// compiled member node returning call2377 (depth = 5)
  partcv[0] = 0;
  Object call2378 = callmethod(call2377, "size",
    1, partcv, params);
  gc_frame_end(callframe2375);
// compiled call node returning call2378 (depth = 4)
// compiled member node returning call2378 (depth = 3)
  *var_s = call2378;
  if (call2378 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1217
  setline(1217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_right_2379 = gc_frame_newslot(*var_s);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_h (depth = 4)
  int op_slot_left_2379 = gc_frame_newslot(*var_h);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus2381 = callmethod(*var_h, "%", 1, partcv, params);
// compiled op node returning modulus2381 (depth = 3)
  *var_t = modulus2381;
  if (modulus2381 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1218
  setline(1218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num2382 = alloc_Float64(5);
// compiled num node returning num2382 (depth = 3)
  *var_jump = num2382;
  if (num2382 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1219
  setline(1219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_candidate = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1220
  setline(1220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2383 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2384 = alloc_Block(NULL, NULL, "collectionsPrelude", 1220);
  gc_frame_newslot(block2384);
// method _apply
  block_savedest(block2384);
  Object closure2385 = createclosure(3, "_apply");
  setclosureframe(closure2385, stackframe);
  addtoclosure(closure2385, var_t);
  addtoclosure(closure2385, var_candidate);
  addtoclosure(closure2385, selfslot);
  struct UserObject *uo2385 = (struct UserObject*)block2384;
  uo2385->data[0] = (Object)closure2385;
  Method *meth_meth_collectionsPrelude__apply2385 = addmethod2pos(block2384, "_apply", &meth_collectionsPrelude__apply2385, 0);
  int argcv_meth_collectionsPrelude__apply2385[] = {0};
  meth_meth_collectionsPrelude__apply2385->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2385);
  meth_meth_collectionsPrelude__apply2385->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2385->definitionLine = 1216;
// compiled block node returning block2384 (depth = 3)
  gc_frame_newslot(block2384);
// Begin line 1223
  setline(1223);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block2397 = alloc_Block(NULL, NULL, "collectionsPrelude", 1223);
  gc_frame_newslot(block2397);
// method _apply
  block_savedest(block2397);
  Object closure2398 = createclosure(6, "_apply");
  setclosureframe(closure2398, stackframe);
  addtoclosure(closure2398, var_x);
  addtoclosure(closure2398, var_candidate);
  addtoclosure(closure2398, var_t);
  addtoclosure(closure2398, var_jump);
  addtoclosure(closure2398, var_s);
  addtoclosure(closure2398, selfslot);
  struct UserObject *uo2398 = (struct UserObject*)block2397;
  uo2398->data[0] = (Object)closure2398;
  Method *meth_meth_collectionsPrelude__apply2398 = addmethod2pos(block2397, "_apply", &meth_collectionsPrelude__apply2398, 0);
  int argcv_meth_collectionsPrelude__apply2398[] = {0};
  meth_meth_collectionsPrelude__apply2398->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2398);
  meth_meth_collectionsPrelude__apply2398->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2398->definitionLine = 1222;
// compiled block node returning block2397 (depth = 3)
  gc_frame_newslot(block2397);
// call case 5: prelude request
  params[0] = block2384;
  params[1] = block2397;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2434 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2383);
// compiled call node returning call2434 (depth = 2)
// Begin line 1234
  setline(1234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_t (depth = 3)
  return *var_t;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply2456(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_candidate = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2458 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2459 = callmethodflags(self, "removed", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2458);
// compiled call node returning call2459 (depth = 8)
// compiled member node returning call2459 (depth = 7)
  int op_slot_right_2457 = gc_frame_newslot(call2459);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_candidate (depth = 7)
  int op_slot_left_2457 = gc_frame_newslot(*var_candidate);
  params[0] = call2459;
  partcv[0] = 1;
  Object opresult2461 = callmethod(*var_candidate, "!=", 1, partcv, params);
// compiled op node returning opresult2461 (depth = 6)
  gc_frame_end(frame);
  return opresult2461;
}
Object meth_collectionsPrelude__apply2448(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_t = getfromclosure(closure, 0);
  Object *var_candidate = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 4)
// Begin line 1243
  setline(1243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2449 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2450 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2451 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2450);
// compiled call node returning call2451 (depth = 7)
// compiled member node returning call2451 (depth = 6)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call2452 = callmethod(call2451, "at",
    1, partcv, params);
  gc_frame_end(callframe2449);
// compiled call node returning call2452 (depth = 5)
  *var_candidate = call2452;
  if (call2452 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1244
  setline(1244);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2454 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block2455 = alloc_Block(NULL, NULL, "collectionsPrelude", 1244);
  gc_frame_newslot(block2455);
// method _apply
  block_savedest(block2455);
  Object closure2456 = createclosure(2, "_apply");
  setclosureframe(closure2456, stackframe);
  addtoclosure(closure2456, var_candidate);
  addtoclosure(closure2456, selfslot);
  struct UserObject *uo2456 = (struct UserObject*)block2455;
  uo2456->data[0] = (Object)closure2456;
  Method *meth_meth_collectionsPrelude__apply2456 = addmethod2pos(block2455, "_apply", &meth_collectionsPrelude__apply2456, 0);
  int argcv_meth_collectionsPrelude__apply2456[] = {0};
  meth_meth_collectionsPrelude__apply2456->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2456);
  meth_meth_collectionsPrelude__apply2456->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2456->definitionLine = 1243;
// compiled block node returning block2455 (depth = 5)
  gc_frame_newslot(block2455);
// call case 6: other member request
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2464 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2465 = callmethodflags(self, "unused", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2464);
// compiled call node returning call2465 (depth = 7)
// compiled member node returning call2465 (depth = 6)
  int op_slot_right_2463 = gc_frame_newslot(call2465);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_candidate (depth = 6)
  int op_slot_left_2463 = gc_frame_newslot(*var_candidate);
  params[0] = call2465;
  partcv[0] = 1;
  Object opresult2467 = callmethod(*var_candidate, "!=", 1, partcv, params);
// compiled op node returning opresult2467 (depth = 5)
  params[0] = block2455;
  partcv[0] = 1;
  Object call2468 = callmethod(opresult2467, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe2454);
// compiled call node returning call2468 (depth = 4)
  gc_frame_end(frame);
  return call2468;
}
Object meth_collectionsPrelude__apply2471(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_x = getfromclosure(closure, 0);
  Object *var_candidate = getfromclosure(closure, 1);
  Object *var_t = getfromclosure(closure, 2);
  Object *var_jump = getfromclosure(closure, 3);
  Object *var_s = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1246
  setline(1246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_x (depth = 6)
  int op_slot_right_2473 = gc_frame_newslot(*var_x);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_candidate (depth = 6)
  int op_slot_left_2473 = gc_frame_newslot(*var_candidate);
  params[0] = *var_x;
  partcv[0] = 1;
  Object opresult2475 = callmethod(*var_candidate, "==", 1, partcv, params);
// compiled op node returning opresult2475 (depth = 5)
  Object if2472 = done;
  if (istrue(opresult2475)) {
// Begin line 1247
  setline(1247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  block_return(realself, *var_t);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if2472 = undefined;
  } else {
  }
// compiled if node returning if2472 (depth = 4)
// Begin line 1249
  setline(1249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num2478 = alloc_Float64(0);
// compiled num node returning num2478 (depth = 6)
  int op_slot_right_2477 = gc_frame_newslot(num2478);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_jump (depth = 6)
  int op_slot_left_2477 = gc_frame_newslot(*var_jump);
  params[0] = num2478;
  partcv[0] = 1;
  Object opresult2480 = callmethod(*var_jump, "!=", 1, partcv, params);
// compiled op node returning opresult2480 (depth = 5)
  Object if2476 = done;
  if (istrue(opresult2480)) {
// Begin line 1250
  setline(1250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_2481 = gc_frame_newslot(*var_s);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2484 = alloc_Float64(1);
// compiled num node returning num2484 (depth = 8)
  int op_slot_right_2483 = gc_frame_newslot(num2484);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2487 = alloc_Float64(3);
// compiled num node returning num2487 (depth = 9)
  int op_slot_right_2486 = gc_frame_newslot(num2487);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_t (depth = 9)
  int op_slot_left_2486 = gc_frame_newslot(*var_t);
  params[0] = num2487;
  partcv[0] = 1;
  Object prod2489 = callmethod(*var_t, "*", 1, partcv, params);
// compiled op node returning prod2489 (depth = 8)
  int op_slot_left_2483 = gc_frame_newslot(prod2489);
  params[0] = num2484;
  partcv[0] = 1;
  Object sum2490 = callmethod(prod2489, "+", 1, partcv, params);
// compiled op node returning sum2490 (depth = 7)
  int op_slot_left_2481 = gc_frame_newslot(sum2490);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus2491 = callmethod(sum2490, "%", 1, partcv, params);
// compiled op node returning modulus2491 (depth = 6)
  *var_t = modulus2491;
  if (modulus2491 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1251
  setline(1251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2494 = alloc_Float64(1);
// compiled num node returning num2494 (depth = 7)
  int op_slot_right_2493 = gc_frame_newslot(num2494);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_jump (depth = 7)
  int op_slot_left_2493 = gc_frame_newslot(*var_jump);
  params[0] = num2494;
  partcv[0] = 1;
  Object diff2496 = callmethod(*var_jump, "-", 1, partcv, params);
// compiled op node returning diff2496 (depth = 6)
  *var_jump = diff2496;
  if (diff2496 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if2476 = done;
  } else {
// Begin line 1253
  setline(1253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_2498 = gc_frame_newslot(*var_s);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2501 = alloc_Float64(1);
// compiled num node returning num2501 (depth = 8)
  int op_slot_right_2500 = gc_frame_newslot(num2501);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  int op_slot_left_2500 = gc_frame_newslot(*var_t);
  params[0] = num2501;
  partcv[0] = 1;
  Object sum2503 = callmethod(*var_t, "+", 1, partcv, params);
// compiled op node returning sum2503 (depth = 7)
  int op_slot_left_2498 = gc_frame_newslot(sum2503);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus2504 = callmethod(sum2503, "%", 1, partcv, params);
// compiled op node returning modulus2504 (depth = 6)
  *var_t = modulus2504;
  if (modulus2504 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if2476 = done;
  }
// compiled if node returning if2476 (depth = 4)
  gc_frame_end(frame);
  return if2476;
}
Object meth_collectionsPrelude_findPositionForAdd2435(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(7, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "findPositionForAdd");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method findPositionForAdd");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for findPositionForAdd (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for findPositionForAdd");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_h = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "h");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
  Object *var_t = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "t");
  Object *var_jump = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "jump");
  Object *var_candidate = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "candidate");
// Begin line 1237
  setline(1237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2436 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_x (depth = 5)
  partcv[0] = 0;
  Object call2437 = callmethod(*var_x, "hash",
    1, partcv, params);
  gc_frame_end(callframe2436);
// compiled call node returning call2437 (depth = 4)
// compiled member node returning call2437 (depth = 3)
  *var_h = call2437;
  if (call2437 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1238
  setline(1238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2438 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2439 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2440 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2439);
// compiled call node returning call2440 (depth = 6)
// compiled member node returning call2440 (depth = 5)
  partcv[0] = 0;
  Object call2441 = callmethod(call2440, "size",
    1, partcv, params);
  gc_frame_end(callframe2438);
// compiled call node returning call2441 (depth = 4)
// compiled member node returning call2441 (depth = 3)
  *var_s = call2441;
  if (call2441 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1239
  setline(1239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_right_2442 = gc_frame_newslot(*var_s);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_h (depth = 4)
  int op_slot_left_2442 = gc_frame_newslot(*var_h);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus2444 = callmethod(*var_h, "%", 1, partcv, params);
// compiled op node returning modulus2444 (depth = 3)
  *var_t = modulus2444;
  if (modulus2444 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1240
  setline(1240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num2445 = alloc_Float64(5);
// compiled num node returning num2445 (depth = 3)
  *var_jump = num2445;
  if (num2445 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1241
  setline(1241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_candidate = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1242
  setline(1242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2446 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2447 = alloc_Block(NULL, NULL, "collectionsPrelude", 1242);
  gc_frame_newslot(block2447);
// method _apply
  block_savedest(block2447);
  Object closure2448 = createclosure(3, "_apply");
  setclosureframe(closure2448, stackframe);
  addtoclosure(closure2448, var_t);
  addtoclosure(closure2448, var_candidate);
  addtoclosure(closure2448, selfslot);
  struct UserObject *uo2448 = (struct UserObject*)block2447;
  uo2448->data[0] = (Object)closure2448;
  Method *meth_meth_collectionsPrelude__apply2448 = addmethod2pos(block2447, "_apply", &meth_collectionsPrelude__apply2448, 0);
  int argcv_meth_collectionsPrelude__apply2448[] = {0};
  meth_meth_collectionsPrelude__apply2448->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2448);
  meth_meth_collectionsPrelude__apply2448->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2448->definitionLine = 1238;
// compiled block node returning block2447 (depth = 3)
  gc_frame_newslot(block2447);
// Begin line 1245
  setline(1245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block2470 = alloc_Block(NULL, NULL, "collectionsPrelude", 1245);
  gc_frame_newslot(block2470);
// method _apply
  block_savedest(block2470);
  Object closure2471 = createclosure(6, "_apply");
  setclosureframe(closure2471, stackframe);
  addtoclosure(closure2471, var_x);
  addtoclosure(closure2471, var_candidate);
  addtoclosure(closure2471, var_t);
  addtoclosure(closure2471, var_jump);
  addtoclosure(closure2471, var_s);
  addtoclosure(closure2471, selfslot);
  struct UserObject *uo2471 = (struct UserObject*)block2470;
  uo2471->data[0] = (Object)closure2471;
  Method *meth_meth_collectionsPrelude__apply2471 = addmethod2pos(block2470, "_apply", &meth_collectionsPrelude__apply2471, 0);
  int argcv_meth_collectionsPrelude__apply2471[] = {0};
  meth_meth_collectionsPrelude__apply2471->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2471);
  meth_meth_collectionsPrelude__apply2471->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2471->definitionLine = 1244;
// compiled block node returning block2470 (depth = 3)
  gc_frame_newslot(block2470);
// call case 5: prelude request
  params[0] = block2447;
  params[1] = block2470;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2507 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2446);
// compiled call node returning call2507 (depth = 2)
// Begin line 1256
  setline(1256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_t (depth = 3)
  return *var_t;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply2512(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2514 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  partcv[0] = 0;
  Object call2515 = callmethod(*var_each, "asString",
    1, partcv, params);
  gc_frame_end(callframe2514);
// compiled call node returning call2515 (depth = 7)
// compiled member node returning call2515 (depth = 6)
  int op_slot_right_2513 = gc_frame_newslot(call2515);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_2513 = gc_frame_newslot(*var_s);
  params[0] = call2515;
  partcv[0] = 1;
  Object opresult2517 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2517 (depth = 5)
  *var_s = opresult2517;
  if (opresult2517 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude__apply2521(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2523 == NULL) {
    strlit2523 = alloc_String(", ");
    gc_root(strlit2523);
  }
// compiled string node returning strlit2523 (depth = 6)
  int op_slot_right_2522 = gc_frame_newslot(strlit2523);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_2522 = gc_frame_newslot(*var_s);
  params[0] = strlit2523;
  partcv[0] = 1;
  Object opresult2525 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2525 (depth = 5)
  *var_s = opresult2525;
  if (opresult2525 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_asString2508(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
// Begin line 1260
  setline(1260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit2509 == NULL) {
    strlit2509 = alloc_String("set{");
    gc_root(strlit2509);
  }
// compiled string node returning strlit2509 (depth = 3)
  *var_s = strlit2509;
  if (strlit2509 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1261
  setline(1261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2510 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2511 = alloc_Block(NULL, NULL, "collectionsPrelude", 1261);
  gc_frame_newslot(block2511);
// method _apply
  block_savedest(block2511);
  Object closure2512 = createclosure(2, "_apply");
  setclosureframe(closure2512, stackframe);
  addtoclosure(closure2512, var_s);
  addtoclosure(closure2512, selfslot);
  struct UserObject *uo2512 = (struct UserObject*)block2511;
  uo2512->data[0] = (Object)closure2512;
  Method *meth_meth_collectionsPrelude__apply2512 = addmethod2pos(block2511, "_apply", &meth_collectionsPrelude__apply2512, 0);
  int argcv_meth_collectionsPrelude__apply2512[] = {1};
  meth_meth_collectionsPrelude__apply2512->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2512);
  meth_meth_collectionsPrelude__apply2512->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2512->definitionLine = 1244;
// compiled block node returning block2511 (depth = 3)
  gc_frame_newslot(block2511);
// Begin line 1262
  setline(1262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block2520 = alloc_Block(NULL, NULL, "collectionsPrelude", 1262);
  gc_frame_newslot(block2520);
// method _apply
  block_savedest(block2520);
  Object closure2521 = createclosure(2, "_apply");
  setclosureframe(closure2521, stackframe);
  addtoclosure(closure2521, var_s);
  addtoclosure(closure2521, selfslot);
  struct UserObject *uo2521 = (struct UserObject*)block2520;
  uo2521->data[0] = (Object)closure2521;
  Method *meth_meth_collectionsPrelude__apply2521 = addmethod2pos(block2520, "_apply", &meth_collectionsPrelude__apply2521, 0);
  int argcv_meth_collectionsPrelude__apply2521[] = {0};
  meth_meth_collectionsPrelude__apply2521->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2521);
  meth_meth_collectionsPrelude__apply2521->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2521->definitionLine = 1261;
// compiled block node returning block2520 (depth = 3)
  gc_frame_newslot(block2520);
// call case 4: self request
  params[0] = block2511;
  params[1] = block2520;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2528 = callmethodflags(self, "do()separatedBy", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2510);
// compiled call node returning call2528 (depth = 2)
// Begin line 1263
  setline(1263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit2530 == NULL) {
    strlit2530 = alloc_String("}");
    gc_root(strlit2530);
  }
// compiled string node returning strlit2530 (depth = 3)
  int op_slot_right_2529 = gc_frame_newslot(strlit2530);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  int op_slot_left_2529 = gc_frame_newslot(*var_s);
  params[0] = strlit2530;
  partcv[0] = 1;
  Object opresult2532 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2532 (depth = 2)
  gc_frame_end(frame);
  return opresult2532;
}
Object meth_collectionsPrelude__apply2536(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1267
  setline(1267);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2537 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  gc_frame_newslot(*var_i);
// call case 4: self request
  params[0] = *var_i;
  partcv[0] = 1;
  Object call2538 = callmethodflags(self, "add", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2537);
// compiled call node returning call2538 (depth = 4)
  gc_frame_end(frame);
  return call2538;
}
Object meth_collectionsPrelude_extend2533(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "extend");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method extend");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for extend (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for extend");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1266
  setline(1266);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2534 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_l (depth = 3)
  gc_frame_newslot(*var_l);
// starting to compile block node (depth = 3)
  Object block2535 = alloc_Block(NULL, NULL, "collectionsPrelude", 1266);
  gc_frame_newslot(block2535);
// method _apply
  block_savedest(block2535);
  Object closure2536 = createclosure(1, "_apply");
  setclosureframe(closure2536, stackframe);
  addtoclosure(closure2536, selfslot);
  struct UserObject *uo2536 = (struct UserObject*)block2535;
  uo2536->data[0] = (Object)closure2536;
  Method *meth_meth_collectionsPrelude__apply2536 = addmethod2pos(block2535, "_apply", &meth_collectionsPrelude__apply2536, 0);
  int argcv_meth_collectionsPrelude__apply2536[] = {1};
  meth_meth_collectionsPrelude__apply2536->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2536);
  meth_meth_collectionsPrelude__apply2536->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2536->definitionLine = 1261;
// compiled block node returning block2535 (depth = 3)
  gc_frame_newslot(block2535);
// call case 5: prelude request
  params[0] = *var_l;
  params[1] = block2535;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2540 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2534);
// compiled call node returning call2540 (depth = 2)
  gc_frame_end(frame);
  return call2540;
}
Object meth_collectionsPrelude__apply2546(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_found = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2548 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2549 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2548);
// compiled call node returning call2549 (depth = 6)
// compiled member node returning call2549 (depth = 5)
  int op_slot_right_2547 = gc_frame_newslot(call2549);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_found (depth = 5)
  int op_slot_left_2547 = gc_frame_newslot(*var_found);
  params[0] = call2549;
  partcv[0] = 1;
  Object opresult2551 = callmethod(*var_found, "<", 1, partcv, params);
// compiled op node returning opresult2551 (depth = 4)
  gc_frame_end(frame);
  return opresult2551;
}
Object meth_collectionsPrelude__apply2563(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_candidate = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2565 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2566 = callmethodflags(self, "removed", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2565);
// compiled call node returning call2566 (depth = 9)
// compiled member node returning call2566 (depth = 8)
  int op_slot_right_2564 = gc_frame_newslot(call2566);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_candidate (depth = 8)
  int op_slot_left_2564 = gc_frame_newslot(*var_candidate);
  params[0] = call2566;
  partcv[0] = 1;
  Object opresult2568 = callmethod(*var_candidate, "!=", 1, partcv, params);
// compiled op node returning opresult2568 (depth = 7)
  gc_frame_end(frame);
  return opresult2568;
}
Object meth_collectionsPrelude__apply2554(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object *var_candidate = getfromclosure(closure, 1);
  Object *var_found = getfromclosure(closure, 2);
  Object *var_block1 = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 4)
// Begin line 1275
  setline(1275);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2555 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2556 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2557 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2556);
// compiled call node returning call2557 (depth = 7)
// compiled member node returning call2557 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call2558 = callmethod(call2557, "at",
    1, partcv, params);
  gc_frame_end(callframe2555);
// compiled call node returning call2558 (depth = 5)
  *var_candidate = call2558;
  if (call2558 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1276
  setline(1276);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2561 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block2562 = alloc_Block(NULL, NULL, "collectionsPrelude", 1276);
  gc_frame_newslot(block2562);
// method _apply
  block_savedest(block2562);
  Object closure2563 = createclosure(2, "_apply");
  setclosureframe(closure2563, stackframe);
  addtoclosure(closure2563, var_candidate);
  addtoclosure(closure2563, selfslot);
  struct UserObject *uo2563 = (struct UserObject*)block2562;
  uo2563->data[0] = (Object)closure2563;
  Method *meth_meth_collectionsPrelude__apply2563 = addmethod2pos(block2562, "_apply", &meth_collectionsPrelude__apply2563, 0);
  int argcv_meth_collectionsPrelude__apply2563[] = {0};
  meth_meth_collectionsPrelude__apply2563->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2563);
  meth_meth_collectionsPrelude__apply2563->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2563->definitionLine = 1275;
// compiled block node returning block2562 (depth = 6)
  gc_frame_newslot(block2562);
// call case 6: other member request
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2571 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2572 = callmethodflags(self, "unused", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2571);
// compiled call node returning call2572 (depth = 8)
// compiled member node returning call2572 (depth = 7)
  int op_slot_right_2570 = gc_frame_newslot(call2572);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_candidate (depth = 7)
  int op_slot_left_2570 = gc_frame_newslot(*var_candidate);
  params[0] = call2572;
  partcv[0] = 1;
  Object opresult2574 = callmethod(*var_candidate, "!=", 1, partcv, params);
// compiled op node returning opresult2574 (depth = 6)
  params[0] = block2562;
  partcv[0] = 1;
  Object call2575 = callmethod(opresult2574, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe2561);
// compiled call node returning call2575 (depth = 5)
  Object if2560 = done;
  if (istrue(call2575)) {
// Begin line 1277
  setline(1277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2577 = alloc_Float64(1);
// compiled num node returning num2577 (depth = 7)
  int op_slot_right_2576 = gc_frame_newslot(num2577);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_found (depth = 7)
  int op_slot_left_2576 = gc_frame_newslot(*var_found);
  params[0] = num2577;
  partcv[0] = 1;
  Object sum2579 = callmethod(*var_found, "+", 1, partcv, params);
// compiled op node returning sum2579 (depth = 6)
  *var_found = sum2579;
  if (sum2579 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1278
  setline(1278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2581 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_candidate (depth = 6)
  gc_frame_newslot(*var_candidate);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_block1 (depth = 6)
  params[0] = *var_candidate;
  partcv[0] = 1;
  Object call2582 = callmethod(*var_block1, "apply",
    1, partcv, params);
  gc_frame_end(callframe2581);
// compiled call node returning call2582 (depth = 5)
    gc_frame_newslot(call2582);
    if2560 = call2582;
  } else {
  }
// compiled if node returning if2560 (depth = 4)
// Begin line 1280
  setline(1280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num2584 = alloc_Float64(1);
// compiled num node returning num2584 (depth = 6)
  int op_slot_right_2583 = gc_frame_newslot(num2584);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_2583 = gc_frame_newslot(*var_i);
  params[0] = num2584;
  partcv[0] = 1;
  Object sum2586 = callmethod(*var_i, "+", 1, partcv, params);
// compiled op node returning sum2586 (depth = 5)
  *var_i = sum2586;
  if (sum2586 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_do2541(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method do");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for do (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for do");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_i = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "i");
  Object *var_found = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "found");
  Object *var_candidate = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "candidate");
// Begin line 1271
  setline(1271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num2542 = alloc_Float64(0);
// compiled num node returning num2542 (depth = 3)
  *var_i = num2542;
  if (num2542 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1272
  setline(1272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num2543 = alloc_Float64(0);
// compiled num node returning num2543 (depth = 3)
  *var_found = num2543;
  if (num2543 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1273
  setline(1273);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_candidate = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1274
  setline(1274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2544 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2545 = alloc_Block(NULL, NULL, "collectionsPrelude", 1274);
  gc_frame_newslot(block2545);
// method _apply
  block_savedest(block2545);
  Object closure2546 = createclosure(2, "_apply");
  setclosureframe(closure2546, stackframe);
  addtoclosure(closure2546, var_found);
  addtoclosure(closure2546, selfslot);
  struct UserObject *uo2546 = (struct UserObject*)block2545;
  uo2546->data[0] = (Object)closure2546;
  Method *meth_meth_collectionsPrelude__apply2546 = addmethod2pos(block2545, "_apply", &meth_collectionsPrelude__apply2546, 0);
  int argcv_meth_collectionsPrelude__apply2546[] = {0};
  meth_meth_collectionsPrelude__apply2546->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2546);
  meth_meth_collectionsPrelude__apply2546->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2546->definitionLine = 1261;
// compiled block node returning block2545 (depth = 3)
  gc_frame_newslot(block2545);
// starting to compile block node (depth = 3)
  Object block2553 = alloc_Block(NULL, NULL, "collectionsPrelude", 1274);
  gc_frame_newslot(block2553);
// method _apply
  block_savedest(block2553);
  Object closure2554 = createclosure(5, "_apply");
  setclosureframe(closure2554, stackframe);
  addtoclosure(closure2554, var_i);
  addtoclosure(closure2554, var_candidate);
  addtoclosure(closure2554, var_found);
  addtoclosure(closure2554, var_block1);
  addtoclosure(closure2554, selfslot);
  struct UserObject *uo2554 = (struct UserObject*)block2553;
  uo2554->data[0] = (Object)closure2554;
  Method *meth_meth_collectionsPrelude__apply2554 = addmethod2pos(block2553, "_apply", &meth_collectionsPrelude__apply2554, 0);
  int argcv_meth_collectionsPrelude__apply2554[] = {0};
  meth_meth_collectionsPrelude__apply2554->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2554);
  meth_meth_collectionsPrelude__apply2554->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2554->definitionLine = 1274;
// compiled block node returning block2553 (depth = 3)
  gc_frame_newslot(block2553);
// call case 5: prelude request
  params[0] = block2545;
  params[1] = block2553;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2589 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2544);
// compiled call node returning call2589 (depth = 2)
  gc_frame_end(frame);
  return call2589;
}
Object meth_collectionsPrelude_hasNext2596(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for hasNext (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for hasNext");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1288
  setline(1288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2598 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2599 = callmethodflags(self, "count", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2598);
// compiled call node returning call2599 (depth = 4)
// compiled member node returning call2599 (depth = 3)
  int op_slot_right_2597 = gc_frame_newslot(call2599);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2601 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2602 = gc_frame_new();
// call case 3: self.outer request
  Object call2603 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2602);
// compiled call node returning call2603 (depth = 6)
// compiled member node returning call2603 (depth = 5)
  partcv[0] = 0;
  Object call2604 = callmethodflags(call2603, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2601);
// compiled call node returning call2604 (depth = 4)
// compiled member node returning call2604 (depth = 3)
  int op_slot_left_2597 = gc_frame_newslot(call2604);
  params[0] = call2599;
  partcv[0] = 1;
  Object opresult2605 = callmethod(call2604, ">=", 1, partcv, params);
// compiled op node returning opresult2605 (depth = 2)
  gc_frame_end(frame);
  return opresult2605;
}
Object meth_collectionsPrelude__apply2671(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_candidate = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2673 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2674 = gc_frame_new();
// call case 3: self.outer request
  Object call2675 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2674);
// compiled call node returning call2675 (depth = 10)
// compiled member node returning call2675 (depth = 9)
  partcv[0] = 0;
  Object call2676 = callmethodflags(call2675, "removed", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2673);
// compiled call node returning call2676 (depth = 8)
// compiled member node returning call2676 (depth = 7)
  int op_slot_right_2672 = gc_frame_newslot(call2676);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_candidate (depth = 7)
  int op_slot_left_2672 = gc_frame_newslot(*var_candidate);
  params[0] = call2676;
  partcv[0] = 1;
  Object opresult2678 = callmethod(*var_candidate, "==", 1, partcv, params);
// compiled op node returning opresult2678 (depth = 6)
  gc_frame_end(frame);
  return opresult2678;
}
Object meth_collectionsPrelude__apply2615(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_innerSize = getfromclosure(closure, 1);
  Object *var_Exhausted = getfromclosure(closure, 2);
  Object *var_candidate = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 4)
// Begin line 1291
  setline(1291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2616 = gc_frame_new();
// Begin line 1293
  setline(1293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2618 = alloc_Float64(1);
// compiled num node returning num2618 (depth = 7)
  int op_slot_right_2617 = gc_frame_newslot(num2618);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2620 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2621 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2620);
// compiled call node returning call2621 (depth = 8)
// compiled member node returning call2621 (depth = 7)
  int op_slot_left_2617 = gc_frame_newslot(call2621);
  params[0] = num2618;
  partcv[0] = 1;
  Object sum2622 = callmethod(call2621, "+", 1, partcv, params);
// compiled op node returning sum2622 (depth = 6)
  gc_frame_newslot(sum2622);
// call case 4: self request
  params[0] = sum2622;
  partcv[0] = 1;
  Object call2623 = callmethodflags(self, "idx:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2616);
// compiled call node returning call2623 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1294
  setline(1294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2626 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2627 = gc_frame_new();
// call case 3: self.outer request
  Object call2628 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2627);
// compiled call node returning call2628 (depth = 9)
// compiled member node returning call2628 (depth = 8)
  partcv[0] = 0;
  Object call2629 = callmethodflags(call2628, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2626);
// compiled call node returning call2629 (depth = 7)
// compiled member node returning call2629 (depth = 6)
  int op_slot_right_2625 = gc_frame_newslot(call2629);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2631 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2632 = callmethodflags(self, "imods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2631);
// compiled call node returning call2632 (depth = 7)
// compiled member node returning call2632 (depth = 6)
  int op_slot_left_2625 = gc_frame_newslot(call2632);
  params[0] = call2629;
  partcv[0] = 1;
  Object opresult2633 = callmethod(call2632, "!=", 1, partcv, params);
// compiled op node returning opresult2633 (depth = 5)
  Object if2624 = done;
  if (istrue(opresult2633)) {
// Begin line 1295
  setline(1295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2634 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2635 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2636 = gc_frame_new();
// call case 3: self.outer request
  Object call2637 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2636);
// compiled call node returning call2637 (depth = 9)
// compiled member node returning call2637 (depth = 8)
  partcv[0] = 0;
  Object call2638 = callmethodflags(call2637, "asString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2635);
// compiled call node returning call2638 (depth = 7)
// compiled member node returning call2638 (depth = 6)
  gc_frame_newslot(call2638);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ConcurrentModification (depth = 6)
  params[0] = call2638;
  partcv[0] = 1;
  Object call2639 = callmethod(*var_ConcurrentModification, "raise",
    1, partcv, params);
  gc_frame_end(callframe2634);
// compiled call node returning call2639 (depth = 5)
    gc_frame_newslot(call2639);
    if2624 = call2639;
  } else {
  }
// compiled if node returning if2624 (depth = 4)
// Begin line 1297
  setline(1297);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_innerSize (depth = 6)
  int op_slot_right_2641 = gc_frame_newslot(*var_innerSize);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2643 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2644 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2643);
// compiled call node returning call2644 (depth = 7)
// compiled member node returning call2644 (depth = 6)
  int op_slot_left_2641 = gc_frame_newslot(call2644);
  params[0] = *var_innerSize;
  partcv[0] = 1;
  Object opresult2645 = callmethod(call2644, ">=", 1, partcv, params);
// compiled op node returning opresult2645 (depth = 5)
  Object if2640 = done;
  if (istrue(opresult2645)) {
// Begin line 1298
  setline(1298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2646 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2648 == NULL) {
    strlit2648 = alloc_String("");
    gc_root(strlit2648);
  }
// compiled string node returning strlit2648 (depth = 7)
  int op_slot_right_2647 = gc_frame_newslot(strlit2648);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2651 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2652 = gc_frame_new();
// call case 3: self.outer request
  Object call2653 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2652);
// compiled call node returning call2653 (depth = 11)
// compiled member node returning call2653 (depth = 10)
  partcv[0] = 0;
  Object call2654 = callmethodflags(call2653, "asString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2651);
// compiled call node returning call2654 (depth = 9)
// compiled member node returning call2654 (depth = 8)
  int op_slot_right_2650 = gc_frame_newslot(call2654);
// starting to compile string node (depth = 8)
  if (strlit2656 == NULL) {
    strlit2656 = alloc_String("iterator over ");
    gc_root(strlit2656);
  }
// compiled string node returning strlit2656 (depth = 8)
  int op_slot_left_2650 = gc_frame_newslot(strlit2656);
  params[0] = call2654;
  partcv[0] = 1;
  Object opresult2657 = callmethod(strlit2656, "++", 1, partcv, params);
// compiled op node returning opresult2657 (depth = 7)
  int op_slot_left_2647 = gc_frame_newslot(opresult2657);
  params[0] = strlit2648;
  partcv[0] = 1;
  Object opresult2658 = callmethod(opresult2657, "++", 1, partcv, params);
// compiled op node returning opresult2658 (depth = 6)
  gc_frame_newslot(opresult2658);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Exhausted (depth = 6)
  params[0] = opresult2658;
  partcv[0] = 1;
  Object call2659 = callmethod(*var_Exhausted, "raise",
    1, partcv, params);
  gc_frame_end(callframe2646);
// compiled call node returning call2659 (depth = 5)
    gc_frame_newslot(call2659);
    if2640 = call2659;
  } else {
  }
// compiled if node returning if2640 (depth = 4)
// Begin line 1300
  setline(1300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2660 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2661 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2662 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2661);
// compiled call node returning call2662 (depth = 7)
// compiled member node returning call2662 (depth = 6)
  gc_frame_newslot(call2662);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2663 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2664 = gc_frame_new();
// call case 3: self.outer request
  Object call2665 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2664);
// compiled call node returning call2665 (depth = 9)
// compiled member node returning call2665 (depth = 8)
  partcv[0] = 0;
  Object call2666 = callmethodflags(call2665, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2663);
// compiled call node returning call2666 (depth = 7)
// compiled member node returning call2666 (depth = 6)
  params[0] = call2662;
  partcv[0] = 1;
  Object call2667 = callmethod(call2666, "at",
    1, partcv, params);
  gc_frame_end(callframe2660);
// compiled call node returning call2667 (depth = 5)
  *var_candidate = call2667;
  if (call2667 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1301
  setline(1301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2669 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block2670 = alloc_Block(NULL, NULL, "collectionsPrelude", 1301);
  gc_frame_newslot(block2670);
// method _apply
  block_savedest(block2670);
  Object closure2671 = createclosure(2, "_apply");
  setclosureframe(closure2671, stackframe);
  addtoclosure(closure2671, var_candidate);
  addtoclosure(closure2671, selfslot);
  struct UserObject *uo2671 = (struct UserObject*)block2670;
  uo2671->data[0] = (Object)closure2671;
  Method *meth_meth_collectionsPrelude__apply2671 = addmethod2pos(block2670, "_apply", &meth_collectionsPrelude__apply2671, 0);
  int argcv_meth_collectionsPrelude__apply2671[] = {0};
  meth_meth_collectionsPrelude__apply2671->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2671);
  meth_meth_collectionsPrelude__apply2671->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2671->definitionLine = 1300;
// compiled block node returning block2670 (depth = 5)
  gc_frame_newslot(block2670);
// call case 6: other member request
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2681 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2682 = gc_frame_new();
// call case 3: self.outer request
  Object call2683 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2682);
// compiled call node returning call2683 (depth = 9)
// compiled member node returning call2683 (depth = 8)
  partcv[0] = 0;
  Object call2684 = callmethodflags(call2683, "unused", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2681);
// compiled call node returning call2684 (depth = 7)
// compiled member node returning call2684 (depth = 6)
  int op_slot_right_2680 = gc_frame_newslot(call2684);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_candidate (depth = 6)
  int op_slot_left_2680 = gc_frame_newslot(*var_candidate);
  params[0] = call2684;
  partcv[0] = 1;
  Object opresult2686 = callmethod(*var_candidate, "==", 1, partcv, params);
// compiled op node returning opresult2686 (depth = 5)
  params[0] = block2670;
  partcv[0] = 1;
  Object call2687 = callmethod(opresult2686, "orElse",
    1, partcv, params);
  gc_frame_end(callframe2669);
// compiled call node returning call2687 (depth = 4)
  gc_frame_end(frame);
  return call2687;
}
Object meth_collectionsPrelude__apply2690(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_next2606(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_Exhausted = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for next (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for next");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_candidate = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "candidate");
  Object *var_innerSize = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "innerSize");
// Begin line 1290
  setline(1290);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_candidate = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1291
  setline(1291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2607 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2608 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2609 = gc_frame_new();
// call case 3: self.outer request
  Object call2610 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2609);
// compiled call node returning call2610 (depth = 8)
// compiled member node returning call2610 (depth = 7)
  partcv[0] = 0;
  Object call2611 = callmethodflags(call2610, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2608);
// compiled call node returning call2611 (depth = 6)
// compiled member node returning call2611 (depth = 5)
  partcv[0] = 0;
  Object call2612 = callmethod(call2611, "size",
    1, partcv, params);
  gc_frame_end(callframe2607);
// compiled call node returning call2612 (depth = 4)
// compiled member node returning call2612 (depth = 3)
  *var_innerSize = call2612;
  if (call2612 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1292
  setline(1292);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2613 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2614 = alloc_Block(NULL, NULL, "collectionsPrelude", 1292);
  gc_frame_newslot(block2614);
// method _apply
  block_savedest(block2614);
  Object closure2615 = createclosure(5, "_apply");
  setclosureframe(closure2615, stackframe);
  addtoclosure(closure2615, var_ConcurrentModification);
  addtoclosure(closure2615, var_innerSize);
  addtoclosure(closure2615, var_Exhausted);
  addtoclosure(closure2615, var_candidate);
  addtoclosure(closure2615, selfslot);
  struct UserObject *uo2615 = (struct UserObject*)block2614;
  uo2615->data[0] = (Object)closure2615;
  Method *meth_meth_collectionsPrelude__apply2615 = addmethod2pos(block2614, "_apply", &meth_collectionsPrelude__apply2615, 0);
  int argcv_meth_collectionsPrelude__apply2615[] = {0};
  meth_meth_collectionsPrelude__apply2615->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2615);
  meth_meth_collectionsPrelude__apply2615->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2615->definitionLine = 1291;
// compiled block node returning block2614 (depth = 3)
  gc_frame_newslot(block2614);
// Begin line 1302
  setline(1302);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block2689 = alloc_Block(NULL, NULL, "collectionsPrelude", 1302);
  gc_frame_newslot(block2689);
// method _apply
  block_savedest(block2689);
  Object closure2690 = createclosure(1, "_apply");
  setclosureframe(closure2690, stackframe);
  addtoclosure(closure2690, selfslot);
  struct UserObject *uo2690 = (struct UserObject*)block2689;
  uo2690->data[0] = (Object)closure2690;
  Method *meth_meth_collectionsPrelude__apply2690 = addmethod2pos(block2689, "_apply", &meth_collectionsPrelude__apply2690, 0);
  int argcv_meth_collectionsPrelude__apply2690[] = {0};
  meth_meth_collectionsPrelude__apply2690->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2690);
  meth_meth_collectionsPrelude__apply2690->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2690->definitionLine = 1301;
// compiled block node returning block2689 (depth = 3)
  gc_frame_newslot(block2689);
// call case 5: prelude request
  params[0] = block2614;
  params[1] = block2689;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2692 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2613);
// compiled call node returning call2692 (depth = 2)
// Begin line 1303
  setline(1303);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 1301
  setline(1301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2693 = gc_frame_new();
// Begin line 1303
  setline(1303);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2695 = alloc_Float64(1);
// compiled num node returning num2695 (depth = 5)
  int op_slot_right_2694 = gc_frame_newslot(num2695);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2697 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2698 = callmethodflags(self, "count", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2697);
// compiled call node returning call2698 (depth = 6)
// compiled member node returning call2698 (depth = 5)
  int op_slot_left_2694 = gc_frame_newslot(call2698);
  params[0] = num2695;
  partcv[0] = 1;
  Object sum2699 = callmethod(call2698, "+", 1, partcv, params);
// compiled op node returning sum2699 (depth = 4)
  gc_frame_newslot(sum2699);
// call case 4: self request
  params[0] = sum2699;
  partcv[0] = 1;
  Object call2700 = callmethodflags(self, "count:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2693);
// compiled call node returning call2700 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 1304
  setline(1304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_candidate (depth = 2)
  gc_frame_end(frame);
  return *var_candidate;
}
Object meth_collectionsPrelude_iterator2590(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_Exhausted = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2591 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2591 = alloc_userobj2(8,6, objclass2591);
  gc_frame_newslot(obj2591);
if (objclass2591 == NULL) {
  glfree(obj2591->class->name);
  obj2591->class->name = "obj2210.iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2591, self, 0);
  addmethodreal(obj2591,"outer", &reader_collectionsPrelude_outer_2592);
  Object oldself2591 = self;
  struct StackFrameObject *oldstackframe2591 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2591);
  gc_frame_newslot((Object)stackframe);
  self = obj2591;
  Object *oldselfslot2591 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2591 = (*(struct UserObject *)self).data[0], lowerouter2591 = thisouter2591;
  if (inheritingObject2591) {
    struct UserObject *inho2591 = (struct UserObject *)inheritingObject2591;
    while (inho2591->super != GraceDefaultObject) inho2591 = (struct UserObject *)inho2591->super;
    inho2591->super = obj2591;
    self = inheritingObject2591;
    *selfslot = self;
    lowerouter2591 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2591;
  }
if (objclass2591 == NULL) {
  Method *reader2593 = addmethodrealflags(obj2591, "imods",&reader_collectionsPrelude_imods_2593, MFLAG_CONFIDENTIAL);
  Method *writer2593 = addmethodrealflags(obj2591, "imods:=",&writer_collectionsPrelude_imods_2593, MFLAG_CONFIDENTIAL);
  reader2593->definitionModule = modulename;
  writer2593->definitionModule = modulename;
  reader2593->definitionLine = 1285;
  writer2593->definitionLine = 1285;
}
obj2591->flags |= OFLAG_MUTABLE;
adddatum2(obj2591, alloc_Undefined(), 1);
if (objclass2591 == NULL) {
  Method *reader2594 = addmethodrealflags(obj2591, "count",&reader_collectionsPrelude_count_2594, MFLAG_CONFIDENTIAL);
  Method *writer2594 = addmethodrealflags(obj2591, "count:=",&writer_collectionsPrelude_count_2594, MFLAG_CONFIDENTIAL);
  reader2594->definitionModule = modulename;
  writer2594->definitionModule = modulename;
  reader2594->definitionLine = 1286;
  writer2594->definitionLine = 1286;
}
obj2591->flags |= OFLAG_MUTABLE;
adddatum2(obj2591, alloc_Undefined(), 2);
if (objclass2591 == NULL) {
  Method *reader2595 = addmethodrealflags(obj2591, "idx",&reader_collectionsPrelude_idx_2595, MFLAG_CONFIDENTIAL);
  Method *writer2595 = addmethodrealflags(obj2591, "idx:=",&writer_collectionsPrelude_idx_2595, MFLAG_CONFIDENTIAL);
  reader2595->definitionModule = modulename;
  writer2595->definitionModule = modulename;
  reader2595->definitionLine = 1287;
  writer2595->definitionLine = 1287;
}
obj2591->flags |= OFLAG_MUTABLE;
adddatum2(obj2591, alloc_Undefined(), 3);
// method hasNext
  struct UserObject *uo2596 = (struct UserObject*)obj2591;
  uo2596->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext2596 = addmethod2pos(obj2591, "hasNext", &meth_collectionsPrelude_hasNext2596, 4);
  int argcv_meth_collectionsPrelude_hasNext2596[] = {0};
  meth_meth_collectionsPrelude_hasNext2596->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext2596);
  meth_meth_collectionsPrelude_hasNext2596->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext2596->definitionLine = 1288;
// method next
  block_savedest(obj2591);
  Object closure2606 = createclosure(2, "next");
  setclosureframe(closure2606, stackframe);
  addtoclosure(closure2606, var_ConcurrentModification);
  addtoclosure(closure2606, var_Exhausted);
  struct UserObject *uo2606 = (struct UserObject*)obj2591;
  uo2606->data[5] = (Object)closure2606;
  Method *meth_meth_collectionsPrelude_next2606 = addmethod2pos(obj2591, "next", &meth_collectionsPrelude_next2606, 5);
  int argcv_meth_collectionsPrelude_next2606[] = {0};
  meth_meth_collectionsPrelude_next2606->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next2606);
  meth_meth_collectionsPrelude_next2606->definitionModule = modulename;
  meth_meth_collectionsPrelude_next2606->definitionLine = 1289;
  sourceObject = obj2591;
// Begin line 1285
  setline(1285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2701 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2702 = gc_frame_new();
// call case 3: self.outer request
  Object call2703 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2702);
// compiled call node returning call2703 (depth = 5)
// compiled member node returning call2703 (depth = 4)
  partcv[0] = 0;
  Object call2704 = callmethodflags(call2703, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2701);
// compiled call node returning call2704 (depth = 3)
// compiled member node returning call2704 (depth = 2)
  adddatum2(obj2591, call2704, 1);
  sourceObject = obj2591;
// Begin line 1286
  setline(1286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2705 = alloc_Float64(1);
// compiled num node returning num2705 (depth = 2)
  adddatum2(obj2591, num2705, 2);
  sourceObject = obj2591;
// Begin line 1288
  setline(1288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2706 = gc_frame_new();
// call case 6: other member request
// Begin line 1287
  setline(1287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num2707 = alloc_Float64(1);
// compiled num node returning num2707 (depth = 3)
  partcv[0] = 0;
  Object call2708 = callmethod(num2707, "prefix-",
    1, partcv, params);
  gc_frame_end(callframe2706);
// compiled call node returning call2708 (depth = 2)
  adddatum2(obj2591, call2708, 3);
  sourceObject = obj2591;
  sourceObject = obj2591;
  objclass2591 = obj2591->class;
  objclass2591->definitionModule = modulename;
  objclass2591->definitionLine = 1284;
  (*(struct UserObject *)self).data[0] = lowerouter2591;
  self = oldself2591;
  selfslot = oldselfslot2591;
  stackframe = oldstackframe2591;
  gc_frame_end(frame);
  return obj2591;
}
Object meth_collectionsPrelude_iterator2590_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_Exhausted = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2591 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2591 = alloc_userobj2(8,6, objclass2591);
  gc_frame_newslot(obj2591);
if (objclass2591 == NULL) {
  glfree(obj2591->class->name);
  obj2591->class->name = "obj2210.iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2591, self, 0);
  addmethodreal(obj2591,"outer", &reader_collectionsPrelude_outer_2592);
  Object oldself2591 = self;
  struct StackFrameObject *oldstackframe2591 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2591);
  gc_frame_newslot((Object)stackframe);
  self = obj2591;
  Object *oldselfslot2591 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2591 = (*(struct UserObject *)self).data[0], lowerouter2591 = thisouter2591;
  if (inheritingObject2591) {
    struct UserObject *inho2591 = (struct UserObject *)inheritingObject2591;
    while (inho2591->super != GraceDefaultObject) inho2591 = (struct UserObject *)inho2591->super;
    inho2591->super = obj2591;
    self = inheritingObject2591;
    *selfslot = self;
    lowerouter2591 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2591;
  }
if (objclass2591 == NULL) {
  Method *reader2593 = addmethodrealflags(obj2591, "imods",&reader_collectionsPrelude_imods_2593, MFLAG_CONFIDENTIAL);
  Method *writer2593 = addmethodrealflags(obj2591, "imods:=",&writer_collectionsPrelude_imods_2593, MFLAG_CONFIDENTIAL);
  reader2593->definitionModule = modulename;
  writer2593->definitionModule = modulename;
  reader2593->definitionLine = 1285;
  writer2593->definitionLine = 1285;
}
obj2591->flags |= OFLAG_MUTABLE;
adddatum2(obj2591, alloc_Undefined(), 1);
if (objclass2591 == NULL) {
  Method *reader2594 = addmethodrealflags(obj2591, "count",&reader_collectionsPrelude_count_2594, MFLAG_CONFIDENTIAL);
  Method *writer2594 = addmethodrealflags(obj2591, "count:=",&writer_collectionsPrelude_count_2594, MFLAG_CONFIDENTIAL);
  reader2594->definitionModule = modulename;
  writer2594->definitionModule = modulename;
  reader2594->definitionLine = 1286;
  writer2594->definitionLine = 1286;
}
obj2591->flags |= OFLAG_MUTABLE;
adddatum2(obj2591, alloc_Undefined(), 2);
if (objclass2591 == NULL) {
  Method *reader2595 = addmethodrealflags(obj2591, "idx",&reader_collectionsPrelude_idx_2595, MFLAG_CONFIDENTIAL);
  Method *writer2595 = addmethodrealflags(obj2591, "idx:=",&writer_collectionsPrelude_idx_2595, MFLAG_CONFIDENTIAL);
  reader2595->definitionModule = modulename;
  writer2595->definitionModule = modulename;
  reader2595->definitionLine = 1287;
  writer2595->definitionLine = 1287;
}
obj2591->flags |= OFLAG_MUTABLE;
adddatum2(obj2591, alloc_Undefined(), 3);
// method hasNext
  struct UserObject *uo2596 = (struct UserObject*)obj2591;
  uo2596->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext2596 = addmethod2pos(obj2591, "hasNext", &meth_collectionsPrelude_hasNext2596, 4);
  int argcv_meth_collectionsPrelude_hasNext2596[] = {0};
  meth_meth_collectionsPrelude_hasNext2596->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext2596);
  meth_meth_collectionsPrelude_hasNext2596->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext2596->definitionLine = 1288;
// method next
  block_savedest(obj2591);
  Object closure2606 = createclosure(2, "next");
  setclosureframe(closure2606, stackframe);
  addtoclosure(closure2606, var_ConcurrentModification);
  addtoclosure(closure2606, var_Exhausted);
  struct UserObject *uo2606 = (struct UserObject*)obj2591;
  uo2606->data[5] = (Object)closure2606;
  Method *meth_meth_collectionsPrelude_next2606 = addmethod2pos(obj2591, "next", &meth_collectionsPrelude_next2606, 5);
  int argcv_meth_collectionsPrelude_next2606[] = {0};
  meth_meth_collectionsPrelude_next2606->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next2606);
  meth_meth_collectionsPrelude_next2606->definitionModule = modulename;
  meth_meth_collectionsPrelude_next2606->definitionLine = 1289;
  sourceObject = obj2591;
// Begin line 1285
  setline(1285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2701 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2702 = gc_frame_new();
// call case 3: self.outer request
  Object call2703 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2702);
// compiled call node returning call2703 (depth = 5)
// compiled member node returning call2703 (depth = 4)
  partcv[0] = 0;
  Object call2704 = callmethodflags(call2703, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2701);
// compiled call node returning call2704 (depth = 3)
// compiled member node returning call2704 (depth = 2)
  adddatum2(obj2591, call2704, 1);
  sourceObject = obj2591;
// Begin line 1286
  setline(1286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2705 = alloc_Float64(1);
// compiled num node returning num2705 (depth = 2)
  adddatum2(obj2591, num2705, 2);
  sourceObject = obj2591;
// Begin line 1288
  setline(1288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2706 = gc_frame_new();
// call case 6: other member request
// Begin line 1287
  setline(1287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num2707 = alloc_Float64(1);
// compiled num node returning num2707 (depth = 3)
  partcv[0] = 0;
  Object call2708 = callmethod(num2707, "prefix-",
    1, partcv, params);
  gc_frame_end(callframe2706);
// compiled call node returning call2708 (depth = 2)
  adddatum2(obj2591, call2708, 3);
  sourceObject = obj2591;
  sourceObject = obj2591;
  objclass2591 = obj2591->class;
  objclass2591->definitionModule = modulename;
  objclass2591->definitionLine = 1284;
  (*(struct UserObject *)self).data[0] = lowerouter2591;
  self = oldself2591;
  selfslot = oldselfslot2591;
  stackframe = oldstackframe2591;
  gc_frame_end(frame);
  return obj2591;
}
Object meth_collectionsPrelude__apply2744(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1316
  setline(1316);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2745 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  gc_frame_newslot(*var_i);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2746 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2747 = callmethodflags(self, "unused", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2746);
// compiled call node returning call2747 (depth = 6)
// compiled member node returning call2747 (depth = 5)
  gc_frame_newslot(call2747);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2748 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2749 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2748);
// compiled call node returning call2749 (depth = 6)
// compiled member node returning call2749 (depth = 5)
  params[0] = *var_i;
  params[1] = call2747;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2750 = callmethod(call2749, "at()put",
    2, partcv, params);
  gc_frame_end(callframe2745);
// compiled call node returning call2750 (depth = 4)
  gc_frame_end(frame);
  return call2750;
}
Object meth_collectionsPrelude__apply2769(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object *var_oldInner = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2771 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2772 = callmethodflags(self, "removed", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2771);
// compiled call node returning call2772 (depth = 9)
// compiled member node returning call2772 (depth = 8)
  int op_slot_right_2770 = gc_frame_newslot(call2772);
// starting to compile call node (depth = 8)
  int callframe2774 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_oldInner (depth = 9)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call2775 = callmethod(*var_oldInner, "at",
    1, partcv, params);
  gc_frame_end(callframe2774);
// compiled call node returning call2775 (depth = 8)
  int op_slot_left_2770 = gc_frame_newslot(call2775);
  params[0] = call2772;
  partcv[0] = 1;
  Object opresult2776 = callmethod(call2775, "!=", 1, partcv, params);
// compiled op node returning opresult2776 (depth = 7)
  gc_frame_end(frame);
  return opresult2776;
}
Object meth_collectionsPrelude__apply2765(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_oldInner = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1319
  setline(1319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2767 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block2768 = alloc_Block(NULL, NULL, "collectionsPrelude", 1319);
  gc_frame_newslot(block2768);
// method _apply
  block_savedest(block2768);
  Object closure2769 = createclosure(3, "_apply");
  setclosureframe(closure2769, stackframe);
  addtoclosure(closure2769, var_i);
  addtoclosure(closure2769, var_oldInner);
  addtoclosure(closure2769, selfslot);
  struct UserObject *uo2769 = (struct UserObject*)block2768;
  uo2769->data[0] = (Object)closure2769;
  Method *meth_meth_collectionsPrelude__apply2769 = addmethod2pos(block2768, "_apply", &meth_collectionsPrelude__apply2769, 0);
  int argcv_meth_collectionsPrelude__apply2769[] = {0};
  meth_meth_collectionsPrelude__apply2769->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2769);
  meth_meth_collectionsPrelude__apply2769->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2769->definitionLine = 1318;
// compiled block node returning block2768 (depth = 6)
  gc_frame_newslot(block2768);
// call case 6: other member request
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2779 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2780 = callmethodflags(self, "unused", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2779);
// compiled call node returning call2780 (depth = 8)
// compiled member node returning call2780 (depth = 7)
  int op_slot_right_2778 = gc_frame_newslot(call2780);
// starting to compile call node (depth = 7)
  int callframe2782 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_oldInner (depth = 8)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call2783 = callmethod(*var_oldInner, "at",
    1, partcv, params);
  gc_frame_end(callframe2782);
// compiled call node returning call2783 (depth = 7)
  int op_slot_left_2778 = gc_frame_newslot(call2783);
  params[0] = call2780;
  partcv[0] = 1;
  Object opresult2784 = callmethod(call2783, "!=", 1, partcv, params);
// compiled op node returning opresult2784 (depth = 6)
  params[0] = block2768;
  partcv[0] = 1;
  Object call2785 = callmethod(opresult2784, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe2767);
// compiled call node returning call2785 (depth = 5)
  Object if2766 = done;
  if (istrue(call2785)) {
// Begin line 1320
  setline(1320);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2786 = gc_frame_new();
// starting to compile call node (depth = 6)
  int callframe2787 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_i (depth = 7)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_oldInner (depth = 7)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call2788 = callmethod(*var_oldInner, "at",
    1, partcv, params);
  gc_frame_end(callframe2787);
// compiled call node returning call2788 (depth = 6)
  gc_frame_newslot(call2788);
// call case 4: self request
  params[0] = call2788;
  partcv[0] = 1;
  Object call2789 = callmethodflags(self, "add", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2786);
// compiled call node returning call2789 (depth = 5)
    gc_frame_newslot(call2789);
    if2766 = call2789;
  } else {
  }
// compiled if node returning if2766 (depth = 4)
  gc_frame_end(frame);
  return if2766;
}
Object meth_collectionsPrelude_expand2710(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 22, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "expand");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var__prelude = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for expand (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for expand");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_c = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "c");
  Object *var_n = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "n");
  Object *var_oldInner = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "oldInner");
// Begin line 1310
  setline(1310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2711 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2712 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2713 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2712);
// compiled call node returning call2713 (depth = 6)
// compiled member node returning call2713 (depth = 5)
  partcv[0] = 0;
  Object call2714 = callmethod(call2713, "size",
    1, partcv, params);
  gc_frame_end(callframe2711);
// compiled call node returning call2714 (depth = 4)
// compiled member node returning call2714 (depth = 3)
  *var_c = call2714;
  if (call2714 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1311
  setline(1311);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num2716 = alloc_Float64(2);
// compiled num node returning num2716 (depth = 4)
  int op_slot_right_2715 = gc_frame_newslot(num2716);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  int op_slot_left_2715 = gc_frame_newslot(*var_c);
  params[0] = num2716;
  partcv[0] = 1;
  Object prod2718 = callmethod(*var_c, "*", 1, partcv, params);
// compiled op node returning prod2718 (depth = 3)
  *var_n = prod2718;
  if (prod2718 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1312
  setline(1312);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2719 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2720 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2719);
// compiled call node returning call2720 (depth = 4)
// compiled member node returning call2720 (depth = 3)
  *var_oldInner = call2720;
  if (call2720 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1313
  setline(1313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 1312
  setline(1312);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2721 = gc_frame_new();
// Begin line 1313
  setline(1313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num2722 = alloc_Float64(0);
// compiled num node returning num2722 (depth = 4)
  gc_frame_newslot(num2722);
// call case 4: self request
  params[0] = num2722;
  partcv[0] = 1;
  Object call2723 = callmethodflags(self, "size:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2721);
// compiled call node returning call2723 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 1314
  setline(1314);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 1312
  setline(1312);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2724 = gc_frame_new();
// Begin line 1314
  setline(1314);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2725 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2726 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var__prelude (depth = 7)
  partcv[0] = 0;
  Object call2727 = callmethod(*var__prelude, "PrimitiveArray",
    1, partcv, params);
  gc_frame_end(callframe2726);
// compiled call node returning call2727 (depth = 6)
// compiled member node returning call2727 (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call2728 = callmethod(call2727, "new",
    1, partcv, params);
  gc_frame_end(callframe2725);
// compiled call node returning call2728 (depth = 4)
  gc_frame_newslot(call2728);
// call case 4: self request
  params[0] = call2728;
  partcv[0] = 1;
  Object call2729 = callmethodflags(self, "inner:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2724);
// compiled call node returning call2729 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 1315
  setline(1315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2730 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2733 = alloc_Float64(1);
// compiled num node returning num2733 (depth = 5)
  int op_slot_right_2732 = gc_frame_newslot(num2733);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2735 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2736 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2737 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2736);
// compiled call node returning call2737 (depth = 8)
// compiled member node returning call2737 (depth = 7)
  partcv[0] = 0;
  Object call2738 = callmethod(call2737, "size",
    1, partcv, params);
  gc_frame_end(callframe2735);
// compiled call node returning call2738 (depth = 6)
// compiled member node returning call2738 (depth = 5)
  int op_slot_left_2732 = gc_frame_newslot(call2738);
  params[0] = num2733;
  partcv[0] = 1;
  Object diff2739 = callmethod(call2738, "-", 1, partcv, params);
// compiled op node returning diff2739 (depth = 4)
  int op_slot_right_2731 = gc_frame_newslot(diff2739);
// starting to compile num node (depth = 4)
  Object num2741 = alloc_Float64(0);
// compiled num node returning num2741 (depth = 4)
  int op_slot_left_2731 = gc_frame_newslot(num2741);
  params[0] = diff2739;
  partcv[0] = 1;
  Object opresult2742 = callmethod(num2741, "..", 1, partcv, params);
// compiled op node returning opresult2742 (depth = 3)
  gc_frame_newslot(opresult2742);
// starting to compile block node (depth = 3)
  Object block2743 = alloc_Block(NULL, NULL, "collectionsPrelude", 1315);
  gc_frame_newslot(block2743);
// method _apply
  block_savedest(block2743);
  Object closure2744 = createclosure(1, "_apply");
  setclosureframe(closure2744, stackframe);
  addtoclosure(closure2744, selfslot);
  struct UserObject *uo2744 = (struct UserObject*)block2743;
  uo2744->data[0] = (Object)closure2744;
  Method *meth_meth_collectionsPrelude__apply2744 = addmethod2pos(block2743, "_apply", &meth_collectionsPrelude__apply2744, 0);
  int argcv_meth_collectionsPrelude__apply2744[] = {1};
  meth_meth_collectionsPrelude__apply2744->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2744);
  meth_meth_collectionsPrelude__apply2744->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2744->definitionLine = 1315;
// compiled block node returning block2743 (depth = 3)
  gc_frame_newslot(block2743);
// call case 5: prelude request
  params[0] = opresult2742;
  params[1] = block2743;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2752 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2730);
// compiled call node returning call2752 (depth = 2)
// Begin line 1318
  setline(1318);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2753 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2756 = alloc_Float64(1);
// compiled num node returning num2756 (depth = 5)
  int op_slot_right_2755 = gc_frame_newslot(num2756);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2758 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_oldInner (depth = 7)
  partcv[0] = 0;
  Object call2759 = callmethod(*var_oldInner, "size",
    1, partcv, params);
  gc_frame_end(callframe2758);
// compiled call node returning call2759 (depth = 6)
// compiled member node returning call2759 (depth = 5)
  int op_slot_left_2755 = gc_frame_newslot(call2759);
  params[0] = num2756;
  partcv[0] = 1;
  Object diff2760 = callmethod(call2759, "-", 1, partcv, params);
// compiled op node returning diff2760 (depth = 4)
  int op_slot_right_2754 = gc_frame_newslot(diff2760);
// starting to compile num node (depth = 4)
  Object num2762 = alloc_Float64(0);
// compiled num node returning num2762 (depth = 4)
  int op_slot_left_2754 = gc_frame_newslot(num2762);
  params[0] = diff2760;
  partcv[0] = 1;
  Object opresult2763 = callmethod(num2762, "..", 1, partcv, params);
// compiled op node returning opresult2763 (depth = 3)
  gc_frame_newslot(opresult2763);
// starting to compile block node (depth = 3)
  Object block2764 = alloc_Block(NULL, NULL, "collectionsPrelude", 1318);
  gc_frame_newslot(block2764);
// method _apply
  block_savedest(block2764);
  Object closure2765 = createclosure(2, "_apply");
  setclosureframe(closure2765, stackframe);
  addtoclosure(closure2765, var_oldInner);
  addtoclosure(closure2765, selfslot);
  struct UserObject *uo2765 = (struct UserObject*)block2764;
  uo2765->data[0] = (Object)closure2765;
  Method *meth_meth_collectionsPrelude__apply2765 = addmethod2pos(block2764, "_apply", &meth_collectionsPrelude__apply2765, 0);
  int argcv_meth_collectionsPrelude__apply2765[] = {1};
  meth_meth_collectionsPrelude__apply2765->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2765);
  meth_meth_collectionsPrelude__apply2765->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2765->definitionLine = 1318;
// compiled block node returning block2764 (depth = 3)
  gc_frame_newslot(block2764);
// call case 5: prelude request
  params[0] = opresult2763;
  params[1] = block2764;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2791 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2753);
// compiled call node returning call2791 (depth = 2)
  gc_frame_end(frame);
  return call2791;
}
Object meth_collectionsPrelude__apply2799(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_oSize = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1329
  setline(1329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2801 = alloc_Float64(1);
// compiled num node returning num2801 (depth = 8)
  int op_slot_right_2800 = gc_frame_newslot(num2801);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_oSize (depth = 8)
  int op_slot_left_2800 = gc_frame_newslot(*var_oSize);
  params[0] = num2801;
  partcv[0] = 1;
  Object sum2803 = callmethod(*var_oSize, "+", 1, partcv, params);
// compiled op node returning sum2803 (depth = 7)
  *var_oSize = sum2803;
  if (sum2803 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1330
  setline(1330);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2806 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe2807 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_each (depth = 9)
  gc_frame_newslot(*var_each);
// call case 4: self request
  params[0] = *var_each;
  partcv[0] = 1;
  Object call2808 = callmethodflags(self, "contains", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2807);
// compiled call node returning call2808 (depth = 8)
  partcv[0] = 0;
  Object call2809 = callmethod(call2808, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe2806);
// compiled call node returning call2809 (depth = 7)
  Object if2805 = done;
  if (istrue(call2809)) {
// Begin line 1331
  setline(1331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool2810 = alloc_Boolean(0);
// compiled identifier node returning bool2810 (depth = 8)
  block_return(realself, bool2810);
// compiled return node returning undefined (depth = 7)
    gc_frame_newslot(undefined);
    if2805 = undefined;
  } else {
  }
// compiled if node returning if2805 (depth = 6)
  gc_frame_end(frame);
  return if2805;
}
Object meth_collectionsPrelude__apply2795(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_oSize = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "oSize");
// Begin line 1327
  setline(1327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2796 = alloc_Float64(0);
// compiled num node returning num2796 (depth = 5)
  *var_oSize = num2796;
  if (num2796 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1328
  setline(1328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2797 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block2798 = alloc_Block(NULL, NULL, "collectionsPrelude", 1328);
  gc_frame_newslot(block2798);
// method _apply
  block_savedest(block2798);
  Object closure2799 = createclosure(2, "_apply");
  setclosureframe(closure2799, stackframe);
  addtoclosure(closure2799, var_oSize);
  addtoclosure(closure2799, selfslot);
  struct UserObject *uo2799 = (struct UserObject*)block2798;
  uo2799->data[0] = (Object)closure2799;
  Method *meth_meth_collectionsPrelude__apply2799 = addmethod2pos(block2798, "_apply", &meth_collectionsPrelude__apply2799, 0);
  int argcv_meth_collectionsPrelude__apply2799[] = {1};
  meth_meth_collectionsPrelude__apply2799->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2799);
  meth_meth_collectionsPrelude__apply2799->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2799->definitionLine = 1319;
// compiled block node returning block2798 (depth = 5)
  gc_frame_newslot(block2798);
// call case 6: other member request
// Begin line 1328
  setline(1328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  params[0] = block2798;
  partcv[0] = 1;
  Object call2812 = callmethod(*var_o, "do",
    1, partcv, params);
  gc_frame_end(callframe2797);
// compiled call node returning call2812 (depth = 4)
// Begin line 1334
  setline(1334);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2814 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2815 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2814);
// compiled call node returning call2815 (depth = 7)
// compiled member node returning call2815 (depth = 6)
  int op_slot_right_2813 = gc_frame_newslot(call2815);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_oSize (depth = 6)
  int op_slot_left_2813 = gc_frame_newslot(*var_oSize);
  params[0] = call2815;
  partcv[0] = 1;
  Object opresult2817 = callmethod(*var_oSize, "==", 1, partcv, params);
// compiled op node returning opresult2817 (depth = 5)
  block_return(realself, opresult2817);
// compiled return node returning undefined (depth = 4)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply2829(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___18 = &(stackframe->slots[0]);
  *var___18 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1337
  setline(1337);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool2830 = alloc_Boolean(0);
// compiled identifier node returning bool2830 (depth = 5)
  block_return(realself, bool2830);
// compiled return node returning undefined (depth = 4)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__61__61_2792(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 23, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "==");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method ==");
  Object params[2];
  int partcv[1];
  Object *var_Collection = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for == (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for ==");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1325
  setline(1325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  int frame2793 = gc_frame_new();
  gc_frame_newslot(*var_other);
// Begin line 1326
  setline(1326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block2794 = alloc_Block(NULL, NULL, "collectionsPrelude", 1326);
  gc_frame_newslot(block2794);
// method _apply
  block_savedest(block2794);
  Object closure2795 = createclosure(1, "_apply");
  setclosureframe(closure2795, stackframe);
  addtoclosure(closure2795, selfslot);
  struct UserObject *uo2795 = (struct UserObject*)block2794;
  uo2795->data[0] = (Object)closure2795;
  Method *meth_meth_collectionsPrelude__apply2795 = addmethod2pos(block2794, "_apply", &meth_collectionsPrelude__apply2795, 0);
  int argcv_meth_collectionsPrelude__apply2795[] = {1};
  meth_meth_collectionsPrelude__apply2795->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2795);
  meth_meth_collectionsPrelude__apply2795->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2795->definitionLine = 1319;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2819 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe2820 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit2821 == NULL) {
    strlit2821 = alloc_String("o");
    gc_root(strlit2821);
  }
// compiled string node returning strlit2821 (depth = 6)
  gc_frame_newslot(strlit2821);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2822 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call2823 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2822);
// compiled call node returning call2823 (depth = 7)
// compiled member node returning call2823 (depth = 6)
  params[0] = strlit2821;
  partcv[0] = 1;
  Object call2824 = callmethod(call2823, "new",
    1, partcv, params);
  gc_frame_end(callframe2820);
// compiled call node returning call2824 (depth = 5)
  gc_frame_newslot(call2824);
// Begin line 1326
  setline(1326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_Collection (depth = 5)
  gc_frame_newslot(*var_Collection);
// call case 6: other member request
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2825 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call2826 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2825);
// compiled call node returning call2826 (depth = 6)
// compiled member node returning call2826 (depth = 5)
  params[0] = call2824;
  params[1] = *var_Collection;
  partcv[0] = 2;
  Object call2827 = callmethod(call2826, "new",
    1, partcv, params);
  gc_frame_end(callframe2819);
// compiled call node returning call2827 (depth = 4)
((struct UserObject *)block2794)->data[1] = call2827;
// compiled block node returning block2794 (depth = 3)
  gc_frame_newslot(block2794);
// Begin line 1336
  setline(1336);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block2828 = alloc_Block(NULL, NULL, "collectionsPrelude", 1336);
  gc_frame_newslot(block2828);
// method _apply
  block_savedest(block2828);
  Object closure2829 = createclosure(1, "_apply");
  setclosureframe(closure2829, stackframe);
  addtoclosure(closure2829, selfslot);
  struct UserObject *uo2829 = (struct UserObject*)block2828;
  uo2829->data[0] = (Object)closure2829;
  Method *meth_meth_collectionsPrelude__apply2829 = addmethod2pos(block2828, "_apply", &meth_collectionsPrelude__apply2829, 0);
  int argcv_meth_collectionsPrelude__apply2829[] = {1};
  meth_meth_collectionsPrelude__apply2829->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2829);
  meth_meth_collectionsPrelude__apply2829->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2829->definitionLine = 0;
// compiled block node returning block2828 (depth = 3)
  gc_frame_newslot(block2828);
  params[0] = block2794;
  params[1] = block2828;
  Object matchres2793 = matchCase(*var_other, params, 2,NULL);
  gc_frame_end(frame2793);
// compiled matchcase node returning matchres2793 (depth = 2)
  gc_frame_end(frame);
  return matchres2793;
}
Object meth_collectionsPrelude_copy2832(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "copy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for copy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for copy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1341
  setline(1341);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2833 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2834 = gc_frame_new();
// call case 3: self.outer request
  Object call2835 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2834);
// compiled call node returning call2835 (depth = 4)
// compiled member node returning call2835 (depth = 3)
  params[0] = self;
  partcv[0] = 1;
  Object call2836 = callmethodflags(call2835, "withAll", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2833);
// compiled call node returning call2836 (depth = 2)
  gc_frame_end(frame);
  return call2836;
}
Object meth_collectionsPrelude__43__43_2837(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "++");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method ++");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for ++ (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for ++");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1345
  setline(1345);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2838 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  gc_frame_newslot(*var_other);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2839 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2840 = callmethodflags(self, "copy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2839);
// compiled call node returning call2840 (depth = 4)
// compiled member node returning call2840 (depth = 3)
  params[0] = *var_other;
  partcv[0] = 1;
  Object call2841 = callmethod(call2840, "addAll",
    1, partcv, params);
  gc_frame_end(callframe2838);
// compiled call node returning call2841 (depth = 2)
  gc_frame_end(frame);
  return call2841;
}
Object meth_collectionsPrelude__apply2853(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_other = getfromclosure(closure, 0);
  Object *var_result = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1351
  setline(1351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2855 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 6)
  int callframe2856 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_v (depth = 7)
  gc_frame_newslot(*var_v);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  params[0] = *var_v;
  partcv[0] = 1;
  Object call2857 = callmethod(*var_other, "contains",
    1, partcv, params);
  gc_frame_end(callframe2856);
// compiled call node returning call2857 (depth = 6)
  partcv[0] = 0;
  Object call2858 = callmethod(call2857, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe2855);
// compiled call node returning call2858 (depth = 5)
  Object if2854 = done;
  if (istrue(call2858)) {
// Begin line 1352
  setline(1352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2859 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  gc_frame_newslot(*var_v);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_result (depth = 6)
  params[0] = *var_v;
  partcv[0] = 1;
  Object call2860 = callmethod(*var_result, "add",
    1, partcv, params);
  gc_frame_end(callframe2859);
// compiled call node returning call2860 (depth = 5)
    gc_frame_newslot(call2860);
    if2854 = call2860;
  } else {
  }
// compiled if node returning if2854 (depth = 4)
  gc_frame_end(frame);
  return if2854;
}
Object meth_collectionsPrelude__45__45_2842(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "--");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method --");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for -- (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for --");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "result");
// Begin line 1349
  setline(1349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2843 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2844 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2845 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2846 = gc_frame_new();
// call case 3: self.outer request
  Object call2847 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2846);
// compiled call node returning call2847 (depth = 10)
// compiled member node returning call2847 (depth = 9)
  partcv[0] = 0;
  Object call2848 = callmethodflags(call2847, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2845);
// compiled call node returning call2848 (depth = 8)
// compiled member node returning call2848 (depth = 7)
  partcv[0] = 0;
  Object call2849 = callmethodflags(call2848, "set", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2844);
// compiled call node returning call2849 (depth = 6)
// compiled member node returning call2849 (depth = 5)
  partcv[0] = 0;
  Object call2850 = callmethod(call2849, "empty",
    1, partcv, params);
  gc_frame_end(callframe2843);
// compiled call node returning call2850 (depth = 4)
// compiled member node returning call2850 (depth = 3)
  *var_result = call2850;
  if (call2850 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1350
  setline(1350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2851 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// starting to compile block node (depth = 3)
  Object block2852 = alloc_Block(NULL, NULL, "collectionsPrelude", 1350);
  gc_frame_newslot(block2852);
// method _apply
  block_savedest(block2852);
  Object closure2853 = createclosure(3, "_apply");
  setclosureframe(closure2853, stackframe);
  addtoclosure(closure2853, var_other);
  addtoclosure(closure2853, var_result);
  addtoclosure(closure2853, selfslot);
  struct UserObject *uo2853 = (struct UserObject*)block2852;
  uo2853->data[0] = (Object)closure2853;
  Method *meth_meth_collectionsPrelude__apply2853 = addmethod2pos(block2852, "_apply", &meth_collectionsPrelude__apply2853, 0);
  int argcv_meth_collectionsPrelude__apply2853[] = {1};
  meth_meth_collectionsPrelude__apply2853->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2853);
  meth_meth_collectionsPrelude__apply2853->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2853->definitionLine = 1349;
// compiled block node returning block2852 (depth = 3)
  gc_frame_newslot(block2852);
// call case 5: prelude request
  params[0] = self;
  params[1] = block2852;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2862 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2851);
// compiled call node returning call2862 (depth = 2)
// Begin line 1355
  setline(1355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_result (depth = 2)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_collectionsPrelude__apply2867(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_other = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 6)
  int callframe2868 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  gc_frame_newslot(*var_each);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call2869 = callmethod(*var_other, "contains",
    1, partcv, params);
  gc_frame_end(callframe2868);
// compiled call node returning call2869 (depth = 6)
  gc_frame_end(frame);
  return call2869;
}
Object meth_collectionsPrelude__42__42_2863(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "**");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method **");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for ** (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for **");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1359
  setline(1359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2864 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe2865 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block2866 = alloc_Block(NULL, NULL, "collectionsPrelude", 1359);
  gc_frame_newslot(block2866);
// method _apply
  block_savedest(block2866);
  Object closure2867 = createclosure(2, "_apply");
  setclosureframe(closure2867, stackframe);
  addtoclosure(closure2867, var_other);
  addtoclosure(closure2867, selfslot);
  struct UserObject *uo2867 = (struct UserObject*)block2866;
  uo2867->data[0] = (Object)closure2867;
  Method *meth_meth_collectionsPrelude__apply2867 = addmethod2pos(block2866, "_apply", &meth_collectionsPrelude__apply2867, 0);
  int argcv_meth_collectionsPrelude__apply2867[] = {1};
  meth_meth_collectionsPrelude__apply2867->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2867);
  meth_meth_collectionsPrelude__apply2867->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2867->definitionLine = 1359;
// compiled block node returning block2866 (depth = 5)
  gc_frame_newslot(block2866);
// call case 4: self request
  params[0] = block2866;
  partcv[0] = 1;
  Object call2871 = callmethodflags(self, "filter", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2865);
// compiled call node returning call2871 (depth = 4)
  partcv[0] = 0;
  Object call2872 = callmethod(call2871, "asSet",
    1, partcv, params);
  gc_frame_end(callframe2864);
// compiled call node returning call2872 (depth = 3)
// compiled member node returning call2872 (depth = 2)
  gc_frame_end(frame);
  return call2872;
}
Object meth_collectionsPrelude_onto2873(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "onto");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method onto");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for onto (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_f = &(stackframe->slots[0]);
  *var_f = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for onto");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1362
  setline(1362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2874 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_f (depth = 3)
  params[0] = self;
  partcv[0] = 1;
  Object call2875 = callmethod(*var_f, "withAll",
    1, partcv, params);
  gc_frame_end(callframe2874);
// compiled call node returning call2875 (depth = 2)
  gc_frame_end(frame);
  return call2875;
}
Object meth_collectionsPrelude__apply2879(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_existing = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe2880 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_each (depth = 5)
  gc_frame_newslot(*var_each);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_existing (depth = 5)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call2881 = callmethod(*var_existing, "add",
    1, partcv, params);
  gc_frame_end(callframe2880);
// compiled call node returning call2881 (depth = 4)
  gc_frame_end(frame);
  return call2881;
}
Object meth_collectionsPrelude_into2876(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "into");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method into");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for into (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_existing = &(stackframe->slots[0]);
  *var_existing = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for into");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1365
  setline(1365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2877 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2878 = alloc_Block(NULL, NULL, "collectionsPrelude", 1365);
  gc_frame_newslot(block2878);
// method _apply
  block_savedest(block2878);
  Object closure2879 = createclosure(2, "_apply");
  setclosureframe(closure2879, stackframe);
  addtoclosure(closure2879, var_existing);
  addtoclosure(closure2879, selfslot);
  struct UserObject *uo2879 = (struct UserObject*)block2878;
  uo2879->data[0] = (Object)closure2879;
  Method *meth_meth_collectionsPrelude__apply2879 = addmethod2pos(block2878, "_apply", &meth_collectionsPrelude__apply2879, 0);
  int argcv_meth_collectionsPrelude__apply2879[] = {1};
  meth_meth_collectionsPrelude__apply2879->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2879);
  meth_meth_collectionsPrelude__apply2879->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2879->definitionLine = 1359;
// compiled block node returning block2878 (depth = 3)
  gc_frame_newslot(block2878);
// call case 4: self request
  params[0] = block2878;
  partcv[0] = 1;
  Object call2883 = callmethodflags(self, "do", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2877);
// compiled call node returning call2883 (depth = 2)
// Begin line 1366
  setline(1366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_existing (depth = 2)
  gc_frame_end(frame);
  return *var_existing;
}
Object meth_collectionsPrelude__apply2889(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_a = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 4)
// Begin line 1359
  setline(1359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2890 = gc_frame_new();
// Begin line 1131
  setline(1131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2891 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2893 = alloc_Float64(1);
// compiled num node returning num2893 (depth = 8)
  int op_slot_right_2892 = gc_frame_newslot(num2893);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2896 = alloc_Float64(3);
// compiled num node returning num2896 (depth = 9)
  int op_slot_right_2895 = gc_frame_newslot(num2896);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2898 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_a (depth = 11)
  partcv[0] = 0;
  Object call2899 = callmethod(*var_a, "size",
    1, partcv, params);
  gc_frame_end(callframe2898);
// compiled call node returning call2899 (depth = 10)
// compiled member node returning call2899 (depth = 9)
  int op_slot_left_2895 = gc_frame_newslot(call2899);
  params[0] = num2896;
  partcv[0] = 1;
  Object prod2900 = callmethod(call2899, "*", 1, partcv, params);
// compiled op node returning prod2900 (depth = 8)
  int op_slot_left_2892 = gc_frame_newslot(prod2900);
  params[0] = num2893;
  partcv[0] = 1;
  Object sum2901 = callmethod(prod2900, "+", 1, partcv, params);
// compiled op node returning sum2901 (depth = 7)
  gc_frame_newslot(sum2901);
// starting to compile num node (depth = 7)
  Object num2902 = alloc_Float64(8);
// compiled num node returning num2902 (depth = 7)
  gc_frame_newslot(num2902);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2903 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2904 = gc_frame_new();
// call case 3: self.outer request
  Object call2905 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2904);
// compiled call node returning call2905 (depth = 10)
// compiled member node returning call2905 (depth = 9)
  partcv[0] = 0;
  Object call2906 = callmethodflags(call2905, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2903);
// compiled call node returning call2906 (depth = 8)
// compiled member node returning call2906 (depth = 7)
  params[0] = sum2901;
  params[1] = num2902;
  partcv[0] = 2;
  Object call2907 = callmethodflags(call2906, "max", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2891);
// compiled call node returning call2907 (depth = 6)
  gc_frame_newslot(call2907);
// call case 4: self request
  params[0] = call2907;
  partcv[0] = 1;
  Object call2908 = callmethodflags(self, "initialSize:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2890);
// compiled call node returning call2908 (depth = 5)
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude__apply2911(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___17 = &(stackframe->slots[0]);
  *var___17 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 4)
// Begin line 1131
  setline(1131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2912 = gc_frame_new();
// Begin line 1132
  setline(1132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num2913 = alloc_Float64(8);
// compiled num node returning num2913 (depth = 6)
  gc_frame_newslot(num2913);
// call case 4: self request
  params[0] = num2913;
  partcv[0] = 1;
  Object call2914 = callmethodflags(self, "initialSize:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2912);
// compiled call node returning call2914 (depth = 5)
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_asString2934(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1136
  setline(1136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit2935 == NULL) {
    strlit2935 = alloc_String("unused");
    gc_root(strlit2935);
  }
// compiled string node returning strlit2935 (depth = 2)
  gc_frame_end(frame);
  return strlit2935;
}
Object meth_collectionsPrelude_asString2940(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1140
  setline(1140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit2941 == NULL) {
    strlit2941 = alloc_String("removed");
    gc_root(strlit2941);
  }
// compiled string node returning strlit2941 (depth = 2)
  gc_frame_end(frame);
  return strlit2941;
}
Object meth_collectionsPrelude__apply2956(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1144
  setline(1144);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2957 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  gc_frame_newslot(*var_i);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2958 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2959 = callmethodflags(self, "unused", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2958);
// compiled call node returning call2959 (depth = 6)
// compiled member node returning call2959 (depth = 5)
  gc_frame_newslot(call2959);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2960 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2961 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2960);
// compiled call node returning call2961 (depth = 6)
// compiled member node returning call2961 (depth = 5)
  params[0] = *var_i;
  params[1] = call2959;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2962 = callmethod(call2961, "at()put",
    2, partcv, params);
  gc_frame_end(callframe2957);
// compiled call node returning call2962 (depth = 4)
  gc_frame_end(frame);
  return call2962;
}
Object meth_collectionsPrelude__apply2967(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe2968 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_x (depth = 5)
  gc_frame_newslot(*var_x);
// call case 4: self request
  params[0] = *var_x;
  partcv[0] = 1;
  Object call2969 = callmethodflags(self, "add", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2968);
// compiled call node returning call2969 (depth = 4)
  gc_frame_end(frame);
  return call2969;
}
Object meth_collectionsPrelude_withAll2209(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "withAll");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method withAll");
  Object params[2];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  Object *var_ConcurrentModification = getfromclosure(closure, 1);
  Object *var_Exhausted = getfromclosure(closure, 2);
  Object *var__prelude = getfromclosure(closure, 3);
  Object *var_Collection = getfromclosure(closure, 4);
  Object *var_collection = getfromclosure(closure, 5);
  Object *var_SizeUnknown = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for withAll (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for withAll");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2210 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2210 = alloc_userobj2(38,35, objclass2210);
  gc_frame_newslot(obj2210);
if (objclass2210 == NULL) {
  glfree(obj2210->class->name);
  obj2210->class->name = "obj2207.withAll";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2210, self, 0);
  addmethodreal(obj2210,"outer", &reader_collectionsPrelude_outer_2211);
  Object oldself2210 = self;
  struct StackFrameObject *oldstackframe2210 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2210);
  gc_frame_newslot((Object)stackframe);
  self = obj2210;
  Object *oldselfslot2210 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2210 = (*(struct UserObject *)self).data[0], lowerouter2210 = thisouter2210;
  if (inheritingObject2210) {
    struct UserObject *inho2210 = (struct UserObject *)inheritingObject2210;
    while (inho2210->super != GraceDefaultObject) inho2210 = (struct UserObject *)inho2210->super;
    inho2210->super = obj2210;
    self = inheritingObject2210;
    *selfslot = self;
    lowerouter2210 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2210;
  }
if (objclass2210 == NULL) {
  Method *reader2212 = addmethodrealflags(obj2210, "mods",&reader_collectionsPrelude_mods_2212, 0);
  Method *writer2212 = addmethodrealflags(obj2210, "mods:=",&writer_collectionsPrelude_mods_2212, MFLAG_CONFIDENTIAL);
  reader2212->definitionModule = modulename;
  writer2212->definitionModule = modulename;
  reader2212->definitionLine = 1129;
  writer2212->definitionLine = 1129;
}
obj2210->flags |= OFLAG_MUTABLE;
adddatum2(obj2210, alloc_Undefined(), 1);
if (objclass2210 == NULL) {
  Method *reader2213 = addmethodrealflags(obj2210, "initialSize",&reader_collectionsPrelude_initialSize_2213, MFLAG_CONFIDENTIAL);
  Method *writer2213 = addmethodrealflags(obj2210, "initialSize:=",&writer_collectionsPrelude_initialSize_2213, MFLAG_CONFIDENTIAL);
  reader2213->definitionModule = modulename;
  writer2213->definitionModule = modulename;
  reader2213->definitionLine = 1130;
  writer2213->definitionLine = 1130;
}
obj2210->flags |= OFLAG_MUTABLE;
adddatum2(obj2210, alloc_Undefined(), 2);
if (objclass2210 == NULL) {
  Method *reader2214 = addmethodrealflags(obj2210, "inner",&reader_collectionsPrelude_inner_2214, MFLAG_CONFIDENTIAL);
  Method *writer2214 = addmethodrealflags(obj2210, "inner:=",&writer_collectionsPrelude_inner_2214, MFLAG_CONFIDENTIAL);
  reader2214->definitionModule = modulename;
  writer2214->definitionModule = modulename;
  reader2214->definitionLine = 1133;
  writer2214->definitionLine = 1133;
}
obj2210->flags |= OFLAG_MUTABLE;
adddatum2(obj2210, alloc_Undefined(), 3);
if (objclass2210 == NULL) {
  Method *reader2215 = addmethodrealflags(obj2210, "unused",&reader_collectionsPrelude_unused_2215, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader2215->definitionModule = modulename;
  reader2215->definitionLine = 1134;
}
adddatum2(obj2210, alloc_Undefined(), 4);
if (objclass2210 == NULL) {
  Method *reader2216 = addmethodrealflags(obj2210, "removed",&reader_collectionsPrelude_removed_2216, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader2216->definitionModule = modulename;
  reader2216->definitionLine = 1138;
}
adddatum2(obj2210, alloc_Undefined(), 5);
if (objclass2210 == NULL) {
  Method *reader2217 = addmethodrealflags(obj2210, "size",&reader_collectionsPrelude_size_2217, 0);
  Method *writer2217 = addmethodrealflags(obj2210, "size:=",&writer_collectionsPrelude_size_2217, MFLAG_CONFIDENTIAL);
  reader2217->definitionModule = modulename;
  writer2217->definitionModule = modulename;
  reader2217->definitionLine = 1142;
  writer2217->definitionLine = 1142;
}
obj2210->flags |= OFLAG_MUTABLE;
adddatum2(obj2210, alloc_Undefined(), 6);
// method addAll
  struct UserObject *uo2218 = (struct UserObject*)obj2210;
  uo2218->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addAll2218 = addmethod2pos(obj2210, "addAll", &meth_collectionsPrelude_addAll2218, 7);
  int argcv_meth_collectionsPrelude_addAll2218[] = {1};
  meth_meth_collectionsPrelude_addAll2218->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addAll2218);
  meth_meth_collectionsPrelude_addAll2218->definitionModule = modulename;
  meth_meth_collectionsPrelude_addAll2218->definitionLine = 1148;
// method add
  struct UserObject *uo2267 = (struct UserObject*)obj2210;
  uo2267->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_add2267 = addmethod2pos(obj2210, "add", &meth_collectionsPrelude_add2267, 8);
  int argcv_meth_collectionsPrelude_add2267[] = {0};
  meth_meth_collectionsPrelude_add2267->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_add2267);
  meth_meth_collectionsPrelude_add2267->definitionModule = modulename;
  meth_meth_collectionsPrelude_add2267->definitionLine = 1163;
// method removeAll
  block_savedest(obj2210);
  Object closure2270 = createclosure(1, "removeAll");
  setclosureframe(closure2270, stackframe);
  addtoclosure(closure2270, var_NoSuchObject);
  struct UserObject *uo2270 = (struct UserObject*)obj2210;
  uo2270->data[9] = (Object)closure2270;
  Method *meth_meth_collectionsPrelude_removeAll2270 = addmethod2pos(obj2210, "removeAll", &meth_collectionsPrelude_removeAll2270, 9);
  int argcv_meth_collectionsPrelude_removeAll2270[] = {1};
  meth_meth_collectionsPrelude_removeAll2270->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAll2270);
  meth_meth_collectionsPrelude_removeAll2270->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAll2270->definitionLine = 1165;
// method removeAll()ifAbsent
  struct UserObject *uo2291 = (struct UserObject*)obj2210;
  uo2291->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeAll_40__41_ifAbsent2291 = addmethod2pos(obj2210, "removeAll()ifAbsent", &meth_collectionsPrelude_removeAll_40__41_ifAbsent2291, 10);
  int argcv_meth_collectionsPrelude_removeAll_40__41_ifAbsent2291[] = {1, 1};
  meth_meth_collectionsPrelude_removeAll_40__41_ifAbsent2291->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_removeAll_40__41_ifAbsent2291);
  meth_meth_collectionsPrelude_removeAll_40__41_ifAbsent2291->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAll_40__41_ifAbsent2291->definitionLine = 1173;
// method remove()ifAbsent
  struct UserObject *uo2331 = (struct UserObject*)obj2210;
  uo2331->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_remove_40__41_ifAbsent2331 = addmethod2pos(obj2210, "remove()ifAbsent", &meth_collectionsPrelude_remove_40__41_ifAbsent2331, 11);
  int argcv_meth_collectionsPrelude_remove_40__41_ifAbsent2331[] = {0, 1};
  meth_meth_collectionsPrelude_remove_40__41_ifAbsent2331->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_remove_40__41_ifAbsent2331);
  meth_meth_collectionsPrelude_remove_40__41_ifAbsent2331->definitionModule = modulename;
  meth_meth_collectionsPrelude_remove_40__41_ifAbsent2331->definitionLine = 1187;
// method remove
  struct UserObject *uo2334 = (struct UserObject*)obj2210;
  uo2334->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_remove2334 = addmethod2pos(obj2210, "remove", &meth_collectionsPrelude_remove2334, 12);
  int argcv_meth_collectionsPrelude_remove2334[] = {0};
  meth_meth_collectionsPrelude_remove2334->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_remove2334);
  meth_meth_collectionsPrelude_remove2334->definitionModule = modulename;
  meth_meth_collectionsPrelude_remove2334->definitionLine = 1191;
// method contains
  struct UserObject *uo2337 = (struct UserObject*)obj2210;
  uo2337->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_contains2337 = addmethod2pos(obj2210, "contains", &meth_collectionsPrelude_contains2337, 13);
  int argcv_meth_collectionsPrelude_contains2337[] = {1};
  meth_meth_collectionsPrelude_contains2337->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains2337);
  meth_meth_collectionsPrelude_contains2337->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains2337->definitionLine = 1195;
// method includes
  struct UserObject *uo2350 = (struct UserObject*)obj2210;
  uo2350->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_includes2350 = addmethod2pos(obj2210, "includes", &meth_collectionsPrelude_includes2350, 14);
  int argcv_meth_collectionsPrelude_includes2350[] = {1};
  meth_meth_collectionsPrelude_includes2350->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_includes2350);
  meth_meth_collectionsPrelude_includes2350->definitionModule = modulename;
  meth_meth_collectionsPrelude_includes2350->definitionLine = 1202;
// method find()ifNone
  struct UserObject *uo2361 = (struct UserObject*)obj2210;
  uo2361->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_find_40__41_ifNone2361 = addmethod2pos(obj2210, "find()ifNone", &meth_collectionsPrelude_find_40__41_ifNone2361, 15);
  int argcv_meth_collectionsPrelude_find_40__41_ifNone2361[] = {1, 1};
  meth_meth_collectionsPrelude_find_40__41_ifNone2361->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_find_40__41_ifNone2361);
  meth_meth_collectionsPrelude_find_40__41_ifNone2361->definitionModule = modulename;
  meth_meth_collectionsPrelude_find_40__41_ifNone2361->definitionLine = 1208;
// method findPosition
  struct UserObject *uo2372 = (struct UserObject*)obj2210;
  uo2372->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_findPosition2372 = addmethod2pos(obj2210, "findPosition", &meth_collectionsPrelude_findPosition2372, 16);
  int argcv_meth_collectionsPrelude_findPosition2372[] = {1};
  meth_meth_collectionsPrelude_findPosition2372->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_findPosition2372);
  meth_meth_collectionsPrelude_findPosition2372->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_findPosition2372->definitionModule = modulename;
  meth_meth_collectionsPrelude_findPosition2372->definitionLine = 1214;
// method findPositionForAdd
  struct UserObject *uo2435 = (struct UserObject*)obj2210;
  uo2435->data[17] = emptyclosure;
  Method *meth_meth_collectionsPrelude_findPositionForAdd2435 = addmethod2pos(obj2210, "findPositionForAdd", &meth_collectionsPrelude_findPositionForAdd2435, 17);
  int argcv_meth_collectionsPrelude_findPositionForAdd2435[] = {1};
  meth_meth_collectionsPrelude_findPositionForAdd2435->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_findPositionForAdd2435);
  meth_meth_collectionsPrelude_findPositionForAdd2435->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_findPositionForAdd2435->definitionModule = modulename;
  meth_meth_collectionsPrelude_findPositionForAdd2435->definitionLine = 1236;
// method asString
  struct UserObject *uo2508 = (struct UserObject*)obj2210;
  uo2508->data[18] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString2508 = addmethod2pos(obj2210, "asString", &meth_collectionsPrelude_asString2508, 18);
  int argcv_meth_collectionsPrelude_asString2508[] = {0};
  meth_meth_collectionsPrelude_asString2508->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString2508);
  meth_meth_collectionsPrelude_asString2508->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString2508->definitionLine = 1259;
// method extend
  struct UserObject *uo2533 = (struct UserObject*)obj2210;
  uo2533->data[19] = emptyclosure;
  Method *meth_meth_collectionsPrelude_extend2533 = addmethod2pos(obj2210, "extend", &meth_collectionsPrelude_extend2533, 19);
  int argcv_meth_collectionsPrelude_extend2533[] = {1};
  meth_meth_collectionsPrelude_extend2533->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_extend2533);
  meth_meth_collectionsPrelude_extend2533->definitionModule = modulename;
  meth_meth_collectionsPrelude_extend2533->definitionLine = 1265;
// method do
  struct UserObject *uo2541 = (struct UserObject*)obj2210;
  uo2541->data[20] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do2541 = addmethod2pos(obj2210, "do", &meth_collectionsPrelude_do2541, 20);
  int argcv_meth_collectionsPrelude_do2541[] = {1};
  meth_meth_collectionsPrelude_do2541->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do2541);
  meth_meth_collectionsPrelude_do2541->definitionModule = modulename;
  meth_meth_collectionsPrelude_do2541->definitionLine = 1270;
// method iterator
  block_savedest(obj2210);
  Object closure2590 = createclosure(2, "iterator");
  setclosureframe(closure2590, stackframe);
  addtoclosure(closure2590, var_ConcurrentModification);
  addtoclosure(closure2590, var_Exhausted);
  struct UserObject *uo2590 = (struct UserObject*)obj2210;
  uo2590->data[21] = (Object)closure2590;
  Method *meth_meth_collectionsPrelude_iterator2590 = addmethod2pos(obj2210, "iterator", &meth_collectionsPrelude_iterator2590, 21);
  int argcv_meth_collectionsPrelude_iterator2590[] = {0};
  meth_meth_collectionsPrelude_iterator2590->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator2590);
  meth_meth_collectionsPrelude_iterator2590->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator2590->definitionLine = 1283;
  block_savedest(obj2210);
  Object closure2709 = createclosure(2, "iterator()object");
  setclosureframe(closure2709, stackframe);
  addtoclosure(closure2709, var_ConcurrentModification);
  addtoclosure(closure2709, var_Exhausted);
  Method *meth_meth_collectionsPrelude_iterator2590_object = addmethod2pos(obj2210, "iterator()object", &meth_collectionsPrelude_iterator2590_object, 21);
  meth_meth_collectionsPrelude_iterator2590_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator2590_object->definitionLine = 1283;
// method expand
  block_savedest(obj2210);
  Object closure2710 = createclosure(1, "expand");
  setclosureframe(closure2710, stackframe);
  addtoclosure(closure2710, var__prelude);
  struct UserObject *uo2710 = (struct UserObject*)obj2210;
  uo2710->data[22] = (Object)closure2710;
  Method *meth_meth_collectionsPrelude_expand2710 = addmethod2pos(obj2210, "expand", &meth_collectionsPrelude_expand2710, 22);
  int argcv_meth_collectionsPrelude_expand2710[] = {0};
  meth_meth_collectionsPrelude_expand2710->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_expand2710);
  meth_meth_collectionsPrelude_expand2710->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_expand2710->definitionModule = modulename;
  meth_meth_collectionsPrelude_expand2710->definitionLine = 1309;
// method ==
  block_savedest(obj2210);
  Object closure2792 = createclosure(1, "==");
  setclosureframe(closure2792, stackframe);
  addtoclosure(closure2792, var_Collection);
  struct UserObject *uo2792 = (struct UserObject*)obj2210;
  uo2792->data[23] = (Object)closure2792;
  Method *meth_meth_collectionsPrelude__61__61_2792 = addmethod2pos(obj2210, "==", &meth_collectionsPrelude__61__61_2792, 23);
  int argcv_meth_collectionsPrelude__61__61_2792[] = {1};
  meth_meth_collectionsPrelude__61__61_2792->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61_2792);
  meth_meth_collectionsPrelude__61__61_2792->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61_2792->definitionLine = 1324;
// method copy
  struct UserObject *uo2832 = (struct UserObject*)obj2210;
  uo2832->data[24] = emptyclosure;
  Method *meth_meth_collectionsPrelude_copy2832 = addmethod2pos(obj2210, "copy", &meth_collectionsPrelude_copy2832, 24);
  int argcv_meth_collectionsPrelude_copy2832[] = {0};
  meth_meth_collectionsPrelude_copy2832->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_copy2832);
  meth_meth_collectionsPrelude_copy2832->definitionModule = modulename;
  meth_meth_collectionsPrelude_copy2832->definitionLine = 1340;
// method ++
  struct UserObject *uo2837 = (struct UserObject*)obj2210;
  uo2837->data[25] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43_2837 = addmethod2pos(obj2210, "++", &meth_collectionsPrelude__43__43_2837, 25);
  int argcv_meth_collectionsPrelude__43__43_2837[] = {1};
  meth_meth_collectionsPrelude__43__43_2837->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43_2837);
  meth_meth_collectionsPrelude__43__43_2837->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43_2837->definitionLine = 1343;
// method --
  struct UserObject *uo2842 = (struct UserObject*)obj2210;
  uo2842->data[26] = emptyclosure;
  Method *meth_meth_collectionsPrelude__45__45_2842 = addmethod2pos(obj2210, "--", &meth_collectionsPrelude__45__45_2842, 26);
  int argcv_meth_collectionsPrelude__45__45_2842[] = {1};
  meth_meth_collectionsPrelude__45__45_2842->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__45__45_2842);
  meth_meth_collectionsPrelude__45__45_2842->definitionModule = modulename;
  meth_meth_collectionsPrelude__45__45_2842->definitionLine = 1347;
// method **
  struct UserObject *uo2863 = (struct UserObject*)obj2210;
  uo2863->data[27] = emptyclosure;
  Method *meth_meth_collectionsPrelude__42__42_2863 = addmethod2pos(obj2210, "**", &meth_collectionsPrelude__42__42_2863, 27);
  int argcv_meth_collectionsPrelude__42__42_2863[] = {1};
  meth_meth_collectionsPrelude__42__42_2863->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__42__42_2863);
  meth_meth_collectionsPrelude__42__42_2863->definitionModule = modulename;
  meth_meth_collectionsPrelude__42__42_2863->definitionLine = 1357;
// method onto
  struct UserObject *uo2873 = (struct UserObject*)obj2210;
  uo2873->data[28] = emptyclosure;
  Method *meth_meth_collectionsPrelude_onto2873 = addmethod2pos(obj2210, "onto", &meth_collectionsPrelude_onto2873, 28);
  int argcv_meth_collectionsPrelude_onto2873[] = {1};
  meth_meth_collectionsPrelude_onto2873->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_onto2873);
  meth_meth_collectionsPrelude_onto2873->definitionModule = modulename;
  meth_meth_collectionsPrelude_onto2873->definitionLine = 1361;
// method into
  struct UserObject *uo2876 = (struct UserObject*)obj2210;
  uo2876->data[29] = emptyclosure;
  Method *meth_meth_collectionsPrelude_into2876 = addmethod2pos(obj2210, "into", &meth_collectionsPrelude_into2876, 29);
  int argcv_meth_collectionsPrelude_into2876[] = {1};
  meth_meth_collectionsPrelude_into2876->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_into2876);
  meth_meth_collectionsPrelude_into2876->definitionModule = modulename;
  meth_meth_collectionsPrelude_into2876->definitionLine = 1364;
  sourceObject = obj2210;
// Begin line 1128
  setline(1128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2884 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_collection (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2885 = callmethod(*var_collection, "trait()object",
    2, partcv, params);
  gc_frame_end(callframe2884);
// compiled call node returning call2885 (depth = 2)
  struct UserObject *obj2210_uo = (struct UserObject *)obj2210;
  obj2210_uo->super = call2885;
  sourceObject = obj2210;
// Begin line 1129
  setline(1129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2886 = alloc_Float64(0);
// compiled num node returning num2886 (depth = 2)
  adddatum2(obj2210, num2886, 1);
  sourceObject = obj2210;
  adddatum2(obj2210, undefined, 2);
  sourceObject = obj2210;
// Begin line 1131
  setline(1131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile catchcase node (depth = 2)
// starting to compile block node (depth = 3)
  Object block2888 = alloc_Block(NULL, NULL, "collectionsPrelude", 1131);
  gc_frame_newslot(block2888);
// method _apply
  block_savedest(block2888);
  Object closure2889 = createclosure(2, "_apply");
  setclosureframe(closure2889, stackframe);
  addtoclosure(closure2889, var_a);
  addtoclosure(closure2889, selfslot);
  struct UserObject *uo2889 = (struct UserObject*)block2888;
  uo2889->data[0] = (Object)closure2889;
  Method *meth_meth_collectionsPrelude__apply2889 = addmethod2pos(block2888, "_apply", &meth_collectionsPrelude__apply2889, 0);
  int argcv_meth_collectionsPrelude__apply2889[] = {0};
  meth_meth_collectionsPrelude__apply2889->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2889);
  meth_meth_collectionsPrelude__apply2889->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2889->definitionLine = 1359;
// compiled block node returning block2888 (depth = 3)
  int frame2887 = gc_frame_new();
  gc_frame_newslot(block2888);
// Begin line 1132
  setline(1132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block2910 = alloc_Block(NULL, NULL, "collectionsPrelude", 1132);
  gc_frame_newslot(block2910);
// method _apply
  block_savedest(block2910);
  Object closure2911 = createclosure(1, "_apply");
  setclosureframe(closure2911, stackframe);
  addtoclosure(closure2911, selfslot);
  struct UserObject *uo2911 = (struct UserObject*)block2910;
  uo2911->data[0] = (Object)closure2911;
  Method *meth_meth_collectionsPrelude__apply2911 = addmethod2pos(block2910, "_apply", &meth_collectionsPrelude__apply2911, 0);
  int argcv_meth_collectionsPrelude__apply2911[] = {1};
  meth_meth_collectionsPrelude__apply2911->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2911);
  meth_meth_collectionsPrelude__apply2911->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2911->definitionLine = 1131;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2916 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe2917 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit2918 == NULL) {
    strlit2918 = alloc_String("__17");
    gc_root(strlit2918);
  }
// compiled string node returning strlit2918 (depth = 6)
  gc_frame_newslot(strlit2918);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2919 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call2920 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2919);
// compiled call node returning call2920 (depth = 7)
// compiled member node returning call2920 (depth = 6)
  params[0] = strlit2918;
  partcv[0] = 1;
  Object call2921 = callmethod(call2920, "new",
    1, partcv, params);
  gc_frame_end(callframe2917);
// compiled call node returning call2921 (depth = 5)
  gc_frame_newslot(call2921);
// Begin line 1132
  setline(1132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_SizeUnknown (depth = 5)
  gc_frame_newslot(*var_SizeUnknown);
// call case 6: other member request
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2922 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call2923 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2922);
// compiled call node returning call2923 (depth = 6)
// compiled member node returning call2923 (depth = 5)
  params[0] = call2921;
  params[1] = *var_SizeUnknown;
  partcv[0] = 2;
  Object call2924 = callmethod(call2923, "new",
    1, partcv, params);
  gc_frame_end(callframe2916);
// compiled call node returning call2924 (depth = 4)
((struct UserObject *)block2910)->data[1] = call2924;
// compiled block node returning block2910 (depth = 3)
  gc_frame_newslot(block2910);
  params[0] = block2910;
  setline(1131);
  Object catchres2887 = catchCase(block2888, params, 1,NULL);
  gc_frame_end(frame2887);
// compiled catchcase node returning catchres2887 (depth = 2)
  sourceObject = obj2210;
// Begin line 1133
  setline(1133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2925 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2926 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2927 = callmethodflags(self, "initialSize", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2926);
// compiled call node returning call2927 (depth = 4)
// compiled member node returning call2927 (depth = 3)
  gc_frame_newslot(call2927);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2928 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var__prelude (depth = 5)
  partcv[0] = 0;
  Object call2929 = callmethod(*var__prelude, "PrimitiveArray",
    1, partcv, params);
  gc_frame_end(callframe2928);
// compiled call node returning call2929 (depth = 4)
// compiled member node returning call2929 (depth = 3)
  params[0] = call2927;
  partcv[0] = 1;
  Object call2930 = callmethod(call2929, "new",
    1, partcv, params);
  gc_frame_end(callframe2925);
// compiled call node returning call2930 (depth = 2)
  adddatum2(obj2210, call2930, 3);
  sourceObject = obj2210;
  Object inheritingObject2931 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2931 = alloc_userobj2(3,4, objclass2931);
  gc_frame_newslot(obj2931);
// OBJECT OUTER DEC outer
  adddatum2(obj2931, obj2210, 0);
  addmethodreal(obj2931,"outer", &reader_collectionsPrelude_outer_2932);
  Object oldself2931 = self;
  struct StackFrameObject *oldstackframe2931 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2931);
  gc_frame_newslot((Object)stackframe);
  self = obj2931;
  Object *oldselfslot2931 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2931 = (*(struct UserObject *)self).data[0], lowerouter2931 = thisouter2931;
  if (inheritingObject2931) {
    struct UserObject *inho2931 = (struct UserObject *)inheritingObject2931;
    while (inho2931->super != GraceDefaultObject) inho2931 = (struct UserObject *)inho2931->super;
    inho2931->super = obj2931;
    self = inheritingObject2931;
    *selfslot = self;
    lowerouter2931 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2931;
  }
if (objclass2931 == NULL) {
  Method *reader2933 = addmethodrealflags(obj2931, "unused",&reader_collectionsPrelude_unused_2933, MFLAG_CONFIDENTIAL);
  Method *writer2933 = addmethodrealflags(obj2931, "unused:=",&writer_collectionsPrelude_unused_2933, MFLAG_CONFIDENTIAL);
  reader2933->definitionModule = modulename;
  writer2933->definitionModule = modulename;
  reader2933->definitionLine = 1135;
  writer2933->definitionLine = 1135;
}
obj2931->flags |= OFLAG_MUTABLE;
adddatum2(obj2931, alloc_Undefined(), 1);
// method asString
  struct UserObject *uo2934 = (struct UserObject*)obj2931;
  uo2934->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString2934 = addmethod2pos(obj2931, "asString", &meth_collectionsPrelude_asString2934, 2);
  int argcv_meth_collectionsPrelude_asString2934[] = {0};
  meth_meth_collectionsPrelude_asString2934->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString2934);
  meth_meth_collectionsPrelude_asString2934->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString2934->definitionLine = 1136;
  sourceObject = obj2931;
// Begin line 1135
  setline(1135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool2936 = alloc_Boolean(1);
// compiled identifier node returning bool2936 (depth = 2)
  adddatum2(obj2931, bool2936, 1);
  sourceObject = obj2931;
  objclass2931 = obj2931->class;
  objclass2931->definitionModule = modulename;
  objclass2931->definitionLine = 1134;
  (*(struct UserObject *)self).data[0] = lowerouter2931;
  self = oldself2931;
  selfslot = oldselfslot2931;
  stackframe = oldstackframe2931;
  adddatum2(obj2210, obj2931, 4);
  sourceObject = obj2210;
  Object inheritingObject2937 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2937 = alloc_userobj2(3,4, objclass2937);
  gc_frame_newslot(obj2937);
// OBJECT OUTER DEC outer
  adddatum2(obj2937, obj2210, 0);
  addmethodreal(obj2937,"outer", &reader_collectionsPrelude_outer_2938);
  Object oldself2937 = self;
  struct StackFrameObject *oldstackframe2937 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2937);
  gc_frame_newslot((Object)stackframe);
  self = obj2937;
  Object *oldselfslot2937 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2937 = (*(struct UserObject *)self).data[0], lowerouter2937 = thisouter2937;
  if (inheritingObject2937) {
    struct UserObject *inho2937 = (struct UserObject *)inheritingObject2937;
    while (inho2937->super != GraceDefaultObject) inho2937 = (struct UserObject *)inho2937->super;
    inho2937->super = obj2937;
    self = inheritingObject2937;
    *selfslot = self;
    lowerouter2937 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2937;
  }
if (objclass2937 == NULL) {
  Method *reader2939 = addmethodrealflags(obj2937, "removed",&reader_collectionsPrelude_removed_2939, MFLAG_CONFIDENTIAL);
  Method *writer2939 = addmethodrealflags(obj2937, "removed:=",&writer_collectionsPrelude_removed_2939, MFLAG_CONFIDENTIAL);
  reader2939->definitionModule = modulename;
  writer2939->definitionModule = modulename;
  reader2939->definitionLine = 1139;
  writer2939->definitionLine = 1139;
}
obj2937->flags |= OFLAG_MUTABLE;
adddatum2(obj2937, alloc_Undefined(), 1);
// method asString
  struct UserObject *uo2940 = (struct UserObject*)obj2937;
  uo2940->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString2940 = addmethod2pos(obj2937, "asString", &meth_collectionsPrelude_asString2940, 2);
  int argcv_meth_collectionsPrelude_asString2940[] = {0};
  meth_meth_collectionsPrelude_asString2940->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString2940);
  meth_meth_collectionsPrelude_asString2940->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString2940->definitionLine = 1140;
  sourceObject = obj2937;
// Begin line 1139
  setline(1139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool2942 = alloc_Boolean(1);
// compiled identifier node returning bool2942 (depth = 2)
  adddatum2(obj2937, bool2942, 1);
  sourceObject = obj2937;
  objclass2937 = obj2937->class;
  objclass2937->definitionModule = modulename;
  objclass2937->definitionLine = 1138;
  (*(struct UserObject *)self).data[0] = lowerouter2937;
  self = oldself2937;
  selfslot = oldselfslot2937;
  stackframe = oldstackframe2937;
  adddatum2(obj2210, obj2937, 5);
  sourceObject = obj2210;
// Begin line 1142
  setline(1142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2943 = alloc_Float64(0);
// compiled num node returning num2943 (depth = 2)
  adddatum2(obj2210, num2943, 6);
  sourceObject = obj2210;
// Begin line 1143
  setline(1143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2944 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2947 = alloc_Float64(1);
// compiled num node returning num2947 (depth = 5)
  int op_slot_right_2946 = gc_frame_newslot(num2947);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2949 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2950 = callmethodflags(self, "initialSize", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2949);
// compiled call node returning call2950 (depth = 6)
// compiled member node returning call2950 (depth = 5)
  int op_slot_left_2946 = gc_frame_newslot(call2950);
  params[0] = num2947;
  partcv[0] = 1;
  Object diff2951 = callmethod(call2950, "-", 1, partcv, params);
// compiled op node returning diff2951 (depth = 4)
  int op_slot_right_2945 = gc_frame_newslot(diff2951);
// starting to compile num node (depth = 4)
  Object num2953 = alloc_Float64(0);
// compiled num node returning num2953 (depth = 4)
  int op_slot_left_2945 = gc_frame_newslot(num2953);
  params[0] = diff2951;
  partcv[0] = 1;
  Object opresult2954 = callmethod(num2953, "..", 1, partcv, params);
// compiled op node returning opresult2954 (depth = 3)
  gc_frame_newslot(opresult2954);
// starting to compile block node (depth = 3)
  Object block2955 = alloc_Block(NULL, NULL, "collectionsPrelude", 1143);
  gc_frame_newslot(block2955);
// method _apply
  block_savedest(block2955);
  Object closure2956 = createclosure(1, "_apply");
  setclosureframe(closure2956, stackframe);
  addtoclosure(closure2956, selfslot);
  struct UserObject *uo2956 = (struct UserObject*)block2955;
  uo2956->data[0] = (Object)closure2956;
  Method *meth_meth_collectionsPrelude__apply2956 = addmethod2pos(block2955, "_apply", &meth_collectionsPrelude__apply2956, 0);
  int argcv_meth_collectionsPrelude__apply2956[] = {1};
  meth_meth_collectionsPrelude__apply2956->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2956);
  meth_meth_collectionsPrelude__apply2956->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2956->definitionLine = 1143;
// compiled block node returning block2955 (depth = 3)
  gc_frame_newslot(block2955);
// call case 5: prelude request
  params[0] = opresult2954;
  params[1] = block2955;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2964 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2944);
// compiled call node returning call2964 (depth = 2)
  sourceObject = obj2210;
// Begin line 1146
  setline(1146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2965 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_a (depth = 3)
  gc_frame_newslot(*var_a);
// starting to compile block node (depth = 3)
  Object block2966 = alloc_Block(NULL, NULL, "collectionsPrelude", 1146);
  gc_frame_newslot(block2966);
// method _apply
  block_savedest(block2966);
  Object closure2967 = createclosure(1, "_apply");
  setclosureframe(closure2967, stackframe);
  addtoclosure(closure2967, selfslot);
  struct UserObject *uo2967 = (struct UserObject*)block2966;
  uo2967->data[0] = (Object)closure2967;
  Method *meth_meth_collectionsPrelude__apply2967 = addmethod2pos(block2966, "_apply", &meth_collectionsPrelude__apply2967, 0);
  int argcv_meth_collectionsPrelude__apply2967[] = {1};
  meth_meth_collectionsPrelude__apply2967->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2967);
  meth_meth_collectionsPrelude__apply2967->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2967->definitionLine = 1144;
// compiled block node returning block2966 (depth = 3)
  gc_frame_newslot(block2966);
// call case 5: prelude request
  params[0] = *var_a;
  params[1] = block2966;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2971 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2965);
// compiled call node returning call2971 (depth = 2)
  sourceObject = obj2210;
  sourceObject = obj2210;
  sourceObject = obj2210;
  sourceObject = obj2210;
  sourceObject = obj2210;
  sourceObject = obj2210;
  sourceObject = obj2210;
  sourceObject = obj2210;
  sourceObject = obj2210;
  sourceObject = obj2210;
  sourceObject = obj2210;
  sourceObject = obj2210;
  sourceObject = obj2210;
  sourceObject = obj2210;
  sourceObject = obj2210;
  sourceObject = obj2210;
  sourceObject = obj2210;
  sourceObject = obj2210;
  sourceObject = obj2210;
  sourceObject = obj2210;
  sourceObject = obj2210;
  sourceObject = obj2210;
  sourceObject = obj2210;
  objclass2210 = obj2210->class;
  objclass2210->definitionModule = modulename;
  objclass2210->definitionLine = 1127;
  (*(struct UserObject *)self).data[0] = lowerouter2210;
  self = oldself2210;
  selfslot = oldselfslot2210;
  stackframe = oldstackframe2210;
  gc_frame_end(frame);
  return obj2210;
}
Object meth_collectionsPrelude_withAll2209_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "withAll()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method withAll()object");
  Object params[2];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  Object *var_ConcurrentModification = getfromclosure(closure, 1);
  Object *var_Exhausted = getfromclosure(closure, 2);
  Object *var__prelude = getfromclosure(closure, 3);
  Object *var_Collection = getfromclosure(closure, 4);
  Object *var_collection = getfromclosure(closure, 5);
  Object *var_SizeUnknown = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for withAll (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for withAll");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2210 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2210 = alloc_userobj2(38,35, objclass2210);
  gc_frame_newslot(obj2210);
if (objclass2210 == NULL) {
  glfree(obj2210->class->name);
  obj2210->class->name = "obj2207.withAll";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2210, self, 0);
  addmethodreal(obj2210,"outer", &reader_collectionsPrelude_outer_2211);
  Object oldself2210 = self;
  struct StackFrameObject *oldstackframe2210 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2210);
  gc_frame_newslot((Object)stackframe);
  self = obj2210;
  Object *oldselfslot2210 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2210 = (*(struct UserObject *)self).data[0], lowerouter2210 = thisouter2210;
  if (inheritingObject2210) {
    struct UserObject *inho2210 = (struct UserObject *)inheritingObject2210;
    while (inho2210->super != GraceDefaultObject) inho2210 = (struct UserObject *)inho2210->super;
    inho2210->super = obj2210;
    self = inheritingObject2210;
    *selfslot = self;
    lowerouter2210 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2210;
  }
if (objclass2210 == NULL) {
  Method *reader2212 = addmethodrealflags(obj2210, "mods",&reader_collectionsPrelude_mods_2212, 0);
  Method *writer2212 = addmethodrealflags(obj2210, "mods:=",&writer_collectionsPrelude_mods_2212, MFLAG_CONFIDENTIAL);
  reader2212->definitionModule = modulename;
  writer2212->definitionModule = modulename;
  reader2212->definitionLine = 1129;
  writer2212->definitionLine = 1129;
}
obj2210->flags |= OFLAG_MUTABLE;
adddatum2(obj2210, alloc_Undefined(), 1);
if (objclass2210 == NULL) {
  Method *reader2213 = addmethodrealflags(obj2210, "initialSize",&reader_collectionsPrelude_initialSize_2213, MFLAG_CONFIDENTIAL);
  Method *writer2213 = addmethodrealflags(obj2210, "initialSize:=",&writer_collectionsPrelude_initialSize_2213, MFLAG_CONFIDENTIAL);
  reader2213->definitionModule = modulename;
  writer2213->definitionModule = modulename;
  reader2213->definitionLine = 1130;
  writer2213->definitionLine = 1130;
}
obj2210->flags |= OFLAG_MUTABLE;
adddatum2(obj2210, alloc_Undefined(), 2);
if (objclass2210 == NULL) {
  Method *reader2214 = addmethodrealflags(obj2210, "inner",&reader_collectionsPrelude_inner_2214, MFLAG_CONFIDENTIAL);
  Method *writer2214 = addmethodrealflags(obj2210, "inner:=",&writer_collectionsPrelude_inner_2214, MFLAG_CONFIDENTIAL);
  reader2214->definitionModule = modulename;
  writer2214->definitionModule = modulename;
  reader2214->definitionLine = 1133;
  writer2214->definitionLine = 1133;
}
obj2210->flags |= OFLAG_MUTABLE;
adddatum2(obj2210, alloc_Undefined(), 3);
if (objclass2210 == NULL) {
  Method *reader2215 = addmethodrealflags(obj2210, "unused",&reader_collectionsPrelude_unused_2215, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader2215->definitionModule = modulename;
  reader2215->definitionLine = 1134;
}
adddatum2(obj2210, alloc_Undefined(), 4);
if (objclass2210 == NULL) {
  Method *reader2216 = addmethodrealflags(obj2210, "removed",&reader_collectionsPrelude_removed_2216, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader2216->definitionModule = modulename;
  reader2216->definitionLine = 1138;
}
adddatum2(obj2210, alloc_Undefined(), 5);
if (objclass2210 == NULL) {
  Method *reader2217 = addmethodrealflags(obj2210, "size",&reader_collectionsPrelude_size_2217, 0);
  Method *writer2217 = addmethodrealflags(obj2210, "size:=",&writer_collectionsPrelude_size_2217, MFLAG_CONFIDENTIAL);
  reader2217->definitionModule = modulename;
  writer2217->definitionModule = modulename;
  reader2217->definitionLine = 1142;
  writer2217->definitionLine = 1142;
}
obj2210->flags |= OFLAG_MUTABLE;
adddatum2(obj2210, alloc_Undefined(), 6);
// method addAll
  struct UserObject *uo2218 = (struct UserObject*)obj2210;
  uo2218->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addAll2218 = addmethod2pos(obj2210, "addAll", &meth_collectionsPrelude_addAll2218, 7);
  int argcv_meth_collectionsPrelude_addAll2218[] = {1};
  meth_meth_collectionsPrelude_addAll2218->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addAll2218);
  meth_meth_collectionsPrelude_addAll2218->definitionModule = modulename;
  meth_meth_collectionsPrelude_addAll2218->definitionLine = 1148;
// method add
  struct UserObject *uo2267 = (struct UserObject*)obj2210;
  uo2267->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_add2267 = addmethod2pos(obj2210, "add", &meth_collectionsPrelude_add2267, 8);
  int argcv_meth_collectionsPrelude_add2267[] = {0};
  meth_meth_collectionsPrelude_add2267->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_add2267);
  meth_meth_collectionsPrelude_add2267->definitionModule = modulename;
  meth_meth_collectionsPrelude_add2267->definitionLine = 1163;
// method removeAll
  block_savedest(obj2210);
  Object closure2270 = createclosure(1, "removeAll");
  setclosureframe(closure2270, stackframe);
  addtoclosure(closure2270, var_NoSuchObject);
  struct UserObject *uo2270 = (struct UserObject*)obj2210;
  uo2270->data[9] = (Object)closure2270;
  Method *meth_meth_collectionsPrelude_removeAll2270 = addmethod2pos(obj2210, "removeAll", &meth_collectionsPrelude_removeAll2270, 9);
  int argcv_meth_collectionsPrelude_removeAll2270[] = {1};
  meth_meth_collectionsPrelude_removeAll2270->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAll2270);
  meth_meth_collectionsPrelude_removeAll2270->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAll2270->definitionLine = 1165;
// method removeAll()ifAbsent
  struct UserObject *uo2291 = (struct UserObject*)obj2210;
  uo2291->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeAll_40__41_ifAbsent2291 = addmethod2pos(obj2210, "removeAll()ifAbsent", &meth_collectionsPrelude_removeAll_40__41_ifAbsent2291, 10);
  int argcv_meth_collectionsPrelude_removeAll_40__41_ifAbsent2291[] = {1, 1};
  meth_meth_collectionsPrelude_removeAll_40__41_ifAbsent2291->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_removeAll_40__41_ifAbsent2291);
  meth_meth_collectionsPrelude_removeAll_40__41_ifAbsent2291->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAll_40__41_ifAbsent2291->definitionLine = 1173;
// method remove()ifAbsent
  struct UserObject *uo2331 = (struct UserObject*)obj2210;
  uo2331->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_remove_40__41_ifAbsent2331 = addmethod2pos(obj2210, "remove()ifAbsent", &meth_collectionsPrelude_remove_40__41_ifAbsent2331, 11);
  int argcv_meth_collectionsPrelude_remove_40__41_ifAbsent2331[] = {0, 1};
  meth_meth_collectionsPrelude_remove_40__41_ifAbsent2331->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_remove_40__41_ifAbsent2331);
  meth_meth_collectionsPrelude_remove_40__41_ifAbsent2331->definitionModule = modulename;
  meth_meth_collectionsPrelude_remove_40__41_ifAbsent2331->definitionLine = 1187;
// method remove
  struct UserObject *uo2334 = (struct UserObject*)obj2210;
  uo2334->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_remove2334 = addmethod2pos(obj2210, "remove", &meth_collectionsPrelude_remove2334, 12);
  int argcv_meth_collectionsPrelude_remove2334[] = {0};
  meth_meth_collectionsPrelude_remove2334->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_remove2334);
  meth_meth_collectionsPrelude_remove2334->definitionModule = modulename;
  meth_meth_collectionsPrelude_remove2334->definitionLine = 1191;
// method contains
  struct UserObject *uo2337 = (struct UserObject*)obj2210;
  uo2337->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_contains2337 = addmethod2pos(obj2210, "contains", &meth_collectionsPrelude_contains2337, 13);
  int argcv_meth_collectionsPrelude_contains2337[] = {1};
  meth_meth_collectionsPrelude_contains2337->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains2337);
  meth_meth_collectionsPrelude_contains2337->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains2337->definitionLine = 1195;
// method includes
  struct UserObject *uo2350 = (struct UserObject*)obj2210;
  uo2350->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_includes2350 = addmethod2pos(obj2210, "includes", &meth_collectionsPrelude_includes2350, 14);
  int argcv_meth_collectionsPrelude_includes2350[] = {1};
  meth_meth_collectionsPrelude_includes2350->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_includes2350);
  meth_meth_collectionsPrelude_includes2350->definitionModule = modulename;
  meth_meth_collectionsPrelude_includes2350->definitionLine = 1202;
// method find()ifNone
  struct UserObject *uo2361 = (struct UserObject*)obj2210;
  uo2361->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_find_40__41_ifNone2361 = addmethod2pos(obj2210, "find()ifNone", &meth_collectionsPrelude_find_40__41_ifNone2361, 15);
  int argcv_meth_collectionsPrelude_find_40__41_ifNone2361[] = {1, 1};
  meth_meth_collectionsPrelude_find_40__41_ifNone2361->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_find_40__41_ifNone2361);
  meth_meth_collectionsPrelude_find_40__41_ifNone2361->definitionModule = modulename;
  meth_meth_collectionsPrelude_find_40__41_ifNone2361->definitionLine = 1208;
// method findPosition
  struct UserObject *uo2372 = (struct UserObject*)obj2210;
  uo2372->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_findPosition2372 = addmethod2pos(obj2210, "findPosition", &meth_collectionsPrelude_findPosition2372, 16);
  int argcv_meth_collectionsPrelude_findPosition2372[] = {1};
  meth_meth_collectionsPrelude_findPosition2372->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_findPosition2372);
  meth_meth_collectionsPrelude_findPosition2372->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_findPosition2372->definitionModule = modulename;
  meth_meth_collectionsPrelude_findPosition2372->definitionLine = 1214;
// method findPositionForAdd
  struct UserObject *uo2435 = (struct UserObject*)obj2210;
  uo2435->data[17] = emptyclosure;
  Method *meth_meth_collectionsPrelude_findPositionForAdd2435 = addmethod2pos(obj2210, "findPositionForAdd", &meth_collectionsPrelude_findPositionForAdd2435, 17);
  int argcv_meth_collectionsPrelude_findPositionForAdd2435[] = {1};
  meth_meth_collectionsPrelude_findPositionForAdd2435->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_findPositionForAdd2435);
  meth_meth_collectionsPrelude_findPositionForAdd2435->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_findPositionForAdd2435->definitionModule = modulename;
  meth_meth_collectionsPrelude_findPositionForAdd2435->definitionLine = 1236;
// method asString
  struct UserObject *uo2508 = (struct UserObject*)obj2210;
  uo2508->data[18] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString2508 = addmethod2pos(obj2210, "asString", &meth_collectionsPrelude_asString2508, 18);
  int argcv_meth_collectionsPrelude_asString2508[] = {0};
  meth_meth_collectionsPrelude_asString2508->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString2508);
  meth_meth_collectionsPrelude_asString2508->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString2508->definitionLine = 1259;
// method extend
  struct UserObject *uo2533 = (struct UserObject*)obj2210;
  uo2533->data[19] = emptyclosure;
  Method *meth_meth_collectionsPrelude_extend2533 = addmethod2pos(obj2210, "extend", &meth_collectionsPrelude_extend2533, 19);
  int argcv_meth_collectionsPrelude_extend2533[] = {1};
  meth_meth_collectionsPrelude_extend2533->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_extend2533);
  meth_meth_collectionsPrelude_extend2533->definitionModule = modulename;
  meth_meth_collectionsPrelude_extend2533->definitionLine = 1265;
// method do
  struct UserObject *uo2541 = (struct UserObject*)obj2210;
  uo2541->data[20] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do2541 = addmethod2pos(obj2210, "do", &meth_collectionsPrelude_do2541, 20);
  int argcv_meth_collectionsPrelude_do2541[] = {1};
  meth_meth_collectionsPrelude_do2541->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do2541);
  meth_meth_collectionsPrelude_do2541->definitionModule = modulename;
  meth_meth_collectionsPrelude_do2541->definitionLine = 1270;
// method iterator
  block_savedest(obj2210);
  Object closure2590 = createclosure(2, "iterator");
  setclosureframe(closure2590, stackframe);
  addtoclosure(closure2590, var_ConcurrentModification);
  addtoclosure(closure2590, var_Exhausted);
  struct UserObject *uo2590 = (struct UserObject*)obj2210;
  uo2590->data[21] = (Object)closure2590;
  Method *meth_meth_collectionsPrelude_iterator2590 = addmethod2pos(obj2210, "iterator", &meth_collectionsPrelude_iterator2590, 21);
  int argcv_meth_collectionsPrelude_iterator2590[] = {0};
  meth_meth_collectionsPrelude_iterator2590->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator2590);
  meth_meth_collectionsPrelude_iterator2590->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator2590->definitionLine = 1283;
  block_savedest(obj2210);
  Object closure2709 = createclosure(2, "iterator()object");
  setclosureframe(closure2709, stackframe);
  addtoclosure(closure2709, var_ConcurrentModification);
  addtoclosure(closure2709, var_Exhausted);
  Method *meth_meth_collectionsPrelude_iterator2590_object = addmethod2pos(obj2210, "iterator()object", &meth_collectionsPrelude_iterator2590_object, 21);
  meth_meth_collectionsPrelude_iterator2590_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator2590_object->definitionLine = 1283;
// method expand
  block_savedest(obj2210);
  Object closure2710 = createclosure(1, "expand");
  setclosureframe(closure2710, stackframe);
  addtoclosure(closure2710, var__prelude);
  struct UserObject *uo2710 = (struct UserObject*)obj2210;
  uo2710->data[22] = (Object)closure2710;
  Method *meth_meth_collectionsPrelude_expand2710 = addmethod2pos(obj2210, "expand", &meth_collectionsPrelude_expand2710, 22);
  int argcv_meth_collectionsPrelude_expand2710[] = {0};
  meth_meth_collectionsPrelude_expand2710->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_expand2710);
  meth_meth_collectionsPrelude_expand2710->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_expand2710->definitionModule = modulename;
  meth_meth_collectionsPrelude_expand2710->definitionLine = 1309;
// method ==
  block_savedest(obj2210);
  Object closure2792 = createclosure(1, "==");
  setclosureframe(closure2792, stackframe);
  addtoclosure(closure2792, var_Collection);
  struct UserObject *uo2792 = (struct UserObject*)obj2210;
  uo2792->data[23] = (Object)closure2792;
  Method *meth_meth_collectionsPrelude__61__61_2792 = addmethod2pos(obj2210, "==", &meth_collectionsPrelude__61__61_2792, 23);
  int argcv_meth_collectionsPrelude__61__61_2792[] = {1};
  meth_meth_collectionsPrelude__61__61_2792->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61_2792);
  meth_meth_collectionsPrelude__61__61_2792->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61_2792->definitionLine = 1324;
// method copy
  struct UserObject *uo2832 = (struct UserObject*)obj2210;
  uo2832->data[24] = emptyclosure;
  Method *meth_meth_collectionsPrelude_copy2832 = addmethod2pos(obj2210, "copy", &meth_collectionsPrelude_copy2832, 24);
  int argcv_meth_collectionsPrelude_copy2832[] = {0};
  meth_meth_collectionsPrelude_copy2832->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_copy2832);
  meth_meth_collectionsPrelude_copy2832->definitionModule = modulename;
  meth_meth_collectionsPrelude_copy2832->definitionLine = 1340;
// method ++
  struct UserObject *uo2837 = (struct UserObject*)obj2210;
  uo2837->data[25] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43_2837 = addmethod2pos(obj2210, "++", &meth_collectionsPrelude__43__43_2837, 25);
  int argcv_meth_collectionsPrelude__43__43_2837[] = {1};
  meth_meth_collectionsPrelude__43__43_2837->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43_2837);
  meth_meth_collectionsPrelude__43__43_2837->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43_2837->definitionLine = 1343;
// method --
  struct UserObject *uo2842 = (struct UserObject*)obj2210;
  uo2842->data[26] = emptyclosure;
  Method *meth_meth_collectionsPrelude__45__45_2842 = addmethod2pos(obj2210, "--", &meth_collectionsPrelude__45__45_2842, 26);
  int argcv_meth_collectionsPrelude__45__45_2842[] = {1};
  meth_meth_collectionsPrelude__45__45_2842->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__45__45_2842);
  meth_meth_collectionsPrelude__45__45_2842->definitionModule = modulename;
  meth_meth_collectionsPrelude__45__45_2842->definitionLine = 1347;
// method **
  struct UserObject *uo2863 = (struct UserObject*)obj2210;
  uo2863->data[27] = emptyclosure;
  Method *meth_meth_collectionsPrelude__42__42_2863 = addmethod2pos(obj2210, "**", &meth_collectionsPrelude__42__42_2863, 27);
  int argcv_meth_collectionsPrelude__42__42_2863[] = {1};
  meth_meth_collectionsPrelude__42__42_2863->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__42__42_2863);
  meth_meth_collectionsPrelude__42__42_2863->definitionModule = modulename;
  meth_meth_collectionsPrelude__42__42_2863->definitionLine = 1357;
// method onto
  struct UserObject *uo2873 = (struct UserObject*)obj2210;
  uo2873->data[28] = emptyclosure;
  Method *meth_meth_collectionsPrelude_onto2873 = addmethod2pos(obj2210, "onto", &meth_collectionsPrelude_onto2873, 28);
  int argcv_meth_collectionsPrelude_onto2873[] = {1};
  meth_meth_collectionsPrelude_onto2873->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_onto2873);
  meth_meth_collectionsPrelude_onto2873->definitionModule = modulename;
  meth_meth_collectionsPrelude_onto2873->definitionLine = 1361;
// method into
  struct UserObject *uo2876 = (struct UserObject*)obj2210;
  uo2876->data[29] = emptyclosure;
  Method *meth_meth_collectionsPrelude_into2876 = addmethod2pos(obj2210, "into", &meth_collectionsPrelude_into2876, 29);
  int argcv_meth_collectionsPrelude_into2876[] = {1};
  meth_meth_collectionsPrelude_into2876->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_into2876);
  meth_meth_collectionsPrelude_into2876->definitionModule = modulename;
  meth_meth_collectionsPrelude_into2876->definitionLine = 1364;
  sourceObject = obj2210;
// Begin line 1128
  setline(1128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2884 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_collection (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2885 = callmethod(*var_collection, "trait()object",
    2, partcv, params);
  gc_frame_end(callframe2884);
// compiled call node returning call2885 (depth = 2)
  struct UserObject *obj2210_uo = (struct UserObject *)obj2210;
  obj2210_uo->super = call2885;
  sourceObject = obj2210;
// Begin line 1129
  setline(1129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2886 = alloc_Float64(0);
// compiled num node returning num2886 (depth = 2)
  adddatum2(obj2210, num2886, 1);
  sourceObject = obj2210;
  adddatum2(obj2210, undefined, 2);
  sourceObject = obj2210;
// Begin line 1131
  setline(1131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile catchcase node (depth = 2)
// starting to compile block node (depth = 3)
  Object block2888 = alloc_Block(NULL, NULL, "collectionsPrelude", 1131);
  gc_frame_newslot(block2888);
// method _apply
  block_savedest(block2888);
  Object closure2889 = createclosure(2, "_apply");
  setclosureframe(closure2889, stackframe);
  addtoclosure(closure2889, var_a);
  addtoclosure(closure2889, selfslot);
  struct UserObject *uo2889 = (struct UserObject*)block2888;
  uo2889->data[0] = (Object)closure2889;
  Method *meth_meth_collectionsPrelude__apply2889 = addmethod2pos(block2888, "_apply", &meth_collectionsPrelude__apply2889, 0);
  int argcv_meth_collectionsPrelude__apply2889[] = {0};
  meth_meth_collectionsPrelude__apply2889->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2889);
  meth_meth_collectionsPrelude__apply2889->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2889->definitionLine = 1359;
// compiled block node returning block2888 (depth = 3)
  int frame2887 = gc_frame_new();
  gc_frame_newslot(block2888);
// Begin line 1132
  setline(1132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block2910 = alloc_Block(NULL, NULL, "collectionsPrelude", 1132);
  gc_frame_newslot(block2910);
// method _apply
  block_savedest(block2910);
  Object closure2911 = createclosure(1, "_apply");
  setclosureframe(closure2911, stackframe);
  addtoclosure(closure2911, selfslot);
  struct UserObject *uo2911 = (struct UserObject*)block2910;
  uo2911->data[0] = (Object)closure2911;
  Method *meth_meth_collectionsPrelude__apply2911 = addmethod2pos(block2910, "_apply", &meth_collectionsPrelude__apply2911, 0);
  int argcv_meth_collectionsPrelude__apply2911[] = {1};
  meth_meth_collectionsPrelude__apply2911->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2911);
  meth_meth_collectionsPrelude__apply2911->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2911->definitionLine = 1131;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2916 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe2917 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit2918 == NULL) {
    strlit2918 = alloc_String("__17");
    gc_root(strlit2918);
  }
// compiled string node returning strlit2918 (depth = 6)
  gc_frame_newslot(strlit2918);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2919 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call2920 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2919);
// compiled call node returning call2920 (depth = 7)
// compiled member node returning call2920 (depth = 6)
  params[0] = strlit2918;
  partcv[0] = 1;
  Object call2921 = callmethod(call2920, "new",
    1, partcv, params);
  gc_frame_end(callframe2917);
// compiled call node returning call2921 (depth = 5)
  gc_frame_newslot(call2921);
// Begin line 1132
  setline(1132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_SizeUnknown (depth = 5)
  gc_frame_newslot(*var_SizeUnknown);
// call case 6: other member request
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2922 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call2923 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2922);
// compiled call node returning call2923 (depth = 6)
// compiled member node returning call2923 (depth = 5)
  params[0] = call2921;
  params[1] = *var_SizeUnknown;
  partcv[0] = 2;
  Object call2924 = callmethod(call2923, "new",
    1, partcv, params);
  gc_frame_end(callframe2916);
// compiled call node returning call2924 (depth = 4)
((struct UserObject *)block2910)->data[1] = call2924;
// compiled block node returning block2910 (depth = 3)
  gc_frame_newslot(block2910);
  params[0] = block2910;
  setline(1131);
  Object catchres2887 = catchCase(block2888, params, 1,NULL);
  gc_frame_end(frame2887);
// compiled catchcase node returning catchres2887 (depth = 2)
  sourceObject = obj2210;
// Begin line 1133
  setline(1133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2925 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2926 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2927 = callmethodflags(self, "initialSize", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2926);
// compiled call node returning call2927 (depth = 4)
// compiled member node returning call2927 (depth = 3)
  gc_frame_newslot(call2927);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2928 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var__prelude (depth = 5)
  partcv[0] = 0;
  Object call2929 = callmethod(*var__prelude, "PrimitiveArray",
    1, partcv, params);
  gc_frame_end(callframe2928);
// compiled call node returning call2929 (depth = 4)
// compiled member node returning call2929 (depth = 3)
  params[0] = call2927;
  partcv[0] = 1;
  Object call2930 = callmethod(call2929, "new",
    1, partcv, params);
  gc_frame_end(callframe2925);
// compiled call node returning call2930 (depth = 2)
  adddatum2(obj2210, call2930, 3);
  sourceObject = obj2210;
  Object inheritingObject2931 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2931 = alloc_userobj2(3,4, objclass2931);
  gc_frame_newslot(obj2931);
// OBJECT OUTER DEC outer
  adddatum2(obj2931, obj2210, 0);
  addmethodreal(obj2931,"outer", &reader_collectionsPrelude_outer_2932);
  Object oldself2931 = self;
  struct StackFrameObject *oldstackframe2931 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2931);
  gc_frame_newslot((Object)stackframe);
  self = obj2931;
  Object *oldselfslot2931 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2931 = (*(struct UserObject *)self).data[0], lowerouter2931 = thisouter2931;
  if (inheritingObject2931) {
    struct UserObject *inho2931 = (struct UserObject *)inheritingObject2931;
    while (inho2931->super != GraceDefaultObject) inho2931 = (struct UserObject *)inho2931->super;
    inho2931->super = obj2931;
    self = inheritingObject2931;
    *selfslot = self;
    lowerouter2931 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2931;
  }
if (objclass2931 == NULL) {
  Method *reader2933 = addmethodrealflags(obj2931, "unused",&reader_collectionsPrelude_unused_2933, MFLAG_CONFIDENTIAL);
  Method *writer2933 = addmethodrealflags(obj2931, "unused:=",&writer_collectionsPrelude_unused_2933, MFLAG_CONFIDENTIAL);
  reader2933->definitionModule = modulename;
  writer2933->definitionModule = modulename;
  reader2933->definitionLine = 1135;
  writer2933->definitionLine = 1135;
}
obj2931->flags |= OFLAG_MUTABLE;
adddatum2(obj2931, alloc_Undefined(), 1);
// method asString
  struct UserObject *uo2934 = (struct UserObject*)obj2931;
  uo2934->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString2934 = addmethod2pos(obj2931, "asString", &meth_collectionsPrelude_asString2934, 2);
  int argcv_meth_collectionsPrelude_asString2934[] = {0};
  meth_meth_collectionsPrelude_asString2934->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString2934);
  meth_meth_collectionsPrelude_asString2934->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString2934->definitionLine = 1136;
  sourceObject = obj2931;
// Begin line 1135
  setline(1135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool2936 = alloc_Boolean(1);
// compiled identifier node returning bool2936 (depth = 2)
  adddatum2(obj2931, bool2936, 1);
  sourceObject = obj2931;
  objclass2931 = obj2931->class;
  objclass2931->definitionModule = modulename;
  objclass2931->definitionLine = 1134;
  (*(struct UserObject *)self).data[0] = lowerouter2931;
  self = oldself2931;
  selfslot = oldselfslot2931;
  stackframe = oldstackframe2931;
  adddatum2(obj2210, obj2931, 4);
  sourceObject = obj2210;
  Object inheritingObject2937 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2937 = alloc_userobj2(3,4, objclass2937);
  gc_frame_newslot(obj2937);
// OBJECT OUTER DEC outer
  adddatum2(obj2937, obj2210, 0);
  addmethodreal(obj2937,"outer", &reader_collectionsPrelude_outer_2938);
  Object oldself2937 = self;
  struct StackFrameObject *oldstackframe2937 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2937);
  gc_frame_newslot((Object)stackframe);
  self = obj2937;
  Object *oldselfslot2937 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2937 = (*(struct UserObject *)self).data[0], lowerouter2937 = thisouter2937;
  if (inheritingObject2937) {
    struct UserObject *inho2937 = (struct UserObject *)inheritingObject2937;
    while (inho2937->super != GraceDefaultObject) inho2937 = (struct UserObject *)inho2937->super;
    inho2937->super = obj2937;
    self = inheritingObject2937;
    *selfslot = self;
    lowerouter2937 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2937;
  }
if (objclass2937 == NULL) {
  Method *reader2939 = addmethodrealflags(obj2937, "removed",&reader_collectionsPrelude_removed_2939, MFLAG_CONFIDENTIAL);
  Method *writer2939 = addmethodrealflags(obj2937, "removed:=",&writer_collectionsPrelude_removed_2939, MFLAG_CONFIDENTIAL);
  reader2939->definitionModule = modulename;
  writer2939->definitionModule = modulename;
  reader2939->definitionLine = 1139;
  writer2939->definitionLine = 1139;
}
obj2937->flags |= OFLAG_MUTABLE;
adddatum2(obj2937, alloc_Undefined(), 1);
// method asString
  struct UserObject *uo2940 = (struct UserObject*)obj2937;
  uo2940->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString2940 = addmethod2pos(obj2937, "asString", &meth_collectionsPrelude_asString2940, 2);
  int argcv_meth_collectionsPrelude_asString2940[] = {0};
  meth_meth_collectionsPrelude_asString2940->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString2940);
  meth_meth_collectionsPrelude_asString2940->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString2940->definitionLine = 1140;
  sourceObject = obj2937;
// Begin line 1139
  setline(1139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool2942 = alloc_Boolean(1);
// compiled identifier node returning bool2942 (depth = 2)
  adddatum2(obj2937, bool2942, 1);
  sourceObject = obj2937;
  objclass2937 = obj2937->class;
  objclass2937->definitionModule = modulename;
  objclass2937->definitionLine = 1138;
  (*(struct UserObject *)self).data[0] = lowerouter2937;
  self = oldself2937;
  selfslot = oldselfslot2937;
  stackframe = oldstackframe2937;
  adddatum2(obj2210, obj2937, 5);
  sourceObject = obj2210;
// Begin line 1142
  setline(1142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2943 = alloc_Float64(0);
// compiled num node returning num2943 (depth = 2)
  adddatum2(obj2210, num2943, 6);
  sourceObject = obj2210;
// Begin line 1143
  setline(1143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2944 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2947 = alloc_Float64(1);
// compiled num node returning num2947 (depth = 5)
  int op_slot_right_2946 = gc_frame_newslot(num2947);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2949 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2950 = callmethodflags(self, "initialSize", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2949);
// compiled call node returning call2950 (depth = 6)
// compiled member node returning call2950 (depth = 5)
  int op_slot_left_2946 = gc_frame_newslot(call2950);
  params[0] = num2947;
  partcv[0] = 1;
  Object diff2951 = callmethod(call2950, "-", 1, partcv, params);
// compiled op node returning diff2951 (depth = 4)
  int op_slot_right_2945 = gc_frame_newslot(diff2951);
// starting to compile num node (depth = 4)
  Object num2953 = alloc_Float64(0);
// compiled num node returning num2953 (depth = 4)
  int op_slot_left_2945 = gc_frame_newslot(num2953);
  params[0] = diff2951;
  partcv[0] = 1;
  Object opresult2954 = callmethod(num2953, "..", 1, partcv, params);
// compiled op node returning opresult2954 (depth = 3)
  gc_frame_newslot(opresult2954);
// starting to compile block node (depth = 3)
  Object block2955 = alloc_Block(NULL, NULL, "collectionsPrelude", 1143);
  gc_frame_newslot(block2955);
// method _apply
  block_savedest(block2955);
  Object closure2956 = createclosure(1, "_apply");
  setclosureframe(closure2956, stackframe);
  addtoclosure(closure2956, selfslot);
  struct UserObject *uo2956 = (struct UserObject*)block2955;
  uo2956->data[0] = (Object)closure2956;
  Method *meth_meth_collectionsPrelude__apply2956 = addmethod2pos(block2955, "_apply", &meth_collectionsPrelude__apply2956, 0);
  int argcv_meth_collectionsPrelude__apply2956[] = {1};
  meth_meth_collectionsPrelude__apply2956->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2956);
  meth_meth_collectionsPrelude__apply2956->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2956->definitionLine = 1143;
// compiled block node returning block2955 (depth = 3)
  gc_frame_newslot(block2955);
// call case 5: prelude request
  params[0] = opresult2954;
  params[1] = block2955;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2964 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2944);
// compiled call node returning call2964 (depth = 2)
  sourceObject = obj2210;
// Begin line 1146
  setline(1146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2965 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_a (depth = 3)
  gc_frame_newslot(*var_a);
// starting to compile block node (depth = 3)
  Object block2966 = alloc_Block(NULL, NULL, "collectionsPrelude", 1146);
  gc_frame_newslot(block2966);
// method _apply
  block_savedest(block2966);
  Object closure2967 = createclosure(1, "_apply");
  setclosureframe(closure2967, stackframe);
  addtoclosure(closure2967, selfslot);
  struct UserObject *uo2967 = (struct UserObject*)block2966;
  uo2967->data[0] = (Object)closure2967;
  Method *meth_meth_collectionsPrelude__apply2967 = addmethod2pos(block2966, "_apply", &meth_collectionsPrelude__apply2967, 0);
  int argcv_meth_collectionsPrelude__apply2967[] = {1};
  meth_meth_collectionsPrelude__apply2967->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2967);
  meth_meth_collectionsPrelude__apply2967->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2967->definitionLine = 1144;
// compiled block node returning block2966 (depth = 3)
  gc_frame_newslot(block2966);
// call case 5: prelude request
  params[0] = *var_a;
  params[1] = block2966;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2971 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2965);
// compiled call node returning call2971 (depth = 2)
  sourceObject = obj2210;
  sourceObject = obj2210;
  sourceObject = obj2210;
  sourceObject = obj2210;
  sourceObject = obj2210;
  sourceObject = obj2210;
  sourceObject = obj2210;
  sourceObject = obj2210;
  sourceObject = obj2210;
  sourceObject = obj2210;
  sourceObject = obj2210;
  sourceObject = obj2210;
  sourceObject = obj2210;
  sourceObject = obj2210;
  sourceObject = obj2210;
  sourceObject = obj2210;
  sourceObject = obj2210;
  sourceObject = obj2210;
  sourceObject = obj2210;
  sourceObject = obj2210;
  sourceObject = obj2210;
  sourceObject = obj2210;
  sourceObject = obj2210;
  objclass2210 = obj2210->class;
  objclass2210->definitionModule = modulename;
  objclass2210->definitionLine = 1127;
  (*(struct UserObject *)self).data[0] = lowerouter2210;
  self = oldself2210;
  selfslot = oldselfslot2210;
  stackframe = oldstackframe2210;
  gc_frame_end(frame);
  return obj2210;
}
Object meth_collectionsPrelude_set2206(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "set");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  Object *var_ConcurrentModification = getfromclosure(closure, 1);
  Object *var_Exhausted = getfromclosure(closure, 2);
  Object *var__prelude = getfromclosure(closure, 3);
  Object *var_Collection = getfromclosure(closure, 4);
  Object *var_collection = getfromclosure(closure, 5);
  Object *var_SizeUnknown = getfromclosure(closure, 6);
  Object *var_collectionFactory = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for set (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for set");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start generics
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      gracedie("insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End generics
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2207 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2207 = alloc_userobj2(3,4, objclass2207);
  gc_frame_newslot(obj2207);
if (objclass2207 == NULL) {
  glfree(obj2207->class->name);
  obj2207->class->name = "self.set";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2207, self, 0);
  addmethodreal(obj2207,"outer", &reader_collectionsPrelude_outer_2208);
  Object oldself2207 = self;
  struct StackFrameObject *oldstackframe2207 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2207);
  gc_frame_newslot((Object)stackframe);
  self = obj2207;
  Object *oldselfslot2207 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2207 = (*(struct UserObject *)self).data[0], lowerouter2207 = thisouter2207;
  if (inheritingObject2207) {
    struct UserObject *inho2207 = (struct UserObject *)inheritingObject2207;
    while (inho2207->super != GraceDefaultObject) inho2207 = (struct UserObject *)inho2207->super;
    inho2207->super = obj2207;
    self = inheritingObject2207;
    *selfslot = self;
    lowerouter2207 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2207;
  }
// method withAll
  block_savedest(obj2207);
  Object closure2209 = createclosure(7, "withAll");
  setclosureframe(closure2209, stackframe);
  addtoclosure(closure2209, var_NoSuchObject);
  addtoclosure(closure2209, var_ConcurrentModification);
  addtoclosure(closure2209, var_Exhausted);
  addtoclosure(closure2209, var__prelude);
  addtoclosure(closure2209, var_Collection);
  addtoclosure(closure2209, var_collection);
  addtoclosure(closure2209, var_SizeUnknown);
  struct UserObject *uo2209 = (struct UserObject*)obj2207;
  uo2209->data[1] = (Object)closure2209;
  Method *meth_meth_collectionsPrelude_withAll2209 = addmethod2pos(obj2207, "withAll", &meth_collectionsPrelude_withAll2209, 1);
  int argcv_meth_collectionsPrelude_withAll2209[] = {1};
  meth_meth_collectionsPrelude_withAll2209->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_withAll2209);
  meth_meth_collectionsPrelude_withAll2209->definitionModule = modulename;
  meth_meth_collectionsPrelude_withAll2209->definitionLine = 1126;
  block_savedest(obj2207);
  Object closure2972 = createclosure(7, "withAll()object");
  setclosureframe(closure2972, stackframe);
  addtoclosure(closure2972, var_NoSuchObject);
  addtoclosure(closure2972, var_ConcurrentModification);
  addtoclosure(closure2972, var_Exhausted);
  addtoclosure(closure2972, var__prelude);
  addtoclosure(closure2972, var_Collection);
  addtoclosure(closure2972, var_collection);
  addtoclosure(closure2972, var_SizeUnknown);
  Method *meth_meth_collectionsPrelude_withAll2209_object = addmethod2pos(obj2207, "withAll()object", &meth_collectionsPrelude_withAll2209_object, 1);
  meth_meth_collectionsPrelude_withAll2209_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_withAll2209_object->definitionLine = 1126;
  sourceObject = obj2207;
// Begin line 1124
  setline(1124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2973 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_collectionFactory (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2974 = callmethod(*var_collectionFactory, "trait()object",
    2, partcv, params);
  gc_frame_end(callframe2973);
// compiled call node returning call2974 (depth = 2)
  struct UserObject *obj2207_uo = (struct UserObject *)obj2207;
  obj2207_uo->super = call2974;
  sourceObject = obj2207;
  objclass2207 = obj2207->class;
  objclass2207->definitionModule = modulename;
  objclass2207->definitionLine = 1123;
  (*(struct UserObject *)self).data[0] = lowerouter2207;
  self = oldself2207;
  selfslot = oldselfslot2207;
  stackframe = oldstackframe2207;
  gc_frame_end(frame);
  return obj2207;
}
Object meth_collectionsPrelude_set2206_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "set()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  Object *var_ConcurrentModification = getfromclosure(closure, 1);
  Object *var_Exhausted = getfromclosure(closure, 2);
  Object *var__prelude = getfromclosure(closure, 3);
  Object *var_Collection = getfromclosure(closure, 4);
  Object *var_collection = getfromclosure(closure, 5);
  Object *var_SizeUnknown = getfromclosure(closure, 6);
  Object *var_collectionFactory = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for set (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for set");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start generics
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      gracedie("insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End generics
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2207 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2207 = alloc_userobj2(3,4, objclass2207);
  gc_frame_newslot(obj2207);
if (objclass2207 == NULL) {
  glfree(obj2207->class->name);
  obj2207->class->name = "self.set";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2207, self, 0);
  addmethodreal(obj2207,"outer", &reader_collectionsPrelude_outer_2208);
  Object oldself2207 = self;
  struct StackFrameObject *oldstackframe2207 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2207);
  gc_frame_newslot((Object)stackframe);
  self = obj2207;
  Object *oldselfslot2207 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2207 = (*(struct UserObject *)self).data[0], lowerouter2207 = thisouter2207;
  if (inheritingObject2207) {
    struct UserObject *inho2207 = (struct UserObject *)inheritingObject2207;
    while (inho2207->super != GraceDefaultObject) inho2207 = (struct UserObject *)inho2207->super;
    inho2207->super = obj2207;
    self = inheritingObject2207;
    *selfslot = self;
    lowerouter2207 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2207;
  }
// method withAll
  block_savedest(obj2207);
  Object closure2209 = createclosure(7, "withAll");
  setclosureframe(closure2209, stackframe);
  addtoclosure(closure2209, var_NoSuchObject);
  addtoclosure(closure2209, var_ConcurrentModification);
  addtoclosure(closure2209, var_Exhausted);
  addtoclosure(closure2209, var__prelude);
  addtoclosure(closure2209, var_Collection);
  addtoclosure(closure2209, var_collection);
  addtoclosure(closure2209, var_SizeUnknown);
  struct UserObject *uo2209 = (struct UserObject*)obj2207;
  uo2209->data[1] = (Object)closure2209;
  Method *meth_meth_collectionsPrelude_withAll2209 = addmethod2pos(obj2207, "withAll", &meth_collectionsPrelude_withAll2209, 1);
  int argcv_meth_collectionsPrelude_withAll2209[] = {1};
  meth_meth_collectionsPrelude_withAll2209->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_withAll2209);
  meth_meth_collectionsPrelude_withAll2209->definitionModule = modulename;
  meth_meth_collectionsPrelude_withAll2209->definitionLine = 1126;
  block_savedest(obj2207);
  Object closure2972 = createclosure(7, "withAll()object");
  setclosureframe(closure2972, stackframe);
  addtoclosure(closure2972, var_NoSuchObject);
  addtoclosure(closure2972, var_ConcurrentModification);
  addtoclosure(closure2972, var_Exhausted);
  addtoclosure(closure2972, var__prelude);
  addtoclosure(closure2972, var_Collection);
  addtoclosure(closure2972, var_collection);
  addtoclosure(closure2972, var_SizeUnknown);
  Method *meth_meth_collectionsPrelude_withAll2209_object = addmethod2pos(obj2207, "withAll()object", &meth_collectionsPrelude_withAll2209_object, 1);
  meth_meth_collectionsPrelude_withAll2209_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_withAll2209_object->definitionLine = 1126;
  sourceObject = obj2207;
// Begin line 1124
  setline(1124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2973 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_collectionFactory (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2974 = callmethod(*var_collectionFactory, "trait()object",
    2, partcv, params);
  gc_frame_end(callframe2973);
// compiled call node returning call2974 (depth = 2)
  struct UserObject *obj2207_uo = (struct UserObject *)obj2207;
  obj2207_uo->super = call2974;
  sourceObject = obj2207;
  objclass2207 = obj2207->class;
  objclass2207->definitionModule = modulename;
  objclass2207->definitionLine = 1123;
  (*(struct UserObject *)self).data[0] = lowerouter2207;
  self = oldself2207;
  selfslot = oldselfslot2207;
  stackframe = oldstackframe2207;
  gc_frame_end(frame);
  return obj2207;
}
Object meth_collectionsPrelude_at_40__41_put2979(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "at()put");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method at()put");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method at()put");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for at()put (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for at");
  Object *var_v = &(stackframe->slots[1]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for put");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1395
  setline(1395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2980 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_k (depth = 3)
  gc_frame_newslot(*var_k);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_v (depth = 3)
  gc_frame_newslot(*var_v);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2981 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2982 = callmethodflags(self, "empty", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2981);
// compiled call node returning call2982 (depth = 4)
// compiled member node returning call2982 (depth = 3)
  params[0] = *var_k;
  params[1] = *var_v;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2983 = callmethod(call2982, "at()put",
    2, partcv, params);
  gc_frame_end(callframe2980);
// compiled call node returning call2983 (depth = 2)
  gc_frame_end(frame);
  return call2983;
}
Object meth_collectionsPrelude_size2992(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "size");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for size (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for size");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1419
  setline(1419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2993 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2994 = callmethodflags(self, "numBindings", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2993);
// compiled call node returning call2994 (depth = 3)
// compiled member node returning call2994 (depth = 2)
  gc_frame_end(frame);
  return call2994;
}
Object meth_collectionsPrelude__apply3009(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_t = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3011 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3012 = callmethodflags(self, "removed", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3011);
// compiled call node returning call3012 (depth = 7)
// compiled member node returning call3012 (depth = 6)
  int op_slot_right_3010 = gc_frame_newslot(call3012);
// starting to compile call node (depth = 6)
  int callframe3014 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_t (depth = 7)
  gc_frame_newslot(*var_t);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3015 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3016 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3015);
// compiled call node returning call3016 (depth = 8)
// compiled member node returning call3016 (depth = 7)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3017 = callmethod(call3016, "at",
    1, partcv, params);
  gc_frame_end(callframe3014);
// compiled call node returning call3017 (depth = 6)
  int op_slot_left_3010 = gc_frame_newslot(call3017);
  params[0] = call3012;
  partcv[0] = 1;
  Object opresult3018 = callmethod(call3017, "==", 1, partcv, params);
// compiled op node returning opresult3018 (depth = 5)
  gc_frame_end(frame);
  return opresult3018;
}
Object meth_collectionsPrelude_at_40__41_put2995(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "at()put");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method at()put");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method at()put");
  Object params[2];
  int partcv[2];
  Object *var_binding = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for at()put (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_key_39_ = &(stackframe->slots[0]);
  *var_key_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for at");
  Object *var_value_39_ = &(stackframe->slots[1]);
  *var_value_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for put");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_t = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "t");
// Begin line 1421
  setline(1421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 1419
  setline(1419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2996 = gc_frame_new();
// Begin line 1421
  setline(1421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2998 = alloc_Float64(1);
// compiled num node returning num2998 (depth = 5)
  int op_slot_right_2997 = gc_frame_newslot(num2998);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3000 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3001 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3000);
// compiled call node returning call3001 (depth = 6)
// compiled member node returning call3001 (depth = 5)
  int op_slot_left_2997 = gc_frame_newslot(call3001);
  params[0] = num2998;
  partcv[0] = 1;
  Object sum3002 = callmethod(call3001, "+", 1, partcv, params);
// compiled op node returning sum3002 (depth = 4)
  gc_frame_newslot(sum3002);
// call case 4: self request
  params[0] = sum3002;
  partcv[0] = 1;
  Object call3003 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2996);
// compiled call node returning call3003 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 1422
  setline(1422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3004 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_key_39_ (depth = 4)
  gc_frame_newslot(*var_key_39_);
// call case 4: self request
  params[0] = *var_key_39_;
  partcv[0] = 1;
  Object call3005 = callmethodflags(self, "findPositionForAdd", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3004);
// compiled call node returning call3005 (depth = 3)
  *var_t = call3005;
  if (call3005 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1423
  setline(1423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3007 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block3008 = alloc_Block(NULL, NULL, "collectionsPrelude", 1423);
  gc_frame_newslot(block3008);
// method _apply
  block_savedest(block3008);
  Object closure3009 = createclosure(2, "_apply");
  setclosureframe(closure3009, stackframe);
  addtoclosure(closure3009, var_t);
  addtoclosure(closure3009, selfslot);
  struct UserObject *uo3009 = (struct UserObject*)block3008;
  uo3009->data[0] = (Object)closure3009;
  Method *meth_meth_collectionsPrelude__apply3009 = addmethod2pos(block3008, "_apply", &meth_collectionsPrelude__apply3009, 0);
  int argcv_meth_collectionsPrelude__apply3009[] = {0};
  meth_meth_collectionsPrelude__apply3009->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply3009);
  meth_meth_collectionsPrelude__apply3009->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply3009->definitionLine = 1421;
// compiled block node returning block3008 (depth = 4)
  gc_frame_newslot(block3008);
// call case 6: other member request
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3021 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3022 = callmethodflags(self, "unused", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3021);
// compiled call node returning call3022 (depth = 6)
// compiled member node returning call3022 (depth = 5)
  int op_slot_right_3020 = gc_frame_newslot(call3022);
// starting to compile call node (depth = 5)
  int callframe3024 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3025 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3026 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3025);
// compiled call node returning call3026 (depth = 7)
// compiled member node returning call3026 (depth = 6)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3027 = callmethod(call3026, "at",
    1, partcv, params);
  gc_frame_end(callframe3024);
// compiled call node returning call3027 (depth = 5)
  int op_slot_left_3020 = gc_frame_newslot(call3027);
  params[0] = call3022;
  partcv[0] = 1;
  Object opresult3028 = callmethod(call3027, "==", 1, partcv, params);
// compiled op node returning opresult3028 (depth = 4)
  params[0] = block3008;
  partcv[0] = 1;
  Object call3029 = callmethod(opresult3028, "orElse",
    1, partcv, params);
  gc_frame_end(callframe3007);
// compiled call node returning call3029 (depth = 3)
  Object if3006 = done;
  if (istrue(call3029)) {
// Begin line 1424
  setline(1424);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 1423
  setline(1423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3030 = gc_frame_new();
// Begin line 1424
  setline(1424);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num3032 = alloc_Float64(1);
// compiled num node returning num3032 (depth = 6)
  int op_slot_right_3031 = gc_frame_newslot(num3032);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3034 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3035 = callmethodflags(self, "numBindings", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3034);
// compiled call node returning call3035 (depth = 7)
// compiled member node returning call3035 (depth = 6)
  int op_slot_left_3031 = gc_frame_newslot(call3035);
  params[0] = num3032;
  partcv[0] = 1;
  Object sum3036 = callmethod(call3035, "+", 1, partcv, params);
// compiled op node returning sum3036 (depth = 5)
  gc_frame_newslot(sum3036);
// call case 4: self request
  params[0] = sum3036;
  partcv[0] = 1;
  Object call3037 = callmethodflags(self, "numBindings:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3030);
// compiled call node returning call3037 (depth = 4)
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if3006 = done;
  } else {
  }
// compiled if node returning if3006 (depth = 2)
// Begin line 1426
  setline(1426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3038 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_t (depth = 3)
  gc_frame_newslot(*var_t);
// starting to compile call node (depth = 3)
  int callframe3039 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_key_39_ (depth = 4)
  gc_frame_newslot(*var_key_39_);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_value_39_ (depth = 4)
  gc_frame_newslot(*var_value_39_);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_binding (depth = 4)
  params[0] = *var_key_39_;
  params[1] = *var_value_39_;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3040 = callmethod(*var_binding, "key()value",
    2, partcv, params);
  gc_frame_end(callframe3039);
// compiled call node returning call3040 (depth = 3)
  gc_frame_newslot(call3040);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3041 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3042 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3041);
// compiled call node returning call3042 (depth = 4)
// compiled member node returning call3042 (depth = 3)
  params[0] = *var_t;
  params[1] = call3040;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3043 = callmethod(call3042, "at()put",
    2, partcv, params);
  gc_frame_end(callframe3038);
// compiled call node returning call3043 (depth = 2)
// Begin line 1427
  setline(1427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3046 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3047 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3048 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3047);
// compiled call node returning call3048 (depth = 7)
// compiled member node returning call3048 (depth = 6)
  partcv[0] = 0;
  Object call3049 = callmethod(call3048, "size",
    1, partcv, params);
  gc_frame_end(callframe3046);
// compiled call node returning call3049 (depth = 5)
// compiled member node returning call3049 (depth = 4)
  int op_slot_right_3045 = gc_frame_newslot(call3049);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3052 = alloc_Float64(2);
// compiled num node returning num3052 (depth = 5)
  int op_slot_right_3051 = gc_frame_newslot(num3052);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3054 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3055 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3054);
// compiled call node returning call3055 (depth = 6)
// compiled member node returning call3055 (depth = 5)
  int op_slot_left_3051 = gc_frame_newslot(call3055);
  params[0] = num3052;
  partcv[0] = 1;
  Object prod3056 = callmethod(call3055, "*", 1, partcv, params);
// compiled op node returning prod3056 (depth = 4)
  int op_slot_left_3045 = gc_frame_newslot(prod3056);
  params[0] = call3049;
  partcv[0] = 1;
  Object opresult3057 = callmethod(prod3056, ">", 1, partcv, params);
// compiled op node returning opresult3057 (depth = 3)
  Object if3044 = done;
  if (istrue(opresult3057)) {
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3058 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3059 = callmethodflags(self, "expand", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3058);
// compiled call node returning call3059 (depth = 4)
// compiled member node returning call3059 (depth = 3)
    gc_frame_newslot(call3059);
    if3044 = call3059;
  } else {
  }
// compiled if node returning if3044 (depth = 2)
// Begin line 1428
  setline(1428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__91__93__58__61_3060(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "[]:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method []:=");
  Object params[2];
  int partcv[2];
  Object *var_done = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for []:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  Object *var_v = &(stackframe->slots[1]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for [:=");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1431
  setline(1431);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3061 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_k (depth = 3)
  gc_frame_newslot(*var_k);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_v (depth = 3)
  gc_frame_newslot(*var_v);
// call case 4: self request
  params[0] = *var_k;
  params[1] = *var_v;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3062 = callmethodflags(self, "at()put", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3061);
// compiled call node returning call3062 (depth = 2)
// Begin line 1432
  setline(1432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_done (depth = 2)
  gc_frame_end(frame);
  return *var_done;
}
Object meth_collectionsPrelude_at3063(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "at");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method at");
  Object params[1];
  int partcv[1];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for at (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for at");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_b = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "b");
// Begin line 1435
  setline(1435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3064 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3065 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_k (depth = 5)
  gc_frame_newslot(*var_k);
// call case 4: self request
  params[0] = *var_k;
  partcv[0] = 1;
  Object call3066 = callmethodflags(self, "findPosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3065);
// compiled call node returning call3066 (depth = 4)
  gc_frame_newslot(call3066);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3067 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3068 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3067);
// compiled call node returning call3068 (depth = 5)
// compiled member node returning call3068 (depth = 4)
  params[0] = call3066;
  partcv[0] = 1;
  Object call3069 = callmethod(call3068, "at",
    1, partcv, params);
  gc_frame_end(callframe3064);
// compiled call node returning call3069 (depth = 3)
  *var_b = call3069;
  if (call3069 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1436
  setline(1436);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  int op_slot_right_3071 = gc_frame_newslot(*var_k);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3073 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_b (depth = 6)
  partcv[0] = 0;
  Object call3074 = callmethod(*var_b, "key",
    1, partcv, params);
  gc_frame_end(callframe3073);
// compiled call node returning call3074 (depth = 5)
// compiled member node returning call3074 (depth = 4)
  int op_slot_left_3071 = gc_frame_newslot(call3074);
  params[0] = *var_k;
  partcv[0] = 1;
  Object opresult3075 = callmethod(call3074, "==", 1, partcv, params);
// compiled op node returning opresult3075 (depth = 3)
  Object if3070 = done;
  if (istrue(opresult3075)) {
// Begin line 1437
  setline(1437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3076 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_b (depth = 6)
  partcv[0] = 0;
  Object call3077 = callmethod(*var_b, "value",
    1, partcv, params);
  gc_frame_end(callframe3076);
// compiled call node returning call3077 (depth = 5)
// compiled member node returning call3077 (depth = 4)
  return call3077;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if3070 = undefined;
  } else {
  }
// compiled if node returning if3070 (depth = 2)
// Begin line 1439
  setline(1439);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3078 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3080 == NULL) {
    strlit3080 = alloc_String("");
    gc_root(strlit3080);
  }
// compiled string node returning strlit3080 (depth = 4)
  int op_slot_right_3079 = gc_frame_newslot(strlit3080);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_k (depth = 5)
  int op_slot_right_3082 = gc_frame_newslot(*var_k);
// starting to compile string node (depth = 5)
  if (strlit3084 == NULL) {
    strlit3084 = alloc_String("dictionary does not contain entry with key ");
    gc_root(strlit3084);
  }
// compiled string node returning strlit3084 (depth = 5)
  int op_slot_left_3082 = gc_frame_newslot(strlit3084);
  params[0] = *var_k;
  partcv[0] = 1;
  Object opresult3085 = callmethod(strlit3084, "++", 1, partcv, params);
// compiled op node returning opresult3085 (depth = 4)
  int op_slot_left_3079 = gc_frame_newslot(opresult3085);
  params[0] = strlit3080;
  partcv[0] = 1;
  Object opresult3086 = callmethod(opresult3085, "++", 1, partcv, params);
// compiled op node returning opresult3086 (depth = 3)
  gc_frame_newslot(opresult3086);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_NoSuchObject (depth = 3)
  params[0] = opresult3086;
  partcv[0] = 1;
  Object call3087 = callmethod(*var_NoSuchObject, "raise",
    1, partcv, params);
  gc_frame_end(callframe3078);
// compiled call node returning call3087 (depth = 2)
  gc_frame_end(frame);
  return call3087;
}
Object meth_collectionsPrelude_at_40__41_ifAbsent3088(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "at()ifAbsent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method at()ifAbsent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method at()ifAbsent");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for at()ifAbsent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for at");
  Object *var_action = &(stackframe->slots[1]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for ifAbsent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_b = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "b");
// Begin line 1442
  setline(1442);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3089 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3090 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_k (depth = 5)
  gc_frame_newslot(*var_k);
// call case 4: self request
  params[0] = *var_k;
  partcv[0] = 1;
  Object call3091 = callmethodflags(self, "findPosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3090);
// compiled call node returning call3091 (depth = 4)
  gc_frame_newslot(call3091);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3092 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3093 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3092);
// compiled call node returning call3093 (depth = 5)
// compiled member node returning call3093 (depth = 4)
  params[0] = call3091;
  partcv[0] = 1;
  Object call3094 = callmethod(call3093, "at",
    1, partcv, params);
  gc_frame_end(callframe3089);
// compiled call node returning call3094 (depth = 3)
  *var_b = call3094;
  if (call3094 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1443
  setline(1443);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  int op_slot_right_3096 = gc_frame_newslot(*var_k);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3098 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_b (depth = 6)
  partcv[0] = 0;
  Object call3099 = callmethod(*var_b, "key",
    1, partcv, params);
  gc_frame_end(callframe3098);
// compiled call node returning call3099 (depth = 5)
// compiled member node returning call3099 (depth = 4)
  int op_slot_left_3096 = gc_frame_newslot(call3099);
  params[0] = *var_k;
  partcv[0] = 1;
  Object opresult3100 = callmethod(call3099, "==", 1, partcv, params);
// compiled op node returning opresult3100 (depth = 3)
  Object if3095 = done;
  if (istrue(opresult3100)) {
// Begin line 1444
  setline(1444);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3101 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_b (depth = 6)
  partcv[0] = 0;
  Object call3102 = callmethod(*var_b, "value",
    1, partcv, params);
  gc_frame_end(callframe3101);
// compiled call node returning call3102 (depth = 5)
// compiled member node returning call3102 (depth = 4)
  return call3102;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if3095 = undefined;
  } else {
  }
// compiled if node returning if3095 (depth = 2)
// Begin line 1446
  setline(1446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3103 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_action (depth = 5)
  partcv[0] = 0;
  Object call3104 = callmethod(*var_action, "apply",
    1, partcv, params);
  gc_frame_end(callframe3103);
// compiled call node returning call3104 (depth = 4)
// compiled member node returning call3104 (depth = 3)
  return call3104;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__91__93_3105(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "[]");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method []");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for [] (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for [");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1448
  setline(1448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3106 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_k (depth = 3)
  gc_frame_newslot(*var_k);
// call case 4: self request
  params[0] = *var_k;
  partcv[0] = 1;
  Object call3107 = callmethodflags(self, "at", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3106);
// compiled call node returning call3107 (depth = 2)
  gc_frame_end(frame);
  return call3107;
}
Object meth_collectionsPrelude_containsKey3108(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "containsKey");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method containsKey");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for containsKey (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for containsKey");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_t = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "t");
// Begin line 1450
  setline(1450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3109 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  gc_frame_newslot(*var_k);
// call case 4: self request
  params[0] = *var_k;
  partcv[0] = 1;
  Object call3110 = callmethodflags(self, "findPosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3109);
// compiled call node returning call3110 (depth = 3)
  *var_t = call3110;
  if (call3110 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1451
  setline(1451);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  int op_slot_right_3112 = gc_frame_newslot(*var_k);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3114 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 6)
  int callframe3115 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_t (depth = 7)
  gc_frame_newslot(*var_t);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3116 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3117 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3116);
// compiled call node returning call3117 (depth = 8)
// compiled member node returning call3117 (depth = 7)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3118 = callmethod(call3117, "at",
    1, partcv, params);
  gc_frame_end(callframe3115);
// compiled call node returning call3118 (depth = 6)
  partcv[0] = 0;
  Object call3119 = callmethod(call3118, "key",
    1, partcv, params);
  gc_frame_end(callframe3114);
// compiled call node returning call3119 (depth = 5)
// compiled member node returning call3119 (depth = 4)
  int op_slot_left_3112 = gc_frame_newslot(call3119);
  params[0] = *var_k;
  partcv[0] = 1;
  Object opresult3120 = callmethod(call3119, "==", 1, partcv, params);
// compiled op node returning opresult3120 (depth = 3)
  Object if3111 = done;
  if (istrue(opresult3120)) {
// Begin line 1452
  setline(1452);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool3121 = alloc_Boolean(1);
// compiled identifier node returning bool3121 (depth = 4)
  return bool3121;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if3111 = undefined;
  } else {
  }
// compiled if node returning if3111 (depth = 2)
// Begin line 1454
  setline(1454);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool3122 = alloc_Boolean(0);
// compiled identifier node returning bool3122 (depth = 3)
  return bool3122;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply3134(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_t = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "t");
// Begin line 1459
  setline(1459);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3135 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_k (depth = 6)
  gc_frame_newslot(*var_k);
// call case 4: self request
  params[0] = *var_k;
  partcv[0] = 1;
  Object call3136 = callmethodflags(self, "findPosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3135);
// compiled call node returning call3136 (depth = 5)
  *var_t = call3136;
  if (call3136 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1460
  setline(1460);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_k (depth = 6)
  int op_slot_right_3138 = gc_frame_newslot(*var_k);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3140 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe3141 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_t (depth = 9)
  gc_frame_newslot(*var_t);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3142 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3143 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3142);
// compiled call node returning call3143 (depth = 10)
// compiled member node returning call3143 (depth = 9)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3144 = callmethod(call3143, "at",
    1, partcv, params);
  gc_frame_end(callframe3141);
// compiled call node returning call3144 (depth = 8)
  partcv[0] = 0;
  Object call3145 = callmethod(call3144, "key",
    1, partcv, params);
  gc_frame_end(callframe3140);
// compiled call node returning call3145 (depth = 7)
// compiled member node returning call3145 (depth = 6)
  int op_slot_left_3138 = gc_frame_newslot(call3145);
  params[0] = *var_k;
  partcv[0] = 1;
  Object opresult3146 = callmethod(call3145, "==", 1, partcv, params);
// compiled op node returning opresult3146 (depth = 5)
  Object if3137 = done;
  if (istrue(opresult3146)) {
// Begin line 1461
  setline(1461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3147 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3148 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3149 = callmethodflags(self, "removed", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3148);
// compiled call node returning call3149 (depth = 7)
// compiled member node returning call3149 (depth = 6)
  gc_frame_newslot(call3149);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3150 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3151 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3150);
// compiled call node returning call3151 (depth = 7)
// compiled member node returning call3151 (depth = 6)
  params[0] = *var_t;
  params[1] = call3149;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3152 = callmethod(call3151, "at()put",
    2, partcv, params);
  gc_frame_end(callframe3147);
// compiled call node returning call3152 (depth = 5)
// Begin line 1462
  setline(1462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 1461
  setline(1461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3153 = gc_frame_new();
// Begin line 1462
  setline(1462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num3155 = alloc_Float64(1);
// compiled num node returning num3155 (depth = 8)
  int op_slot_right_3154 = gc_frame_newslot(num3155);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3157 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3158 = callmethodflags(self, "numBindings", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3157);
// compiled call node returning call3158 (depth = 9)
// compiled member node returning call3158 (depth = 8)
  int op_slot_left_3154 = gc_frame_newslot(call3158);
  params[0] = num3155;
  partcv[0] = 1;
  Object diff3159 = callmethod(call3158, "-", 1, partcv, params);
// compiled op node returning diff3159 (depth = 7)
  gc_frame_newslot(diff3159);
// call case 4: self request
  params[0] = diff3159;
  partcv[0] = 1;
  Object call3160 = callmethodflags(self, "numBindings:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3153);
// compiled call node returning call3160 (depth = 6)
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if3137 = done;
  } else {
// Begin line 1464
  setline(1464);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3161 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3163 == NULL) {
    strlit3163 = alloc_String("");
    gc_root(strlit3163);
  }
// compiled string node returning strlit3163 (depth = 7)
  int op_slot_right_3162 = gc_frame_newslot(strlit3163);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_k (depth = 8)
  int op_slot_right_3165 = gc_frame_newslot(*var_k);
// starting to compile string node (depth = 8)
  if (strlit3167 == NULL) {
    strlit3167 = alloc_String("dictionary does not contain entry with key ");
    gc_root(strlit3167);
  }
// compiled string node returning strlit3167 (depth = 8)
  int op_slot_left_3165 = gc_frame_newslot(strlit3167);
  params[0] = *var_k;
  partcv[0] = 1;
  Object opresult3168 = callmethod(strlit3167, "++", 1, partcv, params);
// compiled op node returning opresult3168 (depth = 7)
  int op_slot_left_3162 = gc_frame_newslot(opresult3168);
  params[0] = strlit3163;
  partcv[0] = 1;
  Object opresult3169 = callmethod(opresult3168, "++", 1, partcv, params);
// compiled op node returning opresult3169 (depth = 6)
  gc_frame_newslot(opresult3169);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_NoSuchObject (depth = 6)
  params[0] = opresult3169;
  partcv[0] = 1;
  Object call3170 = callmethod(*var_NoSuchObject, "raise",
    1, partcv, params);
  gc_frame_end(callframe3161);
// compiled call node returning call3170 (depth = 5)
    gc_frame_newslot(call3170);
    if3137 = call3170;
  }
// compiled if node returning if3137 (depth = 4)
  gc_frame_end(frame);
  return if3137;
}
Object meth_collectionsPrelude_removeAllKeys3123(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "removeAllKeys");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method removeAllKeys");
  Object params[2];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for removeAllKeys (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_keys = &(stackframe->slots[0]);
  *var_keys = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for removeAllKeys");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1457
  setline(1457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 1451
  setline(1451);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3124 = gc_frame_new();
// Begin line 1457
  setline(1457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3126 = alloc_Float64(1);
// compiled num node returning num3126 (depth = 5)
  int op_slot_right_3125 = gc_frame_newslot(num3126);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3128 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3129 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3128);
// compiled call node returning call3129 (depth = 6)
// compiled member node returning call3129 (depth = 5)
  int op_slot_left_3125 = gc_frame_newslot(call3129);
  params[0] = num3126;
  partcv[0] = 1;
  Object sum3130 = callmethod(call3129, "+", 1, partcv, params);
// compiled op node returning sum3130 (depth = 4)
  gc_frame_newslot(sum3130);
// call case 4: self request
  params[0] = sum3130;
  partcv[0] = 1;
  Object call3131 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3124);
// compiled call node returning call3131 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 1458
  setline(1458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3132 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_keys (depth = 3)
  gc_frame_newslot(*var_keys);
// starting to compile block node (depth = 3)
  Object block3133 = alloc_Block(NULL, NULL, "collectionsPrelude", 1458);
  gc_frame_newslot(block3133);
// method _apply
  block_savedest(block3133);
  Object closure3134 = createclosure(2, "_apply");
  setclosureframe(closure3134, stackframe);
  addtoclosure(closure3134, var_NoSuchObject);
  addtoclosure(closure3134, selfslot);
  struct UserObject *uo3134 = (struct UserObject*)block3133;
  uo3134->data[0] = (Object)closure3134;
  Method *meth_meth_collectionsPrelude__apply3134 = addmethod2pos(block3133, "_apply", &meth_collectionsPrelude__apply3134, 0);
  int argcv_meth_collectionsPrelude__apply3134[] = {1};
  meth_meth_collectionsPrelude__apply3134->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply3134);
  meth_meth_collectionsPrelude__apply3134->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply3134->definitionLine = 1457;
// compiled block node returning block3133 (depth = 3)
  gc_frame_newslot(block3133);
// call case 5: prelude request
  params[0] = *var_keys;
  params[1] = block3133;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3172 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3132);
// compiled call node returning call3172 (depth = 2)
// Begin line 1467
  setline(1467);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  return self;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_removeKey3173(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "removeKey");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for removeKey (probably reflection error): got %i lists, expected 1.", nparts);
  Object var_init_keys = alloc_BuiltinList();
  for (i = 0; i < argcv[0]; i++) {
    callmethod(var_init_keys, "push", 1, pushcv, &args[curarg]);
    curarg++;
  }
  Object *var_keys = &(stackframe->slots[0]);
  *var_keys = var_init_keys;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1470
  setline(1470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3174 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_keys (depth = 3)
  gc_frame_newslot(*var_keys);
// call case 4: self request
  params[0] = *var_keys;
  partcv[0] = 1;
  Object call3175 = callmethodflags(self, "removeAllKeys", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3174);
// compiled call node returning call3175 (depth = 2)
  gc_frame_end(frame);
  return call3175;
}
Object meth_collectionsPrelude__apply3199(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_removals = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_a = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "a");
// Begin line 1475
  setline(1475);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3200 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3201 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3202 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3201);
// compiled call node returning call3202 (depth = 7)
// compiled member node returning call3202 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call3203 = callmethod(call3202, "at",
    1, partcv, params);
  gc_frame_end(callframe3200);
// compiled call node returning call3203 (depth = 5)
  *var_a = call3203;
  if (call3203 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1476
  setline(1476);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3205 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3206 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_a (depth = 8)
  partcv[0] = 0;
  Object call3207 = callmethod(*var_a, "value",
    1, partcv, params);
  gc_frame_end(callframe3206);
// compiled call node returning call3207 (depth = 7)
// compiled member node returning call3207 (depth = 6)
  gc_frame_newslot(call3207);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_removals (depth = 6)
  params[0] = call3207;
  partcv[0] = 1;
  Object call3208 = callmethod(*var_removals, "contains",
    1, partcv, params);
  gc_frame_end(callframe3205);
// compiled call node returning call3208 (depth = 5)
  Object if3204 = done;
  if (istrue(call3208)) {
// Begin line 1477
  setline(1477);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3209 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3210 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3211 = callmethodflags(self, "removed", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3210);
// compiled call node returning call3211 (depth = 7)
// compiled member node returning call3211 (depth = 6)
  gc_frame_newslot(call3211);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3212 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3213 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3212);
// compiled call node returning call3213 (depth = 7)
// compiled member node returning call3213 (depth = 6)
  params[0] = *var_i;
  params[1] = call3211;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3214 = callmethod(call3213, "at()put",
    2, partcv, params);
  gc_frame_end(callframe3209);
// compiled call node returning call3214 (depth = 5)
// Begin line 1478
  setline(1478);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 1477
  setline(1477);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3215 = gc_frame_new();
// Begin line 1478
  setline(1478);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num3217 = alloc_Float64(1);
// compiled num node returning num3217 (depth = 8)
  int op_slot_right_3216 = gc_frame_newslot(num3217);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3219 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3220 = callmethodflags(self, "numBindings", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3219);
// compiled call node returning call3220 (depth = 9)
// compiled member node returning call3220 (depth = 8)
  int op_slot_left_3216 = gc_frame_newslot(call3220);
  params[0] = num3217;
  partcv[0] = 1;
  Object diff3221 = callmethod(call3220, "-", 1, partcv, params);
// compiled op node returning diff3221 (depth = 7)
  gc_frame_newslot(diff3221);
// call case 4: self request
  params[0] = diff3221;
  partcv[0] = 1;
  Object call3222 = callmethodflags(self, "numBindings:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3215);
// compiled call node returning call3222 (depth = 6)
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if3204 = done;
  } else {
  }
// compiled if node returning if3204 (depth = 4)
  gc_frame_end(frame);
  return if3204;
}
Object meth_collectionsPrelude_removeAllValues3176(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "removeAllValues");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method removeAllValues");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for removeAllValues (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_removals = &(stackframe->slots[0]);
  *var_removals = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for removeAllValues");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1473
  setline(1473);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 1462
  setline(1462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3177 = gc_frame_new();
// Begin line 1473
  setline(1473);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3179 = alloc_Float64(1);
// compiled num node returning num3179 (depth = 5)
  int op_slot_right_3178 = gc_frame_newslot(num3179);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3181 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3182 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3181);
// compiled call node returning call3182 (depth = 6)
// compiled member node returning call3182 (depth = 5)
  int op_slot_left_3178 = gc_frame_newslot(call3182);
  params[0] = num3179;
  partcv[0] = 1;
  Object sum3183 = callmethod(call3182, "+", 1, partcv, params);
// compiled op node returning sum3183 (depth = 4)
  gc_frame_newslot(sum3183);
// call case 4: self request
  params[0] = sum3183;
  partcv[0] = 1;
  Object call3184 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3177);
// compiled call node returning call3184 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 1474
  setline(1474);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3185 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3188 = alloc_Float64(1);
// compiled num node returning num3188 (depth = 5)
  int op_slot_right_3187 = gc_frame_newslot(num3188);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3190 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3191 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3192 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3191);
// compiled call node returning call3192 (depth = 8)
// compiled member node returning call3192 (depth = 7)
  partcv[0] = 0;
  Object call3193 = callmethod(call3192, "size",
    1, partcv, params);
  gc_frame_end(callframe3190);
// compiled call node returning call3193 (depth = 6)
// compiled member node returning call3193 (depth = 5)
  int op_slot_left_3187 = gc_frame_newslot(call3193);
  params[0] = num3188;
  partcv[0] = 1;
  Object diff3194 = callmethod(call3193, "-", 1, partcv, params);
// compiled op node returning diff3194 (depth = 4)
  int op_slot_right_3186 = gc_frame_newslot(diff3194);
// starting to compile num node (depth = 4)
  Object num3196 = alloc_Float64(0);
// compiled num node returning num3196 (depth = 4)
  int op_slot_left_3186 = gc_frame_newslot(num3196);
  params[0] = diff3194;
  partcv[0] = 1;
  Object opresult3197 = callmethod(num3196, "..", 1, partcv, params);
// compiled op node returning opresult3197 (depth = 3)
  gc_frame_newslot(opresult3197);
// starting to compile block node (depth = 3)
  Object block3198 = alloc_Block(NULL, NULL, "collectionsPrelude", 1474);
  gc_frame_newslot(block3198);
// method _apply
  block_savedest(block3198);
  Object closure3199 = createclosure(2, "_apply");
  setclosureframe(closure3199, stackframe);
  addtoclosure(closure3199, var_removals);
  addtoclosure(closure3199, selfslot);
  struct UserObject *uo3199 = (struct UserObject*)block3198;
  uo3199->data[0] = (Object)closure3199;
  Method *meth_meth_collectionsPrelude__apply3199 = addmethod2pos(block3198, "_apply", &meth_collectionsPrelude__apply3199, 0);
  int argcv_meth_collectionsPrelude__apply3199[] = {1};
  meth_meth_collectionsPrelude__apply3199->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply3199);
  meth_meth_collectionsPrelude__apply3199->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply3199->definitionLine = 1474;
// compiled block node returning block3198 (depth = 3)
  gc_frame_newslot(block3198);
// call case 5: prelude request
  params[0] = opresult3197;
  params[1] = block3198;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3224 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3185);
// compiled call node returning call3224 (depth = 2)
// Begin line 1481
  setline(1481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  return self;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_removeValue3225(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "removeValue");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for removeValue (probably reflection error): got %i lists, expected 1.", nparts);
  Object var_init_removals = alloc_BuiltinList();
  for (i = 0; i < argcv[0]; i++) {
    callmethod(var_init_removals, "push", 1, pushcv, &args[curarg]);
    curarg++;
  }
  Object *var_removals = &(stackframe->slots[0]);
  *var_removals = var_init_removals;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1484
  setline(1484);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3226 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_removals (depth = 3)
  gc_frame_newslot(*var_removals);
// call case 4: self request
  params[0] = *var_removals;
  partcv[0] = 1;
  Object call3227 = callmethodflags(self, "removeAllValues", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3226);
// compiled call node returning call3227 (depth = 2)
  gc_frame_end(frame);
  return call3227;
}
Object meth_collectionsPrelude__apply3231(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_v = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1488
  setline(1488);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_each (depth = 6)
  int op_slot_right_3233 = gc_frame_newslot(*var_each);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  int op_slot_left_3233 = gc_frame_newslot(*var_v);
  params[0] = *var_each;
  partcv[0] = 1;
  Object opresult3235 = callmethod(*var_v, "==", 1, partcv, params);
// compiled op node returning opresult3235 (depth = 5)
  Object if3232 = done;
  if (istrue(opresult3235)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool3236 = alloc_Boolean(1);
// compiled identifier node returning bool3236 (depth = 6)
  block_return(realself, bool3236);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if3232 = undefined;
  } else {
  }
// compiled if node returning if3232 (depth = 4)
  gc_frame_end(frame);
  return if3232;
}
Object meth_collectionsPrelude_containsValue3228(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "containsValue");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method containsValue");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for containsValue (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for containsValue");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1487
  setline(1487);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3229 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block3230 = alloc_Block(NULL, NULL, "collectionsPrelude", 1487);
  gc_frame_newslot(block3230);
// method _apply
  block_savedest(block3230);
  Object closure3231 = createclosure(2, "_apply");
  setclosureframe(closure3231, stackframe);
  addtoclosure(closure3231, var_v);
  addtoclosure(closure3231, selfslot);
  struct UserObject *uo3231 = (struct UserObject*)block3230;
  uo3231->data[0] = (Object)closure3231;
  Method *meth_meth_collectionsPrelude__apply3231 = addmethod2pos(block3230, "_apply", &meth_collectionsPrelude__apply3231, 0);
  int argcv_meth_collectionsPrelude__apply3231[] = {1};
  meth_meth_collectionsPrelude__apply3231->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply3231);
  meth_meth_collectionsPrelude__apply3231->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply3231->definitionLine = 1478;
// compiled block node returning block3230 (depth = 3)
  gc_frame_newslot(block3230);
// call case 4: self request
  params[0] = block3230;
  partcv[0] = 1;
  Object call3238 = callmethodflags(self, "valuesDo", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3229);
// compiled call node returning call3238 (depth = 2)
// Begin line 1490
  setline(1490);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool3239 = alloc_Boolean(0);
// compiled identifier node returning bool3239 (depth = 3)
  return bool3239;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_contains3240(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "contains");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method contains");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for contains (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for contains");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1492
  setline(1492);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3241 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_v (depth = 3)
  gc_frame_newslot(*var_v);
// call case 4: self request
  params[0] = *var_v;
  partcv[0] = 1;
  Object call3242 = callmethodflags(self, "containsValue", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3241);
// compiled call node returning call3242 (depth = 2)
  gc_frame_end(frame);
  return call3242;
}
Object meth_collectionsPrelude__apply3256(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_t = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3258 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3259 = callmethodflags(self, "unused", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3258);
// compiled call node returning call3259 (depth = 6)
// compiled member node returning call3259 (depth = 5)
  int op_slot_right_3257 = gc_frame_newslot(call3259);
// starting to compile call node (depth = 5)
  int callframe3261 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3262 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3263 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3262);
// compiled call node returning call3263 (depth = 7)
// compiled member node returning call3263 (depth = 6)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3264 = callmethod(call3263, "at",
    1, partcv, params);
  gc_frame_end(callframe3261);
// compiled call node returning call3264 (depth = 5)
  int op_slot_left_3257 = gc_frame_newslot(call3264);
  params[0] = call3259;
  partcv[0] = 1;
  Object opresult3265 = callmethod(call3264, "!=", 1, partcv, params);
// compiled op node returning opresult3265 (depth = 4)
  gc_frame_end(frame);
  return opresult3265;
}
Object meth_collectionsPrelude__apply3268(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_x = getfromclosure(closure, 0);
  Object *var_t = getfromclosure(closure, 1);
  Object *var_jump = getfromclosure(closure, 2);
  Object *var_s = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1499
  setline(1499);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_x (depth = 6)
  int op_slot_right_3270 = gc_frame_newslot(*var_x);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3272 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe3273 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_t (depth = 9)
  gc_frame_newslot(*var_t);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3274 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3275 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3274);
// compiled call node returning call3275 (depth = 10)
// compiled member node returning call3275 (depth = 9)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3276 = callmethod(call3275, "at",
    1, partcv, params);
  gc_frame_end(callframe3273);
// compiled call node returning call3276 (depth = 8)
  partcv[0] = 0;
  Object call3277 = callmethod(call3276, "key",
    1, partcv, params);
  gc_frame_end(callframe3272);
// compiled call node returning call3277 (depth = 7)
// compiled member node returning call3277 (depth = 6)
  int op_slot_left_3270 = gc_frame_newslot(call3277);
  params[0] = *var_x;
  partcv[0] = 1;
  Object opresult3278 = callmethod(call3277, "==", 1, partcv, params);
// compiled op node returning opresult3278 (depth = 5)
  Object if3269 = done;
  if (istrue(opresult3278)) {
// Begin line 1500
  setline(1500);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  block_return(realself, *var_t);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if3269 = undefined;
  } else {
  }
// compiled if node returning if3269 (depth = 4)
// Begin line 1502
  setline(1502);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num3281 = alloc_Float64(0);
// compiled num node returning num3281 (depth = 6)
  int op_slot_right_3280 = gc_frame_newslot(num3281);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_jump (depth = 6)
  int op_slot_left_3280 = gc_frame_newslot(*var_jump);
  params[0] = num3281;
  partcv[0] = 1;
  Object opresult3283 = callmethod(*var_jump, "!=", 1, partcv, params);
// compiled op node returning opresult3283 (depth = 5)
  Object if3279 = done;
  if (istrue(opresult3283)) {
// Begin line 1503
  setline(1503);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_3284 = gc_frame_newslot(*var_s);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num3287 = alloc_Float64(1);
// compiled num node returning num3287 (depth = 8)
  int op_slot_right_3286 = gc_frame_newslot(num3287);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3290 = alloc_Float64(3);
// compiled num node returning num3290 (depth = 9)
  int op_slot_right_3289 = gc_frame_newslot(num3290);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_t (depth = 9)
  int op_slot_left_3289 = gc_frame_newslot(*var_t);
  params[0] = num3290;
  partcv[0] = 1;
  Object prod3292 = callmethod(*var_t, "*", 1, partcv, params);
// compiled op node returning prod3292 (depth = 8)
  int op_slot_left_3286 = gc_frame_newslot(prod3292);
  params[0] = num3287;
  partcv[0] = 1;
  Object sum3293 = callmethod(prod3292, "+", 1, partcv, params);
// compiled op node returning sum3293 (depth = 7)
  int op_slot_left_3284 = gc_frame_newslot(sum3293);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus3294 = callmethod(sum3293, "%", 1, partcv, params);
// compiled op node returning modulus3294 (depth = 6)
  *var_t = modulus3294;
  if (modulus3294 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1504
  setline(1504);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num3297 = alloc_Float64(1);
// compiled num node returning num3297 (depth = 7)
  int op_slot_right_3296 = gc_frame_newslot(num3297);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_jump (depth = 7)
  int op_slot_left_3296 = gc_frame_newslot(*var_jump);
  params[0] = num3297;
  partcv[0] = 1;
  Object diff3299 = callmethod(*var_jump, "-", 1, partcv, params);
// compiled op node returning diff3299 (depth = 6)
  *var_jump = diff3299;
  if (diff3299 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if3279 = done;
  } else {
// Begin line 1506
  setline(1506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_3301 = gc_frame_newslot(*var_s);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num3304 = alloc_Float64(1);
// compiled num node returning num3304 (depth = 8)
  int op_slot_right_3303 = gc_frame_newslot(num3304);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  int op_slot_left_3303 = gc_frame_newslot(*var_t);
  params[0] = num3304;
  partcv[0] = 1;
  Object sum3306 = callmethod(*var_t, "+", 1, partcv, params);
// compiled op node returning sum3306 (depth = 7)
  int op_slot_left_3301 = gc_frame_newslot(sum3306);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus3307 = callmethod(sum3306, "%", 1, partcv, params);
// compiled op node returning modulus3307 (depth = 6)
  *var_t = modulus3307;
  if (modulus3307 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if3279 = done;
  }
// compiled if node returning if3279 (depth = 4)
  gc_frame_end(frame);
  return if3279;
}
Object meth_collectionsPrelude_findPosition3243(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(6, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "findPosition");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method findPosition");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for findPosition (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for findPosition");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_h = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "h");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
  Object *var_t = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "t");
  Object *var_jump = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "jump");
// Begin line 1494
  setline(1494);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3244 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_x (depth = 5)
  partcv[0] = 0;
  Object call3245 = callmethod(*var_x, "hash",
    1, partcv, params);
  gc_frame_end(callframe3244);
// compiled call node returning call3245 (depth = 4)
// compiled member node returning call3245 (depth = 3)
  *var_h = call3245;
  if (call3245 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1495
  setline(1495);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3246 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3247 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3248 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3247);
// compiled call node returning call3248 (depth = 6)
// compiled member node returning call3248 (depth = 5)
  partcv[0] = 0;
  Object call3249 = callmethod(call3248, "size",
    1, partcv, params);
  gc_frame_end(callframe3246);
// compiled call node returning call3249 (depth = 4)
// compiled member node returning call3249 (depth = 3)
  *var_s = call3249;
  if (call3249 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1496
  setline(1496);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_right_3250 = gc_frame_newslot(*var_s);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_h (depth = 4)
  int op_slot_left_3250 = gc_frame_newslot(*var_h);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus3252 = callmethod(*var_h, "%", 1, partcv, params);
// compiled op node returning modulus3252 (depth = 3)
  *var_t = modulus3252;
  if (modulus3252 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1497
  setline(1497);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num3253 = alloc_Float64(5);
// compiled num node returning num3253 (depth = 3)
  *var_jump = num3253;
  if (num3253 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1498
  setline(1498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3254 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block3255 = alloc_Block(NULL, NULL, "collectionsPrelude", 1498);
  gc_frame_newslot(block3255);
// method _apply
  block_savedest(block3255);
  Object closure3256 = createclosure(2, "_apply");
  setclosureframe(closure3256, stackframe);
  addtoclosure(closure3256, var_t);
  addtoclosure(closure3256, selfslot);
  struct UserObject *uo3256 = (struct UserObject*)block3255;
  uo3256->data[0] = (Object)closure3256;
  Method *meth_meth_collectionsPrelude__apply3256 = addmethod2pos(block3255, "_apply", &meth_collectionsPrelude__apply3256, 0);
  int argcv_meth_collectionsPrelude__apply3256[] = {0};
  meth_meth_collectionsPrelude__apply3256->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply3256);
  meth_meth_collectionsPrelude__apply3256->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply3256->definitionLine = 1495;
// compiled block node returning block3255 (depth = 3)
  gc_frame_newslot(block3255);
// starting to compile block node (depth = 3)
  Object block3267 = alloc_Block(NULL, NULL, "collectionsPrelude", 1498);
  gc_frame_newslot(block3267);
// method _apply
  block_savedest(block3267);
  Object closure3268 = createclosure(5, "_apply");
  setclosureframe(closure3268, stackframe);
  addtoclosure(closure3268, var_x);
  addtoclosure(closure3268, var_t);
  addtoclosure(closure3268, var_jump);
  addtoclosure(closure3268, var_s);
  addtoclosure(closure3268, selfslot);
  struct UserObject *uo3268 = (struct UserObject*)block3267;
  uo3268->data[0] = (Object)closure3268;
  Method *meth_meth_collectionsPrelude__apply3268 = addmethod2pos(block3267, "_apply", &meth_collectionsPrelude__apply3268, 0);
  int argcv_meth_collectionsPrelude__apply3268[] = {0};
  meth_meth_collectionsPrelude__apply3268->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply3268);
  meth_meth_collectionsPrelude__apply3268->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply3268->definitionLine = 1498;
// compiled block node returning block3267 (depth = 3)
  gc_frame_newslot(block3267);
// call case 5: prelude request
  params[0] = block3255;
  params[1] = block3267;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3310 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3254);
// compiled call node returning call3310 (depth = 2)
// Begin line 1509
  setline(1509);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_t (depth = 3)
  return *var_t;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply3327(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_t = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3329 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3330 = callmethodflags(self, "removed", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3329);
// compiled call node returning call3330 (depth = 8)
// compiled member node returning call3330 (depth = 7)
  int op_slot_right_3328 = gc_frame_newslot(call3330);
// starting to compile call node (depth = 7)
  int callframe3332 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  gc_frame_newslot(*var_t);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3333 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3334 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3333);
// compiled call node returning call3334 (depth = 9)
// compiled member node returning call3334 (depth = 8)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3335 = callmethod(call3334, "at",
    1, partcv, params);
  gc_frame_end(callframe3332);
// compiled call node returning call3335 (depth = 7)
  int op_slot_left_3328 = gc_frame_newslot(call3335);
  params[0] = call3330;
  partcv[0] = 1;
  Object opresult3336 = callmethod(call3335, "!=", 1, partcv, params);
// compiled op node returning opresult3336 (depth = 6)
  gc_frame_end(frame);
  return opresult3336;
}
Object meth_collectionsPrelude__apply3324(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_t = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe3325 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block3326 = alloc_Block(NULL, NULL, "collectionsPrelude", 1516);
  gc_frame_newslot(block3326);
// method _apply
  block_savedest(block3326);
  Object closure3327 = createclosure(2, "_apply");
  setclosureframe(closure3327, stackframe);
  addtoclosure(closure3327, var_t);
  addtoclosure(closure3327, selfslot);
  struct UserObject *uo3327 = (struct UserObject*)block3326;
  uo3327->data[0] = (Object)closure3327;
  Method *meth_meth_collectionsPrelude__apply3327 = addmethod2pos(block3326, "_apply", &meth_collectionsPrelude__apply3327, 0);
  int argcv_meth_collectionsPrelude__apply3327[] = {0};
  meth_meth_collectionsPrelude__apply3327->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply3327);
  meth_meth_collectionsPrelude__apply3327->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply3327->definitionLine = 1513;
// compiled block node returning block3326 (depth = 5)
  gc_frame_newslot(block3326);
// call case 6: other member request
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3339 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3340 = callmethodflags(self, "unused", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3339);
// compiled call node returning call3340 (depth = 7)
// compiled member node returning call3340 (depth = 6)
  int op_slot_right_3338 = gc_frame_newslot(call3340);
// starting to compile call node (depth = 6)
  int callframe3342 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_t (depth = 7)
  gc_frame_newslot(*var_t);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3343 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3344 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3343);
// compiled call node returning call3344 (depth = 8)
// compiled member node returning call3344 (depth = 7)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3345 = callmethod(call3344, "at",
    1, partcv, params);
  gc_frame_end(callframe3342);
// compiled call node returning call3345 (depth = 6)
  int op_slot_left_3338 = gc_frame_newslot(call3345);
  params[0] = call3340;
  partcv[0] = 1;
  Object opresult3346 = callmethod(call3345, "!=", 1, partcv, params);
// compiled op node returning opresult3346 (depth = 5)
  params[0] = block3326;
  partcv[0] = 1;
  Object call3347 = callmethod(opresult3346, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe3325);
// compiled call node returning call3347 (depth = 4)
  gc_frame_end(frame);
  return call3347;
}
Object meth_collectionsPrelude__apply3350(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_x = getfromclosure(closure, 0);
  Object *var_t = getfromclosure(closure, 1);
  Object *var_jump = getfromclosure(closure, 2);
  Object *var_s = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1517
  setline(1517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_x (depth = 6)
  int op_slot_right_3352 = gc_frame_newslot(*var_x);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3354 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe3355 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_t (depth = 9)
  gc_frame_newslot(*var_t);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3356 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3357 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3356);
// compiled call node returning call3357 (depth = 10)
// compiled member node returning call3357 (depth = 9)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3358 = callmethod(call3357, "at",
    1, partcv, params);
  gc_frame_end(callframe3355);
// compiled call node returning call3358 (depth = 8)
  partcv[0] = 0;
  Object call3359 = callmethod(call3358, "key",
    1, partcv, params);
  gc_frame_end(callframe3354);
// compiled call node returning call3359 (depth = 7)
// compiled member node returning call3359 (depth = 6)
  int op_slot_left_3352 = gc_frame_newslot(call3359);
  params[0] = *var_x;
  partcv[0] = 1;
  Object opresult3360 = callmethod(call3359, "==", 1, partcv, params);
// compiled op node returning opresult3360 (depth = 5)
  Object if3351 = done;
  if (istrue(opresult3360)) {
// Begin line 1518
  setline(1518);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  block_return(realself, *var_t);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if3351 = undefined;
  } else {
  }
// compiled if node returning if3351 (depth = 4)
// Begin line 1520
  setline(1520);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num3363 = alloc_Float64(0);
// compiled num node returning num3363 (depth = 6)
  int op_slot_right_3362 = gc_frame_newslot(num3363);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_jump (depth = 6)
  int op_slot_left_3362 = gc_frame_newslot(*var_jump);
  params[0] = num3363;
  partcv[0] = 1;
  Object opresult3365 = callmethod(*var_jump, "!=", 1, partcv, params);
// compiled op node returning opresult3365 (depth = 5)
  Object if3361 = done;
  if (istrue(opresult3365)) {
// Begin line 1521
  setline(1521);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_3366 = gc_frame_newslot(*var_s);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num3369 = alloc_Float64(1);
// compiled num node returning num3369 (depth = 8)
  int op_slot_right_3368 = gc_frame_newslot(num3369);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3372 = alloc_Float64(3);
// compiled num node returning num3372 (depth = 9)
  int op_slot_right_3371 = gc_frame_newslot(num3372);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_t (depth = 9)
  int op_slot_left_3371 = gc_frame_newslot(*var_t);
  params[0] = num3372;
  partcv[0] = 1;
  Object prod3374 = callmethod(*var_t, "*", 1, partcv, params);
// compiled op node returning prod3374 (depth = 8)
  int op_slot_left_3368 = gc_frame_newslot(prod3374);
  params[0] = num3369;
  partcv[0] = 1;
  Object sum3375 = callmethod(prod3374, "+", 1, partcv, params);
// compiled op node returning sum3375 (depth = 7)
  int op_slot_left_3366 = gc_frame_newslot(sum3375);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus3376 = callmethod(sum3375, "%", 1, partcv, params);
// compiled op node returning modulus3376 (depth = 6)
  *var_t = modulus3376;
  if (modulus3376 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1522
  setline(1522);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num3379 = alloc_Float64(1);
// compiled num node returning num3379 (depth = 7)
  int op_slot_right_3378 = gc_frame_newslot(num3379);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_jump (depth = 7)
  int op_slot_left_3378 = gc_frame_newslot(*var_jump);
  params[0] = num3379;
  partcv[0] = 1;
  Object diff3381 = callmethod(*var_jump, "-", 1, partcv, params);
// compiled op node returning diff3381 (depth = 6)
  *var_jump = diff3381;
  if (diff3381 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if3361 = done;
  } else {
// Begin line 1524
  setline(1524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_3383 = gc_frame_newslot(*var_s);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num3386 = alloc_Float64(1);
// compiled num node returning num3386 (depth = 8)
  int op_slot_right_3385 = gc_frame_newslot(num3386);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  int op_slot_left_3385 = gc_frame_newslot(*var_t);
  params[0] = num3386;
  partcv[0] = 1;
  Object sum3388 = callmethod(*var_t, "+", 1, partcv, params);
// compiled op node returning sum3388 (depth = 7)
  int op_slot_left_3383 = gc_frame_newslot(sum3388);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus3389 = callmethod(sum3388, "%", 1, partcv, params);
// compiled op node returning modulus3389 (depth = 6)
  *var_t = modulus3389;
  if (modulus3389 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if3361 = done;
  }
// compiled if node returning if3361 (depth = 4)
  gc_frame_end(frame);
  return if3361;
}
Object meth_collectionsPrelude_findPositionForAdd3311(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(6, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "findPositionForAdd");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method findPositionForAdd");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for findPositionForAdd (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for findPositionForAdd");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_h = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "h");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
  Object *var_t = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "t");
  Object *var_jump = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "jump");
// Begin line 1512
  setline(1512);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3312 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_x (depth = 5)
  partcv[0] = 0;
  Object call3313 = callmethod(*var_x, "hash",
    1, partcv, params);
  gc_frame_end(callframe3312);
// compiled call node returning call3313 (depth = 4)
// compiled member node returning call3313 (depth = 3)
  *var_h = call3313;
  if (call3313 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1513
  setline(1513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3314 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3315 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3316 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3315);
// compiled call node returning call3316 (depth = 6)
// compiled member node returning call3316 (depth = 5)
  partcv[0] = 0;
  Object call3317 = callmethod(call3316, "size",
    1, partcv, params);
  gc_frame_end(callframe3314);
// compiled call node returning call3317 (depth = 4)
// compiled member node returning call3317 (depth = 3)
  *var_s = call3317;
  if (call3317 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1514
  setline(1514);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_right_3318 = gc_frame_newslot(*var_s);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_h (depth = 4)
  int op_slot_left_3318 = gc_frame_newslot(*var_h);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus3320 = callmethod(*var_h, "%", 1, partcv, params);
// compiled op node returning modulus3320 (depth = 3)
  *var_t = modulus3320;
  if (modulus3320 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1515
  setline(1515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num3321 = alloc_Float64(5);
// compiled num node returning num3321 (depth = 3)
  *var_jump = num3321;
  if (num3321 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1516
  setline(1516);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3322 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block3323 = alloc_Block(NULL, NULL, "collectionsPrelude", 1516);
  gc_frame_newslot(block3323);
// method _apply
  block_savedest(block3323);
  Object closure3324 = createclosure(2, "_apply");
  setclosureframe(closure3324, stackframe);
  addtoclosure(closure3324, var_t);
  addtoclosure(closure3324, selfslot);
  struct UserObject *uo3324 = (struct UserObject*)block3323;
  uo3324->data[0] = (Object)closure3324;
  Method *meth_meth_collectionsPrelude__apply3324 = addmethod2pos(block3323, "_apply", &meth_collectionsPrelude__apply3324, 0);
  int argcv_meth_collectionsPrelude__apply3324[] = {0};
  meth_meth_collectionsPrelude__apply3324->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply3324);
  meth_meth_collectionsPrelude__apply3324->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply3324->definitionLine = 1513;
// compiled block node returning block3323 (depth = 3)
  gc_frame_newslot(block3323);
// starting to compile block node (depth = 3)
  Object block3349 = alloc_Block(NULL, NULL, "collectionsPrelude", 1516);
  gc_frame_newslot(block3349);
// method _apply
  block_savedest(block3349);
  Object closure3350 = createclosure(5, "_apply");
  setclosureframe(closure3350, stackframe);
  addtoclosure(closure3350, var_x);
  addtoclosure(closure3350, var_t);
  addtoclosure(closure3350, var_jump);
  addtoclosure(closure3350, var_s);
  addtoclosure(closure3350, selfslot);
  struct UserObject *uo3350 = (struct UserObject*)block3349;
  uo3350->data[0] = (Object)closure3350;
  Method *meth_meth_collectionsPrelude__apply3350 = addmethod2pos(block3349, "_apply", &meth_collectionsPrelude__apply3350, 0);
  int argcv_meth_collectionsPrelude__apply3350[] = {0};
  meth_meth_collectionsPrelude__apply3350->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply3350);
  meth_meth_collectionsPrelude__apply3350->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply3350->definitionLine = 1516;
// compiled block node returning block3349 (depth = 3)
  gc_frame_newslot(block3349);
// call case 5: prelude request
  params[0] = block3323;
  params[1] = block3349;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3392 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3322);
// compiled call node returning call3392 (depth = 2)
// Begin line 1527
  setline(1527);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_t (depth = 3)
  return *var_t;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply3410(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_firstElement = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_a = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "a");
// Begin line 1535
  setline(1535);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3411 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3412 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3413 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3412);
// compiled call node returning call3413 (depth = 7)
// compiled member node returning call3413 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call3414 = callmethod(call3413, "at",
    1, partcv, params);
  gc_frame_end(callframe3411);
// compiled call node returning call3414 (depth = 5)
  *var_a = call3414;
  if (call3414 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1536
  setline(1536);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3418 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3419 = callmethodflags(self, "removed", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3418);
// compiled call node returning call3419 (depth = 8)
// compiled member node returning call3419 (depth = 7)
  int op_slot_right_3417 = gc_frame_newslot(call3419);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_left_3417 = gc_frame_newslot(*var_a);
  params[0] = call3419;
  partcv[0] = 1;
  Object opresult3421 = callmethod(*var_a, "!=", 1, partcv, params);
// compiled op node returning opresult3421 (depth = 6)
  int op_slot_right_3416 = gc_frame_newslot(opresult3421);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3424 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3425 = callmethodflags(self, "unused", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3424);
// compiled call node returning call3425 (depth = 8)
// compiled member node returning call3425 (depth = 7)
  int op_slot_right_3423 = gc_frame_newslot(call3425);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_left_3423 = gc_frame_newslot(*var_a);
  params[0] = call3425;
  partcv[0] = 1;
  Object opresult3427 = callmethod(*var_a, "!=", 1, partcv, params);
// compiled op node returning opresult3427 (depth = 6)
  int op_slot_left_3416 = gc_frame_newslot(opresult3427);
  params[0] = opresult3421;
  partcv[0] = 1;
  Object opresult3428 = callmethod(opresult3427, "&&", 1, partcv, params);
// compiled op node returning opresult3428 (depth = 5)
  Object if3415 = done;
  if (istrue(opresult3428)) {
// Begin line 1537
  setline(1537);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3430 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_firstElement (depth = 7)
  partcv[0] = 0;
  Object call3431 = callmethod(*var_firstElement, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe3430);
// compiled call node returning call3431 (depth = 6)
  Object if3429 = done;
  if (istrue(call3431)) {
// Begin line 1538
  setline(1538);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3433 == NULL) {
    strlit3433 = alloc_String(", ");
    gc_root(strlit3433);
  }
// compiled string node returning strlit3433 (depth = 8)
  int op_slot_right_3432 = gc_frame_newslot(strlit3433);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_3432 = gc_frame_newslot(*var_s);
  params[0] = strlit3433;
  partcv[0] = 1;
  Object opresult3435 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3435 (depth = 7)
  *var_s = opresult3435;
  if (opresult3435 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if3429 = done;
  } else {
// Begin line 1540
  setline(1540);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool3437 = alloc_Boolean(0);
// compiled identifier node returning bool3437 (depth = 7)
  *var_firstElement = bool3437;
  if (bool3437 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if3429 = done;
  }
// compiled if node returning if3429 (depth = 5)
// Begin line 1542
  setline(1542);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3441 == NULL) {
    strlit3441 = alloc_String("");
    gc_root(strlit3441);
  }
// compiled string node returning strlit3441 (depth = 8)
  int op_slot_right_3440 = gc_frame_newslot(strlit3441);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3444 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_a (depth = 11)
  partcv[0] = 0;
  Object call3445 = callmethod(*var_a, "value",
    1, partcv, params);
  gc_frame_end(callframe3444);
// compiled call node returning call3445 (depth = 10)
// compiled member node returning call3445 (depth = 9)
  int op_slot_right_3443 = gc_frame_newslot(call3445);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3448 == NULL) {
    strlit3448 = alloc_String("::");
    gc_root(strlit3448);
  }
// compiled string node returning strlit3448 (depth = 10)
  int op_slot_right_3447 = gc_frame_newslot(strlit3448);
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3451 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_a (depth = 13)
  partcv[0] = 0;
  Object call3452 = callmethod(*var_a, "key",
    1, partcv, params);
  gc_frame_end(callframe3451);
// compiled call node returning call3452 (depth = 12)
// compiled member node returning call3452 (depth = 11)
  int op_slot_right_3450 = gc_frame_newslot(call3452);
// starting to compile string node (depth = 11)
  if (strlit3454 == NULL) {
    strlit3454 = alloc_String("");
    gc_root(strlit3454);
  }
// compiled string node returning strlit3454 (depth = 11)
  int op_slot_left_3450 = gc_frame_newslot(strlit3454);
  params[0] = call3452;
  partcv[0] = 1;
  Object opresult3455 = callmethod(strlit3454, "++", 1, partcv, params);
// compiled op node returning opresult3455 (depth = 10)
  int op_slot_left_3447 = gc_frame_newslot(opresult3455);
  params[0] = strlit3448;
  partcv[0] = 1;
  Object opresult3456 = callmethod(opresult3455, "++", 1, partcv, params);
// compiled op node returning opresult3456 (depth = 9)
  int op_slot_left_3443 = gc_frame_newslot(opresult3456);
  params[0] = call3445;
  partcv[0] = 1;
  Object opresult3457 = callmethod(opresult3456, "++", 1, partcv, params);
// compiled op node returning opresult3457 (depth = 8)
  int op_slot_left_3440 = gc_frame_newslot(opresult3457);
  params[0] = strlit3441;
  partcv[0] = 1;
  Object opresult3458 = callmethod(opresult3457, "++", 1, partcv, params);
// compiled op node returning opresult3458 (depth = 7)
  int op_slot_right_3439 = gc_frame_newslot(opresult3458);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_3439 = gc_frame_newslot(*var_s);
  params[0] = opresult3458;
  partcv[0] = 1;
  Object opresult3460 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3460 (depth = 6)
  *var_s = opresult3460;
  if (opresult3460 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if3415 = done;
  } else {
  }
// compiled if node returning if3415 (depth = 4)
  gc_frame_end(frame);
  return if3415;
}
Object meth_collectionsPrelude_asString3393(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
  Object *var_firstElement = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "firstElement");
// Begin line 1532
  setline(1532);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit3394 == NULL) {
    strlit3394 = alloc_String("dict""\xe2""""\x9f""""\xac""");
    gc_root(strlit3394);
  }
// compiled string node returning strlit3394 (depth = 3)
  *var_s = strlit3394;
  if (strlit3394 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1533
  setline(1533);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool3395 = alloc_Boolean(1);
// compiled identifier node returning bool3395 (depth = 3)
  *var_firstElement = bool3395;
  if (bool3395 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1534
  setline(1534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3396 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3399 = alloc_Float64(1);
// compiled num node returning num3399 (depth = 5)
  int op_slot_right_3398 = gc_frame_newslot(num3399);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3401 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3402 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3403 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3402);
// compiled call node returning call3403 (depth = 8)
// compiled member node returning call3403 (depth = 7)
  partcv[0] = 0;
  Object call3404 = callmethod(call3403, "size",
    1, partcv, params);
  gc_frame_end(callframe3401);
// compiled call node returning call3404 (depth = 6)
// compiled member node returning call3404 (depth = 5)
  int op_slot_left_3398 = gc_frame_newslot(call3404);
  params[0] = num3399;
  partcv[0] = 1;
  Object diff3405 = callmethod(call3404, "-", 1, partcv, params);
// compiled op node returning diff3405 (depth = 4)
  int op_slot_right_3397 = gc_frame_newslot(diff3405);
// starting to compile num node (depth = 4)
  Object num3407 = alloc_Float64(0);
// compiled num node returning num3407 (depth = 4)
  int op_slot_left_3397 = gc_frame_newslot(num3407);
  params[0] = diff3405;
  partcv[0] = 1;
  Object opresult3408 = callmethod(num3407, "..", 1, partcv, params);
// compiled op node returning opresult3408 (depth = 3)
  gc_frame_newslot(opresult3408);
// starting to compile block node (depth = 3)
  Object block3409 = alloc_Block(NULL, NULL, "collectionsPrelude", 1534);
  gc_frame_newslot(block3409);
// method _apply
  block_savedest(block3409);
  Object closure3410 = createclosure(3, "_apply");
  setclosureframe(closure3410, stackframe);
  addtoclosure(closure3410, var_firstElement);
  addtoclosure(closure3410, var_s);
  addtoclosure(closure3410, selfslot);
  struct UserObject *uo3410 = (struct UserObject*)block3409;
  uo3410->data[0] = (Object)closure3410;
  Method *meth_meth_collectionsPrelude__apply3410 = addmethod2pos(block3409, "_apply", &meth_collectionsPrelude__apply3410, 0);
  int argcv_meth_collectionsPrelude__apply3410[] = {1};
  meth_meth_collectionsPrelude__apply3410->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply3410);
  meth_meth_collectionsPrelude__apply3410->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply3410->definitionLine = 1534;
// compiled block node returning block3409 (depth = 3)
  gc_frame_newslot(block3409);
// call case 5: prelude request
  params[0] = opresult3408;
  params[1] = block3409;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3463 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3396);
// compiled call node returning call3463 (depth = 2)
// Begin line 1545
  setline(1545);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit3465 == NULL) {
    strlit3465 = alloc_String("""\xe2""""\x9f""""\xad""");
    gc_root(strlit3465);
  }
// compiled string node returning strlit3465 (depth = 3)
  int op_slot_right_3464 = gc_frame_newslot(strlit3465);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  int op_slot_left_3464 = gc_frame_newslot(*var_s);
  params[0] = strlit3465;
  partcv[0] = 1;
  Object opresult3467 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3467 (depth = 2)
  gc_frame_end(frame);
  return opresult3467;
}
Object meth_collectionsPrelude__apply3484(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_a = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "a");
// Begin line 1550
  setline(1550);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num3487 = alloc_Float64(0);
// compiled num node returning num3487 (depth = 6)
  int op_slot_right_3486 = gc_frame_newslot(num3487);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_3486 = gc_frame_newslot(*var_i);
  params[0] = num3487;
  partcv[0] = 1;
  Object opresult3489 = callmethod(*var_i, ">", 1, partcv, params);
// compiled op node returning opresult3489 (depth = 5)
  Object if3485 = done;
  if (istrue(opresult3489)) {
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3491 == NULL) {
    strlit3491 = alloc_String(", ");
    gc_root(strlit3491);
  }
// compiled string node returning strlit3491 (depth = 7)
  int op_slot_right_3490 = gc_frame_newslot(strlit3491);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_3490 = gc_frame_newslot(*var_s);
  params[0] = strlit3491;
  partcv[0] = 1;
  Object opresult3493 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3493 (depth = 6)
  *var_s = opresult3493;
  if (opresult3493 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if3485 = done;
  } else {
  }
// compiled if node returning if3485 (depth = 4)
// Begin line 1551
  setline(1551);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3495 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3496 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3497 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3496);
// compiled call node returning call3497 (depth = 7)
// compiled member node returning call3497 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call3498 = callmethod(call3497, "at",
    1, partcv, params);
  gc_frame_end(callframe3495);
// compiled call node returning call3498 (depth = 5)
  *var_a = call3498;
  if (call3498 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1552
  setline(1552);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3502 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3503 = callmethodflags(self, "removed", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3502);
// compiled call node returning call3503 (depth = 8)
// compiled member node returning call3503 (depth = 7)
  int op_slot_right_3501 = gc_frame_newslot(call3503);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_left_3501 = gc_frame_newslot(*var_a);
  params[0] = call3503;
  partcv[0] = 1;
  Object opresult3505 = callmethod(*var_a, "!=", 1, partcv, params);
// compiled op node returning opresult3505 (depth = 6)
  int op_slot_right_3500 = gc_frame_newslot(opresult3505);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3508 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3509 = callmethodflags(self, "unused", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3508);
// compiled call node returning call3509 (depth = 8)
// compiled member node returning call3509 (depth = 7)
  int op_slot_right_3507 = gc_frame_newslot(call3509);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_left_3507 = gc_frame_newslot(*var_a);
  params[0] = call3509;
  partcv[0] = 1;
  Object opresult3511 = callmethod(*var_a, "!=", 1, partcv, params);
// compiled op node returning opresult3511 (depth = 6)
  int op_slot_left_3500 = gc_frame_newslot(opresult3511);
  params[0] = opresult3505;
  partcv[0] = 1;
  Object opresult3512 = callmethod(opresult3511, "&&", 1, partcv, params);
// compiled op node returning opresult3512 (depth = 5)
  Object if3499 = done;
  if (istrue(opresult3512)) {
// Begin line 1553
  setline(1553);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3515 == NULL) {
    strlit3515 = alloc_String("");
    gc_root(strlit3515);
  }
// compiled string node returning strlit3515 (depth = 8)
  int op_slot_right_3514 = gc_frame_newslot(strlit3515);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3518 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_a (depth = 11)
  partcv[0] = 0;
  Object call3519 = callmethod(*var_a, "value",
    1, partcv, params);
  gc_frame_end(callframe3518);
// compiled call node returning call3519 (depth = 10)
// compiled member node returning call3519 (depth = 9)
  int op_slot_right_3517 = gc_frame_newslot(call3519);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3522 == NULL) {
    strlit3522 = alloc_String("::");
    gc_root(strlit3522);
  }
// compiled string node returning strlit3522 (depth = 10)
  int op_slot_right_3521 = gc_frame_newslot(strlit3522);
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3525 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_a (depth = 13)
  partcv[0] = 0;
  Object call3526 = callmethod(*var_a, "key",
    1, partcv, params);
  gc_frame_end(callframe3525);
// compiled call node returning call3526 (depth = 12)
// compiled member node returning call3526 (depth = 11)
  int op_slot_right_3524 = gc_frame_newslot(call3526);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit3529 == NULL) {
    strlit3529 = alloc_String("""\xe2""""\x86""""\x92""");
    gc_root(strlit3529);
  }
// compiled string node returning strlit3529 (depth = 12)
  int op_slot_right_3528 = gc_frame_newslot(strlit3529);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_i (depth = 13)
  int op_slot_right_3531 = gc_frame_newslot(*var_i);
// starting to compile string node (depth = 13)
  if (strlit3533 == NULL) {
    strlit3533 = alloc_String("");
    gc_root(strlit3533);
  }
// compiled string node returning strlit3533 (depth = 13)
  int op_slot_left_3531 = gc_frame_newslot(strlit3533);
  params[0] = *var_i;
  partcv[0] = 1;
  Object opresult3534 = callmethod(strlit3533, "++", 1, partcv, params);
// compiled op node returning opresult3534 (depth = 12)
  int op_slot_left_3528 = gc_frame_newslot(opresult3534);
  params[0] = strlit3529;
  partcv[0] = 1;
  Object opresult3535 = callmethod(opresult3534, "++", 1, partcv, params);
// compiled op node returning opresult3535 (depth = 11)
  int op_slot_left_3524 = gc_frame_newslot(opresult3535);
  params[0] = call3526;
  partcv[0] = 1;
  Object opresult3536 = callmethod(opresult3535, "++", 1, partcv, params);
// compiled op node returning opresult3536 (depth = 10)
  int op_slot_left_3521 = gc_frame_newslot(opresult3536);
  params[0] = strlit3522;
  partcv[0] = 1;
  Object opresult3537 = callmethod(opresult3536, "++", 1, partcv, params);
// compiled op node returning opresult3537 (depth = 9)
  int op_slot_left_3517 = gc_frame_newslot(opresult3537);
  params[0] = call3519;
  partcv[0] = 1;
  Object opresult3538 = callmethod(opresult3537, "++", 1, partcv, params);
// compiled op node returning opresult3538 (depth = 8)
  int op_slot_left_3514 = gc_frame_newslot(opresult3538);
  params[0] = strlit3515;
  partcv[0] = 1;
  Object opresult3539 = callmethod(opresult3538, "++", 1, partcv, params);
// compiled op node returning opresult3539 (depth = 7)
  int op_slot_right_3513 = gc_frame_newslot(opresult3539);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_3513 = gc_frame_newslot(*var_s);
  params[0] = opresult3539;
  partcv[0] = 1;
  Object opresult3541 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3541 (depth = 6)
  *var_s = opresult3541;
  if (opresult3541 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if3499 = done;
  } else {
// Begin line 1555
  setline(1555);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3545 == NULL) {
    strlit3545 = alloc_String("");
    gc_root(strlit3545);
  }
// compiled string node returning strlit3545 (depth = 8)
  int op_slot_right_3544 = gc_frame_newslot(strlit3545);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3548 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_a (depth = 11)
  partcv[0] = 0;
  Object call3549 = callmethod(*var_a, "asDebugString",
    1, partcv, params);
  gc_frame_end(callframe3548);
// compiled call node returning call3549 (depth = 10)
// compiled member node returning call3549 (depth = 9)
  int op_slot_right_3547 = gc_frame_newslot(call3549);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3552 == NULL) {
    strlit3552 = alloc_String("""\xe2""""\x86""""\x92""");
    gc_root(strlit3552);
  }
// compiled string node returning strlit3552 (depth = 10)
  int op_slot_right_3551 = gc_frame_newslot(strlit3552);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_i (depth = 11)
  int op_slot_right_3554 = gc_frame_newslot(*var_i);
// starting to compile string node (depth = 11)
  if (strlit3556 == NULL) {
    strlit3556 = alloc_String("");
    gc_root(strlit3556);
  }
// compiled string node returning strlit3556 (depth = 11)
  int op_slot_left_3554 = gc_frame_newslot(strlit3556);
  params[0] = *var_i;
  partcv[0] = 1;
  Object opresult3557 = callmethod(strlit3556, "++", 1, partcv, params);
// compiled op node returning opresult3557 (depth = 10)
  int op_slot_left_3551 = gc_frame_newslot(opresult3557);
  params[0] = strlit3552;
  partcv[0] = 1;
  Object opresult3558 = callmethod(opresult3557, "++", 1, partcv, params);
// compiled op node returning opresult3558 (depth = 9)
  int op_slot_left_3547 = gc_frame_newslot(opresult3558);
  params[0] = call3549;
  partcv[0] = 1;
  Object opresult3559 = callmethod(opresult3558, "++", 1, partcv, params);
// compiled op node returning opresult3559 (depth = 8)
  int op_slot_left_3544 = gc_frame_newslot(opresult3559);
  params[0] = strlit3545;
  partcv[0] = 1;
  Object opresult3560 = callmethod(opresult3559, "++", 1, partcv, params);
// compiled op node returning opresult3560 (depth = 7)
  int op_slot_right_3543 = gc_frame_newslot(opresult3560);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_3543 = gc_frame_newslot(*var_s);
  params[0] = opresult3560;
  partcv[0] = 1;
  Object opresult3562 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3562 (depth = 6)
  *var_s = opresult3562;
  if (opresult3562 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if3499 = done;
  }
// compiled if node returning if3499 (depth = 4)
  gc_frame_end(frame);
  return if3499;
}
Object meth_collectionsPrelude_asDebugString3468(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asDebugString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asDebugString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
// Begin line 1548
  setline(1548);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit3469 == NULL) {
    strlit3469 = alloc_String("dict""\xe2""""\x9f""""\xac""");
    gc_root(strlit3469);
  }
// compiled string node returning strlit3469 (depth = 3)
  *var_s = strlit3469;
  if (strlit3469 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1549
  setline(1549);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3470 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3473 = alloc_Float64(1);
// compiled num node returning num3473 (depth = 5)
  int op_slot_right_3472 = gc_frame_newslot(num3473);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3475 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3476 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3477 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3476);
// compiled call node returning call3477 (depth = 8)
// compiled member node returning call3477 (depth = 7)
  partcv[0] = 0;
  Object call3478 = callmethod(call3477, "size",
    1, partcv, params);
  gc_frame_end(callframe3475);
// compiled call node returning call3478 (depth = 6)
// compiled member node returning call3478 (depth = 5)
  int op_slot_left_3472 = gc_frame_newslot(call3478);
  params[0] = num3473;
  partcv[0] = 1;
  Object diff3479 = callmethod(call3478, "-", 1, partcv, params);
// compiled op node returning diff3479 (depth = 4)
  int op_slot_right_3471 = gc_frame_newslot(diff3479);
// starting to compile num node (depth = 4)
  Object num3481 = alloc_Float64(0);
// compiled num node returning num3481 (depth = 4)
  int op_slot_left_3471 = gc_frame_newslot(num3481);
  params[0] = diff3479;
  partcv[0] = 1;
  Object opresult3482 = callmethod(num3481, "..", 1, partcv, params);
// compiled op node returning opresult3482 (depth = 3)
  gc_frame_newslot(opresult3482);
// starting to compile block node (depth = 3)
  Object block3483 = alloc_Block(NULL, NULL, "collectionsPrelude", 1549);
  gc_frame_newslot(block3483);
// method _apply
  block_savedest(block3483);
  Object closure3484 = createclosure(2, "_apply");
  setclosureframe(closure3484, stackframe);
  addtoclosure(closure3484, var_s);
  addtoclosure(closure3484, selfslot);
  struct UserObject *uo3484 = (struct UserObject*)block3483;
  uo3484->data[0] = (Object)closure3484;
  Method *meth_meth_collectionsPrelude__apply3484 = addmethod2pos(block3483, "_apply", &meth_collectionsPrelude__apply3484, 0);
  int argcv_meth_collectionsPrelude__apply3484[] = {1};
  meth_meth_collectionsPrelude__apply3484->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply3484);
  meth_meth_collectionsPrelude__apply3484->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply3484->definitionLine = 1549;
// compiled block node returning block3483 (depth = 3)
  gc_frame_newslot(block3483);
// call case 5: prelude request
  params[0] = opresult3482;
  params[1] = block3483;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3565 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3470);
// compiled call node returning call3565 (depth = 2)
// Begin line 1558
  setline(1558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit3567 == NULL) {
    strlit3567 = alloc_String("""\xe2""""\x9f""""\xad""");
    gc_root(strlit3567);
  }
// compiled string node returning strlit3567 (depth = 3)
  int op_slot_right_3566 = gc_frame_newslot(strlit3567);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  int op_slot_left_3566 = gc_frame_newslot(*var_s);
  params[0] = strlit3567;
  partcv[0] = 1;
  Object opresult3569 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3569 (depth = 2)
  gc_frame_end(frame);
  return opresult3569;
}
Object meth_collectionsPrelude_hasNext3577(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for hasNext (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for hasNext");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1566
  setline(1566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3578 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3579 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3580 = callmethodflags(self, "sourceIterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3579);
// compiled call node returning call3580 (depth = 5)
// compiled member node returning call3580 (depth = 4)
  partcv[0] = 0;
  Object call3581 = callmethod(call3580, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe3578);
// compiled call node returning call3581 (depth = 3)
// compiled member node returning call3581 (depth = 2)
  gc_frame_end(frame);
  return call3581;
}
Object meth_collectionsPrelude_next3582(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for next (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for next");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1567
  setline(1567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3583 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3584 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3585 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3586 = callmethodflags(self, "sourceIterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3585);
// compiled call node returning call3586 (depth = 7)
// compiled member node returning call3586 (depth = 6)
  partcv[0] = 0;
  Object call3587 = callmethod(call3586, "next",
    1, partcv, params);
  gc_frame_end(callframe3584);
// compiled call node returning call3587 (depth = 5)
// compiled member node returning call3587 (depth = 4)
  partcv[0] = 0;
  Object call3588 = callmethod(call3587, "key",
    1, partcv, params);
  gc_frame_end(callframe3583);
// compiled call node returning call3588 (depth = 3)
// compiled member node returning call3588 (depth = 2)
  gc_frame_end(frame);
  return call3588;
}
Object meth_collectionsPrelude_asString3589(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sourceDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1569
  setline(1569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit3591 == NULL) {
    strlit3591 = alloc_String("");
    gc_root(strlit3591);
  }
// compiled string node returning strlit3591 (depth = 3)
  int op_slot_right_3590 = gc_frame_newslot(strlit3591);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sourceDictionary (depth = 4)
  int op_slot_right_3593 = gc_frame_newslot(*var_sourceDictionary);
// starting to compile string node (depth = 4)
  if (strlit3595 == NULL) {
    strlit3595 = alloc_String("an iterator over keys of ");
    gc_root(strlit3595);
  }
// compiled string node returning strlit3595 (depth = 4)
  int op_slot_left_3593 = gc_frame_newslot(strlit3595);
  params[0] = *var_sourceDictionary;
  partcv[0] = 1;
  Object opresult3596 = callmethod(strlit3595, "++", 1, partcv, params);
// compiled op node returning opresult3596 (depth = 3)
  int op_slot_left_3590 = gc_frame_newslot(opresult3596);
  params[0] = strlit3591;
  partcv[0] = 1;
  Object opresult3597 = callmethod(opresult3596, "++", 1, partcv, params);
// compiled op node returning opresult3597 (depth = 2)
  gc_frame_end(frame);
  return opresult3597;
}
Object meth_collectionsPrelude_iterator3573(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sourceDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3574 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3574 = alloc_userobj2(4,5, objclass3574);
  gc_frame_newslot(obj3574);
if (objclass3574 == NULL) {
  glfree(obj3574->class->name);
  obj3574->class->name = "obj3571.iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3574, self, 0);
  addmethodreal(obj3574,"outer", &reader_collectionsPrelude_outer_3575);
  Object oldself3574 = self;
  struct StackFrameObject *oldstackframe3574 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3574);
  gc_frame_newslot((Object)stackframe);
  self = obj3574;
  Object *oldselfslot3574 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3574 = (*(struct UserObject *)self).data[0], lowerouter3574 = thisouter3574;
  if (inheritingObject3574) {
    struct UserObject *inho3574 = (struct UserObject *)inheritingObject3574;
    while (inho3574->super != GraceDefaultObject) inho3574 = (struct UserObject *)inho3574->super;
    inho3574->super = obj3574;
    self = inheritingObject3574;
    *selfslot = self;
    lowerouter3574 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3574;
  }
if (objclass3574 == NULL) {
  Method *reader3576 = addmethodrealflags(obj3574, "sourceIterator",&reader_collectionsPrelude_sourceIterator_3576, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader3576->definitionModule = modulename;
  reader3576->definitionLine = 1565;
}
adddatum2(obj3574, alloc_Undefined(), 1);
// method hasNext
  struct UserObject *uo3577 = (struct UserObject*)obj3574;
  uo3577->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext3577 = addmethod2pos(obj3574, "hasNext", &meth_collectionsPrelude_hasNext3577, 2);
  int argcv_meth_collectionsPrelude_hasNext3577[] = {0};
  meth_meth_collectionsPrelude_hasNext3577->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext3577);
  meth_meth_collectionsPrelude_hasNext3577->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext3577->definitionLine = 1566;
// method next
  struct UserObject *uo3582 = (struct UserObject*)obj3574;
  uo3582->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_next3582 = addmethod2pos(obj3574, "next", &meth_collectionsPrelude_next3582, 3);
  int argcv_meth_collectionsPrelude_next3582[] = {0};
  meth_meth_collectionsPrelude_next3582->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next3582);
  meth_meth_collectionsPrelude_next3582->definitionModule = modulename;
  meth_meth_collectionsPrelude_next3582->definitionLine = 1567;
// method asString
  block_savedest(obj3574);
  Object closure3589 = createclosure(1, "asString");
  setclosureframe(closure3589, stackframe);
  addtoclosure(closure3589, var_sourceDictionary);
  struct UserObject *uo3589 = (struct UserObject*)obj3574;
  uo3589->data[4] = (Object)closure3589;
  Method *meth_meth_collectionsPrelude_asString3589 = addmethod2pos(obj3574, "asString", &meth_collectionsPrelude_asString3589, 4);
  int argcv_meth_collectionsPrelude_asString3589[] = {0};
  meth_meth_collectionsPrelude_asString3589->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString3589);
  meth_meth_collectionsPrelude_asString3589->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString3589->definitionLine = 1568;
  sourceObject = obj3574;
// Begin line 1565
  setline(1565);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3598 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sourceDictionary (depth = 4)
  partcv[0] = 0;
  Object call3599 = callmethod(*var_sourceDictionary, "bindingsIterator",
    1, partcv, params);
  gc_frame_end(callframe3598);
// compiled call node returning call3599 (depth = 3)
// compiled member node returning call3599 (depth = 2)
  adddatum2(obj3574, call3599, 1);
  sourceObject = obj3574;
  sourceObject = obj3574;
  sourceObject = obj3574;
  objclass3574 = obj3574->class;
  objclass3574->definitionModule = modulename;
  objclass3574->definitionLine = 1564;
  (*(struct UserObject *)self).data[0] = lowerouter3574;
  self = oldself3574;
  selfslot = oldselfslot3574;
  stackframe = oldstackframe3574;
  gc_frame_end(frame);
  return obj3574;
}
Object meth_collectionsPrelude_iterator3573_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_sourceDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3574 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3574 = alloc_userobj2(4,5, objclass3574);
  gc_frame_newslot(obj3574);
if (objclass3574 == NULL) {
  glfree(obj3574->class->name);
  obj3574->class->name = "obj3571.iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3574, self, 0);
  addmethodreal(obj3574,"outer", &reader_collectionsPrelude_outer_3575);
  Object oldself3574 = self;
  struct StackFrameObject *oldstackframe3574 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3574);
  gc_frame_newslot((Object)stackframe);
  self = obj3574;
  Object *oldselfslot3574 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3574 = (*(struct UserObject *)self).data[0], lowerouter3574 = thisouter3574;
  if (inheritingObject3574) {
    struct UserObject *inho3574 = (struct UserObject *)inheritingObject3574;
    while (inho3574->super != GraceDefaultObject) inho3574 = (struct UserObject *)inho3574->super;
    inho3574->super = obj3574;
    self = inheritingObject3574;
    *selfslot = self;
    lowerouter3574 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3574;
  }
if (objclass3574 == NULL) {
  Method *reader3576 = addmethodrealflags(obj3574, "sourceIterator",&reader_collectionsPrelude_sourceIterator_3576, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader3576->definitionModule = modulename;
  reader3576->definitionLine = 1565;
}
adddatum2(obj3574, alloc_Undefined(), 1);
// method hasNext
  struct UserObject *uo3577 = (struct UserObject*)obj3574;
  uo3577->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext3577 = addmethod2pos(obj3574, "hasNext", &meth_collectionsPrelude_hasNext3577, 2);
  int argcv_meth_collectionsPrelude_hasNext3577[] = {0};
  meth_meth_collectionsPrelude_hasNext3577->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext3577);
  meth_meth_collectionsPrelude_hasNext3577->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext3577->definitionLine = 1566;
// method next
  struct UserObject *uo3582 = (struct UserObject*)obj3574;
  uo3582->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_next3582 = addmethod2pos(obj3574, "next", &meth_collectionsPrelude_next3582, 3);
  int argcv_meth_collectionsPrelude_next3582[] = {0};
  meth_meth_collectionsPrelude_next3582->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next3582);
  meth_meth_collectionsPrelude_next3582->definitionModule = modulename;
  meth_meth_collectionsPrelude_next3582->definitionLine = 1567;
// method asString
  block_savedest(obj3574);
  Object closure3589 = createclosure(1, "asString");
  setclosureframe(closure3589, stackframe);
  addtoclosure(closure3589, var_sourceDictionary);
  struct UserObject *uo3589 = (struct UserObject*)obj3574;
  uo3589->data[4] = (Object)closure3589;
  Method *meth_meth_collectionsPrelude_asString3589 = addmethod2pos(obj3574, "asString", &meth_collectionsPrelude_asString3589, 4);
  int argcv_meth_collectionsPrelude_asString3589[] = {0};
  meth_meth_collectionsPrelude_asString3589->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString3589);
  meth_meth_collectionsPrelude_asString3589->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString3589->definitionLine = 1568;
  sourceObject = obj3574;
// Begin line 1565
  setline(1565);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3598 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sourceDictionary (depth = 4)
  partcv[0] = 0;
  Object call3599 = callmethod(*var_sourceDictionary, "bindingsIterator",
    1, partcv, params);
  gc_frame_end(callframe3598);
// compiled call node returning call3599 (depth = 3)
// compiled member node returning call3599 (depth = 2)
  adddatum2(obj3574, call3599, 1);
  sourceObject = obj3574;
  sourceObject = obj3574;
  sourceObject = obj3574;
  objclass3574 = obj3574->class;
  objclass3574->definitionModule = modulename;
  objclass3574->definitionLine = 1564;
  (*(struct UserObject *)self).data[0] = lowerouter3574;
  self = oldself3574;
  selfslot = oldselfslot3574;
  stackframe = oldstackframe3574;
  gc_frame_end(frame);
  return obj3574;
}
Object meth_collectionsPrelude_asDebugString3602(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sourceDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asDebugString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asDebugString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1574
  setline(1574);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit3604 == NULL) {
    strlit3604 = alloc_String("");
    gc_root(strlit3604);
  }
// compiled string node returning strlit3604 (depth = 3)
  int op_slot_right_3603 = gc_frame_newslot(strlit3604);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sourceDictionary (depth = 4)
  int op_slot_right_3606 = gc_frame_newslot(*var_sourceDictionary);
// starting to compile string node (depth = 4)
  if (strlit3608 == NULL) {
    strlit3608 = alloc_String("a lazy sequence over keys of ");
    gc_root(strlit3608);
  }
// compiled string node returning strlit3608 (depth = 4)
  int op_slot_left_3606 = gc_frame_newslot(strlit3608);
  params[0] = *var_sourceDictionary;
  partcv[0] = 1;
  Object opresult3609 = callmethod(strlit3608, "++", 1, partcv, params);
// compiled op node returning opresult3609 (depth = 3)
  int op_slot_left_3603 = gc_frame_newslot(opresult3609);
  params[0] = strlit3604;
  partcv[0] = 1;
  Object opresult3610 = callmethod(opresult3609, "++", 1, partcv, params);
// compiled op node returning opresult3610 (depth = 2)
  gc_frame_end(frame);
  return opresult3610;
}
Object meth_collectionsPrelude_keys3570(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 23, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "keys");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for keys (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for keys");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sourceDictionary = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sourceDictionary");
// Begin line 1561
  setline(1561);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  *var_sourceDictionary = self;
  if (self == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3571 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3571 = alloc_userobj2(5,6, objclass3571);
  gc_frame_newslot(obj3571);
if (objclass3571 == NULL) {
  glfree(obj3571->class->name);
  obj3571->class->name = "obj2985.keys";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3571, self, 0);
  addmethodreal(obj3571,"outer", &reader_collectionsPrelude_outer_3572);
  Object oldself3571 = self;
  struct StackFrameObject *oldstackframe3571 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3571);
  gc_frame_newslot((Object)stackframe);
  self = obj3571;
  Object *oldselfslot3571 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3571 = (*(struct UserObject *)self).data[0], lowerouter3571 = thisouter3571;
  if (inheritingObject3571) {
    struct UserObject *inho3571 = (struct UserObject *)inheritingObject3571;
    while (inho3571->super != GraceDefaultObject) inho3571 = (struct UserObject *)inho3571->super;
    inho3571->super = obj3571;
    self = inheritingObject3571;
    *selfslot = self;
    lowerouter3571 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3571;
  }
// method iterator
  block_savedest(obj3571);
  Object closure3573 = createclosure(1, "iterator");
  setclosureframe(closure3573, stackframe);
  addtoclosure(closure3573, var_sourceDictionary);
  struct UserObject *uo3573 = (struct UserObject*)obj3571;
  uo3573->data[1] = (Object)closure3573;
  Method *meth_meth_collectionsPrelude_iterator3573 = addmethod2pos(obj3571, "iterator", &meth_collectionsPrelude_iterator3573, 1);
  int argcv_meth_collectionsPrelude_iterator3573[] = {0};
  meth_meth_collectionsPrelude_iterator3573->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator3573);
  meth_meth_collectionsPrelude_iterator3573->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator3573->definitionLine = 1564;
  block_savedest(obj3571);
  Object closure3600 = createclosure(1, "iterator()object");
  setclosureframe(closure3600, stackframe);
  addtoclosure(closure3600, var_sourceDictionary);
  Method *meth_meth_collectionsPrelude_iterator3573_object = addmethod2pos(obj3571, "iterator()object", &meth_collectionsPrelude_iterator3573_object, 1);
  meth_meth_collectionsPrelude_iterator3573_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator3573_object->definitionLine = 1564;
if (objclass3571 == NULL) {
  Method *reader3601 = addmethodrealflags(obj3571, "size",&reader_collectionsPrelude_size_3601, MFLAG_DEF);
  reader3601->definitionModule = modulename;
  reader3601->definitionLine = 1572;
}
adddatum2(obj3571, alloc_Undefined(), 2);
// method asDebugString
  block_savedest(obj3571);
  Object closure3602 = createclosure(1, "asDebugString");
  setclosureframe(closure3602, stackframe);
  addtoclosure(closure3602, var_sourceDictionary);
  struct UserObject *uo3602 = (struct UserObject*)obj3571;
  uo3602->data[3] = (Object)closure3602;
  Method *meth_meth_collectionsPrelude_asDebugString3602 = addmethod2pos(obj3571, "asDebugString", &meth_collectionsPrelude_asDebugString3602, 3);
  int argcv_meth_collectionsPrelude_asDebugString3602[] = {0};
  meth_meth_collectionsPrelude_asDebugString3602->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString3602);
  meth_meth_collectionsPrelude_asDebugString3602->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString3602->definitionLine = 1573;
  sourceObject = obj3571;
// Begin line 1563
  setline(1563);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3611 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3612 = callmethod(*var_enumerable, "trait()object",
    2, partcv, params);
  gc_frame_end(callframe3611);
// compiled call node returning call3612 (depth = 2)
  struct UserObject *obj3571_uo = (struct UserObject *)obj3571;
  obj3571_uo->super = call3612;
  sourceObject = obj3571;
  sourceObject = obj3571;
// Begin line 1572
  setline(1572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3613 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sourceDictionary (depth = 4)
  partcv[0] = 0;
  Object call3614 = callmethod(*var_sourceDictionary, "size",
    1, partcv, params);
  gc_frame_end(callframe3613);
// compiled call node returning call3614 (depth = 3)
// compiled member node returning call3614 (depth = 2)
  adddatum2(obj3571, call3614, 2);
  sourceObject = obj3571;
  objclass3571 = obj3571->class;
  objclass3571->definitionModule = modulename;
  objclass3571->definitionLine = 1562;
  (*(struct UserObject *)self).data[0] = lowerouter3571;
  self = oldself3571;
  selfslot = oldselfslot3571;
  stackframe = oldstackframe3571;
  gc_frame_end(frame);
  return obj3571;
}
Object meth_collectionsPrelude_keys3570_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 23, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "keys()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for keys (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for keys");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sourceDictionary = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sourceDictionary");
// Begin line 1561
  setline(1561);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  *var_sourceDictionary = self;
  if (self == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3571 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3571 = alloc_userobj2(5,6, objclass3571);
  gc_frame_newslot(obj3571);
if (objclass3571 == NULL) {
  glfree(obj3571->class->name);
  obj3571->class->name = "obj2985.keys";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3571, self, 0);
  addmethodreal(obj3571,"outer", &reader_collectionsPrelude_outer_3572);
  Object oldself3571 = self;
  struct StackFrameObject *oldstackframe3571 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3571);
  gc_frame_newslot((Object)stackframe);
  self = obj3571;
  Object *oldselfslot3571 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3571 = (*(struct UserObject *)self).data[0], lowerouter3571 = thisouter3571;
  if (inheritingObject3571) {
    struct UserObject *inho3571 = (struct UserObject *)inheritingObject3571;
    while (inho3571->super != GraceDefaultObject) inho3571 = (struct UserObject *)inho3571->super;
    inho3571->super = obj3571;
    self = inheritingObject3571;
    *selfslot = self;
    lowerouter3571 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3571;
  }
// method iterator
  block_savedest(obj3571);
  Object closure3573 = createclosure(1, "iterator");
  setclosureframe(closure3573, stackframe);
  addtoclosure(closure3573, var_sourceDictionary);
  struct UserObject *uo3573 = (struct UserObject*)obj3571;
  uo3573->data[1] = (Object)closure3573;
  Method *meth_meth_collectionsPrelude_iterator3573 = addmethod2pos(obj3571, "iterator", &meth_collectionsPrelude_iterator3573, 1);
  int argcv_meth_collectionsPrelude_iterator3573[] = {0};
  meth_meth_collectionsPrelude_iterator3573->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator3573);
  meth_meth_collectionsPrelude_iterator3573->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator3573->definitionLine = 1564;
  block_savedest(obj3571);
  Object closure3600 = createclosure(1, "iterator()object");
  setclosureframe(closure3600, stackframe);
  addtoclosure(closure3600, var_sourceDictionary);
  Method *meth_meth_collectionsPrelude_iterator3573_object = addmethod2pos(obj3571, "iterator()object", &meth_collectionsPrelude_iterator3573_object, 1);
  meth_meth_collectionsPrelude_iterator3573_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator3573_object->definitionLine = 1564;
if (objclass3571 == NULL) {
  Method *reader3601 = addmethodrealflags(obj3571, "size",&reader_collectionsPrelude_size_3601, MFLAG_DEF);
  reader3601->definitionModule = modulename;
  reader3601->definitionLine = 1572;
}
adddatum2(obj3571, alloc_Undefined(), 2);
// method asDebugString
  block_savedest(obj3571);
  Object closure3602 = createclosure(1, "asDebugString");
  setclosureframe(closure3602, stackframe);
  addtoclosure(closure3602, var_sourceDictionary);
  struct UserObject *uo3602 = (struct UserObject*)obj3571;
  uo3602->data[3] = (Object)closure3602;
  Method *meth_meth_collectionsPrelude_asDebugString3602 = addmethod2pos(obj3571, "asDebugString", &meth_collectionsPrelude_asDebugString3602, 3);
  int argcv_meth_collectionsPrelude_asDebugString3602[] = {0};
  meth_meth_collectionsPrelude_asDebugString3602->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString3602);
  meth_meth_collectionsPrelude_asDebugString3602->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString3602->definitionLine = 1573;
  sourceObject = obj3571;
// Begin line 1563
  setline(1563);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3611 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3612 = callmethod(*var_enumerable, "trait()object",
    2, partcv, params);
  gc_frame_end(callframe3611);
// compiled call node returning call3612 (depth = 2)
  struct UserObject *obj3571_uo = (struct UserObject *)obj3571;
  obj3571_uo->super = call3612;
  sourceObject = obj3571;
  sourceObject = obj3571;
// Begin line 1572
  setline(1572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3613 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sourceDictionary (depth = 4)
  partcv[0] = 0;
  Object call3614 = callmethod(*var_sourceDictionary, "size",
    1, partcv, params);
  gc_frame_end(callframe3613);
// compiled call node returning call3614 (depth = 3)
// compiled member node returning call3614 (depth = 2)
  adddatum2(obj3571, call3614, 2);
  sourceObject = obj3571;
  objclass3571 = obj3571->class;
  objclass3571->definitionModule = modulename;
  objclass3571->definitionLine = 1562;
  (*(struct UserObject *)self).data[0] = lowerouter3571;
  self = oldself3571;
  selfslot = oldselfslot3571;
  stackframe = oldstackframe3571;
  gc_frame_end(frame);
  return obj3571;
}
Object meth_collectionsPrelude_hasNext3623(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for hasNext (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for hasNext");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1585
  setline(1585);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3624 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3625 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3626 = callmethodflags(self, "sourceIterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3625);
// compiled call node returning call3626 (depth = 5)
// compiled member node returning call3626 (depth = 4)
  partcv[0] = 0;
  Object call3627 = callmethod(call3626, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe3624);
// compiled call node returning call3627 (depth = 3)
// compiled member node returning call3627 (depth = 2)
  gc_frame_end(frame);
  return call3627;
}
Object meth_collectionsPrelude_next3628(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for next (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for next");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1586
  setline(1586);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3629 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3630 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3631 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3632 = callmethodflags(self, "sourceIterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3631);
// compiled call node returning call3632 (depth = 7)
// compiled member node returning call3632 (depth = 6)
  partcv[0] = 0;
  Object call3633 = callmethod(call3632, "next",
    1, partcv, params);
  gc_frame_end(callframe3630);
// compiled call node returning call3633 (depth = 5)
// compiled member node returning call3633 (depth = 4)
  partcv[0] = 0;
  Object call3634 = callmethod(call3633, "value",
    1, partcv, params);
  gc_frame_end(callframe3629);
// compiled call node returning call3634 (depth = 3)
// compiled member node returning call3634 (depth = 2)
  gc_frame_end(frame);
  return call3634;
}
Object meth_collectionsPrelude_asString3635(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sourceDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1588
  setline(1588);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit3637 == NULL) {
    strlit3637 = alloc_String("");
    gc_root(strlit3637);
  }
// compiled string node returning strlit3637 (depth = 3)
  int op_slot_right_3636 = gc_frame_newslot(strlit3637);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sourceDictionary (depth = 4)
  int op_slot_right_3639 = gc_frame_newslot(*var_sourceDictionary);
// starting to compile string node (depth = 4)
  if (strlit3641 == NULL) {
    strlit3641 = alloc_String("an iterator over values of ");
    gc_root(strlit3641);
  }
// compiled string node returning strlit3641 (depth = 4)
  int op_slot_left_3639 = gc_frame_newslot(strlit3641);
  params[0] = *var_sourceDictionary;
  partcv[0] = 1;
  Object opresult3642 = callmethod(strlit3641, "++", 1, partcv, params);
// compiled op node returning opresult3642 (depth = 3)
  int op_slot_left_3636 = gc_frame_newslot(opresult3642);
  params[0] = strlit3637;
  partcv[0] = 1;
  Object opresult3643 = callmethod(opresult3642, "++", 1, partcv, params);
// compiled op node returning opresult3643 (depth = 2)
  gc_frame_end(frame);
  return opresult3643;
}
Object meth_collectionsPrelude_iterator3619(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sourceDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3620 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3620 = alloc_userobj2(4,5, objclass3620);
  gc_frame_newslot(obj3620);
if (objclass3620 == NULL) {
  glfree(obj3620->class->name);
  obj3620->class->name = "obj3617.iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3620, self, 0);
  addmethodreal(obj3620,"outer", &reader_collectionsPrelude_outer_3621);
  Object oldself3620 = self;
  struct StackFrameObject *oldstackframe3620 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3620);
  gc_frame_newslot((Object)stackframe);
  self = obj3620;
  Object *oldselfslot3620 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3620 = (*(struct UserObject *)self).data[0], lowerouter3620 = thisouter3620;
  if (inheritingObject3620) {
    struct UserObject *inho3620 = (struct UserObject *)inheritingObject3620;
    while (inho3620->super != GraceDefaultObject) inho3620 = (struct UserObject *)inho3620->super;
    inho3620->super = obj3620;
    self = inheritingObject3620;
    *selfslot = self;
    lowerouter3620 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3620;
  }
if (objclass3620 == NULL) {
  Method *reader3622 = addmethodrealflags(obj3620, "sourceIterator",&reader_collectionsPrelude_sourceIterator_3622, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader3622->definitionModule = modulename;
  reader3622->definitionLine = 1583;
}
adddatum2(obj3620, alloc_Undefined(), 1);
// method hasNext
  struct UserObject *uo3623 = (struct UserObject*)obj3620;
  uo3623->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext3623 = addmethod2pos(obj3620, "hasNext", &meth_collectionsPrelude_hasNext3623, 2);
  int argcv_meth_collectionsPrelude_hasNext3623[] = {0};
  meth_meth_collectionsPrelude_hasNext3623->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext3623);
  meth_meth_collectionsPrelude_hasNext3623->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext3623->definitionLine = 1585;
// method next
  struct UserObject *uo3628 = (struct UserObject*)obj3620;
  uo3628->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_next3628 = addmethod2pos(obj3620, "next", &meth_collectionsPrelude_next3628, 3);
  int argcv_meth_collectionsPrelude_next3628[] = {0};
  meth_meth_collectionsPrelude_next3628->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next3628);
  meth_meth_collectionsPrelude_next3628->definitionModule = modulename;
  meth_meth_collectionsPrelude_next3628->definitionLine = 1586;
// method asString
  block_savedest(obj3620);
  Object closure3635 = createclosure(1, "asString");
  setclosureframe(closure3635, stackframe);
  addtoclosure(closure3635, var_sourceDictionary);
  struct UserObject *uo3635 = (struct UserObject*)obj3620;
  uo3635->data[4] = (Object)closure3635;
  Method *meth_meth_collectionsPrelude_asString3635 = addmethod2pos(obj3620, "asString", &meth_collectionsPrelude_asString3635, 4);
  int argcv_meth_collectionsPrelude_asString3635[] = {0};
  meth_meth_collectionsPrelude_asString3635->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString3635);
  meth_meth_collectionsPrelude_asString3635->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString3635->definitionLine = 1587;
  sourceObject = obj3620;
// Begin line 1583
  setline(1583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3644 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sourceDictionary (depth = 4)
  partcv[0] = 0;
  Object call3645 = callmethod(*var_sourceDictionary, "bindingsIterator",
    1, partcv, params);
  gc_frame_end(callframe3644);
// compiled call node returning call3645 (depth = 3)
// compiled member node returning call3645 (depth = 2)
  adddatum2(obj3620, call3645, 1);
  sourceObject = obj3620;
  sourceObject = obj3620;
  sourceObject = obj3620;
  objclass3620 = obj3620->class;
  objclass3620->definitionModule = modulename;
  objclass3620->definitionLine = 1582;
  (*(struct UserObject *)self).data[0] = lowerouter3620;
  self = oldself3620;
  selfslot = oldselfslot3620;
  stackframe = oldstackframe3620;
  gc_frame_end(frame);
  return obj3620;
}
Object meth_collectionsPrelude_iterator3619_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_sourceDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3620 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3620 = alloc_userobj2(4,5, objclass3620);
  gc_frame_newslot(obj3620);
if (objclass3620 == NULL) {
  glfree(obj3620->class->name);
  obj3620->class->name = "obj3617.iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3620, self, 0);
  addmethodreal(obj3620,"outer", &reader_collectionsPrelude_outer_3621);
  Object oldself3620 = self;
  struct StackFrameObject *oldstackframe3620 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3620);
  gc_frame_newslot((Object)stackframe);
  self = obj3620;
  Object *oldselfslot3620 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3620 = (*(struct UserObject *)self).data[0], lowerouter3620 = thisouter3620;
  if (inheritingObject3620) {
    struct UserObject *inho3620 = (struct UserObject *)inheritingObject3620;
    while (inho3620->super != GraceDefaultObject) inho3620 = (struct UserObject *)inho3620->super;
    inho3620->super = obj3620;
    self = inheritingObject3620;
    *selfslot = self;
    lowerouter3620 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3620;
  }
if (objclass3620 == NULL) {
  Method *reader3622 = addmethodrealflags(obj3620, "sourceIterator",&reader_collectionsPrelude_sourceIterator_3622, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader3622->definitionModule = modulename;
  reader3622->definitionLine = 1583;
}
adddatum2(obj3620, alloc_Undefined(), 1);
// method hasNext
  struct UserObject *uo3623 = (struct UserObject*)obj3620;
  uo3623->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext3623 = addmethod2pos(obj3620, "hasNext", &meth_collectionsPrelude_hasNext3623, 2);
  int argcv_meth_collectionsPrelude_hasNext3623[] = {0};
  meth_meth_collectionsPrelude_hasNext3623->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext3623);
  meth_meth_collectionsPrelude_hasNext3623->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext3623->definitionLine = 1585;
// method next
  struct UserObject *uo3628 = (struct UserObject*)obj3620;
  uo3628->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_next3628 = addmethod2pos(obj3620, "next", &meth_collectionsPrelude_next3628, 3);
  int argcv_meth_collectionsPrelude_next3628[] = {0};
  meth_meth_collectionsPrelude_next3628->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next3628);
  meth_meth_collectionsPrelude_next3628->definitionModule = modulename;
  meth_meth_collectionsPrelude_next3628->definitionLine = 1586;
// method asString
  block_savedest(obj3620);
  Object closure3635 = createclosure(1, "asString");
  setclosureframe(closure3635, stackframe);
  addtoclosure(closure3635, var_sourceDictionary);
  struct UserObject *uo3635 = (struct UserObject*)obj3620;
  uo3635->data[4] = (Object)closure3635;
  Method *meth_meth_collectionsPrelude_asString3635 = addmethod2pos(obj3620, "asString", &meth_collectionsPrelude_asString3635, 4);
  int argcv_meth_collectionsPrelude_asString3635[] = {0};
  meth_meth_collectionsPrelude_asString3635->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString3635);
  meth_meth_collectionsPrelude_asString3635->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString3635->definitionLine = 1587;
  sourceObject = obj3620;
// Begin line 1583
  setline(1583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3644 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sourceDictionary (depth = 4)
  partcv[0] = 0;
  Object call3645 = callmethod(*var_sourceDictionary, "bindingsIterator",
    1, partcv, params);
  gc_frame_end(callframe3644);
// compiled call node returning call3645 (depth = 3)
// compiled member node returning call3645 (depth = 2)
  adddatum2(obj3620, call3645, 1);
  sourceObject = obj3620;
  sourceObject = obj3620;
  sourceObject = obj3620;
  objclass3620 = obj3620->class;
  objclass3620->definitionModule = modulename;
  objclass3620->definitionLine = 1582;
  (*(struct UserObject *)self).data[0] = lowerouter3620;
  self = oldself3620;
  selfslot = oldselfslot3620;
  stackframe = oldstackframe3620;
  gc_frame_end(frame);
  return obj3620;
}
Object meth_collectionsPrelude_asDebugString3648(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sourceDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asDebugString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asDebugString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1593
  setline(1593);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit3650 == NULL) {
    strlit3650 = alloc_String("");
    gc_root(strlit3650);
  }
// compiled string node returning strlit3650 (depth = 3)
  int op_slot_right_3649 = gc_frame_newslot(strlit3650);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sourceDictionary (depth = 4)
  int op_slot_right_3652 = gc_frame_newslot(*var_sourceDictionary);
// starting to compile string node (depth = 4)
  if (strlit3654 == NULL) {
    strlit3654 = alloc_String("a lazy sequence over values of ");
    gc_root(strlit3654);
  }
// compiled string node returning strlit3654 (depth = 4)
  int op_slot_left_3652 = gc_frame_newslot(strlit3654);
  params[0] = *var_sourceDictionary;
  partcv[0] = 1;
  Object opresult3655 = callmethod(strlit3654, "++", 1, partcv, params);
// compiled op node returning opresult3655 (depth = 3)
  int op_slot_left_3649 = gc_frame_newslot(opresult3655);
  params[0] = strlit3650;
  partcv[0] = 1;
  Object opresult3656 = callmethod(opresult3655, "++", 1, partcv, params);
// compiled op node returning opresult3656 (depth = 2)
  gc_frame_end(frame);
  return opresult3656;
}
Object meth_collectionsPrelude_values3616(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 24, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "values");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for values (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for values");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sourceDictionary = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sourceDictionary");
// Begin line 1579
  setline(1579);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  *var_sourceDictionary = self;
  if (self == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3617 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3617 = alloc_userobj2(5,6, objclass3617);
  gc_frame_newslot(obj3617);
if (objclass3617 == NULL) {
  glfree(obj3617->class->name);
  obj3617->class->name = "obj2985.values";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3617, self, 0);
  addmethodreal(obj3617,"outer", &reader_collectionsPrelude_outer_3618);
  Object oldself3617 = self;
  struct StackFrameObject *oldstackframe3617 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3617);
  gc_frame_newslot((Object)stackframe);
  self = obj3617;
  Object *oldselfslot3617 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3617 = (*(struct UserObject *)self).data[0], lowerouter3617 = thisouter3617;
  if (inheritingObject3617) {
    struct UserObject *inho3617 = (struct UserObject *)inheritingObject3617;
    while (inho3617->super != GraceDefaultObject) inho3617 = (struct UserObject *)inho3617->super;
    inho3617->super = obj3617;
    self = inheritingObject3617;
    *selfslot = self;
    lowerouter3617 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3617;
  }
// method iterator
  block_savedest(obj3617);
  Object closure3619 = createclosure(1, "iterator");
  setclosureframe(closure3619, stackframe);
  addtoclosure(closure3619, var_sourceDictionary);
  struct UserObject *uo3619 = (struct UserObject*)obj3617;
  uo3619->data[1] = (Object)closure3619;
  Method *meth_meth_collectionsPrelude_iterator3619 = addmethod2pos(obj3617, "iterator", &meth_collectionsPrelude_iterator3619, 1);
  int argcv_meth_collectionsPrelude_iterator3619[] = {0};
  meth_meth_collectionsPrelude_iterator3619->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator3619);
  meth_meth_collectionsPrelude_iterator3619->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator3619->definitionLine = 1582;
  block_savedest(obj3617);
  Object closure3646 = createclosure(1, "iterator()object");
  setclosureframe(closure3646, stackframe);
  addtoclosure(closure3646, var_sourceDictionary);
  Method *meth_meth_collectionsPrelude_iterator3619_object = addmethod2pos(obj3617, "iterator()object", &meth_collectionsPrelude_iterator3619_object, 1);
  meth_meth_collectionsPrelude_iterator3619_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator3619_object->definitionLine = 1582;
if (objclass3617 == NULL) {
  Method *reader3647 = addmethodrealflags(obj3617, "size",&reader_collectionsPrelude_size_3647, MFLAG_DEF);
  reader3647->definitionModule = modulename;
  reader3647->definitionLine = 1591;
}
adddatum2(obj3617, alloc_Undefined(), 2);
// method asDebugString
  block_savedest(obj3617);
  Object closure3648 = createclosure(1, "asDebugString");
  setclosureframe(closure3648, stackframe);
  addtoclosure(closure3648, var_sourceDictionary);
  struct UserObject *uo3648 = (struct UserObject*)obj3617;
  uo3648->data[3] = (Object)closure3648;
  Method *meth_meth_collectionsPrelude_asDebugString3648 = addmethod2pos(obj3617, "asDebugString", &meth_collectionsPrelude_asDebugString3648, 3);
  int argcv_meth_collectionsPrelude_asDebugString3648[] = {0};
  meth_meth_collectionsPrelude_asDebugString3648->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString3648);
  meth_meth_collectionsPrelude_asDebugString3648->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString3648->definitionLine = 1592;
  sourceObject = obj3617;
// Begin line 1581
  setline(1581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3657 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3658 = callmethod(*var_enumerable, "trait()object",
    2, partcv, params);
  gc_frame_end(callframe3657);
// compiled call node returning call3658 (depth = 2)
  struct UserObject *obj3617_uo = (struct UserObject *)obj3617;
  obj3617_uo->super = call3658;
  sourceObject = obj3617;
  sourceObject = obj3617;
// Begin line 1591
  setline(1591);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3659 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sourceDictionary (depth = 4)
  partcv[0] = 0;
  Object call3660 = callmethod(*var_sourceDictionary, "size",
    1, partcv, params);
  gc_frame_end(callframe3659);
// compiled call node returning call3660 (depth = 3)
// compiled member node returning call3660 (depth = 2)
  adddatum2(obj3617, call3660, 2);
  sourceObject = obj3617;
  objclass3617 = obj3617->class;
  objclass3617->definitionModule = modulename;
  objclass3617->definitionLine = 1580;
  (*(struct UserObject *)self).data[0] = lowerouter3617;
  self = oldself3617;
  selfslot = oldselfslot3617;
  stackframe = oldstackframe3617;
  gc_frame_end(frame);
  return obj3617;
}
Object meth_collectionsPrelude_values3616_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 24, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "values()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for values (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for values");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sourceDictionary = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sourceDictionary");
// Begin line 1579
  setline(1579);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  *var_sourceDictionary = self;
  if (self == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3617 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3617 = alloc_userobj2(5,6, objclass3617);
  gc_frame_newslot(obj3617);
if (objclass3617 == NULL) {
  glfree(obj3617->class->name);
  obj3617->class->name = "obj2985.values";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3617, self, 0);
  addmethodreal(obj3617,"outer", &reader_collectionsPrelude_outer_3618);
  Object oldself3617 = self;
  struct StackFrameObject *oldstackframe3617 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3617);
  gc_frame_newslot((Object)stackframe);
  self = obj3617;
  Object *oldselfslot3617 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3617 = (*(struct UserObject *)self).data[0], lowerouter3617 = thisouter3617;
  if (inheritingObject3617) {
    struct UserObject *inho3617 = (struct UserObject *)inheritingObject3617;
    while (inho3617->super != GraceDefaultObject) inho3617 = (struct UserObject *)inho3617->super;
    inho3617->super = obj3617;
    self = inheritingObject3617;
    *selfslot = self;
    lowerouter3617 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3617;
  }
// method iterator
  block_savedest(obj3617);
  Object closure3619 = createclosure(1, "iterator");
  setclosureframe(closure3619, stackframe);
  addtoclosure(closure3619, var_sourceDictionary);
  struct UserObject *uo3619 = (struct UserObject*)obj3617;
  uo3619->data[1] = (Object)closure3619;
  Method *meth_meth_collectionsPrelude_iterator3619 = addmethod2pos(obj3617, "iterator", &meth_collectionsPrelude_iterator3619, 1);
  int argcv_meth_collectionsPrelude_iterator3619[] = {0};
  meth_meth_collectionsPrelude_iterator3619->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator3619);
  meth_meth_collectionsPrelude_iterator3619->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator3619->definitionLine = 1582;
  block_savedest(obj3617);
  Object closure3646 = createclosure(1, "iterator()object");
  setclosureframe(closure3646, stackframe);
  addtoclosure(closure3646, var_sourceDictionary);
  Method *meth_meth_collectionsPrelude_iterator3619_object = addmethod2pos(obj3617, "iterator()object", &meth_collectionsPrelude_iterator3619_object, 1);
  meth_meth_collectionsPrelude_iterator3619_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator3619_object->definitionLine = 1582;
if (objclass3617 == NULL) {
  Method *reader3647 = addmethodrealflags(obj3617, "size",&reader_collectionsPrelude_size_3647, MFLAG_DEF);
  reader3647->definitionModule = modulename;
  reader3647->definitionLine = 1591;
}
adddatum2(obj3617, alloc_Undefined(), 2);
// method asDebugString
  block_savedest(obj3617);
  Object closure3648 = createclosure(1, "asDebugString");
  setclosureframe(closure3648, stackframe);
  addtoclosure(closure3648, var_sourceDictionary);
  struct UserObject *uo3648 = (struct UserObject*)obj3617;
  uo3648->data[3] = (Object)closure3648;
  Method *meth_meth_collectionsPrelude_asDebugString3648 = addmethod2pos(obj3617, "asDebugString", &meth_collectionsPrelude_asDebugString3648, 3);
  int argcv_meth_collectionsPrelude_asDebugString3648[] = {0};
  meth_meth_collectionsPrelude_asDebugString3648->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString3648);
  meth_meth_collectionsPrelude_asDebugString3648->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString3648->definitionLine = 1592;
  sourceObject = obj3617;
// Begin line 1581
  setline(1581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3657 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3658 = callmethod(*var_enumerable, "trait()object",
    2, partcv, params);
  gc_frame_end(callframe3657);
// compiled call node returning call3658 (depth = 2)
  struct UserObject *obj3617_uo = (struct UserObject *)obj3617;
  obj3617_uo->super = call3658;
  sourceObject = obj3617;
  sourceObject = obj3617;
// Begin line 1591
  setline(1591);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3659 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sourceDictionary (depth = 4)
  partcv[0] = 0;
  Object call3660 = callmethod(*var_sourceDictionary, "size",
    1, partcv, params);
  gc_frame_end(callframe3659);
// compiled call node returning call3660 (depth = 3)
// compiled member node returning call3660 (depth = 2)
  adddatum2(obj3617, call3660, 2);
  sourceObject = obj3617;
  objclass3617 = obj3617->class;
  objclass3617->definitionModule = modulename;
  objclass3617->definitionLine = 1580;
  (*(struct UserObject *)self).data[0] = lowerouter3617;
  self = oldself3617;
  selfslot = oldselfslot3617;
  stackframe = oldstackframe3617;
  gc_frame_end(frame);
  return obj3617;
}
Object meth_collectionsPrelude_iterator3665(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sourceDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1601
  setline(1601);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3666 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sourceDictionary (depth = 4)
  partcv[0] = 0;
  Object call3667 = callmethod(*var_sourceDictionary, "bindingsIterator",
    1, partcv, params);
  gc_frame_end(callframe3666);
// compiled call node returning call3667 (depth = 3)
// compiled member node returning call3667 (depth = 2)
  gc_frame_end(frame);
  return call3667;
}
Object meth_collectionsPrelude_asDebugString3669(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sourceDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asDebugString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asDebugString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1605
  setline(1605);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit3671 == NULL) {
    strlit3671 = alloc_String("");
    gc_root(strlit3671);
  }
// compiled string node returning strlit3671 (depth = 3)
  int op_slot_right_3670 = gc_frame_newslot(strlit3671);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sourceDictionary (depth = 4)
  int op_slot_right_3673 = gc_frame_newslot(*var_sourceDictionary);
// starting to compile string node (depth = 4)
  if (strlit3675 == NULL) {
    strlit3675 = alloc_String("a lazy sequence over bindings of ");
    gc_root(strlit3675);
  }
// compiled string node returning strlit3675 (depth = 4)
  int op_slot_left_3673 = gc_frame_newslot(strlit3675);
  params[0] = *var_sourceDictionary;
  partcv[0] = 1;
  Object opresult3676 = callmethod(strlit3675, "++", 1, partcv, params);
// compiled op node returning opresult3676 (depth = 3)
  int op_slot_left_3670 = gc_frame_newslot(opresult3676);
  params[0] = strlit3671;
  partcv[0] = 1;
  Object opresult3677 = callmethod(opresult3676, "++", 1, partcv, params);
// compiled op node returning opresult3677 (depth = 2)
  gc_frame_end(frame);
  return opresult3677;
}
Object meth_collectionsPrelude_bindings3662(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 25, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "bindings");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for bindings (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for bindings");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sourceDictionary = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sourceDictionary");
// Begin line 1598
  setline(1598);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  *var_sourceDictionary = self;
  if (self == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3663 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3663 = alloc_userobj2(4,5, objclass3663);
  gc_frame_newslot(obj3663);
if (objclass3663 == NULL) {
  glfree(obj3663->class->name);
  obj3663->class->name = "obj2985.bindings";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3663, self, 0);
  addmethodreal(obj3663,"outer", &reader_collectionsPrelude_outer_3664);
  Object oldself3663 = self;
  struct StackFrameObject *oldstackframe3663 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3663);
  gc_frame_newslot((Object)stackframe);
  self = obj3663;
  Object *oldselfslot3663 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3663 = (*(struct UserObject *)self).data[0], lowerouter3663 = thisouter3663;
  if (inheritingObject3663) {
    struct UserObject *inho3663 = (struct UserObject *)inheritingObject3663;
    while (inho3663->super != GraceDefaultObject) inho3663 = (struct UserObject *)inho3663->super;
    inho3663->super = obj3663;
    self = inheritingObject3663;
    *selfslot = self;
    lowerouter3663 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3663;
  }
// method iterator
  block_savedest(obj3663);
  Object closure3665 = createclosure(1, "iterator");
  setclosureframe(closure3665, stackframe);
  addtoclosure(closure3665, var_sourceDictionary);
  struct UserObject *uo3665 = (struct UserObject*)obj3663;
  uo3665->data[1] = (Object)closure3665;
  Method *meth_meth_collectionsPrelude_iterator3665 = addmethod2pos(obj3663, "iterator", &meth_collectionsPrelude_iterator3665, 1);
  int argcv_meth_collectionsPrelude_iterator3665[] = {0};
  meth_meth_collectionsPrelude_iterator3665->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator3665);
  meth_meth_collectionsPrelude_iterator3665->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator3665->definitionLine = 1601;
if (objclass3663 == NULL) {
  Method *reader3668 = addmethodrealflags(obj3663, "size",&reader_collectionsPrelude_size_3668, MFLAG_DEF);
  reader3668->definitionModule = modulename;
  reader3668->definitionLine = 1603;
}
adddatum2(obj3663, alloc_Undefined(), 2);
// method asDebugString
  block_savedest(obj3663);
  Object closure3669 = createclosure(1, "asDebugString");
  setclosureframe(closure3669, stackframe);
  addtoclosure(closure3669, var_sourceDictionary);
  struct UserObject *uo3669 = (struct UserObject*)obj3663;
  uo3669->data[3] = (Object)closure3669;
  Method *meth_meth_collectionsPrelude_asDebugString3669 = addmethod2pos(obj3663, "asDebugString", &meth_collectionsPrelude_asDebugString3669, 3);
  int argcv_meth_collectionsPrelude_asDebugString3669[] = {0};
  meth_meth_collectionsPrelude_asDebugString3669->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString3669);
  meth_meth_collectionsPrelude_asDebugString3669->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString3669->definitionLine = 1604;
  sourceObject = obj3663;
// Begin line 1600
  setline(1600);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3678 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3679 = callmethod(*var_enumerable, "trait()object",
    2, partcv, params);
  gc_frame_end(callframe3678);
// compiled call node returning call3679 (depth = 2)
  struct UserObject *obj3663_uo = (struct UserObject *)obj3663;
  obj3663_uo->super = call3679;
  sourceObject = obj3663;
  sourceObject = obj3663;
// Begin line 1603
  setline(1603);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3680 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sourceDictionary (depth = 4)
  partcv[0] = 0;
  Object call3681 = callmethod(*var_sourceDictionary, "size",
    1, partcv, params);
  gc_frame_end(callframe3680);
// compiled call node returning call3681 (depth = 3)
// compiled member node returning call3681 (depth = 2)
  adddatum2(obj3663, call3681, 2);
  sourceObject = obj3663;
  objclass3663 = obj3663->class;
  objclass3663->definitionModule = modulename;
  objclass3663->definitionLine = 1599;
  (*(struct UserObject *)self).data[0] = lowerouter3663;
  self = oldself3663;
  selfslot = oldselfslot3663;
  stackframe = oldstackframe3663;
  gc_frame_end(frame);
  return obj3663;
}
Object meth_collectionsPrelude_bindings3662_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 25, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "bindings()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for bindings (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for bindings");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sourceDictionary = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sourceDictionary");
// Begin line 1598
  setline(1598);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  *var_sourceDictionary = self;
  if (self == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3663 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3663 = alloc_userobj2(4,5, objclass3663);
  gc_frame_newslot(obj3663);
if (objclass3663 == NULL) {
  glfree(obj3663->class->name);
  obj3663->class->name = "obj2985.bindings";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3663, self, 0);
  addmethodreal(obj3663,"outer", &reader_collectionsPrelude_outer_3664);
  Object oldself3663 = self;
  struct StackFrameObject *oldstackframe3663 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3663);
  gc_frame_newslot((Object)stackframe);
  self = obj3663;
  Object *oldselfslot3663 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3663 = (*(struct UserObject *)self).data[0], lowerouter3663 = thisouter3663;
  if (inheritingObject3663) {
    struct UserObject *inho3663 = (struct UserObject *)inheritingObject3663;
    while (inho3663->super != GraceDefaultObject) inho3663 = (struct UserObject *)inho3663->super;
    inho3663->super = obj3663;
    self = inheritingObject3663;
    *selfslot = self;
    lowerouter3663 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3663;
  }
// method iterator
  block_savedest(obj3663);
  Object closure3665 = createclosure(1, "iterator");
  setclosureframe(closure3665, stackframe);
  addtoclosure(closure3665, var_sourceDictionary);
  struct UserObject *uo3665 = (struct UserObject*)obj3663;
  uo3665->data[1] = (Object)closure3665;
  Method *meth_meth_collectionsPrelude_iterator3665 = addmethod2pos(obj3663, "iterator", &meth_collectionsPrelude_iterator3665, 1);
  int argcv_meth_collectionsPrelude_iterator3665[] = {0};
  meth_meth_collectionsPrelude_iterator3665->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator3665);
  meth_meth_collectionsPrelude_iterator3665->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator3665->definitionLine = 1601;
if (objclass3663 == NULL) {
  Method *reader3668 = addmethodrealflags(obj3663, "size",&reader_collectionsPrelude_size_3668, MFLAG_DEF);
  reader3668->definitionModule = modulename;
  reader3668->definitionLine = 1603;
}
adddatum2(obj3663, alloc_Undefined(), 2);
// method asDebugString
  block_savedest(obj3663);
  Object closure3669 = createclosure(1, "asDebugString");
  setclosureframe(closure3669, stackframe);
  addtoclosure(closure3669, var_sourceDictionary);
  struct UserObject *uo3669 = (struct UserObject*)obj3663;
  uo3669->data[3] = (Object)closure3669;
  Method *meth_meth_collectionsPrelude_asDebugString3669 = addmethod2pos(obj3663, "asDebugString", &meth_collectionsPrelude_asDebugString3669, 3);
  int argcv_meth_collectionsPrelude_asDebugString3669[] = {0};
  meth_meth_collectionsPrelude_asDebugString3669->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString3669);
  meth_meth_collectionsPrelude_asDebugString3669->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString3669->definitionLine = 1604;
  sourceObject = obj3663;
// Begin line 1600
  setline(1600);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3678 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3679 = callmethod(*var_enumerable, "trait()object",
    2, partcv, params);
  gc_frame_end(callframe3678);
// compiled call node returning call3679 (depth = 2)
  struct UserObject *obj3663_uo = (struct UserObject *)obj3663;
  obj3663_uo->super = call3679;
  sourceObject = obj3663;
  sourceObject = obj3663;
// Begin line 1603
  setline(1603);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3680 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sourceDictionary (depth = 4)
  partcv[0] = 0;
  Object call3681 = callmethod(*var_sourceDictionary, "size",
    1, partcv, params);
  gc_frame_end(callframe3680);
// compiled call node returning call3681 (depth = 3)
// compiled member node returning call3681 (depth = 2)
  adddatum2(obj3663, call3681, 2);
  sourceObject = obj3663;
  objclass3663 = obj3663->class;
  objclass3663->definitionModule = modulename;
  objclass3663->definitionLine = 1599;
  (*(struct UserObject *)self).data[0] = lowerouter3663;
  self = oldself3663;
  selfslot = oldselfslot3663;
  stackframe = oldstackframe3663;
  gc_frame_end(frame);
  return obj3663;
}
Object meth_collectionsPrelude_iterator3683(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1609
  setline(1609);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3684 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3685 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3686 = callmethodflags(self, "values", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3685);
// compiled call node returning call3686 (depth = 5)
// compiled member node returning call3686 (depth = 4)
  partcv[0] = 0;
  Object call3687 = callmethod(call3686, "iterator",
    1, partcv, params);
  gc_frame_end(callframe3684);
// compiled call node returning call3687 (depth = 3)
// compiled member node returning call3687 (depth = 2)
  gc_frame_end(frame);
  return call3687;
}
Object meth_collectionsPrelude_hasNext3695(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for hasNext (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for hasNext");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1616
  setline(1616);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3697 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3698 = callmethodflags(self, "count", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3697);
// compiled call node returning call3698 (depth = 4)
// compiled member node returning call3698 (depth = 3)
  int op_slot_right_3696 = gc_frame_newslot(call3698);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3700 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3701 = gc_frame_new();
// call case 3: self.outer request
  Object call3702 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3701);
// compiled call node returning call3702 (depth = 6)
// compiled member node returning call3702 (depth = 5)
  partcv[0] = 0;
  Object call3703 = callmethodflags(call3702, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3700);
// compiled call node returning call3703 (depth = 4)
// compiled member node returning call3703 (depth = 3)
  int op_slot_left_3696 = gc_frame_newslot(call3703);
  params[0] = call3698;
  partcv[0] = 1;
  Object opresult3704 = callmethod(call3703, ">=", 1, partcv, params);
// compiled op node returning opresult3704 (depth = 2)
  gc_frame_end(frame);
  return opresult3704;
}
Object meth_collectionsPrelude__apply3748(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 4)
// Begin line 1621
  setline(1621);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3749 = gc_frame_new();
// Begin line 1623
  setline(1623);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3750 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3751 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3752 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3751);
// compiled call node returning call3752 (depth = 8)
// compiled member node returning call3752 (depth = 7)
  gc_frame_newslot(call3752);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3753 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3754 = gc_frame_new();
// call case 3: self.outer request
  Object call3755 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3754);
// compiled call node returning call3755 (depth = 10)
// compiled member node returning call3755 (depth = 9)
  partcv[0] = 0;
  Object call3756 = callmethodflags(call3755, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3753);
// compiled call node returning call3756 (depth = 8)
// compiled member node returning call3756 (depth = 7)
  params[0] = call3752;
  partcv[0] = 1;
  Object call3757 = callmethod(call3756, "at",
    1, partcv, params);
  gc_frame_end(callframe3750);
// compiled call node returning call3757 (depth = 6)
  gc_frame_newslot(call3757);
// call case 4: self request
  params[0] = call3757;
  partcv[0] = 1;
  Object call3758 = callmethodflags(self, "elt:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3749);
// compiled call node returning call3758 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1624
  setline(1624);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3761 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3762 = gc_frame_new();
// call case 3: self.outer request
  Object call3763 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3762);
// compiled call node returning call3763 (depth = 9)
// compiled member node returning call3763 (depth = 8)
  partcv[0] = 0;
  Object call3764 = callmethodflags(call3763, "removed", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3761);
// compiled call node returning call3764 (depth = 7)
// compiled member node returning call3764 (depth = 6)
  int op_slot_right_3760 = gc_frame_newslot(call3764);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3766 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3767 = callmethodflags(self, "elt", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3766);
// compiled call node returning call3767 (depth = 7)
// compiled member node returning call3767 (depth = 6)
  int op_slot_left_3760 = gc_frame_newslot(call3767);
  params[0] = call3764;
  partcv[0] = 1;
  Object opresult3768 = callmethod(call3767, "==", 1, partcv, params);
// compiled op node returning opresult3768 (depth = 5)
  int op_slot_right_3759 = gc_frame_newslot(opresult3768);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3771 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3772 = gc_frame_new();
// call case 3: self.outer request
  Object call3773 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3772);
// compiled call node returning call3773 (depth = 9)
// compiled member node returning call3773 (depth = 8)
  partcv[0] = 0;
  Object call3774 = callmethodflags(call3773, "unused", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3771);
// compiled call node returning call3774 (depth = 7)
// compiled member node returning call3774 (depth = 6)
  int op_slot_right_3770 = gc_frame_newslot(call3774);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3776 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3777 = callmethodflags(self, "elt", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3776);
// compiled call node returning call3777 (depth = 7)
// compiled member node returning call3777 (depth = 6)
  int op_slot_left_3770 = gc_frame_newslot(call3777);
  params[0] = call3774;
  partcv[0] = 1;
  Object opresult3778 = callmethod(call3777, "==", 1, partcv, params);
// compiled op node returning opresult3778 (depth = 5)
  int op_slot_left_3759 = gc_frame_newslot(opresult3778);
  params[0] = opresult3768;
  partcv[0] = 1;
  Object opresult3779 = callmethod(opresult3778, "||", 1, partcv, params);
// compiled op node returning opresult3779 (depth = 4)
  gc_frame_end(frame);
  return opresult3779;
}
Object meth_collectionsPrelude__apply3782(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 4)
// Begin line 1624
  setline(1624);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3783 = gc_frame_new();
// Begin line 1626
  setline(1626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num3785 = alloc_Float64(1);
// compiled num node returning num3785 (depth = 7)
  int op_slot_right_3784 = gc_frame_newslot(num3785);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3787 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3788 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3787);
// compiled call node returning call3788 (depth = 8)
// compiled member node returning call3788 (depth = 7)
  int op_slot_left_3784 = gc_frame_newslot(call3788);
  params[0] = num3785;
  partcv[0] = 1;
  Object sum3789 = callmethod(call3788, "+", 1, partcv, params);
// compiled op node returning sum3789 (depth = 6)
  gc_frame_newslot(sum3789);
// call case 4: self request
  params[0] = sum3789;
  partcv[0] = 1;
  Object call3790 = callmethodflags(self, "idx:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3783);
// compiled call node returning call3790 (depth = 5)
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_next3705(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_Exhausted = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for next (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for next");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1618
  setline(1618);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3708 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3709 = gc_frame_new();
// call case 3: self.outer request
  Object call3710 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3709);
// compiled call node returning call3710 (depth = 7)
// compiled member node returning call3710 (depth = 6)
  partcv[0] = 0;
  Object call3711 = callmethodflags(call3710, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3708);
// compiled call node returning call3711 (depth = 5)
// compiled member node returning call3711 (depth = 4)
  int op_slot_right_3707 = gc_frame_newslot(call3711);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3713 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3714 = callmethodflags(self, "imods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3713);
// compiled call node returning call3714 (depth = 5)
// compiled member node returning call3714 (depth = 4)
  int op_slot_left_3707 = gc_frame_newslot(call3714);
  params[0] = call3711;
  partcv[0] = 1;
  Object opresult3715 = callmethod(call3714, "!=", 1, partcv, params);
// compiled op node returning opresult3715 (depth = 3)
  Object if3706 = done;
  if (istrue(opresult3715)) {
// Begin line 1619
  setline(1619);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3716 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3717 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3718 = gc_frame_new();
// call case 3: self.outer request
  Object call3719 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3718);
// compiled call node returning call3719 (depth = 7)
// compiled member node returning call3719 (depth = 6)
  partcv[0] = 0;
  Object call3720 = callmethodflags(call3719, "asString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3717);
// compiled call node returning call3720 (depth = 5)
// compiled member node returning call3720 (depth = 4)
  gc_frame_newslot(call3720);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ConcurrentModification (depth = 4)
  params[0] = call3720;
  partcv[0] = 1;
  Object call3721 = callmethod(*var_ConcurrentModification, "raise",
    1, partcv, params);
  gc_frame_end(callframe3716);
// compiled call node returning call3721 (depth = 3)
    gc_frame_newslot(call3721);
    if3706 = call3721;
  } else {
  }
// compiled if node returning if3706 (depth = 2)
// Begin line 1621
  setline(1621);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3724 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3725 = callmethodflags(self, "count", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3724);
// compiled call node returning call3725 (depth = 5)
// compiled member node returning call3725 (depth = 4)
  int op_slot_right_3723 = gc_frame_newslot(call3725);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3727 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3728 = gc_frame_new();
// call case 3: self.outer request
  Object call3729 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3728);
// compiled call node returning call3729 (depth = 7)
// compiled member node returning call3729 (depth = 6)
  partcv[0] = 0;
  Object call3730 = callmethodflags(call3729, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3727);
// compiled call node returning call3730 (depth = 5)
// compiled member node returning call3730 (depth = 4)
  int op_slot_left_3723 = gc_frame_newslot(call3730);
  params[0] = call3725;
  partcv[0] = 1;
  Object opresult3731 = callmethod(call3730, "<", 1, partcv, params);
// compiled op node returning opresult3731 (depth = 3)
  Object if3722 = done;
  if (istrue(opresult3731)) {
// starting to compile call node (depth = 3)
  int callframe3732 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3734 == NULL) {
    strlit3734 = alloc_String("");
    gc_root(strlit3734);
  }
// compiled string node returning strlit3734 (depth = 5)
  int op_slot_right_3733 = gc_frame_newslot(strlit3734);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3737 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3738 = gc_frame_new();
// call case 3: self.outer request
  Object call3739 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3738);
// compiled call node returning call3739 (depth = 9)
// compiled member node returning call3739 (depth = 8)
  partcv[0] = 0;
  Object call3740 = callmethodflags(call3739, "asString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3737);
// compiled call node returning call3740 (depth = 7)
// compiled member node returning call3740 (depth = 6)
  int op_slot_right_3736 = gc_frame_newslot(call3740);
// starting to compile string node (depth = 6)
  if (strlit3742 == NULL) {
    strlit3742 = alloc_String("over ");
    gc_root(strlit3742);
  }
// compiled string node returning strlit3742 (depth = 6)
  int op_slot_left_3736 = gc_frame_newslot(strlit3742);
  params[0] = call3740;
  partcv[0] = 1;
  Object opresult3743 = callmethod(strlit3742, "++", 1, partcv, params);
// compiled op node returning opresult3743 (depth = 5)
  int op_slot_left_3733 = gc_frame_newslot(opresult3743);
  params[0] = strlit3734;
  partcv[0] = 1;
  Object opresult3744 = callmethod(opresult3743, "++", 1, partcv, params);
// compiled op node returning opresult3744 (depth = 4)
  gc_frame_newslot(opresult3744);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_Exhausted (depth = 4)
  params[0] = opresult3744;
  partcv[0] = 1;
  Object call3745 = callmethod(*var_Exhausted, "raise",
    1, partcv, params);
  gc_frame_end(callframe3732);
// compiled call node returning call3745 (depth = 3)
    gc_frame_newslot(call3745);
    if3722 = call3745;
  } else {
  }
// compiled if node returning if3722 (depth = 2)
// Begin line 1622
  setline(1622);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3746 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block3747 = alloc_Block(NULL, NULL, "collectionsPrelude", 1622);
  gc_frame_newslot(block3747);
// method _apply
  block_savedest(block3747);
  Object closure3748 = createclosure(1, "_apply");
  setclosureframe(closure3748, stackframe);
  addtoclosure(closure3748, selfslot);
  struct UserObject *uo3748 = (struct UserObject*)block3747;
  uo3748->data[0] = (Object)closure3748;
  Method *meth_meth_collectionsPrelude__apply3748 = addmethod2pos(block3747, "_apply", &meth_collectionsPrelude__apply3748, 0);
  int argcv_meth_collectionsPrelude__apply3748[] = {0};
  meth_meth_collectionsPrelude__apply3748->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply3748);
  meth_meth_collectionsPrelude__apply3748->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply3748->definitionLine = 1621;
// compiled block node returning block3747 (depth = 3)
  gc_frame_newslot(block3747);
// Begin line 1625
  setline(1625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block3781 = alloc_Block(NULL, NULL, "collectionsPrelude", 1625);
  gc_frame_newslot(block3781);
// method _apply
  block_savedest(block3781);
  Object closure3782 = createclosure(1, "_apply");
  setclosureframe(closure3782, stackframe);
  addtoclosure(closure3782, selfslot);
  struct UserObject *uo3782 = (struct UserObject*)block3781;
  uo3782->data[0] = (Object)closure3782;
  Method *meth_meth_collectionsPrelude__apply3782 = addmethod2pos(block3781, "_apply", &meth_collectionsPrelude__apply3782, 0);
  int argcv_meth_collectionsPrelude__apply3782[] = {0};
  meth_meth_collectionsPrelude__apply3782->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply3782);
  meth_meth_collectionsPrelude__apply3782->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply3782->definitionLine = 1624;
// compiled block node returning block3781 (depth = 3)
  gc_frame_newslot(block3781);
// call case 5: prelude request
  params[0] = block3747;
  params[1] = block3781;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3792 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3746);
// compiled call node returning call3792 (depth = 2)
// Begin line 1628
  setline(1628);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 1626
  setline(1626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3793 = gc_frame_new();
// Begin line 1628
  setline(1628);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3795 = alloc_Float64(1);
// compiled num node returning num3795 (depth = 5)
  int op_slot_right_3794 = gc_frame_newslot(num3795);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3797 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3798 = callmethodflags(self, "count", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3797);
// compiled call node returning call3798 (depth = 6)
// compiled member node returning call3798 (depth = 5)
  int op_slot_left_3794 = gc_frame_newslot(call3798);
  params[0] = num3795;
  partcv[0] = 1;
  Object sum3799 = callmethod(call3798, "+", 1, partcv, params);
// compiled op node returning sum3799 (depth = 4)
  gc_frame_newslot(sum3799);
// call case 4: self request
  params[0] = sum3799;
  partcv[0] = 1;
  Object call3800 = callmethodflags(self, "count:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3793);
// compiled call node returning call3800 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 1629
  setline(1629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 1628
  setline(1628);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3801 = gc_frame_new();
// Begin line 1629
  setline(1629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3803 = alloc_Float64(1);
// compiled num node returning num3803 (depth = 5)
  int op_slot_right_3802 = gc_frame_newslot(num3803);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3805 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3806 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3805);
// compiled call node returning call3806 (depth = 6)
// compiled member node returning call3806 (depth = 5)
  int op_slot_left_3802 = gc_frame_newslot(call3806);
  params[0] = num3803;
  partcv[0] = 1;
  Object sum3807 = callmethod(call3806, "+", 1, partcv, params);
// compiled op node returning sum3807 (depth = 4)
  gc_frame_newslot(sum3807);
// call case 4: self request
  params[0] = sum3807;
  partcv[0] = 1;
  Object call3808 = callmethodflags(self, "idx:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3801);
// compiled call node returning call3808 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 1630
  setline(1630);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3809 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3810 = callmethodflags(self, "elt", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3809);
// compiled call node returning call3810 (depth = 3)
// compiled member node returning call3810 (depth = 2)
  gc_frame_end(frame);
  return call3810;
}
Object meth_collectionsPrelude_bindingsIterator3688(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 27, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "bindingsIterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_Exhausted = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for bindingsIterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for bindingsIterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3689 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3689 = alloc_userobj2(9,7, objclass3689);
  gc_frame_newslot(obj3689);
if (objclass3689 == NULL) {
  glfree(obj3689->class->name);
  obj3689->class->name = "obj2985.bindingsIterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3689, self, 0);
  addmethodreal(obj3689,"outer", &reader_collectionsPrelude_outer_3690);
  Object oldself3689 = self;
  struct StackFrameObject *oldstackframe3689 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3689);
  gc_frame_newslot((Object)stackframe);
  self = obj3689;
  Object *oldselfslot3689 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3689 = (*(struct UserObject *)self).data[0], lowerouter3689 = thisouter3689;
  if (inheritingObject3689) {
    struct UserObject *inho3689 = (struct UserObject *)inheritingObject3689;
    while (inho3689->super != GraceDefaultObject) inho3689 = (struct UserObject *)inho3689->super;
    inho3689->super = obj3689;
    self = inheritingObject3689;
    *selfslot = self;
    lowerouter3689 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3689;
  }
if (objclass3689 == NULL) {
  Method *reader3691 = addmethodrealflags(obj3689, "imods",&reader_collectionsPrelude_imods_3691, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader3691->definitionModule = modulename;
  reader3691->definitionLine = 1612;
}
adddatum2(obj3689, alloc_Undefined(), 1);
if (objclass3689 == NULL) {
  Method *reader3692 = addmethodrealflags(obj3689, "count",&reader_collectionsPrelude_count_3692, MFLAG_CONFIDENTIAL);
  Method *writer3692 = addmethodrealflags(obj3689, "count:=",&writer_collectionsPrelude_count_3692, MFLAG_CONFIDENTIAL);
  reader3692->definitionModule = modulename;
  writer3692->definitionModule = modulename;
  reader3692->definitionLine = 1613;
  writer3692->definitionLine = 1613;
}
obj3689->flags |= OFLAG_MUTABLE;
adddatum2(obj3689, alloc_Undefined(), 2);
if (objclass3689 == NULL) {
  Method *reader3693 = addmethodrealflags(obj3689, "idx",&reader_collectionsPrelude_idx_3693, MFLAG_CONFIDENTIAL);
  Method *writer3693 = addmethodrealflags(obj3689, "idx:=",&writer_collectionsPrelude_idx_3693, MFLAG_CONFIDENTIAL);
  reader3693->definitionModule = modulename;
  writer3693->definitionModule = modulename;
  reader3693->definitionLine = 1614;
  writer3693->definitionLine = 1614;
}
obj3689->flags |= OFLAG_MUTABLE;
adddatum2(obj3689, alloc_Undefined(), 3);
if (objclass3689 == NULL) {
  Method *reader3694 = addmethodrealflags(obj3689, "elt",&reader_collectionsPrelude_elt_3694, MFLAG_CONFIDENTIAL);
  Method *writer3694 = addmethodrealflags(obj3689, "elt:=",&writer_collectionsPrelude_elt_3694, MFLAG_CONFIDENTIAL);
  reader3694->definitionModule = modulename;
  writer3694->definitionModule = modulename;
  reader3694->definitionLine = 1615;
  writer3694->definitionLine = 1615;
}
obj3689->flags |= OFLAG_MUTABLE;
adddatum2(obj3689, alloc_Undefined(), 4);
// method hasNext
  struct UserObject *uo3695 = (struct UserObject*)obj3689;
  uo3695->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext3695 = addmethod2pos(obj3689, "hasNext", &meth_collectionsPrelude_hasNext3695, 5);
  int argcv_meth_collectionsPrelude_hasNext3695[] = {0};
  meth_meth_collectionsPrelude_hasNext3695->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext3695);
  meth_meth_collectionsPrelude_hasNext3695->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext3695->definitionLine = 1616;
// method next
  block_savedest(obj3689);
  Object closure3705 = createclosure(2, "next");
  setclosureframe(closure3705, stackframe);
  addtoclosure(closure3705, var_ConcurrentModification);
  addtoclosure(closure3705, var_Exhausted);
  struct UserObject *uo3705 = (struct UserObject*)obj3689;
  uo3705->data[6] = (Object)closure3705;
  Method *meth_meth_collectionsPrelude_next3705 = addmethod2pos(obj3689, "next", &meth_collectionsPrelude_next3705, 6);
  int argcv_meth_collectionsPrelude_next3705[] = {0};
  meth_meth_collectionsPrelude_next3705->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next3705);
  meth_meth_collectionsPrelude_next3705->definitionModule = modulename;
  meth_meth_collectionsPrelude_next3705->definitionLine = 1617;
  sourceObject = obj3689;
// Begin line 1612
  setline(1612);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3811 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3812 = gc_frame_new();
// call case 3: self.outer request
  Object call3813 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3812);
// compiled call node returning call3813 (depth = 5)
// compiled member node returning call3813 (depth = 4)
  partcv[0] = 0;
  Object call3814 = callmethodflags(call3813, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3811);
// compiled call node returning call3814 (depth = 3)
// compiled member node returning call3814 (depth = 2)
  adddatum2(obj3689, call3814, 1);
  sourceObject = obj3689;
// Begin line 1613
  setline(1613);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num3815 = alloc_Float64(1);
// compiled num node returning num3815 (depth = 2)
  adddatum2(obj3689, num3815, 2);
  sourceObject = obj3689;
// Begin line 1614
  setline(1614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num3816 = alloc_Float64(0);
// compiled num node returning num3816 (depth = 2)
  adddatum2(obj3689, num3816, 3);
  sourceObject = obj3689;
  adddatum2(obj3689, undefined, 4);
  sourceObject = obj3689;
  sourceObject = obj3689;
  objclass3689 = obj3689->class;
  objclass3689->definitionModule = modulename;
  objclass3689->definitionLine = 1610;
  (*(struct UserObject *)self).data[0] = lowerouter3689;
  self = oldself3689;
  selfslot = oldselfslot3689;
  stackframe = oldstackframe3689;
  gc_frame_end(frame);
  return obj3689;
}
Object meth_collectionsPrelude_bindingsIterator3688_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 27, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "bindingsIterator()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_Exhausted = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for bindingsIterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for bindingsIterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3689 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3689 = alloc_userobj2(9,7, objclass3689);
  gc_frame_newslot(obj3689);
if (objclass3689 == NULL) {
  glfree(obj3689->class->name);
  obj3689->class->name = "obj2985.bindingsIterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3689, self, 0);
  addmethodreal(obj3689,"outer", &reader_collectionsPrelude_outer_3690);
  Object oldself3689 = self;
  struct StackFrameObject *oldstackframe3689 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3689);
  gc_frame_newslot((Object)stackframe);
  self = obj3689;
  Object *oldselfslot3689 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3689 = (*(struct UserObject *)self).data[0], lowerouter3689 = thisouter3689;
  if (inheritingObject3689) {
    struct UserObject *inho3689 = (struct UserObject *)inheritingObject3689;
    while (inho3689->super != GraceDefaultObject) inho3689 = (struct UserObject *)inho3689->super;
    inho3689->super = obj3689;
    self = inheritingObject3689;
    *selfslot = self;
    lowerouter3689 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3689;
  }
if (objclass3689 == NULL) {
  Method *reader3691 = addmethodrealflags(obj3689, "imods",&reader_collectionsPrelude_imods_3691, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader3691->definitionModule = modulename;
  reader3691->definitionLine = 1612;
}
adddatum2(obj3689, alloc_Undefined(), 1);
if (objclass3689 == NULL) {
  Method *reader3692 = addmethodrealflags(obj3689, "count",&reader_collectionsPrelude_count_3692, MFLAG_CONFIDENTIAL);
  Method *writer3692 = addmethodrealflags(obj3689, "count:=",&writer_collectionsPrelude_count_3692, MFLAG_CONFIDENTIAL);
  reader3692->definitionModule = modulename;
  writer3692->definitionModule = modulename;
  reader3692->definitionLine = 1613;
  writer3692->definitionLine = 1613;
}
obj3689->flags |= OFLAG_MUTABLE;
adddatum2(obj3689, alloc_Undefined(), 2);
if (objclass3689 == NULL) {
  Method *reader3693 = addmethodrealflags(obj3689, "idx",&reader_collectionsPrelude_idx_3693, MFLAG_CONFIDENTIAL);
  Method *writer3693 = addmethodrealflags(obj3689, "idx:=",&writer_collectionsPrelude_idx_3693, MFLAG_CONFIDENTIAL);
  reader3693->definitionModule = modulename;
  writer3693->definitionModule = modulename;
  reader3693->definitionLine = 1614;
  writer3693->definitionLine = 1614;
}
obj3689->flags |= OFLAG_MUTABLE;
adddatum2(obj3689, alloc_Undefined(), 3);
if (objclass3689 == NULL) {
  Method *reader3694 = addmethodrealflags(obj3689, "elt",&reader_collectionsPrelude_elt_3694, MFLAG_CONFIDENTIAL);
  Method *writer3694 = addmethodrealflags(obj3689, "elt:=",&writer_collectionsPrelude_elt_3694, MFLAG_CONFIDENTIAL);
  reader3694->definitionModule = modulename;
  writer3694->definitionModule = modulename;
  reader3694->definitionLine = 1615;
  writer3694->definitionLine = 1615;
}
obj3689->flags |= OFLAG_MUTABLE;
adddatum2(obj3689, alloc_Undefined(), 4);
// method hasNext
  struct UserObject *uo3695 = (struct UserObject*)obj3689;
  uo3695->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext3695 = addmethod2pos(obj3689, "hasNext", &meth_collectionsPrelude_hasNext3695, 5);
  int argcv_meth_collectionsPrelude_hasNext3695[] = {0};
  meth_meth_collectionsPrelude_hasNext3695->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext3695);
  meth_meth_collectionsPrelude_hasNext3695->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext3695->definitionLine = 1616;
// method next
  block_savedest(obj3689);
  Object closure3705 = createclosure(2, "next");
  setclosureframe(closure3705, stackframe);
  addtoclosure(closure3705, var_ConcurrentModification);
  addtoclosure(closure3705, var_Exhausted);
  struct UserObject *uo3705 = (struct UserObject*)obj3689;
  uo3705->data[6] = (Object)closure3705;
  Method *meth_meth_collectionsPrelude_next3705 = addmethod2pos(obj3689, "next", &meth_collectionsPrelude_next3705, 6);
  int argcv_meth_collectionsPrelude_next3705[] = {0};
  meth_meth_collectionsPrelude_next3705->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next3705);
  meth_meth_collectionsPrelude_next3705->definitionModule = modulename;
  meth_meth_collectionsPrelude_next3705->definitionLine = 1617;
  sourceObject = obj3689;
// Begin line 1612
  setline(1612);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3811 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3812 = gc_frame_new();
// call case 3: self.outer request
  Object call3813 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3812);
// compiled call node returning call3813 (depth = 5)
// compiled member node returning call3813 (depth = 4)
  partcv[0] = 0;
  Object call3814 = callmethodflags(call3813, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3811);
// compiled call node returning call3814 (depth = 3)
// compiled member node returning call3814 (depth = 2)
  adddatum2(obj3689, call3814, 1);
  sourceObject = obj3689;
// Begin line 1613
  setline(1613);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num3815 = alloc_Float64(1);
// compiled num node returning num3815 (depth = 2)
  adddatum2(obj3689, num3815, 2);
  sourceObject = obj3689;
// Begin line 1614
  setline(1614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num3816 = alloc_Float64(0);
// compiled num node returning num3816 (depth = 2)
  adddatum2(obj3689, num3816, 3);
  sourceObject = obj3689;
  adddatum2(obj3689, undefined, 4);
  sourceObject = obj3689;
  sourceObject = obj3689;
  objclass3689 = obj3689->class;
  objclass3689->definitionModule = modulename;
  objclass3689->definitionLine = 1610;
  (*(struct UserObject *)self).data[0] = lowerouter3689;
  self = oldself3689;
  selfslot = oldselfslot3689;
  stackframe = oldstackframe3689;
  gc_frame_end(frame);
  return obj3689;
}
Object meth_collectionsPrelude__apply3845(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1639
  setline(1639);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3846 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  gc_frame_newslot(*var_i);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3847 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3848 = callmethodflags(self, "unused", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3847);
// compiled call node returning call3848 (depth = 6)
// compiled member node returning call3848 (depth = 5)
  gc_frame_newslot(call3848);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3849 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3850 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3849);
// compiled call node returning call3850 (depth = 6)
// compiled member node returning call3850 (depth = 5)
  params[0] = *var_i;
  params[1] = call3848;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3851 = callmethod(call3850, "at()put",
    2, partcv, params);
  gc_frame_end(callframe3846);
// compiled call node returning call3851 (depth = 4)
  gc_frame_end(frame);
  return call3851;
}
Object meth_collectionsPrelude__apply3873(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_a = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3875 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3876 = callmethodflags(self, "removed", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3875);
// compiled call node returning call3876 (depth = 9)
// compiled member node returning call3876 (depth = 8)
  int op_slot_right_3874 = gc_frame_newslot(call3876);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_a (depth = 8)
  int op_slot_left_3874 = gc_frame_newslot(*var_a);
  params[0] = call3876;
  partcv[0] = 1;
  Object opresult3878 = callmethod(*var_a, "!=", 1, partcv, params);
// compiled op node returning opresult3878 (depth = 7)
  gc_frame_end(frame);
  return opresult3878;
}
Object meth_collectionsPrelude__apply3867(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_oldInner = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_a = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "a");
// Begin line 1643
  setline(1643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3868 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_oldInner (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call3869 = callmethod(*var_oldInner, "at",
    1, partcv, params);
  gc_frame_end(callframe3868);
// compiled call node returning call3869 (depth = 5)
  *var_a = call3869;
  if (call3869 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1644
  setline(1644);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3871 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block3872 = alloc_Block(NULL, NULL, "collectionsPrelude", 1644);
  gc_frame_newslot(block3872);
// method _apply
  block_savedest(block3872);
  Object closure3873 = createclosure(2, "_apply");
  setclosureframe(closure3873, stackframe);
  addtoclosure(closure3873, var_a);
  addtoclosure(closure3873, selfslot);
  struct UserObject *uo3873 = (struct UserObject*)block3872;
  uo3873->data[0] = (Object)closure3873;
  Method *meth_meth_collectionsPrelude__apply3873 = addmethod2pos(block3872, "_apply", &meth_collectionsPrelude__apply3873, 0);
  int argcv_meth_collectionsPrelude__apply3873[] = {0};
  meth_meth_collectionsPrelude__apply3873->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply3873);
  meth_meth_collectionsPrelude__apply3873->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply3873->definitionLine = 1639;
// compiled block node returning block3872 (depth = 6)
  gc_frame_newslot(block3872);
// call case 6: other member request
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3881 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3882 = callmethodflags(self, "unused", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3881);
// compiled call node returning call3882 (depth = 8)
// compiled member node returning call3882 (depth = 7)
  int op_slot_right_3880 = gc_frame_newslot(call3882);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_left_3880 = gc_frame_newslot(*var_a);
  params[0] = call3882;
  partcv[0] = 1;
  Object opresult3884 = callmethod(*var_a, "!=", 1, partcv, params);
// compiled op node returning opresult3884 (depth = 6)
  params[0] = block3872;
  partcv[0] = 1;
  Object call3885 = callmethod(opresult3884, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe3871);
// compiled call node returning call3885 (depth = 5)
  Object if3870 = done;
  if (istrue(call3885)) {
// Begin line 1645
  setline(1645);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3886 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3887 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_a (depth = 8)
  partcv[0] = 0;
  Object call3888 = callmethod(*var_a, "key",
    1, partcv, params);
  gc_frame_end(callframe3887);
// compiled call node returning call3888 (depth = 7)
// compiled member node returning call3888 (depth = 6)
  gc_frame_newslot(call3888);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3889 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_a (depth = 8)
  partcv[0] = 0;
  Object call3890 = callmethod(*var_a, "value",
    1, partcv, params);
  gc_frame_end(callframe3889);
// compiled call node returning call3890 (depth = 7)
// compiled member node returning call3890 (depth = 6)
  gc_frame_newslot(call3890);
// call case 4: self request
  params[0] = call3888;
  params[1] = call3890;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3891 = callmethodflags(self, "at()put", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3886);
// compiled call node returning call3891 (depth = 5)
    gc_frame_newslot(call3891);
    if3870 = call3891;
  } else {
  }
// compiled if node returning if3870 (depth = 4)
  gc_frame_end(frame);
  return if3870;
}
Object meth_collectionsPrelude_expand3818(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 28, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "expand");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var__prelude = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for expand (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for expand");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_c = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "c");
  Object *var_n = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "n");
  Object *var_oldInner = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "oldInner");
// Begin line 1634
  setline(1634);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3819 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3820 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3821 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3820);
// compiled call node returning call3821 (depth = 6)
// compiled member node returning call3821 (depth = 5)
  partcv[0] = 0;
  Object call3822 = callmethod(call3821, "size",
    1, partcv, params);
  gc_frame_end(callframe3819);
// compiled call node returning call3822 (depth = 4)
// compiled member node returning call3822 (depth = 3)
  *var_c = call3822;
  if (call3822 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1635
  setline(1635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num3824 = alloc_Float64(2);
// compiled num node returning num3824 (depth = 4)
  int op_slot_right_3823 = gc_frame_newslot(num3824);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  int op_slot_left_3823 = gc_frame_newslot(*var_c);
  params[0] = num3824;
  partcv[0] = 1;
  Object prod3826 = callmethod(*var_c, "*", 1, partcv, params);
// compiled op node returning prod3826 (depth = 3)
  *var_n = prod3826;
  if (prod3826 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1636
  setline(1636);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3827 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3828 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3827);
// compiled call node returning call3828 (depth = 4)
// compiled member node returning call3828 (depth = 3)
  *var_oldInner = call3828;
  if (call3828 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1637
  setline(1637);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 1636
  setline(1636);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3829 = gc_frame_new();
// Begin line 1637
  setline(1637);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3830 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3831 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var__prelude (depth = 7)
  partcv[0] = 0;
  Object call3832 = callmethod(*var__prelude, "PrimitiveArray",
    1, partcv, params);
  gc_frame_end(callframe3831);
// compiled call node returning call3832 (depth = 6)
// compiled member node returning call3832 (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call3833 = callmethod(call3832, "new",
    1, partcv, params);
  gc_frame_end(callframe3830);
// compiled call node returning call3833 (depth = 4)
  gc_frame_newslot(call3833);
// call case 4: self request
  params[0] = call3833;
  partcv[0] = 1;
  Object call3834 = callmethodflags(self, "inner:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3829);
// compiled call node returning call3834 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 1638
  setline(1638);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3835 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3838 = alloc_Float64(1);
// compiled num node returning num3838 (depth = 5)
  int op_slot_right_3837 = gc_frame_newslot(num3838);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  int op_slot_left_3837 = gc_frame_newslot(*var_n);
  params[0] = num3838;
  partcv[0] = 1;
  Object diff3840 = callmethod(*var_n, "-", 1, partcv, params);
// compiled op node returning diff3840 (depth = 4)
  int op_slot_right_3836 = gc_frame_newslot(diff3840);
// starting to compile num node (depth = 4)
  Object num3842 = alloc_Float64(0);
// compiled num node returning num3842 (depth = 4)
  int op_slot_left_3836 = gc_frame_newslot(num3842);
  params[0] = diff3840;
  partcv[0] = 1;
  Object opresult3843 = callmethod(num3842, "..", 1, partcv, params);
// compiled op node returning opresult3843 (depth = 3)
  gc_frame_newslot(opresult3843);
// starting to compile block node (depth = 3)
  Object block3844 = alloc_Block(NULL, NULL, "collectionsPrelude", 1638);
  gc_frame_newslot(block3844);
// method _apply
  block_savedest(block3844);
  Object closure3845 = createclosure(1, "_apply");
  setclosureframe(closure3845, stackframe);
  addtoclosure(closure3845, selfslot);
  struct UserObject *uo3845 = (struct UserObject*)block3844;
  uo3845->data[0] = (Object)closure3845;
  Method *meth_meth_collectionsPrelude__apply3845 = addmethod2pos(block3844, "_apply", &meth_collectionsPrelude__apply3845, 0);
  int argcv_meth_collectionsPrelude__apply3845[] = {1};
  meth_meth_collectionsPrelude__apply3845->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply3845);
  meth_meth_collectionsPrelude__apply3845->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply3845->definitionLine = 1637;
// compiled block node returning block3844 (depth = 3)
  gc_frame_newslot(block3844);
// call case 5: prelude request
  params[0] = opresult3843;
  params[1] = block3844;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3853 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3835);
// compiled call node returning call3853 (depth = 2)
// Begin line 1641
  setline(1641);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 1639
  setline(1639);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3854 = gc_frame_new();
// Begin line 1641
  setline(1641);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num3855 = alloc_Float64(0);
// compiled num node returning num3855 (depth = 4)
  gc_frame_newslot(num3855);
// call case 4: self request
  params[0] = num3855;
  partcv[0] = 1;
  Object call3856 = callmethodflags(self, "numBindings:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3854);
// compiled call node returning call3856 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 1642
  setline(1642);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3857 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3860 = alloc_Float64(1);
// compiled num node returning num3860 (depth = 5)
  int op_slot_right_3859 = gc_frame_newslot(num3860);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_c (depth = 5)
  int op_slot_left_3859 = gc_frame_newslot(*var_c);
  params[0] = num3860;
  partcv[0] = 1;
  Object diff3862 = callmethod(*var_c, "-", 1, partcv, params);
// compiled op node returning diff3862 (depth = 4)
  int op_slot_right_3858 = gc_frame_newslot(diff3862);
// starting to compile num node (depth = 4)
  Object num3864 = alloc_Float64(0);
// compiled num node returning num3864 (depth = 4)
  int op_slot_left_3858 = gc_frame_newslot(num3864);
  params[0] = diff3862;
  partcv[0] = 1;
  Object opresult3865 = callmethod(num3864, "..", 1, partcv, params);
// compiled op node returning opresult3865 (depth = 3)
  gc_frame_newslot(opresult3865);
// starting to compile block node (depth = 3)
  Object block3866 = alloc_Block(NULL, NULL, "collectionsPrelude", 1642);
  gc_frame_newslot(block3866);
// method _apply
  block_savedest(block3866);
  Object closure3867 = createclosure(2, "_apply");
  setclosureframe(closure3867, stackframe);
  addtoclosure(closure3867, var_oldInner);
  addtoclosure(closure3867, selfslot);
  struct UserObject *uo3867 = (struct UserObject*)block3866;
  uo3867->data[0] = (Object)closure3867;
  Method *meth_meth_collectionsPrelude__apply3867 = addmethod2pos(block3866, "_apply", &meth_collectionsPrelude__apply3867, 0);
  int argcv_meth_collectionsPrelude__apply3867[] = {1};
  meth_meth_collectionsPrelude__apply3867->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply3867);
  meth_meth_collectionsPrelude__apply3867->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply3867->definitionLine = 1639;
// compiled block node returning block3866 (depth = 3)
  gc_frame_newslot(block3866);
// call case 5: prelude request
  params[0] = opresult3865;
  params[1] = block3866;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3893 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3857);
// compiled call node returning call3893 (depth = 2)
  gc_frame_end(frame);
  return call3893;
}
Object meth_collectionsPrelude__apply3917(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_a = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3919 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3920 = callmethodflags(self, "removed", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3919);
// compiled call node returning call3920 (depth = 9)
// compiled member node returning call3920 (depth = 8)
  int op_slot_right_3918 = gc_frame_newslot(call3920);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_a (depth = 8)
  int op_slot_left_3918 = gc_frame_newslot(*var_a);
  params[0] = call3920;
  partcv[0] = 1;
  Object opresult3922 = callmethod(*var_a, "!=", 1, partcv, params);
// compiled op node returning opresult3922 (depth = 7)
  gc_frame_end(frame);
  return opresult3922;
}
Object meth_collectionsPrelude__apply3909(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[1];
  Object *var_block2 = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_a = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "a");
// Begin line 1651
  setline(1651);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3910 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3911 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3912 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3911);
// compiled call node returning call3912 (depth = 7)
// compiled member node returning call3912 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call3913 = callmethod(call3912, "at",
    1, partcv, params);
  gc_frame_end(callframe3910);
// compiled call node returning call3913 (depth = 5)
  *var_a = call3913;
  if (call3913 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1652
  setline(1652);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3915 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block3916 = alloc_Block(NULL, NULL, "collectionsPrelude", 1652);
  gc_frame_newslot(block3916);
// method _apply
  block_savedest(block3916);
  Object closure3917 = createclosure(2, "_apply");
  setclosureframe(closure3917, stackframe);
  addtoclosure(closure3917, var_a);
  addtoclosure(closure3917, selfslot);
  struct UserObject *uo3917 = (struct UserObject*)block3916;
  uo3917->data[0] = (Object)closure3917;
  Method *meth_meth_collectionsPrelude__apply3917 = addmethod2pos(block3916, "_apply", &meth_collectionsPrelude__apply3917, 0);
  int argcv_meth_collectionsPrelude__apply3917[] = {0};
  meth_meth_collectionsPrelude__apply3917->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply3917);
  meth_meth_collectionsPrelude__apply3917->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply3917->definitionLine = 1651;
// compiled block node returning block3916 (depth = 6)
  gc_frame_newslot(block3916);
// call case 6: other member request
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3925 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3926 = callmethodflags(self, "unused", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3925);
// compiled call node returning call3926 (depth = 8)
// compiled member node returning call3926 (depth = 7)
  int op_slot_right_3924 = gc_frame_newslot(call3926);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_left_3924 = gc_frame_newslot(*var_a);
  params[0] = call3926;
  partcv[0] = 1;
  Object opresult3928 = callmethod(*var_a, "!=", 1, partcv, params);
// compiled op node returning opresult3928 (depth = 6)
  params[0] = block3916;
  partcv[0] = 1;
  Object call3929 = callmethod(opresult3928, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe3915);
// compiled call node returning call3929 (depth = 5)
  Object if3914 = done;
  if (istrue(call3929)) {
// Begin line 1653
  setline(1653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3930 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3931 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_a (depth = 8)
  partcv[0] = 0;
  Object call3932 = callmethod(*var_a, "key",
    1, partcv, params);
  gc_frame_end(callframe3931);
// compiled call node returning call3932 (depth = 7)
// compiled member node returning call3932 (depth = 6)
  gc_frame_newslot(call3932);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3933 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_a (depth = 8)
  partcv[0] = 0;
  Object call3934 = callmethod(*var_a, "value",
    1, partcv, params);
  gc_frame_end(callframe3933);
// compiled call node returning call3934 (depth = 7)
// compiled member node returning call3934 (depth = 6)
  gc_frame_newslot(call3934);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_block2 (depth = 6)
  params[0] = call3932;
  params[1] = call3934;
  partcv[0] = 2;
  Object call3935 = callmethod(*var_block2, "apply",
    1, partcv, params);
  gc_frame_end(callframe3930);
// compiled call node returning call3935 (depth = 5)
    gc_frame_newslot(call3935);
    if3914 = call3935;
  } else {
  }
// compiled if node returning if3914 (depth = 4)
  gc_frame_end(frame);
  return if3914;
}
Object meth_collectionsPrelude_keysAndValuesDo3894(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keysAndValuesDo");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method keysAndValuesDo");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for keysAndValuesDo (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block2 = &(stackframe->slots[0]);
  *var_block2 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for keysAndValuesDo");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1650
  setline(1650);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3895 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3898 = alloc_Float64(1);
// compiled num node returning num3898 (depth = 5)
  int op_slot_right_3897 = gc_frame_newslot(num3898);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3900 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3901 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3902 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3901);
// compiled call node returning call3902 (depth = 8)
// compiled member node returning call3902 (depth = 7)
  partcv[0] = 0;
  Object call3903 = callmethod(call3902, "size",
    1, partcv, params);
  gc_frame_end(callframe3900);
// compiled call node returning call3903 (depth = 6)
// compiled member node returning call3903 (depth = 5)
  int op_slot_left_3897 = gc_frame_newslot(call3903);
  params[0] = num3898;
  partcv[0] = 1;
  Object diff3904 = callmethod(call3903, "-", 1, partcv, params);
// compiled op node returning diff3904 (depth = 4)
  int op_slot_right_3896 = gc_frame_newslot(diff3904);
// starting to compile num node (depth = 4)
  Object num3906 = alloc_Float64(0);
// compiled num node returning num3906 (depth = 4)
  int op_slot_left_3896 = gc_frame_newslot(num3906);
  params[0] = diff3904;
  partcv[0] = 1;
  Object opresult3907 = callmethod(num3906, "..", 1, partcv, params);
// compiled op node returning opresult3907 (depth = 3)
  gc_frame_newslot(opresult3907);
// starting to compile block node (depth = 3)
  Object block3908 = alloc_Block(NULL, NULL, "collectionsPrelude", 1650);
  gc_frame_newslot(block3908);
// method _apply
  block_savedest(block3908);
  Object closure3909 = createclosure(2, "_apply");
  setclosureframe(closure3909, stackframe);
  addtoclosure(closure3909, var_block2);
  addtoclosure(closure3909, selfslot);
  struct UserObject *uo3909 = (struct UserObject*)block3908;
  uo3909->data[0] = (Object)closure3909;
  Method *meth_meth_collectionsPrelude__apply3909 = addmethod2pos(block3908, "_apply", &meth_collectionsPrelude__apply3909, 0);
  int argcv_meth_collectionsPrelude__apply3909[] = {1};
  meth_meth_collectionsPrelude__apply3909->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply3909);
  meth_meth_collectionsPrelude__apply3909->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply3909->definitionLine = 1650;
// compiled block node returning block3908 (depth = 3)
  gc_frame_newslot(block3908);
// call case 5: prelude request
  params[0] = opresult3907;
  params[1] = block3908;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3937 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3895);
// compiled call node returning call3937 (depth = 2)
  gc_frame_end(frame);
  return call3937;
}
Object meth_collectionsPrelude__apply3961(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_a = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3963 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3964 = callmethodflags(self, "removed", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3963);
// compiled call node returning call3964 (depth = 9)
// compiled member node returning call3964 (depth = 8)
  int op_slot_right_3962 = gc_frame_newslot(call3964);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_a (depth = 8)
  int op_slot_left_3962 = gc_frame_newslot(*var_a);
  params[0] = call3964;
  partcv[0] = 1;
  Object opresult3966 = callmethod(*var_a, "!=", 1, partcv, params);
// compiled op node returning opresult3966 (depth = 7)
  gc_frame_end(frame);
  return opresult3966;
}
Object meth_collectionsPrelude__apply3953(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_block1 = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_a = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "a");
// Begin line 1659
  setline(1659);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3954 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3955 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3956 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3955);
// compiled call node returning call3956 (depth = 7)
// compiled member node returning call3956 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call3957 = callmethod(call3956, "at",
    1, partcv, params);
  gc_frame_end(callframe3954);
// compiled call node returning call3957 (depth = 5)
  *var_a = call3957;
  if (call3957 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1660
  setline(1660);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3959 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block3960 = alloc_Block(NULL, NULL, "collectionsPrelude", 1660);
  gc_frame_newslot(block3960);
// method _apply
  block_savedest(block3960);
  Object closure3961 = createclosure(2, "_apply");
  setclosureframe(closure3961, stackframe);
  addtoclosure(closure3961, var_a);
  addtoclosure(closure3961, selfslot);
  struct UserObject *uo3961 = (struct UserObject*)block3960;
  uo3961->data[0] = (Object)closure3961;
  Method *meth_meth_collectionsPrelude__apply3961 = addmethod2pos(block3960, "_apply", &meth_collectionsPrelude__apply3961, 0);
  int argcv_meth_collectionsPrelude__apply3961[] = {0};
  meth_meth_collectionsPrelude__apply3961->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply3961);
  meth_meth_collectionsPrelude__apply3961->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply3961->definitionLine = 1659;
// compiled block node returning block3960 (depth = 6)
  gc_frame_newslot(block3960);
// call case 6: other member request
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3969 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3970 = callmethodflags(self, "unused", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3969);
// compiled call node returning call3970 (depth = 8)
// compiled member node returning call3970 (depth = 7)
  int op_slot_right_3968 = gc_frame_newslot(call3970);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_left_3968 = gc_frame_newslot(*var_a);
  params[0] = call3970;
  partcv[0] = 1;
  Object opresult3972 = callmethod(*var_a, "!=", 1, partcv, params);
// compiled op node returning opresult3972 (depth = 6)
  params[0] = block3960;
  partcv[0] = 1;
  Object call3973 = callmethod(opresult3972, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe3959);
// compiled call node returning call3973 (depth = 5)
  Object if3958 = done;
  if (istrue(call3973)) {
// Begin line 1661
  setline(1661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3974 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3975 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_a (depth = 8)
  partcv[0] = 0;
  Object call3976 = callmethod(*var_a, "key",
    1, partcv, params);
  gc_frame_end(callframe3975);
// compiled call node returning call3976 (depth = 7)
// compiled member node returning call3976 (depth = 6)
  gc_frame_newslot(call3976);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_block1 (depth = 6)
  params[0] = call3976;
  partcv[0] = 1;
  Object call3977 = callmethod(*var_block1, "apply",
    1, partcv, params);
  gc_frame_end(callframe3974);
// compiled call node returning call3977 (depth = 5)
    gc_frame_newslot(call3977);
    if3958 = call3977;
  } else {
  }
// compiled if node returning if3958 (depth = 4)
  gc_frame_end(frame);
  return if3958;
}
Object meth_collectionsPrelude_keysDo3938(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keysDo");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method keysDo");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for keysDo (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for keysDo");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1658
  setline(1658);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3939 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3942 = alloc_Float64(1);
// compiled num node returning num3942 (depth = 5)
  int op_slot_right_3941 = gc_frame_newslot(num3942);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3944 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3945 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3946 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3945);
// compiled call node returning call3946 (depth = 8)
// compiled member node returning call3946 (depth = 7)
  partcv[0] = 0;
  Object call3947 = callmethod(call3946, "size",
    1, partcv, params);
  gc_frame_end(callframe3944);
// compiled call node returning call3947 (depth = 6)
// compiled member node returning call3947 (depth = 5)
  int op_slot_left_3941 = gc_frame_newslot(call3947);
  params[0] = num3942;
  partcv[0] = 1;
  Object diff3948 = callmethod(call3947, "-", 1, partcv, params);
// compiled op node returning diff3948 (depth = 4)
  int op_slot_right_3940 = gc_frame_newslot(diff3948);
// starting to compile num node (depth = 4)
  Object num3950 = alloc_Float64(0);
// compiled num node returning num3950 (depth = 4)
  int op_slot_left_3940 = gc_frame_newslot(num3950);
  params[0] = diff3948;
  partcv[0] = 1;
  Object opresult3951 = callmethod(num3950, "..", 1, partcv, params);
// compiled op node returning opresult3951 (depth = 3)
  gc_frame_newslot(opresult3951);
// starting to compile block node (depth = 3)
  Object block3952 = alloc_Block(NULL, NULL, "collectionsPrelude", 1658);
  gc_frame_newslot(block3952);
// method _apply
  block_savedest(block3952);
  Object closure3953 = createclosure(2, "_apply");
  setclosureframe(closure3953, stackframe);
  addtoclosure(closure3953, var_block1);
  addtoclosure(closure3953, selfslot);
  struct UserObject *uo3953 = (struct UserObject*)block3952;
  uo3953->data[0] = (Object)closure3953;
  Method *meth_meth_collectionsPrelude__apply3953 = addmethod2pos(block3952, "_apply", &meth_collectionsPrelude__apply3953, 0);
  int argcv_meth_collectionsPrelude__apply3953[] = {1};
  meth_meth_collectionsPrelude__apply3953->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply3953);
  meth_meth_collectionsPrelude__apply3953->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply3953->definitionLine = 1658;
// compiled block node returning block3952 (depth = 3)
  gc_frame_newslot(block3952);
// call case 5: prelude request
  params[0] = opresult3951;
  params[1] = block3952;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3979 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3939);
// compiled call node returning call3979 (depth = 2)
  gc_frame_end(frame);
  return call3979;
}
Object meth_collectionsPrelude__apply4003(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_a = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4005 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4006 = callmethodflags(self, "removed", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4005);
// compiled call node returning call4006 (depth = 9)
// compiled member node returning call4006 (depth = 8)
  int op_slot_right_4004 = gc_frame_newslot(call4006);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_a (depth = 8)
  int op_slot_left_4004 = gc_frame_newslot(*var_a);
  params[0] = call4006;
  partcv[0] = 1;
  Object opresult4008 = callmethod(*var_a, "!=", 1, partcv, params);
// compiled op node returning opresult4008 (depth = 7)
  gc_frame_end(frame);
  return opresult4008;
}
Object meth_collectionsPrelude__apply3995(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_block1 = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_a = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "a");
// Begin line 1667
  setline(1667);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3996 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3997 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3998 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3997);
// compiled call node returning call3998 (depth = 7)
// compiled member node returning call3998 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call3999 = callmethod(call3998, "at",
    1, partcv, params);
  gc_frame_end(callframe3996);
// compiled call node returning call3999 (depth = 5)
  *var_a = call3999;
  if (call3999 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1668
  setline(1668);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4001 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block4002 = alloc_Block(NULL, NULL, "collectionsPrelude", 1668);
  gc_frame_newslot(block4002);
// method _apply
  block_savedest(block4002);
  Object closure4003 = createclosure(2, "_apply");
  setclosureframe(closure4003, stackframe);
  addtoclosure(closure4003, var_a);
  addtoclosure(closure4003, selfslot);
  struct UserObject *uo4003 = (struct UserObject*)block4002;
  uo4003->data[0] = (Object)closure4003;
  Method *meth_meth_collectionsPrelude__apply4003 = addmethod2pos(block4002, "_apply", &meth_collectionsPrelude__apply4003, 0);
  int argcv_meth_collectionsPrelude__apply4003[] = {0};
  meth_meth_collectionsPrelude__apply4003->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4003);
  meth_meth_collectionsPrelude__apply4003->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4003->definitionLine = 1667;
// compiled block node returning block4002 (depth = 6)
  gc_frame_newslot(block4002);
// call case 6: other member request
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4011 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4012 = callmethodflags(self, "unused", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4011);
// compiled call node returning call4012 (depth = 8)
// compiled member node returning call4012 (depth = 7)
  int op_slot_right_4010 = gc_frame_newslot(call4012);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_left_4010 = gc_frame_newslot(*var_a);
  params[0] = call4012;
  partcv[0] = 1;
  Object opresult4014 = callmethod(*var_a, "!=", 1, partcv, params);
// compiled op node returning opresult4014 (depth = 6)
  params[0] = block4002;
  partcv[0] = 1;
  Object call4015 = callmethod(opresult4014, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe4001);
// compiled call node returning call4015 (depth = 5)
  Object if4000 = done;
  if (istrue(call4015)) {
// Begin line 1669
  setline(1669);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4016 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4017 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_a (depth = 8)
  partcv[0] = 0;
  Object call4018 = callmethod(*var_a, "value",
    1, partcv, params);
  gc_frame_end(callframe4017);
// compiled call node returning call4018 (depth = 7)
// compiled member node returning call4018 (depth = 6)
  gc_frame_newslot(call4018);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_block1 (depth = 6)
  params[0] = call4018;
  partcv[0] = 1;
  Object call4019 = callmethod(*var_block1, "apply",
    1, partcv, params);
  gc_frame_end(callframe4016);
// compiled call node returning call4019 (depth = 5)
    gc_frame_newslot(call4019);
    if4000 = call4019;
  } else {
  }
// compiled if node returning if4000 (depth = 4)
  gc_frame_end(frame);
  return if4000;
}
Object meth_collectionsPrelude_valuesDo3980(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "valuesDo");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method valuesDo");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for valuesDo (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for valuesDo");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1666
  setline(1666);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3981 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3984 = alloc_Float64(1);
// compiled num node returning num3984 (depth = 5)
  int op_slot_right_3983 = gc_frame_newslot(num3984);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3986 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3987 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3988 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3987);
// compiled call node returning call3988 (depth = 8)
// compiled member node returning call3988 (depth = 7)
  partcv[0] = 0;
  Object call3989 = callmethod(call3988, "size",
    1, partcv, params);
  gc_frame_end(callframe3986);
// compiled call node returning call3989 (depth = 6)
// compiled member node returning call3989 (depth = 5)
  int op_slot_left_3983 = gc_frame_newslot(call3989);
  params[0] = num3984;
  partcv[0] = 1;
  Object diff3990 = callmethod(call3989, "-", 1, partcv, params);
// compiled op node returning diff3990 (depth = 4)
  int op_slot_right_3982 = gc_frame_newslot(diff3990);
// starting to compile num node (depth = 4)
  Object num3992 = alloc_Float64(0);
// compiled num node returning num3992 (depth = 4)
  int op_slot_left_3982 = gc_frame_newslot(num3992);
  params[0] = diff3990;
  partcv[0] = 1;
  Object opresult3993 = callmethod(num3992, "..", 1, partcv, params);
// compiled op node returning opresult3993 (depth = 3)
  gc_frame_newslot(opresult3993);
// starting to compile block node (depth = 3)
  Object block3994 = alloc_Block(NULL, NULL, "collectionsPrelude", 1666);
  gc_frame_newslot(block3994);
// method _apply
  block_savedest(block3994);
  Object closure3995 = createclosure(2, "_apply");
  setclosureframe(closure3995, stackframe);
  addtoclosure(closure3995, var_block1);
  addtoclosure(closure3995, selfslot);
  struct UserObject *uo3995 = (struct UserObject*)block3994;
  uo3995->data[0] = (Object)closure3995;
  Method *meth_meth_collectionsPrelude__apply3995 = addmethod2pos(block3994, "_apply", &meth_collectionsPrelude__apply3995, 0);
  int argcv_meth_collectionsPrelude__apply3995[] = {1};
  meth_meth_collectionsPrelude__apply3995->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply3995);
  meth_meth_collectionsPrelude__apply3995->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply3995->definitionLine = 1666;
// compiled block node returning block3994 (depth = 3)
  gc_frame_newslot(block3994);
// call case 5: prelude request
  params[0] = opresult3993;
  params[1] = block3994;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4021 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3981);
// compiled call node returning call4021 (depth = 2)
  gc_frame_end(frame);
  return call4021;
}
Object meth_collectionsPrelude_do4022(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method do");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for do (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for do");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1673
  setline(1673);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4023 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_block1 (depth = 3)
  gc_frame_newslot(*var_block1);
// call case 4: self request
  params[0] = *var_block1;
  partcv[0] = 1;
  Object call4024 = callmethodflags(self, "valuesDo", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4023);
// compiled call node returning call4024 (depth = 2)
  gc_frame_end(frame);
  return call4024;
}
Object meth_collectionsPrelude__apply4046(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile return node (depth = 10)
// starting to compile identifier node (depth = 11)
  Object bool4047 = alloc_Boolean(0);
// compiled identifier node returning bool4047 (depth = 11)
  block_return(realself, bool4047);
// compiled return node returning undefined (depth = 10)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply4040(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_o = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  Object *var_v = &(stackframe->slots[1]);
  *var_v = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1680
  setline(1680);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_v (depth = 8)
  int op_slot_right_4042 = gc_frame_newslot(*var_v);
// starting to compile call node (depth = 8)
  int callframe4044 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_k (depth = 9)
  gc_frame_newslot(*var_k);
// starting to compile block node (depth = 9)
  Object block4045 = alloc_Block(NULL, NULL, "collectionsPrelude", 1680);
  gc_frame_newslot(block4045);
// method _apply
  block_savedest(block4045);
  Object closure4046 = createclosure(1, "_apply");
  setclosureframe(closure4046, stackframe);
  addtoclosure(closure4046, selfslot);
  struct UserObject *uo4046 = (struct UserObject*)block4045;
  uo4046->data[0] = (Object)closure4046;
  Method *meth_meth_collectionsPrelude__apply4046 = addmethod2pos(block4045, "_apply", &meth_collectionsPrelude__apply4046, 0);
  int argcv_meth_collectionsPrelude__apply4046[] = {0};
  meth_meth_collectionsPrelude__apply4046->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4046);
  meth_meth_collectionsPrelude__apply4046->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4046->definitionLine = 1678;
// compiled block node returning block4045 (depth = 9)
  gc_frame_newslot(block4045);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_o (depth = 9)
  params[0] = *var_k;
  params[1] = block4045;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4049 = callmethod(*var_o, "at()ifAbsent",
    2, partcv, params);
  gc_frame_end(callframe4044);
// compiled call node returning call4049 (depth = 8)
  int op_slot_left_4042 = gc_frame_newslot(call4049);
  params[0] = *var_v;
  partcv[0] = 1;
  Object opresult4050 = callmethod(call4049, "!=", 1, partcv, params);
// compiled op node returning opresult4050 (depth = 7)
  Object if4041 = done;
  if (istrue(opresult4050)) {
// Begin line 1681
  setline(1681);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool4051 = alloc_Boolean(0);
// compiled identifier node returning bool4051 (depth = 8)
  block_return(realself, bool4051);
// compiled return node returning undefined (depth = 7)
    gc_frame_newslot(undefined);
    if4041 = undefined;
  } else {
  }
// compiled if node returning if4041 (depth = 6)
  gc_frame_end(frame);
  return if4041;
}
Object meth_collectionsPrelude__apply4028(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1678
  setline(1678);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4031 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_o (depth = 8)
  partcv[0] = 0;
  Object call4032 = callmethod(*var_o, "size",
    1, partcv, params);
  gc_frame_end(callframe4031);
// compiled call node returning call4032 (depth = 7)
// compiled member node returning call4032 (depth = 6)
  int op_slot_right_4030 = gc_frame_newslot(call4032);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4034 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4035 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4034);
// compiled call node returning call4035 (depth = 7)
// compiled member node returning call4035 (depth = 6)
  int op_slot_left_4030 = gc_frame_newslot(call4035);
  params[0] = call4032;
  partcv[0] = 1;
  Object opresult4036 = callmethod(call4035, "!=", 1, partcv, params);
// compiled op node returning opresult4036 (depth = 5)
  Object if4029 = done;
  if (istrue(opresult4036)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool4037 = alloc_Boolean(0);
// compiled identifier node returning bool4037 (depth = 6)
  block_return(realself, bool4037);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if4029 = undefined;
  } else {
  }
// compiled if node returning if4029 (depth = 4)
// Begin line 1679
  setline(1679);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4038 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block4039 = alloc_Block(NULL, NULL, "collectionsPrelude", 1679);
  gc_frame_newslot(block4039);
// method _apply
  block_savedest(block4039);
  Object closure4040 = createclosure(2, "_apply");
  setclosureframe(closure4040, stackframe);
  addtoclosure(closure4040, var_o);
  addtoclosure(closure4040, selfslot);
  struct UserObject *uo4040 = (struct UserObject*)block4039;
  uo4040->data[0] = (Object)closure4040;
  Method *meth_meth_collectionsPrelude__apply4040 = addmethod2pos(block4039, "_apply", &meth_collectionsPrelude__apply4040, 0);
  int argcv_meth_collectionsPrelude__apply4040[] = {2};
  meth_meth_collectionsPrelude__apply4040->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4040);
  meth_meth_collectionsPrelude__apply4040->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4040->definitionLine = 1678;
// compiled block node returning block4039 (depth = 5)
  gc_frame_newslot(block4039);
// call case 4: self request
  params[0] = block4039;
  partcv[0] = 1;
  Object call4053 = callmethodflags(self, "keysAndValuesDo", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4038);
// compiled call node returning call4053 (depth = 4)
// Begin line 1684
  setline(1684);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool4054 = alloc_Boolean(1);
// compiled identifier node returning bool4054 (depth = 5)
  block_return(realself, bool4054);
// compiled return node returning undefined (depth = 4)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply4066(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___21 = &(stackframe->slots[0]);
  *var___21 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1687
  setline(1687);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool4067 = alloc_Boolean(0);
// compiled identifier node returning bool4067 (depth = 5)
  block_return(realself, bool4067);
// compiled return node returning undefined (depth = 4)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__61__61_4025(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 33, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "==");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method ==");
  Object params[2];
  int partcv[1];
  Object *var_Dictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for == (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for ==");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1676
  setline(1676);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  int frame4026 = gc_frame_new();
  gc_frame_newslot(*var_other);
// Begin line 1677
  setline(1677);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4027 = alloc_Block(NULL, NULL, "collectionsPrelude", 1677);
  gc_frame_newslot(block4027);
// method _apply
  block_savedest(block4027);
  Object closure4028 = createclosure(1, "_apply");
  setclosureframe(closure4028, stackframe);
  addtoclosure(closure4028, selfslot);
  struct UserObject *uo4028 = (struct UserObject*)block4027;
  uo4028->data[0] = (Object)closure4028;
  Method *meth_meth_collectionsPrelude__apply4028 = addmethod2pos(block4027, "_apply", &meth_collectionsPrelude__apply4028, 0);
  int argcv_meth_collectionsPrelude__apply4028[] = {1};
  meth_meth_collectionsPrelude__apply4028->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4028);
  meth_meth_collectionsPrelude__apply4028->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4028->definitionLine = 1669;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4056 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe4057 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4058 == NULL) {
    strlit4058 = alloc_String("o");
    gc_root(strlit4058);
  }
// compiled string node returning strlit4058 (depth = 6)
  gc_frame_newslot(strlit4058);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4059 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4060 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4059);
// compiled call node returning call4060 (depth = 7)
// compiled member node returning call4060 (depth = 6)
  params[0] = strlit4058;
  partcv[0] = 1;
  Object call4061 = callmethod(call4060, "new",
    1, partcv, params);
  gc_frame_end(callframe4057);
// compiled call node returning call4061 (depth = 5)
  gc_frame_newslot(call4061);
// Begin line 1677
  setline(1677);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_Dictionary (depth = 5)
  gc_frame_newslot(*var_Dictionary);
// call case 6: other member request
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4062 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4063 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4062);
// compiled call node returning call4063 (depth = 6)
// compiled member node returning call4063 (depth = 5)
  params[0] = call4061;
  params[1] = *var_Dictionary;
  partcv[0] = 2;
  Object call4064 = callmethod(call4063, "new",
    1, partcv, params);
  gc_frame_end(callframe4056);
// compiled call node returning call4064 (depth = 4)
((struct UserObject *)block4027)->data[1] = call4064;
// compiled block node returning block4027 (depth = 3)
  gc_frame_newslot(block4027);
// Begin line 1686
  setline(1686);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4065 = alloc_Block(NULL, NULL, "collectionsPrelude", 1686);
  gc_frame_newslot(block4065);
// method _apply
  block_savedest(block4065);
  Object closure4066 = createclosure(1, "_apply");
  setclosureframe(closure4066, stackframe);
  addtoclosure(closure4066, selfslot);
  struct UserObject *uo4066 = (struct UserObject*)block4065;
  uo4066->data[0] = (Object)closure4066;
  Method *meth_meth_collectionsPrelude__apply4066 = addmethod2pos(block4065, "_apply", &meth_collectionsPrelude__apply4066, 0);
  int argcv_meth_collectionsPrelude__apply4066[] = {1};
  meth_meth_collectionsPrelude__apply4066->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4066);
  meth_meth_collectionsPrelude__apply4066->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4066->definitionLine = 0;
// compiled block node returning block4065 (depth = 3)
  gc_frame_newslot(block4065);
  params[0] = block4027;
  params[1] = block4065;
  Object matchres4026 = matchCase(*var_other, params, 2,NULL);
  gc_frame_end(frame4026);
// compiled matchcase node returning matchres4026 (depth = 2)
  gc_frame_end(frame);
  return matchres4026;
}
Object meth_collectionsPrelude__apply4080(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_newCopy = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  Object *var_v = &(stackframe->slots[1]);
  *var_v = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1694
  setline(1694);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4081 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_k (depth = 5)
  gc_frame_newslot(*var_k);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_v (depth = 5)
  gc_frame_newslot(*var_v);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newCopy (depth = 5)
  params[0] = *var_k;
  params[1] = *var_v;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4082 = callmethod(*var_newCopy, "at()put",
    2, partcv, params);
  gc_frame_end(callframe4081);
// compiled call node returning call4082 (depth = 4)
  gc_frame_end(frame);
  return call4082;
}
Object meth_collectionsPrelude_copy4069(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "copy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for copy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for copy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newCopy = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "newCopy");
// Begin line 1692
  setline(1692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4070 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4071 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4072 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4073 = gc_frame_new();
// call case 3: self.outer request
  Object call4074 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4073);
// compiled call node returning call4074 (depth = 10)
// compiled member node returning call4074 (depth = 9)
  partcv[0] = 0;
  Object call4075 = callmethodflags(call4074, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4072);
// compiled call node returning call4075 (depth = 8)
// compiled member node returning call4075 (depth = 7)
  partcv[0] = 0;
  Object call4076 = callmethodflags(call4075, "dictionary", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4071);
// compiled call node returning call4076 (depth = 6)
// compiled member node returning call4076 (depth = 5)
  partcv[0] = 0;
  Object call4077 = callmethod(call4076, "empty",
    1, partcv, params);
  gc_frame_end(callframe4070);
// compiled call node returning call4077 (depth = 4)
// compiled member node returning call4077 (depth = 3)
  *var_newCopy = call4077;
  if (call4077 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1693
  setline(1693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4078 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block4079 = alloc_Block(NULL, NULL, "collectionsPrelude", 1693);
  gc_frame_newslot(block4079);
// method _apply
  block_savedest(block4079);
  Object closure4080 = createclosure(2, "_apply");
  setclosureframe(closure4080, stackframe);
  addtoclosure(closure4080, var_newCopy);
  addtoclosure(closure4080, selfslot);
  struct UserObject *uo4080 = (struct UserObject*)block4079;
  uo4080->data[0] = (Object)closure4080;
  Method *meth_meth_collectionsPrelude__apply4080 = addmethod2pos(block4079, "_apply", &meth_collectionsPrelude__apply4080, 0);
  int argcv_meth_collectionsPrelude__apply4080[] = {2};
  meth_meth_collectionsPrelude__apply4080->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4080);
  meth_meth_collectionsPrelude__apply4080->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4080->definitionLine = 1692;
// compiled block node returning block4079 (depth = 3)
  gc_frame_newslot(block4079);
// call case 4: self request
  params[0] = block4079;
  partcv[0] = 1;
  Object call4084 = callmethodflags(self, "keysAndValuesDo", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4078);
// compiled call node returning call4084 (depth = 2)
// Begin line 1696
  setline(1696);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_newCopy (depth = 2)
  gc_frame_end(frame);
  return *var_newCopy;
}
Object meth_collectionsPrelude_asDictionary4085(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asDictionary");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asDictionary (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asDictionary");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1700
  setline(1700);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply4091(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_newDict = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  Object *var_v = &(stackframe->slots[1]);
  *var_v = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1706
  setline(1706);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4092 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_k (depth = 5)
  gc_frame_newslot(*var_k);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_v (depth = 5)
  gc_frame_newslot(*var_v);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newDict (depth = 5)
  params[0] = *var_k;
  params[1] = *var_v;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4093 = callmethod(*var_newDict, "at()put",
    2, partcv, params);
  gc_frame_end(callframe4092);
// compiled call node returning call4093 (depth = 4)
  gc_frame_end(frame);
  return call4093;
}
Object meth_collectionsPrelude__43__43_4086(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "++");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method ++");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for ++ (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for ++");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newDict = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "newDict");
// Begin line 1704
  setline(1704);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4087 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4088 = callmethodflags(self, "copy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4087);
// compiled call node returning call4088 (depth = 4)
// compiled member node returning call4088 (depth = 3)
  *var_newDict = call4088;
  if (call4088 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1705
  setline(1705);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4089 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block4090 = alloc_Block(NULL, NULL, "collectionsPrelude", 1705);
  gc_frame_newslot(block4090);
// method _apply
  block_savedest(block4090);
  Object closure4091 = createclosure(2, "_apply");
  setclosureframe(closure4091, stackframe);
  addtoclosure(closure4091, var_newDict);
  addtoclosure(closure4091, selfslot);
  struct UserObject *uo4091 = (struct UserObject*)block4090;
  uo4091->data[0] = (Object)closure4091;
  Method *meth_meth_collectionsPrelude__apply4091 = addmethod2pos(block4090, "_apply", &meth_collectionsPrelude__apply4091, 0);
  int argcv_meth_collectionsPrelude__apply4091[] = {2};
  meth_meth_collectionsPrelude__apply4091->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4091);
  meth_meth_collectionsPrelude__apply4091->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4091->definitionLine = 1704;
// compiled block node returning block4090 (depth = 3)
  gc_frame_newslot(block4090);
// call case 6: other member request
// Begin line 1705
  setline(1705);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  params[0] = block4090;
  partcv[0] = 1;
  Object call4095 = callmethod(*var_other, "keysAndValuesDo",
    1, partcv, params);
  gc_frame_end(callframe4089);
// compiled call node returning call4095 (depth = 2)
// Begin line 1708
  setline(1708);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_newDict (depth = 3)
  return *var_newDict;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply4107(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_other = getfromclosure(closure, 0);
  Object *var_newDict = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  Object *var_v = &(stackframe->slots[1]);
  *var_v = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1714
  setline(1714);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4109 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 6)
  int callframe4110 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_k (depth = 7)
  gc_frame_newslot(*var_k);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  params[0] = *var_k;
  partcv[0] = 1;
  Object call4111 = callmethod(*var_other, "containsKey",
    1, partcv, params);
  gc_frame_end(callframe4110);
// compiled call node returning call4111 (depth = 6)
  partcv[0] = 0;
  Object call4112 = callmethod(call4111, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe4109);
// compiled call node returning call4112 (depth = 5)
  Object if4108 = done;
  if (istrue(call4112)) {
// Begin line 1715
  setline(1715);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4113 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_k (depth = 6)
  gc_frame_newslot(*var_k);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  gc_frame_newslot(*var_v);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newDict (depth = 6)
  params[0] = *var_k;
  params[1] = *var_v;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4114 = callmethod(*var_newDict, "at()put",
    2, partcv, params);
  gc_frame_end(callframe4113);
// compiled call node returning call4114 (depth = 5)
    gc_frame_newslot(call4114);
    if4108 = call4114;
  } else {
  }
// compiled if node returning if4108 (depth = 4)
  gc_frame_end(frame);
  return if4108;
}
Object meth_collectionsPrelude__45__45_4096(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "--");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method --");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for -- (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for --");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newDict = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "newDict");
// Begin line 1712
  setline(1712);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4097 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4098 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4099 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4100 = gc_frame_new();
// call case 3: self.outer request
  Object call4101 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4100);
// compiled call node returning call4101 (depth = 10)
// compiled member node returning call4101 (depth = 9)
  partcv[0] = 0;
  Object call4102 = callmethodflags(call4101, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4099);
// compiled call node returning call4102 (depth = 8)
// compiled member node returning call4102 (depth = 7)
  partcv[0] = 0;
  Object call4103 = callmethodflags(call4102, "dictionary", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4098);
// compiled call node returning call4103 (depth = 6)
// compiled member node returning call4103 (depth = 5)
  partcv[0] = 0;
  Object call4104 = callmethod(call4103, "empty",
    1, partcv, params);
  gc_frame_end(callframe4097);
// compiled call node returning call4104 (depth = 4)
// compiled member node returning call4104 (depth = 3)
  *var_newDict = call4104;
  if (call4104 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1713
  setline(1713);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4105 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block4106 = alloc_Block(NULL, NULL, "collectionsPrelude", 1713);
  gc_frame_newslot(block4106);
// method _apply
  block_savedest(block4106);
  Object closure4107 = createclosure(3, "_apply");
  setclosureframe(closure4107, stackframe);
  addtoclosure(closure4107, var_other);
  addtoclosure(closure4107, var_newDict);
  addtoclosure(closure4107, selfslot);
  struct UserObject *uo4107 = (struct UserObject*)block4106;
  uo4107->data[0] = (Object)closure4107;
  Method *meth_meth_collectionsPrelude__apply4107 = addmethod2pos(block4106, "_apply", &meth_collectionsPrelude__apply4107, 0);
  int argcv_meth_collectionsPrelude__apply4107[] = {2};
  meth_meth_collectionsPrelude__apply4107->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4107);
  meth_meth_collectionsPrelude__apply4107->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4107->definitionLine = 1712;
// compiled block node returning block4106 (depth = 3)
  gc_frame_newslot(block4106);
// call case 4: self request
  params[0] = block4106;
  partcv[0] = 1;
  Object call4116 = callmethodflags(self, "keysAndValuesDo", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4105);
// compiled call node returning call4116 (depth = 2)
// Begin line 1718
  setline(1718);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_newDict (depth = 3)
  return *var_newDict;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_asString4131(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1407
  setline(1407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit4132 == NULL) {
    strlit4132 = alloc_String("unused");
    gc_root(strlit4132);
  }
// compiled string node returning strlit4132 (depth = 2)
  gc_frame_end(frame);
  return strlit4132;
}
Object meth_collectionsPrelude_asString4139(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1413
  setline(1413);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit4140 == NULL) {
    strlit4140 = alloc_String("removed");
    gc_root(strlit4140);
  }
// compiled string node returning strlit4140 (depth = 2)
  gc_frame_end(frame);
  return strlit4140;
}
Object meth_collectionsPrelude__apply4156(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1416
  setline(1416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4157 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  gc_frame_newslot(*var_i);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4158 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4159 = callmethodflags(self, "unused", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4158);
// compiled call node returning call4159 (depth = 6)
// compiled member node returning call4159 (depth = 5)
  gc_frame_newslot(call4159);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4160 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4161 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4160);
// compiled call node returning call4161 (depth = 6)
// compiled member node returning call4161 (depth = 5)
  params[0] = *var_i;
  params[1] = call4159;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4162 = callmethod(call4161, "at()put",
    2, partcv, params);
  gc_frame_end(callframe4157);
// compiled call node returning call4162 (depth = 4)
  gc_frame_end(frame);
  return call4162;
}
Object meth_collectionsPrelude__apply4167(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe4168 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4169 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_b (depth = 7)
  partcv[0] = 0;
  Object call4170 = callmethod(*var_b, "key",
    1, partcv, params);
  gc_frame_end(callframe4169);
// compiled call node returning call4170 (depth = 6)
// compiled member node returning call4170 (depth = 5)
  gc_frame_newslot(call4170);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4171 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_b (depth = 7)
  partcv[0] = 0;
  Object call4172 = callmethod(*var_b, "value",
    1, partcv, params);
  gc_frame_end(callframe4171);
// compiled call node returning call4172 (depth = 6)
// compiled member node returning call4172 (depth = 5)
  gc_frame_newslot(call4172);
// call case 4: self request
  params[0] = call4170;
  params[1] = call4172;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4173 = callmethodflags(self, "at()put", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4168);
// compiled call node returning call4173 (depth = 4)
  gc_frame_end(frame);
  return call4173;
}
Object meth_collectionsPrelude_withAll2984(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "withAll");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method withAll");
  Object params[2];
  int partcv[2];
  Object *var_binding = getfromclosure(closure, 0);
  Object *var_done = getfromclosure(closure, 1);
  Object *var_NoSuchObject = getfromclosure(closure, 2);
  Object *var_enumerable = getfromclosure(closure, 3);
  Object *var_ConcurrentModification = getfromclosure(closure, 4);
  Object *var_Exhausted = getfromclosure(closure, 5);
  Object *var__prelude = getfromclosure(closure, 6);
  Object *var_Dictionary = getfromclosure(closure, 7);
  Object *var_collection = getfromclosure(closure, 8);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for withAll (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_initialBindings = &(stackframe->slots[0]);
  *var_initialBindings = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for withAll");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2985 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2985 = alloc_userobj2(47,45, objclass2985);
  gc_frame_newslot(obj2985);
if (objclass2985 == NULL) {
  glfree(obj2985->class->name);
  obj2985->class->name = "obj2977.withAll";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2985, self, 0);
  addmethodreal(obj2985,"outer", &reader_collectionsPrelude_outer_2986);
  Object oldself2985 = self;
  struct StackFrameObject *oldstackframe2985 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2985);
  gc_frame_newslot((Object)stackframe);
  self = obj2985;
  Object *oldselfslot2985 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2985 = (*(struct UserObject *)self).data[0], lowerouter2985 = thisouter2985;
  if (inheritingObject2985) {
    struct UserObject *inho2985 = (struct UserObject *)inheritingObject2985;
    while (inho2985->super != GraceDefaultObject) inho2985 = (struct UserObject *)inho2985->super;
    inho2985->super = obj2985;
    self = inheritingObject2985;
    *selfslot = self;
    lowerouter2985 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2985;
  }
if (objclass2985 == NULL) {
  Method *reader2987 = addmethodrealflags(obj2985, "mods",&reader_collectionsPrelude_mods_2987, 0);
  Method *writer2987 = addmethodrealflags(obj2985, "mods:=",&writer_collectionsPrelude_mods_2987, MFLAG_CONFIDENTIAL);
  reader2987->definitionModule = modulename;
  writer2987->definitionModule = modulename;
  reader2987->definitionLine = 1400;
  writer2987->definitionLine = 1400;
}
obj2985->flags |= OFLAG_MUTABLE;
adddatum2(obj2985, alloc_Undefined(), 1);
if (objclass2985 == NULL) {
  Method *reader2988 = addmethodrealflags(obj2985, "numBindings",&reader_collectionsPrelude_numBindings_2988, MFLAG_CONFIDENTIAL);
  Method *writer2988 = addmethodrealflags(obj2985, "numBindings:=",&writer_collectionsPrelude_numBindings_2988, MFLAG_CONFIDENTIAL);
  reader2988->definitionModule = modulename;
  writer2988->definitionModule = modulename;
  reader2988->definitionLine = 1401;
  writer2988->definitionLine = 1401;
}
obj2985->flags |= OFLAG_MUTABLE;
adddatum2(obj2985, alloc_Undefined(), 2);
if (objclass2985 == NULL) {
  Method *reader2989 = addmethodrealflags(obj2985, "inner",&reader_collectionsPrelude_inner_2989, MFLAG_CONFIDENTIAL);
  Method *writer2989 = addmethodrealflags(obj2985, "inner:=",&writer_collectionsPrelude_inner_2989, MFLAG_CONFIDENTIAL);
  reader2989->definitionModule = modulename;
  writer2989->definitionModule = modulename;
  reader2989->definitionLine = 1402;
  writer2989->definitionLine = 1402;
}
obj2985->flags |= OFLAG_MUTABLE;
adddatum2(obj2985, alloc_Undefined(), 3);
if (objclass2985 == NULL) {
  Method *reader2990 = addmethodrealflags(obj2985, "unused",&reader_collectionsPrelude_unused_2990, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader2990->definitionModule = modulename;
  reader2990->definitionLine = 1403;
}
adddatum2(obj2985, alloc_Undefined(), 4);
if (objclass2985 == NULL) {
  Method *reader2991 = addmethodrealflags(obj2985, "removed",&reader_collectionsPrelude_removed_2991, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader2991->definitionModule = modulename;
  reader2991->definitionLine = 1409;
}
adddatum2(obj2985, alloc_Undefined(), 5);
// method size
  struct UserObject *uo2992 = (struct UserObject*)obj2985;
  uo2992->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_size2992 = addmethod2pos(obj2985, "size", &meth_collectionsPrelude_size2992, 6);
  int argcv_meth_collectionsPrelude_size2992[] = {0};
  meth_meth_collectionsPrelude_size2992->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size2992);
  meth_meth_collectionsPrelude_size2992->definitionModule = modulename;
  meth_meth_collectionsPrelude_size2992->definitionLine = 1419;
// method at()put
  block_savedest(obj2985);
  Object closure2995 = createclosure(1, "at()put");
  setclosureframe(closure2995, stackframe);
  addtoclosure(closure2995, var_binding);
  struct UserObject *uo2995 = (struct UserObject*)obj2985;
  uo2995->data[7] = (Object)closure2995;
  Method *meth_meth_collectionsPrelude_at_40__41_put2995 = addmethod2pos(obj2985, "at()put", &meth_collectionsPrelude_at_40__41_put2995, 7);
  int argcv_meth_collectionsPrelude_at_40__41_put2995[] = {1, 1};
  meth_meth_collectionsPrelude_at_40__41_put2995->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_at_40__41_put2995);
  meth_meth_collectionsPrelude_at_40__41_put2995->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40__41_put2995->definitionLine = 1420;
// method []:=
  block_savedest(obj2985);
  Object closure3060 = createclosure(1, "[]:=");
  setclosureframe(closure3060, stackframe);
  addtoclosure(closure3060, var_done);
  struct UserObject *uo3060 = (struct UserObject*)obj2985;
  uo3060->data[8] = (Object)closure3060;
  Method *meth_meth_collectionsPrelude__91__93__58__61_3060 = addmethod2pos(obj2985, "[]:=", &meth_collectionsPrelude__91__93__58__61_3060, 8);
  int argcv_meth_collectionsPrelude__91__93__58__61_3060[] = {2};
  meth_meth_collectionsPrelude__91__93__58__61_3060->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__91__93__58__61_3060);
  meth_meth_collectionsPrelude__91__93__58__61_3060->definitionModule = modulename;
  meth_meth_collectionsPrelude__91__93__58__61_3060->definitionLine = 1430;
// method at
  block_savedest(obj2985);
  Object closure3063 = createclosure(1, "at");
  setclosureframe(closure3063, stackframe);
  addtoclosure(closure3063, var_NoSuchObject);
  struct UserObject *uo3063 = (struct UserObject*)obj2985;
  uo3063->data[9] = (Object)closure3063;
  Method *meth_meth_collectionsPrelude_at3063 = addmethod2pos(obj2985, "at", &meth_collectionsPrelude_at3063, 9);
  int argcv_meth_collectionsPrelude_at3063[] = {1};
  meth_meth_collectionsPrelude_at3063->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at3063);
  meth_meth_collectionsPrelude_at3063->definitionModule = modulename;
  meth_meth_collectionsPrelude_at3063->definitionLine = 1434;
// method at()ifAbsent
  struct UserObject *uo3088 = (struct UserObject*)obj2985;
  uo3088->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at_40__41_ifAbsent3088 = addmethod2pos(obj2985, "at()ifAbsent", &meth_collectionsPrelude_at_40__41_ifAbsent3088, 10);
  int argcv_meth_collectionsPrelude_at_40__41_ifAbsent3088[] = {1, 1};
  meth_meth_collectionsPrelude_at_40__41_ifAbsent3088->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_at_40__41_ifAbsent3088);
  meth_meth_collectionsPrelude_at_40__41_ifAbsent3088->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40__41_ifAbsent3088->definitionLine = 1441;
// method []
  struct UserObject *uo3105 = (struct UserObject*)obj2985;
  uo3105->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude__91__93_3105 = addmethod2pos(obj2985, "[]", &meth_collectionsPrelude__91__93_3105, 11);
  int argcv_meth_collectionsPrelude__91__93_3105[] = {1};
  meth_meth_collectionsPrelude__91__93_3105->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__91__93_3105);
  meth_meth_collectionsPrelude__91__93_3105->definitionModule = modulename;
  meth_meth_collectionsPrelude__91__93_3105->definitionLine = 1448;
// method containsKey
  struct UserObject *uo3108 = (struct UserObject*)obj2985;
  uo3108->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_containsKey3108 = addmethod2pos(obj2985, "containsKey", &meth_collectionsPrelude_containsKey3108, 12);
  int argcv_meth_collectionsPrelude_containsKey3108[] = {1};
  meth_meth_collectionsPrelude_containsKey3108->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_containsKey3108);
  meth_meth_collectionsPrelude_containsKey3108->definitionModule = modulename;
  meth_meth_collectionsPrelude_containsKey3108->definitionLine = 1449;
// method removeAllKeys
  block_savedest(obj2985);
  Object closure3123 = createclosure(1, "removeAllKeys");
  setclosureframe(closure3123, stackframe);
  addtoclosure(closure3123, var_NoSuchObject);
  struct UserObject *uo3123 = (struct UserObject*)obj2985;
  uo3123->data[13] = (Object)closure3123;
  Method *meth_meth_collectionsPrelude_removeAllKeys3123 = addmethod2pos(obj2985, "removeAllKeys", &meth_collectionsPrelude_removeAllKeys3123, 13);
  int argcv_meth_collectionsPrelude_removeAllKeys3123[] = {1};
  meth_meth_collectionsPrelude_removeAllKeys3123->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAllKeys3123);
  meth_meth_collectionsPrelude_removeAllKeys3123->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAllKeys3123->definitionLine = 1456;
// method removeKey
  struct UserObject *uo3173 = (struct UserObject*)obj2985;
  uo3173->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeKey3173 = addmethod2pos(obj2985, "removeKey", &meth_collectionsPrelude_removeKey3173, 14);
  int argcv_meth_collectionsPrelude_removeKey3173[] = {0};
  meth_meth_collectionsPrelude_removeKey3173->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeKey3173);
  meth_meth_collectionsPrelude_removeKey3173->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeKey3173->definitionLine = 1469;
// method removeAllValues
  struct UserObject *uo3176 = (struct UserObject*)obj2985;
  uo3176->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeAllValues3176 = addmethod2pos(obj2985, "removeAllValues", &meth_collectionsPrelude_removeAllValues3176, 15);
  int argcv_meth_collectionsPrelude_removeAllValues3176[] = {1};
  meth_meth_collectionsPrelude_removeAllValues3176->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAllValues3176);
  meth_meth_collectionsPrelude_removeAllValues3176->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAllValues3176->definitionLine = 1472;
// method removeValue
  struct UserObject *uo3225 = (struct UserObject*)obj2985;
  uo3225->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeValue3225 = addmethod2pos(obj2985, "removeValue", &meth_collectionsPrelude_removeValue3225, 16);
  int argcv_meth_collectionsPrelude_removeValue3225[] = {0};
  meth_meth_collectionsPrelude_removeValue3225->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeValue3225);
  meth_meth_collectionsPrelude_removeValue3225->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeValue3225->definitionLine = 1483;
// method containsValue
  struct UserObject *uo3228 = (struct UserObject*)obj2985;
  uo3228->data[17] = emptyclosure;
  Method *meth_meth_collectionsPrelude_containsValue3228 = addmethod2pos(obj2985, "containsValue", &meth_collectionsPrelude_containsValue3228, 17);
  int argcv_meth_collectionsPrelude_containsValue3228[] = {1};
  meth_meth_collectionsPrelude_containsValue3228->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_containsValue3228);
  meth_meth_collectionsPrelude_containsValue3228->definitionModule = modulename;
  meth_meth_collectionsPrelude_containsValue3228->definitionLine = 1486;
// method contains
  struct UserObject *uo3240 = (struct UserObject*)obj2985;
  uo3240->data[18] = emptyclosure;
  Method *meth_meth_collectionsPrelude_contains3240 = addmethod2pos(obj2985, "contains", &meth_collectionsPrelude_contains3240, 18);
  int argcv_meth_collectionsPrelude_contains3240[] = {1};
  meth_meth_collectionsPrelude_contains3240->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains3240);
  meth_meth_collectionsPrelude_contains3240->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains3240->definitionLine = 1492;
// method findPosition
  struct UserObject *uo3243 = (struct UserObject*)obj2985;
  uo3243->data[19] = emptyclosure;
  Method *meth_meth_collectionsPrelude_findPosition3243 = addmethod2pos(obj2985, "findPosition", &meth_collectionsPrelude_findPosition3243, 19);
  int argcv_meth_collectionsPrelude_findPosition3243[] = {1};
  meth_meth_collectionsPrelude_findPosition3243->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_findPosition3243);
  meth_meth_collectionsPrelude_findPosition3243->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_findPosition3243->definitionModule = modulename;
  meth_meth_collectionsPrelude_findPosition3243->definitionLine = 1493;
// method findPositionForAdd
  struct UserObject *uo3311 = (struct UserObject*)obj2985;
  uo3311->data[20] = emptyclosure;
  Method *meth_meth_collectionsPrelude_findPositionForAdd3311 = addmethod2pos(obj2985, "findPositionForAdd", &meth_collectionsPrelude_findPositionForAdd3311, 20);
  int argcv_meth_collectionsPrelude_findPositionForAdd3311[] = {1};
  meth_meth_collectionsPrelude_findPositionForAdd3311->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_findPositionForAdd3311);
  meth_meth_collectionsPrelude_findPositionForAdd3311->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_findPositionForAdd3311->definitionModule = modulename;
  meth_meth_collectionsPrelude_findPositionForAdd3311->definitionLine = 1511;
// method asString
  struct UserObject *uo3393 = (struct UserObject*)obj2985;
  uo3393->data[21] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString3393 = addmethod2pos(obj2985, "asString", &meth_collectionsPrelude_asString3393, 21);
  int argcv_meth_collectionsPrelude_asString3393[] = {0};
  meth_meth_collectionsPrelude_asString3393->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString3393);
  meth_meth_collectionsPrelude_asString3393->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString3393->definitionLine = 1529;
// method asDebugString
  struct UserObject *uo3468 = (struct UserObject*)obj2985;
  uo3468->data[22] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDebugString3468 = addmethod2pos(obj2985, "asDebugString", &meth_collectionsPrelude_asDebugString3468, 22);
  int argcv_meth_collectionsPrelude_asDebugString3468[] = {0};
  meth_meth_collectionsPrelude_asDebugString3468->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString3468);
  meth_meth_collectionsPrelude_asDebugString3468->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString3468->definitionLine = 1547;
// method keys
  block_savedest(obj2985);
  Object closure3570 = createclosure(1, "keys");
  setclosureframe(closure3570, stackframe);
  addtoclosure(closure3570, var_enumerable);
  struct UserObject *uo3570 = (struct UserObject*)obj2985;
  uo3570->data[23] = (Object)closure3570;
  Method *meth_meth_collectionsPrelude_keys3570 = addmethod2pos(obj2985, "keys", &meth_collectionsPrelude_keys3570, 23);
  int argcv_meth_collectionsPrelude_keys3570[] = {0};
  meth_meth_collectionsPrelude_keys3570->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys3570);
  meth_meth_collectionsPrelude_keys3570->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys3570->definitionLine = 1560;
  block_savedest(obj2985);
  Object closure3615 = createclosure(1, "keys()object");
  setclosureframe(closure3615, stackframe);
  addtoclosure(closure3615, var_enumerable);
  Method *meth_meth_collectionsPrelude_keys3570_object = addmethod2pos(obj2985, "keys()object", &meth_collectionsPrelude_keys3570_object, 23);
  meth_meth_collectionsPrelude_keys3570_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys3570_object->definitionLine = 1560;
// method values
  block_savedest(obj2985);
  Object closure3616 = createclosure(1, "values");
  setclosureframe(closure3616, stackframe);
  addtoclosure(closure3616, var_enumerable);
  struct UserObject *uo3616 = (struct UserObject*)obj2985;
  uo3616->data[24] = (Object)closure3616;
  Method *meth_meth_collectionsPrelude_values3616 = addmethod2pos(obj2985, "values", &meth_collectionsPrelude_values3616, 24);
  int argcv_meth_collectionsPrelude_values3616[] = {0};
  meth_meth_collectionsPrelude_values3616->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values3616);
  meth_meth_collectionsPrelude_values3616->definitionModule = modulename;
  meth_meth_collectionsPrelude_values3616->definitionLine = 1578;
  block_savedest(obj2985);
  Object closure3661 = createclosure(1, "values()object");
  setclosureframe(closure3661, stackframe);
  addtoclosure(closure3661, var_enumerable);
  Method *meth_meth_collectionsPrelude_values3616_object = addmethod2pos(obj2985, "values()object", &meth_collectionsPrelude_values3616_object, 24);
  meth_meth_collectionsPrelude_values3616_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_values3616_object->definitionLine = 1578;
// method bindings
  block_savedest(obj2985);
  Object closure3662 = createclosure(1, "bindings");
  setclosureframe(closure3662, stackframe);
  addtoclosure(closure3662, var_enumerable);
  struct UserObject *uo3662 = (struct UserObject*)obj2985;
  uo3662->data[25] = (Object)closure3662;
  Method *meth_meth_collectionsPrelude_bindings3662 = addmethod2pos(obj2985, "bindings", &meth_collectionsPrelude_bindings3662, 25);
  int argcv_meth_collectionsPrelude_bindings3662[] = {0};
  meth_meth_collectionsPrelude_bindings3662->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_bindings3662);
  meth_meth_collectionsPrelude_bindings3662->definitionModule = modulename;
  meth_meth_collectionsPrelude_bindings3662->definitionLine = 1597;
  block_savedest(obj2985);
  Object closure3682 = createclosure(1, "bindings()object");
  setclosureframe(closure3682, stackframe);
  addtoclosure(closure3682, var_enumerable);
  Method *meth_meth_collectionsPrelude_bindings3662_object = addmethod2pos(obj2985, "bindings()object", &meth_collectionsPrelude_bindings3662_object, 25);
  meth_meth_collectionsPrelude_bindings3662_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_bindings3662_object->definitionLine = 1597;
// method iterator
  struct UserObject *uo3683 = (struct UserObject*)obj2985;
  uo3683->data[26] = emptyclosure;
  Method *meth_meth_collectionsPrelude_iterator3683 = addmethod2pos(obj2985, "iterator", &meth_collectionsPrelude_iterator3683, 26);
  int argcv_meth_collectionsPrelude_iterator3683[] = {0};
  meth_meth_collectionsPrelude_iterator3683->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator3683);
  meth_meth_collectionsPrelude_iterator3683->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator3683->definitionLine = 1609;
// method bindingsIterator
  block_savedest(obj2985);
  Object closure3688 = createclosure(2, "bindingsIterator");
  setclosureframe(closure3688, stackframe);
  addtoclosure(closure3688, var_ConcurrentModification);
  addtoclosure(closure3688, var_Exhausted);
  struct UserObject *uo3688 = (struct UserObject*)obj2985;
  uo3688->data[27] = (Object)closure3688;
  Method *meth_meth_collectionsPrelude_bindingsIterator3688 = addmethod2pos(obj2985, "bindingsIterator", &meth_collectionsPrelude_bindingsIterator3688, 27);
  int argcv_meth_collectionsPrelude_bindingsIterator3688[] = {0};
  meth_meth_collectionsPrelude_bindingsIterator3688->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_bindingsIterator3688);
  meth_meth_collectionsPrelude_bindingsIterator3688->definitionModule = modulename;
  meth_meth_collectionsPrelude_bindingsIterator3688->definitionLine = 1610;
  block_savedest(obj2985);
  Object closure3817 = createclosure(2, "bindingsIterator()object");
  setclosureframe(closure3817, stackframe);
  addtoclosure(closure3817, var_ConcurrentModification);
  addtoclosure(closure3817, var_Exhausted);
  Method *meth_meth_collectionsPrelude_bindingsIterator3688_object = addmethod2pos(obj2985, "bindingsIterator()object", &meth_collectionsPrelude_bindingsIterator3688_object, 27);
  meth_meth_collectionsPrelude_bindingsIterator3688_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_bindingsIterator3688_object->definitionLine = 1610;
// method expand
  block_savedest(obj2985);
  Object closure3818 = createclosure(1, "expand");
  setclosureframe(closure3818, stackframe);
  addtoclosure(closure3818, var__prelude);
  struct UserObject *uo3818 = (struct UserObject*)obj2985;
  uo3818->data[28] = (Object)closure3818;
  Method *meth_meth_collectionsPrelude_expand3818 = addmethod2pos(obj2985, "expand", &meth_collectionsPrelude_expand3818, 28);
  int argcv_meth_collectionsPrelude_expand3818[] = {0};
  meth_meth_collectionsPrelude_expand3818->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_expand3818);
  meth_meth_collectionsPrelude_expand3818->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_expand3818->definitionModule = modulename;
  meth_meth_collectionsPrelude_expand3818->definitionLine = 1633;
// method keysAndValuesDo
  struct UserObject *uo3894 = (struct UserObject*)obj2985;
  uo3894->data[29] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo3894 = addmethod2pos(obj2985, "keysAndValuesDo", &meth_collectionsPrelude_keysAndValuesDo3894, 29);
  int argcv_meth_collectionsPrelude_keysAndValuesDo3894[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo3894->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo3894);
  meth_meth_collectionsPrelude_keysAndValuesDo3894->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo3894->definitionLine = 1649;
// method keysDo
  struct UserObject *uo3938 = (struct UserObject*)obj2985;
  uo3938->data[30] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keysDo3938 = addmethod2pos(obj2985, "keysDo", &meth_collectionsPrelude_keysDo3938, 30);
  int argcv_meth_collectionsPrelude_keysDo3938[] = {1};
  meth_meth_collectionsPrelude_keysDo3938->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysDo3938);
  meth_meth_collectionsPrelude_keysDo3938->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysDo3938->definitionLine = 1657;
// method valuesDo
  struct UserObject *uo3980 = (struct UserObject*)obj2985;
  uo3980->data[31] = emptyclosure;
  Method *meth_meth_collectionsPrelude_valuesDo3980 = addmethod2pos(obj2985, "valuesDo", &meth_collectionsPrelude_valuesDo3980, 31);
  int argcv_meth_collectionsPrelude_valuesDo3980[] = {1};
  meth_meth_collectionsPrelude_valuesDo3980->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_valuesDo3980);
  meth_meth_collectionsPrelude_valuesDo3980->definitionModule = modulename;
  meth_meth_collectionsPrelude_valuesDo3980->definitionLine = 1665;
// method do
  struct UserObject *uo4022 = (struct UserObject*)obj2985;
  uo4022->data[32] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do4022 = addmethod2pos(obj2985, "do", &meth_collectionsPrelude_do4022, 32);
  int argcv_meth_collectionsPrelude_do4022[] = {1};
  meth_meth_collectionsPrelude_do4022->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do4022);
  meth_meth_collectionsPrelude_do4022->definitionModule = modulename;
  meth_meth_collectionsPrelude_do4022->definitionLine = 1673;
// method ==
  block_savedest(obj2985);
  Object closure4025 = createclosure(1, "==");
  setclosureframe(closure4025, stackframe);
  addtoclosure(closure4025, var_Dictionary);
  struct UserObject *uo4025 = (struct UserObject*)obj2985;
  uo4025->data[33] = (Object)closure4025;
  Method *meth_meth_collectionsPrelude__61__61_4025 = addmethod2pos(obj2985, "==", &meth_collectionsPrelude__61__61_4025, 33);
  int argcv_meth_collectionsPrelude__61__61_4025[] = {1};
  meth_meth_collectionsPrelude__61__61_4025->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61_4025);
  meth_meth_collectionsPrelude__61__61_4025->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61_4025->definitionLine = 1675;
// method copy
  struct UserObject *uo4069 = (struct UserObject*)obj2985;
  uo4069->data[34] = emptyclosure;
  Method *meth_meth_collectionsPrelude_copy4069 = addmethod2pos(obj2985, "copy", &meth_collectionsPrelude_copy4069, 34);
  int argcv_meth_collectionsPrelude_copy4069[] = {0};
  meth_meth_collectionsPrelude_copy4069->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_copy4069);
  meth_meth_collectionsPrelude_copy4069->definitionModule = modulename;
  meth_meth_collectionsPrelude_copy4069->definitionLine = 1691;
// method asDictionary
  struct UserObject *uo4085 = (struct UserObject*)obj2985;
  uo4085->data[35] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDictionary4085 = addmethod2pos(obj2985, "asDictionary", &meth_collectionsPrelude_asDictionary4085, 35);
  int argcv_meth_collectionsPrelude_asDictionary4085[] = {0};
  meth_meth_collectionsPrelude_asDictionary4085->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDictionary4085);
  meth_meth_collectionsPrelude_asDictionary4085->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDictionary4085->definitionLine = 1699;
// method ++
  struct UserObject *uo4086 = (struct UserObject*)obj2985;
  uo4086->data[36] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43_4086 = addmethod2pos(obj2985, "++", &meth_collectionsPrelude__43__43_4086, 36);
  int argcv_meth_collectionsPrelude__43__43_4086[] = {1};
  meth_meth_collectionsPrelude__43__43_4086->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43_4086);
  meth_meth_collectionsPrelude__43__43_4086->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43_4086->definitionLine = 1703;
// method --
  struct UserObject *uo4096 = (struct UserObject*)obj2985;
  uo4096->data[37] = emptyclosure;
  Method *meth_meth_collectionsPrelude__45__45_4096 = addmethod2pos(obj2985, "--", &meth_collectionsPrelude__45__45_4096, 37);
  int argcv_meth_collectionsPrelude__45__45_4096[] = {1};
  meth_meth_collectionsPrelude__45__45_4096->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__45__45_4096);
  meth_meth_collectionsPrelude__45__45_4096->definitionModule = modulename;
  meth_meth_collectionsPrelude__45__45_4096->definitionLine = 1711;
  sourceObject = obj2985;
// Begin line 1399
  setline(1399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4117 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_collection (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call4118 = callmethod(*var_collection, "trait()object",
    2, partcv, params);
  gc_frame_end(callframe4117);
// compiled call node returning call4118 (depth = 2)
  struct UserObject *obj2985_uo = (struct UserObject *)obj2985;
  obj2985_uo->super = call4118;
  sourceObject = obj2985;
// Begin line 1400
  setline(1400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num4119 = alloc_Float64(0);
// compiled num node returning num4119 (depth = 2)
  adddatum2(obj2985, num4119, 1);
  sourceObject = obj2985;
// Begin line 1401
  setline(1401);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num4120 = alloc_Float64(0);
// compiled num node returning num4120 (depth = 2)
  adddatum2(obj2985, num4120, 2);
  sourceObject = obj2985;
// Begin line 1402
  setline(1402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4121 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num4122 = alloc_Float64(8);
// compiled num node returning num4122 (depth = 3)
  gc_frame_newslot(num4122);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4123 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var__prelude (depth = 5)
  partcv[0] = 0;
  Object call4124 = callmethod(*var__prelude, "PrimitiveArray",
    1, partcv, params);
  gc_frame_end(callframe4123);
// compiled call node returning call4124 (depth = 4)
// compiled member node returning call4124 (depth = 3)
  params[0] = num4122;
  partcv[0] = 1;
  Object call4125 = callmethod(call4124, "new",
    1, partcv, params);
  gc_frame_end(callframe4121);
// compiled call node returning call4125 (depth = 2)
  adddatum2(obj2985, call4125, 3);
  sourceObject = obj2985;
  Object inheritingObject4126 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4126 = alloc_userobj2(5,5, objclass4126);
  gc_frame_newslot(obj4126);
// OBJECT OUTER DEC outer
  adddatum2(obj4126, obj2985, 0);
  addmethodreal(obj4126,"outer", &reader_collectionsPrelude_outer_4127);
  Object oldself4126 = self;
  struct StackFrameObject *oldstackframe4126 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4126);
  gc_frame_newslot((Object)stackframe);
  self = obj4126;
  Object *oldselfslot4126 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4126 = (*(struct UserObject *)self).data[0], lowerouter4126 = thisouter4126;
  if (inheritingObject4126) {
    struct UserObject *inho4126 = (struct UserObject *)inheritingObject4126;
    while (inho4126->super != GraceDefaultObject) inho4126 = (struct UserObject *)inho4126->super;
    inho4126->super = obj4126;
    self = inheritingObject4126;
    *selfslot = self;
    lowerouter4126 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4126;
  }
if (objclass4126 == NULL) {
  Method *reader4128 = addmethodrealflags(obj4126, "unused",&reader_collectionsPrelude_unused_4128, MFLAG_CONFIDENTIAL);
  Method *writer4128 = addmethodrealflags(obj4126, "unused:=",&writer_collectionsPrelude_unused_4128, MFLAG_CONFIDENTIAL);
  reader4128->definitionModule = modulename;
  writer4128->definitionModule = modulename;
  reader4128->definitionLine = 1404;
  writer4128->definitionLine = 1404;
}
obj4126->flags |= OFLAG_MUTABLE;
adddatum2(obj4126, alloc_Undefined(), 1);
if (objclass4126 == NULL) {
  Method *reader4129 = addmethodrealflags(obj4126, "key",&reader_collectionsPrelude_key_4129, MFLAG_DEF);
  reader4129->definitionModule = modulename;
  reader4129->definitionLine = 1405;
}
adddatum2(obj4126, alloc_Undefined(), 2);
if (objclass4126 == NULL) {
  Method *reader4130 = addmethodrealflags(obj4126, "value",&reader_collectionsPrelude_value_4130, MFLAG_DEF);
  reader4130->definitionModule = modulename;
  reader4130->definitionLine = 1406;
}
adddatum2(obj4126, alloc_Undefined(), 3);
// method asString
  struct UserObject *uo4131 = (struct UserObject*)obj4126;
  uo4131->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString4131 = addmethod2pos(obj4126, "asString", &meth_collectionsPrelude_asString4131, 4);
  int argcv_meth_collectionsPrelude_asString4131[] = {0};
  meth_meth_collectionsPrelude_asString4131->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString4131);
  meth_meth_collectionsPrelude_asString4131->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString4131->definitionLine = 1407;
  sourceObject = obj4126;
// Begin line 1404
  setline(1404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool4133 = alloc_Boolean(1);
// compiled identifier node returning bool4133 (depth = 2)
  adddatum2(obj4126, bool4133, 1);
  sourceObject = obj4126;
// Begin line 1405
  setline(1405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  adddatum2(obj4126, self, 2);
  sourceObject = obj4126;
// Begin line 1406
  setline(1406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  adddatum2(obj4126, self, 3);
  sourceObject = obj4126;
  objclass4126 = obj4126->class;
  objclass4126->definitionModule = modulename;
  objclass4126->definitionLine = 1403;
  (*(struct UserObject *)self).data[0] = lowerouter4126;
  self = oldself4126;
  selfslot = oldselfslot4126;
  stackframe = oldstackframe4126;
  adddatum2(obj2985, obj4126, 4);
  sourceObject = obj2985;
  Object inheritingObject4134 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4134 = alloc_userobj2(5,5, objclass4134);
  gc_frame_newslot(obj4134);
// OBJECT OUTER DEC outer
  adddatum2(obj4134, obj2985, 0);
  addmethodreal(obj4134,"outer", &reader_collectionsPrelude_outer_4135);
  Object oldself4134 = self;
  struct StackFrameObject *oldstackframe4134 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4134);
  gc_frame_newslot((Object)stackframe);
  self = obj4134;
  Object *oldselfslot4134 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4134 = (*(struct UserObject *)self).data[0], lowerouter4134 = thisouter4134;
  if (inheritingObject4134) {
    struct UserObject *inho4134 = (struct UserObject *)inheritingObject4134;
    while (inho4134->super != GraceDefaultObject) inho4134 = (struct UserObject *)inho4134->super;
    inho4134->super = obj4134;
    self = inheritingObject4134;
    *selfslot = self;
    lowerouter4134 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4134;
  }
if (objclass4134 == NULL) {
  Method *reader4136 = addmethodrealflags(obj4134, "removed",&reader_collectionsPrelude_removed_4136, MFLAG_CONFIDENTIAL);
  Method *writer4136 = addmethodrealflags(obj4134, "removed:=",&writer_collectionsPrelude_removed_4136, MFLAG_CONFIDENTIAL);
  reader4136->definitionModule = modulename;
  writer4136->definitionModule = modulename;
  reader4136->definitionLine = 1410;
  writer4136->definitionLine = 1410;
}
obj4134->flags |= OFLAG_MUTABLE;
adddatum2(obj4134, alloc_Undefined(), 1);
if (objclass4134 == NULL) {
  Method *reader4137 = addmethodrealflags(obj4134, "key",&reader_collectionsPrelude_key_4137, MFLAG_DEF);
  reader4137->definitionModule = modulename;
  reader4137->definitionLine = 1411;
}
adddatum2(obj4134, alloc_Undefined(), 2);
if (objclass4134 == NULL) {
  Method *reader4138 = addmethodrealflags(obj4134, "value",&reader_collectionsPrelude_value_4138, MFLAG_DEF);
  reader4138->definitionModule = modulename;
  reader4138->definitionLine = 1412;
}
adddatum2(obj4134, alloc_Undefined(), 3);
// method asString
  struct UserObject *uo4139 = (struct UserObject*)obj4134;
  uo4139->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString4139 = addmethod2pos(obj4134, "asString", &meth_collectionsPrelude_asString4139, 4);
  int argcv_meth_collectionsPrelude_asString4139[] = {0};
  meth_meth_collectionsPrelude_asString4139->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString4139);
  meth_meth_collectionsPrelude_asString4139->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString4139->definitionLine = 1413;
  sourceObject = obj4134;
// Begin line 1410
  setline(1410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool4141 = alloc_Boolean(1);
// compiled identifier node returning bool4141 (depth = 2)
  adddatum2(obj4134, bool4141, 1);
  sourceObject = obj4134;
// Begin line 1411
  setline(1411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  adddatum2(obj4134, self, 2);
  sourceObject = obj4134;
// Begin line 1412
  setline(1412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  adddatum2(obj4134, self, 3);
  sourceObject = obj4134;
  objclass4134 = obj4134->class;
  objclass4134->definitionModule = modulename;
  objclass4134->definitionLine = 1409;
  (*(struct UserObject *)self).data[0] = lowerouter4134;
  self = oldself4134;
  selfslot = oldselfslot4134;
  stackframe = oldstackframe4134;
  adddatum2(obj2985, obj4134, 5);
  sourceObject = obj2985;
// Begin line 1415
  setline(1415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4142 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4145 = alloc_Float64(1);
// compiled num node returning num4145 (depth = 5)
  int op_slot_right_4144 = gc_frame_newslot(num4145);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4147 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4148 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4149 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4148);
// compiled call node returning call4149 (depth = 8)
// compiled member node returning call4149 (depth = 7)
  partcv[0] = 0;
  Object call4150 = callmethod(call4149, "size",
    1, partcv, params);
  gc_frame_end(callframe4147);
// compiled call node returning call4150 (depth = 6)
// compiled member node returning call4150 (depth = 5)
  int op_slot_left_4144 = gc_frame_newslot(call4150);
  params[0] = num4145;
  partcv[0] = 1;
  Object diff4151 = callmethod(call4150, "-", 1, partcv, params);
// compiled op node returning diff4151 (depth = 4)
  int op_slot_right_4143 = gc_frame_newslot(diff4151);
// starting to compile num node (depth = 4)
  Object num4153 = alloc_Float64(0);
// compiled num node returning num4153 (depth = 4)
  int op_slot_left_4143 = gc_frame_newslot(num4153);
  params[0] = diff4151;
  partcv[0] = 1;
  Object opresult4154 = callmethod(num4153, "..", 1, partcv, params);
// compiled op node returning opresult4154 (depth = 3)
  gc_frame_newslot(opresult4154);
// starting to compile block node (depth = 3)
  Object block4155 = alloc_Block(NULL, NULL, "collectionsPrelude", 1415);
  gc_frame_newslot(block4155);
// method _apply
  block_savedest(block4155);
  Object closure4156 = createclosure(1, "_apply");
  setclosureframe(closure4156, stackframe);
  addtoclosure(closure4156, selfslot);
  struct UserObject *uo4156 = (struct UserObject*)block4155;
  uo4156->data[0] = (Object)closure4156;
  Method *meth_meth_collectionsPrelude__apply4156 = addmethod2pos(block4155, "_apply", &meth_collectionsPrelude__apply4156, 0);
  int argcv_meth_collectionsPrelude__apply4156[] = {1};
  meth_meth_collectionsPrelude__apply4156->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4156);
  meth_meth_collectionsPrelude__apply4156->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4156->definitionLine = 1415;
// compiled block node returning block4155 (depth = 3)
  gc_frame_newslot(block4155);
// call case 5: prelude request
  params[0] = opresult4154;
  params[1] = block4155;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4164 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4142);
// compiled call node returning call4164 (depth = 2)
  sourceObject = obj2985;
// Begin line 1418
  setline(1418);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4165 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_initialBindings (depth = 3)
  gc_frame_newslot(*var_initialBindings);
// starting to compile block node (depth = 3)
  Object block4166 = alloc_Block(NULL, NULL, "collectionsPrelude", 1418);
  gc_frame_newslot(block4166);
// method _apply
  block_savedest(block4166);
  Object closure4167 = createclosure(1, "_apply");
  setclosureframe(closure4167, stackframe);
  addtoclosure(closure4167, selfslot);
  struct UserObject *uo4167 = (struct UserObject*)block4166;
  uo4167->data[0] = (Object)closure4167;
  Method *meth_meth_collectionsPrelude__apply4167 = addmethod2pos(block4166, "_apply", &meth_collectionsPrelude__apply4167, 0);
  int argcv_meth_collectionsPrelude__apply4167[] = {1};
  meth_meth_collectionsPrelude__apply4167->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4167);
  meth_meth_collectionsPrelude__apply4167->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4167->definitionLine = 1416;
// compiled block node returning block4166 (depth = 3)
  gc_frame_newslot(block4166);
// call case 5: prelude request
  params[0] = *var_initialBindings;
  params[1] = block4166;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4175 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4165);
// compiled call node returning call4175 (depth = 2)
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  objclass2985 = obj2985->class;
  objclass2985->definitionModule = modulename;
  objclass2985->definitionLine = 1398;
  (*(struct UserObject *)self).data[0] = lowerouter2985;
  self = oldself2985;
  selfslot = oldselfslot2985;
  stackframe = oldstackframe2985;
  gc_frame_end(frame);
  return obj2985;
}
Object meth_collectionsPrelude_withAll2984_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "withAll()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method withAll()object");
  Object params[2];
  int partcv[2];
  Object *var_binding = getfromclosure(closure, 0);
  Object *var_done = getfromclosure(closure, 1);
  Object *var_NoSuchObject = getfromclosure(closure, 2);
  Object *var_enumerable = getfromclosure(closure, 3);
  Object *var_ConcurrentModification = getfromclosure(closure, 4);
  Object *var_Exhausted = getfromclosure(closure, 5);
  Object *var__prelude = getfromclosure(closure, 6);
  Object *var_Dictionary = getfromclosure(closure, 7);
  Object *var_collection = getfromclosure(closure, 8);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for withAll (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_initialBindings = &(stackframe->slots[0]);
  *var_initialBindings = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for withAll");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2985 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2985 = alloc_userobj2(47,45, objclass2985);
  gc_frame_newslot(obj2985);
if (objclass2985 == NULL) {
  glfree(obj2985->class->name);
  obj2985->class->name = "obj2977.withAll";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2985, self, 0);
  addmethodreal(obj2985,"outer", &reader_collectionsPrelude_outer_2986);
  Object oldself2985 = self;
  struct StackFrameObject *oldstackframe2985 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2985);
  gc_frame_newslot((Object)stackframe);
  self = obj2985;
  Object *oldselfslot2985 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2985 = (*(struct UserObject *)self).data[0], lowerouter2985 = thisouter2985;
  if (inheritingObject2985) {
    struct UserObject *inho2985 = (struct UserObject *)inheritingObject2985;
    while (inho2985->super != GraceDefaultObject) inho2985 = (struct UserObject *)inho2985->super;
    inho2985->super = obj2985;
    self = inheritingObject2985;
    *selfslot = self;
    lowerouter2985 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2985;
  }
if (objclass2985 == NULL) {
  Method *reader2987 = addmethodrealflags(obj2985, "mods",&reader_collectionsPrelude_mods_2987, 0);
  Method *writer2987 = addmethodrealflags(obj2985, "mods:=",&writer_collectionsPrelude_mods_2987, MFLAG_CONFIDENTIAL);
  reader2987->definitionModule = modulename;
  writer2987->definitionModule = modulename;
  reader2987->definitionLine = 1400;
  writer2987->definitionLine = 1400;
}
obj2985->flags |= OFLAG_MUTABLE;
adddatum2(obj2985, alloc_Undefined(), 1);
if (objclass2985 == NULL) {
  Method *reader2988 = addmethodrealflags(obj2985, "numBindings",&reader_collectionsPrelude_numBindings_2988, MFLAG_CONFIDENTIAL);
  Method *writer2988 = addmethodrealflags(obj2985, "numBindings:=",&writer_collectionsPrelude_numBindings_2988, MFLAG_CONFIDENTIAL);
  reader2988->definitionModule = modulename;
  writer2988->definitionModule = modulename;
  reader2988->definitionLine = 1401;
  writer2988->definitionLine = 1401;
}
obj2985->flags |= OFLAG_MUTABLE;
adddatum2(obj2985, alloc_Undefined(), 2);
if (objclass2985 == NULL) {
  Method *reader2989 = addmethodrealflags(obj2985, "inner",&reader_collectionsPrelude_inner_2989, MFLAG_CONFIDENTIAL);
  Method *writer2989 = addmethodrealflags(obj2985, "inner:=",&writer_collectionsPrelude_inner_2989, MFLAG_CONFIDENTIAL);
  reader2989->definitionModule = modulename;
  writer2989->definitionModule = modulename;
  reader2989->definitionLine = 1402;
  writer2989->definitionLine = 1402;
}
obj2985->flags |= OFLAG_MUTABLE;
adddatum2(obj2985, alloc_Undefined(), 3);
if (objclass2985 == NULL) {
  Method *reader2990 = addmethodrealflags(obj2985, "unused",&reader_collectionsPrelude_unused_2990, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader2990->definitionModule = modulename;
  reader2990->definitionLine = 1403;
}
adddatum2(obj2985, alloc_Undefined(), 4);
if (objclass2985 == NULL) {
  Method *reader2991 = addmethodrealflags(obj2985, "removed",&reader_collectionsPrelude_removed_2991, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader2991->definitionModule = modulename;
  reader2991->definitionLine = 1409;
}
adddatum2(obj2985, alloc_Undefined(), 5);
// method size
  struct UserObject *uo2992 = (struct UserObject*)obj2985;
  uo2992->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_size2992 = addmethod2pos(obj2985, "size", &meth_collectionsPrelude_size2992, 6);
  int argcv_meth_collectionsPrelude_size2992[] = {0};
  meth_meth_collectionsPrelude_size2992->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size2992);
  meth_meth_collectionsPrelude_size2992->definitionModule = modulename;
  meth_meth_collectionsPrelude_size2992->definitionLine = 1419;
// method at()put
  block_savedest(obj2985);
  Object closure2995 = createclosure(1, "at()put");
  setclosureframe(closure2995, stackframe);
  addtoclosure(closure2995, var_binding);
  struct UserObject *uo2995 = (struct UserObject*)obj2985;
  uo2995->data[7] = (Object)closure2995;
  Method *meth_meth_collectionsPrelude_at_40__41_put2995 = addmethod2pos(obj2985, "at()put", &meth_collectionsPrelude_at_40__41_put2995, 7);
  int argcv_meth_collectionsPrelude_at_40__41_put2995[] = {1, 1};
  meth_meth_collectionsPrelude_at_40__41_put2995->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_at_40__41_put2995);
  meth_meth_collectionsPrelude_at_40__41_put2995->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40__41_put2995->definitionLine = 1420;
// method []:=
  block_savedest(obj2985);
  Object closure3060 = createclosure(1, "[]:=");
  setclosureframe(closure3060, stackframe);
  addtoclosure(closure3060, var_done);
  struct UserObject *uo3060 = (struct UserObject*)obj2985;
  uo3060->data[8] = (Object)closure3060;
  Method *meth_meth_collectionsPrelude__91__93__58__61_3060 = addmethod2pos(obj2985, "[]:=", &meth_collectionsPrelude__91__93__58__61_3060, 8);
  int argcv_meth_collectionsPrelude__91__93__58__61_3060[] = {2};
  meth_meth_collectionsPrelude__91__93__58__61_3060->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__91__93__58__61_3060);
  meth_meth_collectionsPrelude__91__93__58__61_3060->definitionModule = modulename;
  meth_meth_collectionsPrelude__91__93__58__61_3060->definitionLine = 1430;
// method at
  block_savedest(obj2985);
  Object closure3063 = createclosure(1, "at");
  setclosureframe(closure3063, stackframe);
  addtoclosure(closure3063, var_NoSuchObject);
  struct UserObject *uo3063 = (struct UserObject*)obj2985;
  uo3063->data[9] = (Object)closure3063;
  Method *meth_meth_collectionsPrelude_at3063 = addmethod2pos(obj2985, "at", &meth_collectionsPrelude_at3063, 9);
  int argcv_meth_collectionsPrelude_at3063[] = {1};
  meth_meth_collectionsPrelude_at3063->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at3063);
  meth_meth_collectionsPrelude_at3063->definitionModule = modulename;
  meth_meth_collectionsPrelude_at3063->definitionLine = 1434;
// method at()ifAbsent
  struct UserObject *uo3088 = (struct UserObject*)obj2985;
  uo3088->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at_40__41_ifAbsent3088 = addmethod2pos(obj2985, "at()ifAbsent", &meth_collectionsPrelude_at_40__41_ifAbsent3088, 10);
  int argcv_meth_collectionsPrelude_at_40__41_ifAbsent3088[] = {1, 1};
  meth_meth_collectionsPrelude_at_40__41_ifAbsent3088->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_at_40__41_ifAbsent3088);
  meth_meth_collectionsPrelude_at_40__41_ifAbsent3088->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40__41_ifAbsent3088->definitionLine = 1441;
// method []
  struct UserObject *uo3105 = (struct UserObject*)obj2985;
  uo3105->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude__91__93_3105 = addmethod2pos(obj2985, "[]", &meth_collectionsPrelude__91__93_3105, 11);
  int argcv_meth_collectionsPrelude__91__93_3105[] = {1};
  meth_meth_collectionsPrelude__91__93_3105->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__91__93_3105);
  meth_meth_collectionsPrelude__91__93_3105->definitionModule = modulename;
  meth_meth_collectionsPrelude__91__93_3105->definitionLine = 1448;
// method containsKey
  struct UserObject *uo3108 = (struct UserObject*)obj2985;
  uo3108->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_containsKey3108 = addmethod2pos(obj2985, "containsKey", &meth_collectionsPrelude_containsKey3108, 12);
  int argcv_meth_collectionsPrelude_containsKey3108[] = {1};
  meth_meth_collectionsPrelude_containsKey3108->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_containsKey3108);
  meth_meth_collectionsPrelude_containsKey3108->definitionModule = modulename;
  meth_meth_collectionsPrelude_containsKey3108->definitionLine = 1449;
// method removeAllKeys
  block_savedest(obj2985);
  Object closure3123 = createclosure(1, "removeAllKeys");
  setclosureframe(closure3123, stackframe);
  addtoclosure(closure3123, var_NoSuchObject);
  struct UserObject *uo3123 = (struct UserObject*)obj2985;
  uo3123->data[13] = (Object)closure3123;
  Method *meth_meth_collectionsPrelude_removeAllKeys3123 = addmethod2pos(obj2985, "removeAllKeys", &meth_collectionsPrelude_removeAllKeys3123, 13);
  int argcv_meth_collectionsPrelude_removeAllKeys3123[] = {1};
  meth_meth_collectionsPrelude_removeAllKeys3123->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAllKeys3123);
  meth_meth_collectionsPrelude_removeAllKeys3123->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAllKeys3123->definitionLine = 1456;
// method removeKey
  struct UserObject *uo3173 = (struct UserObject*)obj2985;
  uo3173->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeKey3173 = addmethod2pos(obj2985, "removeKey", &meth_collectionsPrelude_removeKey3173, 14);
  int argcv_meth_collectionsPrelude_removeKey3173[] = {0};
  meth_meth_collectionsPrelude_removeKey3173->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeKey3173);
  meth_meth_collectionsPrelude_removeKey3173->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeKey3173->definitionLine = 1469;
// method removeAllValues
  struct UserObject *uo3176 = (struct UserObject*)obj2985;
  uo3176->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeAllValues3176 = addmethod2pos(obj2985, "removeAllValues", &meth_collectionsPrelude_removeAllValues3176, 15);
  int argcv_meth_collectionsPrelude_removeAllValues3176[] = {1};
  meth_meth_collectionsPrelude_removeAllValues3176->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAllValues3176);
  meth_meth_collectionsPrelude_removeAllValues3176->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAllValues3176->definitionLine = 1472;
// method removeValue
  struct UserObject *uo3225 = (struct UserObject*)obj2985;
  uo3225->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeValue3225 = addmethod2pos(obj2985, "removeValue", &meth_collectionsPrelude_removeValue3225, 16);
  int argcv_meth_collectionsPrelude_removeValue3225[] = {0};
  meth_meth_collectionsPrelude_removeValue3225->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeValue3225);
  meth_meth_collectionsPrelude_removeValue3225->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeValue3225->definitionLine = 1483;
// method containsValue
  struct UserObject *uo3228 = (struct UserObject*)obj2985;
  uo3228->data[17] = emptyclosure;
  Method *meth_meth_collectionsPrelude_containsValue3228 = addmethod2pos(obj2985, "containsValue", &meth_collectionsPrelude_containsValue3228, 17);
  int argcv_meth_collectionsPrelude_containsValue3228[] = {1};
  meth_meth_collectionsPrelude_containsValue3228->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_containsValue3228);
  meth_meth_collectionsPrelude_containsValue3228->definitionModule = modulename;
  meth_meth_collectionsPrelude_containsValue3228->definitionLine = 1486;
// method contains
  struct UserObject *uo3240 = (struct UserObject*)obj2985;
  uo3240->data[18] = emptyclosure;
  Method *meth_meth_collectionsPrelude_contains3240 = addmethod2pos(obj2985, "contains", &meth_collectionsPrelude_contains3240, 18);
  int argcv_meth_collectionsPrelude_contains3240[] = {1};
  meth_meth_collectionsPrelude_contains3240->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains3240);
  meth_meth_collectionsPrelude_contains3240->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains3240->definitionLine = 1492;
// method findPosition
  struct UserObject *uo3243 = (struct UserObject*)obj2985;
  uo3243->data[19] = emptyclosure;
  Method *meth_meth_collectionsPrelude_findPosition3243 = addmethod2pos(obj2985, "findPosition", &meth_collectionsPrelude_findPosition3243, 19);
  int argcv_meth_collectionsPrelude_findPosition3243[] = {1};
  meth_meth_collectionsPrelude_findPosition3243->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_findPosition3243);
  meth_meth_collectionsPrelude_findPosition3243->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_findPosition3243->definitionModule = modulename;
  meth_meth_collectionsPrelude_findPosition3243->definitionLine = 1493;
// method findPositionForAdd
  struct UserObject *uo3311 = (struct UserObject*)obj2985;
  uo3311->data[20] = emptyclosure;
  Method *meth_meth_collectionsPrelude_findPositionForAdd3311 = addmethod2pos(obj2985, "findPositionForAdd", &meth_collectionsPrelude_findPositionForAdd3311, 20);
  int argcv_meth_collectionsPrelude_findPositionForAdd3311[] = {1};
  meth_meth_collectionsPrelude_findPositionForAdd3311->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_findPositionForAdd3311);
  meth_meth_collectionsPrelude_findPositionForAdd3311->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_findPositionForAdd3311->definitionModule = modulename;
  meth_meth_collectionsPrelude_findPositionForAdd3311->definitionLine = 1511;
// method asString
  struct UserObject *uo3393 = (struct UserObject*)obj2985;
  uo3393->data[21] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString3393 = addmethod2pos(obj2985, "asString", &meth_collectionsPrelude_asString3393, 21);
  int argcv_meth_collectionsPrelude_asString3393[] = {0};
  meth_meth_collectionsPrelude_asString3393->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString3393);
  meth_meth_collectionsPrelude_asString3393->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString3393->definitionLine = 1529;
// method asDebugString
  struct UserObject *uo3468 = (struct UserObject*)obj2985;
  uo3468->data[22] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDebugString3468 = addmethod2pos(obj2985, "asDebugString", &meth_collectionsPrelude_asDebugString3468, 22);
  int argcv_meth_collectionsPrelude_asDebugString3468[] = {0};
  meth_meth_collectionsPrelude_asDebugString3468->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString3468);
  meth_meth_collectionsPrelude_asDebugString3468->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString3468->definitionLine = 1547;
// method keys
  block_savedest(obj2985);
  Object closure3570 = createclosure(1, "keys");
  setclosureframe(closure3570, stackframe);
  addtoclosure(closure3570, var_enumerable);
  struct UserObject *uo3570 = (struct UserObject*)obj2985;
  uo3570->data[23] = (Object)closure3570;
  Method *meth_meth_collectionsPrelude_keys3570 = addmethod2pos(obj2985, "keys", &meth_collectionsPrelude_keys3570, 23);
  int argcv_meth_collectionsPrelude_keys3570[] = {0};
  meth_meth_collectionsPrelude_keys3570->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys3570);
  meth_meth_collectionsPrelude_keys3570->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys3570->definitionLine = 1560;
  block_savedest(obj2985);
  Object closure3615 = createclosure(1, "keys()object");
  setclosureframe(closure3615, stackframe);
  addtoclosure(closure3615, var_enumerable);
  Method *meth_meth_collectionsPrelude_keys3570_object = addmethod2pos(obj2985, "keys()object", &meth_collectionsPrelude_keys3570_object, 23);
  meth_meth_collectionsPrelude_keys3570_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys3570_object->definitionLine = 1560;
// method values
  block_savedest(obj2985);
  Object closure3616 = createclosure(1, "values");
  setclosureframe(closure3616, stackframe);
  addtoclosure(closure3616, var_enumerable);
  struct UserObject *uo3616 = (struct UserObject*)obj2985;
  uo3616->data[24] = (Object)closure3616;
  Method *meth_meth_collectionsPrelude_values3616 = addmethod2pos(obj2985, "values", &meth_collectionsPrelude_values3616, 24);
  int argcv_meth_collectionsPrelude_values3616[] = {0};
  meth_meth_collectionsPrelude_values3616->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values3616);
  meth_meth_collectionsPrelude_values3616->definitionModule = modulename;
  meth_meth_collectionsPrelude_values3616->definitionLine = 1578;
  block_savedest(obj2985);
  Object closure3661 = createclosure(1, "values()object");
  setclosureframe(closure3661, stackframe);
  addtoclosure(closure3661, var_enumerable);
  Method *meth_meth_collectionsPrelude_values3616_object = addmethod2pos(obj2985, "values()object", &meth_collectionsPrelude_values3616_object, 24);
  meth_meth_collectionsPrelude_values3616_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_values3616_object->definitionLine = 1578;
// method bindings
  block_savedest(obj2985);
  Object closure3662 = createclosure(1, "bindings");
  setclosureframe(closure3662, stackframe);
  addtoclosure(closure3662, var_enumerable);
  struct UserObject *uo3662 = (struct UserObject*)obj2985;
  uo3662->data[25] = (Object)closure3662;
  Method *meth_meth_collectionsPrelude_bindings3662 = addmethod2pos(obj2985, "bindings", &meth_collectionsPrelude_bindings3662, 25);
  int argcv_meth_collectionsPrelude_bindings3662[] = {0};
  meth_meth_collectionsPrelude_bindings3662->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_bindings3662);
  meth_meth_collectionsPrelude_bindings3662->definitionModule = modulename;
  meth_meth_collectionsPrelude_bindings3662->definitionLine = 1597;
  block_savedest(obj2985);
  Object closure3682 = createclosure(1, "bindings()object");
  setclosureframe(closure3682, stackframe);
  addtoclosure(closure3682, var_enumerable);
  Method *meth_meth_collectionsPrelude_bindings3662_object = addmethod2pos(obj2985, "bindings()object", &meth_collectionsPrelude_bindings3662_object, 25);
  meth_meth_collectionsPrelude_bindings3662_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_bindings3662_object->definitionLine = 1597;
// method iterator
  struct UserObject *uo3683 = (struct UserObject*)obj2985;
  uo3683->data[26] = emptyclosure;
  Method *meth_meth_collectionsPrelude_iterator3683 = addmethod2pos(obj2985, "iterator", &meth_collectionsPrelude_iterator3683, 26);
  int argcv_meth_collectionsPrelude_iterator3683[] = {0};
  meth_meth_collectionsPrelude_iterator3683->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator3683);
  meth_meth_collectionsPrelude_iterator3683->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator3683->definitionLine = 1609;
// method bindingsIterator
  block_savedest(obj2985);
  Object closure3688 = createclosure(2, "bindingsIterator");
  setclosureframe(closure3688, stackframe);
  addtoclosure(closure3688, var_ConcurrentModification);
  addtoclosure(closure3688, var_Exhausted);
  struct UserObject *uo3688 = (struct UserObject*)obj2985;
  uo3688->data[27] = (Object)closure3688;
  Method *meth_meth_collectionsPrelude_bindingsIterator3688 = addmethod2pos(obj2985, "bindingsIterator", &meth_collectionsPrelude_bindingsIterator3688, 27);
  int argcv_meth_collectionsPrelude_bindingsIterator3688[] = {0};
  meth_meth_collectionsPrelude_bindingsIterator3688->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_bindingsIterator3688);
  meth_meth_collectionsPrelude_bindingsIterator3688->definitionModule = modulename;
  meth_meth_collectionsPrelude_bindingsIterator3688->definitionLine = 1610;
  block_savedest(obj2985);
  Object closure3817 = createclosure(2, "bindingsIterator()object");
  setclosureframe(closure3817, stackframe);
  addtoclosure(closure3817, var_ConcurrentModification);
  addtoclosure(closure3817, var_Exhausted);
  Method *meth_meth_collectionsPrelude_bindingsIterator3688_object = addmethod2pos(obj2985, "bindingsIterator()object", &meth_collectionsPrelude_bindingsIterator3688_object, 27);
  meth_meth_collectionsPrelude_bindingsIterator3688_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_bindingsIterator3688_object->definitionLine = 1610;
// method expand
  block_savedest(obj2985);
  Object closure3818 = createclosure(1, "expand");
  setclosureframe(closure3818, stackframe);
  addtoclosure(closure3818, var__prelude);
  struct UserObject *uo3818 = (struct UserObject*)obj2985;
  uo3818->data[28] = (Object)closure3818;
  Method *meth_meth_collectionsPrelude_expand3818 = addmethod2pos(obj2985, "expand", &meth_collectionsPrelude_expand3818, 28);
  int argcv_meth_collectionsPrelude_expand3818[] = {0};
  meth_meth_collectionsPrelude_expand3818->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_expand3818);
  meth_meth_collectionsPrelude_expand3818->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_expand3818->definitionModule = modulename;
  meth_meth_collectionsPrelude_expand3818->definitionLine = 1633;
// method keysAndValuesDo
  struct UserObject *uo3894 = (struct UserObject*)obj2985;
  uo3894->data[29] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo3894 = addmethod2pos(obj2985, "keysAndValuesDo", &meth_collectionsPrelude_keysAndValuesDo3894, 29);
  int argcv_meth_collectionsPrelude_keysAndValuesDo3894[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo3894->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo3894);
  meth_meth_collectionsPrelude_keysAndValuesDo3894->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo3894->definitionLine = 1649;
// method keysDo
  struct UserObject *uo3938 = (struct UserObject*)obj2985;
  uo3938->data[30] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keysDo3938 = addmethod2pos(obj2985, "keysDo", &meth_collectionsPrelude_keysDo3938, 30);
  int argcv_meth_collectionsPrelude_keysDo3938[] = {1};
  meth_meth_collectionsPrelude_keysDo3938->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysDo3938);
  meth_meth_collectionsPrelude_keysDo3938->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysDo3938->definitionLine = 1657;
// method valuesDo
  struct UserObject *uo3980 = (struct UserObject*)obj2985;
  uo3980->data[31] = emptyclosure;
  Method *meth_meth_collectionsPrelude_valuesDo3980 = addmethod2pos(obj2985, "valuesDo", &meth_collectionsPrelude_valuesDo3980, 31);
  int argcv_meth_collectionsPrelude_valuesDo3980[] = {1};
  meth_meth_collectionsPrelude_valuesDo3980->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_valuesDo3980);
  meth_meth_collectionsPrelude_valuesDo3980->definitionModule = modulename;
  meth_meth_collectionsPrelude_valuesDo3980->definitionLine = 1665;
// method do
  struct UserObject *uo4022 = (struct UserObject*)obj2985;
  uo4022->data[32] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do4022 = addmethod2pos(obj2985, "do", &meth_collectionsPrelude_do4022, 32);
  int argcv_meth_collectionsPrelude_do4022[] = {1};
  meth_meth_collectionsPrelude_do4022->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do4022);
  meth_meth_collectionsPrelude_do4022->definitionModule = modulename;
  meth_meth_collectionsPrelude_do4022->definitionLine = 1673;
// method ==
  block_savedest(obj2985);
  Object closure4025 = createclosure(1, "==");
  setclosureframe(closure4025, stackframe);
  addtoclosure(closure4025, var_Dictionary);
  struct UserObject *uo4025 = (struct UserObject*)obj2985;
  uo4025->data[33] = (Object)closure4025;
  Method *meth_meth_collectionsPrelude__61__61_4025 = addmethod2pos(obj2985, "==", &meth_collectionsPrelude__61__61_4025, 33);
  int argcv_meth_collectionsPrelude__61__61_4025[] = {1};
  meth_meth_collectionsPrelude__61__61_4025->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61_4025);
  meth_meth_collectionsPrelude__61__61_4025->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61_4025->definitionLine = 1675;
// method copy
  struct UserObject *uo4069 = (struct UserObject*)obj2985;
  uo4069->data[34] = emptyclosure;
  Method *meth_meth_collectionsPrelude_copy4069 = addmethod2pos(obj2985, "copy", &meth_collectionsPrelude_copy4069, 34);
  int argcv_meth_collectionsPrelude_copy4069[] = {0};
  meth_meth_collectionsPrelude_copy4069->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_copy4069);
  meth_meth_collectionsPrelude_copy4069->definitionModule = modulename;
  meth_meth_collectionsPrelude_copy4069->definitionLine = 1691;
// method asDictionary
  struct UserObject *uo4085 = (struct UserObject*)obj2985;
  uo4085->data[35] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDictionary4085 = addmethod2pos(obj2985, "asDictionary", &meth_collectionsPrelude_asDictionary4085, 35);
  int argcv_meth_collectionsPrelude_asDictionary4085[] = {0};
  meth_meth_collectionsPrelude_asDictionary4085->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDictionary4085);
  meth_meth_collectionsPrelude_asDictionary4085->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDictionary4085->definitionLine = 1699;
// method ++
  struct UserObject *uo4086 = (struct UserObject*)obj2985;
  uo4086->data[36] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43_4086 = addmethod2pos(obj2985, "++", &meth_collectionsPrelude__43__43_4086, 36);
  int argcv_meth_collectionsPrelude__43__43_4086[] = {1};
  meth_meth_collectionsPrelude__43__43_4086->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43_4086);
  meth_meth_collectionsPrelude__43__43_4086->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43_4086->definitionLine = 1703;
// method --
  struct UserObject *uo4096 = (struct UserObject*)obj2985;
  uo4096->data[37] = emptyclosure;
  Method *meth_meth_collectionsPrelude__45__45_4096 = addmethod2pos(obj2985, "--", &meth_collectionsPrelude__45__45_4096, 37);
  int argcv_meth_collectionsPrelude__45__45_4096[] = {1};
  meth_meth_collectionsPrelude__45__45_4096->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__45__45_4096);
  meth_meth_collectionsPrelude__45__45_4096->definitionModule = modulename;
  meth_meth_collectionsPrelude__45__45_4096->definitionLine = 1711;
  sourceObject = obj2985;
// Begin line 1399
  setline(1399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4117 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_collection (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call4118 = callmethod(*var_collection, "trait()object",
    2, partcv, params);
  gc_frame_end(callframe4117);
// compiled call node returning call4118 (depth = 2)
  struct UserObject *obj2985_uo = (struct UserObject *)obj2985;
  obj2985_uo->super = call4118;
  sourceObject = obj2985;
// Begin line 1400
  setline(1400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num4119 = alloc_Float64(0);
// compiled num node returning num4119 (depth = 2)
  adddatum2(obj2985, num4119, 1);
  sourceObject = obj2985;
// Begin line 1401
  setline(1401);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num4120 = alloc_Float64(0);
// compiled num node returning num4120 (depth = 2)
  adddatum2(obj2985, num4120, 2);
  sourceObject = obj2985;
// Begin line 1402
  setline(1402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4121 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num4122 = alloc_Float64(8);
// compiled num node returning num4122 (depth = 3)
  gc_frame_newslot(num4122);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4123 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var__prelude (depth = 5)
  partcv[0] = 0;
  Object call4124 = callmethod(*var__prelude, "PrimitiveArray",
    1, partcv, params);
  gc_frame_end(callframe4123);
// compiled call node returning call4124 (depth = 4)
// compiled member node returning call4124 (depth = 3)
  params[0] = num4122;
  partcv[0] = 1;
  Object call4125 = callmethod(call4124, "new",
    1, partcv, params);
  gc_frame_end(callframe4121);
// compiled call node returning call4125 (depth = 2)
  adddatum2(obj2985, call4125, 3);
  sourceObject = obj2985;
  Object inheritingObject4126 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4126 = alloc_userobj2(5,5, objclass4126);
  gc_frame_newslot(obj4126);
// OBJECT OUTER DEC outer
  adddatum2(obj4126, obj2985, 0);
  addmethodreal(obj4126,"outer", &reader_collectionsPrelude_outer_4127);
  Object oldself4126 = self;
  struct StackFrameObject *oldstackframe4126 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4126);
  gc_frame_newslot((Object)stackframe);
  self = obj4126;
  Object *oldselfslot4126 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4126 = (*(struct UserObject *)self).data[0], lowerouter4126 = thisouter4126;
  if (inheritingObject4126) {
    struct UserObject *inho4126 = (struct UserObject *)inheritingObject4126;
    while (inho4126->super != GraceDefaultObject) inho4126 = (struct UserObject *)inho4126->super;
    inho4126->super = obj4126;
    self = inheritingObject4126;
    *selfslot = self;
    lowerouter4126 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4126;
  }
if (objclass4126 == NULL) {
  Method *reader4128 = addmethodrealflags(obj4126, "unused",&reader_collectionsPrelude_unused_4128, MFLAG_CONFIDENTIAL);
  Method *writer4128 = addmethodrealflags(obj4126, "unused:=",&writer_collectionsPrelude_unused_4128, MFLAG_CONFIDENTIAL);
  reader4128->definitionModule = modulename;
  writer4128->definitionModule = modulename;
  reader4128->definitionLine = 1404;
  writer4128->definitionLine = 1404;
}
obj4126->flags |= OFLAG_MUTABLE;
adddatum2(obj4126, alloc_Undefined(), 1);
if (objclass4126 == NULL) {
  Method *reader4129 = addmethodrealflags(obj4126, "key",&reader_collectionsPrelude_key_4129, MFLAG_DEF);
  reader4129->definitionModule = modulename;
  reader4129->definitionLine = 1405;
}
adddatum2(obj4126, alloc_Undefined(), 2);
if (objclass4126 == NULL) {
  Method *reader4130 = addmethodrealflags(obj4126, "value",&reader_collectionsPrelude_value_4130, MFLAG_DEF);
  reader4130->definitionModule = modulename;
  reader4130->definitionLine = 1406;
}
adddatum2(obj4126, alloc_Undefined(), 3);
// method asString
  struct UserObject *uo4131 = (struct UserObject*)obj4126;
  uo4131->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString4131 = addmethod2pos(obj4126, "asString", &meth_collectionsPrelude_asString4131, 4);
  int argcv_meth_collectionsPrelude_asString4131[] = {0};
  meth_meth_collectionsPrelude_asString4131->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString4131);
  meth_meth_collectionsPrelude_asString4131->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString4131->definitionLine = 1407;
  sourceObject = obj4126;
// Begin line 1404
  setline(1404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool4133 = alloc_Boolean(1);
// compiled identifier node returning bool4133 (depth = 2)
  adddatum2(obj4126, bool4133, 1);
  sourceObject = obj4126;
// Begin line 1405
  setline(1405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  adddatum2(obj4126, self, 2);
  sourceObject = obj4126;
// Begin line 1406
  setline(1406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  adddatum2(obj4126, self, 3);
  sourceObject = obj4126;
  objclass4126 = obj4126->class;
  objclass4126->definitionModule = modulename;
  objclass4126->definitionLine = 1403;
  (*(struct UserObject *)self).data[0] = lowerouter4126;
  self = oldself4126;
  selfslot = oldselfslot4126;
  stackframe = oldstackframe4126;
  adddatum2(obj2985, obj4126, 4);
  sourceObject = obj2985;
  Object inheritingObject4134 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4134 = alloc_userobj2(5,5, objclass4134);
  gc_frame_newslot(obj4134);
// OBJECT OUTER DEC outer
  adddatum2(obj4134, obj2985, 0);
  addmethodreal(obj4134,"outer", &reader_collectionsPrelude_outer_4135);
  Object oldself4134 = self;
  struct StackFrameObject *oldstackframe4134 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4134);
  gc_frame_newslot((Object)stackframe);
  self = obj4134;
  Object *oldselfslot4134 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4134 = (*(struct UserObject *)self).data[0], lowerouter4134 = thisouter4134;
  if (inheritingObject4134) {
    struct UserObject *inho4134 = (struct UserObject *)inheritingObject4134;
    while (inho4134->super != GraceDefaultObject) inho4134 = (struct UserObject *)inho4134->super;
    inho4134->super = obj4134;
    self = inheritingObject4134;
    *selfslot = self;
    lowerouter4134 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4134;
  }
if (objclass4134 == NULL) {
  Method *reader4136 = addmethodrealflags(obj4134, "removed",&reader_collectionsPrelude_removed_4136, MFLAG_CONFIDENTIAL);
  Method *writer4136 = addmethodrealflags(obj4134, "removed:=",&writer_collectionsPrelude_removed_4136, MFLAG_CONFIDENTIAL);
  reader4136->definitionModule = modulename;
  writer4136->definitionModule = modulename;
  reader4136->definitionLine = 1410;
  writer4136->definitionLine = 1410;
}
obj4134->flags |= OFLAG_MUTABLE;
adddatum2(obj4134, alloc_Undefined(), 1);
if (objclass4134 == NULL) {
  Method *reader4137 = addmethodrealflags(obj4134, "key",&reader_collectionsPrelude_key_4137, MFLAG_DEF);
  reader4137->definitionModule = modulename;
  reader4137->definitionLine = 1411;
}
adddatum2(obj4134, alloc_Undefined(), 2);
if (objclass4134 == NULL) {
  Method *reader4138 = addmethodrealflags(obj4134, "value",&reader_collectionsPrelude_value_4138, MFLAG_DEF);
  reader4138->definitionModule = modulename;
  reader4138->definitionLine = 1412;
}
adddatum2(obj4134, alloc_Undefined(), 3);
// method asString
  struct UserObject *uo4139 = (struct UserObject*)obj4134;
  uo4139->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString4139 = addmethod2pos(obj4134, "asString", &meth_collectionsPrelude_asString4139, 4);
  int argcv_meth_collectionsPrelude_asString4139[] = {0};
  meth_meth_collectionsPrelude_asString4139->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString4139);
  meth_meth_collectionsPrelude_asString4139->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString4139->definitionLine = 1413;
  sourceObject = obj4134;
// Begin line 1410
  setline(1410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool4141 = alloc_Boolean(1);
// compiled identifier node returning bool4141 (depth = 2)
  adddatum2(obj4134, bool4141, 1);
  sourceObject = obj4134;
// Begin line 1411
  setline(1411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  adddatum2(obj4134, self, 2);
  sourceObject = obj4134;
// Begin line 1412
  setline(1412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  adddatum2(obj4134, self, 3);
  sourceObject = obj4134;
  objclass4134 = obj4134->class;
  objclass4134->definitionModule = modulename;
  objclass4134->definitionLine = 1409;
  (*(struct UserObject *)self).data[0] = lowerouter4134;
  self = oldself4134;
  selfslot = oldselfslot4134;
  stackframe = oldstackframe4134;
  adddatum2(obj2985, obj4134, 5);
  sourceObject = obj2985;
// Begin line 1415
  setline(1415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4142 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4145 = alloc_Float64(1);
// compiled num node returning num4145 (depth = 5)
  int op_slot_right_4144 = gc_frame_newslot(num4145);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4147 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4148 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4149 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4148);
// compiled call node returning call4149 (depth = 8)
// compiled member node returning call4149 (depth = 7)
  partcv[0] = 0;
  Object call4150 = callmethod(call4149, "size",
    1, partcv, params);
  gc_frame_end(callframe4147);
// compiled call node returning call4150 (depth = 6)
// compiled member node returning call4150 (depth = 5)
  int op_slot_left_4144 = gc_frame_newslot(call4150);
  params[0] = num4145;
  partcv[0] = 1;
  Object diff4151 = callmethod(call4150, "-", 1, partcv, params);
// compiled op node returning diff4151 (depth = 4)
  int op_slot_right_4143 = gc_frame_newslot(diff4151);
// starting to compile num node (depth = 4)
  Object num4153 = alloc_Float64(0);
// compiled num node returning num4153 (depth = 4)
  int op_slot_left_4143 = gc_frame_newslot(num4153);
  params[0] = diff4151;
  partcv[0] = 1;
  Object opresult4154 = callmethod(num4153, "..", 1, partcv, params);
// compiled op node returning opresult4154 (depth = 3)
  gc_frame_newslot(opresult4154);
// starting to compile block node (depth = 3)
  Object block4155 = alloc_Block(NULL, NULL, "collectionsPrelude", 1415);
  gc_frame_newslot(block4155);
// method _apply
  block_savedest(block4155);
  Object closure4156 = createclosure(1, "_apply");
  setclosureframe(closure4156, stackframe);
  addtoclosure(closure4156, selfslot);
  struct UserObject *uo4156 = (struct UserObject*)block4155;
  uo4156->data[0] = (Object)closure4156;
  Method *meth_meth_collectionsPrelude__apply4156 = addmethod2pos(block4155, "_apply", &meth_collectionsPrelude__apply4156, 0);
  int argcv_meth_collectionsPrelude__apply4156[] = {1};
  meth_meth_collectionsPrelude__apply4156->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4156);
  meth_meth_collectionsPrelude__apply4156->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4156->definitionLine = 1415;
// compiled block node returning block4155 (depth = 3)
  gc_frame_newslot(block4155);
// call case 5: prelude request
  params[0] = opresult4154;
  params[1] = block4155;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4164 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4142);
// compiled call node returning call4164 (depth = 2)
  sourceObject = obj2985;
// Begin line 1418
  setline(1418);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4165 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_initialBindings (depth = 3)
  gc_frame_newslot(*var_initialBindings);
// starting to compile block node (depth = 3)
  Object block4166 = alloc_Block(NULL, NULL, "collectionsPrelude", 1418);
  gc_frame_newslot(block4166);
// method _apply
  block_savedest(block4166);
  Object closure4167 = createclosure(1, "_apply");
  setclosureframe(closure4167, stackframe);
  addtoclosure(closure4167, selfslot);
  struct UserObject *uo4167 = (struct UserObject*)block4166;
  uo4167->data[0] = (Object)closure4167;
  Method *meth_meth_collectionsPrelude__apply4167 = addmethod2pos(block4166, "_apply", &meth_collectionsPrelude__apply4167, 0);
  int argcv_meth_collectionsPrelude__apply4167[] = {1};
  meth_meth_collectionsPrelude__apply4167->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4167);
  meth_meth_collectionsPrelude__apply4167->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4167->definitionLine = 1416;
// compiled block node returning block4166 (depth = 3)
  gc_frame_newslot(block4166);
// call case 5: prelude request
  params[0] = *var_initialBindings;
  params[1] = block4166;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4175 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4165);
// compiled call node returning call4175 (depth = 2)
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  sourceObject = obj2985;
  objclass2985 = obj2985->class;
  objclass2985->definitionModule = modulename;
  objclass2985->definitionLine = 1398;
  (*(struct UserObject *)self).data[0] = lowerouter2985;
  self = oldself2985;
  selfslot = oldselfslot2985;
  stackframe = oldstackframe2985;
  gc_frame_end(frame);
  return obj2985;
}
Object meth_collectionsPrelude_dictionary2976(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dictionary");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_binding = getfromclosure(closure, 0);
  Object *var_done = getfromclosure(closure, 1);
  Object *var_NoSuchObject = getfromclosure(closure, 2);
  Object *var_enumerable = getfromclosure(closure, 3);
  Object *var_ConcurrentModification = getfromclosure(closure, 4);
  Object *var_Exhausted = getfromclosure(closure, 5);
  Object *var__prelude = getfromclosure(closure, 6);
  Object *var_Dictionary = getfromclosure(closure, 7);
  Object *var_collection = getfromclosure(closure, 8);
  Object *var_collectionFactory = getfromclosure(closure, 9);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for dictionary (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for dictionary");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start generics
  Object *var_K = &(stackframe->slots[1]);
  Object *var_T = &(stackframe->slots[2]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 2) {
      gracedie("insufficient generic parameters");
    }
    *var_K = args[curarg++];
    *var_T = args[curarg++];
  } else {
    *var_K = Unknown;
    *var_T = Unknown;
  }
// End generics
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2977 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2977 = alloc_userobj2(4,5, objclass2977);
  gc_frame_newslot(obj2977);
if (objclass2977 == NULL) {
  glfree(obj2977->class->name);
  obj2977->class->name = "self.dictionary";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2977, self, 0);
  addmethodreal(obj2977,"outer", &reader_collectionsPrelude_outer_2978);
  Object oldself2977 = self;
  struct StackFrameObject *oldstackframe2977 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2977);
  gc_frame_newslot((Object)stackframe);
  self = obj2977;
  Object *oldselfslot2977 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2977 = (*(struct UserObject *)self).data[0], lowerouter2977 = thisouter2977;
  if (inheritingObject2977) {
    struct UserObject *inho2977 = (struct UserObject *)inheritingObject2977;
    while (inho2977->super != GraceDefaultObject) inho2977 = (struct UserObject *)inho2977->super;
    inho2977->super = obj2977;
    self = inheritingObject2977;
    *selfslot = self;
    lowerouter2977 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2977;
  }
// method at()put
  struct UserObject *uo2979 = (struct UserObject*)obj2977;
  uo2979->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at_40__41_put2979 = addmethod2pos(obj2977, "at()put", &meth_collectionsPrelude_at_40__41_put2979, 1);
  int argcv_meth_collectionsPrelude_at_40__41_put2979[] = {1, 1};
  meth_meth_collectionsPrelude_at_40__41_put2979->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_at_40__41_put2979);
  meth_meth_collectionsPrelude_at_40__41_put2979->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40__41_put2979->definitionLine = 1394;
// method withAll
  block_savedest(obj2977);
  Object closure2984 = createclosure(9, "withAll");
  setclosureframe(closure2984, stackframe);
  addtoclosure(closure2984, var_binding);
  addtoclosure(closure2984, var_done);
  addtoclosure(closure2984, var_NoSuchObject);
  addtoclosure(closure2984, var_enumerable);
  addtoclosure(closure2984, var_ConcurrentModification);
  addtoclosure(closure2984, var_Exhausted);
  addtoclosure(closure2984, var__prelude);
  addtoclosure(closure2984, var_Dictionary);
  addtoclosure(closure2984, var_collection);
  struct UserObject *uo2984 = (struct UserObject*)obj2977;
  uo2984->data[2] = (Object)closure2984;
  Method *meth_meth_collectionsPrelude_withAll2984 = addmethod2pos(obj2977, "withAll", &meth_collectionsPrelude_withAll2984, 2);
  int argcv_meth_collectionsPrelude_withAll2984[] = {1};
  meth_meth_collectionsPrelude_withAll2984->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_withAll2984);
  meth_meth_collectionsPrelude_withAll2984->definitionModule = modulename;
  meth_meth_collectionsPrelude_withAll2984->definitionLine = 1397;
  block_savedest(obj2977);
  Object closure4176 = createclosure(9, "withAll()object");
  setclosureframe(closure4176, stackframe);
  addtoclosure(closure4176, var_binding);
  addtoclosure(closure4176, var_done);
  addtoclosure(closure4176, var_NoSuchObject);
  addtoclosure(closure4176, var_enumerable);
  addtoclosure(closure4176, var_ConcurrentModification);
  addtoclosure(closure4176, var_Exhausted);
  addtoclosure(closure4176, var__prelude);
  addtoclosure(closure4176, var_Dictionary);
  addtoclosure(closure4176, var_collection);
  Method *meth_meth_collectionsPrelude_withAll2984_object = addmethod2pos(obj2977, "withAll()object", &meth_collectionsPrelude_withAll2984_object, 2);
  meth_meth_collectionsPrelude_withAll2984_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_withAll2984_object->definitionLine = 1397;
  sourceObject = obj2977;
// Begin line 1393
  setline(1393);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4177 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_collectionFactory (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call4178 = callmethod(*var_collectionFactory, "trait()object",
    2, partcv, params);
  gc_frame_end(callframe4177);
// compiled call node returning call4178 (depth = 2)
  struct UserObject *obj2977_uo = (struct UserObject *)obj2977;
  obj2977_uo->super = call4178;
  sourceObject = obj2977;
  sourceObject = obj2977;
  objclass2977 = obj2977->class;
  objclass2977->definitionModule = modulename;
  objclass2977->definitionLine = 1392;
  (*(struct UserObject *)self).data[0] = lowerouter2977;
  self = oldself2977;
  selfslot = oldselfslot2977;
  stackframe = oldstackframe2977;
  gc_frame_end(frame);
  return obj2977;
}
Object meth_collectionsPrelude_dictionary2976_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dictionary()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_binding = getfromclosure(closure, 0);
  Object *var_done = getfromclosure(closure, 1);
  Object *var_NoSuchObject = getfromclosure(closure, 2);
  Object *var_enumerable = getfromclosure(closure, 3);
  Object *var_ConcurrentModification = getfromclosure(closure, 4);
  Object *var_Exhausted = getfromclosure(closure, 5);
  Object *var__prelude = getfromclosure(closure, 6);
  Object *var_Dictionary = getfromclosure(closure, 7);
  Object *var_collection = getfromclosure(closure, 8);
  Object *var_collectionFactory = getfromclosure(closure, 9);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for dictionary (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for dictionary");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start generics
  Object *var_K = &(stackframe->slots[1]);
  Object *var_T = &(stackframe->slots[2]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 2) {
      gracedie("insufficient generic parameters");
    }
    *var_K = args[curarg++];
    *var_T = args[curarg++];
  } else {
    *var_K = Unknown;
    *var_T = Unknown;
  }
// End generics
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2977 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2977 = alloc_userobj2(4,5, objclass2977);
  gc_frame_newslot(obj2977);
if (objclass2977 == NULL) {
  glfree(obj2977->class->name);
  obj2977->class->name = "self.dictionary";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2977, self, 0);
  addmethodreal(obj2977,"outer", &reader_collectionsPrelude_outer_2978);
  Object oldself2977 = self;
  struct StackFrameObject *oldstackframe2977 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2977);
  gc_frame_newslot((Object)stackframe);
  self = obj2977;
  Object *oldselfslot2977 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2977 = (*(struct UserObject *)self).data[0], lowerouter2977 = thisouter2977;
  if (inheritingObject2977) {
    struct UserObject *inho2977 = (struct UserObject *)inheritingObject2977;
    while (inho2977->super != GraceDefaultObject) inho2977 = (struct UserObject *)inho2977->super;
    inho2977->super = obj2977;
    self = inheritingObject2977;
    *selfslot = self;
    lowerouter2977 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2977;
  }
// method at()put
  struct UserObject *uo2979 = (struct UserObject*)obj2977;
  uo2979->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at_40__41_put2979 = addmethod2pos(obj2977, "at()put", &meth_collectionsPrelude_at_40__41_put2979, 1);
  int argcv_meth_collectionsPrelude_at_40__41_put2979[] = {1, 1};
  meth_meth_collectionsPrelude_at_40__41_put2979->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_at_40__41_put2979);
  meth_meth_collectionsPrelude_at_40__41_put2979->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40__41_put2979->definitionLine = 1394;
// method withAll
  block_savedest(obj2977);
  Object closure2984 = createclosure(9, "withAll");
  setclosureframe(closure2984, stackframe);
  addtoclosure(closure2984, var_binding);
  addtoclosure(closure2984, var_done);
  addtoclosure(closure2984, var_NoSuchObject);
  addtoclosure(closure2984, var_enumerable);
  addtoclosure(closure2984, var_ConcurrentModification);
  addtoclosure(closure2984, var_Exhausted);
  addtoclosure(closure2984, var__prelude);
  addtoclosure(closure2984, var_Dictionary);
  addtoclosure(closure2984, var_collection);
  struct UserObject *uo2984 = (struct UserObject*)obj2977;
  uo2984->data[2] = (Object)closure2984;
  Method *meth_meth_collectionsPrelude_withAll2984 = addmethod2pos(obj2977, "withAll", &meth_collectionsPrelude_withAll2984, 2);
  int argcv_meth_collectionsPrelude_withAll2984[] = {1};
  meth_meth_collectionsPrelude_withAll2984->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_withAll2984);
  meth_meth_collectionsPrelude_withAll2984->definitionModule = modulename;
  meth_meth_collectionsPrelude_withAll2984->definitionLine = 1397;
  block_savedest(obj2977);
  Object closure4176 = createclosure(9, "withAll()object");
  setclosureframe(closure4176, stackframe);
  addtoclosure(closure4176, var_binding);
  addtoclosure(closure4176, var_done);
  addtoclosure(closure4176, var_NoSuchObject);
  addtoclosure(closure4176, var_enumerable);
  addtoclosure(closure4176, var_ConcurrentModification);
  addtoclosure(closure4176, var_Exhausted);
  addtoclosure(closure4176, var__prelude);
  addtoclosure(closure4176, var_Dictionary);
  addtoclosure(closure4176, var_collection);
  Method *meth_meth_collectionsPrelude_withAll2984_object = addmethod2pos(obj2977, "withAll()object", &meth_collectionsPrelude_withAll2984_object, 2);
  meth_meth_collectionsPrelude_withAll2984_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_withAll2984_object->definitionLine = 1397;
  sourceObject = obj2977;
// Begin line 1393
  setline(1393);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4177 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_collectionFactory (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call4178 = callmethod(*var_collectionFactory, "trait()object",
    2, partcv, params);
  gc_frame_end(callframe4177);
// compiled call node returning call4178 (depth = 2)
  struct UserObject *obj2977_uo = (struct UserObject *)obj2977;
  obj2977_uo->super = call4178;
  sourceObject = obj2977;
  sourceObject = obj2977;
  objclass2977 = obj2977->class;
  objclass2977->definitionModule = modulename;
  objclass2977->definitionLine = 1392;
  (*(struct UserObject *)self).data[0] = lowerouter2977;
  self = oldself2977;
  selfslot = oldselfslot2977;
  stackframe = oldstackframe2977;
  gc_frame_end(frame);
  return obj2977;
}
Object meth_collectionsPrelude_hasNext4194(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for hasNext (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for hasNext");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1755
  setline(1755);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4196 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4197 = gc_frame_new();
// call case 3: self.outer request
  Object call4198 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4197);
// compiled call node returning call4198 (depth = 6)
// compiled member node returning call4198 (depth = 5)
  partcv[0] = 0;
  Object call4199 = callmethodflags(call4198, "stop", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4196);
// compiled call node returning call4199 (depth = 4)
// compiled member node returning call4199 (depth = 3)
  int op_slot_right_4195 = gc_frame_newslot(call4199);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4201 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4202 = callmethodflags(self, "val", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4201);
// compiled call node returning call4202 (depth = 4)
// compiled member node returning call4202 (depth = 3)
  int op_slot_left_4195 = gc_frame_newslot(call4202);
  params[0] = call4199;
  partcv[0] = 1;
  Object opresult4203 = callmethod(call4202, "<=", 1, partcv, params);
// compiled op node returning opresult4203 (depth = 2)
  gc_frame_end(frame);
  return opresult4203;
}
Object meth_collectionsPrelude_next4204(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Exhausted = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for next (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for next");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1757
  setline(1757);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4207 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4208 = gc_frame_new();
// call case 3: self.outer request
  Object call4209 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4208);
// compiled call node returning call4209 (depth = 7)
// compiled member node returning call4209 (depth = 6)
  partcv[0] = 0;
  Object call4210 = callmethodflags(call4209, "stop", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4207);
// compiled call node returning call4210 (depth = 5)
// compiled member node returning call4210 (depth = 4)
  int op_slot_right_4206 = gc_frame_newslot(call4210);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4212 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4213 = callmethodflags(self, "val", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4212);
// compiled call node returning call4213 (depth = 5)
// compiled member node returning call4213 (depth = 4)
  int op_slot_left_4206 = gc_frame_newslot(call4213);
  params[0] = call4210;
  partcv[0] = 1;
  Object opresult4214 = callmethod(call4213, ">", 1, partcv, params);
// compiled op node returning opresult4214 (depth = 3)
  Object if4205 = done;
  if (istrue(opresult4214)) {
// Begin line 1758
  setline(1758);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4215 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4217 == NULL) {
    strlit4217 = alloc_String("");
    gc_root(strlit4217);
  }
// compiled string node returning strlit4217 (depth = 5)
  int op_slot_right_4216 = gc_frame_newslot(strlit4217);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4220 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4221 = gc_frame_new();
// call case 3: self.outer request
  Object call4222 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4221);
// compiled call node returning call4222 (depth = 9)
// compiled member node returning call4222 (depth = 8)
  partcv[0] = 0;
  Object call4223 = callmethodflags(call4222, "asString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4220);
// compiled call node returning call4223 (depth = 7)
// compiled member node returning call4223 (depth = 6)
  int op_slot_right_4219 = gc_frame_newslot(call4223);
// starting to compile string node (depth = 6)
  if (strlit4225 == NULL) {
    strlit4225 = alloc_String("over ");
    gc_root(strlit4225);
  }
// compiled string node returning strlit4225 (depth = 6)
  int op_slot_left_4219 = gc_frame_newslot(strlit4225);
  params[0] = call4223;
  partcv[0] = 1;
  Object opresult4226 = callmethod(strlit4225, "++", 1, partcv, params);
// compiled op node returning opresult4226 (depth = 5)
  int op_slot_left_4216 = gc_frame_newslot(opresult4226);
  params[0] = strlit4217;
  partcv[0] = 1;
  Object opresult4227 = callmethod(opresult4226, "++", 1, partcv, params);
// compiled op node returning opresult4227 (depth = 4)
  gc_frame_newslot(opresult4227);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_Exhausted (depth = 4)
  params[0] = opresult4227;
  partcv[0] = 1;
  Object call4228 = callmethod(*var_Exhausted, "raise",
    1, partcv, params);
  gc_frame_end(callframe4215);
// compiled call node returning call4228 (depth = 3)
    gc_frame_newslot(call4228);
    if4205 = call4228;
  } else {
  }
// compiled if node returning if4205 (depth = 2)
// Begin line 1760
  setline(1760);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 1758
  setline(1758);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4229 = gc_frame_new();
// Begin line 1760
  setline(1760);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4231 = alloc_Float64(1);
// compiled num node returning num4231 (depth = 5)
  int op_slot_right_4230 = gc_frame_newslot(num4231);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4233 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4234 = callmethodflags(self, "val", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4233);
// compiled call node returning call4234 (depth = 6)
// compiled member node returning call4234 (depth = 5)
  int op_slot_left_4230 = gc_frame_newslot(call4234);
  params[0] = num4231;
  partcv[0] = 1;
  Object sum4235 = callmethod(call4234, "+", 1, partcv, params);
// compiled op node returning sum4235 (depth = 4)
  gc_frame_newslot(sum4235);
// call case 4: self request
  params[0] = sum4235;
  partcv[0] = 1;
  Object call4236 = callmethodflags(self, "val:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4229);
// compiled call node returning call4236 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 1761
  setline(1761);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4238 = alloc_Float64(1);
// compiled num node returning num4238 (depth = 4)
  int op_slot_right_4237 = gc_frame_newslot(num4238);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4240 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4241 = callmethodflags(self, "val", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4240);
// compiled call node returning call4241 (depth = 5)
// compiled member node returning call4241 (depth = 4)
  int op_slot_left_4237 = gc_frame_newslot(call4241);
  params[0] = num4238;
  partcv[0] = 1;
  Object diff4242 = callmethod(call4241, "-", 1, partcv, params);
// compiled op node returning diff4242 (depth = 3)
  return diff4242;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_asString4243(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lower = getfromclosure(closure, 0);
  Object *var_upper = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1763
  setline(1763);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit4245 == NULL) {
    strlit4245 = alloc_String("");
    gc_root(strlit4245);
  }
// compiled string node returning strlit4245 (depth = 3)
  int op_slot_right_4244 = gc_frame_newslot(strlit4245);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lower (depth = 4)
  int op_slot_right_4247 = gc_frame_newslot(*var_lower);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4250 == NULL) {
    strlit4250 = alloc_String(" to ");
    gc_root(strlit4250);
  }
// compiled string node returning strlit4250 (depth = 5)
  int op_slot_right_4249 = gc_frame_newslot(strlit4250);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_upper (depth = 6)
  int op_slot_right_4252 = gc_frame_newslot(*var_upper);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4255 == NULL) {
    strlit4255 = alloc_String(" from ");
    gc_root(strlit4255);
  }
// compiled string node returning strlit4255 (depth = 7)
  int op_slot_right_4254 = gc_frame_newslot(strlit4255);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4258 = gc_frame_new();
// call case 1: super request
  partcv[0] = 0;
  Object call4259 = callmethod4(self, "asString", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe4258);
// compiled call node returning call4259 (depth = 9)
// compiled member node returning call4259 (depth = 8)
  int op_slot_right_4257 = gc_frame_newslot(call4259);
// starting to compile string node (depth = 8)
  if (strlit4261 == NULL) {
    strlit4261 = alloc_String("");
    gc_root(strlit4261);
  }
// compiled string node returning strlit4261 (depth = 8)
  int op_slot_left_4257 = gc_frame_newslot(strlit4261);
  params[0] = call4259;
  partcv[0] = 1;
  Object opresult4262 = callmethod(strlit4261, "++", 1, partcv, params);
// compiled op node returning opresult4262 (depth = 7)
  int op_slot_left_4254 = gc_frame_newslot(opresult4262);
  params[0] = strlit4255;
  partcv[0] = 1;
  Object opresult4263 = callmethod(opresult4262, "++", 1, partcv, params);
// compiled op node returning opresult4263 (depth = 6)
  int op_slot_left_4252 = gc_frame_newslot(opresult4263);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult4264 = callmethod(opresult4263, "++", 1, partcv, params);
// compiled op node returning opresult4264 (depth = 5)
  int op_slot_left_4249 = gc_frame_newslot(opresult4264);
  params[0] = strlit4250;
  partcv[0] = 1;
  Object opresult4265 = callmethod(opresult4264, "++", 1, partcv, params);
// compiled op node returning opresult4265 (depth = 4)
  int op_slot_left_4247 = gc_frame_newslot(opresult4265);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult4266 = callmethod(opresult4265, "++", 1, partcv, params);
// compiled op node returning opresult4266 (depth = 3)
  int op_slot_left_4244 = gc_frame_newslot(opresult4266);
  params[0] = strlit4245;
  partcv[0] = 1;
  Object opresult4267 = callmethod(opresult4266, "++", 1, partcv, params);
// compiled op node returning opresult4267 (depth = 2)
  gc_frame_end(frame);
  return opresult4267;
}
Object meth_collectionsPrelude_iterator4190(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Exhausted = getfromclosure(closure, 0);
  Object *var_lower = getfromclosure(closure, 1);
  Object *var_upper = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4191 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4191 = alloc_userobj2(5,5, objclass4191);
  gc_frame_newslot(obj4191);
if (objclass4191 == NULL) {
  glfree(obj4191->class->name);
  obj4191->class->name = "obj4184.iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4191, self, 0);
  addmethodreal(obj4191,"outer", &reader_collectionsPrelude_outer_4192);
  Object oldself4191 = self;
  struct StackFrameObject *oldstackframe4191 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4191);
  gc_frame_newslot((Object)stackframe);
  self = obj4191;
  Object *oldselfslot4191 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4191 = (*(struct UserObject *)self).data[0], lowerouter4191 = thisouter4191;
  if (inheritingObject4191) {
    struct UserObject *inho4191 = (struct UserObject *)inheritingObject4191;
    while (inho4191->super != GraceDefaultObject) inho4191 = (struct UserObject *)inho4191->super;
    inho4191->super = obj4191;
    self = inheritingObject4191;
    *selfslot = self;
    lowerouter4191 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4191;
  }
if (objclass4191 == NULL) {
  Method *reader4193 = addmethodrealflags(obj4191, "val",&reader_collectionsPrelude_val_4193, MFLAG_CONFIDENTIAL);
  Method *writer4193 = addmethodrealflags(obj4191, "val:=",&writer_collectionsPrelude_val_4193, MFLAG_CONFIDENTIAL);
  reader4193->definitionModule = modulename;
  writer4193->definitionModule = modulename;
  reader4193->definitionLine = 1754;
  writer4193->definitionLine = 1754;
}
obj4191->flags |= OFLAG_MUTABLE;
adddatum2(obj4191, alloc_Undefined(), 1);
// method hasNext
  struct UserObject *uo4194 = (struct UserObject*)obj4191;
  uo4194->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext4194 = addmethod2pos(obj4191, "hasNext", &meth_collectionsPrelude_hasNext4194, 2);
  int argcv_meth_collectionsPrelude_hasNext4194[] = {0};
  meth_meth_collectionsPrelude_hasNext4194->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext4194);
  meth_meth_collectionsPrelude_hasNext4194->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext4194->definitionLine = 1755;
// method next
  block_savedest(obj4191);
  Object closure4204 = createclosure(1, "next");
  setclosureframe(closure4204, stackframe);
  addtoclosure(closure4204, var_Exhausted);
  struct UserObject *uo4204 = (struct UserObject*)obj4191;
  uo4204->data[3] = (Object)closure4204;
  Method *meth_meth_collectionsPrelude_next4204 = addmethod2pos(obj4191, "next", &meth_collectionsPrelude_next4204, 3);
  int argcv_meth_collectionsPrelude_next4204[] = {0};
  meth_meth_collectionsPrelude_next4204->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next4204);
  meth_meth_collectionsPrelude_next4204->definitionModule = modulename;
  meth_meth_collectionsPrelude_next4204->definitionLine = 1756;
// method asString
  block_savedest(obj4191);
  Object closure4243 = createclosure(2, "asString");
  setclosureframe(closure4243, stackframe);
  addtoclosure(closure4243, var_lower);
  addtoclosure(closure4243, var_upper);
  struct UserObject *uo4243 = (struct UserObject*)obj4191;
  uo4243->data[4] = (Object)closure4243;
  Method *meth_meth_collectionsPrelude_asString4243 = addmethod2pos(obj4191, "asString", &meth_collectionsPrelude_asString4243, 4);
  int argcv_meth_collectionsPrelude_asString4243[] = {0};
  meth_meth_collectionsPrelude_asString4243->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString4243);
  meth_meth_collectionsPrelude_asString4243->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString4243->definitionLine = 1763;
  sourceObject = obj4191;
// Begin line 1754
  setline(1754);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4268 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4269 = gc_frame_new();
// call case 3: self.outer request
  Object call4270 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4269);
// compiled call node returning call4270 (depth = 5)
// compiled member node returning call4270 (depth = 4)
  partcv[0] = 0;
  Object call4271 = callmethodflags(call4270, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4268);
// compiled call node returning call4271 (depth = 3)
// compiled member node returning call4271 (depth = 2)
  adddatum2(obj4191, call4271, 1);
  sourceObject = obj4191;
  sourceObject = obj4191;
  sourceObject = obj4191;
  objclass4191 = obj4191->class;
  objclass4191->definitionModule = modulename;
  objclass4191->definitionLine = 1753;
  (*(struct UserObject *)self).data[0] = lowerouter4191;
  self = oldself4191;
  selfslot = oldselfslot4191;
  stackframe = oldstackframe4191;
  gc_frame_end(frame);
  return obj4191;
}
Object meth_collectionsPrelude_iterator4190_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_Exhausted = getfromclosure(closure, 0);
  Object *var_lower = getfromclosure(closure, 1);
  Object *var_upper = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4191 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4191 = alloc_userobj2(5,5, objclass4191);
  gc_frame_newslot(obj4191);
if (objclass4191 == NULL) {
  glfree(obj4191->class->name);
  obj4191->class->name = "obj4184.iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4191, self, 0);
  addmethodreal(obj4191,"outer", &reader_collectionsPrelude_outer_4192);
  Object oldself4191 = self;
  struct StackFrameObject *oldstackframe4191 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4191);
  gc_frame_newslot((Object)stackframe);
  self = obj4191;
  Object *oldselfslot4191 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4191 = (*(struct UserObject *)self).data[0], lowerouter4191 = thisouter4191;
  if (inheritingObject4191) {
    struct UserObject *inho4191 = (struct UserObject *)inheritingObject4191;
    while (inho4191->super != GraceDefaultObject) inho4191 = (struct UserObject *)inho4191->super;
    inho4191->super = obj4191;
    self = inheritingObject4191;
    *selfslot = self;
    lowerouter4191 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4191;
  }
if (objclass4191 == NULL) {
  Method *reader4193 = addmethodrealflags(obj4191, "val",&reader_collectionsPrelude_val_4193, MFLAG_CONFIDENTIAL);
  Method *writer4193 = addmethodrealflags(obj4191, "val:=",&writer_collectionsPrelude_val_4193, MFLAG_CONFIDENTIAL);
  reader4193->definitionModule = modulename;
  writer4193->definitionModule = modulename;
  reader4193->definitionLine = 1754;
  writer4193->definitionLine = 1754;
}
obj4191->flags |= OFLAG_MUTABLE;
adddatum2(obj4191, alloc_Undefined(), 1);
// method hasNext
  struct UserObject *uo4194 = (struct UserObject*)obj4191;
  uo4194->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext4194 = addmethod2pos(obj4191, "hasNext", &meth_collectionsPrelude_hasNext4194, 2);
  int argcv_meth_collectionsPrelude_hasNext4194[] = {0};
  meth_meth_collectionsPrelude_hasNext4194->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext4194);
  meth_meth_collectionsPrelude_hasNext4194->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext4194->definitionLine = 1755;
// method next
  block_savedest(obj4191);
  Object closure4204 = createclosure(1, "next");
  setclosureframe(closure4204, stackframe);
  addtoclosure(closure4204, var_Exhausted);
  struct UserObject *uo4204 = (struct UserObject*)obj4191;
  uo4204->data[3] = (Object)closure4204;
  Method *meth_meth_collectionsPrelude_next4204 = addmethod2pos(obj4191, "next", &meth_collectionsPrelude_next4204, 3);
  int argcv_meth_collectionsPrelude_next4204[] = {0};
  meth_meth_collectionsPrelude_next4204->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next4204);
  meth_meth_collectionsPrelude_next4204->definitionModule = modulename;
  meth_meth_collectionsPrelude_next4204->definitionLine = 1756;
// method asString
  block_savedest(obj4191);
  Object closure4243 = createclosure(2, "asString");
  setclosureframe(closure4243, stackframe);
  addtoclosure(closure4243, var_lower);
  addtoclosure(closure4243, var_upper);
  struct UserObject *uo4243 = (struct UserObject*)obj4191;
  uo4243->data[4] = (Object)closure4243;
  Method *meth_meth_collectionsPrelude_asString4243 = addmethod2pos(obj4191, "asString", &meth_collectionsPrelude_asString4243, 4);
  int argcv_meth_collectionsPrelude_asString4243[] = {0};
  meth_meth_collectionsPrelude_asString4243->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString4243);
  meth_meth_collectionsPrelude_asString4243->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString4243->definitionLine = 1763;
  sourceObject = obj4191;
// Begin line 1754
  setline(1754);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4268 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4269 = gc_frame_new();
// call case 3: self.outer request
  Object call4270 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4269);
// compiled call node returning call4270 (depth = 5)
// compiled member node returning call4270 (depth = 4)
  partcv[0] = 0;
  Object call4271 = callmethodflags(call4270, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4268);
// compiled call node returning call4271 (depth = 3)
// compiled member node returning call4271 (depth = 2)
  adddatum2(obj4191, call4271, 1);
  sourceObject = obj4191;
  sourceObject = obj4191;
  sourceObject = obj4191;
  objclass4191 = obj4191->class;
  objclass4191->definitionModule = modulename;
  objclass4191->definitionLine = 1753;
  (*(struct UserObject *)self).data[0] = lowerouter4191;
  self = oldself4191;
  selfslot = oldselfslot4191;
  stackframe = oldstackframe4191;
  gc_frame_end(frame);
  return obj4191;
}
Object meth_collectionsPrelude_at4273(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "at");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method at");
  Object params[1];
  int partcv[1];
  Object *var_BoundsError = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for at (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for at");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1767
  setline(1767);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4275 = gc_frame_new();
// call case 6: other member request
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4277 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4278 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4277);
// compiled call node returning call4278 (depth = 6)
// compiled member node returning call4278 (depth = 5)
  int op_slot_right_4276 = gc_frame_newslot(call4278);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ix (depth = 5)
  int op_slot_left_4276 = gc_frame_newslot(*var_ix);
  params[0] = call4278;
  partcv[0] = 1;
  Object opresult4280 = callmethod(*var_ix, "<=", 1, partcv, params);
// compiled op node returning opresult4280 (depth = 4)
  partcv[0] = 0;
  Object call4281 = callmethod(opresult4280, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe4275);
// compiled call node returning call4281 (depth = 3)
  Object if4274 = done;
  if (istrue(call4281)) {
// Begin line 1768
  setline(1768);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4282 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4284 == NULL) {
    strlit4284 = alloc_String("");
    gc_root(strlit4284);
  }
// compiled string node returning strlit4284 (depth = 5)
  int op_slot_right_4283 = gc_frame_newslot(strlit4284);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4287 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4288 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4287);
// compiled call node returning call4288 (depth = 7)
// compiled member node returning call4288 (depth = 6)
  int op_slot_right_4286 = gc_frame_newslot(call4288);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4291 == NULL) {
    strlit4291 = alloc_String("), but upper bound is ");
    gc_root(strlit4291);
  }
// compiled string node returning strlit4291 (depth = 7)
  int op_slot_right_4290 = gc_frame_newslot(strlit4291);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ix (depth = 8)
  int op_slot_right_4293 = gc_frame_newslot(*var_ix);
// starting to compile string node (depth = 8)
  if (strlit4295 == NULL) {
    strlit4295 = alloc_String("requested range.at(");
    gc_root(strlit4295);
  }
// compiled string node returning strlit4295 (depth = 8)
  int op_slot_left_4293 = gc_frame_newslot(strlit4295);
  params[0] = *var_ix;
  partcv[0] = 1;
  Object opresult4296 = callmethod(strlit4295, "++", 1, partcv, params);
// compiled op node returning opresult4296 (depth = 7)
  int op_slot_left_4290 = gc_frame_newslot(opresult4296);
  params[0] = strlit4291;
  partcv[0] = 1;
  Object opresult4297 = callmethod(opresult4296, "++", 1, partcv, params);
// compiled op node returning opresult4297 (depth = 6)
  int op_slot_left_4286 = gc_frame_newslot(opresult4297);
  params[0] = call4288;
  partcv[0] = 1;
  Object opresult4298 = callmethod(opresult4297, "++", 1, partcv, params);
// compiled op node returning opresult4298 (depth = 5)
  int op_slot_left_4283 = gc_frame_newslot(opresult4298);
  params[0] = strlit4284;
  partcv[0] = 1;
  Object opresult4299 = callmethod(opresult4298, "++", 1, partcv, params);
// compiled op node returning opresult4299 (depth = 4)
  gc_frame_newslot(opresult4299);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_BoundsError (depth = 4)
  params[0] = opresult4299;
  partcv[0] = 1;
  Object call4300 = callmethod(*var_BoundsError, "raise",
    1, partcv, params);
  gc_frame_end(callframe4282);
// compiled call node returning call4300 (depth = 3)
    gc_frame_newslot(call4300);
    if4274 = call4300;
  } else {
  }
// compiled if node returning if4274 (depth = 2)
// Begin line 1770
  setline(1770);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4302 = gc_frame_new();
// call case 6: other member request
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4304 = alloc_Float64(1);
// compiled num node returning num4304 (depth = 5)
  int op_slot_right_4303 = gc_frame_newslot(num4304);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ix (depth = 5)
  int op_slot_left_4303 = gc_frame_newslot(*var_ix);
  params[0] = num4304;
  partcv[0] = 1;
  Object opresult4306 = callmethod(*var_ix, ">=", 1, partcv, params);
// compiled op node returning opresult4306 (depth = 4)
  partcv[0] = 0;
  Object call4307 = callmethod(opresult4306, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe4302);
// compiled call node returning call4307 (depth = 3)
  Object if4301 = done;
  if (istrue(call4307)) {
// Begin line 1771
  setline(1771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4308 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4310 == NULL) {
    strlit4310 = alloc_String("), but lower bound is 1");
    gc_root(strlit4310);
  }
// compiled string node returning strlit4310 (depth = 5)
  int op_slot_right_4309 = gc_frame_newslot(strlit4310);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  int op_slot_right_4312 = gc_frame_newslot(*var_ix);
// starting to compile string node (depth = 6)
  if (strlit4314 == NULL) {
    strlit4314 = alloc_String("requested range.at(");
    gc_root(strlit4314);
  }
// compiled string node returning strlit4314 (depth = 6)
  int op_slot_left_4312 = gc_frame_newslot(strlit4314);
  params[0] = *var_ix;
  partcv[0] = 1;
  Object opresult4315 = callmethod(strlit4314, "++", 1, partcv, params);
// compiled op node returning opresult4315 (depth = 5)
  int op_slot_left_4309 = gc_frame_newslot(opresult4315);
  params[0] = strlit4310;
  partcv[0] = 1;
  Object opresult4316 = callmethod(opresult4315, "++", 1, partcv, params);
// compiled op node returning opresult4316 (depth = 4)
  gc_frame_newslot(opresult4316);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_BoundsError (depth = 4)
  params[0] = opresult4316;
  partcv[0] = 1;
  Object call4317 = callmethod(*var_BoundsError, "raise",
    1, partcv, params);
  gc_frame_end(callframe4308);
// compiled call node returning call4317 (depth = 3)
    gc_frame_newslot(call4317);
    if4301 = call4317;
  } else {
  }
// compiled if node returning if4301 (depth = 2)
// Begin line 1773
  setline(1773);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4320 = alloc_Float64(1);
// compiled num node returning num4320 (depth = 5)
  int op_slot_right_4319 = gc_frame_newslot(num4320);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ix (depth = 5)
  int op_slot_left_4319 = gc_frame_newslot(*var_ix);
  params[0] = num4320;
  partcv[0] = 1;
  Object diff4322 = callmethod(*var_ix, "-", 1, partcv, params);
// compiled op node returning diff4322 (depth = 4)
  int op_slot_right_4318 = gc_frame_newslot(diff4322);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4324 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4325 = callmethodflags(self, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4324);
// compiled call node returning call4325 (depth = 5)
// compiled member node returning call4325 (depth = 4)
  int op_slot_left_4318 = gc_frame_newslot(call4325);
  params[0] = diff4322;
  partcv[0] = 1;
  Object sum4326 = callmethod(call4325, "+", 1, partcv, params);
// compiled op node returning sum4326 (depth = 3)
  return sum4326;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply4330(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_elem = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_intElem = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "intElem");
// Begin line 1777
  setline(1777);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4331 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_elem (depth = 7)
  partcv[0] = 0;
  Object call4332 = callmethod(*var_elem, "truncated",
    1, partcv, params);
  gc_frame_end(callframe4331);
// compiled call node returning call4332 (depth = 6)
// compiled member node returning call4332 (depth = 5)
  *var_intElem = call4332;
  if (call4332 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1778
  setline(1778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_elem (depth = 6)
  int op_slot_right_4334 = gc_frame_newslot(*var_elem);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_intElem (depth = 6)
  int op_slot_left_4334 = gc_frame_newslot(*var_intElem);
  params[0] = *var_elem;
  partcv[0] = 1;
  Object opresult4336 = callmethod(*var_intElem, "!=", 1, partcv, params);
// compiled op node returning opresult4336 (depth = 5)
  Object if4333 = done;
  if (istrue(opresult4336)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool4337 = alloc_Boolean(0);
// compiled identifier node returning bool4337 (depth = 6)
  block_return(realself, bool4337);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if4333 = undefined;
  } else {
  }
// compiled if node returning if4333 (depth = 4)
// Begin line 1779
  setline(1779);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4340 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4341 = callmethodflags(self, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4340);
// compiled call node returning call4341 (depth = 7)
// compiled member node returning call4341 (depth = 6)
  int op_slot_right_4339 = gc_frame_newslot(call4341);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_intElem (depth = 6)
  int op_slot_left_4339 = gc_frame_newslot(*var_intElem);
  params[0] = call4341;
  partcv[0] = 1;
  Object opresult4343 = callmethod(*var_intElem, "<", 1, partcv, params);
// compiled op node returning opresult4343 (depth = 5)
  Object if4338 = done;
  if (istrue(opresult4343)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool4344 = alloc_Boolean(0);
// compiled identifier node returning bool4344 (depth = 6)
  block_return(realself, bool4344);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if4338 = undefined;
  } else {
  }
// compiled if node returning if4338 (depth = 4)
// Begin line 1780
  setline(1780);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4347 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4348 = callmethodflags(self, "stop", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4347);
// compiled call node returning call4348 (depth = 7)
// compiled member node returning call4348 (depth = 6)
  int op_slot_right_4346 = gc_frame_newslot(call4348);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_intElem (depth = 6)
  int op_slot_left_4346 = gc_frame_newslot(*var_intElem);
  params[0] = call4348;
  partcv[0] = 1;
  Object opresult4350 = callmethod(*var_intElem, ">", 1, partcv, params);
// compiled op node returning opresult4350 (depth = 5)
  Object if4345 = done;
  if (istrue(opresult4350)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool4351 = alloc_Boolean(0);
// compiled identifier node returning bool4351 (depth = 6)
  block_return(realself, bool4351);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if4345 = undefined;
  } else {
  }
// compiled if node returning if4345 (depth = 4)
  gc_frame_end(frame);
  return if4345;
}
Object meth_collectionsPrelude__apply4354(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ex = &(stackframe->slots[0]);
  *var_ex = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool4355 = alloc_Boolean(0);
// compiled identifier node returning bool4355 (depth = 5)
  block_return(realself, bool4355);
// compiled return node returning undefined (depth = 4)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_contains4327(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "contains");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method contains");
  Object params[2];
  int partcv[1];
  Object *var__prelude = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for contains (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_elem = &(stackframe->slots[0]);
  *var_elem = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for contains");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1776
  setline(1776);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile catchcase node (depth = 2)
// starting to compile block node (depth = 3)
  Object block4329 = alloc_Block(NULL, NULL, "collectionsPrelude", 1776);
  gc_frame_newslot(block4329);
// method _apply
  block_savedest(block4329);
  Object closure4330 = createclosure(2, "_apply");
  setclosureframe(closure4330, stackframe);
  addtoclosure(closure4330, var_elem);
  addtoclosure(closure4330, selfslot);
  struct UserObject *uo4330 = (struct UserObject*)block4329;
  uo4330->data[0] = (Object)closure4330;
  Method *meth_meth_collectionsPrelude__apply4330 = addmethod2pos(block4329, "_apply", &meth_collectionsPrelude__apply4330, 0);
  int argcv_meth_collectionsPrelude__apply4330[] = {0};
  meth_meth_collectionsPrelude__apply4330->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4330);
  meth_meth_collectionsPrelude__apply4330->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4330->definitionLine = 1773;
// compiled block node returning block4329 (depth = 3)
  int frame4328 = gc_frame_new();
  gc_frame_newslot(block4329);
// Begin line 1781
  setline(1781);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4353 = alloc_Block(NULL, NULL, "collectionsPrelude", 1781);
  gc_frame_newslot(block4353);
// method _apply
  block_savedest(block4353);
  Object closure4354 = createclosure(1, "_apply");
  setclosureframe(closure4354, stackframe);
  addtoclosure(closure4354, selfslot);
  struct UserObject *uo4354 = (struct UserObject*)block4353;
  uo4354->data[0] = (Object)closure4354;
  Method *meth_meth_collectionsPrelude__apply4354 = addmethod2pos(block4353, "_apply", &meth_collectionsPrelude__apply4354, 0);
  int argcv_meth_collectionsPrelude__apply4354[] = {1};
  meth_meth_collectionsPrelude__apply4354->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4354);
  meth_meth_collectionsPrelude__apply4354->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4354->definitionLine = 1780;
// starting to compile call node (depth = 4)
  int callframe4357 = gc_frame_new();
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4358 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4359 == NULL) {
    strlit4359 = alloc_String("ex");
    gc_root(strlit4359);
  }
// compiled string node returning strlit4359 (depth = 6)
  gc_frame_newslot(strlit4359);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4360 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4361 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4360);
// compiled call node returning call4361 (depth = 7)
// compiled member node returning call4361 (depth = 6)
  params[0] = strlit4359;
  partcv[0] = 1;
  Object call4362 = callmethod(call4361, "new",
    1, partcv, params);
  gc_frame_end(callframe4358);
// compiled call node returning call4362 (depth = 5)
  gc_frame_newslot(call4362);
// Begin line 1781
  setline(1781);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4363 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var__prelude (depth = 7)
  partcv[0] = 0;
  Object call4364 = callmethod(*var__prelude, "Exception",
    1, partcv, params);
  gc_frame_end(callframe4363);
// compiled call node returning call4364 (depth = 6)
// compiled member node returning call4364 (depth = 5)
  gc_frame_newslot(call4364);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4365 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4366 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4365);
// compiled call node returning call4366 (depth = 6)
// compiled member node returning call4366 (depth = 5)
  params[0] = call4362;
  params[1] = call4364;
  partcv[0] = 2;
  Object call4367 = callmethod(call4366, "new",
    1, partcv, params);
  gc_frame_end(callframe4357);
// compiled call node returning call4367 (depth = 4)
((struct UserObject *)block4353)->data[1] = call4367;
// compiled block node returning block4353 (depth = 3)
  gc_frame_newslot(block4353);
  params[0] = block4353;
  setline(1776);
  Object catchres4328 = catchCase(block4329, params, 1,NULL);
  gc_frame_end(frame4328);
// compiled catchcase node returning catchres4328 (depth = 2)
// Begin line 1782
  setline(1782);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool4368 = alloc_Boolean(1);
// compiled identifier node returning bool4368 (depth = 3)
  return bool4368;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply4374(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_val = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4376 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4377 = callmethodflags(self, "stop", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4376);
// compiled call node returning call4377 (depth = 6)
// compiled member node returning call4377 (depth = 5)
  int op_slot_right_4375 = gc_frame_newslot(call4377);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  int op_slot_left_4375 = gc_frame_newslot(*var_val);
  params[0] = call4377;
  partcv[0] = 1;
  Object opresult4379 = callmethod(*var_val, "<=", 1, partcv, params);
// compiled op node returning opresult4379 (depth = 4)
  gc_frame_end(frame);
  return opresult4379;
}
Object meth_collectionsPrelude__apply4382(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_val = getfromclosure(closure, 0);
  Object *var_block1 = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1787
  setline(1787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4383 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  gc_frame_newslot(*var_val);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_block1 (depth = 5)
  params[0] = *var_val;
  partcv[0] = 1;
  Object call4384 = callmethod(*var_block1, "apply",
    1, partcv, params);
  gc_frame_end(callframe4383);
// compiled call node returning call4384 (depth = 4)
// Begin line 1788
  setline(1788);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num4386 = alloc_Float64(1);
// compiled num node returning num4386 (depth = 6)
  int op_slot_right_4385 = gc_frame_newslot(num4386);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_val (depth = 6)
  int op_slot_left_4385 = gc_frame_newslot(*var_val);
  params[0] = num4386;
  partcv[0] = 1;
  Object sum4388 = callmethod(*var_val, "+", 1, partcv, params);
// compiled op node returning sum4388 (depth = 5)
  *var_val = sum4388;
  if (sum4388 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_do4369(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method do");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for do (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for do");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_val = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "val");
// Begin line 1785
  setline(1785);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4370 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4371 = callmethodflags(self, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4370);
// compiled call node returning call4371 (depth = 4)
// compiled member node returning call4371 (depth = 3)
  *var_val = call4371;
  if (call4371 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1786
  setline(1786);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4372 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block4373 = alloc_Block(NULL, NULL, "collectionsPrelude", 1786);
  gc_frame_newslot(block4373);
// method _apply
  block_savedest(block4373);
  Object closure4374 = createclosure(2, "_apply");
  setclosureframe(closure4374, stackframe);
  addtoclosure(closure4374, var_val);
  addtoclosure(closure4374, selfslot);
  struct UserObject *uo4374 = (struct UserObject*)block4373;
  uo4374->data[0] = (Object)closure4374;
  Method *meth_meth_collectionsPrelude__apply4374 = addmethod2pos(block4373, "_apply", &meth_collectionsPrelude__apply4374, 0);
  int argcv_meth_collectionsPrelude__apply4374[] = {0};
  meth_meth_collectionsPrelude__apply4374->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4374);
  meth_meth_collectionsPrelude__apply4374->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4374->definitionLine = 1785;
// compiled block node returning block4373 (depth = 3)
  gc_frame_newslot(block4373);
// starting to compile block node (depth = 3)
  Object block4381 = alloc_Block(NULL, NULL, "collectionsPrelude", 1786);
  gc_frame_newslot(block4381);
// method _apply
  block_savedest(block4381);
  Object closure4382 = createclosure(3, "_apply");
  setclosureframe(closure4382, stackframe);
  addtoclosure(closure4382, var_val);
  addtoclosure(closure4382, var_block1);
  addtoclosure(closure4382, selfslot);
  struct UserObject *uo4382 = (struct UserObject*)block4381;
  uo4382->data[0] = (Object)closure4382;
  Method *meth_meth_collectionsPrelude__apply4382 = addmethod2pos(block4381, "_apply", &meth_collectionsPrelude__apply4382, 0);
  int argcv_meth_collectionsPrelude__apply4382[] = {0};
  meth_meth_collectionsPrelude__apply4382->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4382);
  meth_meth_collectionsPrelude__apply4382->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4382->definitionLine = 1786;
// compiled block node returning block4381 (depth = 3)
  gc_frame_newslot(block4381);
// call case 5: prelude request
  params[0] = block4373;
  params[1] = block4381;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4391 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4372);
// compiled call node returning call4391 (depth = 2)
  gc_frame_end(frame);
  return call4391;
}
Object meth_collectionsPrelude__apply4398(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_val = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4400 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4401 = callmethodflags(self, "stop", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4400);
// compiled call node returning call4401 (depth = 6)
// compiled member node returning call4401 (depth = 5)
  int op_slot_right_4399 = gc_frame_newslot(call4401);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  int op_slot_left_4399 = gc_frame_newslot(*var_val);
  params[0] = call4401;
  partcv[0] = 1;
  Object opresult4403 = callmethod(*var_val, "<=", 1, partcv, params);
// compiled op node returning opresult4403 (depth = 4)
  gc_frame_end(frame);
  return opresult4403;
}
Object meth_collectionsPrelude__apply4406(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_key = getfromclosure(closure, 0);
  Object *var_val = getfromclosure(closure, 1);
  Object *var_block2 = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1795
  setline(1795);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4407 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_key (depth = 5)
  gc_frame_newslot(*var_key);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  gc_frame_newslot(*var_val);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_block2 (depth = 5)
  params[0] = *var_key;
  params[1] = *var_val;
  partcv[0] = 2;
  Object call4408 = callmethod(*var_block2, "apply",
    1, partcv, params);
  gc_frame_end(callframe4407);
// compiled call node returning call4408 (depth = 4)
// Begin line 1796
  setline(1796);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num4410 = alloc_Float64(1);
// compiled num node returning num4410 (depth = 6)
  int op_slot_right_4409 = gc_frame_newslot(num4410);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_key (depth = 6)
  int op_slot_left_4409 = gc_frame_newslot(*var_key);
  params[0] = num4410;
  partcv[0] = 1;
  Object sum4412 = callmethod(*var_key, "+", 1, partcv, params);
// compiled op node returning sum4412 (depth = 5)
  *var_key = sum4412;
  if (sum4412 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1797
  setline(1797);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num4415 = alloc_Float64(1);
// compiled num node returning num4415 (depth = 6)
  int op_slot_right_4414 = gc_frame_newslot(num4415);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_val (depth = 6)
  int op_slot_left_4414 = gc_frame_newslot(*var_val);
  params[0] = num4415;
  partcv[0] = 1;
  Object sum4417 = callmethod(*var_val, "+", 1, partcv, params);
// compiled op node returning sum4417 (depth = 5)
  *var_val = sum4417;
  if (sum4417 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_keysAndValuesDo4392(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keysAndValuesDo");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method keysAndValuesDo");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for keysAndValuesDo (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block2 = &(stackframe->slots[0]);
  *var_block2 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for keysAndValuesDo");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_key = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "key");
  Object *var_val = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "val");
// Begin line 1792
  setline(1792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num4393 = alloc_Float64(1);
// compiled num node returning num4393 (depth = 3)
  *var_key = num4393;
  if (num4393 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1793
  setline(1793);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4394 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4395 = callmethodflags(self, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4394);
// compiled call node returning call4395 (depth = 4)
// compiled member node returning call4395 (depth = 3)
  *var_val = call4395;
  if (call4395 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1794
  setline(1794);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4396 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block4397 = alloc_Block(NULL, NULL, "collectionsPrelude", 1794);
  gc_frame_newslot(block4397);
// method _apply
  block_savedest(block4397);
  Object closure4398 = createclosure(2, "_apply");
  setclosureframe(closure4398, stackframe);
  addtoclosure(closure4398, var_val);
  addtoclosure(closure4398, selfslot);
  struct UserObject *uo4398 = (struct UserObject*)block4397;
  uo4398->data[0] = (Object)closure4398;
  Method *meth_meth_collectionsPrelude__apply4398 = addmethod2pos(block4397, "_apply", &meth_collectionsPrelude__apply4398, 0);
  int argcv_meth_collectionsPrelude__apply4398[] = {0};
  meth_meth_collectionsPrelude__apply4398->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4398);
  meth_meth_collectionsPrelude__apply4398->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4398->definitionLine = 1793;
// compiled block node returning block4397 (depth = 3)
  gc_frame_newslot(block4397);
// starting to compile block node (depth = 3)
  Object block4405 = alloc_Block(NULL, NULL, "collectionsPrelude", 1794);
  gc_frame_newslot(block4405);
// method _apply
  block_savedest(block4405);
  Object closure4406 = createclosure(4, "_apply");
  setclosureframe(closure4406, stackframe);
  addtoclosure(closure4406, var_key);
  addtoclosure(closure4406, var_val);
  addtoclosure(closure4406, var_block2);
  addtoclosure(closure4406, selfslot);
  struct UserObject *uo4406 = (struct UserObject*)block4405;
  uo4406->data[0] = (Object)closure4406;
  Method *meth_meth_collectionsPrelude__apply4406 = addmethod2pos(block4405, "_apply", &meth_collectionsPrelude__apply4406, 0);
  int argcv_meth_collectionsPrelude__apply4406[] = {0};
  meth_meth_collectionsPrelude__apply4406->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4406);
  meth_meth_collectionsPrelude__apply4406->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4406->definitionLine = 1794;
// compiled block node returning block4405 (depth = 3)
  gc_frame_newslot(block4405);
// call case 5: prelude request
  params[0] = block4397;
  params[1] = block4405;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4420 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4396);
// compiled call node returning call4420 (depth = 2)
  gc_frame_end(frame);
  return call4420;
}
Object meth_collectionsPrelude_reversed4421(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "reversed");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_upper = getfromclosure(closure, 0);
  Object *var_lower = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for reversed (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for reversed");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1801
  setline(1801);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4422 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_upper (depth = 3)
  gc_frame_newslot(*var_upper);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lower (depth = 3)
  gc_frame_newslot(*var_lower);
// call case 2: outer request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4423 = gc_frame_new();
// call case 3: self.outer request
  Object call4424 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4423);
// compiled call node returning call4424 (depth = 4)
// compiled member node returning call4424 (depth = 3)
  params[0] = *var_upper;
  params[1] = *var_lower;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4425 = callmethodflags(call4424, "from()downTo", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4422);
// compiled call node returning call4425 (depth = 2)
  gc_frame_end(frame);
  return call4425;
}
Object meth_collectionsPrelude__43__43_4426(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "++");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method ++");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for ++ (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for ++");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1804
  setline(1804);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4427 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  gc_frame_newslot(*var_other);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4428 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4429 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4430 = gc_frame_new();
// call case 3: self.outer request
  Object call4431 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4430);
// compiled call node returning call4431 (depth = 8)
// compiled member node returning call4431 (depth = 7)
  partcv[0] = 0;
  Object call4432 = callmethodflags(call4431, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4429);
// compiled call node returning call4432 (depth = 6)
// compiled member node returning call4432 (depth = 5)
  partcv[0] = 0;
  Object call4433 = callmethodflags(call4432, "sequence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4428);
// compiled call node returning call4433 (depth = 4)
// compiled member node returning call4433 (depth = 3)
  params[0] = self;
  params[1] = *var_other;
  partcv[0] = 2;
  Object call4434 = callmethod(call4433, "withAll",
    1, partcv, params);
  gc_frame_end(callframe4427);
// compiled call node returning call4434 (depth = 2)
  gc_frame_end(frame);
  return call4434;
}
Object meth_collectionsPrelude__apply4445(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_otherIter = getfromclosure(closure, 0);
  Object *var_selfIter = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4447 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_otherIter (depth = 9)
  partcv[0] = 0;
  Object call4448 = callmethod(*var_otherIter, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe4447);
// compiled call node returning call4448 (depth = 8)
// compiled member node returning call4448 (depth = 7)
  int op_slot_right_4446 = gc_frame_newslot(call4448);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4450 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_selfIter (depth = 9)
  partcv[0] = 0;
  Object call4451 = callmethod(*var_selfIter, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe4450);
// compiled call node returning call4451 (depth = 8)
// compiled member node returning call4451 (depth = 7)
  int op_slot_left_4446 = gc_frame_newslot(call4451);
  params[0] = call4448;
  partcv[0] = 1;
  Object opresult4452 = callmethod(call4451, "&&", 1, partcv, params);
// compiled op node returning opresult4452 (depth = 6)
  gc_frame_end(frame);
  return opresult4452;
}
Object meth_collectionsPrelude__apply4455(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_otherIter = getfromclosure(closure, 0);
  Object *var_selfIter = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1813
  setline(1813);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4458 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_otherIter (depth = 10)
  partcv[0] = 0;
  Object call4459 = callmethod(*var_otherIter, "next",
    1, partcv, params);
  gc_frame_end(callframe4458);
// compiled call node returning call4459 (depth = 9)
// compiled member node returning call4459 (depth = 8)
  int op_slot_right_4457 = gc_frame_newslot(call4459);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4461 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_selfIter (depth = 10)
  partcv[0] = 0;
  Object call4462 = callmethod(*var_selfIter, "next",
    1, partcv, params);
  gc_frame_end(callframe4461);
// compiled call node returning call4462 (depth = 9)
// compiled member node returning call4462 (depth = 8)
  int op_slot_left_4457 = gc_frame_newslot(call4462);
  params[0] = call4459;
  partcv[0] = 1;
  Object opresult4463 = callmethod(call4462, "!=", 1, partcv, params);
// compiled op node returning opresult4463 (depth = 7)
  Object if4456 = done;
  if (istrue(opresult4463)) {
// Begin line 1814
  setline(1814);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool4464 = alloc_Boolean(0);
// compiled identifier node returning bool4464 (depth = 8)
  block_return(realself, bool4464);
// compiled return node returning undefined (depth = 7)
    gc_frame_newslot(undefined);
    if4456 = undefined;
  } else {
  }
// compiled if node returning if4456 (depth = 6)
  gc_frame_end(frame);
  return if4456;
}
Object meth_collectionsPrelude__apply4438(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_other = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_selfIter = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "selfIter");
  Object *var_otherIter = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "otherIter");
// Begin line 1810
  setline(1810);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4439 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4440 = callmethodflags(self, "iterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4439);
// compiled call node returning call4440 (depth = 6)
// compiled member node returning call4440 (depth = 5)
  *var_selfIter = call4440;
  if (call4440 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1811
  setline(1811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4441 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  partcv[0] = 0;
  Object call4442 = callmethod(*var_other, "iterator",
    1, partcv, params);
  gc_frame_end(callframe4441);
// compiled call node returning call4442 (depth = 6)
// compiled member node returning call4442 (depth = 5)
  *var_otherIter = call4442;
  if (call4442 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1812
  setline(1812);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4443 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block4444 = alloc_Block(NULL, NULL, "collectionsPrelude", 1812);
  gc_frame_newslot(block4444);
// method _apply
  block_savedest(block4444);
  Object closure4445 = createclosure(3, "_apply");
  setclosureframe(closure4445, stackframe);
  addtoclosure(closure4445, var_otherIter);
  addtoclosure(closure4445, var_selfIter);
  addtoclosure(closure4445, selfslot);
  struct UserObject *uo4445 = (struct UserObject*)block4444;
  uo4445->data[0] = (Object)closure4445;
  Method *meth_meth_collectionsPrelude__apply4445 = addmethod2pos(block4444, "_apply", &meth_collectionsPrelude__apply4445, 0);
  int argcv_meth_collectionsPrelude__apply4445[] = {0};
  meth_meth_collectionsPrelude__apply4445->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4445);
  meth_meth_collectionsPrelude__apply4445->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4445->definitionLine = 1811;
// compiled block node returning block4444 (depth = 5)
  gc_frame_newslot(block4444);
// starting to compile block node (depth = 5)
  Object block4454 = alloc_Block(NULL, NULL, "collectionsPrelude", 1812);
  gc_frame_newslot(block4454);
// method _apply
  block_savedest(block4454);
  Object closure4455 = createclosure(3, "_apply");
  setclosureframe(closure4455, stackframe);
  addtoclosure(closure4455, var_otherIter);
  addtoclosure(closure4455, var_selfIter);
  addtoclosure(closure4455, selfslot);
  struct UserObject *uo4455 = (struct UserObject*)block4454;
  uo4455->data[0] = (Object)closure4455;
  Method *meth_meth_collectionsPrelude__apply4455 = addmethod2pos(block4454, "_apply", &meth_collectionsPrelude__apply4455, 0);
  int argcv_meth_collectionsPrelude__apply4455[] = {0};
  meth_meth_collectionsPrelude__apply4455->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4455);
  meth_meth_collectionsPrelude__apply4455->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4455->definitionLine = 1812;
// compiled block node returning block4454 (depth = 5)
  gc_frame_newslot(block4454);
// call case 5: prelude request
  params[0] = block4444;
  params[1] = block4454;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4466 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4443);
// compiled call node returning call4466 (depth = 4)
// Begin line 1817
  setline(1817);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4468 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_otherIter (depth = 8)
  partcv[0] = 0;
  Object call4469 = callmethod(*var_otherIter, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe4468);
// compiled call node returning call4469 (depth = 7)
// compiled member node returning call4469 (depth = 6)
  int op_slot_right_4467 = gc_frame_newslot(call4469);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4471 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_selfIter (depth = 8)
  partcv[0] = 0;
  Object call4472 = callmethod(*var_selfIter, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe4471);
// compiled call node returning call4472 (depth = 7)
// compiled member node returning call4472 (depth = 6)
  int op_slot_left_4467 = gc_frame_newslot(call4472);
  params[0] = call4469;
  partcv[0] = 1;
  Object opresult4473 = callmethod(call4472, "==", 1, partcv, params);
// compiled op node returning opresult4473 (depth = 5)
  block_return(realself, opresult4473);
// compiled return node returning undefined (depth = 4)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply4485(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___26 = &(stackframe->slots[0]);
  *var___26 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1820
  setline(1820);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool4486 = alloc_Boolean(0);
// compiled identifier node returning bool4486 (depth = 5)
  block_return(realself, bool4486);
// compiled return node returning undefined (depth = 4)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__61__61_4435(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "==");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method ==");
  Object params[2];
  int partcv[1];
  Object *var_Collection = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for == (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for ==");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1808
  setline(1808);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  int frame4436 = gc_frame_new();
  gc_frame_newslot(*var_other);
// Begin line 1809
  setline(1809);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4437 = alloc_Block(NULL, NULL, "collectionsPrelude", 1809);
  gc_frame_newslot(block4437);
// method _apply
  block_savedest(block4437);
  Object closure4438 = createclosure(2, "_apply");
  setclosureframe(closure4438, stackframe);
  addtoclosure(closure4438, var_other);
  addtoclosure(closure4438, selfslot);
  struct UserObject *uo4438 = (struct UserObject*)block4437;
  uo4438->data[0] = (Object)closure4438;
  Method *meth_meth_collectionsPrelude__apply4438 = addmethod2pos(block4437, "_apply", &meth_collectionsPrelude__apply4438, 0);
  int argcv_meth_collectionsPrelude__apply4438[] = {1};
  meth_meth_collectionsPrelude__apply4438->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4438);
  meth_meth_collectionsPrelude__apply4438->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4438->definitionLine = 1804;
// Begin line 1781
  setline(1781);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4475 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe4476 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4477 == NULL) {
    strlit4477 = alloc_String("o");
    gc_root(strlit4477);
  }
// compiled string node returning strlit4477 (depth = 6)
  gc_frame_newslot(strlit4477);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4478 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4479 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4478);
// compiled call node returning call4479 (depth = 7)
// compiled member node returning call4479 (depth = 6)
  params[0] = strlit4477;
  partcv[0] = 1;
  Object call4480 = callmethod(call4479, "new",
    1, partcv, params);
  gc_frame_end(callframe4476);
// compiled call node returning call4480 (depth = 5)
  gc_frame_newslot(call4480);
// Begin line 1809
  setline(1809);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_Collection (depth = 5)
  gc_frame_newslot(*var_Collection);
// call case 6: other member request
// Begin line 1781
  setline(1781);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4481 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4482 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4481);
// compiled call node returning call4482 (depth = 6)
// compiled member node returning call4482 (depth = 5)
  params[0] = call4480;
  params[1] = *var_Collection;
  partcv[0] = 2;
  Object call4483 = callmethod(call4482, "new",
    1, partcv, params);
  gc_frame_end(callframe4475);
// compiled call node returning call4483 (depth = 4)
((struct UserObject *)block4437)->data[1] = call4483;
// compiled block node returning block4437 (depth = 3)
  gc_frame_newslot(block4437);
// Begin line 1819
  setline(1819);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4484 = alloc_Block(NULL, NULL, "collectionsPrelude", 1819);
  gc_frame_newslot(block4484);
// method _apply
  block_savedest(block4484);
  Object closure4485 = createclosure(1, "_apply");
  setclosureframe(closure4485, stackframe);
  addtoclosure(closure4485, selfslot);
  struct UserObject *uo4485 = (struct UserObject*)block4484;
  uo4485->data[0] = (Object)closure4485;
  Method *meth_meth_collectionsPrelude__apply4485 = addmethod2pos(block4484, "_apply", &meth_collectionsPrelude__apply4485, 0);
  int argcv_meth_collectionsPrelude__apply4485[] = {1};
  meth_meth_collectionsPrelude__apply4485->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4485);
  meth_meth_collectionsPrelude__apply4485->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4485->definitionLine = 1781;
// compiled block node returning block4484 (depth = 3)
  gc_frame_newslot(block4484);
  params[0] = block4437;
  params[1] = block4484;
  Object matchres4436 = matchCase(*var_other, params, 2,NULL);
  gc_frame_end(frame4436);
// compiled matchcase node returning matchres4436 (depth = 2)
  gc_frame_end(frame);
  return matchres4436;
}
Object meth_collectionsPrelude_sorted4488(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sorted");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for sorted (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for sorted");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1823
  setline(1823);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_sortedBy4489(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sortedBy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method sortedBy");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for sortedBy (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for sortedBy");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1825
  setline(1825);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4490 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_c (depth = 3)
  gc_frame_newslot(*var_c);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4491 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4492 = callmethodflags(self, "asList", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4491);
// compiled call node returning call4492 (depth = 4)
// compiled member node returning call4492 (depth = 3)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call4493 = callmethod(call4492, "sortBy",
    1, partcv, params);
  gc_frame_end(callframe4490);
// compiled call node returning call4493 (depth = 2)
  gc_frame_end(frame);
  return call4493;
}
Object meth_collectionsPrelude_keys4494(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keys");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for keys (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for keys");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1827
  setline(1827);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4496 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4497 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4496);
// compiled call node returning call4497 (depth = 4)
// compiled member node returning call4497 (depth = 3)
  int op_slot_right_4495 = gc_frame_newslot(call4497);
// starting to compile num node (depth = 3)
  Object num4499 = alloc_Float64(1);
// compiled num node returning num4499 (depth = 3)
  int op_slot_left_4495 = gc_frame_newslot(num4499);
  params[0] = call4497;
  partcv[0] = 1;
  Object opresult4500 = callmethod(num4499, "..", 1, partcv, params);
// compiled op node returning opresult4500 (depth = 2)
  gc_frame_end(frame);
  return opresult4500;
}
Object meth_collectionsPrelude_values4501(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "values");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for values (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for values");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1829
  setline(1829);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_asString4502(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 17, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_upper = getfromclosure(closure, 0);
  Object *var_lower = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1832
  setline(1832);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit4504 == NULL) {
    strlit4504 = alloc_String(")");
    gc_root(strlit4504);
  }
// compiled string node returning strlit4504 (depth = 3)
  int op_slot_right_4503 = gc_frame_newslot(strlit4504);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_upper (depth = 4)
  int op_slot_right_4506 = gc_frame_newslot(*var_upper);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4509 == NULL) {
    strlit4509 = alloc_String(")to(");
    gc_root(strlit4509);
  }
// compiled string node returning strlit4509 (depth = 5)
  int op_slot_right_4508 = gc_frame_newslot(strlit4509);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lower (depth = 6)
  int op_slot_right_4511 = gc_frame_newslot(*var_lower);
// starting to compile string node (depth = 6)
  if (strlit4513 == NULL) {
    strlit4513 = alloc_String("range.from(");
    gc_root(strlit4513);
  }
// compiled string node returning strlit4513 (depth = 6)
  int op_slot_left_4511 = gc_frame_newslot(strlit4513);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult4514 = callmethod(strlit4513, "++", 1, partcv, params);
// compiled op node returning opresult4514 (depth = 5)
  int op_slot_left_4508 = gc_frame_newslot(opresult4514);
  params[0] = strlit4509;
  partcv[0] = 1;
  Object opresult4515 = callmethod(opresult4514, "++", 1, partcv, params);
// compiled op node returning opresult4515 (depth = 4)
  int op_slot_left_4506 = gc_frame_newslot(opresult4515);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult4516 = callmethod(opresult4515, "++", 1, partcv, params);
// compiled op node returning opresult4516 (depth = 3)
  int op_slot_left_4503 = gc_frame_newslot(opresult4516);
  params[0] = strlit4504;
  partcv[0] = 1;
  Object opresult4517 = callmethod(opresult4516, "++", 1, partcv, params);
// compiled op node returning opresult4517 (depth = 2)
  gc_frame_end(frame);
  return opresult4517;
}
Object meth_collectionsPrelude__apply4529(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_result = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe4530 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_each (depth = 5)
  gc_frame_newslot(*var_each);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call4531 = callmethod(*var_result, "add",
    1, partcv, params);
  gc_frame_end(callframe4530);
// compiled call node returning call4531 (depth = 4)
  gc_frame_end(frame);
  return call4531;
}
Object meth_collectionsPrelude_asList4518(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asList");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asList (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asList");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "result");
// Begin line 1836
  setline(1836);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4519 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4520 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4521 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4522 = gc_frame_new();
// call case 3: self.outer request
  Object call4523 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4522);
// compiled call node returning call4523 (depth = 10)
// compiled member node returning call4523 (depth = 9)
  partcv[0] = 0;
  Object call4524 = callmethodflags(call4523, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4521);
// compiled call node returning call4524 (depth = 8)
// compiled member node returning call4524 (depth = 7)
  partcv[0] = 0;
  Object call4525 = callmethodflags(call4524, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4520);
// compiled call node returning call4525 (depth = 6)
// compiled member node returning call4525 (depth = 5)
  partcv[0] = 0;
  Object call4526 = callmethod(call4525, "empty",
    1, partcv, params);
  gc_frame_end(callframe4519);
// compiled call node returning call4526 (depth = 4)
// compiled member node returning call4526 (depth = 3)
  *var_result = call4526;
  if (call4526 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1837
  setline(1837);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4527 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// starting to compile block node (depth = 3)
  Object block4528 = alloc_Block(NULL, NULL, "collectionsPrelude", 1837);
  gc_frame_newslot(block4528);
// method _apply
  block_savedest(block4528);
  Object closure4529 = createclosure(2, "_apply");
  setclosureframe(closure4529, stackframe);
  addtoclosure(closure4529, var_result);
  addtoclosure(closure4529, selfslot);
  struct UserObject *uo4529 = (struct UserObject*)block4528;
  uo4529->data[0] = (Object)closure4529;
  Method *meth_meth_collectionsPrelude__apply4529 = addmethod2pos(block4528, "_apply", &meth_collectionsPrelude__apply4529, 0);
  int argcv_meth_collectionsPrelude__apply4529[] = {1};
  meth_meth_collectionsPrelude__apply4529->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4529);
  meth_meth_collectionsPrelude__apply4529->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4529->definitionLine = 1836;
// compiled block node returning block4528 (depth = 3)
  gc_frame_newslot(block4528);
// call case 5: prelude request
  params[0] = self;
  params[1] = block4528;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4533 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4527);
// compiled call node returning call4533 (depth = 2)
// Begin line 1838
  setline(1838);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_result (depth = 2)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_collectionsPrelude_asSequence4534(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asSequence");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asSequence (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asSequence");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1842
  setline(1842);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply4539(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___22 = &(stackframe->slots[0]);
  *var___22 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude__apply4551(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_upper = getfromclosure(closure, 0);
  Object *var_lower = getfromclosure(closure, 1);
  Object *var_RequestError = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___23 = &(stackframe->slots[0]);
  *var___23 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// Begin line 1731
  setline(1731);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4554 == NULL) {
    strlit4554 = alloc_String(") is not an integer");
    gc_root(strlit4554);
  }
// compiled string node returning strlit4554 (depth = 6)
  int op_slot_right_4553 = gc_frame_newslot(strlit4554);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_upper (depth = 7)
  int op_slot_right_4556 = gc_frame_newslot(*var_upper);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4559 == NULL) {
    strlit4559 = alloc_String(")to(");
    gc_root(strlit4559);
  }
// compiled string node returning strlit4559 (depth = 8)
  int op_slot_right_4558 = gc_frame_newslot(strlit4559);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lower (depth = 9)
  int op_slot_right_4561 = gc_frame_newslot(*var_lower);
// starting to compile string node (depth = 9)
  if (strlit4563 == NULL) {
    strlit4563 = alloc_String(" in range.from(");
    gc_root(strlit4563);
  }
// compiled string node returning strlit4563 (depth = 9)
  int op_slot_left_4561 = gc_frame_newslot(strlit4563);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult4564 = callmethod(strlit4563, "++", 1, partcv, params);
// compiled op node returning opresult4564 (depth = 8)
  int op_slot_left_4558 = gc_frame_newslot(opresult4564);
  params[0] = strlit4559;
  partcv[0] = 1;
  Object opresult4565 = callmethod(opresult4564, "++", 1, partcv, params);
// compiled op node returning opresult4565 (depth = 7)
  int op_slot_left_4556 = gc_frame_newslot(opresult4565);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult4566 = callmethod(opresult4565, "++", 1, partcv, params);
// compiled op node returning opresult4566 (depth = 6)
  int op_slot_left_4553 = gc_frame_newslot(opresult4566);
  params[0] = strlit4554;
  partcv[0] = 1;
  Object opresult4567 = callmethod(opresult4566, "++", 1, partcv, params);
// compiled op node returning opresult4567 (depth = 5)
  int op_slot_right_4552 = gc_frame_newslot(opresult4567);
// Begin line 1730
  setline(1730);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4569 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4571 == NULL) {
    strlit4571 = alloc_String("");
    gc_root(strlit4571);
  }
// compiled string node returning strlit4571 (depth = 7)
  int op_slot_right_4570 = gc_frame_newslot(strlit4571);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lower (depth = 8)
  int op_slot_right_4573 = gc_frame_newslot(*var_lower);
// starting to compile string node (depth = 8)
  if (strlit4575 == NULL) {
    strlit4575 = alloc_String("lower bound ");
    gc_root(strlit4575);
  }
// compiled string node returning strlit4575 (depth = 8)
  int op_slot_left_4573 = gc_frame_newslot(strlit4575);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult4576 = callmethod(strlit4575, "++", 1, partcv, params);
// compiled op node returning opresult4576 (depth = 7)
  int op_slot_left_4570 = gc_frame_newslot(opresult4576);
  params[0] = strlit4571;
  partcv[0] = 1;
  Object opresult4577 = callmethod(opresult4576, "++", 1, partcv, params);
// compiled op node returning opresult4577 (depth = 6)
  gc_frame_newslot(opresult4577);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_RequestError (depth = 6)
  params[0] = opresult4577;
  partcv[0] = 1;
  Object call4578 = callmethod(*var_RequestError, "raise",
    1, partcv, params);
  gc_frame_end(callframe4569);
// compiled call node returning call4578 (depth = 5)
  int op_slot_left_4552 = gc_frame_newslot(call4578);
  params[0] = opresult4567;
  partcv[0] = 1;
  Object opresult4579 = callmethod(call4578, "++", 1, partcv, params);
// compiled op node returning opresult4579 (depth = 4)
  gc_frame_end(frame);
  return opresult4579;
}
Object meth_collectionsPrelude__apply4619(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___24 = &(stackframe->slots[0]);
  *var___24 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude__apply4631(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_upper = getfromclosure(closure, 0);
  Object *var_lower = getfromclosure(closure, 1);
  Object *var_RequestError = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___25 = &(stackframe->slots[0]);
  *var___25 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// Begin line 1740
  setline(1740);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4634 == NULL) {
    strlit4634 = alloc_String(") is not an integer");
    gc_root(strlit4634);
  }
// compiled string node returning strlit4634 (depth = 6)
  int op_slot_right_4633 = gc_frame_newslot(strlit4634);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_upper (depth = 7)
  int op_slot_right_4636 = gc_frame_newslot(*var_upper);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4639 == NULL) {
    strlit4639 = alloc_String(")to(");
    gc_root(strlit4639);
  }
// compiled string node returning strlit4639 (depth = 8)
  int op_slot_right_4638 = gc_frame_newslot(strlit4639);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lower (depth = 9)
  int op_slot_right_4641 = gc_frame_newslot(*var_lower);
// starting to compile string node (depth = 9)
  if (strlit4643 == NULL) {
    strlit4643 = alloc_String(" in range.from(");
    gc_root(strlit4643);
  }
// compiled string node returning strlit4643 (depth = 9)
  int op_slot_left_4641 = gc_frame_newslot(strlit4643);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult4644 = callmethod(strlit4643, "++", 1, partcv, params);
// compiled op node returning opresult4644 (depth = 8)
  int op_slot_left_4638 = gc_frame_newslot(opresult4644);
  params[0] = strlit4639;
  partcv[0] = 1;
  Object opresult4645 = callmethod(opresult4644, "++", 1, partcv, params);
// compiled op node returning opresult4645 (depth = 7)
  int op_slot_left_4636 = gc_frame_newslot(opresult4645);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult4646 = callmethod(opresult4645, "++", 1, partcv, params);
// compiled op node returning opresult4646 (depth = 6)
  int op_slot_left_4633 = gc_frame_newslot(opresult4646);
  params[0] = strlit4634;
  partcv[0] = 1;
  Object opresult4647 = callmethod(opresult4646, "++", 1, partcv, params);
// compiled op node returning opresult4647 (depth = 5)
  int op_slot_right_4632 = gc_frame_newslot(opresult4647);
// Begin line 1739
  setline(1739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4649 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4651 == NULL) {
    strlit4651 = alloc_String("");
    gc_root(strlit4651);
  }
// compiled string node returning strlit4651 (depth = 7)
  int op_slot_right_4650 = gc_frame_newslot(strlit4651);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_upper (depth = 8)
  int op_slot_right_4653 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 8)
  if (strlit4655 == NULL) {
    strlit4655 = alloc_String("upper bound ");
    gc_root(strlit4655);
  }
// compiled string node returning strlit4655 (depth = 8)
  int op_slot_left_4653 = gc_frame_newslot(strlit4655);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult4656 = callmethod(strlit4655, "++", 1, partcv, params);
// compiled op node returning opresult4656 (depth = 7)
  int op_slot_left_4650 = gc_frame_newslot(opresult4656);
  params[0] = strlit4651;
  partcv[0] = 1;
  Object opresult4657 = callmethod(opresult4656, "++", 1, partcv, params);
// compiled op node returning opresult4657 (depth = 6)
  gc_frame_newslot(opresult4657);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_RequestError (depth = 6)
  params[0] = opresult4657;
  partcv[0] = 1;
  Object call4658 = callmethod(*var_RequestError, "raise",
    1, partcv, params);
  gc_frame_end(callframe4649);
// compiled call node returning call4658 (depth = 5)
  int op_slot_left_4632 = gc_frame_newslot(call4658);
  params[0] = opresult4647;
  partcv[0] = 1;
  Object opresult4659 = callmethod(call4658, "++", 1, partcv, params);
// compiled op node returning opresult4659 (depth = 4)
  gc_frame_end(frame);
  return opresult4659;
}
Object meth_collectionsPrelude__apply4704(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4706 = alloc_Float64(3);
// compiled num node returning num4706 (depth = 4)
  int op_slot_right_4705 = gc_frame_newslot(num4706);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4709 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4710 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4711 = callmethodflags(self, "stop", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4710);
// compiled call node returning call4711 (depth = 8)
// compiled member node returning call4711 (depth = 7)
  partcv[0] = 0;
  Object call4712 = callmethod(call4711, "hash",
    1, partcv, params);
  gc_frame_end(callframe4709);
// compiled call node returning call4712 (depth = 6)
// compiled member node returning call4712 (depth = 5)
  int op_slot_right_4708 = gc_frame_newslot(call4712);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num4715 = alloc_Float64(1021);
// compiled num node returning num4715 (depth = 6)
  int op_slot_right_4714 = gc_frame_newslot(num4715);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4717 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4718 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4719 = callmethodflags(self, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4718);
// compiled call node returning call4719 (depth = 9)
// compiled member node returning call4719 (depth = 8)
  partcv[0] = 0;
  Object call4720 = callmethod(call4719, "hash",
    1, partcv, params);
  gc_frame_end(callframe4717);
// compiled call node returning call4720 (depth = 7)
// compiled member node returning call4720 (depth = 6)
  int op_slot_left_4714 = gc_frame_newslot(call4720);
  params[0] = num4715;
  partcv[0] = 1;
  Object prod4721 = callmethod(call4720, "*", 1, partcv, params);
// compiled op node returning prod4721 (depth = 5)
  int op_slot_left_4708 = gc_frame_newslot(prod4721);
  params[0] = call4712;
  partcv[0] = 1;
  Object sum4722 = callmethod(prod4721, "+", 1, partcv, params);
// compiled op node returning sum4722 (depth = 4)
  int op_slot_left_4705 = gc_frame_newslot(sum4722);
  params[0] = num4706;
  partcv[0] = 1;
  Object prod4723 = callmethod(sum4722, "*", 1, partcv, params);
// compiled op node returning prod4723 (depth = 3)
  gc_frame_end(frame);
  return prod4723;
}
Object meth_collectionsPrelude_from_40__41_to4183(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "from()to");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method from()to");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method from()to");
  Object params[2];
  int partcv[2];
  Object *var_Exhausted = getfromclosure(closure, 0);
  Object *var_BoundsError = getfromclosure(closure, 1);
  Object *var__prelude = getfromclosure(closure, 2);
  Object *var_Collection = getfromclosure(closure, 3);
  Object *var_indexable = getfromclosure(closure, 4);
  Object *var_Number = getfromclosure(closure, 5);
  Object *var_RequestError = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for from()to (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_lower = &(stackframe->slots[0]);
  *var_lower = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for from");
  Object *var_upper = &(stackframe->slots[1]);
  *var_upper = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for to");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4184 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4184 = alloc_userobj2(25,26, objclass4184);
  gc_frame_newslot(obj4184);
if (objclass4184 == NULL) {
  glfree(obj4184->class->name);
  obj4184->class->name = "obj4181.from()to";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4184, self, 0);
  addmethodreal(obj4184,"outer", &reader_collectionsPrelude_outer_4185);
  Object oldself4184 = self;
  struct StackFrameObject *oldstackframe4184 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4184);
  gc_frame_newslot((Object)stackframe);
  self = obj4184;
  Object *oldselfslot4184 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4184 = (*(struct UserObject *)self).data[0], lowerouter4184 = thisouter4184;
  if (inheritingObject4184) {
    struct UserObject *inho4184 = (struct UserObject *)inheritingObject4184;
    while (inho4184->super != GraceDefaultObject) inho4184 = (struct UserObject *)inho4184->super;
    inho4184->super = obj4184;
    self = inheritingObject4184;
    *selfslot = self;
    lowerouter4184 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4184;
  }
if (objclass4184 == NULL) {
  Method *reader4186 = addmethodrealflags(obj4184, "start",&reader_collectionsPrelude_start_4186, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader4186->definitionModule = modulename;
  reader4186->definitionLine = 1732;
}
adddatum2(obj4184, alloc_Undefined(), 1);
if (objclass4184 == NULL) {
  Method *reader4187 = addmethodrealflags(obj4184, "stop",&reader_collectionsPrelude_stop_4187, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader4187->definitionModule = modulename;
  reader4187->definitionLine = 1741;
}
adddatum2(obj4184, alloc_Undefined(), 2);
if (objclass4184 == NULL) {
  Method *reader4188 = addmethodrealflags(obj4184, "size",&reader_collectionsPrelude_size_4188, MFLAG_DEF);
  reader4188->definitionModule = modulename;
  reader4188->definitionLine = 1747;
}
adddatum2(obj4184, alloc_Undefined(), 3);
if (objclass4184 == NULL) {
  Method *reader4189 = addmethodrealflags(obj4184, "hash",&reader_collectionsPrelude_hash_4189, MFLAG_DEF);
  reader4189->definitionModule = modulename;
  reader4189->definitionLine = 1750;
}
adddatum2(obj4184, alloc_Undefined(), 4);
// method iterator
  block_savedest(obj4184);
  Object closure4190 = createclosure(3, "iterator");
  setclosureframe(closure4190, stackframe);
  addtoclosure(closure4190, var_Exhausted);
  addtoclosure(closure4190, var_lower);
  addtoclosure(closure4190, var_upper);
  struct UserObject *uo4190 = (struct UserObject*)obj4184;
  uo4190->data[5] = (Object)closure4190;
  Method *meth_meth_collectionsPrelude_iterator4190 = addmethod2pos(obj4184, "iterator", &meth_collectionsPrelude_iterator4190, 5);
  int argcv_meth_collectionsPrelude_iterator4190[] = {0};
  meth_meth_collectionsPrelude_iterator4190->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator4190);
  meth_meth_collectionsPrelude_iterator4190->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator4190->definitionLine = 1752;
  block_savedest(obj4184);
  Object closure4272 = createclosure(3, "iterator()object");
  setclosureframe(closure4272, stackframe);
  addtoclosure(closure4272, var_Exhausted);
  addtoclosure(closure4272, var_lower);
  addtoclosure(closure4272, var_upper);
  Method *meth_meth_collectionsPrelude_iterator4190_object = addmethod2pos(obj4184, "iterator()object", &meth_collectionsPrelude_iterator4190_object, 5);
  meth_meth_collectionsPrelude_iterator4190_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator4190_object->definitionLine = 1752;
// method at
  block_savedest(obj4184);
  Object closure4273 = createclosure(1, "at");
  setclosureframe(closure4273, stackframe);
  addtoclosure(closure4273, var_BoundsError);
  struct UserObject *uo4273 = (struct UserObject*)obj4184;
  uo4273->data[6] = (Object)closure4273;
  Method *meth_meth_collectionsPrelude_at4273 = addmethod2pos(obj4184, "at", &meth_collectionsPrelude_at4273, 6);
  int argcv_meth_collectionsPrelude_at4273[] = {1};
  meth_meth_collectionsPrelude_at4273->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at4273);
meth_meth_collectionsPrelude_at4273->type->types[0] = type_Number;
meth_meth_collectionsPrelude_at4273->type->names[0] = "ix";
  meth_meth_collectionsPrelude_at4273->definitionModule = modulename;
  meth_meth_collectionsPrelude_at4273->definitionLine = 1766;
// method contains
  block_savedest(obj4184);
  Object closure4327 = createclosure(1, "contains");
  setclosureframe(closure4327, stackframe);
  addtoclosure(closure4327, var__prelude);
  struct UserObject *uo4327 = (struct UserObject*)obj4184;
  uo4327->data[7] = (Object)closure4327;
  Method *meth_meth_collectionsPrelude_contains4327 = addmethod2pos(obj4184, "contains", &meth_collectionsPrelude_contains4327, 7);
  int argcv_meth_collectionsPrelude_contains4327[] = {1};
  meth_meth_collectionsPrelude_contains4327->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains4327);
  meth_meth_collectionsPrelude_contains4327->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains4327->definitionLine = 1775;
// method do
  struct UserObject *uo4369 = (struct UserObject*)obj4184;
  uo4369->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do4369 = addmethod2pos(obj4184, "do", &meth_collectionsPrelude_do4369, 8);
  int argcv_meth_collectionsPrelude_do4369[] = {1};
  meth_meth_collectionsPrelude_do4369->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do4369);
  meth_meth_collectionsPrelude_do4369->definitionModule = modulename;
  meth_meth_collectionsPrelude_do4369->definitionLine = 1784;
// method keysAndValuesDo
  struct UserObject *uo4392 = (struct UserObject*)obj4184;
  uo4392->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo4392 = addmethod2pos(obj4184, "keysAndValuesDo", &meth_collectionsPrelude_keysAndValuesDo4392, 9);
  int argcv_meth_collectionsPrelude_keysAndValuesDo4392[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo4392->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo4392);
  meth_meth_collectionsPrelude_keysAndValuesDo4392->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo4392->definitionLine = 1791;
// method reversed
  block_savedest(obj4184);
  Object closure4421 = createclosure(2, "reversed");
  setclosureframe(closure4421, stackframe);
  addtoclosure(closure4421, var_upper);
  addtoclosure(closure4421, var_lower);
  struct UserObject *uo4421 = (struct UserObject*)obj4184;
  uo4421->data[10] = (Object)closure4421;
  Method *meth_meth_collectionsPrelude_reversed4421 = addmethod2pos(obj4184, "reversed", &meth_collectionsPrelude_reversed4421, 10);
  int argcv_meth_collectionsPrelude_reversed4421[] = {0};
  meth_meth_collectionsPrelude_reversed4421->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reversed4421);
  meth_meth_collectionsPrelude_reversed4421->definitionModule = modulename;
  meth_meth_collectionsPrelude_reversed4421->definitionLine = 1800;
// method ++
  struct UserObject *uo4426 = (struct UserObject*)obj4184;
  uo4426->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43_4426 = addmethod2pos(obj4184, "++", &meth_collectionsPrelude__43__43_4426, 11);
  int argcv_meth_collectionsPrelude__43__43_4426[] = {1};
  meth_meth_collectionsPrelude__43__43_4426->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43_4426);
  meth_meth_collectionsPrelude__43__43_4426->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43_4426->definitionLine = 1803;
// method ==
  block_savedest(obj4184);
  Object closure4435 = createclosure(1, "==");
  setclosureframe(closure4435, stackframe);
  addtoclosure(closure4435, var_Collection);
  struct UserObject *uo4435 = (struct UserObject*)obj4184;
  uo4435->data[12] = (Object)closure4435;
  Method *meth_meth_collectionsPrelude__61__61_4435 = addmethod2pos(obj4184, "==", &meth_collectionsPrelude__61__61_4435, 12);
  int argcv_meth_collectionsPrelude__61__61_4435[] = {1};
  meth_meth_collectionsPrelude__61__61_4435->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61_4435);
  meth_meth_collectionsPrelude__61__61_4435->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61_4435->definitionLine = 1806;
// method sorted
  struct UserObject *uo4488 = (struct UserObject*)obj4184;
  uo4488->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted4488 = addmethod2pos(obj4184, "sorted", &meth_collectionsPrelude_sorted4488, 13);
  int argcv_meth_collectionsPrelude_sorted4488[] = {0};
  meth_meth_collectionsPrelude_sorted4488->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted4488);
  meth_meth_collectionsPrelude_sorted4488->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted4488->definitionLine = 1823;
// method sortedBy
  struct UserObject *uo4489 = (struct UserObject*)obj4184;
  uo4489->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy4489 = addmethod2pos(obj4184, "sortedBy", &meth_collectionsPrelude_sortedBy4489, 14);
  int argcv_meth_collectionsPrelude_sortedBy4489[] = {1};
  meth_meth_collectionsPrelude_sortedBy4489->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy4489);
  meth_meth_collectionsPrelude_sortedBy4489->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy4489->definitionLine = 1825;
// method keys
  struct UserObject *uo4494 = (struct UserObject*)obj4184;
  uo4494->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keys4494 = addmethod2pos(obj4184, "keys", &meth_collectionsPrelude_keys4494, 15);
  int argcv_meth_collectionsPrelude_keys4494[] = {0};
  meth_meth_collectionsPrelude_keys4494->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys4494);
  meth_meth_collectionsPrelude_keys4494->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys4494->definitionLine = 1827;
// method values
  struct UserObject *uo4501 = (struct UserObject*)obj4184;
  uo4501->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values4501 = addmethod2pos(obj4184, "values", &meth_collectionsPrelude_values4501, 16);
  int argcv_meth_collectionsPrelude_values4501[] = {0};
  meth_meth_collectionsPrelude_values4501->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values4501);
  meth_meth_collectionsPrelude_values4501->definitionModule = modulename;
  meth_meth_collectionsPrelude_values4501->definitionLine = 1829;
// method asString
  block_savedest(obj4184);
  Object closure4502 = createclosure(2, "asString");
  setclosureframe(closure4502, stackframe);
  addtoclosure(closure4502, var_upper);
  addtoclosure(closure4502, var_lower);
  struct UserObject *uo4502 = (struct UserObject*)obj4184;
  uo4502->data[17] = (Object)closure4502;
  Method *meth_meth_collectionsPrelude_asString4502 = addmethod2pos(obj4184, "asString", &meth_collectionsPrelude_asString4502, 17);
  int argcv_meth_collectionsPrelude_asString4502[] = {0};
  meth_meth_collectionsPrelude_asString4502->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString4502);
  meth_meth_collectionsPrelude_asString4502->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString4502->definitionLine = 1831;
// method asList
  struct UserObject *uo4518 = (struct UserObject*)obj4184;
  uo4518->data[18] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asList4518 = addmethod2pos(obj4184, "asList", &meth_collectionsPrelude_asList4518, 18);
  int argcv_meth_collectionsPrelude_asList4518[] = {0};
  meth_meth_collectionsPrelude_asList4518->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asList4518);
  meth_meth_collectionsPrelude_asList4518->definitionModule = modulename;
  meth_meth_collectionsPrelude_asList4518->definitionLine = 1835;
// method asSequence
  struct UserObject *uo4534 = (struct UserObject*)obj4184;
  uo4534->data[19] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asSequence4534 = addmethod2pos(obj4184, "asSequence", &meth_collectionsPrelude_asSequence4534, 19);
  int argcv_meth_collectionsPrelude_asSequence4534[] = {0};
  meth_meth_collectionsPrelude_asSequence4534->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asSequence4534);
  meth_meth_collectionsPrelude_asSequence4534->definitionModule = modulename;
  meth_meth_collectionsPrelude_asSequence4534->definitionLine = 1841;
  sourceObject = obj4184;
// Begin line 1727
  setline(1727);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4535 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indexable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call4536 = callmethod(*var_indexable, "trait()object",
    2, partcv, params);
  gc_frame_end(callframe4535);
// compiled call node returning call4536 (depth = 2)
  struct UserObject *obj4184_uo = (struct UserObject *)obj4184;
  obj4184_uo->super = call4536;
  sourceObject = obj4184;
// Begin line 1728
  setline(1728);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lower (depth = 3)
  int frame4537 = gc_frame_new();
  gc_frame_newslot(*var_lower);
// Begin line 1729
  setline(1729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4538 = alloc_Block(NULL, NULL, "collectionsPrelude", 1729);
  gc_frame_newslot(block4538);
// method _apply
  block_savedest(block4538);
  Object closure4539 = createclosure(1, "_apply");
  setclosureframe(closure4539, stackframe);
  addtoclosure(closure4539, selfslot);
  struct UserObject *uo4539 = (struct UserObject*)block4538;
  uo4539->data[0] = (Object)closure4539;
  Method *meth_meth_collectionsPrelude__apply4539 = addmethod2pos(block4538, "_apply", &meth_collectionsPrelude__apply4539, 0);
  int argcv_meth_collectionsPrelude__apply4539[] = {1};
  meth_meth_collectionsPrelude__apply4539->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4539);
meth_meth_collectionsPrelude__apply4539->type->types[0] = type_Number;
meth_meth_collectionsPrelude__apply4539->type->names[0] = "__22";
  meth_meth_collectionsPrelude__apply4539->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4539->definitionLine = 1836;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4541 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe4542 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4543 == NULL) {
    strlit4543 = alloc_String("__22");
    gc_root(strlit4543);
  }
// compiled string node returning strlit4543 (depth = 6)
  gc_frame_newslot(strlit4543);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4544 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4545 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4544);
// compiled call node returning call4545 (depth = 7)
// compiled member node returning call4545 (depth = 6)
  params[0] = strlit4543;
  partcv[0] = 1;
  Object call4546 = callmethod(call4545, "new",
    1, partcv, params);
  gc_frame_end(callframe4542);
// compiled call node returning call4546 (depth = 5)
  gc_frame_newslot(call4546);
// Begin line 1729
  setline(1729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_Number (depth = 5)
  gc_frame_newslot(*var_Number);
// call case 6: other member request
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4547 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4548 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4547);
// compiled call node returning call4548 (depth = 6)
// compiled member node returning call4548 (depth = 5)
  params[0] = call4546;
  params[1] = *var_Number;
  partcv[0] = 2;
  Object call4549 = callmethod(call4548, "new",
    1, partcv, params);
  gc_frame_end(callframe4541);
// compiled call node returning call4549 (depth = 4)
((struct UserObject *)block4538)->data[1] = call4549;
// compiled block node returning block4538 (depth = 3)
  gc_frame_newslot(block4538);
// Begin line 1730
  setline(1730);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4550 = alloc_Block(NULL, NULL, "collectionsPrelude", 1730);
  gc_frame_newslot(block4550);
// method _apply
  block_savedest(block4550);
  Object closure4551 = createclosure(4, "_apply");
  setclosureframe(closure4551, stackframe);
  addtoclosure(closure4551, var_upper);
  addtoclosure(closure4551, var_lower);
  addtoclosure(closure4551, var_RequestError);
  addtoclosure(closure4551, selfslot);
  struct UserObject *uo4551 = (struct UserObject*)block4550;
  uo4551->data[0] = (Object)closure4551;
  Method *meth_meth_collectionsPrelude__apply4551 = addmethod2pos(block4550, "_apply", &meth_collectionsPrelude__apply4551, 0);
  int argcv_meth_collectionsPrelude__apply4551[] = {1};
  meth_meth_collectionsPrelude__apply4551->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4551);
  meth_meth_collectionsPrelude__apply4551->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4551->definitionLine = 0;
// compiled block node returning block4550 (depth = 3)
  gc_frame_newslot(block4550);
  params[0] = block4538;
  params[1] = block4550;
  Object matchres4537 = matchCase(*var_lower, params, 2,NULL);
  gc_frame_end(frame4537);
// compiled matchcase node returning matchres4537 (depth = 2)
  sourceObject = obj4184;
// Begin line 1732
  setline(1732);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4581 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lower (depth = 4)
  partcv[0] = 0;
  Object call4582 = callmethod(*var_lower, "truncated",
    1, partcv, params);
  gc_frame_end(callframe4581);
// compiled call node returning call4582 (depth = 3)
// compiled member node returning call4582 (depth = 2)
  adddatum2(obj4184, call4582, 1);
  sourceObject = obj4184;
// Begin line 1733
  setline(1733);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lower (depth = 4)
  int op_slot_right_4584 = gc_frame_newslot(*var_lower);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4586 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4587 = callmethodflags(self, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4586);
// compiled call node returning call4587 (depth = 5)
// compiled member node returning call4587 (depth = 4)
  int op_slot_left_4584 = gc_frame_newslot(call4587);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult4588 = callmethod(call4587, "!=", 1, partcv, params);
// compiled op node returning opresult4588 (depth = 3)
  Object if4583 = done;
struct StackFrameObject *iftmpstackframe4583 = stackframe;
  if (istrue(opresult4588)) {
stackframe = alloc_StackFrame(0, iftmpstackframe4583);
gc_frame_newslot((Object)stackframe);
// Begin line 1734
  setline(1734);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// Begin line 1735
  setline(1735);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4591 == NULL) {
    strlit4591 = alloc_String(") is not an integer");
    gc_root(strlit4591);
  }
// compiled string node returning strlit4591 (depth = 5)
  int op_slot_right_4590 = gc_frame_newslot(strlit4591);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_upper (depth = 6)
  int op_slot_right_4593 = gc_frame_newslot(*var_upper);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4596 == NULL) {
    strlit4596 = alloc_String(")to(");
    gc_root(strlit4596);
  }
// compiled string node returning strlit4596 (depth = 7)
  int op_slot_right_4595 = gc_frame_newslot(strlit4596);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lower (depth = 8)
  int op_slot_right_4598 = gc_frame_newslot(*var_lower);
// starting to compile string node (depth = 8)
  if (strlit4600 == NULL) {
    strlit4600 = alloc_String(" in range.from(");
    gc_root(strlit4600);
  }
// compiled string node returning strlit4600 (depth = 8)
  int op_slot_left_4598 = gc_frame_newslot(strlit4600);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult4601 = callmethod(strlit4600, "++", 1, partcv, params);
// compiled op node returning opresult4601 (depth = 7)
  int op_slot_left_4595 = gc_frame_newslot(opresult4601);
  params[0] = strlit4596;
  partcv[0] = 1;
  Object opresult4602 = callmethod(opresult4601, "++", 1, partcv, params);
// compiled op node returning opresult4602 (depth = 6)
  int op_slot_left_4593 = gc_frame_newslot(opresult4602);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult4603 = callmethod(opresult4602, "++", 1, partcv, params);
// compiled op node returning opresult4603 (depth = 5)
  int op_slot_left_4590 = gc_frame_newslot(opresult4603);
  params[0] = strlit4591;
  partcv[0] = 1;
  Object opresult4604 = callmethod(opresult4603, "++", 1, partcv, params);
// compiled op node returning opresult4604 (depth = 4)
  int op_slot_right_4589 = gc_frame_newslot(opresult4604);
// Begin line 1734
  setline(1734);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4606 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4608 == NULL) {
    strlit4608 = alloc_String("");
    gc_root(strlit4608);
  }
// compiled string node returning strlit4608 (depth = 6)
  int op_slot_right_4607 = gc_frame_newslot(strlit4608);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lower (depth = 7)
  int op_slot_right_4610 = gc_frame_newslot(*var_lower);
// starting to compile string node (depth = 7)
  if (strlit4612 == NULL) {
    strlit4612 = alloc_String("lower bound ");
    gc_root(strlit4612);
  }
// compiled string node returning strlit4612 (depth = 7)
  int op_slot_left_4610 = gc_frame_newslot(strlit4612);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult4613 = callmethod(strlit4612, "++", 1, partcv, params);
// compiled op node returning opresult4613 (depth = 6)
  int op_slot_left_4607 = gc_frame_newslot(opresult4613);
  params[0] = strlit4608;
  partcv[0] = 1;
  Object opresult4614 = callmethod(opresult4613, "++", 1, partcv, params);
// compiled op node returning opresult4614 (depth = 5)
  gc_frame_newslot(opresult4614);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_RequestError (depth = 5)
  params[0] = opresult4614;
  partcv[0] = 1;
  Object call4615 = callmethod(*var_RequestError, "raise",
    1, partcv, params);
  gc_frame_end(callframe4606);
// compiled call node returning call4615 (depth = 4)
  int op_slot_left_4589 = gc_frame_newslot(call4615);
  params[0] = opresult4604;
  partcv[0] = 1;
  Object opresult4616 = callmethod(call4615, "++", 1, partcv, params);
// compiled op node returning opresult4616 (depth = 3)
    gc_frame_newslot(opresult4616);
    if4583 = opresult4616;
  } else {
  }
stackframe = iftmpstackframe4583;
// compiled if node returning if4583 (depth = 2)
  sourceObject = obj4184;
// Begin line 1737
  setline(1737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_upper (depth = 3)
  int frame4617 = gc_frame_new();
  gc_frame_newslot(*var_upper);
// Begin line 1738
  setline(1738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4618 = alloc_Block(NULL, NULL, "collectionsPrelude", 1738);
  gc_frame_newslot(block4618);
// method _apply
  block_savedest(block4618);
  Object closure4619 = createclosure(1, "_apply");
  setclosureframe(closure4619, stackframe);
  addtoclosure(closure4619, selfslot);
  struct UserObject *uo4619 = (struct UserObject*)block4618;
  uo4619->data[0] = (Object)closure4619;
  Method *meth_meth_collectionsPrelude__apply4619 = addmethod2pos(block4618, "_apply", &meth_collectionsPrelude__apply4619, 0);
  int argcv_meth_collectionsPrelude__apply4619[] = {1};
  meth_meth_collectionsPrelude__apply4619->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4619);
meth_meth_collectionsPrelude__apply4619->type->types[0] = type_Number;
meth_meth_collectionsPrelude__apply4619->type->names[0] = "__24";
  meth_meth_collectionsPrelude__apply4619->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4619->definitionLine = 1733;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4621 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe4622 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4623 == NULL) {
    strlit4623 = alloc_String("__24");
    gc_root(strlit4623);
  }
// compiled string node returning strlit4623 (depth = 6)
  gc_frame_newslot(strlit4623);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4624 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4625 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4624);
// compiled call node returning call4625 (depth = 7)
// compiled member node returning call4625 (depth = 6)
  params[0] = strlit4623;
  partcv[0] = 1;
  Object call4626 = callmethod(call4625, "new",
    1, partcv, params);
  gc_frame_end(callframe4622);
// compiled call node returning call4626 (depth = 5)
  gc_frame_newslot(call4626);
// Begin line 1738
  setline(1738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_Number (depth = 5)
  gc_frame_newslot(*var_Number);
// call case 6: other member request
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4627 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4628 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4627);
// compiled call node returning call4628 (depth = 6)
// compiled member node returning call4628 (depth = 5)
  params[0] = call4626;
  params[1] = *var_Number;
  partcv[0] = 2;
  Object call4629 = callmethod(call4628, "new",
    1, partcv, params);
  gc_frame_end(callframe4621);
// compiled call node returning call4629 (depth = 4)
((struct UserObject *)block4618)->data[1] = call4629;
// compiled block node returning block4618 (depth = 3)
  gc_frame_newslot(block4618);
// Begin line 1739
  setline(1739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4630 = alloc_Block(NULL, NULL, "collectionsPrelude", 1739);
  gc_frame_newslot(block4630);
// method _apply
  block_savedest(block4630);
  Object closure4631 = createclosure(4, "_apply");
  setclosureframe(closure4631, stackframe);
  addtoclosure(closure4631, var_upper);
  addtoclosure(closure4631, var_lower);
  addtoclosure(closure4631, var_RequestError);
  addtoclosure(closure4631, selfslot);
  struct UserObject *uo4631 = (struct UserObject*)block4630;
  uo4631->data[0] = (Object)closure4631;
  Method *meth_meth_collectionsPrelude__apply4631 = addmethod2pos(block4630, "_apply", &meth_collectionsPrelude__apply4631, 0);
  int argcv_meth_collectionsPrelude__apply4631[] = {1};
  meth_meth_collectionsPrelude__apply4631->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4631);
  meth_meth_collectionsPrelude__apply4631->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4631->definitionLine = 0;
// compiled block node returning block4630 (depth = 3)
  gc_frame_newslot(block4630);
  params[0] = block4618;
  params[1] = block4630;
  Object matchres4617 = matchCase(*var_upper, params, 2,NULL);
  gc_frame_end(frame4617);
// compiled matchcase node returning matchres4617 (depth = 2)
  sourceObject = obj4184;
// Begin line 1741
  setline(1741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4661 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_upper (depth = 4)
  partcv[0] = 0;
  Object call4662 = callmethod(*var_upper, "truncated",
    1, partcv, params);
  gc_frame_end(callframe4661);
// compiled call node returning call4662 (depth = 3)
// compiled member node returning call4662 (depth = 2)
  adddatum2(obj4184, call4662, 2);
  sourceObject = obj4184;
// Begin line 1742
  setline(1742);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_upper (depth = 4)
  int op_slot_right_4664 = gc_frame_newslot(*var_upper);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4666 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4667 = callmethodflags(self, "stop", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4666);
// compiled call node returning call4667 (depth = 5)
// compiled member node returning call4667 (depth = 4)
  int op_slot_left_4664 = gc_frame_newslot(call4667);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult4668 = callmethod(call4667, "!=", 1, partcv, params);
// compiled op node returning opresult4668 (depth = 3)
  Object if4663 = done;
struct StackFrameObject *iftmpstackframe4663 = stackframe;
  if (istrue(opresult4668)) {
stackframe = alloc_StackFrame(0, iftmpstackframe4663);
gc_frame_newslot((Object)stackframe);
// Begin line 1743
  setline(1743);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// Begin line 1744
  setline(1744);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit4670 == NULL) {
    strlit4670 = alloc_String(" in range.from()to() is not an integer");
    gc_root(strlit4670);
  }
// compiled string node returning strlit4670 (depth = 4)
  int op_slot_right_4669 = gc_frame_newslot(strlit4670);
// Begin line 1743
  setline(1743);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4672 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4674 == NULL) {
    strlit4674 = alloc_String("");
    gc_root(strlit4674);
  }
// compiled string node returning strlit4674 (depth = 6)
  int op_slot_right_4673 = gc_frame_newslot(strlit4674);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_upper (depth = 7)
  int op_slot_right_4676 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 7)
  if (strlit4678 == NULL) {
    strlit4678 = alloc_String("upper bound ");
    gc_root(strlit4678);
  }
// compiled string node returning strlit4678 (depth = 7)
  int op_slot_left_4676 = gc_frame_newslot(strlit4678);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult4679 = callmethod(strlit4678, "++", 1, partcv, params);
// compiled op node returning opresult4679 (depth = 6)
  int op_slot_left_4673 = gc_frame_newslot(opresult4679);
  params[0] = strlit4674;
  partcv[0] = 1;
  Object opresult4680 = callmethod(opresult4679, "++", 1, partcv, params);
// compiled op node returning opresult4680 (depth = 5)
  gc_frame_newslot(opresult4680);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_RequestError (depth = 5)
  params[0] = opresult4680;
  partcv[0] = 1;
  Object call4681 = callmethod(*var_RequestError, "raise",
    1, partcv, params);
  gc_frame_end(callframe4672);
// compiled call node returning call4681 (depth = 4)
  int op_slot_left_4669 = gc_frame_newslot(call4681);
  params[0] = strlit4670;
  partcv[0] = 1;
  Object opresult4682 = callmethod(call4681, "++", 1, partcv, params);
// compiled op node returning opresult4682 (depth = 3)
    gc_frame_newslot(opresult4682);
    if4663 = opresult4682;
  } else {
  }
stackframe = iftmpstackframe4663;
// compiled if node returning if4663 (depth = 2)
  sourceObject = obj4184;
// Begin line 1748
  setline(1748);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4685 = alloc_Float64(0);
// compiled num node returning num4685 (depth = 4)
  int op_slot_right_4684 = gc_frame_newslot(num4685);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4688 = alloc_Float64(1);
// compiled num node returning num4688 (depth = 5)
  int op_slot_right_4687 = gc_frame_newslot(num4688);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lower (depth = 6)
  int op_slot_right_4690 = gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_upper (depth = 6)
  int op_slot_left_4690 = gc_frame_newslot(*var_upper);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object diff4692 = callmethod(*var_upper, "-", 1, partcv, params);
// compiled op node returning diff4692 (depth = 5)
  int op_slot_left_4687 = gc_frame_newslot(diff4692);
  params[0] = num4688;
  partcv[0] = 1;
  Object sum4693 = callmethod(diff4692, "+", 1, partcv, params);
// compiled op node returning sum4693 (depth = 4)
  int op_slot_left_4684 = gc_frame_newslot(sum4693);
  params[0] = num4685;
  partcv[0] = 1;
  Object opresult4694 = callmethod(sum4693, "<", 1, partcv, params);
// compiled op node returning opresult4694 (depth = 3)
  Object if4683 = done;
struct StackFrameObject *iftmpstackframe4683 = stackframe;
  if (istrue(opresult4694)) {
stackframe = alloc_StackFrame(0, iftmpstackframe4683);
gc_frame_newslot((Object)stackframe);
// starting to compile num node (depth = 3)
  Object num4695 = alloc_Float64(0);
// compiled num node returning num4695 (depth = 3)
    gc_frame_newslot(num4695);
    if4683 = num4695;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe4683);
  gc_frame_newslot((Object)stackframe);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4697 = alloc_Float64(1);
// compiled num node returning num4697 (depth = 4)
  int op_slot_right_4696 = gc_frame_newslot(num4697);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lower (depth = 5)
  int op_slot_right_4699 = gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_upper (depth = 5)
  int op_slot_left_4699 = gc_frame_newslot(*var_upper);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object diff4701 = callmethod(*var_upper, "-", 1, partcv, params);
// compiled op node returning diff4701 (depth = 4)
  int op_slot_left_4696 = gc_frame_newslot(diff4701);
  params[0] = num4697;
  partcv[0] = 1;
  Object sum4702 = callmethod(diff4701, "+", 1, partcv, params);
// compiled op node returning sum4702 (depth = 3)
    gc_frame_newslot(sum4702);
    if4683 = sum4702;
  }
stackframe = iftmpstackframe4683;
// compiled if node returning if4683 (depth = 2)
  adddatum2(obj4184, if4683, 3);
  sourceObject = obj4184;
// Begin line 1750
  setline(1750);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 2)
  Object block4703 = alloc_Block(NULL, NULL, "collectionsPrelude", 1750);
  gc_frame_newslot(block4703);
// method _apply
  block_savedest(block4703);
  Object closure4704 = createclosure(1, "_apply");
  setclosureframe(closure4704, stackframe);
  addtoclosure(closure4704, selfslot);
  struct UserObject *uo4704 = (struct UserObject*)block4703;
  uo4704->data[0] = (Object)closure4704;
  Method *meth_meth_collectionsPrelude__apply4704 = addmethod2pos(block4703, "_apply", &meth_collectionsPrelude__apply4704, 0);
  int argcv_meth_collectionsPrelude__apply4704[] = {0};
  meth_meth_collectionsPrelude__apply4704->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4704);
  meth_meth_collectionsPrelude__apply4704->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4704->definitionLine = 1742;
// compiled block node returning block4703 (depth = 2)
  adddatum2(obj4184, block4703, 4);
  sourceObject = obj4184;
  sourceObject = obj4184;
  sourceObject = obj4184;
  sourceObject = obj4184;
  sourceObject = obj4184;
  sourceObject = obj4184;
  sourceObject = obj4184;
  sourceObject = obj4184;
  sourceObject = obj4184;
  sourceObject = obj4184;
  sourceObject = obj4184;
  sourceObject = obj4184;
  sourceObject = obj4184;
  sourceObject = obj4184;
  sourceObject = obj4184;
  objclass4184 = obj4184->class;
  objclass4184->definitionModule = modulename;
  objclass4184->definitionLine = 1726;
  (*(struct UserObject *)self).data[0] = lowerouter4184;
  self = oldself4184;
  selfslot = oldselfslot4184;
  stackframe = oldstackframe4184;
  gc_frame_end(frame);
  return obj4184;
}
Object meth_collectionsPrelude_from_40__41_to4183_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "from()to()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0] + argcv[1]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method from()to()object");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method from()to()object");
  Object params[2];
  int partcv[2];
  Object *var_Exhausted = getfromclosure(closure, 0);
  Object *var_BoundsError = getfromclosure(closure, 1);
  Object *var__prelude = getfromclosure(closure, 2);
  Object *var_Collection = getfromclosure(closure, 3);
  Object *var_indexable = getfromclosure(closure, 4);
  Object *var_Number = getfromclosure(closure, 5);
  Object *var_RequestError = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for from()to (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_lower = &(stackframe->slots[0]);
  *var_lower = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for from");
  Object *var_upper = &(stackframe->slots[1]);
  *var_upper = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for to");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4184 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4184 = alloc_userobj2(25,26, objclass4184);
  gc_frame_newslot(obj4184);
if (objclass4184 == NULL) {
  glfree(obj4184->class->name);
  obj4184->class->name = "obj4181.from()to";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4184, self, 0);
  addmethodreal(obj4184,"outer", &reader_collectionsPrelude_outer_4185);
  Object oldself4184 = self;
  struct StackFrameObject *oldstackframe4184 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4184);
  gc_frame_newslot((Object)stackframe);
  self = obj4184;
  Object *oldselfslot4184 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4184 = (*(struct UserObject *)self).data[0], lowerouter4184 = thisouter4184;
  if (inheritingObject4184) {
    struct UserObject *inho4184 = (struct UserObject *)inheritingObject4184;
    while (inho4184->super != GraceDefaultObject) inho4184 = (struct UserObject *)inho4184->super;
    inho4184->super = obj4184;
    self = inheritingObject4184;
    *selfslot = self;
    lowerouter4184 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4184;
  }
if (objclass4184 == NULL) {
  Method *reader4186 = addmethodrealflags(obj4184, "start",&reader_collectionsPrelude_start_4186, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader4186->definitionModule = modulename;
  reader4186->definitionLine = 1732;
}
adddatum2(obj4184, alloc_Undefined(), 1);
if (objclass4184 == NULL) {
  Method *reader4187 = addmethodrealflags(obj4184, "stop",&reader_collectionsPrelude_stop_4187, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader4187->definitionModule = modulename;
  reader4187->definitionLine = 1741;
}
adddatum2(obj4184, alloc_Undefined(), 2);
if (objclass4184 == NULL) {
  Method *reader4188 = addmethodrealflags(obj4184, "size",&reader_collectionsPrelude_size_4188, MFLAG_DEF);
  reader4188->definitionModule = modulename;
  reader4188->definitionLine = 1747;
}
adddatum2(obj4184, alloc_Undefined(), 3);
if (objclass4184 == NULL) {
  Method *reader4189 = addmethodrealflags(obj4184, "hash",&reader_collectionsPrelude_hash_4189, MFLAG_DEF);
  reader4189->definitionModule = modulename;
  reader4189->definitionLine = 1750;
}
adddatum2(obj4184, alloc_Undefined(), 4);
// method iterator
  block_savedest(obj4184);
  Object closure4190 = createclosure(3, "iterator");
  setclosureframe(closure4190, stackframe);
  addtoclosure(closure4190, var_Exhausted);
  addtoclosure(closure4190, var_lower);
  addtoclosure(closure4190, var_upper);
  struct UserObject *uo4190 = (struct UserObject*)obj4184;
  uo4190->data[5] = (Object)closure4190;
  Method *meth_meth_collectionsPrelude_iterator4190 = addmethod2pos(obj4184, "iterator", &meth_collectionsPrelude_iterator4190, 5);
  int argcv_meth_collectionsPrelude_iterator4190[] = {0};
  meth_meth_collectionsPrelude_iterator4190->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator4190);
  meth_meth_collectionsPrelude_iterator4190->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator4190->definitionLine = 1752;
  block_savedest(obj4184);
  Object closure4272 = createclosure(3, "iterator()object");
  setclosureframe(closure4272, stackframe);
  addtoclosure(closure4272, var_Exhausted);
  addtoclosure(closure4272, var_lower);
  addtoclosure(closure4272, var_upper);
  Method *meth_meth_collectionsPrelude_iterator4190_object = addmethod2pos(obj4184, "iterator()object", &meth_collectionsPrelude_iterator4190_object, 5);
  meth_meth_collectionsPrelude_iterator4190_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator4190_object->definitionLine = 1752;
// method at
  block_savedest(obj4184);
  Object closure4273 = createclosure(1, "at");
  setclosureframe(closure4273, stackframe);
  addtoclosure(closure4273, var_BoundsError);
  struct UserObject *uo4273 = (struct UserObject*)obj4184;
  uo4273->data[6] = (Object)closure4273;
  Method *meth_meth_collectionsPrelude_at4273 = addmethod2pos(obj4184, "at", &meth_collectionsPrelude_at4273, 6);
  int argcv_meth_collectionsPrelude_at4273[] = {1};
  meth_meth_collectionsPrelude_at4273->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at4273);
meth_meth_collectionsPrelude_at4273->type->types[0] = type_Number;
meth_meth_collectionsPrelude_at4273->type->names[0] = "ix";
  meth_meth_collectionsPrelude_at4273->definitionModule = modulename;
  meth_meth_collectionsPrelude_at4273->definitionLine = 1766;
// method contains
  block_savedest(obj4184);
  Object closure4327 = createclosure(1, "contains");
  setclosureframe(closure4327, stackframe);
  addtoclosure(closure4327, var__prelude);
  struct UserObject *uo4327 = (struct UserObject*)obj4184;
  uo4327->data[7] = (Object)closure4327;
  Method *meth_meth_collectionsPrelude_contains4327 = addmethod2pos(obj4184, "contains", &meth_collectionsPrelude_contains4327, 7);
  int argcv_meth_collectionsPrelude_contains4327[] = {1};
  meth_meth_collectionsPrelude_contains4327->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains4327);
  meth_meth_collectionsPrelude_contains4327->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains4327->definitionLine = 1775;
// method do
  struct UserObject *uo4369 = (struct UserObject*)obj4184;
  uo4369->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do4369 = addmethod2pos(obj4184, "do", &meth_collectionsPrelude_do4369, 8);
  int argcv_meth_collectionsPrelude_do4369[] = {1};
  meth_meth_collectionsPrelude_do4369->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do4369);
  meth_meth_collectionsPrelude_do4369->definitionModule = modulename;
  meth_meth_collectionsPrelude_do4369->definitionLine = 1784;
// method keysAndValuesDo
  struct UserObject *uo4392 = (struct UserObject*)obj4184;
  uo4392->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo4392 = addmethod2pos(obj4184, "keysAndValuesDo", &meth_collectionsPrelude_keysAndValuesDo4392, 9);
  int argcv_meth_collectionsPrelude_keysAndValuesDo4392[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo4392->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo4392);
  meth_meth_collectionsPrelude_keysAndValuesDo4392->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo4392->definitionLine = 1791;
// method reversed
  block_savedest(obj4184);
  Object closure4421 = createclosure(2, "reversed");
  setclosureframe(closure4421, stackframe);
  addtoclosure(closure4421, var_upper);
  addtoclosure(closure4421, var_lower);
  struct UserObject *uo4421 = (struct UserObject*)obj4184;
  uo4421->data[10] = (Object)closure4421;
  Method *meth_meth_collectionsPrelude_reversed4421 = addmethod2pos(obj4184, "reversed", &meth_collectionsPrelude_reversed4421, 10);
  int argcv_meth_collectionsPrelude_reversed4421[] = {0};
  meth_meth_collectionsPrelude_reversed4421->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reversed4421);
  meth_meth_collectionsPrelude_reversed4421->definitionModule = modulename;
  meth_meth_collectionsPrelude_reversed4421->definitionLine = 1800;
// method ++
  struct UserObject *uo4426 = (struct UserObject*)obj4184;
  uo4426->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43_4426 = addmethod2pos(obj4184, "++", &meth_collectionsPrelude__43__43_4426, 11);
  int argcv_meth_collectionsPrelude__43__43_4426[] = {1};
  meth_meth_collectionsPrelude__43__43_4426->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43_4426);
  meth_meth_collectionsPrelude__43__43_4426->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43_4426->definitionLine = 1803;
// method ==
  block_savedest(obj4184);
  Object closure4435 = createclosure(1, "==");
  setclosureframe(closure4435, stackframe);
  addtoclosure(closure4435, var_Collection);
  struct UserObject *uo4435 = (struct UserObject*)obj4184;
  uo4435->data[12] = (Object)closure4435;
  Method *meth_meth_collectionsPrelude__61__61_4435 = addmethod2pos(obj4184, "==", &meth_collectionsPrelude__61__61_4435, 12);
  int argcv_meth_collectionsPrelude__61__61_4435[] = {1};
  meth_meth_collectionsPrelude__61__61_4435->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61_4435);
  meth_meth_collectionsPrelude__61__61_4435->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61_4435->definitionLine = 1806;
// method sorted
  struct UserObject *uo4488 = (struct UserObject*)obj4184;
  uo4488->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted4488 = addmethod2pos(obj4184, "sorted", &meth_collectionsPrelude_sorted4488, 13);
  int argcv_meth_collectionsPrelude_sorted4488[] = {0};
  meth_meth_collectionsPrelude_sorted4488->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted4488);
  meth_meth_collectionsPrelude_sorted4488->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted4488->definitionLine = 1823;
// method sortedBy
  struct UserObject *uo4489 = (struct UserObject*)obj4184;
  uo4489->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy4489 = addmethod2pos(obj4184, "sortedBy", &meth_collectionsPrelude_sortedBy4489, 14);
  int argcv_meth_collectionsPrelude_sortedBy4489[] = {1};
  meth_meth_collectionsPrelude_sortedBy4489->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy4489);
  meth_meth_collectionsPrelude_sortedBy4489->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy4489->definitionLine = 1825;
// method keys
  struct UserObject *uo4494 = (struct UserObject*)obj4184;
  uo4494->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keys4494 = addmethod2pos(obj4184, "keys", &meth_collectionsPrelude_keys4494, 15);
  int argcv_meth_collectionsPrelude_keys4494[] = {0};
  meth_meth_collectionsPrelude_keys4494->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys4494);
  meth_meth_collectionsPrelude_keys4494->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys4494->definitionLine = 1827;
// method values
  struct UserObject *uo4501 = (struct UserObject*)obj4184;
  uo4501->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values4501 = addmethod2pos(obj4184, "values", &meth_collectionsPrelude_values4501, 16);
  int argcv_meth_collectionsPrelude_values4501[] = {0};
  meth_meth_collectionsPrelude_values4501->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values4501);
  meth_meth_collectionsPrelude_values4501->definitionModule = modulename;
  meth_meth_collectionsPrelude_values4501->definitionLine = 1829;
// method asString
  block_savedest(obj4184);
  Object closure4502 = createclosure(2, "asString");
  setclosureframe(closure4502, stackframe);
  addtoclosure(closure4502, var_upper);
  addtoclosure(closure4502, var_lower);
  struct UserObject *uo4502 = (struct UserObject*)obj4184;
  uo4502->data[17] = (Object)closure4502;
  Method *meth_meth_collectionsPrelude_asString4502 = addmethod2pos(obj4184, "asString", &meth_collectionsPrelude_asString4502, 17);
  int argcv_meth_collectionsPrelude_asString4502[] = {0};
  meth_meth_collectionsPrelude_asString4502->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString4502);
  meth_meth_collectionsPrelude_asString4502->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString4502->definitionLine = 1831;
// method asList
  struct UserObject *uo4518 = (struct UserObject*)obj4184;
  uo4518->data[18] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asList4518 = addmethod2pos(obj4184, "asList", &meth_collectionsPrelude_asList4518, 18);
  int argcv_meth_collectionsPrelude_asList4518[] = {0};
  meth_meth_collectionsPrelude_asList4518->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asList4518);
  meth_meth_collectionsPrelude_asList4518->definitionModule = modulename;
  meth_meth_collectionsPrelude_asList4518->definitionLine = 1835;
// method asSequence
  struct UserObject *uo4534 = (struct UserObject*)obj4184;
  uo4534->data[19] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asSequence4534 = addmethod2pos(obj4184, "asSequence", &meth_collectionsPrelude_asSequence4534, 19);
  int argcv_meth_collectionsPrelude_asSequence4534[] = {0};
  meth_meth_collectionsPrelude_asSequence4534->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asSequence4534);
  meth_meth_collectionsPrelude_asSequence4534->definitionModule = modulename;
  meth_meth_collectionsPrelude_asSequence4534->definitionLine = 1841;
  sourceObject = obj4184;
// Begin line 1727
  setline(1727);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4535 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indexable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call4536 = callmethod(*var_indexable, "trait()object",
    2, partcv, params);
  gc_frame_end(callframe4535);
// compiled call node returning call4536 (depth = 2)
  struct UserObject *obj4184_uo = (struct UserObject *)obj4184;
  obj4184_uo->super = call4536;
  sourceObject = obj4184;
// Begin line 1728
  setline(1728);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lower (depth = 3)
  int frame4537 = gc_frame_new();
  gc_frame_newslot(*var_lower);
// Begin line 1729
  setline(1729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4538 = alloc_Block(NULL, NULL, "collectionsPrelude", 1729);
  gc_frame_newslot(block4538);
// method _apply
  block_savedest(block4538);
  Object closure4539 = createclosure(1, "_apply");
  setclosureframe(closure4539, stackframe);
  addtoclosure(closure4539, selfslot);
  struct UserObject *uo4539 = (struct UserObject*)block4538;
  uo4539->data[0] = (Object)closure4539;
  Method *meth_meth_collectionsPrelude__apply4539 = addmethod2pos(block4538, "_apply", &meth_collectionsPrelude__apply4539, 0);
  int argcv_meth_collectionsPrelude__apply4539[] = {1};
  meth_meth_collectionsPrelude__apply4539->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4539);
meth_meth_collectionsPrelude__apply4539->type->types[0] = type_Number;
meth_meth_collectionsPrelude__apply4539->type->names[0] = "__22";
  meth_meth_collectionsPrelude__apply4539->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4539->definitionLine = 1836;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4541 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe4542 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4543 == NULL) {
    strlit4543 = alloc_String("__22");
    gc_root(strlit4543);
  }
// compiled string node returning strlit4543 (depth = 6)
  gc_frame_newslot(strlit4543);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4544 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4545 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4544);
// compiled call node returning call4545 (depth = 7)
// compiled member node returning call4545 (depth = 6)
  params[0] = strlit4543;
  partcv[0] = 1;
  Object call4546 = callmethod(call4545, "new",
    1, partcv, params);
  gc_frame_end(callframe4542);
// compiled call node returning call4546 (depth = 5)
  gc_frame_newslot(call4546);
// Begin line 1729
  setline(1729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_Number (depth = 5)
  gc_frame_newslot(*var_Number);
// call case 6: other member request
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4547 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4548 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4547);
// compiled call node returning call4548 (depth = 6)
// compiled member node returning call4548 (depth = 5)
  params[0] = call4546;
  params[1] = *var_Number;
  partcv[0] = 2;
  Object call4549 = callmethod(call4548, "new",
    1, partcv, params);
  gc_frame_end(callframe4541);
// compiled call node returning call4549 (depth = 4)
((struct UserObject *)block4538)->data[1] = call4549;
// compiled block node returning block4538 (depth = 3)
  gc_frame_newslot(block4538);
// Begin line 1730
  setline(1730);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4550 = alloc_Block(NULL, NULL, "collectionsPrelude", 1730);
  gc_frame_newslot(block4550);
// method _apply
  block_savedest(block4550);
  Object closure4551 = createclosure(4, "_apply");
  setclosureframe(closure4551, stackframe);
  addtoclosure(closure4551, var_upper);
  addtoclosure(closure4551, var_lower);
  addtoclosure(closure4551, var_RequestError);
  addtoclosure(closure4551, selfslot);
  struct UserObject *uo4551 = (struct UserObject*)block4550;
  uo4551->data[0] = (Object)closure4551;
  Method *meth_meth_collectionsPrelude__apply4551 = addmethod2pos(block4550, "_apply", &meth_collectionsPrelude__apply4551, 0);
  int argcv_meth_collectionsPrelude__apply4551[] = {1};
  meth_meth_collectionsPrelude__apply4551->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4551);
  meth_meth_collectionsPrelude__apply4551->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4551->definitionLine = 0;
// compiled block node returning block4550 (depth = 3)
  gc_frame_newslot(block4550);
  params[0] = block4538;
  params[1] = block4550;
  Object matchres4537 = matchCase(*var_lower, params, 2,NULL);
  gc_frame_end(frame4537);
// compiled matchcase node returning matchres4537 (depth = 2)
  sourceObject = obj4184;
// Begin line 1732
  setline(1732);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4581 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lower (depth = 4)
  partcv[0] = 0;
  Object call4582 = callmethod(*var_lower, "truncated",
    1, partcv, params);
  gc_frame_end(callframe4581);
// compiled call node returning call4582 (depth = 3)
// compiled member node returning call4582 (depth = 2)
  adddatum2(obj4184, call4582, 1);
  sourceObject = obj4184;
// Begin line 1733
  setline(1733);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lower (depth = 4)
  int op_slot_right_4584 = gc_frame_newslot(*var_lower);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4586 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4587 = callmethodflags(self, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4586);
// compiled call node returning call4587 (depth = 5)
// compiled member node returning call4587 (depth = 4)
  int op_slot_left_4584 = gc_frame_newslot(call4587);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult4588 = callmethod(call4587, "!=", 1, partcv, params);
// compiled op node returning opresult4588 (depth = 3)
  Object if4583 = done;
struct StackFrameObject *iftmpstackframe4583 = stackframe;
  if (istrue(opresult4588)) {
stackframe = alloc_StackFrame(0, iftmpstackframe4583);
gc_frame_newslot((Object)stackframe);
// Begin line 1734
  setline(1734);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// Begin line 1735
  setline(1735);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4591 == NULL) {
    strlit4591 = alloc_String(") is not an integer");
    gc_root(strlit4591);
  }
// compiled string node returning strlit4591 (depth = 5)
  int op_slot_right_4590 = gc_frame_newslot(strlit4591);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_upper (depth = 6)
  int op_slot_right_4593 = gc_frame_newslot(*var_upper);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4596 == NULL) {
    strlit4596 = alloc_String(")to(");
    gc_root(strlit4596);
  }
// compiled string node returning strlit4596 (depth = 7)
  int op_slot_right_4595 = gc_frame_newslot(strlit4596);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lower (depth = 8)
  int op_slot_right_4598 = gc_frame_newslot(*var_lower);
// starting to compile string node (depth = 8)
  if (strlit4600 == NULL) {
    strlit4600 = alloc_String(" in range.from(");
    gc_root(strlit4600);
  }
// compiled string node returning strlit4600 (depth = 8)
  int op_slot_left_4598 = gc_frame_newslot(strlit4600);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult4601 = callmethod(strlit4600, "++", 1, partcv, params);
// compiled op node returning opresult4601 (depth = 7)
  int op_slot_left_4595 = gc_frame_newslot(opresult4601);
  params[0] = strlit4596;
  partcv[0] = 1;
  Object opresult4602 = callmethod(opresult4601, "++", 1, partcv, params);
// compiled op node returning opresult4602 (depth = 6)
  int op_slot_left_4593 = gc_frame_newslot(opresult4602);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult4603 = callmethod(opresult4602, "++", 1, partcv, params);
// compiled op node returning opresult4603 (depth = 5)
  int op_slot_left_4590 = gc_frame_newslot(opresult4603);
  params[0] = strlit4591;
  partcv[0] = 1;
  Object opresult4604 = callmethod(opresult4603, "++", 1, partcv, params);
// compiled op node returning opresult4604 (depth = 4)
  int op_slot_right_4589 = gc_frame_newslot(opresult4604);
// Begin line 1734
  setline(1734);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4606 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4608 == NULL) {
    strlit4608 = alloc_String("");
    gc_root(strlit4608);
  }
// compiled string node returning strlit4608 (depth = 6)
  int op_slot_right_4607 = gc_frame_newslot(strlit4608);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lower (depth = 7)
  int op_slot_right_4610 = gc_frame_newslot(*var_lower);
// starting to compile string node (depth = 7)
  if (strlit4612 == NULL) {
    strlit4612 = alloc_String("lower bound ");
    gc_root(strlit4612);
  }
// compiled string node returning strlit4612 (depth = 7)
  int op_slot_left_4610 = gc_frame_newslot(strlit4612);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult4613 = callmethod(strlit4612, "++", 1, partcv, params);
// compiled op node returning opresult4613 (depth = 6)
  int op_slot_left_4607 = gc_frame_newslot(opresult4613);
  params[0] = strlit4608;
  partcv[0] = 1;
  Object opresult4614 = callmethod(opresult4613, "++", 1, partcv, params);
// compiled op node returning opresult4614 (depth = 5)
  gc_frame_newslot(opresult4614);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_RequestError (depth = 5)
  params[0] = opresult4614;
  partcv[0] = 1;
  Object call4615 = callmethod(*var_RequestError, "raise",
    1, partcv, params);
  gc_frame_end(callframe4606);
// compiled call node returning call4615 (depth = 4)
  int op_slot_left_4589 = gc_frame_newslot(call4615);
  params[0] = opresult4604;
  partcv[0] = 1;
  Object opresult4616 = callmethod(call4615, "++", 1, partcv, params);
// compiled op node returning opresult4616 (depth = 3)
    gc_frame_newslot(opresult4616);
    if4583 = opresult4616;
  } else {
  }
stackframe = iftmpstackframe4583;
// compiled if node returning if4583 (depth = 2)
  sourceObject = obj4184;
// Begin line 1737
  setline(1737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_upper (depth = 3)
  int frame4617 = gc_frame_new();
  gc_frame_newslot(*var_upper);
// Begin line 1738
  setline(1738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4618 = alloc_Block(NULL, NULL, "collectionsPrelude", 1738);
  gc_frame_newslot(block4618);
// method _apply
  block_savedest(block4618);
  Object closure4619 = createclosure(1, "_apply");
  setclosureframe(closure4619, stackframe);
  addtoclosure(closure4619, selfslot);
  struct UserObject *uo4619 = (struct UserObject*)block4618;
  uo4619->data[0] = (Object)closure4619;
  Method *meth_meth_collectionsPrelude__apply4619 = addmethod2pos(block4618, "_apply", &meth_collectionsPrelude__apply4619, 0);
  int argcv_meth_collectionsPrelude__apply4619[] = {1};
  meth_meth_collectionsPrelude__apply4619->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4619);
meth_meth_collectionsPrelude__apply4619->type->types[0] = type_Number;
meth_meth_collectionsPrelude__apply4619->type->names[0] = "__24";
  meth_meth_collectionsPrelude__apply4619->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4619->definitionLine = 1733;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4621 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe4622 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4623 == NULL) {
    strlit4623 = alloc_String("__24");
    gc_root(strlit4623);
  }
// compiled string node returning strlit4623 (depth = 6)
  gc_frame_newslot(strlit4623);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4624 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4625 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4624);
// compiled call node returning call4625 (depth = 7)
// compiled member node returning call4625 (depth = 6)
  params[0] = strlit4623;
  partcv[0] = 1;
  Object call4626 = callmethod(call4625, "new",
    1, partcv, params);
  gc_frame_end(callframe4622);
// compiled call node returning call4626 (depth = 5)
  gc_frame_newslot(call4626);
// Begin line 1738
  setline(1738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_Number (depth = 5)
  gc_frame_newslot(*var_Number);
// call case 6: other member request
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4627 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4628 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4627);
// compiled call node returning call4628 (depth = 6)
// compiled member node returning call4628 (depth = 5)
  params[0] = call4626;
  params[1] = *var_Number;
  partcv[0] = 2;
  Object call4629 = callmethod(call4628, "new",
    1, partcv, params);
  gc_frame_end(callframe4621);
// compiled call node returning call4629 (depth = 4)
((struct UserObject *)block4618)->data[1] = call4629;
// compiled block node returning block4618 (depth = 3)
  gc_frame_newslot(block4618);
// Begin line 1739
  setline(1739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4630 = alloc_Block(NULL, NULL, "collectionsPrelude", 1739);
  gc_frame_newslot(block4630);
// method _apply
  block_savedest(block4630);
  Object closure4631 = createclosure(4, "_apply");
  setclosureframe(closure4631, stackframe);
  addtoclosure(closure4631, var_upper);
  addtoclosure(closure4631, var_lower);
  addtoclosure(closure4631, var_RequestError);
  addtoclosure(closure4631, selfslot);
  struct UserObject *uo4631 = (struct UserObject*)block4630;
  uo4631->data[0] = (Object)closure4631;
  Method *meth_meth_collectionsPrelude__apply4631 = addmethod2pos(block4630, "_apply", &meth_collectionsPrelude__apply4631, 0);
  int argcv_meth_collectionsPrelude__apply4631[] = {1};
  meth_meth_collectionsPrelude__apply4631->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4631);
  meth_meth_collectionsPrelude__apply4631->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4631->definitionLine = 0;
// compiled block node returning block4630 (depth = 3)
  gc_frame_newslot(block4630);
  params[0] = block4618;
  params[1] = block4630;
  Object matchres4617 = matchCase(*var_upper, params, 2,NULL);
  gc_frame_end(frame4617);
// compiled matchcase node returning matchres4617 (depth = 2)
  sourceObject = obj4184;
// Begin line 1741
  setline(1741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4661 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_upper (depth = 4)
  partcv[0] = 0;
  Object call4662 = callmethod(*var_upper, "truncated",
    1, partcv, params);
  gc_frame_end(callframe4661);
// compiled call node returning call4662 (depth = 3)
// compiled member node returning call4662 (depth = 2)
  adddatum2(obj4184, call4662, 2);
  sourceObject = obj4184;
// Begin line 1742
  setline(1742);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_upper (depth = 4)
  int op_slot_right_4664 = gc_frame_newslot(*var_upper);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4666 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4667 = callmethodflags(self, "stop", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4666);
// compiled call node returning call4667 (depth = 5)
// compiled member node returning call4667 (depth = 4)
  int op_slot_left_4664 = gc_frame_newslot(call4667);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult4668 = callmethod(call4667, "!=", 1, partcv, params);
// compiled op node returning opresult4668 (depth = 3)
  Object if4663 = done;
struct StackFrameObject *iftmpstackframe4663 = stackframe;
  if (istrue(opresult4668)) {
stackframe = alloc_StackFrame(0, iftmpstackframe4663);
gc_frame_newslot((Object)stackframe);
// Begin line 1743
  setline(1743);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// Begin line 1744
  setline(1744);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit4670 == NULL) {
    strlit4670 = alloc_String(" in range.from()to() is not an integer");
    gc_root(strlit4670);
  }
// compiled string node returning strlit4670 (depth = 4)
  int op_slot_right_4669 = gc_frame_newslot(strlit4670);
// Begin line 1743
  setline(1743);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4672 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4674 == NULL) {
    strlit4674 = alloc_String("");
    gc_root(strlit4674);
  }
// compiled string node returning strlit4674 (depth = 6)
  int op_slot_right_4673 = gc_frame_newslot(strlit4674);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_upper (depth = 7)
  int op_slot_right_4676 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 7)
  if (strlit4678 == NULL) {
    strlit4678 = alloc_String("upper bound ");
    gc_root(strlit4678);
  }
// compiled string node returning strlit4678 (depth = 7)
  int op_slot_left_4676 = gc_frame_newslot(strlit4678);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult4679 = callmethod(strlit4678, "++", 1, partcv, params);
// compiled op node returning opresult4679 (depth = 6)
  int op_slot_left_4673 = gc_frame_newslot(opresult4679);
  params[0] = strlit4674;
  partcv[0] = 1;
  Object opresult4680 = callmethod(opresult4679, "++", 1, partcv, params);
// compiled op node returning opresult4680 (depth = 5)
  gc_frame_newslot(opresult4680);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_RequestError (depth = 5)
  params[0] = opresult4680;
  partcv[0] = 1;
  Object call4681 = callmethod(*var_RequestError, "raise",
    1, partcv, params);
  gc_frame_end(callframe4672);
// compiled call node returning call4681 (depth = 4)
  int op_slot_left_4669 = gc_frame_newslot(call4681);
  params[0] = strlit4670;
  partcv[0] = 1;
  Object opresult4682 = callmethod(call4681, "++", 1, partcv, params);
// compiled op node returning opresult4682 (depth = 3)
    gc_frame_newslot(opresult4682);
    if4663 = opresult4682;
  } else {
  }
stackframe = iftmpstackframe4663;
// compiled if node returning if4663 (depth = 2)
  sourceObject = obj4184;
// Begin line 1748
  setline(1748);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4685 = alloc_Float64(0);
// compiled num node returning num4685 (depth = 4)
  int op_slot_right_4684 = gc_frame_newslot(num4685);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4688 = alloc_Float64(1);
// compiled num node returning num4688 (depth = 5)
  int op_slot_right_4687 = gc_frame_newslot(num4688);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lower (depth = 6)
  int op_slot_right_4690 = gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_upper (depth = 6)
  int op_slot_left_4690 = gc_frame_newslot(*var_upper);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object diff4692 = callmethod(*var_upper, "-", 1, partcv, params);
// compiled op node returning diff4692 (depth = 5)
  int op_slot_left_4687 = gc_frame_newslot(diff4692);
  params[0] = num4688;
  partcv[0] = 1;
  Object sum4693 = callmethod(diff4692, "+", 1, partcv, params);
// compiled op node returning sum4693 (depth = 4)
  int op_slot_left_4684 = gc_frame_newslot(sum4693);
  params[0] = num4685;
  partcv[0] = 1;
  Object opresult4694 = callmethod(sum4693, "<", 1, partcv, params);
// compiled op node returning opresult4694 (depth = 3)
  Object if4683 = done;
struct StackFrameObject *iftmpstackframe4683 = stackframe;
  if (istrue(opresult4694)) {
stackframe = alloc_StackFrame(0, iftmpstackframe4683);
gc_frame_newslot((Object)stackframe);
// starting to compile num node (depth = 3)
  Object num4695 = alloc_Float64(0);
// compiled num node returning num4695 (depth = 3)
    gc_frame_newslot(num4695);
    if4683 = num4695;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe4683);
  gc_frame_newslot((Object)stackframe);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4697 = alloc_Float64(1);
// compiled num node returning num4697 (depth = 4)
  int op_slot_right_4696 = gc_frame_newslot(num4697);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lower (depth = 5)
  int op_slot_right_4699 = gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_upper (depth = 5)
  int op_slot_left_4699 = gc_frame_newslot(*var_upper);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object diff4701 = callmethod(*var_upper, "-", 1, partcv, params);
// compiled op node returning diff4701 (depth = 4)
  int op_slot_left_4696 = gc_frame_newslot(diff4701);
  params[0] = num4697;
  partcv[0] = 1;
  Object sum4702 = callmethod(diff4701, "+", 1, partcv, params);
// compiled op node returning sum4702 (depth = 3)
    gc_frame_newslot(sum4702);
    if4683 = sum4702;
  }
stackframe = iftmpstackframe4683;
// compiled if node returning if4683 (depth = 2)
  adddatum2(obj4184, if4683, 3);
  sourceObject = obj4184;
// Begin line 1750
  setline(1750);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 2)
  Object block4703 = alloc_Block(NULL, NULL, "collectionsPrelude", 1750);
  gc_frame_newslot(block4703);
// method _apply
  block_savedest(block4703);
  Object closure4704 = createclosure(1, "_apply");
  setclosureframe(closure4704, stackframe);
  addtoclosure(closure4704, selfslot);
  struct UserObject *uo4704 = (struct UserObject*)block4703;
  uo4704->data[0] = (Object)closure4704;
  Method *meth_meth_collectionsPrelude__apply4704 = addmethod2pos(block4703, "_apply", &meth_collectionsPrelude__apply4704, 0);
  int argcv_meth_collectionsPrelude__apply4704[] = {0};
  meth_meth_collectionsPrelude__apply4704->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4704);
  meth_meth_collectionsPrelude__apply4704->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4704->definitionLine = 1742;
// compiled block node returning block4703 (depth = 2)
  adddatum2(obj4184, block4703, 4);
  sourceObject = obj4184;
  sourceObject = obj4184;
  sourceObject = obj4184;
  sourceObject = obj4184;
  sourceObject = obj4184;
  sourceObject = obj4184;
  sourceObject = obj4184;
  sourceObject = obj4184;
  sourceObject = obj4184;
  sourceObject = obj4184;
  sourceObject = obj4184;
  sourceObject = obj4184;
  sourceObject = obj4184;
  sourceObject = obj4184;
  sourceObject = obj4184;
  objclass4184 = obj4184->class;
  objclass4184->definitionModule = modulename;
  objclass4184->definitionLine = 1726;
  (*(struct UserObject *)self).data[0] = lowerouter4184;
  self = oldself4184;
  selfslot = oldselfslot4184;
  stackframe = oldstackframe4184;
  gc_frame_end(frame);
  return obj4184;
}
Object meth_collectionsPrelude_hasNext4736(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for hasNext (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for hasNext");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1872
  setline(1872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4738 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4739 = gc_frame_new();
// call case 3: self.outer request
  Object call4740 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4739);
// compiled call node returning call4740 (depth = 6)
// compiled member node returning call4740 (depth = 5)
  partcv[0] = 0;
  Object call4741 = callmethodflags(call4740, "stop", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4738);
// compiled call node returning call4741 (depth = 4)
// compiled member node returning call4741 (depth = 3)
  int op_slot_right_4737 = gc_frame_newslot(call4741);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4743 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4744 = callmethodflags(self, "val", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4743);
// compiled call node returning call4744 (depth = 4)
// compiled member node returning call4744 (depth = 3)
  int op_slot_left_4737 = gc_frame_newslot(call4744);
  params[0] = call4741;
  partcv[0] = 1;
  Object opresult4745 = callmethod(call4744, ">=", 1, partcv, params);
// compiled op node returning opresult4745 (depth = 2)
  gc_frame_end(frame);
  return opresult4745;
}
Object meth_collectionsPrelude_next4746(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Exhausted = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for next (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for next");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1874
  setline(1874);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4749 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4750 = gc_frame_new();
// call case 3: self.outer request
  Object call4751 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4750);
// compiled call node returning call4751 (depth = 7)
// compiled member node returning call4751 (depth = 6)
  partcv[0] = 0;
  Object call4752 = callmethodflags(call4751, "stop", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4749);
// compiled call node returning call4752 (depth = 5)
// compiled member node returning call4752 (depth = 4)
  int op_slot_right_4748 = gc_frame_newslot(call4752);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4754 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4755 = callmethodflags(self, "val", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4754);
// compiled call node returning call4755 (depth = 5)
// compiled member node returning call4755 (depth = 4)
  int op_slot_left_4748 = gc_frame_newslot(call4755);
  params[0] = call4752;
  partcv[0] = 1;
  Object opresult4756 = callmethod(call4755, "<", 1, partcv, params);
// compiled op node returning opresult4756 (depth = 3)
  Object if4747 = done;
  if (istrue(opresult4756)) {
// starting to compile call node (depth = 3)
  int callframe4757 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4759 == NULL) {
    strlit4759 = alloc_String("");
    gc_root(strlit4759);
  }
// compiled string node returning strlit4759 (depth = 5)
  int op_slot_right_4758 = gc_frame_newslot(strlit4759);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4762 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4763 = gc_frame_new();
// call case 3: self.outer request
  Object call4764 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4763);
// compiled call node returning call4764 (depth = 9)
// compiled member node returning call4764 (depth = 8)
  partcv[0] = 0;
  Object call4765 = callmethodflags(call4764, "asString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4762);
// compiled call node returning call4765 (depth = 7)
// compiled member node returning call4765 (depth = 6)
  int op_slot_right_4761 = gc_frame_newslot(call4765);
// starting to compile string node (depth = 6)
  if (strlit4767 == NULL) {
    strlit4767 = alloc_String("over ");
    gc_root(strlit4767);
  }
// compiled string node returning strlit4767 (depth = 6)
  int op_slot_left_4761 = gc_frame_newslot(strlit4767);
  params[0] = call4765;
  partcv[0] = 1;
  Object opresult4768 = callmethod(strlit4767, "++", 1, partcv, params);
// compiled op node returning opresult4768 (depth = 5)
  int op_slot_left_4758 = gc_frame_newslot(opresult4768);
  params[0] = strlit4759;
  partcv[0] = 1;
  Object opresult4769 = callmethod(opresult4768, "++", 1, partcv, params);
// compiled op node returning opresult4769 (depth = 4)
  gc_frame_newslot(opresult4769);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_Exhausted (depth = 4)
  params[0] = opresult4769;
  partcv[0] = 1;
  Object call4770 = callmethod(*var_Exhausted, "raise",
    1, partcv, params);
  gc_frame_end(callframe4757);
// compiled call node returning call4770 (depth = 3)
    gc_frame_newslot(call4770);
    if4747 = call4770;
  } else {
  }
// compiled if node returning if4747 (depth = 2)
// Begin line 1875
  setline(1875);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 1874
  setline(1874);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4771 = gc_frame_new();
// Begin line 1875
  setline(1875);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4773 = alloc_Float64(1);
// compiled num node returning num4773 (depth = 5)
  int op_slot_right_4772 = gc_frame_newslot(num4773);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4775 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4776 = callmethodflags(self, "val", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4775);
// compiled call node returning call4776 (depth = 6)
// compiled member node returning call4776 (depth = 5)
  int op_slot_left_4772 = gc_frame_newslot(call4776);
  params[0] = num4773;
  partcv[0] = 1;
  Object diff4777 = callmethod(call4776, "-", 1, partcv, params);
// compiled op node returning diff4777 (depth = 4)
  gc_frame_newslot(diff4777);
// call case 4: self request
  params[0] = diff4777;
  partcv[0] = 1;
  Object call4778 = callmethodflags(self, "val:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4771);
// compiled call node returning call4778 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 1876
  setline(1876);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4780 = alloc_Float64(1);
// compiled num node returning num4780 (depth = 4)
  int op_slot_right_4779 = gc_frame_newslot(num4780);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4782 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4783 = callmethodflags(self, "val", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4782);
// compiled call node returning call4783 (depth = 5)
// compiled member node returning call4783 (depth = 4)
  int op_slot_left_4779 = gc_frame_newslot(call4783);
  params[0] = num4780;
  partcv[0] = 1;
  Object sum4784 = callmethod(call4783, "+", 1, partcv, params);
// compiled op node returning sum4784 (depth = 3)
  return sum4784;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_asString4785(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1878
  setline(1878);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit4787 == NULL) {
    strlit4787 = alloc_String("");
    gc_root(strlit4787);
  }
// compiled string node returning strlit4787 (depth = 3)
  int op_slot_right_4786 = gc_frame_newslot(strlit4787);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4790 = gc_frame_new();
// call case 1: super request
  partcv[0] = 0;
  Object call4791 = callmethod4(self, "asString", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe4790);
// compiled call node returning call4791 (depth = 5)
// compiled member node returning call4791 (depth = 4)
  int op_slot_right_4789 = gc_frame_newslot(call4791);
// starting to compile string node (depth = 4)
  if (strlit4793 == NULL) {
    strlit4793 = alloc_String("anIterator over ");
    gc_root(strlit4793);
  }
// compiled string node returning strlit4793 (depth = 4)
  int op_slot_left_4789 = gc_frame_newslot(strlit4793);
  params[0] = call4791;
  partcv[0] = 1;
  Object opresult4794 = callmethod(strlit4793, "++", 1, partcv, params);
// compiled op node returning opresult4794 (depth = 3)
  int op_slot_left_4786 = gc_frame_newslot(opresult4794);
  params[0] = strlit4787;
  partcv[0] = 1;
  Object opresult4795 = callmethod(opresult4794, "++", 1, partcv, params);
// compiled op node returning opresult4795 (depth = 2)
  gc_frame_end(frame);
  return opresult4795;
}
Object meth_collectionsPrelude_iterator4732(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Exhausted = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4733 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4733 = alloc_userobj2(5,5, objclass4733);
  gc_frame_newslot(obj4733);
if (objclass4733 == NULL) {
  glfree(obj4733->class->name);
  obj4733->class->name = "obj4727.iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4733, self, 0);
  addmethodreal(obj4733,"outer", &reader_collectionsPrelude_outer_4734);
  Object oldself4733 = self;
  struct StackFrameObject *oldstackframe4733 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4733);
  gc_frame_newslot((Object)stackframe);
  self = obj4733;
  Object *oldselfslot4733 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4733 = (*(struct UserObject *)self).data[0], lowerouter4733 = thisouter4733;
  if (inheritingObject4733) {
    struct UserObject *inho4733 = (struct UserObject *)inheritingObject4733;
    while (inho4733->super != GraceDefaultObject) inho4733 = (struct UserObject *)inho4733->super;
    inho4733->super = obj4733;
    self = inheritingObject4733;
    *selfslot = self;
    lowerouter4733 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4733;
  }
if (objclass4733 == NULL) {
  Method *reader4735 = addmethodrealflags(obj4733, "val",&reader_collectionsPrelude_val_4735, MFLAG_CONFIDENTIAL);
  Method *writer4735 = addmethodrealflags(obj4733, "val:=",&writer_collectionsPrelude_val_4735, MFLAG_CONFIDENTIAL);
  reader4735->definitionModule = modulename;
  writer4735->definitionModule = modulename;
  reader4735->definitionLine = 1871;
  writer4735->definitionLine = 1871;
}
obj4733->flags |= OFLAG_MUTABLE;
adddatum2(obj4733, alloc_Undefined(), 1);
// method hasNext
  struct UserObject *uo4736 = (struct UserObject*)obj4733;
  uo4736->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext4736 = addmethod2pos(obj4733, "hasNext", &meth_collectionsPrelude_hasNext4736, 2);
  int argcv_meth_collectionsPrelude_hasNext4736[] = {0};
  meth_meth_collectionsPrelude_hasNext4736->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext4736);
  meth_meth_collectionsPrelude_hasNext4736->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext4736->definitionLine = 1872;
// method next
  block_savedest(obj4733);
  Object closure4746 = createclosure(1, "next");
  setclosureframe(closure4746, stackframe);
  addtoclosure(closure4746, var_Exhausted);
  struct UserObject *uo4746 = (struct UserObject*)obj4733;
  uo4746->data[3] = (Object)closure4746;
  Method *meth_meth_collectionsPrelude_next4746 = addmethod2pos(obj4733, "next", &meth_collectionsPrelude_next4746, 3);
  int argcv_meth_collectionsPrelude_next4746[] = {0};
  meth_meth_collectionsPrelude_next4746->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next4746);
  meth_meth_collectionsPrelude_next4746->definitionModule = modulename;
  meth_meth_collectionsPrelude_next4746->definitionLine = 1873;
// method asString
  struct UserObject *uo4785 = (struct UserObject*)obj4733;
  uo4785->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString4785 = addmethod2pos(obj4733, "asString", &meth_collectionsPrelude_asString4785, 4);
  int argcv_meth_collectionsPrelude_asString4785[] = {0};
  meth_meth_collectionsPrelude_asString4785->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString4785);
  meth_meth_collectionsPrelude_asString4785->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString4785->definitionLine = 1878;
  sourceObject = obj4733;
// Begin line 1871
  setline(1871);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4796 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4797 = gc_frame_new();
// call case 3: self.outer request
  Object call4798 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4797);
// compiled call node returning call4798 (depth = 5)
// compiled member node returning call4798 (depth = 4)
  partcv[0] = 0;
  Object call4799 = callmethodflags(call4798, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4796);
// compiled call node returning call4799 (depth = 3)
// compiled member node returning call4799 (depth = 2)
  adddatum2(obj4733, call4799, 1);
  sourceObject = obj4733;
  sourceObject = obj4733;
  sourceObject = obj4733;
  objclass4733 = obj4733->class;
  objclass4733->definitionModule = modulename;
  objclass4733->definitionLine = 1870;
  (*(struct UserObject *)self).data[0] = lowerouter4733;
  self = oldself4733;
  selfslot = oldselfslot4733;
  stackframe = oldstackframe4733;
  gc_frame_end(frame);
  return obj4733;
}
Object meth_collectionsPrelude_iterator4732_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_Exhausted = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4733 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4733 = alloc_userobj2(5,5, objclass4733);
  gc_frame_newslot(obj4733);
if (objclass4733 == NULL) {
  glfree(obj4733->class->name);
  obj4733->class->name = "obj4727.iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4733, self, 0);
  addmethodreal(obj4733,"outer", &reader_collectionsPrelude_outer_4734);
  Object oldself4733 = self;
  struct StackFrameObject *oldstackframe4733 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4733);
  gc_frame_newslot((Object)stackframe);
  self = obj4733;
  Object *oldselfslot4733 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4733 = (*(struct UserObject *)self).data[0], lowerouter4733 = thisouter4733;
  if (inheritingObject4733) {
    struct UserObject *inho4733 = (struct UserObject *)inheritingObject4733;
    while (inho4733->super != GraceDefaultObject) inho4733 = (struct UserObject *)inho4733->super;
    inho4733->super = obj4733;
    self = inheritingObject4733;
    *selfslot = self;
    lowerouter4733 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4733;
  }
if (objclass4733 == NULL) {
  Method *reader4735 = addmethodrealflags(obj4733, "val",&reader_collectionsPrelude_val_4735, MFLAG_CONFIDENTIAL);
  Method *writer4735 = addmethodrealflags(obj4733, "val:=",&writer_collectionsPrelude_val_4735, MFLAG_CONFIDENTIAL);
  reader4735->definitionModule = modulename;
  writer4735->definitionModule = modulename;
  reader4735->definitionLine = 1871;
  writer4735->definitionLine = 1871;
}
obj4733->flags |= OFLAG_MUTABLE;
adddatum2(obj4733, alloc_Undefined(), 1);
// method hasNext
  struct UserObject *uo4736 = (struct UserObject*)obj4733;
  uo4736->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext4736 = addmethod2pos(obj4733, "hasNext", &meth_collectionsPrelude_hasNext4736, 2);
  int argcv_meth_collectionsPrelude_hasNext4736[] = {0};
  meth_meth_collectionsPrelude_hasNext4736->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext4736);
  meth_meth_collectionsPrelude_hasNext4736->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext4736->definitionLine = 1872;
// method next
  block_savedest(obj4733);
  Object closure4746 = createclosure(1, "next");
  setclosureframe(closure4746, stackframe);
  addtoclosure(closure4746, var_Exhausted);
  struct UserObject *uo4746 = (struct UserObject*)obj4733;
  uo4746->data[3] = (Object)closure4746;
  Method *meth_meth_collectionsPrelude_next4746 = addmethod2pos(obj4733, "next", &meth_collectionsPrelude_next4746, 3);
  int argcv_meth_collectionsPrelude_next4746[] = {0};
  meth_meth_collectionsPrelude_next4746->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next4746);
  meth_meth_collectionsPrelude_next4746->definitionModule = modulename;
  meth_meth_collectionsPrelude_next4746->definitionLine = 1873;
// method asString
  struct UserObject *uo4785 = (struct UserObject*)obj4733;
  uo4785->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString4785 = addmethod2pos(obj4733, "asString", &meth_collectionsPrelude_asString4785, 4);
  int argcv_meth_collectionsPrelude_asString4785[] = {0};
  meth_meth_collectionsPrelude_asString4785->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString4785);
  meth_meth_collectionsPrelude_asString4785->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString4785->definitionLine = 1878;
  sourceObject = obj4733;
// Begin line 1871
  setline(1871);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4796 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4797 = gc_frame_new();
// call case 3: self.outer request
  Object call4798 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4797);
// compiled call node returning call4798 (depth = 5)
// compiled member node returning call4798 (depth = 4)
  partcv[0] = 0;
  Object call4799 = callmethodflags(call4798, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4796);
// compiled call node returning call4799 (depth = 3)
// compiled member node returning call4799 (depth = 2)
  adddatum2(obj4733, call4799, 1);
  sourceObject = obj4733;
  sourceObject = obj4733;
  sourceObject = obj4733;
  objclass4733 = obj4733->class;
  objclass4733->definitionModule = modulename;
  objclass4733->definitionLine = 1870;
  (*(struct UserObject *)self).data[0] = lowerouter4733;
  self = oldself4733;
  selfslot = oldselfslot4733;
  stackframe = oldstackframe4733;
  gc_frame_end(frame);
  return obj4733;
}
Object meth_collectionsPrelude_at4801(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "at");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method at");
  Object params[1];
  int partcv[1];
  Object *var_BoundsError = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for at (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for at");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1882
  setline(1882);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4803 = gc_frame_new();
// call case 6: other member request
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4805 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4806 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4805);
// compiled call node returning call4806 (depth = 6)
// compiled member node returning call4806 (depth = 5)
  int op_slot_right_4804 = gc_frame_newslot(call4806);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ix (depth = 5)
  int op_slot_left_4804 = gc_frame_newslot(*var_ix);
  params[0] = call4806;
  partcv[0] = 1;
  Object opresult4808 = callmethod(*var_ix, "<=", 1, partcv, params);
// compiled op node returning opresult4808 (depth = 4)
  partcv[0] = 0;
  Object call4809 = callmethod(opresult4808, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe4803);
// compiled call node returning call4809 (depth = 3)
  Object if4802 = done;
  if (istrue(call4809)) {
// Begin line 1883
  setline(1883);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4810 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4812 == NULL) {
    strlit4812 = alloc_String("");
    gc_root(strlit4812);
  }
// compiled string node returning strlit4812 (depth = 5)
  int op_slot_right_4811 = gc_frame_newslot(strlit4812);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4815 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4816 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4815);
// compiled call node returning call4816 (depth = 7)
// compiled member node returning call4816 (depth = 6)
  int op_slot_right_4814 = gc_frame_newslot(call4816);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4819 == NULL) {
    strlit4819 = alloc_String(") but upper bound is ");
    gc_root(strlit4819);
  }
// compiled string node returning strlit4819 (depth = 7)
  int op_slot_right_4818 = gc_frame_newslot(strlit4819);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ix (depth = 8)
  int op_slot_right_4821 = gc_frame_newslot(*var_ix);
// starting to compile string node (depth = 8)
  if (strlit4823 == NULL) {
    strlit4823 = alloc_String("requested range.at(");
    gc_root(strlit4823);
  }
// compiled string node returning strlit4823 (depth = 8)
  int op_slot_left_4821 = gc_frame_newslot(strlit4823);
  params[0] = *var_ix;
  partcv[0] = 1;
  Object opresult4824 = callmethod(strlit4823, "++", 1, partcv, params);
// compiled op node returning opresult4824 (depth = 7)
  int op_slot_left_4818 = gc_frame_newslot(opresult4824);
  params[0] = strlit4819;
  partcv[0] = 1;
  Object opresult4825 = callmethod(opresult4824, "++", 1, partcv, params);
// compiled op node returning opresult4825 (depth = 6)
  int op_slot_left_4814 = gc_frame_newslot(opresult4825);
  params[0] = call4816;
  partcv[0] = 1;
  Object opresult4826 = callmethod(opresult4825, "++", 1, partcv, params);
// compiled op node returning opresult4826 (depth = 5)
  int op_slot_left_4811 = gc_frame_newslot(opresult4826);
  params[0] = strlit4812;
  partcv[0] = 1;
  Object opresult4827 = callmethod(opresult4826, "++", 1, partcv, params);
// compiled op node returning opresult4827 (depth = 4)
  gc_frame_newslot(opresult4827);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_BoundsError (depth = 4)
  params[0] = opresult4827;
  partcv[0] = 1;
  Object call4828 = callmethod(*var_BoundsError, "raise",
    1, partcv, params);
  gc_frame_end(callframe4810);
// compiled call node returning call4828 (depth = 3)
    gc_frame_newslot(call4828);
    if4802 = call4828;
  } else {
  }
// compiled if node returning if4802 (depth = 2)
// Begin line 1885
  setline(1885);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4830 = gc_frame_new();
// call case 6: other member request
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4832 = alloc_Float64(1);
// compiled num node returning num4832 (depth = 5)
  int op_slot_right_4831 = gc_frame_newslot(num4832);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ix (depth = 5)
  int op_slot_left_4831 = gc_frame_newslot(*var_ix);
  params[0] = num4832;
  partcv[0] = 1;
  Object opresult4834 = callmethod(*var_ix, ">=", 1, partcv, params);
// compiled op node returning opresult4834 (depth = 4)
  partcv[0] = 0;
  Object call4835 = callmethod(opresult4834, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe4830);
// compiled call node returning call4835 (depth = 3)
  Object if4829 = done;
  if (istrue(call4835)) {
// Begin line 1886
  setline(1886);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4836 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4838 == NULL) {
    strlit4838 = alloc_String(") but lower bound is 1");
    gc_root(strlit4838);
  }
// compiled string node returning strlit4838 (depth = 5)
  int op_slot_right_4837 = gc_frame_newslot(strlit4838);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  int op_slot_right_4840 = gc_frame_newslot(*var_ix);
// starting to compile string node (depth = 6)
  if (strlit4842 == NULL) {
    strlit4842 = alloc_String("requested range.at(");
    gc_root(strlit4842);
  }
// compiled string node returning strlit4842 (depth = 6)
  int op_slot_left_4840 = gc_frame_newslot(strlit4842);
  params[0] = *var_ix;
  partcv[0] = 1;
  Object opresult4843 = callmethod(strlit4842, "++", 1, partcv, params);
// compiled op node returning opresult4843 (depth = 5)
  int op_slot_left_4837 = gc_frame_newslot(opresult4843);
  params[0] = strlit4838;
  partcv[0] = 1;
  Object opresult4844 = callmethod(opresult4843, "++", 1, partcv, params);
// compiled op node returning opresult4844 (depth = 4)
  gc_frame_newslot(opresult4844);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_BoundsError (depth = 4)
  params[0] = opresult4844;
  partcv[0] = 1;
  Object call4845 = callmethod(*var_BoundsError, "raise",
    1, partcv, params);
  gc_frame_end(callframe4836);
// compiled call node returning call4845 (depth = 3)
    gc_frame_newslot(call4845);
    if4829 = call4845;
  } else {
  }
// compiled if node returning if4829 (depth = 2)
// Begin line 1888
  setline(1888);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4848 = alloc_Float64(1);
// compiled num node returning num4848 (depth = 5)
  int op_slot_right_4847 = gc_frame_newslot(num4848);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ix (depth = 5)
  int op_slot_left_4847 = gc_frame_newslot(*var_ix);
  params[0] = num4848;
  partcv[0] = 1;
  Object diff4850 = callmethod(*var_ix, "-", 1, partcv, params);
// compiled op node returning diff4850 (depth = 4)
  int op_slot_right_4846 = gc_frame_newslot(diff4850);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4852 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4853 = callmethodflags(self, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4852);
// compiled call node returning call4853 (depth = 5)
// compiled member node returning call4853 (depth = 4)
  int op_slot_left_4846 = gc_frame_newslot(call4853);
  params[0] = diff4850;
  partcv[0] = 1;
  Object diff4854 = callmethod(call4853, "-", 1, partcv, params);
// compiled op node returning diff4854 (depth = 3)
  return diff4854;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply4858(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_elem = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_intElem = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "intElem");
// Begin line 1892
  setline(1892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4859 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_elem (depth = 7)
  partcv[0] = 0;
  Object call4860 = callmethod(*var_elem, "truncated",
    1, partcv, params);
  gc_frame_end(callframe4859);
// compiled call node returning call4860 (depth = 6)
// compiled member node returning call4860 (depth = 5)
  *var_intElem = call4860;
  if (call4860 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1893
  setline(1893);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_elem (depth = 6)
  int op_slot_right_4862 = gc_frame_newslot(*var_elem);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_intElem (depth = 6)
  int op_slot_left_4862 = gc_frame_newslot(*var_intElem);
  params[0] = *var_elem;
  partcv[0] = 1;
  Object opresult4864 = callmethod(*var_intElem, "!=", 1, partcv, params);
// compiled op node returning opresult4864 (depth = 5)
  Object if4861 = done;
  if (istrue(opresult4864)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool4865 = alloc_Boolean(0);
// compiled identifier node returning bool4865 (depth = 6)
  block_return(realself, bool4865);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if4861 = undefined;
  } else {
  }
// compiled if node returning if4861 (depth = 4)
// Begin line 1894
  setline(1894);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4868 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4869 = callmethodflags(self, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4868);
// compiled call node returning call4869 (depth = 7)
// compiled member node returning call4869 (depth = 6)
  int op_slot_right_4867 = gc_frame_newslot(call4869);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_intElem (depth = 6)
  int op_slot_left_4867 = gc_frame_newslot(*var_intElem);
  params[0] = call4869;
  partcv[0] = 1;
  Object opresult4871 = callmethod(*var_intElem, ">", 1, partcv, params);
// compiled op node returning opresult4871 (depth = 5)
  Object if4866 = done;
  if (istrue(opresult4871)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool4872 = alloc_Boolean(0);
// compiled identifier node returning bool4872 (depth = 6)
  block_return(realself, bool4872);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if4866 = undefined;
  } else {
  }
// compiled if node returning if4866 (depth = 4)
// Begin line 1895
  setline(1895);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4875 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4876 = callmethodflags(self, "stop", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4875);
// compiled call node returning call4876 (depth = 7)
// compiled member node returning call4876 (depth = 6)
  int op_slot_right_4874 = gc_frame_newslot(call4876);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_intElem (depth = 6)
  int op_slot_left_4874 = gc_frame_newslot(*var_intElem);
  params[0] = call4876;
  partcv[0] = 1;
  Object opresult4878 = callmethod(*var_intElem, "<", 1, partcv, params);
// compiled op node returning opresult4878 (depth = 5)
  Object if4873 = done;
  if (istrue(opresult4878)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool4879 = alloc_Boolean(0);
// compiled identifier node returning bool4879 (depth = 6)
  block_return(realself, bool4879);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if4873 = undefined;
  } else {
  }
// compiled if node returning if4873 (depth = 4)
  gc_frame_end(frame);
  return if4873;
}
Object meth_collectionsPrelude__apply4882(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ex = &(stackframe->slots[0]);
  *var_ex = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool4883 = alloc_Boolean(0);
// compiled identifier node returning bool4883 (depth = 5)
  block_return(realself, bool4883);
// compiled return node returning undefined (depth = 4)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_contains4855(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "contains");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method contains");
  Object params[2];
  int partcv[1];
  Object *var__prelude = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for contains (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_elem = &(stackframe->slots[0]);
  *var_elem = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for contains");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1891
  setline(1891);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile catchcase node (depth = 2)
// starting to compile block node (depth = 3)
  Object block4857 = alloc_Block(NULL, NULL, "collectionsPrelude", 1891);
  gc_frame_newslot(block4857);
// method _apply
  block_savedest(block4857);
  Object closure4858 = createclosure(2, "_apply");
  setclosureframe(closure4858, stackframe);
  addtoclosure(closure4858, var_elem);
  addtoclosure(closure4858, selfslot);
  struct UserObject *uo4858 = (struct UserObject*)block4857;
  uo4858->data[0] = (Object)closure4858;
  Method *meth_meth_collectionsPrelude__apply4858 = addmethod2pos(block4857, "_apply", &meth_collectionsPrelude__apply4858, 0);
  int argcv_meth_collectionsPrelude__apply4858[] = {0};
  meth_meth_collectionsPrelude__apply4858->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4858);
  meth_meth_collectionsPrelude__apply4858->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4858->definitionLine = 1888;
// compiled block node returning block4857 (depth = 3)
  int frame4856 = gc_frame_new();
  gc_frame_newslot(block4857);
// Begin line 1896
  setline(1896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4881 = alloc_Block(NULL, NULL, "collectionsPrelude", 1896);
  gc_frame_newslot(block4881);
// method _apply
  block_savedest(block4881);
  Object closure4882 = createclosure(1, "_apply");
  setclosureframe(closure4882, stackframe);
  addtoclosure(closure4882, selfslot);
  struct UserObject *uo4882 = (struct UserObject*)block4881;
  uo4882->data[0] = (Object)closure4882;
  Method *meth_meth_collectionsPrelude__apply4882 = addmethod2pos(block4881, "_apply", &meth_collectionsPrelude__apply4882, 0);
  int argcv_meth_collectionsPrelude__apply4882[] = {1};
  meth_meth_collectionsPrelude__apply4882->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4882);
  meth_meth_collectionsPrelude__apply4882->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4882->definitionLine = 1895;
// starting to compile call node (depth = 4)
  int callframe4885 = gc_frame_new();
// Begin line 1781
  setline(1781);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4886 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4887 == NULL) {
    strlit4887 = alloc_String("ex");
    gc_root(strlit4887);
  }
// compiled string node returning strlit4887 (depth = 6)
  gc_frame_newslot(strlit4887);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4888 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4889 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4888);
// compiled call node returning call4889 (depth = 7)
// compiled member node returning call4889 (depth = 6)
  params[0] = strlit4887;
  partcv[0] = 1;
  Object call4890 = callmethod(call4889, "new",
    1, partcv, params);
  gc_frame_end(callframe4886);
// compiled call node returning call4890 (depth = 5)
  gc_frame_newslot(call4890);
// Begin line 1896
  setline(1896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4891 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var__prelude (depth = 7)
  partcv[0] = 0;
  Object call4892 = callmethod(*var__prelude, "Exception",
    1, partcv, params);
  gc_frame_end(callframe4891);
// compiled call node returning call4892 (depth = 6)
// compiled member node returning call4892 (depth = 5)
  gc_frame_newslot(call4892);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4893 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4894 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4893);
// compiled call node returning call4894 (depth = 6)
// compiled member node returning call4894 (depth = 5)
  params[0] = call4890;
  params[1] = call4892;
  partcv[0] = 2;
  Object call4895 = callmethod(call4894, "new",
    1, partcv, params);
  gc_frame_end(callframe4885);
// compiled call node returning call4895 (depth = 4)
((struct UserObject *)block4881)->data[1] = call4895;
// compiled block node returning block4881 (depth = 3)
  gc_frame_newslot(block4881);
  params[0] = block4881;
  setline(1891);
  Object catchres4856 = catchCase(block4857, params, 1,NULL);
  gc_frame_end(frame4856);
// compiled catchcase node returning catchres4856 (depth = 2)
// Begin line 1897
  setline(1897);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool4896 = alloc_Boolean(1);
// compiled identifier node returning bool4896 (depth = 3)
  return bool4896;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply4902(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_val = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4904 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4905 = callmethodflags(self, "stop", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4904);
// compiled call node returning call4905 (depth = 6)
// compiled member node returning call4905 (depth = 5)
  int op_slot_right_4903 = gc_frame_newslot(call4905);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  int op_slot_left_4903 = gc_frame_newslot(*var_val);
  params[0] = call4905;
  partcv[0] = 1;
  Object opresult4907 = callmethod(*var_val, ">=", 1, partcv, params);
// compiled op node returning opresult4907 (depth = 4)
  gc_frame_end(frame);
  return opresult4907;
}
Object meth_collectionsPrelude__apply4910(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_val = getfromclosure(closure, 0);
  Object *var_block1 = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1902
  setline(1902);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4911 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  gc_frame_newslot(*var_val);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_block1 (depth = 5)
  params[0] = *var_val;
  partcv[0] = 1;
  Object call4912 = callmethod(*var_block1, "apply",
    1, partcv, params);
  gc_frame_end(callframe4911);
// compiled call node returning call4912 (depth = 4)
// Begin line 1903
  setline(1903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num4914 = alloc_Float64(1);
// compiled num node returning num4914 (depth = 6)
  int op_slot_right_4913 = gc_frame_newslot(num4914);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_val (depth = 6)
  int op_slot_left_4913 = gc_frame_newslot(*var_val);
  params[0] = num4914;
  partcv[0] = 1;
  Object diff4916 = callmethod(*var_val, "-", 1, partcv, params);
// compiled op node returning diff4916 (depth = 5)
  *var_val = diff4916;
  if (diff4916 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_do4897(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method do");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for do (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for do");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_val = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "val");
// Begin line 1900
  setline(1900);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4898 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4899 = callmethodflags(self, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4898);
// compiled call node returning call4899 (depth = 4)
// compiled member node returning call4899 (depth = 3)
  *var_val = call4899;
  if (call4899 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1901
  setline(1901);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4900 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block4901 = alloc_Block(NULL, NULL, "collectionsPrelude", 1901);
  gc_frame_newslot(block4901);
// method _apply
  block_savedest(block4901);
  Object closure4902 = createclosure(2, "_apply");
  setclosureframe(closure4902, stackframe);
  addtoclosure(closure4902, var_val);
  addtoclosure(closure4902, selfslot);
  struct UserObject *uo4902 = (struct UserObject*)block4901;
  uo4902->data[0] = (Object)closure4902;
  Method *meth_meth_collectionsPrelude__apply4902 = addmethod2pos(block4901, "_apply", &meth_collectionsPrelude__apply4902, 0);
  int argcv_meth_collectionsPrelude__apply4902[] = {0};
  meth_meth_collectionsPrelude__apply4902->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4902);
  meth_meth_collectionsPrelude__apply4902->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4902->definitionLine = 1900;
// compiled block node returning block4901 (depth = 3)
  gc_frame_newslot(block4901);
// starting to compile block node (depth = 3)
  Object block4909 = alloc_Block(NULL, NULL, "collectionsPrelude", 1901);
  gc_frame_newslot(block4909);
// method _apply
  block_savedest(block4909);
  Object closure4910 = createclosure(3, "_apply");
  setclosureframe(closure4910, stackframe);
  addtoclosure(closure4910, var_val);
  addtoclosure(closure4910, var_block1);
  addtoclosure(closure4910, selfslot);
  struct UserObject *uo4910 = (struct UserObject*)block4909;
  uo4910->data[0] = (Object)closure4910;
  Method *meth_meth_collectionsPrelude__apply4910 = addmethod2pos(block4909, "_apply", &meth_collectionsPrelude__apply4910, 0);
  int argcv_meth_collectionsPrelude__apply4910[] = {0};
  meth_meth_collectionsPrelude__apply4910->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4910);
  meth_meth_collectionsPrelude__apply4910->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4910->definitionLine = 1901;
// compiled block node returning block4909 (depth = 3)
  gc_frame_newslot(block4909);
// call case 5: prelude request
  params[0] = block4901;
  params[1] = block4909;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4919 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4900);
// compiled call node returning call4919 (depth = 2)
  gc_frame_end(frame);
  return call4919;
}
Object meth_collectionsPrelude__apply4926(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_val = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4928 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4929 = callmethodflags(self, "stop", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4928);
// compiled call node returning call4929 (depth = 6)
// compiled member node returning call4929 (depth = 5)
  int op_slot_right_4927 = gc_frame_newslot(call4929);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  int op_slot_left_4927 = gc_frame_newslot(*var_val);
  params[0] = call4929;
  partcv[0] = 1;
  Object opresult4931 = callmethod(*var_val, ">=", 1, partcv, params);
// compiled op node returning opresult4931 (depth = 4)
  gc_frame_end(frame);
  return opresult4931;
}
Object meth_collectionsPrelude__apply4934(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_key = getfromclosure(closure, 0);
  Object *var_val = getfromclosure(closure, 1);
  Object *var_block2 = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1910
  setline(1910);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4935 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_key (depth = 5)
  gc_frame_newslot(*var_key);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  gc_frame_newslot(*var_val);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_block2 (depth = 5)
  params[0] = *var_key;
  params[1] = *var_val;
  partcv[0] = 2;
  Object call4936 = callmethod(*var_block2, "apply",
    1, partcv, params);
  gc_frame_end(callframe4935);
// compiled call node returning call4936 (depth = 4)
// Begin line 1911
  setline(1911);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num4938 = alloc_Float64(1);
// compiled num node returning num4938 (depth = 6)
  int op_slot_right_4937 = gc_frame_newslot(num4938);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_key (depth = 6)
  int op_slot_left_4937 = gc_frame_newslot(*var_key);
  params[0] = num4938;
  partcv[0] = 1;
  Object sum4940 = callmethod(*var_key, "+", 1, partcv, params);
// compiled op node returning sum4940 (depth = 5)
  *var_key = sum4940;
  if (sum4940 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1912
  setline(1912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num4943 = alloc_Float64(1);
// compiled num node returning num4943 (depth = 6)
  int op_slot_right_4942 = gc_frame_newslot(num4943);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_val (depth = 6)
  int op_slot_left_4942 = gc_frame_newslot(*var_val);
  params[0] = num4943;
  partcv[0] = 1;
  Object diff4945 = callmethod(*var_val, "-", 1, partcv, params);
// compiled op node returning diff4945 (depth = 5)
  *var_val = diff4945;
  if (diff4945 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_keysAndValuesDo4920(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keysAndValuesDo");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method keysAndValuesDo");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for keysAndValuesDo (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block2 = &(stackframe->slots[0]);
  *var_block2 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for keysAndValuesDo");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_key = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "key");
  Object *var_val = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "val");
// Begin line 1907
  setline(1907);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num4921 = alloc_Float64(1);
// compiled num node returning num4921 (depth = 3)
  *var_key = num4921;
  if (num4921 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1908
  setline(1908);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4922 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4923 = callmethodflags(self, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4922);
// compiled call node returning call4923 (depth = 4)
// compiled member node returning call4923 (depth = 3)
  *var_val = call4923;
  if (call4923 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1909
  setline(1909);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4924 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block4925 = alloc_Block(NULL, NULL, "collectionsPrelude", 1909);
  gc_frame_newslot(block4925);
// method _apply
  block_savedest(block4925);
  Object closure4926 = createclosure(2, "_apply");
  setclosureframe(closure4926, stackframe);
  addtoclosure(closure4926, var_val);
  addtoclosure(closure4926, selfslot);
  struct UserObject *uo4926 = (struct UserObject*)block4925;
  uo4926->data[0] = (Object)closure4926;
  Method *meth_meth_collectionsPrelude__apply4926 = addmethod2pos(block4925, "_apply", &meth_collectionsPrelude__apply4926, 0);
  int argcv_meth_collectionsPrelude__apply4926[] = {0};
  meth_meth_collectionsPrelude__apply4926->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4926);
  meth_meth_collectionsPrelude__apply4926->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4926->definitionLine = 1908;
// compiled block node returning block4925 (depth = 3)
  gc_frame_newslot(block4925);
// starting to compile block node (depth = 3)
  Object block4933 = alloc_Block(NULL, NULL, "collectionsPrelude", 1909);
  gc_frame_newslot(block4933);
// method _apply
  block_savedest(block4933);
  Object closure4934 = createclosure(4, "_apply");
  setclosureframe(closure4934, stackframe);
  addtoclosure(closure4934, var_key);
  addtoclosure(closure4934, var_val);
  addtoclosure(closure4934, var_block2);
  addtoclosure(closure4934, selfslot);
  struct UserObject *uo4934 = (struct UserObject*)block4933;
  uo4934->data[0] = (Object)closure4934;
  Method *meth_meth_collectionsPrelude__apply4934 = addmethod2pos(block4933, "_apply", &meth_collectionsPrelude__apply4934, 0);
  int argcv_meth_collectionsPrelude__apply4934[] = {0};
  meth_meth_collectionsPrelude__apply4934->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4934);
  meth_meth_collectionsPrelude__apply4934->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4934->definitionLine = 1909;
// compiled block node returning block4933 (depth = 3)
  gc_frame_newslot(block4933);
// call case 5: prelude request
  params[0] = block4925;
  params[1] = block4933;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4948 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4924);
// compiled call node returning call4948 (depth = 2)
  gc_frame_end(frame);
  return call4948;
}
Object meth_collectionsPrelude_reversed4949(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "reversed");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_lower = getfromclosure(closure, 0);
  Object *var_upper = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for reversed (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for reversed");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1916
  setline(1916);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4950 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lower (depth = 3)
  gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_upper (depth = 3)
  gc_frame_newslot(*var_upper);
// call case 2: outer request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4951 = gc_frame_new();
// call case 3: self.outer request
  Object call4952 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4951);
// compiled call node returning call4952 (depth = 4)
// compiled member node returning call4952 (depth = 3)
  params[0] = *var_lower;
  params[1] = *var_upper;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4953 = callmethodflags(call4952, "from()to", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4950);
// compiled call node returning call4953 (depth = 2)
  gc_frame_end(frame);
  return call4953;
}
Object meth_collectionsPrelude__43__43_4954(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "++");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method ++");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for ++ (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for ++");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1919
  setline(1919);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4955 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  gc_frame_newslot(*var_other);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4956 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4957 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4958 = gc_frame_new();
// call case 3: self.outer request
  Object call4959 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4958);
// compiled call node returning call4959 (depth = 8)
// compiled member node returning call4959 (depth = 7)
  partcv[0] = 0;
  Object call4960 = callmethodflags(call4959, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4957);
// compiled call node returning call4960 (depth = 6)
// compiled member node returning call4960 (depth = 5)
  partcv[0] = 0;
  Object call4961 = callmethodflags(call4960, "sequence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4956);
// compiled call node returning call4961 (depth = 4)
// compiled member node returning call4961 (depth = 3)
  params[0] = self;
  params[1] = *var_other;
  partcv[0] = 2;
  Object call4962 = callmethod(call4961, "withAll",
    1, partcv, params);
  gc_frame_end(callframe4955);
// compiled call node returning call4962 (depth = 2)
  gc_frame_end(frame);
  return call4962;
}
Object meth_collectionsPrelude__apply4973(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_otherIter = getfromclosure(closure, 0);
  Object *var_selfIter = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4975 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_otherIter (depth = 9)
  partcv[0] = 0;
  Object call4976 = callmethod(*var_otherIter, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe4975);
// compiled call node returning call4976 (depth = 8)
// compiled member node returning call4976 (depth = 7)
  int op_slot_right_4974 = gc_frame_newslot(call4976);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4978 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_selfIter (depth = 9)
  partcv[0] = 0;
  Object call4979 = callmethod(*var_selfIter, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe4978);
// compiled call node returning call4979 (depth = 8)
// compiled member node returning call4979 (depth = 7)
  int op_slot_left_4974 = gc_frame_newslot(call4979);
  params[0] = call4976;
  partcv[0] = 1;
  Object opresult4980 = callmethod(call4979, "&&", 1, partcv, params);
// compiled op node returning opresult4980 (depth = 6)
  gc_frame_end(frame);
  return opresult4980;
}
Object meth_collectionsPrelude__apply4983(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_otherIter = getfromclosure(closure, 0);
  Object *var_selfIter = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1928
  setline(1928);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4986 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_otherIter (depth = 10)
  partcv[0] = 0;
  Object call4987 = callmethod(*var_otherIter, "next",
    1, partcv, params);
  gc_frame_end(callframe4986);
// compiled call node returning call4987 (depth = 9)
// compiled member node returning call4987 (depth = 8)
  int op_slot_right_4985 = gc_frame_newslot(call4987);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4989 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_selfIter (depth = 10)
  partcv[0] = 0;
  Object call4990 = callmethod(*var_selfIter, "next",
    1, partcv, params);
  gc_frame_end(callframe4989);
// compiled call node returning call4990 (depth = 9)
// compiled member node returning call4990 (depth = 8)
  int op_slot_left_4985 = gc_frame_newslot(call4990);
  params[0] = call4987;
  partcv[0] = 1;
  Object opresult4991 = callmethod(call4990, "!=", 1, partcv, params);
// compiled op node returning opresult4991 (depth = 7)
  Object if4984 = done;
  if (istrue(opresult4991)) {
// Begin line 1929
  setline(1929);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool4992 = alloc_Boolean(0);
// compiled identifier node returning bool4992 (depth = 8)
  block_return(realself, bool4992);
// compiled return node returning undefined (depth = 7)
    gc_frame_newslot(undefined);
    if4984 = undefined;
  } else {
  }
// compiled if node returning if4984 (depth = 6)
  gc_frame_end(frame);
  return if4984;
}
Object meth_collectionsPrelude__apply4966(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_other = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_selfIter = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "selfIter");
  Object *var_otherIter = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "otherIter");
// Begin line 1925
  setline(1925);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4967 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4968 = callmethodflags(self, "iterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4967);
// compiled call node returning call4968 (depth = 6)
// compiled member node returning call4968 (depth = 5)
  *var_selfIter = call4968;
  if (call4968 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1926
  setline(1926);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4969 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  partcv[0] = 0;
  Object call4970 = callmethod(*var_other, "iterator",
    1, partcv, params);
  gc_frame_end(callframe4969);
// compiled call node returning call4970 (depth = 6)
// compiled member node returning call4970 (depth = 5)
  *var_otherIter = call4970;
  if (call4970 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1927
  setline(1927);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4971 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block4972 = alloc_Block(NULL, NULL, "collectionsPrelude", 1927);
  gc_frame_newslot(block4972);
// method _apply
  block_savedest(block4972);
  Object closure4973 = createclosure(3, "_apply");
  setclosureframe(closure4973, stackframe);
  addtoclosure(closure4973, var_otherIter);
  addtoclosure(closure4973, var_selfIter);
  addtoclosure(closure4973, selfslot);
  struct UserObject *uo4973 = (struct UserObject*)block4972;
  uo4973->data[0] = (Object)closure4973;
  Method *meth_meth_collectionsPrelude__apply4973 = addmethod2pos(block4972, "_apply", &meth_collectionsPrelude__apply4973, 0);
  int argcv_meth_collectionsPrelude__apply4973[] = {0};
  meth_meth_collectionsPrelude__apply4973->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4973);
  meth_meth_collectionsPrelude__apply4973->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4973->definitionLine = 1926;
// compiled block node returning block4972 (depth = 5)
  gc_frame_newslot(block4972);
// starting to compile block node (depth = 5)
  Object block4982 = alloc_Block(NULL, NULL, "collectionsPrelude", 1927);
  gc_frame_newslot(block4982);
// method _apply
  block_savedest(block4982);
  Object closure4983 = createclosure(3, "_apply");
  setclosureframe(closure4983, stackframe);
  addtoclosure(closure4983, var_otherIter);
  addtoclosure(closure4983, var_selfIter);
  addtoclosure(closure4983, selfslot);
  struct UserObject *uo4983 = (struct UserObject*)block4982;
  uo4983->data[0] = (Object)closure4983;
  Method *meth_meth_collectionsPrelude__apply4983 = addmethod2pos(block4982, "_apply", &meth_collectionsPrelude__apply4983, 0);
  int argcv_meth_collectionsPrelude__apply4983[] = {0};
  meth_meth_collectionsPrelude__apply4983->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4983);
  meth_meth_collectionsPrelude__apply4983->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4983->definitionLine = 1927;
// compiled block node returning block4982 (depth = 5)
  gc_frame_newslot(block4982);
// call case 5: prelude request
  params[0] = block4972;
  params[1] = block4982;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4994 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4971);
// compiled call node returning call4994 (depth = 4)
// Begin line 1932
  setline(1932);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4996 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_otherIter (depth = 8)
  partcv[0] = 0;
  Object call4997 = callmethod(*var_otherIter, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe4996);
// compiled call node returning call4997 (depth = 7)
// compiled member node returning call4997 (depth = 6)
  int op_slot_right_4995 = gc_frame_newslot(call4997);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4999 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_selfIter (depth = 8)
  partcv[0] = 0;
  Object call5000 = callmethod(*var_selfIter, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe4999);
// compiled call node returning call5000 (depth = 7)
// compiled member node returning call5000 (depth = 6)
  int op_slot_left_4995 = gc_frame_newslot(call5000);
  params[0] = call4997;
  partcv[0] = 1;
  Object opresult5001 = callmethod(call5000, "==", 1, partcv, params);
// compiled op node returning opresult5001 (depth = 5)
  block_return(realself, opresult5001);
// compiled return node returning undefined (depth = 4)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply5013(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___31 = &(stackframe->slots[0]);
  *var___31 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1935
  setline(1935);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool5014 = alloc_Boolean(0);
// compiled identifier node returning bool5014 (depth = 5)
  block_return(realself, bool5014);
// compiled return node returning undefined (depth = 4)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__61__61_4963(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "==");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method ==");
  Object params[2];
  int partcv[1];
  Object *var_Collection = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for == (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for ==");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1923
  setline(1923);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  int frame4964 = gc_frame_new();
  gc_frame_newslot(*var_other);
// Begin line 1924
  setline(1924);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4965 = alloc_Block(NULL, NULL, "collectionsPrelude", 1924);
  gc_frame_newslot(block4965);
// method _apply
  block_savedest(block4965);
  Object closure4966 = createclosure(2, "_apply");
  setclosureframe(closure4966, stackframe);
  addtoclosure(closure4966, var_other);
  addtoclosure(closure4966, selfslot);
  struct UserObject *uo4966 = (struct UserObject*)block4965;
  uo4966->data[0] = (Object)closure4966;
  Method *meth_meth_collectionsPrelude__apply4966 = addmethod2pos(block4965, "_apply", &meth_collectionsPrelude__apply4966, 0);
  int argcv_meth_collectionsPrelude__apply4966[] = {1};
  meth_meth_collectionsPrelude__apply4966->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4966);
  meth_meth_collectionsPrelude__apply4966->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4966->definitionLine = 1919;
// Begin line 1896
  setline(1896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5003 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe5004 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5005 == NULL) {
    strlit5005 = alloc_String("o");
    gc_root(strlit5005);
  }
// compiled string node returning strlit5005 (depth = 6)
  gc_frame_newslot(strlit5005);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5006 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5007 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5006);
// compiled call node returning call5007 (depth = 7)
// compiled member node returning call5007 (depth = 6)
  params[0] = strlit5005;
  partcv[0] = 1;
  Object call5008 = callmethod(call5007, "new",
    1, partcv, params);
  gc_frame_end(callframe5004);
// compiled call node returning call5008 (depth = 5)
  gc_frame_newslot(call5008);
// Begin line 1924
  setline(1924);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_Collection (depth = 5)
  gc_frame_newslot(*var_Collection);
// call case 6: other member request
// Begin line 1896
  setline(1896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5009 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5010 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5009);
// compiled call node returning call5010 (depth = 6)
// compiled member node returning call5010 (depth = 5)
  params[0] = call5008;
  params[1] = *var_Collection;
  partcv[0] = 2;
  Object call5011 = callmethod(call5010, "new",
    1, partcv, params);
  gc_frame_end(callframe5003);
// compiled call node returning call5011 (depth = 4)
((struct UserObject *)block4965)->data[1] = call5011;
// compiled block node returning block4965 (depth = 3)
  gc_frame_newslot(block4965);
// Begin line 1934
  setline(1934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block5012 = alloc_Block(NULL, NULL, "collectionsPrelude", 1934);
  gc_frame_newslot(block5012);
// method _apply
  block_savedest(block5012);
  Object closure5013 = createclosure(1, "_apply");
  setclosureframe(closure5013, stackframe);
  addtoclosure(closure5013, selfslot);
  struct UserObject *uo5013 = (struct UserObject*)block5012;
  uo5013->data[0] = (Object)closure5013;
  Method *meth_meth_collectionsPrelude__apply5013 = addmethod2pos(block5012, "_apply", &meth_collectionsPrelude__apply5013, 0);
  int argcv_meth_collectionsPrelude__apply5013[] = {1};
  meth_meth_collectionsPrelude__apply5013->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5013);
  meth_meth_collectionsPrelude__apply5013->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5013->definitionLine = 1896;
// compiled block node returning block5012 (depth = 3)
  gc_frame_newslot(block5012);
  params[0] = block4965;
  params[1] = block5012;
  Object matchres4964 = matchCase(*var_other, params, 2,NULL);
  gc_frame_end(frame4964);
// compiled matchcase node returning matchres4964 (depth = 2)
  gc_frame_end(frame);
  return matchres4964;
}
Object meth_collectionsPrelude_sorted5016(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sorted");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for sorted (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for sorted");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1938
  setline(1938);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5017 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5018 = callmethodflags(self, "reversed", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5017);
// compiled call node returning call5018 (depth = 3)
// compiled member node returning call5018 (depth = 2)
  gc_frame_end(frame);
  return call5018;
}
Object meth_collectionsPrelude_sortedBy5019(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sortedBy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method sortedBy");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for sortedBy (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for sortedBy");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1940
  setline(1940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5020 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_c (depth = 3)
  gc_frame_newslot(*var_c);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5021 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5022 = callmethodflags(self, "asList", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5021);
// compiled call node returning call5022 (depth = 4)
// compiled member node returning call5022 (depth = 3)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call5023 = callmethod(call5022, "sortBy",
    1, partcv, params);
  gc_frame_end(callframe5020);
// compiled call node returning call5023 (depth = 2)
  gc_frame_end(frame);
  return call5023;
}
Object meth_collectionsPrelude_keys5024(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keys");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for keys (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for keys");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1942
  setline(1942);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5026 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5027 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5026);
// compiled call node returning call5027 (depth = 4)
// compiled member node returning call5027 (depth = 3)
  int op_slot_right_5025 = gc_frame_newslot(call5027);
// starting to compile num node (depth = 3)
  Object num5029 = alloc_Float64(1);
// compiled num node returning num5029 (depth = 3)
  int op_slot_left_5025 = gc_frame_newslot(num5029);
  params[0] = call5027;
  partcv[0] = 1;
  Object opresult5030 = callmethod(num5029, "..", 1, partcv, params);
// compiled op node returning opresult5030 (depth = 2)
  gc_frame_end(frame);
  return opresult5030;
}
Object meth_collectionsPrelude_values5031(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "values");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for values (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for values");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1944
  setline(1944);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_asString5032(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lower = getfromclosure(closure, 0);
  Object *var_upper = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1947
  setline(1947);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit5034 == NULL) {
    strlit5034 = alloc_String("");
    gc_root(strlit5034);
  }
// compiled string node returning strlit5034 (depth = 3)
  int op_slot_right_5033 = gc_frame_newslot(strlit5034);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lower (depth = 4)
  int op_slot_right_5036 = gc_frame_newslot(*var_lower);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5039 == NULL) {
    strlit5039 = alloc_String(" downTo ");
    gc_root(strlit5039);
  }
// compiled string node returning strlit5039 (depth = 5)
  int op_slot_right_5038 = gc_frame_newslot(strlit5039);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_upper (depth = 6)
  int op_slot_right_5041 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 6)
  if (strlit5043 == NULL) {
    strlit5043 = alloc_String("range.from ");
    gc_root(strlit5043);
  }
// compiled string node returning strlit5043 (depth = 6)
  int op_slot_left_5041 = gc_frame_newslot(strlit5043);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5044 = callmethod(strlit5043, "++", 1, partcv, params);
// compiled op node returning opresult5044 (depth = 5)
  int op_slot_left_5038 = gc_frame_newslot(opresult5044);
  params[0] = strlit5039;
  partcv[0] = 1;
  Object opresult5045 = callmethod(opresult5044, "++", 1, partcv, params);
// compiled op node returning opresult5045 (depth = 4)
  int op_slot_left_5036 = gc_frame_newslot(opresult5045);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5046 = callmethod(opresult5045, "++", 1, partcv, params);
// compiled op node returning opresult5046 (depth = 3)
  int op_slot_left_5033 = gc_frame_newslot(opresult5046);
  params[0] = strlit5034;
  partcv[0] = 1;
  Object opresult5047 = callmethod(opresult5046, "++", 1, partcv, params);
// compiled op node returning opresult5047 (depth = 2)
  gc_frame_end(frame);
  return opresult5047;
}
Object meth_collectionsPrelude_asSequence5048(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asSequence");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asSequence (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asSequence");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1950
  setline(1950);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply5053(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___27 = &(stackframe->slots[0]);
  *var___27 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude__apply5065(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_lower = getfromclosure(closure, 0);
  Object *var_upper = getfromclosure(closure, 1);
  Object *var_RequestError = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___28 = &(stackframe->slots[0]);
  *var___28 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// Begin line 1852
  setline(1852);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5068 == NULL) {
    strlit5068 = alloc_String(") is not an integer");
    gc_root(strlit5068);
  }
// compiled string node returning strlit5068 (depth = 6)
  int op_slot_right_5067 = gc_frame_newslot(strlit5068);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lower (depth = 7)
  int op_slot_right_5070 = gc_frame_newslot(*var_lower);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5073 == NULL) {
    strlit5073 = alloc_String(")downTo(");
    gc_root(strlit5073);
  }
// compiled string node returning strlit5073 (depth = 8)
  int op_slot_right_5072 = gc_frame_newslot(strlit5073);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_upper (depth = 9)
  int op_slot_right_5075 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 9)
  if (strlit5077 == NULL) {
    strlit5077 = alloc_String(" in range.from(");
    gc_root(strlit5077);
  }
// compiled string node returning strlit5077 (depth = 9)
  int op_slot_left_5075 = gc_frame_newslot(strlit5077);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5078 = callmethod(strlit5077, "++", 1, partcv, params);
// compiled op node returning opresult5078 (depth = 8)
  int op_slot_left_5072 = gc_frame_newslot(opresult5078);
  params[0] = strlit5073;
  partcv[0] = 1;
  Object opresult5079 = callmethod(opresult5078, "++", 1, partcv, params);
// compiled op node returning opresult5079 (depth = 7)
  int op_slot_left_5070 = gc_frame_newslot(opresult5079);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5080 = callmethod(opresult5079, "++", 1, partcv, params);
// compiled op node returning opresult5080 (depth = 6)
  int op_slot_left_5067 = gc_frame_newslot(opresult5080);
  params[0] = strlit5068;
  partcv[0] = 1;
  Object opresult5081 = callmethod(opresult5080, "++", 1, partcv, params);
// compiled op node returning opresult5081 (depth = 5)
  int op_slot_right_5066 = gc_frame_newslot(opresult5081);
// Begin line 1851
  setline(1851);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5083 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5085 == NULL) {
    strlit5085 = alloc_String("");
    gc_root(strlit5085);
  }
// compiled string node returning strlit5085 (depth = 7)
  int op_slot_right_5084 = gc_frame_newslot(strlit5085);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_upper (depth = 8)
  int op_slot_right_5087 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 8)
  if (strlit5089 == NULL) {
    strlit5089 = alloc_String("upper bound ");
    gc_root(strlit5089);
  }
// compiled string node returning strlit5089 (depth = 8)
  int op_slot_left_5087 = gc_frame_newslot(strlit5089);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5090 = callmethod(strlit5089, "++", 1, partcv, params);
// compiled op node returning opresult5090 (depth = 7)
  int op_slot_left_5084 = gc_frame_newslot(opresult5090);
  params[0] = strlit5085;
  partcv[0] = 1;
  Object opresult5091 = callmethod(opresult5090, "++", 1, partcv, params);
// compiled op node returning opresult5091 (depth = 6)
  gc_frame_newslot(opresult5091);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_RequestError (depth = 6)
  params[0] = opresult5091;
  partcv[0] = 1;
  Object call5092 = callmethod(*var_RequestError, "raise",
    1, partcv, params);
  gc_frame_end(callframe5083);
// compiled call node returning call5092 (depth = 5)
  int op_slot_left_5066 = gc_frame_newslot(call5092);
  params[0] = opresult5081;
  partcv[0] = 1;
  Object opresult5093 = callmethod(call5092, "++", 1, partcv, params);
// compiled op node returning opresult5093 (depth = 4)
  gc_frame_end(frame);
  return opresult5093;
}
Object meth_collectionsPrelude__apply5133(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___29 = &(stackframe->slots[0]);
  *var___29 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude__apply5145(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_lower = getfromclosure(closure, 0);
  Object *var_upper = getfromclosure(closure, 1);
  Object *var_RequestError = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___30 = &(stackframe->slots[0]);
  *var___30 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// Begin line 1861
  setline(1861);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5148 == NULL) {
    strlit5148 = alloc_String(") is not an integer");
    gc_root(strlit5148);
  }
// compiled string node returning strlit5148 (depth = 6)
  int op_slot_right_5147 = gc_frame_newslot(strlit5148);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lower (depth = 7)
  int op_slot_right_5150 = gc_frame_newslot(*var_lower);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5153 == NULL) {
    strlit5153 = alloc_String(")downTo(");
    gc_root(strlit5153);
  }
// compiled string node returning strlit5153 (depth = 8)
  int op_slot_right_5152 = gc_frame_newslot(strlit5153);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_upper (depth = 9)
  int op_slot_right_5155 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 9)
  if (strlit5157 == NULL) {
    strlit5157 = alloc_String(" in range.from(");
    gc_root(strlit5157);
  }
// compiled string node returning strlit5157 (depth = 9)
  int op_slot_left_5155 = gc_frame_newslot(strlit5157);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5158 = callmethod(strlit5157, "++", 1, partcv, params);
// compiled op node returning opresult5158 (depth = 8)
  int op_slot_left_5152 = gc_frame_newslot(opresult5158);
  params[0] = strlit5153;
  partcv[0] = 1;
  Object opresult5159 = callmethod(opresult5158, "++", 1, partcv, params);
// compiled op node returning opresult5159 (depth = 7)
  int op_slot_left_5150 = gc_frame_newslot(opresult5159);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5160 = callmethod(opresult5159, "++", 1, partcv, params);
// compiled op node returning opresult5160 (depth = 6)
  int op_slot_left_5147 = gc_frame_newslot(opresult5160);
  params[0] = strlit5148;
  partcv[0] = 1;
  Object opresult5161 = callmethod(opresult5160, "++", 1, partcv, params);
// compiled op node returning opresult5161 (depth = 5)
  int op_slot_right_5146 = gc_frame_newslot(opresult5161);
// Begin line 1860
  setline(1860);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5163 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5165 == NULL) {
    strlit5165 = alloc_String("");
    gc_root(strlit5165);
  }
// compiled string node returning strlit5165 (depth = 7)
  int op_slot_right_5164 = gc_frame_newslot(strlit5165);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lower (depth = 8)
  int op_slot_right_5167 = gc_frame_newslot(*var_lower);
// starting to compile string node (depth = 8)
  if (strlit5169 == NULL) {
    strlit5169 = alloc_String("lower bound ");
    gc_root(strlit5169);
  }
// compiled string node returning strlit5169 (depth = 8)
  int op_slot_left_5167 = gc_frame_newslot(strlit5169);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5170 = callmethod(strlit5169, "++", 1, partcv, params);
// compiled op node returning opresult5170 (depth = 7)
  int op_slot_left_5164 = gc_frame_newslot(opresult5170);
  params[0] = strlit5165;
  partcv[0] = 1;
  Object opresult5171 = callmethod(opresult5170, "++", 1, partcv, params);
// compiled op node returning opresult5171 (depth = 6)
  gc_frame_newslot(opresult5171);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_RequestError (depth = 6)
  params[0] = opresult5171;
  partcv[0] = 1;
  Object call5172 = callmethod(*var_RequestError, "raise",
    1, partcv, params);
  gc_frame_end(callframe5163);
// compiled call node returning call5172 (depth = 5)
  int op_slot_left_5146 = gc_frame_newslot(call5172);
  params[0] = opresult5161;
  partcv[0] = 1;
  Object opresult5173 = callmethod(call5172, "++", 1, partcv, params);
// compiled op node returning opresult5173 (depth = 4)
  gc_frame_end(frame);
  return opresult5173;
}
Object meth_collectionsPrelude_from_40__41_downTo4726(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "from()downTo");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method from()downTo");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method from()downTo");
  Object params[2];
  int partcv[2];
  Object *var_Exhausted = getfromclosure(closure, 0);
  Object *var_BoundsError = getfromclosure(closure, 1);
  Object *var__prelude = getfromclosure(closure, 2);
  Object *var_Collection = getfromclosure(closure, 3);
  Object *var_indexable = getfromclosure(closure, 4);
  Object *var_Number = getfromclosure(closure, 5);
  Object *var_RequestError = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for from()downTo (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_upper = &(stackframe->slots[0]);
  *var_upper = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for from");
  Object *var_lower = &(stackframe->slots[1]);
  *var_lower = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for downTo");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4727 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4727 = alloc_userobj2(23,24, objclass4727);
  gc_frame_newslot(obj4727);
if (objclass4727 == NULL) {
  glfree(obj4727->class->name);
  obj4727->class->name = "obj4181.from()downTo";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4727, self, 0);
  addmethodreal(obj4727,"outer", &reader_collectionsPrelude_outer_4728);
  Object oldself4727 = self;
  struct StackFrameObject *oldstackframe4727 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4727);
  gc_frame_newslot((Object)stackframe);
  self = obj4727;
  Object *oldselfslot4727 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4727 = (*(struct UserObject *)self).data[0], lowerouter4727 = thisouter4727;
  if (inheritingObject4727) {
    struct UserObject *inho4727 = (struct UserObject *)inheritingObject4727;
    while (inho4727->super != GraceDefaultObject) inho4727 = (struct UserObject *)inho4727->super;
    inho4727->super = obj4727;
    self = inheritingObject4727;
    *selfslot = self;
    lowerouter4727 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4727;
  }
if (objclass4727 == NULL) {
  Method *reader4729 = addmethodrealflags(obj4727, "start",&reader_collectionsPrelude_start_4729, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader4729->definitionModule = modulename;
  reader4729->definitionLine = 1853;
}
adddatum2(obj4727, alloc_Undefined(), 1);
if (objclass4727 == NULL) {
  Method *reader4730 = addmethodrealflags(obj4727, "stop",&reader_collectionsPrelude_stop_4730, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader4730->definitionModule = modulename;
  reader4730->definitionLine = 1862;
}
adddatum2(obj4727, alloc_Undefined(), 2);
if (objclass4727 == NULL) {
  Method *reader4731 = addmethodrealflags(obj4727, "size",&reader_collectionsPrelude_size_4731, MFLAG_DEF);
  reader4731->definitionModule = modulename;
  reader4731->definitionLine = 1867;
}
adddatum2(obj4727, alloc_Undefined(), 3);
// method iterator
  block_savedest(obj4727);
  Object closure4732 = createclosure(1, "iterator");
  setclosureframe(closure4732, stackframe);
  addtoclosure(closure4732, var_Exhausted);
  struct UserObject *uo4732 = (struct UserObject*)obj4727;
  uo4732->data[4] = (Object)closure4732;
  Method *meth_meth_collectionsPrelude_iterator4732 = addmethod2pos(obj4727, "iterator", &meth_collectionsPrelude_iterator4732, 4);
  int argcv_meth_collectionsPrelude_iterator4732[] = {0};
  meth_meth_collectionsPrelude_iterator4732->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator4732);
  meth_meth_collectionsPrelude_iterator4732->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator4732->definitionLine = 1869;
  block_savedest(obj4727);
  Object closure4800 = createclosure(1, "iterator()object");
  setclosureframe(closure4800, stackframe);
  addtoclosure(closure4800, var_Exhausted);
  Method *meth_meth_collectionsPrelude_iterator4732_object = addmethod2pos(obj4727, "iterator()object", &meth_collectionsPrelude_iterator4732_object, 4);
  meth_meth_collectionsPrelude_iterator4732_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator4732_object->definitionLine = 1869;
// method at
  block_savedest(obj4727);
  Object closure4801 = createclosure(1, "at");
  setclosureframe(closure4801, stackframe);
  addtoclosure(closure4801, var_BoundsError);
  struct UserObject *uo4801 = (struct UserObject*)obj4727;
  uo4801->data[5] = (Object)closure4801;
  Method *meth_meth_collectionsPrelude_at4801 = addmethod2pos(obj4727, "at", &meth_collectionsPrelude_at4801, 5);
  int argcv_meth_collectionsPrelude_at4801[] = {1};
  meth_meth_collectionsPrelude_at4801->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at4801);
meth_meth_collectionsPrelude_at4801->type->types[0] = type_Number;
meth_meth_collectionsPrelude_at4801->type->names[0] = "ix";
  meth_meth_collectionsPrelude_at4801->definitionModule = modulename;
  meth_meth_collectionsPrelude_at4801->definitionLine = 1881;
// method contains
  block_savedest(obj4727);
  Object closure4855 = createclosure(1, "contains");
  setclosureframe(closure4855, stackframe);
  addtoclosure(closure4855, var__prelude);
  struct UserObject *uo4855 = (struct UserObject*)obj4727;
  uo4855->data[6] = (Object)closure4855;
  Method *meth_meth_collectionsPrelude_contains4855 = addmethod2pos(obj4727, "contains", &meth_collectionsPrelude_contains4855, 6);
  int argcv_meth_collectionsPrelude_contains4855[] = {1};
  meth_meth_collectionsPrelude_contains4855->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains4855);
  meth_meth_collectionsPrelude_contains4855->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains4855->definitionLine = 1890;
// method do
  struct UserObject *uo4897 = (struct UserObject*)obj4727;
  uo4897->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do4897 = addmethod2pos(obj4727, "do", &meth_collectionsPrelude_do4897, 7);
  int argcv_meth_collectionsPrelude_do4897[] = {1};
  meth_meth_collectionsPrelude_do4897->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do4897);
  meth_meth_collectionsPrelude_do4897->definitionModule = modulename;
  meth_meth_collectionsPrelude_do4897->definitionLine = 1899;
// method keysAndValuesDo
  struct UserObject *uo4920 = (struct UserObject*)obj4727;
  uo4920->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo4920 = addmethod2pos(obj4727, "keysAndValuesDo", &meth_collectionsPrelude_keysAndValuesDo4920, 8);
  int argcv_meth_collectionsPrelude_keysAndValuesDo4920[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo4920->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo4920);
  meth_meth_collectionsPrelude_keysAndValuesDo4920->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo4920->definitionLine = 1906;
// method reversed
  block_savedest(obj4727);
  Object closure4949 = createclosure(2, "reversed");
  setclosureframe(closure4949, stackframe);
  addtoclosure(closure4949, var_lower);
  addtoclosure(closure4949, var_upper);
  struct UserObject *uo4949 = (struct UserObject*)obj4727;
  uo4949->data[9] = (Object)closure4949;
  Method *meth_meth_collectionsPrelude_reversed4949 = addmethod2pos(obj4727, "reversed", &meth_collectionsPrelude_reversed4949, 9);
  int argcv_meth_collectionsPrelude_reversed4949[] = {0};
  meth_meth_collectionsPrelude_reversed4949->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reversed4949);
  meth_meth_collectionsPrelude_reversed4949->definitionModule = modulename;
  meth_meth_collectionsPrelude_reversed4949->definitionLine = 1915;
// method ++
  struct UserObject *uo4954 = (struct UserObject*)obj4727;
  uo4954->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43_4954 = addmethod2pos(obj4727, "++", &meth_collectionsPrelude__43__43_4954, 10);
  int argcv_meth_collectionsPrelude__43__43_4954[] = {1};
  meth_meth_collectionsPrelude__43__43_4954->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43_4954);
  meth_meth_collectionsPrelude__43__43_4954->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43_4954->definitionLine = 1918;
// method ==
  block_savedest(obj4727);
  Object closure4963 = createclosure(1, "==");
  setclosureframe(closure4963, stackframe);
  addtoclosure(closure4963, var_Collection);
  struct UserObject *uo4963 = (struct UserObject*)obj4727;
  uo4963->data[11] = (Object)closure4963;
  Method *meth_meth_collectionsPrelude__61__61_4963 = addmethod2pos(obj4727, "==", &meth_collectionsPrelude__61__61_4963, 11);
  int argcv_meth_collectionsPrelude__61__61_4963[] = {1};
  meth_meth_collectionsPrelude__61__61_4963->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61_4963);
  meth_meth_collectionsPrelude__61__61_4963->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61_4963->definitionLine = 1921;
// method sorted
  struct UserObject *uo5016 = (struct UserObject*)obj4727;
  uo5016->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted5016 = addmethod2pos(obj4727, "sorted", &meth_collectionsPrelude_sorted5016, 12);
  int argcv_meth_collectionsPrelude_sorted5016[] = {0};
  meth_meth_collectionsPrelude_sorted5016->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted5016);
  meth_meth_collectionsPrelude_sorted5016->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted5016->definitionLine = 1938;
// method sortedBy
  struct UserObject *uo5019 = (struct UserObject*)obj4727;
  uo5019->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy5019 = addmethod2pos(obj4727, "sortedBy", &meth_collectionsPrelude_sortedBy5019, 13);
  int argcv_meth_collectionsPrelude_sortedBy5019[] = {1};
  meth_meth_collectionsPrelude_sortedBy5019->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy5019);
  meth_meth_collectionsPrelude_sortedBy5019->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy5019->definitionLine = 1940;
// method keys
  struct UserObject *uo5024 = (struct UserObject*)obj4727;
  uo5024->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keys5024 = addmethod2pos(obj4727, "keys", &meth_collectionsPrelude_keys5024, 14);
  int argcv_meth_collectionsPrelude_keys5024[] = {0};
  meth_meth_collectionsPrelude_keys5024->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys5024);
  meth_meth_collectionsPrelude_keys5024->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys5024->definitionLine = 1942;
// method values
  struct UserObject *uo5031 = (struct UserObject*)obj4727;
  uo5031->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values5031 = addmethod2pos(obj4727, "values", &meth_collectionsPrelude_values5031, 15);
  int argcv_meth_collectionsPrelude_values5031[] = {0};
  meth_meth_collectionsPrelude_values5031->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values5031);
  meth_meth_collectionsPrelude_values5031->definitionModule = modulename;
  meth_meth_collectionsPrelude_values5031->definitionLine = 1944;
// method asString
  block_savedest(obj4727);
  Object closure5032 = createclosure(2, "asString");
  setclosureframe(closure5032, stackframe);
  addtoclosure(closure5032, var_lower);
  addtoclosure(closure5032, var_upper);
  struct UserObject *uo5032 = (struct UserObject*)obj4727;
  uo5032->data[16] = (Object)closure5032;
  Method *meth_meth_collectionsPrelude_asString5032 = addmethod2pos(obj4727, "asString", &meth_collectionsPrelude_asString5032, 16);
  int argcv_meth_collectionsPrelude_asString5032[] = {0};
  meth_meth_collectionsPrelude_asString5032->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString5032);
  meth_meth_collectionsPrelude_asString5032->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString5032->definitionLine = 1946;
// method asSequence
  struct UserObject *uo5048 = (struct UserObject*)obj4727;
  uo5048->data[17] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asSequence5048 = addmethod2pos(obj4727, "asSequence", &meth_collectionsPrelude_asSequence5048, 17);
  int argcv_meth_collectionsPrelude_asSequence5048[] = {0};
  meth_meth_collectionsPrelude_asSequence5048->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asSequence5048);
  meth_meth_collectionsPrelude_asSequence5048->definitionModule = modulename;
  meth_meth_collectionsPrelude_asSequence5048->definitionLine = 1949;
  sourceObject = obj4727;
// Begin line 1848
  setline(1848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5049 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indexable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5050 = callmethod(*var_indexable, "trait()object",
    2, partcv, params);
  gc_frame_end(callframe5049);
// compiled call node returning call5050 (depth = 2)
  struct UserObject *obj4727_uo = (struct UserObject *)obj4727;
  obj4727_uo->super = call5050;
  sourceObject = obj4727;
// Begin line 1849
  setline(1849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_upper (depth = 3)
  int frame5051 = gc_frame_new();
  gc_frame_newslot(*var_upper);
// Begin line 1850
  setline(1850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block5052 = alloc_Block(NULL, NULL, "collectionsPrelude", 1850);
  gc_frame_newslot(block5052);
// method _apply
  block_savedest(block5052);
  Object closure5053 = createclosure(1, "_apply");
  setclosureframe(closure5053, stackframe);
  addtoclosure(closure5053, selfslot);
  struct UserObject *uo5053 = (struct UserObject*)block5052;
  uo5053->data[0] = (Object)closure5053;
  Method *meth_meth_collectionsPrelude__apply5053 = addmethod2pos(block5052, "_apply", &meth_collectionsPrelude__apply5053, 0);
  int argcv_meth_collectionsPrelude__apply5053[] = {1};
  meth_meth_collectionsPrelude__apply5053->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5053);
meth_meth_collectionsPrelude__apply5053->type->types[0] = type_Number;
meth_meth_collectionsPrelude__apply5053->type->names[0] = "__27";
  meth_meth_collectionsPrelude__apply5053->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5053->definitionLine = 1942;
// Begin line 1781
  setline(1781);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5055 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe5056 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5057 == NULL) {
    strlit5057 = alloc_String("__27");
    gc_root(strlit5057);
  }
// compiled string node returning strlit5057 (depth = 6)
  gc_frame_newslot(strlit5057);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5058 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5059 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5058);
// compiled call node returning call5059 (depth = 7)
// compiled member node returning call5059 (depth = 6)
  params[0] = strlit5057;
  partcv[0] = 1;
  Object call5060 = callmethod(call5059, "new",
    1, partcv, params);
  gc_frame_end(callframe5056);
// compiled call node returning call5060 (depth = 5)
  gc_frame_newslot(call5060);
// Begin line 1850
  setline(1850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_Number (depth = 5)
  gc_frame_newslot(*var_Number);
// call case 6: other member request
// Begin line 1781
  setline(1781);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5061 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5062 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5061);
// compiled call node returning call5062 (depth = 6)
// compiled member node returning call5062 (depth = 5)
  params[0] = call5060;
  params[1] = *var_Number;
  partcv[0] = 2;
  Object call5063 = callmethod(call5062, "new",
    1, partcv, params);
  gc_frame_end(callframe5055);
// compiled call node returning call5063 (depth = 4)
((struct UserObject *)block5052)->data[1] = call5063;
// compiled block node returning block5052 (depth = 3)
  gc_frame_newslot(block5052);
// Begin line 1851
  setline(1851);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block5064 = alloc_Block(NULL, NULL, "collectionsPrelude", 1851);
  gc_frame_newslot(block5064);
// method _apply
  block_savedest(block5064);
  Object closure5065 = createclosure(4, "_apply");
  setclosureframe(closure5065, stackframe);
  addtoclosure(closure5065, var_lower);
  addtoclosure(closure5065, var_upper);
  addtoclosure(closure5065, var_RequestError);
  addtoclosure(closure5065, selfslot);
  struct UserObject *uo5065 = (struct UserObject*)block5064;
  uo5065->data[0] = (Object)closure5065;
  Method *meth_meth_collectionsPrelude__apply5065 = addmethod2pos(block5064, "_apply", &meth_collectionsPrelude__apply5065, 0);
  int argcv_meth_collectionsPrelude__apply5065[] = {1};
  meth_meth_collectionsPrelude__apply5065->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5065);
  meth_meth_collectionsPrelude__apply5065->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5065->definitionLine = 1781;
// compiled block node returning block5064 (depth = 3)
  gc_frame_newslot(block5064);
  params[0] = block5052;
  params[1] = block5064;
  Object matchres5051 = matchCase(*var_upper, params, 2,NULL);
  gc_frame_end(frame5051);
// compiled matchcase node returning matchres5051 (depth = 2)
  sourceObject = obj4727;
// Begin line 1853
  setline(1853);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5095 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_upper (depth = 4)
  partcv[0] = 0;
  Object call5096 = callmethod(*var_upper, "truncated",
    1, partcv, params);
  gc_frame_end(callframe5095);
// compiled call node returning call5096 (depth = 3)
// compiled member node returning call5096 (depth = 2)
  adddatum2(obj4727, call5096, 1);
  sourceObject = obj4727;
// Begin line 1854
  setline(1854);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_upper (depth = 4)
  int op_slot_right_5098 = gc_frame_newslot(*var_upper);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5100 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5101 = callmethodflags(self, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5100);
// compiled call node returning call5101 (depth = 5)
// compiled member node returning call5101 (depth = 4)
  int op_slot_left_5098 = gc_frame_newslot(call5101);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5102 = callmethod(call5101, "!=", 1, partcv, params);
// compiled op node returning opresult5102 (depth = 3)
  Object if5097 = done;
struct StackFrameObject *iftmpstackframe5097 = stackframe;
  if (istrue(opresult5102)) {
stackframe = alloc_StackFrame(0, iftmpstackframe5097);
gc_frame_newslot((Object)stackframe);
// Begin line 1855
  setline(1855);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// Begin line 1856
  setline(1856);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5105 == NULL) {
    strlit5105 = alloc_String(") is not an integer");
    gc_root(strlit5105);
  }
// compiled string node returning strlit5105 (depth = 5)
  int op_slot_right_5104 = gc_frame_newslot(strlit5105);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lower (depth = 6)
  int op_slot_right_5107 = gc_frame_newslot(*var_lower);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5110 == NULL) {
    strlit5110 = alloc_String(")downTo(");
    gc_root(strlit5110);
  }
// compiled string node returning strlit5110 (depth = 7)
  int op_slot_right_5109 = gc_frame_newslot(strlit5110);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_upper (depth = 8)
  int op_slot_right_5112 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 8)
  if (strlit5114 == NULL) {
    strlit5114 = alloc_String(" in range.from(");
    gc_root(strlit5114);
  }
// compiled string node returning strlit5114 (depth = 8)
  int op_slot_left_5112 = gc_frame_newslot(strlit5114);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5115 = callmethod(strlit5114, "++", 1, partcv, params);
// compiled op node returning opresult5115 (depth = 7)
  int op_slot_left_5109 = gc_frame_newslot(opresult5115);
  params[0] = strlit5110;
  partcv[0] = 1;
  Object opresult5116 = callmethod(opresult5115, "++", 1, partcv, params);
// compiled op node returning opresult5116 (depth = 6)
  int op_slot_left_5107 = gc_frame_newslot(opresult5116);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5117 = callmethod(opresult5116, "++", 1, partcv, params);
// compiled op node returning opresult5117 (depth = 5)
  int op_slot_left_5104 = gc_frame_newslot(opresult5117);
  params[0] = strlit5105;
  partcv[0] = 1;
  Object opresult5118 = callmethod(opresult5117, "++", 1, partcv, params);
// compiled op node returning opresult5118 (depth = 4)
  int op_slot_right_5103 = gc_frame_newslot(opresult5118);
// Begin line 1855
  setline(1855);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5120 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5122 == NULL) {
    strlit5122 = alloc_String("");
    gc_root(strlit5122);
  }
// compiled string node returning strlit5122 (depth = 6)
  int op_slot_right_5121 = gc_frame_newslot(strlit5122);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_upper (depth = 7)
  int op_slot_right_5124 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 7)
  if (strlit5126 == NULL) {
    strlit5126 = alloc_String("upper bound ");
    gc_root(strlit5126);
  }
// compiled string node returning strlit5126 (depth = 7)
  int op_slot_left_5124 = gc_frame_newslot(strlit5126);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5127 = callmethod(strlit5126, "++", 1, partcv, params);
// compiled op node returning opresult5127 (depth = 6)
  int op_slot_left_5121 = gc_frame_newslot(opresult5127);
  params[0] = strlit5122;
  partcv[0] = 1;
  Object opresult5128 = callmethod(opresult5127, "++", 1, partcv, params);
// compiled op node returning opresult5128 (depth = 5)
  gc_frame_newslot(opresult5128);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_RequestError (depth = 5)
  params[0] = opresult5128;
  partcv[0] = 1;
  Object call5129 = callmethod(*var_RequestError, "raise",
    1, partcv, params);
  gc_frame_end(callframe5120);
// compiled call node returning call5129 (depth = 4)
  int op_slot_left_5103 = gc_frame_newslot(call5129);
  params[0] = opresult5118;
  partcv[0] = 1;
  Object opresult5130 = callmethod(call5129, "++", 1, partcv, params);
// compiled op node returning opresult5130 (depth = 3)
    gc_frame_newslot(opresult5130);
    if5097 = opresult5130;
  } else {
  }
stackframe = iftmpstackframe5097;
// compiled if node returning if5097 (depth = 2)
  sourceObject = obj4727;
// Begin line 1858
  setline(1858);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lower (depth = 3)
  int frame5131 = gc_frame_new();
  gc_frame_newslot(*var_lower);
// Begin line 1859
  setline(1859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block5132 = alloc_Block(NULL, NULL, "collectionsPrelude", 1859);
  gc_frame_newslot(block5132);
// method _apply
  block_savedest(block5132);
  Object closure5133 = createclosure(1, "_apply");
  setclosureframe(closure5133, stackframe);
  addtoclosure(closure5133, selfslot);
  struct UserObject *uo5133 = (struct UserObject*)block5132;
  uo5133->data[0] = (Object)closure5133;
  Method *meth_meth_collectionsPrelude__apply5133 = addmethod2pos(block5132, "_apply", &meth_collectionsPrelude__apply5133, 0);
  int argcv_meth_collectionsPrelude__apply5133[] = {1};
  meth_meth_collectionsPrelude__apply5133->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5133);
meth_meth_collectionsPrelude__apply5133->type->types[0] = type_Number;
meth_meth_collectionsPrelude__apply5133->type->names[0] = "__29";
  meth_meth_collectionsPrelude__apply5133->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5133->definitionLine = 1854;
// Begin line 1781
  setline(1781);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5135 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe5136 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5137 == NULL) {
    strlit5137 = alloc_String("__29");
    gc_root(strlit5137);
  }
// compiled string node returning strlit5137 (depth = 6)
  gc_frame_newslot(strlit5137);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5138 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5139 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5138);
// compiled call node returning call5139 (depth = 7)
// compiled member node returning call5139 (depth = 6)
  params[0] = strlit5137;
  partcv[0] = 1;
  Object call5140 = callmethod(call5139, "new",
    1, partcv, params);
  gc_frame_end(callframe5136);
// compiled call node returning call5140 (depth = 5)
  gc_frame_newslot(call5140);
// Begin line 1859
  setline(1859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_Number (depth = 5)
  gc_frame_newslot(*var_Number);
// call case 6: other member request
// Begin line 1781
  setline(1781);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5141 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5142 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5141);
// compiled call node returning call5142 (depth = 6)
// compiled member node returning call5142 (depth = 5)
  params[0] = call5140;
  params[1] = *var_Number;
  partcv[0] = 2;
  Object call5143 = callmethod(call5142, "new",
    1, partcv, params);
  gc_frame_end(callframe5135);
// compiled call node returning call5143 (depth = 4)
((struct UserObject *)block5132)->data[1] = call5143;
// compiled block node returning block5132 (depth = 3)
  gc_frame_newslot(block5132);
// Begin line 1860
  setline(1860);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block5144 = alloc_Block(NULL, NULL, "collectionsPrelude", 1860);
  gc_frame_newslot(block5144);
// method _apply
  block_savedest(block5144);
  Object closure5145 = createclosure(4, "_apply");
  setclosureframe(closure5145, stackframe);
  addtoclosure(closure5145, var_lower);
  addtoclosure(closure5145, var_upper);
  addtoclosure(closure5145, var_RequestError);
  addtoclosure(closure5145, selfslot);
  struct UserObject *uo5145 = (struct UserObject*)block5144;
  uo5145->data[0] = (Object)closure5145;
  Method *meth_meth_collectionsPrelude__apply5145 = addmethod2pos(block5144, "_apply", &meth_collectionsPrelude__apply5145, 0);
  int argcv_meth_collectionsPrelude__apply5145[] = {1};
  meth_meth_collectionsPrelude__apply5145->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5145);
  meth_meth_collectionsPrelude__apply5145->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5145->definitionLine = 1781;
// compiled block node returning block5144 (depth = 3)
  gc_frame_newslot(block5144);
  params[0] = block5132;
  params[1] = block5144;
  Object matchres5131 = matchCase(*var_lower, params, 2,NULL);
  gc_frame_end(frame5131);
// compiled matchcase node returning matchres5131 (depth = 2)
  sourceObject = obj4727;
// Begin line 1862
  setline(1862);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5175 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lower (depth = 4)
  partcv[0] = 0;
  Object call5176 = callmethod(*var_lower, "truncated",
    1, partcv, params);
  gc_frame_end(callframe5175);
// compiled call node returning call5176 (depth = 3)
// compiled member node returning call5176 (depth = 2)
  adddatum2(obj4727, call5176, 2);
  sourceObject = obj4727;
// Begin line 1863
  setline(1863);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lower (depth = 4)
  int op_slot_right_5178 = gc_frame_newslot(*var_lower);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5180 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5181 = callmethodflags(self, "stop", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5180);
// compiled call node returning call5181 (depth = 5)
// compiled member node returning call5181 (depth = 4)
  int op_slot_left_5178 = gc_frame_newslot(call5181);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5182 = callmethod(call5181, "!=", 1, partcv, params);
// compiled op node returning opresult5182 (depth = 3)
  Object if5177 = done;
struct StackFrameObject *iftmpstackframe5177 = stackframe;
  if (istrue(opresult5182)) {
stackframe = alloc_StackFrame(0, iftmpstackframe5177);
gc_frame_newslot((Object)stackframe);
// Begin line 1864
  setline(1864);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// Begin line 1865
  setline(1865);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5185 == NULL) {
    strlit5185 = alloc_String(") is not an integer");
    gc_root(strlit5185);
  }
// compiled string node returning strlit5185 (depth = 5)
  int op_slot_right_5184 = gc_frame_newslot(strlit5185);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lower (depth = 6)
  int op_slot_right_5187 = gc_frame_newslot(*var_lower);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5190 == NULL) {
    strlit5190 = alloc_String(")downTo(");
    gc_root(strlit5190);
  }
// compiled string node returning strlit5190 (depth = 7)
  int op_slot_right_5189 = gc_frame_newslot(strlit5190);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_upper (depth = 8)
  int op_slot_right_5192 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 8)
  if (strlit5194 == NULL) {
    strlit5194 = alloc_String(" in range.from(");
    gc_root(strlit5194);
  }
// compiled string node returning strlit5194 (depth = 8)
  int op_slot_left_5192 = gc_frame_newslot(strlit5194);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5195 = callmethod(strlit5194, "++", 1, partcv, params);
// compiled op node returning opresult5195 (depth = 7)
  int op_slot_left_5189 = gc_frame_newslot(opresult5195);
  params[0] = strlit5190;
  partcv[0] = 1;
  Object opresult5196 = callmethod(opresult5195, "++", 1, partcv, params);
// compiled op node returning opresult5196 (depth = 6)
  int op_slot_left_5187 = gc_frame_newslot(opresult5196);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5197 = callmethod(opresult5196, "++", 1, partcv, params);
// compiled op node returning opresult5197 (depth = 5)
  int op_slot_left_5184 = gc_frame_newslot(opresult5197);
  params[0] = strlit5185;
  partcv[0] = 1;
  Object opresult5198 = callmethod(opresult5197, "++", 1, partcv, params);
// compiled op node returning opresult5198 (depth = 4)
  int op_slot_right_5183 = gc_frame_newslot(opresult5198);
// Begin line 1864
  setline(1864);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5200 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5202 == NULL) {
    strlit5202 = alloc_String("");
    gc_root(strlit5202);
  }
// compiled string node returning strlit5202 (depth = 6)
  int op_slot_right_5201 = gc_frame_newslot(strlit5202);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lower (depth = 7)
  int op_slot_right_5204 = gc_frame_newslot(*var_lower);
// starting to compile string node (depth = 7)
  if (strlit5206 == NULL) {
    strlit5206 = alloc_String("lower bound ");
    gc_root(strlit5206);
  }
// compiled string node returning strlit5206 (depth = 7)
  int op_slot_left_5204 = gc_frame_newslot(strlit5206);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5207 = callmethod(strlit5206, "++", 1, partcv, params);
// compiled op node returning opresult5207 (depth = 6)
  int op_slot_left_5201 = gc_frame_newslot(opresult5207);
  params[0] = strlit5202;
  partcv[0] = 1;
  Object opresult5208 = callmethod(opresult5207, "++", 1, partcv, params);
// compiled op node returning opresult5208 (depth = 5)
  gc_frame_newslot(opresult5208);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_RequestError (depth = 5)
  params[0] = opresult5208;
  partcv[0] = 1;
  Object call5209 = callmethod(*var_RequestError, "raise",
    1, partcv, params);
  gc_frame_end(callframe5200);
// compiled call node returning call5209 (depth = 4)
  int op_slot_left_5183 = gc_frame_newslot(call5209);
  params[0] = opresult5198;
  partcv[0] = 1;
  Object opresult5210 = callmethod(call5209, "++", 1, partcv, params);
// compiled op node returning opresult5210 (depth = 3)
    gc_frame_newslot(opresult5210);
    if5177 = opresult5210;
  } else {
  }
stackframe = iftmpstackframe5177;
// compiled if node returning if5177 (depth = 2)
  sourceObject = obj4727;
// Begin line 1868
  setline(1868);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5213 = alloc_Float64(0);
// compiled num node returning num5213 (depth = 4)
  int op_slot_right_5212 = gc_frame_newslot(num5213);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num5216 = alloc_Float64(1);
// compiled num node returning num5216 (depth = 5)
  int op_slot_right_5215 = gc_frame_newslot(num5216);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lower (depth = 6)
  int op_slot_right_5218 = gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_upper (depth = 6)
  int op_slot_left_5218 = gc_frame_newslot(*var_upper);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object diff5220 = callmethod(*var_upper, "-", 1, partcv, params);
// compiled op node returning diff5220 (depth = 5)
  int op_slot_left_5215 = gc_frame_newslot(diff5220);
  params[0] = num5216;
  partcv[0] = 1;
  Object sum5221 = callmethod(diff5220, "+", 1, partcv, params);
// compiled op node returning sum5221 (depth = 4)
  int op_slot_left_5212 = gc_frame_newslot(sum5221);
  params[0] = num5213;
  partcv[0] = 1;
  Object opresult5222 = callmethod(sum5221, "<", 1, partcv, params);
// compiled op node returning opresult5222 (depth = 3)
  Object if5211 = done;
struct StackFrameObject *iftmpstackframe5211 = stackframe;
  if (istrue(opresult5222)) {
stackframe = alloc_StackFrame(0, iftmpstackframe5211);
gc_frame_newslot((Object)stackframe);
// starting to compile num node (depth = 3)
  Object num5223 = alloc_Float64(0);
// compiled num node returning num5223 (depth = 3)
    gc_frame_newslot(num5223);
    if5211 = num5223;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe5211);
  gc_frame_newslot((Object)stackframe);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5225 = alloc_Float64(1);
// compiled num node returning num5225 (depth = 4)
  int op_slot_right_5224 = gc_frame_newslot(num5225);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lower (depth = 5)
  int op_slot_right_5227 = gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_upper (depth = 5)
  int op_slot_left_5227 = gc_frame_newslot(*var_upper);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object diff5229 = callmethod(*var_upper, "-", 1, partcv, params);
// compiled op node returning diff5229 (depth = 4)
  int op_slot_left_5224 = gc_frame_newslot(diff5229);
  params[0] = num5225;
  partcv[0] = 1;
  Object sum5230 = callmethod(diff5229, "+", 1, partcv, params);
// compiled op node returning sum5230 (depth = 3)
    gc_frame_newslot(sum5230);
    if5211 = sum5230;
  }
stackframe = iftmpstackframe5211;
// compiled if node returning if5211 (depth = 2)
  adddatum2(obj4727, if5211, 3);
  sourceObject = obj4727;
  sourceObject = obj4727;
  sourceObject = obj4727;
  sourceObject = obj4727;
  sourceObject = obj4727;
  sourceObject = obj4727;
  sourceObject = obj4727;
  sourceObject = obj4727;
  sourceObject = obj4727;
  sourceObject = obj4727;
  sourceObject = obj4727;
  sourceObject = obj4727;
  sourceObject = obj4727;
  sourceObject = obj4727;
  objclass4727 = obj4727->class;
  objclass4727->definitionModule = modulename;
  objclass4727->definitionLine = 1847;
  (*(struct UserObject *)self).data[0] = lowerouter4727;
  self = oldself4727;
  selfslot = oldselfslot4727;
  stackframe = oldstackframe4727;
  gc_frame_end(frame);
  return obj4727;
}
Object meth_collectionsPrelude_from_40__41_downTo4726_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "from()downTo()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0] + argcv[1]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method from()downTo()object");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method from()downTo()object");
  Object params[2];
  int partcv[2];
  Object *var_Exhausted = getfromclosure(closure, 0);
  Object *var_BoundsError = getfromclosure(closure, 1);
  Object *var__prelude = getfromclosure(closure, 2);
  Object *var_Collection = getfromclosure(closure, 3);
  Object *var_indexable = getfromclosure(closure, 4);
  Object *var_Number = getfromclosure(closure, 5);
  Object *var_RequestError = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for from()downTo (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_upper = &(stackframe->slots[0]);
  *var_upper = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for from");
  Object *var_lower = &(stackframe->slots[1]);
  *var_lower = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for downTo");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4727 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4727 = alloc_userobj2(23,24, objclass4727);
  gc_frame_newslot(obj4727);
if (objclass4727 == NULL) {
  glfree(obj4727->class->name);
  obj4727->class->name = "obj4181.from()downTo";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4727, self, 0);
  addmethodreal(obj4727,"outer", &reader_collectionsPrelude_outer_4728);
  Object oldself4727 = self;
  struct StackFrameObject *oldstackframe4727 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4727);
  gc_frame_newslot((Object)stackframe);
  self = obj4727;
  Object *oldselfslot4727 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4727 = (*(struct UserObject *)self).data[0], lowerouter4727 = thisouter4727;
  if (inheritingObject4727) {
    struct UserObject *inho4727 = (struct UserObject *)inheritingObject4727;
    while (inho4727->super != GraceDefaultObject) inho4727 = (struct UserObject *)inho4727->super;
    inho4727->super = obj4727;
    self = inheritingObject4727;
    *selfslot = self;
    lowerouter4727 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4727;
  }
if (objclass4727 == NULL) {
  Method *reader4729 = addmethodrealflags(obj4727, "start",&reader_collectionsPrelude_start_4729, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader4729->definitionModule = modulename;
  reader4729->definitionLine = 1853;
}
adddatum2(obj4727, alloc_Undefined(), 1);
if (objclass4727 == NULL) {
  Method *reader4730 = addmethodrealflags(obj4727, "stop",&reader_collectionsPrelude_stop_4730, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader4730->definitionModule = modulename;
  reader4730->definitionLine = 1862;
}
adddatum2(obj4727, alloc_Undefined(), 2);
if (objclass4727 == NULL) {
  Method *reader4731 = addmethodrealflags(obj4727, "size",&reader_collectionsPrelude_size_4731, MFLAG_DEF);
  reader4731->definitionModule = modulename;
  reader4731->definitionLine = 1867;
}
adddatum2(obj4727, alloc_Undefined(), 3);
// method iterator
  block_savedest(obj4727);
  Object closure4732 = createclosure(1, "iterator");
  setclosureframe(closure4732, stackframe);
  addtoclosure(closure4732, var_Exhausted);
  struct UserObject *uo4732 = (struct UserObject*)obj4727;
  uo4732->data[4] = (Object)closure4732;
  Method *meth_meth_collectionsPrelude_iterator4732 = addmethod2pos(obj4727, "iterator", &meth_collectionsPrelude_iterator4732, 4);
  int argcv_meth_collectionsPrelude_iterator4732[] = {0};
  meth_meth_collectionsPrelude_iterator4732->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator4732);
  meth_meth_collectionsPrelude_iterator4732->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator4732->definitionLine = 1869;
  block_savedest(obj4727);
  Object closure4800 = createclosure(1, "iterator()object");
  setclosureframe(closure4800, stackframe);
  addtoclosure(closure4800, var_Exhausted);
  Method *meth_meth_collectionsPrelude_iterator4732_object = addmethod2pos(obj4727, "iterator()object", &meth_collectionsPrelude_iterator4732_object, 4);
  meth_meth_collectionsPrelude_iterator4732_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator4732_object->definitionLine = 1869;
// method at
  block_savedest(obj4727);
  Object closure4801 = createclosure(1, "at");
  setclosureframe(closure4801, stackframe);
  addtoclosure(closure4801, var_BoundsError);
  struct UserObject *uo4801 = (struct UserObject*)obj4727;
  uo4801->data[5] = (Object)closure4801;
  Method *meth_meth_collectionsPrelude_at4801 = addmethod2pos(obj4727, "at", &meth_collectionsPrelude_at4801, 5);
  int argcv_meth_collectionsPrelude_at4801[] = {1};
  meth_meth_collectionsPrelude_at4801->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at4801);
meth_meth_collectionsPrelude_at4801->type->types[0] = type_Number;
meth_meth_collectionsPrelude_at4801->type->names[0] = "ix";
  meth_meth_collectionsPrelude_at4801->definitionModule = modulename;
  meth_meth_collectionsPrelude_at4801->definitionLine = 1881;
// method contains
  block_savedest(obj4727);
  Object closure4855 = createclosure(1, "contains");
  setclosureframe(closure4855, stackframe);
  addtoclosure(closure4855, var__prelude);
  struct UserObject *uo4855 = (struct UserObject*)obj4727;
  uo4855->data[6] = (Object)closure4855;
  Method *meth_meth_collectionsPrelude_contains4855 = addmethod2pos(obj4727, "contains", &meth_collectionsPrelude_contains4855, 6);
  int argcv_meth_collectionsPrelude_contains4855[] = {1};
  meth_meth_collectionsPrelude_contains4855->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains4855);
  meth_meth_collectionsPrelude_contains4855->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains4855->definitionLine = 1890;
// method do
  struct UserObject *uo4897 = (struct UserObject*)obj4727;
  uo4897->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do4897 = addmethod2pos(obj4727, "do", &meth_collectionsPrelude_do4897, 7);
  int argcv_meth_collectionsPrelude_do4897[] = {1};
  meth_meth_collectionsPrelude_do4897->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do4897);
  meth_meth_collectionsPrelude_do4897->definitionModule = modulename;
  meth_meth_collectionsPrelude_do4897->definitionLine = 1899;
// method keysAndValuesDo
  struct UserObject *uo4920 = (struct UserObject*)obj4727;
  uo4920->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo4920 = addmethod2pos(obj4727, "keysAndValuesDo", &meth_collectionsPrelude_keysAndValuesDo4920, 8);
  int argcv_meth_collectionsPrelude_keysAndValuesDo4920[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo4920->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo4920);
  meth_meth_collectionsPrelude_keysAndValuesDo4920->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo4920->definitionLine = 1906;
// method reversed
  block_savedest(obj4727);
  Object closure4949 = createclosure(2, "reversed");
  setclosureframe(closure4949, stackframe);
  addtoclosure(closure4949, var_lower);
  addtoclosure(closure4949, var_upper);
  struct UserObject *uo4949 = (struct UserObject*)obj4727;
  uo4949->data[9] = (Object)closure4949;
  Method *meth_meth_collectionsPrelude_reversed4949 = addmethod2pos(obj4727, "reversed", &meth_collectionsPrelude_reversed4949, 9);
  int argcv_meth_collectionsPrelude_reversed4949[] = {0};
  meth_meth_collectionsPrelude_reversed4949->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reversed4949);
  meth_meth_collectionsPrelude_reversed4949->definitionModule = modulename;
  meth_meth_collectionsPrelude_reversed4949->definitionLine = 1915;
// method ++
  struct UserObject *uo4954 = (struct UserObject*)obj4727;
  uo4954->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43_4954 = addmethod2pos(obj4727, "++", &meth_collectionsPrelude__43__43_4954, 10);
  int argcv_meth_collectionsPrelude__43__43_4954[] = {1};
  meth_meth_collectionsPrelude__43__43_4954->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43_4954);
  meth_meth_collectionsPrelude__43__43_4954->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43_4954->definitionLine = 1918;
// method ==
  block_savedest(obj4727);
  Object closure4963 = createclosure(1, "==");
  setclosureframe(closure4963, stackframe);
  addtoclosure(closure4963, var_Collection);
  struct UserObject *uo4963 = (struct UserObject*)obj4727;
  uo4963->data[11] = (Object)closure4963;
  Method *meth_meth_collectionsPrelude__61__61_4963 = addmethod2pos(obj4727, "==", &meth_collectionsPrelude__61__61_4963, 11);
  int argcv_meth_collectionsPrelude__61__61_4963[] = {1};
  meth_meth_collectionsPrelude__61__61_4963->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61_4963);
  meth_meth_collectionsPrelude__61__61_4963->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61_4963->definitionLine = 1921;
// method sorted
  struct UserObject *uo5016 = (struct UserObject*)obj4727;
  uo5016->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted5016 = addmethod2pos(obj4727, "sorted", &meth_collectionsPrelude_sorted5016, 12);
  int argcv_meth_collectionsPrelude_sorted5016[] = {0};
  meth_meth_collectionsPrelude_sorted5016->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted5016);
  meth_meth_collectionsPrelude_sorted5016->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted5016->definitionLine = 1938;
// method sortedBy
  struct UserObject *uo5019 = (struct UserObject*)obj4727;
  uo5019->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy5019 = addmethod2pos(obj4727, "sortedBy", &meth_collectionsPrelude_sortedBy5019, 13);
  int argcv_meth_collectionsPrelude_sortedBy5019[] = {1};
  meth_meth_collectionsPrelude_sortedBy5019->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy5019);
  meth_meth_collectionsPrelude_sortedBy5019->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy5019->definitionLine = 1940;
// method keys
  struct UserObject *uo5024 = (struct UserObject*)obj4727;
  uo5024->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keys5024 = addmethod2pos(obj4727, "keys", &meth_collectionsPrelude_keys5024, 14);
  int argcv_meth_collectionsPrelude_keys5024[] = {0};
  meth_meth_collectionsPrelude_keys5024->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys5024);
  meth_meth_collectionsPrelude_keys5024->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys5024->definitionLine = 1942;
// method values
  struct UserObject *uo5031 = (struct UserObject*)obj4727;
  uo5031->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values5031 = addmethod2pos(obj4727, "values", &meth_collectionsPrelude_values5031, 15);
  int argcv_meth_collectionsPrelude_values5031[] = {0};
  meth_meth_collectionsPrelude_values5031->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values5031);
  meth_meth_collectionsPrelude_values5031->definitionModule = modulename;
  meth_meth_collectionsPrelude_values5031->definitionLine = 1944;
// method asString
  block_savedest(obj4727);
  Object closure5032 = createclosure(2, "asString");
  setclosureframe(closure5032, stackframe);
  addtoclosure(closure5032, var_lower);
  addtoclosure(closure5032, var_upper);
  struct UserObject *uo5032 = (struct UserObject*)obj4727;
  uo5032->data[16] = (Object)closure5032;
  Method *meth_meth_collectionsPrelude_asString5032 = addmethod2pos(obj4727, "asString", &meth_collectionsPrelude_asString5032, 16);
  int argcv_meth_collectionsPrelude_asString5032[] = {0};
  meth_meth_collectionsPrelude_asString5032->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString5032);
  meth_meth_collectionsPrelude_asString5032->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString5032->definitionLine = 1946;
// method asSequence
  struct UserObject *uo5048 = (struct UserObject*)obj4727;
  uo5048->data[17] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asSequence5048 = addmethod2pos(obj4727, "asSequence", &meth_collectionsPrelude_asSequence5048, 17);
  int argcv_meth_collectionsPrelude_asSequence5048[] = {0};
  meth_meth_collectionsPrelude_asSequence5048->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asSequence5048);
  meth_meth_collectionsPrelude_asSequence5048->definitionModule = modulename;
  meth_meth_collectionsPrelude_asSequence5048->definitionLine = 1949;
  sourceObject = obj4727;
// Begin line 1848
  setline(1848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5049 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indexable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5050 = callmethod(*var_indexable, "trait()object",
    2, partcv, params);
  gc_frame_end(callframe5049);
// compiled call node returning call5050 (depth = 2)
  struct UserObject *obj4727_uo = (struct UserObject *)obj4727;
  obj4727_uo->super = call5050;
  sourceObject = obj4727;
// Begin line 1849
  setline(1849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_upper (depth = 3)
  int frame5051 = gc_frame_new();
  gc_frame_newslot(*var_upper);
// Begin line 1850
  setline(1850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block5052 = alloc_Block(NULL, NULL, "collectionsPrelude", 1850);
  gc_frame_newslot(block5052);
// method _apply
  block_savedest(block5052);
  Object closure5053 = createclosure(1, "_apply");
  setclosureframe(closure5053, stackframe);
  addtoclosure(closure5053, selfslot);
  struct UserObject *uo5053 = (struct UserObject*)block5052;
  uo5053->data[0] = (Object)closure5053;
  Method *meth_meth_collectionsPrelude__apply5053 = addmethod2pos(block5052, "_apply", &meth_collectionsPrelude__apply5053, 0);
  int argcv_meth_collectionsPrelude__apply5053[] = {1};
  meth_meth_collectionsPrelude__apply5053->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5053);
meth_meth_collectionsPrelude__apply5053->type->types[0] = type_Number;
meth_meth_collectionsPrelude__apply5053->type->names[0] = "__27";
  meth_meth_collectionsPrelude__apply5053->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5053->definitionLine = 1942;
// Begin line 1781
  setline(1781);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5055 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe5056 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5057 == NULL) {
    strlit5057 = alloc_String("__27");
    gc_root(strlit5057);
  }
// compiled string node returning strlit5057 (depth = 6)
  gc_frame_newslot(strlit5057);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5058 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5059 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5058);
// compiled call node returning call5059 (depth = 7)
// compiled member node returning call5059 (depth = 6)
  params[0] = strlit5057;
  partcv[0] = 1;
  Object call5060 = callmethod(call5059, "new",
    1, partcv, params);
  gc_frame_end(callframe5056);
// compiled call node returning call5060 (depth = 5)
  gc_frame_newslot(call5060);
// Begin line 1850
  setline(1850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_Number (depth = 5)
  gc_frame_newslot(*var_Number);
// call case 6: other member request
// Begin line 1781
  setline(1781);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5061 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5062 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5061);
// compiled call node returning call5062 (depth = 6)
// compiled member node returning call5062 (depth = 5)
  params[0] = call5060;
  params[1] = *var_Number;
  partcv[0] = 2;
  Object call5063 = callmethod(call5062, "new",
    1, partcv, params);
  gc_frame_end(callframe5055);
// compiled call node returning call5063 (depth = 4)
((struct UserObject *)block5052)->data[1] = call5063;
// compiled block node returning block5052 (depth = 3)
  gc_frame_newslot(block5052);
// Begin line 1851
  setline(1851);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block5064 = alloc_Block(NULL, NULL, "collectionsPrelude", 1851);
  gc_frame_newslot(block5064);
// method _apply
  block_savedest(block5064);
  Object closure5065 = createclosure(4, "_apply");
  setclosureframe(closure5065, stackframe);
  addtoclosure(closure5065, var_lower);
  addtoclosure(closure5065, var_upper);
  addtoclosure(closure5065, var_RequestError);
  addtoclosure(closure5065, selfslot);
  struct UserObject *uo5065 = (struct UserObject*)block5064;
  uo5065->data[0] = (Object)closure5065;
  Method *meth_meth_collectionsPrelude__apply5065 = addmethod2pos(block5064, "_apply", &meth_collectionsPrelude__apply5065, 0);
  int argcv_meth_collectionsPrelude__apply5065[] = {1};
  meth_meth_collectionsPrelude__apply5065->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5065);
  meth_meth_collectionsPrelude__apply5065->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5065->definitionLine = 1781;
// compiled block node returning block5064 (depth = 3)
  gc_frame_newslot(block5064);
  params[0] = block5052;
  params[1] = block5064;
  Object matchres5051 = matchCase(*var_upper, params, 2,NULL);
  gc_frame_end(frame5051);
// compiled matchcase node returning matchres5051 (depth = 2)
  sourceObject = obj4727;
// Begin line 1853
  setline(1853);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5095 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_upper (depth = 4)
  partcv[0] = 0;
  Object call5096 = callmethod(*var_upper, "truncated",
    1, partcv, params);
  gc_frame_end(callframe5095);
// compiled call node returning call5096 (depth = 3)
// compiled member node returning call5096 (depth = 2)
  adddatum2(obj4727, call5096, 1);
  sourceObject = obj4727;
// Begin line 1854
  setline(1854);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_upper (depth = 4)
  int op_slot_right_5098 = gc_frame_newslot(*var_upper);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5100 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5101 = callmethodflags(self, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5100);
// compiled call node returning call5101 (depth = 5)
// compiled member node returning call5101 (depth = 4)
  int op_slot_left_5098 = gc_frame_newslot(call5101);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5102 = callmethod(call5101, "!=", 1, partcv, params);
// compiled op node returning opresult5102 (depth = 3)
  Object if5097 = done;
struct StackFrameObject *iftmpstackframe5097 = stackframe;
  if (istrue(opresult5102)) {
stackframe = alloc_StackFrame(0, iftmpstackframe5097);
gc_frame_newslot((Object)stackframe);
// Begin line 1855
  setline(1855);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// Begin line 1856
  setline(1856);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5105 == NULL) {
    strlit5105 = alloc_String(") is not an integer");
    gc_root(strlit5105);
  }
// compiled string node returning strlit5105 (depth = 5)
  int op_slot_right_5104 = gc_frame_newslot(strlit5105);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lower (depth = 6)
  int op_slot_right_5107 = gc_frame_newslot(*var_lower);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5110 == NULL) {
    strlit5110 = alloc_String(")downTo(");
    gc_root(strlit5110);
  }
// compiled string node returning strlit5110 (depth = 7)
  int op_slot_right_5109 = gc_frame_newslot(strlit5110);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_upper (depth = 8)
  int op_slot_right_5112 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 8)
  if (strlit5114 == NULL) {
    strlit5114 = alloc_String(" in range.from(");
    gc_root(strlit5114);
  }
// compiled string node returning strlit5114 (depth = 8)
  int op_slot_left_5112 = gc_frame_newslot(strlit5114);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5115 = callmethod(strlit5114, "++", 1, partcv, params);
// compiled op node returning opresult5115 (depth = 7)
  int op_slot_left_5109 = gc_frame_newslot(opresult5115);
  params[0] = strlit5110;
  partcv[0] = 1;
  Object opresult5116 = callmethod(opresult5115, "++", 1, partcv, params);
// compiled op node returning opresult5116 (depth = 6)
  int op_slot_left_5107 = gc_frame_newslot(opresult5116);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5117 = callmethod(opresult5116, "++", 1, partcv, params);
// compiled op node returning opresult5117 (depth = 5)
  int op_slot_left_5104 = gc_frame_newslot(opresult5117);
  params[0] = strlit5105;
  partcv[0] = 1;
  Object opresult5118 = callmethod(opresult5117, "++", 1, partcv, params);
// compiled op node returning opresult5118 (depth = 4)
  int op_slot_right_5103 = gc_frame_newslot(opresult5118);
// Begin line 1855
  setline(1855);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5120 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5122 == NULL) {
    strlit5122 = alloc_String("");
    gc_root(strlit5122);
  }
// compiled string node returning strlit5122 (depth = 6)
  int op_slot_right_5121 = gc_frame_newslot(strlit5122);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_upper (depth = 7)
  int op_slot_right_5124 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 7)
  if (strlit5126 == NULL) {
    strlit5126 = alloc_String("upper bound ");
    gc_root(strlit5126);
  }
// compiled string node returning strlit5126 (depth = 7)
  int op_slot_left_5124 = gc_frame_newslot(strlit5126);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5127 = callmethod(strlit5126, "++", 1, partcv, params);
// compiled op node returning opresult5127 (depth = 6)
  int op_slot_left_5121 = gc_frame_newslot(opresult5127);
  params[0] = strlit5122;
  partcv[0] = 1;
  Object opresult5128 = callmethod(opresult5127, "++", 1, partcv, params);
// compiled op node returning opresult5128 (depth = 5)
  gc_frame_newslot(opresult5128);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_RequestError (depth = 5)
  params[0] = opresult5128;
  partcv[0] = 1;
  Object call5129 = callmethod(*var_RequestError, "raise",
    1, partcv, params);
  gc_frame_end(callframe5120);
// compiled call node returning call5129 (depth = 4)
  int op_slot_left_5103 = gc_frame_newslot(call5129);
  params[0] = opresult5118;
  partcv[0] = 1;
  Object opresult5130 = callmethod(call5129, "++", 1, partcv, params);
// compiled op node returning opresult5130 (depth = 3)
    gc_frame_newslot(opresult5130);
    if5097 = opresult5130;
  } else {
  }
stackframe = iftmpstackframe5097;
// compiled if node returning if5097 (depth = 2)
  sourceObject = obj4727;
// Begin line 1858
  setline(1858);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lower (depth = 3)
  int frame5131 = gc_frame_new();
  gc_frame_newslot(*var_lower);
// Begin line 1859
  setline(1859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block5132 = alloc_Block(NULL, NULL, "collectionsPrelude", 1859);
  gc_frame_newslot(block5132);
// method _apply
  block_savedest(block5132);
  Object closure5133 = createclosure(1, "_apply");
  setclosureframe(closure5133, stackframe);
  addtoclosure(closure5133, selfslot);
  struct UserObject *uo5133 = (struct UserObject*)block5132;
  uo5133->data[0] = (Object)closure5133;
  Method *meth_meth_collectionsPrelude__apply5133 = addmethod2pos(block5132, "_apply", &meth_collectionsPrelude__apply5133, 0);
  int argcv_meth_collectionsPrelude__apply5133[] = {1};
  meth_meth_collectionsPrelude__apply5133->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5133);
meth_meth_collectionsPrelude__apply5133->type->types[0] = type_Number;
meth_meth_collectionsPrelude__apply5133->type->names[0] = "__29";
  meth_meth_collectionsPrelude__apply5133->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5133->definitionLine = 1854;
// Begin line 1781
  setline(1781);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5135 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe5136 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5137 == NULL) {
    strlit5137 = alloc_String("__29");
    gc_root(strlit5137);
  }
// compiled string node returning strlit5137 (depth = 6)
  gc_frame_newslot(strlit5137);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5138 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5139 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5138);
// compiled call node returning call5139 (depth = 7)
// compiled member node returning call5139 (depth = 6)
  params[0] = strlit5137;
  partcv[0] = 1;
  Object call5140 = callmethod(call5139, "new",
    1, partcv, params);
  gc_frame_end(callframe5136);
// compiled call node returning call5140 (depth = 5)
  gc_frame_newslot(call5140);
// Begin line 1859
  setline(1859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_Number (depth = 5)
  gc_frame_newslot(*var_Number);
// call case 6: other member request
// Begin line 1781
  setline(1781);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5141 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5142 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5141);
// compiled call node returning call5142 (depth = 6)
// compiled member node returning call5142 (depth = 5)
  params[0] = call5140;
  params[1] = *var_Number;
  partcv[0] = 2;
  Object call5143 = callmethod(call5142, "new",
    1, partcv, params);
  gc_frame_end(callframe5135);
// compiled call node returning call5143 (depth = 4)
((struct UserObject *)block5132)->data[1] = call5143;
// compiled block node returning block5132 (depth = 3)
  gc_frame_newslot(block5132);
// Begin line 1860
  setline(1860);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block5144 = alloc_Block(NULL, NULL, "collectionsPrelude", 1860);
  gc_frame_newslot(block5144);
// method _apply
  block_savedest(block5144);
  Object closure5145 = createclosure(4, "_apply");
  setclosureframe(closure5145, stackframe);
  addtoclosure(closure5145, var_lower);
  addtoclosure(closure5145, var_upper);
  addtoclosure(closure5145, var_RequestError);
  addtoclosure(closure5145, selfslot);
  struct UserObject *uo5145 = (struct UserObject*)block5144;
  uo5145->data[0] = (Object)closure5145;
  Method *meth_meth_collectionsPrelude__apply5145 = addmethod2pos(block5144, "_apply", &meth_collectionsPrelude__apply5145, 0);
  int argcv_meth_collectionsPrelude__apply5145[] = {1};
  meth_meth_collectionsPrelude__apply5145->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5145);
  meth_meth_collectionsPrelude__apply5145->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5145->definitionLine = 1781;
// compiled block node returning block5144 (depth = 3)
  gc_frame_newslot(block5144);
  params[0] = block5132;
  params[1] = block5144;
  Object matchres5131 = matchCase(*var_lower, params, 2,NULL);
  gc_frame_end(frame5131);
// compiled matchcase node returning matchres5131 (depth = 2)
  sourceObject = obj4727;
// Begin line 1862
  setline(1862);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5175 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lower (depth = 4)
  partcv[0] = 0;
  Object call5176 = callmethod(*var_lower, "truncated",
    1, partcv, params);
  gc_frame_end(callframe5175);
// compiled call node returning call5176 (depth = 3)
// compiled member node returning call5176 (depth = 2)
  adddatum2(obj4727, call5176, 2);
  sourceObject = obj4727;
// Begin line 1863
  setline(1863);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lower (depth = 4)
  int op_slot_right_5178 = gc_frame_newslot(*var_lower);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5180 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5181 = callmethodflags(self, "stop", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5180);
// compiled call node returning call5181 (depth = 5)
// compiled member node returning call5181 (depth = 4)
  int op_slot_left_5178 = gc_frame_newslot(call5181);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5182 = callmethod(call5181, "!=", 1, partcv, params);
// compiled op node returning opresult5182 (depth = 3)
  Object if5177 = done;
struct StackFrameObject *iftmpstackframe5177 = stackframe;
  if (istrue(opresult5182)) {
stackframe = alloc_StackFrame(0, iftmpstackframe5177);
gc_frame_newslot((Object)stackframe);
// Begin line 1864
  setline(1864);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// Begin line 1865
  setline(1865);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5185 == NULL) {
    strlit5185 = alloc_String(") is not an integer");
    gc_root(strlit5185);
  }
// compiled string node returning strlit5185 (depth = 5)
  int op_slot_right_5184 = gc_frame_newslot(strlit5185);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lower (depth = 6)
  int op_slot_right_5187 = gc_frame_newslot(*var_lower);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5190 == NULL) {
    strlit5190 = alloc_String(")downTo(");
    gc_root(strlit5190);
  }
// compiled string node returning strlit5190 (depth = 7)
  int op_slot_right_5189 = gc_frame_newslot(strlit5190);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_upper (depth = 8)
  int op_slot_right_5192 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 8)
  if (strlit5194 == NULL) {
    strlit5194 = alloc_String(" in range.from(");
    gc_root(strlit5194);
  }
// compiled string node returning strlit5194 (depth = 8)
  int op_slot_left_5192 = gc_frame_newslot(strlit5194);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5195 = callmethod(strlit5194, "++", 1, partcv, params);
// compiled op node returning opresult5195 (depth = 7)
  int op_slot_left_5189 = gc_frame_newslot(opresult5195);
  params[0] = strlit5190;
  partcv[0] = 1;
  Object opresult5196 = callmethod(opresult5195, "++", 1, partcv, params);
// compiled op node returning opresult5196 (depth = 6)
  int op_slot_left_5187 = gc_frame_newslot(opresult5196);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5197 = callmethod(opresult5196, "++", 1, partcv, params);
// compiled op node returning opresult5197 (depth = 5)
  int op_slot_left_5184 = gc_frame_newslot(opresult5197);
  params[0] = strlit5185;
  partcv[0] = 1;
  Object opresult5198 = callmethod(opresult5197, "++", 1, partcv, params);
// compiled op node returning opresult5198 (depth = 4)
  int op_slot_right_5183 = gc_frame_newslot(opresult5198);
// Begin line 1864
  setline(1864);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5200 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5202 == NULL) {
    strlit5202 = alloc_String("");
    gc_root(strlit5202);
  }
// compiled string node returning strlit5202 (depth = 6)
  int op_slot_right_5201 = gc_frame_newslot(strlit5202);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lower (depth = 7)
  int op_slot_right_5204 = gc_frame_newslot(*var_lower);
// starting to compile string node (depth = 7)
  if (strlit5206 == NULL) {
    strlit5206 = alloc_String("lower bound ");
    gc_root(strlit5206);
  }
// compiled string node returning strlit5206 (depth = 7)
  int op_slot_left_5204 = gc_frame_newslot(strlit5206);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5207 = callmethod(strlit5206, "++", 1, partcv, params);
// compiled op node returning opresult5207 (depth = 6)
  int op_slot_left_5201 = gc_frame_newslot(opresult5207);
  params[0] = strlit5202;
  partcv[0] = 1;
  Object opresult5208 = callmethod(opresult5207, "++", 1, partcv, params);
// compiled op node returning opresult5208 (depth = 5)
  gc_frame_newslot(opresult5208);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_RequestError (depth = 5)
  params[0] = opresult5208;
  partcv[0] = 1;
  Object call5209 = callmethod(*var_RequestError, "raise",
    1, partcv, params);
  gc_frame_end(callframe5200);
// compiled call node returning call5209 (depth = 4)
  int op_slot_left_5183 = gc_frame_newslot(call5209);
  params[0] = opresult5198;
  partcv[0] = 1;
  Object opresult5210 = callmethod(call5209, "++", 1, partcv, params);
// compiled op node returning opresult5210 (depth = 3)
    gc_frame_newslot(opresult5210);
    if5177 = opresult5210;
  } else {
  }
stackframe = iftmpstackframe5177;
// compiled if node returning if5177 (depth = 2)
  sourceObject = obj4727;
// Begin line 1868
  setline(1868);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5213 = alloc_Float64(0);
// compiled num node returning num5213 (depth = 4)
  int op_slot_right_5212 = gc_frame_newslot(num5213);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num5216 = alloc_Float64(1);
// compiled num node returning num5216 (depth = 5)
  int op_slot_right_5215 = gc_frame_newslot(num5216);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lower (depth = 6)
  int op_slot_right_5218 = gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_upper (depth = 6)
  int op_slot_left_5218 = gc_frame_newslot(*var_upper);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object diff5220 = callmethod(*var_upper, "-", 1, partcv, params);
// compiled op node returning diff5220 (depth = 5)
  int op_slot_left_5215 = gc_frame_newslot(diff5220);
  params[0] = num5216;
  partcv[0] = 1;
  Object sum5221 = callmethod(diff5220, "+", 1, partcv, params);
// compiled op node returning sum5221 (depth = 4)
  int op_slot_left_5212 = gc_frame_newslot(sum5221);
  params[0] = num5213;
  partcv[0] = 1;
  Object opresult5222 = callmethod(sum5221, "<", 1, partcv, params);
// compiled op node returning opresult5222 (depth = 3)
  Object if5211 = done;
struct StackFrameObject *iftmpstackframe5211 = stackframe;
  if (istrue(opresult5222)) {
stackframe = alloc_StackFrame(0, iftmpstackframe5211);
gc_frame_newslot((Object)stackframe);
// starting to compile num node (depth = 3)
  Object num5223 = alloc_Float64(0);
// compiled num node returning num5223 (depth = 3)
    gc_frame_newslot(num5223);
    if5211 = num5223;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe5211);
  gc_frame_newslot((Object)stackframe);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5225 = alloc_Float64(1);
// compiled num node returning num5225 (depth = 4)
  int op_slot_right_5224 = gc_frame_newslot(num5225);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lower (depth = 5)
  int op_slot_right_5227 = gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_upper (depth = 5)
  int op_slot_left_5227 = gc_frame_newslot(*var_upper);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object diff5229 = callmethod(*var_upper, "-", 1, partcv, params);
// compiled op node returning diff5229 (depth = 4)
  int op_slot_left_5224 = gc_frame_newslot(diff5229);
  params[0] = num5225;
  partcv[0] = 1;
  Object sum5230 = callmethod(diff5229, "+", 1, partcv, params);
// compiled op node returning sum5230 (depth = 3)
    gc_frame_newslot(sum5230);
    if5211 = sum5230;
  }
stackframe = iftmpstackframe5211;
// compiled if node returning if5211 (depth = 2)
  adddatum2(obj4727, if5211, 3);
  sourceObject = obj4727;
  sourceObject = obj4727;
  sourceObject = obj4727;
  sourceObject = obj4727;
  sourceObject = obj4727;
  sourceObject = obj4727;
  sourceObject = obj4727;
  sourceObject = obj4727;
  sourceObject = obj4727;
  sourceObject = obj4727;
  sourceObject = obj4727;
  sourceObject = obj4727;
  sourceObject = obj4727;
  sourceObject = obj4727;
  objclass4727 = obj4727->class;
  objclass4727->definitionModule = modulename;
  objclass4727->definitionLine = 1847;
  (*(struct UserObject *)self).data[0] = lowerouter4727;
  self = oldself4727;
  selfslot = oldselfslot4727;
  stackframe = oldstackframe4727;
  gc_frame_end(frame);
  return obj4727;
}
Object meth_collectionsPrelude_range4180(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "range");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Exhausted = getfromclosure(closure, 0);
  Object *var_BoundsError = getfromclosure(closure, 1);
  Object *var__prelude = getfromclosure(closure, 2);
  Object *var_Collection = getfromclosure(closure, 3);
  Object *var_indexable = getfromclosure(closure, 4);
  Object *var_Number = getfromclosure(closure, 5);
  Object *var_RequestError = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for range (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for range");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4181 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4181 = alloc_userobj2(4,5, objclass4181);
  gc_frame_newslot(obj4181);
if (objclass4181 == NULL) {
  glfree(obj4181->class->name);
  obj4181->class->name = "self.range";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4181, self, 0);
  addmethodreal(obj4181,"outer", &reader_collectionsPrelude_outer_4182);
  Object oldself4181 = self;
  struct StackFrameObject *oldstackframe4181 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4181);
  gc_frame_newslot((Object)stackframe);
  self = obj4181;
  Object *oldselfslot4181 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4181 = (*(struct UserObject *)self).data[0], lowerouter4181 = thisouter4181;
  if (inheritingObject4181) {
    struct UserObject *inho4181 = (struct UserObject *)inheritingObject4181;
    while (inho4181->super != GraceDefaultObject) inho4181 = (struct UserObject *)inho4181->super;
    inho4181->super = obj4181;
    self = inheritingObject4181;
    *selfslot = self;
    lowerouter4181 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4181;
  }
// method from()to
  block_savedest(obj4181);
  Object closure4183 = createclosure(7, "from()to");
  setclosureframe(closure4183, stackframe);
  addtoclosure(closure4183, var_Exhausted);
  addtoclosure(closure4183, var_BoundsError);
  addtoclosure(closure4183, var__prelude);
  addtoclosure(closure4183, var_Collection);
  addtoclosure(closure4183, var_indexable);
  addtoclosure(closure4183, var_Number);
  addtoclosure(closure4183, var_RequestError);
  struct UserObject *uo4183 = (struct UserObject*)obj4181;
  uo4183->data[1] = (Object)closure4183;
  Method *meth_meth_collectionsPrelude_from_40__41_to4183 = addmethod2pos(obj4181, "from()to", &meth_collectionsPrelude_from_40__41_to4183, 1);
  int argcv_meth_collectionsPrelude_from_40__41_to4183[] = {1, 1};
  meth_meth_collectionsPrelude_from_40__41_to4183->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_from_40__41_to4183);
  meth_meth_collectionsPrelude_from_40__41_to4183->definitionModule = modulename;
  meth_meth_collectionsPrelude_from_40__41_to4183->definitionLine = 1725;
  block_savedest(obj4181);
  Object closure4725 = createclosure(7, "from()to()object");
  setclosureframe(closure4725, stackframe);
  addtoclosure(closure4725, var_Exhausted);
  addtoclosure(closure4725, var_BoundsError);
  addtoclosure(closure4725, var__prelude);
  addtoclosure(closure4725, var_Collection);
  addtoclosure(closure4725, var_indexable);
  addtoclosure(closure4725, var_Number);
  addtoclosure(closure4725, var_RequestError);
  Method *meth_meth_collectionsPrelude_from_40__41_to4183_object = addmethod2pos(obj4181, "from()to()object", &meth_collectionsPrelude_from_40__41_to4183_object, 1);
  meth_meth_collectionsPrelude_from_40__41_to4183_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_from_40__41_to4183_object->definitionLine = 1725;
// method from()downTo
  block_savedest(obj4181);
  Object closure4726 = createclosure(7, "from()downTo");
  setclosureframe(closure4726, stackframe);
  addtoclosure(closure4726, var_Exhausted);
  addtoclosure(closure4726, var_BoundsError);
  addtoclosure(closure4726, var__prelude);
  addtoclosure(closure4726, var_Collection);
  addtoclosure(closure4726, var_indexable);
  addtoclosure(closure4726, var_Number);
  addtoclosure(closure4726, var_RequestError);
  struct UserObject *uo4726 = (struct UserObject*)obj4181;
  uo4726->data[2] = (Object)closure4726;
  Method *meth_meth_collectionsPrelude_from_40__41_downTo4726 = addmethod2pos(obj4181, "from()downTo", &meth_collectionsPrelude_from_40__41_downTo4726, 2);
  int argcv_meth_collectionsPrelude_from_40__41_downTo4726[] = {1, 1};
  meth_meth_collectionsPrelude_from_40__41_downTo4726->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_from_40__41_downTo4726);
  meth_meth_collectionsPrelude_from_40__41_downTo4726->definitionModule = modulename;
  meth_meth_collectionsPrelude_from_40__41_downTo4726->definitionLine = 1846;
  block_savedest(obj4181);
  Object closure5231 = createclosure(7, "from()downTo()object");
  setclosureframe(closure5231, stackframe);
  addtoclosure(closure5231, var_Exhausted);
  addtoclosure(closure5231, var_BoundsError);
  addtoclosure(closure5231, var__prelude);
  addtoclosure(closure5231, var_Collection);
  addtoclosure(closure5231, var_indexable);
  addtoclosure(closure5231, var_Number);
  addtoclosure(closure5231, var_RequestError);
  Method *meth_meth_collectionsPrelude_from_40__41_downTo4726_object = addmethod2pos(obj4181, "from()downTo()object", &meth_collectionsPrelude_from_40__41_downTo4726_object, 2);
  meth_meth_collectionsPrelude_from_40__41_downTo4726_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_from_40__41_downTo4726_object->definitionLine = 1846;
  sourceObject = obj4181;
  sourceObject = obj4181;
  objclass4181 = obj4181->class;
  objclass4181->definitionModule = modulename;
  objclass4181->definitionLine = 1724;
  (*(struct UserObject *)self).data[0] = lowerouter4181;
  self = oldself4181;
  selfslot = oldselfslot4181;
  stackframe = oldstackframe4181;
  gc_frame_end(frame);
  return obj4181;
}
Object meth_collectionsPrelude_range4180_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "range()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_Exhausted = getfromclosure(closure, 0);
  Object *var_BoundsError = getfromclosure(closure, 1);
  Object *var__prelude = getfromclosure(closure, 2);
  Object *var_Collection = getfromclosure(closure, 3);
  Object *var_indexable = getfromclosure(closure, 4);
  Object *var_Number = getfromclosure(closure, 5);
  Object *var_RequestError = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for range (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for range");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4181 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4181 = alloc_userobj2(4,5, objclass4181);
  gc_frame_newslot(obj4181);
if (objclass4181 == NULL) {
  glfree(obj4181->class->name);
  obj4181->class->name = "self.range";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4181, self, 0);
  addmethodreal(obj4181,"outer", &reader_collectionsPrelude_outer_4182);
  Object oldself4181 = self;
  struct StackFrameObject *oldstackframe4181 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4181);
  gc_frame_newslot((Object)stackframe);
  self = obj4181;
  Object *oldselfslot4181 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4181 = (*(struct UserObject *)self).data[0], lowerouter4181 = thisouter4181;
  if (inheritingObject4181) {
    struct UserObject *inho4181 = (struct UserObject *)inheritingObject4181;
    while (inho4181->super != GraceDefaultObject) inho4181 = (struct UserObject *)inho4181->super;
    inho4181->super = obj4181;
    self = inheritingObject4181;
    *selfslot = self;
    lowerouter4181 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4181;
  }
// method from()to
  block_savedest(obj4181);
  Object closure4183 = createclosure(7, "from()to");
  setclosureframe(closure4183, stackframe);
  addtoclosure(closure4183, var_Exhausted);
  addtoclosure(closure4183, var_BoundsError);
  addtoclosure(closure4183, var__prelude);
  addtoclosure(closure4183, var_Collection);
  addtoclosure(closure4183, var_indexable);
  addtoclosure(closure4183, var_Number);
  addtoclosure(closure4183, var_RequestError);
  struct UserObject *uo4183 = (struct UserObject*)obj4181;
  uo4183->data[1] = (Object)closure4183;
  Method *meth_meth_collectionsPrelude_from_40__41_to4183 = addmethod2pos(obj4181, "from()to", &meth_collectionsPrelude_from_40__41_to4183, 1);
  int argcv_meth_collectionsPrelude_from_40__41_to4183[] = {1, 1};
  meth_meth_collectionsPrelude_from_40__41_to4183->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_from_40__41_to4183);
  meth_meth_collectionsPrelude_from_40__41_to4183->definitionModule = modulename;
  meth_meth_collectionsPrelude_from_40__41_to4183->definitionLine = 1725;
  block_savedest(obj4181);
  Object closure4725 = createclosure(7, "from()to()object");
  setclosureframe(closure4725, stackframe);
  addtoclosure(closure4725, var_Exhausted);
  addtoclosure(closure4725, var_BoundsError);
  addtoclosure(closure4725, var__prelude);
  addtoclosure(closure4725, var_Collection);
  addtoclosure(closure4725, var_indexable);
  addtoclosure(closure4725, var_Number);
  addtoclosure(closure4725, var_RequestError);
  Method *meth_meth_collectionsPrelude_from_40__41_to4183_object = addmethod2pos(obj4181, "from()to()object", &meth_collectionsPrelude_from_40__41_to4183_object, 1);
  meth_meth_collectionsPrelude_from_40__41_to4183_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_from_40__41_to4183_object->definitionLine = 1725;
// method from()downTo
  block_savedest(obj4181);
  Object closure4726 = createclosure(7, "from()downTo");
  setclosureframe(closure4726, stackframe);
  addtoclosure(closure4726, var_Exhausted);
  addtoclosure(closure4726, var_BoundsError);
  addtoclosure(closure4726, var__prelude);
  addtoclosure(closure4726, var_Collection);
  addtoclosure(closure4726, var_indexable);
  addtoclosure(closure4726, var_Number);
  addtoclosure(closure4726, var_RequestError);
  struct UserObject *uo4726 = (struct UserObject*)obj4181;
  uo4726->data[2] = (Object)closure4726;
  Method *meth_meth_collectionsPrelude_from_40__41_downTo4726 = addmethod2pos(obj4181, "from()downTo", &meth_collectionsPrelude_from_40__41_downTo4726, 2);
  int argcv_meth_collectionsPrelude_from_40__41_downTo4726[] = {1, 1};
  meth_meth_collectionsPrelude_from_40__41_downTo4726->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_from_40__41_downTo4726);
  meth_meth_collectionsPrelude_from_40__41_downTo4726->definitionModule = modulename;
  meth_meth_collectionsPrelude_from_40__41_downTo4726->definitionLine = 1846;
  block_savedest(obj4181);
  Object closure5231 = createclosure(7, "from()downTo()object");
  setclosureframe(closure5231, stackframe);
  addtoclosure(closure5231, var_Exhausted);
  addtoclosure(closure5231, var_BoundsError);
  addtoclosure(closure5231, var__prelude);
  addtoclosure(closure5231, var_Collection);
  addtoclosure(closure5231, var_indexable);
  addtoclosure(closure5231, var_Number);
  addtoclosure(closure5231, var_RequestError);
  Method *meth_meth_collectionsPrelude_from_40__41_downTo4726_object = addmethod2pos(obj4181, "from()downTo()object", &meth_collectionsPrelude_from_40__41_downTo4726_object, 2);
  meth_meth_collectionsPrelude_from_40__41_downTo4726_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_from_40__41_downTo4726_object->definitionLine = 1846;
  sourceObject = obj4181;
  sourceObject = obj4181;
  objclass4181 = obj4181->class;
  objclass4181->definitionModule = modulename;
  objclass4181->definitionLine = 1724;
  (*(struct UserObject *)self).data[0] = lowerouter4181;
  self = oldself4181;
  selfslot = oldselfslot4181;
  stackframe = oldstackframe4181;
  gc_frame_end(frame);
  return obj4181;
}
Object meth_collectionsPrelude_BoundsError5238(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "BoundsError");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_BoundsError = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for BoundsError (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹BoundsError›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_BoundsError (depth = 3)
  gc_frame_end(frame);
  return *var_BoundsError;
}
Object meth_collectionsPrelude_Exhausted5244(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Exhausted");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Exhausted = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for Exhausted (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹Exhausted›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Exhausted (depth = 3)
  gc_frame_end(frame);
  return *var_Exhausted;
}
Object meth_collectionsPrelude_SubobjectResponsibility5250(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "SubobjectResponsibility");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_SubobjectResponsibility = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for SubobjectResponsibility (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹SubobjectResponsibility›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_SubobjectResponsibility (depth = 3)
  gc_frame_end(frame);
  return *var_SubobjectResponsibility;
}
Object meth_collectionsPrelude_NoSuchObject5256(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "NoSuchObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for NoSuchObject (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹NoSuchObject›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_NoSuchObject (depth = 3)
  gc_frame_end(frame);
  return *var_NoSuchObject;
}
Object meth_collectionsPrelude_RequestError5262(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "RequestError");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_RequestError = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for RequestError (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹RequestError›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_RequestError (depth = 3)
  gc_frame_end(frame);
  return *var_RequestError;
}
Object meth_collectionsPrelude_ConcurrentModification5268(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 17, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "ConcurrentModification");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for ConcurrentModification (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹ConcurrentModification›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ConcurrentModification (depth = 3)
  gc_frame_end(frame);
  return *var_ConcurrentModification;
}
Object meth_collectionsPrelude_SizeUnknown5274(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 18, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "SizeUnknown");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_SizeUnknown = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for SizeUnknown (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹SizeUnknown›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_SizeUnknown (depth = 3)
  gc_frame_end(frame);
  return *var_SizeUnknown;
}
Object meth_collectionsPrelude_Block05277(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Block0");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Block0 = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for Block0 (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹Block0›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Block0 (depth = 3)
  gc_frame_end(frame);
  return *var_Block0;
}
Object meth_collectionsPrelude_Block15280(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Block1");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Block1 = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for Block1 (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹Block1›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 20
  setline(20);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Block1 (depth = 3)
  gc_frame_end(frame);
  return *var_Block1;
}
Object meth_collectionsPrelude_Block25283(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Block2");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Block2 = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for Block2 (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹Block2›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 24
  setline(24);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Block2 (depth = 3)
  gc_frame_end(frame);
  return *var_Block2;
}
Object meth_collectionsPrelude_SelfType5285(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 22, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "SelfType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_SelfType = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for SelfType (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹SelfType›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 28
  setline(28);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_SelfType (depth = 3)
  gc_frame_end(frame);
  return *var_SelfType;
}
Object meth_collectionsPrelude_Collection5291(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 23, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Collection");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Collection = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for Collection (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹Collection›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 30
  setline(30);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Collection (depth = 3)
  gc_frame_end(frame);
  return *var_Collection;
}
Object meth_collectionsPrelude_Enumerable5297(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 24, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Enumerable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for Enumerable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹Enumerable›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 44
  setline(44);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Enumerable (depth = 3)
  gc_frame_end(frame);
  return *var_Enumerable;
}
Object meth_collectionsPrelude_Sequence5303(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 25, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Sequence");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Sequence = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for Sequence (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹Sequence›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 54
  setline(54);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Sequence (depth = 3)
  gc_frame_end(frame);
  return *var_Sequence;
}
Object meth_collectionsPrelude_List5309(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 26, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "List");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_List = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for List (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹List›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 72
  setline(72);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_List (depth = 3)
  gc_frame_end(frame);
  return *var_List;
}
Object meth_collectionsPrelude_Set5315(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 27, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Set");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Set = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for Set (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹Set›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 105
  setline(105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Set (depth = 3)
  gc_frame_end(frame);
  return *var_Set;
}
Object meth_collectionsPrelude_Dictionary5321(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 28, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Dictionary");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Dictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for Dictionary (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹Dictionary›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 124
  setline(124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Dictionary (depth = 3)
  gc_frame_end(frame);
  return *var_Dictionary;
}
Object meth_collectionsPrelude_Iterator5324(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 29, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Iterator = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for Iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹Iterator›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 151
  setline(151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Iterator (depth = 3)
  gc_frame_end(frame);
  return *var_Iterator;
}
Object meth_collectionsPrelude_CollectionFactory5327(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 30, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "CollectionFactory");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_CollectionFactory = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for CollectionFactory (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹CollectionFactory›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 156
  setline(156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_CollectionFactory (depth = 3)
  gc_frame_end(frame);
  return *var_CollectionFactory;
}
Object meth_collectionsPrelude_EmptyCollectionFactory5330(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 31, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "EmptyCollectionFactory");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_EmptyCollectionFactory = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for EmptyCollectionFactory (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹EmptyCollectionFactory›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 162
  setline(162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_EmptyCollectionFactory (depth = 3)
  gc_frame_end(frame);
  return *var_EmptyCollectionFactory;
}
Object meth_collectionsPrelude_collectionFactory5331(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 32, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "collectionFactory");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_collectionFactory = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for collectionFactory (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for collectionFactory");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_collectionFactory (depth = 3)
  gc_frame_end(frame);
  return *var_collectionFactory;
}
Object meth_collectionsPrelude_withAll5337(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "withAll");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method withAll");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for withAll (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_elts = &(stackframe->slots[0]);
  *var_elts = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for withAll");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 167
  setline(167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5338 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5339 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5340 = gc_frame_new();
// call case 3: self.outer request
  Object call5341 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5340);
// compiled call node returning call5341 (depth = 9)
// compiled member node returning call5341 (depth = 8)
  partcv[0] = 0;
  Object call5342 = callmethodflags(call5341, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5339);
// compiled call node returning call5342 (depth = 7)
// compiled member node returning call5342 (depth = 6)
  partcv[0] = 0;
  Object call5343 = callmethodflags(call5342, "abstract", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5338);
// compiled call node returning call5343 (depth = 5)
// compiled member node returning call5343 (depth = 4)
  gc_frame_end(frame);
  return call5343;
}
Object meth_collectionsPrelude_with5344(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "with");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for with (probably reflection error): got %i lists, expected 1.", nparts);
  Object var_init_a = alloc_BuiltinList();
  for (i = 0; i < argcv[0]; i++) {
    callmethod(var_init_a, "push", 1, pushcv, &args[curarg]);
    curarg++;
  }
  Object *var_a = &(stackframe->slots[0]);
  *var_a = var_init_a;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 168
  setline(168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5345 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_a (depth = 5)
  gc_frame_newslot(*var_a);
// call case 4: self request
  params[0] = *var_a;
  partcv[0] = 1;
  Object call5346 = callmethodflags(self, "withAll", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5345);
// compiled call node returning call5346 (depth = 4)
  gc_frame_end(frame);
  return call5346;
}
Object meth_collectionsPrelude_empty5347(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "empty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for empty (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for empty");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 169
  setline(169);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5348 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5349 = callmethodflags(self, "with", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5348);
// compiled call node returning call5349 (depth = 4)
  gc_frame_end(frame);
  return call5349;
}
Object meth_collectionsPrelude_trait5334(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "trait");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for trait (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for trait");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start generics
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      gracedie("insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End generics
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5335 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5335 = alloc_userobj2(3,4, objclass5335);
  gc_frame_newslot(obj5335);
if (objclass5335 == NULL) {
  glfree(obj5335->class->name);
  obj5335->class->name = "collectionFactory";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5335, self, 0);
  addmethodreal(obj5335,"outer", &reader_collectionsPrelude_outer_5336);
  Object oldself5335 = self;
  struct StackFrameObject *oldstackframe5335 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5335);
  gc_frame_newslot((Object)stackframe);
  self = obj5335;
  Object *oldselfslot5335 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5335 = (*(struct UserObject *)self).data[0], lowerouter5335 = thisouter5335;
  if (inheritingObject5335) {
    struct UserObject *inho5335 = (struct UserObject *)inheritingObject5335;
    while (inho5335->super != GraceDefaultObject) inho5335 = (struct UserObject *)inho5335->super;
    inho5335->super = obj5335;
    self = inheritingObject5335;
    *selfslot = self;
    lowerouter5335 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5335;
  }
// method withAll
  struct UserObject *uo5337 = (struct UserObject*)obj5335;
  uo5337->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_withAll5337 = addmethod2pos(obj5335, "withAll", &meth_collectionsPrelude_withAll5337, 1);
  int argcv_meth_collectionsPrelude_withAll5337[] = {1};
  meth_meth_collectionsPrelude_withAll5337->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_withAll5337);
  meth_meth_collectionsPrelude_withAll5337->definitionModule = modulename;
  meth_meth_collectionsPrelude_withAll5337->definitionLine = 167;
// method with
  struct UserObject *uo5344 = (struct UserObject*)obj5335;
  uo5344->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_with5344 = addmethod2pos(obj5335, "with", &meth_collectionsPrelude_with5344, 2);
  int argcv_meth_collectionsPrelude_with5344[] = {0};
  meth_meth_collectionsPrelude_with5344->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_with5344);
  meth_meth_collectionsPrelude_with5344->definitionModule = modulename;
  meth_meth_collectionsPrelude_with5344->definitionLine = 168;
// method empty
  struct UserObject *uo5347 = (struct UserObject*)obj5335;
  uo5347->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_empty5347 = addmethod2pos(obj5335, "empty", &meth_collectionsPrelude_empty5347, 3);
  int argcv_meth_collectionsPrelude_empty5347[] = {0};
  meth_meth_collectionsPrelude_empty5347->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_empty5347);
  meth_meth_collectionsPrelude_empty5347->definitionModule = modulename;
  meth_meth_collectionsPrelude_empty5347->definitionLine = 169;
  sourceObject = obj5335;
  sourceObject = obj5335;
  sourceObject = obj5335;
  objclass5335 = obj5335->class;
  objclass5335->definitionModule = modulename;
  objclass5335->definitionLine = 166;
  (*(struct UserObject *)self).data[0] = lowerouter5335;
  self = oldself5335;
  selfslot = oldselfslot5335;
  stackframe = oldstackframe5335;
  gc_frame_end(frame);
  return obj5335;
}
Object meth_collectionsPrelude_trait5334_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "trait()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for trait (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for trait");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start generics
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      gracedie("insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End generics
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5335 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5335 = alloc_userobj2(3,4, objclass5335);
  gc_frame_newslot(obj5335);
if (objclass5335 == NULL) {
  glfree(obj5335->class->name);
  obj5335->class->name = "collectionFactory";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5335, self, 0);
  addmethodreal(obj5335,"outer", &reader_collectionsPrelude_outer_5336);
  Object oldself5335 = self;
  struct StackFrameObject *oldstackframe5335 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5335);
  gc_frame_newslot((Object)stackframe);
  self = obj5335;
  Object *oldselfslot5335 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5335 = (*(struct UserObject *)self).data[0], lowerouter5335 = thisouter5335;
  if (inheritingObject5335) {
    struct UserObject *inho5335 = (struct UserObject *)inheritingObject5335;
    while (inho5335->super != GraceDefaultObject) inho5335 = (struct UserObject *)inho5335->super;
    inho5335->super = obj5335;
    self = inheritingObject5335;
    *selfslot = self;
    lowerouter5335 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5335;
  }
// method withAll
  struct UserObject *uo5337 = (struct UserObject*)obj5335;
  uo5337->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_withAll5337 = addmethod2pos(obj5335, "withAll", &meth_collectionsPrelude_withAll5337, 1);
  int argcv_meth_collectionsPrelude_withAll5337[] = {1};
  meth_meth_collectionsPrelude_withAll5337->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_withAll5337);
  meth_meth_collectionsPrelude_withAll5337->definitionModule = modulename;
  meth_meth_collectionsPrelude_withAll5337->definitionLine = 167;
// method with
  struct UserObject *uo5344 = (struct UserObject*)obj5335;
  uo5344->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_with5344 = addmethod2pos(obj5335, "with", &meth_collectionsPrelude_with5344, 2);
  int argcv_meth_collectionsPrelude_with5344[] = {0};
  meth_meth_collectionsPrelude_with5344->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_with5344);
  meth_meth_collectionsPrelude_with5344->definitionModule = modulename;
  meth_meth_collectionsPrelude_with5344->definitionLine = 168;
// method empty
  struct UserObject *uo5347 = (struct UserObject*)obj5335;
  uo5347->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_empty5347 = addmethod2pos(obj5335, "empty", &meth_collectionsPrelude_empty5347, 3);
  int argcv_meth_collectionsPrelude_empty5347[] = {0};
  meth_meth_collectionsPrelude_empty5347->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_empty5347);
  meth_meth_collectionsPrelude_empty5347->definitionModule = modulename;
  meth_meth_collectionsPrelude_empty5347->definitionLine = 169;
  sourceObject = obj5335;
  sourceObject = obj5335;
  sourceObject = obj5335;
  objclass5335 = obj5335->class;
  objclass5335->definitionModule = modulename;
  objclass5335->definitionLine = 166;
  (*(struct UserObject *)self).data[0] = lowerouter5335;
  self = oldself5335;
  selfslot = oldselfslot5335;
  stackframe = oldstackframe5335;
  gc_frame_end(frame);
  return obj5335;
}
Object meth_collectionsPrelude_collection5351(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 33, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "collection");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_collection = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for collection (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for collection");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_collection (depth = 3)
  gc_frame_end(frame);
  return *var_collection;
}
Object meth_collectionsPrelude_do5357(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for do (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for do");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 247
  setline(247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5358 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5359 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5360 = gc_frame_new();
// call case 3: self.outer request
  Object call5361 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5360);
// compiled call node returning call5361 (depth = 9)
// compiled member node returning call5361 (depth = 8)
  partcv[0] = 0;
  Object call5362 = callmethodflags(call5361, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5359);
// compiled call node returning call5362 (depth = 7)
// compiled member node returning call5362 (depth = 6)
  partcv[0] = 0;
  Object call5363 = callmethodflags(call5362, "abstract", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5358);
// compiled call node returning call5363 (depth = 5)
// compiled member node returning call5363 (depth = 4)
  gc_frame_end(frame);
  return call5363;
}
Object meth_collectionsPrelude_iterator5364(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 248
  setline(248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5365 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5366 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5367 = gc_frame_new();
// call case 3: self.outer request
  Object call5368 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5367);
// compiled call node returning call5368 (depth = 9)
// compiled member node returning call5368 (depth = 8)
  partcv[0] = 0;
  Object call5369 = callmethodflags(call5368, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5366);
// compiled call node returning call5369 (depth = 7)
// compiled member node returning call5369 (depth = 6)
  partcv[0] = 0;
  Object call5370 = callmethodflags(call5369, "abstract", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5365);
// compiled call node returning call5370 (depth = 5)
// compiled member node returning call5370 (depth = 4)
  gc_frame_end(frame);
  return call5370;
}
Object meth_collectionsPrelude_isEmpty5371(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isEmpty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isEmpty (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isEmpty");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 251
  setline(251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5372 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5373 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5374 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5375 = callmethodflags(self, "iterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5374);
// compiled call node returning call5375 (depth = 9)
// compiled member node returning call5375 (depth = 8)
  partcv[0] = 0;
  Object call5376 = callmethod(call5375, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe5373);
// compiled call node returning call5376 (depth = 7)
// compiled member node returning call5376 (depth = 6)
  partcv[0] = 0;
  Object call5377 = callmethod(call5376, "not",
    1, partcv, params);
  gc_frame_end(callframe5372);
// compiled call node returning call5377 (depth = 5)
// compiled member node returning call5377 (depth = 4)
  gc_frame_end(frame);
  return call5377;
}
Object meth_collectionsPrelude__apply5383(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_firstTime = getfromclosure(closure, 0);
  Object *var_block0 = getfromclosure(closure, 1);
  Object *var_block1 = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 257
  setline(257);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_firstTime (depth = 7)
  Object if5384 = done;
  if (istrue(*var_firstTime)) {
// Begin line 258
  setline(258);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool5385 = alloc_Boolean(0);
// compiled identifier node returning bool5385 (depth = 8)
  *var_firstTime = bool5385;
  if (bool5385 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if5384 = done;
  } else {
// Begin line 260
  setline(260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5387 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_block0 (depth = 9)
  partcv[0] = 0;
  Object call5388 = callmethod(*var_block0, "apply",
    1, partcv, params);
  gc_frame_end(callframe5387);
// compiled call node returning call5388 (depth = 8)
// compiled member node returning call5388 (depth = 7)
    gc_frame_newslot(call5388);
    if5384 = call5388;
  }
// compiled if node returning if5384 (depth = 6)
// Begin line 262
  setline(262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5389 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  gc_frame_newslot(*var_each);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_block1 (depth = 7)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call5390 = callmethod(*var_block1, "apply",
    1, partcv, params);
  gc_frame_end(callframe5389);
// compiled call node returning call5390 (depth = 6)
  gc_frame_end(frame);
  return call5390;
}
Object meth_collectionsPrelude_do_40__41_separatedBy5378(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do()separatedBy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method do()separatedBy");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method do()separatedBy");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for do()separatedBy (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for do");
  Object *var_block0 = &(stackframe->slots[1]);
  *var_block0 = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for separatedBy");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_firstTime = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "firstTime");
  Object *var_i = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "i");
// Begin line 254
  setline(254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool5379 = alloc_Boolean(1);
// compiled identifier node returning bool5379 (depth = 5)
  *var_firstTime = bool5379;
  if (bool5379 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 255
  setline(255);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile num node (depth = 5)
  Object num5380 = alloc_Float64(0);
// compiled num node returning num5380 (depth = 5)
  *var_i = num5380;
  if (num5380 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 256
  setline(256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5381 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block5382 = alloc_Block(NULL, NULL, "collectionsPrelude", 256);
  gc_frame_newslot(block5382);
// method _apply
  block_savedest(block5382);
  Object closure5383 = createclosure(4, "_apply");
  setclosureframe(closure5383, stackframe);
  addtoclosure(closure5383, var_firstTime);
  addtoclosure(closure5383, var_block0);
  addtoclosure(closure5383, var_block1);
  addtoclosure(closure5383, selfslot);
  struct UserObject *uo5383 = (struct UserObject*)block5382;
  uo5383->data[0] = (Object)closure5383;
  Method *meth_meth_collectionsPrelude__apply5383 = addmethod2pos(block5382, "_apply", &meth_collectionsPrelude__apply5383, 0);
  int argcv_meth_collectionsPrelude__apply5383[] = {1};
  meth_meth_collectionsPrelude__apply5383->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5383);
  meth_meth_collectionsPrelude__apply5383->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5383->definitionLine = 251;
// compiled block node returning block5382 (depth = 5)
  gc_frame_newslot(block5382);
// call case 4: self request
  params[0] = block5382;
  partcv[0] = 1;
  Object call5392 = callmethodflags(self, "do", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5381);
// compiled call node returning call5392 (depth = 4)
// Begin line 264
  setline(264);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  return self;
// compiled return node returning undefined (depth = 4)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_reduce5393(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "reduce");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method reduce");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for reduce (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_initial = &(stackframe->slots[0]);
  *var_initial = args[curarg];
  curarg++;
  Object *var_blk = &(stackframe->slots[1]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for reduce");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 268
  setline(268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5394 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_initial (depth = 5)
  gc_frame_newslot(*var_initial);
// call case 4: self request
  params[0] = *var_blk;
  params[1] = *var_initial;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5395 = callmethodflags(self, "fold()startingWith", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5394);
// compiled call node returning call5395 (depth = 4)
  gc_frame_end(frame);
  return call5395;
}
Object meth_collectionsPrelude__apply5399(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[1];
  Object *var_result = getfromclosure(closure, 0);
  Object *var_blk = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_it = &(stackframe->slots[0]);
  *var_it = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 273
  setline(273);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5400 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_result (depth = 8)
  gc_frame_newslot(*var_result);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_it (depth = 8)
  gc_frame_newslot(*var_it);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_blk (depth = 8)
  params[0] = *var_result;
  params[1] = *var_it;
  partcv[0] = 2;
  Object call5401 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe5400);
// compiled call node returning call5401 (depth = 7)
  *var_result = call5401;
  if (call5401 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_fold_40__41_startingWith5396(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "fold()startingWith");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method fold()startingWith");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method fold()startingWith");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for fold()startingWith (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for fold");
  Object *var_initial = &(stackframe->slots[1]);
  *var_initial = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for startingWith");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "result");
// Begin line 271
  setline(271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_initial (depth = 5)
  *var_result = *var_initial;
  if (*var_initial == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 272
  setline(272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5397 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block5398 = alloc_Block(NULL, NULL, "collectionsPrelude", 272);
  gc_frame_newslot(block5398);
// method _apply
  block_savedest(block5398);
  Object closure5399 = createclosure(3, "_apply");
  setclosureframe(closure5399, stackframe);
  addtoclosure(closure5399, var_result);
  addtoclosure(closure5399, var_blk);
  addtoclosure(closure5399, selfslot);
  struct UserObject *uo5399 = (struct UserObject*)block5398;
  uo5399->data[0] = (Object)closure5399;
  Method *meth_meth_collectionsPrelude__apply5399 = addmethod2pos(block5398, "_apply", &meth_collectionsPrelude__apply5399, 0);
  int argcv_meth_collectionsPrelude__apply5399[] = {1};
  meth_meth_collectionsPrelude__apply5399->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5399);
  meth_meth_collectionsPrelude__apply5399->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5399->definitionLine = 260;
// compiled block node returning block5398 (depth = 5)
  gc_frame_newslot(block5398);
// call case 4: self request
  params[0] = block5398;
  partcv[0] = 1;
  Object call5404 = callmethodflags(self, "do", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5397);
// compiled call node returning call5404 (depth = 4)
// Begin line 275
  setline(275);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  return *var_result;
// compiled return node returning undefined (depth = 4)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_map5405(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start generics
  Object *var_R = &(stackframe->slots[2]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      gracedie("insufficient generic parameters");
    }
    *var_R = args[curarg++];
  } else {
    *var_R = Unknown;
  }
// End generics
// Begin line 278
  setline(278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5406 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_block1 (depth = 5)
  gc_frame_newslot(*var_block1);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5407 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5408 = gc_frame_new();
// call case 3: self.outer request
  Object call5409 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5408);
// compiled call node returning call5409 (depth = 8)
// compiled member node returning call5409 (depth = 7)
  partcv[0] = 0;
  Object call5410 = callmethodflags(call5409, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5407);
// compiled call node returning call5410 (depth = 6)
// compiled member node returning call5410 (depth = 5)
  params[0] = self;
  params[1] = *var_block1;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5411 = callmethodflags(call5410, "lazySequenceOver()mappedBy", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5406);
// compiled call node returning call5411 (depth = 4)
  gc_frame_end(frame);
  return call5411;
}
Object meth_collectionsPrelude_filter5412(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "filter");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method filter");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for filter (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_selectionCondition = &(stackframe->slots[0]);
  *var_selectionCondition = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for filter");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 281
  setline(281);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5413 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_selectionCondition (depth = 5)
  gc_frame_newslot(*var_selectionCondition);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5414 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5415 = gc_frame_new();
// call case 3: self.outer request
  Object call5416 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5415);
// compiled call node returning call5416 (depth = 8)
// compiled member node returning call5416 (depth = 7)
  partcv[0] = 0;
  Object call5417 = callmethodflags(call5416, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5414);
// compiled call node returning call5417 (depth = 6)
// compiled member node returning call5417 (depth = 5)
  params[0] = self;
  params[1] = *var_selectionCondition;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5418 = callmethodflags(call5417, "lazySequenceOver()filteredBy", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5413);
// compiled call node returning call5418 (depth = 4)
  gc_frame_end(frame);
  return call5418;
}
Object meth_collectionsPrelude_iter5419(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "iter");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for iter (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for iter");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 284
  setline(284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5420 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5421 = callmethodflags(self, "iterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5420);
// compiled call node returning call5421 (depth = 5)
// compiled member node returning call5421 (depth = 4)
  gc_frame_end(frame);
  return call5421;
}
Object meth_collectionsPrelude_asSequence5422(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asSequence");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asSequence (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asSequence");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 287
  setline(287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5423 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5424 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5425 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5426 = gc_frame_new();
// call case 3: self.outer request
  Object call5427 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5426);
// compiled call node returning call5427 (depth = 10)
// compiled member node returning call5427 (depth = 9)
  partcv[0] = 0;
  Object call5428 = callmethodflags(call5427, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5425);
// compiled call node returning call5428 (depth = 8)
// compiled member node returning call5428 (depth = 7)
  partcv[0] = 0;
  Object call5429 = callmethodflags(call5428, "sequence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5424);
// compiled call node returning call5429 (depth = 6)
// compiled member node returning call5429 (depth = 5)
  params[0] = self;
  partcv[0] = 1;
  Object call5430 = callmethod(call5429, "withAll",
    1, partcv, params);
  gc_frame_end(callframe5423);
// compiled call node returning call5430 (depth = 4)
  gc_frame_end(frame);
  return call5430;
}
Object meth_collectionsPrelude_asList5431(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asList");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asList (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asList");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 290
  setline(290);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5432 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5433 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5434 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5435 = gc_frame_new();
// call case 3: self.outer request
  Object call5436 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5435);
// compiled call node returning call5436 (depth = 10)
// compiled member node returning call5436 (depth = 9)
  partcv[0] = 0;
  Object call5437 = callmethodflags(call5436, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5434);
// compiled call node returning call5437 (depth = 8)
// compiled member node returning call5437 (depth = 7)
  partcv[0] = 0;
  Object call5438 = callmethodflags(call5437, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5433);
// compiled call node returning call5438 (depth = 6)
// compiled member node returning call5438 (depth = 5)
  params[0] = self;
  partcv[0] = 1;
  Object call5439 = callmethod(call5438, "withAll",
    1, partcv, params);
  gc_frame_end(callframe5432);
// compiled call node returning call5439 (depth = 4)
  gc_frame_end(frame);
  return call5439;
}
Object meth_collectionsPrelude_asSet5440(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asSet");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asSet (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asSet");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 293
  setline(293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5441 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5442 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5443 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5444 = gc_frame_new();
// call case 3: self.outer request
  Object call5445 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5444);
// compiled call node returning call5445 (depth = 10)
// compiled member node returning call5445 (depth = 9)
  partcv[0] = 0;
  Object call5446 = callmethodflags(call5445, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5443);
// compiled call node returning call5446 (depth = 8)
// compiled member node returning call5446 (depth = 7)
  partcv[0] = 0;
  Object call5447 = callmethodflags(call5446, "set", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5442);
// compiled call node returning call5447 (depth = 6)
// compiled member node returning call5447 (depth = 5)
  params[0] = self;
  partcv[0] = 1;
  Object call5448 = callmethod(call5447, "withAll",
    1, partcv, params);
  gc_frame_end(callframe5441);
// compiled call node returning call5448 (depth = 4)
  gc_frame_end(frame);
  return call5448;
}
Object meth_collectionsPrelude_trait5354(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "trait");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for trait (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for trait");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start generics
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      gracedie("insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End generics
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5355 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5355 = alloc_userobj2(12,13, objclass5355);
  gc_frame_newslot(obj5355);
if (objclass5355 == NULL) {
  glfree(obj5355->class->name);
  obj5355->class->name = "collection";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5355, self, 0);
  addmethodreal(obj5355,"outer", &reader_collectionsPrelude_outer_5356);
  Object oldself5355 = self;
  struct StackFrameObject *oldstackframe5355 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5355);
  gc_frame_newslot((Object)stackframe);
  self = obj5355;
  Object *oldselfslot5355 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5355 = (*(struct UserObject *)self).data[0], lowerouter5355 = thisouter5355;
  if (inheritingObject5355) {
    struct UserObject *inho5355 = (struct UserObject *)inheritingObject5355;
    while (inho5355->super != GraceDefaultObject) inho5355 = (struct UserObject *)inho5355->super;
    inho5355->super = obj5355;
    self = inheritingObject5355;
    *selfslot = self;
    lowerouter5355 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5355;
  }
// method do
  struct UserObject *uo5357 = (struct UserObject*)obj5355;
  uo5357->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do5357 = addmethod2pos(obj5355, "do", &meth_collectionsPrelude_do5357, 1);
  int argcv_meth_collectionsPrelude_do5357[] = {0};
  meth_meth_collectionsPrelude_do5357->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do5357);
  meth_meth_collectionsPrelude_do5357->definitionModule = modulename;
  meth_meth_collectionsPrelude_do5357->definitionLine = 247;
// method iterator
  struct UserObject *uo5364 = (struct UserObject*)obj5355;
  uo5364->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_iterator5364 = addmethod2pos(obj5355, "iterator", &meth_collectionsPrelude_iterator5364, 2);
  int argcv_meth_collectionsPrelude_iterator5364[] = {0};
  meth_meth_collectionsPrelude_iterator5364->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator5364);
  meth_meth_collectionsPrelude_iterator5364->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator5364->definitionLine = 248;
// method isEmpty
  struct UserObject *uo5371 = (struct UserObject*)obj5355;
  uo5371->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_isEmpty5371 = addmethod2pos(obj5355, "isEmpty", &meth_collectionsPrelude_isEmpty5371, 3);
  int argcv_meth_collectionsPrelude_isEmpty5371[] = {0};
  meth_meth_collectionsPrelude_isEmpty5371->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_isEmpty5371);
  meth_meth_collectionsPrelude_isEmpty5371->definitionModule = modulename;
  meth_meth_collectionsPrelude_isEmpty5371->definitionLine = 249;
// method do()separatedBy
  struct UserObject *uo5378 = (struct UserObject*)obj5355;
  uo5378->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do_40__41_separatedBy5378 = addmethod2pos(obj5355, "do()separatedBy", &meth_collectionsPrelude_do_40__41_separatedBy5378, 4);
  int argcv_meth_collectionsPrelude_do_40__41_separatedBy5378[] = {1, 1};
  meth_meth_collectionsPrelude_do_40__41_separatedBy5378->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_do_40__41_separatedBy5378);
  meth_meth_collectionsPrelude_do_40__41_separatedBy5378->definitionModule = modulename;
  meth_meth_collectionsPrelude_do_40__41_separatedBy5378->definitionLine = 253;
// method reduce
  struct UserObject *uo5393 = (struct UserObject*)obj5355;
  uo5393->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_reduce5393 = addmethod2pos(obj5355, "reduce", &meth_collectionsPrelude_reduce5393, 5);
  int argcv_meth_collectionsPrelude_reduce5393[] = {2};
  meth_meth_collectionsPrelude_reduce5393->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reduce5393);
  meth_meth_collectionsPrelude_reduce5393->definitionModule = modulename;
  meth_meth_collectionsPrelude_reduce5393->definitionLine = 266;
// method fold()startingWith
  struct UserObject *uo5396 = (struct UserObject*)obj5355;
  uo5396->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_fold_40__41_startingWith5396 = addmethod2pos(obj5355, "fold()startingWith", &meth_collectionsPrelude_fold_40__41_startingWith5396, 6);
  int argcv_meth_collectionsPrelude_fold_40__41_startingWith5396[] = {1, 1};
  meth_meth_collectionsPrelude_fold_40__41_startingWith5396->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_fold_40__41_startingWith5396);
  meth_meth_collectionsPrelude_fold_40__41_startingWith5396->definitionModule = modulename;
  meth_meth_collectionsPrelude_fold_40__41_startingWith5396->definitionLine = 270;
// method map
  struct UserObject *uo5405 = (struct UserObject*)obj5355;
  uo5405->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_map5405 = addmethod2pos(obj5355, "map", &meth_collectionsPrelude_map5405, 7);
  int argcv_meth_collectionsPrelude_map5405[] = {1};
  meth_meth_collectionsPrelude_map5405->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_map5405);
  meth_meth_collectionsPrelude_map5405->definitionModule = modulename;
  meth_meth_collectionsPrelude_map5405->definitionLine = 277;
// method filter
  struct UserObject *uo5412 = (struct UserObject*)obj5355;
  uo5412->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_filter5412 = addmethod2pos(obj5355, "filter", &meth_collectionsPrelude_filter5412, 8);
  int argcv_meth_collectionsPrelude_filter5412[] = {1};
  meth_meth_collectionsPrelude_filter5412->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_filter5412);
  meth_meth_collectionsPrelude_filter5412->definitionModule = modulename;
  meth_meth_collectionsPrelude_filter5412->definitionLine = 280;
// method iter
  struct UserObject *uo5419 = (struct UserObject*)obj5355;
  uo5419->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_iter5419 = addmethod2pos(obj5355, "iter", &meth_collectionsPrelude_iter5419, 9);
  int argcv_meth_collectionsPrelude_iter5419[] = {0};
  meth_meth_collectionsPrelude_iter5419->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iter5419);
  meth_meth_collectionsPrelude_iter5419->definitionModule = modulename;
  meth_meth_collectionsPrelude_iter5419->definitionLine = 284;
// method asSequence
  struct UserObject *uo5422 = (struct UserObject*)obj5355;
  uo5422->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asSequence5422 = addmethod2pos(obj5355, "asSequence", &meth_collectionsPrelude_asSequence5422, 10);
  int argcv_meth_collectionsPrelude_asSequence5422[] = {0};
  meth_meth_collectionsPrelude_asSequence5422->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asSequence5422);
  meth_meth_collectionsPrelude_asSequence5422->definitionModule = modulename;
  meth_meth_collectionsPrelude_asSequence5422->definitionLine = 286;
// method asList
  struct UserObject *uo5431 = (struct UserObject*)obj5355;
  uo5431->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asList5431 = addmethod2pos(obj5355, "asList", &meth_collectionsPrelude_asList5431, 11);
  int argcv_meth_collectionsPrelude_asList5431[] = {0};
  meth_meth_collectionsPrelude_asList5431->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asList5431);
  meth_meth_collectionsPrelude_asList5431->definitionModule = modulename;
  meth_meth_collectionsPrelude_asList5431->definitionLine = 289;
// method asSet
  struct UserObject *uo5440 = (struct UserObject*)obj5355;
  uo5440->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asSet5440 = addmethod2pos(obj5355, "asSet", &meth_collectionsPrelude_asSet5440, 12);
  int argcv_meth_collectionsPrelude_asSet5440[] = {0};
  meth_meth_collectionsPrelude_asSet5440->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asSet5440);
  meth_meth_collectionsPrelude_asSet5440->definitionModule = modulename;
  meth_meth_collectionsPrelude_asSet5440->definitionLine = 292;
  sourceObject = obj5355;
  sourceObject = obj5355;
  sourceObject = obj5355;
  sourceObject = obj5355;
  sourceObject = obj5355;
  sourceObject = obj5355;
  sourceObject = obj5355;
  sourceObject = obj5355;
  sourceObject = obj5355;
  sourceObject = obj5355;
  sourceObject = obj5355;
  sourceObject = obj5355;
  objclass5355 = obj5355->class;
  objclass5355->definitionModule = modulename;
  objclass5355->definitionLine = 246;
  (*(struct UserObject *)self).data[0] = lowerouter5355;
  self = oldself5355;
  selfslot = oldselfslot5355;
  stackframe = oldstackframe5355;
  gc_frame_end(frame);
  return obj5355;
}
Object meth_collectionsPrelude_trait5354_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "trait()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for trait (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for trait");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start generics
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      gracedie("insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End generics
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5355 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5355 = alloc_userobj2(12,13, objclass5355);
  gc_frame_newslot(obj5355);
if (objclass5355 == NULL) {
  glfree(obj5355->class->name);
  obj5355->class->name = "collection";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5355, self, 0);
  addmethodreal(obj5355,"outer", &reader_collectionsPrelude_outer_5356);
  Object oldself5355 = self;
  struct StackFrameObject *oldstackframe5355 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5355);
  gc_frame_newslot((Object)stackframe);
  self = obj5355;
  Object *oldselfslot5355 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5355 = (*(struct UserObject *)self).data[0], lowerouter5355 = thisouter5355;
  if (inheritingObject5355) {
    struct UserObject *inho5355 = (struct UserObject *)inheritingObject5355;
    while (inho5355->super != GraceDefaultObject) inho5355 = (struct UserObject *)inho5355->super;
    inho5355->super = obj5355;
    self = inheritingObject5355;
    *selfslot = self;
    lowerouter5355 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5355;
  }
// method do
  struct UserObject *uo5357 = (struct UserObject*)obj5355;
  uo5357->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do5357 = addmethod2pos(obj5355, "do", &meth_collectionsPrelude_do5357, 1);
  int argcv_meth_collectionsPrelude_do5357[] = {0};
  meth_meth_collectionsPrelude_do5357->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do5357);
  meth_meth_collectionsPrelude_do5357->definitionModule = modulename;
  meth_meth_collectionsPrelude_do5357->definitionLine = 247;
// method iterator
  struct UserObject *uo5364 = (struct UserObject*)obj5355;
  uo5364->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_iterator5364 = addmethod2pos(obj5355, "iterator", &meth_collectionsPrelude_iterator5364, 2);
  int argcv_meth_collectionsPrelude_iterator5364[] = {0};
  meth_meth_collectionsPrelude_iterator5364->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator5364);
  meth_meth_collectionsPrelude_iterator5364->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator5364->definitionLine = 248;
// method isEmpty
  struct UserObject *uo5371 = (struct UserObject*)obj5355;
  uo5371->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_isEmpty5371 = addmethod2pos(obj5355, "isEmpty", &meth_collectionsPrelude_isEmpty5371, 3);
  int argcv_meth_collectionsPrelude_isEmpty5371[] = {0};
  meth_meth_collectionsPrelude_isEmpty5371->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_isEmpty5371);
  meth_meth_collectionsPrelude_isEmpty5371->definitionModule = modulename;
  meth_meth_collectionsPrelude_isEmpty5371->definitionLine = 249;
// method do()separatedBy
  struct UserObject *uo5378 = (struct UserObject*)obj5355;
  uo5378->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do_40__41_separatedBy5378 = addmethod2pos(obj5355, "do()separatedBy", &meth_collectionsPrelude_do_40__41_separatedBy5378, 4);
  int argcv_meth_collectionsPrelude_do_40__41_separatedBy5378[] = {1, 1};
  meth_meth_collectionsPrelude_do_40__41_separatedBy5378->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_do_40__41_separatedBy5378);
  meth_meth_collectionsPrelude_do_40__41_separatedBy5378->definitionModule = modulename;
  meth_meth_collectionsPrelude_do_40__41_separatedBy5378->definitionLine = 253;
// method reduce
  struct UserObject *uo5393 = (struct UserObject*)obj5355;
  uo5393->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_reduce5393 = addmethod2pos(obj5355, "reduce", &meth_collectionsPrelude_reduce5393, 5);
  int argcv_meth_collectionsPrelude_reduce5393[] = {2};
  meth_meth_collectionsPrelude_reduce5393->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reduce5393);
  meth_meth_collectionsPrelude_reduce5393->definitionModule = modulename;
  meth_meth_collectionsPrelude_reduce5393->definitionLine = 266;
// method fold()startingWith
  struct UserObject *uo5396 = (struct UserObject*)obj5355;
  uo5396->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_fold_40__41_startingWith5396 = addmethod2pos(obj5355, "fold()startingWith", &meth_collectionsPrelude_fold_40__41_startingWith5396, 6);
  int argcv_meth_collectionsPrelude_fold_40__41_startingWith5396[] = {1, 1};
  meth_meth_collectionsPrelude_fold_40__41_startingWith5396->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_fold_40__41_startingWith5396);
  meth_meth_collectionsPrelude_fold_40__41_startingWith5396->definitionModule = modulename;
  meth_meth_collectionsPrelude_fold_40__41_startingWith5396->definitionLine = 270;
// method map
  struct UserObject *uo5405 = (struct UserObject*)obj5355;
  uo5405->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_map5405 = addmethod2pos(obj5355, "map", &meth_collectionsPrelude_map5405, 7);
  int argcv_meth_collectionsPrelude_map5405[] = {1};
  meth_meth_collectionsPrelude_map5405->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_map5405);
  meth_meth_collectionsPrelude_map5405->definitionModule = modulename;
  meth_meth_collectionsPrelude_map5405->definitionLine = 277;
// method filter
  struct UserObject *uo5412 = (struct UserObject*)obj5355;
  uo5412->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_filter5412 = addmethod2pos(obj5355, "filter", &meth_collectionsPrelude_filter5412, 8);
  int argcv_meth_collectionsPrelude_filter5412[] = {1};
  meth_meth_collectionsPrelude_filter5412->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_filter5412);
  meth_meth_collectionsPrelude_filter5412->definitionModule = modulename;
  meth_meth_collectionsPrelude_filter5412->definitionLine = 280;
// method iter
  struct UserObject *uo5419 = (struct UserObject*)obj5355;
  uo5419->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_iter5419 = addmethod2pos(obj5355, "iter", &meth_collectionsPrelude_iter5419, 9);
  int argcv_meth_collectionsPrelude_iter5419[] = {0};
  meth_meth_collectionsPrelude_iter5419->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iter5419);
  meth_meth_collectionsPrelude_iter5419->definitionModule = modulename;
  meth_meth_collectionsPrelude_iter5419->definitionLine = 284;
// method asSequence
  struct UserObject *uo5422 = (struct UserObject*)obj5355;
  uo5422->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asSequence5422 = addmethod2pos(obj5355, "asSequence", &meth_collectionsPrelude_asSequence5422, 10);
  int argcv_meth_collectionsPrelude_asSequence5422[] = {0};
  meth_meth_collectionsPrelude_asSequence5422->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asSequence5422);
  meth_meth_collectionsPrelude_asSequence5422->definitionModule = modulename;
  meth_meth_collectionsPrelude_asSequence5422->definitionLine = 286;
// method asList
  struct UserObject *uo5431 = (struct UserObject*)obj5355;
  uo5431->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asList5431 = addmethod2pos(obj5355, "asList", &meth_collectionsPrelude_asList5431, 11);
  int argcv_meth_collectionsPrelude_asList5431[] = {0};
  meth_meth_collectionsPrelude_asList5431->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asList5431);
  meth_meth_collectionsPrelude_asList5431->definitionModule = modulename;
  meth_meth_collectionsPrelude_asList5431->definitionLine = 289;
// method asSet
  struct UserObject *uo5440 = (struct UserObject*)obj5355;
  uo5440->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asSet5440 = addmethod2pos(obj5355, "asSet", &meth_collectionsPrelude_asSet5440, 12);
  int argcv_meth_collectionsPrelude_asSet5440[] = {0};
  meth_meth_collectionsPrelude_asSet5440->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asSet5440);
  meth_meth_collectionsPrelude_asSet5440->definitionModule = modulename;
  meth_meth_collectionsPrelude_asSet5440->definitionLine = 292;
  sourceObject = obj5355;
  sourceObject = obj5355;
  sourceObject = obj5355;
  sourceObject = obj5355;
  sourceObject = obj5355;
  sourceObject = obj5355;
  sourceObject = obj5355;
  sourceObject = obj5355;
  sourceObject = obj5355;
  sourceObject = obj5355;
  sourceObject = obj5355;
  sourceObject = obj5355;
  objclass5355 = obj5355->class;
  objclass5355->definitionModule = modulename;
  objclass5355->definitionLine = 246;
  (*(struct UserObject *)self).data[0] = lowerouter5355;
  self = oldself5355;
  selfslot = oldselfslot5355;
  stackframe = oldstackframe5355;
  gc_frame_end(frame);
  return obj5355;
}
Object meth_collectionsPrelude_enumerable5450(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 34, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "enumerable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for enumerable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for enumerable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  gc_frame_end(frame);
  return *var_enumerable;
}
Object meth_collectionsPrelude_iterator5456(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 299
  setline(299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5457 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5458 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5459 = gc_frame_new();
// call case 3: self.outer request
  Object call5460 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5459);
// compiled call node returning call5460 (depth = 9)
// compiled member node returning call5460 (depth = 8)
  partcv[0] = 0;
  Object call5461 = callmethodflags(call5460, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5458);
// compiled call node returning call5461 (depth = 7)
// compiled member node returning call5461 (depth = 6)
  partcv[0] = 0;
  Object call5462 = callmethodflags(call5461, "abstract", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5457);
// compiled call node returning call5462 (depth = 5)
// compiled member node returning call5462 (depth = 4)
  gc_frame_end(frame);
  return call5462;
}
Object meth_collectionsPrelude_size5463(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "size");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_SizeUnknown = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for size (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for size");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 302
  setline(302);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5464 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5466 == NULL) {
    strlit5466 = alloc_String("");
    gc_root(strlit5466);
  }
// compiled string node returning strlit5466 (depth = 6)
  int op_slot_right_5465 = gc_frame_newslot(strlit5466);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5469 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5470 = callmethodflags(self, "asDebugString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5469);
// compiled call node returning call5470 (depth = 8)
// compiled member node returning call5470 (depth = 7)
  int op_slot_right_5468 = gc_frame_newslot(call5470);
// starting to compile string node (depth = 7)
  if (strlit5472 == NULL) {
    strlit5472 = alloc_String("size requested on ");
    gc_root(strlit5472);
  }
// compiled string node returning strlit5472 (depth = 7)
  int op_slot_left_5468 = gc_frame_newslot(strlit5472);
  params[0] = call5470;
  partcv[0] = 1;
  Object opresult5473 = callmethod(strlit5472, "++", 1, partcv, params);
// compiled op node returning opresult5473 (depth = 6)
  int op_slot_left_5465 = gc_frame_newslot(opresult5473);
  params[0] = strlit5466;
  partcv[0] = 1;
  Object opresult5474 = callmethod(opresult5473, "++", 1, partcv, params);
// compiled op node returning opresult5474 (depth = 5)
  gc_frame_newslot(opresult5474);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_SizeUnknown (depth = 5)
  params[0] = opresult5474;
  partcv[0] = 1;
  Object call5475 = callmethod(*var_SizeUnknown, "raise",
    1, partcv, params);
  gc_frame_end(callframe5464);
// compiled call node returning call5475 (depth = 4)
  gc_frame_end(frame);
  return call5475;
}
Object meth_collectionsPrelude__apply5487(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_result = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  Object *var_v = &(stackframe->slots[1]);
  *var_v = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 307
  setline(307);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5488 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_k (depth = 7)
  gc_frame_newslot(*var_k);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_v (depth = 7)
  gc_frame_newslot(*var_v);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_result (depth = 7)
  params[0] = *var_k;
  params[1] = *var_v;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5489 = callmethod(*var_result, "at()put",
    2, partcv, params);
  gc_frame_end(callframe5488);
// compiled call node returning call5489 (depth = 6)
  gc_frame_end(frame);
  return call5489;
}
Object meth_collectionsPrelude_asDictionary5476(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asDictionary");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asDictionary (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asDictionary");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "result");
// Begin line 305
  setline(305);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5477 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5478 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5479 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe5480 = gc_frame_new();
// call case 3: self.outer request
  Object call5481 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5480);
// compiled call node returning call5481 (depth = 12)
// compiled member node returning call5481 (depth = 11)
  partcv[0] = 0;
  Object call5482 = callmethodflags(call5481, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5479);
// compiled call node returning call5482 (depth = 10)
// compiled member node returning call5482 (depth = 9)
  partcv[0] = 0;
  Object call5483 = callmethodflags(call5482, "dictionary", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5478);
// compiled call node returning call5483 (depth = 8)
// compiled member node returning call5483 (depth = 7)
  partcv[0] = 0;
  Object call5484 = callmethod(call5483, "empty",
    1, partcv, params);
  gc_frame_end(callframe5477);
// compiled call node returning call5484 (depth = 6)
// compiled member node returning call5484 (depth = 5)
  *var_result = call5484;
  if (call5484 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 306
  setline(306);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5485 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block5486 = alloc_Block(NULL, NULL, "collectionsPrelude", 306);
  gc_frame_newslot(block5486);
// method _apply
  block_savedest(block5486);
  Object closure5487 = createclosure(2, "_apply");
  setclosureframe(closure5487, stackframe);
  addtoclosure(closure5487, var_result);
  addtoclosure(closure5487, selfslot);
  struct UserObject *uo5487 = (struct UserObject*)block5486;
  uo5487->data[0] = (Object)closure5487;
  Method *meth_meth_collectionsPrelude__apply5487 = addmethod2pos(block5486, "_apply", &meth_collectionsPrelude__apply5487, 0);
  int argcv_meth_collectionsPrelude__apply5487[] = {2};
  meth_meth_collectionsPrelude__apply5487->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5487);
  meth_meth_collectionsPrelude__apply5487->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5487->definitionLine = 305;
// compiled block node returning block5486 (depth = 5)
  gc_frame_newslot(block5486);
// call case 4: self request
  params[0] = block5486;
  partcv[0] = 1;
  Object call5491 = callmethodflags(self, "keysAndValuesDo", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5485);
// compiled call node returning call5491 (depth = 4)
// Begin line 309
  setline(309);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  return *var_result;
// compiled return node returning undefined (depth = 4)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_onto5492(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "onto");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method onto");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for onto (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_f = &(stackframe->slots[0]);
  *var_f = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for onto");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 312
  setline(312);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5493 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_f (depth = 5)
  params[0] = self;
  partcv[0] = 1;
  Object call5494 = callmethod(*var_f, "withAll",
    1, partcv, params);
  gc_frame_end(callframe5493);
// compiled call node returning call5494 (depth = 4)
  gc_frame_end(frame);
  return call5494;
}
Object meth_collectionsPrelude__apply5500(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_selfIterator = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5501 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_selfIterator (depth = 8)
  partcv[0] = 0;
  Object call5502 = callmethod(*var_selfIterator, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe5501);
// compiled call node returning call5502 (depth = 7)
// compiled member node returning call5502 (depth = 6)
  gc_frame_end(frame);
  return call5502;
}
Object meth_collectionsPrelude__apply5505(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_selfIterator = getfromclosure(closure, 0);
  Object *var_existing = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 317
  setline(317);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5506 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5507 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_selfIterator (depth = 9)
  partcv[0] = 0;
  Object call5508 = callmethod(*var_selfIterator, "next",
    1, partcv, params);
  gc_frame_end(callframe5507);
// compiled call node returning call5508 (depth = 8)
// compiled member node returning call5508 (depth = 7)
  gc_frame_newslot(call5508);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_existing (depth = 7)
  params[0] = call5508;
  partcv[0] = 1;
  Object call5509 = callmethod(*var_existing, "add",
    1, partcv, params);
  gc_frame_end(callframe5506);
// compiled call node returning call5509 (depth = 6)
  gc_frame_end(frame);
  return call5509;
}
Object meth_collectionsPrelude_into5495(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "into");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method into");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for into (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_existing = &(stackframe->slots[0]);
  *var_existing = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for into");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_selfIterator = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "selfIterator");
// Begin line 315
  setline(315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5496 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5497 = callmethodflags(self, "iterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5496);
// compiled call node returning call5497 (depth = 6)
// compiled member node returning call5497 (depth = 5)
  *var_selfIterator = call5497;
  if (call5497 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 316
  setline(316);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5498 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block5499 = alloc_Block(NULL, NULL, "collectionsPrelude", 316);
  gc_frame_newslot(block5499);
// method _apply
  block_savedest(block5499);
  Object closure5500 = createclosure(2, "_apply");
  setclosureframe(closure5500, stackframe);
  addtoclosure(closure5500, var_selfIterator);
  addtoclosure(closure5500, selfslot);
  struct UserObject *uo5500 = (struct UserObject*)block5499;
  uo5500->data[0] = (Object)closure5500;
  Method *meth_meth_collectionsPrelude__apply5500 = addmethod2pos(block5499, "_apply", &meth_collectionsPrelude__apply5500, 0);
  int argcv_meth_collectionsPrelude__apply5500[] = {0};
  meth_meth_collectionsPrelude__apply5500->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5500);
  meth_meth_collectionsPrelude__apply5500->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5500->definitionLine = 315;
// compiled block node returning block5499 (depth = 5)
  gc_frame_newslot(block5499);
// starting to compile block node (depth = 5)
  Object block5504 = alloc_Block(NULL, NULL, "collectionsPrelude", 316);
  gc_frame_newslot(block5504);
// method _apply
  block_savedest(block5504);
  Object closure5505 = createclosure(3, "_apply");
  setclosureframe(closure5505, stackframe);
  addtoclosure(closure5505, var_selfIterator);
  addtoclosure(closure5505, var_existing);
  addtoclosure(closure5505, selfslot);
  struct UserObject *uo5505 = (struct UserObject*)block5504;
  uo5505->data[0] = (Object)closure5505;
  Method *meth_meth_collectionsPrelude__apply5505 = addmethod2pos(block5504, "_apply", &meth_collectionsPrelude__apply5505, 0);
  int argcv_meth_collectionsPrelude__apply5505[] = {0};
  meth_meth_collectionsPrelude__apply5505->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5505);
  meth_meth_collectionsPrelude__apply5505->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5505->definitionLine = 316;
// compiled block node returning block5504 (depth = 5)
  gc_frame_newslot(block5504);
// call case 5: prelude request
  params[0] = block5499;
  params[1] = block5504;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5511 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5498);
// compiled call node returning call5511 (depth = 4)
// Begin line 319
  setline(319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_existing (depth = 4)
  gc_frame_end(frame);
  return *var_existing;
}
Object meth_collectionsPrelude__apply5522(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_otherIter = getfromclosure(closure, 0);
  Object *var_selfIter = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5524 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_otherIter (depth = 11)
  partcv[0] = 0;
  Object call5525 = callmethod(*var_otherIter, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe5524);
// compiled call node returning call5525 (depth = 10)
// compiled member node returning call5525 (depth = 9)
  int op_slot_right_5523 = gc_frame_newslot(call5525);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5527 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_selfIter (depth = 11)
  partcv[0] = 0;
  Object call5528 = callmethod(*var_selfIter, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe5527);
// compiled call node returning call5528 (depth = 10)
// compiled member node returning call5528 (depth = 9)
  int op_slot_left_5523 = gc_frame_newslot(call5528);
  params[0] = call5525;
  partcv[0] = 1;
  Object opresult5529 = callmethod(call5528, "&&", 1, partcv, params);
// compiled op node returning opresult5529 (depth = 8)
  gc_frame_end(frame);
  return opresult5529;
}
Object meth_collectionsPrelude__apply5532(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_otherIter = getfromclosure(closure, 0);
  Object *var_selfIter = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 328
  setline(328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe5535 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_otherIter (depth = 12)
  partcv[0] = 0;
  Object call5536 = callmethod(*var_otherIter, "next",
    1, partcv, params);
  gc_frame_end(callframe5535);
// compiled call node returning call5536 (depth = 11)
// compiled member node returning call5536 (depth = 10)
  int op_slot_right_5534 = gc_frame_newslot(call5536);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe5538 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_selfIter (depth = 12)
  partcv[0] = 0;
  Object call5539 = callmethod(*var_selfIter, "next",
    1, partcv, params);
  gc_frame_end(callframe5538);
// compiled call node returning call5539 (depth = 11)
// compiled member node returning call5539 (depth = 10)
  int op_slot_left_5534 = gc_frame_newslot(call5539);
  params[0] = call5536;
  partcv[0] = 1;
  Object opresult5540 = callmethod(call5539, "!=", 1, partcv, params);
// compiled op node returning opresult5540 (depth = 9)
  Object if5533 = done;
  if (istrue(opresult5540)) {
// Begin line 329
  setline(329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 9)
// starting to compile identifier node (depth = 10)
  Object bool5541 = alloc_Boolean(0);
// compiled identifier node returning bool5541 (depth = 10)
  block_return(realself, bool5541);
// compiled return node returning undefined (depth = 9)
    gc_frame_newslot(undefined);
    if5533 = undefined;
  } else {
  }
// compiled if node returning if5533 (depth = 8)
  gc_frame_end(frame);
  return if5533;
}
Object meth_collectionsPrelude__apply5515(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_other = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_selfIter = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "selfIter");
  Object *var_otherIter = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "otherIter");
  Object *var_result = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "result");
// Begin line 325
  setline(325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5516 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5517 = callmethodflags(self, "iterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5516);
// compiled call node returning call5517 (depth = 8)
// compiled member node returning call5517 (depth = 7)
  *var_selfIter = call5517;
  if (call5517 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 326
  setline(326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5518 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_other (depth = 9)
  partcv[0] = 0;
  Object call5519 = callmethod(*var_other, "iterator",
    1, partcv, params);
  gc_frame_end(callframe5518);
// compiled call node returning call5519 (depth = 8)
// compiled member node returning call5519 (depth = 7)
  *var_otherIter = call5519;
  if (call5519 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 327
  setline(327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5520 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block5521 = alloc_Block(NULL, NULL, "collectionsPrelude", 327);
  gc_frame_newslot(block5521);
// method _apply
  block_savedest(block5521);
  Object closure5522 = createclosure(3, "_apply");
  setclosureframe(closure5522, stackframe);
  addtoclosure(closure5522, var_otherIter);
  addtoclosure(closure5522, var_selfIter);
  addtoclosure(closure5522, selfslot);
  struct UserObject *uo5522 = (struct UserObject*)block5521;
  uo5522->data[0] = (Object)closure5522;
  Method *meth_meth_collectionsPrelude__apply5522 = addmethod2pos(block5521, "_apply", &meth_collectionsPrelude__apply5522, 0);
  int argcv_meth_collectionsPrelude__apply5522[] = {0};
  meth_meth_collectionsPrelude__apply5522->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5522);
  meth_meth_collectionsPrelude__apply5522->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5522->definitionLine = 326;
// compiled block node returning block5521 (depth = 7)
  gc_frame_newslot(block5521);
// starting to compile block node (depth = 7)
  Object block5531 = alloc_Block(NULL, NULL, "collectionsPrelude", 327);
  gc_frame_newslot(block5531);
// method _apply
  block_savedest(block5531);
  Object closure5532 = createclosure(3, "_apply");
  setclosureframe(closure5532, stackframe);
  addtoclosure(closure5532, var_otherIter);
  addtoclosure(closure5532, var_selfIter);
  addtoclosure(closure5532, selfslot);
  struct UserObject *uo5532 = (struct UserObject*)block5531;
  uo5532->data[0] = (Object)closure5532;
  Method *meth_meth_collectionsPrelude__apply5532 = addmethod2pos(block5531, "_apply", &meth_collectionsPrelude__apply5532, 0);
  int argcv_meth_collectionsPrelude__apply5532[] = {0};
  meth_meth_collectionsPrelude__apply5532->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5532);
  meth_meth_collectionsPrelude__apply5532->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5532->definitionLine = 327;
// compiled block node returning block5531 (depth = 7)
  gc_frame_newslot(block5531);
// call case 5: prelude request
  params[0] = block5521;
  params[1] = block5531;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5543 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5520);
// compiled call node returning call5543 (depth = 6)
// Begin line 332
  setline(332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5545 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_otherIter (depth = 10)
  partcv[0] = 0;
  Object call5546 = callmethod(*var_otherIter, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe5545);
// compiled call node returning call5546 (depth = 9)
// compiled member node returning call5546 (depth = 8)
  int op_slot_right_5544 = gc_frame_newslot(call5546);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5548 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_selfIter (depth = 10)
  partcv[0] = 0;
  Object call5549 = callmethod(*var_selfIter, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe5548);
// compiled call node returning call5549 (depth = 9)
// compiled member node returning call5549 (depth = 8)
  int op_slot_left_5544 = gc_frame_newslot(call5549);
  params[0] = call5546;
  partcv[0] = 1;
  Object opresult5550 = callmethod(call5549, "==", 1, partcv, params);
// compiled op node returning opresult5550 (depth = 7)
  *var_result = opresult5550;
  if (opresult5550 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 333
  setline(333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_result (depth = 7)
  block_return(realself, *var_result);
// compiled return node returning undefined (depth = 6)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply5562(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___12 = &(stackframe->slots[0]);
  *var___12 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 336
  setline(336);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool5563 = alloc_Boolean(0);
// compiled identifier node returning bool5563 (depth = 7)
  block_return(realself, bool5563);
// compiled return node returning undefined (depth = 6)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__61__61_5512(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "==");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method ==");
  Object params[2];
  int partcv[1];
  Object *var_Collection = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for == (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for ==");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 323
  setline(323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  int frame5513 = gc_frame_new();
  gc_frame_newslot(*var_other);
// Begin line 324
  setline(324);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 5)
  Object block5514 = alloc_Block(NULL, NULL, "collectionsPrelude", 324);
  gc_frame_newslot(block5514);
// method _apply
  block_savedest(block5514);
  Object closure5515 = createclosure(2, "_apply");
  setclosureframe(closure5515, stackframe);
  addtoclosure(closure5515, var_other);
  addtoclosure(closure5515, selfslot);
  struct UserObject *uo5515 = (struct UserObject*)block5514;
  uo5515->data[0] = (Object)closure5515;
  Method *meth_meth_collectionsPrelude__apply5515 = addmethod2pos(block5514, "_apply", &meth_collectionsPrelude__apply5515, 0);
  int argcv_meth_collectionsPrelude__apply5515[] = {1};
  meth_meth_collectionsPrelude__apply5515->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5515);
  meth_meth_collectionsPrelude__apply5515->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5515->definitionLine = 317;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5552 = gc_frame_new();
// starting to compile call node (depth = 7)
  int callframe5553 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit5554 == NULL) {
    strlit5554 = alloc_String("o");
    gc_root(strlit5554);
  }
// compiled string node returning strlit5554 (depth = 8)
  gc_frame_newslot(strlit5554);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5555 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5556 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5555);
// compiled call node returning call5556 (depth = 9)
// compiled member node returning call5556 (depth = 8)
  params[0] = strlit5554;
  partcv[0] = 1;
  Object call5557 = callmethod(call5556, "new",
    1, partcv, params);
  gc_frame_end(callframe5553);
// compiled call node returning call5557 (depth = 7)
  gc_frame_newslot(call5557);
// Begin line 324
  setline(324);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Collection (depth = 7)
  gc_frame_newslot(*var_Collection);
// call case 6: other member request
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5558 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5559 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5558);
// compiled call node returning call5559 (depth = 8)
// compiled member node returning call5559 (depth = 7)
  params[0] = call5557;
  params[1] = *var_Collection;
  partcv[0] = 2;
  Object call5560 = callmethod(call5559, "new",
    1, partcv, params);
  gc_frame_end(callframe5552);
// compiled call node returning call5560 (depth = 6)
((struct UserObject *)block5514)->data[1] = call5560;
// compiled block node returning block5514 (depth = 5)
  gc_frame_newslot(block5514);
// Begin line 335
  setline(335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 5)
  Object block5561 = alloc_Block(NULL, NULL, "collectionsPrelude", 335);
  gc_frame_newslot(block5561);
// method _apply
  block_savedest(block5561);
  Object closure5562 = createclosure(1, "_apply");
  setclosureframe(closure5562, stackframe);
  addtoclosure(closure5562, selfslot);
  struct UserObject *uo5562 = (struct UserObject*)block5561;
  uo5562->data[0] = (Object)closure5562;
  Method *meth_meth_collectionsPrelude__apply5562 = addmethod2pos(block5561, "_apply", &meth_collectionsPrelude__apply5562, 0);
  int argcv_meth_collectionsPrelude__apply5562[] = {1};
  meth_meth_collectionsPrelude__apply5562->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5562);
  meth_meth_collectionsPrelude__apply5562->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5562->definitionLine = 0;
// compiled block node returning block5561 (depth = 5)
  gc_frame_newslot(block5561);
  params[0] = block5514;
  params[1] = block5561;
  Object matchres5513 = matchCase(*var_other, params, 2,NULL);
  gc_frame_end(frame5513);
// compiled matchcase node returning matchres5513 (depth = 4)
  gc_frame_end(frame);
  return matchres5513;
}
Object meth_collectionsPrelude__apply5570(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_selfIterator = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5571 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_selfIterator (depth = 8)
  partcv[0] = 0;
  Object call5572 = callmethod(*var_selfIterator, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe5571);
// compiled call node returning call5572 (depth = 7)
// compiled member node returning call5572 (depth = 6)
  gc_frame_end(frame);
  return call5572;
}
Object meth_collectionsPrelude__apply5575(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_selfIterator = getfromclosure(closure, 0);
  Object *var_block1 = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 342
  setline(342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5576 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5577 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_selfIterator (depth = 9)
  partcv[0] = 0;
  Object call5578 = callmethod(*var_selfIterator, "next",
    1, partcv, params);
  gc_frame_end(callframe5577);
// compiled call node returning call5578 (depth = 8)
// compiled member node returning call5578 (depth = 7)
  gc_frame_newslot(call5578);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_block1 (depth = 7)
  params[0] = call5578;
  partcv[0] = 1;
  Object call5579 = callmethod(*var_block1, "apply",
    1, partcv, params);
  gc_frame_end(callframe5576);
// compiled call node returning call5579 (depth = 6)
  gc_frame_end(frame);
  return call5579;
}
Object meth_collectionsPrelude_do5565(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method do");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for do (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for do");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_selfIterator = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "selfIterator");
// Begin line 340
  setline(340);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5566 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5567 = callmethodflags(self, "iterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5566);
// compiled call node returning call5567 (depth = 6)
// compiled member node returning call5567 (depth = 5)
  *var_selfIterator = call5567;
  if (call5567 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 341
  setline(341);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5568 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block5569 = alloc_Block(NULL, NULL, "collectionsPrelude", 341);
  gc_frame_newslot(block5569);
// method _apply
  block_savedest(block5569);
  Object closure5570 = createclosure(2, "_apply");
  setclosureframe(closure5570, stackframe);
  addtoclosure(closure5570, var_selfIterator);
  addtoclosure(closure5570, selfslot);
  struct UserObject *uo5570 = (struct UserObject*)block5569;
  uo5570->data[0] = (Object)closure5570;
  Method *meth_meth_collectionsPrelude__apply5570 = addmethod2pos(block5569, "_apply", &meth_collectionsPrelude__apply5570, 0);
  int argcv_meth_collectionsPrelude__apply5570[] = {0};
  meth_meth_collectionsPrelude__apply5570->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5570);
  meth_meth_collectionsPrelude__apply5570->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5570->definitionLine = 340;
// compiled block node returning block5569 (depth = 5)
  gc_frame_newslot(block5569);
// starting to compile block node (depth = 5)
  Object block5574 = alloc_Block(NULL, NULL, "collectionsPrelude", 341);
  gc_frame_newslot(block5574);
// method _apply
  block_savedest(block5574);
  Object closure5575 = createclosure(3, "_apply");
  setclosureframe(closure5575, stackframe);
  addtoclosure(closure5575, var_selfIterator);
  addtoclosure(closure5575, var_block1);
  addtoclosure(closure5575, selfslot);
  struct UserObject *uo5575 = (struct UserObject*)block5574;
  uo5575->data[0] = (Object)closure5575;
  Method *meth_meth_collectionsPrelude__apply5575 = addmethod2pos(block5574, "_apply", &meth_collectionsPrelude__apply5575, 0);
  int argcv_meth_collectionsPrelude__apply5575[] = {0};
  meth_meth_collectionsPrelude__apply5575->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5575);
  meth_meth_collectionsPrelude__apply5575->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5575->definitionLine = 341;
// compiled block node returning block5574 (depth = 5)
  gc_frame_newslot(block5574);
// call case 5: prelude request
  params[0] = block5569;
  params[1] = block5574;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5581 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5568);
// compiled call node returning call5581 (depth = 4)
  gc_frame_end(frame);
  return call5581;
}
Object meth_collectionsPrelude__apply5588(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_selfIterator = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5589 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_selfIterator (depth = 8)
  partcv[0] = 0;
  Object call5590 = callmethod(*var_selfIterator, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe5589);
// compiled call node returning call5590 (depth = 7)
// compiled member node returning call5590 (depth = 6)
  gc_frame_end(frame);
  return call5590;
}
Object meth_collectionsPrelude__apply5593(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_ix = getfromclosure(closure, 0);
  Object *var_selfIterator = getfromclosure(closure, 1);
  Object *var_block2 = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 6)
// Begin line 349
  setline(349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num5595 = alloc_Float64(1);
// compiled num node returning num5595 (depth = 8)
  int op_slot_right_5594 = gc_frame_newslot(num5595);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ix (depth = 8)
  int op_slot_left_5594 = gc_frame_newslot(*var_ix);
  params[0] = num5595;
  partcv[0] = 1;
  Object sum5597 = callmethod(*var_ix, "+", 1, partcv, params);
// compiled op node returning sum5597 (depth = 7)
  *var_ix = sum5597;
  if (sum5597 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 350
  setline(350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5599 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ix (depth = 7)
  gc_frame_newslot(*var_ix);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5600 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_selfIterator (depth = 9)
  partcv[0] = 0;
  Object call5601 = callmethod(*var_selfIterator, "next",
    1, partcv, params);
  gc_frame_end(callframe5600);
// compiled call node returning call5601 (depth = 8)
// compiled member node returning call5601 (depth = 7)
  gc_frame_newslot(call5601);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_block2 (depth = 7)
  params[0] = *var_ix;
  params[1] = call5601;
  partcv[0] = 2;
  Object call5602 = callmethod(*var_block2, "apply",
    1, partcv, params);
  gc_frame_end(callframe5599);
// compiled call node returning call5602 (depth = 6)
  gc_frame_end(frame);
  return call5602;
}
Object meth_collectionsPrelude_keysAndValuesDo5582(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keysAndValuesDo");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method keysAndValuesDo");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for keysAndValuesDo (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block2 = &(stackframe->slots[0]);
  *var_block2 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for keysAndValuesDo");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ix = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "ix");
  Object *var_selfIterator = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "selfIterator");
// Begin line 346
  setline(346);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile num node (depth = 5)
  Object num5583 = alloc_Float64(0);
// compiled num node returning num5583 (depth = 5)
  *var_ix = num5583;
  if (num5583 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 347
  setline(347);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5584 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5585 = callmethodflags(self, "iterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5584);
// compiled call node returning call5585 (depth = 6)
// compiled member node returning call5585 (depth = 5)
  *var_selfIterator = call5585;
  if (call5585 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 348
  setline(348);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5586 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block5587 = alloc_Block(NULL, NULL, "collectionsPrelude", 348);
  gc_frame_newslot(block5587);
// method _apply
  block_savedest(block5587);
  Object closure5588 = createclosure(2, "_apply");
  setclosureframe(closure5588, stackframe);
  addtoclosure(closure5588, var_selfIterator);
  addtoclosure(closure5588, selfslot);
  struct UserObject *uo5588 = (struct UserObject*)block5587;
  uo5588->data[0] = (Object)closure5588;
  Method *meth_meth_collectionsPrelude__apply5588 = addmethod2pos(block5587, "_apply", &meth_collectionsPrelude__apply5588, 0);
  int argcv_meth_collectionsPrelude__apply5588[] = {0};
  meth_meth_collectionsPrelude__apply5588->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5588);
  meth_meth_collectionsPrelude__apply5588->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5588->definitionLine = 347;
// compiled block node returning block5587 (depth = 5)
  gc_frame_newslot(block5587);
// starting to compile block node (depth = 5)
  Object block5592 = alloc_Block(NULL, NULL, "collectionsPrelude", 348);
  gc_frame_newslot(block5592);
// method _apply
  block_savedest(block5592);
  Object closure5593 = createclosure(4, "_apply");
  setclosureframe(closure5593, stackframe);
  addtoclosure(closure5593, var_ix);
  addtoclosure(closure5593, var_selfIterator);
  addtoclosure(closure5593, var_block2);
  addtoclosure(closure5593, selfslot);
  struct UserObject *uo5593 = (struct UserObject*)block5592;
  uo5593->data[0] = (Object)closure5593;
  Method *meth_meth_collectionsPrelude__apply5593 = addmethod2pos(block5592, "_apply", &meth_collectionsPrelude__apply5593, 0);
  int argcv_meth_collectionsPrelude__apply5593[] = {0};
  meth_meth_collectionsPrelude__apply5593->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5593);
  meth_meth_collectionsPrelude__apply5593->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5593->definitionLine = 348;
// compiled block node returning block5592 (depth = 5)
  gc_frame_newslot(block5592);
// call case 5: prelude request
  params[0] = block5587;
  params[1] = block5592;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5604 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5586);
// compiled call node returning call5604 (depth = 4)
  gc_frame_end(frame);
  return call5604;
}
Object meth_collectionsPrelude_values5605(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "values");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for values (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for values");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 354
  setline(354);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply5611(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_selfIterator = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5612 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_selfIterator (depth = 8)
  partcv[0] = 0;
  Object call5613 = callmethod(*var_selfIterator, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe5612);
// compiled call node returning call5613 (depth = 7)
// compiled member node returning call5613 (depth = 6)
  gc_frame_end(frame);
  return call5613;
}
Object meth_collectionsPrelude__apply5616(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_res = getfromclosure(closure, 0);
  Object *var_selfIterator = getfromclosure(closure, 1);
  Object *var_block2 = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 6)
// Begin line 360
  setline(360);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5617 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_res (depth = 8)
  gc_frame_newslot(*var_res);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5618 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_selfIterator (depth = 10)
  partcv[0] = 0;
  Object call5619 = callmethod(*var_selfIterator, "next",
    1, partcv, params);
  gc_frame_end(callframe5618);
// compiled call node returning call5619 (depth = 9)
// compiled member node returning call5619 (depth = 8)
  gc_frame_newslot(call5619);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_block2 (depth = 8)
  params[0] = *var_res;
  params[1] = call5619;
  partcv[0] = 2;
  Object call5620 = callmethod(*var_block2, "apply",
    1, partcv, params);
  gc_frame_end(callframe5617);
// compiled call node returning call5620 (depth = 7)
  *var_res = call5620;
  if (call5620 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_fold_40__41_startingWith5606(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(6, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "fold()startingWith");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method fold()startingWith");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method fold()startingWith");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for fold()startingWith (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_block2 = &(stackframe->slots[0]);
  *var_block2 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for fold");
  Object *var_initial = &(stackframe->slots[1]);
  *var_initial = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for startingWith");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start generics
  Object *var_R = &(stackframe->slots[3]);
  if (nparts == 1 + 2 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      gracedie("insufficient generic parameters");
    }
    *var_R = args[curarg++];
  } else {
    *var_R = Unknown;
  }
// End generics
  Object *var_res = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "res");
  Object *var_selfIterator = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "selfIterator");
// Begin line 357
  setline(357);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_initial (depth = 5)
  *var_res = *var_initial;
  if (*var_initial == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 358
  setline(358);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5607 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5608 = callmethodflags(self, "iterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5607);
// compiled call node returning call5608 (depth = 6)
// compiled member node returning call5608 (depth = 5)
  *var_selfIterator = call5608;
  if (call5608 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 359
  setline(359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5609 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block5610 = alloc_Block(NULL, NULL, "collectionsPrelude", 359);
  gc_frame_newslot(block5610);
// method _apply
  block_savedest(block5610);
  Object closure5611 = createclosure(2, "_apply");
  setclosureframe(closure5611, stackframe);
  addtoclosure(closure5611, var_selfIterator);
  addtoclosure(closure5611, selfslot);
  struct UserObject *uo5611 = (struct UserObject*)block5610;
  uo5611->data[0] = (Object)closure5611;
  Method *meth_meth_collectionsPrelude__apply5611 = addmethod2pos(block5610, "_apply", &meth_collectionsPrelude__apply5611, 0);
  int argcv_meth_collectionsPrelude__apply5611[] = {0};
  meth_meth_collectionsPrelude__apply5611->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5611);
  meth_meth_collectionsPrelude__apply5611->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5611->definitionLine = 358;
// compiled block node returning block5610 (depth = 5)
  gc_frame_newslot(block5610);
// starting to compile block node (depth = 5)
  Object block5615 = alloc_Block(NULL, NULL, "collectionsPrelude", 359);
  gc_frame_newslot(block5615);
// method _apply
  block_savedest(block5615);
  Object closure5616 = createclosure(4, "_apply");
  setclosureframe(closure5616, stackframe);
  addtoclosure(closure5616, var_res);
  addtoclosure(closure5616, var_selfIterator);
  addtoclosure(closure5616, var_block2);
  addtoclosure(closure5616, selfslot);
  struct UserObject *uo5616 = (struct UserObject*)block5615;
  uo5616->data[0] = (Object)closure5616;
  Method *meth_meth_collectionsPrelude__apply5616 = addmethod2pos(block5615, "_apply", &meth_collectionsPrelude__apply5616, 0);
  int argcv_meth_collectionsPrelude__apply5616[] = {0};
  meth_meth_collectionsPrelude__apply5616->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5616);
  meth_meth_collectionsPrelude__apply5616->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5616->definitionLine = 359;
// compiled block node returning block5615 (depth = 5)
  gc_frame_newslot(block5615);
// call case 5: prelude request
  params[0] = block5610;
  params[1] = block5615;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5623 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5609);
// compiled call node returning call5623 (depth = 4)
// Begin line 362
  setline(362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_res (depth = 5)
  return *var_res;
// compiled return node returning undefined (depth = 4)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__43__43_5624(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "++");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method ++");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for ++ (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for ++");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 365
  setline(365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5625 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  gc_frame_newslot(*var_other);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5626 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5627 = gc_frame_new();
// call case 3: self.outer request
  Object call5628 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5627);
// compiled call node returning call5628 (depth = 8)
// compiled member node returning call5628 (depth = 7)
  partcv[0] = 0;
  Object call5629 = callmethodflags(call5628, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5626);
// compiled call node returning call5629 (depth = 6)
// compiled member node returning call5629 (depth = 5)
  params[0] = self;
  params[1] = *var_other;
  partcv[0] = 2;
  Object call5630 = callmethodflags(call5629, "lazyConcatenation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5625);
// compiled call node returning call5630 (depth = 4)
  gc_frame_end(frame);
  return call5630;
}
Object meth_collectionsPrelude_sortedBy5631(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sortedBy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method sortedBy");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for sortedBy (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_sortBlock = &(stackframe->slots[0]);
  *var_sortBlock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for sortedBy");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 368
  setline(368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5632 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sortBlock (depth = 5)
  gc_frame_newslot(*var_sortBlock);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5633 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5634 = callmethodflags(self, "asList", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5633);
// compiled call node returning call5634 (depth = 6)
// compiled member node returning call5634 (depth = 5)
  params[0] = *var_sortBlock;
  partcv[0] = 1;
  Object call5635 = callmethod(call5634, "sortBy",
    1, partcv, params);
  gc_frame_end(callframe5632);
// compiled call node returning call5635 (depth = 4)
  gc_frame_end(frame);
  return call5635;
}
Object meth_collectionsPrelude_sorted5636(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sorted");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for sorted (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for sorted");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 371
  setline(371);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5637 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5638 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5639 = callmethodflags(self, "asList", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5638);
// compiled call node returning call5639 (depth = 7)
// compiled member node returning call5639 (depth = 6)
  partcv[0] = 0;
  Object call5640 = callmethod(call5639, "sort",
    1, partcv, params);
  gc_frame_end(callframe5637);
// compiled call node returning call5640 (depth = 5)
// compiled member node returning call5640 (depth = 4)
  gc_frame_end(frame);
  return call5640;
}
Object meth_collectionsPrelude__apply5645(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5647 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_each (depth = 10)
  partcv[0] = 0;
  Object call5648 = callmethod(*var_each, "asString",
    1, partcv, params);
  gc_frame_end(callframe5647);
// compiled call node returning call5648 (depth = 9)
// compiled member node returning call5648 (depth = 8)
  int op_slot_right_5646 = gc_frame_newslot(call5648);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_5646 = gc_frame_newslot(*var_s);
  params[0] = call5648;
  partcv[0] = 1;
  Object opresult5650 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5650 (depth = 7)
  *var_s = opresult5650;
  if (opresult5650 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude__apply5654(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5656 == NULL) {
    strlit5656 = alloc_String(", ");
    gc_root(strlit5656);
  }
// compiled string node returning strlit5656 (depth = 8)
  int op_slot_right_5655 = gc_frame_newslot(strlit5656);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_5655 = gc_frame_newslot(*var_s);
  params[0] = strlit5656;
  partcv[0] = 1;
  Object opresult5658 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5658 (depth = 7)
  *var_s = opresult5658;
  if (opresult5658 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_asString5641(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
// Begin line 374
  setline(374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5642 == NULL) {
    strlit5642 = alloc_String("""\xe2""""\x9f""""\xa8""");
    gc_root(strlit5642);
  }
// compiled string node returning strlit5642 (depth = 5)
  *var_s = strlit5642;
  if (strlit5642 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 375
  setline(375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5643 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block5644 = alloc_Block(NULL, NULL, "collectionsPrelude", 375);
  gc_frame_newslot(block5644);
// method _apply
  block_savedest(block5644);
  Object closure5645 = createclosure(2, "_apply");
  setclosureframe(closure5645, stackframe);
  addtoclosure(closure5645, var_s);
  addtoclosure(closure5645, selfslot);
  struct UserObject *uo5645 = (struct UserObject*)block5644;
  uo5645->data[0] = (Object)closure5645;
  Method *meth_meth_collectionsPrelude__apply5645 = addmethod2pos(block5644, "_apply", &meth_collectionsPrelude__apply5645, 0);
  int argcv_meth_collectionsPrelude__apply5645[] = {1};
  meth_meth_collectionsPrelude__apply5645->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5645);
  meth_meth_collectionsPrelude__apply5645->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5645->definitionLine = 371;
// compiled block node returning block5644 (depth = 5)
  gc_frame_newslot(block5644);
// starting to compile block node (depth = 5)
  Object block5653 = alloc_Block(NULL, NULL, "collectionsPrelude", 375);
  gc_frame_newslot(block5653);
// method _apply
  block_savedest(block5653);
  Object closure5654 = createclosure(2, "_apply");
  setclosureframe(closure5654, stackframe);
  addtoclosure(closure5654, var_s);
  addtoclosure(closure5654, selfslot);
  struct UserObject *uo5654 = (struct UserObject*)block5653;
  uo5654->data[0] = (Object)closure5654;
  Method *meth_meth_collectionsPrelude__apply5654 = addmethod2pos(block5653, "_apply", &meth_collectionsPrelude__apply5654, 0);
  int argcv_meth_collectionsPrelude__apply5654[] = {0};
  meth_meth_collectionsPrelude__apply5654->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5654);
  meth_meth_collectionsPrelude__apply5654->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5654->definitionLine = 375;
// compiled block node returning block5653 (depth = 5)
  gc_frame_newslot(block5653);
// call case 4: self request
  params[0] = block5644;
  params[1] = block5653;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5661 = callmethodflags(self, "do()separatedBy", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5643);
// compiled call node returning call5661 (depth = 4)
// Begin line 376
  setline(376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5663 == NULL) {
    strlit5663 = alloc_String("""\xe2""""\x9f""""\xa9""");
    gc_root(strlit5663);
  }
// compiled string node returning strlit5663 (depth = 5)
  int op_slot_right_5662 = gc_frame_newslot(strlit5663);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_5662 = gc_frame_newslot(*var_s);
  params[0] = strlit5663;
  partcv[0] = 1;
  Object opresult5665 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5665 (depth = 4)
  gc_frame_end(frame);
  return opresult5665;
}
Object meth_collectionsPrelude_trait5453(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "trait");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_SizeUnknown = getfromclosure(closure, 0);
  Object *var_Collection = getfromclosure(closure, 1);
  Object *var_collection = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for trait (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for trait");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start generics
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      gracedie("insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End generics
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5454 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5454 = alloc_userobj2(15,16, objclass5454);
  gc_frame_newslot(obj5454);
if (objclass5454 == NULL) {
  glfree(obj5454->class->name);
  obj5454->class->name = "enumerable";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5454, self, 0);
  addmethodreal(obj5454,"outer", &reader_collectionsPrelude_outer_5455);
  Object oldself5454 = self;
  struct StackFrameObject *oldstackframe5454 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5454);
  gc_frame_newslot((Object)stackframe);
  self = obj5454;
  Object *oldselfslot5454 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5454 = (*(struct UserObject *)self).data[0], lowerouter5454 = thisouter5454;
  if (inheritingObject5454) {
    struct UserObject *inho5454 = (struct UserObject *)inheritingObject5454;
    while (inho5454->super != GraceDefaultObject) inho5454 = (struct UserObject *)inho5454->super;
    inho5454->super = obj5454;
    self = inheritingObject5454;
    *selfslot = self;
    lowerouter5454 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5454;
  }
// method iterator
  struct UserObject *uo5456 = (struct UserObject*)obj5454;
  uo5456->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_iterator5456 = addmethod2pos(obj5454, "iterator", &meth_collectionsPrelude_iterator5456, 1);
  int argcv_meth_collectionsPrelude_iterator5456[] = {0};
  meth_meth_collectionsPrelude_iterator5456->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator5456);
  meth_meth_collectionsPrelude_iterator5456->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator5456->definitionLine = 299;
// method size
  block_savedest(obj5454);
  Object closure5463 = createclosure(1, "size");
  setclosureframe(closure5463, stackframe);
  addtoclosure(closure5463, var_SizeUnknown);
  struct UserObject *uo5463 = (struct UserObject*)obj5454;
  uo5463->data[2] = (Object)closure5463;
  Method *meth_meth_collectionsPrelude_size5463 = addmethod2pos(obj5454, "size", &meth_collectionsPrelude_size5463, 2);
  int argcv_meth_collectionsPrelude_size5463[] = {0};
  meth_meth_collectionsPrelude_size5463->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size5463);
  meth_meth_collectionsPrelude_size5463->definitionModule = modulename;
  meth_meth_collectionsPrelude_size5463->definitionLine = 300;
// method asDictionary
  struct UserObject *uo5476 = (struct UserObject*)obj5454;
  uo5476->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDictionary5476 = addmethod2pos(obj5454, "asDictionary", &meth_collectionsPrelude_asDictionary5476, 3);
  int argcv_meth_collectionsPrelude_asDictionary5476[] = {0};
  meth_meth_collectionsPrelude_asDictionary5476->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDictionary5476);
  meth_meth_collectionsPrelude_asDictionary5476->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDictionary5476->definitionLine = 304;
// method onto
  struct UserObject *uo5492 = (struct UserObject*)obj5454;
  uo5492->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_onto5492 = addmethod2pos(obj5454, "onto", &meth_collectionsPrelude_onto5492, 4);
  int argcv_meth_collectionsPrelude_onto5492[] = {1};
  meth_meth_collectionsPrelude_onto5492->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_onto5492);
  meth_meth_collectionsPrelude_onto5492->definitionModule = modulename;
  meth_meth_collectionsPrelude_onto5492->definitionLine = 311;
// method into
  struct UserObject *uo5495 = (struct UserObject*)obj5454;
  uo5495->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_into5495 = addmethod2pos(obj5454, "into", &meth_collectionsPrelude_into5495, 5);
  int argcv_meth_collectionsPrelude_into5495[] = {1};
  meth_meth_collectionsPrelude_into5495->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_into5495);
  meth_meth_collectionsPrelude_into5495->definitionModule = modulename;
  meth_meth_collectionsPrelude_into5495->definitionLine = 314;
// method ==
  block_savedest(obj5454);
  Object closure5512 = createclosure(1, "==");
  setclosureframe(closure5512, stackframe);
  addtoclosure(closure5512, var_Collection);
  struct UserObject *uo5512 = (struct UserObject*)obj5454;
  uo5512->data[6] = (Object)closure5512;
  Method *meth_meth_collectionsPrelude__61__61_5512 = addmethod2pos(obj5454, "==", &meth_collectionsPrelude__61__61_5512, 6);
  int argcv_meth_collectionsPrelude__61__61_5512[] = {1};
  meth_meth_collectionsPrelude__61__61_5512->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61_5512);
  meth_meth_collectionsPrelude__61__61_5512->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61_5512->definitionLine = 321;
// method do
  struct UserObject *uo5565 = (struct UserObject*)obj5454;
  uo5565->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do5565 = addmethod2pos(obj5454, "do", &meth_collectionsPrelude_do5565, 7);
  int argcv_meth_collectionsPrelude_do5565[] = {1};
  meth_meth_collectionsPrelude_do5565->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do5565);
  meth_meth_collectionsPrelude_do5565->definitionModule = modulename;
  meth_meth_collectionsPrelude_do5565->definitionLine = 339;
// method keysAndValuesDo
  struct UserObject *uo5582 = (struct UserObject*)obj5454;
  uo5582->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo5582 = addmethod2pos(obj5454, "keysAndValuesDo", &meth_collectionsPrelude_keysAndValuesDo5582, 8);
  int argcv_meth_collectionsPrelude_keysAndValuesDo5582[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo5582->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo5582);
  meth_meth_collectionsPrelude_keysAndValuesDo5582->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo5582->definitionLine = 345;
// method values
  struct UserObject *uo5605 = (struct UserObject*)obj5454;
  uo5605->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values5605 = addmethod2pos(obj5454, "values", &meth_collectionsPrelude_values5605, 9);
  int argcv_meth_collectionsPrelude_values5605[] = {0};
  meth_meth_collectionsPrelude_values5605->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values5605);
  meth_meth_collectionsPrelude_values5605->definitionModule = modulename;
  meth_meth_collectionsPrelude_values5605->definitionLine = 353;
// method fold()startingWith
  struct UserObject *uo5606 = (struct UserObject*)obj5454;
  uo5606->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_fold_40__41_startingWith5606 = addmethod2pos(obj5454, "fold()startingWith", &meth_collectionsPrelude_fold_40__41_startingWith5606, 10);
  int argcv_meth_collectionsPrelude_fold_40__41_startingWith5606[] = {1, 1};
  meth_meth_collectionsPrelude_fold_40__41_startingWith5606->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_fold_40__41_startingWith5606);
  meth_meth_collectionsPrelude_fold_40__41_startingWith5606->definitionModule = modulename;
  meth_meth_collectionsPrelude_fold_40__41_startingWith5606->definitionLine = 356;
// method ++
  struct UserObject *uo5624 = (struct UserObject*)obj5454;
  uo5624->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43_5624 = addmethod2pos(obj5454, "++", &meth_collectionsPrelude__43__43_5624, 11);
  int argcv_meth_collectionsPrelude__43__43_5624[] = {1};
  meth_meth_collectionsPrelude__43__43_5624->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43_5624);
  meth_meth_collectionsPrelude__43__43_5624->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43_5624->definitionLine = 364;
// method sortedBy
  struct UserObject *uo5631 = (struct UserObject*)obj5454;
  uo5631->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy5631 = addmethod2pos(obj5454, "sortedBy", &meth_collectionsPrelude_sortedBy5631, 12);
  int argcv_meth_collectionsPrelude_sortedBy5631[] = {1};
  meth_meth_collectionsPrelude_sortedBy5631->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy5631);
  meth_meth_collectionsPrelude_sortedBy5631->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy5631->definitionLine = 367;
// method sorted
  struct UserObject *uo5636 = (struct UserObject*)obj5454;
  uo5636->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted5636 = addmethod2pos(obj5454, "sorted", &meth_collectionsPrelude_sorted5636, 13);
  int argcv_meth_collectionsPrelude_sorted5636[] = {0};
  meth_meth_collectionsPrelude_sorted5636->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted5636);
  meth_meth_collectionsPrelude_sorted5636->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted5636->definitionLine = 370;
// method asString
  struct UserObject *uo5641 = (struct UserObject*)obj5454;
  uo5641->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString5641 = addmethod2pos(obj5454, "asString", &meth_collectionsPrelude_asString5641, 14);
  int argcv_meth_collectionsPrelude_asString5641[] = {0};
  meth_meth_collectionsPrelude_asString5641->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString5641);
  meth_meth_collectionsPrelude_asString5641->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString5641->definitionLine = 373;
  sourceObject = obj5454;
// Begin line 298
  setline(298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5666 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_collection (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5667 = callmethod(*var_collection, "trait()object",
    2, partcv, params);
  gc_frame_end(callframe5666);
// compiled call node returning call5667 (depth = 4)
  struct UserObject *obj5454_uo = (struct UserObject *)obj5454;
  obj5454_uo->super = call5667;
  sourceObject = obj5454;
  sourceObject = obj5454;
  sourceObject = obj5454;
  sourceObject = obj5454;
  sourceObject = obj5454;
  sourceObject = obj5454;
  sourceObject = obj5454;
  sourceObject = obj5454;
  sourceObject = obj5454;
  sourceObject = obj5454;
  sourceObject = obj5454;
  sourceObject = obj5454;
  sourceObject = obj5454;
  sourceObject = obj5454;
  objclass5454 = obj5454->class;
  objclass5454->definitionModule = modulename;
  objclass5454->definitionLine = 297;
  (*(struct UserObject *)self).data[0] = lowerouter5454;
  self = oldself5454;
  selfslot = oldselfslot5454;
  stackframe = oldstackframe5454;
  gc_frame_end(frame);
  return obj5454;
}
Object meth_collectionsPrelude_trait5453_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "trait()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_SizeUnknown = getfromclosure(closure, 0);
  Object *var_Collection = getfromclosure(closure, 1);
  Object *var_collection = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for trait (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for trait");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start generics
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      gracedie("insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End generics
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5454 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5454 = alloc_userobj2(15,16, objclass5454);
  gc_frame_newslot(obj5454);
if (objclass5454 == NULL) {
  glfree(obj5454->class->name);
  obj5454->class->name = "enumerable";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5454, self, 0);
  addmethodreal(obj5454,"outer", &reader_collectionsPrelude_outer_5455);
  Object oldself5454 = self;
  struct StackFrameObject *oldstackframe5454 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5454);
  gc_frame_newslot((Object)stackframe);
  self = obj5454;
  Object *oldselfslot5454 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5454 = (*(struct UserObject *)self).data[0], lowerouter5454 = thisouter5454;
  if (inheritingObject5454) {
    struct UserObject *inho5454 = (struct UserObject *)inheritingObject5454;
    while (inho5454->super != GraceDefaultObject) inho5454 = (struct UserObject *)inho5454->super;
    inho5454->super = obj5454;
    self = inheritingObject5454;
    *selfslot = self;
    lowerouter5454 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5454;
  }
// method iterator
  struct UserObject *uo5456 = (struct UserObject*)obj5454;
  uo5456->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_iterator5456 = addmethod2pos(obj5454, "iterator", &meth_collectionsPrelude_iterator5456, 1);
  int argcv_meth_collectionsPrelude_iterator5456[] = {0};
  meth_meth_collectionsPrelude_iterator5456->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator5456);
  meth_meth_collectionsPrelude_iterator5456->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator5456->definitionLine = 299;
// method size
  block_savedest(obj5454);
  Object closure5463 = createclosure(1, "size");
  setclosureframe(closure5463, stackframe);
  addtoclosure(closure5463, var_SizeUnknown);
  struct UserObject *uo5463 = (struct UserObject*)obj5454;
  uo5463->data[2] = (Object)closure5463;
  Method *meth_meth_collectionsPrelude_size5463 = addmethod2pos(obj5454, "size", &meth_collectionsPrelude_size5463, 2);
  int argcv_meth_collectionsPrelude_size5463[] = {0};
  meth_meth_collectionsPrelude_size5463->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size5463);
  meth_meth_collectionsPrelude_size5463->definitionModule = modulename;
  meth_meth_collectionsPrelude_size5463->definitionLine = 300;
// method asDictionary
  struct UserObject *uo5476 = (struct UserObject*)obj5454;
  uo5476->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDictionary5476 = addmethod2pos(obj5454, "asDictionary", &meth_collectionsPrelude_asDictionary5476, 3);
  int argcv_meth_collectionsPrelude_asDictionary5476[] = {0};
  meth_meth_collectionsPrelude_asDictionary5476->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDictionary5476);
  meth_meth_collectionsPrelude_asDictionary5476->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDictionary5476->definitionLine = 304;
// method onto
  struct UserObject *uo5492 = (struct UserObject*)obj5454;
  uo5492->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_onto5492 = addmethod2pos(obj5454, "onto", &meth_collectionsPrelude_onto5492, 4);
  int argcv_meth_collectionsPrelude_onto5492[] = {1};
  meth_meth_collectionsPrelude_onto5492->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_onto5492);
  meth_meth_collectionsPrelude_onto5492->definitionModule = modulename;
  meth_meth_collectionsPrelude_onto5492->definitionLine = 311;
// method into
  struct UserObject *uo5495 = (struct UserObject*)obj5454;
  uo5495->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_into5495 = addmethod2pos(obj5454, "into", &meth_collectionsPrelude_into5495, 5);
  int argcv_meth_collectionsPrelude_into5495[] = {1};
  meth_meth_collectionsPrelude_into5495->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_into5495);
  meth_meth_collectionsPrelude_into5495->definitionModule = modulename;
  meth_meth_collectionsPrelude_into5495->definitionLine = 314;
// method ==
  block_savedest(obj5454);
  Object closure5512 = createclosure(1, "==");
  setclosureframe(closure5512, stackframe);
  addtoclosure(closure5512, var_Collection);
  struct UserObject *uo5512 = (struct UserObject*)obj5454;
  uo5512->data[6] = (Object)closure5512;
  Method *meth_meth_collectionsPrelude__61__61_5512 = addmethod2pos(obj5454, "==", &meth_collectionsPrelude__61__61_5512, 6);
  int argcv_meth_collectionsPrelude__61__61_5512[] = {1};
  meth_meth_collectionsPrelude__61__61_5512->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61_5512);
  meth_meth_collectionsPrelude__61__61_5512->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61_5512->definitionLine = 321;
// method do
  struct UserObject *uo5565 = (struct UserObject*)obj5454;
  uo5565->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do5565 = addmethod2pos(obj5454, "do", &meth_collectionsPrelude_do5565, 7);
  int argcv_meth_collectionsPrelude_do5565[] = {1};
  meth_meth_collectionsPrelude_do5565->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do5565);
  meth_meth_collectionsPrelude_do5565->definitionModule = modulename;
  meth_meth_collectionsPrelude_do5565->definitionLine = 339;
// method keysAndValuesDo
  struct UserObject *uo5582 = (struct UserObject*)obj5454;
  uo5582->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo5582 = addmethod2pos(obj5454, "keysAndValuesDo", &meth_collectionsPrelude_keysAndValuesDo5582, 8);
  int argcv_meth_collectionsPrelude_keysAndValuesDo5582[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo5582->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo5582);
  meth_meth_collectionsPrelude_keysAndValuesDo5582->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo5582->definitionLine = 345;
// method values
  struct UserObject *uo5605 = (struct UserObject*)obj5454;
  uo5605->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values5605 = addmethod2pos(obj5454, "values", &meth_collectionsPrelude_values5605, 9);
  int argcv_meth_collectionsPrelude_values5605[] = {0};
  meth_meth_collectionsPrelude_values5605->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values5605);
  meth_meth_collectionsPrelude_values5605->definitionModule = modulename;
  meth_meth_collectionsPrelude_values5605->definitionLine = 353;
// method fold()startingWith
  struct UserObject *uo5606 = (struct UserObject*)obj5454;
  uo5606->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_fold_40__41_startingWith5606 = addmethod2pos(obj5454, "fold()startingWith", &meth_collectionsPrelude_fold_40__41_startingWith5606, 10);
  int argcv_meth_collectionsPrelude_fold_40__41_startingWith5606[] = {1, 1};
  meth_meth_collectionsPrelude_fold_40__41_startingWith5606->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_fold_40__41_startingWith5606);
  meth_meth_collectionsPrelude_fold_40__41_startingWith5606->definitionModule = modulename;
  meth_meth_collectionsPrelude_fold_40__41_startingWith5606->definitionLine = 356;
// method ++
  struct UserObject *uo5624 = (struct UserObject*)obj5454;
  uo5624->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43_5624 = addmethod2pos(obj5454, "++", &meth_collectionsPrelude__43__43_5624, 11);
  int argcv_meth_collectionsPrelude__43__43_5624[] = {1};
  meth_meth_collectionsPrelude__43__43_5624->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43_5624);
  meth_meth_collectionsPrelude__43__43_5624->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43_5624->definitionLine = 364;
// method sortedBy
  struct UserObject *uo5631 = (struct UserObject*)obj5454;
  uo5631->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy5631 = addmethod2pos(obj5454, "sortedBy", &meth_collectionsPrelude_sortedBy5631, 12);
  int argcv_meth_collectionsPrelude_sortedBy5631[] = {1};
  meth_meth_collectionsPrelude_sortedBy5631->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy5631);
  meth_meth_collectionsPrelude_sortedBy5631->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy5631->definitionLine = 367;
// method sorted
  struct UserObject *uo5636 = (struct UserObject*)obj5454;
  uo5636->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted5636 = addmethod2pos(obj5454, "sorted", &meth_collectionsPrelude_sorted5636, 13);
  int argcv_meth_collectionsPrelude_sorted5636[] = {0};
  meth_meth_collectionsPrelude_sorted5636->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted5636);
  meth_meth_collectionsPrelude_sorted5636->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted5636->definitionLine = 370;
// method asString
  struct UserObject *uo5641 = (struct UserObject*)obj5454;
  uo5641->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString5641 = addmethod2pos(obj5454, "asString", &meth_collectionsPrelude_asString5641, 14);
  int argcv_meth_collectionsPrelude_asString5641[] = {0};
  meth_meth_collectionsPrelude_asString5641->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString5641);
  meth_meth_collectionsPrelude_asString5641->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString5641->definitionLine = 373;
  sourceObject = obj5454;
// Begin line 298
  setline(298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5666 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_collection (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5667 = callmethod(*var_collection, "trait()object",
    2, partcv, params);
  gc_frame_end(callframe5666);
// compiled call node returning call5667 (depth = 4)
  struct UserObject *obj5454_uo = (struct UserObject *)obj5454;
  obj5454_uo->super = call5667;
  sourceObject = obj5454;
  sourceObject = obj5454;
  sourceObject = obj5454;
  sourceObject = obj5454;
  sourceObject = obj5454;
  sourceObject = obj5454;
  sourceObject = obj5454;
  sourceObject = obj5454;
  sourceObject = obj5454;
  sourceObject = obj5454;
  sourceObject = obj5454;
  sourceObject = obj5454;
  sourceObject = obj5454;
  sourceObject = obj5454;
  objclass5454 = obj5454->class;
  objclass5454->definitionModule = modulename;
  objclass5454->definitionLine = 297;
  (*(struct UserObject *)self).data[0] = lowerouter5454;
  self = oldself5454;
  selfslot = oldselfslot5454;
  stackframe = oldstackframe5454;
  gc_frame_end(frame);
  return obj5454;
}
Object meth_collectionsPrelude_indexable5669(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 35, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "indexable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_indexable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for indexable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for indexable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indexable (depth = 3)
  gc_frame_end(frame);
  return *var_indexable;
}
Object meth_collectionsPrelude_at5675(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "at");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for at (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for at");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 382
  setline(382);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5676 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5677 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5678 = gc_frame_new();
// call case 3: self.outer request
  Object call5679 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5678);
// compiled call node returning call5679 (depth = 9)
// compiled member node returning call5679 (depth = 8)
  partcv[0] = 0;
  Object call5680 = callmethodflags(call5679, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5677);
// compiled call node returning call5680 (depth = 7)
// compiled member node returning call5680 (depth = 6)
  partcv[0] = 0;
  Object call5681 = callmethodflags(call5680, "abstract", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5676);
// compiled call node returning call5681 (depth = 5)
// compiled member node returning call5681 (depth = 4)
  gc_frame_end(frame);
  return call5681;
}
Object meth_collectionsPrelude_size5682(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "size");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for size (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for size");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 383
  setline(383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5683 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5684 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5685 = gc_frame_new();
// call case 3: self.outer request
  Object call5686 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5685);
// compiled call node returning call5686 (depth = 9)
// compiled member node returning call5686 (depth = 8)
  partcv[0] = 0;
  Object call5687 = callmethodflags(call5686, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5684);
// compiled call node returning call5687 (depth = 7)
// compiled member node returning call5687 (depth = 6)
  partcv[0] = 0;
  Object call5688 = callmethodflags(call5687, "abstract", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5683);
// compiled call node returning call5688 (depth = 5)
// compiled member node returning call5688 (depth = 4)
  gc_frame_end(frame);
  return call5688;
}
Object meth_collectionsPrelude_isEmpty5689(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isEmpty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isEmpty (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isEmpty");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 384
  setline(384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num5691 = alloc_Float64(0);
// compiled num node returning num5691 (depth = 5)
  int op_slot_right_5690 = gc_frame_newslot(num5691);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5693 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5694 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5693);
// compiled call node returning call5694 (depth = 6)
// compiled member node returning call5694 (depth = 5)
  int op_slot_left_5690 = gc_frame_newslot(call5694);
  params[0] = num5691;
  partcv[0] = 1;
  Object opresult5695 = callmethod(call5694, "==", 1, partcv, params);
// compiled op node returning opresult5695 (depth = 4)
  gc_frame_end(frame);
  return opresult5695;
}
Object meth_collectionsPrelude__apply5702(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_curSize = getfromclosure(closure, 0);
  Object *var_i = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_curSize (depth = 7)
  int op_slot_right_5703 = gc_frame_newslot(*var_curSize);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_i (depth = 7)
  int op_slot_left_5703 = gc_frame_newslot(*var_i);
  params[0] = *var_curSize;
  partcv[0] = 1;
  Object opresult5705 = callmethod(*var_i, "<=", 1, partcv, params);
// compiled op node returning opresult5705 (depth = 6)
  gc_frame_end(frame);
  return opresult5705;
}
Object meth_collectionsPrelude__apply5708(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object *var_action = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 389
  setline(389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5709 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_i (depth = 7)
  gc_frame_newslot(*var_i);
// starting to compile call node (depth = 7)
  int callframe5710 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  gc_frame_newslot(*var_i);
// call case 4: self request
  params[0] = *var_i;
  partcv[0] = 1;
  Object call5711 = callmethodflags(self, "at", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5710);
// compiled call node returning call5711 (depth = 7)
  gc_frame_newslot(call5711);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_action (depth = 7)
  params[0] = *var_i;
  params[1] = call5711;
  partcv[0] = 2;
  Object call5712 = callmethod(*var_action, "apply",
    1, partcv, params);
  gc_frame_end(callframe5709);
// compiled call node returning call5712 (depth = 6)
// Begin line 390
  setline(390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num5714 = alloc_Float64(1);
// compiled num node returning num5714 (depth = 8)
  int op_slot_right_5713 = gc_frame_newslot(num5714);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  int op_slot_left_5713 = gc_frame_newslot(*var_i);
  params[0] = num5714;
  partcv[0] = 1;
  Object sum5716 = callmethod(*var_i, "+", 1, partcv, params);
// compiled op node returning sum5716 (depth = 7)
  *var_i = sum5716;
  if (sum5716 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_keysAndValuesDo5696(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keysAndValuesDo");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method keysAndValuesDo");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for keysAndValuesDo (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_action = &(stackframe->slots[0]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for keysAndValuesDo");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_curSize = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "curSize");
  Object *var_i = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "i");
// Begin line 386
  setline(386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5697 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5698 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5697);
// compiled call node returning call5698 (depth = 6)
// compiled member node returning call5698 (depth = 5)
  *var_curSize = call5698;
  if (call5698 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 387
  setline(387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile num node (depth = 5)
  Object num5699 = alloc_Float64(1);
// compiled num node returning num5699 (depth = 5)
  *var_i = num5699;
  if (num5699 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 388
  setline(388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5700 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block5701 = alloc_Block(NULL, NULL, "collectionsPrelude", 388);
  gc_frame_newslot(block5701);
// method _apply
  block_savedest(block5701);
  Object closure5702 = createclosure(3, "_apply");
  setclosureframe(closure5702, stackframe);
  addtoclosure(closure5702, var_curSize);
  addtoclosure(closure5702, var_i);
  addtoclosure(closure5702, selfslot);
  struct UserObject *uo5702 = (struct UserObject*)block5701;
  uo5702->data[0] = (Object)closure5702;
  Method *meth_meth_collectionsPrelude__apply5702 = addmethod2pos(block5701, "_apply", &meth_collectionsPrelude__apply5702, 0);
  int argcv_meth_collectionsPrelude__apply5702[] = {0};
  meth_meth_collectionsPrelude__apply5702->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5702);
  meth_meth_collectionsPrelude__apply5702->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5702->definitionLine = 386;
// compiled block node returning block5701 (depth = 5)
  gc_frame_newslot(block5701);
// starting to compile block node (depth = 5)
  Object block5707 = alloc_Block(NULL, NULL, "collectionsPrelude", 388);
  gc_frame_newslot(block5707);
// method _apply
  block_savedest(block5707);
  Object closure5708 = createclosure(3, "_apply");
  setclosureframe(closure5708, stackframe);
  addtoclosure(closure5708, var_i);
  addtoclosure(closure5708, var_action);
  addtoclosure(closure5708, selfslot);
  struct UserObject *uo5708 = (struct UserObject*)block5707;
  uo5708->data[0] = (Object)closure5708;
  Method *meth_meth_collectionsPrelude__apply5708 = addmethod2pos(block5707, "_apply", &meth_collectionsPrelude__apply5708, 0);
  int argcv_meth_collectionsPrelude__apply5708[] = {0};
  meth_meth_collectionsPrelude__apply5708->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5708);
  meth_meth_collectionsPrelude__apply5708->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5708->definitionLine = 386;
// compiled block node returning block5707 (depth = 5)
  gc_frame_newslot(block5707);
// call case 5: prelude request
  params[0] = block5701;
  params[1] = block5707;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5719 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5700);
// compiled call node returning call5719 (depth = 4)
  gc_frame_end(frame);
  return call5719;
}
Object meth_collectionsPrelude_first5720(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "first");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for first (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for first");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 393
  setline(393);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5721 = gc_frame_new();
// starting to compile num node (depth = 5)
  Object num5722 = alloc_Float64(1);
// compiled num node returning num5722 (depth = 5)
  gc_frame_newslot(num5722);
// call case 4: self request
  params[0] = num5722;
  partcv[0] = 1;
  Object call5723 = callmethodflags(self, "at", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5721);
// compiled call node returning call5723 (depth = 4)
  gc_frame_end(frame);
  return call5723;
}
Object meth_collectionsPrelude_second5724(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "second");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for second (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for second");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 394
  setline(394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5725 = gc_frame_new();
// starting to compile num node (depth = 5)
  Object num5726 = alloc_Float64(2);
// compiled num node returning num5726 (depth = 5)
  gc_frame_newslot(num5726);
// call case 4: self request
  params[0] = num5726;
  partcv[0] = 1;
  Object call5727 = callmethodflags(self, "at", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5725);
// compiled call node returning call5727 (depth = 4)
  gc_frame_end(frame);
  return call5727;
}
Object meth_collectionsPrelude_third5728(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "third");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for third (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for third");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 395
  setline(395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5729 = gc_frame_new();
// starting to compile num node (depth = 5)
  Object num5730 = alloc_Float64(3);
// compiled num node returning num5730 (depth = 5)
  gc_frame_newslot(num5730);
// call case 4: self request
  params[0] = num5730;
  partcv[0] = 1;
  Object call5731 = callmethodflags(self, "at", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5729);
// compiled call node returning call5731 (depth = 4)
  gc_frame_end(frame);
  return call5731;
}
Object meth_collectionsPrelude_fourth5732(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "fourth");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for fourth (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for fourth");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 396
  setline(396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5733 = gc_frame_new();
// starting to compile num node (depth = 5)
  Object num5734 = alloc_Float64(4);
// compiled num node returning num5734 (depth = 5)
  gc_frame_newslot(num5734);
// call case 4: self request
  params[0] = num5734;
  partcv[0] = 1;
  Object call5735 = callmethodflags(self, "at", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5733);
// compiled call node returning call5735 (depth = 4)
  gc_frame_end(frame);
  return call5735;
}
Object meth_collectionsPrelude_fifth5736(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "fifth");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for fifth (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for fifth");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 397
  setline(397);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5737 = gc_frame_new();
// starting to compile num node (depth = 5)
  Object num5738 = alloc_Float64(5);
// compiled num node returning num5738 (depth = 5)
  gc_frame_newslot(num5738);
// call case 4: self request
  params[0] = num5738;
  partcv[0] = 1;
  Object call5739 = callmethodflags(self, "at", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5737);
// compiled call node returning call5739 (depth = 4)
  gc_frame_end(frame);
  return call5739;
}
Object meth_collectionsPrelude_last5740(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "last");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for last (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for last");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 398
  setline(398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5741 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5742 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5743 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5742);
// compiled call node returning call5743 (depth = 6)
// compiled member node returning call5743 (depth = 5)
  gc_frame_newslot(call5743);
// call case 4: self request
  params[0] = call5743;
  partcv[0] = 1;
  Object call5744 = callmethodflags(self, "at", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5741);
// compiled call node returning call5744 (depth = 4)
  gc_frame_end(frame);
  return call5744;
}
Object meth_collectionsPrelude__91__93_5745(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "[]");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method []");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for [] (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for [");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 399
  setline(399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5746 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ix (depth = 5)
  gc_frame_newslot(*var_ix);
// call case 4: self request
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call5747 = callmethodflags(self, "at", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5746);
// compiled call node returning call5747 (depth = 4)
  gc_frame_end(frame);
  return call5747;
}
Object meth_collectionsPrelude_indices5748(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "indices");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for indices (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for indices");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 400
  setline(400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5749 = gc_frame_new();
// starting to compile num node (depth = 5)
  Object num5750 = alloc_Float64(1);
// compiled num node returning num5750 (depth = 5)
  gc_frame_newslot(num5750);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5751 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5752 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5751);
// compiled call node returning call5752 (depth = 6)
// compiled member node returning call5752 (depth = 5)
  gc_frame_newslot(call5752);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5753 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5754 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5755 = gc_frame_new();
// call case 3: self.outer request
  Object call5756 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5755);
// compiled call node returning call5756 (depth = 10)
// compiled member node returning call5756 (depth = 9)
  partcv[0] = 0;
  Object call5757 = callmethodflags(call5756, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5754);
// compiled call node returning call5757 (depth = 8)
// compiled member node returning call5757 (depth = 7)
  partcv[0] = 0;
  Object call5758 = callmethodflags(call5757, "range", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5753);
// compiled call node returning call5758 (depth = 6)
// compiled member node returning call5758 (depth = 5)
  params[0] = num5750;
  params[1] = call5752;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5759 = callmethod(call5758, "from()to",
    2, partcv, params);
  gc_frame_end(callframe5749);
// compiled call node returning call5759 (depth = 4)
  gc_frame_end(frame);
  return call5759;
}
Object meth_collectionsPrelude__apply5763(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sought = getfromclosure(closure, 0);
  Object *var_NoSuchObject = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 6)
  int callframe5764 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5766 == NULL) {
    strlit5766 = alloc_String(" not in collection");
    gc_root(strlit5766);
  }
// compiled string node returning strlit5766 (depth = 8)
  int op_slot_right_5765 = gc_frame_newslot(strlit5766);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sought (depth = 9)
  int op_slot_right_5768 = gc_frame_newslot(*var_sought);
// starting to compile string node (depth = 9)
  if (strlit5770 == NULL) {
    strlit5770 = alloc_String("");
    gc_root(strlit5770);
  }
// compiled string node returning strlit5770 (depth = 9)
  int op_slot_left_5768 = gc_frame_newslot(strlit5770);
  params[0] = *var_sought;
  partcv[0] = 1;
  Object opresult5771 = callmethod(strlit5770, "++", 1, partcv, params);
// compiled op node returning opresult5771 (depth = 8)
  int op_slot_left_5765 = gc_frame_newslot(opresult5771);
  params[0] = strlit5766;
  partcv[0] = 1;
  Object opresult5772 = callmethod(opresult5771, "++", 1, partcv, params);
// compiled op node returning opresult5772 (depth = 7)
  gc_frame_newslot(opresult5772);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_NoSuchObject (depth = 7)
  params[0] = opresult5772;
  partcv[0] = 1;
  Object call5773 = callmethod(*var_NoSuchObject, "raise",
    1, partcv, params);
  gc_frame_end(callframe5764);
// compiled call node returning call5773 (depth = 6)
  gc_frame_end(frame);
  return call5773;
}
Object meth_collectionsPrelude_indexOf5760(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "indexOf");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method indexOf");
  Object params[2];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for indexOf (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_sought = &(stackframe->slots[0]);
  *var_sought = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for indexOf");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 402
  setline(402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5761 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sought (depth = 5)
  gc_frame_newslot(*var_sought);
// starting to compile block node (depth = 5)
  Object block5762 = alloc_Block(NULL, NULL, "collectionsPrelude", 402);
  gc_frame_newslot(block5762);
// method _apply
  block_savedest(block5762);
  Object closure5763 = createclosure(3, "_apply");
  setclosureframe(closure5763, stackframe);
  addtoclosure(closure5763, var_sought);
  addtoclosure(closure5763, var_NoSuchObject);
  addtoclosure(closure5763, selfslot);
  struct UserObject *uo5763 = (struct UserObject*)block5762;
  uo5763->data[0] = (Object)closure5763;
  Method *meth_meth_collectionsPrelude__apply5763 = addmethod2pos(block5762, "_apply", &meth_collectionsPrelude__apply5763, 0);
  int argcv_meth_collectionsPrelude__apply5763[] = {0};
  meth_meth_collectionsPrelude__apply5763->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5763);
  meth_meth_collectionsPrelude__apply5763->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5763->definitionLine = 400;
// compiled block node returning block5762 (depth = 5)
  gc_frame_newslot(block5762);
// call case 4: self request
  params[0] = *var_sought;
  params[1] = block5762;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5775 = callmethodflags(self, "indexOf()ifAbsent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5761);
// compiled call node returning call5775 (depth = 4)
  gc_frame_end(frame);
  return call5775;
}
Object meth_collectionsPrelude__apply5779(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_sought = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *var_v = &(stackframe->slots[1]);
  *var_v = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 406
  setline(406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sought (depth = 8)
  int op_slot_right_5781 = gc_frame_newslot(*var_sought);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_v (depth = 8)
  int op_slot_left_5781 = gc_frame_newslot(*var_v);
  params[0] = *var_sought;
  partcv[0] = 1;
  Object opresult5783 = callmethod(*var_v, "==", 1, partcv, params);
// compiled op node returning opresult5783 (depth = 7)
  Object if5780 = done;
  if (istrue(opresult5783)) {
// starting to compile return node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ix (depth = 8)
  block_return(realself, *var_ix);
// compiled return node returning undefined (depth = 7)
    gc_frame_newslot(undefined);
    if5780 = undefined;
  } else {
  }
// compiled if node returning if5780 (depth = 6)
  gc_frame_end(frame);
  return if5780;
}
Object meth_collectionsPrelude_indexOf_40__41_ifAbsent5776(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "indexOf()ifAbsent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method indexOf()ifAbsent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method indexOf()ifAbsent");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for indexOf()ifAbsent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_sought = &(stackframe->slots[0]);
  *var_sought = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for indexOf");
  Object *var_action = &(stackframe->slots[1]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for ifAbsent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 405
  setline(405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5777 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block5778 = alloc_Block(NULL, NULL, "collectionsPrelude", 405);
  gc_frame_newslot(block5778);
// method _apply
  block_savedest(block5778);
  Object closure5779 = createclosure(2, "_apply");
  setclosureframe(closure5779, stackframe);
  addtoclosure(closure5779, var_sought);
  addtoclosure(closure5779, selfslot);
  struct UserObject *uo5779 = (struct UserObject*)block5778;
  uo5779->data[0] = (Object)closure5779;
  Method *meth_meth_collectionsPrelude__apply5779 = addmethod2pos(block5778, "_apply", &meth_collectionsPrelude__apply5779, 0);
  int argcv_meth_collectionsPrelude__apply5779[] = {2};
  meth_meth_collectionsPrelude__apply5779->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5779);
  meth_meth_collectionsPrelude__apply5779->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5779->definitionLine = 400;
// compiled block node returning block5778 (depth = 5)
  gc_frame_newslot(block5778);
// call case 4: self request
  params[0] = block5778;
  partcv[0] = 1;
  Object call5785 = callmethodflags(self, "keysAndValuesDo", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5777);
// compiled call node returning call5785 (depth = 4)
// Begin line 408
  setline(408);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5786 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_action (depth = 6)
  partcv[0] = 0;
  Object call5787 = callmethod(*var_action, "apply",
    1, partcv, params);
  gc_frame_end(callframe5786);
// compiled call node returning call5787 (depth = 5)
// compiled member node returning call5787 (depth = 4)
  gc_frame_end(frame);
  return call5787;
}
Object meth_collectionsPrelude__apply5799(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_result = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  Object *var_v = &(stackframe->slots[1]);
  *var_v = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 413
  setline(413);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5800 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_k (depth = 7)
  gc_frame_newslot(*var_k);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_v (depth = 7)
  gc_frame_newslot(*var_v);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_result (depth = 7)
  params[0] = *var_k;
  params[1] = *var_v;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5801 = callmethod(*var_result, "at()put",
    2, partcv, params);
  gc_frame_end(callframe5800);
// compiled call node returning call5801 (depth = 6)
  gc_frame_end(frame);
  return call5801;
}
Object meth_collectionsPrelude_asDictionary5788(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asDictionary");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asDictionary (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asDictionary");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "result");
// Begin line 411
  setline(411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5789 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5790 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5791 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe5792 = gc_frame_new();
// call case 3: self.outer request
  Object call5793 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5792);
// compiled call node returning call5793 (depth = 12)
// compiled member node returning call5793 (depth = 11)
  partcv[0] = 0;
  Object call5794 = callmethodflags(call5793, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5791);
// compiled call node returning call5794 (depth = 10)
// compiled member node returning call5794 (depth = 9)
  partcv[0] = 0;
  Object call5795 = callmethodflags(call5794, "dictionary", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5790);
// compiled call node returning call5795 (depth = 8)
// compiled member node returning call5795 (depth = 7)
  partcv[0] = 0;
  Object call5796 = callmethod(call5795, "empty",
    1, partcv, params);
  gc_frame_end(callframe5789);
// compiled call node returning call5796 (depth = 6)
// compiled member node returning call5796 (depth = 5)
  *var_result = call5796;
  if (call5796 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 412
  setline(412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5797 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block5798 = alloc_Block(NULL, NULL, "collectionsPrelude", 412);
  gc_frame_newslot(block5798);
// method _apply
  block_savedest(block5798);
  Object closure5799 = createclosure(2, "_apply");
  setclosureframe(closure5799, stackframe);
  addtoclosure(closure5799, var_result);
  addtoclosure(closure5799, selfslot);
  struct UserObject *uo5799 = (struct UserObject*)block5798;
  uo5799->data[0] = (Object)closure5799;
  Method *meth_meth_collectionsPrelude__apply5799 = addmethod2pos(block5798, "_apply", &meth_collectionsPrelude__apply5799, 0);
  int argcv_meth_collectionsPrelude__apply5799[] = {2};
  meth_meth_collectionsPrelude__apply5799->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5799);
  meth_meth_collectionsPrelude__apply5799->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5799->definitionLine = 411;
// compiled block node returning block5798 (depth = 5)
  gc_frame_newslot(block5798);
// call case 4: self request
  params[0] = block5798;
  partcv[0] = 1;
  Object call5803 = callmethodflags(self, "keysAndValuesDo", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5797);
// compiled call node returning call5803 (depth = 4)
// Begin line 415
  setline(415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  return *var_result;
// compiled return node returning undefined (depth = 4)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_onto5804(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "onto");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method onto");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for onto (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_f = &(stackframe->slots[0]);
  *var_f = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for onto");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 418
  setline(418);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5805 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_f (depth = 5)
  params[0] = self;
  partcv[0] = 1;
  Object call5806 = callmethod(*var_f, "withAll",
    1, partcv, params);
  gc_frame_end(callframe5805);
// compiled call node returning call5806 (depth = 4)
  gc_frame_end(frame);
  return call5806;
}
Object meth_collectionsPrelude__apply5812(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_selfIterator = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5813 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_selfIterator (depth = 8)
  partcv[0] = 0;
  Object call5814 = callmethod(*var_selfIterator, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe5813);
// compiled call node returning call5814 (depth = 7)
// compiled member node returning call5814 (depth = 6)
  gc_frame_end(frame);
  return call5814;
}
Object meth_collectionsPrelude__apply5817(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_selfIterator = getfromclosure(closure, 0);
  Object *var_existing = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 423
  setline(423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5818 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5819 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_selfIterator (depth = 9)
  partcv[0] = 0;
  Object call5820 = callmethod(*var_selfIterator, "next",
    1, partcv, params);
  gc_frame_end(callframe5819);
// compiled call node returning call5820 (depth = 8)
// compiled member node returning call5820 (depth = 7)
  gc_frame_newslot(call5820);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_existing (depth = 7)
  params[0] = call5820;
  partcv[0] = 1;
  Object call5821 = callmethod(*var_existing, "add",
    1, partcv, params);
  gc_frame_end(callframe5818);
// compiled call node returning call5821 (depth = 6)
  gc_frame_end(frame);
  return call5821;
}
Object meth_collectionsPrelude_into5807(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "into");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method into");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for into (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_existing = &(stackframe->slots[0]);
  *var_existing = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for into");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_selfIterator = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "selfIterator");
// Begin line 421
  setline(421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5808 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5809 = callmethodflags(self, "iterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5808);
// compiled call node returning call5809 (depth = 6)
// compiled member node returning call5809 (depth = 5)
  *var_selfIterator = call5809;
  if (call5809 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 422
  setline(422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5810 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block5811 = alloc_Block(NULL, NULL, "collectionsPrelude", 422);
  gc_frame_newslot(block5811);
// method _apply
  block_savedest(block5811);
  Object closure5812 = createclosure(2, "_apply");
  setclosureframe(closure5812, stackframe);
  addtoclosure(closure5812, var_selfIterator);
  addtoclosure(closure5812, selfslot);
  struct UserObject *uo5812 = (struct UserObject*)block5811;
  uo5812->data[0] = (Object)closure5812;
  Method *meth_meth_collectionsPrelude__apply5812 = addmethod2pos(block5811, "_apply", &meth_collectionsPrelude__apply5812, 0);
  int argcv_meth_collectionsPrelude__apply5812[] = {0};
  meth_meth_collectionsPrelude__apply5812->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5812);
  meth_meth_collectionsPrelude__apply5812->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5812->definitionLine = 421;
// compiled block node returning block5811 (depth = 5)
  gc_frame_newslot(block5811);
// starting to compile block node (depth = 5)
  Object block5816 = alloc_Block(NULL, NULL, "collectionsPrelude", 422);
  gc_frame_newslot(block5816);
// method _apply
  block_savedest(block5816);
  Object closure5817 = createclosure(3, "_apply");
  setclosureframe(closure5817, stackframe);
  addtoclosure(closure5817, var_selfIterator);
  addtoclosure(closure5817, var_existing);
  addtoclosure(closure5817, selfslot);
  struct UserObject *uo5817 = (struct UserObject*)block5816;
  uo5817->data[0] = (Object)closure5817;
  Method *meth_meth_collectionsPrelude__apply5817 = addmethod2pos(block5816, "_apply", &meth_collectionsPrelude__apply5817, 0);
  int argcv_meth_collectionsPrelude__apply5817[] = {0};
  meth_meth_collectionsPrelude__apply5817->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5817);
  meth_meth_collectionsPrelude__apply5817->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5817->definitionLine = 422;
// compiled block node returning block5816 (depth = 5)
  gc_frame_newslot(block5816);
// call case 5: prelude request
  params[0] = block5811;
  params[1] = block5816;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5823 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5810);
// compiled call node returning call5823 (depth = 4)
// Begin line 425
  setline(425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_existing (depth = 4)
  gc_frame_end(frame);
  return *var_existing;
}
Object meth_collectionsPrelude_trait5672(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "trait");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  Object *var_collection = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for trait (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for trait");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start generics
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      gracedie("insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End generics
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5673 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5673 = alloc_userobj2(18,19, objclass5673);
  gc_frame_newslot(obj5673);
if (objclass5673 == NULL) {
  glfree(obj5673->class->name);
  obj5673->class->name = "indexable";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5673, self, 0);
  addmethodreal(obj5673,"outer", &reader_collectionsPrelude_outer_5674);
  Object oldself5673 = self;
  struct StackFrameObject *oldstackframe5673 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5673);
  gc_frame_newslot((Object)stackframe);
  self = obj5673;
  Object *oldselfslot5673 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5673 = (*(struct UserObject *)self).data[0], lowerouter5673 = thisouter5673;
  if (inheritingObject5673) {
    struct UserObject *inho5673 = (struct UserObject *)inheritingObject5673;
    while (inho5673->super != GraceDefaultObject) inho5673 = (struct UserObject *)inho5673->super;
    inho5673->super = obj5673;
    self = inheritingObject5673;
    *selfslot = self;
    lowerouter5673 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5673;
  }
// method at
  struct UserObject *uo5675 = (struct UserObject*)obj5673;
  uo5675->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at5675 = addmethod2pos(obj5673, "at", &meth_collectionsPrelude_at5675, 1);
  int argcv_meth_collectionsPrelude_at5675[] = {0};
  meth_meth_collectionsPrelude_at5675->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at5675);
  meth_meth_collectionsPrelude_at5675->definitionModule = modulename;
  meth_meth_collectionsPrelude_at5675->definitionLine = 382;
// method size
  struct UserObject *uo5682 = (struct UserObject*)obj5673;
  uo5682->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_size5682 = addmethod2pos(obj5673, "size", &meth_collectionsPrelude_size5682, 2);
  int argcv_meth_collectionsPrelude_size5682[] = {0};
  meth_meth_collectionsPrelude_size5682->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size5682);
  meth_meth_collectionsPrelude_size5682->definitionModule = modulename;
  meth_meth_collectionsPrelude_size5682->definitionLine = 383;
// method isEmpty
  struct UserObject *uo5689 = (struct UserObject*)obj5673;
  uo5689->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_isEmpty5689 = addmethod2pos(obj5673, "isEmpty", &meth_collectionsPrelude_isEmpty5689, 3);
  int argcv_meth_collectionsPrelude_isEmpty5689[] = {0};
  meth_meth_collectionsPrelude_isEmpty5689->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_isEmpty5689);
  meth_meth_collectionsPrelude_isEmpty5689->definitionModule = modulename;
  meth_meth_collectionsPrelude_isEmpty5689->definitionLine = 384;
// method keysAndValuesDo
  struct UserObject *uo5696 = (struct UserObject*)obj5673;
  uo5696->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo5696 = addmethod2pos(obj5673, "keysAndValuesDo", &meth_collectionsPrelude_keysAndValuesDo5696, 4);
  int argcv_meth_collectionsPrelude_keysAndValuesDo5696[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo5696->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo5696);
  meth_meth_collectionsPrelude_keysAndValuesDo5696->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo5696->definitionLine = 385;
// method first
  struct UserObject *uo5720 = (struct UserObject*)obj5673;
  uo5720->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_first5720 = addmethod2pos(obj5673, "first", &meth_collectionsPrelude_first5720, 5);
  int argcv_meth_collectionsPrelude_first5720[] = {0};
  meth_meth_collectionsPrelude_first5720->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_first5720);
  meth_meth_collectionsPrelude_first5720->definitionModule = modulename;
  meth_meth_collectionsPrelude_first5720->definitionLine = 393;
// method second
  struct UserObject *uo5724 = (struct UserObject*)obj5673;
  uo5724->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_second5724 = addmethod2pos(obj5673, "second", &meth_collectionsPrelude_second5724, 6);
  int argcv_meth_collectionsPrelude_second5724[] = {0};
  meth_meth_collectionsPrelude_second5724->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_second5724);
  meth_meth_collectionsPrelude_second5724->definitionModule = modulename;
  meth_meth_collectionsPrelude_second5724->definitionLine = 394;
// method third
  struct UserObject *uo5728 = (struct UserObject*)obj5673;
  uo5728->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_third5728 = addmethod2pos(obj5673, "third", &meth_collectionsPrelude_third5728, 7);
  int argcv_meth_collectionsPrelude_third5728[] = {0};
  meth_meth_collectionsPrelude_third5728->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_third5728);
  meth_meth_collectionsPrelude_third5728->definitionModule = modulename;
  meth_meth_collectionsPrelude_third5728->definitionLine = 395;
// method fourth
  struct UserObject *uo5732 = (struct UserObject*)obj5673;
  uo5732->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_fourth5732 = addmethod2pos(obj5673, "fourth", &meth_collectionsPrelude_fourth5732, 8);
  int argcv_meth_collectionsPrelude_fourth5732[] = {0};
  meth_meth_collectionsPrelude_fourth5732->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_fourth5732);
  meth_meth_collectionsPrelude_fourth5732->definitionModule = modulename;
  meth_meth_collectionsPrelude_fourth5732->definitionLine = 396;
// method fifth
  struct UserObject *uo5736 = (struct UserObject*)obj5673;
  uo5736->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_fifth5736 = addmethod2pos(obj5673, "fifth", &meth_collectionsPrelude_fifth5736, 9);
  int argcv_meth_collectionsPrelude_fifth5736[] = {0};
  meth_meth_collectionsPrelude_fifth5736->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_fifth5736);
  meth_meth_collectionsPrelude_fifth5736->definitionModule = modulename;
  meth_meth_collectionsPrelude_fifth5736->definitionLine = 397;
// method last
  struct UserObject *uo5740 = (struct UserObject*)obj5673;
  uo5740->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_last5740 = addmethod2pos(obj5673, "last", &meth_collectionsPrelude_last5740, 10);
  int argcv_meth_collectionsPrelude_last5740[] = {0};
  meth_meth_collectionsPrelude_last5740->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_last5740);
  meth_meth_collectionsPrelude_last5740->definitionModule = modulename;
  meth_meth_collectionsPrelude_last5740->definitionLine = 398;
// method []
  struct UserObject *uo5745 = (struct UserObject*)obj5673;
  uo5745->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude__91__93_5745 = addmethod2pos(obj5673, "[]", &meth_collectionsPrelude__91__93_5745, 11);
  int argcv_meth_collectionsPrelude__91__93_5745[] = {1};
  meth_meth_collectionsPrelude__91__93_5745->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__91__93_5745);
  meth_meth_collectionsPrelude__91__93_5745->definitionModule = modulename;
  meth_meth_collectionsPrelude__91__93_5745->definitionLine = 399;
// method indices
  struct UserObject *uo5748 = (struct UserObject*)obj5673;
  uo5748->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_indices5748 = addmethod2pos(obj5673, "indices", &meth_collectionsPrelude_indices5748, 12);
  int argcv_meth_collectionsPrelude_indices5748[] = {0};
  meth_meth_collectionsPrelude_indices5748->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_indices5748);
  meth_meth_collectionsPrelude_indices5748->definitionModule = modulename;
  meth_meth_collectionsPrelude_indices5748->definitionLine = 400;
// method indexOf
  block_savedest(obj5673);
  Object closure5760 = createclosure(1, "indexOf");
  setclosureframe(closure5760, stackframe);
  addtoclosure(closure5760, var_NoSuchObject);
  struct UserObject *uo5760 = (struct UserObject*)obj5673;
  uo5760->data[13] = (Object)closure5760;
  Method *meth_meth_collectionsPrelude_indexOf5760 = addmethod2pos(obj5673, "indexOf", &meth_collectionsPrelude_indexOf5760, 13);
  int argcv_meth_collectionsPrelude_indexOf5760[] = {1};
  meth_meth_collectionsPrelude_indexOf5760->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_indexOf5760);
  meth_meth_collectionsPrelude_indexOf5760->definitionModule = modulename;
  meth_meth_collectionsPrelude_indexOf5760->definitionLine = 401;
// method indexOf()ifAbsent
  struct UserObject *uo5776 = (struct UserObject*)obj5673;
  uo5776->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_indexOf_40__41_ifAbsent5776 = addmethod2pos(obj5673, "indexOf()ifAbsent", &meth_collectionsPrelude_indexOf_40__41_ifAbsent5776, 14);
  int argcv_meth_collectionsPrelude_indexOf_40__41_ifAbsent5776[] = {1, 1};
  meth_meth_collectionsPrelude_indexOf_40__41_ifAbsent5776->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_indexOf_40__41_ifAbsent5776);
  meth_meth_collectionsPrelude_indexOf_40__41_ifAbsent5776->definitionModule = modulename;
  meth_meth_collectionsPrelude_indexOf_40__41_ifAbsent5776->definitionLine = 404;
// method asDictionary
  struct UserObject *uo5788 = (struct UserObject*)obj5673;
  uo5788->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDictionary5788 = addmethod2pos(obj5673, "asDictionary", &meth_collectionsPrelude_asDictionary5788, 15);
  int argcv_meth_collectionsPrelude_asDictionary5788[] = {0};
  meth_meth_collectionsPrelude_asDictionary5788->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDictionary5788);
  meth_meth_collectionsPrelude_asDictionary5788->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDictionary5788->definitionLine = 410;
// method onto
  struct UserObject *uo5804 = (struct UserObject*)obj5673;
  uo5804->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_onto5804 = addmethod2pos(obj5673, "onto", &meth_collectionsPrelude_onto5804, 16);
  int argcv_meth_collectionsPrelude_onto5804[] = {1};
  meth_meth_collectionsPrelude_onto5804->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_onto5804);
  meth_meth_collectionsPrelude_onto5804->definitionModule = modulename;
  meth_meth_collectionsPrelude_onto5804->definitionLine = 417;
// method into
  struct UserObject *uo5807 = (struct UserObject*)obj5673;
  uo5807->data[17] = emptyclosure;
  Method *meth_meth_collectionsPrelude_into5807 = addmethod2pos(obj5673, "into", &meth_collectionsPrelude_into5807, 17);
  int argcv_meth_collectionsPrelude_into5807[] = {1};
  meth_meth_collectionsPrelude_into5807->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_into5807);
  meth_meth_collectionsPrelude_into5807->definitionModule = modulename;
  meth_meth_collectionsPrelude_into5807->definitionLine = 420;
  sourceObject = obj5673;
// Begin line 381
  setline(381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5824 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_collection (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5825 = callmethod(*var_collection, "trait()object",
    2, partcv, params);
  gc_frame_end(callframe5824);
// compiled call node returning call5825 (depth = 4)
  struct UserObject *obj5673_uo = (struct UserObject *)obj5673;
  obj5673_uo->super = call5825;
  sourceObject = obj5673;
  sourceObject = obj5673;
  sourceObject = obj5673;
  sourceObject = obj5673;
  sourceObject = obj5673;
  sourceObject = obj5673;
  sourceObject = obj5673;
  sourceObject = obj5673;
  sourceObject = obj5673;
  sourceObject = obj5673;
  sourceObject = obj5673;
  sourceObject = obj5673;
  sourceObject = obj5673;
  sourceObject = obj5673;
  sourceObject = obj5673;
  sourceObject = obj5673;
  sourceObject = obj5673;
  objclass5673 = obj5673->class;
  objclass5673->definitionModule = modulename;
  objclass5673->definitionLine = 380;
  (*(struct UserObject *)self).data[0] = lowerouter5673;
  self = oldself5673;
  selfslot = oldselfslot5673;
  stackframe = oldstackframe5673;
  gc_frame_end(frame);
  return obj5673;
}
Object meth_collectionsPrelude_trait5672_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "trait()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  Object *var_collection = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for trait (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for trait");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start generics
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      gracedie("insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End generics
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5673 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5673 = alloc_userobj2(18,19, objclass5673);
  gc_frame_newslot(obj5673);
if (objclass5673 == NULL) {
  glfree(obj5673->class->name);
  obj5673->class->name = "indexable";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5673, self, 0);
  addmethodreal(obj5673,"outer", &reader_collectionsPrelude_outer_5674);
  Object oldself5673 = self;
  struct StackFrameObject *oldstackframe5673 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5673);
  gc_frame_newslot((Object)stackframe);
  self = obj5673;
  Object *oldselfslot5673 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5673 = (*(struct UserObject *)self).data[0], lowerouter5673 = thisouter5673;
  if (inheritingObject5673) {
    struct UserObject *inho5673 = (struct UserObject *)inheritingObject5673;
    while (inho5673->super != GraceDefaultObject) inho5673 = (struct UserObject *)inho5673->super;
    inho5673->super = obj5673;
    self = inheritingObject5673;
    *selfslot = self;
    lowerouter5673 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5673;
  }
// method at
  struct UserObject *uo5675 = (struct UserObject*)obj5673;
  uo5675->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at5675 = addmethod2pos(obj5673, "at", &meth_collectionsPrelude_at5675, 1);
  int argcv_meth_collectionsPrelude_at5675[] = {0};
  meth_meth_collectionsPrelude_at5675->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at5675);
  meth_meth_collectionsPrelude_at5675->definitionModule = modulename;
  meth_meth_collectionsPrelude_at5675->definitionLine = 382;
// method size
  struct UserObject *uo5682 = (struct UserObject*)obj5673;
  uo5682->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_size5682 = addmethod2pos(obj5673, "size", &meth_collectionsPrelude_size5682, 2);
  int argcv_meth_collectionsPrelude_size5682[] = {0};
  meth_meth_collectionsPrelude_size5682->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size5682);
  meth_meth_collectionsPrelude_size5682->definitionModule = modulename;
  meth_meth_collectionsPrelude_size5682->definitionLine = 383;
// method isEmpty
  struct UserObject *uo5689 = (struct UserObject*)obj5673;
  uo5689->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_isEmpty5689 = addmethod2pos(obj5673, "isEmpty", &meth_collectionsPrelude_isEmpty5689, 3);
  int argcv_meth_collectionsPrelude_isEmpty5689[] = {0};
  meth_meth_collectionsPrelude_isEmpty5689->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_isEmpty5689);
  meth_meth_collectionsPrelude_isEmpty5689->definitionModule = modulename;
  meth_meth_collectionsPrelude_isEmpty5689->definitionLine = 384;
// method keysAndValuesDo
  struct UserObject *uo5696 = (struct UserObject*)obj5673;
  uo5696->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo5696 = addmethod2pos(obj5673, "keysAndValuesDo", &meth_collectionsPrelude_keysAndValuesDo5696, 4);
  int argcv_meth_collectionsPrelude_keysAndValuesDo5696[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo5696->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo5696);
  meth_meth_collectionsPrelude_keysAndValuesDo5696->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo5696->definitionLine = 385;
// method first
  struct UserObject *uo5720 = (struct UserObject*)obj5673;
  uo5720->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_first5720 = addmethod2pos(obj5673, "first", &meth_collectionsPrelude_first5720, 5);
  int argcv_meth_collectionsPrelude_first5720[] = {0};
  meth_meth_collectionsPrelude_first5720->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_first5720);
  meth_meth_collectionsPrelude_first5720->definitionModule = modulename;
  meth_meth_collectionsPrelude_first5720->definitionLine = 393;
// method second
  struct UserObject *uo5724 = (struct UserObject*)obj5673;
  uo5724->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_second5724 = addmethod2pos(obj5673, "second", &meth_collectionsPrelude_second5724, 6);
  int argcv_meth_collectionsPrelude_second5724[] = {0};
  meth_meth_collectionsPrelude_second5724->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_second5724);
  meth_meth_collectionsPrelude_second5724->definitionModule = modulename;
  meth_meth_collectionsPrelude_second5724->definitionLine = 394;
// method third
  struct UserObject *uo5728 = (struct UserObject*)obj5673;
  uo5728->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_third5728 = addmethod2pos(obj5673, "third", &meth_collectionsPrelude_third5728, 7);
  int argcv_meth_collectionsPrelude_third5728[] = {0};
  meth_meth_collectionsPrelude_third5728->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_third5728);
  meth_meth_collectionsPrelude_third5728->definitionModule = modulename;
  meth_meth_collectionsPrelude_third5728->definitionLine = 395;
// method fourth
  struct UserObject *uo5732 = (struct UserObject*)obj5673;
  uo5732->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_fourth5732 = addmethod2pos(obj5673, "fourth", &meth_collectionsPrelude_fourth5732, 8);
  int argcv_meth_collectionsPrelude_fourth5732[] = {0};
  meth_meth_collectionsPrelude_fourth5732->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_fourth5732);
  meth_meth_collectionsPrelude_fourth5732->definitionModule = modulename;
  meth_meth_collectionsPrelude_fourth5732->definitionLine = 396;
// method fifth
  struct UserObject *uo5736 = (struct UserObject*)obj5673;
  uo5736->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_fifth5736 = addmethod2pos(obj5673, "fifth", &meth_collectionsPrelude_fifth5736, 9);
  int argcv_meth_collectionsPrelude_fifth5736[] = {0};
  meth_meth_collectionsPrelude_fifth5736->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_fifth5736);
  meth_meth_collectionsPrelude_fifth5736->definitionModule = modulename;
  meth_meth_collectionsPrelude_fifth5736->definitionLine = 397;
// method last
  struct UserObject *uo5740 = (struct UserObject*)obj5673;
  uo5740->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_last5740 = addmethod2pos(obj5673, "last", &meth_collectionsPrelude_last5740, 10);
  int argcv_meth_collectionsPrelude_last5740[] = {0};
  meth_meth_collectionsPrelude_last5740->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_last5740);
  meth_meth_collectionsPrelude_last5740->definitionModule = modulename;
  meth_meth_collectionsPrelude_last5740->definitionLine = 398;
// method []
  struct UserObject *uo5745 = (struct UserObject*)obj5673;
  uo5745->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude__91__93_5745 = addmethod2pos(obj5673, "[]", &meth_collectionsPrelude__91__93_5745, 11);
  int argcv_meth_collectionsPrelude__91__93_5745[] = {1};
  meth_meth_collectionsPrelude__91__93_5745->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__91__93_5745);
  meth_meth_collectionsPrelude__91__93_5745->definitionModule = modulename;
  meth_meth_collectionsPrelude__91__93_5745->definitionLine = 399;
// method indices
  struct UserObject *uo5748 = (struct UserObject*)obj5673;
  uo5748->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_indices5748 = addmethod2pos(obj5673, "indices", &meth_collectionsPrelude_indices5748, 12);
  int argcv_meth_collectionsPrelude_indices5748[] = {0};
  meth_meth_collectionsPrelude_indices5748->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_indices5748);
  meth_meth_collectionsPrelude_indices5748->definitionModule = modulename;
  meth_meth_collectionsPrelude_indices5748->definitionLine = 400;
// method indexOf
  block_savedest(obj5673);
  Object closure5760 = createclosure(1, "indexOf");
  setclosureframe(closure5760, stackframe);
  addtoclosure(closure5760, var_NoSuchObject);
  struct UserObject *uo5760 = (struct UserObject*)obj5673;
  uo5760->data[13] = (Object)closure5760;
  Method *meth_meth_collectionsPrelude_indexOf5760 = addmethod2pos(obj5673, "indexOf", &meth_collectionsPrelude_indexOf5760, 13);
  int argcv_meth_collectionsPrelude_indexOf5760[] = {1};
  meth_meth_collectionsPrelude_indexOf5760->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_indexOf5760);
  meth_meth_collectionsPrelude_indexOf5760->definitionModule = modulename;
  meth_meth_collectionsPrelude_indexOf5760->definitionLine = 401;
// method indexOf()ifAbsent
  struct UserObject *uo5776 = (struct UserObject*)obj5673;
  uo5776->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_indexOf_40__41_ifAbsent5776 = addmethod2pos(obj5673, "indexOf()ifAbsent", &meth_collectionsPrelude_indexOf_40__41_ifAbsent5776, 14);
  int argcv_meth_collectionsPrelude_indexOf_40__41_ifAbsent5776[] = {1, 1};
  meth_meth_collectionsPrelude_indexOf_40__41_ifAbsent5776->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_indexOf_40__41_ifAbsent5776);
  meth_meth_collectionsPrelude_indexOf_40__41_ifAbsent5776->definitionModule = modulename;
  meth_meth_collectionsPrelude_indexOf_40__41_ifAbsent5776->definitionLine = 404;
// method asDictionary
  struct UserObject *uo5788 = (struct UserObject*)obj5673;
  uo5788->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDictionary5788 = addmethod2pos(obj5673, "asDictionary", &meth_collectionsPrelude_asDictionary5788, 15);
  int argcv_meth_collectionsPrelude_asDictionary5788[] = {0};
  meth_meth_collectionsPrelude_asDictionary5788->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDictionary5788);
  meth_meth_collectionsPrelude_asDictionary5788->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDictionary5788->definitionLine = 410;
// method onto
  struct UserObject *uo5804 = (struct UserObject*)obj5673;
  uo5804->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_onto5804 = addmethod2pos(obj5673, "onto", &meth_collectionsPrelude_onto5804, 16);
  int argcv_meth_collectionsPrelude_onto5804[] = {1};
  meth_meth_collectionsPrelude_onto5804->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_onto5804);
  meth_meth_collectionsPrelude_onto5804->definitionModule = modulename;
  meth_meth_collectionsPrelude_onto5804->definitionLine = 417;
// method into
  struct UserObject *uo5807 = (struct UserObject*)obj5673;
  uo5807->data[17] = emptyclosure;
  Method *meth_meth_collectionsPrelude_into5807 = addmethod2pos(obj5673, "into", &meth_collectionsPrelude_into5807, 17);
  int argcv_meth_collectionsPrelude_into5807[] = {1};
  meth_meth_collectionsPrelude_into5807->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_into5807);
  meth_meth_collectionsPrelude_into5807->definitionModule = modulename;
  meth_meth_collectionsPrelude_into5807->definitionLine = 420;
  sourceObject = obj5673;
// Begin line 381
  setline(381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5824 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_collection (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5825 = callmethod(*var_collection, "trait()object",
    2, partcv, params);
  gc_frame_end(callframe5824);
// compiled call node returning call5825 (depth = 4)
  struct UserObject *obj5673_uo = (struct UserObject *)obj5673;
  obj5673_uo->super = call5825;
  sourceObject = obj5673;
  sourceObject = obj5673;
  sourceObject = obj5673;
  sourceObject = obj5673;
  sourceObject = obj5673;
  sourceObject = obj5673;
  sourceObject = obj5673;
  sourceObject = obj5673;
  sourceObject = obj5673;
  sourceObject = obj5673;
  sourceObject = obj5673;
  sourceObject = obj5673;
  sourceObject = obj5673;
  sourceObject = obj5673;
  sourceObject = obj5673;
  sourceObject = obj5673;
  sourceObject = obj5673;
  objclass5673 = obj5673->class;
  objclass5673->definitionModule = modulename;
  objclass5673->definitionLine = 380;
  (*(struct UserObject *)self).data[0] = lowerouter5673;
  self = oldself5673;
  selfslot = oldselfslot5673;
  stackframe = oldstackframe5673;
  gc_frame_end(frame);
  return obj5673;
}
Object meth_collectionsPrelude_Binding5829(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 36, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Binding");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Binding = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for Binding (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹Binding›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1372
  setline(1372);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Binding (depth = 3)
  gc_frame_end(frame);
  return *var_Binding;
}
Object meth_collectionsPrelude_binding5830(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 37, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "binding");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_binding = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for binding (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for binding");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_binding (depth = 3)
  gc_frame_end(frame);
  return *var_binding;
}
Object meth_collectionsPrelude_key5836(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "key");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for key (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for key");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1380
  setline(1380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  gc_frame_end(frame);
  return *var_k;
}
Object meth_collectionsPrelude_value5837(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "value");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_v = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for value (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for value");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1381
  setline(1381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_v (depth = 4)
  gc_frame_end(frame);
  return *var_v;
}
Object meth_collectionsPrelude_asString5838(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_v = getfromclosure(closure, 0);
  Object *var_k = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1382
  setline(1382);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5840 == NULL) {
    strlit5840 = alloc_String("");
    gc_root(strlit5840);
  }
// compiled string node returning strlit5840 (depth = 5)
  int op_slot_right_5839 = gc_frame_newslot(strlit5840);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  int op_slot_right_5842 = gc_frame_newslot(*var_v);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5845 == NULL) {
    strlit5845 = alloc_String("::");
    gc_root(strlit5845);
  }
// compiled string node returning strlit5845 (depth = 7)
  int op_slot_right_5844 = gc_frame_newslot(strlit5845);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_k (depth = 8)
  int op_slot_right_5847 = gc_frame_newslot(*var_k);
// starting to compile string node (depth = 8)
  if (strlit5849 == NULL) {
    strlit5849 = alloc_String("");
    gc_root(strlit5849);
  }
// compiled string node returning strlit5849 (depth = 8)
  int op_slot_left_5847 = gc_frame_newslot(strlit5849);
  params[0] = *var_k;
  partcv[0] = 1;
  Object opresult5850 = callmethod(strlit5849, "++", 1, partcv, params);
// compiled op node returning opresult5850 (depth = 7)
  int op_slot_left_5844 = gc_frame_newslot(opresult5850);
  params[0] = strlit5845;
  partcv[0] = 1;
  Object opresult5851 = callmethod(opresult5850, "++", 1, partcv, params);
// compiled op node returning opresult5851 (depth = 6)
  int op_slot_left_5842 = gc_frame_newslot(opresult5851);
  params[0] = *var_v;
  partcv[0] = 1;
  Object opresult5852 = callmethod(opresult5851, "++", 1, partcv, params);
// compiled op node returning opresult5852 (depth = 5)
  int op_slot_left_5839 = gc_frame_newslot(opresult5852);
  params[0] = strlit5840;
  partcv[0] = 1;
  Object opresult5853 = callmethod(opresult5852, "++", 1, partcv, params);
// compiled op node returning opresult5853 (depth = 4)
  gc_frame_end(frame);
  return opresult5853;
}
Object meth_collectionsPrelude_hashcode5854(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "hashcode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_v = getfromclosure(closure, 0);
  Object *var_k = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for hashcode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for hashcode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1383
  setline(1383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5856 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_v (depth = 7)
  partcv[0] = 0;
  Object call5857 = callmethod(*var_v, "hashcode",
    1, partcv, params);
  gc_frame_end(callframe5856);
// compiled call node returning call5857 (depth = 6)
// compiled member node returning call5857 (depth = 5)
  int op_slot_right_5855 = gc_frame_newslot(call5857);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num5860 = alloc_Float64(1021);
// compiled num node returning num5860 (depth = 6)
  int op_slot_right_5859 = gc_frame_newslot(num5860);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5862 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_k (depth = 8)
  partcv[0] = 0;
  Object call5863 = callmethod(*var_k, "hashcode",
    1, partcv, params);
  gc_frame_end(callframe5862);
// compiled call node returning call5863 (depth = 7)
// compiled member node returning call5863 (depth = 6)
  int op_slot_left_5859 = gc_frame_newslot(call5863);
  params[0] = num5860;
  partcv[0] = 1;
  Object prod5864 = callmethod(call5863, "*", 1, partcv, params);
// compiled op node returning prod5864 (depth = 5)
  int op_slot_left_5855 = gc_frame_newslot(prod5864);
  params[0] = call5857;
  partcv[0] = 1;
  Object sum5865 = callmethod(prod5864, "+", 1, partcv, params);
// compiled op node returning sum5865 (depth = 4)
  gc_frame_end(frame);
  return sum5865;
}
Object meth_collectionsPrelude_hash5866(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "hash");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_v = getfromclosure(closure, 0);
  Object *var_k = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for hash (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for hash");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1384
  setline(1384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5868 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_v (depth = 7)
  partcv[0] = 0;
  Object call5869 = callmethod(*var_v, "hash",
    1, partcv, params);
  gc_frame_end(callframe5868);
// compiled call node returning call5869 (depth = 6)
// compiled member node returning call5869 (depth = 5)
  int op_slot_right_5867 = gc_frame_newslot(call5869);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num5872 = alloc_Float64(1021);
// compiled num node returning num5872 (depth = 6)
  int op_slot_right_5871 = gc_frame_newslot(num5872);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5874 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_k (depth = 8)
  partcv[0] = 0;
  Object call5875 = callmethod(*var_k, "hash",
    1, partcv, params);
  gc_frame_end(callframe5874);
// compiled call node returning call5875 (depth = 7)
// compiled member node returning call5875 (depth = 6)
  int op_slot_left_5871 = gc_frame_newslot(call5875);
  params[0] = num5872;
  partcv[0] = 1;
  Object prod5876 = callmethod(call5875, "*", 1, partcv, params);
// compiled op node returning prod5876 (depth = 5)
  int op_slot_left_5867 = gc_frame_newslot(prod5876);
  params[0] = call5869;
  partcv[0] = 1;
  Object sum5877 = callmethod(prod5876, "+", 1, partcv, params);
// compiled op node returning sum5877 (depth = 4)
  gc_frame_end(frame);
  return sum5877;
}
Object meth_collectionsPrelude__apply5881(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_v = getfromclosure(closure, 0);
  Object *var_k = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5884 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_o (depth = 10)
  partcv[0] = 0;
  Object call5885 = callmethod(*var_o, "value",
    1, partcv, params);
  gc_frame_end(callframe5884);
// compiled call node returning call5885 (depth = 9)
// compiled member node returning call5885 (depth = 8)
  int op_slot_right_5883 = gc_frame_newslot(call5885);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_v (depth = 8)
  int op_slot_left_5883 = gc_frame_newslot(*var_v);
  params[0] = call5885;
  partcv[0] = 1;
  Object opresult5887 = callmethod(*var_v, "==", 1, partcv, params);
// compiled op node returning opresult5887 (depth = 7)
  int op_slot_right_5882 = gc_frame_newslot(opresult5887);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5890 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_o (depth = 10)
  partcv[0] = 0;
  Object call5891 = callmethod(*var_o, "key",
    1, partcv, params);
  gc_frame_end(callframe5890);
// compiled call node returning call5891 (depth = 9)
// compiled member node returning call5891 (depth = 8)
  int op_slot_right_5889 = gc_frame_newslot(call5891);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_k (depth = 8)
  int op_slot_left_5889 = gc_frame_newslot(*var_k);
  params[0] = call5891;
  partcv[0] = 1;
  Object opresult5893 = callmethod(*var_k, "==", 1, partcv, params);
// compiled op node returning opresult5893 (depth = 7)
  int op_slot_left_5882 = gc_frame_newslot(opresult5893);
  params[0] = opresult5887;
  partcv[0] = 1;
  Object opresult5894 = callmethod(opresult5893, "&&", 1, partcv, params);
// compiled op node returning opresult5894 (depth = 6)
  gc_frame_end(frame);
  return opresult5894;
}
Object meth_collectionsPrelude__apply5906(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___20 = &(stackframe->slots[0]);
  *var___20 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile return node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool5907 = alloc_Boolean(0);
// compiled identifier node returning bool5907 (depth = 7)
  block_return(realself, bool5907);
// compiled return node returning undefined (depth = 6)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__61__61_5878(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "==");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method ==");
  Object params[2];
  int partcv[1];
  Object *var_v = getfromclosure(closure, 0);
  Object *var_k = getfromclosure(closure, 1);
  Object *var_Binding = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for == (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for ==");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1386
  setline(1386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  int frame5879 = gc_frame_new();
  gc_frame_newslot(*var_other);
// Begin line 1387
  setline(1387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 5)
  Object block5880 = alloc_Block(NULL, NULL, "collectionsPrelude", 1387);
  gc_frame_newslot(block5880);
// method _apply
  block_savedest(block5880);
  Object closure5881 = createclosure(3, "_apply");
  setclosureframe(closure5881, stackframe);
  addtoclosure(closure5881, var_v);
  addtoclosure(closure5881, var_k);
  addtoclosure(closure5881, selfslot);
  struct UserObject *uo5881 = (struct UserObject*)block5880;
  uo5881->data[0] = (Object)closure5881;
  Method *meth_meth_collectionsPrelude__apply5881 = addmethod2pos(block5880, "_apply", &meth_collectionsPrelude__apply5881, 0);
  int argcv_meth_collectionsPrelude__apply5881[] = {1};
  meth_meth_collectionsPrelude__apply5881->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5881);
  meth_meth_collectionsPrelude__apply5881->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5881->definitionLine = 1384;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5896 = gc_frame_new();
// starting to compile call node (depth = 7)
  int callframe5897 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit5898 == NULL) {
    strlit5898 = alloc_String("o");
    gc_root(strlit5898);
  }
// compiled string node returning strlit5898 (depth = 8)
  gc_frame_newslot(strlit5898);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5899 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5900 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5899);
// compiled call node returning call5900 (depth = 9)
// compiled member node returning call5900 (depth = 8)
  params[0] = strlit5898;
  partcv[0] = 1;
  Object call5901 = callmethod(call5900, "new",
    1, partcv, params);
  gc_frame_end(callframe5897);
// compiled call node returning call5901 (depth = 7)
  gc_frame_newslot(call5901);
// Begin line 1387
  setline(1387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Binding (depth = 7)
  gc_frame_newslot(*var_Binding);
// call case 6: other member request
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5902 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5903 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5902);
// compiled call node returning call5903 (depth = 8)
// compiled member node returning call5903 (depth = 7)
  params[0] = call5901;
  params[1] = *var_Binding;
  partcv[0] = 2;
  Object call5904 = callmethod(call5903, "new",
    1, partcv, params);
  gc_frame_end(callframe5896);
// compiled call node returning call5904 (depth = 6)
((struct UserObject *)block5880)->data[1] = call5904;
// compiled block node returning block5880 (depth = 5)
  gc_frame_newslot(block5880);
// Begin line 1388
  setline(1388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 5)
  Object block5905 = alloc_Block(NULL, NULL, "collectionsPrelude", 1388);
  gc_frame_newslot(block5905);
// method _apply
  block_savedest(block5905);
  Object closure5906 = createclosure(1, "_apply");
  setclosureframe(closure5906, stackframe);
  addtoclosure(closure5906, selfslot);
  struct UserObject *uo5906 = (struct UserObject*)block5905;
  uo5906->data[0] = (Object)closure5906;
  Method *meth_meth_collectionsPrelude__apply5906 = addmethod2pos(block5905, "_apply", &meth_collectionsPrelude__apply5906, 0);
  int argcv_meth_collectionsPrelude__apply5906[] = {1};
  meth_meth_collectionsPrelude__apply5906->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5906);
  meth_meth_collectionsPrelude__apply5906->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5906->definitionLine = 0;
// compiled block node returning block5905 (depth = 5)
  gc_frame_newslot(block5905);
  params[0] = block5880;
  params[1] = block5905;
  Object matchres5879 = matchCase(*var_other, params, 2,NULL);
  gc_frame_end(frame5879);
// compiled matchcase node returning matchres5879 (depth = 4)
  gc_frame_end(frame);
  return matchres5879;
}
Object meth_collectionsPrelude_key_40__41_value5833(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "key()value");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method key()value");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method key()value");
  Object params[1];
  int partcv[1];
  Object *var_Binding = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for key()value (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for key");
  Object *var_v = &(stackframe->slots[1]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for value");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5834 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5834 = alloc_userobj2(6,7, objclass5834);
  gc_frame_newslot(obj5834);
if (objclass5834 == NULL) {
  glfree(obj5834->class->name);
  obj5834->class->name = "binding";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5834, self, 0);
  addmethodreal(obj5834,"outer", &reader_collectionsPrelude_outer_5835);
  Object oldself5834 = self;
  struct StackFrameObject *oldstackframe5834 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5834);
  gc_frame_newslot((Object)stackframe);
  self = obj5834;
  Object *oldselfslot5834 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5834 = (*(struct UserObject *)self).data[0], lowerouter5834 = thisouter5834;
  if (inheritingObject5834) {
    struct UserObject *inho5834 = (struct UserObject *)inheritingObject5834;
    while (inho5834->super != GraceDefaultObject) inho5834 = (struct UserObject *)inho5834->super;
    inho5834->super = obj5834;
    self = inheritingObject5834;
    *selfslot = self;
    lowerouter5834 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5834;
  }
// method key
  block_savedest(obj5834);
  Object closure5836 = createclosure(1, "key");
  setclosureframe(closure5836, stackframe);
  addtoclosure(closure5836, var_k);
  struct UserObject *uo5836 = (struct UserObject*)obj5834;
  uo5836->data[1] = (Object)closure5836;
  Method *meth_meth_collectionsPrelude_key5836 = addmethod2pos(obj5834, "key", &meth_collectionsPrelude_key5836, 1);
  int argcv_meth_collectionsPrelude_key5836[] = {0};
  meth_meth_collectionsPrelude_key5836->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_key5836);
  meth_meth_collectionsPrelude_key5836->definitionModule = modulename;
  meth_meth_collectionsPrelude_key5836->definitionLine = 1380;
// method value
  block_savedest(obj5834);
  Object closure5837 = createclosure(1, "value");
  setclosureframe(closure5837, stackframe);
  addtoclosure(closure5837, var_v);
  struct UserObject *uo5837 = (struct UserObject*)obj5834;
  uo5837->data[2] = (Object)closure5837;
  Method *meth_meth_collectionsPrelude_value5837 = addmethod2pos(obj5834, "value", &meth_collectionsPrelude_value5837, 2);
  int argcv_meth_collectionsPrelude_value5837[] = {0};
  meth_meth_collectionsPrelude_value5837->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_value5837);
  meth_meth_collectionsPrelude_value5837->definitionModule = modulename;
  meth_meth_collectionsPrelude_value5837->definitionLine = 1381;
// method asString
  block_savedest(obj5834);
  Object closure5838 = createclosure(2, "asString");
  setclosureframe(closure5838, stackframe);
  addtoclosure(closure5838, var_v);
  addtoclosure(closure5838, var_k);
  struct UserObject *uo5838 = (struct UserObject*)obj5834;
  uo5838->data[3] = (Object)closure5838;
  Method *meth_meth_collectionsPrelude_asString5838 = addmethod2pos(obj5834, "asString", &meth_collectionsPrelude_asString5838, 3);
  int argcv_meth_collectionsPrelude_asString5838[] = {0};
  meth_meth_collectionsPrelude_asString5838->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString5838);
  meth_meth_collectionsPrelude_asString5838->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString5838->definitionLine = 1382;
// method hashcode
  block_savedest(obj5834);
  Object closure5854 = createclosure(2, "hashcode");
  setclosureframe(closure5854, stackframe);
  addtoclosure(closure5854, var_v);
  addtoclosure(closure5854, var_k);
  struct UserObject *uo5854 = (struct UserObject*)obj5834;
  uo5854->data[4] = (Object)closure5854;
  Method *meth_meth_collectionsPrelude_hashcode5854 = addmethod2pos(obj5834, "hashcode", &meth_collectionsPrelude_hashcode5854, 4);
  int argcv_meth_collectionsPrelude_hashcode5854[] = {0};
  meth_meth_collectionsPrelude_hashcode5854->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hashcode5854);
  meth_meth_collectionsPrelude_hashcode5854->definitionModule = modulename;
  meth_meth_collectionsPrelude_hashcode5854->definitionLine = 1383;
// method hash
  block_savedest(obj5834);
  Object closure5866 = createclosure(2, "hash");
  setclosureframe(closure5866, stackframe);
  addtoclosure(closure5866, var_v);
  addtoclosure(closure5866, var_k);
  struct UserObject *uo5866 = (struct UserObject*)obj5834;
  uo5866->data[5] = (Object)closure5866;
  Method *meth_meth_collectionsPrelude_hash5866 = addmethod2pos(obj5834, "hash", &meth_collectionsPrelude_hash5866, 5);
  int argcv_meth_collectionsPrelude_hash5866[] = {0};
  meth_meth_collectionsPrelude_hash5866->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hash5866);
  meth_meth_collectionsPrelude_hash5866->definitionModule = modulename;
  meth_meth_collectionsPrelude_hash5866->definitionLine = 1384;
// method ==
  block_savedest(obj5834);
  Object closure5878 = createclosure(3, "==");
  setclosureframe(closure5878, stackframe);
  addtoclosure(closure5878, var_v);
  addtoclosure(closure5878, var_k);
  addtoclosure(closure5878, var_Binding);
  struct UserObject *uo5878 = (struct UserObject*)obj5834;
  uo5878->data[6] = (Object)closure5878;
  Method *meth_meth_collectionsPrelude__61__61_5878 = addmethod2pos(obj5834, "==", &meth_collectionsPrelude__61__61_5878, 6);
  int argcv_meth_collectionsPrelude__61__61_5878[] = {1};
  meth_meth_collectionsPrelude__61__61_5878->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61_5878);
  meth_meth_collectionsPrelude__61__61_5878->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61_5878->definitionLine = 1385;
  sourceObject = obj5834;
  sourceObject = obj5834;
  sourceObject = obj5834;
  sourceObject = obj5834;
  sourceObject = obj5834;
  sourceObject = obj5834;
  objclass5834 = obj5834->class;
  objclass5834->definitionModule = modulename;
  objclass5834->definitionLine = 1379;
  (*(struct UserObject *)self).data[0] = lowerouter5834;
  self = oldself5834;
  selfslot = oldselfslot5834;
  stackframe = oldstackframe5834;
  gc_frame_end(frame);
  return obj5834;
}
Object meth_collectionsPrelude_key_40__41_value5833_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "key()value()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0] + argcv[1]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method key()value()object");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method key()value()object");
  Object params[1];
  int partcv[1];
  Object *var_Binding = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for key()value (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for key");
  Object *var_v = &(stackframe->slots[1]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for value");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5834 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5834 = alloc_userobj2(6,7, objclass5834);
  gc_frame_newslot(obj5834);
if (objclass5834 == NULL) {
  glfree(obj5834->class->name);
  obj5834->class->name = "binding";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5834, self, 0);
  addmethodreal(obj5834,"outer", &reader_collectionsPrelude_outer_5835);
  Object oldself5834 = self;
  struct StackFrameObject *oldstackframe5834 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5834);
  gc_frame_newslot((Object)stackframe);
  self = obj5834;
  Object *oldselfslot5834 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5834 = (*(struct UserObject *)self).data[0], lowerouter5834 = thisouter5834;
  if (inheritingObject5834) {
    struct UserObject *inho5834 = (struct UserObject *)inheritingObject5834;
    while (inho5834->super != GraceDefaultObject) inho5834 = (struct UserObject *)inho5834->super;
    inho5834->super = obj5834;
    self = inheritingObject5834;
    *selfslot = self;
    lowerouter5834 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5834;
  }
// method key
  block_savedest(obj5834);
  Object closure5836 = createclosure(1, "key");
  setclosureframe(closure5836, stackframe);
  addtoclosure(closure5836, var_k);
  struct UserObject *uo5836 = (struct UserObject*)obj5834;
  uo5836->data[1] = (Object)closure5836;
  Method *meth_meth_collectionsPrelude_key5836 = addmethod2pos(obj5834, "key", &meth_collectionsPrelude_key5836, 1);
  int argcv_meth_collectionsPrelude_key5836[] = {0};
  meth_meth_collectionsPrelude_key5836->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_key5836);
  meth_meth_collectionsPrelude_key5836->definitionModule = modulename;
  meth_meth_collectionsPrelude_key5836->definitionLine = 1380;
// method value
  block_savedest(obj5834);
  Object closure5837 = createclosure(1, "value");
  setclosureframe(closure5837, stackframe);
  addtoclosure(closure5837, var_v);
  struct UserObject *uo5837 = (struct UserObject*)obj5834;
  uo5837->data[2] = (Object)closure5837;
  Method *meth_meth_collectionsPrelude_value5837 = addmethod2pos(obj5834, "value", &meth_collectionsPrelude_value5837, 2);
  int argcv_meth_collectionsPrelude_value5837[] = {0};
  meth_meth_collectionsPrelude_value5837->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_value5837);
  meth_meth_collectionsPrelude_value5837->definitionModule = modulename;
  meth_meth_collectionsPrelude_value5837->definitionLine = 1381;
// method asString
  block_savedest(obj5834);
  Object closure5838 = createclosure(2, "asString");
  setclosureframe(closure5838, stackframe);
  addtoclosure(closure5838, var_v);
  addtoclosure(closure5838, var_k);
  struct UserObject *uo5838 = (struct UserObject*)obj5834;
  uo5838->data[3] = (Object)closure5838;
  Method *meth_meth_collectionsPrelude_asString5838 = addmethod2pos(obj5834, "asString", &meth_collectionsPrelude_asString5838, 3);
  int argcv_meth_collectionsPrelude_asString5838[] = {0};
  meth_meth_collectionsPrelude_asString5838->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString5838);
  meth_meth_collectionsPrelude_asString5838->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString5838->definitionLine = 1382;
// method hashcode
  block_savedest(obj5834);
  Object closure5854 = createclosure(2, "hashcode");
  setclosureframe(closure5854, stackframe);
  addtoclosure(closure5854, var_v);
  addtoclosure(closure5854, var_k);
  struct UserObject *uo5854 = (struct UserObject*)obj5834;
  uo5854->data[4] = (Object)closure5854;
  Method *meth_meth_collectionsPrelude_hashcode5854 = addmethod2pos(obj5834, "hashcode", &meth_collectionsPrelude_hashcode5854, 4);
  int argcv_meth_collectionsPrelude_hashcode5854[] = {0};
  meth_meth_collectionsPrelude_hashcode5854->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hashcode5854);
  meth_meth_collectionsPrelude_hashcode5854->definitionModule = modulename;
  meth_meth_collectionsPrelude_hashcode5854->definitionLine = 1383;
// method hash
  block_savedest(obj5834);
  Object closure5866 = createclosure(2, "hash");
  setclosureframe(closure5866, stackframe);
  addtoclosure(closure5866, var_v);
  addtoclosure(closure5866, var_k);
  struct UserObject *uo5866 = (struct UserObject*)obj5834;
  uo5866->data[5] = (Object)closure5866;
  Method *meth_meth_collectionsPrelude_hash5866 = addmethod2pos(obj5834, "hash", &meth_collectionsPrelude_hash5866, 5);
  int argcv_meth_collectionsPrelude_hash5866[] = {0};
  meth_meth_collectionsPrelude_hash5866->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hash5866);
  meth_meth_collectionsPrelude_hash5866->definitionModule = modulename;
  meth_meth_collectionsPrelude_hash5866->definitionLine = 1384;
// method ==
  block_savedest(obj5834);
  Object closure5878 = createclosure(3, "==");
  setclosureframe(closure5878, stackframe);
  addtoclosure(closure5878, var_v);
  addtoclosure(closure5878, var_k);
  addtoclosure(closure5878, var_Binding);
  struct UserObject *uo5878 = (struct UserObject*)obj5834;
  uo5878->data[6] = (Object)closure5878;
  Method *meth_meth_collectionsPrelude__61__61_5878 = addmethod2pos(obj5834, "==", &meth_collectionsPrelude__61__61_5878, 6);
  int argcv_meth_collectionsPrelude__61__61_5878[] = {1};
  meth_meth_collectionsPrelude__61__61_5878->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61_5878);
  meth_meth_collectionsPrelude__61__61_5878->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61_5878->definitionLine = 1385;
  sourceObject = obj5834;
  sourceObject = obj5834;
  sourceObject = obj5834;
  sourceObject = obj5834;
  sourceObject = obj5834;
  sourceObject = obj5834;
  objclass5834 = obj5834->class;
  objclass5834->definitionModule = modulename;
  objclass5834->definitionLine = 1379;
  (*(struct UserObject *)self).data[0] = lowerouter5834;
  self = oldself5834;
  selfslot = oldselfslot5834;
  stackframe = oldstackframe5834;
  gc_frame_end(frame);
  return obj5834;
}
Object module_collectionsPrelude_init() {
  int flags = 0;
  int frame = gc_frame_new();
  Object self = alloc_obj2(48, 48);
  self->class->definitionModule = modulename;
  gc_root(self);
  prelude = grace_prelude();
  adddatum2(self, grace_prelude(), 0);
  Object ObjectType = alloc_ObjectType();
  addmethod2(self, "outer", &grace_userobj_outer);
  setline(1);
  setmodule(modulename);
  setsource(originalSourceLines);
  setclassname(self, "Module<collectionsPrelude>");
  Object *var_MatchFailed = alloc_var();
  *var_MatchFailed = alloc_MatchFailed();
  Object *var_noSuchValue = alloc_var();
  *var_noSuchValue = done;
  Object *var_done = alloc_var();
  *var_done = done;
  Object *var_Object = alloc_var();
  *var_Object = ObjectType;
  type_Object = ObjectType;
  Object *var_String = alloc_var();
  *var_String = String;
  type_String = String;
  Object *var_Block = alloc_var();
  *var_Block = Block;
  type_Block = Block;
  Object *var_Done = alloc_var();
  *var_Done = Done;
  type_Done = Done;
  Object *var_Number = alloc_var();
  *var_Number = Number;
  type_Number = Number;
  Object *var_Boolean = alloc_var();
  *var_Boolean = Boolean;
  type_Boolean = Boolean;
  Object *var_Dynamic = alloc_var();
  *var_Dynamic = Dynamic;
  Object *var_Unknown = alloc_var();
  *var_Unknown= Unknown;
  Object *var_Type = alloc_var();
  *var_Type = Type;
  type_Done = Type;
  Object *var__prelude = alloc_var();
  *var__prelude = grace_prelude();
  Object *var_prelude = alloc_var();
  *var_prelude = prelude;
  gc_root(*var_MatchFailed);
  emptyclosure = createclosure(0, "empty");
  gc_root(emptyclosure);
  struct StackFrameObject *stackframe = alloc_StackFrame(48, NULL);
  gc_root((Object)stackframe);
  pushstackframe(stackframe, "module scope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object params[1];
  int partcv[1];
  Object *var_BoundsError = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "BoundsError");
  Object *var_Exhausted = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "Exhausted");
  Object *var_SubobjectResponsibility = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "SubobjectResponsibility");
  Object *var_NoSuchObject = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "NoSuchObject");
  Object *var_RequestError = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "RequestError");
  Object *var_ConcurrentModification = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "ConcurrentModification");
  Object *var_SizeUnknown = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "SizeUnknown");
  Object *var_Block0 = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "Block0");
  Object *var_Block1 = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "Block1");
  Object *var_Block2 = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "Block2");
  Object *var_SelfType = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "SelfType");
  Object *var_Collection = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "Collection");
  Object *var_Enumerable = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "Enumerable");
  Object *var_Sequence = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "Sequence");
  Object *var_List = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "List");
  Object *var_Set = &(stackframe->slots[16]);
  setframeelementname(stackframe, 16, "Set");
  Object *var_Dictionary = &(stackframe->slots[17]);
  setframeelementname(stackframe, 17, "Dictionary");
  Object *var_Iterator = &(stackframe->slots[18]);
  setframeelementname(stackframe, 18, "Iterator");
  Object *var_CollectionFactory = &(stackframe->slots[19]);
  setframeelementname(stackframe, 19, "CollectionFactory");
  Object *var_EmptyCollectionFactory = &(stackframe->slots[20]);
  setframeelementname(stackframe, 20, "EmptyCollectionFactory");
  Object *var_collectionFactory = &(stackframe->slots[21]);
  setframeelementname(stackframe, 21, "collectionFactory");
  Object *var_collection = &(stackframe->slots[22]);
  setframeelementname(stackframe, 22, "collection");
  Object *var_enumerable = &(stackframe->slots[23]);
  setframeelementname(stackframe, 23, "enumerable");
  Object *var_indexable = &(stackframe->slots[24]);
  setframeelementname(stackframe, 24, "indexable");
  Object *var_Binding = &(stackframe->slots[25]);
  setframeelementname(stackframe, 25, "Binding");
  Object *var_binding = &(stackframe->slots[26]);
  setframeelementname(stackframe, 26, "binding");
// Begin line 11
  setline(11);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method abstract
  block_savedest(self);
  Object closure0 = createclosure(1, "abstract");
  setclosureframe(closure0, stackframe);
  addtoclosure(closure0, var_SubobjectResponsibility);
  struct UserObject *uo0 = (struct UserObject*)self;
  uo0->data[1] = (Object)closure0;
  Method *meth_meth_collectionsPrelude_abstract0 = addmethod2pos(self, "abstract", &meth_collectionsPrelude_abstract0, 1);
  int argcv_meth_collectionsPrelude_abstract0[] = {0};
  meth_meth_collectionsPrelude_abstract0->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_abstract0);
  meth_meth_collectionsPrelude_abstract0->definitionModule = modulename;
  meth_meth_collectionsPrelude_abstract0->definitionLine = 11;
// compiled method node returning  (depth = 1)
// Begin line 172
  setline(172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method lazySequenceOver()mappedBy
  block_savedest(self);
  Object closure4 = createclosure(1, "lazySequenceOver()mappedBy");
  setclosureframe(closure4, stackframe);
  addtoclosure(closure4, var_enumerable);
  struct UserObject *uo4 = (struct UserObject*)self;
  uo4->data[2] = (Object)closure4;
  Method *meth_meth_collectionsPrelude_lazySequenceOver_40__41_mappedBy4 = addmethod2pos(self, "lazySequenceOver()mappedBy", &meth_collectionsPrelude_lazySequenceOver_40__41_mappedBy4, 2);
  int argcv_meth_collectionsPrelude_lazySequenceOver_40__41_mappedBy4[] = {1, 1};
  meth_meth_collectionsPrelude_lazySequenceOver_40__41_mappedBy4->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_lazySequenceOver_40__41_mappedBy4);
  meth_meth_collectionsPrelude_lazySequenceOver_40__41_mappedBy4->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_lazySequenceOver_40__41_mappedBy4->definitionModule = modulename;
  meth_meth_collectionsPrelude_lazySequenceOver_40__41_mappedBy4->definitionLine = 172;
  block_savedest(self);
  Object closure45 = createclosure(1, "lazySequenceOver()mappedBy()object");
  setclosureframe(closure45, stackframe);
  addtoclosure(closure45, var_enumerable);
  Method *meth_meth_collectionsPrelude_lazySequenceOver_40__41_mappedBy4_object = addmethod2pos(self, "lazySequenceOver()mappedBy()object", &meth_collectionsPrelude_lazySequenceOver_40__41_mappedBy4_object, 2);
  meth_meth_collectionsPrelude_lazySequenceOver_40__41_mappedBy4_object->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_lazySequenceOver_40__41_mappedBy4_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_lazySequenceOver_40__41_mappedBy4_object->definitionLine = 172;
// compiled method node returning  (depth = 1)
// Begin line 186
  setline(186);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method lazySequenceOver()filteredBy
  block_savedest(self);
  Object closure46 = createclosure(2, "lazySequenceOver()filteredBy");
  setclosureframe(closure46, stackframe);
  addtoclosure(closure46, var_Exhausted);
  addtoclosure(closure46, var_enumerable);
  struct UserObject *uo46 = (struct UserObject*)self;
  uo46->data[3] = (Object)closure46;
  Method *meth_meth_collectionsPrelude_lazySequenceOver_40__41_filteredBy46 = addmethod2pos(self, "lazySequenceOver()filteredBy", &meth_collectionsPrelude_lazySequenceOver_40__41_filteredBy46, 3);
  int argcv_meth_collectionsPrelude_lazySequenceOver_40__41_filteredBy46[] = {1, 1};
  meth_meth_collectionsPrelude_lazySequenceOver_40__41_filteredBy46->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_lazySequenceOver_40__41_filteredBy46);
  meth_meth_collectionsPrelude_lazySequenceOver_40__41_filteredBy46->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_lazySequenceOver_40__41_filteredBy46->definitionModule = modulename;
  meth_meth_collectionsPrelude_lazySequenceOver_40__41_filteredBy46->definitionLine = 186;
  block_savedest(self);
  Object closure141 = createclosure(2, "lazySequenceOver()filteredBy()object");
  setclosureframe(closure141, stackframe);
  addtoclosure(closure141, var_Exhausted);
  addtoclosure(closure141, var_enumerable);
  Method *meth_meth_collectionsPrelude_lazySequenceOver_40__41_filteredBy46_object = addmethod2pos(self, "lazySequenceOver()filteredBy()object", &meth_collectionsPrelude_lazySequenceOver_40__41_filteredBy46_object, 3);
  meth_meth_collectionsPrelude_lazySequenceOver_40__41_filteredBy46_object->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_lazySequenceOver_40__41_filteredBy46_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_lazySequenceOver_40__41_filteredBy46_object->definitionLine = 186;
// compiled method node returning  (depth = 1)
// Begin line 221
  setline(221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method iteratorConcat
  struct UserObject *uo142 = (struct UserObject*)self;
  uo142->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_iteratorConcat142 = addmethod2pos(self, "iteratorConcat", &meth_collectionsPrelude_iteratorConcat142, 4);
  int argcv_meth_collectionsPrelude_iteratorConcat142[] = {2};
  meth_meth_collectionsPrelude_iteratorConcat142->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iteratorConcat142);
  meth_meth_collectionsPrelude_iteratorConcat142->definitionModule = modulename;
  meth_meth_collectionsPrelude_iteratorConcat142->definitionLine = 221;
  Method *meth_meth_collectionsPrelude_iteratorConcat142_object = addmethod2pos(self, "iteratorConcat()object", &meth_collectionsPrelude_iteratorConcat142_object, 4);
  int argcv_meth_collectionsPrelude_iteratorConcat142_object[] = {2};
  meth_meth_collectionsPrelude_iteratorConcat142_object->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iteratorConcat142_object);
  meth_meth_collectionsPrelude_iteratorConcat142_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iteratorConcat142_object->definitionLine = 221;
// compiled method node returning  (depth = 1)
// Begin line 236
  setline(236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method lazyConcatenation
  block_savedest(self);
  Object closure179 = createclosure(1, "lazyConcatenation");
  setclosureframe(closure179, stackframe);
  addtoclosure(closure179, var_enumerable);
  struct UserObject *uo179 = (struct UserObject*)self;
  uo179->data[5] = (Object)closure179;
  Method *meth_meth_collectionsPrelude_lazyConcatenation179 = addmethod2pos(self, "lazyConcatenation", &meth_collectionsPrelude_lazyConcatenation179, 5);
  int argcv_meth_collectionsPrelude_lazyConcatenation179[] = {2};
  meth_meth_collectionsPrelude_lazyConcatenation179->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_lazyConcatenation179);
  meth_meth_collectionsPrelude_lazyConcatenation179->definitionModule = modulename;
  meth_meth_collectionsPrelude_lazyConcatenation179->definitionLine = 236;
  block_savedest(self);
  Object closure220 = createclosure(1, "lazyConcatenation()object");
  setclosureframe(closure220, stackframe);
  addtoclosure(closure220, var_enumerable);
  Method *meth_meth_collectionsPrelude_lazyConcatenation179_object = addmethod2pos(self, "lazyConcatenation()object", &meth_collectionsPrelude_lazyConcatenation179_object, 5);
  meth_meth_collectionsPrelude_lazyConcatenation179_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_lazyConcatenation179_object->definitionLine = 236;
// compiled method node returning  (depth = 1)
// Begin line 429
  setline(429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method max
  struct UserObject *uo221 = (struct UserObject*)self;
  uo221->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_max221 = addmethod2pos(self, "max", &meth_collectionsPrelude_max221, 6);
  int argcv_meth_collectionsPrelude_max221[] = {2};
  meth_meth_collectionsPrelude_max221->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_max221);
  meth_meth_collectionsPrelude_max221->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_max221->definitionModule = modulename;
  meth_meth_collectionsPrelude_max221->definitionLine = 429;
// compiled method node returning  (depth = 1)
// Begin line 433
  setline(433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method sequence
  block_savedest(self);
  Object closure226 = createclosure(8, "sequence");
  setclosureframe(closure226, stackframe);
  addtoclosure(closure226, var_SizeUnknown);
  addtoclosure(closure226, var__prelude);
  addtoclosure(closure226, var_BoundsError);
  addtoclosure(closure226, var_Collection);
  addtoclosure(closure226, var_ConcurrentModification);
  addtoclosure(closure226, var_Exhausted);
  addtoclosure(closure226, var_indexable);
  addtoclosure(closure226, var_collectionFactory);
  struct UserObject *uo226 = (struct UserObject*)self;
  uo226->data[7] = (Object)closure226;
  Method *meth_meth_collectionsPrelude_sequence226 = addmethod2pos(self, "sequence", &meth_collectionsPrelude_sequence226, 7);
  int argcv_meth_collectionsPrelude_sequence226[] = {0};
  meth_meth_collectionsPrelude_sequence226->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sequence226);
  meth_meth_collectionsPrelude_sequence226->definitionModule = modulename;
  meth_meth_collectionsPrelude_sequence226->definitionLine = 433;
  block_savedest(self);
  Object closure759 = createclosure(8, "sequence()object");
  setclosureframe(closure759, stackframe);
  addtoclosure(closure759, var_SizeUnknown);
  addtoclosure(closure759, var__prelude);
  addtoclosure(closure759, var_BoundsError);
  addtoclosure(closure759, var_Collection);
  addtoclosure(closure759, var_ConcurrentModification);
  addtoclosure(closure759, var_Exhausted);
  addtoclosure(closure759, var_indexable);
  addtoclosure(closure759, var_collectionFactory);
  Method *meth_meth_collectionsPrelude_sequence226_object = addmethod2pos(self, "sequence()object", &meth_collectionsPrelude_sequence226_object, 7);
  meth_meth_collectionsPrelude_sequence226_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_sequence226_object->definitionLine = 433;
// compiled method node returning  (depth = 1)
// Begin line 591
  setline(591);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method list
  block_savedest(self);
  Object closure760 = createclosure(10, "list");
  setclosureframe(closure760, stackframe);
  addtoclosure(closure760, var_BoundsError);
  addtoclosure(closure760, var_NoSuchObject);
  addtoclosure(closure760, var_done);
  addtoclosure(closure760, var_Collection);
  addtoclosure(closure760, var_ConcurrentModification);
  addtoclosure(closure760, var_Exhausted);
  addtoclosure(closure760, var_indexable);
  addtoclosure(closure760, var__prelude);
  addtoclosure(closure760, var_SizeUnknown);
  addtoclosure(closure760, var_collectionFactory);
  struct UserObject *uo760 = (struct UserObject*)self;
  uo760->data[8] = (Object)closure760;
  Method *meth_meth_collectionsPrelude_list760 = addmethod2pos(self, "list", &meth_collectionsPrelude_list760, 8);
  int argcv_meth_collectionsPrelude_list760[] = {0};
  meth_meth_collectionsPrelude_list760->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_list760);
  meth_meth_collectionsPrelude_list760->definitionModule = modulename;
  meth_meth_collectionsPrelude_list760->definitionLine = 591;
  block_savedest(self);
  Object closure2205 = createclosure(10, "list()object");
  setclosureframe(closure2205, stackframe);
  addtoclosure(closure2205, var_BoundsError);
  addtoclosure(closure2205, var_NoSuchObject);
  addtoclosure(closure2205, var_done);
  addtoclosure(closure2205, var_Collection);
  addtoclosure(closure2205, var_ConcurrentModification);
  addtoclosure(closure2205, var_Exhausted);
  addtoclosure(closure2205, var_indexable);
  addtoclosure(closure2205, var__prelude);
  addtoclosure(closure2205, var_SizeUnknown);
  addtoclosure(closure2205, var_collectionFactory);
  Method *meth_meth_collectionsPrelude_list760_object = addmethod2pos(self, "list()object", &meth_collectionsPrelude_list760_object, 8);
  meth_meth_collectionsPrelude_list760_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_list760_object->definitionLine = 591;
// compiled method node returning  (depth = 1)
// Begin line 1123
  setline(1123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method set
  block_savedest(self);
  Object closure2206 = createclosure(8, "set");
  setclosureframe(closure2206, stackframe);
  addtoclosure(closure2206, var_NoSuchObject);
  addtoclosure(closure2206, var_ConcurrentModification);
  addtoclosure(closure2206, var_Exhausted);
  addtoclosure(closure2206, var__prelude);
  addtoclosure(closure2206, var_Collection);
  addtoclosure(closure2206, var_collection);
  addtoclosure(closure2206, var_SizeUnknown);
  addtoclosure(closure2206, var_collectionFactory);
  struct UserObject *uo2206 = (struct UserObject*)self;
  uo2206->data[9] = (Object)closure2206;
  Method *meth_meth_collectionsPrelude_set2206 = addmethod2pos(self, "set", &meth_collectionsPrelude_set2206, 9);
  int argcv_meth_collectionsPrelude_set2206[] = {0};
  meth_meth_collectionsPrelude_set2206->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_set2206);
  meth_meth_collectionsPrelude_set2206->definitionModule = modulename;
  meth_meth_collectionsPrelude_set2206->definitionLine = 1123;
  block_savedest(self);
  Object closure2975 = createclosure(8, "set()object");
  setclosureframe(closure2975, stackframe);
  addtoclosure(closure2975, var_NoSuchObject);
  addtoclosure(closure2975, var_ConcurrentModification);
  addtoclosure(closure2975, var_Exhausted);
  addtoclosure(closure2975, var__prelude);
  addtoclosure(closure2975, var_Collection);
  addtoclosure(closure2975, var_collection);
  addtoclosure(closure2975, var_SizeUnknown);
  addtoclosure(closure2975, var_collectionFactory);
  Method *meth_meth_collectionsPrelude_set2206_object = addmethod2pos(self, "set()object", &meth_collectionsPrelude_set2206_object, 9);
  meth_meth_collectionsPrelude_set2206_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_set2206_object->definitionLine = 1123;
// compiled method node returning  (depth = 1)
// Begin line 1392
  setline(1392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method dictionary
  block_savedest(self);
  Object closure2976 = createclosure(10, "dictionary");
  setclosureframe(closure2976, stackframe);
  addtoclosure(closure2976, var_binding);
  addtoclosure(closure2976, var_done);
  addtoclosure(closure2976, var_NoSuchObject);
  addtoclosure(closure2976, var_enumerable);
  addtoclosure(closure2976, var_ConcurrentModification);
  addtoclosure(closure2976, var_Exhausted);
  addtoclosure(closure2976, var__prelude);
  addtoclosure(closure2976, var_Dictionary);
  addtoclosure(closure2976, var_collection);
  addtoclosure(closure2976, var_collectionFactory);
  struct UserObject *uo2976 = (struct UserObject*)self;
  uo2976->data[10] = (Object)closure2976;
  Method *meth_meth_collectionsPrelude_dictionary2976 = addmethod2pos(self, "dictionary", &meth_collectionsPrelude_dictionary2976, 10);
  int argcv_meth_collectionsPrelude_dictionary2976[] = {0};
  meth_meth_collectionsPrelude_dictionary2976->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_dictionary2976);
  meth_meth_collectionsPrelude_dictionary2976->definitionModule = modulename;
  meth_meth_collectionsPrelude_dictionary2976->definitionLine = 1392;
  block_savedest(self);
  Object closure4179 = createclosure(10, "dictionary()object");
  setclosureframe(closure4179, stackframe);
  addtoclosure(closure4179, var_binding);
  addtoclosure(closure4179, var_done);
  addtoclosure(closure4179, var_NoSuchObject);
  addtoclosure(closure4179, var_enumerable);
  addtoclosure(closure4179, var_ConcurrentModification);
  addtoclosure(closure4179, var_Exhausted);
  addtoclosure(closure4179, var__prelude);
  addtoclosure(closure4179, var_Dictionary);
  addtoclosure(closure4179, var_collection);
  addtoclosure(closure4179, var_collectionFactory);
  Method *meth_meth_collectionsPrelude_dictionary2976_object = addmethod2pos(self, "dictionary()object", &meth_collectionsPrelude_dictionary2976_object, 10);
  meth_meth_collectionsPrelude_dictionary2976_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_dictionary2976_object->definitionLine = 1392;
// compiled method node returning  (depth = 1)
// Begin line 1724
  setline(1724);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method range
  block_savedest(self);
  Object closure4180 = createclosure(7, "range");
  setclosureframe(closure4180, stackframe);
  addtoclosure(closure4180, var_Exhausted);
  addtoclosure(closure4180, var_BoundsError);
  addtoclosure(closure4180, var__prelude);
  addtoclosure(closure4180, var_Collection);
  addtoclosure(closure4180, var_indexable);
  addtoclosure(closure4180, var_Number);
  addtoclosure(closure4180, var_RequestError);
  struct UserObject *uo4180 = (struct UserObject*)self;
  uo4180->data[11] = (Object)closure4180;
  Method *meth_meth_collectionsPrelude_range4180 = addmethod2pos(self, "range", &meth_collectionsPrelude_range4180, 11);
  int argcv_meth_collectionsPrelude_range4180[] = {0};
  meth_meth_collectionsPrelude_range4180->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_range4180);
  meth_meth_collectionsPrelude_range4180->definitionModule = modulename;
  meth_meth_collectionsPrelude_range4180->definitionLine = 1724;
  block_savedest(self);
  Object closure5232 = createclosure(7, "range()object");
  setclosureframe(closure5232, stackframe);
  addtoclosure(closure5232, var_Exhausted);
  addtoclosure(closure5232, var_BoundsError);
  addtoclosure(closure5232, var__prelude);
  addtoclosure(closure5232, var_Collection);
  addtoclosure(closure5232, var_indexable);
  addtoclosure(closure5232, var_Number);
  addtoclosure(closure5232, var_RequestError);
  Method *meth_meth_collectionsPrelude_range4180_object = addmethod2pos(self, "range()object", &meth_collectionsPrelude_range4180_object, 11);
  meth_meth_collectionsPrelude_range4180_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_range4180_object->definitionLine = 1724;
// compiled method node returning  (depth = 1)
// Begin line 2
  setline(2);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3
  setline(3);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe5233 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit5234 == NULL) {
    strlit5234 = alloc_String("BoundsError");
    gc_root(strlit5234);
  }
// compiled string node returning strlit5234 (depth = 3)
  gc_frame_newslot(strlit5234);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5235 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5236 = callmethodflags(prelude, "ProgrammingError", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5235);
// compiled call node returning call5236 (depth = 4)
// compiled member node returning call5236 (depth = 3)
  params[0] = strlit5234;
  partcv[0] = 1;
  Object call5237 = callmethod(call5236, "refine",
    1, partcv, params);
  gc_frame_end(callframe5233);
// compiled call node returning call5237 (depth = 2)
  *var_BoundsError = call5237;
  if (call5237 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// starting to compile method node (depth = 2)
// method BoundsError
  block_savedest(self);
  Object closure5238 = createclosure(1, "BoundsError");
  setclosureframe(closure5238, stackframe);
  addtoclosure(closure5238, var_BoundsError);
  struct UserObject *uo5238 = (struct UserObject*)self;
  uo5238->data[12] = (Object)closure5238;
  Method *meth_meth_collectionsPrelude_BoundsError5238 = addmethod2pos(self, "BoundsError", &meth_collectionsPrelude_BoundsError5238, 12);
  int argcv_meth_collectionsPrelude_BoundsError5238[] = {0};
  meth_meth_collectionsPrelude_BoundsError5238->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_BoundsError5238);
  meth_meth_collectionsPrelude_BoundsError5238->definitionModule = modulename;
  meth_meth_collectionsPrelude_BoundsError5238->definitionLine = 3;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 4
  setline(4);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe5239 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit5240 == NULL) {
    strlit5240 = alloc_String("iterator Exhausted");
    gc_root(strlit5240);
  }
// compiled string node returning strlit5240 (depth = 3)
  gc_frame_newslot(strlit5240);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5241 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5242 = callmethodflags(prelude, "ProgrammingError", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5241);
// compiled call node returning call5242 (depth = 4)
// compiled member node returning call5242 (depth = 3)
  params[0] = strlit5240;
  partcv[0] = 1;
  Object call5243 = callmethod(call5242, "refine",
    1, partcv, params);
  gc_frame_end(callframe5239);
// compiled call node returning call5243 (depth = 2)
  *var_Exhausted = call5243;
  if (call5243 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// starting to compile method node (depth = 2)
// method Exhausted
  block_savedest(self);
  Object closure5244 = createclosure(1, "Exhausted");
  setclosureframe(closure5244, stackframe);
  addtoclosure(closure5244, var_Exhausted);
  struct UserObject *uo5244 = (struct UserObject*)self;
  uo5244->data[13] = (Object)closure5244;
  Method *meth_meth_collectionsPrelude_Exhausted5244 = addmethod2pos(self, "Exhausted", &meth_collectionsPrelude_Exhausted5244, 13);
  int argcv_meth_collectionsPrelude_Exhausted5244[] = {0};
  meth_meth_collectionsPrelude_Exhausted5244->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_Exhausted5244);
  meth_meth_collectionsPrelude_Exhausted5244->definitionModule = modulename;
  meth_meth_collectionsPrelude_Exhausted5244->definitionLine = 4;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 5
  setline(5);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe5245 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit5246 == NULL) {
    strlit5246 = alloc_String("SubobjectResponsibility");
    gc_root(strlit5246);
  }
// compiled string node returning strlit5246 (depth = 3)
  gc_frame_newslot(strlit5246);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5247 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5248 = callmethodflags(prelude, "ProgrammingError", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5247);
// compiled call node returning call5248 (depth = 4)
// compiled member node returning call5248 (depth = 3)
  params[0] = strlit5246;
  partcv[0] = 1;
  Object call5249 = callmethod(call5248, "refine",
    1, partcv, params);
  gc_frame_end(callframe5245);
// compiled call node returning call5249 (depth = 2)
  *var_SubobjectResponsibility = call5249;
  if (call5249 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// starting to compile method node (depth = 2)
// method SubobjectResponsibility
  block_savedest(self);
  Object closure5250 = createclosure(1, "SubobjectResponsibility");
  setclosureframe(closure5250, stackframe);
  addtoclosure(closure5250, var_SubobjectResponsibility);
  struct UserObject *uo5250 = (struct UserObject*)self;
  uo5250->data[14] = (Object)closure5250;
  Method *meth_meth_collectionsPrelude_SubobjectResponsibility5250 = addmethod2pos(self, "SubobjectResponsibility", &meth_collectionsPrelude_SubobjectResponsibility5250, 14);
  int argcv_meth_collectionsPrelude_SubobjectResponsibility5250[] = {0};
  meth_meth_collectionsPrelude_SubobjectResponsibility5250->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_SubobjectResponsibility5250);
  meth_meth_collectionsPrelude_SubobjectResponsibility5250->definitionModule = modulename;
  meth_meth_collectionsPrelude_SubobjectResponsibility5250->definitionLine = 5;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 6
  setline(6);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe5251 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit5252 == NULL) {
    strlit5252 = alloc_String("no such object");
    gc_root(strlit5252);
  }
// compiled string node returning strlit5252 (depth = 3)
  gc_frame_newslot(strlit5252);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5253 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5254 = callmethodflags(prelude, "ProgrammingError", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5253);
// compiled call node returning call5254 (depth = 4)
// compiled member node returning call5254 (depth = 3)
  params[0] = strlit5252;
  partcv[0] = 1;
  Object call5255 = callmethod(call5254, "refine",
    1, partcv, params);
  gc_frame_end(callframe5251);
// compiled call node returning call5255 (depth = 2)
  *var_NoSuchObject = call5255;
  if (call5255 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// starting to compile method node (depth = 2)
// method NoSuchObject
  block_savedest(self);
  Object closure5256 = createclosure(1, "NoSuchObject");
  setclosureframe(closure5256, stackframe);
  addtoclosure(closure5256, var_NoSuchObject);
  struct UserObject *uo5256 = (struct UserObject*)self;
  uo5256->data[15] = (Object)closure5256;
  Method *meth_meth_collectionsPrelude_NoSuchObject5256 = addmethod2pos(self, "NoSuchObject", &meth_collectionsPrelude_NoSuchObject5256, 15);
  int argcv_meth_collectionsPrelude_NoSuchObject5256[] = {0};
  meth_meth_collectionsPrelude_NoSuchObject5256->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_NoSuchObject5256);
  meth_meth_collectionsPrelude_NoSuchObject5256->definitionModule = modulename;
  meth_meth_collectionsPrelude_NoSuchObject5256->definitionLine = 6;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 7
  setline(7);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe5257 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit5258 == NULL) {
    strlit5258 = alloc_String("inapproriate argument in method request");
    gc_root(strlit5258);
  }
// compiled string node returning strlit5258 (depth = 3)
  gc_frame_newslot(strlit5258);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5259 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5260 = callmethodflags(prelude, "ProgrammingError", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5259);
// compiled call node returning call5260 (depth = 4)
// compiled member node returning call5260 (depth = 3)
  params[0] = strlit5258;
  partcv[0] = 1;
  Object call5261 = callmethod(call5260, "refine",
    1, partcv, params);
  gc_frame_end(callframe5257);
// compiled call node returning call5261 (depth = 2)
  *var_RequestError = call5261;
  if (call5261 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// starting to compile method node (depth = 2)
// method RequestError
  block_savedest(self);
  Object closure5262 = createclosure(1, "RequestError");
  setclosureframe(closure5262, stackframe);
  addtoclosure(closure5262, var_RequestError);
  struct UserObject *uo5262 = (struct UserObject*)self;
  uo5262->data[16] = (Object)closure5262;
  Method *meth_meth_collectionsPrelude_RequestError5262 = addmethod2pos(self, "RequestError", &meth_collectionsPrelude_RequestError5262, 16);
  int argcv_meth_collectionsPrelude_RequestError5262[] = {0};
  meth_meth_collectionsPrelude_RequestError5262->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_RequestError5262);
  meth_meth_collectionsPrelude_RequestError5262->definitionModule = modulename;
  meth_meth_collectionsPrelude_RequestError5262->definitionLine = 7;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 8
  setline(8);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe5263 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit5264 == NULL) {
    strlit5264 = alloc_String("object modified while iterating");
    gc_root(strlit5264);
  }
// compiled string node returning strlit5264 (depth = 3)
  gc_frame_newslot(strlit5264);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5265 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5266 = callmethodflags(prelude, "ProgrammingError", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5265);
// compiled call node returning call5266 (depth = 4)
// compiled member node returning call5266 (depth = 3)
  params[0] = strlit5264;
  partcv[0] = 1;
  Object call5267 = callmethod(call5266, "refine",
    1, partcv, params);
  gc_frame_end(callframe5263);
// compiled call node returning call5267 (depth = 2)
  *var_ConcurrentModification = call5267;
  if (call5267 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// starting to compile method node (depth = 2)
// method ConcurrentModification
  block_savedest(self);
  Object closure5268 = createclosure(1, "ConcurrentModification");
  setclosureframe(closure5268, stackframe);
  addtoclosure(closure5268, var_ConcurrentModification);
  struct UserObject *uo5268 = (struct UserObject*)self;
  uo5268->data[17] = (Object)closure5268;
  Method *meth_meth_collectionsPrelude_ConcurrentModification5268 = addmethod2pos(self, "ConcurrentModification", &meth_collectionsPrelude_ConcurrentModification5268, 17);
  int argcv_meth_collectionsPrelude_ConcurrentModification5268[] = {0};
  meth_meth_collectionsPrelude_ConcurrentModification5268->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_ConcurrentModification5268);
  meth_meth_collectionsPrelude_ConcurrentModification5268->definitionModule = modulename;
  meth_meth_collectionsPrelude_ConcurrentModification5268->definitionLine = 8;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe5269 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit5270 == NULL) {
    strlit5270 = alloc_String("the size is unknown");
    gc_root(strlit5270);
  }
// compiled string node returning strlit5270 (depth = 3)
  gc_frame_newslot(strlit5270);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5271 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5272 = callmethodflags(prelude, "Exception", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5271);
// compiled call node returning call5272 (depth = 4)
// compiled member node returning call5272 (depth = 3)
  params[0] = strlit5270;
  partcv[0] = 1;
  Object call5273 = callmethod(call5272, "refine",
    1, partcv, params);
  gc_frame_end(callframe5269);
// compiled call node returning call5273 (depth = 2)
  *var_SizeUnknown = call5273;
  if (call5273 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// starting to compile method node (depth = 2)
// method SizeUnknown
  block_savedest(self);
  Object closure5274 = createclosure(1, "SizeUnknown");
  setclosureframe(closure5274, stackframe);
  addtoclosure(closure5274, var_SizeUnknown);
  struct UserObject *uo5274 = (struct UserObject*)self;
  uo5274->data[18] = (Object)closure5274;
  Method *meth_meth_collectionsPrelude_SizeUnknown5274 = addmethod2pos(self, "SizeUnknown", &meth_collectionsPrelude_SizeUnknown5274, 18);
  int argcv_meth_collectionsPrelude_SizeUnknown5274[] = {0};
  meth_meth_collectionsPrelude_SizeUnknown5274->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_SizeUnknown5274);
  meth_meth_collectionsPrelude_SizeUnknown5274->definitionModule = modulename;
  meth_meth_collectionsPrelude_SizeUnknown5274->definitionLine = 9;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 10
  setline(10);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 15
  setline(15);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Block0
// starting to compile typeliteral node (depth = 2)
//   Type literal 
    Object type5276 = alloc_Type("Block0", 1);
    add_Method((ClassData)type5276, "apply", NULL);
// compiled typeliteral node returning type5276 (depth = 2)
  *var_Block0 = type5276;
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method Block0
  block_savedest(self);
  Object closure5277 = createclosure(1, "Block0");
  setclosureframe(closure5277, stackframe);
  addtoclosure(closure5277, var_Block0);
  struct UserObject *uo5277 = (struct UserObject*)self;
  uo5277->data[19] = (Object)closure5277;
  Method *meth_meth_collectionsPrelude_Block05277 = addmethod2pos(self, "Block0", &meth_collectionsPrelude_Block05277, 19);
  int argcv_meth_collectionsPrelude_Block05277[] = {0};
  meth_meth_collectionsPrelude_Block05277->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_Block05277);
  meth_meth_collectionsPrelude_Block05277->definitionModule = modulename;
  meth_meth_collectionsPrelude_Block05277->definitionLine = 9;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 19
  setline(19);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 20
  setline(20);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Block1
// starting to compile typeliteral node (depth = 2)
//   Type literal 
    Object type5279 = alloc_Type("Block1", 1);
    add_Method((ClassData)type5279, "apply", NULL);
// compiled typeliteral node returning type5279 (depth = 2)
  *var_Block1 = type5279;
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method Block1
  block_savedest(self);
  Object closure5280 = createclosure(1, "Block1");
  setclosureframe(closure5280, stackframe);
  addtoclosure(closure5280, var_Block1);
  struct UserObject *uo5280 = (struct UserObject*)self;
  uo5280->data[20] = (Object)closure5280;
  Method *meth_meth_collectionsPrelude_Block15280 = addmethod2pos(self, "Block1", &meth_collectionsPrelude_Block15280, 20);
  int argcv_meth_collectionsPrelude_Block15280[] = {0};
  meth_meth_collectionsPrelude_Block15280->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_Block15280);
  meth_meth_collectionsPrelude_Block15280->definitionModule = modulename;
  meth_meth_collectionsPrelude_Block15280->definitionLine = 9;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 23
  setline(23);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 24
  setline(24);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Block2
// starting to compile typeliteral node (depth = 2)
//   Type literal 
    Object type5282 = alloc_Type("Block2", 1);
    add_Method((ClassData)type5282, "apply", NULL);
// compiled typeliteral node returning type5282 (depth = 2)
  *var_Block2 = type5282;
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method Block2
  block_savedest(self);
  Object closure5283 = createclosure(1, "Block2");
  setclosureframe(closure5283, stackframe);
  addtoclosure(closure5283, var_Block2);
  struct UserObject *uo5283 = (struct UserObject*)self;
  uo5283->data[21] = (Object)closure5283;
  Method *meth_meth_collectionsPrelude_Block25283 = addmethod2pos(self, "Block2", &meth_collectionsPrelude_Block25283, 21);
  int argcv_meth_collectionsPrelude_Block25283[] = {0};
  meth_meth_collectionsPrelude_Block25283->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_Block25283);
  meth_meth_collectionsPrelude_Block25283->definitionModule = modulename;
  meth_meth_collectionsPrelude_Block25283->definitionLine = 9;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 27
  setline(27);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 28
  setline(28);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl SelfType
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_Unknown (depth = 2)
  *var_SelfType = *var_Unknown;
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method SelfType
  block_savedest(self);
  Object closure5285 = createclosure(1, "SelfType");
  setclosureframe(closure5285, stackframe);
  addtoclosure(closure5285, var_SelfType);
  struct UserObject *uo5285 = (struct UserObject*)self;
  uo5285->data[22] = (Object)closure5285;
  Method *meth_meth_collectionsPrelude_SelfType5285 = addmethod2pos(self, "SelfType", &meth_collectionsPrelude_SelfType5285, 22);
  int argcv_meth_collectionsPrelude_SelfType5285[] = {0};
  meth_meth_collectionsPrelude_SelfType5285->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_SelfType5285);
  meth_meth_collectionsPrelude_SelfType5285->definitionModule = modulename;
  meth_meth_collectionsPrelude_SelfType5285->definitionLine = 9;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 29
  setline(29);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 30
  setline(30);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Collection
// starting to compile op node (depth = 2)
// starting to compile typeliteral node (depth = 3)
//   Type literal 
    Object type5288 = alloc_Type("‹anon›", 11);
    add_Method((ClassData)type5288, "isEmpty", NULL);
    add_Method((ClassData)type5288, "do", NULL);
    add_Method((ClassData)type5288, "do()separatedBy", NULL);
    add_Method((ClassData)type5288, "fold()startingWith", NULL);
    add_Method((ClassData)type5288, "map", NULL);
    add_Method((ClassData)type5288, "filter", NULL);
    add_Method((ClassData)type5288, "iterator", NULL);
    add_Method((ClassData)type5288, "++", NULL);
    add_Method((ClassData)type5288, "asList", NULL);
    add_Method((ClassData)type5288, "asSequence", NULL);
    add_Method((ClassData)type5288, "asSet", NULL);
// compiled typeliteral node returning type5288 (depth = 3)
  int op_slot_right_5287 = gc_frame_newslot(type5288);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Object (depth = 3)
  int op_slot_left_5287 = gc_frame_newslot(*var_Object);
  params[0] = type5288;
  partcv[0] = 1;
  Object opresult5290 = callmethod(*var_Object, "&", 1, partcv, params);
// compiled op node returning opresult5290 (depth = 2)
  *var_Collection = opresult5290;
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method Collection
  block_savedest(self);
  Object closure5291 = createclosure(1, "Collection");
  setclosureframe(closure5291, stackframe);
  addtoclosure(closure5291, var_Collection);
  struct UserObject *uo5291 = (struct UserObject*)self;
  uo5291->data[23] = (Object)closure5291;
  Method *meth_meth_collectionsPrelude_Collection5291 = addmethod2pos(self, "Collection", &meth_collectionsPrelude_Collection5291, 23);
  int argcv_meth_collectionsPrelude_Collection5291[] = {0};
  meth_meth_collectionsPrelude_Collection5291->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_Collection5291);
  meth_meth_collectionsPrelude_Collection5291->definitionModule = modulename;
  meth_meth_collectionsPrelude_Collection5291->definitionLine = 9;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 43
  setline(43);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 44
  setline(44);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Enumerable
// starting to compile op node (depth = 2)
// starting to compile typeliteral node (depth = 3)
//   Type literal 
    Object type5294 = alloc_Type("‹anon›", 7);
    add_Method((ClassData)type5294, "values", NULL);
    add_Method((ClassData)type5294, "asDictionary", NULL);
    add_Method((ClassData)type5294, "keysAndValuesDo", NULL);
    add_Method((ClassData)type5294, "onto", NULL);
    add_Method((ClassData)type5294, "into", NULL);
    add_Method((ClassData)type5294, "sortedBy", NULL);
    add_Method((ClassData)type5294, "sorted", NULL);
// compiled typeliteral node returning type5294 (depth = 3)
  int op_slot_right_5293 = gc_frame_newslot(type5294);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Collection (depth = 3)
  int op_slot_left_5293 = gc_frame_newslot(*var_Collection);
  params[0] = type5294;
  partcv[0] = 1;
  Object opresult5296 = callmethod(*var_Collection, "&", 1, partcv, params);
// compiled op node returning opresult5296 (depth = 2)
  *var_Enumerable = opresult5296;
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method Enumerable
  block_savedest(self);
  Object closure5297 = createclosure(1, "Enumerable");
  setclosureframe(closure5297, stackframe);
  addtoclosure(closure5297, var_Enumerable);
  struct UserObject *uo5297 = (struct UserObject*)self;
  uo5297->data[24] = (Object)closure5297;
  Method *meth_meth_collectionsPrelude_Enumerable5297 = addmethod2pos(self, "Enumerable", &meth_collectionsPrelude_Enumerable5297, 24);
  int argcv_meth_collectionsPrelude_Enumerable5297[] = {0};
  meth_meth_collectionsPrelude_Enumerable5297->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_Enumerable5297);
  meth_meth_collectionsPrelude_Enumerable5297->definitionModule = modulename;
  meth_meth_collectionsPrelude_Enumerable5297->definitionLine = 9;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 53
  setline(53);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 54
  setline(54);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Sequence
// starting to compile op node (depth = 2)
// starting to compile typeliteral node (depth = 3)
//   Type literal 
    Object type5300 = alloc_Type("‹anon›", 15);
    add_Method((ClassData)type5300, "size", NULL);
    add_Method((ClassData)type5300, "at", NULL);
    add_Method((ClassData)type5300, "[]", NULL);
    add_Method((ClassData)type5300, "indices", NULL);
    add_Method((ClassData)type5300, "keys", NULL);
    add_Method((ClassData)type5300, "first", NULL);
    add_Method((ClassData)type5300, "second", NULL);
    add_Method((ClassData)type5300, "third", NULL);
    add_Method((ClassData)type5300, "fourth", NULL);
    add_Method((ClassData)type5300, "fifth", NULL);
    add_Method((ClassData)type5300, "last", NULL);
    add_Method((ClassData)type5300, "indexOf()ifAbsent", NULL);
    add_Method((ClassData)type5300, "indexOf", NULL);
    add_Method((ClassData)type5300, "contains", NULL);
    add_Method((ClassData)type5300, "reversed", NULL);
// compiled typeliteral node returning type5300 (depth = 3)
  int op_slot_right_5299 = gc_frame_newslot(type5300);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Enumerable (depth = 3)
  int op_slot_left_5299 = gc_frame_newslot(*var_Enumerable);
  params[0] = type5300;
  partcv[0] = 1;
  Object opresult5302 = callmethod(*var_Enumerable, "&", 1, partcv, params);
// compiled op node returning opresult5302 (depth = 2)
  *var_Sequence = opresult5302;
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method Sequence
  block_savedest(self);
  Object closure5303 = createclosure(1, "Sequence");
  setclosureframe(closure5303, stackframe);
  addtoclosure(closure5303, var_Sequence);
  struct UserObject *uo5303 = (struct UserObject*)self;
  uo5303->data[25] = (Object)closure5303;
  Method *meth_meth_collectionsPrelude_Sequence5303 = addmethod2pos(self, "Sequence", &meth_collectionsPrelude_Sequence5303, 25);
  int argcv_meth_collectionsPrelude_Sequence5303[] = {0};
  meth_meth_collectionsPrelude_Sequence5303->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_Sequence5303);
  meth_meth_collectionsPrelude_Sequence5303->definitionModule = modulename;
  meth_meth_collectionsPrelude_Sequence5303->definitionLine = 9;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 71
  setline(71);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 72
  setline(72);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl List
// starting to compile op node (depth = 2)
// starting to compile typeliteral node (depth = 3)
//   Type literal 
    Object type5306 = alloc_Type("‹anon›", 30);
    add_Method((ClassData)type5306, "add", NULL);
    add_Method((ClassData)type5306, "addAll", NULL);
    add_Method((ClassData)type5306, "addFirst", NULL);
    add_Method((ClassData)type5306, "addAllFirst", NULL);
    add_Method((ClassData)type5306, "addLast", NULL);
    add_Method((ClassData)type5306, "at()put", NULL);
    add_Method((ClassData)type5306, "[]:=", NULL);
    add_Method((ClassData)type5306, "removeFirst", NULL);
    add_Method((ClassData)type5306, "removeAt", NULL);
    add_Method((ClassData)type5306, "removeLast", NULL);
    add_Method((ClassData)type5306, "remove", NULL);
    add_Method((ClassData)type5306, "remove()ifAbsent", NULL);
    add_Method((ClassData)type5306, "removeAll", NULL);
    add_Method((ClassData)type5306, "removeAll()ifAbsent", NULL);
    add_Method((ClassData)type5306, "indexOf", NULL);
    add_Method((ClassData)type5306, "indexOf()ifAbsent", NULL);
    add_Method((ClassData)type5306, "pop", NULL);
    add_Method((ClassData)type5306, "first", NULL);
    add_Method((ClassData)type5306, "second", NULL);
    add_Method((ClassData)type5306, "third", NULL);
    add_Method((ClassData)type5306, "fourth", NULL);
    add_Method((ClassData)type5306, "fifth", NULL);
    add_Method((ClassData)type5306, "last", NULL);
    add_Method((ClassData)type5306, "++", NULL);
    add_Method((ClassData)type5306, "addAll", NULL);
    add_Method((ClassData)type5306, "copy", NULL);
    add_Method((ClassData)type5306, "sort", NULL);
    add_Method((ClassData)type5306, "sortBy", NULL);
    add_Method((ClassData)type5306, "reverse", NULL);
    add_Method((ClassData)type5306, "reversed", NULL);
// compiled typeliteral node returning type5306 (depth = 3)
  int op_slot_right_5305 = gc_frame_newslot(type5306);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Sequence (depth = 3)
  int op_slot_left_5305 = gc_frame_newslot(*var_Sequence);
  params[0] = type5306;
  partcv[0] = 1;
  Object opresult5308 = callmethod(*var_Sequence, "&", 1, partcv, params);
// compiled op node returning opresult5308 (depth = 2)
  *var_List = opresult5308;
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method List
  block_savedest(self);
  Object closure5309 = createclosure(1, "List");
  setclosureframe(closure5309, stackframe);
  addtoclosure(closure5309, var_List);
  struct UserObject *uo5309 = (struct UserObject*)self;
  uo5309->data[26] = (Object)closure5309;
  Method *meth_meth_collectionsPrelude_List5309 = addmethod2pos(self, "List", &meth_collectionsPrelude_List5309, 26);
  int argcv_meth_collectionsPrelude_List5309[] = {0};
  meth_meth_collectionsPrelude_List5309->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_List5309);
  meth_meth_collectionsPrelude_List5309->definitionModule = modulename;
  meth_meth_collectionsPrelude_List5309->definitionLine = 9;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 104
  setline(104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 105
  setline(105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Set
// starting to compile op node (depth = 2)
// starting to compile typeliteral node (depth = 3)
//   Type literal 
    Object type5312 = alloc_Type("‹anon›", 16);
    add_Method((ClassData)type5312, "size", NULL);
    add_Method((ClassData)type5312, "add", NULL);
    add_Method((ClassData)type5312, "addAll", NULL);
    add_Method((ClassData)type5312, "remove", NULL);
    add_Method((ClassData)type5312, "remove()ifAbsent", NULL);
    add_Method((ClassData)type5312, "includes", NULL);
    add_Method((ClassData)type5312, "find()ifNone", NULL);
    add_Method((ClassData)type5312, "copy", NULL);
    add_Method((ClassData)type5312, "contains", NULL);
    add_Method((ClassData)type5312, "**", NULL);
    add_Method((ClassData)type5312, "--", NULL);
    add_Method((ClassData)type5312, "++", NULL);
    add_Method((ClassData)type5312, "removeAll", NULL);
    add_Method((ClassData)type5312, "removeAll()ifAbsent", NULL);
    add_Method((ClassData)type5312, "onto", NULL);
    add_Method((ClassData)type5312, "into", NULL);
// compiled typeliteral node returning type5312 (depth = 3)
  int op_slot_right_5311 = gc_frame_newslot(type5312);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Collection (depth = 3)
  int op_slot_left_5311 = gc_frame_newslot(*var_Collection);
  params[0] = type5312;
  partcv[0] = 1;
  Object opresult5314 = callmethod(*var_Collection, "&", 1, partcv, params);
// compiled op node returning opresult5314 (depth = 2)
  *var_Set = opresult5314;
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method Set
  block_savedest(self);
  Object closure5315 = createclosure(1, "Set");
  setclosureframe(closure5315, stackframe);
  addtoclosure(closure5315, var_Set);
  struct UserObject *uo5315 = (struct UserObject*)self;
  uo5315->data[27] = (Object)closure5315;
  Method *meth_meth_collectionsPrelude_Set5315 = addmethod2pos(self, "Set", &meth_collectionsPrelude_Set5315, 27);
  int argcv_meth_collectionsPrelude_Set5315[] = {0};
  meth_meth_collectionsPrelude_Set5315->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_Set5315);
  meth_meth_collectionsPrelude_Set5315->definitionModule = modulename;
  meth_meth_collectionsPrelude_Set5315->definitionLine = 9;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 123
  setline(123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 124
  setline(124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Dictionary
// starting to compile op node (depth = 2)
// starting to compile typeliteral node (depth = 3)
//   Type literal 
    Object type5318 = alloc_Type("‹anon›", 24);
    add_Method((ClassData)type5318, "size", NULL);
    add_Method((ClassData)type5318, "containsKey", NULL);
    add_Method((ClassData)type5318, "containsValue", NULL);
    add_Method((ClassData)type5318, "contains", NULL);
    add_Method((ClassData)type5318, "at()ifAbsent", NULL);
    add_Method((ClassData)type5318, "at()put", NULL);
    add_Method((ClassData)type5318, "[]:=", NULL);
    add_Method((ClassData)type5318, "at", NULL);
    add_Method((ClassData)type5318, "[]", NULL);
    add_Method((ClassData)type5318, "removeAllKeys", NULL);
    add_Method((ClassData)type5318, "removeKey", NULL);
    add_Method((ClassData)type5318, "removeAllValues", NULL);
    add_Method((ClassData)type5318, "removeValue", NULL);
    add_Method((ClassData)type5318, "keys", NULL);
    add_Method((ClassData)type5318, "values", NULL);
    add_Method((ClassData)type5318, "bindings", NULL);
    add_Method((ClassData)type5318, "keysAndValuesDo", NULL);
    add_Method((ClassData)type5318, "keysDo", NULL);
    add_Method((ClassData)type5318, "valuesDo", NULL);
    add_Method((ClassData)type5318, "==", NULL);
    add_Method((ClassData)type5318, "copy", NULL);
    add_Method((ClassData)type5318, "++", NULL);
    add_Method((ClassData)type5318, "--", NULL);
    add_Method((ClassData)type5318, "asDictionary", NULL);
// compiled typeliteral node returning type5318 (depth = 3)
  int op_slot_right_5317 = gc_frame_newslot(type5318);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Collection (depth = 3)
  int op_slot_left_5317 = gc_frame_newslot(*var_Collection);
  params[0] = type5318;
  partcv[0] = 1;
  Object opresult5320 = callmethod(*var_Collection, "&", 1, partcv, params);
// compiled op node returning opresult5320 (depth = 2)
  *var_Dictionary = opresult5320;
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method Dictionary
  block_savedest(self);
  Object closure5321 = createclosure(1, "Dictionary");
  setclosureframe(closure5321, stackframe);
  addtoclosure(closure5321, var_Dictionary);
  struct UserObject *uo5321 = (struct UserObject*)self;
  uo5321->data[28] = (Object)closure5321;
  Method *meth_meth_collectionsPrelude_Dictionary5321 = addmethod2pos(self, "Dictionary", &meth_collectionsPrelude_Dictionary5321, 28);
  int argcv_meth_collectionsPrelude_Dictionary5321[] = {0};
  meth_meth_collectionsPrelude_Dictionary5321->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_Dictionary5321);
  meth_meth_collectionsPrelude_Dictionary5321->definitionModule = modulename;
  meth_meth_collectionsPrelude_Dictionary5321->definitionLine = 9;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 150
  setline(150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 151
  setline(151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Iterator
// starting to compile typeliteral node (depth = 2)
//   Type literal 
    Object type5323 = alloc_Type("Iterator", 2);
    add_Method((ClassData)type5323, "hasNext", NULL);
    add_Method((ClassData)type5323, "next", NULL);
// compiled typeliteral node returning type5323 (depth = 2)
  *var_Iterator = type5323;
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method Iterator
  block_savedest(self);
  Object closure5324 = createclosure(1, "Iterator");
  setclosureframe(closure5324, stackframe);
  addtoclosure(closure5324, var_Iterator);
  struct UserObject *uo5324 = (struct UserObject*)self;
  uo5324->data[29] = (Object)closure5324;
  Method *meth_meth_collectionsPrelude_Iterator5324 = addmethod2pos(self, "Iterator", &meth_collectionsPrelude_Iterator5324, 29);
  int argcv_meth_collectionsPrelude_Iterator5324[] = {0};
  meth_meth_collectionsPrelude_Iterator5324->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_Iterator5324);
  meth_meth_collectionsPrelude_Iterator5324->definitionModule = modulename;
  meth_meth_collectionsPrelude_Iterator5324->definitionLine = 9;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 155
  setline(155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 156
  setline(156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl CollectionFactory
// starting to compile typeliteral node (depth = 2)
//   Type literal 
    Object type5326 = alloc_Type("CollectionFactory", 3);
    add_Method((ClassData)type5326, "withAll", NULL);
    add_Method((ClassData)type5326, "with", NULL);
    add_Method((ClassData)type5326, "empty", NULL);
// compiled typeliteral node returning type5326 (depth = 2)
  *var_CollectionFactory = type5326;
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method CollectionFactory
  block_savedest(self);
  Object closure5327 = createclosure(1, "CollectionFactory");
  setclosureframe(closure5327, stackframe);
  addtoclosure(closure5327, var_CollectionFactory);
  struct UserObject *uo5327 = (struct UserObject*)self;
  uo5327->data[30] = (Object)closure5327;
  Method *meth_meth_collectionsPrelude_CollectionFactory5327 = addmethod2pos(self, "CollectionFactory", &meth_collectionsPrelude_CollectionFactory5327, 30);
  int argcv_meth_collectionsPrelude_CollectionFactory5327[] = {0};
  meth_meth_collectionsPrelude_CollectionFactory5327->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_CollectionFactory5327);
  meth_meth_collectionsPrelude_CollectionFactory5327->definitionModule = modulename;
  meth_meth_collectionsPrelude_CollectionFactory5327->definitionLine = 9;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 161
  setline(161);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 162
  setline(162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl EmptyCollectionFactory
// starting to compile typeliteral node (depth = 2)
//   Type literal 
    Object type5329 = alloc_Type("EmptyCollectionFactory", 1);
    add_Method((ClassData)type5329, "empty", NULL);
// compiled typeliteral node returning type5329 (depth = 2)
  *var_EmptyCollectionFactory = type5329;
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method EmptyCollectionFactory
  block_savedest(self);
  Object closure5330 = createclosure(1, "EmptyCollectionFactory");
  setclosureframe(closure5330, stackframe);
  addtoclosure(closure5330, var_EmptyCollectionFactory);
  struct UserObject *uo5330 = (struct UserObject*)self;
  uo5330->data[31] = (Object)closure5330;
  Method *meth_meth_collectionsPrelude_EmptyCollectionFactory5330 = addmethod2pos(self, "EmptyCollectionFactory", &meth_collectionsPrelude_EmptyCollectionFactory5330, 31);
  int argcv_meth_collectionsPrelude_EmptyCollectionFactory5330[] = {0};
  meth_meth_collectionsPrelude_EmptyCollectionFactory5330->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_EmptyCollectionFactory5330);
  meth_meth_collectionsPrelude_EmptyCollectionFactory5330->definitionModule = modulename;
  meth_meth_collectionsPrelude_EmptyCollectionFactory5330->definitionLine = 9;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 165
  setline(165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 166
  setline(166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method collectionFactory
  block_savedest(self);
  Object closure5331 = createclosure(1, "collectionFactory");
  setclosureframe(closure5331, stackframe);
  addtoclosure(closure5331, var_collectionFactory);
  struct UserObject *uo5331 = (struct UserObject*)self;
  uo5331->data[32] = (Object)closure5331;
  Method *meth_meth_collectionsPrelude_collectionFactory5331 = addmethod2pos(self, "collectionFactory", &meth_collectionsPrelude_collectionFactory5331, 32);
  int argcv_meth_collectionsPrelude_collectionFactory5331[] = {0};
  meth_meth_collectionsPrelude_collectionFactory5331->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_collectionFactory5331);
  meth_meth_collectionsPrelude_collectionFactory5331->definitionModule = modulename;
  meth_meth_collectionsPrelude_collectionFactory5331->definitionLine = 166;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject5332 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5332 = alloc_userobj2(2,4, objclass5332);
  gc_frame_newslot(obj5332);
// OBJECT OUTER DEC outer
  adddatum2(obj5332, self, 0);
  addmethodreal(obj5332,"outer", &reader_collectionsPrelude_outer_5333);
  Object oldself5332 = self;
  struct StackFrameObject *oldstackframe5332 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5332);
  gc_frame_newslot((Object)stackframe);
  self = obj5332;
  Object *oldselfslot5332 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5332 = (*(struct UserObject *)self).data[0], lowerouter5332 = thisouter5332;
  if (inheritingObject5332) {
    struct UserObject *inho5332 = (struct UserObject *)inheritingObject5332;
    while (inho5332->super != GraceDefaultObject) inho5332 = (struct UserObject *)inho5332->super;
    inho5332->super = obj5332;
    self = inheritingObject5332;
    *selfslot = self;
    lowerouter5332 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5332;
  }
// method trait
  struct UserObject *uo5334 = (struct UserObject*)obj5332;
  uo5334->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_trait5334 = addmethod2pos(obj5332, "trait", &meth_collectionsPrelude_trait5334, 1);
  int argcv_meth_collectionsPrelude_trait5334[] = {0};
  meth_meth_collectionsPrelude_trait5334->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_trait5334);
  meth_meth_collectionsPrelude_trait5334->definitionModule = modulename;
  meth_meth_collectionsPrelude_trait5334->definitionLine = 166;
  Method *meth_meth_collectionsPrelude_trait5334_object = addmethod2pos(obj5332, "trait()object", &meth_collectionsPrelude_trait5334_object, 1);
  int argcv_meth_collectionsPrelude_trait5334_object[] = {0};
  meth_meth_collectionsPrelude_trait5334_object->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_trait5334_object);
  meth_meth_collectionsPrelude_trait5334_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_trait5334_object->definitionLine = 166;
  sourceObject = obj5332;
  objclass5332 = obj5332->class;
  objclass5332->definitionModule = modulename;
  objclass5332->definitionLine = 166;
  (*(struct UserObject *)self).data[0] = lowerouter5332;
  self = oldself5332;
  selfslot = oldselfslot5332;
  stackframe = oldstackframe5332;
// compiled object node returning obj5332 (depth = 3)
  *var_collectionFactory = obj5332;
  if (obj5332 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 171
  setline(171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 185
  setline(185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 245
  setline(245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 246
  setline(246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method collection
  block_savedest(self);
  Object closure5351 = createclosure(1, "collection");
  setclosureframe(closure5351, stackframe);
  addtoclosure(closure5351, var_collection);
  struct UserObject *uo5351 = (struct UserObject*)self;
  uo5351->data[33] = (Object)closure5351;
  Method *meth_meth_collectionsPrelude_collection5351 = addmethod2pos(self, "collection", &meth_collectionsPrelude_collection5351, 33);
  int argcv_meth_collectionsPrelude_collection5351[] = {0};
  meth_meth_collectionsPrelude_collection5351->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_collection5351);
  meth_meth_collectionsPrelude_collection5351->definitionModule = modulename;
  meth_meth_collectionsPrelude_collection5351->definitionLine = 246;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject5352 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5352 = alloc_userobj2(2,4, objclass5352);
  gc_frame_newslot(obj5352);
// OBJECT OUTER DEC outer
  adddatum2(obj5352, self, 0);
  addmethodreal(obj5352,"outer", &reader_collectionsPrelude_outer_5353);
  Object oldself5352 = self;
  struct StackFrameObject *oldstackframe5352 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5352);
  gc_frame_newslot((Object)stackframe);
  self = obj5352;
  Object *oldselfslot5352 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5352 = (*(struct UserObject *)self).data[0], lowerouter5352 = thisouter5352;
  if (inheritingObject5352) {
    struct UserObject *inho5352 = (struct UserObject *)inheritingObject5352;
    while (inho5352->super != GraceDefaultObject) inho5352 = (struct UserObject *)inho5352->super;
    inho5352->super = obj5352;
    self = inheritingObject5352;
    *selfslot = self;
    lowerouter5352 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5352;
  }
// method trait
  struct UserObject *uo5354 = (struct UserObject*)obj5352;
  uo5354->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_trait5354 = addmethod2pos(obj5352, "trait", &meth_collectionsPrelude_trait5354, 1);
  int argcv_meth_collectionsPrelude_trait5354[] = {0};
  meth_meth_collectionsPrelude_trait5354->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_trait5354);
  meth_meth_collectionsPrelude_trait5354->definitionModule = modulename;
  meth_meth_collectionsPrelude_trait5354->definitionLine = 246;
  Method *meth_meth_collectionsPrelude_trait5354_object = addmethod2pos(obj5352, "trait()object", &meth_collectionsPrelude_trait5354_object, 1);
  int argcv_meth_collectionsPrelude_trait5354_object[] = {0};
  meth_meth_collectionsPrelude_trait5354_object->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_trait5354_object);
  meth_meth_collectionsPrelude_trait5354_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_trait5354_object->definitionLine = 246;
  sourceObject = obj5352;
  objclass5352 = obj5352->class;
  objclass5352->definitionModule = modulename;
  objclass5352->definitionLine = 246;
  (*(struct UserObject *)self).data[0] = lowerouter5352;
  self = oldself5352;
  selfslot = oldselfslot5352;
  stackframe = oldstackframe5352;
// compiled object node returning obj5352 (depth = 3)
  *var_collection = obj5352;
  if (obj5352 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 296
  setline(296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 297
  setline(297);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method enumerable
  block_savedest(self);
  Object closure5450 = createclosure(1, "enumerable");
  setclosureframe(closure5450, stackframe);
  addtoclosure(closure5450, var_enumerable);
  struct UserObject *uo5450 = (struct UserObject*)self;
  uo5450->data[34] = (Object)closure5450;
  Method *meth_meth_collectionsPrelude_enumerable5450 = addmethod2pos(self, "enumerable", &meth_collectionsPrelude_enumerable5450, 34);
  int argcv_meth_collectionsPrelude_enumerable5450[] = {0};
  meth_meth_collectionsPrelude_enumerable5450->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_enumerable5450);
  meth_meth_collectionsPrelude_enumerable5450->definitionModule = modulename;
  meth_meth_collectionsPrelude_enumerable5450->definitionLine = 297;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject5451 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5451 = alloc_userobj2(2,4, objclass5451);
  gc_frame_newslot(obj5451);
// OBJECT OUTER DEC outer
  adddatum2(obj5451, self, 0);
  addmethodreal(obj5451,"outer", &reader_collectionsPrelude_outer_5452);
  Object oldself5451 = self;
  struct StackFrameObject *oldstackframe5451 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5451);
  gc_frame_newslot((Object)stackframe);
  self = obj5451;
  Object *oldselfslot5451 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5451 = (*(struct UserObject *)self).data[0], lowerouter5451 = thisouter5451;
  if (inheritingObject5451) {
    struct UserObject *inho5451 = (struct UserObject *)inheritingObject5451;
    while (inho5451->super != GraceDefaultObject) inho5451 = (struct UserObject *)inho5451->super;
    inho5451->super = obj5451;
    self = inheritingObject5451;
    *selfslot = self;
    lowerouter5451 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5451;
  }
// method trait
  block_savedest(obj5451);
  Object closure5453 = createclosure(3, "trait");
  setclosureframe(closure5453, stackframe);
  addtoclosure(closure5453, var_SizeUnknown);
  addtoclosure(closure5453, var_Collection);
  addtoclosure(closure5453, var_collection);
  struct UserObject *uo5453 = (struct UserObject*)obj5451;
  uo5453->data[1] = (Object)closure5453;
  Method *meth_meth_collectionsPrelude_trait5453 = addmethod2pos(obj5451, "trait", &meth_collectionsPrelude_trait5453, 1);
  int argcv_meth_collectionsPrelude_trait5453[] = {0};
  meth_meth_collectionsPrelude_trait5453->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_trait5453);
  meth_meth_collectionsPrelude_trait5453->definitionModule = modulename;
  meth_meth_collectionsPrelude_trait5453->definitionLine = 297;
  block_savedest(obj5451);
  Object closure5668 = createclosure(3, "trait()object");
  setclosureframe(closure5668, stackframe);
  addtoclosure(closure5668, var_SizeUnknown);
  addtoclosure(closure5668, var_Collection);
  addtoclosure(closure5668, var_collection);
  Method *meth_meth_collectionsPrelude_trait5453_object = addmethod2pos(obj5451, "trait()object", &meth_collectionsPrelude_trait5453_object, 1);
  meth_meth_collectionsPrelude_trait5453_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_trait5453_object->definitionLine = 297;
  sourceObject = obj5451;
  objclass5451 = obj5451->class;
  objclass5451->definitionModule = modulename;
  objclass5451->definitionLine = 297;
  (*(struct UserObject *)self).data[0] = lowerouter5451;
  self = oldself5451;
  selfslot = oldselfslot5451;
  stackframe = oldstackframe5451;
// compiled object node returning obj5451 (depth = 3)
  *var_enumerable = obj5451;
  if (obj5451 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 379
  setline(379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 380
  setline(380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method indexable
  block_savedest(self);
  Object closure5669 = createclosure(1, "indexable");
  setclosureframe(closure5669, stackframe);
  addtoclosure(closure5669, var_indexable);
  struct UserObject *uo5669 = (struct UserObject*)self;
  uo5669->data[35] = (Object)closure5669;
  Method *meth_meth_collectionsPrelude_indexable5669 = addmethod2pos(self, "indexable", &meth_collectionsPrelude_indexable5669, 35);
  int argcv_meth_collectionsPrelude_indexable5669[] = {0};
  meth_meth_collectionsPrelude_indexable5669->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_indexable5669);
  meth_meth_collectionsPrelude_indexable5669->definitionModule = modulename;
  meth_meth_collectionsPrelude_indexable5669->definitionLine = 380;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject5670 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5670 = alloc_userobj2(2,4, objclass5670);
  gc_frame_newslot(obj5670);
// OBJECT OUTER DEC outer
  adddatum2(obj5670, self, 0);
  addmethodreal(obj5670,"outer", &reader_collectionsPrelude_outer_5671);
  Object oldself5670 = self;
  struct StackFrameObject *oldstackframe5670 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5670);
  gc_frame_newslot((Object)stackframe);
  self = obj5670;
  Object *oldselfslot5670 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5670 = (*(struct UserObject *)self).data[0], lowerouter5670 = thisouter5670;
  if (inheritingObject5670) {
    struct UserObject *inho5670 = (struct UserObject *)inheritingObject5670;
    while (inho5670->super != GraceDefaultObject) inho5670 = (struct UserObject *)inho5670->super;
    inho5670->super = obj5670;
    self = inheritingObject5670;
    *selfslot = self;
    lowerouter5670 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5670;
  }
// method trait
  block_savedest(obj5670);
  Object closure5672 = createclosure(2, "trait");
  setclosureframe(closure5672, stackframe);
  addtoclosure(closure5672, var_NoSuchObject);
  addtoclosure(closure5672, var_collection);
  struct UserObject *uo5672 = (struct UserObject*)obj5670;
  uo5672->data[1] = (Object)closure5672;
  Method *meth_meth_collectionsPrelude_trait5672 = addmethod2pos(obj5670, "trait", &meth_collectionsPrelude_trait5672, 1);
  int argcv_meth_collectionsPrelude_trait5672[] = {0};
  meth_meth_collectionsPrelude_trait5672->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_trait5672);
  meth_meth_collectionsPrelude_trait5672->definitionModule = modulename;
  meth_meth_collectionsPrelude_trait5672->definitionLine = 380;
  block_savedest(obj5670);
  Object closure5826 = createclosure(2, "trait()object");
  setclosureframe(closure5826, stackframe);
  addtoclosure(closure5826, var_NoSuchObject);
  addtoclosure(closure5826, var_collection);
  Method *meth_meth_collectionsPrelude_trait5672_object = addmethod2pos(obj5670, "trait()object", &meth_collectionsPrelude_trait5672_object, 1);
  meth_meth_collectionsPrelude_trait5672_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_trait5672_object->definitionLine = 380;
  sourceObject = obj5670;
  objclass5670 = obj5670->class;
  objclass5670->definitionModule = modulename;
  objclass5670->definitionLine = 380;
  (*(struct UserObject *)self).data[0] = lowerouter5670;
  self = oldself5670;
  selfslot = oldselfslot5670;
  stackframe = oldstackframe5670;
// compiled object node returning obj5670 (depth = 3)
  *var_indexable = obj5670;
  if (obj5670 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 428
  setline(428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 432
  setline(432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 590
  setline(590);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1050
  setline(1050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1371
  setline(1371);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1372
  setline(1372);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Binding
// starting to compile typeliteral node (depth = 2)
//   Type literal 
    Object type5828 = alloc_Type("Binding", 4);
    add_Method((ClassData)type5828, "key", NULL);
    add_Method((ClassData)type5828, "value", NULL);
    add_Method((ClassData)type5828, "hash", NULL);
    add_Method((ClassData)type5828, "==", NULL);
// compiled typeliteral node returning type5828 (depth = 2)
  *var_Binding = type5828;
// Begin line 423
  setline(423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method Binding
  block_savedest(self);
  Object closure5829 = createclosure(1, "Binding");
  setclosureframe(closure5829, stackframe);
  addtoclosure(closure5829, var_Binding);
  struct UserObject *uo5829 = (struct UserObject*)self;
  uo5829->data[36] = (Object)closure5829;
  Method *meth_meth_collectionsPrelude_Binding5829 = addmethod2pos(self, "Binding", &meth_collectionsPrelude_Binding5829, 36);
  int argcv_meth_collectionsPrelude_Binding5829[] = {0};
  meth_meth_collectionsPrelude_Binding5829->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_Binding5829);
  meth_meth_collectionsPrelude_Binding5829->definitionModule = modulename;
  meth_meth_collectionsPrelude_Binding5829->definitionLine = 423;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 1378
  setline(1378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1379
  setline(1379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method binding
  block_savedest(self);
  Object closure5830 = createclosure(1, "binding");
  setclosureframe(closure5830, stackframe);
  addtoclosure(closure5830, var_binding);
  struct UserObject *uo5830 = (struct UserObject*)self;
  uo5830->data[37] = (Object)closure5830;
  Method *meth_meth_collectionsPrelude_binding5830 = addmethod2pos(self, "binding", &meth_collectionsPrelude_binding5830, 37);
  int argcv_meth_collectionsPrelude_binding5830[] = {0};
  meth_meth_collectionsPrelude_binding5830->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_binding5830);
  meth_meth_collectionsPrelude_binding5830->definitionModule = modulename;
  meth_meth_collectionsPrelude_binding5830->definitionLine = 1379;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject5831 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5831 = alloc_userobj2(2,4, objclass5831);
  gc_frame_newslot(obj5831);
// OBJECT OUTER DEC outer
  adddatum2(obj5831, self, 0);
  addmethodreal(obj5831,"outer", &reader_collectionsPrelude_outer_5832);
  Object oldself5831 = self;
  struct StackFrameObject *oldstackframe5831 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5831);
  gc_frame_newslot((Object)stackframe);
  self = obj5831;
  Object *oldselfslot5831 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5831 = (*(struct UserObject *)self).data[0], lowerouter5831 = thisouter5831;
  if (inheritingObject5831) {
    struct UserObject *inho5831 = (struct UserObject *)inheritingObject5831;
    while (inho5831->super != GraceDefaultObject) inho5831 = (struct UserObject *)inho5831->super;
    inho5831->super = obj5831;
    self = inheritingObject5831;
    *selfslot = self;
    lowerouter5831 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5831;
  }
// method key()value
  block_savedest(obj5831);
  Object closure5833 = createclosure(1, "key()value");
  setclosureframe(closure5833, stackframe);
  addtoclosure(closure5833, var_Binding);
  struct UserObject *uo5833 = (struct UserObject*)obj5831;
  uo5833->data[1] = (Object)closure5833;
  Method *meth_meth_collectionsPrelude_key_40__41_value5833 = addmethod2pos(obj5831, "key()value", &meth_collectionsPrelude_key_40__41_value5833, 1);
  int argcv_meth_collectionsPrelude_key_40__41_value5833[] = {1, 1};
  meth_meth_collectionsPrelude_key_40__41_value5833->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_key_40__41_value5833);
  meth_meth_collectionsPrelude_key_40__41_value5833->definitionModule = modulename;
  meth_meth_collectionsPrelude_key_40__41_value5833->definitionLine = 1379;
  block_savedest(obj5831);
  Object closure5909 = createclosure(1, "key()value()object");
  setclosureframe(closure5909, stackframe);
  addtoclosure(closure5909, var_Binding);
  Method *meth_meth_collectionsPrelude_key_40__41_value5833_object = addmethod2pos(obj5831, "key()value()object", &meth_collectionsPrelude_key_40__41_value5833_object, 1);
  meth_meth_collectionsPrelude_key_40__41_value5833_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_key_40__41_value5833_object->definitionLine = 1379;
  sourceObject = obj5831;
  objclass5831 = obj5831->class;
  objclass5831->definitionModule = modulename;
  objclass5831->definitionLine = 1379;
  (*(struct UserObject *)self).data[0] = lowerouter5831;
  self = oldself5831;
  selfslot = oldselfslot5831;
  stackframe = oldstackframe5831;
// compiled object node returning obj5831 (depth = 3)
  *var_binding = obj5831;
  if (obj5831 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 1391
  setline(1391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1723
  setline(1723);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1945
  setline(1945);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
  gc_frame_end(frame);
  return self;
}
